""" Cisco_IOS_XR_infra_policymgr_oper 

This module contains a collection of YANG definitions
for Cisco IOS\-XR infra\-policymgr package operational data.

This module contains definitions
for the following management objects\:
  policy\-manager\: Policy\-map operational data

Copyright (c) 2013\-2018 by Cisco Systems, Inc.
All rights reserved.

"""
from collections import OrderedDict

from ydk.types import Entity, EntityPath, Identity, Enum, YType, YLeaf, YLeafList, YList, LeafDataList, Bits, Empty, Decimal64
from ydk.filters import YFilter
from ydk.errors import YError, YModelError
from ydk.errors.error_handler import handle_type_error as _handle_type_error



class AcctEn(Enum):
    """
    AcctEn (Enum Class)

    Acct en

    .. data:: policy_acct_evt_unspecified = 0

    	policy acct evt unspecified

    .. data:: policy_acct_evt_start = 1

    	policy acct evt start

    .. data:: policy_acct_evt_stop = 2

    	policy acct evt stop

    .. data:: policy_acct_evt_update = 3

    	policy acct evt update

    """

    policy_acct_evt_unspecified = Enum.YLeaf(0, "policy-acct-evt-unspecified")

    policy_acct_evt_start = Enum.YLeaf(1, "policy-acct-evt-start")

    policy_acct_evt_stop = Enum.YLeaf(2, "policy-acct-evt-stop")

    policy_acct_evt_update = Enum.YLeaf(3, "policy-acct-evt-update")


class AfmonAlarmSevEn(Enum):
    """
    AfmonAlarmSevEn (Enum Class)

    AFMon Alarm Severities

    .. data:: afmon_alm_none = 0

    	afmon alm none

    .. data:: afmon_alm_info = 1

    	afmon alm info

    .. data:: afmon_alm_notif = 2

    	afmon alm notif

    .. data:: afmon_alm_warn = 3

    	afmon alm warn

    .. data:: afmon_alm_error = 4

    	afmon alm error

    .. data:: afmon_alm_crit = 5

    	afmon alm crit

    .. data:: afmon_alm_alert = 6

    	afmon alm alert

    .. data:: afmon_alm_emerg = 7

    	afmon alm emerg

    .. data:: afmon_alm_sev_max = 8

    	afmon alm sev max

    """

    afmon_alm_none = Enum.YLeaf(0, "afmon-alm-none")

    afmon_alm_info = Enum.YLeaf(1, "afmon-alm-info")

    afmon_alm_notif = Enum.YLeaf(2, "afmon-alm-notif")

    afmon_alm_warn = Enum.YLeaf(3, "afmon-alm-warn")

    afmon_alm_error = Enum.YLeaf(4, "afmon-alm-error")

    afmon_alm_crit = Enum.YLeaf(5, "afmon-alm-crit")

    afmon_alm_alert = Enum.YLeaf(6, "afmon-alm-alert")

    afmon_alm_emerg = Enum.YLeaf(7, "afmon-alm-emerg")

    afmon_alm_sev_max = Enum.YLeaf(8, "afmon-alm-sev-max")


class AfmonAlarmTypeEn(Enum):
    """
    AfmonAlarmTypeEn (Enum Class)

    Afmon alarm type en

    .. data:: afmon_alm_type_invalid = 0

    	afmon alm type invalid

    .. data:: afmon_alm_discrete = 1

    	afmon alm discrete

    .. data:: afmon_alm_grp_cnt = 2

    	afmon alm grp cnt

    .. data:: afmon_alm_grp_pct = 3

    	afmon alm grp pct

    .. data:: afmon_alm_type_max = 4

    	afmon alm type max

    """

    afmon_alm_type_invalid = Enum.YLeaf(0, "afmon-alm-type-invalid")

    afmon_alm_discrete = Enum.YLeaf(1, "afmon-alm-discrete")

    afmon_alm_grp_cnt = Enum.YLeaf(2, "afmon-alm-grp-cnt")

    afmon_alm_grp_pct = Enum.YLeaf(3, "afmon-alm-grp-pct")

    afmon_alm_type_max = Enum.YLeaf(4, "afmon-alm-type-max")


class AfmonFlowParmTypeEn(Enum):
    """
    AfmonFlowParmTypeEn (Enum Class)

    (afmon) Flow submode param types

    .. data:: afmon_flow_parm_invalid = 0

    	invalid

    .. data:: afmon_flow_parm_max_mon_flow_s = 1

    	Max monitored flows

    .. data:: afmon_flow_parm_mon_interval = 2

    	Monitoring interval

    .. data:: afmon_flow_parm_intvl_hist = 3

    	Interval History

    .. data:: afmon_flow_parm_flow_timeout = 4

    	Flow Timeout

    .. data:: afmon_flow_parm_max = 5

    	Maximum flow parm type

    """

    afmon_flow_parm_invalid = Enum.YLeaf(0, "afmon-flow-parm-invalid")

    afmon_flow_parm_max_mon_flow_s = Enum.YLeaf(1, "afmon-flow-parm-max-mon-flow-s")

    afmon_flow_parm_mon_interval = Enum.YLeaf(2, "afmon-flow-parm-mon-interval")

    afmon_flow_parm_intvl_hist = Enum.YLeaf(3, "afmon-flow-parm-intvl-hist")

    afmon_flow_parm_flow_timeout = Enum.YLeaf(4, "afmon-flow-parm-flow-timeout")

    afmon_flow_parm_max = Enum.YLeaf(5, "afmon-flow-parm-max")


class AfmonIpcbrParmTypeEn(Enum):
    """
    AfmonIpcbrParmTypeEn (Enum Class)

    Afmon ipcbr parm type en

    .. data:: afmon_ipcbr_parm_invalid = 0

    	afmon ipcbr parm invalid

    .. data:: afmon_ipcbr_parm_ip_pkt_rate = 1

    	afmon ipcbr parm ip pkt rate

    .. data:: afmon_ipcbr_parm_ip_bit_rate = 2

    	afmon ipcbr parm ip bit rate

    .. data:: afmon_ipcbr_parm_media_bit_rate = 3

    	afmon ipcbr parm media bit rate

    .. data:: afmon_ipcbr_parm_media_pkt_size = 4

    	afmon ipcbr parm media pkt size

    .. data:: afmon_ipcbr_parm_media_pkts_per_ip = 5

    	afmon ipcbr parm media pkts per ip

    .. data:: afmon_ipcbr_parm_max = 6

    	afmon ipcbr parm max

    """

    afmon_ipcbr_parm_invalid = Enum.YLeaf(0, "afmon-ipcbr-parm-invalid")

    afmon_ipcbr_parm_ip_pkt_rate = Enum.YLeaf(1, "afmon-ipcbr-parm-ip-pkt-rate")

    afmon_ipcbr_parm_ip_bit_rate = Enum.YLeaf(2, "afmon-ipcbr-parm-ip-bit-rate")

    afmon_ipcbr_parm_media_bit_rate = Enum.YLeaf(3, "afmon-ipcbr-parm-media-bit-rate")

    afmon_ipcbr_parm_media_pkt_size = Enum.YLeaf(4, "afmon-ipcbr-parm-media-pkt-size")

    afmon_ipcbr_parm_media_pkts_per_ip = Enum.YLeaf(5, "afmon-ipcbr-parm-media-pkts-per-ip")

    afmon_ipcbr_parm_max = Enum.YLeaf(6, "afmon-ipcbr-parm-max")


class AfmonMdiParmTypeEn(Enum):
    """
    AfmonMdiParmTypeEn (Enum Class)

    Afmon mdi parm type en

    .. data:: afmon_mdi_parm_invalid = 0

    	afmon mdi parm invalid

    .. data:: afmon_mdi_parm_pids = 1

    	afmon mdi parm pids

    .. data:: afmon_mdi_parm_pkt_rate = 2

    	afmon mdi parm pkt rate

    .. data:: afmon_mdi_parm_ip_pkt_rate = 3

    	afmon mdi parm ip pkt rate

    .. data:: afmon_mdi_parm_ip_bit_rate = 4

    	afmon mdi parm ip bit rate

    .. data:: afmon_mdi_parm_max = 5

    	afmon mdi parm max

    """

    afmon_mdi_parm_invalid = Enum.YLeaf(0, "afmon-mdi-parm-invalid")

    afmon_mdi_parm_pids = Enum.YLeaf(1, "afmon-mdi-parm-pids")

    afmon_mdi_parm_pkt_rate = Enum.YLeaf(2, "afmon-mdi-parm-pkt-rate")

    afmon_mdi_parm_ip_pkt_rate = Enum.YLeaf(3, "afmon-mdi-parm-ip-pkt-rate")

    afmon_mdi_parm_ip_bit_rate = Enum.YLeaf(4, "afmon-mdi-parm-ip-bit-rate")

    afmon_mdi_parm_max = Enum.YLeaf(5, "afmon-mdi-parm-max")


class AfmonReactActnEn(Enum):
    """
    AfmonReactActnEn (Enum Class)

    Afmon react actn en

    .. data:: afmon_react_actn_none = 0

    	afmon react actn none

    .. data:: afmon_react_syslog = 1

    	afmon react syslog

    .. data:: afmon_react_snmp = 2

    	afmon react snmp

    .. data:: afmon_react_clone = 3

    	afmon react clone

    """

    afmon_react_actn_none = Enum.YLeaf(0, "afmon-react-actn-none")

    afmon_react_syslog = Enum.YLeaf(1, "afmon-react-syslog")

    afmon_react_snmp = Enum.YLeaf(2, "afmon-react-snmp")

    afmon_react_clone = Enum.YLeaf(3, "afmon-react-clone")


class AfmonReactCriterionEn(Enum):
    """
    AfmonReactCriterionEn (Enum Class)

    Afmon react criterion en

    .. data:: afmon_react_crit_invalid = 0

    	afmon react crit invalid

    .. data:: afmon_react_mrv = 1

    	afmon react mrv

    .. data:: afmon_react_df = 2

    	afmon react df

    .. data:: afmon_react_mse = 3

    	afmon react mse

    .. data:: afmon_react_pkt_rate = 4

    	afmon react pkt rate

    .. data:: afmon_react_flow_cnt = 5

    	afmon react flow cnt

    .. data:: afmon_react_rtp_loss_fraction = 6

    	afmon react rtp loss fraction

    .. data:: afmon_react_rtp_jitter = 7

    	afmon react rtp jitter

    .. data:: afmon_react_rtp_max_jitter = 8

    	afmon react rtp max jitter

    .. data:: afmon_react_rtp_out_of_order = 9

    	afmon react rtp out of order

    .. data:: afmon_react_rtp_loss_pkts = 10

    	afmon react rtp loss pkts

    .. data:: afmon_react_rtp_ta = 11

    	afmon react rtp ta

    .. data:: afmon_react_rtp_es = 12

    	afmon react rtp es

    .. data:: afmon_react_mdi_mlr = 13

    	afmon react mdi mlr

    .. data:: afmon_react_mdi_mdc = 14

    	afmon react mdi mdc

    .. data:: afmon_react_mdi_jitter = 15

    	afmon react mdi jitter

    .. data:: afmon_react_mdi_loss_pkts = 16

    	afmon react mdi loss pkts

    .. data:: afmon_react_mdi_ta = 17

    	afmon react mdi ta

    .. data:: afmon_react_mdi_es = 18

    	afmon react mdi es

    .. data:: afmon_react_crit_max = 19

    	afmon react crit max

    """

    afmon_react_crit_invalid = Enum.YLeaf(0, "afmon-react-crit-invalid")

    afmon_react_mrv = Enum.YLeaf(1, "afmon-react-mrv")

    afmon_react_df = Enum.YLeaf(2, "afmon-react-df")

    afmon_react_mse = Enum.YLeaf(3, "afmon-react-mse")

    afmon_react_pkt_rate = Enum.YLeaf(4, "afmon-react-pkt-rate")

    afmon_react_flow_cnt = Enum.YLeaf(5, "afmon-react-flow-cnt")

    afmon_react_rtp_loss_fraction = Enum.YLeaf(6, "afmon-react-rtp-loss-fraction")

    afmon_react_rtp_jitter = Enum.YLeaf(7, "afmon-react-rtp-jitter")

    afmon_react_rtp_max_jitter = Enum.YLeaf(8, "afmon-react-rtp-max-jitter")

    afmon_react_rtp_out_of_order = Enum.YLeaf(9, "afmon-react-rtp-out-of-order")

    afmon_react_rtp_loss_pkts = Enum.YLeaf(10, "afmon-react-rtp-loss-pkts")

    afmon_react_rtp_ta = Enum.YLeaf(11, "afmon-react-rtp-ta")

    afmon_react_rtp_es = Enum.YLeaf(12, "afmon-react-rtp-es")

    afmon_react_mdi_mlr = Enum.YLeaf(13, "afmon-react-mdi-mlr")

    afmon_react_mdi_mdc = Enum.YLeaf(14, "afmon-react-mdi-mdc")

    afmon_react_mdi_jitter = Enum.YLeaf(15, "afmon-react-mdi-jitter")

    afmon_react_mdi_loss_pkts = Enum.YLeaf(16, "afmon-react-mdi-loss-pkts")

    afmon_react_mdi_ta = Enum.YLeaf(17, "afmon-react-mdi-ta")

    afmon_react_mdi_es = Enum.YLeaf(18, "afmon-react-mdi-es")

    afmon_react_crit_max = Enum.YLeaf(19, "afmon-react-crit-max")


class AfmonReactParmTypeEn(Enum):
    """
    AfmonReactParmTypeEn (Enum Class)

    (afmon) React submode param types

    .. data:: afmon_react_parm_invalid = 0

    	invalid

    .. data:: afmon_react_parm_oper_id = 1

    	Operation ID

    .. data:: afmon_react_parm_crit_erion = 2

    	Criterion

    .. data:: afmon_react_parm_desc = 3

    	Description

    .. data:: afmon_react_parm_trig_value = 4

    	Trigger value

    .. data:: afmon_react_parm_trig_type = 5

    	Trigger Type

    .. data:: afmon_react_parm_action = 6

    	Action

    .. data:: afmon_react_parm_alm_type = 7

    	Alarm type

    .. data:: afmon_react_parm_alm_severity = 8

    	Alarm Severity

    .. data:: afmon_react_parm_max = 9

    	Maximum react parm type

    """

    afmon_react_parm_invalid = Enum.YLeaf(0, "afmon-react-parm-invalid")

    afmon_react_parm_oper_id = Enum.YLeaf(1, "afmon-react-parm-oper-id")

    afmon_react_parm_crit_erion = Enum.YLeaf(2, "afmon-react-parm-crit-erion")

    afmon_react_parm_desc = Enum.YLeaf(3, "afmon-react-parm-desc")

    afmon_react_parm_trig_value = Enum.YLeaf(4, "afmon-react-parm-trig-value")

    afmon_react_parm_trig_type = Enum.YLeaf(5, "afmon-react-parm-trig-type")

    afmon_react_parm_action = Enum.YLeaf(6, "afmon-react-parm-action")

    afmon_react_parm_alm_type = Enum.YLeaf(7, "afmon-react-parm-alm-type")

    afmon_react_parm_alm_severity = Enum.YLeaf(8, "afmon-react-parm-alm-severity")

    afmon_react_parm_max = Enum.YLeaf(9, "afmon-react-parm-max")


class AfmonRtpClockRateTypeEn(Enum):
    """
    AfmonRtpClockRateTypeEn (Enum Class)

    Afmon rtp clock rate type en

    .. data:: afmon_rtp_cr_invalid = 0

    	afmon rtp cr invalid

    .. data:: afmon_rtp_cr_8k = 1

    	afmon rtp cr 8k

    .. data:: afmon_rtp_cr_16k = 2

    	afmon rtp cr 16k

    .. data:: afmon_rtp_cr_11025 = 3

    	afmon rtp cr 11025

    .. data:: afmon_rtp_cr_22050 = 4

    	afmon rtp cr 22050

    .. data:: afmon_rtp_cr_44100 = 5

    	afmon rtp cr 44100

    .. data:: afmon_rtp_cr_48k = 6

    	afmon rtp cr 48k

    .. data:: afmon_rtp_cr_90k = 7

    	afmon rtp cr 90k

    .. data:: afmon_rtp_cr_27m = 8

    	afmon rtp cr 27m

    .. data:: afmon_rtp_cr_148500k = 9

    	afmon rtp cr 148500k

    .. data:: afmon_rtp_cr_148351k = 10

    	afmon rtp cr 148351k

    .. data:: afmon_rtp_cr_max = 11

    	afmon rtp cr max

    """

    afmon_rtp_cr_invalid = Enum.YLeaf(0, "afmon-rtp-cr-invalid")

    afmon_rtp_cr_8k = Enum.YLeaf(1, "afmon-rtp-cr-8k")

    afmon_rtp_cr_16k = Enum.YLeaf(2, "afmon-rtp-cr-16k")

    afmon_rtp_cr_11025 = Enum.YLeaf(3, "afmon-rtp-cr-11025")

    afmon_rtp_cr_22050 = Enum.YLeaf(4, "afmon-rtp-cr-22050")

    afmon_rtp_cr_44100 = Enum.YLeaf(5, "afmon-rtp-cr-44100")

    afmon_rtp_cr_48k = Enum.YLeaf(6, "afmon-rtp-cr-48k")

    afmon_rtp_cr_90k = Enum.YLeaf(7, "afmon-rtp-cr-90k")

    afmon_rtp_cr_27m = Enum.YLeaf(8, "afmon-rtp-cr-27m")

    afmon_rtp_cr_148500k = Enum.YLeaf(9, "afmon-rtp-cr-148500k")

    afmon_rtp_cr_148351k = Enum.YLeaf(10, "afmon-rtp-cr-148351k")

    afmon_rtp_cr_max = Enum.YLeaf(11, "afmon-rtp-cr-max")


class AfmonRtpParmTypeEn(Enum):
    """
    AfmonRtpParmTypeEn (Enum Class)

    Afmon rtp parm type en

    .. data:: afmon_rtp_parm_invalid = 0

    	afmon rtp parm invalid

    .. data:: afmon_rtp_parm_min_seq = 1

    	afmon rtp parm min seq

    .. data:: afmon_rtp_parm_max_drop = 2

    	afmon rtp parm max drop

    .. data:: afmon_rtp_parm_max_mis_order = 3

    	afmon rtp parm max mis order

    .. data:: afmon_rtp_parm_seq_ext_cop4 = 4

    	afmon rtp parm seq ext cop4

    .. data:: afmon_rtp_parm_clock_rate = 5

    	afmon rtp parm clock rate

    .. data:: afmon_rtp_parm_max = 6

    	afmon rtp parm max

    """

    afmon_rtp_parm_invalid = Enum.YLeaf(0, "afmon-rtp-parm-invalid")

    afmon_rtp_parm_min_seq = Enum.YLeaf(1, "afmon-rtp-parm-min-seq")

    afmon_rtp_parm_max_drop = Enum.YLeaf(2, "afmon-rtp-parm-max-drop")

    afmon_rtp_parm_max_mis_order = Enum.YLeaf(3, "afmon-rtp-parm-max-mis-order")

    afmon_rtp_parm_seq_ext_cop4 = Enum.YLeaf(4, "afmon-rtp-parm-seq-ext-cop4")

    afmon_rtp_parm_clock_rate = Enum.YLeaf(5, "afmon-rtp-parm-clock-rate")

    afmon_rtp_parm_max = Enum.YLeaf(6, "afmon-rtp-parm-max")


class AfmonTrigRelopEn(Enum):
    """
    AfmonTrigRelopEn (Enum Class)

    Afmon trig relop en

    .. data:: afmon_trig_relop_invalid = 0

    	afmon trig relop invalid

    .. data:: afmon_trig_lt = 1

    	afmon trig lt

    .. data:: afmon_trig_le = 2

    	afmon trig le

    .. data:: afmon_trig_gt = 3

    	afmon trig gt

    .. data:: afmon_trig_ge = 4

    	afmon trig ge

    .. data:: afmon_trig_range = 5

    	afmon trig range

    .. data:: afmon_trig_relop_max = 6

    	afmon trig relop max

    """

    afmon_trig_relop_invalid = Enum.YLeaf(0, "afmon-trig-relop-invalid")

    afmon_trig_lt = Enum.YLeaf(1, "afmon-trig-lt")

    afmon_trig_le = Enum.YLeaf(2, "afmon-trig-le")

    afmon_trig_gt = Enum.YLeaf(3, "afmon-trig-gt")

    afmon_trig_ge = Enum.YLeaf(4, "afmon-trig-ge")

    afmon_trig_range = Enum.YLeaf(5, "afmon-trig-range")

    afmon_trig_relop_max = Enum.YLeaf(6, "afmon-trig-relop-max")


class AfmonTrigTypeEn(Enum):
    """
    AfmonTrigTypeEn (Enum Class)

    Afmon trig type en

    .. data:: afmon_trig_type_invalid = 0

    	afmon trig type invalid

    .. data:: afmon_trig_immed = 1

    	afmon trig immed

    .. data:: afmon_trig_avg = 2

    	afmon trig avg

    .. data:: afmon_trig_type_max = 3

    	afmon trig type max

    """

    afmon_trig_type_invalid = Enum.YLeaf(0, "afmon-trig-type-invalid")

    afmon_trig_immed = Enum.YLeaf(1, "afmon-trig-immed")

    afmon_trig_avg = Enum.YLeaf(2, "afmon-trig-avg")

    afmon_trig_type_max = Enum.YLeaf(3, "afmon-trig-type-max")


class AuthorizeIdEn(Enum):
    """
    AuthorizeIdEn (Enum Class)

    Authorize id en

    .. data:: policy_authorize_ident_unspecified = 0

    	policy authorize ident unspecified

    .. data:: policy_authorize_ident_dnis = 1

    	policy authorize ident dnis

    .. data:: policy_authorize_ident_domain = 2

    	policy authorize ident domain

    .. data:: policy_authorize_ident_user_name = 3

    	policy authorize ident user name

    .. data:: policy_authorize_ident_nas_port = 4

    	policy authorize ident nas port

    .. data:: policy_authorize_ident_source_address_ipv4 = 5

    	policy authorize ident source address ipv4

    .. data:: policy_authorize_ident_source_address_ipv6 = 6

    	policy authorize ident source address ipv6

    .. data:: policy_authorize_ident_source_address_mac = 7

    	policy authorize ident source address mac

    .. data:: policy_authorize_ident_auto_detect = 8

    	policy authorize ident auto detect

    .. data:: policy_authorize_ident_tunnel_name = 9

    	policy authorize ident tunnel name

    .. data:: policy_authorize_ident_dhcp_client_id = 10

    	policy authorize ident dhcp client id

    .. data:: policy_authorize_ident_circuit_id = 11

    	policy authorize ident circuit id

    .. data:: policy_authorize_ident_remote_id = 12

    	policy authorize ident remote id

    .. data:: policy_authorize_ident_vendor_id = 13

    	policy authorize ident vendor id

    .. data:: policy_authorize_ident_service_name = 14

    	policy authorize ident service name

    .. data:: policy_authorize_ident_max = 15

    	policy authorize ident max

    """

    policy_authorize_ident_unspecified = Enum.YLeaf(0, "policy-authorize-ident-unspecified")

    policy_authorize_ident_dnis = Enum.YLeaf(1, "policy-authorize-ident-dnis")

    policy_authorize_ident_domain = Enum.YLeaf(2, "policy-authorize-ident-domain")

    policy_authorize_ident_user_name = Enum.YLeaf(3, "policy-authorize-ident-user-name")

    policy_authorize_ident_nas_port = Enum.YLeaf(4, "policy-authorize-ident-nas-port")

    policy_authorize_ident_source_address_ipv4 = Enum.YLeaf(5, "policy-authorize-ident-source-address-ipv4")

    policy_authorize_ident_source_address_ipv6 = Enum.YLeaf(6, "policy-authorize-ident-source-address-ipv6")

    policy_authorize_ident_source_address_mac = Enum.YLeaf(7, "policy-authorize-ident-source-address-mac")

    policy_authorize_ident_auto_detect = Enum.YLeaf(8, "policy-authorize-ident-auto-detect")

    policy_authorize_ident_tunnel_name = Enum.YLeaf(9, "policy-authorize-ident-tunnel-name")

    policy_authorize_ident_dhcp_client_id = Enum.YLeaf(10, "policy-authorize-ident-dhcp-client-id")

    policy_authorize_ident_circuit_id = Enum.YLeaf(11, "policy-authorize-ident-circuit-id")

    policy_authorize_ident_remote_id = Enum.YLeaf(12, "policy-authorize-ident-remote-id")

    policy_authorize_ident_vendor_id = Enum.YLeaf(13, "policy-authorize-ident-vendor-id")

    policy_authorize_ident_service_name = Enum.YLeaf(14, "policy-authorize-ident-service-name")

    policy_authorize_ident_max = Enum.YLeaf(15, "policy-authorize-ident-max")


class CacFlowActnTypeEn(Enum):
    """
    CacFlowActnTypeEn (Enum Class)

    CAC flow types

    .. data:: cac_flow_actn_type_local = 0

    	CAC flow local

    .. data:: cac_flow_actn_type_max = 1

    	Max CAC flow types

    """

    cac_flow_actn_type_local = Enum.YLeaf(0, "cac-flow-actn-type-local")

    cac_flow_actn_type_max = Enum.YLeaf(1, "cac-flow-actn-type-max")


class ClassMapModeEn(Enum):
    """
    ClassMapModeEn (Enum Class)

    Class\-Map Mode

    .. data:: class_map_mode_match_any = 0

    	Type Match-Any

    .. data:: class_map_mode_match_all = 1

    	Type Match-All

    .. data:: class_map_mode_max = 2

    	Not a valid mode

    .. data:: class_map_mode_usr_def = 1073741824

    	User defined match type

    """

    class_map_mode_match_any = Enum.YLeaf(0, "class-map-mode-match-any")

    class_map_mode_match_all = Enum.YLeaf(1, "class-map-mode-match-all")

    class_map_mode_max = Enum.YLeaf(2, "class-map-mode-max")

    class_map_mode_usr_def = Enum.YLeaf(1073741824, "class-map-mode-usr-def")


class ClassMapTypeEn(Enum):
    """
    ClassMapTypeEn (Enum Class)

    Class map type en

    .. data:: class_map_type_none = 0

    	class map type none

    .. data:: class_map_type_qos = 1

    	class map type qos

    .. data:: class_map_type_pbr = 2

    	class map type pbr

    .. data:: class_map_type_traffic = 3

    	class map type traffic

    .. data:: class_map_type_subs_control = 4

    	class map type subs control

    .. data:: class_map_type_max = 5

    	class map type max

    """

    class_map_type_none = Enum.YLeaf(0, "class-map-type-none")

    class_map_type_qos = Enum.YLeaf(1, "class-map-type-qos")

    class_map_type_pbr = Enum.YLeaf(2, "class-map-type-pbr")

    class_map_type_traffic = Enum.YLeaf(3, "class-map-type-traffic")

    class_map_type_subs_control = Enum.YLeaf(4, "class-map-type-subs-control")

    class_map_type_max = Enum.YLeaf(5, "class-map-type-max")


class DecodeIdentifierEn(Enum):
    """
    DecodeIdentifierEn (Enum Class)

    Decode identifier en

    .. data:: policy_decid_unspecified = 0

    	policy decid unspecified

    .. data:: policy_decid_remote_id = 1

    	policy decid remote id

    .. data:: policy_decid_circuit_id = 2

    	policy decid circuit id

    .. data:: policy_decid_user_name = 3

    	policy decid user name

    .. data:: policy_decid_max = 4

    	policy decid max

    """

    policy_decid_unspecified = Enum.YLeaf(0, "policy-decid-unspecified")

    policy_decid_remote_id = Enum.YLeaf(1, "policy-decid-remote-id")

    policy_decid_circuit_id = Enum.YLeaf(2, "policy-decid-circuit-id")

    policy_decid_user_name = Enum.YLeaf(3, "policy-decid-user-name")

    policy_decid_max = Enum.YLeaf(4, "policy-decid-max")


class DpssSnidTypeEn(Enum):
    """
    DpssSnidTypeEn (Enum Class)

    Dpss snid type en

    .. data:: dpss_snid_invalid = 0

    	dpss snid invalid

    .. data:: dpss_snid_index = 1

    	dpss snid index

    .. data:: dpss_snid_name = 2

    	dpss snid name

    .. data:: dpss_snid_type_max = 3

    	dpss snid type max

    """

    dpss_snid_invalid = Enum.YLeaf(0, "dpss-snid-invalid")

    dpss_snid_index = Enum.YLeaf(1, "dpss-snid-index")

    dpss_snid_name = Enum.YLeaf(2, "dpss-snid-name")

    dpss_snid_type_max = Enum.YLeaf(3, "dpss-snid-type-max")


class FlowKeyEn(Enum):
    """
    FlowKeyEn (Enum Class)

    Flow key en

    .. data:: flow_key_invalid = 0

    	Flow key invalid

    .. data:: flow_key_src_ip = 1

    	Flow key source ip

    .. data:: flow_key_dst_ip = 2

    	Flow key destination ip

    .. data:: flow_key_five_tuple = 3

    	Flow key five tuple

    .. data:: flow_key_max = 4

    	Flow key max

    """

    flow_key_invalid = Enum.YLeaf(0, "flow-key-invalid")

    flow_key_src_ip = Enum.YLeaf(1, "flow-key-src-ip")

    flow_key_dst_ip = Enum.YLeaf(2, "flow-key-dst-ip")

    flow_key_five_tuple = Enum.YLeaf(3, "flow-key-five-tuple")

    flow_key_max = Enum.YLeaf(4, "flow-key-max")


class IdentifierEn(Enum):
    """
    IdentifierEn (Enum Class)

    Identifier en

    .. data:: policy_ident_unspecified = 0

    	policy ident unspecified

    .. data:: policy_ident_authen_status = 1

    	policy ident authen status

    .. data:: policy_ident_dnis = 2

    	policy ident dnis

    .. data:: policy_ident_media = 3

    	policy ident media

    .. data:: policy_ident_mlp_negotiated = 4

    	policy ident mlp negotiated

    .. data:: policy_ident_nas_port = 5

    	policy ident nas port

    .. data:: policy_ident_no_user_name = 6

    	policy ident no user name

    .. data:: policy_ident_protocol = 7

    	policy ident protocol

    .. data:: policy_ident_service_name = 8

    	policy ident service name

    .. data:: policy_ident_source_address_ipv4 = 9

    	policy ident source address ipv4

    .. data:: policy_ident_source_address_ipv6 = 10

    	policy ident source address ipv6

    .. data:: policy_ident_source_address_mac = 11

    	policy ident source address mac

    .. data:: policy_ident_timer = 12

    	policy ident timer

    .. data:: policy_ident_tunnel_name = 13

    	policy ident tunnel name

    .. data:: policy_ident_auth_domain = 14

    	policy ident auth domain

    .. data:: policy_ident_auth_user_name = 15

    	policy ident auth user name

    .. data:: policy_ident_unauth_domain = 16

    	policy ident unauth domain

    .. data:: policy_ident_unauth_user_name = 17

    	policy ident unauth user name

    .. data:: policy_ident_max = 18

    	policy ident max

    """

    policy_ident_unspecified = Enum.YLeaf(0, "policy-ident-unspecified")

    policy_ident_authen_status = Enum.YLeaf(1, "policy-ident-authen-status")

    policy_ident_dnis = Enum.YLeaf(2, "policy-ident-dnis")

    policy_ident_media = Enum.YLeaf(3, "policy-ident-media")

    policy_ident_mlp_negotiated = Enum.YLeaf(4, "policy-ident-mlp-negotiated")

    policy_ident_nas_port = Enum.YLeaf(5, "policy-ident-nas-port")

    policy_ident_no_user_name = Enum.YLeaf(6, "policy-ident-no-user-name")

    policy_ident_protocol = Enum.YLeaf(7, "policy-ident-protocol")

    policy_ident_service_name = Enum.YLeaf(8, "policy-ident-service-name")

    policy_ident_source_address_ipv4 = Enum.YLeaf(9, "policy-ident-source-address-ipv4")

    policy_ident_source_address_ipv6 = Enum.YLeaf(10, "policy-ident-source-address-ipv6")

    policy_ident_source_address_mac = Enum.YLeaf(11, "policy-ident-source-address-mac")

    policy_ident_timer = Enum.YLeaf(12, "policy-ident-timer")

    policy_ident_tunnel_name = Enum.YLeaf(13, "policy-ident-tunnel-name")

    policy_ident_auth_domain = Enum.YLeaf(14, "policy-ident-auth-domain")

    policy_ident_auth_user_name = Enum.YLeaf(15, "policy-ident-auth-user-name")

    policy_ident_unauth_domain = Enum.YLeaf(16, "policy-ident-unauth-domain")

    policy_ident_unauth_user_name = Enum.YLeaf(17, "policy-ident-unauth-user-name")

    policy_ident_max = Enum.YLeaf(18, "policy-ident-max")


class MarkTypeEn(Enum):
    """
    MarkTypeEn (Enum Class)

    Mark Type Enumeration

    .. data:: mark_type_none = 0

    	Mark None

    .. data:: mark_type_dscp = 1

    	Mark DSCP

    .. data:: mark_type_prec = 2

    	Mark Precedence

    .. data:: mark_type_mpls_exp_topmost = 3

    	Mark MPLS EXP on topmost header

    .. data:: mark_type_mpls_exp_imposition = 4

    	Mark MPLS EXP on imposition header

    .. data:: mark_type_qos_group = 5

    	Mark QoS Group

    .. data:: mark_type_discard_class = 6

    	Mark Discard Class

    .. data:: mark_type_cos = 7

    	Mark CoS

    .. data:: mark_type_cos_inner = 8

    	Mark COS Inner

    .. data:: mark_type_srp_priority = 9

    	Mark Priority

    .. data:: mark_type_atm_clp = 10

    	Mark ATM CLP

    .. data:: mark_type_fr_de = 11

    	Mark FR DE

    .. data:: mark_type_dscp_tunnel = 12

    	Mark DSCP in Tunnel Header

    .. data:: mark_type_prec_tunnel = 13

    	Mark Precedence in Tunnel Header

    .. data:: mark_type_dei = 14

    	Mark DEI

    .. data:: mark_type_dei_imposition = 15

    	Mark DEI on imposition header

    .. data:: mark_type_forward_class = 16

    	Mark forward class

    .. data:: mark_type_df = 17

    	Mark DF bit

    .. data:: mark_type_traffic_class = 18

    	Mark Traffic Class

    .. data:: mark_type_src_mac = 19

    	Mark source mac

    .. data:: mark_type_dst_mac = 20

    	Mark destination mac

    .. data:: mark_type_ipv4_src_addr = 21

    	Mark ipv4 source address

    .. data:: mark_type_ipv4_dst_addr = 22

    	Mark ipv4 destination address

    .. data:: mark_type_vlan_id = 23

    	Mark vlan id

    .. data:: mark_type_udp_src_port = 24

    	Mark type udp source port

    .. data:: mark_type_udp_dst_port = 25

    	Mark type udp destination port

    .. data:: mark_type_tcp_src_port = 26

    	Mark type tcp source port

    .. data:: mark_type_tcp_dst_port = 27

    	Mark type tcp destination port

    .. data:: mark_type_sctp_src_port = 28

    	Mark type sctp source port

    .. data:: mark_type_sctp_dst_port = 29

    	Mark type sctp destination port

    .. data:: mark_type_max = 30

    	Mark Type Max (Invalid)

    """

    mark_type_none = Enum.YLeaf(0, "mark-type-none")

    mark_type_dscp = Enum.YLeaf(1, "mark-type-dscp")

    mark_type_prec = Enum.YLeaf(2, "mark-type-prec")

    mark_type_mpls_exp_topmost = Enum.YLeaf(3, "mark-type-mpls-exp-topmost")

    mark_type_mpls_exp_imposition = Enum.YLeaf(4, "mark-type-mpls-exp-imposition")

    mark_type_qos_group = Enum.YLeaf(5, "mark-type-qos-group")

    mark_type_discard_class = Enum.YLeaf(6, "mark-type-discard-class")

    mark_type_cos = Enum.YLeaf(7, "mark-type-cos")

    mark_type_cos_inner = Enum.YLeaf(8, "mark-type-cos-inner")

    mark_type_srp_priority = Enum.YLeaf(9, "mark-type-srp-priority")

    mark_type_atm_clp = Enum.YLeaf(10, "mark-type-atm-clp")

    mark_type_fr_de = Enum.YLeaf(11, "mark-type-fr-de")

    mark_type_dscp_tunnel = Enum.YLeaf(12, "mark-type-dscp-tunnel")

    mark_type_prec_tunnel = Enum.YLeaf(13, "mark-type-prec-tunnel")

    mark_type_dei = Enum.YLeaf(14, "mark-type-dei")

    mark_type_dei_imposition = Enum.YLeaf(15, "mark-type-dei-imposition")

    mark_type_forward_class = Enum.YLeaf(16, "mark-type-forward-class")

    mark_type_df = Enum.YLeaf(17, "mark-type-df")

    mark_type_traffic_class = Enum.YLeaf(18, "mark-type-traffic-class")

    mark_type_src_mac = Enum.YLeaf(19, "mark-type-src-mac")

    mark_type_dst_mac = Enum.YLeaf(20, "mark-type-dst-mac")

    mark_type_ipv4_src_addr = Enum.YLeaf(21, "mark-type-ipv4-src-addr")

    mark_type_ipv4_dst_addr = Enum.YLeaf(22, "mark-type-ipv4-dst-addr")

    mark_type_vlan_id = Enum.YLeaf(23, "mark-type-vlan-id")

    mark_type_udp_src_port = Enum.YLeaf(24, "mark-type-udp-src-port")

    mark_type_udp_dst_port = Enum.YLeaf(25, "mark-type-udp-dst-port")

    mark_type_tcp_src_port = Enum.YLeaf(26, "mark-type-tcp-src-port")

    mark_type_tcp_dst_port = Enum.YLeaf(27, "mark-type-tcp-dst-port")

    mark_type_sctp_src_port = Enum.YLeaf(28, "mark-type-sctp-src-port")

    mark_type_sctp_dst_port = Enum.YLeaf(29, "mark-type-sctp-dst-port")

    mark_type_max = Enum.YLeaf(30, "mark-type-max")


class MatchAttrE(Enum):
    """
    MatchAttrE (Enum Class)

    Match attribute type

    .. data:: value = 0

    	Match attribute value

    .. data:: range = 1

    	Match attribute range

    .. data:: mask = 2

    	Match attribute mask

    """

    value = Enum.YLeaf(0, "value")

    range = Enum.YLeaf(1, "range")

    mask = Enum.YLeaf(2, "mask")


class MatchAuthenStatusEn(Enum):
    """
    MatchAuthenStatusEn (Enum Class)

    Match authen status en

    .. data:: match_authen_status_unspecified = 0

    	match authen status unspecified

    .. data:: match_authen_status_authenticated = 1

    	match authen status authenticated

    .. data:: match_authen_status_unauthenticated = 2

    	match authen status unauthenticated

    .. data:: match_authen_status_max = 3

    	match authen status max

    """

    match_authen_status_unspecified = Enum.YLeaf(0, "match-authen-status-unspecified")

    match_authen_status_authenticated = Enum.YLeaf(1, "match-authen-status-authenticated")

    match_authen_status_unauthenticated = Enum.YLeaf(2, "match-authen-status-unauthenticated")

    match_authen_status_max = Enum.YLeaf(3, "match-authen-status-max")


class MatchAvailableIdEn(Enum):
    """
    MatchAvailableIdEn (Enum Class)

    Match available id en

    .. data:: match_avail_ident_unspecified = 0

    	match avail ident unspecified

    .. data:: match_avail_ident_dnis = 1

    	match avail ident dnis

    .. data:: match_avail_ident_domain = 2

    	match avail ident domain

    .. data:: match_avail_ident_circuit_id = 3

    	match avail ident circuit id

    .. data:: match_avail_ident_remote_id = 4

    	match avail ident remote id

    .. data:: match_avail_ident_media = 5

    	match avail ident media

    .. data:: match_avail_ident_nas_port = 6

    	match avail ident nas port

    .. data:: match_avail_ident_protocol = 7

    	match avail ident protocol

    .. data:: match_avail_ident_source_address_ipv4 = 8

    	match avail ident source address ipv4

    .. data:: match_avail_ident_source_address_ipv6 = 9

    	match avail ident source address ipv6

    .. data:: match_avail_ident_source_address_mac = 10

    	match avail ident source address mac

    .. data:: match_avail_ident_tunnel_name = 11

    	match avail ident tunnel name

    .. data:: match_avail_ident_user_name = 12

    	match avail ident user name

    .. data:: match_avail_ident_vendor_id = 13

    	match avail ident vendor id

    .. data:: match_avail_ident_dhcp_client_id = 14

    	match avail ident dhcp client id

    .. data:: match_avail_ident_max = 15

    	match avail ident max

    """

    match_avail_ident_unspecified = Enum.YLeaf(0, "match-avail-ident-unspecified")

    match_avail_ident_dnis = Enum.YLeaf(1, "match-avail-ident-dnis")

    match_avail_ident_domain = Enum.YLeaf(2, "match-avail-ident-domain")

    match_avail_ident_circuit_id = Enum.YLeaf(3, "match-avail-ident-circuit-id")

    match_avail_ident_remote_id = Enum.YLeaf(4, "match-avail-ident-remote-id")

    match_avail_ident_media = Enum.YLeaf(5, "match-avail-ident-media")

    match_avail_ident_nas_port = Enum.YLeaf(6, "match-avail-ident-nas-port")

    match_avail_ident_protocol = Enum.YLeaf(7, "match-avail-ident-protocol")

    match_avail_ident_source_address_ipv4 = Enum.YLeaf(8, "match-avail-ident-source-address-ipv4")

    match_avail_ident_source_address_ipv6 = Enum.YLeaf(9, "match-avail-ident-source-address-ipv6")

    match_avail_ident_source_address_mac = Enum.YLeaf(10, "match-avail-ident-source-address-mac")

    match_avail_ident_tunnel_name = Enum.YLeaf(11, "match-avail-ident-tunnel-name")

    match_avail_ident_user_name = Enum.YLeaf(12, "match-avail-ident-user-name")

    match_avail_ident_vendor_id = Enum.YLeaf(13, "match-avail-ident-vendor-id")

    match_avail_ident_dhcp_client_id = Enum.YLeaf(14, "match-avail-ident-dhcp-client-id")

    match_avail_ident_max = Enum.YLeaf(15, "match-avail-ident-max")


class MatchLogicalOperatorEn(Enum):
    """
    MatchLogicalOperatorEn (Enum Class)

    Logical Operators

    .. data:: match_operator_unspecified = 0

    	match operator unspecified

    .. data:: match_equal_to = 1

    	match equal to

    .. data:: match_greater_than = 2

    	match greater than

    .. data:: match_greater_than_or_equal = 3

    	match greater than or equal

    .. data:: match_less_than = 4

    	match less than

    .. data:: match_less_than_or_equal = 5

    	match less than or equal

    .. data:: match_operator_max = 6

    	match operator max

    """

    match_operator_unspecified = Enum.YLeaf(0, "match-operator-unspecified")

    match_equal_to = Enum.YLeaf(1, "match-equal-to")

    match_greater_than = Enum.YLeaf(2, "match-greater-than")

    match_greater_than_or_equal = Enum.YLeaf(3, "match-greater-than-or-equal")

    match_less_than = Enum.YLeaf(4, "match-less-than")

    match_less_than_or_equal = Enum.YLeaf(5, "match-less-than-or-equal")

    match_operator_max = Enum.YLeaf(6, "match-operator-max")


class MatchMediaTypeEn(Enum):
    """
    MatchMediaTypeEn (Enum Class)

    Match media type en

    .. data:: match_media_type_unspecified = 0

    	match media type unspecified

    .. data:: match_media_type_async = 1

    	match media type async

    .. data:: match_media_type_atm = 2

    	match media type atm

    .. data:: match_media_type_ether = 3

    	match media type ether

    .. data:: match_media_type_ip = 4

    	match media type ip

    .. data:: match_media_type_isdn = 5

    	match media type isdn

    .. data:: match_media_type_mpls = 6

    	match media type mpls

    .. data:: match_media_type_sync = 7

    	match media type sync

    .. data:: match_media_type_max = 8

    	match media type max

    """

    match_media_type_unspecified = Enum.YLeaf(0, "match-media-type-unspecified")

    match_media_type_async = Enum.YLeaf(1, "match-media-type-async")

    match_media_type_atm = Enum.YLeaf(2, "match-media-type-atm")

    match_media_type_ether = Enum.YLeaf(3, "match-media-type-ether")

    match_media_type_ip = Enum.YLeaf(4, "match-media-type-ip")

    match_media_type_isdn = Enum.YLeaf(5, "match-media-type-isdn")

    match_media_type_mpls = Enum.YLeaf(6, "match-media-type-mpls")

    match_media_type_sync = Enum.YLeaf(7, "match-media-type-sync")

    match_media_type_max = Enum.YLeaf(8, "match-media-type-max")


class MatchMlpNegotiatedEn(Enum):
    """
    MatchMlpNegotiatedEn (Enum Class)

    Match mlp negotiated en

    .. data:: match_mlp_negotiated_unspecified = 0

    	match mlp negotiated unspecified

    .. data:: match_mlp_negotiated = 1

    	match mlp negotiated

    .. data:: match_mlp_not_negotiated = 2

    	match mlp not negotiated

    .. data:: match_mlp_max = 3

    	match mlp max

    """

    match_mlp_negotiated_unspecified = Enum.YLeaf(0, "match-mlp-negotiated-unspecified")

    match_mlp_negotiated = Enum.YLeaf(1, "match-mlp-negotiated")

    match_mlp_not_negotiated = Enum.YLeaf(2, "match-mlp-not-negotiated")

    match_mlp_max = Enum.YLeaf(3, "match-mlp-max")


class MatchNasPortIntfTypeEn(Enum):
    """
    MatchNasPortIntfTypeEn (Enum Class)

    Match nas port intf type en

    .. data:: match_nas_port_intf_type_unspecified = 0

    	match nas port intf type unspecified

    .. data:: match_nas_port_intf_type_async = 1

    	match nas port intf type async

    .. data:: match_nas_port_intf_type_atm = 2

    	match nas port intf type atm

    .. data:: match_nas_port_intf_type_bri = 3

    	match nas port intf type bri

    .. data:: match_nas_port_intf_type_ether = 4

    	match nas port intf type ether

    .. data:: match_nas_port_intf_type_ipsec = 5

    	match nas port intf type ipsec

    .. data:: match_nas_port_intf_type_none = 6

    	match nas port intf type none

    .. data:: match_nas_port_intf_type_piafs = 7

    	match nas port intf type piafs

    .. data:: match_nas_port_intf_type_pppatm = 8

    	match nas port intf type pppatm

    .. data:: match_nas_port_intf_type_ppp_ether = 9

    	match nas port intf type ppp ether

    .. data:: match_nas_port_intf_type_pppoeatm = 10

    	match nas port intf type pppoeatm

    .. data:: match_nas_port_intf_type_pppqinq = 11

    	match nas port intf type pppqinq

    .. data:: match_nas_port_intf_type_pppvlan = 12

    	match nas port intf type pppvlan

    .. data:: match_nas_port_intf_type_pri = 13

    	match nas port intf type pri

    .. data:: match_nas_port_intf_type_sync = 14

    	match nas port intf type sync

    .. data:: match_nas_port_intf_type_v110 = 15

    	match nas port intf type v110

    .. data:: match_nas_port_intf_type_v120 = 16

    	match nas port intf type v120

    .. data:: match_nas_port_intf_type_vty = 17

    	match nas port intf type vty

    .. data:: match_nas_port_intf_type_x75 = 18

    	match nas port intf type x75

    .. data:: match_nas_port_intf_type_max = 19

    	match nas port intf type max

    """

    match_nas_port_intf_type_unspecified = Enum.YLeaf(0, "match-nas-port-intf-type-unspecified")

    match_nas_port_intf_type_async = Enum.YLeaf(1, "match-nas-port-intf-type-async")

    match_nas_port_intf_type_atm = Enum.YLeaf(2, "match-nas-port-intf-type-atm")

    match_nas_port_intf_type_bri = Enum.YLeaf(3, "match-nas-port-intf-type-bri")

    match_nas_port_intf_type_ether = Enum.YLeaf(4, "match-nas-port-intf-type-ether")

    match_nas_port_intf_type_ipsec = Enum.YLeaf(5, "match-nas-port-intf-type-ipsec")

    match_nas_port_intf_type_none = Enum.YLeaf(6, "match-nas-port-intf-type-none")

    match_nas_port_intf_type_piafs = Enum.YLeaf(7, "match-nas-port-intf-type-piafs")

    match_nas_port_intf_type_pppatm = Enum.YLeaf(8, "match-nas-port-intf-type-pppatm")

    match_nas_port_intf_type_ppp_ether = Enum.YLeaf(9, "match-nas-port-intf-type-ppp-ether")

    match_nas_port_intf_type_pppoeatm = Enum.YLeaf(10, "match-nas-port-intf-type-pppoeatm")

    match_nas_port_intf_type_pppqinq = Enum.YLeaf(11, "match-nas-port-intf-type-pppqinq")

    match_nas_port_intf_type_pppvlan = Enum.YLeaf(12, "match-nas-port-intf-type-pppvlan")

    match_nas_port_intf_type_pri = Enum.YLeaf(13, "match-nas-port-intf-type-pri")

    match_nas_port_intf_type_sync = Enum.YLeaf(14, "match-nas-port-intf-type-sync")

    match_nas_port_intf_type_v110 = Enum.YLeaf(15, "match-nas-port-intf-type-v110")

    match_nas_port_intf_type_v120 = Enum.YLeaf(16, "match-nas-port-intf-type-v120")

    match_nas_port_intf_type_vty = Enum.YLeaf(17, "match-nas-port-intf-type-vty")

    match_nas_port_intf_type_x75 = Enum.YLeaf(18, "match-nas-port-intf-type-x75")

    match_nas_port_intf_type_max = Enum.YLeaf(19, "match-nas-port-intf-type-max")


class MatchNasPortSubIdEn(Enum):
    """
    MatchNasPortSubIdEn (Enum Class)

    Match nas port sub id en

    .. data:: match_nas_port_sub_id_unspecified = 0

    	match nas port sub id unspecified

    .. data:: match_nas_port_sub_id_adapter = 1

    	match nas port sub id adapter

    .. data:: match_nas_port_sub_id_channel = 2

    	match nas port sub id channel

    .. data:: match_nas_port_sub_id_ip_addr = 3

    	match nas port sub id ip addr

    .. data:: match_nas_port_sub_id_port = 4

    	match nas port sub id port

    .. data:: match_nas_port_sub_id_shelf = 5

    	match nas port sub id shelf

    .. data:: match_nas_port_sub_id_slot = 6

    	match nas port sub id slot

    .. data:: match_nas_port_sub_id_sub_interface = 7

    	match nas port sub id sub interface

    .. data:: match_nas_port_sub_id_type = 8

    	match nas port sub id type

    .. data:: match_nas_port_sub_id_vci = 9

    	match nas port sub id vci

    .. data:: match_nas_port_sub_id_vlan = 10

    	match nas port sub id vlan

    .. data:: match_nas_port_sub_id_vpi = 11

    	match nas port sub id vpi

    .. data:: match_nas_port_sub_id_max = 12

    	match nas port sub id max

    """

    match_nas_port_sub_id_unspecified = Enum.YLeaf(0, "match-nas-port-sub-id-unspecified")

    match_nas_port_sub_id_adapter = Enum.YLeaf(1, "match-nas-port-sub-id-adapter")

    match_nas_port_sub_id_channel = Enum.YLeaf(2, "match-nas-port-sub-id-channel")

    match_nas_port_sub_id_ip_addr = Enum.YLeaf(3, "match-nas-port-sub-id-ip-addr")

    match_nas_port_sub_id_port = Enum.YLeaf(4, "match-nas-port-sub-id-port")

    match_nas_port_sub_id_shelf = Enum.YLeaf(5, "match-nas-port-sub-id-shelf")

    match_nas_port_sub_id_slot = Enum.YLeaf(6, "match-nas-port-sub-id-slot")

    match_nas_port_sub_id_sub_interface = Enum.YLeaf(7, "match-nas-port-sub-id-sub-interface")

    match_nas_port_sub_id_type = Enum.YLeaf(8, "match-nas-port-sub-id-type")

    match_nas_port_sub_id_vci = Enum.YLeaf(9, "match-nas-port-sub-id-vci")

    match_nas_port_sub_id_vlan = Enum.YLeaf(10, "match-nas-port-sub-id-vlan")

    match_nas_port_sub_id_vpi = Enum.YLeaf(11, "match-nas-port-sub-id-vpi")

    match_nas_port_sub_id_max = Enum.YLeaf(12, "match-nas-port-sub-id-max")


class MatchNoUsernameEn(Enum):
    """
    MatchNoUsernameEn (Enum Class)

    Match no username en

    .. data:: match_no_user_name_unspecified = 0

    	match no user name unspecified

    .. data:: match_no_user_name = 1

    	match no user name

    .. data:: match_user_name = 2

    	match user name

    .. data:: match_no_user_name_max = 3

    	match no user name max

    """

    match_no_user_name_unspecified = Enum.YLeaf(0, "match-no-user-name-unspecified")

    match_no_user_name = Enum.YLeaf(1, "match-no-user-name")

    match_user_name = Enum.YLeaf(2, "match-user-name")

    match_no_user_name_max = Enum.YLeaf(3, "match-no-user-name-max")


class MatchSubsProtocolEn(Enum):
    """
    MatchSubsProtocolEn (Enum Class)

    Match subs protocol en

    .. data:: match_subs_protocol_unspecified = 0

    	match subs protocol unspecified

    .. data:: match_subs_protocol_ipv4 = 1

    	match subs protocol ipv4

    .. data:: match_subs_protocol_ppp = 2

    	match subs protocol ppp

    .. data:: match_subs_protocol_dhcpv4 = 3

    	match subs protocol dhcpv4

    .. data:: match_subs_protocol_dhcpv6 = 4

    	match subs protocol dhcpv6

    .. data:: match_subs_protocol_max = 5

    	match subs protocol max

    """

    match_subs_protocol_unspecified = Enum.YLeaf(0, "match-subs-protocol-unspecified")

    match_subs_protocol_ipv4 = Enum.YLeaf(1, "match-subs-protocol-ipv4")

    match_subs_protocol_ppp = Enum.YLeaf(2, "match-subs-protocol-ppp")

    match_subs_protocol_dhcpv4 = Enum.YLeaf(3, "match-subs-protocol-dhcpv4")

    match_subs_protocol_dhcpv6 = Enum.YLeaf(4, "match-subs-protocol-dhcpv6")

    match_subs_protocol_max = Enum.YLeaf(5, "match-subs-protocol-max")


class MatchTypeEn(Enum):
    """
    MatchTypeEn (Enum Class)

    Match Type

    .. data:: match_type_none = 0

    	Match Type None

    .. data:: match_type_ipv4_dscp = 1

    	Match Type IPv4 DSCP

    .. data:: match_type_ipv4_prec = 2

    	Match Type IPv4 Precedence

    .. data:: match_type_ipv6_dscp = 3

    	Match Type IPv6 DSCP

    .. data:: match_type_packet_length = 4

    	Match Type Packet length

    .. data:: match_type_ipv4_packet_length = 5

    	Match Type IPv4 Packet length

    .. data:: match_type_ipv6_packet_length = 6

    	Match Type IPv6 Packet length

    .. data:: match_type_flow_tag = 7

    	Match Type Flow Tag

    .. data:: match_type_icmpv4_type = 8

    	Match Type IPv4 icmp-type

    .. data:: match_type_icmpv4_code = 9

    	Match Type IPv4 icmp-code

    .. data:: match_type_icmpv6_type = 10

    	Match Type IPv6 icmp-type

    .. data:: match_type_icmpv6_code = 11

    	Match Type IPv6 icmp-code

    .. data:: match_type_ipv6_prec = 12

    	Match Type IPv6 Precedence

    .. data:: match_type_fragment_type = 13

    	Match type fragment-type

    .. data:: match_type_tcp_flag = 14

    	Match type TCP flag

    .. data:: match_type_dscp = 15

    	Match Type DSCP

    .. data:: match_type_prec = 16

    	Match Type Precedence

    .. data:: match_type_proto = 17

    	Match Type Protocol

    .. data:: match_type_proto_icmpv4 = 18

    	Match Type protocol ICMPv4

    .. data:: match_type_proto_icmpv6 = 19

    	Match Type protocol ICMPv6

    .. data:: match_type_mpls_exp_top = 20

    	Match Type MPLS EXP Topmost

    .. data:: match_type_mpls_exp_imp = 21

    	Match Type MPLS EXP Imposition

    .. data:: match_type_mpls_disp_ipv4_acl = 22

    	Match Type MPLS DISP IPv4 ACL

    .. data:: match_type_mpls_disp_ipv6_acl = 23

    	Match Type MPLS DISP IPv6 ACL

    .. data:: match_type_mpls_topmost_eos = 24

    	Match Type MPLS TOPMOST EOS

    .. data:: match_type_mpls_topmost_label = 25

    	Match Type MPLS TOPMOST LABEL

    .. data:: match_type_cos = 26

    	Match Type COS

    .. data:: match_type_cos_inner = 27

    	Match Type inner COS

    .. data:: match_type_dei = 28

    	Match Type DEI

    .. data:: match_type_dei_inner = 29

    	Match Type inner DEI

    .. data:: match_type_vlan = 30

    	Match Type VLAN

    .. data:: match_type_vlan_inner = 31

    	Match Type inner VLAN

    .. data:: match_type_fr_dlci = 32

    	Match Type  FR DLCI

    .. data:: match_type_src_mac = 33

    	Match Type Source MAC Address

    .. data:: match_type_dst_mac = 34

    	Match Type Destination MAC Address

    .. data:: match_type_atm_oam = 35

    	Match Type ATM OAM

    .. data:: match_type_atm_clp = 36

    	Match Type ATM CLP

    .. data:: match_type_fr_de = 37

    	Match Type FR DE

    .. data:: match_type_qos_grp = 38

    	Match Type QoS Group

    .. data:: match_type_traffic_class = 39

    	Match Type Traffic Class

    .. data:: match_type_disc_cls = 40

    	Match Type Discard Class

    .. data:: match_type_vpls_known = 41

    	Match Type VPLS Known

    .. data:: match_type_vpls_unknown = 42

    	Match Type VPLS Unknown

    .. data:: match_type_vpls_mcast = 43

    	Match Type VPLS Multicast

    .. data:: match_type_vpls_bcast = 44

    	Match Type VPLS Broadcast

    .. data:: match_type_vpls_control = 45

    	Match Type VPLS Control

    .. data:: match_type_ipv4_acl = 46

    	Match Type IPv4 ACL

    .. data:: match_type_ipv6_acl = 47

    	Match Type IPv6 ACL

    .. data:: match_type_flow_key = 48

    	Match Type Flow Key

    .. data:: match_type_avail_id = 49

    	Match Type Available Identifier

    .. data:: match_type_authen_status = 50

    	Match Type Authentication Status

    .. data:: match_type_media = 51

    	Match Type Media

    .. data:: match_type_mlp_negotiated = 52

    	Match Type MLP Negotiated

    .. data:: match_type_subs_protocol = 53

    	Match Type Protocol

    .. data:: match_type_dnis = 54

    	Match Type DNIS

    .. data:: match_type_dnis_regexp = 55

    	Match Type DNIS Regular Exp

    .. data:: match_type_domain = 56

    	Match Type Domain

    .. data:: match_type_domain_regexp = 57

    	Match Type Domain Regular Exp

    .. data:: match_type_nas_port = 58

    	Match Type NAS Port

    .. data:: match_type_service_name = 59

    	Match Type Service Name

    .. data:: match_type_service_name_regexp = 60

    	Match Type Service Name Regular Exp

    .. data:: match_type_src_addr_ipv4 = 61

    	Match Type Source Address IPV4

    .. data:: match_type_dst_addr_ipv4 = 62

    	Match Type Source Address IPV4

    .. data:: match_type_src_addr_ipv6 = 63

    	Match Type Source Address IPV6

    .. data:: match_type_dst_addr_ipv6 = 64

    	Match Type Source Address IPV6

    .. data:: match_type_src_addr_mac = 65

    	Match Type Source Address Mac

    .. data:: match_type_src_port = 66

    	Match Type Source Port

    .. data:: match_type_dst_port = 67

    	Match Type Source Port

    .. data:: match_type_timer = 68

    	Match Type Timer

    .. data:: match_type_timer_regexp = 69

    	Match Type Timer Regular Exp

    .. data:: match_type_tunnel_name = 70

    	Match Type Tunnel Name

    .. data:: match_type_tunnel_name_regexp = 71

    	Match Type Tunnel Name Regular Exp

    .. data:: match_type_user_name = 72

    	Match Type User Name

    .. data:: match_type_user_name_regexp = 73

    	Match Type User Name Regular Exp

    .. data:: match_type_auth_user_name = 74

    	Match Type Authenticated User Name

    .. data:: match_type_auth_user_name_regexp = 75

    	Match Type Authenticated Userame Reg Exp

    .. data:: match_type_unauth_user_name = 76

    	Match Type Unauthenticated Username

    .. data:: match_type_unauth_user_name_regexp = 77

    	Match Type Unauthenicated Username RegEx

    .. data:: match_type_no_user_name = 78

    	Match Type No Username

    .. data:: match_type_auth_domain = 79

    	Match Type Authenticated Domain

    .. data:: match_type_auth_domain_regexp = 80

    	Match Type Authenticated Domain RegEx

    .. data:: match_type_unauth_domain = 81

    	Match Type Unauthenticated Domain

    .. data:: match_type_unauth_domain_regexp = 82

    	Match Type Unauthenticated Domain RegEx

    .. data:: match_type_vendor_id = 83

    	Match Type Vendor ID

    .. data:: match_type_vendor_id_regexp = 84

    	Match Type Vendor ID RegEx

    .. data:: match_type_access_interface = 85

    	Match Type Access Interface

    .. data:: match_type_input_interface = 86

    	Match Type Input Interface

    .. data:: match_type_input_interface_hdl = 87

    	Match Type Input Interface handle

    .. data:: match_type_ether_type = 88

    	Match Type Ethernet Type

    .. data:: match_type_dhcp_client_id = 89

    	Match DHCP Client ID

    .. data:: match_type_dhcp_client_id_regexp = 90

    	Match DHCP Client ID RegEx

    .. data:: match_type_circuit_id = 91

    	Match Type Circuit ID

    .. data:: match_type_circuit_id_regexp = 92

    	Match Type Circuit ID RegEx

    .. data:: match_type_remote_id = 93

    	Match Type Remote ID

    .. data:: match_type_remote_id_regexp = 94

    	Match Type Remote ID RegEx

    .. data:: match_type_cac_admit_local = 95

    	Match Type CAC admitted

    .. data:: match_type_cac_unadmit_local = 96

    	Match Type CAC unadmitted

    .. data:: match_type_any_internal = 97

    	Match Type Any (Used only for class-default)

    .. data:: match_type_ethernet_service_s_acl = 98

    	Match Type Ethernet-Services ACL

    .. data:: match_type_ptrs = 99

    	Dummy match type for internal use

    .. data:: match_type_max = 100

    	Match Type Max (Invalid)

    """

    match_type_none = Enum.YLeaf(0, "match-type-none")

    match_type_ipv4_dscp = Enum.YLeaf(1, "match-type-ipv4-dscp")

    match_type_ipv4_prec = Enum.YLeaf(2, "match-type-ipv4-prec")

    match_type_ipv6_dscp = Enum.YLeaf(3, "match-type-ipv6-dscp")

    match_type_packet_length = Enum.YLeaf(4, "match-type-packet-length")

    match_type_ipv4_packet_length = Enum.YLeaf(5, "match-type-ipv4-packet-length")

    match_type_ipv6_packet_length = Enum.YLeaf(6, "match-type-ipv6-packet-length")

    match_type_flow_tag = Enum.YLeaf(7, "match-type-flow-tag")

    match_type_icmpv4_type = Enum.YLeaf(8, "match-type-icmpv4-type")

    match_type_icmpv4_code = Enum.YLeaf(9, "match-type-icmpv4-code")

    match_type_icmpv6_type = Enum.YLeaf(10, "match-type-icmpv6-type")

    match_type_icmpv6_code = Enum.YLeaf(11, "match-type-icmpv6-code")

    match_type_ipv6_prec = Enum.YLeaf(12, "match-type-ipv6-prec")

    match_type_fragment_type = Enum.YLeaf(13, "match-type-fragment-type")

    match_type_tcp_flag = Enum.YLeaf(14, "match-type-tcp-flag")

    match_type_dscp = Enum.YLeaf(15, "match-type-dscp")

    match_type_prec = Enum.YLeaf(16, "match-type-prec")

    match_type_proto = Enum.YLeaf(17, "match-type-proto")

    match_type_proto_icmpv4 = Enum.YLeaf(18, "match-type-proto-icmpv4")

    match_type_proto_icmpv6 = Enum.YLeaf(19, "match-type-proto-icmpv6")

    match_type_mpls_exp_top = Enum.YLeaf(20, "match-type-mpls-exp-top")

    match_type_mpls_exp_imp = Enum.YLeaf(21, "match-type-mpls-exp-imp")

    match_type_mpls_disp_ipv4_acl = Enum.YLeaf(22, "match-type-mpls-disp-ipv4-acl")

    match_type_mpls_disp_ipv6_acl = Enum.YLeaf(23, "match-type-mpls-disp-ipv6-acl")

    match_type_mpls_topmost_eos = Enum.YLeaf(24, "match-type-mpls-topmost-eos")

    match_type_mpls_topmost_label = Enum.YLeaf(25, "match-type-mpls-topmost-label")

    match_type_cos = Enum.YLeaf(26, "match-type-cos")

    match_type_cos_inner = Enum.YLeaf(27, "match-type-cos-inner")

    match_type_dei = Enum.YLeaf(28, "match-type-dei")

    match_type_dei_inner = Enum.YLeaf(29, "match-type-dei-inner")

    match_type_vlan = Enum.YLeaf(30, "match-type-vlan")

    match_type_vlan_inner = Enum.YLeaf(31, "match-type-vlan-inner")

    match_type_fr_dlci = Enum.YLeaf(32, "match-type-fr-dlci")

    match_type_src_mac = Enum.YLeaf(33, "match-type-src-mac")

    match_type_dst_mac = Enum.YLeaf(34, "match-type-dst-mac")

    match_type_atm_oam = Enum.YLeaf(35, "match-type-atm-oam")

    match_type_atm_clp = Enum.YLeaf(36, "match-type-atm-clp")

    match_type_fr_de = Enum.YLeaf(37, "match-type-fr-de")

    match_type_qos_grp = Enum.YLeaf(38, "match-type-qos-grp")

    match_type_traffic_class = Enum.YLeaf(39, "match-type-traffic-class")

    match_type_disc_cls = Enum.YLeaf(40, "match-type-disc-cls")

    match_type_vpls_known = Enum.YLeaf(41, "match-type-vpls-known")

    match_type_vpls_unknown = Enum.YLeaf(42, "match-type-vpls-unknown")

    match_type_vpls_mcast = Enum.YLeaf(43, "match-type-vpls-mcast")

    match_type_vpls_bcast = Enum.YLeaf(44, "match-type-vpls-bcast")

    match_type_vpls_control = Enum.YLeaf(45, "match-type-vpls-control")

    match_type_ipv4_acl = Enum.YLeaf(46, "match-type-ipv4-acl")

    match_type_ipv6_acl = Enum.YLeaf(47, "match-type-ipv6-acl")

    match_type_flow_key = Enum.YLeaf(48, "match-type-flow-key")

    match_type_avail_id = Enum.YLeaf(49, "match-type-avail-id")

    match_type_authen_status = Enum.YLeaf(50, "match-type-authen-status")

    match_type_media = Enum.YLeaf(51, "match-type-media")

    match_type_mlp_negotiated = Enum.YLeaf(52, "match-type-mlp-negotiated")

    match_type_subs_protocol = Enum.YLeaf(53, "match-type-subs-protocol")

    match_type_dnis = Enum.YLeaf(54, "match-type-dnis")

    match_type_dnis_regexp = Enum.YLeaf(55, "match-type-dnis-regexp")

    match_type_domain = Enum.YLeaf(56, "match-type-domain")

    match_type_domain_regexp = Enum.YLeaf(57, "match-type-domain-regexp")

    match_type_nas_port = Enum.YLeaf(58, "match-type-nas-port")

    match_type_service_name = Enum.YLeaf(59, "match-type-service-name")

    match_type_service_name_regexp = Enum.YLeaf(60, "match-type-service-name-regexp")

    match_type_src_addr_ipv4 = Enum.YLeaf(61, "match-type-src-addr-ipv4")

    match_type_dst_addr_ipv4 = Enum.YLeaf(62, "match-type-dst-addr-ipv4")

    match_type_src_addr_ipv6 = Enum.YLeaf(63, "match-type-src-addr-ipv6")

    match_type_dst_addr_ipv6 = Enum.YLeaf(64, "match-type-dst-addr-ipv6")

    match_type_src_addr_mac = Enum.YLeaf(65, "match-type-src-addr-mac")

    match_type_src_port = Enum.YLeaf(66, "match-type-src-port")

    match_type_dst_port = Enum.YLeaf(67, "match-type-dst-port")

    match_type_timer = Enum.YLeaf(68, "match-type-timer")

    match_type_timer_regexp = Enum.YLeaf(69, "match-type-timer-regexp")

    match_type_tunnel_name = Enum.YLeaf(70, "match-type-tunnel-name")

    match_type_tunnel_name_regexp = Enum.YLeaf(71, "match-type-tunnel-name-regexp")

    match_type_user_name = Enum.YLeaf(72, "match-type-user-name")

    match_type_user_name_regexp = Enum.YLeaf(73, "match-type-user-name-regexp")

    match_type_auth_user_name = Enum.YLeaf(74, "match-type-auth-user-name")

    match_type_auth_user_name_regexp = Enum.YLeaf(75, "match-type-auth-user-name-regexp")

    match_type_unauth_user_name = Enum.YLeaf(76, "match-type-unauth-user-name")

    match_type_unauth_user_name_regexp = Enum.YLeaf(77, "match-type-unauth-user-name-regexp")

    match_type_no_user_name = Enum.YLeaf(78, "match-type-no-user-name")

    match_type_auth_domain = Enum.YLeaf(79, "match-type-auth-domain")

    match_type_auth_domain_regexp = Enum.YLeaf(80, "match-type-auth-domain-regexp")

    match_type_unauth_domain = Enum.YLeaf(81, "match-type-unauth-domain")

    match_type_unauth_domain_regexp = Enum.YLeaf(82, "match-type-unauth-domain-regexp")

    match_type_vendor_id = Enum.YLeaf(83, "match-type-vendor-id")

    match_type_vendor_id_regexp = Enum.YLeaf(84, "match-type-vendor-id-regexp")

    match_type_access_interface = Enum.YLeaf(85, "match-type-access-interface")

    match_type_input_interface = Enum.YLeaf(86, "match-type-input-interface")

    match_type_input_interface_hdl = Enum.YLeaf(87, "match-type-input-interface-hdl")

    match_type_ether_type = Enum.YLeaf(88, "match-type-ether-type")

    match_type_dhcp_client_id = Enum.YLeaf(89, "match-type-dhcp-client-id")

    match_type_dhcp_client_id_regexp = Enum.YLeaf(90, "match-type-dhcp-client-id-regexp")

    match_type_circuit_id = Enum.YLeaf(91, "match-type-circuit-id")

    match_type_circuit_id_regexp = Enum.YLeaf(92, "match-type-circuit-id-regexp")

    match_type_remote_id = Enum.YLeaf(93, "match-type-remote-id")

    match_type_remote_id_regexp = Enum.YLeaf(94, "match-type-remote-id-regexp")

    match_type_cac_admit_local = Enum.YLeaf(95, "match-type-cac-admit-local")

    match_type_cac_unadmit_local = Enum.YLeaf(96, "match-type-cac-unadmit-local")

    match_type_any_internal = Enum.YLeaf(97, "match-type-any-internal")

    match_type_ethernet_service_s_acl = Enum.YLeaf(98, "match-type-ethernet-service-s-acl")

    match_type_ptrs = Enum.YLeaf(99, "match-type-ptrs")

    match_type_max = Enum.YLeaf(100, "match-type-max")


class PclassExecStratEn(Enum):
    """
    PclassExecStratEn (Enum Class)

    Policy class execution strategy

    .. data:: pclass_exe_strat_unspecified = 0

    	Unspecified

    .. data:: pclass_exe_strat_do_all = 1

    	Exec all actions

    .. data:: pclass_exe_strat_do_until_success = 2

    	Exec until one of actions succeeds

    .. data:: pclass_exe_strat_do_until_failure = 3

    	Exec until there is a failure

    .. data:: pclass_exe_strat_max = 4

    	Invalid

    """

    pclass_exe_strat_unspecified = Enum.YLeaf(0, "pclass-exe-strat-unspecified")

    pclass_exe_strat_do_all = Enum.YLeaf(1, "pclass-exe-strat-do-all")

    pclass_exe_strat_do_until_success = Enum.YLeaf(2, "pclass-exe-strat-do-until-success")

    pclass_exe_strat_do_until_failure = Enum.YLeaf(3, "pclass-exe-strat-do-until-failure")

    pclass_exe_strat_max = Enum.YLeaf(4, "pclass-exe-strat-max")


class PeventCondEvalEn(Enum):
    """
    PeventCondEvalEn (Enum Class)

    Policy event execution strategy enumeration

    .. data:: pevent_cond_eval_unspecified = 0

    	Unspecified execution strategy

    .. data:: pevent_cond_eval_match_first = 1

    	Match-first execution strategy

    .. data:: pevent_cond_eval_match_all = 2

    	Match-all execution strategy

    .. data:: pevent_cond_eval_max = 3

    	Internal use only

    """

    pevent_cond_eval_unspecified = Enum.YLeaf(0, "pevent-cond-eval-unspecified")

    pevent_cond_eval_match_first = Enum.YLeaf(1, "pevent-cond-eval-match-first")

    pevent_cond_eval_match_all = Enum.YLeaf(2, "pevent-cond-eval-match-all")

    pevent_cond_eval_max = Enum.YLeaf(3, "pevent-cond-eval-max")


class PeventTypeEn(Enum):
    """
    PeventTypeEn (Enum Class)

    Policy event enumeration

    .. data:: pevent_type_unspecified = 0

    	Unspecified event

    .. data:: pevent_type_acct_logon = 1

    	Log on event

    .. data:: pevent_type_acct_logoff = 2

    	Log off event

    .. data:: pevent_type_credit_exhausted = 3

    	Credit exhausted event

    .. data:: pevent_type_idle_timeout = 4

    	Idle timeout event

    .. data:: pevent_type_absolute_timeout = 5

    	Absolute timeout event

    .. data:: pevent_type_quota_depleted = 6

    	Quota depletion event

    .. data:: pevent_type_service_start = 7

    	Service start event

    .. data:: pevent_type_service_stop = 8

    	Service stop event

    .. data:: pevent_type_session_start = 9

    	Session start event

    .. data:: pevent_type_session_activate = 10

    	Session activate event

    .. data:: pevent_type_session_restart = 11

    	Session restart event

    .. data:: pevent_type_session_stop = 12

    	Session stop event

    .. data:: pevent_type_session_disconnect = 13

    	Session disconnect event

    .. data:: pevent_type_session_update = 14

    	Session update event

    .. data:: pevent_type_flow_start = 15

    	Flow start event

    .. data:: pevent_type_flow_stop = 16

    	Flow stop event

    .. data:: pevent_type_accouting_start = 17

    	Accounting start event

    .. data:: pevent_type_acountng_g_stop = 18

    	Accounting stop event

    .. data:: pevent_type_acountng_g_update = 19

    	Accounting update event

    .. data:: pevent_type_timer_expiry = 20

    	Timer expierd event

    .. data:: pevent_type_threshold_reached = 21

    	Threshold reached event

    .. data:: pevent_type_ka_success = 22

    	Keep alive success event

    .. data:: pevent_type_ka_failure = 23

    	Keep alive failure event

    .. data:: pevent_type_link_up = 24

    	Link up event

    .. data:: pevent_type_link_down = 25

    	Link down event

    .. data:: pevent_type_authorization_failure = 26

    	Authorization failure event

    .. data:: pevent_type_authorization_no_response = 27

    	Authorization no response event

    .. data:: pevent_type_authentication_failure = 28

    	Authentication failure event

    .. data:: pevent_type_authentication_no_response = 29

    	Authentication no response event

    .. data:: pevent_type_exception = 30

    	Exception event

    .. data:: pevent_type_session_ident_chg = 31

    	Session identity change event

    .. data:: pevent_type_max = 32

    	Internal use only

    """

    pevent_type_unspecified = Enum.YLeaf(0, "pevent-type-unspecified")

    pevent_type_acct_logon = Enum.YLeaf(1, "pevent-type-acct-logon")

    pevent_type_acct_logoff = Enum.YLeaf(2, "pevent-type-acct-logoff")

    pevent_type_credit_exhausted = Enum.YLeaf(3, "pevent-type-credit-exhausted")

    pevent_type_idle_timeout = Enum.YLeaf(4, "pevent-type-idle-timeout")

    pevent_type_absolute_timeout = Enum.YLeaf(5, "pevent-type-absolute-timeout")

    pevent_type_quota_depleted = Enum.YLeaf(6, "pevent-type-quota-depleted")

    pevent_type_service_start = Enum.YLeaf(7, "pevent-type-service-start")

    pevent_type_service_stop = Enum.YLeaf(8, "pevent-type-service-stop")

    pevent_type_session_start = Enum.YLeaf(9, "pevent-type-session-start")

    pevent_type_session_activate = Enum.YLeaf(10, "pevent-type-session-activate")

    pevent_type_session_restart = Enum.YLeaf(11, "pevent-type-session-restart")

    pevent_type_session_stop = Enum.YLeaf(12, "pevent-type-session-stop")

    pevent_type_session_disconnect = Enum.YLeaf(13, "pevent-type-session-disconnect")

    pevent_type_session_update = Enum.YLeaf(14, "pevent-type-session-update")

    pevent_type_flow_start = Enum.YLeaf(15, "pevent-type-flow-start")

    pevent_type_flow_stop = Enum.YLeaf(16, "pevent-type-flow-stop")

    pevent_type_accouting_start = Enum.YLeaf(17, "pevent-type-accouting-start")

    pevent_type_acountng_g_stop = Enum.YLeaf(18, "pevent-type-acountng-g-stop")

    pevent_type_acountng_g_update = Enum.YLeaf(19, "pevent-type-acountng-g-update")

    pevent_type_timer_expiry = Enum.YLeaf(20, "pevent-type-timer-expiry")

    pevent_type_threshold_reached = Enum.YLeaf(21, "pevent-type-threshold-reached")

    pevent_type_ka_success = Enum.YLeaf(22, "pevent-type-ka-success")

    pevent_type_ka_failure = Enum.YLeaf(23, "pevent-type-ka-failure")

    pevent_type_link_up = Enum.YLeaf(24, "pevent-type-link-up")

    pevent_type_link_down = Enum.YLeaf(25, "pevent-type-link-down")

    pevent_type_authorization_failure = Enum.YLeaf(26, "pevent-type-authorization-failure")

    pevent_type_authorization_no_response = Enum.YLeaf(27, "pevent-type-authorization-no-response")

    pevent_type_authentication_failure = Enum.YLeaf(28, "pevent-type-authentication-failure")

    pevent_type_authentication_no_response = Enum.YLeaf(29, "pevent-type-authentication-no-response")

    pevent_type_exception = Enum.YLeaf(30, "pevent-type-exception")

    pevent_type_session_ident_chg = Enum.YLeaf(31, "pevent-type-session-ident-chg")

    pevent_type_max = Enum.YLeaf(32, "pevent-type-max")


class PfcPauseType(Enum):
    """
    PfcPauseType (Enum Class)

    Pfc pause type

    .. data:: pfc_buffer_size_defined = 0

    	pfc buffer size defined

    .. data:: pfc_pause_threshold_defined = 1

    	pfc pause threshold defined

    .. data:: pfc_resume_threshold_defined = 2

    	pfc resume threshold defined

    .. data:: pfc_buffer_size_value = 3

    	pfc buffer size value

    .. data:: pfc_pause_threshold_value = 4

    	pfc pause threshold value

    .. data:: pfc_resume_threshold_value = 5

    	pfc resume threshold value

    """

    pfc_buffer_size_defined = Enum.YLeaf(0, "pfc-buffer-size-defined")

    pfc_pause_threshold_defined = Enum.YLeaf(1, "pfc-pause-threshold-defined")

    pfc_resume_threshold_defined = Enum.YLeaf(2, "pfc-resume-threshold-defined")

    pfc_buffer_size_value = Enum.YLeaf(3, "pfc-buffer-size-value")

    pfc_pause_threshold_value = Enum.YLeaf(4, "pfc-pause-threshold-value")

    pfc_resume_threshold_value = Enum.YLeaf(5, "pfc-resume-threshold-value")


class PlmgrAppFwdingTypeE(Enum):
    """
    PlmgrAppFwdingTypeE (Enum Class)

    Forwarding types

    .. data:: layer2 = 0

    	 Forwarding type layer2

    .. data:: layer3 = 1

    	 Forwarding type layer3

    .. data:: any = 2

    	Forwarding type any

    """

    layer2 = Enum.YLeaf(0, "layer2")

    layer3 = Enum.YLeaf(1, "layer3")

    any = Enum.YLeaf(2, "any")


class PlmgrApplnTypeEn(Enum):
    """
    PlmgrApplnTypeEn (Enum Class)

    Different Application types

    .. data:: qos = 1

    	Application type QOS

    .. data:: pbr = 2

    	Application type PBR

    .. data:: subscriber_control = 3

    	Application type subscriber control

    .. data:: accounting = 4

    	Application type accounting

    .. data:: traffic = 5

    	Application type traffic

    .. data:: performance_traffic = 6

    	Application type performance traffic

    """

    qos = Enum.YLeaf(1, "qos")

    pbr = Enum.YLeaf(2, "pbr")

    subscriber_control = Enum.YLeaf(3, "subscriber-control")

    accounting = Enum.YLeaf(4, "accounting")

    traffic = Enum.YLeaf(5, "traffic")

    performance_traffic = Enum.YLeaf(6, "performance-traffic")


class PlmgrVarTypeEn(Enum):
    """
    PlmgrVarTypeEn (Enum Class)

    Type of default variable values

    .. data:: plmgr_var_type_class_name = 0

    	plmgr var type class name

    .. data:: plmgr_var_type_uint8 = 1

    	plmgr var type uint8

    .. data:: plmgr_var_type_uint16 = 2

    	plmgr var type uint16

    .. data:: plmgr_var_type_uint32 = 3

    	plmgr var type uint32

    .. data:: plmgr_var_type_param_uint32 = 4

    	plmgr var type param uint32

    .. data:: plmgr_var_type_dscp = 5

    	plmgr var type dscp

    .. data:: plmgr_var_type_prec = 6

    	plmgr var type prec

    .. data:: plmgr_var_type_max = 7

    	plmgr var type max

    """

    plmgr_var_type_class_name = Enum.YLeaf(0, "plmgr-var-type-class-name")

    plmgr_var_type_uint8 = Enum.YLeaf(1, "plmgr-var-type-uint8")

    plmgr_var_type_uint16 = Enum.YLeaf(2, "plmgr-var-type-uint16")

    plmgr_var_type_uint32 = Enum.YLeaf(3, "plmgr-var-type-uint32")

    plmgr_var_type_param_uint32 = Enum.YLeaf(4, "plmgr-var-type-param-uint32")

    plmgr_var_type_dscp = Enum.YLeaf(5, "plmgr-var-type-dscp")

    plmgr_var_type_prec = Enum.YLeaf(6, "plmgr-var-type-prec")

    plmgr_var_type_max = Enum.YLeaf(7, "plmgr-var-type-max")


class PoliceActionTypeEn(Enum):
    """
    PoliceActionTypeEn (Enum Class)

    Policer Action Type

    .. data:: police_action_none = 0

    	Policer Action None

    .. data:: police_action_transmit = 1

    	Policer Action Transmit

    .. data:: police_action_drop = 2

    	Policer Action Drop

    .. data:: police_action_mark = 3

    	Policer Action Mark

    .. data:: police_action_max = 4

    	Policer Action Max

    """

    police_action_none = Enum.YLeaf(0, "police-action-none")

    police_action_transmit = Enum.YLeaf(1, "police-action-transmit")

    police_action_drop = Enum.YLeaf(2, "police-action-drop")

    police_action_mark = Enum.YLeaf(3, "police-action-mark")

    police_action_max = Enum.YLeaf(4, "police-action-max")


class PoliceActnCategoryEn(Enum):
    """
    PoliceActnCategoryEn (Enum Class)

    Police Action Categories

    .. data:: police_actn_category_conform = 0

    	Conform action

    .. data:: police_actn_category_exceed = 1

    	Exceed action

    .. data:: police_actn_category_violate = 2

    	Violate action

    .. data:: police_actn_category_max = 3

    	Maximum police action categories

    """

    police_actn_category_conform = Enum.YLeaf(0, "police-actn-category-conform")

    police_actn_category_exceed = Enum.YLeaf(1, "police-actn-category-exceed")

    police_actn_category_violate = Enum.YLeaf(2, "police-actn-category-violate")

    police_actn_category_max = Enum.YLeaf(3, "police-actn-category-max")


class PolicyActionAttrEn(Enum):
    """
    PolicyActionAttrEn (Enum Class)

    Policy action attribute enum

    .. data:: action_attribute = 1

    	action attribute

    .. data:: sub_action_attribute = 2

    	sub action attribute

    """

    action_attribute = Enum.YLeaf(1, "action-attribute")

    sub_action_attribute = Enum.YLeaf(2, "sub-action-attribute")


class PolicyActionEn(Enum):
    """
    PolicyActionEn (Enum Class)

    Policy Actions Enumeration

    .. data:: policy_action_none = 0

    	Policy Action None

    .. data:: policy_action_unspecified = 1

    	Policy Action is not specified

    .. data:: policy_action_mark = 2

    	Policy Action Mark

    .. data:: policy_action_mark2 = 3

    	Policy Action Mark2

    .. data:: policy_action_wred = 4

    	Policy Action WRED

    .. data:: policy_action_encap_seq = 5

    	Policy action encap-sequence number

    .. data:: policy_action_priority = 6

    	Policy Action Priority Queue

    .. data:: policy_action_iphc = 7

    	Policy Action IP Header Compression

    .. data:: policy_action_bw_remaining = 8

    	Policy Action Bandwidth Remaining Queue

    .. data:: policy_action_min_bw = 9

    	Policy Action Minimum Bandwidth Queue

    .. data:: policy_action_authenticate_aaa = 10

    	Policy Action authenticate

    .. data:: policy_action_collect_id = 11

    	Policy Action collect identifier

    .. data:: policy_action_disconnect = 12

    	Policy Action disconnect session

    .. data:: policy_action_set_timer = 13

    	Policy Action set timer

    .. data:: policy_action_stop_timer = 14

    	Policy Action stop timer

    .. data:: policy_action_query_ancp = 15

    	Policy Action query ancp

    .. data:: policy_action_accounting_aaa_list = 16

    	Policy Action accounting aaa

    .. data:: policy_action_prepaid_config = 17

    	Policy Action prepaid config

    .. data:: policy_action_timeout_idle = 18

    	Policy Action timeout idle

    .. data:: policy_action_proxy_aaa = 19

    	Policy Action proxy aaa

    .. data:: policy_action_template_activate = 20

    	Policy Action activate template

    .. data:: policy_action_template_deactivate = 21

    	Policy Action deactivate template

    .. data:: policy_action_decode_identifier = 22

    	Policy Action decode identifier

    .. data:: policy_action_q_limit = 23

    	Policy Action Queue Limit

    .. data:: policy_action_authorize_id = 24

    	Policy Action authorize idetifier

    .. data:: policy_action_accounting_event_aaa_list = 25

    	Policy Action accounting event

    .. data:: policy_action_afmon_react = 26

    	Policy Action React (afmon)

    .. data:: policy_action_httpr = 27

    	Policy Action httpr (pbr)

    .. data:: policy_action_pbr_transmit = 28

    	Policy Action pbr transmit

    .. data:: policy_action_pbr_drop = 29

    	Policy Action pbr drop

    .. data:: policy_action_punt = 30

    	Policy Action pbr punt

    .. data:: policy_action_copy = 31

    	Policy Action pbr copy

    .. data:: policy_action_sfrag = 32

    	Policy Action Service fragment

    .. data:: policy_action_monitor = 33

    	Policy Action Monitor

    .. data:: policy_action_redirect = 34

    	Policy Action redirect

    .. data:: policy_action_ipv4_nh = 35

    	Policy Action ipv4 next hop

    .. data:: policy_action_ipv6_nh = 36

    	Policy Action ipv6 next hop

    .. data:: policy_action_vlan_pop = 37

    	Policy Action pop

    .. data:: policy_action_pbr_next_hop = 38

    	Policy Action PBR Forward

    .. data:: policy_action_decap_gre = 39

    	Policy Action decapsule GRE

    .. data:: policy_action_output_interface = 40

    	Policy Action PBR redirect interface

    .. data:: policy_action_service_function_path = 41

    	Policy Action PBR service chaining

    .. data:: policy_action_ptrs = 42

    	Dummy action for internal use

    .. data:: policy_action_police = 43

    	Policy Action Police

    .. data:: policy_action_shape = 44

    	Policy Action Shape

    .. data:: policy_action_serv_pol = 45

    	Policy Action Service Policy

    .. data:: policy_action_cac = 46

    	Policy Action CAC

    .. data:: policy_action_afmon_flow_parm = 47

    	Policy Action Flow params (afmon)

    .. data:: policy_action_afmon_ipcbr_metric = 48

    	Policy Action IP-CBR Metric (afmon)

    .. data:: policy_action_afmon_rtp_metric = 49

    	Policy Action RTP-Custom Metric (afmon)

    .. data:: policy_action_afmon_rtp_mmr_metric = 50

    	Policy Action RTP-MMR Metric (afmon)

    .. data:: policy_action_afmon_rtp_j2k_metric = 51

    	Policy Action RTP-J2K Metric (afmon)

    .. data:: policy_action_afmon_rtp_voice_metric = 52

    	Policy Action RTP-Voice Metric (afmon)

    .. data:: policy_action_afmon_mdi_metric = 53

    	Policy Action MDI Metric (afmon)

    .. data:: policy_action_afmon_mdi_rtp_metric = 54

    	Policy Action MDI RTP Metric (afmon)

    .. data:: policy_action_afmon_fmm = 55

    	Policy Action flow monitor (afmon)

    .. data:: policy_action_pfc = 56

    	Policy Action PFC

    .. data:: policy_action_max = 57

    	Policy Action Max (Invalid)

    """

    policy_action_none = Enum.YLeaf(0, "policy-action-none")

    policy_action_unspecified = Enum.YLeaf(1, "policy-action-unspecified")

    policy_action_mark = Enum.YLeaf(2, "policy-action-mark")

    policy_action_mark2 = Enum.YLeaf(3, "policy-action-mark2")

    policy_action_wred = Enum.YLeaf(4, "policy-action-wred")

    policy_action_encap_seq = Enum.YLeaf(5, "policy-action-encap-seq")

    policy_action_priority = Enum.YLeaf(6, "policy-action-priority")

    policy_action_iphc = Enum.YLeaf(7, "policy-action-iphc")

    policy_action_bw_remaining = Enum.YLeaf(8, "policy-action-bw-remaining")

    policy_action_min_bw = Enum.YLeaf(9, "policy-action-min-bw")

    policy_action_authenticate_aaa = Enum.YLeaf(10, "policy-action-authenticate-aaa")

    policy_action_collect_id = Enum.YLeaf(11, "policy-action-collect-id")

    policy_action_disconnect = Enum.YLeaf(12, "policy-action-disconnect")

    policy_action_set_timer = Enum.YLeaf(13, "policy-action-set-timer")

    policy_action_stop_timer = Enum.YLeaf(14, "policy-action-stop-timer")

    policy_action_query_ancp = Enum.YLeaf(15, "policy-action-query-ancp")

    policy_action_accounting_aaa_list = Enum.YLeaf(16, "policy-action-accounting-aaa-list")

    policy_action_prepaid_config = Enum.YLeaf(17, "policy-action-prepaid-config")

    policy_action_timeout_idle = Enum.YLeaf(18, "policy-action-timeout-idle")

    policy_action_proxy_aaa = Enum.YLeaf(19, "policy-action-proxy-aaa")

    policy_action_template_activate = Enum.YLeaf(20, "policy-action-template-activate")

    policy_action_template_deactivate = Enum.YLeaf(21, "policy-action-template-deactivate")

    policy_action_decode_identifier = Enum.YLeaf(22, "policy-action-decode-identifier")

    policy_action_q_limit = Enum.YLeaf(23, "policy-action-q-limit")

    policy_action_authorize_id = Enum.YLeaf(24, "policy-action-authorize-id")

    policy_action_accounting_event_aaa_list = Enum.YLeaf(25, "policy-action-accounting-event-aaa-list")

    policy_action_afmon_react = Enum.YLeaf(26, "policy-action-afmon-react")

    policy_action_httpr = Enum.YLeaf(27, "policy-action-httpr")

    policy_action_pbr_transmit = Enum.YLeaf(28, "policy-action-pbr-transmit")

    policy_action_pbr_drop = Enum.YLeaf(29, "policy-action-pbr-drop")

    policy_action_punt = Enum.YLeaf(30, "policy-action-punt")

    policy_action_copy = Enum.YLeaf(31, "policy-action-copy")

    policy_action_sfrag = Enum.YLeaf(32, "policy-action-sfrag")

    policy_action_monitor = Enum.YLeaf(33, "policy-action-monitor")

    policy_action_redirect = Enum.YLeaf(34, "policy-action-redirect")

    policy_action_ipv4_nh = Enum.YLeaf(35, "policy-action-ipv4-nh")

    policy_action_ipv6_nh = Enum.YLeaf(36, "policy-action-ipv6-nh")

    policy_action_vlan_pop = Enum.YLeaf(37, "policy-action-vlan-pop")

    policy_action_pbr_next_hop = Enum.YLeaf(38, "policy-action-pbr-next-hop")

    policy_action_decap_gre = Enum.YLeaf(39, "policy-action-decap-gre")

    policy_action_output_interface = Enum.YLeaf(40, "policy-action-output-interface")

    policy_action_service_function_path = Enum.YLeaf(41, "policy-action-service-function-path")

    policy_action_ptrs = Enum.YLeaf(42, "policy-action-ptrs")

    policy_action_police = Enum.YLeaf(43, "policy-action-police")

    policy_action_shape = Enum.YLeaf(44, "policy-action-shape")

    policy_action_serv_pol = Enum.YLeaf(45, "policy-action-serv-pol")

    policy_action_cac = Enum.YLeaf(46, "policy-action-cac")

    policy_action_afmon_flow_parm = Enum.YLeaf(47, "policy-action-afmon-flow-parm")

    policy_action_afmon_ipcbr_metric = Enum.YLeaf(48, "policy-action-afmon-ipcbr-metric")

    policy_action_afmon_rtp_metric = Enum.YLeaf(49, "policy-action-afmon-rtp-metric")

    policy_action_afmon_rtp_mmr_metric = Enum.YLeaf(50, "policy-action-afmon-rtp-mmr-metric")

    policy_action_afmon_rtp_j2k_metric = Enum.YLeaf(51, "policy-action-afmon-rtp-j2k-metric")

    policy_action_afmon_rtp_voice_metric = Enum.YLeaf(52, "policy-action-afmon-rtp-voice-metric")

    policy_action_afmon_mdi_metric = Enum.YLeaf(53, "policy-action-afmon-mdi-metric")

    policy_action_afmon_mdi_rtp_metric = Enum.YLeaf(54, "policy-action-afmon-mdi-rtp-metric")

    policy_action_afmon_fmm = Enum.YLeaf(55, "policy-action-afmon-fmm")

    policy_action_pfc = Enum.YLeaf(56, "policy-action-pfc")

    policy_action_max = Enum.YLeaf(57, "policy-action-max")


class PolicyActionExecTypeE(Enum):
    """
    PolicyActionExecTypeE (Enum Class)

    Policy action execution type enum

    .. data:: execution_immediate = 1

    	execution immediate

    .. data:: execution_deferred = 2

    	execution deferred

    """

    execution_immediate = Enum.YLeaf(1, "execution-immediate")

    execution_deferred = Enum.YLeaf(2, "execution-deferred")


class PolicyClassInfoEn(Enum):
    """
    PolicyClassInfoEn (Enum Class)

    Policy class info en

    .. data:: policy_class_info_key_type = 0

    	Policy Class Info Key

    .. data:: policy_class_info_mod_type = 1

    	Policy Class Info Modify Bag

    """

    policy_class_info_key_type = Enum.YLeaf(0, "policy-class-info-key-type")

    policy_class_info_mod_type = Enum.YLeaf(1, "policy-class-info-mod-type")


class PolicyMapTableTypeEn(Enum):
    """
    PolicyMapTableTypeEn (Enum Class)

    Policy\-Map Table Type

    .. data:: policy_map_table_type_none = 0

    	policy map table type none

    .. data:: policy_map_table_type_l2_any = 1

    	policy map table type l2 any

    .. data:: policy_map_table_type_l2_l3 = 2

    	policy map table type l2 l3

    .. data:: policy_map_table_type_l3_ipv4 = 3

    	policy map table type l3 ipv4

    .. data:: policy_map_table_type_l3_ds = 4

    	policy map table type l3 ds

    .. data:: policy_map_table_type_traffic_ingress = 5

    	policy map table type traffic ingress

    .. data:: policy_map_table_type_qos_ingress = 6

    	policy map table type qos ingress

    .. data:: policy_map_table_type_qos_egress = 7

    	policy map table type qos egress

    .. data:: policy_map_table_type_max = 8

    	policy map table type max

    """

    policy_map_table_type_none = Enum.YLeaf(0, "policy-map-table-type-none")

    policy_map_table_type_l2_any = Enum.YLeaf(1, "policy-map-table-type-l2-any")

    policy_map_table_type_l2_l3 = Enum.YLeaf(2, "policy-map-table-type-l2-l3")

    policy_map_table_type_l3_ipv4 = Enum.YLeaf(3, "policy-map-table-type-l3-ipv4")

    policy_map_table_type_l3_ds = Enum.YLeaf(4, "policy-map-table-type-l3-ds")

    policy_map_table_type_traffic_ingress = Enum.YLeaf(5, "policy-map-table-type-traffic-ingress")

    policy_map_table_type_qos_ingress = Enum.YLeaf(6, "policy-map-table-type-qos-ingress")

    policy_map_table_type_qos_egress = Enum.YLeaf(7, "policy-map-table-type-qos-egress")

    policy_map_table_type_max = Enum.YLeaf(8, "policy-map-table-type-max")


class PolicyMapTypeEn(Enum):
    """
    PolicyMapTypeEn (Enum Class)

    Policy map type en

    .. data:: policy_map_type_none = 0

    	policy map type none

    .. data:: policy_map_type_qos = 1

    	policy map type qos

    .. data:: policy_map_type_pbr = 2

    	policy map type pbr

    .. data:: policy_map_type_traffic = 3

    	policy map type traffic

    .. data:: policy_map_type_subs_control = 4

    	policy map type subs control

    .. data:: policy_map_type_accounting = 5

    	policy map type accounting

    .. data:: policy_map_type_redirect = 6

    	policy map type redirect

    .. data:: policy_map_type_afmon = 7

    	policy map type afmon

    .. data:: policy_map_type_merge = 8

    	policy map type merge

    .. data:: policy_map_type_max = 9

    	policy map type max

    """

    policy_map_type_none = Enum.YLeaf(0, "policy-map-type-none")

    policy_map_type_qos = Enum.YLeaf(1, "policy-map-type-qos")

    policy_map_type_pbr = Enum.YLeaf(2, "policy-map-type-pbr")

    policy_map_type_traffic = Enum.YLeaf(3, "policy-map-type-traffic")

    policy_map_type_subs_control = Enum.YLeaf(4, "policy-map-type-subs-control")

    policy_map_type_accounting = Enum.YLeaf(5, "policy-map-type-accounting")

    policy_map_type_redirect = Enum.YLeaf(6, "policy-map-type-redirect")

    policy_map_type_afmon = Enum.YLeaf(7, "policy-map-type-afmon")

    policy_map_type_merge = Enum.YLeaf(8, "policy-map-type-merge")

    policy_map_type_max = Enum.YLeaf(9, "policy-map-type-max")


class PolicyObjEncEn(Enum):
    """
    PolicyObjEncEn (Enum Class)

    Child policy related encoding information

    .. data:: policy_obj_enc_name = 0

    	Name of the Policy

    .. data:: policy_obj_enc_hdl = 1

    	Policy Handle

    .. data:: policy_obj_enc_var_idx = 2

    	Policy Variable Index

    .. data:: policy_obj_enc_in_line = 3

    	Inline Class

    """

    policy_obj_enc_name = Enum.YLeaf(0, "policy-obj-enc-name")

    policy_obj_enc_hdl = Enum.YLeaf(1, "policy-obj-enc-hdl")

    policy_obj_enc_var_idx = Enum.YLeaf(2, "policy-obj-enc-var-idx")

    policy_obj_enc_in_line = Enum.YLeaf(3, "policy-obj-enc-in-line")


class PolicyParamUnitType(Enum):
    """
    PolicyParamUnitType (Enum Class)

    Policy param unit type

    .. data:: policy_param_unit_invalid = 0

    	policy param unit invalid

    .. data:: policy_param_unit_bytes = 1

    	policy param unit bytes

    .. data:: policy_param_unit_kbytes = 2

    	policy param unit kbytes

    .. data:: policy_param_unit_mbytes = 3

    	policy param unit mbytes

    .. data:: policy_param_unit_gbytes = 4

    	policy param unit gbytes

    .. data:: policy_param_unit_bitsps = 5

    	policy param unit bitsps

    .. data:: policy_param_unit_kbitsps = 6

    	policy param unit kbitsps

    .. data:: policy_param_unit_mbitsps = 7

    	policy param unit mbitsps

    .. data:: policy_param_unit_gbitsps = 8

    	policy param unit gbitsps

    .. data:: policy_param_unit_cells_ps = 9

    	policy param unit cells ps

    .. data:: policy_param_unit_packets_ps = 10

    	policy param unit packets ps

    .. data:: policy_param_unit_us = 11

    	policy param unit us

    .. data:: policy_param_unit_ms = 12

    	policy param unit ms

    .. data:: policy_param_unit_seconds = 13

    	policy param unit seconds

    .. data:: policy_param_unit_packets = 14

    	policy param unit packets

    .. data:: policy_param_unit_cells = 15

    	policy param unit cells

    .. data:: policy_param_unit_percent = 16

    	policy param unit percent

    .. data:: policy_param_unit_per_thousand = 17

    	policy param unit per thousand

    .. data:: policy_param_unit_per_million = 18

    	policy param unit per million

    .. data:: policy_param_unit_hz = 19

    	policy param unit hz

    .. data:: policy_param_unit_khz = 20

    	policy param unit khz

    .. data:: policy_param_unit_mhz = 21

    	policy param unit mhz

    .. data:: policy_param_unit_ratio = 22

    	policy param unit ratio

    .. data:: policy_param_unit_max = 23

    	policy param unit max

    """

    policy_param_unit_invalid = Enum.YLeaf(0, "policy-param-unit-invalid")

    policy_param_unit_bytes = Enum.YLeaf(1, "policy-param-unit-bytes")

    policy_param_unit_kbytes = Enum.YLeaf(2, "policy-param-unit-kbytes")

    policy_param_unit_mbytes = Enum.YLeaf(3, "policy-param-unit-mbytes")

    policy_param_unit_gbytes = Enum.YLeaf(4, "policy-param-unit-gbytes")

    policy_param_unit_bitsps = Enum.YLeaf(5, "policy-param-unit-bitsps")

    policy_param_unit_kbitsps = Enum.YLeaf(6, "policy-param-unit-kbitsps")

    policy_param_unit_mbitsps = Enum.YLeaf(7, "policy-param-unit-mbitsps")

    policy_param_unit_gbitsps = Enum.YLeaf(8, "policy-param-unit-gbitsps")

    policy_param_unit_cells_ps = Enum.YLeaf(9, "policy-param-unit-cells-ps")

    policy_param_unit_packets_ps = Enum.YLeaf(10, "policy-param-unit-packets-ps")

    policy_param_unit_us = Enum.YLeaf(11, "policy-param-unit-us")

    policy_param_unit_ms = Enum.YLeaf(12, "policy-param-unit-ms")

    policy_param_unit_seconds = Enum.YLeaf(13, "policy-param-unit-seconds")

    policy_param_unit_packets = Enum.YLeaf(14, "policy-param-unit-packets")

    policy_param_unit_cells = Enum.YLeaf(15, "policy-param-unit-cells")

    policy_param_unit_percent = Enum.YLeaf(16, "policy-param-unit-percent")

    policy_param_unit_per_thousand = Enum.YLeaf(17, "policy-param-unit-per-thousand")

    policy_param_unit_per_million = Enum.YLeaf(18, "policy-param-unit-per-million")

    policy_param_unit_hz = Enum.YLeaf(19, "policy-param-unit-hz")

    policy_param_unit_khz = Enum.YLeaf(20, "policy-param-unit-khz")

    policy_param_unit_mhz = Enum.YLeaf(21, "policy-param-unit-mhz")

    policy_param_unit_ratio = Enum.YLeaf(22, "policy-param-unit-ratio")

    policy_param_unit_max = Enum.YLeaf(23, "policy-param-unit-max")


class PolicyRouteTargetEn(Enum):
    """
    PolicyRouteTargetEn (Enum Class)

    Policy route target en

    .. data:: policy_rt_type_none = 0

    	policy rt type none

    .. data:: policy_rt_type_asn2 = 1

    	policy rt type asn2

    .. data:: policy_rt_type_ipv4 = 2

    	policy rt type ipv4

    .. data:: policy_rt_type_asn4 = 3

    	policy rt type asn4

    .. data:: policy_rt_type_max = 4

    	policy rt type max

    """

    policy_rt_type_none = Enum.YLeaf(0, "policy-rt-type-none")

    policy_rt_type_asn2 = Enum.YLeaf(1, "policy-rt-type-asn2")

    policy_rt_type_ipv4 = Enum.YLeaf(2, "policy-rt-type-ipv4")

    policy_rt_type_asn4 = Enum.YLeaf(3, "policy-rt-type-asn4")

    policy_rt_type_max = Enum.YLeaf(4, "policy-rt-type-max")


class PolicymgrClassMap(Enum):
    """
    PolicymgrClassMap (Enum Class)

    Policymgr class map

    .. data:: qos = 1

    	QoS Classmap

    .. data:: pbr = 2

    	PBR Classmap

    .. data:: traffic = 3

    	TRAFFIC Classmap

    .. data:: subscriber_control = 4

    	SUBSCONTROL Classmap

    """

    qos = Enum.YLeaf(1, "qos")

    pbr = Enum.YLeaf(2, "pbr")

    traffic = Enum.YLeaf(3, "traffic")

    subscriber_control = Enum.YLeaf(4, "subscriber-control")


class PolicymgrPolicyMap(Enum):
    """
    PolicymgrPolicyMap (Enum Class)

    Policymgr policy map

    .. data:: qos = 1

    	QoS Policymap

    .. data:: pbr = 2

    	PBR Policymap

    .. data:: traffic = 3

    	TRAFFIC Policymap

    .. data:: subscriber_control = 4

    	SUBSCONTROL Policymap

    .. data:: accounting = 5

    	ACCOUNTING Policymap

    .. data:: redirect = 6

    	REDIRECT Policy map

    .. data:: flow_monitor = 7

    	FlOWMONITOR Policy map

    """

    qos = Enum.YLeaf(1, "qos")

    pbr = Enum.YLeaf(2, "pbr")

    traffic = Enum.YLeaf(3, "traffic")

    subscriber_control = Enum.YLeaf(4, "subscriber-control")

    accounting = Enum.YLeaf(5, "accounting")

    redirect = Enum.YLeaf(6, "redirect")

    flow_monitor = Enum.YLeaf(7, "flow-monitor")


class QlimitTypeEn(Enum):
    """
    QlimitTypeEn (Enum Class)

    Queue Limit Types

    .. data:: qlimit_cmd = 0

    	Queue Limit

    .. data:: qlimit_discard_class = 1

    	Queue Limit based on Discard Class

    .. data:: qlimit_qos_group = 2

    	Queue Limit based on Qos Group

    .. data:: qlimit_precedence = 3

    	Queue Limit based on Precedence

    .. data:: qlimit_mpls_exp = 4

    	Queue Limit based on Mpls Exp

    .. data:: qlimit_dscp = 5

    	Queue Limit based on Dscp

    .. data:: qlimit_max = 6

    	Queue Limit Max (Invalid)

    """

    qlimit_cmd = Enum.YLeaf(0, "qlimit-cmd")

    qlimit_discard_class = Enum.YLeaf(1, "qlimit-discard-class")

    qlimit_qos_group = Enum.YLeaf(2, "qlimit-qos-group")

    qlimit_precedence = Enum.YLeaf(3, "qlimit-precedence")

    qlimit_mpls_exp = Enum.YLeaf(4, "qlimit-mpls-exp")

    qlimit_dscp = Enum.YLeaf(5, "qlimit-dscp")

    qlimit_max = Enum.YLeaf(6, "qlimit-max")


class RedirectTypeEn(Enum):
    """
    RedirectTypeEn (Enum Class)

    Redirect types Enumeration

    .. data:: redirect_type_none = 0

    	Redirect None

    .. data:: redirect_type_output_interface = 1

    	Redirect to output intreface

    .. data:: redirect_type_max = 2

    	Redirect Max (Invalid)

    """

    redirect_type_none = Enum.YLeaf(0, "redirect-type-none")

    redirect_type_output_interface = Enum.YLeaf(1, "redirect-type-output-interface")

    redirect_type_max = Enum.YLeaf(2, "redirect-type-max")


class SharedBucketType(Enum):
    """
    SharedBucketType (Enum Class)

    Shared bucket type

    .. data:: shared_bucket_type_not_specified = 0

    	shared bucket type not specified

    .. data:: shared_bucket_referred = 1

    	shared bucket referred

    .. data:: shared_bucket_defined = 2

    	shared bucket defined

    """

    shared_bucket_type_not_specified = Enum.YLeaf(0, "shared-bucket-type-not-specified")

    shared_bucket_referred = Enum.YLeaf(1, "shared-bucket-referred")

    shared_bucket_defined = Enum.YLeaf(2, "shared-bucket-defined")


class VsvcServiceTypeT(Enum):
    """
    VsvcServiceTypeT (Enum Class)

    Vsvc service type t

    .. data:: vsvc_service_invalid = 0

    	vsvc service invalid

    .. data:: vsvc_service_v_path = 1

    	vsvc service v path

    .. data:: vsvc_service_ipsec = 2

    	vsvc service ipsec

    .. data:: vsvc_service_cgn = 3

    	vsvc service cgn

    .. data:: vsvc_service_o_flow = 4

    	vsvc service o flow

    .. data:: vsvc_service_output = 5

    	vsvc service output

    .. data:: vsvc_service_cfg_v_path = 6

    	vsvc service cfg v path

    .. data:: vsvc_service_sfp = 7

    	vsvc service sfp

    .. data:: vsvc_service_sfl = 8

    	vsvc service sfl

    .. data:: vsvc_service_sffl = 9

    	vsvc service sffl

    .. data:: vsvc_service_max = 10

    	vsvc service max

    """

    vsvc_service_invalid = Enum.YLeaf(0, "vsvc-service-invalid")

    vsvc_service_v_path = Enum.YLeaf(1, "vsvc-service-v-path")

    vsvc_service_ipsec = Enum.YLeaf(2, "vsvc-service-ipsec")

    vsvc_service_cgn = Enum.YLeaf(3, "vsvc-service-cgn")

    vsvc_service_o_flow = Enum.YLeaf(4, "vsvc-service-o-flow")

    vsvc_service_output = Enum.YLeaf(5, "vsvc-service-output")

    vsvc_service_cfg_v_path = Enum.YLeaf(6, "vsvc-service-cfg-v-path")

    vsvc_service_sfp = Enum.YLeaf(7, "vsvc-service-sfp")

    vsvc_service_sfl = Enum.YLeaf(8, "vsvc-service-sfl")

    vsvc_service_sffl = Enum.YLeaf(9, "vsvc-service-sffl")

    vsvc_service_max = Enum.YLeaf(10, "vsvc-service-max")


class WredTypeEn(Enum):
    """
    WredTypeEn (Enum Class)

    Wred type en

    .. data:: wred_cos_cmd = 0

    	wred cos cmd

    .. data:: wred_dscp_cmd = 1

    	wred dscp cmd

    .. data:: wred_precedence_cmd = 2

    	wred precedence cmd

    .. data:: wred_discard_class_cmd = 3

    	wred discard class cmd

    .. data:: wred_mpls_exp_cmd = 4

    	wred mpls exp cmd

    .. data:: red_with_user_min_max = 5

    	red with user min max

    .. data:: red_with_default_min_max = 6

    	red with default min max

    .. data:: wred_dei_cmd = 7

    	wred dei cmd

    .. data:: wred_ecn_cmd = 8

    	wred ecn cmd

    .. data:: wred_invalid_cmd = 9

    	wred invalid cmd

    """

    wred_cos_cmd = Enum.YLeaf(0, "wred-cos-cmd")

    wred_dscp_cmd = Enum.YLeaf(1, "wred-dscp-cmd")

    wred_precedence_cmd = Enum.YLeaf(2, "wred-precedence-cmd")

    wred_discard_class_cmd = Enum.YLeaf(3, "wred-discard-class-cmd")

    wred_mpls_exp_cmd = Enum.YLeaf(4, "wred-mpls-exp-cmd")

    red_with_user_min_max = Enum.YLeaf(5, "red-with-user-min-max")

    red_with_default_min_max = Enum.YLeaf(6, "red-with-default-min-max")

    wred_dei_cmd = Enum.YLeaf(7, "wred-dei-cmd")

    wred_ecn_cmd = Enum.YLeaf(8, "wred-ecn-cmd")

    wred_invalid_cmd = Enum.YLeaf(9, "wred-invalid-cmd")



class PolicyManager(Entity):
    """
    Policy\-map operational data
    
    .. attribute:: global_
    
    	Global QOS operational data
    	**type**\:  :py:class:`Global <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global>`
    
    .. attribute:: nodes
    
    	Node\-specific Policymgr operational data
    	**type**\:  :py:class:`Nodes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes>`
    
    

    """

    _prefix = 'infra-policymgr-oper'
    _revision = '2018-01-17'

    def __init__(self):
        super(PolicyManager, self).__init__()
        self._top_entity = None

        self.yang_name = "policy-manager"
        self.yang_parent_name = "Cisco-IOS-XR-infra-policymgr-oper"
        self.is_top_level_class = True
        self.has_list_ancestor = False
        self.ylist_key_names = []
        self._child_classes = OrderedDict([("global", ("global_", PolicyManager.Global)), ("nodes", ("nodes", PolicyManager.Nodes))])
        self._leafs = OrderedDict()

        self.global_ = PolicyManager.Global()
        self.global_.parent = self
        self._children_name_map["global_"] = "global"

        self.nodes = PolicyManager.Nodes()
        self.nodes.parent = self
        self._children_name_map["nodes"] = "nodes"
        self._segment_path = lambda: "Cisco-IOS-XR-infra-policymgr-oper:policy-manager"
        self._is_frozen = True

    def __setattr__(self, name, value):
        self._perform_setattr(PolicyManager, [], name, value)


    class Global(Entity):
        """
        Global QOS operational data
        
        .. attribute:: policy_map_applied_types
        
        	List of Applied policymap details
        	**type**\:  :py:class:`PolicyMapAppliedTypes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes>`
        
        .. attribute:: transient_policy_map_targets_types
        
        	Transient policy\-map target table
        	**type**\:  :py:class:`TransientPolicyMapTargetsTypes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapTargetsTypes>`
        
        .. attribute:: transient_policy_map_applied_types
        
        	Transient policy\-map applied type
        	**type**\:  :py:class:`TransientPolicyMapAppliedTypes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes>`
        
        .. attribute:: target_policy_map_types
        
        	Targets of a policymap
        	**type**\:  :py:class:`TargetPolicyMapTypes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TargetPolicyMapTypes>`
        
        .. attribute:: class_map
        
        	List of classmap details
        	**type**\:  :py:class:`ClassMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap>`
        
        .. attribute:: policy_map
        
        	List of policymap details
        	**type**\:  :py:class:`PolicyMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap>`
        
        .. attribute:: summary
        
        	Summary of policy\-maps and class\-maps configured
        	**type**\:  :py:class:`Summary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.Summary>`
        
        

        """

        _prefix = 'infra-policymgr-oper'
        _revision = '2018-01-17'

        def __init__(self):
            super(PolicyManager.Global, self).__init__()

            self.yang_name = "global"
            self.yang_parent_name = "policy-manager"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("policy-map-applied-types", ("policy_map_applied_types", PolicyManager.Global.PolicyMapAppliedTypes)), ("transient-policy-map-targets-types", ("transient_policy_map_targets_types", PolicyManager.Global.TransientPolicyMapTargetsTypes)), ("transient-policy-map-applied-types", ("transient_policy_map_applied_types", PolicyManager.Global.TransientPolicyMapAppliedTypes)), ("target-policy-map-types", ("target_policy_map_types", PolicyManager.Global.TargetPolicyMapTypes)), ("class-map", ("class_map", PolicyManager.Global.ClassMap)), ("policy-map", ("policy_map", PolicyManager.Global.PolicyMap)), ("summary", ("summary", PolicyManager.Global.Summary))])
            self._leafs = OrderedDict()

            self.policy_map_applied_types = PolicyManager.Global.PolicyMapAppliedTypes()
            self.policy_map_applied_types.parent = self
            self._children_name_map["policy_map_applied_types"] = "policy-map-applied-types"

            self.transient_policy_map_targets_types = PolicyManager.Global.TransientPolicyMapTargetsTypes()
            self.transient_policy_map_targets_types.parent = self
            self._children_name_map["transient_policy_map_targets_types"] = "transient-policy-map-targets-types"

            self.transient_policy_map_applied_types = PolicyManager.Global.TransientPolicyMapAppliedTypes()
            self.transient_policy_map_applied_types.parent = self
            self._children_name_map["transient_policy_map_applied_types"] = "transient-policy-map-applied-types"

            self.target_policy_map_types = PolicyManager.Global.TargetPolicyMapTypes()
            self.target_policy_map_types.parent = self
            self._children_name_map["target_policy_map_types"] = "target-policy-map-types"

            self.class_map = PolicyManager.Global.ClassMap()
            self.class_map.parent = self
            self._children_name_map["class_map"] = "class-map"

            self.policy_map = PolicyManager.Global.PolicyMap()
            self.policy_map.parent = self
            self._children_name_map["policy_map"] = "policy-map"

            self.summary = PolicyManager.Global.Summary()
            self.summary.parent = self
            self._children_name_map["summary"] = "summary"
            self._segment_path = lambda: "global"
            self._absolute_path = lambda: "Cisco-IOS-XR-infra-policymgr-oper:policy-manager/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(PolicyManager.Global, [], name, value)


        class PolicyMapAppliedTypes(Entity):
            """
            List of Applied policymap details
            
            .. attribute:: policy_map_applied_type
            
            	Policymgr application type
            	**type**\: list of  		 :py:class:`PolicyMapAppliedType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType>`
            
            

            """

            _prefix = 'infra-policymgr-oper'
            _revision = '2018-01-17'

            def __init__(self):
                super(PolicyManager.Global.PolicyMapAppliedTypes, self).__init__()

                self.yang_name = "policy-map-applied-types"
                self.yang_parent_name = "global"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("policy-map-applied-type", ("policy_map_applied_type", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType))])
                self._leafs = OrderedDict()

                self.policy_map_applied_type = YList(self)
                self._segment_path = lambda: "policy-map-applied-types"
                self._absolute_path = lambda: "Cisco-IOS-XR-infra-policymgr-oper:policy-manager/global/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes, [], name, value)


            class PolicyMapAppliedType(Entity):
                """
                Policymgr application type
                
                .. attribute:: type  (key)
                
                	The application type
                	**type**\:  :py:class:`PolicymgrPolicyMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicymgrPolicyMap>`
                
                .. attribute:: if_names
                
                	Interface table
                	**type**\:  :py:class:`IfNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames>`
                
                

                """

                _prefix = 'infra-policymgr-oper'
                _revision = '2018-01-17'

                def __init__(self):
                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType, self).__init__()

                    self.yang_name = "policy-map-applied-type"
                    self.yang_parent_name = "policy-map-applied-types"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = ['type']
                    self._child_classes = OrderedDict([("if-names", ("if_names", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames))])
                    self._leafs = OrderedDict([
                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicymgrPolicyMap', '')])),
                    ])
                    self.type = None

                    self.if_names = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames()
                    self.if_names.parent = self
                    self._children_name_map["if_names"] = "if-names"
                    self._segment_path = lambda: "policy-map-applied-type" + "[type='" + str(self.type) + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-infra-policymgr-oper:policy-manager/global/policy-map-applied-types/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType, ['type'], name, value)


                class IfNames(Entity):
                    """
                    Interface table
                    
                    .. attribute:: if_name
                    
                    	WORD interface name
                    	**type**\: list of  		 :py:class:`IfName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName>`
                    
                    

                    """

                    _prefix = 'infra-policymgr-oper'
                    _revision = '2018-01-17'

                    def __init__(self):
                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames, self).__init__()

                        self.yang_name = "if-names"
                        self.yang_parent_name = "policy-map-applied-type"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("if-name", ("if_name", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName))])
                        self._leafs = OrderedDict()

                        self.if_name = YList(self)
                        self._segment_path = lambda: "if-names"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames, [], name, value)


                    class IfName(Entity):
                        """
                        WORD interface name
                        
                        .. attribute:: interface_name  (key)
                        
                        	Name of the interface
                        	**type**\: str
                        
                        	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                        
                        .. attribute:: input
                        
                        	Input direction table
                        	**type**\:  :py:class:`Input <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input>`
                        
                        .. attribute:: output
                        
                        	Output direction table
                        	**type**\:  :py:class:`Output <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output>`
                        
                        

                        """

                        _prefix = 'infra-policymgr-oper'
                        _revision = '2018-01-17'

                        def __init__(self):
                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName, self).__init__()

                            self.yang_name = "if-name"
                            self.yang_parent_name = "if-names"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = ['interface_name']
                            self._child_classes = OrderedDict([("input", ("input", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input)), ("output", ("output", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output))])
                            self._leafs = OrderedDict([
                                ('interface_name', (YLeaf(YType.str, 'interface-name'), ['str'])),
                            ])
                            self.interface_name = None

                            self.input = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input()
                            self.input.parent = self
                            self._children_name_map["input"] = "input"

                            self.output = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output()
                            self.output.parent = self
                            self._children_name_map["output"] = "output"
                            self._segment_path = lambda: "if-name" + "[interface-name='" + str(self.interface_name) + "']"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName, ['interface_name'], name, value)


                        class Input(Entity):
                            """
                            Input direction table
                            
                            .. attribute:: detail
                            
                            	WORD interface name
                            	**type**\:  :py:class:`Detail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail>`
                            
                            

                            """

                            _prefix = 'infra-policymgr-oper'
                            _revision = '2018-01-17'

                            def __init__(self):
                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input, self).__init__()

                                self.yang_name = "input"
                                self.yang_parent_name = "if-name"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("detail", ("detail", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail))])
                                self._leafs = OrderedDict()

                                self.detail = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail()
                                self.detail.parent = self
                                self._children_name_map["detail"] = "detail"
                                self._segment_path = lambda: "input"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input, [], name, value)


                            class Detail(Entity):
                                """
                                WORD interface name
                                
                                .. attribute:: parent_pmap_name
                                
                                	parent pmap name
                                	**type**\: str
                                
                                	**length:** 0..65
                                
                                .. attribute:: pmap_type
                                
                                	pmap type
                                	**type**\:  :py:class:`PolicyMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyMapTypeEn>`
                                
                                .. attribute:: subscriber_grp
                                
                                	subscriber grp
                                	**type**\: list of str
                                
                                	**length:** 0..65
                                
                                .. attribute:: pmaps
                                
                                	pmaps
                                	**type**\: list of  		 :py:class:`Pmaps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps>`
                                
                                .. attribute:: pmap_var_list
                                
                                	pmap var list
                                	**type**\: list of  		 :py:class:`PmapVarList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.PmapVarList>`
                                
                                

                                """

                                _prefix = 'infra-policymgr-oper'
                                _revision = '2018-01-17'

                                def __init__(self):
                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail, self).__init__()

                                    self.yang_name = "detail"
                                    self.yang_parent_name = "input"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("pmaps", ("pmaps", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps)), ("pmap-var-list", ("pmap_var_list", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.PmapVarList))])
                                    self._leafs = OrderedDict([
                                        ('parent_pmap_name', (YLeaf(YType.str, 'parent-pmap-name'), ['str'])),
                                        ('pmap_type', (YLeaf(YType.enumeration, 'pmap-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyMapTypeEn', '')])),
                                        ('subscriber_grp', (YLeafList(YType.str, 'subscriber-grp'), ['str'])),
                                    ])
                                    self.parent_pmap_name = None
                                    self.pmap_type = None
                                    self.subscriber_grp = []

                                    self.pmaps = YList(self)
                                    self.pmap_var_list = YList(self)
                                    self._segment_path = lambda: "detail"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail, ['parent_pmap_name', 'pmap_type', 'subscriber_grp'], name, value)


                                class Pmaps(Entity):
                                    """
                                    pmaps
                                    
                                    .. attribute:: policy_map_bg
                                    
                                    	policy map bg
                                    	**type**\: list of  		 :py:class:`PolicyMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg>`
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2018-01-17'

                                    def __init__(self):
                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps, self).__init__()

                                        self.yang_name = "pmaps"
                                        self.yang_parent_name = "detail"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("policy-map-bg", ("policy_map_bg", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg))])
                                        self._leafs = OrderedDict()

                                        self.policy_map_bg = YList(self)
                                        self._segment_path = lambda: "pmaps"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps, [], name, value)


                                    class PolicyMapBg(Entity):
                                        """
                                        policy map bg
                                        
                                        .. attribute:: pmap_var_list
                                        
                                        	pmap var list
                                        	**type**\:  :py:class:`PmapVarList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.PmapVarList>`
                                        
                                        .. attribute:: event_infop
                                        
                                        	event infop
                                        	**type**\:  :py:class:`EventInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop>`
                                        
                                        .. attribute:: name
                                        
                                        	name
                                        	**type**\: str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: type
                                        
                                        	type
                                        	**type**\:  :py:class:`PolicyMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyMapTypeEn>`
                                        
                                        .. attribute:: description
                                        
                                        	description
                                        	**type**\: str
                                        
                                        

                                        """

                                        _prefix = 'infra-policymgr-oper'
                                        _revision = '2018-01-17'

                                        def __init__(self):
                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg, self).__init__()

                                            self.yang_name = "policy-map-bg"
                                            self.yang_parent_name = "pmaps"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("pmap-var-list", ("pmap_var_list", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.PmapVarList)), ("event-infop", ("event_infop", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop))])
                                            self._leafs = OrderedDict([
                                                ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyMapTypeEn', '')])),
                                                ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                            ])
                                            self.name = None
                                            self.type = None
                                            self.description = None

                                            self.pmap_var_list = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.PmapVarList()
                                            self.pmap_var_list.parent = self
                                            self._children_name_map["pmap_var_list"] = "pmap-var-list"

                                            self.event_infop = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop()
                                            self.event_infop.parent = self
                                            self._children_name_map["event_infop"] = "event-infop"
                                            self._segment_path = lambda: "policy-map-bg"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg, ['name', 'type', 'description'], name, value)


                                        class PmapVarList(Entity):
                                            """
                                            pmap var list
                                            
                                            .. attribute:: pmap_var_list_arr
                                            
                                            	pmap var list arr
                                            	**type**\: list of  		 :py:class:`PmapVarListArr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.PmapVarList.PmapVarListArr>`
                                            
                                            

                                            """

                                            _prefix = 'infra-policymgr-oper'
                                            _revision = '2018-01-17'

                                            def __init__(self):
                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.PmapVarList, self).__init__()

                                                self.yang_name = "pmap-var-list"
                                                self.yang_parent_name = "policy-map-bg"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("pmap-var-list-arr", ("pmap_var_list_arr", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.PmapVarList.PmapVarListArr))])
                                                self._leafs = OrderedDict()

                                                self.pmap_var_list_arr = YList(self)
                                                self._segment_path = lambda: "pmap-var-list"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.PmapVarList, [], name, value)


                                            class PmapVarListArr(Entity):
                                                """
                                                pmap var list arr
                                                
                                                .. attribute:: val
                                                
                                                	val
                                                	**type**\:  :py:class:`Val <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.PmapVarList.PmapVarListArr.Val>`
                                                
                                                .. attribute:: name
                                                
                                                	name
                                                	**type**\: str
                                                
                                                	**length:** 0..32
                                                
                                                .. attribute:: id
                                                
                                                	id
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.PmapVarList.PmapVarListArr, self).__init__()

                                                    self.yang_name = "pmap-var-list-arr"
                                                    self.yang_parent_name = "pmap-var-list"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("val", ("val", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.PmapVarList.PmapVarListArr.Val))])
                                                    self._leafs = OrderedDict([
                                                        ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                        ('id', (YLeaf(YType.uint32, 'id'), ['int'])),
                                                    ])
                                                    self.name = None
                                                    self.id = None

                                                    self.val = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.PmapVarList.PmapVarListArr.Val()
                                                    self.val.parent = self
                                                    self._children_name_map["val"] = "val"
                                                    self._segment_path = lambda: "pmap-var-list-arr"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.PmapVarList.PmapVarListArr, ['name', 'id'], name, value)


                                                class Val(Entity):
                                                    """
                                                    val
                                                    
                                                    .. attribute:: type
                                                    
                                                    	type
                                                    	**type**\:  :py:class:`PlmgrVarTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrVarTypeEn>`
                                                    
                                                    .. attribute:: class_name
                                                    
                                                    	class name
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..65
                                                    
                                                    .. attribute:: uint8_val
                                                    
                                                    	uint8 val
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: uint16_val
                                                    
                                                    	uint16 val
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: uint32_val
                                                    
                                                    	uint32 val
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: param_uint32_val
                                                    
                                                    	param uint32 val
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: dscp_val
                                                    
                                                    	dscp val
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: prec_val
                                                    
                                                    	prec val
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.PmapVarList.PmapVarListArr.Val, self).__init__()

                                                        self.yang_name = "val"
                                                        self.yang_parent_name = "pmap-var-list-arr"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PlmgrVarTypeEn', '')])),
                                                            ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                            ('uint8_val', (YLeaf(YType.uint8, 'uint8_val'), ['int'])),
                                                            ('uint16_val', (YLeaf(YType.uint16, 'uint16_val'), ['int'])),
                                                            ('uint32_val', (YLeaf(YType.uint32, 'uint32_val'), ['int'])),
                                                            ('param_uint32_val', (YLeaf(YType.uint32, 'param-uint32-val'), ['int'])),
                                                            ('dscp_val', (YLeaf(YType.uint8, 'dscp-val'), ['int'])),
                                                            ('prec_val', (YLeaf(YType.uint8, 'prec-val'), ['int'])),
                                                        ])
                                                        self.type = None
                                                        self.class_name = None
                                                        self.uint8_val = None
                                                        self.uint16_val = None
                                                        self.uint32_val = None
                                                        self.param_uint32_val = None
                                                        self.dscp_val = None
                                                        self.prec_val = None
                                                        self._segment_path = lambda: "val"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.PmapVarList.PmapVarListArr.Val, ['type', 'class_name', 'uint8_val', 'uint16_val', 'uint32_val', 'param_uint32_val', 'dscp_val', 'prec_val'], name, value)


                                        class EventInfop(Entity):
                                            """
                                            event infop
                                            
                                            .. attribute:: policy_event_info_bg
                                            
                                            	policy event info bg
                                            	**type**\: list of  		 :py:class:`PolicyEventInfoBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg>`
                                            
                                            

                                            """

                                            _prefix = 'infra-policymgr-oper'
                                            _revision = '2018-01-17'

                                            def __init__(self):
                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop, self).__init__()

                                                self.yang_name = "event-infop"
                                                self.yang_parent_name = "policy-map-bg"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("policy-event-info-bg", ("policy_event_info_bg", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg))])
                                                self._leafs = OrderedDict()

                                                self.policy_event_info_bg = YList(self)
                                                self._segment_path = lambda: "event-infop"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop, [], name, value)


                                            class PolicyEventInfoBg(Entity):
                                                """
                                                policy event info bg
                                                
                                                .. attribute:: class_infop
                                                
                                                	class infop
                                                	**type**\:  :py:class:`ClassInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop>`
                                                
                                                .. attribute:: event_type
                                                
                                                	event type
                                                	**type**\:  :py:class:`PeventTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PeventTypeEn>`
                                                
                                                .. attribute:: cond_eval
                                                
                                                	cond eval
                                                	**type**\:  :py:class:`PeventCondEvalEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PeventCondEvalEn>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg, self).__init__()

                                                    self.yang_name = "policy-event-info-bg"
                                                    self.yang_parent_name = "event-infop"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("class-infop", ("class_infop", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop))])
                                                    self._leafs = OrderedDict([
                                                        ('event_type', (YLeaf(YType.enumeration, 'event-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PeventTypeEn', '')])),
                                                        ('cond_eval', (YLeaf(YType.enumeration, 'cond-eval'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PeventCondEvalEn', '')])),
                                                    ])
                                                    self.event_type = None
                                                    self.cond_eval = None

                                                    self.class_infop = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop()
                                                    self.class_infop.parent = self
                                                    self._children_name_map["class_infop"] = "class-infop"
                                                    self._segment_path = lambda: "policy-event-info-bg"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg, ['event_type', 'cond_eval'], name, value)


                                                class ClassInfop(Entity):
                                                    """
                                                    class infop
                                                    
                                                    .. attribute:: policy_class_info_bg
                                                    
                                                    	policy class info bg
                                                    	**type**\: list of  		 :py:class:`PolicyClassInfoBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop, self).__init__()

                                                        self.yang_name = "class-infop"
                                                        self.yang_parent_name = "policy-event-info-bg"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("policy-class-info-bg", ("policy_class_info_bg", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg))])
                                                        self._leafs = OrderedDict()

                                                        self.policy_class_info_bg = YList(self)
                                                        self._segment_path = lambda: "class-infop"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop, [], name, value)


                                                    class PolicyClassInfoBg(Entity):
                                                        """
                                                        policy class info bg
                                                        
                                                        .. attribute:: cl_encode
                                                        
                                                        	cl encode
                                                        	**type**\:  :py:class:`ClEncode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode>`
                                                        
                                                        .. attribute:: clmp_p
                                                        
                                                        	clmp p
                                                        	**type**\:  :py:class:`ClmpP <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP>`
                                                        
                                                        .. attribute:: act_infop
                                                        
                                                        	act infop
                                                        	**type**\:  :py:class:`ActInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop>`
                                                        
                                                        .. attribute:: policy_class_hd
                                                        
                                                        	policy class hd
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: seq
                                                        
                                                        	seq
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: flags
                                                        
                                                        	flags
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: ctype
                                                        
                                                        	ctype
                                                        	**type**\:  :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                        
                                                        .. attribute:: num_actions
                                                        
                                                        	num actions
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: version
                                                        
                                                        	version
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        .. attribute:: exe_strat
                                                        
                                                        	exe strat
                                                        	**type**\:  :py:class:`PclassExecStratEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PclassExecStratEn>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2018-01-17'

                                                        def __init__(self):
                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg, self).__init__()

                                                            self.yang_name = "policy-class-info-bg"
                                                            self.yang_parent_name = "class-infop"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("cl-encode", ("cl_encode", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode)), ("clmp-p", ("clmp_p", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP)), ("act-infop", ("act_infop", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop))])
                                                            self._leafs = OrderedDict([
                                                                ('policy_class_hd', (YLeaf(YType.uint32, 'policy-class-hd'), ['int'])),
                                                                ('seq', (YLeaf(YType.uint32, 'seq'), ['int'])),
                                                                ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                ('ctype', (YLeaf(YType.enumeration, 'ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapTypeEn', '')])),
                                                                ('num_actions', (YLeaf(YType.uint16, 'num-actions'), ['int'])),
                                                                ('version', (YLeaf(YType.uint8, 'version'), ['int'])),
                                                                ('exe_strat', (YLeaf(YType.enumeration, 'exe-strat'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PclassExecStratEn', '')])),
                                                            ])
                                                            self.policy_class_hd = None
                                                            self.seq = None
                                                            self.flags = None
                                                            self.ctype = None
                                                            self.num_actions = None
                                                            self.version = None
                                                            self.exe_strat = None

                                                            self.cl_encode = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode()
                                                            self.cl_encode.parent = self
                                                            self._children_name_map["cl_encode"] = "cl-encode"

                                                            self.clmp_p = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP()
                                                            self.clmp_p.parent = self
                                                            self._children_name_map["clmp_p"] = "clmp-p"

                                                            self.act_infop = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop()
                                                            self.act_infop.parent = self
                                                            self._children_name_map["act_infop"] = "act-infop"
                                                            self._segment_path = lambda: "policy-class-info-bg"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg, ['policy_class_hd', 'seq', 'flags', 'ctype', 'num_actions', 'version', 'exe_strat'], name, value)


                                                        class ClEncode(Entity):
                                                            """
                                                            cl encode
                                                            
                                                            .. attribute:: inline_cmap
                                                            
                                                            	inline cmap
                                                            	**type**\:  :py:class:`InlineCmap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap>`
                                                            
                                                            .. attribute:: enc
                                                            
                                                            	enc
                                                            	**type**\:  :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                            
                                                            .. attribute:: class_name
                                                            
                                                            	class name
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..65
                                                            
                                                            .. attribute:: hd
                                                            
                                                            	hd
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: idx
                                                            
                                                            	idx
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..255
                                                            
                                                            

                                                            """

                                                            _prefix = 'infra-policymgr-oper'
                                                            _revision = '2018-01-17'

                                                            def __init__(self):
                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode, self).__init__()

                                                                self.yang_name = "cl-encode"
                                                                self.yang_parent_name = "policy-class-info-bg"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("inline-cmap", ("inline_cmap", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap))])
                                                                self._leafs = OrderedDict([
                                                                    ('enc', (YLeaf(YType.enumeration, 'enc'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyObjEncEn', '')])),
                                                                    ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                                    ('hd', (YLeaf(YType.uint64, 'hd'), ['int'])),
                                                                    ('idx', (YLeaf(YType.uint8, 'idx'), ['int'])),
                                                                ])
                                                                self.enc = None
                                                                self.class_name = None
                                                                self.hd = None
                                                                self.idx = None

                                                                self.inline_cmap = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap()
                                                                self.inline_cmap.parent = self
                                                                self._children_name_map["inline_cmap"] = "inline-cmap"
                                                                self._segment_path = lambda: "cl-encode"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode, ['enc', 'class_name', 'hd', 'idx'], name, value)


                                                            class InlineCmap(Entity):
                                                                """
                                                                inline cmap
                                                                
                                                                .. attribute:: match_infop
                                                                
                                                                	Pointer to the first Match info
                                                                	**type**\:  :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop>`
                                                                
                                                                .. attribute:: mode
                                                                
                                                                	Inline Class\-Map Mode Match any/all
                                                                	**type**\:  :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                
                                                                .. attribute:: flags
                                                                
                                                                	Inline Class\-Map flags
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: match_count
                                                                
                                                                	Number of Match infos
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap, self).__init__()

                                                                    self.yang_name = "inline-cmap"
                                                                    self.yang_parent_name = "cl-encode"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("match-infop", ("match_infop", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop))])
                                                                    self._leafs = OrderedDict([
                                                                        ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapModeEn', '')])),
                                                                        ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                        ('match_count', (YLeaf(YType.uint32, 'match-count'), ['int'])),
                                                                    ])
                                                                    self.mode = None
                                                                    self.flags = None
                                                                    self.match_count = None

                                                                    self.match_infop = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop()
                                                                    self.match_infop.parent = self
                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                    self._segment_path = lambda: "inline-cmap"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap, ['mode', 'flags', 'match_count'], name, value)


                                                                class MatchInfop(Entity):
                                                                    """
                                                                    Pointer to the first Match info
                                                                    
                                                                    .. attribute:: class_match_info_st
                                                                    
                                                                    	class match info st
                                                                    	**type**\: list of  		 :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop, self).__init__()

                                                                        self.yang_name = "match-infop"
                                                                        self.yang_parent_name = "inline-cmap"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("class-match-info-st", ("class_match_info_st", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt))])
                                                                        self._leafs = OrderedDict()

                                                                        self.class_match_info_st = YList(self)
                                                                        self._segment_path = lambda: "match-infop"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop, [], name, value)


                                                                    class ClassMatchInfoSt(Entity):
                                                                        """
                                                                        class match info st
                                                                        
                                                                        .. attribute:: match_data
                                                                        
                                                                        	Match criteria
                                                                        	**type**\:  :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                        
                                                                        .. attribute:: flags
                                                                        
                                                                        	Flags
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                            self.yang_name = "class-match-info-st"
                                                                            self.yang_parent_name = "match-infop"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("match-data", ("match_data", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData))])
                                                                            self._leafs = OrderedDict([
                                                                                ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                            ])
                                                                            self.flags = None

                                                                            self.match_data = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                            self.match_data.parent = self
                                                                            self._children_name_map["match_data"] = "match-data"
                                                                            self._segment_path = lambda: "class-match-info-st"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                        class MatchData(Entity):
                                                                            """
                                                                            Match criteria
                                                                            
                                                                            .. attribute:: ipv4_dscp
                                                                            
                                                                            	IPv4 DSCP
                                                                            	**type**\:  :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                            
                                                                            .. attribute:: ipv6_dscp
                                                                            
                                                                            	IPv6 DSCP
                                                                            	**type**\:  :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                            
                                                                            .. attribute:: dscp
                                                                            
                                                                            	Match DSCP range array
                                                                            	**type**\:  :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                            
                                                                            .. attribute:: ipv4_prec
                                                                            
                                                                            	IPv4 Precedence
                                                                            	**type**\:  :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                            
                                                                            .. attribute:: ipv6_prec
                                                                            
                                                                            	IPv6 Precedence
                                                                            	**type**\:  :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                            
                                                                            .. attribute:: prec
                                                                            
                                                                            	Match Precedence array
                                                                            	**type**\:  :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                            
                                                                            .. attribute:: discard_class
                                                                            
                                                                            	Match Discard Class array
                                                                            	**type**\:  :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                            
                                                                            .. attribute:: qos_group
                                                                            
                                                                            	Match QoS group array
                                                                            	**type**\:  :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                            
                                                                            .. attribute:: traffic_class
                                                                            
                                                                            	Match Traffic class array
                                                                            	**type**\:  :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                            
                                                                            .. attribute:: proto
                                                                            
                                                                            	Match Protocol array
                                                                            	**type**\:  :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                            
                                                                            .. attribute:: icmp_v4
                                                                            
                                                                            	Match ICMPV4 Protocol
                                                                            	**type**\:  :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                            
                                                                            .. attribute:: icmp_v6
                                                                            
                                                                            	Match ICMPV6 Protocol array
                                                                            	**type**\:  :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                            
                                                                            .. attribute:: ipv4_packet_len
                                                                            
                                                                            	IPv4 packet length array
                                                                            	**type**\:  :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                            
                                                                            .. attribute:: ipv6_packet_len
                                                                            
                                                                            	IPv6 packet length array
                                                                            	**type**\:  :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                            
                                                                            .. attribute:: packet_len
                                                                            
                                                                            	Match packet length array
                                                                            	**type**\:  :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                            
                                                                            .. attribute:: flow_tag
                                                                            
                                                                            	Match flow\-tag array
                                                                            	**type**\:  :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                            
                                                                            .. attribute:: tcp_flag
                                                                            
                                                                            	Match tcp flag value
                                                                            	**type**\:  :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                            
                                                                            .. attribute:: icmpv4_type
                                                                            
                                                                            	Match ipv4 icmp type
                                                                            	**type**\:  :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                            
                                                                            .. attribute:: icmpv4_code
                                                                            
                                                                            	Match ipv4 icmp code
                                                                            	**type**\:  :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                            
                                                                            .. attribute:: icmpv6_type
                                                                            
                                                                            	Match ipv6 icmp type
                                                                            	**type**\:  :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                            
                                                                            .. attribute:: icmpv6_code
                                                                            
                                                                            	Match ipv6 icmp code
                                                                            	**type**\:  :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                            
                                                                            .. attribute:: mpls_exp
                                                                            
                                                                            	Match MPLS experimental topmost array
                                                                            	**type**\:  :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                            
                                                                            .. attribute:: mpls_exp_imp
                                                                            
                                                                            	Match MPLS experimental imposition array
                                                                            	**type**\:  :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                            
                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                            
                                                                            	MPLS Disposition IPv4 Access\-list
                                                                            	**type**\:  :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                            
                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                            
                                                                            	MPLS Disposition IPv6 Access\-list
                                                                            	**type**\:  :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                            
                                                                            .. attribute:: mpls_top_label
                                                                            
                                                                            	MPLS Topmost LABEL
                                                                            	**type**\:  :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                            
                                                                            .. attribute:: cos
                                                                            
                                                                            	Match CoS array
                                                                            	**type**\:  :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                            
                                                                            .. attribute:: cos_inr
                                                                            
                                                                            	Match inner header CoS
                                                                            	**type**\:  :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                            
                                                                            .. attribute:: dei
                                                                            
                                                                            	Match DEI Bit
                                                                            	**type**\:  :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                            
                                                                            .. attribute:: dei_inr
                                                                            
                                                                            	Match inner DEI Bit
                                                                            	**type**\:  :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                            
                                                                            .. attribute:: vlan
                                                                            
                                                                            	Match VLAN array
                                                                            	**type**\:  :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                            
                                                                            .. attribute:: vlan_inr
                                                                            
                                                                            	Match inner header VLAN range array
                                                                            	**type**\:  :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                            
                                                                            .. attribute:: fr_dlci
                                                                            
                                                                            	Match FR DLCI range array
                                                                            	**type**\:  :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                            
                                                                            .. attribute:: src_mac
                                                                            
                                                                            	Match Source MAC address
                                                                            	**type**\:  :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                            
                                                                            .. attribute:: dst_mac
                                                                            
                                                                            	Match Destination MAC address
                                                                            	**type**\:  :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                            
                                                                            .. attribute:: atm_clp
                                                                            
                                                                            	Match ATM CLP level
                                                                            	**type**\:  :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                            
                                                                            .. attribute:: fr_de
                                                                            
                                                                            	Match FR DE value
                                                                            	**type**\:  :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                            
                                                                            .. attribute:: ipv4_acl
                                                                            
                                                                            	IPv4 Access\-list
                                                                            	**type**\:  :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                            
                                                                            .. attribute:: ipv6_acl
                                                                            
                                                                            	IPv6 Access\-list
                                                                            	**type**\:  :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                            
                                                                            .. attribute:: ether_service_acl
                                                                            
                                                                            	Ethernet\-Services Access\-list
                                                                            	**type**\:  :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                            
                                                                            .. attribute:: avail_id
                                                                            
                                                                            	Available Identifiers
                                                                            	**type**\:  :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                            
                                                                            .. attribute:: media_type
                                                                            
                                                                            	Media Type
                                                                            	**type**\:  :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                            
                                                                            .. attribute:: subs_protocol
                                                                            
                                                                            	Protocol
                                                                            	**type**\:  :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                            
                                                                            .. attribute:: dnis
                                                                            
                                                                            	DNIS
                                                                            	**type**\:  :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                            
                                                                            .. attribute:: dnis_regex
                                                                            
                                                                            	DNIS Regular Expression
                                                                            	**type**\:  :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                            
                                                                            .. attribute:: domain
                                                                            
                                                                            	Domain Name
                                                                            	**type**\:  :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                            
                                                                            .. attribute:: domain_regex
                                                                            
                                                                            	Domain Regular Expression
                                                                            	**type**\:  :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                            
                                                                            .. attribute:: nas_port
                                                                            
                                                                            	NAS Port
                                                                            	**type**\:  :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                            
                                                                            .. attribute:: service_name
                                                                            
                                                                            	Service Name
                                                                            	**type**\:  :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                            
                                                                            .. attribute:: service_name_regex
                                                                            
                                                                            	Service Name Regular Exp
                                                                            	**type**\:  :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                            
                                                                            .. attribute:: src_addr_ipv4
                                                                            
                                                                            	Source Address IPV4
                                                                            	**type**\:  :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                            
                                                                            .. attribute:: dst_addr_ipv4
                                                                            
                                                                            	Destination Address IPV4
                                                                            	**type**\:  :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                            
                                                                            .. attribute:: src_addr_ipv6
                                                                            
                                                                            	Source Address IPV6
                                                                            	**type**\:  :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                            
                                                                            .. attribute:: dst_addr_ipv6
                                                                            
                                                                            	Destination Address IPV6
                                                                            	**type**\:  :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                            
                                                                            .. attribute:: src_addr_mac
                                                                            
                                                                            	Source Address MAC
                                                                            	**type**\:  :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                            
                                                                            .. attribute:: timer
                                                                            
                                                                            	Timer
                                                                            	**type**\:  :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                            
                                                                            .. attribute:: timer_regexp
                                                                            
                                                                            	Timer Regular Expression
                                                                            	**type**\:  :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                            
                                                                            .. attribute:: tunnel_name
                                                                            
                                                                            	Tunnel Name
                                                                            	**type**\:  :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                            
                                                                            .. attribute:: tunnel_name_regex
                                                                            
                                                                            	Tunnel Name Regular Expression
                                                                            	**type**\:  :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                            
                                                                            .. attribute:: user_name
                                                                            
                                                                            	User Name
                                                                            	**type**\:  :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                            
                                                                            .. attribute:: user_name_regex
                                                                            
                                                                            	User Name Regular Expression
                                                                            	**type**\:  :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                            
                                                                            .. attribute:: auth_username
                                                                            
                                                                            	Authenticated User Name
                                                                            	**type**\:  :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                            
                                                                            .. attribute:: auth_username_regex
                                                                            
                                                                            	Authenticated User Name RegEx
                                                                            	**type**\:  :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                            
                                                                            .. attribute:: unauth_username
                                                                            
                                                                            	Unauthenticated User Name
                                                                            	**type**\:  :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                            
                                                                            .. attribute:: unauth_username_regex
                                                                            
                                                                            	Unauthenticated User Name RegEx
                                                                            	**type**\:  :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                            
                                                                            .. attribute:: auth_domain
                                                                            
                                                                            	Authenticated domain name
                                                                            	**type**\:  :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                            
                                                                            .. attribute:: auth_domain_regex
                                                                            
                                                                            	Authenticated Domain Name RegEx
                                                                            	**type**\:  :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                            
                                                                            .. attribute:: unauth_domain
                                                                            
                                                                            	Unauthenticated Domain Name
                                                                            	**type**\:  :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                            
                                                                            .. attribute:: unauth_domain_regex
                                                                            
                                                                            	Unauthenticated Domain Name RegEx
                                                                            	**type**\:  :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                            
                                                                            .. attribute:: vendor_id
                                                                            
                                                                            	Vendor ID
                                                                            	**type**\:  :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                            
                                                                            .. attribute:: vendor_id_regex
                                                                            
                                                                            	Vendor ID RegEx
                                                                            	**type**\:  :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                            
                                                                            .. attribute:: access_interface
                                                                            
                                                                            	Access interface
                                                                            	**type**\:  :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                            
                                                                            .. attribute:: input_interface
                                                                            
                                                                            	Input interface
                                                                            	**type**\:  :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                            
                                                                            .. attribute:: input_intfhdl
                                                                            
                                                                            	Input interface handle
                                                                            	**type**\:  :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                            
                                                                            .. attribute:: ethertype
                                                                            
                                                                            	Ethernet type
                                                                            	**type**\:  :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                            
                                                                            .. attribute:: flow_key_data
                                                                            
                                                                            	Flow key structure
                                                                            	**type**\:  :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                            
                                                                            .. attribute:: dhcp_client_id
                                                                            
                                                                            	Dhcp Client ID
                                                                            	**type**\:  :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                            
                                                                            .. attribute:: dhcp_client_id_regex
                                                                            
                                                                            	Dhcp Client ID RegEx
                                                                            	**type**\:  :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                            
                                                                            .. attribute:: circuit_id
                                                                            
                                                                            	Circuit ID
                                                                            	**type**\:  :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                            
                                                                            .. attribute:: circuit_id_regex
                                                                            
                                                                            	Circuit ID RegEx
                                                                            	**type**\:  :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                            
                                                                            .. attribute:: remote_id
                                                                            
                                                                            	Remote ID
                                                                            	**type**\:  :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                            
                                                                            .. attribute:: remote_id_regex
                                                                            
                                                                            	Remote ID RegEx
                                                                            	**type**\:  :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                            
                                                                            .. attribute:: src_port
                                                                            
                                                                            	Source port
                                                                            	**type**\:  :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                            
                                                                            .. attribute:: dst_port
                                                                            
                                                                            	Destination port
                                                                            	**type**\:  :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:  :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                            
                                                                            .. attribute:: mpls_top_eos
                                                                            
                                                                            	MPLS Topmost EOS
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: fragment_type
                                                                            
                                                                            	Fragment type
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: authen_status
                                                                            
                                                                            	Authentication Status
                                                                            	**type**\:  :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                            
                                                                            .. attribute:: mlp_negotiated
                                                                            
                                                                            	MLP Negotiated
                                                                            	**type**\:  :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                self.yang_name = "match-data"
                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("ipv4-dscp", ("ipv4_dscp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp)), ("ipv6-dscp", ("ipv6_dscp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp)), ("dscp", ("dscp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp)), ("ipv4-prec", ("ipv4_prec", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec)), ("ipv6-prec", ("ipv6_prec", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec)), ("prec", ("prec", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec)), ("discard-class", ("discard_class", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass)), ("qos-group", ("qos_group", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup)), ("traffic-class", ("traffic_class", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass)), ("proto", ("proto", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto)), ("icmp-v4", ("icmp_v4", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4)), ("icmp-v6", ("icmp_v6", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6)), ("ipv4-packet-len", ("ipv4_packet_len", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen)), ("ipv6-packet-len", ("ipv6_packet_len", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen)), ("packet-len", ("packet_len", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen)), ("flow-tag", ("flow_tag", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag)), ("tcp-flag", ("tcp_flag", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag)), ("icmpv4-type", ("icmpv4_type", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type)), ("icmpv4-code", ("icmpv4_code", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code)), ("icmpv6-type", ("icmpv6_type", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type)), ("icmpv6-code", ("icmpv6_code", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code)), ("mpls-exp", ("mpls_exp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp)), ("mpls-exp-imp", ("mpls_exp_imp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp)), ("mpls-disp-ipv4-acl", ("mpls_disp_ipv4_acl", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl)), ("mpls-disp-ipv6-acl", ("mpls_disp_ipv6_acl", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl)), ("mpls-top-label", ("mpls_top_label", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel)), ("cos", ("cos", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos)), ("cos-inr", ("cos_inr", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr)), ("dei", ("dei", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei)), ("dei-inr", ("dei_inr", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr)), ("vlan", ("vlan", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan)), ("vlan-inr", ("vlan_inr", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)), ("fr-dlci", ("fr_dlci", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci)), ("src-mac", ("src_mac", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac)), ("dst-mac", ("dst_mac", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac)), ("atm-clp", ("atm_clp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp)), ("fr-de", ("fr_de", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe)), ("ipv4-acl", ("ipv4_acl", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl)), ("ipv6-acl", ("ipv6_acl", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl)), ("ether-service-acl", ("ether_service_acl", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl)), ("avail-id", ("avail_id", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId)), ("media-type", ("media_type", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType)), ("subs-protocol", ("subs_protocol", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol)), ("dnis", ("dnis", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis)), ("dnis-regex", ("dnis_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex)), ("domain", ("domain", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain)), ("domain-regex", ("domain_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex)), ("nas-port", ("nas_port", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort)), ("service-name", ("service_name", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName)), ("service-name-regex", ("service_name_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex)), ("src-addr-ipv4", ("src_addr_ipv4", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4)), ("dst-addr-ipv4", ("dst_addr_ipv4", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4)), ("src-addr-ipv6", ("src_addr_ipv6", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6)), ("dst-addr-ipv6", ("dst_addr_ipv6", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6)), ("src-addr-mac", ("src_addr_mac", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac)), ("timer", ("timer", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer)), ("timer-regexp", ("timer_regexp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp)), ("tunnel-name", ("tunnel_name", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName)), ("tunnel-name-regex", ("tunnel_name_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex)), ("user-name", ("user_name", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName)), ("user-name-regex", ("user_name_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex)), ("auth-username", ("auth_username", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername)), ("auth-username-regex", ("auth_username_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex)), ("unauth-username", ("unauth_username", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername)), ("unauth-username-regex", ("unauth_username_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex)), ("auth-domain", ("auth_domain", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain)), ("auth-domain-regex", ("auth_domain_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex)), ("unauth-domain", ("unauth_domain", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain)), ("unauth-domain-regex", ("unauth_domain_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex)), ("vendor-id", ("vendor_id", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId)), ("vendor-id-regex", ("vendor_id_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex)), ("access-interface", ("access_interface", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface)), ("input-interface", ("input_interface", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface)), ("input-intfhdl", ("input_intfhdl", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl)), ("ethertype", ("ethertype", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype)), ("flow-key-data", ("flow_key_data", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData)), ("dhcp-client-id", ("dhcp_client_id", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId)), ("dhcp-client-id-regex", ("dhcp_client_id_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex)), ("circuit-id", ("circuit_id", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId)), ("circuit-id-regex", ("circuit_id_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex)), ("remote-id", ("remote_id", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId)), ("remote-id-regex", ("remote_id_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex)), ("src-port", ("src_port", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort)), ("dst-port", ("dst_port", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchTypeEn', '')])),
                                                                                    ('mpls_top_eos', (YLeaf(YType.uint8, 'mpls-top-eos'), ['int'])),
                                                                                    ('fragment_type', (YLeaf(YType.uint8, 'fragment-type'), ['int'])),
                                                                                    ('authen_status', (YLeaf(YType.enumeration, 'authen-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchAuthenStatusEn', '')])),
                                                                                    ('mlp_negotiated', (YLeaf(YType.enumeration, 'mlp-negotiated'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchMlpNegotiatedEn', '')])),
                                                                                ])
                                                                                self.type = None
                                                                                self.mpls_top_eos = None
                                                                                self.fragment_type = None
                                                                                self.authen_status = None
                                                                                self.mlp_negotiated = None

                                                                                self.ipv4_dscp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                self.ipv4_dscp.parent = self
                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"

                                                                                self.ipv6_dscp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                self.ipv6_dscp.parent = self
                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"

                                                                                self.dscp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                self.dscp.parent = self
                                                                                self._children_name_map["dscp"] = "dscp"

                                                                                self.ipv4_prec = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                self.ipv4_prec.parent = self
                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"

                                                                                self.ipv6_prec = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                self.ipv6_prec.parent = self
                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"

                                                                                self.prec = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                self.prec.parent = self
                                                                                self._children_name_map["prec"] = "prec"

                                                                                self.discard_class = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                self.discard_class.parent = self
                                                                                self._children_name_map["discard_class"] = "discard-class"

                                                                                self.qos_group = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                self.qos_group.parent = self
                                                                                self._children_name_map["qos_group"] = "qos-group"

                                                                                self.traffic_class = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                self.traffic_class.parent = self
                                                                                self._children_name_map["traffic_class"] = "traffic-class"

                                                                                self.proto = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                self.proto.parent = self
                                                                                self._children_name_map["proto"] = "proto"

                                                                                self.icmp_v4 = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                self.icmp_v4.parent = self
                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"

                                                                                self.icmp_v6 = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                self.icmp_v6.parent = self
                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"

                                                                                self.ipv4_packet_len = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                self.ipv4_packet_len.parent = self
                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"

                                                                                self.ipv6_packet_len = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                self.ipv6_packet_len.parent = self
                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"

                                                                                self.packet_len = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                self.packet_len.parent = self
                                                                                self._children_name_map["packet_len"] = "packet-len"

                                                                                self.flow_tag = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                self.flow_tag.parent = self
                                                                                self._children_name_map["flow_tag"] = "flow-tag"

                                                                                self.tcp_flag = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                self.tcp_flag.parent = self
                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"

                                                                                self.icmpv4_type = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                self.icmpv4_type.parent = self
                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"

                                                                                self.icmpv4_code = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                self.icmpv4_code.parent = self
                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"

                                                                                self.icmpv6_type = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                self.icmpv6_type.parent = self
                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"

                                                                                self.icmpv6_code = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                self.icmpv6_code.parent = self
                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"

                                                                                self.mpls_exp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                self.mpls_exp.parent = self
                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"

                                                                                self.mpls_exp_imp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                self.mpls_exp_imp.parent = self
                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"

                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"

                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"

                                                                                self.mpls_top_label = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                self.mpls_top_label.parent = self
                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"

                                                                                self.cos = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                self.cos.parent = self
                                                                                self._children_name_map["cos"] = "cos"

                                                                                self.cos_inr = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                self.cos_inr.parent = self
                                                                                self._children_name_map["cos_inr"] = "cos-inr"

                                                                                self.dei = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                self.dei.parent = self
                                                                                self._children_name_map["dei"] = "dei"

                                                                                self.dei_inr = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                self.dei_inr.parent = self
                                                                                self._children_name_map["dei_inr"] = "dei-inr"

                                                                                self.vlan = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                self.vlan.parent = self
                                                                                self._children_name_map["vlan"] = "vlan"

                                                                                self.vlan_inr = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                self.vlan_inr.parent = self
                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"

                                                                                self.fr_dlci = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                self.fr_dlci.parent = self
                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"

                                                                                self.src_mac = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                self.src_mac.parent = self
                                                                                self._children_name_map["src_mac"] = "src-mac"

                                                                                self.dst_mac = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                self.dst_mac.parent = self
                                                                                self._children_name_map["dst_mac"] = "dst-mac"

                                                                                self.atm_clp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                self.atm_clp.parent = self
                                                                                self._children_name_map["atm_clp"] = "atm-clp"

                                                                                self.fr_de = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                self.fr_de.parent = self
                                                                                self._children_name_map["fr_de"] = "fr-de"

                                                                                self.ipv4_acl = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                self.ipv4_acl.parent = self
                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"

                                                                                self.ipv6_acl = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                self.ipv6_acl.parent = self
                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"

                                                                                self.ether_service_acl = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                self.ether_service_acl.parent = self
                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"

                                                                                self.avail_id = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                self.avail_id.parent = self
                                                                                self._children_name_map["avail_id"] = "avail-id"

                                                                                self.media_type = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                self.media_type.parent = self
                                                                                self._children_name_map["media_type"] = "media-type"

                                                                                self.subs_protocol = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                self.subs_protocol.parent = self
                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"

                                                                                self.dnis = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                self.dnis.parent = self
                                                                                self._children_name_map["dnis"] = "dnis"

                                                                                self.dnis_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                self.dnis_regex.parent = self
                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"

                                                                                self.domain = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                self.domain.parent = self
                                                                                self._children_name_map["domain"] = "domain"

                                                                                self.domain_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                self.domain_regex.parent = self
                                                                                self._children_name_map["domain_regex"] = "domain-regex"

                                                                                self.nas_port = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                self.nas_port.parent = self
                                                                                self._children_name_map["nas_port"] = "nas-port"

                                                                                self.service_name = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                self.service_name.parent = self
                                                                                self._children_name_map["service_name"] = "service-name"

                                                                                self.service_name_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                self.service_name_regex.parent = self
                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"

                                                                                self.src_addr_ipv4 = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                self.src_addr_ipv4.parent = self
                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"

                                                                                self.dst_addr_ipv4 = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                self.dst_addr_ipv4.parent = self
                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"

                                                                                self.src_addr_ipv6 = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                self.src_addr_ipv6.parent = self
                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"

                                                                                self.dst_addr_ipv6 = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                self.dst_addr_ipv6.parent = self
                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"

                                                                                self.src_addr_mac = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                self.src_addr_mac.parent = self
                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"

                                                                                self.timer = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                self.timer.parent = self
                                                                                self._children_name_map["timer"] = "timer"

                                                                                self.timer_regexp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                self.timer_regexp.parent = self
                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"

                                                                                self.tunnel_name = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                self.tunnel_name.parent = self
                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"

                                                                                self.tunnel_name_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                self.tunnel_name_regex.parent = self
                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"

                                                                                self.user_name = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                self.user_name.parent = self
                                                                                self._children_name_map["user_name"] = "user-name"

                                                                                self.user_name_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                self.user_name_regex.parent = self
                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"

                                                                                self.auth_username = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                self.auth_username.parent = self
                                                                                self._children_name_map["auth_username"] = "auth-username"

                                                                                self.auth_username_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                self.auth_username_regex.parent = self
                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"

                                                                                self.unauth_username = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                self.unauth_username.parent = self
                                                                                self._children_name_map["unauth_username"] = "unauth-username"

                                                                                self.unauth_username_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                self.unauth_username_regex.parent = self
                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"

                                                                                self.auth_domain = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                self.auth_domain.parent = self
                                                                                self._children_name_map["auth_domain"] = "auth-domain"

                                                                                self.auth_domain_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                self.auth_domain_regex.parent = self
                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"

                                                                                self.unauth_domain = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                self.unauth_domain.parent = self
                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"

                                                                                self.unauth_domain_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                self.unauth_domain_regex.parent = self
                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"

                                                                                self.vendor_id = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                self.vendor_id.parent = self
                                                                                self._children_name_map["vendor_id"] = "vendor-id"

                                                                                self.vendor_id_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                self.vendor_id_regex.parent = self
                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"

                                                                                self.access_interface = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                self.access_interface.parent = self
                                                                                self._children_name_map["access_interface"] = "access-interface"

                                                                                self.input_interface = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                self.input_interface.parent = self
                                                                                self._children_name_map["input_interface"] = "input-interface"

                                                                                self.input_intfhdl = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                self.input_intfhdl.parent = self
                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"

                                                                                self.ethertype = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                self.ethertype.parent = self
                                                                                self._children_name_map["ethertype"] = "ethertype"

                                                                                self.flow_key_data = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                self.flow_key_data.parent = self
                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"

                                                                                self.dhcp_client_id = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                self.dhcp_client_id.parent = self
                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"

                                                                                self.dhcp_client_id_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                self.dhcp_client_id_regex.parent = self
                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"

                                                                                self.circuit_id = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                self.circuit_id.parent = self
                                                                                self._children_name_map["circuit_id"] = "circuit-id"

                                                                                self.circuit_id_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                self.circuit_id_regex.parent = self
                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"

                                                                                self.remote_id = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                self.remote_id.parent = self
                                                                                self._children_name_map["remote_id"] = "remote-id"

                                                                                self.remote_id_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                self.remote_id_regex.parent = self
                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"

                                                                                self.src_port = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                self.src_port.parent = self
                                                                                self._children_name_map["src_port"] = "src-port"

                                                                                self.dst_port = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                self.dst_port.parent = self
                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                self._segment_path = lambda: "match-data"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, ['type', 'mpls_top_eos', 'fragment_type', 'authen_status', 'mlp_negotiated'], name, value)


                                                                            class Ipv4Dscp(Entity):
                                                                                """
                                                                                IPv4 DSCP
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                    self.yang_name = "ipv4-dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv4-dscp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Ipv6Dscp(Entity):
                                                                                """
                                                                                IPv6 DSCP
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                    self.yang_name = "ipv6-dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv6-dscp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Dscp(Entity):
                                                                                """
                                                                                Match DSCP range array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                    self.yang_name = "dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "dscp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Ipv4Prec(Entity):
                                                                                """
                                                                                IPv4 Precedence
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                    self.yang_name = "ipv4-prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "ipv4-prec"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                            class Ipv6Prec(Entity):
                                                                                """
                                                                                IPv6 Precedence
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                    self.yang_name = "ipv6-prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "ipv6-prec"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                            class Prec(Entity):
                                                                                """
                                                                                Match Precedence array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                    self.yang_name = "prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "prec"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                            class DiscardClass(Entity):
                                                                                """
                                                                                Match Discard Class array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                    self.yang_name = "discard-class"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "discard-class"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                            class QosGroup(Entity):
                                                                                """
                                                                                Match QoS group array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                    self.yang_name = "qos-group"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "qos-group"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "qos-group"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class TrafficClass(Entity):
                                                                                """
                                                                                Match Traffic class array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                    self.yang_name = "traffic-class"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "traffic-class"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "traffic-class"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Proto(Entity):
                                                                                """
                                                                                Match Protocol array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                    self.yang_name = "proto"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "proto"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "proto"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class IcmpV4(Entity):
                                                                                """
                                                                                Match ICMPV4 Protocol
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Protocol type
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: code
                                                                                
                                                                                	Protocol code
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                    self.yang_name = "icmp-v4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                    ])
                                                                                    self.type = None
                                                                                    self.code = None
                                                                                    self._segment_path = lambda: "icmp-v4"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['type', 'code'], name, value)


                                                                            class IcmpV6(Entity):
                                                                                """
                                                                                Match ICMPV6 Protocol array
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Protocol type
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: code
                                                                                
                                                                                	Protocol code
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                    self.yang_name = "icmp-v6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                    ])
                                                                                    self.type = None
                                                                                    self.code = None
                                                                                    self._segment_path = lambda: "icmp-v6"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['type', 'code'], name, value)


                                                                            class Ipv4PacketLen(Entity):
                                                                                """
                                                                                IPv4 packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv4-packet-len"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class Ipv6PacketLen(Entity):
                                                                                """
                                                                                IPv6 packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv6-packet-len"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class PacketLen(Entity):
                                                                                """
                                                                                Match packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                    self.yang_name = "packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "packet-len"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class FlowTag(Entity):
                                                                                """
                                                                                Match flow\-tag array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                    self.yang_name = "flow-tag"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "flow-tag"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "flow-tag"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class TcpFlag(Entity):
                                                                                """
                                                                                Match tcp flag value
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	Value of TCP flag
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: match_any
                                                                                
                                                                                	Match any TCP flag bit
                                                                                	**type**\: bool
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                    self.yang_name = "tcp-flag"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                        ('match_any', (YLeaf(YType.boolean, 'match-any'), ['bool'])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.match_any = None
                                                                                    self._segment_path = lambda: "tcp-flag"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['value', 'match_any'], name, value)


                                                                            class Icmpv4Type(Entity):
                                                                                """
                                                                                Match ipv4 icmp type
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                    self.yang_name = "icmpv4-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv4-type"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Icmpv4Code(Entity):
                                                                                """
                                                                                Match ipv4 icmp code
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                    self.yang_name = "icmpv4-code"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv4-code"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Icmpv6Type(Entity):
                                                                                """
                                                                                Match ipv6 icmp type
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                    self.yang_name = "icmpv6-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv6-type"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Icmpv6Code(Entity):
                                                                                """
                                                                                Match ipv6 icmp code
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                    self.yang_name = "icmpv6-code"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv6-code"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class MplsExp(Entity):
                                                                                """
                                                                                Match MPLS experimental topmost array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                    self.yang_name = "mpls-exp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "mpls-exp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                            class MplsExpImp(Entity):
                                                                                """
                                                                                Match MPLS experimental imposition array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "mpls-exp-imp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                            class MplsDispIpv4Acl(Entity):
                                                                                """
                                                                                MPLS Disposition IPv4 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                            class MplsDispIpv6Acl(Entity):
                                                                                """
                                                                                MPLS Disposition IPv6 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                            class MplsTopLabel(Entity):
                                                                                """
                                                                                MPLS Topmost LABEL
                                                                                
                                                                                .. attribute:: uint32_rng_array
                                                                                
                                                                                	uint32 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                    self.yang_name = "mpls-top-label"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint32_rng_array", ("uint32_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint32_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "mpls-top-label"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                class Uint32RngArray(Entity):
                                                                                    """
                                                                                    uint32 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                        self.yang_name = "uint32_rng_array"
                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint32, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint32, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint32_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['min', 'max'], name, value)


                                                                            class Cos(Entity):
                                                                                """
                                                                                Match CoS array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                    self.yang_name = "cos"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "cos"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                            class CosInr(Entity):
                                                                                """
                                                                                Match inner header CoS
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                    self.yang_name = "cos-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "cos-inr"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                            class Dei(Entity):
                                                                                """
                                                                                Match DEI Bit
                                                                                
                                                                                .. attribute:: bit_value
                                                                                
                                                                                	Value of the DEI bit
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                    self.yang_name = "dei"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                    ])
                                                                                    self.bit_value = None
                                                                                    self._segment_path = lambda: "dei"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                            class DeiInr(Entity):
                                                                                """
                                                                                Match inner DEI Bit
                                                                                
                                                                                .. attribute:: bit_value
                                                                                
                                                                                	Value of the DEI bit
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                    self.yang_name = "dei-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                    ])
                                                                                    self.bit_value = None
                                                                                    self._segment_path = lambda: "dei-inr"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                            class Vlan(Entity):
                                                                                """
                                                                                Match VLAN array
                                                                                
                                                                                .. attribute:: vlan_id_array
                                                                                
                                                                                	vlan id array
                                                                                	**type**\: list of  		 :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                    self.yang_name = "vlan"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("vlan-id-array", ("vlan_id_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.vlan_id_array = YList(self)
                                                                                    self._segment_path = lambda: "vlan"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                class VlanIdArray(Entity):
                                                                                    """
                                                                                    vlan id array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	VLAN mask
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                        self.yang_name = "vlan-id-array"
                                                                                        self.yang_parent_name = "vlan"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                            ('mask', (YLeaf(YType.uint16, 'mask'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self.mask = None
                                                                                        self._segment_path = lambda: "vlan-id-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['min', 'max', 'mask'], name, value)


                                                                            class VlanInr(Entity):
                                                                                """
                                                                                Match inner header VLAN range array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                    self.yang_name = "vlan-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "vlan-inr"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class FrDlci(Entity):
                                                                                """
                                                                                Match FR DLCI range array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                    self.yang_name = "fr-dlci"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "fr-dlci"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class SrcMac(Entity):
                                                                                """
                                                                                Match Source MAC address
                                                                                
                                                                                .. attribute:: mac_addr
                                                                                
                                                                                	MAC address
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	MAC mask
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                    self.yang_name = "src-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                    ])
                                                                                    self.mac_addr = []
                                                                                    self.mask = []
                                                                                    self._segment_path = lambda: "src-mac"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                            class DstMac(Entity):
                                                                                """
                                                                                Match Destination MAC address
                                                                                
                                                                                .. attribute:: mac_addr
                                                                                
                                                                                	MAC address
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	MAC mask
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                    self.yang_name = "dst-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                    ])
                                                                                    self.mac_addr = []
                                                                                    self.mask = []
                                                                                    self._segment_path = lambda: "dst-mac"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                            class AtmClp(Entity):
                                                                                """
                                                                                Match ATM CLP level
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                    self.yang_name = "atm-clp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "atm-clp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                            class FrDe(Entity):
                                                                                """
                                                                                Match FR DE value
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                    self.yang_name = "fr-de"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "fr-de"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                            class Ipv4Acl(Entity):
                                                                                """
                                                                                IPv4 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                    self.yang_name = "ipv4-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "ipv4-acl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                            class Ipv6Acl(Entity):
                                                                                """
                                                                                IPv6 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                    self.yang_name = "ipv6-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "ipv6-acl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                            class EtherServiceAcl(Entity):
                                                                                """
                                                                                Ethernet\-Services Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                    self.yang_name = "ether-service-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "ether-service-acl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                            class AvailId(Entity):
                                                                                """
                                                                                Available Identifiers
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                    self.yang_name = "avail-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "avail-id"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                            class MediaType(Entity):
                                                                                """
                                                                                Media Type
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                    self.yang_name = "media-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "media-type"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                            class SubsProtocol(Entity):
                                                                                """
                                                                                Protocol
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                    self.yang_name = "subs-protocol"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "subs-protocol"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                            class Dnis(Entity):
                                                                                """
                                                                                DNIS
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                    self.yang_name = "dnis"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "dnis"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                            class DnisRegex(Entity):
                                                                                """
                                                                                DNIS Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                    self.yang_name = "dnis-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "dnis-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                            class Domain(Entity):
                                                                                """
                                                                                Domain Name
                                                                                
                                                                                .. attribute:: domain_array
                                                                                
                                                                                	domain array
                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                    self.yang_name = "domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.domain_array = YList(self)
                                                                                    self._segment_path = lambda: "domain"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                class DomainArray(Entity):
                                                                                    """
                                                                                    domain array
                                                                                    
                                                                                    .. attribute:: domain_name
                                                                                    
                                                                                    	domain name
                                                                                    	**type**\: str
                                                                                    
                                                                                    .. attribute:: format_name
                                                                                    
                                                                                    	format name
                                                                                    	**type**\: str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                        self.yang_name = "domain-array"
                                                                                        self.yang_parent_name = "domain"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                        ])
                                                                                        self.domain_name = None
                                                                                        self.format_name = None
                                                                                        self._segment_path = lambda: "domain-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                            class DomainRegex(Entity):
                                                                                """
                                                                                Domain Regular Expression
                                                                                
                                                                                .. attribute:: domain_array
                                                                                
                                                                                	domain array
                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                    self.yang_name = "domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.domain_array = YList(self)
                                                                                    self._segment_path = lambda: "domain-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                class DomainArray(Entity):
                                                                                    """
                                                                                    domain array
                                                                                    
                                                                                    .. attribute:: domain_name
                                                                                    
                                                                                    	domain name
                                                                                    	**type**\: str
                                                                                    
                                                                                    .. attribute:: format_name
                                                                                    
                                                                                    	format name
                                                                                    	**type**\: str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                        self.yang_name = "domain-array"
                                                                                        self.yang_parent_name = "domain-regex"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                        ])
                                                                                        self.domain_name = None
                                                                                        self.format_name = None
                                                                                        self._segment_path = lambda: "domain-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                            class NasPort(Entity):
                                                                                """
                                                                                NAS Port
                                                                                
                                                                                .. attribute:: nas_port_array
                                                                                
                                                                                	nas port array
                                                                                	**type**\: list of  		 :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                    self.yang_name = "nas-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("nas-port-array", ("nas_port_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.nas_port_array = YList(self)
                                                                                    self._segment_path = lambda: "nas-port"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                class NasPortArray(Entity):
                                                                                    """
                                                                                    nas port array
                                                                                    
                                                                                    .. attribute:: sub_id
                                                                                    
                                                                                    	sub id
                                                                                    	**type**\:  :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                    
                                                                                    .. attribute:: operator
                                                                                    
                                                                                    	operator
                                                                                    	**type**\:  :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                        self.yang_name = "nas-port-array"
                                                                                        self.yang_parent_name = "nas-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('sub_id', (YLeaf(YType.enumeration, 'sub-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchNasPortSubIdEn', '')])),
                                                                                            ('operator', (YLeaf(YType.enumeration, 'operator'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchLogicalOperatorEn', '')])),
                                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ])
                                                                                        self.sub_id = None
                                                                                        self.operator = None
                                                                                        self.value = None
                                                                                        self._segment_path = lambda: "nas-port-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['sub_id', 'operator', 'value'], name, value)


                                                                            class ServiceName(Entity):
                                                                                """
                                                                                Service Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                    self.yang_name = "service-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "service-name"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                            class ServiceNameRegex(Entity):
                                                                                """
                                                                                Service Name Regular Exp
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                    self.yang_name = "service-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "service-name-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                            class SrcAddrIpv4(Entity):
                                                                                """
                                                                                Source Address IPV4
                                                                                
                                                                                .. attribute:: ipv4_addr_array
                                                                                
                                                                                	ipv4 addr array
                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.ipv4_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-ipv4"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                class Ipv4AddrArray(Entity):
                                                                                    """
                                                                                    ipv4 addr array
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	prefix
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	mask
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                        ])
                                                                                        self.prefix = None
                                                                                        self.mask = None
                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                            class DstAddrIpv4(Entity):
                                                                                """
                                                                                Destination Address IPV4
                                                                                
                                                                                .. attribute:: ipv4_addr_array
                                                                                
                                                                                	ipv4 addr array
                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.ipv4_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-addr-ipv4"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                class Ipv4AddrArray(Entity):
                                                                                    """
                                                                                    ipv4 addr array
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	prefix
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	mask
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                        ])
                                                                                        self.prefix = None
                                                                                        self.mask = None
                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                            class SrcAddrIpv6(Entity):
                                                                                """
                                                                                Source Address IPV6
                                                                                
                                                                                .. attribute:: ipv6_addr_array
                                                                                
                                                                                	ipv6 addr array
                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.ipv6_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-ipv6"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                class Ipv6AddrArray(Entity):
                                                                                    """
                                                                                    ipv6 addr array
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	IPV6 prefix
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	IPV6 mask
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                        ])
                                                                                        self.prefix = None
                                                                                        self.mask = None
                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                            class DstAddrIpv6(Entity):
                                                                                """
                                                                                Destination Address IPV6
                                                                                
                                                                                .. attribute:: ipv6_addr_array
                                                                                
                                                                                	ipv6 addr array
                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.ipv6_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-addr-ipv6"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                class Ipv6AddrArray(Entity):
                                                                                    """
                                                                                    ipv6 addr array
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	IPV6 prefix
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	IPV6 mask
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                        ])
                                                                                        self.prefix = None
                                                                                        self.mask = None
                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                            class SrcAddrMac(Entity):
                                                                                """
                                                                                Source Address MAC
                                                                                
                                                                                .. attribute:: mac_addr_array
                                                                                
                                                                                	mac addr array
                                                                                	**type**\: list of  		 :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                    self.yang_name = "src-addr-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("mac-addr-array", ("mac_addr_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.mac_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-mac"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                class MacAddrArray(Entity):
                                                                                    """
                                                                                    mac addr array
                                                                                    
                                                                                    .. attribute:: mac_addr
                                                                                    
                                                                                    	MAC address
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	MAC mask
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                        self.yang_name = "mac-addr-array"
                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                            ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                        ])
                                                                                        self.mac_addr = []
                                                                                        self.mask = []
                                                                                        self._segment_path = lambda: "mac-addr-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                            class Timer(Entity):
                                                                                """
                                                                                Timer
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                    self.yang_name = "timer"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "timer"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                            class TimerRegexp(Entity):
                                                                                """
                                                                                Timer Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                    self.yang_name = "timer-regexp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "timer-regexp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                            class TunnelName(Entity):
                                                                                """
                                                                                Tunnel Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                    self.yang_name = "tunnel-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "tunnel-name"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                            class TunnelNameRegex(Entity):
                                                                                """
                                                                                Tunnel Name Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "tunnel-name-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                            class UserName(Entity):
                                                                                """
                                                                                User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                    self.yang_name = "user-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "user-name"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                            class UserNameRegex(Entity):
                                                                                """
                                                                                User Name Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                    self.yang_name = "user-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "user-name-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                            class AuthUsername(Entity):
                                                                                """
                                                                                Authenticated User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                    self.yang_name = "auth-username"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "auth-username"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                            class AuthUsernameRegex(Entity):
                                                                                """
                                                                                Authenticated User Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                    self.yang_name = "auth-username-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "auth-username-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                            class UnauthUsername(Entity):
                                                                                """
                                                                                Unauthenticated User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                    self.yang_name = "unauth-username"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "unauth-username"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                            class UnauthUsernameRegex(Entity):
                                                                                """
                                                                                Unauthenticated User Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                    self.yang_name = "unauth-username-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "unauth-username-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                            class AuthDomain(Entity):
                                                                                """
                                                                                Authenticated domain name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                    self.yang_name = "auth-domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "auth-domain"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                            class AuthDomainRegex(Entity):
                                                                                """
                                                                                Authenticated Domain Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                    self.yang_name = "auth-domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "auth-domain-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                            class UnauthDomain(Entity):
                                                                                """
                                                                                Unauthenticated Domain Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                    self.yang_name = "unauth-domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "unauth-domain"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                            class UnauthDomainRegex(Entity):
                                                                                """
                                                                                Unauthenticated Domain Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "unauth-domain-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                            class VendorId(Entity):
                                                                                """
                                                                                Vendor ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                    self.yang_name = "vendor-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "vendor-id"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                            class VendorIdRegex(Entity):
                                                                                """
                                                                                Vendor ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                    self.yang_name = "vendor-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "vendor-id-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                            class AccessInterface(Entity):
                                                                                """
                                                                                Access interface
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                    self.yang_name = "access-interface"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "access-interface"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                            class InputInterface(Entity):
                                                                                """
                                                                                Input interface
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                    self.yang_name = "input-interface"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "input-interface"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                            class InputIntfhdl(Entity):
                                                                                """
                                                                                Input interface handle
                                                                                
                                                                                .. attribute:: uint64_array
                                                                                
                                                                                	uint64 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..18446744073709551615
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                    self.yang_name = "input-intfhdl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint64_array', (YLeafList(YType.uint64, 'uint64_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint64_array = []
                                                                                    self._segment_path = lambda: "input-intfhdl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                            class Ethertype(Entity):
                                                                                """
                                                                                Ethernet type
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                    self.yang_name = "ethertype"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ethertype"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ethertype"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class FlowKeyData(Entity):
                                                                                """
                                                                                Flow key structure
                                                                                
                                                                                .. attribute:: flow_keys
                                                                                
                                                                                	flow keys
                                                                                	**type**\:  :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                
                                                                                .. attribute:: max_count
                                                                                
                                                                                	Maximum count of flows
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: idle_timeout
                                                                                
                                                                                	Idle timeout of flows (in seconds)
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                	**units**\: second
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                    self.yang_name = "flow-key-data"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("flow-keys", ("flow_keys", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('max_count', (YLeaf(YType.uint16, 'max-count'), ['int'])),
                                                                                        ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                                    ])
                                                                                    self.max_count = None
                                                                                    self.idle_timeout = None

                                                                                    self.flow_keys = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                    self.flow_keys.parent = self
                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                    self._segment_path = lambda: "flow-key-data"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['max_count', 'idle_timeout'], name, value)


                                                                                class FlowKeys(Entity):
                                                                                    """
                                                                                    flow keys
                                                                                    
                                                                                    .. attribute:: keys
                                                                                    
                                                                                    	keys
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                    
                                                                                    .. attribute:: num
                                                                                    
                                                                                    	num
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                        self.yang_name = "flow-keys"
                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('keys', (YLeaf(YType.str, 'keys'), ['str'])),
                                                                                            ('num', (YLeaf(YType.uint8, 'num'), ['int'])),
                                                                                        ])
                                                                                        self.keys = None
                                                                                        self.num = None
                                                                                        self._segment_path = lambda: "flow-keys"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                            class DhcpClientId(Entity):
                                                                                """
                                                                                Dhcp Client ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                    self.yang_name = "dhcp-client-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "dhcp-client-id"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                            class DhcpClientIdRegex(Entity):
                                                                                """
                                                                                Dhcp Client ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                            class CircuitId(Entity):
                                                                                """
                                                                                Circuit ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                    self.yang_name = "circuit-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "circuit-id"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                            class CircuitIdRegex(Entity):
                                                                                """
                                                                                Circuit ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                    self.yang_name = "circuit-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "circuit-id-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                            class RemoteId(Entity):
                                                                                """
                                                                                Remote ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                    self.yang_name = "remote-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "remote-id"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                            class RemoteIdRegex(Entity):
                                                                                """
                                                                                Remote ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                    self.yang_name = "remote-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "remote-id-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                            class SrcPort(Entity):
                                                                                """
                                                                                Source port
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                    self.yang_name = "src-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "src-port"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "src-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class DstPort(Entity):
                                                                                """
                                                                                Destination port
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                    self.yang_name = "dst-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-port"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "dst-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['min', 'max'], name, value)


                                                        class ClmpP(Entity):
                                                            """
                                                            clmp p
                                                            
                                                            .. attribute:: class_map_bg
                                                            
                                                            	class map bg
                                                            	**type**\: list of  		 :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'infra-policymgr-oper'
                                                            _revision = '2018-01-17'

                                                            def __init__(self):
                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP, self).__init__()

                                                                self.yang_name = "clmp-p"
                                                                self.yang_parent_name = "policy-class-info-bg"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("class-map-bg", ("class_map_bg", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg))])
                                                                self._leafs = OrderedDict()

                                                                self.class_map_bg = YList(self)
                                                                self._segment_path = lambda: "clmp-p"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP, [], name, value)


                                                            class ClassMapBg(Entity):
                                                                """
                                                                class map bg
                                                                
                                                                .. attribute:: match_infop
                                                                
                                                                	Pointer to the first Match info
                                                                	**type**\:  :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop>`
                                                                
                                                                .. attribute:: name
                                                                
                                                                	Name of the class\-map
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..65
                                                                
                                                                .. attribute:: type
                                                                
                                                                	Class\-Map Type QoS/PBR/Netflow/..
                                                                	**type**\:  :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                                
                                                                .. attribute:: mode
                                                                
                                                                	Class\-Map Mode Match any/Match all
                                                                	**type**\:  :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                
                                                                .. attribute:: description
                                                                
                                                                	description
                                                                	**type**\: str
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg, self).__init__()

                                                                    self.yang_name = "class-map-bg"
                                                                    self.yang_parent_name = "clmp-p"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("match-infop", ("match_infop", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop))])
                                                                    self._leafs = OrderedDict([
                                                                        ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapTypeEn', '')])),
                                                                        ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapModeEn', '')])),
                                                                        ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                    ])
                                                                    self.name = None
                                                                    self.type = None
                                                                    self.mode = None
                                                                    self.description = None

                                                                    self.match_infop = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop()
                                                                    self.match_infop.parent = self
                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                    self._segment_path = lambda: "class-map-bg"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg, ['name', 'type', 'mode', 'description'], name, value)


                                                                class MatchInfop(Entity):
                                                                    """
                                                                    Pointer to the first Match info
                                                                    
                                                                    .. attribute:: class_match_info_st
                                                                    
                                                                    	class match info st
                                                                    	**type**\: list of  		 :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop, self).__init__()

                                                                        self.yang_name = "match-infop"
                                                                        self.yang_parent_name = "class-map-bg"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("class-match-info-st", ("class_match_info_st", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt))])
                                                                        self._leafs = OrderedDict()

                                                                        self.class_match_info_st = YList(self)
                                                                        self._segment_path = lambda: "match-infop"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop, [], name, value)


                                                                    class ClassMatchInfoSt(Entity):
                                                                        """
                                                                        class match info st
                                                                        
                                                                        .. attribute:: match_data
                                                                        
                                                                        	Match criteria
                                                                        	**type**\:  :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                        
                                                                        .. attribute:: flags
                                                                        
                                                                        	Flags
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                            self.yang_name = "class-match-info-st"
                                                                            self.yang_parent_name = "match-infop"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("match-data", ("match_data", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData))])
                                                                            self._leafs = OrderedDict([
                                                                                ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                            ])
                                                                            self.flags = None

                                                                            self.match_data = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                            self.match_data.parent = self
                                                                            self._children_name_map["match_data"] = "match-data"
                                                                            self._segment_path = lambda: "class-match-info-st"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                        class MatchData(Entity):
                                                                            """
                                                                            Match criteria
                                                                            
                                                                            .. attribute:: ipv4_dscp
                                                                            
                                                                            	IPv4 DSCP
                                                                            	**type**\:  :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                            
                                                                            .. attribute:: ipv6_dscp
                                                                            
                                                                            	IPv6 DSCP
                                                                            	**type**\:  :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                            
                                                                            .. attribute:: dscp
                                                                            
                                                                            	Match DSCP range array
                                                                            	**type**\:  :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                            
                                                                            .. attribute:: ipv4_prec
                                                                            
                                                                            	IPv4 Precedence
                                                                            	**type**\:  :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                            
                                                                            .. attribute:: ipv6_prec
                                                                            
                                                                            	IPv6 Precedence
                                                                            	**type**\:  :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                            
                                                                            .. attribute:: prec
                                                                            
                                                                            	Match Precedence array
                                                                            	**type**\:  :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                            
                                                                            .. attribute:: discard_class
                                                                            
                                                                            	Match Discard Class array
                                                                            	**type**\:  :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                            
                                                                            .. attribute:: qos_group
                                                                            
                                                                            	Match QoS group array
                                                                            	**type**\:  :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                            
                                                                            .. attribute:: traffic_class
                                                                            
                                                                            	Match Traffic class array
                                                                            	**type**\:  :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                            
                                                                            .. attribute:: proto
                                                                            
                                                                            	Match Protocol array
                                                                            	**type**\:  :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                            
                                                                            .. attribute:: icmp_v4
                                                                            
                                                                            	Match ICMPV4 Protocol
                                                                            	**type**\:  :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                            
                                                                            .. attribute:: icmp_v6
                                                                            
                                                                            	Match ICMPV6 Protocol array
                                                                            	**type**\:  :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                            
                                                                            .. attribute:: ipv4_packet_len
                                                                            
                                                                            	IPv4 packet length array
                                                                            	**type**\:  :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                            
                                                                            .. attribute:: ipv6_packet_len
                                                                            
                                                                            	IPv6 packet length array
                                                                            	**type**\:  :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                            
                                                                            .. attribute:: packet_len
                                                                            
                                                                            	Match packet length array
                                                                            	**type**\:  :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                            
                                                                            .. attribute:: flow_tag
                                                                            
                                                                            	Match flow\-tag array
                                                                            	**type**\:  :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                            
                                                                            .. attribute:: tcp_flag
                                                                            
                                                                            	Match tcp flag value
                                                                            	**type**\:  :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                            
                                                                            .. attribute:: icmpv4_type
                                                                            
                                                                            	Match ipv4 icmp type
                                                                            	**type**\:  :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                            
                                                                            .. attribute:: icmpv4_code
                                                                            
                                                                            	Match ipv4 icmp code
                                                                            	**type**\:  :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                            
                                                                            .. attribute:: icmpv6_type
                                                                            
                                                                            	Match ipv6 icmp type
                                                                            	**type**\:  :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                            
                                                                            .. attribute:: icmpv6_code
                                                                            
                                                                            	Match ipv6 icmp code
                                                                            	**type**\:  :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                            
                                                                            .. attribute:: mpls_exp
                                                                            
                                                                            	Match MPLS experimental topmost array
                                                                            	**type**\:  :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                            
                                                                            .. attribute:: mpls_exp_imp
                                                                            
                                                                            	Match MPLS experimental imposition array
                                                                            	**type**\:  :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                            
                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                            
                                                                            	MPLS Disposition IPv4 Access\-list
                                                                            	**type**\:  :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                            
                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                            
                                                                            	MPLS Disposition IPv6 Access\-list
                                                                            	**type**\:  :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                            
                                                                            .. attribute:: mpls_top_label
                                                                            
                                                                            	MPLS Topmost LABEL
                                                                            	**type**\:  :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                            
                                                                            .. attribute:: cos
                                                                            
                                                                            	Match CoS array
                                                                            	**type**\:  :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                            
                                                                            .. attribute:: cos_inr
                                                                            
                                                                            	Match inner header CoS
                                                                            	**type**\:  :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                            
                                                                            .. attribute:: dei
                                                                            
                                                                            	Match DEI Bit
                                                                            	**type**\:  :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                            
                                                                            .. attribute:: dei_inr
                                                                            
                                                                            	Match inner DEI Bit
                                                                            	**type**\:  :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                            
                                                                            .. attribute:: vlan
                                                                            
                                                                            	Match VLAN array
                                                                            	**type**\:  :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                            
                                                                            .. attribute:: vlan_inr
                                                                            
                                                                            	Match inner header VLAN range array
                                                                            	**type**\:  :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                            
                                                                            .. attribute:: fr_dlci
                                                                            
                                                                            	Match FR DLCI range array
                                                                            	**type**\:  :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                            
                                                                            .. attribute:: src_mac
                                                                            
                                                                            	Match Source MAC address
                                                                            	**type**\:  :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                            
                                                                            .. attribute:: dst_mac
                                                                            
                                                                            	Match Destination MAC address
                                                                            	**type**\:  :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                            
                                                                            .. attribute:: atm_clp
                                                                            
                                                                            	Match ATM CLP level
                                                                            	**type**\:  :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                            
                                                                            .. attribute:: fr_de
                                                                            
                                                                            	Match FR DE value
                                                                            	**type**\:  :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                            
                                                                            .. attribute:: ipv4_acl
                                                                            
                                                                            	IPv4 Access\-list
                                                                            	**type**\:  :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                            
                                                                            .. attribute:: ipv6_acl
                                                                            
                                                                            	IPv6 Access\-list
                                                                            	**type**\:  :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                            
                                                                            .. attribute:: ether_service_acl
                                                                            
                                                                            	Ethernet\-Services Access\-list
                                                                            	**type**\:  :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                            
                                                                            .. attribute:: avail_id
                                                                            
                                                                            	Available Identifiers
                                                                            	**type**\:  :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                            
                                                                            .. attribute:: media_type
                                                                            
                                                                            	Media Type
                                                                            	**type**\:  :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                            
                                                                            .. attribute:: subs_protocol
                                                                            
                                                                            	Protocol
                                                                            	**type**\:  :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                            
                                                                            .. attribute:: dnis
                                                                            
                                                                            	DNIS
                                                                            	**type**\:  :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                            
                                                                            .. attribute:: dnis_regex
                                                                            
                                                                            	DNIS Regular Expression
                                                                            	**type**\:  :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                            
                                                                            .. attribute:: domain
                                                                            
                                                                            	Domain Name
                                                                            	**type**\:  :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                            
                                                                            .. attribute:: domain_regex
                                                                            
                                                                            	Domain Regular Expression
                                                                            	**type**\:  :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                            
                                                                            .. attribute:: nas_port
                                                                            
                                                                            	NAS Port
                                                                            	**type**\:  :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                            
                                                                            .. attribute:: service_name
                                                                            
                                                                            	Service Name
                                                                            	**type**\:  :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                            
                                                                            .. attribute:: service_name_regex
                                                                            
                                                                            	Service Name Regular Exp
                                                                            	**type**\:  :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                            
                                                                            .. attribute:: src_addr_ipv4
                                                                            
                                                                            	Source Address IPV4
                                                                            	**type**\:  :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                            
                                                                            .. attribute:: dst_addr_ipv4
                                                                            
                                                                            	Destination Address IPV4
                                                                            	**type**\:  :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                            
                                                                            .. attribute:: src_addr_ipv6
                                                                            
                                                                            	Source Address IPV6
                                                                            	**type**\:  :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                            
                                                                            .. attribute:: dst_addr_ipv6
                                                                            
                                                                            	Destination Address IPV6
                                                                            	**type**\:  :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                            
                                                                            .. attribute:: src_addr_mac
                                                                            
                                                                            	Source Address MAC
                                                                            	**type**\:  :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                            
                                                                            .. attribute:: timer
                                                                            
                                                                            	Timer
                                                                            	**type**\:  :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                            
                                                                            .. attribute:: timer_regexp
                                                                            
                                                                            	Timer Regular Expression
                                                                            	**type**\:  :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                            
                                                                            .. attribute:: tunnel_name
                                                                            
                                                                            	Tunnel Name
                                                                            	**type**\:  :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                            
                                                                            .. attribute:: tunnel_name_regex
                                                                            
                                                                            	Tunnel Name Regular Expression
                                                                            	**type**\:  :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                            
                                                                            .. attribute:: user_name
                                                                            
                                                                            	User Name
                                                                            	**type**\:  :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                            
                                                                            .. attribute:: user_name_regex
                                                                            
                                                                            	User Name Regular Expression
                                                                            	**type**\:  :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                            
                                                                            .. attribute:: auth_username
                                                                            
                                                                            	Authenticated User Name
                                                                            	**type**\:  :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                            
                                                                            .. attribute:: auth_username_regex
                                                                            
                                                                            	Authenticated User Name RegEx
                                                                            	**type**\:  :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                            
                                                                            .. attribute:: unauth_username
                                                                            
                                                                            	Unauthenticated User Name
                                                                            	**type**\:  :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                            
                                                                            .. attribute:: unauth_username_regex
                                                                            
                                                                            	Unauthenticated User Name RegEx
                                                                            	**type**\:  :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                            
                                                                            .. attribute:: auth_domain
                                                                            
                                                                            	Authenticated domain name
                                                                            	**type**\:  :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                            
                                                                            .. attribute:: auth_domain_regex
                                                                            
                                                                            	Authenticated Domain Name RegEx
                                                                            	**type**\:  :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                            
                                                                            .. attribute:: unauth_domain
                                                                            
                                                                            	Unauthenticated Domain Name
                                                                            	**type**\:  :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                            
                                                                            .. attribute:: unauth_domain_regex
                                                                            
                                                                            	Unauthenticated Domain Name RegEx
                                                                            	**type**\:  :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                            
                                                                            .. attribute:: vendor_id
                                                                            
                                                                            	Vendor ID
                                                                            	**type**\:  :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                            
                                                                            .. attribute:: vendor_id_regex
                                                                            
                                                                            	Vendor ID RegEx
                                                                            	**type**\:  :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                            
                                                                            .. attribute:: access_interface
                                                                            
                                                                            	Access interface
                                                                            	**type**\:  :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                            
                                                                            .. attribute:: input_interface
                                                                            
                                                                            	Input interface
                                                                            	**type**\:  :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                            
                                                                            .. attribute:: input_intfhdl
                                                                            
                                                                            	Input interface handle
                                                                            	**type**\:  :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                            
                                                                            .. attribute:: ethertype
                                                                            
                                                                            	Ethernet type
                                                                            	**type**\:  :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                            
                                                                            .. attribute:: flow_key_data
                                                                            
                                                                            	Flow key structure
                                                                            	**type**\:  :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                            
                                                                            .. attribute:: dhcp_client_id
                                                                            
                                                                            	Dhcp Client ID
                                                                            	**type**\:  :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                            
                                                                            .. attribute:: dhcp_client_id_regex
                                                                            
                                                                            	Dhcp Client ID RegEx
                                                                            	**type**\:  :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                            
                                                                            .. attribute:: circuit_id
                                                                            
                                                                            	Circuit ID
                                                                            	**type**\:  :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                            
                                                                            .. attribute:: circuit_id_regex
                                                                            
                                                                            	Circuit ID RegEx
                                                                            	**type**\:  :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                            
                                                                            .. attribute:: remote_id
                                                                            
                                                                            	Remote ID
                                                                            	**type**\:  :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                            
                                                                            .. attribute:: remote_id_regex
                                                                            
                                                                            	Remote ID RegEx
                                                                            	**type**\:  :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                            
                                                                            .. attribute:: src_port
                                                                            
                                                                            	Source port
                                                                            	**type**\:  :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                            
                                                                            .. attribute:: dst_port
                                                                            
                                                                            	Destination port
                                                                            	**type**\:  :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:  :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                            
                                                                            .. attribute:: mpls_top_eos
                                                                            
                                                                            	MPLS Topmost EOS
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: fragment_type
                                                                            
                                                                            	Fragment type
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: authen_status
                                                                            
                                                                            	Authentication Status
                                                                            	**type**\:  :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                            
                                                                            .. attribute:: mlp_negotiated
                                                                            
                                                                            	MLP Negotiated
                                                                            	**type**\:  :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                self.yang_name = "match-data"
                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("ipv4-dscp", ("ipv4_dscp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp)), ("ipv6-dscp", ("ipv6_dscp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp)), ("dscp", ("dscp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp)), ("ipv4-prec", ("ipv4_prec", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec)), ("ipv6-prec", ("ipv6_prec", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec)), ("prec", ("prec", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec)), ("discard-class", ("discard_class", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass)), ("qos-group", ("qos_group", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup)), ("traffic-class", ("traffic_class", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass)), ("proto", ("proto", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto)), ("icmp-v4", ("icmp_v4", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4)), ("icmp-v6", ("icmp_v6", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6)), ("ipv4-packet-len", ("ipv4_packet_len", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen)), ("ipv6-packet-len", ("ipv6_packet_len", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen)), ("packet-len", ("packet_len", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen)), ("flow-tag", ("flow_tag", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag)), ("tcp-flag", ("tcp_flag", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag)), ("icmpv4-type", ("icmpv4_type", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type)), ("icmpv4-code", ("icmpv4_code", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code)), ("icmpv6-type", ("icmpv6_type", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type)), ("icmpv6-code", ("icmpv6_code", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code)), ("mpls-exp", ("mpls_exp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp)), ("mpls-exp-imp", ("mpls_exp_imp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp)), ("mpls-disp-ipv4-acl", ("mpls_disp_ipv4_acl", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl)), ("mpls-disp-ipv6-acl", ("mpls_disp_ipv6_acl", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl)), ("mpls-top-label", ("mpls_top_label", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel)), ("cos", ("cos", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos)), ("cos-inr", ("cos_inr", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr)), ("dei", ("dei", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei)), ("dei-inr", ("dei_inr", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr)), ("vlan", ("vlan", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan)), ("vlan-inr", ("vlan_inr", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)), ("fr-dlci", ("fr_dlci", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci)), ("src-mac", ("src_mac", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac)), ("dst-mac", ("dst_mac", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac)), ("atm-clp", ("atm_clp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp)), ("fr-de", ("fr_de", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe)), ("ipv4-acl", ("ipv4_acl", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl)), ("ipv6-acl", ("ipv6_acl", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl)), ("ether-service-acl", ("ether_service_acl", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl)), ("avail-id", ("avail_id", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId)), ("media-type", ("media_type", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType)), ("subs-protocol", ("subs_protocol", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol)), ("dnis", ("dnis", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis)), ("dnis-regex", ("dnis_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex)), ("domain", ("domain", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain)), ("domain-regex", ("domain_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex)), ("nas-port", ("nas_port", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort)), ("service-name", ("service_name", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName)), ("service-name-regex", ("service_name_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex)), ("src-addr-ipv4", ("src_addr_ipv4", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4)), ("dst-addr-ipv4", ("dst_addr_ipv4", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4)), ("src-addr-ipv6", ("src_addr_ipv6", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6)), ("dst-addr-ipv6", ("dst_addr_ipv6", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6)), ("src-addr-mac", ("src_addr_mac", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac)), ("timer", ("timer", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer)), ("timer-regexp", ("timer_regexp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp)), ("tunnel-name", ("tunnel_name", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName)), ("tunnel-name-regex", ("tunnel_name_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex)), ("user-name", ("user_name", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName)), ("user-name-regex", ("user_name_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex)), ("auth-username", ("auth_username", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername)), ("auth-username-regex", ("auth_username_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex)), ("unauth-username", ("unauth_username", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername)), ("unauth-username-regex", ("unauth_username_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex)), ("auth-domain", ("auth_domain", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain)), ("auth-domain-regex", ("auth_domain_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex)), ("unauth-domain", ("unauth_domain", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain)), ("unauth-domain-regex", ("unauth_domain_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex)), ("vendor-id", ("vendor_id", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId)), ("vendor-id-regex", ("vendor_id_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex)), ("access-interface", ("access_interface", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface)), ("input-interface", ("input_interface", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface)), ("input-intfhdl", ("input_intfhdl", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl)), ("ethertype", ("ethertype", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype)), ("flow-key-data", ("flow_key_data", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData)), ("dhcp-client-id", ("dhcp_client_id", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId)), ("dhcp-client-id-regex", ("dhcp_client_id_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex)), ("circuit-id", ("circuit_id", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId)), ("circuit-id-regex", ("circuit_id_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex)), ("remote-id", ("remote_id", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId)), ("remote-id-regex", ("remote_id_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex)), ("src-port", ("src_port", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort)), ("dst-port", ("dst_port", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchTypeEn', '')])),
                                                                                    ('mpls_top_eos', (YLeaf(YType.uint8, 'mpls-top-eos'), ['int'])),
                                                                                    ('fragment_type', (YLeaf(YType.uint8, 'fragment-type'), ['int'])),
                                                                                    ('authen_status', (YLeaf(YType.enumeration, 'authen-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchAuthenStatusEn', '')])),
                                                                                    ('mlp_negotiated', (YLeaf(YType.enumeration, 'mlp-negotiated'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchMlpNegotiatedEn', '')])),
                                                                                ])
                                                                                self.type = None
                                                                                self.mpls_top_eos = None
                                                                                self.fragment_type = None
                                                                                self.authen_status = None
                                                                                self.mlp_negotiated = None

                                                                                self.ipv4_dscp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                self.ipv4_dscp.parent = self
                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"

                                                                                self.ipv6_dscp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                self.ipv6_dscp.parent = self
                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"

                                                                                self.dscp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                self.dscp.parent = self
                                                                                self._children_name_map["dscp"] = "dscp"

                                                                                self.ipv4_prec = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                self.ipv4_prec.parent = self
                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"

                                                                                self.ipv6_prec = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                self.ipv6_prec.parent = self
                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"

                                                                                self.prec = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                self.prec.parent = self
                                                                                self._children_name_map["prec"] = "prec"

                                                                                self.discard_class = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                self.discard_class.parent = self
                                                                                self._children_name_map["discard_class"] = "discard-class"

                                                                                self.qos_group = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                self.qos_group.parent = self
                                                                                self._children_name_map["qos_group"] = "qos-group"

                                                                                self.traffic_class = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                self.traffic_class.parent = self
                                                                                self._children_name_map["traffic_class"] = "traffic-class"

                                                                                self.proto = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                self.proto.parent = self
                                                                                self._children_name_map["proto"] = "proto"

                                                                                self.icmp_v4 = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                self.icmp_v4.parent = self
                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"

                                                                                self.icmp_v6 = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                self.icmp_v6.parent = self
                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"

                                                                                self.ipv4_packet_len = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                self.ipv4_packet_len.parent = self
                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"

                                                                                self.ipv6_packet_len = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                self.ipv6_packet_len.parent = self
                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"

                                                                                self.packet_len = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                self.packet_len.parent = self
                                                                                self._children_name_map["packet_len"] = "packet-len"

                                                                                self.flow_tag = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                self.flow_tag.parent = self
                                                                                self._children_name_map["flow_tag"] = "flow-tag"

                                                                                self.tcp_flag = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                self.tcp_flag.parent = self
                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"

                                                                                self.icmpv4_type = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                self.icmpv4_type.parent = self
                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"

                                                                                self.icmpv4_code = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                self.icmpv4_code.parent = self
                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"

                                                                                self.icmpv6_type = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                self.icmpv6_type.parent = self
                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"

                                                                                self.icmpv6_code = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                self.icmpv6_code.parent = self
                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"

                                                                                self.mpls_exp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                self.mpls_exp.parent = self
                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"

                                                                                self.mpls_exp_imp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                self.mpls_exp_imp.parent = self
                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"

                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"

                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"

                                                                                self.mpls_top_label = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                self.mpls_top_label.parent = self
                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"

                                                                                self.cos = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                self.cos.parent = self
                                                                                self._children_name_map["cos"] = "cos"

                                                                                self.cos_inr = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                self.cos_inr.parent = self
                                                                                self._children_name_map["cos_inr"] = "cos-inr"

                                                                                self.dei = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                self.dei.parent = self
                                                                                self._children_name_map["dei"] = "dei"

                                                                                self.dei_inr = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                self.dei_inr.parent = self
                                                                                self._children_name_map["dei_inr"] = "dei-inr"

                                                                                self.vlan = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                self.vlan.parent = self
                                                                                self._children_name_map["vlan"] = "vlan"

                                                                                self.vlan_inr = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                self.vlan_inr.parent = self
                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"

                                                                                self.fr_dlci = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                self.fr_dlci.parent = self
                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"

                                                                                self.src_mac = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                self.src_mac.parent = self
                                                                                self._children_name_map["src_mac"] = "src-mac"

                                                                                self.dst_mac = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                self.dst_mac.parent = self
                                                                                self._children_name_map["dst_mac"] = "dst-mac"

                                                                                self.atm_clp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                self.atm_clp.parent = self
                                                                                self._children_name_map["atm_clp"] = "atm-clp"

                                                                                self.fr_de = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                self.fr_de.parent = self
                                                                                self._children_name_map["fr_de"] = "fr-de"

                                                                                self.ipv4_acl = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                self.ipv4_acl.parent = self
                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"

                                                                                self.ipv6_acl = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                self.ipv6_acl.parent = self
                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"

                                                                                self.ether_service_acl = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                self.ether_service_acl.parent = self
                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"

                                                                                self.avail_id = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                self.avail_id.parent = self
                                                                                self._children_name_map["avail_id"] = "avail-id"

                                                                                self.media_type = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                self.media_type.parent = self
                                                                                self._children_name_map["media_type"] = "media-type"

                                                                                self.subs_protocol = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                self.subs_protocol.parent = self
                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"

                                                                                self.dnis = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                self.dnis.parent = self
                                                                                self._children_name_map["dnis"] = "dnis"

                                                                                self.dnis_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                self.dnis_regex.parent = self
                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"

                                                                                self.domain = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                self.domain.parent = self
                                                                                self._children_name_map["domain"] = "domain"

                                                                                self.domain_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                self.domain_regex.parent = self
                                                                                self._children_name_map["domain_regex"] = "domain-regex"

                                                                                self.nas_port = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                self.nas_port.parent = self
                                                                                self._children_name_map["nas_port"] = "nas-port"

                                                                                self.service_name = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                self.service_name.parent = self
                                                                                self._children_name_map["service_name"] = "service-name"

                                                                                self.service_name_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                self.service_name_regex.parent = self
                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"

                                                                                self.src_addr_ipv4 = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                self.src_addr_ipv4.parent = self
                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"

                                                                                self.dst_addr_ipv4 = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                self.dst_addr_ipv4.parent = self
                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"

                                                                                self.src_addr_ipv6 = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                self.src_addr_ipv6.parent = self
                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"

                                                                                self.dst_addr_ipv6 = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                self.dst_addr_ipv6.parent = self
                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"

                                                                                self.src_addr_mac = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                self.src_addr_mac.parent = self
                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"

                                                                                self.timer = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                self.timer.parent = self
                                                                                self._children_name_map["timer"] = "timer"

                                                                                self.timer_regexp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                self.timer_regexp.parent = self
                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"

                                                                                self.tunnel_name = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                self.tunnel_name.parent = self
                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"

                                                                                self.tunnel_name_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                self.tunnel_name_regex.parent = self
                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"

                                                                                self.user_name = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                self.user_name.parent = self
                                                                                self._children_name_map["user_name"] = "user-name"

                                                                                self.user_name_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                self.user_name_regex.parent = self
                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"

                                                                                self.auth_username = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                self.auth_username.parent = self
                                                                                self._children_name_map["auth_username"] = "auth-username"

                                                                                self.auth_username_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                self.auth_username_regex.parent = self
                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"

                                                                                self.unauth_username = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                self.unauth_username.parent = self
                                                                                self._children_name_map["unauth_username"] = "unauth-username"

                                                                                self.unauth_username_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                self.unauth_username_regex.parent = self
                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"

                                                                                self.auth_domain = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                self.auth_domain.parent = self
                                                                                self._children_name_map["auth_domain"] = "auth-domain"

                                                                                self.auth_domain_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                self.auth_domain_regex.parent = self
                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"

                                                                                self.unauth_domain = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                self.unauth_domain.parent = self
                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"

                                                                                self.unauth_domain_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                self.unauth_domain_regex.parent = self
                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"

                                                                                self.vendor_id = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                self.vendor_id.parent = self
                                                                                self._children_name_map["vendor_id"] = "vendor-id"

                                                                                self.vendor_id_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                self.vendor_id_regex.parent = self
                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"

                                                                                self.access_interface = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                self.access_interface.parent = self
                                                                                self._children_name_map["access_interface"] = "access-interface"

                                                                                self.input_interface = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                self.input_interface.parent = self
                                                                                self._children_name_map["input_interface"] = "input-interface"

                                                                                self.input_intfhdl = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                self.input_intfhdl.parent = self
                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"

                                                                                self.ethertype = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                self.ethertype.parent = self
                                                                                self._children_name_map["ethertype"] = "ethertype"

                                                                                self.flow_key_data = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                self.flow_key_data.parent = self
                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"

                                                                                self.dhcp_client_id = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                self.dhcp_client_id.parent = self
                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"

                                                                                self.dhcp_client_id_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                self.dhcp_client_id_regex.parent = self
                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"

                                                                                self.circuit_id = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                self.circuit_id.parent = self
                                                                                self._children_name_map["circuit_id"] = "circuit-id"

                                                                                self.circuit_id_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                self.circuit_id_regex.parent = self
                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"

                                                                                self.remote_id = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                self.remote_id.parent = self
                                                                                self._children_name_map["remote_id"] = "remote-id"

                                                                                self.remote_id_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                self.remote_id_regex.parent = self
                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"

                                                                                self.src_port = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                self.src_port.parent = self
                                                                                self._children_name_map["src_port"] = "src-port"

                                                                                self.dst_port = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                self.dst_port.parent = self
                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                self._segment_path = lambda: "match-data"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['type', 'mpls_top_eos', 'fragment_type', 'authen_status', 'mlp_negotiated'], name, value)


                                                                            class Ipv4Dscp(Entity):
                                                                                """
                                                                                IPv4 DSCP
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                    self.yang_name = "ipv4-dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv4-dscp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Ipv6Dscp(Entity):
                                                                                """
                                                                                IPv6 DSCP
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                    self.yang_name = "ipv6-dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv6-dscp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Dscp(Entity):
                                                                                """
                                                                                Match DSCP range array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                    self.yang_name = "dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "dscp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Ipv4Prec(Entity):
                                                                                """
                                                                                IPv4 Precedence
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                    self.yang_name = "ipv4-prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "ipv4-prec"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                            class Ipv6Prec(Entity):
                                                                                """
                                                                                IPv6 Precedence
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                    self.yang_name = "ipv6-prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "ipv6-prec"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                            class Prec(Entity):
                                                                                """
                                                                                Match Precedence array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                    self.yang_name = "prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "prec"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                            class DiscardClass(Entity):
                                                                                """
                                                                                Match Discard Class array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                    self.yang_name = "discard-class"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "discard-class"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                            class QosGroup(Entity):
                                                                                """
                                                                                Match QoS group array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                    self.yang_name = "qos-group"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "qos-group"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "qos-group"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class TrafficClass(Entity):
                                                                                """
                                                                                Match Traffic class array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                    self.yang_name = "traffic-class"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "traffic-class"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "traffic-class"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Proto(Entity):
                                                                                """
                                                                                Match Protocol array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                    self.yang_name = "proto"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "proto"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "proto"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class IcmpV4(Entity):
                                                                                """
                                                                                Match ICMPV4 Protocol
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Protocol type
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: code
                                                                                
                                                                                	Protocol code
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                    self.yang_name = "icmp-v4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                    ])
                                                                                    self.type = None
                                                                                    self.code = None
                                                                                    self._segment_path = lambda: "icmp-v4"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['type', 'code'], name, value)


                                                                            class IcmpV6(Entity):
                                                                                """
                                                                                Match ICMPV6 Protocol array
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Protocol type
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: code
                                                                                
                                                                                	Protocol code
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                    self.yang_name = "icmp-v6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                    ])
                                                                                    self.type = None
                                                                                    self.code = None
                                                                                    self._segment_path = lambda: "icmp-v6"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['type', 'code'], name, value)


                                                                            class Ipv4PacketLen(Entity):
                                                                                """
                                                                                IPv4 packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv4-packet-len"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class Ipv6PacketLen(Entity):
                                                                                """
                                                                                IPv6 packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv6-packet-len"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class PacketLen(Entity):
                                                                                """
                                                                                Match packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                    self.yang_name = "packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "packet-len"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class FlowTag(Entity):
                                                                                """
                                                                                Match flow\-tag array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                    self.yang_name = "flow-tag"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "flow-tag"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "flow-tag"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class TcpFlag(Entity):
                                                                                """
                                                                                Match tcp flag value
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	Value of TCP flag
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: match_any
                                                                                
                                                                                	Match any TCP flag bit
                                                                                	**type**\: bool
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                    self.yang_name = "tcp-flag"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                        ('match_any', (YLeaf(YType.boolean, 'match-any'), ['bool'])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.match_any = None
                                                                                    self._segment_path = lambda: "tcp-flag"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['value', 'match_any'], name, value)


                                                                            class Icmpv4Type(Entity):
                                                                                """
                                                                                Match ipv4 icmp type
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                    self.yang_name = "icmpv4-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv4-type"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Icmpv4Code(Entity):
                                                                                """
                                                                                Match ipv4 icmp code
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                    self.yang_name = "icmpv4-code"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv4-code"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Icmpv6Type(Entity):
                                                                                """
                                                                                Match ipv6 icmp type
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                    self.yang_name = "icmpv6-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv6-type"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Icmpv6Code(Entity):
                                                                                """
                                                                                Match ipv6 icmp code
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                    self.yang_name = "icmpv6-code"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv6-code"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class MplsExp(Entity):
                                                                                """
                                                                                Match MPLS experimental topmost array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                    self.yang_name = "mpls-exp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "mpls-exp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                            class MplsExpImp(Entity):
                                                                                """
                                                                                Match MPLS experimental imposition array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "mpls-exp-imp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                            class MplsDispIpv4Acl(Entity):
                                                                                """
                                                                                MPLS Disposition IPv4 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                            class MplsDispIpv6Acl(Entity):
                                                                                """
                                                                                MPLS Disposition IPv6 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                            class MplsTopLabel(Entity):
                                                                                """
                                                                                MPLS Topmost LABEL
                                                                                
                                                                                .. attribute:: uint32_rng_array
                                                                                
                                                                                	uint32 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                    self.yang_name = "mpls-top-label"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint32_rng_array", ("uint32_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint32_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "mpls-top-label"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                class Uint32RngArray(Entity):
                                                                                    """
                                                                                    uint32 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                        self.yang_name = "uint32_rng_array"
                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint32, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint32, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint32_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['min', 'max'], name, value)


                                                                            class Cos(Entity):
                                                                                """
                                                                                Match CoS array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                    self.yang_name = "cos"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "cos"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                            class CosInr(Entity):
                                                                                """
                                                                                Match inner header CoS
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                    self.yang_name = "cos-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "cos-inr"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                            class Dei(Entity):
                                                                                """
                                                                                Match DEI Bit
                                                                                
                                                                                .. attribute:: bit_value
                                                                                
                                                                                	Value of the DEI bit
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                    self.yang_name = "dei"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                    ])
                                                                                    self.bit_value = None
                                                                                    self._segment_path = lambda: "dei"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                            class DeiInr(Entity):
                                                                                """
                                                                                Match inner DEI Bit
                                                                                
                                                                                .. attribute:: bit_value
                                                                                
                                                                                	Value of the DEI bit
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                    self.yang_name = "dei-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                    ])
                                                                                    self.bit_value = None
                                                                                    self._segment_path = lambda: "dei-inr"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                            class Vlan(Entity):
                                                                                """
                                                                                Match VLAN array
                                                                                
                                                                                .. attribute:: vlan_id_array
                                                                                
                                                                                	vlan id array
                                                                                	**type**\: list of  		 :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                    self.yang_name = "vlan"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("vlan-id-array", ("vlan_id_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.vlan_id_array = YList(self)
                                                                                    self._segment_path = lambda: "vlan"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                class VlanIdArray(Entity):
                                                                                    """
                                                                                    vlan id array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	VLAN mask
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                        self.yang_name = "vlan-id-array"
                                                                                        self.yang_parent_name = "vlan"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                            ('mask', (YLeaf(YType.uint16, 'mask'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self.mask = None
                                                                                        self._segment_path = lambda: "vlan-id-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['min', 'max', 'mask'], name, value)


                                                                            class VlanInr(Entity):
                                                                                """
                                                                                Match inner header VLAN range array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                    self.yang_name = "vlan-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "vlan-inr"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class FrDlci(Entity):
                                                                                """
                                                                                Match FR DLCI range array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                    self.yang_name = "fr-dlci"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "fr-dlci"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class SrcMac(Entity):
                                                                                """
                                                                                Match Source MAC address
                                                                                
                                                                                .. attribute:: mac_addr
                                                                                
                                                                                	MAC address
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	MAC mask
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                    self.yang_name = "src-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                    ])
                                                                                    self.mac_addr = []
                                                                                    self.mask = []
                                                                                    self._segment_path = lambda: "src-mac"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                            class DstMac(Entity):
                                                                                """
                                                                                Match Destination MAC address
                                                                                
                                                                                .. attribute:: mac_addr
                                                                                
                                                                                	MAC address
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	MAC mask
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                    self.yang_name = "dst-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                    ])
                                                                                    self.mac_addr = []
                                                                                    self.mask = []
                                                                                    self._segment_path = lambda: "dst-mac"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                            class AtmClp(Entity):
                                                                                """
                                                                                Match ATM CLP level
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                    self.yang_name = "atm-clp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "atm-clp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                            class FrDe(Entity):
                                                                                """
                                                                                Match FR DE value
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                    self.yang_name = "fr-de"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "fr-de"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                            class Ipv4Acl(Entity):
                                                                                """
                                                                                IPv4 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                    self.yang_name = "ipv4-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "ipv4-acl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                            class Ipv6Acl(Entity):
                                                                                """
                                                                                IPv6 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                    self.yang_name = "ipv6-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "ipv6-acl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                            class EtherServiceAcl(Entity):
                                                                                """
                                                                                Ethernet\-Services Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                    self.yang_name = "ether-service-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "ether-service-acl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                            class AvailId(Entity):
                                                                                """
                                                                                Available Identifiers
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                    self.yang_name = "avail-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "avail-id"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                            class MediaType(Entity):
                                                                                """
                                                                                Media Type
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                    self.yang_name = "media-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "media-type"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                            class SubsProtocol(Entity):
                                                                                """
                                                                                Protocol
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                    self.yang_name = "subs-protocol"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "subs-protocol"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                            class Dnis(Entity):
                                                                                """
                                                                                DNIS
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                    self.yang_name = "dnis"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "dnis"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                            class DnisRegex(Entity):
                                                                                """
                                                                                DNIS Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                    self.yang_name = "dnis-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "dnis-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                            class Domain(Entity):
                                                                                """
                                                                                Domain Name
                                                                                
                                                                                .. attribute:: domain_array
                                                                                
                                                                                	domain array
                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                    self.yang_name = "domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.domain_array = YList(self)
                                                                                    self._segment_path = lambda: "domain"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                class DomainArray(Entity):
                                                                                    """
                                                                                    domain array
                                                                                    
                                                                                    .. attribute:: domain_name
                                                                                    
                                                                                    	domain name
                                                                                    	**type**\: str
                                                                                    
                                                                                    .. attribute:: format_name
                                                                                    
                                                                                    	format name
                                                                                    	**type**\: str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                        self.yang_name = "domain-array"
                                                                                        self.yang_parent_name = "domain"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                        ])
                                                                                        self.domain_name = None
                                                                                        self.format_name = None
                                                                                        self._segment_path = lambda: "domain-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                            class DomainRegex(Entity):
                                                                                """
                                                                                Domain Regular Expression
                                                                                
                                                                                .. attribute:: domain_array
                                                                                
                                                                                	domain array
                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                    self.yang_name = "domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.domain_array = YList(self)
                                                                                    self._segment_path = lambda: "domain-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                class DomainArray(Entity):
                                                                                    """
                                                                                    domain array
                                                                                    
                                                                                    .. attribute:: domain_name
                                                                                    
                                                                                    	domain name
                                                                                    	**type**\: str
                                                                                    
                                                                                    .. attribute:: format_name
                                                                                    
                                                                                    	format name
                                                                                    	**type**\: str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                        self.yang_name = "domain-array"
                                                                                        self.yang_parent_name = "domain-regex"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                        ])
                                                                                        self.domain_name = None
                                                                                        self.format_name = None
                                                                                        self._segment_path = lambda: "domain-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                            class NasPort(Entity):
                                                                                """
                                                                                NAS Port
                                                                                
                                                                                .. attribute:: nas_port_array
                                                                                
                                                                                	nas port array
                                                                                	**type**\: list of  		 :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                    self.yang_name = "nas-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("nas-port-array", ("nas_port_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.nas_port_array = YList(self)
                                                                                    self._segment_path = lambda: "nas-port"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                class NasPortArray(Entity):
                                                                                    """
                                                                                    nas port array
                                                                                    
                                                                                    .. attribute:: sub_id
                                                                                    
                                                                                    	sub id
                                                                                    	**type**\:  :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                    
                                                                                    .. attribute:: operator
                                                                                    
                                                                                    	operator
                                                                                    	**type**\:  :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                        self.yang_name = "nas-port-array"
                                                                                        self.yang_parent_name = "nas-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('sub_id', (YLeaf(YType.enumeration, 'sub-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchNasPortSubIdEn', '')])),
                                                                                            ('operator', (YLeaf(YType.enumeration, 'operator'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchLogicalOperatorEn', '')])),
                                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ])
                                                                                        self.sub_id = None
                                                                                        self.operator = None
                                                                                        self.value = None
                                                                                        self._segment_path = lambda: "nas-port-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['sub_id', 'operator', 'value'], name, value)


                                                                            class ServiceName(Entity):
                                                                                """
                                                                                Service Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                    self.yang_name = "service-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "service-name"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                            class ServiceNameRegex(Entity):
                                                                                """
                                                                                Service Name Regular Exp
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                    self.yang_name = "service-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "service-name-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                            class SrcAddrIpv4(Entity):
                                                                                """
                                                                                Source Address IPV4
                                                                                
                                                                                .. attribute:: ipv4_addr_array
                                                                                
                                                                                	ipv4 addr array
                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.ipv4_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-ipv4"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                class Ipv4AddrArray(Entity):
                                                                                    """
                                                                                    ipv4 addr array
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	prefix
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	mask
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                        ])
                                                                                        self.prefix = None
                                                                                        self.mask = None
                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                            class DstAddrIpv4(Entity):
                                                                                """
                                                                                Destination Address IPV4
                                                                                
                                                                                .. attribute:: ipv4_addr_array
                                                                                
                                                                                	ipv4 addr array
                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.ipv4_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-addr-ipv4"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                class Ipv4AddrArray(Entity):
                                                                                    """
                                                                                    ipv4 addr array
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	prefix
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	mask
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                        ])
                                                                                        self.prefix = None
                                                                                        self.mask = None
                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                            class SrcAddrIpv6(Entity):
                                                                                """
                                                                                Source Address IPV6
                                                                                
                                                                                .. attribute:: ipv6_addr_array
                                                                                
                                                                                	ipv6 addr array
                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.ipv6_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-ipv6"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                class Ipv6AddrArray(Entity):
                                                                                    """
                                                                                    ipv6 addr array
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	IPV6 prefix
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	IPV6 mask
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                        ])
                                                                                        self.prefix = None
                                                                                        self.mask = None
                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                            class DstAddrIpv6(Entity):
                                                                                """
                                                                                Destination Address IPV6
                                                                                
                                                                                .. attribute:: ipv6_addr_array
                                                                                
                                                                                	ipv6 addr array
                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.ipv6_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-addr-ipv6"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                class Ipv6AddrArray(Entity):
                                                                                    """
                                                                                    ipv6 addr array
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	IPV6 prefix
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	IPV6 mask
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                        ])
                                                                                        self.prefix = None
                                                                                        self.mask = None
                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                            class SrcAddrMac(Entity):
                                                                                """
                                                                                Source Address MAC
                                                                                
                                                                                .. attribute:: mac_addr_array
                                                                                
                                                                                	mac addr array
                                                                                	**type**\: list of  		 :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                    self.yang_name = "src-addr-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("mac-addr-array", ("mac_addr_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.mac_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-mac"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                class MacAddrArray(Entity):
                                                                                    """
                                                                                    mac addr array
                                                                                    
                                                                                    .. attribute:: mac_addr
                                                                                    
                                                                                    	MAC address
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	MAC mask
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                        self.yang_name = "mac-addr-array"
                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                            ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                        ])
                                                                                        self.mac_addr = []
                                                                                        self.mask = []
                                                                                        self._segment_path = lambda: "mac-addr-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                            class Timer(Entity):
                                                                                """
                                                                                Timer
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                    self.yang_name = "timer"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "timer"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                            class TimerRegexp(Entity):
                                                                                """
                                                                                Timer Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                    self.yang_name = "timer-regexp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "timer-regexp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                            class TunnelName(Entity):
                                                                                """
                                                                                Tunnel Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                    self.yang_name = "tunnel-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "tunnel-name"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                            class TunnelNameRegex(Entity):
                                                                                """
                                                                                Tunnel Name Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "tunnel-name-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                            class UserName(Entity):
                                                                                """
                                                                                User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                    self.yang_name = "user-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "user-name"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                            class UserNameRegex(Entity):
                                                                                """
                                                                                User Name Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                    self.yang_name = "user-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "user-name-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                            class AuthUsername(Entity):
                                                                                """
                                                                                Authenticated User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                    self.yang_name = "auth-username"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "auth-username"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                            class AuthUsernameRegex(Entity):
                                                                                """
                                                                                Authenticated User Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                    self.yang_name = "auth-username-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "auth-username-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                            class UnauthUsername(Entity):
                                                                                """
                                                                                Unauthenticated User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                    self.yang_name = "unauth-username"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "unauth-username"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                            class UnauthUsernameRegex(Entity):
                                                                                """
                                                                                Unauthenticated User Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                    self.yang_name = "unauth-username-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "unauth-username-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                            class AuthDomain(Entity):
                                                                                """
                                                                                Authenticated domain name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                    self.yang_name = "auth-domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "auth-domain"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                            class AuthDomainRegex(Entity):
                                                                                """
                                                                                Authenticated Domain Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                    self.yang_name = "auth-domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "auth-domain-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                            class UnauthDomain(Entity):
                                                                                """
                                                                                Unauthenticated Domain Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                    self.yang_name = "unauth-domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "unauth-domain"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                            class UnauthDomainRegex(Entity):
                                                                                """
                                                                                Unauthenticated Domain Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "unauth-domain-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                            class VendorId(Entity):
                                                                                """
                                                                                Vendor ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                    self.yang_name = "vendor-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "vendor-id"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                            class VendorIdRegex(Entity):
                                                                                """
                                                                                Vendor ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                    self.yang_name = "vendor-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "vendor-id-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                            class AccessInterface(Entity):
                                                                                """
                                                                                Access interface
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                    self.yang_name = "access-interface"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "access-interface"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                            class InputInterface(Entity):
                                                                                """
                                                                                Input interface
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                    self.yang_name = "input-interface"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "input-interface"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                            class InputIntfhdl(Entity):
                                                                                """
                                                                                Input interface handle
                                                                                
                                                                                .. attribute:: uint64_array
                                                                                
                                                                                	uint64 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..18446744073709551615
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                    self.yang_name = "input-intfhdl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint64_array', (YLeafList(YType.uint64, 'uint64_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint64_array = []
                                                                                    self._segment_path = lambda: "input-intfhdl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                            class Ethertype(Entity):
                                                                                """
                                                                                Ethernet type
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                    self.yang_name = "ethertype"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ethertype"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ethertype"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class FlowKeyData(Entity):
                                                                                """
                                                                                Flow key structure
                                                                                
                                                                                .. attribute:: flow_keys
                                                                                
                                                                                	flow keys
                                                                                	**type**\:  :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                
                                                                                .. attribute:: max_count
                                                                                
                                                                                	Maximum count of flows
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: idle_timeout
                                                                                
                                                                                	Idle timeout of flows (in seconds)
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                	**units**\: second
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                    self.yang_name = "flow-key-data"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("flow-keys", ("flow_keys", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('max_count', (YLeaf(YType.uint16, 'max-count'), ['int'])),
                                                                                        ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                                    ])
                                                                                    self.max_count = None
                                                                                    self.idle_timeout = None

                                                                                    self.flow_keys = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                    self.flow_keys.parent = self
                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                    self._segment_path = lambda: "flow-key-data"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['max_count', 'idle_timeout'], name, value)


                                                                                class FlowKeys(Entity):
                                                                                    """
                                                                                    flow keys
                                                                                    
                                                                                    .. attribute:: keys
                                                                                    
                                                                                    	keys
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                    
                                                                                    .. attribute:: num
                                                                                    
                                                                                    	num
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                        self.yang_name = "flow-keys"
                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('keys', (YLeaf(YType.str, 'keys'), ['str'])),
                                                                                            ('num', (YLeaf(YType.uint8, 'num'), ['int'])),
                                                                                        ])
                                                                                        self.keys = None
                                                                                        self.num = None
                                                                                        self._segment_path = lambda: "flow-keys"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                            class DhcpClientId(Entity):
                                                                                """
                                                                                Dhcp Client ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                    self.yang_name = "dhcp-client-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "dhcp-client-id"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                            class DhcpClientIdRegex(Entity):
                                                                                """
                                                                                Dhcp Client ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                            class CircuitId(Entity):
                                                                                """
                                                                                Circuit ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                    self.yang_name = "circuit-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "circuit-id"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                            class CircuitIdRegex(Entity):
                                                                                """
                                                                                Circuit ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                    self.yang_name = "circuit-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "circuit-id-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                            class RemoteId(Entity):
                                                                                """
                                                                                Remote ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                    self.yang_name = "remote-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "remote-id"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                            class RemoteIdRegex(Entity):
                                                                                """
                                                                                Remote ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                    self.yang_name = "remote-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "remote-id-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                            class SrcPort(Entity):
                                                                                """
                                                                                Source port
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                    self.yang_name = "src-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "src-port"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "src-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class DstPort(Entity):
                                                                                """
                                                                                Destination port
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                    self.yang_name = "dst-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-port"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "dst-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['min', 'max'], name, value)


                                                        class ActInfop(Entity):
                                                            """
                                                            act infop
                                                            
                                                            .. attribute:: policy_action_info_st
                                                            
                                                            	policy action info st
                                                            	**type**\: list of  		 :py:class:`PolicyActionInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'infra-policymgr-oper'
                                                            _revision = '2018-01-17'

                                                            def __init__(self):
                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop, self).__init__()

                                                                self.yang_name = "act-infop"
                                                                self.yang_parent_name = "policy-class-info-bg"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("policy-action-info-st", ("policy_action_info_st", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt))])
                                                                self._leafs = OrderedDict()

                                                                self.policy_action_info_st = YList(self)
                                                                self._segment_path = lambda: "act-infop"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop, [], name, value)


                                                            class PolicyActionInfoSt(Entity):
                                                                """
                                                                policy action info st
                                                                
                                                                .. attribute:: actp
                                                                
                                                                	actp
                                                                	**type**\:  :py:class:`Actp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp>`
                                                                
                                                                .. attribute:: seq
                                                                
                                                                	seq
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..65535
                                                                
                                                                .. attribute:: flags
                                                                
                                                                	flags
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..65535
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt, self).__init__()

                                                                    self.yang_name = "policy-action-info-st"
                                                                    self.yang_parent_name = "act-infop"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("actp", ("actp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp))])
                                                                    self._leafs = OrderedDict([
                                                                        ('seq', (YLeaf(YType.uint16, 'seq'), ['int'])),
                                                                        ('flags', (YLeaf(YType.uint16, 'flags'), ['int'])),
                                                                    ])
                                                                    self.seq = None
                                                                    self.flags = None

                                                                    self.actp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp()
                                                                    self.actp.parent = self
                                                                    self._children_name_map["actp"] = "actp"
                                                                    self._segment_path = lambda: "policy-action-info-st"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt, ['seq', 'flags'], name, value)


                                                                class Actp(Entity):
                                                                    """
                                                                    actp
                                                                    
                                                                    .. attribute:: mark
                                                                    
                                                                    	mark
                                                                    	**type**\:  :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark>`
                                                                    
                                                                    .. attribute:: mark2
                                                                    
                                                                    	mark2
                                                                    	**type**\:  :py:class:`Mark2 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2>`
                                                                    
                                                                    .. attribute:: wred
                                                                    
                                                                    	wred
                                                                    	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred>`
                                                                    
                                                                    .. attribute:: encap
                                                                    
                                                                    	encap
                                                                    	**type**\:  :py:class:`Encap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap>`
                                                                    
                                                                    .. attribute:: prio
                                                                    
                                                                    	prio
                                                                    	**type**\:  :py:class:`Prio <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio>`
                                                                    
                                                                    .. attribute:: bwrem
                                                                    
                                                                    	bwrem
                                                                    	**type**\:  :py:class:`Bwrem <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem>`
                                                                    
                                                                    .. attribute:: min_bw
                                                                    
                                                                    	min bw
                                                                    	**type**\:  :py:class:`MinBw <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw>`
                                                                    
                                                                    .. attribute:: authen_aaa
                                                                    
                                                                    	authen aaa
                                                                    	**type**\:  :py:class:`AuthenAaa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa>`
                                                                    
                                                                    .. attribute:: collect_id
                                                                    
                                                                    	collect id
                                                                    	**type**\:  :py:class:`CollectId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId>`
                                                                    
                                                                    .. attribute:: decode_id
                                                                    
                                                                    	decode id
                                                                    	**type**\:  :py:class:`DecodeId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId>`
                                                                    
                                                                    .. attribute:: set_timer
                                                                    
                                                                    	set timer
                                                                    	**type**\:  :py:class:`SetTimer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer>`
                                                                    
                                                                    .. attribute:: stop_timer
                                                                    
                                                                    	stop timer
                                                                    	**type**\:  :py:class:`StopTimer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer>`
                                                                    
                                                                    .. attribute:: acct_aaa_list
                                                                    
                                                                    	acct aaa list
                                                                    	**type**\:  :py:class:`AcctAaaList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList>`
                                                                    
                                                                    .. attribute:: query_ancp
                                                                    
                                                                    	query ancp
                                                                    	**type**\:  :py:class:`QueryAncp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp>`
                                                                    
                                                                    .. attribute:: prepaid_cfg
                                                                    
                                                                    	prepaid cfg
                                                                    	**type**\:  :py:class:`PrepaidCfg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg>`
                                                                    
                                                                    .. attribute:: timeout_idle
                                                                    
                                                                    	timeout idle
                                                                    	**type**\:  :py:class:`TimeoutIdle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle>`
                                                                    
                                                                    .. attribute:: proxy_aaa
                                                                    
                                                                    	proxy aaa
                                                                    	**type**\:  :py:class:`ProxyAaa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa>`
                                                                    
                                                                    .. attribute:: act_template
                                                                    
                                                                    	act template
                                                                    	**type**\:  :py:class:`ActTemplate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate>`
                                                                    
                                                                    .. attribute:: deact_template
                                                                    
                                                                    	deact template
                                                                    	**type**\:  :py:class:`DeactTemplate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate>`
                                                                    
                                                                    .. attribute:: qlimit
                                                                    
                                                                    	qlimit
                                                                    	**type**\:  :py:class:`Qlimit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit>`
                                                                    
                                                                    .. attribute:: accounting_event_aaa
                                                                    
                                                                    	accounting event aaa
                                                                    	**type**\:  :py:class:`AccountingEventAaa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa>`
                                                                    
                                                                    .. attribute:: authorize_id
                                                                    
                                                                    	authorize id
                                                                    	**type**\:  :py:class:`AuthorizeId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId>`
                                                                    
                                                                    .. attribute:: afm_react
                                                                    
                                                                    	afm react
                                                                    	**type**\:  :py:class:`AfmReact <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact>`
                                                                    
                                                                    .. attribute:: httpr
                                                                    
                                                                    	httpr
                                                                    	**type**\:  :py:class:`Httpr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr>`
                                                                    
                                                                    .. attribute:: punt
                                                                    
                                                                    	punt
                                                                    	**type**\:  :py:class:`Punt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt>`
                                                                    
                                                                    .. attribute:: copy
                                                                    
                                                                    	copy
                                                                    	**type**\:  :py:class:`Copy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy>`
                                                                    
                                                                    .. attribute:: sfrag
                                                                    
                                                                    	sfrag
                                                                    	**type**\:  :py:class:`Sfrag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag>`
                                                                    
                                                                    .. attribute:: redirect
                                                                    
                                                                    	redirect
                                                                    	**type**\:  :py:class:`Redirect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect>`
                                                                    
                                                                    .. attribute:: out_intf
                                                                    
                                                                    	out intf
                                                                    	**type**\:  :py:class:`OutIntf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf>`
                                                                    
                                                                    .. attribute:: serv_func
                                                                    
                                                                    	serv func
                                                                    	**type**\:  :py:class:`ServFunc <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc>`
                                                                    
                                                                    .. attribute:: police
                                                                    
                                                                    	police
                                                                    	**type**\:  :py:class:`Police <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police>`
                                                                    
                                                                    .. attribute:: shape
                                                                    
                                                                    	shape
                                                                    	**type**\:  :py:class:`Shape <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape>`
                                                                    
                                                                    .. attribute:: child_policy
                                                                    
                                                                    	child policy
                                                                    	**type**\:  :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy>`
                                                                    
                                                                    .. attribute:: cac
                                                                    
                                                                    	cac
                                                                    	**type**\:  :py:class:`Cac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac>`
                                                                    
                                                                    .. attribute:: pfc
                                                                    
                                                                    	pfc
                                                                    	**type**\:  :py:class:`Pfc <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc>`
                                                                    
                                                                    .. attribute:: flow_parm
                                                                    
                                                                    	flow parm
                                                                    	**type**\:  :py:class:`FlowParm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm>`
                                                                    
                                                                    .. attribute:: ipcbr
                                                                    
                                                                    	ipcbr
                                                                    	**type**\:  :py:class:`Ipcbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr>`
                                                                    
                                                                    .. attribute:: rtp
                                                                    
                                                                    	rtp
                                                                    	**type**\:  :py:class:`Rtp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp>`
                                                                    
                                                                    .. attribute:: rtp_mmr
                                                                    
                                                                    	rtp mmr
                                                                    	**type**\:  :py:class:`RtpMmr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr>`
                                                                    
                                                                    .. attribute:: rtp_j2k
                                                                    
                                                                    	rtp j2k
                                                                    	**type**\:  :py:class:`RtpJ2k <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k>`
                                                                    
                                                                    .. attribute:: rtp_voice
                                                                    
                                                                    	rtp voice
                                                                    	**type**\:  :py:class:`RtpVoice <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice>`
                                                                    
                                                                    .. attribute:: mdi
                                                                    
                                                                    	mdi
                                                                    	**type**\:  :py:class:`Mdi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi>`
                                                                    
                                                                    .. attribute:: mdi_rtp
                                                                    
                                                                    	mdi rtp
                                                                    	**type**\:  :py:class:`MdiRtp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp>`
                                                                    
                                                                    .. attribute:: fmm
                                                                    
                                                                    	fmm
                                                                    	**type**\:  :py:class:`Fmm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm>`
                                                                    
                                                                    .. attribute:: pbf
                                                                    
                                                                    	pbf
                                                                    	**type**\:  :py:class:`Pbf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf>`
                                                                    
                                                                    .. attribute:: ipv4_nh
                                                                    
                                                                    	ipv4 nh
                                                                    	**type**\:  :py:class:`Ipv4Nh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh>`
                                                                    
                                                                    .. attribute:: ipv6_nh
                                                                    
                                                                    	ipv6 nh
                                                                    	**type**\:  :py:class:`Ipv6Nh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh>`
                                                                    
                                                                    .. attribute:: type
                                                                    
                                                                    	type
                                                                    	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                    
                                                                    .. attribute:: data_p
                                                                    
                                                                    	data p
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp, self).__init__()

                                                                        self.yang_name = "actp"
                                                                        self.yang_parent_name = "policy-action-info-st"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("mark", ("mark", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark)), ("mark2", ("mark2", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2)), ("wred", ("wred", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred)), ("encap", ("encap", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap)), ("prio", ("prio", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio)), ("bwrem", ("bwrem", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem)), ("min-bw", ("min_bw", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw)), ("authen-aaa", ("authen_aaa", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa)), ("collect-id", ("collect_id", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId)), ("decode-id", ("decode_id", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId)), ("set-timer", ("set_timer", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer)), ("stop-timer", ("stop_timer", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer)), ("acct-aaa-list", ("acct_aaa_list", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList)), ("query-ancp", ("query_ancp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp)), ("prepaid-cfg", ("prepaid_cfg", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg)), ("timeout-idle", ("timeout_idle", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle)), ("proxy-aaa", ("proxy_aaa", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa)), ("act-template", ("act_template", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate)), ("deact-template", ("deact_template", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate)), ("qlimit", ("qlimit", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit)), ("accounting-event-aaa", ("accounting_event_aaa", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa)), ("authorize-id", ("authorize_id", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId)), ("afm-react", ("afm_react", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact)), ("httpr", ("httpr", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr)), ("punt", ("punt", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt)), ("copy", ("copy", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy)), ("sfrag", ("sfrag", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag)), ("redirect", ("redirect", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect)), ("out-intf", ("out_intf", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf)), ("serv-func", ("serv_func", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc)), ("police", ("police", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police)), ("shape", ("shape", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape)), ("child-policy", ("child_policy", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy)), ("cac", ("cac", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac)), ("pfc", ("pfc", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc)), ("flow-parm", ("flow_parm", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm)), ("ipcbr", ("ipcbr", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr)), ("rtp", ("rtp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp)), ("rtp-mmr", ("rtp_mmr", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr)), ("rtp-j2k", ("rtp_j2k", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k)), ("rtp-voice", ("rtp_voice", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice)), ("mdi", ("mdi", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi)), ("mdi-rtp", ("mdi_rtp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp)), ("fmm", ("fmm", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm)), ("pbf", ("pbf", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf)), ("ipv4-nh", ("ipv4_nh", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh)), ("ipv6-nh", ("ipv6_nh", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh))])
                                                                        self._leafs = OrderedDict([
                                                                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                            ('data_p', (YLeaf(YType.uint32, 'data-p'), ['int'])),
                                                                        ])
                                                                        self.type = None
                                                                        self.data_p = None

                                                                        self.mark = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark()
                                                                        self.mark.parent = self
                                                                        self._children_name_map["mark"] = "mark"

                                                                        self.mark2 = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2()
                                                                        self.mark2.parent = self
                                                                        self._children_name_map["mark2"] = "mark2"

                                                                        self.wred = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred()
                                                                        self.wred.parent = self
                                                                        self._children_name_map["wred"] = "wred"

                                                                        self.encap = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap()
                                                                        self.encap.parent = self
                                                                        self._children_name_map["encap"] = "encap"

                                                                        self.prio = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio()
                                                                        self.prio.parent = self
                                                                        self._children_name_map["prio"] = "prio"

                                                                        self.bwrem = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem()
                                                                        self.bwrem.parent = self
                                                                        self._children_name_map["bwrem"] = "bwrem"

                                                                        self.min_bw = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw()
                                                                        self.min_bw.parent = self
                                                                        self._children_name_map["min_bw"] = "min-bw"

                                                                        self.authen_aaa = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa()
                                                                        self.authen_aaa.parent = self
                                                                        self._children_name_map["authen_aaa"] = "authen-aaa"

                                                                        self.collect_id = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId()
                                                                        self.collect_id.parent = self
                                                                        self._children_name_map["collect_id"] = "collect-id"

                                                                        self.decode_id = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId()
                                                                        self.decode_id.parent = self
                                                                        self._children_name_map["decode_id"] = "decode-id"

                                                                        self.set_timer = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer()
                                                                        self.set_timer.parent = self
                                                                        self._children_name_map["set_timer"] = "set-timer"

                                                                        self.stop_timer = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer()
                                                                        self.stop_timer.parent = self
                                                                        self._children_name_map["stop_timer"] = "stop-timer"

                                                                        self.acct_aaa_list = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList()
                                                                        self.acct_aaa_list.parent = self
                                                                        self._children_name_map["acct_aaa_list"] = "acct-aaa-list"

                                                                        self.query_ancp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp()
                                                                        self.query_ancp.parent = self
                                                                        self._children_name_map["query_ancp"] = "query-ancp"

                                                                        self.prepaid_cfg = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg()
                                                                        self.prepaid_cfg.parent = self
                                                                        self._children_name_map["prepaid_cfg"] = "prepaid-cfg"

                                                                        self.timeout_idle = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle()
                                                                        self.timeout_idle.parent = self
                                                                        self._children_name_map["timeout_idle"] = "timeout-idle"

                                                                        self.proxy_aaa = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa()
                                                                        self.proxy_aaa.parent = self
                                                                        self._children_name_map["proxy_aaa"] = "proxy-aaa"

                                                                        self.act_template = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate()
                                                                        self.act_template.parent = self
                                                                        self._children_name_map["act_template"] = "act-template"

                                                                        self.deact_template = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate()
                                                                        self.deact_template.parent = self
                                                                        self._children_name_map["deact_template"] = "deact-template"

                                                                        self.qlimit = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit()
                                                                        self.qlimit.parent = self
                                                                        self._children_name_map["qlimit"] = "qlimit"

                                                                        self.accounting_event_aaa = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa()
                                                                        self.accounting_event_aaa.parent = self
                                                                        self._children_name_map["accounting_event_aaa"] = "accounting-event-aaa"

                                                                        self.authorize_id = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId()
                                                                        self.authorize_id.parent = self
                                                                        self._children_name_map["authorize_id"] = "authorize-id"

                                                                        self.afm_react = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact()
                                                                        self.afm_react.parent = self
                                                                        self._children_name_map["afm_react"] = "afm-react"

                                                                        self.httpr = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr()
                                                                        self.httpr.parent = self
                                                                        self._children_name_map["httpr"] = "httpr"

                                                                        self.punt = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt()
                                                                        self.punt.parent = self
                                                                        self._children_name_map["punt"] = "punt"

                                                                        self.copy = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy()
                                                                        self.copy.parent = self
                                                                        self._children_name_map["copy"] = "copy"

                                                                        self.sfrag = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag()
                                                                        self.sfrag.parent = self
                                                                        self._children_name_map["sfrag"] = "sfrag"

                                                                        self.redirect = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect()
                                                                        self.redirect.parent = self
                                                                        self._children_name_map["redirect"] = "redirect"

                                                                        self.out_intf = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf()
                                                                        self.out_intf.parent = self
                                                                        self._children_name_map["out_intf"] = "out-intf"

                                                                        self.serv_func = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc()
                                                                        self.serv_func.parent = self
                                                                        self._children_name_map["serv_func"] = "serv-func"

                                                                        self.police = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police()
                                                                        self.police.parent = self
                                                                        self._children_name_map["police"] = "police"

                                                                        self.shape = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape()
                                                                        self.shape.parent = self
                                                                        self._children_name_map["shape"] = "shape"

                                                                        self.child_policy = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy()
                                                                        self.child_policy.parent = self
                                                                        self._children_name_map["child_policy"] = "child-policy"

                                                                        self.cac = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac()
                                                                        self.cac.parent = self
                                                                        self._children_name_map["cac"] = "cac"

                                                                        self.pfc = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc()
                                                                        self.pfc.parent = self
                                                                        self._children_name_map["pfc"] = "pfc"

                                                                        self.flow_parm = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm()
                                                                        self.flow_parm.parent = self
                                                                        self._children_name_map["flow_parm"] = "flow-parm"

                                                                        self.ipcbr = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr()
                                                                        self.ipcbr.parent = self
                                                                        self._children_name_map["ipcbr"] = "ipcbr"

                                                                        self.rtp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp()
                                                                        self.rtp.parent = self
                                                                        self._children_name_map["rtp"] = "rtp"

                                                                        self.rtp_mmr = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr()
                                                                        self.rtp_mmr.parent = self
                                                                        self._children_name_map["rtp_mmr"] = "rtp-mmr"

                                                                        self.rtp_j2k = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k()
                                                                        self.rtp_j2k.parent = self
                                                                        self._children_name_map["rtp_j2k"] = "rtp-j2k"

                                                                        self.rtp_voice = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice()
                                                                        self.rtp_voice.parent = self
                                                                        self._children_name_map["rtp_voice"] = "rtp-voice"

                                                                        self.mdi = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi()
                                                                        self.mdi.parent = self
                                                                        self._children_name_map["mdi"] = "mdi"

                                                                        self.mdi_rtp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp()
                                                                        self.mdi_rtp.parent = self
                                                                        self._children_name_map["mdi_rtp"] = "mdi-rtp"

                                                                        self.fmm = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm()
                                                                        self.fmm.parent = self
                                                                        self._children_name_map["fmm"] = "fmm"

                                                                        self.pbf = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf()
                                                                        self.pbf.parent = self
                                                                        self._children_name_map["pbf"] = "pbf"

                                                                        self.ipv4_nh = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh()
                                                                        self.ipv4_nh.parent = self
                                                                        self._children_name_map["ipv4_nh"] = "ipv4-nh"

                                                                        self.ipv6_nh = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh()
                                                                        self.ipv6_nh.parent = self
                                                                        self._children_name_map["ipv6_nh"] = "ipv6-nh"
                                                                        self._segment_path = lambda: "actp"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp, ['type', 'data_p'], name, value)


                                                                    class Mark(Entity):
                                                                        """
                                                                        mark
                                                                        
                                                                        .. attribute:: action_mark_info
                                                                        
                                                                        	action mark info
                                                                        	**type**\: list of  		 :py:class:`ActionMarkInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark, self).__init__()

                                                                            self.yang_name = "mark"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("action-mark-info", ("action_mark_info", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo))])
                                                                            self._leafs = OrderedDict()

                                                                            self.action_mark_info = YList(self)
                                                                            self._segment_path = lambda: "mark"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark, [], name, value)


                                                                        class ActionMarkInfo(Entity):
                                                                            """
                                                                            action mark info
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:  :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                            
                                                                            .. attribute:: mark_flags
                                                                            
                                                                            	mark flags
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo, self).__init__()

                                                                                self.yang_name = "action-mark-info"
                                                                                self.yang_parent_name = "mark"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MarkTypeEn', '')])),
                                                                                    ('mark_flags', (YLeaf(YType.uint32, 'mark-flags'), ['int'])),
                                                                                    ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                ])
                                                                                self.type = None
                                                                                self.mark_flags = None
                                                                                self.value = None
                                                                                self._segment_path = lambda: "action-mark-info"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo, ['type', 'mark_flags', 'value'], name, value)


                                                                    class Mark2(Entity):
                                                                        """
                                                                        mark2
                                                                        
                                                                        .. attribute:: action_mark2_info
                                                                        
                                                                        	action mark2 info
                                                                        	**type**\: list of  		 :py:class:`ActionMark2Info <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2, self).__init__()

                                                                            self.yang_name = "mark2"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("action-mark2-info", ("action_mark2_info", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info))])
                                                                            self._leafs = OrderedDict()

                                                                            self.action_mark2_info = YList(self)
                                                                            self._segment_path = lambda: "mark2"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2, [], name, value)


                                                                        class ActionMark2Info(Entity):
                                                                            """
                                                                            action mark2 info
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: value_overflow
                                                                            
                                                                            	value overflow
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: mark_flags
                                                                            
                                                                            	mark flags
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info, self).__init__()

                                                                                self.yang_name = "action-mark2-info"
                                                                                self.yang_parent_name = "mark2"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('value_overflow', (YLeaf(YType.uint16, 'value-overflow'), ['int'])),
                                                                                    ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                    ('mark_flags', (YLeaf(YType.uint8, 'mark-flags'), ['int'])),
                                                                                ])
                                                                                self.value = None
                                                                                self.value_overflow = None
                                                                                self.type = None
                                                                                self.mark_flags = None
                                                                                self._segment_path = lambda: "action-mark2-info"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info, ['value', 'value_overflow', 'type', 'mark_flags'], name, value)


                                                                    class Wred(Entity):
                                                                        """
                                                                        wred
                                                                        
                                                                        .. attribute:: action_wred_info
                                                                        
                                                                        	action wred info
                                                                        	**type**\: list of  		 :py:class:`ActionWredInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred, self).__init__()

                                                                            self.yang_name = "wred"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("action-wred-info", ("action_wred_info", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo))])
                                                                            self._leafs = OrderedDict()

                                                                            self.action_wred_info = YList(self)
                                                                            self._segment_path = lambda: "wred"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred, [], name, value)


                                                                        class ActionWredInfo(Entity):
                                                                            """
                                                                            action wred info
                                                                            
                                                                            .. attribute:: match_ranges
                                                                            
                                                                            	match ranges
                                                                            	**type**\:  :py:class:`MatchRanges <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges>`
                                                                            
                                                                            .. attribute:: min_threshold
                                                                            
                                                                            	min threshold
                                                                            	**type**\:  :py:class:`MinThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold>`
                                                                            
                                                                            .. attribute:: max_threshold
                                                                            
                                                                            	max threshold
                                                                            	**type**\:  :py:class:`MaxThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold>`
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	cos/prec/dscp/ based WRED
                                                                            	**type**\:  :py:class:`WredTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.WredTypeEn>`
                                                                            
                                                                            .. attribute:: wred_flags
                                                                            
                                                                            	wred flags
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: probability
                                                                            
                                                                            	probability
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo, self).__init__()

                                                                                self.yang_name = "action-wred-info"
                                                                                self.yang_parent_name = "wred"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("match-ranges", ("match_ranges", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges)), ("min-threshold", ("min_threshold", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold)), ("max-threshold", ("max_threshold", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'WredTypeEn', '')])),
                                                                                    ('wred_flags', (YLeaf(YType.uint32, 'wred-flags'), ['int'])),
                                                                                    ('probability', (YLeaf(YType.uint32, 'probability'), ['int'])),
                                                                                ])
                                                                                self.type = None
                                                                                self.wred_flags = None
                                                                                self.probability = None

                                                                                self.match_ranges = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges()
                                                                                self.match_ranges.parent = self
                                                                                self._children_name_map["match_ranges"] = "match-ranges"

                                                                                self.min_threshold = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold()
                                                                                self.min_threshold.parent = self
                                                                                self._children_name_map["min_threshold"] = "min-threshold"

                                                                                self.max_threshold = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold()
                                                                                self.max_threshold.parent = self
                                                                                self._children_name_map["max_threshold"] = "max-threshold"
                                                                                self._segment_path = lambda: "action-wred-info"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo, ['type', 'wred_flags', 'probability'], name, value)


                                                                            class MatchRanges(Entity):
                                                                                """
                                                                                match ranges
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges, self).__init__()

                                                                                    self.yang_name = "match-ranges"
                                                                                    self.yang_parent_name = "action-wred-info"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "match-ranges"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "match-ranges"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class MinThreshold(Entity):
                                                                                """
                                                                                min threshold
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold, self).__init__()

                                                                                    self.yang_name = "min-threshold"
                                                                                    self.yang_parent_name = "action-wred-info"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.unit = None
                                                                                    self._segment_path = lambda: "min-threshold"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold, ['value', 'unit'], name, value)


                                                                            class MaxThreshold(Entity):
                                                                                """
                                                                                max threshold
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold, self).__init__()

                                                                                    self.yang_name = "max-threshold"
                                                                                    self.yang_parent_name = "action-wred-info"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.unit = None
                                                                                    self._segment_path = lambda: "max-threshold"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold, ['value', 'unit'], name, value)


                                                                    class Encap(Entity):
                                                                        """
                                                                        encap
                                                                        
                                                                        .. attribute:: seq
                                                                        
                                                                        	seq
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap, self).__init__()

                                                                            self.yang_name = "encap"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('seq', (YLeaf(YType.uint8, 'seq'), ['int'])),
                                                                            ])
                                                                            self.seq = None
                                                                            self._segment_path = lambda: "encap"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap, ['seq'], name, value)


                                                                    class Prio(Entity):
                                                                        """
                                                                        prio
                                                                        
                                                                        .. attribute:: prio_lvl
                                                                        
                                                                        	prio lvl
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio, self).__init__()

                                                                            self.yang_name = "prio"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('prio_lvl', (YLeaf(YType.uint32, 'prio-lvl'), ['int'])),
                                                                            ])
                                                                            self.prio_lvl = None
                                                                            self._segment_path = lambda: "prio"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio, ['prio_lvl'], name, value)


                                                                    class Bwrem(Entity):
                                                                        """
                                                                        bwrem
                                                                        
                                                                        .. attribute:: bwrem
                                                                        
                                                                        	bwrem
                                                                        	**type**\:  :py:class:`Bwrem_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem_>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem, self).__init__()

                                                                            self.yang_name = "bwrem"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("bwrem", ("bwrem", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem_))])
                                                                            self._leafs = OrderedDict()

                                                                            self.bwrem = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem_()
                                                                            self.bwrem.parent = self
                                                                            self._children_name_map["bwrem"] = "bwrem"
                                                                            self._segment_path = lambda: "bwrem"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem, [], name, value)


                                                                        class Bwrem_(Entity):
                                                                            """
                                                                            bwrem
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem_, self).__init__()

                                                                                self.yang_name = "bwrem"
                                                                                self.yang_parent_name = "bwrem"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "bwrem"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem_, ['value', 'unit'], name, value)


                                                                    class MinBw(Entity):
                                                                        """
                                                                        min bw
                                                                        
                                                                        .. attribute:: bw
                                                                        
                                                                        	bw
                                                                        	**type**\:  :py:class:`Bw <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw, self).__init__()

                                                                            self.yang_name = "min-bw"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("bw", ("bw", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw))])
                                                                            self._leafs = OrderedDict()

                                                                            self.bw = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw()
                                                                            self.bw.parent = self
                                                                            self._children_name_map["bw"] = "bw"
                                                                            self._segment_path = lambda: "min-bw"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw, [], name, value)


                                                                        class Bw(Entity):
                                                                            """
                                                                            bw
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw, self).__init__()

                                                                                self.yang_name = "bw"
                                                                                self.yang_parent_name = "min-bw"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "bw"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw, ['value', 'unit'], name, value)


                                                                    class AuthenAaa(Entity):
                                                                        """
                                                                        authen aaa
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: authen_password
                                                                        
                                                                        	authen password
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa, self).__init__()

                                                                            self.yang_name = "authen-aaa"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                                ('authen_password', (YLeaf(YType.str, 'authen-password'), ['str'])),
                                                                            ])
                                                                            self.aaa_list_name = None
                                                                            self.authen_password = None
                                                                            self._segment_path = lambda: "authen-aaa"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa, ['aaa_list_name', 'authen_password'], name, value)


                                                                    class CollectId(Entity):
                                                                        """
                                                                        collect id
                                                                        
                                                                        .. attribute:: id
                                                                        
                                                                        	id
                                                                        	**type**\:  :py:class:`IdentifierEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.IdentifierEn>`
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId, self).__init__()

                                                                            self.yang_name = "collect-id"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('id', (YLeaf(YType.enumeration, 'id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'IdentifierEn', '')])),
                                                                                ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                            ])
                                                                            self.id = None
                                                                            self.aaa_list_name = None
                                                                            self._segment_path = lambda: "collect-id"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId, ['id', 'aaa_list_name'], name, value)


                                                                    class DecodeId(Entity):
                                                                        """
                                                                        decode id
                                                                        
                                                                        .. attribute:: id
                                                                        
                                                                        	id
                                                                        	**type**\:  :py:class:`DecodeIdentifierEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.DecodeIdentifierEn>`
                                                                        
                                                                        .. attribute:: format_name
                                                                        
                                                                        	format name
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId, self).__init__()

                                                                            self.yang_name = "decode-id"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('id', (YLeaf(YType.enumeration, 'id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'DecodeIdentifierEn', '')])),
                                                                                ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                            ])
                                                                            self.id = None
                                                                            self.format_name = None
                                                                            self._segment_path = lambda: "decode-id"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId, ['id', 'format_name'], name, value)


                                                                    class SetTimer(Entity):
                                                                        """
                                                                        set timer
                                                                        
                                                                        .. attribute:: timer_name
                                                                        
                                                                        	timer name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: duration
                                                                        
                                                                        	duration
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: absolute_time
                                                                        
                                                                        	absolute time
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer, self).__init__()

                                                                            self.yang_name = "set-timer"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('timer_name', (YLeaf(YType.str, 'timer-name'), ['str'])),
                                                                                ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                                                ('absolute_time', (YLeaf(YType.str, 'absolute-time'), ['str'])),
                                                                            ])
                                                                            self.timer_name = None
                                                                            self.duration = None
                                                                            self.absolute_time = None
                                                                            self._segment_path = lambda: "set-timer"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer, ['timer_name', 'duration', 'absolute_time'], name, value)


                                                                    class StopTimer(Entity):
                                                                        """
                                                                        stop timer
                                                                        
                                                                        .. attribute:: timer_name
                                                                        
                                                                        	timer name
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer, self).__init__()

                                                                            self.yang_name = "stop-timer"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('timer_name', (YLeaf(YType.str, 'timer-name'), ['str'])),
                                                                            ])
                                                                            self.timer_name = None
                                                                            self._segment_path = lambda: "stop-timer"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer, ['timer_name'], name, value)


                                                                    class AcctAaaList(Entity):
                                                                        """
                                                                        acct aaa list
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: secs
                                                                        
                                                                        	secs
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList, self).__init__()

                                                                            self.yang_name = "acct-aaa-list"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                                ('secs', (YLeaf(YType.uint32, 'secs'), ['int'])),
                                                                            ])
                                                                            self.aaa_list_name = None
                                                                            self.secs = None
                                                                            self._segment_path = lambda: "acct-aaa-list"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList, ['aaa_list_name', 'secs'], name, value)


                                                                    class QueryAncp(Entity):
                                                                        """
                                                                        query ancp
                                                                        
                                                                        .. attribute:: enable
                                                                        
                                                                        	enable
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp, self).__init__()

                                                                            self.yang_name = "query-ancp"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('enable', (YLeaf(YType.uint8, 'enable'), ['int'])),
                                                                            ])
                                                                            self.enable = None
                                                                            self._segment_path = lambda: "query-ancp"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp, ['enable'], name, value)


                                                                    class PrepaidCfg(Entity):
                                                                        """
                                                                        prepaid cfg
                                                                        
                                                                        .. attribute:: prepaid_config_profile_name
                                                                        
                                                                        	prepaid config profile name
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg, self).__init__()

                                                                            self.yang_name = "prepaid-cfg"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('prepaid_config_profile_name', (YLeaf(YType.str, 'prepaid-config-profile-name'), ['str'])),
                                                                            ])
                                                                            self.prepaid_config_profile_name = None
                                                                            self._segment_path = lambda: "prepaid-cfg"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg, ['prepaid_config_profile_name'], name, value)


                                                                    class TimeoutIdle(Entity):
                                                                        """
                                                                        timeout idle
                                                                        
                                                                        .. attribute:: secs
                                                                        
                                                                        	secs
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle, self).__init__()

                                                                            self.yang_name = "timeout-idle"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('secs', (YLeaf(YType.uint32, 'secs'), ['int'])),
                                                                            ])
                                                                            self.secs = None
                                                                            self._segment_path = lambda: "timeout-idle"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle, ['secs'], name, value)


                                                                    class ProxyAaa(Entity):
                                                                        """
                                                                        proxy aaa
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa, self).__init__()

                                                                            self.yang_name = "proxy-aaa"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                            ])
                                                                            self.aaa_list_name = None
                                                                            self._segment_path = lambda: "proxy-aaa"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa, ['aaa_list_name'], name, value)


                                                                    class ActTemplate(Entity):
                                                                        """
                                                                        act template
                                                                        
                                                                        .. attribute:: template_name
                                                                        
                                                                        	template name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: flags
                                                                        
                                                                        	flags
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate, self).__init__()

                                                                            self.yang_name = "act-template"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('template_name', (YLeaf(YType.str, 'template-name'), ['str'])),
                                                                                ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                                ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                            ])
                                                                            self.template_name = None
                                                                            self.aaa_list_name = None
                                                                            self.flags = None
                                                                            self._segment_path = lambda: "act-template"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate, ['template_name', 'aaa_list_name', 'flags'], name, value)


                                                                    class DeactTemplate(Entity):
                                                                        """
                                                                        deact template
                                                                        
                                                                        .. attribute:: template_name
                                                                        
                                                                        	template name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: flags
                                                                        
                                                                        	flags
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate, self).__init__()

                                                                            self.yang_name = "deact-template"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('template_name', (YLeaf(YType.str, 'template-name'), ['str'])),
                                                                                ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                                ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                            ])
                                                                            self.template_name = None
                                                                            self.aaa_list_name = None
                                                                            self.flags = None
                                                                            self._segment_path = lambda: "deact-template"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate, ['template_name', 'aaa_list_name', 'flags'], name, value)


                                                                    class Qlimit(Entity):
                                                                        """
                                                                        qlimit
                                                                        
                                                                        .. attribute:: action_qlimit_info_array
                                                                        
                                                                        	action qlimit info array
                                                                        	**type**\: list of  		 :py:class:`ActionQlimitInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit, self).__init__()

                                                                            self.yang_name = "qlimit"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("action-qlimit-info-array", ("action_qlimit_info_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.action_qlimit_info_array = YList(self)
                                                                            self._segment_path = lambda: "qlimit"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit, [], name, value)


                                                                        class ActionQlimitInfoArray(Entity):
                                                                            """
                                                                            action qlimit info array
                                                                            
                                                                            .. attribute:: qlim
                                                                            
                                                                            	qlim
                                                                            	**type**\:  :py:class:`Qlim <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim>`
                                                                            
                                                                            .. attribute:: atmclp_qlim
                                                                            
                                                                            	atmclp qlim
                                                                            	**type**\:  :py:class:`AtmclpQlim <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim>`
                                                                            
                                                                            .. attribute:: match_values
                                                                            
                                                                            	match values
                                                                            	**type**\:  :py:class:`MatchValues <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues>`
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:  :py:class:`QlimitTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.QlimitTypeEn>`
                                                                            
                                                                            .. attribute:: qlimit_flags
                                                                            
                                                                            	qlimit flags
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray, self).__init__()

                                                                                self.yang_name = "action-qlimit-info-array"
                                                                                self.yang_parent_name = "qlimit"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("qlim", ("qlim", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim)), ("atmclp-qlim", ("atmclp_qlim", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim)), ("match-values", ("match_values", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'QlimitTypeEn', '')])),
                                                                                    ('qlimit_flags', (YLeaf(YType.uint32, 'qlimit-flags'), ['int'])),
                                                                                ])
                                                                                self.type = None
                                                                                self.qlimit_flags = None

                                                                                self.qlim = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim()
                                                                                self.qlim.parent = self
                                                                                self._children_name_map["qlim"] = "qlim"

                                                                                self.atmclp_qlim = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim()
                                                                                self.atmclp_qlim.parent = self
                                                                                self._children_name_map["atmclp_qlim"] = "atmclp-qlim"

                                                                                self.match_values = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues()
                                                                                self.match_values.parent = self
                                                                                self._children_name_map["match_values"] = "match-values"
                                                                                self._segment_path = lambda: "action-qlimit-info-array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray, ['type', 'qlimit_flags'], name, value)


                                                                            class Qlim(Entity):
                                                                                """
                                                                                qlim
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim, self).__init__()

                                                                                    self.yang_name = "qlim"
                                                                                    self.yang_parent_name = "action-qlimit-info-array"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.unit = None
                                                                                    self._segment_path = lambda: "qlim"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim, ['value', 'unit'], name, value)


                                                                            class AtmclpQlim(Entity):
                                                                                """
                                                                                atmclp qlim
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim, self).__init__()

                                                                                    self.yang_name = "atmclp-qlim"
                                                                                    self.yang_parent_name = "action-qlimit-info-array"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.unit = None
                                                                                    self._segment_path = lambda: "atmclp-qlim"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim, ['value', 'unit'], name, value)


                                                                            class MatchValues(Entity):
                                                                                """
                                                                                match values
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues, self).__init__()

                                                                                    self.yang_name = "match-values"
                                                                                    self.yang_parent_name = "action-qlimit-info-array"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "match-values"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "match-values"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray, ['min', 'max'], name, value)


                                                                    class AccountingEventAaa(Entity):
                                                                        """
                                                                        accounting event aaa
                                                                        
                                                                        .. attribute:: action
                                                                        
                                                                        	action
                                                                        	**type**\:  :py:class:`AcctEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.AcctEn>`
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa, self).__init__()

                                                                            self.yang_name = "accounting-event-aaa"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('action', (YLeaf(YType.enumeration, 'action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'AcctEn', '')])),
                                                                                ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                            ])
                                                                            self.action = None
                                                                            self.aaa_list_name = None
                                                                            self._segment_path = lambda: "accounting-event-aaa"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa, ['action', 'aaa_list_name'], name, value)


                                                                    class AuthorizeId(Entity):
                                                                        """
                                                                        authorize id
                                                                        
                                                                        .. attribute:: id
                                                                        
                                                                        	id
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: format_name
                                                                        
                                                                        	format name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: password
                                                                        
                                                                        	password
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId, self).__init__()

                                                                            self.yang_name = "authorize-id"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('id', (YLeaf(YType.uint8, 'id'), ['int'])),
                                                                                ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                                ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                ('password', (YLeaf(YType.str, 'password'), ['str'])),
                                                                            ])
                                                                            self.id = None
                                                                            self.aaa_list_name = None
                                                                            self.format_name = None
                                                                            self.password = None
                                                                            self._segment_path = lambda: "authorize-id"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId, ['id', 'aaa_list_name', 'format_name', 'password'], name, value)


                                                                    class AfmReact(Entity):
                                                                        """
                                                                        afm react
                                                                        
                                                                        .. attribute:: action_afmon_react_info
                                                                        
                                                                        	action afmon react info
                                                                        	**type**\: list of  		 :py:class:`ActionAfmonReactInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact, self).__init__()

                                                                            self.yang_name = "afm-react"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("action-afmon-react-info", ("action_afmon_react_info", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo))])
                                                                            self._leafs = OrderedDict()

                                                                            self.action_afmon_react_info = YList(self)
                                                                            self._segment_path = lambda: "afm-react"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact, [], name, value)


                                                                        class ActionAfmonReactInfo(Entity):
                                                                            """
                                                                            action afmon react info
                                                                            
                                                                            .. attribute:: oper_id
                                                                            
                                                                            	React Operation ID
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: description
                                                                            
                                                                            	Describing the oper
                                                                            	**type**\: str
                                                                            
                                                                            .. attribute:: trig_num_intvls
                                                                            
                                                                            	Averaged over N intvls
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: clone_ifh
                                                                            
                                                                            	Clone interface handle
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: notif_actns
                                                                            
                                                                            	Bitmap of actions on alert
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: criterion
                                                                            
                                                                            	React Criterion
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: trig_type
                                                                            
                                                                            	Immediate or averaged thresh trigger
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: trig_relop
                                                                            
                                                                            	Trigger LT\|LE\|GT\|GE\|Range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: trig_level_1
                                                                            
                                                                            	Trigger threshold 1/lower
                                                                            	**type**\: str
                                                                            
                                                                            .. attribute:: trig_level_2
                                                                            
                                                                            	Trigger upper threshold for range
                                                                            	**type**\: str
                                                                            
                                                                            .. attribute:: alm_grp_thresh
                                                                            
                                                                            	Num/percent in grp
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            	**units**\: percentage
                                                                            
                                                                            .. attribute:: alm_type
                                                                            
                                                                            	Discrete \| grouped alarm
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: alm_severity
                                                                            
                                                                            	Major\|Minor\|... alarm
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo, self).__init__()

                                                                                self.yang_name = "action-afmon-react-info"
                                                                                self.yang_parent_name = "afm-react"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('oper_id', (YLeaf(YType.uint32, 'oper-id'), ['int'])),
                                                                                    ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                    ('trig_num_intvls', (YLeaf(YType.uint32, 'trig-num-intvls'), ['int'])),
                                                                                    ('clone_ifh', (YLeaf(YType.uint32, 'clone-ifh'), ['int'])),
                                                                                    ('notif_actns', (YLeaf(YType.uint8, 'notif-actns'), ['int'])),
                                                                                    ('criterion', (YLeaf(YType.uint8, 'criterion'), ['int'])),
                                                                                    ('trig_type', (YLeaf(YType.uint8, 'trig-type'), ['int'])),
                                                                                    ('trig_relop', (YLeaf(YType.uint8, 'trig-relop'), ['int'])),
                                                                                    ('trig_level_1', (YLeaf(YType.str, 'trig-level-1'), ['str'])),
                                                                                    ('trig_level_2', (YLeaf(YType.str, 'trig-level-2'), ['str'])),
                                                                                    ('alm_grp_thresh', (YLeaf(YType.uint16, 'alm-grp-thresh'), ['int'])),
                                                                                    ('alm_type', (YLeaf(YType.uint8, 'alm-type'), ['int'])),
                                                                                    ('alm_severity', (YLeaf(YType.uint8, 'alm-severity'), ['int'])),
                                                                                ])
                                                                                self.oper_id = None
                                                                                self.description = None
                                                                                self.trig_num_intvls = None
                                                                                self.clone_ifh = None
                                                                                self.notif_actns = None
                                                                                self.criterion = None
                                                                                self.trig_type = None
                                                                                self.trig_relop = None
                                                                                self.trig_level_1 = None
                                                                                self.trig_level_2 = None
                                                                                self.alm_grp_thresh = None
                                                                                self.alm_type = None
                                                                                self.alm_severity = None
                                                                                self._segment_path = lambda: "action-afmon-react-info"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo, ['oper_id', 'description', 'trig_num_intvls', 'clone_ifh', 'notif_actns', 'criterion', 'trig_type', 'trig_relop', 'trig_level_1', 'trig_level_2', 'alm_grp_thresh', 'alm_type', 'alm_severity'], name, value)


                                                                    class Httpr(Entity):
                                                                        """
                                                                        httpr
                                                                        
                                                                        .. attribute:: redirect_url
                                                                        
                                                                        	redirect url
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr, self).__init__()

                                                                            self.yang_name = "httpr"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('redirect_url', (YLeaf(YType.str, 'redirect-url'), ['str'])),
                                                                            ])
                                                                            self.redirect_url = None
                                                                            self._segment_path = lambda: "httpr"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr, ['redirect_url'], name, value)


                                                                    class Punt(Entity):
                                                                        """
                                                                        punt
                                                                        
                                                                        .. attribute:: sn_type
                                                                        
                                                                        	service node ID type
                                                                        	**type**\:  :py:class:`DpssSnidTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.DpssSnidTypeEn>`
                                                                        
                                                                        .. attribute:: sn_index
                                                                        
                                                                        	service node index
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: sn_name
                                                                        
                                                                        	service node name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: app_id
                                                                        
                                                                        	application ID
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: local_id
                                                                        
                                                                        	local ID
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: vsnode_type
                                                                        
                                                                        	vservice node type
                                                                        	**type**\:  :py:class:`VsvcServiceTypeT <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.VsvcServiceTypeT>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt, self).__init__()

                                                                            self.yang_name = "punt"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('sn_type', (YLeaf(YType.enumeration, 'sn-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'DpssSnidTypeEn', '')])),
                                                                                ('sn_index', (YLeaf(YType.uint32, 'sn-index'), ['int'])),
                                                                                ('sn_name', (YLeaf(YType.str, 'sn-name'), ['str'])),
                                                                                ('app_id', (YLeaf(YType.uint32, 'app-id'), ['int'])),
                                                                                ('local_id', (YLeaf(YType.uint32, 'local-id'), ['int'])),
                                                                                ('vsnode_type', (YLeaf(YType.enumeration, 'vsnode-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'VsvcServiceTypeT', '')])),
                                                                            ])
                                                                            self.sn_type = None
                                                                            self.sn_index = None
                                                                            self.sn_name = None
                                                                            self.app_id = None
                                                                            self.local_id = None
                                                                            self.vsnode_type = None
                                                                            self._segment_path = lambda: "punt"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt, ['sn_type', 'sn_index', 'sn_name', 'app_id', 'local_id', 'vsnode_type'], name, value)


                                                                    class Copy(Entity):
                                                                        """
                                                                        copy
                                                                        
                                                                        .. attribute:: num_byte
                                                                        
                                                                        	number of bytes
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: sn_type
                                                                        
                                                                        	service node ID type
                                                                        	**type**\:  :py:class:`DpssSnidTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.DpssSnidTypeEn>`
                                                                        
                                                                        .. attribute:: sn_index
                                                                        
                                                                        	service node index
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: sn_name
                                                                        
                                                                        	service node url
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: app_id
                                                                        
                                                                        	application ID
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: local_id
                                                                        
                                                                        	local ID
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: vsnode_type
                                                                        
                                                                        	vservice node type
                                                                        	**type**\:  :py:class:`VsvcServiceTypeT <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.VsvcServiceTypeT>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy, self).__init__()

                                                                            self.yang_name = "copy"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('num_byte', (YLeaf(YType.uint32, 'num-byte'), ['int'])),
                                                                                ('sn_type', (YLeaf(YType.enumeration, 'sn-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'DpssSnidTypeEn', '')])),
                                                                                ('sn_index', (YLeaf(YType.uint32, 'sn-index'), ['int'])),
                                                                                ('sn_name', (YLeaf(YType.str, 'sn-name'), ['str'])),
                                                                                ('app_id', (YLeaf(YType.uint32, 'app-id'), ['int'])),
                                                                                ('local_id', (YLeaf(YType.uint32, 'local-id'), ['int'])),
                                                                                ('vsnode_type', (YLeaf(YType.enumeration, 'vsnode-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'VsvcServiceTypeT', '')])),
                                                                            ])
                                                                            self.num_byte = None
                                                                            self.sn_type = None
                                                                            self.sn_index = None
                                                                            self.sn_name = None
                                                                            self.app_id = None
                                                                            self.local_id = None
                                                                            self.vsnode_type = None
                                                                            self._segment_path = lambda: "copy"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy, ['num_byte', 'sn_type', 'sn_index', 'sn_name', 'app_id', 'local_id', 'vsnode_type'], name, value)


                                                                    class Sfrag(Entity):
                                                                        """
                                                                        sfrag
                                                                        
                                                                        .. attribute:: name
                                                                        
                                                                        	Service Fragment Name
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag, self).__init__()

                                                                            self.yang_name = "sfrag"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                            ])
                                                                            self.name = None
                                                                            self._segment_path = lambda: "sfrag"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag, ['name'], name, value)


                                                                    class Redirect(Entity):
                                                                        """
                                                                        redirect
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: type
                                                                        
                                                                        	type
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect, self).__init__()

                                                                            self.yang_name = "redirect"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                            ])
                                                                            self.value = None
                                                                            self.type = None
                                                                            self._segment_path = lambda: "redirect"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect, ['value', 'type'], name, value)


                                                                    class OutIntf(Entity):
                                                                        """
                                                                        out intf
                                                                        
                                                                        .. attribute:: out_ifname
                                                                        
                                                                        	output interface name
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf, self).__init__()

                                                                            self.yang_name = "out-intf"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('out_ifname', (YLeaf(YType.str, 'out-ifname'), ['str'])),
                                                                            ])
                                                                            self.out_ifname = None
                                                                            self._segment_path = lambda: "out-intf"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf, ['out_ifname'], name, value)


                                                                    class ServFunc(Entity):
                                                                        """
                                                                        serv func
                                                                        
                                                                        .. attribute:: path_id
                                                                        
                                                                        	service path id
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: service_index
                                                                        
                                                                        	service path index
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: meta_name
                                                                        
                                                                        	metadata name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: vs_index
                                                                        
                                                                        	vservice index
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc, self).__init__()

                                                                            self.yang_name = "serv-func"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('path_id', (YLeaf(YType.uint32, 'path-id'), ['int'])),
                                                                                ('service_index', (YLeaf(YType.uint8, 'service-index'), ['int'])),
                                                                                ('meta_name', (YLeaf(YType.str, 'meta-name'), ['str'])),
                                                                                ('vs_index', (YLeaf(YType.uint32, 'vs-index'), ['int'])),
                                                                            ])
                                                                            self.path_id = None
                                                                            self.service_index = None
                                                                            self.meta_name = None
                                                                            self.vs_index = None
                                                                            self._segment_path = lambda: "serv-func"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc, ['path_id', 'service_index', 'meta_name', 'vs_index'], name, value)


                                                                    class Police(Entity):
                                                                        """
                                                                        police
                                                                        
                                                                        .. attribute:: rate
                                                                        
                                                                        	rate
                                                                        	**type**\:  :py:class:`Rate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate>`
                                                                        
                                                                        .. attribute:: burst
                                                                        
                                                                        	burst
                                                                        	**type**\:  :py:class:`Burst <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst>`
                                                                        
                                                                        .. attribute:: peak_rate
                                                                        
                                                                        	peak rate
                                                                        	**type**\:  :py:class:`PeakRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate>`
                                                                        
                                                                        .. attribute:: peak_burst
                                                                        
                                                                        	peak burst
                                                                        	**type**\:  :py:class:`PeakBurst <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst>`
                                                                        
                                                                        .. attribute:: cdvt
                                                                        
                                                                        	cdvt
                                                                        	**type**\:  :py:class:`Cdvt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt>`
                                                                        
                                                                        .. attribute:: conform_actns
                                                                        
                                                                        	conform actns
                                                                        	**type**\:  :py:class:`ConformActns <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns>`
                                                                        
                                                                        .. attribute:: exceed_actns
                                                                        
                                                                        	exceed actns
                                                                        	**type**\:  :py:class:`ExceedActns <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns>`
                                                                        
                                                                        .. attribute:: violate_actns
                                                                        
                                                                        	violate actns
                                                                        	**type**\:  :py:class:`ViolateActns <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns>`
                                                                        
                                                                        .. attribute:: confclass_encode
                                                                        
                                                                        	confclass encode
                                                                        	**type**\:  :py:class:`ConfclassEncode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode>`
                                                                        
                                                                        .. attribute:: confclass_p
                                                                        
                                                                        	confclass p
                                                                        	**type**\:  :py:class:`ConfclassP <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP>`
                                                                        
                                                                        .. attribute:: excdclass_encode
                                                                        
                                                                        	excdclass encode
                                                                        	**type**\:  :py:class:`ExcdclassEncode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode>`
                                                                        
                                                                        .. attribute:: excdclass_p
                                                                        
                                                                        	excdclass p
                                                                        	**type**\:  :py:class:`ExcdclassP <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP>`
                                                                        
                                                                        .. attribute:: flags
                                                                        
                                                                        	flags
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: police_flags
                                                                        
                                                                        	police flags
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: sbuck_name
                                                                        
                                                                        	sbuck name
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..65
                                                                        
                                                                        .. attribute:: sbuck_type
                                                                        
                                                                        	sbuck type
                                                                        	**type**\:  :py:class:`SharedBucketType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.SharedBucketType>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police, self).__init__()

                                                                            self.yang_name = "police"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("rate", ("rate", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate)), ("burst", ("burst", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst)), ("peak-rate", ("peak_rate", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate)), ("peak-burst", ("peak_burst", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst)), ("cdvt", ("cdvt", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt)), ("conform-actns", ("conform_actns", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns)), ("exceed-actns", ("exceed_actns", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns)), ("violate-actns", ("violate_actns", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns)), ("confclass-encode", ("confclass_encode", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode)), ("confclass-p", ("confclass_p", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP)), ("excdclass-encode", ("excdclass_encode", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode)), ("excdclass-p", ("excdclass_p", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP))])
                                                                            self._leafs = OrderedDict([
                                                                                ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                ('police_flags', (YLeaf(YType.uint32, 'police-flags'), ['int'])),
                                                                                ('sbuck_name', (YLeaf(YType.str, 'sbuck-name'), ['str'])),
                                                                                ('sbuck_type', (YLeaf(YType.enumeration, 'sbuck-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'SharedBucketType', '')])),
                                                                            ])
                                                                            self.flags = None
                                                                            self.police_flags = None
                                                                            self.sbuck_name = None
                                                                            self.sbuck_type = None

                                                                            self.rate = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate()
                                                                            self.rate.parent = self
                                                                            self._children_name_map["rate"] = "rate"

                                                                            self.burst = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst()
                                                                            self.burst.parent = self
                                                                            self._children_name_map["burst"] = "burst"

                                                                            self.peak_rate = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate()
                                                                            self.peak_rate.parent = self
                                                                            self._children_name_map["peak_rate"] = "peak-rate"

                                                                            self.peak_burst = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst()
                                                                            self.peak_burst.parent = self
                                                                            self._children_name_map["peak_burst"] = "peak-burst"

                                                                            self.cdvt = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt()
                                                                            self.cdvt.parent = self
                                                                            self._children_name_map["cdvt"] = "cdvt"

                                                                            self.conform_actns = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns()
                                                                            self.conform_actns.parent = self
                                                                            self._children_name_map["conform_actns"] = "conform-actns"

                                                                            self.exceed_actns = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns()
                                                                            self.exceed_actns.parent = self
                                                                            self._children_name_map["exceed_actns"] = "exceed-actns"

                                                                            self.violate_actns = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns()
                                                                            self.violate_actns.parent = self
                                                                            self._children_name_map["violate_actns"] = "violate-actns"

                                                                            self.confclass_encode = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode()
                                                                            self.confclass_encode.parent = self
                                                                            self._children_name_map["confclass_encode"] = "confclass-encode"

                                                                            self.confclass_p = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP()
                                                                            self.confclass_p.parent = self
                                                                            self._children_name_map["confclass_p"] = "confclass-p"

                                                                            self.excdclass_encode = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode()
                                                                            self.excdclass_encode.parent = self
                                                                            self._children_name_map["excdclass_encode"] = "excdclass-encode"

                                                                            self.excdclass_p = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP()
                                                                            self.excdclass_p.parent = self
                                                                            self._children_name_map["excdclass_p"] = "excdclass-p"
                                                                            self._segment_path = lambda: "police"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police, ['flags', 'police_flags', 'sbuck_name', 'sbuck_type'], name, value)


                                                                        class Rate(Entity):
                                                                            """
                                                                            rate
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate, self).__init__()

                                                                                self.yang_name = "rate"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate, ['value', 'unit'], name, value)


                                                                        class Burst(Entity):
                                                                            """
                                                                            burst
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst, self).__init__()

                                                                                self.yang_name = "burst"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "burst"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst, ['value', 'unit'], name, value)


                                                                        class PeakRate(Entity):
                                                                            """
                                                                            peak rate
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate, self).__init__()

                                                                                self.yang_name = "peak-rate"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "peak-rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate, ['value', 'unit'], name, value)


                                                                        class PeakBurst(Entity):
                                                                            """
                                                                            peak burst
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst, self).__init__()

                                                                                self.yang_name = "peak-burst"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "peak-burst"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst, ['value', 'unit'], name, value)


                                                                        class Cdvt(Entity):
                                                                            """
                                                                            cdvt
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt, self).__init__()

                                                                                self.yang_name = "cdvt"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "cdvt"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt, ['value', 'unit'], name, value)


                                                                        class ConformActns(Entity):
                                                                            """
                                                                            conform actns
                                                                            
                                                                            .. attribute:: police_action_array
                                                                            
                                                                            	police action array
                                                                            	**type**\: list of  		 :py:class:`PoliceActionArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns, self).__init__()

                                                                                self.yang_name = "conform-actns"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("police-action-array", ("police_action_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.police_action_array = YList(self)
                                                                                self._segment_path = lambda: "conform-actns"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns, [], name, value)


                                                                            class PoliceActionArray(Entity):
                                                                                """
                                                                                police action array
                                                                                
                                                                                .. attribute:: mark
                                                                                
                                                                                	mark
                                                                                	**type**\:  :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark>`
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:  :py:class:`PoliceActionTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PoliceActionTypeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray, self).__init__()

                                                                                    self.yang_name = "police-action-array"
                                                                                    self.yang_parent_name = "conform-actns"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("mark", ("mark", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PoliceActionTypeEn', '')])),
                                                                                    ])
                                                                                    self.type = None

                                                                                    self.mark = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark()
                                                                                    self.mark.parent = self
                                                                                    self._children_name_map["mark"] = "mark"
                                                                                    self._segment_path = lambda: "police-action-array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray, ['type'], name, value)


                                                                                class Mark(Entity):
                                                                                    """
                                                                                    mark
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	type
                                                                                    	**type**\:  :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                                    
                                                                                    .. attribute:: mark_flags
                                                                                    
                                                                                    	mark flags
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark, self).__init__()

                                                                                        self.yang_name = "mark"
                                                                                        self.yang_parent_name = "police-action-array"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MarkTypeEn', '')])),
                                                                                            ('mark_flags', (YLeaf(YType.uint32, 'mark-flags'), ['int'])),
                                                                                            ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                        ])
                                                                                        self.type = None
                                                                                        self.mark_flags = None
                                                                                        self.value = None
                                                                                        self._segment_path = lambda: "mark"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark, ['type', 'mark_flags', 'value'], name, value)


                                                                        class ExceedActns(Entity):
                                                                            """
                                                                            exceed actns
                                                                            
                                                                            .. attribute:: police_action_array
                                                                            
                                                                            	police action array
                                                                            	**type**\: list of  		 :py:class:`PoliceActionArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns, self).__init__()

                                                                                self.yang_name = "exceed-actns"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("police-action-array", ("police_action_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.police_action_array = YList(self)
                                                                                self._segment_path = lambda: "exceed-actns"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns, [], name, value)


                                                                            class PoliceActionArray(Entity):
                                                                                """
                                                                                police action array
                                                                                
                                                                                .. attribute:: mark
                                                                                
                                                                                	mark
                                                                                	**type**\:  :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark>`
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:  :py:class:`PoliceActionTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PoliceActionTypeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray, self).__init__()

                                                                                    self.yang_name = "police-action-array"
                                                                                    self.yang_parent_name = "exceed-actns"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("mark", ("mark", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PoliceActionTypeEn', '')])),
                                                                                    ])
                                                                                    self.type = None

                                                                                    self.mark = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark()
                                                                                    self.mark.parent = self
                                                                                    self._children_name_map["mark"] = "mark"
                                                                                    self._segment_path = lambda: "police-action-array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray, ['type'], name, value)


                                                                                class Mark(Entity):
                                                                                    """
                                                                                    mark
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	type
                                                                                    	**type**\:  :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                                    
                                                                                    .. attribute:: mark_flags
                                                                                    
                                                                                    	mark flags
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark, self).__init__()

                                                                                        self.yang_name = "mark"
                                                                                        self.yang_parent_name = "police-action-array"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MarkTypeEn', '')])),
                                                                                            ('mark_flags', (YLeaf(YType.uint32, 'mark-flags'), ['int'])),
                                                                                            ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                        ])
                                                                                        self.type = None
                                                                                        self.mark_flags = None
                                                                                        self.value = None
                                                                                        self._segment_path = lambda: "mark"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark, ['type', 'mark_flags', 'value'], name, value)


                                                                        class ViolateActns(Entity):
                                                                            """
                                                                            violate actns
                                                                            
                                                                            .. attribute:: police_action_array
                                                                            
                                                                            	police action array
                                                                            	**type**\: list of  		 :py:class:`PoliceActionArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns, self).__init__()

                                                                                self.yang_name = "violate-actns"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("police-action-array", ("police_action_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.police_action_array = YList(self)
                                                                                self._segment_path = lambda: "violate-actns"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns, [], name, value)


                                                                            class PoliceActionArray(Entity):
                                                                                """
                                                                                police action array
                                                                                
                                                                                .. attribute:: mark
                                                                                
                                                                                	mark
                                                                                	**type**\:  :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark>`
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:  :py:class:`PoliceActionTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PoliceActionTypeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray, self).__init__()

                                                                                    self.yang_name = "police-action-array"
                                                                                    self.yang_parent_name = "violate-actns"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("mark", ("mark", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PoliceActionTypeEn', '')])),
                                                                                    ])
                                                                                    self.type = None

                                                                                    self.mark = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark()
                                                                                    self.mark.parent = self
                                                                                    self._children_name_map["mark"] = "mark"
                                                                                    self._segment_path = lambda: "police-action-array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray, ['type'], name, value)


                                                                                class Mark(Entity):
                                                                                    """
                                                                                    mark
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	type
                                                                                    	**type**\:  :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                                    
                                                                                    .. attribute:: mark_flags
                                                                                    
                                                                                    	mark flags
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark, self).__init__()

                                                                                        self.yang_name = "mark"
                                                                                        self.yang_parent_name = "police-action-array"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MarkTypeEn', '')])),
                                                                                            ('mark_flags', (YLeaf(YType.uint32, 'mark-flags'), ['int'])),
                                                                                            ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                        ])
                                                                                        self.type = None
                                                                                        self.mark_flags = None
                                                                                        self.value = None
                                                                                        self._segment_path = lambda: "mark"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark, ['type', 'mark_flags', 'value'], name, value)


                                                                        class ConfclassEncode(Entity):
                                                                            """
                                                                            confclass encode
                                                                            
                                                                            .. attribute:: inline_cmap
                                                                            
                                                                            	inline cmap
                                                                            	**type**\:  :py:class:`InlineCmap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap>`
                                                                            
                                                                            .. attribute:: enc
                                                                            
                                                                            	enc
                                                                            	**type**\:  :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                            
                                                                            .. attribute:: class_name
                                                                            
                                                                            	class name
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..65
                                                                            
                                                                            .. attribute:: hd
                                                                            
                                                                            	hd
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: idx
                                                                            
                                                                            	idx
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode, self).__init__()

                                                                                self.yang_name = "confclass-encode"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("inline-cmap", ("inline_cmap", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('enc', (YLeaf(YType.enumeration, 'enc'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyObjEncEn', '')])),
                                                                                    ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                                                    ('hd', (YLeaf(YType.uint64, 'hd'), ['int'])),
                                                                                    ('idx', (YLeaf(YType.uint8, 'idx'), ['int'])),
                                                                                ])
                                                                                self.enc = None
                                                                                self.class_name = None
                                                                                self.hd = None
                                                                                self.idx = None

                                                                                self.inline_cmap = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap()
                                                                                self.inline_cmap.parent = self
                                                                                self._children_name_map["inline_cmap"] = "inline-cmap"
                                                                                self._segment_path = lambda: "confclass-encode"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode, ['enc', 'class_name', 'hd', 'idx'], name, value)


                                                                            class InlineCmap(Entity):
                                                                                """
                                                                                inline cmap
                                                                                
                                                                                .. attribute:: match_infop
                                                                                
                                                                                	Pointer to the first Match info
                                                                                	**type**\:  :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop>`
                                                                                
                                                                                .. attribute:: mode
                                                                                
                                                                                	Inline Class\-Map Mode Match any/all
                                                                                	**type**\:  :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                                
                                                                                .. attribute:: flags
                                                                                
                                                                                	Inline Class\-Map flags
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: match_count
                                                                                
                                                                                	Number of Match infos
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap, self).__init__()

                                                                                    self.yang_name = "inline-cmap"
                                                                                    self.yang_parent_name = "confclass-encode"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("match-infop", ("match_infop", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapModeEn', '')])),
                                                                                        ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                        ('match_count', (YLeaf(YType.uint32, 'match-count'), ['int'])),
                                                                                    ])
                                                                                    self.mode = None
                                                                                    self.flags = None
                                                                                    self.match_count = None

                                                                                    self.match_infop = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop()
                                                                                    self.match_infop.parent = self
                                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                                    self._segment_path = lambda: "inline-cmap"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap, ['mode', 'flags', 'match_count'], name, value)


                                                                                class MatchInfop(Entity):
                                                                                    """
                                                                                    Pointer to the first Match info
                                                                                    
                                                                                    .. attribute:: class_match_info_st
                                                                                    
                                                                                    	class match info st
                                                                                    	**type**\: list of  		 :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop, self).__init__()

                                                                                        self.yang_name = "match-infop"
                                                                                        self.yang_parent_name = "inline-cmap"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("class-match-info-st", ("class_match_info_st", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.class_match_info_st = YList(self)
                                                                                        self._segment_path = lambda: "match-infop"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop, [], name, value)


                                                                                    class ClassMatchInfoSt(Entity):
                                                                                        """
                                                                                        class match info st
                                                                                        
                                                                                        .. attribute:: match_data
                                                                                        
                                                                                        	Match criteria
                                                                                        	**type**\:  :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                        
                                                                                        .. attribute:: flags
                                                                                        
                                                                                        	Flags
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                            self.yang_name = "class-match-info-st"
                                                                                            self.yang_parent_name = "match-infop"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("match-data", ("match_data", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData))])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                            ])
                                                                                            self.flags = None

                                                                                            self.match_data = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                            self.match_data.parent = self
                                                                                            self._children_name_map["match_data"] = "match-data"
                                                                                            self._segment_path = lambda: "class-match-info-st"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                        class MatchData(Entity):
                                                                                            """
                                                                                            Match criteria
                                                                                            
                                                                                            .. attribute:: ipv4_dscp
                                                                                            
                                                                                            	IPv4 DSCP
                                                                                            	**type**\:  :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv6_dscp
                                                                                            
                                                                                            	IPv6 DSCP
                                                                                            	**type**\:  :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                            
                                                                                            .. attribute:: dscp
                                                                                            
                                                                                            	Match DSCP range array
                                                                                            	**type**\:  :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv4_prec
                                                                                            
                                                                                            	IPv4 Precedence
                                                                                            	**type**\:  :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                            
                                                                                            .. attribute:: ipv6_prec
                                                                                            
                                                                                            	IPv6 Precedence
                                                                                            	**type**\:  :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                            
                                                                                            .. attribute:: prec
                                                                                            
                                                                                            	Match Precedence array
                                                                                            	**type**\:  :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                            
                                                                                            .. attribute:: discard_class
                                                                                            
                                                                                            	Match Discard Class array
                                                                                            	**type**\:  :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                            
                                                                                            .. attribute:: qos_group
                                                                                            
                                                                                            	Match QoS group array
                                                                                            	**type**\:  :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                            
                                                                                            .. attribute:: traffic_class
                                                                                            
                                                                                            	Match Traffic class array
                                                                                            	**type**\:  :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                            
                                                                                            .. attribute:: proto
                                                                                            
                                                                                            	Match Protocol array
                                                                                            	**type**\:  :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                            
                                                                                            .. attribute:: icmp_v4
                                                                                            
                                                                                            	Match ICMPV4 Protocol
                                                                                            	**type**\:  :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                            
                                                                                            .. attribute:: icmp_v6
                                                                                            
                                                                                            	Match ICMPV6 Protocol array
                                                                                            	**type**\:  :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                            
                                                                                            .. attribute:: ipv4_packet_len
                                                                                            
                                                                                            	IPv4 packet length array
                                                                                            	**type**\:  :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv6_packet_len
                                                                                            
                                                                                            	IPv6 packet length array
                                                                                            	**type**\:  :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                            
                                                                                            .. attribute:: packet_len
                                                                                            
                                                                                            	Match packet length array
                                                                                            	**type**\:  :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                            
                                                                                            .. attribute:: flow_tag
                                                                                            
                                                                                            	Match flow\-tag array
                                                                                            	**type**\:  :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                            
                                                                                            .. attribute:: tcp_flag
                                                                                            
                                                                                            	Match tcp flag value
                                                                                            	**type**\:  :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                            
                                                                                            .. attribute:: icmpv4_type
                                                                                            
                                                                                            	Match ipv4 icmp type
                                                                                            	**type**\:  :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                            
                                                                                            .. attribute:: icmpv4_code
                                                                                            
                                                                                            	Match ipv4 icmp code
                                                                                            	**type**\:  :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                            
                                                                                            .. attribute:: icmpv6_type
                                                                                            
                                                                                            	Match ipv6 icmp type
                                                                                            	**type**\:  :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                            
                                                                                            .. attribute:: icmpv6_code
                                                                                            
                                                                                            	Match ipv6 icmp code
                                                                                            	**type**\:  :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                            
                                                                                            .. attribute:: mpls_exp
                                                                                            
                                                                                            	Match MPLS experimental topmost array
                                                                                            	**type**\:  :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                            
                                                                                            .. attribute:: mpls_exp_imp
                                                                                            
                                                                                            	Match MPLS experimental imposition array
                                                                                            	**type**\:  :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                                            
                                                                                            	MPLS Disposition IPv4 Access\-list
                                                                                            	**type**\:  :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                                            
                                                                                            	MPLS Disposition IPv6 Access\-list
                                                                                            	**type**\:  :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_top_label
                                                                                            
                                                                                            	MPLS Topmost LABEL
                                                                                            	**type**\:  :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                            
                                                                                            .. attribute:: cos
                                                                                            
                                                                                            	Match CoS array
                                                                                            	**type**\:  :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                            
                                                                                            .. attribute:: cos_inr
                                                                                            
                                                                                            	Match inner header CoS
                                                                                            	**type**\:  :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                            
                                                                                            .. attribute:: dei
                                                                                            
                                                                                            	Match DEI Bit
                                                                                            	**type**\:  :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                            
                                                                                            .. attribute:: dei_inr
                                                                                            
                                                                                            	Match inner DEI Bit
                                                                                            	**type**\:  :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                            
                                                                                            .. attribute:: vlan
                                                                                            
                                                                                            	Match VLAN array
                                                                                            	**type**\:  :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                            
                                                                                            .. attribute:: vlan_inr
                                                                                            
                                                                                            	Match inner header VLAN range array
                                                                                            	**type**\:  :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                            
                                                                                            .. attribute:: fr_dlci
                                                                                            
                                                                                            	Match FR DLCI range array
                                                                                            	**type**\:  :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                            
                                                                                            .. attribute:: src_mac
                                                                                            
                                                                                            	Match Source MAC address
                                                                                            	**type**\:  :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                            
                                                                                            .. attribute:: dst_mac
                                                                                            
                                                                                            	Match Destination MAC address
                                                                                            	**type**\:  :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                            
                                                                                            .. attribute:: atm_clp
                                                                                            
                                                                                            	Match ATM CLP level
                                                                                            	**type**\:  :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                            
                                                                                            .. attribute:: fr_de
                                                                                            
                                                                                            	Match FR DE value
                                                                                            	**type**\:  :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                            
                                                                                            .. attribute:: ipv4_acl
                                                                                            
                                                                                            	IPv4 Access\-list
                                                                                            	**type**\:  :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                            
                                                                                            .. attribute:: ipv6_acl
                                                                                            
                                                                                            	IPv6 Access\-list
                                                                                            	**type**\:  :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                            
                                                                                            .. attribute:: ether_service_acl
                                                                                            
                                                                                            	Ethernet\-Services Access\-list
                                                                                            	**type**\:  :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                            
                                                                                            .. attribute:: avail_id
                                                                                            
                                                                                            	Available Identifiers
                                                                                            	**type**\:  :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                            
                                                                                            .. attribute:: media_type
                                                                                            
                                                                                            	Media Type
                                                                                            	**type**\:  :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                            
                                                                                            .. attribute:: subs_protocol
                                                                                            
                                                                                            	Protocol
                                                                                            	**type**\:  :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                            
                                                                                            .. attribute:: dnis
                                                                                            
                                                                                            	DNIS
                                                                                            	**type**\:  :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                            
                                                                                            .. attribute:: dnis_regex
                                                                                            
                                                                                            	DNIS Regular Expression
                                                                                            	**type**\:  :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                            
                                                                                            .. attribute:: domain
                                                                                            
                                                                                            	Domain Name
                                                                                            	**type**\:  :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                            
                                                                                            .. attribute:: domain_regex
                                                                                            
                                                                                            	Domain Regular Expression
                                                                                            	**type**\:  :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                            
                                                                                            .. attribute:: nas_port
                                                                                            
                                                                                            	NAS Port
                                                                                            	**type**\:  :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                            
                                                                                            .. attribute:: service_name
                                                                                            
                                                                                            	Service Name
                                                                                            	**type**\:  :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                            
                                                                                            .. attribute:: service_name_regex
                                                                                            
                                                                                            	Service Name Regular Exp
                                                                                            	**type**\:  :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv4
                                                                                            
                                                                                            	Source Address IPV4
                                                                                            	**type**\:  :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv4
                                                                                            
                                                                                            	Destination Address IPV4
                                                                                            	**type**\:  :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv6
                                                                                            
                                                                                            	Source Address IPV6
                                                                                            	**type**\:  :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv6
                                                                                            
                                                                                            	Destination Address IPV6
                                                                                            	**type**\:  :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: src_addr_mac
                                                                                            
                                                                                            	Source Address MAC
                                                                                            	**type**\:  :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                            
                                                                                            .. attribute:: timer
                                                                                            
                                                                                            	Timer
                                                                                            	**type**\:  :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                            
                                                                                            .. attribute:: timer_regexp
                                                                                            
                                                                                            	Timer Regular Expression
                                                                                            	**type**\:  :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                            
                                                                                            .. attribute:: tunnel_name
                                                                                            
                                                                                            	Tunnel Name
                                                                                            	**type**\:  :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                            
                                                                                            .. attribute:: tunnel_name_regex
                                                                                            
                                                                                            	Tunnel Name Regular Expression
                                                                                            	**type**\:  :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                            
                                                                                            .. attribute:: user_name
                                                                                            
                                                                                            	User Name
                                                                                            	**type**\:  :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                            
                                                                                            .. attribute:: user_name_regex
                                                                                            
                                                                                            	User Name Regular Expression
                                                                                            	**type**\:  :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                            
                                                                                            .. attribute:: auth_username
                                                                                            
                                                                                            	Authenticated User Name
                                                                                            	**type**\:  :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                            
                                                                                            .. attribute:: auth_username_regex
                                                                                            
                                                                                            	Authenticated User Name RegEx
                                                                                            	**type**\:  :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_username
                                                                                            
                                                                                            	Unauthenticated User Name
                                                                                            	**type**\:  :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                            
                                                                                            .. attribute:: unauth_username_regex
                                                                                            
                                                                                            	Unauthenticated User Name RegEx
                                                                                            	**type**\:  :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: auth_domain
                                                                                            
                                                                                            	Authenticated domain name
                                                                                            	**type**\:  :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                            
                                                                                            .. attribute:: auth_domain_regex
                                                                                            
                                                                                            	Authenticated Domain Name RegEx
                                                                                            	**type**\:  :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_domain
                                                                                            
                                                                                            	Unauthenticated Domain Name
                                                                                            	**type**\:  :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                            
                                                                                            .. attribute:: unauth_domain_regex
                                                                                            
                                                                                            	Unauthenticated Domain Name RegEx
                                                                                            	**type**\:  :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: vendor_id
                                                                                            
                                                                                            	Vendor ID
                                                                                            	**type**\:  :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                            
                                                                                            .. attribute:: vendor_id_regex
                                                                                            
                                                                                            	Vendor ID RegEx
                                                                                            	**type**\:  :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                            
                                                                                            .. attribute:: access_interface
                                                                                            
                                                                                            	Access interface
                                                                                            	**type**\:  :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                            
                                                                                            .. attribute:: input_interface
                                                                                            
                                                                                            	Input interface
                                                                                            	**type**\:  :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                            
                                                                                            .. attribute:: input_intfhdl
                                                                                            
                                                                                            	Input interface handle
                                                                                            	**type**\:  :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                            
                                                                                            .. attribute:: ethertype
                                                                                            
                                                                                            	Ethernet type
                                                                                            	**type**\:  :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                            
                                                                                            .. attribute:: flow_key_data
                                                                                            
                                                                                            	Flow key structure
                                                                                            	**type**\:  :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id
                                                                                            
                                                                                            	Dhcp Client ID
                                                                                            	**type**\:  :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id_regex
                                                                                            
                                                                                            	Dhcp Client ID RegEx
                                                                                            	**type**\:  :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                            
                                                                                            .. attribute:: circuit_id
                                                                                            
                                                                                            	Circuit ID
                                                                                            	**type**\:  :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                            
                                                                                            .. attribute:: circuit_id_regex
                                                                                            
                                                                                            	Circuit ID RegEx
                                                                                            	**type**\:  :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                            
                                                                                            .. attribute:: remote_id
                                                                                            
                                                                                            	Remote ID
                                                                                            	**type**\:  :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                            
                                                                                            .. attribute:: remote_id_regex
                                                                                            
                                                                                            	Remote ID RegEx
                                                                                            	**type**\:  :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                            
                                                                                            .. attribute:: src_port
                                                                                            
                                                                                            	Source port
                                                                                            	**type**\:  :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                            
                                                                                            .. attribute:: dst_port
                                                                                            
                                                                                            	Destination port
                                                                                            	**type**\:  :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	type
                                                                                            	**type**\:  :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                            
                                                                                            .. attribute:: mpls_top_eos
                                                                                            
                                                                                            	MPLS Topmost EOS
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: fragment_type
                                                                                            
                                                                                            	Fragment type
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: authen_status
                                                                                            
                                                                                            	Authentication Status
                                                                                            	**type**\:  :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                            
                                                                                            .. attribute:: mlp_negotiated
                                                                                            
                                                                                            	MLP Negotiated
                                                                                            	**type**\:  :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                                self.yang_name = "match-data"
                                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("ipv4-dscp", ("ipv4_dscp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp)), ("ipv6-dscp", ("ipv6_dscp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp)), ("dscp", ("dscp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp)), ("ipv4-prec", ("ipv4_prec", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec)), ("ipv6-prec", ("ipv6_prec", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec)), ("prec", ("prec", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec)), ("discard-class", ("discard_class", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass)), ("qos-group", ("qos_group", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup)), ("traffic-class", ("traffic_class", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass)), ("proto", ("proto", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto)), ("icmp-v4", ("icmp_v4", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4)), ("icmp-v6", ("icmp_v6", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6)), ("ipv4-packet-len", ("ipv4_packet_len", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen)), ("ipv6-packet-len", ("ipv6_packet_len", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen)), ("packet-len", ("packet_len", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen)), ("flow-tag", ("flow_tag", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag)), ("tcp-flag", ("tcp_flag", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag)), ("icmpv4-type", ("icmpv4_type", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type)), ("icmpv4-code", ("icmpv4_code", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code)), ("icmpv6-type", ("icmpv6_type", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type)), ("icmpv6-code", ("icmpv6_code", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code)), ("mpls-exp", ("mpls_exp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp)), ("mpls-exp-imp", ("mpls_exp_imp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp)), ("mpls-disp-ipv4-acl", ("mpls_disp_ipv4_acl", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl)), ("mpls-disp-ipv6-acl", ("mpls_disp_ipv6_acl", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl)), ("mpls-top-label", ("mpls_top_label", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel)), ("cos", ("cos", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos)), ("cos-inr", ("cos_inr", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr)), ("dei", ("dei", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei)), ("dei-inr", ("dei_inr", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr)), ("vlan", ("vlan", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan)), ("vlan-inr", ("vlan_inr", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)), ("fr-dlci", ("fr_dlci", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci)), ("src-mac", ("src_mac", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac)), ("dst-mac", ("dst_mac", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac)), ("atm-clp", ("atm_clp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp)), ("fr-de", ("fr_de", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe)), ("ipv4-acl", ("ipv4_acl", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl)), ("ipv6-acl", ("ipv6_acl", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl)), ("ether-service-acl", ("ether_service_acl", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl)), ("avail-id", ("avail_id", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId)), ("media-type", ("media_type", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType)), ("subs-protocol", ("subs_protocol", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol)), ("dnis", ("dnis", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis)), ("dnis-regex", ("dnis_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex)), ("domain", ("domain", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain)), ("domain-regex", ("domain_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex)), ("nas-port", ("nas_port", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort)), ("service-name", ("service_name", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName)), ("service-name-regex", ("service_name_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex)), ("src-addr-ipv4", ("src_addr_ipv4", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4)), ("dst-addr-ipv4", ("dst_addr_ipv4", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4)), ("src-addr-ipv6", ("src_addr_ipv6", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6)), ("dst-addr-ipv6", ("dst_addr_ipv6", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6)), ("src-addr-mac", ("src_addr_mac", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac)), ("timer", ("timer", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer)), ("timer-regexp", ("timer_regexp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp)), ("tunnel-name", ("tunnel_name", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName)), ("tunnel-name-regex", ("tunnel_name_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex)), ("user-name", ("user_name", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName)), ("user-name-regex", ("user_name_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex)), ("auth-username", ("auth_username", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername)), ("auth-username-regex", ("auth_username_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex)), ("unauth-username", ("unauth_username", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername)), ("unauth-username-regex", ("unauth_username_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex)), ("auth-domain", ("auth_domain", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain)), ("auth-domain-regex", ("auth_domain_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex)), ("unauth-domain", ("unauth_domain", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain)), ("unauth-domain-regex", ("unauth_domain_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex)), ("vendor-id", ("vendor_id", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId)), ("vendor-id-regex", ("vendor_id_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex)), ("access-interface", ("access_interface", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface)), ("input-interface", ("input_interface", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface)), ("input-intfhdl", ("input_intfhdl", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl)), ("ethertype", ("ethertype", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype)), ("flow-key-data", ("flow_key_data", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData)), ("dhcp-client-id", ("dhcp_client_id", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId)), ("dhcp-client-id-regex", ("dhcp_client_id_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex)), ("circuit-id", ("circuit_id", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId)), ("circuit-id-regex", ("circuit_id_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex)), ("remote-id", ("remote_id", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId)), ("remote-id-regex", ("remote_id_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex)), ("src-port", ("src_port", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort)), ("dst-port", ("dst_port", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort))])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchTypeEn', '')])),
                                                                                                    ('mpls_top_eos', (YLeaf(YType.uint8, 'mpls-top-eos'), ['int'])),
                                                                                                    ('fragment_type', (YLeaf(YType.uint8, 'fragment-type'), ['int'])),
                                                                                                    ('authen_status', (YLeaf(YType.enumeration, 'authen-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchAuthenStatusEn', '')])),
                                                                                                    ('mlp_negotiated', (YLeaf(YType.enumeration, 'mlp-negotiated'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchMlpNegotiatedEn', '')])),
                                                                                                ])
                                                                                                self.type = None
                                                                                                self.mpls_top_eos = None
                                                                                                self.fragment_type = None
                                                                                                self.authen_status = None
                                                                                                self.mlp_negotiated = None

                                                                                                self.ipv4_dscp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                                self.ipv4_dscp.parent = self
                                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"

                                                                                                self.ipv6_dscp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                                self.ipv6_dscp.parent = self
                                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"

                                                                                                self.dscp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                                self.dscp.parent = self
                                                                                                self._children_name_map["dscp"] = "dscp"

                                                                                                self.ipv4_prec = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                                self.ipv4_prec.parent = self
                                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"

                                                                                                self.ipv6_prec = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                                self.ipv6_prec.parent = self
                                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"

                                                                                                self.prec = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                                self.prec.parent = self
                                                                                                self._children_name_map["prec"] = "prec"

                                                                                                self.discard_class = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                                self.discard_class.parent = self
                                                                                                self._children_name_map["discard_class"] = "discard-class"

                                                                                                self.qos_group = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                                self.qos_group.parent = self
                                                                                                self._children_name_map["qos_group"] = "qos-group"

                                                                                                self.traffic_class = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                                self.traffic_class.parent = self
                                                                                                self._children_name_map["traffic_class"] = "traffic-class"

                                                                                                self.proto = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                                self.proto.parent = self
                                                                                                self._children_name_map["proto"] = "proto"

                                                                                                self.icmp_v4 = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                                self.icmp_v4.parent = self
                                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"

                                                                                                self.icmp_v6 = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                                self.icmp_v6.parent = self
                                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"

                                                                                                self.ipv4_packet_len = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                                self.ipv4_packet_len.parent = self
                                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"

                                                                                                self.ipv6_packet_len = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                                self.ipv6_packet_len.parent = self
                                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"

                                                                                                self.packet_len = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                                self.packet_len.parent = self
                                                                                                self._children_name_map["packet_len"] = "packet-len"

                                                                                                self.flow_tag = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                                self.flow_tag.parent = self
                                                                                                self._children_name_map["flow_tag"] = "flow-tag"

                                                                                                self.tcp_flag = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                                self.tcp_flag.parent = self
                                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"

                                                                                                self.icmpv4_type = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                                self.icmpv4_type.parent = self
                                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"

                                                                                                self.icmpv4_code = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                                self.icmpv4_code.parent = self
                                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"

                                                                                                self.icmpv6_type = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                                self.icmpv6_type.parent = self
                                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"

                                                                                                self.icmpv6_code = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                                self.icmpv6_code.parent = self
                                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"

                                                                                                self.mpls_exp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                                self.mpls_exp.parent = self
                                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"

                                                                                                self.mpls_exp_imp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                                self.mpls_exp_imp.parent = self
                                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"

                                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"

                                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"

                                                                                                self.mpls_top_label = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                                self.mpls_top_label.parent = self
                                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"

                                                                                                self.cos = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                                self.cos.parent = self
                                                                                                self._children_name_map["cos"] = "cos"

                                                                                                self.cos_inr = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                                self.cos_inr.parent = self
                                                                                                self._children_name_map["cos_inr"] = "cos-inr"

                                                                                                self.dei = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                                self.dei.parent = self
                                                                                                self._children_name_map["dei"] = "dei"

                                                                                                self.dei_inr = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                                self.dei_inr.parent = self
                                                                                                self._children_name_map["dei_inr"] = "dei-inr"

                                                                                                self.vlan = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                                self.vlan.parent = self
                                                                                                self._children_name_map["vlan"] = "vlan"

                                                                                                self.vlan_inr = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                                self.vlan_inr.parent = self
                                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"

                                                                                                self.fr_dlci = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                                self.fr_dlci.parent = self
                                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"

                                                                                                self.src_mac = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                                self.src_mac.parent = self
                                                                                                self._children_name_map["src_mac"] = "src-mac"

                                                                                                self.dst_mac = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                                self.dst_mac.parent = self
                                                                                                self._children_name_map["dst_mac"] = "dst-mac"

                                                                                                self.atm_clp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                                self.atm_clp.parent = self
                                                                                                self._children_name_map["atm_clp"] = "atm-clp"

                                                                                                self.fr_de = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                                self.fr_de.parent = self
                                                                                                self._children_name_map["fr_de"] = "fr-de"

                                                                                                self.ipv4_acl = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                                self.ipv4_acl.parent = self
                                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"

                                                                                                self.ipv6_acl = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                                self.ipv6_acl.parent = self
                                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"

                                                                                                self.ether_service_acl = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                                self.ether_service_acl.parent = self
                                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"

                                                                                                self.avail_id = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                                self.avail_id.parent = self
                                                                                                self._children_name_map["avail_id"] = "avail-id"

                                                                                                self.media_type = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                                self.media_type.parent = self
                                                                                                self._children_name_map["media_type"] = "media-type"

                                                                                                self.subs_protocol = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                                self.subs_protocol.parent = self
                                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"

                                                                                                self.dnis = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                                self.dnis.parent = self
                                                                                                self._children_name_map["dnis"] = "dnis"

                                                                                                self.dnis_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                                self.dnis_regex.parent = self
                                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"

                                                                                                self.domain = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                                self.domain.parent = self
                                                                                                self._children_name_map["domain"] = "domain"

                                                                                                self.domain_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                                self.domain_regex.parent = self
                                                                                                self._children_name_map["domain_regex"] = "domain-regex"

                                                                                                self.nas_port = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                                self.nas_port.parent = self
                                                                                                self._children_name_map["nas_port"] = "nas-port"

                                                                                                self.service_name = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                                self.service_name.parent = self
                                                                                                self._children_name_map["service_name"] = "service-name"

                                                                                                self.service_name_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                                self.service_name_regex.parent = self
                                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"

                                                                                                self.src_addr_ipv4 = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                                self.src_addr_ipv4.parent = self
                                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"

                                                                                                self.dst_addr_ipv4 = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                                self.dst_addr_ipv4.parent = self
                                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"

                                                                                                self.src_addr_ipv6 = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                                self.src_addr_ipv6.parent = self
                                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"

                                                                                                self.dst_addr_ipv6 = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                                self.dst_addr_ipv6.parent = self
                                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"

                                                                                                self.src_addr_mac = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                                self.src_addr_mac.parent = self
                                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"

                                                                                                self.timer = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                                self.timer.parent = self
                                                                                                self._children_name_map["timer"] = "timer"

                                                                                                self.timer_regexp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                                self.timer_regexp.parent = self
                                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"

                                                                                                self.tunnel_name = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                                self.tunnel_name.parent = self
                                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"

                                                                                                self.tunnel_name_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                                self.tunnel_name_regex.parent = self
                                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"

                                                                                                self.user_name = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                                self.user_name.parent = self
                                                                                                self._children_name_map["user_name"] = "user-name"

                                                                                                self.user_name_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                                self.user_name_regex.parent = self
                                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"

                                                                                                self.auth_username = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                                self.auth_username.parent = self
                                                                                                self._children_name_map["auth_username"] = "auth-username"

                                                                                                self.auth_username_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                                self.auth_username_regex.parent = self
                                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"

                                                                                                self.unauth_username = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                                self.unauth_username.parent = self
                                                                                                self._children_name_map["unauth_username"] = "unauth-username"

                                                                                                self.unauth_username_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                                self.unauth_username_regex.parent = self
                                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"

                                                                                                self.auth_domain = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                                self.auth_domain.parent = self
                                                                                                self._children_name_map["auth_domain"] = "auth-domain"

                                                                                                self.auth_domain_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                                self.auth_domain_regex.parent = self
                                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"

                                                                                                self.unauth_domain = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                                self.unauth_domain.parent = self
                                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"

                                                                                                self.unauth_domain_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                                self.unauth_domain_regex.parent = self
                                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"

                                                                                                self.vendor_id = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                                self.vendor_id.parent = self
                                                                                                self._children_name_map["vendor_id"] = "vendor-id"

                                                                                                self.vendor_id_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                                self.vendor_id_regex.parent = self
                                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"

                                                                                                self.access_interface = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                                self.access_interface.parent = self
                                                                                                self._children_name_map["access_interface"] = "access-interface"

                                                                                                self.input_interface = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                                self.input_interface.parent = self
                                                                                                self._children_name_map["input_interface"] = "input-interface"

                                                                                                self.input_intfhdl = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                                self.input_intfhdl.parent = self
                                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"

                                                                                                self.ethertype = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                                self.ethertype.parent = self
                                                                                                self._children_name_map["ethertype"] = "ethertype"

                                                                                                self.flow_key_data = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                                self.flow_key_data.parent = self
                                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"

                                                                                                self.dhcp_client_id = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                                self.dhcp_client_id.parent = self
                                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"

                                                                                                self.dhcp_client_id_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                                self.dhcp_client_id_regex.parent = self
                                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"

                                                                                                self.circuit_id = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                                self.circuit_id.parent = self
                                                                                                self._children_name_map["circuit_id"] = "circuit-id"

                                                                                                self.circuit_id_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                                self.circuit_id_regex.parent = self
                                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"

                                                                                                self.remote_id = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                                self.remote_id.parent = self
                                                                                                self._children_name_map["remote_id"] = "remote-id"

                                                                                                self.remote_id_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                                self.remote_id_regex.parent = self
                                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"

                                                                                                self.src_port = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                                self.src_port.parent = self
                                                                                                self._children_name_map["src_port"] = "src-port"

                                                                                                self.dst_port = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                                self.dst_port.parent = self
                                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                                self._segment_path = lambda: "match-data"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, ['type', 'mpls_top_eos', 'fragment_type', 'authen_status', 'mlp_negotiated'], name, value)


                                                                                            class Ipv4Dscp(Entity):
                                                                                                """
                                                                                                IPv4 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv4-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv6Dscp(Entity):
                                                                                                """
                                                                                                IPv6 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv6-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Dscp(Entity):
                                                                                                """
                                                                                                Match DSCP range array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                    self.yang_name = "dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv4Prec(Entity):
                                                                                                """
                                                                                                IPv4 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                    self.yang_name = "ipv4-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "ipv4-prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                            class Ipv6Prec(Entity):
                                                                                                """
                                                                                                IPv6 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                    self.yang_name = "ipv6-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "ipv6-prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                            class Prec(Entity):
                                                                                                """
                                                                                                Match Precedence array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                    self.yang_name = "prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                            class DiscardClass(Entity):
                                                                                                """
                                                                                                Match Discard Class array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                    self.yang_name = "discard-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "discard-class"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                            class QosGroup(Entity):
                                                                                                """
                                                                                                Match QoS group array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                    self.yang_name = "qos-group"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "qos-group"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "qos-group"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class TrafficClass(Entity):
                                                                                                """
                                                                                                Match Traffic class array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                    self.yang_name = "traffic-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "traffic-class"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "traffic-class"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Proto(Entity):
                                                                                                """
                                                                                                Match Protocol array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                    self.yang_name = "proto"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "proto"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "proto"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class IcmpV4(Entity):
                                                                                                """
                                                                                                Match ICMPV4 Protocol
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                    self.yang_name = "icmp-v4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                    ])
                                                                                                    self.type = None
                                                                                                    self.code = None
                                                                                                    self._segment_path = lambda: "icmp-v4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['type', 'code'], name, value)


                                                                                            class IcmpV6(Entity):
                                                                                                """
                                                                                                Match ICMPV6 Protocol array
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                    self.yang_name = "icmp-v6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                    ])
                                                                                                    self.type = None
                                                                                                    self.code = None
                                                                                                    self._segment_path = lambda: "icmp-v6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['type', 'code'], name, value)


                                                                                            class Ipv4PacketLen(Entity):
                                                                                                """
                                                                                                IPv4 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv6PacketLen(Entity):
                                                                                                """
                                                                                                IPv6 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class PacketLen(Entity):
                                                                                                """
                                                                                                Match packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                    self.yang_name = "packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FlowTag(Entity):
                                                                                                """
                                                                                                Match flow\-tag array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                    self.yang_name = "flow-tag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "flow-tag"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "flow-tag"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class TcpFlag(Entity):
                                                                                                """
                                                                                                Match tcp flag value
                                                                                                
                                                                                                .. attribute:: value
                                                                                                
                                                                                                	Value of TCP flag
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: match_any
                                                                                                
                                                                                                	Match any TCP flag bit
                                                                                                	**type**\: bool
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                    self.yang_name = "tcp-flag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                                        ('match_any', (YLeaf(YType.boolean, 'match-any'), ['bool'])),
                                                                                                    ])
                                                                                                    self.value = None
                                                                                                    self.match_any = None
                                                                                                    self._segment_path = lambda: "tcp-flag"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['value', 'match_any'], name, value)


                                                                                            class Icmpv4Type(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                    self.yang_name = "icmpv4-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv4Code(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                    self.yang_name = "icmpv4-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-code"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv6Type(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                    self.yang_name = "icmpv6-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv6Code(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                    self.yang_name = "icmpv6-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-code"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class MplsExp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental topmost array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "mpls-exp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                            class MplsExpImp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental imposition array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "mpls-exp-imp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                            class MplsDispIpv4Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                            class MplsDispIpv6Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                            class MplsTopLabel(Entity):
                                                                                                """
                                                                                                MPLS Topmost LABEL
                                                                                                
                                                                                                .. attribute:: uint32_rng_array
                                                                                                
                                                                                                	uint32 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                    self.yang_name = "mpls-top-label"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint32_rng_array", ("uint32_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint32_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "mpls-top-label"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                                class Uint32RngArray(Entity):
                                                                                                    """
                                                                                                    uint32 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                        self.yang_name = "uint32_rng_array"
                                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint32, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint32, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint32_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['min', 'max'], name, value)


                                                                                            class Cos(Entity):
                                                                                                """
                                                                                                Match CoS array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                    self.yang_name = "cos"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "cos"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                            class CosInr(Entity):
                                                                                                """
                                                                                                Match inner header CoS
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                    self.yang_name = "cos-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "cos-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                            class Dei(Entity):
                                                                                                """
                                                                                                Match DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                    self.yang_name = "dei"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                    ])
                                                                                                    self.bit_value = None
                                                                                                    self._segment_path = lambda: "dei"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                            class DeiInr(Entity):
                                                                                                """
                                                                                                Match inner DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                    self.yang_name = "dei-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                    ])
                                                                                                    self.bit_value = None
                                                                                                    self._segment_path = lambda: "dei-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                            class Vlan(Entity):
                                                                                                """
                                                                                                Match VLAN array
                                                                                                
                                                                                                .. attribute:: vlan_id_array
                                                                                                
                                                                                                	vlan id array
                                                                                                	**type**\: list of  		 :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                    self.yang_name = "vlan"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("vlan-id-array", ("vlan_id_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.vlan_id_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                                class VlanIdArray(Entity):
                                                                                                    """
                                                                                                    vlan id array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	VLAN mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                        self.yang_name = "vlan-id-array"
                                                                                                        self.yang_parent_name = "vlan"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ('mask', (YLeaf(YType.uint16, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "vlan-id-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['min', 'max', 'mask'], name, value)


                                                                                            class VlanInr(Entity):
                                                                                                """
                                                                                                Match inner header VLAN range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                    self.yang_name = "vlan-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FrDlci(Entity):
                                                                                                """
                                                                                                Match FR DLCI range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                    self.yang_name = "fr-dlci"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "fr-dlci"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class SrcMac(Entity):
                                                                                                """
                                                                                                Match Source MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                    self.yang_name = "src-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.mac_addr = []
                                                                                                    self.mask = []
                                                                                                    self._segment_path = lambda: "src-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                            class DstMac(Entity):
                                                                                                """
                                                                                                Match Destination MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                    self.yang_name = "dst-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.mac_addr = []
                                                                                                    self.mask = []
                                                                                                    self._segment_path = lambda: "dst-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                            class AtmClp(Entity):
                                                                                                """
                                                                                                Match ATM CLP level
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                    self.yang_name = "atm-clp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "atm-clp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                            class FrDe(Entity):
                                                                                                """
                                                                                                Match FR DE value
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                    self.yang_name = "fr-de"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "fr-de"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                            class Ipv4Acl(Entity):
                                                                                                """
                                                                                                IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                    self.yang_name = "ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ipv4-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                            class Ipv6Acl(Entity):
                                                                                                """
                                                                                                IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                    self.yang_name = "ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ipv6-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                            class EtherServiceAcl(Entity):
                                                                                                """
                                                                                                Ethernet\-Services Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                    self.yang_name = "ether-service-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ether-service-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                            class AvailId(Entity):
                                                                                                """
                                                                                                Available Identifiers
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                    self.yang_name = "avail-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "avail-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                            class MediaType(Entity):
                                                                                                """
                                                                                                Media Type
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                    self.yang_name = "media-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "media-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                            class SubsProtocol(Entity):
                                                                                                """
                                                                                                Protocol
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                    self.yang_name = "subs-protocol"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "subs-protocol"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                            class Dnis(Entity):
                                                                                                """
                                                                                                DNIS
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                    self.yang_name = "dnis"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dnis"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                            class DnisRegex(Entity):
                                                                                                """
                                                                                                DNIS Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                    self.yang_name = "dnis-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dnis-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                            class Domain(Entity):
                                                                                                """
                                                                                                Domain Name
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                    self.yang_name = "domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                        ])
                                                                                                        self.domain_name = None
                                                                                                        self.format_name = None
                                                                                                        self._segment_path = lambda: "domain-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class DomainRegex(Entity):
                                                                                                """
                                                                                                Domain Regular Expression
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                    self.yang_name = "domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain-regex"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                        ])
                                                                                                        self.domain_name = None
                                                                                                        self.format_name = None
                                                                                                        self._segment_path = lambda: "domain-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class NasPort(Entity):
                                                                                                """
                                                                                                NAS Port
                                                                                                
                                                                                                .. attribute:: nas_port_array
                                                                                                
                                                                                                	nas port array
                                                                                                	**type**\: list of  		 :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                    self.yang_name = "nas-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("nas-port-array", ("nas_port_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.nas_port_array = YList(self)
                                                                                                    self._segment_path = lambda: "nas-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                                class NasPortArray(Entity):
                                                                                                    """
                                                                                                    nas port array
                                                                                                    
                                                                                                    .. attribute:: sub_id
                                                                                                    
                                                                                                    	sub id
                                                                                                    	**type**\:  :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                    
                                                                                                    .. attribute:: operator
                                                                                                    
                                                                                                    	operator
                                                                                                    	**type**\:  :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	value
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                        self.yang_name = "nas-port-array"
                                                                                                        self.yang_parent_name = "nas-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('sub_id', (YLeaf(YType.enumeration, 'sub-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchNasPortSubIdEn', '')])),
                                                                                                            ('operator', (YLeaf(YType.enumeration, 'operator'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchLogicalOperatorEn', '')])),
                                                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                                        ])
                                                                                                        self.sub_id = None
                                                                                                        self.operator = None
                                                                                                        self.value = None
                                                                                                        self._segment_path = lambda: "nas-port-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['sub_id', 'operator', 'value'], name, value)


                                                                                            class ServiceName(Entity):
                                                                                                """
                                                                                                Service Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                    self.yang_name = "service-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "service-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                            class ServiceNameRegex(Entity):
                                                                                                """
                                                                                                Service Name Regular Exp
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                    self.yang_name = "service-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "service-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                            class SrcAddrIpv4(Entity):
                                                                                                """
                                                                                                Source Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class DstAddrIpv4(Entity):
                                                                                                """
                                                                                                Destination Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class SrcAddrIpv6(Entity):
                                                                                                """
                                                                                                Source Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class DstAddrIpv6(Entity):
                                                                                                """
                                                                                                Destination Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class SrcAddrMac(Entity):
                                                                                                """
                                                                                                Source Address MAC
                                                                                                
                                                                                                .. attribute:: mac_addr_array
                                                                                                
                                                                                                	mac addr array
                                                                                                	**type**\: list of  		 :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                    self.yang_name = "src-addr-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("mac-addr-array", ("mac_addr_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.mac_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                                class MacAddrArray(Entity):
                                                                                                    """
                                                                                                    mac addr array
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                        self.yang_name = "mac-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                            ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.mac_addr = []
                                                                                                        self.mask = []
                                                                                                        self._segment_path = lambda: "mac-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                            class Timer(Entity):
                                                                                                """
                                                                                                Timer
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                    self.yang_name = "timer"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "timer"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                            class TimerRegexp(Entity):
                                                                                                """
                                                                                                Timer Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                    self.yang_name = "timer-regexp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "timer-regexp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                            class TunnelName(Entity):
                                                                                                """
                                                                                                Tunnel Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                    self.yang_name = "tunnel-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "tunnel-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                            class TunnelNameRegex(Entity):
                                                                                                """
                                                                                                Tunnel Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "tunnel-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                            class UserName(Entity):
                                                                                                """
                                                                                                User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                    self.yang_name = "user-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "user-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                            class UserNameRegex(Entity):
                                                                                                """
                                                                                                User Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                    self.yang_name = "user-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "user-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                            class AuthUsername(Entity):
                                                                                                """
                                                                                                Authenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                    self.yang_name = "auth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-username"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                            class AuthUsernameRegex(Entity):
                                                                                                """
                                                                                                Authenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "auth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-username-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                            class UnauthUsername(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                    self.yang_name = "unauth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-username"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                            class UnauthUsernameRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-username-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                            class AuthDomain(Entity):
                                                                                                """
                                                                                                Authenticated domain name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                    self.yang_name = "auth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                            class AuthDomainRegex(Entity):
                                                                                                """
                                                                                                Authenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "auth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                            class UnauthDomain(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                    self.yang_name = "unauth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                            class UnauthDomainRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                            class VendorId(Entity):
                                                                                                """
                                                                                                Vendor ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                    self.yang_name = "vendor-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "vendor-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                            class VendorIdRegex(Entity):
                                                                                                """
                                                                                                Vendor ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                    self.yang_name = "vendor-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "vendor-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                            class AccessInterface(Entity):
                                                                                                """
                                                                                                Access interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                    self.yang_name = "access-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "access-interface"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                            class InputInterface(Entity):
                                                                                                """
                                                                                                Input interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                    self.yang_name = "input-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "input-interface"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                            class InputIntfhdl(Entity):
                                                                                                """
                                                                                                Input interface handle
                                                                                                
                                                                                                .. attribute:: uint64_array
                                                                                                
                                                                                                	uint64 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..18446744073709551615
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                    self.yang_name = "input-intfhdl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint64_array', (YLeafList(YType.uint64, 'uint64_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint64_array = []
                                                                                                    self._segment_path = lambda: "input-intfhdl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                            class Ethertype(Entity):
                                                                                                """
                                                                                                Ethernet type
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                    self.yang_name = "ethertype"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ethertype"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ethertype"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FlowKeyData(Entity):
                                                                                                """
                                                                                                Flow key structure
                                                                                                
                                                                                                .. attribute:: flow_keys
                                                                                                
                                                                                                	flow keys
                                                                                                	**type**\:  :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                                
                                                                                                .. attribute:: max_count
                                                                                                
                                                                                                	Maximum count of flows
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: idle_timeout
                                                                                                
                                                                                                	Idle timeout of flows (in seconds)
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                	**units**\: second
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                    self.yang_name = "flow-key-data"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("flow-keys", ("flow_keys", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys))])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('max_count', (YLeaf(YType.uint16, 'max-count'), ['int'])),
                                                                                                        ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                                                    ])
                                                                                                    self.max_count = None
                                                                                                    self.idle_timeout = None

                                                                                                    self.flow_keys = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                    self.flow_keys.parent = self
                                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                    self._segment_path = lambda: "flow-key-data"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['max_count', 'idle_timeout'], name, value)


                                                                                                class FlowKeys(Entity):
                                                                                                    """
                                                                                                    flow keys
                                                                                                    
                                                                                                    .. attribute:: keys
                                                                                                    
                                                                                                    	keys
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                    
                                                                                                    .. attribute:: num
                                                                                                    
                                                                                                    	num
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                        self.yang_name = "flow-keys"
                                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('keys', (YLeaf(YType.str, 'keys'), ['str'])),
                                                                                                            ('num', (YLeaf(YType.uint8, 'num'), ['int'])),
                                                                                                        ])
                                                                                                        self.keys = None
                                                                                                        self.num = None
                                                                                                        self._segment_path = lambda: "flow-keys"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                            class DhcpClientId(Entity):
                                                                                                """
                                                                                                Dhcp Client ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dhcp-client-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                            class DhcpClientIdRegex(Entity):
                                                                                                """
                                                                                                Dhcp Client ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                            class CircuitId(Entity):
                                                                                                """
                                                                                                Circuit ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                    self.yang_name = "circuit-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "circuit-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                            class CircuitIdRegex(Entity):
                                                                                                """
                                                                                                Circuit ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                    self.yang_name = "circuit-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "circuit-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                            class RemoteId(Entity):
                                                                                                """
                                                                                                Remote ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                    self.yang_name = "remote-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "remote-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                            class RemoteIdRegex(Entity):
                                                                                                """
                                                                                                Remote ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                    self.yang_name = "remote-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "remote-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                            class SrcPort(Entity):
                                                                                                """
                                                                                                Source port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                    self.yang_name = "src-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "src-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class DstPort(Entity):
                                                                                                """
                                                                                                Destination port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                    self.yang_name = "dst-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "dst-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                        class ConfclassP(Entity):
                                                                            """
                                                                            confclass p
                                                                            
                                                                            .. attribute:: class_map_bg
                                                                            
                                                                            	class map bg
                                                                            	**type**\: list of  		 :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP, self).__init__()

                                                                                self.yang_name = "confclass-p"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("class-map-bg", ("class_map_bg", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg))])
                                                                                self._leafs = OrderedDict()

                                                                                self.class_map_bg = YList(self)
                                                                                self._segment_path = lambda: "confclass-p"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP, [], name, value)


                                                                            class ClassMapBg(Entity):
                                                                                """
                                                                                class map bg
                                                                                
                                                                                .. attribute:: match_infop
                                                                                
                                                                                	Pointer to the first Match info
                                                                                	**type**\:  :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop>`
                                                                                
                                                                                .. attribute:: name
                                                                                
                                                                                	Name of the class\-map
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..65
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Class\-Map Type QoS/PBR/Netflow/..
                                                                                	**type**\:  :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                                                
                                                                                .. attribute:: mode
                                                                                
                                                                                	Class\-Map Mode Match any/Match all
                                                                                	**type**\:  :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                                
                                                                                .. attribute:: description
                                                                                
                                                                                	description
                                                                                	**type**\: str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg, self).__init__()

                                                                                    self.yang_name = "class-map-bg"
                                                                                    self.yang_parent_name = "confclass-p"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("match-infop", ("match_infop", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapTypeEn', '')])),
                                                                                        ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapModeEn', '')])),
                                                                                        ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                    ])
                                                                                    self.name = None
                                                                                    self.type = None
                                                                                    self.mode = None
                                                                                    self.description = None

                                                                                    self.match_infop = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop()
                                                                                    self.match_infop.parent = self
                                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                                    self._segment_path = lambda: "class-map-bg"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg, ['name', 'type', 'mode', 'description'], name, value)


                                                                                class MatchInfop(Entity):
                                                                                    """
                                                                                    Pointer to the first Match info
                                                                                    
                                                                                    .. attribute:: class_match_info_st
                                                                                    
                                                                                    	class match info st
                                                                                    	**type**\: list of  		 :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop, self).__init__()

                                                                                        self.yang_name = "match-infop"
                                                                                        self.yang_parent_name = "class-map-bg"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("class-match-info-st", ("class_match_info_st", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.class_match_info_st = YList(self)
                                                                                        self._segment_path = lambda: "match-infop"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop, [], name, value)


                                                                                    class ClassMatchInfoSt(Entity):
                                                                                        """
                                                                                        class match info st
                                                                                        
                                                                                        .. attribute:: match_data
                                                                                        
                                                                                        	Match criteria
                                                                                        	**type**\:  :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                        
                                                                                        .. attribute:: flags
                                                                                        
                                                                                        	Flags
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                            self.yang_name = "class-match-info-st"
                                                                                            self.yang_parent_name = "match-infop"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("match-data", ("match_data", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData))])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                            ])
                                                                                            self.flags = None

                                                                                            self.match_data = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                            self.match_data.parent = self
                                                                                            self._children_name_map["match_data"] = "match-data"
                                                                                            self._segment_path = lambda: "class-match-info-st"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                        class MatchData(Entity):
                                                                                            """
                                                                                            Match criteria
                                                                                            
                                                                                            .. attribute:: ipv4_dscp
                                                                                            
                                                                                            	IPv4 DSCP
                                                                                            	**type**\:  :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv6_dscp
                                                                                            
                                                                                            	IPv6 DSCP
                                                                                            	**type**\:  :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                            
                                                                                            .. attribute:: dscp
                                                                                            
                                                                                            	Match DSCP range array
                                                                                            	**type**\:  :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv4_prec
                                                                                            
                                                                                            	IPv4 Precedence
                                                                                            	**type**\:  :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                            
                                                                                            .. attribute:: ipv6_prec
                                                                                            
                                                                                            	IPv6 Precedence
                                                                                            	**type**\:  :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                            
                                                                                            .. attribute:: prec
                                                                                            
                                                                                            	Match Precedence array
                                                                                            	**type**\:  :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                            
                                                                                            .. attribute:: discard_class
                                                                                            
                                                                                            	Match Discard Class array
                                                                                            	**type**\:  :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                            
                                                                                            .. attribute:: qos_group
                                                                                            
                                                                                            	Match QoS group array
                                                                                            	**type**\:  :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                            
                                                                                            .. attribute:: traffic_class
                                                                                            
                                                                                            	Match Traffic class array
                                                                                            	**type**\:  :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                            
                                                                                            .. attribute:: proto
                                                                                            
                                                                                            	Match Protocol array
                                                                                            	**type**\:  :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                            
                                                                                            .. attribute:: icmp_v4
                                                                                            
                                                                                            	Match ICMPV4 Protocol
                                                                                            	**type**\:  :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                            
                                                                                            .. attribute:: icmp_v6
                                                                                            
                                                                                            	Match ICMPV6 Protocol array
                                                                                            	**type**\:  :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                            
                                                                                            .. attribute:: ipv4_packet_len
                                                                                            
                                                                                            	IPv4 packet length array
                                                                                            	**type**\:  :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv6_packet_len
                                                                                            
                                                                                            	IPv6 packet length array
                                                                                            	**type**\:  :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                            
                                                                                            .. attribute:: packet_len
                                                                                            
                                                                                            	Match packet length array
                                                                                            	**type**\:  :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                            
                                                                                            .. attribute:: flow_tag
                                                                                            
                                                                                            	Match flow\-tag array
                                                                                            	**type**\:  :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                            
                                                                                            .. attribute:: tcp_flag
                                                                                            
                                                                                            	Match tcp flag value
                                                                                            	**type**\:  :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                            
                                                                                            .. attribute:: icmpv4_type
                                                                                            
                                                                                            	Match ipv4 icmp type
                                                                                            	**type**\:  :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                            
                                                                                            .. attribute:: icmpv4_code
                                                                                            
                                                                                            	Match ipv4 icmp code
                                                                                            	**type**\:  :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                            
                                                                                            .. attribute:: icmpv6_type
                                                                                            
                                                                                            	Match ipv6 icmp type
                                                                                            	**type**\:  :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                            
                                                                                            .. attribute:: icmpv6_code
                                                                                            
                                                                                            	Match ipv6 icmp code
                                                                                            	**type**\:  :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                            
                                                                                            .. attribute:: mpls_exp
                                                                                            
                                                                                            	Match MPLS experimental topmost array
                                                                                            	**type**\:  :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                            
                                                                                            .. attribute:: mpls_exp_imp
                                                                                            
                                                                                            	Match MPLS experimental imposition array
                                                                                            	**type**\:  :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                                            
                                                                                            	MPLS Disposition IPv4 Access\-list
                                                                                            	**type**\:  :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                                            
                                                                                            	MPLS Disposition IPv6 Access\-list
                                                                                            	**type**\:  :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_top_label
                                                                                            
                                                                                            	MPLS Topmost LABEL
                                                                                            	**type**\:  :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                            
                                                                                            .. attribute:: cos
                                                                                            
                                                                                            	Match CoS array
                                                                                            	**type**\:  :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                            
                                                                                            .. attribute:: cos_inr
                                                                                            
                                                                                            	Match inner header CoS
                                                                                            	**type**\:  :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                            
                                                                                            .. attribute:: dei
                                                                                            
                                                                                            	Match DEI Bit
                                                                                            	**type**\:  :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                            
                                                                                            .. attribute:: dei_inr
                                                                                            
                                                                                            	Match inner DEI Bit
                                                                                            	**type**\:  :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                            
                                                                                            .. attribute:: vlan
                                                                                            
                                                                                            	Match VLAN array
                                                                                            	**type**\:  :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                            
                                                                                            .. attribute:: vlan_inr
                                                                                            
                                                                                            	Match inner header VLAN range array
                                                                                            	**type**\:  :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                            
                                                                                            .. attribute:: fr_dlci
                                                                                            
                                                                                            	Match FR DLCI range array
                                                                                            	**type**\:  :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                            
                                                                                            .. attribute:: src_mac
                                                                                            
                                                                                            	Match Source MAC address
                                                                                            	**type**\:  :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                            
                                                                                            .. attribute:: dst_mac
                                                                                            
                                                                                            	Match Destination MAC address
                                                                                            	**type**\:  :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                            
                                                                                            .. attribute:: atm_clp
                                                                                            
                                                                                            	Match ATM CLP level
                                                                                            	**type**\:  :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                            
                                                                                            .. attribute:: fr_de
                                                                                            
                                                                                            	Match FR DE value
                                                                                            	**type**\:  :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                            
                                                                                            .. attribute:: ipv4_acl
                                                                                            
                                                                                            	IPv4 Access\-list
                                                                                            	**type**\:  :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                            
                                                                                            .. attribute:: ipv6_acl
                                                                                            
                                                                                            	IPv6 Access\-list
                                                                                            	**type**\:  :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                            
                                                                                            .. attribute:: ether_service_acl
                                                                                            
                                                                                            	Ethernet\-Services Access\-list
                                                                                            	**type**\:  :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                            
                                                                                            .. attribute:: avail_id
                                                                                            
                                                                                            	Available Identifiers
                                                                                            	**type**\:  :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                            
                                                                                            .. attribute:: media_type
                                                                                            
                                                                                            	Media Type
                                                                                            	**type**\:  :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                            
                                                                                            .. attribute:: subs_protocol
                                                                                            
                                                                                            	Protocol
                                                                                            	**type**\:  :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                            
                                                                                            .. attribute:: dnis
                                                                                            
                                                                                            	DNIS
                                                                                            	**type**\:  :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                            
                                                                                            .. attribute:: dnis_regex
                                                                                            
                                                                                            	DNIS Regular Expression
                                                                                            	**type**\:  :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                            
                                                                                            .. attribute:: domain
                                                                                            
                                                                                            	Domain Name
                                                                                            	**type**\:  :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                            
                                                                                            .. attribute:: domain_regex
                                                                                            
                                                                                            	Domain Regular Expression
                                                                                            	**type**\:  :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                            
                                                                                            .. attribute:: nas_port
                                                                                            
                                                                                            	NAS Port
                                                                                            	**type**\:  :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                            
                                                                                            .. attribute:: service_name
                                                                                            
                                                                                            	Service Name
                                                                                            	**type**\:  :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                            
                                                                                            .. attribute:: service_name_regex
                                                                                            
                                                                                            	Service Name Regular Exp
                                                                                            	**type**\:  :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv4
                                                                                            
                                                                                            	Source Address IPV4
                                                                                            	**type**\:  :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv4
                                                                                            
                                                                                            	Destination Address IPV4
                                                                                            	**type**\:  :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv6
                                                                                            
                                                                                            	Source Address IPV6
                                                                                            	**type**\:  :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv6
                                                                                            
                                                                                            	Destination Address IPV6
                                                                                            	**type**\:  :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: src_addr_mac
                                                                                            
                                                                                            	Source Address MAC
                                                                                            	**type**\:  :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                            
                                                                                            .. attribute:: timer
                                                                                            
                                                                                            	Timer
                                                                                            	**type**\:  :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                            
                                                                                            .. attribute:: timer_regexp
                                                                                            
                                                                                            	Timer Regular Expression
                                                                                            	**type**\:  :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                            
                                                                                            .. attribute:: tunnel_name
                                                                                            
                                                                                            	Tunnel Name
                                                                                            	**type**\:  :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                            
                                                                                            .. attribute:: tunnel_name_regex
                                                                                            
                                                                                            	Tunnel Name Regular Expression
                                                                                            	**type**\:  :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                            
                                                                                            .. attribute:: user_name
                                                                                            
                                                                                            	User Name
                                                                                            	**type**\:  :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                            
                                                                                            .. attribute:: user_name_regex
                                                                                            
                                                                                            	User Name Regular Expression
                                                                                            	**type**\:  :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                            
                                                                                            .. attribute:: auth_username
                                                                                            
                                                                                            	Authenticated User Name
                                                                                            	**type**\:  :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                            
                                                                                            .. attribute:: auth_username_regex
                                                                                            
                                                                                            	Authenticated User Name RegEx
                                                                                            	**type**\:  :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_username
                                                                                            
                                                                                            	Unauthenticated User Name
                                                                                            	**type**\:  :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                            
                                                                                            .. attribute:: unauth_username_regex
                                                                                            
                                                                                            	Unauthenticated User Name RegEx
                                                                                            	**type**\:  :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: auth_domain
                                                                                            
                                                                                            	Authenticated domain name
                                                                                            	**type**\:  :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                            
                                                                                            .. attribute:: auth_domain_regex
                                                                                            
                                                                                            	Authenticated Domain Name RegEx
                                                                                            	**type**\:  :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_domain
                                                                                            
                                                                                            	Unauthenticated Domain Name
                                                                                            	**type**\:  :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                            
                                                                                            .. attribute:: unauth_domain_regex
                                                                                            
                                                                                            	Unauthenticated Domain Name RegEx
                                                                                            	**type**\:  :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: vendor_id
                                                                                            
                                                                                            	Vendor ID
                                                                                            	**type**\:  :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                            
                                                                                            .. attribute:: vendor_id_regex
                                                                                            
                                                                                            	Vendor ID RegEx
                                                                                            	**type**\:  :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                            
                                                                                            .. attribute:: access_interface
                                                                                            
                                                                                            	Access interface
                                                                                            	**type**\:  :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                            
                                                                                            .. attribute:: input_interface
                                                                                            
                                                                                            	Input interface
                                                                                            	**type**\:  :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                            
                                                                                            .. attribute:: input_intfhdl
                                                                                            
                                                                                            	Input interface handle
                                                                                            	**type**\:  :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                            
                                                                                            .. attribute:: ethertype
                                                                                            
                                                                                            	Ethernet type
                                                                                            	**type**\:  :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                            
                                                                                            .. attribute:: flow_key_data
                                                                                            
                                                                                            	Flow key structure
                                                                                            	**type**\:  :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id
                                                                                            
                                                                                            	Dhcp Client ID
                                                                                            	**type**\:  :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id_regex
                                                                                            
                                                                                            	Dhcp Client ID RegEx
                                                                                            	**type**\:  :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                            
                                                                                            .. attribute:: circuit_id
                                                                                            
                                                                                            	Circuit ID
                                                                                            	**type**\:  :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                            
                                                                                            .. attribute:: circuit_id_regex
                                                                                            
                                                                                            	Circuit ID RegEx
                                                                                            	**type**\:  :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                            
                                                                                            .. attribute:: remote_id
                                                                                            
                                                                                            	Remote ID
                                                                                            	**type**\:  :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                            
                                                                                            .. attribute:: remote_id_regex
                                                                                            
                                                                                            	Remote ID RegEx
                                                                                            	**type**\:  :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                            
                                                                                            .. attribute:: src_port
                                                                                            
                                                                                            	Source port
                                                                                            	**type**\:  :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                            
                                                                                            .. attribute:: dst_port
                                                                                            
                                                                                            	Destination port
                                                                                            	**type**\:  :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	type
                                                                                            	**type**\:  :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                            
                                                                                            .. attribute:: mpls_top_eos
                                                                                            
                                                                                            	MPLS Topmost EOS
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: fragment_type
                                                                                            
                                                                                            	Fragment type
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: authen_status
                                                                                            
                                                                                            	Authentication Status
                                                                                            	**type**\:  :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                            
                                                                                            .. attribute:: mlp_negotiated
                                                                                            
                                                                                            	MLP Negotiated
                                                                                            	**type**\:  :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                                self.yang_name = "match-data"
                                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("ipv4-dscp", ("ipv4_dscp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp)), ("ipv6-dscp", ("ipv6_dscp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp)), ("dscp", ("dscp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp)), ("ipv4-prec", ("ipv4_prec", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec)), ("ipv6-prec", ("ipv6_prec", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec)), ("prec", ("prec", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec)), ("discard-class", ("discard_class", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass)), ("qos-group", ("qos_group", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup)), ("traffic-class", ("traffic_class", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass)), ("proto", ("proto", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto)), ("icmp-v4", ("icmp_v4", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4)), ("icmp-v6", ("icmp_v6", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6)), ("ipv4-packet-len", ("ipv4_packet_len", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen)), ("ipv6-packet-len", ("ipv6_packet_len", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen)), ("packet-len", ("packet_len", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen)), ("flow-tag", ("flow_tag", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag)), ("tcp-flag", ("tcp_flag", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag)), ("icmpv4-type", ("icmpv4_type", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type)), ("icmpv4-code", ("icmpv4_code", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code)), ("icmpv6-type", ("icmpv6_type", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type)), ("icmpv6-code", ("icmpv6_code", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code)), ("mpls-exp", ("mpls_exp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp)), ("mpls-exp-imp", ("mpls_exp_imp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp)), ("mpls-disp-ipv4-acl", ("mpls_disp_ipv4_acl", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl)), ("mpls-disp-ipv6-acl", ("mpls_disp_ipv6_acl", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl)), ("mpls-top-label", ("mpls_top_label", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel)), ("cos", ("cos", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos)), ("cos-inr", ("cos_inr", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr)), ("dei", ("dei", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei)), ("dei-inr", ("dei_inr", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr)), ("vlan", ("vlan", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan)), ("vlan-inr", ("vlan_inr", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)), ("fr-dlci", ("fr_dlci", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci)), ("src-mac", ("src_mac", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac)), ("dst-mac", ("dst_mac", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac)), ("atm-clp", ("atm_clp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp)), ("fr-de", ("fr_de", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe)), ("ipv4-acl", ("ipv4_acl", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl)), ("ipv6-acl", ("ipv6_acl", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl)), ("ether-service-acl", ("ether_service_acl", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl)), ("avail-id", ("avail_id", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId)), ("media-type", ("media_type", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType)), ("subs-protocol", ("subs_protocol", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol)), ("dnis", ("dnis", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis)), ("dnis-regex", ("dnis_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex)), ("domain", ("domain", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain)), ("domain-regex", ("domain_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex)), ("nas-port", ("nas_port", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort)), ("service-name", ("service_name", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName)), ("service-name-regex", ("service_name_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex)), ("src-addr-ipv4", ("src_addr_ipv4", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4)), ("dst-addr-ipv4", ("dst_addr_ipv4", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4)), ("src-addr-ipv6", ("src_addr_ipv6", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6)), ("dst-addr-ipv6", ("dst_addr_ipv6", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6)), ("src-addr-mac", ("src_addr_mac", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac)), ("timer", ("timer", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer)), ("timer-regexp", ("timer_regexp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp)), ("tunnel-name", ("tunnel_name", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName)), ("tunnel-name-regex", ("tunnel_name_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex)), ("user-name", ("user_name", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName)), ("user-name-regex", ("user_name_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex)), ("auth-username", ("auth_username", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername)), ("auth-username-regex", ("auth_username_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex)), ("unauth-username", ("unauth_username", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername)), ("unauth-username-regex", ("unauth_username_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex)), ("auth-domain", ("auth_domain", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain)), ("auth-domain-regex", ("auth_domain_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex)), ("unauth-domain", ("unauth_domain", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain)), ("unauth-domain-regex", ("unauth_domain_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex)), ("vendor-id", ("vendor_id", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId)), ("vendor-id-regex", ("vendor_id_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex)), ("access-interface", ("access_interface", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface)), ("input-interface", ("input_interface", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface)), ("input-intfhdl", ("input_intfhdl", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl)), ("ethertype", ("ethertype", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype)), ("flow-key-data", ("flow_key_data", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData)), ("dhcp-client-id", ("dhcp_client_id", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId)), ("dhcp-client-id-regex", ("dhcp_client_id_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex)), ("circuit-id", ("circuit_id", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId)), ("circuit-id-regex", ("circuit_id_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex)), ("remote-id", ("remote_id", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId)), ("remote-id-regex", ("remote_id_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex)), ("src-port", ("src_port", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort)), ("dst-port", ("dst_port", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort))])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchTypeEn', '')])),
                                                                                                    ('mpls_top_eos', (YLeaf(YType.uint8, 'mpls-top-eos'), ['int'])),
                                                                                                    ('fragment_type', (YLeaf(YType.uint8, 'fragment-type'), ['int'])),
                                                                                                    ('authen_status', (YLeaf(YType.enumeration, 'authen-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchAuthenStatusEn', '')])),
                                                                                                    ('mlp_negotiated', (YLeaf(YType.enumeration, 'mlp-negotiated'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchMlpNegotiatedEn', '')])),
                                                                                                ])
                                                                                                self.type = None
                                                                                                self.mpls_top_eos = None
                                                                                                self.fragment_type = None
                                                                                                self.authen_status = None
                                                                                                self.mlp_negotiated = None

                                                                                                self.ipv4_dscp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                                self.ipv4_dscp.parent = self
                                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"

                                                                                                self.ipv6_dscp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                                self.ipv6_dscp.parent = self
                                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"

                                                                                                self.dscp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                                self.dscp.parent = self
                                                                                                self._children_name_map["dscp"] = "dscp"

                                                                                                self.ipv4_prec = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                                self.ipv4_prec.parent = self
                                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"

                                                                                                self.ipv6_prec = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                                self.ipv6_prec.parent = self
                                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"

                                                                                                self.prec = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                                self.prec.parent = self
                                                                                                self._children_name_map["prec"] = "prec"

                                                                                                self.discard_class = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                                self.discard_class.parent = self
                                                                                                self._children_name_map["discard_class"] = "discard-class"

                                                                                                self.qos_group = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                                self.qos_group.parent = self
                                                                                                self._children_name_map["qos_group"] = "qos-group"

                                                                                                self.traffic_class = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                                self.traffic_class.parent = self
                                                                                                self._children_name_map["traffic_class"] = "traffic-class"

                                                                                                self.proto = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                                self.proto.parent = self
                                                                                                self._children_name_map["proto"] = "proto"

                                                                                                self.icmp_v4 = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                                self.icmp_v4.parent = self
                                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"

                                                                                                self.icmp_v6 = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                                self.icmp_v6.parent = self
                                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"

                                                                                                self.ipv4_packet_len = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                                self.ipv4_packet_len.parent = self
                                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"

                                                                                                self.ipv6_packet_len = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                                self.ipv6_packet_len.parent = self
                                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"

                                                                                                self.packet_len = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                                self.packet_len.parent = self
                                                                                                self._children_name_map["packet_len"] = "packet-len"

                                                                                                self.flow_tag = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                                self.flow_tag.parent = self
                                                                                                self._children_name_map["flow_tag"] = "flow-tag"

                                                                                                self.tcp_flag = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                                self.tcp_flag.parent = self
                                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"

                                                                                                self.icmpv4_type = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                                self.icmpv4_type.parent = self
                                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"

                                                                                                self.icmpv4_code = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                                self.icmpv4_code.parent = self
                                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"

                                                                                                self.icmpv6_type = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                                self.icmpv6_type.parent = self
                                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"

                                                                                                self.icmpv6_code = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                                self.icmpv6_code.parent = self
                                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"

                                                                                                self.mpls_exp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                                self.mpls_exp.parent = self
                                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"

                                                                                                self.mpls_exp_imp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                                self.mpls_exp_imp.parent = self
                                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"

                                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"

                                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"

                                                                                                self.mpls_top_label = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                                self.mpls_top_label.parent = self
                                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"

                                                                                                self.cos = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                                self.cos.parent = self
                                                                                                self._children_name_map["cos"] = "cos"

                                                                                                self.cos_inr = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                                self.cos_inr.parent = self
                                                                                                self._children_name_map["cos_inr"] = "cos-inr"

                                                                                                self.dei = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                                self.dei.parent = self
                                                                                                self._children_name_map["dei"] = "dei"

                                                                                                self.dei_inr = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                                self.dei_inr.parent = self
                                                                                                self._children_name_map["dei_inr"] = "dei-inr"

                                                                                                self.vlan = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                                self.vlan.parent = self
                                                                                                self._children_name_map["vlan"] = "vlan"

                                                                                                self.vlan_inr = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                                self.vlan_inr.parent = self
                                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"

                                                                                                self.fr_dlci = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                                self.fr_dlci.parent = self
                                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"

                                                                                                self.src_mac = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                                self.src_mac.parent = self
                                                                                                self._children_name_map["src_mac"] = "src-mac"

                                                                                                self.dst_mac = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                                self.dst_mac.parent = self
                                                                                                self._children_name_map["dst_mac"] = "dst-mac"

                                                                                                self.atm_clp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                                self.atm_clp.parent = self
                                                                                                self._children_name_map["atm_clp"] = "atm-clp"

                                                                                                self.fr_de = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                                self.fr_de.parent = self
                                                                                                self._children_name_map["fr_de"] = "fr-de"

                                                                                                self.ipv4_acl = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                                self.ipv4_acl.parent = self
                                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"

                                                                                                self.ipv6_acl = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                                self.ipv6_acl.parent = self
                                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"

                                                                                                self.ether_service_acl = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                                self.ether_service_acl.parent = self
                                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"

                                                                                                self.avail_id = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                                self.avail_id.parent = self
                                                                                                self._children_name_map["avail_id"] = "avail-id"

                                                                                                self.media_type = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                                self.media_type.parent = self
                                                                                                self._children_name_map["media_type"] = "media-type"

                                                                                                self.subs_protocol = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                                self.subs_protocol.parent = self
                                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"

                                                                                                self.dnis = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                                self.dnis.parent = self
                                                                                                self._children_name_map["dnis"] = "dnis"

                                                                                                self.dnis_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                                self.dnis_regex.parent = self
                                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"

                                                                                                self.domain = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                                self.domain.parent = self
                                                                                                self._children_name_map["domain"] = "domain"

                                                                                                self.domain_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                                self.domain_regex.parent = self
                                                                                                self._children_name_map["domain_regex"] = "domain-regex"

                                                                                                self.nas_port = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                                self.nas_port.parent = self
                                                                                                self._children_name_map["nas_port"] = "nas-port"

                                                                                                self.service_name = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                                self.service_name.parent = self
                                                                                                self._children_name_map["service_name"] = "service-name"

                                                                                                self.service_name_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                                self.service_name_regex.parent = self
                                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"

                                                                                                self.src_addr_ipv4 = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                                self.src_addr_ipv4.parent = self
                                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"

                                                                                                self.dst_addr_ipv4 = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                                self.dst_addr_ipv4.parent = self
                                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"

                                                                                                self.src_addr_ipv6 = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                                self.src_addr_ipv6.parent = self
                                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"

                                                                                                self.dst_addr_ipv6 = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                                self.dst_addr_ipv6.parent = self
                                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"

                                                                                                self.src_addr_mac = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                                self.src_addr_mac.parent = self
                                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"

                                                                                                self.timer = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                                self.timer.parent = self
                                                                                                self._children_name_map["timer"] = "timer"

                                                                                                self.timer_regexp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                                self.timer_regexp.parent = self
                                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"

                                                                                                self.tunnel_name = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                                self.tunnel_name.parent = self
                                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"

                                                                                                self.tunnel_name_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                                self.tunnel_name_regex.parent = self
                                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"

                                                                                                self.user_name = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                                self.user_name.parent = self
                                                                                                self._children_name_map["user_name"] = "user-name"

                                                                                                self.user_name_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                                self.user_name_regex.parent = self
                                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"

                                                                                                self.auth_username = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                                self.auth_username.parent = self
                                                                                                self._children_name_map["auth_username"] = "auth-username"

                                                                                                self.auth_username_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                                self.auth_username_regex.parent = self
                                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"

                                                                                                self.unauth_username = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                                self.unauth_username.parent = self
                                                                                                self._children_name_map["unauth_username"] = "unauth-username"

                                                                                                self.unauth_username_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                                self.unauth_username_regex.parent = self
                                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"

                                                                                                self.auth_domain = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                                self.auth_domain.parent = self
                                                                                                self._children_name_map["auth_domain"] = "auth-domain"

                                                                                                self.auth_domain_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                                self.auth_domain_regex.parent = self
                                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"

                                                                                                self.unauth_domain = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                                self.unauth_domain.parent = self
                                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"

                                                                                                self.unauth_domain_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                                self.unauth_domain_regex.parent = self
                                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"

                                                                                                self.vendor_id = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                                self.vendor_id.parent = self
                                                                                                self._children_name_map["vendor_id"] = "vendor-id"

                                                                                                self.vendor_id_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                                self.vendor_id_regex.parent = self
                                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"

                                                                                                self.access_interface = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                                self.access_interface.parent = self
                                                                                                self._children_name_map["access_interface"] = "access-interface"

                                                                                                self.input_interface = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                                self.input_interface.parent = self
                                                                                                self._children_name_map["input_interface"] = "input-interface"

                                                                                                self.input_intfhdl = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                                self.input_intfhdl.parent = self
                                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"

                                                                                                self.ethertype = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                                self.ethertype.parent = self
                                                                                                self._children_name_map["ethertype"] = "ethertype"

                                                                                                self.flow_key_data = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                                self.flow_key_data.parent = self
                                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"

                                                                                                self.dhcp_client_id = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                                self.dhcp_client_id.parent = self
                                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"

                                                                                                self.dhcp_client_id_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                                self.dhcp_client_id_regex.parent = self
                                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"

                                                                                                self.circuit_id = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                                self.circuit_id.parent = self
                                                                                                self._children_name_map["circuit_id"] = "circuit-id"

                                                                                                self.circuit_id_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                                self.circuit_id_regex.parent = self
                                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"

                                                                                                self.remote_id = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                                self.remote_id.parent = self
                                                                                                self._children_name_map["remote_id"] = "remote-id"

                                                                                                self.remote_id_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                                self.remote_id_regex.parent = self
                                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"

                                                                                                self.src_port = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                                self.src_port.parent = self
                                                                                                self._children_name_map["src_port"] = "src-port"

                                                                                                self.dst_port = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                                self.dst_port.parent = self
                                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                                self._segment_path = lambda: "match-data"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['type', 'mpls_top_eos', 'fragment_type', 'authen_status', 'mlp_negotiated'], name, value)


                                                                                            class Ipv4Dscp(Entity):
                                                                                                """
                                                                                                IPv4 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv4-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv6Dscp(Entity):
                                                                                                """
                                                                                                IPv6 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv6-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Dscp(Entity):
                                                                                                """
                                                                                                Match DSCP range array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                    self.yang_name = "dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv4Prec(Entity):
                                                                                                """
                                                                                                IPv4 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                    self.yang_name = "ipv4-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "ipv4-prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                            class Ipv6Prec(Entity):
                                                                                                """
                                                                                                IPv6 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                    self.yang_name = "ipv6-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "ipv6-prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                            class Prec(Entity):
                                                                                                """
                                                                                                Match Precedence array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                    self.yang_name = "prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                            class DiscardClass(Entity):
                                                                                                """
                                                                                                Match Discard Class array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                    self.yang_name = "discard-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "discard-class"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                            class QosGroup(Entity):
                                                                                                """
                                                                                                Match QoS group array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                    self.yang_name = "qos-group"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "qos-group"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "qos-group"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class TrafficClass(Entity):
                                                                                                """
                                                                                                Match Traffic class array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                    self.yang_name = "traffic-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "traffic-class"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "traffic-class"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Proto(Entity):
                                                                                                """
                                                                                                Match Protocol array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                    self.yang_name = "proto"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "proto"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "proto"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class IcmpV4(Entity):
                                                                                                """
                                                                                                Match ICMPV4 Protocol
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                    self.yang_name = "icmp-v4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                    ])
                                                                                                    self.type = None
                                                                                                    self.code = None
                                                                                                    self._segment_path = lambda: "icmp-v4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['type', 'code'], name, value)


                                                                                            class IcmpV6(Entity):
                                                                                                """
                                                                                                Match ICMPV6 Protocol array
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                    self.yang_name = "icmp-v6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                    ])
                                                                                                    self.type = None
                                                                                                    self.code = None
                                                                                                    self._segment_path = lambda: "icmp-v6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['type', 'code'], name, value)


                                                                                            class Ipv4PacketLen(Entity):
                                                                                                """
                                                                                                IPv4 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv6PacketLen(Entity):
                                                                                                """
                                                                                                IPv6 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class PacketLen(Entity):
                                                                                                """
                                                                                                Match packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                    self.yang_name = "packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FlowTag(Entity):
                                                                                                """
                                                                                                Match flow\-tag array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                    self.yang_name = "flow-tag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "flow-tag"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "flow-tag"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class TcpFlag(Entity):
                                                                                                """
                                                                                                Match tcp flag value
                                                                                                
                                                                                                .. attribute:: value
                                                                                                
                                                                                                	Value of TCP flag
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: match_any
                                                                                                
                                                                                                	Match any TCP flag bit
                                                                                                	**type**\: bool
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                    self.yang_name = "tcp-flag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                                        ('match_any', (YLeaf(YType.boolean, 'match-any'), ['bool'])),
                                                                                                    ])
                                                                                                    self.value = None
                                                                                                    self.match_any = None
                                                                                                    self._segment_path = lambda: "tcp-flag"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['value', 'match_any'], name, value)


                                                                                            class Icmpv4Type(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                    self.yang_name = "icmpv4-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv4Code(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                    self.yang_name = "icmpv4-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-code"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv6Type(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                    self.yang_name = "icmpv6-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv6Code(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                    self.yang_name = "icmpv6-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-code"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class MplsExp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental topmost array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "mpls-exp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                            class MplsExpImp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental imposition array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "mpls-exp-imp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                            class MplsDispIpv4Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                            class MplsDispIpv6Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                            class MplsTopLabel(Entity):
                                                                                                """
                                                                                                MPLS Topmost LABEL
                                                                                                
                                                                                                .. attribute:: uint32_rng_array
                                                                                                
                                                                                                	uint32 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                    self.yang_name = "mpls-top-label"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint32_rng_array", ("uint32_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint32_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "mpls-top-label"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                                class Uint32RngArray(Entity):
                                                                                                    """
                                                                                                    uint32 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                        self.yang_name = "uint32_rng_array"
                                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint32, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint32, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint32_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['min', 'max'], name, value)


                                                                                            class Cos(Entity):
                                                                                                """
                                                                                                Match CoS array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                    self.yang_name = "cos"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "cos"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                            class CosInr(Entity):
                                                                                                """
                                                                                                Match inner header CoS
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                    self.yang_name = "cos-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "cos-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                            class Dei(Entity):
                                                                                                """
                                                                                                Match DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                    self.yang_name = "dei"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                    ])
                                                                                                    self.bit_value = None
                                                                                                    self._segment_path = lambda: "dei"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                            class DeiInr(Entity):
                                                                                                """
                                                                                                Match inner DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                    self.yang_name = "dei-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                    ])
                                                                                                    self.bit_value = None
                                                                                                    self._segment_path = lambda: "dei-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                            class Vlan(Entity):
                                                                                                """
                                                                                                Match VLAN array
                                                                                                
                                                                                                .. attribute:: vlan_id_array
                                                                                                
                                                                                                	vlan id array
                                                                                                	**type**\: list of  		 :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                    self.yang_name = "vlan"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("vlan-id-array", ("vlan_id_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.vlan_id_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                                class VlanIdArray(Entity):
                                                                                                    """
                                                                                                    vlan id array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	VLAN mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                        self.yang_name = "vlan-id-array"
                                                                                                        self.yang_parent_name = "vlan"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ('mask', (YLeaf(YType.uint16, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "vlan-id-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['min', 'max', 'mask'], name, value)


                                                                                            class VlanInr(Entity):
                                                                                                """
                                                                                                Match inner header VLAN range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                    self.yang_name = "vlan-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FrDlci(Entity):
                                                                                                """
                                                                                                Match FR DLCI range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                    self.yang_name = "fr-dlci"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "fr-dlci"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class SrcMac(Entity):
                                                                                                """
                                                                                                Match Source MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                    self.yang_name = "src-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.mac_addr = []
                                                                                                    self.mask = []
                                                                                                    self._segment_path = lambda: "src-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                            class DstMac(Entity):
                                                                                                """
                                                                                                Match Destination MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                    self.yang_name = "dst-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.mac_addr = []
                                                                                                    self.mask = []
                                                                                                    self._segment_path = lambda: "dst-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                            class AtmClp(Entity):
                                                                                                """
                                                                                                Match ATM CLP level
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                    self.yang_name = "atm-clp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "atm-clp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                            class FrDe(Entity):
                                                                                                """
                                                                                                Match FR DE value
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                    self.yang_name = "fr-de"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "fr-de"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                            class Ipv4Acl(Entity):
                                                                                                """
                                                                                                IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                    self.yang_name = "ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ipv4-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                            class Ipv6Acl(Entity):
                                                                                                """
                                                                                                IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                    self.yang_name = "ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ipv6-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                            class EtherServiceAcl(Entity):
                                                                                                """
                                                                                                Ethernet\-Services Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                    self.yang_name = "ether-service-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ether-service-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                            class AvailId(Entity):
                                                                                                """
                                                                                                Available Identifiers
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                    self.yang_name = "avail-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "avail-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                            class MediaType(Entity):
                                                                                                """
                                                                                                Media Type
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                    self.yang_name = "media-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "media-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                            class SubsProtocol(Entity):
                                                                                                """
                                                                                                Protocol
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                    self.yang_name = "subs-protocol"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "subs-protocol"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                            class Dnis(Entity):
                                                                                                """
                                                                                                DNIS
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                    self.yang_name = "dnis"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dnis"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                            class DnisRegex(Entity):
                                                                                                """
                                                                                                DNIS Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                    self.yang_name = "dnis-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dnis-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                            class Domain(Entity):
                                                                                                """
                                                                                                Domain Name
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                    self.yang_name = "domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                        ])
                                                                                                        self.domain_name = None
                                                                                                        self.format_name = None
                                                                                                        self._segment_path = lambda: "domain-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class DomainRegex(Entity):
                                                                                                """
                                                                                                Domain Regular Expression
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                    self.yang_name = "domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain-regex"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                        ])
                                                                                                        self.domain_name = None
                                                                                                        self.format_name = None
                                                                                                        self._segment_path = lambda: "domain-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class NasPort(Entity):
                                                                                                """
                                                                                                NAS Port
                                                                                                
                                                                                                .. attribute:: nas_port_array
                                                                                                
                                                                                                	nas port array
                                                                                                	**type**\: list of  		 :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                    self.yang_name = "nas-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("nas-port-array", ("nas_port_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.nas_port_array = YList(self)
                                                                                                    self._segment_path = lambda: "nas-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                                class NasPortArray(Entity):
                                                                                                    """
                                                                                                    nas port array
                                                                                                    
                                                                                                    .. attribute:: sub_id
                                                                                                    
                                                                                                    	sub id
                                                                                                    	**type**\:  :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                    
                                                                                                    .. attribute:: operator
                                                                                                    
                                                                                                    	operator
                                                                                                    	**type**\:  :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	value
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                        self.yang_name = "nas-port-array"
                                                                                                        self.yang_parent_name = "nas-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('sub_id', (YLeaf(YType.enumeration, 'sub-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchNasPortSubIdEn', '')])),
                                                                                                            ('operator', (YLeaf(YType.enumeration, 'operator'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchLogicalOperatorEn', '')])),
                                                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                                        ])
                                                                                                        self.sub_id = None
                                                                                                        self.operator = None
                                                                                                        self.value = None
                                                                                                        self._segment_path = lambda: "nas-port-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['sub_id', 'operator', 'value'], name, value)


                                                                                            class ServiceName(Entity):
                                                                                                """
                                                                                                Service Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                    self.yang_name = "service-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "service-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                            class ServiceNameRegex(Entity):
                                                                                                """
                                                                                                Service Name Regular Exp
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                    self.yang_name = "service-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "service-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                            class SrcAddrIpv4(Entity):
                                                                                                """
                                                                                                Source Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class DstAddrIpv4(Entity):
                                                                                                """
                                                                                                Destination Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class SrcAddrIpv6(Entity):
                                                                                                """
                                                                                                Source Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class DstAddrIpv6(Entity):
                                                                                                """
                                                                                                Destination Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class SrcAddrMac(Entity):
                                                                                                """
                                                                                                Source Address MAC
                                                                                                
                                                                                                .. attribute:: mac_addr_array
                                                                                                
                                                                                                	mac addr array
                                                                                                	**type**\: list of  		 :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                    self.yang_name = "src-addr-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("mac-addr-array", ("mac_addr_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.mac_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                                class MacAddrArray(Entity):
                                                                                                    """
                                                                                                    mac addr array
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                        self.yang_name = "mac-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                            ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.mac_addr = []
                                                                                                        self.mask = []
                                                                                                        self._segment_path = lambda: "mac-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                            class Timer(Entity):
                                                                                                """
                                                                                                Timer
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                    self.yang_name = "timer"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "timer"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                            class TimerRegexp(Entity):
                                                                                                """
                                                                                                Timer Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                    self.yang_name = "timer-regexp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "timer-regexp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                            class TunnelName(Entity):
                                                                                                """
                                                                                                Tunnel Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                    self.yang_name = "tunnel-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "tunnel-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                            class TunnelNameRegex(Entity):
                                                                                                """
                                                                                                Tunnel Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "tunnel-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                            class UserName(Entity):
                                                                                                """
                                                                                                User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                    self.yang_name = "user-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "user-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                            class UserNameRegex(Entity):
                                                                                                """
                                                                                                User Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                    self.yang_name = "user-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "user-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                            class AuthUsername(Entity):
                                                                                                """
                                                                                                Authenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                    self.yang_name = "auth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-username"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                            class AuthUsernameRegex(Entity):
                                                                                                """
                                                                                                Authenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "auth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-username-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                            class UnauthUsername(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                    self.yang_name = "unauth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-username"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                            class UnauthUsernameRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-username-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                            class AuthDomain(Entity):
                                                                                                """
                                                                                                Authenticated domain name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                    self.yang_name = "auth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                            class AuthDomainRegex(Entity):
                                                                                                """
                                                                                                Authenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "auth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                            class UnauthDomain(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                    self.yang_name = "unauth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                            class UnauthDomainRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                            class VendorId(Entity):
                                                                                                """
                                                                                                Vendor ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                    self.yang_name = "vendor-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "vendor-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                            class VendorIdRegex(Entity):
                                                                                                """
                                                                                                Vendor ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                    self.yang_name = "vendor-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "vendor-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                            class AccessInterface(Entity):
                                                                                                """
                                                                                                Access interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                    self.yang_name = "access-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "access-interface"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                            class InputInterface(Entity):
                                                                                                """
                                                                                                Input interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                    self.yang_name = "input-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "input-interface"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                            class InputIntfhdl(Entity):
                                                                                                """
                                                                                                Input interface handle
                                                                                                
                                                                                                .. attribute:: uint64_array
                                                                                                
                                                                                                	uint64 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..18446744073709551615
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                    self.yang_name = "input-intfhdl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint64_array', (YLeafList(YType.uint64, 'uint64_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint64_array = []
                                                                                                    self._segment_path = lambda: "input-intfhdl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                            class Ethertype(Entity):
                                                                                                """
                                                                                                Ethernet type
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                    self.yang_name = "ethertype"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ethertype"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ethertype"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FlowKeyData(Entity):
                                                                                                """
                                                                                                Flow key structure
                                                                                                
                                                                                                .. attribute:: flow_keys
                                                                                                
                                                                                                	flow keys
                                                                                                	**type**\:  :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                                
                                                                                                .. attribute:: max_count
                                                                                                
                                                                                                	Maximum count of flows
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: idle_timeout
                                                                                                
                                                                                                	Idle timeout of flows (in seconds)
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                	**units**\: second
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                    self.yang_name = "flow-key-data"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("flow-keys", ("flow_keys", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys))])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('max_count', (YLeaf(YType.uint16, 'max-count'), ['int'])),
                                                                                                        ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                                                    ])
                                                                                                    self.max_count = None
                                                                                                    self.idle_timeout = None

                                                                                                    self.flow_keys = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                    self.flow_keys.parent = self
                                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                    self._segment_path = lambda: "flow-key-data"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['max_count', 'idle_timeout'], name, value)


                                                                                                class FlowKeys(Entity):
                                                                                                    """
                                                                                                    flow keys
                                                                                                    
                                                                                                    .. attribute:: keys
                                                                                                    
                                                                                                    	keys
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                    
                                                                                                    .. attribute:: num
                                                                                                    
                                                                                                    	num
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                        self.yang_name = "flow-keys"
                                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('keys', (YLeaf(YType.str, 'keys'), ['str'])),
                                                                                                            ('num', (YLeaf(YType.uint8, 'num'), ['int'])),
                                                                                                        ])
                                                                                                        self.keys = None
                                                                                                        self.num = None
                                                                                                        self._segment_path = lambda: "flow-keys"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                            class DhcpClientId(Entity):
                                                                                                """
                                                                                                Dhcp Client ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dhcp-client-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                            class DhcpClientIdRegex(Entity):
                                                                                                """
                                                                                                Dhcp Client ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                            class CircuitId(Entity):
                                                                                                """
                                                                                                Circuit ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                    self.yang_name = "circuit-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "circuit-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                            class CircuitIdRegex(Entity):
                                                                                                """
                                                                                                Circuit ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                    self.yang_name = "circuit-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "circuit-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                            class RemoteId(Entity):
                                                                                                """
                                                                                                Remote ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                    self.yang_name = "remote-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "remote-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                            class RemoteIdRegex(Entity):
                                                                                                """
                                                                                                Remote ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                    self.yang_name = "remote-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "remote-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                            class SrcPort(Entity):
                                                                                                """
                                                                                                Source port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                    self.yang_name = "src-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "src-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class DstPort(Entity):
                                                                                                """
                                                                                                Destination port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                    self.yang_name = "dst-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "dst-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                        class ExcdclassEncode(Entity):
                                                                            """
                                                                            excdclass encode
                                                                            
                                                                            .. attribute:: inline_cmap
                                                                            
                                                                            	inline cmap
                                                                            	**type**\:  :py:class:`InlineCmap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap>`
                                                                            
                                                                            .. attribute:: enc
                                                                            
                                                                            	enc
                                                                            	**type**\:  :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                            
                                                                            .. attribute:: class_name
                                                                            
                                                                            	class name
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..65
                                                                            
                                                                            .. attribute:: hd
                                                                            
                                                                            	hd
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: idx
                                                                            
                                                                            	idx
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode, self).__init__()

                                                                                self.yang_name = "excdclass-encode"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("inline-cmap", ("inline_cmap", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('enc', (YLeaf(YType.enumeration, 'enc'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyObjEncEn', '')])),
                                                                                    ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                                                    ('hd', (YLeaf(YType.uint64, 'hd'), ['int'])),
                                                                                    ('idx', (YLeaf(YType.uint8, 'idx'), ['int'])),
                                                                                ])
                                                                                self.enc = None
                                                                                self.class_name = None
                                                                                self.hd = None
                                                                                self.idx = None

                                                                                self.inline_cmap = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap()
                                                                                self.inline_cmap.parent = self
                                                                                self._children_name_map["inline_cmap"] = "inline-cmap"
                                                                                self._segment_path = lambda: "excdclass-encode"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode, ['enc', 'class_name', 'hd', 'idx'], name, value)


                                                                            class InlineCmap(Entity):
                                                                                """
                                                                                inline cmap
                                                                                
                                                                                .. attribute:: match_infop
                                                                                
                                                                                	Pointer to the first Match info
                                                                                	**type**\:  :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop>`
                                                                                
                                                                                .. attribute:: mode
                                                                                
                                                                                	Inline Class\-Map Mode Match any/all
                                                                                	**type**\:  :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                                
                                                                                .. attribute:: flags
                                                                                
                                                                                	Inline Class\-Map flags
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: match_count
                                                                                
                                                                                	Number of Match infos
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap, self).__init__()

                                                                                    self.yang_name = "inline-cmap"
                                                                                    self.yang_parent_name = "excdclass-encode"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("match-infop", ("match_infop", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapModeEn', '')])),
                                                                                        ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                        ('match_count', (YLeaf(YType.uint32, 'match-count'), ['int'])),
                                                                                    ])
                                                                                    self.mode = None
                                                                                    self.flags = None
                                                                                    self.match_count = None

                                                                                    self.match_infop = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop()
                                                                                    self.match_infop.parent = self
                                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                                    self._segment_path = lambda: "inline-cmap"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap, ['mode', 'flags', 'match_count'], name, value)


                                                                                class MatchInfop(Entity):
                                                                                    """
                                                                                    Pointer to the first Match info
                                                                                    
                                                                                    .. attribute:: class_match_info_st
                                                                                    
                                                                                    	class match info st
                                                                                    	**type**\: list of  		 :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop, self).__init__()

                                                                                        self.yang_name = "match-infop"
                                                                                        self.yang_parent_name = "inline-cmap"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("class-match-info-st", ("class_match_info_st", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.class_match_info_st = YList(self)
                                                                                        self._segment_path = lambda: "match-infop"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop, [], name, value)


                                                                                    class ClassMatchInfoSt(Entity):
                                                                                        """
                                                                                        class match info st
                                                                                        
                                                                                        .. attribute:: match_data
                                                                                        
                                                                                        	Match criteria
                                                                                        	**type**\:  :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                        
                                                                                        .. attribute:: flags
                                                                                        
                                                                                        	Flags
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                            self.yang_name = "class-match-info-st"
                                                                                            self.yang_parent_name = "match-infop"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("match-data", ("match_data", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData))])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                            ])
                                                                                            self.flags = None

                                                                                            self.match_data = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                            self.match_data.parent = self
                                                                                            self._children_name_map["match_data"] = "match-data"
                                                                                            self._segment_path = lambda: "class-match-info-st"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                        class MatchData(Entity):
                                                                                            """
                                                                                            Match criteria
                                                                                            
                                                                                            .. attribute:: ipv4_dscp
                                                                                            
                                                                                            	IPv4 DSCP
                                                                                            	**type**\:  :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv6_dscp
                                                                                            
                                                                                            	IPv6 DSCP
                                                                                            	**type**\:  :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                            
                                                                                            .. attribute:: dscp
                                                                                            
                                                                                            	Match DSCP range array
                                                                                            	**type**\:  :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv4_prec
                                                                                            
                                                                                            	IPv4 Precedence
                                                                                            	**type**\:  :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                            
                                                                                            .. attribute:: ipv6_prec
                                                                                            
                                                                                            	IPv6 Precedence
                                                                                            	**type**\:  :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                            
                                                                                            .. attribute:: prec
                                                                                            
                                                                                            	Match Precedence array
                                                                                            	**type**\:  :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                            
                                                                                            .. attribute:: discard_class
                                                                                            
                                                                                            	Match Discard Class array
                                                                                            	**type**\:  :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                            
                                                                                            .. attribute:: qos_group
                                                                                            
                                                                                            	Match QoS group array
                                                                                            	**type**\:  :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                            
                                                                                            .. attribute:: traffic_class
                                                                                            
                                                                                            	Match Traffic class array
                                                                                            	**type**\:  :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                            
                                                                                            .. attribute:: proto
                                                                                            
                                                                                            	Match Protocol array
                                                                                            	**type**\:  :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                            
                                                                                            .. attribute:: icmp_v4
                                                                                            
                                                                                            	Match ICMPV4 Protocol
                                                                                            	**type**\:  :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                            
                                                                                            .. attribute:: icmp_v6
                                                                                            
                                                                                            	Match ICMPV6 Protocol array
                                                                                            	**type**\:  :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                            
                                                                                            .. attribute:: ipv4_packet_len
                                                                                            
                                                                                            	IPv4 packet length array
                                                                                            	**type**\:  :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv6_packet_len
                                                                                            
                                                                                            	IPv6 packet length array
                                                                                            	**type**\:  :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                            
                                                                                            .. attribute:: packet_len
                                                                                            
                                                                                            	Match packet length array
                                                                                            	**type**\:  :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                            
                                                                                            .. attribute:: flow_tag
                                                                                            
                                                                                            	Match flow\-tag array
                                                                                            	**type**\:  :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                            
                                                                                            .. attribute:: tcp_flag
                                                                                            
                                                                                            	Match tcp flag value
                                                                                            	**type**\:  :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                            
                                                                                            .. attribute:: icmpv4_type
                                                                                            
                                                                                            	Match ipv4 icmp type
                                                                                            	**type**\:  :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                            
                                                                                            .. attribute:: icmpv4_code
                                                                                            
                                                                                            	Match ipv4 icmp code
                                                                                            	**type**\:  :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                            
                                                                                            .. attribute:: icmpv6_type
                                                                                            
                                                                                            	Match ipv6 icmp type
                                                                                            	**type**\:  :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                            
                                                                                            .. attribute:: icmpv6_code
                                                                                            
                                                                                            	Match ipv6 icmp code
                                                                                            	**type**\:  :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                            
                                                                                            .. attribute:: mpls_exp
                                                                                            
                                                                                            	Match MPLS experimental topmost array
                                                                                            	**type**\:  :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                            
                                                                                            .. attribute:: mpls_exp_imp
                                                                                            
                                                                                            	Match MPLS experimental imposition array
                                                                                            	**type**\:  :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                                            
                                                                                            	MPLS Disposition IPv4 Access\-list
                                                                                            	**type**\:  :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                                            
                                                                                            	MPLS Disposition IPv6 Access\-list
                                                                                            	**type**\:  :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_top_label
                                                                                            
                                                                                            	MPLS Topmost LABEL
                                                                                            	**type**\:  :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                            
                                                                                            .. attribute:: cos
                                                                                            
                                                                                            	Match CoS array
                                                                                            	**type**\:  :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                            
                                                                                            .. attribute:: cos_inr
                                                                                            
                                                                                            	Match inner header CoS
                                                                                            	**type**\:  :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                            
                                                                                            .. attribute:: dei
                                                                                            
                                                                                            	Match DEI Bit
                                                                                            	**type**\:  :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                            
                                                                                            .. attribute:: dei_inr
                                                                                            
                                                                                            	Match inner DEI Bit
                                                                                            	**type**\:  :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                            
                                                                                            .. attribute:: vlan
                                                                                            
                                                                                            	Match VLAN array
                                                                                            	**type**\:  :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                            
                                                                                            .. attribute:: vlan_inr
                                                                                            
                                                                                            	Match inner header VLAN range array
                                                                                            	**type**\:  :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                            
                                                                                            .. attribute:: fr_dlci
                                                                                            
                                                                                            	Match FR DLCI range array
                                                                                            	**type**\:  :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                            
                                                                                            .. attribute:: src_mac
                                                                                            
                                                                                            	Match Source MAC address
                                                                                            	**type**\:  :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                            
                                                                                            .. attribute:: dst_mac
                                                                                            
                                                                                            	Match Destination MAC address
                                                                                            	**type**\:  :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                            
                                                                                            .. attribute:: atm_clp
                                                                                            
                                                                                            	Match ATM CLP level
                                                                                            	**type**\:  :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                            
                                                                                            .. attribute:: fr_de
                                                                                            
                                                                                            	Match FR DE value
                                                                                            	**type**\:  :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                            
                                                                                            .. attribute:: ipv4_acl
                                                                                            
                                                                                            	IPv4 Access\-list
                                                                                            	**type**\:  :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                            
                                                                                            .. attribute:: ipv6_acl
                                                                                            
                                                                                            	IPv6 Access\-list
                                                                                            	**type**\:  :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                            
                                                                                            .. attribute:: ether_service_acl
                                                                                            
                                                                                            	Ethernet\-Services Access\-list
                                                                                            	**type**\:  :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                            
                                                                                            .. attribute:: avail_id
                                                                                            
                                                                                            	Available Identifiers
                                                                                            	**type**\:  :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                            
                                                                                            .. attribute:: media_type
                                                                                            
                                                                                            	Media Type
                                                                                            	**type**\:  :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                            
                                                                                            .. attribute:: subs_protocol
                                                                                            
                                                                                            	Protocol
                                                                                            	**type**\:  :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                            
                                                                                            .. attribute:: dnis
                                                                                            
                                                                                            	DNIS
                                                                                            	**type**\:  :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                            
                                                                                            .. attribute:: dnis_regex
                                                                                            
                                                                                            	DNIS Regular Expression
                                                                                            	**type**\:  :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                            
                                                                                            .. attribute:: domain
                                                                                            
                                                                                            	Domain Name
                                                                                            	**type**\:  :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                            
                                                                                            .. attribute:: domain_regex
                                                                                            
                                                                                            	Domain Regular Expression
                                                                                            	**type**\:  :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                            
                                                                                            .. attribute:: nas_port
                                                                                            
                                                                                            	NAS Port
                                                                                            	**type**\:  :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                            
                                                                                            .. attribute:: service_name
                                                                                            
                                                                                            	Service Name
                                                                                            	**type**\:  :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                            
                                                                                            .. attribute:: service_name_regex
                                                                                            
                                                                                            	Service Name Regular Exp
                                                                                            	**type**\:  :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv4
                                                                                            
                                                                                            	Source Address IPV4
                                                                                            	**type**\:  :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv4
                                                                                            
                                                                                            	Destination Address IPV4
                                                                                            	**type**\:  :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv6
                                                                                            
                                                                                            	Source Address IPV6
                                                                                            	**type**\:  :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv6
                                                                                            
                                                                                            	Destination Address IPV6
                                                                                            	**type**\:  :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: src_addr_mac
                                                                                            
                                                                                            	Source Address MAC
                                                                                            	**type**\:  :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                            
                                                                                            .. attribute:: timer
                                                                                            
                                                                                            	Timer
                                                                                            	**type**\:  :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                            
                                                                                            .. attribute:: timer_regexp
                                                                                            
                                                                                            	Timer Regular Expression
                                                                                            	**type**\:  :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                            
                                                                                            .. attribute:: tunnel_name
                                                                                            
                                                                                            	Tunnel Name
                                                                                            	**type**\:  :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                            
                                                                                            .. attribute:: tunnel_name_regex
                                                                                            
                                                                                            	Tunnel Name Regular Expression
                                                                                            	**type**\:  :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                            
                                                                                            .. attribute:: user_name
                                                                                            
                                                                                            	User Name
                                                                                            	**type**\:  :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                            
                                                                                            .. attribute:: user_name_regex
                                                                                            
                                                                                            	User Name Regular Expression
                                                                                            	**type**\:  :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                            
                                                                                            .. attribute:: auth_username
                                                                                            
                                                                                            	Authenticated User Name
                                                                                            	**type**\:  :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                            
                                                                                            .. attribute:: auth_username_regex
                                                                                            
                                                                                            	Authenticated User Name RegEx
                                                                                            	**type**\:  :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_username
                                                                                            
                                                                                            	Unauthenticated User Name
                                                                                            	**type**\:  :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                            
                                                                                            .. attribute:: unauth_username_regex
                                                                                            
                                                                                            	Unauthenticated User Name RegEx
                                                                                            	**type**\:  :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: auth_domain
                                                                                            
                                                                                            	Authenticated domain name
                                                                                            	**type**\:  :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                            
                                                                                            .. attribute:: auth_domain_regex
                                                                                            
                                                                                            	Authenticated Domain Name RegEx
                                                                                            	**type**\:  :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_domain
                                                                                            
                                                                                            	Unauthenticated Domain Name
                                                                                            	**type**\:  :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                            
                                                                                            .. attribute:: unauth_domain_regex
                                                                                            
                                                                                            	Unauthenticated Domain Name RegEx
                                                                                            	**type**\:  :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: vendor_id
                                                                                            
                                                                                            	Vendor ID
                                                                                            	**type**\:  :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                            
                                                                                            .. attribute:: vendor_id_regex
                                                                                            
                                                                                            	Vendor ID RegEx
                                                                                            	**type**\:  :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                            
                                                                                            .. attribute:: access_interface
                                                                                            
                                                                                            	Access interface
                                                                                            	**type**\:  :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                            
                                                                                            .. attribute:: input_interface
                                                                                            
                                                                                            	Input interface
                                                                                            	**type**\:  :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                            
                                                                                            .. attribute:: input_intfhdl
                                                                                            
                                                                                            	Input interface handle
                                                                                            	**type**\:  :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                            
                                                                                            .. attribute:: ethertype
                                                                                            
                                                                                            	Ethernet type
                                                                                            	**type**\:  :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                            
                                                                                            .. attribute:: flow_key_data
                                                                                            
                                                                                            	Flow key structure
                                                                                            	**type**\:  :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id
                                                                                            
                                                                                            	Dhcp Client ID
                                                                                            	**type**\:  :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id_regex
                                                                                            
                                                                                            	Dhcp Client ID RegEx
                                                                                            	**type**\:  :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                            
                                                                                            .. attribute:: circuit_id
                                                                                            
                                                                                            	Circuit ID
                                                                                            	**type**\:  :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                            
                                                                                            .. attribute:: circuit_id_regex
                                                                                            
                                                                                            	Circuit ID RegEx
                                                                                            	**type**\:  :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                            
                                                                                            .. attribute:: remote_id
                                                                                            
                                                                                            	Remote ID
                                                                                            	**type**\:  :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                            
                                                                                            .. attribute:: remote_id_regex
                                                                                            
                                                                                            	Remote ID RegEx
                                                                                            	**type**\:  :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                            
                                                                                            .. attribute:: src_port
                                                                                            
                                                                                            	Source port
                                                                                            	**type**\:  :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                            
                                                                                            .. attribute:: dst_port
                                                                                            
                                                                                            	Destination port
                                                                                            	**type**\:  :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	type
                                                                                            	**type**\:  :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                            
                                                                                            .. attribute:: mpls_top_eos
                                                                                            
                                                                                            	MPLS Topmost EOS
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: fragment_type
                                                                                            
                                                                                            	Fragment type
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: authen_status
                                                                                            
                                                                                            	Authentication Status
                                                                                            	**type**\:  :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                            
                                                                                            .. attribute:: mlp_negotiated
                                                                                            
                                                                                            	MLP Negotiated
                                                                                            	**type**\:  :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                                self.yang_name = "match-data"
                                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("ipv4-dscp", ("ipv4_dscp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp)), ("ipv6-dscp", ("ipv6_dscp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp)), ("dscp", ("dscp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp)), ("ipv4-prec", ("ipv4_prec", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec)), ("ipv6-prec", ("ipv6_prec", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec)), ("prec", ("prec", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec)), ("discard-class", ("discard_class", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass)), ("qos-group", ("qos_group", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup)), ("traffic-class", ("traffic_class", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass)), ("proto", ("proto", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto)), ("icmp-v4", ("icmp_v4", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4)), ("icmp-v6", ("icmp_v6", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6)), ("ipv4-packet-len", ("ipv4_packet_len", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen)), ("ipv6-packet-len", ("ipv6_packet_len", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen)), ("packet-len", ("packet_len", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen)), ("flow-tag", ("flow_tag", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag)), ("tcp-flag", ("tcp_flag", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag)), ("icmpv4-type", ("icmpv4_type", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type)), ("icmpv4-code", ("icmpv4_code", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code)), ("icmpv6-type", ("icmpv6_type", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type)), ("icmpv6-code", ("icmpv6_code", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code)), ("mpls-exp", ("mpls_exp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp)), ("mpls-exp-imp", ("mpls_exp_imp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp)), ("mpls-disp-ipv4-acl", ("mpls_disp_ipv4_acl", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl)), ("mpls-disp-ipv6-acl", ("mpls_disp_ipv6_acl", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl)), ("mpls-top-label", ("mpls_top_label", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel)), ("cos", ("cos", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos)), ("cos-inr", ("cos_inr", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr)), ("dei", ("dei", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei)), ("dei-inr", ("dei_inr", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr)), ("vlan", ("vlan", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan)), ("vlan-inr", ("vlan_inr", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)), ("fr-dlci", ("fr_dlci", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci)), ("src-mac", ("src_mac", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac)), ("dst-mac", ("dst_mac", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac)), ("atm-clp", ("atm_clp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp)), ("fr-de", ("fr_de", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe)), ("ipv4-acl", ("ipv4_acl", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl)), ("ipv6-acl", ("ipv6_acl", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl)), ("ether-service-acl", ("ether_service_acl", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl)), ("avail-id", ("avail_id", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId)), ("media-type", ("media_type", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType)), ("subs-protocol", ("subs_protocol", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol)), ("dnis", ("dnis", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis)), ("dnis-regex", ("dnis_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex)), ("domain", ("domain", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain)), ("domain-regex", ("domain_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex)), ("nas-port", ("nas_port", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort)), ("service-name", ("service_name", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName)), ("service-name-regex", ("service_name_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex)), ("src-addr-ipv4", ("src_addr_ipv4", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4)), ("dst-addr-ipv4", ("dst_addr_ipv4", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4)), ("src-addr-ipv6", ("src_addr_ipv6", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6)), ("dst-addr-ipv6", ("dst_addr_ipv6", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6)), ("src-addr-mac", ("src_addr_mac", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac)), ("timer", ("timer", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer)), ("timer-regexp", ("timer_regexp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp)), ("tunnel-name", ("tunnel_name", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName)), ("tunnel-name-regex", ("tunnel_name_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex)), ("user-name", ("user_name", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName)), ("user-name-regex", ("user_name_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex)), ("auth-username", ("auth_username", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername)), ("auth-username-regex", ("auth_username_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex)), ("unauth-username", ("unauth_username", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername)), ("unauth-username-regex", ("unauth_username_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex)), ("auth-domain", ("auth_domain", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain)), ("auth-domain-regex", ("auth_domain_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex)), ("unauth-domain", ("unauth_domain", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain)), ("unauth-domain-regex", ("unauth_domain_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex)), ("vendor-id", ("vendor_id", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId)), ("vendor-id-regex", ("vendor_id_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex)), ("access-interface", ("access_interface", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface)), ("input-interface", ("input_interface", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface)), ("input-intfhdl", ("input_intfhdl", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl)), ("ethertype", ("ethertype", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype)), ("flow-key-data", ("flow_key_data", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData)), ("dhcp-client-id", ("dhcp_client_id", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId)), ("dhcp-client-id-regex", ("dhcp_client_id_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex)), ("circuit-id", ("circuit_id", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId)), ("circuit-id-regex", ("circuit_id_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex)), ("remote-id", ("remote_id", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId)), ("remote-id-regex", ("remote_id_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex)), ("src-port", ("src_port", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort)), ("dst-port", ("dst_port", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort))])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchTypeEn', '')])),
                                                                                                    ('mpls_top_eos', (YLeaf(YType.uint8, 'mpls-top-eos'), ['int'])),
                                                                                                    ('fragment_type', (YLeaf(YType.uint8, 'fragment-type'), ['int'])),
                                                                                                    ('authen_status', (YLeaf(YType.enumeration, 'authen-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchAuthenStatusEn', '')])),
                                                                                                    ('mlp_negotiated', (YLeaf(YType.enumeration, 'mlp-negotiated'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchMlpNegotiatedEn', '')])),
                                                                                                ])
                                                                                                self.type = None
                                                                                                self.mpls_top_eos = None
                                                                                                self.fragment_type = None
                                                                                                self.authen_status = None
                                                                                                self.mlp_negotiated = None

                                                                                                self.ipv4_dscp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                                self.ipv4_dscp.parent = self
                                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"

                                                                                                self.ipv6_dscp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                                self.ipv6_dscp.parent = self
                                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"

                                                                                                self.dscp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                                self.dscp.parent = self
                                                                                                self._children_name_map["dscp"] = "dscp"

                                                                                                self.ipv4_prec = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                                self.ipv4_prec.parent = self
                                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"

                                                                                                self.ipv6_prec = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                                self.ipv6_prec.parent = self
                                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"

                                                                                                self.prec = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                                self.prec.parent = self
                                                                                                self._children_name_map["prec"] = "prec"

                                                                                                self.discard_class = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                                self.discard_class.parent = self
                                                                                                self._children_name_map["discard_class"] = "discard-class"

                                                                                                self.qos_group = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                                self.qos_group.parent = self
                                                                                                self._children_name_map["qos_group"] = "qos-group"

                                                                                                self.traffic_class = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                                self.traffic_class.parent = self
                                                                                                self._children_name_map["traffic_class"] = "traffic-class"

                                                                                                self.proto = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                                self.proto.parent = self
                                                                                                self._children_name_map["proto"] = "proto"

                                                                                                self.icmp_v4 = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                                self.icmp_v4.parent = self
                                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"

                                                                                                self.icmp_v6 = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                                self.icmp_v6.parent = self
                                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"

                                                                                                self.ipv4_packet_len = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                                self.ipv4_packet_len.parent = self
                                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"

                                                                                                self.ipv6_packet_len = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                                self.ipv6_packet_len.parent = self
                                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"

                                                                                                self.packet_len = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                                self.packet_len.parent = self
                                                                                                self._children_name_map["packet_len"] = "packet-len"

                                                                                                self.flow_tag = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                                self.flow_tag.parent = self
                                                                                                self._children_name_map["flow_tag"] = "flow-tag"

                                                                                                self.tcp_flag = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                                self.tcp_flag.parent = self
                                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"

                                                                                                self.icmpv4_type = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                                self.icmpv4_type.parent = self
                                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"

                                                                                                self.icmpv4_code = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                                self.icmpv4_code.parent = self
                                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"

                                                                                                self.icmpv6_type = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                                self.icmpv6_type.parent = self
                                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"

                                                                                                self.icmpv6_code = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                                self.icmpv6_code.parent = self
                                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"

                                                                                                self.mpls_exp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                                self.mpls_exp.parent = self
                                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"

                                                                                                self.mpls_exp_imp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                                self.mpls_exp_imp.parent = self
                                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"

                                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"

                                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"

                                                                                                self.mpls_top_label = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                                self.mpls_top_label.parent = self
                                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"

                                                                                                self.cos = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                                self.cos.parent = self
                                                                                                self._children_name_map["cos"] = "cos"

                                                                                                self.cos_inr = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                                self.cos_inr.parent = self
                                                                                                self._children_name_map["cos_inr"] = "cos-inr"

                                                                                                self.dei = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                                self.dei.parent = self
                                                                                                self._children_name_map["dei"] = "dei"

                                                                                                self.dei_inr = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                                self.dei_inr.parent = self
                                                                                                self._children_name_map["dei_inr"] = "dei-inr"

                                                                                                self.vlan = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                                self.vlan.parent = self
                                                                                                self._children_name_map["vlan"] = "vlan"

                                                                                                self.vlan_inr = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                                self.vlan_inr.parent = self
                                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"

                                                                                                self.fr_dlci = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                                self.fr_dlci.parent = self
                                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"

                                                                                                self.src_mac = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                                self.src_mac.parent = self
                                                                                                self._children_name_map["src_mac"] = "src-mac"

                                                                                                self.dst_mac = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                                self.dst_mac.parent = self
                                                                                                self._children_name_map["dst_mac"] = "dst-mac"

                                                                                                self.atm_clp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                                self.atm_clp.parent = self
                                                                                                self._children_name_map["atm_clp"] = "atm-clp"

                                                                                                self.fr_de = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                                self.fr_de.parent = self
                                                                                                self._children_name_map["fr_de"] = "fr-de"

                                                                                                self.ipv4_acl = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                                self.ipv4_acl.parent = self
                                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"

                                                                                                self.ipv6_acl = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                                self.ipv6_acl.parent = self
                                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"

                                                                                                self.ether_service_acl = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                                self.ether_service_acl.parent = self
                                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"

                                                                                                self.avail_id = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                                self.avail_id.parent = self
                                                                                                self._children_name_map["avail_id"] = "avail-id"

                                                                                                self.media_type = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                                self.media_type.parent = self
                                                                                                self._children_name_map["media_type"] = "media-type"

                                                                                                self.subs_protocol = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                                self.subs_protocol.parent = self
                                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"

                                                                                                self.dnis = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                                self.dnis.parent = self
                                                                                                self._children_name_map["dnis"] = "dnis"

                                                                                                self.dnis_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                                self.dnis_regex.parent = self
                                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"

                                                                                                self.domain = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                                self.domain.parent = self
                                                                                                self._children_name_map["domain"] = "domain"

                                                                                                self.domain_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                                self.domain_regex.parent = self
                                                                                                self._children_name_map["domain_regex"] = "domain-regex"

                                                                                                self.nas_port = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                                self.nas_port.parent = self
                                                                                                self._children_name_map["nas_port"] = "nas-port"

                                                                                                self.service_name = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                                self.service_name.parent = self
                                                                                                self._children_name_map["service_name"] = "service-name"

                                                                                                self.service_name_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                                self.service_name_regex.parent = self
                                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"

                                                                                                self.src_addr_ipv4 = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                                self.src_addr_ipv4.parent = self
                                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"

                                                                                                self.dst_addr_ipv4 = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                                self.dst_addr_ipv4.parent = self
                                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"

                                                                                                self.src_addr_ipv6 = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                                self.src_addr_ipv6.parent = self
                                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"

                                                                                                self.dst_addr_ipv6 = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                                self.dst_addr_ipv6.parent = self
                                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"

                                                                                                self.src_addr_mac = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                                self.src_addr_mac.parent = self
                                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"

                                                                                                self.timer = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                                self.timer.parent = self
                                                                                                self._children_name_map["timer"] = "timer"

                                                                                                self.timer_regexp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                                self.timer_regexp.parent = self
                                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"

                                                                                                self.tunnel_name = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                                self.tunnel_name.parent = self
                                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"

                                                                                                self.tunnel_name_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                                self.tunnel_name_regex.parent = self
                                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"

                                                                                                self.user_name = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                                self.user_name.parent = self
                                                                                                self._children_name_map["user_name"] = "user-name"

                                                                                                self.user_name_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                                self.user_name_regex.parent = self
                                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"

                                                                                                self.auth_username = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                                self.auth_username.parent = self
                                                                                                self._children_name_map["auth_username"] = "auth-username"

                                                                                                self.auth_username_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                                self.auth_username_regex.parent = self
                                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"

                                                                                                self.unauth_username = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                                self.unauth_username.parent = self
                                                                                                self._children_name_map["unauth_username"] = "unauth-username"

                                                                                                self.unauth_username_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                                self.unauth_username_regex.parent = self
                                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"

                                                                                                self.auth_domain = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                                self.auth_domain.parent = self
                                                                                                self._children_name_map["auth_domain"] = "auth-domain"

                                                                                                self.auth_domain_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                                self.auth_domain_regex.parent = self
                                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"

                                                                                                self.unauth_domain = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                                self.unauth_domain.parent = self
                                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"

                                                                                                self.unauth_domain_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                                self.unauth_domain_regex.parent = self
                                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"

                                                                                                self.vendor_id = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                                self.vendor_id.parent = self
                                                                                                self._children_name_map["vendor_id"] = "vendor-id"

                                                                                                self.vendor_id_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                                self.vendor_id_regex.parent = self
                                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"

                                                                                                self.access_interface = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                                self.access_interface.parent = self
                                                                                                self._children_name_map["access_interface"] = "access-interface"

                                                                                                self.input_interface = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                                self.input_interface.parent = self
                                                                                                self._children_name_map["input_interface"] = "input-interface"

                                                                                                self.input_intfhdl = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                                self.input_intfhdl.parent = self
                                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"

                                                                                                self.ethertype = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                                self.ethertype.parent = self
                                                                                                self._children_name_map["ethertype"] = "ethertype"

                                                                                                self.flow_key_data = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                                self.flow_key_data.parent = self
                                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"

                                                                                                self.dhcp_client_id = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                                self.dhcp_client_id.parent = self
                                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"

                                                                                                self.dhcp_client_id_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                                self.dhcp_client_id_regex.parent = self
                                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"

                                                                                                self.circuit_id = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                                self.circuit_id.parent = self
                                                                                                self._children_name_map["circuit_id"] = "circuit-id"

                                                                                                self.circuit_id_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                                self.circuit_id_regex.parent = self
                                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"

                                                                                                self.remote_id = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                                self.remote_id.parent = self
                                                                                                self._children_name_map["remote_id"] = "remote-id"

                                                                                                self.remote_id_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                                self.remote_id_regex.parent = self
                                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"

                                                                                                self.src_port = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                                self.src_port.parent = self
                                                                                                self._children_name_map["src_port"] = "src-port"

                                                                                                self.dst_port = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                                self.dst_port.parent = self
                                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                                self._segment_path = lambda: "match-data"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, ['type', 'mpls_top_eos', 'fragment_type', 'authen_status', 'mlp_negotiated'], name, value)


                                                                                            class Ipv4Dscp(Entity):
                                                                                                """
                                                                                                IPv4 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv4-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv6Dscp(Entity):
                                                                                                """
                                                                                                IPv6 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv6-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Dscp(Entity):
                                                                                                """
                                                                                                Match DSCP range array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                    self.yang_name = "dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv4Prec(Entity):
                                                                                                """
                                                                                                IPv4 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                    self.yang_name = "ipv4-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "ipv4-prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                            class Ipv6Prec(Entity):
                                                                                                """
                                                                                                IPv6 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                    self.yang_name = "ipv6-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "ipv6-prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                            class Prec(Entity):
                                                                                                """
                                                                                                Match Precedence array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                    self.yang_name = "prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                            class DiscardClass(Entity):
                                                                                                """
                                                                                                Match Discard Class array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                    self.yang_name = "discard-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "discard-class"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                            class QosGroup(Entity):
                                                                                                """
                                                                                                Match QoS group array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                    self.yang_name = "qos-group"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "qos-group"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "qos-group"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class TrafficClass(Entity):
                                                                                                """
                                                                                                Match Traffic class array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                    self.yang_name = "traffic-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "traffic-class"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "traffic-class"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Proto(Entity):
                                                                                                """
                                                                                                Match Protocol array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                    self.yang_name = "proto"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "proto"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "proto"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class IcmpV4(Entity):
                                                                                                """
                                                                                                Match ICMPV4 Protocol
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                    self.yang_name = "icmp-v4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                    ])
                                                                                                    self.type = None
                                                                                                    self.code = None
                                                                                                    self._segment_path = lambda: "icmp-v4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['type', 'code'], name, value)


                                                                                            class IcmpV6(Entity):
                                                                                                """
                                                                                                Match ICMPV6 Protocol array
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                    self.yang_name = "icmp-v6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                    ])
                                                                                                    self.type = None
                                                                                                    self.code = None
                                                                                                    self._segment_path = lambda: "icmp-v6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['type', 'code'], name, value)


                                                                                            class Ipv4PacketLen(Entity):
                                                                                                """
                                                                                                IPv4 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv6PacketLen(Entity):
                                                                                                """
                                                                                                IPv6 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class PacketLen(Entity):
                                                                                                """
                                                                                                Match packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                    self.yang_name = "packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FlowTag(Entity):
                                                                                                """
                                                                                                Match flow\-tag array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                    self.yang_name = "flow-tag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "flow-tag"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "flow-tag"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class TcpFlag(Entity):
                                                                                                """
                                                                                                Match tcp flag value
                                                                                                
                                                                                                .. attribute:: value
                                                                                                
                                                                                                	Value of TCP flag
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: match_any
                                                                                                
                                                                                                	Match any TCP flag bit
                                                                                                	**type**\: bool
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                    self.yang_name = "tcp-flag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                                        ('match_any', (YLeaf(YType.boolean, 'match-any'), ['bool'])),
                                                                                                    ])
                                                                                                    self.value = None
                                                                                                    self.match_any = None
                                                                                                    self._segment_path = lambda: "tcp-flag"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['value', 'match_any'], name, value)


                                                                                            class Icmpv4Type(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                    self.yang_name = "icmpv4-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv4Code(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                    self.yang_name = "icmpv4-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-code"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv6Type(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                    self.yang_name = "icmpv6-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv6Code(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                    self.yang_name = "icmpv6-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-code"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class MplsExp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental topmost array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "mpls-exp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                            class MplsExpImp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental imposition array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "mpls-exp-imp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                            class MplsDispIpv4Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                            class MplsDispIpv6Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                            class MplsTopLabel(Entity):
                                                                                                """
                                                                                                MPLS Topmost LABEL
                                                                                                
                                                                                                .. attribute:: uint32_rng_array
                                                                                                
                                                                                                	uint32 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                    self.yang_name = "mpls-top-label"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint32_rng_array", ("uint32_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint32_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "mpls-top-label"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                                class Uint32RngArray(Entity):
                                                                                                    """
                                                                                                    uint32 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                        self.yang_name = "uint32_rng_array"
                                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint32, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint32, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint32_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['min', 'max'], name, value)


                                                                                            class Cos(Entity):
                                                                                                """
                                                                                                Match CoS array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                    self.yang_name = "cos"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "cos"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                            class CosInr(Entity):
                                                                                                """
                                                                                                Match inner header CoS
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                    self.yang_name = "cos-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "cos-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                            class Dei(Entity):
                                                                                                """
                                                                                                Match DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                    self.yang_name = "dei"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                    ])
                                                                                                    self.bit_value = None
                                                                                                    self._segment_path = lambda: "dei"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                            class DeiInr(Entity):
                                                                                                """
                                                                                                Match inner DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                    self.yang_name = "dei-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                    ])
                                                                                                    self.bit_value = None
                                                                                                    self._segment_path = lambda: "dei-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                            class Vlan(Entity):
                                                                                                """
                                                                                                Match VLAN array
                                                                                                
                                                                                                .. attribute:: vlan_id_array
                                                                                                
                                                                                                	vlan id array
                                                                                                	**type**\: list of  		 :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                    self.yang_name = "vlan"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("vlan-id-array", ("vlan_id_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.vlan_id_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                                class VlanIdArray(Entity):
                                                                                                    """
                                                                                                    vlan id array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	VLAN mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                        self.yang_name = "vlan-id-array"
                                                                                                        self.yang_parent_name = "vlan"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ('mask', (YLeaf(YType.uint16, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "vlan-id-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['min', 'max', 'mask'], name, value)


                                                                                            class VlanInr(Entity):
                                                                                                """
                                                                                                Match inner header VLAN range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                    self.yang_name = "vlan-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FrDlci(Entity):
                                                                                                """
                                                                                                Match FR DLCI range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                    self.yang_name = "fr-dlci"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "fr-dlci"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class SrcMac(Entity):
                                                                                                """
                                                                                                Match Source MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                    self.yang_name = "src-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.mac_addr = []
                                                                                                    self.mask = []
                                                                                                    self._segment_path = lambda: "src-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                            class DstMac(Entity):
                                                                                                """
                                                                                                Match Destination MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                    self.yang_name = "dst-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.mac_addr = []
                                                                                                    self.mask = []
                                                                                                    self._segment_path = lambda: "dst-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                            class AtmClp(Entity):
                                                                                                """
                                                                                                Match ATM CLP level
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                    self.yang_name = "atm-clp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "atm-clp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                            class FrDe(Entity):
                                                                                                """
                                                                                                Match FR DE value
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                    self.yang_name = "fr-de"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "fr-de"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                            class Ipv4Acl(Entity):
                                                                                                """
                                                                                                IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                    self.yang_name = "ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ipv4-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                            class Ipv6Acl(Entity):
                                                                                                """
                                                                                                IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                    self.yang_name = "ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ipv6-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                            class EtherServiceAcl(Entity):
                                                                                                """
                                                                                                Ethernet\-Services Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                    self.yang_name = "ether-service-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ether-service-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                            class AvailId(Entity):
                                                                                                """
                                                                                                Available Identifiers
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                    self.yang_name = "avail-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "avail-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                            class MediaType(Entity):
                                                                                                """
                                                                                                Media Type
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                    self.yang_name = "media-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "media-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                            class SubsProtocol(Entity):
                                                                                                """
                                                                                                Protocol
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                    self.yang_name = "subs-protocol"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "subs-protocol"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                            class Dnis(Entity):
                                                                                                """
                                                                                                DNIS
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                    self.yang_name = "dnis"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dnis"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                            class DnisRegex(Entity):
                                                                                                """
                                                                                                DNIS Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                    self.yang_name = "dnis-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dnis-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                            class Domain(Entity):
                                                                                                """
                                                                                                Domain Name
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                    self.yang_name = "domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                        ])
                                                                                                        self.domain_name = None
                                                                                                        self.format_name = None
                                                                                                        self._segment_path = lambda: "domain-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class DomainRegex(Entity):
                                                                                                """
                                                                                                Domain Regular Expression
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                    self.yang_name = "domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain-regex"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                        ])
                                                                                                        self.domain_name = None
                                                                                                        self.format_name = None
                                                                                                        self._segment_path = lambda: "domain-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class NasPort(Entity):
                                                                                                """
                                                                                                NAS Port
                                                                                                
                                                                                                .. attribute:: nas_port_array
                                                                                                
                                                                                                	nas port array
                                                                                                	**type**\: list of  		 :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                    self.yang_name = "nas-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("nas-port-array", ("nas_port_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.nas_port_array = YList(self)
                                                                                                    self._segment_path = lambda: "nas-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                                class NasPortArray(Entity):
                                                                                                    """
                                                                                                    nas port array
                                                                                                    
                                                                                                    .. attribute:: sub_id
                                                                                                    
                                                                                                    	sub id
                                                                                                    	**type**\:  :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                    
                                                                                                    .. attribute:: operator
                                                                                                    
                                                                                                    	operator
                                                                                                    	**type**\:  :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	value
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                        self.yang_name = "nas-port-array"
                                                                                                        self.yang_parent_name = "nas-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('sub_id', (YLeaf(YType.enumeration, 'sub-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchNasPortSubIdEn', '')])),
                                                                                                            ('operator', (YLeaf(YType.enumeration, 'operator'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchLogicalOperatorEn', '')])),
                                                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                                        ])
                                                                                                        self.sub_id = None
                                                                                                        self.operator = None
                                                                                                        self.value = None
                                                                                                        self._segment_path = lambda: "nas-port-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['sub_id', 'operator', 'value'], name, value)


                                                                                            class ServiceName(Entity):
                                                                                                """
                                                                                                Service Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                    self.yang_name = "service-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "service-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                            class ServiceNameRegex(Entity):
                                                                                                """
                                                                                                Service Name Regular Exp
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                    self.yang_name = "service-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "service-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                            class SrcAddrIpv4(Entity):
                                                                                                """
                                                                                                Source Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class DstAddrIpv4(Entity):
                                                                                                """
                                                                                                Destination Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class SrcAddrIpv6(Entity):
                                                                                                """
                                                                                                Source Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class DstAddrIpv6(Entity):
                                                                                                """
                                                                                                Destination Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class SrcAddrMac(Entity):
                                                                                                """
                                                                                                Source Address MAC
                                                                                                
                                                                                                .. attribute:: mac_addr_array
                                                                                                
                                                                                                	mac addr array
                                                                                                	**type**\: list of  		 :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                    self.yang_name = "src-addr-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("mac-addr-array", ("mac_addr_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.mac_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                                class MacAddrArray(Entity):
                                                                                                    """
                                                                                                    mac addr array
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                        self.yang_name = "mac-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                            ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.mac_addr = []
                                                                                                        self.mask = []
                                                                                                        self._segment_path = lambda: "mac-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                            class Timer(Entity):
                                                                                                """
                                                                                                Timer
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                    self.yang_name = "timer"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "timer"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                            class TimerRegexp(Entity):
                                                                                                """
                                                                                                Timer Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                    self.yang_name = "timer-regexp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "timer-regexp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                            class TunnelName(Entity):
                                                                                                """
                                                                                                Tunnel Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                    self.yang_name = "tunnel-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "tunnel-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                            class TunnelNameRegex(Entity):
                                                                                                """
                                                                                                Tunnel Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "tunnel-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                            class UserName(Entity):
                                                                                                """
                                                                                                User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                    self.yang_name = "user-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "user-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                            class UserNameRegex(Entity):
                                                                                                """
                                                                                                User Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                    self.yang_name = "user-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "user-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                            class AuthUsername(Entity):
                                                                                                """
                                                                                                Authenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                    self.yang_name = "auth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-username"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                            class AuthUsernameRegex(Entity):
                                                                                                """
                                                                                                Authenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "auth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-username-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                            class UnauthUsername(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                    self.yang_name = "unauth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-username"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                            class UnauthUsernameRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-username-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                            class AuthDomain(Entity):
                                                                                                """
                                                                                                Authenticated domain name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                    self.yang_name = "auth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                            class AuthDomainRegex(Entity):
                                                                                                """
                                                                                                Authenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "auth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                            class UnauthDomain(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                    self.yang_name = "unauth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                            class UnauthDomainRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                            class VendorId(Entity):
                                                                                                """
                                                                                                Vendor ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                    self.yang_name = "vendor-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "vendor-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                            class VendorIdRegex(Entity):
                                                                                                """
                                                                                                Vendor ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                    self.yang_name = "vendor-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "vendor-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                            class AccessInterface(Entity):
                                                                                                """
                                                                                                Access interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                    self.yang_name = "access-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "access-interface"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                            class InputInterface(Entity):
                                                                                                """
                                                                                                Input interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                    self.yang_name = "input-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "input-interface"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                            class InputIntfhdl(Entity):
                                                                                                """
                                                                                                Input interface handle
                                                                                                
                                                                                                .. attribute:: uint64_array
                                                                                                
                                                                                                	uint64 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..18446744073709551615
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                    self.yang_name = "input-intfhdl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint64_array', (YLeafList(YType.uint64, 'uint64_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint64_array = []
                                                                                                    self._segment_path = lambda: "input-intfhdl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                            class Ethertype(Entity):
                                                                                                """
                                                                                                Ethernet type
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                    self.yang_name = "ethertype"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ethertype"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ethertype"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FlowKeyData(Entity):
                                                                                                """
                                                                                                Flow key structure
                                                                                                
                                                                                                .. attribute:: flow_keys
                                                                                                
                                                                                                	flow keys
                                                                                                	**type**\:  :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                                
                                                                                                .. attribute:: max_count
                                                                                                
                                                                                                	Maximum count of flows
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: idle_timeout
                                                                                                
                                                                                                	Idle timeout of flows (in seconds)
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                	**units**\: second
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                    self.yang_name = "flow-key-data"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("flow-keys", ("flow_keys", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys))])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('max_count', (YLeaf(YType.uint16, 'max-count'), ['int'])),
                                                                                                        ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                                                    ])
                                                                                                    self.max_count = None
                                                                                                    self.idle_timeout = None

                                                                                                    self.flow_keys = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                    self.flow_keys.parent = self
                                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                    self._segment_path = lambda: "flow-key-data"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['max_count', 'idle_timeout'], name, value)


                                                                                                class FlowKeys(Entity):
                                                                                                    """
                                                                                                    flow keys
                                                                                                    
                                                                                                    .. attribute:: keys
                                                                                                    
                                                                                                    	keys
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                    
                                                                                                    .. attribute:: num
                                                                                                    
                                                                                                    	num
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                        self.yang_name = "flow-keys"
                                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('keys', (YLeaf(YType.str, 'keys'), ['str'])),
                                                                                                            ('num', (YLeaf(YType.uint8, 'num'), ['int'])),
                                                                                                        ])
                                                                                                        self.keys = None
                                                                                                        self.num = None
                                                                                                        self._segment_path = lambda: "flow-keys"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                            class DhcpClientId(Entity):
                                                                                                """
                                                                                                Dhcp Client ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dhcp-client-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                            class DhcpClientIdRegex(Entity):
                                                                                                """
                                                                                                Dhcp Client ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                            class CircuitId(Entity):
                                                                                                """
                                                                                                Circuit ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                    self.yang_name = "circuit-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "circuit-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                            class CircuitIdRegex(Entity):
                                                                                                """
                                                                                                Circuit ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                    self.yang_name = "circuit-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "circuit-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                            class RemoteId(Entity):
                                                                                                """
                                                                                                Remote ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                    self.yang_name = "remote-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "remote-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                            class RemoteIdRegex(Entity):
                                                                                                """
                                                                                                Remote ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                    self.yang_name = "remote-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "remote-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                            class SrcPort(Entity):
                                                                                                """
                                                                                                Source port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                    self.yang_name = "src-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "src-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class DstPort(Entity):
                                                                                                """
                                                                                                Destination port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                    self.yang_name = "dst-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "dst-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                        class ExcdclassP(Entity):
                                                                            """
                                                                            excdclass p
                                                                            
                                                                            .. attribute:: class_map_bg
                                                                            
                                                                            	class map bg
                                                                            	**type**\: list of  		 :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP, self).__init__()

                                                                                self.yang_name = "excdclass-p"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("class-map-bg", ("class_map_bg", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg))])
                                                                                self._leafs = OrderedDict()

                                                                                self.class_map_bg = YList(self)
                                                                                self._segment_path = lambda: "excdclass-p"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP, [], name, value)


                                                                            class ClassMapBg(Entity):
                                                                                """
                                                                                class map bg
                                                                                
                                                                                .. attribute:: match_infop
                                                                                
                                                                                	Pointer to the first Match info
                                                                                	**type**\:  :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop>`
                                                                                
                                                                                .. attribute:: name
                                                                                
                                                                                	Name of the class\-map
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..65
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Class\-Map Type QoS/PBR/Netflow/..
                                                                                	**type**\:  :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                                                
                                                                                .. attribute:: mode
                                                                                
                                                                                	Class\-Map Mode Match any/Match all
                                                                                	**type**\:  :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                                
                                                                                .. attribute:: description
                                                                                
                                                                                	description
                                                                                	**type**\: str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg, self).__init__()

                                                                                    self.yang_name = "class-map-bg"
                                                                                    self.yang_parent_name = "excdclass-p"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("match-infop", ("match_infop", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapTypeEn', '')])),
                                                                                        ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapModeEn', '')])),
                                                                                        ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                    ])
                                                                                    self.name = None
                                                                                    self.type = None
                                                                                    self.mode = None
                                                                                    self.description = None

                                                                                    self.match_infop = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop()
                                                                                    self.match_infop.parent = self
                                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                                    self._segment_path = lambda: "class-map-bg"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg, ['name', 'type', 'mode', 'description'], name, value)


                                                                                class MatchInfop(Entity):
                                                                                    """
                                                                                    Pointer to the first Match info
                                                                                    
                                                                                    .. attribute:: class_match_info_st
                                                                                    
                                                                                    	class match info st
                                                                                    	**type**\: list of  		 :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop, self).__init__()

                                                                                        self.yang_name = "match-infop"
                                                                                        self.yang_parent_name = "class-map-bg"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("class-match-info-st", ("class_match_info_st", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.class_match_info_st = YList(self)
                                                                                        self._segment_path = lambda: "match-infop"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop, [], name, value)


                                                                                    class ClassMatchInfoSt(Entity):
                                                                                        """
                                                                                        class match info st
                                                                                        
                                                                                        .. attribute:: match_data
                                                                                        
                                                                                        	Match criteria
                                                                                        	**type**\:  :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                        
                                                                                        .. attribute:: flags
                                                                                        
                                                                                        	Flags
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                            self.yang_name = "class-match-info-st"
                                                                                            self.yang_parent_name = "match-infop"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("match-data", ("match_data", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData))])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                            ])
                                                                                            self.flags = None

                                                                                            self.match_data = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                            self.match_data.parent = self
                                                                                            self._children_name_map["match_data"] = "match-data"
                                                                                            self._segment_path = lambda: "class-match-info-st"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                        class MatchData(Entity):
                                                                                            """
                                                                                            Match criteria
                                                                                            
                                                                                            .. attribute:: ipv4_dscp
                                                                                            
                                                                                            	IPv4 DSCP
                                                                                            	**type**\:  :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv6_dscp
                                                                                            
                                                                                            	IPv6 DSCP
                                                                                            	**type**\:  :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                            
                                                                                            .. attribute:: dscp
                                                                                            
                                                                                            	Match DSCP range array
                                                                                            	**type**\:  :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv4_prec
                                                                                            
                                                                                            	IPv4 Precedence
                                                                                            	**type**\:  :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                            
                                                                                            .. attribute:: ipv6_prec
                                                                                            
                                                                                            	IPv6 Precedence
                                                                                            	**type**\:  :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                            
                                                                                            .. attribute:: prec
                                                                                            
                                                                                            	Match Precedence array
                                                                                            	**type**\:  :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                            
                                                                                            .. attribute:: discard_class
                                                                                            
                                                                                            	Match Discard Class array
                                                                                            	**type**\:  :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                            
                                                                                            .. attribute:: qos_group
                                                                                            
                                                                                            	Match QoS group array
                                                                                            	**type**\:  :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                            
                                                                                            .. attribute:: traffic_class
                                                                                            
                                                                                            	Match Traffic class array
                                                                                            	**type**\:  :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                            
                                                                                            .. attribute:: proto
                                                                                            
                                                                                            	Match Protocol array
                                                                                            	**type**\:  :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                            
                                                                                            .. attribute:: icmp_v4
                                                                                            
                                                                                            	Match ICMPV4 Protocol
                                                                                            	**type**\:  :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                            
                                                                                            .. attribute:: icmp_v6
                                                                                            
                                                                                            	Match ICMPV6 Protocol array
                                                                                            	**type**\:  :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                            
                                                                                            .. attribute:: ipv4_packet_len
                                                                                            
                                                                                            	IPv4 packet length array
                                                                                            	**type**\:  :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv6_packet_len
                                                                                            
                                                                                            	IPv6 packet length array
                                                                                            	**type**\:  :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                            
                                                                                            .. attribute:: packet_len
                                                                                            
                                                                                            	Match packet length array
                                                                                            	**type**\:  :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                            
                                                                                            .. attribute:: flow_tag
                                                                                            
                                                                                            	Match flow\-tag array
                                                                                            	**type**\:  :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                            
                                                                                            .. attribute:: tcp_flag
                                                                                            
                                                                                            	Match tcp flag value
                                                                                            	**type**\:  :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                            
                                                                                            .. attribute:: icmpv4_type
                                                                                            
                                                                                            	Match ipv4 icmp type
                                                                                            	**type**\:  :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                            
                                                                                            .. attribute:: icmpv4_code
                                                                                            
                                                                                            	Match ipv4 icmp code
                                                                                            	**type**\:  :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                            
                                                                                            .. attribute:: icmpv6_type
                                                                                            
                                                                                            	Match ipv6 icmp type
                                                                                            	**type**\:  :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                            
                                                                                            .. attribute:: icmpv6_code
                                                                                            
                                                                                            	Match ipv6 icmp code
                                                                                            	**type**\:  :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                            
                                                                                            .. attribute:: mpls_exp
                                                                                            
                                                                                            	Match MPLS experimental topmost array
                                                                                            	**type**\:  :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                            
                                                                                            .. attribute:: mpls_exp_imp
                                                                                            
                                                                                            	Match MPLS experimental imposition array
                                                                                            	**type**\:  :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                                            
                                                                                            	MPLS Disposition IPv4 Access\-list
                                                                                            	**type**\:  :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                                            
                                                                                            	MPLS Disposition IPv6 Access\-list
                                                                                            	**type**\:  :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_top_label
                                                                                            
                                                                                            	MPLS Topmost LABEL
                                                                                            	**type**\:  :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                            
                                                                                            .. attribute:: cos
                                                                                            
                                                                                            	Match CoS array
                                                                                            	**type**\:  :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                            
                                                                                            .. attribute:: cos_inr
                                                                                            
                                                                                            	Match inner header CoS
                                                                                            	**type**\:  :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                            
                                                                                            .. attribute:: dei
                                                                                            
                                                                                            	Match DEI Bit
                                                                                            	**type**\:  :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                            
                                                                                            .. attribute:: dei_inr
                                                                                            
                                                                                            	Match inner DEI Bit
                                                                                            	**type**\:  :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                            
                                                                                            .. attribute:: vlan
                                                                                            
                                                                                            	Match VLAN array
                                                                                            	**type**\:  :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                            
                                                                                            .. attribute:: vlan_inr
                                                                                            
                                                                                            	Match inner header VLAN range array
                                                                                            	**type**\:  :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                            
                                                                                            .. attribute:: fr_dlci
                                                                                            
                                                                                            	Match FR DLCI range array
                                                                                            	**type**\:  :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                            
                                                                                            .. attribute:: src_mac
                                                                                            
                                                                                            	Match Source MAC address
                                                                                            	**type**\:  :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                            
                                                                                            .. attribute:: dst_mac
                                                                                            
                                                                                            	Match Destination MAC address
                                                                                            	**type**\:  :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                            
                                                                                            .. attribute:: atm_clp
                                                                                            
                                                                                            	Match ATM CLP level
                                                                                            	**type**\:  :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                            
                                                                                            .. attribute:: fr_de
                                                                                            
                                                                                            	Match FR DE value
                                                                                            	**type**\:  :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                            
                                                                                            .. attribute:: ipv4_acl
                                                                                            
                                                                                            	IPv4 Access\-list
                                                                                            	**type**\:  :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                            
                                                                                            .. attribute:: ipv6_acl
                                                                                            
                                                                                            	IPv6 Access\-list
                                                                                            	**type**\:  :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                            
                                                                                            .. attribute:: ether_service_acl
                                                                                            
                                                                                            	Ethernet\-Services Access\-list
                                                                                            	**type**\:  :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                            
                                                                                            .. attribute:: avail_id
                                                                                            
                                                                                            	Available Identifiers
                                                                                            	**type**\:  :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                            
                                                                                            .. attribute:: media_type
                                                                                            
                                                                                            	Media Type
                                                                                            	**type**\:  :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                            
                                                                                            .. attribute:: subs_protocol
                                                                                            
                                                                                            	Protocol
                                                                                            	**type**\:  :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                            
                                                                                            .. attribute:: dnis
                                                                                            
                                                                                            	DNIS
                                                                                            	**type**\:  :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                            
                                                                                            .. attribute:: dnis_regex
                                                                                            
                                                                                            	DNIS Regular Expression
                                                                                            	**type**\:  :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                            
                                                                                            .. attribute:: domain
                                                                                            
                                                                                            	Domain Name
                                                                                            	**type**\:  :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                            
                                                                                            .. attribute:: domain_regex
                                                                                            
                                                                                            	Domain Regular Expression
                                                                                            	**type**\:  :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                            
                                                                                            .. attribute:: nas_port
                                                                                            
                                                                                            	NAS Port
                                                                                            	**type**\:  :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                            
                                                                                            .. attribute:: service_name
                                                                                            
                                                                                            	Service Name
                                                                                            	**type**\:  :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                            
                                                                                            .. attribute:: service_name_regex
                                                                                            
                                                                                            	Service Name Regular Exp
                                                                                            	**type**\:  :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv4
                                                                                            
                                                                                            	Source Address IPV4
                                                                                            	**type**\:  :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv4
                                                                                            
                                                                                            	Destination Address IPV4
                                                                                            	**type**\:  :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv6
                                                                                            
                                                                                            	Source Address IPV6
                                                                                            	**type**\:  :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv6
                                                                                            
                                                                                            	Destination Address IPV6
                                                                                            	**type**\:  :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: src_addr_mac
                                                                                            
                                                                                            	Source Address MAC
                                                                                            	**type**\:  :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                            
                                                                                            .. attribute:: timer
                                                                                            
                                                                                            	Timer
                                                                                            	**type**\:  :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                            
                                                                                            .. attribute:: timer_regexp
                                                                                            
                                                                                            	Timer Regular Expression
                                                                                            	**type**\:  :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                            
                                                                                            .. attribute:: tunnel_name
                                                                                            
                                                                                            	Tunnel Name
                                                                                            	**type**\:  :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                            
                                                                                            .. attribute:: tunnel_name_regex
                                                                                            
                                                                                            	Tunnel Name Regular Expression
                                                                                            	**type**\:  :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                            
                                                                                            .. attribute:: user_name
                                                                                            
                                                                                            	User Name
                                                                                            	**type**\:  :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                            
                                                                                            .. attribute:: user_name_regex
                                                                                            
                                                                                            	User Name Regular Expression
                                                                                            	**type**\:  :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                            
                                                                                            .. attribute:: auth_username
                                                                                            
                                                                                            	Authenticated User Name
                                                                                            	**type**\:  :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                            
                                                                                            .. attribute:: auth_username_regex
                                                                                            
                                                                                            	Authenticated User Name RegEx
                                                                                            	**type**\:  :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_username
                                                                                            
                                                                                            	Unauthenticated User Name
                                                                                            	**type**\:  :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                            
                                                                                            .. attribute:: unauth_username_regex
                                                                                            
                                                                                            	Unauthenticated User Name RegEx
                                                                                            	**type**\:  :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: auth_domain
                                                                                            
                                                                                            	Authenticated domain name
                                                                                            	**type**\:  :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                            
                                                                                            .. attribute:: auth_domain_regex
                                                                                            
                                                                                            	Authenticated Domain Name RegEx
                                                                                            	**type**\:  :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_domain
                                                                                            
                                                                                            	Unauthenticated Domain Name
                                                                                            	**type**\:  :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                            
                                                                                            .. attribute:: unauth_domain_regex
                                                                                            
                                                                                            	Unauthenticated Domain Name RegEx
                                                                                            	**type**\:  :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: vendor_id
                                                                                            
                                                                                            	Vendor ID
                                                                                            	**type**\:  :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                            
                                                                                            .. attribute:: vendor_id_regex
                                                                                            
                                                                                            	Vendor ID RegEx
                                                                                            	**type**\:  :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                            
                                                                                            .. attribute:: access_interface
                                                                                            
                                                                                            	Access interface
                                                                                            	**type**\:  :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                            
                                                                                            .. attribute:: input_interface
                                                                                            
                                                                                            	Input interface
                                                                                            	**type**\:  :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                            
                                                                                            .. attribute:: input_intfhdl
                                                                                            
                                                                                            	Input interface handle
                                                                                            	**type**\:  :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                            
                                                                                            .. attribute:: ethertype
                                                                                            
                                                                                            	Ethernet type
                                                                                            	**type**\:  :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                            
                                                                                            .. attribute:: flow_key_data
                                                                                            
                                                                                            	Flow key structure
                                                                                            	**type**\:  :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id
                                                                                            
                                                                                            	Dhcp Client ID
                                                                                            	**type**\:  :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id_regex
                                                                                            
                                                                                            	Dhcp Client ID RegEx
                                                                                            	**type**\:  :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                            
                                                                                            .. attribute:: circuit_id
                                                                                            
                                                                                            	Circuit ID
                                                                                            	**type**\:  :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                            
                                                                                            .. attribute:: circuit_id_regex
                                                                                            
                                                                                            	Circuit ID RegEx
                                                                                            	**type**\:  :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                            
                                                                                            .. attribute:: remote_id
                                                                                            
                                                                                            	Remote ID
                                                                                            	**type**\:  :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                            
                                                                                            .. attribute:: remote_id_regex
                                                                                            
                                                                                            	Remote ID RegEx
                                                                                            	**type**\:  :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                            
                                                                                            .. attribute:: src_port
                                                                                            
                                                                                            	Source port
                                                                                            	**type**\:  :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                            
                                                                                            .. attribute:: dst_port
                                                                                            
                                                                                            	Destination port
                                                                                            	**type**\:  :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	type
                                                                                            	**type**\:  :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                            
                                                                                            .. attribute:: mpls_top_eos
                                                                                            
                                                                                            	MPLS Topmost EOS
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: fragment_type
                                                                                            
                                                                                            	Fragment type
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: authen_status
                                                                                            
                                                                                            	Authentication Status
                                                                                            	**type**\:  :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                            
                                                                                            .. attribute:: mlp_negotiated
                                                                                            
                                                                                            	MLP Negotiated
                                                                                            	**type**\:  :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                                self.yang_name = "match-data"
                                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("ipv4-dscp", ("ipv4_dscp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp)), ("ipv6-dscp", ("ipv6_dscp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp)), ("dscp", ("dscp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp)), ("ipv4-prec", ("ipv4_prec", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec)), ("ipv6-prec", ("ipv6_prec", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec)), ("prec", ("prec", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec)), ("discard-class", ("discard_class", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass)), ("qos-group", ("qos_group", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup)), ("traffic-class", ("traffic_class", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass)), ("proto", ("proto", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto)), ("icmp-v4", ("icmp_v4", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4)), ("icmp-v6", ("icmp_v6", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6)), ("ipv4-packet-len", ("ipv4_packet_len", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen)), ("ipv6-packet-len", ("ipv6_packet_len", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen)), ("packet-len", ("packet_len", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen)), ("flow-tag", ("flow_tag", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag)), ("tcp-flag", ("tcp_flag", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag)), ("icmpv4-type", ("icmpv4_type", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type)), ("icmpv4-code", ("icmpv4_code", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code)), ("icmpv6-type", ("icmpv6_type", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type)), ("icmpv6-code", ("icmpv6_code", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code)), ("mpls-exp", ("mpls_exp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp)), ("mpls-exp-imp", ("mpls_exp_imp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp)), ("mpls-disp-ipv4-acl", ("mpls_disp_ipv4_acl", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl)), ("mpls-disp-ipv6-acl", ("mpls_disp_ipv6_acl", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl)), ("mpls-top-label", ("mpls_top_label", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel)), ("cos", ("cos", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos)), ("cos-inr", ("cos_inr", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr)), ("dei", ("dei", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei)), ("dei-inr", ("dei_inr", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr)), ("vlan", ("vlan", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan)), ("vlan-inr", ("vlan_inr", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)), ("fr-dlci", ("fr_dlci", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci)), ("src-mac", ("src_mac", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac)), ("dst-mac", ("dst_mac", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac)), ("atm-clp", ("atm_clp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp)), ("fr-de", ("fr_de", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe)), ("ipv4-acl", ("ipv4_acl", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl)), ("ipv6-acl", ("ipv6_acl", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl)), ("ether-service-acl", ("ether_service_acl", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl)), ("avail-id", ("avail_id", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId)), ("media-type", ("media_type", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType)), ("subs-protocol", ("subs_protocol", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol)), ("dnis", ("dnis", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis)), ("dnis-regex", ("dnis_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex)), ("domain", ("domain", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain)), ("domain-regex", ("domain_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex)), ("nas-port", ("nas_port", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort)), ("service-name", ("service_name", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName)), ("service-name-regex", ("service_name_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex)), ("src-addr-ipv4", ("src_addr_ipv4", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4)), ("dst-addr-ipv4", ("dst_addr_ipv4", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4)), ("src-addr-ipv6", ("src_addr_ipv6", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6)), ("dst-addr-ipv6", ("dst_addr_ipv6", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6)), ("src-addr-mac", ("src_addr_mac", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac)), ("timer", ("timer", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer)), ("timer-regexp", ("timer_regexp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp)), ("tunnel-name", ("tunnel_name", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName)), ("tunnel-name-regex", ("tunnel_name_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex)), ("user-name", ("user_name", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName)), ("user-name-regex", ("user_name_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex)), ("auth-username", ("auth_username", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername)), ("auth-username-regex", ("auth_username_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex)), ("unauth-username", ("unauth_username", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername)), ("unauth-username-regex", ("unauth_username_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex)), ("auth-domain", ("auth_domain", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain)), ("auth-domain-regex", ("auth_domain_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex)), ("unauth-domain", ("unauth_domain", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain)), ("unauth-domain-regex", ("unauth_domain_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex)), ("vendor-id", ("vendor_id", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId)), ("vendor-id-regex", ("vendor_id_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex)), ("access-interface", ("access_interface", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface)), ("input-interface", ("input_interface", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface)), ("input-intfhdl", ("input_intfhdl", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl)), ("ethertype", ("ethertype", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype)), ("flow-key-data", ("flow_key_data", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData)), ("dhcp-client-id", ("dhcp_client_id", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId)), ("dhcp-client-id-regex", ("dhcp_client_id_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex)), ("circuit-id", ("circuit_id", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId)), ("circuit-id-regex", ("circuit_id_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex)), ("remote-id", ("remote_id", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId)), ("remote-id-regex", ("remote_id_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex)), ("src-port", ("src_port", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort)), ("dst-port", ("dst_port", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort))])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchTypeEn', '')])),
                                                                                                    ('mpls_top_eos', (YLeaf(YType.uint8, 'mpls-top-eos'), ['int'])),
                                                                                                    ('fragment_type', (YLeaf(YType.uint8, 'fragment-type'), ['int'])),
                                                                                                    ('authen_status', (YLeaf(YType.enumeration, 'authen-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchAuthenStatusEn', '')])),
                                                                                                    ('mlp_negotiated', (YLeaf(YType.enumeration, 'mlp-negotiated'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchMlpNegotiatedEn', '')])),
                                                                                                ])
                                                                                                self.type = None
                                                                                                self.mpls_top_eos = None
                                                                                                self.fragment_type = None
                                                                                                self.authen_status = None
                                                                                                self.mlp_negotiated = None

                                                                                                self.ipv4_dscp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                                self.ipv4_dscp.parent = self
                                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"

                                                                                                self.ipv6_dscp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                                self.ipv6_dscp.parent = self
                                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"

                                                                                                self.dscp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                                self.dscp.parent = self
                                                                                                self._children_name_map["dscp"] = "dscp"

                                                                                                self.ipv4_prec = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                                self.ipv4_prec.parent = self
                                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"

                                                                                                self.ipv6_prec = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                                self.ipv6_prec.parent = self
                                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"

                                                                                                self.prec = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                                self.prec.parent = self
                                                                                                self._children_name_map["prec"] = "prec"

                                                                                                self.discard_class = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                                self.discard_class.parent = self
                                                                                                self._children_name_map["discard_class"] = "discard-class"

                                                                                                self.qos_group = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                                self.qos_group.parent = self
                                                                                                self._children_name_map["qos_group"] = "qos-group"

                                                                                                self.traffic_class = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                                self.traffic_class.parent = self
                                                                                                self._children_name_map["traffic_class"] = "traffic-class"

                                                                                                self.proto = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                                self.proto.parent = self
                                                                                                self._children_name_map["proto"] = "proto"

                                                                                                self.icmp_v4 = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                                self.icmp_v4.parent = self
                                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"

                                                                                                self.icmp_v6 = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                                self.icmp_v6.parent = self
                                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"

                                                                                                self.ipv4_packet_len = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                                self.ipv4_packet_len.parent = self
                                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"

                                                                                                self.ipv6_packet_len = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                                self.ipv6_packet_len.parent = self
                                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"

                                                                                                self.packet_len = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                                self.packet_len.parent = self
                                                                                                self._children_name_map["packet_len"] = "packet-len"

                                                                                                self.flow_tag = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                                self.flow_tag.parent = self
                                                                                                self._children_name_map["flow_tag"] = "flow-tag"

                                                                                                self.tcp_flag = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                                self.tcp_flag.parent = self
                                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"

                                                                                                self.icmpv4_type = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                                self.icmpv4_type.parent = self
                                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"

                                                                                                self.icmpv4_code = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                                self.icmpv4_code.parent = self
                                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"

                                                                                                self.icmpv6_type = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                                self.icmpv6_type.parent = self
                                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"

                                                                                                self.icmpv6_code = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                                self.icmpv6_code.parent = self
                                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"

                                                                                                self.mpls_exp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                                self.mpls_exp.parent = self
                                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"

                                                                                                self.mpls_exp_imp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                                self.mpls_exp_imp.parent = self
                                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"

                                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"

                                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"

                                                                                                self.mpls_top_label = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                                self.mpls_top_label.parent = self
                                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"

                                                                                                self.cos = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                                self.cos.parent = self
                                                                                                self._children_name_map["cos"] = "cos"

                                                                                                self.cos_inr = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                                self.cos_inr.parent = self
                                                                                                self._children_name_map["cos_inr"] = "cos-inr"

                                                                                                self.dei = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                                self.dei.parent = self
                                                                                                self._children_name_map["dei"] = "dei"

                                                                                                self.dei_inr = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                                self.dei_inr.parent = self
                                                                                                self._children_name_map["dei_inr"] = "dei-inr"

                                                                                                self.vlan = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                                self.vlan.parent = self
                                                                                                self._children_name_map["vlan"] = "vlan"

                                                                                                self.vlan_inr = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                                self.vlan_inr.parent = self
                                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"

                                                                                                self.fr_dlci = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                                self.fr_dlci.parent = self
                                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"

                                                                                                self.src_mac = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                                self.src_mac.parent = self
                                                                                                self._children_name_map["src_mac"] = "src-mac"

                                                                                                self.dst_mac = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                                self.dst_mac.parent = self
                                                                                                self._children_name_map["dst_mac"] = "dst-mac"

                                                                                                self.atm_clp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                                self.atm_clp.parent = self
                                                                                                self._children_name_map["atm_clp"] = "atm-clp"

                                                                                                self.fr_de = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                                self.fr_de.parent = self
                                                                                                self._children_name_map["fr_de"] = "fr-de"

                                                                                                self.ipv4_acl = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                                self.ipv4_acl.parent = self
                                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"

                                                                                                self.ipv6_acl = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                                self.ipv6_acl.parent = self
                                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"

                                                                                                self.ether_service_acl = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                                self.ether_service_acl.parent = self
                                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"

                                                                                                self.avail_id = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                                self.avail_id.parent = self
                                                                                                self._children_name_map["avail_id"] = "avail-id"

                                                                                                self.media_type = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                                self.media_type.parent = self
                                                                                                self._children_name_map["media_type"] = "media-type"

                                                                                                self.subs_protocol = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                                self.subs_protocol.parent = self
                                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"

                                                                                                self.dnis = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                                self.dnis.parent = self
                                                                                                self._children_name_map["dnis"] = "dnis"

                                                                                                self.dnis_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                                self.dnis_regex.parent = self
                                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"

                                                                                                self.domain = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                                self.domain.parent = self
                                                                                                self._children_name_map["domain"] = "domain"

                                                                                                self.domain_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                                self.domain_regex.parent = self
                                                                                                self._children_name_map["domain_regex"] = "domain-regex"

                                                                                                self.nas_port = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                                self.nas_port.parent = self
                                                                                                self._children_name_map["nas_port"] = "nas-port"

                                                                                                self.service_name = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                                self.service_name.parent = self
                                                                                                self._children_name_map["service_name"] = "service-name"

                                                                                                self.service_name_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                                self.service_name_regex.parent = self
                                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"

                                                                                                self.src_addr_ipv4 = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                                self.src_addr_ipv4.parent = self
                                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"

                                                                                                self.dst_addr_ipv4 = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                                self.dst_addr_ipv4.parent = self
                                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"

                                                                                                self.src_addr_ipv6 = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                                self.src_addr_ipv6.parent = self
                                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"

                                                                                                self.dst_addr_ipv6 = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                                self.dst_addr_ipv6.parent = self
                                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"

                                                                                                self.src_addr_mac = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                                self.src_addr_mac.parent = self
                                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"

                                                                                                self.timer = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                                self.timer.parent = self
                                                                                                self._children_name_map["timer"] = "timer"

                                                                                                self.timer_regexp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                                self.timer_regexp.parent = self
                                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"

                                                                                                self.tunnel_name = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                                self.tunnel_name.parent = self
                                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"

                                                                                                self.tunnel_name_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                                self.tunnel_name_regex.parent = self
                                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"

                                                                                                self.user_name = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                                self.user_name.parent = self
                                                                                                self._children_name_map["user_name"] = "user-name"

                                                                                                self.user_name_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                                self.user_name_regex.parent = self
                                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"

                                                                                                self.auth_username = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                                self.auth_username.parent = self
                                                                                                self._children_name_map["auth_username"] = "auth-username"

                                                                                                self.auth_username_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                                self.auth_username_regex.parent = self
                                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"

                                                                                                self.unauth_username = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                                self.unauth_username.parent = self
                                                                                                self._children_name_map["unauth_username"] = "unauth-username"

                                                                                                self.unauth_username_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                                self.unauth_username_regex.parent = self
                                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"

                                                                                                self.auth_domain = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                                self.auth_domain.parent = self
                                                                                                self._children_name_map["auth_domain"] = "auth-domain"

                                                                                                self.auth_domain_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                                self.auth_domain_regex.parent = self
                                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"

                                                                                                self.unauth_domain = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                                self.unauth_domain.parent = self
                                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"

                                                                                                self.unauth_domain_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                                self.unauth_domain_regex.parent = self
                                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"

                                                                                                self.vendor_id = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                                self.vendor_id.parent = self
                                                                                                self._children_name_map["vendor_id"] = "vendor-id"

                                                                                                self.vendor_id_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                                self.vendor_id_regex.parent = self
                                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"

                                                                                                self.access_interface = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                                self.access_interface.parent = self
                                                                                                self._children_name_map["access_interface"] = "access-interface"

                                                                                                self.input_interface = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                                self.input_interface.parent = self
                                                                                                self._children_name_map["input_interface"] = "input-interface"

                                                                                                self.input_intfhdl = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                                self.input_intfhdl.parent = self
                                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"

                                                                                                self.ethertype = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                                self.ethertype.parent = self
                                                                                                self._children_name_map["ethertype"] = "ethertype"

                                                                                                self.flow_key_data = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                                self.flow_key_data.parent = self
                                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"

                                                                                                self.dhcp_client_id = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                                self.dhcp_client_id.parent = self
                                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"

                                                                                                self.dhcp_client_id_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                                self.dhcp_client_id_regex.parent = self
                                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"

                                                                                                self.circuit_id = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                                self.circuit_id.parent = self
                                                                                                self._children_name_map["circuit_id"] = "circuit-id"

                                                                                                self.circuit_id_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                                self.circuit_id_regex.parent = self
                                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"

                                                                                                self.remote_id = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                                self.remote_id.parent = self
                                                                                                self._children_name_map["remote_id"] = "remote-id"

                                                                                                self.remote_id_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                                self.remote_id_regex.parent = self
                                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"

                                                                                                self.src_port = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                                self.src_port.parent = self
                                                                                                self._children_name_map["src_port"] = "src-port"

                                                                                                self.dst_port = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                                self.dst_port.parent = self
                                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                                self._segment_path = lambda: "match-data"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['type', 'mpls_top_eos', 'fragment_type', 'authen_status', 'mlp_negotiated'], name, value)


                                                                                            class Ipv4Dscp(Entity):
                                                                                                """
                                                                                                IPv4 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv4-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv6Dscp(Entity):
                                                                                                """
                                                                                                IPv6 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv6-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Dscp(Entity):
                                                                                                """
                                                                                                Match DSCP range array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                    self.yang_name = "dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv4Prec(Entity):
                                                                                                """
                                                                                                IPv4 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                    self.yang_name = "ipv4-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "ipv4-prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                            class Ipv6Prec(Entity):
                                                                                                """
                                                                                                IPv6 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                    self.yang_name = "ipv6-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "ipv6-prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                            class Prec(Entity):
                                                                                                """
                                                                                                Match Precedence array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                    self.yang_name = "prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                            class DiscardClass(Entity):
                                                                                                """
                                                                                                Match Discard Class array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                    self.yang_name = "discard-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "discard-class"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                            class QosGroup(Entity):
                                                                                                """
                                                                                                Match QoS group array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                    self.yang_name = "qos-group"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "qos-group"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "qos-group"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class TrafficClass(Entity):
                                                                                                """
                                                                                                Match Traffic class array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                    self.yang_name = "traffic-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "traffic-class"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "traffic-class"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Proto(Entity):
                                                                                                """
                                                                                                Match Protocol array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                    self.yang_name = "proto"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "proto"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "proto"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class IcmpV4(Entity):
                                                                                                """
                                                                                                Match ICMPV4 Protocol
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                    self.yang_name = "icmp-v4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                    ])
                                                                                                    self.type = None
                                                                                                    self.code = None
                                                                                                    self._segment_path = lambda: "icmp-v4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['type', 'code'], name, value)


                                                                                            class IcmpV6(Entity):
                                                                                                """
                                                                                                Match ICMPV6 Protocol array
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                    self.yang_name = "icmp-v6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                    ])
                                                                                                    self.type = None
                                                                                                    self.code = None
                                                                                                    self._segment_path = lambda: "icmp-v6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['type', 'code'], name, value)


                                                                                            class Ipv4PacketLen(Entity):
                                                                                                """
                                                                                                IPv4 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv6PacketLen(Entity):
                                                                                                """
                                                                                                IPv6 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class PacketLen(Entity):
                                                                                                """
                                                                                                Match packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                    self.yang_name = "packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FlowTag(Entity):
                                                                                                """
                                                                                                Match flow\-tag array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                    self.yang_name = "flow-tag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "flow-tag"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "flow-tag"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class TcpFlag(Entity):
                                                                                                """
                                                                                                Match tcp flag value
                                                                                                
                                                                                                .. attribute:: value
                                                                                                
                                                                                                	Value of TCP flag
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: match_any
                                                                                                
                                                                                                	Match any TCP flag bit
                                                                                                	**type**\: bool
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                    self.yang_name = "tcp-flag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                                        ('match_any', (YLeaf(YType.boolean, 'match-any'), ['bool'])),
                                                                                                    ])
                                                                                                    self.value = None
                                                                                                    self.match_any = None
                                                                                                    self._segment_path = lambda: "tcp-flag"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['value', 'match_any'], name, value)


                                                                                            class Icmpv4Type(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                    self.yang_name = "icmpv4-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv4Code(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                    self.yang_name = "icmpv4-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-code"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv6Type(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                    self.yang_name = "icmpv6-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv6Code(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                    self.yang_name = "icmpv6-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-code"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class MplsExp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental topmost array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "mpls-exp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                            class MplsExpImp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental imposition array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "mpls-exp-imp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                            class MplsDispIpv4Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                            class MplsDispIpv6Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                            class MplsTopLabel(Entity):
                                                                                                """
                                                                                                MPLS Topmost LABEL
                                                                                                
                                                                                                .. attribute:: uint32_rng_array
                                                                                                
                                                                                                	uint32 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                    self.yang_name = "mpls-top-label"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint32_rng_array", ("uint32_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint32_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "mpls-top-label"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                                class Uint32RngArray(Entity):
                                                                                                    """
                                                                                                    uint32 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                        self.yang_name = "uint32_rng_array"
                                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint32, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint32, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint32_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['min', 'max'], name, value)


                                                                                            class Cos(Entity):
                                                                                                """
                                                                                                Match CoS array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                    self.yang_name = "cos"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "cos"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                            class CosInr(Entity):
                                                                                                """
                                                                                                Match inner header CoS
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                    self.yang_name = "cos-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "cos-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                            class Dei(Entity):
                                                                                                """
                                                                                                Match DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                    self.yang_name = "dei"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                    ])
                                                                                                    self.bit_value = None
                                                                                                    self._segment_path = lambda: "dei"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                            class DeiInr(Entity):
                                                                                                """
                                                                                                Match inner DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                    self.yang_name = "dei-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                    ])
                                                                                                    self.bit_value = None
                                                                                                    self._segment_path = lambda: "dei-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                            class Vlan(Entity):
                                                                                                """
                                                                                                Match VLAN array
                                                                                                
                                                                                                .. attribute:: vlan_id_array
                                                                                                
                                                                                                	vlan id array
                                                                                                	**type**\: list of  		 :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                    self.yang_name = "vlan"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("vlan-id-array", ("vlan_id_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.vlan_id_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                                class VlanIdArray(Entity):
                                                                                                    """
                                                                                                    vlan id array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	VLAN mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                        self.yang_name = "vlan-id-array"
                                                                                                        self.yang_parent_name = "vlan"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ('mask', (YLeaf(YType.uint16, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "vlan-id-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['min', 'max', 'mask'], name, value)


                                                                                            class VlanInr(Entity):
                                                                                                """
                                                                                                Match inner header VLAN range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                    self.yang_name = "vlan-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FrDlci(Entity):
                                                                                                """
                                                                                                Match FR DLCI range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                    self.yang_name = "fr-dlci"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "fr-dlci"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class SrcMac(Entity):
                                                                                                """
                                                                                                Match Source MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                    self.yang_name = "src-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.mac_addr = []
                                                                                                    self.mask = []
                                                                                                    self._segment_path = lambda: "src-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                            class DstMac(Entity):
                                                                                                """
                                                                                                Match Destination MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                    self.yang_name = "dst-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.mac_addr = []
                                                                                                    self.mask = []
                                                                                                    self._segment_path = lambda: "dst-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                            class AtmClp(Entity):
                                                                                                """
                                                                                                Match ATM CLP level
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                    self.yang_name = "atm-clp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "atm-clp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                            class FrDe(Entity):
                                                                                                """
                                                                                                Match FR DE value
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                    self.yang_name = "fr-de"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "fr-de"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                            class Ipv4Acl(Entity):
                                                                                                """
                                                                                                IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                    self.yang_name = "ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ipv4-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                            class Ipv6Acl(Entity):
                                                                                                """
                                                                                                IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                    self.yang_name = "ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ipv6-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                            class EtherServiceAcl(Entity):
                                                                                                """
                                                                                                Ethernet\-Services Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                    self.yang_name = "ether-service-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ether-service-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                            class AvailId(Entity):
                                                                                                """
                                                                                                Available Identifiers
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                    self.yang_name = "avail-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "avail-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                            class MediaType(Entity):
                                                                                                """
                                                                                                Media Type
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                    self.yang_name = "media-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "media-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                            class SubsProtocol(Entity):
                                                                                                """
                                                                                                Protocol
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                    self.yang_name = "subs-protocol"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "subs-protocol"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                            class Dnis(Entity):
                                                                                                """
                                                                                                DNIS
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                    self.yang_name = "dnis"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dnis"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                            class DnisRegex(Entity):
                                                                                                """
                                                                                                DNIS Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                    self.yang_name = "dnis-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dnis-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                            class Domain(Entity):
                                                                                                """
                                                                                                Domain Name
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                    self.yang_name = "domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                        ])
                                                                                                        self.domain_name = None
                                                                                                        self.format_name = None
                                                                                                        self._segment_path = lambda: "domain-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class DomainRegex(Entity):
                                                                                                """
                                                                                                Domain Regular Expression
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                    self.yang_name = "domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain-regex"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                        ])
                                                                                                        self.domain_name = None
                                                                                                        self.format_name = None
                                                                                                        self._segment_path = lambda: "domain-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class NasPort(Entity):
                                                                                                """
                                                                                                NAS Port
                                                                                                
                                                                                                .. attribute:: nas_port_array
                                                                                                
                                                                                                	nas port array
                                                                                                	**type**\: list of  		 :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                    self.yang_name = "nas-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("nas-port-array", ("nas_port_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.nas_port_array = YList(self)
                                                                                                    self._segment_path = lambda: "nas-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                                class NasPortArray(Entity):
                                                                                                    """
                                                                                                    nas port array
                                                                                                    
                                                                                                    .. attribute:: sub_id
                                                                                                    
                                                                                                    	sub id
                                                                                                    	**type**\:  :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                    
                                                                                                    .. attribute:: operator
                                                                                                    
                                                                                                    	operator
                                                                                                    	**type**\:  :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	value
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                        self.yang_name = "nas-port-array"
                                                                                                        self.yang_parent_name = "nas-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('sub_id', (YLeaf(YType.enumeration, 'sub-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchNasPortSubIdEn', '')])),
                                                                                                            ('operator', (YLeaf(YType.enumeration, 'operator'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchLogicalOperatorEn', '')])),
                                                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                                        ])
                                                                                                        self.sub_id = None
                                                                                                        self.operator = None
                                                                                                        self.value = None
                                                                                                        self._segment_path = lambda: "nas-port-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['sub_id', 'operator', 'value'], name, value)


                                                                                            class ServiceName(Entity):
                                                                                                """
                                                                                                Service Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                    self.yang_name = "service-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "service-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                            class ServiceNameRegex(Entity):
                                                                                                """
                                                                                                Service Name Regular Exp
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                    self.yang_name = "service-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "service-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                            class SrcAddrIpv4(Entity):
                                                                                                """
                                                                                                Source Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class DstAddrIpv4(Entity):
                                                                                                """
                                                                                                Destination Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class SrcAddrIpv6(Entity):
                                                                                                """
                                                                                                Source Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class DstAddrIpv6(Entity):
                                                                                                """
                                                                                                Destination Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class SrcAddrMac(Entity):
                                                                                                """
                                                                                                Source Address MAC
                                                                                                
                                                                                                .. attribute:: mac_addr_array
                                                                                                
                                                                                                	mac addr array
                                                                                                	**type**\: list of  		 :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                    self.yang_name = "src-addr-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("mac-addr-array", ("mac_addr_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.mac_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                                class MacAddrArray(Entity):
                                                                                                    """
                                                                                                    mac addr array
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                        self.yang_name = "mac-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                            ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.mac_addr = []
                                                                                                        self.mask = []
                                                                                                        self._segment_path = lambda: "mac-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                            class Timer(Entity):
                                                                                                """
                                                                                                Timer
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                    self.yang_name = "timer"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "timer"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                            class TimerRegexp(Entity):
                                                                                                """
                                                                                                Timer Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                    self.yang_name = "timer-regexp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "timer-regexp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                            class TunnelName(Entity):
                                                                                                """
                                                                                                Tunnel Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                    self.yang_name = "tunnel-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "tunnel-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                            class TunnelNameRegex(Entity):
                                                                                                """
                                                                                                Tunnel Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "tunnel-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                            class UserName(Entity):
                                                                                                """
                                                                                                User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                    self.yang_name = "user-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "user-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                            class UserNameRegex(Entity):
                                                                                                """
                                                                                                User Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                    self.yang_name = "user-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "user-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                            class AuthUsername(Entity):
                                                                                                """
                                                                                                Authenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                    self.yang_name = "auth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-username"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                            class AuthUsernameRegex(Entity):
                                                                                                """
                                                                                                Authenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "auth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-username-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                            class UnauthUsername(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                    self.yang_name = "unauth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-username"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                            class UnauthUsernameRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-username-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                            class AuthDomain(Entity):
                                                                                                """
                                                                                                Authenticated domain name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                    self.yang_name = "auth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                            class AuthDomainRegex(Entity):
                                                                                                """
                                                                                                Authenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "auth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                            class UnauthDomain(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                    self.yang_name = "unauth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                            class UnauthDomainRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                            class VendorId(Entity):
                                                                                                """
                                                                                                Vendor ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                    self.yang_name = "vendor-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "vendor-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                            class VendorIdRegex(Entity):
                                                                                                """
                                                                                                Vendor ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                    self.yang_name = "vendor-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "vendor-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                            class AccessInterface(Entity):
                                                                                                """
                                                                                                Access interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                    self.yang_name = "access-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "access-interface"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                            class InputInterface(Entity):
                                                                                                """
                                                                                                Input interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                    self.yang_name = "input-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "input-interface"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                            class InputIntfhdl(Entity):
                                                                                                """
                                                                                                Input interface handle
                                                                                                
                                                                                                .. attribute:: uint64_array
                                                                                                
                                                                                                	uint64 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..18446744073709551615
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                    self.yang_name = "input-intfhdl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint64_array', (YLeafList(YType.uint64, 'uint64_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint64_array = []
                                                                                                    self._segment_path = lambda: "input-intfhdl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                            class Ethertype(Entity):
                                                                                                """
                                                                                                Ethernet type
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                    self.yang_name = "ethertype"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ethertype"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ethertype"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FlowKeyData(Entity):
                                                                                                """
                                                                                                Flow key structure
                                                                                                
                                                                                                .. attribute:: flow_keys
                                                                                                
                                                                                                	flow keys
                                                                                                	**type**\:  :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                                
                                                                                                .. attribute:: max_count
                                                                                                
                                                                                                	Maximum count of flows
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: idle_timeout
                                                                                                
                                                                                                	Idle timeout of flows (in seconds)
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                	**units**\: second
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                    self.yang_name = "flow-key-data"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("flow-keys", ("flow_keys", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys))])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('max_count', (YLeaf(YType.uint16, 'max-count'), ['int'])),
                                                                                                        ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                                                    ])
                                                                                                    self.max_count = None
                                                                                                    self.idle_timeout = None

                                                                                                    self.flow_keys = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                    self.flow_keys.parent = self
                                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                    self._segment_path = lambda: "flow-key-data"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['max_count', 'idle_timeout'], name, value)


                                                                                                class FlowKeys(Entity):
                                                                                                    """
                                                                                                    flow keys
                                                                                                    
                                                                                                    .. attribute:: keys
                                                                                                    
                                                                                                    	keys
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                    
                                                                                                    .. attribute:: num
                                                                                                    
                                                                                                    	num
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                        self.yang_name = "flow-keys"
                                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('keys', (YLeaf(YType.str, 'keys'), ['str'])),
                                                                                                            ('num', (YLeaf(YType.uint8, 'num'), ['int'])),
                                                                                                        ])
                                                                                                        self.keys = None
                                                                                                        self.num = None
                                                                                                        self._segment_path = lambda: "flow-keys"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                            class DhcpClientId(Entity):
                                                                                                """
                                                                                                Dhcp Client ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dhcp-client-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                            class DhcpClientIdRegex(Entity):
                                                                                                """
                                                                                                Dhcp Client ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                            class CircuitId(Entity):
                                                                                                """
                                                                                                Circuit ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                    self.yang_name = "circuit-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "circuit-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                            class CircuitIdRegex(Entity):
                                                                                                """
                                                                                                Circuit ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                    self.yang_name = "circuit-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "circuit-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                            class RemoteId(Entity):
                                                                                                """
                                                                                                Remote ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                    self.yang_name = "remote-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "remote-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                            class RemoteIdRegex(Entity):
                                                                                                """
                                                                                                Remote ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                    self.yang_name = "remote-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "remote-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                            class SrcPort(Entity):
                                                                                                """
                                                                                                Source port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                    self.yang_name = "src-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "src-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class DstPort(Entity):
                                                                                                """
                                                                                                Destination port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                    self.yang_name = "dst-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "dst-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                    class Shape(Entity):
                                                                        """
                                                                        shape
                                                                        
                                                                        .. attribute:: bw
                                                                        
                                                                        	bw
                                                                        	**type**\:  :py:class:`Bw <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw>`
                                                                        
                                                                        .. attribute:: be
                                                                        
                                                                        	be
                                                                        	**type**\:  :py:class:`Be <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape, self).__init__()

                                                                            self.yang_name = "shape"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("bw", ("bw", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw)), ("be", ("be", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be))])
                                                                            self._leafs = OrderedDict()

                                                                            self.bw = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw()
                                                                            self.bw.parent = self
                                                                            self._children_name_map["bw"] = "bw"

                                                                            self.be = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be()
                                                                            self.be.parent = self
                                                                            self._children_name_map["be"] = "be"
                                                                            self._segment_path = lambda: "shape"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape, [], name, value)


                                                                        class Bw(Entity):
                                                                            """
                                                                            bw
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw, self).__init__()

                                                                                self.yang_name = "bw"
                                                                                self.yang_parent_name = "shape"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "bw"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw, ['value', 'unit'], name, value)


                                                                        class Be(Entity):
                                                                            """
                                                                            be
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be, self).__init__()

                                                                                self.yang_name = "be"
                                                                                self.yang_parent_name = "shape"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "be"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be, ['value', 'unit'], name, value)


                                                                    class ChildPolicy(Entity):
                                                                        """
                                                                        child policy
                                                                        
                                                                        .. attribute:: info
                                                                        
                                                                        	info
                                                                        	**type**\:  :py:class:`Info <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info>`
                                                                        
                                                                        .. attribute:: hd_info
                                                                        
                                                                        	hd info
                                                                        	**type**\:  :py:class:`HdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo>`
                                                                        
                                                                        .. attribute:: enc
                                                                        
                                                                        	enc
                                                                        	**type**\:  :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy, self).__init__()

                                                                            self.yang_name = "child-policy"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("info", ("info", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info)), ("hd-info", ("hd_info", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo))])
                                                                            self._leafs = OrderedDict([
                                                                                ('enc', (YLeaf(YType.enumeration, 'enc'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyObjEncEn', '')])),
                                                                            ])
                                                                            self.enc = None

                                                                            self.info = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info()
                                                                            self.info.parent = self
                                                                            self._children_name_map["info"] = "info"

                                                                            self.hd_info = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo()
                                                                            self.hd_info.parent = self
                                                                            self._children_name_map["hd_info"] = "hd-info"
                                                                            self._segment_path = lambda: "child-policy"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy, ['enc'], name, value)


                                                                        class Info(Entity):
                                                                            """
                                                                            info
                                                                            
                                                                            .. attribute:: name
                                                                            
                                                                            	name
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..65
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:  :py:class:`PolicyMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyMapTypeEn>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info, self).__init__()

                                                                                self.yang_name = "info"
                                                                                self.yang_parent_name = "child-policy"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyMapTypeEn', '')])),
                                                                                ])
                                                                                self.name = None
                                                                                self.type = None
                                                                                self._segment_path = lambda: "info"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info, ['name', 'type'], name, value)


                                                                        class HdInfo(Entity):
                                                                            """
                                                                            hd info
                                                                            
                                                                            .. attribute:: data_hd
                                                                            
                                                                            	data hd
                                                                            	**type**\:  :py:class:`DataHd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd>`
                                                                            
                                                                            .. attribute:: hd
                                                                            
                                                                            	hd
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo, self).__init__()

                                                                                self.yang_name = "hd-info"
                                                                                self.yang_parent_name = "child-policy"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("data-hd", ("data_hd", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('hd', (YLeaf(YType.uint64, 'hd'), ['int'])),
                                                                                ])
                                                                                self.hd = None

                                                                                self.data_hd = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd()
                                                                                self.data_hd.parent = self
                                                                                self._children_name_map["data_hd"] = "data-hd"
                                                                                self._segment_path = lambda: "hd-info"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo, ['hd'], name, value)


                                                                            class DataHd(Entity):
                                                                                """
                                                                                data hd
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd, self).__init__()

                                                                                    self.yang_name = "data-hd"
                                                                                    self.yang_parent_name = "hd-info"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict()
                                                                                    self._segment_path = lambda: "data-hd"
                                                                                    self._is_frozen = True


                                                                    class Cac(Entity):
                                                                        """
                                                                        cac
                                                                        
                                                                        .. attribute:: flow_rate
                                                                        
                                                                        	flow rate
                                                                        	**type**\:  :py:class:`FlowRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate>`
                                                                        
                                                                        .. attribute:: rate
                                                                        
                                                                        	rate
                                                                        	**type**\:  :py:class:`Rate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate>`
                                                                        
                                                                        .. attribute:: cac_type
                                                                        
                                                                        	cac type
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: idle_timeout
                                                                        
                                                                        	idle timeout
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..65535
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac, self).__init__()

                                                                            self.yang_name = "cac"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("flow-rate", ("flow_rate", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate)), ("rate", ("rate", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate))])
                                                                            self._leafs = OrderedDict([
                                                                                ('cac_type', (YLeaf(YType.uint8, 'cac-type'), ['int'])),
                                                                                ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                            ])
                                                                            self.cac_type = None
                                                                            self.idle_timeout = None

                                                                            self.flow_rate = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate()
                                                                            self.flow_rate.parent = self
                                                                            self._children_name_map["flow_rate"] = "flow-rate"

                                                                            self.rate = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate()
                                                                            self.rate.parent = self
                                                                            self._children_name_map["rate"] = "rate"
                                                                            self._segment_path = lambda: "cac"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac, ['cac_type', 'idle_timeout'], name, value)


                                                                        class FlowRate(Entity):
                                                                            """
                                                                            flow rate
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate, self).__init__()

                                                                                self.yang_name = "flow-rate"
                                                                                self.yang_parent_name = "cac"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "flow-rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate, ['value', 'unit'], name, value)


                                                                        class Rate(Entity):
                                                                            """
                                                                            rate
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate, self).__init__()

                                                                                self.yang_name = "rate"
                                                                                self.yang_parent_name = "cac"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate, ['value', 'unit'], name, value)


                                                                    class Pfc(Entity):
                                                                        """
                                                                        pfc
                                                                        
                                                                        .. attribute:: buffer_size
                                                                        
                                                                        	buffer size
                                                                        	**type**\:  :py:class:`BufferSize <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize>`
                                                                        
                                                                        .. attribute:: pause_threshold
                                                                        
                                                                        	pause threshold
                                                                        	**type**\:  :py:class:`PauseThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold>`
                                                                        
                                                                        .. attribute:: resume_threshold
                                                                        
                                                                        	resume threshold
                                                                        	**type**\:  :py:class:`ResumeThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold>`
                                                                        
                                                                        .. attribute:: pfc_pause_set
                                                                        
                                                                        	pfc pause set
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: buffer_size_flag
                                                                        
                                                                        	buffer size flag
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc, self).__init__()

                                                                            self.yang_name = "pfc"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("buffer-size", ("buffer_size", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize)), ("pause-threshold", ("pause_threshold", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold)), ("resume-threshold", ("resume_threshold", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold))])
                                                                            self._leafs = OrderedDict([
                                                                                ('pfc_pause_set', (YLeaf(YType.uint32, 'pfc-pause-set'), ['int'])),
                                                                                ('buffer_size_flag', (YLeaf(YType.uint32, 'buffer-size-flag'), ['int'])),
                                                                            ])
                                                                            self.pfc_pause_set = None
                                                                            self.buffer_size_flag = None

                                                                            self.buffer_size = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize()
                                                                            self.buffer_size.parent = self
                                                                            self._children_name_map["buffer_size"] = "buffer-size"

                                                                            self.pause_threshold = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold()
                                                                            self.pause_threshold.parent = self
                                                                            self._children_name_map["pause_threshold"] = "pause-threshold"

                                                                            self.resume_threshold = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold()
                                                                            self.resume_threshold.parent = self
                                                                            self._children_name_map["resume_threshold"] = "resume-threshold"
                                                                            self._segment_path = lambda: "pfc"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc, ['pfc_pause_set', 'buffer_size_flag'], name, value)


                                                                        class BufferSize(Entity):
                                                                            """
                                                                            buffer size
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize, self).__init__()

                                                                                self.yang_name = "buffer-size"
                                                                                self.yang_parent_name = "pfc"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "buffer-size"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize, ['value', 'unit'], name, value)


                                                                        class PauseThreshold(Entity):
                                                                            """
                                                                            pause threshold
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold, self).__init__()

                                                                                self.yang_name = "pause-threshold"
                                                                                self.yang_parent_name = "pfc"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "pause-threshold"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold, ['value', 'unit'], name, value)


                                                                        class ResumeThreshold(Entity):
                                                                            """
                                                                            resume threshold
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold, self).__init__()

                                                                                self.yang_name = "resume-threshold"
                                                                                self.yang_parent_name = "pfc"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "resume-threshold"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold, ['value', 'unit'], name, value)


                                                                    class FlowParm(Entity):
                                                                        """
                                                                        flow parm
                                                                        
                                                                        .. attribute:: max_mon_flows
                                                                        
                                                                        	max simult flows monitored per policy class
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: mon_interval
                                                                        
                                                                        	monitored interval duration in secs
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: second
                                                                        
                                                                        .. attribute:: intvl_hist
                                                                        
                                                                        	num intervals of data stored on rtr
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: flow_timeout
                                                                        
                                                                        	timeout in secs
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: second
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm, self).__init__()

                                                                            self.yang_name = "flow-parm"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('max_mon_flows', (YLeaf(YType.uint32, 'max-mon-flows'), ['int'])),
                                                                                ('mon_interval', (YLeaf(YType.uint32, 'mon-interval'), ['int'])),
                                                                                ('intvl_hist', (YLeaf(YType.uint32, 'intvl-hist'), ['int'])),
                                                                                ('flow_timeout', (YLeaf(YType.uint32, 'flow-timeout'), ['int'])),
                                                                            ])
                                                                            self.max_mon_flows = None
                                                                            self.mon_interval = None
                                                                            self.intvl_hist = None
                                                                            self.flow_timeout = None
                                                                            self._segment_path = lambda: "flow-parm"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm, ['max_mon_flows', 'mon_interval', 'intvl_hist', 'flow_timeout'], name, value)


                                                                    class Ipcbr(Entity):
                                                                        """
                                                                        ipcbr
                                                                        
                                                                        .. attribute:: ip_bit_rate
                                                                        
                                                                        	data rate in bps
                                                                        	**type**\:  :py:class:`IpBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate>`
                                                                        
                                                                        .. attribute:: media_bit_rate
                                                                        
                                                                        	media data rate in bps
                                                                        	**type**\:  :py:class:`MediaBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate>`
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: ip_pkt_rate
                                                                        
                                                                        	packet rate in pps
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: media_pkt_size
                                                                        
                                                                        	media packet size in bytes
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: media_pkts_per_ip
                                                                        
                                                                        	media packets per ip pkt
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr, self).__init__()

                                                                            self.yang_name = "ipcbr"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("ip-bit-rate", ("ip_bit_rate", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate)), ("media-bit-rate", ("media_bit_rate", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate))])
                                                                            self._leafs = OrderedDict([
                                                                                ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                                ('ip_pkt_rate', (YLeaf(YType.uint32, 'ip-pkt-rate'), ['int'])),
                                                                                ('media_pkt_size', (YLeaf(YType.uint32, 'media-pkt-size'), ['int'])),
                                                                                ('media_pkts_per_ip', (YLeaf(YType.uint32, 'media-pkts-per-ip'), ['int'])),
                                                                            ])
                                                                            self.action_metric_type = None
                                                                            self.ip_pkt_rate = None
                                                                            self.media_pkt_size = None
                                                                            self.media_pkts_per_ip = None

                                                                            self.ip_bit_rate = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate()
                                                                            self.ip_bit_rate.parent = self
                                                                            self._children_name_map["ip_bit_rate"] = "ip-bit-rate"

                                                                            self.media_bit_rate = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate()
                                                                            self.media_bit_rate.parent = self
                                                                            self._children_name_map["media_bit_rate"] = "media-bit-rate"
                                                                            self._segment_path = lambda: "ipcbr"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr, ['action_metric_type', 'ip_pkt_rate', 'media_pkt_size', 'media_pkts_per_ip'], name, value)


                                                                        class IpBitRate(Entity):
                                                                            """
                                                                            data rate in bps
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate, self).__init__()

                                                                                self.yang_name = "ip-bit-rate"
                                                                                self.yang_parent_name = "ipcbr"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "ip-bit-rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate, ['value', 'unit'], name, value)


                                                                        class MediaBitRate(Entity):
                                                                            """
                                                                            media data rate in bps
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate, self).__init__()

                                                                                self.yang_name = "media-bit-rate"
                                                                                self.yang_parent_name = "ipcbr"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "media-bit-rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate, ['value', 'unit'], name, value)


                                                                    class Rtp(Entity):
                                                                        """
                                                                        rtp
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: min_sequential
                                                                        
                                                                        	min sequential
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_dropout
                                                                        
                                                                        	max dropout
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_misorder
                                                                        
                                                                        	max misorder
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: seq_ext_cop4
                                                                        
                                                                        	enable seq extension cop4
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: clock_rate
                                                                        
                                                                        	clock rate
                                                                        	**type**\: list of  		 :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp, self).__init__()

                                                                            self.yang_name = "rtp"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("clock-rate", ("clock_rate", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate))])
                                                                            self._leafs = OrderedDict([
                                                                                ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                                ('min_sequential', (YLeaf(YType.uint32, 'min-sequential'), ['int'])),
                                                                                ('max_dropout', (YLeaf(YType.uint32, 'max-dropout'), ['int'])),
                                                                                ('max_misorder', (YLeaf(YType.uint32, 'max-misorder'), ['int'])),
                                                                                ('seq_ext_cop4', (YLeaf(YType.uint32, 'seq-ext-cop4'), ['int'])),
                                                                            ])
                                                                            self.action_metric_type = None
                                                                            self.min_sequential = None
                                                                            self.max_dropout = None
                                                                            self.max_misorder = None
                                                                            self.seq_ext_cop4 = None

                                                                            self.clock_rate = YList(self)
                                                                            self._segment_path = lambda: "rtp"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp, ['action_metric_type', 'min_sequential', 'max_dropout', 'max_misorder', 'seq_ext_cop4'], name, value)


                                                                        class ClockRate(Entity):
                                                                            """
                                                                            clock rate
                                                                            
                                                                            .. attribute:: pt
                                                                            
                                                                            	pt
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: frequency
                                                                            
                                                                            	frequency
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate, self).__init__()

                                                                                self.yang_name = "clock-rate"
                                                                                self.yang_parent_name = "rtp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('pt', (YLeaf(YType.uint32, 'pt'), ['int'])),
                                                                                    ('frequency', (YLeaf(YType.uint32, 'frequency'), ['int'])),
                                                                                ])
                                                                                self.pt = None
                                                                                self.frequency = None
                                                                                self._segment_path = lambda: "clock-rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate, ['pt', 'frequency'], name, value)


                                                                    class RtpMmr(Entity):
                                                                        """
                                                                        rtp mmr
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: min_sequential
                                                                        
                                                                        	min sequential
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_dropout
                                                                        
                                                                        	max dropout
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_misorder
                                                                        
                                                                        	max misorder
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: seq_ext_cop4
                                                                        
                                                                        	enable seq extension cop4
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: clock_rate
                                                                        
                                                                        	clock rate
                                                                        	**type**\: list of  		 :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr, self).__init__()

                                                                            self.yang_name = "rtp-mmr"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("clock-rate", ("clock_rate", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate))])
                                                                            self._leafs = OrderedDict([
                                                                                ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                                ('min_sequential', (YLeaf(YType.uint32, 'min-sequential'), ['int'])),
                                                                                ('max_dropout', (YLeaf(YType.uint32, 'max-dropout'), ['int'])),
                                                                                ('max_misorder', (YLeaf(YType.uint32, 'max-misorder'), ['int'])),
                                                                                ('seq_ext_cop4', (YLeaf(YType.uint32, 'seq-ext-cop4'), ['int'])),
                                                                            ])
                                                                            self.action_metric_type = None
                                                                            self.min_sequential = None
                                                                            self.max_dropout = None
                                                                            self.max_misorder = None
                                                                            self.seq_ext_cop4 = None

                                                                            self.clock_rate = YList(self)
                                                                            self._segment_path = lambda: "rtp-mmr"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr, ['action_metric_type', 'min_sequential', 'max_dropout', 'max_misorder', 'seq_ext_cop4'], name, value)


                                                                        class ClockRate(Entity):
                                                                            """
                                                                            clock rate
                                                                            
                                                                            .. attribute:: pt
                                                                            
                                                                            	pt
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: frequency
                                                                            
                                                                            	frequency
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate, self).__init__()

                                                                                self.yang_name = "clock-rate"
                                                                                self.yang_parent_name = "rtp-mmr"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('pt', (YLeaf(YType.uint32, 'pt'), ['int'])),
                                                                                    ('frequency', (YLeaf(YType.uint32, 'frequency'), ['int'])),
                                                                                ])
                                                                                self.pt = None
                                                                                self.frequency = None
                                                                                self._segment_path = lambda: "clock-rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate, ['pt', 'frequency'], name, value)


                                                                    class RtpJ2k(Entity):
                                                                        """
                                                                        rtp j2k
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: min_sequential
                                                                        
                                                                        	min sequential
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_dropout
                                                                        
                                                                        	max dropout
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_misorder
                                                                        
                                                                        	max misorder
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: seq_ext_cop4
                                                                        
                                                                        	enable seq extension cop4
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: clock_rate
                                                                        
                                                                        	clock rate
                                                                        	**type**\: list of  		 :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k.ClockRate>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k, self).__init__()

                                                                            self.yang_name = "rtp-j2k"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("clock-rate", ("clock_rate", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k.ClockRate))])
                                                                            self._leafs = OrderedDict([
                                                                                ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                                ('min_sequential', (YLeaf(YType.uint32, 'min-sequential'), ['int'])),
                                                                                ('max_dropout', (YLeaf(YType.uint32, 'max-dropout'), ['int'])),
                                                                                ('max_misorder', (YLeaf(YType.uint32, 'max-misorder'), ['int'])),
                                                                                ('seq_ext_cop4', (YLeaf(YType.uint32, 'seq-ext-cop4'), ['int'])),
                                                                            ])
                                                                            self.action_metric_type = None
                                                                            self.min_sequential = None
                                                                            self.max_dropout = None
                                                                            self.max_misorder = None
                                                                            self.seq_ext_cop4 = None

                                                                            self.clock_rate = YList(self)
                                                                            self._segment_path = lambda: "rtp-j2k"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k, ['action_metric_type', 'min_sequential', 'max_dropout', 'max_misorder', 'seq_ext_cop4'], name, value)


                                                                        class ClockRate(Entity):
                                                                            """
                                                                            clock rate
                                                                            
                                                                            .. attribute:: pt
                                                                            
                                                                            	pt
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: frequency
                                                                            
                                                                            	frequency
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k.ClockRate, self).__init__()

                                                                                self.yang_name = "clock-rate"
                                                                                self.yang_parent_name = "rtp-j2k"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('pt', (YLeaf(YType.uint32, 'pt'), ['int'])),
                                                                                    ('frequency', (YLeaf(YType.uint32, 'frequency'), ['int'])),
                                                                                ])
                                                                                self.pt = None
                                                                                self.frequency = None
                                                                                self._segment_path = lambda: "clock-rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k.ClockRate, ['pt', 'frequency'], name, value)


                                                                    class RtpVoice(Entity):
                                                                        """
                                                                        rtp voice
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: min_sequential
                                                                        
                                                                        	min sequential
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_dropout
                                                                        
                                                                        	max dropout
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_misorder
                                                                        
                                                                        	max misorder
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: seq_ext_cop4
                                                                        
                                                                        	enable seq extension cop4
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: clock_rate
                                                                        
                                                                        	clock rate
                                                                        	**type**\: list of  		 :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice, self).__init__()

                                                                            self.yang_name = "rtp-voice"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("clock-rate", ("clock_rate", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate))])
                                                                            self._leafs = OrderedDict([
                                                                                ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                                ('min_sequential', (YLeaf(YType.uint32, 'min-sequential'), ['int'])),
                                                                                ('max_dropout', (YLeaf(YType.uint32, 'max-dropout'), ['int'])),
                                                                                ('max_misorder', (YLeaf(YType.uint32, 'max-misorder'), ['int'])),
                                                                                ('seq_ext_cop4', (YLeaf(YType.uint32, 'seq-ext-cop4'), ['int'])),
                                                                            ])
                                                                            self.action_metric_type = None
                                                                            self.min_sequential = None
                                                                            self.max_dropout = None
                                                                            self.max_misorder = None
                                                                            self.seq_ext_cop4 = None

                                                                            self.clock_rate = YList(self)
                                                                            self._segment_path = lambda: "rtp-voice"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice, ['action_metric_type', 'min_sequential', 'max_dropout', 'max_misorder', 'seq_ext_cop4'], name, value)


                                                                        class ClockRate(Entity):
                                                                            """
                                                                            clock rate
                                                                            
                                                                            .. attribute:: pt
                                                                            
                                                                            	pt
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: frequency
                                                                            
                                                                            	frequency
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate, self).__init__()

                                                                                self.yang_name = "clock-rate"
                                                                                self.yang_parent_name = "rtp-voice"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('pt', (YLeaf(YType.uint32, 'pt'), ['int'])),
                                                                                    ('frequency', (YLeaf(YType.uint32, 'frequency'), ['int'])),
                                                                                ])
                                                                                self.pt = None
                                                                                self.frequency = None
                                                                                self._segment_path = lambda: "clock-rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate, ['pt', 'frequency'], name, value)


                                                                    class Mdi(Entity):
                                                                        """
                                                                        mdi
                                                                        
                                                                        .. attribute:: ip_bit_rate
                                                                        
                                                                        	data rate in bps
                                                                        	**type**\:  :py:class:`IpBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate>`
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: filtered_pkt_rate
                                                                        
                                                                        	filtered packet rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: ip_pkt_rate
                                                                        
                                                                        	packet rate in pps
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: pids
                                                                        
                                                                        	array of monitoredcd  pids
                                                                        	**type**\: list of int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi, self).__init__()

                                                                            self.yang_name = "mdi"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("ip-bit-rate", ("ip_bit_rate", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate))])
                                                                            self._leafs = OrderedDict([
                                                                                ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                                ('filtered_pkt_rate', (YLeaf(YType.uint32, 'filtered-pkt-rate'), ['int'])),
                                                                                ('ip_pkt_rate', (YLeaf(YType.uint32, 'ip-pkt-rate'), ['int'])),
                                                                                ('pids', (YLeafList(YType.uint32, 'pids'), ['int'])),
                                                                            ])
                                                                            self.action_metric_type = None
                                                                            self.filtered_pkt_rate = None
                                                                            self.ip_pkt_rate = None
                                                                            self.pids = []

                                                                            self.ip_bit_rate = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate()
                                                                            self.ip_bit_rate.parent = self
                                                                            self._children_name_map["ip_bit_rate"] = "ip-bit-rate"
                                                                            self._segment_path = lambda: "mdi"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi, ['action_metric_type', 'filtered_pkt_rate', 'ip_pkt_rate', 'pids'], name, value)


                                                                        class IpBitRate(Entity):
                                                                            """
                                                                            data rate in bps
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate, self).__init__()

                                                                                self.yang_name = "ip-bit-rate"
                                                                                self.yang_parent_name = "mdi"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "ip-bit-rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate, ['value', 'unit'], name, value)


                                                                    class MdiRtp(Entity):
                                                                        """
                                                                        mdi rtp
                                                                        
                                                                        .. attribute:: ip_bit_rate
                                                                        
                                                                        	data rate in bps
                                                                        	**type**\:  :py:class:`IpBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate>`
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: filtered_pkt_rate
                                                                        
                                                                        	filtered packet rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: ip_pkt_rate
                                                                        
                                                                        	packet rate in pps
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: pids
                                                                        
                                                                        	array of monitoredcd  pids
                                                                        	**type**\: list of int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp, self).__init__()

                                                                            self.yang_name = "mdi-rtp"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("ip-bit-rate", ("ip_bit_rate", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate))])
                                                                            self._leafs = OrderedDict([
                                                                                ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                                ('filtered_pkt_rate', (YLeaf(YType.uint32, 'filtered-pkt-rate'), ['int'])),
                                                                                ('ip_pkt_rate', (YLeaf(YType.uint32, 'ip-pkt-rate'), ['int'])),
                                                                                ('pids', (YLeafList(YType.uint32, 'pids'), ['int'])),
                                                                            ])
                                                                            self.action_metric_type = None
                                                                            self.filtered_pkt_rate = None
                                                                            self.ip_pkt_rate = None
                                                                            self.pids = []

                                                                            self.ip_bit_rate = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate()
                                                                            self.ip_bit_rate.parent = self
                                                                            self._children_name_map["ip_bit_rate"] = "ip-bit-rate"
                                                                            self._segment_path = lambda: "mdi-rtp"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp, ['action_metric_type', 'filtered_pkt_rate', 'ip_pkt_rate', 'pids'], name, value)


                                                                        class IpBitRate(Entity):
                                                                            """
                                                                            data rate in bps
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate, self).__init__()

                                                                                self.yang_name = "ip-bit-rate"
                                                                                self.yang_parent_name = "mdi-rtp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "ip-bit-rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate, ['value', 'unit'], name, value)


                                                                    class Fmm(Entity):
                                                                        """
                                                                        fmm
                                                                        
                                                                        .. attribute:: fmm_name
                                                                        
                                                                        	flow monitor name
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..33
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm, self).__init__()

                                                                            self.yang_name = "fmm"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('fmm_name', (YLeaf(YType.str, 'fmm-name'), ['str'])),
                                                                            ])
                                                                            self.fmm_name = None
                                                                            self._segment_path = lambda: "fmm"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm, ['fmm_name'], name, value)


                                                                    class Pbf(Entity):
                                                                        """
                                                                        pbf
                                                                        
                                                                        .. attribute:: action_pbf_info_array
                                                                        
                                                                        	action pbf info array
                                                                        	**type**\: list of  		 :py:class:`ActionPbfInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf, self).__init__()

                                                                            self.yang_name = "pbf"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("action-pbf-info-array", ("action_pbf_info_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.action_pbf_info_array = YList(self)
                                                                            self._segment_path = lambda: "pbf"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf, [], name, value)


                                                                        class ActionPbfInfoArray(Entity):
                                                                            """
                                                                            action pbf info array
                                                                            
                                                                            .. attribute:: addr
                                                                            
                                                                            	v4 or v6 address
                                                                            	**type**\: str
                                                                            
                                                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                            
                                                                            .. attribute:: vrf
                                                                            
                                                                            	vrf name
                                                                            	**type**\: str
                                                                            
                                                                            .. attribute:: rt_type
                                                                            
                                                                            	route target type
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: rt
                                                                            
                                                                            	route target
                                                                            	**type**\: str
                                                                            
                                                                            	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray, self).__init__()

                                                                                self.yang_name = "action-pbf-info-array"
                                                                                self.yang_parent_name = "pbf"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('addr', (YLeaf(YType.str, 'addr'), ['str'])),
                                                                                    ('vrf', (YLeaf(YType.str, 'vrf'), ['str'])),
                                                                                    ('rt_type', (YLeaf(YType.uint8, 'rt-type'), ['int'])),
                                                                                    ('rt', (YLeaf(YType.str, 'rt'), ['str'])),
                                                                                ])
                                                                                self.addr = None
                                                                                self.vrf = None
                                                                                self.rt_type = None
                                                                                self.rt = None
                                                                                self._segment_path = lambda: "action-pbf-info-array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray, ['addr', 'vrf', 'rt_type', 'rt'], name, value)


                                                                    class Ipv4Nh(Entity):
                                                                        """
                                                                        ipv4 nh
                                                                        
                                                                        .. attribute:: action_ipv4_nh_info_array
                                                                        
                                                                        	action ipv4 nh info array
                                                                        	**type**\: list of  		 :py:class:`ActionIpv4NhInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh, self).__init__()

                                                                            self.yang_name = "ipv4-nh"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("action-ipv4-nh-info-array", ("action_ipv4_nh_info_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.action_ipv4_nh_info_array = YList(self)
                                                                            self._segment_path = lambda: "ipv4-nh"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh, [], name, value)


                                                                        class ActionIpv4NhInfoArray(Entity):
                                                                            """
                                                                            action ipv4 nh info array
                                                                            
                                                                            .. attribute:: nh_addr
                                                                            
                                                                            	nh addr
                                                                            	**type**\: str
                                                                            
                                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                            
                                                                            .. attribute:: vrf_name
                                                                            
                                                                            	Vrf name
                                                                            	**type**\: str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray, self).__init__()

                                                                                self.yang_name = "action-ipv4-nh-info-array"
                                                                                self.yang_parent_name = "ipv4-nh"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('nh_addr', (YLeaf(YType.str, 'nh-addr'), ['str'])),
                                                                                    ('vrf_name', (YLeaf(YType.str, 'vrf-name'), ['str'])),
                                                                                ])
                                                                                self.nh_addr = None
                                                                                self.vrf_name = None
                                                                                self._segment_path = lambda: "action-ipv4-nh-info-array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray, ['nh_addr', 'vrf_name'], name, value)


                                                                    class Ipv6Nh(Entity):
                                                                        """
                                                                        ipv6 nh
                                                                        
                                                                        .. attribute:: action_ipv6_nh_info_array
                                                                        
                                                                        	action ipv6 nh info array
                                                                        	**type**\: list of  		 :py:class:`ActionIpv6NhInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh, self).__init__()

                                                                            self.yang_name = "ipv6-nh"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("action-ipv6-nh-info-array", ("action_ipv6_nh_info_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.action_ipv6_nh_info_array = YList(self)
                                                                            self._segment_path = lambda: "ipv6-nh"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh, [], name, value)


                                                                        class ActionIpv6NhInfoArray(Entity):
                                                                            """
                                                                            action ipv6 nh info array
                                                                            
                                                                            .. attribute:: nh_addr
                                                                            
                                                                            	IPV6 Address
                                                                            	**type**\: str
                                                                            
                                                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                            
                                                                            .. attribute:: vrf_name
                                                                            
                                                                            	Vrf name
                                                                            	**type**\: str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray, self).__init__()

                                                                                self.yang_name = "action-ipv6-nh-info-array"
                                                                                self.yang_parent_name = "ipv6-nh"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('nh_addr', (YLeaf(YType.str, 'nh-addr'), ['str'])),
                                                                                    ('vrf_name', (YLeaf(YType.str, 'vrf-name'), ['str'])),
                                                                                ])
                                                                                self.nh_addr = None
                                                                                self.vrf_name = None
                                                                                self._segment_path = lambda: "action-ipv6-nh-info-array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray, ['nh_addr', 'vrf_name'], name, value)


                                class PmapVarList(Entity):
                                    """
                                    pmap var list
                                    
                                    .. attribute:: var_list
                                    
                                    	var list
                                    	**type**\: list of  		 :py:class:`VarList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.PmapVarList.VarList>`
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2018-01-17'

                                    def __init__(self):
                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.PmapVarList, self).__init__()

                                        self.yang_name = "pmap-var-list"
                                        self.yang_parent_name = "detail"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("var-list", ("var_list", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.PmapVarList.VarList))])
                                        self._leafs = OrderedDict()

                                        self.var_list = YList(self)
                                        self._segment_path = lambda: "pmap-var-list"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.PmapVarList, [], name, value)


                                    class VarList(Entity):
                                        """
                                        var list
                                        
                                        .. attribute:: type
                                        
                                        	type
                                        	**type**\:  :py:class:`PlmgrVarTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrVarTypeEn>`
                                        
                                        .. attribute:: class_name
                                        
                                        	class name
                                        	**type**\: str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: uint8_val
                                        
                                        	uint8 val
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: uint16_val
                                        
                                        	uint16 val
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: uint32_val
                                        
                                        	uint32 val
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: param_uint32_val
                                        
                                        	param uint32 val
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: dscp_val
                                        
                                        	dscp val
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: prec_val
                                        
                                        	prec val
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'infra-policymgr-oper'
                                        _revision = '2018-01-17'

                                        def __init__(self):
                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.PmapVarList.VarList, self).__init__()

                                            self.yang_name = "var-list"
                                            self.yang_parent_name = "pmap-var-list"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PlmgrVarTypeEn', '')])),
                                                ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                ('uint8_val', (YLeaf(YType.uint8, 'uint8_val'), ['int'])),
                                                ('uint16_val', (YLeaf(YType.uint16, 'uint16_val'), ['int'])),
                                                ('uint32_val', (YLeaf(YType.uint32, 'uint32_val'), ['int'])),
                                                ('param_uint32_val', (YLeaf(YType.uint32, 'param-uint32-val'), ['int'])),
                                                ('dscp_val', (YLeaf(YType.uint8, 'dscp-val'), ['int'])),
                                                ('prec_val', (YLeaf(YType.uint8, 'prec-val'), ['int'])),
                                            ])
                                            self.type = None
                                            self.class_name = None
                                            self.uint8_val = None
                                            self.uint16_val = None
                                            self.uint32_val = None
                                            self.param_uint32_val = None
                                            self.dscp_val = None
                                            self.prec_val = None
                                            self._segment_path = lambda: "var-list"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.PmapVarList.VarList, ['type', 'class_name', 'uint8_val', 'uint16_val', 'uint32_val', 'param_uint32_val', 'dscp_val', 'prec_val'], name, value)


                        class Output(Entity):
                            """
                            Output direction table
                            
                            .. attribute:: detail
                            
                            	WORD interface name
                            	**type**\:  :py:class:`Detail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail>`
                            
                            

                            """

                            _prefix = 'infra-policymgr-oper'
                            _revision = '2018-01-17'

                            def __init__(self):
                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output, self).__init__()

                                self.yang_name = "output"
                                self.yang_parent_name = "if-name"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("detail", ("detail", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail))])
                                self._leafs = OrderedDict()

                                self.detail = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail()
                                self.detail.parent = self
                                self._children_name_map["detail"] = "detail"
                                self._segment_path = lambda: "output"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output, [], name, value)


                            class Detail(Entity):
                                """
                                WORD interface name
                                
                                .. attribute:: parent_pmap_name
                                
                                	parent pmap name
                                	**type**\: str
                                
                                	**length:** 0..65
                                
                                .. attribute:: pmap_type
                                
                                	pmap type
                                	**type**\:  :py:class:`PolicyMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyMapTypeEn>`
                                
                                .. attribute:: subscriber_grp
                                
                                	subscriber grp
                                	**type**\: list of str
                                
                                	**length:** 0..65
                                
                                .. attribute:: pmaps
                                
                                	pmaps
                                	**type**\: list of  		 :py:class:`Pmaps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps>`
                                
                                .. attribute:: pmap_var_list
                                
                                	pmap var list
                                	**type**\: list of  		 :py:class:`PmapVarList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.PmapVarList>`
                                
                                

                                """

                                _prefix = 'infra-policymgr-oper'
                                _revision = '2018-01-17'

                                def __init__(self):
                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail, self).__init__()

                                    self.yang_name = "detail"
                                    self.yang_parent_name = "output"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("pmaps", ("pmaps", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps)), ("pmap-var-list", ("pmap_var_list", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.PmapVarList))])
                                    self._leafs = OrderedDict([
                                        ('parent_pmap_name', (YLeaf(YType.str, 'parent-pmap-name'), ['str'])),
                                        ('pmap_type', (YLeaf(YType.enumeration, 'pmap-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyMapTypeEn', '')])),
                                        ('subscriber_grp', (YLeafList(YType.str, 'subscriber-grp'), ['str'])),
                                    ])
                                    self.parent_pmap_name = None
                                    self.pmap_type = None
                                    self.subscriber_grp = []

                                    self.pmaps = YList(self)
                                    self.pmap_var_list = YList(self)
                                    self._segment_path = lambda: "detail"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail, ['parent_pmap_name', 'pmap_type', 'subscriber_grp'], name, value)


                                class Pmaps(Entity):
                                    """
                                    pmaps
                                    
                                    .. attribute:: policy_map_bg
                                    
                                    	policy map bg
                                    	**type**\: list of  		 :py:class:`PolicyMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg>`
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2018-01-17'

                                    def __init__(self):
                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps, self).__init__()

                                        self.yang_name = "pmaps"
                                        self.yang_parent_name = "detail"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("policy-map-bg", ("policy_map_bg", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg))])
                                        self._leafs = OrderedDict()

                                        self.policy_map_bg = YList(self)
                                        self._segment_path = lambda: "pmaps"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps, [], name, value)


                                    class PolicyMapBg(Entity):
                                        """
                                        policy map bg
                                        
                                        .. attribute:: pmap_var_list
                                        
                                        	pmap var list
                                        	**type**\:  :py:class:`PmapVarList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.PmapVarList>`
                                        
                                        .. attribute:: event_infop
                                        
                                        	event infop
                                        	**type**\:  :py:class:`EventInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop>`
                                        
                                        .. attribute:: name
                                        
                                        	name
                                        	**type**\: str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: type
                                        
                                        	type
                                        	**type**\:  :py:class:`PolicyMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyMapTypeEn>`
                                        
                                        .. attribute:: description
                                        
                                        	description
                                        	**type**\: str
                                        
                                        

                                        """

                                        _prefix = 'infra-policymgr-oper'
                                        _revision = '2018-01-17'

                                        def __init__(self):
                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg, self).__init__()

                                            self.yang_name = "policy-map-bg"
                                            self.yang_parent_name = "pmaps"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("pmap-var-list", ("pmap_var_list", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.PmapVarList)), ("event-infop", ("event_infop", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop))])
                                            self._leafs = OrderedDict([
                                                ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyMapTypeEn', '')])),
                                                ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                            ])
                                            self.name = None
                                            self.type = None
                                            self.description = None

                                            self.pmap_var_list = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.PmapVarList()
                                            self.pmap_var_list.parent = self
                                            self._children_name_map["pmap_var_list"] = "pmap-var-list"

                                            self.event_infop = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop()
                                            self.event_infop.parent = self
                                            self._children_name_map["event_infop"] = "event-infop"
                                            self._segment_path = lambda: "policy-map-bg"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg, ['name', 'type', 'description'], name, value)


                                        class PmapVarList(Entity):
                                            """
                                            pmap var list
                                            
                                            .. attribute:: pmap_var_list_arr
                                            
                                            	pmap var list arr
                                            	**type**\: list of  		 :py:class:`PmapVarListArr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.PmapVarList.PmapVarListArr>`
                                            
                                            

                                            """

                                            _prefix = 'infra-policymgr-oper'
                                            _revision = '2018-01-17'

                                            def __init__(self):
                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.PmapVarList, self).__init__()

                                                self.yang_name = "pmap-var-list"
                                                self.yang_parent_name = "policy-map-bg"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("pmap-var-list-arr", ("pmap_var_list_arr", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.PmapVarList.PmapVarListArr))])
                                                self._leafs = OrderedDict()

                                                self.pmap_var_list_arr = YList(self)
                                                self._segment_path = lambda: "pmap-var-list"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.PmapVarList, [], name, value)


                                            class PmapVarListArr(Entity):
                                                """
                                                pmap var list arr
                                                
                                                .. attribute:: val
                                                
                                                	val
                                                	**type**\:  :py:class:`Val <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.PmapVarList.PmapVarListArr.Val>`
                                                
                                                .. attribute:: name
                                                
                                                	name
                                                	**type**\: str
                                                
                                                	**length:** 0..32
                                                
                                                .. attribute:: id
                                                
                                                	id
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.PmapVarList.PmapVarListArr, self).__init__()

                                                    self.yang_name = "pmap-var-list-arr"
                                                    self.yang_parent_name = "pmap-var-list"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("val", ("val", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.PmapVarList.PmapVarListArr.Val))])
                                                    self._leafs = OrderedDict([
                                                        ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                        ('id', (YLeaf(YType.uint32, 'id'), ['int'])),
                                                    ])
                                                    self.name = None
                                                    self.id = None

                                                    self.val = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.PmapVarList.PmapVarListArr.Val()
                                                    self.val.parent = self
                                                    self._children_name_map["val"] = "val"
                                                    self._segment_path = lambda: "pmap-var-list-arr"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.PmapVarList.PmapVarListArr, ['name', 'id'], name, value)


                                                class Val(Entity):
                                                    """
                                                    val
                                                    
                                                    .. attribute:: type
                                                    
                                                    	type
                                                    	**type**\:  :py:class:`PlmgrVarTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrVarTypeEn>`
                                                    
                                                    .. attribute:: class_name
                                                    
                                                    	class name
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..65
                                                    
                                                    .. attribute:: uint8_val
                                                    
                                                    	uint8 val
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: uint16_val
                                                    
                                                    	uint16 val
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: uint32_val
                                                    
                                                    	uint32 val
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: param_uint32_val
                                                    
                                                    	param uint32 val
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: dscp_val
                                                    
                                                    	dscp val
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: prec_val
                                                    
                                                    	prec val
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.PmapVarList.PmapVarListArr.Val, self).__init__()

                                                        self.yang_name = "val"
                                                        self.yang_parent_name = "pmap-var-list-arr"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PlmgrVarTypeEn', '')])),
                                                            ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                            ('uint8_val', (YLeaf(YType.uint8, 'uint8_val'), ['int'])),
                                                            ('uint16_val', (YLeaf(YType.uint16, 'uint16_val'), ['int'])),
                                                            ('uint32_val', (YLeaf(YType.uint32, 'uint32_val'), ['int'])),
                                                            ('param_uint32_val', (YLeaf(YType.uint32, 'param-uint32-val'), ['int'])),
                                                            ('dscp_val', (YLeaf(YType.uint8, 'dscp-val'), ['int'])),
                                                            ('prec_val', (YLeaf(YType.uint8, 'prec-val'), ['int'])),
                                                        ])
                                                        self.type = None
                                                        self.class_name = None
                                                        self.uint8_val = None
                                                        self.uint16_val = None
                                                        self.uint32_val = None
                                                        self.param_uint32_val = None
                                                        self.dscp_val = None
                                                        self.prec_val = None
                                                        self._segment_path = lambda: "val"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.PmapVarList.PmapVarListArr.Val, ['type', 'class_name', 'uint8_val', 'uint16_val', 'uint32_val', 'param_uint32_val', 'dscp_val', 'prec_val'], name, value)


                                        class EventInfop(Entity):
                                            """
                                            event infop
                                            
                                            .. attribute:: policy_event_info_bg
                                            
                                            	policy event info bg
                                            	**type**\: list of  		 :py:class:`PolicyEventInfoBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg>`
                                            
                                            

                                            """

                                            _prefix = 'infra-policymgr-oper'
                                            _revision = '2018-01-17'

                                            def __init__(self):
                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop, self).__init__()

                                                self.yang_name = "event-infop"
                                                self.yang_parent_name = "policy-map-bg"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("policy-event-info-bg", ("policy_event_info_bg", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg))])
                                                self._leafs = OrderedDict()

                                                self.policy_event_info_bg = YList(self)
                                                self._segment_path = lambda: "event-infop"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop, [], name, value)


                                            class PolicyEventInfoBg(Entity):
                                                """
                                                policy event info bg
                                                
                                                .. attribute:: class_infop
                                                
                                                	class infop
                                                	**type**\:  :py:class:`ClassInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop>`
                                                
                                                .. attribute:: event_type
                                                
                                                	event type
                                                	**type**\:  :py:class:`PeventTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PeventTypeEn>`
                                                
                                                .. attribute:: cond_eval
                                                
                                                	cond eval
                                                	**type**\:  :py:class:`PeventCondEvalEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PeventCondEvalEn>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg, self).__init__()

                                                    self.yang_name = "policy-event-info-bg"
                                                    self.yang_parent_name = "event-infop"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("class-infop", ("class_infop", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop))])
                                                    self._leafs = OrderedDict([
                                                        ('event_type', (YLeaf(YType.enumeration, 'event-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PeventTypeEn', '')])),
                                                        ('cond_eval', (YLeaf(YType.enumeration, 'cond-eval'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PeventCondEvalEn', '')])),
                                                    ])
                                                    self.event_type = None
                                                    self.cond_eval = None

                                                    self.class_infop = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop()
                                                    self.class_infop.parent = self
                                                    self._children_name_map["class_infop"] = "class-infop"
                                                    self._segment_path = lambda: "policy-event-info-bg"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg, ['event_type', 'cond_eval'], name, value)


                                                class ClassInfop(Entity):
                                                    """
                                                    class infop
                                                    
                                                    .. attribute:: policy_class_info_bg
                                                    
                                                    	policy class info bg
                                                    	**type**\: list of  		 :py:class:`PolicyClassInfoBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop, self).__init__()

                                                        self.yang_name = "class-infop"
                                                        self.yang_parent_name = "policy-event-info-bg"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("policy-class-info-bg", ("policy_class_info_bg", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg))])
                                                        self._leafs = OrderedDict()

                                                        self.policy_class_info_bg = YList(self)
                                                        self._segment_path = lambda: "class-infop"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop, [], name, value)


                                                    class PolicyClassInfoBg(Entity):
                                                        """
                                                        policy class info bg
                                                        
                                                        .. attribute:: cl_encode
                                                        
                                                        	cl encode
                                                        	**type**\:  :py:class:`ClEncode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode>`
                                                        
                                                        .. attribute:: clmp_p
                                                        
                                                        	clmp p
                                                        	**type**\:  :py:class:`ClmpP <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP>`
                                                        
                                                        .. attribute:: act_infop
                                                        
                                                        	act infop
                                                        	**type**\:  :py:class:`ActInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop>`
                                                        
                                                        .. attribute:: policy_class_hd
                                                        
                                                        	policy class hd
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: seq
                                                        
                                                        	seq
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: flags
                                                        
                                                        	flags
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: ctype
                                                        
                                                        	ctype
                                                        	**type**\:  :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                        
                                                        .. attribute:: num_actions
                                                        
                                                        	num actions
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: version
                                                        
                                                        	version
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        .. attribute:: exe_strat
                                                        
                                                        	exe strat
                                                        	**type**\:  :py:class:`PclassExecStratEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PclassExecStratEn>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2018-01-17'

                                                        def __init__(self):
                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg, self).__init__()

                                                            self.yang_name = "policy-class-info-bg"
                                                            self.yang_parent_name = "class-infop"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("cl-encode", ("cl_encode", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode)), ("clmp-p", ("clmp_p", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP)), ("act-infop", ("act_infop", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop))])
                                                            self._leafs = OrderedDict([
                                                                ('policy_class_hd', (YLeaf(YType.uint32, 'policy-class-hd'), ['int'])),
                                                                ('seq', (YLeaf(YType.uint32, 'seq'), ['int'])),
                                                                ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                ('ctype', (YLeaf(YType.enumeration, 'ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapTypeEn', '')])),
                                                                ('num_actions', (YLeaf(YType.uint16, 'num-actions'), ['int'])),
                                                                ('version', (YLeaf(YType.uint8, 'version'), ['int'])),
                                                                ('exe_strat', (YLeaf(YType.enumeration, 'exe-strat'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PclassExecStratEn', '')])),
                                                            ])
                                                            self.policy_class_hd = None
                                                            self.seq = None
                                                            self.flags = None
                                                            self.ctype = None
                                                            self.num_actions = None
                                                            self.version = None
                                                            self.exe_strat = None

                                                            self.cl_encode = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode()
                                                            self.cl_encode.parent = self
                                                            self._children_name_map["cl_encode"] = "cl-encode"

                                                            self.clmp_p = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP()
                                                            self.clmp_p.parent = self
                                                            self._children_name_map["clmp_p"] = "clmp-p"

                                                            self.act_infop = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop()
                                                            self.act_infop.parent = self
                                                            self._children_name_map["act_infop"] = "act-infop"
                                                            self._segment_path = lambda: "policy-class-info-bg"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg, ['policy_class_hd', 'seq', 'flags', 'ctype', 'num_actions', 'version', 'exe_strat'], name, value)


                                                        class ClEncode(Entity):
                                                            """
                                                            cl encode
                                                            
                                                            .. attribute:: inline_cmap
                                                            
                                                            	inline cmap
                                                            	**type**\:  :py:class:`InlineCmap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap>`
                                                            
                                                            .. attribute:: enc
                                                            
                                                            	enc
                                                            	**type**\:  :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                            
                                                            .. attribute:: class_name
                                                            
                                                            	class name
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..65
                                                            
                                                            .. attribute:: hd
                                                            
                                                            	hd
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: idx
                                                            
                                                            	idx
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..255
                                                            
                                                            

                                                            """

                                                            _prefix = 'infra-policymgr-oper'
                                                            _revision = '2018-01-17'

                                                            def __init__(self):
                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode, self).__init__()

                                                                self.yang_name = "cl-encode"
                                                                self.yang_parent_name = "policy-class-info-bg"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("inline-cmap", ("inline_cmap", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap))])
                                                                self._leafs = OrderedDict([
                                                                    ('enc', (YLeaf(YType.enumeration, 'enc'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyObjEncEn', '')])),
                                                                    ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                                    ('hd', (YLeaf(YType.uint64, 'hd'), ['int'])),
                                                                    ('idx', (YLeaf(YType.uint8, 'idx'), ['int'])),
                                                                ])
                                                                self.enc = None
                                                                self.class_name = None
                                                                self.hd = None
                                                                self.idx = None

                                                                self.inline_cmap = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap()
                                                                self.inline_cmap.parent = self
                                                                self._children_name_map["inline_cmap"] = "inline-cmap"
                                                                self._segment_path = lambda: "cl-encode"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode, ['enc', 'class_name', 'hd', 'idx'], name, value)


                                                            class InlineCmap(Entity):
                                                                """
                                                                inline cmap
                                                                
                                                                .. attribute:: match_infop
                                                                
                                                                	Pointer to the first Match info
                                                                	**type**\:  :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop>`
                                                                
                                                                .. attribute:: mode
                                                                
                                                                	Inline Class\-Map Mode Match any/all
                                                                	**type**\:  :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                
                                                                .. attribute:: flags
                                                                
                                                                	Inline Class\-Map flags
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: match_count
                                                                
                                                                	Number of Match infos
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap, self).__init__()

                                                                    self.yang_name = "inline-cmap"
                                                                    self.yang_parent_name = "cl-encode"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("match-infop", ("match_infop", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop))])
                                                                    self._leafs = OrderedDict([
                                                                        ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapModeEn', '')])),
                                                                        ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                        ('match_count', (YLeaf(YType.uint32, 'match-count'), ['int'])),
                                                                    ])
                                                                    self.mode = None
                                                                    self.flags = None
                                                                    self.match_count = None

                                                                    self.match_infop = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop()
                                                                    self.match_infop.parent = self
                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                    self._segment_path = lambda: "inline-cmap"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap, ['mode', 'flags', 'match_count'], name, value)


                                                                class MatchInfop(Entity):
                                                                    """
                                                                    Pointer to the first Match info
                                                                    
                                                                    .. attribute:: class_match_info_st
                                                                    
                                                                    	class match info st
                                                                    	**type**\: list of  		 :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop, self).__init__()

                                                                        self.yang_name = "match-infop"
                                                                        self.yang_parent_name = "inline-cmap"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("class-match-info-st", ("class_match_info_st", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt))])
                                                                        self._leafs = OrderedDict()

                                                                        self.class_match_info_st = YList(self)
                                                                        self._segment_path = lambda: "match-infop"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop, [], name, value)


                                                                    class ClassMatchInfoSt(Entity):
                                                                        """
                                                                        class match info st
                                                                        
                                                                        .. attribute:: match_data
                                                                        
                                                                        	Match criteria
                                                                        	**type**\:  :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                        
                                                                        .. attribute:: flags
                                                                        
                                                                        	Flags
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                            self.yang_name = "class-match-info-st"
                                                                            self.yang_parent_name = "match-infop"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("match-data", ("match_data", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData))])
                                                                            self._leafs = OrderedDict([
                                                                                ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                            ])
                                                                            self.flags = None

                                                                            self.match_data = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                            self.match_data.parent = self
                                                                            self._children_name_map["match_data"] = "match-data"
                                                                            self._segment_path = lambda: "class-match-info-st"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                        class MatchData(Entity):
                                                                            """
                                                                            Match criteria
                                                                            
                                                                            .. attribute:: ipv4_dscp
                                                                            
                                                                            	IPv4 DSCP
                                                                            	**type**\:  :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                            
                                                                            .. attribute:: ipv6_dscp
                                                                            
                                                                            	IPv6 DSCP
                                                                            	**type**\:  :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                            
                                                                            .. attribute:: dscp
                                                                            
                                                                            	Match DSCP range array
                                                                            	**type**\:  :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                            
                                                                            .. attribute:: ipv4_prec
                                                                            
                                                                            	IPv4 Precedence
                                                                            	**type**\:  :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                            
                                                                            .. attribute:: ipv6_prec
                                                                            
                                                                            	IPv6 Precedence
                                                                            	**type**\:  :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                            
                                                                            .. attribute:: prec
                                                                            
                                                                            	Match Precedence array
                                                                            	**type**\:  :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                            
                                                                            .. attribute:: discard_class
                                                                            
                                                                            	Match Discard Class array
                                                                            	**type**\:  :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                            
                                                                            .. attribute:: qos_group
                                                                            
                                                                            	Match QoS group array
                                                                            	**type**\:  :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                            
                                                                            .. attribute:: traffic_class
                                                                            
                                                                            	Match Traffic class array
                                                                            	**type**\:  :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                            
                                                                            .. attribute:: proto
                                                                            
                                                                            	Match Protocol array
                                                                            	**type**\:  :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                            
                                                                            .. attribute:: icmp_v4
                                                                            
                                                                            	Match ICMPV4 Protocol
                                                                            	**type**\:  :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                            
                                                                            .. attribute:: icmp_v6
                                                                            
                                                                            	Match ICMPV6 Protocol array
                                                                            	**type**\:  :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                            
                                                                            .. attribute:: ipv4_packet_len
                                                                            
                                                                            	IPv4 packet length array
                                                                            	**type**\:  :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                            
                                                                            .. attribute:: ipv6_packet_len
                                                                            
                                                                            	IPv6 packet length array
                                                                            	**type**\:  :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                            
                                                                            .. attribute:: packet_len
                                                                            
                                                                            	Match packet length array
                                                                            	**type**\:  :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                            
                                                                            .. attribute:: flow_tag
                                                                            
                                                                            	Match flow\-tag array
                                                                            	**type**\:  :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                            
                                                                            .. attribute:: tcp_flag
                                                                            
                                                                            	Match tcp flag value
                                                                            	**type**\:  :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                            
                                                                            .. attribute:: icmpv4_type
                                                                            
                                                                            	Match ipv4 icmp type
                                                                            	**type**\:  :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                            
                                                                            .. attribute:: icmpv4_code
                                                                            
                                                                            	Match ipv4 icmp code
                                                                            	**type**\:  :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                            
                                                                            .. attribute:: icmpv6_type
                                                                            
                                                                            	Match ipv6 icmp type
                                                                            	**type**\:  :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                            
                                                                            .. attribute:: icmpv6_code
                                                                            
                                                                            	Match ipv6 icmp code
                                                                            	**type**\:  :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                            
                                                                            .. attribute:: mpls_exp
                                                                            
                                                                            	Match MPLS experimental topmost array
                                                                            	**type**\:  :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                            
                                                                            .. attribute:: mpls_exp_imp
                                                                            
                                                                            	Match MPLS experimental imposition array
                                                                            	**type**\:  :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                            
                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                            
                                                                            	MPLS Disposition IPv4 Access\-list
                                                                            	**type**\:  :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                            
                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                            
                                                                            	MPLS Disposition IPv6 Access\-list
                                                                            	**type**\:  :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                            
                                                                            .. attribute:: mpls_top_label
                                                                            
                                                                            	MPLS Topmost LABEL
                                                                            	**type**\:  :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                            
                                                                            .. attribute:: cos
                                                                            
                                                                            	Match CoS array
                                                                            	**type**\:  :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                            
                                                                            .. attribute:: cos_inr
                                                                            
                                                                            	Match inner header CoS
                                                                            	**type**\:  :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                            
                                                                            .. attribute:: dei
                                                                            
                                                                            	Match DEI Bit
                                                                            	**type**\:  :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                            
                                                                            .. attribute:: dei_inr
                                                                            
                                                                            	Match inner DEI Bit
                                                                            	**type**\:  :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                            
                                                                            .. attribute:: vlan
                                                                            
                                                                            	Match VLAN array
                                                                            	**type**\:  :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                            
                                                                            .. attribute:: vlan_inr
                                                                            
                                                                            	Match inner header VLAN range array
                                                                            	**type**\:  :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                            
                                                                            .. attribute:: fr_dlci
                                                                            
                                                                            	Match FR DLCI range array
                                                                            	**type**\:  :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                            
                                                                            .. attribute:: src_mac
                                                                            
                                                                            	Match Source MAC address
                                                                            	**type**\:  :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                            
                                                                            .. attribute:: dst_mac
                                                                            
                                                                            	Match Destination MAC address
                                                                            	**type**\:  :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                            
                                                                            .. attribute:: atm_clp
                                                                            
                                                                            	Match ATM CLP level
                                                                            	**type**\:  :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                            
                                                                            .. attribute:: fr_de
                                                                            
                                                                            	Match FR DE value
                                                                            	**type**\:  :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                            
                                                                            .. attribute:: ipv4_acl
                                                                            
                                                                            	IPv4 Access\-list
                                                                            	**type**\:  :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                            
                                                                            .. attribute:: ipv6_acl
                                                                            
                                                                            	IPv6 Access\-list
                                                                            	**type**\:  :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                            
                                                                            .. attribute:: ether_service_acl
                                                                            
                                                                            	Ethernet\-Services Access\-list
                                                                            	**type**\:  :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                            
                                                                            .. attribute:: avail_id
                                                                            
                                                                            	Available Identifiers
                                                                            	**type**\:  :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                            
                                                                            .. attribute:: media_type
                                                                            
                                                                            	Media Type
                                                                            	**type**\:  :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                            
                                                                            .. attribute:: subs_protocol
                                                                            
                                                                            	Protocol
                                                                            	**type**\:  :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                            
                                                                            .. attribute:: dnis
                                                                            
                                                                            	DNIS
                                                                            	**type**\:  :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                            
                                                                            .. attribute:: dnis_regex
                                                                            
                                                                            	DNIS Regular Expression
                                                                            	**type**\:  :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                            
                                                                            .. attribute:: domain
                                                                            
                                                                            	Domain Name
                                                                            	**type**\:  :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                            
                                                                            .. attribute:: domain_regex
                                                                            
                                                                            	Domain Regular Expression
                                                                            	**type**\:  :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                            
                                                                            .. attribute:: nas_port
                                                                            
                                                                            	NAS Port
                                                                            	**type**\:  :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                            
                                                                            .. attribute:: service_name
                                                                            
                                                                            	Service Name
                                                                            	**type**\:  :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                            
                                                                            .. attribute:: service_name_regex
                                                                            
                                                                            	Service Name Regular Exp
                                                                            	**type**\:  :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                            
                                                                            .. attribute:: src_addr_ipv4
                                                                            
                                                                            	Source Address IPV4
                                                                            	**type**\:  :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                            
                                                                            .. attribute:: dst_addr_ipv4
                                                                            
                                                                            	Destination Address IPV4
                                                                            	**type**\:  :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                            
                                                                            .. attribute:: src_addr_ipv6
                                                                            
                                                                            	Source Address IPV6
                                                                            	**type**\:  :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                            
                                                                            .. attribute:: dst_addr_ipv6
                                                                            
                                                                            	Destination Address IPV6
                                                                            	**type**\:  :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                            
                                                                            .. attribute:: src_addr_mac
                                                                            
                                                                            	Source Address MAC
                                                                            	**type**\:  :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                            
                                                                            .. attribute:: timer
                                                                            
                                                                            	Timer
                                                                            	**type**\:  :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                            
                                                                            .. attribute:: timer_regexp
                                                                            
                                                                            	Timer Regular Expression
                                                                            	**type**\:  :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                            
                                                                            .. attribute:: tunnel_name
                                                                            
                                                                            	Tunnel Name
                                                                            	**type**\:  :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                            
                                                                            .. attribute:: tunnel_name_regex
                                                                            
                                                                            	Tunnel Name Regular Expression
                                                                            	**type**\:  :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                            
                                                                            .. attribute:: user_name
                                                                            
                                                                            	User Name
                                                                            	**type**\:  :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                            
                                                                            .. attribute:: user_name_regex
                                                                            
                                                                            	User Name Regular Expression
                                                                            	**type**\:  :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                            
                                                                            .. attribute:: auth_username
                                                                            
                                                                            	Authenticated User Name
                                                                            	**type**\:  :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                            
                                                                            .. attribute:: auth_username_regex
                                                                            
                                                                            	Authenticated User Name RegEx
                                                                            	**type**\:  :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                            
                                                                            .. attribute:: unauth_username
                                                                            
                                                                            	Unauthenticated User Name
                                                                            	**type**\:  :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                            
                                                                            .. attribute:: unauth_username_regex
                                                                            
                                                                            	Unauthenticated User Name RegEx
                                                                            	**type**\:  :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                            
                                                                            .. attribute:: auth_domain
                                                                            
                                                                            	Authenticated domain name
                                                                            	**type**\:  :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                            
                                                                            .. attribute:: auth_domain_regex
                                                                            
                                                                            	Authenticated Domain Name RegEx
                                                                            	**type**\:  :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                            
                                                                            .. attribute:: unauth_domain
                                                                            
                                                                            	Unauthenticated Domain Name
                                                                            	**type**\:  :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                            
                                                                            .. attribute:: unauth_domain_regex
                                                                            
                                                                            	Unauthenticated Domain Name RegEx
                                                                            	**type**\:  :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                            
                                                                            .. attribute:: vendor_id
                                                                            
                                                                            	Vendor ID
                                                                            	**type**\:  :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                            
                                                                            .. attribute:: vendor_id_regex
                                                                            
                                                                            	Vendor ID RegEx
                                                                            	**type**\:  :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                            
                                                                            .. attribute:: access_interface
                                                                            
                                                                            	Access interface
                                                                            	**type**\:  :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                            
                                                                            .. attribute:: input_interface
                                                                            
                                                                            	Input interface
                                                                            	**type**\:  :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                            
                                                                            .. attribute:: input_intfhdl
                                                                            
                                                                            	Input interface handle
                                                                            	**type**\:  :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                            
                                                                            .. attribute:: ethertype
                                                                            
                                                                            	Ethernet type
                                                                            	**type**\:  :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                            
                                                                            .. attribute:: flow_key_data
                                                                            
                                                                            	Flow key structure
                                                                            	**type**\:  :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                            
                                                                            .. attribute:: dhcp_client_id
                                                                            
                                                                            	Dhcp Client ID
                                                                            	**type**\:  :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                            
                                                                            .. attribute:: dhcp_client_id_regex
                                                                            
                                                                            	Dhcp Client ID RegEx
                                                                            	**type**\:  :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                            
                                                                            .. attribute:: circuit_id
                                                                            
                                                                            	Circuit ID
                                                                            	**type**\:  :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                            
                                                                            .. attribute:: circuit_id_regex
                                                                            
                                                                            	Circuit ID RegEx
                                                                            	**type**\:  :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                            
                                                                            .. attribute:: remote_id
                                                                            
                                                                            	Remote ID
                                                                            	**type**\:  :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                            
                                                                            .. attribute:: remote_id_regex
                                                                            
                                                                            	Remote ID RegEx
                                                                            	**type**\:  :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                            
                                                                            .. attribute:: src_port
                                                                            
                                                                            	Source port
                                                                            	**type**\:  :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                            
                                                                            .. attribute:: dst_port
                                                                            
                                                                            	Destination port
                                                                            	**type**\:  :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:  :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                            
                                                                            .. attribute:: mpls_top_eos
                                                                            
                                                                            	MPLS Topmost EOS
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: fragment_type
                                                                            
                                                                            	Fragment type
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: authen_status
                                                                            
                                                                            	Authentication Status
                                                                            	**type**\:  :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                            
                                                                            .. attribute:: mlp_negotiated
                                                                            
                                                                            	MLP Negotiated
                                                                            	**type**\:  :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                self.yang_name = "match-data"
                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("ipv4-dscp", ("ipv4_dscp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp)), ("ipv6-dscp", ("ipv6_dscp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp)), ("dscp", ("dscp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp)), ("ipv4-prec", ("ipv4_prec", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec)), ("ipv6-prec", ("ipv6_prec", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec)), ("prec", ("prec", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec)), ("discard-class", ("discard_class", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass)), ("qos-group", ("qos_group", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup)), ("traffic-class", ("traffic_class", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass)), ("proto", ("proto", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto)), ("icmp-v4", ("icmp_v4", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4)), ("icmp-v6", ("icmp_v6", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6)), ("ipv4-packet-len", ("ipv4_packet_len", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen)), ("ipv6-packet-len", ("ipv6_packet_len", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen)), ("packet-len", ("packet_len", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen)), ("flow-tag", ("flow_tag", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag)), ("tcp-flag", ("tcp_flag", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag)), ("icmpv4-type", ("icmpv4_type", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type)), ("icmpv4-code", ("icmpv4_code", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code)), ("icmpv6-type", ("icmpv6_type", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type)), ("icmpv6-code", ("icmpv6_code", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code)), ("mpls-exp", ("mpls_exp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp)), ("mpls-exp-imp", ("mpls_exp_imp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp)), ("mpls-disp-ipv4-acl", ("mpls_disp_ipv4_acl", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl)), ("mpls-disp-ipv6-acl", ("mpls_disp_ipv6_acl", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl)), ("mpls-top-label", ("mpls_top_label", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel)), ("cos", ("cos", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos)), ("cos-inr", ("cos_inr", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr)), ("dei", ("dei", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei)), ("dei-inr", ("dei_inr", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr)), ("vlan", ("vlan", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan)), ("vlan-inr", ("vlan_inr", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)), ("fr-dlci", ("fr_dlci", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci)), ("src-mac", ("src_mac", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac)), ("dst-mac", ("dst_mac", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac)), ("atm-clp", ("atm_clp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp)), ("fr-de", ("fr_de", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe)), ("ipv4-acl", ("ipv4_acl", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl)), ("ipv6-acl", ("ipv6_acl", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl)), ("ether-service-acl", ("ether_service_acl", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl)), ("avail-id", ("avail_id", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId)), ("media-type", ("media_type", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType)), ("subs-protocol", ("subs_protocol", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol)), ("dnis", ("dnis", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis)), ("dnis-regex", ("dnis_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex)), ("domain", ("domain", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain)), ("domain-regex", ("domain_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex)), ("nas-port", ("nas_port", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort)), ("service-name", ("service_name", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName)), ("service-name-regex", ("service_name_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex)), ("src-addr-ipv4", ("src_addr_ipv4", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4)), ("dst-addr-ipv4", ("dst_addr_ipv4", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4)), ("src-addr-ipv6", ("src_addr_ipv6", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6)), ("dst-addr-ipv6", ("dst_addr_ipv6", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6)), ("src-addr-mac", ("src_addr_mac", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac)), ("timer", ("timer", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer)), ("timer-regexp", ("timer_regexp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp)), ("tunnel-name", ("tunnel_name", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName)), ("tunnel-name-regex", ("tunnel_name_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex)), ("user-name", ("user_name", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName)), ("user-name-regex", ("user_name_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex)), ("auth-username", ("auth_username", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername)), ("auth-username-regex", ("auth_username_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex)), ("unauth-username", ("unauth_username", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername)), ("unauth-username-regex", ("unauth_username_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex)), ("auth-domain", ("auth_domain", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain)), ("auth-domain-regex", ("auth_domain_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex)), ("unauth-domain", ("unauth_domain", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain)), ("unauth-domain-regex", ("unauth_domain_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex)), ("vendor-id", ("vendor_id", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId)), ("vendor-id-regex", ("vendor_id_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex)), ("access-interface", ("access_interface", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface)), ("input-interface", ("input_interface", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface)), ("input-intfhdl", ("input_intfhdl", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl)), ("ethertype", ("ethertype", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype)), ("flow-key-data", ("flow_key_data", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData)), ("dhcp-client-id", ("dhcp_client_id", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId)), ("dhcp-client-id-regex", ("dhcp_client_id_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex)), ("circuit-id", ("circuit_id", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId)), ("circuit-id-regex", ("circuit_id_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex)), ("remote-id", ("remote_id", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId)), ("remote-id-regex", ("remote_id_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex)), ("src-port", ("src_port", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort)), ("dst-port", ("dst_port", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchTypeEn', '')])),
                                                                                    ('mpls_top_eos', (YLeaf(YType.uint8, 'mpls-top-eos'), ['int'])),
                                                                                    ('fragment_type', (YLeaf(YType.uint8, 'fragment-type'), ['int'])),
                                                                                    ('authen_status', (YLeaf(YType.enumeration, 'authen-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchAuthenStatusEn', '')])),
                                                                                    ('mlp_negotiated', (YLeaf(YType.enumeration, 'mlp-negotiated'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchMlpNegotiatedEn', '')])),
                                                                                ])
                                                                                self.type = None
                                                                                self.mpls_top_eos = None
                                                                                self.fragment_type = None
                                                                                self.authen_status = None
                                                                                self.mlp_negotiated = None

                                                                                self.ipv4_dscp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                self.ipv4_dscp.parent = self
                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"

                                                                                self.ipv6_dscp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                self.ipv6_dscp.parent = self
                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"

                                                                                self.dscp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                self.dscp.parent = self
                                                                                self._children_name_map["dscp"] = "dscp"

                                                                                self.ipv4_prec = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                self.ipv4_prec.parent = self
                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"

                                                                                self.ipv6_prec = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                self.ipv6_prec.parent = self
                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"

                                                                                self.prec = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                self.prec.parent = self
                                                                                self._children_name_map["prec"] = "prec"

                                                                                self.discard_class = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                self.discard_class.parent = self
                                                                                self._children_name_map["discard_class"] = "discard-class"

                                                                                self.qos_group = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                self.qos_group.parent = self
                                                                                self._children_name_map["qos_group"] = "qos-group"

                                                                                self.traffic_class = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                self.traffic_class.parent = self
                                                                                self._children_name_map["traffic_class"] = "traffic-class"

                                                                                self.proto = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                self.proto.parent = self
                                                                                self._children_name_map["proto"] = "proto"

                                                                                self.icmp_v4 = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                self.icmp_v4.parent = self
                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"

                                                                                self.icmp_v6 = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                self.icmp_v6.parent = self
                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"

                                                                                self.ipv4_packet_len = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                self.ipv4_packet_len.parent = self
                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"

                                                                                self.ipv6_packet_len = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                self.ipv6_packet_len.parent = self
                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"

                                                                                self.packet_len = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                self.packet_len.parent = self
                                                                                self._children_name_map["packet_len"] = "packet-len"

                                                                                self.flow_tag = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                self.flow_tag.parent = self
                                                                                self._children_name_map["flow_tag"] = "flow-tag"

                                                                                self.tcp_flag = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                self.tcp_flag.parent = self
                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"

                                                                                self.icmpv4_type = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                self.icmpv4_type.parent = self
                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"

                                                                                self.icmpv4_code = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                self.icmpv4_code.parent = self
                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"

                                                                                self.icmpv6_type = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                self.icmpv6_type.parent = self
                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"

                                                                                self.icmpv6_code = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                self.icmpv6_code.parent = self
                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"

                                                                                self.mpls_exp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                self.mpls_exp.parent = self
                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"

                                                                                self.mpls_exp_imp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                self.mpls_exp_imp.parent = self
                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"

                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"

                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"

                                                                                self.mpls_top_label = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                self.mpls_top_label.parent = self
                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"

                                                                                self.cos = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                self.cos.parent = self
                                                                                self._children_name_map["cos"] = "cos"

                                                                                self.cos_inr = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                self.cos_inr.parent = self
                                                                                self._children_name_map["cos_inr"] = "cos-inr"

                                                                                self.dei = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                self.dei.parent = self
                                                                                self._children_name_map["dei"] = "dei"

                                                                                self.dei_inr = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                self.dei_inr.parent = self
                                                                                self._children_name_map["dei_inr"] = "dei-inr"

                                                                                self.vlan = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                self.vlan.parent = self
                                                                                self._children_name_map["vlan"] = "vlan"

                                                                                self.vlan_inr = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                self.vlan_inr.parent = self
                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"

                                                                                self.fr_dlci = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                self.fr_dlci.parent = self
                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"

                                                                                self.src_mac = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                self.src_mac.parent = self
                                                                                self._children_name_map["src_mac"] = "src-mac"

                                                                                self.dst_mac = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                self.dst_mac.parent = self
                                                                                self._children_name_map["dst_mac"] = "dst-mac"

                                                                                self.atm_clp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                self.atm_clp.parent = self
                                                                                self._children_name_map["atm_clp"] = "atm-clp"

                                                                                self.fr_de = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                self.fr_de.parent = self
                                                                                self._children_name_map["fr_de"] = "fr-de"

                                                                                self.ipv4_acl = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                self.ipv4_acl.parent = self
                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"

                                                                                self.ipv6_acl = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                self.ipv6_acl.parent = self
                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"

                                                                                self.ether_service_acl = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                self.ether_service_acl.parent = self
                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"

                                                                                self.avail_id = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                self.avail_id.parent = self
                                                                                self._children_name_map["avail_id"] = "avail-id"

                                                                                self.media_type = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                self.media_type.parent = self
                                                                                self._children_name_map["media_type"] = "media-type"

                                                                                self.subs_protocol = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                self.subs_protocol.parent = self
                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"

                                                                                self.dnis = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                self.dnis.parent = self
                                                                                self._children_name_map["dnis"] = "dnis"

                                                                                self.dnis_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                self.dnis_regex.parent = self
                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"

                                                                                self.domain = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                self.domain.parent = self
                                                                                self._children_name_map["domain"] = "domain"

                                                                                self.domain_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                self.domain_regex.parent = self
                                                                                self._children_name_map["domain_regex"] = "domain-regex"

                                                                                self.nas_port = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                self.nas_port.parent = self
                                                                                self._children_name_map["nas_port"] = "nas-port"

                                                                                self.service_name = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                self.service_name.parent = self
                                                                                self._children_name_map["service_name"] = "service-name"

                                                                                self.service_name_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                self.service_name_regex.parent = self
                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"

                                                                                self.src_addr_ipv4 = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                self.src_addr_ipv4.parent = self
                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"

                                                                                self.dst_addr_ipv4 = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                self.dst_addr_ipv4.parent = self
                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"

                                                                                self.src_addr_ipv6 = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                self.src_addr_ipv6.parent = self
                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"

                                                                                self.dst_addr_ipv6 = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                self.dst_addr_ipv6.parent = self
                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"

                                                                                self.src_addr_mac = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                self.src_addr_mac.parent = self
                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"

                                                                                self.timer = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                self.timer.parent = self
                                                                                self._children_name_map["timer"] = "timer"

                                                                                self.timer_regexp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                self.timer_regexp.parent = self
                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"

                                                                                self.tunnel_name = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                self.tunnel_name.parent = self
                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"

                                                                                self.tunnel_name_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                self.tunnel_name_regex.parent = self
                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"

                                                                                self.user_name = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                self.user_name.parent = self
                                                                                self._children_name_map["user_name"] = "user-name"

                                                                                self.user_name_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                self.user_name_regex.parent = self
                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"

                                                                                self.auth_username = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                self.auth_username.parent = self
                                                                                self._children_name_map["auth_username"] = "auth-username"

                                                                                self.auth_username_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                self.auth_username_regex.parent = self
                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"

                                                                                self.unauth_username = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                self.unauth_username.parent = self
                                                                                self._children_name_map["unauth_username"] = "unauth-username"

                                                                                self.unauth_username_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                self.unauth_username_regex.parent = self
                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"

                                                                                self.auth_domain = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                self.auth_domain.parent = self
                                                                                self._children_name_map["auth_domain"] = "auth-domain"

                                                                                self.auth_domain_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                self.auth_domain_regex.parent = self
                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"

                                                                                self.unauth_domain = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                self.unauth_domain.parent = self
                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"

                                                                                self.unauth_domain_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                self.unauth_domain_regex.parent = self
                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"

                                                                                self.vendor_id = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                self.vendor_id.parent = self
                                                                                self._children_name_map["vendor_id"] = "vendor-id"

                                                                                self.vendor_id_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                self.vendor_id_regex.parent = self
                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"

                                                                                self.access_interface = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                self.access_interface.parent = self
                                                                                self._children_name_map["access_interface"] = "access-interface"

                                                                                self.input_interface = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                self.input_interface.parent = self
                                                                                self._children_name_map["input_interface"] = "input-interface"

                                                                                self.input_intfhdl = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                self.input_intfhdl.parent = self
                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"

                                                                                self.ethertype = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                self.ethertype.parent = self
                                                                                self._children_name_map["ethertype"] = "ethertype"

                                                                                self.flow_key_data = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                self.flow_key_data.parent = self
                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"

                                                                                self.dhcp_client_id = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                self.dhcp_client_id.parent = self
                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"

                                                                                self.dhcp_client_id_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                self.dhcp_client_id_regex.parent = self
                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"

                                                                                self.circuit_id = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                self.circuit_id.parent = self
                                                                                self._children_name_map["circuit_id"] = "circuit-id"

                                                                                self.circuit_id_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                self.circuit_id_regex.parent = self
                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"

                                                                                self.remote_id = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                self.remote_id.parent = self
                                                                                self._children_name_map["remote_id"] = "remote-id"

                                                                                self.remote_id_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                self.remote_id_regex.parent = self
                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"

                                                                                self.src_port = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                self.src_port.parent = self
                                                                                self._children_name_map["src_port"] = "src-port"

                                                                                self.dst_port = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                self.dst_port.parent = self
                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                self._segment_path = lambda: "match-data"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, ['type', 'mpls_top_eos', 'fragment_type', 'authen_status', 'mlp_negotiated'], name, value)


                                                                            class Ipv4Dscp(Entity):
                                                                                """
                                                                                IPv4 DSCP
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                    self.yang_name = "ipv4-dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv4-dscp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Ipv6Dscp(Entity):
                                                                                """
                                                                                IPv6 DSCP
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                    self.yang_name = "ipv6-dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv6-dscp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Dscp(Entity):
                                                                                """
                                                                                Match DSCP range array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                    self.yang_name = "dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "dscp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Ipv4Prec(Entity):
                                                                                """
                                                                                IPv4 Precedence
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                    self.yang_name = "ipv4-prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "ipv4-prec"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                            class Ipv6Prec(Entity):
                                                                                """
                                                                                IPv6 Precedence
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                    self.yang_name = "ipv6-prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "ipv6-prec"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                            class Prec(Entity):
                                                                                """
                                                                                Match Precedence array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                    self.yang_name = "prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "prec"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                            class DiscardClass(Entity):
                                                                                """
                                                                                Match Discard Class array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                    self.yang_name = "discard-class"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "discard-class"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                            class QosGroup(Entity):
                                                                                """
                                                                                Match QoS group array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                    self.yang_name = "qos-group"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "qos-group"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "qos-group"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class TrafficClass(Entity):
                                                                                """
                                                                                Match Traffic class array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                    self.yang_name = "traffic-class"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "traffic-class"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "traffic-class"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Proto(Entity):
                                                                                """
                                                                                Match Protocol array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                    self.yang_name = "proto"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "proto"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "proto"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class IcmpV4(Entity):
                                                                                """
                                                                                Match ICMPV4 Protocol
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Protocol type
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: code
                                                                                
                                                                                	Protocol code
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                    self.yang_name = "icmp-v4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                    ])
                                                                                    self.type = None
                                                                                    self.code = None
                                                                                    self._segment_path = lambda: "icmp-v4"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['type', 'code'], name, value)


                                                                            class IcmpV6(Entity):
                                                                                """
                                                                                Match ICMPV6 Protocol array
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Protocol type
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: code
                                                                                
                                                                                	Protocol code
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                    self.yang_name = "icmp-v6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                    ])
                                                                                    self.type = None
                                                                                    self.code = None
                                                                                    self._segment_path = lambda: "icmp-v6"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['type', 'code'], name, value)


                                                                            class Ipv4PacketLen(Entity):
                                                                                """
                                                                                IPv4 packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv4-packet-len"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class Ipv6PacketLen(Entity):
                                                                                """
                                                                                IPv6 packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv6-packet-len"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class PacketLen(Entity):
                                                                                """
                                                                                Match packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                    self.yang_name = "packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "packet-len"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class FlowTag(Entity):
                                                                                """
                                                                                Match flow\-tag array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                    self.yang_name = "flow-tag"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "flow-tag"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "flow-tag"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class TcpFlag(Entity):
                                                                                """
                                                                                Match tcp flag value
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	Value of TCP flag
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: match_any
                                                                                
                                                                                	Match any TCP flag bit
                                                                                	**type**\: bool
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                    self.yang_name = "tcp-flag"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                        ('match_any', (YLeaf(YType.boolean, 'match-any'), ['bool'])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.match_any = None
                                                                                    self._segment_path = lambda: "tcp-flag"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['value', 'match_any'], name, value)


                                                                            class Icmpv4Type(Entity):
                                                                                """
                                                                                Match ipv4 icmp type
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                    self.yang_name = "icmpv4-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv4-type"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Icmpv4Code(Entity):
                                                                                """
                                                                                Match ipv4 icmp code
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                    self.yang_name = "icmpv4-code"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv4-code"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Icmpv6Type(Entity):
                                                                                """
                                                                                Match ipv6 icmp type
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                    self.yang_name = "icmpv6-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv6-type"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Icmpv6Code(Entity):
                                                                                """
                                                                                Match ipv6 icmp code
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                    self.yang_name = "icmpv6-code"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv6-code"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class MplsExp(Entity):
                                                                                """
                                                                                Match MPLS experimental topmost array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                    self.yang_name = "mpls-exp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "mpls-exp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                            class MplsExpImp(Entity):
                                                                                """
                                                                                Match MPLS experimental imposition array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "mpls-exp-imp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                            class MplsDispIpv4Acl(Entity):
                                                                                """
                                                                                MPLS Disposition IPv4 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                            class MplsDispIpv6Acl(Entity):
                                                                                """
                                                                                MPLS Disposition IPv6 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                            class MplsTopLabel(Entity):
                                                                                """
                                                                                MPLS Topmost LABEL
                                                                                
                                                                                .. attribute:: uint32_rng_array
                                                                                
                                                                                	uint32 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                    self.yang_name = "mpls-top-label"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint32_rng_array", ("uint32_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint32_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "mpls-top-label"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                class Uint32RngArray(Entity):
                                                                                    """
                                                                                    uint32 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                        self.yang_name = "uint32_rng_array"
                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint32, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint32, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint32_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['min', 'max'], name, value)


                                                                            class Cos(Entity):
                                                                                """
                                                                                Match CoS array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                    self.yang_name = "cos"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "cos"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                            class CosInr(Entity):
                                                                                """
                                                                                Match inner header CoS
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                    self.yang_name = "cos-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "cos-inr"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                            class Dei(Entity):
                                                                                """
                                                                                Match DEI Bit
                                                                                
                                                                                .. attribute:: bit_value
                                                                                
                                                                                	Value of the DEI bit
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                    self.yang_name = "dei"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                    ])
                                                                                    self.bit_value = None
                                                                                    self._segment_path = lambda: "dei"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                            class DeiInr(Entity):
                                                                                """
                                                                                Match inner DEI Bit
                                                                                
                                                                                .. attribute:: bit_value
                                                                                
                                                                                	Value of the DEI bit
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                    self.yang_name = "dei-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                    ])
                                                                                    self.bit_value = None
                                                                                    self._segment_path = lambda: "dei-inr"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                            class Vlan(Entity):
                                                                                """
                                                                                Match VLAN array
                                                                                
                                                                                .. attribute:: vlan_id_array
                                                                                
                                                                                	vlan id array
                                                                                	**type**\: list of  		 :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                    self.yang_name = "vlan"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("vlan-id-array", ("vlan_id_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.vlan_id_array = YList(self)
                                                                                    self._segment_path = lambda: "vlan"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                class VlanIdArray(Entity):
                                                                                    """
                                                                                    vlan id array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	VLAN mask
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                        self.yang_name = "vlan-id-array"
                                                                                        self.yang_parent_name = "vlan"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                            ('mask', (YLeaf(YType.uint16, 'mask'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self.mask = None
                                                                                        self._segment_path = lambda: "vlan-id-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['min', 'max', 'mask'], name, value)


                                                                            class VlanInr(Entity):
                                                                                """
                                                                                Match inner header VLAN range array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                    self.yang_name = "vlan-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "vlan-inr"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class FrDlci(Entity):
                                                                                """
                                                                                Match FR DLCI range array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                    self.yang_name = "fr-dlci"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "fr-dlci"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class SrcMac(Entity):
                                                                                """
                                                                                Match Source MAC address
                                                                                
                                                                                .. attribute:: mac_addr
                                                                                
                                                                                	MAC address
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	MAC mask
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                    self.yang_name = "src-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                    ])
                                                                                    self.mac_addr = []
                                                                                    self.mask = []
                                                                                    self._segment_path = lambda: "src-mac"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                            class DstMac(Entity):
                                                                                """
                                                                                Match Destination MAC address
                                                                                
                                                                                .. attribute:: mac_addr
                                                                                
                                                                                	MAC address
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	MAC mask
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                    self.yang_name = "dst-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                    ])
                                                                                    self.mac_addr = []
                                                                                    self.mask = []
                                                                                    self._segment_path = lambda: "dst-mac"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                            class AtmClp(Entity):
                                                                                """
                                                                                Match ATM CLP level
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                    self.yang_name = "atm-clp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "atm-clp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                            class FrDe(Entity):
                                                                                """
                                                                                Match FR DE value
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                    self.yang_name = "fr-de"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "fr-de"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                            class Ipv4Acl(Entity):
                                                                                """
                                                                                IPv4 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                    self.yang_name = "ipv4-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "ipv4-acl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                            class Ipv6Acl(Entity):
                                                                                """
                                                                                IPv6 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                    self.yang_name = "ipv6-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "ipv6-acl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                            class EtherServiceAcl(Entity):
                                                                                """
                                                                                Ethernet\-Services Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                    self.yang_name = "ether-service-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "ether-service-acl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                            class AvailId(Entity):
                                                                                """
                                                                                Available Identifiers
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                    self.yang_name = "avail-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "avail-id"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                            class MediaType(Entity):
                                                                                """
                                                                                Media Type
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                    self.yang_name = "media-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "media-type"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                            class SubsProtocol(Entity):
                                                                                """
                                                                                Protocol
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                    self.yang_name = "subs-protocol"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "subs-protocol"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                            class Dnis(Entity):
                                                                                """
                                                                                DNIS
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                    self.yang_name = "dnis"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "dnis"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                            class DnisRegex(Entity):
                                                                                """
                                                                                DNIS Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                    self.yang_name = "dnis-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "dnis-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                            class Domain(Entity):
                                                                                """
                                                                                Domain Name
                                                                                
                                                                                .. attribute:: domain_array
                                                                                
                                                                                	domain array
                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                    self.yang_name = "domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.domain_array = YList(self)
                                                                                    self._segment_path = lambda: "domain"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                class DomainArray(Entity):
                                                                                    """
                                                                                    domain array
                                                                                    
                                                                                    .. attribute:: domain_name
                                                                                    
                                                                                    	domain name
                                                                                    	**type**\: str
                                                                                    
                                                                                    .. attribute:: format_name
                                                                                    
                                                                                    	format name
                                                                                    	**type**\: str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                        self.yang_name = "domain-array"
                                                                                        self.yang_parent_name = "domain"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                        ])
                                                                                        self.domain_name = None
                                                                                        self.format_name = None
                                                                                        self._segment_path = lambda: "domain-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                            class DomainRegex(Entity):
                                                                                """
                                                                                Domain Regular Expression
                                                                                
                                                                                .. attribute:: domain_array
                                                                                
                                                                                	domain array
                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                    self.yang_name = "domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.domain_array = YList(self)
                                                                                    self._segment_path = lambda: "domain-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                class DomainArray(Entity):
                                                                                    """
                                                                                    domain array
                                                                                    
                                                                                    .. attribute:: domain_name
                                                                                    
                                                                                    	domain name
                                                                                    	**type**\: str
                                                                                    
                                                                                    .. attribute:: format_name
                                                                                    
                                                                                    	format name
                                                                                    	**type**\: str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                        self.yang_name = "domain-array"
                                                                                        self.yang_parent_name = "domain-regex"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                        ])
                                                                                        self.domain_name = None
                                                                                        self.format_name = None
                                                                                        self._segment_path = lambda: "domain-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                            class NasPort(Entity):
                                                                                """
                                                                                NAS Port
                                                                                
                                                                                .. attribute:: nas_port_array
                                                                                
                                                                                	nas port array
                                                                                	**type**\: list of  		 :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                    self.yang_name = "nas-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("nas-port-array", ("nas_port_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.nas_port_array = YList(self)
                                                                                    self._segment_path = lambda: "nas-port"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                class NasPortArray(Entity):
                                                                                    """
                                                                                    nas port array
                                                                                    
                                                                                    .. attribute:: sub_id
                                                                                    
                                                                                    	sub id
                                                                                    	**type**\:  :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                    
                                                                                    .. attribute:: operator
                                                                                    
                                                                                    	operator
                                                                                    	**type**\:  :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                        self.yang_name = "nas-port-array"
                                                                                        self.yang_parent_name = "nas-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('sub_id', (YLeaf(YType.enumeration, 'sub-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchNasPortSubIdEn', '')])),
                                                                                            ('operator', (YLeaf(YType.enumeration, 'operator'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchLogicalOperatorEn', '')])),
                                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ])
                                                                                        self.sub_id = None
                                                                                        self.operator = None
                                                                                        self.value = None
                                                                                        self._segment_path = lambda: "nas-port-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['sub_id', 'operator', 'value'], name, value)


                                                                            class ServiceName(Entity):
                                                                                """
                                                                                Service Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                    self.yang_name = "service-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "service-name"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                            class ServiceNameRegex(Entity):
                                                                                """
                                                                                Service Name Regular Exp
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                    self.yang_name = "service-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "service-name-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                            class SrcAddrIpv4(Entity):
                                                                                """
                                                                                Source Address IPV4
                                                                                
                                                                                .. attribute:: ipv4_addr_array
                                                                                
                                                                                	ipv4 addr array
                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.ipv4_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-ipv4"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                class Ipv4AddrArray(Entity):
                                                                                    """
                                                                                    ipv4 addr array
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	prefix
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	mask
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                        ])
                                                                                        self.prefix = None
                                                                                        self.mask = None
                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                            class DstAddrIpv4(Entity):
                                                                                """
                                                                                Destination Address IPV4
                                                                                
                                                                                .. attribute:: ipv4_addr_array
                                                                                
                                                                                	ipv4 addr array
                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.ipv4_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-addr-ipv4"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                class Ipv4AddrArray(Entity):
                                                                                    """
                                                                                    ipv4 addr array
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	prefix
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	mask
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                        ])
                                                                                        self.prefix = None
                                                                                        self.mask = None
                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                            class SrcAddrIpv6(Entity):
                                                                                """
                                                                                Source Address IPV6
                                                                                
                                                                                .. attribute:: ipv6_addr_array
                                                                                
                                                                                	ipv6 addr array
                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.ipv6_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-ipv6"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                class Ipv6AddrArray(Entity):
                                                                                    """
                                                                                    ipv6 addr array
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	IPV6 prefix
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	IPV6 mask
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                        ])
                                                                                        self.prefix = None
                                                                                        self.mask = None
                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                            class DstAddrIpv6(Entity):
                                                                                """
                                                                                Destination Address IPV6
                                                                                
                                                                                .. attribute:: ipv6_addr_array
                                                                                
                                                                                	ipv6 addr array
                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.ipv6_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-addr-ipv6"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                class Ipv6AddrArray(Entity):
                                                                                    """
                                                                                    ipv6 addr array
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	IPV6 prefix
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	IPV6 mask
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                        ])
                                                                                        self.prefix = None
                                                                                        self.mask = None
                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                            class SrcAddrMac(Entity):
                                                                                """
                                                                                Source Address MAC
                                                                                
                                                                                .. attribute:: mac_addr_array
                                                                                
                                                                                	mac addr array
                                                                                	**type**\: list of  		 :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                    self.yang_name = "src-addr-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("mac-addr-array", ("mac_addr_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.mac_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-mac"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                class MacAddrArray(Entity):
                                                                                    """
                                                                                    mac addr array
                                                                                    
                                                                                    .. attribute:: mac_addr
                                                                                    
                                                                                    	MAC address
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	MAC mask
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                        self.yang_name = "mac-addr-array"
                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                            ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                        ])
                                                                                        self.mac_addr = []
                                                                                        self.mask = []
                                                                                        self._segment_path = lambda: "mac-addr-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                            class Timer(Entity):
                                                                                """
                                                                                Timer
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                    self.yang_name = "timer"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "timer"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                            class TimerRegexp(Entity):
                                                                                """
                                                                                Timer Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                    self.yang_name = "timer-regexp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "timer-regexp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                            class TunnelName(Entity):
                                                                                """
                                                                                Tunnel Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                    self.yang_name = "tunnel-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "tunnel-name"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                            class TunnelNameRegex(Entity):
                                                                                """
                                                                                Tunnel Name Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "tunnel-name-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                            class UserName(Entity):
                                                                                """
                                                                                User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                    self.yang_name = "user-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "user-name"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                            class UserNameRegex(Entity):
                                                                                """
                                                                                User Name Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                    self.yang_name = "user-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "user-name-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                            class AuthUsername(Entity):
                                                                                """
                                                                                Authenticated User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                    self.yang_name = "auth-username"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "auth-username"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                            class AuthUsernameRegex(Entity):
                                                                                """
                                                                                Authenticated User Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                    self.yang_name = "auth-username-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "auth-username-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                            class UnauthUsername(Entity):
                                                                                """
                                                                                Unauthenticated User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                    self.yang_name = "unauth-username"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "unauth-username"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                            class UnauthUsernameRegex(Entity):
                                                                                """
                                                                                Unauthenticated User Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                    self.yang_name = "unauth-username-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "unauth-username-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                            class AuthDomain(Entity):
                                                                                """
                                                                                Authenticated domain name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                    self.yang_name = "auth-domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "auth-domain"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                            class AuthDomainRegex(Entity):
                                                                                """
                                                                                Authenticated Domain Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                    self.yang_name = "auth-domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "auth-domain-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                            class UnauthDomain(Entity):
                                                                                """
                                                                                Unauthenticated Domain Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                    self.yang_name = "unauth-domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "unauth-domain"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                            class UnauthDomainRegex(Entity):
                                                                                """
                                                                                Unauthenticated Domain Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "unauth-domain-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                            class VendorId(Entity):
                                                                                """
                                                                                Vendor ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                    self.yang_name = "vendor-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "vendor-id"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                            class VendorIdRegex(Entity):
                                                                                """
                                                                                Vendor ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                    self.yang_name = "vendor-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "vendor-id-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                            class AccessInterface(Entity):
                                                                                """
                                                                                Access interface
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                    self.yang_name = "access-interface"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "access-interface"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                            class InputInterface(Entity):
                                                                                """
                                                                                Input interface
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                    self.yang_name = "input-interface"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "input-interface"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                            class InputIntfhdl(Entity):
                                                                                """
                                                                                Input interface handle
                                                                                
                                                                                .. attribute:: uint64_array
                                                                                
                                                                                	uint64 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..18446744073709551615
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                    self.yang_name = "input-intfhdl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint64_array', (YLeafList(YType.uint64, 'uint64_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint64_array = []
                                                                                    self._segment_path = lambda: "input-intfhdl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                            class Ethertype(Entity):
                                                                                """
                                                                                Ethernet type
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                    self.yang_name = "ethertype"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ethertype"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ethertype"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class FlowKeyData(Entity):
                                                                                """
                                                                                Flow key structure
                                                                                
                                                                                .. attribute:: flow_keys
                                                                                
                                                                                	flow keys
                                                                                	**type**\:  :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                
                                                                                .. attribute:: max_count
                                                                                
                                                                                	Maximum count of flows
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: idle_timeout
                                                                                
                                                                                	Idle timeout of flows (in seconds)
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                	**units**\: second
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                    self.yang_name = "flow-key-data"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("flow-keys", ("flow_keys", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('max_count', (YLeaf(YType.uint16, 'max-count'), ['int'])),
                                                                                        ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                                    ])
                                                                                    self.max_count = None
                                                                                    self.idle_timeout = None

                                                                                    self.flow_keys = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                    self.flow_keys.parent = self
                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                    self._segment_path = lambda: "flow-key-data"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['max_count', 'idle_timeout'], name, value)


                                                                                class FlowKeys(Entity):
                                                                                    """
                                                                                    flow keys
                                                                                    
                                                                                    .. attribute:: keys
                                                                                    
                                                                                    	keys
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                    
                                                                                    .. attribute:: num
                                                                                    
                                                                                    	num
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                        self.yang_name = "flow-keys"
                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('keys', (YLeaf(YType.str, 'keys'), ['str'])),
                                                                                            ('num', (YLeaf(YType.uint8, 'num'), ['int'])),
                                                                                        ])
                                                                                        self.keys = None
                                                                                        self.num = None
                                                                                        self._segment_path = lambda: "flow-keys"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                            class DhcpClientId(Entity):
                                                                                """
                                                                                Dhcp Client ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                    self.yang_name = "dhcp-client-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "dhcp-client-id"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                            class DhcpClientIdRegex(Entity):
                                                                                """
                                                                                Dhcp Client ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                            class CircuitId(Entity):
                                                                                """
                                                                                Circuit ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                    self.yang_name = "circuit-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "circuit-id"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                            class CircuitIdRegex(Entity):
                                                                                """
                                                                                Circuit ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                    self.yang_name = "circuit-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "circuit-id-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                            class RemoteId(Entity):
                                                                                """
                                                                                Remote ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                    self.yang_name = "remote-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "remote-id"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                            class RemoteIdRegex(Entity):
                                                                                """
                                                                                Remote ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                    self.yang_name = "remote-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "remote-id-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                            class SrcPort(Entity):
                                                                                """
                                                                                Source port
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                    self.yang_name = "src-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "src-port"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "src-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class DstPort(Entity):
                                                                                """
                                                                                Destination port
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                    self.yang_name = "dst-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-port"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "dst-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['min', 'max'], name, value)


                                                        class ClmpP(Entity):
                                                            """
                                                            clmp p
                                                            
                                                            .. attribute:: class_map_bg
                                                            
                                                            	class map bg
                                                            	**type**\: list of  		 :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'infra-policymgr-oper'
                                                            _revision = '2018-01-17'

                                                            def __init__(self):
                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP, self).__init__()

                                                                self.yang_name = "clmp-p"
                                                                self.yang_parent_name = "policy-class-info-bg"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("class-map-bg", ("class_map_bg", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg))])
                                                                self._leafs = OrderedDict()

                                                                self.class_map_bg = YList(self)
                                                                self._segment_path = lambda: "clmp-p"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP, [], name, value)


                                                            class ClassMapBg(Entity):
                                                                """
                                                                class map bg
                                                                
                                                                .. attribute:: match_infop
                                                                
                                                                	Pointer to the first Match info
                                                                	**type**\:  :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop>`
                                                                
                                                                .. attribute:: name
                                                                
                                                                	Name of the class\-map
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..65
                                                                
                                                                .. attribute:: type
                                                                
                                                                	Class\-Map Type QoS/PBR/Netflow/..
                                                                	**type**\:  :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                                
                                                                .. attribute:: mode
                                                                
                                                                	Class\-Map Mode Match any/Match all
                                                                	**type**\:  :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                
                                                                .. attribute:: description
                                                                
                                                                	description
                                                                	**type**\: str
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg, self).__init__()

                                                                    self.yang_name = "class-map-bg"
                                                                    self.yang_parent_name = "clmp-p"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("match-infop", ("match_infop", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop))])
                                                                    self._leafs = OrderedDict([
                                                                        ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapTypeEn', '')])),
                                                                        ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapModeEn', '')])),
                                                                        ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                    ])
                                                                    self.name = None
                                                                    self.type = None
                                                                    self.mode = None
                                                                    self.description = None

                                                                    self.match_infop = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop()
                                                                    self.match_infop.parent = self
                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                    self._segment_path = lambda: "class-map-bg"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg, ['name', 'type', 'mode', 'description'], name, value)


                                                                class MatchInfop(Entity):
                                                                    """
                                                                    Pointer to the first Match info
                                                                    
                                                                    .. attribute:: class_match_info_st
                                                                    
                                                                    	class match info st
                                                                    	**type**\: list of  		 :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop, self).__init__()

                                                                        self.yang_name = "match-infop"
                                                                        self.yang_parent_name = "class-map-bg"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("class-match-info-st", ("class_match_info_st", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt))])
                                                                        self._leafs = OrderedDict()

                                                                        self.class_match_info_st = YList(self)
                                                                        self._segment_path = lambda: "match-infop"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop, [], name, value)


                                                                    class ClassMatchInfoSt(Entity):
                                                                        """
                                                                        class match info st
                                                                        
                                                                        .. attribute:: match_data
                                                                        
                                                                        	Match criteria
                                                                        	**type**\:  :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                        
                                                                        .. attribute:: flags
                                                                        
                                                                        	Flags
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                            self.yang_name = "class-match-info-st"
                                                                            self.yang_parent_name = "match-infop"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("match-data", ("match_data", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData))])
                                                                            self._leafs = OrderedDict([
                                                                                ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                            ])
                                                                            self.flags = None

                                                                            self.match_data = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                            self.match_data.parent = self
                                                                            self._children_name_map["match_data"] = "match-data"
                                                                            self._segment_path = lambda: "class-match-info-st"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                        class MatchData(Entity):
                                                                            """
                                                                            Match criteria
                                                                            
                                                                            .. attribute:: ipv4_dscp
                                                                            
                                                                            	IPv4 DSCP
                                                                            	**type**\:  :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                            
                                                                            .. attribute:: ipv6_dscp
                                                                            
                                                                            	IPv6 DSCP
                                                                            	**type**\:  :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                            
                                                                            .. attribute:: dscp
                                                                            
                                                                            	Match DSCP range array
                                                                            	**type**\:  :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                            
                                                                            .. attribute:: ipv4_prec
                                                                            
                                                                            	IPv4 Precedence
                                                                            	**type**\:  :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                            
                                                                            .. attribute:: ipv6_prec
                                                                            
                                                                            	IPv6 Precedence
                                                                            	**type**\:  :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                            
                                                                            .. attribute:: prec
                                                                            
                                                                            	Match Precedence array
                                                                            	**type**\:  :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                            
                                                                            .. attribute:: discard_class
                                                                            
                                                                            	Match Discard Class array
                                                                            	**type**\:  :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                            
                                                                            .. attribute:: qos_group
                                                                            
                                                                            	Match QoS group array
                                                                            	**type**\:  :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                            
                                                                            .. attribute:: traffic_class
                                                                            
                                                                            	Match Traffic class array
                                                                            	**type**\:  :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                            
                                                                            .. attribute:: proto
                                                                            
                                                                            	Match Protocol array
                                                                            	**type**\:  :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                            
                                                                            .. attribute:: icmp_v4
                                                                            
                                                                            	Match ICMPV4 Protocol
                                                                            	**type**\:  :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                            
                                                                            .. attribute:: icmp_v6
                                                                            
                                                                            	Match ICMPV6 Protocol array
                                                                            	**type**\:  :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                            
                                                                            .. attribute:: ipv4_packet_len
                                                                            
                                                                            	IPv4 packet length array
                                                                            	**type**\:  :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                            
                                                                            .. attribute:: ipv6_packet_len
                                                                            
                                                                            	IPv6 packet length array
                                                                            	**type**\:  :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                            
                                                                            .. attribute:: packet_len
                                                                            
                                                                            	Match packet length array
                                                                            	**type**\:  :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                            
                                                                            .. attribute:: flow_tag
                                                                            
                                                                            	Match flow\-tag array
                                                                            	**type**\:  :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                            
                                                                            .. attribute:: tcp_flag
                                                                            
                                                                            	Match tcp flag value
                                                                            	**type**\:  :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                            
                                                                            .. attribute:: icmpv4_type
                                                                            
                                                                            	Match ipv4 icmp type
                                                                            	**type**\:  :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                            
                                                                            .. attribute:: icmpv4_code
                                                                            
                                                                            	Match ipv4 icmp code
                                                                            	**type**\:  :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                            
                                                                            .. attribute:: icmpv6_type
                                                                            
                                                                            	Match ipv6 icmp type
                                                                            	**type**\:  :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                            
                                                                            .. attribute:: icmpv6_code
                                                                            
                                                                            	Match ipv6 icmp code
                                                                            	**type**\:  :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                            
                                                                            .. attribute:: mpls_exp
                                                                            
                                                                            	Match MPLS experimental topmost array
                                                                            	**type**\:  :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                            
                                                                            .. attribute:: mpls_exp_imp
                                                                            
                                                                            	Match MPLS experimental imposition array
                                                                            	**type**\:  :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                            
                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                            
                                                                            	MPLS Disposition IPv4 Access\-list
                                                                            	**type**\:  :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                            
                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                            
                                                                            	MPLS Disposition IPv6 Access\-list
                                                                            	**type**\:  :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                            
                                                                            .. attribute:: mpls_top_label
                                                                            
                                                                            	MPLS Topmost LABEL
                                                                            	**type**\:  :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                            
                                                                            .. attribute:: cos
                                                                            
                                                                            	Match CoS array
                                                                            	**type**\:  :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                            
                                                                            .. attribute:: cos_inr
                                                                            
                                                                            	Match inner header CoS
                                                                            	**type**\:  :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                            
                                                                            .. attribute:: dei
                                                                            
                                                                            	Match DEI Bit
                                                                            	**type**\:  :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                            
                                                                            .. attribute:: dei_inr
                                                                            
                                                                            	Match inner DEI Bit
                                                                            	**type**\:  :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                            
                                                                            .. attribute:: vlan
                                                                            
                                                                            	Match VLAN array
                                                                            	**type**\:  :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                            
                                                                            .. attribute:: vlan_inr
                                                                            
                                                                            	Match inner header VLAN range array
                                                                            	**type**\:  :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                            
                                                                            .. attribute:: fr_dlci
                                                                            
                                                                            	Match FR DLCI range array
                                                                            	**type**\:  :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                            
                                                                            .. attribute:: src_mac
                                                                            
                                                                            	Match Source MAC address
                                                                            	**type**\:  :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                            
                                                                            .. attribute:: dst_mac
                                                                            
                                                                            	Match Destination MAC address
                                                                            	**type**\:  :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                            
                                                                            .. attribute:: atm_clp
                                                                            
                                                                            	Match ATM CLP level
                                                                            	**type**\:  :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                            
                                                                            .. attribute:: fr_de
                                                                            
                                                                            	Match FR DE value
                                                                            	**type**\:  :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                            
                                                                            .. attribute:: ipv4_acl
                                                                            
                                                                            	IPv4 Access\-list
                                                                            	**type**\:  :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                            
                                                                            .. attribute:: ipv6_acl
                                                                            
                                                                            	IPv6 Access\-list
                                                                            	**type**\:  :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                            
                                                                            .. attribute:: ether_service_acl
                                                                            
                                                                            	Ethernet\-Services Access\-list
                                                                            	**type**\:  :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                            
                                                                            .. attribute:: avail_id
                                                                            
                                                                            	Available Identifiers
                                                                            	**type**\:  :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                            
                                                                            .. attribute:: media_type
                                                                            
                                                                            	Media Type
                                                                            	**type**\:  :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                            
                                                                            .. attribute:: subs_protocol
                                                                            
                                                                            	Protocol
                                                                            	**type**\:  :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                            
                                                                            .. attribute:: dnis
                                                                            
                                                                            	DNIS
                                                                            	**type**\:  :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                            
                                                                            .. attribute:: dnis_regex
                                                                            
                                                                            	DNIS Regular Expression
                                                                            	**type**\:  :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                            
                                                                            .. attribute:: domain
                                                                            
                                                                            	Domain Name
                                                                            	**type**\:  :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                            
                                                                            .. attribute:: domain_regex
                                                                            
                                                                            	Domain Regular Expression
                                                                            	**type**\:  :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                            
                                                                            .. attribute:: nas_port
                                                                            
                                                                            	NAS Port
                                                                            	**type**\:  :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                            
                                                                            .. attribute:: service_name
                                                                            
                                                                            	Service Name
                                                                            	**type**\:  :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                            
                                                                            .. attribute:: service_name_regex
                                                                            
                                                                            	Service Name Regular Exp
                                                                            	**type**\:  :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                            
                                                                            .. attribute:: src_addr_ipv4
                                                                            
                                                                            	Source Address IPV4
                                                                            	**type**\:  :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                            
                                                                            .. attribute:: dst_addr_ipv4
                                                                            
                                                                            	Destination Address IPV4
                                                                            	**type**\:  :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                            
                                                                            .. attribute:: src_addr_ipv6
                                                                            
                                                                            	Source Address IPV6
                                                                            	**type**\:  :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                            
                                                                            .. attribute:: dst_addr_ipv6
                                                                            
                                                                            	Destination Address IPV6
                                                                            	**type**\:  :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                            
                                                                            .. attribute:: src_addr_mac
                                                                            
                                                                            	Source Address MAC
                                                                            	**type**\:  :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                            
                                                                            .. attribute:: timer
                                                                            
                                                                            	Timer
                                                                            	**type**\:  :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                            
                                                                            .. attribute:: timer_regexp
                                                                            
                                                                            	Timer Regular Expression
                                                                            	**type**\:  :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                            
                                                                            .. attribute:: tunnel_name
                                                                            
                                                                            	Tunnel Name
                                                                            	**type**\:  :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                            
                                                                            .. attribute:: tunnel_name_regex
                                                                            
                                                                            	Tunnel Name Regular Expression
                                                                            	**type**\:  :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                            
                                                                            .. attribute:: user_name
                                                                            
                                                                            	User Name
                                                                            	**type**\:  :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                            
                                                                            .. attribute:: user_name_regex
                                                                            
                                                                            	User Name Regular Expression
                                                                            	**type**\:  :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                            
                                                                            .. attribute:: auth_username
                                                                            
                                                                            	Authenticated User Name
                                                                            	**type**\:  :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                            
                                                                            .. attribute:: auth_username_regex
                                                                            
                                                                            	Authenticated User Name RegEx
                                                                            	**type**\:  :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                            
                                                                            .. attribute:: unauth_username
                                                                            
                                                                            	Unauthenticated User Name
                                                                            	**type**\:  :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                            
                                                                            .. attribute:: unauth_username_regex
                                                                            
                                                                            	Unauthenticated User Name RegEx
                                                                            	**type**\:  :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                            
                                                                            .. attribute:: auth_domain
                                                                            
                                                                            	Authenticated domain name
                                                                            	**type**\:  :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                            
                                                                            .. attribute:: auth_domain_regex
                                                                            
                                                                            	Authenticated Domain Name RegEx
                                                                            	**type**\:  :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                            
                                                                            .. attribute:: unauth_domain
                                                                            
                                                                            	Unauthenticated Domain Name
                                                                            	**type**\:  :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                            
                                                                            .. attribute:: unauth_domain_regex
                                                                            
                                                                            	Unauthenticated Domain Name RegEx
                                                                            	**type**\:  :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                            
                                                                            .. attribute:: vendor_id
                                                                            
                                                                            	Vendor ID
                                                                            	**type**\:  :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                            
                                                                            .. attribute:: vendor_id_regex
                                                                            
                                                                            	Vendor ID RegEx
                                                                            	**type**\:  :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                            
                                                                            .. attribute:: access_interface
                                                                            
                                                                            	Access interface
                                                                            	**type**\:  :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                            
                                                                            .. attribute:: input_interface
                                                                            
                                                                            	Input interface
                                                                            	**type**\:  :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                            
                                                                            .. attribute:: input_intfhdl
                                                                            
                                                                            	Input interface handle
                                                                            	**type**\:  :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                            
                                                                            .. attribute:: ethertype
                                                                            
                                                                            	Ethernet type
                                                                            	**type**\:  :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                            
                                                                            .. attribute:: flow_key_data
                                                                            
                                                                            	Flow key structure
                                                                            	**type**\:  :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                            
                                                                            .. attribute:: dhcp_client_id
                                                                            
                                                                            	Dhcp Client ID
                                                                            	**type**\:  :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                            
                                                                            .. attribute:: dhcp_client_id_regex
                                                                            
                                                                            	Dhcp Client ID RegEx
                                                                            	**type**\:  :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                            
                                                                            .. attribute:: circuit_id
                                                                            
                                                                            	Circuit ID
                                                                            	**type**\:  :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                            
                                                                            .. attribute:: circuit_id_regex
                                                                            
                                                                            	Circuit ID RegEx
                                                                            	**type**\:  :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                            
                                                                            .. attribute:: remote_id
                                                                            
                                                                            	Remote ID
                                                                            	**type**\:  :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                            
                                                                            .. attribute:: remote_id_regex
                                                                            
                                                                            	Remote ID RegEx
                                                                            	**type**\:  :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                            
                                                                            .. attribute:: src_port
                                                                            
                                                                            	Source port
                                                                            	**type**\:  :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                            
                                                                            .. attribute:: dst_port
                                                                            
                                                                            	Destination port
                                                                            	**type**\:  :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:  :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                            
                                                                            .. attribute:: mpls_top_eos
                                                                            
                                                                            	MPLS Topmost EOS
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: fragment_type
                                                                            
                                                                            	Fragment type
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: authen_status
                                                                            
                                                                            	Authentication Status
                                                                            	**type**\:  :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                            
                                                                            .. attribute:: mlp_negotiated
                                                                            
                                                                            	MLP Negotiated
                                                                            	**type**\:  :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                self.yang_name = "match-data"
                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("ipv4-dscp", ("ipv4_dscp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp)), ("ipv6-dscp", ("ipv6_dscp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp)), ("dscp", ("dscp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp)), ("ipv4-prec", ("ipv4_prec", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec)), ("ipv6-prec", ("ipv6_prec", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec)), ("prec", ("prec", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec)), ("discard-class", ("discard_class", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass)), ("qos-group", ("qos_group", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup)), ("traffic-class", ("traffic_class", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass)), ("proto", ("proto", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto)), ("icmp-v4", ("icmp_v4", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4)), ("icmp-v6", ("icmp_v6", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6)), ("ipv4-packet-len", ("ipv4_packet_len", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen)), ("ipv6-packet-len", ("ipv6_packet_len", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen)), ("packet-len", ("packet_len", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen)), ("flow-tag", ("flow_tag", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag)), ("tcp-flag", ("tcp_flag", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag)), ("icmpv4-type", ("icmpv4_type", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type)), ("icmpv4-code", ("icmpv4_code", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code)), ("icmpv6-type", ("icmpv6_type", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type)), ("icmpv6-code", ("icmpv6_code", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code)), ("mpls-exp", ("mpls_exp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp)), ("mpls-exp-imp", ("mpls_exp_imp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp)), ("mpls-disp-ipv4-acl", ("mpls_disp_ipv4_acl", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl)), ("mpls-disp-ipv6-acl", ("mpls_disp_ipv6_acl", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl)), ("mpls-top-label", ("mpls_top_label", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel)), ("cos", ("cos", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos)), ("cos-inr", ("cos_inr", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr)), ("dei", ("dei", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei)), ("dei-inr", ("dei_inr", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr)), ("vlan", ("vlan", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan)), ("vlan-inr", ("vlan_inr", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)), ("fr-dlci", ("fr_dlci", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci)), ("src-mac", ("src_mac", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac)), ("dst-mac", ("dst_mac", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac)), ("atm-clp", ("atm_clp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp)), ("fr-de", ("fr_de", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe)), ("ipv4-acl", ("ipv4_acl", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl)), ("ipv6-acl", ("ipv6_acl", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl)), ("ether-service-acl", ("ether_service_acl", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl)), ("avail-id", ("avail_id", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId)), ("media-type", ("media_type", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType)), ("subs-protocol", ("subs_protocol", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol)), ("dnis", ("dnis", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis)), ("dnis-regex", ("dnis_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex)), ("domain", ("domain", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain)), ("domain-regex", ("domain_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex)), ("nas-port", ("nas_port", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort)), ("service-name", ("service_name", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName)), ("service-name-regex", ("service_name_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex)), ("src-addr-ipv4", ("src_addr_ipv4", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4)), ("dst-addr-ipv4", ("dst_addr_ipv4", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4)), ("src-addr-ipv6", ("src_addr_ipv6", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6)), ("dst-addr-ipv6", ("dst_addr_ipv6", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6)), ("src-addr-mac", ("src_addr_mac", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac)), ("timer", ("timer", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer)), ("timer-regexp", ("timer_regexp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp)), ("tunnel-name", ("tunnel_name", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName)), ("tunnel-name-regex", ("tunnel_name_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex)), ("user-name", ("user_name", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName)), ("user-name-regex", ("user_name_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex)), ("auth-username", ("auth_username", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername)), ("auth-username-regex", ("auth_username_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex)), ("unauth-username", ("unauth_username", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername)), ("unauth-username-regex", ("unauth_username_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex)), ("auth-domain", ("auth_domain", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain)), ("auth-domain-regex", ("auth_domain_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex)), ("unauth-domain", ("unauth_domain", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain)), ("unauth-domain-regex", ("unauth_domain_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex)), ("vendor-id", ("vendor_id", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId)), ("vendor-id-regex", ("vendor_id_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex)), ("access-interface", ("access_interface", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface)), ("input-interface", ("input_interface", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface)), ("input-intfhdl", ("input_intfhdl", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl)), ("ethertype", ("ethertype", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype)), ("flow-key-data", ("flow_key_data", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData)), ("dhcp-client-id", ("dhcp_client_id", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId)), ("dhcp-client-id-regex", ("dhcp_client_id_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex)), ("circuit-id", ("circuit_id", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId)), ("circuit-id-regex", ("circuit_id_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex)), ("remote-id", ("remote_id", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId)), ("remote-id-regex", ("remote_id_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex)), ("src-port", ("src_port", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort)), ("dst-port", ("dst_port", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchTypeEn', '')])),
                                                                                    ('mpls_top_eos', (YLeaf(YType.uint8, 'mpls-top-eos'), ['int'])),
                                                                                    ('fragment_type', (YLeaf(YType.uint8, 'fragment-type'), ['int'])),
                                                                                    ('authen_status', (YLeaf(YType.enumeration, 'authen-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchAuthenStatusEn', '')])),
                                                                                    ('mlp_negotiated', (YLeaf(YType.enumeration, 'mlp-negotiated'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchMlpNegotiatedEn', '')])),
                                                                                ])
                                                                                self.type = None
                                                                                self.mpls_top_eos = None
                                                                                self.fragment_type = None
                                                                                self.authen_status = None
                                                                                self.mlp_negotiated = None

                                                                                self.ipv4_dscp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                self.ipv4_dscp.parent = self
                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"

                                                                                self.ipv6_dscp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                self.ipv6_dscp.parent = self
                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"

                                                                                self.dscp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                self.dscp.parent = self
                                                                                self._children_name_map["dscp"] = "dscp"

                                                                                self.ipv4_prec = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                self.ipv4_prec.parent = self
                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"

                                                                                self.ipv6_prec = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                self.ipv6_prec.parent = self
                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"

                                                                                self.prec = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                self.prec.parent = self
                                                                                self._children_name_map["prec"] = "prec"

                                                                                self.discard_class = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                self.discard_class.parent = self
                                                                                self._children_name_map["discard_class"] = "discard-class"

                                                                                self.qos_group = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                self.qos_group.parent = self
                                                                                self._children_name_map["qos_group"] = "qos-group"

                                                                                self.traffic_class = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                self.traffic_class.parent = self
                                                                                self._children_name_map["traffic_class"] = "traffic-class"

                                                                                self.proto = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                self.proto.parent = self
                                                                                self._children_name_map["proto"] = "proto"

                                                                                self.icmp_v4 = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                self.icmp_v4.parent = self
                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"

                                                                                self.icmp_v6 = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                self.icmp_v6.parent = self
                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"

                                                                                self.ipv4_packet_len = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                self.ipv4_packet_len.parent = self
                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"

                                                                                self.ipv6_packet_len = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                self.ipv6_packet_len.parent = self
                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"

                                                                                self.packet_len = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                self.packet_len.parent = self
                                                                                self._children_name_map["packet_len"] = "packet-len"

                                                                                self.flow_tag = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                self.flow_tag.parent = self
                                                                                self._children_name_map["flow_tag"] = "flow-tag"

                                                                                self.tcp_flag = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                self.tcp_flag.parent = self
                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"

                                                                                self.icmpv4_type = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                self.icmpv4_type.parent = self
                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"

                                                                                self.icmpv4_code = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                self.icmpv4_code.parent = self
                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"

                                                                                self.icmpv6_type = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                self.icmpv6_type.parent = self
                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"

                                                                                self.icmpv6_code = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                self.icmpv6_code.parent = self
                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"

                                                                                self.mpls_exp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                self.mpls_exp.parent = self
                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"

                                                                                self.mpls_exp_imp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                self.mpls_exp_imp.parent = self
                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"

                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"

                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"

                                                                                self.mpls_top_label = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                self.mpls_top_label.parent = self
                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"

                                                                                self.cos = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                self.cos.parent = self
                                                                                self._children_name_map["cos"] = "cos"

                                                                                self.cos_inr = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                self.cos_inr.parent = self
                                                                                self._children_name_map["cos_inr"] = "cos-inr"

                                                                                self.dei = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                self.dei.parent = self
                                                                                self._children_name_map["dei"] = "dei"

                                                                                self.dei_inr = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                self.dei_inr.parent = self
                                                                                self._children_name_map["dei_inr"] = "dei-inr"

                                                                                self.vlan = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                self.vlan.parent = self
                                                                                self._children_name_map["vlan"] = "vlan"

                                                                                self.vlan_inr = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                self.vlan_inr.parent = self
                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"

                                                                                self.fr_dlci = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                self.fr_dlci.parent = self
                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"

                                                                                self.src_mac = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                self.src_mac.parent = self
                                                                                self._children_name_map["src_mac"] = "src-mac"

                                                                                self.dst_mac = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                self.dst_mac.parent = self
                                                                                self._children_name_map["dst_mac"] = "dst-mac"

                                                                                self.atm_clp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                self.atm_clp.parent = self
                                                                                self._children_name_map["atm_clp"] = "atm-clp"

                                                                                self.fr_de = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                self.fr_de.parent = self
                                                                                self._children_name_map["fr_de"] = "fr-de"

                                                                                self.ipv4_acl = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                self.ipv4_acl.parent = self
                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"

                                                                                self.ipv6_acl = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                self.ipv6_acl.parent = self
                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"

                                                                                self.ether_service_acl = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                self.ether_service_acl.parent = self
                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"

                                                                                self.avail_id = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                self.avail_id.parent = self
                                                                                self._children_name_map["avail_id"] = "avail-id"

                                                                                self.media_type = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                self.media_type.parent = self
                                                                                self._children_name_map["media_type"] = "media-type"

                                                                                self.subs_protocol = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                self.subs_protocol.parent = self
                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"

                                                                                self.dnis = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                self.dnis.parent = self
                                                                                self._children_name_map["dnis"] = "dnis"

                                                                                self.dnis_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                self.dnis_regex.parent = self
                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"

                                                                                self.domain = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                self.domain.parent = self
                                                                                self._children_name_map["domain"] = "domain"

                                                                                self.domain_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                self.domain_regex.parent = self
                                                                                self._children_name_map["domain_regex"] = "domain-regex"

                                                                                self.nas_port = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                self.nas_port.parent = self
                                                                                self._children_name_map["nas_port"] = "nas-port"

                                                                                self.service_name = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                self.service_name.parent = self
                                                                                self._children_name_map["service_name"] = "service-name"

                                                                                self.service_name_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                self.service_name_regex.parent = self
                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"

                                                                                self.src_addr_ipv4 = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                self.src_addr_ipv4.parent = self
                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"

                                                                                self.dst_addr_ipv4 = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                self.dst_addr_ipv4.parent = self
                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"

                                                                                self.src_addr_ipv6 = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                self.src_addr_ipv6.parent = self
                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"

                                                                                self.dst_addr_ipv6 = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                self.dst_addr_ipv6.parent = self
                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"

                                                                                self.src_addr_mac = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                self.src_addr_mac.parent = self
                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"

                                                                                self.timer = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                self.timer.parent = self
                                                                                self._children_name_map["timer"] = "timer"

                                                                                self.timer_regexp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                self.timer_regexp.parent = self
                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"

                                                                                self.tunnel_name = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                self.tunnel_name.parent = self
                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"

                                                                                self.tunnel_name_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                self.tunnel_name_regex.parent = self
                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"

                                                                                self.user_name = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                self.user_name.parent = self
                                                                                self._children_name_map["user_name"] = "user-name"

                                                                                self.user_name_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                self.user_name_regex.parent = self
                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"

                                                                                self.auth_username = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                self.auth_username.parent = self
                                                                                self._children_name_map["auth_username"] = "auth-username"

                                                                                self.auth_username_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                self.auth_username_regex.parent = self
                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"

                                                                                self.unauth_username = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                self.unauth_username.parent = self
                                                                                self._children_name_map["unauth_username"] = "unauth-username"

                                                                                self.unauth_username_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                self.unauth_username_regex.parent = self
                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"

                                                                                self.auth_domain = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                self.auth_domain.parent = self
                                                                                self._children_name_map["auth_domain"] = "auth-domain"

                                                                                self.auth_domain_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                self.auth_domain_regex.parent = self
                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"

                                                                                self.unauth_domain = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                self.unauth_domain.parent = self
                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"

                                                                                self.unauth_domain_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                self.unauth_domain_regex.parent = self
                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"

                                                                                self.vendor_id = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                self.vendor_id.parent = self
                                                                                self._children_name_map["vendor_id"] = "vendor-id"

                                                                                self.vendor_id_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                self.vendor_id_regex.parent = self
                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"

                                                                                self.access_interface = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                self.access_interface.parent = self
                                                                                self._children_name_map["access_interface"] = "access-interface"

                                                                                self.input_interface = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                self.input_interface.parent = self
                                                                                self._children_name_map["input_interface"] = "input-interface"

                                                                                self.input_intfhdl = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                self.input_intfhdl.parent = self
                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"

                                                                                self.ethertype = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                self.ethertype.parent = self
                                                                                self._children_name_map["ethertype"] = "ethertype"

                                                                                self.flow_key_data = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                self.flow_key_data.parent = self
                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"

                                                                                self.dhcp_client_id = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                self.dhcp_client_id.parent = self
                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"

                                                                                self.dhcp_client_id_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                self.dhcp_client_id_regex.parent = self
                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"

                                                                                self.circuit_id = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                self.circuit_id.parent = self
                                                                                self._children_name_map["circuit_id"] = "circuit-id"

                                                                                self.circuit_id_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                self.circuit_id_regex.parent = self
                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"

                                                                                self.remote_id = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                self.remote_id.parent = self
                                                                                self._children_name_map["remote_id"] = "remote-id"

                                                                                self.remote_id_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                self.remote_id_regex.parent = self
                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"

                                                                                self.src_port = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                self.src_port.parent = self
                                                                                self._children_name_map["src_port"] = "src-port"

                                                                                self.dst_port = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                self.dst_port.parent = self
                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                self._segment_path = lambda: "match-data"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['type', 'mpls_top_eos', 'fragment_type', 'authen_status', 'mlp_negotiated'], name, value)


                                                                            class Ipv4Dscp(Entity):
                                                                                """
                                                                                IPv4 DSCP
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                    self.yang_name = "ipv4-dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv4-dscp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Ipv6Dscp(Entity):
                                                                                """
                                                                                IPv6 DSCP
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                    self.yang_name = "ipv6-dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv6-dscp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Dscp(Entity):
                                                                                """
                                                                                Match DSCP range array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                    self.yang_name = "dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "dscp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Ipv4Prec(Entity):
                                                                                """
                                                                                IPv4 Precedence
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                    self.yang_name = "ipv4-prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "ipv4-prec"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                            class Ipv6Prec(Entity):
                                                                                """
                                                                                IPv6 Precedence
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                    self.yang_name = "ipv6-prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "ipv6-prec"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                            class Prec(Entity):
                                                                                """
                                                                                Match Precedence array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                    self.yang_name = "prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "prec"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                            class DiscardClass(Entity):
                                                                                """
                                                                                Match Discard Class array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                    self.yang_name = "discard-class"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "discard-class"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                            class QosGroup(Entity):
                                                                                """
                                                                                Match QoS group array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                    self.yang_name = "qos-group"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "qos-group"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "qos-group"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class TrafficClass(Entity):
                                                                                """
                                                                                Match Traffic class array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                    self.yang_name = "traffic-class"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "traffic-class"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "traffic-class"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Proto(Entity):
                                                                                """
                                                                                Match Protocol array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                    self.yang_name = "proto"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "proto"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "proto"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class IcmpV4(Entity):
                                                                                """
                                                                                Match ICMPV4 Protocol
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Protocol type
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: code
                                                                                
                                                                                	Protocol code
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                    self.yang_name = "icmp-v4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                    ])
                                                                                    self.type = None
                                                                                    self.code = None
                                                                                    self._segment_path = lambda: "icmp-v4"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['type', 'code'], name, value)


                                                                            class IcmpV6(Entity):
                                                                                """
                                                                                Match ICMPV6 Protocol array
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Protocol type
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: code
                                                                                
                                                                                	Protocol code
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                    self.yang_name = "icmp-v6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                    ])
                                                                                    self.type = None
                                                                                    self.code = None
                                                                                    self._segment_path = lambda: "icmp-v6"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['type', 'code'], name, value)


                                                                            class Ipv4PacketLen(Entity):
                                                                                """
                                                                                IPv4 packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv4-packet-len"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class Ipv6PacketLen(Entity):
                                                                                """
                                                                                IPv6 packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv6-packet-len"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class PacketLen(Entity):
                                                                                """
                                                                                Match packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                    self.yang_name = "packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "packet-len"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class FlowTag(Entity):
                                                                                """
                                                                                Match flow\-tag array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                    self.yang_name = "flow-tag"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "flow-tag"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "flow-tag"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class TcpFlag(Entity):
                                                                                """
                                                                                Match tcp flag value
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	Value of TCP flag
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: match_any
                                                                                
                                                                                	Match any TCP flag bit
                                                                                	**type**\: bool
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                    self.yang_name = "tcp-flag"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                        ('match_any', (YLeaf(YType.boolean, 'match-any'), ['bool'])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.match_any = None
                                                                                    self._segment_path = lambda: "tcp-flag"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['value', 'match_any'], name, value)


                                                                            class Icmpv4Type(Entity):
                                                                                """
                                                                                Match ipv4 icmp type
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                    self.yang_name = "icmpv4-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv4-type"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Icmpv4Code(Entity):
                                                                                """
                                                                                Match ipv4 icmp code
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                    self.yang_name = "icmpv4-code"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv4-code"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Icmpv6Type(Entity):
                                                                                """
                                                                                Match ipv6 icmp type
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                    self.yang_name = "icmpv6-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv6-type"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Icmpv6Code(Entity):
                                                                                """
                                                                                Match ipv6 icmp code
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                    self.yang_name = "icmpv6-code"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv6-code"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class MplsExp(Entity):
                                                                                """
                                                                                Match MPLS experimental topmost array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                    self.yang_name = "mpls-exp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "mpls-exp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                            class MplsExpImp(Entity):
                                                                                """
                                                                                Match MPLS experimental imposition array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "mpls-exp-imp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                            class MplsDispIpv4Acl(Entity):
                                                                                """
                                                                                MPLS Disposition IPv4 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                            class MplsDispIpv6Acl(Entity):
                                                                                """
                                                                                MPLS Disposition IPv6 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                            class MplsTopLabel(Entity):
                                                                                """
                                                                                MPLS Topmost LABEL
                                                                                
                                                                                .. attribute:: uint32_rng_array
                                                                                
                                                                                	uint32 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                    self.yang_name = "mpls-top-label"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint32_rng_array", ("uint32_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint32_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "mpls-top-label"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                class Uint32RngArray(Entity):
                                                                                    """
                                                                                    uint32 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                        self.yang_name = "uint32_rng_array"
                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint32, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint32, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint32_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['min', 'max'], name, value)


                                                                            class Cos(Entity):
                                                                                """
                                                                                Match CoS array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                    self.yang_name = "cos"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "cos"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                            class CosInr(Entity):
                                                                                """
                                                                                Match inner header CoS
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                    self.yang_name = "cos-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "cos-inr"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                            class Dei(Entity):
                                                                                """
                                                                                Match DEI Bit
                                                                                
                                                                                .. attribute:: bit_value
                                                                                
                                                                                	Value of the DEI bit
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                    self.yang_name = "dei"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                    ])
                                                                                    self.bit_value = None
                                                                                    self._segment_path = lambda: "dei"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                            class DeiInr(Entity):
                                                                                """
                                                                                Match inner DEI Bit
                                                                                
                                                                                .. attribute:: bit_value
                                                                                
                                                                                	Value of the DEI bit
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                    self.yang_name = "dei-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                    ])
                                                                                    self.bit_value = None
                                                                                    self._segment_path = lambda: "dei-inr"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                            class Vlan(Entity):
                                                                                """
                                                                                Match VLAN array
                                                                                
                                                                                .. attribute:: vlan_id_array
                                                                                
                                                                                	vlan id array
                                                                                	**type**\: list of  		 :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                    self.yang_name = "vlan"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("vlan-id-array", ("vlan_id_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.vlan_id_array = YList(self)
                                                                                    self._segment_path = lambda: "vlan"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                class VlanIdArray(Entity):
                                                                                    """
                                                                                    vlan id array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	VLAN mask
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                        self.yang_name = "vlan-id-array"
                                                                                        self.yang_parent_name = "vlan"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                            ('mask', (YLeaf(YType.uint16, 'mask'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self.mask = None
                                                                                        self._segment_path = lambda: "vlan-id-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['min', 'max', 'mask'], name, value)


                                                                            class VlanInr(Entity):
                                                                                """
                                                                                Match inner header VLAN range array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                    self.yang_name = "vlan-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "vlan-inr"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class FrDlci(Entity):
                                                                                """
                                                                                Match FR DLCI range array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                    self.yang_name = "fr-dlci"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "fr-dlci"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class SrcMac(Entity):
                                                                                """
                                                                                Match Source MAC address
                                                                                
                                                                                .. attribute:: mac_addr
                                                                                
                                                                                	MAC address
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	MAC mask
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                    self.yang_name = "src-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                    ])
                                                                                    self.mac_addr = []
                                                                                    self.mask = []
                                                                                    self._segment_path = lambda: "src-mac"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                            class DstMac(Entity):
                                                                                """
                                                                                Match Destination MAC address
                                                                                
                                                                                .. attribute:: mac_addr
                                                                                
                                                                                	MAC address
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	MAC mask
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                    self.yang_name = "dst-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                    ])
                                                                                    self.mac_addr = []
                                                                                    self.mask = []
                                                                                    self._segment_path = lambda: "dst-mac"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                            class AtmClp(Entity):
                                                                                """
                                                                                Match ATM CLP level
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                    self.yang_name = "atm-clp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "atm-clp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                            class FrDe(Entity):
                                                                                """
                                                                                Match FR DE value
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                    self.yang_name = "fr-de"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "fr-de"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                            class Ipv4Acl(Entity):
                                                                                """
                                                                                IPv4 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                    self.yang_name = "ipv4-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "ipv4-acl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                            class Ipv6Acl(Entity):
                                                                                """
                                                                                IPv6 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                    self.yang_name = "ipv6-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "ipv6-acl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                            class EtherServiceAcl(Entity):
                                                                                """
                                                                                Ethernet\-Services Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                    self.yang_name = "ether-service-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "ether-service-acl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                            class AvailId(Entity):
                                                                                """
                                                                                Available Identifiers
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                    self.yang_name = "avail-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "avail-id"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                            class MediaType(Entity):
                                                                                """
                                                                                Media Type
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                    self.yang_name = "media-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "media-type"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                            class SubsProtocol(Entity):
                                                                                """
                                                                                Protocol
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                    self.yang_name = "subs-protocol"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "subs-protocol"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                            class Dnis(Entity):
                                                                                """
                                                                                DNIS
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                    self.yang_name = "dnis"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "dnis"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                            class DnisRegex(Entity):
                                                                                """
                                                                                DNIS Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                    self.yang_name = "dnis-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "dnis-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                            class Domain(Entity):
                                                                                """
                                                                                Domain Name
                                                                                
                                                                                .. attribute:: domain_array
                                                                                
                                                                                	domain array
                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                    self.yang_name = "domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.domain_array = YList(self)
                                                                                    self._segment_path = lambda: "domain"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                class DomainArray(Entity):
                                                                                    """
                                                                                    domain array
                                                                                    
                                                                                    .. attribute:: domain_name
                                                                                    
                                                                                    	domain name
                                                                                    	**type**\: str
                                                                                    
                                                                                    .. attribute:: format_name
                                                                                    
                                                                                    	format name
                                                                                    	**type**\: str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                        self.yang_name = "domain-array"
                                                                                        self.yang_parent_name = "domain"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                        ])
                                                                                        self.domain_name = None
                                                                                        self.format_name = None
                                                                                        self._segment_path = lambda: "domain-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                            class DomainRegex(Entity):
                                                                                """
                                                                                Domain Regular Expression
                                                                                
                                                                                .. attribute:: domain_array
                                                                                
                                                                                	domain array
                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                    self.yang_name = "domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.domain_array = YList(self)
                                                                                    self._segment_path = lambda: "domain-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                class DomainArray(Entity):
                                                                                    """
                                                                                    domain array
                                                                                    
                                                                                    .. attribute:: domain_name
                                                                                    
                                                                                    	domain name
                                                                                    	**type**\: str
                                                                                    
                                                                                    .. attribute:: format_name
                                                                                    
                                                                                    	format name
                                                                                    	**type**\: str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                        self.yang_name = "domain-array"
                                                                                        self.yang_parent_name = "domain-regex"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                        ])
                                                                                        self.domain_name = None
                                                                                        self.format_name = None
                                                                                        self._segment_path = lambda: "domain-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                            class NasPort(Entity):
                                                                                """
                                                                                NAS Port
                                                                                
                                                                                .. attribute:: nas_port_array
                                                                                
                                                                                	nas port array
                                                                                	**type**\: list of  		 :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                    self.yang_name = "nas-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("nas-port-array", ("nas_port_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.nas_port_array = YList(self)
                                                                                    self._segment_path = lambda: "nas-port"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                class NasPortArray(Entity):
                                                                                    """
                                                                                    nas port array
                                                                                    
                                                                                    .. attribute:: sub_id
                                                                                    
                                                                                    	sub id
                                                                                    	**type**\:  :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                    
                                                                                    .. attribute:: operator
                                                                                    
                                                                                    	operator
                                                                                    	**type**\:  :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                        self.yang_name = "nas-port-array"
                                                                                        self.yang_parent_name = "nas-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('sub_id', (YLeaf(YType.enumeration, 'sub-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchNasPortSubIdEn', '')])),
                                                                                            ('operator', (YLeaf(YType.enumeration, 'operator'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchLogicalOperatorEn', '')])),
                                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ])
                                                                                        self.sub_id = None
                                                                                        self.operator = None
                                                                                        self.value = None
                                                                                        self._segment_path = lambda: "nas-port-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['sub_id', 'operator', 'value'], name, value)


                                                                            class ServiceName(Entity):
                                                                                """
                                                                                Service Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                    self.yang_name = "service-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "service-name"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                            class ServiceNameRegex(Entity):
                                                                                """
                                                                                Service Name Regular Exp
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                    self.yang_name = "service-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "service-name-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                            class SrcAddrIpv4(Entity):
                                                                                """
                                                                                Source Address IPV4
                                                                                
                                                                                .. attribute:: ipv4_addr_array
                                                                                
                                                                                	ipv4 addr array
                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.ipv4_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-ipv4"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                class Ipv4AddrArray(Entity):
                                                                                    """
                                                                                    ipv4 addr array
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	prefix
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	mask
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                        ])
                                                                                        self.prefix = None
                                                                                        self.mask = None
                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                            class DstAddrIpv4(Entity):
                                                                                """
                                                                                Destination Address IPV4
                                                                                
                                                                                .. attribute:: ipv4_addr_array
                                                                                
                                                                                	ipv4 addr array
                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.ipv4_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-addr-ipv4"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                class Ipv4AddrArray(Entity):
                                                                                    """
                                                                                    ipv4 addr array
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	prefix
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	mask
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                        ])
                                                                                        self.prefix = None
                                                                                        self.mask = None
                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                            class SrcAddrIpv6(Entity):
                                                                                """
                                                                                Source Address IPV6
                                                                                
                                                                                .. attribute:: ipv6_addr_array
                                                                                
                                                                                	ipv6 addr array
                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.ipv6_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-ipv6"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                class Ipv6AddrArray(Entity):
                                                                                    """
                                                                                    ipv6 addr array
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	IPV6 prefix
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	IPV6 mask
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                        ])
                                                                                        self.prefix = None
                                                                                        self.mask = None
                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                            class DstAddrIpv6(Entity):
                                                                                """
                                                                                Destination Address IPV6
                                                                                
                                                                                .. attribute:: ipv6_addr_array
                                                                                
                                                                                	ipv6 addr array
                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.ipv6_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-addr-ipv6"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                class Ipv6AddrArray(Entity):
                                                                                    """
                                                                                    ipv6 addr array
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	IPV6 prefix
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	IPV6 mask
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                        ])
                                                                                        self.prefix = None
                                                                                        self.mask = None
                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                            class SrcAddrMac(Entity):
                                                                                """
                                                                                Source Address MAC
                                                                                
                                                                                .. attribute:: mac_addr_array
                                                                                
                                                                                	mac addr array
                                                                                	**type**\: list of  		 :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                    self.yang_name = "src-addr-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("mac-addr-array", ("mac_addr_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.mac_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-mac"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                class MacAddrArray(Entity):
                                                                                    """
                                                                                    mac addr array
                                                                                    
                                                                                    .. attribute:: mac_addr
                                                                                    
                                                                                    	MAC address
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	MAC mask
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                        self.yang_name = "mac-addr-array"
                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                            ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                        ])
                                                                                        self.mac_addr = []
                                                                                        self.mask = []
                                                                                        self._segment_path = lambda: "mac-addr-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                            class Timer(Entity):
                                                                                """
                                                                                Timer
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                    self.yang_name = "timer"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "timer"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                            class TimerRegexp(Entity):
                                                                                """
                                                                                Timer Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                    self.yang_name = "timer-regexp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "timer-regexp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                            class TunnelName(Entity):
                                                                                """
                                                                                Tunnel Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                    self.yang_name = "tunnel-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "tunnel-name"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                            class TunnelNameRegex(Entity):
                                                                                """
                                                                                Tunnel Name Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "tunnel-name-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                            class UserName(Entity):
                                                                                """
                                                                                User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                    self.yang_name = "user-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "user-name"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                            class UserNameRegex(Entity):
                                                                                """
                                                                                User Name Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                    self.yang_name = "user-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "user-name-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                            class AuthUsername(Entity):
                                                                                """
                                                                                Authenticated User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                    self.yang_name = "auth-username"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "auth-username"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                            class AuthUsernameRegex(Entity):
                                                                                """
                                                                                Authenticated User Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                    self.yang_name = "auth-username-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "auth-username-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                            class UnauthUsername(Entity):
                                                                                """
                                                                                Unauthenticated User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                    self.yang_name = "unauth-username"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "unauth-username"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                            class UnauthUsernameRegex(Entity):
                                                                                """
                                                                                Unauthenticated User Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                    self.yang_name = "unauth-username-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "unauth-username-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                            class AuthDomain(Entity):
                                                                                """
                                                                                Authenticated domain name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                    self.yang_name = "auth-domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "auth-domain"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                            class AuthDomainRegex(Entity):
                                                                                """
                                                                                Authenticated Domain Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                    self.yang_name = "auth-domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "auth-domain-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                            class UnauthDomain(Entity):
                                                                                """
                                                                                Unauthenticated Domain Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                    self.yang_name = "unauth-domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "unauth-domain"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                            class UnauthDomainRegex(Entity):
                                                                                """
                                                                                Unauthenticated Domain Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "unauth-domain-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                            class VendorId(Entity):
                                                                                """
                                                                                Vendor ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                    self.yang_name = "vendor-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "vendor-id"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                            class VendorIdRegex(Entity):
                                                                                """
                                                                                Vendor ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                    self.yang_name = "vendor-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "vendor-id-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                            class AccessInterface(Entity):
                                                                                """
                                                                                Access interface
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                    self.yang_name = "access-interface"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "access-interface"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                            class InputInterface(Entity):
                                                                                """
                                                                                Input interface
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                    self.yang_name = "input-interface"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "input-interface"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                            class InputIntfhdl(Entity):
                                                                                """
                                                                                Input interface handle
                                                                                
                                                                                .. attribute:: uint64_array
                                                                                
                                                                                	uint64 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..18446744073709551615
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                    self.yang_name = "input-intfhdl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint64_array', (YLeafList(YType.uint64, 'uint64_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint64_array = []
                                                                                    self._segment_path = lambda: "input-intfhdl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                            class Ethertype(Entity):
                                                                                """
                                                                                Ethernet type
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                    self.yang_name = "ethertype"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ethertype"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ethertype"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class FlowKeyData(Entity):
                                                                                """
                                                                                Flow key structure
                                                                                
                                                                                .. attribute:: flow_keys
                                                                                
                                                                                	flow keys
                                                                                	**type**\:  :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                
                                                                                .. attribute:: max_count
                                                                                
                                                                                	Maximum count of flows
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: idle_timeout
                                                                                
                                                                                	Idle timeout of flows (in seconds)
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                	**units**\: second
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                    self.yang_name = "flow-key-data"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("flow-keys", ("flow_keys", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('max_count', (YLeaf(YType.uint16, 'max-count'), ['int'])),
                                                                                        ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                                    ])
                                                                                    self.max_count = None
                                                                                    self.idle_timeout = None

                                                                                    self.flow_keys = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                    self.flow_keys.parent = self
                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                    self._segment_path = lambda: "flow-key-data"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['max_count', 'idle_timeout'], name, value)


                                                                                class FlowKeys(Entity):
                                                                                    """
                                                                                    flow keys
                                                                                    
                                                                                    .. attribute:: keys
                                                                                    
                                                                                    	keys
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                    
                                                                                    .. attribute:: num
                                                                                    
                                                                                    	num
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                        self.yang_name = "flow-keys"
                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('keys', (YLeaf(YType.str, 'keys'), ['str'])),
                                                                                            ('num', (YLeaf(YType.uint8, 'num'), ['int'])),
                                                                                        ])
                                                                                        self.keys = None
                                                                                        self.num = None
                                                                                        self._segment_path = lambda: "flow-keys"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                            class DhcpClientId(Entity):
                                                                                """
                                                                                Dhcp Client ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                    self.yang_name = "dhcp-client-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "dhcp-client-id"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                            class DhcpClientIdRegex(Entity):
                                                                                """
                                                                                Dhcp Client ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                            class CircuitId(Entity):
                                                                                """
                                                                                Circuit ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                    self.yang_name = "circuit-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "circuit-id"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                            class CircuitIdRegex(Entity):
                                                                                """
                                                                                Circuit ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                    self.yang_name = "circuit-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "circuit-id-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                            class RemoteId(Entity):
                                                                                """
                                                                                Remote ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                    self.yang_name = "remote-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "remote-id"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                            class RemoteIdRegex(Entity):
                                                                                """
                                                                                Remote ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                    self.yang_name = "remote-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "remote-id-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                            class SrcPort(Entity):
                                                                                """
                                                                                Source port
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                    self.yang_name = "src-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "src-port"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "src-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class DstPort(Entity):
                                                                                """
                                                                                Destination port
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                    self.yang_name = "dst-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-port"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "dst-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['min', 'max'], name, value)


                                                        class ActInfop(Entity):
                                                            """
                                                            act infop
                                                            
                                                            .. attribute:: policy_action_info_st
                                                            
                                                            	policy action info st
                                                            	**type**\: list of  		 :py:class:`PolicyActionInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'infra-policymgr-oper'
                                                            _revision = '2018-01-17'

                                                            def __init__(self):
                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop, self).__init__()

                                                                self.yang_name = "act-infop"
                                                                self.yang_parent_name = "policy-class-info-bg"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("policy-action-info-st", ("policy_action_info_st", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt))])
                                                                self._leafs = OrderedDict()

                                                                self.policy_action_info_st = YList(self)
                                                                self._segment_path = lambda: "act-infop"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop, [], name, value)


                                                            class PolicyActionInfoSt(Entity):
                                                                """
                                                                policy action info st
                                                                
                                                                .. attribute:: actp
                                                                
                                                                	actp
                                                                	**type**\:  :py:class:`Actp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp>`
                                                                
                                                                .. attribute:: seq
                                                                
                                                                	seq
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..65535
                                                                
                                                                .. attribute:: flags
                                                                
                                                                	flags
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..65535
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt, self).__init__()

                                                                    self.yang_name = "policy-action-info-st"
                                                                    self.yang_parent_name = "act-infop"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("actp", ("actp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp))])
                                                                    self._leafs = OrderedDict([
                                                                        ('seq', (YLeaf(YType.uint16, 'seq'), ['int'])),
                                                                        ('flags', (YLeaf(YType.uint16, 'flags'), ['int'])),
                                                                    ])
                                                                    self.seq = None
                                                                    self.flags = None

                                                                    self.actp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp()
                                                                    self.actp.parent = self
                                                                    self._children_name_map["actp"] = "actp"
                                                                    self._segment_path = lambda: "policy-action-info-st"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt, ['seq', 'flags'], name, value)


                                                                class Actp(Entity):
                                                                    """
                                                                    actp
                                                                    
                                                                    .. attribute:: mark
                                                                    
                                                                    	mark
                                                                    	**type**\:  :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark>`
                                                                    
                                                                    .. attribute:: mark2
                                                                    
                                                                    	mark2
                                                                    	**type**\:  :py:class:`Mark2 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2>`
                                                                    
                                                                    .. attribute:: wred
                                                                    
                                                                    	wred
                                                                    	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred>`
                                                                    
                                                                    .. attribute:: encap
                                                                    
                                                                    	encap
                                                                    	**type**\:  :py:class:`Encap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap>`
                                                                    
                                                                    .. attribute:: prio
                                                                    
                                                                    	prio
                                                                    	**type**\:  :py:class:`Prio <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio>`
                                                                    
                                                                    .. attribute:: bwrem
                                                                    
                                                                    	bwrem
                                                                    	**type**\:  :py:class:`Bwrem <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem>`
                                                                    
                                                                    .. attribute:: min_bw
                                                                    
                                                                    	min bw
                                                                    	**type**\:  :py:class:`MinBw <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw>`
                                                                    
                                                                    .. attribute:: authen_aaa
                                                                    
                                                                    	authen aaa
                                                                    	**type**\:  :py:class:`AuthenAaa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa>`
                                                                    
                                                                    .. attribute:: collect_id
                                                                    
                                                                    	collect id
                                                                    	**type**\:  :py:class:`CollectId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId>`
                                                                    
                                                                    .. attribute:: decode_id
                                                                    
                                                                    	decode id
                                                                    	**type**\:  :py:class:`DecodeId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId>`
                                                                    
                                                                    .. attribute:: set_timer
                                                                    
                                                                    	set timer
                                                                    	**type**\:  :py:class:`SetTimer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer>`
                                                                    
                                                                    .. attribute:: stop_timer
                                                                    
                                                                    	stop timer
                                                                    	**type**\:  :py:class:`StopTimer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer>`
                                                                    
                                                                    .. attribute:: acct_aaa_list
                                                                    
                                                                    	acct aaa list
                                                                    	**type**\:  :py:class:`AcctAaaList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList>`
                                                                    
                                                                    .. attribute:: query_ancp
                                                                    
                                                                    	query ancp
                                                                    	**type**\:  :py:class:`QueryAncp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp>`
                                                                    
                                                                    .. attribute:: prepaid_cfg
                                                                    
                                                                    	prepaid cfg
                                                                    	**type**\:  :py:class:`PrepaidCfg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg>`
                                                                    
                                                                    .. attribute:: timeout_idle
                                                                    
                                                                    	timeout idle
                                                                    	**type**\:  :py:class:`TimeoutIdle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle>`
                                                                    
                                                                    .. attribute:: proxy_aaa
                                                                    
                                                                    	proxy aaa
                                                                    	**type**\:  :py:class:`ProxyAaa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa>`
                                                                    
                                                                    .. attribute:: act_template
                                                                    
                                                                    	act template
                                                                    	**type**\:  :py:class:`ActTemplate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate>`
                                                                    
                                                                    .. attribute:: deact_template
                                                                    
                                                                    	deact template
                                                                    	**type**\:  :py:class:`DeactTemplate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate>`
                                                                    
                                                                    .. attribute:: qlimit
                                                                    
                                                                    	qlimit
                                                                    	**type**\:  :py:class:`Qlimit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit>`
                                                                    
                                                                    .. attribute:: accounting_event_aaa
                                                                    
                                                                    	accounting event aaa
                                                                    	**type**\:  :py:class:`AccountingEventAaa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa>`
                                                                    
                                                                    .. attribute:: authorize_id
                                                                    
                                                                    	authorize id
                                                                    	**type**\:  :py:class:`AuthorizeId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId>`
                                                                    
                                                                    .. attribute:: afm_react
                                                                    
                                                                    	afm react
                                                                    	**type**\:  :py:class:`AfmReact <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact>`
                                                                    
                                                                    .. attribute:: httpr
                                                                    
                                                                    	httpr
                                                                    	**type**\:  :py:class:`Httpr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr>`
                                                                    
                                                                    .. attribute:: punt
                                                                    
                                                                    	punt
                                                                    	**type**\:  :py:class:`Punt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt>`
                                                                    
                                                                    .. attribute:: copy
                                                                    
                                                                    	copy
                                                                    	**type**\:  :py:class:`Copy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy>`
                                                                    
                                                                    .. attribute:: sfrag
                                                                    
                                                                    	sfrag
                                                                    	**type**\:  :py:class:`Sfrag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag>`
                                                                    
                                                                    .. attribute:: redirect
                                                                    
                                                                    	redirect
                                                                    	**type**\:  :py:class:`Redirect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect>`
                                                                    
                                                                    .. attribute:: out_intf
                                                                    
                                                                    	out intf
                                                                    	**type**\:  :py:class:`OutIntf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf>`
                                                                    
                                                                    .. attribute:: serv_func
                                                                    
                                                                    	serv func
                                                                    	**type**\:  :py:class:`ServFunc <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc>`
                                                                    
                                                                    .. attribute:: police
                                                                    
                                                                    	police
                                                                    	**type**\:  :py:class:`Police <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police>`
                                                                    
                                                                    .. attribute:: shape
                                                                    
                                                                    	shape
                                                                    	**type**\:  :py:class:`Shape <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape>`
                                                                    
                                                                    .. attribute:: child_policy
                                                                    
                                                                    	child policy
                                                                    	**type**\:  :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy>`
                                                                    
                                                                    .. attribute:: cac
                                                                    
                                                                    	cac
                                                                    	**type**\:  :py:class:`Cac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac>`
                                                                    
                                                                    .. attribute:: pfc
                                                                    
                                                                    	pfc
                                                                    	**type**\:  :py:class:`Pfc <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc>`
                                                                    
                                                                    .. attribute:: flow_parm
                                                                    
                                                                    	flow parm
                                                                    	**type**\:  :py:class:`FlowParm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm>`
                                                                    
                                                                    .. attribute:: ipcbr
                                                                    
                                                                    	ipcbr
                                                                    	**type**\:  :py:class:`Ipcbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr>`
                                                                    
                                                                    .. attribute:: rtp
                                                                    
                                                                    	rtp
                                                                    	**type**\:  :py:class:`Rtp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp>`
                                                                    
                                                                    .. attribute:: rtp_mmr
                                                                    
                                                                    	rtp mmr
                                                                    	**type**\:  :py:class:`RtpMmr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr>`
                                                                    
                                                                    .. attribute:: rtp_j2k
                                                                    
                                                                    	rtp j2k
                                                                    	**type**\:  :py:class:`RtpJ2k <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k>`
                                                                    
                                                                    .. attribute:: rtp_voice
                                                                    
                                                                    	rtp voice
                                                                    	**type**\:  :py:class:`RtpVoice <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice>`
                                                                    
                                                                    .. attribute:: mdi
                                                                    
                                                                    	mdi
                                                                    	**type**\:  :py:class:`Mdi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi>`
                                                                    
                                                                    .. attribute:: mdi_rtp
                                                                    
                                                                    	mdi rtp
                                                                    	**type**\:  :py:class:`MdiRtp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp>`
                                                                    
                                                                    .. attribute:: fmm
                                                                    
                                                                    	fmm
                                                                    	**type**\:  :py:class:`Fmm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm>`
                                                                    
                                                                    .. attribute:: pbf
                                                                    
                                                                    	pbf
                                                                    	**type**\:  :py:class:`Pbf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf>`
                                                                    
                                                                    .. attribute:: ipv4_nh
                                                                    
                                                                    	ipv4 nh
                                                                    	**type**\:  :py:class:`Ipv4Nh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh>`
                                                                    
                                                                    .. attribute:: ipv6_nh
                                                                    
                                                                    	ipv6 nh
                                                                    	**type**\:  :py:class:`Ipv6Nh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh>`
                                                                    
                                                                    .. attribute:: type
                                                                    
                                                                    	type
                                                                    	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                    
                                                                    .. attribute:: data_p
                                                                    
                                                                    	data p
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp, self).__init__()

                                                                        self.yang_name = "actp"
                                                                        self.yang_parent_name = "policy-action-info-st"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("mark", ("mark", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark)), ("mark2", ("mark2", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2)), ("wred", ("wred", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred)), ("encap", ("encap", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap)), ("prio", ("prio", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio)), ("bwrem", ("bwrem", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem)), ("min-bw", ("min_bw", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw)), ("authen-aaa", ("authen_aaa", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa)), ("collect-id", ("collect_id", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId)), ("decode-id", ("decode_id", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId)), ("set-timer", ("set_timer", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer)), ("stop-timer", ("stop_timer", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer)), ("acct-aaa-list", ("acct_aaa_list", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList)), ("query-ancp", ("query_ancp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp)), ("prepaid-cfg", ("prepaid_cfg", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg)), ("timeout-idle", ("timeout_idle", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle)), ("proxy-aaa", ("proxy_aaa", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa)), ("act-template", ("act_template", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate)), ("deact-template", ("deact_template", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate)), ("qlimit", ("qlimit", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit)), ("accounting-event-aaa", ("accounting_event_aaa", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa)), ("authorize-id", ("authorize_id", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId)), ("afm-react", ("afm_react", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact)), ("httpr", ("httpr", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr)), ("punt", ("punt", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt)), ("copy", ("copy", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy)), ("sfrag", ("sfrag", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag)), ("redirect", ("redirect", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect)), ("out-intf", ("out_intf", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf)), ("serv-func", ("serv_func", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc)), ("police", ("police", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police)), ("shape", ("shape", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape)), ("child-policy", ("child_policy", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy)), ("cac", ("cac", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac)), ("pfc", ("pfc", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc)), ("flow-parm", ("flow_parm", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm)), ("ipcbr", ("ipcbr", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr)), ("rtp", ("rtp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp)), ("rtp-mmr", ("rtp_mmr", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr)), ("rtp-j2k", ("rtp_j2k", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k)), ("rtp-voice", ("rtp_voice", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice)), ("mdi", ("mdi", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi)), ("mdi-rtp", ("mdi_rtp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp)), ("fmm", ("fmm", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm)), ("pbf", ("pbf", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf)), ("ipv4-nh", ("ipv4_nh", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh)), ("ipv6-nh", ("ipv6_nh", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh))])
                                                                        self._leafs = OrderedDict([
                                                                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                            ('data_p', (YLeaf(YType.uint32, 'data-p'), ['int'])),
                                                                        ])
                                                                        self.type = None
                                                                        self.data_p = None

                                                                        self.mark = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark()
                                                                        self.mark.parent = self
                                                                        self._children_name_map["mark"] = "mark"

                                                                        self.mark2 = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2()
                                                                        self.mark2.parent = self
                                                                        self._children_name_map["mark2"] = "mark2"

                                                                        self.wred = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred()
                                                                        self.wred.parent = self
                                                                        self._children_name_map["wred"] = "wred"

                                                                        self.encap = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap()
                                                                        self.encap.parent = self
                                                                        self._children_name_map["encap"] = "encap"

                                                                        self.prio = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio()
                                                                        self.prio.parent = self
                                                                        self._children_name_map["prio"] = "prio"

                                                                        self.bwrem = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem()
                                                                        self.bwrem.parent = self
                                                                        self._children_name_map["bwrem"] = "bwrem"

                                                                        self.min_bw = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw()
                                                                        self.min_bw.parent = self
                                                                        self._children_name_map["min_bw"] = "min-bw"

                                                                        self.authen_aaa = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa()
                                                                        self.authen_aaa.parent = self
                                                                        self._children_name_map["authen_aaa"] = "authen-aaa"

                                                                        self.collect_id = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId()
                                                                        self.collect_id.parent = self
                                                                        self._children_name_map["collect_id"] = "collect-id"

                                                                        self.decode_id = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId()
                                                                        self.decode_id.parent = self
                                                                        self._children_name_map["decode_id"] = "decode-id"

                                                                        self.set_timer = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer()
                                                                        self.set_timer.parent = self
                                                                        self._children_name_map["set_timer"] = "set-timer"

                                                                        self.stop_timer = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer()
                                                                        self.stop_timer.parent = self
                                                                        self._children_name_map["stop_timer"] = "stop-timer"

                                                                        self.acct_aaa_list = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList()
                                                                        self.acct_aaa_list.parent = self
                                                                        self._children_name_map["acct_aaa_list"] = "acct-aaa-list"

                                                                        self.query_ancp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp()
                                                                        self.query_ancp.parent = self
                                                                        self._children_name_map["query_ancp"] = "query-ancp"

                                                                        self.prepaid_cfg = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg()
                                                                        self.prepaid_cfg.parent = self
                                                                        self._children_name_map["prepaid_cfg"] = "prepaid-cfg"

                                                                        self.timeout_idle = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle()
                                                                        self.timeout_idle.parent = self
                                                                        self._children_name_map["timeout_idle"] = "timeout-idle"

                                                                        self.proxy_aaa = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa()
                                                                        self.proxy_aaa.parent = self
                                                                        self._children_name_map["proxy_aaa"] = "proxy-aaa"

                                                                        self.act_template = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate()
                                                                        self.act_template.parent = self
                                                                        self._children_name_map["act_template"] = "act-template"

                                                                        self.deact_template = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate()
                                                                        self.deact_template.parent = self
                                                                        self._children_name_map["deact_template"] = "deact-template"

                                                                        self.qlimit = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit()
                                                                        self.qlimit.parent = self
                                                                        self._children_name_map["qlimit"] = "qlimit"

                                                                        self.accounting_event_aaa = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa()
                                                                        self.accounting_event_aaa.parent = self
                                                                        self._children_name_map["accounting_event_aaa"] = "accounting-event-aaa"

                                                                        self.authorize_id = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId()
                                                                        self.authorize_id.parent = self
                                                                        self._children_name_map["authorize_id"] = "authorize-id"

                                                                        self.afm_react = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact()
                                                                        self.afm_react.parent = self
                                                                        self._children_name_map["afm_react"] = "afm-react"

                                                                        self.httpr = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr()
                                                                        self.httpr.parent = self
                                                                        self._children_name_map["httpr"] = "httpr"

                                                                        self.punt = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt()
                                                                        self.punt.parent = self
                                                                        self._children_name_map["punt"] = "punt"

                                                                        self.copy = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy()
                                                                        self.copy.parent = self
                                                                        self._children_name_map["copy"] = "copy"

                                                                        self.sfrag = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag()
                                                                        self.sfrag.parent = self
                                                                        self._children_name_map["sfrag"] = "sfrag"

                                                                        self.redirect = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect()
                                                                        self.redirect.parent = self
                                                                        self._children_name_map["redirect"] = "redirect"

                                                                        self.out_intf = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf()
                                                                        self.out_intf.parent = self
                                                                        self._children_name_map["out_intf"] = "out-intf"

                                                                        self.serv_func = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc()
                                                                        self.serv_func.parent = self
                                                                        self._children_name_map["serv_func"] = "serv-func"

                                                                        self.police = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police()
                                                                        self.police.parent = self
                                                                        self._children_name_map["police"] = "police"

                                                                        self.shape = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape()
                                                                        self.shape.parent = self
                                                                        self._children_name_map["shape"] = "shape"

                                                                        self.child_policy = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy()
                                                                        self.child_policy.parent = self
                                                                        self._children_name_map["child_policy"] = "child-policy"

                                                                        self.cac = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac()
                                                                        self.cac.parent = self
                                                                        self._children_name_map["cac"] = "cac"

                                                                        self.pfc = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc()
                                                                        self.pfc.parent = self
                                                                        self._children_name_map["pfc"] = "pfc"

                                                                        self.flow_parm = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm()
                                                                        self.flow_parm.parent = self
                                                                        self._children_name_map["flow_parm"] = "flow-parm"

                                                                        self.ipcbr = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr()
                                                                        self.ipcbr.parent = self
                                                                        self._children_name_map["ipcbr"] = "ipcbr"

                                                                        self.rtp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp()
                                                                        self.rtp.parent = self
                                                                        self._children_name_map["rtp"] = "rtp"

                                                                        self.rtp_mmr = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr()
                                                                        self.rtp_mmr.parent = self
                                                                        self._children_name_map["rtp_mmr"] = "rtp-mmr"

                                                                        self.rtp_j2k = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k()
                                                                        self.rtp_j2k.parent = self
                                                                        self._children_name_map["rtp_j2k"] = "rtp-j2k"

                                                                        self.rtp_voice = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice()
                                                                        self.rtp_voice.parent = self
                                                                        self._children_name_map["rtp_voice"] = "rtp-voice"

                                                                        self.mdi = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi()
                                                                        self.mdi.parent = self
                                                                        self._children_name_map["mdi"] = "mdi"

                                                                        self.mdi_rtp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp()
                                                                        self.mdi_rtp.parent = self
                                                                        self._children_name_map["mdi_rtp"] = "mdi-rtp"

                                                                        self.fmm = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm()
                                                                        self.fmm.parent = self
                                                                        self._children_name_map["fmm"] = "fmm"

                                                                        self.pbf = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf()
                                                                        self.pbf.parent = self
                                                                        self._children_name_map["pbf"] = "pbf"

                                                                        self.ipv4_nh = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh()
                                                                        self.ipv4_nh.parent = self
                                                                        self._children_name_map["ipv4_nh"] = "ipv4-nh"

                                                                        self.ipv6_nh = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh()
                                                                        self.ipv6_nh.parent = self
                                                                        self._children_name_map["ipv6_nh"] = "ipv6-nh"
                                                                        self._segment_path = lambda: "actp"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp, ['type', 'data_p'], name, value)


                                                                    class Mark(Entity):
                                                                        """
                                                                        mark
                                                                        
                                                                        .. attribute:: action_mark_info
                                                                        
                                                                        	action mark info
                                                                        	**type**\: list of  		 :py:class:`ActionMarkInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark, self).__init__()

                                                                            self.yang_name = "mark"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("action-mark-info", ("action_mark_info", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo))])
                                                                            self._leafs = OrderedDict()

                                                                            self.action_mark_info = YList(self)
                                                                            self._segment_path = lambda: "mark"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark, [], name, value)


                                                                        class ActionMarkInfo(Entity):
                                                                            """
                                                                            action mark info
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:  :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                            
                                                                            .. attribute:: mark_flags
                                                                            
                                                                            	mark flags
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo, self).__init__()

                                                                                self.yang_name = "action-mark-info"
                                                                                self.yang_parent_name = "mark"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MarkTypeEn', '')])),
                                                                                    ('mark_flags', (YLeaf(YType.uint32, 'mark-flags'), ['int'])),
                                                                                    ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                ])
                                                                                self.type = None
                                                                                self.mark_flags = None
                                                                                self.value = None
                                                                                self._segment_path = lambda: "action-mark-info"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo, ['type', 'mark_flags', 'value'], name, value)


                                                                    class Mark2(Entity):
                                                                        """
                                                                        mark2
                                                                        
                                                                        .. attribute:: action_mark2_info
                                                                        
                                                                        	action mark2 info
                                                                        	**type**\: list of  		 :py:class:`ActionMark2Info <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2, self).__init__()

                                                                            self.yang_name = "mark2"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("action-mark2-info", ("action_mark2_info", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info))])
                                                                            self._leafs = OrderedDict()

                                                                            self.action_mark2_info = YList(self)
                                                                            self._segment_path = lambda: "mark2"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2, [], name, value)


                                                                        class ActionMark2Info(Entity):
                                                                            """
                                                                            action mark2 info
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: value_overflow
                                                                            
                                                                            	value overflow
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: mark_flags
                                                                            
                                                                            	mark flags
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info, self).__init__()

                                                                                self.yang_name = "action-mark2-info"
                                                                                self.yang_parent_name = "mark2"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('value_overflow', (YLeaf(YType.uint16, 'value-overflow'), ['int'])),
                                                                                    ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                    ('mark_flags', (YLeaf(YType.uint8, 'mark-flags'), ['int'])),
                                                                                ])
                                                                                self.value = None
                                                                                self.value_overflow = None
                                                                                self.type = None
                                                                                self.mark_flags = None
                                                                                self._segment_path = lambda: "action-mark2-info"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info, ['value', 'value_overflow', 'type', 'mark_flags'], name, value)


                                                                    class Wred(Entity):
                                                                        """
                                                                        wred
                                                                        
                                                                        .. attribute:: action_wred_info
                                                                        
                                                                        	action wred info
                                                                        	**type**\: list of  		 :py:class:`ActionWredInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred, self).__init__()

                                                                            self.yang_name = "wred"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("action-wred-info", ("action_wred_info", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo))])
                                                                            self._leafs = OrderedDict()

                                                                            self.action_wred_info = YList(self)
                                                                            self._segment_path = lambda: "wred"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred, [], name, value)


                                                                        class ActionWredInfo(Entity):
                                                                            """
                                                                            action wred info
                                                                            
                                                                            .. attribute:: match_ranges
                                                                            
                                                                            	match ranges
                                                                            	**type**\:  :py:class:`MatchRanges <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges>`
                                                                            
                                                                            .. attribute:: min_threshold
                                                                            
                                                                            	min threshold
                                                                            	**type**\:  :py:class:`MinThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold>`
                                                                            
                                                                            .. attribute:: max_threshold
                                                                            
                                                                            	max threshold
                                                                            	**type**\:  :py:class:`MaxThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold>`
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	cos/prec/dscp/ based WRED
                                                                            	**type**\:  :py:class:`WredTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.WredTypeEn>`
                                                                            
                                                                            .. attribute:: wred_flags
                                                                            
                                                                            	wred flags
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: probability
                                                                            
                                                                            	probability
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo, self).__init__()

                                                                                self.yang_name = "action-wred-info"
                                                                                self.yang_parent_name = "wred"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("match-ranges", ("match_ranges", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges)), ("min-threshold", ("min_threshold", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold)), ("max-threshold", ("max_threshold", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'WredTypeEn', '')])),
                                                                                    ('wred_flags', (YLeaf(YType.uint32, 'wred-flags'), ['int'])),
                                                                                    ('probability', (YLeaf(YType.uint32, 'probability'), ['int'])),
                                                                                ])
                                                                                self.type = None
                                                                                self.wred_flags = None
                                                                                self.probability = None

                                                                                self.match_ranges = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges()
                                                                                self.match_ranges.parent = self
                                                                                self._children_name_map["match_ranges"] = "match-ranges"

                                                                                self.min_threshold = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold()
                                                                                self.min_threshold.parent = self
                                                                                self._children_name_map["min_threshold"] = "min-threshold"

                                                                                self.max_threshold = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold()
                                                                                self.max_threshold.parent = self
                                                                                self._children_name_map["max_threshold"] = "max-threshold"
                                                                                self._segment_path = lambda: "action-wred-info"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo, ['type', 'wred_flags', 'probability'], name, value)


                                                                            class MatchRanges(Entity):
                                                                                """
                                                                                match ranges
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges, self).__init__()

                                                                                    self.yang_name = "match-ranges"
                                                                                    self.yang_parent_name = "action-wred-info"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "match-ranges"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "match-ranges"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class MinThreshold(Entity):
                                                                                """
                                                                                min threshold
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold, self).__init__()

                                                                                    self.yang_name = "min-threshold"
                                                                                    self.yang_parent_name = "action-wred-info"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.unit = None
                                                                                    self._segment_path = lambda: "min-threshold"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold, ['value', 'unit'], name, value)


                                                                            class MaxThreshold(Entity):
                                                                                """
                                                                                max threshold
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold, self).__init__()

                                                                                    self.yang_name = "max-threshold"
                                                                                    self.yang_parent_name = "action-wred-info"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.unit = None
                                                                                    self._segment_path = lambda: "max-threshold"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold, ['value', 'unit'], name, value)


                                                                    class Encap(Entity):
                                                                        """
                                                                        encap
                                                                        
                                                                        .. attribute:: seq
                                                                        
                                                                        	seq
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap, self).__init__()

                                                                            self.yang_name = "encap"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('seq', (YLeaf(YType.uint8, 'seq'), ['int'])),
                                                                            ])
                                                                            self.seq = None
                                                                            self._segment_path = lambda: "encap"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap, ['seq'], name, value)


                                                                    class Prio(Entity):
                                                                        """
                                                                        prio
                                                                        
                                                                        .. attribute:: prio_lvl
                                                                        
                                                                        	prio lvl
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio, self).__init__()

                                                                            self.yang_name = "prio"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('prio_lvl', (YLeaf(YType.uint32, 'prio-lvl'), ['int'])),
                                                                            ])
                                                                            self.prio_lvl = None
                                                                            self._segment_path = lambda: "prio"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio, ['prio_lvl'], name, value)


                                                                    class Bwrem(Entity):
                                                                        """
                                                                        bwrem
                                                                        
                                                                        .. attribute:: bwrem
                                                                        
                                                                        	bwrem
                                                                        	**type**\:  :py:class:`Bwrem_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem_>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem, self).__init__()

                                                                            self.yang_name = "bwrem"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("bwrem", ("bwrem", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem_))])
                                                                            self._leafs = OrderedDict()

                                                                            self.bwrem = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem_()
                                                                            self.bwrem.parent = self
                                                                            self._children_name_map["bwrem"] = "bwrem"
                                                                            self._segment_path = lambda: "bwrem"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem, [], name, value)


                                                                        class Bwrem_(Entity):
                                                                            """
                                                                            bwrem
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem_, self).__init__()

                                                                                self.yang_name = "bwrem"
                                                                                self.yang_parent_name = "bwrem"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "bwrem"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem_, ['value', 'unit'], name, value)


                                                                    class MinBw(Entity):
                                                                        """
                                                                        min bw
                                                                        
                                                                        .. attribute:: bw
                                                                        
                                                                        	bw
                                                                        	**type**\:  :py:class:`Bw <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw, self).__init__()

                                                                            self.yang_name = "min-bw"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("bw", ("bw", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw))])
                                                                            self._leafs = OrderedDict()

                                                                            self.bw = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw()
                                                                            self.bw.parent = self
                                                                            self._children_name_map["bw"] = "bw"
                                                                            self._segment_path = lambda: "min-bw"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw, [], name, value)


                                                                        class Bw(Entity):
                                                                            """
                                                                            bw
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw, self).__init__()

                                                                                self.yang_name = "bw"
                                                                                self.yang_parent_name = "min-bw"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "bw"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw, ['value', 'unit'], name, value)


                                                                    class AuthenAaa(Entity):
                                                                        """
                                                                        authen aaa
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: authen_password
                                                                        
                                                                        	authen password
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa, self).__init__()

                                                                            self.yang_name = "authen-aaa"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                                ('authen_password', (YLeaf(YType.str, 'authen-password'), ['str'])),
                                                                            ])
                                                                            self.aaa_list_name = None
                                                                            self.authen_password = None
                                                                            self._segment_path = lambda: "authen-aaa"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa, ['aaa_list_name', 'authen_password'], name, value)


                                                                    class CollectId(Entity):
                                                                        """
                                                                        collect id
                                                                        
                                                                        .. attribute:: id
                                                                        
                                                                        	id
                                                                        	**type**\:  :py:class:`IdentifierEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.IdentifierEn>`
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId, self).__init__()

                                                                            self.yang_name = "collect-id"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('id', (YLeaf(YType.enumeration, 'id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'IdentifierEn', '')])),
                                                                                ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                            ])
                                                                            self.id = None
                                                                            self.aaa_list_name = None
                                                                            self._segment_path = lambda: "collect-id"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId, ['id', 'aaa_list_name'], name, value)


                                                                    class DecodeId(Entity):
                                                                        """
                                                                        decode id
                                                                        
                                                                        .. attribute:: id
                                                                        
                                                                        	id
                                                                        	**type**\:  :py:class:`DecodeIdentifierEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.DecodeIdentifierEn>`
                                                                        
                                                                        .. attribute:: format_name
                                                                        
                                                                        	format name
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId, self).__init__()

                                                                            self.yang_name = "decode-id"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('id', (YLeaf(YType.enumeration, 'id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'DecodeIdentifierEn', '')])),
                                                                                ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                            ])
                                                                            self.id = None
                                                                            self.format_name = None
                                                                            self._segment_path = lambda: "decode-id"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId, ['id', 'format_name'], name, value)


                                                                    class SetTimer(Entity):
                                                                        """
                                                                        set timer
                                                                        
                                                                        .. attribute:: timer_name
                                                                        
                                                                        	timer name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: duration
                                                                        
                                                                        	duration
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: absolute_time
                                                                        
                                                                        	absolute time
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer, self).__init__()

                                                                            self.yang_name = "set-timer"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('timer_name', (YLeaf(YType.str, 'timer-name'), ['str'])),
                                                                                ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                                                ('absolute_time', (YLeaf(YType.str, 'absolute-time'), ['str'])),
                                                                            ])
                                                                            self.timer_name = None
                                                                            self.duration = None
                                                                            self.absolute_time = None
                                                                            self._segment_path = lambda: "set-timer"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer, ['timer_name', 'duration', 'absolute_time'], name, value)


                                                                    class StopTimer(Entity):
                                                                        """
                                                                        stop timer
                                                                        
                                                                        .. attribute:: timer_name
                                                                        
                                                                        	timer name
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer, self).__init__()

                                                                            self.yang_name = "stop-timer"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('timer_name', (YLeaf(YType.str, 'timer-name'), ['str'])),
                                                                            ])
                                                                            self.timer_name = None
                                                                            self._segment_path = lambda: "stop-timer"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer, ['timer_name'], name, value)


                                                                    class AcctAaaList(Entity):
                                                                        """
                                                                        acct aaa list
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: secs
                                                                        
                                                                        	secs
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList, self).__init__()

                                                                            self.yang_name = "acct-aaa-list"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                                ('secs', (YLeaf(YType.uint32, 'secs'), ['int'])),
                                                                            ])
                                                                            self.aaa_list_name = None
                                                                            self.secs = None
                                                                            self._segment_path = lambda: "acct-aaa-list"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList, ['aaa_list_name', 'secs'], name, value)


                                                                    class QueryAncp(Entity):
                                                                        """
                                                                        query ancp
                                                                        
                                                                        .. attribute:: enable
                                                                        
                                                                        	enable
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp, self).__init__()

                                                                            self.yang_name = "query-ancp"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('enable', (YLeaf(YType.uint8, 'enable'), ['int'])),
                                                                            ])
                                                                            self.enable = None
                                                                            self._segment_path = lambda: "query-ancp"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp, ['enable'], name, value)


                                                                    class PrepaidCfg(Entity):
                                                                        """
                                                                        prepaid cfg
                                                                        
                                                                        .. attribute:: prepaid_config_profile_name
                                                                        
                                                                        	prepaid config profile name
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg, self).__init__()

                                                                            self.yang_name = "prepaid-cfg"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('prepaid_config_profile_name', (YLeaf(YType.str, 'prepaid-config-profile-name'), ['str'])),
                                                                            ])
                                                                            self.prepaid_config_profile_name = None
                                                                            self._segment_path = lambda: "prepaid-cfg"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg, ['prepaid_config_profile_name'], name, value)


                                                                    class TimeoutIdle(Entity):
                                                                        """
                                                                        timeout idle
                                                                        
                                                                        .. attribute:: secs
                                                                        
                                                                        	secs
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle, self).__init__()

                                                                            self.yang_name = "timeout-idle"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('secs', (YLeaf(YType.uint32, 'secs'), ['int'])),
                                                                            ])
                                                                            self.secs = None
                                                                            self._segment_path = lambda: "timeout-idle"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle, ['secs'], name, value)


                                                                    class ProxyAaa(Entity):
                                                                        """
                                                                        proxy aaa
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa, self).__init__()

                                                                            self.yang_name = "proxy-aaa"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                            ])
                                                                            self.aaa_list_name = None
                                                                            self._segment_path = lambda: "proxy-aaa"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa, ['aaa_list_name'], name, value)


                                                                    class ActTemplate(Entity):
                                                                        """
                                                                        act template
                                                                        
                                                                        .. attribute:: template_name
                                                                        
                                                                        	template name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: flags
                                                                        
                                                                        	flags
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate, self).__init__()

                                                                            self.yang_name = "act-template"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('template_name', (YLeaf(YType.str, 'template-name'), ['str'])),
                                                                                ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                                ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                            ])
                                                                            self.template_name = None
                                                                            self.aaa_list_name = None
                                                                            self.flags = None
                                                                            self._segment_path = lambda: "act-template"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate, ['template_name', 'aaa_list_name', 'flags'], name, value)


                                                                    class DeactTemplate(Entity):
                                                                        """
                                                                        deact template
                                                                        
                                                                        .. attribute:: template_name
                                                                        
                                                                        	template name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: flags
                                                                        
                                                                        	flags
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate, self).__init__()

                                                                            self.yang_name = "deact-template"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('template_name', (YLeaf(YType.str, 'template-name'), ['str'])),
                                                                                ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                                ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                            ])
                                                                            self.template_name = None
                                                                            self.aaa_list_name = None
                                                                            self.flags = None
                                                                            self._segment_path = lambda: "deact-template"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate, ['template_name', 'aaa_list_name', 'flags'], name, value)


                                                                    class Qlimit(Entity):
                                                                        """
                                                                        qlimit
                                                                        
                                                                        .. attribute:: action_qlimit_info_array
                                                                        
                                                                        	action qlimit info array
                                                                        	**type**\: list of  		 :py:class:`ActionQlimitInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit, self).__init__()

                                                                            self.yang_name = "qlimit"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("action-qlimit-info-array", ("action_qlimit_info_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.action_qlimit_info_array = YList(self)
                                                                            self._segment_path = lambda: "qlimit"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit, [], name, value)


                                                                        class ActionQlimitInfoArray(Entity):
                                                                            """
                                                                            action qlimit info array
                                                                            
                                                                            .. attribute:: qlim
                                                                            
                                                                            	qlim
                                                                            	**type**\:  :py:class:`Qlim <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim>`
                                                                            
                                                                            .. attribute:: atmclp_qlim
                                                                            
                                                                            	atmclp qlim
                                                                            	**type**\:  :py:class:`AtmclpQlim <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim>`
                                                                            
                                                                            .. attribute:: match_values
                                                                            
                                                                            	match values
                                                                            	**type**\:  :py:class:`MatchValues <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues>`
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:  :py:class:`QlimitTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.QlimitTypeEn>`
                                                                            
                                                                            .. attribute:: qlimit_flags
                                                                            
                                                                            	qlimit flags
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray, self).__init__()

                                                                                self.yang_name = "action-qlimit-info-array"
                                                                                self.yang_parent_name = "qlimit"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("qlim", ("qlim", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim)), ("atmclp-qlim", ("atmclp_qlim", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim)), ("match-values", ("match_values", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'QlimitTypeEn', '')])),
                                                                                    ('qlimit_flags', (YLeaf(YType.uint32, 'qlimit-flags'), ['int'])),
                                                                                ])
                                                                                self.type = None
                                                                                self.qlimit_flags = None

                                                                                self.qlim = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim()
                                                                                self.qlim.parent = self
                                                                                self._children_name_map["qlim"] = "qlim"

                                                                                self.atmclp_qlim = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim()
                                                                                self.atmclp_qlim.parent = self
                                                                                self._children_name_map["atmclp_qlim"] = "atmclp-qlim"

                                                                                self.match_values = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues()
                                                                                self.match_values.parent = self
                                                                                self._children_name_map["match_values"] = "match-values"
                                                                                self._segment_path = lambda: "action-qlimit-info-array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray, ['type', 'qlimit_flags'], name, value)


                                                                            class Qlim(Entity):
                                                                                """
                                                                                qlim
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim, self).__init__()

                                                                                    self.yang_name = "qlim"
                                                                                    self.yang_parent_name = "action-qlimit-info-array"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.unit = None
                                                                                    self._segment_path = lambda: "qlim"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim, ['value', 'unit'], name, value)


                                                                            class AtmclpQlim(Entity):
                                                                                """
                                                                                atmclp qlim
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim, self).__init__()

                                                                                    self.yang_name = "atmclp-qlim"
                                                                                    self.yang_parent_name = "action-qlimit-info-array"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.unit = None
                                                                                    self._segment_path = lambda: "atmclp-qlim"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim, ['value', 'unit'], name, value)


                                                                            class MatchValues(Entity):
                                                                                """
                                                                                match values
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues, self).__init__()

                                                                                    self.yang_name = "match-values"
                                                                                    self.yang_parent_name = "action-qlimit-info-array"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "match-values"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "match-values"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray, ['min', 'max'], name, value)


                                                                    class AccountingEventAaa(Entity):
                                                                        """
                                                                        accounting event aaa
                                                                        
                                                                        .. attribute:: action
                                                                        
                                                                        	action
                                                                        	**type**\:  :py:class:`AcctEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.AcctEn>`
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa, self).__init__()

                                                                            self.yang_name = "accounting-event-aaa"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('action', (YLeaf(YType.enumeration, 'action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'AcctEn', '')])),
                                                                                ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                            ])
                                                                            self.action = None
                                                                            self.aaa_list_name = None
                                                                            self._segment_path = lambda: "accounting-event-aaa"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa, ['action', 'aaa_list_name'], name, value)


                                                                    class AuthorizeId(Entity):
                                                                        """
                                                                        authorize id
                                                                        
                                                                        .. attribute:: id
                                                                        
                                                                        	id
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: format_name
                                                                        
                                                                        	format name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: password
                                                                        
                                                                        	password
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId, self).__init__()

                                                                            self.yang_name = "authorize-id"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('id', (YLeaf(YType.uint8, 'id'), ['int'])),
                                                                                ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                                ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                ('password', (YLeaf(YType.str, 'password'), ['str'])),
                                                                            ])
                                                                            self.id = None
                                                                            self.aaa_list_name = None
                                                                            self.format_name = None
                                                                            self.password = None
                                                                            self._segment_path = lambda: "authorize-id"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId, ['id', 'aaa_list_name', 'format_name', 'password'], name, value)


                                                                    class AfmReact(Entity):
                                                                        """
                                                                        afm react
                                                                        
                                                                        .. attribute:: action_afmon_react_info
                                                                        
                                                                        	action afmon react info
                                                                        	**type**\: list of  		 :py:class:`ActionAfmonReactInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact, self).__init__()

                                                                            self.yang_name = "afm-react"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("action-afmon-react-info", ("action_afmon_react_info", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo))])
                                                                            self._leafs = OrderedDict()

                                                                            self.action_afmon_react_info = YList(self)
                                                                            self._segment_path = lambda: "afm-react"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact, [], name, value)


                                                                        class ActionAfmonReactInfo(Entity):
                                                                            """
                                                                            action afmon react info
                                                                            
                                                                            .. attribute:: oper_id
                                                                            
                                                                            	React Operation ID
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: description
                                                                            
                                                                            	Describing the oper
                                                                            	**type**\: str
                                                                            
                                                                            .. attribute:: trig_num_intvls
                                                                            
                                                                            	Averaged over N intvls
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: clone_ifh
                                                                            
                                                                            	Clone interface handle
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: notif_actns
                                                                            
                                                                            	Bitmap of actions on alert
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: criterion
                                                                            
                                                                            	React Criterion
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: trig_type
                                                                            
                                                                            	Immediate or averaged thresh trigger
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: trig_relop
                                                                            
                                                                            	Trigger LT\|LE\|GT\|GE\|Range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: trig_level_1
                                                                            
                                                                            	Trigger threshold 1/lower
                                                                            	**type**\: str
                                                                            
                                                                            .. attribute:: trig_level_2
                                                                            
                                                                            	Trigger upper threshold for range
                                                                            	**type**\: str
                                                                            
                                                                            .. attribute:: alm_grp_thresh
                                                                            
                                                                            	Num/percent in grp
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            	**units**\: percentage
                                                                            
                                                                            .. attribute:: alm_type
                                                                            
                                                                            	Discrete \| grouped alarm
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: alm_severity
                                                                            
                                                                            	Major\|Minor\|... alarm
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo, self).__init__()

                                                                                self.yang_name = "action-afmon-react-info"
                                                                                self.yang_parent_name = "afm-react"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('oper_id', (YLeaf(YType.uint32, 'oper-id'), ['int'])),
                                                                                    ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                    ('trig_num_intvls', (YLeaf(YType.uint32, 'trig-num-intvls'), ['int'])),
                                                                                    ('clone_ifh', (YLeaf(YType.uint32, 'clone-ifh'), ['int'])),
                                                                                    ('notif_actns', (YLeaf(YType.uint8, 'notif-actns'), ['int'])),
                                                                                    ('criterion', (YLeaf(YType.uint8, 'criterion'), ['int'])),
                                                                                    ('trig_type', (YLeaf(YType.uint8, 'trig-type'), ['int'])),
                                                                                    ('trig_relop', (YLeaf(YType.uint8, 'trig-relop'), ['int'])),
                                                                                    ('trig_level_1', (YLeaf(YType.str, 'trig-level-1'), ['str'])),
                                                                                    ('trig_level_2', (YLeaf(YType.str, 'trig-level-2'), ['str'])),
                                                                                    ('alm_grp_thresh', (YLeaf(YType.uint16, 'alm-grp-thresh'), ['int'])),
                                                                                    ('alm_type', (YLeaf(YType.uint8, 'alm-type'), ['int'])),
                                                                                    ('alm_severity', (YLeaf(YType.uint8, 'alm-severity'), ['int'])),
                                                                                ])
                                                                                self.oper_id = None
                                                                                self.description = None
                                                                                self.trig_num_intvls = None
                                                                                self.clone_ifh = None
                                                                                self.notif_actns = None
                                                                                self.criterion = None
                                                                                self.trig_type = None
                                                                                self.trig_relop = None
                                                                                self.trig_level_1 = None
                                                                                self.trig_level_2 = None
                                                                                self.alm_grp_thresh = None
                                                                                self.alm_type = None
                                                                                self.alm_severity = None
                                                                                self._segment_path = lambda: "action-afmon-react-info"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo, ['oper_id', 'description', 'trig_num_intvls', 'clone_ifh', 'notif_actns', 'criterion', 'trig_type', 'trig_relop', 'trig_level_1', 'trig_level_2', 'alm_grp_thresh', 'alm_type', 'alm_severity'], name, value)


                                                                    class Httpr(Entity):
                                                                        """
                                                                        httpr
                                                                        
                                                                        .. attribute:: redirect_url
                                                                        
                                                                        	redirect url
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr, self).__init__()

                                                                            self.yang_name = "httpr"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('redirect_url', (YLeaf(YType.str, 'redirect-url'), ['str'])),
                                                                            ])
                                                                            self.redirect_url = None
                                                                            self._segment_path = lambda: "httpr"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr, ['redirect_url'], name, value)


                                                                    class Punt(Entity):
                                                                        """
                                                                        punt
                                                                        
                                                                        .. attribute:: sn_type
                                                                        
                                                                        	service node ID type
                                                                        	**type**\:  :py:class:`DpssSnidTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.DpssSnidTypeEn>`
                                                                        
                                                                        .. attribute:: sn_index
                                                                        
                                                                        	service node index
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: sn_name
                                                                        
                                                                        	service node name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: app_id
                                                                        
                                                                        	application ID
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: local_id
                                                                        
                                                                        	local ID
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: vsnode_type
                                                                        
                                                                        	vservice node type
                                                                        	**type**\:  :py:class:`VsvcServiceTypeT <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.VsvcServiceTypeT>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt, self).__init__()

                                                                            self.yang_name = "punt"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('sn_type', (YLeaf(YType.enumeration, 'sn-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'DpssSnidTypeEn', '')])),
                                                                                ('sn_index', (YLeaf(YType.uint32, 'sn-index'), ['int'])),
                                                                                ('sn_name', (YLeaf(YType.str, 'sn-name'), ['str'])),
                                                                                ('app_id', (YLeaf(YType.uint32, 'app-id'), ['int'])),
                                                                                ('local_id', (YLeaf(YType.uint32, 'local-id'), ['int'])),
                                                                                ('vsnode_type', (YLeaf(YType.enumeration, 'vsnode-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'VsvcServiceTypeT', '')])),
                                                                            ])
                                                                            self.sn_type = None
                                                                            self.sn_index = None
                                                                            self.sn_name = None
                                                                            self.app_id = None
                                                                            self.local_id = None
                                                                            self.vsnode_type = None
                                                                            self._segment_path = lambda: "punt"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt, ['sn_type', 'sn_index', 'sn_name', 'app_id', 'local_id', 'vsnode_type'], name, value)


                                                                    class Copy(Entity):
                                                                        """
                                                                        copy
                                                                        
                                                                        .. attribute:: num_byte
                                                                        
                                                                        	number of bytes
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: sn_type
                                                                        
                                                                        	service node ID type
                                                                        	**type**\:  :py:class:`DpssSnidTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.DpssSnidTypeEn>`
                                                                        
                                                                        .. attribute:: sn_index
                                                                        
                                                                        	service node index
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: sn_name
                                                                        
                                                                        	service node url
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: app_id
                                                                        
                                                                        	application ID
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: local_id
                                                                        
                                                                        	local ID
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: vsnode_type
                                                                        
                                                                        	vservice node type
                                                                        	**type**\:  :py:class:`VsvcServiceTypeT <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.VsvcServiceTypeT>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy, self).__init__()

                                                                            self.yang_name = "copy"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('num_byte', (YLeaf(YType.uint32, 'num-byte'), ['int'])),
                                                                                ('sn_type', (YLeaf(YType.enumeration, 'sn-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'DpssSnidTypeEn', '')])),
                                                                                ('sn_index', (YLeaf(YType.uint32, 'sn-index'), ['int'])),
                                                                                ('sn_name', (YLeaf(YType.str, 'sn-name'), ['str'])),
                                                                                ('app_id', (YLeaf(YType.uint32, 'app-id'), ['int'])),
                                                                                ('local_id', (YLeaf(YType.uint32, 'local-id'), ['int'])),
                                                                                ('vsnode_type', (YLeaf(YType.enumeration, 'vsnode-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'VsvcServiceTypeT', '')])),
                                                                            ])
                                                                            self.num_byte = None
                                                                            self.sn_type = None
                                                                            self.sn_index = None
                                                                            self.sn_name = None
                                                                            self.app_id = None
                                                                            self.local_id = None
                                                                            self.vsnode_type = None
                                                                            self._segment_path = lambda: "copy"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy, ['num_byte', 'sn_type', 'sn_index', 'sn_name', 'app_id', 'local_id', 'vsnode_type'], name, value)


                                                                    class Sfrag(Entity):
                                                                        """
                                                                        sfrag
                                                                        
                                                                        .. attribute:: name
                                                                        
                                                                        	Service Fragment Name
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag, self).__init__()

                                                                            self.yang_name = "sfrag"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                            ])
                                                                            self.name = None
                                                                            self._segment_path = lambda: "sfrag"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag, ['name'], name, value)


                                                                    class Redirect(Entity):
                                                                        """
                                                                        redirect
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: type
                                                                        
                                                                        	type
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect, self).__init__()

                                                                            self.yang_name = "redirect"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                            ])
                                                                            self.value = None
                                                                            self.type = None
                                                                            self._segment_path = lambda: "redirect"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect, ['value', 'type'], name, value)


                                                                    class OutIntf(Entity):
                                                                        """
                                                                        out intf
                                                                        
                                                                        .. attribute:: out_ifname
                                                                        
                                                                        	output interface name
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf, self).__init__()

                                                                            self.yang_name = "out-intf"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('out_ifname', (YLeaf(YType.str, 'out-ifname'), ['str'])),
                                                                            ])
                                                                            self.out_ifname = None
                                                                            self._segment_path = lambda: "out-intf"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf, ['out_ifname'], name, value)


                                                                    class ServFunc(Entity):
                                                                        """
                                                                        serv func
                                                                        
                                                                        .. attribute:: path_id
                                                                        
                                                                        	service path id
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: service_index
                                                                        
                                                                        	service path index
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: meta_name
                                                                        
                                                                        	metadata name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: vs_index
                                                                        
                                                                        	vservice index
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc, self).__init__()

                                                                            self.yang_name = "serv-func"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('path_id', (YLeaf(YType.uint32, 'path-id'), ['int'])),
                                                                                ('service_index', (YLeaf(YType.uint8, 'service-index'), ['int'])),
                                                                                ('meta_name', (YLeaf(YType.str, 'meta-name'), ['str'])),
                                                                                ('vs_index', (YLeaf(YType.uint32, 'vs-index'), ['int'])),
                                                                            ])
                                                                            self.path_id = None
                                                                            self.service_index = None
                                                                            self.meta_name = None
                                                                            self.vs_index = None
                                                                            self._segment_path = lambda: "serv-func"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc, ['path_id', 'service_index', 'meta_name', 'vs_index'], name, value)


                                                                    class Police(Entity):
                                                                        """
                                                                        police
                                                                        
                                                                        .. attribute:: rate
                                                                        
                                                                        	rate
                                                                        	**type**\:  :py:class:`Rate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate>`
                                                                        
                                                                        .. attribute:: burst
                                                                        
                                                                        	burst
                                                                        	**type**\:  :py:class:`Burst <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst>`
                                                                        
                                                                        .. attribute:: peak_rate
                                                                        
                                                                        	peak rate
                                                                        	**type**\:  :py:class:`PeakRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate>`
                                                                        
                                                                        .. attribute:: peak_burst
                                                                        
                                                                        	peak burst
                                                                        	**type**\:  :py:class:`PeakBurst <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst>`
                                                                        
                                                                        .. attribute:: cdvt
                                                                        
                                                                        	cdvt
                                                                        	**type**\:  :py:class:`Cdvt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt>`
                                                                        
                                                                        .. attribute:: conform_actns
                                                                        
                                                                        	conform actns
                                                                        	**type**\:  :py:class:`ConformActns <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns>`
                                                                        
                                                                        .. attribute:: exceed_actns
                                                                        
                                                                        	exceed actns
                                                                        	**type**\:  :py:class:`ExceedActns <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns>`
                                                                        
                                                                        .. attribute:: violate_actns
                                                                        
                                                                        	violate actns
                                                                        	**type**\:  :py:class:`ViolateActns <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns>`
                                                                        
                                                                        .. attribute:: confclass_encode
                                                                        
                                                                        	confclass encode
                                                                        	**type**\:  :py:class:`ConfclassEncode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode>`
                                                                        
                                                                        .. attribute:: confclass_p
                                                                        
                                                                        	confclass p
                                                                        	**type**\:  :py:class:`ConfclassP <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP>`
                                                                        
                                                                        .. attribute:: excdclass_encode
                                                                        
                                                                        	excdclass encode
                                                                        	**type**\:  :py:class:`ExcdclassEncode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode>`
                                                                        
                                                                        .. attribute:: excdclass_p
                                                                        
                                                                        	excdclass p
                                                                        	**type**\:  :py:class:`ExcdclassP <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP>`
                                                                        
                                                                        .. attribute:: flags
                                                                        
                                                                        	flags
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: police_flags
                                                                        
                                                                        	police flags
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: sbuck_name
                                                                        
                                                                        	sbuck name
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..65
                                                                        
                                                                        .. attribute:: sbuck_type
                                                                        
                                                                        	sbuck type
                                                                        	**type**\:  :py:class:`SharedBucketType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.SharedBucketType>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police, self).__init__()

                                                                            self.yang_name = "police"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("rate", ("rate", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate)), ("burst", ("burst", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst)), ("peak-rate", ("peak_rate", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate)), ("peak-burst", ("peak_burst", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst)), ("cdvt", ("cdvt", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt)), ("conform-actns", ("conform_actns", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns)), ("exceed-actns", ("exceed_actns", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns)), ("violate-actns", ("violate_actns", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns)), ("confclass-encode", ("confclass_encode", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode)), ("confclass-p", ("confclass_p", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP)), ("excdclass-encode", ("excdclass_encode", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode)), ("excdclass-p", ("excdclass_p", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP))])
                                                                            self._leafs = OrderedDict([
                                                                                ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                ('police_flags', (YLeaf(YType.uint32, 'police-flags'), ['int'])),
                                                                                ('sbuck_name', (YLeaf(YType.str, 'sbuck-name'), ['str'])),
                                                                                ('sbuck_type', (YLeaf(YType.enumeration, 'sbuck-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'SharedBucketType', '')])),
                                                                            ])
                                                                            self.flags = None
                                                                            self.police_flags = None
                                                                            self.sbuck_name = None
                                                                            self.sbuck_type = None

                                                                            self.rate = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate()
                                                                            self.rate.parent = self
                                                                            self._children_name_map["rate"] = "rate"

                                                                            self.burst = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst()
                                                                            self.burst.parent = self
                                                                            self._children_name_map["burst"] = "burst"

                                                                            self.peak_rate = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate()
                                                                            self.peak_rate.parent = self
                                                                            self._children_name_map["peak_rate"] = "peak-rate"

                                                                            self.peak_burst = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst()
                                                                            self.peak_burst.parent = self
                                                                            self._children_name_map["peak_burst"] = "peak-burst"

                                                                            self.cdvt = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt()
                                                                            self.cdvt.parent = self
                                                                            self._children_name_map["cdvt"] = "cdvt"

                                                                            self.conform_actns = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns()
                                                                            self.conform_actns.parent = self
                                                                            self._children_name_map["conform_actns"] = "conform-actns"

                                                                            self.exceed_actns = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns()
                                                                            self.exceed_actns.parent = self
                                                                            self._children_name_map["exceed_actns"] = "exceed-actns"

                                                                            self.violate_actns = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns()
                                                                            self.violate_actns.parent = self
                                                                            self._children_name_map["violate_actns"] = "violate-actns"

                                                                            self.confclass_encode = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode()
                                                                            self.confclass_encode.parent = self
                                                                            self._children_name_map["confclass_encode"] = "confclass-encode"

                                                                            self.confclass_p = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP()
                                                                            self.confclass_p.parent = self
                                                                            self._children_name_map["confclass_p"] = "confclass-p"

                                                                            self.excdclass_encode = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode()
                                                                            self.excdclass_encode.parent = self
                                                                            self._children_name_map["excdclass_encode"] = "excdclass-encode"

                                                                            self.excdclass_p = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP()
                                                                            self.excdclass_p.parent = self
                                                                            self._children_name_map["excdclass_p"] = "excdclass-p"
                                                                            self._segment_path = lambda: "police"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police, ['flags', 'police_flags', 'sbuck_name', 'sbuck_type'], name, value)


                                                                        class Rate(Entity):
                                                                            """
                                                                            rate
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate, self).__init__()

                                                                                self.yang_name = "rate"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate, ['value', 'unit'], name, value)


                                                                        class Burst(Entity):
                                                                            """
                                                                            burst
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst, self).__init__()

                                                                                self.yang_name = "burst"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "burst"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst, ['value', 'unit'], name, value)


                                                                        class PeakRate(Entity):
                                                                            """
                                                                            peak rate
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate, self).__init__()

                                                                                self.yang_name = "peak-rate"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "peak-rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate, ['value', 'unit'], name, value)


                                                                        class PeakBurst(Entity):
                                                                            """
                                                                            peak burst
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst, self).__init__()

                                                                                self.yang_name = "peak-burst"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "peak-burst"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst, ['value', 'unit'], name, value)


                                                                        class Cdvt(Entity):
                                                                            """
                                                                            cdvt
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt, self).__init__()

                                                                                self.yang_name = "cdvt"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "cdvt"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt, ['value', 'unit'], name, value)


                                                                        class ConformActns(Entity):
                                                                            """
                                                                            conform actns
                                                                            
                                                                            .. attribute:: police_action_array
                                                                            
                                                                            	police action array
                                                                            	**type**\: list of  		 :py:class:`PoliceActionArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns, self).__init__()

                                                                                self.yang_name = "conform-actns"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("police-action-array", ("police_action_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.police_action_array = YList(self)
                                                                                self._segment_path = lambda: "conform-actns"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns, [], name, value)


                                                                            class PoliceActionArray(Entity):
                                                                                """
                                                                                police action array
                                                                                
                                                                                .. attribute:: mark
                                                                                
                                                                                	mark
                                                                                	**type**\:  :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark>`
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:  :py:class:`PoliceActionTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PoliceActionTypeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray, self).__init__()

                                                                                    self.yang_name = "police-action-array"
                                                                                    self.yang_parent_name = "conform-actns"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("mark", ("mark", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PoliceActionTypeEn', '')])),
                                                                                    ])
                                                                                    self.type = None

                                                                                    self.mark = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark()
                                                                                    self.mark.parent = self
                                                                                    self._children_name_map["mark"] = "mark"
                                                                                    self._segment_path = lambda: "police-action-array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray, ['type'], name, value)


                                                                                class Mark(Entity):
                                                                                    """
                                                                                    mark
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	type
                                                                                    	**type**\:  :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                                    
                                                                                    .. attribute:: mark_flags
                                                                                    
                                                                                    	mark flags
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark, self).__init__()

                                                                                        self.yang_name = "mark"
                                                                                        self.yang_parent_name = "police-action-array"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MarkTypeEn', '')])),
                                                                                            ('mark_flags', (YLeaf(YType.uint32, 'mark-flags'), ['int'])),
                                                                                            ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                        ])
                                                                                        self.type = None
                                                                                        self.mark_flags = None
                                                                                        self.value = None
                                                                                        self._segment_path = lambda: "mark"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark, ['type', 'mark_flags', 'value'], name, value)


                                                                        class ExceedActns(Entity):
                                                                            """
                                                                            exceed actns
                                                                            
                                                                            .. attribute:: police_action_array
                                                                            
                                                                            	police action array
                                                                            	**type**\: list of  		 :py:class:`PoliceActionArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns, self).__init__()

                                                                                self.yang_name = "exceed-actns"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("police-action-array", ("police_action_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.police_action_array = YList(self)
                                                                                self._segment_path = lambda: "exceed-actns"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns, [], name, value)


                                                                            class PoliceActionArray(Entity):
                                                                                """
                                                                                police action array
                                                                                
                                                                                .. attribute:: mark
                                                                                
                                                                                	mark
                                                                                	**type**\:  :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark>`
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:  :py:class:`PoliceActionTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PoliceActionTypeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray, self).__init__()

                                                                                    self.yang_name = "police-action-array"
                                                                                    self.yang_parent_name = "exceed-actns"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("mark", ("mark", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PoliceActionTypeEn', '')])),
                                                                                    ])
                                                                                    self.type = None

                                                                                    self.mark = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark()
                                                                                    self.mark.parent = self
                                                                                    self._children_name_map["mark"] = "mark"
                                                                                    self._segment_path = lambda: "police-action-array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray, ['type'], name, value)


                                                                                class Mark(Entity):
                                                                                    """
                                                                                    mark
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	type
                                                                                    	**type**\:  :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                                    
                                                                                    .. attribute:: mark_flags
                                                                                    
                                                                                    	mark flags
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark, self).__init__()

                                                                                        self.yang_name = "mark"
                                                                                        self.yang_parent_name = "police-action-array"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MarkTypeEn', '')])),
                                                                                            ('mark_flags', (YLeaf(YType.uint32, 'mark-flags'), ['int'])),
                                                                                            ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                        ])
                                                                                        self.type = None
                                                                                        self.mark_flags = None
                                                                                        self.value = None
                                                                                        self._segment_path = lambda: "mark"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark, ['type', 'mark_flags', 'value'], name, value)


                                                                        class ViolateActns(Entity):
                                                                            """
                                                                            violate actns
                                                                            
                                                                            .. attribute:: police_action_array
                                                                            
                                                                            	police action array
                                                                            	**type**\: list of  		 :py:class:`PoliceActionArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns, self).__init__()

                                                                                self.yang_name = "violate-actns"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("police-action-array", ("police_action_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.police_action_array = YList(self)
                                                                                self._segment_path = lambda: "violate-actns"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns, [], name, value)


                                                                            class PoliceActionArray(Entity):
                                                                                """
                                                                                police action array
                                                                                
                                                                                .. attribute:: mark
                                                                                
                                                                                	mark
                                                                                	**type**\:  :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark>`
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:  :py:class:`PoliceActionTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PoliceActionTypeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray, self).__init__()

                                                                                    self.yang_name = "police-action-array"
                                                                                    self.yang_parent_name = "violate-actns"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("mark", ("mark", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PoliceActionTypeEn', '')])),
                                                                                    ])
                                                                                    self.type = None

                                                                                    self.mark = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark()
                                                                                    self.mark.parent = self
                                                                                    self._children_name_map["mark"] = "mark"
                                                                                    self._segment_path = lambda: "police-action-array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray, ['type'], name, value)


                                                                                class Mark(Entity):
                                                                                    """
                                                                                    mark
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	type
                                                                                    	**type**\:  :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                                    
                                                                                    .. attribute:: mark_flags
                                                                                    
                                                                                    	mark flags
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark, self).__init__()

                                                                                        self.yang_name = "mark"
                                                                                        self.yang_parent_name = "police-action-array"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MarkTypeEn', '')])),
                                                                                            ('mark_flags', (YLeaf(YType.uint32, 'mark-flags'), ['int'])),
                                                                                            ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                        ])
                                                                                        self.type = None
                                                                                        self.mark_flags = None
                                                                                        self.value = None
                                                                                        self._segment_path = lambda: "mark"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark, ['type', 'mark_flags', 'value'], name, value)


                                                                        class ConfclassEncode(Entity):
                                                                            """
                                                                            confclass encode
                                                                            
                                                                            .. attribute:: inline_cmap
                                                                            
                                                                            	inline cmap
                                                                            	**type**\:  :py:class:`InlineCmap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap>`
                                                                            
                                                                            .. attribute:: enc
                                                                            
                                                                            	enc
                                                                            	**type**\:  :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                            
                                                                            .. attribute:: class_name
                                                                            
                                                                            	class name
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..65
                                                                            
                                                                            .. attribute:: hd
                                                                            
                                                                            	hd
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: idx
                                                                            
                                                                            	idx
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode, self).__init__()

                                                                                self.yang_name = "confclass-encode"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("inline-cmap", ("inline_cmap", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('enc', (YLeaf(YType.enumeration, 'enc'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyObjEncEn', '')])),
                                                                                    ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                                                    ('hd', (YLeaf(YType.uint64, 'hd'), ['int'])),
                                                                                    ('idx', (YLeaf(YType.uint8, 'idx'), ['int'])),
                                                                                ])
                                                                                self.enc = None
                                                                                self.class_name = None
                                                                                self.hd = None
                                                                                self.idx = None

                                                                                self.inline_cmap = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap()
                                                                                self.inline_cmap.parent = self
                                                                                self._children_name_map["inline_cmap"] = "inline-cmap"
                                                                                self._segment_path = lambda: "confclass-encode"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode, ['enc', 'class_name', 'hd', 'idx'], name, value)


                                                                            class InlineCmap(Entity):
                                                                                """
                                                                                inline cmap
                                                                                
                                                                                .. attribute:: match_infop
                                                                                
                                                                                	Pointer to the first Match info
                                                                                	**type**\:  :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop>`
                                                                                
                                                                                .. attribute:: mode
                                                                                
                                                                                	Inline Class\-Map Mode Match any/all
                                                                                	**type**\:  :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                                
                                                                                .. attribute:: flags
                                                                                
                                                                                	Inline Class\-Map flags
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: match_count
                                                                                
                                                                                	Number of Match infos
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap, self).__init__()

                                                                                    self.yang_name = "inline-cmap"
                                                                                    self.yang_parent_name = "confclass-encode"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("match-infop", ("match_infop", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapModeEn', '')])),
                                                                                        ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                        ('match_count', (YLeaf(YType.uint32, 'match-count'), ['int'])),
                                                                                    ])
                                                                                    self.mode = None
                                                                                    self.flags = None
                                                                                    self.match_count = None

                                                                                    self.match_infop = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop()
                                                                                    self.match_infop.parent = self
                                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                                    self._segment_path = lambda: "inline-cmap"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap, ['mode', 'flags', 'match_count'], name, value)


                                                                                class MatchInfop(Entity):
                                                                                    """
                                                                                    Pointer to the first Match info
                                                                                    
                                                                                    .. attribute:: class_match_info_st
                                                                                    
                                                                                    	class match info st
                                                                                    	**type**\: list of  		 :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop, self).__init__()

                                                                                        self.yang_name = "match-infop"
                                                                                        self.yang_parent_name = "inline-cmap"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("class-match-info-st", ("class_match_info_st", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.class_match_info_st = YList(self)
                                                                                        self._segment_path = lambda: "match-infop"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop, [], name, value)


                                                                                    class ClassMatchInfoSt(Entity):
                                                                                        """
                                                                                        class match info st
                                                                                        
                                                                                        .. attribute:: match_data
                                                                                        
                                                                                        	Match criteria
                                                                                        	**type**\:  :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                        
                                                                                        .. attribute:: flags
                                                                                        
                                                                                        	Flags
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                            self.yang_name = "class-match-info-st"
                                                                                            self.yang_parent_name = "match-infop"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("match-data", ("match_data", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData))])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                            ])
                                                                                            self.flags = None

                                                                                            self.match_data = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                            self.match_data.parent = self
                                                                                            self._children_name_map["match_data"] = "match-data"
                                                                                            self._segment_path = lambda: "class-match-info-st"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                        class MatchData(Entity):
                                                                                            """
                                                                                            Match criteria
                                                                                            
                                                                                            .. attribute:: ipv4_dscp
                                                                                            
                                                                                            	IPv4 DSCP
                                                                                            	**type**\:  :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv6_dscp
                                                                                            
                                                                                            	IPv6 DSCP
                                                                                            	**type**\:  :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                            
                                                                                            .. attribute:: dscp
                                                                                            
                                                                                            	Match DSCP range array
                                                                                            	**type**\:  :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv4_prec
                                                                                            
                                                                                            	IPv4 Precedence
                                                                                            	**type**\:  :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                            
                                                                                            .. attribute:: ipv6_prec
                                                                                            
                                                                                            	IPv6 Precedence
                                                                                            	**type**\:  :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                            
                                                                                            .. attribute:: prec
                                                                                            
                                                                                            	Match Precedence array
                                                                                            	**type**\:  :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                            
                                                                                            .. attribute:: discard_class
                                                                                            
                                                                                            	Match Discard Class array
                                                                                            	**type**\:  :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                            
                                                                                            .. attribute:: qos_group
                                                                                            
                                                                                            	Match QoS group array
                                                                                            	**type**\:  :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                            
                                                                                            .. attribute:: traffic_class
                                                                                            
                                                                                            	Match Traffic class array
                                                                                            	**type**\:  :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                            
                                                                                            .. attribute:: proto
                                                                                            
                                                                                            	Match Protocol array
                                                                                            	**type**\:  :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                            
                                                                                            .. attribute:: icmp_v4
                                                                                            
                                                                                            	Match ICMPV4 Protocol
                                                                                            	**type**\:  :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                            
                                                                                            .. attribute:: icmp_v6
                                                                                            
                                                                                            	Match ICMPV6 Protocol array
                                                                                            	**type**\:  :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                            
                                                                                            .. attribute:: ipv4_packet_len
                                                                                            
                                                                                            	IPv4 packet length array
                                                                                            	**type**\:  :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv6_packet_len
                                                                                            
                                                                                            	IPv6 packet length array
                                                                                            	**type**\:  :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                            
                                                                                            .. attribute:: packet_len
                                                                                            
                                                                                            	Match packet length array
                                                                                            	**type**\:  :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                            
                                                                                            .. attribute:: flow_tag
                                                                                            
                                                                                            	Match flow\-tag array
                                                                                            	**type**\:  :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                            
                                                                                            .. attribute:: tcp_flag
                                                                                            
                                                                                            	Match tcp flag value
                                                                                            	**type**\:  :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                            
                                                                                            .. attribute:: icmpv4_type
                                                                                            
                                                                                            	Match ipv4 icmp type
                                                                                            	**type**\:  :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                            
                                                                                            .. attribute:: icmpv4_code
                                                                                            
                                                                                            	Match ipv4 icmp code
                                                                                            	**type**\:  :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                            
                                                                                            .. attribute:: icmpv6_type
                                                                                            
                                                                                            	Match ipv6 icmp type
                                                                                            	**type**\:  :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                            
                                                                                            .. attribute:: icmpv6_code
                                                                                            
                                                                                            	Match ipv6 icmp code
                                                                                            	**type**\:  :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                            
                                                                                            .. attribute:: mpls_exp
                                                                                            
                                                                                            	Match MPLS experimental topmost array
                                                                                            	**type**\:  :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                            
                                                                                            .. attribute:: mpls_exp_imp
                                                                                            
                                                                                            	Match MPLS experimental imposition array
                                                                                            	**type**\:  :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                                            
                                                                                            	MPLS Disposition IPv4 Access\-list
                                                                                            	**type**\:  :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                                            
                                                                                            	MPLS Disposition IPv6 Access\-list
                                                                                            	**type**\:  :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_top_label
                                                                                            
                                                                                            	MPLS Topmost LABEL
                                                                                            	**type**\:  :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                            
                                                                                            .. attribute:: cos
                                                                                            
                                                                                            	Match CoS array
                                                                                            	**type**\:  :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                            
                                                                                            .. attribute:: cos_inr
                                                                                            
                                                                                            	Match inner header CoS
                                                                                            	**type**\:  :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                            
                                                                                            .. attribute:: dei
                                                                                            
                                                                                            	Match DEI Bit
                                                                                            	**type**\:  :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                            
                                                                                            .. attribute:: dei_inr
                                                                                            
                                                                                            	Match inner DEI Bit
                                                                                            	**type**\:  :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                            
                                                                                            .. attribute:: vlan
                                                                                            
                                                                                            	Match VLAN array
                                                                                            	**type**\:  :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                            
                                                                                            .. attribute:: vlan_inr
                                                                                            
                                                                                            	Match inner header VLAN range array
                                                                                            	**type**\:  :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                            
                                                                                            .. attribute:: fr_dlci
                                                                                            
                                                                                            	Match FR DLCI range array
                                                                                            	**type**\:  :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                            
                                                                                            .. attribute:: src_mac
                                                                                            
                                                                                            	Match Source MAC address
                                                                                            	**type**\:  :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                            
                                                                                            .. attribute:: dst_mac
                                                                                            
                                                                                            	Match Destination MAC address
                                                                                            	**type**\:  :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                            
                                                                                            .. attribute:: atm_clp
                                                                                            
                                                                                            	Match ATM CLP level
                                                                                            	**type**\:  :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                            
                                                                                            .. attribute:: fr_de
                                                                                            
                                                                                            	Match FR DE value
                                                                                            	**type**\:  :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                            
                                                                                            .. attribute:: ipv4_acl
                                                                                            
                                                                                            	IPv4 Access\-list
                                                                                            	**type**\:  :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                            
                                                                                            .. attribute:: ipv6_acl
                                                                                            
                                                                                            	IPv6 Access\-list
                                                                                            	**type**\:  :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                            
                                                                                            .. attribute:: ether_service_acl
                                                                                            
                                                                                            	Ethernet\-Services Access\-list
                                                                                            	**type**\:  :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                            
                                                                                            .. attribute:: avail_id
                                                                                            
                                                                                            	Available Identifiers
                                                                                            	**type**\:  :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                            
                                                                                            .. attribute:: media_type
                                                                                            
                                                                                            	Media Type
                                                                                            	**type**\:  :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                            
                                                                                            .. attribute:: subs_protocol
                                                                                            
                                                                                            	Protocol
                                                                                            	**type**\:  :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                            
                                                                                            .. attribute:: dnis
                                                                                            
                                                                                            	DNIS
                                                                                            	**type**\:  :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                            
                                                                                            .. attribute:: dnis_regex
                                                                                            
                                                                                            	DNIS Regular Expression
                                                                                            	**type**\:  :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                            
                                                                                            .. attribute:: domain
                                                                                            
                                                                                            	Domain Name
                                                                                            	**type**\:  :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                            
                                                                                            .. attribute:: domain_regex
                                                                                            
                                                                                            	Domain Regular Expression
                                                                                            	**type**\:  :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                            
                                                                                            .. attribute:: nas_port
                                                                                            
                                                                                            	NAS Port
                                                                                            	**type**\:  :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                            
                                                                                            .. attribute:: service_name
                                                                                            
                                                                                            	Service Name
                                                                                            	**type**\:  :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                            
                                                                                            .. attribute:: service_name_regex
                                                                                            
                                                                                            	Service Name Regular Exp
                                                                                            	**type**\:  :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv4
                                                                                            
                                                                                            	Source Address IPV4
                                                                                            	**type**\:  :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv4
                                                                                            
                                                                                            	Destination Address IPV4
                                                                                            	**type**\:  :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv6
                                                                                            
                                                                                            	Source Address IPV6
                                                                                            	**type**\:  :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv6
                                                                                            
                                                                                            	Destination Address IPV6
                                                                                            	**type**\:  :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: src_addr_mac
                                                                                            
                                                                                            	Source Address MAC
                                                                                            	**type**\:  :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                            
                                                                                            .. attribute:: timer
                                                                                            
                                                                                            	Timer
                                                                                            	**type**\:  :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                            
                                                                                            .. attribute:: timer_regexp
                                                                                            
                                                                                            	Timer Regular Expression
                                                                                            	**type**\:  :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                            
                                                                                            .. attribute:: tunnel_name
                                                                                            
                                                                                            	Tunnel Name
                                                                                            	**type**\:  :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                            
                                                                                            .. attribute:: tunnel_name_regex
                                                                                            
                                                                                            	Tunnel Name Regular Expression
                                                                                            	**type**\:  :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                            
                                                                                            .. attribute:: user_name
                                                                                            
                                                                                            	User Name
                                                                                            	**type**\:  :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                            
                                                                                            .. attribute:: user_name_regex
                                                                                            
                                                                                            	User Name Regular Expression
                                                                                            	**type**\:  :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                            
                                                                                            .. attribute:: auth_username
                                                                                            
                                                                                            	Authenticated User Name
                                                                                            	**type**\:  :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                            
                                                                                            .. attribute:: auth_username_regex
                                                                                            
                                                                                            	Authenticated User Name RegEx
                                                                                            	**type**\:  :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_username
                                                                                            
                                                                                            	Unauthenticated User Name
                                                                                            	**type**\:  :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                            
                                                                                            .. attribute:: unauth_username_regex
                                                                                            
                                                                                            	Unauthenticated User Name RegEx
                                                                                            	**type**\:  :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: auth_domain
                                                                                            
                                                                                            	Authenticated domain name
                                                                                            	**type**\:  :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                            
                                                                                            .. attribute:: auth_domain_regex
                                                                                            
                                                                                            	Authenticated Domain Name RegEx
                                                                                            	**type**\:  :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_domain
                                                                                            
                                                                                            	Unauthenticated Domain Name
                                                                                            	**type**\:  :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                            
                                                                                            .. attribute:: unauth_domain_regex
                                                                                            
                                                                                            	Unauthenticated Domain Name RegEx
                                                                                            	**type**\:  :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: vendor_id
                                                                                            
                                                                                            	Vendor ID
                                                                                            	**type**\:  :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                            
                                                                                            .. attribute:: vendor_id_regex
                                                                                            
                                                                                            	Vendor ID RegEx
                                                                                            	**type**\:  :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                            
                                                                                            .. attribute:: access_interface
                                                                                            
                                                                                            	Access interface
                                                                                            	**type**\:  :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                            
                                                                                            .. attribute:: input_interface
                                                                                            
                                                                                            	Input interface
                                                                                            	**type**\:  :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                            
                                                                                            .. attribute:: input_intfhdl
                                                                                            
                                                                                            	Input interface handle
                                                                                            	**type**\:  :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                            
                                                                                            .. attribute:: ethertype
                                                                                            
                                                                                            	Ethernet type
                                                                                            	**type**\:  :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                            
                                                                                            .. attribute:: flow_key_data
                                                                                            
                                                                                            	Flow key structure
                                                                                            	**type**\:  :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id
                                                                                            
                                                                                            	Dhcp Client ID
                                                                                            	**type**\:  :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id_regex
                                                                                            
                                                                                            	Dhcp Client ID RegEx
                                                                                            	**type**\:  :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                            
                                                                                            .. attribute:: circuit_id
                                                                                            
                                                                                            	Circuit ID
                                                                                            	**type**\:  :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                            
                                                                                            .. attribute:: circuit_id_regex
                                                                                            
                                                                                            	Circuit ID RegEx
                                                                                            	**type**\:  :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                            
                                                                                            .. attribute:: remote_id
                                                                                            
                                                                                            	Remote ID
                                                                                            	**type**\:  :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                            
                                                                                            .. attribute:: remote_id_regex
                                                                                            
                                                                                            	Remote ID RegEx
                                                                                            	**type**\:  :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                            
                                                                                            .. attribute:: src_port
                                                                                            
                                                                                            	Source port
                                                                                            	**type**\:  :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                            
                                                                                            .. attribute:: dst_port
                                                                                            
                                                                                            	Destination port
                                                                                            	**type**\:  :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	type
                                                                                            	**type**\:  :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                            
                                                                                            .. attribute:: mpls_top_eos
                                                                                            
                                                                                            	MPLS Topmost EOS
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: fragment_type
                                                                                            
                                                                                            	Fragment type
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: authen_status
                                                                                            
                                                                                            	Authentication Status
                                                                                            	**type**\:  :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                            
                                                                                            .. attribute:: mlp_negotiated
                                                                                            
                                                                                            	MLP Negotiated
                                                                                            	**type**\:  :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                                self.yang_name = "match-data"
                                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("ipv4-dscp", ("ipv4_dscp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp)), ("ipv6-dscp", ("ipv6_dscp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp)), ("dscp", ("dscp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp)), ("ipv4-prec", ("ipv4_prec", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec)), ("ipv6-prec", ("ipv6_prec", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec)), ("prec", ("prec", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec)), ("discard-class", ("discard_class", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass)), ("qos-group", ("qos_group", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup)), ("traffic-class", ("traffic_class", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass)), ("proto", ("proto", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto)), ("icmp-v4", ("icmp_v4", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4)), ("icmp-v6", ("icmp_v6", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6)), ("ipv4-packet-len", ("ipv4_packet_len", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen)), ("ipv6-packet-len", ("ipv6_packet_len", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen)), ("packet-len", ("packet_len", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen)), ("flow-tag", ("flow_tag", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag)), ("tcp-flag", ("tcp_flag", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag)), ("icmpv4-type", ("icmpv4_type", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type)), ("icmpv4-code", ("icmpv4_code", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code)), ("icmpv6-type", ("icmpv6_type", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type)), ("icmpv6-code", ("icmpv6_code", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code)), ("mpls-exp", ("mpls_exp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp)), ("mpls-exp-imp", ("mpls_exp_imp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp)), ("mpls-disp-ipv4-acl", ("mpls_disp_ipv4_acl", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl)), ("mpls-disp-ipv6-acl", ("mpls_disp_ipv6_acl", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl)), ("mpls-top-label", ("mpls_top_label", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel)), ("cos", ("cos", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos)), ("cos-inr", ("cos_inr", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr)), ("dei", ("dei", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei)), ("dei-inr", ("dei_inr", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr)), ("vlan", ("vlan", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan)), ("vlan-inr", ("vlan_inr", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)), ("fr-dlci", ("fr_dlci", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci)), ("src-mac", ("src_mac", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac)), ("dst-mac", ("dst_mac", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac)), ("atm-clp", ("atm_clp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp)), ("fr-de", ("fr_de", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe)), ("ipv4-acl", ("ipv4_acl", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl)), ("ipv6-acl", ("ipv6_acl", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl)), ("ether-service-acl", ("ether_service_acl", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl)), ("avail-id", ("avail_id", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId)), ("media-type", ("media_type", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType)), ("subs-protocol", ("subs_protocol", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol)), ("dnis", ("dnis", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis)), ("dnis-regex", ("dnis_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex)), ("domain", ("domain", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain)), ("domain-regex", ("domain_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex)), ("nas-port", ("nas_port", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort)), ("service-name", ("service_name", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName)), ("service-name-regex", ("service_name_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex)), ("src-addr-ipv4", ("src_addr_ipv4", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4)), ("dst-addr-ipv4", ("dst_addr_ipv4", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4)), ("src-addr-ipv6", ("src_addr_ipv6", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6)), ("dst-addr-ipv6", ("dst_addr_ipv6", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6)), ("src-addr-mac", ("src_addr_mac", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac)), ("timer", ("timer", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer)), ("timer-regexp", ("timer_regexp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp)), ("tunnel-name", ("tunnel_name", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName)), ("tunnel-name-regex", ("tunnel_name_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex)), ("user-name", ("user_name", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName)), ("user-name-regex", ("user_name_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex)), ("auth-username", ("auth_username", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername)), ("auth-username-regex", ("auth_username_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex)), ("unauth-username", ("unauth_username", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername)), ("unauth-username-regex", ("unauth_username_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex)), ("auth-domain", ("auth_domain", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain)), ("auth-domain-regex", ("auth_domain_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex)), ("unauth-domain", ("unauth_domain", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain)), ("unauth-domain-regex", ("unauth_domain_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex)), ("vendor-id", ("vendor_id", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId)), ("vendor-id-regex", ("vendor_id_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex)), ("access-interface", ("access_interface", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface)), ("input-interface", ("input_interface", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface)), ("input-intfhdl", ("input_intfhdl", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl)), ("ethertype", ("ethertype", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype)), ("flow-key-data", ("flow_key_data", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData)), ("dhcp-client-id", ("dhcp_client_id", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId)), ("dhcp-client-id-regex", ("dhcp_client_id_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex)), ("circuit-id", ("circuit_id", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId)), ("circuit-id-regex", ("circuit_id_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex)), ("remote-id", ("remote_id", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId)), ("remote-id-regex", ("remote_id_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex)), ("src-port", ("src_port", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort)), ("dst-port", ("dst_port", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort))])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchTypeEn', '')])),
                                                                                                    ('mpls_top_eos', (YLeaf(YType.uint8, 'mpls-top-eos'), ['int'])),
                                                                                                    ('fragment_type', (YLeaf(YType.uint8, 'fragment-type'), ['int'])),
                                                                                                    ('authen_status', (YLeaf(YType.enumeration, 'authen-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchAuthenStatusEn', '')])),
                                                                                                    ('mlp_negotiated', (YLeaf(YType.enumeration, 'mlp-negotiated'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchMlpNegotiatedEn', '')])),
                                                                                                ])
                                                                                                self.type = None
                                                                                                self.mpls_top_eos = None
                                                                                                self.fragment_type = None
                                                                                                self.authen_status = None
                                                                                                self.mlp_negotiated = None

                                                                                                self.ipv4_dscp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                                self.ipv4_dscp.parent = self
                                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"

                                                                                                self.ipv6_dscp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                                self.ipv6_dscp.parent = self
                                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"

                                                                                                self.dscp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                                self.dscp.parent = self
                                                                                                self._children_name_map["dscp"] = "dscp"

                                                                                                self.ipv4_prec = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                                self.ipv4_prec.parent = self
                                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"

                                                                                                self.ipv6_prec = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                                self.ipv6_prec.parent = self
                                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"

                                                                                                self.prec = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                                self.prec.parent = self
                                                                                                self._children_name_map["prec"] = "prec"

                                                                                                self.discard_class = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                                self.discard_class.parent = self
                                                                                                self._children_name_map["discard_class"] = "discard-class"

                                                                                                self.qos_group = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                                self.qos_group.parent = self
                                                                                                self._children_name_map["qos_group"] = "qos-group"

                                                                                                self.traffic_class = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                                self.traffic_class.parent = self
                                                                                                self._children_name_map["traffic_class"] = "traffic-class"

                                                                                                self.proto = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                                self.proto.parent = self
                                                                                                self._children_name_map["proto"] = "proto"

                                                                                                self.icmp_v4 = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                                self.icmp_v4.parent = self
                                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"

                                                                                                self.icmp_v6 = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                                self.icmp_v6.parent = self
                                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"

                                                                                                self.ipv4_packet_len = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                                self.ipv4_packet_len.parent = self
                                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"

                                                                                                self.ipv6_packet_len = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                                self.ipv6_packet_len.parent = self
                                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"

                                                                                                self.packet_len = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                                self.packet_len.parent = self
                                                                                                self._children_name_map["packet_len"] = "packet-len"

                                                                                                self.flow_tag = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                                self.flow_tag.parent = self
                                                                                                self._children_name_map["flow_tag"] = "flow-tag"

                                                                                                self.tcp_flag = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                                self.tcp_flag.parent = self
                                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"

                                                                                                self.icmpv4_type = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                                self.icmpv4_type.parent = self
                                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"

                                                                                                self.icmpv4_code = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                                self.icmpv4_code.parent = self
                                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"

                                                                                                self.icmpv6_type = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                                self.icmpv6_type.parent = self
                                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"

                                                                                                self.icmpv6_code = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                                self.icmpv6_code.parent = self
                                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"

                                                                                                self.mpls_exp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                                self.mpls_exp.parent = self
                                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"

                                                                                                self.mpls_exp_imp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                                self.mpls_exp_imp.parent = self
                                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"

                                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"

                                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"

                                                                                                self.mpls_top_label = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                                self.mpls_top_label.parent = self
                                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"

                                                                                                self.cos = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                                self.cos.parent = self
                                                                                                self._children_name_map["cos"] = "cos"

                                                                                                self.cos_inr = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                                self.cos_inr.parent = self
                                                                                                self._children_name_map["cos_inr"] = "cos-inr"

                                                                                                self.dei = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                                self.dei.parent = self
                                                                                                self._children_name_map["dei"] = "dei"

                                                                                                self.dei_inr = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                                self.dei_inr.parent = self
                                                                                                self._children_name_map["dei_inr"] = "dei-inr"

                                                                                                self.vlan = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                                self.vlan.parent = self
                                                                                                self._children_name_map["vlan"] = "vlan"

                                                                                                self.vlan_inr = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                                self.vlan_inr.parent = self
                                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"

                                                                                                self.fr_dlci = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                                self.fr_dlci.parent = self
                                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"

                                                                                                self.src_mac = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                                self.src_mac.parent = self
                                                                                                self._children_name_map["src_mac"] = "src-mac"

                                                                                                self.dst_mac = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                                self.dst_mac.parent = self
                                                                                                self._children_name_map["dst_mac"] = "dst-mac"

                                                                                                self.atm_clp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                                self.atm_clp.parent = self
                                                                                                self._children_name_map["atm_clp"] = "atm-clp"

                                                                                                self.fr_de = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                                self.fr_de.parent = self
                                                                                                self._children_name_map["fr_de"] = "fr-de"

                                                                                                self.ipv4_acl = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                                self.ipv4_acl.parent = self
                                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"

                                                                                                self.ipv6_acl = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                                self.ipv6_acl.parent = self
                                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"

                                                                                                self.ether_service_acl = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                                self.ether_service_acl.parent = self
                                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"

                                                                                                self.avail_id = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                                self.avail_id.parent = self
                                                                                                self._children_name_map["avail_id"] = "avail-id"

                                                                                                self.media_type = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                                self.media_type.parent = self
                                                                                                self._children_name_map["media_type"] = "media-type"

                                                                                                self.subs_protocol = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                                self.subs_protocol.parent = self
                                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"

                                                                                                self.dnis = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                                self.dnis.parent = self
                                                                                                self._children_name_map["dnis"] = "dnis"

                                                                                                self.dnis_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                                self.dnis_regex.parent = self
                                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"

                                                                                                self.domain = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                                self.domain.parent = self
                                                                                                self._children_name_map["domain"] = "domain"

                                                                                                self.domain_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                                self.domain_regex.parent = self
                                                                                                self._children_name_map["domain_regex"] = "domain-regex"

                                                                                                self.nas_port = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                                self.nas_port.parent = self
                                                                                                self._children_name_map["nas_port"] = "nas-port"

                                                                                                self.service_name = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                                self.service_name.parent = self
                                                                                                self._children_name_map["service_name"] = "service-name"

                                                                                                self.service_name_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                                self.service_name_regex.parent = self
                                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"

                                                                                                self.src_addr_ipv4 = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                                self.src_addr_ipv4.parent = self
                                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"

                                                                                                self.dst_addr_ipv4 = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                                self.dst_addr_ipv4.parent = self
                                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"

                                                                                                self.src_addr_ipv6 = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                                self.src_addr_ipv6.parent = self
                                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"

                                                                                                self.dst_addr_ipv6 = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                                self.dst_addr_ipv6.parent = self
                                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"

                                                                                                self.src_addr_mac = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                                self.src_addr_mac.parent = self
                                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"

                                                                                                self.timer = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                                self.timer.parent = self
                                                                                                self._children_name_map["timer"] = "timer"

                                                                                                self.timer_regexp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                                self.timer_regexp.parent = self
                                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"

                                                                                                self.tunnel_name = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                                self.tunnel_name.parent = self
                                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"

                                                                                                self.tunnel_name_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                                self.tunnel_name_regex.parent = self
                                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"

                                                                                                self.user_name = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                                self.user_name.parent = self
                                                                                                self._children_name_map["user_name"] = "user-name"

                                                                                                self.user_name_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                                self.user_name_regex.parent = self
                                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"

                                                                                                self.auth_username = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                                self.auth_username.parent = self
                                                                                                self._children_name_map["auth_username"] = "auth-username"

                                                                                                self.auth_username_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                                self.auth_username_regex.parent = self
                                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"

                                                                                                self.unauth_username = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                                self.unauth_username.parent = self
                                                                                                self._children_name_map["unauth_username"] = "unauth-username"

                                                                                                self.unauth_username_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                                self.unauth_username_regex.parent = self
                                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"

                                                                                                self.auth_domain = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                                self.auth_domain.parent = self
                                                                                                self._children_name_map["auth_domain"] = "auth-domain"

                                                                                                self.auth_domain_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                                self.auth_domain_regex.parent = self
                                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"

                                                                                                self.unauth_domain = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                                self.unauth_domain.parent = self
                                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"

                                                                                                self.unauth_domain_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                                self.unauth_domain_regex.parent = self
                                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"

                                                                                                self.vendor_id = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                                self.vendor_id.parent = self
                                                                                                self._children_name_map["vendor_id"] = "vendor-id"

                                                                                                self.vendor_id_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                                self.vendor_id_regex.parent = self
                                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"

                                                                                                self.access_interface = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                                self.access_interface.parent = self
                                                                                                self._children_name_map["access_interface"] = "access-interface"

                                                                                                self.input_interface = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                                self.input_interface.parent = self
                                                                                                self._children_name_map["input_interface"] = "input-interface"

                                                                                                self.input_intfhdl = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                                self.input_intfhdl.parent = self
                                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"

                                                                                                self.ethertype = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                                self.ethertype.parent = self
                                                                                                self._children_name_map["ethertype"] = "ethertype"

                                                                                                self.flow_key_data = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                                self.flow_key_data.parent = self
                                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"

                                                                                                self.dhcp_client_id = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                                self.dhcp_client_id.parent = self
                                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"

                                                                                                self.dhcp_client_id_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                                self.dhcp_client_id_regex.parent = self
                                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"

                                                                                                self.circuit_id = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                                self.circuit_id.parent = self
                                                                                                self._children_name_map["circuit_id"] = "circuit-id"

                                                                                                self.circuit_id_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                                self.circuit_id_regex.parent = self
                                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"

                                                                                                self.remote_id = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                                self.remote_id.parent = self
                                                                                                self._children_name_map["remote_id"] = "remote-id"

                                                                                                self.remote_id_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                                self.remote_id_regex.parent = self
                                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"

                                                                                                self.src_port = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                                self.src_port.parent = self
                                                                                                self._children_name_map["src_port"] = "src-port"

                                                                                                self.dst_port = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                                self.dst_port.parent = self
                                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                                self._segment_path = lambda: "match-data"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, ['type', 'mpls_top_eos', 'fragment_type', 'authen_status', 'mlp_negotiated'], name, value)


                                                                                            class Ipv4Dscp(Entity):
                                                                                                """
                                                                                                IPv4 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv4-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv6Dscp(Entity):
                                                                                                """
                                                                                                IPv6 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv6-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Dscp(Entity):
                                                                                                """
                                                                                                Match DSCP range array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                    self.yang_name = "dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv4Prec(Entity):
                                                                                                """
                                                                                                IPv4 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                    self.yang_name = "ipv4-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "ipv4-prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                            class Ipv6Prec(Entity):
                                                                                                """
                                                                                                IPv6 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                    self.yang_name = "ipv6-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "ipv6-prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                            class Prec(Entity):
                                                                                                """
                                                                                                Match Precedence array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                    self.yang_name = "prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                            class DiscardClass(Entity):
                                                                                                """
                                                                                                Match Discard Class array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                    self.yang_name = "discard-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "discard-class"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                            class QosGroup(Entity):
                                                                                                """
                                                                                                Match QoS group array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                    self.yang_name = "qos-group"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "qos-group"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "qos-group"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class TrafficClass(Entity):
                                                                                                """
                                                                                                Match Traffic class array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                    self.yang_name = "traffic-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "traffic-class"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "traffic-class"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Proto(Entity):
                                                                                                """
                                                                                                Match Protocol array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                    self.yang_name = "proto"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "proto"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "proto"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class IcmpV4(Entity):
                                                                                                """
                                                                                                Match ICMPV4 Protocol
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                    self.yang_name = "icmp-v4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                    ])
                                                                                                    self.type = None
                                                                                                    self.code = None
                                                                                                    self._segment_path = lambda: "icmp-v4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['type', 'code'], name, value)


                                                                                            class IcmpV6(Entity):
                                                                                                """
                                                                                                Match ICMPV6 Protocol array
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                    self.yang_name = "icmp-v6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                    ])
                                                                                                    self.type = None
                                                                                                    self.code = None
                                                                                                    self._segment_path = lambda: "icmp-v6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['type', 'code'], name, value)


                                                                                            class Ipv4PacketLen(Entity):
                                                                                                """
                                                                                                IPv4 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv6PacketLen(Entity):
                                                                                                """
                                                                                                IPv6 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class PacketLen(Entity):
                                                                                                """
                                                                                                Match packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                    self.yang_name = "packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FlowTag(Entity):
                                                                                                """
                                                                                                Match flow\-tag array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                    self.yang_name = "flow-tag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "flow-tag"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "flow-tag"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class TcpFlag(Entity):
                                                                                                """
                                                                                                Match tcp flag value
                                                                                                
                                                                                                .. attribute:: value
                                                                                                
                                                                                                	Value of TCP flag
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: match_any
                                                                                                
                                                                                                	Match any TCP flag bit
                                                                                                	**type**\: bool
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                    self.yang_name = "tcp-flag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                                        ('match_any', (YLeaf(YType.boolean, 'match-any'), ['bool'])),
                                                                                                    ])
                                                                                                    self.value = None
                                                                                                    self.match_any = None
                                                                                                    self._segment_path = lambda: "tcp-flag"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['value', 'match_any'], name, value)


                                                                                            class Icmpv4Type(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                    self.yang_name = "icmpv4-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv4Code(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                    self.yang_name = "icmpv4-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-code"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv6Type(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                    self.yang_name = "icmpv6-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv6Code(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                    self.yang_name = "icmpv6-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-code"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class MplsExp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental topmost array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "mpls-exp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                            class MplsExpImp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental imposition array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "mpls-exp-imp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                            class MplsDispIpv4Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                            class MplsDispIpv6Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                            class MplsTopLabel(Entity):
                                                                                                """
                                                                                                MPLS Topmost LABEL
                                                                                                
                                                                                                .. attribute:: uint32_rng_array
                                                                                                
                                                                                                	uint32 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                    self.yang_name = "mpls-top-label"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint32_rng_array", ("uint32_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint32_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "mpls-top-label"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                                class Uint32RngArray(Entity):
                                                                                                    """
                                                                                                    uint32 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                        self.yang_name = "uint32_rng_array"
                                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint32, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint32, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint32_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['min', 'max'], name, value)


                                                                                            class Cos(Entity):
                                                                                                """
                                                                                                Match CoS array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                    self.yang_name = "cos"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "cos"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                            class CosInr(Entity):
                                                                                                """
                                                                                                Match inner header CoS
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                    self.yang_name = "cos-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "cos-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                            class Dei(Entity):
                                                                                                """
                                                                                                Match DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                    self.yang_name = "dei"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                    ])
                                                                                                    self.bit_value = None
                                                                                                    self._segment_path = lambda: "dei"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                            class DeiInr(Entity):
                                                                                                """
                                                                                                Match inner DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                    self.yang_name = "dei-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                    ])
                                                                                                    self.bit_value = None
                                                                                                    self._segment_path = lambda: "dei-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                            class Vlan(Entity):
                                                                                                """
                                                                                                Match VLAN array
                                                                                                
                                                                                                .. attribute:: vlan_id_array
                                                                                                
                                                                                                	vlan id array
                                                                                                	**type**\: list of  		 :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                    self.yang_name = "vlan"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("vlan-id-array", ("vlan_id_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.vlan_id_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                                class VlanIdArray(Entity):
                                                                                                    """
                                                                                                    vlan id array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	VLAN mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                        self.yang_name = "vlan-id-array"
                                                                                                        self.yang_parent_name = "vlan"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ('mask', (YLeaf(YType.uint16, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "vlan-id-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['min', 'max', 'mask'], name, value)


                                                                                            class VlanInr(Entity):
                                                                                                """
                                                                                                Match inner header VLAN range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                    self.yang_name = "vlan-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FrDlci(Entity):
                                                                                                """
                                                                                                Match FR DLCI range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                    self.yang_name = "fr-dlci"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "fr-dlci"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class SrcMac(Entity):
                                                                                                """
                                                                                                Match Source MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                    self.yang_name = "src-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.mac_addr = []
                                                                                                    self.mask = []
                                                                                                    self._segment_path = lambda: "src-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                            class DstMac(Entity):
                                                                                                """
                                                                                                Match Destination MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                    self.yang_name = "dst-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.mac_addr = []
                                                                                                    self.mask = []
                                                                                                    self._segment_path = lambda: "dst-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                            class AtmClp(Entity):
                                                                                                """
                                                                                                Match ATM CLP level
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                    self.yang_name = "atm-clp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "atm-clp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                            class FrDe(Entity):
                                                                                                """
                                                                                                Match FR DE value
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                    self.yang_name = "fr-de"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "fr-de"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                            class Ipv4Acl(Entity):
                                                                                                """
                                                                                                IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                    self.yang_name = "ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ipv4-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                            class Ipv6Acl(Entity):
                                                                                                """
                                                                                                IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                    self.yang_name = "ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ipv6-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                            class EtherServiceAcl(Entity):
                                                                                                """
                                                                                                Ethernet\-Services Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                    self.yang_name = "ether-service-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ether-service-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                            class AvailId(Entity):
                                                                                                """
                                                                                                Available Identifiers
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                    self.yang_name = "avail-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "avail-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                            class MediaType(Entity):
                                                                                                """
                                                                                                Media Type
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                    self.yang_name = "media-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "media-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                            class SubsProtocol(Entity):
                                                                                                """
                                                                                                Protocol
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                    self.yang_name = "subs-protocol"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "subs-protocol"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                            class Dnis(Entity):
                                                                                                """
                                                                                                DNIS
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                    self.yang_name = "dnis"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dnis"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                            class DnisRegex(Entity):
                                                                                                """
                                                                                                DNIS Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                    self.yang_name = "dnis-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dnis-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                            class Domain(Entity):
                                                                                                """
                                                                                                Domain Name
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                    self.yang_name = "domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                        ])
                                                                                                        self.domain_name = None
                                                                                                        self.format_name = None
                                                                                                        self._segment_path = lambda: "domain-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class DomainRegex(Entity):
                                                                                                """
                                                                                                Domain Regular Expression
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                    self.yang_name = "domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain-regex"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                        ])
                                                                                                        self.domain_name = None
                                                                                                        self.format_name = None
                                                                                                        self._segment_path = lambda: "domain-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class NasPort(Entity):
                                                                                                """
                                                                                                NAS Port
                                                                                                
                                                                                                .. attribute:: nas_port_array
                                                                                                
                                                                                                	nas port array
                                                                                                	**type**\: list of  		 :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                    self.yang_name = "nas-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("nas-port-array", ("nas_port_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.nas_port_array = YList(self)
                                                                                                    self._segment_path = lambda: "nas-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                                class NasPortArray(Entity):
                                                                                                    """
                                                                                                    nas port array
                                                                                                    
                                                                                                    .. attribute:: sub_id
                                                                                                    
                                                                                                    	sub id
                                                                                                    	**type**\:  :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                    
                                                                                                    .. attribute:: operator
                                                                                                    
                                                                                                    	operator
                                                                                                    	**type**\:  :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	value
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                        self.yang_name = "nas-port-array"
                                                                                                        self.yang_parent_name = "nas-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('sub_id', (YLeaf(YType.enumeration, 'sub-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchNasPortSubIdEn', '')])),
                                                                                                            ('operator', (YLeaf(YType.enumeration, 'operator'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchLogicalOperatorEn', '')])),
                                                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                                        ])
                                                                                                        self.sub_id = None
                                                                                                        self.operator = None
                                                                                                        self.value = None
                                                                                                        self._segment_path = lambda: "nas-port-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['sub_id', 'operator', 'value'], name, value)


                                                                                            class ServiceName(Entity):
                                                                                                """
                                                                                                Service Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                    self.yang_name = "service-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "service-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                            class ServiceNameRegex(Entity):
                                                                                                """
                                                                                                Service Name Regular Exp
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                    self.yang_name = "service-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "service-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                            class SrcAddrIpv4(Entity):
                                                                                                """
                                                                                                Source Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class DstAddrIpv4(Entity):
                                                                                                """
                                                                                                Destination Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class SrcAddrIpv6(Entity):
                                                                                                """
                                                                                                Source Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class DstAddrIpv6(Entity):
                                                                                                """
                                                                                                Destination Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class SrcAddrMac(Entity):
                                                                                                """
                                                                                                Source Address MAC
                                                                                                
                                                                                                .. attribute:: mac_addr_array
                                                                                                
                                                                                                	mac addr array
                                                                                                	**type**\: list of  		 :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                    self.yang_name = "src-addr-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("mac-addr-array", ("mac_addr_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.mac_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                                class MacAddrArray(Entity):
                                                                                                    """
                                                                                                    mac addr array
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                        self.yang_name = "mac-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                            ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.mac_addr = []
                                                                                                        self.mask = []
                                                                                                        self._segment_path = lambda: "mac-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                            class Timer(Entity):
                                                                                                """
                                                                                                Timer
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                    self.yang_name = "timer"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "timer"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                            class TimerRegexp(Entity):
                                                                                                """
                                                                                                Timer Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                    self.yang_name = "timer-regexp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "timer-regexp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                            class TunnelName(Entity):
                                                                                                """
                                                                                                Tunnel Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                    self.yang_name = "tunnel-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "tunnel-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                            class TunnelNameRegex(Entity):
                                                                                                """
                                                                                                Tunnel Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "tunnel-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                            class UserName(Entity):
                                                                                                """
                                                                                                User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                    self.yang_name = "user-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "user-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                            class UserNameRegex(Entity):
                                                                                                """
                                                                                                User Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                    self.yang_name = "user-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "user-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                            class AuthUsername(Entity):
                                                                                                """
                                                                                                Authenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                    self.yang_name = "auth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-username"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                            class AuthUsernameRegex(Entity):
                                                                                                """
                                                                                                Authenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "auth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-username-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                            class UnauthUsername(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                    self.yang_name = "unauth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-username"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                            class UnauthUsernameRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-username-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                            class AuthDomain(Entity):
                                                                                                """
                                                                                                Authenticated domain name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                    self.yang_name = "auth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                            class AuthDomainRegex(Entity):
                                                                                                """
                                                                                                Authenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "auth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                            class UnauthDomain(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                    self.yang_name = "unauth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                            class UnauthDomainRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                            class VendorId(Entity):
                                                                                                """
                                                                                                Vendor ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                    self.yang_name = "vendor-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "vendor-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                            class VendorIdRegex(Entity):
                                                                                                """
                                                                                                Vendor ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                    self.yang_name = "vendor-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "vendor-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                            class AccessInterface(Entity):
                                                                                                """
                                                                                                Access interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                    self.yang_name = "access-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "access-interface"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                            class InputInterface(Entity):
                                                                                                """
                                                                                                Input interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                    self.yang_name = "input-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "input-interface"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                            class InputIntfhdl(Entity):
                                                                                                """
                                                                                                Input interface handle
                                                                                                
                                                                                                .. attribute:: uint64_array
                                                                                                
                                                                                                	uint64 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..18446744073709551615
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                    self.yang_name = "input-intfhdl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint64_array', (YLeafList(YType.uint64, 'uint64_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint64_array = []
                                                                                                    self._segment_path = lambda: "input-intfhdl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                            class Ethertype(Entity):
                                                                                                """
                                                                                                Ethernet type
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                    self.yang_name = "ethertype"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ethertype"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ethertype"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FlowKeyData(Entity):
                                                                                                """
                                                                                                Flow key structure
                                                                                                
                                                                                                .. attribute:: flow_keys
                                                                                                
                                                                                                	flow keys
                                                                                                	**type**\:  :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                                
                                                                                                .. attribute:: max_count
                                                                                                
                                                                                                	Maximum count of flows
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: idle_timeout
                                                                                                
                                                                                                	Idle timeout of flows (in seconds)
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                	**units**\: second
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                    self.yang_name = "flow-key-data"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("flow-keys", ("flow_keys", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys))])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('max_count', (YLeaf(YType.uint16, 'max-count'), ['int'])),
                                                                                                        ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                                                    ])
                                                                                                    self.max_count = None
                                                                                                    self.idle_timeout = None

                                                                                                    self.flow_keys = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                    self.flow_keys.parent = self
                                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                    self._segment_path = lambda: "flow-key-data"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['max_count', 'idle_timeout'], name, value)


                                                                                                class FlowKeys(Entity):
                                                                                                    """
                                                                                                    flow keys
                                                                                                    
                                                                                                    .. attribute:: keys
                                                                                                    
                                                                                                    	keys
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                    
                                                                                                    .. attribute:: num
                                                                                                    
                                                                                                    	num
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                        self.yang_name = "flow-keys"
                                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('keys', (YLeaf(YType.str, 'keys'), ['str'])),
                                                                                                            ('num', (YLeaf(YType.uint8, 'num'), ['int'])),
                                                                                                        ])
                                                                                                        self.keys = None
                                                                                                        self.num = None
                                                                                                        self._segment_path = lambda: "flow-keys"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                            class DhcpClientId(Entity):
                                                                                                """
                                                                                                Dhcp Client ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dhcp-client-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                            class DhcpClientIdRegex(Entity):
                                                                                                """
                                                                                                Dhcp Client ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                            class CircuitId(Entity):
                                                                                                """
                                                                                                Circuit ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                    self.yang_name = "circuit-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "circuit-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                            class CircuitIdRegex(Entity):
                                                                                                """
                                                                                                Circuit ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                    self.yang_name = "circuit-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "circuit-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                            class RemoteId(Entity):
                                                                                                """
                                                                                                Remote ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                    self.yang_name = "remote-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "remote-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                            class RemoteIdRegex(Entity):
                                                                                                """
                                                                                                Remote ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                    self.yang_name = "remote-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "remote-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                            class SrcPort(Entity):
                                                                                                """
                                                                                                Source port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                    self.yang_name = "src-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "src-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class DstPort(Entity):
                                                                                                """
                                                                                                Destination port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                    self.yang_name = "dst-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "dst-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                        class ConfclassP(Entity):
                                                                            """
                                                                            confclass p
                                                                            
                                                                            .. attribute:: class_map_bg
                                                                            
                                                                            	class map bg
                                                                            	**type**\: list of  		 :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP, self).__init__()

                                                                                self.yang_name = "confclass-p"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("class-map-bg", ("class_map_bg", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg))])
                                                                                self._leafs = OrderedDict()

                                                                                self.class_map_bg = YList(self)
                                                                                self._segment_path = lambda: "confclass-p"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP, [], name, value)


                                                                            class ClassMapBg(Entity):
                                                                                """
                                                                                class map bg
                                                                                
                                                                                .. attribute:: match_infop
                                                                                
                                                                                	Pointer to the first Match info
                                                                                	**type**\:  :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop>`
                                                                                
                                                                                .. attribute:: name
                                                                                
                                                                                	Name of the class\-map
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..65
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Class\-Map Type QoS/PBR/Netflow/..
                                                                                	**type**\:  :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                                                
                                                                                .. attribute:: mode
                                                                                
                                                                                	Class\-Map Mode Match any/Match all
                                                                                	**type**\:  :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                                
                                                                                .. attribute:: description
                                                                                
                                                                                	description
                                                                                	**type**\: str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg, self).__init__()

                                                                                    self.yang_name = "class-map-bg"
                                                                                    self.yang_parent_name = "confclass-p"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("match-infop", ("match_infop", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapTypeEn', '')])),
                                                                                        ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapModeEn', '')])),
                                                                                        ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                    ])
                                                                                    self.name = None
                                                                                    self.type = None
                                                                                    self.mode = None
                                                                                    self.description = None

                                                                                    self.match_infop = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop()
                                                                                    self.match_infop.parent = self
                                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                                    self._segment_path = lambda: "class-map-bg"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg, ['name', 'type', 'mode', 'description'], name, value)


                                                                                class MatchInfop(Entity):
                                                                                    """
                                                                                    Pointer to the first Match info
                                                                                    
                                                                                    .. attribute:: class_match_info_st
                                                                                    
                                                                                    	class match info st
                                                                                    	**type**\: list of  		 :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop, self).__init__()

                                                                                        self.yang_name = "match-infop"
                                                                                        self.yang_parent_name = "class-map-bg"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("class-match-info-st", ("class_match_info_st", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.class_match_info_st = YList(self)
                                                                                        self._segment_path = lambda: "match-infop"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop, [], name, value)


                                                                                    class ClassMatchInfoSt(Entity):
                                                                                        """
                                                                                        class match info st
                                                                                        
                                                                                        .. attribute:: match_data
                                                                                        
                                                                                        	Match criteria
                                                                                        	**type**\:  :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                        
                                                                                        .. attribute:: flags
                                                                                        
                                                                                        	Flags
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                            self.yang_name = "class-match-info-st"
                                                                                            self.yang_parent_name = "match-infop"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("match-data", ("match_data", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData))])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                            ])
                                                                                            self.flags = None

                                                                                            self.match_data = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                            self.match_data.parent = self
                                                                                            self._children_name_map["match_data"] = "match-data"
                                                                                            self._segment_path = lambda: "class-match-info-st"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                        class MatchData(Entity):
                                                                                            """
                                                                                            Match criteria
                                                                                            
                                                                                            .. attribute:: ipv4_dscp
                                                                                            
                                                                                            	IPv4 DSCP
                                                                                            	**type**\:  :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv6_dscp
                                                                                            
                                                                                            	IPv6 DSCP
                                                                                            	**type**\:  :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                            
                                                                                            .. attribute:: dscp
                                                                                            
                                                                                            	Match DSCP range array
                                                                                            	**type**\:  :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv4_prec
                                                                                            
                                                                                            	IPv4 Precedence
                                                                                            	**type**\:  :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                            
                                                                                            .. attribute:: ipv6_prec
                                                                                            
                                                                                            	IPv6 Precedence
                                                                                            	**type**\:  :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                            
                                                                                            .. attribute:: prec
                                                                                            
                                                                                            	Match Precedence array
                                                                                            	**type**\:  :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                            
                                                                                            .. attribute:: discard_class
                                                                                            
                                                                                            	Match Discard Class array
                                                                                            	**type**\:  :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                            
                                                                                            .. attribute:: qos_group
                                                                                            
                                                                                            	Match QoS group array
                                                                                            	**type**\:  :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                            
                                                                                            .. attribute:: traffic_class
                                                                                            
                                                                                            	Match Traffic class array
                                                                                            	**type**\:  :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                            
                                                                                            .. attribute:: proto
                                                                                            
                                                                                            	Match Protocol array
                                                                                            	**type**\:  :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                            
                                                                                            .. attribute:: icmp_v4
                                                                                            
                                                                                            	Match ICMPV4 Protocol
                                                                                            	**type**\:  :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                            
                                                                                            .. attribute:: icmp_v6
                                                                                            
                                                                                            	Match ICMPV6 Protocol array
                                                                                            	**type**\:  :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                            
                                                                                            .. attribute:: ipv4_packet_len
                                                                                            
                                                                                            	IPv4 packet length array
                                                                                            	**type**\:  :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv6_packet_len
                                                                                            
                                                                                            	IPv6 packet length array
                                                                                            	**type**\:  :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                            
                                                                                            .. attribute:: packet_len
                                                                                            
                                                                                            	Match packet length array
                                                                                            	**type**\:  :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                            
                                                                                            .. attribute:: flow_tag
                                                                                            
                                                                                            	Match flow\-tag array
                                                                                            	**type**\:  :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                            
                                                                                            .. attribute:: tcp_flag
                                                                                            
                                                                                            	Match tcp flag value
                                                                                            	**type**\:  :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                            
                                                                                            .. attribute:: icmpv4_type
                                                                                            
                                                                                            	Match ipv4 icmp type
                                                                                            	**type**\:  :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                            
                                                                                            .. attribute:: icmpv4_code
                                                                                            
                                                                                            	Match ipv4 icmp code
                                                                                            	**type**\:  :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                            
                                                                                            .. attribute:: icmpv6_type
                                                                                            
                                                                                            	Match ipv6 icmp type
                                                                                            	**type**\:  :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                            
                                                                                            .. attribute:: icmpv6_code
                                                                                            
                                                                                            	Match ipv6 icmp code
                                                                                            	**type**\:  :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                            
                                                                                            .. attribute:: mpls_exp
                                                                                            
                                                                                            	Match MPLS experimental topmost array
                                                                                            	**type**\:  :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                            
                                                                                            .. attribute:: mpls_exp_imp
                                                                                            
                                                                                            	Match MPLS experimental imposition array
                                                                                            	**type**\:  :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                                            
                                                                                            	MPLS Disposition IPv4 Access\-list
                                                                                            	**type**\:  :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                                            
                                                                                            	MPLS Disposition IPv6 Access\-list
                                                                                            	**type**\:  :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_top_label
                                                                                            
                                                                                            	MPLS Topmost LABEL
                                                                                            	**type**\:  :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                            
                                                                                            .. attribute:: cos
                                                                                            
                                                                                            	Match CoS array
                                                                                            	**type**\:  :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                            
                                                                                            .. attribute:: cos_inr
                                                                                            
                                                                                            	Match inner header CoS
                                                                                            	**type**\:  :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                            
                                                                                            .. attribute:: dei
                                                                                            
                                                                                            	Match DEI Bit
                                                                                            	**type**\:  :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                            
                                                                                            .. attribute:: dei_inr
                                                                                            
                                                                                            	Match inner DEI Bit
                                                                                            	**type**\:  :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                            
                                                                                            .. attribute:: vlan
                                                                                            
                                                                                            	Match VLAN array
                                                                                            	**type**\:  :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                            
                                                                                            .. attribute:: vlan_inr
                                                                                            
                                                                                            	Match inner header VLAN range array
                                                                                            	**type**\:  :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                            
                                                                                            .. attribute:: fr_dlci
                                                                                            
                                                                                            	Match FR DLCI range array
                                                                                            	**type**\:  :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                            
                                                                                            .. attribute:: src_mac
                                                                                            
                                                                                            	Match Source MAC address
                                                                                            	**type**\:  :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                            
                                                                                            .. attribute:: dst_mac
                                                                                            
                                                                                            	Match Destination MAC address
                                                                                            	**type**\:  :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                            
                                                                                            .. attribute:: atm_clp
                                                                                            
                                                                                            	Match ATM CLP level
                                                                                            	**type**\:  :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                            
                                                                                            .. attribute:: fr_de
                                                                                            
                                                                                            	Match FR DE value
                                                                                            	**type**\:  :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                            
                                                                                            .. attribute:: ipv4_acl
                                                                                            
                                                                                            	IPv4 Access\-list
                                                                                            	**type**\:  :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                            
                                                                                            .. attribute:: ipv6_acl
                                                                                            
                                                                                            	IPv6 Access\-list
                                                                                            	**type**\:  :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                            
                                                                                            .. attribute:: ether_service_acl
                                                                                            
                                                                                            	Ethernet\-Services Access\-list
                                                                                            	**type**\:  :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                            
                                                                                            .. attribute:: avail_id
                                                                                            
                                                                                            	Available Identifiers
                                                                                            	**type**\:  :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                            
                                                                                            .. attribute:: media_type
                                                                                            
                                                                                            	Media Type
                                                                                            	**type**\:  :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                            
                                                                                            .. attribute:: subs_protocol
                                                                                            
                                                                                            	Protocol
                                                                                            	**type**\:  :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                            
                                                                                            .. attribute:: dnis
                                                                                            
                                                                                            	DNIS
                                                                                            	**type**\:  :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                            
                                                                                            .. attribute:: dnis_regex
                                                                                            
                                                                                            	DNIS Regular Expression
                                                                                            	**type**\:  :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                            
                                                                                            .. attribute:: domain
                                                                                            
                                                                                            	Domain Name
                                                                                            	**type**\:  :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                            
                                                                                            .. attribute:: domain_regex
                                                                                            
                                                                                            	Domain Regular Expression
                                                                                            	**type**\:  :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                            
                                                                                            .. attribute:: nas_port
                                                                                            
                                                                                            	NAS Port
                                                                                            	**type**\:  :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                            
                                                                                            .. attribute:: service_name
                                                                                            
                                                                                            	Service Name
                                                                                            	**type**\:  :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                            
                                                                                            .. attribute:: service_name_regex
                                                                                            
                                                                                            	Service Name Regular Exp
                                                                                            	**type**\:  :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv4
                                                                                            
                                                                                            	Source Address IPV4
                                                                                            	**type**\:  :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv4
                                                                                            
                                                                                            	Destination Address IPV4
                                                                                            	**type**\:  :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv6
                                                                                            
                                                                                            	Source Address IPV6
                                                                                            	**type**\:  :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv6
                                                                                            
                                                                                            	Destination Address IPV6
                                                                                            	**type**\:  :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: src_addr_mac
                                                                                            
                                                                                            	Source Address MAC
                                                                                            	**type**\:  :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                            
                                                                                            .. attribute:: timer
                                                                                            
                                                                                            	Timer
                                                                                            	**type**\:  :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                            
                                                                                            .. attribute:: timer_regexp
                                                                                            
                                                                                            	Timer Regular Expression
                                                                                            	**type**\:  :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                            
                                                                                            .. attribute:: tunnel_name
                                                                                            
                                                                                            	Tunnel Name
                                                                                            	**type**\:  :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                            
                                                                                            .. attribute:: tunnel_name_regex
                                                                                            
                                                                                            	Tunnel Name Regular Expression
                                                                                            	**type**\:  :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                            
                                                                                            .. attribute:: user_name
                                                                                            
                                                                                            	User Name
                                                                                            	**type**\:  :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                            
                                                                                            .. attribute:: user_name_regex
                                                                                            
                                                                                            	User Name Regular Expression
                                                                                            	**type**\:  :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                            
                                                                                            .. attribute:: auth_username
                                                                                            
                                                                                            	Authenticated User Name
                                                                                            	**type**\:  :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                            
                                                                                            .. attribute:: auth_username_regex
                                                                                            
                                                                                            	Authenticated User Name RegEx
                                                                                            	**type**\:  :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_username
                                                                                            
                                                                                            	Unauthenticated User Name
                                                                                            	**type**\:  :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                            
                                                                                            .. attribute:: unauth_username_regex
                                                                                            
                                                                                            	Unauthenticated User Name RegEx
                                                                                            	**type**\:  :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: auth_domain
                                                                                            
                                                                                            	Authenticated domain name
                                                                                            	**type**\:  :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                            
                                                                                            .. attribute:: auth_domain_regex
                                                                                            
                                                                                            	Authenticated Domain Name RegEx
                                                                                            	**type**\:  :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_domain
                                                                                            
                                                                                            	Unauthenticated Domain Name
                                                                                            	**type**\:  :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                            
                                                                                            .. attribute:: unauth_domain_regex
                                                                                            
                                                                                            	Unauthenticated Domain Name RegEx
                                                                                            	**type**\:  :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: vendor_id
                                                                                            
                                                                                            	Vendor ID
                                                                                            	**type**\:  :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                            
                                                                                            .. attribute:: vendor_id_regex
                                                                                            
                                                                                            	Vendor ID RegEx
                                                                                            	**type**\:  :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                            
                                                                                            .. attribute:: access_interface
                                                                                            
                                                                                            	Access interface
                                                                                            	**type**\:  :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                            
                                                                                            .. attribute:: input_interface
                                                                                            
                                                                                            	Input interface
                                                                                            	**type**\:  :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                            
                                                                                            .. attribute:: input_intfhdl
                                                                                            
                                                                                            	Input interface handle
                                                                                            	**type**\:  :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                            
                                                                                            .. attribute:: ethertype
                                                                                            
                                                                                            	Ethernet type
                                                                                            	**type**\:  :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                            
                                                                                            .. attribute:: flow_key_data
                                                                                            
                                                                                            	Flow key structure
                                                                                            	**type**\:  :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id
                                                                                            
                                                                                            	Dhcp Client ID
                                                                                            	**type**\:  :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id_regex
                                                                                            
                                                                                            	Dhcp Client ID RegEx
                                                                                            	**type**\:  :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                            
                                                                                            .. attribute:: circuit_id
                                                                                            
                                                                                            	Circuit ID
                                                                                            	**type**\:  :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                            
                                                                                            .. attribute:: circuit_id_regex
                                                                                            
                                                                                            	Circuit ID RegEx
                                                                                            	**type**\:  :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                            
                                                                                            .. attribute:: remote_id
                                                                                            
                                                                                            	Remote ID
                                                                                            	**type**\:  :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                            
                                                                                            .. attribute:: remote_id_regex
                                                                                            
                                                                                            	Remote ID RegEx
                                                                                            	**type**\:  :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                            
                                                                                            .. attribute:: src_port
                                                                                            
                                                                                            	Source port
                                                                                            	**type**\:  :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                            
                                                                                            .. attribute:: dst_port
                                                                                            
                                                                                            	Destination port
                                                                                            	**type**\:  :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	type
                                                                                            	**type**\:  :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                            
                                                                                            .. attribute:: mpls_top_eos
                                                                                            
                                                                                            	MPLS Topmost EOS
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: fragment_type
                                                                                            
                                                                                            	Fragment type
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: authen_status
                                                                                            
                                                                                            	Authentication Status
                                                                                            	**type**\:  :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                            
                                                                                            .. attribute:: mlp_negotiated
                                                                                            
                                                                                            	MLP Negotiated
                                                                                            	**type**\:  :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                                self.yang_name = "match-data"
                                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("ipv4-dscp", ("ipv4_dscp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp)), ("ipv6-dscp", ("ipv6_dscp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp)), ("dscp", ("dscp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp)), ("ipv4-prec", ("ipv4_prec", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec)), ("ipv6-prec", ("ipv6_prec", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec)), ("prec", ("prec", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec)), ("discard-class", ("discard_class", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass)), ("qos-group", ("qos_group", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup)), ("traffic-class", ("traffic_class", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass)), ("proto", ("proto", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto)), ("icmp-v4", ("icmp_v4", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4)), ("icmp-v6", ("icmp_v6", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6)), ("ipv4-packet-len", ("ipv4_packet_len", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen)), ("ipv6-packet-len", ("ipv6_packet_len", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen)), ("packet-len", ("packet_len", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen)), ("flow-tag", ("flow_tag", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag)), ("tcp-flag", ("tcp_flag", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag)), ("icmpv4-type", ("icmpv4_type", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type)), ("icmpv4-code", ("icmpv4_code", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code)), ("icmpv6-type", ("icmpv6_type", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type)), ("icmpv6-code", ("icmpv6_code", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code)), ("mpls-exp", ("mpls_exp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp)), ("mpls-exp-imp", ("mpls_exp_imp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp)), ("mpls-disp-ipv4-acl", ("mpls_disp_ipv4_acl", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl)), ("mpls-disp-ipv6-acl", ("mpls_disp_ipv6_acl", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl)), ("mpls-top-label", ("mpls_top_label", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel)), ("cos", ("cos", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos)), ("cos-inr", ("cos_inr", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr)), ("dei", ("dei", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei)), ("dei-inr", ("dei_inr", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr)), ("vlan", ("vlan", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan)), ("vlan-inr", ("vlan_inr", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)), ("fr-dlci", ("fr_dlci", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci)), ("src-mac", ("src_mac", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac)), ("dst-mac", ("dst_mac", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac)), ("atm-clp", ("atm_clp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp)), ("fr-de", ("fr_de", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe)), ("ipv4-acl", ("ipv4_acl", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl)), ("ipv6-acl", ("ipv6_acl", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl)), ("ether-service-acl", ("ether_service_acl", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl)), ("avail-id", ("avail_id", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId)), ("media-type", ("media_type", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType)), ("subs-protocol", ("subs_protocol", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol)), ("dnis", ("dnis", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis)), ("dnis-regex", ("dnis_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex)), ("domain", ("domain", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain)), ("domain-regex", ("domain_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex)), ("nas-port", ("nas_port", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort)), ("service-name", ("service_name", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName)), ("service-name-regex", ("service_name_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex)), ("src-addr-ipv4", ("src_addr_ipv4", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4)), ("dst-addr-ipv4", ("dst_addr_ipv4", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4)), ("src-addr-ipv6", ("src_addr_ipv6", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6)), ("dst-addr-ipv6", ("dst_addr_ipv6", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6)), ("src-addr-mac", ("src_addr_mac", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac)), ("timer", ("timer", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer)), ("timer-regexp", ("timer_regexp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp)), ("tunnel-name", ("tunnel_name", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName)), ("tunnel-name-regex", ("tunnel_name_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex)), ("user-name", ("user_name", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName)), ("user-name-regex", ("user_name_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex)), ("auth-username", ("auth_username", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername)), ("auth-username-regex", ("auth_username_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex)), ("unauth-username", ("unauth_username", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername)), ("unauth-username-regex", ("unauth_username_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex)), ("auth-domain", ("auth_domain", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain)), ("auth-domain-regex", ("auth_domain_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex)), ("unauth-domain", ("unauth_domain", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain)), ("unauth-domain-regex", ("unauth_domain_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex)), ("vendor-id", ("vendor_id", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId)), ("vendor-id-regex", ("vendor_id_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex)), ("access-interface", ("access_interface", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface)), ("input-interface", ("input_interface", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface)), ("input-intfhdl", ("input_intfhdl", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl)), ("ethertype", ("ethertype", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype)), ("flow-key-data", ("flow_key_data", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData)), ("dhcp-client-id", ("dhcp_client_id", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId)), ("dhcp-client-id-regex", ("dhcp_client_id_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex)), ("circuit-id", ("circuit_id", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId)), ("circuit-id-regex", ("circuit_id_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex)), ("remote-id", ("remote_id", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId)), ("remote-id-regex", ("remote_id_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex)), ("src-port", ("src_port", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort)), ("dst-port", ("dst_port", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort))])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchTypeEn', '')])),
                                                                                                    ('mpls_top_eos', (YLeaf(YType.uint8, 'mpls-top-eos'), ['int'])),
                                                                                                    ('fragment_type', (YLeaf(YType.uint8, 'fragment-type'), ['int'])),
                                                                                                    ('authen_status', (YLeaf(YType.enumeration, 'authen-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchAuthenStatusEn', '')])),
                                                                                                    ('mlp_negotiated', (YLeaf(YType.enumeration, 'mlp-negotiated'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchMlpNegotiatedEn', '')])),
                                                                                                ])
                                                                                                self.type = None
                                                                                                self.mpls_top_eos = None
                                                                                                self.fragment_type = None
                                                                                                self.authen_status = None
                                                                                                self.mlp_negotiated = None

                                                                                                self.ipv4_dscp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                                self.ipv4_dscp.parent = self
                                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"

                                                                                                self.ipv6_dscp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                                self.ipv6_dscp.parent = self
                                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"

                                                                                                self.dscp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                                self.dscp.parent = self
                                                                                                self._children_name_map["dscp"] = "dscp"

                                                                                                self.ipv4_prec = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                                self.ipv4_prec.parent = self
                                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"

                                                                                                self.ipv6_prec = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                                self.ipv6_prec.parent = self
                                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"

                                                                                                self.prec = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                                self.prec.parent = self
                                                                                                self._children_name_map["prec"] = "prec"

                                                                                                self.discard_class = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                                self.discard_class.parent = self
                                                                                                self._children_name_map["discard_class"] = "discard-class"

                                                                                                self.qos_group = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                                self.qos_group.parent = self
                                                                                                self._children_name_map["qos_group"] = "qos-group"

                                                                                                self.traffic_class = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                                self.traffic_class.parent = self
                                                                                                self._children_name_map["traffic_class"] = "traffic-class"

                                                                                                self.proto = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                                self.proto.parent = self
                                                                                                self._children_name_map["proto"] = "proto"

                                                                                                self.icmp_v4 = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                                self.icmp_v4.parent = self
                                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"

                                                                                                self.icmp_v6 = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                                self.icmp_v6.parent = self
                                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"

                                                                                                self.ipv4_packet_len = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                                self.ipv4_packet_len.parent = self
                                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"

                                                                                                self.ipv6_packet_len = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                                self.ipv6_packet_len.parent = self
                                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"

                                                                                                self.packet_len = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                                self.packet_len.parent = self
                                                                                                self._children_name_map["packet_len"] = "packet-len"

                                                                                                self.flow_tag = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                                self.flow_tag.parent = self
                                                                                                self._children_name_map["flow_tag"] = "flow-tag"

                                                                                                self.tcp_flag = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                                self.tcp_flag.parent = self
                                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"

                                                                                                self.icmpv4_type = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                                self.icmpv4_type.parent = self
                                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"

                                                                                                self.icmpv4_code = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                                self.icmpv4_code.parent = self
                                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"

                                                                                                self.icmpv6_type = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                                self.icmpv6_type.parent = self
                                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"

                                                                                                self.icmpv6_code = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                                self.icmpv6_code.parent = self
                                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"

                                                                                                self.mpls_exp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                                self.mpls_exp.parent = self
                                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"

                                                                                                self.mpls_exp_imp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                                self.mpls_exp_imp.parent = self
                                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"

                                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"

                                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"

                                                                                                self.mpls_top_label = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                                self.mpls_top_label.parent = self
                                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"

                                                                                                self.cos = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                                self.cos.parent = self
                                                                                                self._children_name_map["cos"] = "cos"

                                                                                                self.cos_inr = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                                self.cos_inr.parent = self
                                                                                                self._children_name_map["cos_inr"] = "cos-inr"

                                                                                                self.dei = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                                self.dei.parent = self
                                                                                                self._children_name_map["dei"] = "dei"

                                                                                                self.dei_inr = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                                self.dei_inr.parent = self
                                                                                                self._children_name_map["dei_inr"] = "dei-inr"

                                                                                                self.vlan = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                                self.vlan.parent = self
                                                                                                self._children_name_map["vlan"] = "vlan"

                                                                                                self.vlan_inr = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                                self.vlan_inr.parent = self
                                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"

                                                                                                self.fr_dlci = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                                self.fr_dlci.parent = self
                                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"

                                                                                                self.src_mac = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                                self.src_mac.parent = self
                                                                                                self._children_name_map["src_mac"] = "src-mac"

                                                                                                self.dst_mac = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                                self.dst_mac.parent = self
                                                                                                self._children_name_map["dst_mac"] = "dst-mac"

                                                                                                self.atm_clp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                                self.atm_clp.parent = self
                                                                                                self._children_name_map["atm_clp"] = "atm-clp"

                                                                                                self.fr_de = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                                self.fr_de.parent = self
                                                                                                self._children_name_map["fr_de"] = "fr-de"

                                                                                                self.ipv4_acl = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                                self.ipv4_acl.parent = self
                                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"

                                                                                                self.ipv6_acl = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                                self.ipv6_acl.parent = self
                                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"

                                                                                                self.ether_service_acl = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                                self.ether_service_acl.parent = self
                                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"

                                                                                                self.avail_id = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                                self.avail_id.parent = self
                                                                                                self._children_name_map["avail_id"] = "avail-id"

                                                                                                self.media_type = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                                self.media_type.parent = self
                                                                                                self._children_name_map["media_type"] = "media-type"

                                                                                                self.subs_protocol = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                                self.subs_protocol.parent = self
                                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"

                                                                                                self.dnis = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                                self.dnis.parent = self
                                                                                                self._children_name_map["dnis"] = "dnis"

                                                                                                self.dnis_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                                self.dnis_regex.parent = self
                                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"

                                                                                                self.domain = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                                self.domain.parent = self
                                                                                                self._children_name_map["domain"] = "domain"

                                                                                                self.domain_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                                self.domain_regex.parent = self
                                                                                                self._children_name_map["domain_regex"] = "domain-regex"

                                                                                                self.nas_port = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                                self.nas_port.parent = self
                                                                                                self._children_name_map["nas_port"] = "nas-port"

                                                                                                self.service_name = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                                self.service_name.parent = self
                                                                                                self._children_name_map["service_name"] = "service-name"

                                                                                                self.service_name_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                                self.service_name_regex.parent = self
                                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"

                                                                                                self.src_addr_ipv4 = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                                self.src_addr_ipv4.parent = self
                                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"

                                                                                                self.dst_addr_ipv4 = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                                self.dst_addr_ipv4.parent = self
                                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"

                                                                                                self.src_addr_ipv6 = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                                self.src_addr_ipv6.parent = self
                                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"

                                                                                                self.dst_addr_ipv6 = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                                self.dst_addr_ipv6.parent = self
                                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"

                                                                                                self.src_addr_mac = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                                self.src_addr_mac.parent = self
                                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"

                                                                                                self.timer = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                                self.timer.parent = self
                                                                                                self._children_name_map["timer"] = "timer"

                                                                                                self.timer_regexp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                                self.timer_regexp.parent = self
                                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"

                                                                                                self.tunnel_name = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                                self.tunnel_name.parent = self
                                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"

                                                                                                self.tunnel_name_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                                self.tunnel_name_regex.parent = self
                                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"

                                                                                                self.user_name = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                                self.user_name.parent = self
                                                                                                self._children_name_map["user_name"] = "user-name"

                                                                                                self.user_name_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                                self.user_name_regex.parent = self
                                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"

                                                                                                self.auth_username = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                                self.auth_username.parent = self
                                                                                                self._children_name_map["auth_username"] = "auth-username"

                                                                                                self.auth_username_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                                self.auth_username_regex.parent = self
                                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"

                                                                                                self.unauth_username = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                                self.unauth_username.parent = self
                                                                                                self._children_name_map["unauth_username"] = "unauth-username"

                                                                                                self.unauth_username_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                                self.unauth_username_regex.parent = self
                                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"

                                                                                                self.auth_domain = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                                self.auth_domain.parent = self
                                                                                                self._children_name_map["auth_domain"] = "auth-domain"

                                                                                                self.auth_domain_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                                self.auth_domain_regex.parent = self
                                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"

                                                                                                self.unauth_domain = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                                self.unauth_domain.parent = self
                                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"

                                                                                                self.unauth_domain_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                                self.unauth_domain_regex.parent = self
                                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"

                                                                                                self.vendor_id = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                                self.vendor_id.parent = self
                                                                                                self._children_name_map["vendor_id"] = "vendor-id"

                                                                                                self.vendor_id_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                                self.vendor_id_regex.parent = self
                                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"

                                                                                                self.access_interface = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                                self.access_interface.parent = self
                                                                                                self._children_name_map["access_interface"] = "access-interface"

                                                                                                self.input_interface = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                                self.input_interface.parent = self
                                                                                                self._children_name_map["input_interface"] = "input-interface"

                                                                                                self.input_intfhdl = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                                self.input_intfhdl.parent = self
                                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"

                                                                                                self.ethertype = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                                self.ethertype.parent = self
                                                                                                self._children_name_map["ethertype"] = "ethertype"

                                                                                                self.flow_key_data = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                                self.flow_key_data.parent = self
                                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"

                                                                                                self.dhcp_client_id = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                                self.dhcp_client_id.parent = self
                                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"

                                                                                                self.dhcp_client_id_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                                self.dhcp_client_id_regex.parent = self
                                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"

                                                                                                self.circuit_id = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                                self.circuit_id.parent = self
                                                                                                self._children_name_map["circuit_id"] = "circuit-id"

                                                                                                self.circuit_id_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                                self.circuit_id_regex.parent = self
                                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"

                                                                                                self.remote_id = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                                self.remote_id.parent = self
                                                                                                self._children_name_map["remote_id"] = "remote-id"

                                                                                                self.remote_id_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                                self.remote_id_regex.parent = self
                                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"

                                                                                                self.src_port = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                                self.src_port.parent = self
                                                                                                self._children_name_map["src_port"] = "src-port"

                                                                                                self.dst_port = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                                self.dst_port.parent = self
                                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                                self._segment_path = lambda: "match-data"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['type', 'mpls_top_eos', 'fragment_type', 'authen_status', 'mlp_negotiated'], name, value)


                                                                                            class Ipv4Dscp(Entity):
                                                                                                """
                                                                                                IPv4 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv4-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv6Dscp(Entity):
                                                                                                """
                                                                                                IPv6 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv6-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Dscp(Entity):
                                                                                                """
                                                                                                Match DSCP range array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                    self.yang_name = "dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv4Prec(Entity):
                                                                                                """
                                                                                                IPv4 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                    self.yang_name = "ipv4-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "ipv4-prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                            class Ipv6Prec(Entity):
                                                                                                """
                                                                                                IPv6 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                    self.yang_name = "ipv6-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "ipv6-prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                            class Prec(Entity):
                                                                                                """
                                                                                                Match Precedence array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                    self.yang_name = "prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                            class DiscardClass(Entity):
                                                                                                """
                                                                                                Match Discard Class array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                    self.yang_name = "discard-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "discard-class"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                            class QosGroup(Entity):
                                                                                                """
                                                                                                Match QoS group array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                    self.yang_name = "qos-group"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "qos-group"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "qos-group"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class TrafficClass(Entity):
                                                                                                """
                                                                                                Match Traffic class array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                    self.yang_name = "traffic-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "traffic-class"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "traffic-class"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Proto(Entity):
                                                                                                """
                                                                                                Match Protocol array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                    self.yang_name = "proto"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "proto"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "proto"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class IcmpV4(Entity):
                                                                                                """
                                                                                                Match ICMPV4 Protocol
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                    self.yang_name = "icmp-v4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                    ])
                                                                                                    self.type = None
                                                                                                    self.code = None
                                                                                                    self._segment_path = lambda: "icmp-v4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['type', 'code'], name, value)


                                                                                            class IcmpV6(Entity):
                                                                                                """
                                                                                                Match ICMPV6 Protocol array
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                    self.yang_name = "icmp-v6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                    ])
                                                                                                    self.type = None
                                                                                                    self.code = None
                                                                                                    self._segment_path = lambda: "icmp-v6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['type', 'code'], name, value)


                                                                                            class Ipv4PacketLen(Entity):
                                                                                                """
                                                                                                IPv4 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv6PacketLen(Entity):
                                                                                                """
                                                                                                IPv6 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class PacketLen(Entity):
                                                                                                """
                                                                                                Match packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                    self.yang_name = "packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FlowTag(Entity):
                                                                                                """
                                                                                                Match flow\-tag array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                    self.yang_name = "flow-tag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "flow-tag"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "flow-tag"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class TcpFlag(Entity):
                                                                                                """
                                                                                                Match tcp flag value
                                                                                                
                                                                                                .. attribute:: value
                                                                                                
                                                                                                	Value of TCP flag
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: match_any
                                                                                                
                                                                                                	Match any TCP flag bit
                                                                                                	**type**\: bool
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                    self.yang_name = "tcp-flag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                                        ('match_any', (YLeaf(YType.boolean, 'match-any'), ['bool'])),
                                                                                                    ])
                                                                                                    self.value = None
                                                                                                    self.match_any = None
                                                                                                    self._segment_path = lambda: "tcp-flag"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['value', 'match_any'], name, value)


                                                                                            class Icmpv4Type(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                    self.yang_name = "icmpv4-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv4Code(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                    self.yang_name = "icmpv4-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-code"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv6Type(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                    self.yang_name = "icmpv6-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv6Code(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                    self.yang_name = "icmpv6-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-code"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class MplsExp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental topmost array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "mpls-exp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                            class MplsExpImp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental imposition array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "mpls-exp-imp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                            class MplsDispIpv4Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                            class MplsDispIpv6Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                            class MplsTopLabel(Entity):
                                                                                                """
                                                                                                MPLS Topmost LABEL
                                                                                                
                                                                                                .. attribute:: uint32_rng_array
                                                                                                
                                                                                                	uint32 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                    self.yang_name = "mpls-top-label"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint32_rng_array", ("uint32_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint32_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "mpls-top-label"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                                class Uint32RngArray(Entity):
                                                                                                    """
                                                                                                    uint32 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                        self.yang_name = "uint32_rng_array"
                                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint32, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint32, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint32_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['min', 'max'], name, value)


                                                                                            class Cos(Entity):
                                                                                                """
                                                                                                Match CoS array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                    self.yang_name = "cos"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "cos"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                            class CosInr(Entity):
                                                                                                """
                                                                                                Match inner header CoS
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                    self.yang_name = "cos-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "cos-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                            class Dei(Entity):
                                                                                                """
                                                                                                Match DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                    self.yang_name = "dei"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                    ])
                                                                                                    self.bit_value = None
                                                                                                    self._segment_path = lambda: "dei"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                            class DeiInr(Entity):
                                                                                                """
                                                                                                Match inner DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                    self.yang_name = "dei-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                    ])
                                                                                                    self.bit_value = None
                                                                                                    self._segment_path = lambda: "dei-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                            class Vlan(Entity):
                                                                                                """
                                                                                                Match VLAN array
                                                                                                
                                                                                                .. attribute:: vlan_id_array
                                                                                                
                                                                                                	vlan id array
                                                                                                	**type**\: list of  		 :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                    self.yang_name = "vlan"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("vlan-id-array", ("vlan_id_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.vlan_id_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                                class VlanIdArray(Entity):
                                                                                                    """
                                                                                                    vlan id array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	VLAN mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                        self.yang_name = "vlan-id-array"
                                                                                                        self.yang_parent_name = "vlan"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ('mask', (YLeaf(YType.uint16, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "vlan-id-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['min', 'max', 'mask'], name, value)


                                                                                            class VlanInr(Entity):
                                                                                                """
                                                                                                Match inner header VLAN range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                    self.yang_name = "vlan-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FrDlci(Entity):
                                                                                                """
                                                                                                Match FR DLCI range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                    self.yang_name = "fr-dlci"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "fr-dlci"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class SrcMac(Entity):
                                                                                                """
                                                                                                Match Source MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                    self.yang_name = "src-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.mac_addr = []
                                                                                                    self.mask = []
                                                                                                    self._segment_path = lambda: "src-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                            class DstMac(Entity):
                                                                                                """
                                                                                                Match Destination MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                    self.yang_name = "dst-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.mac_addr = []
                                                                                                    self.mask = []
                                                                                                    self._segment_path = lambda: "dst-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                            class AtmClp(Entity):
                                                                                                """
                                                                                                Match ATM CLP level
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                    self.yang_name = "atm-clp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "atm-clp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                            class FrDe(Entity):
                                                                                                """
                                                                                                Match FR DE value
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                    self.yang_name = "fr-de"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "fr-de"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                            class Ipv4Acl(Entity):
                                                                                                """
                                                                                                IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                    self.yang_name = "ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ipv4-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                            class Ipv6Acl(Entity):
                                                                                                """
                                                                                                IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                    self.yang_name = "ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ipv6-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                            class EtherServiceAcl(Entity):
                                                                                                """
                                                                                                Ethernet\-Services Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                    self.yang_name = "ether-service-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ether-service-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                            class AvailId(Entity):
                                                                                                """
                                                                                                Available Identifiers
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                    self.yang_name = "avail-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "avail-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                            class MediaType(Entity):
                                                                                                """
                                                                                                Media Type
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                    self.yang_name = "media-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "media-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                            class SubsProtocol(Entity):
                                                                                                """
                                                                                                Protocol
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                    self.yang_name = "subs-protocol"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "subs-protocol"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                            class Dnis(Entity):
                                                                                                """
                                                                                                DNIS
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                    self.yang_name = "dnis"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dnis"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                            class DnisRegex(Entity):
                                                                                                """
                                                                                                DNIS Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                    self.yang_name = "dnis-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dnis-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                            class Domain(Entity):
                                                                                                """
                                                                                                Domain Name
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                    self.yang_name = "domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                        ])
                                                                                                        self.domain_name = None
                                                                                                        self.format_name = None
                                                                                                        self._segment_path = lambda: "domain-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class DomainRegex(Entity):
                                                                                                """
                                                                                                Domain Regular Expression
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                    self.yang_name = "domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain-regex"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                        ])
                                                                                                        self.domain_name = None
                                                                                                        self.format_name = None
                                                                                                        self._segment_path = lambda: "domain-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class NasPort(Entity):
                                                                                                """
                                                                                                NAS Port
                                                                                                
                                                                                                .. attribute:: nas_port_array
                                                                                                
                                                                                                	nas port array
                                                                                                	**type**\: list of  		 :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                    self.yang_name = "nas-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("nas-port-array", ("nas_port_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.nas_port_array = YList(self)
                                                                                                    self._segment_path = lambda: "nas-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                                class NasPortArray(Entity):
                                                                                                    """
                                                                                                    nas port array
                                                                                                    
                                                                                                    .. attribute:: sub_id
                                                                                                    
                                                                                                    	sub id
                                                                                                    	**type**\:  :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                    
                                                                                                    .. attribute:: operator
                                                                                                    
                                                                                                    	operator
                                                                                                    	**type**\:  :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	value
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                        self.yang_name = "nas-port-array"
                                                                                                        self.yang_parent_name = "nas-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('sub_id', (YLeaf(YType.enumeration, 'sub-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchNasPortSubIdEn', '')])),
                                                                                                            ('operator', (YLeaf(YType.enumeration, 'operator'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchLogicalOperatorEn', '')])),
                                                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                                        ])
                                                                                                        self.sub_id = None
                                                                                                        self.operator = None
                                                                                                        self.value = None
                                                                                                        self._segment_path = lambda: "nas-port-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['sub_id', 'operator', 'value'], name, value)


                                                                                            class ServiceName(Entity):
                                                                                                """
                                                                                                Service Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                    self.yang_name = "service-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "service-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                            class ServiceNameRegex(Entity):
                                                                                                """
                                                                                                Service Name Regular Exp
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                    self.yang_name = "service-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "service-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                            class SrcAddrIpv4(Entity):
                                                                                                """
                                                                                                Source Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class DstAddrIpv4(Entity):
                                                                                                """
                                                                                                Destination Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class SrcAddrIpv6(Entity):
                                                                                                """
                                                                                                Source Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class DstAddrIpv6(Entity):
                                                                                                """
                                                                                                Destination Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class SrcAddrMac(Entity):
                                                                                                """
                                                                                                Source Address MAC
                                                                                                
                                                                                                .. attribute:: mac_addr_array
                                                                                                
                                                                                                	mac addr array
                                                                                                	**type**\: list of  		 :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                    self.yang_name = "src-addr-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("mac-addr-array", ("mac_addr_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.mac_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                                class MacAddrArray(Entity):
                                                                                                    """
                                                                                                    mac addr array
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                        self.yang_name = "mac-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                            ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.mac_addr = []
                                                                                                        self.mask = []
                                                                                                        self._segment_path = lambda: "mac-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                            class Timer(Entity):
                                                                                                """
                                                                                                Timer
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                    self.yang_name = "timer"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "timer"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                            class TimerRegexp(Entity):
                                                                                                """
                                                                                                Timer Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                    self.yang_name = "timer-regexp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "timer-regexp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                            class TunnelName(Entity):
                                                                                                """
                                                                                                Tunnel Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                    self.yang_name = "tunnel-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "tunnel-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                            class TunnelNameRegex(Entity):
                                                                                                """
                                                                                                Tunnel Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "tunnel-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                            class UserName(Entity):
                                                                                                """
                                                                                                User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                    self.yang_name = "user-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "user-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                            class UserNameRegex(Entity):
                                                                                                """
                                                                                                User Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                    self.yang_name = "user-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "user-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                            class AuthUsername(Entity):
                                                                                                """
                                                                                                Authenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                    self.yang_name = "auth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-username"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                            class AuthUsernameRegex(Entity):
                                                                                                """
                                                                                                Authenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "auth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-username-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                            class UnauthUsername(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                    self.yang_name = "unauth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-username"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                            class UnauthUsernameRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-username-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                            class AuthDomain(Entity):
                                                                                                """
                                                                                                Authenticated domain name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                    self.yang_name = "auth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                            class AuthDomainRegex(Entity):
                                                                                                """
                                                                                                Authenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "auth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                            class UnauthDomain(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                    self.yang_name = "unauth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                            class UnauthDomainRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                            class VendorId(Entity):
                                                                                                """
                                                                                                Vendor ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                    self.yang_name = "vendor-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "vendor-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                            class VendorIdRegex(Entity):
                                                                                                """
                                                                                                Vendor ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                    self.yang_name = "vendor-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "vendor-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                            class AccessInterface(Entity):
                                                                                                """
                                                                                                Access interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                    self.yang_name = "access-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "access-interface"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                            class InputInterface(Entity):
                                                                                                """
                                                                                                Input interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                    self.yang_name = "input-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "input-interface"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                            class InputIntfhdl(Entity):
                                                                                                """
                                                                                                Input interface handle
                                                                                                
                                                                                                .. attribute:: uint64_array
                                                                                                
                                                                                                	uint64 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..18446744073709551615
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                    self.yang_name = "input-intfhdl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint64_array', (YLeafList(YType.uint64, 'uint64_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint64_array = []
                                                                                                    self._segment_path = lambda: "input-intfhdl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                            class Ethertype(Entity):
                                                                                                """
                                                                                                Ethernet type
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                    self.yang_name = "ethertype"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ethertype"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ethertype"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FlowKeyData(Entity):
                                                                                                """
                                                                                                Flow key structure
                                                                                                
                                                                                                .. attribute:: flow_keys
                                                                                                
                                                                                                	flow keys
                                                                                                	**type**\:  :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                                
                                                                                                .. attribute:: max_count
                                                                                                
                                                                                                	Maximum count of flows
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: idle_timeout
                                                                                                
                                                                                                	Idle timeout of flows (in seconds)
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                	**units**\: second
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                    self.yang_name = "flow-key-data"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("flow-keys", ("flow_keys", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys))])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('max_count', (YLeaf(YType.uint16, 'max-count'), ['int'])),
                                                                                                        ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                                                    ])
                                                                                                    self.max_count = None
                                                                                                    self.idle_timeout = None

                                                                                                    self.flow_keys = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                    self.flow_keys.parent = self
                                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                    self._segment_path = lambda: "flow-key-data"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['max_count', 'idle_timeout'], name, value)


                                                                                                class FlowKeys(Entity):
                                                                                                    """
                                                                                                    flow keys
                                                                                                    
                                                                                                    .. attribute:: keys
                                                                                                    
                                                                                                    	keys
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                    
                                                                                                    .. attribute:: num
                                                                                                    
                                                                                                    	num
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                        self.yang_name = "flow-keys"
                                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('keys', (YLeaf(YType.str, 'keys'), ['str'])),
                                                                                                            ('num', (YLeaf(YType.uint8, 'num'), ['int'])),
                                                                                                        ])
                                                                                                        self.keys = None
                                                                                                        self.num = None
                                                                                                        self._segment_path = lambda: "flow-keys"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                            class DhcpClientId(Entity):
                                                                                                """
                                                                                                Dhcp Client ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dhcp-client-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                            class DhcpClientIdRegex(Entity):
                                                                                                """
                                                                                                Dhcp Client ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                            class CircuitId(Entity):
                                                                                                """
                                                                                                Circuit ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                    self.yang_name = "circuit-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "circuit-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                            class CircuitIdRegex(Entity):
                                                                                                """
                                                                                                Circuit ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                    self.yang_name = "circuit-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "circuit-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                            class RemoteId(Entity):
                                                                                                """
                                                                                                Remote ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                    self.yang_name = "remote-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "remote-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                            class RemoteIdRegex(Entity):
                                                                                                """
                                                                                                Remote ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                    self.yang_name = "remote-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "remote-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                            class SrcPort(Entity):
                                                                                                """
                                                                                                Source port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                    self.yang_name = "src-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "src-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class DstPort(Entity):
                                                                                                """
                                                                                                Destination port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                    self.yang_name = "dst-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "dst-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                        class ExcdclassEncode(Entity):
                                                                            """
                                                                            excdclass encode
                                                                            
                                                                            .. attribute:: inline_cmap
                                                                            
                                                                            	inline cmap
                                                                            	**type**\:  :py:class:`InlineCmap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap>`
                                                                            
                                                                            .. attribute:: enc
                                                                            
                                                                            	enc
                                                                            	**type**\:  :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                            
                                                                            .. attribute:: class_name
                                                                            
                                                                            	class name
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..65
                                                                            
                                                                            .. attribute:: hd
                                                                            
                                                                            	hd
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: idx
                                                                            
                                                                            	idx
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode, self).__init__()

                                                                                self.yang_name = "excdclass-encode"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("inline-cmap", ("inline_cmap", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('enc', (YLeaf(YType.enumeration, 'enc'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyObjEncEn', '')])),
                                                                                    ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                                                    ('hd', (YLeaf(YType.uint64, 'hd'), ['int'])),
                                                                                    ('idx', (YLeaf(YType.uint8, 'idx'), ['int'])),
                                                                                ])
                                                                                self.enc = None
                                                                                self.class_name = None
                                                                                self.hd = None
                                                                                self.idx = None

                                                                                self.inline_cmap = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap()
                                                                                self.inline_cmap.parent = self
                                                                                self._children_name_map["inline_cmap"] = "inline-cmap"
                                                                                self._segment_path = lambda: "excdclass-encode"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode, ['enc', 'class_name', 'hd', 'idx'], name, value)


                                                                            class InlineCmap(Entity):
                                                                                """
                                                                                inline cmap
                                                                                
                                                                                .. attribute:: match_infop
                                                                                
                                                                                	Pointer to the first Match info
                                                                                	**type**\:  :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop>`
                                                                                
                                                                                .. attribute:: mode
                                                                                
                                                                                	Inline Class\-Map Mode Match any/all
                                                                                	**type**\:  :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                                
                                                                                .. attribute:: flags
                                                                                
                                                                                	Inline Class\-Map flags
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: match_count
                                                                                
                                                                                	Number of Match infos
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap, self).__init__()

                                                                                    self.yang_name = "inline-cmap"
                                                                                    self.yang_parent_name = "excdclass-encode"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("match-infop", ("match_infop", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapModeEn', '')])),
                                                                                        ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                        ('match_count', (YLeaf(YType.uint32, 'match-count'), ['int'])),
                                                                                    ])
                                                                                    self.mode = None
                                                                                    self.flags = None
                                                                                    self.match_count = None

                                                                                    self.match_infop = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop()
                                                                                    self.match_infop.parent = self
                                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                                    self._segment_path = lambda: "inline-cmap"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap, ['mode', 'flags', 'match_count'], name, value)


                                                                                class MatchInfop(Entity):
                                                                                    """
                                                                                    Pointer to the first Match info
                                                                                    
                                                                                    .. attribute:: class_match_info_st
                                                                                    
                                                                                    	class match info st
                                                                                    	**type**\: list of  		 :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop, self).__init__()

                                                                                        self.yang_name = "match-infop"
                                                                                        self.yang_parent_name = "inline-cmap"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("class-match-info-st", ("class_match_info_st", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.class_match_info_st = YList(self)
                                                                                        self._segment_path = lambda: "match-infop"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop, [], name, value)


                                                                                    class ClassMatchInfoSt(Entity):
                                                                                        """
                                                                                        class match info st
                                                                                        
                                                                                        .. attribute:: match_data
                                                                                        
                                                                                        	Match criteria
                                                                                        	**type**\:  :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                        
                                                                                        .. attribute:: flags
                                                                                        
                                                                                        	Flags
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                            self.yang_name = "class-match-info-st"
                                                                                            self.yang_parent_name = "match-infop"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("match-data", ("match_data", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData))])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                            ])
                                                                                            self.flags = None

                                                                                            self.match_data = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                            self.match_data.parent = self
                                                                                            self._children_name_map["match_data"] = "match-data"
                                                                                            self._segment_path = lambda: "class-match-info-st"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                        class MatchData(Entity):
                                                                                            """
                                                                                            Match criteria
                                                                                            
                                                                                            .. attribute:: ipv4_dscp
                                                                                            
                                                                                            	IPv4 DSCP
                                                                                            	**type**\:  :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv6_dscp
                                                                                            
                                                                                            	IPv6 DSCP
                                                                                            	**type**\:  :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                            
                                                                                            .. attribute:: dscp
                                                                                            
                                                                                            	Match DSCP range array
                                                                                            	**type**\:  :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv4_prec
                                                                                            
                                                                                            	IPv4 Precedence
                                                                                            	**type**\:  :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                            
                                                                                            .. attribute:: ipv6_prec
                                                                                            
                                                                                            	IPv6 Precedence
                                                                                            	**type**\:  :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                            
                                                                                            .. attribute:: prec
                                                                                            
                                                                                            	Match Precedence array
                                                                                            	**type**\:  :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                            
                                                                                            .. attribute:: discard_class
                                                                                            
                                                                                            	Match Discard Class array
                                                                                            	**type**\:  :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                            
                                                                                            .. attribute:: qos_group
                                                                                            
                                                                                            	Match QoS group array
                                                                                            	**type**\:  :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                            
                                                                                            .. attribute:: traffic_class
                                                                                            
                                                                                            	Match Traffic class array
                                                                                            	**type**\:  :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                            
                                                                                            .. attribute:: proto
                                                                                            
                                                                                            	Match Protocol array
                                                                                            	**type**\:  :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                            
                                                                                            .. attribute:: icmp_v4
                                                                                            
                                                                                            	Match ICMPV4 Protocol
                                                                                            	**type**\:  :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                            
                                                                                            .. attribute:: icmp_v6
                                                                                            
                                                                                            	Match ICMPV6 Protocol array
                                                                                            	**type**\:  :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                            
                                                                                            .. attribute:: ipv4_packet_len
                                                                                            
                                                                                            	IPv4 packet length array
                                                                                            	**type**\:  :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv6_packet_len
                                                                                            
                                                                                            	IPv6 packet length array
                                                                                            	**type**\:  :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                            
                                                                                            .. attribute:: packet_len
                                                                                            
                                                                                            	Match packet length array
                                                                                            	**type**\:  :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                            
                                                                                            .. attribute:: flow_tag
                                                                                            
                                                                                            	Match flow\-tag array
                                                                                            	**type**\:  :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                            
                                                                                            .. attribute:: tcp_flag
                                                                                            
                                                                                            	Match tcp flag value
                                                                                            	**type**\:  :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                            
                                                                                            .. attribute:: icmpv4_type
                                                                                            
                                                                                            	Match ipv4 icmp type
                                                                                            	**type**\:  :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                            
                                                                                            .. attribute:: icmpv4_code
                                                                                            
                                                                                            	Match ipv4 icmp code
                                                                                            	**type**\:  :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                            
                                                                                            .. attribute:: icmpv6_type
                                                                                            
                                                                                            	Match ipv6 icmp type
                                                                                            	**type**\:  :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                            
                                                                                            .. attribute:: icmpv6_code
                                                                                            
                                                                                            	Match ipv6 icmp code
                                                                                            	**type**\:  :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                            
                                                                                            .. attribute:: mpls_exp
                                                                                            
                                                                                            	Match MPLS experimental topmost array
                                                                                            	**type**\:  :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                            
                                                                                            .. attribute:: mpls_exp_imp
                                                                                            
                                                                                            	Match MPLS experimental imposition array
                                                                                            	**type**\:  :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                                            
                                                                                            	MPLS Disposition IPv4 Access\-list
                                                                                            	**type**\:  :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                                            
                                                                                            	MPLS Disposition IPv6 Access\-list
                                                                                            	**type**\:  :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_top_label
                                                                                            
                                                                                            	MPLS Topmost LABEL
                                                                                            	**type**\:  :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                            
                                                                                            .. attribute:: cos
                                                                                            
                                                                                            	Match CoS array
                                                                                            	**type**\:  :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                            
                                                                                            .. attribute:: cos_inr
                                                                                            
                                                                                            	Match inner header CoS
                                                                                            	**type**\:  :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                            
                                                                                            .. attribute:: dei
                                                                                            
                                                                                            	Match DEI Bit
                                                                                            	**type**\:  :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                            
                                                                                            .. attribute:: dei_inr
                                                                                            
                                                                                            	Match inner DEI Bit
                                                                                            	**type**\:  :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                            
                                                                                            .. attribute:: vlan
                                                                                            
                                                                                            	Match VLAN array
                                                                                            	**type**\:  :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                            
                                                                                            .. attribute:: vlan_inr
                                                                                            
                                                                                            	Match inner header VLAN range array
                                                                                            	**type**\:  :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                            
                                                                                            .. attribute:: fr_dlci
                                                                                            
                                                                                            	Match FR DLCI range array
                                                                                            	**type**\:  :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                            
                                                                                            .. attribute:: src_mac
                                                                                            
                                                                                            	Match Source MAC address
                                                                                            	**type**\:  :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                            
                                                                                            .. attribute:: dst_mac
                                                                                            
                                                                                            	Match Destination MAC address
                                                                                            	**type**\:  :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                            
                                                                                            .. attribute:: atm_clp
                                                                                            
                                                                                            	Match ATM CLP level
                                                                                            	**type**\:  :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                            
                                                                                            .. attribute:: fr_de
                                                                                            
                                                                                            	Match FR DE value
                                                                                            	**type**\:  :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                            
                                                                                            .. attribute:: ipv4_acl
                                                                                            
                                                                                            	IPv4 Access\-list
                                                                                            	**type**\:  :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                            
                                                                                            .. attribute:: ipv6_acl
                                                                                            
                                                                                            	IPv6 Access\-list
                                                                                            	**type**\:  :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                            
                                                                                            .. attribute:: ether_service_acl
                                                                                            
                                                                                            	Ethernet\-Services Access\-list
                                                                                            	**type**\:  :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                            
                                                                                            .. attribute:: avail_id
                                                                                            
                                                                                            	Available Identifiers
                                                                                            	**type**\:  :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                            
                                                                                            .. attribute:: media_type
                                                                                            
                                                                                            	Media Type
                                                                                            	**type**\:  :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                            
                                                                                            .. attribute:: subs_protocol
                                                                                            
                                                                                            	Protocol
                                                                                            	**type**\:  :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                            
                                                                                            .. attribute:: dnis
                                                                                            
                                                                                            	DNIS
                                                                                            	**type**\:  :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                            
                                                                                            .. attribute:: dnis_regex
                                                                                            
                                                                                            	DNIS Regular Expression
                                                                                            	**type**\:  :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                            
                                                                                            .. attribute:: domain
                                                                                            
                                                                                            	Domain Name
                                                                                            	**type**\:  :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                            
                                                                                            .. attribute:: domain_regex
                                                                                            
                                                                                            	Domain Regular Expression
                                                                                            	**type**\:  :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                            
                                                                                            .. attribute:: nas_port
                                                                                            
                                                                                            	NAS Port
                                                                                            	**type**\:  :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                            
                                                                                            .. attribute:: service_name
                                                                                            
                                                                                            	Service Name
                                                                                            	**type**\:  :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                            
                                                                                            .. attribute:: service_name_regex
                                                                                            
                                                                                            	Service Name Regular Exp
                                                                                            	**type**\:  :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv4
                                                                                            
                                                                                            	Source Address IPV4
                                                                                            	**type**\:  :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv4
                                                                                            
                                                                                            	Destination Address IPV4
                                                                                            	**type**\:  :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv6
                                                                                            
                                                                                            	Source Address IPV6
                                                                                            	**type**\:  :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv6
                                                                                            
                                                                                            	Destination Address IPV6
                                                                                            	**type**\:  :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: src_addr_mac
                                                                                            
                                                                                            	Source Address MAC
                                                                                            	**type**\:  :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                            
                                                                                            .. attribute:: timer
                                                                                            
                                                                                            	Timer
                                                                                            	**type**\:  :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                            
                                                                                            .. attribute:: timer_regexp
                                                                                            
                                                                                            	Timer Regular Expression
                                                                                            	**type**\:  :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                            
                                                                                            .. attribute:: tunnel_name
                                                                                            
                                                                                            	Tunnel Name
                                                                                            	**type**\:  :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                            
                                                                                            .. attribute:: tunnel_name_regex
                                                                                            
                                                                                            	Tunnel Name Regular Expression
                                                                                            	**type**\:  :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                            
                                                                                            .. attribute:: user_name
                                                                                            
                                                                                            	User Name
                                                                                            	**type**\:  :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                            
                                                                                            .. attribute:: user_name_regex
                                                                                            
                                                                                            	User Name Regular Expression
                                                                                            	**type**\:  :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                            
                                                                                            .. attribute:: auth_username
                                                                                            
                                                                                            	Authenticated User Name
                                                                                            	**type**\:  :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                            
                                                                                            .. attribute:: auth_username_regex
                                                                                            
                                                                                            	Authenticated User Name RegEx
                                                                                            	**type**\:  :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_username
                                                                                            
                                                                                            	Unauthenticated User Name
                                                                                            	**type**\:  :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                            
                                                                                            .. attribute:: unauth_username_regex
                                                                                            
                                                                                            	Unauthenticated User Name RegEx
                                                                                            	**type**\:  :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: auth_domain
                                                                                            
                                                                                            	Authenticated domain name
                                                                                            	**type**\:  :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                            
                                                                                            .. attribute:: auth_domain_regex
                                                                                            
                                                                                            	Authenticated Domain Name RegEx
                                                                                            	**type**\:  :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_domain
                                                                                            
                                                                                            	Unauthenticated Domain Name
                                                                                            	**type**\:  :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                            
                                                                                            .. attribute:: unauth_domain_regex
                                                                                            
                                                                                            	Unauthenticated Domain Name RegEx
                                                                                            	**type**\:  :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: vendor_id
                                                                                            
                                                                                            	Vendor ID
                                                                                            	**type**\:  :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                            
                                                                                            .. attribute:: vendor_id_regex
                                                                                            
                                                                                            	Vendor ID RegEx
                                                                                            	**type**\:  :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                            
                                                                                            .. attribute:: access_interface
                                                                                            
                                                                                            	Access interface
                                                                                            	**type**\:  :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                            
                                                                                            .. attribute:: input_interface
                                                                                            
                                                                                            	Input interface
                                                                                            	**type**\:  :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                            
                                                                                            .. attribute:: input_intfhdl
                                                                                            
                                                                                            	Input interface handle
                                                                                            	**type**\:  :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                            
                                                                                            .. attribute:: ethertype
                                                                                            
                                                                                            	Ethernet type
                                                                                            	**type**\:  :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                            
                                                                                            .. attribute:: flow_key_data
                                                                                            
                                                                                            	Flow key structure
                                                                                            	**type**\:  :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id
                                                                                            
                                                                                            	Dhcp Client ID
                                                                                            	**type**\:  :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id_regex
                                                                                            
                                                                                            	Dhcp Client ID RegEx
                                                                                            	**type**\:  :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                            
                                                                                            .. attribute:: circuit_id
                                                                                            
                                                                                            	Circuit ID
                                                                                            	**type**\:  :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                            
                                                                                            .. attribute:: circuit_id_regex
                                                                                            
                                                                                            	Circuit ID RegEx
                                                                                            	**type**\:  :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                            
                                                                                            .. attribute:: remote_id
                                                                                            
                                                                                            	Remote ID
                                                                                            	**type**\:  :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                            
                                                                                            .. attribute:: remote_id_regex
                                                                                            
                                                                                            	Remote ID RegEx
                                                                                            	**type**\:  :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                            
                                                                                            .. attribute:: src_port
                                                                                            
                                                                                            	Source port
                                                                                            	**type**\:  :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                            
                                                                                            .. attribute:: dst_port
                                                                                            
                                                                                            	Destination port
                                                                                            	**type**\:  :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	type
                                                                                            	**type**\:  :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                            
                                                                                            .. attribute:: mpls_top_eos
                                                                                            
                                                                                            	MPLS Topmost EOS
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: fragment_type
                                                                                            
                                                                                            	Fragment type
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: authen_status
                                                                                            
                                                                                            	Authentication Status
                                                                                            	**type**\:  :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                            
                                                                                            .. attribute:: mlp_negotiated
                                                                                            
                                                                                            	MLP Negotiated
                                                                                            	**type**\:  :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                                self.yang_name = "match-data"
                                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("ipv4-dscp", ("ipv4_dscp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp)), ("ipv6-dscp", ("ipv6_dscp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp)), ("dscp", ("dscp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp)), ("ipv4-prec", ("ipv4_prec", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec)), ("ipv6-prec", ("ipv6_prec", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec)), ("prec", ("prec", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec)), ("discard-class", ("discard_class", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass)), ("qos-group", ("qos_group", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup)), ("traffic-class", ("traffic_class", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass)), ("proto", ("proto", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto)), ("icmp-v4", ("icmp_v4", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4)), ("icmp-v6", ("icmp_v6", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6)), ("ipv4-packet-len", ("ipv4_packet_len", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen)), ("ipv6-packet-len", ("ipv6_packet_len", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen)), ("packet-len", ("packet_len", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen)), ("flow-tag", ("flow_tag", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag)), ("tcp-flag", ("tcp_flag", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag)), ("icmpv4-type", ("icmpv4_type", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type)), ("icmpv4-code", ("icmpv4_code", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code)), ("icmpv6-type", ("icmpv6_type", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type)), ("icmpv6-code", ("icmpv6_code", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code)), ("mpls-exp", ("mpls_exp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp)), ("mpls-exp-imp", ("mpls_exp_imp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp)), ("mpls-disp-ipv4-acl", ("mpls_disp_ipv4_acl", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl)), ("mpls-disp-ipv6-acl", ("mpls_disp_ipv6_acl", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl)), ("mpls-top-label", ("mpls_top_label", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel)), ("cos", ("cos", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos)), ("cos-inr", ("cos_inr", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr)), ("dei", ("dei", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei)), ("dei-inr", ("dei_inr", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr)), ("vlan", ("vlan", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan)), ("vlan-inr", ("vlan_inr", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)), ("fr-dlci", ("fr_dlci", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci)), ("src-mac", ("src_mac", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac)), ("dst-mac", ("dst_mac", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac)), ("atm-clp", ("atm_clp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp)), ("fr-de", ("fr_de", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe)), ("ipv4-acl", ("ipv4_acl", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl)), ("ipv6-acl", ("ipv6_acl", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl)), ("ether-service-acl", ("ether_service_acl", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl)), ("avail-id", ("avail_id", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId)), ("media-type", ("media_type", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType)), ("subs-protocol", ("subs_protocol", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol)), ("dnis", ("dnis", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis)), ("dnis-regex", ("dnis_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex)), ("domain", ("domain", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain)), ("domain-regex", ("domain_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex)), ("nas-port", ("nas_port", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort)), ("service-name", ("service_name", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName)), ("service-name-regex", ("service_name_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex)), ("src-addr-ipv4", ("src_addr_ipv4", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4)), ("dst-addr-ipv4", ("dst_addr_ipv4", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4)), ("src-addr-ipv6", ("src_addr_ipv6", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6)), ("dst-addr-ipv6", ("dst_addr_ipv6", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6)), ("src-addr-mac", ("src_addr_mac", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac)), ("timer", ("timer", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer)), ("timer-regexp", ("timer_regexp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp)), ("tunnel-name", ("tunnel_name", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName)), ("tunnel-name-regex", ("tunnel_name_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex)), ("user-name", ("user_name", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName)), ("user-name-regex", ("user_name_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex)), ("auth-username", ("auth_username", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername)), ("auth-username-regex", ("auth_username_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex)), ("unauth-username", ("unauth_username", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername)), ("unauth-username-regex", ("unauth_username_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex)), ("auth-domain", ("auth_domain", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain)), ("auth-domain-regex", ("auth_domain_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex)), ("unauth-domain", ("unauth_domain", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain)), ("unauth-domain-regex", ("unauth_domain_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex)), ("vendor-id", ("vendor_id", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId)), ("vendor-id-regex", ("vendor_id_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex)), ("access-interface", ("access_interface", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface)), ("input-interface", ("input_interface", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface)), ("input-intfhdl", ("input_intfhdl", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl)), ("ethertype", ("ethertype", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype)), ("flow-key-data", ("flow_key_data", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData)), ("dhcp-client-id", ("dhcp_client_id", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId)), ("dhcp-client-id-regex", ("dhcp_client_id_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex)), ("circuit-id", ("circuit_id", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId)), ("circuit-id-regex", ("circuit_id_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex)), ("remote-id", ("remote_id", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId)), ("remote-id-regex", ("remote_id_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex)), ("src-port", ("src_port", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort)), ("dst-port", ("dst_port", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort))])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchTypeEn', '')])),
                                                                                                    ('mpls_top_eos', (YLeaf(YType.uint8, 'mpls-top-eos'), ['int'])),
                                                                                                    ('fragment_type', (YLeaf(YType.uint8, 'fragment-type'), ['int'])),
                                                                                                    ('authen_status', (YLeaf(YType.enumeration, 'authen-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchAuthenStatusEn', '')])),
                                                                                                    ('mlp_negotiated', (YLeaf(YType.enumeration, 'mlp-negotiated'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchMlpNegotiatedEn', '')])),
                                                                                                ])
                                                                                                self.type = None
                                                                                                self.mpls_top_eos = None
                                                                                                self.fragment_type = None
                                                                                                self.authen_status = None
                                                                                                self.mlp_negotiated = None

                                                                                                self.ipv4_dscp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                                self.ipv4_dscp.parent = self
                                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"

                                                                                                self.ipv6_dscp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                                self.ipv6_dscp.parent = self
                                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"

                                                                                                self.dscp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                                self.dscp.parent = self
                                                                                                self._children_name_map["dscp"] = "dscp"

                                                                                                self.ipv4_prec = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                                self.ipv4_prec.parent = self
                                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"

                                                                                                self.ipv6_prec = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                                self.ipv6_prec.parent = self
                                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"

                                                                                                self.prec = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                                self.prec.parent = self
                                                                                                self._children_name_map["prec"] = "prec"

                                                                                                self.discard_class = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                                self.discard_class.parent = self
                                                                                                self._children_name_map["discard_class"] = "discard-class"

                                                                                                self.qos_group = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                                self.qos_group.parent = self
                                                                                                self._children_name_map["qos_group"] = "qos-group"

                                                                                                self.traffic_class = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                                self.traffic_class.parent = self
                                                                                                self._children_name_map["traffic_class"] = "traffic-class"

                                                                                                self.proto = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                                self.proto.parent = self
                                                                                                self._children_name_map["proto"] = "proto"

                                                                                                self.icmp_v4 = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                                self.icmp_v4.parent = self
                                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"

                                                                                                self.icmp_v6 = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                                self.icmp_v6.parent = self
                                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"

                                                                                                self.ipv4_packet_len = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                                self.ipv4_packet_len.parent = self
                                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"

                                                                                                self.ipv6_packet_len = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                                self.ipv6_packet_len.parent = self
                                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"

                                                                                                self.packet_len = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                                self.packet_len.parent = self
                                                                                                self._children_name_map["packet_len"] = "packet-len"

                                                                                                self.flow_tag = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                                self.flow_tag.parent = self
                                                                                                self._children_name_map["flow_tag"] = "flow-tag"

                                                                                                self.tcp_flag = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                                self.tcp_flag.parent = self
                                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"

                                                                                                self.icmpv4_type = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                                self.icmpv4_type.parent = self
                                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"

                                                                                                self.icmpv4_code = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                                self.icmpv4_code.parent = self
                                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"

                                                                                                self.icmpv6_type = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                                self.icmpv6_type.parent = self
                                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"

                                                                                                self.icmpv6_code = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                                self.icmpv6_code.parent = self
                                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"

                                                                                                self.mpls_exp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                                self.mpls_exp.parent = self
                                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"

                                                                                                self.mpls_exp_imp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                                self.mpls_exp_imp.parent = self
                                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"

                                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"

                                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"

                                                                                                self.mpls_top_label = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                                self.mpls_top_label.parent = self
                                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"

                                                                                                self.cos = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                                self.cos.parent = self
                                                                                                self._children_name_map["cos"] = "cos"

                                                                                                self.cos_inr = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                                self.cos_inr.parent = self
                                                                                                self._children_name_map["cos_inr"] = "cos-inr"

                                                                                                self.dei = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                                self.dei.parent = self
                                                                                                self._children_name_map["dei"] = "dei"

                                                                                                self.dei_inr = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                                self.dei_inr.parent = self
                                                                                                self._children_name_map["dei_inr"] = "dei-inr"

                                                                                                self.vlan = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                                self.vlan.parent = self
                                                                                                self._children_name_map["vlan"] = "vlan"

                                                                                                self.vlan_inr = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                                self.vlan_inr.parent = self
                                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"

                                                                                                self.fr_dlci = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                                self.fr_dlci.parent = self
                                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"

                                                                                                self.src_mac = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                                self.src_mac.parent = self
                                                                                                self._children_name_map["src_mac"] = "src-mac"

                                                                                                self.dst_mac = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                                self.dst_mac.parent = self
                                                                                                self._children_name_map["dst_mac"] = "dst-mac"

                                                                                                self.atm_clp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                                self.atm_clp.parent = self
                                                                                                self._children_name_map["atm_clp"] = "atm-clp"

                                                                                                self.fr_de = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                                self.fr_de.parent = self
                                                                                                self._children_name_map["fr_de"] = "fr-de"

                                                                                                self.ipv4_acl = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                                self.ipv4_acl.parent = self
                                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"

                                                                                                self.ipv6_acl = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                                self.ipv6_acl.parent = self
                                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"

                                                                                                self.ether_service_acl = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                                self.ether_service_acl.parent = self
                                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"

                                                                                                self.avail_id = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                                self.avail_id.parent = self
                                                                                                self._children_name_map["avail_id"] = "avail-id"

                                                                                                self.media_type = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                                self.media_type.parent = self
                                                                                                self._children_name_map["media_type"] = "media-type"

                                                                                                self.subs_protocol = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                                self.subs_protocol.parent = self
                                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"

                                                                                                self.dnis = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                                self.dnis.parent = self
                                                                                                self._children_name_map["dnis"] = "dnis"

                                                                                                self.dnis_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                                self.dnis_regex.parent = self
                                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"

                                                                                                self.domain = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                                self.domain.parent = self
                                                                                                self._children_name_map["domain"] = "domain"

                                                                                                self.domain_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                                self.domain_regex.parent = self
                                                                                                self._children_name_map["domain_regex"] = "domain-regex"

                                                                                                self.nas_port = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                                self.nas_port.parent = self
                                                                                                self._children_name_map["nas_port"] = "nas-port"

                                                                                                self.service_name = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                                self.service_name.parent = self
                                                                                                self._children_name_map["service_name"] = "service-name"

                                                                                                self.service_name_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                                self.service_name_regex.parent = self
                                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"

                                                                                                self.src_addr_ipv4 = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                                self.src_addr_ipv4.parent = self
                                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"

                                                                                                self.dst_addr_ipv4 = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                                self.dst_addr_ipv4.parent = self
                                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"

                                                                                                self.src_addr_ipv6 = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                                self.src_addr_ipv6.parent = self
                                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"

                                                                                                self.dst_addr_ipv6 = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                                self.dst_addr_ipv6.parent = self
                                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"

                                                                                                self.src_addr_mac = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                                self.src_addr_mac.parent = self
                                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"

                                                                                                self.timer = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                                self.timer.parent = self
                                                                                                self._children_name_map["timer"] = "timer"

                                                                                                self.timer_regexp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                                self.timer_regexp.parent = self
                                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"

                                                                                                self.tunnel_name = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                                self.tunnel_name.parent = self
                                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"

                                                                                                self.tunnel_name_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                                self.tunnel_name_regex.parent = self
                                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"

                                                                                                self.user_name = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                                self.user_name.parent = self
                                                                                                self._children_name_map["user_name"] = "user-name"

                                                                                                self.user_name_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                                self.user_name_regex.parent = self
                                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"

                                                                                                self.auth_username = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                                self.auth_username.parent = self
                                                                                                self._children_name_map["auth_username"] = "auth-username"

                                                                                                self.auth_username_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                                self.auth_username_regex.parent = self
                                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"

                                                                                                self.unauth_username = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                                self.unauth_username.parent = self
                                                                                                self._children_name_map["unauth_username"] = "unauth-username"

                                                                                                self.unauth_username_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                                self.unauth_username_regex.parent = self
                                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"

                                                                                                self.auth_domain = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                                self.auth_domain.parent = self
                                                                                                self._children_name_map["auth_domain"] = "auth-domain"

                                                                                                self.auth_domain_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                                self.auth_domain_regex.parent = self
                                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"

                                                                                                self.unauth_domain = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                                self.unauth_domain.parent = self
                                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"

                                                                                                self.unauth_domain_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                                self.unauth_domain_regex.parent = self
                                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"

                                                                                                self.vendor_id = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                                self.vendor_id.parent = self
                                                                                                self._children_name_map["vendor_id"] = "vendor-id"

                                                                                                self.vendor_id_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                                self.vendor_id_regex.parent = self
                                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"

                                                                                                self.access_interface = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                                self.access_interface.parent = self
                                                                                                self._children_name_map["access_interface"] = "access-interface"

                                                                                                self.input_interface = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                                self.input_interface.parent = self
                                                                                                self._children_name_map["input_interface"] = "input-interface"

                                                                                                self.input_intfhdl = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                                self.input_intfhdl.parent = self
                                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"

                                                                                                self.ethertype = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                                self.ethertype.parent = self
                                                                                                self._children_name_map["ethertype"] = "ethertype"

                                                                                                self.flow_key_data = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                                self.flow_key_data.parent = self
                                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"

                                                                                                self.dhcp_client_id = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                                self.dhcp_client_id.parent = self
                                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"

                                                                                                self.dhcp_client_id_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                                self.dhcp_client_id_regex.parent = self
                                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"

                                                                                                self.circuit_id = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                                self.circuit_id.parent = self
                                                                                                self._children_name_map["circuit_id"] = "circuit-id"

                                                                                                self.circuit_id_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                                self.circuit_id_regex.parent = self
                                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"

                                                                                                self.remote_id = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                                self.remote_id.parent = self
                                                                                                self._children_name_map["remote_id"] = "remote-id"

                                                                                                self.remote_id_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                                self.remote_id_regex.parent = self
                                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"

                                                                                                self.src_port = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                                self.src_port.parent = self
                                                                                                self._children_name_map["src_port"] = "src-port"

                                                                                                self.dst_port = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                                self.dst_port.parent = self
                                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                                self._segment_path = lambda: "match-data"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, ['type', 'mpls_top_eos', 'fragment_type', 'authen_status', 'mlp_negotiated'], name, value)


                                                                                            class Ipv4Dscp(Entity):
                                                                                                """
                                                                                                IPv4 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv4-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv6Dscp(Entity):
                                                                                                """
                                                                                                IPv6 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv6-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Dscp(Entity):
                                                                                                """
                                                                                                Match DSCP range array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                    self.yang_name = "dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv4Prec(Entity):
                                                                                                """
                                                                                                IPv4 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                    self.yang_name = "ipv4-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "ipv4-prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                            class Ipv6Prec(Entity):
                                                                                                """
                                                                                                IPv6 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                    self.yang_name = "ipv6-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "ipv6-prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                            class Prec(Entity):
                                                                                                """
                                                                                                Match Precedence array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                    self.yang_name = "prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                            class DiscardClass(Entity):
                                                                                                """
                                                                                                Match Discard Class array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                    self.yang_name = "discard-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "discard-class"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                            class QosGroup(Entity):
                                                                                                """
                                                                                                Match QoS group array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                    self.yang_name = "qos-group"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "qos-group"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "qos-group"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class TrafficClass(Entity):
                                                                                                """
                                                                                                Match Traffic class array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                    self.yang_name = "traffic-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "traffic-class"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "traffic-class"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Proto(Entity):
                                                                                                """
                                                                                                Match Protocol array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                    self.yang_name = "proto"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "proto"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "proto"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class IcmpV4(Entity):
                                                                                                """
                                                                                                Match ICMPV4 Protocol
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                    self.yang_name = "icmp-v4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                    ])
                                                                                                    self.type = None
                                                                                                    self.code = None
                                                                                                    self._segment_path = lambda: "icmp-v4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['type', 'code'], name, value)


                                                                                            class IcmpV6(Entity):
                                                                                                """
                                                                                                Match ICMPV6 Protocol array
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                    self.yang_name = "icmp-v6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                    ])
                                                                                                    self.type = None
                                                                                                    self.code = None
                                                                                                    self._segment_path = lambda: "icmp-v6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['type', 'code'], name, value)


                                                                                            class Ipv4PacketLen(Entity):
                                                                                                """
                                                                                                IPv4 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv6PacketLen(Entity):
                                                                                                """
                                                                                                IPv6 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class PacketLen(Entity):
                                                                                                """
                                                                                                Match packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                    self.yang_name = "packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FlowTag(Entity):
                                                                                                """
                                                                                                Match flow\-tag array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                    self.yang_name = "flow-tag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "flow-tag"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "flow-tag"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class TcpFlag(Entity):
                                                                                                """
                                                                                                Match tcp flag value
                                                                                                
                                                                                                .. attribute:: value
                                                                                                
                                                                                                	Value of TCP flag
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: match_any
                                                                                                
                                                                                                	Match any TCP flag bit
                                                                                                	**type**\: bool
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                    self.yang_name = "tcp-flag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                                        ('match_any', (YLeaf(YType.boolean, 'match-any'), ['bool'])),
                                                                                                    ])
                                                                                                    self.value = None
                                                                                                    self.match_any = None
                                                                                                    self._segment_path = lambda: "tcp-flag"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['value', 'match_any'], name, value)


                                                                                            class Icmpv4Type(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                    self.yang_name = "icmpv4-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv4Code(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                    self.yang_name = "icmpv4-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-code"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv6Type(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                    self.yang_name = "icmpv6-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv6Code(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                    self.yang_name = "icmpv6-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-code"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class MplsExp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental topmost array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "mpls-exp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                            class MplsExpImp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental imposition array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "mpls-exp-imp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                            class MplsDispIpv4Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                            class MplsDispIpv6Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                            class MplsTopLabel(Entity):
                                                                                                """
                                                                                                MPLS Topmost LABEL
                                                                                                
                                                                                                .. attribute:: uint32_rng_array
                                                                                                
                                                                                                	uint32 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                    self.yang_name = "mpls-top-label"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint32_rng_array", ("uint32_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint32_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "mpls-top-label"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                                class Uint32RngArray(Entity):
                                                                                                    """
                                                                                                    uint32 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                        self.yang_name = "uint32_rng_array"
                                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint32, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint32, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint32_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['min', 'max'], name, value)


                                                                                            class Cos(Entity):
                                                                                                """
                                                                                                Match CoS array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                    self.yang_name = "cos"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "cos"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                            class CosInr(Entity):
                                                                                                """
                                                                                                Match inner header CoS
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                    self.yang_name = "cos-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "cos-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                            class Dei(Entity):
                                                                                                """
                                                                                                Match DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                    self.yang_name = "dei"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                    ])
                                                                                                    self.bit_value = None
                                                                                                    self._segment_path = lambda: "dei"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                            class DeiInr(Entity):
                                                                                                """
                                                                                                Match inner DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                    self.yang_name = "dei-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                    ])
                                                                                                    self.bit_value = None
                                                                                                    self._segment_path = lambda: "dei-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                            class Vlan(Entity):
                                                                                                """
                                                                                                Match VLAN array
                                                                                                
                                                                                                .. attribute:: vlan_id_array
                                                                                                
                                                                                                	vlan id array
                                                                                                	**type**\: list of  		 :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                    self.yang_name = "vlan"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("vlan-id-array", ("vlan_id_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.vlan_id_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                                class VlanIdArray(Entity):
                                                                                                    """
                                                                                                    vlan id array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	VLAN mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                        self.yang_name = "vlan-id-array"
                                                                                                        self.yang_parent_name = "vlan"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ('mask', (YLeaf(YType.uint16, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "vlan-id-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['min', 'max', 'mask'], name, value)


                                                                                            class VlanInr(Entity):
                                                                                                """
                                                                                                Match inner header VLAN range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                    self.yang_name = "vlan-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FrDlci(Entity):
                                                                                                """
                                                                                                Match FR DLCI range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                    self.yang_name = "fr-dlci"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "fr-dlci"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class SrcMac(Entity):
                                                                                                """
                                                                                                Match Source MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                    self.yang_name = "src-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.mac_addr = []
                                                                                                    self.mask = []
                                                                                                    self._segment_path = lambda: "src-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                            class DstMac(Entity):
                                                                                                """
                                                                                                Match Destination MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                    self.yang_name = "dst-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.mac_addr = []
                                                                                                    self.mask = []
                                                                                                    self._segment_path = lambda: "dst-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                            class AtmClp(Entity):
                                                                                                """
                                                                                                Match ATM CLP level
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                    self.yang_name = "atm-clp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "atm-clp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                            class FrDe(Entity):
                                                                                                """
                                                                                                Match FR DE value
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                    self.yang_name = "fr-de"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "fr-de"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                            class Ipv4Acl(Entity):
                                                                                                """
                                                                                                IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                    self.yang_name = "ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ipv4-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                            class Ipv6Acl(Entity):
                                                                                                """
                                                                                                IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                    self.yang_name = "ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ipv6-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                            class EtherServiceAcl(Entity):
                                                                                                """
                                                                                                Ethernet\-Services Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                    self.yang_name = "ether-service-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ether-service-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                            class AvailId(Entity):
                                                                                                """
                                                                                                Available Identifiers
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                    self.yang_name = "avail-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "avail-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                            class MediaType(Entity):
                                                                                                """
                                                                                                Media Type
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                    self.yang_name = "media-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "media-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                            class SubsProtocol(Entity):
                                                                                                """
                                                                                                Protocol
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                    self.yang_name = "subs-protocol"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "subs-protocol"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                            class Dnis(Entity):
                                                                                                """
                                                                                                DNIS
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                    self.yang_name = "dnis"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dnis"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                            class DnisRegex(Entity):
                                                                                                """
                                                                                                DNIS Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                    self.yang_name = "dnis-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dnis-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                            class Domain(Entity):
                                                                                                """
                                                                                                Domain Name
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                    self.yang_name = "domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                        ])
                                                                                                        self.domain_name = None
                                                                                                        self.format_name = None
                                                                                                        self._segment_path = lambda: "domain-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class DomainRegex(Entity):
                                                                                                """
                                                                                                Domain Regular Expression
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                    self.yang_name = "domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain-regex"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                        ])
                                                                                                        self.domain_name = None
                                                                                                        self.format_name = None
                                                                                                        self._segment_path = lambda: "domain-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class NasPort(Entity):
                                                                                                """
                                                                                                NAS Port
                                                                                                
                                                                                                .. attribute:: nas_port_array
                                                                                                
                                                                                                	nas port array
                                                                                                	**type**\: list of  		 :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                    self.yang_name = "nas-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("nas-port-array", ("nas_port_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.nas_port_array = YList(self)
                                                                                                    self._segment_path = lambda: "nas-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                                class NasPortArray(Entity):
                                                                                                    """
                                                                                                    nas port array
                                                                                                    
                                                                                                    .. attribute:: sub_id
                                                                                                    
                                                                                                    	sub id
                                                                                                    	**type**\:  :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                    
                                                                                                    .. attribute:: operator
                                                                                                    
                                                                                                    	operator
                                                                                                    	**type**\:  :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	value
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                        self.yang_name = "nas-port-array"
                                                                                                        self.yang_parent_name = "nas-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('sub_id', (YLeaf(YType.enumeration, 'sub-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchNasPortSubIdEn', '')])),
                                                                                                            ('operator', (YLeaf(YType.enumeration, 'operator'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchLogicalOperatorEn', '')])),
                                                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                                        ])
                                                                                                        self.sub_id = None
                                                                                                        self.operator = None
                                                                                                        self.value = None
                                                                                                        self._segment_path = lambda: "nas-port-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['sub_id', 'operator', 'value'], name, value)


                                                                                            class ServiceName(Entity):
                                                                                                """
                                                                                                Service Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                    self.yang_name = "service-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "service-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                            class ServiceNameRegex(Entity):
                                                                                                """
                                                                                                Service Name Regular Exp
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                    self.yang_name = "service-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "service-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                            class SrcAddrIpv4(Entity):
                                                                                                """
                                                                                                Source Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class DstAddrIpv4(Entity):
                                                                                                """
                                                                                                Destination Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class SrcAddrIpv6(Entity):
                                                                                                """
                                                                                                Source Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class DstAddrIpv6(Entity):
                                                                                                """
                                                                                                Destination Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class SrcAddrMac(Entity):
                                                                                                """
                                                                                                Source Address MAC
                                                                                                
                                                                                                .. attribute:: mac_addr_array
                                                                                                
                                                                                                	mac addr array
                                                                                                	**type**\: list of  		 :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                    self.yang_name = "src-addr-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("mac-addr-array", ("mac_addr_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.mac_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                                class MacAddrArray(Entity):
                                                                                                    """
                                                                                                    mac addr array
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                        self.yang_name = "mac-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                            ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.mac_addr = []
                                                                                                        self.mask = []
                                                                                                        self._segment_path = lambda: "mac-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                            class Timer(Entity):
                                                                                                """
                                                                                                Timer
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                    self.yang_name = "timer"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "timer"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                            class TimerRegexp(Entity):
                                                                                                """
                                                                                                Timer Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                    self.yang_name = "timer-regexp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "timer-regexp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                            class TunnelName(Entity):
                                                                                                """
                                                                                                Tunnel Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                    self.yang_name = "tunnel-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "tunnel-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                            class TunnelNameRegex(Entity):
                                                                                                """
                                                                                                Tunnel Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "tunnel-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                            class UserName(Entity):
                                                                                                """
                                                                                                User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                    self.yang_name = "user-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "user-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                            class UserNameRegex(Entity):
                                                                                                """
                                                                                                User Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                    self.yang_name = "user-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "user-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                            class AuthUsername(Entity):
                                                                                                """
                                                                                                Authenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                    self.yang_name = "auth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-username"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                            class AuthUsernameRegex(Entity):
                                                                                                """
                                                                                                Authenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "auth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-username-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                            class UnauthUsername(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                    self.yang_name = "unauth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-username"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                            class UnauthUsernameRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-username-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                            class AuthDomain(Entity):
                                                                                                """
                                                                                                Authenticated domain name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                    self.yang_name = "auth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                            class AuthDomainRegex(Entity):
                                                                                                """
                                                                                                Authenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "auth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                            class UnauthDomain(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                    self.yang_name = "unauth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                            class UnauthDomainRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                            class VendorId(Entity):
                                                                                                """
                                                                                                Vendor ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                    self.yang_name = "vendor-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "vendor-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                            class VendorIdRegex(Entity):
                                                                                                """
                                                                                                Vendor ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                    self.yang_name = "vendor-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "vendor-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                            class AccessInterface(Entity):
                                                                                                """
                                                                                                Access interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                    self.yang_name = "access-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "access-interface"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                            class InputInterface(Entity):
                                                                                                """
                                                                                                Input interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                    self.yang_name = "input-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "input-interface"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                            class InputIntfhdl(Entity):
                                                                                                """
                                                                                                Input interface handle
                                                                                                
                                                                                                .. attribute:: uint64_array
                                                                                                
                                                                                                	uint64 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..18446744073709551615
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                    self.yang_name = "input-intfhdl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint64_array', (YLeafList(YType.uint64, 'uint64_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint64_array = []
                                                                                                    self._segment_path = lambda: "input-intfhdl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                            class Ethertype(Entity):
                                                                                                """
                                                                                                Ethernet type
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                    self.yang_name = "ethertype"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ethertype"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ethertype"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FlowKeyData(Entity):
                                                                                                """
                                                                                                Flow key structure
                                                                                                
                                                                                                .. attribute:: flow_keys
                                                                                                
                                                                                                	flow keys
                                                                                                	**type**\:  :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                                
                                                                                                .. attribute:: max_count
                                                                                                
                                                                                                	Maximum count of flows
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: idle_timeout
                                                                                                
                                                                                                	Idle timeout of flows (in seconds)
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                	**units**\: second
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                    self.yang_name = "flow-key-data"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("flow-keys", ("flow_keys", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys))])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('max_count', (YLeaf(YType.uint16, 'max-count'), ['int'])),
                                                                                                        ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                                                    ])
                                                                                                    self.max_count = None
                                                                                                    self.idle_timeout = None

                                                                                                    self.flow_keys = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                    self.flow_keys.parent = self
                                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                    self._segment_path = lambda: "flow-key-data"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['max_count', 'idle_timeout'], name, value)


                                                                                                class FlowKeys(Entity):
                                                                                                    """
                                                                                                    flow keys
                                                                                                    
                                                                                                    .. attribute:: keys
                                                                                                    
                                                                                                    	keys
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                    
                                                                                                    .. attribute:: num
                                                                                                    
                                                                                                    	num
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                        self.yang_name = "flow-keys"
                                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('keys', (YLeaf(YType.str, 'keys'), ['str'])),
                                                                                                            ('num', (YLeaf(YType.uint8, 'num'), ['int'])),
                                                                                                        ])
                                                                                                        self.keys = None
                                                                                                        self.num = None
                                                                                                        self._segment_path = lambda: "flow-keys"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                            class DhcpClientId(Entity):
                                                                                                """
                                                                                                Dhcp Client ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dhcp-client-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                            class DhcpClientIdRegex(Entity):
                                                                                                """
                                                                                                Dhcp Client ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                            class CircuitId(Entity):
                                                                                                """
                                                                                                Circuit ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                    self.yang_name = "circuit-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "circuit-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                            class CircuitIdRegex(Entity):
                                                                                                """
                                                                                                Circuit ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                    self.yang_name = "circuit-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "circuit-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                            class RemoteId(Entity):
                                                                                                """
                                                                                                Remote ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                    self.yang_name = "remote-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "remote-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                            class RemoteIdRegex(Entity):
                                                                                                """
                                                                                                Remote ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                    self.yang_name = "remote-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "remote-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                            class SrcPort(Entity):
                                                                                                """
                                                                                                Source port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                    self.yang_name = "src-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "src-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class DstPort(Entity):
                                                                                                """
                                                                                                Destination port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                    self.yang_name = "dst-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "dst-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                        class ExcdclassP(Entity):
                                                                            """
                                                                            excdclass p
                                                                            
                                                                            .. attribute:: class_map_bg
                                                                            
                                                                            	class map bg
                                                                            	**type**\: list of  		 :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP, self).__init__()

                                                                                self.yang_name = "excdclass-p"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("class-map-bg", ("class_map_bg", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg))])
                                                                                self._leafs = OrderedDict()

                                                                                self.class_map_bg = YList(self)
                                                                                self._segment_path = lambda: "excdclass-p"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP, [], name, value)


                                                                            class ClassMapBg(Entity):
                                                                                """
                                                                                class map bg
                                                                                
                                                                                .. attribute:: match_infop
                                                                                
                                                                                	Pointer to the first Match info
                                                                                	**type**\:  :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop>`
                                                                                
                                                                                .. attribute:: name
                                                                                
                                                                                	Name of the class\-map
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..65
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Class\-Map Type QoS/PBR/Netflow/..
                                                                                	**type**\:  :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                                                
                                                                                .. attribute:: mode
                                                                                
                                                                                	Class\-Map Mode Match any/Match all
                                                                                	**type**\:  :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                                
                                                                                .. attribute:: description
                                                                                
                                                                                	description
                                                                                	**type**\: str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg, self).__init__()

                                                                                    self.yang_name = "class-map-bg"
                                                                                    self.yang_parent_name = "excdclass-p"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("match-infop", ("match_infop", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapTypeEn', '')])),
                                                                                        ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapModeEn', '')])),
                                                                                        ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                    ])
                                                                                    self.name = None
                                                                                    self.type = None
                                                                                    self.mode = None
                                                                                    self.description = None

                                                                                    self.match_infop = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop()
                                                                                    self.match_infop.parent = self
                                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                                    self._segment_path = lambda: "class-map-bg"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg, ['name', 'type', 'mode', 'description'], name, value)


                                                                                class MatchInfop(Entity):
                                                                                    """
                                                                                    Pointer to the first Match info
                                                                                    
                                                                                    .. attribute:: class_match_info_st
                                                                                    
                                                                                    	class match info st
                                                                                    	**type**\: list of  		 :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop, self).__init__()

                                                                                        self.yang_name = "match-infop"
                                                                                        self.yang_parent_name = "class-map-bg"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("class-match-info-st", ("class_match_info_st", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.class_match_info_st = YList(self)
                                                                                        self._segment_path = lambda: "match-infop"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop, [], name, value)


                                                                                    class ClassMatchInfoSt(Entity):
                                                                                        """
                                                                                        class match info st
                                                                                        
                                                                                        .. attribute:: match_data
                                                                                        
                                                                                        	Match criteria
                                                                                        	**type**\:  :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                        
                                                                                        .. attribute:: flags
                                                                                        
                                                                                        	Flags
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                            self.yang_name = "class-match-info-st"
                                                                                            self.yang_parent_name = "match-infop"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("match-data", ("match_data", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData))])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                            ])
                                                                                            self.flags = None

                                                                                            self.match_data = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                            self.match_data.parent = self
                                                                                            self._children_name_map["match_data"] = "match-data"
                                                                                            self._segment_path = lambda: "class-match-info-st"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                        class MatchData(Entity):
                                                                                            """
                                                                                            Match criteria
                                                                                            
                                                                                            .. attribute:: ipv4_dscp
                                                                                            
                                                                                            	IPv4 DSCP
                                                                                            	**type**\:  :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv6_dscp
                                                                                            
                                                                                            	IPv6 DSCP
                                                                                            	**type**\:  :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                            
                                                                                            .. attribute:: dscp
                                                                                            
                                                                                            	Match DSCP range array
                                                                                            	**type**\:  :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv4_prec
                                                                                            
                                                                                            	IPv4 Precedence
                                                                                            	**type**\:  :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                            
                                                                                            .. attribute:: ipv6_prec
                                                                                            
                                                                                            	IPv6 Precedence
                                                                                            	**type**\:  :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                            
                                                                                            .. attribute:: prec
                                                                                            
                                                                                            	Match Precedence array
                                                                                            	**type**\:  :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                            
                                                                                            .. attribute:: discard_class
                                                                                            
                                                                                            	Match Discard Class array
                                                                                            	**type**\:  :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                            
                                                                                            .. attribute:: qos_group
                                                                                            
                                                                                            	Match QoS group array
                                                                                            	**type**\:  :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                            
                                                                                            .. attribute:: traffic_class
                                                                                            
                                                                                            	Match Traffic class array
                                                                                            	**type**\:  :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                            
                                                                                            .. attribute:: proto
                                                                                            
                                                                                            	Match Protocol array
                                                                                            	**type**\:  :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                            
                                                                                            .. attribute:: icmp_v4
                                                                                            
                                                                                            	Match ICMPV4 Protocol
                                                                                            	**type**\:  :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                            
                                                                                            .. attribute:: icmp_v6
                                                                                            
                                                                                            	Match ICMPV6 Protocol array
                                                                                            	**type**\:  :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                            
                                                                                            .. attribute:: ipv4_packet_len
                                                                                            
                                                                                            	IPv4 packet length array
                                                                                            	**type**\:  :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv6_packet_len
                                                                                            
                                                                                            	IPv6 packet length array
                                                                                            	**type**\:  :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                            
                                                                                            .. attribute:: packet_len
                                                                                            
                                                                                            	Match packet length array
                                                                                            	**type**\:  :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                            
                                                                                            .. attribute:: flow_tag
                                                                                            
                                                                                            	Match flow\-tag array
                                                                                            	**type**\:  :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                            
                                                                                            .. attribute:: tcp_flag
                                                                                            
                                                                                            	Match tcp flag value
                                                                                            	**type**\:  :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                            
                                                                                            .. attribute:: icmpv4_type
                                                                                            
                                                                                            	Match ipv4 icmp type
                                                                                            	**type**\:  :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                            
                                                                                            .. attribute:: icmpv4_code
                                                                                            
                                                                                            	Match ipv4 icmp code
                                                                                            	**type**\:  :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                            
                                                                                            .. attribute:: icmpv6_type
                                                                                            
                                                                                            	Match ipv6 icmp type
                                                                                            	**type**\:  :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                            
                                                                                            .. attribute:: icmpv6_code
                                                                                            
                                                                                            	Match ipv6 icmp code
                                                                                            	**type**\:  :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                            
                                                                                            .. attribute:: mpls_exp
                                                                                            
                                                                                            	Match MPLS experimental topmost array
                                                                                            	**type**\:  :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                            
                                                                                            .. attribute:: mpls_exp_imp
                                                                                            
                                                                                            	Match MPLS experimental imposition array
                                                                                            	**type**\:  :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                                            
                                                                                            	MPLS Disposition IPv4 Access\-list
                                                                                            	**type**\:  :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                                            
                                                                                            	MPLS Disposition IPv6 Access\-list
                                                                                            	**type**\:  :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_top_label
                                                                                            
                                                                                            	MPLS Topmost LABEL
                                                                                            	**type**\:  :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                            
                                                                                            .. attribute:: cos
                                                                                            
                                                                                            	Match CoS array
                                                                                            	**type**\:  :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                            
                                                                                            .. attribute:: cos_inr
                                                                                            
                                                                                            	Match inner header CoS
                                                                                            	**type**\:  :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                            
                                                                                            .. attribute:: dei
                                                                                            
                                                                                            	Match DEI Bit
                                                                                            	**type**\:  :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                            
                                                                                            .. attribute:: dei_inr
                                                                                            
                                                                                            	Match inner DEI Bit
                                                                                            	**type**\:  :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                            
                                                                                            .. attribute:: vlan
                                                                                            
                                                                                            	Match VLAN array
                                                                                            	**type**\:  :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                            
                                                                                            .. attribute:: vlan_inr
                                                                                            
                                                                                            	Match inner header VLAN range array
                                                                                            	**type**\:  :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                            
                                                                                            .. attribute:: fr_dlci
                                                                                            
                                                                                            	Match FR DLCI range array
                                                                                            	**type**\:  :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                            
                                                                                            .. attribute:: src_mac
                                                                                            
                                                                                            	Match Source MAC address
                                                                                            	**type**\:  :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                            
                                                                                            .. attribute:: dst_mac
                                                                                            
                                                                                            	Match Destination MAC address
                                                                                            	**type**\:  :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                            
                                                                                            .. attribute:: atm_clp
                                                                                            
                                                                                            	Match ATM CLP level
                                                                                            	**type**\:  :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                            
                                                                                            .. attribute:: fr_de
                                                                                            
                                                                                            	Match FR DE value
                                                                                            	**type**\:  :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                            
                                                                                            .. attribute:: ipv4_acl
                                                                                            
                                                                                            	IPv4 Access\-list
                                                                                            	**type**\:  :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                            
                                                                                            .. attribute:: ipv6_acl
                                                                                            
                                                                                            	IPv6 Access\-list
                                                                                            	**type**\:  :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                            
                                                                                            .. attribute:: ether_service_acl
                                                                                            
                                                                                            	Ethernet\-Services Access\-list
                                                                                            	**type**\:  :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                            
                                                                                            .. attribute:: avail_id
                                                                                            
                                                                                            	Available Identifiers
                                                                                            	**type**\:  :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                            
                                                                                            .. attribute:: media_type
                                                                                            
                                                                                            	Media Type
                                                                                            	**type**\:  :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                            
                                                                                            .. attribute:: subs_protocol
                                                                                            
                                                                                            	Protocol
                                                                                            	**type**\:  :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                            
                                                                                            .. attribute:: dnis
                                                                                            
                                                                                            	DNIS
                                                                                            	**type**\:  :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                            
                                                                                            .. attribute:: dnis_regex
                                                                                            
                                                                                            	DNIS Regular Expression
                                                                                            	**type**\:  :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                            
                                                                                            .. attribute:: domain
                                                                                            
                                                                                            	Domain Name
                                                                                            	**type**\:  :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                            
                                                                                            .. attribute:: domain_regex
                                                                                            
                                                                                            	Domain Regular Expression
                                                                                            	**type**\:  :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                            
                                                                                            .. attribute:: nas_port
                                                                                            
                                                                                            	NAS Port
                                                                                            	**type**\:  :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                            
                                                                                            .. attribute:: service_name
                                                                                            
                                                                                            	Service Name
                                                                                            	**type**\:  :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                            
                                                                                            .. attribute:: service_name_regex
                                                                                            
                                                                                            	Service Name Regular Exp
                                                                                            	**type**\:  :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv4
                                                                                            
                                                                                            	Source Address IPV4
                                                                                            	**type**\:  :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv4
                                                                                            
                                                                                            	Destination Address IPV4
                                                                                            	**type**\:  :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv6
                                                                                            
                                                                                            	Source Address IPV6
                                                                                            	**type**\:  :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv6
                                                                                            
                                                                                            	Destination Address IPV6
                                                                                            	**type**\:  :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: src_addr_mac
                                                                                            
                                                                                            	Source Address MAC
                                                                                            	**type**\:  :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                            
                                                                                            .. attribute:: timer
                                                                                            
                                                                                            	Timer
                                                                                            	**type**\:  :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                            
                                                                                            .. attribute:: timer_regexp
                                                                                            
                                                                                            	Timer Regular Expression
                                                                                            	**type**\:  :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                            
                                                                                            .. attribute:: tunnel_name
                                                                                            
                                                                                            	Tunnel Name
                                                                                            	**type**\:  :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                            
                                                                                            .. attribute:: tunnel_name_regex
                                                                                            
                                                                                            	Tunnel Name Regular Expression
                                                                                            	**type**\:  :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                            
                                                                                            .. attribute:: user_name
                                                                                            
                                                                                            	User Name
                                                                                            	**type**\:  :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                            
                                                                                            .. attribute:: user_name_regex
                                                                                            
                                                                                            	User Name Regular Expression
                                                                                            	**type**\:  :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                            
                                                                                            .. attribute:: auth_username
                                                                                            
                                                                                            	Authenticated User Name
                                                                                            	**type**\:  :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                            
                                                                                            .. attribute:: auth_username_regex
                                                                                            
                                                                                            	Authenticated User Name RegEx
                                                                                            	**type**\:  :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_username
                                                                                            
                                                                                            	Unauthenticated User Name
                                                                                            	**type**\:  :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                            
                                                                                            .. attribute:: unauth_username_regex
                                                                                            
                                                                                            	Unauthenticated User Name RegEx
                                                                                            	**type**\:  :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: auth_domain
                                                                                            
                                                                                            	Authenticated domain name
                                                                                            	**type**\:  :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                            
                                                                                            .. attribute:: auth_domain_regex
                                                                                            
                                                                                            	Authenticated Domain Name RegEx
                                                                                            	**type**\:  :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_domain
                                                                                            
                                                                                            	Unauthenticated Domain Name
                                                                                            	**type**\:  :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                            
                                                                                            .. attribute:: unauth_domain_regex
                                                                                            
                                                                                            	Unauthenticated Domain Name RegEx
                                                                                            	**type**\:  :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: vendor_id
                                                                                            
                                                                                            	Vendor ID
                                                                                            	**type**\:  :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                            
                                                                                            .. attribute:: vendor_id_regex
                                                                                            
                                                                                            	Vendor ID RegEx
                                                                                            	**type**\:  :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                            
                                                                                            .. attribute:: access_interface
                                                                                            
                                                                                            	Access interface
                                                                                            	**type**\:  :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                            
                                                                                            .. attribute:: input_interface
                                                                                            
                                                                                            	Input interface
                                                                                            	**type**\:  :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                            
                                                                                            .. attribute:: input_intfhdl
                                                                                            
                                                                                            	Input interface handle
                                                                                            	**type**\:  :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                            
                                                                                            .. attribute:: ethertype
                                                                                            
                                                                                            	Ethernet type
                                                                                            	**type**\:  :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                            
                                                                                            .. attribute:: flow_key_data
                                                                                            
                                                                                            	Flow key structure
                                                                                            	**type**\:  :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id
                                                                                            
                                                                                            	Dhcp Client ID
                                                                                            	**type**\:  :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id_regex
                                                                                            
                                                                                            	Dhcp Client ID RegEx
                                                                                            	**type**\:  :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                            
                                                                                            .. attribute:: circuit_id
                                                                                            
                                                                                            	Circuit ID
                                                                                            	**type**\:  :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                            
                                                                                            .. attribute:: circuit_id_regex
                                                                                            
                                                                                            	Circuit ID RegEx
                                                                                            	**type**\:  :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                            
                                                                                            .. attribute:: remote_id
                                                                                            
                                                                                            	Remote ID
                                                                                            	**type**\:  :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                            
                                                                                            .. attribute:: remote_id_regex
                                                                                            
                                                                                            	Remote ID RegEx
                                                                                            	**type**\:  :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                            
                                                                                            .. attribute:: src_port
                                                                                            
                                                                                            	Source port
                                                                                            	**type**\:  :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                            
                                                                                            .. attribute:: dst_port
                                                                                            
                                                                                            	Destination port
                                                                                            	**type**\:  :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	type
                                                                                            	**type**\:  :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                            
                                                                                            .. attribute:: mpls_top_eos
                                                                                            
                                                                                            	MPLS Topmost EOS
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: fragment_type
                                                                                            
                                                                                            	Fragment type
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: authen_status
                                                                                            
                                                                                            	Authentication Status
                                                                                            	**type**\:  :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                            
                                                                                            .. attribute:: mlp_negotiated
                                                                                            
                                                                                            	MLP Negotiated
                                                                                            	**type**\:  :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                                self.yang_name = "match-data"
                                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("ipv4-dscp", ("ipv4_dscp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp)), ("ipv6-dscp", ("ipv6_dscp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp)), ("dscp", ("dscp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp)), ("ipv4-prec", ("ipv4_prec", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec)), ("ipv6-prec", ("ipv6_prec", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec)), ("prec", ("prec", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec)), ("discard-class", ("discard_class", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass)), ("qos-group", ("qos_group", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup)), ("traffic-class", ("traffic_class", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass)), ("proto", ("proto", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto)), ("icmp-v4", ("icmp_v4", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4)), ("icmp-v6", ("icmp_v6", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6)), ("ipv4-packet-len", ("ipv4_packet_len", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen)), ("ipv6-packet-len", ("ipv6_packet_len", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen)), ("packet-len", ("packet_len", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen)), ("flow-tag", ("flow_tag", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag)), ("tcp-flag", ("tcp_flag", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag)), ("icmpv4-type", ("icmpv4_type", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type)), ("icmpv4-code", ("icmpv4_code", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code)), ("icmpv6-type", ("icmpv6_type", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type)), ("icmpv6-code", ("icmpv6_code", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code)), ("mpls-exp", ("mpls_exp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp)), ("mpls-exp-imp", ("mpls_exp_imp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp)), ("mpls-disp-ipv4-acl", ("mpls_disp_ipv4_acl", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl)), ("mpls-disp-ipv6-acl", ("mpls_disp_ipv6_acl", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl)), ("mpls-top-label", ("mpls_top_label", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel)), ("cos", ("cos", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos)), ("cos-inr", ("cos_inr", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr)), ("dei", ("dei", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei)), ("dei-inr", ("dei_inr", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr)), ("vlan", ("vlan", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan)), ("vlan-inr", ("vlan_inr", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)), ("fr-dlci", ("fr_dlci", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci)), ("src-mac", ("src_mac", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac)), ("dst-mac", ("dst_mac", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac)), ("atm-clp", ("atm_clp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp)), ("fr-de", ("fr_de", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe)), ("ipv4-acl", ("ipv4_acl", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl)), ("ipv6-acl", ("ipv6_acl", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl)), ("ether-service-acl", ("ether_service_acl", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl)), ("avail-id", ("avail_id", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId)), ("media-type", ("media_type", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType)), ("subs-protocol", ("subs_protocol", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol)), ("dnis", ("dnis", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis)), ("dnis-regex", ("dnis_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex)), ("domain", ("domain", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain)), ("domain-regex", ("domain_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex)), ("nas-port", ("nas_port", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort)), ("service-name", ("service_name", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName)), ("service-name-regex", ("service_name_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex)), ("src-addr-ipv4", ("src_addr_ipv4", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4)), ("dst-addr-ipv4", ("dst_addr_ipv4", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4)), ("src-addr-ipv6", ("src_addr_ipv6", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6)), ("dst-addr-ipv6", ("dst_addr_ipv6", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6)), ("src-addr-mac", ("src_addr_mac", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac)), ("timer", ("timer", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer)), ("timer-regexp", ("timer_regexp", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp)), ("tunnel-name", ("tunnel_name", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName)), ("tunnel-name-regex", ("tunnel_name_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex)), ("user-name", ("user_name", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName)), ("user-name-regex", ("user_name_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex)), ("auth-username", ("auth_username", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername)), ("auth-username-regex", ("auth_username_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex)), ("unauth-username", ("unauth_username", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername)), ("unauth-username-regex", ("unauth_username_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex)), ("auth-domain", ("auth_domain", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain)), ("auth-domain-regex", ("auth_domain_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex)), ("unauth-domain", ("unauth_domain", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain)), ("unauth-domain-regex", ("unauth_domain_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex)), ("vendor-id", ("vendor_id", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId)), ("vendor-id-regex", ("vendor_id_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex)), ("access-interface", ("access_interface", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface)), ("input-interface", ("input_interface", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface)), ("input-intfhdl", ("input_intfhdl", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl)), ("ethertype", ("ethertype", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype)), ("flow-key-data", ("flow_key_data", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData)), ("dhcp-client-id", ("dhcp_client_id", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId)), ("dhcp-client-id-regex", ("dhcp_client_id_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex)), ("circuit-id", ("circuit_id", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId)), ("circuit-id-regex", ("circuit_id_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex)), ("remote-id", ("remote_id", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId)), ("remote-id-regex", ("remote_id_regex", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex)), ("src-port", ("src_port", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort)), ("dst-port", ("dst_port", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort))])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchTypeEn', '')])),
                                                                                                    ('mpls_top_eos', (YLeaf(YType.uint8, 'mpls-top-eos'), ['int'])),
                                                                                                    ('fragment_type', (YLeaf(YType.uint8, 'fragment-type'), ['int'])),
                                                                                                    ('authen_status', (YLeaf(YType.enumeration, 'authen-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchAuthenStatusEn', '')])),
                                                                                                    ('mlp_negotiated', (YLeaf(YType.enumeration, 'mlp-negotiated'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchMlpNegotiatedEn', '')])),
                                                                                                ])
                                                                                                self.type = None
                                                                                                self.mpls_top_eos = None
                                                                                                self.fragment_type = None
                                                                                                self.authen_status = None
                                                                                                self.mlp_negotiated = None

                                                                                                self.ipv4_dscp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                                self.ipv4_dscp.parent = self
                                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"

                                                                                                self.ipv6_dscp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                                self.ipv6_dscp.parent = self
                                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"

                                                                                                self.dscp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                                self.dscp.parent = self
                                                                                                self._children_name_map["dscp"] = "dscp"

                                                                                                self.ipv4_prec = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                                self.ipv4_prec.parent = self
                                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"

                                                                                                self.ipv6_prec = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                                self.ipv6_prec.parent = self
                                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"

                                                                                                self.prec = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                                self.prec.parent = self
                                                                                                self._children_name_map["prec"] = "prec"

                                                                                                self.discard_class = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                                self.discard_class.parent = self
                                                                                                self._children_name_map["discard_class"] = "discard-class"

                                                                                                self.qos_group = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                                self.qos_group.parent = self
                                                                                                self._children_name_map["qos_group"] = "qos-group"

                                                                                                self.traffic_class = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                                self.traffic_class.parent = self
                                                                                                self._children_name_map["traffic_class"] = "traffic-class"

                                                                                                self.proto = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                                self.proto.parent = self
                                                                                                self._children_name_map["proto"] = "proto"

                                                                                                self.icmp_v4 = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                                self.icmp_v4.parent = self
                                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"

                                                                                                self.icmp_v6 = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                                self.icmp_v6.parent = self
                                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"

                                                                                                self.ipv4_packet_len = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                                self.ipv4_packet_len.parent = self
                                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"

                                                                                                self.ipv6_packet_len = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                                self.ipv6_packet_len.parent = self
                                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"

                                                                                                self.packet_len = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                                self.packet_len.parent = self
                                                                                                self._children_name_map["packet_len"] = "packet-len"

                                                                                                self.flow_tag = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                                self.flow_tag.parent = self
                                                                                                self._children_name_map["flow_tag"] = "flow-tag"

                                                                                                self.tcp_flag = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                                self.tcp_flag.parent = self
                                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"

                                                                                                self.icmpv4_type = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                                self.icmpv4_type.parent = self
                                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"

                                                                                                self.icmpv4_code = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                                self.icmpv4_code.parent = self
                                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"

                                                                                                self.icmpv6_type = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                                self.icmpv6_type.parent = self
                                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"

                                                                                                self.icmpv6_code = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                                self.icmpv6_code.parent = self
                                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"

                                                                                                self.mpls_exp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                                self.mpls_exp.parent = self
                                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"

                                                                                                self.mpls_exp_imp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                                self.mpls_exp_imp.parent = self
                                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"

                                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"

                                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"

                                                                                                self.mpls_top_label = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                                self.mpls_top_label.parent = self
                                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"

                                                                                                self.cos = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                                self.cos.parent = self
                                                                                                self._children_name_map["cos"] = "cos"

                                                                                                self.cos_inr = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                                self.cos_inr.parent = self
                                                                                                self._children_name_map["cos_inr"] = "cos-inr"

                                                                                                self.dei = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                                self.dei.parent = self
                                                                                                self._children_name_map["dei"] = "dei"

                                                                                                self.dei_inr = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                                self.dei_inr.parent = self
                                                                                                self._children_name_map["dei_inr"] = "dei-inr"

                                                                                                self.vlan = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                                self.vlan.parent = self
                                                                                                self._children_name_map["vlan"] = "vlan"

                                                                                                self.vlan_inr = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                                self.vlan_inr.parent = self
                                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"

                                                                                                self.fr_dlci = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                                self.fr_dlci.parent = self
                                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"

                                                                                                self.src_mac = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                                self.src_mac.parent = self
                                                                                                self._children_name_map["src_mac"] = "src-mac"

                                                                                                self.dst_mac = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                                self.dst_mac.parent = self
                                                                                                self._children_name_map["dst_mac"] = "dst-mac"

                                                                                                self.atm_clp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                                self.atm_clp.parent = self
                                                                                                self._children_name_map["atm_clp"] = "atm-clp"

                                                                                                self.fr_de = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                                self.fr_de.parent = self
                                                                                                self._children_name_map["fr_de"] = "fr-de"

                                                                                                self.ipv4_acl = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                                self.ipv4_acl.parent = self
                                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"

                                                                                                self.ipv6_acl = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                                self.ipv6_acl.parent = self
                                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"

                                                                                                self.ether_service_acl = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                                self.ether_service_acl.parent = self
                                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"

                                                                                                self.avail_id = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                                self.avail_id.parent = self
                                                                                                self._children_name_map["avail_id"] = "avail-id"

                                                                                                self.media_type = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                                self.media_type.parent = self
                                                                                                self._children_name_map["media_type"] = "media-type"

                                                                                                self.subs_protocol = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                                self.subs_protocol.parent = self
                                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"

                                                                                                self.dnis = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                                self.dnis.parent = self
                                                                                                self._children_name_map["dnis"] = "dnis"

                                                                                                self.dnis_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                                self.dnis_regex.parent = self
                                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"

                                                                                                self.domain = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                                self.domain.parent = self
                                                                                                self._children_name_map["domain"] = "domain"

                                                                                                self.domain_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                                self.domain_regex.parent = self
                                                                                                self._children_name_map["domain_regex"] = "domain-regex"

                                                                                                self.nas_port = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                                self.nas_port.parent = self
                                                                                                self._children_name_map["nas_port"] = "nas-port"

                                                                                                self.service_name = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                                self.service_name.parent = self
                                                                                                self._children_name_map["service_name"] = "service-name"

                                                                                                self.service_name_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                                self.service_name_regex.parent = self
                                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"

                                                                                                self.src_addr_ipv4 = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                                self.src_addr_ipv4.parent = self
                                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"

                                                                                                self.dst_addr_ipv4 = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                                self.dst_addr_ipv4.parent = self
                                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"

                                                                                                self.src_addr_ipv6 = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                                self.src_addr_ipv6.parent = self
                                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"

                                                                                                self.dst_addr_ipv6 = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                                self.dst_addr_ipv6.parent = self
                                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"

                                                                                                self.src_addr_mac = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                                self.src_addr_mac.parent = self
                                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"

                                                                                                self.timer = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                                self.timer.parent = self
                                                                                                self._children_name_map["timer"] = "timer"

                                                                                                self.timer_regexp = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                                self.timer_regexp.parent = self
                                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"

                                                                                                self.tunnel_name = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                                self.tunnel_name.parent = self
                                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"

                                                                                                self.tunnel_name_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                                self.tunnel_name_regex.parent = self
                                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"

                                                                                                self.user_name = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                                self.user_name.parent = self
                                                                                                self._children_name_map["user_name"] = "user-name"

                                                                                                self.user_name_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                                self.user_name_regex.parent = self
                                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"

                                                                                                self.auth_username = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                                self.auth_username.parent = self
                                                                                                self._children_name_map["auth_username"] = "auth-username"

                                                                                                self.auth_username_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                                self.auth_username_regex.parent = self
                                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"

                                                                                                self.unauth_username = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                                self.unauth_username.parent = self
                                                                                                self._children_name_map["unauth_username"] = "unauth-username"

                                                                                                self.unauth_username_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                                self.unauth_username_regex.parent = self
                                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"

                                                                                                self.auth_domain = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                                self.auth_domain.parent = self
                                                                                                self._children_name_map["auth_domain"] = "auth-domain"

                                                                                                self.auth_domain_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                                self.auth_domain_regex.parent = self
                                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"

                                                                                                self.unauth_domain = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                                self.unauth_domain.parent = self
                                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"

                                                                                                self.unauth_domain_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                                self.unauth_domain_regex.parent = self
                                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"

                                                                                                self.vendor_id = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                                self.vendor_id.parent = self
                                                                                                self._children_name_map["vendor_id"] = "vendor-id"

                                                                                                self.vendor_id_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                                self.vendor_id_regex.parent = self
                                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"

                                                                                                self.access_interface = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                                self.access_interface.parent = self
                                                                                                self._children_name_map["access_interface"] = "access-interface"

                                                                                                self.input_interface = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                                self.input_interface.parent = self
                                                                                                self._children_name_map["input_interface"] = "input-interface"

                                                                                                self.input_intfhdl = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                                self.input_intfhdl.parent = self
                                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"

                                                                                                self.ethertype = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                                self.ethertype.parent = self
                                                                                                self._children_name_map["ethertype"] = "ethertype"

                                                                                                self.flow_key_data = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                                self.flow_key_data.parent = self
                                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"

                                                                                                self.dhcp_client_id = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                                self.dhcp_client_id.parent = self
                                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"

                                                                                                self.dhcp_client_id_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                                self.dhcp_client_id_regex.parent = self
                                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"

                                                                                                self.circuit_id = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                                self.circuit_id.parent = self
                                                                                                self._children_name_map["circuit_id"] = "circuit-id"

                                                                                                self.circuit_id_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                                self.circuit_id_regex.parent = self
                                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"

                                                                                                self.remote_id = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                                self.remote_id.parent = self
                                                                                                self._children_name_map["remote_id"] = "remote-id"

                                                                                                self.remote_id_regex = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                                self.remote_id_regex.parent = self
                                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"

                                                                                                self.src_port = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                                self.src_port.parent = self
                                                                                                self._children_name_map["src_port"] = "src-port"

                                                                                                self.dst_port = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                                self.dst_port.parent = self
                                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                                self._segment_path = lambda: "match-data"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['type', 'mpls_top_eos', 'fragment_type', 'authen_status', 'mlp_negotiated'], name, value)


                                                                                            class Ipv4Dscp(Entity):
                                                                                                """
                                                                                                IPv4 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv4-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv6Dscp(Entity):
                                                                                                """
                                                                                                IPv6 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv6-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Dscp(Entity):
                                                                                                """
                                                                                                Match DSCP range array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                    self.yang_name = "dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv4Prec(Entity):
                                                                                                """
                                                                                                IPv4 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                    self.yang_name = "ipv4-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "ipv4-prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                            class Ipv6Prec(Entity):
                                                                                                """
                                                                                                IPv6 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                    self.yang_name = "ipv6-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "ipv6-prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                            class Prec(Entity):
                                                                                                """
                                                                                                Match Precedence array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                    self.yang_name = "prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                            class DiscardClass(Entity):
                                                                                                """
                                                                                                Match Discard Class array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                    self.yang_name = "discard-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "discard-class"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                            class QosGroup(Entity):
                                                                                                """
                                                                                                Match QoS group array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                    self.yang_name = "qos-group"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "qos-group"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "qos-group"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class TrafficClass(Entity):
                                                                                                """
                                                                                                Match Traffic class array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                    self.yang_name = "traffic-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "traffic-class"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "traffic-class"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Proto(Entity):
                                                                                                """
                                                                                                Match Protocol array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                    self.yang_name = "proto"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "proto"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "proto"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class IcmpV4(Entity):
                                                                                                """
                                                                                                Match ICMPV4 Protocol
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                    self.yang_name = "icmp-v4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                    ])
                                                                                                    self.type = None
                                                                                                    self.code = None
                                                                                                    self._segment_path = lambda: "icmp-v4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['type', 'code'], name, value)


                                                                                            class IcmpV6(Entity):
                                                                                                """
                                                                                                Match ICMPV6 Protocol array
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                    self.yang_name = "icmp-v6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                    ])
                                                                                                    self.type = None
                                                                                                    self.code = None
                                                                                                    self._segment_path = lambda: "icmp-v6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['type', 'code'], name, value)


                                                                                            class Ipv4PacketLen(Entity):
                                                                                                """
                                                                                                IPv4 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv6PacketLen(Entity):
                                                                                                """
                                                                                                IPv6 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class PacketLen(Entity):
                                                                                                """
                                                                                                Match packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                    self.yang_name = "packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FlowTag(Entity):
                                                                                                """
                                                                                                Match flow\-tag array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                    self.yang_name = "flow-tag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "flow-tag"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "flow-tag"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class TcpFlag(Entity):
                                                                                                """
                                                                                                Match tcp flag value
                                                                                                
                                                                                                .. attribute:: value
                                                                                                
                                                                                                	Value of TCP flag
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: match_any
                                                                                                
                                                                                                	Match any TCP flag bit
                                                                                                	**type**\: bool
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                    self.yang_name = "tcp-flag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                                        ('match_any', (YLeaf(YType.boolean, 'match-any'), ['bool'])),
                                                                                                    ])
                                                                                                    self.value = None
                                                                                                    self.match_any = None
                                                                                                    self._segment_path = lambda: "tcp-flag"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['value', 'match_any'], name, value)


                                                                                            class Icmpv4Type(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                    self.yang_name = "icmpv4-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv4Code(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                    self.yang_name = "icmpv4-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-code"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv6Type(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                    self.yang_name = "icmpv6-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv6Code(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                    self.yang_name = "icmpv6-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-code"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class MplsExp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental topmost array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "mpls-exp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                            class MplsExpImp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental imposition array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "mpls-exp-imp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                            class MplsDispIpv4Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                            class MplsDispIpv6Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                            class MplsTopLabel(Entity):
                                                                                                """
                                                                                                MPLS Topmost LABEL
                                                                                                
                                                                                                .. attribute:: uint32_rng_array
                                                                                                
                                                                                                	uint32 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                    self.yang_name = "mpls-top-label"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint32_rng_array", ("uint32_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint32_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "mpls-top-label"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                                class Uint32RngArray(Entity):
                                                                                                    """
                                                                                                    uint32 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                        self.yang_name = "uint32_rng_array"
                                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint32, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint32, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint32_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['min', 'max'], name, value)


                                                                                            class Cos(Entity):
                                                                                                """
                                                                                                Match CoS array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                    self.yang_name = "cos"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "cos"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                            class CosInr(Entity):
                                                                                                """
                                                                                                Match inner header CoS
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                    self.yang_name = "cos-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "cos-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                            class Dei(Entity):
                                                                                                """
                                                                                                Match DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                    self.yang_name = "dei"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                    ])
                                                                                                    self.bit_value = None
                                                                                                    self._segment_path = lambda: "dei"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                            class DeiInr(Entity):
                                                                                                """
                                                                                                Match inner DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                    self.yang_name = "dei-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                    ])
                                                                                                    self.bit_value = None
                                                                                                    self._segment_path = lambda: "dei-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                            class Vlan(Entity):
                                                                                                """
                                                                                                Match VLAN array
                                                                                                
                                                                                                .. attribute:: vlan_id_array
                                                                                                
                                                                                                	vlan id array
                                                                                                	**type**\: list of  		 :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                    self.yang_name = "vlan"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("vlan-id-array", ("vlan_id_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.vlan_id_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                                class VlanIdArray(Entity):
                                                                                                    """
                                                                                                    vlan id array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	VLAN mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                        self.yang_name = "vlan-id-array"
                                                                                                        self.yang_parent_name = "vlan"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ('mask', (YLeaf(YType.uint16, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "vlan-id-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['min', 'max', 'mask'], name, value)


                                                                                            class VlanInr(Entity):
                                                                                                """
                                                                                                Match inner header VLAN range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                    self.yang_name = "vlan-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FrDlci(Entity):
                                                                                                """
                                                                                                Match FR DLCI range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                    self.yang_name = "fr-dlci"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "fr-dlci"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class SrcMac(Entity):
                                                                                                """
                                                                                                Match Source MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                    self.yang_name = "src-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.mac_addr = []
                                                                                                    self.mask = []
                                                                                                    self._segment_path = lambda: "src-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                            class DstMac(Entity):
                                                                                                """
                                                                                                Match Destination MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                    self.yang_name = "dst-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.mac_addr = []
                                                                                                    self.mask = []
                                                                                                    self._segment_path = lambda: "dst-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                            class AtmClp(Entity):
                                                                                                """
                                                                                                Match ATM CLP level
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                    self.yang_name = "atm-clp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "atm-clp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                            class FrDe(Entity):
                                                                                                """
                                                                                                Match FR DE value
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                    self.yang_name = "fr-de"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "fr-de"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                            class Ipv4Acl(Entity):
                                                                                                """
                                                                                                IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                    self.yang_name = "ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ipv4-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                            class Ipv6Acl(Entity):
                                                                                                """
                                                                                                IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                    self.yang_name = "ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ipv6-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                            class EtherServiceAcl(Entity):
                                                                                                """
                                                                                                Ethernet\-Services Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                    self.yang_name = "ether-service-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ether-service-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                            class AvailId(Entity):
                                                                                                """
                                                                                                Available Identifiers
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                    self.yang_name = "avail-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "avail-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                            class MediaType(Entity):
                                                                                                """
                                                                                                Media Type
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                    self.yang_name = "media-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "media-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                            class SubsProtocol(Entity):
                                                                                                """
                                                                                                Protocol
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                    self.yang_name = "subs-protocol"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "subs-protocol"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                            class Dnis(Entity):
                                                                                                """
                                                                                                DNIS
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                    self.yang_name = "dnis"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dnis"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                            class DnisRegex(Entity):
                                                                                                """
                                                                                                DNIS Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                    self.yang_name = "dnis-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dnis-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                            class Domain(Entity):
                                                                                                """
                                                                                                Domain Name
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                    self.yang_name = "domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                        ])
                                                                                                        self.domain_name = None
                                                                                                        self.format_name = None
                                                                                                        self._segment_path = lambda: "domain-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class DomainRegex(Entity):
                                                                                                """
                                                                                                Domain Regular Expression
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                    self.yang_name = "domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain-regex"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                        ])
                                                                                                        self.domain_name = None
                                                                                                        self.format_name = None
                                                                                                        self._segment_path = lambda: "domain-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class NasPort(Entity):
                                                                                                """
                                                                                                NAS Port
                                                                                                
                                                                                                .. attribute:: nas_port_array
                                                                                                
                                                                                                	nas port array
                                                                                                	**type**\: list of  		 :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                    self.yang_name = "nas-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("nas-port-array", ("nas_port_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.nas_port_array = YList(self)
                                                                                                    self._segment_path = lambda: "nas-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                                class NasPortArray(Entity):
                                                                                                    """
                                                                                                    nas port array
                                                                                                    
                                                                                                    .. attribute:: sub_id
                                                                                                    
                                                                                                    	sub id
                                                                                                    	**type**\:  :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                    
                                                                                                    .. attribute:: operator
                                                                                                    
                                                                                                    	operator
                                                                                                    	**type**\:  :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	value
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                        self.yang_name = "nas-port-array"
                                                                                                        self.yang_parent_name = "nas-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('sub_id', (YLeaf(YType.enumeration, 'sub-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchNasPortSubIdEn', '')])),
                                                                                                            ('operator', (YLeaf(YType.enumeration, 'operator'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchLogicalOperatorEn', '')])),
                                                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                                        ])
                                                                                                        self.sub_id = None
                                                                                                        self.operator = None
                                                                                                        self.value = None
                                                                                                        self._segment_path = lambda: "nas-port-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['sub_id', 'operator', 'value'], name, value)


                                                                                            class ServiceName(Entity):
                                                                                                """
                                                                                                Service Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                    self.yang_name = "service-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "service-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                            class ServiceNameRegex(Entity):
                                                                                                """
                                                                                                Service Name Regular Exp
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                    self.yang_name = "service-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "service-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                            class SrcAddrIpv4(Entity):
                                                                                                """
                                                                                                Source Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class DstAddrIpv4(Entity):
                                                                                                """
                                                                                                Destination Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class SrcAddrIpv6(Entity):
                                                                                                """
                                                                                                Source Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class DstAddrIpv6(Entity):
                                                                                                """
                                                                                                Destination Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class SrcAddrMac(Entity):
                                                                                                """
                                                                                                Source Address MAC
                                                                                                
                                                                                                .. attribute:: mac_addr_array
                                                                                                
                                                                                                	mac addr array
                                                                                                	**type**\: list of  		 :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                    self.yang_name = "src-addr-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("mac-addr-array", ("mac_addr_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.mac_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                                class MacAddrArray(Entity):
                                                                                                    """
                                                                                                    mac addr array
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                        self.yang_name = "mac-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                            ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.mac_addr = []
                                                                                                        self.mask = []
                                                                                                        self._segment_path = lambda: "mac-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                            class Timer(Entity):
                                                                                                """
                                                                                                Timer
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                    self.yang_name = "timer"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "timer"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                            class TimerRegexp(Entity):
                                                                                                """
                                                                                                Timer Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                    self.yang_name = "timer-regexp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "timer-regexp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                            class TunnelName(Entity):
                                                                                                """
                                                                                                Tunnel Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                    self.yang_name = "tunnel-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "tunnel-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                            class TunnelNameRegex(Entity):
                                                                                                """
                                                                                                Tunnel Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "tunnel-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                            class UserName(Entity):
                                                                                                """
                                                                                                User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                    self.yang_name = "user-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "user-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                            class UserNameRegex(Entity):
                                                                                                """
                                                                                                User Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                    self.yang_name = "user-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "user-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                            class AuthUsername(Entity):
                                                                                                """
                                                                                                Authenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                    self.yang_name = "auth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-username"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                            class AuthUsernameRegex(Entity):
                                                                                                """
                                                                                                Authenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "auth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-username-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                            class UnauthUsername(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                    self.yang_name = "unauth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-username"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                            class UnauthUsernameRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-username-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                            class AuthDomain(Entity):
                                                                                                """
                                                                                                Authenticated domain name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                    self.yang_name = "auth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                            class AuthDomainRegex(Entity):
                                                                                                """
                                                                                                Authenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "auth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                            class UnauthDomain(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                    self.yang_name = "unauth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                            class UnauthDomainRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                            class VendorId(Entity):
                                                                                                """
                                                                                                Vendor ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                    self.yang_name = "vendor-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "vendor-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                            class VendorIdRegex(Entity):
                                                                                                """
                                                                                                Vendor ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                    self.yang_name = "vendor-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "vendor-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                            class AccessInterface(Entity):
                                                                                                """
                                                                                                Access interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                    self.yang_name = "access-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "access-interface"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                            class InputInterface(Entity):
                                                                                                """
                                                                                                Input interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                    self.yang_name = "input-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "input-interface"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                            class InputIntfhdl(Entity):
                                                                                                """
                                                                                                Input interface handle
                                                                                                
                                                                                                .. attribute:: uint64_array
                                                                                                
                                                                                                	uint64 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..18446744073709551615
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                    self.yang_name = "input-intfhdl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint64_array', (YLeafList(YType.uint64, 'uint64_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint64_array = []
                                                                                                    self._segment_path = lambda: "input-intfhdl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                            class Ethertype(Entity):
                                                                                                """
                                                                                                Ethernet type
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                    self.yang_name = "ethertype"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ethertype"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ethertype"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FlowKeyData(Entity):
                                                                                                """
                                                                                                Flow key structure
                                                                                                
                                                                                                .. attribute:: flow_keys
                                                                                                
                                                                                                	flow keys
                                                                                                	**type**\:  :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                                
                                                                                                .. attribute:: max_count
                                                                                                
                                                                                                	Maximum count of flows
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: idle_timeout
                                                                                                
                                                                                                	Idle timeout of flows (in seconds)
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                	**units**\: second
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                    self.yang_name = "flow-key-data"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("flow-keys", ("flow_keys", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys))])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('max_count', (YLeaf(YType.uint16, 'max-count'), ['int'])),
                                                                                                        ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                                                    ])
                                                                                                    self.max_count = None
                                                                                                    self.idle_timeout = None

                                                                                                    self.flow_keys = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                    self.flow_keys.parent = self
                                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                    self._segment_path = lambda: "flow-key-data"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['max_count', 'idle_timeout'], name, value)


                                                                                                class FlowKeys(Entity):
                                                                                                    """
                                                                                                    flow keys
                                                                                                    
                                                                                                    .. attribute:: keys
                                                                                                    
                                                                                                    	keys
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                    
                                                                                                    .. attribute:: num
                                                                                                    
                                                                                                    	num
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                        self.yang_name = "flow-keys"
                                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('keys', (YLeaf(YType.str, 'keys'), ['str'])),
                                                                                                            ('num', (YLeaf(YType.uint8, 'num'), ['int'])),
                                                                                                        ])
                                                                                                        self.keys = None
                                                                                                        self.num = None
                                                                                                        self._segment_path = lambda: "flow-keys"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                            class DhcpClientId(Entity):
                                                                                                """
                                                                                                Dhcp Client ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dhcp-client-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                            class DhcpClientIdRegex(Entity):
                                                                                                """
                                                                                                Dhcp Client ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                            class CircuitId(Entity):
                                                                                                """
                                                                                                Circuit ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                    self.yang_name = "circuit-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "circuit-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                            class CircuitIdRegex(Entity):
                                                                                                """
                                                                                                Circuit ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                    self.yang_name = "circuit-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "circuit-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                            class RemoteId(Entity):
                                                                                                """
                                                                                                Remote ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                    self.yang_name = "remote-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "remote-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                            class RemoteIdRegex(Entity):
                                                                                                """
                                                                                                Remote ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                    self.yang_name = "remote-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "remote-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                            class SrcPort(Entity):
                                                                                                """
                                                                                                Source port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                    self.yang_name = "src-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "src-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class DstPort(Entity):
                                                                                                """
                                                                                                Destination port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                    self.yang_name = "dst-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "dst-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                    class Shape(Entity):
                                                                        """
                                                                        shape
                                                                        
                                                                        .. attribute:: bw
                                                                        
                                                                        	bw
                                                                        	**type**\:  :py:class:`Bw <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw>`
                                                                        
                                                                        .. attribute:: be
                                                                        
                                                                        	be
                                                                        	**type**\:  :py:class:`Be <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape, self).__init__()

                                                                            self.yang_name = "shape"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("bw", ("bw", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw)), ("be", ("be", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be))])
                                                                            self._leafs = OrderedDict()

                                                                            self.bw = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw()
                                                                            self.bw.parent = self
                                                                            self._children_name_map["bw"] = "bw"

                                                                            self.be = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be()
                                                                            self.be.parent = self
                                                                            self._children_name_map["be"] = "be"
                                                                            self._segment_path = lambda: "shape"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape, [], name, value)


                                                                        class Bw(Entity):
                                                                            """
                                                                            bw
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw, self).__init__()

                                                                                self.yang_name = "bw"
                                                                                self.yang_parent_name = "shape"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "bw"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw, ['value', 'unit'], name, value)


                                                                        class Be(Entity):
                                                                            """
                                                                            be
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be, self).__init__()

                                                                                self.yang_name = "be"
                                                                                self.yang_parent_name = "shape"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "be"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be, ['value', 'unit'], name, value)


                                                                    class ChildPolicy(Entity):
                                                                        """
                                                                        child policy
                                                                        
                                                                        .. attribute:: info
                                                                        
                                                                        	info
                                                                        	**type**\:  :py:class:`Info <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info>`
                                                                        
                                                                        .. attribute:: hd_info
                                                                        
                                                                        	hd info
                                                                        	**type**\:  :py:class:`HdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo>`
                                                                        
                                                                        .. attribute:: enc
                                                                        
                                                                        	enc
                                                                        	**type**\:  :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy, self).__init__()

                                                                            self.yang_name = "child-policy"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("info", ("info", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info)), ("hd-info", ("hd_info", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo))])
                                                                            self._leafs = OrderedDict([
                                                                                ('enc', (YLeaf(YType.enumeration, 'enc'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyObjEncEn', '')])),
                                                                            ])
                                                                            self.enc = None

                                                                            self.info = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info()
                                                                            self.info.parent = self
                                                                            self._children_name_map["info"] = "info"

                                                                            self.hd_info = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo()
                                                                            self.hd_info.parent = self
                                                                            self._children_name_map["hd_info"] = "hd-info"
                                                                            self._segment_path = lambda: "child-policy"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy, ['enc'], name, value)


                                                                        class Info(Entity):
                                                                            """
                                                                            info
                                                                            
                                                                            .. attribute:: name
                                                                            
                                                                            	name
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..65
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:  :py:class:`PolicyMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyMapTypeEn>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info, self).__init__()

                                                                                self.yang_name = "info"
                                                                                self.yang_parent_name = "child-policy"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyMapTypeEn', '')])),
                                                                                ])
                                                                                self.name = None
                                                                                self.type = None
                                                                                self._segment_path = lambda: "info"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info, ['name', 'type'], name, value)


                                                                        class HdInfo(Entity):
                                                                            """
                                                                            hd info
                                                                            
                                                                            .. attribute:: data_hd
                                                                            
                                                                            	data hd
                                                                            	**type**\:  :py:class:`DataHd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd>`
                                                                            
                                                                            .. attribute:: hd
                                                                            
                                                                            	hd
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo, self).__init__()

                                                                                self.yang_name = "hd-info"
                                                                                self.yang_parent_name = "child-policy"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("data-hd", ("data_hd", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('hd', (YLeaf(YType.uint64, 'hd'), ['int'])),
                                                                                ])
                                                                                self.hd = None

                                                                                self.data_hd = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd()
                                                                                self.data_hd.parent = self
                                                                                self._children_name_map["data_hd"] = "data-hd"
                                                                                self._segment_path = lambda: "hd-info"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo, ['hd'], name, value)


                                                                            class DataHd(Entity):
                                                                                """
                                                                                data hd
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd, self).__init__()

                                                                                    self.yang_name = "data-hd"
                                                                                    self.yang_parent_name = "hd-info"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict()
                                                                                    self._segment_path = lambda: "data-hd"
                                                                                    self._is_frozen = True


                                                                    class Cac(Entity):
                                                                        """
                                                                        cac
                                                                        
                                                                        .. attribute:: flow_rate
                                                                        
                                                                        	flow rate
                                                                        	**type**\:  :py:class:`FlowRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate>`
                                                                        
                                                                        .. attribute:: rate
                                                                        
                                                                        	rate
                                                                        	**type**\:  :py:class:`Rate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate>`
                                                                        
                                                                        .. attribute:: cac_type
                                                                        
                                                                        	cac type
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: idle_timeout
                                                                        
                                                                        	idle timeout
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..65535
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac, self).__init__()

                                                                            self.yang_name = "cac"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("flow-rate", ("flow_rate", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate)), ("rate", ("rate", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate))])
                                                                            self._leafs = OrderedDict([
                                                                                ('cac_type', (YLeaf(YType.uint8, 'cac-type'), ['int'])),
                                                                                ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                            ])
                                                                            self.cac_type = None
                                                                            self.idle_timeout = None

                                                                            self.flow_rate = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate()
                                                                            self.flow_rate.parent = self
                                                                            self._children_name_map["flow_rate"] = "flow-rate"

                                                                            self.rate = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate()
                                                                            self.rate.parent = self
                                                                            self._children_name_map["rate"] = "rate"
                                                                            self._segment_path = lambda: "cac"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac, ['cac_type', 'idle_timeout'], name, value)


                                                                        class FlowRate(Entity):
                                                                            """
                                                                            flow rate
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate, self).__init__()

                                                                                self.yang_name = "flow-rate"
                                                                                self.yang_parent_name = "cac"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "flow-rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate, ['value', 'unit'], name, value)


                                                                        class Rate(Entity):
                                                                            """
                                                                            rate
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate, self).__init__()

                                                                                self.yang_name = "rate"
                                                                                self.yang_parent_name = "cac"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate, ['value', 'unit'], name, value)


                                                                    class Pfc(Entity):
                                                                        """
                                                                        pfc
                                                                        
                                                                        .. attribute:: buffer_size
                                                                        
                                                                        	buffer size
                                                                        	**type**\:  :py:class:`BufferSize <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize>`
                                                                        
                                                                        .. attribute:: pause_threshold
                                                                        
                                                                        	pause threshold
                                                                        	**type**\:  :py:class:`PauseThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold>`
                                                                        
                                                                        .. attribute:: resume_threshold
                                                                        
                                                                        	resume threshold
                                                                        	**type**\:  :py:class:`ResumeThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold>`
                                                                        
                                                                        .. attribute:: pfc_pause_set
                                                                        
                                                                        	pfc pause set
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: buffer_size_flag
                                                                        
                                                                        	buffer size flag
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc, self).__init__()

                                                                            self.yang_name = "pfc"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("buffer-size", ("buffer_size", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize)), ("pause-threshold", ("pause_threshold", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold)), ("resume-threshold", ("resume_threshold", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold))])
                                                                            self._leafs = OrderedDict([
                                                                                ('pfc_pause_set', (YLeaf(YType.uint32, 'pfc-pause-set'), ['int'])),
                                                                                ('buffer_size_flag', (YLeaf(YType.uint32, 'buffer-size-flag'), ['int'])),
                                                                            ])
                                                                            self.pfc_pause_set = None
                                                                            self.buffer_size_flag = None

                                                                            self.buffer_size = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize()
                                                                            self.buffer_size.parent = self
                                                                            self._children_name_map["buffer_size"] = "buffer-size"

                                                                            self.pause_threshold = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold()
                                                                            self.pause_threshold.parent = self
                                                                            self._children_name_map["pause_threshold"] = "pause-threshold"

                                                                            self.resume_threshold = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold()
                                                                            self.resume_threshold.parent = self
                                                                            self._children_name_map["resume_threshold"] = "resume-threshold"
                                                                            self._segment_path = lambda: "pfc"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc, ['pfc_pause_set', 'buffer_size_flag'], name, value)


                                                                        class BufferSize(Entity):
                                                                            """
                                                                            buffer size
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize, self).__init__()

                                                                                self.yang_name = "buffer-size"
                                                                                self.yang_parent_name = "pfc"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "buffer-size"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize, ['value', 'unit'], name, value)


                                                                        class PauseThreshold(Entity):
                                                                            """
                                                                            pause threshold
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold, self).__init__()

                                                                                self.yang_name = "pause-threshold"
                                                                                self.yang_parent_name = "pfc"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "pause-threshold"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold, ['value', 'unit'], name, value)


                                                                        class ResumeThreshold(Entity):
                                                                            """
                                                                            resume threshold
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold, self).__init__()

                                                                                self.yang_name = "resume-threshold"
                                                                                self.yang_parent_name = "pfc"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "resume-threshold"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold, ['value', 'unit'], name, value)


                                                                    class FlowParm(Entity):
                                                                        """
                                                                        flow parm
                                                                        
                                                                        .. attribute:: max_mon_flows
                                                                        
                                                                        	max simult flows monitored per policy class
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: mon_interval
                                                                        
                                                                        	monitored interval duration in secs
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: second
                                                                        
                                                                        .. attribute:: intvl_hist
                                                                        
                                                                        	num intervals of data stored on rtr
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: flow_timeout
                                                                        
                                                                        	timeout in secs
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: second
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm, self).__init__()

                                                                            self.yang_name = "flow-parm"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('max_mon_flows', (YLeaf(YType.uint32, 'max-mon-flows'), ['int'])),
                                                                                ('mon_interval', (YLeaf(YType.uint32, 'mon-interval'), ['int'])),
                                                                                ('intvl_hist', (YLeaf(YType.uint32, 'intvl-hist'), ['int'])),
                                                                                ('flow_timeout', (YLeaf(YType.uint32, 'flow-timeout'), ['int'])),
                                                                            ])
                                                                            self.max_mon_flows = None
                                                                            self.mon_interval = None
                                                                            self.intvl_hist = None
                                                                            self.flow_timeout = None
                                                                            self._segment_path = lambda: "flow-parm"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm, ['max_mon_flows', 'mon_interval', 'intvl_hist', 'flow_timeout'], name, value)


                                                                    class Ipcbr(Entity):
                                                                        """
                                                                        ipcbr
                                                                        
                                                                        .. attribute:: ip_bit_rate
                                                                        
                                                                        	data rate in bps
                                                                        	**type**\:  :py:class:`IpBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate>`
                                                                        
                                                                        .. attribute:: media_bit_rate
                                                                        
                                                                        	media data rate in bps
                                                                        	**type**\:  :py:class:`MediaBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate>`
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: ip_pkt_rate
                                                                        
                                                                        	packet rate in pps
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: media_pkt_size
                                                                        
                                                                        	media packet size in bytes
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: media_pkts_per_ip
                                                                        
                                                                        	media packets per ip pkt
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr, self).__init__()

                                                                            self.yang_name = "ipcbr"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("ip-bit-rate", ("ip_bit_rate", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate)), ("media-bit-rate", ("media_bit_rate", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate))])
                                                                            self._leafs = OrderedDict([
                                                                                ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                                ('ip_pkt_rate', (YLeaf(YType.uint32, 'ip-pkt-rate'), ['int'])),
                                                                                ('media_pkt_size', (YLeaf(YType.uint32, 'media-pkt-size'), ['int'])),
                                                                                ('media_pkts_per_ip', (YLeaf(YType.uint32, 'media-pkts-per-ip'), ['int'])),
                                                                            ])
                                                                            self.action_metric_type = None
                                                                            self.ip_pkt_rate = None
                                                                            self.media_pkt_size = None
                                                                            self.media_pkts_per_ip = None

                                                                            self.ip_bit_rate = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate()
                                                                            self.ip_bit_rate.parent = self
                                                                            self._children_name_map["ip_bit_rate"] = "ip-bit-rate"

                                                                            self.media_bit_rate = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate()
                                                                            self.media_bit_rate.parent = self
                                                                            self._children_name_map["media_bit_rate"] = "media-bit-rate"
                                                                            self._segment_path = lambda: "ipcbr"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr, ['action_metric_type', 'ip_pkt_rate', 'media_pkt_size', 'media_pkts_per_ip'], name, value)


                                                                        class IpBitRate(Entity):
                                                                            """
                                                                            data rate in bps
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate, self).__init__()

                                                                                self.yang_name = "ip-bit-rate"
                                                                                self.yang_parent_name = "ipcbr"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "ip-bit-rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate, ['value', 'unit'], name, value)


                                                                        class MediaBitRate(Entity):
                                                                            """
                                                                            media data rate in bps
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate, self).__init__()

                                                                                self.yang_name = "media-bit-rate"
                                                                                self.yang_parent_name = "ipcbr"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "media-bit-rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate, ['value', 'unit'], name, value)


                                                                    class Rtp(Entity):
                                                                        """
                                                                        rtp
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: min_sequential
                                                                        
                                                                        	min sequential
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_dropout
                                                                        
                                                                        	max dropout
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_misorder
                                                                        
                                                                        	max misorder
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: seq_ext_cop4
                                                                        
                                                                        	enable seq extension cop4
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: clock_rate
                                                                        
                                                                        	clock rate
                                                                        	**type**\: list of  		 :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp, self).__init__()

                                                                            self.yang_name = "rtp"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("clock-rate", ("clock_rate", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate))])
                                                                            self._leafs = OrderedDict([
                                                                                ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                                ('min_sequential', (YLeaf(YType.uint32, 'min-sequential'), ['int'])),
                                                                                ('max_dropout', (YLeaf(YType.uint32, 'max-dropout'), ['int'])),
                                                                                ('max_misorder', (YLeaf(YType.uint32, 'max-misorder'), ['int'])),
                                                                                ('seq_ext_cop4', (YLeaf(YType.uint32, 'seq-ext-cop4'), ['int'])),
                                                                            ])
                                                                            self.action_metric_type = None
                                                                            self.min_sequential = None
                                                                            self.max_dropout = None
                                                                            self.max_misorder = None
                                                                            self.seq_ext_cop4 = None

                                                                            self.clock_rate = YList(self)
                                                                            self._segment_path = lambda: "rtp"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp, ['action_metric_type', 'min_sequential', 'max_dropout', 'max_misorder', 'seq_ext_cop4'], name, value)


                                                                        class ClockRate(Entity):
                                                                            """
                                                                            clock rate
                                                                            
                                                                            .. attribute:: pt
                                                                            
                                                                            	pt
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: frequency
                                                                            
                                                                            	frequency
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate, self).__init__()

                                                                                self.yang_name = "clock-rate"
                                                                                self.yang_parent_name = "rtp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('pt', (YLeaf(YType.uint32, 'pt'), ['int'])),
                                                                                    ('frequency', (YLeaf(YType.uint32, 'frequency'), ['int'])),
                                                                                ])
                                                                                self.pt = None
                                                                                self.frequency = None
                                                                                self._segment_path = lambda: "clock-rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate, ['pt', 'frequency'], name, value)


                                                                    class RtpMmr(Entity):
                                                                        """
                                                                        rtp mmr
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: min_sequential
                                                                        
                                                                        	min sequential
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_dropout
                                                                        
                                                                        	max dropout
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_misorder
                                                                        
                                                                        	max misorder
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: seq_ext_cop4
                                                                        
                                                                        	enable seq extension cop4
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: clock_rate
                                                                        
                                                                        	clock rate
                                                                        	**type**\: list of  		 :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr, self).__init__()

                                                                            self.yang_name = "rtp-mmr"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("clock-rate", ("clock_rate", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate))])
                                                                            self._leafs = OrderedDict([
                                                                                ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                                ('min_sequential', (YLeaf(YType.uint32, 'min-sequential'), ['int'])),
                                                                                ('max_dropout', (YLeaf(YType.uint32, 'max-dropout'), ['int'])),
                                                                                ('max_misorder', (YLeaf(YType.uint32, 'max-misorder'), ['int'])),
                                                                                ('seq_ext_cop4', (YLeaf(YType.uint32, 'seq-ext-cop4'), ['int'])),
                                                                            ])
                                                                            self.action_metric_type = None
                                                                            self.min_sequential = None
                                                                            self.max_dropout = None
                                                                            self.max_misorder = None
                                                                            self.seq_ext_cop4 = None

                                                                            self.clock_rate = YList(self)
                                                                            self._segment_path = lambda: "rtp-mmr"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr, ['action_metric_type', 'min_sequential', 'max_dropout', 'max_misorder', 'seq_ext_cop4'], name, value)


                                                                        class ClockRate(Entity):
                                                                            """
                                                                            clock rate
                                                                            
                                                                            .. attribute:: pt
                                                                            
                                                                            	pt
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: frequency
                                                                            
                                                                            	frequency
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate, self).__init__()

                                                                                self.yang_name = "clock-rate"
                                                                                self.yang_parent_name = "rtp-mmr"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('pt', (YLeaf(YType.uint32, 'pt'), ['int'])),
                                                                                    ('frequency', (YLeaf(YType.uint32, 'frequency'), ['int'])),
                                                                                ])
                                                                                self.pt = None
                                                                                self.frequency = None
                                                                                self._segment_path = lambda: "clock-rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate, ['pt', 'frequency'], name, value)


                                                                    class RtpJ2k(Entity):
                                                                        """
                                                                        rtp j2k
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: min_sequential
                                                                        
                                                                        	min sequential
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_dropout
                                                                        
                                                                        	max dropout
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_misorder
                                                                        
                                                                        	max misorder
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: seq_ext_cop4
                                                                        
                                                                        	enable seq extension cop4
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: clock_rate
                                                                        
                                                                        	clock rate
                                                                        	**type**\: list of  		 :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k.ClockRate>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k, self).__init__()

                                                                            self.yang_name = "rtp-j2k"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("clock-rate", ("clock_rate", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k.ClockRate))])
                                                                            self._leafs = OrderedDict([
                                                                                ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                                ('min_sequential', (YLeaf(YType.uint32, 'min-sequential'), ['int'])),
                                                                                ('max_dropout', (YLeaf(YType.uint32, 'max-dropout'), ['int'])),
                                                                                ('max_misorder', (YLeaf(YType.uint32, 'max-misorder'), ['int'])),
                                                                                ('seq_ext_cop4', (YLeaf(YType.uint32, 'seq-ext-cop4'), ['int'])),
                                                                            ])
                                                                            self.action_metric_type = None
                                                                            self.min_sequential = None
                                                                            self.max_dropout = None
                                                                            self.max_misorder = None
                                                                            self.seq_ext_cop4 = None

                                                                            self.clock_rate = YList(self)
                                                                            self._segment_path = lambda: "rtp-j2k"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k, ['action_metric_type', 'min_sequential', 'max_dropout', 'max_misorder', 'seq_ext_cop4'], name, value)


                                                                        class ClockRate(Entity):
                                                                            """
                                                                            clock rate
                                                                            
                                                                            .. attribute:: pt
                                                                            
                                                                            	pt
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: frequency
                                                                            
                                                                            	frequency
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k.ClockRate, self).__init__()

                                                                                self.yang_name = "clock-rate"
                                                                                self.yang_parent_name = "rtp-j2k"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('pt', (YLeaf(YType.uint32, 'pt'), ['int'])),
                                                                                    ('frequency', (YLeaf(YType.uint32, 'frequency'), ['int'])),
                                                                                ])
                                                                                self.pt = None
                                                                                self.frequency = None
                                                                                self._segment_path = lambda: "clock-rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k.ClockRate, ['pt', 'frequency'], name, value)


                                                                    class RtpVoice(Entity):
                                                                        """
                                                                        rtp voice
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: min_sequential
                                                                        
                                                                        	min sequential
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_dropout
                                                                        
                                                                        	max dropout
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_misorder
                                                                        
                                                                        	max misorder
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: seq_ext_cop4
                                                                        
                                                                        	enable seq extension cop4
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: clock_rate
                                                                        
                                                                        	clock rate
                                                                        	**type**\: list of  		 :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice, self).__init__()

                                                                            self.yang_name = "rtp-voice"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("clock-rate", ("clock_rate", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate))])
                                                                            self._leafs = OrderedDict([
                                                                                ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                                ('min_sequential', (YLeaf(YType.uint32, 'min-sequential'), ['int'])),
                                                                                ('max_dropout', (YLeaf(YType.uint32, 'max-dropout'), ['int'])),
                                                                                ('max_misorder', (YLeaf(YType.uint32, 'max-misorder'), ['int'])),
                                                                                ('seq_ext_cop4', (YLeaf(YType.uint32, 'seq-ext-cop4'), ['int'])),
                                                                            ])
                                                                            self.action_metric_type = None
                                                                            self.min_sequential = None
                                                                            self.max_dropout = None
                                                                            self.max_misorder = None
                                                                            self.seq_ext_cop4 = None

                                                                            self.clock_rate = YList(self)
                                                                            self._segment_path = lambda: "rtp-voice"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice, ['action_metric_type', 'min_sequential', 'max_dropout', 'max_misorder', 'seq_ext_cop4'], name, value)


                                                                        class ClockRate(Entity):
                                                                            """
                                                                            clock rate
                                                                            
                                                                            .. attribute:: pt
                                                                            
                                                                            	pt
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: frequency
                                                                            
                                                                            	frequency
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate, self).__init__()

                                                                                self.yang_name = "clock-rate"
                                                                                self.yang_parent_name = "rtp-voice"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('pt', (YLeaf(YType.uint32, 'pt'), ['int'])),
                                                                                    ('frequency', (YLeaf(YType.uint32, 'frequency'), ['int'])),
                                                                                ])
                                                                                self.pt = None
                                                                                self.frequency = None
                                                                                self._segment_path = lambda: "clock-rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate, ['pt', 'frequency'], name, value)


                                                                    class Mdi(Entity):
                                                                        """
                                                                        mdi
                                                                        
                                                                        .. attribute:: ip_bit_rate
                                                                        
                                                                        	data rate in bps
                                                                        	**type**\:  :py:class:`IpBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate>`
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: filtered_pkt_rate
                                                                        
                                                                        	filtered packet rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: ip_pkt_rate
                                                                        
                                                                        	packet rate in pps
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: pids
                                                                        
                                                                        	array of monitoredcd  pids
                                                                        	**type**\: list of int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi, self).__init__()

                                                                            self.yang_name = "mdi"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("ip-bit-rate", ("ip_bit_rate", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate))])
                                                                            self._leafs = OrderedDict([
                                                                                ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                                ('filtered_pkt_rate', (YLeaf(YType.uint32, 'filtered-pkt-rate'), ['int'])),
                                                                                ('ip_pkt_rate', (YLeaf(YType.uint32, 'ip-pkt-rate'), ['int'])),
                                                                                ('pids', (YLeafList(YType.uint32, 'pids'), ['int'])),
                                                                            ])
                                                                            self.action_metric_type = None
                                                                            self.filtered_pkt_rate = None
                                                                            self.ip_pkt_rate = None
                                                                            self.pids = []

                                                                            self.ip_bit_rate = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate()
                                                                            self.ip_bit_rate.parent = self
                                                                            self._children_name_map["ip_bit_rate"] = "ip-bit-rate"
                                                                            self._segment_path = lambda: "mdi"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi, ['action_metric_type', 'filtered_pkt_rate', 'ip_pkt_rate', 'pids'], name, value)


                                                                        class IpBitRate(Entity):
                                                                            """
                                                                            data rate in bps
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate, self).__init__()

                                                                                self.yang_name = "ip-bit-rate"
                                                                                self.yang_parent_name = "mdi"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "ip-bit-rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate, ['value', 'unit'], name, value)


                                                                    class MdiRtp(Entity):
                                                                        """
                                                                        mdi rtp
                                                                        
                                                                        .. attribute:: ip_bit_rate
                                                                        
                                                                        	data rate in bps
                                                                        	**type**\:  :py:class:`IpBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate>`
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: filtered_pkt_rate
                                                                        
                                                                        	filtered packet rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: ip_pkt_rate
                                                                        
                                                                        	packet rate in pps
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: pids
                                                                        
                                                                        	array of monitoredcd  pids
                                                                        	**type**\: list of int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp, self).__init__()

                                                                            self.yang_name = "mdi-rtp"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("ip-bit-rate", ("ip_bit_rate", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate))])
                                                                            self._leafs = OrderedDict([
                                                                                ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                                ('filtered_pkt_rate', (YLeaf(YType.uint32, 'filtered-pkt-rate'), ['int'])),
                                                                                ('ip_pkt_rate', (YLeaf(YType.uint32, 'ip-pkt-rate'), ['int'])),
                                                                                ('pids', (YLeafList(YType.uint32, 'pids'), ['int'])),
                                                                            ])
                                                                            self.action_metric_type = None
                                                                            self.filtered_pkt_rate = None
                                                                            self.ip_pkt_rate = None
                                                                            self.pids = []

                                                                            self.ip_bit_rate = PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate()
                                                                            self.ip_bit_rate.parent = self
                                                                            self._children_name_map["ip_bit_rate"] = "ip-bit-rate"
                                                                            self._segment_path = lambda: "mdi-rtp"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp, ['action_metric_type', 'filtered_pkt_rate', 'ip_pkt_rate', 'pids'], name, value)


                                                                        class IpBitRate(Entity):
                                                                            """
                                                                            data rate in bps
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate, self).__init__()

                                                                                self.yang_name = "ip-bit-rate"
                                                                                self.yang_parent_name = "mdi-rtp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "ip-bit-rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate, ['value', 'unit'], name, value)


                                                                    class Fmm(Entity):
                                                                        """
                                                                        fmm
                                                                        
                                                                        .. attribute:: fmm_name
                                                                        
                                                                        	flow monitor name
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..33
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm, self).__init__()

                                                                            self.yang_name = "fmm"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('fmm_name', (YLeaf(YType.str, 'fmm-name'), ['str'])),
                                                                            ])
                                                                            self.fmm_name = None
                                                                            self._segment_path = lambda: "fmm"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm, ['fmm_name'], name, value)


                                                                    class Pbf(Entity):
                                                                        """
                                                                        pbf
                                                                        
                                                                        .. attribute:: action_pbf_info_array
                                                                        
                                                                        	action pbf info array
                                                                        	**type**\: list of  		 :py:class:`ActionPbfInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf, self).__init__()

                                                                            self.yang_name = "pbf"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("action-pbf-info-array", ("action_pbf_info_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.action_pbf_info_array = YList(self)
                                                                            self._segment_path = lambda: "pbf"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf, [], name, value)


                                                                        class ActionPbfInfoArray(Entity):
                                                                            """
                                                                            action pbf info array
                                                                            
                                                                            .. attribute:: addr
                                                                            
                                                                            	v4 or v6 address
                                                                            	**type**\: str
                                                                            
                                                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                            
                                                                            .. attribute:: vrf
                                                                            
                                                                            	vrf name
                                                                            	**type**\: str
                                                                            
                                                                            .. attribute:: rt_type
                                                                            
                                                                            	route target type
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: rt
                                                                            
                                                                            	route target
                                                                            	**type**\: str
                                                                            
                                                                            	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray, self).__init__()

                                                                                self.yang_name = "action-pbf-info-array"
                                                                                self.yang_parent_name = "pbf"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('addr', (YLeaf(YType.str, 'addr'), ['str'])),
                                                                                    ('vrf', (YLeaf(YType.str, 'vrf'), ['str'])),
                                                                                    ('rt_type', (YLeaf(YType.uint8, 'rt-type'), ['int'])),
                                                                                    ('rt', (YLeaf(YType.str, 'rt'), ['str'])),
                                                                                ])
                                                                                self.addr = None
                                                                                self.vrf = None
                                                                                self.rt_type = None
                                                                                self.rt = None
                                                                                self._segment_path = lambda: "action-pbf-info-array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray, ['addr', 'vrf', 'rt_type', 'rt'], name, value)


                                                                    class Ipv4Nh(Entity):
                                                                        """
                                                                        ipv4 nh
                                                                        
                                                                        .. attribute:: action_ipv4_nh_info_array
                                                                        
                                                                        	action ipv4 nh info array
                                                                        	**type**\: list of  		 :py:class:`ActionIpv4NhInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh, self).__init__()

                                                                            self.yang_name = "ipv4-nh"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("action-ipv4-nh-info-array", ("action_ipv4_nh_info_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.action_ipv4_nh_info_array = YList(self)
                                                                            self._segment_path = lambda: "ipv4-nh"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh, [], name, value)


                                                                        class ActionIpv4NhInfoArray(Entity):
                                                                            """
                                                                            action ipv4 nh info array
                                                                            
                                                                            .. attribute:: nh_addr
                                                                            
                                                                            	nh addr
                                                                            	**type**\: str
                                                                            
                                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                            
                                                                            .. attribute:: vrf_name
                                                                            
                                                                            	Vrf name
                                                                            	**type**\: str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray, self).__init__()

                                                                                self.yang_name = "action-ipv4-nh-info-array"
                                                                                self.yang_parent_name = "ipv4-nh"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('nh_addr', (YLeaf(YType.str, 'nh-addr'), ['str'])),
                                                                                    ('vrf_name', (YLeaf(YType.str, 'vrf-name'), ['str'])),
                                                                                ])
                                                                                self.nh_addr = None
                                                                                self.vrf_name = None
                                                                                self._segment_path = lambda: "action-ipv4-nh-info-array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray, ['nh_addr', 'vrf_name'], name, value)


                                                                    class Ipv6Nh(Entity):
                                                                        """
                                                                        ipv6 nh
                                                                        
                                                                        .. attribute:: action_ipv6_nh_info_array
                                                                        
                                                                        	action ipv6 nh info array
                                                                        	**type**\: list of  		 :py:class:`ActionIpv6NhInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh, self).__init__()

                                                                            self.yang_name = "ipv6-nh"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("action-ipv6-nh-info-array", ("action_ipv6_nh_info_array", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.action_ipv6_nh_info_array = YList(self)
                                                                            self._segment_path = lambda: "ipv6-nh"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh, [], name, value)


                                                                        class ActionIpv6NhInfoArray(Entity):
                                                                            """
                                                                            action ipv6 nh info array
                                                                            
                                                                            .. attribute:: nh_addr
                                                                            
                                                                            	IPV6 Address
                                                                            	**type**\: str
                                                                            
                                                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                            
                                                                            .. attribute:: vrf_name
                                                                            
                                                                            	Vrf name
                                                                            	**type**\: str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray, self).__init__()

                                                                                self.yang_name = "action-ipv6-nh-info-array"
                                                                                self.yang_parent_name = "ipv6-nh"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('nh_addr', (YLeaf(YType.str, 'nh-addr'), ['str'])),
                                                                                    ('vrf_name', (YLeaf(YType.str, 'vrf-name'), ['str'])),
                                                                                ])
                                                                                self.nh_addr = None
                                                                                self.vrf_name = None
                                                                                self._segment_path = lambda: "action-ipv6-nh-info-array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray, ['nh_addr', 'vrf_name'], name, value)


                                class PmapVarList(Entity):
                                    """
                                    pmap var list
                                    
                                    .. attribute:: var_list
                                    
                                    	var list
                                    	**type**\: list of  		 :py:class:`VarList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.PmapVarList.VarList>`
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2018-01-17'

                                    def __init__(self):
                                        super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.PmapVarList, self).__init__()

                                        self.yang_name = "pmap-var-list"
                                        self.yang_parent_name = "detail"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("var-list", ("var_list", PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.PmapVarList.VarList))])
                                        self._leafs = OrderedDict()

                                        self.var_list = YList(self)
                                        self._segment_path = lambda: "pmap-var-list"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.PmapVarList, [], name, value)


                                    class VarList(Entity):
                                        """
                                        var list
                                        
                                        .. attribute:: type
                                        
                                        	type
                                        	**type**\:  :py:class:`PlmgrVarTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrVarTypeEn>`
                                        
                                        .. attribute:: class_name
                                        
                                        	class name
                                        	**type**\: str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: uint8_val
                                        
                                        	uint8 val
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: uint16_val
                                        
                                        	uint16 val
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: uint32_val
                                        
                                        	uint32 val
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: param_uint32_val
                                        
                                        	param uint32 val
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: dscp_val
                                        
                                        	dscp val
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: prec_val
                                        
                                        	prec val
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'infra-policymgr-oper'
                                        _revision = '2018-01-17'

                                        def __init__(self):
                                            super(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.PmapVarList.VarList, self).__init__()

                                            self.yang_name = "var-list"
                                            self.yang_parent_name = "pmap-var-list"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PlmgrVarTypeEn', '')])),
                                                ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                ('uint8_val', (YLeaf(YType.uint8, 'uint8_val'), ['int'])),
                                                ('uint16_val', (YLeaf(YType.uint16, 'uint16_val'), ['int'])),
                                                ('uint32_val', (YLeaf(YType.uint32, 'uint32_val'), ['int'])),
                                                ('param_uint32_val', (YLeaf(YType.uint32, 'param-uint32-val'), ['int'])),
                                                ('dscp_val', (YLeaf(YType.uint8, 'dscp-val'), ['int'])),
                                                ('prec_val', (YLeaf(YType.uint8, 'prec-val'), ['int'])),
                                            ])
                                            self.type = None
                                            self.class_name = None
                                            self.uint8_val = None
                                            self.uint16_val = None
                                            self.uint32_val = None
                                            self.param_uint32_val = None
                                            self.dscp_val = None
                                            self.prec_val = None
                                            self._segment_path = lambda: "var-list"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(PolicyManager.Global.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.PmapVarList.VarList, ['type', 'class_name', 'uint8_val', 'uint16_val', 'uint32_val', 'param_uint32_val', 'dscp_val', 'prec_val'], name, value)


        class TransientPolicyMapTargetsTypes(Entity):
            """
            Transient policy\-map target table
            
            .. attribute:: transient_policy_map_targets_type
            
            	Transient Policymgr application type
            	**type**\: list of  		 :py:class:`TransientPolicyMapTargetsType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapTargetsTypes.TransientPolicyMapTargetsType>`
            
            

            """

            _prefix = 'infra-policymgr-oper'
            _revision = '2018-01-17'

            def __init__(self):
                super(PolicyManager.Global.TransientPolicyMapTargetsTypes, self).__init__()

                self.yang_name = "transient-policy-map-targets-types"
                self.yang_parent_name = "global"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("transient-policy-map-targets-type", ("transient_policy_map_targets_type", PolicyManager.Global.TransientPolicyMapTargetsTypes.TransientPolicyMapTargetsType))])
                self._leafs = OrderedDict()

                self.transient_policy_map_targets_type = YList(self)
                self._segment_path = lambda: "transient-policy-map-targets-types"
                self._absolute_path = lambda: "Cisco-IOS-XR-infra-policymgr-oper:policy-manager/global/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(PolicyManager.Global.TransientPolicyMapTargetsTypes, [], name, value)


            class TransientPolicyMapTargetsType(Entity):
                """
                Transient Policymgr application type
                
                .. attribute:: type  (key)
                
                	The application type
                	**type**\:  :py:class:`PolicymgrPolicyMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicymgrPolicyMap>`
                
                .. attribute:: transient_target_summary_per_policy_maps
                
                	Transient Policy\-map table per Policy\-map
                	**type**\:  :py:class:`TransientTargetSummaryPerPolicyMaps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapTargetsTypes.TransientPolicyMapTargetsType.TransientTargetSummaryPerPolicyMaps>`
                
                .. attribute:: transient_policy_map_target_summary
                
                	Transient Policy\-map table
                	**type**\:  :py:class:`TransientPolicyMapTargetSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapTargetsTypes.TransientPolicyMapTargetsType.TransientPolicyMapTargetSummary>`
                
                .. attribute:: transient_policy_map_targets
                
                	Transient Policy\-map table
                	**type**\:  :py:class:`TransientPolicyMapTargets <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapTargetsTypes.TransientPolicyMapTargetsType.TransientPolicyMapTargets>`
                
                

                """

                _prefix = 'infra-policymgr-oper'
                _revision = '2018-01-17'

                def __init__(self):
                    super(PolicyManager.Global.TransientPolicyMapTargetsTypes.TransientPolicyMapTargetsType, self).__init__()

                    self.yang_name = "transient-policy-map-targets-type"
                    self.yang_parent_name = "transient-policy-map-targets-types"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = ['type']
                    self._child_classes = OrderedDict([("transient-target-summary-per-policy-maps", ("transient_target_summary_per_policy_maps", PolicyManager.Global.TransientPolicyMapTargetsTypes.TransientPolicyMapTargetsType.TransientTargetSummaryPerPolicyMaps)), ("transient-policy-map-target-summary", ("transient_policy_map_target_summary", PolicyManager.Global.TransientPolicyMapTargetsTypes.TransientPolicyMapTargetsType.TransientPolicyMapTargetSummary)), ("transient-policy-map-targets", ("transient_policy_map_targets", PolicyManager.Global.TransientPolicyMapTargetsTypes.TransientPolicyMapTargetsType.TransientPolicyMapTargets))])
                    self._leafs = OrderedDict([
                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicymgrPolicyMap', '')])),
                    ])
                    self.type = None

                    self.transient_target_summary_per_policy_maps = PolicyManager.Global.TransientPolicyMapTargetsTypes.TransientPolicyMapTargetsType.TransientTargetSummaryPerPolicyMaps()
                    self.transient_target_summary_per_policy_maps.parent = self
                    self._children_name_map["transient_target_summary_per_policy_maps"] = "transient-target-summary-per-policy-maps"

                    self.transient_policy_map_target_summary = PolicyManager.Global.TransientPolicyMapTargetsTypes.TransientPolicyMapTargetsType.TransientPolicyMapTargetSummary()
                    self.transient_policy_map_target_summary.parent = self
                    self._children_name_map["transient_policy_map_target_summary"] = "transient-policy-map-target-summary"

                    self.transient_policy_map_targets = PolicyManager.Global.TransientPolicyMapTargetsTypes.TransientPolicyMapTargetsType.TransientPolicyMapTargets()
                    self.transient_policy_map_targets.parent = self
                    self._children_name_map["transient_policy_map_targets"] = "transient-policy-map-targets"
                    self._segment_path = lambda: "transient-policy-map-targets-type" + "[type='" + str(self.type) + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-infra-policymgr-oper:policy-manager/global/transient-policy-map-targets-types/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapTargetsTypes.TransientPolicyMapTargetsType, ['type'], name, value)


                class TransientTargetSummaryPerPolicyMaps(Entity):
                    """
                    Transient Policy\-map table per Policy\-map
                    
                    .. attribute:: transient_target_summary_per_policy_map
                    
                    	Policy\-map targets summary
                    	**type**\: list of  		 :py:class:`TransientTargetSummaryPerPolicyMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapTargetsTypes.TransientPolicyMapTargetsType.TransientTargetSummaryPerPolicyMaps.TransientTargetSummaryPerPolicyMap>`
                    
                    

                    """

                    _prefix = 'infra-policymgr-oper'
                    _revision = '2018-01-17'

                    def __init__(self):
                        super(PolicyManager.Global.TransientPolicyMapTargetsTypes.TransientPolicyMapTargetsType.TransientTargetSummaryPerPolicyMaps, self).__init__()

                        self.yang_name = "transient-target-summary-per-policy-maps"
                        self.yang_parent_name = "transient-policy-map-targets-type"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("transient-target-summary-per-policy-map", ("transient_target_summary_per_policy_map", PolicyManager.Global.TransientPolicyMapTargetsTypes.TransientPolicyMapTargetsType.TransientTargetSummaryPerPolicyMaps.TransientTargetSummaryPerPolicyMap))])
                        self._leafs = OrderedDict()

                        self.transient_target_summary_per_policy_map = YList(self)
                        self._segment_path = lambda: "transient-target-summary-per-policy-maps"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapTargetsTypes.TransientPolicyMapTargetsType.TransientTargetSummaryPerPolicyMaps, [], name, value)


                    class TransientTargetSummaryPerPolicyMap(Entity):
                        """
                        Policy\-map targets summary
                        
                        .. attribute:: policy_map_name  (key)
                        
                        	Name of policy\-map
                        	**type**\: str
                        
                        	**length:** 1..63
                        
                        .. attribute:: total_policy_maps_input_direction
                        
                        	Total policymapsin the input direction
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: total_policy_maps_output_direction
                        
                        	Total policymapsin the output direction
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: total_child_policy_maps_input_direction
                        
                        	Totalpolicymaps applied as child policy in the input direction
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: total_child_policy_maps_output_direction
                        
                        	Totalpolicymaps applied as child policy in the output direction
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: total_interfaces_input_direction
                        
                        	Totalinterfaces with service\-policy in the input direction
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: total_interfaces_output_direction
                        
                        	Totalinterfaces with service\-policy in the output direction
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'infra-policymgr-oper'
                        _revision = '2018-01-17'

                        def __init__(self):
                            super(PolicyManager.Global.TransientPolicyMapTargetsTypes.TransientPolicyMapTargetsType.TransientTargetSummaryPerPolicyMaps.TransientTargetSummaryPerPolicyMap, self).__init__()

                            self.yang_name = "transient-target-summary-per-policy-map"
                            self.yang_parent_name = "transient-target-summary-per-policy-maps"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = ['policy_map_name']
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('policy_map_name', (YLeaf(YType.str, 'policy-map-name'), ['str'])),
                                ('total_policy_maps_input_direction', (YLeaf(YType.uint32, 'total-policy-maps-input-direction'), ['int'])),
                                ('total_policy_maps_output_direction', (YLeaf(YType.uint32, 'total-policy-maps-output-direction'), ['int'])),
                                ('total_child_policy_maps_input_direction', (YLeaf(YType.uint32, 'total-child-policy-maps-input-direction'), ['int'])),
                                ('total_child_policy_maps_output_direction', (YLeaf(YType.uint32, 'total-child-policy-maps-output-direction'), ['int'])),
                                ('total_interfaces_input_direction', (YLeaf(YType.uint32, 'total-interfaces-input-direction'), ['int'])),
                                ('total_interfaces_output_direction', (YLeaf(YType.uint32, 'total-interfaces-output-direction'), ['int'])),
                            ])
                            self.policy_map_name = None
                            self.total_policy_maps_input_direction = None
                            self.total_policy_maps_output_direction = None
                            self.total_child_policy_maps_input_direction = None
                            self.total_child_policy_maps_output_direction = None
                            self.total_interfaces_input_direction = None
                            self.total_interfaces_output_direction = None
                            self._segment_path = lambda: "transient-target-summary-per-policy-map" + "[policy-map-name='" + str(self.policy_map_name) + "']"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapTargetsTypes.TransientPolicyMapTargetsType.TransientTargetSummaryPerPolicyMaps.TransientTargetSummaryPerPolicyMap, ['policy_map_name', 'total_policy_maps_input_direction', 'total_policy_maps_output_direction', 'total_child_policy_maps_input_direction', 'total_child_policy_maps_output_direction', 'total_interfaces_input_direction', 'total_interfaces_output_direction'], name, value)


                class TransientPolicyMapTargetSummary(Entity):
                    """
                    Transient Policy\-map table
                    
                    .. attribute:: total_policy_maps_input_direction
                    
                    	Total policymapsin the input direction
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: total_policy_maps_output_direction
                    
                    	Total policymapsin the output direction
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: total_child_policy_maps_input_direction
                    
                    	Totalpolicymaps applied as child policy in the input direction
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: total_child_policy_maps_output_direction
                    
                    	Totalpolicymaps applied as child policy in the output direction
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: total_interfaces_input_direction
                    
                    	Totalinterfaces with service\-policy in the input direction
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: total_interfaces_output_direction
                    
                    	Totalinterfaces with service\-policy in the output direction
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'infra-policymgr-oper'
                    _revision = '2018-01-17'

                    def __init__(self):
                        super(PolicyManager.Global.TransientPolicyMapTargetsTypes.TransientPolicyMapTargetsType.TransientPolicyMapTargetSummary, self).__init__()

                        self.yang_name = "transient-policy-map-target-summary"
                        self.yang_parent_name = "transient-policy-map-targets-type"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('total_policy_maps_input_direction', (YLeaf(YType.uint32, 'total-policy-maps-input-direction'), ['int'])),
                            ('total_policy_maps_output_direction', (YLeaf(YType.uint32, 'total-policy-maps-output-direction'), ['int'])),
                            ('total_child_policy_maps_input_direction', (YLeaf(YType.uint32, 'total-child-policy-maps-input-direction'), ['int'])),
                            ('total_child_policy_maps_output_direction', (YLeaf(YType.uint32, 'total-child-policy-maps-output-direction'), ['int'])),
                            ('total_interfaces_input_direction', (YLeaf(YType.uint32, 'total-interfaces-input-direction'), ['int'])),
                            ('total_interfaces_output_direction', (YLeaf(YType.uint32, 'total-interfaces-output-direction'), ['int'])),
                        ])
                        self.total_policy_maps_input_direction = None
                        self.total_policy_maps_output_direction = None
                        self.total_child_policy_maps_input_direction = None
                        self.total_child_policy_maps_output_direction = None
                        self.total_interfaces_input_direction = None
                        self.total_interfaces_output_direction = None
                        self._segment_path = lambda: "transient-policy-map-target-summary"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapTargetsTypes.TransientPolicyMapTargetsType.TransientPolicyMapTargetSummary, ['total_policy_maps_input_direction', 'total_policy_maps_output_direction', 'total_child_policy_maps_input_direction', 'total_child_policy_maps_output_direction', 'total_interfaces_input_direction', 'total_interfaces_output_direction'], name, value)


                class TransientPolicyMapTargets(Entity):
                    """
                    Transient Policy\-map table
                    
                    .. attribute:: transient_policy_map_target
                    
                    	Transient Policy\-map targets
                    	**type**\: list of  		 :py:class:`TransientPolicyMapTarget <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapTargetsTypes.TransientPolicyMapTargetsType.TransientPolicyMapTargets.TransientPolicyMapTarget>`
                    
                    

                    """

                    _prefix = 'infra-policymgr-oper'
                    _revision = '2018-01-17'

                    def __init__(self):
                        super(PolicyManager.Global.TransientPolicyMapTargetsTypes.TransientPolicyMapTargetsType.TransientPolicyMapTargets, self).__init__()

                        self.yang_name = "transient-policy-map-targets"
                        self.yang_parent_name = "transient-policy-map-targets-type"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("transient-policy-map-target", ("transient_policy_map_target", PolicyManager.Global.TransientPolicyMapTargetsTypes.TransientPolicyMapTargetsType.TransientPolicyMapTargets.TransientPolicyMapTarget))])
                        self._leafs = OrderedDict()

                        self.transient_policy_map_target = YList(self)
                        self._segment_path = lambda: "transient-policy-map-targets"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapTargetsTypes.TransientPolicyMapTargetsType.TransientPolicyMapTargets, [], name, value)


                    class TransientPolicyMapTarget(Entity):
                        """
                        Transient Policy\-map targets
                        
                        .. attribute:: policy_map_name  (key)
                        
                        	Name of policy\-map
                        	**type**\: str
                        
                        	**length:** 1..63
                        
                        .. attribute:: targets
                        
                        	targets
                        	**type**\: list of str
                        
                        .. attribute:: parent_targets
                        
                        	parent targets
                        	**type**\: list of str
                        
                        

                        """

                        _prefix = 'infra-policymgr-oper'
                        _revision = '2018-01-17'

                        def __init__(self):
                            super(PolicyManager.Global.TransientPolicyMapTargetsTypes.TransientPolicyMapTargetsType.TransientPolicyMapTargets.TransientPolicyMapTarget, self).__init__()

                            self.yang_name = "transient-policy-map-target"
                            self.yang_parent_name = "transient-policy-map-targets"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = ['policy_map_name']
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('policy_map_name', (YLeaf(YType.str, 'policy-map-name'), ['str'])),
                                ('targets', (YLeafList(YType.str, 'targets'), ['str'])),
                                ('parent_targets', (YLeafList(YType.str, 'parent-targets'), ['str'])),
                            ])
                            self.policy_map_name = None
                            self.targets = []
                            self.parent_targets = []
                            self._segment_path = lambda: "transient-policy-map-target" + "[policy-map-name='" + str(self.policy_map_name) + "']"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapTargetsTypes.TransientPolicyMapTargetsType.TransientPolicyMapTargets.TransientPolicyMapTarget, ['policy_map_name', 'targets', 'parent_targets'], name, value)


        class TransientPolicyMapAppliedTypes(Entity):
            """
            Transient policy\-map applied type
            
            .. attribute:: transient_policy_map_applied_type
            
            	Transient policy\-map applied type
            	**type**\: list of  		 :py:class:`TransientPolicyMapAppliedType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType>`
            
            

            """

            _prefix = 'infra-policymgr-oper'
            _revision = '2018-01-17'

            def __init__(self):
                super(PolicyManager.Global.TransientPolicyMapAppliedTypes, self).__init__()

                self.yang_name = "transient-policy-map-applied-types"
                self.yang_parent_name = "global"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("transient-policy-map-applied-type", ("transient_policy_map_applied_type", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType))])
                self._leafs = OrderedDict()

                self.transient_policy_map_applied_type = YList(self)
                self._segment_path = lambda: "transient-policy-map-applied-types"
                self._absolute_path = lambda: "Cisco-IOS-XR-infra-policymgr-oper:policy-manager/global/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes, [], name, value)


            class TransientPolicyMapAppliedType(Entity):
                """
                Transient policy\-map applied type
                
                .. attribute:: type  (key)
                
                	The application type
                	**type**\:  :py:class:`PolicymgrPolicyMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicymgrPolicyMap>`
                
                .. attribute:: transient_interface_names
                
                	Interface table
                	**type**\:  :py:class:`TransientInterfaceNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames>`
                
                

                """

                _prefix = 'infra-policymgr-oper'
                _revision = '2018-01-17'

                def __init__(self):
                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType, self).__init__()

                    self.yang_name = "transient-policy-map-applied-type"
                    self.yang_parent_name = "transient-policy-map-applied-types"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = ['type']
                    self._child_classes = OrderedDict([("transient-interface-names", ("transient_interface_names", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames))])
                    self._leafs = OrderedDict([
                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicymgrPolicyMap', '')])),
                    ])
                    self.type = None

                    self.transient_interface_names = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames()
                    self.transient_interface_names.parent = self
                    self._children_name_map["transient_interface_names"] = "transient-interface-names"
                    self._segment_path = lambda: "transient-policy-map-applied-type" + "[type='" + str(self.type) + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-infra-policymgr-oper:policy-manager/global/transient-policy-map-applied-types/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType, ['type'], name, value)


                class TransientInterfaceNames(Entity):
                    """
                    Interface table
                    
                    .. attribute:: transient_interface_name
                    
                    	WORD interface name
                    	**type**\: list of  		 :py:class:`TransientInterfaceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName>`
                    
                    

                    """

                    _prefix = 'infra-policymgr-oper'
                    _revision = '2018-01-17'

                    def __init__(self):
                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames, self).__init__()

                        self.yang_name = "transient-interface-names"
                        self.yang_parent_name = "transient-policy-map-applied-type"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("transient-interface-name", ("transient_interface_name", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName))])
                        self._leafs = OrderedDict()

                        self.transient_interface_name = YList(self)
                        self._segment_path = lambda: "transient-interface-names"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames, [], name, value)


                    class TransientInterfaceName(Entity):
                        """
                        WORD interface name
                        
                        .. attribute:: interface_name  (key)
                        
                        	Name of the interface
                        	**type**\: str
                        
                        	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                        
                        .. attribute:: transient_output
                        
                        	Output direction table
                        	**type**\:  :py:class:`TransientOutput <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput>`
                        
                        .. attribute:: transient_input
                        
                        	Input direction table
                        	**type**\:  :py:class:`TransientInput <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput>`
                        
                        

                        """

                        _prefix = 'infra-policymgr-oper'
                        _revision = '2018-01-17'

                        def __init__(self):
                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName, self).__init__()

                            self.yang_name = "transient-interface-name"
                            self.yang_parent_name = "transient-interface-names"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = ['interface_name']
                            self._child_classes = OrderedDict([("transient-output", ("transient_output", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput)), ("transient-input", ("transient_input", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput))])
                            self._leafs = OrderedDict([
                                ('interface_name', (YLeaf(YType.str, 'interface-name'), ['str'])),
                            ])
                            self.interface_name = None

                            self.transient_output = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput()
                            self.transient_output.parent = self
                            self._children_name_map["transient_output"] = "transient-output"

                            self.transient_input = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput()
                            self.transient_input.parent = self
                            self._children_name_map["transient_input"] = "transient-input"
                            self._segment_path = lambda: "transient-interface-name" + "[interface-name='" + str(self.interface_name) + "']"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName, ['interface_name'], name, value)


                        class TransientOutput(Entity):
                            """
                            Output direction table
                            
                            .. attribute:: detail
                            
                            	Policy map
                            	**type**\:  :py:class:`Detail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail>`
                            
                            

                            """

                            _prefix = 'infra-policymgr-oper'
                            _revision = '2018-01-17'

                            def __init__(self):
                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput, self).__init__()

                                self.yang_name = "transient-output"
                                self.yang_parent_name = "transient-interface-name"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("detail", ("detail", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail))])
                                self._leafs = OrderedDict()

                                self.detail = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail()
                                self.detail.parent = self
                                self._children_name_map["detail"] = "detail"
                                self._segment_path = lambda: "transient-output"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput, [], name, value)


                            class Detail(Entity):
                                """
                                Policy map
                                
                                .. attribute:: parent_pmap_name
                                
                                	parent pmap name
                                	**type**\: str
                                
                                	**length:** 0..65
                                
                                .. attribute:: pmap_type
                                
                                	pmap type
                                	**type**\:  :py:class:`PolicyMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyMapTypeEn>`
                                
                                .. attribute:: subscriber_grp
                                
                                	subscriber grp
                                	**type**\: list of str
                                
                                	**length:** 0..65
                                
                                .. attribute:: pmaps
                                
                                	pmaps
                                	**type**\: list of  		 :py:class:`Pmaps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps>`
                                
                                .. attribute:: pmap_var_list
                                
                                	pmap var list
                                	**type**\: list of  		 :py:class:`PmapVarList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.PmapVarList>`
                                
                                

                                """

                                _prefix = 'infra-policymgr-oper'
                                _revision = '2018-01-17'

                                def __init__(self):
                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail, self).__init__()

                                    self.yang_name = "detail"
                                    self.yang_parent_name = "transient-output"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("pmaps", ("pmaps", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps)), ("pmap-var-list", ("pmap_var_list", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.PmapVarList))])
                                    self._leafs = OrderedDict([
                                        ('parent_pmap_name', (YLeaf(YType.str, 'parent-pmap-name'), ['str'])),
                                        ('pmap_type', (YLeaf(YType.enumeration, 'pmap-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyMapTypeEn', '')])),
                                        ('subscriber_grp', (YLeafList(YType.str, 'subscriber-grp'), ['str'])),
                                    ])
                                    self.parent_pmap_name = None
                                    self.pmap_type = None
                                    self.subscriber_grp = []

                                    self.pmaps = YList(self)
                                    self.pmap_var_list = YList(self)
                                    self._segment_path = lambda: "detail"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail, ['parent_pmap_name', 'pmap_type', 'subscriber_grp'], name, value)


                                class Pmaps(Entity):
                                    """
                                    pmaps
                                    
                                    .. attribute:: policy_map_bg
                                    
                                    	policy map bg
                                    	**type**\: list of  		 :py:class:`PolicyMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg>`
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2018-01-17'

                                    def __init__(self):
                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps, self).__init__()

                                        self.yang_name = "pmaps"
                                        self.yang_parent_name = "detail"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("policy-map-bg", ("policy_map_bg", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg))])
                                        self._leafs = OrderedDict()

                                        self.policy_map_bg = YList(self)
                                        self._segment_path = lambda: "pmaps"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps, [], name, value)


                                    class PolicyMapBg(Entity):
                                        """
                                        policy map bg
                                        
                                        .. attribute:: pmap_var_list
                                        
                                        	pmap var list
                                        	**type**\:  :py:class:`PmapVarList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.PmapVarList>`
                                        
                                        .. attribute:: event_infop
                                        
                                        	event infop
                                        	**type**\:  :py:class:`EventInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop>`
                                        
                                        .. attribute:: name
                                        
                                        	name
                                        	**type**\: str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: type
                                        
                                        	type
                                        	**type**\:  :py:class:`PolicyMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyMapTypeEn>`
                                        
                                        .. attribute:: description
                                        
                                        	description
                                        	**type**\: str
                                        
                                        

                                        """

                                        _prefix = 'infra-policymgr-oper'
                                        _revision = '2018-01-17'

                                        def __init__(self):
                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg, self).__init__()

                                            self.yang_name = "policy-map-bg"
                                            self.yang_parent_name = "pmaps"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("pmap-var-list", ("pmap_var_list", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.PmapVarList)), ("event-infop", ("event_infop", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop))])
                                            self._leafs = OrderedDict([
                                                ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyMapTypeEn', '')])),
                                                ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                            ])
                                            self.name = None
                                            self.type = None
                                            self.description = None

                                            self.pmap_var_list = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.PmapVarList()
                                            self.pmap_var_list.parent = self
                                            self._children_name_map["pmap_var_list"] = "pmap-var-list"

                                            self.event_infop = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop()
                                            self.event_infop.parent = self
                                            self._children_name_map["event_infop"] = "event-infop"
                                            self._segment_path = lambda: "policy-map-bg"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg, ['name', 'type', 'description'], name, value)


                                        class PmapVarList(Entity):
                                            """
                                            pmap var list
                                            
                                            .. attribute:: pmap_var_list_arr
                                            
                                            	pmap var list arr
                                            	**type**\: list of  		 :py:class:`PmapVarListArr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.PmapVarList.PmapVarListArr>`
                                            
                                            

                                            """

                                            _prefix = 'infra-policymgr-oper'
                                            _revision = '2018-01-17'

                                            def __init__(self):
                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.PmapVarList, self).__init__()

                                                self.yang_name = "pmap-var-list"
                                                self.yang_parent_name = "policy-map-bg"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("pmap-var-list-arr", ("pmap_var_list_arr", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.PmapVarList.PmapVarListArr))])
                                                self._leafs = OrderedDict()

                                                self.pmap_var_list_arr = YList(self)
                                                self._segment_path = lambda: "pmap-var-list"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.PmapVarList, [], name, value)


                                            class PmapVarListArr(Entity):
                                                """
                                                pmap var list arr
                                                
                                                .. attribute:: val
                                                
                                                	val
                                                	**type**\:  :py:class:`Val <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.PmapVarList.PmapVarListArr.Val>`
                                                
                                                .. attribute:: name
                                                
                                                	name
                                                	**type**\: str
                                                
                                                	**length:** 0..32
                                                
                                                .. attribute:: id
                                                
                                                	id
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.PmapVarList.PmapVarListArr, self).__init__()

                                                    self.yang_name = "pmap-var-list-arr"
                                                    self.yang_parent_name = "pmap-var-list"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("val", ("val", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.PmapVarList.PmapVarListArr.Val))])
                                                    self._leafs = OrderedDict([
                                                        ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                        ('id', (YLeaf(YType.uint32, 'id'), ['int'])),
                                                    ])
                                                    self.name = None
                                                    self.id = None

                                                    self.val = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.PmapVarList.PmapVarListArr.Val()
                                                    self.val.parent = self
                                                    self._children_name_map["val"] = "val"
                                                    self._segment_path = lambda: "pmap-var-list-arr"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.PmapVarList.PmapVarListArr, ['name', 'id'], name, value)


                                                class Val(Entity):
                                                    """
                                                    val
                                                    
                                                    .. attribute:: type
                                                    
                                                    	type
                                                    	**type**\:  :py:class:`PlmgrVarTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrVarTypeEn>`
                                                    
                                                    .. attribute:: class_name
                                                    
                                                    	class name
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..65
                                                    
                                                    .. attribute:: uint8_val
                                                    
                                                    	uint8 val
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: uint16_val
                                                    
                                                    	uint16 val
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: uint32_val
                                                    
                                                    	uint32 val
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: param_uint32_val
                                                    
                                                    	param uint32 val
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: dscp_val
                                                    
                                                    	dscp val
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: prec_val
                                                    
                                                    	prec val
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.PmapVarList.PmapVarListArr.Val, self).__init__()

                                                        self.yang_name = "val"
                                                        self.yang_parent_name = "pmap-var-list-arr"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PlmgrVarTypeEn', '')])),
                                                            ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                            ('uint8_val', (YLeaf(YType.uint8, 'uint8_val'), ['int'])),
                                                            ('uint16_val', (YLeaf(YType.uint16, 'uint16_val'), ['int'])),
                                                            ('uint32_val', (YLeaf(YType.uint32, 'uint32_val'), ['int'])),
                                                            ('param_uint32_val', (YLeaf(YType.uint32, 'param-uint32-val'), ['int'])),
                                                            ('dscp_val', (YLeaf(YType.uint8, 'dscp-val'), ['int'])),
                                                            ('prec_val', (YLeaf(YType.uint8, 'prec-val'), ['int'])),
                                                        ])
                                                        self.type = None
                                                        self.class_name = None
                                                        self.uint8_val = None
                                                        self.uint16_val = None
                                                        self.uint32_val = None
                                                        self.param_uint32_val = None
                                                        self.dscp_val = None
                                                        self.prec_val = None
                                                        self._segment_path = lambda: "val"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.PmapVarList.PmapVarListArr.Val, ['type', 'class_name', 'uint8_val', 'uint16_val', 'uint32_val', 'param_uint32_val', 'dscp_val', 'prec_val'], name, value)


                                        class EventInfop(Entity):
                                            """
                                            event infop
                                            
                                            .. attribute:: policy_event_info_bg
                                            
                                            	policy event info bg
                                            	**type**\: list of  		 :py:class:`PolicyEventInfoBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg>`
                                            
                                            

                                            """

                                            _prefix = 'infra-policymgr-oper'
                                            _revision = '2018-01-17'

                                            def __init__(self):
                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop, self).__init__()

                                                self.yang_name = "event-infop"
                                                self.yang_parent_name = "policy-map-bg"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("policy-event-info-bg", ("policy_event_info_bg", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg))])
                                                self._leafs = OrderedDict()

                                                self.policy_event_info_bg = YList(self)
                                                self._segment_path = lambda: "event-infop"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop, [], name, value)


                                            class PolicyEventInfoBg(Entity):
                                                """
                                                policy event info bg
                                                
                                                .. attribute:: class_infop
                                                
                                                	class infop
                                                	**type**\:  :py:class:`ClassInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop>`
                                                
                                                .. attribute:: event_type
                                                
                                                	event type
                                                	**type**\:  :py:class:`PeventTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PeventTypeEn>`
                                                
                                                .. attribute:: cond_eval
                                                
                                                	cond eval
                                                	**type**\:  :py:class:`PeventCondEvalEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PeventCondEvalEn>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg, self).__init__()

                                                    self.yang_name = "policy-event-info-bg"
                                                    self.yang_parent_name = "event-infop"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("class-infop", ("class_infop", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop))])
                                                    self._leafs = OrderedDict([
                                                        ('event_type', (YLeaf(YType.enumeration, 'event-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PeventTypeEn', '')])),
                                                        ('cond_eval', (YLeaf(YType.enumeration, 'cond-eval'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PeventCondEvalEn', '')])),
                                                    ])
                                                    self.event_type = None
                                                    self.cond_eval = None

                                                    self.class_infop = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop()
                                                    self.class_infop.parent = self
                                                    self._children_name_map["class_infop"] = "class-infop"
                                                    self._segment_path = lambda: "policy-event-info-bg"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg, ['event_type', 'cond_eval'], name, value)


                                                class ClassInfop(Entity):
                                                    """
                                                    class infop
                                                    
                                                    .. attribute:: policy_class_info_bg
                                                    
                                                    	policy class info bg
                                                    	**type**\: list of  		 :py:class:`PolicyClassInfoBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop, self).__init__()

                                                        self.yang_name = "class-infop"
                                                        self.yang_parent_name = "policy-event-info-bg"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("policy-class-info-bg", ("policy_class_info_bg", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg))])
                                                        self._leafs = OrderedDict()

                                                        self.policy_class_info_bg = YList(self)
                                                        self._segment_path = lambda: "class-infop"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop, [], name, value)


                                                    class PolicyClassInfoBg(Entity):
                                                        """
                                                        policy class info bg
                                                        
                                                        .. attribute:: cl_encode
                                                        
                                                        	cl encode
                                                        	**type**\:  :py:class:`ClEncode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode>`
                                                        
                                                        .. attribute:: clmp_p
                                                        
                                                        	clmp p
                                                        	**type**\:  :py:class:`ClmpP <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP>`
                                                        
                                                        .. attribute:: act_infop
                                                        
                                                        	act infop
                                                        	**type**\:  :py:class:`ActInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop>`
                                                        
                                                        .. attribute:: policy_class_hd
                                                        
                                                        	policy class hd
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: seq
                                                        
                                                        	seq
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: flags
                                                        
                                                        	flags
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: ctype
                                                        
                                                        	ctype
                                                        	**type**\:  :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                        
                                                        .. attribute:: num_actions
                                                        
                                                        	num actions
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: version
                                                        
                                                        	version
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        .. attribute:: exe_strat
                                                        
                                                        	exe strat
                                                        	**type**\:  :py:class:`PclassExecStratEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PclassExecStratEn>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2018-01-17'

                                                        def __init__(self):
                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg, self).__init__()

                                                            self.yang_name = "policy-class-info-bg"
                                                            self.yang_parent_name = "class-infop"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("cl-encode", ("cl_encode", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode)), ("clmp-p", ("clmp_p", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP)), ("act-infop", ("act_infop", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop))])
                                                            self._leafs = OrderedDict([
                                                                ('policy_class_hd', (YLeaf(YType.uint32, 'policy-class-hd'), ['int'])),
                                                                ('seq', (YLeaf(YType.uint32, 'seq'), ['int'])),
                                                                ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                ('ctype', (YLeaf(YType.enumeration, 'ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapTypeEn', '')])),
                                                                ('num_actions', (YLeaf(YType.uint16, 'num-actions'), ['int'])),
                                                                ('version', (YLeaf(YType.uint8, 'version'), ['int'])),
                                                                ('exe_strat', (YLeaf(YType.enumeration, 'exe-strat'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PclassExecStratEn', '')])),
                                                            ])
                                                            self.policy_class_hd = None
                                                            self.seq = None
                                                            self.flags = None
                                                            self.ctype = None
                                                            self.num_actions = None
                                                            self.version = None
                                                            self.exe_strat = None

                                                            self.cl_encode = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode()
                                                            self.cl_encode.parent = self
                                                            self._children_name_map["cl_encode"] = "cl-encode"

                                                            self.clmp_p = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP()
                                                            self.clmp_p.parent = self
                                                            self._children_name_map["clmp_p"] = "clmp-p"

                                                            self.act_infop = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop()
                                                            self.act_infop.parent = self
                                                            self._children_name_map["act_infop"] = "act-infop"
                                                            self._segment_path = lambda: "policy-class-info-bg"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg, ['policy_class_hd', 'seq', 'flags', 'ctype', 'num_actions', 'version', 'exe_strat'], name, value)


                                                        class ClEncode(Entity):
                                                            """
                                                            cl encode
                                                            
                                                            .. attribute:: inline_cmap
                                                            
                                                            	inline cmap
                                                            	**type**\:  :py:class:`InlineCmap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap>`
                                                            
                                                            .. attribute:: enc
                                                            
                                                            	enc
                                                            	**type**\:  :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                            
                                                            .. attribute:: class_name
                                                            
                                                            	class name
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..65
                                                            
                                                            .. attribute:: hd
                                                            
                                                            	hd
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: idx
                                                            
                                                            	idx
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..255
                                                            
                                                            

                                                            """

                                                            _prefix = 'infra-policymgr-oper'
                                                            _revision = '2018-01-17'

                                                            def __init__(self):
                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode, self).__init__()

                                                                self.yang_name = "cl-encode"
                                                                self.yang_parent_name = "policy-class-info-bg"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("inline-cmap", ("inline_cmap", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap))])
                                                                self._leafs = OrderedDict([
                                                                    ('enc', (YLeaf(YType.enumeration, 'enc'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyObjEncEn', '')])),
                                                                    ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                                    ('hd', (YLeaf(YType.uint64, 'hd'), ['int'])),
                                                                    ('idx', (YLeaf(YType.uint8, 'idx'), ['int'])),
                                                                ])
                                                                self.enc = None
                                                                self.class_name = None
                                                                self.hd = None
                                                                self.idx = None

                                                                self.inline_cmap = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap()
                                                                self.inline_cmap.parent = self
                                                                self._children_name_map["inline_cmap"] = "inline-cmap"
                                                                self._segment_path = lambda: "cl-encode"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode, ['enc', 'class_name', 'hd', 'idx'], name, value)


                                                            class InlineCmap(Entity):
                                                                """
                                                                inline cmap
                                                                
                                                                .. attribute:: match_infop
                                                                
                                                                	Pointer to the first Match info
                                                                	**type**\:  :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop>`
                                                                
                                                                .. attribute:: mode
                                                                
                                                                	Inline Class\-Map Mode Match any/all
                                                                	**type**\:  :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                
                                                                .. attribute:: flags
                                                                
                                                                	Inline Class\-Map flags
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: match_count
                                                                
                                                                	Number of Match infos
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap, self).__init__()

                                                                    self.yang_name = "inline-cmap"
                                                                    self.yang_parent_name = "cl-encode"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("match-infop", ("match_infop", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop))])
                                                                    self._leafs = OrderedDict([
                                                                        ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapModeEn', '')])),
                                                                        ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                        ('match_count', (YLeaf(YType.uint32, 'match-count'), ['int'])),
                                                                    ])
                                                                    self.mode = None
                                                                    self.flags = None
                                                                    self.match_count = None

                                                                    self.match_infop = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop()
                                                                    self.match_infop.parent = self
                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                    self._segment_path = lambda: "inline-cmap"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap, ['mode', 'flags', 'match_count'], name, value)


                                                                class MatchInfop(Entity):
                                                                    """
                                                                    Pointer to the first Match info
                                                                    
                                                                    .. attribute:: class_match_info_st
                                                                    
                                                                    	class match info st
                                                                    	**type**\: list of  		 :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop, self).__init__()

                                                                        self.yang_name = "match-infop"
                                                                        self.yang_parent_name = "inline-cmap"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("class-match-info-st", ("class_match_info_st", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt))])
                                                                        self._leafs = OrderedDict()

                                                                        self.class_match_info_st = YList(self)
                                                                        self._segment_path = lambda: "match-infop"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop, [], name, value)


                                                                    class ClassMatchInfoSt(Entity):
                                                                        """
                                                                        class match info st
                                                                        
                                                                        .. attribute:: match_data
                                                                        
                                                                        	Match criteria
                                                                        	**type**\:  :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                        
                                                                        .. attribute:: flags
                                                                        
                                                                        	Flags
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                            self.yang_name = "class-match-info-st"
                                                                            self.yang_parent_name = "match-infop"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("match-data", ("match_data", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData))])
                                                                            self._leafs = OrderedDict([
                                                                                ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                            ])
                                                                            self.flags = None

                                                                            self.match_data = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                            self.match_data.parent = self
                                                                            self._children_name_map["match_data"] = "match-data"
                                                                            self._segment_path = lambda: "class-match-info-st"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                        class MatchData(Entity):
                                                                            """
                                                                            Match criteria
                                                                            
                                                                            .. attribute:: ipv4_dscp
                                                                            
                                                                            	IPv4 DSCP
                                                                            	**type**\:  :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                            
                                                                            .. attribute:: ipv6_dscp
                                                                            
                                                                            	IPv6 DSCP
                                                                            	**type**\:  :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                            
                                                                            .. attribute:: dscp
                                                                            
                                                                            	Match DSCP range array
                                                                            	**type**\:  :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                            
                                                                            .. attribute:: ipv4_prec
                                                                            
                                                                            	IPv4 Precedence
                                                                            	**type**\:  :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                            
                                                                            .. attribute:: ipv6_prec
                                                                            
                                                                            	IPv6 Precedence
                                                                            	**type**\:  :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                            
                                                                            .. attribute:: prec
                                                                            
                                                                            	Match Precedence array
                                                                            	**type**\:  :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                            
                                                                            .. attribute:: discard_class
                                                                            
                                                                            	Match Discard Class array
                                                                            	**type**\:  :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                            
                                                                            .. attribute:: qos_group
                                                                            
                                                                            	Match QoS group array
                                                                            	**type**\:  :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                            
                                                                            .. attribute:: traffic_class
                                                                            
                                                                            	Match Traffic class array
                                                                            	**type**\:  :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                            
                                                                            .. attribute:: proto
                                                                            
                                                                            	Match Protocol array
                                                                            	**type**\:  :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                            
                                                                            .. attribute:: icmp_v4
                                                                            
                                                                            	Match ICMPV4 Protocol
                                                                            	**type**\:  :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                            
                                                                            .. attribute:: icmp_v6
                                                                            
                                                                            	Match ICMPV6 Protocol array
                                                                            	**type**\:  :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                            
                                                                            .. attribute:: ipv4_packet_len
                                                                            
                                                                            	IPv4 packet length array
                                                                            	**type**\:  :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                            
                                                                            .. attribute:: ipv6_packet_len
                                                                            
                                                                            	IPv6 packet length array
                                                                            	**type**\:  :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                            
                                                                            .. attribute:: packet_len
                                                                            
                                                                            	Match packet length array
                                                                            	**type**\:  :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                            
                                                                            .. attribute:: flow_tag
                                                                            
                                                                            	Match flow\-tag array
                                                                            	**type**\:  :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                            
                                                                            .. attribute:: tcp_flag
                                                                            
                                                                            	Match tcp flag value
                                                                            	**type**\:  :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                            
                                                                            .. attribute:: icmpv4_type
                                                                            
                                                                            	Match ipv4 icmp type
                                                                            	**type**\:  :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                            
                                                                            .. attribute:: icmpv4_code
                                                                            
                                                                            	Match ipv4 icmp code
                                                                            	**type**\:  :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                            
                                                                            .. attribute:: icmpv6_type
                                                                            
                                                                            	Match ipv6 icmp type
                                                                            	**type**\:  :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                            
                                                                            .. attribute:: icmpv6_code
                                                                            
                                                                            	Match ipv6 icmp code
                                                                            	**type**\:  :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                            
                                                                            .. attribute:: mpls_exp
                                                                            
                                                                            	Match MPLS experimental topmost array
                                                                            	**type**\:  :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                            
                                                                            .. attribute:: mpls_exp_imp
                                                                            
                                                                            	Match MPLS experimental imposition array
                                                                            	**type**\:  :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                            
                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                            
                                                                            	MPLS Disposition IPv4 Access\-list
                                                                            	**type**\:  :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                            
                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                            
                                                                            	MPLS Disposition IPv6 Access\-list
                                                                            	**type**\:  :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                            
                                                                            .. attribute:: mpls_top_label
                                                                            
                                                                            	MPLS Topmost LABEL
                                                                            	**type**\:  :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                            
                                                                            .. attribute:: cos
                                                                            
                                                                            	Match CoS array
                                                                            	**type**\:  :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                            
                                                                            .. attribute:: cos_inr
                                                                            
                                                                            	Match inner header CoS
                                                                            	**type**\:  :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                            
                                                                            .. attribute:: dei
                                                                            
                                                                            	Match DEI Bit
                                                                            	**type**\:  :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                            
                                                                            .. attribute:: dei_inr
                                                                            
                                                                            	Match inner DEI Bit
                                                                            	**type**\:  :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                            
                                                                            .. attribute:: vlan
                                                                            
                                                                            	Match VLAN array
                                                                            	**type**\:  :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                            
                                                                            .. attribute:: vlan_inr
                                                                            
                                                                            	Match inner header VLAN range array
                                                                            	**type**\:  :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                            
                                                                            .. attribute:: fr_dlci
                                                                            
                                                                            	Match FR DLCI range array
                                                                            	**type**\:  :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                            
                                                                            .. attribute:: src_mac
                                                                            
                                                                            	Match Source MAC address
                                                                            	**type**\:  :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                            
                                                                            .. attribute:: dst_mac
                                                                            
                                                                            	Match Destination MAC address
                                                                            	**type**\:  :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                            
                                                                            .. attribute:: atm_clp
                                                                            
                                                                            	Match ATM CLP level
                                                                            	**type**\:  :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                            
                                                                            .. attribute:: fr_de
                                                                            
                                                                            	Match FR DE value
                                                                            	**type**\:  :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                            
                                                                            .. attribute:: ipv4_acl
                                                                            
                                                                            	IPv4 Access\-list
                                                                            	**type**\:  :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                            
                                                                            .. attribute:: ipv6_acl
                                                                            
                                                                            	IPv6 Access\-list
                                                                            	**type**\:  :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                            
                                                                            .. attribute:: ether_service_acl
                                                                            
                                                                            	Ethernet\-Services Access\-list
                                                                            	**type**\:  :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                            
                                                                            .. attribute:: avail_id
                                                                            
                                                                            	Available Identifiers
                                                                            	**type**\:  :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                            
                                                                            .. attribute:: media_type
                                                                            
                                                                            	Media Type
                                                                            	**type**\:  :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                            
                                                                            .. attribute:: subs_protocol
                                                                            
                                                                            	Protocol
                                                                            	**type**\:  :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                            
                                                                            .. attribute:: dnis
                                                                            
                                                                            	DNIS
                                                                            	**type**\:  :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                            
                                                                            .. attribute:: dnis_regex
                                                                            
                                                                            	DNIS Regular Expression
                                                                            	**type**\:  :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                            
                                                                            .. attribute:: domain
                                                                            
                                                                            	Domain Name
                                                                            	**type**\:  :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                            
                                                                            .. attribute:: domain_regex
                                                                            
                                                                            	Domain Regular Expression
                                                                            	**type**\:  :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                            
                                                                            .. attribute:: nas_port
                                                                            
                                                                            	NAS Port
                                                                            	**type**\:  :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                            
                                                                            .. attribute:: service_name
                                                                            
                                                                            	Service Name
                                                                            	**type**\:  :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                            
                                                                            .. attribute:: service_name_regex
                                                                            
                                                                            	Service Name Regular Exp
                                                                            	**type**\:  :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                            
                                                                            .. attribute:: src_addr_ipv4
                                                                            
                                                                            	Source Address IPV4
                                                                            	**type**\:  :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                            
                                                                            .. attribute:: dst_addr_ipv4
                                                                            
                                                                            	Destination Address IPV4
                                                                            	**type**\:  :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                            
                                                                            .. attribute:: src_addr_ipv6
                                                                            
                                                                            	Source Address IPV6
                                                                            	**type**\:  :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                            
                                                                            .. attribute:: dst_addr_ipv6
                                                                            
                                                                            	Destination Address IPV6
                                                                            	**type**\:  :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                            
                                                                            .. attribute:: src_addr_mac
                                                                            
                                                                            	Source Address MAC
                                                                            	**type**\:  :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                            
                                                                            .. attribute:: timer
                                                                            
                                                                            	Timer
                                                                            	**type**\:  :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                            
                                                                            .. attribute:: timer_regexp
                                                                            
                                                                            	Timer Regular Expression
                                                                            	**type**\:  :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                            
                                                                            .. attribute:: tunnel_name
                                                                            
                                                                            	Tunnel Name
                                                                            	**type**\:  :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                            
                                                                            .. attribute:: tunnel_name_regex
                                                                            
                                                                            	Tunnel Name Regular Expression
                                                                            	**type**\:  :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                            
                                                                            .. attribute:: user_name
                                                                            
                                                                            	User Name
                                                                            	**type**\:  :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                            
                                                                            .. attribute:: user_name_regex
                                                                            
                                                                            	User Name Regular Expression
                                                                            	**type**\:  :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                            
                                                                            .. attribute:: auth_username
                                                                            
                                                                            	Authenticated User Name
                                                                            	**type**\:  :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                            
                                                                            .. attribute:: auth_username_regex
                                                                            
                                                                            	Authenticated User Name RegEx
                                                                            	**type**\:  :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                            
                                                                            .. attribute:: unauth_username
                                                                            
                                                                            	Unauthenticated User Name
                                                                            	**type**\:  :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                            
                                                                            .. attribute:: unauth_username_regex
                                                                            
                                                                            	Unauthenticated User Name RegEx
                                                                            	**type**\:  :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                            
                                                                            .. attribute:: auth_domain
                                                                            
                                                                            	Authenticated domain name
                                                                            	**type**\:  :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                            
                                                                            .. attribute:: auth_domain_regex
                                                                            
                                                                            	Authenticated Domain Name RegEx
                                                                            	**type**\:  :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                            
                                                                            .. attribute:: unauth_domain
                                                                            
                                                                            	Unauthenticated Domain Name
                                                                            	**type**\:  :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                            
                                                                            .. attribute:: unauth_domain_regex
                                                                            
                                                                            	Unauthenticated Domain Name RegEx
                                                                            	**type**\:  :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                            
                                                                            .. attribute:: vendor_id
                                                                            
                                                                            	Vendor ID
                                                                            	**type**\:  :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                            
                                                                            .. attribute:: vendor_id_regex
                                                                            
                                                                            	Vendor ID RegEx
                                                                            	**type**\:  :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                            
                                                                            .. attribute:: access_interface
                                                                            
                                                                            	Access interface
                                                                            	**type**\:  :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                            
                                                                            .. attribute:: input_interface
                                                                            
                                                                            	Input interface
                                                                            	**type**\:  :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                            
                                                                            .. attribute:: input_intfhdl
                                                                            
                                                                            	Input interface handle
                                                                            	**type**\:  :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                            
                                                                            .. attribute:: ethertype
                                                                            
                                                                            	Ethernet type
                                                                            	**type**\:  :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                            
                                                                            .. attribute:: flow_key_data
                                                                            
                                                                            	Flow key structure
                                                                            	**type**\:  :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                            
                                                                            .. attribute:: dhcp_client_id
                                                                            
                                                                            	Dhcp Client ID
                                                                            	**type**\:  :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                            
                                                                            .. attribute:: dhcp_client_id_regex
                                                                            
                                                                            	Dhcp Client ID RegEx
                                                                            	**type**\:  :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                            
                                                                            .. attribute:: circuit_id
                                                                            
                                                                            	Circuit ID
                                                                            	**type**\:  :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                            
                                                                            .. attribute:: circuit_id_regex
                                                                            
                                                                            	Circuit ID RegEx
                                                                            	**type**\:  :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                            
                                                                            .. attribute:: remote_id
                                                                            
                                                                            	Remote ID
                                                                            	**type**\:  :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                            
                                                                            .. attribute:: remote_id_regex
                                                                            
                                                                            	Remote ID RegEx
                                                                            	**type**\:  :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                            
                                                                            .. attribute:: src_port
                                                                            
                                                                            	Source port
                                                                            	**type**\:  :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                            
                                                                            .. attribute:: dst_port
                                                                            
                                                                            	Destination port
                                                                            	**type**\:  :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:  :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                            
                                                                            .. attribute:: mpls_top_eos
                                                                            
                                                                            	MPLS Topmost EOS
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: fragment_type
                                                                            
                                                                            	Fragment type
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: authen_status
                                                                            
                                                                            	Authentication Status
                                                                            	**type**\:  :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                            
                                                                            .. attribute:: mlp_negotiated
                                                                            
                                                                            	MLP Negotiated
                                                                            	**type**\:  :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                self.yang_name = "match-data"
                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("ipv4-dscp", ("ipv4_dscp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp)), ("ipv6-dscp", ("ipv6_dscp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp)), ("dscp", ("dscp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp)), ("ipv4-prec", ("ipv4_prec", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec)), ("ipv6-prec", ("ipv6_prec", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec)), ("prec", ("prec", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec)), ("discard-class", ("discard_class", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass)), ("qos-group", ("qos_group", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup)), ("traffic-class", ("traffic_class", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass)), ("proto", ("proto", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto)), ("icmp-v4", ("icmp_v4", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4)), ("icmp-v6", ("icmp_v6", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6)), ("ipv4-packet-len", ("ipv4_packet_len", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen)), ("ipv6-packet-len", ("ipv6_packet_len", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen)), ("packet-len", ("packet_len", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen)), ("flow-tag", ("flow_tag", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag)), ("tcp-flag", ("tcp_flag", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag)), ("icmpv4-type", ("icmpv4_type", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type)), ("icmpv4-code", ("icmpv4_code", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code)), ("icmpv6-type", ("icmpv6_type", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type)), ("icmpv6-code", ("icmpv6_code", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code)), ("mpls-exp", ("mpls_exp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp)), ("mpls-exp-imp", ("mpls_exp_imp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp)), ("mpls-disp-ipv4-acl", ("mpls_disp_ipv4_acl", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl)), ("mpls-disp-ipv6-acl", ("mpls_disp_ipv6_acl", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl)), ("mpls-top-label", ("mpls_top_label", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel)), ("cos", ("cos", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos)), ("cos-inr", ("cos_inr", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr)), ("dei", ("dei", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei)), ("dei-inr", ("dei_inr", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr)), ("vlan", ("vlan", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan)), ("vlan-inr", ("vlan_inr", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)), ("fr-dlci", ("fr_dlci", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci)), ("src-mac", ("src_mac", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac)), ("dst-mac", ("dst_mac", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac)), ("atm-clp", ("atm_clp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp)), ("fr-de", ("fr_de", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe)), ("ipv4-acl", ("ipv4_acl", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl)), ("ipv6-acl", ("ipv6_acl", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl)), ("ether-service-acl", ("ether_service_acl", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl)), ("avail-id", ("avail_id", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId)), ("media-type", ("media_type", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType)), ("subs-protocol", ("subs_protocol", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol)), ("dnis", ("dnis", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis)), ("dnis-regex", ("dnis_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex)), ("domain", ("domain", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain)), ("domain-regex", ("domain_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex)), ("nas-port", ("nas_port", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort)), ("service-name", ("service_name", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName)), ("service-name-regex", ("service_name_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex)), ("src-addr-ipv4", ("src_addr_ipv4", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4)), ("dst-addr-ipv4", ("dst_addr_ipv4", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4)), ("src-addr-ipv6", ("src_addr_ipv6", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6)), ("dst-addr-ipv6", ("dst_addr_ipv6", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6)), ("src-addr-mac", ("src_addr_mac", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac)), ("timer", ("timer", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer)), ("timer-regexp", ("timer_regexp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp)), ("tunnel-name", ("tunnel_name", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName)), ("tunnel-name-regex", ("tunnel_name_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex)), ("user-name", ("user_name", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName)), ("user-name-regex", ("user_name_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex)), ("auth-username", ("auth_username", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername)), ("auth-username-regex", ("auth_username_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex)), ("unauth-username", ("unauth_username", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername)), ("unauth-username-regex", ("unauth_username_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex)), ("auth-domain", ("auth_domain", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain)), ("auth-domain-regex", ("auth_domain_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex)), ("unauth-domain", ("unauth_domain", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain)), ("unauth-domain-regex", ("unauth_domain_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex)), ("vendor-id", ("vendor_id", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId)), ("vendor-id-regex", ("vendor_id_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex)), ("access-interface", ("access_interface", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface)), ("input-interface", ("input_interface", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface)), ("input-intfhdl", ("input_intfhdl", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl)), ("ethertype", ("ethertype", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype)), ("flow-key-data", ("flow_key_data", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData)), ("dhcp-client-id", ("dhcp_client_id", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId)), ("dhcp-client-id-regex", ("dhcp_client_id_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex)), ("circuit-id", ("circuit_id", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId)), ("circuit-id-regex", ("circuit_id_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex)), ("remote-id", ("remote_id", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId)), ("remote-id-regex", ("remote_id_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex)), ("src-port", ("src_port", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort)), ("dst-port", ("dst_port", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchTypeEn', '')])),
                                                                                    ('mpls_top_eos', (YLeaf(YType.uint8, 'mpls-top-eos'), ['int'])),
                                                                                    ('fragment_type', (YLeaf(YType.uint8, 'fragment-type'), ['int'])),
                                                                                    ('authen_status', (YLeaf(YType.enumeration, 'authen-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchAuthenStatusEn', '')])),
                                                                                    ('mlp_negotiated', (YLeaf(YType.enumeration, 'mlp-negotiated'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchMlpNegotiatedEn', '')])),
                                                                                ])
                                                                                self.type = None
                                                                                self.mpls_top_eos = None
                                                                                self.fragment_type = None
                                                                                self.authen_status = None
                                                                                self.mlp_negotiated = None

                                                                                self.ipv4_dscp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                self.ipv4_dscp.parent = self
                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"

                                                                                self.ipv6_dscp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                self.ipv6_dscp.parent = self
                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"

                                                                                self.dscp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                self.dscp.parent = self
                                                                                self._children_name_map["dscp"] = "dscp"

                                                                                self.ipv4_prec = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                self.ipv4_prec.parent = self
                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"

                                                                                self.ipv6_prec = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                self.ipv6_prec.parent = self
                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"

                                                                                self.prec = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                self.prec.parent = self
                                                                                self._children_name_map["prec"] = "prec"

                                                                                self.discard_class = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                self.discard_class.parent = self
                                                                                self._children_name_map["discard_class"] = "discard-class"

                                                                                self.qos_group = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                self.qos_group.parent = self
                                                                                self._children_name_map["qos_group"] = "qos-group"

                                                                                self.traffic_class = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                self.traffic_class.parent = self
                                                                                self._children_name_map["traffic_class"] = "traffic-class"

                                                                                self.proto = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                self.proto.parent = self
                                                                                self._children_name_map["proto"] = "proto"

                                                                                self.icmp_v4 = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                self.icmp_v4.parent = self
                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"

                                                                                self.icmp_v6 = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                self.icmp_v6.parent = self
                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"

                                                                                self.ipv4_packet_len = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                self.ipv4_packet_len.parent = self
                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"

                                                                                self.ipv6_packet_len = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                self.ipv6_packet_len.parent = self
                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"

                                                                                self.packet_len = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                self.packet_len.parent = self
                                                                                self._children_name_map["packet_len"] = "packet-len"

                                                                                self.flow_tag = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                self.flow_tag.parent = self
                                                                                self._children_name_map["flow_tag"] = "flow-tag"

                                                                                self.tcp_flag = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                self.tcp_flag.parent = self
                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"

                                                                                self.icmpv4_type = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                self.icmpv4_type.parent = self
                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"

                                                                                self.icmpv4_code = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                self.icmpv4_code.parent = self
                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"

                                                                                self.icmpv6_type = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                self.icmpv6_type.parent = self
                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"

                                                                                self.icmpv6_code = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                self.icmpv6_code.parent = self
                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"

                                                                                self.mpls_exp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                self.mpls_exp.parent = self
                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"

                                                                                self.mpls_exp_imp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                self.mpls_exp_imp.parent = self
                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"

                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"

                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"

                                                                                self.mpls_top_label = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                self.mpls_top_label.parent = self
                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"

                                                                                self.cos = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                self.cos.parent = self
                                                                                self._children_name_map["cos"] = "cos"

                                                                                self.cos_inr = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                self.cos_inr.parent = self
                                                                                self._children_name_map["cos_inr"] = "cos-inr"

                                                                                self.dei = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                self.dei.parent = self
                                                                                self._children_name_map["dei"] = "dei"

                                                                                self.dei_inr = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                self.dei_inr.parent = self
                                                                                self._children_name_map["dei_inr"] = "dei-inr"

                                                                                self.vlan = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                self.vlan.parent = self
                                                                                self._children_name_map["vlan"] = "vlan"

                                                                                self.vlan_inr = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                self.vlan_inr.parent = self
                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"

                                                                                self.fr_dlci = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                self.fr_dlci.parent = self
                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"

                                                                                self.src_mac = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                self.src_mac.parent = self
                                                                                self._children_name_map["src_mac"] = "src-mac"

                                                                                self.dst_mac = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                self.dst_mac.parent = self
                                                                                self._children_name_map["dst_mac"] = "dst-mac"

                                                                                self.atm_clp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                self.atm_clp.parent = self
                                                                                self._children_name_map["atm_clp"] = "atm-clp"

                                                                                self.fr_de = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                self.fr_de.parent = self
                                                                                self._children_name_map["fr_de"] = "fr-de"

                                                                                self.ipv4_acl = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                self.ipv4_acl.parent = self
                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"

                                                                                self.ipv6_acl = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                self.ipv6_acl.parent = self
                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"

                                                                                self.ether_service_acl = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                self.ether_service_acl.parent = self
                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"

                                                                                self.avail_id = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                self.avail_id.parent = self
                                                                                self._children_name_map["avail_id"] = "avail-id"

                                                                                self.media_type = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                self.media_type.parent = self
                                                                                self._children_name_map["media_type"] = "media-type"

                                                                                self.subs_protocol = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                self.subs_protocol.parent = self
                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"

                                                                                self.dnis = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                self.dnis.parent = self
                                                                                self._children_name_map["dnis"] = "dnis"

                                                                                self.dnis_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                self.dnis_regex.parent = self
                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"

                                                                                self.domain = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                self.domain.parent = self
                                                                                self._children_name_map["domain"] = "domain"

                                                                                self.domain_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                self.domain_regex.parent = self
                                                                                self._children_name_map["domain_regex"] = "domain-regex"

                                                                                self.nas_port = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                self.nas_port.parent = self
                                                                                self._children_name_map["nas_port"] = "nas-port"

                                                                                self.service_name = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                self.service_name.parent = self
                                                                                self._children_name_map["service_name"] = "service-name"

                                                                                self.service_name_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                self.service_name_regex.parent = self
                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"

                                                                                self.src_addr_ipv4 = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                self.src_addr_ipv4.parent = self
                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"

                                                                                self.dst_addr_ipv4 = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                self.dst_addr_ipv4.parent = self
                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"

                                                                                self.src_addr_ipv6 = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                self.src_addr_ipv6.parent = self
                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"

                                                                                self.dst_addr_ipv6 = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                self.dst_addr_ipv6.parent = self
                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"

                                                                                self.src_addr_mac = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                self.src_addr_mac.parent = self
                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"

                                                                                self.timer = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                self.timer.parent = self
                                                                                self._children_name_map["timer"] = "timer"

                                                                                self.timer_regexp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                self.timer_regexp.parent = self
                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"

                                                                                self.tunnel_name = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                self.tunnel_name.parent = self
                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"

                                                                                self.tunnel_name_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                self.tunnel_name_regex.parent = self
                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"

                                                                                self.user_name = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                self.user_name.parent = self
                                                                                self._children_name_map["user_name"] = "user-name"

                                                                                self.user_name_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                self.user_name_regex.parent = self
                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"

                                                                                self.auth_username = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                self.auth_username.parent = self
                                                                                self._children_name_map["auth_username"] = "auth-username"

                                                                                self.auth_username_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                self.auth_username_regex.parent = self
                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"

                                                                                self.unauth_username = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                self.unauth_username.parent = self
                                                                                self._children_name_map["unauth_username"] = "unauth-username"

                                                                                self.unauth_username_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                self.unauth_username_regex.parent = self
                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"

                                                                                self.auth_domain = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                self.auth_domain.parent = self
                                                                                self._children_name_map["auth_domain"] = "auth-domain"

                                                                                self.auth_domain_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                self.auth_domain_regex.parent = self
                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"

                                                                                self.unauth_domain = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                self.unauth_domain.parent = self
                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"

                                                                                self.unauth_domain_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                self.unauth_domain_regex.parent = self
                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"

                                                                                self.vendor_id = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                self.vendor_id.parent = self
                                                                                self._children_name_map["vendor_id"] = "vendor-id"

                                                                                self.vendor_id_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                self.vendor_id_regex.parent = self
                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"

                                                                                self.access_interface = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                self.access_interface.parent = self
                                                                                self._children_name_map["access_interface"] = "access-interface"

                                                                                self.input_interface = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                self.input_interface.parent = self
                                                                                self._children_name_map["input_interface"] = "input-interface"

                                                                                self.input_intfhdl = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                self.input_intfhdl.parent = self
                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"

                                                                                self.ethertype = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                self.ethertype.parent = self
                                                                                self._children_name_map["ethertype"] = "ethertype"

                                                                                self.flow_key_data = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                self.flow_key_data.parent = self
                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"

                                                                                self.dhcp_client_id = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                self.dhcp_client_id.parent = self
                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"

                                                                                self.dhcp_client_id_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                self.dhcp_client_id_regex.parent = self
                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"

                                                                                self.circuit_id = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                self.circuit_id.parent = self
                                                                                self._children_name_map["circuit_id"] = "circuit-id"

                                                                                self.circuit_id_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                self.circuit_id_regex.parent = self
                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"

                                                                                self.remote_id = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                self.remote_id.parent = self
                                                                                self._children_name_map["remote_id"] = "remote-id"

                                                                                self.remote_id_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                self.remote_id_regex.parent = self
                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"

                                                                                self.src_port = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                self.src_port.parent = self
                                                                                self._children_name_map["src_port"] = "src-port"

                                                                                self.dst_port = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                self.dst_port.parent = self
                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                self._segment_path = lambda: "match-data"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, ['type', 'mpls_top_eos', 'fragment_type', 'authen_status', 'mlp_negotiated'], name, value)


                                                                            class Ipv4Dscp(Entity):
                                                                                """
                                                                                IPv4 DSCP
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                    self.yang_name = "ipv4-dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv4-dscp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Ipv6Dscp(Entity):
                                                                                """
                                                                                IPv6 DSCP
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                    self.yang_name = "ipv6-dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv6-dscp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Dscp(Entity):
                                                                                """
                                                                                Match DSCP range array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                    self.yang_name = "dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "dscp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Ipv4Prec(Entity):
                                                                                """
                                                                                IPv4 Precedence
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                    self.yang_name = "ipv4-prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "ipv4-prec"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                            class Ipv6Prec(Entity):
                                                                                """
                                                                                IPv6 Precedence
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                    self.yang_name = "ipv6-prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "ipv6-prec"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                            class Prec(Entity):
                                                                                """
                                                                                Match Precedence array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                    self.yang_name = "prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "prec"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                            class DiscardClass(Entity):
                                                                                """
                                                                                Match Discard Class array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                    self.yang_name = "discard-class"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "discard-class"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                            class QosGroup(Entity):
                                                                                """
                                                                                Match QoS group array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                    self.yang_name = "qos-group"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "qos-group"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "qos-group"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class TrafficClass(Entity):
                                                                                """
                                                                                Match Traffic class array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                    self.yang_name = "traffic-class"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "traffic-class"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "traffic-class"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Proto(Entity):
                                                                                """
                                                                                Match Protocol array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                    self.yang_name = "proto"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "proto"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "proto"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class IcmpV4(Entity):
                                                                                """
                                                                                Match ICMPV4 Protocol
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Protocol type
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: code
                                                                                
                                                                                	Protocol code
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                    self.yang_name = "icmp-v4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                    ])
                                                                                    self.type = None
                                                                                    self.code = None
                                                                                    self._segment_path = lambda: "icmp-v4"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['type', 'code'], name, value)


                                                                            class IcmpV6(Entity):
                                                                                """
                                                                                Match ICMPV6 Protocol array
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Protocol type
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: code
                                                                                
                                                                                	Protocol code
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                    self.yang_name = "icmp-v6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                    ])
                                                                                    self.type = None
                                                                                    self.code = None
                                                                                    self._segment_path = lambda: "icmp-v6"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['type', 'code'], name, value)


                                                                            class Ipv4PacketLen(Entity):
                                                                                """
                                                                                IPv4 packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv4-packet-len"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class Ipv6PacketLen(Entity):
                                                                                """
                                                                                IPv6 packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv6-packet-len"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class PacketLen(Entity):
                                                                                """
                                                                                Match packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                    self.yang_name = "packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "packet-len"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class FlowTag(Entity):
                                                                                """
                                                                                Match flow\-tag array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                    self.yang_name = "flow-tag"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "flow-tag"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "flow-tag"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class TcpFlag(Entity):
                                                                                """
                                                                                Match tcp flag value
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	Value of TCP flag
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: match_any
                                                                                
                                                                                	Match any TCP flag bit
                                                                                	**type**\: bool
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                    self.yang_name = "tcp-flag"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                        ('match_any', (YLeaf(YType.boolean, 'match-any'), ['bool'])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.match_any = None
                                                                                    self._segment_path = lambda: "tcp-flag"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['value', 'match_any'], name, value)


                                                                            class Icmpv4Type(Entity):
                                                                                """
                                                                                Match ipv4 icmp type
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                    self.yang_name = "icmpv4-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv4-type"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Icmpv4Code(Entity):
                                                                                """
                                                                                Match ipv4 icmp code
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                    self.yang_name = "icmpv4-code"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv4-code"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Icmpv6Type(Entity):
                                                                                """
                                                                                Match ipv6 icmp type
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                    self.yang_name = "icmpv6-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv6-type"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Icmpv6Code(Entity):
                                                                                """
                                                                                Match ipv6 icmp code
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                    self.yang_name = "icmpv6-code"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv6-code"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class MplsExp(Entity):
                                                                                """
                                                                                Match MPLS experimental topmost array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                    self.yang_name = "mpls-exp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "mpls-exp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                            class MplsExpImp(Entity):
                                                                                """
                                                                                Match MPLS experimental imposition array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "mpls-exp-imp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                            class MplsDispIpv4Acl(Entity):
                                                                                """
                                                                                MPLS Disposition IPv4 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                            class MplsDispIpv6Acl(Entity):
                                                                                """
                                                                                MPLS Disposition IPv6 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                            class MplsTopLabel(Entity):
                                                                                """
                                                                                MPLS Topmost LABEL
                                                                                
                                                                                .. attribute:: uint32_rng_array
                                                                                
                                                                                	uint32 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                    self.yang_name = "mpls-top-label"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint32_rng_array", ("uint32_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint32_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "mpls-top-label"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                class Uint32RngArray(Entity):
                                                                                    """
                                                                                    uint32 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                        self.yang_name = "uint32_rng_array"
                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint32, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint32, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint32_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['min', 'max'], name, value)


                                                                            class Cos(Entity):
                                                                                """
                                                                                Match CoS array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                    self.yang_name = "cos"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "cos"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                            class CosInr(Entity):
                                                                                """
                                                                                Match inner header CoS
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                    self.yang_name = "cos-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "cos-inr"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                            class Dei(Entity):
                                                                                """
                                                                                Match DEI Bit
                                                                                
                                                                                .. attribute:: bit_value
                                                                                
                                                                                	Value of the DEI bit
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                    self.yang_name = "dei"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                    ])
                                                                                    self.bit_value = None
                                                                                    self._segment_path = lambda: "dei"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                            class DeiInr(Entity):
                                                                                """
                                                                                Match inner DEI Bit
                                                                                
                                                                                .. attribute:: bit_value
                                                                                
                                                                                	Value of the DEI bit
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                    self.yang_name = "dei-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                    ])
                                                                                    self.bit_value = None
                                                                                    self._segment_path = lambda: "dei-inr"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                            class Vlan(Entity):
                                                                                """
                                                                                Match VLAN array
                                                                                
                                                                                .. attribute:: vlan_id_array
                                                                                
                                                                                	vlan id array
                                                                                	**type**\: list of  		 :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                    self.yang_name = "vlan"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("vlan-id-array", ("vlan_id_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.vlan_id_array = YList(self)
                                                                                    self._segment_path = lambda: "vlan"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                class VlanIdArray(Entity):
                                                                                    """
                                                                                    vlan id array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	VLAN mask
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                        self.yang_name = "vlan-id-array"
                                                                                        self.yang_parent_name = "vlan"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                            ('mask', (YLeaf(YType.uint16, 'mask'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self.mask = None
                                                                                        self._segment_path = lambda: "vlan-id-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['min', 'max', 'mask'], name, value)


                                                                            class VlanInr(Entity):
                                                                                """
                                                                                Match inner header VLAN range array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                    self.yang_name = "vlan-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "vlan-inr"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class FrDlci(Entity):
                                                                                """
                                                                                Match FR DLCI range array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                    self.yang_name = "fr-dlci"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "fr-dlci"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class SrcMac(Entity):
                                                                                """
                                                                                Match Source MAC address
                                                                                
                                                                                .. attribute:: mac_addr
                                                                                
                                                                                	MAC address
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	MAC mask
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                    self.yang_name = "src-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                    ])
                                                                                    self.mac_addr = []
                                                                                    self.mask = []
                                                                                    self._segment_path = lambda: "src-mac"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                            class DstMac(Entity):
                                                                                """
                                                                                Match Destination MAC address
                                                                                
                                                                                .. attribute:: mac_addr
                                                                                
                                                                                	MAC address
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	MAC mask
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                    self.yang_name = "dst-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                    ])
                                                                                    self.mac_addr = []
                                                                                    self.mask = []
                                                                                    self._segment_path = lambda: "dst-mac"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                            class AtmClp(Entity):
                                                                                """
                                                                                Match ATM CLP level
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                    self.yang_name = "atm-clp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "atm-clp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                            class FrDe(Entity):
                                                                                """
                                                                                Match FR DE value
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                    self.yang_name = "fr-de"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "fr-de"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                            class Ipv4Acl(Entity):
                                                                                """
                                                                                IPv4 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                    self.yang_name = "ipv4-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "ipv4-acl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                            class Ipv6Acl(Entity):
                                                                                """
                                                                                IPv6 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                    self.yang_name = "ipv6-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "ipv6-acl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                            class EtherServiceAcl(Entity):
                                                                                """
                                                                                Ethernet\-Services Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                    self.yang_name = "ether-service-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "ether-service-acl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                            class AvailId(Entity):
                                                                                """
                                                                                Available Identifiers
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                    self.yang_name = "avail-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "avail-id"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                            class MediaType(Entity):
                                                                                """
                                                                                Media Type
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                    self.yang_name = "media-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "media-type"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                            class SubsProtocol(Entity):
                                                                                """
                                                                                Protocol
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                    self.yang_name = "subs-protocol"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "subs-protocol"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                            class Dnis(Entity):
                                                                                """
                                                                                DNIS
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                    self.yang_name = "dnis"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "dnis"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                            class DnisRegex(Entity):
                                                                                """
                                                                                DNIS Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                    self.yang_name = "dnis-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "dnis-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                            class Domain(Entity):
                                                                                """
                                                                                Domain Name
                                                                                
                                                                                .. attribute:: domain_array
                                                                                
                                                                                	domain array
                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                    self.yang_name = "domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.domain_array = YList(self)
                                                                                    self._segment_path = lambda: "domain"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                class DomainArray(Entity):
                                                                                    """
                                                                                    domain array
                                                                                    
                                                                                    .. attribute:: domain_name
                                                                                    
                                                                                    	domain name
                                                                                    	**type**\: str
                                                                                    
                                                                                    .. attribute:: format_name
                                                                                    
                                                                                    	format name
                                                                                    	**type**\: str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                        self.yang_name = "domain-array"
                                                                                        self.yang_parent_name = "domain"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                        ])
                                                                                        self.domain_name = None
                                                                                        self.format_name = None
                                                                                        self._segment_path = lambda: "domain-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                            class DomainRegex(Entity):
                                                                                """
                                                                                Domain Regular Expression
                                                                                
                                                                                .. attribute:: domain_array
                                                                                
                                                                                	domain array
                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                    self.yang_name = "domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.domain_array = YList(self)
                                                                                    self._segment_path = lambda: "domain-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                class DomainArray(Entity):
                                                                                    """
                                                                                    domain array
                                                                                    
                                                                                    .. attribute:: domain_name
                                                                                    
                                                                                    	domain name
                                                                                    	**type**\: str
                                                                                    
                                                                                    .. attribute:: format_name
                                                                                    
                                                                                    	format name
                                                                                    	**type**\: str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                        self.yang_name = "domain-array"
                                                                                        self.yang_parent_name = "domain-regex"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                        ])
                                                                                        self.domain_name = None
                                                                                        self.format_name = None
                                                                                        self._segment_path = lambda: "domain-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                            class NasPort(Entity):
                                                                                """
                                                                                NAS Port
                                                                                
                                                                                .. attribute:: nas_port_array
                                                                                
                                                                                	nas port array
                                                                                	**type**\: list of  		 :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                    self.yang_name = "nas-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("nas-port-array", ("nas_port_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.nas_port_array = YList(self)
                                                                                    self._segment_path = lambda: "nas-port"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                class NasPortArray(Entity):
                                                                                    """
                                                                                    nas port array
                                                                                    
                                                                                    .. attribute:: sub_id
                                                                                    
                                                                                    	sub id
                                                                                    	**type**\:  :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                    
                                                                                    .. attribute:: operator
                                                                                    
                                                                                    	operator
                                                                                    	**type**\:  :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                        self.yang_name = "nas-port-array"
                                                                                        self.yang_parent_name = "nas-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('sub_id', (YLeaf(YType.enumeration, 'sub-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchNasPortSubIdEn', '')])),
                                                                                            ('operator', (YLeaf(YType.enumeration, 'operator'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchLogicalOperatorEn', '')])),
                                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ])
                                                                                        self.sub_id = None
                                                                                        self.operator = None
                                                                                        self.value = None
                                                                                        self._segment_path = lambda: "nas-port-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['sub_id', 'operator', 'value'], name, value)


                                                                            class ServiceName(Entity):
                                                                                """
                                                                                Service Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                    self.yang_name = "service-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "service-name"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                            class ServiceNameRegex(Entity):
                                                                                """
                                                                                Service Name Regular Exp
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                    self.yang_name = "service-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "service-name-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                            class SrcAddrIpv4(Entity):
                                                                                """
                                                                                Source Address IPV4
                                                                                
                                                                                .. attribute:: ipv4_addr_array
                                                                                
                                                                                	ipv4 addr array
                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.ipv4_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-ipv4"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                class Ipv4AddrArray(Entity):
                                                                                    """
                                                                                    ipv4 addr array
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	prefix
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	mask
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                        ])
                                                                                        self.prefix = None
                                                                                        self.mask = None
                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                            class DstAddrIpv4(Entity):
                                                                                """
                                                                                Destination Address IPV4
                                                                                
                                                                                .. attribute:: ipv4_addr_array
                                                                                
                                                                                	ipv4 addr array
                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.ipv4_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-addr-ipv4"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                class Ipv4AddrArray(Entity):
                                                                                    """
                                                                                    ipv4 addr array
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	prefix
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	mask
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                        ])
                                                                                        self.prefix = None
                                                                                        self.mask = None
                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                            class SrcAddrIpv6(Entity):
                                                                                """
                                                                                Source Address IPV6
                                                                                
                                                                                .. attribute:: ipv6_addr_array
                                                                                
                                                                                	ipv6 addr array
                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.ipv6_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-ipv6"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                class Ipv6AddrArray(Entity):
                                                                                    """
                                                                                    ipv6 addr array
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	IPV6 prefix
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	IPV6 mask
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                        ])
                                                                                        self.prefix = None
                                                                                        self.mask = None
                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                            class DstAddrIpv6(Entity):
                                                                                """
                                                                                Destination Address IPV6
                                                                                
                                                                                .. attribute:: ipv6_addr_array
                                                                                
                                                                                	ipv6 addr array
                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.ipv6_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-addr-ipv6"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                class Ipv6AddrArray(Entity):
                                                                                    """
                                                                                    ipv6 addr array
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	IPV6 prefix
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	IPV6 mask
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                        ])
                                                                                        self.prefix = None
                                                                                        self.mask = None
                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                            class SrcAddrMac(Entity):
                                                                                """
                                                                                Source Address MAC
                                                                                
                                                                                .. attribute:: mac_addr_array
                                                                                
                                                                                	mac addr array
                                                                                	**type**\: list of  		 :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                    self.yang_name = "src-addr-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("mac-addr-array", ("mac_addr_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.mac_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-mac"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                class MacAddrArray(Entity):
                                                                                    """
                                                                                    mac addr array
                                                                                    
                                                                                    .. attribute:: mac_addr
                                                                                    
                                                                                    	MAC address
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	MAC mask
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                        self.yang_name = "mac-addr-array"
                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                            ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                        ])
                                                                                        self.mac_addr = []
                                                                                        self.mask = []
                                                                                        self._segment_path = lambda: "mac-addr-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                            class Timer(Entity):
                                                                                """
                                                                                Timer
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                    self.yang_name = "timer"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "timer"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                            class TimerRegexp(Entity):
                                                                                """
                                                                                Timer Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                    self.yang_name = "timer-regexp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "timer-regexp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                            class TunnelName(Entity):
                                                                                """
                                                                                Tunnel Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                    self.yang_name = "tunnel-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "tunnel-name"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                            class TunnelNameRegex(Entity):
                                                                                """
                                                                                Tunnel Name Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "tunnel-name-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                            class UserName(Entity):
                                                                                """
                                                                                User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                    self.yang_name = "user-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "user-name"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                            class UserNameRegex(Entity):
                                                                                """
                                                                                User Name Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                    self.yang_name = "user-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "user-name-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                            class AuthUsername(Entity):
                                                                                """
                                                                                Authenticated User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                    self.yang_name = "auth-username"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "auth-username"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                            class AuthUsernameRegex(Entity):
                                                                                """
                                                                                Authenticated User Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                    self.yang_name = "auth-username-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "auth-username-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                            class UnauthUsername(Entity):
                                                                                """
                                                                                Unauthenticated User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                    self.yang_name = "unauth-username"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "unauth-username"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                            class UnauthUsernameRegex(Entity):
                                                                                """
                                                                                Unauthenticated User Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                    self.yang_name = "unauth-username-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "unauth-username-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                            class AuthDomain(Entity):
                                                                                """
                                                                                Authenticated domain name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                    self.yang_name = "auth-domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "auth-domain"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                            class AuthDomainRegex(Entity):
                                                                                """
                                                                                Authenticated Domain Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                    self.yang_name = "auth-domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "auth-domain-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                            class UnauthDomain(Entity):
                                                                                """
                                                                                Unauthenticated Domain Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                    self.yang_name = "unauth-domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "unauth-domain"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                            class UnauthDomainRegex(Entity):
                                                                                """
                                                                                Unauthenticated Domain Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "unauth-domain-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                            class VendorId(Entity):
                                                                                """
                                                                                Vendor ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                    self.yang_name = "vendor-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "vendor-id"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                            class VendorIdRegex(Entity):
                                                                                """
                                                                                Vendor ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                    self.yang_name = "vendor-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "vendor-id-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                            class AccessInterface(Entity):
                                                                                """
                                                                                Access interface
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                    self.yang_name = "access-interface"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "access-interface"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                            class InputInterface(Entity):
                                                                                """
                                                                                Input interface
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                    self.yang_name = "input-interface"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "input-interface"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                            class InputIntfhdl(Entity):
                                                                                """
                                                                                Input interface handle
                                                                                
                                                                                .. attribute:: uint64_array
                                                                                
                                                                                	uint64 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..18446744073709551615
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                    self.yang_name = "input-intfhdl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint64_array', (YLeafList(YType.uint64, 'uint64_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint64_array = []
                                                                                    self._segment_path = lambda: "input-intfhdl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                            class Ethertype(Entity):
                                                                                """
                                                                                Ethernet type
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                    self.yang_name = "ethertype"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ethertype"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ethertype"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class FlowKeyData(Entity):
                                                                                """
                                                                                Flow key structure
                                                                                
                                                                                .. attribute:: flow_keys
                                                                                
                                                                                	flow keys
                                                                                	**type**\:  :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                
                                                                                .. attribute:: max_count
                                                                                
                                                                                	Maximum count of flows
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: idle_timeout
                                                                                
                                                                                	Idle timeout of flows (in seconds)
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                	**units**\: second
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                    self.yang_name = "flow-key-data"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("flow-keys", ("flow_keys", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('max_count', (YLeaf(YType.uint16, 'max-count'), ['int'])),
                                                                                        ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                                    ])
                                                                                    self.max_count = None
                                                                                    self.idle_timeout = None

                                                                                    self.flow_keys = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                    self.flow_keys.parent = self
                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                    self._segment_path = lambda: "flow-key-data"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['max_count', 'idle_timeout'], name, value)


                                                                                class FlowKeys(Entity):
                                                                                    """
                                                                                    flow keys
                                                                                    
                                                                                    .. attribute:: keys
                                                                                    
                                                                                    	keys
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                    
                                                                                    .. attribute:: num
                                                                                    
                                                                                    	num
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                        self.yang_name = "flow-keys"
                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('keys', (YLeaf(YType.str, 'keys'), ['str'])),
                                                                                            ('num', (YLeaf(YType.uint8, 'num'), ['int'])),
                                                                                        ])
                                                                                        self.keys = None
                                                                                        self.num = None
                                                                                        self._segment_path = lambda: "flow-keys"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                            class DhcpClientId(Entity):
                                                                                """
                                                                                Dhcp Client ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                    self.yang_name = "dhcp-client-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "dhcp-client-id"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                            class DhcpClientIdRegex(Entity):
                                                                                """
                                                                                Dhcp Client ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                            class CircuitId(Entity):
                                                                                """
                                                                                Circuit ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                    self.yang_name = "circuit-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "circuit-id"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                            class CircuitIdRegex(Entity):
                                                                                """
                                                                                Circuit ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                    self.yang_name = "circuit-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "circuit-id-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                            class RemoteId(Entity):
                                                                                """
                                                                                Remote ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                    self.yang_name = "remote-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "remote-id"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                            class RemoteIdRegex(Entity):
                                                                                """
                                                                                Remote ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                    self.yang_name = "remote-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "remote-id-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                            class SrcPort(Entity):
                                                                                """
                                                                                Source port
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                    self.yang_name = "src-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "src-port"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "src-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class DstPort(Entity):
                                                                                """
                                                                                Destination port
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                    self.yang_name = "dst-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-port"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "dst-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['min', 'max'], name, value)


                                                        class ClmpP(Entity):
                                                            """
                                                            clmp p
                                                            
                                                            .. attribute:: class_map_bg
                                                            
                                                            	class map bg
                                                            	**type**\: list of  		 :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'infra-policymgr-oper'
                                                            _revision = '2018-01-17'

                                                            def __init__(self):
                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP, self).__init__()

                                                                self.yang_name = "clmp-p"
                                                                self.yang_parent_name = "policy-class-info-bg"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("class-map-bg", ("class_map_bg", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg))])
                                                                self._leafs = OrderedDict()

                                                                self.class_map_bg = YList(self)
                                                                self._segment_path = lambda: "clmp-p"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP, [], name, value)


                                                            class ClassMapBg(Entity):
                                                                """
                                                                class map bg
                                                                
                                                                .. attribute:: match_infop
                                                                
                                                                	Pointer to the first Match info
                                                                	**type**\:  :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop>`
                                                                
                                                                .. attribute:: name
                                                                
                                                                	Name of the class\-map
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..65
                                                                
                                                                .. attribute:: type
                                                                
                                                                	Class\-Map Type QoS/PBR/Netflow/..
                                                                	**type**\:  :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                                
                                                                .. attribute:: mode
                                                                
                                                                	Class\-Map Mode Match any/Match all
                                                                	**type**\:  :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                
                                                                .. attribute:: description
                                                                
                                                                	description
                                                                	**type**\: str
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg, self).__init__()

                                                                    self.yang_name = "class-map-bg"
                                                                    self.yang_parent_name = "clmp-p"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("match-infop", ("match_infop", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop))])
                                                                    self._leafs = OrderedDict([
                                                                        ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapTypeEn', '')])),
                                                                        ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapModeEn', '')])),
                                                                        ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                    ])
                                                                    self.name = None
                                                                    self.type = None
                                                                    self.mode = None
                                                                    self.description = None

                                                                    self.match_infop = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop()
                                                                    self.match_infop.parent = self
                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                    self._segment_path = lambda: "class-map-bg"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg, ['name', 'type', 'mode', 'description'], name, value)


                                                                class MatchInfop(Entity):
                                                                    """
                                                                    Pointer to the first Match info
                                                                    
                                                                    .. attribute:: class_match_info_st
                                                                    
                                                                    	class match info st
                                                                    	**type**\: list of  		 :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop, self).__init__()

                                                                        self.yang_name = "match-infop"
                                                                        self.yang_parent_name = "class-map-bg"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("class-match-info-st", ("class_match_info_st", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt))])
                                                                        self._leafs = OrderedDict()

                                                                        self.class_match_info_st = YList(self)
                                                                        self._segment_path = lambda: "match-infop"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop, [], name, value)


                                                                    class ClassMatchInfoSt(Entity):
                                                                        """
                                                                        class match info st
                                                                        
                                                                        .. attribute:: match_data
                                                                        
                                                                        	Match criteria
                                                                        	**type**\:  :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                        
                                                                        .. attribute:: flags
                                                                        
                                                                        	Flags
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                            self.yang_name = "class-match-info-st"
                                                                            self.yang_parent_name = "match-infop"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("match-data", ("match_data", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData))])
                                                                            self._leafs = OrderedDict([
                                                                                ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                            ])
                                                                            self.flags = None

                                                                            self.match_data = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                            self.match_data.parent = self
                                                                            self._children_name_map["match_data"] = "match-data"
                                                                            self._segment_path = lambda: "class-match-info-st"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                        class MatchData(Entity):
                                                                            """
                                                                            Match criteria
                                                                            
                                                                            .. attribute:: ipv4_dscp
                                                                            
                                                                            	IPv4 DSCP
                                                                            	**type**\:  :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                            
                                                                            .. attribute:: ipv6_dscp
                                                                            
                                                                            	IPv6 DSCP
                                                                            	**type**\:  :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                            
                                                                            .. attribute:: dscp
                                                                            
                                                                            	Match DSCP range array
                                                                            	**type**\:  :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                            
                                                                            .. attribute:: ipv4_prec
                                                                            
                                                                            	IPv4 Precedence
                                                                            	**type**\:  :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                            
                                                                            .. attribute:: ipv6_prec
                                                                            
                                                                            	IPv6 Precedence
                                                                            	**type**\:  :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                            
                                                                            .. attribute:: prec
                                                                            
                                                                            	Match Precedence array
                                                                            	**type**\:  :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                            
                                                                            .. attribute:: discard_class
                                                                            
                                                                            	Match Discard Class array
                                                                            	**type**\:  :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                            
                                                                            .. attribute:: qos_group
                                                                            
                                                                            	Match QoS group array
                                                                            	**type**\:  :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                            
                                                                            .. attribute:: traffic_class
                                                                            
                                                                            	Match Traffic class array
                                                                            	**type**\:  :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                            
                                                                            .. attribute:: proto
                                                                            
                                                                            	Match Protocol array
                                                                            	**type**\:  :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                            
                                                                            .. attribute:: icmp_v4
                                                                            
                                                                            	Match ICMPV4 Protocol
                                                                            	**type**\:  :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                            
                                                                            .. attribute:: icmp_v6
                                                                            
                                                                            	Match ICMPV6 Protocol array
                                                                            	**type**\:  :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                            
                                                                            .. attribute:: ipv4_packet_len
                                                                            
                                                                            	IPv4 packet length array
                                                                            	**type**\:  :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                            
                                                                            .. attribute:: ipv6_packet_len
                                                                            
                                                                            	IPv6 packet length array
                                                                            	**type**\:  :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                            
                                                                            .. attribute:: packet_len
                                                                            
                                                                            	Match packet length array
                                                                            	**type**\:  :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                            
                                                                            .. attribute:: flow_tag
                                                                            
                                                                            	Match flow\-tag array
                                                                            	**type**\:  :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                            
                                                                            .. attribute:: tcp_flag
                                                                            
                                                                            	Match tcp flag value
                                                                            	**type**\:  :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                            
                                                                            .. attribute:: icmpv4_type
                                                                            
                                                                            	Match ipv4 icmp type
                                                                            	**type**\:  :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                            
                                                                            .. attribute:: icmpv4_code
                                                                            
                                                                            	Match ipv4 icmp code
                                                                            	**type**\:  :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                            
                                                                            .. attribute:: icmpv6_type
                                                                            
                                                                            	Match ipv6 icmp type
                                                                            	**type**\:  :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                            
                                                                            .. attribute:: icmpv6_code
                                                                            
                                                                            	Match ipv6 icmp code
                                                                            	**type**\:  :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                            
                                                                            .. attribute:: mpls_exp
                                                                            
                                                                            	Match MPLS experimental topmost array
                                                                            	**type**\:  :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                            
                                                                            .. attribute:: mpls_exp_imp
                                                                            
                                                                            	Match MPLS experimental imposition array
                                                                            	**type**\:  :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                            
                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                            
                                                                            	MPLS Disposition IPv4 Access\-list
                                                                            	**type**\:  :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                            
                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                            
                                                                            	MPLS Disposition IPv6 Access\-list
                                                                            	**type**\:  :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                            
                                                                            .. attribute:: mpls_top_label
                                                                            
                                                                            	MPLS Topmost LABEL
                                                                            	**type**\:  :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                            
                                                                            .. attribute:: cos
                                                                            
                                                                            	Match CoS array
                                                                            	**type**\:  :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                            
                                                                            .. attribute:: cos_inr
                                                                            
                                                                            	Match inner header CoS
                                                                            	**type**\:  :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                            
                                                                            .. attribute:: dei
                                                                            
                                                                            	Match DEI Bit
                                                                            	**type**\:  :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                            
                                                                            .. attribute:: dei_inr
                                                                            
                                                                            	Match inner DEI Bit
                                                                            	**type**\:  :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                            
                                                                            .. attribute:: vlan
                                                                            
                                                                            	Match VLAN array
                                                                            	**type**\:  :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                            
                                                                            .. attribute:: vlan_inr
                                                                            
                                                                            	Match inner header VLAN range array
                                                                            	**type**\:  :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                            
                                                                            .. attribute:: fr_dlci
                                                                            
                                                                            	Match FR DLCI range array
                                                                            	**type**\:  :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                            
                                                                            .. attribute:: src_mac
                                                                            
                                                                            	Match Source MAC address
                                                                            	**type**\:  :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                            
                                                                            .. attribute:: dst_mac
                                                                            
                                                                            	Match Destination MAC address
                                                                            	**type**\:  :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                            
                                                                            .. attribute:: atm_clp
                                                                            
                                                                            	Match ATM CLP level
                                                                            	**type**\:  :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                            
                                                                            .. attribute:: fr_de
                                                                            
                                                                            	Match FR DE value
                                                                            	**type**\:  :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                            
                                                                            .. attribute:: ipv4_acl
                                                                            
                                                                            	IPv4 Access\-list
                                                                            	**type**\:  :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                            
                                                                            .. attribute:: ipv6_acl
                                                                            
                                                                            	IPv6 Access\-list
                                                                            	**type**\:  :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                            
                                                                            .. attribute:: ether_service_acl
                                                                            
                                                                            	Ethernet\-Services Access\-list
                                                                            	**type**\:  :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                            
                                                                            .. attribute:: avail_id
                                                                            
                                                                            	Available Identifiers
                                                                            	**type**\:  :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                            
                                                                            .. attribute:: media_type
                                                                            
                                                                            	Media Type
                                                                            	**type**\:  :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                            
                                                                            .. attribute:: subs_protocol
                                                                            
                                                                            	Protocol
                                                                            	**type**\:  :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                            
                                                                            .. attribute:: dnis
                                                                            
                                                                            	DNIS
                                                                            	**type**\:  :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                            
                                                                            .. attribute:: dnis_regex
                                                                            
                                                                            	DNIS Regular Expression
                                                                            	**type**\:  :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                            
                                                                            .. attribute:: domain
                                                                            
                                                                            	Domain Name
                                                                            	**type**\:  :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                            
                                                                            .. attribute:: domain_regex
                                                                            
                                                                            	Domain Regular Expression
                                                                            	**type**\:  :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                            
                                                                            .. attribute:: nas_port
                                                                            
                                                                            	NAS Port
                                                                            	**type**\:  :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                            
                                                                            .. attribute:: service_name
                                                                            
                                                                            	Service Name
                                                                            	**type**\:  :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                            
                                                                            .. attribute:: service_name_regex
                                                                            
                                                                            	Service Name Regular Exp
                                                                            	**type**\:  :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                            
                                                                            .. attribute:: src_addr_ipv4
                                                                            
                                                                            	Source Address IPV4
                                                                            	**type**\:  :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                            
                                                                            .. attribute:: dst_addr_ipv4
                                                                            
                                                                            	Destination Address IPV4
                                                                            	**type**\:  :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                            
                                                                            .. attribute:: src_addr_ipv6
                                                                            
                                                                            	Source Address IPV6
                                                                            	**type**\:  :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                            
                                                                            .. attribute:: dst_addr_ipv6
                                                                            
                                                                            	Destination Address IPV6
                                                                            	**type**\:  :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                            
                                                                            .. attribute:: src_addr_mac
                                                                            
                                                                            	Source Address MAC
                                                                            	**type**\:  :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                            
                                                                            .. attribute:: timer
                                                                            
                                                                            	Timer
                                                                            	**type**\:  :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                            
                                                                            .. attribute:: timer_regexp
                                                                            
                                                                            	Timer Regular Expression
                                                                            	**type**\:  :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                            
                                                                            .. attribute:: tunnel_name
                                                                            
                                                                            	Tunnel Name
                                                                            	**type**\:  :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                            
                                                                            .. attribute:: tunnel_name_regex
                                                                            
                                                                            	Tunnel Name Regular Expression
                                                                            	**type**\:  :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                            
                                                                            .. attribute:: user_name
                                                                            
                                                                            	User Name
                                                                            	**type**\:  :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                            
                                                                            .. attribute:: user_name_regex
                                                                            
                                                                            	User Name Regular Expression
                                                                            	**type**\:  :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                            
                                                                            .. attribute:: auth_username
                                                                            
                                                                            	Authenticated User Name
                                                                            	**type**\:  :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                            
                                                                            .. attribute:: auth_username_regex
                                                                            
                                                                            	Authenticated User Name RegEx
                                                                            	**type**\:  :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                            
                                                                            .. attribute:: unauth_username
                                                                            
                                                                            	Unauthenticated User Name
                                                                            	**type**\:  :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                            
                                                                            .. attribute:: unauth_username_regex
                                                                            
                                                                            	Unauthenticated User Name RegEx
                                                                            	**type**\:  :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                            
                                                                            .. attribute:: auth_domain
                                                                            
                                                                            	Authenticated domain name
                                                                            	**type**\:  :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                            
                                                                            .. attribute:: auth_domain_regex
                                                                            
                                                                            	Authenticated Domain Name RegEx
                                                                            	**type**\:  :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                            
                                                                            .. attribute:: unauth_domain
                                                                            
                                                                            	Unauthenticated Domain Name
                                                                            	**type**\:  :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                            
                                                                            .. attribute:: unauth_domain_regex
                                                                            
                                                                            	Unauthenticated Domain Name RegEx
                                                                            	**type**\:  :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                            
                                                                            .. attribute:: vendor_id
                                                                            
                                                                            	Vendor ID
                                                                            	**type**\:  :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                            
                                                                            .. attribute:: vendor_id_regex
                                                                            
                                                                            	Vendor ID RegEx
                                                                            	**type**\:  :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                            
                                                                            .. attribute:: access_interface
                                                                            
                                                                            	Access interface
                                                                            	**type**\:  :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                            
                                                                            .. attribute:: input_interface
                                                                            
                                                                            	Input interface
                                                                            	**type**\:  :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                            
                                                                            .. attribute:: input_intfhdl
                                                                            
                                                                            	Input interface handle
                                                                            	**type**\:  :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                            
                                                                            .. attribute:: ethertype
                                                                            
                                                                            	Ethernet type
                                                                            	**type**\:  :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                            
                                                                            .. attribute:: flow_key_data
                                                                            
                                                                            	Flow key structure
                                                                            	**type**\:  :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                            
                                                                            .. attribute:: dhcp_client_id
                                                                            
                                                                            	Dhcp Client ID
                                                                            	**type**\:  :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                            
                                                                            .. attribute:: dhcp_client_id_regex
                                                                            
                                                                            	Dhcp Client ID RegEx
                                                                            	**type**\:  :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                            
                                                                            .. attribute:: circuit_id
                                                                            
                                                                            	Circuit ID
                                                                            	**type**\:  :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                            
                                                                            .. attribute:: circuit_id_regex
                                                                            
                                                                            	Circuit ID RegEx
                                                                            	**type**\:  :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                            
                                                                            .. attribute:: remote_id
                                                                            
                                                                            	Remote ID
                                                                            	**type**\:  :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                            
                                                                            .. attribute:: remote_id_regex
                                                                            
                                                                            	Remote ID RegEx
                                                                            	**type**\:  :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                            
                                                                            .. attribute:: src_port
                                                                            
                                                                            	Source port
                                                                            	**type**\:  :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                            
                                                                            .. attribute:: dst_port
                                                                            
                                                                            	Destination port
                                                                            	**type**\:  :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:  :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                            
                                                                            .. attribute:: mpls_top_eos
                                                                            
                                                                            	MPLS Topmost EOS
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: fragment_type
                                                                            
                                                                            	Fragment type
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: authen_status
                                                                            
                                                                            	Authentication Status
                                                                            	**type**\:  :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                            
                                                                            .. attribute:: mlp_negotiated
                                                                            
                                                                            	MLP Negotiated
                                                                            	**type**\:  :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                self.yang_name = "match-data"
                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("ipv4-dscp", ("ipv4_dscp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp)), ("ipv6-dscp", ("ipv6_dscp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp)), ("dscp", ("dscp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp)), ("ipv4-prec", ("ipv4_prec", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec)), ("ipv6-prec", ("ipv6_prec", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec)), ("prec", ("prec", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec)), ("discard-class", ("discard_class", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass)), ("qos-group", ("qos_group", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup)), ("traffic-class", ("traffic_class", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass)), ("proto", ("proto", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto)), ("icmp-v4", ("icmp_v4", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4)), ("icmp-v6", ("icmp_v6", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6)), ("ipv4-packet-len", ("ipv4_packet_len", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen)), ("ipv6-packet-len", ("ipv6_packet_len", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen)), ("packet-len", ("packet_len", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen)), ("flow-tag", ("flow_tag", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag)), ("tcp-flag", ("tcp_flag", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag)), ("icmpv4-type", ("icmpv4_type", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type)), ("icmpv4-code", ("icmpv4_code", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code)), ("icmpv6-type", ("icmpv6_type", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type)), ("icmpv6-code", ("icmpv6_code", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code)), ("mpls-exp", ("mpls_exp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp)), ("mpls-exp-imp", ("mpls_exp_imp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp)), ("mpls-disp-ipv4-acl", ("mpls_disp_ipv4_acl", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl)), ("mpls-disp-ipv6-acl", ("mpls_disp_ipv6_acl", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl)), ("mpls-top-label", ("mpls_top_label", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel)), ("cos", ("cos", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos)), ("cos-inr", ("cos_inr", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr)), ("dei", ("dei", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei)), ("dei-inr", ("dei_inr", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr)), ("vlan", ("vlan", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan)), ("vlan-inr", ("vlan_inr", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)), ("fr-dlci", ("fr_dlci", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci)), ("src-mac", ("src_mac", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac)), ("dst-mac", ("dst_mac", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac)), ("atm-clp", ("atm_clp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp)), ("fr-de", ("fr_de", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe)), ("ipv4-acl", ("ipv4_acl", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl)), ("ipv6-acl", ("ipv6_acl", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl)), ("ether-service-acl", ("ether_service_acl", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl)), ("avail-id", ("avail_id", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId)), ("media-type", ("media_type", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType)), ("subs-protocol", ("subs_protocol", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol)), ("dnis", ("dnis", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis)), ("dnis-regex", ("dnis_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex)), ("domain", ("domain", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain)), ("domain-regex", ("domain_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex)), ("nas-port", ("nas_port", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort)), ("service-name", ("service_name", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName)), ("service-name-regex", ("service_name_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex)), ("src-addr-ipv4", ("src_addr_ipv4", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4)), ("dst-addr-ipv4", ("dst_addr_ipv4", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4)), ("src-addr-ipv6", ("src_addr_ipv6", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6)), ("dst-addr-ipv6", ("dst_addr_ipv6", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6)), ("src-addr-mac", ("src_addr_mac", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac)), ("timer", ("timer", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer)), ("timer-regexp", ("timer_regexp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp)), ("tunnel-name", ("tunnel_name", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName)), ("tunnel-name-regex", ("tunnel_name_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex)), ("user-name", ("user_name", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName)), ("user-name-regex", ("user_name_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex)), ("auth-username", ("auth_username", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername)), ("auth-username-regex", ("auth_username_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex)), ("unauth-username", ("unauth_username", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername)), ("unauth-username-regex", ("unauth_username_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex)), ("auth-domain", ("auth_domain", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain)), ("auth-domain-regex", ("auth_domain_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex)), ("unauth-domain", ("unauth_domain", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain)), ("unauth-domain-regex", ("unauth_domain_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex)), ("vendor-id", ("vendor_id", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId)), ("vendor-id-regex", ("vendor_id_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex)), ("access-interface", ("access_interface", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface)), ("input-interface", ("input_interface", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface)), ("input-intfhdl", ("input_intfhdl", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl)), ("ethertype", ("ethertype", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype)), ("flow-key-data", ("flow_key_data", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData)), ("dhcp-client-id", ("dhcp_client_id", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId)), ("dhcp-client-id-regex", ("dhcp_client_id_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex)), ("circuit-id", ("circuit_id", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId)), ("circuit-id-regex", ("circuit_id_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex)), ("remote-id", ("remote_id", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId)), ("remote-id-regex", ("remote_id_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex)), ("src-port", ("src_port", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort)), ("dst-port", ("dst_port", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchTypeEn', '')])),
                                                                                    ('mpls_top_eos', (YLeaf(YType.uint8, 'mpls-top-eos'), ['int'])),
                                                                                    ('fragment_type', (YLeaf(YType.uint8, 'fragment-type'), ['int'])),
                                                                                    ('authen_status', (YLeaf(YType.enumeration, 'authen-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchAuthenStatusEn', '')])),
                                                                                    ('mlp_negotiated', (YLeaf(YType.enumeration, 'mlp-negotiated'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchMlpNegotiatedEn', '')])),
                                                                                ])
                                                                                self.type = None
                                                                                self.mpls_top_eos = None
                                                                                self.fragment_type = None
                                                                                self.authen_status = None
                                                                                self.mlp_negotiated = None

                                                                                self.ipv4_dscp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                self.ipv4_dscp.parent = self
                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"

                                                                                self.ipv6_dscp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                self.ipv6_dscp.parent = self
                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"

                                                                                self.dscp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                self.dscp.parent = self
                                                                                self._children_name_map["dscp"] = "dscp"

                                                                                self.ipv4_prec = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                self.ipv4_prec.parent = self
                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"

                                                                                self.ipv6_prec = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                self.ipv6_prec.parent = self
                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"

                                                                                self.prec = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                self.prec.parent = self
                                                                                self._children_name_map["prec"] = "prec"

                                                                                self.discard_class = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                self.discard_class.parent = self
                                                                                self._children_name_map["discard_class"] = "discard-class"

                                                                                self.qos_group = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                self.qos_group.parent = self
                                                                                self._children_name_map["qos_group"] = "qos-group"

                                                                                self.traffic_class = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                self.traffic_class.parent = self
                                                                                self._children_name_map["traffic_class"] = "traffic-class"

                                                                                self.proto = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                self.proto.parent = self
                                                                                self._children_name_map["proto"] = "proto"

                                                                                self.icmp_v4 = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                self.icmp_v4.parent = self
                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"

                                                                                self.icmp_v6 = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                self.icmp_v6.parent = self
                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"

                                                                                self.ipv4_packet_len = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                self.ipv4_packet_len.parent = self
                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"

                                                                                self.ipv6_packet_len = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                self.ipv6_packet_len.parent = self
                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"

                                                                                self.packet_len = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                self.packet_len.parent = self
                                                                                self._children_name_map["packet_len"] = "packet-len"

                                                                                self.flow_tag = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                self.flow_tag.parent = self
                                                                                self._children_name_map["flow_tag"] = "flow-tag"

                                                                                self.tcp_flag = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                self.tcp_flag.parent = self
                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"

                                                                                self.icmpv4_type = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                self.icmpv4_type.parent = self
                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"

                                                                                self.icmpv4_code = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                self.icmpv4_code.parent = self
                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"

                                                                                self.icmpv6_type = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                self.icmpv6_type.parent = self
                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"

                                                                                self.icmpv6_code = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                self.icmpv6_code.parent = self
                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"

                                                                                self.mpls_exp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                self.mpls_exp.parent = self
                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"

                                                                                self.mpls_exp_imp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                self.mpls_exp_imp.parent = self
                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"

                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"

                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"

                                                                                self.mpls_top_label = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                self.mpls_top_label.parent = self
                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"

                                                                                self.cos = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                self.cos.parent = self
                                                                                self._children_name_map["cos"] = "cos"

                                                                                self.cos_inr = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                self.cos_inr.parent = self
                                                                                self._children_name_map["cos_inr"] = "cos-inr"

                                                                                self.dei = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                self.dei.parent = self
                                                                                self._children_name_map["dei"] = "dei"

                                                                                self.dei_inr = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                self.dei_inr.parent = self
                                                                                self._children_name_map["dei_inr"] = "dei-inr"

                                                                                self.vlan = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                self.vlan.parent = self
                                                                                self._children_name_map["vlan"] = "vlan"

                                                                                self.vlan_inr = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                self.vlan_inr.parent = self
                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"

                                                                                self.fr_dlci = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                self.fr_dlci.parent = self
                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"

                                                                                self.src_mac = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                self.src_mac.parent = self
                                                                                self._children_name_map["src_mac"] = "src-mac"

                                                                                self.dst_mac = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                self.dst_mac.parent = self
                                                                                self._children_name_map["dst_mac"] = "dst-mac"

                                                                                self.atm_clp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                self.atm_clp.parent = self
                                                                                self._children_name_map["atm_clp"] = "atm-clp"

                                                                                self.fr_de = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                self.fr_de.parent = self
                                                                                self._children_name_map["fr_de"] = "fr-de"

                                                                                self.ipv4_acl = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                self.ipv4_acl.parent = self
                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"

                                                                                self.ipv6_acl = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                self.ipv6_acl.parent = self
                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"

                                                                                self.ether_service_acl = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                self.ether_service_acl.parent = self
                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"

                                                                                self.avail_id = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                self.avail_id.parent = self
                                                                                self._children_name_map["avail_id"] = "avail-id"

                                                                                self.media_type = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                self.media_type.parent = self
                                                                                self._children_name_map["media_type"] = "media-type"

                                                                                self.subs_protocol = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                self.subs_protocol.parent = self
                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"

                                                                                self.dnis = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                self.dnis.parent = self
                                                                                self._children_name_map["dnis"] = "dnis"

                                                                                self.dnis_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                self.dnis_regex.parent = self
                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"

                                                                                self.domain = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                self.domain.parent = self
                                                                                self._children_name_map["domain"] = "domain"

                                                                                self.domain_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                self.domain_regex.parent = self
                                                                                self._children_name_map["domain_regex"] = "domain-regex"

                                                                                self.nas_port = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                self.nas_port.parent = self
                                                                                self._children_name_map["nas_port"] = "nas-port"

                                                                                self.service_name = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                self.service_name.parent = self
                                                                                self._children_name_map["service_name"] = "service-name"

                                                                                self.service_name_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                self.service_name_regex.parent = self
                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"

                                                                                self.src_addr_ipv4 = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                self.src_addr_ipv4.parent = self
                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"

                                                                                self.dst_addr_ipv4 = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                self.dst_addr_ipv4.parent = self
                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"

                                                                                self.src_addr_ipv6 = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                self.src_addr_ipv6.parent = self
                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"

                                                                                self.dst_addr_ipv6 = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                self.dst_addr_ipv6.parent = self
                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"

                                                                                self.src_addr_mac = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                self.src_addr_mac.parent = self
                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"

                                                                                self.timer = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                self.timer.parent = self
                                                                                self._children_name_map["timer"] = "timer"

                                                                                self.timer_regexp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                self.timer_regexp.parent = self
                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"

                                                                                self.tunnel_name = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                self.tunnel_name.parent = self
                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"

                                                                                self.tunnel_name_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                self.tunnel_name_regex.parent = self
                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"

                                                                                self.user_name = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                self.user_name.parent = self
                                                                                self._children_name_map["user_name"] = "user-name"

                                                                                self.user_name_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                self.user_name_regex.parent = self
                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"

                                                                                self.auth_username = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                self.auth_username.parent = self
                                                                                self._children_name_map["auth_username"] = "auth-username"

                                                                                self.auth_username_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                self.auth_username_regex.parent = self
                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"

                                                                                self.unauth_username = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                self.unauth_username.parent = self
                                                                                self._children_name_map["unauth_username"] = "unauth-username"

                                                                                self.unauth_username_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                self.unauth_username_regex.parent = self
                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"

                                                                                self.auth_domain = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                self.auth_domain.parent = self
                                                                                self._children_name_map["auth_domain"] = "auth-domain"

                                                                                self.auth_domain_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                self.auth_domain_regex.parent = self
                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"

                                                                                self.unauth_domain = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                self.unauth_domain.parent = self
                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"

                                                                                self.unauth_domain_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                self.unauth_domain_regex.parent = self
                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"

                                                                                self.vendor_id = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                self.vendor_id.parent = self
                                                                                self._children_name_map["vendor_id"] = "vendor-id"

                                                                                self.vendor_id_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                self.vendor_id_regex.parent = self
                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"

                                                                                self.access_interface = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                self.access_interface.parent = self
                                                                                self._children_name_map["access_interface"] = "access-interface"

                                                                                self.input_interface = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                self.input_interface.parent = self
                                                                                self._children_name_map["input_interface"] = "input-interface"

                                                                                self.input_intfhdl = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                self.input_intfhdl.parent = self
                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"

                                                                                self.ethertype = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                self.ethertype.parent = self
                                                                                self._children_name_map["ethertype"] = "ethertype"

                                                                                self.flow_key_data = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                self.flow_key_data.parent = self
                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"

                                                                                self.dhcp_client_id = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                self.dhcp_client_id.parent = self
                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"

                                                                                self.dhcp_client_id_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                self.dhcp_client_id_regex.parent = self
                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"

                                                                                self.circuit_id = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                self.circuit_id.parent = self
                                                                                self._children_name_map["circuit_id"] = "circuit-id"

                                                                                self.circuit_id_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                self.circuit_id_regex.parent = self
                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"

                                                                                self.remote_id = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                self.remote_id.parent = self
                                                                                self._children_name_map["remote_id"] = "remote-id"

                                                                                self.remote_id_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                self.remote_id_regex.parent = self
                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"

                                                                                self.src_port = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                self.src_port.parent = self
                                                                                self._children_name_map["src_port"] = "src-port"

                                                                                self.dst_port = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                self.dst_port.parent = self
                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                self._segment_path = lambda: "match-data"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['type', 'mpls_top_eos', 'fragment_type', 'authen_status', 'mlp_negotiated'], name, value)


                                                                            class Ipv4Dscp(Entity):
                                                                                """
                                                                                IPv4 DSCP
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                    self.yang_name = "ipv4-dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv4-dscp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Ipv6Dscp(Entity):
                                                                                """
                                                                                IPv6 DSCP
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                    self.yang_name = "ipv6-dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv6-dscp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Dscp(Entity):
                                                                                """
                                                                                Match DSCP range array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                    self.yang_name = "dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "dscp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Ipv4Prec(Entity):
                                                                                """
                                                                                IPv4 Precedence
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                    self.yang_name = "ipv4-prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "ipv4-prec"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                            class Ipv6Prec(Entity):
                                                                                """
                                                                                IPv6 Precedence
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                    self.yang_name = "ipv6-prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "ipv6-prec"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                            class Prec(Entity):
                                                                                """
                                                                                Match Precedence array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                    self.yang_name = "prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "prec"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                            class DiscardClass(Entity):
                                                                                """
                                                                                Match Discard Class array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                    self.yang_name = "discard-class"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "discard-class"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                            class QosGroup(Entity):
                                                                                """
                                                                                Match QoS group array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                    self.yang_name = "qos-group"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "qos-group"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "qos-group"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class TrafficClass(Entity):
                                                                                """
                                                                                Match Traffic class array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                    self.yang_name = "traffic-class"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "traffic-class"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "traffic-class"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Proto(Entity):
                                                                                """
                                                                                Match Protocol array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                    self.yang_name = "proto"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "proto"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "proto"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class IcmpV4(Entity):
                                                                                """
                                                                                Match ICMPV4 Protocol
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Protocol type
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: code
                                                                                
                                                                                	Protocol code
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                    self.yang_name = "icmp-v4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                    ])
                                                                                    self.type = None
                                                                                    self.code = None
                                                                                    self._segment_path = lambda: "icmp-v4"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['type', 'code'], name, value)


                                                                            class IcmpV6(Entity):
                                                                                """
                                                                                Match ICMPV6 Protocol array
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Protocol type
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: code
                                                                                
                                                                                	Protocol code
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                    self.yang_name = "icmp-v6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                    ])
                                                                                    self.type = None
                                                                                    self.code = None
                                                                                    self._segment_path = lambda: "icmp-v6"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['type', 'code'], name, value)


                                                                            class Ipv4PacketLen(Entity):
                                                                                """
                                                                                IPv4 packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv4-packet-len"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class Ipv6PacketLen(Entity):
                                                                                """
                                                                                IPv6 packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv6-packet-len"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class PacketLen(Entity):
                                                                                """
                                                                                Match packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                    self.yang_name = "packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "packet-len"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class FlowTag(Entity):
                                                                                """
                                                                                Match flow\-tag array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                    self.yang_name = "flow-tag"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "flow-tag"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "flow-tag"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class TcpFlag(Entity):
                                                                                """
                                                                                Match tcp flag value
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	Value of TCP flag
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: match_any
                                                                                
                                                                                	Match any TCP flag bit
                                                                                	**type**\: bool
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                    self.yang_name = "tcp-flag"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                        ('match_any', (YLeaf(YType.boolean, 'match-any'), ['bool'])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.match_any = None
                                                                                    self._segment_path = lambda: "tcp-flag"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['value', 'match_any'], name, value)


                                                                            class Icmpv4Type(Entity):
                                                                                """
                                                                                Match ipv4 icmp type
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                    self.yang_name = "icmpv4-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv4-type"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Icmpv4Code(Entity):
                                                                                """
                                                                                Match ipv4 icmp code
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                    self.yang_name = "icmpv4-code"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv4-code"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Icmpv6Type(Entity):
                                                                                """
                                                                                Match ipv6 icmp type
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                    self.yang_name = "icmpv6-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv6-type"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Icmpv6Code(Entity):
                                                                                """
                                                                                Match ipv6 icmp code
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                    self.yang_name = "icmpv6-code"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv6-code"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class MplsExp(Entity):
                                                                                """
                                                                                Match MPLS experimental topmost array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                    self.yang_name = "mpls-exp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "mpls-exp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                            class MplsExpImp(Entity):
                                                                                """
                                                                                Match MPLS experimental imposition array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "mpls-exp-imp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                            class MplsDispIpv4Acl(Entity):
                                                                                """
                                                                                MPLS Disposition IPv4 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                            class MplsDispIpv6Acl(Entity):
                                                                                """
                                                                                MPLS Disposition IPv6 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                            class MplsTopLabel(Entity):
                                                                                """
                                                                                MPLS Topmost LABEL
                                                                                
                                                                                .. attribute:: uint32_rng_array
                                                                                
                                                                                	uint32 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                    self.yang_name = "mpls-top-label"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint32_rng_array", ("uint32_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint32_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "mpls-top-label"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                class Uint32RngArray(Entity):
                                                                                    """
                                                                                    uint32 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                        self.yang_name = "uint32_rng_array"
                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint32, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint32, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint32_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['min', 'max'], name, value)


                                                                            class Cos(Entity):
                                                                                """
                                                                                Match CoS array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                    self.yang_name = "cos"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "cos"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                            class CosInr(Entity):
                                                                                """
                                                                                Match inner header CoS
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                    self.yang_name = "cos-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "cos-inr"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                            class Dei(Entity):
                                                                                """
                                                                                Match DEI Bit
                                                                                
                                                                                .. attribute:: bit_value
                                                                                
                                                                                	Value of the DEI bit
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                    self.yang_name = "dei"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                    ])
                                                                                    self.bit_value = None
                                                                                    self._segment_path = lambda: "dei"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                            class DeiInr(Entity):
                                                                                """
                                                                                Match inner DEI Bit
                                                                                
                                                                                .. attribute:: bit_value
                                                                                
                                                                                	Value of the DEI bit
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                    self.yang_name = "dei-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                    ])
                                                                                    self.bit_value = None
                                                                                    self._segment_path = lambda: "dei-inr"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                            class Vlan(Entity):
                                                                                """
                                                                                Match VLAN array
                                                                                
                                                                                .. attribute:: vlan_id_array
                                                                                
                                                                                	vlan id array
                                                                                	**type**\: list of  		 :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                    self.yang_name = "vlan"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("vlan-id-array", ("vlan_id_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.vlan_id_array = YList(self)
                                                                                    self._segment_path = lambda: "vlan"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                class VlanIdArray(Entity):
                                                                                    """
                                                                                    vlan id array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	VLAN mask
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                        self.yang_name = "vlan-id-array"
                                                                                        self.yang_parent_name = "vlan"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                            ('mask', (YLeaf(YType.uint16, 'mask'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self.mask = None
                                                                                        self._segment_path = lambda: "vlan-id-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['min', 'max', 'mask'], name, value)


                                                                            class VlanInr(Entity):
                                                                                """
                                                                                Match inner header VLAN range array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                    self.yang_name = "vlan-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "vlan-inr"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class FrDlci(Entity):
                                                                                """
                                                                                Match FR DLCI range array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                    self.yang_name = "fr-dlci"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "fr-dlci"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class SrcMac(Entity):
                                                                                """
                                                                                Match Source MAC address
                                                                                
                                                                                .. attribute:: mac_addr
                                                                                
                                                                                	MAC address
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	MAC mask
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                    self.yang_name = "src-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                    ])
                                                                                    self.mac_addr = []
                                                                                    self.mask = []
                                                                                    self._segment_path = lambda: "src-mac"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                            class DstMac(Entity):
                                                                                """
                                                                                Match Destination MAC address
                                                                                
                                                                                .. attribute:: mac_addr
                                                                                
                                                                                	MAC address
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	MAC mask
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                    self.yang_name = "dst-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                    ])
                                                                                    self.mac_addr = []
                                                                                    self.mask = []
                                                                                    self._segment_path = lambda: "dst-mac"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                            class AtmClp(Entity):
                                                                                """
                                                                                Match ATM CLP level
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                    self.yang_name = "atm-clp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "atm-clp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                            class FrDe(Entity):
                                                                                """
                                                                                Match FR DE value
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                    self.yang_name = "fr-de"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "fr-de"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                            class Ipv4Acl(Entity):
                                                                                """
                                                                                IPv4 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                    self.yang_name = "ipv4-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "ipv4-acl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                            class Ipv6Acl(Entity):
                                                                                """
                                                                                IPv6 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                    self.yang_name = "ipv6-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "ipv6-acl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                            class EtherServiceAcl(Entity):
                                                                                """
                                                                                Ethernet\-Services Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                    self.yang_name = "ether-service-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "ether-service-acl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                            class AvailId(Entity):
                                                                                """
                                                                                Available Identifiers
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                    self.yang_name = "avail-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "avail-id"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                            class MediaType(Entity):
                                                                                """
                                                                                Media Type
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                    self.yang_name = "media-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "media-type"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                            class SubsProtocol(Entity):
                                                                                """
                                                                                Protocol
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                    self.yang_name = "subs-protocol"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "subs-protocol"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                            class Dnis(Entity):
                                                                                """
                                                                                DNIS
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                    self.yang_name = "dnis"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "dnis"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                            class DnisRegex(Entity):
                                                                                """
                                                                                DNIS Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                    self.yang_name = "dnis-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "dnis-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                            class Domain(Entity):
                                                                                """
                                                                                Domain Name
                                                                                
                                                                                .. attribute:: domain_array
                                                                                
                                                                                	domain array
                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                    self.yang_name = "domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.domain_array = YList(self)
                                                                                    self._segment_path = lambda: "domain"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                class DomainArray(Entity):
                                                                                    """
                                                                                    domain array
                                                                                    
                                                                                    .. attribute:: domain_name
                                                                                    
                                                                                    	domain name
                                                                                    	**type**\: str
                                                                                    
                                                                                    .. attribute:: format_name
                                                                                    
                                                                                    	format name
                                                                                    	**type**\: str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                        self.yang_name = "domain-array"
                                                                                        self.yang_parent_name = "domain"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                        ])
                                                                                        self.domain_name = None
                                                                                        self.format_name = None
                                                                                        self._segment_path = lambda: "domain-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                            class DomainRegex(Entity):
                                                                                """
                                                                                Domain Regular Expression
                                                                                
                                                                                .. attribute:: domain_array
                                                                                
                                                                                	domain array
                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                    self.yang_name = "domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.domain_array = YList(self)
                                                                                    self._segment_path = lambda: "domain-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                class DomainArray(Entity):
                                                                                    """
                                                                                    domain array
                                                                                    
                                                                                    .. attribute:: domain_name
                                                                                    
                                                                                    	domain name
                                                                                    	**type**\: str
                                                                                    
                                                                                    .. attribute:: format_name
                                                                                    
                                                                                    	format name
                                                                                    	**type**\: str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                        self.yang_name = "domain-array"
                                                                                        self.yang_parent_name = "domain-regex"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                        ])
                                                                                        self.domain_name = None
                                                                                        self.format_name = None
                                                                                        self._segment_path = lambda: "domain-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                            class NasPort(Entity):
                                                                                """
                                                                                NAS Port
                                                                                
                                                                                .. attribute:: nas_port_array
                                                                                
                                                                                	nas port array
                                                                                	**type**\: list of  		 :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                    self.yang_name = "nas-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("nas-port-array", ("nas_port_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.nas_port_array = YList(self)
                                                                                    self._segment_path = lambda: "nas-port"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                class NasPortArray(Entity):
                                                                                    """
                                                                                    nas port array
                                                                                    
                                                                                    .. attribute:: sub_id
                                                                                    
                                                                                    	sub id
                                                                                    	**type**\:  :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                    
                                                                                    .. attribute:: operator
                                                                                    
                                                                                    	operator
                                                                                    	**type**\:  :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                        self.yang_name = "nas-port-array"
                                                                                        self.yang_parent_name = "nas-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('sub_id', (YLeaf(YType.enumeration, 'sub-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchNasPortSubIdEn', '')])),
                                                                                            ('operator', (YLeaf(YType.enumeration, 'operator'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchLogicalOperatorEn', '')])),
                                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ])
                                                                                        self.sub_id = None
                                                                                        self.operator = None
                                                                                        self.value = None
                                                                                        self._segment_path = lambda: "nas-port-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['sub_id', 'operator', 'value'], name, value)


                                                                            class ServiceName(Entity):
                                                                                """
                                                                                Service Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                    self.yang_name = "service-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "service-name"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                            class ServiceNameRegex(Entity):
                                                                                """
                                                                                Service Name Regular Exp
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                    self.yang_name = "service-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "service-name-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                            class SrcAddrIpv4(Entity):
                                                                                """
                                                                                Source Address IPV4
                                                                                
                                                                                .. attribute:: ipv4_addr_array
                                                                                
                                                                                	ipv4 addr array
                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.ipv4_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-ipv4"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                class Ipv4AddrArray(Entity):
                                                                                    """
                                                                                    ipv4 addr array
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	prefix
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	mask
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                        ])
                                                                                        self.prefix = None
                                                                                        self.mask = None
                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                            class DstAddrIpv4(Entity):
                                                                                """
                                                                                Destination Address IPV4
                                                                                
                                                                                .. attribute:: ipv4_addr_array
                                                                                
                                                                                	ipv4 addr array
                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.ipv4_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-addr-ipv4"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                class Ipv4AddrArray(Entity):
                                                                                    """
                                                                                    ipv4 addr array
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	prefix
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	mask
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                        ])
                                                                                        self.prefix = None
                                                                                        self.mask = None
                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                            class SrcAddrIpv6(Entity):
                                                                                """
                                                                                Source Address IPV6
                                                                                
                                                                                .. attribute:: ipv6_addr_array
                                                                                
                                                                                	ipv6 addr array
                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.ipv6_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-ipv6"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                class Ipv6AddrArray(Entity):
                                                                                    """
                                                                                    ipv6 addr array
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	IPV6 prefix
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	IPV6 mask
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                        ])
                                                                                        self.prefix = None
                                                                                        self.mask = None
                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                            class DstAddrIpv6(Entity):
                                                                                """
                                                                                Destination Address IPV6
                                                                                
                                                                                .. attribute:: ipv6_addr_array
                                                                                
                                                                                	ipv6 addr array
                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.ipv6_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-addr-ipv6"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                class Ipv6AddrArray(Entity):
                                                                                    """
                                                                                    ipv6 addr array
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	IPV6 prefix
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	IPV6 mask
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                        ])
                                                                                        self.prefix = None
                                                                                        self.mask = None
                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                            class SrcAddrMac(Entity):
                                                                                """
                                                                                Source Address MAC
                                                                                
                                                                                .. attribute:: mac_addr_array
                                                                                
                                                                                	mac addr array
                                                                                	**type**\: list of  		 :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                    self.yang_name = "src-addr-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("mac-addr-array", ("mac_addr_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.mac_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-mac"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                class MacAddrArray(Entity):
                                                                                    """
                                                                                    mac addr array
                                                                                    
                                                                                    .. attribute:: mac_addr
                                                                                    
                                                                                    	MAC address
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	MAC mask
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                        self.yang_name = "mac-addr-array"
                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                            ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                        ])
                                                                                        self.mac_addr = []
                                                                                        self.mask = []
                                                                                        self._segment_path = lambda: "mac-addr-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                            class Timer(Entity):
                                                                                """
                                                                                Timer
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                    self.yang_name = "timer"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "timer"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                            class TimerRegexp(Entity):
                                                                                """
                                                                                Timer Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                    self.yang_name = "timer-regexp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "timer-regexp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                            class TunnelName(Entity):
                                                                                """
                                                                                Tunnel Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                    self.yang_name = "tunnel-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "tunnel-name"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                            class TunnelNameRegex(Entity):
                                                                                """
                                                                                Tunnel Name Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "tunnel-name-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                            class UserName(Entity):
                                                                                """
                                                                                User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                    self.yang_name = "user-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "user-name"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                            class UserNameRegex(Entity):
                                                                                """
                                                                                User Name Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                    self.yang_name = "user-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "user-name-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                            class AuthUsername(Entity):
                                                                                """
                                                                                Authenticated User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                    self.yang_name = "auth-username"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "auth-username"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                            class AuthUsernameRegex(Entity):
                                                                                """
                                                                                Authenticated User Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                    self.yang_name = "auth-username-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "auth-username-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                            class UnauthUsername(Entity):
                                                                                """
                                                                                Unauthenticated User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                    self.yang_name = "unauth-username"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "unauth-username"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                            class UnauthUsernameRegex(Entity):
                                                                                """
                                                                                Unauthenticated User Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                    self.yang_name = "unauth-username-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "unauth-username-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                            class AuthDomain(Entity):
                                                                                """
                                                                                Authenticated domain name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                    self.yang_name = "auth-domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "auth-domain"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                            class AuthDomainRegex(Entity):
                                                                                """
                                                                                Authenticated Domain Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                    self.yang_name = "auth-domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "auth-domain-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                            class UnauthDomain(Entity):
                                                                                """
                                                                                Unauthenticated Domain Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                    self.yang_name = "unauth-domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "unauth-domain"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                            class UnauthDomainRegex(Entity):
                                                                                """
                                                                                Unauthenticated Domain Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "unauth-domain-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                            class VendorId(Entity):
                                                                                """
                                                                                Vendor ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                    self.yang_name = "vendor-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "vendor-id"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                            class VendorIdRegex(Entity):
                                                                                """
                                                                                Vendor ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                    self.yang_name = "vendor-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "vendor-id-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                            class AccessInterface(Entity):
                                                                                """
                                                                                Access interface
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                    self.yang_name = "access-interface"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "access-interface"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                            class InputInterface(Entity):
                                                                                """
                                                                                Input interface
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                    self.yang_name = "input-interface"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "input-interface"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                            class InputIntfhdl(Entity):
                                                                                """
                                                                                Input interface handle
                                                                                
                                                                                .. attribute:: uint64_array
                                                                                
                                                                                	uint64 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..18446744073709551615
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                    self.yang_name = "input-intfhdl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint64_array', (YLeafList(YType.uint64, 'uint64_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint64_array = []
                                                                                    self._segment_path = lambda: "input-intfhdl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                            class Ethertype(Entity):
                                                                                """
                                                                                Ethernet type
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                    self.yang_name = "ethertype"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ethertype"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ethertype"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class FlowKeyData(Entity):
                                                                                """
                                                                                Flow key structure
                                                                                
                                                                                .. attribute:: flow_keys
                                                                                
                                                                                	flow keys
                                                                                	**type**\:  :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                
                                                                                .. attribute:: max_count
                                                                                
                                                                                	Maximum count of flows
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: idle_timeout
                                                                                
                                                                                	Idle timeout of flows (in seconds)
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                	**units**\: second
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                    self.yang_name = "flow-key-data"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("flow-keys", ("flow_keys", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('max_count', (YLeaf(YType.uint16, 'max-count'), ['int'])),
                                                                                        ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                                    ])
                                                                                    self.max_count = None
                                                                                    self.idle_timeout = None

                                                                                    self.flow_keys = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                    self.flow_keys.parent = self
                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                    self._segment_path = lambda: "flow-key-data"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['max_count', 'idle_timeout'], name, value)


                                                                                class FlowKeys(Entity):
                                                                                    """
                                                                                    flow keys
                                                                                    
                                                                                    .. attribute:: keys
                                                                                    
                                                                                    	keys
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                    
                                                                                    .. attribute:: num
                                                                                    
                                                                                    	num
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                        self.yang_name = "flow-keys"
                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('keys', (YLeaf(YType.str, 'keys'), ['str'])),
                                                                                            ('num', (YLeaf(YType.uint8, 'num'), ['int'])),
                                                                                        ])
                                                                                        self.keys = None
                                                                                        self.num = None
                                                                                        self._segment_path = lambda: "flow-keys"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                            class DhcpClientId(Entity):
                                                                                """
                                                                                Dhcp Client ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                    self.yang_name = "dhcp-client-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "dhcp-client-id"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                            class DhcpClientIdRegex(Entity):
                                                                                """
                                                                                Dhcp Client ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                            class CircuitId(Entity):
                                                                                """
                                                                                Circuit ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                    self.yang_name = "circuit-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "circuit-id"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                            class CircuitIdRegex(Entity):
                                                                                """
                                                                                Circuit ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                    self.yang_name = "circuit-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "circuit-id-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                            class RemoteId(Entity):
                                                                                """
                                                                                Remote ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                    self.yang_name = "remote-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "remote-id"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                            class RemoteIdRegex(Entity):
                                                                                """
                                                                                Remote ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                    self.yang_name = "remote-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "remote-id-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                            class SrcPort(Entity):
                                                                                """
                                                                                Source port
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                    self.yang_name = "src-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "src-port"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "src-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class DstPort(Entity):
                                                                                """
                                                                                Destination port
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                    self.yang_name = "dst-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-port"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "dst-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['min', 'max'], name, value)


                                                        class ActInfop(Entity):
                                                            """
                                                            act infop
                                                            
                                                            .. attribute:: policy_action_info_st
                                                            
                                                            	policy action info st
                                                            	**type**\: list of  		 :py:class:`PolicyActionInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'infra-policymgr-oper'
                                                            _revision = '2018-01-17'

                                                            def __init__(self):
                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop, self).__init__()

                                                                self.yang_name = "act-infop"
                                                                self.yang_parent_name = "policy-class-info-bg"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("policy-action-info-st", ("policy_action_info_st", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt))])
                                                                self._leafs = OrderedDict()

                                                                self.policy_action_info_st = YList(self)
                                                                self._segment_path = lambda: "act-infop"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop, [], name, value)


                                                            class PolicyActionInfoSt(Entity):
                                                                """
                                                                policy action info st
                                                                
                                                                .. attribute:: actp
                                                                
                                                                	actp
                                                                	**type**\:  :py:class:`Actp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp>`
                                                                
                                                                .. attribute:: seq
                                                                
                                                                	seq
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..65535
                                                                
                                                                .. attribute:: flags
                                                                
                                                                	flags
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..65535
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt, self).__init__()

                                                                    self.yang_name = "policy-action-info-st"
                                                                    self.yang_parent_name = "act-infop"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("actp", ("actp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp))])
                                                                    self._leafs = OrderedDict([
                                                                        ('seq', (YLeaf(YType.uint16, 'seq'), ['int'])),
                                                                        ('flags', (YLeaf(YType.uint16, 'flags'), ['int'])),
                                                                    ])
                                                                    self.seq = None
                                                                    self.flags = None

                                                                    self.actp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp()
                                                                    self.actp.parent = self
                                                                    self._children_name_map["actp"] = "actp"
                                                                    self._segment_path = lambda: "policy-action-info-st"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt, ['seq', 'flags'], name, value)


                                                                class Actp(Entity):
                                                                    """
                                                                    actp
                                                                    
                                                                    .. attribute:: mark
                                                                    
                                                                    	mark
                                                                    	**type**\:  :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark>`
                                                                    
                                                                    .. attribute:: mark2
                                                                    
                                                                    	mark2
                                                                    	**type**\:  :py:class:`Mark2 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2>`
                                                                    
                                                                    .. attribute:: wred
                                                                    
                                                                    	wred
                                                                    	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred>`
                                                                    
                                                                    .. attribute:: encap
                                                                    
                                                                    	encap
                                                                    	**type**\:  :py:class:`Encap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap>`
                                                                    
                                                                    .. attribute:: prio
                                                                    
                                                                    	prio
                                                                    	**type**\:  :py:class:`Prio <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio>`
                                                                    
                                                                    .. attribute:: bwrem
                                                                    
                                                                    	bwrem
                                                                    	**type**\:  :py:class:`Bwrem <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem>`
                                                                    
                                                                    .. attribute:: min_bw
                                                                    
                                                                    	min bw
                                                                    	**type**\:  :py:class:`MinBw <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw>`
                                                                    
                                                                    .. attribute:: authen_aaa
                                                                    
                                                                    	authen aaa
                                                                    	**type**\:  :py:class:`AuthenAaa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa>`
                                                                    
                                                                    .. attribute:: collect_id
                                                                    
                                                                    	collect id
                                                                    	**type**\:  :py:class:`CollectId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId>`
                                                                    
                                                                    .. attribute:: decode_id
                                                                    
                                                                    	decode id
                                                                    	**type**\:  :py:class:`DecodeId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId>`
                                                                    
                                                                    .. attribute:: set_timer
                                                                    
                                                                    	set timer
                                                                    	**type**\:  :py:class:`SetTimer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer>`
                                                                    
                                                                    .. attribute:: stop_timer
                                                                    
                                                                    	stop timer
                                                                    	**type**\:  :py:class:`StopTimer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer>`
                                                                    
                                                                    .. attribute:: acct_aaa_list
                                                                    
                                                                    	acct aaa list
                                                                    	**type**\:  :py:class:`AcctAaaList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList>`
                                                                    
                                                                    .. attribute:: query_ancp
                                                                    
                                                                    	query ancp
                                                                    	**type**\:  :py:class:`QueryAncp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp>`
                                                                    
                                                                    .. attribute:: prepaid_cfg
                                                                    
                                                                    	prepaid cfg
                                                                    	**type**\:  :py:class:`PrepaidCfg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg>`
                                                                    
                                                                    .. attribute:: timeout_idle
                                                                    
                                                                    	timeout idle
                                                                    	**type**\:  :py:class:`TimeoutIdle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle>`
                                                                    
                                                                    .. attribute:: proxy_aaa
                                                                    
                                                                    	proxy aaa
                                                                    	**type**\:  :py:class:`ProxyAaa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa>`
                                                                    
                                                                    .. attribute:: act_template
                                                                    
                                                                    	act template
                                                                    	**type**\:  :py:class:`ActTemplate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate>`
                                                                    
                                                                    .. attribute:: deact_template
                                                                    
                                                                    	deact template
                                                                    	**type**\:  :py:class:`DeactTemplate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate>`
                                                                    
                                                                    .. attribute:: qlimit
                                                                    
                                                                    	qlimit
                                                                    	**type**\:  :py:class:`Qlimit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit>`
                                                                    
                                                                    .. attribute:: accounting_event_aaa
                                                                    
                                                                    	accounting event aaa
                                                                    	**type**\:  :py:class:`AccountingEventAaa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa>`
                                                                    
                                                                    .. attribute:: authorize_id
                                                                    
                                                                    	authorize id
                                                                    	**type**\:  :py:class:`AuthorizeId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId>`
                                                                    
                                                                    .. attribute:: afm_react
                                                                    
                                                                    	afm react
                                                                    	**type**\:  :py:class:`AfmReact <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact>`
                                                                    
                                                                    .. attribute:: httpr
                                                                    
                                                                    	httpr
                                                                    	**type**\:  :py:class:`Httpr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr>`
                                                                    
                                                                    .. attribute:: punt
                                                                    
                                                                    	punt
                                                                    	**type**\:  :py:class:`Punt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt>`
                                                                    
                                                                    .. attribute:: copy
                                                                    
                                                                    	copy
                                                                    	**type**\:  :py:class:`Copy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy>`
                                                                    
                                                                    .. attribute:: sfrag
                                                                    
                                                                    	sfrag
                                                                    	**type**\:  :py:class:`Sfrag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag>`
                                                                    
                                                                    .. attribute:: redirect
                                                                    
                                                                    	redirect
                                                                    	**type**\:  :py:class:`Redirect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect>`
                                                                    
                                                                    .. attribute:: out_intf
                                                                    
                                                                    	out intf
                                                                    	**type**\:  :py:class:`OutIntf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf>`
                                                                    
                                                                    .. attribute:: serv_func
                                                                    
                                                                    	serv func
                                                                    	**type**\:  :py:class:`ServFunc <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc>`
                                                                    
                                                                    .. attribute:: police
                                                                    
                                                                    	police
                                                                    	**type**\:  :py:class:`Police <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police>`
                                                                    
                                                                    .. attribute:: shape
                                                                    
                                                                    	shape
                                                                    	**type**\:  :py:class:`Shape <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape>`
                                                                    
                                                                    .. attribute:: child_policy
                                                                    
                                                                    	child policy
                                                                    	**type**\:  :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy>`
                                                                    
                                                                    .. attribute:: cac
                                                                    
                                                                    	cac
                                                                    	**type**\:  :py:class:`Cac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac>`
                                                                    
                                                                    .. attribute:: pfc
                                                                    
                                                                    	pfc
                                                                    	**type**\:  :py:class:`Pfc <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc>`
                                                                    
                                                                    .. attribute:: flow_parm
                                                                    
                                                                    	flow parm
                                                                    	**type**\:  :py:class:`FlowParm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm>`
                                                                    
                                                                    .. attribute:: ipcbr
                                                                    
                                                                    	ipcbr
                                                                    	**type**\:  :py:class:`Ipcbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr>`
                                                                    
                                                                    .. attribute:: rtp
                                                                    
                                                                    	rtp
                                                                    	**type**\:  :py:class:`Rtp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp>`
                                                                    
                                                                    .. attribute:: rtp_mmr
                                                                    
                                                                    	rtp mmr
                                                                    	**type**\:  :py:class:`RtpMmr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr>`
                                                                    
                                                                    .. attribute:: rtp_j2k
                                                                    
                                                                    	rtp j2k
                                                                    	**type**\:  :py:class:`RtpJ2k <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k>`
                                                                    
                                                                    .. attribute:: rtp_voice
                                                                    
                                                                    	rtp voice
                                                                    	**type**\:  :py:class:`RtpVoice <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice>`
                                                                    
                                                                    .. attribute:: mdi
                                                                    
                                                                    	mdi
                                                                    	**type**\:  :py:class:`Mdi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi>`
                                                                    
                                                                    .. attribute:: mdi_rtp
                                                                    
                                                                    	mdi rtp
                                                                    	**type**\:  :py:class:`MdiRtp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp>`
                                                                    
                                                                    .. attribute:: fmm
                                                                    
                                                                    	fmm
                                                                    	**type**\:  :py:class:`Fmm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm>`
                                                                    
                                                                    .. attribute:: pbf
                                                                    
                                                                    	pbf
                                                                    	**type**\:  :py:class:`Pbf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf>`
                                                                    
                                                                    .. attribute:: ipv4_nh
                                                                    
                                                                    	ipv4 nh
                                                                    	**type**\:  :py:class:`Ipv4Nh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh>`
                                                                    
                                                                    .. attribute:: ipv6_nh
                                                                    
                                                                    	ipv6 nh
                                                                    	**type**\:  :py:class:`Ipv6Nh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh>`
                                                                    
                                                                    .. attribute:: type
                                                                    
                                                                    	type
                                                                    	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                    
                                                                    .. attribute:: data_p
                                                                    
                                                                    	data p
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp, self).__init__()

                                                                        self.yang_name = "actp"
                                                                        self.yang_parent_name = "policy-action-info-st"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("mark", ("mark", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark)), ("mark2", ("mark2", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2)), ("wred", ("wred", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred)), ("encap", ("encap", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap)), ("prio", ("prio", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio)), ("bwrem", ("bwrem", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem)), ("min-bw", ("min_bw", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw)), ("authen-aaa", ("authen_aaa", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa)), ("collect-id", ("collect_id", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId)), ("decode-id", ("decode_id", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId)), ("set-timer", ("set_timer", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer)), ("stop-timer", ("stop_timer", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer)), ("acct-aaa-list", ("acct_aaa_list", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList)), ("query-ancp", ("query_ancp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp)), ("prepaid-cfg", ("prepaid_cfg", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg)), ("timeout-idle", ("timeout_idle", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle)), ("proxy-aaa", ("proxy_aaa", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa)), ("act-template", ("act_template", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate)), ("deact-template", ("deact_template", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate)), ("qlimit", ("qlimit", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit)), ("accounting-event-aaa", ("accounting_event_aaa", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa)), ("authorize-id", ("authorize_id", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId)), ("afm-react", ("afm_react", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact)), ("httpr", ("httpr", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr)), ("punt", ("punt", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt)), ("copy", ("copy", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy)), ("sfrag", ("sfrag", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag)), ("redirect", ("redirect", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect)), ("out-intf", ("out_intf", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf)), ("serv-func", ("serv_func", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc)), ("police", ("police", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police)), ("shape", ("shape", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape)), ("child-policy", ("child_policy", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy)), ("cac", ("cac", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac)), ("pfc", ("pfc", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc)), ("flow-parm", ("flow_parm", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm)), ("ipcbr", ("ipcbr", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr)), ("rtp", ("rtp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp)), ("rtp-mmr", ("rtp_mmr", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr)), ("rtp-j2k", ("rtp_j2k", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k)), ("rtp-voice", ("rtp_voice", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice)), ("mdi", ("mdi", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi)), ("mdi-rtp", ("mdi_rtp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp)), ("fmm", ("fmm", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm)), ("pbf", ("pbf", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf)), ("ipv4-nh", ("ipv4_nh", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh)), ("ipv6-nh", ("ipv6_nh", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh))])
                                                                        self._leafs = OrderedDict([
                                                                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                            ('data_p', (YLeaf(YType.uint32, 'data-p'), ['int'])),
                                                                        ])
                                                                        self.type = None
                                                                        self.data_p = None

                                                                        self.mark = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark()
                                                                        self.mark.parent = self
                                                                        self._children_name_map["mark"] = "mark"

                                                                        self.mark2 = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2()
                                                                        self.mark2.parent = self
                                                                        self._children_name_map["mark2"] = "mark2"

                                                                        self.wred = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred()
                                                                        self.wred.parent = self
                                                                        self._children_name_map["wred"] = "wred"

                                                                        self.encap = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap()
                                                                        self.encap.parent = self
                                                                        self._children_name_map["encap"] = "encap"

                                                                        self.prio = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio()
                                                                        self.prio.parent = self
                                                                        self._children_name_map["prio"] = "prio"

                                                                        self.bwrem = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem()
                                                                        self.bwrem.parent = self
                                                                        self._children_name_map["bwrem"] = "bwrem"

                                                                        self.min_bw = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw()
                                                                        self.min_bw.parent = self
                                                                        self._children_name_map["min_bw"] = "min-bw"

                                                                        self.authen_aaa = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa()
                                                                        self.authen_aaa.parent = self
                                                                        self._children_name_map["authen_aaa"] = "authen-aaa"

                                                                        self.collect_id = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId()
                                                                        self.collect_id.parent = self
                                                                        self._children_name_map["collect_id"] = "collect-id"

                                                                        self.decode_id = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId()
                                                                        self.decode_id.parent = self
                                                                        self._children_name_map["decode_id"] = "decode-id"

                                                                        self.set_timer = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer()
                                                                        self.set_timer.parent = self
                                                                        self._children_name_map["set_timer"] = "set-timer"

                                                                        self.stop_timer = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer()
                                                                        self.stop_timer.parent = self
                                                                        self._children_name_map["stop_timer"] = "stop-timer"

                                                                        self.acct_aaa_list = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList()
                                                                        self.acct_aaa_list.parent = self
                                                                        self._children_name_map["acct_aaa_list"] = "acct-aaa-list"

                                                                        self.query_ancp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp()
                                                                        self.query_ancp.parent = self
                                                                        self._children_name_map["query_ancp"] = "query-ancp"

                                                                        self.prepaid_cfg = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg()
                                                                        self.prepaid_cfg.parent = self
                                                                        self._children_name_map["prepaid_cfg"] = "prepaid-cfg"

                                                                        self.timeout_idle = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle()
                                                                        self.timeout_idle.parent = self
                                                                        self._children_name_map["timeout_idle"] = "timeout-idle"

                                                                        self.proxy_aaa = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa()
                                                                        self.proxy_aaa.parent = self
                                                                        self._children_name_map["proxy_aaa"] = "proxy-aaa"

                                                                        self.act_template = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate()
                                                                        self.act_template.parent = self
                                                                        self._children_name_map["act_template"] = "act-template"

                                                                        self.deact_template = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate()
                                                                        self.deact_template.parent = self
                                                                        self._children_name_map["deact_template"] = "deact-template"

                                                                        self.qlimit = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit()
                                                                        self.qlimit.parent = self
                                                                        self._children_name_map["qlimit"] = "qlimit"

                                                                        self.accounting_event_aaa = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa()
                                                                        self.accounting_event_aaa.parent = self
                                                                        self._children_name_map["accounting_event_aaa"] = "accounting-event-aaa"

                                                                        self.authorize_id = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId()
                                                                        self.authorize_id.parent = self
                                                                        self._children_name_map["authorize_id"] = "authorize-id"

                                                                        self.afm_react = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact()
                                                                        self.afm_react.parent = self
                                                                        self._children_name_map["afm_react"] = "afm-react"

                                                                        self.httpr = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr()
                                                                        self.httpr.parent = self
                                                                        self._children_name_map["httpr"] = "httpr"

                                                                        self.punt = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt()
                                                                        self.punt.parent = self
                                                                        self._children_name_map["punt"] = "punt"

                                                                        self.copy = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy()
                                                                        self.copy.parent = self
                                                                        self._children_name_map["copy"] = "copy"

                                                                        self.sfrag = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag()
                                                                        self.sfrag.parent = self
                                                                        self._children_name_map["sfrag"] = "sfrag"

                                                                        self.redirect = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect()
                                                                        self.redirect.parent = self
                                                                        self._children_name_map["redirect"] = "redirect"

                                                                        self.out_intf = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf()
                                                                        self.out_intf.parent = self
                                                                        self._children_name_map["out_intf"] = "out-intf"

                                                                        self.serv_func = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc()
                                                                        self.serv_func.parent = self
                                                                        self._children_name_map["serv_func"] = "serv-func"

                                                                        self.police = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police()
                                                                        self.police.parent = self
                                                                        self._children_name_map["police"] = "police"

                                                                        self.shape = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape()
                                                                        self.shape.parent = self
                                                                        self._children_name_map["shape"] = "shape"

                                                                        self.child_policy = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy()
                                                                        self.child_policy.parent = self
                                                                        self._children_name_map["child_policy"] = "child-policy"

                                                                        self.cac = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac()
                                                                        self.cac.parent = self
                                                                        self._children_name_map["cac"] = "cac"

                                                                        self.pfc = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc()
                                                                        self.pfc.parent = self
                                                                        self._children_name_map["pfc"] = "pfc"

                                                                        self.flow_parm = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm()
                                                                        self.flow_parm.parent = self
                                                                        self._children_name_map["flow_parm"] = "flow-parm"

                                                                        self.ipcbr = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr()
                                                                        self.ipcbr.parent = self
                                                                        self._children_name_map["ipcbr"] = "ipcbr"

                                                                        self.rtp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp()
                                                                        self.rtp.parent = self
                                                                        self._children_name_map["rtp"] = "rtp"

                                                                        self.rtp_mmr = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr()
                                                                        self.rtp_mmr.parent = self
                                                                        self._children_name_map["rtp_mmr"] = "rtp-mmr"

                                                                        self.rtp_j2k = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k()
                                                                        self.rtp_j2k.parent = self
                                                                        self._children_name_map["rtp_j2k"] = "rtp-j2k"

                                                                        self.rtp_voice = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice()
                                                                        self.rtp_voice.parent = self
                                                                        self._children_name_map["rtp_voice"] = "rtp-voice"

                                                                        self.mdi = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi()
                                                                        self.mdi.parent = self
                                                                        self._children_name_map["mdi"] = "mdi"

                                                                        self.mdi_rtp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp()
                                                                        self.mdi_rtp.parent = self
                                                                        self._children_name_map["mdi_rtp"] = "mdi-rtp"

                                                                        self.fmm = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm()
                                                                        self.fmm.parent = self
                                                                        self._children_name_map["fmm"] = "fmm"

                                                                        self.pbf = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf()
                                                                        self.pbf.parent = self
                                                                        self._children_name_map["pbf"] = "pbf"

                                                                        self.ipv4_nh = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh()
                                                                        self.ipv4_nh.parent = self
                                                                        self._children_name_map["ipv4_nh"] = "ipv4-nh"

                                                                        self.ipv6_nh = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh()
                                                                        self.ipv6_nh.parent = self
                                                                        self._children_name_map["ipv6_nh"] = "ipv6-nh"
                                                                        self._segment_path = lambda: "actp"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp, ['type', 'data_p'], name, value)


                                                                    class Mark(Entity):
                                                                        """
                                                                        mark
                                                                        
                                                                        .. attribute:: action_mark_info
                                                                        
                                                                        	action mark info
                                                                        	**type**\: list of  		 :py:class:`ActionMarkInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark, self).__init__()

                                                                            self.yang_name = "mark"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("action-mark-info", ("action_mark_info", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo))])
                                                                            self._leafs = OrderedDict()

                                                                            self.action_mark_info = YList(self)
                                                                            self._segment_path = lambda: "mark"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark, [], name, value)


                                                                        class ActionMarkInfo(Entity):
                                                                            """
                                                                            action mark info
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:  :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                            
                                                                            .. attribute:: mark_flags
                                                                            
                                                                            	mark flags
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo, self).__init__()

                                                                                self.yang_name = "action-mark-info"
                                                                                self.yang_parent_name = "mark"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MarkTypeEn', '')])),
                                                                                    ('mark_flags', (YLeaf(YType.uint32, 'mark-flags'), ['int'])),
                                                                                    ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                ])
                                                                                self.type = None
                                                                                self.mark_flags = None
                                                                                self.value = None
                                                                                self._segment_path = lambda: "action-mark-info"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo, ['type', 'mark_flags', 'value'], name, value)


                                                                    class Mark2(Entity):
                                                                        """
                                                                        mark2
                                                                        
                                                                        .. attribute:: action_mark2_info
                                                                        
                                                                        	action mark2 info
                                                                        	**type**\: list of  		 :py:class:`ActionMark2Info <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2, self).__init__()

                                                                            self.yang_name = "mark2"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("action-mark2-info", ("action_mark2_info", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info))])
                                                                            self._leafs = OrderedDict()

                                                                            self.action_mark2_info = YList(self)
                                                                            self._segment_path = lambda: "mark2"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2, [], name, value)


                                                                        class ActionMark2Info(Entity):
                                                                            """
                                                                            action mark2 info
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: value_overflow
                                                                            
                                                                            	value overflow
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: mark_flags
                                                                            
                                                                            	mark flags
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info, self).__init__()

                                                                                self.yang_name = "action-mark2-info"
                                                                                self.yang_parent_name = "mark2"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('value_overflow', (YLeaf(YType.uint16, 'value-overflow'), ['int'])),
                                                                                    ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                    ('mark_flags', (YLeaf(YType.uint8, 'mark-flags'), ['int'])),
                                                                                ])
                                                                                self.value = None
                                                                                self.value_overflow = None
                                                                                self.type = None
                                                                                self.mark_flags = None
                                                                                self._segment_path = lambda: "action-mark2-info"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info, ['value', 'value_overflow', 'type', 'mark_flags'], name, value)


                                                                    class Wred(Entity):
                                                                        """
                                                                        wred
                                                                        
                                                                        .. attribute:: action_wred_info
                                                                        
                                                                        	action wred info
                                                                        	**type**\: list of  		 :py:class:`ActionWredInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred, self).__init__()

                                                                            self.yang_name = "wred"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("action-wred-info", ("action_wred_info", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo))])
                                                                            self._leafs = OrderedDict()

                                                                            self.action_wred_info = YList(self)
                                                                            self._segment_path = lambda: "wred"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred, [], name, value)


                                                                        class ActionWredInfo(Entity):
                                                                            """
                                                                            action wred info
                                                                            
                                                                            .. attribute:: match_ranges
                                                                            
                                                                            	match ranges
                                                                            	**type**\:  :py:class:`MatchRanges <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges>`
                                                                            
                                                                            .. attribute:: min_threshold
                                                                            
                                                                            	min threshold
                                                                            	**type**\:  :py:class:`MinThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold>`
                                                                            
                                                                            .. attribute:: max_threshold
                                                                            
                                                                            	max threshold
                                                                            	**type**\:  :py:class:`MaxThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold>`
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	cos/prec/dscp/ based WRED
                                                                            	**type**\:  :py:class:`WredTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.WredTypeEn>`
                                                                            
                                                                            .. attribute:: wred_flags
                                                                            
                                                                            	wred flags
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: probability
                                                                            
                                                                            	probability
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo, self).__init__()

                                                                                self.yang_name = "action-wred-info"
                                                                                self.yang_parent_name = "wred"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("match-ranges", ("match_ranges", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges)), ("min-threshold", ("min_threshold", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold)), ("max-threshold", ("max_threshold", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'WredTypeEn', '')])),
                                                                                    ('wred_flags', (YLeaf(YType.uint32, 'wred-flags'), ['int'])),
                                                                                    ('probability', (YLeaf(YType.uint32, 'probability'), ['int'])),
                                                                                ])
                                                                                self.type = None
                                                                                self.wred_flags = None
                                                                                self.probability = None

                                                                                self.match_ranges = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges()
                                                                                self.match_ranges.parent = self
                                                                                self._children_name_map["match_ranges"] = "match-ranges"

                                                                                self.min_threshold = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold()
                                                                                self.min_threshold.parent = self
                                                                                self._children_name_map["min_threshold"] = "min-threshold"

                                                                                self.max_threshold = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold()
                                                                                self.max_threshold.parent = self
                                                                                self._children_name_map["max_threshold"] = "max-threshold"
                                                                                self._segment_path = lambda: "action-wred-info"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo, ['type', 'wred_flags', 'probability'], name, value)


                                                                            class MatchRanges(Entity):
                                                                                """
                                                                                match ranges
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges, self).__init__()

                                                                                    self.yang_name = "match-ranges"
                                                                                    self.yang_parent_name = "action-wred-info"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "match-ranges"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "match-ranges"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class MinThreshold(Entity):
                                                                                """
                                                                                min threshold
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold, self).__init__()

                                                                                    self.yang_name = "min-threshold"
                                                                                    self.yang_parent_name = "action-wred-info"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.unit = None
                                                                                    self._segment_path = lambda: "min-threshold"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold, ['value', 'unit'], name, value)


                                                                            class MaxThreshold(Entity):
                                                                                """
                                                                                max threshold
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold, self).__init__()

                                                                                    self.yang_name = "max-threshold"
                                                                                    self.yang_parent_name = "action-wred-info"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.unit = None
                                                                                    self._segment_path = lambda: "max-threshold"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold, ['value', 'unit'], name, value)


                                                                    class Encap(Entity):
                                                                        """
                                                                        encap
                                                                        
                                                                        .. attribute:: seq
                                                                        
                                                                        	seq
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap, self).__init__()

                                                                            self.yang_name = "encap"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('seq', (YLeaf(YType.uint8, 'seq'), ['int'])),
                                                                            ])
                                                                            self.seq = None
                                                                            self._segment_path = lambda: "encap"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap, ['seq'], name, value)


                                                                    class Prio(Entity):
                                                                        """
                                                                        prio
                                                                        
                                                                        .. attribute:: prio_lvl
                                                                        
                                                                        	prio lvl
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio, self).__init__()

                                                                            self.yang_name = "prio"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('prio_lvl', (YLeaf(YType.uint32, 'prio-lvl'), ['int'])),
                                                                            ])
                                                                            self.prio_lvl = None
                                                                            self._segment_path = lambda: "prio"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio, ['prio_lvl'], name, value)


                                                                    class Bwrem(Entity):
                                                                        """
                                                                        bwrem
                                                                        
                                                                        .. attribute:: bwrem
                                                                        
                                                                        	bwrem
                                                                        	**type**\:  :py:class:`Bwrem_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem_>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem, self).__init__()

                                                                            self.yang_name = "bwrem"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("bwrem", ("bwrem", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem_))])
                                                                            self._leafs = OrderedDict()

                                                                            self.bwrem = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem_()
                                                                            self.bwrem.parent = self
                                                                            self._children_name_map["bwrem"] = "bwrem"
                                                                            self._segment_path = lambda: "bwrem"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem, [], name, value)


                                                                        class Bwrem_(Entity):
                                                                            """
                                                                            bwrem
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem_, self).__init__()

                                                                                self.yang_name = "bwrem"
                                                                                self.yang_parent_name = "bwrem"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "bwrem"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem_, ['value', 'unit'], name, value)


                                                                    class MinBw(Entity):
                                                                        """
                                                                        min bw
                                                                        
                                                                        .. attribute:: bw
                                                                        
                                                                        	bw
                                                                        	**type**\:  :py:class:`Bw <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw, self).__init__()

                                                                            self.yang_name = "min-bw"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("bw", ("bw", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw))])
                                                                            self._leafs = OrderedDict()

                                                                            self.bw = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw()
                                                                            self.bw.parent = self
                                                                            self._children_name_map["bw"] = "bw"
                                                                            self._segment_path = lambda: "min-bw"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw, [], name, value)


                                                                        class Bw(Entity):
                                                                            """
                                                                            bw
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw, self).__init__()

                                                                                self.yang_name = "bw"
                                                                                self.yang_parent_name = "min-bw"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "bw"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw, ['value', 'unit'], name, value)


                                                                    class AuthenAaa(Entity):
                                                                        """
                                                                        authen aaa
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: authen_password
                                                                        
                                                                        	authen password
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa, self).__init__()

                                                                            self.yang_name = "authen-aaa"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                                ('authen_password', (YLeaf(YType.str, 'authen-password'), ['str'])),
                                                                            ])
                                                                            self.aaa_list_name = None
                                                                            self.authen_password = None
                                                                            self._segment_path = lambda: "authen-aaa"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa, ['aaa_list_name', 'authen_password'], name, value)


                                                                    class CollectId(Entity):
                                                                        """
                                                                        collect id
                                                                        
                                                                        .. attribute:: id
                                                                        
                                                                        	id
                                                                        	**type**\:  :py:class:`IdentifierEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.IdentifierEn>`
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId, self).__init__()

                                                                            self.yang_name = "collect-id"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('id', (YLeaf(YType.enumeration, 'id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'IdentifierEn', '')])),
                                                                                ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                            ])
                                                                            self.id = None
                                                                            self.aaa_list_name = None
                                                                            self._segment_path = lambda: "collect-id"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId, ['id', 'aaa_list_name'], name, value)


                                                                    class DecodeId(Entity):
                                                                        """
                                                                        decode id
                                                                        
                                                                        .. attribute:: id
                                                                        
                                                                        	id
                                                                        	**type**\:  :py:class:`DecodeIdentifierEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.DecodeIdentifierEn>`
                                                                        
                                                                        .. attribute:: format_name
                                                                        
                                                                        	format name
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId, self).__init__()

                                                                            self.yang_name = "decode-id"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('id', (YLeaf(YType.enumeration, 'id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'DecodeIdentifierEn', '')])),
                                                                                ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                            ])
                                                                            self.id = None
                                                                            self.format_name = None
                                                                            self._segment_path = lambda: "decode-id"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId, ['id', 'format_name'], name, value)


                                                                    class SetTimer(Entity):
                                                                        """
                                                                        set timer
                                                                        
                                                                        .. attribute:: timer_name
                                                                        
                                                                        	timer name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: duration
                                                                        
                                                                        	duration
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: absolute_time
                                                                        
                                                                        	absolute time
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer, self).__init__()

                                                                            self.yang_name = "set-timer"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('timer_name', (YLeaf(YType.str, 'timer-name'), ['str'])),
                                                                                ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                                                ('absolute_time', (YLeaf(YType.str, 'absolute-time'), ['str'])),
                                                                            ])
                                                                            self.timer_name = None
                                                                            self.duration = None
                                                                            self.absolute_time = None
                                                                            self._segment_path = lambda: "set-timer"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer, ['timer_name', 'duration', 'absolute_time'], name, value)


                                                                    class StopTimer(Entity):
                                                                        """
                                                                        stop timer
                                                                        
                                                                        .. attribute:: timer_name
                                                                        
                                                                        	timer name
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer, self).__init__()

                                                                            self.yang_name = "stop-timer"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('timer_name', (YLeaf(YType.str, 'timer-name'), ['str'])),
                                                                            ])
                                                                            self.timer_name = None
                                                                            self._segment_path = lambda: "stop-timer"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer, ['timer_name'], name, value)


                                                                    class AcctAaaList(Entity):
                                                                        """
                                                                        acct aaa list
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: secs
                                                                        
                                                                        	secs
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList, self).__init__()

                                                                            self.yang_name = "acct-aaa-list"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                                ('secs', (YLeaf(YType.uint32, 'secs'), ['int'])),
                                                                            ])
                                                                            self.aaa_list_name = None
                                                                            self.secs = None
                                                                            self._segment_path = lambda: "acct-aaa-list"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList, ['aaa_list_name', 'secs'], name, value)


                                                                    class QueryAncp(Entity):
                                                                        """
                                                                        query ancp
                                                                        
                                                                        .. attribute:: enable
                                                                        
                                                                        	enable
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp, self).__init__()

                                                                            self.yang_name = "query-ancp"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('enable', (YLeaf(YType.uint8, 'enable'), ['int'])),
                                                                            ])
                                                                            self.enable = None
                                                                            self._segment_path = lambda: "query-ancp"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp, ['enable'], name, value)


                                                                    class PrepaidCfg(Entity):
                                                                        """
                                                                        prepaid cfg
                                                                        
                                                                        .. attribute:: prepaid_config_profile_name
                                                                        
                                                                        	prepaid config profile name
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg, self).__init__()

                                                                            self.yang_name = "prepaid-cfg"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('prepaid_config_profile_name', (YLeaf(YType.str, 'prepaid-config-profile-name'), ['str'])),
                                                                            ])
                                                                            self.prepaid_config_profile_name = None
                                                                            self._segment_path = lambda: "prepaid-cfg"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg, ['prepaid_config_profile_name'], name, value)


                                                                    class TimeoutIdle(Entity):
                                                                        """
                                                                        timeout idle
                                                                        
                                                                        .. attribute:: secs
                                                                        
                                                                        	secs
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle, self).__init__()

                                                                            self.yang_name = "timeout-idle"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('secs', (YLeaf(YType.uint32, 'secs'), ['int'])),
                                                                            ])
                                                                            self.secs = None
                                                                            self._segment_path = lambda: "timeout-idle"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle, ['secs'], name, value)


                                                                    class ProxyAaa(Entity):
                                                                        """
                                                                        proxy aaa
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa, self).__init__()

                                                                            self.yang_name = "proxy-aaa"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                            ])
                                                                            self.aaa_list_name = None
                                                                            self._segment_path = lambda: "proxy-aaa"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa, ['aaa_list_name'], name, value)


                                                                    class ActTemplate(Entity):
                                                                        """
                                                                        act template
                                                                        
                                                                        .. attribute:: template_name
                                                                        
                                                                        	template name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: flags
                                                                        
                                                                        	flags
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate, self).__init__()

                                                                            self.yang_name = "act-template"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('template_name', (YLeaf(YType.str, 'template-name'), ['str'])),
                                                                                ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                                ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                            ])
                                                                            self.template_name = None
                                                                            self.aaa_list_name = None
                                                                            self.flags = None
                                                                            self._segment_path = lambda: "act-template"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate, ['template_name', 'aaa_list_name', 'flags'], name, value)


                                                                    class DeactTemplate(Entity):
                                                                        """
                                                                        deact template
                                                                        
                                                                        .. attribute:: template_name
                                                                        
                                                                        	template name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: flags
                                                                        
                                                                        	flags
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate, self).__init__()

                                                                            self.yang_name = "deact-template"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('template_name', (YLeaf(YType.str, 'template-name'), ['str'])),
                                                                                ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                                ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                            ])
                                                                            self.template_name = None
                                                                            self.aaa_list_name = None
                                                                            self.flags = None
                                                                            self._segment_path = lambda: "deact-template"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate, ['template_name', 'aaa_list_name', 'flags'], name, value)


                                                                    class Qlimit(Entity):
                                                                        """
                                                                        qlimit
                                                                        
                                                                        .. attribute:: action_qlimit_info_array
                                                                        
                                                                        	action qlimit info array
                                                                        	**type**\: list of  		 :py:class:`ActionQlimitInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit, self).__init__()

                                                                            self.yang_name = "qlimit"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("action-qlimit-info-array", ("action_qlimit_info_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.action_qlimit_info_array = YList(self)
                                                                            self._segment_path = lambda: "qlimit"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit, [], name, value)


                                                                        class ActionQlimitInfoArray(Entity):
                                                                            """
                                                                            action qlimit info array
                                                                            
                                                                            .. attribute:: qlim
                                                                            
                                                                            	qlim
                                                                            	**type**\:  :py:class:`Qlim <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim>`
                                                                            
                                                                            .. attribute:: atmclp_qlim
                                                                            
                                                                            	atmclp qlim
                                                                            	**type**\:  :py:class:`AtmclpQlim <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim>`
                                                                            
                                                                            .. attribute:: match_values
                                                                            
                                                                            	match values
                                                                            	**type**\:  :py:class:`MatchValues <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues>`
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:  :py:class:`QlimitTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.QlimitTypeEn>`
                                                                            
                                                                            .. attribute:: qlimit_flags
                                                                            
                                                                            	qlimit flags
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray, self).__init__()

                                                                                self.yang_name = "action-qlimit-info-array"
                                                                                self.yang_parent_name = "qlimit"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("qlim", ("qlim", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim)), ("atmclp-qlim", ("atmclp_qlim", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim)), ("match-values", ("match_values", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'QlimitTypeEn', '')])),
                                                                                    ('qlimit_flags', (YLeaf(YType.uint32, 'qlimit-flags'), ['int'])),
                                                                                ])
                                                                                self.type = None
                                                                                self.qlimit_flags = None

                                                                                self.qlim = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim()
                                                                                self.qlim.parent = self
                                                                                self._children_name_map["qlim"] = "qlim"

                                                                                self.atmclp_qlim = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim()
                                                                                self.atmclp_qlim.parent = self
                                                                                self._children_name_map["atmclp_qlim"] = "atmclp-qlim"

                                                                                self.match_values = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues()
                                                                                self.match_values.parent = self
                                                                                self._children_name_map["match_values"] = "match-values"
                                                                                self._segment_path = lambda: "action-qlimit-info-array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray, ['type', 'qlimit_flags'], name, value)


                                                                            class Qlim(Entity):
                                                                                """
                                                                                qlim
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim, self).__init__()

                                                                                    self.yang_name = "qlim"
                                                                                    self.yang_parent_name = "action-qlimit-info-array"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.unit = None
                                                                                    self._segment_path = lambda: "qlim"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim, ['value', 'unit'], name, value)


                                                                            class AtmclpQlim(Entity):
                                                                                """
                                                                                atmclp qlim
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim, self).__init__()

                                                                                    self.yang_name = "atmclp-qlim"
                                                                                    self.yang_parent_name = "action-qlimit-info-array"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.unit = None
                                                                                    self._segment_path = lambda: "atmclp-qlim"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim, ['value', 'unit'], name, value)


                                                                            class MatchValues(Entity):
                                                                                """
                                                                                match values
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues, self).__init__()

                                                                                    self.yang_name = "match-values"
                                                                                    self.yang_parent_name = "action-qlimit-info-array"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "match-values"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "match-values"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray, ['min', 'max'], name, value)


                                                                    class AccountingEventAaa(Entity):
                                                                        """
                                                                        accounting event aaa
                                                                        
                                                                        .. attribute:: action
                                                                        
                                                                        	action
                                                                        	**type**\:  :py:class:`AcctEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.AcctEn>`
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa, self).__init__()

                                                                            self.yang_name = "accounting-event-aaa"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('action', (YLeaf(YType.enumeration, 'action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'AcctEn', '')])),
                                                                                ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                            ])
                                                                            self.action = None
                                                                            self.aaa_list_name = None
                                                                            self._segment_path = lambda: "accounting-event-aaa"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa, ['action', 'aaa_list_name'], name, value)


                                                                    class AuthorizeId(Entity):
                                                                        """
                                                                        authorize id
                                                                        
                                                                        .. attribute:: id
                                                                        
                                                                        	id
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: format_name
                                                                        
                                                                        	format name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: password
                                                                        
                                                                        	password
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId, self).__init__()

                                                                            self.yang_name = "authorize-id"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('id', (YLeaf(YType.uint8, 'id'), ['int'])),
                                                                                ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                                ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                ('password', (YLeaf(YType.str, 'password'), ['str'])),
                                                                            ])
                                                                            self.id = None
                                                                            self.aaa_list_name = None
                                                                            self.format_name = None
                                                                            self.password = None
                                                                            self._segment_path = lambda: "authorize-id"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId, ['id', 'aaa_list_name', 'format_name', 'password'], name, value)


                                                                    class AfmReact(Entity):
                                                                        """
                                                                        afm react
                                                                        
                                                                        .. attribute:: action_afmon_react_info
                                                                        
                                                                        	action afmon react info
                                                                        	**type**\: list of  		 :py:class:`ActionAfmonReactInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact, self).__init__()

                                                                            self.yang_name = "afm-react"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("action-afmon-react-info", ("action_afmon_react_info", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo))])
                                                                            self._leafs = OrderedDict()

                                                                            self.action_afmon_react_info = YList(self)
                                                                            self._segment_path = lambda: "afm-react"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact, [], name, value)


                                                                        class ActionAfmonReactInfo(Entity):
                                                                            """
                                                                            action afmon react info
                                                                            
                                                                            .. attribute:: oper_id
                                                                            
                                                                            	React Operation ID
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: description
                                                                            
                                                                            	Describing the oper
                                                                            	**type**\: str
                                                                            
                                                                            .. attribute:: trig_num_intvls
                                                                            
                                                                            	Averaged over N intvls
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: clone_ifh
                                                                            
                                                                            	Clone interface handle
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: notif_actns
                                                                            
                                                                            	Bitmap of actions on alert
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: criterion
                                                                            
                                                                            	React Criterion
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: trig_type
                                                                            
                                                                            	Immediate or averaged thresh trigger
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: trig_relop
                                                                            
                                                                            	Trigger LT\|LE\|GT\|GE\|Range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: trig_level_1
                                                                            
                                                                            	Trigger threshold 1/lower
                                                                            	**type**\: str
                                                                            
                                                                            .. attribute:: trig_level_2
                                                                            
                                                                            	Trigger upper threshold for range
                                                                            	**type**\: str
                                                                            
                                                                            .. attribute:: alm_grp_thresh
                                                                            
                                                                            	Num/percent in grp
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            	**units**\: percentage
                                                                            
                                                                            .. attribute:: alm_type
                                                                            
                                                                            	Discrete \| grouped alarm
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: alm_severity
                                                                            
                                                                            	Major\|Minor\|... alarm
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo, self).__init__()

                                                                                self.yang_name = "action-afmon-react-info"
                                                                                self.yang_parent_name = "afm-react"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('oper_id', (YLeaf(YType.uint32, 'oper-id'), ['int'])),
                                                                                    ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                    ('trig_num_intvls', (YLeaf(YType.uint32, 'trig-num-intvls'), ['int'])),
                                                                                    ('clone_ifh', (YLeaf(YType.uint32, 'clone-ifh'), ['int'])),
                                                                                    ('notif_actns', (YLeaf(YType.uint8, 'notif-actns'), ['int'])),
                                                                                    ('criterion', (YLeaf(YType.uint8, 'criterion'), ['int'])),
                                                                                    ('trig_type', (YLeaf(YType.uint8, 'trig-type'), ['int'])),
                                                                                    ('trig_relop', (YLeaf(YType.uint8, 'trig-relop'), ['int'])),
                                                                                    ('trig_level_1', (YLeaf(YType.str, 'trig-level-1'), ['str'])),
                                                                                    ('trig_level_2', (YLeaf(YType.str, 'trig-level-2'), ['str'])),
                                                                                    ('alm_grp_thresh', (YLeaf(YType.uint16, 'alm-grp-thresh'), ['int'])),
                                                                                    ('alm_type', (YLeaf(YType.uint8, 'alm-type'), ['int'])),
                                                                                    ('alm_severity', (YLeaf(YType.uint8, 'alm-severity'), ['int'])),
                                                                                ])
                                                                                self.oper_id = None
                                                                                self.description = None
                                                                                self.trig_num_intvls = None
                                                                                self.clone_ifh = None
                                                                                self.notif_actns = None
                                                                                self.criterion = None
                                                                                self.trig_type = None
                                                                                self.trig_relop = None
                                                                                self.trig_level_1 = None
                                                                                self.trig_level_2 = None
                                                                                self.alm_grp_thresh = None
                                                                                self.alm_type = None
                                                                                self.alm_severity = None
                                                                                self._segment_path = lambda: "action-afmon-react-info"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo, ['oper_id', 'description', 'trig_num_intvls', 'clone_ifh', 'notif_actns', 'criterion', 'trig_type', 'trig_relop', 'trig_level_1', 'trig_level_2', 'alm_grp_thresh', 'alm_type', 'alm_severity'], name, value)


                                                                    class Httpr(Entity):
                                                                        """
                                                                        httpr
                                                                        
                                                                        .. attribute:: redirect_url
                                                                        
                                                                        	redirect url
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr, self).__init__()

                                                                            self.yang_name = "httpr"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('redirect_url', (YLeaf(YType.str, 'redirect-url'), ['str'])),
                                                                            ])
                                                                            self.redirect_url = None
                                                                            self._segment_path = lambda: "httpr"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr, ['redirect_url'], name, value)


                                                                    class Punt(Entity):
                                                                        """
                                                                        punt
                                                                        
                                                                        .. attribute:: sn_type
                                                                        
                                                                        	service node ID type
                                                                        	**type**\:  :py:class:`DpssSnidTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.DpssSnidTypeEn>`
                                                                        
                                                                        .. attribute:: sn_index
                                                                        
                                                                        	service node index
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: sn_name
                                                                        
                                                                        	service node name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: app_id
                                                                        
                                                                        	application ID
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: local_id
                                                                        
                                                                        	local ID
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: vsnode_type
                                                                        
                                                                        	vservice node type
                                                                        	**type**\:  :py:class:`VsvcServiceTypeT <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.VsvcServiceTypeT>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt, self).__init__()

                                                                            self.yang_name = "punt"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('sn_type', (YLeaf(YType.enumeration, 'sn-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'DpssSnidTypeEn', '')])),
                                                                                ('sn_index', (YLeaf(YType.uint32, 'sn-index'), ['int'])),
                                                                                ('sn_name', (YLeaf(YType.str, 'sn-name'), ['str'])),
                                                                                ('app_id', (YLeaf(YType.uint32, 'app-id'), ['int'])),
                                                                                ('local_id', (YLeaf(YType.uint32, 'local-id'), ['int'])),
                                                                                ('vsnode_type', (YLeaf(YType.enumeration, 'vsnode-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'VsvcServiceTypeT', '')])),
                                                                            ])
                                                                            self.sn_type = None
                                                                            self.sn_index = None
                                                                            self.sn_name = None
                                                                            self.app_id = None
                                                                            self.local_id = None
                                                                            self.vsnode_type = None
                                                                            self._segment_path = lambda: "punt"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt, ['sn_type', 'sn_index', 'sn_name', 'app_id', 'local_id', 'vsnode_type'], name, value)


                                                                    class Copy(Entity):
                                                                        """
                                                                        copy
                                                                        
                                                                        .. attribute:: num_byte
                                                                        
                                                                        	number of bytes
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: sn_type
                                                                        
                                                                        	service node ID type
                                                                        	**type**\:  :py:class:`DpssSnidTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.DpssSnidTypeEn>`
                                                                        
                                                                        .. attribute:: sn_index
                                                                        
                                                                        	service node index
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: sn_name
                                                                        
                                                                        	service node url
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: app_id
                                                                        
                                                                        	application ID
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: local_id
                                                                        
                                                                        	local ID
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: vsnode_type
                                                                        
                                                                        	vservice node type
                                                                        	**type**\:  :py:class:`VsvcServiceTypeT <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.VsvcServiceTypeT>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy, self).__init__()

                                                                            self.yang_name = "copy"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('num_byte', (YLeaf(YType.uint32, 'num-byte'), ['int'])),
                                                                                ('sn_type', (YLeaf(YType.enumeration, 'sn-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'DpssSnidTypeEn', '')])),
                                                                                ('sn_index', (YLeaf(YType.uint32, 'sn-index'), ['int'])),
                                                                                ('sn_name', (YLeaf(YType.str, 'sn-name'), ['str'])),
                                                                                ('app_id', (YLeaf(YType.uint32, 'app-id'), ['int'])),
                                                                                ('local_id', (YLeaf(YType.uint32, 'local-id'), ['int'])),
                                                                                ('vsnode_type', (YLeaf(YType.enumeration, 'vsnode-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'VsvcServiceTypeT', '')])),
                                                                            ])
                                                                            self.num_byte = None
                                                                            self.sn_type = None
                                                                            self.sn_index = None
                                                                            self.sn_name = None
                                                                            self.app_id = None
                                                                            self.local_id = None
                                                                            self.vsnode_type = None
                                                                            self._segment_path = lambda: "copy"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy, ['num_byte', 'sn_type', 'sn_index', 'sn_name', 'app_id', 'local_id', 'vsnode_type'], name, value)


                                                                    class Sfrag(Entity):
                                                                        """
                                                                        sfrag
                                                                        
                                                                        .. attribute:: name
                                                                        
                                                                        	Service Fragment Name
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag, self).__init__()

                                                                            self.yang_name = "sfrag"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                            ])
                                                                            self.name = None
                                                                            self._segment_path = lambda: "sfrag"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag, ['name'], name, value)


                                                                    class Redirect(Entity):
                                                                        """
                                                                        redirect
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: type
                                                                        
                                                                        	type
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect, self).__init__()

                                                                            self.yang_name = "redirect"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                            ])
                                                                            self.value = None
                                                                            self.type = None
                                                                            self._segment_path = lambda: "redirect"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect, ['value', 'type'], name, value)


                                                                    class OutIntf(Entity):
                                                                        """
                                                                        out intf
                                                                        
                                                                        .. attribute:: out_ifname
                                                                        
                                                                        	output interface name
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf, self).__init__()

                                                                            self.yang_name = "out-intf"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('out_ifname', (YLeaf(YType.str, 'out-ifname'), ['str'])),
                                                                            ])
                                                                            self.out_ifname = None
                                                                            self._segment_path = lambda: "out-intf"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf, ['out_ifname'], name, value)


                                                                    class ServFunc(Entity):
                                                                        """
                                                                        serv func
                                                                        
                                                                        .. attribute:: path_id
                                                                        
                                                                        	service path id
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: service_index
                                                                        
                                                                        	service path index
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: meta_name
                                                                        
                                                                        	metadata name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: vs_index
                                                                        
                                                                        	vservice index
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc, self).__init__()

                                                                            self.yang_name = "serv-func"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('path_id', (YLeaf(YType.uint32, 'path-id'), ['int'])),
                                                                                ('service_index', (YLeaf(YType.uint8, 'service-index'), ['int'])),
                                                                                ('meta_name', (YLeaf(YType.str, 'meta-name'), ['str'])),
                                                                                ('vs_index', (YLeaf(YType.uint32, 'vs-index'), ['int'])),
                                                                            ])
                                                                            self.path_id = None
                                                                            self.service_index = None
                                                                            self.meta_name = None
                                                                            self.vs_index = None
                                                                            self._segment_path = lambda: "serv-func"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc, ['path_id', 'service_index', 'meta_name', 'vs_index'], name, value)


                                                                    class Police(Entity):
                                                                        """
                                                                        police
                                                                        
                                                                        .. attribute:: rate
                                                                        
                                                                        	rate
                                                                        	**type**\:  :py:class:`Rate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate>`
                                                                        
                                                                        .. attribute:: burst
                                                                        
                                                                        	burst
                                                                        	**type**\:  :py:class:`Burst <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst>`
                                                                        
                                                                        .. attribute:: peak_rate
                                                                        
                                                                        	peak rate
                                                                        	**type**\:  :py:class:`PeakRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate>`
                                                                        
                                                                        .. attribute:: peak_burst
                                                                        
                                                                        	peak burst
                                                                        	**type**\:  :py:class:`PeakBurst <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst>`
                                                                        
                                                                        .. attribute:: cdvt
                                                                        
                                                                        	cdvt
                                                                        	**type**\:  :py:class:`Cdvt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt>`
                                                                        
                                                                        .. attribute:: conform_actns
                                                                        
                                                                        	conform actns
                                                                        	**type**\:  :py:class:`ConformActns <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns>`
                                                                        
                                                                        .. attribute:: exceed_actns
                                                                        
                                                                        	exceed actns
                                                                        	**type**\:  :py:class:`ExceedActns <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns>`
                                                                        
                                                                        .. attribute:: violate_actns
                                                                        
                                                                        	violate actns
                                                                        	**type**\:  :py:class:`ViolateActns <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns>`
                                                                        
                                                                        .. attribute:: confclass_encode
                                                                        
                                                                        	confclass encode
                                                                        	**type**\:  :py:class:`ConfclassEncode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode>`
                                                                        
                                                                        .. attribute:: confclass_p
                                                                        
                                                                        	confclass p
                                                                        	**type**\:  :py:class:`ConfclassP <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP>`
                                                                        
                                                                        .. attribute:: excdclass_encode
                                                                        
                                                                        	excdclass encode
                                                                        	**type**\:  :py:class:`ExcdclassEncode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode>`
                                                                        
                                                                        .. attribute:: excdclass_p
                                                                        
                                                                        	excdclass p
                                                                        	**type**\:  :py:class:`ExcdclassP <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP>`
                                                                        
                                                                        .. attribute:: flags
                                                                        
                                                                        	flags
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: police_flags
                                                                        
                                                                        	police flags
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: sbuck_name
                                                                        
                                                                        	sbuck name
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..65
                                                                        
                                                                        .. attribute:: sbuck_type
                                                                        
                                                                        	sbuck type
                                                                        	**type**\:  :py:class:`SharedBucketType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.SharedBucketType>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police, self).__init__()

                                                                            self.yang_name = "police"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("rate", ("rate", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate)), ("burst", ("burst", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst)), ("peak-rate", ("peak_rate", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate)), ("peak-burst", ("peak_burst", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst)), ("cdvt", ("cdvt", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt)), ("conform-actns", ("conform_actns", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns)), ("exceed-actns", ("exceed_actns", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns)), ("violate-actns", ("violate_actns", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns)), ("confclass-encode", ("confclass_encode", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode)), ("confclass-p", ("confclass_p", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP)), ("excdclass-encode", ("excdclass_encode", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode)), ("excdclass-p", ("excdclass_p", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP))])
                                                                            self._leafs = OrderedDict([
                                                                                ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                ('police_flags', (YLeaf(YType.uint32, 'police-flags'), ['int'])),
                                                                                ('sbuck_name', (YLeaf(YType.str, 'sbuck-name'), ['str'])),
                                                                                ('sbuck_type', (YLeaf(YType.enumeration, 'sbuck-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'SharedBucketType', '')])),
                                                                            ])
                                                                            self.flags = None
                                                                            self.police_flags = None
                                                                            self.sbuck_name = None
                                                                            self.sbuck_type = None

                                                                            self.rate = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate()
                                                                            self.rate.parent = self
                                                                            self._children_name_map["rate"] = "rate"

                                                                            self.burst = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst()
                                                                            self.burst.parent = self
                                                                            self._children_name_map["burst"] = "burst"

                                                                            self.peak_rate = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate()
                                                                            self.peak_rate.parent = self
                                                                            self._children_name_map["peak_rate"] = "peak-rate"

                                                                            self.peak_burst = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst()
                                                                            self.peak_burst.parent = self
                                                                            self._children_name_map["peak_burst"] = "peak-burst"

                                                                            self.cdvt = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt()
                                                                            self.cdvt.parent = self
                                                                            self._children_name_map["cdvt"] = "cdvt"

                                                                            self.conform_actns = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns()
                                                                            self.conform_actns.parent = self
                                                                            self._children_name_map["conform_actns"] = "conform-actns"

                                                                            self.exceed_actns = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns()
                                                                            self.exceed_actns.parent = self
                                                                            self._children_name_map["exceed_actns"] = "exceed-actns"

                                                                            self.violate_actns = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns()
                                                                            self.violate_actns.parent = self
                                                                            self._children_name_map["violate_actns"] = "violate-actns"

                                                                            self.confclass_encode = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode()
                                                                            self.confclass_encode.parent = self
                                                                            self._children_name_map["confclass_encode"] = "confclass-encode"

                                                                            self.confclass_p = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP()
                                                                            self.confclass_p.parent = self
                                                                            self._children_name_map["confclass_p"] = "confclass-p"

                                                                            self.excdclass_encode = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode()
                                                                            self.excdclass_encode.parent = self
                                                                            self._children_name_map["excdclass_encode"] = "excdclass-encode"

                                                                            self.excdclass_p = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP()
                                                                            self.excdclass_p.parent = self
                                                                            self._children_name_map["excdclass_p"] = "excdclass-p"
                                                                            self._segment_path = lambda: "police"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police, ['flags', 'police_flags', 'sbuck_name', 'sbuck_type'], name, value)


                                                                        class Rate(Entity):
                                                                            """
                                                                            rate
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate, self).__init__()

                                                                                self.yang_name = "rate"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate, ['value', 'unit'], name, value)


                                                                        class Burst(Entity):
                                                                            """
                                                                            burst
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst, self).__init__()

                                                                                self.yang_name = "burst"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "burst"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst, ['value', 'unit'], name, value)


                                                                        class PeakRate(Entity):
                                                                            """
                                                                            peak rate
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate, self).__init__()

                                                                                self.yang_name = "peak-rate"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "peak-rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate, ['value', 'unit'], name, value)


                                                                        class PeakBurst(Entity):
                                                                            """
                                                                            peak burst
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst, self).__init__()

                                                                                self.yang_name = "peak-burst"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "peak-burst"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst, ['value', 'unit'], name, value)


                                                                        class Cdvt(Entity):
                                                                            """
                                                                            cdvt
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt, self).__init__()

                                                                                self.yang_name = "cdvt"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "cdvt"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt, ['value', 'unit'], name, value)


                                                                        class ConformActns(Entity):
                                                                            """
                                                                            conform actns
                                                                            
                                                                            .. attribute:: police_action_array
                                                                            
                                                                            	police action array
                                                                            	**type**\: list of  		 :py:class:`PoliceActionArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns, self).__init__()

                                                                                self.yang_name = "conform-actns"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("police-action-array", ("police_action_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.police_action_array = YList(self)
                                                                                self._segment_path = lambda: "conform-actns"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns, [], name, value)


                                                                            class PoliceActionArray(Entity):
                                                                                """
                                                                                police action array
                                                                                
                                                                                .. attribute:: mark
                                                                                
                                                                                	mark
                                                                                	**type**\:  :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark>`
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:  :py:class:`PoliceActionTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PoliceActionTypeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray, self).__init__()

                                                                                    self.yang_name = "police-action-array"
                                                                                    self.yang_parent_name = "conform-actns"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("mark", ("mark", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PoliceActionTypeEn', '')])),
                                                                                    ])
                                                                                    self.type = None

                                                                                    self.mark = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark()
                                                                                    self.mark.parent = self
                                                                                    self._children_name_map["mark"] = "mark"
                                                                                    self._segment_path = lambda: "police-action-array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray, ['type'], name, value)


                                                                                class Mark(Entity):
                                                                                    """
                                                                                    mark
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	type
                                                                                    	**type**\:  :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                                    
                                                                                    .. attribute:: mark_flags
                                                                                    
                                                                                    	mark flags
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark, self).__init__()

                                                                                        self.yang_name = "mark"
                                                                                        self.yang_parent_name = "police-action-array"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MarkTypeEn', '')])),
                                                                                            ('mark_flags', (YLeaf(YType.uint32, 'mark-flags'), ['int'])),
                                                                                            ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                        ])
                                                                                        self.type = None
                                                                                        self.mark_flags = None
                                                                                        self.value = None
                                                                                        self._segment_path = lambda: "mark"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark, ['type', 'mark_flags', 'value'], name, value)


                                                                        class ExceedActns(Entity):
                                                                            """
                                                                            exceed actns
                                                                            
                                                                            .. attribute:: police_action_array
                                                                            
                                                                            	police action array
                                                                            	**type**\: list of  		 :py:class:`PoliceActionArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns, self).__init__()

                                                                                self.yang_name = "exceed-actns"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("police-action-array", ("police_action_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.police_action_array = YList(self)
                                                                                self._segment_path = lambda: "exceed-actns"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns, [], name, value)


                                                                            class PoliceActionArray(Entity):
                                                                                """
                                                                                police action array
                                                                                
                                                                                .. attribute:: mark
                                                                                
                                                                                	mark
                                                                                	**type**\:  :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark>`
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:  :py:class:`PoliceActionTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PoliceActionTypeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray, self).__init__()

                                                                                    self.yang_name = "police-action-array"
                                                                                    self.yang_parent_name = "exceed-actns"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("mark", ("mark", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PoliceActionTypeEn', '')])),
                                                                                    ])
                                                                                    self.type = None

                                                                                    self.mark = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark()
                                                                                    self.mark.parent = self
                                                                                    self._children_name_map["mark"] = "mark"
                                                                                    self._segment_path = lambda: "police-action-array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray, ['type'], name, value)


                                                                                class Mark(Entity):
                                                                                    """
                                                                                    mark
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	type
                                                                                    	**type**\:  :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                                    
                                                                                    .. attribute:: mark_flags
                                                                                    
                                                                                    	mark flags
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark, self).__init__()

                                                                                        self.yang_name = "mark"
                                                                                        self.yang_parent_name = "police-action-array"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MarkTypeEn', '')])),
                                                                                            ('mark_flags', (YLeaf(YType.uint32, 'mark-flags'), ['int'])),
                                                                                            ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                        ])
                                                                                        self.type = None
                                                                                        self.mark_flags = None
                                                                                        self.value = None
                                                                                        self._segment_path = lambda: "mark"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark, ['type', 'mark_flags', 'value'], name, value)


                                                                        class ViolateActns(Entity):
                                                                            """
                                                                            violate actns
                                                                            
                                                                            .. attribute:: police_action_array
                                                                            
                                                                            	police action array
                                                                            	**type**\: list of  		 :py:class:`PoliceActionArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns, self).__init__()

                                                                                self.yang_name = "violate-actns"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("police-action-array", ("police_action_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.police_action_array = YList(self)
                                                                                self._segment_path = lambda: "violate-actns"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns, [], name, value)


                                                                            class PoliceActionArray(Entity):
                                                                                """
                                                                                police action array
                                                                                
                                                                                .. attribute:: mark
                                                                                
                                                                                	mark
                                                                                	**type**\:  :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark>`
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:  :py:class:`PoliceActionTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PoliceActionTypeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray, self).__init__()

                                                                                    self.yang_name = "police-action-array"
                                                                                    self.yang_parent_name = "violate-actns"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("mark", ("mark", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PoliceActionTypeEn', '')])),
                                                                                    ])
                                                                                    self.type = None

                                                                                    self.mark = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark()
                                                                                    self.mark.parent = self
                                                                                    self._children_name_map["mark"] = "mark"
                                                                                    self._segment_path = lambda: "police-action-array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray, ['type'], name, value)


                                                                                class Mark(Entity):
                                                                                    """
                                                                                    mark
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	type
                                                                                    	**type**\:  :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                                    
                                                                                    .. attribute:: mark_flags
                                                                                    
                                                                                    	mark flags
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark, self).__init__()

                                                                                        self.yang_name = "mark"
                                                                                        self.yang_parent_name = "police-action-array"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MarkTypeEn', '')])),
                                                                                            ('mark_flags', (YLeaf(YType.uint32, 'mark-flags'), ['int'])),
                                                                                            ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                        ])
                                                                                        self.type = None
                                                                                        self.mark_flags = None
                                                                                        self.value = None
                                                                                        self._segment_path = lambda: "mark"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark, ['type', 'mark_flags', 'value'], name, value)


                                                                        class ConfclassEncode(Entity):
                                                                            """
                                                                            confclass encode
                                                                            
                                                                            .. attribute:: inline_cmap
                                                                            
                                                                            	inline cmap
                                                                            	**type**\:  :py:class:`InlineCmap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap>`
                                                                            
                                                                            .. attribute:: enc
                                                                            
                                                                            	enc
                                                                            	**type**\:  :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                            
                                                                            .. attribute:: class_name
                                                                            
                                                                            	class name
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..65
                                                                            
                                                                            .. attribute:: hd
                                                                            
                                                                            	hd
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: idx
                                                                            
                                                                            	idx
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode, self).__init__()

                                                                                self.yang_name = "confclass-encode"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("inline-cmap", ("inline_cmap", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('enc', (YLeaf(YType.enumeration, 'enc'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyObjEncEn', '')])),
                                                                                    ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                                                    ('hd', (YLeaf(YType.uint64, 'hd'), ['int'])),
                                                                                    ('idx', (YLeaf(YType.uint8, 'idx'), ['int'])),
                                                                                ])
                                                                                self.enc = None
                                                                                self.class_name = None
                                                                                self.hd = None
                                                                                self.idx = None

                                                                                self.inline_cmap = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap()
                                                                                self.inline_cmap.parent = self
                                                                                self._children_name_map["inline_cmap"] = "inline-cmap"
                                                                                self._segment_path = lambda: "confclass-encode"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode, ['enc', 'class_name', 'hd', 'idx'], name, value)


                                                                            class InlineCmap(Entity):
                                                                                """
                                                                                inline cmap
                                                                                
                                                                                .. attribute:: match_infop
                                                                                
                                                                                	Pointer to the first Match info
                                                                                	**type**\:  :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop>`
                                                                                
                                                                                .. attribute:: mode
                                                                                
                                                                                	Inline Class\-Map Mode Match any/all
                                                                                	**type**\:  :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                                
                                                                                .. attribute:: flags
                                                                                
                                                                                	Inline Class\-Map flags
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: match_count
                                                                                
                                                                                	Number of Match infos
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap, self).__init__()

                                                                                    self.yang_name = "inline-cmap"
                                                                                    self.yang_parent_name = "confclass-encode"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("match-infop", ("match_infop", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapModeEn', '')])),
                                                                                        ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                        ('match_count', (YLeaf(YType.uint32, 'match-count'), ['int'])),
                                                                                    ])
                                                                                    self.mode = None
                                                                                    self.flags = None
                                                                                    self.match_count = None

                                                                                    self.match_infop = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop()
                                                                                    self.match_infop.parent = self
                                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                                    self._segment_path = lambda: "inline-cmap"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap, ['mode', 'flags', 'match_count'], name, value)


                                                                                class MatchInfop(Entity):
                                                                                    """
                                                                                    Pointer to the first Match info
                                                                                    
                                                                                    .. attribute:: class_match_info_st
                                                                                    
                                                                                    	class match info st
                                                                                    	**type**\: list of  		 :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop, self).__init__()

                                                                                        self.yang_name = "match-infop"
                                                                                        self.yang_parent_name = "inline-cmap"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("class-match-info-st", ("class_match_info_st", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.class_match_info_st = YList(self)
                                                                                        self._segment_path = lambda: "match-infop"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop, [], name, value)


                                                                                    class ClassMatchInfoSt(Entity):
                                                                                        """
                                                                                        class match info st
                                                                                        
                                                                                        .. attribute:: match_data
                                                                                        
                                                                                        	Match criteria
                                                                                        	**type**\:  :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                        
                                                                                        .. attribute:: flags
                                                                                        
                                                                                        	Flags
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                            self.yang_name = "class-match-info-st"
                                                                                            self.yang_parent_name = "match-infop"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("match-data", ("match_data", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData))])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                            ])
                                                                                            self.flags = None

                                                                                            self.match_data = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                            self.match_data.parent = self
                                                                                            self._children_name_map["match_data"] = "match-data"
                                                                                            self._segment_path = lambda: "class-match-info-st"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                        class MatchData(Entity):
                                                                                            """
                                                                                            Match criteria
                                                                                            
                                                                                            .. attribute:: ipv4_dscp
                                                                                            
                                                                                            	IPv4 DSCP
                                                                                            	**type**\:  :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv6_dscp
                                                                                            
                                                                                            	IPv6 DSCP
                                                                                            	**type**\:  :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                            
                                                                                            .. attribute:: dscp
                                                                                            
                                                                                            	Match DSCP range array
                                                                                            	**type**\:  :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv4_prec
                                                                                            
                                                                                            	IPv4 Precedence
                                                                                            	**type**\:  :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                            
                                                                                            .. attribute:: ipv6_prec
                                                                                            
                                                                                            	IPv6 Precedence
                                                                                            	**type**\:  :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                            
                                                                                            .. attribute:: prec
                                                                                            
                                                                                            	Match Precedence array
                                                                                            	**type**\:  :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                            
                                                                                            .. attribute:: discard_class
                                                                                            
                                                                                            	Match Discard Class array
                                                                                            	**type**\:  :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                            
                                                                                            .. attribute:: qos_group
                                                                                            
                                                                                            	Match QoS group array
                                                                                            	**type**\:  :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                            
                                                                                            .. attribute:: traffic_class
                                                                                            
                                                                                            	Match Traffic class array
                                                                                            	**type**\:  :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                            
                                                                                            .. attribute:: proto
                                                                                            
                                                                                            	Match Protocol array
                                                                                            	**type**\:  :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                            
                                                                                            .. attribute:: icmp_v4
                                                                                            
                                                                                            	Match ICMPV4 Protocol
                                                                                            	**type**\:  :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                            
                                                                                            .. attribute:: icmp_v6
                                                                                            
                                                                                            	Match ICMPV6 Protocol array
                                                                                            	**type**\:  :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                            
                                                                                            .. attribute:: ipv4_packet_len
                                                                                            
                                                                                            	IPv4 packet length array
                                                                                            	**type**\:  :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv6_packet_len
                                                                                            
                                                                                            	IPv6 packet length array
                                                                                            	**type**\:  :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                            
                                                                                            .. attribute:: packet_len
                                                                                            
                                                                                            	Match packet length array
                                                                                            	**type**\:  :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                            
                                                                                            .. attribute:: flow_tag
                                                                                            
                                                                                            	Match flow\-tag array
                                                                                            	**type**\:  :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                            
                                                                                            .. attribute:: tcp_flag
                                                                                            
                                                                                            	Match tcp flag value
                                                                                            	**type**\:  :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                            
                                                                                            .. attribute:: icmpv4_type
                                                                                            
                                                                                            	Match ipv4 icmp type
                                                                                            	**type**\:  :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                            
                                                                                            .. attribute:: icmpv4_code
                                                                                            
                                                                                            	Match ipv4 icmp code
                                                                                            	**type**\:  :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                            
                                                                                            .. attribute:: icmpv6_type
                                                                                            
                                                                                            	Match ipv6 icmp type
                                                                                            	**type**\:  :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                            
                                                                                            .. attribute:: icmpv6_code
                                                                                            
                                                                                            	Match ipv6 icmp code
                                                                                            	**type**\:  :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                            
                                                                                            .. attribute:: mpls_exp
                                                                                            
                                                                                            	Match MPLS experimental topmost array
                                                                                            	**type**\:  :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                            
                                                                                            .. attribute:: mpls_exp_imp
                                                                                            
                                                                                            	Match MPLS experimental imposition array
                                                                                            	**type**\:  :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                                            
                                                                                            	MPLS Disposition IPv4 Access\-list
                                                                                            	**type**\:  :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                                            
                                                                                            	MPLS Disposition IPv6 Access\-list
                                                                                            	**type**\:  :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_top_label
                                                                                            
                                                                                            	MPLS Topmost LABEL
                                                                                            	**type**\:  :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                            
                                                                                            .. attribute:: cos
                                                                                            
                                                                                            	Match CoS array
                                                                                            	**type**\:  :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                            
                                                                                            .. attribute:: cos_inr
                                                                                            
                                                                                            	Match inner header CoS
                                                                                            	**type**\:  :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                            
                                                                                            .. attribute:: dei
                                                                                            
                                                                                            	Match DEI Bit
                                                                                            	**type**\:  :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                            
                                                                                            .. attribute:: dei_inr
                                                                                            
                                                                                            	Match inner DEI Bit
                                                                                            	**type**\:  :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                            
                                                                                            .. attribute:: vlan
                                                                                            
                                                                                            	Match VLAN array
                                                                                            	**type**\:  :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                            
                                                                                            .. attribute:: vlan_inr
                                                                                            
                                                                                            	Match inner header VLAN range array
                                                                                            	**type**\:  :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                            
                                                                                            .. attribute:: fr_dlci
                                                                                            
                                                                                            	Match FR DLCI range array
                                                                                            	**type**\:  :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                            
                                                                                            .. attribute:: src_mac
                                                                                            
                                                                                            	Match Source MAC address
                                                                                            	**type**\:  :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                            
                                                                                            .. attribute:: dst_mac
                                                                                            
                                                                                            	Match Destination MAC address
                                                                                            	**type**\:  :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                            
                                                                                            .. attribute:: atm_clp
                                                                                            
                                                                                            	Match ATM CLP level
                                                                                            	**type**\:  :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                            
                                                                                            .. attribute:: fr_de
                                                                                            
                                                                                            	Match FR DE value
                                                                                            	**type**\:  :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                            
                                                                                            .. attribute:: ipv4_acl
                                                                                            
                                                                                            	IPv4 Access\-list
                                                                                            	**type**\:  :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                            
                                                                                            .. attribute:: ipv6_acl
                                                                                            
                                                                                            	IPv6 Access\-list
                                                                                            	**type**\:  :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                            
                                                                                            .. attribute:: ether_service_acl
                                                                                            
                                                                                            	Ethernet\-Services Access\-list
                                                                                            	**type**\:  :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                            
                                                                                            .. attribute:: avail_id
                                                                                            
                                                                                            	Available Identifiers
                                                                                            	**type**\:  :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                            
                                                                                            .. attribute:: media_type
                                                                                            
                                                                                            	Media Type
                                                                                            	**type**\:  :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                            
                                                                                            .. attribute:: subs_protocol
                                                                                            
                                                                                            	Protocol
                                                                                            	**type**\:  :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                            
                                                                                            .. attribute:: dnis
                                                                                            
                                                                                            	DNIS
                                                                                            	**type**\:  :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                            
                                                                                            .. attribute:: dnis_regex
                                                                                            
                                                                                            	DNIS Regular Expression
                                                                                            	**type**\:  :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                            
                                                                                            .. attribute:: domain
                                                                                            
                                                                                            	Domain Name
                                                                                            	**type**\:  :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                            
                                                                                            .. attribute:: domain_regex
                                                                                            
                                                                                            	Domain Regular Expression
                                                                                            	**type**\:  :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                            
                                                                                            .. attribute:: nas_port
                                                                                            
                                                                                            	NAS Port
                                                                                            	**type**\:  :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                            
                                                                                            .. attribute:: service_name
                                                                                            
                                                                                            	Service Name
                                                                                            	**type**\:  :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                            
                                                                                            .. attribute:: service_name_regex
                                                                                            
                                                                                            	Service Name Regular Exp
                                                                                            	**type**\:  :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv4
                                                                                            
                                                                                            	Source Address IPV4
                                                                                            	**type**\:  :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv4
                                                                                            
                                                                                            	Destination Address IPV4
                                                                                            	**type**\:  :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv6
                                                                                            
                                                                                            	Source Address IPV6
                                                                                            	**type**\:  :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv6
                                                                                            
                                                                                            	Destination Address IPV6
                                                                                            	**type**\:  :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: src_addr_mac
                                                                                            
                                                                                            	Source Address MAC
                                                                                            	**type**\:  :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                            
                                                                                            .. attribute:: timer
                                                                                            
                                                                                            	Timer
                                                                                            	**type**\:  :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                            
                                                                                            .. attribute:: timer_regexp
                                                                                            
                                                                                            	Timer Regular Expression
                                                                                            	**type**\:  :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                            
                                                                                            .. attribute:: tunnel_name
                                                                                            
                                                                                            	Tunnel Name
                                                                                            	**type**\:  :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                            
                                                                                            .. attribute:: tunnel_name_regex
                                                                                            
                                                                                            	Tunnel Name Regular Expression
                                                                                            	**type**\:  :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                            
                                                                                            .. attribute:: user_name
                                                                                            
                                                                                            	User Name
                                                                                            	**type**\:  :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                            
                                                                                            .. attribute:: user_name_regex
                                                                                            
                                                                                            	User Name Regular Expression
                                                                                            	**type**\:  :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                            
                                                                                            .. attribute:: auth_username
                                                                                            
                                                                                            	Authenticated User Name
                                                                                            	**type**\:  :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                            
                                                                                            .. attribute:: auth_username_regex
                                                                                            
                                                                                            	Authenticated User Name RegEx
                                                                                            	**type**\:  :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_username
                                                                                            
                                                                                            	Unauthenticated User Name
                                                                                            	**type**\:  :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                            
                                                                                            .. attribute:: unauth_username_regex
                                                                                            
                                                                                            	Unauthenticated User Name RegEx
                                                                                            	**type**\:  :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: auth_domain
                                                                                            
                                                                                            	Authenticated domain name
                                                                                            	**type**\:  :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                            
                                                                                            .. attribute:: auth_domain_regex
                                                                                            
                                                                                            	Authenticated Domain Name RegEx
                                                                                            	**type**\:  :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_domain
                                                                                            
                                                                                            	Unauthenticated Domain Name
                                                                                            	**type**\:  :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                            
                                                                                            .. attribute:: unauth_domain_regex
                                                                                            
                                                                                            	Unauthenticated Domain Name RegEx
                                                                                            	**type**\:  :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: vendor_id
                                                                                            
                                                                                            	Vendor ID
                                                                                            	**type**\:  :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                            
                                                                                            .. attribute:: vendor_id_regex
                                                                                            
                                                                                            	Vendor ID RegEx
                                                                                            	**type**\:  :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                            
                                                                                            .. attribute:: access_interface
                                                                                            
                                                                                            	Access interface
                                                                                            	**type**\:  :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                            
                                                                                            .. attribute:: input_interface
                                                                                            
                                                                                            	Input interface
                                                                                            	**type**\:  :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                            
                                                                                            .. attribute:: input_intfhdl
                                                                                            
                                                                                            	Input interface handle
                                                                                            	**type**\:  :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                            
                                                                                            .. attribute:: ethertype
                                                                                            
                                                                                            	Ethernet type
                                                                                            	**type**\:  :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                            
                                                                                            .. attribute:: flow_key_data
                                                                                            
                                                                                            	Flow key structure
                                                                                            	**type**\:  :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id
                                                                                            
                                                                                            	Dhcp Client ID
                                                                                            	**type**\:  :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id_regex
                                                                                            
                                                                                            	Dhcp Client ID RegEx
                                                                                            	**type**\:  :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                            
                                                                                            .. attribute:: circuit_id
                                                                                            
                                                                                            	Circuit ID
                                                                                            	**type**\:  :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                            
                                                                                            .. attribute:: circuit_id_regex
                                                                                            
                                                                                            	Circuit ID RegEx
                                                                                            	**type**\:  :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                            
                                                                                            .. attribute:: remote_id
                                                                                            
                                                                                            	Remote ID
                                                                                            	**type**\:  :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                            
                                                                                            .. attribute:: remote_id_regex
                                                                                            
                                                                                            	Remote ID RegEx
                                                                                            	**type**\:  :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                            
                                                                                            .. attribute:: src_port
                                                                                            
                                                                                            	Source port
                                                                                            	**type**\:  :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                            
                                                                                            .. attribute:: dst_port
                                                                                            
                                                                                            	Destination port
                                                                                            	**type**\:  :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	type
                                                                                            	**type**\:  :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                            
                                                                                            .. attribute:: mpls_top_eos
                                                                                            
                                                                                            	MPLS Topmost EOS
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: fragment_type
                                                                                            
                                                                                            	Fragment type
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: authen_status
                                                                                            
                                                                                            	Authentication Status
                                                                                            	**type**\:  :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                            
                                                                                            .. attribute:: mlp_negotiated
                                                                                            
                                                                                            	MLP Negotiated
                                                                                            	**type**\:  :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                                self.yang_name = "match-data"
                                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("ipv4-dscp", ("ipv4_dscp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp)), ("ipv6-dscp", ("ipv6_dscp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp)), ("dscp", ("dscp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp)), ("ipv4-prec", ("ipv4_prec", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec)), ("ipv6-prec", ("ipv6_prec", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec)), ("prec", ("prec", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec)), ("discard-class", ("discard_class", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass)), ("qos-group", ("qos_group", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup)), ("traffic-class", ("traffic_class", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass)), ("proto", ("proto", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto)), ("icmp-v4", ("icmp_v4", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4)), ("icmp-v6", ("icmp_v6", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6)), ("ipv4-packet-len", ("ipv4_packet_len", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen)), ("ipv6-packet-len", ("ipv6_packet_len", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen)), ("packet-len", ("packet_len", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen)), ("flow-tag", ("flow_tag", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag)), ("tcp-flag", ("tcp_flag", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag)), ("icmpv4-type", ("icmpv4_type", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type)), ("icmpv4-code", ("icmpv4_code", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code)), ("icmpv6-type", ("icmpv6_type", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type)), ("icmpv6-code", ("icmpv6_code", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code)), ("mpls-exp", ("mpls_exp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp)), ("mpls-exp-imp", ("mpls_exp_imp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp)), ("mpls-disp-ipv4-acl", ("mpls_disp_ipv4_acl", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl)), ("mpls-disp-ipv6-acl", ("mpls_disp_ipv6_acl", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl)), ("mpls-top-label", ("mpls_top_label", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel)), ("cos", ("cos", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos)), ("cos-inr", ("cos_inr", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr)), ("dei", ("dei", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei)), ("dei-inr", ("dei_inr", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr)), ("vlan", ("vlan", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan)), ("vlan-inr", ("vlan_inr", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)), ("fr-dlci", ("fr_dlci", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci)), ("src-mac", ("src_mac", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac)), ("dst-mac", ("dst_mac", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac)), ("atm-clp", ("atm_clp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp)), ("fr-de", ("fr_de", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe)), ("ipv4-acl", ("ipv4_acl", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl)), ("ipv6-acl", ("ipv6_acl", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl)), ("ether-service-acl", ("ether_service_acl", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl)), ("avail-id", ("avail_id", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId)), ("media-type", ("media_type", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType)), ("subs-protocol", ("subs_protocol", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol)), ("dnis", ("dnis", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis)), ("dnis-regex", ("dnis_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex)), ("domain", ("domain", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain)), ("domain-regex", ("domain_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex)), ("nas-port", ("nas_port", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort)), ("service-name", ("service_name", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName)), ("service-name-regex", ("service_name_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex)), ("src-addr-ipv4", ("src_addr_ipv4", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4)), ("dst-addr-ipv4", ("dst_addr_ipv4", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4)), ("src-addr-ipv6", ("src_addr_ipv6", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6)), ("dst-addr-ipv6", ("dst_addr_ipv6", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6)), ("src-addr-mac", ("src_addr_mac", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac)), ("timer", ("timer", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer)), ("timer-regexp", ("timer_regexp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp)), ("tunnel-name", ("tunnel_name", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName)), ("tunnel-name-regex", ("tunnel_name_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex)), ("user-name", ("user_name", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName)), ("user-name-regex", ("user_name_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex)), ("auth-username", ("auth_username", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername)), ("auth-username-regex", ("auth_username_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex)), ("unauth-username", ("unauth_username", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername)), ("unauth-username-regex", ("unauth_username_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex)), ("auth-domain", ("auth_domain", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain)), ("auth-domain-regex", ("auth_domain_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex)), ("unauth-domain", ("unauth_domain", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain)), ("unauth-domain-regex", ("unauth_domain_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex)), ("vendor-id", ("vendor_id", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId)), ("vendor-id-regex", ("vendor_id_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex)), ("access-interface", ("access_interface", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface)), ("input-interface", ("input_interface", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface)), ("input-intfhdl", ("input_intfhdl", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl)), ("ethertype", ("ethertype", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype)), ("flow-key-data", ("flow_key_data", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData)), ("dhcp-client-id", ("dhcp_client_id", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId)), ("dhcp-client-id-regex", ("dhcp_client_id_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex)), ("circuit-id", ("circuit_id", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId)), ("circuit-id-regex", ("circuit_id_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex)), ("remote-id", ("remote_id", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId)), ("remote-id-regex", ("remote_id_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex)), ("src-port", ("src_port", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort)), ("dst-port", ("dst_port", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort))])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchTypeEn', '')])),
                                                                                                    ('mpls_top_eos', (YLeaf(YType.uint8, 'mpls-top-eos'), ['int'])),
                                                                                                    ('fragment_type', (YLeaf(YType.uint8, 'fragment-type'), ['int'])),
                                                                                                    ('authen_status', (YLeaf(YType.enumeration, 'authen-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchAuthenStatusEn', '')])),
                                                                                                    ('mlp_negotiated', (YLeaf(YType.enumeration, 'mlp-negotiated'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchMlpNegotiatedEn', '')])),
                                                                                                ])
                                                                                                self.type = None
                                                                                                self.mpls_top_eos = None
                                                                                                self.fragment_type = None
                                                                                                self.authen_status = None
                                                                                                self.mlp_negotiated = None

                                                                                                self.ipv4_dscp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                                self.ipv4_dscp.parent = self
                                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"

                                                                                                self.ipv6_dscp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                                self.ipv6_dscp.parent = self
                                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"

                                                                                                self.dscp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                                self.dscp.parent = self
                                                                                                self._children_name_map["dscp"] = "dscp"

                                                                                                self.ipv4_prec = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                                self.ipv4_prec.parent = self
                                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"

                                                                                                self.ipv6_prec = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                                self.ipv6_prec.parent = self
                                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"

                                                                                                self.prec = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                                self.prec.parent = self
                                                                                                self._children_name_map["prec"] = "prec"

                                                                                                self.discard_class = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                                self.discard_class.parent = self
                                                                                                self._children_name_map["discard_class"] = "discard-class"

                                                                                                self.qos_group = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                                self.qos_group.parent = self
                                                                                                self._children_name_map["qos_group"] = "qos-group"

                                                                                                self.traffic_class = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                                self.traffic_class.parent = self
                                                                                                self._children_name_map["traffic_class"] = "traffic-class"

                                                                                                self.proto = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                                self.proto.parent = self
                                                                                                self._children_name_map["proto"] = "proto"

                                                                                                self.icmp_v4 = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                                self.icmp_v4.parent = self
                                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"

                                                                                                self.icmp_v6 = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                                self.icmp_v6.parent = self
                                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"

                                                                                                self.ipv4_packet_len = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                                self.ipv4_packet_len.parent = self
                                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"

                                                                                                self.ipv6_packet_len = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                                self.ipv6_packet_len.parent = self
                                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"

                                                                                                self.packet_len = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                                self.packet_len.parent = self
                                                                                                self._children_name_map["packet_len"] = "packet-len"

                                                                                                self.flow_tag = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                                self.flow_tag.parent = self
                                                                                                self._children_name_map["flow_tag"] = "flow-tag"

                                                                                                self.tcp_flag = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                                self.tcp_flag.parent = self
                                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"

                                                                                                self.icmpv4_type = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                                self.icmpv4_type.parent = self
                                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"

                                                                                                self.icmpv4_code = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                                self.icmpv4_code.parent = self
                                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"

                                                                                                self.icmpv6_type = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                                self.icmpv6_type.parent = self
                                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"

                                                                                                self.icmpv6_code = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                                self.icmpv6_code.parent = self
                                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"

                                                                                                self.mpls_exp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                                self.mpls_exp.parent = self
                                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"

                                                                                                self.mpls_exp_imp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                                self.mpls_exp_imp.parent = self
                                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"

                                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"

                                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"

                                                                                                self.mpls_top_label = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                                self.mpls_top_label.parent = self
                                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"

                                                                                                self.cos = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                                self.cos.parent = self
                                                                                                self._children_name_map["cos"] = "cos"

                                                                                                self.cos_inr = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                                self.cos_inr.parent = self
                                                                                                self._children_name_map["cos_inr"] = "cos-inr"

                                                                                                self.dei = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                                self.dei.parent = self
                                                                                                self._children_name_map["dei"] = "dei"

                                                                                                self.dei_inr = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                                self.dei_inr.parent = self
                                                                                                self._children_name_map["dei_inr"] = "dei-inr"

                                                                                                self.vlan = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                                self.vlan.parent = self
                                                                                                self._children_name_map["vlan"] = "vlan"

                                                                                                self.vlan_inr = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                                self.vlan_inr.parent = self
                                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"

                                                                                                self.fr_dlci = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                                self.fr_dlci.parent = self
                                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"

                                                                                                self.src_mac = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                                self.src_mac.parent = self
                                                                                                self._children_name_map["src_mac"] = "src-mac"

                                                                                                self.dst_mac = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                                self.dst_mac.parent = self
                                                                                                self._children_name_map["dst_mac"] = "dst-mac"

                                                                                                self.atm_clp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                                self.atm_clp.parent = self
                                                                                                self._children_name_map["atm_clp"] = "atm-clp"

                                                                                                self.fr_de = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                                self.fr_de.parent = self
                                                                                                self._children_name_map["fr_de"] = "fr-de"

                                                                                                self.ipv4_acl = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                                self.ipv4_acl.parent = self
                                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"

                                                                                                self.ipv6_acl = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                                self.ipv6_acl.parent = self
                                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"

                                                                                                self.ether_service_acl = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                                self.ether_service_acl.parent = self
                                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"

                                                                                                self.avail_id = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                                self.avail_id.parent = self
                                                                                                self._children_name_map["avail_id"] = "avail-id"

                                                                                                self.media_type = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                                self.media_type.parent = self
                                                                                                self._children_name_map["media_type"] = "media-type"

                                                                                                self.subs_protocol = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                                self.subs_protocol.parent = self
                                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"

                                                                                                self.dnis = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                                self.dnis.parent = self
                                                                                                self._children_name_map["dnis"] = "dnis"

                                                                                                self.dnis_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                                self.dnis_regex.parent = self
                                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"

                                                                                                self.domain = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                                self.domain.parent = self
                                                                                                self._children_name_map["domain"] = "domain"

                                                                                                self.domain_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                                self.domain_regex.parent = self
                                                                                                self._children_name_map["domain_regex"] = "domain-regex"

                                                                                                self.nas_port = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                                self.nas_port.parent = self
                                                                                                self._children_name_map["nas_port"] = "nas-port"

                                                                                                self.service_name = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                                self.service_name.parent = self
                                                                                                self._children_name_map["service_name"] = "service-name"

                                                                                                self.service_name_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                                self.service_name_regex.parent = self
                                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"

                                                                                                self.src_addr_ipv4 = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                                self.src_addr_ipv4.parent = self
                                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"

                                                                                                self.dst_addr_ipv4 = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                                self.dst_addr_ipv4.parent = self
                                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"

                                                                                                self.src_addr_ipv6 = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                                self.src_addr_ipv6.parent = self
                                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"

                                                                                                self.dst_addr_ipv6 = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                                self.dst_addr_ipv6.parent = self
                                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"

                                                                                                self.src_addr_mac = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                                self.src_addr_mac.parent = self
                                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"

                                                                                                self.timer = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                                self.timer.parent = self
                                                                                                self._children_name_map["timer"] = "timer"

                                                                                                self.timer_regexp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                                self.timer_regexp.parent = self
                                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"

                                                                                                self.tunnel_name = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                                self.tunnel_name.parent = self
                                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"

                                                                                                self.tunnel_name_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                                self.tunnel_name_regex.parent = self
                                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"

                                                                                                self.user_name = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                                self.user_name.parent = self
                                                                                                self._children_name_map["user_name"] = "user-name"

                                                                                                self.user_name_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                                self.user_name_regex.parent = self
                                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"

                                                                                                self.auth_username = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                                self.auth_username.parent = self
                                                                                                self._children_name_map["auth_username"] = "auth-username"

                                                                                                self.auth_username_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                                self.auth_username_regex.parent = self
                                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"

                                                                                                self.unauth_username = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                                self.unauth_username.parent = self
                                                                                                self._children_name_map["unauth_username"] = "unauth-username"

                                                                                                self.unauth_username_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                                self.unauth_username_regex.parent = self
                                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"

                                                                                                self.auth_domain = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                                self.auth_domain.parent = self
                                                                                                self._children_name_map["auth_domain"] = "auth-domain"

                                                                                                self.auth_domain_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                                self.auth_domain_regex.parent = self
                                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"

                                                                                                self.unauth_domain = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                                self.unauth_domain.parent = self
                                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"

                                                                                                self.unauth_domain_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                                self.unauth_domain_regex.parent = self
                                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"

                                                                                                self.vendor_id = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                                self.vendor_id.parent = self
                                                                                                self._children_name_map["vendor_id"] = "vendor-id"

                                                                                                self.vendor_id_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                                self.vendor_id_regex.parent = self
                                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"

                                                                                                self.access_interface = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                                self.access_interface.parent = self
                                                                                                self._children_name_map["access_interface"] = "access-interface"

                                                                                                self.input_interface = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                                self.input_interface.parent = self
                                                                                                self._children_name_map["input_interface"] = "input-interface"

                                                                                                self.input_intfhdl = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                                self.input_intfhdl.parent = self
                                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"

                                                                                                self.ethertype = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                                self.ethertype.parent = self
                                                                                                self._children_name_map["ethertype"] = "ethertype"

                                                                                                self.flow_key_data = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                                self.flow_key_data.parent = self
                                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"

                                                                                                self.dhcp_client_id = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                                self.dhcp_client_id.parent = self
                                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"

                                                                                                self.dhcp_client_id_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                                self.dhcp_client_id_regex.parent = self
                                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"

                                                                                                self.circuit_id = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                                self.circuit_id.parent = self
                                                                                                self._children_name_map["circuit_id"] = "circuit-id"

                                                                                                self.circuit_id_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                                self.circuit_id_regex.parent = self
                                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"

                                                                                                self.remote_id = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                                self.remote_id.parent = self
                                                                                                self._children_name_map["remote_id"] = "remote-id"

                                                                                                self.remote_id_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                                self.remote_id_regex.parent = self
                                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"

                                                                                                self.src_port = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                                self.src_port.parent = self
                                                                                                self._children_name_map["src_port"] = "src-port"

                                                                                                self.dst_port = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                                self.dst_port.parent = self
                                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                                self._segment_path = lambda: "match-data"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, ['type', 'mpls_top_eos', 'fragment_type', 'authen_status', 'mlp_negotiated'], name, value)


                                                                                            class Ipv4Dscp(Entity):
                                                                                                """
                                                                                                IPv4 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv4-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv6Dscp(Entity):
                                                                                                """
                                                                                                IPv6 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv6-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Dscp(Entity):
                                                                                                """
                                                                                                Match DSCP range array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                    self.yang_name = "dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv4Prec(Entity):
                                                                                                """
                                                                                                IPv4 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                    self.yang_name = "ipv4-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "ipv4-prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                            class Ipv6Prec(Entity):
                                                                                                """
                                                                                                IPv6 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                    self.yang_name = "ipv6-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "ipv6-prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                            class Prec(Entity):
                                                                                                """
                                                                                                Match Precedence array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                    self.yang_name = "prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                            class DiscardClass(Entity):
                                                                                                """
                                                                                                Match Discard Class array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                    self.yang_name = "discard-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "discard-class"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                            class QosGroup(Entity):
                                                                                                """
                                                                                                Match QoS group array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                    self.yang_name = "qos-group"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "qos-group"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "qos-group"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class TrafficClass(Entity):
                                                                                                """
                                                                                                Match Traffic class array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                    self.yang_name = "traffic-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "traffic-class"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "traffic-class"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Proto(Entity):
                                                                                                """
                                                                                                Match Protocol array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                    self.yang_name = "proto"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "proto"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "proto"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class IcmpV4(Entity):
                                                                                                """
                                                                                                Match ICMPV4 Protocol
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                    self.yang_name = "icmp-v4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                    ])
                                                                                                    self.type = None
                                                                                                    self.code = None
                                                                                                    self._segment_path = lambda: "icmp-v4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['type', 'code'], name, value)


                                                                                            class IcmpV6(Entity):
                                                                                                """
                                                                                                Match ICMPV6 Protocol array
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                    self.yang_name = "icmp-v6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                    ])
                                                                                                    self.type = None
                                                                                                    self.code = None
                                                                                                    self._segment_path = lambda: "icmp-v6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['type', 'code'], name, value)


                                                                                            class Ipv4PacketLen(Entity):
                                                                                                """
                                                                                                IPv4 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv6PacketLen(Entity):
                                                                                                """
                                                                                                IPv6 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class PacketLen(Entity):
                                                                                                """
                                                                                                Match packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                    self.yang_name = "packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FlowTag(Entity):
                                                                                                """
                                                                                                Match flow\-tag array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                    self.yang_name = "flow-tag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "flow-tag"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "flow-tag"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class TcpFlag(Entity):
                                                                                                """
                                                                                                Match tcp flag value
                                                                                                
                                                                                                .. attribute:: value
                                                                                                
                                                                                                	Value of TCP flag
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: match_any
                                                                                                
                                                                                                	Match any TCP flag bit
                                                                                                	**type**\: bool
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                    self.yang_name = "tcp-flag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                                        ('match_any', (YLeaf(YType.boolean, 'match-any'), ['bool'])),
                                                                                                    ])
                                                                                                    self.value = None
                                                                                                    self.match_any = None
                                                                                                    self._segment_path = lambda: "tcp-flag"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['value', 'match_any'], name, value)


                                                                                            class Icmpv4Type(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                    self.yang_name = "icmpv4-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv4Code(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                    self.yang_name = "icmpv4-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-code"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv6Type(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                    self.yang_name = "icmpv6-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv6Code(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                    self.yang_name = "icmpv6-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-code"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class MplsExp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental topmost array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "mpls-exp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                            class MplsExpImp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental imposition array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "mpls-exp-imp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                            class MplsDispIpv4Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                            class MplsDispIpv6Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                            class MplsTopLabel(Entity):
                                                                                                """
                                                                                                MPLS Topmost LABEL
                                                                                                
                                                                                                .. attribute:: uint32_rng_array
                                                                                                
                                                                                                	uint32 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                    self.yang_name = "mpls-top-label"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint32_rng_array", ("uint32_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint32_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "mpls-top-label"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                                class Uint32RngArray(Entity):
                                                                                                    """
                                                                                                    uint32 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                        self.yang_name = "uint32_rng_array"
                                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint32, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint32, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint32_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['min', 'max'], name, value)


                                                                                            class Cos(Entity):
                                                                                                """
                                                                                                Match CoS array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                    self.yang_name = "cos"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "cos"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                            class CosInr(Entity):
                                                                                                """
                                                                                                Match inner header CoS
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                    self.yang_name = "cos-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "cos-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                            class Dei(Entity):
                                                                                                """
                                                                                                Match DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                    self.yang_name = "dei"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                    ])
                                                                                                    self.bit_value = None
                                                                                                    self._segment_path = lambda: "dei"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                            class DeiInr(Entity):
                                                                                                """
                                                                                                Match inner DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                    self.yang_name = "dei-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                    ])
                                                                                                    self.bit_value = None
                                                                                                    self._segment_path = lambda: "dei-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                            class Vlan(Entity):
                                                                                                """
                                                                                                Match VLAN array
                                                                                                
                                                                                                .. attribute:: vlan_id_array
                                                                                                
                                                                                                	vlan id array
                                                                                                	**type**\: list of  		 :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                    self.yang_name = "vlan"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("vlan-id-array", ("vlan_id_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.vlan_id_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                                class VlanIdArray(Entity):
                                                                                                    """
                                                                                                    vlan id array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	VLAN mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                        self.yang_name = "vlan-id-array"
                                                                                                        self.yang_parent_name = "vlan"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ('mask', (YLeaf(YType.uint16, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "vlan-id-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['min', 'max', 'mask'], name, value)


                                                                                            class VlanInr(Entity):
                                                                                                """
                                                                                                Match inner header VLAN range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                    self.yang_name = "vlan-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FrDlci(Entity):
                                                                                                """
                                                                                                Match FR DLCI range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                    self.yang_name = "fr-dlci"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "fr-dlci"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class SrcMac(Entity):
                                                                                                """
                                                                                                Match Source MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                    self.yang_name = "src-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.mac_addr = []
                                                                                                    self.mask = []
                                                                                                    self._segment_path = lambda: "src-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                            class DstMac(Entity):
                                                                                                """
                                                                                                Match Destination MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                    self.yang_name = "dst-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.mac_addr = []
                                                                                                    self.mask = []
                                                                                                    self._segment_path = lambda: "dst-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                            class AtmClp(Entity):
                                                                                                """
                                                                                                Match ATM CLP level
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                    self.yang_name = "atm-clp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "atm-clp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                            class FrDe(Entity):
                                                                                                """
                                                                                                Match FR DE value
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                    self.yang_name = "fr-de"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "fr-de"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                            class Ipv4Acl(Entity):
                                                                                                """
                                                                                                IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                    self.yang_name = "ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ipv4-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                            class Ipv6Acl(Entity):
                                                                                                """
                                                                                                IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                    self.yang_name = "ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ipv6-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                            class EtherServiceAcl(Entity):
                                                                                                """
                                                                                                Ethernet\-Services Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                    self.yang_name = "ether-service-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ether-service-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                            class AvailId(Entity):
                                                                                                """
                                                                                                Available Identifiers
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                    self.yang_name = "avail-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "avail-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                            class MediaType(Entity):
                                                                                                """
                                                                                                Media Type
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                    self.yang_name = "media-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "media-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                            class SubsProtocol(Entity):
                                                                                                """
                                                                                                Protocol
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                    self.yang_name = "subs-protocol"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "subs-protocol"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                            class Dnis(Entity):
                                                                                                """
                                                                                                DNIS
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                    self.yang_name = "dnis"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dnis"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                            class DnisRegex(Entity):
                                                                                                """
                                                                                                DNIS Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                    self.yang_name = "dnis-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dnis-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                            class Domain(Entity):
                                                                                                """
                                                                                                Domain Name
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                    self.yang_name = "domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                        ])
                                                                                                        self.domain_name = None
                                                                                                        self.format_name = None
                                                                                                        self._segment_path = lambda: "domain-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class DomainRegex(Entity):
                                                                                                """
                                                                                                Domain Regular Expression
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                    self.yang_name = "domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain-regex"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                        ])
                                                                                                        self.domain_name = None
                                                                                                        self.format_name = None
                                                                                                        self._segment_path = lambda: "domain-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class NasPort(Entity):
                                                                                                """
                                                                                                NAS Port
                                                                                                
                                                                                                .. attribute:: nas_port_array
                                                                                                
                                                                                                	nas port array
                                                                                                	**type**\: list of  		 :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                    self.yang_name = "nas-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("nas-port-array", ("nas_port_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.nas_port_array = YList(self)
                                                                                                    self._segment_path = lambda: "nas-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                                class NasPortArray(Entity):
                                                                                                    """
                                                                                                    nas port array
                                                                                                    
                                                                                                    .. attribute:: sub_id
                                                                                                    
                                                                                                    	sub id
                                                                                                    	**type**\:  :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                    
                                                                                                    .. attribute:: operator
                                                                                                    
                                                                                                    	operator
                                                                                                    	**type**\:  :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	value
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                        self.yang_name = "nas-port-array"
                                                                                                        self.yang_parent_name = "nas-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('sub_id', (YLeaf(YType.enumeration, 'sub-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchNasPortSubIdEn', '')])),
                                                                                                            ('operator', (YLeaf(YType.enumeration, 'operator'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchLogicalOperatorEn', '')])),
                                                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                                        ])
                                                                                                        self.sub_id = None
                                                                                                        self.operator = None
                                                                                                        self.value = None
                                                                                                        self._segment_path = lambda: "nas-port-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['sub_id', 'operator', 'value'], name, value)


                                                                                            class ServiceName(Entity):
                                                                                                """
                                                                                                Service Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                    self.yang_name = "service-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "service-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                            class ServiceNameRegex(Entity):
                                                                                                """
                                                                                                Service Name Regular Exp
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                    self.yang_name = "service-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "service-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                            class SrcAddrIpv4(Entity):
                                                                                                """
                                                                                                Source Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class DstAddrIpv4(Entity):
                                                                                                """
                                                                                                Destination Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class SrcAddrIpv6(Entity):
                                                                                                """
                                                                                                Source Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class DstAddrIpv6(Entity):
                                                                                                """
                                                                                                Destination Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class SrcAddrMac(Entity):
                                                                                                """
                                                                                                Source Address MAC
                                                                                                
                                                                                                .. attribute:: mac_addr_array
                                                                                                
                                                                                                	mac addr array
                                                                                                	**type**\: list of  		 :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                    self.yang_name = "src-addr-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("mac-addr-array", ("mac_addr_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.mac_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                                class MacAddrArray(Entity):
                                                                                                    """
                                                                                                    mac addr array
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                        self.yang_name = "mac-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                            ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.mac_addr = []
                                                                                                        self.mask = []
                                                                                                        self._segment_path = lambda: "mac-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                            class Timer(Entity):
                                                                                                """
                                                                                                Timer
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                    self.yang_name = "timer"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "timer"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                            class TimerRegexp(Entity):
                                                                                                """
                                                                                                Timer Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                    self.yang_name = "timer-regexp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "timer-regexp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                            class TunnelName(Entity):
                                                                                                """
                                                                                                Tunnel Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                    self.yang_name = "tunnel-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "tunnel-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                            class TunnelNameRegex(Entity):
                                                                                                """
                                                                                                Tunnel Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "tunnel-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                            class UserName(Entity):
                                                                                                """
                                                                                                User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                    self.yang_name = "user-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "user-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                            class UserNameRegex(Entity):
                                                                                                """
                                                                                                User Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                    self.yang_name = "user-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "user-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                            class AuthUsername(Entity):
                                                                                                """
                                                                                                Authenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                    self.yang_name = "auth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-username"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                            class AuthUsernameRegex(Entity):
                                                                                                """
                                                                                                Authenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "auth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-username-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                            class UnauthUsername(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                    self.yang_name = "unauth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-username"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                            class UnauthUsernameRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-username-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                            class AuthDomain(Entity):
                                                                                                """
                                                                                                Authenticated domain name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                    self.yang_name = "auth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                            class AuthDomainRegex(Entity):
                                                                                                """
                                                                                                Authenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "auth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                            class UnauthDomain(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                    self.yang_name = "unauth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                            class UnauthDomainRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                            class VendorId(Entity):
                                                                                                """
                                                                                                Vendor ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                    self.yang_name = "vendor-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "vendor-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                            class VendorIdRegex(Entity):
                                                                                                """
                                                                                                Vendor ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                    self.yang_name = "vendor-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "vendor-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                            class AccessInterface(Entity):
                                                                                                """
                                                                                                Access interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                    self.yang_name = "access-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "access-interface"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                            class InputInterface(Entity):
                                                                                                """
                                                                                                Input interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                    self.yang_name = "input-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "input-interface"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                            class InputIntfhdl(Entity):
                                                                                                """
                                                                                                Input interface handle
                                                                                                
                                                                                                .. attribute:: uint64_array
                                                                                                
                                                                                                	uint64 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..18446744073709551615
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                    self.yang_name = "input-intfhdl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint64_array', (YLeafList(YType.uint64, 'uint64_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint64_array = []
                                                                                                    self._segment_path = lambda: "input-intfhdl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                            class Ethertype(Entity):
                                                                                                """
                                                                                                Ethernet type
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                    self.yang_name = "ethertype"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ethertype"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ethertype"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FlowKeyData(Entity):
                                                                                                """
                                                                                                Flow key structure
                                                                                                
                                                                                                .. attribute:: flow_keys
                                                                                                
                                                                                                	flow keys
                                                                                                	**type**\:  :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                                
                                                                                                .. attribute:: max_count
                                                                                                
                                                                                                	Maximum count of flows
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: idle_timeout
                                                                                                
                                                                                                	Idle timeout of flows (in seconds)
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                	**units**\: second
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                    self.yang_name = "flow-key-data"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("flow-keys", ("flow_keys", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys))])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('max_count', (YLeaf(YType.uint16, 'max-count'), ['int'])),
                                                                                                        ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                                                    ])
                                                                                                    self.max_count = None
                                                                                                    self.idle_timeout = None

                                                                                                    self.flow_keys = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                    self.flow_keys.parent = self
                                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                    self._segment_path = lambda: "flow-key-data"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['max_count', 'idle_timeout'], name, value)


                                                                                                class FlowKeys(Entity):
                                                                                                    """
                                                                                                    flow keys
                                                                                                    
                                                                                                    .. attribute:: keys
                                                                                                    
                                                                                                    	keys
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                    
                                                                                                    .. attribute:: num
                                                                                                    
                                                                                                    	num
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                        self.yang_name = "flow-keys"
                                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('keys', (YLeaf(YType.str, 'keys'), ['str'])),
                                                                                                            ('num', (YLeaf(YType.uint8, 'num'), ['int'])),
                                                                                                        ])
                                                                                                        self.keys = None
                                                                                                        self.num = None
                                                                                                        self._segment_path = lambda: "flow-keys"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                            class DhcpClientId(Entity):
                                                                                                """
                                                                                                Dhcp Client ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dhcp-client-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                            class DhcpClientIdRegex(Entity):
                                                                                                """
                                                                                                Dhcp Client ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                            class CircuitId(Entity):
                                                                                                """
                                                                                                Circuit ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                    self.yang_name = "circuit-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "circuit-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                            class CircuitIdRegex(Entity):
                                                                                                """
                                                                                                Circuit ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                    self.yang_name = "circuit-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "circuit-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                            class RemoteId(Entity):
                                                                                                """
                                                                                                Remote ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                    self.yang_name = "remote-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "remote-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                            class RemoteIdRegex(Entity):
                                                                                                """
                                                                                                Remote ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                    self.yang_name = "remote-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "remote-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                            class SrcPort(Entity):
                                                                                                """
                                                                                                Source port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                    self.yang_name = "src-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "src-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class DstPort(Entity):
                                                                                                """
                                                                                                Destination port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                    self.yang_name = "dst-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "dst-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                        class ConfclassP(Entity):
                                                                            """
                                                                            confclass p
                                                                            
                                                                            .. attribute:: class_map_bg
                                                                            
                                                                            	class map bg
                                                                            	**type**\: list of  		 :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP, self).__init__()

                                                                                self.yang_name = "confclass-p"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("class-map-bg", ("class_map_bg", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg))])
                                                                                self._leafs = OrderedDict()

                                                                                self.class_map_bg = YList(self)
                                                                                self._segment_path = lambda: "confclass-p"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP, [], name, value)


                                                                            class ClassMapBg(Entity):
                                                                                """
                                                                                class map bg
                                                                                
                                                                                .. attribute:: match_infop
                                                                                
                                                                                	Pointer to the first Match info
                                                                                	**type**\:  :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop>`
                                                                                
                                                                                .. attribute:: name
                                                                                
                                                                                	Name of the class\-map
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..65
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Class\-Map Type QoS/PBR/Netflow/..
                                                                                	**type**\:  :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                                                
                                                                                .. attribute:: mode
                                                                                
                                                                                	Class\-Map Mode Match any/Match all
                                                                                	**type**\:  :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                                
                                                                                .. attribute:: description
                                                                                
                                                                                	description
                                                                                	**type**\: str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg, self).__init__()

                                                                                    self.yang_name = "class-map-bg"
                                                                                    self.yang_parent_name = "confclass-p"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("match-infop", ("match_infop", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapTypeEn', '')])),
                                                                                        ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapModeEn', '')])),
                                                                                        ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                    ])
                                                                                    self.name = None
                                                                                    self.type = None
                                                                                    self.mode = None
                                                                                    self.description = None

                                                                                    self.match_infop = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop()
                                                                                    self.match_infop.parent = self
                                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                                    self._segment_path = lambda: "class-map-bg"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg, ['name', 'type', 'mode', 'description'], name, value)


                                                                                class MatchInfop(Entity):
                                                                                    """
                                                                                    Pointer to the first Match info
                                                                                    
                                                                                    .. attribute:: class_match_info_st
                                                                                    
                                                                                    	class match info st
                                                                                    	**type**\: list of  		 :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop, self).__init__()

                                                                                        self.yang_name = "match-infop"
                                                                                        self.yang_parent_name = "class-map-bg"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("class-match-info-st", ("class_match_info_st", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.class_match_info_st = YList(self)
                                                                                        self._segment_path = lambda: "match-infop"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop, [], name, value)


                                                                                    class ClassMatchInfoSt(Entity):
                                                                                        """
                                                                                        class match info st
                                                                                        
                                                                                        .. attribute:: match_data
                                                                                        
                                                                                        	Match criteria
                                                                                        	**type**\:  :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                        
                                                                                        .. attribute:: flags
                                                                                        
                                                                                        	Flags
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                            self.yang_name = "class-match-info-st"
                                                                                            self.yang_parent_name = "match-infop"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("match-data", ("match_data", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData))])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                            ])
                                                                                            self.flags = None

                                                                                            self.match_data = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                            self.match_data.parent = self
                                                                                            self._children_name_map["match_data"] = "match-data"
                                                                                            self._segment_path = lambda: "class-match-info-st"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                        class MatchData(Entity):
                                                                                            """
                                                                                            Match criteria
                                                                                            
                                                                                            .. attribute:: ipv4_dscp
                                                                                            
                                                                                            	IPv4 DSCP
                                                                                            	**type**\:  :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv6_dscp
                                                                                            
                                                                                            	IPv6 DSCP
                                                                                            	**type**\:  :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                            
                                                                                            .. attribute:: dscp
                                                                                            
                                                                                            	Match DSCP range array
                                                                                            	**type**\:  :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv4_prec
                                                                                            
                                                                                            	IPv4 Precedence
                                                                                            	**type**\:  :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                            
                                                                                            .. attribute:: ipv6_prec
                                                                                            
                                                                                            	IPv6 Precedence
                                                                                            	**type**\:  :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                            
                                                                                            .. attribute:: prec
                                                                                            
                                                                                            	Match Precedence array
                                                                                            	**type**\:  :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                            
                                                                                            .. attribute:: discard_class
                                                                                            
                                                                                            	Match Discard Class array
                                                                                            	**type**\:  :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                            
                                                                                            .. attribute:: qos_group
                                                                                            
                                                                                            	Match QoS group array
                                                                                            	**type**\:  :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                            
                                                                                            .. attribute:: traffic_class
                                                                                            
                                                                                            	Match Traffic class array
                                                                                            	**type**\:  :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                            
                                                                                            .. attribute:: proto
                                                                                            
                                                                                            	Match Protocol array
                                                                                            	**type**\:  :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                            
                                                                                            .. attribute:: icmp_v4
                                                                                            
                                                                                            	Match ICMPV4 Protocol
                                                                                            	**type**\:  :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                            
                                                                                            .. attribute:: icmp_v6
                                                                                            
                                                                                            	Match ICMPV6 Protocol array
                                                                                            	**type**\:  :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                            
                                                                                            .. attribute:: ipv4_packet_len
                                                                                            
                                                                                            	IPv4 packet length array
                                                                                            	**type**\:  :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv6_packet_len
                                                                                            
                                                                                            	IPv6 packet length array
                                                                                            	**type**\:  :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                            
                                                                                            .. attribute:: packet_len
                                                                                            
                                                                                            	Match packet length array
                                                                                            	**type**\:  :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                            
                                                                                            .. attribute:: flow_tag
                                                                                            
                                                                                            	Match flow\-tag array
                                                                                            	**type**\:  :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                            
                                                                                            .. attribute:: tcp_flag
                                                                                            
                                                                                            	Match tcp flag value
                                                                                            	**type**\:  :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                            
                                                                                            .. attribute:: icmpv4_type
                                                                                            
                                                                                            	Match ipv4 icmp type
                                                                                            	**type**\:  :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                            
                                                                                            .. attribute:: icmpv4_code
                                                                                            
                                                                                            	Match ipv4 icmp code
                                                                                            	**type**\:  :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                            
                                                                                            .. attribute:: icmpv6_type
                                                                                            
                                                                                            	Match ipv6 icmp type
                                                                                            	**type**\:  :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                            
                                                                                            .. attribute:: icmpv6_code
                                                                                            
                                                                                            	Match ipv6 icmp code
                                                                                            	**type**\:  :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                            
                                                                                            .. attribute:: mpls_exp
                                                                                            
                                                                                            	Match MPLS experimental topmost array
                                                                                            	**type**\:  :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                            
                                                                                            .. attribute:: mpls_exp_imp
                                                                                            
                                                                                            	Match MPLS experimental imposition array
                                                                                            	**type**\:  :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                                            
                                                                                            	MPLS Disposition IPv4 Access\-list
                                                                                            	**type**\:  :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                                            
                                                                                            	MPLS Disposition IPv6 Access\-list
                                                                                            	**type**\:  :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_top_label
                                                                                            
                                                                                            	MPLS Topmost LABEL
                                                                                            	**type**\:  :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                            
                                                                                            .. attribute:: cos
                                                                                            
                                                                                            	Match CoS array
                                                                                            	**type**\:  :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                            
                                                                                            .. attribute:: cos_inr
                                                                                            
                                                                                            	Match inner header CoS
                                                                                            	**type**\:  :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                            
                                                                                            .. attribute:: dei
                                                                                            
                                                                                            	Match DEI Bit
                                                                                            	**type**\:  :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                            
                                                                                            .. attribute:: dei_inr
                                                                                            
                                                                                            	Match inner DEI Bit
                                                                                            	**type**\:  :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                            
                                                                                            .. attribute:: vlan
                                                                                            
                                                                                            	Match VLAN array
                                                                                            	**type**\:  :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                            
                                                                                            .. attribute:: vlan_inr
                                                                                            
                                                                                            	Match inner header VLAN range array
                                                                                            	**type**\:  :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                            
                                                                                            .. attribute:: fr_dlci
                                                                                            
                                                                                            	Match FR DLCI range array
                                                                                            	**type**\:  :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                            
                                                                                            .. attribute:: src_mac
                                                                                            
                                                                                            	Match Source MAC address
                                                                                            	**type**\:  :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                            
                                                                                            .. attribute:: dst_mac
                                                                                            
                                                                                            	Match Destination MAC address
                                                                                            	**type**\:  :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                            
                                                                                            .. attribute:: atm_clp
                                                                                            
                                                                                            	Match ATM CLP level
                                                                                            	**type**\:  :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                            
                                                                                            .. attribute:: fr_de
                                                                                            
                                                                                            	Match FR DE value
                                                                                            	**type**\:  :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                            
                                                                                            .. attribute:: ipv4_acl
                                                                                            
                                                                                            	IPv4 Access\-list
                                                                                            	**type**\:  :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                            
                                                                                            .. attribute:: ipv6_acl
                                                                                            
                                                                                            	IPv6 Access\-list
                                                                                            	**type**\:  :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                            
                                                                                            .. attribute:: ether_service_acl
                                                                                            
                                                                                            	Ethernet\-Services Access\-list
                                                                                            	**type**\:  :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                            
                                                                                            .. attribute:: avail_id
                                                                                            
                                                                                            	Available Identifiers
                                                                                            	**type**\:  :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                            
                                                                                            .. attribute:: media_type
                                                                                            
                                                                                            	Media Type
                                                                                            	**type**\:  :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                            
                                                                                            .. attribute:: subs_protocol
                                                                                            
                                                                                            	Protocol
                                                                                            	**type**\:  :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                            
                                                                                            .. attribute:: dnis
                                                                                            
                                                                                            	DNIS
                                                                                            	**type**\:  :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                            
                                                                                            .. attribute:: dnis_regex
                                                                                            
                                                                                            	DNIS Regular Expression
                                                                                            	**type**\:  :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                            
                                                                                            .. attribute:: domain
                                                                                            
                                                                                            	Domain Name
                                                                                            	**type**\:  :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                            
                                                                                            .. attribute:: domain_regex
                                                                                            
                                                                                            	Domain Regular Expression
                                                                                            	**type**\:  :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                            
                                                                                            .. attribute:: nas_port
                                                                                            
                                                                                            	NAS Port
                                                                                            	**type**\:  :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                            
                                                                                            .. attribute:: service_name
                                                                                            
                                                                                            	Service Name
                                                                                            	**type**\:  :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                            
                                                                                            .. attribute:: service_name_regex
                                                                                            
                                                                                            	Service Name Regular Exp
                                                                                            	**type**\:  :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv4
                                                                                            
                                                                                            	Source Address IPV4
                                                                                            	**type**\:  :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv4
                                                                                            
                                                                                            	Destination Address IPV4
                                                                                            	**type**\:  :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv6
                                                                                            
                                                                                            	Source Address IPV6
                                                                                            	**type**\:  :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv6
                                                                                            
                                                                                            	Destination Address IPV6
                                                                                            	**type**\:  :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: src_addr_mac
                                                                                            
                                                                                            	Source Address MAC
                                                                                            	**type**\:  :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                            
                                                                                            .. attribute:: timer
                                                                                            
                                                                                            	Timer
                                                                                            	**type**\:  :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                            
                                                                                            .. attribute:: timer_regexp
                                                                                            
                                                                                            	Timer Regular Expression
                                                                                            	**type**\:  :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                            
                                                                                            .. attribute:: tunnel_name
                                                                                            
                                                                                            	Tunnel Name
                                                                                            	**type**\:  :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                            
                                                                                            .. attribute:: tunnel_name_regex
                                                                                            
                                                                                            	Tunnel Name Regular Expression
                                                                                            	**type**\:  :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                            
                                                                                            .. attribute:: user_name
                                                                                            
                                                                                            	User Name
                                                                                            	**type**\:  :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                            
                                                                                            .. attribute:: user_name_regex
                                                                                            
                                                                                            	User Name Regular Expression
                                                                                            	**type**\:  :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                            
                                                                                            .. attribute:: auth_username
                                                                                            
                                                                                            	Authenticated User Name
                                                                                            	**type**\:  :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                            
                                                                                            .. attribute:: auth_username_regex
                                                                                            
                                                                                            	Authenticated User Name RegEx
                                                                                            	**type**\:  :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_username
                                                                                            
                                                                                            	Unauthenticated User Name
                                                                                            	**type**\:  :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                            
                                                                                            .. attribute:: unauth_username_regex
                                                                                            
                                                                                            	Unauthenticated User Name RegEx
                                                                                            	**type**\:  :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: auth_domain
                                                                                            
                                                                                            	Authenticated domain name
                                                                                            	**type**\:  :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                            
                                                                                            .. attribute:: auth_domain_regex
                                                                                            
                                                                                            	Authenticated Domain Name RegEx
                                                                                            	**type**\:  :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_domain
                                                                                            
                                                                                            	Unauthenticated Domain Name
                                                                                            	**type**\:  :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                            
                                                                                            .. attribute:: unauth_domain_regex
                                                                                            
                                                                                            	Unauthenticated Domain Name RegEx
                                                                                            	**type**\:  :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: vendor_id
                                                                                            
                                                                                            	Vendor ID
                                                                                            	**type**\:  :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                            
                                                                                            .. attribute:: vendor_id_regex
                                                                                            
                                                                                            	Vendor ID RegEx
                                                                                            	**type**\:  :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                            
                                                                                            .. attribute:: access_interface
                                                                                            
                                                                                            	Access interface
                                                                                            	**type**\:  :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                            
                                                                                            .. attribute:: input_interface
                                                                                            
                                                                                            	Input interface
                                                                                            	**type**\:  :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                            
                                                                                            .. attribute:: input_intfhdl
                                                                                            
                                                                                            	Input interface handle
                                                                                            	**type**\:  :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                            
                                                                                            .. attribute:: ethertype
                                                                                            
                                                                                            	Ethernet type
                                                                                            	**type**\:  :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                            
                                                                                            .. attribute:: flow_key_data
                                                                                            
                                                                                            	Flow key structure
                                                                                            	**type**\:  :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id
                                                                                            
                                                                                            	Dhcp Client ID
                                                                                            	**type**\:  :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id_regex
                                                                                            
                                                                                            	Dhcp Client ID RegEx
                                                                                            	**type**\:  :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                            
                                                                                            .. attribute:: circuit_id
                                                                                            
                                                                                            	Circuit ID
                                                                                            	**type**\:  :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                            
                                                                                            .. attribute:: circuit_id_regex
                                                                                            
                                                                                            	Circuit ID RegEx
                                                                                            	**type**\:  :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                            
                                                                                            .. attribute:: remote_id
                                                                                            
                                                                                            	Remote ID
                                                                                            	**type**\:  :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                            
                                                                                            .. attribute:: remote_id_regex
                                                                                            
                                                                                            	Remote ID RegEx
                                                                                            	**type**\:  :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                            
                                                                                            .. attribute:: src_port
                                                                                            
                                                                                            	Source port
                                                                                            	**type**\:  :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                            
                                                                                            .. attribute:: dst_port
                                                                                            
                                                                                            	Destination port
                                                                                            	**type**\:  :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	type
                                                                                            	**type**\:  :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                            
                                                                                            .. attribute:: mpls_top_eos
                                                                                            
                                                                                            	MPLS Topmost EOS
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: fragment_type
                                                                                            
                                                                                            	Fragment type
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: authen_status
                                                                                            
                                                                                            	Authentication Status
                                                                                            	**type**\:  :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                            
                                                                                            .. attribute:: mlp_negotiated
                                                                                            
                                                                                            	MLP Negotiated
                                                                                            	**type**\:  :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                                self.yang_name = "match-data"
                                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("ipv4-dscp", ("ipv4_dscp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp)), ("ipv6-dscp", ("ipv6_dscp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp)), ("dscp", ("dscp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp)), ("ipv4-prec", ("ipv4_prec", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec)), ("ipv6-prec", ("ipv6_prec", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec)), ("prec", ("prec", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec)), ("discard-class", ("discard_class", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass)), ("qos-group", ("qos_group", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup)), ("traffic-class", ("traffic_class", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass)), ("proto", ("proto", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto)), ("icmp-v4", ("icmp_v4", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4)), ("icmp-v6", ("icmp_v6", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6)), ("ipv4-packet-len", ("ipv4_packet_len", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen)), ("ipv6-packet-len", ("ipv6_packet_len", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen)), ("packet-len", ("packet_len", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen)), ("flow-tag", ("flow_tag", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag)), ("tcp-flag", ("tcp_flag", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag)), ("icmpv4-type", ("icmpv4_type", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type)), ("icmpv4-code", ("icmpv4_code", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code)), ("icmpv6-type", ("icmpv6_type", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type)), ("icmpv6-code", ("icmpv6_code", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code)), ("mpls-exp", ("mpls_exp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp)), ("mpls-exp-imp", ("mpls_exp_imp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp)), ("mpls-disp-ipv4-acl", ("mpls_disp_ipv4_acl", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl)), ("mpls-disp-ipv6-acl", ("mpls_disp_ipv6_acl", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl)), ("mpls-top-label", ("mpls_top_label", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel)), ("cos", ("cos", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos)), ("cos-inr", ("cos_inr", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr)), ("dei", ("dei", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei)), ("dei-inr", ("dei_inr", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr)), ("vlan", ("vlan", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan)), ("vlan-inr", ("vlan_inr", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)), ("fr-dlci", ("fr_dlci", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci)), ("src-mac", ("src_mac", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac)), ("dst-mac", ("dst_mac", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac)), ("atm-clp", ("atm_clp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp)), ("fr-de", ("fr_de", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe)), ("ipv4-acl", ("ipv4_acl", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl)), ("ipv6-acl", ("ipv6_acl", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl)), ("ether-service-acl", ("ether_service_acl", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl)), ("avail-id", ("avail_id", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId)), ("media-type", ("media_type", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType)), ("subs-protocol", ("subs_protocol", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol)), ("dnis", ("dnis", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis)), ("dnis-regex", ("dnis_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex)), ("domain", ("domain", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain)), ("domain-regex", ("domain_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex)), ("nas-port", ("nas_port", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort)), ("service-name", ("service_name", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName)), ("service-name-regex", ("service_name_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex)), ("src-addr-ipv4", ("src_addr_ipv4", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4)), ("dst-addr-ipv4", ("dst_addr_ipv4", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4)), ("src-addr-ipv6", ("src_addr_ipv6", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6)), ("dst-addr-ipv6", ("dst_addr_ipv6", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6)), ("src-addr-mac", ("src_addr_mac", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac)), ("timer", ("timer", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer)), ("timer-regexp", ("timer_regexp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp)), ("tunnel-name", ("tunnel_name", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName)), ("tunnel-name-regex", ("tunnel_name_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex)), ("user-name", ("user_name", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName)), ("user-name-regex", ("user_name_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex)), ("auth-username", ("auth_username", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername)), ("auth-username-regex", ("auth_username_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex)), ("unauth-username", ("unauth_username", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername)), ("unauth-username-regex", ("unauth_username_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex)), ("auth-domain", ("auth_domain", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain)), ("auth-domain-regex", ("auth_domain_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex)), ("unauth-domain", ("unauth_domain", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain)), ("unauth-domain-regex", ("unauth_domain_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex)), ("vendor-id", ("vendor_id", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId)), ("vendor-id-regex", ("vendor_id_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex)), ("access-interface", ("access_interface", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface)), ("input-interface", ("input_interface", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface)), ("input-intfhdl", ("input_intfhdl", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl)), ("ethertype", ("ethertype", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype)), ("flow-key-data", ("flow_key_data", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData)), ("dhcp-client-id", ("dhcp_client_id", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId)), ("dhcp-client-id-regex", ("dhcp_client_id_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex)), ("circuit-id", ("circuit_id", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId)), ("circuit-id-regex", ("circuit_id_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex)), ("remote-id", ("remote_id", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId)), ("remote-id-regex", ("remote_id_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex)), ("src-port", ("src_port", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort)), ("dst-port", ("dst_port", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort))])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchTypeEn', '')])),
                                                                                                    ('mpls_top_eos', (YLeaf(YType.uint8, 'mpls-top-eos'), ['int'])),
                                                                                                    ('fragment_type', (YLeaf(YType.uint8, 'fragment-type'), ['int'])),
                                                                                                    ('authen_status', (YLeaf(YType.enumeration, 'authen-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchAuthenStatusEn', '')])),
                                                                                                    ('mlp_negotiated', (YLeaf(YType.enumeration, 'mlp-negotiated'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchMlpNegotiatedEn', '')])),
                                                                                                ])
                                                                                                self.type = None
                                                                                                self.mpls_top_eos = None
                                                                                                self.fragment_type = None
                                                                                                self.authen_status = None
                                                                                                self.mlp_negotiated = None

                                                                                                self.ipv4_dscp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                                self.ipv4_dscp.parent = self
                                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"

                                                                                                self.ipv6_dscp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                                self.ipv6_dscp.parent = self
                                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"

                                                                                                self.dscp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                                self.dscp.parent = self
                                                                                                self._children_name_map["dscp"] = "dscp"

                                                                                                self.ipv4_prec = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                                self.ipv4_prec.parent = self
                                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"

                                                                                                self.ipv6_prec = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                                self.ipv6_prec.parent = self
                                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"

                                                                                                self.prec = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                                self.prec.parent = self
                                                                                                self._children_name_map["prec"] = "prec"

                                                                                                self.discard_class = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                                self.discard_class.parent = self
                                                                                                self._children_name_map["discard_class"] = "discard-class"

                                                                                                self.qos_group = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                                self.qos_group.parent = self
                                                                                                self._children_name_map["qos_group"] = "qos-group"

                                                                                                self.traffic_class = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                                self.traffic_class.parent = self
                                                                                                self._children_name_map["traffic_class"] = "traffic-class"

                                                                                                self.proto = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                                self.proto.parent = self
                                                                                                self._children_name_map["proto"] = "proto"

                                                                                                self.icmp_v4 = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                                self.icmp_v4.parent = self
                                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"

                                                                                                self.icmp_v6 = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                                self.icmp_v6.parent = self
                                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"

                                                                                                self.ipv4_packet_len = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                                self.ipv4_packet_len.parent = self
                                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"

                                                                                                self.ipv6_packet_len = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                                self.ipv6_packet_len.parent = self
                                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"

                                                                                                self.packet_len = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                                self.packet_len.parent = self
                                                                                                self._children_name_map["packet_len"] = "packet-len"

                                                                                                self.flow_tag = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                                self.flow_tag.parent = self
                                                                                                self._children_name_map["flow_tag"] = "flow-tag"

                                                                                                self.tcp_flag = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                                self.tcp_flag.parent = self
                                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"

                                                                                                self.icmpv4_type = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                                self.icmpv4_type.parent = self
                                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"

                                                                                                self.icmpv4_code = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                                self.icmpv4_code.parent = self
                                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"

                                                                                                self.icmpv6_type = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                                self.icmpv6_type.parent = self
                                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"

                                                                                                self.icmpv6_code = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                                self.icmpv6_code.parent = self
                                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"

                                                                                                self.mpls_exp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                                self.mpls_exp.parent = self
                                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"

                                                                                                self.mpls_exp_imp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                                self.mpls_exp_imp.parent = self
                                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"

                                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"

                                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"

                                                                                                self.mpls_top_label = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                                self.mpls_top_label.parent = self
                                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"

                                                                                                self.cos = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                                self.cos.parent = self
                                                                                                self._children_name_map["cos"] = "cos"

                                                                                                self.cos_inr = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                                self.cos_inr.parent = self
                                                                                                self._children_name_map["cos_inr"] = "cos-inr"

                                                                                                self.dei = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                                self.dei.parent = self
                                                                                                self._children_name_map["dei"] = "dei"

                                                                                                self.dei_inr = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                                self.dei_inr.parent = self
                                                                                                self._children_name_map["dei_inr"] = "dei-inr"

                                                                                                self.vlan = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                                self.vlan.parent = self
                                                                                                self._children_name_map["vlan"] = "vlan"

                                                                                                self.vlan_inr = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                                self.vlan_inr.parent = self
                                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"

                                                                                                self.fr_dlci = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                                self.fr_dlci.parent = self
                                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"

                                                                                                self.src_mac = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                                self.src_mac.parent = self
                                                                                                self._children_name_map["src_mac"] = "src-mac"

                                                                                                self.dst_mac = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                                self.dst_mac.parent = self
                                                                                                self._children_name_map["dst_mac"] = "dst-mac"

                                                                                                self.atm_clp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                                self.atm_clp.parent = self
                                                                                                self._children_name_map["atm_clp"] = "atm-clp"

                                                                                                self.fr_de = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                                self.fr_de.parent = self
                                                                                                self._children_name_map["fr_de"] = "fr-de"

                                                                                                self.ipv4_acl = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                                self.ipv4_acl.parent = self
                                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"

                                                                                                self.ipv6_acl = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                                self.ipv6_acl.parent = self
                                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"

                                                                                                self.ether_service_acl = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                                self.ether_service_acl.parent = self
                                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"

                                                                                                self.avail_id = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                                self.avail_id.parent = self
                                                                                                self._children_name_map["avail_id"] = "avail-id"

                                                                                                self.media_type = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                                self.media_type.parent = self
                                                                                                self._children_name_map["media_type"] = "media-type"

                                                                                                self.subs_protocol = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                                self.subs_protocol.parent = self
                                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"

                                                                                                self.dnis = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                                self.dnis.parent = self
                                                                                                self._children_name_map["dnis"] = "dnis"

                                                                                                self.dnis_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                                self.dnis_regex.parent = self
                                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"

                                                                                                self.domain = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                                self.domain.parent = self
                                                                                                self._children_name_map["domain"] = "domain"

                                                                                                self.domain_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                                self.domain_regex.parent = self
                                                                                                self._children_name_map["domain_regex"] = "domain-regex"

                                                                                                self.nas_port = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                                self.nas_port.parent = self
                                                                                                self._children_name_map["nas_port"] = "nas-port"

                                                                                                self.service_name = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                                self.service_name.parent = self
                                                                                                self._children_name_map["service_name"] = "service-name"

                                                                                                self.service_name_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                                self.service_name_regex.parent = self
                                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"

                                                                                                self.src_addr_ipv4 = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                                self.src_addr_ipv4.parent = self
                                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"

                                                                                                self.dst_addr_ipv4 = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                                self.dst_addr_ipv4.parent = self
                                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"

                                                                                                self.src_addr_ipv6 = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                                self.src_addr_ipv6.parent = self
                                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"

                                                                                                self.dst_addr_ipv6 = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                                self.dst_addr_ipv6.parent = self
                                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"

                                                                                                self.src_addr_mac = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                                self.src_addr_mac.parent = self
                                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"

                                                                                                self.timer = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                                self.timer.parent = self
                                                                                                self._children_name_map["timer"] = "timer"

                                                                                                self.timer_regexp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                                self.timer_regexp.parent = self
                                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"

                                                                                                self.tunnel_name = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                                self.tunnel_name.parent = self
                                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"

                                                                                                self.tunnel_name_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                                self.tunnel_name_regex.parent = self
                                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"

                                                                                                self.user_name = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                                self.user_name.parent = self
                                                                                                self._children_name_map["user_name"] = "user-name"

                                                                                                self.user_name_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                                self.user_name_regex.parent = self
                                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"

                                                                                                self.auth_username = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                                self.auth_username.parent = self
                                                                                                self._children_name_map["auth_username"] = "auth-username"

                                                                                                self.auth_username_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                                self.auth_username_regex.parent = self
                                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"

                                                                                                self.unauth_username = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                                self.unauth_username.parent = self
                                                                                                self._children_name_map["unauth_username"] = "unauth-username"

                                                                                                self.unauth_username_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                                self.unauth_username_regex.parent = self
                                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"

                                                                                                self.auth_domain = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                                self.auth_domain.parent = self
                                                                                                self._children_name_map["auth_domain"] = "auth-domain"

                                                                                                self.auth_domain_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                                self.auth_domain_regex.parent = self
                                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"

                                                                                                self.unauth_domain = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                                self.unauth_domain.parent = self
                                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"

                                                                                                self.unauth_domain_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                                self.unauth_domain_regex.parent = self
                                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"

                                                                                                self.vendor_id = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                                self.vendor_id.parent = self
                                                                                                self._children_name_map["vendor_id"] = "vendor-id"

                                                                                                self.vendor_id_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                                self.vendor_id_regex.parent = self
                                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"

                                                                                                self.access_interface = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                                self.access_interface.parent = self
                                                                                                self._children_name_map["access_interface"] = "access-interface"

                                                                                                self.input_interface = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                                self.input_interface.parent = self
                                                                                                self._children_name_map["input_interface"] = "input-interface"

                                                                                                self.input_intfhdl = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                                self.input_intfhdl.parent = self
                                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"

                                                                                                self.ethertype = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                                self.ethertype.parent = self
                                                                                                self._children_name_map["ethertype"] = "ethertype"

                                                                                                self.flow_key_data = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                                self.flow_key_data.parent = self
                                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"

                                                                                                self.dhcp_client_id = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                                self.dhcp_client_id.parent = self
                                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"

                                                                                                self.dhcp_client_id_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                                self.dhcp_client_id_regex.parent = self
                                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"

                                                                                                self.circuit_id = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                                self.circuit_id.parent = self
                                                                                                self._children_name_map["circuit_id"] = "circuit-id"

                                                                                                self.circuit_id_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                                self.circuit_id_regex.parent = self
                                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"

                                                                                                self.remote_id = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                                self.remote_id.parent = self
                                                                                                self._children_name_map["remote_id"] = "remote-id"

                                                                                                self.remote_id_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                                self.remote_id_regex.parent = self
                                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"

                                                                                                self.src_port = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                                self.src_port.parent = self
                                                                                                self._children_name_map["src_port"] = "src-port"

                                                                                                self.dst_port = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                                self.dst_port.parent = self
                                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                                self._segment_path = lambda: "match-data"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['type', 'mpls_top_eos', 'fragment_type', 'authen_status', 'mlp_negotiated'], name, value)


                                                                                            class Ipv4Dscp(Entity):
                                                                                                """
                                                                                                IPv4 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv4-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv6Dscp(Entity):
                                                                                                """
                                                                                                IPv6 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv6-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Dscp(Entity):
                                                                                                """
                                                                                                Match DSCP range array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                    self.yang_name = "dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv4Prec(Entity):
                                                                                                """
                                                                                                IPv4 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                    self.yang_name = "ipv4-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "ipv4-prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                            class Ipv6Prec(Entity):
                                                                                                """
                                                                                                IPv6 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                    self.yang_name = "ipv6-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "ipv6-prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                            class Prec(Entity):
                                                                                                """
                                                                                                Match Precedence array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                    self.yang_name = "prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                            class DiscardClass(Entity):
                                                                                                """
                                                                                                Match Discard Class array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                    self.yang_name = "discard-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "discard-class"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                            class QosGroup(Entity):
                                                                                                """
                                                                                                Match QoS group array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                    self.yang_name = "qos-group"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "qos-group"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "qos-group"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class TrafficClass(Entity):
                                                                                                """
                                                                                                Match Traffic class array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                    self.yang_name = "traffic-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "traffic-class"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "traffic-class"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Proto(Entity):
                                                                                                """
                                                                                                Match Protocol array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                    self.yang_name = "proto"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "proto"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "proto"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class IcmpV4(Entity):
                                                                                                """
                                                                                                Match ICMPV4 Protocol
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                    self.yang_name = "icmp-v4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                    ])
                                                                                                    self.type = None
                                                                                                    self.code = None
                                                                                                    self._segment_path = lambda: "icmp-v4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['type', 'code'], name, value)


                                                                                            class IcmpV6(Entity):
                                                                                                """
                                                                                                Match ICMPV6 Protocol array
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                    self.yang_name = "icmp-v6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                    ])
                                                                                                    self.type = None
                                                                                                    self.code = None
                                                                                                    self._segment_path = lambda: "icmp-v6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['type', 'code'], name, value)


                                                                                            class Ipv4PacketLen(Entity):
                                                                                                """
                                                                                                IPv4 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv6PacketLen(Entity):
                                                                                                """
                                                                                                IPv6 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class PacketLen(Entity):
                                                                                                """
                                                                                                Match packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                    self.yang_name = "packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FlowTag(Entity):
                                                                                                """
                                                                                                Match flow\-tag array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                    self.yang_name = "flow-tag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "flow-tag"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "flow-tag"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class TcpFlag(Entity):
                                                                                                """
                                                                                                Match tcp flag value
                                                                                                
                                                                                                .. attribute:: value
                                                                                                
                                                                                                	Value of TCP flag
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: match_any
                                                                                                
                                                                                                	Match any TCP flag bit
                                                                                                	**type**\: bool
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                    self.yang_name = "tcp-flag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                                        ('match_any', (YLeaf(YType.boolean, 'match-any'), ['bool'])),
                                                                                                    ])
                                                                                                    self.value = None
                                                                                                    self.match_any = None
                                                                                                    self._segment_path = lambda: "tcp-flag"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['value', 'match_any'], name, value)


                                                                                            class Icmpv4Type(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                    self.yang_name = "icmpv4-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv4Code(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                    self.yang_name = "icmpv4-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-code"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv6Type(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                    self.yang_name = "icmpv6-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv6Code(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                    self.yang_name = "icmpv6-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-code"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class MplsExp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental topmost array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "mpls-exp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                            class MplsExpImp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental imposition array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "mpls-exp-imp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                            class MplsDispIpv4Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                            class MplsDispIpv6Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                            class MplsTopLabel(Entity):
                                                                                                """
                                                                                                MPLS Topmost LABEL
                                                                                                
                                                                                                .. attribute:: uint32_rng_array
                                                                                                
                                                                                                	uint32 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                    self.yang_name = "mpls-top-label"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint32_rng_array", ("uint32_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint32_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "mpls-top-label"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                                class Uint32RngArray(Entity):
                                                                                                    """
                                                                                                    uint32 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                        self.yang_name = "uint32_rng_array"
                                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint32, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint32, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint32_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['min', 'max'], name, value)


                                                                                            class Cos(Entity):
                                                                                                """
                                                                                                Match CoS array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                    self.yang_name = "cos"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "cos"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                            class CosInr(Entity):
                                                                                                """
                                                                                                Match inner header CoS
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                    self.yang_name = "cos-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "cos-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                            class Dei(Entity):
                                                                                                """
                                                                                                Match DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                    self.yang_name = "dei"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                    ])
                                                                                                    self.bit_value = None
                                                                                                    self._segment_path = lambda: "dei"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                            class DeiInr(Entity):
                                                                                                """
                                                                                                Match inner DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                    self.yang_name = "dei-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                    ])
                                                                                                    self.bit_value = None
                                                                                                    self._segment_path = lambda: "dei-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                            class Vlan(Entity):
                                                                                                """
                                                                                                Match VLAN array
                                                                                                
                                                                                                .. attribute:: vlan_id_array
                                                                                                
                                                                                                	vlan id array
                                                                                                	**type**\: list of  		 :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                    self.yang_name = "vlan"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("vlan-id-array", ("vlan_id_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.vlan_id_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                                class VlanIdArray(Entity):
                                                                                                    """
                                                                                                    vlan id array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	VLAN mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                        self.yang_name = "vlan-id-array"
                                                                                                        self.yang_parent_name = "vlan"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ('mask', (YLeaf(YType.uint16, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "vlan-id-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['min', 'max', 'mask'], name, value)


                                                                                            class VlanInr(Entity):
                                                                                                """
                                                                                                Match inner header VLAN range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                    self.yang_name = "vlan-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FrDlci(Entity):
                                                                                                """
                                                                                                Match FR DLCI range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                    self.yang_name = "fr-dlci"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "fr-dlci"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class SrcMac(Entity):
                                                                                                """
                                                                                                Match Source MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                    self.yang_name = "src-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.mac_addr = []
                                                                                                    self.mask = []
                                                                                                    self._segment_path = lambda: "src-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                            class DstMac(Entity):
                                                                                                """
                                                                                                Match Destination MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                    self.yang_name = "dst-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.mac_addr = []
                                                                                                    self.mask = []
                                                                                                    self._segment_path = lambda: "dst-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                            class AtmClp(Entity):
                                                                                                """
                                                                                                Match ATM CLP level
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                    self.yang_name = "atm-clp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "atm-clp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                            class FrDe(Entity):
                                                                                                """
                                                                                                Match FR DE value
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                    self.yang_name = "fr-de"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "fr-de"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                            class Ipv4Acl(Entity):
                                                                                                """
                                                                                                IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                    self.yang_name = "ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ipv4-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                            class Ipv6Acl(Entity):
                                                                                                """
                                                                                                IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                    self.yang_name = "ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ipv6-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                            class EtherServiceAcl(Entity):
                                                                                                """
                                                                                                Ethernet\-Services Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                    self.yang_name = "ether-service-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ether-service-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                            class AvailId(Entity):
                                                                                                """
                                                                                                Available Identifiers
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                    self.yang_name = "avail-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "avail-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                            class MediaType(Entity):
                                                                                                """
                                                                                                Media Type
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                    self.yang_name = "media-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "media-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                            class SubsProtocol(Entity):
                                                                                                """
                                                                                                Protocol
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                    self.yang_name = "subs-protocol"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "subs-protocol"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                            class Dnis(Entity):
                                                                                                """
                                                                                                DNIS
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                    self.yang_name = "dnis"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dnis"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                            class DnisRegex(Entity):
                                                                                                """
                                                                                                DNIS Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                    self.yang_name = "dnis-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dnis-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                            class Domain(Entity):
                                                                                                """
                                                                                                Domain Name
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                    self.yang_name = "domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                        ])
                                                                                                        self.domain_name = None
                                                                                                        self.format_name = None
                                                                                                        self._segment_path = lambda: "domain-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class DomainRegex(Entity):
                                                                                                """
                                                                                                Domain Regular Expression
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                    self.yang_name = "domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain-regex"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                        ])
                                                                                                        self.domain_name = None
                                                                                                        self.format_name = None
                                                                                                        self._segment_path = lambda: "domain-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class NasPort(Entity):
                                                                                                """
                                                                                                NAS Port
                                                                                                
                                                                                                .. attribute:: nas_port_array
                                                                                                
                                                                                                	nas port array
                                                                                                	**type**\: list of  		 :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                    self.yang_name = "nas-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("nas-port-array", ("nas_port_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.nas_port_array = YList(self)
                                                                                                    self._segment_path = lambda: "nas-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                                class NasPortArray(Entity):
                                                                                                    """
                                                                                                    nas port array
                                                                                                    
                                                                                                    .. attribute:: sub_id
                                                                                                    
                                                                                                    	sub id
                                                                                                    	**type**\:  :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                    
                                                                                                    .. attribute:: operator
                                                                                                    
                                                                                                    	operator
                                                                                                    	**type**\:  :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	value
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                        self.yang_name = "nas-port-array"
                                                                                                        self.yang_parent_name = "nas-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('sub_id', (YLeaf(YType.enumeration, 'sub-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchNasPortSubIdEn', '')])),
                                                                                                            ('operator', (YLeaf(YType.enumeration, 'operator'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchLogicalOperatorEn', '')])),
                                                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                                        ])
                                                                                                        self.sub_id = None
                                                                                                        self.operator = None
                                                                                                        self.value = None
                                                                                                        self._segment_path = lambda: "nas-port-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['sub_id', 'operator', 'value'], name, value)


                                                                                            class ServiceName(Entity):
                                                                                                """
                                                                                                Service Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                    self.yang_name = "service-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "service-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                            class ServiceNameRegex(Entity):
                                                                                                """
                                                                                                Service Name Regular Exp
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                    self.yang_name = "service-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "service-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                            class SrcAddrIpv4(Entity):
                                                                                                """
                                                                                                Source Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class DstAddrIpv4(Entity):
                                                                                                """
                                                                                                Destination Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class SrcAddrIpv6(Entity):
                                                                                                """
                                                                                                Source Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class DstAddrIpv6(Entity):
                                                                                                """
                                                                                                Destination Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class SrcAddrMac(Entity):
                                                                                                """
                                                                                                Source Address MAC
                                                                                                
                                                                                                .. attribute:: mac_addr_array
                                                                                                
                                                                                                	mac addr array
                                                                                                	**type**\: list of  		 :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                    self.yang_name = "src-addr-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("mac-addr-array", ("mac_addr_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.mac_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                                class MacAddrArray(Entity):
                                                                                                    """
                                                                                                    mac addr array
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                        self.yang_name = "mac-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                            ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.mac_addr = []
                                                                                                        self.mask = []
                                                                                                        self._segment_path = lambda: "mac-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                            class Timer(Entity):
                                                                                                """
                                                                                                Timer
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                    self.yang_name = "timer"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "timer"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                            class TimerRegexp(Entity):
                                                                                                """
                                                                                                Timer Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                    self.yang_name = "timer-regexp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "timer-regexp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                            class TunnelName(Entity):
                                                                                                """
                                                                                                Tunnel Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                    self.yang_name = "tunnel-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "tunnel-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                            class TunnelNameRegex(Entity):
                                                                                                """
                                                                                                Tunnel Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "tunnel-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                            class UserName(Entity):
                                                                                                """
                                                                                                User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                    self.yang_name = "user-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "user-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                            class UserNameRegex(Entity):
                                                                                                """
                                                                                                User Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                    self.yang_name = "user-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "user-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                            class AuthUsername(Entity):
                                                                                                """
                                                                                                Authenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                    self.yang_name = "auth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-username"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                            class AuthUsernameRegex(Entity):
                                                                                                """
                                                                                                Authenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "auth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-username-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                            class UnauthUsername(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                    self.yang_name = "unauth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-username"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                            class UnauthUsernameRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-username-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                            class AuthDomain(Entity):
                                                                                                """
                                                                                                Authenticated domain name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                    self.yang_name = "auth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                            class AuthDomainRegex(Entity):
                                                                                                """
                                                                                                Authenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "auth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                            class UnauthDomain(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                    self.yang_name = "unauth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                            class UnauthDomainRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                            class VendorId(Entity):
                                                                                                """
                                                                                                Vendor ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                    self.yang_name = "vendor-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "vendor-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                            class VendorIdRegex(Entity):
                                                                                                """
                                                                                                Vendor ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                    self.yang_name = "vendor-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "vendor-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                            class AccessInterface(Entity):
                                                                                                """
                                                                                                Access interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                    self.yang_name = "access-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "access-interface"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                            class InputInterface(Entity):
                                                                                                """
                                                                                                Input interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                    self.yang_name = "input-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "input-interface"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                            class InputIntfhdl(Entity):
                                                                                                """
                                                                                                Input interface handle
                                                                                                
                                                                                                .. attribute:: uint64_array
                                                                                                
                                                                                                	uint64 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..18446744073709551615
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                    self.yang_name = "input-intfhdl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint64_array', (YLeafList(YType.uint64, 'uint64_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint64_array = []
                                                                                                    self._segment_path = lambda: "input-intfhdl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                            class Ethertype(Entity):
                                                                                                """
                                                                                                Ethernet type
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                    self.yang_name = "ethertype"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ethertype"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ethertype"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FlowKeyData(Entity):
                                                                                                """
                                                                                                Flow key structure
                                                                                                
                                                                                                .. attribute:: flow_keys
                                                                                                
                                                                                                	flow keys
                                                                                                	**type**\:  :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                                
                                                                                                .. attribute:: max_count
                                                                                                
                                                                                                	Maximum count of flows
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: idle_timeout
                                                                                                
                                                                                                	Idle timeout of flows (in seconds)
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                	**units**\: second
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                    self.yang_name = "flow-key-data"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("flow-keys", ("flow_keys", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys))])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('max_count', (YLeaf(YType.uint16, 'max-count'), ['int'])),
                                                                                                        ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                                                    ])
                                                                                                    self.max_count = None
                                                                                                    self.idle_timeout = None

                                                                                                    self.flow_keys = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                    self.flow_keys.parent = self
                                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                    self._segment_path = lambda: "flow-key-data"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['max_count', 'idle_timeout'], name, value)


                                                                                                class FlowKeys(Entity):
                                                                                                    """
                                                                                                    flow keys
                                                                                                    
                                                                                                    .. attribute:: keys
                                                                                                    
                                                                                                    	keys
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                    
                                                                                                    .. attribute:: num
                                                                                                    
                                                                                                    	num
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                        self.yang_name = "flow-keys"
                                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('keys', (YLeaf(YType.str, 'keys'), ['str'])),
                                                                                                            ('num', (YLeaf(YType.uint8, 'num'), ['int'])),
                                                                                                        ])
                                                                                                        self.keys = None
                                                                                                        self.num = None
                                                                                                        self._segment_path = lambda: "flow-keys"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                            class DhcpClientId(Entity):
                                                                                                """
                                                                                                Dhcp Client ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dhcp-client-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                            class DhcpClientIdRegex(Entity):
                                                                                                """
                                                                                                Dhcp Client ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                            class CircuitId(Entity):
                                                                                                """
                                                                                                Circuit ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                    self.yang_name = "circuit-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "circuit-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                            class CircuitIdRegex(Entity):
                                                                                                """
                                                                                                Circuit ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                    self.yang_name = "circuit-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "circuit-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                            class RemoteId(Entity):
                                                                                                """
                                                                                                Remote ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                    self.yang_name = "remote-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "remote-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                            class RemoteIdRegex(Entity):
                                                                                                """
                                                                                                Remote ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                    self.yang_name = "remote-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "remote-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                            class SrcPort(Entity):
                                                                                                """
                                                                                                Source port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                    self.yang_name = "src-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "src-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class DstPort(Entity):
                                                                                                """
                                                                                                Destination port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                    self.yang_name = "dst-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "dst-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                        class ExcdclassEncode(Entity):
                                                                            """
                                                                            excdclass encode
                                                                            
                                                                            .. attribute:: inline_cmap
                                                                            
                                                                            	inline cmap
                                                                            	**type**\:  :py:class:`InlineCmap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap>`
                                                                            
                                                                            .. attribute:: enc
                                                                            
                                                                            	enc
                                                                            	**type**\:  :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                            
                                                                            .. attribute:: class_name
                                                                            
                                                                            	class name
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..65
                                                                            
                                                                            .. attribute:: hd
                                                                            
                                                                            	hd
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: idx
                                                                            
                                                                            	idx
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode, self).__init__()

                                                                                self.yang_name = "excdclass-encode"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("inline-cmap", ("inline_cmap", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('enc', (YLeaf(YType.enumeration, 'enc'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyObjEncEn', '')])),
                                                                                    ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                                                    ('hd', (YLeaf(YType.uint64, 'hd'), ['int'])),
                                                                                    ('idx', (YLeaf(YType.uint8, 'idx'), ['int'])),
                                                                                ])
                                                                                self.enc = None
                                                                                self.class_name = None
                                                                                self.hd = None
                                                                                self.idx = None

                                                                                self.inline_cmap = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap()
                                                                                self.inline_cmap.parent = self
                                                                                self._children_name_map["inline_cmap"] = "inline-cmap"
                                                                                self._segment_path = lambda: "excdclass-encode"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode, ['enc', 'class_name', 'hd', 'idx'], name, value)


                                                                            class InlineCmap(Entity):
                                                                                """
                                                                                inline cmap
                                                                                
                                                                                .. attribute:: match_infop
                                                                                
                                                                                	Pointer to the first Match info
                                                                                	**type**\:  :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop>`
                                                                                
                                                                                .. attribute:: mode
                                                                                
                                                                                	Inline Class\-Map Mode Match any/all
                                                                                	**type**\:  :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                                
                                                                                .. attribute:: flags
                                                                                
                                                                                	Inline Class\-Map flags
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: match_count
                                                                                
                                                                                	Number of Match infos
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap, self).__init__()

                                                                                    self.yang_name = "inline-cmap"
                                                                                    self.yang_parent_name = "excdclass-encode"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("match-infop", ("match_infop", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapModeEn', '')])),
                                                                                        ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                        ('match_count', (YLeaf(YType.uint32, 'match-count'), ['int'])),
                                                                                    ])
                                                                                    self.mode = None
                                                                                    self.flags = None
                                                                                    self.match_count = None

                                                                                    self.match_infop = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop()
                                                                                    self.match_infop.parent = self
                                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                                    self._segment_path = lambda: "inline-cmap"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap, ['mode', 'flags', 'match_count'], name, value)


                                                                                class MatchInfop(Entity):
                                                                                    """
                                                                                    Pointer to the first Match info
                                                                                    
                                                                                    .. attribute:: class_match_info_st
                                                                                    
                                                                                    	class match info st
                                                                                    	**type**\: list of  		 :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop, self).__init__()

                                                                                        self.yang_name = "match-infop"
                                                                                        self.yang_parent_name = "inline-cmap"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("class-match-info-st", ("class_match_info_st", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.class_match_info_st = YList(self)
                                                                                        self._segment_path = lambda: "match-infop"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop, [], name, value)


                                                                                    class ClassMatchInfoSt(Entity):
                                                                                        """
                                                                                        class match info st
                                                                                        
                                                                                        .. attribute:: match_data
                                                                                        
                                                                                        	Match criteria
                                                                                        	**type**\:  :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                        
                                                                                        .. attribute:: flags
                                                                                        
                                                                                        	Flags
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                            self.yang_name = "class-match-info-st"
                                                                                            self.yang_parent_name = "match-infop"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("match-data", ("match_data", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData))])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                            ])
                                                                                            self.flags = None

                                                                                            self.match_data = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                            self.match_data.parent = self
                                                                                            self._children_name_map["match_data"] = "match-data"
                                                                                            self._segment_path = lambda: "class-match-info-st"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                        class MatchData(Entity):
                                                                                            """
                                                                                            Match criteria
                                                                                            
                                                                                            .. attribute:: ipv4_dscp
                                                                                            
                                                                                            	IPv4 DSCP
                                                                                            	**type**\:  :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv6_dscp
                                                                                            
                                                                                            	IPv6 DSCP
                                                                                            	**type**\:  :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                            
                                                                                            .. attribute:: dscp
                                                                                            
                                                                                            	Match DSCP range array
                                                                                            	**type**\:  :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv4_prec
                                                                                            
                                                                                            	IPv4 Precedence
                                                                                            	**type**\:  :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                            
                                                                                            .. attribute:: ipv6_prec
                                                                                            
                                                                                            	IPv6 Precedence
                                                                                            	**type**\:  :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                            
                                                                                            .. attribute:: prec
                                                                                            
                                                                                            	Match Precedence array
                                                                                            	**type**\:  :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                            
                                                                                            .. attribute:: discard_class
                                                                                            
                                                                                            	Match Discard Class array
                                                                                            	**type**\:  :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                            
                                                                                            .. attribute:: qos_group
                                                                                            
                                                                                            	Match QoS group array
                                                                                            	**type**\:  :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                            
                                                                                            .. attribute:: traffic_class
                                                                                            
                                                                                            	Match Traffic class array
                                                                                            	**type**\:  :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                            
                                                                                            .. attribute:: proto
                                                                                            
                                                                                            	Match Protocol array
                                                                                            	**type**\:  :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                            
                                                                                            .. attribute:: icmp_v4
                                                                                            
                                                                                            	Match ICMPV4 Protocol
                                                                                            	**type**\:  :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                            
                                                                                            .. attribute:: icmp_v6
                                                                                            
                                                                                            	Match ICMPV6 Protocol array
                                                                                            	**type**\:  :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                            
                                                                                            .. attribute:: ipv4_packet_len
                                                                                            
                                                                                            	IPv4 packet length array
                                                                                            	**type**\:  :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv6_packet_len
                                                                                            
                                                                                            	IPv6 packet length array
                                                                                            	**type**\:  :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                            
                                                                                            .. attribute:: packet_len
                                                                                            
                                                                                            	Match packet length array
                                                                                            	**type**\:  :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                            
                                                                                            .. attribute:: flow_tag
                                                                                            
                                                                                            	Match flow\-tag array
                                                                                            	**type**\:  :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                            
                                                                                            .. attribute:: tcp_flag
                                                                                            
                                                                                            	Match tcp flag value
                                                                                            	**type**\:  :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                            
                                                                                            .. attribute:: icmpv4_type
                                                                                            
                                                                                            	Match ipv4 icmp type
                                                                                            	**type**\:  :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                            
                                                                                            .. attribute:: icmpv4_code
                                                                                            
                                                                                            	Match ipv4 icmp code
                                                                                            	**type**\:  :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                            
                                                                                            .. attribute:: icmpv6_type
                                                                                            
                                                                                            	Match ipv6 icmp type
                                                                                            	**type**\:  :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                            
                                                                                            .. attribute:: icmpv6_code
                                                                                            
                                                                                            	Match ipv6 icmp code
                                                                                            	**type**\:  :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                            
                                                                                            .. attribute:: mpls_exp
                                                                                            
                                                                                            	Match MPLS experimental topmost array
                                                                                            	**type**\:  :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                            
                                                                                            .. attribute:: mpls_exp_imp
                                                                                            
                                                                                            	Match MPLS experimental imposition array
                                                                                            	**type**\:  :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                                            
                                                                                            	MPLS Disposition IPv4 Access\-list
                                                                                            	**type**\:  :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                                            
                                                                                            	MPLS Disposition IPv6 Access\-list
                                                                                            	**type**\:  :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_top_label
                                                                                            
                                                                                            	MPLS Topmost LABEL
                                                                                            	**type**\:  :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                            
                                                                                            .. attribute:: cos
                                                                                            
                                                                                            	Match CoS array
                                                                                            	**type**\:  :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                            
                                                                                            .. attribute:: cos_inr
                                                                                            
                                                                                            	Match inner header CoS
                                                                                            	**type**\:  :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                            
                                                                                            .. attribute:: dei
                                                                                            
                                                                                            	Match DEI Bit
                                                                                            	**type**\:  :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                            
                                                                                            .. attribute:: dei_inr
                                                                                            
                                                                                            	Match inner DEI Bit
                                                                                            	**type**\:  :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                            
                                                                                            .. attribute:: vlan
                                                                                            
                                                                                            	Match VLAN array
                                                                                            	**type**\:  :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                            
                                                                                            .. attribute:: vlan_inr
                                                                                            
                                                                                            	Match inner header VLAN range array
                                                                                            	**type**\:  :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                            
                                                                                            .. attribute:: fr_dlci
                                                                                            
                                                                                            	Match FR DLCI range array
                                                                                            	**type**\:  :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                            
                                                                                            .. attribute:: src_mac
                                                                                            
                                                                                            	Match Source MAC address
                                                                                            	**type**\:  :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                            
                                                                                            .. attribute:: dst_mac
                                                                                            
                                                                                            	Match Destination MAC address
                                                                                            	**type**\:  :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                            
                                                                                            .. attribute:: atm_clp
                                                                                            
                                                                                            	Match ATM CLP level
                                                                                            	**type**\:  :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                            
                                                                                            .. attribute:: fr_de
                                                                                            
                                                                                            	Match FR DE value
                                                                                            	**type**\:  :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                            
                                                                                            .. attribute:: ipv4_acl
                                                                                            
                                                                                            	IPv4 Access\-list
                                                                                            	**type**\:  :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                            
                                                                                            .. attribute:: ipv6_acl
                                                                                            
                                                                                            	IPv6 Access\-list
                                                                                            	**type**\:  :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                            
                                                                                            .. attribute:: ether_service_acl
                                                                                            
                                                                                            	Ethernet\-Services Access\-list
                                                                                            	**type**\:  :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                            
                                                                                            .. attribute:: avail_id
                                                                                            
                                                                                            	Available Identifiers
                                                                                            	**type**\:  :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                            
                                                                                            .. attribute:: media_type
                                                                                            
                                                                                            	Media Type
                                                                                            	**type**\:  :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                            
                                                                                            .. attribute:: subs_protocol
                                                                                            
                                                                                            	Protocol
                                                                                            	**type**\:  :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                            
                                                                                            .. attribute:: dnis
                                                                                            
                                                                                            	DNIS
                                                                                            	**type**\:  :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                            
                                                                                            .. attribute:: dnis_regex
                                                                                            
                                                                                            	DNIS Regular Expression
                                                                                            	**type**\:  :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                            
                                                                                            .. attribute:: domain
                                                                                            
                                                                                            	Domain Name
                                                                                            	**type**\:  :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                            
                                                                                            .. attribute:: domain_regex
                                                                                            
                                                                                            	Domain Regular Expression
                                                                                            	**type**\:  :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                            
                                                                                            .. attribute:: nas_port
                                                                                            
                                                                                            	NAS Port
                                                                                            	**type**\:  :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                            
                                                                                            .. attribute:: service_name
                                                                                            
                                                                                            	Service Name
                                                                                            	**type**\:  :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                            
                                                                                            .. attribute:: service_name_regex
                                                                                            
                                                                                            	Service Name Regular Exp
                                                                                            	**type**\:  :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv4
                                                                                            
                                                                                            	Source Address IPV4
                                                                                            	**type**\:  :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv4
                                                                                            
                                                                                            	Destination Address IPV4
                                                                                            	**type**\:  :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv6
                                                                                            
                                                                                            	Source Address IPV6
                                                                                            	**type**\:  :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv6
                                                                                            
                                                                                            	Destination Address IPV6
                                                                                            	**type**\:  :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: src_addr_mac
                                                                                            
                                                                                            	Source Address MAC
                                                                                            	**type**\:  :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                            
                                                                                            .. attribute:: timer
                                                                                            
                                                                                            	Timer
                                                                                            	**type**\:  :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                            
                                                                                            .. attribute:: timer_regexp
                                                                                            
                                                                                            	Timer Regular Expression
                                                                                            	**type**\:  :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                            
                                                                                            .. attribute:: tunnel_name
                                                                                            
                                                                                            	Tunnel Name
                                                                                            	**type**\:  :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                            
                                                                                            .. attribute:: tunnel_name_regex
                                                                                            
                                                                                            	Tunnel Name Regular Expression
                                                                                            	**type**\:  :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                            
                                                                                            .. attribute:: user_name
                                                                                            
                                                                                            	User Name
                                                                                            	**type**\:  :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                            
                                                                                            .. attribute:: user_name_regex
                                                                                            
                                                                                            	User Name Regular Expression
                                                                                            	**type**\:  :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                            
                                                                                            .. attribute:: auth_username
                                                                                            
                                                                                            	Authenticated User Name
                                                                                            	**type**\:  :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                            
                                                                                            .. attribute:: auth_username_regex
                                                                                            
                                                                                            	Authenticated User Name RegEx
                                                                                            	**type**\:  :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_username
                                                                                            
                                                                                            	Unauthenticated User Name
                                                                                            	**type**\:  :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                            
                                                                                            .. attribute:: unauth_username_regex
                                                                                            
                                                                                            	Unauthenticated User Name RegEx
                                                                                            	**type**\:  :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: auth_domain
                                                                                            
                                                                                            	Authenticated domain name
                                                                                            	**type**\:  :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                            
                                                                                            .. attribute:: auth_domain_regex
                                                                                            
                                                                                            	Authenticated Domain Name RegEx
                                                                                            	**type**\:  :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_domain
                                                                                            
                                                                                            	Unauthenticated Domain Name
                                                                                            	**type**\:  :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                            
                                                                                            .. attribute:: unauth_domain_regex
                                                                                            
                                                                                            	Unauthenticated Domain Name RegEx
                                                                                            	**type**\:  :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: vendor_id
                                                                                            
                                                                                            	Vendor ID
                                                                                            	**type**\:  :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                            
                                                                                            .. attribute:: vendor_id_regex
                                                                                            
                                                                                            	Vendor ID RegEx
                                                                                            	**type**\:  :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                            
                                                                                            .. attribute:: access_interface
                                                                                            
                                                                                            	Access interface
                                                                                            	**type**\:  :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                            
                                                                                            .. attribute:: input_interface
                                                                                            
                                                                                            	Input interface
                                                                                            	**type**\:  :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                            
                                                                                            .. attribute:: input_intfhdl
                                                                                            
                                                                                            	Input interface handle
                                                                                            	**type**\:  :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                            
                                                                                            .. attribute:: ethertype
                                                                                            
                                                                                            	Ethernet type
                                                                                            	**type**\:  :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                            
                                                                                            .. attribute:: flow_key_data
                                                                                            
                                                                                            	Flow key structure
                                                                                            	**type**\:  :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id
                                                                                            
                                                                                            	Dhcp Client ID
                                                                                            	**type**\:  :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id_regex
                                                                                            
                                                                                            	Dhcp Client ID RegEx
                                                                                            	**type**\:  :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                            
                                                                                            .. attribute:: circuit_id
                                                                                            
                                                                                            	Circuit ID
                                                                                            	**type**\:  :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                            
                                                                                            .. attribute:: circuit_id_regex
                                                                                            
                                                                                            	Circuit ID RegEx
                                                                                            	**type**\:  :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                            
                                                                                            .. attribute:: remote_id
                                                                                            
                                                                                            	Remote ID
                                                                                            	**type**\:  :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                            
                                                                                            .. attribute:: remote_id_regex
                                                                                            
                                                                                            	Remote ID RegEx
                                                                                            	**type**\:  :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                            
                                                                                            .. attribute:: src_port
                                                                                            
                                                                                            	Source port
                                                                                            	**type**\:  :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                            
                                                                                            .. attribute:: dst_port
                                                                                            
                                                                                            	Destination port
                                                                                            	**type**\:  :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	type
                                                                                            	**type**\:  :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                            
                                                                                            .. attribute:: mpls_top_eos
                                                                                            
                                                                                            	MPLS Topmost EOS
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: fragment_type
                                                                                            
                                                                                            	Fragment type
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: authen_status
                                                                                            
                                                                                            	Authentication Status
                                                                                            	**type**\:  :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                            
                                                                                            .. attribute:: mlp_negotiated
                                                                                            
                                                                                            	MLP Negotiated
                                                                                            	**type**\:  :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                                self.yang_name = "match-data"
                                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("ipv4-dscp", ("ipv4_dscp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp)), ("ipv6-dscp", ("ipv6_dscp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp)), ("dscp", ("dscp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp)), ("ipv4-prec", ("ipv4_prec", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec)), ("ipv6-prec", ("ipv6_prec", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec)), ("prec", ("prec", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec)), ("discard-class", ("discard_class", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass)), ("qos-group", ("qos_group", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup)), ("traffic-class", ("traffic_class", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass)), ("proto", ("proto", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto)), ("icmp-v4", ("icmp_v4", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4)), ("icmp-v6", ("icmp_v6", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6)), ("ipv4-packet-len", ("ipv4_packet_len", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen)), ("ipv6-packet-len", ("ipv6_packet_len", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen)), ("packet-len", ("packet_len", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen)), ("flow-tag", ("flow_tag", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag)), ("tcp-flag", ("tcp_flag", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag)), ("icmpv4-type", ("icmpv4_type", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type)), ("icmpv4-code", ("icmpv4_code", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code)), ("icmpv6-type", ("icmpv6_type", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type)), ("icmpv6-code", ("icmpv6_code", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code)), ("mpls-exp", ("mpls_exp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp)), ("mpls-exp-imp", ("mpls_exp_imp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp)), ("mpls-disp-ipv4-acl", ("mpls_disp_ipv4_acl", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl)), ("mpls-disp-ipv6-acl", ("mpls_disp_ipv6_acl", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl)), ("mpls-top-label", ("mpls_top_label", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel)), ("cos", ("cos", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos)), ("cos-inr", ("cos_inr", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr)), ("dei", ("dei", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei)), ("dei-inr", ("dei_inr", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr)), ("vlan", ("vlan", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan)), ("vlan-inr", ("vlan_inr", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)), ("fr-dlci", ("fr_dlci", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci)), ("src-mac", ("src_mac", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac)), ("dst-mac", ("dst_mac", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac)), ("atm-clp", ("atm_clp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp)), ("fr-de", ("fr_de", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe)), ("ipv4-acl", ("ipv4_acl", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl)), ("ipv6-acl", ("ipv6_acl", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl)), ("ether-service-acl", ("ether_service_acl", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl)), ("avail-id", ("avail_id", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId)), ("media-type", ("media_type", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType)), ("subs-protocol", ("subs_protocol", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol)), ("dnis", ("dnis", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis)), ("dnis-regex", ("dnis_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex)), ("domain", ("domain", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain)), ("domain-regex", ("domain_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex)), ("nas-port", ("nas_port", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort)), ("service-name", ("service_name", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName)), ("service-name-regex", ("service_name_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex)), ("src-addr-ipv4", ("src_addr_ipv4", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4)), ("dst-addr-ipv4", ("dst_addr_ipv4", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4)), ("src-addr-ipv6", ("src_addr_ipv6", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6)), ("dst-addr-ipv6", ("dst_addr_ipv6", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6)), ("src-addr-mac", ("src_addr_mac", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac)), ("timer", ("timer", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer)), ("timer-regexp", ("timer_regexp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp)), ("tunnel-name", ("tunnel_name", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName)), ("tunnel-name-regex", ("tunnel_name_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex)), ("user-name", ("user_name", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName)), ("user-name-regex", ("user_name_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex)), ("auth-username", ("auth_username", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername)), ("auth-username-regex", ("auth_username_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex)), ("unauth-username", ("unauth_username", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername)), ("unauth-username-regex", ("unauth_username_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex)), ("auth-domain", ("auth_domain", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain)), ("auth-domain-regex", ("auth_domain_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex)), ("unauth-domain", ("unauth_domain", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain)), ("unauth-domain-regex", ("unauth_domain_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex)), ("vendor-id", ("vendor_id", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId)), ("vendor-id-regex", ("vendor_id_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex)), ("access-interface", ("access_interface", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface)), ("input-interface", ("input_interface", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface)), ("input-intfhdl", ("input_intfhdl", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl)), ("ethertype", ("ethertype", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype)), ("flow-key-data", ("flow_key_data", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData)), ("dhcp-client-id", ("dhcp_client_id", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId)), ("dhcp-client-id-regex", ("dhcp_client_id_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex)), ("circuit-id", ("circuit_id", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId)), ("circuit-id-regex", ("circuit_id_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex)), ("remote-id", ("remote_id", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId)), ("remote-id-regex", ("remote_id_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex)), ("src-port", ("src_port", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort)), ("dst-port", ("dst_port", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort))])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchTypeEn', '')])),
                                                                                                    ('mpls_top_eos', (YLeaf(YType.uint8, 'mpls-top-eos'), ['int'])),
                                                                                                    ('fragment_type', (YLeaf(YType.uint8, 'fragment-type'), ['int'])),
                                                                                                    ('authen_status', (YLeaf(YType.enumeration, 'authen-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchAuthenStatusEn', '')])),
                                                                                                    ('mlp_negotiated', (YLeaf(YType.enumeration, 'mlp-negotiated'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchMlpNegotiatedEn', '')])),
                                                                                                ])
                                                                                                self.type = None
                                                                                                self.mpls_top_eos = None
                                                                                                self.fragment_type = None
                                                                                                self.authen_status = None
                                                                                                self.mlp_negotiated = None

                                                                                                self.ipv4_dscp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                                self.ipv4_dscp.parent = self
                                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"

                                                                                                self.ipv6_dscp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                                self.ipv6_dscp.parent = self
                                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"

                                                                                                self.dscp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                                self.dscp.parent = self
                                                                                                self._children_name_map["dscp"] = "dscp"

                                                                                                self.ipv4_prec = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                                self.ipv4_prec.parent = self
                                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"

                                                                                                self.ipv6_prec = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                                self.ipv6_prec.parent = self
                                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"

                                                                                                self.prec = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                                self.prec.parent = self
                                                                                                self._children_name_map["prec"] = "prec"

                                                                                                self.discard_class = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                                self.discard_class.parent = self
                                                                                                self._children_name_map["discard_class"] = "discard-class"

                                                                                                self.qos_group = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                                self.qos_group.parent = self
                                                                                                self._children_name_map["qos_group"] = "qos-group"

                                                                                                self.traffic_class = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                                self.traffic_class.parent = self
                                                                                                self._children_name_map["traffic_class"] = "traffic-class"

                                                                                                self.proto = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                                self.proto.parent = self
                                                                                                self._children_name_map["proto"] = "proto"

                                                                                                self.icmp_v4 = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                                self.icmp_v4.parent = self
                                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"

                                                                                                self.icmp_v6 = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                                self.icmp_v6.parent = self
                                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"

                                                                                                self.ipv4_packet_len = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                                self.ipv4_packet_len.parent = self
                                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"

                                                                                                self.ipv6_packet_len = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                                self.ipv6_packet_len.parent = self
                                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"

                                                                                                self.packet_len = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                                self.packet_len.parent = self
                                                                                                self._children_name_map["packet_len"] = "packet-len"

                                                                                                self.flow_tag = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                                self.flow_tag.parent = self
                                                                                                self._children_name_map["flow_tag"] = "flow-tag"

                                                                                                self.tcp_flag = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                                self.tcp_flag.parent = self
                                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"

                                                                                                self.icmpv4_type = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                                self.icmpv4_type.parent = self
                                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"

                                                                                                self.icmpv4_code = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                                self.icmpv4_code.parent = self
                                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"

                                                                                                self.icmpv6_type = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                                self.icmpv6_type.parent = self
                                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"

                                                                                                self.icmpv6_code = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                                self.icmpv6_code.parent = self
                                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"

                                                                                                self.mpls_exp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                                self.mpls_exp.parent = self
                                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"

                                                                                                self.mpls_exp_imp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                                self.mpls_exp_imp.parent = self
                                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"

                                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"

                                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"

                                                                                                self.mpls_top_label = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                                self.mpls_top_label.parent = self
                                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"

                                                                                                self.cos = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                                self.cos.parent = self
                                                                                                self._children_name_map["cos"] = "cos"

                                                                                                self.cos_inr = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                                self.cos_inr.parent = self
                                                                                                self._children_name_map["cos_inr"] = "cos-inr"

                                                                                                self.dei = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                                self.dei.parent = self
                                                                                                self._children_name_map["dei"] = "dei"

                                                                                                self.dei_inr = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                                self.dei_inr.parent = self
                                                                                                self._children_name_map["dei_inr"] = "dei-inr"

                                                                                                self.vlan = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                                self.vlan.parent = self
                                                                                                self._children_name_map["vlan"] = "vlan"

                                                                                                self.vlan_inr = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                                self.vlan_inr.parent = self
                                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"

                                                                                                self.fr_dlci = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                                self.fr_dlci.parent = self
                                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"

                                                                                                self.src_mac = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                                self.src_mac.parent = self
                                                                                                self._children_name_map["src_mac"] = "src-mac"

                                                                                                self.dst_mac = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                                self.dst_mac.parent = self
                                                                                                self._children_name_map["dst_mac"] = "dst-mac"

                                                                                                self.atm_clp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                                self.atm_clp.parent = self
                                                                                                self._children_name_map["atm_clp"] = "atm-clp"

                                                                                                self.fr_de = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                                self.fr_de.parent = self
                                                                                                self._children_name_map["fr_de"] = "fr-de"

                                                                                                self.ipv4_acl = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                                self.ipv4_acl.parent = self
                                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"

                                                                                                self.ipv6_acl = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                                self.ipv6_acl.parent = self
                                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"

                                                                                                self.ether_service_acl = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                                self.ether_service_acl.parent = self
                                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"

                                                                                                self.avail_id = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                                self.avail_id.parent = self
                                                                                                self._children_name_map["avail_id"] = "avail-id"

                                                                                                self.media_type = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                                self.media_type.parent = self
                                                                                                self._children_name_map["media_type"] = "media-type"

                                                                                                self.subs_protocol = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                                self.subs_protocol.parent = self
                                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"

                                                                                                self.dnis = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                                self.dnis.parent = self
                                                                                                self._children_name_map["dnis"] = "dnis"

                                                                                                self.dnis_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                                self.dnis_regex.parent = self
                                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"

                                                                                                self.domain = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                                self.domain.parent = self
                                                                                                self._children_name_map["domain"] = "domain"

                                                                                                self.domain_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                                self.domain_regex.parent = self
                                                                                                self._children_name_map["domain_regex"] = "domain-regex"

                                                                                                self.nas_port = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                                self.nas_port.parent = self
                                                                                                self._children_name_map["nas_port"] = "nas-port"

                                                                                                self.service_name = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                                self.service_name.parent = self
                                                                                                self._children_name_map["service_name"] = "service-name"

                                                                                                self.service_name_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                                self.service_name_regex.parent = self
                                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"

                                                                                                self.src_addr_ipv4 = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                                self.src_addr_ipv4.parent = self
                                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"

                                                                                                self.dst_addr_ipv4 = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                                self.dst_addr_ipv4.parent = self
                                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"

                                                                                                self.src_addr_ipv6 = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                                self.src_addr_ipv6.parent = self
                                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"

                                                                                                self.dst_addr_ipv6 = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                                self.dst_addr_ipv6.parent = self
                                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"

                                                                                                self.src_addr_mac = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                                self.src_addr_mac.parent = self
                                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"

                                                                                                self.timer = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                                self.timer.parent = self
                                                                                                self._children_name_map["timer"] = "timer"

                                                                                                self.timer_regexp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                                self.timer_regexp.parent = self
                                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"

                                                                                                self.tunnel_name = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                                self.tunnel_name.parent = self
                                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"

                                                                                                self.tunnel_name_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                                self.tunnel_name_regex.parent = self
                                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"

                                                                                                self.user_name = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                                self.user_name.parent = self
                                                                                                self._children_name_map["user_name"] = "user-name"

                                                                                                self.user_name_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                                self.user_name_regex.parent = self
                                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"

                                                                                                self.auth_username = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                                self.auth_username.parent = self
                                                                                                self._children_name_map["auth_username"] = "auth-username"

                                                                                                self.auth_username_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                                self.auth_username_regex.parent = self
                                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"

                                                                                                self.unauth_username = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                                self.unauth_username.parent = self
                                                                                                self._children_name_map["unauth_username"] = "unauth-username"

                                                                                                self.unauth_username_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                                self.unauth_username_regex.parent = self
                                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"

                                                                                                self.auth_domain = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                                self.auth_domain.parent = self
                                                                                                self._children_name_map["auth_domain"] = "auth-domain"

                                                                                                self.auth_domain_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                                self.auth_domain_regex.parent = self
                                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"

                                                                                                self.unauth_domain = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                                self.unauth_domain.parent = self
                                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"

                                                                                                self.unauth_domain_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                                self.unauth_domain_regex.parent = self
                                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"

                                                                                                self.vendor_id = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                                self.vendor_id.parent = self
                                                                                                self._children_name_map["vendor_id"] = "vendor-id"

                                                                                                self.vendor_id_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                                self.vendor_id_regex.parent = self
                                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"

                                                                                                self.access_interface = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                                self.access_interface.parent = self
                                                                                                self._children_name_map["access_interface"] = "access-interface"

                                                                                                self.input_interface = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                                self.input_interface.parent = self
                                                                                                self._children_name_map["input_interface"] = "input-interface"

                                                                                                self.input_intfhdl = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                                self.input_intfhdl.parent = self
                                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"

                                                                                                self.ethertype = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                                self.ethertype.parent = self
                                                                                                self._children_name_map["ethertype"] = "ethertype"

                                                                                                self.flow_key_data = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                                self.flow_key_data.parent = self
                                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"

                                                                                                self.dhcp_client_id = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                                self.dhcp_client_id.parent = self
                                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"

                                                                                                self.dhcp_client_id_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                                self.dhcp_client_id_regex.parent = self
                                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"

                                                                                                self.circuit_id = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                                self.circuit_id.parent = self
                                                                                                self._children_name_map["circuit_id"] = "circuit-id"

                                                                                                self.circuit_id_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                                self.circuit_id_regex.parent = self
                                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"

                                                                                                self.remote_id = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                                self.remote_id.parent = self
                                                                                                self._children_name_map["remote_id"] = "remote-id"

                                                                                                self.remote_id_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                                self.remote_id_regex.parent = self
                                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"

                                                                                                self.src_port = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                                self.src_port.parent = self
                                                                                                self._children_name_map["src_port"] = "src-port"

                                                                                                self.dst_port = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                                self.dst_port.parent = self
                                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                                self._segment_path = lambda: "match-data"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, ['type', 'mpls_top_eos', 'fragment_type', 'authen_status', 'mlp_negotiated'], name, value)


                                                                                            class Ipv4Dscp(Entity):
                                                                                                """
                                                                                                IPv4 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv4-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv6Dscp(Entity):
                                                                                                """
                                                                                                IPv6 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv6-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Dscp(Entity):
                                                                                                """
                                                                                                Match DSCP range array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                    self.yang_name = "dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv4Prec(Entity):
                                                                                                """
                                                                                                IPv4 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                    self.yang_name = "ipv4-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "ipv4-prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                            class Ipv6Prec(Entity):
                                                                                                """
                                                                                                IPv6 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                    self.yang_name = "ipv6-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "ipv6-prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                            class Prec(Entity):
                                                                                                """
                                                                                                Match Precedence array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                    self.yang_name = "prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                            class DiscardClass(Entity):
                                                                                                """
                                                                                                Match Discard Class array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                    self.yang_name = "discard-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "discard-class"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                            class QosGroup(Entity):
                                                                                                """
                                                                                                Match QoS group array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                    self.yang_name = "qos-group"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "qos-group"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "qos-group"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class TrafficClass(Entity):
                                                                                                """
                                                                                                Match Traffic class array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                    self.yang_name = "traffic-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "traffic-class"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "traffic-class"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Proto(Entity):
                                                                                                """
                                                                                                Match Protocol array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                    self.yang_name = "proto"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "proto"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "proto"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class IcmpV4(Entity):
                                                                                                """
                                                                                                Match ICMPV4 Protocol
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                    self.yang_name = "icmp-v4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                    ])
                                                                                                    self.type = None
                                                                                                    self.code = None
                                                                                                    self._segment_path = lambda: "icmp-v4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['type', 'code'], name, value)


                                                                                            class IcmpV6(Entity):
                                                                                                """
                                                                                                Match ICMPV6 Protocol array
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                    self.yang_name = "icmp-v6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                    ])
                                                                                                    self.type = None
                                                                                                    self.code = None
                                                                                                    self._segment_path = lambda: "icmp-v6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['type', 'code'], name, value)


                                                                                            class Ipv4PacketLen(Entity):
                                                                                                """
                                                                                                IPv4 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv6PacketLen(Entity):
                                                                                                """
                                                                                                IPv6 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class PacketLen(Entity):
                                                                                                """
                                                                                                Match packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                    self.yang_name = "packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FlowTag(Entity):
                                                                                                """
                                                                                                Match flow\-tag array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                    self.yang_name = "flow-tag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "flow-tag"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "flow-tag"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class TcpFlag(Entity):
                                                                                                """
                                                                                                Match tcp flag value
                                                                                                
                                                                                                .. attribute:: value
                                                                                                
                                                                                                	Value of TCP flag
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: match_any
                                                                                                
                                                                                                	Match any TCP flag bit
                                                                                                	**type**\: bool
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                    self.yang_name = "tcp-flag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                                        ('match_any', (YLeaf(YType.boolean, 'match-any'), ['bool'])),
                                                                                                    ])
                                                                                                    self.value = None
                                                                                                    self.match_any = None
                                                                                                    self._segment_path = lambda: "tcp-flag"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['value', 'match_any'], name, value)


                                                                                            class Icmpv4Type(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                    self.yang_name = "icmpv4-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv4Code(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                    self.yang_name = "icmpv4-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-code"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv6Type(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                    self.yang_name = "icmpv6-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv6Code(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                    self.yang_name = "icmpv6-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-code"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class MplsExp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental topmost array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "mpls-exp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                            class MplsExpImp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental imposition array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "mpls-exp-imp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                            class MplsDispIpv4Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                            class MplsDispIpv6Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                            class MplsTopLabel(Entity):
                                                                                                """
                                                                                                MPLS Topmost LABEL
                                                                                                
                                                                                                .. attribute:: uint32_rng_array
                                                                                                
                                                                                                	uint32 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                    self.yang_name = "mpls-top-label"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint32_rng_array", ("uint32_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint32_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "mpls-top-label"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                                class Uint32RngArray(Entity):
                                                                                                    """
                                                                                                    uint32 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                        self.yang_name = "uint32_rng_array"
                                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint32, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint32, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint32_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['min', 'max'], name, value)


                                                                                            class Cos(Entity):
                                                                                                """
                                                                                                Match CoS array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                    self.yang_name = "cos"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "cos"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                            class CosInr(Entity):
                                                                                                """
                                                                                                Match inner header CoS
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                    self.yang_name = "cos-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "cos-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                            class Dei(Entity):
                                                                                                """
                                                                                                Match DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                    self.yang_name = "dei"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                    ])
                                                                                                    self.bit_value = None
                                                                                                    self._segment_path = lambda: "dei"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                            class DeiInr(Entity):
                                                                                                """
                                                                                                Match inner DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                    self.yang_name = "dei-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                    ])
                                                                                                    self.bit_value = None
                                                                                                    self._segment_path = lambda: "dei-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                            class Vlan(Entity):
                                                                                                """
                                                                                                Match VLAN array
                                                                                                
                                                                                                .. attribute:: vlan_id_array
                                                                                                
                                                                                                	vlan id array
                                                                                                	**type**\: list of  		 :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                    self.yang_name = "vlan"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("vlan-id-array", ("vlan_id_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.vlan_id_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                                class VlanIdArray(Entity):
                                                                                                    """
                                                                                                    vlan id array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	VLAN mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                        self.yang_name = "vlan-id-array"
                                                                                                        self.yang_parent_name = "vlan"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ('mask', (YLeaf(YType.uint16, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "vlan-id-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['min', 'max', 'mask'], name, value)


                                                                                            class VlanInr(Entity):
                                                                                                """
                                                                                                Match inner header VLAN range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                    self.yang_name = "vlan-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FrDlci(Entity):
                                                                                                """
                                                                                                Match FR DLCI range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                    self.yang_name = "fr-dlci"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "fr-dlci"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class SrcMac(Entity):
                                                                                                """
                                                                                                Match Source MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                    self.yang_name = "src-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.mac_addr = []
                                                                                                    self.mask = []
                                                                                                    self._segment_path = lambda: "src-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                            class DstMac(Entity):
                                                                                                """
                                                                                                Match Destination MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                    self.yang_name = "dst-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.mac_addr = []
                                                                                                    self.mask = []
                                                                                                    self._segment_path = lambda: "dst-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                            class AtmClp(Entity):
                                                                                                """
                                                                                                Match ATM CLP level
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                    self.yang_name = "atm-clp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "atm-clp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                            class FrDe(Entity):
                                                                                                """
                                                                                                Match FR DE value
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                    self.yang_name = "fr-de"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "fr-de"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                            class Ipv4Acl(Entity):
                                                                                                """
                                                                                                IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                    self.yang_name = "ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ipv4-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                            class Ipv6Acl(Entity):
                                                                                                """
                                                                                                IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                    self.yang_name = "ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ipv6-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                            class EtherServiceAcl(Entity):
                                                                                                """
                                                                                                Ethernet\-Services Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                    self.yang_name = "ether-service-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ether-service-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                            class AvailId(Entity):
                                                                                                """
                                                                                                Available Identifiers
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                    self.yang_name = "avail-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "avail-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                            class MediaType(Entity):
                                                                                                """
                                                                                                Media Type
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                    self.yang_name = "media-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "media-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                            class SubsProtocol(Entity):
                                                                                                """
                                                                                                Protocol
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                    self.yang_name = "subs-protocol"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "subs-protocol"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                            class Dnis(Entity):
                                                                                                """
                                                                                                DNIS
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                    self.yang_name = "dnis"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dnis"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                            class DnisRegex(Entity):
                                                                                                """
                                                                                                DNIS Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                    self.yang_name = "dnis-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dnis-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                            class Domain(Entity):
                                                                                                """
                                                                                                Domain Name
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                    self.yang_name = "domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                        ])
                                                                                                        self.domain_name = None
                                                                                                        self.format_name = None
                                                                                                        self._segment_path = lambda: "domain-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class DomainRegex(Entity):
                                                                                                """
                                                                                                Domain Regular Expression
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                    self.yang_name = "domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain-regex"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                        ])
                                                                                                        self.domain_name = None
                                                                                                        self.format_name = None
                                                                                                        self._segment_path = lambda: "domain-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class NasPort(Entity):
                                                                                                """
                                                                                                NAS Port
                                                                                                
                                                                                                .. attribute:: nas_port_array
                                                                                                
                                                                                                	nas port array
                                                                                                	**type**\: list of  		 :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                    self.yang_name = "nas-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("nas-port-array", ("nas_port_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.nas_port_array = YList(self)
                                                                                                    self._segment_path = lambda: "nas-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                                class NasPortArray(Entity):
                                                                                                    """
                                                                                                    nas port array
                                                                                                    
                                                                                                    .. attribute:: sub_id
                                                                                                    
                                                                                                    	sub id
                                                                                                    	**type**\:  :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                    
                                                                                                    .. attribute:: operator
                                                                                                    
                                                                                                    	operator
                                                                                                    	**type**\:  :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	value
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                        self.yang_name = "nas-port-array"
                                                                                                        self.yang_parent_name = "nas-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('sub_id', (YLeaf(YType.enumeration, 'sub-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchNasPortSubIdEn', '')])),
                                                                                                            ('operator', (YLeaf(YType.enumeration, 'operator'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchLogicalOperatorEn', '')])),
                                                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                                        ])
                                                                                                        self.sub_id = None
                                                                                                        self.operator = None
                                                                                                        self.value = None
                                                                                                        self._segment_path = lambda: "nas-port-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['sub_id', 'operator', 'value'], name, value)


                                                                                            class ServiceName(Entity):
                                                                                                """
                                                                                                Service Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                    self.yang_name = "service-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "service-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                            class ServiceNameRegex(Entity):
                                                                                                """
                                                                                                Service Name Regular Exp
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                    self.yang_name = "service-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "service-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                            class SrcAddrIpv4(Entity):
                                                                                                """
                                                                                                Source Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class DstAddrIpv4(Entity):
                                                                                                """
                                                                                                Destination Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class SrcAddrIpv6(Entity):
                                                                                                """
                                                                                                Source Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class DstAddrIpv6(Entity):
                                                                                                """
                                                                                                Destination Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class SrcAddrMac(Entity):
                                                                                                """
                                                                                                Source Address MAC
                                                                                                
                                                                                                .. attribute:: mac_addr_array
                                                                                                
                                                                                                	mac addr array
                                                                                                	**type**\: list of  		 :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                    self.yang_name = "src-addr-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("mac-addr-array", ("mac_addr_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.mac_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                                class MacAddrArray(Entity):
                                                                                                    """
                                                                                                    mac addr array
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                        self.yang_name = "mac-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                            ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.mac_addr = []
                                                                                                        self.mask = []
                                                                                                        self._segment_path = lambda: "mac-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                            class Timer(Entity):
                                                                                                """
                                                                                                Timer
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                    self.yang_name = "timer"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "timer"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                            class TimerRegexp(Entity):
                                                                                                """
                                                                                                Timer Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                    self.yang_name = "timer-regexp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "timer-regexp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                            class TunnelName(Entity):
                                                                                                """
                                                                                                Tunnel Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                    self.yang_name = "tunnel-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "tunnel-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                            class TunnelNameRegex(Entity):
                                                                                                """
                                                                                                Tunnel Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "tunnel-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                            class UserName(Entity):
                                                                                                """
                                                                                                User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                    self.yang_name = "user-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "user-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                            class UserNameRegex(Entity):
                                                                                                """
                                                                                                User Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                    self.yang_name = "user-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "user-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                            class AuthUsername(Entity):
                                                                                                """
                                                                                                Authenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                    self.yang_name = "auth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-username"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                            class AuthUsernameRegex(Entity):
                                                                                                """
                                                                                                Authenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "auth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-username-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                            class UnauthUsername(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                    self.yang_name = "unauth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-username"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                            class UnauthUsernameRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-username-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                            class AuthDomain(Entity):
                                                                                                """
                                                                                                Authenticated domain name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                    self.yang_name = "auth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                            class AuthDomainRegex(Entity):
                                                                                                """
                                                                                                Authenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "auth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                            class UnauthDomain(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                    self.yang_name = "unauth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                            class UnauthDomainRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                            class VendorId(Entity):
                                                                                                """
                                                                                                Vendor ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                    self.yang_name = "vendor-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "vendor-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                            class VendorIdRegex(Entity):
                                                                                                """
                                                                                                Vendor ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                    self.yang_name = "vendor-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "vendor-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                            class AccessInterface(Entity):
                                                                                                """
                                                                                                Access interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                    self.yang_name = "access-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "access-interface"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                            class InputInterface(Entity):
                                                                                                """
                                                                                                Input interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                    self.yang_name = "input-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "input-interface"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                            class InputIntfhdl(Entity):
                                                                                                """
                                                                                                Input interface handle
                                                                                                
                                                                                                .. attribute:: uint64_array
                                                                                                
                                                                                                	uint64 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..18446744073709551615
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                    self.yang_name = "input-intfhdl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint64_array', (YLeafList(YType.uint64, 'uint64_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint64_array = []
                                                                                                    self._segment_path = lambda: "input-intfhdl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                            class Ethertype(Entity):
                                                                                                """
                                                                                                Ethernet type
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                    self.yang_name = "ethertype"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ethertype"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ethertype"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FlowKeyData(Entity):
                                                                                                """
                                                                                                Flow key structure
                                                                                                
                                                                                                .. attribute:: flow_keys
                                                                                                
                                                                                                	flow keys
                                                                                                	**type**\:  :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                                
                                                                                                .. attribute:: max_count
                                                                                                
                                                                                                	Maximum count of flows
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: idle_timeout
                                                                                                
                                                                                                	Idle timeout of flows (in seconds)
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                	**units**\: second
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                    self.yang_name = "flow-key-data"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("flow-keys", ("flow_keys", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys))])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('max_count', (YLeaf(YType.uint16, 'max-count'), ['int'])),
                                                                                                        ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                                                    ])
                                                                                                    self.max_count = None
                                                                                                    self.idle_timeout = None

                                                                                                    self.flow_keys = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                    self.flow_keys.parent = self
                                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                    self._segment_path = lambda: "flow-key-data"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['max_count', 'idle_timeout'], name, value)


                                                                                                class FlowKeys(Entity):
                                                                                                    """
                                                                                                    flow keys
                                                                                                    
                                                                                                    .. attribute:: keys
                                                                                                    
                                                                                                    	keys
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                    
                                                                                                    .. attribute:: num
                                                                                                    
                                                                                                    	num
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                        self.yang_name = "flow-keys"
                                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('keys', (YLeaf(YType.str, 'keys'), ['str'])),
                                                                                                            ('num', (YLeaf(YType.uint8, 'num'), ['int'])),
                                                                                                        ])
                                                                                                        self.keys = None
                                                                                                        self.num = None
                                                                                                        self._segment_path = lambda: "flow-keys"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                            class DhcpClientId(Entity):
                                                                                                """
                                                                                                Dhcp Client ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dhcp-client-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                            class DhcpClientIdRegex(Entity):
                                                                                                """
                                                                                                Dhcp Client ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                            class CircuitId(Entity):
                                                                                                """
                                                                                                Circuit ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                    self.yang_name = "circuit-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "circuit-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                            class CircuitIdRegex(Entity):
                                                                                                """
                                                                                                Circuit ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                    self.yang_name = "circuit-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "circuit-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                            class RemoteId(Entity):
                                                                                                """
                                                                                                Remote ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                    self.yang_name = "remote-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "remote-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                            class RemoteIdRegex(Entity):
                                                                                                """
                                                                                                Remote ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                    self.yang_name = "remote-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "remote-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                            class SrcPort(Entity):
                                                                                                """
                                                                                                Source port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                    self.yang_name = "src-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "src-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class DstPort(Entity):
                                                                                                """
                                                                                                Destination port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                    self.yang_name = "dst-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "dst-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                        class ExcdclassP(Entity):
                                                                            """
                                                                            excdclass p
                                                                            
                                                                            .. attribute:: class_map_bg
                                                                            
                                                                            	class map bg
                                                                            	**type**\: list of  		 :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP, self).__init__()

                                                                                self.yang_name = "excdclass-p"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("class-map-bg", ("class_map_bg", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg))])
                                                                                self._leafs = OrderedDict()

                                                                                self.class_map_bg = YList(self)
                                                                                self._segment_path = lambda: "excdclass-p"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP, [], name, value)


                                                                            class ClassMapBg(Entity):
                                                                                """
                                                                                class map bg
                                                                                
                                                                                .. attribute:: match_infop
                                                                                
                                                                                	Pointer to the first Match info
                                                                                	**type**\:  :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop>`
                                                                                
                                                                                .. attribute:: name
                                                                                
                                                                                	Name of the class\-map
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..65
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Class\-Map Type QoS/PBR/Netflow/..
                                                                                	**type**\:  :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                                                
                                                                                .. attribute:: mode
                                                                                
                                                                                	Class\-Map Mode Match any/Match all
                                                                                	**type**\:  :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                                
                                                                                .. attribute:: description
                                                                                
                                                                                	description
                                                                                	**type**\: str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg, self).__init__()

                                                                                    self.yang_name = "class-map-bg"
                                                                                    self.yang_parent_name = "excdclass-p"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("match-infop", ("match_infop", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapTypeEn', '')])),
                                                                                        ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapModeEn', '')])),
                                                                                        ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                    ])
                                                                                    self.name = None
                                                                                    self.type = None
                                                                                    self.mode = None
                                                                                    self.description = None

                                                                                    self.match_infop = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop()
                                                                                    self.match_infop.parent = self
                                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                                    self._segment_path = lambda: "class-map-bg"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg, ['name', 'type', 'mode', 'description'], name, value)


                                                                                class MatchInfop(Entity):
                                                                                    """
                                                                                    Pointer to the first Match info
                                                                                    
                                                                                    .. attribute:: class_match_info_st
                                                                                    
                                                                                    	class match info st
                                                                                    	**type**\: list of  		 :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop, self).__init__()

                                                                                        self.yang_name = "match-infop"
                                                                                        self.yang_parent_name = "class-map-bg"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("class-match-info-st", ("class_match_info_st", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.class_match_info_st = YList(self)
                                                                                        self._segment_path = lambda: "match-infop"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop, [], name, value)


                                                                                    class ClassMatchInfoSt(Entity):
                                                                                        """
                                                                                        class match info st
                                                                                        
                                                                                        .. attribute:: match_data
                                                                                        
                                                                                        	Match criteria
                                                                                        	**type**\:  :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                        
                                                                                        .. attribute:: flags
                                                                                        
                                                                                        	Flags
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                            self.yang_name = "class-match-info-st"
                                                                                            self.yang_parent_name = "match-infop"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("match-data", ("match_data", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData))])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                            ])
                                                                                            self.flags = None

                                                                                            self.match_data = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                            self.match_data.parent = self
                                                                                            self._children_name_map["match_data"] = "match-data"
                                                                                            self._segment_path = lambda: "class-match-info-st"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                        class MatchData(Entity):
                                                                                            """
                                                                                            Match criteria
                                                                                            
                                                                                            .. attribute:: ipv4_dscp
                                                                                            
                                                                                            	IPv4 DSCP
                                                                                            	**type**\:  :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv6_dscp
                                                                                            
                                                                                            	IPv6 DSCP
                                                                                            	**type**\:  :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                            
                                                                                            .. attribute:: dscp
                                                                                            
                                                                                            	Match DSCP range array
                                                                                            	**type**\:  :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv4_prec
                                                                                            
                                                                                            	IPv4 Precedence
                                                                                            	**type**\:  :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                            
                                                                                            .. attribute:: ipv6_prec
                                                                                            
                                                                                            	IPv6 Precedence
                                                                                            	**type**\:  :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                            
                                                                                            .. attribute:: prec
                                                                                            
                                                                                            	Match Precedence array
                                                                                            	**type**\:  :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                            
                                                                                            .. attribute:: discard_class
                                                                                            
                                                                                            	Match Discard Class array
                                                                                            	**type**\:  :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                            
                                                                                            .. attribute:: qos_group
                                                                                            
                                                                                            	Match QoS group array
                                                                                            	**type**\:  :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                            
                                                                                            .. attribute:: traffic_class
                                                                                            
                                                                                            	Match Traffic class array
                                                                                            	**type**\:  :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                            
                                                                                            .. attribute:: proto
                                                                                            
                                                                                            	Match Protocol array
                                                                                            	**type**\:  :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                            
                                                                                            .. attribute:: icmp_v4
                                                                                            
                                                                                            	Match ICMPV4 Protocol
                                                                                            	**type**\:  :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                            
                                                                                            .. attribute:: icmp_v6
                                                                                            
                                                                                            	Match ICMPV6 Protocol array
                                                                                            	**type**\:  :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                            
                                                                                            .. attribute:: ipv4_packet_len
                                                                                            
                                                                                            	IPv4 packet length array
                                                                                            	**type**\:  :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv6_packet_len
                                                                                            
                                                                                            	IPv6 packet length array
                                                                                            	**type**\:  :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                            
                                                                                            .. attribute:: packet_len
                                                                                            
                                                                                            	Match packet length array
                                                                                            	**type**\:  :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                            
                                                                                            .. attribute:: flow_tag
                                                                                            
                                                                                            	Match flow\-tag array
                                                                                            	**type**\:  :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                            
                                                                                            .. attribute:: tcp_flag
                                                                                            
                                                                                            	Match tcp flag value
                                                                                            	**type**\:  :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                            
                                                                                            .. attribute:: icmpv4_type
                                                                                            
                                                                                            	Match ipv4 icmp type
                                                                                            	**type**\:  :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                            
                                                                                            .. attribute:: icmpv4_code
                                                                                            
                                                                                            	Match ipv4 icmp code
                                                                                            	**type**\:  :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                            
                                                                                            .. attribute:: icmpv6_type
                                                                                            
                                                                                            	Match ipv6 icmp type
                                                                                            	**type**\:  :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                            
                                                                                            .. attribute:: icmpv6_code
                                                                                            
                                                                                            	Match ipv6 icmp code
                                                                                            	**type**\:  :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                            
                                                                                            .. attribute:: mpls_exp
                                                                                            
                                                                                            	Match MPLS experimental topmost array
                                                                                            	**type**\:  :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                            
                                                                                            .. attribute:: mpls_exp_imp
                                                                                            
                                                                                            	Match MPLS experimental imposition array
                                                                                            	**type**\:  :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                                            
                                                                                            	MPLS Disposition IPv4 Access\-list
                                                                                            	**type**\:  :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                                            
                                                                                            	MPLS Disposition IPv6 Access\-list
                                                                                            	**type**\:  :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_top_label
                                                                                            
                                                                                            	MPLS Topmost LABEL
                                                                                            	**type**\:  :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                            
                                                                                            .. attribute:: cos
                                                                                            
                                                                                            	Match CoS array
                                                                                            	**type**\:  :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                            
                                                                                            .. attribute:: cos_inr
                                                                                            
                                                                                            	Match inner header CoS
                                                                                            	**type**\:  :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                            
                                                                                            .. attribute:: dei
                                                                                            
                                                                                            	Match DEI Bit
                                                                                            	**type**\:  :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                            
                                                                                            .. attribute:: dei_inr
                                                                                            
                                                                                            	Match inner DEI Bit
                                                                                            	**type**\:  :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                            
                                                                                            .. attribute:: vlan
                                                                                            
                                                                                            	Match VLAN array
                                                                                            	**type**\:  :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                            
                                                                                            .. attribute:: vlan_inr
                                                                                            
                                                                                            	Match inner header VLAN range array
                                                                                            	**type**\:  :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                            
                                                                                            .. attribute:: fr_dlci
                                                                                            
                                                                                            	Match FR DLCI range array
                                                                                            	**type**\:  :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                            
                                                                                            .. attribute:: src_mac
                                                                                            
                                                                                            	Match Source MAC address
                                                                                            	**type**\:  :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                            
                                                                                            .. attribute:: dst_mac
                                                                                            
                                                                                            	Match Destination MAC address
                                                                                            	**type**\:  :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                            
                                                                                            .. attribute:: atm_clp
                                                                                            
                                                                                            	Match ATM CLP level
                                                                                            	**type**\:  :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                            
                                                                                            .. attribute:: fr_de
                                                                                            
                                                                                            	Match FR DE value
                                                                                            	**type**\:  :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                            
                                                                                            .. attribute:: ipv4_acl
                                                                                            
                                                                                            	IPv4 Access\-list
                                                                                            	**type**\:  :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                            
                                                                                            .. attribute:: ipv6_acl
                                                                                            
                                                                                            	IPv6 Access\-list
                                                                                            	**type**\:  :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                            
                                                                                            .. attribute:: ether_service_acl
                                                                                            
                                                                                            	Ethernet\-Services Access\-list
                                                                                            	**type**\:  :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                            
                                                                                            .. attribute:: avail_id
                                                                                            
                                                                                            	Available Identifiers
                                                                                            	**type**\:  :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                            
                                                                                            .. attribute:: media_type
                                                                                            
                                                                                            	Media Type
                                                                                            	**type**\:  :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                            
                                                                                            .. attribute:: subs_protocol
                                                                                            
                                                                                            	Protocol
                                                                                            	**type**\:  :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                            
                                                                                            .. attribute:: dnis
                                                                                            
                                                                                            	DNIS
                                                                                            	**type**\:  :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                            
                                                                                            .. attribute:: dnis_regex
                                                                                            
                                                                                            	DNIS Regular Expression
                                                                                            	**type**\:  :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                            
                                                                                            .. attribute:: domain
                                                                                            
                                                                                            	Domain Name
                                                                                            	**type**\:  :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                            
                                                                                            .. attribute:: domain_regex
                                                                                            
                                                                                            	Domain Regular Expression
                                                                                            	**type**\:  :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                            
                                                                                            .. attribute:: nas_port
                                                                                            
                                                                                            	NAS Port
                                                                                            	**type**\:  :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                            
                                                                                            .. attribute:: service_name
                                                                                            
                                                                                            	Service Name
                                                                                            	**type**\:  :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                            
                                                                                            .. attribute:: service_name_regex
                                                                                            
                                                                                            	Service Name Regular Exp
                                                                                            	**type**\:  :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv4
                                                                                            
                                                                                            	Source Address IPV4
                                                                                            	**type**\:  :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv4
                                                                                            
                                                                                            	Destination Address IPV4
                                                                                            	**type**\:  :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv6
                                                                                            
                                                                                            	Source Address IPV6
                                                                                            	**type**\:  :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv6
                                                                                            
                                                                                            	Destination Address IPV6
                                                                                            	**type**\:  :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: src_addr_mac
                                                                                            
                                                                                            	Source Address MAC
                                                                                            	**type**\:  :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                            
                                                                                            .. attribute:: timer
                                                                                            
                                                                                            	Timer
                                                                                            	**type**\:  :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                            
                                                                                            .. attribute:: timer_regexp
                                                                                            
                                                                                            	Timer Regular Expression
                                                                                            	**type**\:  :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                            
                                                                                            .. attribute:: tunnel_name
                                                                                            
                                                                                            	Tunnel Name
                                                                                            	**type**\:  :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                            
                                                                                            .. attribute:: tunnel_name_regex
                                                                                            
                                                                                            	Tunnel Name Regular Expression
                                                                                            	**type**\:  :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                            
                                                                                            .. attribute:: user_name
                                                                                            
                                                                                            	User Name
                                                                                            	**type**\:  :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                            
                                                                                            .. attribute:: user_name_regex
                                                                                            
                                                                                            	User Name Regular Expression
                                                                                            	**type**\:  :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                            
                                                                                            .. attribute:: auth_username
                                                                                            
                                                                                            	Authenticated User Name
                                                                                            	**type**\:  :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                            
                                                                                            .. attribute:: auth_username_regex
                                                                                            
                                                                                            	Authenticated User Name RegEx
                                                                                            	**type**\:  :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_username
                                                                                            
                                                                                            	Unauthenticated User Name
                                                                                            	**type**\:  :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                            
                                                                                            .. attribute:: unauth_username_regex
                                                                                            
                                                                                            	Unauthenticated User Name RegEx
                                                                                            	**type**\:  :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: auth_domain
                                                                                            
                                                                                            	Authenticated domain name
                                                                                            	**type**\:  :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                            
                                                                                            .. attribute:: auth_domain_regex
                                                                                            
                                                                                            	Authenticated Domain Name RegEx
                                                                                            	**type**\:  :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_domain
                                                                                            
                                                                                            	Unauthenticated Domain Name
                                                                                            	**type**\:  :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                            
                                                                                            .. attribute:: unauth_domain_regex
                                                                                            
                                                                                            	Unauthenticated Domain Name RegEx
                                                                                            	**type**\:  :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: vendor_id
                                                                                            
                                                                                            	Vendor ID
                                                                                            	**type**\:  :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                            
                                                                                            .. attribute:: vendor_id_regex
                                                                                            
                                                                                            	Vendor ID RegEx
                                                                                            	**type**\:  :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                            
                                                                                            .. attribute:: access_interface
                                                                                            
                                                                                            	Access interface
                                                                                            	**type**\:  :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                            
                                                                                            .. attribute:: input_interface
                                                                                            
                                                                                            	Input interface
                                                                                            	**type**\:  :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                            
                                                                                            .. attribute:: input_intfhdl
                                                                                            
                                                                                            	Input interface handle
                                                                                            	**type**\:  :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                            
                                                                                            .. attribute:: ethertype
                                                                                            
                                                                                            	Ethernet type
                                                                                            	**type**\:  :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                            
                                                                                            .. attribute:: flow_key_data
                                                                                            
                                                                                            	Flow key structure
                                                                                            	**type**\:  :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id
                                                                                            
                                                                                            	Dhcp Client ID
                                                                                            	**type**\:  :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id_regex
                                                                                            
                                                                                            	Dhcp Client ID RegEx
                                                                                            	**type**\:  :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                            
                                                                                            .. attribute:: circuit_id
                                                                                            
                                                                                            	Circuit ID
                                                                                            	**type**\:  :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                            
                                                                                            .. attribute:: circuit_id_regex
                                                                                            
                                                                                            	Circuit ID RegEx
                                                                                            	**type**\:  :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                            
                                                                                            .. attribute:: remote_id
                                                                                            
                                                                                            	Remote ID
                                                                                            	**type**\:  :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                            
                                                                                            .. attribute:: remote_id_regex
                                                                                            
                                                                                            	Remote ID RegEx
                                                                                            	**type**\:  :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                            
                                                                                            .. attribute:: src_port
                                                                                            
                                                                                            	Source port
                                                                                            	**type**\:  :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                            
                                                                                            .. attribute:: dst_port
                                                                                            
                                                                                            	Destination port
                                                                                            	**type**\:  :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	type
                                                                                            	**type**\:  :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                            
                                                                                            .. attribute:: mpls_top_eos
                                                                                            
                                                                                            	MPLS Topmost EOS
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: fragment_type
                                                                                            
                                                                                            	Fragment type
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: authen_status
                                                                                            
                                                                                            	Authentication Status
                                                                                            	**type**\:  :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                            
                                                                                            .. attribute:: mlp_negotiated
                                                                                            
                                                                                            	MLP Negotiated
                                                                                            	**type**\:  :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                                self.yang_name = "match-data"
                                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("ipv4-dscp", ("ipv4_dscp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp)), ("ipv6-dscp", ("ipv6_dscp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp)), ("dscp", ("dscp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp)), ("ipv4-prec", ("ipv4_prec", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec)), ("ipv6-prec", ("ipv6_prec", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec)), ("prec", ("prec", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec)), ("discard-class", ("discard_class", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass)), ("qos-group", ("qos_group", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup)), ("traffic-class", ("traffic_class", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass)), ("proto", ("proto", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto)), ("icmp-v4", ("icmp_v4", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4)), ("icmp-v6", ("icmp_v6", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6)), ("ipv4-packet-len", ("ipv4_packet_len", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen)), ("ipv6-packet-len", ("ipv6_packet_len", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen)), ("packet-len", ("packet_len", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen)), ("flow-tag", ("flow_tag", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag)), ("tcp-flag", ("tcp_flag", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag)), ("icmpv4-type", ("icmpv4_type", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type)), ("icmpv4-code", ("icmpv4_code", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code)), ("icmpv6-type", ("icmpv6_type", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type)), ("icmpv6-code", ("icmpv6_code", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code)), ("mpls-exp", ("mpls_exp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp)), ("mpls-exp-imp", ("mpls_exp_imp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp)), ("mpls-disp-ipv4-acl", ("mpls_disp_ipv4_acl", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl)), ("mpls-disp-ipv6-acl", ("mpls_disp_ipv6_acl", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl)), ("mpls-top-label", ("mpls_top_label", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel)), ("cos", ("cos", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos)), ("cos-inr", ("cos_inr", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr)), ("dei", ("dei", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei)), ("dei-inr", ("dei_inr", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr)), ("vlan", ("vlan", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan)), ("vlan-inr", ("vlan_inr", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)), ("fr-dlci", ("fr_dlci", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci)), ("src-mac", ("src_mac", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac)), ("dst-mac", ("dst_mac", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac)), ("atm-clp", ("atm_clp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp)), ("fr-de", ("fr_de", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe)), ("ipv4-acl", ("ipv4_acl", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl)), ("ipv6-acl", ("ipv6_acl", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl)), ("ether-service-acl", ("ether_service_acl", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl)), ("avail-id", ("avail_id", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId)), ("media-type", ("media_type", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType)), ("subs-protocol", ("subs_protocol", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol)), ("dnis", ("dnis", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis)), ("dnis-regex", ("dnis_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex)), ("domain", ("domain", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain)), ("domain-regex", ("domain_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex)), ("nas-port", ("nas_port", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort)), ("service-name", ("service_name", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName)), ("service-name-regex", ("service_name_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex)), ("src-addr-ipv4", ("src_addr_ipv4", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4)), ("dst-addr-ipv4", ("dst_addr_ipv4", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4)), ("src-addr-ipv6", ("src_addr_ipv6", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6)), ("dst-addr-ipv6", ("dst_addr_ipv6", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6)), ("src-addr-mac", ("src_addr_mac", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac)), ("timer", ("timer", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer)), ("timer-regexp", ("timer_regexp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp)), ("tunnel-name", ("tunnel_name", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName)), ("tunnel-name-regex", ("tunnel_name_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex)), ("user-name", ("user_name", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName)), ("user-name-regex", ("user_name_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex)), ("auth-username", ("auth_username", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername)), ("auth-username-regex", ("auth_username_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex)), ("unauth-username", ("unauth_username", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername)), ("unauth-username-regex", ("unauth_username_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex)), ("auth-domain", ("auth_domain", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain)), ("auth-domain-regex", ("auth_domain_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex)), ("unauth-domain", ("unauth_domain", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain)), ("unauth-domain-regex", ("unauth_domain_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex)), ("vendor-id", ("vendor_id", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId)), ("vendor-id-regex", ("vendor_id_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex)), ("access-interface", ("access_interface", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface)), ("input-interface", ("input_interface", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface)), ("input-intfhdl", ("input_intfhdl", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl)), ("ethertype", ("ethertype", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype)), ("flow-key-data", ("flow_key_data", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData)), ("dhcp-client-id", ("dhcp_client_id", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId)), ("dhcp-client-id-regex", ("dhcp_client_id_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex)), ("circuit-id", ("circuit_id", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId)), ("circuit-id-regex", ("circuit_id_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex)), ("remote-id", ("remote_id", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId)), ("remote-id-regex", ("remote_id_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex)), ("src-port", ("src_port", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort)), ("dst-port", ("dst_port", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort))])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchTypeEn', '')])),
                                                                                                    ('mpls_top_eos', (YLeaf(YType.uint8, 'mpls-top-eos'), ['int'])),
                                                                                                    ('fragment_type', (YLeaf(YType.uint8, 'fragment-type'), ['int'])),
                                                                                                    ('authen_status', (YLeaf(YType.enumeration, 'authen-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchAuthenStatusEn', '')])),
                                                                                                    ('mlp_negotiated', (YLeaf(YType.enumeration, 'mlp-negotiated'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchMlpNegotiatedEn', '')])),
                                                                                                ])
                                                                                                self.type = None
                                                                                                self.mpls_top_eos = None
                                                                                                self.fragment_type = None
                                                                                                self.authen_status = None
                                                                                                self.mlp_negotiated = None

                                                                                                self.ipv4_dscp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                                self.ipv4_dscp.parent = self
                                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"

                                                                                                self.ipv6_dscp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                                self.ipv6_dscp.parent = self
                                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"

                                                                                                self.dscp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                                self.dscp.parent = self
                                                                                                self._children_name_map["dscp"] = "dscp"

                                                                                                self.ipv4_prec = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                                self.ipv4_prec.parent = self
                                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"

                                                                                                self.ipv6_prec = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                                self.ipv6_prec.parent = self
                                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"

                                                                                                self.prec = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                                self.prec.parent = self
                                                                                                self._children_name_map["prec"] = "prec"

                                                                                                self.discard_class = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                                self.discard_class.parent = self
                                                                                                self._children_name_map["discard_class"] = "discard-class"

                                                                                                self.qos_group = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                                self.qos_group.parent = self
                                                                                                self._children_name_map["qos_group"] = "qos-group"

                                                                                                self.traffic_class = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                                self.traffic_class.parent = self
                                                                                                self._children_name_map["traffic_class"] = "traffic-class"

                                                                                                self.proto = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                                self.proto.parent = self
                                                                                                self._children_name_map["proto"] = "proto"

                                                                                                self.icmp_v4 = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                                self.icmp_v4.parent = self
                                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"

                                                                                                self.icmp_v6 = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                                self.icmp_v6.parent = self
                                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"

                                                                                                self.ipv4_packet_len = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                                self.ipv4_packet_len.parent = self
                                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"

                                                                                                self.ipv6_packet_len = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                                self.ipv6_packet_len.parent = self
                                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"

                                                                                                self.packet_len = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                                self.packet_len.parent = self
                                                                                                self._children_name_map["packet_len"] = "packet-len"

                                                                                                self.flow_tag = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                                self.flow_tag.parent = self
                                                                                                self._children_name_map["flow_tag"] = "flow-tag"

                                                                                                self.tcp_flag = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                                self.tcp_flag.parent = self
                                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"

                                                                                                self.icmpv4_type = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                                self.icmpv4_type.parent = self
                                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"

                                                                                                self.icmpv4_code = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                                self.icmpv4_code.parent = self
                                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"

                                                                                                self.icmpv6_type = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                                self.icmpv6_type.parent = self
                                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"

                                                                                                self.icmpv6_code = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                                self.icmpv6_code.parent = self
                                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"

                                                                                                self.mpls_exp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                                self.mpls_exp.parent = self
                                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"

                                                                                                self.mpls_exp_imp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                                self.mpls_exp_imp.parent = self
                                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"

                                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"

                                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"

                                                                                                self.mpls_top_label = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                                self.mpls_top_label.parent = self
                                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"

                                                                                                self.cos = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                                self.cos.parent = self
                                                                                                self._children_name_map["cos"] = "cos"

                                                                                                self.cos_inr = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                                self.cos_inr.parent = self
                                                                                                self._children_name_map["cos_inr"] = "cos-inr"

                                                                                                self.dei = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                                self.dei.parent = self
                                                                                                self._children_name_map["dei"] = "dei"

                                                                                                self.dei_inr = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                                self.dei_inr.parent = self
                                                                                                self._children_name_map["dei_inr"] = "dei-inr"

                                                                                                self.vlan = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                                self.vlan.parent = self
                                                                                                self._children_name_map["vlan"] = "vlan"

                                                                                                self.vlan_inr = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                                self.vlan_inr.parent = self
                                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"

                                                                                                self.fr_dlci = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                                self.fr_dlci.parent = self
                                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"

                                                                                                self.src_mac = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                                self.src_mac.parent = self
                                                                                                self._children_name_map["src_mac"] = "src-mac"

                                                                                                self.dst_mac = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                                self.dst_mac.parent = self
                                                                                                self._children_name_map["dst_mac"] = "dst-mac"

                                                                                                self.atm_clp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                                self.atm_clp.parent = self
                                                                                                self._children_name_map["atm_clp"] = "atm-clp"

                                                                                                self.fr_de = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                                self.fr_de.parent = self
                                                                                                self._children_name_map["fr_de"] = "fr-de"

                                                                                                self.ipv4_acl = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                                self.ipv4_acl.parent = self
                                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"

                                                                                                self.ipv6_acl = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                                self.ipv6_acl.parent = self
                                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"

                                                                                                self.ether_service_acl = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                                self.ether_service_acl.parent = self
                                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"

                                                                                                self.avail_id = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                                self.avail_id.parent = self
                                                                                                self._children_name_map["avail_id"] = "avail-id"

                                                                                                self.media_type = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                                self.media_type.parent = self
                                                                                                self._children_name_map["media_type"] = "media-type"

                                                                                                self.subs_protocol = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                                self.subs_protocol.parent = self
                                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"

                                                                                                self.dnis = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                                self.dnis.parent = self
                                                                                                self._children_name_map["dnis"] = "dnis"

                                                                                                self.dnis_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                                self.dnis_regex.parent = self
                                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"

                                                                                                self.domain = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                                self.domain.parent = self
                                                                                                self._children_name_map["domain"] = "domain"

                                                                                                self.domain_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                                self.domain_regex.parent = self
                                                                                                self._children_name_map["domain_regex"] = "domain-regex"

                                                                                                self.nas_port = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                                self.nas_port.parent = self
                                                                                                self._children_name_map["nas_port"] = "nas-port"

                                                                                                self.service_name = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                                self.service_name.parent = self
                                                                                                self._children_name_map["service_name"] = "service-name"

                                                                                                self.service_name_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                                self.service_name_regex.parent = self
                                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"

                                                                                                self.src_addr_ipv4 = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                                self.src_addr_ipv4.parent = self
                                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"

                                                                                                self.dst_addr_ipv4 = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                                self.dst_addr_ipv4.parent = self
                                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"

                                                                                                self.src_addr_ipv6 = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                                self.src_addr_ipv6.parent = self
                                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"

                                                                                                self.dst_addr_ipv6 = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                                self.dst_addr_ipv6.parent = self
                                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"

                                                                                                self.src_addr_mac = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                                self.src_addr_mac.parent = self
                                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"

                                                                                                self.timer = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                                self.timer.parent = self
                                                                                                self._children_name_map["timer"] = "timer"

                                                                                                self.timer_regexp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                                self.timer_regexp.parent = self
                                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"

                                                                                                self.tunnel_name = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                                self.tunnel_name.parent = self
                                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"

                                                                                                self.tunnel_name_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                                self.tunnel_name_regex.parent = self
                                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"

                                                                                                self.user_name = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                                self.user_name.parent = self
                                                                                                self._children_name_map["user_name"] = "user-name"

                                                                                                self.user_name_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                                self.user_name_regex.parent = self
                                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"

                                                                                                self.auth_username = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                                self.auth_username.parent = self
                                                                                                self._children_name_map["auth_username"] = "auth-username"

                                                                                                self.auth_username_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                                self.auth_username_regex.parent = self
                                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"

                                                                                                self.unauth_username = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                                self.unauth_username.parent = self
                                                                                                self._children_name_map["unauth_username"] = "unauth-username"

                                                                                                self.unauth_username_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                                self.unauth_username_regex.parent = self
                                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"

                                                                                                self.auth_domain = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                                self.auth_domain.parent = self
                                                                                                self._children_name_map["auth_domain"] = "auth-domain"

                                                                                                self.auth_domain_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                                self.auth_domain_regex.parent = self
                                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"

                                                                                                self.unauth_domain = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                                self.unauth_domain.parent = self
                                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"

                                                                                                self.unauth_domain_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                                self.unauth_domain_regex.parent = self
                                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"

                                                                                                self.vendor_id = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                                self.vendor_id.parent = self
                                                                                                self._children_name_map["vendor_id"] = "vendor-id"

                                                                                                self.vendor_id_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                                self.vendor_id_regex.parent = self
                                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"

                                                                                                self.access_interface = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                                self.access_interface.parent = self
                                                                                                self._children_name_map["access_interface"] = "access-interface"

                                                                                                self.input_interface = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                                self.input_interface.parent = self
                                                                                                self._children_name_map["input_interface"] = "input-interface"

                                                                                                self.input_intfhdl = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                                self.input_intfhdl.parent = self
                                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"

                                                                                                self.ethertype = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                                self.ethertype.parent = self
                                                                                                self._children_name_map["ethertype"] = "ethertype"

                                                                                                self.flow_key_data = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                                self.flow_key_data.parent = self
                                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"

                                                                                                self.dhcp_client_id = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                                self.dhcp_client_id.parent = self
                                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"

                                                                                                self.dhcp_client_id_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                                self.dhcp_client_id_regex.parent = self
                                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"

                                                                                                self.circuit_id = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                                self.circuit_id.parent = self
                                                                                                self._children_name_map["circuit_id"] = "circuit-id"

                                                                                                self.circuit_id_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                                self.circuit_id_regex.parent = self
                                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"

                                                                                                self.remote_id = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                                self.remote_id.parent = self
                                                                                                self._children_name_map["remote_id"] = "remote-id"

                                                                                                self.remote_id_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                                self.remote_id_regex.parent = self
                                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"

                                                                                                self.src_port = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                                self.src_port.parent = self
                                                                                                self._children_name_map["src_port"] = "src-port"

                                                                                                self.dst_port = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                                self.dst_port.parent = self
                                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                                self._segment_path = lambda: "match-data"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['type', 'mpls_top_eos', 'fragment_type', 'authen_status', 'mlp_negotiated'], name, value)


                                                                                            class Ipv4Dscp(Entity):
                                                                                                """
                                                                                                IPv4 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv4-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv6Dscp(Entity):
                                                                                                """
                                                                                                IPv6 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv6-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Dscp(Entity):
                                                                                                """
                                                                                                Match DSCP range array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                    self.yang_name = "dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv4Prec(Entity):
                                                                                                """
                                                                                                IPv4 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                    self.yang_name = "ipv4-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "ipv4-prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                            class Ipv6Prec(Entity):
                                                                                                """
                                                                                                IPv6 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                    self.yang_name = "ipv6-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "ipv6-prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                            class Prec(Entity):
                                                                                                """
                                                                                                Match Precedence array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                    self.yang_name = "prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                            class DiscardClass(Entity):
                                                                                                """
                                                                                                Match Discard Class array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                    self.yang_name = "discard-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "discard-class"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                            class QosGroup(Entity):
                                                                                                """
                                                                                                Match QoS group array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                    self.yang_name = "qos-group"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "qos-group"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "qos-group"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class TrafficClass(Entity):
                                                                                                """
                                                                                                Match Traffic class array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                    self.yang_name = "traffic-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "traffic-class"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "traffic-class"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Proto(Entity):
                                                                                                """
                                                                                                Match Protocol array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                    self.yang_name = "proto"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "proto"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "proto"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class IcmpV4(Entity):
                                                                                                """
                                                                                                Match ICMPV4 Protocol
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                    self.yang_name = "icmp-v4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                    ])
                                                                                                    self.type = None
                                                                                                    self.code = None
                                                                                                    self._segment_path = lambda: "icmp-v4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['type', 'code'], name, value)


                                                                                            class IcmpV6(Entity):
                                                                                                """
                                                                                                Match ICMPV6 Protocol array
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                    self.yang_name = "icmp-v6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                    ])
                                                                                                    self.type = None
                                                                                                    self.code = None
                                                                                                    self._segment_path = lambda: "icmp-v6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['type', 'code'], name, value)


                                                                                            class Ipv4PacketLen(Entity):
                                                                                                """
                                                                                                IPv4 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv6PacketLen(Entity):
                                                                                                """
                                                                                                IPv6 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class PacketLen(Entity):
                                                                                                """
                                                                                                Match packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                    self.yang_name = "packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FlowTag(Entity):
                                                                                                """
                                                                                                Match flow\-tag array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                    self.yang_name = "flow-tag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "flow-tag"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "flow-tag"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class TcpFlag(Entity):
                                                                                                """
                                                                                                Match tcp flag value
                                                                                                
                                                                                                .. attribute:: value
                                                                                                
                                                                                                	Value of TCP flag
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: match_any
                                                                                                
                                                                                                	Match any TCP flag bit
                                                                                                	**type**\: bool
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                    self.yang_name = "tcp-flag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                                        ('match_any', (YLeaf(YType.boolean, 'match-any'), ['bool'])),
                                                                                                    ])
                                                                                                    self.value = None
                                                                                                    self.match_any = None
                                                                                                    self._segment_path = lambda: "tcp-flag"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['value', 'match_any'], name, value)


                                                                                            class Icmpv4Type(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                    self.yang_name = "icmpv4-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv4Code(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                    self.yang_name = "icmpv4-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-code"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv6Type(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                    self.yang_name = "icmpv6-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv6Code(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                    self.yang_name = "icmpv6-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-code"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class MplsExp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental topmost array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "mpls-exp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                            class MplsExpImp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental imposition array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "mpls-exp-imp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                            class MplsDispIpv4Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                            class MplsDispIpv6Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                            class MplsTopLabel(Entity):
                                                                                                """
                                                                                                MPLS Topmost LABEL
                                                                                                
                                                                                                .. attribute:: uint32_rng_array
                                                                                                
                                                                                                	uint32 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                    self.yang_name = "mpls-top-label"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint32_rng_array", ("uint32_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint32_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "mpls-top-label"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                                class Uint32RngArray(Entity):
                                                                                                    """
                                                                                                    uint32 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                        self.yang_name = "uint32_rng_array"
                                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint32, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint32, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint32_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['min', 'max'], name, value)


                                                                                            class Cos(Entity):
                                                                                                """
                                                                                                Match CoS array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                    self.yang_name = "cos"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "cos"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                            class CosInr(Entity):
                                                                                                """
                                                                                                Match inner header CoS
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                    self.yang_name = "cos-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "cos-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                            class Dei(Entity):
                                                                                                """
                                                                                                Match DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                    self.yang_name = "dei"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                    ])
                                                                                                    self.bit_value = None
                                                                                                    self._segment_path = lambda: "dei"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                            class DeiInr(Entity):
                                                                                                """
                                                                                                Match inner DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                    self.yang_name = "dei-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                    ])
                                                                                                    self.bit_value = None
                                                                                                    self._segment_path = lambda: "dei-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                            class Vlan(Entity):
                                                                                                """
                                                                                                Match VLAN array
                                                                                                
                                                                                                .. attribute:: vlan_id_array
                                                                                                
                                                                                                	vlan id array
                                                                                                	**type**\: list of  		 :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                    self.yang_name = "vlan"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("vlan-id-array", ("vlan_id_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.vlan_id_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                                class VlanIdArray(Entity):
                                                                                                    """
                                                                                                    vlan id array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	VLAN mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                        self.yang_name = "vlan-id-array"
                                                                                                        self.yang_parent_name = "vlan"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ('mask', (YLeaf(YType.uint16, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "vlan-id-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['min', 'max', 'mask'], name, value)


                                                                                            class VlanInr(Entity):
                                                                                                """
                                                                                                Match inner header VLAN range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                    self.yang_name = "vlan-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FrDlci(Entity):
                                                                                                """
                                                                                                Match FR DLCI range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                    self.yang_name = "fr-dlci"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "fr-dlci"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class SrcMac(Entity):
                                                                                                """
                                                                                                Match Source MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                    self.yang_name = "src-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.mac_addr = []
                                                                                                    self.mask = []
                                                                                                    self._segment_path = lambda: "src-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                            class DstMac(Entity):
                                                                                                """
                                                                                                Match Destination MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                    self.yang_name = "dst-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.mac_addr = []
                                                                                                    self.mask = []
                                                                                                    self._segment_path = lambda: "dst-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                            class AtmClp(Entity):
                                                                                                """
                                                                                                Match ATM CLP level
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                    self.yang_name = "atm-clp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "atm-clp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                            class FrDe(Entity):
                                                                                                """
                                                                                                Match FR DE value
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                    self.yang_name = "fr-de"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "fr-de"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                            class Ipv4Acl(Entity):
                                                                                                """
                                                                                                IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                    self.yang_name = "ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ipv4-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                            class Ipv6Acl(Entity):
                                                                                                """
                                                                                                IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                    self.yang_name = "ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ipv6-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                            class EtherServiceAcl(Entity):
                                                                                                """
                                                                                                Ethernet\-Services Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                    self.yang_name = "ether-service-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ether-service-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                            class AvailId(Entity):
                                                                                                """
                                                                                                Available Identifiers
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                    self.yang_name = "avail-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "avail-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                            class MediaType(Entity):
                                                                                                """
                                                                                                Media Type
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                    self.yang_name = "media-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "media-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                            class SubsProtocol(Entity):
                                                                                                """
                                                                                                Protocol
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                    self.yang_name = "subs-protocol"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "subs-protocol"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                            class Dnis(Entity):
                                                                                                """
                                                                                                DNIS
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                    self.yang_name = "dnis"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dnis"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                            class DnisRegex(Entity):
                                                                                                """
                                                                                                DNIS Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                    self.yang_name = "dnis-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dnis-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                            class Domain(Entity):
                                                                                                """
                                                                                                Domain Name
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                    self.yang_name = "domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                        ])
                                                                                                        self.domain_name = None
                                                                                                        self.format_name = None
                                                                                                        self._segment_path = lambda: "domain-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class DomainRegex(Entity):
                                                                                                """
                                                                                                Domain Regular Expression
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                    self.yang_name = "domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain-regex"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                        ])
                                                                                                        self.domain_name = None
                                                                                                        self.format_name = None
                                                                                                        self._segment_path = lambda: "domain-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class NasPort(Entity):
                                                                                                """
                                                                                                NAS Port
                                                                                                
                                                                                                .. attribute:: nas_port_array
                                                                                                
                                                                                                	nas port array
                                                                                                	**type**\: list of  		 :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                    self.yang_name = "nas-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("nas-port-array", ("nas_port_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.nas_port_array = YList(self)
                                                                                                    self._segment_path = lambda: "nas-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                                class NasPortArray(Entity):
                                                                                                    """
                                                                                                    nas port array
                                                                                                    
                                                                                                    .. attribute:: sub_id
                                                                                                    
                                                                                                    	sub id
                                                                                                    	**type**\:  :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                    
                                                                                                    .. attribute:: operator
                                                                                                    
                                                                                                    	operator
                                                                                                    	**type**\:  :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	value
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                        self.yang_name = "nas-port-array"
                                                                                                        self.yang_parent_name = "nas-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('sub_id', (YLeaf(YType.enumeration, 'sub-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchNasPortSubIdEn', '')])),
                                                                                                            ('operator', (YLeaf(YType.enumeration, 'operator'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchLogicalOperatorEn', '')])),
                                                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                                        ])
                                                                                                        self.sub_id = None
                                                                                                        self.operator = None
                                                                                                        self.value = None
                                                                                                        self._segment_path = lambda: "nas-port-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['sub_id', 'operator', 'value'], name, value)


                                                                                            class ServiceName(Entity):
                                                                                                """
                                                                                                Service Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                    self.yang_name = "service-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "service-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                            class ServiceNameRegex(Entity):
                                                                                                """
                                                                                                Service Name Regular Exp
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                    self.yang_name = "service-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "service-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                            class SrcAddrIpv4(Entity):
                                                                                                """
                                                                                                Source Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class DstAddrIpv4(Entity):
                                                                                                """
                                                                                                Destination Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class SrcAddrIpv6(Entity):
                                                                                                """
                                                                                                Source Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class DstAddrIpv6(Entity):
                                                                                                """
                                                                                                Destination Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class SrcAddrMac(Entity):
                                                                                                """
                                                                                                Source Address MAC
                                                                                                
                                                                                                .. attribute:: mac_addr_array
                                                                                                
                                                                                                	mac addr array
                                                                                                	**type**\: list of  		 :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                    self.yang_name = "src-addr-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("mac-addr-array", ("mac_addr_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.mac_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                                class MacAddrArray(Entity):
                                                                                                    """
                                                                                                    mac addr array
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                        self.yang_name = "mac-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                            ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.mac_addr = []
                                                                                                        self.mask = []
                                                                                                        self._segment_path = lambda: "mac-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                            class Timer(Entity):
                                                                                                """
                                                                                                Timer
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                    self.yang_name = "timer"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "timer"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                            class TimerRegexp(Entity):
                                                                                                """
                                                                                                Timer Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                    self.yang_name = "timer-regexp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "timer-regexp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                            class TunnelName(Entity):
                                                                                                """
                                                                                                Tunnel Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                    self.yang_name = "tunnel-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "tunnel-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                            class TunnelNameRegex(Entity):
                                                                                                """
                                                                                                Tunnel Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "tunnel-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                            class UserName(Entity):
                                                                                                """
                                                                                                User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                    self.yang_name = "user-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "user-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                            class UserNameRegex(Entity):
                                                                                                """
                                                                                                User Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                    self.yang_name = "user-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "user-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                            class AuthUsername(Entity):
                                                                                                """
                                                                                                Authenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                    self.yang_name = "auth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-username"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                            class AuthUsernameRegex(Entity):
                                                                                                """
                                                                                                Authenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "auth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-username-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                            class UnauthUsername(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                    self.yang_name = "unauth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-username"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                            class UnauthUsernameRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-username-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                            class AuthDomain(Entity):
                                                                                                """
                                                                                                Authenticated domain name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                    self.yang_name = "auth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                            class AuthDomainRegex(Entity):
                                                                                                """
                                                                                                Authenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "auth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                            class UnauthDomain(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                    self.yang_name = "unauth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                            class UnauthDomainRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                            class VendorId(Entity):
                                                                                                """
                                                                                                Vendor ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                    self.yang_name = "vendor-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "vendor-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                            class VendorIdRegex(Entity):
                                                                                                """
                                                                                                Vendor ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                    self.yang_name = "vendor-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "vendor-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                            class AccessInterface(Entity):
                                                                                                """
                                                                                                Access interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                    self.yang_name = "access-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "access-interface"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                            class InputInterface(Entity):
                                                                                                """
                                                                                                Input interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                    self.yang_name = "input-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "input-interface"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                            class InputIntfhdl(Entity):
                                                                                                """
                                                                                                Input interface handle
                                                                                                
                                                                                                .. attribute:: uint64_array
                                                                                                
                                                                                                	uint64 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..18446744073709551615
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                    self.yang_name = "input-intfhdl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint64_array', (YLeafList(YType.uint64, 'uint64_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint64_array = []
                                                                                                    self._segment_path = lambda: "input-intfhdl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                            class Ethertype(Entity):
                                                                                                """
                                                                                                Ethernet type
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                    self.yang_name = "ethertype"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ethertype"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ethertype"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FlowKeyData(Entity):
                                                                                                """
                                                                                                Flow key structure
                                                                                                
                                                                                                .. attribute:: flow_keys
                                                                                                
                                                                                                	flow keys
                                                                                                	**type**\:  :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                                
                                                                                                .. attribute:: max_count
                                                                                                
                                                                                                	Maximum count of flows
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: idle_timeout
                                                                                                
                                                                                                	Idle timeout of flows (in seconds)
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                	**units**\: second
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                    self.yang_name = "flow-key-data"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("flow-keys", ("flow_keys", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys))])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('max_count', (YLeaf(YType.uint16, 'max-count'), ['int'])),
                                                                                                        ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                                                    ])
                                                                                                    self.max_count = None
                                                                                                    self.idle_timeout = None

                                                                                                    self.flow_keys = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                    self.flow_keys.parent = self
                                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                    self._segment_path = lambda: "flow-key-data"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['max_count', 'idle_timeout'], name, value)


                                                                                                class FlowKeys(Entity):
                                                                                                    """
                                                                                                    flow keys
                                                                                                    
                                                                                                    .. attribute:: keys
                                                                                                    
                                                                                                    	keys
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                    
                                                                                                    .. attribute:: num
                                                                                                    
                                                                                                    	num
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                        self.yang_name = "flow-keys"
                                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('keys', (YLeaf(YType.str, 'keys'), ['str'])),
                                                                                                            ('num', (YLeaf(YType.uint8, 'num'), ['int'])),
                                                                                                        ])
                                                                                                        self.keys = None
                                                                                                        self.num = None
                                                                                                        self._segment_path = lambda: "flow-keys"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                            class DhcpClientId(Entity):
                                                                                                """
                                                                                                Dhcp Client ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dhcp-client-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                            class DhcpClientIdRegex(Entity):
                                                                                                """
                                                                                                Dhcp Client ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                            class CircuitId(Entity):
                                                                                                """
                                                                                                Circuit ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                    self.yang_name = "circuit-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "circuit-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                            class CircuitIdRegex(Entity):
                                                                                                """
                                                                                                Circuit ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                    self.yang_name = "circuit-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "circuit-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                            class RemoteId(Entity):
                                                                                                """
                                                                                                Remote ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                    self.yang_name = "remote-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "remote-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                            class RemoteIdRegex(Entity):
                                                                                                """
                                                                                                Remote ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                    self.yang_name = "remote-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "remote-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                            class SrcPort(Entity):
                                                                                                """
                                                                                                Source port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                    self.yang_name = "src-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "src-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class DstPort(Entity):
                                                                                                """
                                                                                                Destination port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                    self.yang_name = "dst-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "dst-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                    class Shape(Entity):
                                                                        """
                                                                        shape
                                                                        
                                                                        .. attribute:: bw
                                                                        
                                                                        	bw
                                                                        	**type**\:  :py:class:`Bw <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw>`
                                                                        
                                                                        .. attribute:: be
                                                                        
                                                                        	be
                                                                        	**type**\:  :py:class:`Be <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape, self).__init__()

                                                                            self.yang_name = "shape"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("bw", ("bw", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw)), ("be", ("be", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be))])
                                                                            self._leafs = OrderedDict()

                                                                            self.bw = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw()
                                                                            self.bw.parent = self
                                                                            self._children_name_map["bw"] = "bw"

                                                                            self.be = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be()
                                                                            self.be.parent = self
                                                                            self._children_name_map["be"] = "be"
                                                                            self._segment_path = lambda: "shape"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape, [], name, value)


                                                                        class Bw(Entity):
                                                                            """
                                                                            bw
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw, self).__init__()

                                                                                self.yang_name = "bw"
                                                                                self.yang_parent_name = "shape"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "bw"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw, ['value', 'unit'], name, value)


                                                                        class Be(Entity):
                                                                            """
                                                                            be
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be, self).__init__()

                                                                                self.yang_name = "be"
                                                                                self.yang_parent_name = "shape"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "be"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be, ['value', 'unit'], name, value)


                                                                    class ChildPolicy(Entity):
                                                                        """
                                                                        child policy
                                                                        
                                                                        .. attribute:: info
                                                                        
                                                                        	info
                                                                        	**type**\:  :py:class:`Info <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info>`
                                                                        
                                                                        .. attribute:: hd_info
                                                                        
                                                                        	hd info
                                                                        	**type**\:  :py:class:`HdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo>`
                                                                        
                                                                        .. attribute:: enc
                                                                        
                                                                        	enc
                                                                        	**type**\:  :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy, self).__init__()

                                                                            self.yang_name = "child-policy"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("info", ("info", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info)), ("hd-info", ("hd_info", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo))])
                                                                            self._leafs = OrderedDict([
                                                                                ('enc', (YLeaf(YType.enumeration, 'enc'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyObjEncEn', '')])),
                                                                            ])
                                                                            self.enc = None

                                                                            self.info = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info()
                                                                            self.info.parent = self
                                                                            self._children_name_map["info"] = "info"

                                                                            self.hd_info = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo()
                                                                            self.hd_info.parent = self
                                                                            self._children_name_map["hd_info"] = "hd-info"
                                                                            self._segment_path = lambda: "child-policy"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy, ['enc'], name, value)


                                                                        class Info(Entity):
                                                                            """
                                                                            info
                                                                            
                                                                            .. attribute:: name
                                                                            
                                                                            	name
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..65
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:  :py:class:`PolicyMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyMapTypeEn>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info, self).__init__()

                                                                                self.yang_name = "info"
                                                                                self.yang_parent_name = "child-policy"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyMapTypeEn', '')])),
                                                                                ])
                                                                                self.name = None
                                                                                self.type = None
                                                                                self._segment_path = lambda: "info"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info, ['name', 'type'], name, value)


                                                                        class HdInfo(Entity):
                                                                            """
                                                                            hd info
                                                                            
                                                                            .. attribute:: data_hd
                                                                            
                                                                            	data hd
                                                                            	**type**\:  :py:class:`DataHd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd>`
                                                                            
                                                                            .. attribute:: hd
                                                                            
                                                                            	hd
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo, self).__init__()

                                                                                self.yang_name = "hd-info"
                                                                                self.yang_parent_name = "child-policy"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("data-hd", ("data_hd", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('hd', (YLeaf(YType.uint64, 'hd'), ['int'])),
                                                                                ])
                                                                                self.hd = None

                                                                                self.data_hd = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd()
                                                                                self.data_hd.parent = self
                                                                                self._children_name_map["data_hd"] = "data-hd"
                                                                                self._segment_path = lambda: "hd-info"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo, ['hd'], name, value)


                                                                            class DataHd(Entity):
                                                                                """
                                                                                data hd
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd, self).__init__()

                                                                                    self.yang_name = "data-hd"
                                                                                    self.yang_parent_name = "hd-info"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict()
                                                                                    self._segment_path = lambda: "data-hd"
                                                                                    self._is_frozen = True


                                                                    class Cac(Entity):
                                                                        """
                                                                        cac
                                                                        
                                                                        .. attribute:: flow_rate
                                                                        
                                                                        	flow rate
                                                                        	**type**\:  :py:class:`FlowRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate>`
                                                                        
                                                                        .. attribute:: rate
                                                                        
                                                                        	rate
                                                                        	**type**\:  :py:class:`Rate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate>`
                                                                        
                                                                        .. attribute:: cac_type
                                                                        
                                                                        	cac type
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: idle_timeout
                                                                        
                                                                        	idle timeout
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..65535
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac, self).__init__()

                                                                            self.yang_name = "cac"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("flow-rate", ("flow_rate", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate)), ("rate", ("rate", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate))])
                                                                            self._leafs = OrderedDict([
                                                                                ('cac_type', (YLeaf(YType.uint8, 'cac-type'), ['int'])),
                                                                                ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                            ])
                                                                            self.cac_type = None
                                                                            self.idle_timeout = None

                                                                            self.flow_rate = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate()
                                                                            self.flow_rate.parent = self
                                                                            self._children_name_map["flow_rate"] = "flow-rate"

                                                                            self.rate = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate()
                                                                            self.rate.parent = self
                                                                            self._children_name_map["rate"] = "rate"
                                                                            self._segment_path = lambda: "cac"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac, ['cac_type', 'idle_timeout'], name, value)


                                                                        class FlowRate(Entity):
                                                                            """
                                                                            flow rate
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate, self).__init__()

                                                                                self.yang_name = "flow-rate"
                                                                                self.yang_parent_name = "cac"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "flow-rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate, ['value', 'unit'], name, value)


                                                                        class Rate(Entity):
                                                                            """
                                                                            rate
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate, self).__init__()

                                                                                self.yang_name = "rate"
                                                                                self.yang_parent_name = "cac"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate, ['value', 'unit'], name, value)


                                                                    class Pfc(Entity):
                                                                        """
                                                                        pfc
                                                                        
                                                                        .. attribute:: buffer_size
                                                                        
                                                                        	buffer size
                                                                        	**type**\:  :py:class:`BufferSize <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize>`
                                                                        
                                                                        .. attribute:: pause_threshold
                                                                        
                                                                        	pause threshold
                                                                        	**type**\:  :py:class:`PauseThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold>`
                                                                        
                                                                        .. attribute:: resume_threshold
                                                                        
                                                                        	resume threshold
                                                                        	**type**\:  :py:class:`ResumeThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold>`
                                                                        
                                                                        .. attribute:: pfc_pause_set
                                                                        
                                                                        	pfc pause set
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: buffer_size_flag
                                                                        
                                                                        	buffer size flag
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc, self).__init__()

                                                                            self.yang_name = "pfc"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("buffer-size", ("buffer_size", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize)), ("pause-threshold", ("pause_threshold", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold)), ("resume-threshold", ("resume_threshold", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold))])
                                                                            self._leafs = OrderedDict([
                                                                                ('pfc_pause_set', (YLeaf(YType.uint32, 'pfc-pause-set'), ['int'])),
                                                                                ('buffer_size_flag', (YLeaf(YType.uint32, 'buffer-size-flag'), ['int'])),
                                                                            ])
                                                                            self.pfc_pause_set = None
                                                                            self.buffer_size_flag = None

                                                                            self.buffer_size = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize()
                                                                            self.buffer_size.parent = self
                                                                            self._children_name_map["buffer_size"] = "buffer-size"

                                                                            self.pause_threshold = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold()
                                                                            self.pause_threshold.parent = self
                                                                            self._children_name_map["pause_threshold"] = "pause-threshold"

                                                                            self.resume_threshold = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold()
                                                                            self.resume_threshold.parent = self
                                                                            self._children_name_map["resume_threshold"] = "resume-threshold"
                                                                            self._segment_path = lambda: "pfc"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc, ['pfc_pause_set', 'buffer_size_flag'], name, value)


                                                                        class BufferSize(Entity):
                                                                            """
                                                                            buffer size
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize, self).__init__()

                                                                                self.yang_name = "buffer-size"
                                                                                self.yang_parent_name = "pfc"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "buffer-size"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize, ['value', 'unit'], name, value)


                                                                        class PauseThreshold(Entity):
                                                                            """
                                                                            pause threshold
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold, self).__init__()

                                                                                self.yang_name = "pause-threshold"
                                                                                self.yang_parent_name = "pfc"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "pause-threshold"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold, ['value', 'unit'], name, value)


                                                                        class ResumeThreshold(Entity):
                                                                            """
                                                                            resume threshold
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold, self).__init__()

                                                                                self.yang_name = "resume-threshold"
                                                                                self.yang_parent_name = "pfc"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "resume-threshold"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold, ['value', 'unit'], name, value)


                                                                    class FlowParm(Entity):
                                                                        """
                                                                        flow parm
                                                                        
                                                                        .. attribute:: max_mon_flows
                                                                        
                                                                        	max simult flows monitored per policy class
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: mon_interval
                                                                        
                                                                        	monitored interval duration in secs
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: second
                                                                        
                                                                        .. attribute:: intvl_hist
                                                                        
                                                                        	num intervals of data stored on rtr
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: flow_timeout
                                                                        
                                                                        	timeout in secs
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: second
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm, self).__init__()

                                                                            self.yang_name = "flow-parm"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('max_mon_flows', (YLeaf(YType.uint32, 'max-mon-flows'), ['int'])),
                                                                                ('mon_interval', (YLeaf(YType.uint32, 'mon-interval'), ['int'])),
                                                                                ('intvl_hist', (YLeaf(YType.uint32, 'intvl-hist'), ['int'])),
                                                                                ('flow_timeout', (YLeaf(YType.uint32, 'flow-timeout'), ['int'])),
                                                                            ])
                                                                            self.max_mon_flows = None
                                                                            self.mon_interval = None
                                                                            self.intvl_hist = None
                                                                            self.flow_timeout = None
                                                                            self._segment_path = lambda: "flow-parm"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm, ['max_mon_flows', 'mon_interval', 'intvl_hist', 'flow_timeout'], name, value)


                                                                    class Ipcbr(Entity):
                                                                        """
                                                                        ipcbr
                                                                        
                                                                        .. attribute:: ip_bit_rate
                                                                        
                                                                        	data rate in bps
                                                                        	**type**\:  :py:class:`IpBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate>`
                                                                        
                                                                        .. attribute:: media_bit_rate
                                                                        
                                                                        	media data rate in bps
                                                                        	**type**\:  :py:class:`MediaBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate>`
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: ip_pkt_rate
                                                                        
                                                                        	packet rate in pps
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: media_pkt_size
                                                                        
                                                                        	media packet size in bytes
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: media_pkts_per_ip
                                                                        
                                                                        	media packets per ip pkt
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr, self).__init__()

                                                                            self.yang_name = "ipcbr"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("ip-bit-rate", ("ip_bit_rate", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate)), ("media-bit-rate", ("media_bit_rate", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate))])
                                                                            self._leafs = OrderedDict([
                                                                                ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                                ('ip_pkt_rate', (YLeaf(YType.uint32, 'ip-pkt-rate'), ['int'])),
                                                                                ('media_pkt_size', (YLeaf(YType.uint32, 'media-pkt-size'), ['int'])),
                                                                                ('media_pkts_per_ip', (YLeaf(YType.uint32, 'media-pkts-per-ip'), ['int'])),
                                                                            ])
                                                                            self.action_metric_type = None
                                                                            self.ip_pkt_rate = None
                                                                            self.media_pkt_size = None
                                                                            self.media_pkts_per_ip = None

                                                                            self.ip_bit_rate = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate()
                                                                            self.ip_bit_rate.parent = self
                                                                            self._children_name_map["ip_bit_rate"] = "ip-bit-rate"

                                                                            self.media_bit_rate = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate()
                                                                            self.media_bit_rate.parent = self
                                                                            self._children_name_map["media_bit_rate"] = "media-bit-rate"
                                                                            self._segment_path = lambda: "ipcbr"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr, ['action_metric_type', 'ip_pkt_rate', 'media_pkt_size', 'media_pkts_per_ip'], name, value)


                                                                        class IpBitRate(Entity):
                                                                            """
                                                                            data rate in bps
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate, self).__init__()

                                                                                self.yang_name = "ip-bit-rate"
                                                                                self.yang_parent_name = "ipcbr"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "ip-bit-rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate, ['value', 'unit'], name, value)


                                                                        class MediaBitRate(Entity):
                                                                            """
                                                                            media data rate in bps
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate, self).__init__()

                                                                                self.yang_name = "media-bit-rate"
                                                                                self.yang_parent_name = "ipcbr"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "media-bit-rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate, ['value', 'unit'], name, value)


                                                                    class Rtp(Entity):
                                                                        """
                                                                        rtp
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: min_sequential
                                                                        
                                                                        	min sequential
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_dropout
                                                                        
                                                                        	max dropout
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_misorder
                                                                        
                                                                        	max misorder
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: seq_ext_cop4
                                                                        
                                                                        	enable seq extension cop4
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: clock_rate
                                                                        
                                                                        	clock rate
                                                                        	**type**\: list of  		 :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp, self).__init__()

                                                                            self.yang_name = "rtp"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("clock-rate", ("clock_rate", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate))])
                                                                            self._leafs = OrderedDict([
                                                                                ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                                ('min_sequential', (YLeaf(YType.uint32, 'min-sequential'), ['int'])),
                                                                                ('max_dropout', (YLeaf(YType.uint32, 'max-dropout'), ['int'])),
                                                                                ('max_misorder', (YLeaf(YType.uint32, 'max-misorder'), ['int'])),
                                                                                ('seq_ext_cop4', (YLeaf(YType.uint32, 'seq-ext-cop4'), ['int'])),
                                                                            ])
                                                                            self.action_metric_type = None
                                                                            self.min_sequential = None
                                                                            self.max_dropout = None
                                                                            self.max_misorder = None
                                                                            self.seq_ext_cop4 = None

                                                                            self.clock_rate = YList(self)
                                                                            self._segment_path = lambda: "rtp"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp, ['action_metric_type', 'min_sequential', 'max_dropout', 'max_misorder', 'seq_ext_cop4'], name, value)


                                                                        class ClockRate(Entity):
                                                                            """
                                                                            clock rate
                                                                            
                                                                            .. attribute:: pt
                                                                            
                                                                            	pt
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: frequency
                                                                            
                                                                            	frequency
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate, self).__init__()

                                                                                self.yang_name = "clock-rate"
                                                                                self.yang_parent_name = "rtp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('pt', (YLeaf(YType.uint32, 'pt'), ['int'])),
                                                                                    ('frequency', (YLeaf(YType.uint32, 'frequency'), ['int'])),
                                                                                ])
                                                                                self.pt = None
                                                                                self.frequency = None
                                                                                self._segment_path = lambda: "clock-rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate, ['pt', 'frequency'], name, value)


                                                                    class RtpMmr(Entity):
                                                                        """
                                                                        rtp mmr
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: min_sequential
                                                                        
                                                                        	min sequential
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_dropout
                                                                        
                                                                        	max dropout
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_misorder
                                                                        
                                                                        	max misorder
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: seq_ext_cop4
                                                                        
                                                                        	enable seq extension cop4
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: clock_rate
                                                                        
                                                                        	clock rate
                                                                        	**type**\: list of  		 :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr, self).__init__()

                                                                            self.yang_name = "rtp-mmr"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("clock-rate", ("clock_rate", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate))])
                                                                            self._leafs = OrderedDict([
                                                                                ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                                ('min_sequential', (YLeaf(YType.uint32, 'min-sequential'), ['int'])),
                                                                                ('max_dropout', (YLeaf(YType.uint32, 'max-dropout'), ['int'])),
                                                                                ('max_misorder', (YLeaf(YType.uint32, 'max-misorder'), ['int'])),
                                                                                ('seq_ext_cop4', (YLeaf(YType.uint32, 'seq-ext-cop4'), ['int'])),
                                                                            ])
                                                                            self.action_metric_type = None
                                                                            self.min_sequential = None
                                                                            self.max_dropout = None
                                                                            self.max_misorder = None
                                                                            self.seq_ext_cop4 = None

                                                                            self.clock_rate = YList(self)
                                                                            self._segment_path = lambda: "rtp-mmr"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr, ['action_metric_type', 'min_sequential', 'max_dropout', 'max_misorder', 'seq_ext_cop4'], name, value)


                                                                        class ClockRate(Entity):
                                                                            """
                                                                            clock rate
                                                                            
                                                                            .. attribute:: pt
                                                                            
                                                                            	pt
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: frequency
                                                                            
                                                                            	frequency
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate, self).__init__()

                                                                                self.yang_name = "clock-rate"
                                                                                self.yang_parent_name = "rtp-mmr"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('pt', (YLeaf(YType.uint32, 'pt'), ['int'])),
                                                                                    ('frequency', (YLeaf(YType.uint32, 'frequency'), ['int'])),
                                                                                ])
                                                                                self.pt = None
                                                                                self.frequency = None
                                                                                self._segment_path = lambda: "clock-rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate, ['pt', 'frequency'], name, value)


                                                                    class RtpJ2k(Entity):
                                                                        """
                                                                        rtp j2k
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: min_sequential
                                                                        
                                                                        	min sequential
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_dropout
                                                                        
                                                                        	max dropout
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_misorder
                                                                        
                                                                        	max misorder
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: seq_ext_cop4
                                                                        
                                                                        	enable seq extension cop4
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: clock_rate
                                                                        
                                                                        	clock rate
                                                                        	**type**\: list of  		 :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k.ClockRate>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k, self).__init__()

                                                                            self.yang_name = "rtp-j2k"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("clock-rate", ("clock_rate", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k.ClockRate))])
                                                                            self._leafs = OrderedDict([
                                                                                ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                                ('min_sequential', (YLeaf(YType.uint32, 'min-sequential'), ['int'])),
                                                                                ('max_dropout', (YLeaf(YType.uint32, 'max-dropout'), ['int'])),
                                                                                ('max_misorder', (YLeaf(YType.uint32, 'max-misorder'), ['int'])),
                                                                                ('seq_ext_cop4', (YLeaf(YType.uint32, 'seq-ext-cop4'), ['int'])),
                                                                            ])
                                                                            self.action_metric_type = None
                                                                            self.min_sequential = None
                                                                            self.max_dropout = None
                                                                            self.max_misorder = None
                                                                            self.seq_ext_cop4 = None

                                                                            self.clock_rate = YList(self)
                                                                            self._segment_path = lambda: "rtp-j2k"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k, ['action_metric_type', 'min_sequential', 'max_dropout', 'max_misorder', 'seq_ext_cop4'], name, value)


                                                                        class ClockRate(Entity):
                                                                            """
                                                                            clock rate
                                                                            
                                                                            .. attribute:: pt
                                                                            
                                                                            	pt
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: frequency
                                                                            
                                                                            	frequency
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k.ClockRate, self).__init__()

                                                                                self.yang_name = "clock-rate"
                                                                                self.yang_parent_name = "rtp-j2k"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('pt', (YLeaf(YType.uint32, 'pt'), ['int'])),
                                                                                    ('frequency', (YLeaf(YType.uint32, 'frequency'), ['int'])),
                                                                                ])
                                                                                self.pt = None
                                                                                self.frequency = None
                                                                                self._segment_path = lambda: "clock-rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k.ClockRate, ['pt', 'frequency'], name, value)


                                                                    class RtpVoice(Entity):
                                                                        """
                                                                        rtp voice
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: min_sequential
                                                                        
                                                                        	min sequential
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_dropout
                                                                        
                                                                        	max dropout
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_misorder
                                                                        
                                                                        	max misorder
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: seq_ext_cop4
                                                                        
                                                                        	enable seq extension cop4
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: clock_rate
                                                                        
                                                                        	clock rate
                                                                        	**type**\: list of  		 :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice, self).__init__()

                                                                            self.yang_name = "rtp-voice"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("clock-rate", ("clock_rate", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate))])
                                                                            self._leafs = OrderedDict([
                                                                                ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                                ('min_sequential', (YLeaf(YType.uint32, 'min-sequential'), ['int'])),
                                                                                ('max_dropout', (YLeaf(YType.uint32, 'max-dropout'), ['int'])),
                                                                                ('max_misorder', (YLeaf(YType.uint32, 'max-misorder'), ['int'])),
                                                                                ('seq_ext_cop4', (YLeaf(YType.uint32, 'seq-ext-cop4'), ['int'])),
                                                                            ])
                                                                            self.action_metric_type = None
                                                                            self.min_sequential = None
                                                                            self.max_dropout = None
                                                                            self.max_misorder = None
                                                                            self.seq_ext_cop4 = None

                                                                            self.clock_rate = YList(self)
                                                                            self._segment_path = lambda: "rtp-voice"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice, ['action_metric_type', 'min_sequential', 'max_dropout', 'max_misorder', 'seq_ext_cop4'], name, value)


                                                                        class ClockRate(Entity):
                                                                            """
                                                                            clock rate
                                                                            
                                                                            .. attribute:: pt
                                                                            
                                                                            	pt
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: frequency
                                                                            
                                                                            	frequency
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate, self).__init__()

                                                                                self.yang_name = "clock-rate"
                                                                                self.yang_parent_name = "rtp-voice"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('pt', (YLeaf(YType.uint32, 'pt'), ['int'])),
                                                                                    ('frequency', (YLeaf(YType.uint32, 'frequency'), ['int'])),
                                                                                ])
                                                                                self.pt = None
                                                                                self.frequency = None
                                                                                self._segment_path = lambda: "clock-rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate, ['pt', 'frequency'], name, value)


                                                                    class Mdi(Entity):
                                                                        """
                                                                        mdi
                                                                        
                                                                        .. attribute:: ip_bit_rate
                                                                        
                                                                        	data rate in bps
                                                                        	**type**\:  :py:class:`IpBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate>`
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: filtered_pkt_rate
                                                                        
                                                                        	filtered packet rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: ip_pkt_rate
                                                                        
                                                                        	packet rate in pps
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: pids
                                                                        
                                                                        	array of monitoredcd  pids
                                                                        	**type**\: list of int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi, self).__init__()

                                                                            self.yang_name = "mdi"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("ip-bit-rate", ("ip_bit_rate", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate))])
                                                                            self._leafs = OrderedDict([
                                                                                ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                                ('filtered_pkt_rate', (YLeaf(YType.uint32, 'filtered-pkt-rate'), ['int'])),
                                                                                ('ip_pkt_rate', (YLeaf(YType.uint32, 'ip-pkt-rate'), ['int'])),
                                                                                ('pids', (YLeafList(YType.uint32, 'pids'), ['int'])),
                                                                            ])
                                                                            self.action_metric_type = None
                                                                            self.filtered_pkt_rate = None
                                                                            self.ip_pkt_rate = None
                                                                            self.pids = []

                                                                            self.ip_bit_rate = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate()
                                                                            self.ip_bit_rate.parent = self
                                                                            self._children_name_map["ip_bit_rate"] = "ip-bit-rate"
                                                                            self._segment_path = lambda: "mdi"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi, ['action_metric_type', 'filtered_pkt_rate', 'ip_pkt_rate', 'pids'], name, value)


                                                                        class IpBitRate(Entity):
                                                                            """
                                                                            data rate in bps
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate, self).__init__()

                                                                                self.yang_name = "ip-bit-rate"
                                                                                self.yang_parent_name = "mdi"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "ip-bit-rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate, ['value', 'unit'], name, value)


                                                                    class MdiRtp(Entity):
                                                                        """
                                                                        mdi rtp
                                                                        
                                                                        .. attribute:: ip_bit_rate
                                                                        
                                                                        	data rate in bps
                                                                        	**type**\:  :py:class:`IpBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate>`
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: filtered_pkt_rate
                                                                        
                                                                        	filtered packet rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: ip_pkt_rate
                                                                        
                                                                        	packet rate in pps
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: pids
                                                                        
                                                                        	array of monitoredcd  pids
                                                                        	**type**\: list of int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp, self).__init__()

                                                                            self.yang_name = "mdi-rtp"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("ip-bit-rate", ("ip_bit_rate", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate))])
                                                                            self._leafs = OrderedDict([
                                                                                ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                                ('filtered_pkt_rate', (YLeaf(YType.uint32, 'filtered-pkt-rate'), ['int'])),
                                                                                ('ip_pkt_rate', (YLeaf(YType.uint32, 'ip-pkt-rate'), ['int'])),
                                                                                ('pids', (YLeafList(YType.uint32, 'pids'), ['int'])),
                                                                            ])
                                                                            self.action_metric_type = None
                                                                            self.filtered_pkt_rate = None
                                                                            self.ip_pkt_rate = None
                                                                            self.pids = []

                                                                            self.ip_bit_rate = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate()
                                                                            self.ip_bit_rate.parent = self
                                                                            self._children_name_map["ip_bit_rate"] = "ip-bit-rate"
                                                                            self._segment_path = lambda: "mdi-rtp"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp, ['action_metric_type', 'filtered_pkt_rate', 'ip_pkt_rate', 'pids'], name, value)


                                                                        class IpBitRate(Entity):
                                                                            """
                                                                            data rate in bps
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate, self).__init__()

                                                                                self.yang_name = "ip-bit-rate"
                                                                                self.yang_parent_name = "mdi-rtp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "ip-bit-rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate, ['value', 'unit'], name, value)


                                                                    class Fmm(Entity):
                                                                        """
                                                                        fmm
                                                                        
                                                                        .. attribute:: fmm_name
                                                                        
                                                                        	flow monitor name
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..33
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm, self).__init__()

                                                                            self.yang_name = "fmm"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('fmm_name', (YLeaf(YType.str, 'fmm-name'), ['str'])),
                                                                            ])
                                                                            self.fmm_name = None
                                                                            self._segment_path = lambda: "fmm"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm, ['fmm_name'], name, value)


                                                                    class Pbf(Entity):
                                                                        """
                                                                        pbf
                                                                        
                                                                        .. attribute:: action_pbf_info_array
                                                                        
                                                                        	action pbf info array
                                                                        	**type**\: list of  		 :py:class:`ActionPbfInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf, self).__init__()

                                                                            self.yang_name = "pbf"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("action-pbf-info-array", ("action_pbf_info_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.action_pbf_info_array = YList(self)
                                                                            self._segment_path = lambda: "pbf"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf, [], name, value)


                                                                        class ActionPbfInfoArray(Entity):
                                                                            """
                                                                            action pbf info array
                                                                            
                                                                            .. attribute:: addr
                                                                            
                                                                            	v4 or v6 address
                                                                            	**type**\: str
                                                                            
                                                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                            
                                                                            .. attribute:: vrf
                                                                            
                                                                            	vrf name
                                                                            	**type**\: str
                                                                            
                                                                            .. attribute:: rt_type
                                                                            
                                                                            	route target type
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: rt
                                                                            
                                                                            	route target
                                                                            	**type**\: str
                                                                            
                                                                            	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray, self).__init__()

                                                                                self.yang_name = "action-pbf-info-array"
                                                                                self.yang_parent_name = "pbf"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('addr', (YLeaf(YType.str, 'addr'), ['str'])),
                                                                                    ('vrf', (YLeaf(YType.str, 'vrf'), ['str'])),
                                                                                    ('rt_type', (YLeaf(YType.uint8, 'rt-type'), ['int'])),
                                                                                    ('rt', (YLeaf(YType.str, 'rt'), ['str'])),
                                                                                ])
                                                                                self.addr = None
                                                                                self.vrf = None
                                                                                self.rt_type = None
                                                                                self.rt = None
                                                                                self._segment_path = lambda: "action-pbf-info-array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray, ['addr', 'vrf', 'rt_type', 'rt'], name, value)


                                                                    class Ipv4Nh(Entity):
                                                                        """
                                                                        ipv4 nh
                                                                        
                                                                        .. attribute:: action_ipv4_nh_info_array
                                                                        
                                                                        	action ipv4 nh info array
                                                                        	**type**\: list of  		 :py:class:`ActionIpv4NhInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh, self).__init__()

                                                                            self.yang_name = "ipv4-nh"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("action-ipv4-nh-info-array", ("action_ipv4_nh_info_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.action_ipv4_nh_info_array = YList(self)
                                                                            self._segment_path = lambda: "ipv4-nh"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh, [], name, value)


                                                                        class ActionIpv4NhInfoArray(Entity):
                                                                            """
                                                                            action ipv4 nh info array
                                                                            
                                                                            .. attribute:: nh_addr
                                                                            
                                                                            	nh addr
                                                                            	**type**\: str
                                                                            
                                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                            
                                                                            .. attribute:: vrf_name
                                                                            
                                                                            	Vrf name
                                                                            	**type**\: str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray, self).__init__()

                                                                                self.yang_name = "action-ipv4-nh-info-array"
                                                                                self.yang_parent_name = "ipv4-nh"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('nh_addr', (YLeaf(YType.str, 'nh-addr'), ['str'])),
                                                                                    ('vrf_name', (YLeaf(YType.str, 'vrf-name'), ['str'])),
                                                                                ])
                                                                                self.nh_addr = None
                                                                                self.vrf_name = None
                                                                                self._segment_path = lambda: "action-ipv4-nh-info-array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray, ['nh_addr', 'vrf_name'], name, value)


                                                                    class Ipv6Nh(Entity):
                                                                        """
                                                                        ipv6 nh
                                                                        
                                                                        .. attribute:: action_ipv6_nh_info_array
                                                                        
                                                                        	action ipv6 nh info array
                                                                        	**type**\: list of  		 :py:class:`ActionIpv6NhInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh, self).__init__()

                                                                            self.yang_name = "ipv6-nh"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("action-ipv6-nh-info-array", ("action_ipv6_nh_info_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.action_ipv6_nh_info_array = YList(self)
                                                                            self._segment_path = lambda: "ipv6-nh"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh, [], name, value)


                                                                        class ActionIpv6NhInfoArray(Entity):
                                                                            """
                                                                            action ipv6 nh info array
                                                                            
                                                                            .. attribute:: nh_addr
                                                                            
                                                                            	IPV6 Address
                                                                            	**type**\: str
                                                                            
                                                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                            
                                                                            .. attribute:: vrf_name
                                                                            
                                                                            	Vrf name
                                                                            	**type**\: str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray, self).__init__()

                                                                                self.yang_name = "action-ipv6-nh-info-array"
                                                                                self.yang_parent_name = "ipv6-nh"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('nh_addr', (YLeaf(YType.str, 'nh-addr'), ['str'])),
                                                                                    ('vrf_name', (YLeaf(YType.str, 'vrf-name'), ['str'])),
                                                                                ])
                                                                                self.nh_addr = None
                                                                                self.vrf_name = None
                                                                                self._segment_path = lambda: "action-ipv6-nh-info-array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray, ['nh_addr', 'vrf_name'], name, value)


                                class PmapVarList(Entity):
                                    """
                                    pmap var list
                                    
                                    .. attribute:: var_list
                                    
                                    	var list
                                    	**type**\: list of  		 :py:class:`VarList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.PmapVarList.VarList>`
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2018-01-17'

                                    def __init__(self):
                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.PmapVarList, self).__init__()

                                        self.yang_name = "pmap-var-list"
                                        self.yang_parent_name = "detail"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("var-list", ("var_list", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.PmapVarList.VarList))])
                                        self._leafs = OrderedDict()

                                        self.var_list = YList(self)
                                        self._segment_path = lambda: "pmap-var-list"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.PmapVarList, [], name, value)


                                    class VarList(Entity):
                                        """
                                        var list
                                        
                                        .. attribute:: type
                                        
                                        	type
                                        	**type**\:  :py:class:`PlmgrVarTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrVarTypeEn>`
                                        
                                        .. attribute:: class_name
                                        
                                        	class name
                                        	**type**\: str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: uint8_val
                                        
                                        	uint8 val
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: uint16_val
                                        
                                        	uint16 val
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: uint32_val
                                        
                                        	uint32 val
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: param_uint32_val
                                        
                                        	param uint32 val
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: dscp_val
                                        
                                        	dscp val
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: prec_val
                                        
                                        	prec val
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'infra-policymgr-oper'
                                        _revision = '2018-01-17'

                                        def __init__(self):
                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.PmapVarList.VarList, self).__init__()

                                            self.yang_name = "var-list"
                                            self.yang_parent_name = "pmap-var-list"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PlmgrVarTypeEn', '')])),
                                                ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                ('uint8_val', (YLeaf(YType.uint8, 'uint8_val'), ['int'])),
                                                ('uint16_val', (YLeaf(YType.uint16, 'uint16_val'), ['int'])),
                                                ('uint32_val', (YLeaf(YType.uint32, 'uint32_val'), ['int'])),
                                                ('param_uint32_val', (YLeaf(YType.uint32, 'param-uint32-val'), ['int'])),
                                                ('dscp_val', (YLeaf(YType.uint8, 'dscp-val'), ['int'])),
                                                ('prec_val', (YLeaf(YType.uint8, 'prec-val'), ['int'])),
                                            ])
                                            self.type = None
                                            self.class_name = None
                                            self.uint8_val = None
                                            self.uint16_val = None
                                            self.uint32_val = None
                                            self.param_uint32_val = None
                                            self.dscp_val = None
                                            self.prec_val = None
                                            self._segment_path = lambda: "var-list"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.PmapVarList.VarList, ['type', 'class_name', 'uint8_val', 'uint16_val', 'uint32_val', 'param_uint32_val', 'dscp_val', 'prec_val'], name, value)


                        class TransientInput(Entity):
                            """
                            Input direction table
                            
                            .. attribute:: detail
                            
                            	Policy map
                            	**type**\:  :py:class:`Detail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail>`
                            
                            

                            """

                            _prefix = 'infra-policymgr-oper'
                            _revision = '2018-01-17'

                            def __init__(self):
                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput, self).__init__()

                                self.yang_name = "transient-input"
                                self.yang_parent_name = "transient-interface-name"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("detail", ("detail", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail))])
                                self._leafs = OrderedDict()

                                self.detail = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail()
                                self.detail.parent = self
                                self._children_name_map["detail"] = "detail"
                                self._segment_path = lambda: "transient-input"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput, [], name, value)


                            class Detail(Entity):
                                """
                                Policy map
                                
                                .. attribute:: parent_pmap_name
                                
                                	parent pmap name
                                	**type**\: str
                                
                                	**length:** 0..65
                                
                                .. attribute:: pmap_type
                                
                                	pmap type
                                	**type**\:  :py:class:`PolicyMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyMapTypeEn>`
                                
                                .. attribute:: subscriber_grp
                                
                                	subscriber grp
                                	**type**\: list of str
                                
                                	**length:** 0..65
                                
                                .. attribute:: pmaps
                                
                                	pmaps
                                	**type**\: list of  		 :py:class:`Pmaps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps>`
                                
                                .. attribute:: pmap_var_list
                                
                                	pmap var list
                                	**type**\: list of  		 :py:class:`PmapVarList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.PmapVarList>`
                                
                                

                                """

                                _prefix = 'infra-policymgr-oper'
                                _revision = '2018-01-17'

                                def __init__(self):
                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail, self).__init__()

                                    self.yang_name = "detail"
                                    self.yang_parent_name = "transient-input"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("pmaps", ("pmaps", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps)), ("pmap-var-list", ("pmap_var_list", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.PmapVarList))])
                                    self._leafs = OrderedDict([
                                        ('parent_pmap_name', (YLeaf(YType.str, 'parent-pmap-name'), ['str'])),
                                        ('pmap_type', (YLeaf(YType.enumeration, 'pmap-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyMapTypeEn', '')])),
                                        ('subscriber_grp', (YLeafList(YType.str, 'subscriber-grp'), ['str'])),
                                    ])
                                    self.parent_pmap_name = None
                                    self.pmap_type = None
                                    self.subscriber_grp = []

                                    self.pmaps = YList(self)
                                    self.pmap_var_list = YList(self)
                                    self._segment_path = lambda: "detail"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail, ['parent_pmap_name', 'pmap_type', 'subscriber_grp'], name, value)


                                class Pmaps(Entity):
                                    """
                                    pmaps
                                    
                                    .. attribute:: policy_map_bg
                                    
                                    	policy map bg
                                    	**type**\: list of  		 :py:class:`PolicyMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg>`
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2018-01-17'

                                    def __init__(self):
                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps, self).__init__()

                                        self.yang_name = "pmaps"
                                        self.yang_parent_name = "detail"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("policy-map-bg", ("policy_map_bg", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg))])
                                        self._leafs = OrderedDict()

                                        self.policy_map_bg = YList(self)
                                        self._segment_path = lambda: "pmaps"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps, [], name, value)


                                    class PolicyMapBg(Entity):
                                        """
                                        policy map bg
                                        
                                        .. attribute:: pmap_var_list
                                        
                                        	pmap var list
                                        	**type**\:  :py:class:`PmapVarList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.PmapVarList>`
                                        
                                        .. attribute:: event_infop
                                        
                                        	event infop
                                        	**type**\:  :py:class:`EventInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop>`
                                        
                                        .. attribute:: name
                                        
                                        	name
                                        	**type**\: str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: type
                                        
                                        	type
                                        	**type**\:  :py:class:`PolicyMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyMapTypeEn>`
                                        
                                        .. attribute:: description
                                        
                                        	description
                                        	**type**\: str
                                        
                                        

                                        """

                                        _prefix = 'infra-policymgr-oper'
                                        _revision = '2018-01-17'

                                        def __init__(self):
                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg, self).__init__()

                                            self.yang_name = "policy-map-bg"
                                            self.yang_parent_name = "pmaps"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("pmap-var-list", ("pmap_var_list", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.PmapVarList)), ("event-infop", ("event_infop", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop))])
                                            self._leafs = OrderedDict([
                                                ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyMapTypeEn', '')])),
                                                ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                            ])
                                            self.name = None
                                            self.type = None
                                            self.description = None

                                            self.pmap_var_list = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.PmapVarList()
                                            self.pmap_var_list.parent = self
                                            self._children_name_map["pmap_var_list"] = "pmap-var-list"

                                            self.event_infop = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop()
                                            self.event_infop.parent = self
                                            self._children_name_map["event_infop"] = "event-infop"
                                            self._segment_path = lambda: "policy-map-bg"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg, ['name', 'type', 'description'], name, value)


                                        class PmapVarList(Entity):
                                            """
                                            pmap var list
                                            
                                            .. attribute:: pmap_var_list_arr
                                            
                                            	pmap var list arr
                                            	**type**\: list of  		 :py:class:`PmapVarListArr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.PmapVarList.PmapVarListArr>`
                                            
                                            

                                            """

                                            _prefix = 'infra-policymgr-oper'
                                            _revision = '2018-01-17'

                                            def __init__(self):
                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.PmapVarList, self).__init__()

                                                self.yang_name = "pmap-var-list"
                                                self.yang_parent_name = "policy-map-bg"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("pmap-var-list-arr", ("pmap_var_list_arr", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.PmapVarList.PmapVarListArr))])
                                                self._leafs = OrderedDict()

                                                self.pmap_var_list_arr = YList(self)
                                                self._segment_path = lambda: "pmap-var-list"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.PmapVarList, [], name, value)


                                            class PmapVarListArr(Entity):
                                                """
                                                pmap var list arr
                                                
                                                .. attribute:: val
                                                
                                                	val
                                                	**type**\:  :py:class:`Val <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.PmapVarList.PmapVarListArr.Val>`
                                                
                                                .. attribute:: name
                                                
                                                	name
                                                	**type**\: str
                                                
                                                	**length:** 0..32
                                                
                                                .. attribute:: id
                                                
                                                	id
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.PmapVarList.PmapVarListArr, self).__init__()

                                                    self.yang_name = "pmap-var-list-arr"
                                                    self.yang_parent_name = "pmap-var-list"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("val", ("val", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.PmapVarList.PmapVarListArr.Val))])
                                                    self._leafs = OrderedDict([
                                                        ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                        ('id', (YLeaf(YType.uint32, 'id'), ['int'])),
                                                    ])
                                                    self.name = None
                                                    self.id = None

                                                    self.val = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.PmapVarList.PmapVarListArr.Val()
                                                    self.val.parent = self
                                                    self._children_name_map["val"] = "val"
                                                    self._segment_path = lambda: "pmap-var-list-arr"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.PmapVarList.PmapVarListArr, ['name', 'id'], name, value)


                                                class Val(Entity):
                                                    """
                                                    val
                                                    
                                                    .. attribute:: type
                                                    
                                                    	type
                                                    	**type**\:  :py:class:`PlmgrVarTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrVarTypeEn>`
                                                    
                                                    .. attribute:: class_name
                                                    
                                                    	class name
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..65
                                                    
                                                    .. attribute:: uint8_val
                                                    
                                                    	uint8 val
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: uint16_val
                                                    
                                                    	uint16 val
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: uint32_val
                                                    
                                                    	uint32 val
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: param_uint32_val
                                                    
                                                    	param uint32 val
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: dscp_val
                                                    
                                                    	dscp val
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: prec_val
                                                    
                                                    	prec val
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.PmapVarList.PmapVarListArr.Val, self).__init__()

                                                        self.yang_name = "val"
                                                        self.yang_parent_name = "pmap-var-list-arr"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PlmgrVarTypeEn', '')])),
                                                            ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                            ('uint8_val', (YLeaf(YType.uint8, 'uint8_val'), ['int'])),
                                                            ('uint16_val', (YLeaf(YType.uint16, 'uint16_val'), ['int'])),
                                                            ('uint32_val', (YLeaf(YType.uint32, 'uint32_val'), ['int'])),
                                                            ('param_uint32_val', (YLeaf(YType.uint32, 'param-uint32-val'), ['int'])),
                                                            ('dscp_val', (YLeaf(YType.uint8, 'dscp-val'), ['int'])),
                                                            ('prec_val', (YLeaf(YType.uint8, 'prec-val'), ['int'])),
                                                        ])
                                                        self.type = None
                                                        self.class_name = None
                                                        self.uint8_val = None
                                                        self.uint16_val = None
                                                        self.uint32_val = None
                                                        self.param_uint32_val = None
                                                        self.dscp_val = None
                                                        self.prec_val = None
                                                        self._segment_path = lambda: "val"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.PmapVarList.PmapVarListArr.Val, ['type', 'class_name', 'uint8_val', 'uint16_val', 'uint32_val', 'param_uint32_val', 'dscp_val', 'prec_val'], name, value)


                                        class EventInfop(Entity):
                                            """
                                            event infop
                                            
                                            .. attribute:: policy_event_info_bg
                                            
                                            	policy event info bg
                                            	**type**\: list of  		 :py:class:`PolicyEventInfoBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg>`
                                            
                                            

                                            """

                                            _prefix = 'infra-policymgr-oper'
                                            _revision = '2018-01-17'

                                            def __init__(self):
                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop, self).__init__()

                                                self.yang_name = "event-infop"
                                                self.yang_parent_name = "policy-map-bg"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("policy-event-info-bg", ("policy_event_info_bg", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg))])
                                                self._leafs = OrderedDict()

                                                self.policy_event_info_bg = YList(self)
                                                self._segment_path = lambda: "event-infop"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop, [], name, value)


                                            class PolicyEventInfoBg(Entity):
                                                """
                                                policy event info bg
                                                
                                                .. attribute:: class_infop
                                                
                                                	class infop
                                                	**type**\:  :py:class:`ClassInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop>`
                                                
                                                .. attribute:: event_type
                                                
                                                	event type
                                                	**type**\:  :py:class:`PeventTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PeventTypeEn>`
                                                
                                                .. attribute:: cond_eval
                                                
                                                	cond eval
                                                	**type**\:  :py:class:`PeventCondEvalEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PeventCondEvalEn>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg, self).__init__()

                                                    self.yang_name = "policy-event-info-bg"
                                                    self.yang_parent_name = "event-infop"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("class-infop", ("class_infop", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop))])
                                                    self._leafs = OrderedDict([
                                                        ('event_type', (YLeaf(YType.enumeration, 'event-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PeventTypeEn', '')])),
                                                        ('cond_eval', (YLeaf(YType.enumeration, 'cond-eval'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PeventCondEvalEn', '')])),
                                                    ])
                                                    self.event_type = None
                                                    self.cond_eval = None

                                                    self.class_infop = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop()
                                                    self.class_infop.parent = self
                                                    self._children_name_map["class_infop"] = "class-infop"
                                                    self._segment_path = lambda: "policy-event-info-bg"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg, ['event_type', 'cond_eval'], name, value)


                                                class ClassInfop(Entity):
                                                    """
                                                    class infop
                                                    
                                                    .. attribute:: policy_class_info_bg
                                                    
                                                    	policy class info bg
                                                    	**type**\: list of  		 :py:class:`PolicyClassInfoBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop, self).__init__()

                                                        self.yang_name = "class-infop"
                                                        self.yang_parent_name = "policy-event-info-bg"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("policy-class-info-bg", ("policy_class_info_bg", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg))])
                                                        self._leafs = OrderedDict()

                                                        self.policy_class_info_bg = YList(self)
                                                        self._segment_path = lambda: "class-infop"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop, [], name, value)


                                                    class PolicyClassInfoBg(Entity):
                                                        """
                                                        policy class info bg
                                                        
                                                        .. attribute:: cl_encode
                                                        
                                                        	cl encode
                                                        	**type**\:  :py:class:`ClEncode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode>`
                                                        
                                                        .. attribute:: clmp_p
                                                        
                                                        	clmp p
                                                        	**type**\:  :py:class:`ClmpP <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP>`
                                                        
                                                        .. attribute:: act_infop
                                                        
                                                        	act infop
                                                        	**type**\:  :py:class:`ActInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop>`
                                                        
                                                        .. attribute:: policy_class_hd
                                                        
                                                        	policy class hd
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: seq
                                                        
                                                        	seq
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: flags
                                                        
                                                        	flags
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: ctype
                                                        
                                                        	ctype
                                                        	**type**\:  :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                        
                                                        .. attribute:: num_actions
                                                        
                                                        	num actions
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: version
                                                        
                                                        	version
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        .. attribute:: exe_strat
                                                        
                                                        	exe strat
                                                        	**type**\:  :py:class:`PclassExecStratEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PclassExecStratEn>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2018-01-17'

                                                        def __init__(self):
                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg, self).__init__()

                                                            self.yang_name = "policy-class-info-bg"
                                                            self.yang_parent_name = "class-infop"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("cl-encode", ("cl_encode", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode)), ("clmp-p", ("clmp_p", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP)), ("act-infop", ("act_infop", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop))])
                                                            self._leafs = OrderedDict([
                                                                ('policy_class_hd', (YLeaf(YType.uint32, 'policy-class-hd'), ['int'])),
                                                                ('seq', (YLeaf(YType.uint32, 'seq'), ['int'])),
                                                                ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                ('ctype', (YLeaf(YType.enumeration, 'ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapTypeEn', '')])),
                                                                ('num_actions', (YLeaf(YType.uint16, 'num-actions'), ['int'])),
                                                                ('version', (YLeaf(YType.uint8, 'version'), ['int'])),
                                                                ('exe_strat', (YLeaf(YType.enumeration, 'exe-strat'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PclassExecStratEn', '')])),
                                                            ])
                                                            self.policy_class_hd = None
                                                            self.seq = None
                                                            self.flags = None
                                                            self.ctype = None
                                                            self.num_actions = None
                                                            self.version = None
                                                            self.exe_strat = None

                                                            self.cl_encode = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode()
                                                            self.cl_encode.parent = self
                                                            self._children_name_map["cl_encode"] = "cl-encode"

                                                            self.clmp_p = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP()
                                                            self.clmp_p.parent = self
                                                            self._children_name_map["clmp_p"] = "clmp-p"

                                                            self.act_infop = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop()
                                                            self.act_infop.parent = self
                                                            self._children_name_map["act_infop"] = "act-infop"
                                                            self._segment_path = lambda: "policy-class-info-bg"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg, ['policy_class_hd', 'seq', 'flags', 'ctype', 'num_actions', 'version', 'exe_strat'], name, value)


                                                        class ClEncode(Entity):
                                                            """
                                                            cl encode
                                                            
                                                            .. attribute:: inline_cmap
                                                            
                                                            	inline cmap
                                                            	**type**\:  :py:class:`InlineCmap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap>`
                                                            
                                                            .. attribute:: enc
                                                            
                                                            	enc
                                                            	**type**\:  :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                            
                                                            .. attribute:: class_name
                                                            
                                                            	class name
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..65
                                                            
                                                            .. attribute:: hd
                                                            
                                                            	hd
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: idx
                                                            
                                                            	idx
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..255
                                                            
                                                            

                                                            """

                                                            _prefix = 'infra-policymgr-oper'
                                                            _revision = '2018-01-17'

                                                            def __init__(self):
                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode, self).__init__()

                                                                self.yang_name = "cl-encode"
                                                                self.yang_parent_name = "policy-class-info-bg"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("inline-cmap", ("inline_cmap", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap))])
                                                                self._leafs = OrderedDict([
                                                                    ('enc', (YLeaf(YType.enumeration, 'enc'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyObjEncEn', '')])),
                                                                    ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                                    ('hd', (YLeaf(YType.uint64, 'hd'), ['int'])),
                                                                    ('idx', (YLeaf(YType.uint8, 'idx'), ['int'])),
                                                                ])
                                                                self.enc = None
                                                                self.class_name = None
                                                                self.hd = None
                                                                self.idx = None

                                                                self.inline_cmap = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap()
                                                                self.inline_cmap.parent = self
                                                                self._children_name_map["inline_cmap"] = "inline-cmap"
                                                                self._segment_path = lambda: "cl-encode"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode, ['enc', 'class_name', 'hd', 'idx'], name, value)


                                                            class InlineCmap(Entity):
                                                                """
                                                                inline cmap
                                                                
                                                                .. attribute:: match_infop
                                                                
                                                                	Pointer to the first Match info
                                                                	**type**\:  :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop>`
                                                                
                                                                .. attribute:: mode
                                                                
                                                                	Inline Class\-Map Mode Match any/all
                                                                	**type**\:  :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                
                                                                .. attribute:: flags
                                                                
                                                                	Inline Class\-Map flags
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: match_count
                                                                
                                                                	Number of Match infos
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap, self).__init__()

                                                                    self.yang_name = "inline-cmap"
                                                                    self.yang_parent_name = "cl-encode"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("match-infop", ("match_infop", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop))])
                                                                    self._leafs = OrderedDict([
                                                                        ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapModeEn', '')])),
                                                                        ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                        ('match_count', (YLeaf(YType.uint32, 'match-count'), ['int'])),
                                                                    ])
                                                                    self.mode = None
                                                                    self.flags = None
                                                                    self.match_count = None

                                                                    self.match_infop = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop()
                                                                    self.match_infop.parent = self
                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                    self._segment_path = lambda: "inline-cmap"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap, ['mode', 'flags', 'match_count'], name, value)


                                                                class MatchInfop(Entity):
                                                                    """
                                                                    Pointer to the first Match info
                                                                    
                                                                    .. attribute:: class_match_info_st
                                                                    
                                                                    	class match info st
                                                                    	**type**\: list of  		 :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop, self).__init__()

                                                                        self.yang_name = "match-infop"
                                                                        self.yang_parent_name = "inline-cmap"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("class-match-info-st", ("class_match_info_st", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt))])
                                                                        self._leafs = OrderedDict()

                                                                        self.class_match_info_st = YList(self)
                                                                        self._segment_path = lambda: "match-infop"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop, [], name, value)


                                                                    class ClassMatchInfoSt(Entity):
                                                                        """
                                                                        class match info st
                                                                        
                                                                        .. attribute:: match_data
                                                                        
                                                                        	Match criteria
                                                                        	**type**\:  :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                        
                                                                        .. attribute:: flags
                                                                        
                                                                        	Flags
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                            self.yang_name = "class-match-info-st"
                                                                            self.yang_parent_name = "match-infop"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("match-data", ("match_data", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData))])
                                                                            self._leafs = OrderedDict([
                                                                                ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                            ])
                                                                            self.flags = None

                                                                            self.match_data = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                            self.match_data.parent = self
                                                                            self._children_name_map["match_data"] = "match-data"
                                                                            self._segment_path = lambda: "class-match-info-st"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                        class MatchData(Entity):
                                                                            """
                                                                            Match criteria
                                                                            
                                                                            .. attribute:: ipv4_dscp
                                                                            
                                                                            	IPv4 DSCP
                                                                            	**type**\:  :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                            
                                                                            .. attribute:: ipv6_dscp
                                                                            
                                                                            	IPv6 DSCP
                                                                            	**type**\:  :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                            
                                                                            .. attribute:: dscp
                                                                            
                                                                            	Match DSCP range array
                                                                            	**type**\:  :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                            
                                                                            .. attribute:: ipv4_prec
                                                                            
                                                                            	IPv4 Precedence
                                                                            	**type**\:  :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                            
                                                                            .. attribute:: ipv6_prec
                                                                            
                                                                            	IPv6 Precedence
                                                                            	**type**\:  :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                            
                                                                            .. attribute:: prec
                                                                            
                                                                            	Match Precedence array
                                                                            	**type**\:  :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                            
                                                                            .. attribute:: discard_class
                                                                            
                                                                            	Match Discard Class array
                                                                            	**type**\:  :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                            
                                                                            .. attribute:: qos_group
                                                                            
                                                                            	Match QoS group array
                                                                            	**type**\:  :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                            
                                                                            .. attribute:: traffic_class
                                                                            
                                                                            	Match Traffic class array
                                                                            	**type**\:  :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                            
                                                                            .. attribute:: proto
                                                                            
                                                                            	Match Protocol array
                                                                            	**type**\:  :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                            
                                                                            .. attribute:: icmp_v4
                                                                            
                                                                            	Match ICMPV4 Protocol
                                                                            	**type**\:  :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                            
                                                                            .. attribute:: icmp_v6
                                                                            
                                                                            	Match ICMPV6 Protocol array
                                                                            	**type**\:  :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                            
                                                                            .. attribute:: ipv4_packet_len
                                                                            
                                                                            	IPv4 packet length array
                                                                            	**type**\:  :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                            
                                                                            .. attribute:: ipv6_packet_len
                                                                            
                                                                            	IPv6 packet length array
                                                                            	**type**\:  :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                            
                                                                            .. attribute:: packet_len
                                                                            
                                                                            	Match packet length array
                                                                            	**type**\:  :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                            
                                                                            .. attribute:: flow_tag
                                                                            
                                                                            	Match flow\-tag array
                                                                            	**type**\:  :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                            
                                                                            .. attribute:: tcp_flag
                                                                            
                                                                            	Match tcp flag value
                                                                            	**type**\:  :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                            
                                                                            .. attribute:: icmpv4_type
                                                                            
                                                                            	Match ipv4 icmp type
                                                                            	**type**\:  :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                            
                                                                            .. attribute:: icmpv4_code
                                                                            
                                                                            	Match ipv4 icmp code
                                                                            	**type**\:  :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                            
                                                                            .. attribute:: icmpv6_type
                                                                            
                                                                            	Match ipv6 icmp type
                                                                            	**type**\:  :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                            
                                                                            .. attribute:: icmpv6_code
                                                                            
                                                                            	Match ipv6 icmp code
                                                                            	**type**\:  :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                            
                                                                            .. attribute:: mpls_exp
                                                                            
                                                                            	Match MPLS experimental topmost array
                                                                            	**type**\:  :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                            
                                                                            .. attribute:: mpls_exp_imp
                                                                            
                                                                            	Match MPLS experimental imposition array
                                                                            	**type**\:  :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                            
                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                            
                                                                            	MPLS Disposition IPv4 Access\-list
                                                                            	**type**\:  :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                            
                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                            
                                                                            	MPLS Disposition IPv6 Access\-list
                                                                            	**type**\:  :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                            
                                                                            .. attribute:: mpls_top_label
                                                                            
                                                                            	MPLS Topmost LABEL
                                                                            	**type**\:  :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                            
                                                                            .. attribute:: cos
                                                                            
                                                                            	Match CoS array
                                                                            	**type**\:  :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                            
                                                                            .. attribute:: cos_inr
                                                                            
                                                                            	Match inner header CoS
                                                                            	**type**\:  :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                            
                                                                            .. attribute:: dei
                                                                            
                                                                            	Match DEI Bit
                                                                            	**type**\:  :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                            
                                                                            .. attribute:: dei_inr
                                                                            
                                                                            	Match inner DEI Bit
                                                                            	**type**\:  :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                            
                                                                            .. attribute:: vlan
                                                                            
                                                                            	Match VLAN array
                                                                            	**type**\:  :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                            
                                                                            .. attribute:: vlan_inr
                                                                            
                                                                            	Match inner header VLAN range array
                                                                            	**type**\:  :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                            
                                                                            .. attribute:: fr_dlci
                                                                            
                                                                            	Match FR DLCI range array
                                                                            	**type**\:  :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                            
                                                                            .. attribute:: src_mac
                                                                            
                                                                            	Match Source MAC address
                                                                            	**type**\:  :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                            
                                                                            .. attribute:: dst_mac
                                                                            
                                                                            	Match Destination MAC address
                                                                            	**type**\:  :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                            
                                                                            .. attribute:: atm_clp
                                                                            
                                                                            	Match ATM CLP level
                                                                            	**type**\:  :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                            
                                                                            .. attribute:: fr_de
                                                                            
                                                                            	Match FR DE value
                                                                            	**type**\:  :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                            
                                                                            .. attribute:: ipv4_acl
                                                                            
                                                                            	IPv4 Access\-list
                                                                            	**type**\:  :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                            
                                                                            .. attribute:: ipv6_acl
                                                                            
                                                                            	IPv6 Access\-list
                                                                            	**type**\:  :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                            
                                                                            .. attribute:: ether_service_acl
                                                                            
                                                                            	Ethernet\-Services Access\-list
                                                                            	**type**\:  :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                            
                                                                            .. attribute:: avail_id
                                                                            
                                                                            	Available Identifiers
                                                                            	**type**\:  :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                            
                                                                            .. attribute:: media_type
                                                                            
                                                                            	Media Type
                                                                            	**type**\:  :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                            
                                                                            .. attribute:: subs_protocol
                                                                            
                                                                            	Protocol
                                                                            	**type**\:  :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                            
                                                                            .. attribute:: dnis
                                                                            
                                                                            	DNIS
                                                                            	**type**\:  :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                            
                                                                            .. attribute:: dnis_regex
                                                                            
                                                                            	DNIS Regular Expression
                                                                            	**type**\:  :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                            
                                                                            .. attribute:: domain
                                                                            
                                                                            	Domain Name
                                                                            	**type**\:  :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                            
                                                                            .. attribute:: domain_regex
                                                                            
                                                                            	Domain Regular Expression
                                                                            	**type**\:  :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                            
                                                                            .. attribute:: nas_port
                                                                            
                                                                            	NAS Port
                                                                            	**type**\:  :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                            
                                                                            .. attribute:: service_name
                                                                            
                                                                            	Service Name
                                                                            	**type**\:  :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                            
                                                                            .. attribute:: service_name_regex
                                                                            
                                                                            	Service Name Regular Exp
                                                                            	**type**\:  :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                            
                                                                            .. attribute:: src_addr_ipv4
                                                                            
                                                                            	Source Address IPV4
                                                                            	**type**\:  :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                            
                                                                            .. attribute:: dst_addr_ipv4
                                                                            
                                                                            	Destination Address IPV4
                                                                            	**type**\:  :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                            
                                                                            .. attribute:: src_addr_ipv6
                                                                            
                                                                            	Source Address IPV6
                                                                            	**type**\:  :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                            
                                                                            .. attribute:: dst_addr_ipv6
                                                                            
                                                                            	Destination Address IPV6
                                                                            	**type**\:  :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                            
                                                                            .. attribute:: src_addr_mac
                                                                            
                                                                            	Source Address MAC
                                                                            	**type**\:  :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                            
                                                                            .. attribute:: timer
                                                                            
                                                                            	Timer
                                                                            	**type**\:  :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                            
                                                                            .. attribute:: timer_regexp
                                                                            
                                                                            	Timer Regular Expression
                                                                            	**type**\:  :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                            
                                                                            .. attribute:: tunnel_name
                                                                            
                                                                            	Tunnel Name
                                                                            	**type**\:  :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                            
                                                                            .. attribute:: tunnel_name_regex
                                                                            
                                                                            	Tunnel Name Regular Expression
                                                                            	**type**\:  :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                            
                                                                            .. attribute:: user_name
                                                                            
                                                                            	User Name
                                                                            	**type**\:  :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                            
                                                                            .. attribute:: user_name_regex
                                                                            
                                                                            	User Name Regular Expression
                                                                            	**type**\:  :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                            
                                                                            .. attribute:: auth_username
                                                                            
                                                                            	Authenticated User Name
                                                                            	**type**\:  :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                            
                                                                            .. attribute:: auth_username_regex
                                                                            
                                                                            	Authenticated User Name RegEx
                                                                            	**type**\:  :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                            
                                                                            .. attribute:: unauth_username
                                                                            
                                                                            	Unauthenticated User Name
                                                                            	**type**\:  :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                            
                                                                            .. attribute:: unauth_username_regex
                                                                            
                                                                            	Unauthenticated User Name RegEx
                                                                            	**type**\:  :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                            
                                                                            .. attribute:: auth_domain
                                                                            
                                                                            	Authenticated domain name
                                                                            	**type**\:  :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                            
                                                                            .. attribute:: auth_domain_regex
                                                                            
                                                                            	Authenticated Domain Name RegEx
                                                                            	**type**\:  :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                            
                                                                            .. attribute:: unauth_domain
                                                                            
                                                                            	Unauthenticated Domain Name
                                                                            	**type**\:  :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                            
                                                                            .. attribute:: unauth_domain_regex
                                                                            
                                                                            	Unauthenticated Domain Name RegEx
                                                                            	**type**\:  :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                            
                                                                            .. attribute:: vendor_id
                                                                            
                                                                            	Vendor ID
                                                                            	**type**\:  :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                            
                                                                            .. attribute:: vendor_id_regex
                                                                            
                                                                            	Vendor ID RegEx
                                                                            	**type**\:  :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                            
                                                                            .. attribute:: access_interface
                                                                            
                                                                            	Access interface
                                                                            	**type**\:  :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                            
                                                                            .. attribute:: input_interface
                                                                            
                                                                            	Input interface
                                                                            	**type**\:  :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                            
                                                                            .. attribute:: input_intfhdl
                                                                            
                                                                            	Input interface handle
                                                                            	**type**\:  :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                            
                                                                            .. attribute:: ethertype
                                                                            
                                                                            	Ethernet type
                                                                            	**type**\:  :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                            
                                                                            .. attribute:: flow_key_data
                                                                            
                                                                            	Flow key structure
                                                                            	**type**\:  :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                            
                                                                            .. attribute:: dhcp_client_id
                                                                            
                                                                            	Dhcp Client ID
                                                                            	**type**\:  :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                            
                                                                            .. attribute:: dhcp_client_id_regex
                                                                            
                                                                            	Dhcp Client ID RegEx
                                                                            	**type**\:  :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                            
                                                                            .. attribute:: circuit_id
                                                                            
                                                                            	Circuit ID
                                                                            	**type**\:  :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                            
                                                                            .. attribute:: circuit_id_regex
                                                                            
                                                                            	Circuit ID RegEx
                                                                            	**type**\:  :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                            
                                                                            .. attribute:: remote_id
                                                                            
                                                                            	Remote ID
                                                                            	**type**\:  :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                            
                                                                            .. attribute:: remote_id_regex
                                                                            
                                                                            	Remote ID RegEx
                                                                            	**type**\:  :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                            
                                                                            .. attribute:: src_port
                                                                            
                                                                            	Source port
                                                                            	**type**\:  :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                            
                                                                            .. attribute:: dst_port
                                                                            
                                                                            	Destination port
                                                                            	**type**\:  :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:  :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                            
                                                                            .. attribute:: mpls_top_eos
                                                                            
                                                                            	MPLS Topmost EOS
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: fragment_type
                                                                            
                                                                            	Fragment type
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: authen_status
                                                                            
                                                                            	Authentication Status
                                                                            	**type**\:  :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                            
                                                                            .. attribute:: mlp_negotiated
                                                                            
                                                                            	MLP Negotiated
                                                                            	**type**\:  :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                self.yang_name = "match-data"
                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("ipv4-dscp", ("ipv4_dscp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp)), ("ipv6-dscp", ("ipv6_dscp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp)), ("dscp", ("dscp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp)), ("ipv4-prec", ("ipv4_prec", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec)), ("ipv6-prec", ("ipv6_prec", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec)), ("prec", ("prec", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec)), ("discard-class", ("discard_class", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass)), ("qos-group", ("qos_group", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup)), ("traffic-class", ("traffic_class", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass)), ("proto", ("proto", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto)), ("icmp-v4", ("icmp_v4", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4)), ("icmp-v6", ("icmp_v6", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6)), ("ipv4-packet-len", ("ipv4_packet_len", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen)), ("ipv6-packet-len", ("ipv6_packet_len", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen)), ("packet-len", ("packet_len", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen)), ("flow-tag", ("flow_tag", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag)), ("tcp-flag", ("tcp_flag", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag)), ("icmpv4-type", ("icmpv4_type", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type)), ("icmpv4-code", ("icmpv4_code", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code)), ("icmpv6-type", ("icmpv6_type", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type)), ("icmpv6-code", ("icmpv6_code", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code)), ("mpls-exp", ("mpls_exp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp)), ("mpls-exp-imp", ("mpls_exp_imp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp)), ("mpls-disp-ipv4-acl", ("mpls_disp_ipv4_acl", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl)), ("mpls-disp-ipv6-acl", ("mpls_disp_ipv6_acl", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl)), ("mpls-top-label", ("mpls_top_label", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel)), ("cos", ("cos", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos)), ("cos-inr", ("cos_inr", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr)), ("dei", ("dei", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei)), ("dei-inr", ("dei_inr", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr)), ("vlan", ("vlan", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan)), ("vlan-inr", ("vlan_inr", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)), ("fr-dlci", ("fr_dlci", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci)), ("src-mac", ("src_mac", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac)), ("dst-mac", ("dst_mac", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac)), ("atm-clp", ("atm_clp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp)), ("fr-de", ("fr_de", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe)), ("ipv4-acl", ("ipv4_acl", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl)), ("ipv6-acl", ("ipv6_acl", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl)), ("ether-service-acl", ("ether_service_acl", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl)), ("avail-id", ("avail_id", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId)), ("media-type", ("media_type", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType)), ("subs-protocol", ("subs_protocol", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol)), ("dnis", ("dnis", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis)), ("dnis-regex", ("dnis_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex)), ("domain", ("domain", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain)), ("domain-regex", ("domain_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex)), ("nas-port", ("nas_port", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort)), ("service-name", ("service_name", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName)), ("service-name-regex", ("service_name_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex)), ("src-addr-ipv4", ("src_addr_ipv4", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4)), ("dst-addr-ipv4", ("dst_addr_ipv4", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4)), ("src-addr-ipv6", ("src_addr_ipv6", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6)), ("dst-addr-ipv6", ("dst_addr_ipv6", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6)), ("src-addr-mac", ("src_addr_mac", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac)), ("timer", ("timer", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer)), ("timer-regexp", ("timer_regexp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp)), ("tunnel-name", ("tunnel_name", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName)), ("tunnel-name-regex", ("tunnel_name_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex)), ("user-name", ("user_name", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName)), ("user-name-regex", ("user_name_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex)), ("auth-username", ("auth_username", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername)), ("auth-username-regex", ("auth_username_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex)), ("unauth-username", ("unauth_username", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername)), ("unauth-username-regex", ("unauth_username_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex)), ("auth-domain", ("auth_domain", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain)), ("auth-domain-regex", ("auth_domain_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex)), ("unauth-domain", ("unauth_domain", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain)), ("unauth-domain-regex", ("unauth_domain_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex)), ("vendor-id", ("vendor_id", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId)), ("vendor-id-regex", ("vendor_id_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex)), ("access-interface", ("access_interface", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface)), ("input-interface", ("input_interface", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface)), ("input-intfhdl", ("input_intfhdl", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl)), ("ethertype", ("ethertype", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype)), ("flow-key-data", ("flow_key_data", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData)), ("dhcp-client-id", ("dhcp_client_id", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId)), ("dhcp-client-id-regex", ("dhcp_client_id_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex)), ("circuit-id", ("circuit_id", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId)), ("circuit-id-regex", ("circuit_id_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex)), ("remote-id", ("remote_id", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId)), ("remote-id-regex", ("remote_id_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex)), ("src-port", ("src_port", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort)), ("dst-port", ("dst_port", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchTypeEn', '')])),
                                                                                    ('mpls_top_eos', (YLeaf(YType.uint8, 'mpls-top-eos'), ['int'])),
                                                                                    ('fragment_type', (YLeaf(YType.uint8, 'fragment-type'), ['int'])),
                                                                                    ('authen_status', (YLeaf(YType.enumeration, 'authen-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchAuthenStatusEn', '')])),
                                                                                    ('mlp_negotiated', (YLeaf(YType.enumeration, 'mlp-negotiated'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchMlpNegotiatedEn', '')])),
                                                                                ])
                                                                                self.type = None
                                                                                self.mpls_top_eos = None
                                                                                self.fragment_type = None
                                                                                self.authen_status = None
                                                                                self.mlp_negotiated = None

                                                                                self.ipv4_dscp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                self.ipv4_dscp.parent = self
                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"

                                                                                self.ipv6_dscp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                self.ipv6_dscp.parent = self
                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"

                                                                                self.dscp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                self.dscp.parent = self
                                                                                self._children_name_map["dscp"] = "dscp"

                                                                                self.ipv4_prec = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                self.ipv4_prec.parent = self
                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"

                                                                                self.ipv6_prec = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                self.ipv6_prec.parent = self
                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"

                                                                                self.prec = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                self.prec.parent = self
                                                                                self._children_name_map["prec"] = "prec"

                                                                                self.discard_class = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                self.discard_class.parent = self
                                                                                self._children_name_map["discard_class"] = "discard-class"

                                                                                self.qos_group = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                self.qos_group.parent = self
                                                                                self._children_name_map["qos_group"] = "qos-group"

                                                                                self.traffic_class = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                self.traffic_class.parent = self
                                                                                self._children_name_map["traffic_class"] = "traffic-class"

                                                                                self.proto = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                self.proto.parent = self
                                                                                self._children_name_map["proto"] = "proto"

                                                                                self.icmp_v4 = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                self.icmp_v4.parent = self
                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"

                                                                                self.icmp_v6 = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                self.icmp_v6.parent = self
                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"

                                                                                self.ipv4_packet_len = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                self.ipv4_packet_len.parent = self
                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"

                                                                                self.ipv6_packet_len = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                self.ipv6_packet_len.parent = self
                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"

                                                                                self.packet_len = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                self.packet_len.parent = self
                                                                                self._children_name_map["packet_len"] = "packet-len"

                                                                                self.flow_tag = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                self.flow_tag.parent = self
                                                                                self._children_name_map["flow_tag"] = "flow-tag"

                                                                                self.tcp_flag = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                self.tcp_flag.parent = self
                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"

                                                                                self.icmpv4_type = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                self.icmpv4_type.parent = self
                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"

                                                                                self.icmpv4_code = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                self.icmpv4_code.parent = self
                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"

                                                                                self.icmpv6_type = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                self.icmpv6_type.parent = self
                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"

                                                                                self.icmpv6_code = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                self.icmpv6_code.parent = self
                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"

                                                                                self.mpls_exp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                self.mpls_exp.parent = self
                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"

                                                                                self.mpls_exp_imp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                self.mpls_exp_imp.parent = self
                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"

                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"

                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"

                                                                                self.mpls_top_label = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                self.mpls_top_label.parent = self
                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"

                                                                                self.cos = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                self.cos.parent = self
                                                                                self._children_name_map["cos"] = "cos"

                                                                                self.cos_inr = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                self.cos_inr.parent = self
                                                                                self._children_name_map["cos_inr"] = "cos-inr"

                                                                                self.dei = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                self.dei.parent = self
                                                                                self._children_name_map["dei"] = "dei"

                                                                                self.dei_inr = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                self.dei_inr.parent = self
                                                                                self._children_name_map["dei_inr"] = "dei-inr"

                                                                                self.vlan = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                self.vlan.parent = self
                                                                                self._children_name_map["vlan"] = "vlan"

                                                                                self.vlan_inr = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                self.vlan_inr.parent = self
                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"

                                                                                self.fr_dlci = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                self.fr_dlci.parent = self
                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"

                                                                                self.src_mac = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                self.src_mac.parent = self
                                                                                self._children_name_map["src_mac"] = "src-mac"

                                                                                self.dst_mac = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                self.dst_mac.parent = self
                                                                                self._children_name_map["dst_mac"] = "dst-mac"

                                                                                self.atm_clp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                self.atm_clp.parent = self
                                                                                self._children_name_map["atm_clp"] = "atm-clp"

                                                                                self.fr_de = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                self.fr_de.parent = self
                                                                                self._children_name_map["fr_de"] = "fr-de"

                                                                                self.ipv4_acl = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                self.ipv4_acl.parent = self
                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"

                                                                                self.ipv6_acl = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                self.ipv6_acl.parent = self
                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"

                                                                                self.ether_service_acl = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                self.ether_service_acl.parent = self
                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"

                                                                                self.avail_id = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                self.avail_id.parent = self
                                                                                self._children_name_map["avail_id"] = "avail-id"

                                                                                self.media_type = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                self.media_type.parent = self
                                                                                self._children_name_map["media_type"] = "media-type"

                                                                                self.subs_protocol = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                self.subs_protocol.parent = self
                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"

                                                                                self.dnis = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                self.dnis.parent = self
                                                                                self._children_name_map["dnis"] = "dnis"

                                                                                self.dnis_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                self.dnis_regex.parent = self
                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"

                                                                                self.domain = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                self.domain.parent = self
                                                                                self._children_name_map["domain"] = "domain"

                                                                                self.domain_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                self.domain_regex.parent = self
                                                                                self._children_name_map["domain_regex"] = "domain-regex"

                                                                                self.nas_port = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                self.nas_port.parent = self
                                                                                self._children_name_map["nas_port"] = "nas-port"

                                                                                self.service_name = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                self.service_name.parent = self
                                                                                self._children_name_map["service_name"] = "service-name"

                                                                                self.service_name_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                self.service_name_regex.parent = self
                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"

                                                                                self.src_addr_ipv4 = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                self.src_addr_ipv4.parent = self
                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"

                                                                                self.dst_addr_ipv4 = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                self.dst_addr_ipv4.parent = self
                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"

                                                                                self.src_addr_ipv6 = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                self.src_addr_ipv6.parent = self
                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"

                                                                                self.dst_addr_ipv6 = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                self.dst_addr_ipv6.parent = self
                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"

                                                                                self.src_addr_mac = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                self.src_addr_mac.parent = self
                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"

                                                                                self.timer = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                self.timer.parent = self
                                                                                self._children_name_map["timer"] = "timer"

                                                                                self.timer_regexp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                self.timer_regexp.parent = self
                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"

                                                                                self.tunnel_name = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                self.tunnel_name.parent = self
                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"

                                                                                self.tunnel_name_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                self.tunnel_name_regex.parent = self
                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"

                                                                                self.user_name = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                self.user_name.parent = self
                                                                                self._children_name_map["user_name"] = "user-name"

                                                                                self.user_name_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                self.user_name_regex.parent = self
                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"

                                                                                self.auth_username = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                self.auth_username.parent = self
                                                                                self._children_name_map["auth_username"] = "auth-username"

                                                                                self.auth_username_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                self.auth_username_regex.parent = self
                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"

                                                                                self.unauth_username = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                self.unauth_username.parent = self
                                                                                self._children_name_map["unauth_username"] = "unauth-username"

                                                                                self.unauth_username_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                self.unauth_username_regex.parent = self
                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"

                                                                                self.auth_domain = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                self.auth_domain.parent = self
                                                                                self._children_name_map["auth_domain"] = "auth-domain"

                                                                                self.auth_domain_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                self.auth_domain_regex.parent = self
                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"

                                                                                self.unauth_domain = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                self.unauth_domain.parent = self
                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"

                                                                                self.unauth_domain_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                self.unauth_domain_regex.parent = self
                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"

                                                                                self.vendor_id = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                self.vendor_id.parent = self
                                                                                self._children_name_map["vendor_id"] = "vendor-id"

                                                                                self.vendor_id_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                self.vendor_id_regex.parent = self
                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"

                                                                                self.access_interface = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                self.access_interface.parent = self
                                                                                self._children_name_map["access_interface"] = "access-interface"

                                                                                self.input_interface = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                self.input_interface.parent = self
                                                                                self._children_name_map["input_interface"] = "input-interface"

                                                                                self.input_intfhdl = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                self.input_intfhdl.parent = self
                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"

                                                                                self.ethertype = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                self.ethertype.parent = self
                                                                                self._children_name_map["ethertype"] = "ethertype"

                                                                                self.flow_key_data = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                self.flow_key_data.parent = self
                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"

                                                                                self.dhcp_client_id = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                self.dhcp_client_id.parent = self
                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"

                                                                                self.dhcp_client_id_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                self.dhcp_client_id_regex.parent = self
                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"

                                                                                self.circuit_id = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                self.circuit_id.parent = self
                                                                                self._children_name_map["circuit_id"] = "circuit-id"

                                                                                self.circuit_id_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                self.circuit_id_regex.parent = self
                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"

                                                                                self.remote_id = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                self.remote_id.parent = self
                                                                                self._children_name_map["remote_id"] = "remote-id"

                                                                                self.remote_id_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                self.remote_id_regex.parent = self
                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"

                                                                                self.src_port = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                self.src_port.parent = self
                                                                                self._children_name_map["src_port"] = "src-port"

                                                                                self.dst_port = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                self.dst_port.parent = self
                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                self._segment_path = lambda: "match-data"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, ['type', 'mpls_top_eos', 'fragment_type', 'authen_status', 'mlp_negotiated'], name, value)


                                                                            class Ipv4Dscp(Entity):
                                                                                """
                                                                                IPv4 DSCP
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                    self.yang_name = "ipv4-dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv4-dscp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Ipv6Dscp(Entity):
                                                                                """
                                                                                IPv6 DSCP
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                    self.yang_name = "ipv6-dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv6-dscp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Dscp(Entity):
                                                                                """
                                                                                Match DSCP range array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                    self.yang_name = "dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "dscp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Ipv4Prec(Entity):
                                                                                """
                                                                                IPv4 Precedence
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                    self.yang_name = "ipv4-prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "ipv4-prec"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                            class Ipv6Prec(Entity):
                                                                                """
                                                                                IPv6 Precedence
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                    self.yang_name = "ipv6-prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "ipv6-prec"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                            class Prec(Entity):
                                                                                """
                                                                                Match Precedence array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                    self.yang_name = "prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "prec"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                            class DiscardClass(Entity):
                                                                                """
                                                                                Match Discard Class array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                    self.yang_name = "discard-class"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "discard-class"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                            class QosGroup(Entity):
                                                                                """
                                                                                Match QoS group array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                    self.yang_name = "qos-group"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "qos-group"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "qos-group"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class TrafficClass(Entity):
                                                                                """
                                                                                Match Traffic class array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                    self.yang_name = "traffic-class"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "traffic-class"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "traffic-class"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Proto(Entity):
                                                                                """
                                                                                Match Protocol array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                    self.yang_name = "proto"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "proto"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "proto"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class IcmpV4(Entity):
                                                                                """
                                                                                Match ICMPV4 Protocol
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Protocol type
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: code
                                                                                
                                                                                	Protocol code
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                    self.yang_name = "icmp-v4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                    ])
                                                                                    self.type = None
                                                                                    self.code = None
                                                                                    self._segment_path = lambda: "icmp-v4"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['type', 'code'], name, value)


                                                                            class IcmpV6(Entity):
                                                                                """
                                                                                Match ICMPV6 Protocol array
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Protocol type
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: code
                                                                                
                                                                                	Protocol code
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                    self.yang_name = "icmp-v6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                    ])
                                                                                    self.type = None
                                                                                    self.code = None
                                                                                    self._segment_path = lambda: "icmp-v6"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['type', 'code'], name, value)


                                                                            class Ipv4PacketLen(Entity):
                                                                                """
                                                                                IPv4 packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv4-packet-len"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class Ipv6PacketLen(Entity):
                                                                                """
                                                                                IPv6 packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv6-packet-len"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class PacketLen(Entity):
                                                                                """
                                                                                Match packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                    self.yang_name = "packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "packet-len"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class FlowTag(Entity):
                                                                                """
                                                                                Match flow\-tag array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                    self.yang_name = "flow-tag"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "flow-tag"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "flow-tag"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class TcpFlag(Entity):
                                                                                """
                                                                                Match tcp flag value
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	Value of TCP flag
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: match_any
                                                                                
                                                                                	Match any TCP flag bit
                                                                                	**type**\: bool
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                    self.yang_name = "tcp-flag"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                        ('match_any', (YLeaf(YType.boolean, 'match-any'), ['bool'])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.match_any = None
                                                                                    self._segment_path = lambda: "tcp-flag"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['value', 'match_any'], name, value)


                                                                            class Icmpv4Type(Entity):
                                                                                """
                                                                                Match ipv4 icmp type
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                    self.yang_name = "icmpv4-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv4-type"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Icmpv4Code(Entity):
                                                                                """
                                                                                Match ipv4 icmp code
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                    self.yang_name = "icmpv4-code"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv4-code"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Icmpv6Type(Entity):
                                                                                """
                                                                                Match ipv6 icmp type
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                    self.yang_name = "icmpv6-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv6-type"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Icmpv6Code(Entity):
                                                                                """
                                                                                Match ipv6 icmp code
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                    self.yang_name = "icmpv6-code"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv6-code"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class MplsExp(Entity):
                                                                                """
                                                                                Match MPLS experimental topmost array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                    self.yang_name = "mpls-exp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "mpls-exp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                            class MplsExpImp(Entity):
                                                                                """
                                                                                Match MPLS experimental imposition array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "mpls-exp-imp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                            class MplsDispIpv4Acl(Entity):
                                                                                """
                                                                                MPLS Disposition IPv4 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                            class MplsDispIpv6Acl(Entity):
                                                                                """
                                                                                MPLS Disposition IPv6 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                            class MplsTopLabel(Entity):
                                                                                """
                                                                                MPLS Topmost LABEL
                                                                                
                                                                                .. attribute:: uint32_rng_array
                                                                                
                                                                                	uint32 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                    self.yang_name = "mpls-top-label"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint32_rng_array", ("uint32_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint32_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "mpls-top-label"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                class Uint32RngArray(Entity):
                                                                                    """
                                                                                    uint32 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                        self.yang_name = "uint32_rng_array"
                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint32, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint32, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint32_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['min', 'max'], name, value)


                                                                            class Cos(Entity):
                                                                                """
                                                                                Match CoS array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                    self.yang_name = "cos"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "cos"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                            class CosInr(Entity):
                                                                                """
                                                                                Match inner header CoS
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                    self.yang_name = "cos-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "cos-inr"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                            class Dei(Entity):
                                                                                """
                                                                                Match DEI Bit
                                                                                
                                                                                .. attribute:: bit_value
                                                                                
                                                                                	Value of the DEI bit
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                    self.yang_name = "dei"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                    ])
                                                                                    self.bit_value = None
                                                                                    self._segment_path = lambda: "dei"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                            class DeiInr(Entity):
                                                                                """
                                                                                Match inner DEI Bit
                                                                                
                                                                                .. attribute:: bit_value
                                                                                
                                                                                	Value of the DEI bit
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                    self.yang_name = "dei-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                    ])
                                                                                    self.bit_value = None
                                                                                    self._segment_path = lambda: "dei-inr"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                            class Vlan(Entity):
                                                                                """
                                                                                Match VLAN array
                                                                                
                                                                                .. attribute:: vlan_id_array
                                                                                
                                                                                	vlan id array
                                                                                	**type**\: list of  		 :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                    self.yang_name = "vlan"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("vlan-id-array", ("vlan_id_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.vlan_id_array = YList(self)
                                                                                    self._segment_path = lambda: "vlan"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                class VlanIdArray(Entity):
                                                                                    """
                                                                                    vlan id array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	VLAN mask
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                        self.yang_name = "vlan-id-array"
                                                                                        self.yang_parent_name = "vlan"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                            ('mask', (YLeaf(YType.uint16, 'mask'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self.mask = None
                                                                                        self._segment_path = lambda: "vlan-id-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['min', 'max', 'mask'], name, value)


                                                                            class VlanInr(Entity):
                                                                                """
                                                                                Match inner header VLAN range array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                    self.yang_name = "vlan-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "vlan-inr"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class FrDlci(Entity):
                                                                                """
                                                                                Match FR DLCI range array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                    self.yang_name = "fr-dlci"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "fr-dlci"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class SrcMac(Entity):
                                                                                """
                                                                                Match Source MAC address
                                                                                
                                                                                .. attribute:: mac_addr
                                                                                
                                                                                	MAC address
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	MAC mask
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                    self.yang_name = "src-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                    ])
                                                                                    self.mac_addr = []
                                                                                    self.mask = []
                                                                                    self._segment_path = lambda: "src-mac"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                            class DstMac(Entity):
                                                                                """
                                                                                Match Destination MAC address
                                                                                
                                                                                .. attribute:: mac_addr
                                                                                
                                                                                	MAC address
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	MAC mask
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                    self.yang_name = "dst-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                    ])
                                                                                    self.mac_addr = []
                                                                                    self.mask = []
                                                                                    self._segment_path = lambda: "dst-mac"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                            class AtmClp(Entity):
                                                                                """
                                                                                Match ATM CLP level
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                    self.yang_name = "atm-clp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "atm-clp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                            class FrDe(Entity):
                                                                                """
                                                                                Match FR DE value
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                    self.yang_name = "fr-de"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "fr-de"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                            class Ipv4Acl(Entity):
                                                                                """
                                                                                IPv4 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                    self.yang_name = "ipv4-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "ipv4-acl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                            class Ipv6Acl(Entity):
                                                                                """
                                                                                IPv6 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                    self.yang_name = "ipv6-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "ipv6-acl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                            class EtherServiceAcl(Entity):
                                                                                """
                                                                                Ethernet\-Services Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                    self.yang_name = "ether-service-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "ether-service-acl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                            class AvailId(Entity):
                                                                                """
                                                                                Available Identifiers
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                    self.yang_name = "avail-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "avail-id"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                            class MediaType(Entity):
                                                                                """
                                                                                Media Type
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                    self.yang_name = "media-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "media-type"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                            class SubsProtocol(Entity):
                                                                                """
                                                                                Protocol
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                    self.yang_name = "subs-protocol"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "subs-protocol"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                            class Dnis(Entity):
                                                                                """
                                                                                DNIS
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                    self.yang_name = "dnis"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "dnis"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                            class DnisRegex(Entity):
                                                                                """
                                                                                DNIS Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                    self.yang_name = "dnis-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "dnis-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                            class Domain(Entity):
                                                                                """
                                                                                Domain Name
                                                                                
                                                                                .. attribute:: domain_array
                                                                                
                                                                                	domain array
                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                    self.yang_name = "domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.domain_array = YList(self)
                                                                                    self._segment_path = lambda: "domain"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                class DomainArray(Entity):
                                                                                    """
                                                                                    domain array
                                                                                    
                                                                                    .. attribute:: domain_name
                                                                                    
                                                                                    	domain name
                                                                                    	**type**\: str
                                                                                    
                                                                                    .. attribute:: format_name
                                                                                    
                                                                                    	format name
                                                                                    	**type**\: str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                        self.yang_name = "domain-array"
                                                                                        self.yang_parent_name = "domain"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                        ])
                                                                                        self.domain_name = None
                                                                                        self.format_name = None
                                                                                        self._segment_path = lambda: "domain-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                            class DomainRegex(Entity):
                                                                                """
                                                                                Domain Regular Expression
                                                                                
                                                                                .. attribute:: domain_array
                                                                                
                                                                                	domain array
                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                    self.yang_name = "domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.domain_array = YList(self)
                                                                                    self._segment_path = lambda: "domain-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                class DomainArray(Entity):
                                                                                    """
                                                                                    domain array
                                                                                    
                                                                                    .. attribute:: domain_name
                                                                                    
                                                                                    	domain name
                                                                                    	**type**\: str
                                                                                    
                                                                                    .. attribute:: format_name
                                                                                    
                                                                                    	format name
                                                                                    	**type**\: str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                        self.yang_name = "domain-array"
                                                                                        self.yang_parent_name = "domain-regex"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                        ])
                                                                                        self.domain_name = None
                                                                                        self.format_name = None
                                                                                        self._segment_path = lambda: "domain-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                            class NasPort(Entity):
                                                                                """
                                                                                NAS Port
                                                                                
                                                                                .. attribute:: nas_port_array
                                                                                
                                                                                	nas port array
                                                                                	**type**\: list of  		 :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                    self.yang_name = "nas-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("nas-port-array", ("nas_port_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.nas_port_array = YList(self)
                                                                                    self._segment_path = lambda: "nas-port"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                class NasPortArray(Entity):
                                                                                    """
                                                                                    nas port array
                                                                                    
                                                                                    .. attribute:: sub_id
                                                                                    
                                                                                    	sub id
                                                                                    	**type**\:  :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                    
                                                                                    .. attribute:: operator
                                                                                    
                                                                                    	operator
                                                                                    	**type**\:  :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                        self.yang_name = "nas-port-array"
                                                                                        self.yang_parent_name = "nas-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('sub_id', (YLeaf(YType.enumeration, 'sub-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchNasPortSubIdEn', '')])),
                                                                                            ('operator', (YLeaf(YType.enumeration, 'operator'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchLogicalOperatorEn', '')])),
                                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ])
                                                                                        self.sub_id = None
                                                                                        self.operator = None
                                                                                        self.value = None
                                                                                        self._segment_path = lambda: "nas-port-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['sub_id', 'operator', 'value'], name, value)


                                                                            class ServiceName(Entity):
                                                                                """
                                                                                Service Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                    self.yang_name = "service-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "service-name"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                            class ServiceNameRegex(Entity):
                                                                                """
                                                                                Service Name Regular Exp
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                    self.yang_name = "service-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "service-name-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                            class SrcAddrIpv4(Entity):
                                                                                """
                                                                                Source Address IPV4
                                                                                
                                                                                .. attribute:: ipv4_addr_array
                                                                                
                                                                                	ipv4 addr array
                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.ipv4_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-ipv4"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                class Ipv4AddrArray(Entity):
                                                                                    """
                                                                                    ipv4 addr array
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	prefix
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	mask
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                        ])
                                                                                        self.prefix = None
                                                                                        self.mask = None
                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                            class DstAddrIpv4(Entity):
                                                                                """
                                                                                Destination Address IPV4
                                                                                
                                                                                .. attribute:: ipv4_addr_array
                                                                                
                                                                                	ipv4 addr array
                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.ipv4_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-addr-ipv4"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                class Ipv4AddrArray(Entity):
                                                                                    """
                                                                                    ipv4 addr array
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	prefix
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	mask
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                        ])
                                                                                        self.prefix = None
                                                                                        self.mask = None
                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                            class SrcAddrIpv6(Entity):
                                                                                """
                                                                                Source Address IPV6
                                                                                
                                                                                .. attribute:: ipv6_addr_array
                                                                                
                                                                                	ipv6 addr array
                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.ipv6_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-ipv6"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                class Ipv6AddrArray(Entity):
                                                                                    """
                                                                                    ipv6 addr array
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	IPV6 prefix
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	IPV6 mask
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                        ])
                                                                                        self.prefix = None
                                                                                        self.mask = None
                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                            class DstAddrIpv6(Entity):
                                                                                """
                                                                                Destination Address IPV6
                                                                                
                                                                                .. attribute:: ipv6_addr_array
                                                                                
                                                                                	ipv6 addr array
                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.ipv6_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-addr-ipv6"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                class Ipv6AddrArray(Entity):
                                                                                    """
                                                                                    ipv6 addr array
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	IPV6 prefix
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	IPV6 mask
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                        ])
                                                                                        self.prefix = None
                                                                                        self.mask = None
                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                            class SrcAddrMac(Entity):
                                                                                """
                                                                                Source Address MAC
                                                                                
                                                                                .. attribute:: mac_addr_array
                                                                                
                                                                                	mac addr array
                                                                                	**type**\: list of  		 :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                    self.yang_name = "src-addr-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("mac-addr-array", ("mac_addr_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.mac_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-mac"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                class MacAddrArray(Entity):
                                                                                    """
                                                                                    mac addr array
                                                                                    
                                                                                    .. attribute:: mac_addr
                                                                                    
                                                                                    	MAC address
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	MAC mask
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                        self.yang_name = "mac-addr-array"
                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                            ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                        ])
                                                                                        self.mac_addr = []
                                                                                        self.mask = []
                                                                                        self._segment_path = lambda: "mac-addr-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                            class Timer(Entity):
                                                                                """
                                                                                Timer
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                    self.yang_name = "timer"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "timer"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                            class TimerRegexp(Entity):
                                                                                """
                                                                                Timer Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                    self.yang_name = "timer-regexp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "timer-regexp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                            class TunnelName(Entity):
                                                                                """
                                                                                Tunnel Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                    self.yang_name = "tunnel-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "tunnel-name"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                            class TunnelNameRegex(Entity):
                                                                                """
                                                                                Tunnel Name Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "tunnel-name-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                            class UserName(Entity):
                                                                                """
                                                                                User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                    self.yang_name = "user-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "user-name"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                            class UserNameRegex(Entity):
                                                                                """
                                                                                User Name Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                    self.yang_name = "user-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "user-name-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                            class AuthUsername(Entity):
                                                                                """
                                                                                Authenticated User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                    self.yang_name = "auth-username"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "auth-username"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                            class AuthUsernameRegex(Entity):
                                                                                """
                                                                                Authenticated User Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                    self.yang_name = "auth-username-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "auth-username-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                            class UnauthUsername(Entity):
                                                                                """
                                                                                Unauthenticated User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                    self.yang_name = "unauth-username"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "unauth-username"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                            class UnauthUsernameRegex(Entity):
                                                                                """
                                                                                Unauthenticated User Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                    self.yang_name = "unauth-username-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "unauth-username-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                            class AuthDomain(Entity):
                                                                                """
                                                                                Authenticated domain name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                    self.yang_name = "auth-domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "auth-domain"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                            class AuthDomainRegex(Entity):
                                                                                """
                                                                                Authenticated Domain Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                    self.yang_name = "auth-domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "auth-domain-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                            class UnauthDomain(Entity):
                                                                                """
                                                                                Unauthenticated Domain Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                    self.yang_name = "unauth-domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "unauth-domain"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                            class UnauthDomainRegex(Entity):
                                                                                """
                                                                                Unauthenticated Domain Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "unauth-domain-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                            class VendorId(Entity):
                                                                                """
                                                                                Vendor ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                    self.yang_name = "vendor-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "vendor-id"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                            class VendorIdRegex(Entity):
                                                                                """
                                                                                Vendor ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                    self.yang_name = "vendor-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "vendor-id-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                            class AccessInterface(Entity):
                                                                                """
                                                                                Access interface
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                    self.yang_name = "access-interface"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "access-interface"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                            class InputInterface(Entity):
                                                                                """
                                                                                Input interface
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                    self.yang_name = "input-interface"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "input-interface"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                            class InputIntfhdl(Entity):
                                                                                """
                                                                                Input interface handle
                                                                                
                                                                                .. attribute:: uint64_array
                                                                                
                                                                                	uint64 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..18446744073709551615
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                    self.yang_name = "input-intfhdl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint64_array', (YLeafList(YType.uint64, 'uint64_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint64_array = []
                                                                                    self._segment_path = lambda: "input-intfhdl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                            class Ethertype(Entity):
                                                                                """
                                                                                Ethernet type
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                    self.yang_name = "ethertype"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ethertype"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ethertype"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class FlowKeyData(Entity):
                                                                                """
                                                                                Flow key structure
                                                                                
                                                                                .. attribute:: flow_keys
                                                                                
                                                                                	flow keys
                                                                                	**type**\:  :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                
                                                                                .. attribute:: max_count
                                                                                
                                                                                	Maximum count of flows
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: idle_timeout
                                                                                
                                                                                	Idle timeout of flows (in seconds)
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                	**units**\: second
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                    self.yang_name = "flow-key-data"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("flow-keys", ("flow_keys", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('max_count', (YLeaf(YType.uint16, 'max-count'), ['int'])),
                                                                                        ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                                    ])
                                                                                    self.max_count = None
                                                                                    self.idle_timeout = None

                                                                                    self.flow_keys = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                    self.flow_keys.parent = self
                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                    self._segment_path = lambda: "flow-key-data"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['max_count', 'idle_timeout'], name, value)


                                                                                class FlowKeys(Entity):
                                                                                    """
                                                                                    flow keys
                                                                                    
                                                                                    .. attribute:: keys
                                                                                    
                                                                                    	keys
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                    
                                                                                    .. attribute:: num
                                                                                    
                                                                                    	num
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                        self.yang_name = "flow-keys"
                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('keys', (YLeaf(YType.str, 'keys'), ['str'])),
                                                                                            ('num', (YLeaf(YType.uint8, 'num'), ['int'])),
                                                                                        ])
                                                                                        self.keys = None
                                                                                        self.num = None
                                                                                        self._segment_path = lambda: "flow-keys"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                            class DhcpClientId(Entity):
                                                                                """
                                                                                Dhcp Client ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                    self.yang_name = "dhcp-client-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "dhcp-client-id"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                            class DhcpClientIdRegex(Entity):
                                                                                """
                                                                                Dhcp Client ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                            class CircuitId(Entity):
                                                                                """
                                                                                Circuit ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                    self.yang_name = "circuit-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "circuit-id"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                            class CircuitIdRegex(Entity):
                                                                                """
                                                                                Circuit ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                    self.yang_name = "circuit-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "circuit-id-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                            class RemoteId(Entity):
                                                                                """
                                                                                Remote ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                    self.yang_name = "remote-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "remote-id"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                            class RemoteIdRegex(Entity):
                                                                                """
                                                                                Remote ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                    self.yang_name = "remote-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "remote-id-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                            class SrcPort(Entity):
                                                                                """
                                                                                Source port
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                    self.yang_name = "src-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "src-port"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "src-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class DstPort(Entity):
                                                                                """
                                                                                Destination port
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                    self.yang_name = "dst-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-port"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "dst-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['min', 'max'], name, value)


                                                        class ClmpP(Entity):
                                                            """
                                                            clmp p
                                                            
                                                            .. attribute:: class_map_bg
                                                            
                                                            	class map bg
                                                            	**type**\: list of  		 :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'infra-policymgr-oper'
                                                            _revision = '2018-01-17'

                                                            def __init__(self):
                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP, self).__init__()

                                                                self.yang_name = "clmp-p"
                                                                self.yang_parent_name = "policy-class-info-bg"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("class-map-bg", ("class_map_bg", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg))])
                                                                self._leafs = OrderedDict()

                                                                self.class_map_bg = YList(self)
                                                                self._segment_path = lambda: "clmp-p"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP, [], name, value)


                                                            class ClassMapBg(Entity):
                                                                """
                                                                class map bg
                                                                
                                                                .. attribute:: match_infop
                                                                
                                                                	Pointer to the first Match info
                                                                	**type**\:  :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop>`
                                                                
                                                                .. attribute:: name
                                                                
                                                                	Name of the class\-map
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..65
                                                                
                                                                .. attribute:: type
                                                                
                                                                	Class\-Map Type QoS/PBR/Netflow/..
                                                                	**type**\:  :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                                
                                                                .. attribute:: mode
                                                                
                                                                	Class\-Map Mode Match any/Match all
                                                                	**type**\:  :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                
                                                                .. attribute:: description
                                                                
                                                                	description
                                                                	**type**\: str
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg, self).__init__()

                                                                    self.yang_name = "class-map-bg"
                                                                    self.yang_parent_name = "clmp-p"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("match-infop", ("match_infop", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop))])
                                                                    self._leafs = OrderedDict([
                                                                        ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapTypeEn', '')])),
                                                                        ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapModeEn', '')])),
                                                                        ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                    ])
                                                                    self.name = None
                                                                    self.type = None
                                                                    self.mode = None
                                                                    self.description = None

                                                                    self.match_infop = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop()
                                                                    self.match_infop.parent = self
                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                    self._segment_path = lambda: "class-map-bg"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg, ['name', 'type', 'mode', 'description'], name, value)


                                                                class MatchInfop(Entity):
                                                                    """
                                                                    Pointer to the first Match info
                                                                    
                                                                    .. attribute:: class_match_info_st
                                                                    
                                                                    	class match info st
                                                                    	**type**\: list of  		 :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop, self).__init__()

                                                                        self.yang_name = "match-infop"
                                                                        self.yang_parent_name = "class-map-bg"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("class-match-info-st", ("class_match_info_st", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt))])
                                                                        self._leafs = OrderedDict()

                                                                        self.class_match_info_st = YList(self)
                                                                        self._segment_path = lambda: "match-infop"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop, [], name, value)


                                                                    class ClassMatchInfoSt(Entity):
                                                                        """
                                                                        class match info st
                                                                        
                                                                        .. attribute:: match_data
                                                                        
                                                                        	Match criteria
                                                                        	**type**\:  :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                        
                                                                        .. attribute:: flags
                                                                        
                                                                        	Flags
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                            self.yang_name = "class-match-info-st"
                                                                            self.yang_parent_name = "match-infop"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("match-data", ("match_data", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData))])
                                                                            self._leafs = OrderedDict([
                                                                                ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                            ])
                                                                            self.flags = None

                                                                            self.match_data = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                            self.match_data.parent = self
                                                                            self._children_name_map["match_data"] = "match-data"
                                                                            self._segment_path = lambda: "class-match-info-st"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                        class MatchData(Entity):
                                                                            """
                                                                            Match criteria
                                                                            
                                                                            .. attribute:: ipv4_dscp
                                                                            
                                                                            	IPv4 DSCP
                                                                            	**type**\:  :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                            
                                                                            .. attribute:: ipv6_dscp
                                                                            
                                                                            	IPv6 DSCP
                                                                            	**type**\:  :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                            
                                                                            .. attribute:: dscp
                                                                            
                                                                            	Match DSCP range array
                                                                            	**type**\:  :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                            
                                                                            .. attribute:: ipv4_prec
                                                                            
                                                                            	IPv4 Precedence
                                                                            	**type**\:  :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                            
                                                                            .. attribute:: ipv6_prec
                                                                            
                                                                            	IPv6 Precedence
                                                                            	**type**\:  :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                            
                                                                            .. attribute:: prec
                                                                            
                                                                            	Match Precedence array
                                                                            	**type**\:  :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                            
                                                                            .. attribute:: discard_class
                                                                            
                                                                            	Match Discard Class array
                                                                            	**type**\:  :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                            
                                                                            .. attribute:: qos_group
                                                                            
                                                                            	Match QoS group array
                                                                            	**type**\:  :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                            
                                                                            .. attribute:: traffic_class
                                                                            
                                                                            	Match Traffic class array
                                                                            	**type**\:  :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                            
                                                                            .. attribute:: proto
                                                                            
                                                                            	Match Protocol array
                                                                            	**type**\:  :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                            
                                                                            .. attribute:: icmp_v4
                                                                            
                                                                            	Match ICMPV4 Protocol
                                                                            	**type**\:  :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                            
                                                                            .. attribute:: icmp_v6
                                                                            
                                                                            	Match ICMPV6 Protocol array
                                                                            	**type**\:  :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                            
                                                                            .. attribute:: ipv4_packet_len
                                                                            
                                                                            	IPv4 packet length array
                                                                            	**type**\:  :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                            
                                                                            .. attribute:: ipv6_packet_len
                                                                            
                                                                            	IPv6 packet length array
                                                                            	**type**\:  :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                            
                                                                            .. attribute:: packet_len
                                                                            
                                                                            	Match packet length array
                                                                            	**type**\:  :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                            
                                                                            .. attribute:: flow_tag
                                                                            
                                                                            	Match flow\-tag array
                                                                            	**type**\:  :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                            
                                                                            .. attribute:: tcp_flag
                                                                            
                                                                            	Match tcp flag value
                                                                            	**type**\:  :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                            
                                                                            .. attribute:: icmpv4_type
                                                                            
                                                                            	Match ipv4 icmp type
                                                                            	**type**\:  :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                            
                                                                            .. attribute:: icmpv4_code
                                                                            
                                                                            	Match ipv4 icmp code
                                                                            	**type**\:  :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                            
                                                                            .. attribute:: icmpv6_type
                                                                            
                                                                            	Match ipv6 icmp type
                                                                            	**type**\:  :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                            
                                                                            .. attribute:: icmpv6_code
                                                                            
                                                                            	Match ipv6 icmp code
                                                                            	**type**\:  :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                            
                                                                            .. attribute:: mpls_exp
                                                                            
                                                                            	Match MPLS experimental topmost array
                                                                            	**type**\:  :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                            
                                                                            .. attribute:: mpls_exp_imp
                                                                            
                                                                            	Match MPLS experimental imposition array
                                                                            	**type**\:  :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                            
                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                            
                                                                            	MPLS Disposition IPv4 Access\-list
                                                                            	**type**\:  :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                            
                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                            
                                                                            	MPLS Disposition IPv6 Access\-list
                                                                            	**type**\:  :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                            
                                                                            .. attribute:: mpls_top_label
                                                                            
                                                                            	MPLS Topmost LABEL
                                                                            	**type**\:  :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                            
                                                                            .. attribute:: cos
                                                                            
                                                                            	Match CoS array
                                                                            	**type**\:  :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                            
                                                                            .. attribute:: cos_inr
                                                                            
                                                                            	Match inner header CoS
                                                                            	**type**\:  :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                            
                                                                            .. attribute:: dei
                                                                            
                                                                            	Match DEI Bit
                                                                            	**type**\:  :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                            
                                                                            .. attribute:: dei_inr
                                                                            
                                                                            	Match inner DEI Bit
                                                                            	**type**\:  :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                            
                                                                            .. attribute:: vlan
                                                                            
                                                                            	Match VLAN array
                                                                            	**type**\:  :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                            
                                                                            .. attribute:: vlan_inr
                                                                            
                                                                            	Match inner header VLAN range array
                                                                            	**type**\:  :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                            
                                                                            .. attribute:: fr_dlci
                                                                            
                                                                            	Match FR DLCI range array
                                                                            	**type**\:  :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                            
                                                                            .. attribute:: src_mac
                                                                            
                                                                            	Match Source MAC address
                                                                            	**type**\:  :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                            
                                                                            .. attribute:: dst_mac
                                                                            
                                                                            	Match Destination MAC address
                                                                            	**type**\:  :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                            
                                                                            .. attribute:: atm_clp
                                                                            
                                                                            	Match ATM CLP level
                                                                            	**type**\:  :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                            
                                                                            .. attribute:: fr_de
                                                                            
                                                                            	Match FR DE value
                                                                            	**type**\:  :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                            
                                                                            .. attribute:: ipv4_acl
                                                                            
                                                                            	IPv4 Access\-list
                                                                            	**type**\:  :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                            
                                                                            .. attribute:: ipv6_acl
                                                                            
                                                                            	IPv6 Access\-list
                                                                            	**type**\:  :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                            
                                                                            .. attribute:: ether_service_acl
                                                                            
                                                                            	Ethernet\-Services Access\-list
                                                                            	**type**\:  :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                            
                                                                            .. attribute:: avail_id
                                                                            
                                                                            	Available Identifiers
                                                                            	**type**\:  :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                            
                                                                            .. attribute:: media_type
                                                                            
                                                                            	Media Type
                                                                            	**type**\:  :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                            
                                                                            .. attribute:: subs_protocol
                                                                            
                                                                            	Protocol
                                                                            	**type**\:  :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                            
                                                                            .. attribute:: dnis
                                                                            
                                                                            	DNIS
                                                                            	**type**\:  :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                            
                                                                            .. attribute:: dnis_regex
                                                                            
                                                                            	DNIS Regular Expression
                                                                            	**type**\:  :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                            
                                                                            .. attribute:: domain
                                                                            
                                                                            	Domain Name
                                                                            	**type**\:  :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                            
                                                                            .. attribute:: domain_regex
                                                                            
                                                                            	Domain Regular Expression
                                                                            	**type**\:  :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                            
                                                                            .. attribute:: nas_port
                                                                            
                                                                            	NAS Port
                                                                            	**type**\:  :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                            
                                                                            .. attribute:: service_name
                                                                            
                                                                            	Service Name
                                                                            	**type**\:  :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                            
                                                                            .. attribute:: service_name_regex
                                                                            
                                                                            	Service Name Regular Exp
                                                                            	**type**\:  :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                            
                                                                            .. attribute:: src_addr_ipv4
                                                                            
                                                                            	Source Address IPV4
                                                                            	**type**\:  :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                            
                                                                            .. attribute:: dst_addr_ipv4
                                                                            
                                                                            	Destination Address IPV4
                                                                            	**type**\:  :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                            
                                                                            .. attribute:: src_addr_ipv6
                                                                            
                                                                            	Source Address IPV6
                                                                            	**type**\:  :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                            
                                                                            .. attribute:: dst_addr_ipv6
                                                                            
                                                                            	Destination Address IPV6
                                                                            	**type**\:  :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                            
                                                                            .. attribute:: src_addr_mac
                                                                            
                                                                            	Source Address MAC
                                                                            	**type**\:  :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                            
                                                                            .. attribute:: timer
                                                                            
                                                                            	Timer
                                                                            	**type**\:  :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                            
                                                                            .. attribute:: timer_regexp
                                                                            
                                                                            	Timer Regular Expression
                                                                            	**type**\:  :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                            
                                                                            .. attribute:: tunnel_name
                                                                            
                                                                            	Tunnel Name
                                                                            	**type**\:  :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                            
                                                                            .. attribute:: tunnel_name_regex
                                                                            
                                                                            	Tunnel Name Regular Expression
                                                                            	**type**\:  :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                            
                                                                            .. attribute:: user_name
                                                                            
                                                                            	User Name
                                                                            	**type**\:  :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                            
                                                                            .. attribute:: user_name_regex
                                                                            
                                                                            	User Name Regular Expression
                                                                            	**type**\:  :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                            
                                                                            .. attribute:: auth_username
                                                                            
                                                                            	Authenticated User Name
                                                                            	**type**\:  :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                            
                                                                            .. attribute:: auth_username_regex
                                                                            
                                                                            	Authenticated User Name RegEx
                                                                            	**type**\:  :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                            
                                                                            .. attribute:: unauth_username
                                                                            
                                                                            	Unauthenticated User Name
                                                                            	**type**\:  :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                            
                                                                            .. attribute:: unauth_username_regex
                                                                            
                                                                            	Unauthenticated User Name RegEx
                                                                            	**type**\:  :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                            
                                                                            .. attribute:: auth_domain
                                                                            
                                                                            	Authenticated domain name
                                                                            	**type**\:  :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                            
                                                                            .. attribute:: auth_domain_regex
                                                                            
                                                                            	Authenticated Domain Name RegEx
                                                                            	**type**\:  :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                            
                                                                            .. attribute:: unauth_domain
                                                                            
                                                                            	Unauthenticated Domain Name
                                                                            	**type**\:  :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                            
                                                                            .. attribute:: unauth_domain_regex
                                                                            
                                                                            	Unauthenticated Domain Name RegEx
                                                                            	**type**\:  :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                            
                                                                            .. attribute:: vendor_id
                                                                            
                                                                            	Vendor ID
                                                                            	**type**\:  :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                            
                                                                            .. attribute:: vendor_id_regex
                                                                            
                                                                            	Vendor ID RegEx
                                                                            	**type**\:  :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                            
                                                                            .. attribute:: access_interface
                                                                            
                                                                            	Access interface
                                                                            	**type**\:  :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                            
                                                                            .. attribute:: input_interface
                                                                            
                                                                            	Input interface
                                                                            	**type**\:  :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                            
                                                                            .. attribute:: input_intfhdl
                                                                            
                                                                            	Input interface handle
                                                                            	**type**\:  :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                            
                                                                            .. attribute:: ethertype
                                                                            
                                                                            	Ethernet type
                                                                            	**type**\:  :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                            
                                                                            .. attribute:: flow_key_data
                                                                            
                                                                            	Flow key structure
                                                                            	**type**\:  :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                            
                                                                            .. attribute:: dhcp_client_id
                                                                            
                                                                            	Dhcp Client ID
                                                                            	**type**\:  :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                            
                                                                            .. attribute:: dhcp_client_id_regex
                                                                            
                                                                            	Dhcp Client ID RegEx
                                                                            	**type**\:  :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                            
                                                                            .. attribute:: circuit_id
                                                                            
                                                                            	Circuit ID
                                                                            	**type**\:  :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                            
                                                                            .. attribute:: circuit_id_regex
                                                                            
                                                                            	Circuit ID RegEx
                                                                            	**type**\:  :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                            
                                                                            .. attribute:: remote_id
                                                                            
                                                                            	Remote ID
                                                                            	**type**\:  :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                            
                                                                            .. attribute:: remote_id_regex
                                                                            
                                                                            	Remote ID RegEx
                                                                            	**type**\:  :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                            
                                                                            .. attribute:: src_port
                                                                            
                                                                            	Source port
                                                                            	**type**\:  :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                            
                                                                            .. attribute:: dst_port
                                                                            
                                                                            	Destination port
                                                                            	**type**\:  :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:  :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                            
                                                                            .. attribute:: mpls_top_eos
                                                                            
                                                                            	MPLS Topmost EOS
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: fragment_type
                                                                            
                                                                            	Fragment type
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: authen_status
                                                                            
                                                                            	Authentication Status
                                                                            	**type**\:  :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                            
                                                                            .. attribute:: mlp_negotiated
                                                                            
                                                                            	MLP Negotiated
                                                                            	**type**\:  :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                self.yang_name = "match-data"
                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("ipv4-dscp", ("ipv4_dscp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp)), ("ipv6-dscp", ("ipv6_dscp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp)), ("dscp", ("dscp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp)), ("ipv4-prec", ("ipv4_prec", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec)), ("ipv6-prec", ("ipv6_prec", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec)), ("prec", ("prec", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec)), ("discard-class", ("discard_class", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass)), ("qos-group", ("qos_group", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup)), ("traffic-class", ("traffic_class", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass)), ("proto", ("proto", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto)), ("icmp-v4", ("icmp_v4", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4)), ("icmp-v6", ("icmp_v6", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6)), ("ipv4-packet-len", ("ipv4_packet_len", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen)), ("ipv6-packet-len", ("ipv6_packet_len", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen)), ("packet-len", ("packet_len", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen)), ("flow-tag", ("flow_tag", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag)), ("tcp-flag", ("tcp_flag", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag)), ("icmpv4-type", ("icmpv4_type", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type)), ("icmpv4-code", ("icmpv4_code", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code)), ("icmpv6-type", ("icmpv6_type", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type)), ("icmpv6-code", ("icmpv6_code", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code)), ("mpls-exp", ("mpls_exp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp)), ("mpls-exp-imp", ("mpls_exp_imp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp)), ("mpls-disp-ipv4-acl", ("mpls_disp_ipv4_acl", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl)), ("mpls-disp-ipv6-acl", ("mpls_disp_ipv6_acl", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl)), ("mpls-top-label", ("mpls_top_label", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel)), ("cos", ("cos", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos)), ("cos-inr", ("cos_inr", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr)), ("dei", ("dei", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei)), ("dei-inr", ("dei_inr", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr)), ("vlan", ("vlan", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan)), ("vlan-inr", ("vlan_inr", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)), ("fr-dlci", ("fr_dlci", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci)), ("src-mac", ("src_mac", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac)), ("dst-mac", ("dst_mac", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac)), ("atm-clp", ("atm_clp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp)), ("fr-de", ("fr_de", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe)), ("ipv4-acl", ("ipv4_acl", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl)), ("ipv6-acl", ("ipv6_acl", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl)), ("ether-service-acl", ("ether_service_acl", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl)), ("avail-id", ("avail_id", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId)), ("media-type", ("media_type", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType)), ("subs-protocol", ("subs_protocol", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol)), ("dnis", ("dnis", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis)), ("dnis-regex", ("dnis_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex)), ("domain", ("domain", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain)), ("domain-regex", ("domain_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex)), ("nas-port", ("nas_port", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort)), ("service-name", ("service_name", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName)), ("service-name-regex", ("service_name_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex)), ("src-addr-ipv4", ("src_addr_ipv4", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4)), ("dst-addr-ipv4", ("dst_addr_ipv4", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4)), ("src-addr-ipv6", ("src_addr_ipv6", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6)), ("dst-addr-ipv6", ("dst_addr_ipv6", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6)), ("src-addr-mac", ("src_addr_mac", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac)), ("timer", ("timer", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer)), ("timer-regexp", ("timer_regexp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp)), ("tunnel-name", ("tunnel_name", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName)), ("tunnel-name-regex", ("tunnel_name_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex)), ("user-name", ("user_name", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName)), ("user-name-regex", ("user_name_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex)), ("auth-username", ("auth_username", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername)), ("auth-username-regex", ("auth_username_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex)), ("unauth-username", ("unauth_username", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername)), ("unauth-username-regex", ("unauth_username_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex)), ("auth-domain", ("auth_domain", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain)), ("auth-domain-regex", ("auth_domain_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex)), ("unauth-domain", ("unauth_domain", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain)), ("unauth-domain-regex", ("unauth_domain_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex)), ("vendor-id", ("vendor_id", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId)), ("vendor-id-regex", ("vendor_id_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex)), ("access-interface", ("access_interface", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface)), ("input-interface", ("input_interface", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface)), ("input-intfhdl", ("input_intfhdl", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl)), ("ethertype", ("ethertype", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype)), ("flow-key-data", ("flow_key_data", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData)), ("dhcp-client-id", ("dhcp_client_id", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId)), ("dhcp-client-id-regex", ("dhcp_client_id_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex)), ("circuit-id", ("circuit_id", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId)), ("circuit-id-regex", ("circuit_id_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex)), ("remote-id", ("remote_id", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId)), ("remote-id-regex", ("remote_id_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex)), ("src-port", ("src_port", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort)), ("dst-port", ("dst_port", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchTypeEn', '')])),
                                                                                    ('mpls_top_eos', (YLeaf(YType.uint8, 'mpls-top-eos'), ['int'])),
                                                                                    ('fragment_type', (YLeaf(YType.uint8, 'fragment-type'), ['int'])),
                                                                                    ('authen_status', (YLeaf(YType.enumeration, 'authen-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchAuthenStatusEn', '')])),
                                                                                    ('mlp_negotiated', (YLeaf(YType.enumeration, 'mlp-negotiated'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchMlpNegotiatedEn', '')])),
                                                                                ])
                                                                                self.type = None
                                                                                self.mpls_top_eos = None
                                                                                self.fragment_type = None
                                                                                self.authen_status = None
                                                                                self.mlp_negotiated = None

                                                                                self.ipv4_dscp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                self.ipv4_dscp.parent = self
                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"

                                                                                self.ipv6_dscp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                self.ipv6_dscp.parent = self
                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"

                                                                                self.dscp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                self.dscp.parent = self
                                                                                self._children_name_map["dscp"] = "dscp"

                                                                                self.ipv4_prec = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                self.ipv4_prec.parent = self
                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"

                                                                                self.ipv6_prec = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                self.ipv6_prec.parent = self
                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"

                                                                                self.prec = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                self.prec.parent = self
                                                                                self._children_name_map["prec"] = "prec"

                                                                                self.discard_class = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                self.discard_class.parent = self
                                                                                self._children_name_map["discard_class"] = "discard-class"

                                                                                self.qos_group = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                self.qos_group.parent = self
                                                                                self._children_name_map["qos_group"] = "qos-group"

                                                                                self.traffic_class = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                self.traffic_class.parent = self
                                                                                self._children_name_map["traffic_class"] = "traffic-class"

                                                                                self.proto = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                self.proto.parent = self
                                                                                self._children_name_map["proto"] = "proto"

                                                                                self.icmp_v4 = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                self.icmp_v4.parent = self
                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"

                                                                                self.icmp_v6 = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                self.icmp_v6.parent = self
                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"

                                                                                self.ipv4_packet_len = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                self.ipv4_packet_len.parent = self
                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"

                                                                                self.ipv6_packet_len = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                self.ipv6_packet_len.parent = self
                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"

                                                                                self.packet_len = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                self.packet_len.parent = self
                                                                                self._children_name_map["packet_len"] = "packet-len"

                                                                                self.flow_tag = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                self.flow_tag.parent = self
                                                                                self._children_name_map["flow_tag"] = "flow-tag"

                                                                                self.tcp_flag = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                self.tcp_flag.parent = self
                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"

                                                                                self.icmpv4_type = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                self.icmpv4_type.parent = self
                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"

                                                                                self.icmpv4_code = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                self.icmpv4_code.parent = self
                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"

                                                                                self.icmpv6_type = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                self.icmpv6_type.parent = self
                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"

                                                                                self.icmpv6_code = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                self.icmpv6_code.parent = self
                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"

                                                                                self.mpls_exp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                self.mpls_exp.parent = self
                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"

                                                                                self.mpls_exp_imp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                self.mpls_exp_imp.parent = self
                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"

                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"

                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"

                                                                                self.mpls_top_label = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                self.mpls_top_label.parent = self
                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"

                                                                                self.cos = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                self.cos.parent = self
                                                                                self._children_name_map["cos"] = "cos"

                                                                                self.cos_inr = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                self.cos_inr.parent = self
                                                                                self._children_name_map["cos_inr"] = "cos-inr"

                                                                                self.dei = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                self.dei.parent = self
                                                                                self._children_name_map["dei"] = "dei"

                                                                                self.dei_inr = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                self.dei_inr.parent = self
                                                                                self._children_name_map["dei_inr"] = "dei-inr"

                                                                                self.vlan = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                self.vlan.parent = self
                                                                                self._children_name_map["vlan"] = "vlan"

                                                                                self.vlan_inr = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                self.vlan_inr.parent = self
                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"

                                                                                self.fr_dlci = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                self.fr_dlci.parent = self
                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"

                                                                                self.src_mac = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                self.src_mac.parent = self
                                                                                self._children_name_map["src_mac"] = "src-mac"

                                                                                self.dst_mac = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                self.dst_mac.parent = self
                                                                                self._children_name_map["dst_mac"] = "dst-mac"

                                                                                self.atm_clp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                self.atm_clp.parent = self
                                                                                self._children_name_map["atm_clp"] = "atm-clp"

                                                                                self.fr_de = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                self.fr_de.parent = self
                                                                                self._children_name_map["fr_de"] = "fr-de"

                                                                                self.ipv4_acl = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                self.ipv4_acl.parent = self
                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"

                                                                                self.ipv6_acl = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                self.ipv6_acl.parent = self
                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"

                                                                                self.ether_service_acl = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                self.ether_service_acl.parent = self
                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"

                                                                                self.avail_id = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                self.avail_id.parent = self
                                                                                self._children_name_map["avail_id"] = "avail-id"

                                                                                self.media_type = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                self.media_type.parent = self
                                                                                self._children_name_map["media_type"] = "media-type"

                                                                                self.subs_protocol = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                self.subs_protocol.parent = self
                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"

                                                                                self.dnis = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                self.dnis.parent = self
                                                                                self._children_name_map["dnis"] = "dnis"

                                                                                self.dnis_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                self.dnis_regex.parent = self
                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"

                                                                                self.domain = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                self.domain.parent = self
                                                                                self._children_name_map["domain"] = "domain"

                                                                                self.domain_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                self.domain_regex.parent = self
                                                                                self._children_name_map["domain_regex"] = "domain-regex"

                                                                                self.nas_port = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                self.nas_port.parent = self
                                                                                self._children_name_map["nas_port"] = "nas-port"

                                                                                self.service_name = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                self.service_name.parent = self
                                                                                self._children_name_map["service_name"] = "service-name"

                                                                                self.service_name_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                self.service_name_regex.parent = self
                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"

                                                                                self.src_addr_ipv4 = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                self.src_addr_ipv4.parent = self
                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"

                                                                                self.dst_addr_ipv4 = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                self.dst_addr_ipv4.parent = self
                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"

                                                                                self.src_addr_ipv6 = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                self.src_addr_ipv6.parent = self
                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"

                                                                                self.dst_addr_ipv6 = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                self.dst_addr_ipv6.parent = self
                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"

                                                                                self.src_addr_mac = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                self.src_addr_mac.parent = self
                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"

                                                                                self.timer = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                self.timer.parent = self
                                                                                self._children_name_map["timer"] = "timer"

                                                                                self.timer_regexp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                self.timer_regexp.parent = self
                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"

                                                                                self.tunnel_name = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                self.tunnel_name.parent = self
                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"

                                                                                self.tunnel_name_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                self.tunnel_name_regex.parent = self
                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"

                                                                                self.user_name = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                self.user_name.parent = self
                                                                                self._children_name_map["user_name"] = "user-name"

                                                                                self.user_name_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                self.user_name_regex.parent = self
                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"

                                                                                self.auth_username = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                self.auth_username.parent = self
                                                                                self._children_name_map["auth_username"] = "auth-username"

                                                                                self.auth_username_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                self.auth_username_regex.parent = self
                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"

                                                                                self.unauth_username = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                self.unauth_username.parent = self
                                                                                self._children_name_map["unauth_username"] = "unauth-username"

                                                                                self.unauth_username_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                self.unauth_username_regex.parent = self
                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"

                                                                                self.auth_domain = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                self.auth_domain.parent = self
                                                                                self._children_name_map["auth_domain"] = "auth-domain"

                                                                                self.auth_domain_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                self.auth_domain_regex.parent = self
                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"

                                                                                self.unauth_domain = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                self.unauth_domain.parent = self
                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"

                                                                                self.unauth_domain_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                self.unauth_domain_regex.parent = self
                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"

                                                                                self.vendor_id = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                self.vendor_id.parent = self
                                                                                self._children_name_map["vendor_id"] = "vendor-id"

                                                                                self.vendor_id_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                self.vendor_id_regex.parent = self
                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"

                                                                                self.access_interface = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                self.access_interface.parent = self
                                                                                self._children_name_map["access_interface"] = "access-interface"

                                                                                self.input_interface = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                self.input_interface.parent = self
                                                                                self._children_name_map["input_interface"] = "input-interface"

                                                                                self.input_intfhdl = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                self.input_intfhdl.parent = self
                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"

                                                                                self.ethertype = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                self.ethertype.parent = self
                                                                                self._children_name_map["ethertype"] = "ethertype"

                                                                                self.flow_key_data = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                self.flow_key_data.parent = self
                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"

                                                                                self.dhcp_client_id = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                self.dhcp_client_id.parent = self
                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"

                                                                                self.dhcp_client_id_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                self.dhcp_client_id_regex.parent = self
                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"

                                                                                self.circuit_id = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                self.circuit_id.parent = self
                                                                                self._children_name_map["circuit_id"] = "circuit-id"

                                                                                self.circuit_id_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                self.circuit_id_regex.parent = self
                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"

                                                                                self.remote_id = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                self.remote_id.parent = self
                                                                                self._children_name_map["remote_id"] = "remote-id"

                                                                                self.remote_id_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                self.remote_id_regex.parent = self
                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"

                                                                                self.src_port = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                self.src_port.parent = self
                                                                                self._children_name_map["src_port"] = "src-port"

                                                                                self.dst_port = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                self.dst_port.parent = self
                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                self._segment_path = lambda: "match-data"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['type', 'mpls_top_eos', 'fragment_type', 'authen_status', 'mlp_negotiated'], name, value)


                                                                            class Ipv4Dscp(Entity):
                                                                                """
                                                                                IPv4 DSCP
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                    self.yang_name = "ipv4-dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv4-dscp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Ipv6Dscp(Entity):
                                                                                """
                                                                                IPv6 DSCP
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                    self.yang_name = "ipv6-dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv6-dscp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Dscp(Entity):
                                                                                """
                                                                                Match DSCP range array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                    self.yang_name = "dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "dscp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Ipv4Prec(Entity):
                                                                                """
                                                                                IPv4 Precedence
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                    self.yang_name = "ipv4-prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "ipv4-prec"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                            class Ipv6Prec(Entity):
                                                                                """
                                                                                IPv6 Precedence
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                    self.yang_name = "ipv6-prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "ipv6-prec"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                            class Prec(Entity):
                                                                                """
                                                                                Match Precedence array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                    self.yang_name = "prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "prec"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                            class DiscardClass(Entity):
                                                                                """
                                                                                Match Discard Class array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                    self.yang_name = "discard-class"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "discard-class"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                            class QosGroup(Entity):
                                                                                """
                                                                                Match QoS group array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                    self.yang_name = "qos-group"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "qos-group"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "qos-group"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class TrafficClass(Entity):
                                                                                """
                                                                                Match Traffic class array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                    self.yang_name = "traffic-class"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "traffic-class"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "traffic-class"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Proto(Entity):
                                                                                """
                                                                                Match Protocol array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                    self.yang_name = "proto"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "proto"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "proto"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class IcmpV4(Entity):
                                                                                """
                                                                                Match ICMPV4 Protocol
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Protocol type
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: code
                                                                                
                                                                                	Protocol code
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                    self.yang_name = "icmp-v4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                    ])
                                                                                    self.type = None
                                                                                    self.code = None
                                                                                    self._segment_path = lambda: "icmp-v4"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['type', 'code'], name, value)


                                                                            class IcmpV6(Entity):
                                                                                """
                                                                                Match ICMPV6 Protocol array
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Protocol type
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: code
                                                                                
                                                                                	Protocol code
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                    self.yang_name = "icmp-v6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                    ])
                                                                                    self.type = None
                                                                                    self.code = None
                                                                                    self._segment_path = lambda: "icmp-v6"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['type', 'code'], name, value)


                                                                            class Ipv4PacketLen(Entity):
                                                                                """
                                                                                IPv4 packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv4-packet-len"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class Ipv6PacketLen(Entity):
                                                                                """
                                                                                IPv6 packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv6-packet-len"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class PacketLen(Entity):
                                                                                """
                                                                                Match packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                    self.yang_name = "packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "packet-len"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class FlowTag(Entity):
                                                                                """
                                                                                Match flow\-tag array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                    self.yang_name = "flow-tag"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "flow-tag"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "flow-tag"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class TcpFlag(Entity):
                                                                                """
                                                                                Match tcp flag value
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	Value of TCP flag
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: match_any
                                                                                
                                                                                	Match any TCP flag bit
                                                                                	**type**\: bool
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                    self.yang_name = "tcp-flag"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                        ('match_any', (YLeaf(YType.boolean, 'match-any'), ['bool'])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.match_any = None
                                                                                    self._segment_path = lambda: "tcp-flag"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['value', 'match_any'], name, value)


                                                                            class Icmpv4Type(Entity):
                                                                                """
                                                                                Match ipv4 icmp type
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                    self.yang_name = "icmpv4-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv4-type"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Icmpv4Code(Entity):
                                                                                """
                                                                                Match ipv4 icmp code
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                    self.yang_name = "icmpv4-code"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv4-code"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Icmpv6Type(Entity):
                                                                                """
                                                                                Match ipv6 icmp type
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                    self.yang_name = "icmpv6-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv6-type"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Icmpv6Code(Entity):
                                                                                """
                                                                                Match ipv6 icmp code
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                    self.yang_name = "icmpv6-code"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv6-code"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class MplsExp(Entity):
                                                                                """
                                                                                Match MPLS experimental topmost array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                    self.yang_name = "mpls-exp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "mpls-exp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                            class MplsExpImp(Entity):
                                                                                """
                                                                                Match MPLS experimental imposition array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "mpls-exp-imp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                            class MplsDispIpv4Acl(Entity):
                                                                                """
                                                                                MPLS Disposition IPv4 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                            class MplsDispIpv6Acl(Entity):
                                                                                """
                                                                                MPLS Disposition IPv6 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                            class MplsTopLabel(Entity):
                                                                                """
                                                                                MPLS Topmost LABEL
                                                                                
                                                                                .. attribute:: uint32_rng_array
                                                                                
                                                                                	uint32 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                    self.yang_name = "mpls-top-label"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint32_rng_array", ("uint32_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint32_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "mpls-top-label"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                class Uint32RngArray(Entity):
                                                                                    """
                                                                                    uint32 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                        self.yang_name = "uint32_rng_array"
                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint32, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint32, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint32_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['min', 'max'], name, value)


                                                                            class Cos(Entity):
                                                                                """
                                                                                Match CoS array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                    self.yang_name = "cos"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "cos"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                            class CosInr(Entity):
                                                                                """
                                                                                Match inner header CoS
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                    self.yang_name = "cos-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "cos-inr"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                            class Dei(Entity):
                                                                                """
                                                                                Match DEI Bit
                                                                                
                                                                                .. attribute:: bit_value
                                                                                
                                                                                	Value of the DEI bit
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                    self.yang_name = "dei"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                    ])
                                                                                    self.bit_value = None
                                                                                    self._segment_path = lambda: "dei"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                            class DeiInr(Entity):
                                                                                """
                                                                                Match inner DEI Bit
                                                                                
                                                                                .. attribute:: bit_value
                                                                                
                                                                                	Value of the DEI bit
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                    self.yang_name = "dei-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                    ])
                                                                                    self.bit_value = None
                                                                                    self._segment_path = lambda: "dei-inr"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                            class Vlan(Entity):
                                                                                """
                                                                                Match VLAN array
                                                                                
                                                                                .. attribute:: vlan_id_array
                                                                                
                                                                                	vlan id array
                                                                                	**type**\: list of  		 :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                    self.yang_name = "vlan"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("vlan-id-array", ("vlan_id_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.vlan_id_array = YList(self)
                                                                                    self._segment_path = lambda: "vlan"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                class VlanIdArray(Entity):
                                                                                    """
                                                                                    vlan id array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	VLAN mask
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                        self.yang_name = "vlan-id-array"
                                                                                        self.yang_parent_name = "vlan"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                            ('mask', (YLeaf(YType.uint16, 'mask'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self.mask = None
                                                                                        self._segment_path = lambda: "vlan-id-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['min', 'max', 'mask'], name, value)


                                                                            class VlanInr(Entity):
                                                                                """
                                                                                Match inner header VLAN range array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                    self.yang_name = "vlan-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "vlan-inr"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class FrDlci(Entity):
                                                                                """
                                                                                Match FR DLCI range array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                    self.yang_name = "fr-dlci"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "fr-dlci"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class SrcMac(Entity):
                                                                                """
                                                                                Match Source MAC address
                                                                                
                                                                                .. attribute:: mac_addr
                                                                                
                                                                                	MAC address
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	MAC mask
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                    self.yang_name = "src-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                    ])
                                                                                    self.mac_addr = []
                                                                                    self.mask = []
                                                                                    self._segment_path = lambda: "src-mac"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                            class DstMac(Entity):
                                                                                """
                                                                                Match Destination MAC address
                                                                                
                                                                                .. attribute:: mac_addr
                                                                                
                                                                                	MAC address
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	MAC mask
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                    self.yang_name = "dst-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                    ])
                                                                                    self.mac_addr = []
                                                                                    self.mask = []
                                                                                    self._segment_path = lambda: "dst-mac"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                            class AtmClp(Entity):
                                                                                """
                                                                                Match ATM CLP level
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                    self.yang_name = "atm-clp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "atm-clp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                            class FrDe(Entity):
                                                                                """
                                                                                Match FR DE value
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                    self.yang_name = "fr-de"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "fr-de"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                            class Ipv4Acl(Entity):
                                                                                """
                                                                                IPv4 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                    self.yang_name = "ipv4-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "ipv4-acl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                            class Ipv6Acl(Entity):
                                                                                """
                                                                                IPv6 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                    self.yang_name = "ipv6-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "ipv6-acl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                            class EtherServiceAcl(Entity):
                                                                                """
                                                                                Ethernet\-Services Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                    self.yang_name = "ether-service-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "ether-service-acl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                            class AvailId(Entity):
                                                                                """
                                                                                Available Identifiers
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                    self.yang_name = "avail-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "avail-id"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                            class MediaType(Entity):
                                                                                """
                                                                                Media Type
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                    self.yang_name = "media-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "media-type"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                            class SubsProtocol(Entity):
                                                                                """
                                                                                Protocol
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                    self.yang_name = "subs-protocol"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "subs-protocol"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                            class Dnis(Entity):
                                                                                """
                                                                                DNIS
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                    self.yang_name = "dnis"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "dnis"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                            class DnisRegex(Entity):
                                                                                """
                                                                                DNIS Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                    self.yang_name = "dnis-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "dnis-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                            class Domain(Entity):
                                                                                """
                                                                                Domain Name
                                                                                
                                                                                .. attribute:: domain_array
                                                                                
                                                                                	domain array
                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                    self.yang_name = "domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.domain_array = YList(self)
                                                                                    self._segment_path = lambda: "domain"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                class DomainArray(Entity):
                                                                                    """
                                                                                    domain array
                                                                                    
                                                                                    .. attribute:: domain_name
                                                                                    
                                                                                    	domain name
                                                                                    	**type**\: str
                                                                                    
                                                                                    .. attribute:: format_name
                                                                                    
                                                                                    	format name
                                                                                    	**type**\: str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                        self.yang_name = "domain-array"
                                                                                        self.yang_parent_name = "domain"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                        ])
                                                                                        self.domain_name = None
                                                                                        self.format_name = None
                                                                                        self._segment_path = lambda: "domain-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                            class DomainRegex(Entity):
                                                                                """
                                                                                Domain Regular Expression
                                                                                
                                                                                .. attribute:: domain_array
                                                                                
                                                                                	domain array
                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                    self.yang_name = "domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.domain_array = YList(self)
                                                                                    self._segment_path = lambda: "domain-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                class DomainArray(Entity):
                                                                                    """
                                                                                    domain array
                                                                                    
                                                                                    .. attribute:: domain_name
                                                                                    
                                                                                    	domain name
                                                                                    	**type**\: str
                                                                                    
                                                                                    .. attribute:: format_name
                                                                                    
                                                                                    	format name
                                                                                    	**type**\: str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                        self.yang_name = "domain-array"
                                                                                        self.yang_parent_name = "domain-regex"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                        ])
                                                                                        self.domain_name = None
                                                                                        self.format_name = None
                                                                                        self._segment_path = lambda: "domain-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                            class NasPort(Entity):
                                                                                """
                                                                                NAS Port
                                                                                
                                                                                .. attribute:: nas_port_array
                                                                                
                                                                                	nas port array
                                                                                	**type**\: list of  		 :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                    self.yang_name = "nas-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("nas-port-array", ("nas_port_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.nas_port_array = YList(self)
                                                                                    self._segment_path = lambda: "nas-port"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                class NasPortArray(Entity):
                                                                                    """
                                                                                    nas port array
                                                                                    
                                                                                    .. attribute:: sub_id
                                                                                    
                                                                                    	sub id
                                                                                    	**type**\:  :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                    
                                                                                    .. attribute:: operator
                                                                                    
                                                                                    	operator
                                                                                    	**type**\:  :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                        self.yang_name = "nas-port-array"
                                                                                        self.yang_parent_name = "nas-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('sub_id', (YLeaf(YType.enumeration, 'sub-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchNasPortSubIdEn', '')])),
                                                                                            ('operator', (YLeaf(YType.enumeration, 'operator'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchLogicalOperatorEn', '')])),
                                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ])
                                                                                        self.sub_id = None
                                                                                        self.operator = None
                                                                                        self.value = None
                                                                                        self._segment_path = lambda: "nas-port-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['sub_id', 'operator', 'value'], name, value)


                                                                            class ServiceName(Entity):
                                                                                """
                                                                                Service Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                    self.yang_name = "service-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "service-name"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                            class ServiceNameRegex(Entity):
                                                                                """
                                                                                Service Name Regular Exp
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                    self.yang_name = "service-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "service-name-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                            class SrcAddrIpv4(Entity):
                                                                                """
                                                                                Source Address IPV4
                                                                                
                                                                                .. attribute:: ipv4_addr_array
                                                                                
                                                                                	ipv4 addr array
                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.ipv4_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-ipv4"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                class Ipv4AddrArray(Entity):
                                                                                    """
                                                                                    ipv4 addr array
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	prefix
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	mask
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                        ])
                                                                                        self.prefix = None
                                                                                        self.mask = None
                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                            class DstAddrIpv4(Entity):
                                                                                """
                                                                                Destination Address IPV4
                                                                                
                                                                                .. attribute:: ipv4_addr_array
                                                                                
                                                                                	ipv4 addr array
                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.ipv4_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-addr-ipv4"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                class Ipv4AddrArray(Entity):
                                                                                    """
                                                                                    ipv4 addr array
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	prefix
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	mask
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                        ])
                                                                                        self.prefix = None
                                                                                        self.mask = None
                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                            class SrcAddrIpv6(Entity):
                                                                                """
                                                                                Source Address IPV6
                                                                                
                                                                                .. attribute:: ipv6_addr_array
                                                                                
                                                                                	ipv6 addr array
                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.ipv6_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-ipv6"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                class Ipv6AddrArray(Entity):
                                                                                    """
                                                                                    ipv6 addr array
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	IPV6 prefix
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	IPV6 mask
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                        ])
                                                                                        self.prefix = None
                                                                                        self.mask = None
                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                            class DstAddrIpv6(Entity):
                                                                                """
                                                                                Destination Address IPV6
                                                                                
                                                                                .. attribute:: ipv6_addr_array
                                                                                
                                                                                	ipv6 addr array
                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.ipv6_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-addr-ipv6"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                class Ipv6AddrArray(Entity):
                                                                                    """
                                                                                    ipv6 addr array
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	IPV6 prefix
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	IPV6 mask
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                        ])
                                                                                        self.prefix = None
                                                                                        self.mask = None
                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                            class SrcAddrMac(Entity):
                                                                                """
                                                                                Source Address MAC
                                                                                
                                                                                .. attribute:: mac_addr_array
                                                                                
                                                                                	mac addr array
                                                                                	**type**\: list of  		 :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                    self.yang_name = "src-addr-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("mac-addr-array", ("mac_addr_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.mac_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-mac"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                class MacAddrArray(Entity):
                                                                                    """
                                                                                    mac addr array
                                                                                    
                                                                                    .. attribute:: mac_addr
                                                                                    
                                                                                    	MAC address
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	MAC mask
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                        self.yang_name = "mac-addr-array"
                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                            ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                        ])
                                                                                        self.mac_addr = []
                                                                                        self.mask = []
                                                                                        self._segment_path = lambda: "mac-addr-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                            class Timer(Entity):
                                                                                """
                                                                                Timer
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                    self.yang_name = "timer"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "timer"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                            class TimerRegexp(Entity):
                                                                                """
                                                                                Timer Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                    self.yang_name = "timer-regexp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "timer-regexp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                            class TunnelName(Entity):
                                                                                """
                                                                                Tunnel Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                    self.yang_name = "tunnel-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "tunnel-name"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                            class TunnelNameRegex(Entity):
                                                                                """
                                                                                Tunnel Name Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "tunnel-name-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                            class UserName(Entity):
                                                                                """
                                                                                User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                    self.yang_name = "user-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "user-name"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                            class UserNameRegex(Entity):
                                                                                """
                                                                                User Name Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                    self.yang_name = "user-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "user-name-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                            class AuthUsername(Entity):
                                                                                """
                                                                                Authenticated User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                    self.yang_name = "auth-username"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "auth-username"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                            class AuthUsernameRegex(Entity):
                                                                                """
                                                                                Authenticated User Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                    self.yang_name = "auth-username-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "auth-username-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                            class UnauthUsername(Entity):
                                                                                """
                                                                                Unauthenticated User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                    self.yang_name = "unauth-username"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "unauth-username"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                            class UnauthUsernameRegex(Entity):
                                                                                """
                                                                                Unauthenticated User Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                    self.yang_name = "unauth-username-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "unauth-username-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                            class AuthDomain(Entity):
                                                                                """
                                                                                Authenticated domain name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                    self.yang_name = "auth-domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "auth-domain"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                            class AuthDomainRegex(Entity):
                                                                                """
                                                                                Authenticated Domain Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                    self.yang_name = "auth-domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "auth-domain-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                            class UnauthDomain(Entity):
                                                                                """
                                                                                Unauthenticated Domain Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                    self.yang_name = "unauth-domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "unauth-domain"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                            class UnauthDomainRegex(Entity):
                                                                                """
                                                                                Unauthenticated Domain Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "unauth-domain-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                            class VendorId(Entity):
                                                                                """
                                                                                Vendor ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                    self.yang_name = "vendor-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "vendor-id"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                            class VendorIdRegex(Entity):
                                                                                """
                                                                                Vendor ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                    self.yang_name = "vendor-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "vendor-id-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                            class AccessInterface(Entity):
                                                                                """
                                                                                Access interface
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                    self.yang_name = "access-interface"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "access-interface"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                            class InputInterface(Entity):
                                                                                """
                                                                                Input interface
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                    self.yang_name = "input-interface"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "input-interface"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                            class InputIntfhdl(Entity):
                                                                                """
                                                                                Input interface handle
                                                                                
                                                                                .. attribute:: uint64_array
                                                                                
                                                                                	uint64 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..18446744073709551615
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                    self.yang_name = "input-intfhdl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint64_array', (YLeafList(YType.uint64, 'uint64_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint64_array = []
                                                                                    self._segment_path = lambda: "input-intfhdl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                            class Ethertype(Entity):
                                                                                """
                                                                                Ethernet type
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                    self.yang_name = "ethertype"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ethertype"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ethertype"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class FlowKeyData(Entity):
                                                                                """
                                                                                Flow key structure
                                                                                
                                                                                .. attribute:: flow_keys
                                                                                
                                                                                	flow keys
                                                                                	**type**\:  :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                
                                                                                .. attribute:: max_count
                                                                                
                                                                                	Maximum count of flows
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: idle_timeout
                                                                                
                                                                                	Idle timeout of flows (in seconds)
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                	**units**\: second
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                    self.yang_name = "flow-key-data"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("flow-keys", ("flow_keys", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('max_count', (YLeaf(YType.uint16, 'max-count'), ['int'])),
                                                                                        ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                                    ])
                                                                                    self.max_count = None
                                                                                    self.idle_timeout = None

                                                                                    self.flow_keys = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                    self.flow_keys.parent = self
                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                    self._segment_path = lambda: "flow-key-data"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['max_count', 'idle_timeout'], name, value)


                                                                                class FlowKeys(Entity):
                                                                                    """
                                                                                    flow keys
                                                                                    
                                                                                    .. attribute:: keys
                                                                                    
                                                                                    	keys
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                    
                                                                                    .. attribute:: num
                                                                                    
                                                                                    	num
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                        self.yang_name = "flow-keys"
                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('keys', (YLeaf(YType.str, 'keys'), ['str'])),
                                                                                            ('num', (YLeaf(YType.uint8, 'num'), ['int'])),
                                                                                        ])
                                                                                        self.keys = None
                                                                                        self.num = None
                                                                                        self._segment_path = lambda: "flow-keys"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                            class DhcpClientId(Entity):
                                                                                """
                                                                                Dhcp Client ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                    self.yang_name = "dhcp-client-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "dhcp-client-id"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                            class DhcpClientIdRegex(Entity):
                                                                                """
                                                                                Dhcp Client ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                            class CircuitId(Entity):
                                                                                """
                                                                                Circuit ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                    self.yang_name = "circuit-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "circuit-id"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                            class CircuitIdRegex(Entity):
                                                                                """
                                                                                Circuit ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                    self.yang_name = "circuit-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "circuit-id-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                            class RemoteId(Entity):
                                                                                """
                                                                                Remote ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                    self.yang_name = "remote-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "remote-id"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                            class RemoteIdRegex(Entity):
                                                                                """
                                                                                Remote ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                    self.yang_name = "remote-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "remote-id-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                            class SrcPort(Entity):
                                                                                """
                                                                                Source port
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                    self.yang_name = "src-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "src-port"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "src-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class DstPort(Entity):
                                                                                """
                                                                                Destination port
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                    self.yang_name = "dst-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-port"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "dst-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['min', 'max'], name, value)


                                                        class ActInfop(Entity):
                                                            """
                                                            act infop
                                                            
                                                            .. attribute:: policy_action_info_st
                                                            
                                                            	policy action info st
                                                            	**type**\: list of  		 :py:class:`PolicyActionInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'infra-policymgr-oper'
                                                            _revision = '2018-01-17'

                                                            def __init__(self):
                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop, self).__init__()

                                                                self.yang_name = "act-infop"
                                                                self.yang_parent_name = "policy-class-info-bg"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("policy-action-info-st", ("policy_action_info_st", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt))])
                                                                self._leafs = OrderedDict()

                                                                self.policy_action_info_st = YList(self)
                                                                self._segment_path = lambda: "act-infop"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop, [], name, value)


                                                            class PolicyActionInfoSt(Entity):
                                                                """
                                                                policy action info st
                                                                
                                                                .. attribute:: actp
                                                                
                                                                	actp
                                                                	**type**\:  :py:class:`Actp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp>`
                                                                
                                                                .. attribute:: seq
                                                                
                                                                	seq
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..65535
                                                                
                                                                .. attribute:: flags
                                                                
                                                                	flags
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..65535
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt, self).__init__()

                                                                    self.yang_name = "policy-action-info-st"
                                                                    self.yang_parent_name = "act-infop"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("actp", ("actp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp))])
                                                                    self._leafs = OrderedDict([
                                                                        ('seq', (YLeaf(YType.uint16, 'seq'), ['int'])),
                                                                        ('flags', (YLeaf(YType.uint16, 'flags'), ['int'])),
                                                                    ])
                                                                    self.seq = None
                                                                    self.flags = None

                                                                    self.actp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp()
                                                                    self.actp.parent = self
                                                                    self._children_name_map["actp"] = "actp"
                                                                    self._segment_path = lambda: "policy-action-info-st"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt, ['seq', 'flags'], name, value)


                                                                class Actp(Entity):
                                                                    """
                                                                    actp
                                                                    
                                                                    .. attribute:: mark
                                                                    
                                                                    	mark
                                                                    	**type**\:  :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark>`
                                                                    
                                                                    .. attribute:: mark2
                                                                    
                                                                    	mark2
                                                                    	**type**\:  :py:class:`Mark2 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2>`
                                                                    
                                                                    .. attribute:: wred
                                                                    
                                                                    	wred
                                                                    	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred>`
                                                                    
                                                                    .. attribute:: encap
                                                                    
                                                                    	encap
                                                                    	**type**\:  :py:class:`Encap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap>`
                                                                    
                                                                    .. attribute:: prio
                                                                    
                                                                    	prio
                                                                    	**type**\:  :py:class:`Prio <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio>`
                                                                    
                                                                    .. attribute:: bwrem
                                                                    
                                                                    	bwrem
                                                                    	**type**\:  :py:class:`Bwrem <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem>`
                                                                    
                                                                    .. attribute:: min_bw
                                                                    
                                                                    	min bw
                                                                    	**type**\:  :py:class:`MinBw <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw>`
                                                                    
                                                                    .. attribute:: authen_aaa
                                                                    
                                                                    	authen aaa
                                                                    	**type**\:  :py:class:`AuthenAaa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa>`
                                                                    
                                                                    .. attribute:: collect_id
                                                                    
                                                                    	collect id
                                                                    	**type**\:  :py:class:`CollectId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId>`
                                                                    
                                                                    .. attribute:: decode_id
                                                                    
                                                                    	decode id
                                                                    	**type**\:  :py:class:`DecodeId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId>`
                                                                    
                                                                    .. attribute:: set_timer
                                                                    
                                                                    	set timer
                                                                    	**type**\:  :py:class:`SetTimer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer>`
                                                                    
                                                                    .. attribute:: stop_timer
                                                                    
                                                                    	stop timer
                                                                    	**type**\:  :py:class:`StopTimer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer>`
                                                                    
                                                                    .. attribute:: acct_aaa_list
                                                                    
                                                                    	acct aaa list
                                                                    	**type**\:  :py:class:`AcctAaaList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList>`
                                                                    
                                                                    .. attribute:: query_ancp
                                                                    
                                                                    	query ancp
                                                                    	**type**\:  :py:class:`QueryAncp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp>`
                                                                    
                                                                    .. attribute:: prepaid_cfg
                                                                    
                                                                    	prepaid cfg
                                                                    	**type**\:  :py:class:`PrepaidCfg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg>`
                                                                    
                                                                    .. attribute:: timeout_idle
                                                                    
                                                                    	timeout idle
                                                                    	**type**\:  :py:class:`TimeoutIdle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle>`
                                                                    
                                                                    .. attribute:: proxy_aaa
                                                                    
                                                                    	proxy aaa
                                                                    	**type**\:  :py:class:`ProxyAaa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa>`
                                                                    
                                                                    .. attribute:: act_template
                                                                    
                                                                    	act template
                                                                    	**type**\:  :py:class:`ActTemplate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate>`
                                                                    
                                                                    .. attribute:: deact_template
                                                                    
                                                                    	deact template
                                                                    	**type**\:  :py:class:`DeactTemplate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate>`
                                                                    
                                                                    .. attribute:: qlimit
                                                                    
                                                                    	qlimit
                                                                    	**type**\:  :py:class:`Qlimit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit>`
                                                                    
                                                                    .. attribute:: accounting_event_aaa
                                                                    
                                                                    	accounting event aaa
                                                                    	**type**\:  :py:class:`AccountingEventAaa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa>`
                                                                    
                                                                    .. attribute:: authorize_id
                                                                    
                                                                    	authorize id
                                                                    	**type**\:  :py:class:`AuthorizeId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId>`
                                                                    
                                                                    .. attribute:: afm_react
                                                                    
                                                                    	afm react
                                                                    	**type**\:  :py:class:`AfmReact <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact>`
                                                                    
                                                                    .. attribute:: httpr
                                                                    
                                                                    	httpr
                                                                    	**type**\:  :py:class:`Httpr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr>`
                                                                    
                                                                    .. attribute:: punt
                                                                    
                                                                    	punt
                                                                    	**type**\:  :py:class:`Punt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt>`
                                                                    
                                                                    .. attribute:: copy
                                                                    
                                                                    	copy
                                                                    	**type**\:  :py:class:`Copy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy>`
                                                                    
                                                                    .. attribute:: sfrag
                                                                    
                                                                    	sfrag
                                                                    	**type**\:  :py:class:`Sfrag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag>`
                                                                    
                                                                    .. attribute:: redirect
                                                                    
                                                                    	redirect
                                                                    	**type**\:  :py:class:`Redirect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect>`
                                                                    
                                                                    .. attribute:: out_intf
                                                                    
                                                                    	out intf
                                                                    	**type**\:  :py:class:`OutIntf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf>`
                                                                    
                                                                    .. attribute:: serv_func
                                                                    
                                                                    	serv func
                                                                    	**type**\:  :py:class:`ServFunc <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc>`
                                                                    
                                                                    .. attribute:: police
                                                                    
                                                                    	police
                                                                    	**type**\:  :py:class:`Police <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police>`
                                                                    
                                                                    .. attribute:: shape
                                                                    
                                                                    	shape
                                                                    	**type**\:  :py:class:`Shape <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape>`
                                                                    
                                                                    .. attribute:: child_policy
                                                                    
                                                                    	child policy
                                                                    	**type**\:  :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy>`
                                                                    
                                                                    .. attribute:: cac
                                                                    
                                                                    	cac
                                                                    	**type**\:  :py:class:`Cac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac>`
                                                                    
                                                                    .. attribute:: pfc
                                                                    
                                                                    	pfc
                                                                    	**type**\:  :py:class:`Pfc <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc>`
                                                                    
                                                                    .. attribute:: flow_parm
                                                                    
                                                                    	flow parm
                                                                    	**type**\:  :py:class:`FlowParm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm>`
                                                                    
                                                                    .. attribute:: ipcbr
                                                                    
                                                                    	ipcbr
                                                                    	**type**\:  :py:class:`Ipcbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr>`
                                                                    
                                                                    .. attribute:: rtp
                                                                    
                                                                    	rtp
                                                                    	**type**\:  :py:class:`Rtp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp>`
                                                                    
                                                                    .. attribute:: rtp_mmr
                                                                    
                                                                    	rtp mmr
                                                                    	**type**\:  :py:class:`RtpMmr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr>`
                                                                    
                                                                    .. attribute:: rtp_j2k
                                                                    
                                                                    	rtp j2k
                                                                    	**type**\:  :py:class:`RtpJ2k <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k>`
                                                                    
                                                                    .. attribute:: rtp_voice
                                                                    
                                                                    	rtp voice
                                                                    	**type**\:  :py:class:`RtpVoice <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice>`
                                                                    
                                                                    .. attribute:: mdi
                                                                    
                                                                    	mdi
                                                                    	**type**\:  :py:class:`Mdi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi>`
                                                                    
                                                                    .. attribute:: mdi_rtp
                                                                    
                                                                    	mdi rtp
                                                                    	**type**\:  :py:class:`MdiRtp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp>`
                                                                    
                                                                    .. attribute:: fmm
                                                                    
                                                                    	fmm
                                                                    	**type**\:  :py:class:`Fmm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm>`
                                                                    
                                                                    .. attribute:: pbf
                                                                    
                                                                    	pbf
                                                                    	**type**\:  :py:class:`Pbf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf>`
                                                                    
                                                                    .. attribute:: ipv4_nh
                                                                    
                                                                    	ipv4 nh
                                                                    	**type**\:  :py:class:`Ipv4Nh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh>`
                                                                    
                                                                    .. attribute:: ipv6_nh
                                                                    
                                                                    	ipv6 nh
                                                                    	**type**\:  :py:class:`Ipv6Nh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh>`
                                                                    
                                                                    .. attribute:: type
                                                                    
                                                                    	type
                                                                    	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                    
                                                                    .. attribute:: data_p
                                                                    
                                                                    	data p
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp, self).__init__()

                                                                        self.yang_name = "actp"
                                                                        self.yang_parent_name = "policy-action-info-st"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("mark", ("mark", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark)), ("mark2", ("mark2", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2)), ("wred", ("wred", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred)), ("encap", ("encap", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap)), ("prio", ("prio", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio)), ("bwrem", ("bwrem", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem)), ("min-bw", ("min_bw", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw)), ("authen-aaa", ("authen_aaa", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa)), ("collect-id", ("collect_id", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId)), ("decode-id", ("decode_id", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId)), ("set-timer", ("set_timer", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer)), ("stop-timer", ("stop_timer", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer)), ("acct-aaa-list", ("acct_aaa_list", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList)), ("query-ancp", ("query_ancp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp)), ("prepaid-cfg", ("prepaid_cfg", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg)), ("timeout-idle", ("timeout_idle", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle)), ("proxy-aaa", ("proxy_aaa", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa)), ("act-template", ("act_template", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate)), ("deact-template", ("deact_template", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate)), ("qlimit", ("qlimit", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit)), ("accounting-event-aaa", ("accounting_event_aaa", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa)), ("authorize-id", ("authorize_id", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId)), ("afm-react", ("afm_react", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact)), ("httpr", ("httpr", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr)), ("punt", ("punt", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt)), ("copy", ("copy", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy)), ("sfrag", ("sfrag", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag)), ("redirect", ("redirect", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect)), ("out-intf", ("out_intf", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf)), ("serv-func", ("serv_func", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc)), ("police", ("police", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police)), ("shape", ("shape", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape)), ("child-policy", ("child_policy", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy)), ("cac", ("cac", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac)), ("pfc", ("pfc", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc)), ("flow-parm", ("flow_parm", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm)), ("ipcbr", ("ipcbr", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr)), ("rtp", ("rtp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp)), ("rtp-mmr", ("rtp_mmr", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr)), ("rtp-j2k", ("rtp_j2k", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k)), ("rtp-voice", ("rtp_voice", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice)), ("mdi", ("mdi", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi)), ("mdi-rtp", ("mdi_rtp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp)), ("fmm", ("fmm", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm)), ("pbf", ("pbf", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf)), ("ipv4-nh", ("ipv4_nh", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh)), ("ipv6-nh", ("ipv6_nh", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh))])
                                                                        self._leafs = OrderedDict([
                                                                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                            ('data_p', (YLeaf(YType.uint32, 'data-p'), ['int'])),
                                                                        ])
                                                                        self.type = None
                                                                        self.data_p = None

                                                                        self.mark = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark()
                                                                        self.mark.parent = self
                                                                        self._children_name_map["mark"] = "mark"

                                                                        self.mark2 = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2()
                                                                        self.mark2.parent = self
                                                                        self._children_name_map["mark2"] = "mark2"

                                                                        self.wred = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred()
                                                                        self.wred.parent = self
                                                                        self._children_name_map["wred"] = "wred"

                                                                        self.encap = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap()
                                                                        self.encap.parent = self
                                                                        self._children_name_map["encap"] = "encap"

                                                                        self.prio = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio()
                                                                        self.prio.parent = self
                                                                        self._children_name_map["prio"] = "prio"

                                                                        self.bwrem = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem()
                                                                        self.bwrem.parent = self
                                                                        self._children_name_map["bwrem"] = "bwrem"

                                                                        self.min_bw = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw()
                                                                        self.min_bw.parent = self
                                                                        self._children_name_map["min_bw"] = "min-bw"

                                                                        self.authen_aaa = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa()
                                                                        self.authen_aaa.parent = self
                                                                        self._children_name_map["authen_aaa"] = "authen-aaa"

                                                                        self.collect_id = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId()
                                                                        self.collect_id.parent = self
                                                                        self._children_name_map["collect_id"] = "collect-id"

                                                                        self.decode_id = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId()
                                                                        self.decode_id.parent = self
                                                                        self._children_name_map["decode_id"] = "decode-id"

                                                                        self.set_timer = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer()
                                                                        self.set_timer.parent = self
                                                                        self._children_name_map["set_timer"] = "set-timer"

                                                                        self.stop_timer = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer()
                                                                        self.stop_timer.parent = self
                                                                        self._children_name_map["stop_timer"] = "stop-timer"

                                                                        self.acct_aaa_list = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList()
                                                                        self.acct_aaa_list.parent = self
                                                                        self._children_name_map["acct_aaa_list"] = "acct-aaa-list"

                                                                        self.query_ancp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp()
                                                                        self.query_ancp.parent = self
                                                                        self._children_name_map["query_ancp"] = "query-ancp"

                                                                        self.prepaid_cfg = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg()
                                                                        self.prepaid_cfg.parent = self
                                                                        self._children_name_map["prepaid_cfg"] = "prepaid-cfg"

                                                                        self.timeout_idle = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle()
                                                                        self.timeout_idle.parent = self
                                                                        self._children_name_map["timeout_idle"] = "timeout-idle"

                                                                        self.proxy_aaa = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa()
                                                                        self.proxy_aaa.parent = self
                                                                        self._children_name_map["proxy_aaa"] = "proxy-aaa"

                                                                        self.act_template = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate()
                                                                        self.act_template.parent = self
                                                                        self._children_name_map["act_template"] = "act-template"

                                                                        self.deact_template = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate()
                                                                        self.deact_template.parent = self
                                                                        self._children_name_map["deact_template"] = "deact-template"

                                                                        self.qlimit = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit()
                                                                        self.qlimit.parent = self
                                                                        self._children_name_map["qlimit"] = "qlimit"

                                                                        self.accounting_event_aaa = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa()
                                                                        self.accounting_event_aaa.parent = self
                                                                        self._children_name_map["accounting_event_aaa"] = "accounting-event-aaa"

                                                                        self.authorize_id = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId()
                                                                        self.authorize_id.parent = self
                                                                        self._children_name_map["authorize_id"] = "authorize-id"

                                                                        self.afm_react = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact()
                                                                        self.afm_react.parent = self
                                                                        self._children_name_map["afm_react"] = "afm-react"

                                                                        self.httpr = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr()
                                                                        self.httpr.parent = self
                                                                        self._children_name_map["httpr"] = "httpr"

                                                                        self.punt = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt()
                                                                        self.punt.parent = self
                                                                        self._children_name_map["punt"] = "punt"

                                                                        self.copy = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy()
                                                                        self.copy.parent = self
                                                                        self._children_name_map["copy"] = "copy"

                                                                        self.sfrag = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag()
                                                                        self.sfrag.parent = self
                                                                        self._children_name_map["sfrag"] = "sfrag"

                                                                        self.redirect = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect()
                                                                        self.redirect.parent = self
                                                                        self._children_name_map["redirect"] = "redirect"

                                                                        self.out_intf = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf()
                                                                        self.out_intf.parent = self
                                                                        self._children_name_map["out_intf"] = "out-intf"

                                                                        self.serv_func = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc()
                                                                        self.serv_func.parent = self
                                                                        self._children_name_map["serv_func"] = "serv-func"

                                                                        self.police = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police()
                                                                        self.police.parent = self
                                                                        self._children_name_map["police"] = "police"

                                                                        self.shape = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape()
                                                                        self.shape.parent = self
                                                                        self._children_name_map["shape"] = "shape"

                                                                        self.child_policy = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy()
                                                                        self.child_policy.parent = self
                                                                        self._children_name_map["child_policy"] = "child-policy"

                                                                        self.cac = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac()
                                                                        self.cac.parent = self
                                                                        self._children_name_map["cac"] = "cac"

                                                                        self.pfc = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc()
                                                                        self.pfc.parent = self
                                                                        self._children_name_map["pfc"] = "pfc"

                                                                        self.flow_parm = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm()
                                                                        self.flow_parm.parent = self
                                                                        self._children_name_map["flow_parm"] = "flow-parm"

                                                                        self.ipcbr = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr()
                                                                        self.ipcbr.parent = self
                                                                        self._children_name_map["ipcbr"] = "ipcbr"

                                                                        self.rtp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp()
                                                                        self.rtp.parent = self
                                                                        self._children_name_map["rtp"] = "rtp"

                                                                        self.rtp_mmr = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr()
                                                                        self.rtp_mmr.parent = self
                                                                        self._children_name_map["rtp_mmr"] = "rtp-mmr"

                                                                        self.rtp_j2k = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k()
                                                                        self.rtp_j2k.parent = self
                                                                        self._children_name_map["rtp_j2k"] = "rtp-j2k"

                                                                        self.rtp_voice = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice()
                                                                        self.rtp_voice.parent = self
                                                                        self._children_name_map["rtp_voice"] = "rtp-voice"

                                                                        self.mdi = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi()
                                                                        self.mdi.parent = self
                                                                        self._children_name_map["mdi"] = "mdi"

                                                                        self.mdi_rtp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp()
                                                                        self.mdi_rtp.parent = self
                                                                        self._children_name_map["mdi_rtp"] = "mdi-rtp"

                                                                        self.fmm = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm()
                                                                        self.fmm.parent = self
                                                                        self._children_name_map["fmm"] = "fmm"

                                                                        self.pbf = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf()
                                                                        self.pbf.parent = self
                                                                        self._children_name_map["pbf"] = "pbf"

                                                                        self.ipv4_nh = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh()
                                                                        self.ipv4_nh.parent = self
                                                                        self._children_name_map["ipv4_nh"] = "ipv4-nh"

                                                                        self.ipv6_nh = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh()
                                                                        self.ipv6_nh.parent = self
                                                                        self._children_name_map["ipv6_nh"] = "ipv6-nh"
                                                                        self._segment_path = lambda: "actp"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp, ['type', 'data_p'], name, value)


                                                                    class Mark(Entity):
                                                                        """
                                                                        mark
                                                                        
                                                                        .. attribute:: action_mark_info
                                                                        
                                                                        	action mark info
                                                                        	**type**\: list of  		 :py:class:`ActionMarkInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark, self).__init__()

                                                                            self.yang_name = "mark"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("action-mark-info", ("action_mark_info", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo))])
                                                                            self._leafs = OrderedDict()

                                                                            self.action_mark_info = YList(self)
                                                                            self._segment_path = lambda: "mark"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark, [], name, value)


                                                                        class ActionMarkInfo(Entity):
                                                                            """
                                                                            action mark info
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:  :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                            
                                                                            .. attribute:: mark_flags
                                                                            
                                                                            	mark flags
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo, self).__init__()

                                                                                self.yang_name = "action-mark-info"
                                                                                self.yang_parent_name = "mark"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MarkTypeEn', '')])),
                                                                                    ('mark_flags', (YLeaf(YType.uint32, 'mark-flags'), ['int'])),
                                                                                    ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                ])
                                                                                self.type = None
                                                                                self.mark_flags = None
                                                                                self.value = None
                                                                                self._segment_path = lambda: "action-mark-info"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo, ['type', 'mark_flags', 'value'], name, value)


                                                                    class Mark2(Entity):
                                                                        """
                                                                        mark2
                                                                        
                                                                        .. attribute:: action_mark2_info
                                                                        
                                                                        	action mark2 info
                                                                        	**type**\: list of  		 :py:class:`ActionMark2Info <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2, self).__init__()

                                                                            self.yang_name = "mark2"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("action-mark2-info", ("action_mark2_info", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info))])
                                                                            self._leafs = OrderedDict()

                                                                            self.action_mark2_info = YList(self)
                                                                            self._segment_path = lambda: "mark2"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2, [], name, value)


                                                                        class ActionMark2Info(Entity):
                                                                            """
                                                                            action mark2 info
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: value_overflow
                                                                            
                                                                            	value overflow
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: mark_flags
                                                                            
                                                                            	mark flags
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info, self).__init__()

                                                                                self.yang_name = "action-mark2-info"
                                                                                self.yang_parent_name = "mark2"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('value_overflow', (YLeaf(YType.uint16, 'value-overflow'), ['int'])),
                                                                                    ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                    ('mark_flags', (YLeaf(YType.uint8, 'mark-flags'), ['int'])),
                                                                                ])
                                                                                self.value = None
                                                                                self.value_overflow = None
                                                                                self.type = None
                                                                                self.mark_flags = None
                                                                                self._segment_path = lambda: "action-mark2-info"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info, ['value', 'value_overflow', 'type', 'mark_flags'], name, value)


                                                                    class Wred(Entity):
                                                                        """
                                                                        wred
                                                                        
                                                                        .. attribute:: action_wred_info
                                                                        
                                                                        	action wred info
                                                                        	**type**\: list of  		 :py:class:`ActionWredInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred, self).__init__()

                                                                            self.yang_name = "wred"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("action-wred-info", ("action_wred_info", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo))])
                                                                            self._leafs = OrderedDict()

                                                                            self.action_wred_info = YList(self)
                                                                            self._segment_path = lambda: "wred"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred, [], name, value)


                                                                        class ActionWredInfo(Entity):
                                                                            """
                                                                            action wred info
                                                                            
                                                                            .. attribute:: match_ranges
                                                                            
                                                                            	match ranges
                                                                            	**type**\:  :py:class:`MatchRanges <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges>`
                                                                            
                                                                            .. attribute:: min_threshold
                                                                            
                                                                            	min threshold
                                                                            	**type**\:  :py:class:`MinThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold>`
                                                                            
                                                                            .. attribute:: max_threshold
                                                                            
                                                                            	max threshold
                                                                            	**type**\:  :py:class:`MaxThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold>`
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	cos/prec/dscp/ based WRED
                                                                            	**type**\:  :py:class:`WredTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.WredTypeEn>`
                                                                            
                                                                            .. attribute:: wred_flags
                                                                            
                                                                            	wred flags
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: probability
                                                                            
                                                                            	probability
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo, self).__init__()

                                                                                self.yang_name = "action-wred-info"
                                                                                self.yang_parent_name = "wred"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("match-ranges", ("match_ranges", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges)), ("min-threshold", ("min_threshold", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold)), ("max-threshold", ("max_threshold", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'WredTypeEn', '')])),
                                                                                    ('wred_flags', (YLeaf(YType.uint32, 'wred-flags'), ['int'])),
                                                                                    ('probability', (YLeaf(YType.uint32, 'probability'), ['int'])),
                                                                                ])
                                                                                self.type = None
                                                                                self.wred_flags = None
                                                                                self.probability = None

                                                                                self.match_ranges = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges()
                                                                                self.match_ranges.parent = self
                                                                                self._children_name_map["match_ranges"] = "match-ranges"

                                                                                self.min_threshold = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold()
                                                                                self.min_threshold.parent = self
                                                                                self._children_name_map["min_threshold"] = "min-threshold"

                                                                                self.max_threshold = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold()
                                                                                self.max_threshold.parent = self
                                                                                self._children_name_map["max_threshold"] = "max-threshold"
                                                                                self._segment_path = lambda: "action-wred-info"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo, ['type', 'wred_flags', 'probability'], name, value)


                                                                            class MatchRanges(Entity):
                                                                                """
                                                                                match ranges
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges, self).__init__()

                                                                                    self.yang_name = "match-ranges"
                                                                                    self.yang_parent_name = "action-wred-info"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "match-ranges"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "match-ranges"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class MinThreshold(Entity):
                                                                                """
                                                                                min threshold
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold, self).__init__()

                                                                                    self.yang_name = "min-threshold"
                                                                                    self.yang_parent_name = "action-wred-info"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.unit = None
                                                                                    self._segment_path = lambda: "min-threshold"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold, ['value', 'unit'], name, value)


                                                                            class MaxThreshold(Entity):
                                                                                """
                                                                                max threshold
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold, self).__init__()

                                                                                    self.yang_name = "max-threshold"
                                                                                    self.yang_parent_name = "action-wred-info"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.unit = None
                                                                                    self._segment_path = lambda: "max-threshold"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold, ['value', 'unit'], name, value)


                                                                    class Encap(Entity):
                                                                        """
                                                                        encap
                                                                        
                                                                        .. attribute:: seq
                                                                        
                                                                        	seq
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap, self).__init__()

                                                                            self.yang_name = "encap"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('seq', (YLeaf(YType.uint8, 'seq'), ['int'])),
                                                                            ])
                                                                            self.seq = None
                                                                            self._segment_path = lambda: "encap"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap, ['seq'], name, value)


                                                                    class Prio(Entity):
                                                                        """
                                                                        prio
                                                                        
                                                                        .. attribute:: prio_lvl
                                                                        
                                                                        	prio lvl
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio, self).__init__()

                                                                            self.yang_name = "prio"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('prio_lvl', (YLeaf(YType.uint32, 'prio-lvl'), ['int'])),
                                                                            ])
                                                                            self.prio_lvl = None
                                                                            self._segment_path = lambda: "prio"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio, ['prio_lvl'], name, value)


                                                                    class Bwrem(Entity):
                                                                        """
                                                                        bwrem
                                                                        
                                                                        .. attribute:: bwrem
                                                                        
                                                                        	bwrem
                                                                        	**type**\:  :py:class:`Bwrem_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem_>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem, self).__init__()

                                                                            self.yang_name = "bwrem"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("bwrem", ("bwrem", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem_))])
                                                                            self._leafs = OrderedDict()

                                                                            self.bwrem = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem_()
                                                                            self.bwrem.parent = self
                                                                            self._children_name_map["bwrem"] = "bwrem"
                                                                            self._segment_path = lambda: "bwrem"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem, [], name, value)


                                                                        class Bwrem_(Entity):
                                                                            """
                                                                            bwrem
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem_, self).__init__()

                                                                                self.yang_name = "bwrem"
                                                                                self.yang_parent_name = "bwrem"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "bwrem"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem_, ['value', 'unit'], name, value)


                                                                    class MinBw(Entity):
                                                                        """
                                                                        min bw
                                                                        
                                                                        .. attribute:: bw
                                                                        
                                                                        	bw
                                                                        	**type**\:  :py:class:`Bw <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw, self).__init__()

                                                                            self.yang_name = "min-bw"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("bw", ("bw", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw))])
                                                                            self._leafs = OrderedDict()

                                                                            self.bw = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw()
                                                                            self.bw.parent = self
                                                                            self._children_name_map["bw"] = "bw"
                                                                            self._segment_path = lambda: "min-bw"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw, [], name, value)


                                                                        class Bw(Entity):
                                                                            """
                                                                            bw
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw, self).__init__()

                                                                                self.yang_name = "bw"
                                                                                self.yang_parent_name = "min-bw"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "bw"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw, ['value', 'unit'], name, value)


                                                                    class AuthenAaa(Entity):
                                                                        """
                                                                        authen aaa
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: authen_password
                                                                        
                                                                        	authen password
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa, self).__init__()

                                                                            self.yang_name = "authen-aaa"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                                ('authen_password', (YLeaf(YType.str, 'authen-password'), ['str'])),
                                                                            ])
                                                                            self.aaa_list_name = None
                                                                            self.authen_password = None
                                                                            self._segment_path = lambda: "authen-aaa"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa, ['aaa_list_name', 'authen_password'], name, value)


                                                                    class CollectId(Entity):
                                                                        """
                                                                        collect id
                                                                        
                                                                        .. attribute:: id
                                                                        
                                                                        	id
                                                                        	**type**\:  :py:class:`IdentifierEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.IdentifierEn>`
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId, self).__init__()

                                                                            self.yang_name = "collect-id"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('id', (YLeaf(YType.enumeration, 'id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'IdentifierEn', '')])),
                                                                                ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                            ])
                                                                            self.id = None
                                                                            self.aaa_list_name = None
                                                                            self._segment_path = lambda: "collect-id"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId, ['id', 'aaa_list_name'], name, value)


                                                                    class DecodeId(Entity):
                                                                        """
                                                                        decode id
                                                                        
                                                                        .. attribute:: id
                                                                        
                                                                        	id
                                                                        	**type**\:  :py:class:`DecodeIdentifierEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.DecodeIdentifierEn>`
                                                                        
                                                                        .. attribute:: format_name
                                                                        
                                                                        	format name
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId, self).__init__()

                                                                            self.yang_name = "decode-id"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('id', (YLeaf(YType.enumeration, 'id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'DecodeIdentifierEn', '')])),
                                                                                ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                            ])
                                                                            self.id = None
                                                                            self.format_name = None
                                                                            self._segment_path = lambda: "decode-id"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId, ['id', 'format_name'], name, value)


                                                                    class SetTimer(Entity):
                                                                        """
                                                                        set timer
                                                                        
                                                                        .. attribute:: timer_name
                                                                        
                                                                        	timer name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: duration
                                                                        
                                                                        	duration
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: absolute_time
                                                                        
                                                                        	absolute time
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer, self).__init__()

                                                                            self.yang_name = "set-timer"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('timer_name', (YLeaf(YType.str, 'timer-name'), ['str'])),
                                                                                ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                                                ('absolute_time', (YLeaf(YType.str, 'absolute-time'), ['str'])),
                                                                            ])
                                                                            self.timer_name = None
                                                                            self.duration = None
                                                                            self.absolute_time = None
                                                                            self._segment_path = lambda: "set-timer"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer, ['timer_name', 'duration', 'absolute_time'], name, value)


                                                                    class StopTimer(Entity):
                                                                        """
                                                                        stop timer
                                                                        
                                                                        .. attribute:: timer_name
                                                                        
                                                                        	timer name
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer, self).__init__()

                                                                            self.yang_name = "stop-timer"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('timer_name', (YLeaf(YType.str, 'timer-name'), ['str'])),
                                                                            ])
                                                                            self.timer_name = None
                                                                            self._segment_path = lambda: "stop-timer"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer, ['timer_name'], name, value)


                                                                    class AcctAaaList(Entity):
                                                                        """
                                                                        acct aaa list
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: secs
                                                                        
                                                                        	secs
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList, self).__init__()

                                                                            self.yang_name = "acct-aaa-list"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                                ('secs', (YLeaf(YType.uint32, 'secs'), ['int'])),
                                                                            ])
                                                                            self.aaa_list_name = None
                                                                            self.secs = None
                                                                            self._segment_path = lambda: "acct-aaa-list"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList, ['aaa_list_name', 'secs'], name, value)


                                                                    class QueryAncp(Entity):
                                                                        """
                                                                        query ancp
                                                                        
                                                                        .. attribute:: enable
                                                                        
                                                                        	enable
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp, self).__init__()

                                                                            self.yang_name = "query-ancp"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('enable', (YLeaf(YType.uint8, 'enable'), ['int'])),
                                                                            ])
                                                                            self.enable = None
                                                                            self._segment_path = lambda: "query-ancp"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp, ['enable'], name, value)


                                                                    class PrepaidCfg(Entity):
                                                                        """
                                                                        prepaid cfg
                                                                        
                                                                        .. attribute:: prepaid_config_profile_name
                                                                        
                                                                        	prepaid config profile name
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg, self).__init__()

                                                                            self.yang_name = "prepaid-cfg"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('prepaid_config_profile_name', (YLeaf(YType.str, 'prepaid-config-profile-name'), ['str'])),
                                                                            ])
                                                                            self.prepaid_config_profile_name = None
                                                                            self._segment_path = lambda: "prepaid-cfg"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg, ['prepaid_config_profile_name'], name, value)


                                                                    class TimeoutIdle(Entity):
                                                                        """
                                                                        timeout idle
                                                                        
                                                                        .. attribute:: secs
                                                                        
                                                                        	secs
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle, self).__init__()

                                                                            self.yang_name = "timeout-idle"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('secs', (YLeaf(YType.uint32, 'secs'), ['int'])),
                                                                            ])
                                                                            self.secs = None
                                                                            self._segment_path = lambda: "timeout-idle"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle, ['secs'], name, value)


                                                                    class ProxyAaa(Entity):
                                                                        """
                                                                        proxy aaa
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa, self).__init__()

                                                                            self.yang_name = "proxy-aaa"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                            ])
                                                                            self.aaa_list_name = None
                                                                            self._segment_path = lambda: "proxy-aaa"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa, ['aaa_list_name'], name, value)


                                                                    class ActTemplate(Entity):
                                                                        """
                                                                        act template
                                                                        
                                                                        .. attribute:: template_name
                                                                        
                                                                        	template name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: flags
                                                                        
                                                                        	flags
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate, self).__init__()

                                                                            self.yang_name = "act-template"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('template_name', (YLeaf(YType.str, 'template-name'), ['str'])),
                                                                                ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                                ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                            ])
                                                                            self.template_name = None
                                                                            self.aaa_list_name = None
                                                                            self.flags = None
                                                                            self._segment_path = lambda: "act-template"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate, ['template_name', 'aaa_list_name', 'flags'], name, value)


                                                                    class DeactTemplate(Entity):
                                                                        """
                                                                        deact template
                                                                        
                                                                        .. attribute:: template_name
                                                                        
                                                                        	template name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: flags
                                                                        
                                                                        	flags
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate, self).__init__()

                                                                            self.yang_name = "deact-template"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('template_name', (YLeaf(YType.str, 'template-name'), ['str'])),
                                                                                ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                                ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                            ])
                                                                            self.template_name = None
                                                                            self.aaa_list_name = None
                                                                            self.flags = None
                                                                            self._segment_path = lambda: "deact-template"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate, ['template_name', 'aaa_list_name', 'flags'], name, value)


                                                                    class Qlimit(Entity):
                                                                        """
                                                                        qlimit
                                                                        
                                                                        .. attribute:: action_qlimit_info_array
                                                                        
                                                                        	action qlimit info array
                                                                        	**type**\: list of  		 :py:class:`ActionQlimitInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit, self).__init__()

                                                                            self.yang_name = "qlimit"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("action-qlimit-info-array", ("action_qlimit_info_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.action_qlimit_info_array = YList(self)
                                                                            self._segment_path = lambda: "qlimit"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit, [], name, value)


                                                                        class ActionQlimitInfoArray(Entity):
                                                                            """
                                                                            action qlimit info array
                                                                            
                                                                            .. attribute:: qlim
                                                                            
                                                                            	qlim
                                                                            	**type**\:  :py:class:`Qlim <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim>`
                                                                            
                                                                            .. attribute:: atmclp_qlim
                                                                            
                                                                            	atmclp qlim
                                                                            	**type**\:  :py:class:`AtmclpQlim <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim>`
                                                                            
                                                                            .. attribute:: match_values
                                                                            
                                                                            	match values
                                                                            	**type**\:  :py:class:`MatchValues <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues>`
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:  :py:class:`QlimitTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.QlimitTypeEn>`
                                                                            
                                                                            .. attribute:: qlimit_flags
                                                                            
                                                                            	qlimit flags
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray, self).__init__()

                                                                                self.yang_name = "action-qlimit-info-array"
                                                                                self.yang_parent_name = "qlimit"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("qlim", ("qlim", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim)), ("atmclp-qlim", ("atmclp_qlim", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim)), ("match-values", ("match_values", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'QlimitTypeEn', '')])),
                                                                                    ('qlimit_flags', (YLeaf(YType.uint32, 'qlimit-flags'), ['int'])),
                                                                                ])
                                                                                self.type = None
                                                                                self.qlimit_flags = None

                                                                                self.qlim = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim()
                                                                                self.qlim.parent = self
                                                                                self._children_name_map["qlim"] = "qlim"

                                                                                self.atmclp_qlim = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim()
                                                                                self.atmclp_qlim.parent = self
                                                                                self._children_name_map["atmclp_qlim"] = "atmclp-qlim"

                                                                                self.match_values = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues()
                                                                                self.match_values.parent = self
                                                                                self._children_name_map["match_values"] = "match-values"
                                                                                self._segment_path = lambda: "action-qlimit-info-array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray, ['type', 'qlimit_flags'], name, value)


                                                                            class Qlim(Entity):
                                                                                """
                                                                                qlim
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim, self).__init__()

                                                                                    self.yang_name = "qlim"
                                                                                    self.yang_parent_name = "action-qlimit-info-array"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.unit = None
                                                                                    self._segment_path = lambda: "qlim"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim, ['value', 'unit'], name, value)


                                                                            class AtmclpQlim(Entity):
                                                                                """
                                                                                atmclp qlim
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim, self).__init__()

                                                                                    self.yang_name = "atmclp-qlim"
                                                                                    self.yang_parent_name = "action-qlimit-info-array"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.unit = None
                                                                                    self._segment_path = lambda: "atmclp-qlim"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim, ['value', 'unit'], name, value)


                                                                            class MatchValues(Entity):
                                                                                """
                                                                                match values
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues, self).__init__()

                                                                                    self.yang_name = "match-values"
                                                                                    self.yang_parent_name = "action-qlimit-info-array"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "match-values"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "match-values"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray, ['min', 'max'], name, value)


                                                                    class AccountingEventAaa(Entity):
                                                                        """
                                                                        accounting event aaa
                                                                        
                                                                        .. attribute:: action
                                                                        
                                                                        	action
                                                                        	**type**\:  :py:class:`AcctEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.AcctEn>`
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa, self).__init__()

                                                                            self.yang_name = "accounting-event-aaa"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('action', (YLeaf(YType.enumeration, 'action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'AcctEn', '')])),
                                                                                ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                            ])
                                                                            self.action = None
                                                                            self.aaa_list_name = None
                                                                            self._segment_path = lambda: "accounting-event-aaa"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa, ['action', 'aaa_list_name'], name, value)


                                                                    class AuthorizeId(Entity):
                                                                        """
                                                                        authorize id
                                                                        
                                                                        .. attribute:: id
                                                                        
                                                                        	id
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: format_name
                                                                        
                                                                        	format name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: password
                                                                        
                                                                        	password
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId, self).__init__()

                                                                            self.yang_name = "authorize-id"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('id', (YLeaf(YType.uint8, 'id'), ['int'])),
                                                                                ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                                ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                ('password', (YLeaf(YType.str, 'password'), ['str'])),
                                                                            ])
                                                                            self.id = None
                                                                            self.aaa_list_name = None
                                                                            self.format_name = None
                                                                            self.password = None
                                                                            self._segment_path = lambda: "authorize-id"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId, ['id', 'aaa_list_name', 'format_name', 'password'], name, value)


                                                                    class AfmReact(Entity):
                                                                        """
                                                                        afm react
                                                                        
                                                                        .. attribute:: action_afmon_react_info
                                                                        
                                                                        	action afmon react info
                                                                        	**type**\: list of  		 :py:class:`ActionAfmonReactInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact, self).__init__()

                                                                            self.yang_name = "afm-react"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("action-afmon-react-info", ("action_afmon_react_info", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo))])
                                                                            self._leafs = OrderedDict()

                                                                            self.action_afmon_react_info = YList(self)
                                                                            self._segment_path = lambda: "afm-react"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact, [], name, value)


                                                                        class ActionAfmonReactInfo(Entity):
                                                                            """
                                                                            action afmon react info
                                                                            
                                                                            .. attribute:: oper_id
                                                                            
                                                                            	React Operation ID
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: description
                                                                            
                                                                            	Describing the oper
                                                                            	**type**\: str
                                                                            
                                                                            .. attribute:: trig_num_intvls
                                                                            
                                                                            	Averaged over N intvls
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: clone_ifh
                                                                            
                                                                            	Clone interface handle
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: notif_actns
                                                                            
                                                                            	Bitmap of actions on alert
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: criterion
                                                                            
                                                                            	React Criterion
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: trig_type
                                                                            
                                                                            	Immediate or averaged thresh trigger
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: trig_relop
                                                                            
                                                                            	Trigger LT\|LE\|GT\|GE\|Range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: trig_level_1
                                                                            
                                                                            	Trigger threshold 1/lower
                                                                            	**type**\: str
                                                                            
                                                                            .. attribute:: trig_level_2
                                                                            
                                                                            	Trigger upper threshold for range
                                                                            	**type**\: str
                                                                            
                                                                            .. attribute:: alm_grp_thresh
                                                                            
                                                                            	Num/percent in grp
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            	**units**\: percentage
                                                                            
                                                                            .. attribute:: alm_type
                                                                            
                                                                            	Discrete \| grouped alarm
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: alm_severity
                                                                            
                                                                            	Major\|Minor\|... alarm
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo, self).__init__()

                                                                                self.yang_name = "action-afmon-react-info"
                                                                                self.yang_parent_name = "afm-react"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('oper_id', (YLeaf(YType.uint32, 'oper-id'), ['int'])),
                                                                                    ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                    ('trig_num_intvls', (YLeaf(YType.uint32, 'trig-num-intvls'), ['int'])),
                                                                                    ('clone_ifh', (YLeaf(YType.uint32, 'clone-ifh'), ['int'])),
                                                                                    ('notif_actns', (YLeaf(YType.uint8, 'notif-actns'), ['int'])),
                                                                                    ('criterion', (YLeaf(YType.uint8, 'criterion'), ['int'])),
                                                                                    ('trig_type', (YLeaf(YType.uint8, 'trig-type'), ['int'])),
                                                                                    ('trig_relop', (YLeaf(YType.uint8, 'trig-relop'), ['int'])),
                                                                                    ('trig_level_1', (YLeaf(YType.str, 'trig-level-1'), ['str'])),
                                                                                    ('trig_level_2', (YLeaf(YType.str, 'trig-level-2'), ['str'])),
                                                                                    ('alm_grp_thresh', (YLeaf(YType.uint16, 'alm-grp-thresh'), ['int'])),
                                                                                    ('alm_type', (YLeaf(YType.uint8, 'alm-type'), ['int'])),
                                                                                    ('alm_severity', (YLeaf(YType.uint8, 'alm-severity'), ['int'])),
                                                                                ])
                                                                                self.oper_id = None
                                                                                self.description = None
                                                                                self.trig_num_intvls = None
                                                                                self.clone_ifh = None
                                                                                self.notif_actns = None
                                                                                self.criterion = None
                                                                                self.trig_type = None
                                                                                self.trig_relop = None
                                                                                self.trig_level_1 = None
                                                                                self.trig_level_2 = None
                                                                                self.alm_grp_thresh = None
                                                                                self.alm_type = None
                                                                                self.alm_severity = None
                                                                                self._segment_path = lambda: "action-afmon-react-info"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo, ['oper_id', 'description', 'trig_num_intvls', 'clone_ifh', 'notif_actns', 'criterion', 'trig_type', 'trig_relop', 'trig_level_1', 'trig_level_2', 'alm_grp_thresh', 'alm_type', 'alm_severity'], name, value)


                                                                    class Httpr(Entity):
                                                                        """
                                                                        httpr
                                                                        
                                                                        .. attribute:: redirect_url
                                                                        
                                                                        	redirect url
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr, self).__init__()

                                                                            self.yang_name = "httpr"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('redirect_url', (YLeaf(YType.str, 'redirect-url'), ['str'])),
                                                                            ])
                                                                            self.redirect_url = None
                                                                            self._segment_path = lambda: "httpr"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr, ['redirect_url'], name, value)


                                                                    class Punt(Entity):
                                                                        """
                                                                        punt
                                                                        
                                                                        .. attribute:: sn_type
                                                                        
                                                                        	service node ID type
                                                                        	**type**\:  :py:class:`DpssSnidTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.DpssSnidTypeEn>`
                                                                        
                                                                        .. attribute:: sn_index
                                                                        
                                                                        	service node index
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: sn_name
                                                                        
                                                                        	service node name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: app_id
                                                                        
                                                                        	application ID
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: local_id
                                                                        
                                                                        	local ID
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: vsnode_type
                                                                        
                                                                        	vservice node type
                                                                        	**type**\:  :py:class:`VsvcServiceTypeT <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.VsvcServiceTypeT>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt, self).__init__()

                                                                            self.yang_name = "punt"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('sn_type', (YLeaf(YType.enumeration, 'sn-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'DpssSnidTypeEn', '')])),
                                                                                ('sn_index', (YLeaf(YType.uint32, 'sn-index'), ['int'])),
                                                                                ('sn_name', (YLeaf(YType.str, 'sn-name'), ['str'])),
                                                                                ('app_id', (YLeaf(YType.uint32, 'app-id'), ['int'])),
                                                                                ('local_id', (YLeaf(YType.uint32, 'local-id'), ['int'])),
                                                                                ('vsnode_type', (YLeaf(YType.enumeration, 'vsnode-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'VsvcServiceTypeT', '')])),
                                                                            ])
                                                                            self.sn_type = None
                                                                            self.sn_index = None
                                                                            self.sn_name = None
                                                                            self.app_id = None
                                                                            self.local_id = None
                                                                            self.vsnode_type = None
                                                                            self._segment_path = lambda: "punt"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt, ['sn_type', 'sn_index', 'sn_name', 'app_id', 'local_id', 'vsnode_type'], name, value)


                                                                    class Copy(Entity):
                                                                        """
                                                                        copy
                                                                        
                                                                        .. attribute:: num_byte
                                                                        
                                                                        	number of bytes
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: sn_type
                                                                        
                                                                        	service node ID type
                                                                        	**type**\:  :py:class:`DpssSnidTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.DpssSnidTypeEn>`
                                                                        
                                                                        .. attribute:: sn_index
                                                                        
                                                                        	service node index
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: sn_name
                                                                        
                                                                        	service node url
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: app_id
                                                                        
                                                                        	application ID
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: local_id
                                                                        
                                                                        	local ID
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: vsnode_type
                                                                        
                                                                        	vservice node type
                                                                        	**type**\:  :py:class:`VsvcServiceTypeT <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.VsvcServiceTypeT>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy, self).__init__()

                                                                            self.yang_name = "copy"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('num_byte', (YLeaf(YType.uint32, 'num-byte'), ['int'])),
                                                                                ('sn_type', (YLeaf(YType.enumeration, 'sn-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'DpssSnidTypeEn', '')])),
                                                                                ('sn_index', (YLeaf(YType.uint32, 'sn-index'), ['int'])),
                                                                                ('sn_name', (YLeaf(YType.str, 'sn-name'), ['str'])),
                                                                                ('app_id', (YLeaf(YType.uint32, 'app-id'), ['int'])),
                                                                                ('local_id', (YLeaf(YType.uint32, 'local-id'), ['int'])),
                                                                                ('vsnode_type', (YLeaf(YType.enumeration, 'vsnode-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'VsvcServiceTypeT', '')])),
                                                                            ])
                                                                            self.num_byte = None
                                                                            self.sn_type = None
                                                                            self.sn_index = None
                                                                            self.sn_name = None
                                                                            self.app_id = None
                                                                            self.local_id = None
                                                                            self.vsnode_type = None
                                                                            self._segment_path = lambda: "copy"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy, ['num_byte', 'sn_type', 'sn_index', 'sn_name', 'app_id', 'local_id', 'vsnode_type'], name, value)


                                                                    class Sfrag(Entity):
                                                                        """
                                                                        sfrag
                                                                        
                                                                        .. attribute:: name
                                                                        
                                                                        	Service Fragment Name
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag, self).__init__()

                                                                            self.yang_name = "sfrag"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                            ])
                                                                            self.name = None
                                                                            self._segment_path = lambda: "sfrag"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag, ['name'], name, value)


                                                                    class Redirect(Entity):
                                                                        """
                                                                        redirect
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: type
                                                                        
                                                                        	type
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect, self).__init__()

                                                                            self.yang_name = "redirect"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                            ])
                                                                            self.value = None
                                                                            self.type = None
                                                                            self._segment_path = lambda: "redirect"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect, ['value', 'type'], name, value)


                                                                    class OutIntf(Entity):
                                                                        """
                                                                        out intf
                                                                        
                                                                        .. attribute:: out_ifname
                                                                        
                                                                        	output interface name
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf, self).__init__()

                                                                            self.yang_name = "out-intf"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('out_ifname', (YLeaf(YType.str, 'out-ifname'), ['str'])),
                                                                            ])
                                                                            self.out_ifname = None
                                                                            self._segment_path = lambda: "out-intf"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf, ['out_ifname'], name, value)


                                                                    class ServFunc(Entity):
                                                                        """
                                                                        serv func
                                                                        
                                                                        .. attribute:: path_id
                                                                        
                                                                        	service path id
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: service_index
                                                                        
                                                                        	service path index
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: meta_name
                                                                        
                                                                        	metadata name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: vs_index
                                                                        
                                                                        	vservice index
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc, self).__init__()

                                                                            self.yang_name = "serv-func"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('path_id', (YLeaf(YType.uint32, 'path-id'), ['int'])),
                                                                                ('service_index', (YLeaf(YType.uint8, 'service-index'), ['int'])),
                                                                                ('meta_name', (YLeaf(YType.str, 'meta-name'), ['str'])),
                                                                                ('vs_index', (YLeaf(YType.uint32, 'vs-index'), ['int'])),
                                                                            ])
                                                                            self.path_id = None
                                                                            self.service_index = None
                                                                            self.meta_name = None
                                                                            self.vs_index = None
                                                                            self._segment_path = lambda: "serv-func"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc, ['path_id', 'service_index', 'meta_name', 'vs_index'], name, value)


                                                                    class Police(Entity):
                                                                        """
                                                                        police
                                                                        
                                                                        .. attribute:: rate
                                                                        
                                                                        	rate
                                                                        	**type**\:  :py:class:`Rate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate>`
                                                                        
                                                                        .. attribute:: burst
                                                                        
                                                                        	burst
                                                                        	**type**\:  :py:class:`Burst <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst>`
                                                                        
                                                                        .. attribute:: peak_rate
                                                                        
                                                                        	peak rate
                                                                        	**type**\:  :py:class:`PeakRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate>`
                                                                        
                                                                        .. attribute:: peak_burst
                                                                        
                                                                        	peak burst
                                                                        	**type**\:  :py:class:`PeakBurst <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst>`
                                                                        
                                                                        .. attribute:: cdvt
                                                                        
                                                                        	cdvt
                                                                        	**type**\:  :py:class:`Cdvt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt>`
                                                                        
                                                                        .. attribute:: conform_actns
                                                                        
                                                                        	conform actns
                                                                        	**type**\:  :py:class:`ConformActns <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns>`
                                                                        
                                                                        .. attribute:: exceed_actns
                                                                        
                                                                        	exceed actns
                                                                        	**type**\:  :py:class:`ExceedActns <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns>`
                                                                        
                                                                        .. attribute:: violate_actns
                                                                        
                                                                        	violate actns
                                                                        	**type**\:  :py:class:`ViolateActns <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns>`
                                                                        
                                                                        .. attribute:: confclass_encode
                                                                        
                                                                        	confclass encode
                                                                        	**type**\:  :py:class:`ConfclassEncode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode>`
                                                                        
                                                                        .. attribute:: confclass_p
                                                                        
                                                                        	confclass p
                                                                        	**type**\:  :py:class:`ConfclassP <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP>`
                                                                        
                                                                        .. attribute:: excdclass_encode
                                                                        
                                                                        	excdclass encode
                                                                        	**type**\:  :py:class:`ExcdclassEncode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode>`
                                                                        
                                                                        .. attribute:: excdclass_p
                                                                        
                                                                        	excdclass p
                                                                        	**type**\:  :py:class:`ExcdclassP <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP>`
                                                                        
                                                                        .. attribute:: flags
                                                                        
                                                                        	flags
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: police_flags
                                                                        
                                                                        	police flags
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: sbuck_name
                                                                        
                                                                        	sbuck name
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..65
                                                                        
                                                                        .. attribute:: sbuck_type
                                                                        
                                                                        	sbuck type
                                                                        	**type**\:  :py:class:`SharedBucketType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.SharedBucketType>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police, self).__init__()

                                                                            self.yang_name = "police"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("rate", ("rate", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate)), ("burst", ("burst", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst)), ("peak-rate", ("peak_rate", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate)), ("peak-burst", ("peak_burst", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst)), ("cdvt", ("cdvt", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt)), ("conform-actns", ("conform_actns", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns)), ("exceed-actns", ("exceed_actns", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns)), ("violate-actns", ("violate_actns", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns)), ("confclass-encode", ("confclass_encode", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode)), ("confclass-p", ("confclass_p", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP)), ("excdclass-encode", ("excdclass_encode", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode)), ("excdclass-p", ("excdclass_p", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP))])
                                                                            self._leafs = OrderedDict([
                                                                                ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                ('police_flags', (YLeaf(YType.uint32, 'police-flags'), ['int'])),
                                                                                ('sbuck_name', (YLeaf(YType.str, 'sbuck-name'), ['str'])),
                                                                                ('sbuck_type', (YLeaf(YType.enumeration, 'sbuck-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'SharedBucketType', '')])),
                                                                            ])
                                                                            self.flags = None
                                                                            self.police_flags = None
                                                                            self.sbuck_name = None
                                                                            self.sbuck_type = None

                                                                            self.rate = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate()
                                                                            self.rate.parent = self
                                                                            self._children_name_map["rate"] = "rate"

                                                                            self.burst = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst()
                                                                            self.burst.parent = self
                                                                            self._children_name_map["burst"] = "burst"

                                                                            self.peak_rate = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate()
                                                                            self.peak_rate.parent = self
                                                                            self._children_name_map["peak_rate"] = "peak-rate"

                                                                            self.peak_burst = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst()
                                                                            self.peak_burst.parent = self
                                                                            self._children_name_map["peak_burst"] = "peak-burst"

                                                                            self.cdvt = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt()
                                                                            self.cdvt.parent = self
                                                                            self._children_name_map["cdvt"] = "cdvt"

                                                                            self.conform_actns = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns()
                                                                            self.conform_actns.parent = self
                                                                            self._children_name_map["conform_actns"] = "conform-actns"

                                                                            self.exceed_actns = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns()
                                                                            self.exceed_actns.parent = self
                                                                            self._children_name_map["exceed_actns"] = "exceed-actns"

                                                                            self.violate_actns = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns()
                                                                            self.violate_actns.parent = self
                                                                            self._children_name_map["violate_actns"] = "violate-actns"

                                                                            self.confclass_encode = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode()
                                                                            self.confclass_encode.parent = self
                                                                            self._children_name_map["confclass_encode"] = "confclass-encode"

                                                                            self.confclass_p = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP()
                                                                            self.confclass_p.parent = self
                                                                            self._children_name_map["confclass_p"] = "confclass-p"

                                                                            self.excdclass_encode = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode()
                                                                            self.excdclass_encode.parent = self
                                                                            self._children_name_map["excdclass_encode"] = "excdclass-encode"

                                                                            self.excdclass_p = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP()
                                                                            self.excdclass_p.parent = self
                                                                            self._children_name_map["excdclass_p"] = "excdclass-p"
                                                                            self._segment_path = lambda: "police"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police, ['flags', 'police_flags', 'sbuck_name', 'sbuck_type'], name, value)


                                                                        class Rate(Entity):
                                                                            """
                                                                            rate
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate, self).__init__()

                                                                                self.yang_name = "rate"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate, ['value', 'unit'], name, value)


                                                                        class Burst(Entity):
                                                                            """
                                                                            burst
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst, self).__init__()

                                                                                self.yang_name = "burst"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "burst"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst, ['value', 'unit'], name, value)


                                                                        class PeakRate(Entity):
                                                                            """
                                                                            peak rate
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate, self).__init__()

                                                                                self.yang_name = "peak-rate"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "peak-rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate, ['value', 'unit'], name, value)


                                                                        class PeakBurst(Entity):
                                                                            """
                                                                            peak burst
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst, self).__init__()

                                                                                self.yang_name = "peak-burst"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "peak-burst"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst, ['value', 'unit'], name, value)


                                                                        class Cdvt(Entity):
                                                                            """
                                                                            cdvt
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt, self).__init__()

                                                                                self.yang_name = "cdvt"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "cdvt"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt, ['value', 'unit'], name, value)


                                                                        class ConformActns(Entity):
                                                                            """
                                                                            conform actns
                                                                            
                                                                            .. attribute:: police_action_array
                                                                            
                                                                            	police action array
                                                                            	**type**\: list of  		 :py:class:`PoliceActionArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns, self).__init__()

                                                                                self.yang_name = "conform-actns"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("police-action-array", ("police_action_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.police_action_array = YList(self)
                                                                                self._segment_path = lambda: "conform-actns"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns, [], name, value)


                                                                            class PoliceActionArray(Entity):
                                                                                """
                                                                                police action array
                                                                                
                                                                                .. attribute:: mark
                                                                                
                                                                                	mark
                                                                                	**type**\:  :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark>`
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:  :py:class:`PoliceActionTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PoliceActionTypeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray, self).__init__()

                                                                                    self.yang_name = "police-action-array"
                                                                                    self.yang_parent_name = "conform-actns"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("mark", ("mark", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PoliceActionTypeEn', '')])),
                                                                                    ])
                                                                                    self.type = None

                                                                                    self.mark = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark()
                                                                                    self.mark.parent = self
                                                                                    self._children_name_map["mark"] = "mark"
                                                                                    self._segment_path = lambda: "police-action-array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray, ['type'], name, value)


                                                                                class Mark(Entity):
                                                                                    """
                                                                                    mark
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	type
                                                                                    	**type**\:  :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                                    
                                                                                    .. attribute:: mark_flags
                                                                                    
                                                                                    	mark flags
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark, self).__init__()

                                                                                        self.yang_name = "mark"
                                                                                        self.yang_parent_name = "police-action-array"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MarkTypeEn', '')])),
                                                                                            ('mark_flags', (YLeaf(YType.uint32, 'mark-flags'), ['int'])),
                                                                                            ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                        ])
                                                                                        self.type = None
                                                                                        self.mark_flags = None
                                                                                        self.value = None
                                                                                        self._segment_path = lambda: "mark"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark, ['type', 'mark_flags', 'value'], name, value)


                                                                        class ExceedActns(Entity):
                                                                            """
                                                                            exceed actns
                                                                            
                                                                            .. attribute:: police_action_array
                                                                            
                                                                            	police action array
                                                                            	**type**\: list of  		 :py:class:`PoliceActionArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns, self).__init__()

                                                                                self.yang_name = "exceed-actns"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("police-action-array", ("police_action_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.police_action_array = YList(self)
                                                                                self._segment_path = lambda: "exceed-actns"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns, [], name, value)


                                                                            class PoliceActionArray(Entity):
                                                                                """
                                                                                police action array
                                                                                
                                                                                .. attribute:: mark
                                                                                
                                                                                	mark
                                                                                	**type**\:  :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark>`
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:  :py:class:`PoliceActionTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PoliceActionTypeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray, self).__init__()

                                                                                    self.yang_name = "police-action-array"
                                                                                    self.yang_parent_name = "exceed-actns"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("mark", ("mark", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PoliceActionTypeEn', '')])),
                                                                                    ])
                                                                                    self.type = None

                                                                                    self.mark = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark()
                                                                                    self.mark.parent = self
                                                                                    self._children_name_map["mark"] = "mark"
                                                                                    self._segment_path = lambda: "police-action-array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray, ['type'], name, value)


                                                                                class Mark(Entity):
                                                                                    """
                                                                                    mark
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	type
                                                                                    	**type**\:  :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                                    
                                                                                    .. attribute:: mark_flags
                                                                                    
                                                                                    	mark flags
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark, self).__init__()

                                                                                        self.yang_name = "mark"
                                                                                        self.yang_parent_name = "police-action-array"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MarkTypeEn', '')])),
                                                                                            ('mark_flags', (YLeaf(YType.uint32, 'mark-flags'), ['int'])),
                                                                                            ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                        ])
                                                                                        self.type = None
                                                                                        self.mark_flags = None
                                                                                        self.value = None
                                                                                        self._segment_path = lambda: "mark"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark, ['type', 'mark_flags', 'value'], name, value)


                                                                        class ViolateActns(Entity):
                                                                            """
                                                                            violate actns
                                                                            
                                                                            .. attribute:: police_action_array
                                                                            
                                                                            	police action array
                                                                            	**type**\: list of  		 :py:class:`PoliceActionArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns, self).__init__()

                                                                                self.yang_name = "violate-actns"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("police-action-array", ("police_action_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.police_action_array = YList(self)
                                                                                self._segment_path = lambda: "violate-actns"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns, [], name, value)


                                                                            class PoliceActionArray(Entity):
                                                                                """
                                                                                police action array
                                                                                
                                                                                .. attribute:: mark
                                                                                
                                                                                	mark
                                                                                	**type**\:  :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark>`
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:  :py:class:`PoliceActionTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PoliceActionTypeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray, self).__init__()

                                                                                    self.yang_name = "police-action-array"
                                                                                    self.yang_parent_name = "violate-actns"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("mark", ("mark", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PoliceActionTypeEn', '')])),
                                                                                    ])
                                                                                    self.type = None

                                                                                    self.mark = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark()
                                                                                    self.mark.parent = self
                                                                                    self._children_name_map["mark"] = "mark"
                                                                                    self._segment_path = lambda: "police-action-array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray, ['type'], name, value)


                                                                                class Mark(Entity):
                                                                                    """
                                                                                    mark
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	type
                                                                                    	**type**\:  :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                                    
                                                                                    .. attribute:: mark_flags
                                                                                    
                                                                                    	mark flags
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark, self).__init__()

                                                                                        self.yang_name = "mark"
                                                                                        self.yang_parent_name = "police-action-array"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MarkTypeEn', '')])),
                                                                                            ('mark_flags', (YLeaf(YType.uint32, 'mark-flags'), ['int'])),
                                                                                            ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                        ])
                                                                                        self.type = None
                                                                                        self.mark_flags = None
                                                                                        self.value = None
                                                                                        self._segment_path = lambda: "mark"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark, ['type', 'mark_flags', 'value'], name, value)


                                                                        class ConfclassEncode(Entity):
                                                                            """
                                                                            confclass encode
                                                                            
                                                                            .. attribute:: inline_cmap
                                                                            
                                                                            	inline cmap
                                                                            	**type**\:  :py:class:`InlineCmap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap>`
                                                                            
                                                                            .. attribute:: enc
                                                                            
                                                                            	enc
                                                                            	**type**\:  :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                            
                                                                            .. attribute:: class_name
                                                                            
                                                                            	class name
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..65
                                                                            
                                                                            .. attribute:: hd
                                                                            
                                                                            	hd
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: idx
                                                                            
                                                                            	idx
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode, self).__init__()

                                                                                self.yang_name = "confclass-encode"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("inline-cmap", ("inline_cmap", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('enc', (YLeaf(YType.enumeration, 'enc'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyObjEncEn', '')])),
                                                                                    ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                                                    ('hd', (YLeaf(YType.uint64, 'hd'), ['int'])),
                                                                                    ('idx', (YLeaf(YType.uint8, 'idx'), ['int'])),
                                                                                ])
                                                                                self.enc = None
                                                                                self.class_name = None
                                                                                self.hd = None
                                                                                self.idx = None

                                                                                self.inline_cmap = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap()
                                                                                self.inline_cmap.parent = self
                                                                                self._children_name_map["inline_cmap"] = "inline-cmap"
                                                                                self._segment_path = lambda: "confclass-encode"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode, ['enc', 'class_name', 'hd', 'idx'], name, value)


                                                                            class InlineCmap(Entity):
                                                                                """
                                                                                inline cmap
                                                                                
                                                                                .. attribute:: match_infop
                                                                                
                                                                                	Pointer to the first Match info
                                                                                	**type**\:  :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop>`
                                                                                
                                                                                .. attribute:: mode
                                                                                
                                                                                	Inline Class\-Map Mode Match any/all
                                                                                	**type**\:  :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                                
                                                                                .. attribute:: flags
                                                                                
                                                                                	Inline Class\-Map flags
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: match_count
                                                                                
                                                                                	Number of Match infos
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap, self).__init__()

                                                                                    self.yang_name = "inline-cmap"
                                                                                    self.yang_parent_name = "confclass-encode"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("match-infop", ("match_infop", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapModeEn', '')])),
                                                                                        ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                        ('match_count', (YLeaf(YType.uint32, 'match-count'), ['int'])),
                                                                                    ])
                                                                                    self.mode = None
                                                                                    self.flags = None
                                                                                    self.match_count = None

                                                                                    self.match_infop = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop()
                                                                                    self.match_infop.parent = self
                                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                                    self._segment_path = lambda: "inline-cmap"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap, ['mode', 'flags', 'match_count'], name, value)


                                                                                class MatchInfop(Entity):
                                                                                    """
                                                                                    Pointer to the first Match info
                                                                                    
                                                                                    .. attribute:: class_match_info_st
                                                                                    
                                                                                    	class match info st
                                                                                    	**type**\: list of  		 :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop, self).__init__()

                                                                                        self.yang_name = "match-infop"
                                                                                        self.yang_parent_name = "inline-cmap"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("class-match-info-st", ("class_match_info_st", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.class_match_info_st = YList(self)
                                                                                        self._segment_path = lambda: "match-infop"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop, [], name, value)


                                                                                    class ClassMatchInfoSt(Entity):
                                                                                        """
                                                                                        class match info st
                                                                                        
                                                                                        .. attribute:: match_data
                                                                                        
                                                                                        	Match criteria
                                                                                        	**type**\:  :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                        
                                                                                        .. attribute:: flags
                                                                                        
                                                                                        	Flags
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                            self.yang_name = "class-match-info-st"
                                                                                            self.yang_parent_name = "match-infop"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("match-data", ("match_data", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData))])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                            ])
                                                                                            self.flags = None

                                                                                            self.match_data = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                            self.match_data.parent = self
                                                                                            self._children_name_map["match_data"] = "match-data"
                                                                                            self._segment_path = lambda: "class-match-info-st"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                        class MatchData(Entity):
                                                                                            """
                                                                                            Match criteria
                                                                                            
                                                                                            .. attribute:: ipv4_dscp
                                                                                            
                                                                                            	IPv4 DSCP
                                                                                            	**type**\:  :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv6_dscp
                                                                                            
                                                                                            	IPv6 DSCP
                                                                                            	**type**\:  :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                            
                                                                                            .. attribute:: dscp
                                                                                            
                                                                                            	Match DSCP range array
                                                                                            	**type**\:  :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv4_prec
                                                                                            
                                                                                            	IPv4 Precedence
                                                                                            	**type**\:  :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                            
                                                                                            .. attribute:: ipv6_prec
                                                                                            
                                                                                            	IPv6 Precedence
                                                                                            	**type**\:  :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                            
                                                                                            .. attribute:: prec
                                                                                            
                                                                                            	Match Precedence array
                                                                                            	**type**\:  :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                            
                                                                                            .. attribute:: discard_class
                                                                                            
                                                                                            	Match Discard Class array
                                                                                            	**type**\:  :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                            
                                                                                            .. attribute:: qos_group
                                                                                            
                                                                                            	Match QoS group array
                                                                                            	**type**\:  :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                            
                                                                                            .. attribute:: traffic_class
                                                                                            
                                                                                            	Match Traffic class array
                                                                                            	**type**\:  :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                            
                                                                                            .. attribute:: proto
                                                                                            
                                                                                            	Match Protocol array
                                                                                            	**type**\:  :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                            
                                                                                            .. attribute:: icmp_v4
                                                                                            
                                                                                            	Match ICMPV4 Protocol
                                                                                            	**type**\:  :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                            
                                                                                            .. attribute:: icmp_v6
                                                                                            
                                                                                            	Match ICMPV6 Protocol array
                                                                                            	**type**\:  :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                            
                                                                                            .. attribute:: ipv4_packet_len
                                                                                            
                                                                                            	IPv4 packet length array
                                                                                            	**type**\:  :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv6_packet_len
                                                                                            
                                                                                            	IPv6 packet length array
                                                                                            	**type**\:  :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                            
                                                                                            .. attribute:: packet_len
                                                                                            
                                                                                            	Match packet length array
                                                                                            	**type**\:  :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                            
                                                                                            .. attribute:: flow_tag
                                                                                            
                                                                                            	Match flow\-tag array
                                                                                            	**type**\:  :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                            
                                                                                            .. attribute:: tcp_flag
                                                                                            
                                                                                            	Match tcp flag value
                                                                                            	**type**\:  :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                            
                                                                                            .. attribute:: icmpv4_type
                                                                                            
                                                                                            	Match ipv4 icmp type
                                                                                            	**type**\:  :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                            
                                                                                            .. attribute:: icmpv4_code
                                                                                            
                                                                                            	Match ipv4 icmp code
                                                                                            	**type**\:  :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                            
                                                                                            .. attribute:: icmpv6_type
                                                                                            
                                                                                            	Match ipv6 icmp type
                                                                                            	**type**\:  :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                            
                                                                                            .. attribute:: icmpv6_code
                                                                                            
                                                                                            	Match ipv6 icmp code
                                                                                            	**type**\:  :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                            
                                                                                            .. attribute:: mpls_exp
                                                                                            
                                                                                            	Match MPLS experimental topmost array
                                                                                            	**type**\:  :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                            
                                                                                            .. attribute:: mpls_exp_imp
                                                                                            
                                                                                            	Match MPLS experimental imposition array
                                                                                            	**type**\:  :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                                            
                                                                                            	MPLS Disposition IPv4 Access\-list
                                                                                            	**type**\:  :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                                            
                                                                                            	MPLS Disposition IPv6 Access\-list
                                                                                            	**type**\:  :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_top_label
                                                                                            
                                                                                            	MPLS Topmost LABEL
                                                                                            	**type**\:  :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                            
                                                                                            .. attribute:: cos
                                                                                            
                                                                                            	Match CoS array
                                                                                            	**type**\:  :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                            
                                                                                            .. attribute:: cos_inr
                                                                                            
                                                                                            	Match inner header CoS
                                                                                            	**type**\:  :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                            
                                                                                            .. attribute:: dei
                                                                                            
                                                                                            	Match DEI Bit
                                                                                            	**type**\:  :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                            
                                                                                            .. attribute:: dei_inr
                                                                                            
                                                                                            	Match inner DEI Bit
                                                                                            	**type**\:  :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                            
                                                                                            .. attribute:: vlan
                                                                                            
                                                                                            	Match VLAN array
                                                                                            	**type**\:  :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                            
                                                                                            .. attribute:: vlan_inr
                                                                                            
                                                                                            	Match inner header VLAN range array
                                                                                            	**type**\:  :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                            
                                                                                            .. attribute:: fr_dlci
                                                                                            
                                                                                            	Match FR DLCI range array
                                                                                            	**type**\:  :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                            
                                                                                            .. attribute:: src_mac
                                                                                            
                                                                                            	Match Source MAC address
                                                                                            	**type**\:  :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                            
                                                                                            .. attribute:: dst_mac
                                                                                            
                                                                                            	Match Destination MAC address
                                                                                            	**type**\:  :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                            
                                                                                            .. attribute:: atm_clp
                                                                                            
                                                                                            	Match ATM CLP level
                                                                                            	**type**\:  :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                            
                                                                                            .. attribute:: fr_de
                                                                                            
                                                                                            	Match FR DE value
                                                                                            	**type**\:  :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                            
                                                                                            .. attribute:: ipv4_acl
                                                                                            
                                                                                            	IPv4 Access\-list
                                                                                            	**type**\:  :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                            
                                                                                            .. attribute:: ipv6_acl
                                                                                            
                                                                                            	IPv6 Access\-list
                                                                                            	**type**\:  :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                            
                                                                                            .. attribute:: ether_service_acl
                                                                                            
                                                                                            	Ethernet\-Services Access\-list
                                                                                            	**type**\:  :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                            
                                                                                            .. attribute:: avail_id
                                                                                            
                                                                                            	Available Identifiers
                                                                                            	**type**\:  :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                            
                                                                                            .. attribute:: media_type
                                                                                            
                                                                                            	Media Type
                                                                                            	**type**\:  :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                            
                                                                                            .. attribute:: subs_protocol
                                                                                            
                                                                                            	Protocol
                                                                                            	**type**\:  :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                            
                                                                                            .. attribute:: dnis
                                                                                            
                                                                                            	DNIS
                                                                                            	**type**\:  :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                            
                                                                                            .. attribute:: dnis_regex
                                                                                            
                                                                                            	DNIS Regular Expression
                                                                                            	**type**\:  :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                            
                                                                                            .. attribute:: domain
                                                                                            
                                                                                            	Domain Name
                                                                                            	**type**\:  :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                            
                                                                                            .. attribute:: domain_regex
                                                                                            
                                                                                            	Domain Regular Expression
                                                                                            	**type**\:  :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                            
                                                                                            .. attribute:: nas_port
                                                                                            
                                                                                            	NAS Port
                                                                                            	**type**\:  :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                            
                                                                                            .. attribute:: service_name
                                                                                            
                                                                                            	Service Name
                                                                                            	**type**\:  :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                            
                                                                                            .. attribute:: service_name_regex
                                                                                            
                                                                                            	Service Name Regular Exp
                                                                                            	**type**\:  :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv4
                                                                                            
                                                                                            	Source Address IPV4
                                                                                            	**type**\:  :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv4
                                                                                            
                                                                                            	Destination Address IPV4
                                                                                            	**type**\:  :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv6
                                                                                            
                                                                                            	Source Address IPV6
                                                                                            	**type**\:  :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv6
                                                                                            
                                                                                            	Destination Address IPV6
                                                                                            	**type**\:  :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: src_addr_mac
                                                                                            
                                                                                            	Source Address MAC
                                                                                            	**type**\:  :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                            
                                                                                            .. attribute:: timer
                                                                                            
                                                                                            	Timer
                                                                                            	**type**\:  :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                            
                                                                                            .. attribute:: timer_regexp
                                                                                            
                                                                                            	Timer Regular Expression
                                                                                            	**type**\:  :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                            
                                                                                            .. attribute:: tunnel_name
                                                                                            
                                                                                            	Tunnel Name
                                                                                            	**type**\:  :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                            
                                                                                            .. attribute:: tunnel_name_regex
                                                                                            
                                                                                            	Tunnel Name Regular Expression
                                                                                            	**type**\:  :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                            
                                                                                            .. attribute:: user_name
                                                                                            
                                                                                            	User Name
                                                                                            	**type**\:  :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                            
                                                                                            .. attribute:: user_name_regex
                                                                                            
                                                                                            	User Name Regular Expression
                                                                                            	**type**\:  :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                            
                                                                                            .. attribute:: auth_username
                                                                                            
                                                                                            	Authenticated User Name
                                                                                            	**type**\:  :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                            
                                                                                            .. attribute:: auth_username_regex
                                                                                            
                                                                                            	Authenticated User Name RegEx
                                                                                            	**type**\:  :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_username
                                                                                            
                                                                                            	Unauthenticated User Name
                                                                                            	**type**\:  :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                            
                                                                                            .. attribute:: unauth_username_regex
                                                                                            
                                                                                            	Unauthenticated User Name RegEx
                                                                                            	**type**\:  :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: auth_domain
                                                                                            
                                                                                            	Authenticated domain name
                                                                                            	**type**\:  :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                            
                                                                                            .. attribute:: auth_domain_regex
                                                                                            
                                                                                            	Authenticated Domain Name RegEx
                                                                                            	**type**\:  :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_domain
                                                                                            
                                                                                            	Unauthenticated Domain Name
                                                                                            	**type**\:  :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                            
                                                                                            .. attribute:: unauth_domain_regex
                                                                                            
                                                                                            	Unauthenticated Domain Name RegEx
                                                                                            	**type**\:  :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: vendor_id
                                                                                            
                                                                                            	Vendor ID
                                                                                            	**type**\:  :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                            
                                                                                            .. attribute:: vendor_id_regex
                                                                                            
                                                                                            	Vendor ID RegEx
                                                                                            	**type**\:  :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                            
                                                                                            .. attribute:: access_interface
                                                                                            
                                                                                            	Access interface
                                                                                            	**type**\:  :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                            
                                                                                            .. attribute:: input_interface
                                                                                            
                                                                                            	Input interface
                                                                                            	**type**\:  :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                            
                                                                                            .. attribute:: input_intfhdl
                                                                                            
                                                                                            	Input interface handle
                                                                                            	**type**\:  :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                            
                                                                                            .. attribute:: ethertype
                                                                                            
                                                                                            	Ethernet type
                                                                                            	**type**\:  :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                            
                                                                                            .. attribute:: flow_key_data
                                                                                            
                                                                                            	Flow key structure
                                                                                            	**type**\:  :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id
                                                                                            
                                                                                            	Dhcp Client ID
                                                                                            	**type**\:  :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id_regex
                                                                                            
                                                                                            	Dhcp Client ID RegEx
                                                                                            	**type**\:  :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                            
                                                                                            .. attribute:: circuit_id
                                                                                            
                                                                                            	Circuit ID
                                                                                            	**type**\:  :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                            
                                                                                            .. attribute:: circuit_id_regex
                                                                                            
                                                                                            	Circuit ID RegEx
                                                                                            	**type**\:  :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                            
                                                                                            .. attribute:: remote_id
                                                                                            
                                                                                            	Remote ID
                                                                                            	**type**\:  :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                            
                                                                                            .. attribute:: remote_id_regex
                                                                                            
                                                                                            	Remote ID RegEx
                                                                                            	**type**\:  :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                            
                                                                                            .. attribute:: src_port
                                                                                            
                                                                                            	Source port
                                                                                            	**type**\:  :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                            
                                                                                            .. attribute:: dst_port
                                                                                            
                                                                                            	Destination port
                                                                                            	**type**\:  :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	type
                                                                                            	**type**\:  :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                            
                                                                                            .. attribute:: mpls_top_eos
                                                                                            
                                                                                            	MPLS Topmost EOS
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: fragment_type
                                                                                            
                                                                                            	Fragment type
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: authen_status
                                                                                            
                                                                                            	Authentication Status
                                                                                            	**type**\:  :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                            
                                                                                            .. attribute:: mlp_negotiated
                                                                                            
                                                                                            	MLP Negotiated
                                                                                            	**type**\:  :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                                self.yang_name = "match-data"
                                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("ipv4-dscp", ("ipv4_dscp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp)), ("ipv6-dscp", ("ipv6_dscp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp)), ("dscp", ("dscp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp)), ("ipv4-prec", ("ipv4_prec", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec)), ("ipv6-prec", ("ipv6_prec", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec)), ("prec", ("prec", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec)), ("discard-class", ("discard_class", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass)), ("qos-group", ("qos_group", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup)), ("traffic-class", ("traffic_class", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass)), ("proto", ("proto", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto)), ("icmp-v4", ("icmp_v4", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4)), ("icmp-v6", ("icmp_v6", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6)), ("ipv4-packet-len", ("ipv4_packet_len", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen)), ("ipv6-packet-len", ("ipv6_packet_len", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen)), ("packet-len", ("packet_len", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen)), ("flow-tag", ("flow_tag", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag)), ("tcp-flag", ("tcp_flag", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag)), ("icmpv4-type", ("icmpv4_type", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type)), ("icmpv4-code", ("icmpv4_code", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code)), ("icmpv6-type", ("icmpv6_type", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type)), ("icmpv6-code", ("icmpv6_code", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code)), ("mpls-exp", ("mpls_exp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp)), ("mpls-exp-imp", ("mpls_exp_imp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp)), ("mpls-disp-ipv4-acl", ("mpls_disp_ipv4_acl", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl)), ("mpls-disp-ipv6-acl", ("mpls_disp_ipv6_acl", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl)), ("mpls-top-label", ("mpls_top_label", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel)), ("cos", ("cos", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos)), ("cos-inr", ("cos_inr", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr)), ("dei", ("dei", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei)), ("dei-inr", ("dei_inr", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr)), ("vlan", ("vlan", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan)), ("vlan-inr", ("vlan_inr", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)), ("fr-dlci", ("fr_dlci", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci)), ("src-mac", ("src_mac", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac)), ("dst-mac", ("dst_mac", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac)), ("atm-clp", ("atm_clp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp)), ("fr-de", ("fr_de", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe)), ("ipv4-acl", ("ipv4_acl", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl)), ("ipv6-acl", ("ipv6_acl", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl)), ("ether-service-acl", ("ether_service_acl", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl)), ("avail-id", ("avail_id", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId)), ("media-type", ("media_type", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType)), ("subs-protocol", ("subs_protocol", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol)), ("dnis", ("dnis", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis)), ("dnis-regex", ("dnis_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex)), ("domain", ("domain", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain)), ("domain-regex", ("domain_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex)), ("nas-port", ("nas_port", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort)), ("service-name", ("service_name", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName)), ("service-name-regex", ("service_name_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex)), ("src-addr-ipv4", ("src_addr_ipv4", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4)), ("dst-addr-ipv4", ("dst_addr_ipv4", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4)), ("src-addr-ipv6", ("src_addr_ipv6", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6)), ("dst-addr-ipv6", ("dst_addr_ipv6", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6)), ("src-addr-mac", ("src_addr_mac", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac)), ("timer", ("timer", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer)), ("timer-regexp", ("timer_regexp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp)), ("tunnel-name", ("tunnel_name", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName)), ("tunnel-name-regex", ("tunnel_name_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex)), ("user-name", ("user_name", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName)), ("user-name-regex", ("user_name_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex)), ("auth-username", ("auth_username", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername)), ("auth-username-regex", ("auth_username_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex)), ("unauth-username", ("unauth_username", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername)), ("unauth-username-regex", ("unauth_username_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex)), ("auth-domain", ("auth_domain", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain)), ("auth-domain-regex", ("auth_domain_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex)), ("unauth-domain", ("unauth_domain", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain)), ("unauth-domain-regex", ("unauth_domain_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex)), ("vendor-id", ("vendor_id", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId)), ("vendor-id-regex", ("vendor_id_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex)), ("access-interface", ("access_interface", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface)), ("input-interface", ("input_interface", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface)), ("input-intfhdl", ("input_intfhdl", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl)), ("ethertype", ("ethertype", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype)), ("flow-key-data", ("flow_key_data", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData)), ("dhcp-client-id", ("dhcp_client_id", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId)), ("dhcp-client-id-regex", ("dhcp_client_id_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex)), ("circuit-id", ("circuit_id", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId)), ("circuit-id-regex", ("circuit_id_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex)), ("remote-id", ("remote_id", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId)), ("remote-id-regex", ("remote_id_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex)), ("src-port", ("src_port", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort)), ("dst-port", ("dst_port", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort))])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchTypeEn', '')])),
                                                                                                    ('mpls_top_eos', (YLeaf(YType.uint8, 'mpls-top-eos'), ['int'])),
                                                                                                    ('fragment_type', (YLeaf(YType.uint8, 'fragment-type'), ['int'])),
                                                                                                    ('authen_status', (YLeaf(YType.enumeration, 'authen-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchAuthenStatusEn', '')])),
                                                                                                    ('mlp_negotiated', (YLeaf(YType.enumeration, 'mlp-negotiated'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchMlpNegotiatedEn', '')])),
                                                                                                ])
                                                                                                self.type = None
                                                                                                self.mpls_top_eos = None
                                                                                                self.fragment_type = None
                                                                                                self.authen_status = None
                                                                                                self.mlp_negotiated = None

                                                                                                self.ipv4_dscp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                                self.ipv4_dscp.parent = self
                                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"

                                                                                                self.ipv6_dscp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                                self.ipv6_dscp.parent = self
                                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"

                                                                                                self.dscp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                                self.dscp.parent = self
                                                                                                self._children_name_map["dscp"] = "dscp"

                                                                                                self.ipv4_prec = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                                self.ipv4_prec.parent = self
                                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"

                                                                                                self.ipv6_prec = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                                self.ipv6_prec.parent = self
                                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"

                                                                                                self.prec = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                                self.prec.parent = self
                                                                                                self._children_name_map["prec"] = "prec"

                                                                                                self.discard_class = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                                self.discard_class.parent = self
                                                                                                self._children_name_map["discard_class"] = "discard-class"

                                                                                                self.qos_group = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                                self.qos_group.parent = self
                                                                                                self._children_name_map["qos_group"] = "qos-group"

                                                                                                self.traffic_class = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                                self.traffic_class.parent = self
                                                                                                self._children_name_map["traffic_class"] = "traffic-class"

                                                                                                self.proto = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                                self.proto.parent = self
                                                                                                self._children_name_map["proto"] = "proto"

                                                                                                self.icmp_v4 = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                                self.icmp_v4.parent = self
                                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"

                                                                                                self.icmp_v6 = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                                self.icmp_v6.parent = self
                                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"

                                                                                                self.ipv4_packet_len = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                                self.ipv4_packet_len.parent = self
                                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"

                                                                                                self.ipv6_packet_len = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                                self.ipv6_packet_len.parent = self
                                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"

                                                                                                self.packet_len = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                                self.packet_len.parent = self
                                                                                                self._children_name_map["packet_len"] = "packet-len"

                                                                                                self.flow_tag = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                                self.flow_tag.parent = self
                                                                                                self._children_name_map["flow_tag"] = "flow-tag"

                                                                                                self.tcp_flag = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                                self.tcp_flag.parent = self
                                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"

                                                                                                self.icmpv4_type = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                                self.icmpv4_type.parent = self
                                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"

                                                                                                self.icmpv4_code = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                                self.icmpv4_code.parent = self
                                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"

                                                                                                self.icmpv6_type = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                                self.icmpv6_type.parent = self
                                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"

                                                                                                self.icmpv6_code = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                                self.icmpv6_code.parent = self
                                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"

                                                                                                self.mpls_exp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                                self.mpls_exp.parent = self
                                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"

                                                                                                self.mpls_exp_imp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                                self.mpls_exp_imp.parent = self
                                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"

                                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"

                                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"

                                                                                                self.mpls_top_label = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                                self.mpls_top_label.parent = self
                                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"

                                                                                                self.cos = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                                self.cos.parent = self
                                                                                                self._children_name_map["cos"] = "cos"

                                                                                                self.cos_inr = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                                self.cos_inr.parent = self
                                                                                                self._children_name_map["cos_inr"] = "cos-inr"

                                                                                                self.dei = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                                self.dei.parent = self
                                                                                                self._children_name_map["dei"] = "dei"

                                                                                                self.dei_inr = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                                self.dei_inr.parent = self
                                                                                                self._children_name_map["dei_inr"] = "dei-inr"

                                                                                                self.vlan = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                                self.vlan.parent = self
                                                                                                self._children_name_map["vlan"] = "vlan"

                                                                                                self.vlan_inr = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                                self.vlan_inr.parent = self
                                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"

                                                                                                self.fr_dlci = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                                self.fr_dlci.parent = self
                                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"

                                                                                                self.src_mac = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                                self.src_mac.parent = self
                                                                                                self._children_name_map["src_mac"] = "src-mac"

                                                                                                self.dst_mac = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                                self.dst_mac.parent = self
                                                                                                self._children_name_map["dst_mac"] = "dst-mac"

                                                                                                self.atm_clp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                                self.atm_clp.parent = self
                                                                                                self._children_name_map["atm_clp"] = "atm-clp"

                                                                                                self.fr_de = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                                self.fr_de.parent = self
                                                                                                self._children_name_map["fr_de"] = "fr-de"

                                                                                                self.ipv4_acl = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                                self.ipv4_acl.parent = self
                                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"

                                                                                                self.ipv6_acl = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                                self.ipv6_acl.parent = self
                                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"

                                                                                                self.ether_service_acl = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                                self.ether_service_acl.parent = self
                                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"

                                                                                                self.avail_id = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                                self.avail_id.parent = self
                                                                                                self._children_name_map["avail_id"] = "avail-id"

                                                                                                self.media_type = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                                self.media_type.parent = self
                                                                                                self._children_name_map["media_type"] = "media-type"

                                                                                                self.subs_protocol = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                                self.subs_protocol.parent = self
                                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"

                                                                                                self.dnis = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                                self.dnis.parent = self
                                                                                                self._children_name_map["dnis"] = "dnis"

                                                                                                self.dnis_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                                self.dnis_regex.parent = self
                                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"

                                                                                                self.domain = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                                self.domain.parent = self
                                                                                                self._children_name_map["domain"] = "domain"

                                                                                                self.domain_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                                self.domain_regex.parent = self
                                                                                                self._children_name_map["domain_regex"] = "domain-regex"

                                                                                                self.nas_port = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                                self.nas_port.parent = self
                                                                                                self._children_name_map["nas_port"] = "nas-port"

                                                                                                self.service_name = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                                self.service_name.parent = self
                                                                                                self._children_name_map["service_name"] = "service-name"

                                                                                                self.service_name_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                                self.service_name_regex.parent = self
                                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"

                                                                                                self.src_addr_ipv4 = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                                self.src_addr_ipv4.parent = self
                                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"

                                                                                                self.dst_addr_ipv4 = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                                self.dst_addr_ipv4.parent = self
                                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"

                                                                                                self.src_addr_ipv6 = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                                self.src_addr_ipv6.parent = self
                                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"

                                                                                                self.dst_addr_ipv6 = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                                self.dst_addr_ipv6.parent = self
                                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"

                                                                                                self.src_addr_mac = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                                self.src_addr_mac.parent = self
                                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"

                                                                                                self.timer = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                                self.timer.parent = self
                                                                                                self._children_name_map["timer"] = "timer"

                                                                                                self.timer_regexp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                                self.timer_regexp.parent = self
                                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"

                                                                                                self.tunnel_name = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                                self.tunnel_name.parent = self
                                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"

                                                                                                self.tunnel_name_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                                self.tunnel_name_regex.parent = self
                                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"

                                                                                                self.user_name = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                                self.user_name.parent = self
                                                                                                self._children_name_map["user_name"] = "user-name"

                                                                                                self.user_name_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                                self.user_name_regex.parent = self
                                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"

                                                                                                self.auth_username = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                                self.auth_username.parent = self
                                                                                                self._children_name_map["auth_username"] = "auth-username"

                                                                                                self.auth_username_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                                self.auth_username_regex.parent = self
                                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"

                                                                                                self.unauth_username = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                                self.unauth_username.parent = self
                                                                                                self._children_name_map["unauth_username"] = "unauth-username"

                                                                                                self.unauth_username_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                                self.unauth_username_regex.parent = self
                                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"

                                                                                                self.auth_domain = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                                self.auth_domain.parent = self
                                                                                                self._children_name_map["auth_domain"] = "auth-domain"

                                                                                                self.auth_domain_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                                self.auth_domain_regex.parent = self
                                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"

                                                                                                self.unauth_domain = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                                self.unauth_domain.parent = self
                                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"

                                                                                                self.unauth_domain_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                                self.unauth_domain_regex.parent = self
                                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"

                                                                                                self.vendor_id = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                                self.vendor_id.parent = self
                                                                                                self._children_name_map["vendor_id"] = "vendor-id"

                                                                                                self.vendor_id_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                                self.vendor_id_regex.parent = self
                                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"

                                                                                                self.access_interface = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                                self.access_interface.parent = self
                                                                                                self._children_name_map["access_interface"] = "access-interface"

                                                                                                self.input_interface = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                                self.input_interface.parent = self
                                                                                                self._children_name_map["input_interface"] = "input-interface"

                                                                                                self.input_intfhdl = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                                self.input_intfhdl.parent = self
                                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"

                                                                                                self.ethertype = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                                self.ethertype.parent = self
                                                                                                self._children_name_map["ethertype"] = "ethertype"

                                                                                                self.flow_key_data = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                                self.flow_key_data.parent = self
                                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"

                                                                                                self.dhcp_client_id = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                                self.dhcp_client_id.parent = self
                                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"

                                                                                                self.dhcp_client_id_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                                self.dhcp_client_id_regex.parent = self
                                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"

                                                                                                self.circuit_id = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                                self.circuit_id.parent = self
                                                                                                self._children_name_map["circuit_id"] = "circuit-id"

                                                                                                self.circuit_id_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                                self.circuit_id_regex.parent = self
                                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"

                                                                                                self.remote_id = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                                self.remote_id.parent = self
                                                                                                self._children_name_map["remote_id"] = "remote-id"

                                                                                                self.remote_id_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                                self.remote_id_regex.parent = self
                                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"

                                                                                                self.src_port = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                                self.src_port.parent = self
                                                                                                self._children_name_map["src_port"] = "src-port"

                                                                                                self.dst_port = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                                self.dst_port.parent = self
                                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                                self._segment_path = lambda: "match-data"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, ['type', 'mpls_top_eos', 'fragment_type', 'authen_status', 'mlp_negotiated'], name, value)


                                                                                            class Ipv4Dscp(Entity):
                                                                                                """
                                                                                                IPv4 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv4-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv6Dscp(Entity):
                                                                                                """
                                                                                                IPv6 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv6-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Dscp(Entity):
                                                                                                """
                                                                                                Match DSCP range array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                    self.yang_name = "dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv4Prec(Entity):
                                                                                                """
                                                                                                IPv4 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                    self.yang_name = "ipv4-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "ipv4-prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                            class Ipv6Prec(Entity):
                                                                                                """
                                                                                                IPv6 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                    self.yang_name = "ipv6-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "ipv6-prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                            class Prec(Entity):
                                                                                                """
                                                                                                Match Precedence array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                    self.yang_name = "prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                            class DiscardClass(Entity):
                                                                                                """
                                                                                                Match Discard Class array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                    self.yang_name = "discard-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "discard-class"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                            class QosGroup(Entity):
                                                                                                """
                                                                                                Match QoS group array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                    self.yang_name = "qos-group"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "qos-group"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "qos-group"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class TrafficClass(Entity):
                                                                                                """
                                                                                                Match Traffic class array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                    self.yang_name = "traffic-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "traffic-class"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "traffic-class"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Proto(Entity):
                                                                                                """
                                                                                                Match Protocol array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                    self.yang_name = "proto"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "proto"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "proto"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class IcmpV4(Entity):
                                                                                                """
                                                                                                Match ICMPV4 Protocol
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                    self.yang_name = "icmp-v4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                    ])
                                                                                                    self.type = None
                                                                                                    self.code = None
                                                                                                    self._segment_path = lambda: "icmp-v4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['type', 'code'], name, value)


                                                                                            class IcmpV6(Entity):
                                                                                                """
                                                                                                Match ICMPV6 Protocol array
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                    self.yang_name = "icmp-v6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                    ])
                                                                                                    self.type = None
                                                                                                    self.code = None
                                                                                                    self._segment_path = lambda: "icmp-v6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['type', 'code'], name, value)


                                                                                            class Ipv4PacketLen(Entity):
                                                                                                """
                                                                                                IPv4 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv6PacketLen(Entity):
                                                                                                """
                                                                                                IPv6 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class PacketLen(Entity):
                                                                                                """
                                                                                                Match packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                    self.yang_name = "packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FlowTag(Entity):
                                                                                                """
                                                                                                Match flow\-tag array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                    self.yang_name = "flow-tag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "flow-tag"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "flow-tag"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class TcpFlag(Entity):
                                                                                                """
                                                                                                Match tcp flag value
                                                                                                
                                                                                                .. attribute:: value
                                                                                                
                                                                                                	Value of TCP flag
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: match_any
                                                                                                
                                                                                                	Match any TCP flag bit
                                                                                                	**type**\: bool
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                    self.yang_name = "tcp-flag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                                        ('match_any', (YLeaf(YType.boolean, 'match-any'), ['bool'])),
                                                                                                    ])
                                                                                                    self.value = None
                                                                                                    self.match_any = None
                                                                                                    self._segment_path = lambda: "tcp-flag"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['value', 'match_any'], name, value)


                                                                                            class Icmpv4Type(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                    self.yang_name = "icmpv4-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv4Code(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                    self.yang_name = "icmpv4-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-code"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv6Type(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                    self.yang_name = "icmpv6-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv6Code(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                    self.yang_name = "icmpv6-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-code"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class MplsExp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental topmost array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "mpls-exp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                            class MplsExpImp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental imposition array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "mpls-exp-imp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                            class MplsDispIpv4Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                            class MplsDispIpv6Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                            class MplsTopLabel(Entity):
                                                                                                """
                                                                                                MPLS Topmost LABEL
                                                                                                
                                                                                                .. attribute:: uint32_rng_array
                                                                                                
                                                                                                	uint32 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                    self.yang_name = "mpls-top-label"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint32_rng_array", ("uint32_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint32_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "mpls-top-label"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                                class Uint32RngArray(Entity):
                                                                                                    """
                                                                                                    uint32 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                        self.yang_name = "uint32_rng_array"
                                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint32, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint32, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint32_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['min', 'max'], name, value)


                                                                                            class Cos(Entity):
                                                                                                """
                                                                                                Match CoS array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                    self.yang_name = "cos"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "cos"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                            class CosInr(Entity):
                                                                                                """
                                                                                                Match inner header CoS
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                    self.yang_name = "cos-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "cos-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                            class Dei(Entity):
                                                                                                """
                                                                                                Match DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                    self.yang_name = "dei"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                    ])
                                                                                                    self.bit_value = None
                                                                                                    self._segment_path = lambda: "dei"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                            class DeiInr(Entity):
                                                                                                """
                                                                                                Match inner DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                    self.yang_name = "dei-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                    ])
                                                                                                    self.bit_value = None
                                                                                                    self._segment_path = lambda: "dei-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                            class Vlan(Entity):
                                                                                                """
                                                                                                Match VLAN array
                                                                                                
                                                                                                .. attribute:: vlan_id_array
                                                                                                
                                                                                                	vlan id array
                                                                                                	**type**\: list of  		 :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                    self.yang_name = "vlan"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("vlan-id-array", ("vlan_id_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.vlan_id_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                                class VlanIdArray(Entity):
                                                                                                    """
                                                                                                    vlan id array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	VLAN mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                        self.yang_name = "vlan-id-array"
                                                                                                        self.yang_parent_name = "vlan"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ('mask', (YLeaf(YType.uint16, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "vlan-id-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['min', 'max', 'mask'], name, value)


                                                                                            class VlanInr(Entity):
                                                                                                """
                                                                                                Match inner header VLAN range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                    self.yang_name = "vlan-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FrDlci(Entity):
                                                                                                """
                                                                                                Match FR DLCI range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                    self.yang_name = "fr-dlci"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "fr-dlci"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class SrcMac(Entity):
                                                                                                """
                                                                                                Match Source MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                    self.yang_name = "src-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.mac_addr = []
                                                                                                    self.mask = []
                                                                                                    self._segment_path = lambda: "src-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                            class DstMac(Entity):
                                                                                                """
                                                                                                Match Destination MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                    self.yang_name = "dst-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.mac_addr = []
                                                                                                    self.mask = []
                                                                                                    self._segment_path = lambda: "dst-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                            class AtmClp(Entity):
                                                                                                """
                                                                                                Match ATM CLP level
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                    self.yang_name = "atm-clp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "atm-clp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                            class FrDe(Entity):
                                                                                                """
                                                                                                Match FR DE value
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                    self.yang_name = "fr-de"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "fr-de"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                            class Ipv4Acl(Entity):
                                                                                                """
                                                                                                IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                    self.yang_name = "ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ipv4-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                            class Ipv6Acl(Entity):
                                                                                                """
                                                                                                IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                    self.yang_name = "ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ipv6-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                            class EtherServiceAcl(Entity):
                                                                                                """
                                                                                                Ethernet\-Services Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                    self.yang_name = "ether-service-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ether-service-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                            class AvailId(Entity):
                                                                                                """
                                                                                                Available Identifiers
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                    self.yang_name = "avail-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "avail-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                            class MediaType(Entity):
                                                                                                """
                                                                                                Media Type
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                    self.yang_name = "media-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "media-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                            class SubsProtocol(Entity):
                                                                                                """
                                                                                                Protocol
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                    self.yang_name = "subs-protocol"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "subs-protocol"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                            class Dnis(Entity):
                                                                                                """
                                                                                                DNIS
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                    self.yang_name = "dnis"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dnis"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                            class DnisRegex(Entity):
                                                                                                """
                                                                                                DNIS Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                    self.yang_name = "dnis-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dnis-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                            class Domain(Entity):
                                                                                                """
                                                                                                Domain Name
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                    self.yang_name = "domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                        ])
                                                                                                        self.domain_name = None
                                                                                                        self.format_name = None
                                                                                                        self._segment_path = lambda: "domain-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class DomainRegex(Entity):
                                                                                                """
                                                                                                Domain Regular Expression
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                    self.yang_name = "domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain-regex"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                        ])
                                                                                                        self.domain_name = None
                                                                                                        self.format_name = None
                                                                                                        self._segment_path = lambda: "domain-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class NasPort(Entity):
                                                                                                """
                                                                                                NAS Port
                                                                                                
                                                                                                .. attribute:: nas_port_array
                                                                                                
                                                                                                	nas port array
                                                                                                	**type**\: list of  		 :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                    self.yang_name = "nas-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("nas-port-array", ("nas_port_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.nas_port_array = YList(self)
                                                                                                    self._segment_path = lambda: "nas-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                                class NasPortArray(Entity):
                                                                                                    """
                                                                                                    nas port array
                                                                                                    
                                                                                                    .. attribute:: sub_id
                                                                                                    
                                                                                                    	sub id
                                                                                                    	**type**\:  :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                    
                                                                                                    .. attribute:: operator
                                                                                                    
                                                                                                    	operator
                                                                                                    	**type**\:  :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	value
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                        self.yang_name = "nas-port-array"
                                                                                                        self.yang_parent_name = "nas-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('sub_id', (YLeaf(YType.enumeration, 'sub-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchNasPortSubIdEn', '')])),
                                                                                                            ('operator', (YLeaf(YType.enumeration, 'operator'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchLogicalOperatorEn', '')])),
                                                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                                        ])
                                                                                                        self.sub_id = None
                                                                                                        self.operator = None
                                                                                                        self.value = None
                                                                                                        self._segment_path = lambda: "nas-port-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['sub_id', 'operator', 'value'], name, value)


                                                                                            class ServiceName(Entity):
                                                                                                """
                                                                                                Service Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                    self.yang_name = "service-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "service-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                            class ServiceNameRegex(Entity):
                                                                                                """
                                                                                                Service Name Regular Exp
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                    self.yang_name = "service-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "service-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                            class SrcAddrIpv4(Entity):
                                                                                                """
                                                                                                Source Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class DstAddrIpv4(Entity):
                                                                                                """
                                                                                                Destination Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class SrcAddrIpv6(Entity):
                                                                                                """
                                                                                                Source Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class DstAddrIpv6(Entity):
                                                                                                """
                                                                                                Destination Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class SrcAddrMac(Entity):
                                                                                                """
                                                                                                Source Address MAC
                                                                                                
                                                                                                .. attribute:: mac_addr_array
                                                                                                
                                                                                                	mac addr array
                                                                                                	**type**\: list of  		 :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                    self.yang_name = "src-addr-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("mac-addr-array", ("mac_addr_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.mac_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                                class MacAddrArray(Entity):
                                                                                                    """
                                                                                                    mac addr array
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                        self.yang_name = "mac-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                            ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.mac_addr = []
                                                                                                        self.mask = []
                                                                                                        self._segment_path = lambda: "mac-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                            class Timer(Entity):
                                                                                                """
                                                                                                Timer
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                    self.yang_name = "timer"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "timer"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                            class TimerRegexp(Entity):
                                                                                                """
                                                                                                Timer Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                    self.yang_name = "timer-regexp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "timer-regexp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                            class TunnelName(Entity):
                                                                                                """
                                                                                                Tunnel Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                    self.yang_name = "tunnel-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "tunnel-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                            class TunnelNameRegex(Entity):
                                                                                                """
                                                                                                Tunnel Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "tunnel-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                            class UserName(Entity):
                                                                                                """
                                                                                                User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                    self.yang_name = "user-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "user-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                            class UserNameRegex(Entity):
                                                                                                """
                                                                                                User Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                    self.yang_name = "user-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "user-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                            class AuthUsername(Entity):
                                                                                                """
                                                                                                Authenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                    self.yang_name = "auth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-username"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                            class AuthUsernameRegex(Entity):
                                                                                                """
                                                                                                Authenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "auth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-username-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                            class UnauthUsername(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                    self.yang_name = "unauth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-username"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                            class UnauthUsernameRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-username-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                            class AuthDomain(Entity):
                                                                                                """
                                                                                                Authenticated domain name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                    self.yang_name = "auth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                            class AuthDomainRegex(Entity):
                                                                                                """
                                                                                                Authenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "auth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                            class UnauthDomain(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                    self.yang_name = "unauth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                            class UnauthDomainRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                            class VendorId(Entity):
                                                                                                """
                                                                                                Vendor ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                    self.yang_name = "vendor-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "vendor-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                            class VendorIdRegex(Entity):
                                                                                                """
                                                                                                Vendor ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                    self.yang_name = "vendor-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "vendor-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                            class AccessInterface(Entity):
                                                                                                """
                                                                                                Access interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                    self.yang_name = "access-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "access-interface"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                            class InputInterface(Entity):
                                                                                                """
                                                                                                Input interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                    self.yang_name = "input-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "input-interface"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                            class InputIntfhdl(Entity):
                                                                                                """
                                                                                                Input interface handle
                                                                                                
                                                                                                .. attribute:: uint64_array
                                                                                                
                                                                                                	uint64 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..18446744073709551615
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                    self.yang_name = "input-intfhdl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint64_array', (YLeafList(YType.uint64, 'uint64_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint64_array = []
                                                                                                    self._segment_path = lambda: "input-intfhdl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                            class Ethertype(Entity):
                                                                                                """
                                                                                                Ethernet type
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                    self.yang_name = "ethertype"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ethertype"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ethertype"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FlowKeyData(Entity):
                                                                                                """
                                                                                                Flow key structure
                                                                                                
                                                                                                .. attribute:: flow_keys
                                                                                                
                                                                                                	flow keys
                                                                                                	**type**\:  :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                                
                                                                                                .. attribute:: max_count
                                                                                                
                                                                                                	Maximum count of flows
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: idle_timeout
                                                                                                
                                                                                                	Idle timeout of flows (in seconds)
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                	**units**\: second
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                    self.yang_name = "flow-key-data"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("flow-keys", ("flow_keys", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys))])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('max_count', (YLeaf(YType.uint16, 'max-count'), ['int'])),
                                                                                                        ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                                                    ])
                                                                                                    self.max_count = None
                                                                                                    self.idle_timeout = None

                                                                                                    self.flow_keys = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                    self.flow_keys.parent = self
                                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                    self._segment_path = lambda: "flow-key-data"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['max_count', 'idle_timeout'], name, value)


                                                                                                class FlowKeys(Entity):
                                                                                                    """
                                                                                                    flow keys
                                                                                                    
                                                                                                    .. attribute:: keys
                                                                                                    
                                                                                                    	keys
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                    
                                                                                                    .. attribute:: num
                                                                                                    
                                                                                                    	num
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                        self.yang_name = "flow-keys"
                                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('keys', (YLeaf(YType.str, 'keys'), ['str'])),
                                                                                                            ('num', (YLeaf(YType.uint8, 'num'), ['int'])),
                                                                                                        ])
                                                                                                        self.keys = None
                                                                                                        self.num = None
                                                                                                        self._segment_path = lambda: "flow-keys"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                            class DhcpClientId(Entity):
                                                                                                """
                                                                                                Dhcp Client ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dhcp-client-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                            class DhcpClientIdRegex(Entity):
                                                                                                """
                                                                                                Dhcp Client ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                            class CircuitId(Entity):
                                                                                                """
                                                                                                Circuit ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                    self.yang_name = "circuit-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "circuit-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                            class CircuitIdRegex(Entity):
                                                                                                """
                                                                                                Circuit ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                    self.yang_name = "circuit-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "circuit-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                            class RemoteId(Entity):
                                                                                                """
                                                                                                Remote ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                    self.yang_name = "remote-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "remote-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                            class RemoteIdRegex(Entity):
                                                                                                """
                                                                                                Remote ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                    self.yang_name = "remote-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "remote-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                            class SrcPort(Entity):
                                                                                                """
                                                                                                Source port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                    self.yang_name = "src-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "src-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class DstPort(Entity):
                                                                                                """
                                                                                                Destination port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                    self.yang_name = "dst-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "dst-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                        class ConfclassP(Entity):
                                                                            """
                                                                            confclass p
                                                                            
                                                                            .. attribute:: class_map_bg
                                                                            
                                                                            	class map bg
                                                                            	**type**\: list of  		 :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP, self).__init__()

                                                                                self.yang_name = "confclass-p"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("class-map-bg", ("class_map_bg", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg))])
                                                                                self._leafs = OrderedDict()

                                                                                self.class_map_bg = YList(self)
                                                                                self._segment_path = lambda: "confclass-p"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP, [], name, value)


                                                                            class ClassMapBg(Entity):
                                                                                """
                                                                                class map bg
                                                                                
                                                                                .. attribute:: match_infop
                                                                                
                                                                                	Pointer to the first Match info
                                                                                	**type**\:  :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop>`
                                                                                
                                                                                .. attribute:: name
                                                                                
                                                                                	Name of the class\-map
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..65
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Class\-Map Type QoS/PBR/Netflow/..
                                                                                	**type**\:  :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                                                
                                                                                .. attribute:: mode
                                                                                
                                                                                	Class\-Map Mode Match any/Match all
                                                                                	**type**\:  :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                                
                                                                                .. attribute:: description
                                                                                
                                                                                	description
                                                                                	**type**\: str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg, self).__init__()

                                                                                    self.yang_name = "class-map-bg"
                                                                                    self.yang_parent_name = "confclass-p"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("match-infop", ("match_infop", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapTypeEn', '')])),
                                                                                        ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapModeEn', '')])),
                                                                                        ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                    ])
                                                                                    self.name = None
                                                                                    self.type = None
                                                                                    self.mode = None
                                                                                    self.description = None

                                                                                    self.match_infop = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop()
                                                                                    self.match_infop.parent = self
                                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                                    self._segment_path = lambda: "class-map-bg"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg, ['name', 'type', 'mode', 'description'], name, value)


                                                                                class MatchInfop(Entity):
                                                                                    """
                                                                                    Pointer to the first Match info
                                                                                    
                                                                                    .. attribute:: class_match_info_st
                                                                                    
                                                                                    	class match info st
                                                                                    	**type**\: list of  		 :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop, self).__init__()

                                                                                        self.yang_name = "match-infop"
                                                                                        self.yang_parent_name = "class-map-bg"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("class-match-info-st", ("class_match_info_st", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.class_match_info_st = YList(self)
                                                                                        self._segment_path = lambda: "match-infop"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop, [], name, value)


                                                                                    class ClassMatchInfoSt(Entity):
                                                                                        """
                                                                                        class match info st
                                                                                        
                                                                                        .. attribute:: match_data
                                                                                        
                                                                                        	Match criteria
                                                                                        	**type**\:  :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                        
                                                                                        .. attribute:: flags
                                                                                        
                                                                                        	Flags
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                            self.yang_name = "class-match-info-st"
                                                                                            self.yang_parent_name = "match-infop"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("match-data", ("match_data", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData))])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                            ])
                                                                                            self.flags = None

                                                                                            self.match_data = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                            self.match_data.parent = self
                                                                                            self._children_name_map["match_data"] = "match-data"
                                                                                            self._segment_path = lambda: "class-match-info-st"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                        class MatchData(Entity):
                                                                                            """
                                                                                            Match criteria
                                                                                            
                                                                                            .. attribute:: ipv4_dscp
                                                                                            
                                                                                            	IPv4 DSCP
                                                                                            	**type**\:  :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv6_dscp
                                                                                            
                                                                                            	IPv6 DSCP
                                                                                            	**type**\:  :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                            
                                                                                            .. attribute:: dscp
                                                                                            
                                                                                            	Match DSCP range array
                                                                                            	**type**\:  :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv4_prec
                                                                                            
                                                                                            	IPv4 Precedence
                                                                                            	**type**\:  :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                            
                                                                                            .. attribute:: ipv6_prec
                                                                                            
                                                                                            	IPv6 Precedence
                                                                                            	**type**\:  :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                            
                                                                                            .. attribute:: prec
                                                                                            
                                                                                            	Match Precedence array
                                                                                            	**type**\:  :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                            
                                                                                            .. attribute:: discard_class
                                                                                            
                                                                                            	Match Discard Class array
                                                                                            	**type**\:  :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                            
                                                                                            .. attribute:: qos_group
                                                                                            
                                                                                            	Match QoS group array
                                                                                            	**type**\:  :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                            
                                                                                            .. attribute:: traffic_class
                                                                                            
                                                                                            	Match Traffic class array
                                                                                            	**type**\:  :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                            
                                                                                            .. attribute:: proto
                                                                                            
                                                                                            	Match Protocol array
                                                                                            	**type**\:  :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                            
                                                                                            .. attribute:: icmp_v4
                                                                                            
                                                                                            	Match ICMPV4 Protocol
                                                                                            	**type**\:  :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                            
                                                                                            .. attribute:: icmp_v6
                                                                                            
                                                                                            	Match ICMPV6 Protocol array
                                                                                            	**type**\:  :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                            
                                                                                            .. attribute:: ipv4_packet_len
                                                                                            
                                                                                            	IPv4 packet length array
                                                                                            	**type**\:  :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv6_packet_len
                                                                                            
                                                                                            	IPv6 packet length array
                                                                                            	**type**\:  :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                            
                                                                                            .. attribute:: packet_len
                                                                                            
                                                                                            	Match packet length array
                                                                                            	**type**\:  :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                            
                                                                                            .. attribute:: flow_tag
                                                                                            
                                                                                            	Match flow\-tag array
                                                                                            	**type**\:  :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                            
                                                                                            .. attribute:: tcp_flag
                                                                                            
                                                                                            	Match tcp flag value
                                                                                            	**type**\:  :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                            
                                                                                            .. attribute:: icmpv4_type
                                                                                            
                                                                                            	Match ipv4 icmp type
                                                                                            	**type**\:  :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                            
                                                                                            .. attribute:: icmpv4_code
                                                                                            
                                                                                            	Match ipv4 icmp code
                                                                                            	**type**\:  :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                            
                                                                                            .. attribute:: icmpv6_type
                                                                                            
                                                                                            	Match ipv6 icmp type
                                                                                            	**type**\:  :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                            
                                                                                            .. attribute:: icmpv6_code
                                                                                            
                                                                                            	Match ipv6 icmp code
                                                                                            	**type**\:  :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                            
                                                                                            .. attribute:: mpls_exp
                                                                                            
                                                                                            	Match MPLS experimental topmost array
                                                                                            	**type**\:  :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                            
                                                                                            .. attribute:: mpls_exp_imp
                                                                                            
                                                                                            	Match MPLS experimental imposition array
                                                                                            	**type**\:  :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                                            
                                                                                            	MPLS Disposition IPv4 Access\-list
                                                                                            	**type**\:  :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                                            
                                                                                            	MPLS Disposition IPv6 Access\-list
                                                                                            	**type**\:  :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_top_label
                                                                                            
                                                                                            	MPLS Topmost LABEL
                                                                                            	**type**\:  :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                            
                                                                                            .. attribute:: cos
                                                                                            
                                                                                            	Match CoS array
                                                                                            	**type**\:  :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                            
                                                                                            .. attribute:: cos_inr
                                                                                            
                                                                                            	Match inner header CoS
                                                                                            	**type**\:  :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                            
                                                                                            .. attribute:: dei
                                                                                            
                                                                                            	Match DEI Bit
                                                                                            	**type**\:  :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                            
                                                                                            .. attribute:: dei_inr
                                                                                            
                                                                                            	Match inner DEI Bit
                                                                                            	**type**\:  :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                            
                                                                                            .. attribute:: vlan
                                                                                            
                                                                                            	Match VLAN array
                                                                                            	**type**\:  :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                            
                                                                                            .. attribute:: vlan_inr
                                                                                            
                                                                                            	Match inner header VLAN range array
                                                                                            	**type**\:  :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                            
                                                                                            .. attribute:: fr_dlci
                                                                                            
                                                                                            	Match FR DLCI range array
                                                                                            	**type**\:  :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                            
                                                                                            .. attribute:: src_mac
                                                                                            
                                                                                            	Match Source MAC address
                                                                                            	**type**\:  :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                            
                                                                                            .. attribute:: dst_mac
                                                                                            
                                                                                            	Match Destination MAC address
                                                                                            	**type**\:  :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                            
                                                                                            .. attribute:: atm_clp
                                                                                            
                                                                                            	Match ATM CLP level
                                                                                            	**type**\:  :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                            
                                                                                            .. attribute:: fr_de
                                                                                            
                                                                                            	Match FR DE value
                                                                                            	**type**\:  :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                            
                                                                                            .. attribute:: ipv4_acl
                                                                                            
                                                                                            	IPv4 Access\-list
                                                                                            	**type**\:  :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                            
                                                                                            .. attribute:: ipv6_acl
                                                                                            
                                                                                            	IPv6 Access\-list
                                                                                            	**type**\:  :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                            
                                                                                            .. attribute:: ether_service_acl
                                                                                            
                                                                                            	Ethernet\-Services Access\-list
                                                                                            	**type**\:  :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                            
                                                                                            .. attribute:: avail_id
                                                                                            
                                                                                            	Available Identifiers
                                                                                            	**type**\:  :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                            
                                                                                            .. attribute:: media_type
                                                                                            
                                                                                            	Media Type
                                                                                            	**type**\:  :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                            
                                                                                            .. attribute:: subs_protocol
                                                                                            
                                                                                            	Protocol
                                                                                            	**type**\:  :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                            
                                                                                            .. attribute:: dnis
                                                                                            
                                                                                            	DNIS
                                                                                            	**type**\:  :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                            
                                                                                            .. attribute:: dnis_regex
                                                                                            
                                                                                            	DNIS Regular Expression
                                                                                            	**type**\:  :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                            
                                                                                            .. attribute:: domain
                                                                                            
                                                                                            	Domain Name
                                                                                            	**type**\:  :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                            
                                                                                            .. attribute:: domain_regex
                                                                                            
                                                                                            	Domain Regular Expression
                                                                                            	**type**\:  :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                            
                                                                                            .. attribute:: nas_port
                                                                                            
                                                                                            	NAS Port
                                                                                            	**type**\:  :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                            
                                                                                            .. attribute:: service_name
                                                                                            
                                                                                            	Service Name
                                                                                            	**type**\:  :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                            
                                                                                            .. attribute:: service_name_regex
                                                                                            
                                                                                            	Service Name Regular Exp
                                                                                            	**type**\:  :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv4
                                                                                            
                                                                                            	Source Address IPV4
                                                                                            	**type**\:  :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv4
                                                                                            
                                                                                            	Destination Address IPV4
                                                                                            	**type**\:  :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv6
                                                                                            
                                                                                            	Source Address IPV6
                                                                                            	**type**\:  :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv6
                                                                                            
                                                                                            	Destination Address IPV6
                                                                                            	**type**\:  :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: src_addr_mac
                                                                                            
                                                                                            	Source Address MAC
                                                                                            	**type**\:  :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                            
                                                                                            .. attribute:: timer
                                                                                            
                                                                                            	Timer
                                                                                            	**type**\:  :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                            
                                                                                            .. attribute:: timer_regexp
                                                                                            
                                                                                            	Timer Regular Expression
                                                                                            	**type**\:  :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                            
                                                                                            .. attribute:: tunnel_name
                                                                                            
                                                                                            	Tunnel Name
                                                                                            	**type**\:  :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                            
                                                                                            .. attribute:: tunnel_name_regex
                                                                                            
                                                                                            	Tunnel Name Regular Expression
                                                                                            	**type**\:  :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                            
                                                                                            .. attribute:: user_name
                                                                                            
                                                                                            	User Name
                                                                                            	**type**\:  :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                            
                                                                                            .. attribute:: user_name_regex
                                                                                            
                                                                                            	User Name Regular Expression
                                                                                            	**type**\:  :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                            
                                                                                            .. attribute:: auth_username
                                                                                            
                                                                                            	Authenticated User Name
                                                                                            	**type**\:  :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                            
                                                                                            .. attribute:: auth_username_regex
                                                                                            
                                                                                            	Authenticated User Name RegEx
                                                                                            	**type**\:  :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_username
                                                                                            
                                                                                            	Unauthenticated User Name
                                                                                            	**type**\:  :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                            
                                                                                            .. attribute:: unauth_username_regex
                                                                                            
                                                                                            	Unauthenticated User Name RegEx
                                                                                            	**type**\:  :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: auth_domain
                                                                                            
                                                                                            	Authenticated domain name
                                                                                            	**type**\:  :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                            
                                                                                            .. attribute:: auth_domain_regex
                                                                                            
                                                                                            	Authenticated Domain Name RegEx
                                                                                            	**type**\:  :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_domain
                                                                                            
                                                                                            	Unauthenticated Domain Name
                                                                                            	**type**\:  :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                            
                                                                                            .. attribute:: unauth_domain_regex
                                                                                            
                                                                                            	Unauthenticated Domain Name RegEx
                                                                                            	**type**\:  :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: vendor_id
                                                                                            
                                                                                            	Vendor ID
                                                                                            	**type**\:  :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                            
                                                                                            .. attribute:: vendor_id_regex
                                                                                            
                                                                                            	Vendor ID RegEx
                                                                                            	**type**\:  :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                            
                                                                                            .. attribute:: access_interface
                                                                                            
                                                                                            	Access interface
                                                                                            	**type**\:  :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                            
                                                                                            .. attribute:: input_interface
                                                                                            
                                                                                            	Input interface
                                                                                            	**type**\:  :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                            
                                                                                            .. attribute:: input_intfhdl
                                                                                            
                                                                                            	Input interface handle
                                                                                            	**type**\:  :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                            
                                                                                            .. attribute:: ethertype
                                                                                            
                                                                                            	Ethernet type
                                                                                            	**type**\:  :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                            
                                                                                            .. attribute:: flow_key_data
                                                                                            
                                                                                            	Flow key structure
                                                                                            	**type**\:  :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id
                                                                                            
                                                                                            	Dhcp Client ID
                                                                                            	**type**\:  :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id_regex
                                                                                            
                                                                                            	Dhcp Client ID RegEx
                                                                                            	**type**\:  :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                            
                                                                                            .. attribute:: circuit_id
                                                                                            
                                                                                            	Circuit ID
                                                                                            	**type**\:  :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                            
                                                                                            .. attribute:: circuit_id_regex
                                                                                            
                                                                                            	Circuit ID RegEx
                                                                                            	**type**\:  :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                            
                                                                                            .. attribute:: remote_id
                                                                                            
                                                                                            	Remote ID
                                                                                            	**type**\:  :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                            
                                                                                            .. attribute:: remote_id_regex
                                                                                            
                                                                                            	Remote ID RegEx
                                                                                            	**type**\:  :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                            
                                                                                            .. attribute:: src_port
                                                                                            
                                                                                            	Source port
                                                                                            	**type**\:  :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                            
                                                                                            .. attribute:: dst_port
                                                                                            
                                                                                            	Destination port
                                                                                            	**type**\:  :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	type
                                                                                            	**type**\:  :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                            
                                                                                            .. attribute:: mpls_top_eos
                                                                                            
                                                                                            	MPLS Topmost EOS
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: fragment_type
                                                                                            
                                                                                            	Fragment type
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: authen_status
                                                                                            
                                                                                            	Authentication Status
                                                                                            	**type**\:  :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                            
                                                                                            .. attribute:: mlp_negotiated
                                                                                            
                                                                                            	MLP Negotiated
                                                                                            	**type**\:  :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                                self.yang_name = "match-data"
                                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("ipv4-dscp", ("ipv4_dscp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp)), ("ipv6-dscp", ("ipv6_dscp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp)), ("dscp", ("dscp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp)), ("ipv4-prec", ("ipv4_prec", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec)), ("ipv6-prec", ("ipv6_prec", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec)), ("prec", ("prec", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec)), ("discard-class", ("discard_class", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass)), ("qos-group", ("qos_group", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup)), ("traffic-class", ("traffic_class", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass)), ("proto", ("proto", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto)), ("icmp-v4", ("icmp_v4", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4)), ("icmp-v6", ("icmp_v6", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6)), ("ipv4-packet-len", ("ipv4_packet_len", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen)), ("ipv6-packet-len", ("ipv6_packet_len", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen)), ("packet-len", ("packet_len", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen)), ("flow-tag", ("flow_tag", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag)), ("tcp-flag", ("tcp_flag", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag)), ("icmpv4-type", ("icmpv4_type", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type)), ("icmpv4-code", ("icmpv4_code", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code)), ("icmpv6-type", ("icmpv6_type", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type)), ("icmpv6-code", ("icmpv6_code", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code)), ("mpls-exp", ("mpls_exp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp)), ("mpls-exp-imp", ("mpls_exp_imp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp)), ("mpls-disp-ipv4-acl", ("mpls_disp_ipv4_acl", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl)), ("mpls-disp-ipv6-acl", ("mpls_disp_ipv6_acl", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl)), ("mpls-top-label", ("mpls_top_label", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel)), ("cos", ("cos", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos)), ("cos-inr", ("cos_inr", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr)), ("dei", ("dei", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei)), ("dei-inr", ("dei_inr", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr)), ("vlan", ("vlan", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan)), ("vlan-inr", ("vlan_inr", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)), ("fr-dlci", ("fr_dlci", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci)), ("src-mac", ("src_mac", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac)), ("dst-mac", ("dst_mac", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac)), ("atm-clp", ("atm_clp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp)), ("fr-de", ("fr_de", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe)), ("ipv4-acl", ("ipv4_acl", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl)), ("ipv6-acl", ("ipv6_acl", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl)), ("ether-service-acl", ("ether_service_acl", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl)), ("avail-id", ("avail_id", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId)), ("media-type", ("media_type", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType)), ("subs-protocol", ("subs_protocol", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol)), ("dnis", ("dnis", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis)), ("dnis-regex", ("dnis_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex)), ("domain", ("domain", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain)), ("domain-regex", ("domain_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex)), ("nas-port", ("nas_port", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort)), ("service-name", ("service_name", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName)), ("service-name-regex", ("service_name_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex)), ("src-addr-ipv4", ("src_addr_ipv4", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4)), ("dst-addr-ipv4", ("dst_addr_ipv4", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4)), ("src-addr-ipv6", ("src_addr_ipv6", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6)), ("dst-addr-ipv6", ("dst_addr_ipv6", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6)), ("src-addr-mac", ("src_addr_mac", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac)), ("timer", ("timer", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer)), ("timer-regexp", ("timer_regexp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp)), ("tunnel-name", ("tunnel_name", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName)), ("tunnel-name-regex", ("tunnel_name_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex)), ("user-name", ("user_name", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName)), ("user-name-regex", ("user_name_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex)), ("auth-username", ("auth_username", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername)), ("auth-username-regex", ("auth_username_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex)), ("unauth-username", ("unauth_username", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername)), ("unauth-username-regex", ("unauth_username_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex)), ("auth-domain", ("auth_domain", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain)), ("auth-domain-regex", ("auth_domain_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex)), ("unauth-domain", ("unauth_domain", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain)), ("unauth-domain-regex", ("unauth_domain_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex)), ("vendor-id", ("vendor_id", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId)), ("vendor-id-regex", ("vendor_id_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex)), ("access-interface", ("access_interface", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface)), ("input-interface", ("input_interface", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface)), ("input-intfhdl", ("input_intfhdl", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl)), ("ethertype", ("ethertype", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype)), ("flow-key-data", ("flow_key_data", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData)), ("dhcp-client-id", ("dhcp_client_id", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId)), ("dhcp-client-id-regex", ("dhcp_client_id_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex)), ("circuit-id", ("circuit_id", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId)), ("circuit-id-regex", ("circuit_id_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex)), ("remote-id", ("remote_id", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId)), ("remote-id-regex", ("remote_id_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex)), ("src-port", ("src_port", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort)), ("dst-port", ("dst_port", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort))])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchTypeEn', '')])),
                                                                                                    ('mpls_top_eos', (YLeaf(YType.uint8, 'mpls-top-eos'), ['int'])),
                                                                                                    ('fragment_type', (YLeaf(YType.uint8, 'fragment-type'), ['int'])),
                                                                                                    ('authen_status', (YLeaf(YType.enumeration, 'authen-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchAuthenStatusEn', '')])),
                                                                                                    ('mlp_negotiated', (YLeaf(YType.enumeration, 'mlp-negotiated'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchMlpNegotiatedEn', '')])),
                                                                                                ])
                                                                                                self.type = None
                                                                                                self.mpls_top_eos = None
                                                                                                self.fragment_type = None
                                                                                                self.authen_status = None
                                                                                                self.mlp_negotiated = None

                                                                                                self.ipv4_dscp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                                self.ipv4_dscp.parent = self
                                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"

                                                                                                self.ipv6_dscp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                                self.ipv6_dscp.parent = self
                                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"

                                                                                                self.dscp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                                self.dscp.parent = self
                                                                                                self._children_name_map["dscp"] = "dscp"

                                                                                                self.ipv4_prec = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                                self.ipv4_prec.parent = self
                                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"

                                                                                                self.ipv6_prec = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                                self.ipv6_prec.parent = self
                                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"

                                                                                                self.prec = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                                self.prec.parent = self
                                                                                                self._children_name_map["prec"] = "prec"

                                                                                                self.discard_class = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                                self.discard_class.parent = self
                                                                                                self._children_name_map["discard_class"] = "discard-class"

                                                                                                self.qos_group = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                                self.qos_group.parent = self
                                                                                                self._children_name_map["qos_group"] = "qos-group"

                                                                                                self.traffic_class = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                                self.traffic_class.parent = self
                                                                                                self._children_name_map["traffic_class"] = "traffic-class"

                                                                                                self.proto = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                                self.proto.parent = self
                                                                                                self._children_name_map["proto"] = "proto"

                                                                                                self.icmp_v4 = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                                self.icmp_v4.parent = self
                                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"

                                                                                                self.icmp_v6 = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                                self.icmp_v6.parent = self
                                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"

                                                                                                self.ipv4_packet_len = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                                self.ipv4_packet_len.parent = self
                                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"

                                                                                                self.ipv6_packet_len = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                                self.ipv6_packet_len.parent = self
                                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"

                                                                                                self.packet_len = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                                self.packet_len.parent = self
                                                                                                self._children_name_map["packet_len"] = "packet-len"

                                                                                                self.flow_tag = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                                self.flow_tag.parent = self
                                                                                                self._children_name_map["flow_tag"] = "flow-tag"

                                                                                                self.tcp_flag = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                                self.tcp_flag.parent = self
                                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"

                                                                                                self.icmpv4_type = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                                self.icmpv4_type.parent = self
                                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"

                                                                                                self.icmpv4_code = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                                self.icmpv4_code.parent = self
                                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"

                                                                                                self.icmpv6_type = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                                self.icmpv6_type.parent = self
                                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"

                                                                                                self.icmpv6_code = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                                self.icmpv6_code.parent = self
                                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"

                                                                                                self.mpls_exp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                                self.mpls_exp.parent = self
                                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"

                                                                                                self.mpls_exp_imp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                                self.mpls_exp_imp.parent = self
                                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"

                                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"

                                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"

                                                                                                self.mpls_top_label = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                                self.mpls_top_label.parent = self
                                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"

                                                                                                self.cos = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                                self.cos.parent = self
                                                                                                self._children_name_map["cos"] = "cos"

                                                                                                self.cos_inr = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                                self.cos_inr.parent = self
                                                                                                self._children_name_map["cos_inr"] = "cos-inr"

                                                                                                self.dei = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                                self.dei.parent = self
                                                                                                self._children_name_map["dei"] = "dei"

                                                                                                self.dei_inr = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                                self.dei_inr.parent = self
                                                                                                self._children_name_map["dei_inr"] = "dei-inr"

                                                                                                self.vlan = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                                self.vlan.parent = self
                                                                                                self._children_name_map["vlan"] = "vlan"

                                                                                                self.vlan_inr = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                                self.vlan_inr.parent = self
                                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"

                                                                                                self.fr_dlci = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                                self.fr_dlci.parent = self
                                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"

                                                                                                self.src_mac = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                                self.src_mac.parent = self
                                                                                                self._children_name_map["src_mac"] = "src-mac"

                                                                                                self.dst_mac = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                                self.dst_mac.parent = self
                                                                                                self._children_name_map["dst_mac"] = "dst-mac"

                                                                                                self.atm_clp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                                self.atm_clp.parent = self
                                                                                                self._children_name_map["atm_clp"] = "atm-clp"

                                                                                                self.fr_de = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                                self.fr_de.parent = self
                                                                                                self._children_name_map["fr_de"] = "fr-de"

                                                                                                self.ipv4_acl = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                                self.ipv4_acl.parent = self
                                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"

                                                                                                self.ipv6_acl = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                                self.ipv6_acl.parent = self
                                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"

                                                                                                self.ether_service_acl = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                                self.ether_service_acl.parent = self
                                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"

                                                                                                self.avail_id = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                                self.avail_id.parent = self
                                                                                                self._children_name_map["avail_id"] = "avail-id"

                                                                                                self.media_type = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                                self.media_type.parent = self
                                                                                                self._children_name_map["media_type"] = "media-type"

                                                                                                self.subs_protocol = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                                self.subs_protocol.parent = self
                                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"

                                                                                                self.dnis = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                                self.dnis.parent = self
                                                                                                self._children_name_map["dnis"] = "dnis"

                                                                                                self.dnis_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                                self.dnis_regex.parent = self
                                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"

                                                                                                self.domain = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                                self.domain.parent = self
                                                                                                self._children_name_map["domain"] = "domain"

                                                                                                self.domain_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                                self.domain_regex.parent = self
                                                                                                self._children_name_map["domain_regex"] = "domain-regex"

                                                                                                self.nas_port = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                                self.nas_port.parent = self
                                                                                                self._children_name_map["nas_port"] = "nas-port"

                                                                                                self.service_name = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                                self.service_name.parent = self
                                                                                                self._children_name_map["service_name"] = "service-name"

                                                                                                self.service_name_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                                self.service_name_regex.parent = self
                                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"

                                                                                                self.src_addr_ipv4 = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                                self.src_addr_ipv4.parent = self
                                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"

                                                                                                self.dst_addr_ipv4 = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                                self.dst_addr_ipv4.parent = self
                                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"

                                                                                                self.src_addr_ipv6 = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                                self.src_addr_ipv6.parent = self
                                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"

                                                                                                self.dst_addr_ipv6 = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                                self.dst_addr_ipv6.parent = self
                                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"

                                                                                                self.src_addr_mac = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                                self.src_addr_mac.parent = self
                                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"

                                                                                                self.timer = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                                self.timer.parent = self
                                                                                                self._children_name_map["timer"] = "timer"

                                                                                                self.timer_regexp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                                self.timer_regexp.parent = self
                                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"

                                                                                                self.tunnel_name = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                                self.tunnel_name.parent = self
                                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"

                                                                                                self.tunnel_name_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                                self.tunnel_name_regex.parent = self
                                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"

                                                                                                self.user_name = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                                self.user_name.parent = self
                                                                                                self._children_name_map["user_name"] = "user-name"

                                                                                                self.user_name_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                                self.user_name_regex.parent = self
                                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"

                                                                                                self.auth_username = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                                self.auth_username.parent = self
                                                                                                self._children_name_map["auth_username"] = "auth-username"

                                                                                                self.auth_username_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                                self.auth_username_regex.parent = self
                                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"

                                                                                                self.unauth_username = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                                self.unauth_username.parent = self
                                                                                                self._children_name_map["unauth_username"] = "unauth-username"

                                                                                                self.unauth_username_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                                self.unauth_username_regex.parent = self
                                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"

                                                                                                self.auth_domain = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                                self.auth_domain.parent = self
                                                                                                self._children_name_map["auth_domain"] = "auth-domain"

                                                                                                self.auth_domain_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                                self.auth_domain_regex.parent = self
                                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"

                                                                                                self.unauth_domain = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                                self.unauth_domain.parent = self
                                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"

                                                                                                self.unauth_domain_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                                self.unauth_domain_regex.parent = self
                                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"

                                                                                                self.vendor_id = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                                self.vendor_id.parent = self
                                                                                                self._children_name_map["vendor_id"] = "vendor-id"

                                                                                                self.vendor_id_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                                self.vendor_id_regex.parent = self
                                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"

                                                                                                self.access_interface = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                                self.access_interface.parent = self
                                                                                                self._children_name_map["access_interface"] = "access-interface"

                                                                                                self.input_interface = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                                self.input_interface.parent = self
                                                                                                self._children_name_map["input_interface"] = "input-interface"

                                                                                                self.input_intfhdl = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                                self.input_intfhdl.parent = self
                                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"

                                                                                                self.ethertype = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                                self.ethertype.parent = self
                                                                                                self._children_name_map["ethertype"] = "ethertype"

                                                                                                self.flow_key_data = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                                self.flow_key_data.parent = self
                                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"

                                                                                                self.dhcp_client_id = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                                self.dhcp_client_id.parent = self
                                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"

                                                                                                self.dhcp_client_id_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                                self.dhcp_client_id_regex.parent = self
                                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"

                                                                                                self.circuit_id = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                                self.circuit_id.parent = self
                                                                                                self._children_name_map["circuit_id"] = "circuit-id"

                                                                                                self.circuit_id_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                                self.circuit_id_regex.parent = self
                                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"

                                                                                                self.remote_id = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                                self.remote_id.parent = self
                                                                                                self._children_name_map["remote_id"] = "remote-id"

                                                                                                self.remote_id_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                                self.remote_id_regex.parent = self
                                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"

                                                                                                self.src_port = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                                self.src_port.parent = self
                                                                                                self._children_name_map["src_port"] = "src-port"

                                                                                                self.dst_port = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                                self.dst_port.parent = self
                                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                                self._segment_path = lambda: "match-data"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['type', 'mpls_top_eos', 'fragment_type', 'authen_status', 'mlp_negotiated'], name, value)


                                                                                            class Ipv4Dscp(Entity):
                                                                                                """
                                                                                                IPv4 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv4-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv6Dscp(Entity):
                                                                                                """
                                                                                                IPv6 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv6-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Dscp(Entity):
                                                                                                """
                                                                                                Match DSCP range array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                    self.yang_name = "dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv4Prec(Entity):
                                                                                                """
                                                                                                IPv4 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                    self.yang_name = "ipv4-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "ipv4-prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                            class Ipv6Prec(Entity):
                                                                                                """
                                                                                                IPv6 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                    self.yang_name = "ipv6-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "ipv6-prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                            class Prec(Entity):
                                                                                                """
                                                                                                Match Precedence array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                    self.yang_name = "prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                            class DiscardClass(Entity):
                                                                                                """
                                                                                                Match Discard Class array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                    self.yang_name = "discard-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "discard-class"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                            class QosGroup(Entity):
                                                                                                """
                                                                                                Match QoS group array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                    self.yang_name = "qos-group"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "qos-group"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "qos-group"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class TrafficClass(Entity):
                                                                                                """
                                                                                                Match Traffic class array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                    self.yang_name = "traffic-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "traffic-class"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "traffic-class"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Proto(Entity):
                                                                                                """
                                                                                                Match Protocol array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                    self.yang_name = "proto"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "proto"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "proto"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class IcmpV4(Entity):
                                                                                                """
                                                                                                Match ICMPV4 Protocol
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                    self.yang_name = "icmp-v4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                    ])
                                                                                                    self.type = None
                                                                                                    self.code = None
                                                                                                    self._segment_path = lambda: "icmp-v4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['type', 'code'], name, value)


                                                                                            class IcmpV6(Entity):
                                                                                                """
                                                                                                Match ICMPV6 Protocol array
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                    self.yang_name = "icmp-v6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                    ])
                                                                                                    self.type = None
                                                                                                    self.code = None
                                                                                                    self._segment_path = lambda: "icmp-v6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['type', 'code'], name, value)


                                                                                            class Ipv4PacketLen(Entity):
                                                                                                """
                                                                                                IPv4 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv6PacketLen(Entity):
                                                                                                """
                                                                                                IPv6 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class PacketLen(Entity):
                                                                                                """
                                                                                                Match packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                    self.yang_name = "packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FlowTag(Entity):
                                                                                                """
                                                                                                Match flow\-tag array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                    self.yang_name = "flow-tag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "flow-tag"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "flow-tag"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class TcpFlag(Entity):
                                                                                                """
                                                                                                Match tcp flag value
                                                                                                
                                                                                                .. attribute:: value
                                                                                                
                                                                                                	Value of TCP flag
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: match_any
                                                                                                
                                                                                                	Match any TCP flag bit
                                                                                                	**type**\: bool
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                    self.yang_name = "tcp-flag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                                        ('match_any', (YLeaf(YType.boolean, 'match-any'), ['bool'])),
                                                                                                    ])
                                                                                                    self.value = None
                                                                                                    self.match_any = None
                                                                                                    self._segment_path = lambda: "tcp-flag"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['value', 'match_any'], name, value)


                                                                                            class Icmpv4Type(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                    self.yang_name = "icmpv4-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv4Code(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                    self.yang_name = "icmpv4-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-code"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv6Type(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                    self.yang_name = "icmpv6-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv6Code(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                    self.yang_name = "icmpv6-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-code"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class MplsExp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental topmost array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "mpls-exp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                            class MplsExpImp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental imposition array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "mpls-exp-imp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                            class MplsDispIpv4Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                            class MplsDispIpv6Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                            class MplsTopLabel(Entity):
                                                                                                """
                                                                                                MPLS Topmost LABEL
                                                                                                
                                                                                                .. attribute:: uint32_rng_array
                                                                                                
                                                                                                	uint32 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                    self.yang_name = "mpls-top-label"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint32_rng_array", ("uint32_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint32_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "mpls-top-label"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                                class Uint32RngArray(Entity):
                                                                                                    """
                                                                                                    uint32 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                        self.yang_name = "uint32_rng_array"
                                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint32, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint32, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint32_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['min', 'max'], name, value)


                                                                                            class Cos(Entity):
                                                                                                """
                                                                                                Match CoS array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                    self.yang_name = "cos"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "cos"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                            class CosInr(Entity):
                                                                                                """
                                                                                                Match inner header CoS
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                    self.yang_name = "cos-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "cos-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                            class Dei(Entity):
                                                                                                """
                                                                                                Match DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                    self.yang_name = "dei"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                    ])
                                                                                                    self.bit_value = None
                                                                                                    self._segment_path = lambda: "dei"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                            class DeiInr(Entity):
                                                                                                """
                                                                                                Match inner DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                    self.yang_name = "dei-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                    ])
                                                                                                    self.bit_value = None
                                                                                                    self._segment_path = lambda: "dei-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                            class Vlan(Entity):
                                                                                                """
                                                                                                Match VLAN array
                                                                                                
                                                                                                .. attribute:: vlan_id_array
                                                                                                
                                                                                                	vlan id array
                                                                                                	**type**\: list of  		 :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                    self.yang_name = "vlan"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("vlan-id-array", ("vlan_id_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.vlan_id_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                                class VlanIdArray(Entity):
                                                                                                    """
                                                                                                    vlan id array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	VLAN mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                        self.yang_name = "vlan-id-array"
                                                                                                        self.yang_parent_name = "vlan"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ('mask', (YLeaf(YType.uint16, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "vlan-id-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['min', 'max', 'mask'], name, value)


                                                                                            class VlanInr(Entity):
                                                                                                """
                                                                                                Match inner header VLAN range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                    self.yang_name = "vlan-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FrDlci(Entity):
                                                                                                """
                                                                                                Match FR DLCI range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                    self.yang_name = "fr-dlci"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "fr-dlci"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class SrcMac(Entity):
                                                                                                """
                                                                                                Match Source MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                    self.yang_name = "src-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.mac_addr = []
                                                                                                    self.mask = []
                                                                                                    self._segment_path = lambda: "src-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                            class DstMac(Entity):
                                                                                                """
                                                                                                Match Destination MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                    self.yang_name = "dst-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.mac_addr = []
                                                                                                    self.mask = []
                                                                                                    self._segment_path = lambda: "dst-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                            class AtmClp(Entity):
                                                                                                """
                                                                                                Match ATM CLP level
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                    self.yang_name = "atm-clp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "atm-clp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                            class FrDe(Entity):
                                                                                                """
                                                                                                Match FR DE value
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                    self.yang_name = "fr-de"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "fr-de"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                            class Ipv4Acl(Entity):
                                                                                                """
                                                                                                IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                    self.yang_name = "ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ipv4-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                            class Ipv6Acl(Entity):
                                                                                                """
                                                                                                IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                    self.yang_name = "ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ipv6-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                            class EtherServiceAcl(Entity):
                                                                                                """
                                                                                                Ethernet\-Services Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                    self.yang_name = "ether-service-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ether-service-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                            class AvailId(Entity):
                                                                                                """
                                                                                                Available Identifiers
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                    self.yang_name = "avail-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "avail-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                            class MediaType(Entity):
                                                                                                """
                                                                                                Media Type
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                    self.yang_name = "media-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "media-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                            class SubsProtocol(Entity):
                                                                                                """
                                                                                                Protocol
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                    self.yang_name = "subs-protocol"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "subs-protocol"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                            class Dnis(Entity):
                                                                                                """
                                                                                                DNIS
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                    self.yang_name = "dnis"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dnis"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                            class DnisRegex(Entity):
                                                                                                """
                                                                                                DNIS Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                    self.yang_name = "dnis-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dnis-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                            class Domain(Entity):
                                                                                                """
                                                                                                Domain Name
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                    self.yang_name = "domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                        ])
                                                                                                        self.domain_name = None
                                                                                                        self.format_name = None
                                                                                                        self._segment_path = lambda: "domain-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class DomainRegex(Entity):
                                                                                                """
                                                                                                Domain Regular Expression
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                    self.yang_name = "domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain-regex"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                        ])
                                                                                                        self.domain_name = None
                                                                                                        self.format_name = None
                                                                                                        self._segment_path = lambda: "domain-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class NasPort(Entity):
                                                                                                """
                                                                                                NAS Port
                                                                                                
                                                                                                .. attribute:: nas_port_array
                                                                                                
                                                                                                	nas port array
                                                                                                	**type**\: list of  		 :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                    self.yang_name = "nas-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("nas-port-array", ("nas_port_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.nas_port_array = YList(self)
                                                                                                    self._segment_path = lambda: "nas-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                                class NasPortArray(Entity):
                                                                                                    """
                                                                                                    nas port array
                                                                                                    
                                                                                                    .. attribute:: sub_id
                                                                                                    
                                                                                                    	sub id
                                                                                                    	**type**\:  :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                    
                                                                                                    .. attribute:: operator
                                                                                                    
                                                                                                    	operator
                                                                                                    	**type**\:  :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	value
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                        self.yang_name = "nas-port-array"
                                                                                                        self.yang_parent_name = "nas-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('sub_id', (YLeaf(YType.enumeration, 'sub-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchNasPortSubIdEn', '')])),
                                                                                                            ('operator', (YLeaf(YType.enumeration, 'operator'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchLogicalOperatorEn', '')])),
                                                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                                        ])
                                                                                                        self.sub_id = None
                                                                                                        self.operator = None
                                                                                                        self.value = None
                                                                                                        self._segment_path = lambda: "nas-port-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['sub_id', 'operator', 'value'], name, value)


                                                                                            class ServiceName(Entity):
                                                                                                """
                                                                                                Service Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                    self.yang_name = "service-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "service-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                            class ServiceNameRegex(Entity):
                                                                                                """
                                                                                                Service Name Regular Exp
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                    self.yang_name = "service-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "service-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                            class SrcAddrIpv4(Entity):
                                                                                                """
                                                                                                Source Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class DstAddrIpv4(Entity):
                                                                                                """
                                                                                                Destination Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class SrcAddrIpv6(Entity):
                                                                                                """
                                                                                                Source Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class DstAddrIpv6(Entity):
                                                                                                """
                                                                                                Destination Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class SrcAddrMac(Entity):
                                                                                                """
                                                                                                Source Address MAC
                                                                                                
                                                                                                .. attribute:: mac_addr_array
                                                                                                
                                                                                                	mac addr array
                                                                                                	**type**\: list of  		 :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                    self.yang_name = "src-addr-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("mac-addr-array", ("mac_addr_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.mac_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                                class MacAddrArray(Entity):
                                                                                                    """
                                                                                                    mac addr array
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                        self.yang_name = "mac-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                            ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.mac_addr = []
                                                                                                        self.mask = []
                                                                                                        self._segment_path = lambda: "mac-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                            class Timer(Entity):
                                                                                                """
                                                                                                Timer
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                    self.yang_name = "timer"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "timer"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                            class TimerRegexp(Entity):
                                                                                                """
                                                                                                Timer Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                    self.yang_name = "timer-regexp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "timer-regexp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                            class TunnelName(Entity):
                                                                                                """
                                                                                                Tunnel Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                    self.yang_name = "tunnel-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "tunnel-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                            class TunnelNameRegex(Entity):
                                                                                                """
                                                                                                Tunnel Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "tunnel-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                            class UserName(Entity):
                                                                                                """
                                                                                                User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                    self.yang_name = "user-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "user-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                            class UserNameRegex(Entity):
                                                                                                """
                                                                                                User Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                    self.yang_name = "user-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "user-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                            class AuthUsername(Entity):
                                                                                                """
                                                                                                Authenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                    self.yang_name = "auth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-username"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                            class AuthUsernameRegex(Entity):
                                                                                                """
                                                                                                Authenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "auth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-username-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                            class UnauthUsername(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                    self.yang_name = "unauth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-username"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                            class UnauthUsernameRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-username-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                            class AuthDomain(Entity):
                                                                                                """
                                                                                                Authenticated domain name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                    self.yang_name = "auth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                            class AuthDomainRegex(Entity):
                                                                                                """
                                                                                                Authenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "auth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                            class UnauthDomain(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                    self.yang_name = "unauth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                            class UnauthDomainRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                            class VendorId(Entity):
                                                                                                """
                                                                                                Vendor ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                    self.yang_name = "vendor-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "vendor-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                            class VendorIdRegex(Entity):
                                                                                                """
                                                                                                Vendor ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                    self.yang_name = "vendor-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "vendor-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                            class AccessInterface(Entity):
                                                                                                """
                                                                                                Access interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                    self.yang_name = "access-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "access-interface"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                            class InputInterface(Entity):
                                                                                                """
                                                                                                Input interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                    self.yang_name = "input-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "input-interface"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                            class InputIntfhdl(Entity):
                                                                                                """
                                                                                                Input interface handle
                                                                                                
                                                                                                .. attribute:: uint64_array
                                                                                                
                                                                                                	uint64 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..18446744073709551615
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                    self.yang_name = "input-intfhdl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint64_array', (YLeafList(YType.uint64, 'uint64_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint64_array = []
                                                                                                    self._segment_path = lambda: "input-intfhdl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                            class Ethertype(Entity):
                                                                                                """
                                                                                                Ethernet type
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                    self.yang_name = "ethertype"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ethertype"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ethertype"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FlowKeyData(Entity):
                                                                                                """
                                                                                                Flow key structure
                                                                                                
                                                                                                .. attribute:: flow_keys
                                                                                                
                                                                                                	flow keys
                                                                                                	**type**\:  :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                                
                                                                                                .. attribute:: max_count
                                                                                                
                                                                                                	Maximum count of flows
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: idle_timeout
                                                                                                
                                                                                                	Idle timeout of flows (in seconds)
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                	**units**\: second
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                    self.yang_name = "flow-key-data"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("flow-keys", ("flow_keys", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys))])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('max_count', (YLeaf(YType.uint16, 'max-count'), ['int'])),
                                                                                                        ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                                                    ])
                                                                                                    self.max_count = None
                                                                                                    self.idle_timeout = None

                                                                                                    self.flow_keys = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                    self.flow_keys.parent = self
                                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                    self._segment_path = lambda: "flow-key-data"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['max_count', 'idle_timeout'], name, value)


                                                                                                class FlowKeys(Entity):
                                                                                                    """
                                                                                                    flow keys
                                                                                                    
                                                                                                    .. attribute:: keys
                                                                                                    
                                                                                                    	keys
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                    
                                                                                                    .. attribute:: num
                                                                                                    
                                                                                                    	num
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                        self.yang_name = "flow-keys"
                                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('keys', (YLeaf(YType.str, 'keys'), ['str'])),
                                                                                                            ('num', (YLeaf(YType.uint8, 'num'), ['int'])),
                                                                                                        ])
                                                                                                        self.keys = None
                                                                                                        self.num = None
                                                                                                        self._segment_path = lambda: "flow-keys"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                            class DhcpClientId(Entity):
                                                                                                """
                                                                                                Dhcp Client ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dhcp-client-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                            class DhcpClientIdRegex(Entity):
                                                                                                """
                                                                                                Dhcp Client ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                            class CircuitId(Entity):
                                                                                                """
                                                                                                Circuit ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                    self.yang_name = "circuit-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "circuit-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                            class CircuitIdRegex(Entity):
                                                                                                """
                                                                                                Circuit ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                    self.yang_name = "circuit-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "circuit-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                            class RemoteId(Entity):
                                                                                                """
                                                                                                Remote ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                    self.yang_name = "remote-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "remote-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                            class RemoteIdRegex(Entity):
                                                                                                """
                                                                                                Remote ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                    self.yang_name = "remote-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "remote-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                            class SrcPort(Entity):
                                                                                                """
                                                                                                Source port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                    self.yang_name = "src-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "src-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class DstPort(Entity):
                                                                                                """
                                                                                                Destination port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                    self.yang_name = "dst-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "dst-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                        class ExcdclassEncode(Entity):
                                                                            """
                                                                            excdclass encode
                                                                            
                                                                            .. attribute:: inline_cmap
                                                                            
                                                                            	inline cmap
                                                                            	**type**\:  :py:class:`InlineCmap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap>`
                                                                            
                                                                            .. attribute:: enc
                                                                            
                                                                            	enc
                                                                            	**type**\:  :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                            
                                                                            .. attribute:: class_name
                                                                            
                                                                            	class name
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..65
                                                                            
                                                                            .. attribute:: hd
                                                                            
                                                                            	hd
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: idx
                                                                            
                                                                            	idx
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode, self).__init__()

                                                                                self.yang_name = "excdclass-encode"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("inline-cmap", ("inline_cmap", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('enc', (YLeaf(YType.enumeration, 'enc'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyObjEncEn', '')])),
                                                                                    ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                                                    ('hd', (YLeaf(YType.uint64, 'hd'), ['int'])),
                                                                                    ('idx', (YLeaf(YType.uint8, 'idx'), ['int'])),
                                                                                ])
                                                                                self.enc = None
                                                                                self.class_name = None
                                                                                self.hd = None
                                                                                self.idx = None

                                                                                self.inline_cmap = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap()
                                                                                self.inline_cmap.parent = self
                                                                                self._children_name_map["inline_cmap"] = "inline-cmap"
                                                                                self._segment_path = lambda: "excdclass-encode"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode, ['enc', 'class_name', 'hd', 'idx'], name, value)


                                                                            class InlineCmap(Entity):
                                                                                """
                                                                                inline cmap
                                                                                
                                                                                .. attribute:: match_infop
                                                                                
                                                                                	Pointer to the first Match info
                                                                                	**type**\:  :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop>`
                                                                                
                                                                                .. attribute:: mode
                                                                                
                                                                                	Inline Class\-Map Mode Match any/all
                                                                                	**type**\:  :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                                
                                                                                .. attribute:: flags
                                                                                
                                                                                	Inline Class\-Map flags
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: match_count
                                                                                
                                                                                	Number of Match infos
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap, self).__init__()

                                                                                    self.yang_name = "inline-cmap"
                                                                                    self.yang_parent_name = "excdclass-encode"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("match-infop", ("match_infop", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapModeEn', '')])),
                                                                                        ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                        ('match_count', (YLeaf(YType.uint32, 'match-count'), ['int'])),
                                                                                    ])
                                                                                    self.mode = None
                                                                                    self.flags = None
                                                                                    self.match_count = None

                                                                                    self.match_infop = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop()
                                                                                    self.match_infop.parent = self
                                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                                    self._segment_path = lambda: "inline-cmap"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap, ['mode', 'flags', 'match_count'], name, value)


                                                                                class MatchInfop(Entity):
                                                                                    """
                                                                                    Pointer to the first Match info
                                                                                    
                                                                                    .. attribute:: class_match_info_st
                                                                                    
                                                                                    	class match info st
                                                                                    	**type**\: list of  		 :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop, self).__init__()

                                                                                        self.yang_name = "match-infop"
                                                                                        self.yang_parent_name = "inline-cmap"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("class-match-info-st", ("class_match_info_st", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.class_match_info_st = YList(self)
                                                                                        self._segment_path = lambda: "match-infop"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop, [], name, value)


                                                                                    class ClassMatchInfoSt(Entity):
                                                                                        """
                                                                                        class match info st
                                                                                        
                                                                                        .. attribute:: match_data
                                                                                        
                                                                                        	Match criteria
                                                                                        	**type**\:  :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                        
                                                                                        .. attribute:: flags
                                                                                        
                                                                                        	Flags
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                            self.yang_name = "class-match-info-st"
                                                                                            self.yang_parent_name = "match-infop"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("match-data", ("match_data", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData))])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                            ])
                                                                                            self.flags = None

                                                                                            self.match_data = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                            self.match_data.parent = self
                                                                                            self._children_name_map["match_data"] = "match-data"
                                                                                            self._segment_path = lambda: "class-match-info-st"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                        class MatchData(Entity):
                                                                                            """
                                                                                            Match criteria
                                                                                            
                                                                                            .. attribute:: ipv4_dscp
                                                                                            
                                                                                            	IPv4 DSCP
                                                                                            	**type**\:  :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv6_dscp
                                                                                            
                                                                                            	IPv6 DSCP
                                                                                            	**type**\:  :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                            
                                                                                            .. attribute:: dscp
                                                                                            
                                                                                            	Match DSCP range array
                                                                                            	**type**\:  :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv4_prec
                                                                                            
                                                                                            	IPv4 Precedence
                                                                                            	**type**\:  :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                            
                                                                                            .. attribute:: ipv6_prec
                                                                                            
                                                                                            	IPv6 Precedence
                                                                                            	**type**\:  :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                            
                                                                                            .. attribute:: prec
                                                                                            
                                                                                            	Match Precedence array
                                                                                            	**type**\:  :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                            
                                                                                            .. attribute:: discard_class
                                                                                            
                                                                                            	Match Discard Class array
                                                                                            	**type**\:  :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                            
                                                                                            .. attribute:: qos_group
                                                                                            
                                                                                            	Match QoS group array
                                                                                            	**type**\:  :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                            
                                                                                            .. attribute:: traffic_class
                                                                                            
                                                                                            	Match Traffic class array
                                                                                            	**type**\:  :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                            
                                                                                            .. attribute:: proto
                                                                                            
                                                                                            	Match Protocol array
                                                                                            	**type**\:  :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                            
                                                                                            .. attribute:: icmp_v4
                                                                                            
                                                                                            	Match ICMPV4 Protocol
                                                                                            	**type**\:  :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                            
                                                                                            .. attribute:: icmp_v6
                                                                                            
                                                                                            	Match ICMPV6 Protocol array
                                                                                            	**type**\:  :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                            
                                                                                            .. attribute:: ipv4_packet_len
                                                                                            
                                                                                            	IPv4 packet length array
                                                                                            	**type**\:  :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv6_packet_len
                                                                                            
                                                                                            	IPv6 packet length array
                                                                                            	**type**\:  :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                            
                                                                                            .. attribute:: packet_len
                                                                                            
                                                                                            	Match packet length array
                                                                                            	**type**\:  :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                            
                                                                                            .. attribute:: flow_tag
                                                                                            
                                                                                            	Match flow\-tag array
                                                                                            	**type**\:  :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                            
                                                                                            .. attribute:: tcp_flag
                                                                                            
                                                                                            	Match tcp flag value
                                                                                            	**type**\:  :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                            
                                                                                            .. attribute:: icmpv4_type
                                                                                            
                                                                                            	Match ipv4 icmp type
                                                                                            	**type**\:  :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                            
                                                                                            .. attribute:: icmpv4_code
                                                                                            
                                                                                            	Match ipv4 icmp code
                                                                                            	**type**\:  :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                            
                                                                                            .. attribute:: icmpv6_type
                                                                                            
                                                                                            	Match ipv6 icmp type
                                                                                            	**type**\:  :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                            
                                                                                            .. attribute:: icmpv6_code
                                                                                            
                                                                                            	Match ipv6 icmp code
                                                                                            	**type**\:  :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                            
                                                                                            .. attribute:: mpls_exp
                                                                                            
                                                                                            	Match MPLS experimental topmost array
                                                                                            	**type**\:  :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                            
                                                                                            .. attribute:: mpls_exp_imp
                                                                                            
                                                                                            	Match MPLS experimental imposition array
                                                                                            	**type**\:  :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                                            
                                                                                            	MPLS Disposition IPv4 Access\-list
                                                                                            	**type**\:  :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                                            
                                                                                            	MPLS Disposition IPv6 Access\-list
                                                                                            	**type**\:  :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_top_label
                                                                                            
                                                                                            	MPLS Topmost LABEL
                                                                                            	**type**\:  :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                            
                                                                                            .. attribute:: cos
                                                                                            
                                                                                            	Match CoS array
                                                                                            	**type**\:  :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                            
                                                                                            .. attribute:: cos_inr
                                                                                            
                                                                                            	Match inner header CoS
                                                                                            	**type**\:  :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                            
                                                                                            .. attribute:: dei
                                                                                            
                                                                                            	Match DEI Bit
                                                                                            	**type**\:  :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                            
                                                                                            .. attribute:: dei_inr
                                                                                            
                                                                                            	Match inner DEI Bit
                                                                                            	**type**\:  :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                            
                                                                                            .. attribute:: vlan
                                                                                            
                                                                                            	Match VLAN array
                                                                                            	**type**\:  :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                            
                                                                                            .. attribute:: vlan_inr
                                                                                            
                                                                                            	Match inner header VLAN range array
                                                                                            	**type**\:  :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                            
                                                                                            .. attribute:: fr_dlci
                                                                                            
                                                                                            	Match FR DLCI range array
                                                                                            	**type**\:  :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                            
                                                                                            .. attribute:: src_mac
                                                                                            
                                                                                            	Match Source MAC address
                                                                                            	**type**\:  :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                            
                                                                                            .. attribute:: dst_mac
                                                                                            
                                                                                            	Match Destination MAC address
                                                                                            	**type**\:  :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                            
                                                                                            .. attribute:: atm_clp
                                                                                            
                                                                                            	Match ATM CLP level
                                                                                            	**type**\:  :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                            
                                                                                            .. attribute:: fr_de
                                                                                            
                                                                                            	Match FR DE value
                                                                                            	**type**\:  :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                            
                                                                                            .. attribute:: ipv4_acl
                                                                                            
                                                                                            	IPv4 Access\-list
                                                                                            	**type**\:  :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                            
                                                                                            .. attribute:: ipv6_acl
                                                                                            
                                                                                            	IPv6 Access\-list
                                                                                            	**type**\:  :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                            
                                                                                            .. attribute:: ether_service_acl
                                                                                            
                                                                                            	Ethernet\-Services Access\-list
                                                                                            	**type**\:  :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                            
                                                                                            .. attribute:: avail_id
                                                                                            
                                                                                            	Available Identifiers
                                                                                            	**type**\:  :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                            
                                                                                            .. attribute:: media_type
                                                                                            
                                                                                            	Media Type
                                                                                            	**type**\:  :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                            
                                                                                            .. attribute:: subs_protocol
                                                                                            
                                                                                            	Protocol
                                                                                            	**type**\:  :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                            
                                                                                            .. attribute:: dnis
                                                                                            
                                                                                            	DNIS
                                                                                            	**type**\:  :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                            
                                                                                            .. attribute:: dnis_regex
                                                                                            
                                                                                            	DNIS Regular Expression
                                                                                            	**type**\:  :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                            
                                                                                            .. attribute:: domain
                                                                                            
                                                                                            	Domain Name
                                                                                            	**type**\:  :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                            
                                                                                            .. attribute:: domain_regex
                                                                                            
                                                                                            	Domain Regular Expression
                                                                                            	**type**\:  :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                            
                                                                                            .. attribute:: nas_port
                                                                                            
                                                                                            	NAS Port
                                                                                            	**type**\:  :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                            
                                                                                            .. attribute:: service_name
                                                                                            
                                                                                            	Service Name
                                                                                            	**type**\:  :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                            
                                                                                            .. attribute:: service_name_regex
                                                                                            
                                                                                            	Service Name Regular Exp
                                                                                            	**type**\:  :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv4
                                                                                            
                                                                                            	Source Address IPV4
                                                                                            	**type**\:  :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv4
                                                                                            
                                                                                            	Destination Address IPV4
                                                                                            	**type**\:  :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv6
                                                                                            
                                                                                            	Source Address IPV6
                                                                                            	**type**\:  :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv6
                                                                                            
                                                                                            	Destination Address IPV6
                                                                                            	**type**\:  :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: src_addr_mac
                                                                                            
                                                                                            	Source Address MAC
                                                                                            	**type**\:  :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                            
                                                                                            .. attribute:: timer
                                                                                            
                                                                                            	Timer
                                                                                            	**type**\:  :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                            
                                                                                            .. attribute:: timer_regexp
                                                                                            
                                                                                            	Timer Regular Expression
                                                                                            	**type**\:  :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                            
                                                                                            .. attribute:: tunnel_name
                                                                                            
                                                                                            	Tunnel Name
                                                                                            	**type**\:  :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                            
                                                                                            .. attribute:: tunnel_name_regex
                                                                                            
                                                                                            	Tunnel Name Regular Expression
                                                                                            	**type**\:  :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                            
                                                                                            .. attribute:: user_name
                                                                                            
                                                                                            	User Name
                                                                                            	**type**\:  :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                            
                                                                                            .. attribute:: user_name_regex
                                                                                            
                                                                                            	User Name Regular Expression
                                                                                            	**type**\:  :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                            
                                                                                            .. attribute:: auth_username
                                                                                            
                                                                                            	Authenticated User Name
                                                                                            	**type**\:  :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                            
                                                                                            .. attribute:: auth_username_regex
                                                                                            
                                                                                            	Authenticated User Name RegEx
                                                                                            	**type**\:  :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_username
                                                                                            
                                                                                            	Unauthenticated User Name
                                                                                            	**type**\:  :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                            
                                                                                            .. attribute:: unauth_username_regex
                                                                                            
                                                                                            	Unauthenticated User Name RegEx
                                                                                            	**type**\:  :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: auth_domain
                                                                                            
                                                                                            	Authenticated domain name
                                                                                            	**type**\:  :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                            
                                                                                            .. attribute:: auth_domain_regex
                                                                                            
                                                                                            	Authenticated Domain Name RegEx
                                                                                            	**type**\:  :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_domain
                                                                                            
                                                                                            	Unauthenticated Domain Name
                                                                                            	**type**\:  :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                            
                                                                                            .. attribute:: unauth_domain_regex
                                                                                            
                                                                                            	Unauthenticated Domain Name RegEx
                                                                                            	**type**\:  :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: vendor_id
                                                                                            
                                                                                            	Vendor ID
                                                                                            	**type**\:  :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                            
                                                                                            .. attribute:: vendor_id_regex
                                                                                            
                                                                                            	Vendor ID RegEx
                                                                                            	**type**\:  :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                            
                                                                                            .. attribute:: access_interface
                                                                                            
                                                                                            	Access interface
                                                                                            	**type**\:  :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                            
                                                                                            .. attribute:: input_interface
                                                                                            
                                                                                            	Input interface
                                                                                            	**type**\:  :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                            
                                                                                            .. attribute:: input_intfhdl
                                                                                            
                                                                                            	Input interface handle
                                                                                            	**type**\:  :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                            
                                                                                            .. attribute:: ethertype
                                                                                            
                                                                                            	Ethernet type
                                                                                            	**type**\:  :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                            
                                                                                            .. attribute:: flow_key_data
                                                                                            
                                                                                            	Flow key structure
                                                                                            	**type**\:  :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id
                                                                                            
                                                                                            	Dhcp Client ID
                                                                                            	**type**\:  :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id_regex
                                                                                            
                                                                                            	Dhcp Client ID RegEx
                                                                                            	**type**\:  :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                            
                                                                                            .. attribute:: circuit_id
                                                                                            
                                                                                            	Circuit ID
                                                                                            	**type**\:  :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                            
                                                                                            .. attribute:: circuit_id_regex
                                                                                            
                                                                                            	Circuit ID RegEx
                                                                                            	**type**\:  :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                            
                                                                                            .. attribute:: remote_id
                                                                                            
                                                                                            	Remote ID
                                                                                            	**type**\:  :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                            
                                                                                            .. attribute:: remote_id_regex
                                                                                            
                                                                                            	Remote ID RegEx
                                                                                            	**type**\:  :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                            
                                                                                            .. attribute:: src_port
                                                                                            
                                                                                            	Source port
                                                                                            	**type**\:  :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                            
                                                                                            .. attribute:: dst_port
                                                                                            
                                                                                            	Destination port
                                                                                            	**type**\:  :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	type
                                                                                            	**type**\:  :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                            
                                                                                            .. attribute:: mpls_top_eos
                                                                                            
                                                                                            	MPLS Topmost EOS
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: fragment_type
                                                                                            
                                                                                            	Fragment type
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: authen_status
                                                                                            
                                                                                            	Authentication Status
                                                                                            	**type**\:  :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                            
                                                                                            .. attribute:: mlp_negotiated
                                                                                            
                                                                                            	MLP Negotiated
                                                                                            	**type**\:  :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                                self.yang_name = "match-data"
                                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("ipv4-dscp", ("ipv4_dscp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp)), ("ipv6-dscp", ("ipv6_dscp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp)), ("dscp", ("dscp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp)), ("ipv4-prec", ("ipv4_prec", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec)), ("ipv6-prec", ("ipv6_prec", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec)), ("prec", ("prec", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec)), ("discard-class", ("discard_class", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass)), ("qos-group", ("qos_group", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup)), ("traffic-class", ("traffic_class", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass)), ("proto", ("proto", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto)), ("icmp-v4", ("icmp_v4", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4)), ("icmp-v6", ("icmp_v6", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6)), ("ipv4-packet-len", ("ipv4_packet_len", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen)), ("ipv6-packet-len", ("ipv6_packet_len", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen)), ("packet-len", ("packet_len", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen)), ("flow-tag", ("flow_tag", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag)), ("tcp-flag", ("tcp_flag", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag)), ("icmpv4-type", ("icmpv4_type", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type)), ("icmpv4-code", ("icmpv4_code", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code)), ("icmpv6-type", ("icmpv6_type", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type)), ("icmpv6-code", ("icmpv6_code", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code)), ("mpls-exp", ("mpls_exp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp)), ("mpls-exp-imp", ("mpls_exp_imp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp)), ("mpls-disp-ipv4-acl", ("mpls_disp_ipv4_acl", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl)), ("mpls-disp-ipv6-acl", ("mpls_disp_ipv6_acl", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl)), ("mpls-top-label", ("mpls_top_label", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel)), ("cos", ("cos", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos)), ("cos-inr", ("cos_inr", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr)), ("dei", ("dei", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei)), ("dei-inr", ("dei_inr", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr)), ("vlan", ("vlan", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan)), ("vlan-inr", ("vlan_inr", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)), ("fr-dlci", ("fr_dlci", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci)), ("src-mac", ("src_mac", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac)), ("dst-mac", ("dst_mac", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac)), ("atm-clp", ("atm_clp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp)), ("fr-de", ("fr_de", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe)), ("ipv4-acl", ("ipv4_acl", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl)), ("ipv6-acl", ("ipv6_acl", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl)), ("ether-service-acl", ("ether_service_acl", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl)), ("avail-id", ("avail_id", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId)), ("media-type", ("media_type", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType)), ("subs-protocol", ("subs_protocol", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol)), ("dnis", ("dnis", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis)), ("dnis-regex", ("dnis_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex)), ("domain", ("domain", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain)), ("domain-regex", ("domain_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex)), ("nas-port", ("nas_port", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort)), ("service-name", ("service_name", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName)), ("service-name-regex", ("service_name_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex)), ("src-addr-ipv4", ("src_addr_ipv4", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4)), ("dst-addr-ipv4", ("dst_addr_ipv4", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4)), ("src-addr-ipv6", ("src_addr_ipv6", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6)), ("dst-addr-ipv6", ("dst_addr_ipv6", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6)), ("src-addr-mac", ("src_addr_mac", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac)), ("timer", ("timer", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer)), ("timer-regexp", ("timer_regexp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp)), ("tunnel-name", ("tunnel_name", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName)), ("tunnel-name-regex", ("tunnel_name_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex)), ("user-name", ("user_name", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName)), ("user-name-regex", ("user_name_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex)), ("auth-username", ("auth_username", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername)), ("auth-username-regex", ("auth_username_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex)), ("unauth-username", ("unauth_username", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername)), ("unauth-username-regex", ("unauth_username_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex)), ("auth-domain", ("auth_domain", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain)), ("auth-domain-regex", ("auth_domain_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex)), ("unauth-domain", ("unauth_domain", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain)), ("unauth-domain-regex", ("unauth_domain_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex)), ("vendor-id", ("vendor_id", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId)), ("vendor-id-regex", ("vendor_id_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex)), ("access-interface", ("access_interface", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface)), ("input-interface", ("input_interface", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface)), ("input-intfhdl", ("input_intfhdl", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl)), ("ethertype", ("ethertype", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype)), ("flow-key-data", ("flow_key_data", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData)), ("dhcp-client-id", ("dhcp_client_id", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId)), ("dhcp-client-id-regex", ("dhcp_client_id_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex)), ("circuit-id", ("circuit_id", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId)), ("circuit-id-regex", ("circuit_id_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex)), ("remote-id", ("remote_id", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId)), ("remote-id-regex", ("remote_id_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex)), ("src-port", ("src_port", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort)), ("dst-port", ("dst_port", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort))])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchTypeEn', '')])),
                                                                                                    ('mpls_top_eos', (YLeaf(YType.uint8, 'mpls-top-eos'), ['int'])),
                                                                                                    ('fragment_type', (YLeaf(YType.uint8, 'fragment-type'), ['int'])),
                                                                                                    ('authen_status', (YLeaf(YType.enumeration, 'authen-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchAuthenStatusEn', '')])),
                                                                                                    ('mlp_negotiated', (YLeaf(YType.enumeration, 'mlp-negotiated'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchMlpNegotiatedEn', '')])),
                                                                                                ])
                                                                                                self.type = None
                                                                                                self.mpls_top_eos = None
                                                                                                self.fragment_type = None
                                                                                                self.authen_status = None
                                                                                                self.mlp_negotiated = None

                                                                                                self.ipv4_dscp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                                self.ipv4_dscp.parent = self
                                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"

                                                                                                self.ipv6_dscp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                                self.ipv6_dscp.parent = self
                                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"

                                                                                                self.dscp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                                self.dscp.parent = self
                                                                                                self._children_name_map["dscp"] = "dscp"

                                                                                                self.ipv4_prec = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                                self.ipv4_prec.parent = self
                                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"

                                                                                                self.ipv6_prec = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                                self.ipv6_prec.parent = self
                                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"

                                                                                                self.prec = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                                self.prec.parent = self
                                                                                                self._children_name_map["prec"] = "prec"

                                                                                                self.discard_class = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                                self.discard_class.parent = self
                                                                                                self._children_name_map["discard_class"] = "discard-class"

                                                                                                self.qos_group = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                                self.qos_group.parent = self
                                                                                                self._children_name_map["qos_group"] = "qos-group"

                                                                                                self.traffic_class = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                                self.traffic_class.parent = self
                                                                                                self._children_name_map["traffic_class"] = "traffic-class"

                                                                                                self.proto = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                                self.proto.parent = self
                                                                                                self._children_name_map["proto"] = "proto"

                                                                                                self.icmp_v4 = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                                self.icmp_v4.parent = self
                                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"

                                                                                                self.icmp_v6 = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                                self.icmp_v6.parent = self
                                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"

                                                                                                self.ipv4_packet_len = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                                self.ipv4_packet_len.parent = self
                                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"

                                                                                                self.ipv6_packet_len = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                                self.ipv6_packet_len.parent = self
                                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"

                                                                                                self.packet_len = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                                self.packet_len.parent = self
                                                                                                self._children_name_map["packet_len"] = "packet-len"

                                                                                                self.flow_tag = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                                self.flow_tag.parent = self
                                                                                                self._children_name_map["flow_tag"] = "flow-tag"

                                                                                                self.tcp_flag = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                                self.tcp_flag.parent = self
                                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"

                                                                                                self.icmpv4_type = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                                self.icmpv4_type.parent = self
                                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"

                                                                                                self.icmpv4_code = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                                self.icmpv4_code.parent = self
                                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"

                                                                                                self.icmpv6_type = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                                self.icmpv6_type.parent = self
                                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"

                                                                                                self.icmpv6_code = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                                self.icmpv6_code.parent = self
                                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"

                                                                                                self.mpls_exp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                                self.mpls_exp.parent = self
                                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"

                                                                                                self.mpls_exp_imp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                                self.mpls_exp_imp.parent = self
                                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"

                                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"

                                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"

                                                                                                self.mpls_top_label = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                                self.mpls_top_label.parent = self
                                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"

                                                                                                self.cos = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                                self.cos.parent = self
                                                                                                self._children_name_map["cos"] = "cos"

                                                                                                self.cos_inr = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                                self.cos_inr.parent = self
                                                                                                self._children_name_map["cos_inr"] = "cos-inr"

                                                                                                self.dei = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                                self.dei.parent = self
                                                                                                self._children_name_map["dei"] = "dei"

                                                                                                self.dei_inr = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                                self.dei_inr.parent = self
                                                                                                self._children_name_map["dei_inr"] = "dei-inr"

                                                                                                self.vlan = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                                self.vlan.parent = self
                                                                                                self._children_name_map["vlan"] = "vlan"

                                                                                                self.vlan_inr = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                                self.vlan_inr.parent = self
                                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"

                                                                                                self.fr_dlci = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                                self.fr_dlci.parent = self
                                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"

                                                                                                self.src_mac = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                                self.src_mac.parent = self
                                                                                                self._children_name_map["src_mac"] = "src-mac"

                                                                                                self.dst_mac = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                                self.dst_mac.parent = self
                                                                                                self._children_name_map["dst_mac"] = "dst-mac"

                                                                                                self.atm_clp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                                self.atm_clp.parent = self
                                                                                                self._children_name_map["atm_clp"] = "atm-clp"

                                                                                                self.fr_de = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                                self.fr_de.parent = self
                                                                                                self._children_name_map["fr_de"] = "fr-de"

                                                                                                self.ipv4_acl = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                                self.ipv4_acl.parent = self
                                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"

                                                                                                self.ipv6_acl = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                                self.ipv6_acl.parent = self
                                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"

                                                                                                self.ether_service_acl = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                                self.ether_service_acl.parent = self
                                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"

                                                                                                self.avail_id = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                                self.avail_id.parent = self
                                                                                                self._children_name_map["avail_id"] = "avail-id"

                                                                                                self.media_type = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                                self.media_type.parent = self
                                                                                                self._children_name_map["media_type"] = "media-type"

                                                                                                self.subs_protocol = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                                self.subs_protocol.parent = self
                                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"

                                                                                                self.dnis = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                                self.dnis.parent = self
                                                                                                self._children_name_map["dnis"] = "dnis"

                                                                                                self.dnis_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                                self.dnis_regex.parent = self
                                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"

                                                                                                self.domain = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                                self.domain.parent = self
                                                                                                self._children_name_map["domain"] = "domain"

                                                                                                self.domain_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                                self.domain_regex.parent = self
                                                                                                self._children_name_map["domain_regex"] = "domain-regex"

                                                                                                self.nas_port = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                                self.nas_port.parent = self
                                                                                                self._children_name_map["nas_port"] = "nas-port"

                                                                                                self.service_name = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                                self.service_name.parent = self
                                                                                                self._children_name_map["service_name"] = "service-name"

                                                                                                self.service_name_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                                self.service_name_regex.parent = self
                                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"

                                                                                                self.src_addr_ipv4 = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                                self.src_addr_ipv4.parent = self
                                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"

                                                                                                self.dst_addr_ipv4 = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                                self.dst_addr_ipv4.parent = self
                                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"

                                                                                                self.src_addr_ipv6 = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                                self.src_addr_ipv6.parent = self
                                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"

                                                                                                self.dst_addr_ipv6 = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                                self.dst_addr_ipv6.parent = self
                                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"

                                                                                                self.src_addr_mac = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                                self.src_addr_mac.parent = self
                                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"

                                                                                                self.timer = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                                self.timer.parent = self
                                                                                                self._children_name_map["timer"] = "timer"

                                                                                                self.timer_regexp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                                self.timer_regexp.parent = self
                                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"

                                                                                                self.tunnel_name = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                                self.tunnel_name.parent = self
                                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"

                                                                                                self.tunnel_name_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                                self.tunnel_name_regex.parent = self
                                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"

                                                                                                self.user_name = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                                self.user_name.parent = self
                                                                                                self._children_name_map["user_name"] = "user-name"

                                                                                                self.user_name_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                                self.user_name_regex.parent = self
                                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"

                                                                                                self.auth_username = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                                self.auth_username.parent = self
                                                                                                self._children_name_map["auth_username"] = "auth-username"

                                                                                                self.auth_username_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                                self.auth_username_regex.parent = self
                                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"

                                                                                                self.unauth_username = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                                self.unauth_username.parent = self
                                                                                                self._children_name_map["unauth_username"] = "unauth-username"

                                                                                                self.unauth_username_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                                self.unauth_username_regex.parent = self
                                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"

                                                                                                self.auth_domain = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                                self.auth_domain.parent = self
                                                                                                self._children_name_map["auth_domain"] = "auth-domain"

                                                                                                self.auth_domain_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                                self.auth_domain_regex.parent = self
                                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"

                                                                                                self.unauth_domain = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                                self.unauth_domain.parent = self
                                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"

                                                                                                self.unauth_domain_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                                self.unauth_domain_regex.parent = self
                                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"

                                                                                                self.vendor_id = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                                self.vendor_id.parent = self
                                                                                                self._children_name_map["vendor_id"] = "vendor-id"

                                                                                                self.vendor_id_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                                self.vendor_id_regex.parent = self
                                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"

                                                                                                self.access_interface = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                                self.access_interface.parent = self
                                                                                                self._children_name_map["access_interface"] = "access-interface"

                                                                                                self.input_interface = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                                self.input_interface.parent = self
                                                                                                self._children_name_map["input_interface"] = "input-interface"

                                                                                                self.input_intfhdl = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                                self.input_intfhdl.parent = self
                                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"

                                                                                                self.ethertype = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                                self.ethertype.parent = self
                                                                                                self._children_name_map["ethertype"] = "ethertype"

                                                                                                self.flow_key_data = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                                self.flow_key_data.parent = self
                                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"

                                                                                                self.dhcp_client_id = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                                self.dhcp_client_id.parent = self
                                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"

                                                                                                self.dhcp_client_id_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                                self.dhcp_client_id_regex.parent = self
                                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"

                                                                                                self.circuit_id = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                                self.circuit_id.parent = self
                                                                                                self._children_name_map["circuit_id"] = "circuit-id"

                                                                                                self.circuit_id_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                                self.circuit_id_regex.parent = self
                                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"

                                                                                                self.remote_id = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                                self.remote_id.parent = self
                                                                                                self._children_name_map["remote_id"] = "remote-id"

                                                                                                self.remote_id_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                                self.remote_id_regex.parent = self
                                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"

                                                                                                self.src_port = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                                self.src_port.parent = self
                                                                                                self._children_name_map["src_port"] = "src-port"

                                                                                                self.dst_port = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                                self.dst_port.parent = self
                                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                                self._segment_path = lambda: "match-data"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, ['type', 'mpls_top_eos', 'fragment_type', 'authen_status', 'mlp_negotiated'], name, value)


                                                                                            class Ipv4Dscp(Entity):
                                                                                                """
                                                                                                IPv4 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv4-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv6Dscp(Entity):
                                                                                                """
                                                                                                IPv6 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv6-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Dscp(Entity):
                                                                                                """
                                                                                                Match DSCP range array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                    self.yang_name = "dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv4Prec(Entity):
                                                                                                """
                                                                                                IPv4 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                    self.yang_name = "ipv4-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "ipv4-prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                            class Ipv6Prec(Entity):
                                                                                                """
                                                                                                IPv6 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                    self.yang_name = "ipv6-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "ipv6-prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                            class Prec(Entity):
                                                                                                """
                                                                                                Match Precedence array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                    self.yang_name = "prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                            class DiscardClass(Entity):
                                                                                                """
                                                                                                Match Discard Class array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                    self.yang_name = "discard-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "discard-class"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                            class QosGroup(Entity):
                                                                                                """
                                                                                                Match QoS group array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                    self.yang_name = "qos-group"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "qos-group"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "qos-group"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class TrafficClass(Entity):
                                                                                                """
                                                                                                Match Traffic class array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                    self.yang_name = "traffic-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "traffic-class"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "traffic-class"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Proto(Entity):
                                                                                                """
                                                                                                Match Protocol array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                    self.yang_name = "proto"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "proto"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "proto"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class IcmpV4(Entity):
                                                                                                """
                                                                                                Match ICMPV4 Protocol
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                    self.yang_name = "icmp-v4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                    ])
                                                                                                    self.type = None
                                                                                                    self.code = None
                                                                                                    self._segment_path = lambda: "icmp-v4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['type', 'code'], name, value)


                                                                                            class IcmpV6(Entity):
                                                                                                """
                                                                                                Match ICMPV6 Protocol array
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                    self.yang_name = "icmp-v6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                    ])
                                                                                                    self.type = None
                                                                                                    self.code = None
                                                                                                    self._segment_path = lambda: "icmp-v6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['type', 'code'], name, value)


                                                                                            class Ipv4PacketLen(Entity):
                                                                                                """
                                                                                                IPv4 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv6PacketLen(Entity):
                                                                                                """
                                                                                                IPv6 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class PacketLen(Entity):
                                                                                                """
                                                                                                Match packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                    self.yang_name = "packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FlowTag(Entity):
                                                                                                """
                                                                                                Match flow\-tag array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                    self.yang_name = "flow-tag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "flow-tag"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "flow-tag"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class TcpFlag(Entity):
                                                                                                """
                                                                                                Match tcp flag value
                                                                                                
                                                                                                .. attribute:: value
                                                                                                
                                                                                                	Value of TCP flag
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: match_any
                                                                                                
                                                                                                	Match any TCP flag bit
                                                                                                	**type**\: bool
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                    self.yang_name = "tcp-flag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                                        ('match_any', (YLeaf(YType.boolean, 'match-any'), ['bool'])),
                                                                                                    ])
                                                                                                    self.value = None
                                                                                                    self.match_any = None
                                                                                                    self._segment_path = lambda: "tcp-flag"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['value', 'match_any'], name, value)


                                                                                            class Icmpv4Type(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                    self.yang_name = "icmpv4-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv4Code(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                    self.yang_name = "icmpv4-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-code"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv6Type(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                    self.yang_name = "icmpv6-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv6Code(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                    self.yang_name = "icmpv6-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-code"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class MplsExp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental topmost array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "mpls-exp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                            class MplsExpImp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental imposition array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "mpls-exp-imp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                            class MplsDispIpv4Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                            class MplsDispIpv6Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                            class MplsTopLabel(Entity):
                                                                                                """
                                                                                                MPLS Topmost LABEL
                                                                                                
                                                                                                .. attribute:: uint32_rng_array
                                                                                                
                                                                                                	uint32 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                    self.yang_name = "mpls-top-label"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint32_rng_array", ("uint32_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint32_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "mpls-top-label"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                                class Uint32RngArray(Entity):
                                                                                                    """
                                                                                                    uint32 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                        self.yang_name = "uint32_rng_array"
                                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint32, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint32, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint32_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['min', 'max'], name, value)


                                                                                            class Cos(Entity):
                                                                                                """
                                                                                                Match CoS array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                    self.yang_name = "cos"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "cos"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                            class CosInr(Entity):
                                                                                                """
                                                                                                Match inner header CoS
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                    self.yang_name = "cos-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "cos-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                            class Dei(Entity):
                                                                                                """
                                                                                                Match DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                    self.yang_name = "dei"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                    ])
                                                                                                    self.bit_value = None
                                                                                                    self._segment_path = lambda: "dei"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                            class DeiInr(Entity):
                                                                                                """
                                                                                                Match inner DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                    self.yang_name = "dei-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                    ])
                                                                                                    self.bit_value = None
                                                                                                    self._segment_path = lambda: "dei-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                            class Vlan(Entity):
                                                                                                """
                                                                                                Match VLAN array
                                                                                                
                                                                                                .. attribute:: vlan_id_array
                                                                                                
                                                                                                	vlan id array
                                                                                                	**type**\: list of  		 :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                    self.yang_name = "vlan"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("vlan-id-array", ("vlan_id_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.vlan_id_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                                class VlanIdArray(Entity):
                                                                                                    """
                                                                                                    vlan id array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	VLAN mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                        self.yang_name = "vlan-id-array"
                                                                                                        self.yang_parent_name = "vlan"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ('mask', (YLeaf(YType.uint16, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "vlan-id-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['min', 'max', 'mask'], name, value)


                                                                                            class VlanInr(Entity):
                                                                                                """
                                                                                                Match inner header VLAN range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                    self.yang_name = "vlan-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FrDlci(Entity):
                                                                                                """
                                                                                                Match FR DLCI range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                    self.yang_name = "fr-dlci"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "fr-dlci"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class SrcMac(Entity):
                                                                                                """
                                                                                                Match Source MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                    self.yang_name = "src-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.mac_addr = []
                                                                                                    self.mask = []
                                                                                                    self._segment_path = lambda: "src-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                            class DstMac(Entity):
                                                                                                """
                                                                                                Match Destination MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                    self.yang_name = "dst-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.mac_addr = []
                                                                                                    self.mask = []
                                                                                                    self._segment_path = lambda: "dst-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                            class AtmClp(Entity):
                                                                                                """
                                                                                                Match ATM CLP level
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                    self.yang_name = "atm-clp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "atm-clp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                            class FrDe(Entity):
                                                                                                """
                                                                                                Match FR DE value
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                    self.yang_name = "fr-de"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "fr-de"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                            class Ipv4Acl(Entity):
                                                                                                """
                                                                                                IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                    self.yang_name = "ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ipv4-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                            class Ipv6Acl(Entity):
                                                                                                """
                                                                                                IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                    self.yang_name = "ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ipv6-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                            class EtherServiceAcl(Entity):
                                                                                                """
                                                                                                Ethernet\-Services Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                    self.yang_name = "ether-service-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ether-service-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                            class AvailId(Entity):
                                                                                                """
                                                                                                Available Identifiers
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                    self.yang_name = "avail-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "avail-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                            class MediaType(Entity):
                                                                                                """
                                                                                                Media Type
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                    self.yang_name = "media-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "media-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                            class SubsProtocol(Entity):
                                                                                                """
                                                                                                Protocol
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                    self.yang_name = "subs-protocol"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "subs-protocol"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                            class Dnis(Entity):
                                                                                                """
                                                                                                DNIS
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                    self.yang_name = "dnis"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dnis"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                            class DnisRegex(Entity):
                                                                                                """
                                                                                                DNIS Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                    self.yang_name = "dnis-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dnis-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                            class Domain(Entity):
                                                                                                """
                                                                                                Domain Name
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                    self.yang_name = "domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                        ])
                                                                                                        self.domain_name = None
                                                                                                        self.format_name = None
                                                                                                        self._segment_path = lambda: "domain-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class DomainRegex(Entity):
                                                                                                """
                                                                                                Domain Regular Expression
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                    self.yang_name = "domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain-regex"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                        ])
                                                                                                        self.domain_name = None
                                                                                                        self.format_name = None
                                                                                                        self._segment_path = lambda: "domain-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class NasPort(Entity):
                                                                                                """
                                                                                                NAS Port
                                                                                                
                                                                                                .. attribute:: nas_port_array
                                                                                                
                                                                                                	nas port array
                                                                                                	**type**\: list of  		 :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                    self.yang_name = "nas-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("nas-port-array", ("nas_port_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.nas_port_array = YList(self)
                                                                                                    self._segment_path = lambda: "nas-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                                class NasPortArray(Entity):
                                                                                                    """
                                                                                                    nas port array
                                                                                                    
                                                                                                    .. attribute:: sub_id
                                                                                                    
                                                                                                    	sub id
                                                                                                    	**type**\:  :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                    
                                                                                                    .. attribute:: operator
                                                                                                    
                                                                                                    	operator
                                                                                                    	**type**\:  :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	value
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                        self.yang_name = "nas-port-array"
                                                                                                        self.yang_parent_name = "nas-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('sub_id', (YLeaf(YType.enumeration, 'sub-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchNasPortSubIdEn', '')])),
                                                                                                            ('operator', (YLeaf(YType.enumeration, 'operator'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchLogicalOperatorEn', '')])),
                                                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                                        ])
                                                                                                        self.sub_id = None
                                                                                                        self.operator = None
                                                                                                        self.value = None
                                                                                                        self._segment_path = lambda: "nas-port-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['sub_id', 'operator', 'value'], name, value)


                                                                                            class ServiceName(Entity):
                                                                                                """
                                                                                                Service Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                    self.yang_name = "service-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "service-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                            class ServiceNameRegex(Entity):
                                                                                                """
                                                                                                Service Name Regular Exp
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                    self.yang_name = "service-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "service-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                            class SrcAddrIpv4(Entity):
                                                                                                """
                                                                                                Source Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class DstAddrIpv4(Entity):
                                                                                                """
                                                                                                Destination Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class SrcAddrIpv6(Entity):
                                                                                                """
                                                                                                Source Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class DstAddrIpv6(Entity):
                                                                                                """
                                                                                                Destination Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class SrcAddrMac(Entity):
                                                                                                """
                                                                                                Source Address MAC
                                                                                                
                                                                                                .. attribute:: mac_addr_array
                                                                                                
                                                                                                	mac addr array
                                                                                                	**type**\: list of  		 :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                    self.yang_name = "src-addr-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("mac-addr-array", ("mac_addr_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.mac_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                                class MacAddrArray(Entity):
                                                                                                    """
                                                                                                    mac addr array
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                        self.yang_name = "mac-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                            ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.mac_addr = []
                                                                                                        self.mask = []
                                                                                                        self._segment_path = lambda: "mac-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                            class Timer(Entity):
                                                                                                """
                                                                                                Timer
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                    self.yang_name = "timer"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "timer"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                            class TimerRegexp(Entity):
                                                                                                """
                                                                                                Timer Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                    self.yang_name = "timer-regexp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "timer-regexp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                            class TunnelName(Entity):
                                                                                                """
                                                                                                Tunnel Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                    self.yang_name = "tunnel-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "tunnel-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                            class TunnelNameRegex(Entity):
                                                                                                """
                                                                                                Tunnel Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "tunnel-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                            class UserName(Entity):
                                                                                                """
                                                                                                User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                    self.yang_name = "user-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "user-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                            class UserNameRegex(Entity):
                                                                                                """
                                                                                                User Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                    self.yang_name = "user-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "user-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                            class AuthUsername(Entity):
                                                                                                """
                                                                                                Authenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                    self.yang_name = "auth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-username"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                            class AuthUsernameRegex(Entity):
                                                                                                """
                                                                                                Authenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "auth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-username-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                            class UnauthUsername(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                    self.yang_name = "unauth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-username"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                            class UnauthUsernameRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-username-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                            class AuthDomain(Entity):
                                                                                                """
                                                                                                Authenticated domain name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                    self.yang_name = "auth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                            class AuthDomainRegex(Entity):
                                                                                                """
                                                                                                Authenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "auth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                            class UnauthDomain(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                    self.yang_name = "unauth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                            class UnauthDomainRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                            class VendorId(Entity):
                                                                                                """
                                                                                                Vendor ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                    self.yang_name = "vendor-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "vendor-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                            class VendorIdRegex(Entity):
                                                                                                """
                                                                                                Vendor ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                    self.yang_name = "vendor-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "vendor-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                            class AccessInterface(Entity):
                                                                                                """
                                                                                                Access interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                    self.yang_name = "access-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "access-interface"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                            class InputInterface(Entity):
                                                                                                """
                                                                                                Input interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                    self.yang_name = "input-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "input-interface"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                            class InputIntfhdl(Entity):
                                                                                                """
                                                                                                Input interface handle
                                                                                                
                                                                                                .. attribute:: uint64_array
                                                                                                
                                                                                                	uint64 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..18446744073709551615
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                    self.yang_name = "input-intfhdl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint64_array', (YLeafList(YType.uint64, 'uint64_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint64_array = []
                                                                                                    self._segment_path = lambda: "input-intfhdl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                            class Ethertype(Entity):
                                                                                                """
                                                                                                Ethernet type
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                    self.yang_name = "ethertype"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ethertype"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ethertype"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FlowKeyData(Entity):
                                                                                                """
                                                                                                Flow key structure
                                                                                                
                                                                                                .. attribute:: flow_keys
                                                                                                
                                                                                                	flow keys
                                                                                                	**type**\:  :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                                
                                                                                                .. attribute:: max_count
                                                                                                
                                                                                                	Maximum count of flows
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: idle_timeout
                                                                                                
                                                                                                	Idle timeout of flows (in seconds)
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                	**units**\: second
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                    self.yang_name = "flow-key-data"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("flow-keys", ("flow_keys", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys))])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('max_count', (YLeaf(YType.uint16, 'max-count'), ['int'])),
                                                                                                        ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                                                    ])
                                                                                                    self.max_count = None
                                                                                                    self.idle_timeout = None

                                                                                                    self.flow_keys = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                    self.flow_keys.parent = self
                                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                    self._segment_path = lambda: "flow-key-data"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['max_count', 'idle_timeout'], name, value)


                                                                                                class FlowKeys(Entity):
                                                                                                    """
                                                                                                    flow keys
                                                                                                    
                                                                                                    .. attribute:: keys
                                                                                                    
                                                                                                    	keys
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                    
                                                                                                    .. attribute:: num
                                                                                                    
                                                                                                    	num
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                        self.yang_name = "flow-keys"
                                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('keys', (YLeaf(YType.str, 'keys'), ['str'])),
                                                                                                            ('num', (YLeaf(YType.uint8, 'num'), ['int'])),
                                                                                                        ])
                                                                                                        self.keys = None
                                                                                                        self.num = None
                                                                                                        self._segment_path = lambda: "flow-keys"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                            class DhcpClientId(Entity):
                                                                                                """
                                                                                                Dhcp Client ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dhcp-client-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                            class DhcpClientIdRegex(Entity):
                                                                                                """
                                                                                                Dhcp Client ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                            class CircuitId(Entity):
                                                                                                """
                                                                                                Circuit ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                    self.yang_name = "circuit-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "circuit-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                            class CircuitIdRegex(Entity):
                                                                                                """
                                                                                                Circuit ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                    self.yang_name = "circuit-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "circuit-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                            class RemoteId(Entity):
                                                                                                """
                                                                                                Remote ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                    self.yang_name = "remote-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "remote-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                            class RemoteIdRegex(Entity):
                                                                                                """
                                                                                                Remote ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                    self.yang_name = "remote-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "remote-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                            class SrcPort(Entity):
                                                                                                """
                                                                                                Source port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                    self.yang_name = "src-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "src-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class DstPort(Entity):
                                                                                                """
                                                                                                Destination port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                    self.yang_name = "dst-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "dst-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                        class ExcdclassP(Entity):
                                                                            """
                                                                            excdclass p
                                                                            
                                                                            .. attribute:: class_map_bg
                                                                            
                                                                            	class map bg
                                                                            	**type**\: list of  		 :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP, self).__init__()

                                                                                self.yang_name = "excdclass-p"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("class-map-bg", ("class_map_bg", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg))])
                                                                                self._leafs = OrderedDict()

                                                                                self.class_map_bg = YList(self)
                                                                                self._segment_path = lambda: "excdclass-p"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP, [], name, value)


                                                                            class ClassMapBg(Entity):
                                                                                """
                                                                                class map bg
                                                                                
                                                                                .. attribute:: match_infop
                                                                                
                                                                                	Pointer to the first Match info
                                                                                	**type**\:  :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop>`
                                                                                
                                                                                .. attribute:: name
                                                                                
                                                                                	Name of the class\-map
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..65
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Class\-Map Type QoS/PBR/Netflow/..
                                                                                	**type**\:  :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                                                
                                                                                .. attribute:: mode
                                                                                
                                                                                	Class\-Map Mode Match any/Match all
                                                                                	**type**\:  :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                                
                                                                                .. attribute:: description
                                                                                
                                                                                	description
                                                                                	**type**\: str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg, self).__init__()

                                                                                    self.yang_name = "class-map-bg"
                                                                                    self.yang_parent_name = "excdclass-p"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("match-infop", ("match_infop", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapTypeEn', '')])),
                                                                                        ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapModeEn', '')])),
                                                                                        ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                    ])
                                                                                    self.name = None
                                                                                    self.type = None
                                                                                    self.mode = None
                                                                                    self.description = None

                                                                                    self.match_infop = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop()
                                                                                    self.match_infop.parent = self
                                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                                    self._segment_path = lambda: "class-map-bg"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg, ['name', 'type', 'mode', 'description'], name, value)


                                                                                class MatchInfop(Entity):
                                                                                    """
                                                                                    Pointer to the first Match info
                                                                                    
                                                                                    .. attribute:: class_match_info_st
                                                                                    
                                                                                    	class match info st
                                                                                    	**type**\: list of  		 :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop, self).__init__()

                                                                                        self.yang_name = "match-infop"
                                                                                        self.yang_parent_name = "class-map-bg"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("class-match-info-st", ("class_match_info_st", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.class_match_info_st = YList(self)
                                                                                        self._segment_path = lambda: "match-infop"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop, [], name, value)


                                                                                    class ClassMatchInfoSt(Entity):
                                                                                        """
                                                                                        class match info st
                                                                                        
                                                                                        .. attribute:: match_data
                                                                                        
                                                                                        	Match criteria
                                                                                        	**type**\:  :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                        
                                                                                        .. attribute:: flags
                                                                                        
                                                                                        	Flags
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                            self.yang_name = "class-match-info-st"
                                                                                            self.yang_parent_name = "match-infop"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("match-data", ("match_data", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData))])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                            ])
                                                                                            self.flags = None

                                                                                            self.match_data = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                            self.match_data.parent = self
                                                                                            self._children_name_map["match_data"] = "match-data"
                                                                                            self._segment_path = lambda: "class-match-info-st"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                        class MatchData(Entity):
                                                                                            """
                                                                                            Match criteria
                                                                                            
                                                                                            .. attribute:: ipv4_dscp
                                                                                            
                                                                                            	IPv4 DSCP
                                                                                            	**type**\:  :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv6_dscp
                                                                                            
                                                                                            	IPv6 DSCP
                                                                                            	**type**\:  :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                            
                                                                                            .. attribute:: dscp
                                                                                            
                                                                                            	Match DSCP range array
                                                                                            	**type**\:  :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv4_prec
                                                                                            
                                                                                            	IPv4 Precedence
                                                                                            	**type**\:  :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                            
                                                                                            .. attribute:: ipv6_prec
                                                                                            
                                                                                            	IPv6 Precedence
                                                                                            	**type**\:  :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                            
                                                                                            .. attribute:: prec
                                                                                            
                                                                                            	Match Precedence array
                                                                                            	**type**\:  :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                            
                                                                                            .. attribute:: discard_class
                                                                                            
                                                                                            	Match Discard Class array
                                                                                            	**type**\:  :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                            
                                                                                            .. attribute:: qos_group
                                                                                            
                                                                                            	Match QoS group array
                                                                                            	**type**\:  :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                            
                                                                                            .. attribute:: traffic_class
                                                                                            
                                                                                            	Match Traffic class array
                                                                                            	**type**\:  :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                            
                                                                                            .. attribute:: proto
                                                                                            
                                                                                            	Match Protocol array
                                                                                            	**type**\:  :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                            
                                                                                            .. attribute:: icmp_v4
                                                                                            
                                                                                            	Match ICMPV4 Protocol
                                                                                            	**type**\:  :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                            
                                                                                            .. attribute:: icmp_v6
                                                                                            
                                                                                            	Match ICMPV6 Protocol array
                                                                                            	**type**\:  :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                            
                                                                                            .. attribute:: ipv4_packet_len
                                                                                            
                                                                                            	IPv4 packet length array
                                                                                            	**type**\:  :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv6_packet_len
                                                                                            
                                                                                            	IPv6 packet length array
                                                                                            	**type**\:  :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                            
                                                                                            .. attribute:: packet_len
                                                                                            
                                                                                            	Match packet length array
                                                                                            	**type**\:  :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                            
                                                                                            .. attribute:: flow_tag
                                                                                            
                                                                                            	Match flow\-tag array
                                                                                            	**type**\:  :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                            
                                                                                            .. attribute:: tcp_flag
                                                                                            
                                                                                            	Match tcp flag value
                                                                                            	**type**\:  :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                            
                                                                                            .. attribute:: icmpv4_type
                                                                                            
                                                                                            	Match ipv4 icmp type
                                                                                            	**type**\:  :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                            
                                                                                            .. attribute:: icmpv4_code
                                                                                            
                                                                                            	Match ipv4 icmp code
                                                                                            	**type**\:  :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                            
                                                                                            .. attribute:: icmpv6_type
                                                                                            
                                                                                            	Match ipv6 icmp type
                                                                                            	**type**\:  :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                            
                                                                                            .. attribute:: icmpv6_code
                                                                                            
                                                                                            	Match ipv6 icmp code
                                                                                            	**type**\:  :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                            
                                                                                            .. attribute:: mpls_exp
                                                                                            
                                                                                            	Match MPLS experimental topmost array
                                                                                            	**type**\:  :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                            
                                                                                            .. attribute:: mpls_exp_imp
                                                                                            
                                                                                            	Match MPLS experimental imposition array
                                                                                            	**type**\:  :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                                            
                                                                                            	MPLS Disposition IPv4 Access\-list
                                                                                            	**type**\:  :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                                            
                                                                                            	MPLS Disposition IPv6 Access\-list
                                                                                            	**type**\:  :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_top_label
                                                                                            
                                                                                            	MPLS Topmost LABEL
                                                                                            	**type**\:  :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                            
                                                                                            .. attribute:: cos
                                                                                            
                                                                                            	Match CoS array
                                                                                            	**type**\:  :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                            
                                                                                            .. attribute:: cos_inr
                                                                                            
                                                                                            	Match inner header CoS
                                                                                            	**type**\:  :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                            
                                                                                            .. attribute:: dei
                                                                                            
                                                                                            	Match DEI Bit
                                                                                            	**type**\:  :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                            
                                                                                            .. attribute:: dei_inr
                                                                                            
                                                                                            	Match inner DEI Bit
                                                                                            	**type**\:  :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                            
                                                                                            .. attribute:: vlan
                                                                                            
                                                                                            	Match VLAN array
                                                                                            	**type**\:  :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                            
                                                                                            .. attribute:: vlan_inr
                                                                                            
                                                                                            	Match inner header VLAN range array
                                                                                            	**type**\:  :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                            
                                                                                            .. attribute:: fr_dlci
                                                                                            
                                                                                            	Match FR DLCI range array
                                                                                            	**type**\:  :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                            
                                                                                            .. attribute:: src_mac
                                                                                            
                                                                                            	Match Source MAC address
                                                                                            	**type**\:  :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                            
                                                                                            .. attribute:: dst_mac
                                                                                            
                                                                                            	Match Destination MAC address
                                                                                            	**type**\:  :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                            
                                                                                            .. attribute:: atm_clp
                                                                                            
                                                                                            	Match ATM CLP level
                                                                                            	**type**\:  :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                            
                                                                                            .. attribute:: fr_de
                                                                                            
                                                                                            	Match FR DE value
                                                                                            	**type**\:  :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                            
                                                                                            .. attribute:: ipv4_acl
                                                                                            
                                                                                            	IPv4 Access\-list
                                                                                            	**type**\:  :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                            
                                                                                            .. attribute:: ipv6_acl
                                                                                            
                                                                                            	IPv6 Access\-list
                                                                                            	**type**\:  :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                            
                                                                                            .. attribute:: ether_service_acl
                                                                                            
                                                                                            	Ethernet\-Services Access\-list
                                                                                            	**type**\:  :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                            
                                                                                            .. attribute:: avail_id
                                                                                            
                                                                                            	Available Identifiers
                                                                                            	**type**\:  :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                            
                                                                                            .. attribute:: media_type
                                                                                            
                                                                                            	Media Type
                                                                                            	**type**\:  :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                            
                                                                                            .. attribute:: subs_protocol
                                                                                            
                                                                                            	Protocol
                                                                                            	**type**\:  :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                            
                                                                                            .. attribute:: dnis
                                                                                            
                                                                                            	DNIS
                                                                                            	**type**\:  :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                            
                                                                                            .. attribute:: dnis_regex
                                                                                            
                                                                                            	DNIS Regular Expression
                                                                                            	**type**\:  :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                            
                                                                                            .. attribute:: domain
                                                                                            
                                                                                            	Domain Name
                                                                                            	**type**\:  :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                            
                                                                                            .. attribute:: domain_regex
                                                                                            
                                                                                            	Domain Regular Expression
                                                                                            	**type**\:  :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                            
                                                                                            .. attribute:: nas_port
                                                                                            
                                                                                            	NAS Port
                                                                                            	**type**\:  :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                            
                                                                                            .. attribute:: service_name
                                                                                            
                                                                                            	Service Name
                                                                                            	**type**\:  :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                            
                                                                                            .. attribute:: service_name_regex
                                                                                            
                                                                                            	Service Name Regular Exp
                                                                                            	**type**\:  :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv4
                                                                                            
                                                                                            	Source Address IPV4
                                                                                            	**type**\:  :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv4
                                                                                            
                                                                                            	Destination Address IPV4
                                                                                            	**type**\:  :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv6
                                                                                            
                                                                                            	Source Address IPV6
                                                                                            	**type**\:  :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv6
                                                                                            
                                                                                            	Destination Address IPV6
                                                                                            	**type**\:  :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: src_addr_mac
                                                                                            
                                                                                            	Source Address MAC
                                                                                            	**type**\:  :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                            
                                                                                            .. attribute:: timer
                                                                                            
                                                                                            	Timer
                                                                                            	**type**\:  :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                            
                                                                                            .. attribute:: timer_regexp
                                                                                            
                                                                                            	Timer Regular Expression
                                                                                            	**type**\:  :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                            
                                                                                            .. attribute:: tunnel_name
                                                                                            
                                                                                            	Tunnel Name
                                                                                            	**type**\:  :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                            
                                                                                            .. attribute:: tunnel_name_regex
                                                                                            
                                                                                            	Tunnel Name Regular Expression
                                                                                            	**type**\:  :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                            
                                                                                            .. attribute:: user_name
                                                                                            
                                                                                            	User Name
                                                                                            	**type**\:  :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                            
                                                                                            .. attribute:: user_name_regex
                                                                                            
                                                                                            	User Name Regular Expression
                                                                                            	**type**\:  :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                            
                                                                                            .. attribute:: auth_username
                                                                                            
                                                                                            	Authenticated User Name
                                                                                            	**type**\:  :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                            
                                                                                            .. attribute:: auth_username_regex
                                                                                            
                                                                                            	Authenticated User Name RegEx
                                                                                            	**type**\:  :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_username
                                                                                            
                                                                                            	Unauthenticated User Name
                                                                                            	**type**\:  :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                            
                                                                                            .. attribute:: unauth_username_regex
                                                                                            
                                                                                            	Unauthenticated User Name RegEx
                                                                                            	**type**\:  :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: auth_domain
                                                                                            
                                                                                            	Authenticated domain name
                                                                                            	**type**\:  :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                            
                                                                                            .. attribute:: auth_domain_regex
                                                                                            
                                                                                            	Authenticated Domain Name RegEx
                                                                                            	**type**\:  :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_domain
                                                                                            
                                                                                            	Unauthenticated Domain Name
                                                                                            	**type**\:  :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                            
                                                                                            .. attribute:: unauth_domain_regex
                                                                                            
                                                                                            	Unauthenticated Domain Name RegEx
                                                                                            	**type**\:  :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: vendor_id
                                                                                            
                                                                                            	Vendor ID
                                                                                            	**type**\:  :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                            
                                                                                            .. attribute:: vendor_id_regex
                                                                                            
                                                                                            	Vendor ID RegEx
                                                                                            	**type**\:  :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                            
                                                                                            .. attribute:: access_interface
                                                                                            
                                                                                            	Access interface
                                                                                            	**type**\:  :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                            
                                                                                            .. attribute:: input_interface
                                                                                            
                                                                                            	Input interface
                                                                                            	**type**\:  :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                            
                                                                                            .. attribute:: input_intfhdl
                                                                                            
                                                                                            	Input interface handle
                                                                                            	**type**\:  :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                            
                                                                                            .. attribute:: ethertype
                                                                                            
                                                                                            	Ethernet type
                                                                                            	**type**\:  :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                            
                                                                                            .. attribute:: flow_key_data
                                                                                            
                                                                                            	Flow key structure
                                                                                            	**type**\:  :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id
                                                                                            
                                                                                            	Dhcp Client ID
                                                                                            	**type**\:  :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id_regex
                                                                                            
                                                                                            	Dhcp Client ID RegEx
                                                                                            	**type**\:  :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                            
                                                                                            .. attribute:: circuit_id
                                                                                            
                                                                                            	Circuit ID
                                                                                            	**type**\:  :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                            
                                                                                            .. attribute:: circuit_id_regex
                                                                                            
                                                                                            	Circuit ID RegEx
                                                                                            	**type**\:  :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                            
                                                                                            .. attribute:: remote_id
                                                                                            
                                                                                            	Remote ID
                                                                                            	**type**\:  :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                            
                                                                                            .. attribute:: remote_id_regex
                                                                                            
                                                                                            	Remote ID RegEx
                                                                                            	**type**\:  :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                            
                                                                                            .. attribute:: src_port
                                                                                            
                                                                                            	Source port
                                                                                            	**type**\:  :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                            
                                                                                            .. attribute:: dst_port
                                                                                            
                                                                                            	Destination port
                                                                                            	**type**\:  :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	type
                                                                                            	**type**\:  :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                            
                                                                                            .. attribute:: mpls_top_eos
                                                                                            
                                                                                            	MPLS Topmost EOS
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: fragment_type
                                                                                            
                                                                                            	Fragment type
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: authen_status
                                                                                            
                                                                                            	Authentication Status
                                                                                            	**type**\:  :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                            
                                                                                            .. attribute:: mlp_negotiated
                                                                                            
                                                                                            	MLP Negotiated
                                                                                            	**type**\:  :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                                self.yang_name = "match-data"
                                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("ipv4-dscp", ("ipv4_dscp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp)), ("ipv6-dscp", ("ipv6_dscp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp)), ("dscp", ("dscp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp)), ("ipv4-prec", ("ipv4_prec", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec)), ("ipv6-prec", ("ipv6_prec", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec)), ("prec", ("prec", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec)), ("discard-class", ("discard_class", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass)), ("qos-group", ("qos_group", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup)), ("traffic-class", ("traffic_class", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass)), ("proto", ("proto", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto)), ("icmp-v4", ("icmp_v4", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4)), ("icmp-v6", ("icmp_v6", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6)), ("ipv4-packet-len", ("ipv4_packet_len", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen)), ("ipv6-packet-len", ("ipv6_packet_len", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen)), ("packet-len", ("packet_len", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen)), ("flow-tag", ("flow_tag", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag)), ("tcp-flag", ("tcp_flag", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag)), ("icmpv4-type", ("icmpv4_type", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type)), ("icmpv4-code", ("icmpv4_code", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code)), ("icmpv6-type", ("icmpv6_type", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type)), ("icmpv6-code", ("icmpv6_code", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code)), ("mpls-exp", ("mpls_exp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp)), ("mpls-exp-imp", ("mpls_exp_imp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp)), ("mpls-disp-ipv4-acl", ("mpls_disp_ipv4_acl", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl)), ("mpls-disp-ipv6-acl", ("mpls_disp_ipv6_acl", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl)), ("mpls-top-label", ("mpls_top_label", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel)), ("cos", ("cos", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos)), ("cos-inr", ("cos_inr", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr)), ("dei", ("dei", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei)), ("dei-inr", ("dei_inr", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr)), ("vlan", ("vlan", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan)), ("vlan-inr", ("vlan_inr", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)), ("fr-dlci", ("fr_dlci", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci)), ("src-mac", ("src_mac", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac)), ("dst-mac", ("dst_mac", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac)), ("atm-clp", ("atm_clp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp)), ("fr-de", ("fr_de", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe)), ("ipv4-acl", ("ipv4_acl", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl)), ("ipv6-acl", ("ipv6_acl", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl)), ("ether-service-acl", ("ether_service_acl", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl)), ("avail-id", ("avail_id", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId)), ("media-type", ("media_type", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType)), ("subs-protocol", ("subs_protocol", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol)), ("dnis", ("dnis", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis)), ("dnis-regex", ("dnis_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex)), ("domain", ("domain", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain)), ("domain-regex", ("domain_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex)), ("nas-port", ("nas_port", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort)), ("service-name", ("service_name", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName)), ("service-name-regex", ("service_name_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex)), ("src-addr-ipv4", ("src_addr_ipv4", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4)), ("dst-addr-ipv4", ("dst_addr_ipv4", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4)), ("src-addr-ipv6", ("src_addr_ipv6", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6)), ("dst-addr-ipv6", ("dst_addr_ipv6", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6)), ("src-addr-mac", ("src_addr_mac", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac)), ("timer", ("timer", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer)), ("timer-regexp", ("timer_regexp", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp)), ("tunnel-name", ("tunnel_name", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName)), ("tunnel-name-regex", ("tunnel_name_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex)), ("user-name", ("user_name", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName)), ("user-name-regex", ("user_name_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex)), ("auth-username", ("auth_username", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername)), ("auth-username-regex", ("auth_username_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex)), ("unauth-username", ("unauth_username", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername)), ("unauth-username-regex", ("unauth_username_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex)), ("auth-domain", ("auth_domain", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain)), ("auth-domain-regex", ("auth_domain_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex)), ("unauth-domain", ("unauth_domain", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain)), ("unauth-domain-regex", ("unauth_domain_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex)), ("vendor-id", ("vendor_id", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId)), ("vendor-id-regex", ("vendor_id_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex)), ("access-interface", ("access_interface", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface)), ("input-interface", ("input_interface", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface)), ("input-intfhdl", ("input_intfhdl", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl)), ("ethertype", ("ethertype", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype)), ("flow-key-data", ("flow_key_data", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData)), ("dhcp-client-id", ("dhcp_client_id", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId)), ("dhcp-client-id-regex", ("dhcp_client_id_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex)), ("circuit-id", ("circuit_id", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId)), ("circuit-id-regex", ("circuit_id_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex)), ("remote-id", ("remote_id", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId)), ("remote-id-regex", ("remote_id_regex", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex)), ("src-port", ("src_port", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort)), ("dst-port", ("dst_port", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort))])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchTypeEn', '')])),
                                                                                                    ('mpls_top_eos', (YLeaf(YType.uint8, 'mpls-top-eos'), ['int'])),
                                                                                                    ('fragment_type', (YLeaf(YType.uint8, 'fragment-type'), ['int'])),
                                                                                                    ('authen_status', (YLeaf(YType.enumeration, 'authen-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchAuthenStatusEn', '')])),
                                                                                                    ('mlp_negotiated', (YLeaf(YType.enumeration, 'mlp-negotiated'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchMlpNegotiatedEn', '')])),
                                                                                                ])
                                                                                                self.type = None
                                                                                                self.mpls_top_eos = None
                                                                                                self.fragment_type = None
                                                                                                self.authen_status = None
                                                                                                self.mlp_negotiated = None

                                                                                                self.ipv4_dscp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                                self.ipv4_dscp.parent = self
                                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"

                                                                                                self.ipv6_dscp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                                self.ipv6_dscp.parent = self
                                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"

                                                                                                self.dscp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                                self.dscp.parent = self
                                                                                                self._children_name_map["dscp"] = "dscp"

                                                                                                self.ipv4_prec = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                                self.ipv4_prec.parent = self
                                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"

                                                                                                self.ipv6_prec = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                                self.ipv6_prec.parent = self
                                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"

                                                                                                self.prec = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                                self.prec.parent = self
                                                                                                self._children_name_map["prec"] = "prec"

                                                                                                self.discard_class = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                                self.discard_class.parent = self
                                                                                                self._children_name_map["discard_class"] = "discard-class"

                                                                                                self.qos_group = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                                self.qos_group.parent = self
                                                                                                self._children_name_map["qos_group"] = "qos-group"

                                                                                                self.traffic_class = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                                self.traffic_class.parent = self
                                                                                                self._children_name_map["traffic_class"] = "traffic-class"

                                                                                                self.proto = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                                self.proto.parent = self
                                                                                                self._children_name_map["proto"] = "proto"

                                                                                                self.icmp_v4 = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                                self.icmp_v4.parent = self
                                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"

                                                                                                self.icmp_v6 = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                                self.icmp_v6.parent = self
                                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"

                                                                                                self.ipv4_packet_len = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                                self.ipv4_packet_len.parent = self
                                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"

                                                                                                self.ipv6_packet_len = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                                self.ipv6_packet_len.parent = self
                                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"

                                                                                                self.packet_len = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                                self.packet_len.parent = self
                                                                                                self._children_name_map["packet_len"] = "packet-len"

                                                                                                self.flow_tag = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                                self.flow_tag.parent = self
                                                                                                self._children_name_map["flow_tag"] = "flow-tag"

                                                                                                self.tcp_flag = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                                self.tcp_flag.parent = self
                                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"

                                                                                                self.icmpv4_type = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                                self.icmpv4_type.parent = self
                                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"

                                                                                                self.icmpv4_code = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                                self.icmpv4_code.parent = self
                                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"

                                                                                                self.icmpv6_type = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                                self.icmpv6_type.parent = self
                                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"

                                                                                                self.icmpv6_code = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                                self.icmpv6_code.parent = self
                                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"

                                                                                                self.mpls_exp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                                self.mpls_exp.parent = self
                                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"

                                                                                                self.mpls_exp_imp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                                self.mpls_exp_imp.parent = self
                                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"

                                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"

                                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"

                                                                                                self.mpls_top_label = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                                self.mpls_top_label.parent = self
                                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"

                                                                                                self.cos = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                                self.cos.parent = self
                                                                                                self._children_name_map["cos"] = "cos"

                                                                                                self.cos_inr = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                                self.cos_inr.parent = self
                                                                                                self._children_name_map["cos_inr"] = "cos-inr"

                                                                                                self.dei = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                                self.dei.parent = self
                                                                                                self._children_name_map["dei"] = "dei"

                                                                                                self.dei_inr = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                                self.dei_inr.parent = self
                                                                                                self._children_name_map["dei_inr"] = "dei-inr"

                                                                                                self.vlan = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                                self.vlan.parent = self
                                                                                                self._children_name_map["vlan"] = "vlan"

                                                                                                self.vlan_inr = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                                self.vlan_inr.parent = self
                                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"

                                                                                                self.fr_dlci = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                                self.fr_dlci.parent = self
                                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"

                                                                                                self.src_mac = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                                self.src_mac.parent = self
                                                                                                self._children_name_map["src_mac"] = "src-mac"

                                                                                                self.dst_mac = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                                self.dst_mac.parent = self
                                                                                                self._children_name_map["dst_mac"] = "dst-mac"

                                                                                                self.atm_clp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                                self.atm_clp.parent = self
                                                                                                self._children_name_map["atm_clp"] = "atm-clp"

                                                                                                self.fr_de = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                                self.fr_de.parent = self
                                                                                                self._children_name_map["fr_de"] = "fr-de"

                                                                                                self.ipv4_acl = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                                self.ipv4_acl.parent = self
                                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"

                                                                                                self.ipv6_acl = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                                self.ipv6_acl.parent = self
                                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"

                                                                                                self.ether_service_acl = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                                self.ether_service_acl.parent = self
                                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"

                                                                                                self.avail_id = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                                self.avail_id.parent = self
                                                                                                self._children_name_map["avail_id"] = "avail-id"

                                                                                                self.media_type = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                                self.media_type.parent = self
                                                                                                self._children_name_map["media_type"] = "media-type"

                                                                                                self.subs_protocol = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                                self.subs_protocol.parent = self
                                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"

                                                                                                self.dnis = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                                self.dnis.parent = self
                                                                                                self._children_name_map["dnis"] = "dnis"

                                                                                                self.dnis_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                                self.dnis_regex.parent = self
                                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"

                                                                                                self.domain = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                                self.domain.parent = self
                                                                                                self._children_name_map["domain"] = "domain"

                                                                                                self.domain_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                                self.domain_regex.parent = self
                                                                                                self._children_name_map["domain_regex"] = "domain-regex"

                                                                                                self.nas_port = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                                self.nas_port.parent = self
                                                                                                self._children_name_map["nas_port"] = "nas-port"

                                                                                                self.service_name = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                                self.service_name.parent = self
                                                                                                self._children_name_map["service_name"] = "service-name"

                                                                                                self.service_name_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                                self.service_name_regex.parent = self
                                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"

                                                                                                self.src_addr_ipv4 = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                                self.src_addr_ipv4.parent = self
                                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"

                                                                                                self.dst_addr_ipv4 = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                                self.dst_addr_ipv4.parent = self
                                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"

                                                                                                self.src_addr_ipv6 = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                                self.src_addr_ipv6.parent = self
                                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"

                                                                                                self.dst_addr_ipv6 = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                                self.dst_addr_ipv6.parent = self
                                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"

                                                                                                self.src_addr_mac = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                                self.src_addr_mac.parent = self
                                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"

                                                                                                self.timer = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                                self.timer.parent = self
                                                                                                self._children_name_map["timer"] = "timer"

                                                                                                self.timer_regexp = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                                self.timer_regexp.parent = self
                                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"

                                                                                                self.tunnel_name = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                                self.tunnel_name.parent = self
                                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"

                                                                                                self.tunnel_name_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                                self.tunnel_name_regex.parent = self
                                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"

                                                                                                self.user_name = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                                self.user_name.parent = self
                                                                                                self._children_name_map["user_name"] = "user-name"

                                                                                                self.user_name_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                                self.user_name_regex.parent = self
                                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"

                                                                                                self.auth_username = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                                self.auth_username.parent = self
                                                                                                self._children_name_map["auth_username"] = "auth-username"

                                                                                                self.auth_username_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                                self.auth_username_regex.parent = self
                                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"

                                                                                                self.unauth_username = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                                self.unauth_username.parent = self
                                                                                                self._children_name_map["unauth_username"] = "unauth-username"

                                                                                                self.unauth_username_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                                self.unauth_username_regex.parent = self
                                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"

                                                                                                self.auth_domain = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                                self.auth_domain.parent = self
                                                                                                self._children_name_map["auth_domain"] = "auth-domain"

                                                                                                self.auth_domain_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                                self.auth_domain_regex.parent = self
                                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"

                                                                                                self.unauth_domain = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                                self.unauth_domain.parent = self
                                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"

                                                                                                self.unauth_domain_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                                self.unauth_domain_regex.parent = self
                                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"

                                                                                                self.vendor_id = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                                self.vendor_id.parent = self
                                                                                                self._children_name_map["vendor_id"] = "vendor-id"

                                                                                                self.vendor_id_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                                self.vendor_id_regex.parent = self
                                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"

                                                                                                self.access_interface = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                                self.access_interface.parent = self
                                                                                                self._children_name_map["access_interface"] = "access-interface"

                                                                                                self.input_interface = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                                self.input_interface.parent = self
                                                                                                self._children_name_map["input_interface"] = "input-interface"

                                                                                                self.input_intfhdl = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                                self.input_intfhdl.parent = self
                                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"

                                                                                                self.ethertype = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                                self.ethertype.parent = self
                                                                                                self._children_name_map["ethertype"] = "ethertype"

                                                                                                self.flow_key_data = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                                self.flow_key_data.parent = self
                                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"

                                                                                                self.dhcp_client_id = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                                self.dhcp_client_id.parent = self
                                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"

                                                                                                self.dhcp_client_id_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                                self.dhcp_client_id_regex.parent = self
                                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"

                                                                                                self.circuit_id = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                                self.circuit_id.parent = self
                                                                                                self._children_name_map["circuit_id"] = "circuit-id"

                                                                                                self.circuit_id_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                                self.circuit_id_regex.parent = self
                                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"

                                                                                                self.remote_id = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                                self.remote_id.parent = self
                                                                                                self._children_name_map["remote_id"] = "remote-id"

                                                                                                self.remote_id_regex = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                                self.remote_id_regex.parent = self
                                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"

                                                                                                self.src_port = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                                self.src_port.parent = self
                                                                                                self._children_name_map["src_port"] = "src-port"

                                                                                                self.dst_port = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                                self.dst_port.parent = self
                                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                                self._segment_path = lambda: "match-data"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['type', 'mpls_top_eos', 'fragment_type', 'authen_status', 'mlp_negotiated'], name, value)


                                                                                            class Ipv4Dscp(Entity):
                                                                                                """
                                                                                                IPv4 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv4-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv6Dscp(Entity):
                                                                                                """
                                                                                                IPv6 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv6-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Dscp(Entity):
                                                                                                """
                                                                                                Match DSCP range array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                    self.yang_name = "dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv4Prec(Entity):
                                                                                                """
                                                                                                IPv4 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                    self.yang_name = "ipv4-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "ipv4-prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                            class Ipv6Prec(Entity):
                                                                                                """
                                                                                                IPv6 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                    self.yang_name = "ipv6-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "ipv6-prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                            class Prec(Entity):
                                                                                                """
                                                                                                Match Precedence array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                    self.yang_name = "prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                            class DiscardClass(Entity):
                                                                                                """
                                                                                                Match Discard Class array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                    self.yang_name = "discard-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "discard-class"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                            class QosGroup(Entity):
                                                                                                """
                                                                                                Match QoS group array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                    self.yang_name = "qos-group"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "qos-group"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "qos-group"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class TrafficClass(Entity):
                                                                                                """
                                                                                                Match Traffic class array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                    self.yang_name = "traffic-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "traffic-class"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "traffic-class"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Proto(Entity):
                                                                                                """
                                                                                                Match Protocol array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                    self.yang_name = "proto"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "proto"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "proto"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class IcmpV4(Entity):
                                                                                                """
                                                                                                Match ICMPV4 Protocol
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                    self.yang_name = "icmp-v4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                    ])
                                                                                                    self.type = None
                                                                                                    self.code = None
                                                                                                    self._segment_path = lambda: "icmp-v4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['type', 'code'], name, value)


                                                                                            class IcmpV6(Entity):
                                                                                                """
                                                                                                Match ICMPV6 Protocol array
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                    self.yang_name = "icmp-v6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                    ])
                                                                                                    self.type = None
                                                                                                    self.code = None
                                                                                                    self._segment_path = lambda: "icmp-v6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['type', 'code'], name, value)


                                                                                            class Ipv4PacketLen(Entity):
                                                                                                """
                                                                                                IPv4 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv6PacketLen(Entity):
                                                                                                """
                                                                                                IPv6 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class PacketLen(Entity):
                                                                                                """
                                                                                                Match packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                    self.yang_name = "packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FlowTag(Entity):
                                                                                                """
                                                                                                Match flow\-tag array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                    self.yang_name = "flow-tag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "flow-tag"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "flow-tag"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class TcpFlag(Entity):
                                                                                                """
                                                                                                Match tcp flag value
                                                                                                
                                                                                                .. attribute:: value
                                                                                                
                                                                                                	Value of TCP flag
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: match_any
                                                                                                
                                                                                                	Match any TCP flag bit
                                                                                                	**type**\: bool
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                    self.yang_name = "tcp-flag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                                        ('match_any', (YLeaf(YType.boolean, 'match-any'), ['bool'])),
                                                                                                    ])
                                                                                                    self.value = None
                                                                                                    self.match_any = None
                                                                                                    self._segment_path = lambda: "tcp-flag"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['value', 'match_any'], name, value)


                                                                                            class Icmpv4Type(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                    self.yang_name = "icmpv4-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv4Code(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                    self.yang_name = "icmpv4-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-code"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv6Type(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                    self.yang_name = "icmpv6-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv6Code(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                    self.yang_name = "icmpv6-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-code"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class MplsExp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental topmost array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "mpls-exp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                            class MplsExpImp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental imposition array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "mpls-exp-imp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                            class MplsDispIpv4Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                            class MplsDispIpv6Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                            class MplsTopLabel(Entity):
                                                                                                """
                                                                                                MPLS Topmost LABEL
                                                                                                
                                                                                                .. attribute:: uint32_rng_array
                                                                                                
                                                                                                	uint32 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                    self.yang_name = "mpls-top-label"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint32_rng_array", ("uint32_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint32_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "mpls-top-label"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                                class Uint32RngArray(Entity):
                                                                                                    """
                                                                                                    uint32 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                        self.yang_name = "uint32_rng_array"
                                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint32, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint32, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint32_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['min', 'max'], name, value)


                                                                                            class Cos(Entity):
                                                                                                """
                                                                                                Match CoS array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                    self.yang_name = "cos"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "cos"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                            class CosInr(Entity):
                                                                                                """
                                                                                                Match inner header CoS
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                    self.yang_name = "cos-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "cos-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                            class Dei(Entity):
                                                                                                """
                                                                                                Match DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                    self.yang_name = "dei"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                    ])
                                                                                                    self.bit_value = None
                                                                                                    self._segment_path = lambda: "dei"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                            class DeiInr(Entity):
                                                                                                """
                                                                                                Match inner DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                    self.yang_name = "dei-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                    ])
                                                                                                    self.bit_value = None
                                                                                                    self._segment_path = lambda: "dei-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                            class Vlan(Entity):
                                                                                                """
                                                                                                Match VLAN array
                                                                                                
                                                                                                .. attribute:: vlan_id_array
                                                                                                
                                                                                                	vlan id array
                                                                                                	**type**\: list of  		 :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                    self.yang_name = "vlan"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("vlan-id-array", ("vlan_id_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.vlan_id_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                                class VlanIdArray(Entity):
                                                                                                    """
                                                                                                    vlan id array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	VLAN mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                        self.yang_name = "vlan-id-array"
                                                                                                        self.yang_parent_name = "vlan"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ('mask', (YLeaf(YType.uint16, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "vlan-id-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['min', 'max', 'mask'], name, value)


                                                                                            class VlanInr(Entity):
                                                                                                """
                                                                                                Match inner header VLAN range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                    self.yang_name = "vlan-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FrDlci(Entity):
                                                                                                """
                                                                                                Match FR DLCI range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                    self.yang_name = "fr-dlci"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "fr-dlci"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class SrcMac(Entity):
                                                                                                """
                                                                                                Match Source MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                    self.yang_name = "src-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.mac_addr = []
                                                                                                    self.mask = []
                                                                                                    self._segment_path = lambda: "src-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                            class DstMac(Entity):
                                                                                                """
                                                                                                Match Destination MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                    self.yang_name = "dst-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.mac_addr = []
                                                                                                    self.mask = []
                                                                                                    self._segment_path = lambda: "dst-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                            class AtmClp(Entity):
                                                                                                """
                                                                                                Match ATM CLP level
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                    self.yang_name = "atm-clp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "atm-clp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                            class FrDe(Entity):
                                                                                                """
                                                                                                Match FR DE value
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                    self.yang_name = "fr-de"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "fr-de"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                            class Ipv4Acl(Entity):
                                                                                                """
                                                                                                IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                    self.yang_name = "ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ipv4-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                            class Ipv6Acl(Entity):
                                                                                                """
                                                                                                IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                    self.yang_name = "ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ipv6-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                            class EtherServiceAcl(Entity):
                                                                                                """
                                                                                                Ethernet\-Services Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                    self.yang_name = "ether-service-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ether-service-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                            class AvailId(Entity):
                                                                                                """
                                                                                                Available Identifiers
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                    self.yang_name = "avail-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "avail-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                            class MediaType(Entity):
                                                                                                """
                                                                                                Media Type
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                    self.yang_name = "media-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "media-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                            class SubsProtocol(Entity):
                                                                                                """
                                                                                                Protocol
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                    self.yang_name = "subs-protocol"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "subs-protocol"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                            class Dnis(Entity):
                                                                                                """
                                                                                                DNIS
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                    self.yang_name = "dnis"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dnis"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                            class DnisRegex(Entity):
                                                                                                """
                                                                                                DNIS Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                    self.yang_name = "dnis-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dnis-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                            class Domain(Entity):
                                                                                                """
                                                                                                Domain Name
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                    self.yang_name = "domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                        ])
                                                                                                        self.domain_name = None
                                                                                                        self.format_name = None
                                                                                                        self._segment_path = lambda: "domain-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class DomainRegex(Entity):
                                                                                                """
                                                                                                Domain Regular Expression
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                    self.yang_name = "domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain-regex"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                        ])
                                                                                                        self.domain_name = None
                                                                                                        self.format_name = None
                                                                                                        self._segment_path = lambda: "domain-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class NasPort(Entity):
                                                                                                """
                                                                                                NAS Port
                                                                                                
                                                                                                .. attribute:: nas_port_array
                                                                                                
                                                                                                	nas port array
                                                                                                	**type**\: list of  		 :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                    self.yang_name = "nas-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("nas-port-array", ("nas_port_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.nas_port_array = YList(self)
                                                                                                    self._segment_path = lambda: "nas-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                                class NasPortArray(Entity):
                                                                                                    """
                                                                                                    nas port array
                                                                                                    
                                                                                                    .. attribute:: sub_id
                                                                                                    
                                                                                                    	sub id
                                                                                                    	**type**\:  :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                    
                                                                                                    .. attribute:: operator
                                                                                                    
                                                                                                    	operator
                                                                                                    	**type**\:  :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	value
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                        self.yang_name = "nas-port-array"
                                                                                                        self.yang_parent_name = "nas-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('sub_id', (YLeaf(YType.enumeration, 'sub-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchNasPortSubIdEn', '')])),
                                                                                                            ('operator', (YLeaf(YType.enumeration, 'operator'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchLogicalOperatorEn', '')])),
                                                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                                        ])
                                                                                                        self.sub_id = None
                                                                                                        self.operator = None
                                                                                                        self.value = None
                                                                                                        self._segment_path = lambda: "nas-port-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['sub_id', 'operator', 'value'], name, value)


                                                                                            class ServiceName(Entity):
                                                                                                """
                                                                                                Service Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                    self.yang_name = "service-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "service-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                            class ServiceNameRegex(Entity):
                                                                                                """
                                                                                                Service Name Regular Exp
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                    self.yang_name = "service-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "service-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                            class SrcAddrIpv4(Entity):
                                                                                                """
                                                                                                Source Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class DstAddrIpv4(Entity):
                                                                                                """
                                                                                                Destination Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class SrcAddrIpv6(Entity):
                                                                                                """
                                                                                                Source Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class DstAddrIpv6(Entity):
                                                                                                """
                                                                                                Destination Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class SrcAddrMac(Entity):
                                                                                                """
                                                                                                Source Address MAC
                                                                                                
                                                                                                .. attribute:: mac_addr_array
                                                                                                
                                                                                                	mac addr array
                                                                                                	**type**\: list of  		 :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                    self.yang_name = "src-addr-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("mac-addr-array", ("mac_addr_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.mac_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                                class MacAddrArray(Entity):
                                                                                                    """
                                                                                                    mac addr array
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                        self.yang_name = "mac-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                            ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.mac_addr = []
                                                                                                        self.mask = []
                                                                                                        self._segment_path = lambda: "mac-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                            class Timer(Entity):
                                                                                                """
                                                                                                Timer
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                    self.yang_name = "timer"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "timer"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                            class TimerRegexp(Entity):
                                                                                                """
                                                                                                Timer Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                    self.yang_name = "timer-regexp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "timer-regexp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                            class TunnelName(Entity):
                                                                                                """
                                                                                                Tunnel Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                    self.yang_name = "tunnel-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "tunnel-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                            class TunnelNameRegex(Entity):
                                                                                                """
                                                                                                Tunnel Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "tunnel-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                            class UserName(Entity):
                                                                                                """
                                                                                                User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                    self.yang_name = "user-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "user-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                            class UserNameRegex(Entity):
                                                                                                """
                                                                                                User Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                    self.yang_name = "user-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "user-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                            class AuthUsername(Entity):
                                                                                                """
                                                                                                Authenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                    self.yang_name = "auth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-username"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                            class AuthUsernameRegex(Entity):
                                                                                                """
                                                                                                Authenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "auth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-username-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                            class UnauthUsername(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                    self.yang_name = "unauth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-username"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                            class UnauthUsernameRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-username-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                            class AuthDomain(Entity):
                                                                                                """
                                                                                                Authenticated domain name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                    self.yang_name = "auth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                            class AuthDomainRegex(Entity):
                                                                                                """
                                                                                                Authenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "auth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                            class UnauthDomain(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                    self.yang_name = "unauth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                            class UnauthDomainRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                            class VendorId(Entity):
                                                                                                """
                                                                                                Vendor ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                    self.yang_name = "vendor-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "vendor-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                            class VendorIdRegex(Entity):
                                                                                                """
                                                                                                Vendor ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                    self.yang_name = "vendor-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "vendor-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                            class AccessInterface(Entity):
                                                                                                """
                                                                                                Access interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                    self.yang_name = "access-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "access-interface"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                            class InputInterface(Entity):
                                                                                                """
                                                                                                Input interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                    self.yang_name = "input-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "input-interface"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                            class InputIntfhdl(Entity):
                                                                                                """
                                                                                                Input interface handle
                                                                                                
                                                                                                .. attribute:: uint64_array
                                                                                                
                                                                                                	uint64 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..18446744073709551615
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                    self.yang_name = "input-intfhdl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint64_array', (YLeafList(YType.uint64, 'uint64_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint64_array = []
                                                                                                    self._segment_path = lambda: "input-intfhdl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                            class Ethertype(Entity):
                                                                                                """
                                                                                                Ethernet type
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                    self.yang_name = "ethertype"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ethertype"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ethertype"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FlowKeyData(Entity):
                                                                                                """
                                                                                                Flow key structure
                                                                                                
                                                                                                .. attribute:: flow_keys
                                                                                                
                                                                                                	flow keys
                                                                                                	**type**\:  :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                                
                                                                                                .. attribute:: max_count
                                                                                                
                                                                                                	Maximum count of flows
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: idle_timeout
                                                                                                
                                                                                                	Idle timeout of flows (in seconds)
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                	**units**\: second
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                    self.yang_name = "flow-key-data"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("flow-keys", ("flow_keys", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys))])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('max_count', (YLeaf(YType.uint16, 'max-count'), ['int'])),
                                                                                                        ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                                                    ])
                                                                                                    self.max_count = None
                                                                                                    self.idle_timeout = None

                                                                                                    self.flow_keys = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                    self.flow_keys.parent = self
                                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                    self._segment_path = lambda: "flow-key-data"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['max_count', 'idle_timeout'], name, value)


                                                                                                class FlowKeys(Entity):
                                                                                                    """
                                                                                                    flow keys
                                                                                                    
                                                                                                    .. attribute:: keys
                                                                                                    
                                                                                                    	keys
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                    
                                                                                                    .. attribute:: num
                                                                                                    
                                                                                                    	num
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                        self.yang_name = "flow-keys"
                                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('keys', (YLeaf(YType.str, 'keys'), ['str'])),
                                                                                                            ('num', (YLeaf(YType.uint8, 'num'), ['int'])),
                                                                                                        ])
                                                                                                        self.keys = None
                                                                                                        self.num = None
                                                                                                        self._segment_path = lambda: "flow-keys"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                            class DhcpClientId(Entity):
                                                                                                """
                                                                                                Dhcp Client ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dhcp-client-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                            class DhcpClientIdRegex(Entity):
                                                                                                """
                                                                                                Dhcp Client ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                            class CircuitId(Entity):
                                                                                                """
                                                                                                Circuit ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                    self.yang_name = "circuit-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "circuit-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                            class CircuitIdRegex(Entity):
                                                                                                """
                                                                                                Circuit ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                    self.yang_name = "circuit-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "circuit-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                            class RemoteId(Entity):
                                                                                                """
                                                                                                Remote ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                    self.yang_name = "remote-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "remote-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                            class RemoteIdRegex(Entity):
                                                                                                """
                                                                                                Remote ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                    self.yang_name = "remote-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "remote-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                            class SrcPort(Entity):
                                                                                                """
                                                                                                Source port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                    self.yang_name = "src-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "src-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class DstPort(Entity):
                                                                                                """
                                                                                                Destination port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                    self.yang_name = "dst-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "dst-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                    class Shape(Entity):
                                                                        """
                                                                        shape
                                                                        
                                                                        .. attribute:: bw
                                                                        
                                                                        	bw
                                                                        	**type**\:  :py:class:`Bw <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw>`
                                                                        
                                                                        .. attribute:: be
                                                                        
                                                                        	be
                                                                        	**type**\:  :py:class:`Be <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape, self).__init__()

                                                                            self.yang_name = "shape"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("bw", ("bw", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw)), ("be", ("be", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be))])
                                                                            self._leafs = OrderedDict()

                                                                            self.bw = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw()
                                                                            self.bw.parent = self
                                                                            self._children_name_map["bw"] = "bw"

                                                                            self.be = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be()
                                                                            self.be.parent = self
                                                                            self._children_name_map["be"] = "be"
                                                                            self._segment_path = lambda: "shape"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape, [], name, value)


                                                                        class Bw(Entity):
                                                                            """
                                                                            bw
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw, self).__init__()

                                                                                self.yang_name = "bw"
                                                                                self.yang_parent_name = "shape"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "bw"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw, ['value', 'unit'], name, value)


                                                                        class Be(Entity):
                                                                            """
                                                                            be
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be, self).__init__()

                                                                                self.yang_name = "be"
                                                                                self.yang_parent_name = "shape"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "be"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be, ['value', 'unit'], name, value)


                                                                    class ChildPolicy(Entity):
                                                                        """
                                                                        child policy
                                                                        
                                                                        .. attribute:: info
                                                                        
                                                                        	info
                                                                        	**type**\:  :py:class:`Info <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info>`
                                                                        
                                                                        .. attribute:: hd_info
                                                                        
                                                                        	hd info
                                                                        	**type**\:  :py:class:`HdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo>`
                                                                        
                                                                        .. attribute:: enc
                                                                        
                                                                        	enc
                                                                        	**type**\:  :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy, self).__init__()

                                                                            self.yang_name = "child-policy"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("info", ("info", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info)), ("hd-info", ("hd_info", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo))])
                                                                            self._leafs = OrderedDict([
                                                                                ('enc', (YLeaf(YType.enumeration, 'enc'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyObjEncEn', '')])),
                                                                            ])
                                                                            self.enc = None

                                                                            self.info = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info()
                                                                            self.info.parent = self
                                                                            self._children_name_map["info"] = "info"

                                                                            self.hd_info = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo()
                                                                            self.hd_info.parent = self
                                                                            self._children_name_map["hd_info"] = "hd-info"
                                                                            self._segment_path = lambda: "child-policy"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy, ['enc'], name, value)


                                                                        class Info(Entity):
                                                                            """
                                                                            info
                                                                            
                                                                            .. attribute:: name
                                                                            
                                                                            	name
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..65
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:  :py:class:`PolicyMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyMapTypeEn>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info, self).__init__()

                                                                                self.yang_name = "info"
                                                                                self.yang_parent_name = "child-policy"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyMapTypeEn', '')])),
                                                                                ])
                                                                                self.name = None
                                                                                self.type = None
                                                                                self._segment_path = lambda: "info"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info, ['name', 'type'], name, value)


                                                                        class HdInfo(Entity):
                                                                            """
                                                                            hd info
                                                                            
                                                                            .. attribute:: data_hd
                                                                            
                                                                            	data hd
                                                                            	**type**\:  :py:class:`DataHd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd>`
                                                                            
                                                                            .. attribute:: hd
                                                                            
                                                                            	hd
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo, self).__init__()

                                                                                self.yang_name = "hd-info"
                                                                                self.yang_parent_name = "child-policy"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("data-hd", ("data_hd", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('hd', (YLeaf(YType.uint64, 'hd'), ['int'])),
                                                                                ])
                                                                                self.hd = None

                                                                                self.data_hd = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd()
                                                                                self.data_hd.parent = self
                                                                                self._children_name_map["data_hd"] = "data-hd"
                                                                                self._segment_path = lambda: "hd-info"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo, ['hd'], name, value)


                                                                            class DataHd(Entity):
                                                                                """
                                                                                data hd
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd, self).__init__()

                                                                                    self.yang_name = "data-hd"
                                                                                    self.yang_parent_name = "hd-info"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict()
                                                                                    self._segment_path = lambda: "data-hd"
                                                                                    self._is_frozen = True


                                                                    class Cac(Entity):
                                                                        """
                                                                        cac
                                                                        
                                                                        .. attribute:: flow_rate
                                                                        
                                                                        	flow rate
                                                                        	**type**\:  :py:class:`FlowRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate>`
                                                                        
                                                                        .. attribute:: rate
                                                                        
                                                                        	rate
                                                                        	**type**\:  :py:class:`Rate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate>`
                                                                        
                                                                        .. attribute:: cac_type
                                                                        
                                                                        	cac type
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: idle_timeout
                                                                        
                                                                        	idle timeout
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..65535
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac, self).__init__()

                                                                            self.yang_name = "cac"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("flow-rate", ("flow_rate", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate)), ("rate", ("rate", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate))])
                                                                            self._leafs = OrderedDict([
                                                                                ('cac_type', (YLeaf(YType.uint8, 'cac-type'), ['int'])),
                                                                                ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                            ])
                                                                            self.cac_type = None
                                                                            self.idle_timeout = None

                                                                            self.flow_rate = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate()
                                                                            self.flow_rate.parent = self
                                                                            self._children_name_map["flow_rate"] = "flow-rate"

                                                                            self.rate = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate()
                                                                            self.rate.parent = self
                                                                            self._children_name_map["rate"] = "rate"
                                                                            self._segment_path = lambda: "cac"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac, ['cac_type', 'idle_timeout'], name, value)


                                                                        class FlowRate(Entity):
                                                                            """
                                                                            flow rate
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate, self).__init__()

                                                                                self.yang_name = "flow-rate"
                                                                                self.yang_parent_name = "cac"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "flow-rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate, ['value', 'unit'], name, value)


                                                                        class Rate(Entity):
                                                                            """
                                                                            rate
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate, self).__init__()

                                                                                self.yang_name = "rate"
                                                                                self.yang_parent_name = "cac"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate, ['value', 'unit'], name, value)


                                                                    class Pfc(Entity):
                                                                        """
                                                                        pfc
                                                                        
                                                                        .. attribute:: buffer_size
                                                                        
                                                                        	buffer size
                                                                        	**type**\:  :py:class:`BufferSize <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize>`
                                                                        
                                                                        .. attribute:: pause_threshold
                                                                        
                                                                        	pause threshold
                                                                        	**type**\:  :py:class:`PauseThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold>`
                                                                        
                                                                        .. attribute:: resume_threshold
                                                                        
                                                                        	resume threshold
                                                                        	**type**\:  :py:class:`ResumeThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold>`
                                                                        
                                                                        .. attribute:: pfc_pause_set
                                                                        
                                                                        	pfc pause set
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: buffer_size_flag
                                                                        
                                                                        	buffer size flag
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc, self).__init__()

                                                                            self.yang_name = "pfc"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("buffer-size", ("buffer_size", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize)), ("pause-threshold", ("pause_threshold", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold)), ("resume-threshold", ("resume_threshold", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold))])
                                                                            self._leafs = OrderedDict([
                                                                                ('pfc_pause_set', (YLeaf(YType.uint32, 'pfc-pause-set'), ['int'])),
                                                                                ('buffer_size_flag', (YLeaf(YType.uint32, 'buffer-size-flag'), ['int'])),
                                                                            ])
                                                                            self.pfc_pause_set = None
                                                                            self.buffer_size_flag = None

                                                                            self.buffer_size = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize()
                                                                            self.buffer_size.parent = self
                                                                            self._children_name_map["buffer_size"] = "buffer-size"

                                                                            self.pause_threshold = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold()
                                                                            self.pause_threshold.parent = self
                                                                            self._children_name_map["pause_threshold"] = "pause-threshold"

                                                                            self.resume_threshold = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold()
                                                                            self.resume_threshold.parent = self
                                                                            self._children_name_map["resume_threshold"] = "resume-threshold"
                                                                            self._segment_path = lambda: "pfc"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc, ['pfc_pause_set', 'buffer_size_flag'], name, value)


                                                                        class BufferSize(Entity):
                                                                            """
                                                                            buffer size
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize, self).__init__()

                                                                                self.yang_name = "buffer-size"
                                                                                self.yang_parent_name = "pfc"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "buffer-size"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize, ['value', 'unit'], name, value)


                                                                        class PauseThreshold(Entity):
                                                                            """
                                                                            pause threshold
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold, self).__init__()

                                                                                self.yang_name = "pause-threshold"
                                                                                self.yang_parent_name = "pfc"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "pause-threshold"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold, ['value', 'unit'], name, value)


                                                                        class ResumeThreshold(Entity):
                                                                            """
                                                                            resume threshold
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold, self).__init__()

                                                                                self.yang_name = "resume-threshold"
                                                                                self.yang_parent_name = "pfc"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "resume-threshold"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold, ['value', 'unit'], name, value)


                                                                    class FlowParm(Entity):
                                                                        """
                                                                        flow parm
                                                                        
                                                                        .. attribute:: max_mon_flows
                                                                        
                                                                        	max simult flows monitored per policy class
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: mon_interval
                                                                        
                                                                        	monitored interval duration in secs
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: second
                                                                        
                                                                        .. attribute:: intvl_hist
                                                                        
                                                                        	num intervals of data stored on rtr
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: flow_timeout
                                                                        
                                                                        	timeout in secs
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: second
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm, self).__init__()

                                                                            self.yang_name = "flow-parm"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('max_mon_flows', (YLeaf(YType.uint32, 'max-mon-flows'), ['int'])),
                                                                                ('mon_interval', (YLeaf(YType.uint32, 'mon-interval'), ['int'])),
                                                                                ('intvl_hist', (YLeaf(YType.uint32, 'intvl-hist'), ['int'])),
                                                                                ('flow_timeout', (YLeaf(YType.uint32, 'flow-timeout'), ['int'])),
                                                                            ])
                                                                            self.max_mon_flows = None
                                                                            self.mon_interval = None
                                                                            self.intvl_hist = None
                                                                            self.flow_timeout = None
                                                                            self._segment_path = lambda: "flow-parm"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm, ['max_mon_flows', 'mon_interval', 'intvl_hist', 'flow_timeout'], name, value)


                                                                    class Ipcbr(Entity):
                                                                        """
                                                                        ipcbr
                                                                        
                                                                        .. attribute:: ip_bit_rate
                                                                        
                                                                        	data rate in bps
                                                                        	**type**\:  :py:class:`IpBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate>`
                                                                        
                                                                        .. attribute:: media_bit_rate
                                                                        
                                                                        	media data rate in bps
                                                                        	**type**\:  :py:class:`MediaBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate>`
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: ip_pkt_rate
                                                                        
                                                                        	packet rate in pps
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: media_pkt_size
                                                                        
                                                                        	media packet size in bytes
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: media_pkts_per_ip
                                                                        
                                                                        	media packets per ip pkt
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr, self).__init__()

                                                                            self.yang_name = "ipcbr"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("ip-bit-rate", ("ip_bit_rate", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate)), ("media-bit-rate", ("media_bit_rate", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate))])
                                                                            self._leafs = OrderedDict([
                                                                                ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                                ('ip_pkt_rate', (YLeaf(YType.uint32, 'ip-pkt-rate'), ['int'])),
                                                                                ('media_pkt_size', (YLeaf(YType.uint32, 'media-pkt-size'), ['int'])),
                                                                                ('media_pkts_per_ip', (YLeaf(YType.uint32, 'media-pkts-per-ip'), ['int'])),
                                                                            ])
                                                                            self.action_metric_type = None
                                                                            self.ip_pkt_rate = None
                                                                            self.media_pkt_size = None
                                                                            self.media_pkts_per_ip = None

                                                                            self.ip_bit_rate = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate()
                                                                            self.ip_bit_rate.parent = self
                                                                            self._children_name_map["ip_bit_rate"] = "ip-bit-rate"

                                                                            self.media_bit_rate = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate()
                                                                            self.media_bit_rate.parent = self
                                                                            self._children_name_map["media_bit_rate"] = "media-bit-rate"
                                                                            self._segment_path = lambda: "ipcbr"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr, ['action_metric_type', 'ip_pkt_rate', 'media_pkt_size', 'media_pkts_per_ip'], name, value)


                                                                        class IpBitRate(Entity):
                                                                            """
                                                                            data rate in bps
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate, self).__init__()

                                                                                self.yang_name = "ip-bit-rate"
                                                                                self.yang_parent_name = "ipcbr"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "ip-bit-rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate, ['value', 'unit'], name, value)


                                                                        class MediaBitRate(Entity):
                                                                            """
                                                                            media data rate in bps
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate, self).__init__()

                                                                                self.yang_name = "media-bit-rate"
                                                                                self.yang_parent_name = "ipcbr"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "media-bit-rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate, ['value', 'unit'], name, value)


                                                                    class Rtp(Entity):
                                                                        """
                                                                        rtp
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: min_sequential
                                                                        
                                                                        	min sequential
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_dropout
                                                                        
                                                                        	max dropout
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_misorder
                                                                        
                                                                        	max misorder
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: seq_ext_cop4
                                                                        
                                                                        	enable seq extension cop4
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: clock_rate
                                                                        
                                                                        	clock rate
                                                                        	**type**\: list of  		 :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp, self).__init__()

                                                                            self.yang_name = "rtp"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("clock-rate", ("clock_rate", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate))])
                                                                            self._leafs = OrderedDict([
                                                                                ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                                ('min_sequential', (YLeaf(YType.uint32, 'min-sequential'), ['int'])),
                                                                                ('max_dropout', (YLeaf(YType.uint32, 'max-dropout'), ['int'])),
                                                                                ('max_misorder', (YLeaf(YType.uint32, 'max-misorder'), ['int'])),
                                                                                ('seq_ext_cop4', (YLeaf(YType.uint32, 'seq-ext-cop4'), ['int'])),
                                                                            ])
                                                                            self.action_metric_type = None
                                                                            self.min_sequential = None
                                                                            self.max_dropout = None
                                                                            self.max_misorder = None
                                                                            self.seq_ext_cop4 = None

                                                                            self.clock_rate = YList(self)
                                                                            self._segment_path = lambda: "rtp"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp, ['action_metric_type', 'min_sequential', 'max_dropout', 'max_misorder', 'seq_ext_cop4'], name, value)


                                                                        class ClockRate(Entity):
                                                                            """
                                                                            clock rate
                                                                            
                                                                            .. attribute:: pt
                                                                            
                                                                            	pt
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: frequency
                                                                            
                                                                            	frequency
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate, self).__init__()

                                                                                self.yang_name = "clock-rate"
                                                                                self.yang_parent_name = "rtp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('pt', (YLeaf(YType.uint32, 'pt'), ['int'])),
                                                                                    ('frequency', (YLeaf(YType.uint32, 'frequency'), ['int'])),
                                                                                ])
                                                                                self.pt = None
                                                                                self.frequency = None
                                                                                self._segment_path = lambda: "clock-rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate, ['pt', 'frequency'], name, value)


                                                                    class RtpMmr(Entity):
                                                                        """
                                                                        rtp mmr
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: min_sequential
                                                                        
                                                                        	min sequential
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_dropout
                                                                        
                                                                        	max dropout
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_misorder
                                                                        
                                                                        	max misorder
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: seq_ext_cop4
                                                                        
                                                                        	enable seq extension cop4
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: clock_rate
                                                                        
                                                                        	clock rate
                                                                        	**type**\: list of  		 :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr, self).__init__()

                                                                            self.yang_name = "rtp-mmr"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("clock-rate", ("clock_rate", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate))])
                                                                            self._leafs = OrderedDict([
                                                                                ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                                ('min_sequential', (YLeaf(YType.uint32, 'min-sequential'), ['int'])),
                                                                                ('max_dropout', (YLeaf(YType.uint32, 'max-dropout'), ['int'])),
                                                                                ('max_misorder', (YLeaf(YType.uint32, 'max-misorder'), ['int'])),
                                                                                ('seq_ext_cop4', (YLeaf(YType.uint32, 'seq-ext-cop4'), ['int'])),
                                                                            ])
                                                                            self.action_metric_type = None
                                                                            self.min_sequential = None
                                                                            self.max_dropout = None
                                                                            self.max_misorder = None
                                                                            self.seq_ext_cop4 = None

                                                                            self.clock_rate = YList(self)
                                                                            self._segment_path = lambda: "rtp-mmr"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr, ['action_metric_type', 'min_sequential', 'max_dropout', 'max_misorder', 'seq_ext_cop4'], name, value)


                                                                        class ClockRate(Entity):
                                                                            """
                                                                            clock rate
                                                                            
                                                                            .. attribute:: pt
                                                                            
                                                                            	pt
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: frequency
                                                                            
                                                                            	frequency
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate, self).__init__()

                                                                                self.yang_name = "clock-rate"
                                                                                self.yang_parent_name = "rtp-mmr"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('pt', (YLeaf(YType.uint32, 'pt'), ['int'])),
                                                                                    ('frequency', (YLeaf(YType.uint32, 'frequency'), ['int'])),
                                                                                ])
                                                                                self.pt = None
                                                                                self.frequency = None
                                                                                self._segment_path = lambda: "clock-rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate, ['pt', 'frequency'], name, value)


                                                                    class RtpJ2k(Entity):
                                                                        """
                                                                        rtp j2k
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: min_sequential
                                                                        
                                                                        	min sequential
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_dropout
                                                                        
                                                                        	max dropout
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_misorder
                                                                        
                                                                        	max misorder
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: seq_ext_cop4
                                                                        
                                                                        	enable seq extension cop4
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: clock_rate
                                                                        
                                                                        	clock rate
                                                                        	**type**\: list of  		 :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k.ClockRate>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k, self).__init__()

                                                                            self.yang_name = "rtp-j2k"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("clock-rate", ("clock_rate", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k.ClockRate))])
                                                                            self._leafs = OrderedDict([
                                                                                ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                                ('min_sequential', (YLeaf(YType.uint32, 'min-sequential'), ['int'])),
                                                                                ('max_dropout', (YLeaf(YType.uint32, 'max-dropout'), ['int'])),
                                                                                ('max_misorder', (YLeaf(YType.uint32, 'max-misorder'), ['int'])),
                                                                                ('seq_ext_cop4', (YLeaf(YType.uint32, 'seq-ext-cop4'), ['int'])),
                                                                            ])
                                                                            self.action_metric_type = None
                                                                            self.min_sequential = None
                                                                            self.max_dropout = None
                                                                            self.max_misorder = None
                                                                            self.seq_ext_cop4 = None

                                                                            self.clock_rate = YList(self)
                                                                            self._segment_path = lambda: "rtp-j2k"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k, ['action_metric_type', 'min_sequential', 'max_dropout', 'max_misorder', 'seq_ext_cop4'], name, value)


                                                                        class ClockRate(Entity):
                                                                            """
                                                                            clock rate
                                                                            
                                                                            .. attribute:: pt
                                                                            
                                                                            	pt
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: frequency
                                                                            
                                                                            	frequency
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k.ClockRate, self).__init__()

                                                                                self.yang_name = "clock-rate"
                                                                                self.yang_parent_name = "rtp-j2k"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('pt', (YLeaf(YType.uint32, 'pt'), ['int'])),
                                                                                    ('frequency', (YLeaf(YType.uint32, 'frequency'), ['int'])),
                                                                                ])
                                                                                self.pt = None
                                                                                self.frequency = None
                                                                                self._segment_path = lambda: "clock-rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k.ClockRate, ['pt', 'frequency'], name, value)


                                                                    class RtpVoice(Entity):
                                                                        """
                                                                        rtp voice
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: min_sequential
                                                                        
                                                                        	min sequential
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_dropout
                                                                        
                                                                        	max dropout
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_misorder
                                                                        
                                                                        	max misorder
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: seq_ext_cop4
                                                                        
                                                                        	enable seq extension cop4
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: clock_rate
                                                                        
                                                                        	clock rate
                                                                        	**type**\: list of  		 :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice, self).__init__()

                                                                            self.yang_name = "rtp-voice"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("clock-rate", ("clock_rate", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate))])
                                                                            self._leafs = OrderedDict([
                                                                                ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                                ('min_sequential', (YLeaf(YType.uint32, 'min-sequential'), ['int'])),
                                                                                ('max_dropout', (YLeaf(YType.uint32, 'max-dropout'), ['int'])),
                                                                                ('max_misorder', (YLeaf(YType.uint32, 'max-misorder'), ['int'])),
                                                                                ('seq_ext_cop4', (YLeaf(YType.uint32, 'seq-ext-cop4'), ['int'])),
                                                                            ])
                                                                            self.action_metric_type = None
                                                                            self.min_sequential = None
                                                                            self.max_dropout = None
                                                                            self.max_misorder = None
                                                                            self.seq_ext_cop4 = None

                                                                            self.clock_rate = YList(self)
                                                                            self._segment_path = lambda: "rtp-voice"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice, ['action_metric_type', 'min_sequential', 'max_dropout', 'max_misorder', 'seq_ext_cop4'], name, value)


                                                                        class ClockRate(Entity):
                                                                            """
                                                                            clock rate
                                                                            
                                                                            .. attribute:: pt
                                                                            
                                                                            	pt
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: frequency
                                                                            
                                                                            	frequency
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate, self).__init__()

                                                                                self.yang_name = "clock-rate"
                                                                                self.yang_parent_name = "rtp-voice"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('pt', (YLeaf(YType.uint32, 'pt'), ['int'])),
                                                                                    ('frequency', (YLeaf(YType.uint32, 'frequency'), ['int'])),
                                                                                ])
                                                                                self.pt = None
                                                                                self.frequency = None
                                                                                self._segment_path = lambda: "clock-rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate, ['pt', 'frequency'], name, value)


                                                                    class Mdi(Entity):
                                                                        """
                                                                        mdi
                                                                        
                                                                        .. attribute:: ip_bit_rate
                                                                        
                                                                        	data rate in bps
                                                                        	**type**\:  :py:class:`IpBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate>`
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: filtered_pkt_rate
                                                                        
                                                                        	filtered packet rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: ip_pkt_rate
                                                                        
                                                                        	packet rate in pps
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: pids
                                                                        
                                                                        	array of monitoredcd  pids
                                                                        	**type**\: list of int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi, self).__init__()

                                                                            self.yang_name = "mdi"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("ip-bit-rate", ("ip_bit_rate", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate))])
                                                                            self._leafs = OrderedDict([
                                                                                ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                                ('filtered_pkt_rate', (YLeaf(YType.uint32, 'filtered-pkt-rate'), ['int'])),
                                                                                ('ip_pkt_rate', (YLeaf(YType.uint32, 'ip-pkt-rate'), ['int'])),
                                                                                ('pids', (YLeafList(YType.uint32, 'pids'), ['int'])),
                                                                            ])
                                                                            self.action_metric_type = None
                                                                            self.filtered_pkt_rate = None
                                                                            self.ip_pkt_rate = None
                                                                            self.pids = []

                                                                            self.ip_bit_rate = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate()
                                                                            self.ip_bit_rate.parent = self
                                                                            self._children_name_map["ip_bit_rate"] = "ip-bit-rate"
                                                                            self._segment_path = lambda: "mdi"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi, ['action_metric_type', 'filtered_pkt_rate', 'ip_pkt_rate', 'pids'], name, value)


                                                                        class IpBitRate(Entity):
                                                                            """
                                                                            data rate in bps
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate, self).__init__()

                                                                                self.yang_name = "ip-bit-rate"
                                                                                self.yang_parent_name = "mdi"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "ip-bit-rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate, ['value', 'unit'], name, value)


                                                                    class MdiRtp(Entity):
                                                                        """
                                                                        mdi rtp
                                                                        
                                                                        .. attribute:: ip_bit_rate
                                                                        
                                                                        	data rate in bps
                                                                        	**type**\:  :py:class:`IpBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate>`
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: filtered_pkt_rate
                                                                        
                                                                        	filtered packet rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: ip_pkt_rate
                                                                        
                                                                        	packet rate in pps
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: pids
                                                                        
                                                                        	array of monitoredcd  pids
                                                                        	**type**\: list of int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp, self).__init__()

                                                                            self.yang_name = "mdi-rtp"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("ip-bit-rate", ("ip_bit_rate", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate))])
                                                                            self._leafs = OrderedDict([
                                                                                ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                                ('filtered_pkt_rate', (YLeaf(YType.uint32, 'filtered-pkt-rate'), ['int'])),
                                                                                ('ip_pkt_rate', (YLeaf(YType.uint32, 'ip-pkt-rate'), ['int'])),
                                                                                ('pids', (YLeafList(YType.uint32, 'pids'), ['int'])),
                                                                            ])
                                                                            self.action_metric_type = None
                                                                            self.filtered_pkt_rate = None
                                                                            self.ip_pkt_rate = None
                                                                            self.pids = []

                                                                            self.ip_bit_rate = PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate()
                                                                            self.ip_bit_rate.parent = self
                                                                            self._children_name_map["ip_bit_rate"] = "ip-bit-rate"
                                                                            self._segment_path = lambda: "mdi-rtp"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp, ['action_metric_type', 'filtered_pkt_rate', 'ip_pkt_rate', 'pids'], name, value)


                                                                        class IpBitRate(Entity):
                                                                            """
                                                                            data rate in bps
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate, self).__init__()

                                                                                self.yang_name = "ip-bit-rate"
                                                                                self.yang_parent_name = "mdi-rtp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "ip-bit-rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate, ['value', 'unit'], name, value)


                                                                    class Fmm(Entity):
                                                                        """
                                                                        fmm
                                                                        
                                                                        .. attribute:: fmm_name
                                                                        
                                                                        	flow monitor name
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..33
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm, self).__init__()

                                                                            self.yang_name = "fmm"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('fmm_name', (YLeaf(YType.str, 'fmm-name'), ['str'])),
                                                                            ])
                                                                            self.fmm_name = None
                                                                            self._segment_path = lambda: "fmm"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm, ['fmm_name'], name, value)


                                                                    class Pbf(Entity):
                                                                        """
                                                                        pbf
                                                                        
                                                                        .. attribute:: action_pbf_info_array
                                                                        
                                                                        	action pbf info array
                                                                        	**type**\: list of  		 :py:class:`ActionPbfInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf, self).__init__()

                                                                            self.yang_name = "pbf"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("action-pbf-info-array", ("action_pbf_info_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.action_pbf_info_array = YList(self)
                                                                            self._segment_path = lambda: "pbf"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf, [], name, value)


                                                                        class ActionPbfInfoArray(Entity):
                                                                            """
                                                                            action pbf info array
                                                                            
                                                                            .. attribute:: addr
                                                                            
                                                                            	v4 or v6 address
                                                                            	**type**\: str
                                                                            
                                                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                            
                                                                            .. attribute:: vrf
                                                                            
                                                                            	vrf name
                                                                            	**type**\: str
                                                                            
                                                                            .. attribute:: rt_type
                                                                            
                                                                            	route target type
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: rt
                                                                            
                                                                            	route target
                                                                            	**type**\: str
                                                                            
                                                                            	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray, self).__init__()

                                                                                self.yang_name = "action-pbf-info-array"
                                                                                self.yang_parent_name = "pbf"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('addr', (YLeaf(YType.str, 'addr'), ['str'])),
                                                                                    ('vrf', (YLeaf(YType.str, 'vrf'), ['str'])),
                                                                                    ('rt_type', (YLeaf(YType.uint8, 'rt-type'), ['int'])),
                                                                                    ('rt', (YLeaf(YType.str, 'rt'), ['str'])),
                                                                                ])
                                                                                self.addr = None
                                                                                self.vrf = None
                                                                                self.rt_type = None
                                                                                self.rt = None
                                                                                self._segment_path = lambda: "action-pbf-info-array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray, ['addr', 'vrf', 'rt_type', 'rt'], name, value)


                                                                    class Ipv4Nh(Entity):
                                                                        """
                                                                        ipv4 nh
                                                                        
                                                                        .. attribute:: action_ipv4_nh_info_array
                                                                        
                                                                        	action ipv4 nh info array
                                                                        	**type**\: list of  		 :py:class:`ActionIpv4NhInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh, self).__init__()

                                                                            self.yang_name = "ipv4-nh"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("action-ipv4-nh-info-array", ("action_ipv4_nh_info_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.action_ipv4_nh_info_array = YList(self)
                                                                            self._segment_path = lambda: "ipv4-nh"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh, [], name, value)


                                                                        class ActionIpv4NhInfoArray(Entity):
                                                                            """
                                                                            action ipv4 nh info array
                                                                            
                                                                            .. attribute:: nh_addr
                                                                            
                                                                            	nh addr
                                                                            	**type**\: str
                                                                            
                                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                            
                                                                            .. attribute:: vrf_name
                                                                            
                                                                            	Vrf name
                                                                            	**type**\: str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray, self).__init__()

                                                                                self.yang_name = "action-ipv4-nh-info-array"
                                                                                self.yang_parent_name = "ipv4-nh"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('nh_addr', (YLeaf(YType.str, 'nh-addr'), ['str'])),
                                                                                    ('vrf_name', (YLeaf(YType.str, 'vrf-name'), ['str'])),
                                                                                ])
                                                                                self.nh_addr = None
                                                                                self.vrf_name = None
                                                                                self._segment_path = lambda: "action-ipv4-nh-info-array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray, ['nh_addr', 'vrf_name'], name, value)


                                                                    class Ipv6Nh(Entity):
                                                                        """
                                                                        ipv6 nh
                                                                        
                                                                        .. attribute:: action_ipv6_nh_info_array
                                                                        
                                                                        	action ipv6 nh info array
                                                                        	**type**\: list of  		 :py:class:`ActionIpv6NhInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh, self).__init__()

                                                                            self.yang_name = "ipv6-nh"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("action-ipv6-nh-info-array", ("action_ipv6_nh_info_array", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.action_ipv6_nh_info_array = YList(self)
                                                                            self._segment_path = lambda: "ipv6-nh"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh, [], name, value)


                                                                        class ActionIpv6NhInfoArray(Entity):
                                                                            """
                                                                            action ipv6 nh info array
                                                                            
                                                                            .. attribute:: nh_addr
                                                                            
                                                                            	IPV6 Address
                                                                            	**type**\: str
                                                                            
                                                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                            
                                                                            .. attribute:: vrf_name
                                                                            
                                                                            	Vrf name
                                                                            	**type**\: str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray, self).__init__()

                                                                                self.yang_name = "action-ipv6-nh-info-array"
                                                                                self.yang_parent_name = "ipv6-nh"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('nh_addr', (YLeaf(YType.str, 'nh-addr'), ['str'])),
                                                                                    ('vrf_name', (YLeaf(YType.str, 'vrf-name'), ['str'])),
                                                                                ])
                                                                                self.nh_addr = None
                                                                                self.vrf_name = None
                                                                                self._segment_path = lambda: "action-ipv6-nh-info-array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray, ['nh_addr', 'vrf_name'], name, value)


                                class PmapVarList(Entity):
                                    """
                                    pmap var list
                                    
                                    .. attribute:: var_list
                                    
                                    	var list
                                    	**type**\: list of  		 :py:class:`VarList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.PmapVarList.VarList>`
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2018-01-17'

                                    def __init__(self):
                                        super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.PmapVarList, self).__init__()

                                        self.yang_name = "pmap-var-list"
                                        self.yang_parent_name = "detail"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("var-list", ("var_list", PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.PmapVarList.VarList))])
                                        self._leafs = OrderedDict()

                                        self.var_list = YList(self)
                                        self._segment_path = lambda: "pmap-var-list"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.PmapVarList, [], name, value)


                                    class VarList(Entity):
                                        """
                                        var list
                                        
                                        .. attribute:: type
                                        
                                        	type
                                        	**type**\:  :py:class:`PlmgrVarTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrVarTypeEn>`
                                        
                                        .. attribute:: class_name
                                        
                                        	class name
                                        	**type**\: str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: uint8_val
                                        
                                        	uint8 val
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: uint16_val
                                        
                                        	uint16 val
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: uint32_val
                                        
                                        	uint32 val
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: param_uint32_val
                                        
                                        	param uint32 val
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: dscp_val
                                        
                                        	dscp val
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: prec_val
                                        
                                        	prec val
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'infra-policymgr-oper'
                                        _revision = '2018-01-17'

                                        def __init__(self):
                                            super(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.PmapVarList.VarList, self).__init__()

                                            self.yang_name = "var-list"
                                            self.yang_parent_name = "pmap-var-list"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PlmgrVarTypeEn', '')])),
                                                ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                ('uint8_val', (YLeaf(YType.uint8, 'uint8_val'), ['int'])),
                                                ('uint16_val', (YLeaf(YType.uint16, 'uint16_val'), ['int'])),
                                                ('uint32_val', (YLeaf(YType.uint32, 'uint32_val'), ['int'])),
                                                ('param_uint32_val', (YLeaf(YType.uint32, 'param-uint32-val'), ['int'])),
                                                ('dscp_val', (YLeaf(YType.uint8, 'dscp-val'), ['int'])),
                                                ('prec_val', (YLeaf(YType.uint8, 'prec-val'), ['int'])),
                                            ])
                                            self.type = None
                                            self.class_name = None
                                            self.uint8_val = None
                                            self.uint16_val = None
                                            self.uint32_val = None
                                            self.param_uint32_val = None
                                            self.dscp_val = None
                                            self.prec_val = None
                                            self._segment_path = lambda: "var-list"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(PolicyManager.Global.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.PmapVarList.VarList, ['type', 'class_name', 'uint8_val', 'uint16_val', 'uint32_val', 'param_uint32_val', 'dscp_val', 'prec_val'], name, value)


        class TargetPolicyMapTypes(Entity):
            """
            Targets of a policymap
            
            .. attribute:: target_policy_map_type
            
            	Policymgr application type
            	**type**\: list of  		 :py:class:`TargetPolicyMapType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TargetPolicyMapTypes.TargetPolicyMapType>`
            
            

            """

            _prefix = 'infra-policymgr-oper'
            _revision = '2018-01-17'

            def __init__(self):
                super(PolicyManager.Global.TargetPolicyMapTypes, self).__init__()

                self.yang_name = "target-policy-map-types"
                self.yang_parent_name = "global"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("target-policy-map-type", ("target_policy_map_type", PolicyManager.Global.TargetPolicyMapTypes.TargetPolicyMapType))])
                self._leafs = OrderedDict()

                self.target_policy_map_type = YList(self)
                self._segment_path = lambda: "target-policy-map-types"
                self._absolute_path = lambda: "Cisco-IOS-XR-infra-policymgr-oper:policy-manager/global/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(PolicyManager.Global.TargetPolicyMapTypes, [], name, value)


            class TargetPolicyMapType(Entity):
                """
                Policymgr application type
                
                .. attribute:: type  (key)
                
                	The application type
                	**type**\:  :py:class:`PolicymgrPolicyMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicymgrPolicyMap>`
                
                .. attribute:: policy_map_targets
                
                	Policy\-map table
                	**type**\:  :py:class:`PolicyMapTargets <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TargetPolicyMapTypes.TargetPolicyMapType.PolicyMapTargets>`
                
                .. attribute:: policy_map_target_summary
                
                	Policy\-map table
                	**type**\:  :py:class:`PolicyMapTargetSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TargetPolicyMapTypes.TargetPolicyMapType.PolicyMapTargetSummary>`
                
                .. attribute:: target_summary_per_policy_maps
                
                	Policy\-map table per Policy\-map
                	**type**\:  :py:class:`TargetSummaryPerPolicyMaps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TargetPolicyMapTypes.TargetPolicyMapType.TargetSummaryPerPolicyMaps>`
                
                

                """

                _prefix = 'infra-policymgr-oper'
                _revision = '2018-01-17'

                def __init__(self):
                    super(PolicyManager.Global.TargetPolicyMapTypes.TargetPolicyMapType, self).__init__()

                    self.yang_name = "target-policy-map-type"
                    self.yang_parent_name = "target-policy-map-types"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = ['type']
                    self._child_classes = OrderedDict([("policy-map-targets", ("policy_map_targets", PolicyManager.Global.TargetPolicyMapTypes.TargetPolicyMapType.PolicyMapTargets)), ("policy-map-target-summary", ("policy_map_target_summary", PolicyManager.Global.TargetPolicyMapTypes.TargetPolicyMapType.PolicyMapTargetSummary)), ("target-summary-per-policy-maps", ("target_summary_per_policy_maps", PolicyManager.Global.TargetPolicyMapTypes.TargetPolicyMapType.TargetSummaryPerPolicyMaps))])
                    self._leafs = OrderedDict([
                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicymgrPolicyMap', '')])),
                    ])
                    self.type = None

                    self.policy_map_targets = PolicyManager.Global.TargetPolicyMapTypes.TargetPolicyMapType.PolicyMapTargets()
                    self.policy_map_targets.parent = self
                    self._children_name_map["policy_map_targets"] = "policy-map-targets"

                    self.policy_map_target_summary = PolicyManager.Global.TargetPolicyMapTypes.TargetPolicyMapType.PolicyMapTargetSummary()
                    self.policy_map_target_summary.parent = self
                    self._children_name_map["policy_map_target_summary"] = "policy-map-target-summary"

                    self.target_summary_per_policy_maps = PolicyManager.Global.TargetPolicyMapTypes.TargetPolicyMapType.TargetSummaryPerPolicyMaps()
                    self.target_summary_per_policy_maps.parent = self
                    self._children_name_map["target_summary_per_policy_maps"] = "target-summary-per-policy-maps"
                    self._segment_path = lambda: "target-policy-map-type" + "[type='" + str(self.type) + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-infra-policymgr-oper:policy-manager/global/target-policy-map-types/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(PolicyManager.Global.TargetPolicyMapTypes.TargetPolicyMapType, ['type'], name, value)


                class PolicyMapTargets(Entity):
                    """
                    Policy\-map table
                    
                    .. attribute:: policy_map_target
                    
                    	Policy\-map targets
                    	**type**\: list of  		 :py:class:`PolicyMapTarget <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TargetPolicyMapTypes.TargetPolicyMapType.PolicyMapTargets.PolicyMapTarget>`
                    
                    

                    """

                    _prefix = 'infra-policymgr-oper'
                    _revision = '2018-01-17'

                    def __init__(self):
                        super(PolicyManager.Global.TargetPolicyMapTypes.TargetPolicyMapType.PolicyMapTargets, self).__init__()

                        self.yang_name = "policy-map-targets"
                        self.yang_parent_name = "target-policy-map-type"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("policy-map-target", ("policy_map_target", PolicyManager.Global.TargetPolicyMapTypes.TargetPolicyMapType.PolicyMapTargets.PolicyMapTarget))])
                        self._leafs = OrderedDict()

                        self.policy_map_target = YList(self)
                        self._segment_path = lambda: "policy-map-targets"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(PolicyManager.Global.TargetPolicyMapTypes.TargetPolicyMapType.PolicyMapTargets, [], name, value)


                    class PolicyMapTarget(Entity):
                        """
                        Policy\-map targets
                        
                        .. attribute:: policy_map_name  (key)
                        
                        	Name of policy\-map
                        	**type**\: str
                        
                        	**length:** 1..63
                        
                        .. attribute:: targets
                        
                        	targets
                        	**type**\: list of str
                        
                        .. attribute:: parent_targets
                        
                        	parent targets
                        	**type**\: list of str
                        
                        

                        """

                        _prefix = 'infra-policymgr-oper'
                        _revision = '2018-01-17'

                        def __init__(self):
                            super(PolicyManager.Global.TargetPolicyMapTypes.TargetPolicyMapType.PolicyMapTargets.PolicyMapTarget, self).__init__()

                            self.yang_name = "policy-map-target"
                            self.yang_parent_name = "policy-map-targets"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = ['policy_map_name']
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('policy_map_name', (YLeaf(YType.str, 'policy-map-name'), ['str'])),
                                ('targets', (YLeafList(YType.str, 'targets'), ['str'])),
                                ('parent_targets', (YLeafList(YType.str, 'parent-targets'), ['str'])),
                            ])
                            self.policy_map_name = None
                            self.targets = []
                            self.parent_targets = []
                            self._segment_path = lambda: "policy-map-target" + "[policy-map-name='" + str(self.policy_map_name) + "']"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(PolicyManager.Global.TargetPolicyMapTypes.TargetPolicyMapType.PolicyMapTargets.PolicyMapTarget, ['policy_map_name', 'targets', 'parent_targets'], name, value)


                class PolicyMapTargetSummary(Entity):
                    """
                    Policy\-map table
                    
                    .. attribute:: total_policy_maps_input_direction
                    
                    	Total policymapsin the input direction
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: total_policy_maps_output_direction
                    
                    	Total policymapsin the output direction
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: total_child_policy_maps_input_direction
                    
                    	Totalpolicymaps applied as child policy in the input direction
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: total_child_policy_maps_output_direction
                    
                    	Totalpolicymaps applied as child policy in the output direction
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: total_interfaces_input_direction
                    
                    	Totalinterfaces with service\-policy in the input direction
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: total_interfaces_output_direction
                    
                    	Totalinterfaces with service\-policy in the output direction
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'infra-policymgr-oper'
                    _revision = '2018-01-17'

                    def __init__(self):
                        super(PolicyManager.Global.TargetPolicyMapTypes.TargetPolicyMapType.PolicyMapTargetSummary, self).__init__()

                        self.yang_name = "policy-map-target-summary"
                        self.yang_parent_name = "target-policy-map-type"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('total_policy_maps_input_direction', (YLeaf(YType.uint32, 'total-policy-maps-input-direction'), ['int'])),
                            ('total_policy_maps_output_direction', (YLeaf(YType.uint32, 'total-policy-maps-output-direction'), ['int'])),
                            ('total_child_policy_maps_input_direction', (YLeaf(YType.uint32, 'total-child-policy-maps-input-direction'), ['int'])),
                            ('total_child_policy_maps_output_direction', (YLeaf(YType.uint32, 'total-child-policy-maps-output-direction'), ['int'])),
                            ('total_interfaces_input_direction', (YLeaf(YType.uint32, 'total-interfaces-input-direction'), ['int'])),
                            ('total_interfaces_output_direction', (YLeaf(YType.uint32, 'total-interfaces-output-direction'), ['int'])),
                        ])
                        self.total_policy_maps_input_direction = None
                        self.total_policy_maps_output_direction = None
                        self.total_child_policy_maps_input_direction = None
                        self.total_child_policy_maps_output_direction = None
                        self.total_interfaces_input_direction = None
                        self.total_interfaces_output_direction = None
                        self._segment_path = lambda: "policy-map-target-summary"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(PolicyManager.Global.TargetPolicyMapTypes.TargetPolicyMapType.PolicyMapTargetSummary, ['total_policy_maps_input_direction', 'total_policy_maps_output_direction', 'total_child_policy_maps_input_direction', 'total_child_policy_maps_output_direction', 'total_interfaces_input_direction', 'total_interfaces_output_direction'], name, value)


                class TargetSummaryPerPolicyMaps(Entity):
                    """
                    Policy\-map table per Policy\-map
                    
                    .. attribute:: target_summary_per_policy_map
                    
                    	Policy\-map targets summary
                    	**type**\: list of  		 :py:class:`TargetSummaryPerPolicyMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.TargetPolicyMapTypes.TargetPolicyMapType.TargetSummaryPerPolicyMaps.TargetSummaryPerPolicyMap>`
                    
                    

                    """

                    _prefix = 'infra-policymgr-oper'
                    _revision = '2018-01-17'

                    def __init__(self):
                        super(PolicyManager.Global.TargetPolicyMapTypes.TargetPolicyMapType.TargetSummaryPerPolicyMaps, self).__init__()

                        self.yang_name = "target-summary-per-policy-maps"
                        self.yang_parent_name = "target-policy-map-type"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("target-summary-per-policy-map", ("target_summary_per_policy_map", PolicyManager.Global.TargetPolicyMapTypes.TargetPolicyMapType.TargetSummaryPerPolicyMaps.TargetSummaryPerPolicyMap))])
                        self._leafs = OrderedDict()

                        self.target_summary_per_policy_map = YList(self)
                        self._segment_path = lambda: "target-summary-per-policy-maps"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(PolicyManager.Global.TargetPolicyMapTypes.TargetPolicyMapType.TargetSummaryPerPolicyMaps, [], name, value)


                    class TargetSummaryPerPolicyMap(Entity):
                        """
                        Policy\-map targets summary
                        
                        .. attribute:: policy_map_name  (key)
                        
                        	Name of policy\-map
                        	**type**\: str
                        
                        	**length:** 1..63
                        
                        .. attribute:: total_policy_maps_input_direction
                        
                        	Total policymapsin the input direction
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: total_policy_maps_output_direction
                        
                        	Total policymapsin the output direction
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: total_child_policy_maps_input_direction
                        
                        	Totalpolicymaps applied as child policy in the input direction
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: total_child_policy_maps_output_direction
                        
                        	Totalpolicymaps applied as child policy in the output direction
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: total_interfaces_input_direction
                        
                        	Totalinterfaces with service\-policy in the input direction
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: total_interfaces_output_direction
                        
                        	Totalinterfaces with service\-policy in the output direction
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'infra-policymgr-oper'
                        _revision = '2018-01-17'

                        def __init__(self):
                            super(PolicyManager.Global.TargetPolicyMapTypes.TargetPolicyMapType.TargetSummaryPerPolicyMaps.TargetSummaryPerPolicyMap, self).__init__()

                            self.yang_name = "target-summary-per-policy-map"
                            self.yang_parent_name = "target-summary-per-policy-maps"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = ['policy_map_name']
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('policy_map_name', (YLeaf(YType.str, 'policy-map-name'), ['str'])),
                                ('total_policy_maps_input_direction', (YLeaf(YType.uint32, 'total-policy-maps-input-direction'), ['int'])),
                                ('total_policy_maps_output_direction', (YLeaf(YType.uint32, 'total-policy-maps-output-direction'), ['int'])),
                                ('total_child_policy_maps_input_direction', (YLeaf(YType.uint32, 'total-child-policy-maps-input-direction'), ['int'])),
                                ('total_child_policy_maps_output_direction', (YLeaf(YType.uint32, 'total-child-policy-maps-output-direction'), ['int'])),
                                ('total_interfaces_input_direction', (YLeaf(YType.uint32, 'total-interfaces-input-direction'), ['int'])),
                                ('total_interfaces_output_direction', (YLeaf(YType.uint32, 'total-interfaces-output-direction'), ['int'])),
                            ])
                            self.policy_map_name = None
                            self.total_policy_maps_input_direction = None
                            self.total_policy_maps_output_direction = None
                            self.total_child_policy_maps_input_direction = None
                            self.total_child_policy_maps_output_direction = None
                            self.total_interfaces_input_direction = None
                            self.total_interfaces_output_direction = None
                            self._segment_path = lambda: "target-summary-per-policy-map" + "[policy-map-name='" + str(self.policy_map_name) + "']"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(PolicyManager.Global.TargetPolicyMapTypes.TargetPolicyMapType.TargetSummaryPerPolicyMaps.TargetSummaryPerPolicyMap, ['policy_map_name', 'total_policy_maps_input_direction', 'total_policy_maps_output_direction', 'total_child_policy_maps_input_direction', 'total_child_policy_maps_output_direction', 'total_interfaces_input_direction', 'total_interfaces_output_direction'], name, value)


        class ClassMap(Entity):
            """
            List of classmap details
            
            .. attribute:: class_map_types
            
            	Application type of a classmap
            	**type**\:  :py:class:`ClassMapTypes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes>`
            
            

            """

            _prefix = 'infra-policymgr-oper'
            _revision = '2018-01-17'

            def __init__(self):
                super(PolicyManager.Global.ClassMap, self).__init__()

                self.yang_name = "class-map"
                self.yang_parent_name = "global"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("class-map-types", ("class_map_types", PolicyManager.Global.ClassMap.ClassMapTypes))])
                self._leafs = OrderedDict()

                self.class_map_types = PolicyManager.Global.ClassMap.ClassMapTypes()
                self.class_map_types.parent = self
                self._children_name_map["class_map_types"] = "class-map-types"
                self._segment_path = lambda: "class-map"
                self._absolute_path = lambda: "Cisco-IOS-XR-infra-policymgr-oper:policy-manager/global/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(PolicyManager.Global.ClassMap, [], name, value)


            class ClassMapTypes(Entity):
                """
                Application type of a classmap
                
                .. attribute:: class_map_type
                
                	Policymgr application type
                	**type**\: list of  		 :py:class:`ClassMapType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType>`
                
                

                """

                _prefix = 'infra-policymgr-oper'
                _revision = '2018-01-17'

                def __init__(self):
                    super(PolicyManager.Global.ClassMap.ClassMapTypes, self).__init__()

                    self.yang_name = "class-map-types"
                    self.yang_parent_name = "class-map"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("class-map-type", ("class_map_type", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType))])
                    self._leafs = OrderedDict()

                    self.class_map_type = YList(self)
                    self._segment_path = lambda: "class-map-types"
                    self._absolute_path = lambda: "Cisco-IOS-XR-infra-policymgr-oper:policy-manager/global/class-map/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes, [], name, value)


                class ClassMapType(Entity):
                    """
                    Policymgr application type
                    
                    .. attribute:: type  (key)
                    
                    	The application type
                    	**type**\:  :py:class:`PolicymgrClassMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicymgrClassMap>`
                    
                    .. attribute:: class_map_details
                    
                    	Class\-map detail table
                    	**type**\:  :py:class:`ClassMapDetails <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails>`
                    
                    .. attribute:: class_maps
                    
                    	Class\-map definition table
                    	**type**\:  :py:class:`ClassMaps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps>`
                    
                    .. attribute:: class_map_briefs
                    
                    	Class\-map brief table
                    	**type**\:  :py:class:`ClassMapBriefs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs>`
                    
                    

                    """

                    _prefix = 'infra-policymgr-oper'
                    _revision = '2018-01-17'

                    def __init__(self):
                        super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType, self).__init__()

                        self.yang_name = "class-map-type"
                        self.yang_parent_name = "class-map-types"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = ['type']
                        self._child_classes = OrderedDict([("class-map-details", ("class_map_details", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails)), ("class-maps", ("class_maps", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps)), ("class-map-briefs", ("class_map_briefs", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs))])
                        self._leafs = OrderedDict([
                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicymgrClassMap', '')])),
                        ])
                        self.type = None

                        self.class_map_details = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails()
                        self.class_map_details.parent = self
                        self._children_name_map["class_map_details"] = "class-map-details"

                        self.class_maps = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps()
                        self.class_maps.parent = self
                        self._children_name_map["class_maps"] = "class-maps"

                        self.class_map_briefs = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs()
                        self.class_map_briefs.parent = self
                        self._children_name_map["class_map_briefs"] = "class-map-briefs"
                        self._segment_path = lambda: "class-map-type" + "[type='" + str(self.type) + "']"
                        self._absolute_path = lambda: "Cisco-IOS-XR-infra-policymgr-oper:policy-manager/global/class-map/class-map-types/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType, ['type'], name, value)


                    class ClassMapDetails(Entity):
                        """
                        Class\-map detail table
                        
                        .. attribute:: class_map_detail
                        
                        	Class\-map detail information
                        	**type**\: list of  		 :py:class:`ClassMapDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail>`
                        
                        

                        """

                        _prefix = 'infra-policymgr-oper'
                        _revision = '2018-01-17'

                        def __init__(self):
                            super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails, self).__init__()

                            self.yang_name = "class-map-details"
                            self.yang_parent_name = "class-map-type"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("class-map-detail", ("class_map_detail", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail))])
                            self._leafs = OrderedDict()

                            self.class_map_detail = YList(self)
                            self._segment_path = lambda: "class-map-details"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails, [], name, value)


                        class ClassMapDetail(Entity):
                            """
                            Class\-map detail information
                            
                            .. attribute:: class_map_name  (key)
                            
                            	Name of class\-map
                            	**type**\: str
                            
                            	**length:** 1..63
                            
                            .. attribute:: object_type
                            
                            	Application type configured
                            	**type**\:  :py:class:`PlmgrApplnTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrApplnTypeEn>`
                            
                            .. attribute:: total_objects
                            
                            	Total number of objects configured for a specific object type
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: transient
                            
                            	Transient object
                            	**type**\: bool
                            
                            .. attribute:: reference
                            
                            	Each Policymap details
                            	**type**\: list of  		 :py:class:`Reference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail.Reference>`
                            
                            .. attribute:: objects
                            
                            	Each object details
                            	**type**\: list of  		 :py:class:`Objects <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail.Objects>`
                            
                            .. attribute:: class_map_reference
                            
                            	Each Classmapdetails
                            	**type**\: list of  		 :py:class:`ClassMapReference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail.ClassMapReference>`
                            
                            

                            """

                            _prefix = 'infra-policymgr-oper'
                            _revision = '2018-01-17'

                            def __init__(self):
                                super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail, self).__init__()

                                self.yang_name = "class-map-detail"
                                self.yang_parent_name = "class-map-details"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = ['class_map_name']
                                self._child_classes = OrderedDict([("reference", ("reference", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail.Reference)), ("objects", ("objects", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail.Objects)), ("class-map-reference", ("class_map_reference", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail.ClassMapReference))])
                                self._leafs = OrderedDict([
                                    ('class_map_name', (YLeaf(YType.str, 'class-map-name'), ['str'])),
                                    ('object_type', (YLeaf(YType.enumeration, 'object-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PlmgrApplnTypeEn', '')])),
                                    ('total_objects', (YLeaf(YType.uint32, 'total-objects'), ['int'])),
                                    ('transient', (YLeaf(YType.boolean, 'transient'), ['bool'])),
                                ])
                                self.class_map_name = None
                                self.object_type = None
                                self.total_objects = None
                                self.transient = None

                                self.reference = YList(self)
                                self.objects = YList(self)
                                self.class_map_reference = YList(self)
                                self._segment_path = lambda: "class-map-detail" + "[class-map-name='" + str(self.class_map_name) + "']"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail, ['class_map_name', 'object_type', 'total_objects', 'transient'], name, value)


                            class Reference(Entity):
                                """
                                Each Policymap details
                                
                                .. attribute:: total_internal_reference_objects
                                
                                	Total number of internal reference objects
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: total_class_maps
                                
                                	Total number of Classmaps in a Policymap
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: total_flows
                                
                                	Total flows in a Policymap
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'infra-policymgr-oper'
                                _revision = '2018-01-17'

                                def __init__(self):
                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail.Reference, self).__init__()

                                    self.yang_name = "reference"
                                    self.yang_parent_name = "class-map-detail"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('total_internal_reference_objects', (YLeaf(YType.uint32, 'total-internal-reference-objects'), ['int'])),
                                        ('total_class_maps', (YLeaf(YType.uint32, 'total-class-maps'), ['int'])),
                                        ('total_flows', (YLeaf(YType.uint32, 'total-flows'), ['int'])),
                                    ])
                                    self.total_internal_reference_objects = None
                                    self.total_class_maps = None
                                    self.total_flows = None
                                    self._segment_path = lambda: "reference"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail.Reference, ['total_internal_reference_objects', 'total_class_maps', 'total_flows'], name, value)


                            class Objects(Entity):
                                """
                                Each object details
                                
                                .. attribute:: object_name
                                
                                	Name of object (Policymap/Classmap)
                                	**type**\: str
                                
                                	**length:** 0..64
                                
                                

                                """

                                _prefix = 'infra-policymgr-oper'
                                _revision = '2018-01-17'

                                def __init__(self):
                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail.Objects, self).__init__()

                                    self.yang_name = "objects"
                                    self.yang_parent_name = "class-map-detail"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('object_name', (YLeaf(YType.str, 'object-name'), ['str'])),
                                    ])
                                    self.object_name = None
                                    self._segment_path = lambda: "objects"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail.Objects, ['object_name'], name, value)


                            class ClassMapReference(Entity):
                                """
                                Each Classmapdetails
                                
                                .. attribute:: total_reference_objects
                                
                                	Total number of Policymaps referencing a Classmap
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: policy_map_reference
                                
                                	List of Policymaps referencing a Classmap
                                	**type**\: list of  		 :py:class:`PolicyMapReference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail.ClassMapReference.PolicyMapReference>`
                                
                                

                                """

                                _prefix = 'infra-policymgr-oper'
                                _revision = '2018-01-17'

                                def __init__(self):
                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail.ClassMapReference, self).__init__()

                                    self.yang_name = "class-map-reference"
                                    self.yang_parent_name = "class-map-detail"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("policy-map-reference", ("policy_map_reference", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail.ClassMapReference.PolicyMapReference))])
                                    self._leafs = OrderedDict([
                                        ('total_reference_objects', (YLeaf(YType.uint32, 'total-reference-objects'), ['int'])),
                                    ])
                                    self.total_reference_objects = None

                                    self.policy_map_reference = YList(self)
                                    self._segment_path = lambda: "class-map-reference"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail.ClassMapReference, ['total_reference_objects'], name, value)


                                class PolicyMapReference(Entity):
                                    """
                                    List of Policymaps referencing a Classmap
                                    
                                    .. attribute:: object_type
                                    
                                    	Application type configured
                                    	**type**\:  :py:class:`PlmgrApplnTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrApplnTypeEn>`
                                    
                                    .. attribute:: policy_map_name
                                    
                                    	Name of Policymap referencing a Classmap
                                    	**type**\: str
                                    
                                    	**length:** 0..64
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2018-01-17'

                                    def __init__(self):
                                        super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail.ClassMapReference.PolicyMapReference, self).__init__()

                                        self.yang_name = "policy-map-reference"
                                        self.yang_parent_name = "class-map-reference"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('object_type', (YLeaf(YType.enumeration, 'object-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PlmgrApplnTypeEn', '')])),
                                            ('policy_map_name', (YLeaf(YType.str, 'policy-map-name'), ['str'])),
                                        ])
                                        self.object_type = None
                                        self.policy_map_name = None
                                        self._segment_path = lambda: "policy-map-reference"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail.ClassMapReference.PolicyMapReference, ['object_type', 'policy_map_name'], name, value)


                    class ClassMaps(Entity):
                        """
                        Class\-map definition table
                        
                        .. attribute:: class_map
                        
                        	Class\-map configuration
                        	**type**\: list of  		 :py:class:`ClassMap_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_>`
                        
                        

                        """

                        _prefix = 'infra-policymgr-oper'
                        _revision = '2018-01-17'

                        def __init__(self):
                            super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps, self).__init__()

                            self.yang_name = "class-maps"
                            self.yang_parent_name = "class-map-type"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("class-map", ("class_map", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_))])
                            self._leafs = OrderedDict()

                            self.class_map = YList(self)
                            self._segment_path = lambda: "class-maps"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps, [], name, value)


                        class ClassMap_(Entity):
                            """
                            Class\-map configuration
                            
                            .. attribute:: class_map_name  (key)
                            
                            	Name of class\-map
                            	**type**\: str
                            
                            	**length:** 1..63
                            
                            .. attribute:: class_map_bg
                            
                            	class map bg
                            	**type**\: list of  		 :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg>`
                            
                            

                            """

                            _prefix = 'infra-policymgr-oper'
                            _revision = '2018-01-17'

                            def __init__(self):
                                super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_, self).__init__()

                                self.yang_name = "class-map"
                                self.yang_parent_name = "class-maps"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = ['class_map_name']
                                self._child_classes = OrderedDict([("class-map-bg", ("class_map_bg", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg))])
                                self._leafs = OrderedDict([
                                    ('class_map_name', (YLeaf(YType.str, 'class-map-name'), ['str'])),
                                ])
                                self.class_map_name = None

                                self.class_map_bg = YList(self)
                                self._segment_path = lambda: "class-map" + "[class-map-name='" + str(self.class_map_name) + "']"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_, ['class_map_name'], name, value)


                            class ClassMapBg(Entity):
                                """
                                class map bg
                                
                                .. attribute:: match_infop
                                
                                	Pointer to the first Match info
                                	**type**\:  :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop>`
                                
                                .. attribute:: name
                                
                                	Name of the class\-map
                                	**type**\: str
                                
                                	**length:** 0..65
                                
                                .. attribute:: type
                                
                                	Class\-Map Type QoS/PBR/Netflow/..
                                	**type**\:  :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                
                                .. attribute:: mode
                                
                                	Class\-Map Mode Match any/Match all
                                	**type**\:  :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                
                                .. attribute:: description
                                
                                	description
                                	**type**\: str
                                
                                

                                """

                                _prefix = 'infra-policymgr-oper'
                                _revision = '2018-01-17'

                                def __init__(self):
                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg, self).__init__()

                                    self.yang_name = "class-map-bg"
                                    self.yang_parent_name = "class-map"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("match-infop", ("match_infop", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop))])
                                    self._leafs = OrderedDict([
                                        ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapTypeEn', '')])),
                                        ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapModeEn', '')])),
                                        ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                    ])
                                    self.name = None
                                    self.type = None
                                    self.mode = None
                                    self.description = None

                                    self.match_infop = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop()
                                    self.match_infop.parent = self
                                    self._children_name_map["match_infop"] = "match-infop"
                                    self._segment_path = lambda: "class-map-bg"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg, ['name', 'type', 'mode', 'description'], name, value)


                                class MatchInfop(Entity):
                                    """
                                    Pointer to the first Match info
                                    
                                    .. attribute:: class_match_info_st
                                    
                                    	class match info st
                                    	**type**\: list of  		 :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2018-01-17'

                                    def __init__(self):
                                        super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop, self).__init__()

                                        self.yang_name = "match-infop"
                                        self.yang_parent_name = "class-map-bg"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("class-match-info-st", ("class_match_info_st", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt))])
                                        self._leafs = OrderedDict()

                                        self.class_match_info_st = YList(self)
                                        self._segment_path = lambda: "match-infop"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop, [], name, value)


                                    class ClassMatchInfoSt(Entity):
                                        """
                                        class match info st
                                        
                                        .. attribute:: match_data
                                        
                                        	Match criteria
                                        	**type**\:  :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                        
                                        .. attribute:: flags
                                        
                                        	Flags
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'infra-policymgr-oper'
                                        _revision = '2018-01-17'

                                        def __init__(self):
                                            super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                            self.yang_name = "class-match-info-st"
                                            self.yang_parent_name = "match-infop"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("match-data", ("match_data", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData))])
                                            self._leafs = OrderedDict([
                                                ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                            ])
                                            self.flags = None

                                            self.match_data = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                            self.match_data.parent = self
                                            self._children_name_map["match_data"] = "match-data"
                                            self._segment_path = lambda: "class-match-info-st"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                        class MatchData(Entity):
                                            """
                                            Match criteria
                                            
                                            .. attribute:: ipv4_dscp
                                            
                                            	IPv4 DSCP
                                            	**type**\:  :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                            
                                            .. attribute:: ipv6_dscp
                                            
                                            	IPv6 DSCP
                                            	**type**\:  :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                            
                                            .. attribute:: dscp
                                            
                                            	Match DSCP range array
                                            	**type**\:  :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                            
                                            .. attribute:: ipv4_prec
                                            
                                            	IPv4 Precedence
                                            	**type**\:  :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                            
                                            .. attribute:: ipv6_prec
                                            
                                            	IPv6 Precedence
                                            	**type**\:  :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                            
                                            .. attribute:: prec
                                            
                                            	Match Precedence array
                                            	**type**\:  :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                            
                                            .. attribute:: discard_class
                                            
                                            	Match Discard Class array
                                            	**type**\:  :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                            
                                            .. attribute:: qos_group
                                            
                                            	Match QoS group array
                                            	**type**\:  :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                            
                                            .. attribute:: traffic_class
                                            
                                            	Match Traffic class array
                                            	**type**\:  :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                            
                                            .. attribute:: proto
                                            
                                            	Match Protocol array
                                            	**type**\:  :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                            
                                            .. attribute:: icmp_v4
                                            
                                            	Match ICMPV4 Protocol
                                            	**type**\:  :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                            
                                            .. attribute:: icmp_v6
                                            
                                            	Match ICMPV6 Protocol array
                                            	**type**\:  :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                            
                                            .. attribute:: ipv4_packet_len
                                            
                                            	IPv4 packet length array
                                            	**type**\:  :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                            
                                            .. attribute:: ipv6_packet_len
                                            
                                            	IPv6 packet length array
                                            	**type**\:  :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                            
                                            .. attribute:: packet_len
                                            
                                            	Match packet length array
                                            	**type**\:  :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                            
                                            .. attribute:: flow_tag
                                            
                                            	Match flow\-tag array
                                            	**type**\:  :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                            
                                            .. attribute:: tcp_flag
                                            
                                            	Match tcp flag value
                                            	**type**\:  :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                            
                                            .. attribute:: icmpv4_type
                                            
                                            	Match ipv4 icmp type
                                            	**type**\:  :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                            
                                            .. attribute:: icmpv4_code
                                            
                                            	Match ipv4 icmp code
                                            	**type**\:  :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                            
                                            .. attribute:: icmpv6_type
                                            
                                            	Match ipv6 icmp type
                                            	**type**\:  :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                            
                                            .. attribute:: icmpv6_code
                                            
                                            	Match ipv6 icmp code
                                            	**type**\:  :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                            
                                            .. attribute:: mpls_exp
                                            
                                            	Match MPLS experimental topmost array
                                            	**type**\:  :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                            
                                            .. attribute:: mpls_exp_imp
                                            
                                            	Match MPLS experimental imposition array
                                            	**type**\:  :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                            
                                            .. attribute:: mpls_disp_ipv4_acl
                                            
                                            	MPLS Disposition IPv4 Access\-list
                                            	**type**\:  :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                            
                                            .. attribute:: mpls_disp_ipv6_acl
                                            
                                            	MPLS Disposition IPv6 Access\-list
                                            	**type**\:  :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                            
                                            .. attribute:: mpls_top_label
                                            
                                            	MPLS Topmost LABEL
                                            	**type**\:  :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                            
                                            .. attribute:: cos
                                            
                                            	Match CoS array
                                            	**type**\:  :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                            
                                            .. attribute:: cos_inr
                                            
                                            	Match inner header CoS
                                            	**type**\:  :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                            
                                            .. attribute:: dei
                                            
                                            	Match DEI Bit
                                            	**type**\:  :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                            
                                            .. attribute:: dei_inr
                                            
                                            	Match inner DEI Bit
                                            	**type**\:  :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                            
                                            .. attribute:: vlan
                                            
                                            	Match VLAN array
                                            	**type**\:  :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                            
                                            .. attribute:: vlan_inr
                                            
                                            	Match inner header VLAN range array
                                            	**type**\:  :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                            
                                            .. attribute:: fr_dlci
                                            
                                            	Match FR DLCI range array
                                            	**type**\:  :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                            
                                            .. attribute:: src_mac
                                            
                                            	Match Source MAC address
                                            	**type**\:  :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                            
                                            .. attribute:: dst_mac
                                            
                                            	Match Destination MAC address
                                            	**type**\:  :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                            
                                            .. attribute:: atm_clp
                                            
                                            	Match ATM CLP level
                                            	**type**\:  :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                            
                                            .. attribute:: fr_de
                                            
                                            	Match FR DE value
                                            	**type**\:  :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                            
                                            .. attribute:: ipv4_acl
                                            
                                            	IPv4 Access\-list
                                            	**type**\:  :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                            
                                            .. attribute:: ipv6_acl
                                            
                                            	IPv6 Access\-list
                                            	**type**\:  :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                            
                                            .. attribute:: ether_service_acl
                                            
                                            	Ethernet\-Services Access\-list
                                            	**type**\:  :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                            
                                            .. attribute:: avail_id
                                            
                                            	Available Identifiers
                                            	**type**\:  :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                            
                                            .. attribute:: media_type
                                            
                                            	Media Type
                                            	**type**\:  :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                            
                                            .. attribute:: subs_protocol
                                            
                                            	Protocol
                                            	**type**\:  :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                            
                                            .. attribute:: dnis
                                            
                                            	DNIS
                                            	**type**\:  :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                            
                                            .. attribute:: dnis_regex
                                            
                                            	DNIS Regular Expression
                                            	**type**\:  :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                            
                                            .. attribute:: domain
                                            
                                            	Domain Name
                                            	**type**\:  :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                            
                                            .. attribute:: domain_regex
                                            
                                            	Domain Regular Expression
                                            	**type**\:  :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                            
                                            .. attribute:: nas_port
                                            
                                            	NAS Port
                                            	**type**\:  :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                            
                                            .. attribute:: service_name
                                            
                                            	Service Name
                                            	**type**\:  :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                            
                                            .. attribute:: service_name_regex
                                            
                                            	Service Name Regular Exp
                                            	**type**\:  :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                            
                                            .. attribute:: src_addr_ipv4
                                            
                                            	Source Address IPV4
                                            	**type**\:  :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                            
                                            .. attribute:: dst_addr_ipv4
                                            
                                            	Destination Address IPV4
                                            	**type**\:  :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                            
                                            .. attribute:: src_addr_ipv6
                                            
                                            	Source Address IPV6
                                            	**type**\:  :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                            
                                            .. attribute:: dst_addr_ipv6
                                            
                                            	Destination Address IPV6
                                            	**type**\:  :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                            
                                            .. attribute:: src_addr_mac
                                            
                                            	Source Address MAC
                                            	**type**\:  :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                            
                                            .. attribute:: timer
                                            
                                            	Timer
                                            	**type**\:  :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                            
                                            .. attribute:: timer_regexp
                                            
                                            	Timer Regular Expression
                                            	**type**\:  :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                            
                                            .. attribute:: tunnel_name
                                            
                                            	Tunnel Name
                                            	**type**\:  :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                            
                                            .. attribute:: tunnel_name_regex
                                            
                                            	Tunnel Name Regular Expression
                                            	**type**\:  :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                            
                                            .. attribute:: user_name
                                            
                                            	User Name
                                            	**type**\:  :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                            
                                            .. attribute:: user_name_regex
                                            
                                            	User Name Regular Expression
                                            	**type**\:  :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                            
                                            .. attribute:: auth_username
                                            
                                            	Authenticated User Name
                                            	**type**\:  :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                            
                                            .. attribute:: auth_username_regex
                                            
                                            	Authenticated User Name RegEx
                                            	**type**\:  :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                            
                                            .. attribute:: unauth_username
                                            
                                            	Unauthenticated User Name
                                            	**type**\:  :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                            
                                            .. attribute:: unauth_username_regex
                                            
                                            	Unauthenticated User Name RegEx
                                            	**type**\:  :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                            
                                            .. attribute:: auth_domain
                                            
                                            	Authenticated domain name
                                            	**type**\:  :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                            
                                            .. attribute:: auth_domain_regex
                                            
                                            	Authenticated Domain Name RegEx
                                            	**type**\:  :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                            
                                            .. attribute:: unauth_domain
                                            
                                            	Unauthenticated Domain Name
                                            	**type**\:  :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                            
                                            .. attribute:: unauth_domain_regex
                                            
                                            	Unauthenticated Domain Name RegEx
                                            	**type**\:  :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                            
                                            .. attribute:: vendor_id
                                            
                                            	Vendor ID
                                            	**type**\:  :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                            
                                            .. attribute:: vendor_id_regex
                                            
                                            	Vendor ID RegEx
                                            	**type**\:  :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                            
                                            .. attribute:: access_interface
                                            
                                            	Access interface
                                            	**type**\:  :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                            
                                            .. attribute:: input_interface
                                            
                                            	Input interface
                                            	**type**\:  :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                            
                                            .. attribute:: input_intfhdl
                                            
                                            	Input interface handle
                                            	**type**\:  :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                            
                                            .. attribute:: ethertype
                                            
                                            	Ethernet type
                                            	**type**\:  :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                            
                                            .. attribute:: flow_key_data
                                            
                                            	Flow key structure
                                            	**type**\:  :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                            
                                            .. attribute:: dhcp_client_id
                                            
                                            	Dhcp Client ID
                                            	**type**\:  :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                            
                                            .. attribute:: dhcp_client_id_regex
                                            
                                            	Dhcp Client ID RegEx
                                            	**type**\:  :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                            
                                            .. attribute:: circuit_id
                                            
                                            	Circuit ID
                                            	**type**\:  :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                            
                                            .. attribute:: circuit_id_regex
                                            
                                            	Circuit ID RegEx
                                            	**type**\:  :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                            
                                            .. attribute:: remote_id
                                            
                                            	Remote ID
                                            	**type**\:  :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                            
                                            .. attribute:: remote_id_regex
                                            
                                            	Remote ID RegEx
                                            	**type**\:  :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                            
                                            .. attribute:: src_port
                                            
                                            	Source port
                                            	**type**\:  :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                            
                                            .. attribute:: dst_port
                                            
                                            	Destination port
                                            	**type**\:  :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                            
                                            .. attribute:: type
                                            
                                            	type
                                            	**type**\:  :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                            
                                            .. attribute:: mpls_top_eos
                                            
                                            	MPLS Topmost EOS
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: fragment_type
                                            
                                            	Fragment type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: authen_status
                                            
                                            	Authentication Status
                                            	**type**\:  :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                            
                                            .. attribute:: mlp_negotiated
                                            
                                            	MLP Negotiated
                                            	**type**\:  :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                            
                                            

                                            """

                                            _prefix = 'infra-policymgr-oper'
                                            _revision = '2018-01-17'

                                            def __init__(self):
                                                super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                self.yang_name = "match-data"
                                                self.yang_parent_name = "class-match-info-st"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("ipv4-dscp", ("ipv4_dscp", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp)), ("ipv6-dscp", ("ipv6_dscp", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp)), ("dscp", ("dscp", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp)), ("ipv4-prec", ("ipv4_prec", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec)), ("ipv6-prec", ("ipv6_prec", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec)), ("prec", ("prec", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec)), ("discard-class", ("discard_class", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass)), ("qos-group", ("qos_group", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup)), ("traffic-class", ("traffic_class", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass)), ("proto", ("proto", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto)), ("icmp-v4", ("icmp_v4", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4)), ("icmp-v6", ("icmp_v6", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6)), ("ipv4-packet-len", ("ipv4_packet_len", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen)), ("ipv6-packet-len", ("ipv6_packet_len", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen)), ("packet-len", ("packet_len", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen)), ("flow-tag", ("flow_tag", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag)), ("tcp-flag", ("tcp_flag", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag)), ("icmpv4-type", ("icmpv4_type", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type)), ("icmpv4-code", ("icmpv4_code", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code)), ("icmpv6-type", ("icmpv6_type", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type)), ("icmpv6-code", ("icmpv6_code", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code)), ("mpls-exp", ("mpls_exp", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp)), ("mpls-exp-imp", ("mpls_exp_imp", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp)), ("mpls-disp-ipv4-acl", ("mpls_disp_ipv4_acl", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl)), ("mpls-disp-ipv6-acl", ("mpls_disp_ipv6_acl", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl)), ("mpls-top-label", ("mpls_top_label", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel)), ("cos", ("cos", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos)), ("cos-inr", ("cos_inr", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr)), ("dei", ("dei", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei)), ("dei-inr", ("dei_inr", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr)), ("vlan", ("vlan", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan)), ("vlan-inr", ("vlan_inr", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)), ("fr-dlci", ("fr_dlci", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci)), ("src-mac", ("src_mac", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac)), ("dst-mac", ("dst_mac", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac)), ("atm-clp", ("atm_clp", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp)), ("fr-de", ("fr_de", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe)), ("ipv4-acl", ("ipv4_acl", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl)), ("ipv6-acl", ("ipv6_acl", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl)), ("ether-service-acl", ("ether_service_acl", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl)), ("avail-id", ("avail_id", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId)), ("media-type", ("media_type", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType)), ("subs-protocol", ("subs_protocol", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol)), ("dnis", ("dnis", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis)), ("dnis-regex", ("dnis_regex", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex)), ("domain", ("domain", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain)), ("domain-regex", ("domain_regex", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex)), ("nas-port", ("nas_port", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort)), ("service-name", ("service_name", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName)), ("service-name-regex", ("service_name_regex", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex)), ("src-addr-ipv4", ("src_addr_ipv4", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4)), ("dst-addr-ipv4", ("dst_addr_ipv4", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4)), ("src-addr-ipv6", ("src_addr_ipv6", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6)), ("dst-addr-ipv6", ("dst_addr_ipv6", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6)), ("src-addr-mac", ("src_addr_mac", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac)), ("timer", ("timer", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer)), ("timer-regexp", ("timer_regexp", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp)), ("tunnel-name", ("tunnel_name", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName)), ("tunnel-name-regex", ("tunnel_name_regex", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex)), ("user-name", ("user_name", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName)), ("user-name-regex", ("user_name_regex", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex)), ("auth-username", ("auth_username", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername)), ("auth-username-regex", ("auth_username_regex", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex)), ("unauth-username", ("unauth_username", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername)), ("unauth-username-regex", ("unauth_username_regex", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex)), ("auth-domain", ("auth_domain", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain)), ("auth-domain-regex", ("auth_domain_regex", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex)), ("unauth-domain", ("unauth_domain", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain)), ("unauth-domain-regex", ("unauth_domain_regex", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex)), ("vendor-id", ("vendor_id", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId)), ("vendor-id-regex", ("vendor_id_regex", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex)), ("access-interface", ("access_interface", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface)), ("input-interface", ("input_interface", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface)), ("input-intfhdl", ("input_intfhdl", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl)), ("ethertype", ("ethertype", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype)), ("flow-key-data", ("flow_key_data", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData)), ("dhcp-client-id", ("dhcp_client_id", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId)), ("dhcp-client-id-regex", ("dhcp_client_id_regex", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex)), ("circuit-id", ("circuit_id", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId)), ("circuit-id-regex", ("circuit_id_regex", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex)), ("remote-id", ("remote_id", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId)), ("remote-id-regex", ("remote_id_regex", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex)), ("src-port", ("src_port", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort)), ("dst-port", ("dst_port", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort))])
                                                self._leafs = OrderedDict([
                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchTypeEn', '')])),
                                                    ('mpls_top_eos', (YLeaf(YType.uint8, 'mpls-top-eos'), ['int'])),
                                                    ('fragment_type', (YLeaf(YType.uint8, 'fragment-type'), ['int'])),
                                                    ('authen_status', (YLeaf(YType.enumeration, 'authen-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchAuthenStatusEn', '')])),
                                                    ('mlp_negotiated', (YLeaf(YType.enumeration, 'mlp-negotiated'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchMlpNegotiatedEn', '')])),
                                                ])
                                                self.type = None
                                                self.mpls_top_eos = None
                                                self.fragment_type = None
                                                self.authen_status = None
                                                self.mlp_negotiated = None

                                                self.ipv4_dscp = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                self.ipv4_dscp.parent = self
                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"

                                                self.ipv6_dscp = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                self.ipv6_dscp.parent = self
                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"

                                                self.dscp = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                self.dscp.parent = self
                                                self._children_name_map["dscp"] = "dscp"

                                                self.ipv4_prec = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                self.ipv4_prec.parent = self
                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"

                                                self.ipv6_prec = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                self.ipv6_prec.parent = self
                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"

                                                self.prec = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                self.prec.parent = self
                                                self._children_name_map["prec"] = "prec"

                                                self.discard_class = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                self.discard_class.parent = self
                                                self._children_name_map["discard_class"] = "discard-class"

                                                self.qos_group = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                self.qos_group.parent = self
                                                self._children_name_map["qos_group"] = "qos-group"

                                                self.traffic_class = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                self.traffic_class.parent = self
                                                self._children_name_map["traffic_class"] = "traffic-class"

                                                self.proto = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                self.proto.parent = self
                                                self._children_name_map["proto"] = "proto"

                                                self.icmp_v4 = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                self.icmp_v4.parent = self
                                                self._children_name_map["icmp_v4"] = "icmp-v4"

                                                self.icmp_v6 = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                self.icmp_v6.parent = self
                                                self._children_name_map["icmp_v6"] = "icmp-v6"

                                                self.ipv4_packet_len = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                self.ipv4_packet_len.parent = self
                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"

                                                self.ipv6_packet_len = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                self.ipv6_packet_len.parent = self
                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"

                                                self.packet_len = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                self.packet_len.parent = self
                                                self._children_name_map["packet_len"] = "packet-len"

                                                self.flow_tag = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                self.flow_tag.parent = self
                                                self._children_name_map["flow_tag"] = "flow-tag"

                                                self.tcp_flag = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                self.tcp_flag.parent = self
                                                self._children_name_map["tcp_flag"] = "tcp-flag"

                                                self.icmpv4_type = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                self.icmpv4_type.parent = self
                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"

                                                self.icmpv4_code = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                self.icmpv4_code.parent = self
                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"

                                                self.icmpv6_type = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                self.icmpv6_type.parent = self
                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"

                                                self.icmpv6_code = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                self.icmpv6_code.parent = self
                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"

                                                self.mpls_exp = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                self.mpls_exp.parent = self
                                                self._children_name_map["mpls_exp"] = "mpls-exp"

                                                self.mpls_exp_imp = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                self.mpls_exp_imp.parent = self
                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"

                                                self.mpls_disp_ipv4_acl = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                self.mpls_disp_ipv4_acl.parent = self
                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"

                                                self.mpls_disp_ipv6_acl = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                self.mpls_disp_ipv6_acl.parent = self
                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"

                                                self.mpls_top_label = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                self.mpls_top_label.parent = self
                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"

                                                self.cos = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                self.cos.parent = self
                                                self._children_name_map["cos"] = "cos"

                                                self.cos_inr = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                self.cos_inr.parent = self
                                                self._children_name_map["cos_inr"] = "cos-inr"

                                                self.dei = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                self.dei.parent = self
                                                self._children_name_map["dei"] = "dei"

                                                self.dei_inr = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                self.dei_inr.parent = self
                                                self._children_name_map["dei_inr"] = "dei-inr"

                                                self.vlan = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                self.vlan.parent = self
                                                self._children_name_map["vlan"] = "vlan"

                                                self.vlan_inr = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                self.vlan_inr.parent = self
                                                self._children_name_map["vlan_inr"] = "vlan-inr"

                                                self.fr_dlci = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                self.fr_dlci.parent = self
                                                self._children_name_map["fr_dlci"] = "fr-dlci"

                                                self.src_mac = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                self.src_mac.parent = self
                                                self._children_name_map["src_mac"] = "src-mac"

                                                self.dst_mac = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                self.dst_mac.parent = self
                                                self._children_name_map["dst_mac"] = "dst-mac"

                                                self.atm_clp = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                self.atm_clp.parent = self
                                                self._children_name_map["atm_clp"] = "atm-clp"

                                                self.fr_de = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                self.fr_de.parent = self
                                                self._children_name_map["fr_de"] = "fr-de"

                                                self.ipv4_acl = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                self.ipv4_acl.parent = self
                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"

                                                self.ipv6_acl = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                self.ipv6_acl.parent = self
                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"

                                                self.ether_service_acl = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                self.ether_service_acl.parent = self
                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"

                                                self.avail_id = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                self.avail_id.parent = self
                                                self._children_name_map["avail_id"] = "avail-id"

                                                self.media_type = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                self.media_type.parent = self
                                                self._children_name_map["media_type"] = "media-type"

                                                self.subs_protocol = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                self.subs_protocol.parent = self
                                                self._children_name_map["subs_protocol"] = "subs-protocol"

                                                self.dnis = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                self.dnis.parent = self
                                                self._children_name_map["dnis"] = "dnis"

                                                self.dnis_regex = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                self.dnis_regex.parent = self
                                                self._children_name_map["dnis_regex"] = "dnis-regex"

                                                self.domain = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                self.domain.parent = self
                                                self._children_name_map["domain"] = "domain"

                                                self.domain_regex = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                self.domain_regex.parent = self
                                                self._children_name_map["domain_regex"] = "domain-regex"

                                                self.nas_port = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                self.nas_port.parent = self
                                                self._children_name_map["nas_port"] = "nas-port"

                                                self.service_name = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                self.service_name.parent = self
                                                self._children_name_map["service_name"] = "service-name"

                                                self.service_name_regex = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                self.service_name_regex.parent = self
                                                self._children_name_map["service_name_regex"] = "service-name-regex"

                                                self.src_addr_ipv4 = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                self.src_addr_ipv4.parent = self
                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"

                                                self.dst_addr_ipv4 = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                self.dst_addr_ipv4.parent = self
                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"

                                                self.src_addr_ipv6 = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                self.src_addr_ipv6.parent = self
                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"

                                                self.dst_addr_ipv6 = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                self.dst_addr_ipv6.parent = self
                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"

                                                self.src_addr_mac = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                self.src_addr_mac.parent = self
                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"

                                                self.timer = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                self.timer.parent = self
                                                self._children_name_map["timer"] = "timer"

                                                self.timer_regexp = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                self.timer_regexp.parent = self
                                                self._children_name_map["timer_regexp"] = "timer-regexp"

                                                self.tunnel_name = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                self.tunnel_name.parent = self
                                                self._children_name_map["tunnel_name"] = "tunnel-name"

                                                self.tunnel_name_regex = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                self.tunnel_name_regex.parent = self
                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"

                                                self.user_name = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                self.user_name.parent = self
                                                self._children_name_map["user_name"] = "user-name"

                                                self.user_name_regex = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                self.user_name_regex.parent = self
                                                self._children_name_map["user_name_regex"] = "user-name-regex"

                                                self.auth_username = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                self.auth_username.parent = self
                                                self._children_name_map["auth_username"] = "auth-username"

                                                self.auth_username_regex = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                self.auth_username_regex.parent = self
                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"

                                                self.unauth_username = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                self.unauth_username.parent = self
                                                self._children_name_map["unauth_username"] = "unauth-username"

                                                self.unauth_username_regex = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                self.unauth_username_regex.parent = self
                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"

                                                self.auth_domain = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                self.auth_domain.parent = self
                                                self._children_name_map["auth_domain"] = "auth-domain"

                                                self.auth_domain_regex = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                self.auth_domain_regex.parent = self
                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"

                                                self.unauth_domain = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                self.unauth_domain.parent = self
                                                self._children_name_map["unauth_domain"] = "unauth-domain"

                                                self.unauth_domain_regex = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                self.unauth_domain_regex.parent = self
                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"

                                                self.vendor_id = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                self.vendor_id.parent = self
                                                self._children_name_map["vendor_id"] = "vendor-id"

                                                self.vendor_id_regex = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                self.vendor_id_regex.parent = self
                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"

                                                self.access_interface = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                self.access_interface.parent = self
                                                self._children_name_map["access_interface"] = "access-interface"

                                                self.input_interface = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                self.input_interface.parent = self
                                                self._children_name_map["input_interface"] = "input-interface"

                                                self.input_intfhdl = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                self.input_intfhdl.parent = self
                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"

                                                self.ethertype = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                self.ethertype.parent = self
                                                self._children_name_map["ethertype"] = "ethertype"

                                                self.flow_key_data = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                self.flow_key_data.parent = self
                                                self._children_name_map["flow_key_data"] = "flow-key-data"

                                                self.dhcp_client_id = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                self.dhcp_client_id.parent = self
                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"

                                                self.dhcp_client_id_regex = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                self.dhcp_client_id_regex.parent = self
                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"

                                                self.circuit_id = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                self.circuit_id.parent = self
                                                self._children_name_map["circuit_id"] = "circuit-id"

                                                self.circuit_id_regex = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                self.circuit_id_regex.parent = self
                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"

                                                self.remote_id = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                self.remote_id.parent = self
                                                self._children_name_map["remote_id"] = "remote-id"

                                                self.remote_id_regex = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                self.remote_id_regex.parent = self
                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"

                                                self.src_port = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                self.src_port.parent = self
                                                self._children_name_map["src_port"] = "src-port"

                                                self.dst_port = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                self.dst_port.parent = self
                                                self._children_name_map["dst_port"] = "dst-port"
                                                self._segment_path = lambda: "match-data"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['type', 'mpls_top_eos', 'fragment_type', 'authen_status', 'mlp_negotiated'], name, value)


                                            class Ipv4Dscp(Entity):
                                                """
                                                IPv4 DSCP
                                                
                                                .. attribute:: uint8_rng_array
                                                
                                                	uint8 rng array
                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                    self.yang_name = "ipv4-dscp"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray))])
                                                    self._leafs = OrderedDict()

                                                    self.uint8_rng_array = YList(self)
                                                    self._segment_path = lambda: "ipv4-dscp"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                class Uint8RngArray(Entity):
                                                    """
                                                    uint8 rng array
                                                    
                                                    .. attribute:: min
                                                    
                                                    	Lower limit of the range
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: max
                                                    
                                                    	Upper limit of the range
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                        self.yang_name = "uint8_rng_array"
                                                        self.yang_parent_name = "ipv4-dscp"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                        ])
                                                        self.min = None
                                                        self.max = None
                                                        self._segment_path = lambda: "uint8_rng_array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                            class Ipv6Dscp(Entity):
                                                """
                                                IPv6 DSCP
                                                
                                                .. attribute:: uint8_rng_array
                                                
                                                	uint8 rng array
                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                    self.yang_name = "ipv6-dscp"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray))])
                                                    self._leafs = OrderedDict()

                                                    self.uint8_rng_array = YList(self)
                                                    self._segment_path = lambda: "ipv6-dscp"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                class Uint8RngArray(Entity):
                                                    """
                                                    uint8 rng array
                                                    
                                                    .. attribute:: min
                                                    
                                                    	Lower limit of the range
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: max
                                                    
                                                    	Upper limit of the range
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                        self.yang_name = "uint8_rng_array"
                                                        self.yang_parent_name = "ipv6-dscp"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                        ])
                                                        self.min = None
                                                        self.max = None
                                                        self._segment_path = lambda: "uint8_rng_array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                            class Dscp(Entity):
                                                """
                                                Match DSCP range array
                                                
                                                .. attribute:: uint8_rng_array
                                                
                                                	uint8 rng array
                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                    self.yang_name = "dscp"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray))])
                                                    self._leafs = OrderedDict()

                                                    self.uint8_rng_array = YList(self)
                                                    self._segment_path = lambda: "dscp"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                class Uint8RngArray(Entity):
                                                    """
                                                    uint8 rng array
                                                    
                                                    .. attribute:: min
                                                    
                                                    	Lower limit of the range
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: max
                                                    
                                                    	Upper limit of the range
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                        self.yang_name = "uint8_rng_array"
                                                        self.yang_parent_name = "dscp"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                        ])
                                                        self.min = None
                                                        self.max = None
                                                        self._segment_path = lambda: "uint8_rng_array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                            class Ipv4Prec(Entity):
                                                """
                                                IPv4 Precedence
                                                
                                                .. attribute:: uint8_array
                                                
                                                	uint8 array
                                                	**type**\: list of int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                    self.yang_name = "ipv4-prec"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                    ])
                                                    self.uint8_array = []
                                                    self._segment_path = lambda: "ipv4-prec"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                            class Ipv6Prec(Entity):
                                                """
                                                IPv6 Precedence
                                                
                                                .. attribute:: uint8_array
                                                
                                                	uint8 array
                                                	**type**\: list of int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                    self.yang_name = "ipv6-prec"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                    ])
                                                    self.uint8_array = []
                                                    self._segment_path = lambda: "ipv6-prec"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                            class Prec(Entity):
                                                """
                                                Match Precedence array
                                                
                                                .. attribute:: uint8_array
                                                
                                                	uint8 array
                                                	**type**\: list of int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                    self.yang_name = "prec"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                    ])
                                                    self.uint8_array = []
                                                    self._segment_path = lambda: "prec"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                            class DiscardClass(Entity):
                                                """
                                                Match Discard Class array
                                                
                                                .. attribute:: uint8_array
                                                
                                                	uint8 array
                                                	**type**\: list of int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                    self.yang_name = "discard-class"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                    ])
                                                    self.uint8_array = []
                                                    self._segment_path = lambda: "discard-class"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                            class QosGroup(Entity):
                                                """
                                                Match QoS group array
                                                
                                                .. attribute:: uint16_rng_array
                                                
                                                	uint16 rng array
                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                    self.yang_name = "qos-group"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray))])
                                                    self._leafs = OrderedDict()

                                                    self.uint16_rng_array = YList(self)
                                                    self._segment_path = lambda: "qos-group"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                class Uint16RngArray(Entity):
                                                    """
                                                    uint16 rng array
                                                    
                                                    .. attribute:: min
                                                    
                                                    	Lower limit of the range
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: max
                                                    
                                                    	Upper limit of the range
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                        self.yang_name = "uint16_rng_array"
                                                        self.yang_parent_name = "qos-group"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                        ])
                                                        self.min = None
                                                        self.max = None
                                                        self._segment_path = lambda: "uint16_rng_array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['min', 'max'], name, value)


                                            class TrafficClass(Entity):
                                                """
                                                Match Traffic class array
                                                
                                                .. attribute:: uint8_rng_array
                                                
                                                	uint8 rng array
                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                    self.yang_name = "traffic-class"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray))])
                                                    self._leafs = OrderedDict()

                                                    self.uint8_rng_array = YList(self)
                                                    self._segment_path = lambda: "traffic-class"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                class Uint8RngArray(Entity):
                                                    """
                                                    uint8 rng array
                                                    
                                                    .. attribute:: min
                                                    
                                                    	Lower limit of the range
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: max
                                                    
                                                    	Upper limit of the range
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                        self.yang_name = "uint8_rng_array"
                                                        self.yang_parent_name = "traffic-class"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                        ])
                                                        self.min = None
                                                        self.max = None
                                                        self._segment_path = lambda: "uint8_rng_array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['min', 'max'], name, value)


                                            class Proto(Entity):
                                                """
                                                Match Protocol array
                                                
                                                .. attribute:: uint16_rng_array
                                                
                                                	uint16 rng array
                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                    self.yang_name = "proto"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray))])
                                                    self._leafs = OrderedDict()

                                                    self.uint16_rng_array = YList(self)
                                                    self._segment_path = lambda: "proto"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                class Uint16RngArray(Entity):
                                                    """
                                                    uint16 rng array
                                                    
                                                    .. attribute:: min
                                                    
                                                    	Lower limit of the range
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: max
                                                    
                                                    	Upper limit of the range
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                        self.yang_name = "uint16_rng_array"
                                                        self.yang_parent_name = "proto"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                        ])
                                                        self.min = None
                                                        self.max = None
                                                        self._segment_path = lambda: "uint16_rng_array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['min', 'max'], name, value)


                                            class IcmpV4(Entity):
                                                """
                                                Match ICMPV4 Protocol
                                                
                                                .. attribute:: type
                                                
                                                	Protocol type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: code
                                                
                                                	Protocol code
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                    self.yang_name = "icmp-v4"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                    ])
                                                    self.type = None
                                                    self.code = None
                                                    self._segment_path = lambda: "icmp-v4"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['type', 'code'], name, value)


                                            class IcmpV6(Entity):
                                                """
                                                Match ICMPV6 Protocol array
                                                
                                                .. attribute:: type
                                                
                                                	Protocol type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: code
                                                
                                                	Protocol code
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                    self.yang_name = "icmp-v6"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                    ])
                                                    self.type = None
                                                    self.code = None
                                                    self._segment_path = lambda: "icmp-v6"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['type', 'code'], name, value)


                                            class Ipv4PacketLen(Entity):
                                                """
                                                IPv4 packet length array
                                                
                                                .. attribute:: uint16_rng_array
                                                
                                                	uint16 rng array
                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                    self.yang_name = "ipv4-packet-len"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray))])
                                                    self._leafs = OrderedDict()

                                                    self.uint16_rng_array = YList(self)
                                                    self._segment_path = lambda: "ipv4-packet-len"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                class Uint16RngArray(Entity):
                                                    """
                                                    uint16 rng array
                                                    
                                                    .. attribute:: min
                                                    
                                                    	Lower limit of the range
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: max
                                                    
                                                    	Upper limit of the range
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                        self.yang_name = "uint16_rng_array"
                                                        self.yang_parent_name = "ipv4-packet-len"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                        ])
                                                        self.min = None
                                                        self.max = None
                                                        self._segment_path = lambda: "uint16_rng_array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                            class Ipv6PacketLen(Entity):
                                                """
                                                IPv6 packet length array
                                                
                                                .. attribute:: uint16_rng_array
                                                
                                                	uint16 rng array
                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                    self.yang_name = "ipv6-packet-len"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray))])
                                                    self._leafs = OrderedDict()

                                                    self.uint16_rng_array = YList(self)
                                                    self._segment_path = lambda: "ipv6-packet-len"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                class Uint16RngArray(Entity):
                                                    """
                                                    uint16 rng array
                                                    
                                                    .. attribute:: min
                                                    
                                                    	Lower limit of the range
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: max
                                                    
                                                    	Upper limit of the range
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                        self.yang_name = "uint16_rng_array"
                                                        self.yang_parent_name = "ipv6-packet-len"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                        ])
                                                        self.min = None
                                                        self.max = None
                                                        self._segment_path = lambda: "uint16_rng_array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                            class PacketLen(Entity):
                                                """
                                                Match packet length array
                                                
                                                .. attribute:: uint16_rng_array
                                                
                                                	uint16 rng array
                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                    self.yang_name = "packet-len"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray))])
                                                    self._leafs = OrderedDict()

                                                    self.uint16_rng_array = YList(self)
                                                    self._segment_path = lambda: "packet-len"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                class Uint16RngArray(Entity):
                                                    """
                                                    uint16 rng array
                                                    
                                                    .. attribute:: min
                                                    
                                                    	Lower limit of the range
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: max
                                                    
                                                    	Upper limit of the range
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                        self.yang_name = "uint16_rng_array"
                                                        self.yang_parent_name = "packet-len"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                        ])
                                                        self.min = None
                                                        self.max = None
                                                        self._segment_path = lambda: "uint16_rng_array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                            class FlowTag(Entity):
                                                """
                                                Match flow\-tag array
                                                
                                                .. attribute:: uint8_rng_array
                                                
                                                	uint8 rng array
                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                    self.yang_name = "flow-tag"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray))])
                                                    self._leafs = OrderedDict()

                                                    self.uint8_rng_array = YList(self)
                                                    self._segment_path = lambda: "flow-tag"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                class Uint8RngArray(Entity):
                                                    """
                                                    uint8 rng array
                                                    
                                                    .. attribute:: min
                                                    
                                                    	Lower limit of the range
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: max
                                                    
                                                    	Upper limit of the range
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                        self.yang_name = "uint8_rng_array"
                                                        self.yang_parent_name = "flow-tag"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                        ])
                                                        self.min = None
                                                        self.max = None
                                                        self._segment_path = lambda: "uint8_rng_array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['min', 'max'], name, value)


                                            class TcpFlag(Entity):
                                                """
                                                Match tcp flag value
                                                
                                                .. attribute:: value
                                                
                                                	Value of TCP flag
                                                	**type**\: int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: match_any
                                                
                                                	Match any TCP flag bit
                                                	**type**\: bool
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                    self.yang_name = "tcp-flag"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                        ('match_any', (YLeaf(YType.boolean, 'match-any'), ['bool'])),
                                                    ])
                                                    self.value = None
                                                    self.match_any = None
                                                    self._segment_path = lambda: "tcp-flag"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['value', 'match_any'], name, value)


                                            class Icmpv4Type(Entity):
                                                """
                                                Match ipv4 icmp type
                                                
                                                .. attribute:: uint8_rng_array
                                                
                                                	uint8 rng array
                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                    self.yang_name = "icmpv4-type"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray))])
                                                    self._leafs = OrderedDict()

                                                    self.uint8_rng_array = YList(self)
                                                    self._segment_path = lambda: "icmpv4-type"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                class Uint8RngArray(Entity):
                                                    """
                                                    uint8 rng array
                                                    
                                                    .. attribute:: min
                                                    
                                                    	Lower limit of the range
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: max
                                                    
                                                    	Upper limit of the range
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                        self.yang_name = "uint8_rng_array"
                                                        self.yang_parent_name = "icmpv4-type"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                        ])
                                                        self.min = None
                                                        self.max = None
                                                        self._segment_path = lambda: "uint8_rng_array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['min', 'max'], name, value)


                                            class Icmpv4Code(Entity):
                                                """
                                                Match ipv4 icmp code
                                                
                                                .. attribute:: uint8_rng_array
                                                
                                                	uint8 rng array
                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                    self.yang_name = "icmpv4-code"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray))])
                                                    self._leafs = OrderedDict()

                                                    self.uint8_rng_array = YList(self)
                                                    self._segment_path = lambda: "icmpv4-code"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                class Uint8RngArray(Entity):
                                                    """
                                                    uint8 rng array
                                                    
                                                    .. attribute:: min
                                                    
                                                    	Lower limit of the range
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: max
                                                    
                                                    	Upper limit of the range
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                        self.yang_name = "uint8_rng_array"
                                                        self.yang_parent_name = "icmpv4-code"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                        ])
                                                        self.min = None
                                                        self.max = None
                                                        self._segment_path = lambda: "uint8_rng_array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['min', 'max'], name, value)


                                            class Icmpv6Type(Entity):
                                                """
                                                Match ipv6 icmp type
                                                
                                                .. attribute:: uint8_rng_array
                                                
                                                	uint8 rng array
                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                    self.yang_name = "icmpv6-type"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray))])
                                                    self._leafs = OrderedDict()

                                                    self.uint8_rng_array = YList(self)
                                                    self._segment_path = lambda: "icmpv6-type"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                class Uint8RngArray(Entity):
                                                    """
                                                    uint8 rng array
                                                    
                                                    .. attribute:: min
                                                    
                                                    	Lower limit of the range
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: max
                                                    
                                                    	Upper limit of the range
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                        self.yang_name = "uint8_rng_array"
                                                        self.yang_parent_name = "icmpv6-type"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                        ])
                                                        self.min = None
                                                        self.max = None
                                                        self._segment_path = lambda: "uint8_rng_array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['min', 'max'], name, value)


                                            class Icmpv6Code(Entity):
                                                """
                                                Match ipv6 icmp code
                                                
                                                .. attribute:: uint8_rng_array
                                                
                                                	uint8 rng array
                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                    self.yang_name = "icmpv6-code"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray))])
                                                    self._leafs = OrderedDict()

                                                    self.uint8_rng_array = YList(self)
                                                    self._segment_path = lambda: "icmpv6-code"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                class Uint8RngArray(Entity):
                                                    """
                                                    uint8 rng array
                                                    
                                                    .. attribute:: min
                                                    
                                                    	Lower limit of the range
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: max
                                                    
                                                    	Upper limit of the range
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                        self.yang_name = "uint8_rng_array"
                                                        self.yang_parent_name = "icmpv6-code"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                        ])
                                                        self.min = None
                                                        self.max = None
                                                        self._segment_path = lambda: "uint8_rng_array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['min', 'max'], name, value)


                                            class MplsExp(Entity):
                                                """
                                                Match MPLS experimental topmost array
                                                
                                                .. attribute:: uint8_array
                                                
                                                	uint8 array
                                                	**type**\: list of int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                    self.yang_name = "mpls-exp"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                    ])
                                                    self.uint8_array = []
                                                    self._segment_path = lambda: "mpls-exp"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                            class MplsExpImp(Entity):
                                                """
                                                Match MPLS experimental imposition array
                                                
                                                .. attribute:: uint8_array
                                                
                                                	uint8 array
                                                	**type**\: list of int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                    self.yang_name = "mpls-exp-imp"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                    ])
                                                    self.uint8_array = []
                                                    self._segment_path = lambda: "mpls-exp-imp"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                            class MplsDispIpv4Acl(Entity):
                                                """
                                                MPLS Disposition IPv4 Access\-list
                                                
                                                .. attribute:: string_array
                                                
                                                	string array
                                                	**type**\: list of str
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                    ])
                                                    self.string_array = []
                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                            class MplsDispIpv6Acl(Entity):
                                                """
                                                MPLS Disposition IPv6 Access\-list
                                                
                                                .. attribute:: string_array
                                                
                                                	string array
                                                	**type**\: list of str
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                    ])
                                                    self.string_array = []
                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                            class MplsTopLabel(Entity):
                                                """
                                                MPLS Topmost LABEL
                                                
                                                .. attribute:: uint32_rng_array
                                                
                                                	uint32 rng array
                                                	**type**\: list of  		 :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                    self.yang_name = "mpls-top-label"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("uint32_rng_array", ("uint32_rng_array", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray))])
                                                    self._leafs = OrderedDict()

                                                    self.uint32_rng_array = YList(self)
                                                    self._segment_path = lambda: "mpls-top-label"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                class Uint32RngArray(Entity):
                                                    """
                                                    uint32 rng array
                                                    
                                                    .. attribute:: min
                                                    
                                                    	Lower limit of the range
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: max
                                                    
                                                    	Upper limit of the range
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                        self.yang_name = "uint32_rng_array"
                                                        self.yang_parent_name = "mpls-top-label"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('min', (YLeaf(YType.uint32, 'min'), ['int'])),
                                                            ('max', (YLeaf(YType.uint32, 'max'), ['int'])),
                                                        ])
                                                        self.min = None
                                                        self.max = None
                                                        self._segment_path = lambda: "uint32_rng_array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['min', 'max'], name, value)


                                            class Cos(Entity):
                                                """
                                                Match CoS array
                                                
                                                .. attribute:: uint8_array
                                                
                                                	uint8 array
                                                	**type**\: list of int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                    self.yang_name = "cos"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                    ])
                                                    self.uint8_array = []
                                                    self._segment_path = lambda: "cos"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                            class CosInr(Entity):
                                                """
                                                Match inner header CoS
                                                
                                                .. attribute:: uint8_array
                                                
                                                	uint8 array
                                                	**type**\: list of int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                    self.yang_name = "cos-inr"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                    ])
                                                    self.uint8_array = []
                                                    self._segment_path = lambda: "cos-inr"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                            class Dei(Entity):
                                                """
                                                Match DEI Bit
                                                
                                                .. attribute:: bit_value
                                                
                                                	Value of the DEI bit
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                    self.yang_name = "dei"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                    ])
                                                    self.bit_value = None
                                                    self._segment_path = lambda: "dei"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                            class DeiInr(Entity):
                                                """
                                                Match inner DEI Bit
                                                
                                                .. attribute:: bit_value
                                                
                                                	Value of the DEI bit
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                    self.yang_name = "dei-inr"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                    ])
                                                    self.bit_value = None
                                                    self._segment_path = lambda: "dei-inr"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                            class Vlan(Entity):
                                                """
                                                Match VLAN array
                                                
                                                .. attribute:: vlan_id_array
                                                
                                                	vlan id array
                                                	**type**\: list of  		 :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                    self.yang_name = "vlan"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("vlan-id-array", ("vlan_id_array", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray))])
                                                    self._leafs = OrderedDict()

                                                    self.vlan_id_array = YList(self)
                                                    self._segment_path = lambda: "vlan"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                class VlanIdArray(Entity):
                                                    """
                                                    vlan id array
                                                    
                                                    .. attribute:: min
                                                    
                                                    	Lower limit of the range
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: max
                                                    
                                                    	Upper limit of the range
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: mask
                                                    
                                                    	VLAN mask
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                        self.yang_name = "vlan-id-array"
                                                        self.yang_parent_name = "vlan"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                            ('mask', (YLeaf(YType.uint16, 'mask'), ['int'])),
                                                        ])
                                                        self.min = None
                                                        self.max = None
                                                        self.mask = None
                                                        self._segment_path = lambda: "vlan-id-array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['min', 'max', 'mask'], name, value)


                                            class VlanInr(Entity):
                                                """
                                                Match inner header VLAN range array
                                                
                                                .. attribute:: uint16_rng_array
                                                
                                                	uint16 rng array
                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                    self.yang_name = "vlan-inr"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray))])
                                                    self._leafs = OrderedDict()

                                                    self.uint16_rng_array = YList(self)
                                                    self._segment_path = lambda: "vlan-inr"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                class Uint16RngArray(Entity):
                                                    """
                                                    uint16 rng array
                                                    
                                                    .. attribute:: min
                                                    
                                                    	Lower limit of the range
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: max
                                                    
                                                    	Upper limit of the range
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                        self.yang_name = "uint16_rng_array"
                                                        self.yang_parent_name = "vlan-inr"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                        ])
                                                        self.min = None
                                                        self.max = None
                                                        self._segment_path = lambda: "uint16_rng_array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['min', 'max'], name, value)


                                            class FrDlci(Entity):
                                                """
                                                Match FR DLCI range array
                                                
                                                .. attribute:: uint16_rng_array
                                                
                                                	uint16 rng array
                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                    self.yang_name = "fr-dlci"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray))])
                                                    self._leafs = OrderedDict()

                                                    self.uint16_rng_array = YList(self)
                                                    self._segment_path = lambda: "fr-dlci"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                class Uint16RngArray(Entity):
                                                    """
                                                    uint16 rng array
                                                    
                                                    .. attribute:: min
                                                    
                                                    	Lower limit of the range
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: max
                                                    
                                                    	Upper limit of the range
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                        self.yang_name = "uint16_rng_array"
                                                        self.yang_parent_name = "fr-dlci"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                        ])
                                                        self.min = None
                                                        self.max = None
                                                        self._segment_path = lambda: "uint16_rng_array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['min', 'max'], name, value)


                                            class SrcMac(Entity):
                                                """
                                                Match Source MAC address
                                                
                                                .. attribute:: mac_addr
                                                
                                                	MAC address
                                                	**type**\: list of int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: mask
                                                
                                                	MAC mask
                                                	**type**\: list of int
                                                
                                                	**range:** 0..65535
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                    self.yang_name = "src-mac"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                    ])
                                                    self.mac_addr = []
                                                    self.mask = []
                                                    self._segment_path = lambda: "src-mac"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                            class DstMac(Entity):
                                                """
                                                Match Destination MAC address
                                                
                                                .. attribute:: mac_addr
                                                
                                                	MAC address
                                                	**type**\: list of int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: mask
                                                
                                                	MAC mask
                                                	**type**\: list of int
                                                
                                                	**range:** 0..65535
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                    self.yang_name = "dst-mac"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                    ])
                                                    self.mac_addr = []
                                                    self.mask = []
                                                    self._segment_path = lambda: "dst-mac"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                            class AtmClp(Entity):
                                                """
                                                Match ATM CLP level
                                                
                                                .. attribute:: uint8_array
                                                
                                                	uint8 array
                                                	**type**\: list of int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                    self.yang_name = "atm-clp"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                    ])
                                                    self.uint8_array = []
                                                    self._segment_path = lambda: "atm-clp"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                            class FrDe(Entity):
                                                """
                                                Match FR DE value
                                                
                                                .. attribute:: uint8_array
                                                
                                                	uint8 array
                                                	**type**\: list of int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                    self.yang_name = "fr-de"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                    ])
                                                    self.uint8_array = []
                                                    self._segment_path = lambda: "fr-de"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                            class Ipv4Acl(Entity):
                                                """
                                                IPv4 Access\-list
                                                
                                                .. attribute:: string_array
                                                
                                                	string array
                                                	**type**\: list of str
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                    self.yang_name = "ipv4-acl"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                    ])
                                                    self.string_array = []
                                                    self._segment_path = lambda: "ipv4-acl"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                            class Ipv6Acl(Entity):
                                                """
                                                IPv6 Access\-list
                                                
                                                .. attribute:: string_array
                                                
                                                	string array
                                                	**type**\: list of str
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                    self.yang_name = "ipv6-acl"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                    ])
                                                    self.string_array = []
                                                    self._segment_path = lambda: "ipv6-acl"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                            class EtherServiceAcl(Entity):
                                                """
                                                Ethernet\-Services Access\-list
                                                
                                                .. attribute:: string_array
                                                
                                                	string array
                                                	**type**\: list of str
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                    self.yang_name = "ether-service-acl"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                    ])
                                                    self.string_array = []
                                                    self._segment_path = lambda: "ether-service-acl"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                            class AvailId(Entity):
                                                """
                                                Available Identifiers
                                                
                                                .. attribute:: uint8_array
                                                
                                                	uint8 array
                                                	**type**\: list of int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                    self.yang_name = "avail-id"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                    ])
                                                    self.uint8_array = []
                                                    self._segment_path = lambda: "avail-id"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                            class MediaType(Entity):
                                                """
                                                Media Type
                                                
                                                .. attribute:: uint8_array
                                                
                                                	uint8 array
                                                	**type**\: list of int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                    self.yang_name = "media-type"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                    ])
                                                    self.uint8_array = []
                                                    self._segment_path = lambda: "media-type"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                            class SubsProtocol(Entity):
                                                """
                                                Protocol
                                                
                                                .. attribute:: uint8_array
                                                
                                                	uint8 array
                                                	**type**\: list of int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                    self.yang_name = "subs-protocol"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                    ])
                                                    self.uint8_array = []
                                                    self._segment_path = lambda: "subs-protocol"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                            class Dnis(Entity):
                                                """
                                                DNIS
                                                
                                                .. attribute:: string_array
                                                
                                                	string array
                                                	**type**\: list of str
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                    self.yang_name = "dnis"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                    ])
                                                    self.string_array = []
                                                    self._segment_path = lambda: "dnis"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                            class DnisRegex(Entity):
                                                """
                                                DNIS Regular Expression
                                                
                                                .. attribute:: string_array
                                                
                                                	string array
                                                	**type**\: list of str
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                    self.yang_name = "dnis-regex"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                    ])
                                                    self.string_array = []
                                                    self._segment_path = lambda: "dnis-regex"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                            class Domain(Entity):
                                                """
                                                Domain Name
                                                
                                                .. attribute:: domain_array
                                                
                                                	domain array
                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                    self.yang_name = "domain"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray))])
                                                    self._leafs = OrderedDict()

                                                    self.domain_array = YList(self)
                                                    self._segment_path = lambda: "domain"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                class DomainArray(Entity):
                                                    """
                                                    domain array
                                                    
                                                    .. attribute:: domain_name
                                                    
                                                    	domain name
                                                    	**type**\: str
                                                    
                                                    .. attribute:: format_name
                                                    
                                                    	format name
                                                    	**type**\: str
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                        self.yang_name = "domain-array"
                                                        self.yang_parent_name = "domain"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                        ])
                                                        self.domain_name = None
                                                        self.format_name = None
                                                        self._segment_path = lambda: "domain-array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                            class DomainRegex(Entity):
                                                """
                                                Domain Regular Expression
                                                
                                                .. attribute:: domain_array
                                                
                                                	domain array
                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                    self.yang_name = "domain-regex"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray))])
                                                    self._leafs = OrderedDict()

                                                    self.domain_array = YList(self)
                                                    self._segment_path = lambda: "domain-regex"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                class DomainArray(Entity):
                                                    """
                                                    domain array
                                                    
                                                    .. attribute:: domain_name
                                                    
                                                    	domain name
                                                    	**type**\: str
                                                    
                                                    .. attribute:: format_name
                                                    
                                                    	format name
                                                    	**type**\: str
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                        self.yang_name = "domain-array"
                                                        self.yang_parent_name = "domain-regex"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                        ])
                                                        self.domain_name = None
                                                        self.format_name = None
                                                        self._segment_path = lambda: "domain-array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                            class NasPort(Entity):
                                                """
                                                NAS Port
                                                
                                                .. attribute:: nas_port_array
                                                
                                                	nas port array
                                                	**type**\: list of  		 :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                    self.yang_name = "nas-port"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("nas-port-array", ("nas_port_array", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray))])
                                                    self._leafs = OrderedDict()

                                                    self.nas_port_array = YList(self)
                                                    self._segment_path = lambda: "nas-port"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                class NasPortArray(Entity):
                                                    """
                                                    nas port array
                                                    
                                                    .. attribute:: sub_id
                                                    
                                                    	sub id
                                                    	**type**\:  :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                    
                                                    .. attribute:: operator
                                                    
                                                    	operator
                                                    	**type**\:  :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                        self.yang_name = "nas-port-array"
                                                        self.yang_parent_name = "nas-port"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('sub_id', (YLeaf(YType.enumeration, 'sub-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchNasPortSubIdEn', '')])),
                                                            ('operator', (YLeaf(YType.enumeration, 'operator'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchLogicalOperatorEn', '')])),
                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                        ])
                                                        self.sub_id = None
                                                        self.operator = None
                                                        self.value = None
                                                        self._segment_path = lambda: "nas-port-array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['sub_id', 'operator', 'value'], name, value)


                                            class ServiceName(Entity):
                                                """
                                                Service Name
                                                
                                                .. attribute:: string_array
                                                
                                                	string array
                                                	**type**\: list of str
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                    self.yang_name = "service-name"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                    ])
                                                    self.string_array = []
                                                    self._segment_path = lambda: "service-name"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                            class ServiceNameRegex(Entity):
                                                """
                                                Service Name Regular Exp
                                                
                                                .. attribute:: string_array
                                                
                                                	string array
                                                	**type**\: list of str
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                    self.yang_name = "service-name-regex"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                    ])
                                                    self.string_array = []
                                                    self._segment_path = lambda: "service-name-regex"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                            class SrcAddrIpv4(Entity):
                                                """
                                                Source Address IPV4
                                                
                                                .. attribute:: ipv4_addr_array
                                                
                                                	ipv4 addr array
                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                    self.yang_name = "src-addr-ipv4"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray))])
                                                    self._leafs = OrderedDict()

                                                    self.ipv4_addr_array = YList(self)
                                                    self._segment_path = lambda: "src-addr-ipv4"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                class Ipv4AddrArray(Entity):
                                                    """
                                                    ipv4 addr array
                                                    
                                                    .. attribute:: prefix
                                                    
                                                    	prefix
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: mask
                                                    
                                                    	mask
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                        self.yang_name = "ipv4-addr-array"
                                                        self.yang_parent_name = "src-addr-ipv4"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                        ])
                                                        self.prefix = None
                                                        self.mask = None
                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                            class DstAddrIpv4(Entity):
                                                """
                                                Destination Address IPV4
                                                
                                                .. attribute:: ipv4_addr_array
                                                
                                                	ipv4 addr array
                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                    self.yang_name = "dst-addr-ipv4"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray))])
                                                    self._leafs = OrderedDict()

                                                    self.ipv4_addr_array = YList(self)
                                                    self._segment_path = lambda: "dst-addr-ipv4"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                class Ipv4AddrArray(Entity):
                                                    """
                                                    ipv4 addr array
                                                    
                                                    .. attribute:: prefix
                                                    
                                                    	prefix
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: mask
                                                    
                                                    	mask
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                        self.yang_name = "ipv4-addr-array"
                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                        ])
                                                        self.prefix = None
                                                        self.mask = None
                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                            class SrcAddrIpv6(Entity):
                                                """
                                                Source Address IPV6
                                                
                                                .. attribute:: ipv6_addr_array
                                                
                                                	ipv6 addr array
                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                    self.yang_name = "src-addr-ipv6"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray))])
                                                    self._leafs = OrderedDict()

                                                    self.ipv6_addr_array = YList(self)
                                                    self._segment_path = lambda: "src-addr-ipv6"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                class Ipv6AddrArray(Entity):
                                                    """
                                                    ipv6 addr array
                                                    
                                                    .. attribute:: prefix
                                                    
                                                    	IPV6 prefix
                                                    	**type**\: str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: mask
                                                    
                                                    	IPV6 mask
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                        self.yang_name = "ipv6-addr-array"
                                                        self.yang_parent_name = "src-addr-ipv6"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                        ])
                                                        self.prefix = None
                                                        self.mask = None
                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                            class DstAddrIpv6(Entity):
                                                """
                                                Destination Address IPV6
                                                
                                                .. attribute:: ipv6_addr_array
                                                
                                                	ipv6 addr array
                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                    self.yang_name = "dst-addr-ipv6"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray))])
                                                    self._leafs = OrderedDict()

                                                    self.ipv6_addr_array = YList(self)
                                                    self._segment_path = lambda: "dst-addr-ipv6"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                class Ipv6AddrArray(Entity):
                                                    """
                                                    ipv6 addr array
                                                    
                                                    .. attribute:: prefix
                                                    
                                                    	IPV6 prefix
                                                    	**type**\: str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: mask
                                                    
                                                    	IPV6 mask
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                        self.yang_name = "ipv6-addr-array"
                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                        ])
                                                        self.prefix = None
                                                        self.mask = None
                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                            class SrcAddrMac(Entity):
                                                """
                                                Source Address MAC
                                                
                                                .. attribute:: mac_addr_array
                                                
                                                	mac addr array
                                                	**type**\: list of  		 :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                    self.yang_name = "src-addr-mac"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("mac-addr-array", ("mac_addr_array", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray))])
                                                    self._leafs = OrderedDict()

                                                    self.mac_addr_array = YList(self)
                                                    self._segment_path = lambda: "src-addr-mac"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                class MacAddrArray(Entity):
                                                    """
                                                    mac addr array
                                                    
                                                    .. attribute:: mac_addr
                                                    
                                                    	MAC address
                                                    	**type**\: list of int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: mask
                                                    
                                                    	MAC mask
                                                    	**type**\: list of int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                        self.yang_name = "mac-addr-array"
                                                        self.yang_parent_name = "src-addr-mac"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                            ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                        ])
                                                        self.mac_addr = []
                                                        self.mask = []
                                                        self._segment_path = lambda: "mac-addr-array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                            class Timer(Entity):
                                                """
                                                Timer
                                                
                                                .. attribute:: string_array
                                                
                                                	string array
                                                	**type**\: list of str
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                    self.yang_name = "timer"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                    ])
                                                    self.string_array = []
                                                    self._segment_path = lambda: "timer"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                            class TimerRegexp(Entity):
                                                """
                                                Timer Regular Expression
                                                
                                                .. attribute:: string_array
                                                
                                                	string array
                                                	**type**\: list of str
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                    self.yang_name = "timer-regexp"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                    ])
                                                    self.string_array = []
                                                    self._segment_path = lambda: "timer-regexp"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                            class TunnelName(Entity):
                                                """
                                                Tunnel Name
                                                
                                                .. attribute:: string_array
                                                
                                                	string array
                                                	**type**\: list of str
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                    self.yang_name = "tunnel-name"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                    ])
                                                    self.string_array = []
                                                    self._segment_path = lambda: "tunnel-name"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                            class TunnelNameRegex(Entity):
                                                """
                                                Tunnel Name Regular Expression
                                                
                                                .. attribute:: string_array
                                                
                                                	string array
                                                	**type**\: list of str
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                    self.yang_name = "tunnel-name-regex"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                    ])
                                                    self.string_array = []
                                                    self._segment_path = lambda: "tunnel-name-regex"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                            class UserName(Entity):
                                                """
                                                User Name
                                                
                                                .. attribute:: string_array
                                                
                                                	string array
                                                	**type**\: list of str
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                    self.yang_name = "user-name"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                    ])
                                                    self.string_array = []
                                                    self._segment_path = lambda: "user-name"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                            class UserNameRegex(Entity):
                                                """
                                                User Name Regular Expression
                                                
                                                .. attribute:: string_array
                                                
                                                	string array
                                                	**type**\: list of str
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                    self.yang_name = "user-name-regex"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                    ])
                                                    self.string_array = []
                                                    self._segment_path = lambda: "user-name-regex"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                            class AuthUsername(Entity):
                                                """
                                                Authenticated User Name
                                                
                                                .. attribute:: string_array
                                                
                                                	string array
                                                	**type**\: list of str
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                    self.yang_name = "auth-username"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                    ])
                                                    self.string_array = []
                                                    self._segment_path = lambda: "auth-username"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                            class AuthUsernameRegex(Entity):
                                                """
                                                Authenticated User Name RegEx
                                                
                                                .. attribute:: string_array
                                                
                                                	string array
                                                	**type**\: list of str
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                    self.yang_name = "auth-username-regex"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                    ])
                                                    self.string_array = []
                                                    self._segment_path = lambda: "auth-username-regex"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                            class UnauthUsername(Entity):
                                                """
                                                Unauthenticated User Name
                                                
                                                .. attribute:: string_array
                                                
                                                	string array
                                                	**type**\: list of str
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                    self.yang_name = "unauth-username"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                    ])
                                                    self.string_array = []
                                                    self._segment_path = lambda: "unauth-username"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                            class UnauthUsernameRegex(Entity):
                                                """
                                                Unauthenticated User Name RegEx
                                                
                                                .. attribute:: string_array
                                                
                                                	string array
                                                	**type**\: list of str
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                    self.yang_name = "unauth-username-regex"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                    ])
                                                    self.string_array = []
                                                    self._segment_path = lambda: "unauth-username-regex"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                            class AuthDomain(Entity):
                                                """
                                                Authenticated domain name
                                                
                                                .. attribute:: string_array
                                                
                                                	string array
                                                	**type**\: list of str
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                    self.yang_name = "auth-domain"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                    ])
                                                    self.string_array = []
                                                    self._segment_path = lambda: "auth-domain"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                            class AuthDomainRegex(Entity):
                                                """
                                                Authenticated Domain Name RegEx
                                                
                                                .. attribute:: string_array
                                                
                                                	string array
                                                	**type**\: list of str
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                    self.yang_name = "auth-domain-regex"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                    ])
                                                    self.string_array = []
                                                    self._segment_path = lambda: "auth-domain-regex"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                            class UnauthDomain(Entity):
                                                """
                                                Unauthenticated Domain Name
                                                
                                                .. attribute:: string_array
                                                
                                                	string array
                                                	**type**\: list of str
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                    self.yang_name = "unauth-domain"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                    ])
                                                    self.string_array = []
                                                    self._segment_path = lambda: "unauth-domain"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                            class UnauthDomainRegex(Entity):
                                                """
                                                Unauthenticated Domain Name RegEx
                                                
                                                .. attribute:: string_array
                                                
                                                	string array
                                                	**type**\: list of str
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                    self.yang_name = "unauth-domain-regex"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                    ])
                                                    self.string_array = []
                                                    self._segment_path = lambda: "unauth-domain-regex"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                            class VendorId(Entity):
                                                """
                                                Vendor ID
                                                
                                                .. attribute:: string_array
                                                
                                                	string array
                                                	**type**\: list of str
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                    self.yang_name = "vendor-id"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                    ])
                                                    self.string_array = []
                                                    self._segment_path = lambda: "vendor-id"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                            class VendorIdRegex(Entity):
                                                """
                                                Vendor ID RegEx
                                                
                                                .. attribute:: string_array
                                                
                                                	string array
                                                	**type**\: list of str
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                    self.yang_name = "vendor-id-regex"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                    ])
                                                    self.string_array = []
                                                    self._segment_path = lambda: "vendor-id-regex"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                            class AccessInterface(Entity):
                                                """
                                                Access interface
                                                
                                                .. attribute:: string_array
                                                
                                                	string array
                                                	**type**\: list of str
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                    self.yang_name = "access-interface"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                    ])
                                                    self.string_array = []
                                                    self._segment_path = lambda: "access-interface"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                            class InputInterface(Entity):
                                                """
                                                Input interface
                                                
                                                .. attribute:: string_array
                                                
                                                	string array
                                                	**type**\: list of str
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                    self.yang_name = "input-interface"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                    ])
                                                    self.string_array = []
                                                    self._segment_path = lambda: "input-interface"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                            class InputIntfhdl(Entity):
                                                """
                                                Input interface handle
                                                
                                                .. attribute:: uint64_array
                                                
                                                	uint64 array
                                                	**type**\: list of int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                    self.yang_name = "input-intfhdl"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('uint64_array', (YLeafList(YType.uint64, 'uint64_array'), ['int'])),
                                                    ])
                                                    self.uint64_array = []
                                                    self._segment_path = lambda: "input-intfhdl"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                            class Ethertype(Entity):
                                                """
                                                Ethernet type
                                                
                                                .. attribute:: uint16_rng_array
                                                
                                                	uint16 rng array
                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                    self.yang_name = "ethertype"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray))])
                                                    self._leafs = OrderedDict()

                                                    self.uint16_rng_array = YList(self)
                                                    self._segment_path = lambda: "ethertype"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                class Uint16RngArray(Entity):
                                                    """
                                                    uint16 rng array
                                                    
                                                    .. attribute:: min
                                                    
                                                    	Lower limit of the range
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: max
                                                    
                                                    	Upper limit of the range
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                        self.yang_name = "uint16_rng_array"
                                                        self.yang_parent_name = "ethertype"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                        ])
                                                        self.min = None
                                                        self.max = None
                                                        self._segment_path = lambda: "uint16_rng_array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['min', 'max'], name, value)


                                            class FlowKeyData(Entity):
                                                """
                                                Flow key structure
                                                
                                                .. attribute:: flow_keys
                                                
                                                	flow keys
                                                	**type**\:  :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                
                                                .. attribute:: max_count
                                                
                                                	Maximum count of flows
                                                	**type**\: int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: idle_timeout
                                                
                                                	Idle timeout of flows (in seconds)
                                                	**type**\: int
                                                
                                                	**range:** 0..65535
                                                
                                                	**units**\: second
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                    self.yang_name = "flow-key-data"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("flow-keys", ("flow_keys", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys))])
                                                    self._leafs = OrderedDict([
                                                        ('max_count', (YLeaf(YType.uint16, 'max-count'), ['int'])),
                                                        ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                    ])
                                                    self.max_count = None
                                                    self.idle_timeout = None

                                                    self.flow_keys = PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                    self.flow_keys.parent = self
                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                    self._segment_path = lambda: "flow-key-data"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['max_count', 'idle_timeout'], name, value)


                                                class FlowKeys(Entity):
                                                    """
                                                    flow keys
                                                    
                                                    .. attribute:: keys
                                                    
                                                    	keys
                                                    	**type**\: str
                                                    
                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                    
                                                    .. attribute:: num
                                                    
                                                    	num
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                        self.yang_name = "flow-keys"
                                                        self.yang_parent_name = "flow-key-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('keys', (YLeaf(YType.str, 'keys'), ['str'])),
                                                            ('num', (YLeaf(YType.uint8, 'num'), ['int'])),
                                                        ])
                                                        self.keys = None
                                                        self.num = None
                                                        self._segment_path = lambda: "flow-keys"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                            class DhcpClientId(Entity):
                                                """
                                                Dhcp Client ID
                                                
                                                .. attribute:: string_array
                                                
                                                	string array
                                                	**type**\: list of str
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                    self.yang_name = "dhcp-client-id"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                    ])
                                                    self.string_array = []
                                                    self._segment_path = lambda: "dhcp-client-id"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                            class DhcpClientIdRegex(Entity):
                                                """
                                                Dhcp Client ID RegEx
                                                
                                                .. attribute:: string_array
                                                
                                                	string array
                                                	**type**\: list of str
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                    self.yang_name = "dhcp-client-id-regex"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                    ])
                                                    self.string_array = []
                                                    self._segment_path = lambda: "dhcp-client-id-regex"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                            class CircuitId(Entity):
                                                """
                                                Circuit ID
                                                
                                                .. attribute:: string_array
                                                
                                                	string array
                                                	**type**\: list of str
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                    self.yang_name = "circuit-id"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                    ])
                                                    self.string_array = []
                                                    self._segment_path = lambda: "circuit-id"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                            class CircuitIdRegex(Entity):
                                                """
                                                Circuit ID RegEx
                                                
                                                .. attribute:: string_array
                                                
                                                	string array
                                                	**type**\: list of str
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                    self.yang_name = "circuit-id-regex"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                    ])
                                                    self.string_array = []
                                                    self._segment_path = lambda: "circuit-id-regex"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                            class RemoteId(Entity):
                                                """
                                                Remote ID
                                                
                                                .. attribute:: string_array
                                                
                                                	string array
                                                	**type**\: list of str
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                    self.yang_name = "remote-id"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                    ])
                                                    self.string_array = []
                                                    self._segment_path = lambda: "remote-id"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                            class RemoteIdRegex(Entity):
                                                """
                                                Remote ID RegEx
                                                
                                                .. attribute:: string_array
                                                
                                                	string array
                                                	**type**\: list of str
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                    self.yang_name = "remote-id-regex"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                    ])
                                                    self.string_array = []
                                                    self._segment_path = lambda: "remote-id-regex"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                            class SrcPort(Entity):
                                                """
                                                Source port
                                                
                                                .. attribute:: uint16_rng_array
                                                
                                                	uint16 rng array
                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                    self.yang_name = "src-port"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray))])
                                                    self._leafs = OrderedDict()

                                                    self.uint16_rng_array = YList(self)
                                                    self._segment_path = lambda: "src-port"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                class Uint16RngArray(Entity):
                                                    """
                                                    uint16 rng array
                                                    
                                                    .. attribute:: min
                                                    
                                                    	Lower limit of the range
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: max
                                                    
                                                    	Upper limit of the range
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                        self.yang_name = "uint16_rng_array"
                                                        self.yang_parent_name = "src-port"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                        ])
                                                        self.min = None
                                                        self.max = None
                                                        self._segment_path = lambda: "uint16_rng_array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['min', 'max'], name, value)


                                            class DstPort(Entity):
                                                """
                                                Destination port
                                                
                                                .. attribute:: uint16_rng_array
                                                
                                                	uint16 rng array
                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                    self.yang_name = "dst-port"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray))])
                                                    self._leafs = OrderedDict()

                                                    self.uint16_rng_array = YList(self)
                                                    self._segment_path = lambda: "dst-port"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                class Uint16RngArray(Entity):
                                                    """
                                                    uint16 rng array
                                                    
                                                    .. attribute:: min
                                                    
                                                    	Lower limit of the range
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: max
                                                    
                                                    	Upper limit of the range
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                        self.yang_name = "uint16_rng_array"
                                                        self.yang_parent_name = "dst-port"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                        ])
                                                        self.min = None
                                                        self.max = None
                                                        self._segment_path = lambda: "uint16_rng_array"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['min', 'max'], name, value)


                    class ClassMapBriefs(Entity):
                        """
                        Class\-map brief table
                        
                        .. attribute:: class_map_brief
                        
                        	Class\-map brief information
                        	**type**\: list of  		 :py:class:`ClassMapBrief <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief>`
                        
                        

                        """

                        _prefix = 'infra-policymgr-oper'
                        _revision = '2018-01-17'

                        def __init__(self):
                            super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs, self).__init__()

                            self.yang_name = "class-map-briefs"
                            self.yang_parent_name = "class-map-type"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("class-map-brief", ("class_map_brief", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief))])
                            self._leafs = OrderedDict()

                            self.class_map_brief = YList(self)
                            self._segment_path = lambda: "class-map-briefs"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs, [], name, value)


                        class ClassMapBrief(Entity):
                            """
                            Class\-map brief information
                            
                            .. attribute:: class_map_name  (key)
                            
                            	Name of class\-map
                            	**type**\: str
                            
                            	**length:** 1..63
                            
                            .. attribute:: object_type
                            
                            	Application type configured
                            	**type**\:  :py:class:`PlmgrApplnTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrApplnTypeEn>`
                            
                            .. attribute:: total_objects
                            
                            	Total number of objects configured for a specific object type
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: transient
                            
                            	Transient object
                            	**type**\: bool
                            
                            .. attribute:: reference
                            
                            	Each Policymap details
                            	**type**\: list of  		 :py:class:`Reference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief.Reference>`
                            
                            .. attribute:: objects
                            
                            	Each object details
                            	**type**\: list of  		 :py:class:`Objects <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief.Objects>`
                            
                            .. attribute:: class_map_reference
                            
                            	Each Classmapdetails
                            	**type**\: list of  		 :py:class:`ClassMapReference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief.ClassMapReference>`
                            
                            

                            """

                            _prefix = 'infra-policymgr-oper'
                            _revision = '2018-01-17'

                            def __init__(self):
                                super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief, self).__init__()

                                self.yang_name = "class-map-brief"
                                self.yang_parent_name = "class-map-briefs"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = ['class_map_name']
                                self._child_classes = OrderedDict([("reference", ("reference", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief.Reference)), ("objects", ("objects", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief.Objects)), ("class-map-reference", ("class_map_reference", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief.ClassMapReference))])
                                self._leafs = OrderedDict([
                                    ('class_map_name', (YLeaf(YType.str, 'class-map-name'), ['str'])),
                                    ('object_type', (YLeaf(YType.enumeration, 'object-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PlmgrApplnTypeEn', '')])),
                                    ('total_objects', (YLeaf(YType.uint32, 'total-objects'), ['int'])),
                                    ('transient', (YLeaf(YType.boolean, 'transient'), ['bool'])),
                                ])
                                self.class_map_name = None
                                self.object_type = None
                                self.total_objects = None
                                self.transient = None

                                self.reference = YList(self)
                                self.objects = YList(self)
                                self.class_map_reference = YList(self)
                                self._segment_path = lambda: "class-map-brief" + "[class-map-name='" + str(self.class_map_name) + "']"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief, ['class_map_name', 'object_type', 'total_objects', 'transient'], name, value)


                            class Reference(Entity):
                                """
                                Each Policymap details
                                
                                .. attribute:: total_internal_reference_objects
                                
                                	Total number of internal reference objects
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: total_class_maps
                                
                                	Total number of Classmaps in a Policymap
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: total_flows
                                
                                	Total flows in a Policymap
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'infra-policymgr-oper'
                                _revision = '2018-01-17'

                                def __init__(self):
                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief.Reference, self).__init__()

                                    self.yang_name = "reference"
                                    self.yang_parent_name = "class-map-brief"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('total_internal_reference_objects', (YLeaf(YType.uint32, 'total-internal-reference-objects'), ['int'])),
                                        ('total_class_maps', (YLeaf(YType.uint32, 'total-class-maps'), ['int'])),
                                        ('total_flows', (YLeaf(YType.uint32, 'total-flows'), ['int'])),
                                    ])
                                    self.total_internal_reference_objects = None
                                    self.total_class_maps = None
                                    self.total_flows = None
                                    self._segment_path = lambda: "reference"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief.Reference, ['total_internal_reference_objects', 'total_class_maps', 'total_flows'], name, value)


                            class Objects(Entity):
                                """
                                Each object details
                                
                                .. attribute:: object_name
                                
                                	Name of object (Policymap/Classmap)
                                	**type**\: str
                                
                                	**length:** 0..64
                                
                                

                                """

                                _prefix = 'infra-policymgr-oper'
                                _revision = '2018-01-17'

                                def __init__(self):
                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief.Objects, self).__init__()

                                    self.yang_name = "objects"
                                    self.yang_parent_name = "class-map-brief"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('object_name', (YLeaf(YType.str, 'object-name'), ['str'])),
                                    ])
                                    self.object_name = None
                                    self._segment_path = lambda: "objects"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief.Objects, ['object_name'], name, value)


                            class ClassMapReference(Entity):
                                """
                                Each Classmapdetails
                                
                                .. attribute:: total_reference_objects
                                
                                	Total number of Policymaps referencing a Classmap
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: policy_map_reference
                                
                                	List of Policymaps referencing a Classmap
                                	**type**\: list of  		 :py:class:`PolicyMapReference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief.ClassMapReference.PolicyMapReference>`
                                
                                

                                """

                                _prefix = 'infra-policymgr-oper'
                                _revision = '2018-01-17'

                                def __init__(self):
                                    super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief.ClassMapReference, self).__init__()

                                    self.yang_name = "class-map-reference"
                                    self.yang_parent_name = "class-map-brief"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("policy-map-reference", ("policy_map_reference", PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief.ClassMapReference.PolicyMapReference))])
                                    self._leafs = OrderedDict([
                                        ('total_reference_objects', (YLeaf(YType.uint32, 'total-reference-objects'), ['int'])),
                                    ])
                                    self.total_reference_objects = None

                                    self.policy_map_reference = YList(self)
                                    self._segment_path = lambda: "class-map-reference"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief.ClassMapReference, ['total_reference_objects'], name, value)


                                class PolicyMapReference(Entity):
                                    """
                                    List of Policymaps referencing a Classmap
                                    
                                    .. attribute:: object_type
                                    
                                    	Application type configured
                                    	**type**\:  :py:class:`PlmgrApplnTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrApplnTypeEn>`
                                    
                                    .. attribute:: policy_map_name
                                    
                                    	Name of Policymap referencing a Classmap
                                    	**type**\: str
                                    
                                    	**length:** 0..64
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2018-01-17'

                                    def __init__(self):
                                        super(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief.ClassMapReference.PolicyMapReference, self).__init__()

                                        self.yang_name = "policy-map-reference"
                                        self.yang_parent_name = "class-map-reference"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('object_type', (YLeaf(YType.enumeration, 'object-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PlmgrApplnTypeEn', '')])),
                                            ('policy_map_name', (YLeaf(YType.str, 'policy-map-name'), ['str'])),
                                        ])
                                        self.object_type = None
                                        self.policy_map_name = None
                                        self._segment_path = lambda: "policy-map-reference"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Global.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief.ClassMapReference.PolicyMapReference, ['object_type', 'policy_map_name'], name, value)


        class PolicyMap(Entity):
            """
            List of policymap details
            
            .. attribute:: transient_policy_map_type_xr
            
            	Application type of transient policy\-map
            	**type**\:  :py:class:`TransientPolicyMapTypeXr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr>`
            
            .. attribute:: policy_map_unused_types
            
            	Policy\-map unused table
            	**type**\:  :py:class:`PolicyMapUnusedTypes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapUnusedTypes>`
            
            .. attribute:: policy_map_types
            
            	Application type of a policymap
            	**type**\:  :py:class:`PolicyMapTypes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes>`
            
            .. attribute:: transient_policy_map_types
            
            	Application type of transient policy\-map list
            	**type**\:  :py:class:`TransientPolicyMapTypes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypes>`
            
            

            """

            _prefix = 'infra-policymgr-oper'
            _revision = '2018-01-17'

            def __init__(self):
                super(PolicyManager.Global.PolicyMap, self).__init__()

                self.yang_name = "policy-map"
                self.yang_parent_name = "global"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("transient-policy-map-type-xr", ("transient_policy_map_type_xr", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr)), ("policy-map-unused-types", ("policy_map_unused_types", PolicyManager.Global.PolicyMap.PolicyMapUnusedTypes)), ("policy-map-types", ("policy_map_types", PolicyManager.Global.PolicyMap.PolicyMapTypes)), ("transient-policy-map-types", ("transient_policy_map_types", PolicyManager.Global.PolicyMap.TransientPolicyMapTypes))])
                self._leafs = OrderedDict()

                self.transient_policy_map_type_xr = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr()
                self.transient_policy_map_type_xr.parent = self
                self._children_name_map["transient_policy_map_type_xr"] = "transient-policy-map-type-xr"

                self.policy_map_unused_types = PolicyManager.Global.PolicyMap.PolicyMapUnusedTypes()
                self.policy_map_unused_types.parent = self
                self._children_name_map["policy_map_unused_types"] = "policy-map-unused-types"

                self.policy_map_types = PolicyManager.Global.PolicyMap.PolicyMapTypes()
                self.policy_map_types.parent = self
                self._children_name_map["policy_map_types"] = "policy-map-types"

                self.transient_policy_map_types = PolicyManager.Global.PolicyMap.TransientPolicyMapTypes()
                self.transient_policy_map_types.parent = self
                self._children_name_map["transient_policy_map_types"] = "transient-policy-map-types"
                self._segment_path = lambda: "policy-map"
                self._absolute_path = lambda: "Cisco-IOS-XR-infra-policymgr-oper:policy-manager/global/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(PolicyManager.Global.PolicyMap, [], name, value)


            class TransientPolicyMapTypeXr(Entity):
                """
                Application type of transient policy\-map
                
                .. attribute:: transient_policy_map_type
                
                	Transient policy\-map type
                	**type**\: list of  		 :py:class:`TransientPolicyMapType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType>`
                
                

                """

                _prefix = 'infra-policymgr-oper'
                _revision = '2018-01-17'

                def __init__(self):
                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr, self).__init__()

                    self.yang_name = "transient-policy-map-type-xr"
                    self.yang_parent_name = "policy-map"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("transient-policy-map-type", ("transient_policy_map_type", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType))])
                    self._leafs = OrderedDict()

                    self.transient_policy_map_type = YList(self)
                    self._segment_path = lambda: "transient-policy-map-type-xr"
                    self._absolute_path = lambda: "Cisco-IOS-XR-infra-policymgr-oper:policy-manager/global/policy-map/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr, [], name, value)


                class TransientPolicyMapType(Entity):
                    """
                    Transient policy\-map type
                    
                    .. attribute:: type  (key)
                    
                    	The application type
                    	**type**\:  :py:class:`PolicymgrPolicyMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicymgrPolicyMap>`
                    
                    .. attribute:: transient_policy_map_names
                    
                    	Transient policy\-map definition table
                    	**type**\:  :py:class:`TransientPolicyMapNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames>`
                    
                    

                    """

                    _prefix = 'infra-policymgr-oper'
                    _revision = '2018-01-17'

                    def __init__(self):
                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType, self).__init__()

                        self.yang_name = "transient-policy-map-type"
                        self.yang_parent_name = "transient-policy-map-type-xr"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = ['type']
                        self._child_classes = OrderedDict([("transient-policy-map-names", ("transient_policy_map_names", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames))])
                        self._leafs = OrderedDict([
                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicymgrPolicyMap', '')])),
                        ])
                        self.type = None

                        self.transient_policy_map_names = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames()
                        self.transient_policy_map_names.parent = self
                        self._children_name_map["transient_policy_map_names"] = "transient-policy-map-names"
                        self._segment_path = lambda: "transient-policy-map-type" + "[type='" + str(self.type) + "']"
                        self._absolute_path = lambda: "Cisco-IOS-XR-infra-policymgr-oper:policy-manager/global/policy-map/transient-policy-map-type-xr/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType, ['type'], name, value)


                    class TransientPolicyMapNames(Entity):
                        """
                        Transient policy\-map definition table
                        
                        .. attribute:: transient_policy_map_name
                        
                        	Transient policy\-map definition table
                        	**type**\: list of  		 :py:class:`TransientPolicyMapName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName>`
                        
                        

                        """

                        _prefix = 'infra-policymgr-oper'
                        _revision = '2018-01-17'

                        def __init__(self):
                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames, self).__init__()

                            self.yang_name = "transient-policy-map-names"
                            self.yang_parent_name = "transient-policy-map-type"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("transient-policy-map-name", ("transient_policy_map_name", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName))])
                            self._leafs = OrderedDict()

                            self.transient_policy_map_name = YList(self)
                            self._segment_path = lambda: "transient-policy-map-names"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames, [], name, value)


                        class TransientPolicyMapName(Entity):
                            """
                            Transient policy\-map definition table
                            
                            .. attribute:: policy_map_name  (key)
                            
                            	Name of policy\-map
                            	**type**\: str
                            
                            	**length:** 1..63
                            
                            .. attribute:: class_handles
                            
                            	Transient policy\-map class handle table
                            	**type**\:  :py:class:`ClassHandles <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles>`
                            
                            .. attribute:: class_seq_nums
                            
                            	Transient policy\-map sequence number table
                            	**type**\:  :py:class:`ClassSeqNums <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums>`
                            
                            .. attribute:: definition
                            
                            	Transient Policy\-map type name
                            	**type**\:  :py:class:`Definition <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition>`
                            
                            

                            """

                            _prefix = 'infra-policymgr-oper'
                            _revision = '2018-01-17'

                            def __init__(self):
                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName, self).__init__()

                                self.yang_name = "transient-policy-map-name"
                                self.yang_parent_name = "transient-policy-map-names"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = ['policy_map_name']
                                self._child_classes = OrderedDict([("class-handles", ("class_handles", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles)), ("class-seq-nums", ("class_seq_nums", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums)), ("definition", ("definition", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition))])
                                self._leafs = OrderedDict([
                                    ('policy_map_name', (YLeaf(YType.str, 'policy-map-name'), ['str'])),
                                ])
                                self.policy_map_name = None

                                self.class_handles = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles()
                                self.class_handles.parent = self
                                self._children_name_map["class_handles"] = "class-handles"

                                self.class_seq_nums = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums()
                                self.class_seq_nums.parent = self
                                self._children_name_map["class_seq_nums"] = "class-seq-nums"

                                self.definition = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition()
                                self.definition.parent = self
                                self._children_name_map["definition"] = "definition"
                                self._segment_path = lambda: "transient-policy-map-name" + "[policy-map-name='" + str(self.policy_map_name) + "']"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName, ['policy_map_name'], name, value)


                            class ClassHandles(Entity):
                                """
                                Transient policy\-map class handle table
                                
                                .. attribute:: class_handle
                                
                                	Transient policy\-map class handle
                                	**type**\: list of  		 :py:class:`ClassHandle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle>`
                                
                                

                                """

                                _prefix = 'infra-policymgr-oper'
                                _revision = '2018-01-17'

                                def __init__(self):
                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles, self).__init__()

                                    self.yang_name = "class-handles"
                                    self.yang_parent_name = "transient-policy-map-name"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("class-handle", ("class_handle", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle))])
                                    self._leafs = OrderedDict()

                                    self.class_handle = YList(self)
                                    self._segment_path = lambda: "class-handles"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles, [], name, value)


                                class ClassHandle(Entity):
                                    """
                                    Transient policy\-map class handle
                                    
                                    .. attribute:: inline_classhandle  (key)
                                    
                                    	inline class handle
                                    	**type**\: int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: policy_map_bg
                                    
                                    	policy map bg
                                    	**type**\: list of  		 :py:class:`PolicyMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg>`
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2018-01-17'

                                    def __init__(self):
                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle, self).__init__()

                                        self.yang_name = "class-handle"
                                        self.yang_parent_name = "class-handles"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = ['inline_classhandle']
                                        self._child_classes = OrderedDict([("policy-map-bg", ("policy_map_bg", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg))])
                                        self._leafs = OrderedDict([
                                            ('inline_classhandle', (YLeaf(YType.int32, 'inline-classhandle'), ['int'])),
                                        ])
                                        self.inline_classhandle = None

                                        self.policy_map_bg = YList(self)
                                        self._segment_path = lambda: "class-handle" + "[inline-classhandle='" + str(self.inline_classhandle) + "']"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle, ['inline_classhandle'], name, value)


                                    class PolicyMapBg(Entity):
                                        """
                                        policy map bg
                                        
                                        .. attribute:: pmap_var_list
                                        
                                        	pmap var list
                                        	**type**\:  :py:class:`PmapVarList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.PmapVarList>`
                                        
                                        .. attribute:: event_infop
                                        
                                        	event infop
                                        	**type**\:  :py:class:`EventInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop>`
                                        
                                        .. attribute:: name
                                        
                                        	name
                                        	**type**\: str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: type
                                        
                                        	type
                                        	**type**\:  :py:class:`PolicyMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyMapTypeEn>`
                                        
                                        .. attribute:: description
                                        
                                        	description
                                        	**type**\: str
                                        
                                        

                                        """

                                        _prefix = 'infra-policymgr-oper'
                                        _revision = '2018-01-17'

                                        def __init__(self):
                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg, self).__init__()

                                            self.yang_name = "policy-map-bg"
                                            self.yang_parent_name = "class-handle"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("pmap-var-list", ("pmap_var_list", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.PmapVarList)), ("event-infop", ("event_infop", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop))])
                                            self._leafs = OrderedDict([
                                                ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyMapTypeEn', '')])),
                                                ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                            ])
                                            self.name = None
                                            self.type = None
                                            self.description = None

                                            self.pmap_var_list = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.PmapVarList()
                                            self.pmap_var_list.parent = self
                                            self._children_name_map["pmap_var_list"] = "pmap-var-list"

                                            self.event_infop = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop()
                                            self.event_infop.parent = self
                                            self._children_name_map["event_infop"] = "event-infop"
                                            self._segment_path = lambda: "policy-map-bg"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg, ['name', 'type', 'description'], name, value)


                                        class PmapVarList(Entity):
                                            """
                                            pmap var list
                                            
                                            .. attribute:: pmap_var_list_arr
                                            
                                            	pmap var list arr
                                            	**type**\: list of  		 :py:class:`PmapVarListArr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.PmapVarList.PmapVarListArr>`
                                            
                                            

                                            """

                                            _prefix = 'infra-policymgr-oper'
                                            _revision = '2018-01-17'

                                            def __init__(self):
                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.PmapVarList, self).__init__()

                                                self.yang_name = "pmap-var-list"
                                                self.yang_parent_name = "policy-map-bg"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("pmap-var-list-arr", ("pmap_var_list_arr", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.PmapVarList.PmapVarListArr))])
                                                self._leafs = OrderedDict()

                                                self.pmap_var_list_arr = YList(self)
                                                self._segment_path = lambda: "pmap-var-list"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.PmapVarList, [], name, value)


                                            class PmapVarListArr(Entity):
                                                """
                                                pmap var list arr
                                                
                                                .. attribute:: val
                                                
                                                	val
                                                	**type**\:  :py:class:`Val <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.PmapVarList.PmapVarListArr.Val>`
                                                
                                                .. attribute:: name
                                                
                                                	name
                                                	**type**\: str
                                                
                                                	**length:** 0..32
                                                
                                                .. attribute:: id
                                                
                                                	id
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.PmapVarList.PmapVarListArr, self).__init__()

                                                    self.yang_name = "pmap-var-list-arr"
                                                    self.yang_parent_name = "pmap-var-list"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("val", ("val", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.PmapVarList.PmapVarListArr.Val))])
                                                    self._leafs = OrderedDict([
                                                        ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                        ('id', (YLeaf(YType.uint32, 'id'), ['int'])),
                                                    ])
                                                    self.name = None
                                                    self.id = None

                                                    self.val = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.PmapVarList.PmapVarListArr.Val()
                                                    self.val.parent = self
                                                    self._children_name_map["val"] = "val"
                                                    self._segment_path = lambda: "pmap-var-list-arr"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.PmapVarList.PmapVarListArr, ['name', 'id'], name, value)


                                                class Val(Entity):
                                                    """
                                                    val
                                                    
                                                    .. attribute:: type
                                                    
                                                    	type
                                                    	**type**\:  :py:class:`PlmgrVarTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrVarTypeEn>`
                                                    
                                                    .. attribute:: class_name
                                                    
                                                    	class name
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..65
                                                    
                                                    .. attribute:: uint8_val
                                                    
                                                    	uint8 val
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: uint16_val
                                                    
                                                    	uint16 val
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: uint32_val
                                                    
                                                    	uint32 val
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: param_uint32_val
                                                    
                                                    	param uint32 val
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: dscp_val
                                                    
                                                    	dscp val
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: prec_val
                                                    
                                                    	prec val
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.PmapVarList.PmapVarListArr.Val, self).__init__()

                                                        self.yang_name = "val"
                                                        self.yang_parent_name = "pmap-var-list-arr"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PlmgrVarTypeEn', '')])),
                                                            ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                            ('uint8_val', (YLeaf(YType.uint8, 'uint8_val'), ['int'])),
                                                            ('uint16_val', (YLeaf(YType.uint16, 'uint16_val'), ['int'])),
                                                            ('uint32_val', (YLeaf(YType.uint32, 'uint32_val'), ['int'])),
                                                            ('param_uint32_val', (YLeaf(YType.uint32, 'param-uint32-val'), ['int'])),
                                                            ('dscp_val', (YLeaf(YType.uint8, 'dscp-val'), ['int'])),
                                                            ('prec_val', (YLeaf(YType.uint8, 'prec-val'), ['int'])),
                                                        ])
                                                        self.type = None
                                                        self.class_name = None
                                                        self.uint8_val = None
                                                        self.uint16_val = None
                                                        self.uint32_val = None
                                                        self.param_uint32_val = None
                                                        self.dscp_val = None
                                                        self.prec_val = None
                                                        self._segment_path = lambda: "val"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.PmapVarList.PmapVarListArr.Val, ['type', 'class_name', 'uint8_val', 'uint16_val', 'uint32_val', 'param_uint32_val', 'dscp_val', 'prec_val'], name, value)


                                        class EventInfop(Entity):
                                            """
                                            event infop
                                            
                                            .. attribute:: policy_event_info_bg
                                            
                                            	policy event info bg
                                            	**type**\: list of  		 :py:class:`PolicyEventInfoBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg>`
                                            
                                            

                                            """

                                            _prefix = 'infra-policymgr-oper'
                                            _revision = '2018-01-17'

                                            def __init__(self):
                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop, self).__init__()

                                                self.yang_name = "event-infop"
                                                self.yang_parent_name = "policy-map-bg"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("policy-event-info-bg", ("policy_event_info_bg", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg))])
                                                self._leafs = OrderedDict()

                                                self.policy_event_info_bg = YList(self)
                                                self._segment_path = lambda: "event-infop"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop, [], name, value)


                                            class PolicyEventInfoBg(Entity):
                                                """
                                                policy event info bg
                                                
                                                .. attribute:: class_infop
                                                
                                                	class infop
                                                	**type**\:  :py:class:`ClassInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop>`
                                                
                                                .. attribute:: event_type
                                                
                                                	event type
                                                	**type**\:  :py:class:`PeventTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PeventTypeEn>`
                                                
                                                .. attribute:: cond_eval
                                                
                                                	cond eval
                                                	**type**\:  :py:class:`PeventCondEvalEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PeventCondEvalEn>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg, self).__init__()

                                                    self.yang_name = "policy-event-info-bg"
                                                    self.yang_parent_name = "event-infop"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("class-infop", ("class_infop", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop))])
                                                    self._leafs = OrderedDict([
                                                        ('event_type', (YLeaf(YType.enumeration, 'event-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PeventTypeEn', '')])),
                                                        ('cond_eval', (YLeaf(YType.enumeration, 'cond-eval'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PeventCondEvalEn', '')])),
                                                    ])
                                                    self.event_type = None
                                                    self.cond_eval = None

                                                    self.class_infop = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop()
                                                    self.class_infop.parent = self
                                                    self._children_name_map["class_infop"] = "class-infop"
                                                    self._segment_path = lambda: "policy-event-info-bg"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg, ['event_type', 'cond_eval'], name, value)


                                                class ClassInfop(Entity):
                                                    """
                                                    class infop
                                                    
                                                    .. attribute:: policy_class_info_bg
                                                    
                                                    	policy class info bg
                                                    	**type**\: list of  		 :py:class:`PolicyClassInfoBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop, self).__init__()

                                                        self.yang_name = "class-infop"
                                                        self.yang_parent_name = "policy-event-info-bg"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("policy-class-info-bg", ("policy_class_info_bg", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg))])
                                                        self._leafs = OrderedDict()

                                                        self.policy_class_info_bg = YList(self)
                                                        self._segment_path = lambda: "class-infop"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop, [], name, value)


                                                    class PolicyClassInfoBg(Entity):
                                                        """
                                                        policy class info bg
                                                        
                                                        .. attribute:: cl_encode
                                                        
                                                        	cl encode
                                                        	**type**\:  :py:class:`ClEncode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode>`
                                                        
                                                        .. attribute:: clmp_p
                                                        
                                                        	clmp p
                                                        	**type**\:  :py:class:`ClmpP <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP>`
                                                        
                                                        .. attribute:: act_infop
                                                        
                                                        	act infop
                                                        	**type**\:  :py:class:`ActInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop>`
                                                        
                                                        .. attribute:: policy_class_hd
                                                        
                                                        	policy class hd
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: seq
                                                        
                                                        	seq
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: flags
                                                        
                                                        	flags
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: ctype
                                                        
                                                        	ctype
                                                        	**type**\:  :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                        
                                                        .. attribute:: num_actions
                                                        
                                                        	num actions
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: version
                                                        
                                                        	version
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        .. attribute:: exe_strat
                                                        
                                                        	exe strat
                                                        	**type**\:  :py:class:`PclassExecStratEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PclassExecStratEn>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2018-01-17'

                                                        def __init__(self):
                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg, self).__init__()

                                                            self.yang_name = "policy-class-info-bg"
                                                            self.yang_parent_name = "class-infop"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("cl-encode", ("cl_encode", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode)), ("clmp-p", ("clmp_p", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP)), ("act-infop", ("act_infop", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop))])
                                                            self._leafs = OrderedDict([
                                                                ('policy_class_hd', (YLeaf(YType.uint32, 'policy-class-hd'), ['int'])),
                                                                ('seq', (YLeaf(YType.uint32, 'seq'), ['int'])),
                                                                ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                ('ctype', (YLeaf(YType.enumeration, 'ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapTypeEn', '')])),
                                                                ('num_actions', (YLeaf(YType.uint16, 'num-actions'), ['int'])),
                                                                ('version', (YLeaf(YType.uint8, 'version'), ['int'])),
                                                                ('exe_strat', (YLeaf(YType.enumeration, 'exe-strat'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PclassExecStratEn', '')])),
                                                            ])
                                                            self.policy_class_hd = None
                                                            self.seq = None
                                                            self.flags = None
                                                            self.ctype = None
                                                            self.num_actions = None
                                                            self.version = None
                                                            self.exe_strat = None

                                                            self.cl_encode = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode()
                                                            self.cl_encode.parent = self
                                                            self._children_name_map["cl_encode"] = "cl-encode"

                                                            self.clmp_p = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP()
                                                            self.clmp_p.parent = self
                                                            self._children_name_map["clmp_p"] = "clmp-p"

                                                            self.act_infop = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop()
                                                            self.act_infop.parent = self
                                                            self._children_name_map["act_infop"] = "act-infop"
                                                            self._segment_path = lambda: "policy-class-info-bg"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg, ['policy_class_hd', 'seq', 'flags', 'ctype', 'num_actions', 'version', 'exe_strat'], name, value)


                                                        class ClEncode(Entity):
                                                            """
                                                            cl encode
                                                            
                                                            .. attribute:: inline_cmap
                                                            
                                                            	inline cmap
                                                            	**type**\:  :py:class:`InlineCmap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap>`
                                                            
                                                            .. attribute:: enc
                                                            
                                                            	enc
                                                            	**type**\:  :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                            
                                                            .. attribute:: class_name
                                                            
                                                            	class name
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..65
                                                            
                                                            .. attribute:: hd
                                                            
                                                            	hd
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: idx
                                                            
                                                            	idx
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..255
                                                            
                                                            

                                                            """

                                                            _prefix = 'infra-policymgr-oper'
                                                            _revision = '2018-01-17'

                                                            def __init__(self):
                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode, self).__init__()

                                                                self.yang_name = "cl-encode"
                                                                self.yang_parent_name = "policy-class-info-bg"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("inline-cmap", ("inline_cmap", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap))])
                                                                self._leafs = OrderedDict([
                                                                    ('enc', (YLeaf(YType.enumeration, 'enc'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyObjEncEn', '')])),
                                                                    ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                                    ('hd', (YLeaf(YType.uint64, 'hd'), ['int'])),
                                                                    ('idx', (YLeaf(YType.uint8, 'idx'), ['int'])),
                                                                ])
                                                                self.enc = None
                                                                self.class_name = None
                                                                self.hd = None
                                                                self.idx = None

                                                                self.inline_cmap = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap()
                                                                self.inline_cmap.parent = self
                                                                self._children_name_map["inline_cmap"] = "inline-cmap"
                                                                self._segment_path = lambda: "cl-encode"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode, ['enc', 'class_name', 'hd', 'idx'], name, value)


                                                            class InlineCmap(Entity):
                                                                """
                                                                inline cmap
                                                                
                                                                .. attribute:: match_infop
                                                                
                                                                	Pointer to the first Match info
                                                                	**type**\:  :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop>`
                                                                
                                                                .. attribute:: mode
                                                                
                                                                	Inline Class\-Map Mode Match any/all
                                                                	**type**\:  :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                
                                                                .. attribute:: flags
                                                                
                                                                	Inline Class\-Map flags
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: match_count
                                                                
                                                                	Number of Match infos
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap, self).__init__()

                                                                    self.yang_name = "inline-cmap"
                                                                    self.yang_parent_name = "cl-encode"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("match-infop", ("match_infop", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop))])
                                                                    self._leafs = OrderedDict([
                                                                        ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapModeEn', '')])),
                                                                        ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                        ('match_count', (YLeaf(YType.uint32, 'match-count'), ['int'])),
                                                                    ])
                                                                    self.mode = None
                                                                    self.flags = None
                                                                    self.match_count = None

                                                                    self.match_infop = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop()
                                                                    self.match_infop.parent = self
                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                    self._segment_path = lambda: "inline-cmap"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap, ['mode', 'flags', 'match_count'], name, value)


                                                                class MatchInfop(Entity):
                                                                    """
                                                                    Pointer to the first Match info
                                                                    
                                                                    .. attribute:: class_match_info_st
                                                                    
                                                                    	class match info st
                                                                    	**type**\: list of  		 :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop, self).__init__()

                                                                        self.yang_name = "match-infop"
                                                                        self.yang_parent_name = "inline-cmap"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("class-match-info-st", ("class_match_info_st", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt))])
                                                                        self._leafs = OrderedDict()

                                                                        self.class_match_info_st = YList(self)
                                                                        self._segment_path = lambda: "match-infop"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop, [], name, value)


                                                                    class ClassMatchInfoSt(Entity):
                                                                        """
                                                                        class match info st
                                                                        
                                                                        .. attribute:: match_data
                                                                        
                                                                        	Match criteria
                                                                        	**type**\:  :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                        
                                                                        .. attribute:: flags
                                                                        
                                                                        	Flags
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                            self.yang_name = "class-match-info-st"
                                                                            self.yang_parent_name = "match-infop"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("match-data", ("match_data", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData))])
                                                                            self._leafs = OrderedDict([
                                                                                ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                            ])
                                                                            self.flags = None

                                                                            self.match_data = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                            self.match_data.parent = self
                                                                            self._children_name_map["match_data"] = "match-data"
                                                                            self._segment_path = lambda: "class-match-info-st"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                        class MatchData(Entity):
                                                                            """
                                                                            Match criteria
                                                                            
                                                                            .. attribute:: ipv4_dscp
                                                                            
                                                                            	IPv4 DSCP
                                                                            	**type**\:  :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                            
                                                                            .. attribute:: ipv6_dscp
                                                                            
                                                                            	IPv6 DSCP
                                                                            	**type**\:  :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                            
                                                                            .. attribute:: dscp
                                                                            
                                                                            	Match DSCP range array
                                                                            	**type**\:  :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                            
                                                                            .. attribute:: ipv4_prec
                                                                            
                                                                            	IPv4 Precedence
                                                                            	**type**\:  :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                            
                                                                            .. attribute:: ipv6_prec
                                                                            
                                                                            	IPv6 Precedence
                                                                            	**type**\:  :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                            
                                                                            .. attribute:: prec
                                                                            
                                                                            	Match Precedence array
                                                                            	**type**\:  :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                            
                                                                            .. attribute:: discard_class
                                                                            
                                                                            	Match Discard Class array
                                                                            	**type**\:  :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                            
                                                                            .. attribute:: qos_group
                                                                            
                                                                            	Match QoS group array
                                                                            	**type**\:  :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                            
                                                                            .. attribute:: traffic_class
                                                                            
                                                                            	Match Traffic class array
                                                                            	**type**\:  :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                            
                                                                            .. attribute:: proto
                                                                            
                                                                            	Match Protocol array
                                                                            	**type**\:  :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                            
                                                                            .. attribute:: icmp_v4
                                                                            
                                                                            	Match ICMPV4 Protocol
                                                                            	**type**\:  :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                            
                                                                            .. attribute:: icmp_v6
                                                                            
                                                                            	Match ICMPV6 Protocol array
                                                                            	**type**\:  :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                            
                                                                            .. attribute:: ipv4_packet_len
                                                                            
                                                                            	IPv4 packet length array
                                                                            	**type**\:  :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                            
                                                                            .. attribute:: ipv6_packet_len
                                                                            
                                                                            	IPv6 packet length array
                                                                            	**type**\:  :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                            
                                                                            .. attribute:: packet_len
                                                                            
                                                                            	Match packet length array
                                                                            	**type**\:  :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                            
                                                                            .. attribute:: flow_tag
                                                                            
                                                                            	Match flow\-tag array
                                                                            	**type**\:  :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                            
                                                                            .. attribute:: tcp_flag
                                                                            
                                                                            	Match tcp flag value
                                                                            	**type**\:  :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                            
                                                                            .. attribute:: icmpv4_type
                                                                            
                                                                            	Match ipv4 icmp type
                                                                            	**type**\:  :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                            
                                                                            .. attribute:: icmpv4_code
                                                                            
                                                                            	Match ipv4 icmp code
                                                                            	**type**\:  :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                            
                                                                            .. attribute:: icmpv6_type
                                                                            
                                                                            	Match ipv6 icmp type
                                                                            	**type**\:  :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                            
                                                                            .. attribute:: icmpv6_code
                                                                            
                                                                            	Match ipv6 icmp code
                                                                            	**type**\:  :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                            
                                                                            .. attribute:: mpls_exp
                                                                            
                                                                            	Match MPLS experimental topmost array
                                                                            	**type**\:  :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                            
                                                                            .. attribute:: mpls_exp_imp
                                                                            
                                                                            	Match MPLS experimental imposition array
                                                                            	**type**\:  :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                            
                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                            
                                                                            	MPLS Disposition IPv4 Access\-list
                                                                            	**type**\:  :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                            
                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                            
                                                                            	MPLS Disposition IPv6 Access\-list
                                                                            	**type**\:  :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                            
                                                                            .. attribute:: mpls_top_label
                                                                            
                                                                            	MPLS Topmost LABEL
                                                                            	**type**\:  :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                            
                                                                            .. attribute:: cos
                                                                            
                                                                            	Match CoS array
                                                                            	**type**\:  :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                            
                                                                            .. attribute:: cos_inr
                                                                            
                                                                            	Match inner header CoS
                                                                            	**type**\:  :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                            
                                                                            .. attribute:: dei
                                                                            
                                                                            	Match DEI Bit
                                                                            	**type**\:  :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                            
                                                                            .. attribute:: dei_inr
                                                                            
                                                                            	Match inner DEI Bit
                                                                            	**type**\:  :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                            
                                                                            .. attribute:: vlan
                                                                            
                                                                            	Match VLAN array
                                                                            	**type**\:  :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                            
                                                                            .. attribute:: vlan_inr
                                                                            
                                                                            	Match inner header VLAN range array
                                                                            	**type**\:  :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                            
                                                                            .. attribute:: fr_dlci
                                                                            
                                                                            	Match FR DLCI range array
                                                                            	**type**\:  :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                            
                                                                            .. attribute:: src_mac
                                                                            
                                                                            	Match Source MAC address
                                                                            	**type**\:  :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                            
                                                                            .. attribute:: dst_mac
                                                                            
                                                                            	Match Destination MAC address
                                                                            	**type**\:  :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                            
                                                                            .. attribute:: atm_clp
                                                                            
                                                                            	Match ATM CLP level
                                                                            	**type**\:  :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                            
                                                                            .. attribute:: fr_de
                                                                            
                                                                            	Match FR DE value
                                                                            	**type**\:  :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                            
                                                                            .. attribute:: ipv4_acl
                                                                            
                                                                            	IPv4 Access\-list
                                                                            	**type**\:  :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                            
                                                                            .. attribute:: ipv6_acl
                                                                            
                                                                            	IPv6 Access\-list
                                                                            	**type**\:  :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                            
                                                                            .. attribute:: ether_service_acl
                                                                            
                                                                            	Ethernet\-Services Access\-list
                                                                            	**type**\:  :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                            
                                                                            .. attribute:: avail_id
                                                                            
                                                                            	Available Identifiers
                                                                            	**type**\:  :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                            
                                                                            .. attribute:: media_type
                                                                            
                                                                            	Media Type
                                                                            	**type**\:  :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                            
                                                                            .. attribute:: subs_protocol
                                                                            
                                                                            	Protocol
                                                                            	**type**\:  :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                            
                                                                            .. attribute:: dnis
                                                                            
                                                                            	DNIS
                                                                            	**type**\:  :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                            
                                                                            .. attribute:: dnis_regex
                                                                            
                                                                            	DNIS Regular Expression
                                                                            	**type**\:  :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                            
                                                                            .. attribute:: domain
                                                                            
                                                                            	Domain Name
                                                                            	**type**\:  :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                            
                                                                            .. attribute:: domain_regex
                                                                            
                                                                            	Domain Regular Expression
                                                                            	**type**\:  :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                            
                                                                            .. attribute:: nas_port
                                                                            
                                                                            	NAS Port
                                                                            	**type**\:  :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                            
                                                                            .. attribute:: service_name
                                                                            
                                                                            	Service Name
                                                                            	**type**\:  :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                            
                                                                            .. attribute:: service_name_regex
                                                                            
                                                                            	Service Name Regular Exp
                                                                            	**type**\:  :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                            
                                                                            .. attribute:: src_addr_ipv4
                                                                            
                                                                            	Source Address IPV4
                                                                            	**type**\:  :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                            
                                                                            .. attribute:: dst_addr_ipv4
                                                                            
                                                                            	Destination Address IPV4
                                                                            	**type**\:  :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                            
                                                                            .. attribute:: src_addr_ipv6
                                                                            
                                                                            	Source Address IPV6
                                                                            	**type**\:  :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                            
                                                                            .. attribute:: dst_addr_ipv6
                                                                            
                                                                            	Destination Address IPV6
                                                                            	**type**\:  :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                            
                                                                            .. attribute:: src_addr_mac
                                                                            
                                                                            	Source Address MAC
                                                                            	**type**\:  :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                            
                                                                            .. attribute:: timer
                                                                            
                                                                            	Timer
                                                                            	**type**\:  :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                            
                                                                            .. attribute:: timer_regexp
                                                                            
                                                                            	Timer Regular Expression
                                                                            	**type**\:  :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                            
                                                                            .. attribute:: tunnel_name
                                                                            
                                                                            	Tunnel Name
                                                                            	**type**\:  :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                            
                                                                            .. attribute:: tunnel_name_regex
                                                                            
                                                                            	Tunnel Name Regular Expression
                                                                            	**type**\:  :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                            
                                                                            .. attribute:: user_name
                                                                            
                                                                            	User Name
                                                                            	**type**\:  :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                            
                                                                            .. attribute:: user_name_regex
                                                                            
                                                                            	User Name Regular Expression
                                                                            	**type**\:  :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                            
                                                                            .. attribute:: auth_username
                                                                            
                                                                            	Authenticated User Name
                                                                            	**type**\:  :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                            
                                                                            .. attribute:: auth_username_regex
                                                                            
                                                                            	Authenticated User Name RegEx
                                                                            	**type**\:  :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                            
                                                                            .. attribute:: unauth_username
                                                                            
                                                                            	Unauthenticated User Name
                                                                            	**type**\:  :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                            
                                                                            .. attribute:: unauth_username_regex
                                                                            
                                                                            	Unauthenticated User Name RegEx
                                                                            	**type**\:  :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                            
                                                                            .. attribute:: auth_domain
                                                                            
                                                                            	Authenticated domain name
                                                                            	**type**\:  :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                            
                                                                            .. attribute:: auth_domain_regex
                                                                            
                                                                            	Authenticated Domain Name RegEx
                                                                            	**type**\:  :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                            
                                                                            .. attribute:: unauth_domain
                                                                            
                                                                            	Unauthenticated Domain Name
                                                                            	**type**\:  :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                            
                                                                            .. attribute:: unauth_domain_regex
                                                                            
                                                                            	Unauthenticated Domain Name RegEx
                                                                            	**type**\:  :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                            
                                                                            .. attribute:: vendor_id
                                                                            
                                                                            	Vendor ID
                                                                            	**type**\:  :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                            
                                                                            .. attribute:: vendor_id_regex
                                                                            
                                                                            	Vendor ID RegEx
                                                                            	**type**\:  :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                            
                                                                            .. attribute:: access_interface
                                                                            
                                                                            	Access interface
                                                                            	**type**\:  :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                            
                                                                            .. attribute:: input_interface
                                                                            
                                                                            	Input interface
                                                                            	**type**\:  :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                            
                                                                            .. attribute:: input_intfhdl
                                                                            
                                                                            	Input interface handle
                                                                            	**type**\:  :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                            
                                                                            .. attribute:: ethertype
                                                                            
                                                                            	Ethernet type
                                                                            	**type**\:  :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                            
                                                                            .. attribute:: flow_key_data
                                                                            
                                                                            	Flow key structure
                                                                            	**type**\:  :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                            
                                                                            .. attribute:: dhcp_client_id
                                                                            
                                                                            	Dhcp Client ID
                                                                            	**type**\:  :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                            
                                                                            .. attribute:: dhcp_client_id_regex
                                                                            
                                                                            	Dhcp Client ID RegEx
                                                                            	**type**\:  :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                            
                                                                            .. attribute:: circuit_id
                                                                            
                                                                            	Circuit ID
                                                                            	**type**\:  :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                            
                                                                            .. attribute:: circuit_id_regex
                                                                            
                                                                            	Circuit ID RegEx
                                                                            	**type**\:  :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                            
                                                                            .. attribute:: remote_id
                                                                            
                                                                            	Remote ID
                                                                            	**type**\:  :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                            
                                                                            .. attribute:: remote_id_regex
                                                                            
                                                                            	Remote ID RegEx
                                                                            	**type**\:  :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                            
                                                                            .. attribute:: src_port
                                                                            
                                                                            	Source port
                                                                            	**type**\:  :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                            
                                                                            .. attribute:: dst_port
                                                                            
                                                                            	Destination port
                                                                            	**type**\:  :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:  :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                            
                                                                            .. attribute:: mpls_top_eos
                                                                            
                                                                            	MPLS Topmost EOS
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: fragment_type
                                                                            
                                                                            	Fragment type
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: authen_status
                                                                            
                                                                            	Authentication Status
                                                                            	**type**\:  :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                            
                                                                            .. attribute:: mlp_negotiated
                                                                            
                                                                            	MLP Negotiated
                                                                            	**type**\:  :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                self.yang_name = "match-data"
                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("ipv4-dscp", ("ipv4_dscp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp)), ("ipv6-dscp", ("ipv6_dscp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp)), ("dscp", ("dscp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp)), ("ipv4-prec", ("ipv4_prec", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec)), ("ipv6-prec", ("ipv6_prec", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec)), ("prec", ("prec", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec)), ("discard-class", ("discard_class", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass)), ("qos-group", ("qos_group", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup)), ("traffic-class", ("traffic_class", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass)), ("proto", ("proto", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto)), ("icmp-v4", ("icmp_v4", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4)), ("icmp-v6", ("icmp_v6", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6)), ("ipv4-packet-len", ("ipv4_packet_len", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen)), ("ipv6-packet-len", ("ipv6_packet_len", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen)), ("packet-len", ("packet_len", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen)), ("flow-tag", ("flow_tag", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag)), ("tcp-flag", ("tcp_flag", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag)), ("icmpv4-type", ("icmpv4_type", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type)), ("icmpv4-code", ("icmpv4_code", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code)), ("icmpv6-type", ("icmpv6_type", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type)), ("icmpv6-code", ("icmpv6_code", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code)), ("mpls-exp", ("mpls_exp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp)), ("mpls-exp-imp", ("mpls_exp_imp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp)), ("mpls-disp-ipv4-acl", ("mpls_disp_ipv4_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl)), ("mpls-disp-ipv6-acl", ("mpls_disp_ipv6_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl)), ("mpls-top-label", ("mpls_top_label", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel)), ("cos", ("cos", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos)), ("cos-inr", ("cos_inr", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr)), ("dei", ("dei", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei)), ("dei-inr", ("dei_inr", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr)), ("vlan", ("vlan", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan)), ("vlan-inr", ("vlan_inr", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)), ("fr-dlci", ("fr_dlci", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci)), ("src-mac", ("src_mac", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac)), ("dst-mac", ("dst_mac", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac)), ("atm-clp", ("atm_clp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp)), ("fr-de", ("fr_de", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe)), ("ipv4-acl", ("ipv4_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl)), ("ipv6-acl", ("ipv6_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl)), ("ether-service-acl", ("ether_service_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl)), ("avail-id", ("avail_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId)), ("media-type", ("media_type", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType)), ("subs-protocol", ("subs_protocol", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol)), ("dnis", ("dnis", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis)), ("dnis-regex", ("dnis_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex)), ("domain", ("domain", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain)), ("domain-regex", ("domain_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex)), ("nas-port", ("nas_port", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort)), ("service-name", ("service_name", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName)), ("service-name-regex", ("service_name_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex)), ("src-addr-ipv4", ("src_addr_ipv4", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4)), ("dst-addr-ipv4", ("dst_addr_ipv4", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4)), ("src-addr-ipv6", ("src_addr_ipv6", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6)), ("dst-addr-ipv6", ("dst_addr_ipv6", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6)), ("src-addr-mac", ("src_addr_mac", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac)), ("timer", ("timer", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer)), ("timer-regexp", ("timer_regexp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp)), ("tunnel-name", ("tunnel_name", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName)), ("tunnel-name-regex", ("tunnel_name_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex)), ("user-name", ("user_name", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName)), ("user-name-regex", ("user_name_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex)), ("auth-username", ("auth_username", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername)), ("auth-username-regex", ("auth_username_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex)), ("unauth-username", ("unauth_username", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername)), ("unauth-username-regex", ("unauth_username_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex)), ("auth-domain", ("auth_domain", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain)), ("auth-domain-regex", ("auth_domain_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex)), ("unauth-domain", ("unauth_domain", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain)), ("unauth-domain-regex", ("unauth_domain_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex)), ("vendor-id", ("vendor_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId)), ("vendor-id-regex", ("vendor_id_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex)), ("access-interface", ("access_interface", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface)), ("input-interface", ("input_interface", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface)), ("input-intfhdl", ("input_intfhdl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl)), ("ethertype", ("ethertype", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype)), ("flow-key-data", ("flow_key_data", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData)), ("dhcp-client-id", ("dhcp_client_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId)), ("dhcp-client-id-regex", ("dhcp_client_id_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex)), ("circuit-id", ("circuit_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId)), ("circuit-id-regex", ("circuit_id_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex)), ("remote-id", ("remote_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId)), ("remote-id-regex", ("remote_id_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex)), ("src-port", ("src_port", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort)), ("dst-port", ("dst_port", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchTypeEn', '')])),
                                                                                    ('mpls_top_eos', (YLeaf(YType.uint8, 'mpls-top-eos'), ['int'])),
                                                                                    ('fragment_type', (YLeaf(YType.uint8, 'fragment-type'), ['int'])),
                                                                                    ('authen_status', (YLeaf(YType.enumeration, 'authen-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchAuthenStatusEn', '')])),
                                                                                    ('mlp_negotiated', (YLeaf(YType.enumeration, 'mlp-negotiated'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchMlpNegotiatedEn', '')])),
                                                                                ])
                                                                                self.type = None
                                                                                self.mpls_top_eos = None
                                                                                self.fragment_type = None
                                                                                self.authen_status = None
                                                                                self.mlp_negotiated = None

                                                                                self.ipv4_dscp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                self.ipv4_dscp.parent = self
                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"

                                                                                self.ipv6_dscp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                self.ipv6_dscp.parent = self
                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"

                                                                                self.dscp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                self.dscp.parent = self
                                                                                self._children_name_map["dscp"] = "dscp"

                                                                                self.ipv4_prec = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                self.ipv4_prec.parent = self
                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"

                                                                                self.ipv6_prec = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                self.ipv6_prec.parent = self
                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"

                                                                                self.prec = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                self.prec.parent = self
                                                                                self._children_name_map["prec"] = "prec"

                                                                                self.discard_class = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                self.discard_class.parent = self
                                                                                self._children_name_map["discard_class"] = "discard-class"

                                                                                self.qos_group = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                self.qos_group.parent = self
                                                                                self._children_name_map["qos_group"] = "qos-group"

                                                                                self.traffic_class = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                self.traffic_class.parent = self
                                                                                self._children_name_map["traffic_class"] = "traffic-class"

                                                                                self.proto = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                self.proto.parent = self
                                                                                self._children_name_map["proto"] = "proto"

                                                                                self.icmp_v4 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                self.icmp_v4.parent = self
                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"

                                                                                self.icmp_v6 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                self.icmp_v6.parent = self
                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"

                                                                                self.ipv4_packet_len = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                self.ipv4_packet_len.parent = self
                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"

                                                                                self.ipv6_packet_len = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                self.ipv6_packet_len.parent = self
                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"

                                                                                self.packet_len = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                self.packet_len.parent = self
                                                                                self._children_name_map["packet_len"] = "packet-len"

                                                                                self.flow_tag = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                self.flow_tag.parent = self
                                                                                self._children_name_map["flow_tag"] = "flow-tag"

                                                                                self.tcp_flag = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                self.tcp_flag.parent = self
                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"

                                                                                self.icmpv4_type = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                self.icmpv4_type.parent = self
                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"

                                                                                self.icmpv4_code = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                self.icmpv4_code.parent = self
                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"

                                                                                self.icmpv6_type = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                self.icmpv6_type.parent = self
                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"

                                                                                self.icmpv6_code = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                self.icmpv6_code.parent = self
                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"

                                                                                self.mpls_exp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                self.mpls_exp.parent = self
                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"

                                                                                self.mpls_exp_imp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                self.mpls_exp_imp.parent = self
                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"

                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"

                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"

                                                                                self.mpls_top_label = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                self.mpls_top_label.parent = self
                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"

                                                                                self.cos = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                self.cos.parent = self
                                                                                self._children_name_map["cos"] = "cos"

                                                                                self.cos_inr = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                self.cos_inr.parent = self
                                                                                self._children_name_map["cos_inr"] = "cos-inr"

                                                                                self.dei = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                self.dei.parent = self
                                                                                self._children_name_map["dei"] = "dei"

                                                                                self.dei_inr = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                self.dei_inr.parent = self
                                                                                self._children_name_map["dei_inr"] = "dei-inr"

                                                                                self.vlan = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                self.vlan.parent = self
                                                                                self._children_name_map["vlan"] = "vlan"

                                                                                self.vlan_inr = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                self.vlan_inr.parent = self
                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"

                                                                                self.fr_dlci = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                self.fr_dlci.parent = self
                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"

                                                                                self.src_mac = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                self.src_mac.parent = self
                                                                                self._children_name_map["src_mac"] = "src-mac"

                                                                                self.dst_mac = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                self.dst_mac.parent = self
                                                                                self._children_name_map["dst_mac"] = "dst-mac"

                                                                                self.atm_clp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                self.atm_clp.parent = self
                                                                                self._children_name_map["atm_clp"] = "atm-clp"

                                                                                self.fr_de = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                self.fr_de.parent = self
                                                                                self._children_name_map["fr_de"] = "fr-de"

                                                                                self.ipv4_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                self.ipv4_acl.parent = self
                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"

                                                                                self.ipv6_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                self.ipv6_acl.parent = self
                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"

                                                                                self.ether_service_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                self.ether_service_acl.parent = self
                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"

                                                                                self.avail_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                self.avail_id.parent = self
                                                                                self._children_name_map["avail_id"] = "avail-id"

                                                                                self.media_type = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                self.media_type.parent = self
                                                                                self._children_name_map["media_type"] = "media-type"

                                                                                self.subs_protocol = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                self.subs_protocol.parent = self
                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"

                                                                                self.dnis = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                self.dnis.parent = self
                                                                                self._children_name_map["dnis"] = "dnis"

                                                                                self.dnis_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                self.dnis_regex.parent = self
                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"

                                                                                self.domain = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                self.domain.parent = self
                                                                                self._children_name_map["domain"] = "domain"

                                                                                self.domain_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                self.domain_regex.parent = self
                                                                                self._children_name_map["domain_regex"] = "domain-regex"

                                                                                self.nas_port = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                self.nas_port.parent = self
                                                                                self._children_name_map["nas_port"] = "nas-port"

                                                                                self.service_name = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                self.service_name.parent = self
                                                                                self._children_name_map["service_name"] = "service-name"

                                                                                self.service_name_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                self.service_name_regex.parent = self
                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"

                                                                                self.src_addr_ipv4 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                self.src_addr_ipv4.parent = self
                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"

                                                                                self.dst_addr_ipv4 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                self.dst_addr_ipv4.parent = self
                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"

                                                                                self.src_addr_ipv6 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                self.src_addr_ipv6.parent = self
                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"

                                                                                self.dst_addr_ipv6 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                self.dst_addr_ipv6.parent = self
                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"

                                                                                self.src_addr_mac = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                self.src_addr_mac.parent = self
                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"

                                                                                self.timer = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                self.timer.parent = self
                                                                                self._children_name_map["timer"] = "timer"

                                                                                self.timer_regexp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                self.timer_regexp.parent = self
                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"

                                                                                self.tunnel_name = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                self.tunnel_name.parent = self
                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"

                                                                                self.tunnel_name_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                self.tunnel_name_regex.parent = self
                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"

                                                                                self.user_name = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                self.user_name.parent = self
                                                                                self._children_name_map["user_name"] = "user-name"

                                                                                self.user_name_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                self.user_name_regex.parent = self
                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"

                                                                                self.auth_username = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                self.auth_username.parent = self
                                                                                self._children_name_map["auth_username"] = "auth-username"

                                                                                self.auth_username_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                self.auth_username_regex.parent = self
                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"

                                                                                self.unauth_username = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                self.unauth_username.parent = self
                                                                                self._children_name_map["unauth_username"] = "unauth-username"

                                                                                self.unauth_username_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                self.unauth_username_regex.parent = self
                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"

                                                                                self.auth_domain = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                self.auth_domain.parent = self
                                                                                self._children_name_map["auth_domain"] = "auth-domain"

                                                                                self.auth_domain_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                self.auth_domain_regex.parent = self
                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"

                                                                                self.unauth_domain = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                self.unauth_domain.parent = self
                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"

                                                                                self.unauth_domain_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                self.unauth_domain_regex.parent = self
                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"

                                                                                self.vendor_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                self.vendor_id.parent = self
                                                                                self._children_name_map["vendor_id"] = "vendor-id"

                                                                                self.vendor_id_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                self.vendor_id_regex.parent = self
                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"

                                                                                self.access_interface = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                self.access_interface.parent = self
                                                                                self._children_name_map["access_interface"] = "access-interface"

                                                                                self.input_interface = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                self.input_interface.parent = self
                                                                                self._children_name_map["input_interface"] = "input-interface"

                                                                                self.input_intfhdl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                self.input_intfhdl.parent = self
                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"

                                                                                self.ethertype = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                self.ethertype.parent = self
                                                                                self._children_name_map["ethertype"] = "ethertype"

                                                                                self.flow_key_data = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                self.flow_key_data.parent = self
                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"

                                                                                self.dhcp_client_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                self.dhcp_client_id.parent = self
                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"

                                                                                self.dhcp_client_id_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                self.dhcp_client_id_regex.parent = self
                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"

                                                                                self.circuit_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                self.circuit_id.parent = self
                                                                                self._children_name_map["circuit_id"] = "circuit-id"

                                                                                self.circuit_id_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                self.circuit_id_regex.parent = self
                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"

                                                                                self.remote_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                self.remote_id.parent = self
                                                                                self._children_name_map["remote_id"] = "remote-id"

                                                                                self.remote_id_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                self.remote_id_regex.parent = self
                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"

                                                                                self.src_port = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                self.src_port.parent = self
                                                                                self._children_name_map["src_port"] = "src-port"

                                                                                self.dst_port = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                self.dst_port.parent = self
                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                self._segment_path = lambda: "match-data"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, ['type', 'mpls_top_eos', 'fragment_type', 'authen_status', 'mlp_negotiated'], name, value)


                                                                            class Ipv4Dscp(Entity):
                                                                                """
                                                                                IPv4 DSCP
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                    self.yang_name = "ipv4-dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv4-dscp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Ipv6Dscp(Entity):
                                                                                """
                                                                                IPv6 DSCP
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                    self.yang_name = "ipv6-dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv6-dscp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Dscp(Entity):
                                                                                """
                                                                                Match DSCP range array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                    self.yang_name = "dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "dscp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Ipv4Prec(Entity):
                                                                                """
                                                                                IPv4 Precedence
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                    self.yang_name = "ipv4-prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "ipv4-prec"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                            class Ipv6Prec(Entity):
                                                                                """
                                                                                IPv6 Precedence
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                    self.yang_name = "ipv6-prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "ipv6-prec"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                            class Prec(Entity):
                                                                                """
                                                                                Match Precedence array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                    self.yang_name = "prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "prec"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                            class DiscardClass(Entity):
                                                                                """
                                                                                Match Discard Class array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                    self.yang_name = "discard-class"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "discard-class"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                            class QosGroup(Entity):
                                                                                """
                                                                                Match QoS group array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                    self.yang_name = "qos-group"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "qos-group"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "qos-group"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class TrafficClass(Entity):
                                                                                """
                                                                                Match Traffic class array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                    self.yang_name = "traffic-class"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "traffic-class"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "traffic-class"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Proto(Entity):
                                                                                """
                                                                                Match Protocol array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                    self.yang_name = "proto"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "proto"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "proto"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class IcmpV4(Entity):
                                                                                """
                                                                                Match ICMPV4 Protocol
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Protocol type
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: code
                                                                                
                                                                                	Protocol code
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                    self.yang_name = "icmp-v4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                    ])
                                                                                    self.type = None
                                                                                    self.code = None
                                                                                    self._segment_path = lambda: "icmp-v4"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['type', 'code'], name, value)


                                                                            class IcmpV6(Entity):
                                                                                """
                                                                                Match ICMPV6 Protocol array
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Protocol type
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: code
                                                                                
                                                                                	Protocol code
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                    self.yang_name = "icmp-v6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                    ])
                                                                                    self.type = None
                                                                                    self.code = None
                                                                                    self._segment_path = lambda: "icmp-v6"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['type', 'code'], name, value)


                                                                            class Ipv4PacketLen(Entity):
                                                                                """
                                                                                IPv4 packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv4-packet-len"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class Ipv6PacketLen(Entity):
                                                                                """
                                                                                IPv6 packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv6-packet-len"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class PacketLen(Entity):
                                                                                """
                                                                                Match packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                    self.yang_name = "packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "packet-len"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class FlowTag(Entity):
                                                                                """
                                                                                Match flow\-tag array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                    self.yang_name = "flow-tag"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "flow-tag"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "flow-tag"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class TcpFlag(Entity):
                                                                                """
                                                                                Match tcp flag value
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	Value of TCP flag
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: match_any
                                                                                
                                                                                	Match any TCP flag bit
                                                                                	**type**\: bool
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                    self.yang_name = "tcp-flag"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                        ('match_any', (YLeaf(YType.boolean, 'match-any'), ['bool'])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.match_any = None
                                                                                    self._segment_path = lambda: "tcp-flag"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['value', 'match_any'], name, value)


                                                                            class Icmpv4Type(Entity):
                                                                                """
                                                                                Match ipv4 icmp type
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                    self.yang_name = "icmpv4-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv4-type"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Icmpv4Code(Entity):
                                                                                """
                                                                                Match ipv4 icmp code
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                    self.yang_name = "icmpv4-code"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv4-code"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Icmpv6Type(Entity):
                                                                                """
                                                                                Match ipv6 icmp type
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                    self.yang_name = "icmpv6-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv6-type"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Icmpv6Code(Entity):
                                                                                """
                                                                                Match ipv6 icmp code
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                    self.yang_name = "icmpv6-code"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv6-code"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class MplsExp(Entity):
                                                                                """
                                                                                Match MPLS experimental topmost array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                    self.yang_name = "mpls-exp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "mpls-exp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                            class MplsExpImp(Entity):
                                                                                """
                                                                                Match MPLS experimental imposition array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "mpls-exp-imp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                            class MplsDispIpv4Acl(Entity):
                                                                                """
                                                                                MPLS Disposition IPv4 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                            class MplsDispIpv6Acl(Entity):
                                                                                """
                                                                                MPLS Disposition IPv6 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                            class MplsTopLabel(Entity):
                                                                                """
                                                                                MPLS Topmost LABEL
                                                                                
                                                                                .. attribute:: uint32_rng_array
                                                                                
                                                                                	uint32 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                    self.yang_name = "mpls-top-label"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint32_rng_array", ("uint32_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint32_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "mpls-top-label"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                class Uint32RngArray(Entity):
                                                                                    """
                                                                                    uint32 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                        self.yang_name = "uint32_rng_array"
                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint32, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint32, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint32_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['min', 'max'], name, value)


                                                                            class Cos(Entity):
                                                                                """
                                                                                Match CoS array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                    self.yang_name = "cos"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "cos"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                            class CosInr(Entity):
                                                                                """
                                                                                Match inner header CoS
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                    self.yang_name = "cos-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "cos-inr"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                            class Dei(Entity):
                                                                                """
                                                                                Match DEI Bit
                                                                                
                                                                                .. attribute:: bit_value
                                                                                
                                                                                	Value of the DEI bit
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                    self.yang_name = "dei"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                    ])
                                                                                    self.bit_value = None
                                                                                    self._segment_path = lambda: "dei"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                            class DeiInr(Entity):
                                                                                """
                                                                                Match inner DEI Bit
                                                                                
                                                                                .. attribute:: bit_value
                                                                                
                                                                                	Value of the DEI bit
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                    self.yang_name = "dei-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                    ])
                                                                                    self.bit_value = None
                                                                                    self._segment_path = lambda: "dei-inr"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                            class Vlan(Entity):
                                                                                """
                                                                                Match VLAN array
                                                                                
                                                                                .. attribute:: vlan_id_array
                                                                                
                                                                                	vlan id array
                                                                                	**type**\: list of  		 :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                    self.yang_name = "vlan"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("vlan-id-array", ("vlan_id_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.vlan_id_array = YList(self)
                                                                                    self._segment_path = lambda: "vlan"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                class VlanIdArray(Entity):
                                                                                    """
                                                                                    vlan id array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	VLAN mask
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                        self.yang_name = "vlan-id-array"
                                                                                        self.yang_parent_name = "vlan"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                            ('mask', (YLeaf(YType.uint16, 'mask'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self.mask = None
                                                                                        self._segment_path = lambda: "vlan-id-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['min', 'max', 'mask'], name, value)


                                                                            class VlanInr(Entity):
                                                                                """
                                                                                Match inner header VLAN range array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                    self.yang_name = "vlan-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "vlan-inr"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class FrDlci(Entity):
                                                                                """
                                                                                Match FR DLCI range array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                    self.yang_name = "fr-dlci"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "fr-dlci"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class SrcMac(Entity):
                                                                                """
                                                                                Match Source MAC address
                                                                                
                                                                                .. attribute:: mac_addr
                                                                                
                                                                                	MAC address
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	MAC mask
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                    self.yang_name = "src-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                    ])
                                                                                    self.mac_addr = []
                                                                                    self.mask = []
                                                                                    self._segment_path = lambda: "src-mac"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                            class DstMac(Entity):
                                                                                """
                                                                                Match Destination MAC address
                                                                                
                                                                                .. attribute:: mac_addr
                                                                                
                                                                                	MAC address
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	MAC mask
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                    self.yang_name = "dst-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                    ])
                                                                                    self.mac_addr = []
                                                                                    self.mask = []
                                                                                    self._segment_path = lambda: "dst-mac"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                            class AtmClp(Entity):
                                                                                """
                                                                                Match ATM CLP level
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                    self.yang_name = "atm-clp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "atm-clp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                            class FrDe(Entity):
                                                                                """
                                                                                Match FR DE value
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                    self.yang_name = "fr-de"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "fr-de"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                            class Ipv4Acl(Entity):
                                                                                """
                                                                                IPv4 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                    self.yang_name = "ipv4-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "ipv4-acl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                            class Ipv6Acl(Entity):
                                                                                """
                                                                                IPv6 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                    self.yang_name = "ipv6-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "ipv6-acl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                            class EtherServiceAcl(Entity):
                                                                                """
                                                                                Ethernet\-Services Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                    self.yang_name = "ether-service-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "ether-service-acl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                            class AvailId(Entity):
                                                                                """
                                                                                Available Identifiers
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                    self.yang_name = "avail-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "avail-id"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                            class MediaType(Entity):
                                                                                """
                                                                                Media Type
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                    self.yang_name = "media-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "media-type"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                            class SubsProtocol(Entity):
                                                                                """
                                                                                Protocol
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                    self.yang_name = "subs-protocol"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "subs-protocol"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                            class Dnis(Entity):
                                                                                """
                                                                                DNIS
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                    self.yang_name = "dnis"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "dnis"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                            class DnisRegex(Entity):
                                                                                """
                                                                                DNIS Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                    self.yang_name = "dnis-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "dnis-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                            class Domain(Entity):
                                                                                """
                                                                                Domain Name
                                                                                
                                                                                .. attribute:: domain_array
                                                                                
                                                                                	domain array
                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                    self.yang_name = "domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.domain_array = YList(self)
                                                                                    self._segment_path = lambda: "domain"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                class DomainArray(Entity):
                                                                                    """
                                                                                    domain array
                                                                                    
                                                                                    .. attribute:: domain_name
                                                                                    
                                                                                    	domain name
                                                                                    	**type**\: str
                                                                                    
                                                                                    .. attribute:: format_name
                                                                                    
                                                                                    	format name
                                                                                    	**type**\: str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                        self.yang_name = "domain-array"
                                                                                        self.yang_parent_name = "domain"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                        ])
                                                                                        self.domain_name = None
                                                                                        self.format_name = None
                                                                                        self._segment_path = lambda: "domain-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                            class DomainRegex(Entity):
                                                                                """
                                                                                Domain Regular Expression
                                                                                
                                                                                .. attribute:: domain_array
                                                                                
                                                                                	domain array
                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                    self.yang_name = "domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.domain_array = YList(self)
                                                                                    self._segment_path = lambda: "domain-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                class DomainArray(Entity):
                                                                                    """
                                                                                    domain array
                                                                                    
                                                                                    .. attribute:: domain_name
                                                                                    
                                                                                    	domain name
                                                                                    	**type**\: str
                                                                                    
                                                                                    .. attribute:: format_name
                                                                                    
                                                                                    	format name
                                                                                    	**type**\: str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                        self.yang_name = "domain-array"
                                                                                        self.yang_parent_name = "domain-regex"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                        ])
                                                                                        self.domain_name = None
                                                                                        self.format_name = None
                                                                                        self._segment_path = lambda: "domain-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                            class NasPort(Entity):
                                                                                """
                                                                                NAS Port
                                                                                
                                                                                .. attribute:: nas_port_array
                                                                                
                                                                                	nas port array
                                                                                	**type**\: list of  		 :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                    self.yang_name = "nas-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("nas-port-array", ("nas_port_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.nas_port_array = YList(self)
                                                                                    self._segment_path = lambda: "nas-port"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                class NasPortArray(Entity):
                                                                                    """
                                                                                    nas port array
                                                                                    
                                                                                    .. attribute:: sub_id
                                                                                    
                                                                                    	sub id
                                                                                    	**type**\:  :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                    
                                                                                    .. attribute:: operator
                                                                                    
                                                                                    	operator
                                                                                    	**type**\:  :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                        self.yang_name = "nas-port-array"
                                                                                        self.yang_parent_name = "nas-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('sub_id', (YLeaf(YType.enumeration, 'sub-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchNasPortSubIdEn', '')])),
                                                                                            ('operator', (YLeaf(YType.enumeration, 'operator'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchLogicalOperatorEn', '')])),
                                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ])
                                                                                        self.sub_id = None
                                                                                        self.operator = None
                                                                                        self.value = None
                                                                                        self._segment_path = lambda: "nas-port-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['sub_id', 'operator', 'value'], name, value)


                                                                            class ServiceName(Entity):
                                                                                """
                                                                                Service Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                    self.yang_name = "service-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "service-name"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                            class ServiceNameRegex(Entity):
                                                                                """
                                                                                Service Name Regular Exp
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                    self.yang_name = "service-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "service-name-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                            class SrcAddrIpv4(Entity):
                                                                                """
                                                                                Source Address IPV4
                                                                                
                                                                                .. attribute:: ipv4_addr_array
                                                                                
                                                                                	ipv4 addr array
                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.ipv4_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-ipv4"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                class Ipv4AddrArray(Entity):
                                                                                    """
                                                                                    ipv4 addr array
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	prefix
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	mask
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                        ])
                                                                                        self.prefix = None
                                                                                        self.mask = None
                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                            class DstAddrIpv4(Entity):
                                                                                """
                                                                                Destination Address IPV4
                                                                                
                                                                                .. attribute:: ipv4_addr_array
                                                                                
                                                                                	ipv4 addr array
                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.ipv4_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-addr-ipv4"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                class Ipv4AddrArray(Entity):
                                                                                    """
                                                                                    ipv4 addr array
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	prefix
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	mask
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                        ])
                                                                                        self.prefix = None
                                                                                        self.mask = None
                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                            class SrcAddrIpv6(Entity):
                                                                                """
                                                                                Source Address IPV6
                                                                                
                                                                                .. attribute:: ipv6_addr_array
                                                                                
                                                                                	ipv6 addr array
                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.ipv6_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-ipv6"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                class Ipv6AddrArray(Entity):
                                                                                    """
                                                                                    ipv6 addr array
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	IPV6 prefix
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	IPV6 mask
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                        ])
                                                                                        self.prefix = None
                                                                                        self.mask = None
                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                            class DstAddrIpv6(Entity):
                                                                                """
                                                                                Destination Address IPV6
                                                                                
                                                                                .. attribute:: ipv6_addr_array
                                                                                
                                                                                	ipv6 addr array
                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.ipv6_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-addr-ipv6"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                class Ipv6AddrArray(Entity):
                                                                                    """
                                                                                    ipv6 addr array
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	IPV6 prefix
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	IPV6 mask
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                        ])
                                                                                        self.prefix = None
                                                                                        self.mask = None
                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                            class SrcAddrMac(Entity):
                                                                                """
                                                                                Source Address MAC
                                                                                
                                                                                .. attribute:: mac_addr_array
                                                                                
                                                                                	mac addr array
                                                                                	**type**\: list of  		 :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                    self.yang_name = "src-addr-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("mac-addr-array", ("mac_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.mac_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-mac"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                class MacAddrArray(Entity):
                                                                                    """
                                                                                    mac addr array
                                                                                    
                                                                                    .. attribute:: mac_addr
                                                                                    
                                                                                    	MAC address
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	MAC mask
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                        self.yang_name = "mac-addr-array"
                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                            ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                        ])
                                                                                        self.mac_addr = []
                                                                                        self.mask = []
                                                                                        self._segment_path = lambda: "mac-addr-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                            class Timer(Entity):
                                                                                """
                                                                                Timer
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                    self.yang_name = "timer"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "timer"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                            class TimerRegexp(Entity):
                                                                                """
                                                                                Timer Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                    self.yang_name = "timer-regexp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "timer-regexp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                            class TunnelName(Entity):
                                                                                """
                                                                                Tunnel Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                    self.yang_name = "tunnel-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "tunnel-name"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                            class TunnelNameRegex(Entity):
                                                                                """
                                                                                Tunnel Name Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "tunnel-name-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                            class UserName(Entity):
                                                                                """
                                                                                User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                    self.yang_name = "user-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "user-name"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                            class UserNameRegex(Entity):
                                                                                """
                                                                                User Name Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                    self.yang_name = "user-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "user-name-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                            class AuthUsername(Entity):
                                                                                """
                                                                                Authenticated User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                    self.yang_name = "auth-username"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "auth-username"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                            class AuthUsernameRegex(Entity):
                                                                                """
                                                                                Authenticated User Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                    self.yang_name = "auth-username-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "auth-username-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                            class UnauthUsername(Entity):
                                                                                """
                                                                                Unauthenticated User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                    self.yang_name = "unauth-username"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "unauth-username"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                            class UnauthUsernameRegex(Entity):
                                                                                """
                                                                                Unauthenticated User Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                    self.yang_name = "unauth-username-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "unauth-username-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                            class AuthDomain(Entity):
                                                                                """
                                                                                Authenticated domain name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                    self.yang_name = "auth-domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "auth-domain"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                            class AuthDomainRegex(Entity):
                                                                                """
                                                                                Authenticated Domain Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                    self.yang_name = "auth-domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "auth-domain-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                            class UnauthDomain(Entity):
                                                                                """
                                                                                Unauthenticated Domain Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                    self.yang_name = "unauth-domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "unauth-domain"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                            class UnauthDomainRegex(Entity):
                                                                                """
                                                                                Unauthenticated Domain Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "unauth-domain-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                            class VendorId(Entity):
                                                                                """
                                                                                Vendor ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                    self.yang_name = "vendor-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "vendor-id"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                            class VendorIdRegex(Entity):
                                                                                """
                                                                                Vendor ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                    self.yang_name = "vendor-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "vendor-id-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                            class AccessInterface(Entity):
                                                                                """
                                                                                Access interface
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                    self.yang_name = "access-interface"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "access-interface"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                            class InputInterface(Entity):
                                                                                """
                                                                                Input interface
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                    self.yang_name = "input-interface"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "input-interface"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                            class InputIntfhdl(Entity):
                                                                                """
                                                                                Input interface handle
                                                                                
                                                                                .. attribute:: uint64_array
                                                                                
                                                                                	uint64 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..18446744073709551615
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                    self.yang_name = "input-intfhdl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint64_array', (YLeafList(YType.uint64, 'uint64_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint64_array = []
                                                                                    self._segment_path = lambda: "input-intfhdl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                            class Ethertype(Entity):
                                                                                """
                                                                                Ethernet type
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                    self.yang_name = "ethertype"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ethertype"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ethertype"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class FlowKeyData(Entity):
                                                                                """
                                                                                Flow key structure
                                                                                
                                                                                .. attribute:: flow_keys
                                                                                
                                                                                	flow keys
                                                                                	**type**\:  :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                
                                                                                .. attribute:: max_count
                                                                                
                                                                                	Maximum count of flows
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: idle_timeout
                                                                                
                                                                                	Idle timeout of flows (in seconds)
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                	**units**\: second
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                    self.yang_name = "flow-key-data"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("flow-keys", ("flow_keys", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('max_count', (YLeaf(YType.uint16, 'max-count'), ['int'])),
                                                                                        ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                                    ])
                                                                                    self.max_count = None
                                                                                    self.idle_timeout = None

                                                                                    self.flow_keys = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                    self.flow_keys.parent = self
                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                    self._segment_path = lambda: "flow-key-data"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['max_count', 'idle_timeout'], name, value)


                                                                                class FlowKeys(Entity):
                                                                                    """
                                                                                    flow keys
                                                                                    
                                                                                    .. attribute:: keys
                                                                                    
                                                                                    	keys
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                    
                                                                                    .. attribute:: num
                                                                                    
                                                                                    	num
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                        self.yang_name = "flow-keys"
                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('keys', (YLeaf(YType.str, 'keys'), ['str'])),
                                                                                            ('num', (YLeaf(YType.uint8, 'num'), ['int'])),
                                                                                        ])
                                                                                        self.keys = None
                                                                                        self.num = None
                                                                                        self._segment_path = lambda: "flow-keys"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                            class DhcpClientId(Entity):
                                                                                """
                                                                                Dhcp Client ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                    self.yang_name = "dhcp-client-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "dhcp-client-id"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                            class DhcpClientIdRegex(Entity):
                                                                                """
                                                                                Dhcp Client ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                            class CircuitId(Entity):
                                                                                """
                                                                                Circuit ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                    self.yang_name = "circuit-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "circuit-id"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                            class CircuitIdRegex(Entity):
                                                                                """
                                                                                Circuit ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                    self.yang_name = "circuit-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "circuit-id-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                            class RemoteId(Entity):
                                                                                """
                                                                                Remote ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                    self.yang_name = "remote-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "remote-id"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                            class RemoteIdRegex(Entity):
                                                                                """
                                                                                Remote ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                    self.yang_name = "remote-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "remote-id-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                            class SrcPort(Entity):
                                                                                """
                                                                                Source port
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                    self.yang_name = "src-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "src-port"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "src-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class DstPort(Entity):
                                                                                """
                                                                                Destination port
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                    self.yang_name = "dst-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-port"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "dst-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['min', 'max'], name, value)


                                                        class ClmpP(Entity):
                                                            """
                                                            clmp p
                                                            
                                                            .. attribute:: class_map_bg
                                                            
                                                            	class map bg
                                                            	**type**\: list of  		 :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'infra-policymgr-oper'
                                                            _revision = '2018-01-17'

                                                            def __init__(self):
                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP, self).__init__()

                                                                self.yang_name = "clmp-p"
                                                                self.yang_parent_name = "policy-class-info-bg"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("class-map-bg", ("class_map_bg", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg))])
                                                                self._leafs = OrderedDict()

                                                                self.class_map_bg = YList(self)
                                                                self._segment_path = lambda: "clmp-p"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP, [], name, value)


                                                            class ClassMapBg(Entity):
                                                                """
                                                                class map bg
                                                                
                                                                .. attribute:: match_infop
                                                                
                                                                	Pointer to the first Match info
                                                                	**type**\:  :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop>`
                                                                
                                                                .. attribute:: name
                                                                
                                                                	Name of the class\-map
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..65
                                                                
                                                                .. attribute:: type
                                                                
                                                                	Class\-Map Type QoS/PBR/Netflow/..
                                                                	**type**\:  :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                                
                                                                .. attribute:: mode
                                                                
                                                                	Class\-Map Mode Match any/Match all
                                                                	**type**\:  :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                
                                                                .. attribute:: description
                                                                
                                                                	description
                                                                	**type**\: str
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg, self).__init__()

                                                                    self.yang_name = "class-map-bg"
                                                                    self.yang_parent_name = "clmp-p"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("match-infop", ("match_infop", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop))])
                                                                    self._leafs = OrderedDict([
                                                                        ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapTypeEn', '')])),
                                                                        ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapModeEn', '')])),
                                                                        ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                    ])
                                                                    self.name = None
                                                                    self.type = None
                                                                    self.mode = None
                                                                    self.description = None

                                                                    self.match_infop = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop()
                                                                    self.match_infop.parent = self
                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                    self._segment_path = lambda: "class-map-bg"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg, ['name', 'type', 'mode', 'description'], name, value)


                                                                class MatchInfop(Entity):
                                                                    """
                                                                    Pointer to the first Match info
                                                                    
                                                                    .. attribute:: class_match_info_st
                                                                    
                                                                    	class match info st
                                                                    	**type**\: list of  		 :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop, self).__init__()

                                                                        self.yang_name = "match-infop"
                                                                        self.yang_parent_name = "class-map-bg"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("class-match-info-st", ("class_match_info_st", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt))])
                                                                        self._leafs = OrderedDict()

                                                                        self.class_match_info_st = YList(self)
                                                                        self._segment_path = lambda: "match-infop"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop, [], name, value)


                                                                    class ClassMatchInfoSt(Entity):
                                                                        """
                                                                        class match info st
                                                                        
                                                                        .. attribute:: match_data
                                                                        
                                                                        	Match criteria
                                                                        	**type**\:  :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                        
                                                                        .. attribute:: flags
                                                                        
                                                                        	Flags
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                            self.yang_name = "class-match-info-st"
                                                                            self.yang_parent_name = "match-infop"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("match-data", ("match_data", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData))])
                                                                            self._leafs = OrderedDict([
                                                                                ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                            ])
                                                                            self.flags = None

                                                                            self.match_data = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                            self.match_data.parent = self
                                                                            self._children_name_map["match_data"] = "match-data"
                                                                            self._segment_path = lambda: "class-match-info-st"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                        class MatchData(Entity):
                                                                            """
                                                                            Match criteria
                                                                            
                                                                            .. attribute:: ipv4_dscp
                                                                            
                                                                            	IPv4 DSCP
                                                                            	**type**\:  :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                            
                                                                            .. attribute:: ipv6_dscp
                                                                            
                                                                            	IPv6 DSCP
                                                                            	**type**\:  :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                            
                                                                            .. attribute:: dscp
                                                                            
                                                                            	Match DSCP range array
                                                                            	**type**\:  :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                            
                                                                            .. attribute:: ipv4_prec
                                                                            
                                                                            	IPv4 Precedence
                                                                            	**type**\:  :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                            
                                                                            .. attribute:: ipv6_prec
                                                                            
                                                                            	IPv6 Precedence
                                                                            	**type**\:  :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                            
                                                                            .. attribute:: prec
                                                                            
                                                                            	Match Precedence array
                                                                            	**type**\:  :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                            
                                                                            .. attribute:: discard_class
                                                                            
                                                                            	Match Discard Class array
                                                                            	**type**\:  :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                            
                                                                            .. attribute:: qos_group
                                                                            
                                                                            	Match QoS group array
                                                                            	**type**\:  :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                            
                                                                            .. attribute:: traffic_class
                                                                            
                                                                            	Match Traffic class array
                                                                            	**type**\:  :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                            
                                                                            .. attribute:: proto
                                                                            
                                                                            	Match Protocol array
                                                                            	**type**\:  :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                            
                                                                            .. attribute:: icmp_v4
                                                                            
                                                                            	Match ICMPV4 Protocol
                                                                            	**type**\:  :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                            
                                                                            .. attribute:: icmp_v6
                                                                            
                                                                            	Match ICMPV6 Protocol array
                                                                            	**type**\:  :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                            
                                                                            .. attribute:: ipv4_packet_len
                                                                            
                                                                            	IPv4 packet length array
                                                                            	**type**\:  :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                            
                                                                            .. attribute:: ipv6_packet_len
                                                                            
                                                                            	IPv6 packet length array
                                                                            	**type**\:  :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                            
                                                                            .. attribute:: packet_len
                                                                            
                                                                            	Match packet length array
                                                                            	**type**\:  :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                            
                                                                            .. attribute:: flow_tag
                                                                            
                                                                            	Match flow\-tag array
                                                                            	**type**\:  :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                            
                                                                            .. attribute:: tcp_flag
                                                                            
                                                                            	Match tcp flag value
                                                                            	**type**\:  :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                            
                                                                            .. attribute:: icmpv4_type
                                                                            
                                                                            	Match ipv4 icmp type
                                                                            	**type**\:  :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                            
                                                                            .. attribute:: icmpv4_code
                                                                            
                                                                            	Match ipv4 icmp code
                                                                            	**type**\:  :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                            
                                                                            .. attribute:: icmpv6_type
                                                                            
                                                                            	Match ipv6 icmp type
                                                                            	**type**\:  :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                            
                                                                            .. attribute:: icmpv6_code
                                                                            
                                                                            	Match ipv6 icmp code
                                                                            	**type**\:  :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                            
                                                                            .. attribute:: mpls_exp
                                                                            
                                                                            	Match MPLS experimental topmost array
                                                                            	**type**\:  :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                            
                                                                            .. attribute:: mpls_exp_imp
                                                                            
                                                                            	Match MPLS experimental imposition array
                                                                            	**type**\:  :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                            
                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                            
                                                                            	MPLS Disposition IPv4 Access\-list
                                                                            	**type**\:  :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                            
                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                            
                                                                            	MPLS Disposition IPv6 Access\-list
                                                                            	**type**\:  :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                            
                                                                            .. attribute:: mpls_top_label
                                                                            
                                                                            	MPLS Topmost LABEL
                                                                            	**type**\:  :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                            
                                                                            .. attribute:: cos
                                                                            
                                                                            	Match CoS array
                                                                            	**type**\:  :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                            
                                                                            .. attribute:: cos_inr
                                                                            
                                                                            	Match inner header CoS
                                                                            	**type**\:  :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                            
                                                                            .. attribute:: dei
                                                                            
                                                                            	Match DEI Bit
                                                                            	**type**\:  :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                            
                                                                            .. attribute:: dei_inr
                                                                            
                                                                            	Match inner DEI Bit
                                                                            	**type**\:  :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                            
                                                                            .. attribute:: vlan
                                                                            
                                                                            	Match VLAN array
                                                                            	**type**\:  :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                            
                                                                            .. attribute:: vlan_inr
                                                                            
                                                                            	Match inner header VLAN range array
                                                                            	**type**\:  :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                            
                                                                            .. attribute:: fr_dlci
                                                                            
                                                                            	Match FR DLCI range array
                                                                            	**type**\:  :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                            
                                                                            .. attribute:: src_mac
                                                                            
                                                                            	Match Source MAC address
                                                                            	**type**\:  :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                            
                                                                            .. attribute:: dst_mac
                                                                            
                                                                            	Match Destination MAC address
                                                                            	**type**\:  :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                            
                                                                            .. attribute:: atm_clp
                                                                            
                                                                            	Match ATM CLP level
                                                                            	**type**\:  :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                            
                                                                            .. attribute:: fr_de
                                                                            
                                                                            	Match FR DE value
                                                                            	**type**\:  :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                            
                                                                            .. attribute:: ipv4_acl
                                                                            
                                                                            	IPv4 Access\-list
                                                                            	**type**\:  :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                            
                                                                            .. attribute:: ipv6_acl
                                                                            
                                                                            	IPv6 Access\-list
                                                                            	**type**\:  :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                            
                                                                            .. attribute:: ether_service_acl
                                                                            
                                                                            	Ethernet\-Services Access\-list
                                                                            	**type**\:  :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                            
                                                                            .. attribute:: avail_id
                                                                            
                                                                            	Available Identifiers
                                                                            	**type**\:  :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                            
                                                                            .. attribute:: media_type
                                                                            
                                                                            	Media Type
                                                                            	**type**\:  :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                            
                                                                            .. attribute:: subs_protocol
                                                                            
                                                                            	Protocol
                                                                            	**type**\:  :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                            
                                                                            .. attribute:: dnis
                                                                            
                                                                            	DNIS
                                                                            	**type**\:  :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                            
                                                                            .. attribute:: dnis_regex
                                                                            
                                                                            	DNIS Regular Expression
                                                                            	**type**\:  :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                            
                                                                            .. attribute:: domain
                                                                            
                                                                            	Domain Name
                                                                            	**type**\:  :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                            
                                                                            .. attribute:: domain_regex
                                                                            
                                                                            	Domain Regular Expression
                                                                            	**type**\:  :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                            
                                                                            .. attribute:: nas_port
                                                                            
                                                                            	NAS Port
                                                                            	**type**\:  :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                            
                                                                            .. attribute:: service_name
                                                                            
                                                                            	Service Name
                                                                            	**type**\:  :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                            
                                                                            .. attribute:: service_name_regex
                                                                            
                                                                            	Service Name Regular Exp
                                                                            	**type**\:  :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                            
                                                                            .. attribute:: src_addr_ipv4
                                                                            
                                                                            	Source Address IPV4
                                                                            	**type**\:  :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                            
                                                                            .. attribute:: dst_addr_ipv4
                                                                            
                                                                            	Destination Address IPV4
                                                                            	**type**\:  :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                            
                                                                            .. attribute:: src_addr_ipv6
                                                                            
                                                                            	Source Address IPV6
                                                                            	**type**\:  :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                            
                                                                            .. attribute:: dst_addr_ipv6
                                                                            
                                                                            	Destination Address IPV6
                                                                            	**type**\:  :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                            
                                                                            .. attribute:: src_addr_mac
                                                                            
                                                                            	Source Address MAC
                                                                            	**type**\:  :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                            
                                                                            .. attribute:: timer
                                                                            
                                                                            	Timer
                                                                            	**type**\:  :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                            
                                                                            .. attribute:: timer_regexp
                                                                            
                                                                            	Timer Regular Expression
                                                                            	**type**\:  :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                            
                                                                            .. attribute:: tunnel_name
                                                                            
                                                                            	Tunnel Name
                                                                            	**type**\:  :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                            
                                                                            .. attribute:: tunnel_name_regex
                                                                            
                                                                            	Tunnel Name Regular Expression
                                                                            	**type**\:  :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                            
                                                                            .. attribute:: user_name
                                                                            
                                                                            	User Name
                                                                            	**type**\:  :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                            
                                                                            .. attribute:: user_name_regex
                                                                            
                                                                            	User Name Regular Expression
                                                                            	**type**\:  :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                            
                                                                            .. attribute:: auth_username
                                                                            
                                                                            	Authenticated User Name
                                                                            	**type**\:  :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                            
                                                                            .. attribute:: auth_username_regex
                                                                            
                                                                            	Authenticated User Name RegEx
                                                                            	**type**\:  :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                            
                                                                            .. attribute:: unauth_username
                                                                            
                                                                            	Unauthenticated User Name
                                                                            	**type**\:  :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                            
                                                                            .. attribute:: unauth_username_regex
                                                                            
                                                                            	Unauthenticated User Name RegEx
                                                                            	**type**\:  :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                            
                                                                            .. attribute:: auth_domain
                                                                            
                                                                            	Authenticated domain name
                                                                            	**type**\:  :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                            
                                                                            .. attribute:: auth_domain_regex
                                                                            
                                                                            	Authenticated Domain Name RegEx
                                                                            	**type**\:  :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                            
                                                                            .. attribute:: unauth_domain
                                                                            
                                                                            	Unauthenticated Domain Name
                                                                            	**type**\:  :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                            
                                                                            .. attribute:: unauth_domain_regex
                                                                            
                                                                            	Unauthenticated Domain Name RegEx
                                                                            	**type**\:  :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                            
                                                                            .. attribute:: vendor_id
                                                                            
                                                                            	Vendor ID
                                                                            	**type**\:  :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                            
                                                                            .. attribute:: vendor_id_regex
                                                                            
                                                                            	Vendor ID RegEx
                                                                            	**type**\:  :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                            
                                                                            .. attribute:: access_interface
                                                                            
                                                                            	Access interface
                                                                            	**type**\:  :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                            
                                                                            .. attribute:: input_interface
                                                                            
                                                                            	Input interface
                                                                            	**type**\:  :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                            
                                                                            .. attribute:: input_intfhdl
                                                                            
                                                                            	Input interface handle
                                                                            	**type**\:  :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                            
                                                                            .. attribute:: ethertype
                                                                            
                                                                            	Ethernet type
                                                                            	**type**\:  :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                            
                                                                            .. attribute:: flow_key_data
                                                                            
                                                                            	Flow key structure
                                                                            	**type**\:  :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                            
                                                                            .. attribute:: dhcp_client_id
                                                                            
                                                                            	Dhcp Client ID
                                                                            	**type**\:  :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                            
                                                                            .. attribute:: dhcp_client_id_regex
                                                                            
                                                                            	Dhcp Client ID RegEx
                                                                            	**type**\:  :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                            
                                                                            .. attribute:: circuit_id
                                                                            
                                                                            	Circuit ID
                                                                            	**type**\:  :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                            
                                                                            .. attribute:: circuit_id_regex
                                                                            
                                                                            	Circuit ID RegEx
                                                                            	**type**\:  :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                            
                                                                            .. attribute:: remote_id
                                                                            
                                                                            	Remote ID
                                                                            	**type**\:  :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                            
                                                                            .. attribute:: remote_id_regex
                                                                            
                                                                            	Remote ID RegEx
                                                                            	**type**\:  :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                            
                                                                            .. attribute:: src_port
                                                                            
                                                                            	Source port
                                                                            	**type**\:  :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                            
                                                                            .. attribute:: dst_port
                                                                            
                                                                            	Destination port
                                                                            	**type**\:  :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:  :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                            
                                                                            .. attribute:: mpls_top_eos
                                                                            
                                                                            	MPLS Topmost EOS
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: fragment_type
                                                                            
                                                                            	Fragment type
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: authen_status
                                                                            
                                                                            	Authentication Status
                                                                            	**type**\:  :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                            
                                                                            .. attribute:: mlp_negotiated
                                                                            
                                                                            	MLP Negotiated
                                                                            	**type**\:  :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                self.yang_name = "match-data"
                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("ipv4-dscp", ("ipv4_dscp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp)), ("ipv6-dscp", ("ipv6_dscp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp)), ("dscp", ("dscp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp)), ("ipv4-prec", ("ipv4_prec", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec)), ("ipv6-prec", ("ipv6_prec", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec)), ("prec", ("prec", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec)), ("discard-class", ("discard_class", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass)), ("qos-group", ("qos_group", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup)), ("traffic-class", ("traffic_class", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass)), ("proto", ("proto", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto)), ("icmp-v4", ("icmp_v4", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4)), ("icmp-v6", ("icmp_v6", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6)), ("ipv4-packet-len", ("ipv4_packet_len", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen)), ("ipv6-packet-len", ("ipv6_packet_len", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen)), ("packet-len", ("packet_len", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen)), ("flow-tag", ("flow_tag", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag)), ("tcp-flag", ("tcp_flag", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag)), ("icmpv4-type", ("icmpv4_type", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type)), ("icmpv4-code", ("icmpv4_code", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code)), ("icmpv6-type", ("icmpv6_type", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type)), ("icmpv6-code", ("icmpv6_code", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code)), ("mpls-exp", ("mpls_exp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp)), ("mpls-exp-imp", ("mpls_exp_imp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp)), ("mpls-disp-ipv4-acl", ("mpls_disp_ipv4_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl)), ("mpls-disp-ipv6-acl", ("mpls_disp_ipv6_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl)), ("mpls-top-label", ("mpls_top_label", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel)), ("cos", ("cos", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos)), ("cos-inr", ("cos_inr", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr)), ("dei", ("dei", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei)), ("dei-inr", ("dei_inr", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr)), ("vlan", ("vlan", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan)), ("vlan-inr", ("vlan_inr", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)), ("fr-dlci", ("fr_dlci", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci)), ("src-mac", ("src_mac", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac)), ("dst-mac", ("dst_mac", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac)), ("atm-clp", ("atm_clp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp)), ("fr-de", ("fr_de", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe)), ("ipv4-acl", ("ipv4_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl)), ("ipv6-acl", ("ipv6_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl)), ("ether-service-acl", ("ether_service_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl)), ("avail-id", ("avail_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId)), ("media-type", ("media_type", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType)), ("subs-protocol", ("subs_protocol", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol)), ("dnis", ("dnis", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis)), ("dnis-regex", ("dnis_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex)), ("domain", ("domain", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain)), ("domain-regex", ("domain_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex)), ("nas-port", ("nas_port", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort)), ("service-name", ("service_name", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName)), ("service-name-regex", ("service_name_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex)), ("src-addr-ipv4", ("src_addr_ipv4", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4)), ("dst-addr-ipv4", ("dst_addr_ipv4", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4)), ("src-addr-ipv6", ("src_addr_ipv6", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6)), ("dst-addr-ipv6", ("dst_addr_ipv6", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6)), ("src-addr-mac", ("src_addr_mac", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac)), ("timer", ("timer", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer)), ("timer-regexp", ("timer_regexp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp)), ("tunnel-name", ("tunnel_name", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName)), ("tunnel-name-regex", ("tunnel_name_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex)), ("user-name", ("user_name", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName)), ("user-name-regex", ("user_name_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex)), ("auth-username", ("auth_username", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername)), ("auth-username-regex", ("auth_username_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex)), ("unauth-username", ("unauth_username", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername)), ("unauth-username-regex", ("unauth_username_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex)), ("auth-domain", ("auth_domain", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain)), ("auth-domain-regex", ("auth_domain_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex)), ("unauth-domain", ("unauth_domain", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain)), ("unauth-domain-regex", ("unauth_domain_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex)), ("vendor-id", ("vendor_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId)), ("vendor-id-regex", ("vendor_id_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex)), ("access-interface", ("access_interface", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface)), ("input-interface", ("input_interface", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface)), ("input-intfhdl", ("input_intfhdl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl)), ("ethertype", ("ethertype", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype)), ("flow-key-data", ("flow_key_data", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData)), ("dhcp-client-id", ("dhcp_client_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId)), ("dhcp-client-id-regex", ("dhcp_client_id_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex)), ("circuit-id", ("circuit_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId)), ("circuit-id-regex", ("circuit_id_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex)), ("remote-id", ("remote_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId)), ("remote-id-regex", ("remote_id_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex)), ("src-port", ("src_port", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort)), ("dst-port", ("dst_port", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchTypeEn', '')])),
                                                                                    ('mpls_top_eos', (YLeaf(YType.uint8, 'mpls-top-eos'), ['int'])),
                                                                                    ('fragment_type', (YLeaf(YType.uint8, 'fragment-type'), ['int'])),
                                                                                    ('authen_status', (YLeaf(YType.enumeration, 'authen-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchAuthenStatusEn', '')])),
                                                                                    ('mlp_negotiated', (YLeaf(YType.enumeration, 'mlp-negotiated'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchMlpNegotiatedEn', '')])),
                                                                                ])
                                                                                self.type = None
                                                                                self.mpls_top_eos = None
                                                                                self.fragment_type = None
                                                                                self.authen_status = None
                                                                                self.mlp_negotiated = None

                                                                                self.ipv4_dscp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                self.ipv4_dscp.parent = self
                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"

                                                                                self.ipv6_dscp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                self.ipv6_dscp.parent = self
                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"

                                                                                self.dscp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                self.dscp.parent = self
                                                                                self._children_name_map["dscp"] = "dscp"

                                                                                self.ipv4_prec = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                self.ipv4_prec.parent = self
                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"

                                                                                self.ipv6_prec = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                self.ipv6_prec.parent = self
                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"

                                                                                self.prec = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                self.prec.parent = self
                                                                                self._children_name_map["prec"] = "prec"

                                                                                self.discard_class = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                self.discard_class.parent = self
                                                                                self._children_name_map["discard_class"] = "discard-class"

                                                                                self.qos_group = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                self.qos_group.parent = self
                                                                                self._children_name_map["qos_group"] = "qos-group"

                                                                                self.traffic_class = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                self.traffic_class.parent = self
                                                                                self._children_name_map["traffic_class"] = "traffic-class"

                                                                                self.proto = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                self.proto.parent = self
                                                                                self._children_name_map["proto"] = "proto"

                                                                                self.icmp_v4 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                self.icmp_v4.parent = self
                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"

                                                                                self.icmp_v6 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                self.icmp_v6.parent = self
                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"

                                                                                self.ipv4_packet_len = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                self.ipv4_packet_len.parent = self
                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"

                                                                                self.ipv6_packet_len = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                self.ipv6_packet_len.parent = self
                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"

                                                                                self.packet_len = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                self.packet_len.parent = self
                                                                                self._children_name_map["packet_len"] = "packet-len"

                                                                                self.flow_tag = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                self.flow_tag.parent = self
                                                                                self._children_name_map["flow_tag"] = "flow-tag"

                                                                                self.tcp_flag = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                self.tcp_flag.parent = self
                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"

                                                                                self.icmpv4_type = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                self.icmpv4_type.parent = self
                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"

                                                                                self.icmpv4_code = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                self.icmpv4_code.parent = self
                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"

                                                                                self.icmpv6_type = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                self.icmpv6_type.parent = self
                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"

                                                                                self.icmpv6_code = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                self.icmpv6_code.parent = self
                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"

                                                                                self.mpls_exp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                self.mpls_exp.parent = self
                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"

                                                                                self.mpls_exp_imp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                self.mpls_exp_imp.parent = self
                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"

                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"

                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"

                                                                                self.mpls_top_label = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                self.mpls_top_label.parent = self
                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"

                                                                                self.cos = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                self.cos.parent = self
                                                                                self._children_name_map["cos"] = "cos"

                                                                                self.cos_inr = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                self.cos_inr.parent = self
                                                                                self._children_name_map["cos_inr"] = "cos-inr"

                                                                                self.dei = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                self.dei.parent = self
                                                                                self._children_name_map["dei"] = "dei"

                                                                                self.dei_inr = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                self.dei_inr.parent = self
                                                                                self._children_name_map["dei_inr"] = "dei-inr"

                                                                                self.vlan = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                self.vlan.parent = self
                                                                                self._children_name_map["vlan"] = "vlan"

                                                                                self.vlan_inr = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                self.vlan_inr.parent = self
                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"

                                                                                self.fr_dlci = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                self.fr_dlci.parent = self
                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"

                                                                                self.src_mac = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                self.src_mac.parent = self
                                                                                self._children_name_map["src_mac"] = "src-mac"

                                                                                self.dst_mac = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                self.dst_mac.parent = self
                                                                                self._children_name_map["dst_mac"] = "dst-mac"

                                                                                self.atm_clp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                self.atm_clp.parent = self
                                                                                self._children_name_map["atm_clp"] = "atm-clp"

                                                                                self.fr_de = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                self.fr_de.parent = self
                                                                                self._children_name_map["fr_de"] = "fr-de"

                                                                                self.ipv4_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                self.ipv4_acl.parent = self
                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"

                                                                                self.ipv6_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                self.ipv6_acl.parent = self
                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"

                                                                                self.ether_service_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                self.ether_service_acl.parent = self
                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"

                                                                                self.avail_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                self.avail_id.parent = self
                                                                                self._children_name_map["avail_id"] = "avail-id"

                                                                                self.media_type = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                self.media_type.parent = self
                                                                                self._children_name_map["media_type"] = "media-type"

                                                                                self.subs_protocol = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                self.subs_protocol.parent = self
                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"

                                                                                self.dnis = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                self.dnis.parent = self
                                                                                self._children_name_map["dnis"] = "dnis"

                                                                                self.dnis_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                self.dnis_regex.parent = self
                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"

                                                                                self.domain = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                self.domain.parent = self
                                                                                self._children_name_map["domain"] = "domain"

                                                                                self.domain_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                self.domain_regex.parent = self
                                                                                self._children_name_map["domain_regex"] = "domain-regex"

                                                                                self.nas_port = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                self.nas_port.parent = self
                                                                                self._children_name_map["nas_port"] = "nas-port"

                                                                                self.service_name = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                self.service_name.parent = self
                                                                                self._children_name_map["service_name"] = "service-name"

                                                                                self.service_name_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                self.service_name_regex.parent = self
                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"

                                                                                self.src_addr_ipv4 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                self.src_addr_ipv4.parent = self
                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"

                                                                                self.dst_addr_ipv4 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                self.dst_addr_ipv4.parent = self
                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"

                                                                                self.src_addr_ipv6 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                self.src_addr_ipv6.parent = self
                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"

                                                                                self.dst_addr_ipv6 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                self.dst_addr_ipv6.parent = self
                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"

                                                                                self.src_addr_mac = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                self.src_addr_mac.parent = self
                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"

                                                                                self.timer = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                self.timer.parent = self
                                                                                self._children_name_map["timer"] = "timer"

                                                                                self.timer_regexp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                self.timer_regexp.parent = self
                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"

                                                                                self.tunnel_name = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                self.tunnel_name.parent = self
                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"

                                                                                self.tunnel_name_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                self.tunnel_name_regex.parent = self
                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"

                                                                                self.user_name = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                self.user_name.parent = self
                                                                                self._children_name_map["user_name"] = "user-name"

                                                                                self.user_name_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                self.user_name_regex.parent = self
                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"

                                                                                self.auth_username = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                self.auth_username.parent = self
                                                                                self._children_name_map["auth_username"] = "auth-username"

                                                                                self.auth_username_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                self.auth_username_regex.parent = self
                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"

                                                                                self.unauth_username = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                self.unauth_username.parent = self
                                                                                self._children_name_map["unauth_username"] = "unauth-username"

                                                                                self.unauth_username_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                self.unauth_username_regex.parent = self
                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"

                                                                                self.auth_domain = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                self.auth_domain.parent = self
                                                                                self._children_name_map["auth_domain"] = "auth-domain"

                                                                                self.auth_domain_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                self.auth_domain_regex.parent = self
                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"

                                                                                self.unauth_domain = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                self.unauth_domain.parent = self
                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"

                                                                                self.unauth_domain_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                self.unauth_domain_regex.parent = self
                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"

                                                                                self.vendor_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                self.vendor_id.parent = self
                                                                                self._children_name_map["vendor_id"] = "vendor-id"

                                                                                self.vendor_id_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                self.vendor_id_regex.parent = self
                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"

                                                                                self.access_interface = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                self.access_interface.parent = self
                                                                                self._children_name_map["access_interface"] = "access-interface"

                                                                                self.input_interface = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                self.input_interface.parent = self
                                                                                self._children_name_map["input_interface"] = "input-interface"

                                                                                self.input_intfhdl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                self.input_intfhdl.parent = self
                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"

                                                                                self.ethertype = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                self.ethertype.parent = self
                                                                                self._children_name_map["ethertype"] = "ethertype"

                                                                                self.flow_key_data = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                self.flow_key_data.parent = self
                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"

                                                                                self.dhcp_client_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                self.dhcp_client_id.parent = self
                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"

                                                                                self.dhcp_client_id_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                self.dhcp_client_id_regex.parent = self
                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"

                                                                                self.circuit_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                self.circuit_id.parent = self
                                                                                self._children_name_map["circuit_id"] = "circuit-id"

                                                                                self.circuit_id_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                self.circuit_id_regex.parent = self
                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"

                                                                                self.remote_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                self.remote_id.parent = self
                                                                                self._children_name_map["remote_id"] = "remote-id"

                                                                                self.remote_id_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                self.remote_id_regex.parent = self
                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"

                                                                                self.src_port = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                self.src_port.parent = self
                                                                                self._children_name_map["src_port"] = "src-port"

                                                                                self.dst_port = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                self.dst_port.parent = self
                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                self._segment_path = lambda: "match-data"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['type', 'mpls_top_eos', 'fragment_type', 'authen_status', 'mlp_negotiated'], name, value)


                                                                            class Ipv4Dscp(Entity):
                                                                                """
                                                                                IPv4 DSCP
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                    self.yang_name = "ipv4-dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv4-dscp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Ipv6Dscp(Entity):
                                                                                """
                                                                                IPv6 DSCP
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                    self.yang_name = "ipv6-dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv6-dscp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Dscp(Entity):
                                                                                """
                                                                                Match DSCP range array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                    self.yang_name = "dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "dscp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Ipv4Prec(Entity):
                                                                                """
                                                                                IPv4 Precedence
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                    self.yang_name = "ipv4-prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "ipv4-prec"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                            class Ipv6Prec(Entity):
                                                                                """
                                                                                IPv6 Precedence
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                    self.yang_name = "ipv6-prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "ipv6-prec"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                            class Prec(Entity):
                                                                                """
                                                                                Match Precedence array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                    self.yang_name = "prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "prec"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                            class DiscardClass(Entity):
                                                                                """
                                                                                Match Discard Class array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                    self.yang_name = "discard-class"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "discard-class"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                            class QosGroup(Entity):
                                                                                """
                                                                                Match QoS group array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                    self.yang_name = "qos-group"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "qos-group"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "qos-group"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class TrafficClass(Entity):
                                                                                """
                                                                                Match Traffic class array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                    self.yang_name = "traffic-class"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "traffic-class"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "traffic-class"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Proto(Entity):
                                                                                """
                                                                                Match Protocol array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                    self.yang_name = "proto"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "proto"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "proto"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class IcmpV4(Entity):
                                                                                """
                                                                                Match ICMPV4 Protocol
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Protocol type
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: code
                                                                                
                                                                                	Protocol code
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                    self.yang_name = "icmp-v4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                    ])
                                                                                    self.type = None
                                                                                    self.code = None
                                                                                    self._segment_path = lambda: "icmp-v4"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['type', 'code'], name, value)


                                                                            class IcmpV6(Entity):
                                                                                """
                                                                                Match ICMPV6 Protocol array
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Protocol type
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: code
                                                                                
                                                                                	Protocol code
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                    self.yang_name = "icmp-v6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                    ])
                                                                                    self.type = None
                                                                                    self.code = None
                                                                                    self._segment_path = lambda: "icmp-v6"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['type', 'code'], name, value)


                                                                            class Ipv4PacketLen(Entity):
                                                                                """
                                                                                IPv4 packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv4-packet-len"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class Ipv6PacketLen(Entity):
                                                                                """
                                                                                IPv6 packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv6-packet-len"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class PacketLen(Entity):
                                                                                """
                                                                                Match packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                    self.yang_name = "packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "packet-len"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class FlowTag(Entity):
                                                                                """
                                                                                Match flow\-tag array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                    self.yang_name = "flow-tag"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "flow-tag"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "flow-tag"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class TcpFlag(Entity):
                                                                                """
                                                                                Match tcp flag value
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	Value of TCP flag
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: match_any
                                                                                
                                                                                	Match any TCP flag bit
                                                                                	**type**\: bool
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                    self.yang_name = "tcp-flag"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                        ('match_any', (YLeaf(YType.boolean, 'match-any'), ['bool'])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.match_any = None
                                                                                    self._segment_path = lambda: "tcp-flag"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['value', 'match_any'], name, value)


                                                                            class Icmpv4Type(Entity):
                                                                                """
                                                                                Match ipv4 icmp type
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                    self.yang_name = "icmpv4-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv4-type"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Icmpv4Code(Entity):
                                                                                """
                                                                                Match ipv4 icmp code
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                    self.yang_name = "icmpv4-code"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv4-code"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Icmpv6Type(Entity):
                                                                                """
                                                                                Match ipv6 icmp type
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                    self.yang_name = "icmpv6-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv6-type"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Icmpv6Code(Entity):
                                                                                """
                                                                                Match ipv6 icmp code
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                    self.yang_name = "icmpv6-code"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv6-code"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class MplsExp(Entity):
                                                                                """
                                                                                Match MPLS experimental topmost array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                    self.yang_name = "mpls-exp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "mpls-exp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                            class MplsExpImp(Entity):
                                                                                """
                                                                                Match MPLS experimental imposition array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "mpls-exp-imp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                            class MplsDispIpv4Acl(Entity):
                                                                                """
                                                                                MPLS Disposition IPv4 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                            class MplsDispIpv6Acl(Entity):
                                                                                """
                                                                                MPLS Disposition IPv6 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                            class MplsTopLabel(Entity):
                                                                                """
                                                                                MPLS Topmost LABEL
                                                                                
                                                                                .. attribute:: uint32_rng_array
                                                                                
                                                                                	uint32 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                    self.yang_name = "mpls-top-label"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint32_rng_array", ("uint32_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint32_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "mpls-top-label"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                class Uint32RngArray(Entity):
                                                                                    """
                                                                                    uint32 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                        self.yang_name = "uint32_rng_array"
                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint32, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint32, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint32_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['min', 'max'], name, value)


                                                                            class Cos(Entity):
                                                                                """
                                                                                Match CoS array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                    self.yang_name = "cos"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "cos"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                            class CosInr(Entity):
                                                                                """
                                                                                Match inner header CoS
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                    self.yang_name = "cos-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "cos-inr"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                            class Dei(Entity):
                                                                                """
                                                                                Match DEI Bit
                                                                                
                                                                                .. attribute:: bit_value
                                                                                
                                                                                	Value of the DEI bit
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                    self.yang_name = "dei"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                    ])
                                                                                    self.bit_value = None
                                                                                    self._segment_path = lambda: "dei"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                            class DeiInr(Entity):
                                                                                """
                                                                                Match inner DEI Bit
                                                                                
                                                                                .. attribute:: bit_value
                                                                                
                                                                                	Value of the DEI bit
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                    self.yang_name = "dei-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                    ])
                                                                                    self.bit_value = None
                                                                                    self._segment_path = lambda: "dei-inr"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                            class Vlan(Entity):
                                                                                """
                                                                                Match VLAN array
                                                                                
                                                                                .. attribute:: vlan_id_array
                                                                                
                                                                                	vlan id array
                                                                                	**type**\: list of  		 :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                    self.yang_name = "vlan"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("vlan-id-array", ("vlan_id_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.vlan_id_array = YList(self)
                                                                                    self._segment_path = lambda: "vlan"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                class VlanIdArray(Entity):
                                                                                    """
                                                                                    vlan id array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	VLAN mask
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                        self.yang_name = "vlan-id-array"
                                                                                        self.yang_parent_name = "vlan"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                            ('mask', (YLeaf(YType.uint16, 'mask'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self.mask = None
                                                                                        self._segment_path = lambda: "vlan-id-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['min', 'max', 'mask'], name, value)


                                                                            class VlanInr(Entity):
                                                                                """
                                                                                Match inner header VLAN range array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                    self.yang_name = "vlan-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "vlan-inr"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class FrDlci(Entity):
                                                                                """
                                                                                Match FR DLCI range array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                    self.yang_name = "fr-dlci"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "fr-dlci"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class SrcMac(Entity):
                                                                                """
                                                                                Match Source MAC address
                                                                                
                                                                                .. attribute:: mac_addr
                                                                                
                                                                                	MAC address
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	MAC mask
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                    self.yang_name = "src-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                    ])
                                                                                    self.mac_addr = []
                                                                                    self.mask = []
                                                                                    self._segment_path = lambda: "src-mac"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                            class DstMac(Entity):
                                                                                """
                                                                                Match Destination MAC address
                                                                                
                                                                                .. attribute:: mac_addr
                                                                                
                                                                                	MAC address
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	MAC mask
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                    self.yang_name = "dst-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                    ])
                                                                                    self.mac_addr = []
                                                                                    self.mask = []
                                                                                    self._segment_path = lambda: "dst-mac"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                            class AtmClp(Entity):
                                                                                """
                                                                                Match ATM CLP level
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                    self.yang_name = "atm-clp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "atm-clp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                            class FrDe(Entity):
                                                                                """
                                                                                Match FR DE value
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                    self.yang_name = "fr-de"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "fr-de"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                            class Ipv4Acl(Entity):
                                                                                """
                                                                                IPv4 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                    self.yang_name = "ipv4-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "ipv4-acl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                            class Ipv6Acl(Entity):
                                                                                """
                                                                                IPv6 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                    self.yang_name = "ipv6-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "ipv6-acl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                            class EtherServiceAcl(Entity):
                                                                                """
                                                                                Ethernet\-Services Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                    self.yang_name = "ether-service-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "ether-service-acl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                            class AvailId(Entity):
                                                                                """
                                                                                Available Identifiers
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                    self.yang_name = "avail-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "avail-id"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                            class MediaType(Entity):
                                                                                """
                                                                                Media Type
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                    self.yang_name = "media-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "media-type"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                            class SubsProtocol(Entity):
                                                                                """
                                                                                Protocol
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                    self.yang_name = "subs-protocol"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "subs-protocol"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                            class Dnis(Entity):
                                                                                """
                                                                                DNIS
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                    self.yang_name = "dnis"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "dnis"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                            class DnisRegex(Entity):
                                                                                """
                                                                                DNIS Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                    self.yang_name = "dnis-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "dnis-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                            class Domain(Entity):
                                                                                """
                                                                                Domain Name
                                                                                
                                                                                .. attribute:: domain_array
                                                                                
                                                                                	domain array
                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                    self.yang_name = "domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.domain_array = YList(self)
                                                                                    self._segment_path = lambda: "domain"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                class DomainArray(Entity):
                                                                                    """
                                                                                    domain array
                                                                                    
                                                                                    .. attribute:: domain_name
                                                                                    
                                                                                    	domain name
                                                                                    	**type**\: str
                                                                                    
                                                                                    .. attribute:: format_name
                                                                                    
                                                                                    	format name
                                                                                    	**type**\: str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                        self.yang_name = "domain-array"
                                                                                        self.yang_parent_name = "domain"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                        ])
                                                                                        self.domain_name = None
                                                                                        self.format_name = None
                                                                                        self._segment_path = lambda: "domain-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                            class DomainRegex(Entity):
                                                                                """
                                                                                Domain Regular Expression
                                                                                
                                                                                .. attribute:: domain_array
                                                                                
                                                                                	domain array
                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                    self.yang_name = "domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.domain_array = YList(self)
                                                                                    self._segment_path = lambda: "domain-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                class DomainArray(Entity):
                                                                                    """
                                                                                    domain array
                                                                                    
                                                                                    .. attribute:: domain_name
                                                                                    
                                                                                    	domain name
                                                                                    	**type**\: str
                                                                                    
                                                                                    .. attribute:: format_name
                                                                                    
                                                                                    	format name
                                                                                    	**type**\: str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                        self.yang_name = "domain-array"
                                                                                        self.yang_parent_name = "domain-regex"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                        ])
                                                                                        self.domain_name = None
                                                                                        self.format_name = None
                                                                                        self._segment_path = lambda: "domain-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                            class NasPort(Entity):
                                                                                """
                                                                                NAS Port
                                                                                
                                                                                .. attribute:: nas_port_array
                                                                                
                                                                                	nas port array
                                                                                	**type**\: list of  		 :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                    self.yang_name = "nas-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("nas-port-array", ("nas_port_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.nas_port_array = YList(self)
                                                                                    self._segment_path = lambda: "nas-port"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                class NasPortArray(Entity):
                                                                                    """
                                                                                    nas port array
                                                                                    
                                                                                    .. attribute:: sub_id
                                                                                    
                                                                                    	sub id
                                                                                    	**type**\:  :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                    
                                                                                    .. attribute:: operator
                                                                                    
                                                                                    	operator
                                                                                    	**type**\:  :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                        self.yang_name = "nas-port-array"
                                                                                        self.yang_parent_name = "nas-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('sub_id', (YLeaf(YType.enumeration, 'sub-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchNasPortSubIdEn', '')])),
                                                                                            ('operator', (YLeaf(YType.enumeration, 'operator'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchLogicalOperatorEn', '')])),
                                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ])
                                                                                        self.sub_id = None
                                                                                        self.operator = None
                                                                                        self.value = None
                                                                                        self._segment_path = lambda: "nas-port-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['sub_id', 'operator', 'value'], name, value)


                                                                            class ServiceName(Entity):
                                                                                """
                                                                                Service Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                    self.yang_name = "service-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "service-name"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                            class ServiceNameRegex(Entity):
                                                                                """
                                                                                Service Name Regular Exp
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                    self.yang_name = "service-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "service-name-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                            class SrcAddrIpv4(Entity):
                                                                                """
                                                                                Source Address IPV4
                                                                                
                                                                                .. attribute:: ipv4_addr_array
                                                                                
                                                                                	ipv4 addr array
                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.ipv4_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-ipv4"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                class Ipv4AddrArray(Entity):
                                                                                    """
                                                                                    ipv4 addr array
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	prefix
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	mask
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                        ])
                                                                                        self.prefix = None
                                                                                        self.mask = None
                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                            class DstAddrIpv4(Entity):
                                                                                """
                                                                                Destination Address IPV4
                                                                                
                                                                                .. attribute:: ipv4_addr_array
                                                                                
                                                                                	ipv4 addr array
                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.ipv4_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-addr-ipv4"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                class Ipv4AddrArray(Entity):
                                                                                    """
                                                                                    ipv4 addr array
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	prefix
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	mask
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                        ])
                                                                                        self.prefix = None
                                                                                        self.mask = None
                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                            class SrcAddrIpv6(Entity):
                                                                                """
                                                                                Source Address IPV6
                                                                                
                                                                                .. attribute:: ipv6_addr_array
                                                                                
                                                                                	ipv6 addr array
                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.ipv6_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-ipv6"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                class Ipv6AddrArray(Entity):
                                                                                    """
                                                                                    ipv6 addr array
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	IPV6 prefix
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	IPV6 mask
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                        ])
                                                                                        self.prefix = None
                                                                                        self.mask = None
                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                            class DstAddrIpv6(Entity):
                                                                                """
                                                                                Destination Address IPV6
                                                                                
                                                                                .. attribute:: ipv6_addr_array
                                                                                
                                                                                	ipv6 addr array
                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.ipv6_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-addr-ipv6"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                class Ipv6AddrArray(Entity):
                                                                                    """
                                                                                    ipv6 addr array
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	IPV6 prefix
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	IPV6 mask
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                        ])
                                                                                        self.prefix = None
                                                                                        self.mask = None
                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                            class SrcAddrMac(Entity):
                                                                                """
                                                                                Source Address MAC
                                                                                
                                                                                .. attribute:: mac_addr_array
                                                                                
                                                                                	mac addr array
                                                                                	**type**\: list of  		 :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                    self.yang_name = "src-addr-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("mac-addr-array", ("mac_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.mac_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-mac"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                class MacAddrArray(Entity):
                                                                                    """
                                                                                    mac addr array
                                                                                    
                                                                                    .. attribute:: mac_addr
                                                                                    
                                                                                    	MAC address
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	MAC mask
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                        self.yang_name = "mac-addr-array"
                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                            ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                        ])
                                                                                        self.mac_addr = []
                                                                                        self.mask = []
                                                                                        self._segment_path = lambda: "mac-addr-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                            class Timer(Entity):
                                                                                """
                                                                                Timer
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                    self.yang_name = "timer"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "timer"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                            class TimerRegexp(Entity):
                                                                                """
                                                                                Timer Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                    self.yang_name = "timer-regexp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "timer-regexp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                            class TunnelName(Entity):
                                                                                """
                                                                                Tunnel Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                    self.yang_name = "tunnel-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "tunnel-name"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                            class TunnelNameRegex(Entity):
                                                                                """
                                                                                Tunnel Name Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "tunnel-name-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                            class UserName(Entity):
                                                                                """
                                                                                User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                    self.yang_name = "user-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "user-name"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                            class UserNameRegex(Entity):
                                                                                """
                                                                                User Name Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                    self.yang_name = "user-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "user-name-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                            class AuthUsername(Entity):
                                                                                """
                                                                                Authenticated User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                    self.yang_name = "auth-username"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "auth-username"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                            class AuthUsernameRegex(Entity):
                                                                                """
                                                                                Authenticated User Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                    self.yang_name = "auth-username-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "auth-username-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                            class UnauthUsername(Entity):
                                                                                """
                                                                                Unauthenticated User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                    self.yang_name = "unauth-username"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "unauth-username"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                            class UnauthUsernameRegex(Entity):
                                                                                """
                                                                                Unauthenticated User Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                    self.yang_name = "unauth-username-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "unauth-username-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                            class AuthDomain(Entity):
                                                                                """
                                                                                Authenticated domain name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                    self.yang_name = "auth-domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "auth-domain"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                            class AuthDomainRegex(Entity):
                                                                                """
                                                                                Authenticated Domain Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                    self.yang_name = "auth-domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "auth-domain-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                            class UnauthDomain(Entity):
                                                                                """
                                                                                Unauthenticated Domain Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                    self.yang_name = "unauth-domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "unauth-domain"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                            class UnauthDomainRegex(Entity):
                                                                                """
                                                                                Unauthenticated Domain Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "unauth-domain-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                            class VendorId(Entity):
                                                                                """
                                                                                Vendor ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                    self.yang_name = "vendor-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "vendor-id"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                            class VendorIdRegex(Entity):
                                                                                """
                                                                                Vendor ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                    self.yang_name = "vendor-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "vendor-id-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                            class AccessInterface(Entity):
                                                                                """
                                                                                Access interface
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                    self.yang_name = "access-interface"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "access-interface"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                            class InputInterface(Entity):
                                                                                """
                                                                                Input interface
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                    self.yang_name = "input-interface"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "input-interface"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                            class InputIntfhdl(Entity):
                                                                                """
                                                                                Input interface handle
                                                                                
                                                                                .. attribute:: uint64_array
                                                                                
                                                                                	uint64 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..18446744073709551615
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                    self.yang_name = "input-intfhdl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint64_array', (YLeafList(YType.uint64, 'uint64_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint64_array = []
                                                                                    self._segment_path = lambda: "input-intfhdl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                            class Ethertype(Entity):
                                                                                """
                                                                                Ethernet type
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                    self.yang_name = "ethertype"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ethertype"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ethertype"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class FlowKeyData(Entity):
                                                                                """
                                                                                Flow key structure
                                                                                
                                                                                .. attribute:: flow_keys
                                                                                
                                                                                	flow keys
                                                                                	**type**\:  :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                
                                                                                .. attribute:: max_count
                                                                                
                                                                                	Maximum count of flows
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: idle_timeout
                                                                                
                                                                                	Idle timeout of flows (in seconds)
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                	**units**\: second
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                    self.yang_name = "flow-key-data"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("flow-keys", ("flow_keys", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('max_count', (YLeaf(YType.uint16, 'max-count'), ['int'])),
                                                                                        ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                                    ])
                                                                                    self.max_count = None
                                                                                    self.idle_timeout = None

                                                                                    self.flow_keys = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                    self.flow_keys.parent = self
                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                    self._segment_path = lambda: "flow-key-data"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['max_count', 'idle_timeout'], name, value)


                                                                                class FlowKeys(Entity):
                                                                                    """
                                                                                    flow keys
                                                                                    
                                                                                    .. attribute:: keys
                                                                                    
                                                                                    	keys
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                    
                                                                                    .. attribute:: num
                                                                                    
                                                                                    	num
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                        self.yang_name = "flow-keys"
                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('keys', (YLeaf(YType.str, 'keys'), ['str'])),
                                                                                            ('num', (YLeaf(YType.uint8, 'num'), ['int'])),
                                                                                        ])
                                                                                        self.keys = None
                                                                                        self.num = None
                                                                                        self._segment_path = lambda: "flow-keys"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                            class DhcpClientId(Entity):
                                                                                """
                                                                                Dhcp Client ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                    self.yang_name = "dhcp-client-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "dhcp-client-id"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                            class DhcpClientIdRegex(Entity):
                                                                                """
                                                                                Dhcp Client ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                            class CircuitId(Entity):
                                                                                """
                                                                                Circuit ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                    self.yang_name = "circuit-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "circuit-id"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                            class CircuitIdRegex(Entity):
                                                                                """
                                                                                Circuit ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                    self.yang_name = "circuit-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "circuit-id-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                            class RemoteId(Entity):
                                                                                """
                                                                                Remote ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                    self.yang_name = "remote-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "remote-id"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                            class RemoteIdRegex(Entity):
                                                                                """
                                                                                Remote ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                    self.yang_name = "remote-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "remote-id-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                            class SrcPort(Entity):
                                                                                """
                                                                                Source port
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                    self.yang_name = "src-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "src-port"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "src-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class DstPort(Entity):
                                                                                """
                                                                                Destination port
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                    self.yang_name = "dst-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-port"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "dst-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['min', 'max'], name, value)


                                                        class ActInfop(Entity):
                                                            """
                                                            act infop
                                                            
                                                            .. attribute:: policy_action_info_st
                                                            
                                                            	policy action info st
                                                            	**type**\: list of  		 :py:class:`PolicyActionInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'infra-policymgr-oper'
                                                            _revision = '2018-01-17'

                                                            def __init__(self):
                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop, self).__init__()

                                                                self.yang_name = "act-infop"
                                                                self.yang_parent_name = "policy-class-info-bg"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("policy-action-info-st", ("policy_action_info_st", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt))])
                                                                self._leafs = OrderedDict()

                                                                self.policy_action_info_st = YList(self)
                                                                self._segment_path = lambda: "act-infop"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop, [], name, value)


                                                            class PolicyActionInfoSt(Entity):
                                                                """
                                                                policy action info st
                                                                
                                                                .. attribute:: actp
                                                                
                                                                	actp
                                                                	**type**\:  :py:class:`Actp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp>`
                                                                
                                                                .. attribute:: seq
                                                                
                                                                	seq
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..65535
                                                                
                                                                .. attribute:: flags
                                                                
                                                                	flags
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..65535
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt, self).__init__()

                                                                    self.yang_name = "policy-action-info-st"
                                                                    self.yang_parent_name = "act-infop"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("actp", ("actp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp))])
                                                                    self._leafs = OrderedDict([
                                                                        ('seq', (YLeaf(YType.uint16, 'seq'), ['int'])),
                                                                        ('flags', (YLeaf(YType.uint16, 'flags'), ['int'])),
                                                                    ])
                                                                    self.seq = None
                                                                    self.flags = None

                                                                    self.actp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp()
                                                                    self.actp.parent = self
                                                                    self._children_name_map["actp"] = "actp"
                                                                    self._segment_path = lambda: "policy-action-info-st"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt, ['seq', 'flags'], name, value)


                                                                class Actp(Entity):
                                                                    """
                                                                    actp
                                                                    
                                                                    .. attribute:: mark
                                                                    
                                                                    	mark
                                                                    	**type**\:  :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark>`
                                                                    
                                                                    .. attribute:: mark2
                                                                    
                                                                    	mark2
                                                                    	**type**\:  :py:class:`Mark2 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2>`
                                                                    
                                                                    .. attribute:: wred
                                                                    
                                                                    	wred
                                                                    	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred>`
                                                                    
                                                                    .. attribute:: encap
                                                                    
                                                                    	encap
                                                                    	**type**\:  :py:class:`Encap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap>`
                                                                    
                                                                    .. attribute:: prio
                                                                    
                                                                    	prio
                                                                    	**type**\:  :py:class:`Prio <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio>`
                                                                    
                                                                    .. attribute:: bwrem
                                                                    
                                                                    	bwrem
                                                                    	**type**\:  :py:class:`Bwrem <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem>`
                                                                    
                                                                    .. attribute:: min_bw
                                                                    
                                                                    	min bw
                                                                    	**type**\:  :py:class:`MinBw <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw>`
                                                                    
                                                                    .. attribute:: authen_aaa
                                                                    
                                                                    	authen aaa
                                                                    	**type**\:  :py:class:`AuthenAaa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa>`
                                                                    
                                                                    .. attribute:: collect_id
                                                                    
                                                                    	collect id
                                                                    	**type**\:  :py:class:`CollectId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId>`
                                                                    
                                                                    .. attribute:: decode_id
                                                                    
                                                                    	decode id
                                                                    	**type**\:  :py:class:`DecodeId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId>`
                                                                    
                                                                    .. attribute:: set_timer
                                                                    
                                                                    	set timer
                                                                    	**type**\:  :py:class:`SetTimer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer>`
                                                                    
                                                                    .. attribute:: stop_timer
                                                                    
                                                                    	stop timer
                                                                    	**type**\:  :py:class:`StopTimer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer>`
                                                                    
                                                                    .. attribute:: acct_aaa_list
                                                                    
                                                                    	acct aaa list
                                                                    	**type**\:  :py:class:`AcctAaaList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList>`
                                                                    
                                                                    .. attribute:: query_ancp
                                                                    
                                                                    	query ancp
                                                                    	**type**\:  :py:class:`QueryAncp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp>`
                                                                    
                                                                    .. attribute:: prepaid_cfg
                                                                    
                                                                    	prepaid cfg
                                                                    	**type**\:  :py:class:`PrepaidCfg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg>`
                                                                    
                                                                    .. attribute:: timeout_idle
                                                                    
                                                                    	timeout idle
                                                                    	**type**\:  :py:class:`TimeoutIdle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle>`
                                                                    
                                                                    .. attribute:: proxy_aaa
                                                                    
                                                                    	proxy aaa
                                                                    	**type**\:  :py:class:`ProxyAaa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa>`
                                                                    
                                                                    .. attribute:: act_template
                                                                    
                                                                    	act template
                                                                    	**type**\:  :py:class:`ActTemplate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate>`
                                                                    
                                                                    .. attribute:: deact_template
                                                                    
                                                                    	deact template
                                                                    	**type**\:  :py:class:`DeactTemplate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate>`
                                                                    
                                                                    .. attribute:: qlimit
                                                                    
                                                                    	qlimit
                                                                    	**type**\:  :py:class:`Qlimit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit>`
                                                                    
                                                                    .. attribute:: accounting_event_aaa
                                                                    
                                                                    	accounting event aaa
                                                                    	**type**\:  :py:class:`AccountingEventAaa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa>`
                                                                    
                                                                    .. attribute:: authorize_id
                                                                    
                                                                    	authorize id
                                                                    	**type**\:  :py:class:`AuthorizeId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId>`
                                                                    
                                                                    .. attribute:: afm_react
                                                                    
                                                                    	afm react
                                                                    	**type**\:  :py:class:`AfmReact <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact>`
                                                                    
                                                                    .. attribute:: httpr
                                                                    
                                                                    	httpr
                                                                    	**type**\:  :py:class:`Httpr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr>`
                                                                    
                                                                    .. attribute:: punt
                                                                    
                                                                    	punt
                                                                    	**type**\:  :py:class:`Punt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt>`
                                                                    
                                                                    .. attribute:: copy
                                                                    
                                                                    	copy
                                                                    	**type**\:  :py:class:`Copy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy>`
                                                                    
                                                                    .. attribute:: sfrag
                                                                    
                                                                    	sfrag
                                                                    	**type**\:  :py:class:`Sfrag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag>`
                                                                    
                                                                    .. attribute:: redirect
                                                                    
                                                                    	redirect
                                                                    	**type**\:  :py:class:`Redirect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect>`
                                                                    
                                                                    .. attribute:: out_intf
                                                                    
                                                                    	out intf
                                                                    	**type**\:  :py:class:`OutIntf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf>`
                                                                    
                                                                    .. attribute:: serv_func
                                                                    
                                                                    	serv func
                                                                    	**type**\:  :py:class:`ServFunc <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc>`
                                                                    
                                                                    .. attribute:: police
                                                                    
                                                                    	police
                                                                    	**type**\:  :py:class:`Police <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police>`
                                                                    
                                                                    .. attribute:: shape
                                                                    
                                                                    	shape
                                                                    	**type**\:  :py:class:`Shape <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape>`
                                                                    
                                                                    .. attribute:: child_policy
                                                                    
                                                                    	child policy
                                                                    	**type**\:  :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy>`
                                                                    
                                                                    .. attribute:: cac
                                                                    
                                                                    	cac
                                                                    	**type**\:  :py:class:`Cac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac>`
                                                                    
                                                                    .. attribute:: pfc
                                                                    
                                                                    	pfc
                                                                    	**type**\:  :py:class:`Pfc <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc>`
                                                                    
                                                                    .. attribute:: flow_parm
                                                                    
                                                                    	flow parm
                                                                    	**type**\:  :py:class:`FlowParm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm>`
                                                                    
                                                                    .. attribute:: ipcbr
                                                                    
                                                                    	ipcbr
                                                                    	**type**\:  :py:class:`Ipcbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr>`
                                                                    
                                                                    .. attribute:: rtp
                                                                    
                                                                    	rtp
                                                                    	**type**\:  :py:class:`Rtp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp>`
                                                                    
                                                                    .. attribute:: rtp_mmr
                                                                    
                                                                    	rtp mmr
                                                                    	**type**\:  :py:class:`RtpMmr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr>`
                                                                    
                                                                    .. attribute:: rtp_j2k
                                                                    
                                                                    	rtp j2k
                                                                    	**type**\:  :py:class:`RtpJ2k <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k>`
                                                                    
                                                                    .. attribute:: rtp_voice
                                                                    
                                                                    	rtp voice
                                                                    	**type**\:  :py:class:`RtpVoice <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice>`
                                                                    
                                                                    .. attribute:: mdi
                                                                    
                                                                    	mdi
                                                                    	**type**\:  :py:class:`Mdi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi>`
                                                                    
                                                                    .. attribute:: mdi_rtp
                                                                    
                                                                    	mdi rtp
                                                                    	**type**\:  :py:class:`MdiRtp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp>`
                                                                    
                                                                    .. attribute:: fmm
                                                                    
                                                                    	fmm
                                                                    	**type**\:  :py:class:`Fmm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm>`
                                                                    
                                                                    .. attribute:: pbf
                                                                    
                                                                    	pbf
                                                                    	**type**\:  :py:class:`Pbf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf>`
                                                                    
                                                                    .. attribute:: ipv4_nh
                                                                    
                                                                    	ipv4 nh
                                                                    	**type**\:  :py:class:`Ipv4Nh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh>`
                                                                    
                                                                    .. attribute:: ipv6_nh
                                                                    
                                                                    	ipv6 nh
                                                                    	**type**\:  :py:class:`Ipv6Nh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh>`
                                                                    
                                                                    .. attribute:: type
                                                                    
                                                                    	type
                                                                    	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                    
                                                                    .. attribute:: data_p
                                                                    
                                                                    	data p
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp, self).__init__()

                                                                        self.yang_name = "actp"
                                                                        self.yang_parent_name = "policy-action-info-st"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("mark", ("mark", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark)), ("mark2", ("mark2", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2)), ("wred", ("wred", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred)), ("encap", ("encap", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap)), ("prio", ("prio", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio)), ("bwrem", ("bwrem", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem)), ("min-bw", ("min_bw", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw)), ("authen-aaa", ("authen_aaa", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa)), ("collect-id", ("collect_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId)), ("decode-id", ("decode_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId)), ("set-timer", ("set_timer", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer)), ("stop-timer", ("stop_timer", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer)), ("acct-aaa-list", ("acct_aaa_list", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList)), ("query-ancp", ("query_ancp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp)), ("prepaid-cfg", ("prepaid_cfg", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg)), ("timeout-idle", ("timeout_idle", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle)), ("proxy-aaa", ("proxy_aaa", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa)), ("act-template", ("act_template", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate)), ("deact-template", ("deact_template", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate)), ("qlimit", ("qlimit", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit)), ("accounting-event-aaa", ("accounting_event_aaa", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa)), ("authorize-id", ("authorize_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId)), ("afm-react", ("afm_react", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact)), ("httpr", ("httpr", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr)), ("punt", ("punt", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt)), ("copy", ("copy", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy)), ("sfrag", ("sfrag", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag)), ("redirect", ("redirect", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect)), ("out-intf", ("out_intf", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf)), ("serv-func", ("serv_func", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc)), ("police", ("police", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police)), ("shape", ("shape", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape)), ("child-policy", ("child_policy", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy)), ("cac", ("cac", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac)), ("pfc", ("pfc", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc)), ("flow-parm", ("flow_parm", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm)), ("ipcbr", ("ipcbr", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr)), ("rtp", ("rtp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp)), ("rtp-mmr", ("rtp_mmr", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr)), ("rtp-j2k", ("rtp_j2k", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k)), ("rtp-voice", ("rtp_voice", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice)), ("mdi", ("mdi", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi)), ("mdi-rtp", ("mdi_rtp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp)), ("fmm", ("fmm", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm)), ("pbf", ("pbf", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf)), ("ipv4-nh", ("ipv4_nh", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh)), ("ipv6-nh", ("ipv6_nh", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh))])
                                                                        self._leafs = OrderedDict([
                                                                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                            ('data_p', (YLeaf(YType.uint32, 'data-p'), ['int'])),
                                                                        ])
                                                                        self.type = None
                                                                        self.data_p = None

                                                                        self.mark = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark()
                                                                        self.mark.parent = self
                                                                        self._children_name_map["mark"] = "mark"

                                                                        self.mark2 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2()
                                                                        self.mark2.parent = self
                                                                        self._children_name_map["mark2"] = "mark2"

                                                                        self.wred = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred()
                                                                        self.wred.parent = self
                                                                        self._children_name_map["wred"] = "wred"

                                                                        self.encap = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap()
                                                                        self.encap.parent = self
                                                                        self._children_name_map["encap"] = "encap"

                                                                        self.prio = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio()
                                                                        self.prio.parent = self
                                                                        self._children_name_map["prio"] = "prio"

                                                                        self.bwrem = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem()
                                                                        self.bwrem.parent = self
                                                                        self._children_name_map["bwrem"] = "bwrem"

                                                                        self.min_bw = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw()
                                                                        self.min_bw.parent = self
                                                                        self._children_name_map["min_bw"] = "min-bw"

                                                                        self.authen_aaa = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa()
                                                                        self.authen_aaa.parent = self
                                                                        self._children_name_map["authen_aaa"] = "authen-aaa"

                                                                        self.collect_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId()
                                                                        self.collect_id.parent = self
                                                                        self._children_name_map["collect_id"] = "collect-id"

                                                                        self.decode_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId()
                                                                        self.decode_id.parent = self
                                                                        self._children_name_map["decode_id"] = "decode-id"

                                                                        self.set_timer = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer()
                                                                        self.set_timer.parent = self
                                                                        self._children_name_map["set_timer"] = "set-timer"

                                                                        self.stop_timer = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer()
                                                                        self.stop_timer.parent = self
                                                                        self._children_name_map["stop_timer"] = "stop-timer"

                                                                        self.acct_aaa_list = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList()
                                                                        self.acct_aaa_list.parent = self
                                                                        self._children_name_map["acct_aaa_list"] = "acct-aaa-list"

                                                                        self.query_ancp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp()
                                                                        self.query_ancp.parent = self
                                                                        self._children_name_map["query_ancp"] = "query-ancp"

                                                                        self.prepaid_cfg = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg()
                                                                        self.prepaid_cfg.parent = self
                                                                        self._children_name_map["prepaid_cfg"] = "prepaid-cfg"

                                                                        self.timeout_idle = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle()
                                                                        self.timeout_idle.parent = self
                                                                        self._children_name_map["timeout_idle"] = "timeout-idle"

                                                                        self.proxy_aaa = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa()
                                                                        self.proxy_aaa.parent = self
                                                                        self._children_name_map["proxy_aaa"] = "proxy-aaa"

                                                                        self.act_template = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate()
                                                                        self.act_template.parent = self
                                                                        self._children_name_map["act_template"] = "act-template"

                                                                        self.deact_template = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate()
                                                                        self.deact_template.parent = self
                                                                        self._children_name_map["deact_template"] = "deact-template"

                                                                        self.qlimit = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit()
                                                                        self.qlimit.parent = self
                                                                        self._children_name_map["qlimit"] = "qlimit"

                                                                        self.accounting_event_aaa = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa()
                                                                        self.accounting_event_aaa.parent = self
                                                                        self._children_name_map["accounting_event_aaa"] = "accounting-event-aaa"

                                                                        self.authorize_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId()
                                                                        self.authorize_id.parent = self
                                                                        self._children_name_map["authorize_id"] = "authorize-id"

                                                                        self.afm_react = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact()
                                                                        self.afm_react.parent = self
                                                                        self._children_name_map["afm_react"] = "afm-react"

                                                                        self.httpr = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr()
                                                                        self.httpr.parent = self
                                                                        self._children_name_map["httpr"] = "httpr"

                                                                        self.punt = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt()
                                                                        self.punt.parent = self
                                                                        self._children_name_map["punt"] = "punt"

                                                                        self.copy = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy()
                                                                        self.copy.parent = self
                                                                        self._children_name_map["copy"] = "copy"

                                                                        self.sfrag = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag()
                                                                        self.sfrag.parent = self
                                                                        self._children_name_map["sfrag"] = "sfrag"

                                                                        self.redirect = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect()
                                                                        self.redirect.parent = self
                                                                        self._children_name_map["redirect"] = "redirect"

                                                                        self.out_intf = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf()
                                                                        self.out_intf.parent = self
                                                                        self._children_name_map["out_intf"] = "out-intf"

                                                                        self.serv_func = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc()
                                                                        self.serv_func.parent = self
                                                                        self._children_name_map["serv_func"] = "serv-func"

                                                                        self.police = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police()
                                                                        self.police.parent = self
                                                                        self._children_name_map["police"] = "police"

                                                                        self.shape = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape()
                                                                        self.shape.parent = self
                                                                        self._children_name_map["shape"] = "shape"

                                                                        self.child_policy = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy()
                                                                        self.child_policy.parent = self
                                                                        self._children_name_map["child_policy"] = "child-policy"

                                                                        self.cac = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac()
                                                                        self.cac.parent = self
                                                                        self._children_name_map["cac"] = "cac"

                                                                        self.pfc = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc()
                                                                        self.pfc.parent = self
                                                                        self._children_name_map["pfc"] = "pfc"

                                                                        self.flow_parm = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm()
                                                                        self.flow_parm.parent = self
                                                                        self._children_name_map["flow_parm"] = "flow-parm"

                                                                        self.ipcbr = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr()
                                                                        self.ipcbr.parent = self
                                                                        self._children_name_map["ipcbr"] = "ipcbr"

                                                                        self.rtp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp()
                                                                        self.rtp.parent = self
                                                                        self._children_name_map["rtp"] = "rtp"

                                                                        self.rtp_mmr = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr()
                                                                        self.rtp_mmr.parent = self
                                                                        self._children_name_map["rtp_mmr"] = "rtp-mmr"

                                                                        self.rtp_j2k = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k()
                                                                        self.rtp_j2k.parent = self
                                                                        self._children_name_map["rtp_j2k"] = "rtp-j2k"

                                                                        self.rtp_voice = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice()
                                                                        self.rtp_voice.parent = self
                                                                        self._children_name_map["rtp_voice"] = "rtp-voice"

                                                                        self.mdi = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi()
                                                                        self.mdi.parent = self
                                                                        self._children_name_map["mdi"] = "mdi"

                                                                        self.mdi_rtp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp()
                                                                        self.mdi_rtp.parent = self
                                                                        self._children_name_map["mdi_rtp"] = "mdi-rtp"

                                                                        self.fmm = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm()
                                                                        self.fmm.parent = self
                                                                        self._children_name_map["fmm"] = "fmm"

                                                                        self.pbf = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf()
                                                                        self.pbf.parent = self
                                                                        self._children_name_map["pbf"] = "pbf"

                                                                        self.ipv4_nh = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh()
                                                                        self.ipv4_nh.parent = self
                                                                        self._children_name_map["ipv4_nh"] = "ipv4-nh"

                                                                        self.ipv6_nh = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh()
                                                                        self.ipv6_nh.parent = self
                                                                        self._children_name_map["ipv6_nh"] = "ipv6-nh"
                                                                        self._segment_path = lambda: "actp"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp, ['type', 'data_p'], name, value)


                                                                    class Mark(Entity):
                                                                        """
                                                                        mark
                                                                        
                                                                        .. attribute:: action_mark_info
                                                                        
                                                                        	action mark info
                                                                        	**type**\: list of  		 :py:class:`ActionMarkInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark, self).__init__()

                                                                            self.yang_name = "mark"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("action-mark-info", ("action_mark_info", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo))])
                                                                            self._leafs = OrderedDict()

                                                                            self.action_mark_info = YList(self)
                                                                            self._segment_path = lambda: "mark"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark, [], name, value)


                                                                        class ActionMarkInfo(Entity):
                                                                            """
                                                                            action mark info
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:  :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                            
                                                                            .. attribute:: mark_flags
                                                                            
                                                                            	mark flags
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo, self).__init__()

                                                                                self.yang_name = "action-mark-info"
                                                                                self.yang_parent_name = "mark"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MarkTypeEn', '')])),
                                                                                    ('mark_flags', (YLeaf(YType.uint32, 'mark-flags'), ['int'])),
                                                                                    ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                ])
                                                                                self.type = None
                                                                                self.mark_flags = None
                                                                                self.value = None
                                                                                self._segment_path = lambda: "action-mark-info"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo, ['type', 'mark_flags', 'value'], name, value)


                                                                    class Mark2(Entity):
                                                                        """
                                                                        mark2
                                                                        
                                                                        .. attribute:: action_mark2_info
                                                                        
                                                                        	action mark2 info
                                                                        	**type**\: list of  		 :py:class:`ActionMark2Info <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2, self).__init__()

                                                                            self.yang_name = "mark2"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("action-mark2-info", ("action_mark2_info", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info))])
                                                                            self._leafs = OrderedDict()

                                                                            self.action_mark2_info = YList(self)
                                                                            self._segment_path = lambda: "mark2"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2, [], name, value)


                                                                        class ActionMark2Info(Entity):
                                                                            """
                                                                            action mark2 info
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: value_overflow
                                                                            
                                                                            	value overflow
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: mark_flags
                                                                            
                                                                            	mark flags
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info, self).__init__()

                                                                                self.yang_name = "action-mark2-info"
                                                                                self.yang_parent_name = "mark2"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('value_overflow', (YLeaf(YType.uint16, 'value-overflow'), ['int'])),
                                                                                    ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                    ('mark_flags', (YLeaf(YType.uint8, 'mark-flags'), ['int'])),
                                                                                ])
                                                                                self.value = None
                                                                                self.value_overflow = None
                                                                                self.type = None
                                                                                self.mark_flags = None
                                                                                self._segment_path = lambda: "action-mark2-info"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info, ['value', 'value_overflow', 'type', 'mark_flags'], name, value)


                                                                    class Wred(Entity):
                                                                        """
                                                                        wred
                                                                        
                                                                        .. attribute:: action_wred_info
                                                                        
                                                                        	action wred info
                                                                        	**type**\: list of  		 :py:class:`ActionWredInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred, self).__init__()

                                                                            self.yang_name = "wred"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("action-wred-info", ("action_wred_info", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo))])
                                                                            self._leafs = OrderedDict()

                                                                            self.action_wred_info = YList(self)
                                                                            self._segment_path = lambda: "wred"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred, [], name, value)


                                                                        class ActionWredInfo(Entity):
                                                                            """
                                                                            action wred info
                                                                            
                                                                            .. attribute:: match_ranges
                                                                            
                                                                            	match ranges
                                                                            	**type**\:  :py:class:`MatchRanges <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges>`
                                                                            
                                                                            .. attribute:: min_threshold
                                                                            
                                                                            	min threshold
                                                                            	**type**\:  :py:class:`MinThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold>`
                                                                            
                                                                            .. attribute:: max_threshold
                                                                            
                                                                            	max threshold
                                                                            	**type**\:  :py:class:`MaxThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold>`
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	cos/prec/dscp/ based WRED
                                                                            	**type**\:  :py:class:`WredTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.WredTypeEn>`
                                                                            
                                                                            .. attribute:: wred_flags
                                                                            
                                                                            	wred flags
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: probability
                                                                            
                                                                            	probability
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo, self).__init__()

                                                                                self.yang_name = "action-wred-info"
                                                                                self.yang_parent_name = "wred"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("match-ranges", ("match_ranges", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges)), ("min-threshold", ("min_threshold", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold)), ("max-threshold", ("max_threshold", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'WredTypeEn', '')])),
                                                                                    ('wred_flags', (YLeaf(YType.uint32, 'wred-flags'), ['int'])),
                                                                                    ('probability', (YLeaf(YType.uint32, 'probability'), ['int'])),
                                                                                ])
                                                                                self.type = None
                                                                                self.wred_flags = None
                                                                                self.probability = None

                                                                                self.match_ranges = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges()
                                                                                self.match_ranges.parent = self
                                                                                self._children_name_map["match_ranges"] = "match-ranges"

                                                                                self.min_threshold = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold()
                                                                                self.min_threshold.parent = self
                                                                                self._children_name_map["min_threshold"] = "min-threshold"

                                                                                self.max_threshold = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold()
                                                                                self.max_threshold.parent = self
                                                                                self._children_name_map["max_threshold"] = "max-threshold"
                                                                                self._segment_path = lambda: "action-wred-info"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo, ['type', 'wred_flags', 'probability'], name, value)


                                                                            class MatchRanges(Entity):
                                                                                """
                                                                                match ranges
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges, self).__init__()

                                                                                    self.yang_name = "match-ranges"
                                                                                    self.yang_parent_name = "action-wred-info"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "match-ranges"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "match-ranges"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class MinThreshold(Entity):
                                                                                """
                                                                                min threshold
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold, self).__init__()

                                                                                    self.yang_name = "min-threshold"
                                                                                    self.yang_parent_name = "action-wred-info"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.unit = None
                                                                                    self._segment_path = lambda: "min-threshold"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold, ['value', 'unit'], name, value)


                                                                            class MaxThreshold(Entity):
                                                                                """
                                                                                max threshold
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold, self).__init__()

                                                                                    self.yang_name = "max-threshold"
                                                                                    self.yang_parent_name = "action-wred-info"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.unit = None
                                                                                    self._segment_path = lambda: "max-threshold"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold, ['value', 'unit'], name, value)


                                                                    class Encap(Entity):
                                                                        """
                                                                        encap
                                                                        
                                                                        .. attribute:: seq
                                                                        
                                                                        	seq
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap, self).__init__()

                                                                            self.yang_name = "encap"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('seq', (YLeaf(YType.uint8, 'seq'), ['int'])),
                                                                            ])
                                                                            self.seq = None
                                                                            self._segment_path = lambda: "encap"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap, ['seq'], name, value)


                                                                    class Prio(Entity):
                                                                        """
                                                                        prio
                                                                        
                                                                        .. attribute:: prio_lvl
                                                                        
                                                                        	prio lvl
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio, self).__init__()

                                                                            self.yang_name = "prio"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('prio_lvl', (YLeaf(YType.uint32, 'prio-lvl'), ['int'])),
                                                                            ])
                                                                            self.prio_lvl = None
                                                                            self._segment_path = lambda: "prio"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio, ['prio_lvl'], name, value)


                                                                    class Bwrem(Entity):
                                                                        """
                                                                        bwrem
                                                                        
                                                                        .. attribute:: bwrem
                                                                        
                                                                        	bwrem
                                                                        	**type**\:  :py:class:`Bwrem_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem_>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem, self).__init__()

                                                                            self.yang_name = "bwrem"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("bwrem", ("bwrem", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem_))])
                                                                            self._leafs = OrderedDict()

                                                                            self.bwrem = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem_()
                                                                            self.bwrem.parent = self
                                                                            self._children_name_map["bwrem"] = "bwrem"
                                                                            self._segment_path = lambda: "bwrem"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem, [], name, value)


                                                                        class Bwrem_(Entity):
                                                                            """
                                                                            bwrem
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem_, self).__init__()

                                                                                self.yang_name = "bwrem"
                                                                                self.yang_parent_name = "bwrem"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "bwrem"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem_, ['value', 'unit'], name, value)


                                                                    class MinBw(Entity):
                                                                        """
                                                                        min bw
                                                                        
                                                                        .. attribute:: bw
                                                                        
                                                                        	bw
                                                                        	**type**\:  :py:class:`Bw <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw, self).__init__()

                                                                            self.yang_name = "min-bw"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("bw", ("bw", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw))])
                                                                            self._leafs = OrderedDict()

                                                                            self.bw = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw()
                                                                            self.bw.parent = self
                                                                            self._children_name_map["bw"] = "bw"
                                                                            self._segment_path = lambda: "min-bw"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw, [], name, value)


                                                                        class Bw(Entity):
                                                                            """
                                                                            bw
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw, self).__init__()

                                                                                self.yang_name = "bw"
                                                                                self.yang_parent_name = "min-bw"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "bw"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw, ['value', 'unit'], name, value)


                                                                    class AuthenAaa(Entity):
                                                                        """
                                                                        authen aaa
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: authen_password
                                                                        
                                                                        	authen password
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa, self).__init__()

                                                                            self.yang_name = "authen-aaa"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                                ('authen_password', (YLeaf(YType.str, 'authen-password'), ['str'])),
                                                                            ])
                                                                            self.aaa_list_name = None
                                                                            self.authen_password = None
                                                                            self._segment_path = lambda: "authen-aaa"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa, ['aaa_list_name', 'authen_password'], name, value)


                                                                    class CollectId(Entity):
                                                                        """
                                                                        collect id
                                                                        
                                                                        .. attribute:: id
                                                                        
                                                                        	id
                                                                        	**type**\:  :py:class:`IdentifierEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.IdentifierEn>`
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId, self).__init__()

                                                                            self.yang_name = "collect-id"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('id', (YLeaf(YType.enumeration, 'id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'IdentifierEn', '')])),
                                                                                ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                            ])
                                                                            self.id = None
                                                                            self.aaa_list_name = None
                                                                            self._segment_path = lambda: "collect-id"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId, ['id', 'aaa_list_name'], name, value)


                                                                    class DecodeId(Entity):
                                                                        """
                                                                        decode id
                                                                        
                                                                        .. attribute:: id
                                                                        
                                                                        	id
                                                                        	**type**\:  :py:class:`DecodeIdentifierEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.DecodeIdentifierEn>`
                                                                        
                                                                        .. attribute:: format_name
                                                                        
                                                                        	format name
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId, self).__init__()

                                                                            self.yang_name = "decode-id"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('id', (YLeaf(YType.enumeration, 'id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'DecodeIdentifierEn', '')])),
                                                                                ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                            ])
                                                                            self.id = None
                                                                            self.format_name = None
                                                                            self._segment_path = lambda: "decode-id"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId, ['id', 'format_name'], name, value)


                                                                    class SetTimer(Entity):
                                                                        """
                                                                        set timer
                                                                        
                                                                        .. attribute:: timer_name
                                                                        
                                                                        	timer name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: duration
                                                                        
                                                                        	duration
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: absolute_time
                                                                        
                                                                        	absolute time
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer, self).__init__()

                                                                            self.yang_name = "set-timer"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('timer_name', (YLeaf(YType.str, 'timer-name'), ['str'])),
                                                                                ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                                                ('absolute_time', (YLeaf(YType.str, 'absolute-time'), ['str'])),
                                                                            ])
                                                                            self.timer_name = None
                                                                            self.duration = None
                                                                            self.absolute_time = None
                                                                            self._segment_path = lambda: "set-timer"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer, ['timer_name', 'duration', 'absolute_time'], name, value)


                                                                    class StopTimer(Entity):
                                                                        """
                                                                        stop timer
                                                                        
                                                                        .. attribute:: timer_name
                                                                        
                                                                        	timer name
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer, self).__init__()

                                                                            self.yang_name = "stop-timer"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('timer_name', (YLeaf(YType.str, 'timer-name'), ['str'])),
                                                                            ])
                                                                            self.timer_name = None
                                                                            self._segment_path = lambda: "stop-timer"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer, ['timer_name'], name, value)


                                                                    class AcctAaaList(Entity):
                                                                        """
                                                                        acct aaa list
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: secs
                                                                        
                                                                        	secs
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList, self).__init__()

                                                                            self.yang_name = "acct-aaa-list"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                                ('secs', (YLeaf(YType.uint32, 'secs'), ['int'])),
                                                                            ])
                                                                            self.aaa_list_name = None
                                                                            self.secs = None
                                                                            self._segment_path = lambda: "acct-aaa-list"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList, ['aaa_list_name', 'secs'], name, value)


                                                                    class QueryAncp(Entity):
                                                                        """
                                                                        query ancp
                                                                        
                                                                        .. attribute:: enable
                                                                        
                                                                        	enable
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp, self).__init__()

                                                                            self.yang_name = "query-ancp"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('enable', (YLeaf(YType.uint8, 'enable'), ['int'])),
                                                                            ])
                                                                            self.enable = None
                                                                            self._segment_path = lambda: "query-ancp"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp, ['enable'], name, value)


                                                                    class PrepaidCfg(Entity):
                                                                        """
                                                                        prepaid cfg
                                                                        
                                                                        .. attribute:: prepaid_config_profile_name
                                                                        
                                                                        	prepaid config profile name
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg, self).__init__()

                                                                            self.yang_name = "prepaid-cfg"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('prepaid_config_profile_name', (YLeaf(YType.str, 'prepaid-config-profile-name'), ['str'])),
                                                                            ])
                                                                            self.prepaid_config_profile_name = None
                                                                            self._segment_path = lambda: "prepaid-cfg"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg, ['prepaid_config_profile_name'], name, value)


                                                                    class TimeoutIdle(Entity):
                                                                        """
                                                                        timeout idle
                                                                        
                                                                        .. attribute:: secs
                                                                        
                                                                        	secs
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle, self).__init__()

                                                                            self.yang_name = "timeout-idle"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('secs', (YLeaf(YType.uint32, 'secs'), ['int'])),
                                                                            ])
                                                                            self.secs = None
                                                                            self._segment_path = lambda: "timeout-idle"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle, ['secs'], name, value)


                                                                    class ProxyAaa(Entity):
                                                                        """
                                                                        proxy aaa
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa, self).__init__()

                                                                            self.yang_name = "proxy-aaa"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                            ])
                                                                            self.aaa_list_name = None
                                                                            self._segment_path = lambda: "proxy-aaa"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa, ['aaa_list_name'], name, value)


                                                                    class ActTemplate(Entity):
                                                                        """
                                                                        act template
                                                                        
                                                                        .. attribute:: template_name
                                                                        
                                                                        	template name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: flags
                                                                        
                                                                        	flags
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate, self).__init__()

                                                                            self.yang_name = "act-template"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('template_name', (YLeaf(YType.str, 'template-name'), ['str'])),
                                                                                ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                                ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                            ])
                                                                            self.template_name = None
                                                                            self.aaa_list_name = None
                                                                            self.flags = None
                                                                            self._segment_path = lambda: "act-template"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate, ['template_name', 'aaa_list_name', 'flags'], name, value)


                                                                    class DeactTemplate(Entity):
                                                                        """
                                                                        deact template
                                                                        
                                                                        .. attribute:: template_name
                                                                        
                                                                        	template name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: flags
                                                                        
                                                                        	flags
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate, self).__init__()

                                                                            self.yang_name = "deact-template"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('template_name', (YLeaf(YType.str, 'template-name'), ['str'])),
                                                                                ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                                ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                            ])
                                                                            self.template_name = None
                                                                            self.aaa_list_name = None
                                                                            self.flags = None
                                                                            self._segment_path = lambda: "deact-template"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate, ['template_name', 'aaa_list_name', 'flags'], name, value)


                                                                    class Qlimit(Entity):
                                                                        """
                                                                        qlimit
                                                                        
                                                                        .. attribute:: action_qlimit_info_array
                                                                        
                                                                        	action qlimit info array
                                                                        	**type**\: list of  		 :py:class:`ActionQlimitInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit, self).__init__()

                                                                            self.yang_name = "qlimit"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("action-qlimit-info-array", ("action_qlimit_info_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.action_qlimit_info_array = YList(self)
                                                                            self._segment_path = lambda: "qlimit"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit, [], name, value)


                                                                        class ActionQlimitInfoArray(Entity):
                                                                            """
                                                                            action qlimit info array
                                                                            
                                                                            .. attribute:: qlim
                                                                            
                                                                            	qlim
                                                                            	**type**\:  :py:class:`Qlim <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim>`
                                                                            
                                                                            .. attribute:: atmclp_qlim
                                                                            
                                                                            	atmclp qlim
                                                                            	**type**\:  :py:class:`AtmclpQlim <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim>`
                                                                            
                                                                            .. attribute:: match_values
                                                                            
                                                                            	match values
                                                                            	**type**\:  :py:class:`MatchValues <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues>`
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:  :py:class:`QlimitTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.QlimitTypeEn>`
                                                                            
                                                                            .. attribute:: qlimit_flags
                                                                            
                                                                            	qlimit flags
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray, self).__init__()

                                                                                self.yang_name = "action-qlimit-info-array"
                                                                                self.yang_parent_name = "qlimit"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("qlim", ("qlim", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim)), ("atmclp-qlim", ("atmclp_qlim", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim)), ("match-values", ("match_values", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'QlimitTypeEn', '')])),
                                                                                    ('qlimit_flags', (YLeaf(YType.uint32, 'qlimit-flags'), ['int'])),
                                                                                ])
                                                                                self.type = None
                                                                                self.qlimit_flags = None

                                                                                self.qlim = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim()
                                                                                self.qlim.parent = self
                                                                                self._children_name_map["qlim"] = "qlim"

                                                                                self.atmclp_qlim = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim()
                                                                                self.atmclp_qlim.parent = self
                                                                                self._children_name_map["atmclp_qlim"] = "atmclp-qlim"

                                                                                self.match_values = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues()
                                                                                self.match_values.parent = self
                                                                                self._children_name_map["match_values"] = "match-values"
                                                                                self._segment_path = lambda: "action-qlimit-info-array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray, ['type', 'qlimit_flags'], name, value)


                                                                            class Qlim(Entity):
                                                                                """
                                                                                qlim
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim, self).__init__()

                                                                                    self.yang_name = "qlim"
                                                                                    self.yang_parent_name = "action-qlimit-info-array"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.unit = None
                                                                                    self._segment_path = lambda: "qlim"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim, ['value', 'unit'], name, value)


                                                                            class AtmclpQlim(Entity):
                                                                                """
                                                                                atmclp qlim
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim, self).__init__()

                                                                                    self.yang_name = "atmclp-qlim"
                                                                                    self.yang_parent_name = "action-qlimit-info-array"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.unit = None
                                                                                    self._segment_path = lambda: "atmclp-qlim"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim, ['value', 'unit'], name, value)


                                                                            class MatchValues(Entity):
                                                                                """
                                                                                match values
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues, self).__init__()

                                                                                    self.yang_name = "match-values"
                                                                                    self.yang_parent_name = "action-qlimit-info-array"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "match-values"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "match-values"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray, ['min', 'max'], name, value)


                                                                    class AccountingEventAaa(Entity):
                                                                        """
                                                                        accounting event aaa
                                                                        
                                                                        .. attribute:: action
                                                                        
                                                                        	action
                                                                        	**type**\:  :py:class:`AcctEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.AcctEn>`
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa, self).__init__()

                                                                            self.yang_name = "accounting-event-aaa"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('action', (YLeaf(YType.enumeration, 'action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'AcctEn', '')])),
                                                                                ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                            ])
                                                                            self.action = None
                                                                            self.aaa_list_name = None
                                                                            self._segment_path = lambda: "accounting-event-aaa"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa, ['action', 'aaa_list_name'], name, value)


                                                                    class AuthorizeId(Entity):
                                                                        """
                                                                        authorize id
                                                                        
                                                                        .. attribute:: id
                                                                        
                                                                        	id
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: format_name
                                                                        
                                                                        	format name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: password
                                                                        
                                                                        	password
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId, self).__init__()

                                                                            self.yang_name = "authorize-id"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('id', (YLeaf(YType.uint8, 'id'), ['int'])),
                                                                                ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                                ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                ('password', (YLeaf(YType.str, 'password'), ['str'])),
                                                                            ])
                                                                            self.id = None
                                                                            self.aaa_list_name = None
                                                                            self.format_name = None
                                                                            self.password = None
                                                                            self._segment_path = lambda: "authorize-id"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId, ['id', 'aaa_list_name', 'format_name', 'password'], name, value)


                                                                    class AfmReact(Entity):
                                                                        """
                                                                        afm react
                                                                        
                                                                        .. attribute:: action_afmon_react_info
                                                                        
                                                                        	action afmon react info
                                                                        	**type**\: list of  		 :py:class:`ActionAfmonReactInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact, self).__init__()

                                                                            self.yang_name = "afm-react"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("action-afmon-react-info", ("action_afmon_react_info", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo))])
                                                                            self._leafs = OrderedDict()

                                                                            self.action_afmon_react_info = YList(self)
                                                                            self._segment_path = lambda: "afm-react"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact, [], name, value)


                                                                        class ActionAfmonReactInfo(Entity):
                                                                            """
                                                                            action afmon react info
                                                                            
                                                                            .. attribute:: oper_id
                                                                            
                                                                            	React Operation ID
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: description
                                                                            
                                                                            	Describing the oper
                                                                            	**type**\: str
                                                                            
                                                                            .. attribute:: trig_num_intvls
                                                                            
                                                                            	Averaged over N intvls
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: clone_ifh
                                                                            
                                                                            	Clone interface handle
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: notif_actns
                                                                            
                                                                            	Bitmap of actions on alert
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: criterion
                                                                            
                                                                            	React Criterion
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: trig_type
                                                                            
                                                                            	Immediate or averaged thresh trigger
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: trig_relop
                                                                            
                                                                            	Trigger LT\|LE\|GT\|GE\|Range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: trig_level_1
                                                                            
                                                                            	Trigger threshold 1/lower
                                                                            	**type**\: str
                                                                            
                                                                            .. attribute:: trig_level_2
                                                                            
                                                                            	Trigger upper threshold for range
                                                                            	**type**\: str
                                                                            
                                                                            .. attribute:: alm_grp_thresh
                                                                            
                                                                            	Num/percent in grp
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            	**units**\: percentage
                                                                            
                                                                            .. attribute:: alm_type
                                                                            
                                                                            	Discrete \| grouped alarm
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: alm_severity
                                                                            
                                                                            	Major\|Minor\|... alarm
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo, self).__init__()

                                                                                self.yang_name = "action-afmon-react-info"
                                                                                self.yang_parent_name = "afm-react"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('oper_id', (YLeaf(YType.uint32, 'oper-id'), ['int'])),
                                                                                    ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                    ('trig_num_intvls', (YLeaf(YType.uint32, 'trig-num-intvls'), ['int'])),
                                                                                    ('clone_ifh', (YLeaf(YType.uint32, 'clone-ifh'), ['int'])),
                                                                                    ('notif_actns', (YLeaf(YType.uint8, 'notif-actns'), ['int'])),
                                                                                    ('criterion', (YLeaf(YType.uint8, 'criterion'), ['int'])),
                                                                                    ('trig_type', (YLeaf(YType.uint8, 'trig-type'), ['int'])),
                                                                                    ('trig_relop', (YLeaf(YType.uint8, 'trig-relop'), ['int'])),
                                                                                    ('trig_level_1', (YLeaf(YType.str, 'trig-level-1'), ['str'])),
                                                                                    ('trig_level_2', (YLeaf(YType.str, 'trig-level-2'), ['str'])),
                                                                                    ('alm_grp_thresh', (YLeaf(YType.uint16, 'alm-grp-thresh'), ['int'])),
                                                                                    ('alm_type', (YLeaf(YType.uint8, 'alm-type'), ['int'])),
                                                                                    ('alm_severity', (YLeaf(YType.uint8, 'alm-severity'), ['int'])),
                                                                                ])
                                                                                self.oper_id = None
                                                                                self.description = None
                                                                                self.trig_num_intvls = None
                                                                                self.clone_ifh = None
                                                                                self.notif_actns = None
                                                                                self.criterion = None
                                                                                self.trig_type = None
                                                                                self.trig_relop = None
                                                                                self.trig_level_1 = None
                                                                                self.trig_level_2 = None
                                                                                self.alm_grp_thresh = None
                                                                                self.alm_type = None
                                                                                self.alm_severity = None
                                                                                self._segment_path = lambda: "action-afmon-react-info"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo, ['oper_id', 'description', 'trig_num_intvls', 'clone_ifh', 'notif_actns', 'criterion', 'trig_type', 'trig_relop', 'trig_level_1', 'trig_level_2', 'alm_grp_thresh', 'alm_type', 'alm_severity'], name, value)


                                                                    class Httpr(Entity):
                                                                        """
                                                                        httpr
                                                                        
                                                                        .. attribute:: redirect_url
                                                                        
                                                                        	redirect url
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr, self).__init__()

                                                                            self.yang_name = "httpr"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('redirect_url', (YLeaf(YType.str, 'redirect-url'), ['str'])),
                                                                            ])
                                                                            self.redirect_url = None
                                                                            self._segment_path = lambda: "httpr"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr, ['redirect_url'], name, value)


                                                                    class Punt(Entity):
                                                                        """
                                                                        punt
                                                                        
                                                                        .. attribute:: sn_type
                                                                        
                                                                        	service node ID type
                                                                        	**type**\:  :py:class:`DpssSnidTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.DpssSnidTypeEn>`
                                                                        
                                                                        .. attribute:: sn_index
                                                                        
                                                                        	service node index
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: sn_name
                                                                        
                                                                        	service node name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: app_id
                                                                        
                                                                        	application ID
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: local_id
                                                                        
                                                                        	local ID
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: vsnode_type
                                                                        
                                                                        	vservice node type
                                                                        	**type**\:  :py:class:`VsvcServiceTypeT <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.VsvcServiceTypeT>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt, self).__init__()

                                                                            self.yang_name = "punt"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('sn_type', (YLeaf(YType.enumeration, 'sn-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'DpssSnidTypeEn', '')])),
                                                                                ('sn_index', (YLeaf(YType.uint32, 'sn-index'), ['int'])),
                                                                                ('sn_name', (YLeaf(YType.str, 'sn-name'), ['str'])),
                                                                                ('app_id', (YLeaf(YType.uint32, 'app-id'), ['int'])),
                                                                                ('local_id', (YLeaf(YType.uint32, 'local-id'), ['int'])),
                                                                                ('vsnode_type', (YLeaf(YType.enumeration, 'vsnode-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'VsvcServiceTypeT', '')])),
                                                                            ])
                                                                            self.sn_type = None
                                                                            self.sn_index = None
                                                                            self.sn_name = None
                                                                            self.app_id = None
                                                                            self.local_id = None
                                                                            self.vsnode_type = None
                                                                            self._segment_path = lambda: "punt"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt, ['sn_type', 'sn_index', 'sn_name', 'app_id', 'local_id', 'vsnode_type'], name, value)


                                                                    class Copy(Entity):
                                                                        """
                                                                        copy
                                                                        
                                                                        .. attribute:: num_byte
                                                                        
                                                                        	number of bytes
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: sn_type
                                                                        
                                                                        	service node ID type
                                                                        	**type**\:  :py:class:`DpssSnidTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.DpssSnidTypeEn>`
                                                                        
                                                                        .. attribute:: sn_index
                                                                        
                                                                        	service node index
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: sn_name
                                                                        
                                                                        	service node url
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: app_id
                                                                        
                                                                        	application ID
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: local_id
                                                                        
                                                                        	local ID
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: vsnode_type
                                                                        
                                                                        	vservice node type
                                                                        	**type**\:  :py:class:`VsvcServiceTypeT <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.VsvcServiceTypeT>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy, self).__init__()

                                                                            self.yang_name = "copy"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('num_byte', (YLeaf(YType.uint32, 'num-byte'), ['int'])),
                                                                                ('sn_type', (YLeaf(YType.enumeration, 'sn-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'DpssSnidTypeEn', '')])),
                                                                                ('sn_index', (YLeaf(YType.uint32, 'sn-index'), ['int'])),
                                                                                ('sn_name', (YLeaf(YType.str, 'sn-name'), ['str'])),
                                                                                ('app_id', (YLeaf(YType.uint32, 'app-id'), ['int'])),
                                                                                ('local_id', (YLeaf(YType.uint32, 'local-id'), ['int'])),
                                                                                ('vsnode_type', (YLeaf(YType.enumeration, 'vsnode-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'VsvcServiceTypeT', '')])),
                                                                            ])
                                                                            self.num_byte = None
                                                                            self.sn_type = None
                                                                            self.sn_index = None
                                                                            self.sn_name = None
                                                                            self.app_id = None
                                                                            self.local_id = None
                                                                            self.vsnode_type = None
                                                                            self._segment_path = lambda: "copy"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy, ['num_byte', 'sn_type', 'sn_index', 'sn_name', 'app_id', 'local_id', 'vsnode_type'], name, value)


                                                                    class Sfrag(Entity):
                                                                        """
                                                                        sfrag
                                                                        
                                                                        .. attribute:: name
                                                                        
                                                                        	Service Fragment Name
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag, self).__init__()

                                                                            self.yang_name = "sfrag"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                            ])
                                                                            self.name = None
                                                                            self._segment_path = lambda: "sfrag"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag, ['name'], name, value)


                                                                    class Redirect(Entity):
                                                                        """
                                                                        redirect
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: type
                                                                        
                                                                        	type
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect, self).__init__()

                                                                            self.yang_name = "redirect"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                            ])
                                                                            self.value = None
                                                                            self.type = None
                                                                            self._segment_path = lambda: "redirect"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect, ['value', 'type'], name, value)


                                                                    class OutIntf(Entity):
                                                                        """
                                                                        out intf
                                                                        
                                                                        .. attribute:: out_ifname
                                                                        
                                                                        	output interface name
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf, self).__init__()

                                                                            self.yang_name = "out-intf"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('out_ifname', (YLeaf(YType.str, 'out-ifname'), ['str'])),
                                                                            ])
                                                                            self.out_ifname = None
                                                                            self._segment_path = lambda: "out-intf"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf, ['out_ifname'], name, value)


                                                                    class ServFunc(Entity):
                                                                        """
                                                                        serv func
                                                                        
                                                                        .. attribute:: path_id
                                                                        
                                                                        	service path id
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: service_index
                                                                        
                                                                        	service path index
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: meta_name
                                                                        
                                                                        	metadata name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: vs_index
                                                                        
                                                                        	vservice index
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc, self).__init__()

                                                                            self.yang_name = "serv-func"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('path_id', (YLeaf(YType.uint32, 'path-id'), ['int'])),
                                                                                ('service_index', (YLeaf(YType.uint8, 'service-index'), ['int'])),
                                                                                ('meta_name', (YLeaf(YType.str, 'meta-name'), ['str'])),
                                                                                ('vs_index', (YLeaf(YType.uint32, 'vs-index'), ['int'])),
                                                                            ])
                                                                            self.path_id = None
                                                                            self.service_index = None
                                                                            self.meta_name = None
                                                                            self.vs_index = None
                                                                            self._segment_path = lambda: "serv-func"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc, ['path_id', 'service_index', 'meta_name', 'vs_index'], name, value)


                                                                    class Police(Entity):
                                                                        """
                                                                        police
                                                                        
                                                                        .. attribute:: rate
                                                                        
                                                                        	rate
                                                                        	**type**\:  :py:class:`Rate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate>`
                                                                        
                                                                        .. attribute:: burst
                                                                        
                                                                        	burst
                                                                        	**type**\:  :py:class:`Burst <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst>`
                                                                        
                                                                        .. attribute:: peak_rate
                                                                        
                                                                        	peak rate
                                                                        	**type**\:  :py:class:`PeakRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate>`
                                                                        
                                                                        .. attribute:: peak_burst
                                                                        
                                                                        	peak burst
                                                                        	**type**\:  :py:class:`PeakBurst <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst>`
                                                                        
                                                                        .. attribute:: cdvt
                                                                        
                                                                        	cdvt
                                                                        	**type**\:  :py:class:`Cdvt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt>`
                                                                        
                                                                        .. attribute:: conform_actns
                                                                        
                                                                        	conform actns
                                                                        	**type**\:  :py:class:`ConformActns <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns>`
                                                                        
                                                                        .. attribute:: exceed_actns
                                                                        
                                                                        	exceed actns
                                                                        	**type**\:  :py:class:`ExceedActns <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns>`
                                                                        
                                                                        .. attribute:: violate_actns
                                                                        
                                                                        	violate actns
                                                                        	**type**\:  :py:class:`ViolateActns <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns>`
                                                                        
                                                                        .. attribute:: confclass_encode
                                                                        
                                                                        	confclass encode
                                                                        	**type**\:  :py:class:`ConfclassEncode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode>`
                                                                        
                                                                        .. attribute:: confclass_p
                                                                        
                                                                        	confclass p
                                                                        	**type**\:  :py:class:`ConfclassP <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP>`
                                                                        
                                                                        .. attribute:: excdclass_encode
                                                                        
                                                                        	excdclass encode
                                                                        	**type**\:  :py:class:`ExcdclassEncode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode>`
                                                                        
                                                                        .. attribute:: excdclass_p
                                                                        
                                                                        	excdclass p
                                                                        	**type**\:  :py:class:`ExcdclassP <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP>`
                                                                        
                                                                        .. attribute:: flags
                                                                        
                                                                        	flags
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: police_flags
                                                                        
                                                                        	police flags
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: sbuck_name
                                                                        
                                                                        	sbuck name
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..65
                                                                        
                                                                        .. attribute:: sbuck_type
                                                                        
                                                                        	sbuck type
                                                                        	**type**\:  :py:class:`SharedBucketType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.SharedBucketType>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police, self).__init__()

                                                                            self.yang_name = "police"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("rate", ("rate", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate)), ("burst", ("burst", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst)), ("peak-rate", ("peak_rate", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate)), ("peak-burst", ("peak_burst", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst)), ("cdvt", ("cdvt", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt)), ("conform-actns", ("conform_actns", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns)), ("exceed-actns", ("exceed_actns", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns)), ("violate-actns", ("violate_actns", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns)), ("confclass-encode", ("confclass_encode", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode)), ("confclass-p", ("confclass_p", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP)), ("excdclass-encode", ("excdclass_encode", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode)), ("excdclass-p", ("excdclass_p", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP))])
                                                                            self._leafs = OrderedDict([
                                                                                ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                ('police_flags', (YLeaf(YType.uint32, 'police-flags'), ['int'])),
                                                                                ('sbuck_name', (YLeaf(YType.str, 'sbuck-name'), ['str'])),
                                                                                ('sbuck_type', (YLeaf(YType.enumeration, 'sbuck-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'SharedBucketType', '')])),
                                                                            ])
                                                                            self.flags = None
                                                                            self.police_flags = None
                                                                            self.sbuck_name = None
                                                                            self.sbuck_type = None

                                                                            self.rate = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate()
                                                                            self.rate.parent = self
                                                                            self._children_name_map["rate"] = "rate"

                                                                            self.burst = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst()
                                                                            self.burst.parent = self
                                                                            self._children_name_map["burst"] = "burst"

                                                                            self.peak_rate = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate()
                                                                            self.peak_rate.parent = self
                                                                            self._children_name_map["peak_rate"] = "peak-rate"

                                                                            self.peak_burst = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst()
                                                                            self.peak_burst.parent = self
                                                                            self._children_name_map["peak_burst"] = "peak-burst"

                                                                            self.cdvt = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt()
                                                                            self.cdvt.parent = self
                                                                            self._children_name_map["cdvt"] = "cdvt"

                                                                            self.conform_actns = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns()
                                                                            self.conform_actns.parent = self
                                                                            self._children_name_map["conform_actns"] = "conform-actns"

                                                                            self.exceed_actns = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns()
                                                                            self.exceed_actns.parent = self
                                                                            self._children_name_map["exceed_actns"] = "exceed-actns"

                                                                            self.violate_actns = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns()
                                                                            self.violate_actns.parent = self
                                                                            self._children_name_map["violate_actns"] = "violate-actns"

                                                                            self.confclass_encode = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode()
                                                                            self.confclass_encode.parent = self
                                                                            self._children_name_map["confclass_encode"] = "confclass-encode"

                                                                            self.confclass_p = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP()
                                                                            self.confclass_p.parent = self
                                                                            self._children_name_map["confclass_p"] = "confclass-p"

                                                                            self.excdclass_encode = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode()
                                                                            self.excdclass_encode.parent = self
                                                                            self._children_name_map["excdclass_encode"] = "excdclass-encode"

                                                                            self.excdclass_p = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP()
                                                                            self.excdclass_p.parent = self
                                                                            self._children_name_map["excdclass_p"] = "excdclass-p"
                                                                            self._segment_path = lambda: "police"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police, ['flags', 'police_flags', 'sbuck_name', 'sbuck_type'], name, value)


                                                                        class Rate(Entity):
                                                                            """
                                                                            rate
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate, self).__init__()

                                                                                self.yang_name = "rate"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate, ['value', 'unit'], name, value)


                                                                        class Burst(Entity):
                                                                            """
                                                                            burst
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst, self).__init__()

                                                                                self.yang_name = "burst"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "burst"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst, ['value', 'unit'], name, value)


                                                                        class PeakRate(Entity):
                                                                            """
                                                                            peak rate
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate, self).__init__()

                                                                                self.yang_name = "peak-rate"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "peak-rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate, ['value', 'unit'], name, value)


                                                                        class PeakBurst(Entity):
                                                                            """
                                                                            peak burst
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst, self).__init__()

                                                                                self.yang_name = "peak-burst"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "peak-burst"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst, ['value', 'unit'], name, value)


                                                                        class Cdvt(Entity):
                                                                            """
                                                                            cdvt
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt, self).__init__()

                                                                                self.yang_name = "cdvt"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "cdvt"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt, ['value', 'unit'], name, value)


                                                                        class ConformActns(Entity):
                                                                            """
                                                                            conform actns
                                                                            
                                                                            .. attribute:: police_action_array
                                                                            
                                                                            	police action array
                                                                            	**type**\: list of  		 :py:class:`PoliceActionArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns, self).__init__()

                                                                                self.yang_name = "conform-actns"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("police-action-array", ("police_action_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.police_action_array = YList(self)
                                                                                self._segment_path = lambda: "conform-actns"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns, [], name, value)


                                                                            class PoliceActionArray(Entity):
                                                                                """
                                                                                police action array
                                                                                
                                                                                .. attribute:: mark
                                                                                
                                                                                	mark
                                                                                	**type**\:  :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark>`
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:  :py:class:`PoliceActionTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PoliceActionTypeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray, self).__init__()

                                                                                    self.yang_name = "police-action-array"
                                                                                    self.yang_parent_name = "conform-actns"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("mark", ("mark", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PoliceActionTypeEn', '')])),
                                                                                    ])
                                                                                    self.type = None

                                                                                    self.mark = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark()
                                                                                    self.mark.parent = self
                                                                                    self._children_name_map["mark"] = "mark"
                                                                                    self._segment_path = lambda: "police-action-array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray, ['type'], name, value)


                                                                                class Mark(Entity):
                                                                                    """
                                                                                    mark
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	type
                                                                                    	**type**\:  :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                                    
                                                                                    .. attribute:: mark_flags
                                                                                    
                                                                                    	mark flags
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark, self).__init__()

                                                                                        self.yang_name = "mark"
                                                                                        self.yang_parent_name = "police-action-array"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MarkTypeEn', '')])),
                                                                                            ('mark_flags', (YLeaf(YType.uint32, 'mark-flags'), ['int'])),
                                                                                            ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                        ])
                                                                                        self.type = None
                                                                                        self.mark_flags = None
                                                                                        self.value = None
                                                                                        self._segment_path = lambda: "mark"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark, ['type', 'mark_flags', 'value'], name, value)


                                                                        class ExceedActns(Entity):
                                                                            """
                                                                            exceed actns
                                                                            
                                                                            .. attribute:: police_action_array
                                                                            
                                                                            	police action array
                                                                            	**type**\: list of  		 :py:class:`PoliceActionArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns, self).__init__()

                                                                                self.yang_name = "exceed-actns"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("police-action-array", ("police_action_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.police_action_array = YList(self)
                                                                                self._segment_path = lambda: "exceed-actns"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns, [], name, value)


                                                                            class PoliceActionArray(Entity):
                                                                                """
                                                                                police action array
                                                                                
                                                                                .. attribute:: mark
                                                                                
                                                                                	mark
                                                                                	**type**\:  :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark>`
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:  :py:class:`PoliceActionTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PoliceActionTypeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray, self).__init__()

                                                                                    self.yang_name = "police-action-array"
                                                                                    self.yang_parent_name = "exceed-actns"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("mark", ("mark", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PoliceActionTypeEn', '')])),
                                                                                    ])
                                                                                    self.type = None

                                                                                    self.mark = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark()
                                                                                    self.mark.parent = self
                                                                                    self._children_name_map["mark"] = "mark"
                                                                                    self._segment_path = lambda: "police-action-array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray, ['type'], name, value)


                                                                                class Mark(Entity):
                                                                                    """
                                                                                    mark
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	type
                                                                                    	**type**\:  :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                                    
                                                                                    .. attribute:: mark_flags
                                                                                    
                                                                                    	mark flags
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark, self).__init__()

                                                                                        self.yang_name = "mark"
                                                                                        self.yang_parent_name = "police-action-array"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MarkTypeEn', '')])),
                                                                                            ('mark_flags', (YLeaf(YType.uint32, 'mark-flags'), ['int'])),
                                                                                            ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                        ])
                                                                                        self.type = None
                                                                                        self.mark_flags = None
                                                                                        self.value = None
                                                                                        self._segment_path = lambda: "mark"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark, ['type', 'mark_flags', 'value'], name, value)


                                                                        class ViolateActns(Entity):
                                                                            """
                                                                            violate actns
                                                                            
                                                                            .. attribute:: police_action_array
                                                                            
                                                                            	police action array
                                                                            	**type**\: list of  		 :py:class:`PoliceActionArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns, self).__init__()

                                                                                self.yang_name = "violate-actns"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("police-action-array", ("police_action_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.police_action_array = YList(self)
                                                                                self._segment_path = lambda: "violate-actns"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns, [], name, value)


                                                                            class PoliceActionArray(Entity):
                                                                                """
                                                                                police action array
                                                                                
                                                                                .. attribute:: mark
                                                                                
                                                                                	mark
                                                                                	**type**\:  :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark>`
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:  :py:class:`PoliceActionTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PoliceActionTypeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray, self).__init__()

                                                                                    self.yang_name = "police-action-array"
                                                                                    self.yang_parent_name = "violate-actns"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("mark", ("mark", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PoliceActionTypeEn', '')])),
                                                                                    ])
                                                                                    self.type = None

                                                                                    self.mark = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark()
                                                                                    self.mark.parent = self
                                                                                    self._children_name_map["mark"] = "mark"
                                                                                    self._segment_path = lambda: "police-action-array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray, ['type'], name, value)


                                                                                class Mark(Entity):
                                                                                    """
                                                                                    mark
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	type
                                                                                    	**type**\:  :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                                    
                                                                                    .. attribute:: mark_flags
                                                                                    
                                                                                    	mark flags
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark, self).__init__()

                                                                                        self.yang_name = "mark"
                                                                                        self.yang_parent_name = "police-action-array"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MarkTypeEn', '')])),
                                                                                            ('mark_flags', (YLeaf(YType.uint32, 'mark-flags'), ['int'])),
                                                                                            ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                        ])
                                                                                        self.type = None
                                                                                        self.mark_flags = None
                                                                                        self.value = None
                                                                                        self._segment_path = lambda: "mark"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark, ['type', 'mark_flags', 'value'], name, value)


                                                                        class ConfclassEncode(Entity):
                                                                            """
                                                                            confclass encode
                                                                            
                                                                            .. attribute:: inline_cmap
                                                                            
                                                                            	inline cmap
                                                                            	**type**\:  :py:class:`InlineCmap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap>`
                                                                            
                                                                            .. attribute:: enc
                                                                            
                                                                            	enc
                                                                            	**type**\:  :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                            
                                                                            .. attribute:: class_name
                                                                            
                                                                            	class name
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..65
                                                                            
                                                                            .. attribute:: hd
                                                                            
                                                                            	hd
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: idx
                                                                            
                                                                            	idx
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode, self).__init__()

                                                                                self.yang_name = "confclass-encode"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("inline-cmap", ("inline_cmap", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('enc', (YLeaf(YType.enumeration, 'enc'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyObjEncEn', '')])),
                                                                                    ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                                                    ('hd', (YLeaf(YType.uint64, 'hd'), ['int'])),
                                                                                    ('idx', (YLeaf(YType.uint8, 'idx'), ['int'])),
                                                                                ])
                                                                                self.enc = None
                                                                                self.class_name = None
                                                                                self.hd = None
                                                                                self.idx = None

                                                                                self.inline_cmap = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap()
                                                                                self.inline_cmap.parent = self
                                                                                self._children_name_map["inline_cmap"] = "inline-cmap"
                                                                                self._segment_path = lambda: "confclass-encode"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode, ['enc', 'class_name', 'hd', 'idx'], name, value)


                                                                            class InlineCmap(Entity):
                                                                                """
                                                                                inline cmap
                                                                                
                                                                                .. attribute:: match_infop
                                                                                
                                                                                	Pointer to the first Match info
                                                                                	**type**\:  :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop>`
                                                                                
                                                                                .. attribute:: mode
                                                                                
                                                                                	Inline Class\-Map Mode Match any/all
                                                                                	**type**\:  :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                                
                                                                                .. attribute:: flags
                                                                                
                                                                                	Inline Class\-Map flags
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: match_count
                                                                                
                                                                                	Number of Match infos
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap, self).__init__()

                                                                                    self.yang_name = "inline-cmap"
                                                                                    self.yang_parent_name = "confclass-encode"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("match-infop", ("match_infop", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapModeEn', '')])),
                                                                                        ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                        ('match_count', (YLeaf(YType.uint32, 'match-count'), ['int'])),
                                                                                    ])
                                                                                    self.mode = None
                                                                                    self.flags = None
                                                                                    self.match_count = None

                                                                                    self.match_infop = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop()
                                                                                    self.match_infop.parent = self
                                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                                    self._segment_path = lambda: "inline-cmap"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap, ['mode', 'flags', 'match_count'], name, value)


                                                                                class MatchInfop(Entity):
                                                                                    """
                                                                                    Pointer to the first Match info
                                                                                    
                                                                                    .. attribute:: class_match_info_st
                                                                                    
                                                                                    	class match info st
                                                                                    	**type**\: list of  		 :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop, self).__init__()

                                                                                        self.yang_name = "match-infop"
                                                                                        self.yang_parent_name = "inline-cmap"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("class-match-info-st", ("class_match_info_st", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.class_match_info_st = YList(self)
                                                                                        self._segment_path = lambda: "match-infop"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop, [], name, value)


                                                                                    class ClassMatchInfoSt(Entity):
                                                                                        """
                                                                                        class match info st
                                                                                        
                                                                                        .. attribute:: match_data
                                                                                        
                                                                                        	Match criteria
                                                                                        	**type**\:  :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                        
                                                                                        .. attribute:: flags
                                                                                        
                                                                                        	Flags
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                            self.yang_name = "class-match-info-st"
                                                                                            self.yang_parent_name = "match-infop"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("match-data", ("match_data", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData))])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                            ])
                                                                                            self.flags = None

                                                                                            self.match_data = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                            self.match_data.parent = self
                                                                                            self._children_name_map["match_data"] = "match-data"
                                                                                            self._segment_path = lambda: "class-match-info-st"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                        class MatchData(Entity):
                                                                                            """
                                                                                            Match criteria
                                                                                            
                                                                                            .. attribute:: ipv4_dscp
                                                                                            
                                                                                            	IPv4 DSCP
                                                                                            	**type**\:  :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv6_dscp
                                                                                            
                                                                                            	IPv6 DSCP
                                                                                            	**type**\:  :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                            
                                                                                            .. attribute:: dscp
                                                                                            
                                                                                            	Match DSCP range array
                                                                                            	**type**\:  :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv4_prec
                                                                                            
                                                                                            	IPv4 Precedence
                                                                                            	**type**\:  :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                            
                                                                                            .. attribute:: ipv6_prec
                                                                                            
                                                                                            	IPv6 Precedence
                                                                                            	**type**\:  :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                            
                                                                                            .. attribute:: prec
                                                                                            
                                                                                            	Match Precedence array
                                                                                            	**type**\:  :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                            
                                                                                            .. attribute:: discard_class
                                                                                            
                                                                                            	Match Discard Class array
                                                                                            	**type**\:  :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                            
                                                                                            .. attribute:: qos_group
                                                                                            
                                                                                            	Match QoS group array
                                                                                            	**type**\:  :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                            
                                                                                            .. attribute:: traffic_class
                                                                                            
                                                                                            	Match Traffic class array
                                                                                            	**type**\:  :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                            
                                                                                            .. attribute:: proto
                                                                                            
                                                                                            	Match Protocol array
                                                                                            	**type**\:  :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                            
                                                                                            .. attribute:: icmp_v4
                                                                                            
                                                                                            	Match ICMPV4 Protocol
                                                                                            	**type**\:  :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                            
                                                                                            .. attribute:: icmp_v6
                                                                                            
                                                                                            	Match ICMPV6 Protocol array
                                                                                            	**type**\:  :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                            
                                                                                            .. attribute:: ipv4_packet_len
                                                                                            
                                                                                            	IPv4 packet length array
                                                                                            	**type**\:  :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv6_packet_len
                                                                                            
                                                                                            	IPv6 packet length array
                                                                                            	**type**\:  :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                            
                                                                                            .. attribute:: packet_len
                                                                                            
                                                                                            	Match packet length array
                                                                                            	**type**\:  :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                            
                                                                                            .. attribute:: flow_tag
                                                                                            
                                                                                            	Match flow\-tag array
                                                                                            	**type**\:  :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                            
                                                                                            .. attribute:: tcp_flag
                                                                                            
                                                                                            	Match tcp flag value
                                                                                            	**type**\:  :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                            
                                                                                            .. attribute:: icmpv4_type
                                                                                            
                                                                                            	Match ipv4 icmp type
                                                                                            	**type**\:  :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                            
                                                                                            .. attribute:: icmpv4_code
                                                                                            
                                                                                            	Match ipv4 icmp code
                                                                                            	**type**\:  :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                            
                                                                                            .. attribute:: icmpv6_type
                                                                                            
                                                                                            	Match ipv6 icmp type
                                                                                            	**type**\:  :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                            
                                                                                            .. attribute:: icmpv6_code
                                                                                            
                                                                                            	Match ipv6 icmp code
                                                                                            	**type**\:  :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                            
                                                                                            .. attribute:: mpls_exp
                                                                                            
                                                                                            	Match MPLS experimental topmost array
                                                                                            	**type**\:  :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                            
                                                                                            .. attribute:: mpls_exp_imp
                                                                                            
                                                                                            	Match MPLS experimental imposition array
                                                                                            	**type**\:  :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                                            
                                                                                            	MPLS Disposition IPv4 Access\-list
                                                                                            	**type**\:  :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                                            
                                                                                            	MPLS Disposition IPv6 Access\-list
                                                                                            	**type**\:  :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_top_label
                                                                                            
                                                                                            	MPLS Topmost LABEL
                                                                                            	**type**\:  :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                            
                                                                                            .. attribute:: cos
                                                                                            
                                                                                            	Match CoS array
                                                                                            	**type**\:  :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                            
                                                                                            .. attribute:: cos_inr
                                                                                            
                                                                                            	Match inner header CoS
                                                                                            	**type**\:  :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                            
                                                                                            .. attribute:: dei
                                                                                            
                                                                                            	Match DEI Bit
                                                                                            	**type**\:  :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                            
                                                                                            .. attribute:: dei_inr
                                                                                            
                                                                                            	Match inner DEI Bit
                                                                                            	**type**\:  :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                            
                                                                                            .. attribute:: vlan
                                                                                            
                                                                                            	Match VLAN array
                                                                                            	**type**\:  :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                            
                                                                                            .. attribute:: vlan_inr
                                                                                            
                                                                                            	Match inner header VLAN range array
                                                                                            	**type**\:  :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                            
                                                                                            .. attribute:: fr_dlci
                                                                                            
                                                                                            	Match FR DLCI range array
                                                                                            	**type**\:  :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                            
                                                                                            .. attribute:: src_mac
                                                                                            
                                                                                            	Match Source MAC address
                                                                                            	**type**\:  :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                            
                                                                                            .. attribute:: dst_mac
                                                                                            
                                                                                            	Match Destination MAC address
                                                                                            	**type**\:  :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                            
                                                                                            .. attribute:: atm_clp
                                                                                            
                                                                                            	Match ATM CLP level
                                                                                            	**type**\:  :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                            
                                                                                            .. attribute:: fr_de
                                                                                            
                                                                                            	Match FR DE value
                                                                                            	**type**\:  :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                            
                                                                                            .. attribute:: ipv4_acl
                                                                                            
                                                                                            	IPv4 Access\-list
                                                                                            	**type**\:  :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                            
                                                                                            .. attribute:: ipv6_acl
                                                                                            
                                                                                            	IPv6 Access\-list
                                                                                            	**type**\:  :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                            
                                                                                            .. attribute:: ether_service_acl
                                                                                            
                                                                                            	Ethernet\-Services Access\-list
                                                                                            	**type**\:  :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                            
                                                                                            .. attribute:: avail_id
                                                                                            
                                                                                            	Available Identifiers
                                                                                            	**type**\:  :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                            
                                                                                            .. attribute:: media_type
                                                                                            
                                                                                            	Media Type
                                                                                            	**type**\:  :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                            
                                                                                            .. attribute:: subs_protocol
                                                                                            
                                                                                            	Protocol
                                                                                            	**type**\:  :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                            
                                                                                            .. attribute:: dnis
                                                                                            
                                                                                            	DNIS
                                                                                            	**type**\:  :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                            
                                                                                            .. attribute:: dnis_regex
                                                                                            
                                                                                            	DNIS Regular Expression
                                                                                            	**type**\:  :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                            
                                                                                            .. attribute:: domain
                                                                                            
                                                                                            	Domain Name
                                                                                            	**type**\:  :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                            
                                                                                            .. attribute:: domain_regex
                                                                                            
                                                                                            	Domain Regular Expression
                                                                                            	**type**\:  :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                            
                                                                                            .. attribute:: nas_port
                                                                                            
                                                                                            	NAS Port
                                                                                            	**type**\:  :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                            
                                                                                            .. attribute:: service_name
                                                                                            
                                                                                            	Service Name
                                                                                            	**type**\:  :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                            
                                                                                            .. attribute:: service_name_regex
                                                                                            
                                                                                            	Service Name Regular Exp
                                                                                            	**type**\:  :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv4
                                                                                            
                                                                                            	Source Address IPV4
                                                                                            	**type**\:  :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv4
                                                                                            
                                                                                            	Destination Address IPV4
                                                                                            	**type**\:  :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv6
                                                                                            
                                                                                            	Source Address IPV6
                                                                                            	**type**\:  :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv6
                                                                                            
                                                                                            	Destination Address IPV6
                                                                                            	**type**\:  :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: src_addr_mac
                                                                                            
                                                                                            	Source Address MAC
                                                                                            	**type**\:  :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                            
                                                                                            .. attribute:: timer
                                                                                            
                                                                                            	Timer
                                                                                            	**type**\:  :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                            
                                                                                            .. attribute:: timer_regexp
                                                                                            
                                                                                            	Timer Regular Expression
                                                                                            	**type**\:  :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                            
                                                                                            .. attribute:: tunnel_name
                                                                                            
                                                                                            	Tunnel Name
                                                                                            	**type**\:  :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                            
                                                                                            .. attribute:: tunnel_name_regex
                                                                                            
                                                                                            	Tunnel Name Regular Expression
                                                                                            	**type**\:  :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                            
                                                                                            .. attribute:: user_name
                                                                                            
                                                                                            	User Name
                                                                                            	**type**\:  :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                            
                                                                                            .. attribute:: user_name_regex
                                                                                            
                                                                                            	User Name Regular Expression
                                                                                            	**type**\:  :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                            
                                                                                            .. attribute:: auth_username
                                                                                            
                                                                                            	Authenticated User Name
                                                                                            	**type**\:  :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                            
                                                                                            .. attribute:: auth_username_regex
                                                                                            
                                                                                            	Authenticated User Name RegEx
                                                                                            	**type**\:  :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_username
                                                                                            
                                                                                            	Unauthenticated User Name
                                                                                            	**type**\:  :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                            
                                                                                            .. attribute:: unauth_username_regex
                                                                                            
                                                                                            	Unauthenticated User Name RegEx
                                                                                            	**type**\:  :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: auth_domain
                                                                                            
                                                                                            	Authenticated domain name
                                                                                            	**type**\:  :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                            
                                                                                            .. attribute:: auth_domain_regex
                                                                                            
                                                                                            	Authenticated Domain Name RegEx
                                                                                            	**type**\:  :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_domain
                                                                                            
                                                                                            	Unauthenticated Domain Name
                                                                                            	**type**\:  :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                            
                                                                                            .. attribute:: unauth_domain_regex
                                                                                            
                                                                                            	Unauthenticated Domain Name RegEx
                                                                                            	**type**\:  :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: vendor_id
                                                                                            
                                                                                            	Vendor ID
                                                                                            	**type**\:  :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                            
                                                                                            .. attribute:: vendor_id_regex
                                                                                            
                                                                                            	Vendor ID RegEx
                                                                                            	**type**\:  :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                            
                                                                                            .. attribute:: access_interface
                                                                                            
                                                                                            	Access interface
                                                                                            	**type**\:  :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                            
                                                                                            .. attribute:: input_interface
                                                                                            
                                                                                            	Input interface
                                                                                            	**type**\:  :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                            
                                                                                            .. attribute:: input_intfhdl
                                                                                            
                                                                                            	Input interface handle
                                                                                            	**type**\:  :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                            
                                                                                            .. attribute:: ethertype
                                                                                            
                                                                                            	Ethernet type
                                                                                            	**type**\:  :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                            
                                                                                            .. attribute:: flow_key_data
                                                                                            
                                                                                            	Flow key structure
                                                                                            	**type**\:  :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id
                                                                                            
                                                                                            	Dhcp Client ID
                                                                                            	**type**\:  :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id_regex
                                                                                            
                                                                                            	Dhcp Client ID RegEx
                                                                                            	**type**\:  :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                            
                                                                                            .. attribute:: circuit_id
                                                                                            
                                                                                            	Circuit ID
                                                                                            	**type**\:  :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                            
                                                                                            .. attribute:: circuit_id_regex
                                                                                            
                                                                                            	Circuit ID RegEx
                                                                                            	**type**\:  :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                            
                                                                                            .. attribute:: remote_id
                                                                                            
                                                                                            	Remote ID
                                                                                            	**type**\:  :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                            
                                                                                            .. attribute:: remote_id_regex
                                                                                            
                                                                                            	Remote ID RegEx
                                                                                            	**type**\:  :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                            
                                                                                            .. attribute:: src_port
                                                                                            
                                                                                            	Source port
                                                                                            	**type**\:  :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                            
                                                                                            .. attribute:: dst_port
                                                                                            
                                                                                            	Destination port
                                                                                            	**type**\:  :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	type
                                                                                            	**type**\:  :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                            
                                                                                            .. attribute:: mpls_top_eos
                                                                                            
                                                                                            	MPLS Topmost EOS
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: fragment_type
                                                                                            
                                                                                            	Fragment type
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: authen_status
                                                                                            
                                                                                            	Authentication Status
                                                                                            	**type**\:  :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                            
                                                                                            .. attribute:: mlp_negotiated
                                                                                            
                                                                                            	MLP Negotiated
                                                                                            	**type**\:  :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                                self.yang_name = "match-data"
                                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("ipv4-dscp", ("ipv4_dscp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp)), ("ipv6-dscp", ("ipv6_dscp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp)), ("dscp", ("dscp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp)), ("ipv4-prec", ("ipv4_prec", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec)), ("ipv6-prec", ("ipv6_prec", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec)), ("prec", ("prec", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec)), ("discard-class", ("discard_class", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass)), ("qos-group", ("qos_group", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup)), ("traffic-class", ("traffic_class", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass)), ("proto", ("proto", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto)), ("icmp-v4", ("icmp_v4", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4)), ("icmp-v6", ("icmp_v6", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6)), ("ipv4-packet-len", ("ipv4_packet_len", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen)), ("ipv6-packet-len", ("ipv6_packet_len", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen)), ("packet-len", ("packet_len", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen)), ("flow-tag", ("flow_tag", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag)), ("tcp-flag", ("tcp_flag", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag)), ("icmpv4-type", ("icmpv4_type", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type)), ("icmpv4-code", ("icmpv4_code", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code)), ("icmpv6-type", ("icmpv6_type", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type)), ("icmpv6-code", ("icmpv6_code", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code)), ("mpls-exp", ("mpls_exp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp)), ("mpls-exp-imp", ("mpls_exp_imp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp)), ("mpls-disp-ipv4-acl", ("mpls_disp_ipv4_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl)), ("mpls-disp-ipv6-acl", ("mpls_disp_ipv6_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl)), ("mpls-top-label", ("mpls_top_label", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel)), ("cos", ("cos", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos)), ("cos-inr", ("cos_inr", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr)), ("dei", ("dei", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei)), ("dei-inr", ("dei_inr", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr)), ("vlan", ("vlan", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan)), ("vlan-inr", ("vlan_inr", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)), ("fr-dlci", ("fr_dlci", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci)), ("src-mac", ("src_mac", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac)), ("dst-mac", ("dst_mac", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac)), ("atm-clp", ("atm_clp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp)), ("fr-de", ("fr_de", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe)), ("ipv4-acl", ("ipv4_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl)), ("ipv6-acl", ("ipv6_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl)), ("ether-service-acl", ("ether_service_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl)), ("avail-id", ("avail_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId)), ("media-type", ("media_type", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType)), ("subs-protocol", ("subs_protocol", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol)), ("dnis", ("dnis", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis)), ("dnis-regex", ("dnis_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex)), ("domain", ("domain", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain)), ("domain-regex", ("domain_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex)), ("nas-port", ("nas_port", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort)), ("service-name", ("service_name", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName)), ("service-name-regex", ("service_name_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex)), ("src-addr-ipv4", ("src_addr_ipv4", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4)), ("dst-addr-ipv4", ("dst_addr_ipv4", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4)), ("src-addr-ipv6", ("src_addr_ipv6", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6)), ("dst-addr-ipv6", ("dst_addr_ipv6", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6)), ("src-addr-mac", ("src_addr_mac", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac)), ("timer", ("timer", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer)), ("timer-regexp", ("timer_regexp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp)), ("tunnel-name", ("tunnel_name", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName)), ("tunnel-name-regex", ("tunnel_name_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex)), ("user-name", ("user_name", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName)), ("user-name-regex", ("user_name_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex)), ("auth-username", ("auth_username", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername)), ("auth-username-regex", ("auth_username_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex)), ("unauth-username", ("unauth_username", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername)), ("unauth-username-regex", ("unauth_username_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex)), ("auth-domain", ("auth_domain", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain)), ("auth-domain-regex", ("auth_domain_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex)), ("unauth-domain", ("unauth_domain", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain)), ("unauth-domain-regex", ("unauth_domain_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex)), ("vendor-id", ("vendor_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId)), ("vendor-id-regex", ("vendor_id_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex)), ("access-interface", ("access_interface", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface)), ("input-interface", ("input_interface", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface)), ("input-intfhdl", ("input_intfhdl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl)), ("ethertype", ("ethertype", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype)), ("flow-key-data", ("flow_key_data", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData)), ("dhcp-client-id", ("dhcp_client_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId)), ("dhcp-client-id-regex", ("dhcp_client_id_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex)), ("circuit-id", ("circuit_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId)), ("circuit-id-regex", ("circuit_id_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex)), ("remote-id", ("remote_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId)), ("remote-id-regex", ("remote_id_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex)), ("src-port", ("src_port", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort)), ("dst-port", ("dst_port", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort))])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchTypeEn', '')])),
                                                                                                    ('mpls_top_eos', (YLeaf(YType.uint8, 'mpls-top-eos'), ['int'])),
                                                                                                    ('fragment_type', (YLeaf(YType.uint8, 'fragment-type'), ['int'])),
                                                                                                    ('authen_status', (YLeaf(YType.enumeration, 'authen-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchAuthenStatusEn', '')])),
                                                                                                    ('mlp_negotiated', (YLeaf(YType.enumeration, 'mlp-negotiated'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchMlpNegotiatedEn', '')])),
                                                                                                ])
                                                                                                self.type = None
                                                                                                self.mpls_top_eos = None
                                                                                                self.fragment_type = None
                                                                                                self.authen_status = None
                                                                                                self.mlp_negotiated = None

                                                                                                self.ipv4_dscp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                                self.ipv4_dscp.parent = self
                                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"

                                                                                                self.ipv6_dscp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                                self.ipv6_dscp.parent = self
                                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"

                                                                                                self.dscp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                                self.dscp.parent = self
                                                                                                self._children_name_map["dscp"] = "dscp"

                                                                                                self.ipv4_prec = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                                self.ipv4_prec.parent = self
                                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"

                                                                                                self.ipv6_prec = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                                self.ipv6_prec.parent = self
                                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"

                                                                                                self.prec = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                                self.prec.parent = self
                                                                                                self._children_name_map["prec"] = "prec"

                                                                                                self.discard_class = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                                self.discard_class.parent = self
                                                                                                self._children_name_map["discard_class"] = "discard-class"

                                                                                                self.qos_group = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                                self.qos_group.parent = self
                                                                                                self._children_name_map["qos_group"] = "qos-group"

                                                                                                self.traffic_class = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                                self.traffic_class.parent = self
                                                                                                self._children_name_map["traffic_class"] = "traffic-class"

                                                                                                self.proto = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                                self.proto.parent = self
                                                                                                self._children_name_map["proto"] = "proto"

                                                                                                self.icmp_v4 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                                self.icmp_v4.parent = self
                                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"

                                                                                                self.icmp_v6 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                                self.icmp_v6.parent = self
                                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"

                                                                                                self.ipv4_packet_len = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                                self.ipv4_packet_len.parent = self
                                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"

                                                                                                self.ipv6_packet_len = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                                self.ipv6_packet_len.parent = self
                                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"

                                                                                                self.packet_len = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                                self.packet_len.parent = self
                                                                                                self._children_name_map["packet_len"] = "packet-len"

                                                                                                self.flow_tag = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                                self.flow_tag.parent = self
                                                                                                self._children_name_map["flow_tag"] = "flow-tag"

                                                                                                self.tcp_flag = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                                self.tcp_flag.parent = self
                                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"

                                                                                                self.icmpv4_type = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                                self.icmpv4_type.parent = self
                                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"

                                                                                                self.icmpv4_code = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                                self.icmpv4_code.parent = self
                                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"

                                                                                                self.icmpv6_type = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                                self.icmpv6_type.parent = self
                                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"

                                                                                                self.icmpv6_code = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                                self.icmpv6_code.parent = self
                                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"

                                                                                                self.mpls_exp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                                self.mpls_exp.parent = self
                                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"

                                                                                                self.mpls_exp_imp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                                self.mpls_exp_imp.parent = self
                                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"

                                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"

                                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"

                                                                                                self.mpls_top_label = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                                self.mpls_top_label.parent = self
                                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"

                                                                                                self.cos = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                                self.cos.parent = self
                                                                                                self._children_name_map["cos"] = "cos"

                                                                                                self.cos_inr = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                                self.cos_inr.parent = self
                                                                                                self._children_name_map["cos_inr"] = "cos-inr"

                                                                                                self.dei = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                                self.dei.parent = self
                                                                                                self._children_name_map["dei"] = "dei"

                                                                                                self.dei_inr = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                                self.dei_inr.parent = self
                                                                                                self._children_name_map["dei_inr"] = "dei-inr"

                                                                                                self.vlan = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                                self.vlan.parent = self
                                                                                                self._children_name_map["vlan"] = "vlan"

                                                                                                self.vlan_inr = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                                self.vlan_inr.parent = self
                                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"

                                                                                                self.fr_dlci = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                                self.fr_dlci.parent = self
                                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"

                                                                                                self.src_mac = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                                self.src_mac.parent = self
                                                                                                self._children_name_map["src_mac"] = "src-mac"

                                                                                                self.dst_mac = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                                self.dst_mac.parent = self
                                                                                                self._children_name_map["dst_mac"] = "dst-mac"

                                                                                                self.atm_clp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                                self.atm_clp.parent = self
                                                                                                self._children_name_map["atm_clp"] = "atm-clp"

                                                                                                self.fr_de = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                                self.fr_de.parent = self
                                                                                                self._children_name_map["fr_de"] = "fr-de"

                                                                                                self.ipv4_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                                self.ipv4_acl.parent = self
                                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"

                                                                                                self.ipv6_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                                self.ipv6_acl.parent = self
                                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"

                                                                                                self.ether_service_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                                self.ether_service_acl.parent = self
                                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"

                                                                                                self.avail_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                                self.avail_id.parent = self
                                                                                                self._children_name_map["avail_id"] = "avail-id"

                                                                                                self.media_type = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                                self.media_type.parent = self
                                                                                                self._children_name_map["media_type"] = "media-type"

                                                                                                self.subs_protocol = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                                self.subs_protocol.parent = self
                                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"

                                                                                                self.dnis = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                                self.dnis.parent = self
                                                                                                self._children_name_map["dnis"] = "dnis"

                                                                                                self.dnis_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                                self.dnis_regex.parent = self
                                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"

                                                                                                self.domain = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                                self.domain.parent = self
                                                                                                self._children_name_map["domain"] = "domain"

                                                                                                self.domain_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                                self.domain_regex.parent = self
                                                                                                self._children_name_map["domain_regex"] = "domain-regex"

                                                                                                self.nas_port = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                                self.nas_port.parent = self
                                                                                                self._children_name_map["nas_port"] = "nas-port"

                                                                                                self.service_name = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                                self.service_name.parent = self
                                                                                                self._children_name_map["service_name"] = "service-name"

                                                                                                self.service_name_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                                self.service_name_regex.parent = self
                                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"

                                                                                                self.src_addr_ipv4 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                                self.src_addr_ipv4.parent = self
                                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"

                                                                                                self.dst_addr_ipv4 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                                self.dst_addr_ipv4.parent = self
                                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"

                                                                                                self.src_addr_ipv6 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                                self.src_addr_ipv6.parent = self
                                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"

                                                                                                self.dst_addr_ipv6 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                                self.dst_addr_ipv6.parent = self
                                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"

                                                                                                self.src_addr_mac = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                                self.src_addr_mac.parent = self
                                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"

                                                                                                self.timer = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                                self.timer.parent = self
                                                                                                self._children_name_map["timer"] = "timer"

                                                                                                self.timer_regexp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                                self.timer_regexp.parent = self
                                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"

                                                                                                self.tunnel_name = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                                self.tunnel_name.parent = self
                                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"

                                                                                                self.tunnel_name_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                                self.tunnel_name_regex.parent = self
                                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"

                                                                                                self.user_name = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                                self.user_name.parent = self
                                                                                                self._children_name_map["user_name"] = "user-name"

                                                                                                self.user_name_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                                self.user_name_regex.parent = self
                                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"

                                                                                                self.auth_username = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                                self.auth_username.parent = self
                                                                                                self._children_name_map["auth_username"] = "auth-username"

                                                                                                self.auth_username_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                                self.auth_username_regex.parent = self
                                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"

                                                                                                self.unauth_username = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                                self.unauth_username.parent = self
                                                                                                self._children_name_map["unauth_username"] = "unauth-username"

                                                                                                self.unauth_username_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                                self.unauth_username_regex.parent = self
                                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"

                                                                                                self.auth_domain = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                                self.auth_domain.parent = self
                                                                                                self._children_name_map["auth_domain"] = "auth-domain"

                                                                                                self.auth_domain_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                                self.auth_domain_regex.parent = self
                                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"

                                                                                                self.unauth_domain = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                                self.unauth_domain.parent = self
                                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"

                                                                                                self.unauth_domain_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                                self.unauth_domain_regex.parent = self
                                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"

                                                                                                self.vendor_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                                self.vendor_id.parent = self
                                                                                                self._children_name_map["vendor_id"] = "vendor-id"

                                                                                                self.vendor_id_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                                self.vendor_id_regex.parent = self
                                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"

                                                                                                self.access_interface = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                                self.access_interface.parent = self
                                                                                                self._children_name_map["access_interface"] = "access-interface"

                                                                                                self.input_interface = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                                self.input_interface.parent = self
                                                                                                self._children_name_map["input_interface"] = "input-interface"

                                                                                                self.input_intfhdl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                                self.input_intfhdl.parent = self
                                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"

                                                                                                self.ethertype = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                                self.ethertype.parent = self
                                                                                                self._children_name_map["ethertype"] = "ethertype"

                                                                                                self.flow_key_data = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                                self.flow_key_data.parent = self
                                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"

                                                                                                self.dhcp_client_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                                self.dhcp_client_id.parent = self
                                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"

                                                                                                self.dhcp_client_id_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                                self.dhcp_client_id_regex.parent = self
                                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"

                                                                                                self.circuit_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                                self.circuit_id.parent = self
                                                                                                self._children_name_map["circuit_id"] = "circuit-id"

                                                                                                self.circuit_id_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                                self.circuit_id_regex.parent = self
                                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"

                                                                                                self.remote_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                                self.remote_id.parent = self
                                                                                                self._children_name_map["remote_id"] = "remote-id"

                                                                                                self.remote_id_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                                self.remote_id_regex.parent = self
                                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"

                                                                                                self.src_port = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                                self.src_port.parent = self
                                                                                                self._children_name_map["src_port"] = "src-port"

                                                                                                self.dst_port = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                                self.dst_port.parent = self
                                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                                self._segment_path = lambda: "match-data"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, ['type', 'mpls_top_eos', 'fragment_type', 'authen_status', 'mlp_negotiated'], name, value)


                                                                                            class Ipv4Dscp(Entity):
                                                                                                """
                                                                                                IPv4 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv4-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv6Dscp(Entity):
                                                                                                """
                                                                                                IPv6 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv6-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Dscp(Entity):
                                                                                                """
                                                                                                Match DSCP range array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                    self.yang_name = "dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv4Prec(Entity):
                                                                                                """
                                                                                                IPv4 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                    self.yang_name = "ipv4-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "ipv4-prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                            class Ipv6Prec(Entity):
                                                                                                """
                                                                                                IPv6 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                    self.yang_name = "ipv6-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "ipv6-prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                            class Prec(Entity):
                                                                                                """
                                                                                                Match Precedence array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                    self.yang_name = "prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                            class DiscardClass(Entity):
                                                                                                """
                                                                                                Match Discard Class array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                    self.yang_name = "discard-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "discard-class"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                            class QosGroup(Entity):
                                                                                                """
                                                                                                Match QoS group array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                    self.yang_name = "qos-group"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "qos-group"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "qos-group"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class TrafficClass(Entity):
                                                                                                """
                                                                                                Match Traffic class array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                    self.yang_name = "traffic-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "traffic-class"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "traffic-class"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Proto(Entity):
                                                                                                """
                                                                                                Match Protocol array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                    self.yang_name = "proto"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "proto"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "proto"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class IcmpV4(Entity):
                                                                                                """
                                                                                                Match ICMPV4 Protocol
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                    self.yang_name = "icmp-v4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                    ])
                                                                                                    self.type = None
                                                                                                    self.code = None
                                                                                                    self._segment_path = lambda: "icmp-v4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['type', 'code'], name, value)


                                                                                            class IcmpV6(Entity):
                                                                                                """
                                                                                                Match ICMPV6 Protocol array
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                    self.yang_name = "icmp-v6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                    ])
                                                                                                    self.type = None
                                                                                                    self.code = None
                                                                                                    self._segment_path = lambda: "icmp-v6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['type', 'code'], name, value)


                                                                                            class Ipv4PacketLen(Entity):
                                                                                                """
                                                                                                IPv4 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv6PacketLen(Entity):
                                                                                                """
                                                                                                IPv6 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class PacketLen(Entity):
                                                                                                """
                                                                                                Match packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                    self.yang_name = "packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FlowTag(Entity):
                                                                                                """
                                                                                                Match flow\-tag array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                    self.yang_name = "flow-tag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "flow-tag"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "flow-tag"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class TcpFlag(Entity):
                                                                                                """
                                                                                                Match tcp flag value
                                                                                                
                                                                                                .. attribute:: value
                                                                                                
                                                                                                	Value of TCP flag
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: match_any
                                                                                                
                                                                                                	Match any TCP flag bit
                                                                                                	**type**\: bool
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                    self.yang_name = "tcp-flag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                                        ('match_any', (YLeaf(YType.boolean, 'match-any'), ['bool'])),
                                                                                                    ])
                                                                                                    self.value = None
                                                                                                    self.match_any = None
                                                                                                    self._segment_path = lambda: "tcp-flag"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['value', 'match_any'], name, value)


                                                                                            class Icmpv4Type(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                    self.yang_name = "icmpv4-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv4Code(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                    self.yang_name = "icmpv4-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-code"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv6Type(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                    self.yang_name = "icmpv6-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv6Code(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                    self.yang_name = "icmpv6-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-code"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class MplsExp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental topmost array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "mpls-exp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                            class MplsExpImp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental imposition array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "mpls-exp-imp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                            class MplsDispIpv4Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                            class MplsDispIpv6Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                            class MplsTopLabel(Entity):
                                                                                                """
                                                                                                MPLS Topmost LABEL
                                                                                                
                                                                                                .. attribute:: uint32_rng_array
                                                                                                
                                                                                                	uint32 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                    self.yang_name = "mpls-top-label"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint32_rng_array", ("uint32_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint32_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "mpls-top-label"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                                class Uint32RngArray(Entity):
                                                                                                    """
                                                                                                    uint32 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                        self.yang_name = "uint32_rng_array"
                                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint32, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint32, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint32_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['min', 'max'], name, value)


                                                                                            class Cos(Entity):
                                                                                                """
                                                                                                Match CoS array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                    self.yang_name = "cos"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "cos"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                            class CosInr(Entity):
                                                                                                """
                                                                                                Match inner header CoS
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                    self.yang_name = "cos-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "cos-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                            class Dei(Entity):
                                                                                                """
                                                                                                Match DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                    self.yang_name = "dei"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                    ])
                                                                                                    self.bit_value = None
                                                                                                    self._segment_path = lambda: "dei"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                            class DeiInr(Entity):
                                                                                                """
                                                                                                Match inner DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                    self.yang_name = "dei-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                    ])
                                                                                                    self.bit_value = None
                                                                                                    self._segment_path = lambda: "dei-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                            class Vlan(Entity):
                                                                                                """
                                                                                                Match VLAN array
                                                                                                
                                                                                                .. attribute:: vlan_id_array
                                                                                                
                                                                                                	vlan id array
                                                                                                	**type**\: list of  		 :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                    self.yang_name = "vlan"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("vlan-id-array", ("vlan_id_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.vlan_id_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                                class VlanIdArray(Entity):
                                                                                                    """
                                                                                                    vlan id array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	VLAN mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                        self.yang_name = "vlan-id-array"
                                                                                                        self.yang_parent_name = "vlan"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ('mask', (YLeaf(YType.uint16, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "vlan-id-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['min', 'max', 'mask'], name, value)


                                                                                            class VlanInr(Entity):
                                                                                                """
                                                                                                Match inner header VLAN range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                    self.yang_name = "vlan-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FrDlci(Entity):
                                                                                                """
                                                                                                Match FR DLCI range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                    self.yang_name = "fr-dlci"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "fr-dlci"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class SrcMac(Entity):
                                                                                                """
                                                                                                Match Source MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                    self.yang_name = "src-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.mac_addr = []
                                                                                                    self.mask = []
                                                                                                    self._segment_path = lambda: "src-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                            class DstMac(Entity):
                                                                                                """
                                                                                                Match Destination MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                    self.yang_name = "dst-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.mac_addr = []
                                                                                                    self.mask = []
                                                                                                    self._segment_path = lambda: "dst-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                            class AtmClp(Entity):
                                                                                                """
                                                                                                Match ATM CLP level
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                    self.yang_name = "atm-clp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "atm-clp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                            class FrDe(Entity):
                                                                                                """
                                                                                                Match FR DE value
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                    self.yang_name = "fr-de"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "fr-de"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                            class Ipv4Acl(Entity):
                                                                                                """
                                                                                                IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                    self.yang_name = "ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ipv4-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                            class Ipv6Acl(Entity):
                                                                                                """
                                                                                                IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                    self.yang_name = "ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ipv6-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                            class EtherServiceAcl(Entity):
                                                                                                """
                                                                                                Ethernet\-Services Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                    self.yang_name = "ether-service-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ether-service-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                            class AvailId(Entity):
                                                                                                """
                                                                                                Available Identifiers
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                    self.yang_name = "avail-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "avail-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                            class MediaType(Entity):
                                                                                                """
                                                                                                Media Type
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                    self.yang_name = "media-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "media-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                            class SubsProtocol(Entity):
                                                                                                """
                                                                                                Protocol
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                    self.yang_name = "subs-protocol"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "subs-protocol"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                            class Dnis(Entity):
                                                                                                """
                                                                                                DNIS
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                    self.yang_name = "dnis"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dnis"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                            class DnisRegex(Entity):
                                                                                                """
                                                                                                DNIS Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                    self.yang_name = "dnis-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dnis-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                            class Domain(Entity):
                                                                                                """
                                                                                                Domain Name
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                    self.yang_name = "domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                        ])
                                                                                                        self.domain_name = None
                                                                                                        self.format_name = None
                                                                                                        self._segment_path = lambda: "domain-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class DomainRegex(Entity):
                                                                                                """
                                                                                                Domain Regular Expression
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                    self.yang_name = "domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain-regex"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                        ])
                                                                                                        self.domain_name = None
                                                                                                        self.format_name = None
                                                                                                        self._segment_path = lambda: "domain-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class NasPort(Entity):
                                                                                                """
                                                                                                NAS Port
                                                                                                
                                                                                                .. attribute:: nas_port_array
                                                                                                
                                                                                                	nas port array
                                                                                                	**type**\: list of  		 :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                    self.yang_name = "nas-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("nas-port-array", ("nas_port_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.nas_port_array = YList(self)
                                                                                                    self._segment_path = lambda: "nas-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                                class NasPortArray(Entity):
                                                                                                    """
                                                                                                    nas port array
                                                                                                    
                                                                                                    .. attribute:: sub_id
                                                                                                    
                                                                                                    	sub id
                                                                                                    	**type**\:  :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                    
                                                                                                    .. attribute:: operator
                                                                                                    
                                                                                                    	operator
                                                                                                    	**type**\:  :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	value
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                        self.yang_name = "nas-port-array"
                                                                                                        self.yang_parent_name = "nas-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('sub_id', (YLeaf(YType.enumeration, 'sub-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchNasPortSubIdEn', '')])),
                                                                                                            ('operator', (YLeaf(YType.enumeration, 'operator'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchLogicalOperatorEn', '')])),
                                                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                                        ])
                                                                                                        self.sub_id = None
                                                                                                        self.operator = None
                                                                                                        self.value = None
                                                                                                        self._segment_path = lambda: "nas-port-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['sub_id', 'operator', 'value'], name, value)


                                                                                            class ServiceName(Entity):
                                                                                                """
                                                                                                Service Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                    self.yang_name = "service-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "service-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                            class ServiceNameRegex(Entity):
                                                                                                """
                                                                                                Service Name Regular Exp
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                    self.yang_name = "service-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "service-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                            class SrcAddrIpv4(Entity):
                                                                                                """
                                                                                                Source Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class DstAddrIpv4(Entity):
                                                                                                """
                                                                                                Destination Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class SrcAddrIpv6(Entity):
                                                                                                """
                                                                                                Source Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class DstAddrIpv6(Entity):
                                                                                                """
                                                                                                Destination Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class SrcAddrMac(Entity):
                                                                                                """
                                                                                                Source Address MAC
                                                                                                
                                                                                                .. attribute:: mac_addr_array
                                                                                                
                                                                                                	mac addr array
                                                                                                	**type**\: list of  		 :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                    self.yang_name = "src-addr-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("mac-addr-array", ("mac_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.mac_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                                class MacAddrArray(Entity):
                                                                                                    """
                                                                                                    mac addr array
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                        self.yang_name = "mac-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                            ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.mac_addr = []
                                                                                                        self.mask = []
                                                                                                        self._segment_path = lambda: "mac-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                            class Timer(Entity):
                                                                                                """
                                                                                                Timer
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                    self.yang_name = "timer"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "timer"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                            class TimerRegexp(Entity):
                                                                                                """
                                                                                                Timer Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                    self.yang_name = "timer-regexp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "timer-regexp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                            class TunnelName(Entity):
                                                                                                """
                                                                                                Tunnel Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                    self.yang_name = "tunnel-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "tunnel-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                            class TunnelNameRegex(Entity):
                                                                                                """
                                                                                                Tunnel Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "tunnel-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                            class UserName(Entity):
                                                                                                """
                                                                                                User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                    self.yang_name = "user-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "user-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                            class UserNameRegex(Entity):
                                                                                                """
                                                                                                User Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                    self.yang_name = "user-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "user-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                            class AuthUsername(Entity):
                                                                                                """
                                                                                                Authenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                    self.yang_name = "auth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-username"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                            class AuthUsernameRegex(Entity):
                                                                                                """
                                                                                                Authenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "auth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-username-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                            class UnauthUsername(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                    self.yang_name = "unauth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-username"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                            class UnauthUsernameRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-username-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                            class AuthDomain(Entity):
                                                                                                """
                                                                                                Authenticated domain name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                    self.yang_name = "auth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                            class AuthDomainRegex(Entity):
                                                                                                """
                                                                                                Authenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "auth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                            class UnauthDomain(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                    self.yang_name = "unauth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                            class UnauthDomainRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                            class VendorId(Entity):
                                                                                                """
                                                                                                Vendor ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                    self.yang_name = "vendor-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "vendor-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                            class VendorIdRegex(Entity):
                                                                                                """
                                                                                                Vendor ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                    self.yang_name = "vendor-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "vendor-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                            class AccessInterface(Entity):
                                                                                                """
                                                                                                Access interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                    self.yang_name = "access-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "access-interface"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                            class InputInterface(Entity):
                                                                                                """
                                                                                                Input interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                    self.yang_name = "input-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "input-interface"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                            class InputIntfhdl(Entity):
                                                                                                """
                                                                                                Input interface handle
                                                                                                
                                                                                                .. attribute:: uint64_array
                                                                                                
                                                                                                	uint64 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..18446744073709551615
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                    self.yang_name = "input-intfhdl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint64_array', (YLeafList(YType.uint64, 'uint64_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint64_array = []
                                                                                                    self._segment_path = lambda: "input-intfhdl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                            class Ethertype(Entity):
                                                                                                """
                                                                                                Ethernet type
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                    self.yang_name = "ethertype"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ethertype"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ethertype"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FlowKeyData(Entity):
                                                                                                """
                                                                                                Flow key structure
                                                                                                
                                                                                                .. attribute:: flow_keys
                                                                                                
                                                                                                	flow keys
                                                                                                	**type**\:  :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                                
                                                                                                .. attribute:: max_count
                                                                                                
                                                                                                	Maximum count of flows
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: idle_timeout
                                                                                                
                                                                                                	Idle timeout of flows (in seconds)
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                	**units**\: second
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                    self.yang_name = "flow-key-data"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("flow-keys", ("flow_keys", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys))])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('max_count', (YLeaf(YType.uint16, 'max-count'), ['int'])),
                                                                                                        ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                                                    ])
                                                                                                    self.max_count = None
                                                                                                    self.idle_timeout = None

                                                                                                    self.flow_keys = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                    self.flow_keys.parent = self
                                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                    self._segment_path = lambda: "flow-key-data"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['max_count', 'idle_timeout'], name, value)


                                                                                                class FlowKeys(Entity):
                                                                                                    """
                                                                                                    flow keys
                                                                                                    
                                                                                                    .. attribute:: keys
                                                                                                    
                                                                                                    	keys
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                    
                                                                                                    .. attribute:: num
                                                                                                    
                                                                                                    	num
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                        self.yang_name = "flow-keys"
                                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('keys', (YLeaf(YType.str, 'keys'), ['str'])),
                                                                                                            ('num', (YLeaf(YType.uint8, 'num'), ['int'])),
                                                                                                        ])
                                                                                                        self.keys = None
                                                                                                        self.num = None
                                                                                                        self._segment_path = lambda: "flow-keys"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                            class DhcpClientId(Entity):
                                                                                                """
                                                                                                Dhcp Client ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dhcp-client-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                            class DhcpClientIdRegex(Entity):
                                                                                                """
                                                                                                Dhcp Client ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                            class CircuitId(Entity):
                                                                                                """
                                                                                                Circuit ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                    self.yang_name = "circuit-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "circuit-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                            class CircuitIdRegex(Entity):
                                                                                                """
                                                                                                Circuit ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                    self.yang_name = "circuit-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "circuit-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                            class RemoteId(Entity):
                                                                                                """
                                                                                                Remote ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                    self.yang_name = "remote-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "remote-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                            class RemoteIdRegex(Entity):
                                                                                                """
                                                                                                Remote ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                    self.yang_name = "remote-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "remote-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                            class SrcPort(Entity):
                                                                                                """
                                                                                                Source port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                    self.yang_name = "src-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "src-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class DstPort(Entity):
                                                                                                """
                                                                                                Destination port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                    self.yang_name = "dst-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "dst-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                        class ConfclassP(Entity):
                                                                            """
                                                                            confclass p
                                                                            
                                                                            .. attribute:: class_map_bg
                                                                            
                                                                            	class map bg
                                                                            	**type**\: list of  		 :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP, self).__init__()

                                                                                self.yang_name = "confclass-p"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("class-map-bg", ("class_map_bg", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg))])
                                                                                self._leafs = OrderedDict()

                                                                                self.class_map_bg = YList(self)
                                                                                self._segment_path = lambda: "confclass-p"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP, [], name, value)


                                                                            class ClassMapBg(Entity):
                                                                                """
                                                                                class map bg
                                                                                
                                                                                .. attribute:: match_infop
                                                                                
                                                                                	Pointer to the first Match info
                                                                                	**type**\:  :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop>`
                                                                                
                                                                                .. attribute:: name
                                                                                
                                                                                	Name of the class\-map
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..65
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Class\-Map Type QoS/PBR/Netflow/..
                                                                                	**type**\:  :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                                                
                                                                                .. attribute:: mode
                                                                                
                                                                                	Class\-Map Mode Match any/Match all
                                                                                	**type**\:  :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                                
                                                                                .. attribute:: description
                                                                                
                                                                                	description
                                                                                	**type**\: str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg, self).__init__()

                                                                                    self.yang_name = "class-map-bg"
                                                                                    self.yang_parent_name = "confclass-p"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("match-infop", ("match_infop", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapTypeEn', '')])),
                                                                                        ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapModeEn', '')])),
                                                                                        ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                    ])
                                                                                    self.name = None
                                                                                    self.type = None
                                                                                    self.mode = None
                                                                                    self.description = None

                                                                                    self.match_infop = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop()
                                                                                    self.match_infop.parent = self
                                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                                    self._segment_path = lambda: "class-map-bg"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg, ['name', 'type', 'mode', 'description'], name, value)


                                                                                class MatchInfop(Entity):
                                                                                    """
                                                                                    Pointer to the first Match info
                                                                                    
                                                                                    .. attribute:: class_match_info_st
                                                                                    
                                                                                    	class match info st
                                                                                    	**type**\: list of  		 :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop, self).__init__()

                                                                                        self.yang_name = "match-infop"
                                                                                        self.yang_parent_name = "class-map-bg"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("class-match-info-st", ("class_match_info_st", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.class_match_info_st = YList(self)
                                                                                        self._segment_path = lambda: "match-infop"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop, [], name, value)


                                                                                    class ClassMatchInfoSt(Entity):
                                                                                        """
                                                                                        class match info st
                                                                                        
                                                                                        .. attribute:: match_data
                                                                                        
                                                                                        	Match criteria
                                                                                        	**type**\:  :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                        
                                                                                        .. attribute:: flags
                                                                                        
                                                                                        	Flags
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                            self.yang_name = "class-match-info-st"
                                                                                            self.yang_parent_name = "match-infop"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("match-data", ("match_data", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData))])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                            ])
                                                                                            self.flags = None

                                                                                            self.match_data = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                            self.match_data.parent = self
                                                                                            self._children_name_map["match_data"] = "match-data"
                                                                                            self._segment_path = lambda: "class-match-info-st"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                        class MatchData(Entity):
                                                                                            """
                                                                                            Match criteria
                                                                                            
                                                                                            .. attribute:: ipv4_dscp
                                                                                            
                                                                                            	IPv4 DSCP
                                                                                            	**type**\:  :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv6_dscp
                                                                                            
                                                                                            	IPv6 DSCP
                                                                                            	**type**\:  :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                            
                                                                                            .. attribute:: dscp
                                                                                            
                                                                                            	Match DSCP range array
                                                                                            	**type**\:  :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv4_prec
                                                                                            
                                                                                            	IPv4 Precedence
                                                                                            	**type**\:  :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                            
                                                                                            .. attribute:: ipv6_prec
                                                                                            
                                                                                            	IPv6 Precedence
                                                                                            	**type**\:  :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                            
                                                                                            .. attribute:: prec
                                                                                            
                                                                                            	Match Precedence array
                                                                                            	**type**\:  :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                            
                                                                                            .. attribute:: discard_class
                                                                                            
                                                                                            	Match Discard Class array
                                                                                            	**type**\:  :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                            
                                                                                            .. attribute:: qos_group
                                                                                            
                                                                                            	Match QoS group array
                                                                                            	**type**\:  :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                            
                                                                                            .. attribute:: traffic_class
                                                                                            
                                                                                            	Match Traffic class array
                                                                                            	**type**\:  :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                            
                                                                                            .. attribute:: proto
                                                                                            
                                                                                            	Match Protocol array
                                                                                            	**type**\:  :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                            
                                                                                            .. attribute:: icmp_v4
                                                                                            
                                                                                            	Match ICMPV4 Protocol
                                                                                            	**type**\:  :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                            
                                                                                            .. attribute:: icmp_v6
                                                                                            
                                                                                            	Match ICMPV6 Protocol array
                                                                                            	**type**\:  :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                            
                                                                                            .. attribute:: ipv4_packet_len
                                                                                            
                                                                                            	IPv4 packet length array
                                                                                            	**type**\:  :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv6_packet_len
                                                                                            
                                                                                            	IPv6 packet length array
                                                                                            	**type**\:  :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                            
                                                                                            .. attribute:: packet_len
                                                                                            
                                                                                            	Match packet length array
                                                                                            	**type**\:  :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                            
                                                                                            .. attribute:: flow_tag
                                                                                            
                                                                                            	Match flow\-tag array
                                                                                            	**type**\:  :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                            
                                                                                            .. attribute:: tcp_flag
                                                                                            
                                                                                            	Match tcp flag value
                                                                                            	**type**\:  :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                            
                                                                                            .. attribute:: icmpv4_type
                                                                                            
                                                                                            	Match ipv4 icmp type
                                                                                            	**type**\:  :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                            
                                                                                            .. attribute:: icmpv4_code
                                                                                            
                                                                                            	Match ipv4 icmp code
                                                                                            	**type**\:  :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                            
                                                                                            .. attribute:: icmpv6_type
                                                                                            
                                                                                            	Match ipv6 icmp type
                                                                                            	**type**\:  :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                            
                                                                                            .. attribute:: icmpv6_code
                                                                                            
                                                                                            	Match ipv6 icmp code
                                                                                            	**type**\:  :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                            
                                                                                            .. attribute:: mpls_exp
                                                                                            
                                                                                            	Match MPLS experimental topmost array
                                                                                            	**type**\:  :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                            
                                                                                            .. attribute:: mpls_exp_imp
                                                                                            
                                                                                            	Match MPLS experimental imposition array
                                                                                            	**type**\:  :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                                            
                                                                                            	MPLS Disposition IPv4 Access\-list
                                                                                            	**type**\:  :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                                            
                                                                                            	MPLS Disposition IPv6 Access\-list
                                                                                            	**type**\:  :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_top_label
                                                                                            
                                                                                            	MPLS Topmost LABEL
                                                                                            	**type**\:  :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                            
                                                                                            .. attribute:: cos
                                                                                            
                                                                                            	Match CoS array
                                                                                            	**type**\:  :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                            
                                                                                            .. attribute:: cos_inr
                                                                                            
                                                                                            	Match inner header CoS
                                                                                            	**type**\:  :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                            
                                                                                            .. attribute:: dei
                                                                                            
                                                                                            	Match DEI Bit
                                                                                            	**type**\:  :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                            
                                                                                            .. attribute:: dei_inr
                                                                                            
                                                                                            	Match inner DEI Bit
                                                                                            	**type**\:  :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                            
                                                                                            .. attribute:: vlan
                                                                                            
                                                                                            	Match VLAN array
                                                                                            	**type**\:  :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                            
                                                                                            .. attribute:: vlan_inr
                                                                                            
                                                                                            	Match inner header VLAN range array
                                                                                            	**type**\:  :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                            
                                                                                            .. attribute:: fr_dlci
                                                                                            
                                                                                            	Match FR DLCI range array
                                                                                            	**type**\:  :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                            
                                                                                            .. attribute:: src_mac
                                                                                            
                                                                                            	Match Source MAC address
                                                                                            	**type**\:  :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                            
                                                                                            .. attribute:: dst_mac
                                                                                            
                                                                                            	Match Destination MAC address
                                                                                            	**type**\:  :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                            
                                                                                            .. attribute:: atm_clp
                                                                                            
                                                                                            	Match ATM CLP level
                                                                                            	**type**\:  :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                            
                                                                                            .. attribute:: fr_de
                                                                                            
                                                                                            	Match FR DE value
                                                                                            	**type**\:  :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                            
                                                                                            .. attribute:: ipv4_acl
                                                                                            
                                                                                            	IPv4 Access\-list
                                                                                            	**type**\:  :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                            
                                                                                            .. attribute:: ipv6_acl
                                                                                            
                                                                                            	IPv6 Access\-list
                                                                                            	**type**\:  :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                            
                                                                                            .. attribute:: ether_service_acl
                                                                                            
                                                                                            	Ethernet\-Services Access\-list
                                                                                            	**type**\:  :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                            
                                                                                            .. attribute:: avail_id
                                                                                            
                                                                                            	Available Identifiers
                                                                                            	**type**\:  :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                            
                                                                                            .. attribute:: media_type
                                                                                            
                                                                                            	Media Type
                                                                                            	**type**\:  :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                            
                                                                                            .. attribute:: subs_protocol
                                                                                            
                                                                                            	Protocol
                                                                                            	**type**\:  :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                            
                                                                                            .. attribute:: dnis
                                                                                            
                                                                                            	DNIS
                                                                                            	**type**\:  :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                            
                                                                                            .. attribute:: dnis_regex
                                                                                            
                                                                                            	DNIS Regular Expression
                                                                                            	**type**\:  :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                            
                                                                                            .. attribute:: domain
                                                                                            
                                                                                            	Domain Name
                                                                                            	**type**\:  :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                            
                                                                                            .. attribute:: domain_regex
                                                                                            
                                                                                            	Domain Regular Expression
                                                                                            	**type**\:  :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                            
                                                                                            .. attribute:: nas_port
                                                                                            
                                                                                            	NAS Port
                                                                                            	**type**\:  :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                            
                                                                                            .. attribute:: service_name
                                                                                            
                                                                                            	Service Name
                                                                                            	**type**\:  :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                            
                                                                                            .. attribute:: service_name_regex
                                                                                            
                                                                                            	Service Name Regular Exp
                                                                                            	**type**\:  :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv4
                                                                                            
                                                                                            	Source Address IPV4
                                                                                            	**type**\:  :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv4
                                                                                            
                                                                                            	Destination Address IPV4
                                                                                            	**type**\:  :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv6
                                                                                            
                                                                                            	Source Address IPV6
                                                                                            	**type**\:  :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv6
                                                                                            
                                                                                            	Destination Address IPV6
                                                                                            	**type**\:  :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: src_addr_mac
                                                                                            
                                                                                            	Source Address MAC
                                                                                            	**type**\:  :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                            
                                                                                            .. attribute:: timer
                                                                                            
                                                                                            	Timer
                                                                                            	**type**\:  :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                            
                                                                                            .. attribute:: timer_regexp
                                                                                            
                                                                                            	Timer Regular Expression
                                                                                            	**type**\:  :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                            
                                                                                            .. attribute:: tunnel_name
                                                                                            
                                                                                            	Tunnel Name
                                                                                            	**type**\:  :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                            
                                                                                            .. attribute:: tunnel_name_regex
                                                                                            
                                                                                            	Tunnel Name Regular Expression
                                                                                            	**type**\:  :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                            
                                                                                            .. attribute:: user_name
                                                                                            
                                                                                            	User Name
                                                                                            	**type**\:  :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                            
                                                                                            .. attribute:: user_name_regex
                                                                                            
                                                                                            	User Name Regular Expression
                                                                                            	**type**\:  :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                            
                                                                                            .. attribute:: auth_username
                                                                                            
                                                                                            	Authenticated User Name
                                                                                            	**type**\:  :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                            
                                                                                            .. attribute:: auth_username_regex
                                                                                            
                                                                                            	Authenticated User Name RegEx
                                                                                            	**type**\:  :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_username
                                                                                            
                                                                                            	Unauthenticated User Name
                                                                                            	**type**\:  :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                            
                                                                                            .. attribute:: unauth_username_regex
                                                                                            
                                                                                            	Unauthenticated User Name RegEx
                                                                                            	**type**\:  :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: auth_domain
                                                                                            
                                                                                            	Authenticated domain name
                                                                                            	**type**\:  :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                            
                                                                                            .. attribute:: auth_domain_regex
                                                                                            
                                                                                            	Authenticated Domain Name RegEx
                                                                                            	**type**\:  :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_domain
                                                                                            
                                                                                            	Unauthenticated Domain Name
                                                                                            	**type**\:  :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                            
                                                                                            .. attribute:: unauth_domain_regex
                                                                                            
                                                                                            	Unauthenticated Domain Name RegEx
                                                                                            	**type**\:  :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: vendor_id
                                                                                            
                                                                                            	Vendor ID
                                                                                            	**type**\:  :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                            
                                                                                            .. attribute:: vendor_id_regex
                                                                                            
                                                                                            	Vendor ID RegEx
                                                                                            	**type**\:  :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                            
                                                                                            .. attribute:: access_interface
                                                                                            
                                                                                            	Access interface
                                                                                            	**type**\:  :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                            
                                                                                            .. attribute:: input_interface
                                                                                            
                                                                                            	Input interface
                                                                                            	**type**\:  :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                            
                                                                                            .. attribute:: input_intfhdl
                                                                                            
                                                                                            	Input interface handle
                                                                                            	**type**\:  :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                            
                                                                                            .. attribute:: ethertype
                                                                                            
                                                                                            	Ethernet type
                                                                                            	**type**\:  :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                            
                                                                                            .. attribute:: flow_key_data
                                                                                            
                                                                                            	Flow key structure
                                                                                            	**type**\:  :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id
                                                                                            
                                                                                            	Dhcp Client ID
                                                                                            	**type**\:  :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id_regex
                                                                                            
                                                                                            	Dhcp Client ID RegEx
                                                                                            	**type**\:  :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                            
                                                                                            .. attribute:: circuit_id
                                                                                            
                                                                                            	Circuit ID
                                                                                            	**type**\:  :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                            
                                                                                            .. attribute:: circuit_id_regex
                                                                                            
                                                                                            	Circuit ID RegEx
                                                                                            	**type**\:  :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                            
                                                                                            .. attribute:: remote_id
                                                                                            
                                                                                            	Remote ID
                                                                                            	**type**\:  :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                            
                                                                                            .. attribute:: remote_id_regex
                                                                                            
                                                                                            	Remote ID RegEx
                                                                                            	**type**\:  :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                            
                                                                                            .. attribute:: src_port
                                                                                            
                                                                                            	Source port
                                                                                            	**type**\:  :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                            
                                                                                            .. attribute:: dst_port
                                                                                            
                                                                                            	Destination port
                                                                                            	**type**\:  :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	type
                                                                                            	**type**\:  :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                            
                                                                                            .. attribute:: mpls_top_eos
                                                                                            
                                                                                            	MPLS Topmost EOS
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: fragment_type
                                                                                            
                                                                                            	Fragment type
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: authen_status
                                                                                            
                                                                                            	Authentication Status
                                                                                            	**type**\:  :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                            
                                                                                            .. attribute:: mlp_negotiated
                                                                                            
                                                                                            	MLP Negotiated
                                                                                            	**type**\:  :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                                self.yang_name = "match-data"
                                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("ipv4-dscp", ("ipv4_dscp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp)), ("ipv6-dscp", ("ipv6_dscp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp)), ("dscp", ("dscp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp)), ("ipv4-prec", ("ipv4_prec", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec)), ("ipv6-prec", ("ipv6_prec", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec)), ("prec", ("prec", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec)), ("discard-class", ("discard_class", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass)), ("qos-group", ("qos_group", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup)), ("traffic-class", ("traffic_class", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass)), ("proto", ("proto", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto)), ("icmp-v4", ("icmp_v4", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4)), ("icmp-v6", ("icmp_v6", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6)), ("ipv4-packet-len", ("ipv4_packet_len", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen)), ("ipv6-packet-len", ("ipv6_packet_len", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen)), ("packet-len", ("packet_len", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen)), ("flow-tag", ("flow_tag", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag)), ("tcp-flag", ("tcp_flag", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag)), ("icmpv4-type", ("icmpv4_type", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type)), ("icmpv4-code", ("icmpv4_code", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code)), ("icmpv6-type", ("icmpv6_type", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type)), ("icmpv6-code", ("icmpv6_code", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code)), ("mpls-exp", ("mpls_exp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp)), ("mpls-exp-imp", ("mpls_exp_imp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp)), ("mpls-disp-ipv4-acl", ("mpls_disp_ipv4_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl)), ("mpls-disp-ipv6-acl", ("mpls_disp_ipv6_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl)), ("mpls-top-label", ("mpls_top_label", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel)), ("cos", ("cos", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos)), ("cos-inr", ("cos_inr", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr)), ("dei", ("dei", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei)), ("dei-inr", ("dei_inr", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr)), ("vlan", ("vlan", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan)), ("vlan-inr", ("vlan_inr", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)), ("fr-dlci", ("fr_dlci", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci)), ("src-mac", ("src_mac", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac)), ("dst-mac", ("dst_mac", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac)), ("atm-clp", ("atm_clp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp)), ("fr-de", ("fr_de", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe)), ("ipv4-acl", ("ipv4_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl)), ("ipv6-acl", ("ipv6_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl)), ("ether-service-acl", ("ether_service_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl)), ("avail-id", ("avail_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId)), ("media-type", ("media_type", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType)), ("subs-protocol", ("subs_protocol", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol)), ("dnis", ("dnis", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis)), ("dnis-regex", ("dnis_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex)), ("domain", ("domain", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain)), ("domain-regex", ("domain_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex)), ("nas-port", ("nas_port", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort)), ("service-name", ("service_name", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName)), ("service-name-regex", ("service_name_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex)), ("src-addr-ipv4", ("src_addr_ipv4", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4)), ("dst-addr-ipv4", ("dst_addr_ipv4", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4)), ("src-addr-ipv6", ("src_addr_ipv6", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6)), ("dst-addr-ipv6", ("dst_addr_ipv6", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6)), ("src-addr-mac", ("src_addr_mac", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac)), ("timer", ("timer", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer)), ("timer-regexp", ("timer_regexp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp)), ("tunnel-name", ("tunnel_name", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName)), ("tunnel-name-regex", ("tunnel_name_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex)), ("user-name", ("user_name", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName)), ("user-name-regex", ("user_name_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex)), ("auth-username", ("auth_username", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername)), ("auth-username-regex", ("auth_username_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex)), ("unauth-username", ("unauth_username", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername)), ("unauth-username-regex", ("unauth_username_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex)), ("auth-domain", ("auth_domain", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain)), ("auth-domain-regex", ("auth_domain_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex)), ("unauth-domain", ("unauth_domain", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain)), ("unauth-domain-regex", ("unauth_domain_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex)), ("vendor-id", ("vendor_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId)), ("vendor-id-regex", ("vendor_id_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex)), ("access-interface", ("access_interface", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface)), ("input-interface", ("input_interface", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface)), ("input-intfhdl", ("input_intfhdl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl)), ("ethertype", ("ethertype", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype)), ("flow-key-data", ("flow_key_data", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData)), ("dhcp-client-id", ("dhcp_client_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId)), ("dhcp-client-id-regex", ("dhcp_client_id_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex)), ("circuit-id", ("circuit_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId)), ("circuit-id-regex", ("circuit_id_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex)), ("remote-id", ("remote_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId)), ("remote-id-regex", ("remote_id_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex)), ("src-port", ("src_port", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort)), ("dst-port", ("dst_port", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort))])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchTypeEn', '')])),
                                                                                                    ('mpls_top_eos', (YLeaf(YType.uint8, 'mpls-top-eos'), ['int'])),
                                                                                                    ('fragment_type', (YLeaf(YType.uint8, 'fragment-type'), ['int'])),
                                                                                                    ('authen_status', (YLeaf(YType.enumeration, 'authen-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchAuthenStatusEn', '')])),
                                                                                                    ('mlp_negotiated', (YLeaf(YType.enumeration, 'mlp-negotiated'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchMlpNegotiatedEn', '')])),
                                                                                                ])
                                                                                                self.type = None
                                                                                                self.mpls_top_eos = None
                                                                                                self.fragment_type = None
                                                                                                self.authen_status = None
                                                                                                self.mlp_negotiated = None

                                                                                                self.ipv4_dscp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                                self.ipv4_dscp.parent = self
                                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"

                                                                                                self.ipv6_dscp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                                self.ipv6_dscp.parent = self
                                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"

                                                                                                self.dscp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                                self.dscp.parent = self
                                                                                                self._children_name_map["dscp"] = "dscp"

                                                                                                self.ipv4_prec = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                                self.ipv4_prec.parent = self
                                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"

                                                                                                self.ipv6_prec = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                                self.ipv6_prec.parent = self
                                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"

                                                                                                self.prec = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                                self.prec.parent = self
                                                                                                self._children_name_map["prec"] = "prec"

                                                                                                self.discard_class = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                                self.discard_class.parent = self
                                                                                                self._children_name_map["discard_class"] = "discard-class"

                                                                                                self.qos_group = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                                self.qos_group.parent = self
                                                                                                self._children_name_map["qos_group"] = "qos-group"

                                                                                                self.traffic_class = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                                self.traffic_class.parent = self
                                                                                                self._children_name_map["traffic_class"] = "traffic-class"

                                                                                                self.proto = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                                self.proto.parent = self
                                                                                                self._children_name_map["proto"] = "proto"

                                                                                                self.icmp_v4 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                                self.icmp_v4.parent = self
                                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"

                                                                                                self.icmp_v6 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                                self.icmp_v6.parent = self
                                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"

                                                                                                self.ipv4_packet_len = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                                self.ipv4_packet_len.parent = self
                                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"

                                                                                                self.ipv6_packet_len = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                                self.ipv6_packet_len.parent = self
                                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"

                                                                                                self.packet_len = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                                self.packet_len.parent = self
                                                                                                self._children_name_map["packet_len"] = "packet-len"

                                                                                                self.flow_tag = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                                self.flow_tag.parent = self
                                                                                                self._children_name_map["flow_tag"] = "flow-tag"

                                                                                                self.tcp_flag = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                                self.tcp_flag.parent = self
                                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"

                                                                                                self.icmpv4_type = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                                self.icmpv4_type.parent = self
                                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"

                                                                                                self.icmpv4_code = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                                self.icmpv4_code.parent = self
                                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"

                                                                                                self.icmpv6_type = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                                self.icmpv6_type.parent = self
                                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"

                                                                                                self.icmpv6_code = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                                self.icmpv6_code.parent = self
                                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"

                                                                                                self.mpls_exp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                                self.mpls_exp.parent = self
                                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"

                                                                                                self.mpls_exp_imp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                                self.mpls_exp_imp.parent = self
                                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"

                                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"

                                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"

                                                                                                self.mpls_top_label = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                                self.mpls_top_label.parent = self
                                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"

                                                                                                self.cos = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                                self.cos.parent = self
                                                                                                self._children_name_map["cos"] = "cos"

                                                                                                self.cos_inr = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                                self.cos_inr.parent = self
                                                                                                self._children_name_map["cos_inr"] = "cos-inr"

                                                                                                self.dei = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                                self.dei.parent = self
                                                                                                self._children_name_map["dei"] = "dei"

                                                                                                self.dei_inr = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                                self.dei_inr.parent = self
                                                                                                self._children_name_map["dei_inr"] = "dei-inr"

                                                                                                self.vlan = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                                self.vlan.parent = self
                                                                                                self._children_name_map["vlan"] = "vlan"

                                                                                                self.vlan_inr = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                                self.vlan_inr.parent = self
                                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"

                                                                                                self.fr_dlci = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                                self.fr_dlci.parent = self
                                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"

                                                                                                self.src_mac = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                                self.src_mac.parent = self
                                                                                                self._children_name_map["src_mac"] = "src-mac"

                                                                                                self.dst_mac = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                                self.dst_mac.parent = self
                                                                                                self._children_name_map["dst_mac"] = "dst-mac"

                                                                                                self.atm_clp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                                self.atm_clp.parent = self
                                                                                                self._children_name_map["atm_clp"] = "atm-clp"

                                                                                                self.fr_de = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                                self.fr_de.parent = self
                                                                                                self._children_name_map["fr_de"] = "fr-de"

                                                                                                self.ipv4_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                                self.ipv4_acl.parent = self
                                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"

                                                                                                self.ipv6_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                                self.ipv6_acl.parent = self
                                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"

                                                                                                self.ether_service_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                                self.ether_service_acl.parent = self
                                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"

                                                                                                self.avail_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                                self.avail_id.parent = self
                                                                                                self._children_name_map["avail_id"] = "avail-id"

                                                                                                self.media_type = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                                self.media_type.parent = self
                                                                                                self._children_name_map["media_type"] = "media-type"

                                                                                                self.subs_protocol = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                                self.subs_protocol.parent = self
                                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"

                                                                                                self.dnis = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                                self.dnis.parent = self
                                                                                                self._children_name_map["dnis"] = "dnis"

                                                                                                self.dnis_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                                self.dnis_regex.parent = self
                                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"

                                                                                                self.domain = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                                self.domain.parent = self
                                                                                                self._children_name_map["domain"] = "domain"

                                                                                                self.domain_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                                self.domain_regex.parent = self
                                                                                                self._children_name_map["domain_regex"] = "domain-regex"

                                                                                                self.nas_port = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                                self.nas_port.parent = self
                                                                                                self._children_name_map["nas_port"] = "nas-port"

                                                                                                self.service_name = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                                self.service_name.parent = self
                                                                                                self._children_name_map["service_name"] = "service-name"

                                                                                                self.service_name_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                                self.service_name_regex.parent = self
                                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"

                                                                                                self.src_addr_ipv4 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                                self.src_addr_ipv4.parent = self
                                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"

                                                                                                self.dst_addr_ipv4 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                                self.dst_addr_ipv4.parent = self
                                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"

                                                                                                self.src_addr_ipv6 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                                self.src_addr_ipv6.parent = self
                                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"

                                                                                                self.dst_addr_ipv6 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                                self.dst_addr_ipv6.parent = self
                                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"

                                                                                                self.src_addr_mac = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                                self.src_addr_mac.parent = self
                                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"

                                                                                                self.timer = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                                self.timer.parent = self
                                                                                                self._children_name_map["timer"] = "timer"

                                                                                                self.timer_regexp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                                self.timer_regexp.parent = self
                                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"

                                                                                                self.tunnel_name = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                                self.tunnel_name.parent = self
                                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"

                                                                                                self.tunnel_name_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                                self.tunnel_name_regex.parent = self
                                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"

                                                                                                self.user_name = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                                self.user_name.parent = self
                                                                                                self._children_name_map["user_name"] = "user-name"

                                                                                                self.user_name_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                                self.user_name_regex.parent = self
                                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"

                                                                                                self.auth_username = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                                self.auth_username.parent = self
                                                                                                self._children_name_map["auth_username"] = "auth-username"

                                                                                                self.auth_username_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                                self.auth_username_regex.parent = self
                                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"

                                                                                                self.unauth_username = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                                self.unauth_username.parent = self
                                                                                                self._children_name_map["unauth_username"] = "unauth-username"

                                                                                                self.unauth_username_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                                self.unauth_username_regex.parent = self
                                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"

                                                                                                self.auth_domain = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                                self.auth_domain.parent = self
                                                                                                self._children_name_map["auth_domain"] = "auth-domain"

                                                                                                self.auth_domain_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                                self.auth_domain_regex.parent = self
                                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"

                                                                                                self.unauth_domain = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                                self.unauth_domain.parent = self
                                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"

                                                                                                self.unauth_domain_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                                self.unauth_domain_regex.parent = self
                                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"

                                                                                                self.vendor_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                                self.vendor_id.parent = self
                                                                                                self._children_name_map["vendor_id"] = "vendor-id"

                                                                                                self.vendor_id_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                                self.vendor_id_regex.parent = self
                                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"

                                                                                                self.access_interface = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                                self.access_interface.parent = self
                                                                                                self._children_name_map["access_interface"] = "access-interface"

                                                                                                self.input_interface = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                                self.input_interface.parent = self
                                                                                                self._children_name_map["input_interface"] = "input-interface"

                                                                                                self.input_intfhdl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                                self.input_intfhdl.parent = self
                                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"

                                                                                                self.ethertype = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                                self.ethertype.parent = self
                                                                                                self._children_name_map["ethertype"] = "ethertype"

                                                                                                self.flow_key_data = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                                self.flow_key_data.parent = self
                                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"

                                                                                                self.dhcp_client_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                                self.dhcp_client_id.parent = self
                                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"

                                                                                                self.dhcp_client_id_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                                self.dhcp_client_id_regex.parent = self
                                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"

                                                                                                self.circuit_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                                self.circuit_id.parent = self
                                                                                                self._children_name_map["circuit_id"] = "circuit-id"

                                                                                                self.circuit_id_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                                self.circuit_id_regex.parent = self
                                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"

                                                                                                self.remote_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                                self.remote_id.parent = self
                                                                                                self._children_name_map["remote_id"] = "remote-id"

                                                                                                self.remote_id_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                                self.remote_id_regex.parent = self
                                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"

                                                                                                self.src_port = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                                self.src_port.parent = self
                                                                                                self._children_name_map["src_port"] = "src-port"

                                                                                                self.dst_port = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                                self.dst_port.parent = self
                                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                                self._segment_path = lambda: "match-data"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['type', 'mpls_top_eos', 'fragment_type', 'authen_status', 'mlp_negotiated'], name, value)


                                                                                            class Ipv4Dscp(Entity):
                                                                                                """
                                                                                                IPv4 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv4-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv6Dscp(Entity):
                                                                                                """
                                                                                                IPv6 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv6-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Dscp(Entity):
                                                                                                """
                                                                                                Match DSCP range array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                    self.yang_name = "dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv4Prec(Entity):
                                                                                                """
                                                                                                IPv4 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                    self.yang_name = "ipv4-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "ipv4-prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                            class Ipv6Prec(Entity):
                                                                                                """
                                                                                                IPv6 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                    self.yang_name = "ipv6-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "ipv6-prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                            class Prec(Entity):
                                                                                                """
                                                                                                Match Precedence array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                    self.yang_name = "prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                            class DiscardClass(Entity):
                                                                                                """
                                                                                                Match Discard Class array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                    self.yang_name = "discard-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "discard-class"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                            class QosGroup(Entity):
                                                                                                """
                                                                                                Match QoS group array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                    self.yang_name = "qos-group"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "qos-group"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "qos-group"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class TrafficClass(Entity):
                                                                                                """
                                                                                                Match Traffic class array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                    self.yang_name = "traffic-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "traffic-class"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "traffic-class"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Proto(Entity):
                                                                                                """
                                                                                                Match Protocol array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                    self.yang_name = "proto"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "proto"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "proto"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class IcmpV4(Entity):
                                                                                                """
                                                                                                Match ICMPV4 Protocol
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                    self.yang_name = "icmp-v4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                    ])
                                                                                                    self.type = None
                                                                                                    self.code = None
                                                                                                    self._segment_path = lambda: "icmp-v4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['type', 'code'], name, value)


                                                                                            class IcmpV6(Entity):
                                                                                                """
                                                                                                Match ICMPV6 Protocol array
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                    self.yang_name = "icmp-v6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                    ])
                                                                                                    self.type = None
                                                                                                    self.code = None
                                                                                                    self._segment_path = lambda: "icmp-v6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['type', 'code'], name, value)


                                                                                            class Ipv4PacketLen(Entity):
                                                                                                """
                                                                                                IPv4 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv6PacketLen(Entity):
                                                                                                """
                                                                                                IPv6 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class PacketLen(Entity):
                                                                                                """
                                                                                                Match packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                    self.yang_name = "packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FlowTag(Entity):
                                                                                                """
                                                                                                Match flow\-tag array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                    self.yang_name = "flow-tag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "flow-tag"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "flow-tag"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class TcpFlag(Entity):
                                                                                                """
                                                                                                Match tcp flag value
                                                                                                
                                                                                                .. attribute:: value
                                                                                                
                                                                                                	Value of TCP flag
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: match_any
                                                                                                
                                                                                                	Match any TCP flag bit
                                                                                                	**type**\: bool
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                    self.yang_name = "tcp-flag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                                        ('match_any', (YLeaf(YType.boolean, 'match-any'), ['bool'])),
                                                                                                    ])
                                                                                                    self.value = None
                                                                                                    self.match_any = None
                                                                                                    self._segment_path = lambda: "tcp-flag"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['value', 'match_any'], name, value)


                                                                                            class Icmpv4Type(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                    self.yang_name = "icmpv4-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv4Code(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                    self.yang_name = "icmpv4-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-code"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv6Type(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                    self.yang_name = "icmpv6-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv6Code(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                    self.yang_name = "icmpv6-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-code"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class MplsExp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental topmost array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "mpls-exp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                            class MplsExpImp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental imposition array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "mpls-exp-imp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                            class MplsDispIpv4Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                            class MplsDispIpv6Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                            class MplsTopLabel(Entity):
                                                                                                """
                                                                                                MPLS Topmost LABEL
                                                                                                
                                                                                                .. attribute:: uint32_rng_array
                                                                                                
                                                                                                	uint32 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                    self.yang_name = "mpls-top-label"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint32_rng_array", ("uint32_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint32_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "mpls-top-label"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                                class Uint32RngArray(Entity):
                                                                                                    """
                                                                                                    uint32 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                        self.yang_name = "uint32_rng_array"
                                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint32, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint32, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint32_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['min', 'max'], name, value)


                                                                                            class Cos(Entity):
                                                                                                """
                                                                                                Match CoS array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                    self.yang_name = "cos"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "cos"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                            class CosInr(Entity):
                                                                                                """
                                                                                                Match inner header CoS
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                    self.yang_name = "cos-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "cos-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                            class Dei(Entity):
                                                                                                """
                                                                                                Match DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                    self.yang_name = "dei"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                    ])
                                                                                                    self.bit_value = None
                                                                                                    self._segment_path = lambda: "dei"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                            class DeiInr(Entity):
                                                                                                """
                                                                                                Match inner DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                    self.yang_name = "dei-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                    ])
                                                                                                    self.bit_value = None
                                                                                                    self._segment_path = lambda: "dei-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                            class Vlan(Entity):
                                                                                                """
                                                                                                Match VLAN array
                                                                                                
                                                                                                .. attribute:: vlan_id_array
                                                                                                
                                                                                                	vlan id array
                                                                                                	**type**\: list of  		 :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                    self.yang_name = "vlan"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("vlan-id-array", ("vlan_id_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.vlan_id_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                                class VlanIdArray(Entity):
                                                                                                    """
                                                                                                    vlan id array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	VLAN mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                        self.yang_name = "vlan-id-array"
                                                                                                        self.yang_parent_name = "vlan"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ('mask', (YLeaf(YType.uint16, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "vlan-id-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['min', 'max', 'mask'], name, value)


                                                                                            class VlanInr(Entity):
                                                                                                """
                                                                                                Match inner header VLAN range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                    self.yang_name = "vlan-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FrDlci(Entity):
                                                                                                """
                                                                                                Match FR DLCI range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                    self.yang_name = "fr-dlci"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "fr-dlci"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class SrcMac(Entity):
                                                                                                """
                                                                                                Match Source MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                    self.yang_name = "src-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.mac_addr = []
                                                                                                    self.mask = []
                                                                                                    self._segment_path = lambda: "src-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                            class DstMac(Entity):
                                                                                                """
                                                                                                Match Destination MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                    self.yang_name = "dst-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.mac_addr = []
                                                                                                    self.mask = []
                                                                                                    self._segment_path = lambda: "dst-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                            class AtmClp(Entity):
                                                                                                """
                                                                                                Match ATM CLP level
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                    self.yang_name = "atm-clp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "atm-clp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                            class FrDe(Entity):
                                                                                                """
                                                                                                Match FR DE value
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                    self.yang_name = "fr-de"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "fr-de"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                            class Ipv4Acl(Entity):
                                                                                                """
                                                                                                IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                    self.yang_name = "ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ipv4-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                            class Ipv6Acl(Entity):
                                                                                                """
                                                                                                IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                    self.yang_name = "ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ipv6-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                            class EtherServiceAcl(Entity):
                                                                                                """
                                                                                                Ethernet\-Services Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                    self.yang_name = "ether-service-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ether-service-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                            class AvailId(Entity):
                                                                                                """
                                                                                                Available Identifiers
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                    self.yang_name = "avail-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "avail-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                            class MediaType(Entity):
                                                                                                """
                                                                                                Media Type
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                    self.yang_name = "media-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "media-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                            class SubsProtocol(Entity):
                                                                                                """
                                                                                                Protocol
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                    self.yang_name = "subs-protocol"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "subs-protocol"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                            class Dnis(Entity):
                                                                                                """
                                                                                                DNIS
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                    self.yang_name = "dnis"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dnis"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                            class DnisRegex(Entity):
                                                                                                """
                                                                                                DNIS Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                    self.yang_name = "dnis-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dnis-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                            class Domain(Entity):
                                                                                                """
                                                                                                Domain Name
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                    self.yang_name = "domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                        ])
                                                                                                        self.domain_name = None
                                                                                                        self.format_name = None
                                                                                                        self._segment_path = lambda: "domain-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class DomainRegex(Entity):
                                                                                                """
                                                                                                Domain Regular Expression
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                    self.yang_name = "domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain-regex"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                        ])
                                                                                                        self.domain_name = None
                                                                                                        self.format_name = None
                                                                                                        self._segment_path = lambda: "domain-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class NasPort(Entity):
                                                                                                """
                                                                                                NAS Port
                                                                                                
                                                                                                .. attribute:: nas_port_array
                                                                                                
                                                                                                	nas port array
                                                                                                	**type**\: list of  		 :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                    self.yang_name = "nas-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("nas-port-array", ("nas_port_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.nas_port_array = YList(self)
                                                                                                    self._segment_path = lambda: "nas-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                                class NasPortArray(Entity):
                                                                                                    """
                                                                                                    nas port array
                                                                                                    
                                                                                                    .. attribute:: sub_id
                                                                                                    
                                                                                                    	sub id
                                                                                                    	**type**\:  :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                    
                                                                                                    .. attribute:: operator
                                                                                                    
                                                                                                    	operator
                                                                                                    	**type**\:  :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	value
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                        self.yang_name = "nas-port-array"
                                                                                                        self.yang_parent_name = "nas-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('sub_id', (YLeaf(YType.enumeration, 'sub-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchNasPortSubIdEn', '')])),
                                                                                                            ('operator', (YLeaf(YType.enumeration, 'operator'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchLogicalOperatorEn', '')])),
                                                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                                        ])
                                                                                                        self.sub_id = None
                                                                                                        self.operator = None
                                                                                                        self.value = None
                                                                                                        self._segment_path = lambda: "nas-port-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['sub_id', 'operator', 'value'], name, value)


                                                                                            class ServiceName(Entity):
                                                                                                """
                                                                                                Service Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                    self.yang_name = "service-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "service-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                            class ServiceNameRegex(Entity):
                                                                                                """
                                                                                                Service Name Regular Exp
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                    self.yang_name = "service-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "service-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                            class SrcAddrIpv4(Entity):
                                                                                                """
                                                                                                Source Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class DstAddrIpv4(Entity):
                                                                                                """
                                                                                                Destination Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class SrcAddrIpv6(Entity):
                                                                                                """
                                                                                                Source Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class DstAddrIpv6(Entity):
                                                                                                """
                                                                                                Destination Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class SrcAddrMac(Entity):
                                                                                                """
                                                                                                Source Address MAC
                                                                                                
                                                                                                .. attribute:: mac_addr_array
                                                                                                
                                                                                                	mac addr array
                                                                                                	**type**\: list of  		 :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                    self.yang_name = "src-addr-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("mac-addr-array", ("mac_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.mac_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                                class MacAddrArray(Entity):
                                                                                                    """
                                                                                                    mac addr array
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                        self.yang_name = "mac-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                            ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.mac_addr = []
                                                                                                        self.mask = []
                                                                                                        self._segment_path = lambda: "mac-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                            class Timer(Entity):
                                                                                                """
                                                                                                Timer
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                    self.yang_name = "timer"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "timer"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                            class TimerRegexp(Entity):
                                                                                                """
                                                                                                Timer Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                    self.yang_name = "timer-regexp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "timer-regexp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                            class TunnelName(Entity):
                                                                                                """
                                                                                                Tunnel Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                    self.yang_name = "tunnel-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "tunnel-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                            class TunnelNameRegex(Entity):
                                                                                                """
                                                                                                Tunnel Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "tunnel-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                            class UserName(Entity):
                                                                                                """
                                                                                                User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                    self.yang_name = "user-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "user-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                            class UserNameRegex(Entity):
                                                                                                """
                                                                                                User Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                    self.yang_name = "user-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "user-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                            class AuthUsername(Entity):
                                                                                                """
                                                                                                Authenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                    self.yang_name = "auth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-username"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                            class AuthUsernameRegex(Entity):
                                                                                                """
                                                                                                Authenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "auth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-username-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                            class UnauthUsername(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                    self.yang_name = "unauth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-username"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                            class UnauthUsernameRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-username-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                            class AuthDomain(Entity):
                                                                                                """
                                                                                                Authenticated domain name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                    self.yang_name = "auth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                            class AuthDomainRegex(Entity):
                                                                                                """
                                                                                                Authenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "auth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                            class UnauthDomain(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                    self.yang_name = "unauth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                            class UnauthDomainRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                            class VendorId(Entity):
                                                                                                """
                                                                                                Vendor ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                    self.yang_name = "vendor-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "vendor-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                            class VendorIdRegex(Entity):
                                                                                                """
                                                                                                Vendor ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                    self.yang_name = "vendor-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "vendor-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                            class AccessInterface(Entity):
                                                                                                """
                                                                                                Access interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                    self.yang_name = "access-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "access-interface"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                            class InputInterface(Entity):
                                                                                                """
                                                                                                Input interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                    self.yang_name = "input-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "input-interface"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                            class InputIntfhdl(Entity):
                                                                                                """
                                                                                                Input interface handle
                                                                                                
                                                                                                .. attribute:: uint64_array
                                                                                                
                                                                                                	uint64 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..18446744073709551615
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                    self.yang_name = "input-intfhdl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint64_array', (YLeafList(YType.uint64, 'uint64_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint64_array = []
                                                                                                    self._segment_path = lambda: "input-intfhdl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                            class Ethertype(Entity):
                                                                                                """
                                                                                                Ethernet type
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                    self.yang_name = "ethertype"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ethertype"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ethertype"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FlowKeyData(Entity):
                                                                                                """
                                                                                                Flow key structure
                                                                                                
                                                                                                .. attribute:: flow_keys
                                                                                                
                                                                                                	flow keys
                                                                                                	**type**\:  :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                                
                                                                                                .. attribute:: max_count
                                                                                                
                                                                                                	Maximum count of flows
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: idle_timeout
                                                                                                
                                                                                                	Idle timeout of flows (in seconds)
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                	**units**\: second
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                    self.yang_name = "flow-key-data"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("flow-keys", ("flow_keys", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys))])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('max_count', (YLeaf(YType.uint16, 'max-count'), ['int'])),
                                                                                                        ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                                                    ])
                                                                                                    self.max_count = None
                                                                                                    self.idle_timeout = None

                                                                                                    self.flow_keys = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                    self.flow_keys.parent = self
                                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                    self._segment_path = lambda: "flow-key-data"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['max_count', 'idle_timeout'], name, value)


                                                                                                class FlowKeys(Entity):
                                                                                                    """
                                                                                                    flow keys
                                                                                                    
                                                                                                    .. attribute:: keys
                                                                                                    
                                                                                                    	keys
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                    
                                                                                                    .. attribute:: num
                                                                                                    
                                                                                                    	num
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                        self.yang_name = "flow-keys"
                                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('keys', (YLeaf(YType.str, 'keys'), ['str'])),
                                                                                                            ('num', (YLeaf(YType.uint8, 'num'), ['int'])),
                                                                                                        ])
                                                                                                        self.keys = None
                                                                                                        self.num = None
                                                                                                        self._segment_path = lambda: "flow-keys"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                            class DhcpClientId(Entity):
                                                                                                """
                                                                                                Dhcp Client ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dhcp-client-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                            class DhcpClientIdRegex(Entity):
                                                                                                """
                                                                                                Dhcp Client ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                            class CircuitId(Entity):
                                                                                                """
                                                                                                Circuit ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                    self.yang_name = "circuit-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "circuit-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                            class CircuitIdRegex(Entity):
                                                                                                """
                                                                                                Circuit ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                    self.yang_name = "circuit-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "circuit-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                            class RemoteId(Entity):
                                                                                                """
                                                                                                Remote ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                    self.yang_name = "remote-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "remote-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                            class RemoteIdRegex(Entity):
                                                                                                """
                                                                                                Remote ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                    self.yang_name = "remote-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "remote-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                            class SrcPort(Entity):
                                                                                                """
                                                                                                Source port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                    self.yang_name = "src-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "src-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class DstPort(Entity):
                                                                                                """
                                                                                                Destination port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                    self.yang_name = "dst-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "dst-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                        class ExcdclassEncode(Entity):
                                                                            """
                                                                            excdclass encode
                                                                            
                                                                            .. attribute:: inline_cmap
                                                                            
                                                                            	inline cmap
                                                                            	**type**\:  :py:class:`InlineCmap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap>`
                                                                            
                                                                            .. attribute:: enc
                                                                            
                                                                            	enc
                                                                            	**type**\:  :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                            
                                                                            .. attribute:: class_name
                                                                            
                                                                            	class name
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..65
                                                                            
                                                                            .. attribute:: hd
                                                                            
                                                                            	hd
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: idx
                                                                            
                                                                            	idx
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode, self).__init__()

                                                                                self.yang_name = "excdclass-encode"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("inline-cmap", ("inline_cmap", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('enc', (YLeaf(YType.enumeration, 'enc'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyObjEncEn', '')])),
                                                                                    ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                                                    ('hd', (YLeaf(YType.uint64, 'hd'), ['int'])),
                                                                                    ('idx', (YLeaf(YType.uint8, 'idx'), ['int'])),
                                                                                ])
                                                                                self.enc = None
                                                                                self.class_name = None
                                                                                self.hd = None
                                                                                self.idx = None

                                                                                self.inline_cmap = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap()
                                                                                self.inline_cmap.parent = self
                                                                                self._children_name_map["inline_cmap"] = "inline-cmap"
                                                                                self._segment_path = lambda: "excdclass-encode"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode, ['enc', 'class_name', 'hd', 'idx'], name, value)


                                                                            class InlineCmap(Entity):
                                                                                """
                                                                                inline cmap
                                                                                
                                                                                .. attribute:: match_infop
                                                                                
                                                                                	Pointer to the first Match info
                                                                                	**type**\:  :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop>`
                                                                                
                                                                                .. attribute:: mode
                                                                                
                                                                                	Inline Class\-Map Mode Match any/all
                                                                                	**type**\:  :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                                
                                                                                .. attribute:: flags
                                                                                
                                                                                	Inline Class\-Map flags
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: match_count
                                                                                
                                                                                	Number of Match infos
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap, self).__init__()

                                                                                    self.yang_name = "inline-cmap"
                                                                                    self.yang_parent_name = "excdclass-encode"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("match-infop", ("match_infop", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapModeEn', '')])),
                                                                                        ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                        ('match_count', (YLeaf(YType.uint32, 'match-count'), ['int'])),
                                                                                    ])
                                                                                    self.mode = None
                                                                                    self.flags = None
                                                                                    self.match_count = None

                                                                                    self.match_infop = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop()
                                                                                    self.match_infop.parent = self
                                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                                    self._segment_path = lambda: "inline-cmap"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap, ['mode', 'flags', 'match_count'], name, value)


                                                                                class MatchInfop(Entity):
                                                                                    """
                                                                                    Pointer to the first Match info
                                                                                    
                                                                                    .. attribute:: class_match_info_st
                                                                                    
                                                                                    	class match info st
                                                                                    	**type**\: list of  		 :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop, self).__init__()

                                                                                        self.yang_name = "match-infop"
                                                                                        self.yang_parent_name = "inline-cmap"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("class-match-info-st", ("class_match_info_st", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.class_match_info_st = YList(self)
                                                                                        self._segment_path = lambda: "match-infop"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop, [], name, value)


                                                                                    class ClassMatchInfoSt(Entity):
                                                                                        """
                                                                                        class match info st
                                                                                        
                                                                                        .. attribute:: match_data
                                                                                        
                                                                                        	Match criteria
                                                                                        	**type**\:  :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                        
                                                                                        .. attribute:: flags
                                                                                        
                                                                                        	Flags
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                            self.yang_name = "class-match-info-st"
                                                                                            self.yang_parent_name = "match-infop"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("match-data", ("match_data", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData))])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                            ])
                                                                                            self.flags = None

                                                                                            self.match_data = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                            self.match_data.parent = self
                                                                                            self._children_name_map["match_data"] = "match-data"
                                                                                            self._segment_path = lambda: "class-match-info-st"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                        class MatchData(Entity):
                                                                                            """
                                                                                            Match criteria
                                                                                            
                                                                                            .. attribute:: ipv4_dscp
                                                                                            
                                                                                            	IPv4 DSCP
                                                                                            	**type**\:  :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv6_dscp
                                                                                            
                                                                                            	IPv6 DSCP
                                                                                            	**type**\:  :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                            
                                                                                            .. attribute:: dscp
                                                                                            
                                                                                            	Match DSCP range array
                                                                                            	**type**\:  :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv4_prec
                                                                                            
                                                                                            	IPv4 Precedence
                                                                                            	**type**\:  :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                            
                                                                                            .. attribute:: ipv6_prec
                                                                                            
                                                                                            	IPv6 Precedence
                                                                                            	**type**\:  :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                            
                                                                                            .. attribute:: prec
                                                                                            
                                                                                            	Match Precedence array
                                                                                            	**type**\:  :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                            
                                                                                            .. attribute:: discard_class
                                                                                            
                                                                                            	Match Discard Class array
                                                                                            	**type**\:  :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                            
                                                                                            .. attribute:: qos_group
                                                                                            
                                                                                            	Match QoS group array
                                                                                            	**type**\:  :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                            
                                                                                            .. attribute:: traffic_class
                                                                                            
                                                                                            	Match Traffic class array
                                                                                            	**type**\:  :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                            
                                                                                            .. attribute:: proto
                                                                                            
                                                                                            	Match Protocol array
                                                                                            	**type**\:  :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                            
                                                                                            .. attribute:: icmp_v4
                                                                                            
                                                                                            	Match ICMPV4 Protocol
                                                                                            	**type**\:  :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                            
                                                                                            .. attribute:: icmp_v6
                                                                                            
                                                                                            	Match ICMPV6 Protocol array
                                                                                            	**type**\:  :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                            
                                                                                            .. attribute:: ipv4_packet_len
                                                                                            
                                                                                            	IPv4 packet length array
                                                                                            	**type**\:  :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv6_packet_len
                                                                                            
                                                                                            	IPv6 packet length array
                                                                                            	**type**\:  :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                            
                                                                                            .. attribute:: packet_len
                                                                                            
                                                                                            	Match packet length array
                                                                                            	**type**\:  :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                            
                                                                                            .. attribute:: flow_tag
                                                                                            
                                                                                            	Match flow\-tag array
                                                                                            	**type**\:  :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                            
                                                                                            .. attribute:: tcp_flag
                                                                                            
                                                                                            	Match tcp flag value
                                                                                            	**type**\:  :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                            
                                                                                            .. attribute:: icmpv4_type
                                                                                            
                                                                                            	Match ipv4 icmp type
                                                                                            	**type**\:  :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                            
                                                                                            .. attribute:: icmpv4_code
                                                                                            
                                                                                            	Match ipv4 icmp code
                                                                                            	**type**\:  :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                            
                                                                                            .. attribute:: icmpv6_type
                                                                                            
                                                                                            	Match ipv6 icmp type
                                                                                            	**type**\:  :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                            
                                                                                            .. attribute:: icmpv6_code
                                                                                            
                                                                                            	Match ipv6 icmp code
                                                                                            	**type**\:  :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                            
                                                                                            .. attribute:: mpls_exp
                                                                                            
                                                                                            	Match MPLS experimental topmost array
                                                                                            	**type**\:  :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                            
                                                                                            .. attribute:: mpls_exp_imp
                                                                                            
                                                                                            	Match MPLS experimental imposition array
                                                                                            	**type**\:  :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                                            
                                                                                            	MPLS Disposition IPv4 Access\-list
                                                                                            	**type**\:  :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                                            
                                                                                            	MPLS Disposition IPv6 Access\-list
                                                                                            	**type**\:  :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_top_label
                                                                                            
                                                                                            	MPLS Topmost LABEL
                                                                                            	**type**\:  :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                            
                                                                                            .. attribute:: cos
                                                                                            
                                                                                            	Match CoS array
                                                                                            	**type**\:  :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                            
                                                                                            .. attribute:: cos_inr
                                                                                            
                                                                                            	Match inner header CoS
                                                                                            	**type**\:  :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                            
                                                                                            .. attribute:: dei
                                                                                            
                                                                                            	Match DEI Bit
                                                                                            	**type**\:  :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                            
                                                                                            .. attribute:: dei_inr
                                                                                            
                                                                                            	Match inner DEI Bit
                                                                                            	**type**\:  :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                            
                                                                                            .. attribute:: vlan
                                                                                            
                                                                                            	Match VLAN array
                                                                                            	**type**\:  :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                            
                                                                                            .. attribute:: vlan_inr
                                                                                            
                                                                                            	Match inner header VLAN range array
                                                                                            	**type**\:  :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                            
                                                                                            .. attribute:: fr_dlci
                                                                                            
                                                                                            	Match FR DLCI range array
                                                                                            	**type**\:  :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                            
                                                                                            .. attribute:: src_mac
                                                                                            
                                                                                            	Match Source MAC address
                                                                                            	**type**\:  :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                            
                                                                                            .. attribute:: dst_mac
                                                                                            
                                                                                            	Match Destination MAC address
                                                                                            	**type**\:  :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                            
                                                                                            .. attribute:: atm_clp
                                                                                            
                                                                                            	Match ATM CLP level
                                                                                            	**type**\:  :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                            
                                                                                            .. attribute:: fr_de
                                                                                            
                                                                                            	Match FR DE value
                                                                                            	**type**\:  :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                            
                                                                                            .. attribute:: ipv4_acl
                                                                                            
                                                                                            	IPv4 Access\-list
                                                                                            	**type**\:  :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                            
                                                                                            .. attribute:: ipv6_acl
                                                                                            
                                                                                            	IPv6 Access\-list
                                                                                            	**type**\:  :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                            
                                                                                            .. attribute:: ether_service_acl
                                                                                            
                                                                                            	Ethernet\-Services Access\-list
                                                                                            	**type**\:  :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                            
                                                                                            .. attribute:: avail_id
                                                                                            
                                                                                            	Available Identifiers
                                                                                            	**type**\:  :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                            
                                                                                            .. attribute:: media_type
                                                                                            
                                                                                            	Media Type
                                                                                            	**type**\:  :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                            
                                                                                            .. attribute:: subs_protocol
                                                                                            
                                                                                            	Protocol
                                                                                            	**type**\:  :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                            
                                                                                            .. attribute:: dnis
                                                                                            
                                                                                            	DNIS
                                                                                            	**type**\:  :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                            
                                                                                            .. attribute:: dnis_regex
                                                                                            
                                                                                            	DNIS Regular Expression
                                                                                            	**type**\:  :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                            
                                                                                            .. attribute:: domain
                                                                                            
                                                                                            	Domain Name
                                                                                            	**type**\:  :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                            
                                                                                            .. attribute:: domain_regex
                                                                                            
                                                                                            	Domain Regular Expression
                                                                                            	**type**\:  :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                            
                                                                                            .. attribute:: nas_port
                                                                                            
                                                                                            	NAS Port
                                                                                            	**type**\:  :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                            
                                                                                            .. attribute:: service_name
                                                                                            
                                                                                            	Service Name
                                                                                            	**type**\:  :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                            
                                                                                            .. attribute:: service_name_regex
                                                                                            
                                                                                            	Service Name Regular Exp
                                                                                            	**type**\:  :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv4
                                                                                            
                                                                                            	Source Address IPV4
                                                                                            	**type**\:  :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv4
                                                                                            
                                                                                            	Destination Address IPV4
                                                                                            	**type**\:  :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv6
                                                                                            
                                                                                            	Source Address IPV6
                                                                                            	**type**\:  :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv6
                                                                                            
                                                                                            	Destination Address IPV6
                                                                                            	**type**\:  :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: src_addr_mac
                                                                                            
                                                                                            	Source Address MAC
                                                                                            	**type**\:  :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                            
                                                                                            .. attribute:: timer
                                                                                            
                                                                                            	Timer
                                                                                            	**type**\:  :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                            
                                                                                            .. attribute:: timer_regexp
                                                                                            
                                                                                            	Timer Regular Expression
                                                                                            	**type**\:  :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                            
                                                                                            .. attribute:: tunnel_name
                                                                                            
                                                                                            	Tunnel Name
                                                                                            	**type**\:  :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                            
                                                                                            .. attribute:: tunnel_name_regex
                                                                                            
                                                                                            	Tunnel Name Regular Expression
                                                                                            	**type**\:  :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                            
                                                                                            .. attribute:: user_name
                                                                                            
                                                                                            	User Name
                                                                                            	**type**\:  :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                            
                                                                                            .. attribute:: user_name_regex
                                                                                            
                                                                                            	User Name Regular Expression
                                                                                            	**type**\:  :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                            
                                                                                            .. attribute:: auth_username
                                                                                            
                                                                                            	Authenticated User Name
                                                                                            	**type**\:  :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                            
                                                                                            .. attribute:: auth_username_regex
                                                                                            
                                                                                            	Authenticated User Name RegEx
                                                                                            	**type**\:  :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_username
                                                                                            
                                                                                            	Unauthenticated User Name
                                                                                            	**type**\:  :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                            
                                                                                            .. attribute:: unauth_username_regex
                                                                                            
                                                                                            	Unauthenticated User Name RegEx
                                                                                            	**type**\:  :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: auth_domain
                                                                                            
                                                                                            	Authenticated domain name
                                                                                            	**type**\:  :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                            
                                                                                            .. attribute:: auth_domain_regex
                                                                                            
                                                                                            	Authenticated Domain Name RegEx
                                                                                            	**type**\:  :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_domain
                                                                                            
                                                                                            	Unauthenticated Domain Name
                                                                                            	**type**\:  :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                            
                                                                                            .. attribute:: unauth_domain_regex
                                                                                            
                                                                                            	Unauthenticated Domain Name RegEx
                                                                                            	**type**\:  :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: vendor_id
                                                                                            
                                                                                            	Vendor ID
                                                                                            	**type**\:  :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                            
                                                                                            .. attribute:: vendor_id_regex
                                                                                            
                                                                                            	Vendor ID RegEx
                                                                                            	**type**\:  :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                            
                                                                                            .. attribute:: access_interface
                                                                                            
                                                                                            	Access interface
                                                                                            	**type**\:  :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                            
                                                                                            .. attribute:: input_interface
                                                                                            
                                                                                            	Input interface
                                                                                            	**type**\:  :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                            
                                                                                            .. attribute:: input_intfhdl
                                                                                            
                                                                                            	Input interface handle
                                                                                            	**type**\:  :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                            
                                                                                            .. attribute:: ethertype
                                                                                            
                                                                                            	Ethernet type
                                                                                            	**type**\:  :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                            
                                                                                            .. attribute:: flow_key_data
                                                                                            
                                                                                            	Flow key structure
                                                                                            	**type**\:  :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id
                                                                                            
                                                                                            	Dhcp Client ID
                                                                                            	**type**\:  :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id_regex
                                                                                            
                                                                                            	Dhcp Client ID RegEx
                                                                                            	**type**\:  :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                            
                                                                                            .. attribute:: circuit_id
                                                                                            
                                                                                            	Circuit ID
                                                                                            	**type**\:  :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                            
                                                                                            .. attribute:: circuit_id_regex
                                                                                            
                                                                                            	Circuit ID RegEx
                                                                                            	**type**\:  :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                            
                                                                                            .. attribute:: remote_id
                                                                                            
                                                                                            	Remote ID
                                                                                            	**type**\:  :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                            
                                                                                            .. attribute:: remote_id_regex
                                                                                            
                                                                                            	Remote ID RegEx
                                                                                            	**type**\:  :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                            
                                                                                            .. attribute:: src_port
                                                                                            
                                                                                            	Source port
                                                                                            	**type**\:  :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                            
                                                                                            .. attribute:: dst_port
                                                                                            
                                                                                            	Destination port
                                                                                            	**type**\:  :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	type
                                                                                            	**type**\:  :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                            
                                                                                            .. attribute:: mpls_top_eos
                                                                                            
                                                                                            	MPLS Topmost EOS
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: fragment_type
                                                                                            
                                                                                            	Fragment type
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: authen_status
                                                                                            
                                                                                            	Authentication Status
                                                                                            	**type**\:  :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                            
                                                                                            .. attribute:: mlp_negotiated
                                                                                            
                                                                                            	MLP Negotiated
                                                                                            	**type**\:  :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                                self.yang_name = "match-data"
                                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("ipv4-dscp", ("ipv4_dscp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp)), ("ipv6-dscp", ("ipv6_dscp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp)), ("dscp", ("dscp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp)), ("ipv4-prec", ("ipv4_prec", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec)), ("ipv6-prec", ("ipv6_prec", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec)), ("prec", ("prec", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec)), ("discard-class", ("discard_class", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass)), ("qos-group", ("qos_group", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup)), ("traffic-class", ("traffic_class", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass)), ("proto", ("proto", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto)), ("icmp-v4", ("icmp_v4", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4)), ("icmp-v6", ("icmp_v6", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6)), ("ipv4-packet-len", ("ipv4_packet_len", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen)), ("ipv6-packet-len", ("ipv6_packet_len", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen)), ("packet-len", ("packet_len", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen)), ("flow-tag", ("flow_tag", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag)), ("tcp-flag", ("tcp_flag", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag)), ("icmpv4-type", ("icmpv4_type", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type)), ("icmpv4-code", ("icmpv4_code", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code)), ("icmpv6-type", ("icmpv6_type", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type)), ("icmpv6-code", ("icmpv6_code", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code)), ("mpls-exp", ("mpls_exp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp)), ("mpls-exp-imp", ("mpls_exp_imp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp)), ("mpls-disp-ipv4-acl", ("mpls_disp_ipv4_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl)), ("mpls-disp-ipv6-acl", ("mpls_disp_ipv6_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl)), ("mpls-top-label", ("mpls_top_label", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel)), ("cos", ("cos", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos)), ("cos-inr", ("cos_inr", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr)), ("dei", ("dei", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei)), ("dei-inr", ("dei_inr", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr)), ("vlan", ("vlan", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan)), ("vlan-inr", ("vlan_inr", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)), ("fr-dlci", ("fr_dlci", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci)), ("src-mac", ("src_mac", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac)), ("dst-mac", ("dst_mac", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac)), ("atm-clp", ("atm_clp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp)), ("fr-de", ("fr_de", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe)), ("ipv4-acl", ("ipv4_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl)), ("ipv6-acl", ("ipv6_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl)), ("ether-service-acl", ("ether_service_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl)), ("avail-id", ("avail_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId)), ("media-type", ("media_type", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType)), ("subs-protocol", ("subs_protocol", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol)), ("dnis", ("dnis", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis)), ("dnis-regex", ("dnis_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex)), ("domain", ("domain", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain)), ("domain-regex", ("domain_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex)), ("nas-port", ("nas_port", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort)), ("service-name", ("service_name", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName)), ("service-name-regex", ("service_name_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex)), ("src-addr-ipv4", ("src_addr_ipv4", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4)), ("dst-addr-ipv4", ("dst_addr_ipv4", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4)), ("src-addr-ipv6", ("src_addr_ipv6", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6)), ("dst-addr-ipv6", ("dst_addr_ipv6", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6)), ("src-addr-mac", ("src_addr_mac", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac)), ("timer", ("timer", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer)), ("timer-regexp", ("timer_regexp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp)), ("tunnel-name", ("tunnel_name", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName)), ("tunnel-name-regex", ("tunnel_name_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex)), ("user-name", ("user_name", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName)), ("user-name-regex", ("user_name_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex)), ("auth-username", ("auth_username", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername)), ("auth-username-regex", ("auth_username_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex)), ("unauth-username", ("unauth_username", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername)), ("unauth-username-regex", ("unauth_username_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex)), ("auth-domain", ("auth_domain", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain)), ("auth-domain-regex", ("auth_domain_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex)), ("unauth-domain", ("unauth_domain", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain)), ("unauth-domain-regex", ("unauth_domain_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex)), ("vendor-id", ("vendor_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId)), ("vendor-id-regex", ("vendor_id_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex)), ("access-interface", ("access_interface", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface)), ("input-interface", ("input_interface", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface)), ("input-intfhdl", ("input_intfhdl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl)), ("ethertype", ("ethertype", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype)), ("flow-key-data", ("flow_key_data", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData)), ("dhcp-client-id", ("dhcp_client_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId)), ("dhcp-client-id-regex", ("dhcp_client_id_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex)), ("circuit-id", ("circuit_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId)), ("circuit-id-regex", ("circuit_id_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex)), ("remote-id", ("remote_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId)), ("remote-id-regex", ("remote_id_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex)), ("src-port", ("src_port", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort)), ("dst-port", ("dst_port", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort))])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchTypeEn', '')])),
                                                                                                    ('mpls_top_eos', (YLeaf(YType.uint8, 'mpls-top-eos'), ['int'])),
                                                                                                    ('fragment_type', (YLeaf(YType.uint8, 'fragment-type'), ['int'])),
                                                                                                    ('authen_status', (YLeaf(YType.enumeration, 'authen-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchAuthenStatusEn', '')])),
                                                                                                    ('mlp_negotiated', (YLeaf(YType.enumeration, 'mlp-negotiated'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchMlpNegotiatedEn', '')])),
                                                                                                ])
                                                                                                self.type = None
                                                                                                self.mpls_top_eos = None
                                                                                                self.fragment_type = None
                                                                                                self.authen_status = None
                                                                                                self.mlp_negotiated = None

                                                                                                self.ipv4_dscp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                                self.ipv4_dscp.parent = self
                                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"

                                                                                                self.ipv6_dscp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                                self.ipv6_dscp.parent = self
                                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"

                                                                                                self.dscp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                                self.dscp.parent = self
                                                                                                self._children_name_map["dscp"] = "dscp"

                                                                                                self.ipv4_prec = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                                self.ipv4_prec.parent = self
                                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"

                                                                                                self.ipv6_prec = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                                self.ipv6_prec.parent = self
                                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"

                                                                                                self.prec = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                                self.prec.parent = self
                                                                                                self._children_name_map["prec"] = "prec"

                                                                                                self.discard_class = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                                self.discard_class.parent = self
                                                                                                self._children_name_map["discard_class"] = "discard-class"

                                                                                                self.qos_group = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                                self.qos_group.parent = self
                                                                                                self._children_name_map["qos_group"] = "qos-group"

                                                                                                self.traffic_class = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                                self.traffic_class.parent = self
                                                                                                self._children_name_map["traffic_class"] = "traffic-class"

                                                                                                self.proto = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                                self.proto.parent = self
                                                                                                self._children_name_map["proto"] = "proto"

                                                                                                self.icmp_v4 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                                self.icmp_v4.parent = self
                                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"

                                                                                                self.icmp_v6 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                                self.icmp_v6.parent = self
                                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"

                                                                                                self.ipv4_packet_len = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                                self.ipv4_packet_len.parent = self
                                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"

                                                                                                self.ipv6_packet_len = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                                self.ipv6_packet_len.parent = self
                                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"

                                                                                                self.packet_len = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                                self.packet_len.parent = self
                                                                                                self._children_name_map["packet_len"] = "packet-len"

                                                                                                self.flow_tag = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                                self.flow_tag.parent = self
                                                                                                self._children_name_map["flow_tag"] = "flow-tag"

                                                                                                self.tcp_flag = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                                self.tcp_flag.parent = self
                                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"

                                                                                                self.icmpv4_type = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                                self.icmpv4_type.parent = self
                                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"

                                                                                                self.icmpv4_code = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                                self.icmpv4_code.parent = self
                                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"

                                                                                                self.icmpv6_type = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                                self.icmpv6_type.parent = self
                                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"

                                                                                                self.icmpv6_code = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                                self.icmpv6_code.parent = self
                                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"

                                                                                                self.mpls_exp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                                self.mpls_exp.parent = self
                                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"

                                                                                                self.mpls_exp_imp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                                self.mpls_exp_imp.parent = self
                                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"

                                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"

                                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"

                                                                                                self.mpls_top_label = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                                self.mpls_top_label.parent = self
                                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"

                                                                                                self.cos = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                                self.cos.parent = self
                                                                                                self._children_name_map["cos"] = "cos"

                                                                                                self.cos_inr = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                                self.cos_inr.parent = self
                                                                                                self._children_name_map["cos_inr"] = "cos-inr"

                                                                                                self.dei = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                                self.dei.parent = self
                                                                                                self._children_name_map["dei"] = "dei"

                                                                                                self.dei_inr = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                                self.dei_inr.parent = self
                                                                                                self._children_name_map["dei_inr"] = "dei-inr"

                                                                                                self.vlan = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                                self.vlan.parent = self
                                                                                                self._children_name_map["vlan"] = "vlan"

                                                                                                self.vlan_inr = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                                self.vlan_inr.parent = self
                                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"

                                                                                                self.fr_dlci = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                                self.fr_dlci.parent = self
                                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"

                                                                                                self.src_mac = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                                self.src_mac.parent = self
                                                                                                self._children_name_map["src_mac"] = "src-mac"

                                                                                                self.dst_mac = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                                self.dst_mac.parent = self
                                                                                                self._children_name_map["dst_mac"] = "dst-mac"

                                                                                                self.atm_clp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                                self.atm_clp.parent = self
                                                                                                self._children_name_map["atm_clp"] = "atm-clp"

                                                                                                self.fr_de = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                                self.fr_de.parent = self
                                                                                                self._children_name_map["fr_de"] = "fr-de"

                                                                                                self.ipv4_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                                self.ipv4_acl.parent = self
                                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"

                                                                                                self.ipv6_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                                self.ipv6_acl.parent = self
                                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"

                                                                                                self.ether_service_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                                self.ether_service_acl.parent = self
                                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"

                                                                                                self.avail_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                                self.avail_id.parent = self
                                                                                                self._children_name_map["avail_id"] = "avail-id"

                                                                                                self.media_type = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                                self.media_type.parent = self
                                                                                                self._children_name_map["media_type"] = "media-type"

                                                                                                self.subs_protocol = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                                self.subs_protocol.parent = self
                                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"

                                                                                                self.dnis = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                                self.dnis.parent = self
                                                                                                self._children_name_map["dnis"] = "dnis"

                                                                                                self.dnis_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                                self.dnis_regex.parent = self
                                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"

                                                                                                self.domain = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                                self.domain.parent = self
                                                                                                self._children_name_map["domain"] = "domain"

                                                                                                self.domain_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                                self.domain_regex.parent = self
                                                                                                self._children_name_map["domain_regex"] = "domain-regex"

                                                                                                self.nas_port = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                                self.nas_port.parent = self
                                                                                                self._children_name_map["nas_port"] = "nas-port"

                                                                                                self.service_name = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                                self.service_name.parent = self
                                                                                                self._children_name_map["service_name"] = "service-name"

                                                                                                self.service_name_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                                self.service_name_regex.parent = self
                                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"

                                                                                                self.src_addr_ipv4 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                                self.src_addr_ipv4.parent = self
                                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"

                                                                                                self.dst_addr_ipv4 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                                self.dst_addr_ipv4.parent = self
                                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"

                                                                                                self.src_addr_ipv6 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                                self.src_addr_ipv6.parent = self
                                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"

                                                                                                self.dst_addr_ipv6 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                                self.dst_addr_ipv6.parent = self
                                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"

                                                                                                self.src_addr_mac = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                                self.src_addr_mac.parent = self
                                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"

                                                                                                self.timer = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                                self.timer.parent = self
                                                                                                self._children_name_map["timer"] = "timer"

                                                                                                self.timer_regexp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                                self.timer_regexp.parent = self
                                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"

                                                                                                self.tunnel_name = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                                self.tunnel_name.parent = self
                                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"

                                                                                                self.tunnel_name_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                                self.tunnel_name_regex.parent = self
                                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"

                                                                                                self.user_name = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                                self.user_name.parent = self
                                                                                                self._children_name_map["user_name"] = "user-name"

                                                                                                self.user_name_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                                self.user_name_regex.parent = self
                                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"

                                                                                                self.auth_username = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                                self.auth_username.parent = self
                                                                                                self._children_name_map["auth_username"] = "auth-username"

                                                                                                self.auth_username_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                                self.auth_username_regex.parent = self
                                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"

                                                                                                self.unauth_username = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                                self.unauth_username.parent = self
                                                                                                self._children_name_map["unauth_username"] = "unauth-username"

                                                                                                self.unauth_username_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                                self.unauth_username_regex.parent = self
                                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"

                                                                                                self.auth_domain = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                                self.auth_domain.parent = self
                                                                                                self._children_name_map["auth_domain"] = "auth-domain"

                                                                                                self.auth_domain_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                                self.auth_domain_regex.parent = self
                                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"

                                                                                                self.unauth_domain = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                                self.unauth_domain.parent = self
                                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"

                                                                                                self.unauth_domain_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                                self.unauth_domain_regex.parent = self
                                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"

                                                                                                self.vendor_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                                self.vendor_id.parent = self
                                                                                                self._children_name_map["vendor_id"] = "vendor-id"

                                                                                                self.vendor_id_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                                self.vendor_id_regex.parent = self
                                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"

                                                                                                self.access_interface = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                                self.access_interface.parent = self
                                                                                                self._children_name_map["access_interface"] = "access-interface"

                                                                                                self.input_interface = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                                self.input_interface.parent = self
                                                                                                self._children_name_map["input_interface"] = "input-interface"

                                                                                                self.input_intfhdl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                                self.input_intfhdl.parent = self
                                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"

                                                                                                self.ethertype = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                                self.ethertype.parent = self
                                                                                                self._children_name_map["ethertype"] = "ethertype"

                                                                                                self.flow_key_data = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                                self.flow_key_data.parent = self
                                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"

                                                                                                self.dhcp_client_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                                self.dhcp_client_id.parent = self
                                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"

                                                                                                self.dhcp_client_id_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                                self.dhcp_client_id_regex.parent = self
                                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"

                                                                                                self.circuit_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                                self.circuit_id.parent = self
                                                                                                self._children_name_map["circuit_id"] = "circuit-id"

                                                                                                self.circuit_id_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                                self.circuit_id_regex.parent = self
                                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"

                                                                                                self.remote_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                                self.remote_id.parent = self
                                                                                                self._children_name_map["remote_id"] = "remote-id"

                                                                                                self.remote_id_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                                self.remote_id_regex.parent = self
                                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"

                                                                                                self.src_port = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                                self.src_port.parent = self
                                                                                                self._children_name_map["src_port"] = "src-port"

                                                                                                self.dst_port = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                                self.dst_port.parent = self
                                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                                self._segment_path = lambda: "match-data"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, ['type', 'mpls_top_eos', 'fragment_type', 'authen_status', 'mlp_negotiated'], name, value)


                                                                                            class Ipv4Dscp(Entity):
                                                                                                """
                                                                                                IPv4 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv4-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv6Dscp(Entity):
                                                                                                """
                                                                                                IPv6 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv6-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Dscp(Entity):
                                                                                                """
                                                                                                Match DSCP range array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                    self.yang_name = "dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv4Prec(Entity):
                                                                                                """
                                                                                                IPv4 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                    self.yang_name = "ipv4-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "ipv4-prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                            class Ipv6Prec(Entity):
                                                                                                """
                                                                                                IPv6 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                    self.yang_name = "ipv6-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "ipv6-prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                            class Prec(Entity):
                                                                                                """
                                                                                                Match Precedence array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                    self.yang_name = "prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                            class DiscardClass(Entity):
                                                                                                """
                                                                                                Match Discard Class array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                    self.yang_name = "discard-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "discard-class"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                            class QosGroup(Entity):
                                                                                                """
                                                                                                Match QoS group array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                    self.yang_name = "qos-group"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "qos-group"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "qos-group"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class TrafficClass(Entity):
                                                                                                """
                                                                                                Match Traffic class array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                    self.yang_name = "traffic-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "traffic-class"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "traffic-class"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Proto(Entity):
                                                                                                """
                                                                                                Match Protocol array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                    self.yang_name = "proto"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "proto"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "proto"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class IcmpV4(Entity):
                                                                                                """
                                                                                                Match ICMPV4 Protocol
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                    self.yang_name = "icmp-v4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                    ])
                                                                                                    self.type = None
                                                                                                    self.code = None
                                                                                                    self._segment_path = lambda: "icmp-v4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['type', 'code'], name, value)


                                                                                            class IcmpV6(Entity):
                                                                                                """
                                                                                                Match ICMPV6 Protocol array
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                    self.yang_name = "icmp-v6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                    ])
                                                                                                    self.type = None
                                                                                                    self.code = None
                                                                                                    self._segment_path = lambda: "icmp-v6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['type', 'code'], name, value)


                                                                                            class Ipv4PacketLen(Entity):
                                                                                                """
                                                                                                IPv4 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv6PacketLen(Entity):
                                                                                                """
                                                                                                IPv6 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class PacketLen(Entity):
                                                                                                """
                                                                                                Match packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                    self.yang_name = "packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FlowTag(Entity):
                                                                                                """
                                                                                                Match flow\-tag array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                    self.yang_name = "flow-tag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "flow-tag"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "flow-tag"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class TcpFlag(Entity):
                                                                                                """
                                                                                                Match tcp flag value
                                                                                                
                                                                                                .. attribute:: value
                                                                                                
                                                                                                	Value of TCP flag
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: match_any
                                                                                                
                                                                                                	Match any TCP flag bit
                                                                                                	**type**\: bool
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                    self.yang_name = "tcp-flag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                                        ('match_any', (YLeaf(YType.boolean, 'match-any'), ['bool'])),
                                                                                                    ])
                                                                                                    self.value = None
                                                                                                    self.match_any = None
                                                                                                    self._segment_path = lambda: "tcp-flag"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['value', 'match_any'], name, value)


                                                                                            class Icmpv4Type(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                    self.yang_name = "icmpv4-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv4Code(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                    self.yang_name = "icmpv4-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-code"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv6Type(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                    self.yang_name = "icmpv6-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv6Code(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                    self.yang_name = "icmpv6-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-code"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class MplsExp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental topmost array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "mpls-exp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                            class MplsExpImp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental imposition array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "mpls-exp-imp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                            class MplsDispIpv4Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                            class MplsDispIpv6Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                            class MplsTopLabel(Entity):
                                                                                                """
                                                                                                MPLS Topmost LABEL
                                                                                                
                                                                                                .. attribute:: uint32_rng_array
                                                                                                
                                                                                                	uint32 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                    self.yang_name = "mpls-top-label"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint32_rng_array", ("uint32_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint32_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "mpls-top-label"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                                class Uint32RngArray(Entity):
                                                                                                    """
                                                                                                    uint32 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                        self.yang_name = "uint32_rng_array"
                                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint32, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint32, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint32_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['min', 'max'], name, value)


                                                                                            class Cos(Entity):
                                                                                                """
                                                                                                Match CoS array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                    self.yang_name = "cos"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "cos"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                            class CosInr(Entity):
                                                                                                """
                                                                                                Match inner header CoS
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                    self.yang_name = "cos-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "cos-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                            class Dei(Entity):
                                                                                                """
                                                                                                Match DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                    self.yang_name = "dei"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                    ])
                                                                                                    self.bit_value = None
                                                                                                    self._segment_path = lambda: "dei"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                            class DeiInr(Entity):
                                                                                                """
                                                                                                Match inner DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                    self.yang_name = "dei-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                    ])
                                                                                                    self.bit_value = None
                                                                                                    self._segment_path = lambda: "dei-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                            class Vlan(Entity):
                                                                                                """
                                                                                                Match VLAN array
                                                                                                
                                                                                                .. attribute:: vlan_id_array
                                                                                                
                                                                                                	vlan id array
                                                                                                	**type**\: list of  		 :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                    self.yang_name = "vlan"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("vlan-id-array", ("vlan_id_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.vlan_id_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                                class VlanIdArray(Entity):
                                                                                                    """
                                                                                                    vlan id array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	VLAN mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                        self.yang_name = "vlan-id-array"
                                                                                                        self.yang_parent_name = "vlan"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ('mask', (YLeaf(YType.uint16, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "vlan-id-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['min', 'max', 'mask'], name, value)


                                                                                            class VlanInr(Entity):
                                                                                                """
                                                                                                Match inner header VLAN range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                    self.yang_name = "vlan-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FrDlci(Entity):
                                                                                                """
                                                                                                Match FR DLCI range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                    self.yang_name = "fr-dlci"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "fr-dlci"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class SrcMac(Entity):
                                                                                                """
                                                                                                Match Source MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                    self.yang_name = "src-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.mac_addr = []
                                                                                                    self.mask = []
                                                                                                    self._segment_path = lambda: "src-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                            class DstMac(Entity):
                                                                                                """
                                                                                                Match Destination MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                    self.yang_name = "dst-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.mac_addr = []
                                                                                                    self.mask = []
                                                                                                    self._segment_path = lambda: "dst-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                            class AtmClp(Entity):
                                                                                                """
                                                                                                Match ATM CLP level
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                    self.yang_name = "atm-clp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "atm-clp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                            class FrDe(Entity):
                                                                                                """
                                                                                                Match FR DE value
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                    self.yang_name = "fr-de"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "fr-de"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                            class Ipv4Acl(Entity):
                                                                                                """
                                                                                                IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                    self.yang_name = "ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ipv4-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                            class Ipv6Acl(Entity):
                                                                                                """
                                                                                                IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                    self.yang_name = "ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ipv6-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                            class EtherServiceAcl(Entity):
                                                                                                """
                                                                                                Ethernet\-Services Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                    self.yang_name = "ether-service-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ether-service-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                            class AvailId(Entity):
                                                                                                """
                                                                                                Available Identifiers
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                    self.yang_name = "avail-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "avail-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                            class MediaType(Entity):
                                                                                                """
                                                                                                Media Type
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                    self.yang_name = "media-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "media-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                            class SubsProtocol(Entity):
                                                                                                """
                                                                                                Protocol
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                    self.yang_name = "subs-protocol"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "subs-protocol"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                            class Dnis(Entity):
                                                                                                """
                                                                                                DNIS
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                    self.yang_name = "dnis"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dnis"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                            class DnisRegex(Entity):
                                                                                                """
                                                                                                DNIS Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                    self.yang_name = "dnis-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dnis-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                            class Domain(Entity):
                                                                                                """
                                                                                                Domain Name
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                    self.yang_name = "domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                        ])
                                                                                                        self.domain_name = None
                                                                                                        self.format_name = None
                                                                                                        self._segment_path = lambda: "domain-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class DomainRegex(Entity):
                                                                                                """
                                                                                                Domain Regular Expression
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                    self.yang_name = "domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain-regex"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                        ])
                                                                                                        self.domain_name = None
                                                                                                        self.format_name = None
                                                                                                        self._segment_path = lambda: "domain-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class NasPort(Entity):
                                                                                                """
                                                                                                NAS Port
                                                                                                
                                                                                                .. attribute:: nas_port_array
                                                                                                
                                                                                                	nas port array
                                                                                                	**type**\: list of  		 :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                    self.yang_name = "nas-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("nas-port-array", ("nas_port_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.nas_port_array = YList(self)
                                                                                                    self._segment_path = lambda: "nas-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                                class NasPortArray(Entity):
                                                                                                    """
                                                                                                    nas port array
                                                                                                    
                                                                                                    .. attribute:: sub_id
                                                                                                    
                                                                                                    	sub id
                                                                                                    	**type**\:  :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                    
                                                                                                    .. attribute:: operator
                                                                                                    
                                                                                                    	operator
                                                                                                    	**type**\:  :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	value
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                        self.yang_name = "nas-port-array"
                                                                                                        self.yang_parent_name = "nas-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('sub_id', (YLeaf(YType.enumeration, 'sub-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchNasPortSubIdEn', '')])),
                                                                                                            ('operator', (YLeaf(YType.enumeration, 'operator'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchLogicalOperatorEn', '')])),
                                                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                                        ])
                                                                                                        self.sub_id = None
                                                                                                        self.operator = None
                                                                                                        self.value = None
                                                                                                        self._segment_path = lambda: "nas-port-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['sub_id', 'operator', 'value'], name, value)


                                                                                            class ServiceName(Entity):
                                                                                                """
                                                                                                Service Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                    self.yang_name = "service-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "service-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                            class ServiceNameRegex(Entity):
                                                                                                """
                                                                                                Service Name Regular Exp
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                    self.yang_name = "service-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "service-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                            class SrcAddrIpv4(Entity):
                                                                                                """
                                                                                                Source Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class DstAddrIpv4(Entity):
                                                                                                """
                                                                                                Destination Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class SrcAddrIpv6(Entity):
                                                                                                """
                                                                                                Source Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class DstAddrIpv6(Entity):
                                                                                                """
                                                                                                Destination Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class SrcAddrMac(Entity):
                                                                                                """
                                                                                                Source Address MAC
                                                                                                
                                                                                                .. attribute:: mac_addr_array
                                                                                                
                                                                                                	mac addr array
                                                                                                	**type**\: list of  		 :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                    self.yang_name = "src-addr-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("mac-addr-array", ("mac_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.mac_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                                class MacAddrArray(Entity):
                                                                                                    """
                                                                                                    mac addr array
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                        self.yang_name = "mac-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                            ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.mac_addr = []
                                                                                                        self.mask = []
                                                                                                        self._segment_path = lambda: "mac-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                            class Timer(Entity):
                                                                                                """
                                                                                                Timer
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                    self.yang_name = "timer"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "timer"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                            class TimerRegexp(Entity):
                                                                                                """
                                                                                                Timer Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                    self.yang_name = "timer-regexp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "timer-regexp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                            class TunnelName(Entity):
                                                                                                """
                                                                                                Tunnel Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                    self.yang_name = "tunnel-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "tunnel-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                            class TunnelNameRegex(Entity):
                                                                                                """
                                                                                                Tunnel Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "tunnel-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                            class UserName(Entity):
                                                                                                """
                                                                                                User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                    self.yang_name = "user-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "user-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                            class UserNameRegex(Entity):
                                                                                                """
                                                                                                User Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                    self.yang_name = "user-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "user-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                            class AuthUsername(Entity):
                                                                                                """
                                                                                                Authenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                    self.yang_name = "auth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-username"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                            class AuthUsernameRegex(Entity):
                                                                                                """
                                                                                                Authenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "auth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-username-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                            class UnauthUsername(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                    self.yang_name = "unauth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-username"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                            class UnauthUsernameRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-username-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                            class AuthDomain(Entity):
                                                                                                """
                                                                                                Authenticated domain name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                    self.yang_name = "auth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                            class AuthDomainRegex(Entity):
                                                                                                """
                                                                                                Authenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "auth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                            class UnauthDomain(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                    self.yang_name = "unauth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                            class UnauthDomainRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                            class VendorId(Entity):
                                                                                                """
                                                                                                Vendor ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                    self.yang_name = "vendor-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "vendor-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                            class VendorIdRegex(Entity):
                                                                                                """
                                                                                                Vendor ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                    self.yang_name = "vendor-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "vendor-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                            class AccessInterface(Entity):
                                                                                                """
                                                                                                Access interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                    self.yang_name = "access-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "access-interface"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                            class InputInterface(Entity):
                                                                                                """
                                                                                                Input interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                    self.yang_name = "input-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "input-interface"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                            class InputIntfhdl(Entity):
                                                                                                """
                                                                                                Input interface handle
                                                                                                
                                                                                                .. attribute:: uint64_array
                                                                                                
                                                                                                	uint64 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..18446744073709551615
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                    self.yang_name = "input-intfhdl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint64_array', (YLeafList(YType.uint64, 'uint64_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint64_array = []
                                                                                                    self._segment_path = lambda: "input-intfhdl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                            class Ethertype(Entity):
                                                                                                """
                                                                                                Ethernet type
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                    self.yang_name = "ethertype"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ethertype"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ethertype"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FlowKeyData(Entity):
                                                                                                """
                                                                                                Flow key structure
                                                                                                
                                                                                                .. attribute:: flow_keys
                                                                                                
                                                                                                	flow keys
                                                                                                	**type**\:  :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                                
                                                                                                .. attribute:: max_count
                                                                                                
                                                                                                	Maximum count of flows
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: idle_timeout
                                                                                                
                                                                                                	Idle timeout of flows (in seconds)
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                	**units**\: second
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                    self.yang_name = "flow-key-data"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("flow-keys", ("flow_keys", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys))])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('max_count', (YLeaf(YType.uint16, 'max-count'), ['int'])),
                                                                                                        ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                                                    ])
                                                                                                    self.max_count = None
                                                                                                    self.idle_timeout = None

                                                                                                    self.flow_keys = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                    self.flow_keys.parent = self
                                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                    self._segment_path = lambda: "flow-key-data"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['max_count', 'idle_timeout'], name, value)


                                                                                                class FlowKeys(Entity):
                                                                                                    """
                                                                                                    flow keys
                                                                                                    
                                                                                                    .. attribute:: keys
                                                                                                    
                                                                                                    	keys
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                    
                                                                                                    .. attribute:: num
                                                                                                    
                                                                                                    	num
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                        self.yang_name = "flow-keys"
                                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('keys', (YLeaf(YType.str, 'keys'), ['str'])),
                                                                                                            ('num', (YLeaf(YType.uint8, 'num'), ['int'])),
                                                                                                        ])
                                                                                                        self.keys = None
                                                                                                        self.num = None
                                                                                                        self._segment_path = lambda: "flow-keys"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                            class DhcpClientId(Entity):
                                                                                                """
                                                                                                Dhcp Client ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dhcp-client-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                            class DhcpClientIdRegex(Entity):
                                                                                                """
                                                                                                Dhcp Client ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                            class CircuitId(Entity):
                                                                                                """
                                                                                                Circuit ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                    self.yang_name = "circuit-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "circuit-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                            class CircuitIdRegex(Entity):
                                                                                                """
                                                                                                Circuit ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                    self.yang_name = "circuit-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "circuit-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                            class RemoteId(Entity):
                                                                                                """
                                                                                                Remote ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                    self.yang_name = "remote-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "remote-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                            class RemoteIdRegex(Entity):
                                                                                                """
                                                                                                Remote ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                    self.yang_name = "remote-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "remote-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                            class SrcPort(Entity):
                                                                                                """
                                                                                                Source port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                    self.yang_name = "src-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "src-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class DstPort(Entity):
                                                                                                """
                                                                                                Destination port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                    self.yang_name = "dst-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "dst-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                        class ExcdclassP(Entity):
                                                                            """
                                                                            excdclass p
                                                                            
                                                                            .. attribute:: class_map_bg
                                                                            
                                                                            	class map bg
                                                                            	**type**\: list of  		 :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP, self).__init__()

                                                                                self.yang_name = "excdclass-p"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("class-map-bg", ("class_map_bg", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg))])
                                                                                self._leafs = OrderedDict()

                                                                                self.class_map_bg = YList(self)
                                                                                self._segment_path = lambda: "excdclass-p"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP, [], name, value)


                                                                            class ClassMapBg(Entity):
                                                                                """
                                                                                class map bg
                                                                                
                                                                                .. attribute:: match_infop
                                                                                
                                                                                	Pointer to the first Match info
                                                                                	**type**\:  :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop>`
                                                                                
                                                                                .. attribute:: name
                                                                                
                                                                                	Name of the class\-map
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..65
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Class\-Map Type QoS/PBR/Netflow/..
                                                                                	**type**\:  :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                                                
                                                                                .. attribute:: mode
                                                                                
                                                                                	Class\-Map Mode Match any/Match all
                                                                                	**type**\:  :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                                
                                                                                .. attribute:: description
                                                                                
                                                                                	description
                                                                                	**type**\: str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg, self).__init__()

                                                                                    self.yang_name = "class-map-bg"
                                                                                    self.yang_parent_name = "excdclass-p"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("match-infop", ("match_infop", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapTypeEn', '')])),
                                                                                        ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapModeEn', '')])),
                                                                                        ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                    ])
                                                                                    self.name = None
                                                                                    self.type = None
                                                                                    self.mode = None
                                                                                    self.description = None

                                                                                    self.match_infop = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop()
                                                                                    self.match_infop.parent = self
                                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                                    self._segment_path = lambda: "class-map-bg"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg, ['name', 'type', 'mode', 'description'], name, value)


                                                                                class MatchInfop(Entity):
                                                                                    """
                                                                                    Pointer to the first Match info
                                                                                    
                                                                                    .. attribute:: class_match_info_st
                                                                                    
                                                                                    	class match info st
                                                                                    	**type**\: list of  		 :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop, self).__init__()

                                                                                        self.yang_name = "match-infop"
                                                                                        self.yang_parent_name = "class-map-bg"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("class-match-info-st", ("class_match_info_st", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.class_match_info_st = YList(self)
                                                                                        self._segment_path = lambda: "match-infop"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop, [], name, value)


                                                                                    class ClassMatchInfoSt(Entity):
                                                                                        """
                                                                                        class match info st
                                                                                        
                                                                                        .. attribute:: match_data
                                                                                        
                                                                                        	Match criteria
                                                                                        	**type**\:  :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                        
                                                                                        .. attribute:: flags
                                                                                        
                                                                                        	Flags
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                            self.yang_name = "class-match-info-st"
                                                                                            self.yang_parent_name = "match-infop"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("match-data", ("match_data", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData))])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                            ])
                                                                                            self.flags = None

                                                                                            self.match_data = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                            self.match_data.parent = self
                                                                                            self._children_name_map["match_data"] = "match-data"
                                                                                            self._segment_path = lambda: "class-match-info-st"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                        class MatchData(Entity):
                                                                                            """
                                                                                            Match criteria
                                                                                            
                                                                                            .. attribute:: ipv4_dscp
                                                                                            
                                                                                            	IPv4 DSCP
                                                                                            	**type**\:  :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv6_dscp
                                                                                            
                                                                                            	IPv6 DSCP
                                                                                            	**type**\:  :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                            
                                                                                            .. attribute:: dscp
                                                                                            
                                                                                            	Match DSCP range array
                                                                                            	**type**\:  :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv4_prec
                                                                                            
                                                                                            	IPv4 Precedence
                                                                                            	**type**\:  :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                            
                                                                                            .. attribute:: ipv6_prec
                                                                                            
                                                                                            	IPv6 Precedence
                                                                                            	**type**\:  :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                            
                                                                                            .. attribute:: prec
                                                                                            
                                                                                            	Match Precedence array
                                                                                            	**type**\:  :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                            
                                                                                            .. attribute:: discard_class
                                                                                            
                                                                                            	Match Discard Class array
                                                                                            	**type**\:  :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                            
                                                                                            .. attribute:: qos_group
                                                                                            
                                                                                            	Match QoS group array
                                                                                            	**type**\:  :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                            
                                                                                            .. attribute:: traffic_class
                                                                                            
                                                                                            	Match Traffic class array
                                                                                            	**type**\:  :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                            
                                                                                            .. attribute:: proto
                                                                                            
                                                                                            	Match Protocol array
                                                                                            	**type**\:  :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                            
                                                                                            .. attribute:: icmp_v4
                                                                                            
                                                                                            	Match ICMPV4 Protocol
                                                                                            	**type**\:  :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                            
                                                                                            .. attribute:: icmp_v6
                                                                                            
                                                                                            	Match ICMPV6 Protocol array
                                                                                            	**type**\:  :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                            
                                                                                            .. attribute:: ipv4_packet_len
                                                                                            
                                                                                            	IPv4 packet length array
                                                                                            	**type**\:  :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv6_packet_len
                                                                                            
                                                                                            	IPv6 packet length array
                                                                                            	**type**\:  :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                            
                                                                                            .. attribute:: packet_len
                                                                                            
                                                                                            	Match packet length array
                                                                                            	**type**\:  :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                            
                                                                                            .. attribute:: flow_tag
                                                                                            
                                                                                            	Match flow\-tag array
                                                                                            	**type**\:  :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                            
                                                                                            .. attribute:: tcp_flag
                                                                                            
                                                                                            	Match tcp flag value
                                                                                            	**type**\:  :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                            
                                                                                            .. attribute:: icmpv4_type
                                                                                            
                                                                                            	Match ipv4 icmp type
                                                                                            	**type**\:  :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                            
                                                                                            .. attribute:: icmpv4_code
                                                                                            
                                                                                            	Match ipv4 icmp code
                                                                                            	**type**\:  :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                            
                                                                                            .. attribute:: icmpv6_type
                                                                                            
                                                                                            	Match ipv6 icmp type
                                                                                            	**type**\:  :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                            
                                                                                            .. attribute:: icmpv6_code
                                                                                            
                                                                                            	Match ipv6 icmp code
                                                                                            	**type**\:  :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                            
                                                                                            .. attribute:: mpls_exp
                                                                                            
                                                                                            	Match MPLS experimental topmost array
                                                                                            	**type**\:  :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                            
                                                                                            .. attribute:: mpls_exp_imp
                                                                                            
                                                                                            	Match MPLS experimental imposition array
                                                                                            	**type**\:  :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                                            
                                                                                            	MPLS Disposition IPv4 Access\-list
                                                                                            	**type**\:  :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                                            
                                                                                            	MPLS Disposition IPv6 Access\-list
                                                                                            	**type**\:  :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_top_label
                                                                                            
                                                                                            	MPLS Topmost LABEL
                                                                                            	**type**\:  :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                            
                                                                                            .. attribute:: cos
                                                                                            
                                                                                            	Match CoS array
                                                                                            	**type**\:  :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                            
                                                                                            .. attribute:: cos_inr
                                                                                            
                                                                                            	Match inner header CoS
                                                                                            	**type**\:  :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                            
                                                                                            .. attribute:: dei
                                                                                            
                                                                                            	Match DEI Bit
                                                                                            	**type**\:  :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                            
                                                                                            .. attribute:: dei_inr
                                                                                            
                                                                                            	Match inner DEI Bit
                                                                                            	**type**\:  :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                            
                                                                                            .. attribute:: vlan
                                                                                            
                                                                                            	Match VLAN array
                                                                                            	**type**\:  :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                            
                                                                                            .. attribute:: vlan_inr
                                                                                            
                                                                                            	Match inner header VLAN range array
                                                                                            	**type**\:  :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                            
                                                                                            .. attribute:: fr_dlci
                                                                                            
                                                                                            	Match FR DLCI range array
                                                                                            	**type**\:  :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                            
                                                                                            .. attribute:: src_mac
                                                                                            
                                                                                            	Match Source MAC address
                                                                                            	**type**\:  :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                            
                                                                                            .. attribute:: dst_mac
                                                                                            
                                                                                            	Match Destination MAC address
                                                                                            	**type**\:  :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                            
                                                                                            .. attribute:: atm_clp
                                                                                            
                                                                                            	Match ATM CLP level
                                                                                            	**type**\:  :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                            
                                                                                            .. attribute:: fr_de
                                                                                            
                                                                                            	Match FR DE value
                                                                                            	**type**\:  :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                            
                                                                                            .. attribute:: ipv4_acl
                                                                                            
                                                                                            	IPv4 Access\-list
                                                                                            	**type**\:  :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                            
                                                                                            .. attribute:: ipv6_acl
                                                                                            
                                                                                            	IPv6 Access\-list
                                                                                            	**type**\:  :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                            
                                                                                            .. attribute:: ether_service_acl
                                                                                            
                                                                                            	Ethernet\-Services Access\-list
                                                                                            	**type**\:  :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                            
                                                                                            .. attribute:: avail_id
                                                                                            
                                                                                            	Available Identifiers
                                                                                            	**type**\:  :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                            
                                                                                            .. attribute:: media_type
                                                                                            
                                                                                            	Media Type
                                                                                            	**type**\:  :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                            
                                                                                            .. attribute:: subs_protocol
                                                                                            
                                                                                            	Protocol
                                                                                            	**type**\:  :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                            
                                                                                            .. attribute:: dnis
                                                                                            
                                                                                            	DNIS
                                                                                            	**type**\:  :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                            
                                                                                            .. attribute:: dnis_regex
                                                                                            
                                                                                            	DNIS Regular Expression
                                                                                            	**type**\:  :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                            
                                                                                            .. attribute:: domain
                                                                                            
                                                                                            	Domain Name
                                                                                            	**type**\:  :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                            
                                                                                            .. attribute:: domain_regex
                                                                                            
                                                                                            	Domain Regular Expression
                                                                                            	**type**\:  :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                            
                                                                                            .. attribute:: nas_port
                                                                                            
                                                                                            	NAS Port
                                                                                            	**type**\:  :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                            
                                                                                            .. attribute:: service_name
                                                                                            
                                                                                            	Service Name
                                                                                            	**type**\:  :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                            
                                                                                            .. attribute:: service_name_regex
                                                                                            
                                                                                            	Service Name Regular Exp
                                                                                            	**type**\:  :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv4
                                                                                            
                                                                                            	Source Address IPV4
                                                                                            	**type**\:  :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv4
                                                                                            
                                                                                            	Destination Address IPV4
                                                                                            	**type**\:  :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv6
                                                                                            
                                                                                            	Source Address IPV6
                                                                                            	**type**\:  :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv6
                                                                                            
                                                                                            	Destination Address IPV6
                                                                                            	**type**\:  :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: src_addr_mac
                                                                                            
                                                                                            	Source Address MAC
                                                                                            	**type**\:  :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                            
                                                                                            .. attribute:: timer
                                                                                            
                                                                                            	Timer
                                                                                            	**type**\:  :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                            
                                                                                            .. attribute:: timer_regexp
                                                                                            
                                                                                            	Timer Regular Expression
                                                                                            	**type**\:  :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                            
                                                                                            .. attribute:: tunnel_name
                                                                                            
                                                                                            	Tunnel Name
                                                                                            	**type**\:  :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                            
                                                                                            .. attribute:: tunnel_name_regex
                                                                                            
                                                                                            	Tunnel Name Regular Expression
                                                                                            	**type**\:  :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                            
                                                                                            .. attribute:: user_name
                                                                                            
                                                                                            	User Name
                                                                                            	**type**\:  :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                            
                                                                                            .. attribute:: user_name_regex
                                                                                            
                                                                                            	User Name Regular Expression
                                                                                            	**type**\:  :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                            
                                                                                            .. attribute:: auth_username
                                                                                            
                                                                                            	Authenticated User Name
                                                                                            	**type**\:  :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                            
                                                                                            .. attribute:: auth_username_regex
                                                                                            
                                                                                            	Authenticated User Name RegEx
                                                                                            	**type**\:  :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_username
                                                                                            
                                                                                            	Unauthenticated User Name
                                                                                            	**type**\:  :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                            
                                                                                            .. attribute:: unauth_username_regex
                                                                                            
                                                                                            	Unauthenticated User Name RegEx
                                                                                            	**type**\:  :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: auth_domain
                                                                                            
                                                                                            	Authenticated domain name
                                                                                            	**type**\:  :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                            
                                                                                            .. attribute:: auth_domain_regex
                                                                                            
                                                                                            	Authenticated Domain Name RegEx
                                                                                            	**type**\:  :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_domain
                                                                                            
                                                                                            	Unauthenticated Domain Name
                                                                                            	**type**\:  :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                            
                                                                                            .. attribute:: unauth_domain_regex
                                                                                            
                                                                                            	Unauthenticated Domain Name RegEx
                                                                                            	**type**\:  :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: vendor_id
                                                                                            
                                                                                            	Vendor ID
                                                                                            	**type**\:  :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                            
                                                                                            .. attribute:: vendor_id_regex
                                                                                            
                                                                                            	Vendor ID RegEx
                                                                                            	**type**\:  :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                            
                                                                                            .. attribute:: access_interface
                                                                                            
                                                                                            	Access interface
                                                                                            	**type**\:  :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                            
                                                                                            .. attribute:: input_interface
                                                                                            
                                                                                            	Input interface
                                                                                            	**type**\:  :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                            
                                                                                            .. attribute:: input_intfhdl
                                                                                            
                                                                                            	Input interface handle
                                                                                            	**type**\:  :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                            
                                                                                            .. attribute:: ethertype
                                                                                            
                                                                                            	Ethernet type
                                                                                            	**type**\:  :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                            
                                                                                            .. attribute:: flow_key_data
                                                                                            
                                                                                            	Flow key structure
                                                                                            	**type**\:  :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id
                                                                                            
                                                                                            	Dhcp Client ID
                                                                                            	**type**\:  :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id_regex
                                                                                            
                                                                                            	Dhcp Client ID RegEx
                                                                                            	**type**\:  :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                            
                                                                                            .. attribute:: circuit_id
                                                                                            
                                                                                            	Circuit ID
                                                                                            	**type**\:  :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                            
                                                                                            .. attribute:: circuit_id_regex
                                                                                            
                                                                                            	Circuit ID RegEx
                                                                                            	**type**\:  :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                            
                                                                                            .. attribute:: remote_id
                                                                                            
                                                                                            	Remote ID
                                                                                            	**type**\:  :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                            
                                                                                            .. attribute:: remote_id_regex
                                                                                            
                                                                                            	Remote ID RegEx
                                                                                            	**type**\:  :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                            
                                                                                            .. attribute:: src_port
                                                                                            
                                                                                            	Source port
                                                                                            	**type**\:  :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                            
                                                                                            .. attribute:: dst_port
                                                                                            
                                                                                            	Destination port
                                                                                            	**type**\:  :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	type
                                                                                            	**type**\:  :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                            
                                                                                            .. attribute:: mpls_top_eos
                                                                                            
                                                                                            	MPLS Topmost EOS
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: fragment_type
                                                                                            
                                                                                            	Fragment type
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: authen_status
                                                                                            
                                                                                            	Authentication Status
                                                                                            	**type**\:  :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                            
                                                                                            .. attribute:: mlp_negotiated
                                                                                            
                                                                                            	MLP Negotiated
                                                                                            	**type**\:  :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                                self.yang_name = "match-data"
                                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("ipv4-dscp", ("ipv4_dscp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp)), ("ipv6-dscp", ("ipv6_dscp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp)), ("dscp", ("dscp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp)), ("ipv4-prec", ("ipv4_prec", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec)), ("ipv6-prec", ("ipv6_prec", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec)), ("prec", ("prec", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec)), ("discard-class", ("discard_class", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass)), ("qos-group", ("qos_group", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup)), ("traffic-class", ("traffic_class", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass)), ("proto", ("proto", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto)), ("icmp-v4", ("icmp_v4", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4)), ("icmp-v6", ("icmp_v6", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6)), ("ipv4-packet-len", ("ipv4_packet_len", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen)), ("ipv6-packet-len", ("ipv6_packet_len", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen)), ("packet-len", ("packet_len", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen)), ("flow-tag", ("flow_tag", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag)), ("tcp-flag", ("tcp_flag", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag)), ("icmpv4-type", ("icmpv4_type", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type)), ("icmpv4-code", ("icmpv4_code", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code)), ("icmpv6-type", ("icmpv6_type", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type)), ("icmpv6-code", ("icmpv6_code", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code)), ("mpls-exp", ("mpls_exp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp)), ("mpls-exp-imp", ("mpls_exp_imp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp)), ("mpls-disp-ipv4-acl", ("mpls_disp_ipv4_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl)), ("mpls-disp-ipv6-acl", ("mpls_disp_ipv6_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl)), ("mpls-top-label", ("mpls_top_label", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel)), ("cos", ("cos", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos)), ("cos-inr", ("cos_inr", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr)), ("dei", ("dei", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei)), ("dei-inr", ("dei_inr", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr)), ("vlan", ("vlan", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan)), ("vlan-inr", ("vlan_inr", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)), ("fr-dlci", ("fr_dlci", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci)), ("src-mac", ("src_mac", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac)), ("dst-mac", ("dst_mac", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac)), ("atm-clp", ("atm_clp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp)), ("fr-de", ("fr_de", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe)), ("ipv4-acl", ("ipv4_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl)), ("ipv6-acl", ("ipv6_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl)), ("ether-service-acl", ("ether_service_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl)), ("avail-id", ("avail_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId)), ("media-type", ("media_type", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType)), ("subs-protocol", ("subs_protocol", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol)), ("dnis", ("dnis", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis)), ("dnis-regex", ("dnis_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex)), ("domain", ("domain", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain)), ("domain-regex", ("domain_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex)), ("nas-port", ("nas_port", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort)), ("service-name", ("service_name", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName)), ("service-name-regex", ("service_name_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex)), ("src-addr-ipv4", ("src_addr_ipv4", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4)), ("dst-addr-ipv4", ("dst_addr_ipv4", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4)), ("src-addr-ipv6", ("src_addr_ipv6", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6)), ("dst-addr-ipv6", ("dst_addr_ipv6", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6)), ("src-addr-mac", ("src_addr_mac", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac)), ("timer", ("timer", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer)), ("timer-regexp", ("timer_regexp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp)), ("tunnel-name", ("tunnel_name", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName)), ("tunnel-name-regex", ("tunnel_name_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex)), ("user-name", ("user_name", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName)), ("user-name-regex", ("user_name_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex)), ("auth-username", ("auth_username", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername)), ("auth-username-regex", ("auth_username_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex)), ("unauth-username", ("unauth_username", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername)), ("unauth-username-regex", ("unauth_username_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex)), ("auth-domain", ("auth_domain", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain)), ("auth-domain-regex", ("auth_domain_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex)), ("unauth-domain", ("unauth_domain", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain)), ("unauth-domain-regex", ("unauth_domain_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex)), ("vendor-id", ("vendor_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId)), ("vendor-id-regex", ("vendor_id_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex)), ("access-interface", ("access_interface", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface)), ("input-interface", ("input_interface", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface)), ("input-intfhdl", ("input_intfhdl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl)), ("ethertype", ("ethertype", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype)), ("flow-key-data", ("flow_key_data", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData)), ("dhcp-client-id", ("dhcp_client_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId)), ("dhcp-client-id-regex", ("dhcp_client_id_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex)), ("circuit-id", ("circuit_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId)), ("circuit-id-regex", ("circuit_id_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex)), ("remote-id", ("remote_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId)), ("remote-id-regex", ("remote_id_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex)), ("src-port", ("src_port", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort)), ("dst-port", ("dst_port", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort))])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchTypeEn', '')])),
                                                                                                    ('mpls_top_eos', (YLeaf(YType.uint8, 'mpls-top-eos'), ['int'])),
                                                                                                    ('fragment_type', (YLeaf(YType.uint8, 'fragment-type'), ['int'])),
                                                                                                    ('authen_status', (YLeaf(YType.enumeration, 'authen-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchAuthenStatusEn', '')])),
                                                                                                    ('mlp_negotiated', (YLeaf(YType.enumeration, 'mlp-negotiated'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchMlpNegotiatedEn', '')])),
                                                                                                ])
                                                                                                self.type = None
                                                                                                self.mpls_top_eos = None
                                                                                                self.fragment_type = None
                                                                                                self.authen_status = None
                                                                                                self.mlp_negotiated = None

                                                                                                self.ipv4_dscp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                                self.ipv4_dscp.parent = self
                                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"

                                                                                                self.ipv6_dscp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                                self.ipv6_dscp.parent = self
                                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"

                                                                                                self.dscp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                                self.dscp.parent = self
                                                                                                self._children_name_map["dscp"] = "dscp"

                                                                                                self.ipv4_prec = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                                self.ipv4_prec.parent = self
                                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"

                                                                                                self.ipv6_prec = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                                self.ipv6_prec.parent = self
                                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"

                                                                                                self.prec = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                                self.prec.parent = self
                                                                                                self._children_name_map["prec"] = "prec"

                                                                                                self.discard_class = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                                self.discard_class.parent = self
                                                                                                self._children_name_map["discard_class"] = "discard-class"

                                                                                                self.qos_group = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                                self.qos_group.parent = self
                                                                                                self._children_name_map["qos_group"] = "qos-group"

                                                                                                self.traffic_class = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                                self.traffic_class.parent = self
                                                                                                self._children_name_map["traffic_class"] = "traffic-class"

                                                                                                self.proto = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                                self.proto.parent = self
                                                                                                self._children_name_map["proto"] = "proto"

                                                                                                self.icmp_v4 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                                self.icmp_v4.parent = self
                                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"

                                                                                                self.icmp_v6 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                                self.icmp_v6.parent = self
                                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"

                                                                                                self.ipv4_packet_len = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                                self.ipv4_packet_len.parent = self
                                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"

                                                                                                self.ipv6_packet_len = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                                self.ipv6_packet_len.parent = self
                                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"

                                                                                                self.packet_len = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                                self.packet_len.parent = self
                                                                                                self._children_name_map["packet_len"] = "packet-len"

                                                                                                self.flow_tag = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                                self.flow_tag.parent = self
                                                                                                self._children_name_map["flow_tag"] = "flow-tag"

                                                                                                self.tcp_flag = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                                self.tcp_flag.parent = self
                                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"

                                                                                                self.icmpv4_type = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                                self.icmpv4_type.parent = self
                                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"

                                                                                                self.icmpv4_code = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                                self.icmpv4_code.parent = self
                                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"

                                                                                                self.icmpv6_type = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                                self.icmpv6_type.parent = self
                                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"

                                                                                                self.icmpv6_code = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                                self.icmpv6_code.parent = self
                                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"

                                                                                                self.mpls_exp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                                self.mpls_exp.parent = self
                                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"

                                                                                                self.mpls_exp_imp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                                self.mpls_exp_imp.parent = self
                                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"

                                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"

                                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"

                                                                                                self.mpls_top_label = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                                self.mpls_top_label.parent = self
                                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"

                                                                                                self.cos = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                                self.cos.parent = self
                                                                                                self._children_name_map["cos"] = "cos"

                                                                                                self.cos_inr = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                                self.cos_inr.parent = self
                                                                                                self._children_name_map["cos_inr"] = "cos-inr"

                                                                                                self.dei = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                                self.dei.parent = self
                                                                                                self._children_name_map["dei"] = "dei"

                                                                                                self.dei_inr = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                                self.dei_inr.parent = self
                                                                                                self._children_name_map["dei_inr"] = "dei-inr"

                                                                                                self.vlan = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                                self.vlan.parent = self
                                                                                                self._children_name_map["vlan"] = "vlan"

                                                                                                self.vlan_inr = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                                self.vlan_inr.parent = self
                                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"

                                                                                                self.fr_dlci = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                                self.fr_dlci.parent = self
                                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"

                                                                                                self.src_mac = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                                self.src_mac.parent = self
                                                                                                self._children_name_map["src_mac"] = "src-mac"

                                                                                                self.dst_mac = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                                self.dst_mac.parent = self
                                                                                                self._children_name_map["dst_mac"] = "dst-mac"

                                                                                                self.atm_clp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                                self.atm_clp.parent = self
                                                                                                self._children_name_map["atm_clp"] = "atm-clp"

                                                                                                self.fr_de = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                                self.fr_de.parent = self
                                                                                                self._children_name_map["fr_de"] = "fr-de"

                                                                                                self.ipv4_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                                self.ipv4_acl.parent = self
                                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"

                                                                                                self.ipv6_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                                self.ipv6_acl.parent = self
                                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"

                                                                                                self.ether_service_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                                self.ether_service_acl.parent = self
                                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"

                                                                                                self.avail_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                                self.avail_id.parent = self
                                                                                                self._children_name_map["avail_id"] = "avail-id"

                                                                                                self.media_type = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                                self.media_type.parent = self
                                                                                                self._children_name_map["media_type"] = "media-type"

                                                                                                self.subs_protocol = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                                self.subs_protocol.parent = self
                                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"

                                                                                                self.dnis = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                                self.dnis.parent = self
                                                                                                self._children_name_map["dnis"] = "dnis"

                                                                                                self.dnis_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                                self.dnis_regex.parent = self
                                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"

                                                                                                self.domain = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                                self.domain.parent = self
                                                                                                self._children_name_map["domain"] = "domain"

                                                                                                self.domain_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                                self.domain_regex.parent = self
                                                                                                self._children_name_map["domain_regex"] = "domain-regex"

                                                                                                self.nas_port = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                                self.nas_port.parent = self
                                                                                                self._children_name_map["nas_port"] = "nas-port"

                                                                                                self.service_name = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                                self.service_name.parent = self
                                                                                                self._children_name_map["service_name"] = "service-name"

                                                                                                self.service_name_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                                self.service_name_regex.parent = self
                                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"

                                                                                                self.src_addr_ipv4 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                                self.src_addr_ipv4.parent = self
                                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"

                                                                                                self.dst_addr_ipv4 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                                self.dst_addr_ipv4.parent = self
                                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"

                                                                                                self.src_addr_ipv6 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                                self.src_addr_ipv6.parent = self
                                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"

                                                                                                self.dst_addr_ipv6 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                                self.dst_addr_ipv6.parent = self
                                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"

                                                                                                self.src_addr_mac = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                                self.src_addr_mac.parent = self
                                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"

                                                                                                self.timer = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                                self.timer.parent = self
                                                                                                self._children_name_map["timer"] = "timer"

                                                                                                self.timer_regexp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                                self.timer_regexp.parent = self
                                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"

                                                                                                self.tunnel_name = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                                self.tunnel_name.parent = self
                                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"

                                                                                                self.tunnel_name_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                                self.tunnel_name_regex.parent = self
                                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"

                                                                                                self.user_name = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                                self.user_name.parent = self
                                                                                                self._children_name_map["user_name"] = "user-name"

                                                                                                self.user_name_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                                self.user_name_regex.parent = self
                                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"

                                                                                                self.auth_username = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                                self.auth_username.parent = self
                                                                                                self._children_name_map["auth_username"] = "auth-username"

                                                                                                self.auth_username_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                                self.auth_username_regex.parent = self
                                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"

                                                                                                self.unauth_username = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                                self.unauth_username.parent = self
                                                                                                self._children_name_map["unauth_username"] = "unauth-username"

                                                                                                self.unauth_username_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                                self.unauth_username_regex.parent = self
                                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"

                                                                                                self.auth_domain = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                                self.auth_domain.parent = self
                                                                                                self._children_name_map["auth_domain"] = "auth-domain"

                                                                                                self.auth_domain_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                                self.auth_domain_regex.parent = self
                                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"

                                                                                                self.unauth_domain = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                                self.unauth_domain.parent = self
                                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"

                                                                                                self.unauth_domain_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                                self.unauth_domain_regex.parent = self
                                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"

                                                                                                self.vendor_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                                self.vendor_id.parent = self
                                                                                                self._children_name_map["vendor_id"] = "vendor-id"

                                                                                                self.vendor_id_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                                self.vendor_id_regex.parent = self
                                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"

                                                                                                self.access_interface = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                                self.access_interface.parent = self
                                                                                                self._children_name_map["access_interface"] = "access-interface"

                                                                                                self.input_interface = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                                self.input_interface.parent = self
                                                                                                self._children_name_map["input_interface"] = "input-interface"

                                                                                                self.input_intfhdl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                                self.input_intfhdl.parent = self
                                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"

                                                                                                self.ethertype = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                                self.ethertype.parent = self
                                                                                                self._children_name_map["ethertype"] = "ethertype"

                                                                                                self.flow_key_data = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                                self.flow_key_data.parent = self
                                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"

                                                                                                self.dhcp_client_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                                self.dhcp_client_id.parent = self
                                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"

                                                                                                self.dhcp_client_id_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                                self.dhcp_client_id_regex.parent = self
                                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"

                                                                                                self.circuit_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                                self.circuit_id.parent = self
                                                                                                self._children_name_map["circuit_id"] = "circuit-id"

                                                                                                self.circuit_id_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                                self.circuit_id_regex.parent = self
                                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"

                                                                                                self.remote_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                                self.remote_id.parent = self
                                                                                                self._children_name_map["remote_id"] = "remote-id"

                                                                                                self.remote_id_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                                self.remote_id_regex.parent = self
                                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"

                                                                                                self.src_port = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                                self.src_port.parent = self
                                                                                                self._children_name_map["src_port"] = "src-port"

                                                                                                self.dst_port = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                                self.dst_port.parent = self
                                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                                self._segment_path = lambda: "match-data"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['type', 'mpls_top_eos', 'fragment_type', 'authen_status', 'mlp_negotiated'], name, value)


                                                                                            class Ipv4Dscp(Entity):
                                                                                                """
                                                                                                IPv4 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv4-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv6Dscp(Entity):
                                                                                                """
                                                                                                IPv6 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv6-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Dscp(Entity):
                                                                                                """
                                                                                                Match DSCP range array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                    self.yang_name = "dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv4Prec(Entity):
                                                                                                """
                                                                                                IPv4 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                    self.yang_name = "ipv4-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "ipv4-prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                            class Ipv6Prec(Entity):
                                                                                                """
                                                                                                IPv6 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                    self.yang_name = "ipv6-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "ipv6-prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                            class Prec(Entity):
                                                                                                """
                                                                                                Match Precedence array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                    self.yang_name = "prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                            class DiscardClass(Entity):
                                                                                                """
                                                                                                Match Discard Class array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                    self.yang_name = "discard-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "discard-class"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                            class QosGroup(Entity):
                                                                                                """
                                                                                                Match QoS group array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                    self.yang_name = "qos-group"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "qos-group"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "qos-group"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class TrafficClass(Entity):
                                                                                                """
                                                                                                Match Traffic class array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                    self.yang_name = "traffic-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "traffic-class"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "traffic-class"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Proto(Entity):
                                                                                                """
                                                                                                Match Protocol array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                    self.yang_name = "proto"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "proto"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "proto"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class IcmpV4(Entity):
                                                                                                """
                                                                                                Match ICMPV4 Protocol
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                    self.yang_name = "icmp-v4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                    ])
                                                                                                    self.type = None
                                                                                                    self.code = None
                                                                                                    self._segment_path = lambda: "icmp-v4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['type', 'code'], name, value)


                                                                                            class IcmpV6(Entity):
                                                                                                """
                                                                                                Match ICMPV6 Protocol array
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                    self.yang_name = "icmp-v6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                    ])
                                                                                                    self.type = None
                                                                                                    self.code = None
                                                                                                    self._segment_path = lambda: "icmp-v6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['type', 'code'], name, value)


                                                                                            class Ipv4PacketLen(Entity):
                                                                                                """
                                                                                                IPv4 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv6PacketLen(Entity):
                                                                                                """
                                                                                                IPv6 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class PacketLen(Entity):
                                                                                                """
                                                                                                Match packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                    self.yang_name = "packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FlowTag(Entity):
                                                                                                """
                                                                                                Match flow\-tag array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                    self.yang_name = "flow-tag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "flow-tag"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "flow-tag"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class TcpFlag(Entity):
                                                                                                """
                                                                                                Match tcp flag value
                                                                                                
                                                                                                .. attribute:: value
                                                                                                
                                                                                                	Value of TCP flag
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: match_any
                                                                                                
                                                                                                	Match any TCP flag bit
                                                                                                	**type**\: bool
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                    self.yang_name = "tcp-flag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                                        ('match_any', (YLeaf(YType.boolean, 'match-any'), ['bool'])),
                                                                                                    ])
                                                                                                    self.value = None
                                                                                                    self.match_any = None
                                                                                                    self._segment_path = lambda: "tcp-flag"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['value', 'match_any'], name, value)


                                                                                            class Icmpv4Type(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                    self.yang_name = "icmpv4-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv4Code(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                    self.yang_name = "icmpv4-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-code"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv6Type(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                    self.yang_name = "icmpv6-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv6Code(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                    self.yang_name = "icmpv6-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-code"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class MplsExp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental topmost array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "mpls-exp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                            class MplsExpImp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental imposition array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "mpls-exp-imp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                            class MplsDispIpv4Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                            class MplsDispIpv6Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                            class MplsTopLabel(Entity):
                                                                                                """
                                                                                                MPLS Topmost LABEL
                                                                                                
                                                                                                .. attribute:: uint32_rng_array
                                                                                                
                                                                                                	uint32 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                    self.yang_name = "mpls-top-label"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint32_rng_array", ("uint32_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint32_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "mpls-top-label"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                                class Uint32RngArray(Entity):
                                                                                                    """
                                                                                                    uint32 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                        self.yang_name = "uint32_rng_array"
                                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint32, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint32, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint32_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['min', 'max'], name, value)


                                                                                            class Cos(Entity):
                                                                                                """
                                                                                                Match CoS array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                    self.yang_name = "cos"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "cos"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                            class CosInr(Entity):
                                                                                                """
                                                                                                Match inner header CoS
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                    self.yang_name = "cos-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "cos-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                            class Dei(Entity):
                                                                                                """
                                                                                                Match DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                    self.yang_name = "dei"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                    ])
                                                                                                    self.bit_value = None
                                                                                                    self._segment_path = lambda: "dei"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                            class DeiInr(Entity):
                                                                                                """
                                                                                                Match inner DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                    self.yang_name = "dei-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                    ])
                                                                                                    self.bit_value = None
                                                                                                    self._segment_path = lambda: "dei-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                            class Vlan(Entity):
                                                                                                """
                                                                                                Match VLAN array
                                                                                                
                                                                                                .. attribute:: vlan_id_array
                                                                                                
                                                                                                	vlan id array
                                                                                                	**type**\: list of  		 :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                    self.yang_name = "vlan"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("vlan-id-array", ("vlan_id_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.vlan_id_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                                class VlanIdArray(Entity):
                                                                                                    """
                                                                                                    vlan id array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	VLAN mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                        self.yang_name = "vlan-id-array"
                                                                                                        self.yang_parent_name = "vlan"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ('mask', (YLeaf(YType.uint16, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "vlan-id-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['min', 'max', 'mask'], name, value)


                                                                                            class VlanInr(Entity):
                                                                                                """
                                                                                                Match inner header VLAN range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                    self.yang_name = "vlan-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FrDlci(Entity):
                                                                                                """
                                                                                                Match FR DLCI range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                    self.yang_name = "fr-dlci"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "fr-dlci"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class SrcMac(Entity):
                                                                                                """
                                                                                                Match Source MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                    self.yang_name = "src-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.mac_addr = []
                                                                                                    self.mask = []
                                                                                                    self._segment_path = lambda: "src-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                            class DstMac(Entity):
                                                                                                """
                                                                                                Match Destination MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                    self.yang_name = "dst-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.mac_addr = []
                                                                                                    self.mask = []
                                                                                                    self._segment_path = lambda: "dst-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                            class AtmClp(Entity):
                                                                                                """
                                                                                                Match ATM CLP level
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                    self.yang_name = "atm-clp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "atm-clp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                            class FrDe(Entity):
                                                                                                """
                                                                                                Match FR DE value
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                    self.yang_name = "fr-de"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "fr-de"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                            class Ipv4Acl(Entity):
                                                                                                """
                                                                                                IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                    self.yang_name = "ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ipv4-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                            class Ipv6Acl(Entity):
                                                                                                """
                                                                                                IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                    self.yang_name = "ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ipv6-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                            class EtherServiceAcl(Entity):
                                                                                                """
                                                                                                Ethernet\-Services Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                    self.yang_name = "ether-service-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ether-service-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                            class AvailId(Entity):
                                                                                                """
                                                                                                Available Identifiers
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                    self.yang_name = "avail-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "avail-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                            class MediaType(Entity):
                                                                                                """
                                                                                                Media Type
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                    self.yang_name = "media-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "media-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                            class SubsProtocol(Entity):
                                                                                                """
                                                                                                Protocol
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                    self.yang_name = "subs-protocol"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "subs-protocol"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                            class Dnis(Entity):
                                                                                                """
                                                                                                DNIS
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                    self.yang_name = "dnis"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dnis"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                            class DnisRegex(Entity):
                                                                                                """
                                                                                                DNIS Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                    self.yang_name = "dnis-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dnis-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                            class Domain(Entity):
                                                                                                """
                                                                                                Domain Name
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                    self.yang_name = "domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                        ])
                                                                                                        self.domain_name = None
                                                                                                        self.format_name = None
                                                                                                        self._segment_path = lambda: "domain-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class DomainRegex(Entity):
                                                                                                """
                                                                                                Domain Regular Expression
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                    self.yang_name = "domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain-regex"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                        ])
                                                                                                        self.domain_name = None
                                                                                                        self.format_name = None
                                                                                                        self._segment_path = lambda: "domain-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class NasPort(Entity):
                                                                                                """
                                                                                                NAS Port
                                                                                                
                                                                                                .. attribute:: nas_port_array
                                                                                                
                                                                                                	nas port array
                                                                                                	**type**\: list of  		 :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                    self.yang_name = "nas-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("nas-port-array", ("nas_port_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.nas_port_array = YList(self)
                                                                                                    self._segment_path = lambda: "nas-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                                class NasPortArray(Entity):
                                                                                                    """
                                                                                                    nas port array
                                                                                                    
                                                                                                    .. attribute:: sub_id
                                                                                                    
                                                                                                    	sub id
                                                                                                    	**type**\:  :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                    
                                                                                                    .. attribute:: operator
                                                                                                    
                                                                                                    	operator
                                                                                                    	**type**\:  :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	value
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                        self.yang_name = "nas-port-array"
                                                                                                        self.yang_parent_name = "nas-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('sub_id', (YLeaf(YType.enumeration, 'sub-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchNasPortSubIdEn', '')])),
                                                                                                            ('operator', (YLeaf(YType.enumeration, 'operator'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchLogicalOperatorEn', '')])),
                                                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                                        ])
                                                                                                        self.sub_id = None
                                                                                                        self.operator = None
                                                                                                        self.value = None
                                                                                                        self._segment_path = lambda: "nas-port-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['sub_id', 'operator', 'value'], name, value)


                                                                                            class ServiceName(Entity):
                                                                                                """
                                                                                                Service Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                    self.yang_name = "service-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "service-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                            class ServiceNameRegex(Entity):
                                                                                                """
                                                                                                Service Name Regular Exp
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                    self.yang_name = "service-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "service-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                            class SrcAddrIpv4(Entity):
                                                                                                """
                                                                                                Source Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class DstAddrIpv4(Entity):
                                                                                                """
                                                                                                Destination Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class SrcAddrIpv6(Entity):
                                                                                                """
                                                                                                Source Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class DstAddrIpv6(Entity):
                                                                                                """
                                                                                                Destination Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class SrcAddrMac(Entity):
                                                                                                """
                                                                                                Source Address MAC
                                                                                                
                                                                                                .. attribute:: mac_addr_array
                                                                                                
                                                                                                	mac addr array
                                                                                                	**type**\: list of  		 :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                    self.yang_name = "src-addr-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("mac-addr-array", ("mac_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.mac_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                                class MacAddrArray(Entity):
                                                                                                    """
                                                                                                    mac addr array
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                        self.yang_name = "mac-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                            ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.mac_addr = []
                                                                                                        self.mask = []
                                                                                                        self._segment_path = lambda: "mac-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                            class Timer(Entity):
                                                                                                """
                                                                                                Timer
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                    self.yang_name = "timer"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "timer"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                            class TimerRegexp(Entity):
                                                                                                """
                                                                                                Timer Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                    self.yang_name = "timer-regexp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "timer-regexp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                            class TunnelName(Entity):
                                                                                                """
                                                                                                Tunnel Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                    self.yang_name = "tunnel-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "tunnel-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                            class TunnelNameRegex(Entity):
                                                                                                """
                                                                                                Tunnel Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "tunnel-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                            class UserName(Entity):
                                                                                                """
                                                                                                User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                    self.yang_name = "user-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "user-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                            class UserNameRegex(Entity):
                                                                                                """
                                                                                                User Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                    self.yang_name = "user-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "user-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                            class AuthUsername(Entity):
                                                                                                """
                                                                                                Authenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                    self.yang_name = "auth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-username"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                            class AuthUsernameRegex(Entity):
                                                                                                """
                                                                                                Authenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "auth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-username-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                            class UnauthUsername(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                    self.yang_name = "unauth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-username"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                            class UnauthUsernameRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-username-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                            class AuthDomain(Entity):
                                                                                                """
                                                                                                Authenticated domain name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                    self.yang_name = "auth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                            class AuthDomainRegex(Entity):
                                                                                                """
                                                                                                Authenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "auth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                            class UnauthDomain(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                    self.yang_name = "unauth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                            class UnauthDomainRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                            class VendorId(Entity):
                                                                                                """
                                                                                                Vendor ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                    self.yang_name = "vendor-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "vendor-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                            class VendorIdRegex(Entity):
                                                                                                """
                                                                                                Vendor ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                    self.yang_name = "vendor-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "vendor-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                            class AccessInterface(Entity):
                                                                                                """
                                                                                                Access interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                    self.yang_name = "access-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "access-interface"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                            class InputInterface(Entity):
                                                                                                """
                                                                                                Input interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                    self.yang_name = "input-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "input-interface"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                            class InputIntfhdl(Entity):
                                                                                                """
                                                                                                Input interface handle
                                                                                                
                                                                                                .. attribute:: uint64_array
                                                                                                
                                                                                                	uint64 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..18446744073709551615
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                    self.yang_name = "input-intfhdl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint64_array', (YLeafList(YType.uint64, 'uint64_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint64_array = []
                                                                                                    self._segment_path = lambda: "input-intfhdl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                            class Ethertype(Entity):
                                                                                                """
                                                                                                Ethernet type
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                    self.yang_name = "ethertype"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ethertype"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ethertype"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FlowKeyData(Entity):
                                                                                                """
                                                                                                Flow key structure
                                                                                                
                                                                                                .. attribute:: flow_keys
                                                                                                
                                                                                                	flow keys
                                                                                                	**type**\:  :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                                
                                                                                                .. attribute:: max_count
                                                                                                
                                                                                                	Maximum count of flows
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: idle_timeout
                                                                                                
                                                                                                	Idle timeout of flows (in seconds)
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                	**units**\: second
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                    self.yang_name = "flow-key-data"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("flow-keys", ("flow_keys", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys))])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('max_count', (YLeaf(YType.uint16, 'max-count'), ['int'])),
                                                                                                        ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                                                    ])
                                                                                                    self.max_count = None
                                                                                                    self.idle_timeout = None

                                                                                                    self.flow_keys = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                    self.flow_keys.parent = self
                                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                    self._segment_path = lambda: "flow-key-data"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['max_count', 'idle_timeout'], name, value)


                                                                                                class FlowKeys(Entity):
                                                                                                    """
                                                                                                    flow keys
                                                                                                    
                                                                                                    .. attribute:: keys
                                                                                                    
                                                                                                    	keys
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                    
                                                                                                    .. attribute:: num
                                                                                                    
                                                                                                    	num
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                        self.yang_name = "flow-keys"
                                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('keys', (YLeaf(YType.str, 'keys'), ['str'])),
                                                                                                            ('num', (YLeaf(YType.uint8, 'num'), ['int'])),
                                                                                                        ])
                                                                                                        self.keys = None
                                                                                                        self.num = None
                                                                                                        self._segment_path = lambda: "flow-keys"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                            class DhcpClientId(Entity):
                                                                                                """
                                                                                                Dhcp Client ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dhcp-client-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                            class DhcpClientIdRegex(Entity):
                                                                                                """
                                                                                                Dhcp Client ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                            class CircuitId(Entity):
                                                                                                """
                                                                                                Circuit ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                    self.yang_name = "circuit-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "circuit-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                            class CircuitIdRegex(Entity):
                                                                                                """
                                                                                                Circuit ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                    self.yang_name = "circuit-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "circuit-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                            class RemoteId(Entity):
                                                                                                """
                                                                                                Remote ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                    self.yang_name = "remote-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "remote-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                            class RemoteIdRegex(Entity):
                                                                                                """
                                                                                                Remote ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                    self.yang_name = "remote-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "remote-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                            class SrcPort(Entity):
                                                                                                """
                                                                                                Source port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                    self.yang_name = "src-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "src-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class DstPort(Entity):
                                                                                                """
                                                                                                Destination port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                    self.yang_name = "dst-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "dst-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                    class Shape(Entity):
                                                                        """
                                                                        shape
                                                                        
                                                                        .. attribute:: bw
                                                                        
                                                                        	bw
                                                                        	**type**\:  :py:class:`Bw <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw>`
                                                                        
                                                                        .. attribute:: be
                                                                        
                                                                        	be
                                                                        	**type**\:  :py:class:`Be <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape, self).__init__()

                                                                            self.yang_name = "shape"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("bw", ("bw", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw)), ("be", ("be", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be))])
                                                                            self._leafs = OrderedDict()

                                                                            self.bw = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw()
                                                                            self.bw.parent = self
                                                                            self._children_name_map["bw"] = "bw"

                                                                            self.be = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be()
                                                                            self.be.parent = self
                                                                            self._children_name_map["be"] = "be"
                                                                            self._segment_path = lambda: "shape"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape, [], name, value)


                                                                        class Bw(Entity):
                                                                            """
                                                                            bw
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw, self).__init__()

                                                                                self.yang_name = "bw"
                                                                                self.yang_parent_name = "shape"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "bw"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw, ['value', 'unit'], name, value)


                                                                        class Be(Entity):
                                                                            """
                                                                            be
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be, self).__init__()

                                                                                self.yang_name = "be"
                                                                                self.yang_parent_name = "shape"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "be"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be, ['value', 'unit'], name, value)


                                                                    class ChildPolicy(Entity):
                                                                        """
                                                                        child policy
                                                                        
                                                                        .. attribute:: info
                                                                        
                                                                        	info
                                                                        	**type**\:  :py:class:`Info <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info>`
                                                                        
                                                                        .. attribute:: hd_info
                                                                        
                                                                        	hd info
                                                                        	**type**\:  :py:class:`HdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo>`
                                                                        
                                                                        .. attribute:: enc
                                                                        
                                                                        	enc
                                                                        	**type**\:  :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy, self).__init__()

                                                                            self.yang_name = "child-policy"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("info", ("info", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info)), ("hd-info", ("hd_info", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo))])
                                                                            self._leafs = OrderedDict([
                                                                                ('enc', (YLeaf(YType.enumeration, 'enc'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyObjEncEn', '')])),
                                                                            ])
                                                                            self.enc = None

                                                                            self.info = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info()
                                                                            self.info.parent = self
                                                                            self._children_name_map["info"] = "info"

                                                                            self.hd_info = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo()
                                                                            self.hd_info.parent = self
                                                                            self._children_name_map["hd_info"] = "hd-info"
                                                                            self._segment_path = lambda: "child-policy"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy, ['enc'], name, value)


                                                                        class Info(Entity):
                                                                            """
                                                                            info
                                                                            
                                                                            .. attribute:: name
                                                                            
                                                                            	name
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..65
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:  :py:class:`PolicyMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyMapTypeEn>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info, self).__init__()

                                                                                self.yang_name = "info"
                                                                                self.yang_parent_name = "child-policy"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyMapTypeEn', '')])),
                                                                                ])
                                                                                self.name = None
                                                                                self.type = None
                                                                                self._segment_path = lambda: "info"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info, ['name', 'type'], name, value)


                                                                        class HdInfo(Entity):
                                                                            """
                                                                            hd info
                                                                            
                                                                            .. attribute:: data_hd
                                                                            
                                                                            	data hd
                                                                            	**type**\:  :py:class:`DataHd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd>`
                                                                            
                                                                            .. attribute:: hd
                                                                            
                                                                            	hd
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo, self).__init__()

                                                                                self.yang_name = "hd-info"
                                                                                self.yang_parent_name = "child-policy"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("data-hd", ("data_hd", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('hd', (YLeaf(YType.uint64, 'hd'), ['int'])),
                                                                                ])
                                                                                self.hd = None

                                                                                self.data_hd = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd()
                                                                                self.data_hd.parent = self
                                                                                self._children_name_map["data_hd"] = "data-hd"
                                                                                self._segment_path = lambda: "hd-info"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo, ['hd'], name, value)


                                                                            class DataHd(Entity):
                                                                                """
                                                                                data hd
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd, self).__init__()

                                                                                    self.yang_name = "data-hd"
                                                                                    self.yang_parent_name = "hd-info"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict()
                                                                                    self._segment_path = lambda: "data-hd"
                                                                                    self._is_frozen = True


                                                                    class Cac(Entity):
                                                                        """
                                                                        cac
                                                                        
                                                                        .. attribute:: flow_rate
                                                                        
                                                                        	flow rate
                                                                        	**type**\:  :py:class:`FlowRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate>`
                                                                        
                                                                        .. attribute:: rate
                                                                        
                                                                        	rate
                                                                        	**type**\:  :py:class:`Rate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate>`
                                                                        
                                                                        .. attribute:: cac_type
                                                                        
                                                                        	cac type
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: idle_timeout
                                                                        
                                                                        	idle timeout
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..65535
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac, self).__init__()

                                                                            self.yang_name = "cac"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("flow-rate", ("flow_rate", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate)), ("rate", ("rate", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate))])
                                                                            self._leafs = OrderedDict([
                                                                                ('cac_type', (YLeaf(YType.uint8, 'cac-type'), ['int'])),
                                                                                ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                            ])
                                                                            self.cac_type = None
                                                                            self.idle_timeout = None

                                                                            self.flow_rate = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate()
                                                                            self.flow_rate.parent = self
                                                                            self._children_name_map["flow_rate"] = "flow-rate"

                                                                            self.rate = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate()
                                                                            self.rate.parent = self
                                                                            self._children_name_map["rate"] = "rate"
                                                                            self._segment_path = lambda: "cac"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac, ['cac_type', 'idle_timeout'], name, value)


                                                                        class FlowRate(Entity):
                                                                            """
                                                                            flow rate
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate, self).__init__()

                                                                                self.yang_name = "flow-rate"
                                                                                self.yang_parent_name = "cac"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "flow-rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate, ['value', 'unit'], name, value)


                                                                        class Rate(Entity):
                                                                            """
                                                                            rate
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate, self).__init__()

                                                                                self.yang_name = "rate"
                                                                                self.yang_parent_name = "cac"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate, ['value', 'unit'], name, value)


                                                                    class Pfc(Entity):
                                                                        """
                                                                        pfc
                                                                        
                                                                        .. attribute:: buffer_size
                                                                        
                                                                        	buffer size
                                                                        	**type**\:  :py:class:`BufferSize <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize>`
                                                                        
                                                                        .. attribute:: pause_threshold
                                                                        
                                                                        	pause threshold
                                                                        	**type**\:  :py:class:`PauseThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold>`
                                                                        
                                                                        .. attribute:: resume_threshold
                                                                        
                                                                        	resume threshold
                                                                        	**type**\:  :py:class:`ResumeThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold>`
                                                                        
                                                                        .. attribute:: pfc_pause_set
                                                                        
                                                                        	pfc pause set
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: buffer_size_flag
                                                                        
                                                                        	buffer size flag
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc, self).__init__()

                                                                            self.yang_name = "pfc"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("buffer-size", ("buffer_size", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize)), ("pause-threshold", ("pause_threshold", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold)), ("resume-threshold", ("resume_threshold", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold))])
                                                                            self._leafs = OrderedDict([
                                                                                ('pfc_pause_set', (YLeaf(YType.uint32, 'pfc-pause-set'), ['int'])),
                                                                                ('buffer_size_flag', (YLeaf(YType.uint32, 'buffer-size-flag'), ['int'])),
                                                                            ])
                                                                            self.pfc_pause_set = None
                                                                            self.buffer_size_flag = None

                                                                            self.buffer_size = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize()
                                                                            self.buffer_size.parent = self
                                                                            self._children_name_map["buffer_size"] = "buffer-size"

                                                                            self.pause_threshold = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold()
                                                                            self.pause_threshold.parent = self
                                                                            self._children_name_map["pause_threshold"] = "pause-threshold"

                                                                            self.resume_threshold = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold()
                                                                            self.resume_threshold.parent = self
                                                                            self._children_name_map["resume_threshold"] = "resume-threshold"
                                                                            self._segment_path = lambda: "pfc"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc, ['pfc_pause_set', 'buffer_size_flag'], name, value)


                                                                        class BufferSize(Entity):
                                                                            """
                                                                            buffer size
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize, self).__init__()

                                                                                self.yang_name = "buffer-size"
                                                                                self.yang_parent_name = "pfc"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "buffer-size"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize, ['value', 'unit'], name, value)


                                                                        class PauseThreshold(Entity):
                                                                            """
                                                                            pause threshold
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold, self).__init__()

                                                                                self.yang_name = "pause-threshold"
                                                                                self.yang_parent_name = "pfc"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "pause-threshold"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold, ['value', 'unit'], name, value)


                                                                        class ResumeThreshold(Entity):
                                                                            """
                                                                            resume threshold
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold, self).__init__()

                                                                                self.yang_name = "resume-threshold"
                                                                                self.yang_parent_name = "pfc"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "resume-threshold"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold, ['value', 'unit'], name, value)


                                                                    class FlowParm(Entity):
                                                                        """
                                                                        flow parm
                                                                        
                                                                        .. attribute:: max_mon_flows
                                                                        
                                                                        	max simult flows monitored per policy class
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: mon_interval
                                                                        
                                                                        	monitored interval duration in secs
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: second
                                                                        
                                                                        .. attribute:: intvl_hist
                                                                        
                                                                        	num intervals of data stored on rtr
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: flow_timeout
                                                                        
                                                                        	timeout in secs
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: second
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm, self).__init__()

                                                                            self.yang_name = "flow-parm"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('max_mon_flows', (YLeaf(YType.uint32, 'max-mon-flows'), ['int'])),
                                                                                ('mon_interval', (YLeaf(YType.uint32, 'mon-interval'), ['int'])),
                                                                                ('intvl_hist', (YLeaf(YType.uint32, 'intvl-hist'), ['int'])),
                                                                                ('flow_timeout', (YLeaf(YType.uint32, 'flow-timeout'), ['int'])),
                                                                            ])
                                                                            self.max_mon_flows = None
                                                                            self.mon_interval = None
                                                                            self.intvl_hist = None
                                                                            self.flow_timeout = None
                                                                            self._segment_path = lambda: "flow-parm"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm, ['max_mon_flows', 'mon_interval', 'intvl_hist', 'flow_timeout'], name, value)


                                                                    class Ipcbr(Entity):
                                                                        """
                                                                        ipcbr
                                                                        
                                                                        .. attribute:: ip_bit_rate
                                                                        
                                                                        	data rate in bps
                                                                        	**type**\:  :py:class:`IpBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate>`
                                                                        
                                                                        .. attribute:: media_bit_rate
                                                                        
                                                                        	media data rate in bps
                                                                        	**type**\:  :py:class:`MediaBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate>`
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: ip_pkt_rate
                                                                        
                                                                        	packet rate in pps
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: media_pkt_size
                                                                        
                                                                        	media packet size in bytes
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: media_pkts_per_ip
                                                                        
                                                                        	media packets per ip pkt
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr, self).__init__()

                                                                            self.yang_name = "ipcbr"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("ip-bit-rate", ("ip_bit_rate", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate)), ("media-bit-rate", ("media_bit_rate", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate))])
                                                                            self._leafs = OrderedDict([
                                                                                ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                                ('ip_pkt_rate', (YLeaf(YType.uint32, 'ip-pkt-rate'), ['int'])),
                                                                                ('media_pkt_size', (YLeaf(YType.uint32, 'media-pkt-size'), ['int'])),
                                                                                ('media_pkts_per_ip', (YLeaf(YType.uint32, 'media-pkts-per-ip'), ['int'])),
                                                                            ])
                                                                            self.action_metric_type = None
                                                                            self.ip_pkt_rate = None
                                                                            self.media_pkt_size = None
                                                                            self.media_pkts_per_ip = None

                                                                            self.ip_bit_rate = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate()
                                                                            self.ip_bit_rate.parent = self
                                                                            self._children_name_map["ip_bit_rate"] = "ip-bit-rate"

                                                                            self.media_bit_rate = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate()
                                                                            self.media_bit_rate.parent = self
                                                                            self._children_name_map["media_bit_rate"] = "media-bit-rate"
                                                                            self._segment_path = lambda: "ipcbr"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr, ['action_metric_type', 'ip_pkt_rate', 'media_pkt_size', 'media_pkts_per_ip'], name, value)


                                                                        class IpBitRate(Entity):
                                                                            """
                                                                            data rate in bps
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate, self).__init__()

                                                                                self.yang_name = "ip-bit-rate"
                                                                                self.yang_parent_name = "ipcbr"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "ip-bit-rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate, ['value', 'unit'], name, value)


                                                                        class MediaBitRate(Entity):
                                                                            """
                                                                            media data rate in bps
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate, self).__init__()

                                                                                self.yang_name = "media-bit-rate"
                                                                                self.yang_parent_name = "ipcbr"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "media-bit-rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate, ['value', 'unit'], name, value)


                                                                    class Rtp(Entity):
                                                                        """
                                                                        rtp
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: min_sequential
                                                                        
                                                                        	min sequential
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_dropout
                                                                        
                                                                        	max dropout
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_misorder
                                                                        
                                                                        	max misorder
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: seq_ext_cop4
                                                                        
                                                                        	enable seq extension cop4
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: clock_rate
                                                                        
                                                                        	clock rate
                                                                        	**type**\: list of  		 :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp, self).__init__()

                                                                            self.yang_name = "rtp"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("clock-rate", ("clock_rate", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate))])
                                                                            self._leafs = OrderedDict([
                                                                                ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                                ('min_sequential', (YLeaf(YType.uint32, 'min-sequential'), ['int'])),
                                                                                ('max_dropout', (YLeaf(YType.uint32, 'max-dropout'), ['int'])),
                                                                                ('max_misorder', (YLeaf(YType.uint32, 'max-misorder'), ['int'])),
                                                                                ('seq_ext_cop4', (YLeaf(YType.uint32, 'seq-ext-cop4'), ['int'])),
                                                                            ])
                                                                            self.action_metric_type = None
                                                                            self.min_sequential = None
                                                                            self.max_dropout = None
                                                                            self.max_misorder = None
                                                                            self.seq_ext_cop4 = None

                                                                            self.clock_rate = YList(self)
                                                                            self._segment_path = lambda: "rtp"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp, ['action_metric_type', 'min_sequential', 'max_dropout', 'max_misorder', 'seq_ext_cop4'], name, value)


                                                                        class ClockRate(Entity):
                                                                            """
                                                                            clock rate
                                                                            
                                                                            .. attribute:: pt
                                                                            
                                                                            	pt
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: frequency
                                                                            
                                                                            	frequency
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate, self).__init__()

                                                                                self.yang_name = "clock-rate"
                                                                                self.yang_parent_name = "rtp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('pt', (YLeaf(YType.uint32, 'pt'), ['int'])),
                                                                                    ('frequency', (YLeaf(YType.uint32, 'frequency'), ['int'])),
                                                                                ])
                                                                                self.pt = None
                                                                                self.frequency = None
                                                                                self._segment_path = lambda: "clock-rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate, ['pt', 'frequency'], name, value)


                                                                    class RtpMmr(Entity):
                                                                        """
                                                                        rtp mmr
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: min_sequential
                                                                        
                                                                        	min sequential
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_dropout
                                                                        
                                                                        	max dropout
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_misorder
                                                                        
                                                                        	max misorder
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: seq_ext_cop4
                                                                        
                                                                        	enable seq extension cop4
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: clock_rate
                                                                        
                                                                        	clock rate
                                                                        	**type**\: list of  		 :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr, self).__init__()

                                                                            self.yang_name = "rtp-mmr"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("clock-rate", ("clock_rate", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate))])
                                                                            self._leafs = OrderedDict([
                                                                                ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                                ('min_sequential', (YLeaf(YType.uint32, 'min-sequential'), ['int'])),
                                                                                ('max_dropout', (YLeaf(YType.uint32, 'max-dropout'), ['int'])),
                                                                                ('max_misorder', (YLeaf(YType.uint32, 'max-misorder'), ['int'])),
                                                                                ('seq_ext_cop4', (YLeaf(YType.uint32, 'seq-ext-cop4'), ['int'])),
                                                                            ])
                                                                            self.action_metric_type = None
                                                                            self.min_sequential = None
                                                                            self.max_dropout = None
                                                                            self.max_misorder = None
                                                                            self.seq_ext_cop4 = None

                                                                            self.clock_rate = YList(self)
                                                                            self._segment_path = lambda: "rtp-mmr"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr, ['action_metric_type', 'min_sequential', 'max_dropout', 'max_misorder', 'seq_ext_cop4'], name, value)


                                                                        class ClockRate(Entity):
                                                                            """
                                                                            clock rate
                                                                            
                                                                            .. attribute:: pt
                                                                            
                                                                            	pt
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: frequency
                                                                            
                                                                            	frequency
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate, self).__init__()

                                                                                self.yang_name = "clock-rate"
                                                                                self.yang_parent_name = "rtp-mmr"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('pt', (YLeaf(YType.uint32, 'pt'), ['int'])),
                                                                                    ('frequency', (YLeaf(YType.uint32, 'frequency'), ['int'])),
                                                                                ])
                                                                                self.pt = None
                                                                                self.frequency = None
                                                                                self._segment_path = lambda: "clock-rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate, ['pt', 'frequency'], name, value)


                                                                    class RtpJ2k(Entity):
                                                                        """
                                                                        rtp j2k
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: min_sequential
                                                                        
                                                                        	min sequential
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_dropout
                                                                        
                                                                        	max dropout
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_misorder
                                                                        
                                                                        	max misorder
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: seq_ext_cop4
                                                                        
                                                                        	enable seq extension cop4
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: clock_rate
                                                                        
                                                                        	clock rate
                                                                        	**type**\: list of  		 :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k.ClockRate>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k, self).__init__()

                                                                            self.yang_name = "rtp-j2k"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("clock-rate", ("clock_rate", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k.ClockRate))])
                                                                            self._leafs = OrderedDict([
                                                                                ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                                ('min_sequential', (YLeaf(YType.uint32, 'min-sequential'), ['int'])),
                                                                                ('max_dropout', (YLeaf(YType.uint32, 'max-dropout'), ['int'])),
                                                                                ('max_misorder', (YLeaf(YType.uint32, 'max-misorder'), ['int'])),
                                                                                ('seq_ext_cop4', (YLeaf(YType.uint32, 'seq-ext-cop4'), ['int'])),
                                                                            ])
                                                                            self.action_metric_type = None
                                                                            self.min_sequential = None
                                                                            self.max_dropout = None
                                                                            self.max_misorder = None
                                                                            self.seq_ext_cop4 = None

                                                                            self.clock_rate = YList(self)
                                                                            self._segment_path = lambda: "rtp-j2k"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k, ['action_metric_type', 'min_sequential', 'max_dropout', 'max_misorder', 'seq_ext_cop4'], name, value)


                                                                        class ClockRate(Entity):
                                                                            """
                                                                            clock rate
                                                                            
                                                                            .. attribute:: pt
                                                                            
                                                                            	pt
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: frequency
                                                                            
                                                                            	frequency
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k.ClockRate, self).__init__()

                                                                                self.yang_name = "clock-rate"
                                                                                self.yang_parent_name = "rtp-j2k"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('pt', (YLeaf(YType.uint32, 'pt'), ['int'])),
                                                                                    ('frequency', (YLeaf(YType.uint32, 'frequency'), ['int'])),
                                                                                ])
                                                                                self.pt = None
                                                                                self.frequency = None
                                                                                self._segment_path = lambda: "clock-rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k.ClockRate, ['pt', 'frequency'], name, value)


                                                                    class RtpVoice(Entity):
                                                                        """
                                                                        rtp voice
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: min_sequential
                                                                        
                                                                        	min sequential
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_dropout
                                                                        
                                                                        	max dropout
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_misorder
                                                                        
                                                                        	max misorder
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: seq_ext_cop4
                                                                        
                                                                        	enable seq extension cop4
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: clock_rate
                                                                        
                                                                        	clock rate
                                                                        	**type**\: list of  		 :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice, self).__init__()

                                                                            self.yang_name = "rtp-voice"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("clock-rate", ("clock_rate", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate))])
                                                                            self._leafs = OrderedDict([
                                                                                ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                                ('min_sequential', (YLeaf(YType.uint32, 'min-sequential'), ['int'])),
                                                                                ('max_dropout', (YLeaf(YType.uint32, 'max-dropout'), ['int'])),
                                                                                ('max_misorder', (YLeaf(YType.uint32, 'max-misorder'), ['int'])),
                                                                                ('seq_ext_cop4', (YLeaf(YType.uint32, 'seq-ext-cop4'), ['int'])),
                                                                            ])
                                                                            self.action_metric_type = None
                                                                            self.min_sequential = None
                                                                            self.max_dropout = None
                                                                            self.max_misorder = None
                                                                            self.seq_ext_cop4 = None

                                                                            self.clock_rate = YList(self)
                                                                            self._segment_path = lambda: "rtp-voice"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice, ['action_metric_type', 'min_sequential', 'max_dropout', 'max_misorder', 'seq_ext_cop4'], name, value)


                                                                        class ClockRate(Entity):
                                                                            """
                                                                            clock rate
                                                                            
                                                                            .. attribute:: pt
                                                                            
                                                                            	pt
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: frequency
                                                                            
                                                                            	frequency
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate, self).__init__()

                                                                                self.yang_name = "clock-rate"
                                                                                self.yang_parent_name = "rtp-voice"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('pt', (YLeaf(YType.uint32, 'pt'), ['int'])),
                                                                                    ('frequency', (YLeaf(YType.uint32, 'frequency'), ['int'])),
                                                                                ])
                                                                                self.pt = None
                                                                                self.frequency = None
                                                                                self._segment_path = lambda: "clock-rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate, ['pt', 'frequency'], name, value)


                                                                    class Mdi(Entity):
                                                                        """
                                                                        mdi
                                                                        
                                                                        .. attribute:: ip_bit_rate
                                                                        
                                                                        	data rate in bps
                                                                        	**type**\:  :py:class:`IpBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate>`
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: filtered_pkt_rate
                                                                        
                                                                        	filtered packet rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: ip_pkt_rate
                                                                        
                                                                        	packet rate in pps
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: pids
                                                                        
                                                                        	array of monitoredcd  pids
                                                                        	**type**\: list of int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi, self).__init__()

                                                                            self.yang_name = "mdi"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("ip-bit-rate", ("ip_bit_rate", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate))])
                                                                            self._leafs = OrderedDict([
                                                                                ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                                ('filtered_pkt_rate', (YLeaf(YType.uint32, 'filtered-pkt-rate'), ['int'])),
                                                                                ('ip_pkt_rate', (YLeaf(YType.uint32, 'ip-pkt-rate'), ['int'])),
                                                                                ('pids', (YLeafList(YType.uint32, 'pids'), ['int'])),
                                                                            ])
                                                                            self.action_metric_type = None
                                                                            self.filtered_pkt_rate = None
                                                                            self.ip_pkt_rate = None
                                                                            self.pids = []

                                                                            self.ip_bit_rate = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate()
                                                                            self.ip_bit_rate.parent = self
                                                                            self._children_name_map["ip_bit_rate"] = "ip-bit-rate"
                                                                            self._segment_path = lambda: "mdi"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi, ['action_metric_type', 'filtered_pkt_rate', 'ip_pkt_rate', 'pids'], name, value)


                                                                        class IpBitRate(Entity):
                                                                            """
                                                                            data rate in bps
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate, self).__init__()

                                                                                self.yang_name = "ip-bit-rate"
                                                                                self.yang_parent_name = "mdi"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "ip-bit-rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate, ['value', 'unit'], name, value)


                                                                    class MdiRtp(Entity):
                                                                        """
                                                                        mdi rtp
                                                                        
                                                                        .. attribute:: ip_bit_rate
                                                                        
                                                                        	data rate in bps
                                                                        	**type**\:  :py:class:`IpBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate>`
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: filtered_pkt_rate
                                                                        
                                                                        	filtered packet rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: ip_pkt_rate
                                                                        
                                                                        	packet rate in pps
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: pids
                                                                        
                                                                        	array of monitoredcd  pids
                                                                        	**type**\: list of int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp, self).__init__()

                                                                            self.yang_name = "mdi-rtp"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("ip-bit-rate", ("ip_bit_rate", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate))])
                                                                            self._leafs = OrderedDict([
                                                                                ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                                ('filtered_pkt_rate', (YLeaf(YType.uint32, 'filtered-pkt-rate'), ['int'])),
                                                                                ('ip_pkt_rate', (YLeaf(YType.uint32, 'ip-pkt-rate'), ['int'])),
                                                                                ('pids', (YLeafList(YType.uint32, 'pids'), ['int'])),
                                                                            ])
                                                                            self.action_metric_type = None
                                                                            self.filtered_pkt_rate = None
                                                                            self.ip_pkt_rate = None
                                                                            self.pids = []

                                                                            self.ip_bit_rate = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate()
                                                                            self.ip_bit_rate.parent = self
                                                                            self._children_name_map["ip_bit_rate"] = "ip-bit-rate"
                                                                            self._segment_path = lambda: "mdi-rtp"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp, ['action_metric_type', 'filtered_pkt_rate', 'ip_pkt_rate', 'pids'], name, value)


                                                                        class IpBitRate(Entity):
                                                                            """
                                                                            data rate in bps
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate, self).__init__()

                                                                                self.yang_name = "ip-bit-rate"
                                                                                self.yang_parent_name = "mdi-rtp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "ip-bit-rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate, ['value', 'unit'], name, value)


                                                                    class Fmm(Entity):
                                                                        """
                                                                        fmm
                                                                        
                                                                        .. attribute:: fmm_name
                                                                        
                                                                        	flow monitor name
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..33
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm, self).__init__()

                                                                            self.yang_name = "fmm"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('fmm_name', (YLeaf(YType.str, 'fmm-name'), ['str'])),
                                                                            ])
                                                                            self.fmm_name = None
                                                                            self._segment_path = lambda: "fmm"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm, ['fmm_name'], name, value)


                                                                    class Pbf(Entity):
                                                                        """
                                                                        pbf
                                                                        
                                                                        .. attribute:: action_pbf_info_array
                                                                        
                                                                        	action pbf info array
                                                                        	**type**\: list of  		 :py:class:`ActionPbfInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf, self).__init__()

                                                                            self.yang_name = "pbf"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("action-pbf-info-array", ("action_pbf_info_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.action_pbf_info_array = YList(self)
                                                                            self._segment_path = lambda: "pbf"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf, [], name, value)


                                                                        class ActionPbfInfoArray(Entity):
                                                                            """
                                                                            action pbf info array
                                                                            
                                                                            .. attribute:: addr
                                                                            
                                                                            	v4 or v6 address
                                                                            	**type**\: str
                                                                            
                                                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                            
                                                                            .. attribute:: vrf
                                                                            
                                                                            	vrf name
                                                                            	**type**\: str
                                                                            
                                                                            .. attribute:: rt_type
                                                                            
                                                                            	route target type
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: rt
                                                                            
                                                                            	route target
                                                                            	**type**\: str
                                                                            
                                                                            	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray, self).__init__()

                                                                                self.yang_name = "action-pbf-info-array"
                                                                                self.yang_parent_name = "pbf"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('addr', (YLeaf(YType.str, 'addr'), ['str'])),
                                                                                    ('vrf', (YLeaf(YType.str, 'vrf'), ['str'])),
                                                                                    ('rt_type', (YLeaf(YType.uint8, 'rt-type'), ['int'])),
                                                                                    ('rt', (YLeaf(YType.str, 'rt'), ['str'])),
                                                                                ])
                                                                                self.addr = None
                                                                                self.vrf = None
                                                                                self.rt_type = None
                                                                                self.rt = None
                                                                                self._segment_path = lambda: "action-pbf-info-array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray, ['addr', 'vrf', 'rt_type', 'rt'], name, value)


                                                                    class Ipv4Nh(Entity):
                                                                        """
                                                                        ipv4 nh
                                                                        
                                                                        .. attribute:: action_ipv4_nh_info_array
                                                                        
                                                                        	action ipv4 nh info array
                                                                        	**type**\: list of  		 :py:class:`ActionIpv4NhInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh, self).__init__()

                                                                            self.yang_name = "ipv4-nh"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("action-ipv4-nh-info-array", ("action_ipv4_nh_info_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.action_ipv4_nh_info_array = YList(self)
                                                                            self._segment_path = lambda: "ipv4-nh"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh, [], name, value)


                                                                        class ActionIpv4NhInfoArray(Entity):
                                                                            """
                                                                            action ipv4 nh info array
                                                                            
                                                                            .. attribute:: nh_addr
                                                                            
                                                                            	nh addr
                                                                            	**type**\: str
                                                                            
                                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                            
                                                                            .. attribute:: vrf_name
                                                                            
                                                                            	Vrf name
                                                                            	**type**\: str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray, self).__init__()

                                                                                self.yang_name = "action-ipv4-nh-info-array"
                                                                                self.yang_parent_name = "ipv4-nh"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('nh_addr', (YLeaf(YType.str, 'nh-addr'), ['str'])),
                                                                                    ('vrf_name', (YLeaf(YType.str, 'vrf-name'), ['str'])),
                                                                                ])
                                                                                self.nh_addr = None
                                                                                self.vrf_name = None
                                                                                self._segment_path = lambda: "action-ipv4-nh-info-array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray, ['nh_addr', 'vrf_name'], name, value)


                                                                    class Ipv6Nh(Entity):
                                                                        """
                                                                        ipv6 nh
                                                                        
                                                                        .. attribute:: action_ipv6_nh_info_array
                                                                        
                                                                        	action ipv6 nh info array
                                                                        	**type**\: list of  		 :py:class:`ActionIpv6NhInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh, self).__init__()

                                                                            self.yang_name = "ipv6-nh"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("action-ipv6-nh-info-array", ("action_ipv6_nh_info_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.action_ipv6_nh_info_array = YList(self)
                                                                            self._segment_path = lambda: "ipv6-nh"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh, [], name, value)


                                                                        class ActionIpv6NhInfoArray(Entity):
                                                                            """
                                                                            action ipv6 nh info array
                                                                            
                                                                            .. attribute:: nh_addr
                                                                            
                                                                            	IPV6 Address
                                                                            	**type**\: str
                                                                            
                                                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                            
                                                                            .. attribute:: vrf_name
                                                                            
                                                                            	Vrf name
                                                                            	**type**\: str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray, self).__init__()

                                                                                self.yang_name = "action-ipv6-nh-info-array"
                                                                                self.yang_parent_name = "ipv6-nh"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('nh_addr', (YLeaf(YType.str, 'nh-addr'), ['str'])),
                                                                                    ('vrf_name', (YLeaf(YType.str, 'vrf-name'), ['str'])),
                                                                                ])
                                                                                self.nh_addr = None
                                                                                self.vrf_name = None
                                                                                self._segment_path = lambda: "action-ipv6-nh-info-array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray, ['nh_addr', 'vrf_name'], name, value)


                            class ClassSeqNums(Entity):
                                """
                                Transient policy\-map sequence number table
                                
                                .. attribute:: class_seq_num
                                
                                	Transient policy\-map sequence number
                                	**type**\: list of  		 :py:class:`ClassSeqNum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum>`
                                
                                

                                """

                                _prefix = 'infra-policymgr-oper'
                                _revision = '2018-01-17'

                                def __init__(self):
                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums, self).__init__()

                                    self.yang_name = "class-seq-nums"
                                    self.yang_parent_name = "transient-policy-map-name"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("class-seq-num", ("class_seq_num", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum))])
                                    self._leafs = OrderedDict()

                                    self.class_seq_num = YList(self)
                                    self._segment_path = lambda: "class-seq-nums"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums, [], name, value)


                                class ClassSeqNum(Entity):
                                    """
                                    Transient policy\-map sequence number
                                    
                                    .. attribute:: sequence_num  (key)
                                    
                                    	sequence number
                                    	**type**\: int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: policy_map_bg
                                    
                                    	policy map bg
                                    	**type**\: list of  		 :py:class:`PolicyMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg>`
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2018-01-17'

                                    def __init__(self):
                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum, self).__init__()

                                        self.yang_name = "class-seq-num"
                                        self.yang_parent_name = "class-seq-nums"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = ['sequence_num']
                                        self._child_classes = OrderedDict([("policy-map-bg", ("policy_map_bg", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg))])
                                        self._leafs = OrderedDict([
                                            ('sequence_num', (YLeaf(YType.int32, 'sequence-num'), ['int'])),
                                        ])
                                        self.sequence_num = None

                                        self.policy_map_bg = YList(self)
                                        self._segment_path = lambda: "class-seq-num" + "[sequence-num='" + str(self.sequence_num) + "']"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum, ['sequence_num'], name, value)


                                    class PolicyMapBg(Entity):
                                        """
                                        policy map bg
                                        
                                        .. attribute:: pmap_var_list
                                        
                                        	pmap var list
                                        	**type**\:  :py:class:`PmapVarList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.PmapVarList>`
                                        
                                        .. attribute:: event_infop
                                        
                                        	event infop
                                        	**type**\:  :py:class:`EventInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop>`
                                        
                                        .. attribute:: name
                                        
                                        	name
                                        	**type**\: str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: type
                                        
                                        	type
                                        	**type**\:  :py:class:`PolicyMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyMapTypeEn>`
                                        
                                        .. attribute:: description
                                        
                                        	description
                                        	**type**\: str
                                        
                                        

                                        """

                                        _prefix = 'infra-policymgr-oper'
                                        _revision = '2018-01-17'

                                        def __init__(self):
                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg, self).__init__()

                                            self.yang_name = "policy-map-bg"
                                            self.yang_parent_name = "class-seq-num"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("pmap-var-list", ("pmap_var_list", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.PmapVarList)), ("event-infop", ("event_infop", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop))])
                                            self._leafs = OrderedDict([
                                                ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyMapTypeEn', '')])),
                                                ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                            ])
                                            self.name = None
                                            self.type = None
                                            self.description = None

                                            self.pmap_var_list = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.PmapVarList()
                                            self.pmap_var_list.parent = self
                                            self._children_name_map["pmap_var_list"] = "pmap-var-list"

                                            self.event_infop = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop()
                                            self.event_infop.parent = self
                                            self._children_name_map["event_infop"] = "event-infop"
                                            self._segment_path = lambda: "policy-map-bg"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg, ['name', 'type', 'description'], name, value)


                                        class PmapVarList(Entity):
                                            """
                                            pmap var list
                                            
                                            .. attribute:: pmap_var_list_arr
                                            
                                            	pmap var list arr
                                            	**type**\: list of  		 :py:class:`PmapVarListArr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.PmapVarList.PmapVarListArr>`
                                            
                                            

                                            """

                                            _prefix = 'infra-policymgr-oper'
                                            _revision = '2018-01-17'

                                            def __init__(self):
                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.PmapVarList, self).__init__()

                                                self.yang_name = "pmap-var-list"
                                                self.yang_parent_name = "policy-map-bg"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("pmap-var-list-arr", ("pmap_var_list_arr", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.PmapVarList.PmapVarListArr))])
                                                self._leafs = OrderedDict()

                                                self.pmap_var_list_arr = YList(self)
                                                self._segment_path = lambda: "pmap-var-list"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.PmapVarList, [], name, value)


                                            class PmapVarListArr(Entity):
                                                """
                                                pmap var list arr
                                                
                                                .. attribute:: val
                                                
                                                	val
                                                	**type**\:  :py:class:`Val <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.PmapVarList.PmapVarListArr.Val>`
                                                
                                                .. attribute:: name
                                                
                                                	name
                                                	**type**\: str
                                                
                                                	**length:** 0..32
                                                
                                                .. attribute:: id
                                                
                                                	id
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.PmapVarList.PmapVarListArr, self).__init__()

                                                    self.yang_name = "pmap-var-list-arr"
                                                    self.yang_parent_name = "pmap-var-list"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("val", ("val", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.PmapVarList.PmapVarListArr.Val))])
                                                    self._leafs = OrderedDict([
                                                        ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                        ('id', (YLeaf(YType.uint32, 'id'), ['int'])),
                                                    ])
                                                    self.name = None
                                                    self.id = None

                                                    self.val = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.PmapVarList.PmapVarListArr.Val()
                                                    self.val.parent = self
                                                    self._children_name_map["val"] = "val"
                                                    self._segment_path = lambda: "pmap-var-list-arr"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.PmapVarList.PmapVarListArr, ['name', 'id'], name, value)


                                                class Val(Entity):
                                                    """
                                                    val
                                                    
                                                    .. attribute:: type
                                                    
                                                    	type
                                                    	**type**\:  :py:class:`PlmgrVarTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrVarTypeEn>`
                                                    
                                                    .. attribute:: class_name
                                                    
                                                    	class name
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..65
                                                    
                                                    .. attribute:: uint8_val
                                                    
                                                    	uint8 val
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: uint16_val
                                                    
                                                    	uint16 val
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: uint32_val
                                                    
                                                    	uint32 val
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: param_uint32_val
                                                    
                                                    	param uint32 val
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: dscp_val
                                                    
                                                    	dscp val
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: prec_val
                                                    
                                                    	prec val
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.PmapVarList.PmapVarListArr.Val, self).__init__()

                                                        self.yang_name = "val"
                                                        self.yang_parent_name = "pmap-var-list-arr"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PlmgrVarTypeEn', '')])),
                                                            ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                            ('uint8_val', (YLeaf(YType.uint8, 'uint8_val'), ['int'])),
                                                            ('uint16_val', (YLeaf(YType.uint16, 'uint16_val'), ['int'])),
                                                            ('uint32_val', (YLeaf(YType.uint32, 'uint32_val'), ['int'])),
                                                            ('param_uint32_val', (YLeaf(YType.uint32, 'param-uint32-val'), ['int'])),
                                                            ('dscp_val', (YLeaf(YType.uint8, 'dscp-val'), ['int'])),
                                                            ('prec_val', (YLeaf(YType.uint8, 'prec-val'), ['int'])),
                                                        ])
                                                        self.type = None
                                                        self.class_name = None
                                                        self.uint8_val = None
                                                        self.uint16_val = None
                                                        self.uint32_val = None
                                                        self.param_uint32_val = None
                                                        self.dscp_val = None
                                                        self.prec_val = None
                                                        self._segment_path = lambda: "val"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.PmapVarList.PmapVarListArr.Val, ['type', 'class_name', 'uint8_val', 'uint16_val', 'uint32_val', 'param_uint32_val', 'dscp_val', 'prec_val'], name, value)


                                        class EventInfop(Entity):
                                            """
                                            event infop
                                            
                                            .. attribute:: policy_event_info_bg
                                            
                                            	policy event info bg
                                            	**type**\: list of  		 :py:class:`PolicyEventInfoBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg>`
                                            
                                            

                                            """

                                            _prefix = 'infra-policymgr-oper'
                                            _revision = '2018-01-17'

                                            def __init__(self):
                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop, self).__init__()

                                                self.yang_name = "event-infop"
                                                self.yang_parent_name = "policy-map-bg"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("policy-event-info-bg", ("policy_event_info_bg", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg))])
                                                self._leafs = OrderedDict()

                                                self.policy_event_info_bg = YList(self)
                                                self._segment_path = lambda: "event-infop"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop, [], name, value)


                                            class PolicyEventInfoBg(Entity):
                                                """
                                                policy event info bg
                                                
                                                .. attribute:: class_infop
                                                
                                                	class infop
                                                	**type**\:  :py:class:`ClassInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop>`
                                                
                                                .. attribute:: event_type
                                                
                                                	event type
                                                	**type**\:  :py:class:`PeventTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PeventTypeEn>`
                                                
                                                .. attribute:: cond_eval
                                                
                                                	cond eval
                                                	**type**\:  :py:class:`PeventCondEvalEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PeventCondEvalEn>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg, self).__init__()

                                                    self.yang_name = "policy-event-info-bg"
                                                    self.yang_parent_name = "event-infop"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("class-infop", ("class_infop", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop))])
                                                    self._leafs = OrderedDict([
                                                        ('event_type', (YLeaf(YType.enumeration, 'event-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PeventTypeEn', '')])),
                                                        ('cond_eval', (YLeaf(YType.enumeration, 'cond-eval'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PeventCondEvalEn', '')])),
                                                    ])
                                                    self.event_type = None
                                                    self.cond_eval = None

                                                    self.class_infop = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop()
                                                    self.class_infop.parent = self
                                                    self._children_name_map["class_infop"] = "class-infop"
                                                    self._segment_path = lambda: "policy-event-info-bg"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg, ['event_type', 'cond_eval'], name, value)


                                                class ClassInfop(Entity):
                                                    """
                                                    class infop
                                                    
                                                    .. attribute:: policy_class_info_bg
                                                    
                                                    	policy class info bg
                                                    	**type**\: list of  		 :py:class:`PolicyClassInfoBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop, self).__init__()

                                                        self.yang_name = "class-infop"
                                                        self.yang_parent_name = "policy-event-info-bg"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("policy-class-info-bg", ("policy_class_info_bg", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg))])
                                                        self._leafs = OrderedDict()

                                                        self.policy_class_info_bg = YList(self)
                                                        self._segment_path = lambda: "class-infop"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop, [], name, value)


                                                    class PolicyClassInfoBg(Entity):
                                                        """
                                                        policy class info bg
                                                        
                                                        .. attribute:: cl_encode
                                                        
                                                        	cl encode
                                                        	**type**\:  :py:class:`ClEncode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode>`
                                                        
                                                        .. attribute:: clmp_p
                                                        
                                                        	clmp p
                                                        	**type**\:  :py:class:`ClmpP <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP>`
                                                        
                                                        .. attribute:: act_infop
                                                        
                                                        	act infop
                                                        	**type**\:  :py:class:`ActInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop>`
                                                        
                                                        .. attribute:: policy_class_hd
                                                        
                                                        	policy class hd
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: seq
                                                        
                                                        	seq
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: flags
                                                        
                                                        	flags
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: ctype
                                                        
                                                        	ctype
                                                        	**type**\:  :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                        
                                                        .. attribute:: num_actions
                                                        
                                                        	num actions
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: version
                                                        
                                                        	version
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        .. attribute:: exe_strat
                                                        
                                                        	exe strat
                                                        	**type**\:  :py:class:`PclassExecStratEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PclassExecStratEn>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2018-01-17'

                                                        def __init__(self):
                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg, self).__init__()

                                                            self.yang_name = "policy-class-info-bg"
                                                            self.yang_parent_name = "class-infop"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("cl-encode", ("cl_encode", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode)), ("clmp-p", ("clmp_p", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP)), ("act-infop", ("act_infop", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop))])
                                                            self._leafs = OrderedDict([
                                                                ('policy_class_hd', (YLeaf(YType.uint32, 'policy-class-hd'), ['int'])),
                                                                ('seq', (YLeaf(YType.uint32, 'seq'), ['int'])),
                                                                ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                ('ctype', (YLeaf(YType.enumeration, 'ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapTypeEn', '')])),
                                                                ('num_actions', (YLeaf(YType.uint16, 'num-actions'), ['int'])),
                                                                ('version', (YLeaf(YType.uint8, 'version'), ['int'])),
                                                                ('exe_strat', (YLeaf(YType.enumeration, 'exe-strat'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PclassExecStratEn', '')])),
                                                            ])
                                                            self.policy_class_hd = None
                                                            self.seq = None
                                                            self.flags = None
                                                            self.ctype = None
                                                            self.num_actions = None
                                                            self.version = None
                                                            self.exe_strat = None

                                                            self.cl_encode = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode()
                                                            self.cl_encode.parent = self
                                                            self._children_name_map["cl_encode"] = "cl-encode"

                                                            self.clmp_p = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP()
                                                            self.clmp_p.parent = self
                                                            self._children_name_map["clmp_p"] = "clmp-p"

                                                            self.act_infop = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop()
                                                            self.act_infop.parent = self
                                                            self._children_name_map["act_infop"] = "act-infop"
                                                            self._segment_path = lambda: "policy-class-info-bg"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg, ['policy_class_hd', 'seq', 'flags', 'ctype', 'num_actions', 'version', 'exe_strat'], name, value)


                                                        class ClEncode(Entity):
                                                            """
                                                            cl encode
                                                            
                                                            .. attribute:: inline_cmap
                                                            
                                                            	inline cmap
                                                            	**type**\:  :py:class:`InlineCmap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap>`
                                                            
                                                            .. attribute:: enc
                                                            
                                                            	enc
                                                            	**type**\:  :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                            
                                                            .. attribute:: class_name
                                                            
                                                            	class name
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..65
                                                            
                                                            .. attribute:: hd
                                                            
                                                            	hd
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: idx
                                                            
                                                            	idx
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..255
                                                            
                                                            

                                                            """

                                                            _prefix = 'infra-policymgr-oper'
                                                            _revision = '2018-01-17'

                                                            def __init__(self):
                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode, self).__init__()

                                                                self.yang_name = "cl-encode"
                                                                self.yang_parent_name = "policy-class-info-bg"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("inline-cmap", ("inline_cmap", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap))])
                                                                self._leafs = OrderedDict([
                                                                    ('enc', (YLeaf(YType.enumeration, 'enc'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyObjEncEn', '')])),
                                                                    ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                                    ('hd', (YLeaf(YType.uint64, 'hd'), ['int'])),
                                                                    ('idx', (YLeaf(YType.uint8, 'idx'), ['int'])),
                                                                ])
                                                                self.enc = None
                                                                self.class_name = None
                                                                self.hd = None
                                                                self.idx = None

                                                                self.inline_cmap = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap()
                                                                self.inline_cmap.parent = self
                                                                self._children_name_map["inline_cmap"] = "inline-cmap"
                                                                self._segment_path = lambda: "cl-encode"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode, ['enc', 'class_name', 'hd', 'idx'], name, value)


                                                            class InlineCmap(Entity):
                                                                """
                                                                inline cmap
                                                                
                                                                .. attribute:: match_infop
                                                                
                                                                	Pointer to the first Match info
                                                                	**type**\:  :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop>`
                                                                
                                                                .. attribute:: mode
                                                                
                                                                	Inline Class\-Map Mode Match any/all
                                                                	**type**\:  :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                
                                                                .. attribute:: flags
                                                                
                                                                	Inline Class\-Map flags
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: match_count
                                                                
                                                                	Number of Match infos
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap, self).__init__()

                                                                    self.yang_name = "inline-cmap"
                                                                    self.yang_parent_name = "cl-encode"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("match-infop", ("match_infop", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop))])
                                                                    self._leafs = OrderedDict([
                                                                        ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapModeEn', '')])),
                                                                        ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                        ('match_count', (YLeaf(YType.uint32, 'match-count'), ['int'])),
                                                                    ])
                                                                    self.mode = None
                                                                    self.flags = None
                                                                    self.match_count = None

                                                                    self.match_infop = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop()
                                                                    self.match_infop.parent = self
                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                    self._segment_path = lambda: "inline-cmap"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap, ['mode', 'flags', 'match_count'], name, value)


                                                                class MatchInfop(Entity):
                                                                    """
                                                                    Pointer to the first Match info
                                                                    
                                                                    .. attribute:: class_match_info_st
                                                                    
                                                                    	class match info st
                                                                    	**type**\: list of  		 :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop, self).__init__()

                                                                        self.yang_name = "match-infop"
                                                                        self.yang_parent_name = "inline-cmap"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("class-match-info-st", ("class_match_info_st", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt))])
                                                                        self._leafs = OrderedDict()

                                                                        self.class_match_info_st = YList(self)
                                                                        self._segment_path = lambda: "match-infop"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop, [], name, value)


                                                                    class ClassMatchInfoSt(Entity):
                                                                        """
                                                                        class match info st
                                                                        
                                                                        .. attribute:: match_data
                                                                        
                                                                        	Match criteria
                                                                        	**type**\:  :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                        
                                                                        .. attribute:: flags
                                                                        
                                                                        	Flags
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                            self.yang_name = "class-match-info-st"
                                                                            self.yang_parent_name = "match-infop"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("match-data", ("match_data", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData))])
                                                                            self._leafs = OrderedDict([
                                                                                ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                            ])
                                                                            self.flags = None

                                                                            self.match_data = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                            self.match_data.parent = self
                                                                            self._children_name_map["match_data"] = "match-data"
                                                                            self._segment_path = lambda: "class-match-info-st"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                        class MatchData(Entity):
                                                                            """
                                                                            Match criteria
                                                                            
                                                                            .. attribute:: ipv4_dscp
                                                                            
                                                                            	IPv4 DSCP
                                                                            	**type**\:  :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                            
                                                                            .. attribute:: ipv6_dscp
                                                                            
                                                                            	IPv6 DSCP
                                                                            	**type**\:  :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                            
                                                                            .. attribute:: dscp
                                                                            
                                                                            	Match DSCP range array
                                                                            	**type**\:  :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                            
                                                                            .. attribute:: ipv4_prec
                                                                            
                                                                            	IPv4 Precedence
                                                                            	**type**\:  :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                            
                                                                            .. attribute:: ipv6_prec
                                                                            
                                                                            	IPv6 Precedence
                                                                            	**type**\:  :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                            
                                                                            .. attribute:: prec
                                                                            
                                                                            	Match Precedence array
                                                                            	**type**\:  :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                            
                                                                            .. attribute:: discard_class
                                                                            
                                                                            	Match Discard Class array
                                                                            	**type**\:  :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                            
                                                                            .. attribute:: qos_group
                                                                            
                                                                            	Match QoS group array
                                                                            	**type**\:  :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                            
                                                                            .. attribute:: traffic_class
                                                                            
                                                                            	Match Traffic class array
                                                                            	**type**\:  :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                            
                                                                            .. attribute:: proto
                                                                            
                                                                            	Match Protocol array
                                                                            	**type**\:  :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                            
                                                                            .. attribute:: icmp_v4
                                                                            
                                                                            	Match ICMPV4 Protocol
                                                                            	**type**\:  :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                            
                                                                            .. attribute:: icmp_v6
                                                                            
                                                                            	Match ICMPV6 Protocol array
                                                                            	**type**\:  :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                            
                                                                            .. attribute:: ipv4_packet_len
                                                                            
                                                                            	IPv4 packet length array
                                                                            	**type**\:  :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                            
                                                                            .. attribute:: ipv6_packet_len
                                                                            
                                                                            	IPv6 packet length array
                                                                            	**type**\:  :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                            
                                                                            .. attribute:: packet_len
                                                                            
                                                                            	Match packet length array
                                                                            	**type**\:  :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                            
                                                                            .. attribute:: flow_tag
                                                                            
                                                                            	Match flow\-tag array
                                                                            	**type**\:  :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                            
                                                                            .. attribute:: tcp_flag
                                                                            
                                                                            	Match tcp flag value
                                                                            	**type**\:  :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                            
                                                                            .. attribute:: icmpv4_type
                                                                            
                                                                            	Match ipv4 icmp type
                                                                            	**type**\:  :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                            
                                                                            .. attribute:: icmpv4_code
                                                                            
                                                                            	Match ipv4 icmp code
                                                                            	**type**\:  :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                            
                                                                            .. attribute:: icmpv6_type
                                                                            
                                                                            	Match ipv6 icmp type
                                                                            	**type**\:  :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                            
                                                                            .. attribute:: icmpv6_code
                                                                            
                                                                            	Match ipv6 icmp code
                                                                            	**type**\:  :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                            
                                                                            .. attribute:: mpls_exp
                                                                            
                                                                            	Match MPLS experimental topmost array
                                                                            	**type**\:  :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                            
                                                                            .. attribute:: mpls_exp_imp
                                                                            
                                                                            	Match MPLS experimental imposition array
                                                                            	**type**\:  :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                            
                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                            
                                                                            	MPLS Disposition IPv4 Access\-list
                                                                            	**type**\:  :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                            
                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                            
                                                                            	MPLS Disposition IPv6 Access\-list
                                                                            	**type**\:  :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                            
                                                                            .. attribute:: mpls_top_label
                                                                            
                                                                            	MPLS Topmost LABEL
                                                                            	**type**\:  :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                            
                                                                            .. attribute:: cos
                                                                            
                                                                            	Match CoS array
                                                                            	**type**\:  :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                            
                                                                            .. attribute:: cos_inr
                                                                            
                                                                            	Match inner header CoS
                                                                            	**type**\:  :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                            
                                                                            .. attribute:: dei
                                                                            
                                                                            	Match DEI Bit
                                                                            	**type**\:  :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                            
                                                                            .. attribute:: dei_inr
                                                                            
                                                                            	Match inner DEI Bit
                                                                            	**type**\:  :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                            
                                                                            .. attribute:: vlan
                                                                            
                                                                            	Match VLAN array
                                                                            	**type**\:  :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                            
                                                                            .. attribute:: vlan_inr
                                                                            
                                                                            	Match inner header VLAN range array
                                                                            	**type**\:  :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                            
                                                                            .. attribute:: fr_dlci
                                                                            
                                                                            	Match FR DLCI range array
                                                                            	**type**\:  :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                            
                                                                            .. attribute:: src_mac
                                                                            
                                                                            	Match Source MAC address
                                                                            	**type**\:  :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                            
                                                                            .. attribute:: dst_mac
                                                                            
                                                                            	Match Destination MAC address
                                                                            	**type**\:  :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                            
                                                                            .. attribute:: atm_clp
                                                                            
                                                                            	Match ATM CLP level
                                                                            	**type**\:  :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                            
                                                                            .. attribute:: fr_de
                                                                            
                                                                            	Match FR DE value
                                                                            	**type**\:  :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                            
                                                                            .. attribute:: ipv4_acl
                                                                            
                                                                            	IPv4 Access\-list
                                                                            	**type**\:  :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                            
                                                                            .. attribute:: ipv6_acl
                                                                            
                                                                            	IPv6 Access\-list
                                                                            	**type**\:  :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                            
                                                                            .. attribute:: ether_service_acl
                                                                            
                                                                            	Ethernet\-Services Access\-list
                                                                            	**type**\:  :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                            
                                                                            .. attribute:: avail_id
                                                                            
                                                                            	Available Identifiers
                                                                            	**type**\:  :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                            
                                                                            .. attribute:: media_type
                                                                            
                                                                            	Media Type
                                                                            	**type**\:  :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                            
                                                                            .. attribute:: subs_protocol
                                                                            
                                                                            	Protocol
                                                                            	**type**\:  :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                            
                                                                            .. attribute:: dnis
                                                                            
                                                                            	DNIS
                                                                            	**type**\:  :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                            
                                                                            .. attribute:: dnis_regex
                                                                            
                                                                            	DNIS Regular Expression
                                                                            	**type**\:  :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                            
                                                                            .. attribute:: domain
                                                                            
                                                                            	Domain Name
                                                                            	**type**\:  :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                            
                                                                            .. attribute:: domain_regex
                                                                            
                                                                            	Domain Regular Expression
                                                                            	**type**\:  :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                            
                                                                            .. attribute:: nas_port
                                                                            
                                                                            	NAS Port
                                                                            	**type**\:  :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                            
                                                                            .. attribute:: service_name
                                                                            
                                                                            	Service Name
                                                                            	**type**\:  :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                            
                                                                            .. attribute:: service_name_regex
                                                                            
                                                                            	Service Name Regular Exp
                                                                            	**type**\:  :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                            
                                                                            .. attribute:: src_addr_ipv4
                                                                            
                                                                            	Source Address IPV4
                                                                            	**type**\:  :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                            
                                                                            .. attribute:: dst_addr_ipv4
                                                                            
                                                                            	Destination Address IPV4
                                                                            	**type**\:  :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                            
                                                                            .. attribute:: src_addr_ipv6
                                                                            
                                                                            	Source Address IPV6
                                                                            	**type**\:  :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                            
                                                                            .. attribute:: dst_addr_ipv6
                                                                            
                                                                            	Destination Address IPV6
                                                                            	**type**\:  :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                            
                                                                            .. attribute:: src_addr_mac
                                                                            
                                                                            	Source Address MAC
                                                                            	**type**\:  :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                            
                                                                            .. attribute:: timer
                                                                            
                                                                            	Timer
                                                                            	**type**\:  :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                            
                                                                            .. attribute:: timer_regexp
                                                                            
                                                                            	Timer Regular Expression
                                                                            	**type**\:  :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                            
                                                                            .. attribute:: tunnel_name
                                                                            
                                                                            	Tunnel Name
                                                                            	**type**\:  :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                            
                                                                            .. attribute:: tunnel_name_regex
                                                                            
                                                                            	Tunnel Name Regular Expression
                                                                            	**type**\:  :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                            
                                                                            .. attribute:: user_name
                                                                            
                                                                            	User Name
                                                                            	**type**\:  :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                            
                                                                            .. attribute:: user_name_regex
                                                                            
                                                                            	User Name Regular Expression
                                                                            	**type**\:  :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                            
                                                                            .. attribute:: auth_username
                                                                            
                                                                            	Authenticated User Name
                                                                            	**type**\:  :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                            
                                                                            .. attribute:: auth_username_regex
                                                                            
                                                                            	Authenticated User Name RegEx
                                                                            	**type**\:  :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                            
                                                                            .. attribute:: unauth_username
                                                                            
                                                                            	Unauthenticated User Name
                                                                            	**type**\:  :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                            
                                                                            .. attribute:: unauth_username_regex
                                                                            
                                                                            	Unauthenticated User Name RegEx
                                                                            	**type**\:  :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                            
                                                                            .. attribute:: auth_domain
                                                                            
                                                                            	Authenticated domain name
                                                                            	**type**\:  :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                            
                                                                            .. attribute:: auth_domain_regex
                                                                            
                                                                            	Authenticated Domain Name RegEx
                                                                            	**type**\:  :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                            
                                                                            .. attribute:: unauth_domain
                                                                            
                                                                            	Unauthenticated Domain Name
                                                                            	**type**\:  :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                            
                                                                            .. attribute:: unauth_domain_regex
                                                                            
                                                                            	Unauthenticated Domain Name RegEx
                                                                            	**type**\:  :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                            
                                                                            .. attribute:: vendor_id
                                                                            
                                                                            	Vendor ID
                                                                            	**type**\:  :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                            
                                                                            .. attribute:: vendor_id_regex
                                                                            
                                                                            	Vendor ID RegEx
                                                                            	**type**\:  :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                            
                                                                            .. attribute:: access_interface
                                                                            
                                                                            	Access interface
                                                                            	**type**\:  :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                            
                                                                            .. attribute:: input_interface
                                                                            
                                                                            	Input interface
                                                                            	**type**\:  :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                            
                                                                            .. attribute:: input_intfhdl
                                                                            
                                                                            	Input interface handle
                                                                            	**type**\:  :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                            
                                                                            .. attribute:: ethertype
                                                                            
                                                                            	Ethernet type
                                                                            	**type**\:  :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                            
                                                                            .. attribute:: flow_key_data
                                                                            
                                                                            	Flow key structure
                                                                            	**type**\:  :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                            
                                                                            .. attribute:: dhcp_client_id
                                                                            
                                                                            	Dhcp Client ID
                                                                            	**type**\:  :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                            
                                                                            .. attribute:: dhcp_client_id_regex
                                                                            
                                                                            	Dhcp Client ID RegEx
                                                                            	**type**\:  :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                            
                                                                            .. attribute:: circuit_id
                                                                            
                                                                            	Circuit ID
                                                                            	**type**\:  :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                            
                                                                            .. attribute:: circuit_id_regex
                                                                            
                                                                            	Circuit ID RegEx
                                                                            	**type**\:  :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                            
                                                                            .. attribute:: remote_id
                                                                            
                                                                            	Remote ID
                                                                            	**type**\:  :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                            
                                                                            .. attribute:: remote_id_regex
                                                                            
                                                                            	Remote ID RegEx
                                                                            	**type**\:  :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                            
                                                                            .. attribute:: src_port
                                                                            
                                                                            	Source port
                                                                            	**type**\:  :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                            
                                                                            .. attribute:: dst_port
                                                                            
                                                                            	Destination port
                                                                            	**type**\:  :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:  :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                            
                                                                            .. attribute:: mpls_top_eos
                                                                            
                                                                            	MPLS Topmost EOS
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: fragment_type
                                                                            
                                                                            	Fragment type
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: authen_status
                                                                            
                                                                            	Authentication Status
                                                                            	**type**\:  :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                            
                                                                            .. attribute:: mlp_negotiated
                                                                            
                                                                            	MLP Negotiated
                                                                            	**type**\:  :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                self.yang_name = "match-data"
                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("ipv4-dscp", ("ipv4_dscp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp)), ("ipv6-dscp", ("ipv6_dscp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp)), ("dscp", ("dscp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp)), ("ipv4-prec", ("ipv4_prec", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec)), ("ipv6-prec", ("ipv6_prec", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec)), ("prec", ("prec", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec)), ("discard-class", ("discard_class", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass)), ("qos-group", ("qos_group", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup)), ("traffic-class", ("traffic_class", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass)), ("proto", ("proto", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto)), ("icmp-v4", ("icmp_v4", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4)), ("icmp-v6", ("icmp_v6", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6)), ("ipv4-packet-len", ("ipv4_packet_len", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen)), ("ipv6-packet-len", ("ipv6_packet_len", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen)), ("packet-len", ("packet_len", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen)), ("flow-tag", ("flow_tag", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag)), ("tcp-flag", ("tcp_flag", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag)), ("icmpv4-type", ("icmpv4_type", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type)), ("icmpv4-code", ("icmpv4_code", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code)), ("icmpv6-type", ("icmpv6_type", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type)), ("icmpv6-code", ("icmpv6_code", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code)), ("mpls-exp", ("mpls_exp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp)), ("mpls-exp-imp", ("mpls_exp_imp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp)), ("mpls-disp-ipv4-acl", ("mpls_disp_ipv4_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl)), ("mpls-disp-ipv6-acl", ("mpls_disp_ipv6_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl)), ("mpls-top-label", ("mpls_top_label", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel)), ("cos", ("cos", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos)), ("cos-inr", ("cos_inr", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr)), ("dei", ("dei", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei)), ("dei-inr", ("dei_inr", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr)), ("vlan", ("vlan", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan)), ("vlan-inr", ("vlan_inr", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)), ("fr-dlci", ("fr_dlci", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci)), ("src-mac", ("src_mac", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac)), ("dst-mac", ("dst_mac", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac)), ("atm-clp", ("atm_clp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp)), ("fr-de", ("fr_de", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe)), ("ipv4-acl", ("ipv4_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl)), ("ipv6-acl", ("ipv6_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl)), ("ether-service-acl", ("ether_service_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl)), ("avail-id", ("avail_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId)), ("media-type", ("media_type", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType)), ("subs-protocol", ("subs_protocol", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol)), ("dnis", ("dnis", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis)), ("dnis-regex", ("dnis_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex)), ("domain", ("domain", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain)), ("domain-regex", ("domain_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex)), ("nas-port", ("nas_port", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort)), ("service-name", ("service_name", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName)), ("service-name-regex", ("service_name_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex)), ("src-addr-ipv4", ("src_addr_ipv4", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4)), ("dst-addr-ipv4", ("dst_addr_ipv4", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4)), ("src-addr-ipv6", ("src_addr_ipv6", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6)), ("dst-addr-ipv6", ("dst_addr_ipv6", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6)), ("src-addr-mac", ("src_addr_mac", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac)), ("timer", ("timer", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer)), ("timer-regexp", ("timer_regexp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp)), ("tunnel-name", ("tunnel_name", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName)), ("tunnel-name-regex", ("tunnel_name_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex)), ("user-name", ("user_name", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName)), ("user-name-regex", ("user_name_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex)), ("auth-username", ("auth_username", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername)), ("auth-username-regex", ("auth_username_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex)), ("unauth-username", ("unauth_username", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername)), ("unauth-username-regex", ("unauth_username_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex)), ("auth-domain", ("auth_domain", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain)), ("auth-domain-regex", ("auth_domain_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex)), ("unauth-domain", ("unauth_domain", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain)), ("unauth-domain-regex", ("unauth_domain_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex)), ("vendor-id", ("vendor_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId)), ("vendor-id-regex", ("vendor_id_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex)), ("access-interface", ("access_interface", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface)), ("input-interface", ("input_interface", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface)), ("input-intfhdl", ("input_intfhdl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl)), ("ethertype", ("ethertype", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype)), ("flow-key-data", ("flow_key_data", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData)), ("dhcp-client-id", ("dhcp_client_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId)), ("dhcp-client-id-regex", ("dhcp_client_id_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex)), ("circuit-id", ("circuit_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId)), ("circuit-id-regex", ("circuit_id_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex)), ("remote-id", ("remote_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId)), ("remote-id-regex", ("remote_id_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex)), ("src-port", ("src_port", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort)), ("dst-port", ("dst_port", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchTypeEn', '')])),
                                                                                    ('mpls_top_eos', (YLeaf(YType.uint8, 'mpls-top-eos'), ['int'])),
                                                                                    ('fragment_type', (YLeaf(YType.uint8, 'fragment-type'), ['int'])),
                                                                                    ('authen_status', (YLeaf(YType.enumeration, 'authen-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchAuthenStatusEn', '')])),
                                                                                    ('mlp_negotiated', (YLeaf(YType.enumeration, 'mlp-negotiated'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchMlpNegotiatedEn', '')])),
                                                                                ])
                                                                                self.type = None
                                                                                self.mpls_top_eos = None
                                                                                self.fragment_type = None
                                                                                self.authen_status = None
                                                                                self.mlp_negotiated = None

                                                                                self.ipv4_dscp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                self.ipv4_dscp.parent = self
                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"

                                                                                self.ipv6_dscp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                self.ipv6_dscp.parent = self
                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"

                                                                                self.dscp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                self.dscp.parent = self
                                                                                self._children_name_map["dscp"] = "dscp"

                                                                                self.ipv4_prec = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                self.ipv4_prec.parent = self
                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"

                                                                                self.ipv6_prec = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                self.ipv6_prec.parent = self
                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"

                                                                                self.prec = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                self.prec.parent = self
                                                                                self._children_name_map["prec"] = "prec"

                                                                                self.discard_class = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                self.discard_class.parent = self
                                                                                self._children_name_map["discard_class"] = "discard-class"

                                                                                self.qos_group = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                self.qos_group.parent = self
                                                                                self._children_name_map["qos_group"] = "qos-group"

                                                                                self.traffic_class = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                self.traffic_class.parent = self
                                                                                self._children_name_map["traffic_class"] = "traffic-class"

                                                                                self.proto = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                self.proto.parent = self
                                                                                self._children_name_map["proto"] = "proto"

                                                                                self.icmp_v4 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                self.icmp_v4.parent = self
                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"

                                                                                self.icmp_v6 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                self.icmp_v6.parent = self
                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"

                                                                                self.ipv4_packet_len = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                self.ipv4_packet_len.parent = self
                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"

                                                                                self.ipv6_packet_len = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                self.ipv6_packet_len.parent = self
                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"

                                                                                self.packet_len = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                self.packet_len.parent = self
                                                                                self._children_name_map["packet_len"] = "packet-len"

                                                                                self.flow_tag = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                self.flow_tag.parent = self
                                                                                self._children_name_map["flow_tag"] = "flow-tag"

                                                                                self.tcp_flag = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                self.tcp_flag.parent = self
                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"

                                                                                self.icmpv4_type = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                self.icmpv4_type.parent = self
                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"

                                                                                self.icmpv4_code = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                self.icmpv4_code.parent = self
                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"

                                                                                self.icmpv6_type = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                self.icmpv6_type.parent = self
                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"

                                                                                self.icmpv6_code = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                self.icmpv6_code.parent = self
                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"

                                                                                self.mpls_exp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                self.mpls_exp.parent = self
                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"

                                                                                self.mpls_exp_imp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                self.mpls_exp_imp.parent = self
                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"

                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"

                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"

                                                                                self.mpls_top_label = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                self.mpls_top_label.parent = self
                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"

                                                                                self.cos = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                self.cos.parent = self
                                                                                self._children_name_map["cos"] = "cos"

                                                                                self.cos_inr = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                self.cos_inr.parent = self
                                                                                self._children_name_map["cos_inr"] = "cos-inr"

                                                                                self.dei = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                self.dei.parent = self
                                                                                self._children_name_map["dei"] = "dei"

                                                                                self.dei_inr = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                self.dei_inr.parent = self
                                                                                self._children_name_map["dei_inr"] = "dei-inr"

                                                                                self.vlan = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                self.vlan.parent = self
                                                                                self._children_name_map["vlan"] = "vlan"

                                                                                self.vlan_inr = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                self.vlan_inr.parent = self
                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"

                                                                                self.fr_dlci = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                self.fr_dlci.parent = self
                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"

                                                                                self.src_mac = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                self.src_mac.parent = self
                                                                                self._children_name_map["src_mac"] = "src-mac"

                                                                                self.dst_mac = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                self.dst_mac.parent = self
                                                                                self._children_name_map["dst_mac"] = "dst-mac"

                                                                                self.atm_clp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                self.atm_clp.parent = self
                                                                                self._children_name_map["atm_clp"] = "atm-clp"

                                                                                self.fr_de = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                self.fr_de.parent = self
                                                                                self._children_name_map["fr_de"] = "fr-de"

                                                                                self.ipv4_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                self.ipv4_acl.parent = self
                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"

                                                                                self.ipv6_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                self.ipv6_acl.parent = self
                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"

                                                                                self.ether_service_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                self.ether_service_acl.parent = self
                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"

                                                                                self.avail_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                self.avail_id.parent = self
                                                                                self._children_name_map["avail_id"] = "avail-id"

                                                                                self.media_type = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                self.media_type.parent = self
                                                                                self._children_name_map["media_type"] = "media-type"

                                                                                self.subs_protocol = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                self.subs_protocol.parent = self
                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"

                                                                                self.dnis = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                self.dnis.parent = self
                                                                                self._children_name_map["dnis"] = "dnis"

                                                                                self.dnis_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                self.dnis_regex.parent = self
                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"

                                                                                self.domain = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                self.domain.parent = self
                                                                                self._children_name_map["domain"] = "domain"

                                                                                self.domain_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                self.domain_regex.parent = self
                                                                                self._children_name_map["domain_regex"] = "domain-regex"

                                                                                self.nas_port = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                self.nas_port.parent = self
                                                                                self._children_name_map["nas_port"] = "nas-port"

                                                                                self.service_name = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                self.service_name.parent = self
                                                                                self._children_name_map["service_name"] = "service-name"

                                                                                self.service_name_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                self.service_name_regex.parent = self
                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"

                                                                                self.src_addr_ipv4 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                self.src_addr_ipv4.parent = self
                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"

                                                                                self.dst_addr_ipv4 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                self.dst_addr_ipv4.parent = self
                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"

                                                                                self.src_addr_ipv6 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                self.src_addr_ipv6.parent = self
                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"

                                                                                self.dst_addr_ipv6 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                self.dst_addr_ipv6.parent = self
                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"

                                                                                self.src_addr_mac = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                self.src_addr_mac.parent = self
                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"

                                                                                self.timer = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                self.timer.parent = self
                                                                                self._children_name_map["timer"] = "timer"

                                                                                self.timer_regexp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                self.timer_regexp.parent = self
                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"

                                                                                self.tunnel_name = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                self.tunnel_name.parent = self
                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"

                                                                                self.tunnel_name_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                self.tunnel_name_regex.parent = self
                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"

                                                                                self.user_name = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                self.user_name.parent = self
                                                                                self._children_name_map["user_name"] = "user-name"

                                                                                self.user_name_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                self.user_name_regex.parent = self
                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"

                                                                                self.auth_username = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                self.auth_username.parent = self
                                                                                self._children_name_map["auth_username"] = "auth-username"

                                                                                self.auth_username_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                self.auth_username_regex.parent = self
                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"

                                                                                self.unauth_username = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                self.unauth_username.parent = self
                                                                                self._children_name_map["unauth_username"] = "unauth-username"

                                                                                self.unauth_username_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                self.unauth_username_regex.parent = self
                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"

                                                                                self.auth_domain = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                self.auth_domain.parent = self
                                                                                self._children_name_map["auth_domain"] = "auth-domain"

                                                                                self.auth_domain_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                self.auth_domain_regex.parent = self
                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"

                                                                                self.unauth_domain = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                self.unauth_domain.parent = self
                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"

                                                                                self.unauth_domain_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                self.unauth_domain_regex.parent = self
                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"

                                                                                self.vendor_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                self.vendor_id.parent = self
                                                                                self._children_name_map["vendor_id"] = "vendor-id"

                                                                                self.vendor_id_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                self.vendor_id_regex.parent = self
                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"

                                                                                self.access_interface = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                self.access_interface.parent = self
                                                                                self._children_name_map["access_interface"] = "access-interface"

                                                                                self.input_interface = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                self.input_interface.parent = self
                                                                                self._children_name_map["input_interface"] = "input-interface"

                                                                                self.input_intfhdl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                self.input_intfhdl.parent = self
                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"

                                                                                self.ethertype = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                self.ethertype.parent = self
                                                                                self._children_name_map["ethertype"] = "ethertype"

                                                                                self.flow_key_data = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                self.flow_key_data.parent = self
                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"

                                                                                self.dhcp_client_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                self.dhcp_client_id.parent = self
                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"

                                                                                self.dhcp_client_id_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                self.dhcp_client_id_regex.parent = self
                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"

                                                                                self.circuit_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                self.circuit_id.parent = self
                                                                                self._children_name_map["circuit_id"] = "circuit-id"

                                                                                self.circuit_id_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                self.circuit_id_regex.parent = self
                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"

                                                                                self.remote_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                self.remote_id.parent = self
                                                                                self._children_name_map["remote_id"] = "remote-id"

                                                                                self.remote_id_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                self.remote_id_regex.parent = self
                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"

                                                                                self.src_port = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                self.src_port.parent = self
                                                                                self._children_name_map["src_port"] = "src-port"

                                                                                self.dst_port = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                self.dst_port.parent = self
                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                self._segment_path = lambda: "match-data"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, ['type', 'mpls_top_eos', 'fragment_type', 'authen_status', 'mlp_negotiated'], name, value)


                                                                            class Ipv4Dscp(Entity):
                                                                                """
                                                                                IPv4 DSCP
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                    self.yang_name = "ipv4-dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv4-dscp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Ipv6Dscp(Entity):
                                                                                """
                                                                                IPv6 DSCP
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                    self.yang_name = "ipv6-dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv6-dscp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Dscp(Entity):
                                                                                """
                                                                                Match DSCP range array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                    self.yang_name = "dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "dscp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Ipv4Prec(Entity):
                                                                                """
                                                                                IPv4 Precedence
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                    self.yang_name = "ipv4-prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "ipv4-prec"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                            class Ipv6Prec(Entity):
                                                                                """
                                                                                IPv6 Precedence
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                    self.yang_name = "ipv6-prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "ipv6-prec"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                            class Prec(Entity):
                                                                                """
                                                                                Match Precedence array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                    self.yang_name = "prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "prec"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                            class DiscardClass(Entity):
                                                                                """
                                                                                Match Discard Class array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                    self.yang_name = "discard-class"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "discard-class"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                            class QosGroup(Entity):
                                                                                """
                                                                                Match QoS group array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                    self.yang_name = "qos-group"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "qos-group"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "qos-group"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class TrafficClass(Entity):
                                                                                """
                                                                                Match Traffic class array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                    self.yang_name = "traffic-class"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "traffic-class"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "traffic-class"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Proto(Entity):
                                                                                """
                                                                                Match Protocol array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                    self.yang_name = "proto"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "proto"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "proto"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class IcmpV4(Entity):
                                                                                """
                                                                                Match ICMPV4 Protocol
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Protocol type
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: code
                                                                                
                                                                                	Protocol code
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                    self.yang_name = "icmp-v4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                    ])
                                                                                    self.type = None
                                                                                    self.code = None
                                                                                    self._segment_path = lambda: "icmp-v4"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['type', 'code'], name, value)


                                                                            class IcmpV6(Entity):
                                                                                """
                                                                                Match ICMPV6 Protocol array
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Protocol type
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: code
                                                                                
                                                                                	Protocol code
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                    self.yang_name = "icmp-v6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                    ])
                                                                                    self.type = None
                                                                                    self.code = None
                                                                                    self._segment_path = lambda: "icmp-v6"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['type', 'code'], name, value)


                                                                            class Ipv4PacketLen(Entity):
                                                                                """
                                                                                IPv4 packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv4-packet-len"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class Ipv6PacketLen(Entity):
                                                                                """
                                                                                IPv6 packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv6-packet-len"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class PacketLen(Entity):
                                                                                """
                                                                                Match packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                    self.yang_name = "packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "packet-len"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class FlowTag(Entity):
                                                                                """
                                                                                Match flow\-tag array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                    self.yang_name = "flow-tag"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "flow-tag"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "flow-tag"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class TcpFlag(Entity):
                                                                                """
                                                                                Match tcp flag value
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	Value of TCP flag
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: match_any
                                                                                
                                                                                	Match any TCP flag bit
                                                                                	**type**\: bool
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                    self.yang_name = "tcp-flag"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                        ('match_any', (YLeaf(YType.boolean, 'match-any'), ['bool'])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.match_any = None
                                                                                    self._segment_path = lambda: "tcp-flag"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['value', 'match_any'], name, value)


                                                                            class Icmpv4Type(Entity):
                                                                                """
                                                                                Match ipv4 icmp type
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                    self.yang_name = "icmpv4-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv4-type"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Icmpv4Code(Entity):
                                                                                """
                                                                                Match ipv4 icmp code
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                    self.yang_name = "icmpv4-code"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv4-code"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Icmpv6Type(Entity):
                                                                                """
                                                                                Match ipv6 icmp type
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                    self.yang_name = "icmpv6-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv6-type"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Icmpv6Code(Entity):
                                                                                """
                                                                                Match ipv6 icmp code
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                    self.yang_name = "icmpv6-code"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv6-code"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class MplsExp(Entity):
                                                                                """
                                                                                Match MPLS experimental topmost array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                    self.yang_name = "mpls-exp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "mpls-exp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                            class MplsExpImp(Entity):
                                                                                """
                                                                                Match MPLS experimental imposition array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "mpls-exp-imp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                            class MplsDispIpv4Acl(Entity):
                                                                                """
                                                                                MPLS Disposition IPv4 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                            class MplsDispIpv6Acl(Entity):
                                                                                """
                                                                                MPLS Disposition IPv6 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                            class MplsTopLabel(Entity):
                                                                                """
                                                                                MPLS Topmost LABEL
                                                                                
                                                                                .. attribute:: uint32_rng_array
                                                                                
                                                                                	uint32 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                    self.yang_name = "mpls-top-label"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint32_rng_array", ("uint32_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint32_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "mpls-top-label"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                class Uint32RngArray(Entity):
                                                                                    """
                                                                                    uint32 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                        self.yang_name = "uint32_rng_array"
                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint32, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint32, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint32_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['min', 'max'], name, value)


                                                                            class Cos(Entity):
                                                                                """
                                                                                Match CoS array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                    self.yang_name = "cos"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "cos"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                            class CosInr(Entity):
                                                                                """
                                                                                Match inner header CoS
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                    self.yang_name = "cos-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "cos-inr"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                            class Dei(Entity):
                                                                                """
                                                                                Match DEI Bit
                                                                                
                                                                                .. attribute:: bit_value
                                                                                
                                                                                	Value of the DEI bit
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                    self.yang_name = "dei"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                    ])
                                                                                    self.bit_value = None
                                                                                    self._segment_path = lambda: "dei"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                            class DeiInr(Entity):
                                                                                """
                                                                                Match inner DEI Bit
                                                                                
                                                                                .. attribute:: bit_value
                                                                                
                                                                                	Value of the DEI bit
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                    self.yang_name = "dei-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                    ])
                                                                                    self.bit_value = None
                                                                                    self._segment_path = lambda: "dei-inr"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                            class Vlan(Entity):
                                                                                """
                                                                                Match VLAN array
                                                                                
                                                                                .. attribute:: vlan_id_array
                                                                                
                                                                                	vlan id array
                                                                                	**type**\: list of  		 :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                    self.yang_name = "vlan"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("vlan-id-array", ("vlan_id_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.vlan_id_array = YList(self)
                                                                                    self._segment_path = lambda: "vlan"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                class VlanIdArray(Entity):
                                                                                    """
                                                                                    vlan id array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	VLAN mask
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                        self.yang_name = "vlan-id-array"
                                                                                        self.yang_parent_name = "vlan"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                            ('mask', (YLeaf(YType.uint16, 'mask'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self.mask = None
                                                                                        self._segment_path = lambda: "vlan-id-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['min', 'max', 'mask'], name, value)


                                                                            class VlanInr(Entity):
                                                                                """
                                                                                Match inner header VLAN range array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                    self.yang_name = "vlan-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "vlan-inr"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class FrDlci(Entity):
                                                                                """
                                                                                Match FR DLCI range array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                    self.yang_name = "fr-dlci"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "fr-dlci"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class SrcMac(Entity):
                                                                                """
                                                                                Match Source MAC address
                                                                                
                                                                                .. attribute:: mac_addr
                                                                                
                                                                                	MAC address
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	MAC mask
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                    self.yang_name = "src-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                    ])
                                                                                    self.mac_addr = []
                                                                                    self.mask = []
                                                                                    self._segment_path = lambda: "src-mac"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                            class DstMac(Entity):
                                                                                """
                                                                                Match Destination MAC address
                                                                                
                                                                                .. attribute:: mac_addr
                                                                                
                                                                                	MAC address
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	MAC mask
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                    self.yang_name = "dst-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                    ])
                                                                                    self.mac_addr = []
                                                                                    self.mask = []
                                                                                    self._segment_path = lambda: "dst-mac"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                            class AtmClp(Entity):
                                                                                """
                                                                                Match ATM CLP level
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                    self.yang_name = "atm-clp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "atm-clp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                            class FrDe(Entity):
                                                                                """
                                                                                Match FR DE value
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                    self.yang_name = "fr-de"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "fr-de"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                            class Ipv4Acl(Entity):
                                                                                """
                                                                                IPv4 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                    self.yang_name = "ipv4-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "ipv4-acl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                            class Ipv6Acl(Entity):
                                                                                """
                                                                                IPv6 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                    self.yang_name = "ipv6-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "ipv6-acl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                            class EtherServiceAcl(Entity):
                                                                                """
                                                                                Ethernet\-Services Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                    self.yang_name = "ether-service-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "ether-service-acl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                            class AvailId(Entity):
                                                                                """
                                                                                Available Identifiers
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                    self.yang_name = "avail-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "avail-id"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                            class MediaType(Entity):
                                                                                """
                                                                                Media Type
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                    self.yang_name = "media-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "media-type"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                            class SubsProtocol(Entity):
                                                                                """
                                                                                Protocol
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                    self.yang_name = "subs-protocol"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "subs-protocol"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                            class Dnis(Entity):
                                                                                """
                                                                                DNIS
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                    self.yang_name = "dnis"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "dnis"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                            class DnisRegex(Entity):
                                                                                """
                                                                                DNIS Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                    self.yang_name = "dnis-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "dnis-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                            class Domain(Entity):
                                                                                """
                                                                                Domain Name
                                                                                
                                                                                .. attribute:: domain_array
                                                                                
                                                                                	domain array
                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                    self.yang_name = "domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.domain_array = YList(self)
                                                                                    self._segment_path = lambda: "domain"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                class DomainArray(Entity):
                                                                                    """
                                                                                    domain array
                                                                                    
                                                                                    .. attribute:: domain_name
                                                                                    
                                                                                    	domain name
                                                                                    	**type**\: str
                                                                                    
                                                                                    .. attribute:: format_name
                                                                                    
                                                                                    	format name
                                                                                    	**type**\: str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                        self.yang_name = "domain-array"
                                                                                        self.yang_parent_name = "domain"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                        ])
                                                                                        self.domain_name = None
                                                                                        self.format_name = None
                                                                                        self._segment_path = lambda: "domain-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                            class DomainRegex(Entity):
                                                                                """
                                                                                Domain Regular Expression
                                                                                
                                                                                .. attribute:: domain_array
                                                                                
                                                                                	domain array
                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                    self.yang_name = "domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.domain_array = YList(self)
                                                                                    self._segment_path = lambda: "domain-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                class DomainArray(Entity):
                                                                                    """
                                                                                    domain array
                                                                                    
                                                                                    .. attribute:: domain_name
                                                                                    
                                                                                    	domain name
                                                                                    	**type**\: str
                                                                                    
                                                                                    .. attribute:: format_name
                                                                                    
                                                                                    	format name
                                                                                    	**type**\: str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                        self.yang_name = "domain-array"
                                                                                        self.yang_parent_name = "domain-regex"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                        ])
                                                                                        self.domain_name = None
                                                                                        self.format_name = None
                                                                                        self._segment_path = lambda: "domain-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                            class NasPort(Entity):
                                                                                """
                                                                                NAS Port
                                                                                
                                                                                .. attribute:: nas_port_array
                                                                                
                                                                                	nas port array
                                                                                	**type**\: list of  		 :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                    self.yang_name = "nas-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("nas-port-array", ("nas_port_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.nas_port_array = YList(self)
                                                                                    self._segment_path = lambda: "nas-port"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                class NasPortArray(Entity):
                                                                                    """
                                                                                    nas port array
                                                                                    
                                                                                    .. attribute:: sub_id
                                                                                    
                                                                                    	sub id
                                                                                    	**type**\:  :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                    
                                                                                    .. attribute:: operator
                                                                                    
                                                                                    	operator
                                                                                    	**type**\:  :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                        self.yang_name = "nas-port-array"
                                                                                        self.yang_parent_name = "nas-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('sub_id', (YLeaf(YType.enumeration, 'sub-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchNasPortSubIdEn', '')])),
                                                                                            ('operator', (YLeaf(YType.enumeration, 'operator'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchLogicalOperatorEn', '')])),
                                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ])
                                                                                        self.sub_id = None
                                                                                        self.operator = None
                                                                                        self.value = None
                                                                                        self._segment_path = lambda: "nas-port-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['sub_id', 'operator', 'value'], name, value)


                                                                            class ServiceName(Entity):
                                                                                """
                                                                                Service Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                    self.yang_name = "service-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "service-name"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                            class ServiceNameRegex(Entity):
                                                                                """
                                                                                Service Name Regular Exp
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                    self.yang_name = "service-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "service-name-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                            class SrcAddrIpv4(Entity):
                                                                                """
                                                                                Source Address IPV4
                                                                                
                                                                                .. attribute:: ipv4_addr_array
                                                                                
                                                                                	ipv4 addr array
                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.ipv4_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-ipv4"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                class Ipv4AddrArray(Entity):
                                                                                    """
                                                                                    ipv4 addr array
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	prefix
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	mask
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                        ])
                                                                                        self.prefix = None
                                                                                        self.mask = None
                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                            class DstAddrIpv4(Entity):
                                                                                """
                                                                                Destination Address IPV4
                                                                                
                                                                                .. attribute:: ipv4_addr_array
                                                                                
                                                                                	ipv4 addr array
                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.ipv4_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-addr-ipv4"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                class Ipv4AddrArray(Entity):
                                                                                    """
                                                                                    ipv4 addr array
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	prefix
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	mask
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                        ])
                                                                                        self.prefix = None
                                                                                        self.mask = None
                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                            class SrcAddrIpv6(Entity):
                                                                                """
                                                                                Source Address IPV6
                                                                                
                                                                                .. attribute:: ipv6_addr_array
                                                                                
                                                                                	ipv6 addr array
                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.ipv6_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-ipv6"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                class Ipv6AddrArray(Entity):
                                                                                    """
                                                                                    ipv6 addr array
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	IPV6 prefix
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	IPV6 mask
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                        ])
                                                                                        self.prefix = None
                                                                                        self.mask = None
                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                            class DstAddrIpv6(Entity):
                                                                                """
                                                                                Destination Address IPV6
                                                                                
                                                                                .. attribute:: ipv6_addr_array
                                                                                
                                                                                	ipv6 addr array
                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.ipv6_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-addr-ipv6"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                class Ipv6AddrArray(Entity):
                                                                                    """
                                                                                    ipv6 addr array
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	IPV6 prefix
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	IPV6 mask
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                        ])
                                                                                        self.prefix = None
                                                                                        self.mask = None
                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                            class SrcAddrMac(Entity):
                                                                                """
                                                                                Source Address MAC
                                                                                
                                                                                .. attribute:: mac_addr_array
                                                                                
                                                                                	mac addr array
                                                                                	**type**\: list of  		 :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                    self.yang_name = "src-addr-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("mac-addr-array", ("mac_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.mac_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-mac"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                class MacAddrArray(Entity):
                                                                                    """
                                                                                    mac addr array
                                                                                    
                                                                                    .. attribute:: mac_addr
                                                                                    
                                                                                    	MAC address
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	MAC mask
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                        self.yang_name = "mac-addr-array"
                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                            ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                        ])
                                                                                        self.mac_addr = []
                                                                                        self.mask = []
                                                                                        self._segment_path = lambda: "mac-addr-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                            class Timer(Entity):
                                                                                """
                                                                                Timer
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                    self.yang_name = "timer"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "timer"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                            class TimerRegexp(Entity):
                                                                                """
                                                                                Timer Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                    self.yang_name = "timer-regexp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "timer-regexp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                            class TunnelName(Entity):
                                                                                """
                                                                                Tunnel Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                    self.yang_name = "tunnel-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "tunnel-name"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                            class TunnelNameRegex(Entity):
                                                                                """
                                                                                Tunnel Name Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "tunnel-name-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                            class UserName(Entity):
                                                                                """
                                                                                User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                    self.yang_name = "user-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "user-name"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                            class UserNameRegex(Entity):
                                                                                """
                                                                                User Name Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                    self.yang_name = "user-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "user-name-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                            class AuthUsername(Entity):
                                                                                """
                                                                                Authenticated User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                    self.yang_name = "auth-username"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "auth-username"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                            class AuthUsernameRegex(Entity):
                                                                                """
                                                                                Authenticated User Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                    self.yang_name = "auth-username-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "auth-username-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                            class UnauthUsername(Entity):
                                                                                """
                                                                                Unauthenticated User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                    self.yang_name = "unauth-username"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "unauth-username"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                            class UnauthUsernameRegex(Entity):
                                                                                """
                                                                                Unauthenticated User Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                    self.yang_name = "unauth-username-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "unauth-username-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                            class AuthDomain(Entity):
                                                                                """
                                                                                Authenticated domain name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                    self.yang_name = "auth-domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "auth-domain"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                            class AuthDomainRegex(Entity):
                                                                                """
                                                                                Authenticated Domain Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                    self.yang_name = "auth-domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "auth-domain-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                            class UnauthDomain(Entity):
                                                                                """
                                                                                Unauthenticated Domain Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                    self.yang_name = "unauth-domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "unauth-domain"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                            class UnauthDomainRegex(Entity):
                                                                                """
                                                                                Unauthenticated Domain Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "unauth-domain-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                            class VendorId(Entity):
                                                                                """
                                                                                Vendor ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                    self.yang_name = "vendor-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "vendor-id"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                            class VendorIdRegex(Entity):
                                                                                """
                                                                                Vendor ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                    self.yang_name = "vendor-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "vendor-id-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                            class AccessInterface(Entity):
                                                                                """
                                                                                Access interface
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                    self.yang_name = "access-interface"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "access-interface"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                            class InputInterface(Entity):
                                                                                """
                                                                                Input interface
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                    self.yang_name = "input-interface"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "input-interface"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                            class InputIntfhdl(Entity):
                                                                                """
                                                                                Input interface handle
                                                                                
                                                                                .. attribute:: uint64_array
                                                                                
                                                                                	uint64 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..18446744073709551615
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                    self.yang_name = "input-intfhdl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint64_array', (YLeafList(YType.uint64, 'uint64_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint64_array = []
                                                                                    self._segment_path = lambda: "input-intfhdl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                            class Ethertype(Entity):
                                                                                """
                                                                                Ethernet type
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                    self.yang_name = "ethertype"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ethertype"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ethertype"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class FlowKeyData(Entity):
                                                                                """
                                                                                Flow key structure
                                                                                
                                                                                .. attribute:: flow_keys
                                                                                
                                                                                	flow keys
                                                                                	**type**\:  :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                
                                                                                .. attribute:: max_count
                                                                                
                                                                                	Maximum count of flows
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: idle_timeout
                                                                                
                                                                                	Idle timeout of flows (in seconds)
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                	**units**\: second
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                    self.yang_name = "flow-key-data"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("flow-keys", ("flow_keys", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('max_count', (YLeaf(YType.uint16, 'max-count'), ['int'])),
                                                                                        ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                                    ])
                                                                                    self.max_count = None
                                                                                    self.idle_timeout = None

                                                                                    self.flow_keys = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                    self.flow_keys.parent = self
                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                    self._segment_path = lambda: "flow-key-data"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['max_count', 'idle_timeout'], name, value)


                                                                                class FlowKeys(Entity):
                                                                                    """
                                                                                    flow keys
                                                                                    
                                                                                    .. attribute:: keys
                                                                                    
                                                                                    	keys
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                    
                                                                                    .. attribute:: num
                                                                                    
                                                                                    	num
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                        self.yang_name = "flow-keys"
                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('keys', (YLeaf(YType.str, 'keys'), ['str'])),
                                                                                            ('num', (YLeaf(YType.uint8, 'num'), ['int'])),
                                                                                        ])
                                                                                        self.keys = None
                                                                                        self.num = None
                                                                                        self._segment_path = lambda: "flow-keys"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                            class DhcpClientId(Entity):
                                                                                """
                                                                                Dhcp Client ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                    self.yang_name = "dhcp-client-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "dhcp-client-id"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                            class DhcpClientIdRegex(Entity):
                                                                                """
                                                                                Dhcp Client ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                            class CircuitId(Entity):
                                                                                """
                                                                                Circuit ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                    self.yang_name = "circuit-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "circuit-id"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                            class CircuitIdRegex(Entity):
                                                                                """
                                                                                Circuit ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                    self.yang_name = "circuit-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "circuit-id-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                            class RemoteId(Entity):
                                                                                """
                                                                                Remote ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                    self.yang_name = "remote-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "remote-id"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                            class RemoteIdRegex(Entity):
                                                                                """
                                                                                Remote ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                    self.yang_name = "remote-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "remote-id-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                            class SrcPort(Entity):
                                                                                """
                                                                                Source port
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                    self.yang_name = "src-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "src-port"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "src-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class DstPort(Entity):
                                                                                """
                                                                                Destination port
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                    self.yang_name = "dst-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-port"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "dst-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['min', 'max'], name, value)


                                                        class ClmpP(Entity):
                                                            """
                                                            clmp p
                                                            
                                                            .. attribute:: class_map_bg
                                                            
                                                            	class map bg
                                                            	**type**\: list of  		 :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'infra-policymgr-oper'
                                                            _revision = '2018-01-17'

                                                            def __init__(self):
                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP, self).__init__()

                                                                self.yang_name = "clmp-p"
                                                                self.yang_parent_name = "policy-class-info-bg"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("class-map-bg", ("class_map_bg", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg))])
                                                                self._leafs = OrderedDict()

                                                                self.class_map_bg = YList(self)
                                                                self._segment_path = lambda: "clmp-p"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP, [], name, value)


                                                            class ClassMapBg(Entity):
                                                                """
                                                                class map bg
                                                                
                                                                .. attribute:: match_infop
                                                                
                                                                	Pointer to the first Match info
                                                                	**type**\:  :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop>`
                                                                
                                                                .. attribute:: name
                                                                
                                                                	Name of the class\-map
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..65
                                                                
                                                                .. attribute:: type
                                                                
                                                                	Class\-Map Type QoS/PBR/Netflow/..
                                                                	**type**\:  :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                                
                                                                .. attribute:: mode
                                                                
                                                                	Class\-Map Mode Match any/Match all
                                                                	**type**\:  :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                
                                                                .. attribute:: description
                                                                
                                                                	description
                                                                	**type**\: str
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg, self).__init__()

                                                                    self.yang_name = "class-map-bg"
                                                                    self.yang_parent_name = "clmp-p"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("match-infop", ("match_infop", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop))])
                                                                    self._leafs = OrderedDict([
                                                                        ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapTypeEn', '')])),
                                                                        ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapModeEn', '')])),
                                                                        ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                    ])
                                                                    self.name = None
                                                                    self.type = None
                                                                    self.mode = None
                                                                    self.description = None

                                                                    self.match_infop = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop()
                                                                    self.match_infop.parent = self
                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                    self._segment_path = lambda: "class-map-bg"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg, ['name', 'type', 'mode', 'description'], name, value)


                                                                class MatchInfop(Entity):
                                                                    """
                                                                    Pointer to the first Match info
                                                                    
                                                                    .. attribute:: class_match_info_st
                                                                    
                                                                    	class match info st
                                                                    	**type**\: list of  		 :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop, self).__init__()

                                                                        self.yang_name = "match-infop"
                                                                        self.yang_parent_name = "class-map-bg"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("class-match-info-st", ("class_match_info_st", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt))])
                                                                        self._leafs = OrderedDict()

                                                                        self.class_match_info_st = YList(self)
                                                                        self._segment_path = lambda: "match-infop"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop, [], name, value)


                                                                    class ClassMatchInfoSt(Entity):
                                                                        """
                                                                        class match info st
                                                                        
                                                                        .. attribute:: match_data
                                                                        
                                                                        	Match criteria
                                                                        	**type**\:  :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                        
                                                                        .. attribute:: flags
                                                                        
                                                                        	Flags
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                            self.yang_name = "class-match-info-st"
                                                                            self.yang_parent_name = "match-infop"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("match-data", ("match_data", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData))])
                                                                            self._leafs = OrderedDict([
                                                                                ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                            ])
                                                                            self.flags = None

                                                                            self.match_data = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                            self.match_data.parent = self
                                                                            self._children_name_map["match_data"] = "match-data"
                                                                            self._segment_path = lambda: "class-match-info-st"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                        class MatchData(Entity):
                                                                            """
                                                                            Match criteria
                                                                            
                                                                            .. attribute:: ipv4_dscp
                                                                            
                                                                            	IPv4 DSCP
                                                                            	**type**\:  :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                            
                                                                            .. attribute:: ipv6_dscp
                                                                            
                                                                            	IPv6 DSCP
                                                                            	**type**\:  :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                            
                                                                            .. attribute:: dscp
                                                                            
                                                                            	Match DSCP range array
                                                                            	**type**\:  :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                            
                                                                            .. attribute:: ipv4_prec
                                                                            
                                                                            	IPv4 Precedence
                                                                            	**type**\:  :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                            
                                                                            .. attribute:: ipv6_prec
                                                                            
                                                                            	IPv6 Precedence
                                                                            	**type**\:  :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                            
                                                                            .. attribute:: prec
                                                                            
                                                                            	Match Precedence array
                                                                            	**type**\:  :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                            
                                                                            .. attribute:: discard_class
                                                                            
                                                                            	Match Discard Class array
                                                                            	**type**\:  :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                            
                                                                            .. attribute:: qos_group
                                                                            
                                                                            	Match QoS group array
                                                                            	**type**\:  :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                            
                                                                            .. attribute:: traffic_class
                                                                            
                                                                            	Match Traffic class array
                                                                            	**type**\:  :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                            
                                                                            .. attribute:: proto
                                                                            
                                                                            	Match Protocol array
                                                                            	**type**\:  :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                            
                                                                            .. attribute:: icmp_v4
                                                                            
                                                                            	Match ICMPV4 Protocol
                                                                            	**type**\:  :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                            
                                                                            .. attribute:: icmp_v6
                                                                            
                                                                            	Match ICMPV6 Protocol array
                                                                            	**type**\:  :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                            
                                                                            .. attribute:: ipv4_packet_len
                                                                            
                                                                            	IPv4 packet length array
                                                                            	**type**\:  :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                            
                                                                            .. attribute:: ipv6_packet_len
                                                                            
                                                                            	IPv6 packet length array
                                                                            	**type**\:  :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                            
                                                                            .. attribute:: packet_len
                                                                            
                                                                            	Match packet length array
                                                                            	**type**\:  :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                            
                                                                            .. attribute:: flow_tag
                                                                            
                                                                            	Match flow\-tag array
                                                                            	**type**\:  :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                            
                                                                            .. attribute:: tcp_flag
                                                                            
                                                                            	Match tcp flag value
                                                                            	**type**\:  :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                            
                                                                            .. attribute:: icmpv4_type
                                                                            
                                                                            	Match ipv4 icmp type
                                                                            	**type**\:  :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                            
                                                                            .. attribute:: icmpv4_code
                                                                            
                                                                            	Match ipv4 icmp code
                                                                            	**type**\:  :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                            
                                                                            .. attribute:: icmpv6_type
                                                                            
                                                                            	Match ipv6 icmp type
                                                                            	**type**\:  :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                            
                                                                            .. attribute:: icmpv6_code
                                                                            
                                                                            	Match ipv6 icmp code
                                                                            	**type**\:  :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                            
                                                                            .. attribute:: mpls_exp
                                                                            
                                                                            	Match MPLS experimental topmost array
                                                                            	**type**\:  :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                            
                                                                            .. attribute:: mpls_exp_imp
                                                                            
                                                                            	Match MPLS experimental imposition array
                                                                            	**type**\:  :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                            
                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                            
                                                                            	MPLS Disposition IPv4 Access\-list
                                                                            	**type**\:  :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                            
                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                            
                                                                            	MPLS Disposition IPv6 Access\-list
                                                                            	**type**\:  :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                            
                                                                            .. attribute:: mpls_top_label
                                                                            
                                                                            	MPLS Topmost LABEL
                                                                            	**type**\:  :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                            
                                                                            .. attribute:: cos
                                                                            
                                                                            	Match CoS array
                                                                            	**type**\:  :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                            
                                                                            .. attribute:: cos_inr
                                                                            
                                                                            	Match inner header CoS
                                                                            	**type**\:  :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                            
                                                                            .. attribute:: dei
                                                                            
                                                                            	Match DEI Bit
                                                                            	**type**\:  :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                            
                                                                            .. attribute:: dei_inr
                                                                            
                                                                            	Match inner DEI Bit
                                                                            	**type**\:  :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                            
                                                                            .. attribute:: vlan
                                                                            
                                                                            	Match VLAN array
                                                                            	**type**\:  :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                            
                                                                            .. attribute:: vlan_inr
                                                                            
                                                                            	Match inner header VLAN range array
                                                                            	**type**\:  :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                            
                                                                            .. attribute:: fr_dlci
                                                                            
                                                                            	Match FR DLCI range array
                                                                            	**type**\:  :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                            
                                                                            .. attribute:: src_mac
                                                                            
                                                                            	Match Source MAC address
                                                                            	**type**\:  :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                            
                                                                            .. attribute:: dst_mac
                                                                            
                                                                            	Match Destination MAC address
                                                                            	**type**\:  :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                            
                                                                            .. attribute:: atm_clp
                                                                            
                                                                            	Match ATM CLP level
                                                                            	**type**\:  :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                            
                                                                            .. attribute:: fr_de
                                                                            
                                                                            	Match FR DE value
                                                                            	**type**\:  :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                            
                                                                            .. attribute:: ipv4_acl
                                                                            
                                                                            	IPv4 Access\-list
                                                                            	**type**\:  :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                            
                                                                            .. attribute:: ipv6_acl
                                                                            
                                                                            	IPv6 Access\-list
                                                                            	**type**\:  :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                            
                                                                            .. attribute:: ether_service_acl
                                                                            
                                                                            	Ethernet\-Services Access\-list
                                                                            	**type**\:  :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                            
                                                                            .. attribute:: avail_id
                                                                            
                                                                            	Available Identifiers
                                                                            	**type**\:  :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                            
                                                                            .. attribute:: media_type
                                                                            
                                                                            	Media Type
                                                                            	**type**\:  :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                            
                                                                            .. attribute:: subs_protocol
                                                                            
                                                                            	Protocol
                                                                            	**type**\:  :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                            
                                                                            .. attribute:: dnis
                                                                            
                                                                            	DNIS
                                                                            	**type**\:  :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                            
                                                                            .. attribute:: dnis_regex
                                                                            
                                                                            	DNIS Regular Expression
                                                                            	**type**\:  :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                            
                                                                            .. attribute:: domain
                                                                            
                                                                            	Domain Name
                                                                            	**type**\:  :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                            
                                                                            .. attribute:: domain_regex
                                                                            
                                                                            	Domain Regular Expression
                                                                            	**type**\:  :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                            
                                                                            .. attribute:: nas_port
                                                                            
                                                                            	NAS Port
                                                                            	**type**\:  :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                            
                                                                            .. attribute:: service_name
                                                                            
                                                                            	Service Name
                                                                            	**type**\:  :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                            
                                                                            .. attribute:: service_name_regex
                                                                            
                                                                            	Service Name Regular Exp
                                                                            	**type**\:  :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                            
                                                                            .. attribute:: src_addr_ipv4
                                                                            
                                                                            	Source Address IPV4
                                                                            	**type**\:  :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                            
                                                                            .. attribute:: dst_addr_ipv4
                                                                            
                                                                            	Destination Address IPV4
                                                                            	**type**\:  :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                            
                                                                            .. attribute:: src_addr_ipv6
                                                                            
                                                                            	Source Address IPV6
                                                                            	**type**\:  :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                            
                                                                            .. attribute:: dst_addr_ipv6
                                                                            
                                                                            	Destination Address IPV6
                                                                            	**type**\:  :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                            
                                                                            .. attribute:: src_addr_mac
                                                                            
                                                                            	Source Address MAC
                                                                            	**type**\:  :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                            
                                                                            .. attribute:: timer
                                                                            
                                                                            	Timer
                                                                            	**type**\:  :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                            
                                                                            .. attribute:: timer_regexp
                                                                            
                                                                            	Timer Regular Expression
                                                                            	**type**\:  :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                            
                                                                            .. attribute:: tunnel_name
                                                                            
                                                                            	Tunnel Name
                                                                            	**type**\:  :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                            
                                                                            .. attribute:: tunnel_name_regex
                                                                            
                                                                            	Tunnel Name Regular Expression
                                                                            	**type**\:  :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                            
                                                                            .. attribute:: user_name
                                                                            
                                                                            	User Name
                                                                            	**type**\:  :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                            
                                                                            .. attribute:: user_name_regex
                                                                            
                                                                            	User Name Regular Expression
                                                                            	**type**\:  :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                            
                                                                            .. attribute:: auth_username
                                                                            
                                                                            	Authenticated User Name
                                                                            	**type**\:  :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                            
                                                                            .. attribute:: auth_username_regex
                                                                            
                                                                            	Authenticated User Name RegEx
                                                                            	**type**\:  :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                            
                                                                            .. attribute:: unauth_username
                                                                            
                                                                            	Unauthenticated User Name
                                                                            	**type**\:  :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                            
                                                                            .. attribute:: unauth_username_regex
                                                                            
                                                                            	Unauthenticated User Name RegEx
                                                                            	**type**\:  :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                            
                                                                            .. attribute:: auth_domain
                                                                            
                                                                            	Authenticated domain name
                                                                            	**type**\:  :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                            
                                                                            .. attribute:: auth_domain_regex
                                                                            
                                                                            	Authenticated Domain Name RegEx
                                                                            	**type**\:  :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                            
                                                                            .. attribute:: unauth_domain
                                                                            
                                                                            	Unauthenticated Domain Name
                                                                            	**type**\:  :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                            
                                                                            .. attribute:: unauth_domain_regex
                                                                            
                                                                            	Unauthenticated Domain Name RegEx
                                                                            	**type**\:  :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                            
                                                                            .. attribute:: vendor_id
                                                                            
                                                                            	Vendor ID
                                                                            	**type**\:  :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                            
                                                                            .. attribute:: vendor_id_regex
                                                                            
                                                                            	Vendor ID RegEx
                                                                            	**type**\:  :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                            
                                                                            .. attribute:: access_interface
                                                                            
                                                                            	Access interface
                                                                            	**type**\:  :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                            
                                                                            .. attribute:: input_interface
                                                                            
                                                                            	Input interface
                                                                            	**type**\:  :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                            
                                                                            .. attribute:: input_intfhdl
                                                                            
                                                                            	Input interface handle
                                                                            	**type**\:  :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                            
                                                                            .. attribute:: ethertype
                                                                            
                                                                            	Ethernet type
                                                                            	**type**\:  :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                            
                                                                            .. attribute:: flow_key_data
                                                                            
                                                                            	Flow key structure
                                                                            	**type**\:  :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                            
                                                                            .. attribute:: dhcp_client_id
                                                                            
                                                                            	Dhcp Client ID
                                                                            	**type**\:  :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                            
                                                                            .. attribute:: dhcp_client_id_regex
                                                                            
                                                                            	Dhcp Client ID RegEx
                                                                            	**type**\:  :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                            
                                                                            .. attribute:: circuit_id
                                                                            
                                                                            	Circuit ID
                                                                            	**type**\:  :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                            
                                                                            .. attribute:: circuit_id_regex
                                                                            
                                                                            	Circuit ID RegEx
                                                                            	**type**\:  :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                            
                                                                            .. attribute:: remote_id
                                                                            
                                                                            	Remote ID
                                                                            	**type**\:  :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                            
                                                                            .. attribute:: remote_id_regex
                                                                            
                                                                            	Remote ID RegEx
                                                                            	**type**\:  :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                            
                                                                            .. attribute:: src_port
                                                                            
                                                                            	Source port
                                                                            	**type**\:  :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                            
                                                                            .. attribute:: dst_port
                                                                            
                                                                            	Destination port
                                                                            	**type**\:  :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:  :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                            
                                                                            .. attribute:: mpls_top_eos
                                                                            
                                                                            	MPLS Topmost EOS
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: fragment_type
                                                                            
                                                                            	Fragment type
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: authen_status
                                                                            
                                                                            	Authentication Status
                                                                            	**type**\:  :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                            
                                                                            .. attribute:: mlp_negotiated
                                                                            
                                                                            	MLP Negotiated
                                                                            	**type**\:  :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                self.yang_name = "match-data"
                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("ipv4-dscp", ("ipv4_dscp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp)), ("ipv6-dscp", ("ipv6_dscp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp)), ("dscp", ("dscp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp)), ("ipv4-prec", ("ipv4_prec", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec)), ("ipv6-prec", ("ipv6_prec", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec)), ("prec", ("prec", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec)), ("discard-class", ("discard_class", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass)), ("qos-group", ("qos_group", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup)), ("traffic-class", ("traffic_class", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass)), ("proto", ("proto", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto)), ("icmp-v4", ("icmp_v4", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4)), ("icmp-v6", ("icmp_v6", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6)), ("ipv4-packet-len", ("ipv4_packet_len", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen)), ("ipv6-packet-len", ("ipv6_packet_len", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen)), ("packet-len", ("packet_len", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen)), ("flow-tag", ("flow_tag", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag)), ("tcp-flag", ("tcp_flag", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag)), ("icmpv4-type", ("icmpv4_type", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type)), ("icmpv4-code", ("icmpv4_code", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code)), ("icmpv6-type", ("icmpv6_type", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type)), ("icmpv6-code", ("icmpv6_code", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code)), ("mpls-exp", ("mpls_exp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp)), ("mpls-exp-imp", ("mpls_exp_imp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp)), ("mpls-disp-ipv4-acl", ("mpls_disp_ipv4_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl)), ("mpls-disp-ipv6-acl", ("mpls_disp_ipv6_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl)), ("mpls-top-label", ("mpls_top_label", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel)), ("cos", ("cos", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos)), ("cos-inr", ("cos_inr", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr)), ("dei", ("dei", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei)), ("dei-inr", ("dei_inr", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr)), ("vlan", ("vlan", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan)), ("vlan-inr", ("vlan_inr", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)), ("fr-dlci", ("fr_dlci", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci)), ("src-mac", ("src_mac", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac)), ("dst-mac", ("dst_mac", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac)), ("atm-clp", ("atm_clp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp)), ("fr-de", ("fr_de", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe)), ("ipv4-acl", ("ipv4_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl)), ("ipv6-acl", ("ipv6_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl)), ("ether-service-acl", ("ether_service_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl)), ("avail-id", ("avail_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId)), ("media-type", ("media_type", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType)), ("subs-protocol", ("subs_protocol", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol)), ("dnis", ("dnis", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis)), ("dnis-regex", ("dnis_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex)), ("domain", ("domain", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain)), ("domain-regex", ("domain_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex)), ("nas-port", ("nas_port", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort)), ("service-name", ("service_name", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName)), ("service-name-regex", ("service_name_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex)), ("src-addr-ipv4", ("src_addr_ipv4", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4)), ("dst-addr-ipv4", ("dst_addr_ipv4", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4)), ("src-addr-ipv6", ("src_addr_ipv6", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6)), ("dst-addr-ipv6", ("dst_addr_ipv6", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6)), ("src-addr-mac", ("src_addr_mac", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac)), ("timer", ("timer", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer)), ("timer-regexp", ("timer_regexp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp)), ("tunnel-name", ("tunnel_name", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName)), ("tunnel-name-regex", ("tunnel_name_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex)), ("user-name", ("user_name", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName)), ("user-name-regex", ("user_name_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex)), ("auth-username", ("auth_username", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername)), ("auth-username-regex", ("auth_username_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex)), ("unauth-username", ("unauth_username", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername)), ("unauth-username-regex", ("unauth_username_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex)), ("auth-domain", ("auth_domain", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain)), ("auth-domain-regex", ("auth_domain_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex)), ("unauth-domain", ("unauth_domain", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain)), ("unauth-domain-regex", ("unauth_domain_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex)), ("vendor-id", ("vendor_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId)), ("vendor-id-regex", ("vendor_id_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex)), ("access-interface", ("access_interface", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface)), ("input-interface", ("input_interface", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface)), ("input-intfhdl", ("input_intfhdl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl)), ("ethertype", ("ethertype", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype)), ("flow-key-data", ("flow_key_data", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData)), ("dhcp-client-id", ("dhcp_client_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId)), ("dhcp-client-id-regex", ("dhcp_client_id_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex)), ("circuit-id", ("circuit_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId)), ("circuit-id-regex", ("circuit_id_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex)), ("remote-id", ("remote_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId)), ("remote-id-regex", ("remote_id_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex)), ("src-port", ("src_port", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort)), ("dst-port", ("dst_port", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchTypeEn', '')])),
                                                                                    ('mpls_top_eos', (YLeaf(YType.uint8, 'mpls-top-eos'), ['int'])),
                                                                                    ('fragment_type', (YLeaf(YType.uint8, 'fragment-type'), ['int'])),
                                                                                    ('authen_status', (YLeaf(YType.enumeration, 'authen-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchAuthenStatusEn', '')])),
                                                                                    ('mlp_negotiated', (YLeaf(YType.enumeration, 'mlp-negotiated'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchMlpNegotiatedEn', '')])),
                                                                                ])
                                                                                self.type = None
                                                                                self.mpls_top_eos = None
                                                                                self.fragment_type = None
                                                                                self.authen_status = None
                                                                                self.mlp_negotiated = None

                                                                                self.ipv4_dscp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                self.ipv4_dscp.parent = self
                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"

                                                                                self.ipv6_dscp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                self.ipv6_dscp.parent = self
                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"

                                                                                self.dscp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                self.dscp.parent = self
                                                                                self._children_name_map["dscp"] = "dscp"

                                                                                self.ipv4_prec = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                self.ipv4_prec.parent = self
                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"

                                                                                self.ipv6_prec = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                self.ipv6_prec.parent = self
                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"

                                                                                self.prec = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                self.prec.parent = self
                                                                                self._children_name_map["prec"] = "prec"

                                                                                self.discard_class = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                self.discard_class.parent = self
                                                                                self._children_name_map["discard_class"] = "discard-class"

                                                                                self.qos_group = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                self.qos_group.parent = self
                                                                                self._children_name_map["qos_group"] = "qos-group"

                                                                                self.traffic_class = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                self.traffic_class.parent = self
                                                                                self._children_name_map["traffic_class"] = "traffic-class"

                                                                                self.proto = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                self.proto.parent = self
                                                                                self._children_name_map["proto"] = "proto"

                                                                                self.icmp_v4 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                self.icmp_v4.parent = self
                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"

                                                                                self.icmp_v6 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                self.icmp_v6.parent = self
                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"

                                                                                self.ipv4_packet_len = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                self.ipv4_packet_len.parent = self
                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"

                                                                                self.ipv6_packet_len = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                self.ipv6_packet_len.parent = self
                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"

                                                                                self.packet_len = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                self.packet_len.parent = self
                                                                                self._children_name_map["packet_len"] = "packet-len"

                                                                                self.flow_tag = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                self.flow_tag.parent = self
                                                                                self._children_name_map["flow_tag"] = "flow-tag"

                                                                                self.tcp_flag = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                self.tcp_flag.parent = self
                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"

                                                                                self.icmpv4_type = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                self.icmpv4_type.parent = self
                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"

                                                                                self.icmpv4_code = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                self.icmpv4_code.parent = self
                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"

                                                                                self.icmpv6_type = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                self.icmpv6_type.parent = self
                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"

                                                                                self.icmpv6_code = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                self.icmpv6_code.parent = self
                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"

                                                                                self.mpls_exp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                self.mpls_exp.parent = self
                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"

                                                                                self.mpls_exp_imp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                self.mpls_exp_imp.parent = self
                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"

                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"

                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"

                                                                                self.mpls_top_label = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                self.mpls_top_label.parent = self
                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"

                                                                                self.cos = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                self.cos.parent = self
                                                                                self._children_name_map["cos"] = "cos"

                                                                                self.cos_inr = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                self.cos_inr.parent = self
                                                                                self._children_name_map["cos_inr"] = "cos-inr"

                                                                                self.dei = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                self.dei.parent = self
                                                                                self._children_name_map["dei"] = "dei"

                                                                                self.dei_inr = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                self.dei_inr.parent = self
                                                                                self._children_name_map["dei_inr"] = "dei-inr"

                                                                                self.vlan = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                self.vlan.parent = self
                                                                                self._children_name_map["vlan"] = "vlan"

                                                                                self.vlan_inr = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                self.vlan_inr.parent = self
                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"

                                                                                self.fr_dlci = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                self.fr_dlci.parent = self
                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"

                                                                                self.src_mac = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                self.src_mac.parent = self
                                                                                self._children_name_map["src_mac"] = "src-mac"

                                                                                self.dst_mac = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                self.dst_mac.parent = self
                                                                                self._children_name_map["dst_mac"] = "dst-mac"

                                                                                self.atm_clp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                self.atm_clp.parent = self
                                                                                self._children_name_map["atm_clp"] = "atm-clp"

                                                                                self.fr_de = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                self.fr_de.parent = self
                                                                                self._children_name_map["fr_de"] = "fr-de"

                                                                                self.ipv4_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                self.ipv4_acl.parent = self
                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"

                                                                                self.ipv6_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                self.ipv6_acl.parent = self
                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"

                                                                                self.ether_service_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                self.ether_service_acl.parent = self
                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"

                                                                                self.avail_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                self.avail_id.parent = self
                                                                                self._children_name_map["avail_id"] = "avail-id"

                                                                                self.media_type = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                self.media_type.parent = self
                                                                                self._children_name_map["media_type"] = "media-type"

                                                                                self.subs_protocol = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                self.subs_protocol.parent = self
                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"

                                                                                self.dnis = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                self.dnis.parent = self
                                                                                self._children_name_map["dnis"] = "dnis"

                                                                                self.dnis_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                self.dnis_regex.parent = self
                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"

                                                                                self.domain = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                self.domain.parent = self
                                                                                self._children_name_map["domain"] = "domain"

                                                                                self.domain_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                self.domain_regex.parent = self
                                                                                self._children_name_map["domain_regex"] = "domain-regex"

                                                                                self.nas_port = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                self.nas_port.parent = self
                                                                                self._children_name_map["nas_port"] = "nas-port"

                                                                                self.service_name = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                self.service_name.parent = self
                                                                                self._children_name_map["service_name"] = "service-name"

                                                                                self.service_name_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                self.service_name_regex.parent = self
                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"

                                                                                self.src_addr_ipv4 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                self.src_addr_ipv4.parent = self
                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"

                                                                                self.dst_addr_ipv4 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                self.dst_addr_ipv4.parent = self
                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"

                                                                                self.src_addr_ipv6 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                self.src_addr_ipv6.parent = self
                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"

                                                                                self.dst_addr_ipv6 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                self.dst_addr_ipv6.parent = self
                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"

                                                                                self.src_addr_mac = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                self.src_addr_mac.parent = self
                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"

                                                                                self.timer = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                self.timer.parent = self
                                                                                self._children_name_map["timer"] = "timer"

                                                                                self.timer_regexp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                self.timer_regexp.parent = self
                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"

                                                                                self.tunnel_name = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                self.tunnel_name.parent = self
                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"

                                                                                self.tunnel_name_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                self.tunnel_name_regex.parent = self
                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"

                                                                                self.user_name = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                self.user_name.parent = self
                                                                                self._children_name_map["user_name"] = "user-name"

                                                                                self.user_name_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                self.user_name_regex.parent = self
                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"

                                                                                self.auth_username = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                self.auth_username.parent = self
                                                                                self._children_name_map["auth_username"] = "auth-username"

                                                                                self.auth_username_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                self.auth_username_regex.parent = self
                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"

                                                                                self.unauth_username = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                self.unauth_username.parent = self
                                                                                self._children_name_map["unauth_username"] = "unauth-username"

                                                                                self.unauth_username_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                self.unauth_username_regex.parent = self
                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"

                                                                                self.auth_domain = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                self.auth_domain.parent = self
                                                                                self._children_name_map["auth_domain"] = "auth-domain"

                                                                                self.auth_domain_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                self.auth_domain_regex.parent = self
                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"

                                                                                self.unauth_domain = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                self.unauth_domain.parent = self
                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"

                                                                                self.unauth_domain_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                self.unauth_domain_regex.parent = self
                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"

                                                                                self.vendor_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                self.vendor_id.parent = self
                                                                                self._children_name_map["vendor_id"] = "vendor-id"

                                                                                self.vendor_id_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                self.vendor_id_regex.parent = self
                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"

                                                                                self.access_interface = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                self.access_interface.parent = self
                                                                                self._children_name_map["access_interface"] = "access-interface"

                                                                                self.input_interface = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                self.input_interface.parent = self
                                                                                self._children_name_map["input_interface"] = "input-interface"

                                                                                self.input_intfhdl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                self.input_intfhdl.parent = self
                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"

                                                                                self.ethertype = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                self.ethertype.parent = self
                                                                                self._children_name_map["ethertype"] = "ethertype"

                                                                                self.flow_key_data = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                self.flow_key_data.parent = self
                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"

                                                                                self.dhcp_client_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                self.dhcp_client_id.parent = self
                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"

                                                                                self.dhcp_client_id_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                self.dhcp_client_id_regex.parent = self
                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"

                                                                                self.circuit_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                self.circuit_id.parent = self
                                                                                self._children_name_map["circuit_id"] = "circuit-id"

                                                                                self.circuit_id_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                self.circuit_id_regex.parent = self
                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"

                                                                                self.remote_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                self.remote_id.parent = self
                                                                                self._children_name_map["remote_id"] = "remote-id"

                                                                                self.remote_id_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                self.remote_id_regex.parent = self
                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"

                                                                                self.src_port = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                self.src_port.parent = self
                                                                                self._children_name_map["src_port"] = "src-port"

                                                                                self.dst_port = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                self.dst_port.parent = self
                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                self._segment_path = lambda: "match-data"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['type', 'mpls_top_eos', 'fragment_type', 'authen_status', 'mlp_negotiated'], name, value)


                                                                            class Ipv4Dscp(Entity):
                                                                                """
                                                                                IPv4 DSCP
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                    self.yang_name = "ipv4-dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv4-dscp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Ipv6Dscp(Entity):
                                                                                """
                                                                                IPv6 DSCP
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                    self.yang_name = "ipv6-dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv6-dscp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Dscp(Entity):
                                                                                """
                                                                                Match DSCP range array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                    self.yang_name = "dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "dscp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Ipv4Prec(Entity):
                                                                                """
                                                                                IPv4 Precedence
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                    self.yang_name = "ipv4-prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "ipv4-prec"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                            class Ipv6Prec(Entity):
                                                                                """
                                                                                IPv6 Precedence
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                    self.yang_name = "ipv6-prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "ipv6-prec"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                            class Prec(Entity):
                                                                                """
                                                                                Match Precedence array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                    self.yang_name = "prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "prec"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                            class DiscardClass(Entity):
                                                                                """
                                                                                Match Discard Class array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                    self.yang_name = "discard-class"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "discard-class"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                            class QosGroup(Entity):
                                                                                """
                                                                                Match QoS group array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                    self.yang_name = "qos-group"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "qos-group"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "qos-group"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class TrafficClass(Entity):
                                                                                """
                                                                                Match Traffic class array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                    self.yang_name = "traffic-class"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "traffic-class"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "traffic-class"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Proto(Entity):
                                                                                """
                                                                                Match Protocol array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                    self.yang_name = "proto"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "proto"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "proto"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class IcmpV4(Entity):
                                                                                """
                                                                                Match ICMPV4 Protocol
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Protocol type
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: code
                                                                                
                                                                                	Protocol code
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                    self.yang_name = "icmp-v4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                    ])
                                                                                    self.type = None
                                                                                    self.code = None
                                                                                    self._segment_path = lambda: "icmp-v4"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['type', 'code'], name, value)


                                                                            class IcmpV6(Entity):
                                                                                """
                                                                                Match ICMPV6 Protocol array
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Protocol type
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: code
                                                                                
                                                                                	Protocol code
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                    self.yang_name = "icmp-v6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                    ])
                                                                                    self.type = None
                                                                                    self.code = None
                                                                                    self._segment_path = lambda: "icmp-v6"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['type', 'code'], name, value)


                                                                            class Ipv4PacketLen(Entity):
                                                                                """
                                                                                IPv4 packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv4-packet-len"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class Ipv6PacketLen(Entity):
                                                                                """
                                                                                IPv6 packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv6-packet-len"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class PacketLen(Entity):
                                                                                """
                                                                                Match packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                    self.yang_name = "packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "packet-len"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class FlowTag(Entity):
                                                                                """
                                                                                Match flow\-tag array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                    self.yang_name = "flow-tag"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "flow-tag"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "flow-tag"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class TcpFlag(Entity):
                                                                                """
                                                                                Match tcp flag value
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	Value of TCP flag
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: match_any
                                                                                
                                                                                	Match any TCP flag bit
                                                                                	**type**\: bool
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                    self.yang_name = "tcp-flag"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                        ('match_any', (YLeaf(YType.boolean, 'match-any'), ['bool'])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.match_any = None
                                                                                    self._segment_path = lambda: "tcp-flag"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['value', 'match_any'], name, value)


                                                                            class Icmpv4Type(Entity):
                                                                                """
                                                                                Match ipv4 icmp type
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                    self.yang_name = "icmpv4-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv4-type"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Icmpv4Code(Entity):
                                                                                """
                                                                                Match ipv4 icmp code
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                    self.yang_name = "icmpv4-code"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv4-code"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Icmpv6Type(Entity):
                                                                                """
                                                                                Match ipv6 icmp type
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                    self.yang_name = "icmpv6-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv6-type"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Icmpv6Code(Entity):
                                                                                """
                                                                                Match ipv6 icmp code
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                    self.yang_name = "icmpv6-code"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv6-code"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class MplsExp(Entity):
                                                                                """
                                                                                Match MPLS experimental topmost array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                    self.yang_name = "mpls-exp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "mpls-exp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                            class MplsExpImp(Entity):
                                                                                """
                                                                                Match MPLS experimental imposition array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "mpls-exp-imp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                            class MplsDispIpv4Acl(Entity):
                                                                                """
                                                                                MPLS Disposition IPv4 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                            class MplsDispIpv6Acl(Entity):
                                                                                """
                                                                                MPLS Disposition IPv6 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                            class MplsTopLabel(Entity):
                                                                                """
                                                                                MPLS Topmost LABEL
                                                                                
                                                                                .. attribute:: uint32_rng_array
                                                                                
                                                                                	uint32 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                    self.yang_name = "mpls-top-label"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint32_rng_array", ("uint32_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint32_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "mpls-top-label"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                class Uint32RngArray(Entity):
                                                                                    """
                                                                                    uint32 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                        self.yang_name = "uint32_rng_array"
                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint32, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint32, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint32_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['min', 'max'], name, value)


                                                                            class Cos(Entity):
                                                                                """
                                                                                Match CoS array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                    self.yang_name = "cos"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "cos"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                            class CosInr(Entity):
                                                                                """
                                                                                Match inner header CoS
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                    self.yang_name = "cos-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "cos-inr"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                            class Dei(Entity):
                                                                                """
                                                                                Match DEI Bit
                                                                                
                                                                                .. attribute:: bit_value
                                                                                
                                                                                	Value of the DEI bit
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                    self.yang_name = "dei"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                    ])
                                                                                    self.bit_value = None
                                                                                    self._segment_path = lambda: "dei"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                            class DeiInr(Entity):
                                                                                """
                                                                                Match inner DEI Bit
                                                                                
                                                                                .. attribute:: bit_value
                                                                                
                                                                                	Value of the DEI bit
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                    self.yang_name = "dei-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                    ])
                                                                                    self.bit_value = None
                                                                                    self._segment_path = lambda: "dei-inr"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                            class Vlan(Entity):
                                                                                """
                                                                                Match VLAN array
                                                                                
                                                                                .. attribute:: vlan_id_array
                                                                                
                                                                                	vlan id array
                                                                                	**type**\: list of  		 :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                    self.yang_name = "vlan"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("vlan-id-array", ("vlan_id_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.vlan_id_array = YList(self)
                                                                                    self._segment_path = lambda: "vlan"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                class VlanIdArray(Entity):
                                                                                    """
                                                                                    vlan id array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	VLAN mask
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                        self.yang_name = "vlan-id-array"
                                                                                        self.yang_parent_name = "vlan"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                            ('mask', (YLeaf(YType.uint16, 'mask'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self.mask = None
                                                                                        self._segment_path = lambda: "vlan-id-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['min', 'max', 'mask'], name, value)


                                                                            class VlanInr(Entity):
                                                                                """
                                                                                Match inner header VLAN range array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                    self.yang_name = "vlan-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "vlan-inr"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class FrDlci(Entity):
                                                                                """
                                                                                Match FR DLCI range array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                    self.yang_name = "fr-dlci"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "fr-dlci"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class SrcMac(Entity):
                                                                                """
                                                                                Match Source MAC address
                                                                                
                                                                                .. attribute:: mac_addr
                                                                                
                                                                                	MAC address
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	MAC mask
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                    self.yang_name = "src-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                    ])
                                                                                    self.mac_addr = []
                                                                                    self.mask = []
                                                                                    self._segment_path = lambda: "src-mac"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                            class DstMac(Entity):
                                                                                """
                                                                                Match Destination MAC address
                                                                                
                                                                                .. attribute:: mac_addr
                                                                                
                                                                                	MAC address
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	MAC mask
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                    self.yang_name = "dst-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                    ])
                                                                                    self.mac_addr = []
                                                                                    self.mask = []
                                                                                    self._segment_path = lambda: "dst-mac"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                            class AtmClp(Entity):
                                                                                """
                                                                                Match ATM CLP level
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                    self.yang_name = "atm-clp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "atm-clp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                            class FrDe(Entity):
                                                                                """
                                                                                Match FR DE value
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                    self.yang_name = "fr-de"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "fr-de"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                            class Ipv4Acl(Entity):
                                                                                """
                                                                                IPv4 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                    self.yang_name = "ipv4-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "ipv4-acl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                            class Ipv6Acl(Entity):
                                                                                """
                                                                                IPv6 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                    self.yang_name = "ipv6-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "ipv6-acl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                            class EtherServiceAcl(Entity):
                                                                                """
                                                                                Ethernet\-Services Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                    self.yang_name = "ether-service-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "ether-service-acl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                            class AvailId(Entity):
                                                                                """
                                                                                Available Identifiers
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                    self.yang_name = "avail-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "avail-id"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                            class MediaType(Entity):
                                                                                """
                                                                                Media Type
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                    self.yang_name = "media-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "media-type"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                            class SubsProtocol(Entity):
                                                                                """
                                                                                Protocol
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                    self.yang_name = "subs-protocol"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "subs-protocol"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                            class Dnis(Entity):
                                                                                """
                                                                                DNIS
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                    self.yang_name = "dnis"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "dnis"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                            class DnisRegex(Entity):
                                                                                """
                                                                                DNIS Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                    self.yang_name = "dnis-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "dnis-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                            class Domain(Entity):
                                                                                """
                                                                                Domain Name
                                                                                
                                                                                .. attribute:: domain_array
                                                                                
                                                                                	domain array
                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                    self.yang_name = "domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.domain_array = YList(self)
                                                                                    self._segment_path = lambda: "domain"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                class DomainArray(Entity):
                                                                                    """
                                                                                    domain array
                                                                                    
                                                                                    .. attribute:: domain_name
                                                                                    
                                                                                    	domain name
                                                                                    	**type**\: str
                                                                                    
                                                                                    .. attribute:: format_name
                                                                                    
                                                                                    	format name
                                                                                    	**type**\: str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                        self.yang_name = "domain-array"
                                                                                        self.yang_parent_name = "domain"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                        ])
                                                                                        self.domain_name = None
                                                                                        self.format_name = None
                                                                                        self._segment_path = lambda: "domain-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                            class DomainRegex(Entity):
                                                                                """
                                                                                Domain Regular Expression
                                                                                
                                                                                .. attribute:: domain_array
                                                                                
                                                                                	domain array
                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                    self.yang_name = "domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.domain_array = YList(self)
                                                                                    self._segment_path = lambda: "domain-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                class DomainArray(Entity):
                                                                                    """
                                                                                    domain array
                                                                                    
                                                                                    .. attribute:: domain_name
                                                                                    
                                                                                    	domain name
                                                                                    	**type**\: str
                                                                                    
                                                                                    .. attribute:: format_name
                                                                                    
                                                                                    	format name
                                                                                    	**type**\: str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                        self.yang_name = "domain-array"
                                                                                        self.yang_parent_name = "domain-regex"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                        ])
                                                                                        self.domain_name = None
                                                                                        self.format_name = None
                                                                                        self._segment_path = lambda: "domain-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                            class NasPort(Entity):
                                                                                """
                                                                                NAS Port
                                                                                
                                                                                .. attribute:: nas_port_array
                                                                                
                                                                                	nas port array
                                                                                	**type**\: list of  		 :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                    self.yang_name = "nas-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("nas-port-array", ("nas_port_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.nas_port_array = YList(self)
                                                                                    self._segment_path = lambda: "nas-port"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                class NasPortArray(Entity):
                                                                                    """
                                                                                    nas port array
                                                                                    
                                                                                    .. attribute:: sub_id
                                                                                    
                                                                                    	sub id
                                                                                    	**type**\:  :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                    
                                                                                    .. attribute:: operator
                                                                                    
                                                                                    	operator
                                                                                    	**type**\:  :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                        self.yang_name = "nas-port-array"
                                                                                        self.yang_parent_name = "nas-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('sub_id', (YLeaf(YType.enumeration, 'sub-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchNasPortSubIdEn', '')])),
                                                                                            ('operator', (YLeaf(YType.enumeration, 'operator'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchLogicalOperatorEn', '')])),
                                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ])
                                                                                        self.sub_id = None
                                                                                        self.operator = None
                                                                                        self.value = None
                                                                                        self._segment_path = lambda: "nas-port-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['sub_id', 'operator', 'value'], name, value)


                                                                            class ServiceName(Entity):
                                                                                """
                                                                                Service Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                    self.yang_name = "service-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "service-name"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                            class ServiceNameRegex(Entity):
                                                                                """
                                                                                Service Name Regular Exp
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                    self.yang_name = "service-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "service-name-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                            class SrcAddrIpv4(Entity):
                                                                                """
                                                                                Source Address IPV4
                                                                                
                                                                                .. attribute:: ipv4_addr_array
                                                                                
                                                                                	ipv4 addr array
                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.ipv4_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-ipv4"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                class Ipv4AddrArray(Entity):
                                                                                    """
                                                                                    ipv4 addr array
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	prefix
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	mask
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                        ])
                                                                                        self.prefix = None
                                                                                        self.mask = None
                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                            class DstAddrIpv4(Entity):
                                                                                """
                                                                                Destination Address IPV4
                                                                                
                                                                                .. attribute:: ipv4_addr_array
                                                                                
                                                                                	ipv4 addr array
                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.ipv4_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-addr-ipv4"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                class Ipv4AddrArray(Entity):
                                                                                    """
                                                                                    ipv4 addr array
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	prefix
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	mask
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                        ])
                                                                                        self.prefix = None
                                                                                        self.mask = None
                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                            class SrcAddrIpv6(Entity):
                                                                                """
                                                                                Source Address IPV6
                                                                                
                                                                                .. attribute:: ipv6_addr_array
                                                                                
                                                                                	ipv6 addr array
                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.ipv6_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-ipv6"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                class Ipv6AddrArray(Entity):
                                                                                    """
                                                                                    ipv6 addr array
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	IPV6 prefix
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	IPV6 mask
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                        ])
                                                                                        self.prefix = None
                                                                                        self.mask = None
                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                            class DstAddrIpv6(Entity):
                                                                                """
                                                                                Destination Address IPV6
                                                                                
                                                                                .. attribute:: ipv6_addr_array
                                                                                
                                                                                	ipv6 addr array
                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.ipv6_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-addr-ipv6"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                class Ipv6AddrArray(Entity):
                                                                                    """
                                                                                    ipv6 addr array
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	IPV6 prefix
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	IPV6 mask
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                        ])
                                                                                        self.prefix = None
                                                                                        self.mask = None
                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                            class SrcAddrMac(Entity):
                                                                                """
                                                                                Source Address MAC
                                                                                
                                                                                .. attribute:: mac_addr_array
                                                                                
                                                                                	mac addr array
                                                                                	**type**\: list of  		 :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                    self.yang_name = "src-addr-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("mac-addr-array", ("mac_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.mac_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-mac"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                class MacAddrArray(Entity):
                                                                                    """
                                                                                    mac addr array
                                                                                    
                                                                                    .. attribute:: mac_addr
                                                                                    
                                                                                    	MAC address
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	MAC mask
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                        self.yang_name = "mac-addr-array"
                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                            ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                        ])
                                                                                        self.mac_addr = []
                                                                                        self.mask = []
                                                                                        self._segment_path = lambda: "mac-addr-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                            class Timer(Entity):
                                                                                """
                                                                                Timer
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                    self.yang_name = "timer"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "timer"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                            class TimerRegexp(Entity):
                                                                                """
                                                                                Timer Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                    self.yang_name = "timer-regexp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "timer-regexp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                            class TunnelName(Entity):
                                                                                """
                                                                                Tunnel Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                    self.yang_name = "tunnel-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "tunnel-name"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                            class TunnelNameRegex(Entity):
                                                                                """
                                                                                Tunnel Name Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "tunnel-name-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                            class UserName(Entity):
                                                                                """
                                                                                User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                    self.yang_name = "user-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "user-name"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                            class UserNameRegex(Entity):
                                                                                """
                                                                                User Name Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                    self.yang_name = "user-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "user-name-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                            class AuthUsername(Entity):
                                                                                """
                                                                                Authenticated User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                    self.yang_name = "auth-username"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "auth-username"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                            class AuthUsernameRegex(Entity):
                                                                                """
                                                                                Authenticated User Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                    self.yang_name = "auth-username-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "auth-username-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                            class UnauthUsername(Entity):
                                                                                """
                                                                                Unauthenticated User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                    self.yang_name = "unauth-username"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "unauth-username"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                            class UnauthUsernameRegex(Entity):
                                                                                """
                                                                                Unauthenticated User Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                    self.yang_name = "unauth-username-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "unauth-username-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                            class AuthDomain(Entity):
                                                                                """
                                                                                Authenticated domain name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                    self.yang_name = "auth-domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "auth-domain"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                            class AuthDomainRegex(Entity):
                                                                                """
                                                                                Authenticated Domain Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                    self.yang_name = "auth-domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "auth-domain-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                            class UnauthDomain(Entity):
                                                                                """
                                                                                Unauthenticated Domain Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                    self.yang_name = "unauth-domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "unauth-domain"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                            class UnauthDomainRegex(Entity):
                                                                                """
                                                                                Unauthenticated Domain Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "unauth-domain-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                            class VendorId(Entity):
                                                                                """
                                                                                Vendor ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                    self.yang_name = "vendor-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "vendor-id"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                            class VendorIdRegex(Entity):
                                                                                """
                                                                                Vendor ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                    self.yang_name = "vendor-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "vendor-id-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                            class AccessInterface(Entity):
                                                                                """
                                                                                Access interface
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                    self.yang_name = "access-interface"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "access-interface"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                            class InputInterface(Entity):
                                                                                """
                                                                                Input interface
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                    self.yang_name = "input-interface"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "input-interface"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                            class InputIntfhdl(Entity):
                                                                                """
                                                                                Input interface handle
                                                                                
                                                                                .. attribute:: uint64_array
                                                                                
                                                                                	uint64 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..18446744073709551615
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                    self.yang_name = "input-intfhdl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint64_array', (YLeafList(YType.uint64, 'uint64_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint64_array = []
                                                                                    self._segment_path = lambda: "input-intfhdl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                            class Ethertype(Entity):
                                                                                """
                                                                                Ethernet type
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                    self.yang_name = "ethertype"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ethertype"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ethertype"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class FlowKeyData(Entity):
                                                                                """
                                                                                Flow key structure
                                                                                
                                                                                .. attribute:: flow_keys
                                                                                
                                                                                	flow keys
                                                                                	**type**\:  :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                
                                                                                .. attribute:: max_count
                                                                                
                                                                                	Maximum count of flows
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: idle_timeout
                                                                                
                                                                                	Idle timeout of flows (in seconds)
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                	**units**\: second
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                    self.yang_name = "flow-key-data"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("flow-keys", ("flow_keys", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('max_count', (YLeaf(YType.uint16, 'max-count'), ['int'])),
                                                                                        ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                                    ])
                                                                                    self.max_count = None
                                                                                    self.idle_timeout = None

                                                                                    self.flow_keys = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                    self.flow_keys.parent = self
                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                    self._segment_path = lambda: "flow-key-data"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['max_count', 'idle_timeout'], name, value)


                                                                                class FlowKeys(Entity):
                                                                                    """
                                                                                    flow keys
                                                                                    
                                                                                    .. attribute:: keys
                                                                                    
                                                                                    	keys
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                    
                                                                                    .. attribute:: num
                                                                                    
                                                                                    	num
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                        self.yang_name = "flow-keys"
                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('keys', (YLeaf(YType.str, 'keys'), ['str'])),
                                                                                            ('num', (YLeaf(YType.uint8, 'num'), ['int'])),
                                                                                        ])
                                                                                        self.keys = None
                                                                                        self.num = None
                                                                                        self._segment_path = lambda: "flow-keys"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                            class DhcpClientId(Entity):
                                                                                """
                                                                                Dhcp Client ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                    self.yang_name = "dhcp-client-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "dhcp-client-id"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                            class DhcpClientIdRegex(Entity):
                                                                                """
                                                                                Dhcp Client ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                            class CircuitId(Entity):
                                                                                """
                                                                                Circuit ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                    self.yang_name = "circuit-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "circuit-id"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                            class CircuitIdRegex(Entity):
                                                                                """
                                                                                Circuit ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                    self.yang_name = "circuit-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "circuit-id-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                            class RemoteId(Entity):
                                                                                """
                                                                                Remote ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                    self.yang_name = "remote-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "remote-id"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                            class RemoteIdRegex(Entity):
                                                                                """
                                                                                Remote ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                    self.yang_name = "remote-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "remote-id-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                            class SrcPort(Entity):
                                                                                """
                                                                                Source port
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                    self.yang_name = "src-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "src-port"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "src-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class DstPort(Entity):
                                                                                """
                                                                                Destination port
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                    self.yang_name = "dst-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-port"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "dst-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['min', 'max'], name, value)


                                                        class ActInfop(Entity):
                                                            """
                                                            act infop
                                                            
                                                            .. attribute:: policy_action_info_st
                                                            
                                                            	policy action info st
                                                            	**type**\: list of  		 :py:class:`PolicyActionInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'infra-policymgr-oper'
                                                            _revision = '2018-01-17'

                                                            def __init__(self):
                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop, self).__init__()

                                                                self.yang_name = "act-infop"
                                                                self.yang_parent_name = "policy-class-info-bg"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("policy-action-info-st", ("policy_action_info_st", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt))])
                                                                self._leafs = OrderedDict()

                                                                self.policy_action_info_st = YList(self)
                                                                self._segment_path = lambda: "act-infop"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop, [], name, value)


                                                            class PolicyActionInfoSt(Entity):
                                                                """
                                                                policy action info st
                                                                
                                                                .. attribute:: actp
                                                                
                                                                	actp
                                                                	**type**\:  :py:class:`Actp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp>`
                                                                
                                                                .. attribute:: seq
                                                                
                                                                	seq
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..65535
                                                                
                                                                .. attribute:: flags
                                                                
                                                                	flags
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..65535
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt, self).__init__()

                                                                    self.yang_name = "policy-action-info-st"
                                                                    self.yang_parent_name = "act-infop"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("actp", ("actp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp))])
                                                                    self._leafs = OrderedDict([
                                                                        ('seq', (YLeaf(YType.uint16, 'seq'), ['int'])),
                                                                        ('flags', (YLeaf(YType.uint16, 'flags'), ['int'])),
                                                                    ])
                                                                    self.seq = None
                                                                    self.flags = None

                                                                    self.actp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp()
                                                                    self.actp.parent = self
                                                                    self._children_name_map["actp"] = "actp"
                                                                    self._segment_path = lambda: "policy-action-info-st"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt, ['seq', 'flags'], name, value)


                                                                class Actp(Entity):
                                                                    """
                                                                    actp
                                                                    
                                                                    .. attribute:: mark
                                                                    
                                                                    	mark
                                                                    	**type**\:  :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark>`
                                                                    
                                                                    .. attribute:: mark2
                                                                    
                                                                    	mark2
                                                                    	**type**\:  :py:class:`Mark2 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2>`
                                                                    
                                                                    .. attribute:: wred
                                                                    
                                                                    	wred
                                                                    	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred>`
                                                                    
                                                                    .. attribute:: encap
                                                                    
                                                                    	encap
                                                                    	**type**\:  :py:class:`Encap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap>`
                                                                    
                                                                    .. attribute:: prio
                                                                    
                                                                    	prio
                                                                    	**type**\:  :py:class:`Prio <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio>`
                                                                    
                                                                    .. attribute:: bwrem
                                                                    
                                                                    	bwrem
                                                                    	**type**\:  :py:class:`Bwrem <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem>`
                                                                    
                                                                    .. attribute:: min_bw
                                                                    
                                                                    	min bw
                                                                    	**type**\:  :py:class:`MinBw <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw>`
                                                                    
                                                                    .. attribute:: authen_aaa
                                                                    
                                                                    	authen aaa
                                                                    	**type**\:  :py:class:`AuthenAaa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa>`
                                                                    
                                                                    .. attribute:: collect_id
                                                                    
                                                                    	collect id
                                                                    	**type**\:  :py:class:`CollectId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId>`
                                                                    
                                                                    .. attribute:: decode_id
                                                                    
                                                                    	decode id
                                                                    	**type**\:  :py:class:`DecodeId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId>`
                                                                    
                                                                    .. attribute:: set_timer
                                                                    
                                                                    	set timer
                                                                    	**type**\:  :py:class:`SetTimer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer>`
                                                                    
                                                                    .. attribute:: stop_timer
                                                                    
                                                                    	stop timer
                                                                    	**type**\:  :py:class:`StopTimer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer>`
                                                                    
                                                                    .. attribute:: acct_aaa_list
                                                                    
                                                                    	acct aaa list
                                                                    	**type**\:  :py:class:`AcctAaaList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList>`
                                                                    
                                                                    .. attribute:: query_ancp
                                                                    
                                                                    	query ancp
                                                                    	**type**\:  :py:class:`QueryAncp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp>`
                                                                    
                                                                    .. attribute:: prepaid_cfg
                                                                    
                                                                    	prepaid cfg
                                                                    	**type**\:  :py:class:`PrepaidCfg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg>`
                                                                    
                                                                    .. attribute:: timeout_idle
                                                                    
                                                                    	timeout idle
                                                                    	**type**\:  :py:class:`TimeoutIdle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle>`
                                                                    
                                                                    .. attribute:: proxy_aaa
                                                                    
                                                                    	proxy aaa
                                                                    	**type**\:  :py:class:`ProxyAaa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa>`
                                                                    
                                                                    .. attribute:: act_template
                                                                    
                                                                    	act template
                                                                    	**type**\:  :py:class:`ActTemplate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate>`
                                                                    
                                                                    .. attribute:: deact_template
                                                                    
                                                                    	deact template
                                                                    	**type**\:  :py:class:`DeactTemplate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate>`
                                                                    
                                                                    .. attribute:: qlimit
                                                                    
                                                                    	qlimit
                                                                    	**type**\:  :py:class:`Qlimit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit>`
                                                                    
                                                                    .. attribute:: accounting_event_aaa
                                                                    
                                                                    	accounting event aaa
                                                                    	**type**\:  :py:class:`AccountingEventAaa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa>`
                                                                    
                                                                    .. attribute:: authorize_id
                                                                    
                                                                    	authorize id
                                                                    	**type**\:  :py:class:`AuthorizeId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId>`
                                                                    
                                                                    .. attribute:: afm_react
                                                                    
                                                                    	afm react
                                                                    	**type**\:  :py:class:`AfmReact <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact>`
                                                                    
                                                                    .. attribute:: httpr
                                                                    
                                                                    	httpr
                                                                    	**type**\:  :py:class:`Httpr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr>`
                                                                    
                                                                    .. attribute:: punt
                                                                    
                                                                    	punt
                                                                    	**type**\:  :py:class:`Punt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt>`
                                                                    
                                                                    .. attribute:: copy
                                                                    
                                                                    	copy
                                                                    	**type**\:  :py:class:`Copy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy>`
                                                                    
                                                                    .. attribute:: sfrag
                                                                    
                                                                    	sfrag
                                                                    	**type**\:  :py:class:`Sfrag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag>`
                                                                    
                                                                    .. attribute:: redirect
                                                                    
                                                                    	redirect
                                                                    	**type**\:  :py:class:`Redirect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect>`
                                                                    
                                                                    .. attribute:: out_intf
                                                                    
                                                                    	out intf
                                                                    	**type**\:  :py:class:`OutIntf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf>`
                                                                    
                                                                    .. attribute:: serv_func
                                                                    
                                                                    	serv func
                                                                    	**type**\:  :py:class:`ServFunc <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc>`
                                                                    
                                                                    .. attribute:: police
                                                                    
                                                                    	police
                                                                    	**type**\:  :py:class:`Police <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police>`
                                                                    
                                                                    .. attribute:: shape
                                                                    
                                                                    	shape
                                                                    	**type**\:  :py:class:`Shape <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape>`
                                                                    
                                                                    .. attribute:: child_policy
                                                                    
                                                                    	child policy
                                                                    	**type**\:  :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy>`
                                                                    
                                                                    .. attribute:: cac
                                                                    
                                                                    	cac
                                                                    	**type**\:  :py:class:`Cac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac>`
                                                                    
                                                                    .. attribute:: pfc
                                                                    
                                                                    	pfc
                                                                    	**type**\:  :py:class:`Pfc <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc>`
                                                                    
                                                                    .. attribute:: flow_parm
                                                                    
                                                                    	flow parm
                                                                    	**type**\:  :py:class:`FlowParm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm>`
                                                                    
                                                                    .. attribute:: ipcbr
                                                                    
                                                                    	ipcbr
                                                                    	**type**\:  :py:class:`Ipcbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr>`
                                                                    
                                                                    .. attribute:: rtp
                                                                    
                                                                    	rtp
                                                                    	**type**\:  :py:class:`Rtp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp>`
                                                                    
                                                                    .. attribute:: rtp_mmr
                                                                    
                                                                    	rtp mmr
                                                                    	**type**\:  :py:class:`RtpMmr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr>`
                                                                    
                                                                    .. attribute:: rtp_j2k
                                                                    
                                                                    	rtp j2k
                                                                    	**type**\:  :py:class:`RtpJ2k <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k>`
                                                                    
                                                                    .. attribute:: rtp_voice
                                                                    
                                                                    	rtp voice
                                                                    	**type**\:  :py:class:`RtpVoice <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice>`
                                                                    
                                                                    .. attribute:: mdi
                                                                    
                                                                    	mdi
                                                                    	**type**\:  :py:class:`Mdi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi>`
                                                                    
                                                                    .. attribute:: mdi_rtp
                                                                    
                                                                    	mdi rtp
                                                                    	**type**\:  :py:class:`MdiRtp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp>`
                                                                    
                                                                    .. attribute:: fmm
                                                                    
                                                                    	fmm
                                                                    	**type**\:  :py:class:`Fmm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm>`
                                                                    
                                                                    .. attribute:: pbf
                                                                    
                                                                    	pbf
                                                                    	**type**\:  :py:class:`Pbf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf>`
                                                                    
                                                                    .. attribute:: ipv4_nh
                                                                    
                                                                    	ipv4 nh
                                                                    	**type**\:  :py:class:`Ipv4Nh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh>`
                                                                    
                                                                    .. attribute:: ipv6_nh
                                                                    
                                                                    	ipv6 nh
                                                                    	**type**\:  :py:class:`Ipv6Nh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh>`
                                                                    
                                                                    .. attribute:: type
                                                                    
                                                                    	type
                                                                    	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                    
                                                                    .. attribute:: data_p
                                                                    
                                                                    	data p
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp, self).__init__()

                                                                        self.yang_name = "actp"
                                                                        self.yang_parent_name = "policy-action-info-st"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("mark", ("mark", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark)), ("mark2", ("mark2", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2)), ("wred", ("wred", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred)), ("encap", ("encap", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap)), ("prio", ("prio", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio)), ("bwrem", ("bwrem", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem)), ("min-bw", ("min_bw", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw)), ("authen-aaa", ("authen_aaa", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa)), ("collect-id", ("collect_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId)), ("decode-id", ("decode_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId)), ("set-timer", ("set_timer", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer)), ("stop-timer", ("stop_timer", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer)), ("acct-aaa-list", ("acct_aaa_list", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList)), ("query-ancp", ("query_ancp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp)), ("prepaid-cfg", ("prepaid_cfg", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg)), ("timeout-idle", ("timeout_idle", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle)), ("proxy-aaa", ("proxy_aaa", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa)), ("act-template", ("act_template", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate)), ("deact-template", ("deact_template", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate)), ("qlimit", ("qlimit", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit)), ("accounting-event-aaa", ("accounting_event_aaa", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa)), ("authorize-id", ("authorize_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId)), ("afm-react", ("afm_react", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact)), ("httpr", ("httpr", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr)), ("punt", ("punt", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt)), ("copy", ("copy", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy)), ("sfrag", ("sfrag", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag)), ("redirect", ("redirect", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect)), ("out-intf", ("out_intf", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf)), ("serv-func", ("serv_func", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc)), ("police", ("police", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police)), ("shape", ("shape", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape)), ("child-policy", ("child_policy", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy)), ("cac", ("cac", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac)), ("pfc", ("pfc", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc)), ("flow-parm", ("flow_parm", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm)), ("ipcbr", ("ipcbr", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr)), ("rtp", ("rtp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp)), ("rtp-mmr", ("rtp_mmr", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr)), ("rtp-j2k", ("rtp_j2k", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k)), ("rtp-voice", ("rtp_voice", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice)), ("mdi", ("mdi", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi)), ("mdi-rtp", ("mdi_rtp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp)), ("fmm", ("fmm", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm)), ("pbf", ("pbf", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf)), ("ipv4-nh", ("ipv4_nh", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh)), ("ipv6-nh", ("ipv6_nh", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh))])
                                                                        self._leafs = OrderedDict([
                                                                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                            ('data_p', (YLeaf(YType.uint32, 'data-p'), ['int'])),
                                                                        ])
                                                                        self.type = None
                                                                        self.data_p = None

                                                                        self.mark = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark()
                                                                        self.mark.parent = self
                                                                        self._children_name_map["mark"] = "mark"

                                                                        self.mark2 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2()
                                                                        self.mark2.parent = self
                                                                        self._children_name_map["mark2"] = "mark2"

                                                                        self.wred = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred()
                                                                        self.wred.parent = self
                                                                        self._children_name_map["wred"] = "wred"

                                                                        self.encap = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap()
                                                                        self.encap.parent = self
                                                                        self._children_name_map["encap"] = "encap"

                                                                        self.prio = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio()
                                                                        self.prio.parent = self
                                                                        self._children_name_map["prio"] = "prio"

                                                                        self.bwrem = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem()
                                                                        self.bwrem.parent = self
                                                                        self._children_name_map["bwrem"] = "bwrem"

                                                                        self.min_bw = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw()
                                                                        self.min_bw.parent = self
                                                                        self._children_name_map["min_bw"] = "min-bw"

                                                                        self.authen_aaa = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa()
                                                                        self.authen_aaa.parent = self
                                                                        self._children_name_map["authen_aaa"] = "authen-aaa"

                                                                        self.collect_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId()
                                                                        self.collect_id.parent = self
                                                                        self._children_name_map["collect_id"] = "collect-id"

                                                                        self.decode_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId()
                                                                        self.decode_id.parent = self
                                                                        self._children_name_map["decode_id"] = "decode-id"

                                                                        self.set_timer = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer()
                                                                        self.set_timer.parent = self
                                                                        self._children_name_map["set_timer"] = "set-timer"

                                                                        self.stop_timer = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer()
                                                                        self.stop_timer.parent = self
                                                                        self._children_name_map["stop_timer"] = "stop-timer"

                                                                        self.acct_aaa_list = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList()
                                                                        self.acct_aaa_list.parent = self
                                                                        self._children_name_map["acct_aaa_list"] = "acct-aaa-list"

                                                                        self.query_ancp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp()
                                                                        self.query_ancp.parent = self
                                                                        self._children_name_map["query_ancp"] = "query-ancp"

                                                                        self.prepaid_cfg = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg()
                                                                        self.prepaid_cfg.parent = self
                                                                        self._children_name_map["prepaid_cfg"] = "prepaid-cfg"

                                                                        self.timeout_idle = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle()
                                                                        self.timeout_idle.parent = self
                                                                        self._children_name_map["timeout_idle"] = "timeout-idle"

                                                                        self.proxy_aaa = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa()
                                                                        self.proxy_aaa.parent = self
                                                                        self._children_name_map["proxy_aaa"] = "proxy-aaa"

                                                                        self.act_template = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate()
                                                                        self.act_template.parent = self
                                                                        self._children_name_map["act_template"] = "act-template"

                                                                        self.deact_template = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate()
                                                                        self.deact_template.parent = self
                                                                        self._children_name_map["deact_template"] = "deact-template"

                                                                        self.qlimit = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit()
                                                                        self.qlimit.parent = self
                                                                        self._children_name_map["qlimit"] = "qlimit"

                                                                        self.accounting_event_aaa = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa()
                                                                        self.accounting_event_aaa.parent = self
                                                                        self._children_name_map["accounting_event_aaa"] = "accounting-event-aaa"

                                                                        self.authorize_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId()
                                                                        self.authorize_id.parent = self
                                                                        self._children_name_map["authorize_id"] = "authorize-id"

                                                                        self.afm_react = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact()
                                                                        self.afm_react.parent = self
                                                                        self._children_name_map["afm_react"] = "afm-react"

                                                                        self.httpr = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr()
                                                                        self.httpr.parent = self
                                                                        self._children_name_map["httpr"] = "httpr"

                                                                        self.punt = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt()
                                                                        self.punt.parent = self
                                                                        self._children_name_map["punt"] = "punt"

                                                                        self.copy = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy()
                                                                        self.copy.parent = self
                                                                        self._children_name_map["copy"] = "copy"

                                                                        self.sfrag = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag()
                                                                        self.sfrag.parent = self
                                                                        self._children_name_map["sfrag"] = "sfrag"

                                                                        self.redirect = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect()
                                                                        self.redirect.parent = self
                                                                        self._children_name_map["redirect"] = "redirect"

                                                                        self.out_intf = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf()
                                                                        self.out_intf.parent = self
                                                                        self._children_name_map["out_intf"] = "out-intf"

                                                                        self.serv_func = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc()
                                                                        self.serv_func.parent = self
                                                                        self._children_name_map["serv_func"] = "serv-func"

                                                                        self.police = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police()
                                                                        self.police.parent = self
                                                                        self._children_name_map["police"] = "police"

                                                                        self.shape = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape()
                                                                        self.shape.parent = self
                                                                        self._children_name_map["shape"] = "shape"

                                                                        self.child_policy = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy()
                                                                        self.child_policy.parent = self
                                                                        self._children_name_map["child_policy"] = "child-policy"

                                                                        self.cac = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac()
                                                                        self.cac.parent = self
                                                                        self._children_name_map["cac"] = "cac"

                                                                        self.pfc = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc()
                                                                        self.pfc.parent = self
                                                                        self._children_name_map["pfc"] = "pfc"

                                                                        self.flow_parm = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm()
                                                                        self.flow_parm.parent = self
                                                                        self._children_name_map["flow_parm"] = "flow-parm"

                                                                        self.ipcbr = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr()
                                                                        self.ipcbr.parent = self
                                                                        self._children_name_map["ipcbr"] = "ipcbr"

                                                                        self.rtp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp()
                                                                        self.rtp.parent = self
                                                                        self._children_name_map["rtp"] = "rtp"

                                                                        self.rtp_mmr = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr()
                                                                        self.rtp_mmr.parent = self
                                                                        self._children_name_map["rtp_mmr"] = "rtp-mmr"

                                                                        self.rtp_j2k = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k()
                                                                        self.rtp_j2k.parent = self
                                                                        self._children_name_map["rtp_j2k"] = "rtp-j2k"

                                                                        self.rtp_voice = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice()
                                                                        self.rtp_voice.parent = self
                                                                        self._children_name_map["rtp_voice"] = "rtp-voice"

                                                                        self.mdi = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi()
                                                                        self.mdi.parent = self
                                                                        self._children_name_map["mdi"] = "mdi"

                                                                        self.mdi_rtp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp()
                                                                        self.mdi_rtp.parent = self
                                                                        self._children_name_map["mdi_rtp"] = "mdi-rtp"

                                                                        self.fmm = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm()
                                                                        self.fmm.parent = self
                                                                        self._children_name_map["fmm"] = "fmm"

                                                                        self.pbf = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf()
                                                                        self.pbf.parent = self
                                                                        self._children_name_map["pbf"] = "pbf"

                                                                        self.ipv4_nh = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh()
                                                                        self.ipv4_nh.parent = self
                                                                        self._children_name_map["ipv4_nh"] = "ipv4-nh"

                                                                        self.ipv6_nh = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh()
                                                                        self.ipv6_nh.parent = self
                                                                        self._children_name_map["ipv6_nh"] = "ipv6-nh"
                                                                        self._segment_path = lambda: "actp"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp, ['type', 'data_p'], name, value)


                                                                    class Mark(Entity):
                                                                        """
                                                                        mark
                                                                        
                                                                        .. attribute:: action_mark_info
                                                                        
                                                                        	action mark info
                                                                        	**type**\: list of  		 :py:class:`ActionMarkInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark, self).__init__()

                                                                            self.yang_name = "mark"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("action-mark-info", ("action_mark_info", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo))])
                                                                            self._leafs = OrderedDict()

                                                                            self.action_mark_info = YList(self)
                                                                            self._segment_path = lambda: "mark"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark, [], name, value)


                                                                        class ActionMarkInfo(Entity):
                                                                            """
                                                                            action mark info
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:  :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                            
                                                                            .. attribute:: mark_flags
                                                                            
                                                                            	mark flags
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo, self).__init__()

                                                                                self.yang_name = "action-mark-info"
                                                                                self.yang_parent_name = "mark"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MarkTypeEn', '')])),
                                                                                    ('mark_flags', (YLeaf(YType.uint32, 'mark-flags'), ['int'])),
                                                                                    ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                ])
                                                                                self.type = None
                                                                                self.mark_flags = None
                                                                                self.value = None
                                                                                self._segment_path = lambda: "action-mark-info"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo, ['type', 'mark_flags', 'value'], name, value)


                                                                    class Mark2(Entity):
                                                                        """
                                                                        mark2
                                                                        
                                                                        .. attribute:: action_mark2_info
                                                                        
                                                                        	action mark2 info
                                                                        	**type**\: list of  		 :py:class:`ActionMark2Info <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2, self).__init__()

                                                                            self.yang_name = "mark2"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("action-mark2-info", ("action_mark2_info", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info))])
                                                                            self._leafs = OrderedDict()

                                                                            self.action_mark2_info = YList(self)
                                                                            self._segment_path = lambda: "mark2"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2, [], name, value)


                                                                        class ActionMark2Info(Entity):
                                                                            """
                                                                            action mark2 info
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: value_overflow
                                                                            
                                                                            	value overflow
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: mark_flags
                                                                            
                                                                            	mark flags
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info, self).__init__()

                                                                                self.yang_name = "action-mark2-info"
                                                                                self.yang_parent_name = "mark2"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('value_overflow', (YLeaf(YType.uint16, 'value-overflow'), ['int'])),
                                                                                    ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                    ('mark_flags', (YLeaf(YType.uint8, 'mark-flags'), ['int'])),
                                                                                ])
                                                                                self.value = None
                                                                                self.value_overflow = None
                                                                                self.type = None
                                                                                self.mark_flags = None
                                                                                self._segment_path = lambda: "action-mark2-info"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info, ['value', 'value_overflow', 'type', 'mark_flags'], name, value)


                                                                    class Wred(Entity):
                                                                        """
                                                                        wred
                                                                        
                                                                        .. attribute:: action_wred_info
                                                                        
                                                                        	action wred info
                                                                        	**type**\: list of  		 :py:class:`ActionWredInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred, self).__init__()

                                                                            self.yang_name = "wred"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("action-wred-info", ("action_wred_info", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo))])
                                                                            self._leafs = OrderedDict()

                                                                            self.action_wred_info = YList(self)
                                                                            self._segment_path = lambda: "wred"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred, [], name, value)


                                                                        class ActionWredInfo(Entity):
                                                                            """
                                                                            action wred info
                                                                            
                                                                            .. attribute:: match_ranges
                                                                            
                                                                            	match ranges
                                                                            	**type**\:  :py:class:`MatchRanges <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges>`
                                                                            
                                                                            .. attribute:: min_threshold
                                                                            
                                                                            	min threshold
                                                                            	**type**\:  :py:class:`MinThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold>`
                                                                            
                                                                            .. attribute:: max_threshold
                                                                            
                                                                            	max threshold
                                                                            	**type**\:  :py:class:`MaxThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold>`
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	cos/prec/dscp/ based WRED
                                                                            	**type**\:  :py:class:`WredTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.WredTypeEn>`
                                                                            
                                                                            .. attribute:: wred_flags
                                                                            
                                                                            	wred flags
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: probability
                                                                            
                                                                            	probability
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo, self).__init__()

                                                                                self.yang_name = "action-wred-info"
                                                                                self.yang_parent_name = "wred"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("match-ranges", ("match_ranges", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges)), ("min-threshold", ("min_threshold", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold)), ("max-threshold", ("max_threshold", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'WredTypeEn', '')])),
                                                                                    ('wred_flags', (YLeaf(YType.uint32, 'wred-flags'), ['int'])),
                                                                                    ('probability', (YLeaf(YType.uint32, 'probability'), ['int'])),
                                                                                ])
                                                                                self.type = None
                                                                                self.wred_flags = None
                                                                                self.probability = None

                                                                                self.match_ranges = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges()
                                                                                self.match_ranges.parent = self
                                                                                self._children_name_map["match_ranges"] = "match-ranges"

                                                                                self.min_threshold = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold()
                                                                                self.min_threshold.parent = self
                                                                                self._children_name_map["min_threshold"] = "min-threshold"

                                                                                self.max_threshold = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold()
                                                                                self.max_threshold.parent = self
                                                                                self._children_name_map["max_threshold"] = "max-threshold"
                                                                                self._segment_path = lambda: "action-wred-info"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo, ['type', 'wred_flags', 'probability'], name, value)


                                                                            class MatchRanges(Entity):
                                                                                """
                                                                                match ranges
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges, self).__init__()

                                                                                    self.yang_name = "match-ranges"
                                                                                    self.yang_parent_name = "action-wred-info"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "match-ranges"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "match-ranges"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class MinThreshold(Entity):
                                                                                """
                                                                                min threshold
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold, self).__init__()

                                                                                    self.yang_name = "min-threshold"
                                                                                    self.yang_parent_name = "action-wred-info"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.unit = None
                                                                                    self._segment_path = lambda: "min-threshold"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold, ['value', 'unit'], name, value)


                                                                            class MaxThreshold(Entity):
                                                                                """
                                                                                max threshold
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold, self).__init__()

                                                                                    self.yang_name = "max-threshold"
                                                                                    self.yang_parent_name = "action-wred-info"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.unit = None
                                                                                    self._segment_path = lambda: "max-threshold"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold, ['value', 'unit'], name, value)


                                                                    class Encap(Entity):
                                                                        """
                                                                        encap
                                                                        
                                                                        .. attribute:: seq
                                                                        
                                                                        	seq
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap, self).__init__()

                                                                            self.yang_name = "encap"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('seq', (YLeaf(YType.uint8, 'seq'), ['int'])),
                                                                            ])
                                                                            self.seq = None
                                                                            self._segment_path = lambda: "encap"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap, ['seq'], name, value)


                                                                    class Prio(Entity):
                                                                        """
                                                                        prio
                                                                        
                                                                        .. attribute:: prio_lvl
                                                                        
                                                                        	prio lvl
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio, self).__init__()

                                                                            self.yang_name = "prio"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('prio_lvl', (YLeaf(YType.uint32, 'prio-lvl'), ['int'])),
                                                                            ])
                                                                            self.prio_lvl = None
                                                                            self._segment_path = lambda: "prio"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio, ['prio_lvl'], name, value)


                                                                    class Bwrem(Entity):
                                                                        """
                                                                        bwrem
                                                                        
                                                                        .. attribute:: bwrem
                                                                        
                                                                        	bwrem
                                                                        	**type**\:  :py:class:`Bwrem_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem_>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem, self).__init__()

                                                                            self.yang_name = "bwrem"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("bwrem", ("bwrem", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem_))])
                                                                            self._leafs = OrderedDict()

                                                                            self.bwrem = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem_()
                                                                            self.bwrem.parent = self
                                                                            self._children_name_map["bwrem"] = "bwrem"
                                                                            self._segment_path = lambda: "bwrem"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem, [], name, value)


                                                                        class Bwrem_(Entity):
                                                                            """
                                                                            bwrem
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem_, self).__init__()

                                                                                self.yang_name = "bwrem"
                                                                                self.yang_parent_name = "bwrem"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "bwrem"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem_, ['value', 'unit'], name, value)


                                                                    class MinBw(Entity):
                                                                        """
                                                                        min bw
                                                                        
                                                                        .. attribute:: bw
                                                                        
                                                                        	bw
                                                                        	**type**\:  :py:class:`Bw <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw, self).__init__()

                                                                            self.yang_name = "min-bw"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("bw", ("bw", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw))])
                                                                            self._leafs = OrderedDict()

                                                                            self.bw = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw()
                                                                            self.bw.parent = self
                                                                            self._children_name_map["bw"] = "bw"
                                                                            self._segment_path = lambda: "min-bw"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw, [], name, value)


                                                                        class Bw(Entity):
                                                                            """
                                                                            bw
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw, self).__init__()

                                                                                self.yang_name = "bw"
                                                                                self.yang_parent_name = "min-bw"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "bw"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw, ['value', 'unit'], name, value)


                                                                    class AuthenAaa(Entity):
                                                                        """
                                                                        authen aaa
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: authen_password
                                                                        
                                                                        	authen password
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa, self).__init__()

                                                                            self.yang_name = "authen-aaa"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                                ('authen_password', (YLeaf(YType.str, 'authen-password'), ['str'])),
                                                                            ])
                                                                            self.aaa_list_name = None
                                                                            self.authen_password = None
                                                                            self._segment_path = lambda: "authen-aaa"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa, ['aaa_list_name', 'authen_password'], name, value)


                                                                    class CollectId(Entity):
                                                                        """
                                                                        collect id
                                                                        
                                                                        .. attribute:: id
                                                                        
                                                                        	id
                                                                        	**type**\:  :py:class:`IdentifierEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.IdentifierEn>`
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId, self).__init__()

                                                                            self.yang_name = "collect-id"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('id', (YLeaf(YType.enumeration, 'id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'IdentifierEn', '')])),
                                                                                ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                            ])
                                                                            self.id = None
                                                                            self.aaa_list_name = None
                                                                            self._segment_path = lambda: "collect-id"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId, ['id', 'aaa_list_name'], name, value)


                                                                    class DecodeId(Entity):
                                                                        """
                                                                        decode id
                                                                        
                                                                        .. attribute:: id
                                                                        
                                                                        	id
                                                                        	**type**\:  :py:class:`DecodeIdentifierEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.DecodeIdentifierEn>`
                                                                        
                                                                        .. attribute:: format_name
                                                                        
                                                                        	format name
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId, self).__init__()

                                                                            self.yang_name = "decode-id"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('id', (YLeaf(YType.enumeration, 'id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'DecodeIdentifierEn', '')])),
                                                                                ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                            ])
                                                                            self.id = None
                                                                            self.format_name = None
                                                                            self._segment_path = lambda: "decode-id"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId, ['id', 'format_name'], name, value)


                                                                    class SetTimer(Entity):
                                                                        """
                                                                        set timer
                                                                        
                                                                        .. attribute:: timer_name
                                                                        
                                                                        	timer name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: duration
                                                                        
                                                                        	duration
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: absolute_time
                                                                        
                                                                        	absolute time
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer, self).__init__()

                                                                            self.yang_name = "set-timer"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('timer_name', (YLeaf(YType.str, 'timer-name'), ['str'])),
                                                                                ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                                                ('absolute_time', (YLeaf(YType.str, 'absolute-time'), ['str'])),
                                                                            ])
                                                                            self.timer_name = None
                                                                            self.duration = None
                                                                            self.absolute_time = None
                                                                            self._segment_path = lambda: "set-timer"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer, ['timer_name', 'duration', 'absolute_time'], name, value)


                                                                    class StopTimer(Entity):
                                                                        """
                                                                        stop timer
                                                                        
                                                                        .. attribute:: timer_name
                                                                        
                                                                        	timer name
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer, self).__init__()

                                                                            self.yang_name = "stop-timer"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('timer_name', (YLeaf(YType.str, 'timer-name'), ['str'])),
                                                                            ])
                                                                            self.timer_name = None
                                                                            self._segment_path = lambda: "stop-timer"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer, ['timer_name'], name, value)


                                                                    class AcctAaaList(Entity):
                                                                        """
                                                                        acct aaa list
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: secs
                                                                        
                                                                        	secs
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList, self).__init__()

                                                                            self.yang_name = "acct-aaa-list"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                                ('secs', (YLeaf(YType.uint32, 'secs'), ['int'])),
                                                                            ])
                                                                            self.aaa_list_name = None
                                                                            self.secs = None
                                                                            self._segment_path = lambda: "acct-aaa-list"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList, ['aaa_list_name', 'secs'], name, value)


                                                                    class QueryAncp(Entity):
                                                                        """
                                                                        query ancp
                                                                        
                                                                        .. attribute:: enable
                                                                        
                                                                        	enable
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp, self).__init__()

                                                                            self.yang_name = "query-ancp"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('enable', (YLeaf(YType.uint8, 'enable'), ['int'])),
                                                                            ])
                                                                            self.enable = None
                                                                            self._segment_path = lambda: "query-ancp"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp, ['enable'], name, value)


                                                                    class PrepaidCfg(Entity):
                                                                        """
                                                                        prepaid cfg
                                                                        
                                                                        .. attribute:: prepaid_config_profile_name
                                                                        
                                                                        	prepaid config profile name
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg, self).__init__()

                                                                            self.yang_name = "prepaid-cfg"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('prepaid_config_profile_name', (YLeaf(YType.str, 'prepaid-config-profile-name'), ['str'])),
                                                                            ])
                                                                            self.prepaid_config_profile_name = None
                                                                            self._segment_path = lambda: "prepaid-cfg"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg, ['prepaid_config_profile_name'], name, value)


                                                                    class TimeoutIdle(Entity):
                                                                        """
                                                                        timeout idle
                                                                        
                                                                        .. attribute:: secs
                                                                        
                                                                        	secs
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle, self).__init__()

                                                                            self.yang_name = "timeout-idle"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('secs', (YLeaf(YType.uint32, 'secs'), ['int'])),
                                                                            ])
                                                                            self.secs = None
                                                                            self._segment_path = lambda: "timeout-idle"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle, ['secs'], name, value)


                                                                    class ProxyAaa(Entity):
                                                                        """
                                                                        proxy aaa
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa, self).__init__()

                                                                            self.yang_name = "proxy-aaa"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                            ])
                                                                            self.aaa_list_name = None
                                                                            self._segment_path = lambda: "proxy-aaa"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa, ['aaa_list_name'], name, value)


                                                                    class ActTemplate(Entity):
                                                                        """
                                                                        act template
                                                                        
                                                                        .. attribute:: template_name
                                                                        
                                                                        	template name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: flags
                                                                        
                                                                        	flags
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate, self).__init__()

                                                                            self.yang_name = "act-template"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('template_name', (YLeaf(YType.str, 'template-name'), ['str'])),
                                                                                ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                                ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                            ])
                                                                            self.template_name = None
                                                                            self.aaa_list_name = None
                                                                            self.flags = None
                                                                            self._segment_path = lambda: "act-template"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate, ['template_name', 'aaa_list_name', 'flags'], name, value)


                                                                    class DeactTemplate(Entity):
                                                                        """
                                                                        deact template
                                                                        
                                                                        .. attribute:: template_name
                                                                        
                                                                        	template name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: flags
                                                                        
                                                                        	flags
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate, self).__init__()

                                                                            self.yang_name = "deact-template"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('template_name', (YLeaf(YType.str, 'template-name'), ['str'])),
                                                                                ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                                ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                            ])
                                                                            self.template_name = None
                                                                            self.aaa_list_name = None
                                                                            self.flags = None
                                                                            self._segment_path = lambda: "deact-template"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate, ['template_name', 'aaa_list_name', 'flags'], name, value)


                                                                    class Qlimit(Entity):
                                                                        """
                                                                        qlimit
                                                                        
                                                                        .. attribute:: action_qlimit_info_array
                                                                        
                                                                        	action qlimit info array
                                                                        	**type**\: list of  		 :py:class:`ActionQlimitInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit, self).__init__()

                                                                            self.yang_name = "qlimit"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("action-qlimit-info-array", ("action_qlimit_info_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.action_qlimit_info_array = YList(self)
                                                                            self._segment_path = lambda: "qlimit"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit, [], name, value)


                                                                        class ActionQlimitInfoArray(Entity):
                                                                            """
                                                                            action qlimit info array
                                                                            
                                                                            .. attribute:: qlim
                                                                            
                                                                            	qlim
                                                                            	**type**\:  :py:class:`Qlim <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim>`
                                                                            
                                                                            .. attribute:: atmclp_qlim
                                                                            
                                                                            	atmclp qlim
                                                                            	**type**\:  :py:class:`AtmclpQlim <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim>`
                                                                            
                                                                            .. attribute:: match_values
                                                                            
                                                                            	match values
                                                                            	**type**\:  :py:class:`MatchValues <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues>`
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:  :py:class:`QlimitTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.QlimitTypeEn>`
                                                                            
                                                                            .. attribute:: qlimit_flags
                                                                            
                                                                            	qlimit flags
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray, self).__init__()

                                                                                self.yang_name = "action-qlimit-info-array"
                                                                                self.yang_parent_name = "qlimit"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("qlim", ("qlim", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim)), ("atmclp-qlim", ("atmclp_qlim", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim)), ("match-values", ("match_values", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'QlimitTypeEn', '')])),
                                                                                    ('qlimit_flags', (YLeaf(YType.uint32, 'qlimit-flags'), ['int'])),
                                                                                ])
                                                                                self.type = None
                                                                                self.qlimit_flags = None

                                                                                self.qlim = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim()
                                                                                self.qlim.parent = self
                                                                                self._children_name_map["qlim"] = "qlim"

                                                                                self.atmclp_qlim = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim()
                                                                                self.atmclp_qlim.parent = self
                                                                                self._children_name_map["atmclp_qlim"] = "atmclp-qlim"

                                                                                self.match_values = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues()
                                                                                self.match_values.parent = self
                                                                                self._children_name_map["match_values"] = "match-values"
                                                                                self._segment_path = lambda: "action-qlimit-info-array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray, ['type', 'qlimit_flags'], name, value)


                                                                            class Qlim(Entity):
                                                                                """
                                                                                qlim
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim, self).__init__()

                                                                                    self.yang_name = "qlim"
                                                                                    self.yang_parent_name = "action-qlimit-info-array"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.unit = None
                                                                                    self._segment_path = lambda: "qlim"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim, ['value', 'unit'], name, value)


                                                                            class AtmclpQlim(Entity):
                                                                                """
                                                                                atmclp qlim
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim, self).__init__()

                                                                                    self.yang_name = "atmclp-qlim"
                                                                                    self.yang_parent_name = "action-qlimit-info-array"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.unit = None
                                                                                    self._segment_path = lambda: "atmclp-qlim"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim, ['value', 'unit'], name, value)


                                                                            class MatchValues(Entity):
                                                                                """
                                                                                match values
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues, self).__init__()

                                                                                    self.yang_name = "match-values"
                                                                                    self.yang_parent_name = "action-qlimit-info-array"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "match-values"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "match-values"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray, ['min', 'max'], name, value)


                                                                    class AccountingEventAaa(Entity):
                                                                        """
                                                                        accounting event aaa
                                                                        
                                                                        .. attribute:: action
                                                                        
                                                                        	action
                                                                        	**type**\:  :py:class:`AcctEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.AcctEn>`
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa, self).__init__()

                                                                            self.yang_name = "accounting-event-aaa"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('action', (YLeaf(YType.enumeration, 'action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'AcctEn', '')])),
                                                                                ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                            ])
                                                                            self.action = None
                                                                            self.aaa_list_name = None
                                                                            self._segment_path = lambda: "accounting-event-aaa"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa, ['action', 'aaa_list_name'], name, value)


                                                                    class AuthorizeId(Entity):
                                                                        """
                                                                        authorize id
                                                                        
                                                                        .. attribute:: id
                                                                        
                                                                        	id
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: format_name
                                                                        
                                                                        	format name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: password
                                                                        
                                                                        	password
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId, self).__init__()

                                                                            self.yang_name = "authorize-id"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('id', (YLeaf(YType.uint8, 'id'), ['int'])),
                                                                                ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                                ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                ('password', (YLeaf(YType.str, 'password'), ['str'])),
                                                                            ])
                                                                            self.id = None
                                                                            self.aaa_list_name = None
                                                                            self.format_name = None
                                                                            self.password = None
                                                                            self._segment_path = lambda: "authorize-id"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId, ['id', 'aaa_list_name', 'format_name', 'password'], name, value)


                                                                    class AfmReact(Entity):
                                                                        """
                                                                        afm react
                                                                        
                                                                        .. attribute:: action_afmon_react_info
                                                                        
                                                                        	action afmon react info
                                                                        	**type**\: list of  		 :py:class:`ActionAfmonReactInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact, self).__init__()

                                                                            self.yang_name = "afm-react"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("action-afmon-react-info", ("action_afmon_react_info", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo))])
                                                                            self._leafs = OrderedDict()

                                                                            self.action_afmon_react_info = YList(self)
                                                                            self._segment_path = lambda: "afm-react"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact, [], name, value)


                                                                        class ActionAfmonReactInfo(Entity):
                                                                            """
                                                                            action afmon react info
                                                                            
                                                                            .. attribute:: oper_id
                                                                            
                                                                            	React Operation ID
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: description
                                                                            
                                                                            	Describing the oper
                                                                            	**type**\: str
                                                                            
                                                                            .. attribute:: trig_num_intvls
                                                                            
                                                                            	Averaged over N intvls
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: clone_ifh
                                                                            
                                                                            	Clone interface handle
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: notif_actns
                                                                            
                                                                            	Bitmap of actions on alert
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: criterion
                                                                            
                                                                            	React Criterion
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: trig_type
                                                                            
                                                                            	Immediate or averaged thresh trigger
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: trig_relop
                                                                            
                                                                            	Trigger LT\|LE\|GT\|GE\|Range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: trig_level_1
                                                                            
                                                                            	Trigger threshold 1/lower
                                                                            	**type**\: str
                                                                            
                                                                            .. attribute:: trig_level_2
                                                                            
                                                                            	Trigger upper threshold for range
                                                                            	**type**\: str
                                                                            
                                                                            .. attribute:: alm_grp_thresh
                                                                            
                                                                            	Num/percent in grp
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            	**units**\: percentage
                                                                            
                                                                            .. attribute:: alm_type
                                                                            
                                                                            	Discrete \| grouped alarm
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: alm_severity
                                                                            
                                                                            	Major\|Minor\|... alarm
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo, self).__init__()

                                                                                self.yang_name = "action-afmon-react-info"
                                                                                self.yang_parent_name = "afm-react"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('oper_id', (YLeaf(YType.uint32, 'oper-id'), ['int'])),
                                                                                    ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                    ('trig_num_intvls', (YLeaf(YType.uint32, 'trig-num-intvls'), ['int'])),
                                                                                    ('clone_ifh', (YLeaf(YType.uint32, 'clone-ifh'), ['int'])),
                                                                                    ('notif_actns', (YLeaf(YType.uint8, 'notif-actns'), ['int'])),
                                                                                    ('criterion', (YLeaf(YType.uint8, 'criterion'), ['int'])),
                                                                                    ('trig_type', (YLeaf(YType.uint8, 'trig-type'), ['int'])),
                                                                                    ('trig_relop', (YLeaf(YType.uint8, 'trig-relop'), ['int'])),
                                                                                    ('trig_level_1', (YLeaf(YType.str, 'trig-level-1'), ['str'])),
                                                                                    ('trig_level_2', (YLeaf(YType.str, 'trig-level-2'), ['str'])),
                                                                                    ('alm_grp_thresh', (YLeaf(YType.uint16, 'alm-grp-thresh'), ['int'])),
                                                                                    ('alm_type', (YLeaf(YType.uint8, 'alm-type'), ['int'])),
                                                                                    ('alm_severity', (YLeaf(YType.uint8, 'alm-severity'), ['int'])),
                                                                                ])
                                                                                self.oper_id = None
                                                                                self.description = None
                                                                                self.trig_num_intvls = None
                                                                                self.clone_ifh = None
                                                                                self.notif_actns = None
                                                                                self.criterion = None
                                                                                self.trig_type = None
                                                                                self.trig_relop = None
                                                                                self.trig_level_1 = None
                                                                                self.trig_level_2 = None
                                                                                self.alm_grp_thresh = None
                                                                                self.alm_type = None
                                                                                self.alm_severity = None
                                                                                self._segment_path = lambda: "action-afmon-react-info"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo, ['oper_id', 'description', 'trig_num_intvls', 'clone_ifh', 'notif_actns', 'criterion', 'trig_type', 'trig_relop', 'trig_level_1', 'trig_level_2', 'alm_grp_thresh', 'alm_type', 'alm_severity'], name, value)


                                                                    class Httpr(Entity):
                                                                        """
                                                                        httpr
                                                                        
                                                                        .. attribute:: redirect_url
                                                                        
                                                                        	redirect url
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr, self).__init__()

                                                                            self.yang_name = "httpr"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('redirect_url', (YLeaf(YType.str, 'redirect-url'), ['str'])),
                                                                            ])
                                                                            self.redirect_url = None
                                                                            self._segment_path = lambda: "httpr"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr, ['redirect_url'], name, value)


                                                                    class Punt(Entity):
                                                                        """
                                                                        punt
                                                                        
                                                                        .. attribute:: sn_type
                                                                        
                                                                        	service node ID type
                                                                        	**type**\:  :py:class:`DpssSnidTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.DpssSnidTypeEn>`
                                                                        
                                                                        .. attribute:: sn_index
                                                                        
                                                                        	service node index
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: sn_name
                                                                        
                                                                        	service node name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: app_id
                                                                        
                                                                        	application ID
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: local_id
                                                                        
                                                                        	local ID
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: vsnode_type
                                                                        
                                                                        	vservice node type
                                                                        	**type**\:  :py:class:`VsvcServiceTypeT <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.VsvcServiceTypeT>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt, self).__init__()

                                                                            self.yang_name = "punt"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('sn_type', (YLeaf(YType.enumeration, 'sn-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'DpssSnidTypeEn', '')])),
                                                                                ('sn_index', (YLeaf(YType.uint32, 'sn-index'), ['int'])),
                                                                                ('sn_name', (YLeaf(YType.str, 'sn-name'), ['str'])),
                                                                                ('app_id', (YLeaf(YType.uint32, 'app-id'), ['int'])),
                                                                                ('local_id', (YLeaf(YType.uint32, 'local-id'), ['int'])),
                                                                                ('vsnode_type', (YLeaf(YType.enumeration, 'vsnode-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'VsvcServiceTypeT', '')])),
                                                                            ])
                                                                            self.sn_type = None
                                                                            self.sn_index = None
                                                                            self.sn_name = None
                                                                            self.app_id = None
                                                                            self.local_id = None
                                                                            self.vsnode_type = None
                                                                            self._segment_path = lambda: "punt"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt, ['sn_type', 'sn_index', 'sn_name', 'app_id', 'local_id', 'vsnode_type'], name, value)


                                                                    class Copy(Entity):
                                                                        """
                                                                        copy
                                                                        
                                                                        .. attribute:: num_byte
                                                                        
                                                                        	number of bytes
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: sn_type
                                                                        
                                                                        	service node ID type
                                                                        	**type**\:  :py:class:`DpssSnidTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.DpssSnidTypeEn>`
                                                                        
                                                                        .. attribute:: sn_index
                                                                        
                                                                        	service node index
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: sn_name
                                                                        
                                                                        	service node url
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: app_id
                                                                        
                                                                        	application ID
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: local_id
                                                                        
                                                                        	local ID
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: vsnode_type
                                                                        
                                                                        	vservice node type
                                                                        	**type**\:  :py:class:`VsvcServiceTypeT <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.VsvcServiceTypeT>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy, self).__init__()

                                                                            self.yang_name = "copy"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('num_byte', (YLeaf(YType.uint32, 'num-byte'), ['int'])),
                                                                                ('sn_type', (YLeaf(YType.enumeration, 'sn-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'DpssSnidTypeEn', '')])),
                                                                                ('sn_index', (YLeaf(YType.uint32, 'sn-index'), ['int'])),
                                                                                ('sn_name', (YLeaf(YType.str, 'sn-name'), ['str'])),
                                                                                ('app_id', (YLeaf(YType.uint32, 'app-id'), ['int'])),
                                                                                ('local_id', (YLeaf(YType.uint32, 'local-id'), ['int'])),
                                                                                ('vsnode_type', (YLeaf(YType.enumeration, 'vsnode-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'VsvcServiceTypeT', '')])),
                                                                            ])
                                                                            self.num_byte = None
                                                                            self.sn_type = None
                                                                            self.sn_index = None
                                                                            self.sn_name = None
                                                                            self.app_id = None
                                                                            self.local_id = None
                                                                            self.vsnode_type = None
                                                                            self._segment_path = lambda: "copy"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy, ['num_byte', 'sn_type', 'sn_index', 'sn_name', 'app_id', 'local_id', 'vsnode_type'], name, value)


                                                                    class Sfrag(Entity):
                                                                        """
                                                                        sfrag
                                                                        
                                                                        .. attribute:: name
                                                                        
                                                                        	Service Fragment Name
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag, self).__init__()

                                                                            self.yang_name = "sfrag"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                            ])
                                                                            self.name = None
                                                                            self._segment_path = lambda: "sfrag"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag, ['name'], name, value)


                                                                    class Redirect(Entity):
                                                                        """
                                                                        redirect
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: type
                                                                        
                                                                        	type
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect, self).__init__()

                                                                            self.yang_name = "redirect"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                            ])
                                                                            self.value = None
                                                                            self.type = None
                                                                            self._segment_path = lambda: "redirect"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect, ['value', 'type'], name, value)


                                                                    class OutIntf(Entity):
                                                                        """
                                                                        out intf
                                                                        
                                                                        .. attribute:: out_ifname
                                                                        
                                                                        	output interface name
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf, self).__init__()

                                                                            self.yang_name = "out-intf"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('out_ifname', (YLeaf(YType.str, 'out-ifname'), ['str'])),
                                                                            ])
                                                                            self.out_ifname = None
                                                                            self._segment_path = lambda: "out-intf"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf, ['out_ifname'], name, value)


                                                                    class ServFunc(Entity):
                                                                        """
                                                                        serv func
                                                                        
                                                                        .. attribute:: path_id
                                                                        
                                                                        	service path id
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: service_index
                                                                        
                                                                        	service path index
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: meta_name
                                                                        
                                                                        	metadata name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: vs_index
                                                                        
                                                                        	vservice index
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc, self).__init__()

                                                                            self.yang_name = "serv-func"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('path_id', (YLeaf(YType.uint32, 'path-id'), ['int'])),
                                                                                ('service_index', (YLeaf(YType.uint8, 'service-index'), ['int'])),
                                                                                ('meta_name', (YLeaf(YType.str, 'meta-name'), ['str'])),
                                                                                ('vs_index', (YLeaf(YType.uint32, 'vs-index'), ['int'])),
                                                                            ])
                                                                            self.path_id = None
                                                                            self.service_index = None
                                                                            self.meta_name = None
                                                                            self.vs_index = None
                                                                            self._segment_path = lambda: "serv-func"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc, ['path_id', 'service_index', 'meta_name', 'vs_index'], name, value)


                                                                    class Police(Entity):
                                                                        """
                                                                        police
                                                                        
                                                                        .. attribute:: rate
                                                                        
                                                                        	rate
                                                                        	**type**\:  :py:class:`Rate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate>`
                                                                        
                                                                        .. attribute:: burst
                                                                        
                                                                        	burst
                                                                        	**type**\:  :py:class:`Burst <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst>`
                                                                        
                                                                        .. attribute:: peak_rate
                                                                        
                                                                        	peak rate
                                                                        	**type**\:  :py:class:`PeakRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate>`
                                                                        
                                                                        .. attribute:: peak_burst
                                                                        
                                                                        	peak burst
                                                                        	**type**\:  :py:class:`PeakBurst <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst>`
                                                                        
                                                                        .. attribute:: cdvt
                                                                        
                                                                        	cdvt
                                                                        	**type**\:  :py:class:`Cdvt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt>`
                                                                        
                                                                        .. attribute:: conform_actns
                                                                        
                                                                        	conform actns
                                                                        	**type**\:  :py:class:`ConformActns <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns>`
                                                                        
                                                                        .. attribute:: exceed_actns
                                                                        
                                                                        	exceed actns
                                                                        	**type**\:  :py:class:`ExceedActns <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns>`
                                                                        
                                                                        .. attribute:: violate_actns
                                                                        
                                                                        	violate actns
                                                                        	**type**\:  :py:class:`ViolateActns <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns>`
                                                                        
                                                                        .. attribute:: confclass_encode
                                                                        
                                                                        	confclass encode
                                                                        	**type**\:  :py:class:`ConfclassEncode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode>`
                                                                        
                                                                        .. attribute:: confclass_p
                                                                        
                                                                        	confclass p
                                                                        	**type**\:  :py:class:`ConfclassP <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP>`
                                                                        
                                                                        .. attribute:: excdclass_encode
                                                                        
                                                                        	excdclass encode
                                                                        	**type**\:  :py:class:`ExcdclassEncode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode>`
                                                                        
                                                                        .. attribute:: excdclass_p
                                                                        
                                                                        	excdclass p
                                                                        	**type**\:  :py:class:`ExcdclassP <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP>`
                                                                        
                                                                        .. attribute:: flags
                                                                        
                                                                        	flags
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: police_flags
                                                                        
                                                                        	police flags
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: sbuck_name
                                                                        
                                                                        	sbuck name
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..65
                                                                        
                                                                        .. attribute:: sbuck_type
                                                                        
                                                                        	sbuck type
                                                                        	**type**\:  :py:class:`SharedBucketType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.SharedBucketType>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police, self).__init__()

                                                                            self.yang_name = "police"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("rate", ("rate", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate)), ("burst", ("burst", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst)), ("peak-rate", ("peak_rate", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate)), ("peak-burst", ("peak_burst", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst)), ("cdvt", ("cdvt", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt)), ("conform-actns", ("conform_actns", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns)), ("exceed-actns", ("exceed_actns", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns)), ("violate-actns", ("violate_actns", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns)), ("confclass-encode", ("confclass_encode", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode)), ("confclass-p", ("confclass_p", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP)), ("excdclass-encode", ("excdclass_encode", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode)), ("excdclass-p", ("excdclass_p", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP))])
                                                                            self._leafs = OrderedDict([
                                                                                ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                ('police_flags', (YLeaf(YType.uint32, 'police-flags'), ['int'])),
                                                                                ('sbuck_name', (YLeaf(YType.str, 'sbuck-name'), ['str'])),
                                                                                ('sbuck_type', (YLeaf(YType.enumeration, 'sbuck-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'SharedBucketType', '')])),
                                                                            ])
                                                                            self.flags = None
                                                                            self.police_flags = None
                                                                            self.sbuck_name = None
                                                                            self.sbuck_type = None

                                                                            self.rate = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate()
                                                                            self.rate.parent = self
                                                                            self._children_name_map["rate"] = "rate"

                                                                            self.burst = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst()
                                                                            self.burst.parent = self
                                                                            self._children_name_map["burst"] = "burst"

                                                                            self.peak_rate = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate()
                                                                            self.peak_rate.parent = self
                                                                            self._children_name_map["peak_rate"] = "peak-rate"

                                                                            self.peak_burst = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst()
                                                                            self.peak_burst.parent = self
                                                                            self._children_name_map["peak_burst"] = "peak-burst"

                                                                            self.cdvt = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt()
                                                                            self.cdvt.parent = self
                                                                            self._children_name_map["cdvt"] = "cdvt"

                                                                            self.conform_actns = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns()
                                                                            self.conform_actns.parent = self
                                                                            self._children_name_map["conform_actns"] = "conform-actns"

                                                                            self.exceed_actns = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns()
                                                                            self.exceed_actns.parent = self
                                                                            self._children_name_map["exceed_actns"] = "exceed-actns"

                                                                            self.violate_actns = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns()
                                                                            self.violate_actns.parent = self
                                                                            self._children_name_map["violate_actns"] = "violate-actns"

                                                                            self.confclass_encode = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode()
                                                                            self.confclass_encode.parent = self
                                                                            self._children_name_map["confclass_encode"] = "confclass-encode"

                                                                            self.confclass_p = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP()
                                                                            self.confclass_p.parent = self
                                                                            self._children_name_map["confclass_p"] = "confclass-p"

                                                                            self.excdclass_encode = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode()
                                                                            self.excdclass_encode.parent = self
                                                                            self._children_name_map["excdclass_encode"] = "excdclass-encode"

                                                                            self.excdclass_p = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP()
                                                                            self.excdclass_p.parent = self
                                                                            self._children_name_map["excdclass_p"] = "excdclass-p"
                                                                            self._segment_path = lambda: "police"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police, ['flags', 'police_flags', 'sbuck_name', 'sbuck_type'], name, value)


                                                                        class Rate(Entity):
                                                                            """
                                                                            rate
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate, self).__init__()

                                                                                self.yang_name = "rate"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate, ['value', 'unit'], name, value)


                                                                        class Burst(Entity):
                                                                            """
                                                                            burst
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst, self).__init__()

                                                                                self.yang_name = "burst"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "burst"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst, ['value', 'unit'], name, value)


                                                                        class PeakRate(Entity):
                                                                            """
                                                                            peak rate
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate, self).__init__()

                                                                                self.yang_name = "peak-rate"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "peak-rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate, ['value', 'unit'], name, value)


                                                                        class PeakBurst(Entity):
                                                                            """
                                                                            peak burst
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst, self).__init__()

                                                                                self.yang_name = "peak-burst"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "peak-burst"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst, ['value', 'unit'], name, value)


                                                                        class Cdvt(Entity):
                                                                            """
                                                                            cdvt
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt, self).__init__()

                                                                                self.yang_name = "cdvt"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "cdvt"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt, ['value', 'unit'], name, value)


                                                                        class ConformActns(Entity):
                                                                            """
                                                                            conform actns
                                                                            
                                                                            .. attribute:: police_action_array
                                                                            
                                                                            	police action array
                                                                            	**type**\: list of  		 :py:class:`PoliceActionArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns, self).__init__()

                                                                                self.yang_name = "conform-actns"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("police-action-array", ("police_action_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.police_action_array = YList(self)
                                                                                self._segment_path = lambda: "conform-actns"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns, [], name, value)


                                                                            class PoliceActionArray(Entity):
                                                                                """
                                                                                police action array
                                                                                
                                                                                .. attribute:: mark
                                                                                
                                                                                	mark
                                                                                	**type**\:  :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark>`
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:  :py:class:`PoliceActionTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PoliceActionTypeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray, self).__init__()

                                                                                    self.yang_name = "police-action-array"
                                                                                    self.yang_parent_name = "conform-actns"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("mark", ("mark", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PoliceActionTypeEn', '')])),
                                                                                    ])
                                                                                    self.type = None

                                                                                    self.mark = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark()
                                                                                    self.mark.parent = self
                                                                                    self._children_name_map["mark"] = "mark"
                                                                                    self._segment_path = lambda: "police-action-array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray, ['type'], name, value)


                                                                                class Mark(Entity):
                                                                                    """
                                                                                    mark
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	type
                                                                                    	**type**\:  :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                                    
                                                                                    .. attribute:: mark_flags
                                                                                    
                                                                                    	mark flags
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark, self).__init__()

                                                                                        self.yang_name = "mark"
                                                                                        self.yang_parent_name = "police-action-array"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MarkTypeEn', '')])),
                                                                                            ('mark_flags', (YLeaf(YType.uint32, 'mark-flags'), ['int'])),
                                                                                            ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                        ])
                                                                                        self.type = None
                                                                                        self.mark_flags = None
                                                                                        self.value = None
                                                                                        self._segment_path = lambda: "mark"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark, ['type', 'mark_flags', 'value'], name, value)


                                                                        class ExceedActns(Entity):
                                                                            """
                                                                            exceed actns
                                                                            
                                                                            .. attribute:: police_action_array
                                                                            
                                                                            	police action array
                                                                            	**type**\: list of  		 :py:class:`PoliceActionArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns, self).__init__()

                                                                                self.yang_name = "exceed-actns"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("police-action-array", ("police_action_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.police_action_array = YList(self)
                                                                                self._segment_path = lambda: "exceed-actns"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns, [], name, value)


                                                                            class PoliceActionArray(Entity):
                                                                                """
                                                                                police action array
                                                                                
                                                                                .. attribute:: mark
                                                                                
                                                                                	mark
                                                                                	**type**\:  :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark>`
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:  :py:class:`PoliceActionTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PoliceActionTypeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray, self).__init__()

                                                                                    self.yang_name = "police-action-array"
                                                                                    self.yang_parent_name = "exceed-actns"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("mark", ("mark", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PoliceActionTypeEn', '')])),
                                                                                    ])
                                                                                    self.type = None

                                                                                    self.mark = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark()
                                                                                    self.mark.parent = self
                                                                                    self._children_name_map["mark"] = "mark"
                                                                                    self._segment_path = lambda: "police-action-array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray, ['type'], name, value)


                                                                                class Mark(Entity):
                                                                                    """
                                                                                    mark
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	type
                                                                                    	**type**\:  :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                                    
                                                                                    .. attribute:: mark_flags
                                                                                    
                                                                                    	mark flags
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark, self).__init__()

                                                                                        self.yang_name = "mark"
                                                                                        self.yang_parent_name = "police-action-array"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MarkTypeEn', '')])),
                                                                                            ('mark_flags', (YLeaf(YType.uint32, 'mark-flags'), ['int'])),
                                                                                            ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                        ])
                                                                                        self.type = None
                                                                                        self.mark_flags = None
                                                                                        self.value = None
                                                                                        self._segment_path = lambda: "mark"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark, ['type', 'mark_flags', 'value'], name, value)


                                                                        class ViolateActns(Entity):
                                                                            """
                                                                            violate actns
                                                                            
                                                                            .. attribute:: police_action_array
                                                                            
                                                                            	police action array
                                                                            	**type**\: list of  		 :py:class:`PoliceActionArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns, self).__init__()

                                                                                self.yang_name = "violate-actns"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("police-action-array", ("police_action_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.police_action_array = YList(self)
                                                                                self._segment_path = lambda: "violate-actns"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns, [], name, value)


                                                                            class PoliceActionArray(Entity):
                                                                                """
                                                                                police action array
                                                                                
                                                                                .. attribute:: mark
                                                                                
                                                                                	mark
                                                                                	**type**\:  :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark>`
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:  :py:class:`PoliceActionTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PoliceActionTypeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray, self).__init__()

                                                                                    self.yang_name = "police-action-array"
                                                                                    self.yang_parent_name = "violate-actns"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("mark", ("mark", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PoliceActionTypeEn', '')])),
                                                                                    ])
                                                                                    self.type = None

                                                                                    self.mark = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark()
                                                                                    self.mark.parent = self
                                                                                    self._children_name_map["mark"] = "mark"
                                                                                    self._segment_path = lambda: "police-action-array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray, ['type'], name, value)


                                                                                class Mark(Entity):
                                                                                    """
                                                                                    mark
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	type
                                                                                    	**type**\:  :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                                    
                                                                                    .. attribute:: mark_flags
                                                                                    
                                                                                    	mark flags
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark, self).__init__()

                                                                                        self.yang_name = "mark"
                                                                                        self.yang_parent_name = "police-action-array"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MarkTypeEn', '')])),
                                                                                            ('mark_flags', (YLeaf(YType.uint32, 'mark-flags'), ['int'])),
                                                                                            ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                        ])
                                                                                        self.type = None
                                                                                        self.mark_flags = None
                                                                                        self.value = None
                                                                                        self._segment_path = lambda: "mark"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark, ['type', 'mark_flags', 'value'], name, value)


                                                                        class ConfclassEncode(Entity):
                                                                            """
                                                                            confclass encode
                                                                            
                                                                            .. attribute:: inline_cmap
                                                                            
                                                                            	inline cmap
                                                                            	**type**\:  :py:class:`InlineCmap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap>`
                                                                            
                                                                            .. attribute:: enc
                                                                            
                                                                            	enc
                                                                            	**type**\:  :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                            
                                                                            .. attribute:: class_name
                                                                            
                                                                            	class name
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..65
                                                                            
                                                                            .. attribute:: hd
                                                                            
                                                                            	hd
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: idx
                                                                            
                                                                            	idx
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode, self).__init__()

                                                                                self.yang_name = "confclass-encode"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("inline-cmap", ("inline_cmap", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('enc', (YLeaf(YType.enumeration, 'enc'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyObjEncEn', '')])),
                                                                                    ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                                                    ('hd', (YLeaf(YType.uint64, 'hd'), ['int'])),
                                                                                    ('idx', (YLeaf(YType.uint8, 'idx'), ['int'])),
                                                                                ])
                                                                                self.enc = None
                                                                                self.class_name = None
                                                                                self.hd = None
                                                                                self.idx = None

                                                                                self.inline_cmap = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap()
                                                                                self.inline_cmap.parent = self
                                                                                self._children_name_map["inline_cmap"] = "inline-cmap"
                                                                                self._segment_path = lambda: "confclass-encode"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode, ['enc', 'class_name', 'hd', 'idx'], name, value)


                                                                            class InlineCmap(Entity):
                                                                                """
                                                                                inline cmap
                                                                                
                                                                                .. attribute:: match_infop
                                                                                
                                                                                	Pointer to the first Match info
                                                                                	**type**\:  :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop>`
                                                                                
                                                                                .. attribute:: mode
                                                                                
                                                                                	Inline Class\-Map Mode Match any/all
                                                                                	**type**\:  :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                                
                                                                                .. attribute:: flags
                                                                                
                                                                                	Inline Class\-Map flags
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: match_count
                                                                                
                                                                                	Number of Match infos
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap, self).__init__()

                                                                                    self.yang_name = "inline-cmap"
                                                                                    self.yang_parent_name = "confclass-encode"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("match-infop", ("match_infop", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapModeEn', '')])),
                                                                                        ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                        ('match_count', (YLeaf(YType.uint32, 'match-count'), ['int'])),
                                                                                    ])
                                                                                    self.mode = None
                                                                                    self.flags = None
                                                                                    self.match_count = None

                                                                                    self.match_infop = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop()
                                                                                    self.match_infop.parent = self
                                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                                    self._segment_path = lambda: "inline-cmap"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap, ['mode', 'flags', 'match_count'], name, value)


                                                                                class MatchInfop(Entity):
                                                                                    """
                                                                                    Pointer to the first Match info
                                                                                    
                                                                                    .. attribute:: class_match_info_st
                                                                                    
                                                                                    	class match info st
                                                                                    	**type**\: list of  		 :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop, self).__init__()

                                                                                        self.yang_name = "match-infop"
                                                                                        self.yang_parent_name = "inline-cmap"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("class-match-info-st", ("class_match_info_st", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.class_match_info_st = YList(self)
                                                                                        self._segment_path = lambda: "match-infop"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop, [], name, value)


                                                                                    class ClassMatchInfoSt(Entity):
                                                                                        """
                                                                                        class match info st
                                                                                        
                                                                                        .. attribute:: match_data
                                                                                        
                                                                                        	Match criteria
                                                                                        	**type**\:  :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                        
                                                                                        .. attribute:: flags
                                                                                        
                                                                                        	Flags
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                            self.yang_name = "class-match-info-st"
                                                                                            self.yang_parent_name = "match-infop"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("match-data", ("match_data", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData))])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                            ])
                                                                                            self.flags = None

                                                                                            self.match_data = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                            self.match_data.parent = self
                                                                                            self._children_name_map["match_data"] = "match-data"
                                                                                            self._segment_path = lambda: "class-match-info-st"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                        class MatchData(Entity):
                                                                                            """
                                                                                            Match criteria
                                                                                            
                                                                                            .. attribute:: ipv4_dscp
                                                                                            
                                                                                            	IPv4 DSCP
                                                                                            	**type**\:  :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv6_dscp
                                                                                            
                                                                                            	IPv6 DSCP
                                                                                            	**type**\:  :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                            
                                                                                            .. attribute:: dscp
                                                                                            
                                                                                            	Match DSCP range array
                                                                                            	**type**\:  :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv4_prec
                                                                                            
                                                                                            	IPv4 Precedence
                                                                                            	**type**\:  :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                            
                                                                                            .. attribute:: ipv6_prec
                                                                                            
                                                                                            	IPv6 Precedence
                                                                                            	**type**\:  :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                            
                                                                                            .. attribute:: prec
                                                                                            
                                                                                            	Match Precedence array
                                                                                            	**type**\:  :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                            
                                                                                            .. attribute:: discard_class
                                                                                            
                                                                                            	Match Discard Class array
                                                                                            	**type**\:  :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                            
                                                                                            .. attribute:: qos_group
                                                                                            
                                                                                            	Match QoS group array
                                                                                            	**type**\:  :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                            
                                                                                            .. attribute:: traffic_class
                                                                                            
                                                                                            	Match Traffic class array
                                                                                            	**type**\:  :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                            
                                                                                            .. attribute:: proto
                                                                                            
                                                                                            	Match Protocol array
                                                                                            	**type**\:  :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                            
                                                                                            .. attribute:: icmp_v4
                                                                                            
                                                                                            	Match ICMPV4 Protocol
                                                                                            	**type**\:  :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                            
                                                                                            .. attribute:: icmp_v6
                                                                                            
                                                                                            	Match ICMPV6 Protocol array
                                                                                            	**type**\:  :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                            
                                                                                            .. attribute:: ipv4_packet_len
                                                                                            
                                                                                            	IPv4 packet length array
                                                                                            	**type**\:  :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv6_packet_len
                                                                                            
                                                                                            	IPv6 packet length array
                                                                                            	**type**\:  :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                            
                                                                                            .. attribute:: packet_len
                                                                                            
                                                                                            	Match packet length array
                                                                                            	**type**\:  :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                            
                                                                                            .. attribute:: flow_tag
                                                                                            
                                                                                            	Match flow\-tag array
                                                                                            	**type**\:  :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                            
                                                                                            .. attribute:: tcp_flag
                                                                                            
                                                                                            	Match tcp flag value
                                                                                            	**type**\:  :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                            
                                                                                            .. attribute:: icmpv4_type
                                                                                            
                                                                                            	Match ipv4 icmp type
                                                                                            	**type**\:  :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                            
                                                                                            .. attribute:: icmpv4_code
                                                                                            
                                                                                            	Match ipv4 icmp code
                                                                                            	**type**\:  :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                            
                                                                                            .. attribute:: icmpv6_type
                                                                                            
                                                                                            	Match ipv6 icmp type
                                                                                            	**type**\:  :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                            
                                                                                            .. attribute:: icmpv6_code
                                                                                            
                                                                                            	Match ipv6 icmp code
                                                                                            	**type**\:  :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                            
                                                                                            .. attribute:: mpls_exp
                                                                                            
                                                                                            	Match MPLS experimental topmost array
                                                                                            	**type**\:  :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                            
                                                                                            .. attribute:: mpls_exp_imp
                                                                                            
                                                                                            	Match MPLS experimental imposition array
                                                                                            	**type**\:  :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                                            
                                                                                            	MPLS Disposition IPv4 Access\-list
                                                                                            	**type**\:  :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                                            
                                                                                            	MPLS Disposition IPv6 Access\-list
                                                                                            	**type**\:  :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_top_label
                                                                                            
                                                                                            	MPLS Topmost LABEL
                                                                                            	**type**\:  :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                            
                                                                                            .. attribute:: cos
                                                                                            
                                                                                            	Match CoS array
                                                                                            	**type**\:  :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                            
                                                                                            .. attribute:: cos_inr
                                                                                            
                                                                                            	Match inner header CoS
                                                                                            	**type**\:  :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                            
                                                                                            .. attribute:: dei
                                                                                            
                                                                                            	Match DEI Bit
                                                                                            	**type**\:  :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                            
                                                                                            .. attribute:: dei_inr
                                                                                            
                                                                                            	Match inner DEI Bit
                                                                                            	**type**\:  :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                            
                                                                                            .. attribute:: vlan
                                                                                            
                                                                                            	Match VLAN array
                                                                                            	**type**\:  :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                            
                                                                                            .. attribute:: vlan_inr
                                                                                            
                                                                                            	Match inner header VLAN range array
                                                                                            	**type**\:  :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                            
                                                                                            .. attribute:: fr_dlci
                                                                                            
                                                                                            	Match FR DLCI range array
                                                                                            	**type**\:  :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                            
                                                                                            .. attribute:: src_mac
                                                                                            
                                                                                            	Match Source MAC address
                                                                                            	**type**\:  :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                            
                                                                                            .. attribute:: dst_mac
                                                                                            
                                                                                            	Match Destination MAC address
                                                                                            	**type**\:  :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                            
                                                                                            .. attribute:: atm_clp
                                                                                            
                                                                                            	Match ATM CLP level
                                                                                            	**type**\:  :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                            
                                                                                            .. attribute:: fr_de
                                                                                            
                                                                                            	Match FR DE value
                                                                                            	**type**\:  :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                            
                                                                                            .. attribute:: ipv4_acl
                                                                                            
                                                                                            	IPv4 Access\-list
                                                                                            	**type**\:  :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                            
                                                                                            .. attribute:: ipv6_acl
                                                                                            
                                                                                            	IPv6 Access\-list
                                                                                            	**type**\:  :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                            
                                                                                            .. attribute:: ether_service_acl
                                                                                            
                                                                                            	Ethernet\-Services Access\-list
                                                                                            	**type**\:  :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                            
                                                                                            .. attribute:: avail_id
                                                                                            
                                                                                            	Available Identifiers
                                                                                            	**type**\:  :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                            
                                                                                            .. attribute:: media_type
                                                                                            
                                                                                            	Media Type
                                                                                            	**type**\:  :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                            
                                                                                            .. attribute:: subs_protocol
                                                                                            
                                                                                            	Protocol
                                                                                            	**type**\:  :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                            
                                                                                            .. attribute:: dnis
                                                                                            
                                                                                            	DNIS
                                                                                            	**type**\:  :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                            
                                                                                            .. attribute:: dnis_regex
                                                                                            
                                                                                            	DNIS Regular Expression
                                                                                            	**type**\:  :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                            
                                                                                            .. attribute:: domain
                                                                                            
                                                                                            	Domain Name
                                                                                            	**type**\:  :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                            
                                                                                            .. attribute:: domain_regex
                                                                                            
                                                                                            	Domain Regular Expression
                                                                                            	**type**\:  :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                            
                                                                                            .. attribute:: nas_port
                                                                                            
                                                                                            	NAS Port
                                                                                            	**type**\:  :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                            
                                                                                            .. attribute:: service_name
                                                                                            
                                                                                            	Service Name
                                                                                            	**type**\:  :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                            
                                                                                            .. attribute:: service_name_regex
                                                                                            
                                                                                            	Service Name Regular Exp
                                                                                            	**type**\:  :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv4
                                                                                            
                                                                                            	Source Address IPV4
                                                                                            	**type**\:  :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv4
                                                                                            
                                                                                            	Destination Address IPV4
                                                                                            	**type**\:  :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv6
                                                                                            
                                                                                            	Source Address IPV6
                                                                                            	**type**\:  :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv6
                                                                                            
                                                                                            	Destination Address IPV6
                                                                                            	**type**\:  :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: src_addr_mac
                                                                                            
                                                                                            	Source Address MAC
                                                                                            	**type**\:  :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                            
                                                                                            .. attribute:: timer
                                                                                            
                                                                                            	Timer
                                                                                            	**type**\:  :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                            
                                                                                            .. attribute:: timer_regexp
                                                                                            
                                                                                            	Timer Regular Expression
                                                                                            	**type**\:  :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                            
                                                                                            .. attribute:: tunnel_name
                                                                                            
                                                                                            	Tunnel Name
                                                                                            	**type**\:  :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                            
                                                                                            .. attribute:: tunnel_name_regex
                                                                                            
                                                                                            	Tunnel Name Regular Expression
                                                                                            	**type**\:  :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                            
                                                                                            .. attribute:: user_name
                                                                                            
                                                                                            	User Name
                                                                                            	**type**\:  :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                            
                                                                                            .. attribute:: user_name_regex
                                                                                            
                                                                                            	User Name Regular Expression
                                                                                            	**type**\:  :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                            
                                                                                            .. attribute:: auth_username
                                                                                            
                                                                                            	Authenticated User Name
                                                                                            	**type**\:  :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                            
                                                                                            .. attribute:: auth_username_regex
                                                                                            
                                                                                            	Authenticated User Name RegEx
                                                                                            	**type**\:  :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_username
                                                                                            
                                                                                            	Unauthenticated User Name
                                                                                            	**type**\:  :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                            
                                                                                            .. attribute:: unauth_username_regex
                                                                                            
                                                                                            	Unauthenticated User Name RegEx
                                                                                            	**type**\:  :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: auth_domain
                                                                                            
                                                                                            	Authenticated domain name
                                                                                            	**type**\:  :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                            
                                                                                            .. attribute:: auth_domain_regex
                                                                                            
                                                                                            	Authenticated Domain Name RegEx
                                                                                            	**type**\:  :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_domain
                                                                                            
                                                                                            	Unauthenticated Domain Name
                                                                                            	**type**\:  :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                            
                                                                                            .. attribute:: unauth_domain_regex
                                                                                            
                                                                                            	Unauthenticated Domain Name RegEx
                                                                                            	**type**\:  :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: vendor_id
                                                                                            
                                                                                            	Vendor ID
                                                                                            	**type**\:  :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                            
                                                                                            .. attribute:: vendor_id_regex
                                                                                            
                                                                                            	Vendor ID RegEx
                                                                                            	**type**\:  :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                            
                                                                                            .. attribute:: access_interface
                                                                                            
                                                                                            	Access interface
                                                                                            	**type**\:  :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                            
                                                                                            .. attribute:: input_interface
                                                                                            
                                                                                            	Input interface
                                                                                            	**type**\:  :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                            
                                                                                            .. attribute:: input_intfhdl
                                                                                            
                                                                                            	Input interface handle
                                                                                            	**type**\:  :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                            
                                                                                            .. attribute:: ethertype
                                                                                            
                                                                                            	Ethernet type
                                                                                            	**type**\:  :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                            
                                                                                            .. attribute:: flow_key_data
                                                                                            
                                                                                            	Flow key structure
                                                                                            	**type**\:  :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id
                                                                                            
                                                                                            	Dhcp Client ID
                                                                                            	**type**\:  :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id_regex
                                                                                            
                                                                                            	Dhcp Client ID RegEx
                                                                                            	**type**\:  :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                            
                                                                                            .. attribute:: circuit_id
                                                                                            
                                                                                            	Circuit ID
                                                                                            	**type**\:  :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                            
                                                                                            .. attribute:: circuit_id_regex
                                                                                            
                                                                                            	Circuit ID RegEx
                                                                                            	**type**\:  :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                            
                                                                                            .. attribute:: remote_id
                                                                                            
                                                                                            	Remote ID
                                                                                            	**type**\:  :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                            
                                                                                            .. attribute:: remote_id_regex
                                                                                            
                                                                                            	Remote ID RegEx
                                                                                            	**type**\:  :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                            
                                                                                            .. attribute:: src_port
                                                                                            
                                                                                            	Source port
                                                                                            	**type**\:  :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                            
                                                                                            .. attribute:: dst_port
                                                                                            
                                                                                            	Destination port
                                                                                            	**type**\:  :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	type
                                                                                            	**type**\:  :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                            
                                                                                            .. attribute:: mpls_top_eos
                                                                                            
                                                                                            	MPLS Topmost EOS
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: fragment_type
                                                                                            
                                                                                            	Fragment type
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: authen_status
                                                                                            
                                                                                            	Authentication Status
                                                                                            	**type**\:  :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                            
                                                                                            .. attribute:: mlp_negotiated
                                                                                            
                                                                                            	MLP Negotiated
                                                                                            	**type**\:  :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                                self.yang_name = "match-data"
                                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("ipv4-dscp", ("ipv4_dscp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp)), ("ipv6-dscp", ("ipv6_dscp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp)), ("dscp", ("dscp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp)), ("ipv4-prec", ("ipv4_prec", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec)), ("ipv6-prec", ("ipv6_prec", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec)), ("prec", ("prec", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec)), ("discard-class", ("discard_class", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass)), ("qos-group", ("qos_group", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup)), ("traffic-class", ("traffic_class", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass)), ("proto", ("proto", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto)), ("icmp-v4", ("icmp_v4", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4)), ("icmp-v6", ("icmp_v6", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6)), ("ipv4-packet-len", ("ipv4_packet_len", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen)), ("ipv6-packet-len", ("ipv6_packet_len", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen)), ("packet-len", ("packet_len", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen)), ("flow-tag", ("flow_tag", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag)), ("tcp-flag", ("tcp_flag", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag)), ("icmpv4-type", ("icmpv4_type", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type)), ("icmpv4-code", ("icmpv4_code", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code)), ("icmpv6-type", ("icmpv6_type", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type)), ("icmpv6-code", ("icmpv6_code", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code)), ("mpls-exp", ("mpls_exp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp)), ("mpls-exp-imp", ("mpls_exp_imp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp)), ("mpls-disp-ipv4-acl", ("mpls_disp_ipv4_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl)), ("mpls-disp-ipv6-acl", ("mpls_disp_ipv6_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl)), ("mpls-top-label", ("mpls_top_label", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel)), ("cos", ("cos", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos)), ("cos-inr", ("cos_inr", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr)), ("dei", ("dei", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei)), ("dei-inr", ("dei_inr", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr)), ("vlan", ("vlan", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan)), ("vlan-inr", ("vlan_inr", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)), ("fr-dlci", ("fr_dlci", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci)), ("src-mac", ("src_mac", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac)), ("dst-mac", ("dst_mac", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac)), ("atm-clp", ("atm_clp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp)), ("fr-de", ("fr_de", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe)), ("ipv4-acl", ("ipv4_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl)), ("ipv6-acl", ("ipv6_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl)), ("ether-service-acl", ("ether_service_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl)), ("avail-id", ("avail_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId)), ("media-type", ("media_type", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType)), ("subs-protocol", ("subs_protocol", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol)), ("dnis", ("dnis", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis)), ("dnis-regex", ("dnis_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex)), ("domain", ("domain", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain)), ("domain-regex", ("domain_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex)), ("nas-port", ("nas_port", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort)), ("service-name", ("service_name", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName)), ("service-name-regex", ("service_name_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex)), ("src-addr-ipv4", ("src_addr_ipv4", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4)), ("dst-addr-ipv4", ("dst_addr_ipv4", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4)), ("src-addr-ipv6", ("src_addr_ipv6", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6)), ("dst-addr-ipv6", ("dst_addr_ipv6", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6)), ("src-addr-mac", ("src_addr_mac", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac)), ("timer", ("timer", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer)), ("timer-regexp", ("timer_regexp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp)), ("tunnel-name", ("tunnel_name", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName)), ("tunnel-name-regex", ("tunnel_name_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex)), ("user-name", ("user_name", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName)), ("user-name-regex", ("user_name_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex)), ("auth-username", ("auth_username", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername)), ("auth-username-regex", ("auth_username_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex)), ("unauth-username", ("unauth_username", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername)), ("unauth-username-regex", ("unauth_username_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex)), ("auth-domain", ("auth_domain", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain)), ("auth-domain-regex", ("auth_domain_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex)), ("unauth-domain", ("unauth_domain", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain)), ("unauth-domain-regex", ("unauth_domain_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex)), ("vendor-id", ("vendor_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId)), ("vendor-id-regex", ("vendor_id_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex)), ("access-interface", ("access_interface", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface)), ("input-interface", ("input_interface", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface)), ("input-intfhdl", ("input_intfhdl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl)), ("ethertype", ("ethertype", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype)), ("flow-key-data", ("flow_key_data", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData)), ("dhcp-client-id", ("dhcp_client_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId)), ("dhcp-client-id-regex", ("dhcp_client_id_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex)), ("circuit-id", ("circuit_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId)), ("circuit-id-regex", ("circuit_id_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex)), ("remote-id", ("remote_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId)), ("remote-id-regex", ("remote_id_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex)), ("src-port", ("src_port", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort)), ("dst-port", ("dst_port", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort))])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchTypeEn', '')])),
                                                                                                    ('mpls_top_eos', (YLeaf(YType.uint8, 'mpls-top-eos'), ['int'])),
                                                                                                    ('fragment_type', (YLeaf(YType.uint8, 'fragment-type'), ['int'])),
                                                                                                    ('authen_status', (YLeaf(YType.enumeration, 'authen-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchAuthenStatusEn', '')])),
                                                                                                    ('mlp_negotiated', (YLeaf(YType.enumeration, 'mlp-negotiated'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchMlpNegotiatedEn', '')])),
                                                                                                ])
                                                                                                self.type = None
                                                                                                self.mpls_top_eos = None
                                                                                                self.fragment_type = None
                                                                                                self.authen_status = None
                                                                                                self.mlp_negotiated = None

                                                                                                self.ipv4_dscp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                                self.ipv4_dscp.parent = self
                                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"

                                                                                                self.ipv6_dscp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                                self.ipv6_dscp.parent = self
                                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"

                                                                                                self.dscp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                                self.dscp.parent = self
                                                                                                self._children_name_map["dscp"] = "dscp"

                                                                                                self.ipv4_prec = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                                self.ipv4_prec.parent = self
                                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"

                                                                                                self.ipv6_prec = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                                self.ipv6_prec.parent = self
                                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"

                                                                                                self.prec = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                                self.prec.parent = self
                                                                                                self._children_name_map["prec"] = "prec"

                                                                                                self.discard_class = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                                self.discard_class.parent = self
                                                                                                self._children_name_map["discard_class"] = "discard-class"

                                                                                                self.qos_group = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                                self.qos_group.parent = self
                                                                                                self._children_name_map["qos_group"] = "qos-group"

                                                                                                self.traffic_class = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                                self.traffic_class.parent = self
                                                                                                self._children_name_map["traffic_class"] = "traffic-class"

                                                                                                self.proto = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                                self.proto.parent = self
                                                                                                self._children_name_map["proto"] = "proto"

                                                                                                self.icmp_v4 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                                self.icmp_v4.parent = self
                                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"

                                                                                                self.icmp_v6 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                                self.icmp_v6.parent = self
                                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"

                                                                                                self.ipv4_packet_len = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                                self.ipv4_packet_len.parent = self
                                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"

                                                                                                self.ipv6_packet_len = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                                self.ipv6_packet_len.parent = self
                                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"

                                                                                                self.packet_len = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                                self.packet_len.parent = self
                                                                                                self._children_name_map["packet_len"] = "packet-len"

                                                                                                self.flow_tag = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                                self.flow_tag.parent = self
                                                                                                self._children_name_map["flow_tag"] = "flow-tag"

                                                                                                self.tcp_flag = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                                self.tcp_flag.parent = self
                                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"

                                                                                                self.icmpv4_type = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                                self.icmpv4_type.parent = self
                                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"

                                                                                                self.icmpv4_code = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                                self.icmpv4_code.parent = self
                                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"

                                                                                                self.icmpv6_type = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                                self.icmpv6_type.parent = self
                                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"

                                                                                                self.icmpv6_code = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                                self.icmpv6_code.parent = self
                                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"

                                                                                                self.mpls_exp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                                self.mpls_exp.parent = self
                                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"

                                                                                                self.mpls_exp_imp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                                self.mpls_exp_imp.parent = self
                                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"

                                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"

                                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"

                                                                                                self.mpls_top_label = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                                self.mpls_top_label.parent = self
                                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"

                                                                                                self.cos = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                                self.cos.parent = self
                                                                                                self._children_name_map["cos"] = "cos"

                                                                                                self.cos_inr = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                                self.cos_inr.parent = self
                                                                                                self._children_name_map["cos_inr"] = "cos-inr"

                                                                                                self.dei = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                                self.dei.parent = self
                                                                                                self._children_name_map["dei"] = "dei"

                                                                                                self.dei_inr = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                                self.dei_inr.parent = self
                                                                                                self._children_name_map["dei_inr"] = "dei-inr"

                                                                                                self.vlan = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                                self.vlan.parent = self
                                                                                                self._children_name_map["vlan"] = "vlan"

                                                                                                self.vlan_inr = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                                self.vlan_inr.parent = self
                                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"

                                                                                                self.fr_dlci = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                                self.fr_dlci.parent = self
                                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"

                                                                                                self.src_mac = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                                self.src_mac.parent = self
                                                                                                self._children_name_map["src_mac"] = "src-mac"

                                                                                                self.dst_mac = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                                self.dst_mac.parent = self
                                                                                                self._children_name_map["dst_mac"] = "dst-mac"

                                                                                                self.atm_clp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                                self.atm_clp.parent = self
                                                                                                self._children_name_map["atm_clp"] = "atm-clp"

                                                                                                self.fr_de = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                                self.fr_de.parent = self
                                                                                                self._children_name_map["fr_de"] = "fr-de"

                                                                                                self.ipv4_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                                self.ipv4_acl.parent = self
                                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"

                                                                                                self.ipv6_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                                self.ipv6_acl.parent = self
                                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"

                                                                                                self.ether_service_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                                self.ether_service_acl.parent = self
                                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"

                                                                                                self.avail_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                                self.avail_id.parent = self
                                                                                                self._children_name_map["avail_id"] = "avail-id"

                                                                                                self.media_type = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                                self.media_type.parent = self
                                                                                                self._children_name_map["media_type"] = "media-type"

                                                                                                self.subs_protocol = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                                self.subs_protocol.parent = self
                                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"

                                                                                                self.dnis = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                                self.dnis.parent = self
                                                                                                self._children_name_map["dnis"] = "dnis"

                                                                                                self.dnis_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                                self.dnis_regex.parent = self
                                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"

                                                                                                self.domain = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                                self.domain.parent = self
                                                                                                self._children_name_map["domain"] = "domain"

                                                                                                self.domain_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                                self.domain_regex.parent = self
                                                                                                self._children_name_map["domain_regex"] = "domain-regex"

                                                                                                self.nas_port = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                                self.nas_port.parent = self
                                                                                                self._children_name_map["nas_port"] = "nas-port"

                                                                                                self.service_name = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                                self.service_name.parent = self
                                                                                                self._children_name_map["service_name"] = "service-name"

                                                                                                self.service_name_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                                self.service_name_regex.parent = self
                                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"

                                                                                                self.src_addr_ipv4 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                                self.src_addr_ipv4.parent = self
                                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"

                                                                                                self.dst_addr_ipv4 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                                self.dst_addr_ipv4.parent = self
                                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"

                                                                                                self.src_addr_ipv6 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                                self.src_addr_ipv6.parent = self
                                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"

                                                                                                self.dst_addr_ipv6 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                                self.dst_addr_ipv6.parent = self
                                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"

                                                                                                self.src_addr_mac = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                                self.src_addr_mac.parent = self
                                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"

                                                                                                self.timer = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                                self.timer.parent = self
                                                                                                self._children_name_map["timer"] = "timer"

                                                                                                self.timer_regexp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                                self.timer_regexp.parent = self
                                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"

                                                                                                self.tunnel_name = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                                self.tunnel_name.parent = self
                                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"

                                                                                                self.tunnel_name_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                                self.tunnel_name_regex.parent = self
                                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"

                                                                                                self.user_name = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                                self.user_name.parent = self
                                                                                                self._children_name_map["user_name"] = "user-name"

                                                                                                self.user_name_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                                self.user_name_regex.parent = self
                                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"

                                                                                                self.auth_username = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                                self.auth_username.parent = self
                                                                                                self._children_name_map["auth_username"] = "auth-username"

                                                                                                self.auth_username_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                                self.auth_username_regex.parent = self
                                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"

                                                                                                self.unauth_username = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                                self.unauth_username.parent = self
                                                                                                self._children_name_map["unauth_username"] = "unauth-username"

                                                                                                self.unauth_username_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                                self.unauth_username_regex.parent = self
                                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"

                                                                                                self.auth_domain = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                                self.auth_domain.parent = self
                                                                                                self._children_name_map["auth_domain"] = "auth-domain"

                                                                                                self.auth_domain_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                                self.auth_domain_regex.parent = self
                                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"

                                                                                                self.unauth_domain = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                                self.unauth_domain.parent = self
                                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"

                                                                                                self.unauth_domain_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                                self.unauth_domain_regex.parent = self
                                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"

                                                                                                self.vendor_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                                self.vendor_id.parent = self
                                                                                                self._children_name_map["vendor_id"] = "vendor-id"

                                                                                                self.vendor_id_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                                self.vendor_id_regex.parent = self
                                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"

                                                                                                self.access_interface = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                                self.access_interface.parent = self
                                                                                                self._children_name_map["access_interface"] = "access-interface"

                                                                                                self.input_interface = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                                self.input_interface.parent = self
                                                                                                self._children_name_map["input_interface"] = "input-interface"

                                                                                                self.input_intfhdl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                                self.input_intfhdl.parent = self
                                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"

                                                                                                self.ethertype = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                                self.ethertype.parent = self
                                                                                                self._children_name_map["ethertype"] = "ethertype"

                                                                                                self.flow_key_data = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                                self.flow_key_data.parent = self
                                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"

                                                                                                self.dhcp_client_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                                self.dhcp_client_id.parent = self
                                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"

                                                                                                self.dhcp_client_id_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                                self.dhcp_client_id_regex.parent = self
                                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"

                                                                                                self.circuit_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                                self.circuit_id.parent = self
                                                                                                self._children_name_map["circuit_id"] = "circuit-id"

                                                                                                self.circuit_id_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                                self.circuit_id_regex.parent = self
                                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"

                                                                                                self.remote_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                                self.remote_id.parent = self
                                                                                                self._children_name_map["remote_id"] = "remote-id"

                                                                                                self.remote_id_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                                self.remote_id_regex.parent = self
                                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"

                                                                                                self.src_port = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                                self.src_port.parent = self
                                                                                                self._children_name_map["src_port"] = "src-port"

                                                                                                self.dst_port = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                                self.dst_port.parent = self
                                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                                self._segment_path = lambda: "match-data"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, ['type', 'mpls_top_eos', 'fragment_type', 'authen_status', 'mlp_negotiated'], name, value)


                                                                                            class Ipv4Dscp(Entity):
                                                                                                """
                                                                                                IPv4 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv4-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv6Dscp(Entity):
                                                                                                """
                                                                                                IPv6 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv6-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Dscp(Entity):
                                                                                                """
                                                                                                Match DSCP range array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                    self.yang_name = "dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv4Prec(Entity):
                                                                                                """
                                                                                                IPv4 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                    self.yang_name = "ipv4-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "ipv4-prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                            class Ipv6Prec(Entity):
                                                                                                """
                                                                                                IPv6 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                    self.yang_name = "ipv6-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "ipv6-prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                            class Prec(Entity):
                                                                                                """
                                                                                                Match Precedence array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                    self.yang_name = "prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                            class DiscardClass(Entity):
                                                                                                """
                                                                                                Match Discard Class array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                    self.yang_name = "discard-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "discard-class"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                            class QosGroup(Entity):
                                                                                                """
                                                                                                Match QoS group array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                    self.yang_name = "qos-group"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "qos-group"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "qos-group"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class TrafficClass(Entity):
                                                                                                """
                                                                                                Match Traffic class array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                    self.yang_name = "traffic-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "traffic-class"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "traffic-class"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Proto(Entity):
                                                                                                """
                                                                                                Match Protocol array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                    self.yang_name = "proto"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "proto"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "proto"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class IcmpV4(Entity):
                                                                                                """
                                                                                                Match ICMPV4 Protocol
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                    self.yang_name = "icmp-v4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                    ])
                                                                                                    self.type = None
                                                                                                    self.code = None
                                                                                                    self._segment_path = lambda: "icmp-v4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['type', 'code'], name, value)


                                                                                            class IcmpV6(Entity):
                                                                                                """
                                                                                                Match ICMPV6 Protocol array
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                    self.yang_name = "icmp-v6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                    ])
                                                                                                    self.type = None
                                                                                                    self.code = None
                                                                                                    self._segment_path = lambda: "icmp-v6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['type', 'code'], name, value)


                                                                                            class Ipv4PacketLen(Entity):
                                                                                                """
                                                                                                IPv4 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv6PacketLen(Entity):
                                                                                                """
                                                                                                IPv6 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class PacketLen(Entity):
                                                                                                """
                                                                                                Match packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                    self.yang_name = "packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FlowTag(Entity):
                                                                                                """
                                                                                                Match flow\-tag array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                    self.yang_name = "flow-tag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "flow-tag"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "flow-tag"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class TcpFlag(Entity):
                                                                                                """
                                                                                                Match tcp flag value
                                                                                                
                                                                                                .. attribute:: value
                                                                                                
                                                                                                	Value of TCP flag
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: match_any
                                                                                                
                                                                                                	Match any TCP flag bit
                                                                                                	**type**\: bool
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                    self.yang_name = "tcp-flag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                                        ('match_any', (YLeaf(YType.boolean, 'match-any'), ['bool'])),
                                                                                                    ])
                                                                                                    self.value = None
                                                                                                    self.match_any = None
                                                                                                    self._segment_path = lambda: "tcp-flag"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['value', 'match_any'], name, value)


                                                                                            class Icmpv4Type(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                    self.yang_name = "icmpv4-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv4Code(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                    self.yang_name = "icmpv4-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-code"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv6Type(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                    self.yang_name = "icmpv6-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv6Code(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                    self.yang_name = "icmpv6-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-code"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class MplsExp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental topmost array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "mpls-exp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                            class MplsExpImp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental imposition array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "mpls-exp-imp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                            class MplsDispIpv4Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                            class MplsDispIpv6Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                            class MplsTopLabel(Entity):
                                                                                                """
                                                                                                MPLS Topmost LABEL
                                                                                                
                                                                                                .. attribute:: uint32_rng_array
                                                                                                
                                                                                                	uint32 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                    self.yang_name = "mpls-top-label"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint32_rng_array", ("uint32_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint32_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "mpls-top-label"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                                class Uint32RngArray(Entity):
                                                                                                    """
                                                                                                    uint32 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                        self.yang_name = "uint32_rng_array"
                                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint32, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint32, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint32_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['min', 'max'], name, value)


                                                                                            class Cos(Entity):
                                                                                                """
                                                                                                Match CoS array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                    self.yang_name = "cos"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "cos"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                            class CosInr(Entity):
                                                                                                """
                                                                                                Match inner header CoS
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                    self.yang_name = "cos-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "cos-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                            class Dei(Entity):
                                                                                                """
                                                                                                Match DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                    self.yang_name = "dei"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                    ])
                                                                                                    self.bit_value = None
                                                                                                    self._segment_path = lambda: "dei"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                            class DeiInr(Entity):
                                                                                                """
                                                                                                Match inner DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                    self.yang_name = "dei-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                    ])
                                                                                                    self.bit_value = None
                                                                                                    self._segment_path = lambda: "dei-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                            class Vlan(Entity):
                                                                                                """
                                                                                                Match VLAN array
                                                                                                
                                                                                                .. attribute:: vlan_id_array
                                                                                                
                                                                                                	vlan id array
                                                                                                	**type**\: list of  		 :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                    self.yang_name = "vlan"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("vlan-id-array", ("vlan_id_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.vlan_id_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                                class VlanIdArray(Entity):
                                                                                                    """
                                                                                                    vlan id array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	VLAN mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                        self.yang_name = "vlan-id-array"
                                                                                                        self.yang_parent_name = "vlan"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ('mask', (YLeaf(YType.uint16, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "vlan-id-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['min', 'max', 'mask'], name, value)


                                                                                            class VlanInr(Entity):
                                                                                                """
                                                                                                Match inner header VLAN range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                    self.yang_name = "vlan-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FrDlci(Entity):
                                                                                                """
                                                                                                Match FR DLCI range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                    self.yang_name = "fr-dlci"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "fr-dlci"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class SrcMac(Entity):
                                                                                                """
                                                                                                Match Source MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                    self.yang_name = "src-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.mac_addr = []
                                                                                                    self.mask = []
                                                                                                    self._segment_path = lambda: "src-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                            class DstMac(Entity):
                                                                                                """
                                                                                                Match Destination MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                    self.yang_name = "dst-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.mac_addr = []
                                                                                                    self.mask = []
                                                                                                    self._segment_path = lambda: "dst-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                            class AtmClp(Entity):
                                                                                                """
                                                                                                Match ATM CLP level
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                    self.yang_name = "atm-clp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "atm-clp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                            class FrDe(Entity):
                                                                                                """
                                                                                                Match FR DE value
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                    self.yang_name = "fr-de"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "fr-de"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                            class Ipv4Acl(Entity):
                                                                                                """
                                                                                                IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                    self.yang_name = "ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ipv4-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                            class Ipv6Acl(Entity):
                                                                                                """
                                                                                                IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                    self.yang_name = "ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ipv6-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                            class EtherServiceAcl(Entity):
                                                                                                """
                                                                                                Ethernet\-Services Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                    self.yang_name = "ether-service-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ether-service-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                            class AvailId(Entity):
                                                                                                """
                                                                                                Available Identifiers
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                    self.yang_name = "avail-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "avail-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                            class MediaType(Entity):
                                                                                                """
                                                                                                Media Type
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                    self.yang_name = "media-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "media-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                            class SubsProtocol(Entity):
                                                                                                """
                                                                                                Protocol
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                    self.yang_name = "subs-protocol"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "subs-protocol"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                            class Dnis(Entity):
                                                                                                """
                                                                                                DNIS
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                    self.yang_name = "dnis"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dnis"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                            class DnisRegex(Entity):
                                                                                                """
                                                                                                DNIS Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                    self.yang_name = "dnis-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dnis-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                            class Domain(Entity):
                                                                                                """
                                                                                                Domain Name
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                    self.yang_name = "domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                        ])
                                                                                                        self.domain_name = None
                                                                                                        self.format_name = None
                                                                                                        self._segment_path = lambda: "domain-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class DomainRegex(Entity):
                                                                                                """
                                                                                                Domain Regular Expression
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                    self.yang_name = "domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain-regex"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                        ])
                                                                                                        self.domain_name = None
                                                                                                        self.format_name = None
                                                                                                        self._segment_path = lambda: "domain-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class NasPort(Entity):
                                                                                                """
                                                                                                NAS Port
                                                                                                
                                                                                                .. attribute:: nas_port_array
                                                                                                
                                                                                                	nas port array
                                                                                                	**type**\: list of  		 :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                    self.yang_name = "nas-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("nas-port-array", ("nas_port_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.nas_port_array = YList(self)
                                                                                                    self._segment_path = lambda: "nas-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                                class NasPortArray(Entity):
                                                                                                    """
                                                                                                    nas port array
                                                                                                    
                                                                                                    .. attribute:: sub_id
                                                                                                    
                                                                                                    	sub id
                                                                                                    	**type**\:  :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                    
                                                                                                    .. attribute:: operator
                                                                                                    
                                                                                                    	operator
                                                                                                    	**type**\:  :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	value
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                        self.yang_name = "nas-port-array"
                                                                                                        self.yang_parent_name = "nas-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('sub_id', (YLeaf(YType.enumeration, 'sub-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchNasPortSubIdEn', '')])),
                                                                                                            ('operator', (YLeaf(YType.enumeration, 'operator'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchLogicalOperatorEn', '')])),
                                                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                                        ])
                                                                                                        self.sub_id = None
                                                                                                        self.operator = None
                                                                                                        self.value = None
                                                                                                        self._segment_path = lambda: "nas-port-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['sub_id', 'operator', 'value'], name, value)


                                                                                            class ServiceName(Entity):
                                                                                                """
                                                                                                Service Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                    self.yang_name = "service-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "service-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                            class ServiceNameRegex(Entity):
                                                                                                """
                                                                                                Service Name Regular Exp
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                    self.yang_name = "service-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "service-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                            class SrcAddrIpv4(Entity):
                                                                                                """
                                                                                                Source Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class DstAddrIpv4(Entity):
                                                                                                """
                                                                                                Destination Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class SrcAddrIpv6(Entity):
                                                                                                """
                                                                                                Source Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class DstAddrIpv6(Entity):
                                                                                                """
                                                                                                Destination Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class SrcAddrMac(Entity):
                                                                                                """
                                                                                                Source Address MAC
                                                                                                
                                                                                                .. attribute:: mac_addr_array
                                                                                                
                                                                                                	mac addr array
                                                                                                	**type**\: list of  		 :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                    self.yang_name = "src-addr-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("mac-addr-array", ("mac_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.mac_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                                class MacAddrArray(Entity):
                                                                                                    """
                                                                                                    mac addr array
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                        self.yang_name = "mac-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                            ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.mac_addr = []
                                                                                                        self.mask = []
                                                                                                        self._segment_path = lambda: "mac-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                            class Timer(Entity):
                                                                                                """
                                                                                                Timer
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                    self.yang_name = "timer"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "timer"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                            class TimerRegexp(Entity):
                                                                                                """
                                                                                                Timer Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                    self.yang_name = "timer-regexp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "timer-regexp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                            class TunnelName(Entity):
                                                                                                """
                                                                                                Tunnel Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                    self.yang_name = "tunnel-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "tunnel-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                            class TunnelNameRegex(Entity):
                                                                                                """
                                                                                                Tunnel Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "tunnel-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                            class UserName(Entity):
                                                                                                """
                                                                                                User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                    self.yang_name = "user-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "user-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                            class UserNameRegex(Entity):
                                                                                                """
                                                                                                User Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                    self.yang_name = "user-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "user-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                            class AuthUsername(Entity):
                                                                                                """
                                                                                                Authenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                    self.yang_name = "auth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-username"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                            class AuthUsernameRegex(Entity):
                                                                                                """
                                                                                                Authenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "auth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-username-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                            class UnauthUsername(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                    self.yang_name = "unauth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-username"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                            class UnauthUsernameRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-username-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                            class AuthDomain(Entity):
                                                                                                """
                                                                                                Authenticated domain name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                    self.yang_name = "auth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                            class AuthDomainRegex(Entity):
                                                                                                """
                                                                                                Authenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "auth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                            class UnauthDomain(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                    self.yang_name = "unauth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                            class UnauthDomainRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                            class VendorId(Entity):
                                                                                                """
                                                                                                Vendor ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                    self.yang_name = "vendor-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "vendor-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                            class VendorIdRegex(Entity):
                                                                                                """
                                                                                                Vendor ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                    self.yang_name = "vendor-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "vendor-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                            class AccessInterface(Entity):
                                                                                                """
                                                                                                Access interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                    self.yang_name = "access-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "access-interface"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                            class InputInterface(Entity):
                                                                                                """
                                                                                                Input interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                    self.yang_name = "input-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "input-interface"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                            class InputIntfhdl(Entity):
                                                                                                """
                                                                                                Input interface handle
                                                                                                
                                                                                                .. attribute:: uint64_array
                                                                                                
                                                                                                	uint64 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..18446744073709551615
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                    self.yang_name = "input-intfhdl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint64_array', (YLeafList(YType.uint64, 'uint64_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint64_array = []
                                                                                                    self._segment_path = lambda: "input-intfhdl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                            class Ethertype(Entity):
                                                                                                """
                                                                                                Ethernet type
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                    self.yang_name = "ethertype"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ethertype"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ethertype"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FlowKeyData(Entity):
                                                                                                """
                                                                                                Flow key structure
                                                                                                
                                                                                                .. attribute:: flow_keys
                                                                                                
                                                                                                	flow keys
                                                                                                	**type**\:  :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                                
                                                                                                .. attribute:: max_count
                                                                                                
                                                                                                	Maximum count of flows
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: idle_timeout
                                                                                                
                                                                                                	Idle timeout of flows (in seconds)
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                	**units**\: second
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                    self.yang_name = "flow-key-data"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("flow-keys", ("flow_keys", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys))])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('max_count', (YLeaf(YType.uint16, 'max-count'), ['int'])),
                                                                                                        ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                                                    ])
                                                                                                    self.max_count = None
                                                                                                    self.idle_timeout = None

                                                                                                    self.flow_keys = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                    self.flow_keys.parent = self
                                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                    self._segment_path = lambda: "flow-key-data"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['max_count', 'idle_timeout'], name, value)


                                                                                                class FlowKeys(Entity):
                                                                                                    """
                                                                                                    flow keys
                                                                                                    
                                                                                                    .. attribute:: keys
                                                                                                    
                                                                                                    	keys
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                    
                                                                                                    .. attribute:: num
                                                                                                    
                                                                                                    	num
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                        self.yang_name = "flow-keys"
                                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('keys', (YLeaf(YType.str, 'keys'), ['str'])),
                                                                                                            ('num', (YLeaf(YType.uint8, 'num'), ['int'])),
                                                                                                        ])
                                                                                                        self.keys = None
                                                                                                        self.num = None
                                                                                                        self._segment_path = lambda: "flow-keys"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                            class DhcpClientId(Entity):
                                                                                                """
                                                                                                Dhcp Client ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dhcp-client-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                            class DhcpClientIdRegex(Entity):
                                                                                                """
                                                                                                Dhcp Client ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                            class CircuitId(Entity):
                                                                                                """
                                                                                                Circuit ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                    self.yang_name = "circuit-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "circuit-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                            class CircuitIdRegex(Entity):
                                                                                                """
                                                                                                Circuit ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                    self.yang_name = "circuit-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "circuit-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                            class RemoteId(Entity):
                                                                                                """
                                                                                                Remote ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                    self.yang_name = "remote-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "remote-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                            class RemoteIdRegex(Entity):
                                                                                                """
                                                                                                Remote ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                    self.yang_name = "remote-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "remote-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                            class SrcPort(Entity):
                                                                                                """
                                                                                                Source port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                    self.yang_name = "src-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "src-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class DstPort(Entity):
                                                                                                """
                                                                                                Destination port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                    self.yang_name = "dst-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "dst-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                        class ConfclassP(Entity):
                                                                            """
                                                                            confclass p
                                                                            
                                                                            .. attribute:: class_map_bg
                                                                            
                                                                            	class map bg
                                                                            	**type**\: list of  		 :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP, self).__init__()

                                                                                self.yang_name = "confclass-p"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("class-map-bg", ("class_map_bg", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg))])
                                                                                self._leafs = OrderedDict()

                                                                                self.class_map_bg = YList(self)
                                                                                self._segment_path = lambda: "confclass-p"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP, [], name, value)


                                                                            class ClassMapBg(Entity):
                                                                                """
                                                                                class map bg
                                                                                
                                                                                .. attribute:: match_infop
                                                                                
                                                                                	Pointer to the first Match info
                                                                                	**type**\:  :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop>`
                                                                                
                                                                                .. attribute:: name
                                                                                
                                                                                	Name of the class\-map
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..65
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Class\-Map Type QoS/PBR/Netflow/..
                                                                                	**type**\:  :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                                                
                                                                                .. attribute:: mode
                                                                                
                                                                                	Class\-Map Mode Match any/Match all
                                                                                	**type**\:  :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                                
                                                                                .. attribute:: description
                                                                                
                                                                                	description
                                                                                	**type**\: str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg, self).__init__()

                                                                                    self.yang_name = "class-map-bg"
                                                                                    self.yang_parent_name = "confclass-p"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("match-infop", ("match_infop", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapTypeEn', '')])),
                                                                                        ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapModeEn', '')])),
                                                                                        ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                    ])
                                                                                    self.name = None
                                                                                    self.type = None
                                                                                    self.mode = None
                                                                                    self.description = None

                                                                                    self.match_infop = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop()
                                                                                    self.match_infop.parent = self
                                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                                    self._segment_path = lambda: "class-map-bg"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg, ['name', 'type', 'mode', 'description'], name, value)


                                                                                class MatchInfop(Entity):
                                                                                    """
                                                                                    Pointer to the first Match info
                                                                                    
                                                                                    .. attribute:: class_match_info_st
                                                                                    
                                                                                    	class match info st
                                                                                    	**type**\: list of  		 :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop, self).__init__()

                                                                                        self.yang_name = "match-infop"
                                                                                        self.yang_parent_name = "class-map-bg"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("class-match-info-st", ("class_match_info_st", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.class_match_info_st = YList(self)
                                                                                        self._segment_path = lambda: "match-infop"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop, [], name, value)


                                                                                    class ClassMatchInfoSt(Entity):
                                                                                        """
                                                                                        class match info st
                                                                                        
                                                                                        .. attribute:: match_data
                                                                                        
                                                                                        	Match criteria
                                                                                        	**type**\:  :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                        
                                                                                        .. attribute:: flags
                                                                                        
                                                                                        	Flags
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                            self.yang_name = "class-match-info-st"
                                                                                            self.yang_parent_name = "match-infop"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("match-data", ("match_data", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData))])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                            ])
                                                                                            self.flags = None

                                                                                            self.match_data = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                            self.match_data.parent = self
                                                                                            self._children_name_map["match_data"] = "match-data"
                                                                                            self._segment_path = lambda: "class-match-info-st"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                        class MatchData(Entity):
                                                                                            """
                                                                                            Match criteria
                                                                                            
                                                                                            .. attribute:: ipv4_dscp
                                                                                            
                                                                                            	IPv4 DSCP
                                                                                            	**type**\:  :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv6_dscp
                                                                                            
                                                                                            	IPv6 DSCP
                                                                                            	**type**\:  :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                            
                                                                                            .. attribute:: dscp
                                                                                            
                                                                                            	Match DSCP range array
                                                                                            	**type**\:  :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv4_prec
                                                                                            
                                                                                            	IPv4 Precedence
                                                                                            	**type**\:  :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                            
                                                                                            .. attribute:: ipv6_prec
                                                                                            
                                                                                            	IPv6 Precedence
                                                                                            	**type**\:  :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                            
                                                                                            .. attribute:: prec
                                                                                            
                                                                                            	Match Precedence array
                                                                                            	**type**\:  :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                            
                                                                                            .. attribute:: discard_class
                                                                                            
                                                                                            	Match Discard Class array
                                                                                            	**type**\:  :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                            
                                                                                            .. attribute:: qos_group
                                                                                            
                                                                                            	Match QoS group array
                                                                                            	**type**\:  :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                            
                                                                                            .. attribute:: traffic_class
                                                                                            
                                                                                            	Match Traffic class array
                                                                                            	**type**\:  :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                            
                                                                                            .. attribute:: proto
                                                                                            
                                                                                            	Match Protocol array
                                                                                            	**type**\:  :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                            
                                                                                            .. attribute:: icmp_v4
                                                                                            
                                                                                            	Match ICMPV4 Protocol
                                                                                            	**type**\:  :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                            
                                                                                            .. attribute:: icmp_v6
                                                                                            
                                                                                            	Match ICMPV6 Protocol array
                                                                                            	**type**\:  :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                            
                                                                                            .. attribute:: ipv4_packet_len
                                                                                            
                                                                                            	IPv4 packet length array
                                                                                            	**type**\:  :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv6_packet_len
                                                                                            
                                                                                            	IPv6 packet length array
                                                                                            	**type**\:  :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                            
                                                                                            .. attribute:: packet_len
                                                                                            
                                                                                            	Match packet length array
                                                                                            	**type**\:  :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                            
                                                                                            .. attribute:: flow_tag
                                                                                            
                                                                                            	Match flow\-tag array
                                                                                            	**type**\:  :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                            
                                                                                            .. attribute:: tcp_flag
                                                                                            
                                                                                            	Match tcp flag value
                                                                                            	**type**\:  :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                            
                                                                                            .. attribute:: icmpv4_type
                                                                                            
                                                                                            	Match ipv4 icmp type
                                                                                            	**type**\:  :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                            
                                                                                            .. attribute:: icmpv4_code
                                                                                            
                                                                                            	Match ipv4 icmp code
                                                                                            	**type**\:  :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                            
                                                                                            .. attribute:: icmpv6_type
                                                                                            
                                                                                            	Match ipv6 icmp type
                                                                                            	**type**\:  :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                            
                                                                                            .. attribute:: icmpv6_code
                                                                                            
                                                                                            	Match ipv6 icmp code
                                                                                            	**type**\:  :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                            
                                                                                            .. attribute:: mpls_exp
                                                                                            
                                                                                            	Match MPLS experimental topmost array
                                                                                            	**type**\:  :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                            
                                                                                            .. attribute:: mpls_exp_imp
                                                                                            
                                                                                            	Match MPLS experimental imposition array
                                                                                            	**type**\:  :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                                            
                                                                                            	MPLS Disposition IPv4 Access\-list
                                                                                            	**type**\:  :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                                            
                                                                                            	MPLS Disposition IPv6 Access\-list
                                                                                            	**type**\:  :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_top_label
                                                                                            
                                                                                            	MPLS Topmost LABEL
                                                                                            	**type**\:  :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                            
                                                                                            .. attribute:: cos
                                                                                            
                                                                                            	Match CoS array
                                                                                            	**type**\:  :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                            
                                                                                            .. attribute:: cos_inr
                                                                                            
                                                                                            	Match inner header CoS
                                                                                            	**type**\:  :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                            
                                                                                            .. attribute:: dei
                                                                                            
                                                                                            	Match DEI Bit
                                                                                            	**type**\:  :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                            
                                                                                            .. attribute:: dei_inr
                                                                                            
                                                                                            	Match inner DEI Bit
                                                                                            	**type**\:  :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                            
                                                                                            .. attribute:: vlan
                                                                                            
                                                                                            	Match VLAN array
                                                                                            	**type**\:  :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                            
                                                                                            .. attribute:: vlan_inr
                                                                                            
                                                                                            	Match inner header VLAN range array
                                                                                            	**type**\:  :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                            
                                                                                            .. attribute:: fr_dlci
                                                                                            
                                                                                            	Match FR DLCI range array
                                                                                            	**type**\:  :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                            
                                                                                            .. attribute:: src_mac
                                                                                            
                                                                                            	Match Source MAC address
                                                                                            	**type**\:  :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                            
                                                                                            .. attribute:: dst_mac
                                                                                            
                                                                                            	Match Destination MAC address
                                                                                            	**type**\:  :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                            
                                                                                            .. attribute:: atm_clp
                                                                                            
                                                                                            	Match ATM CLP level
                                                                                            	**type**\:  :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                            
                                                                                            .. attribute:: fr_de
                                                                                            
                                                                                            	Match FR DE value
                                                                                            	**type**\:  :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                            
                                                                                            .. attribute:: ipv4_acl
                                                                                            
                                                                                            	IPv4 Access\-list
                                                                                            	**type**\:  :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                            
                                                                                            .. attribute:: ipv6_acl
                                                                                            
                                                                                            	IPv6 Access\-list
                                                                                            	**type**\:  :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                            
                                                                                            .. attribute:: ether_service_acl
                                                                                            
                                                                                            	Ethernet\-Services Access\-list
                                                                                            	**type**\:  :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                            
                                                                                            .. attribute:: avail_id
                                                                                            
                                                                                            	Available Identifiers
                                                                                            	**type**\:  :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                            
                                                                                            .. attribute:: media_type
                                                                                            
                                                                                            	Media Type
                                                                                            	**type**\:  :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                            
                                                                                            .. attribute:: subs_protocol
                                                                                            
                                                                                            	Protocol
                                                                                            	**type**\:  :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                            
                                                                                            .. attribute:: dnis
                                                                                            
                                                                                            	DNIS
                                                                                            	**type**\:  :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                            
                                                                                            .. attribute:: dnis_regex
                                                                                            
                                                                                            	DNIS Regular Expression
                                                                                            	**type**\:  :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                            
                                                                                            .. attribute:: domain
                                                                                            
                                                                                            	Domain Name
                                                                                            	**type**\:  :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                            
                                                                                            .. attribute:: domain_regex
                                                                                            
                                                                                            	Domain Regular Expression
                                                                                            	**type**\:  :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                            
                                                                                            .. attribute:: nas_port
                                                                                            
                                                                                            	NAS Port
                                                                                            	**type**\:  :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                            
                                                                                            .. attribute:: service_name
                                                                                            
                                                                                            	Service Name
                                                                                            	**type**\:  :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                            
                                                                                            .. attribute:: service_name_regex
                                                                                            
                                                                                            	Service Name Regular Exp
                                                                                            	**type**\:  :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv4
                                                                                            
                                                                                            	Source Address IPV4
                                                                                            	**type**\:  :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv4
                                                                                            
                                                                                            	Destination Address IPV4
                                                                                            	**type**\:  :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv6
                                                                                            
                                                                                            	Source Address IPV6
                                                                                            	**type**\:  :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv6
                                                                                            
                                                                                            	Destination Address IPV6
                                                                                            	**type**\:  :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: src_addr_mac
                                                                                            
                                                                                            	Source Address MAC
                                                                                            	**type**\:  :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                            
                                                                                            .. attribute:: timer
                                                                                            
                                                                                            	Timer
                                                                                            	**type**\:  :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                            
                                                                                            .. attribute:: timer_regexp
                                                                                            
                                                                                            	Timer Regular Expression
                                                                                            	**type**\:  :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                            
                                                                                            .. attribute:: tunnel_name
                                                                                            
                                                                                            	Tunnel Name
                                                                                            	**type**\:  :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                            
                                                                                            .. attribute:: tunnel_name_regex
                                                                                            
                                                                                            	Tunnel Name Regular Expression
                                                                                            	**type**\:  :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                            
                                                                                            .. attribute:: user_name
                                                                                            
                                                                                            	User Name
                                                                                            	**type**\:  :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                            
                                                                                            .. attribute:: user_name_regex
                                                                                            
                                                                                            	User Name Regular Expression
                                                                                            	**type**\:  :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                            
                                                                                            .. attribute:: auth_username
                                                                                            
                                                                                            	Authenticated User Name
                                                                                            	**type**\:  :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                            
                                                                                            .. attribute:: auth_username_regex
                                                                                            
                                                                                            	Authenticated User Name RegEx
                                                                                            	**type**\:  :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_username
                                                                                            
                                                                                            	Unauthenticated User Name
                                                                                            	**type**\:  :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                            
                                                                                            .. attribute:: unauth_username_regex
                                                                                            
                                                                                            	Unauthenticated User Name RegEx
                                                                                            	**type**\:  :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: auth_domain
                                                                                            
                                                                                            	Authenticated domain name
                                                                                            	**type**\:  :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                            
                                                                                            .. attribute:: auth_domain_regex
                                                                                            
                                                                                            	Authenticated Domain Name RegEx
                                                                                            	**type**\:  :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_domain
                                                                                            
                                                                                            	Unauthenticated Domain Name
                                                                                            	**type**\:  :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                            
                                                                                            .. attribute:: unauth_domain_regex
                                                                                            
                                                                                            	Unauthenticated Domain Name RegEx
                                                                                            	**type**\:  :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: vendor_id
                                                                                            
                                                                                            	Vendor ID
                                                                                            	**type**\:  :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                            
                                                                                            .. attribute:: vendor_id_regex
                                                                                            
                                                                                            	Vendor ID RegEx
                                                                                            	**type**\:  :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                            
                                                                                            .. attribute:: access_interface
                                                                                            
                                                                                            	Access interface
                                                                                            	**type**\:  :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                            
                                                                                            .. attribute:: input_interface
                                                                                            
                                                                                            	Input interface
                                                                                            	**type**\:  :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                            
                                                                                            .. attribute:: input_intfhdl
                                                                                            
                                                                                            	Input interface handle
                                                                                            	**type**\:  :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                            
                                                                                            .. attribute:: ethertype
                                                                                            
                                                                                            	Ethernet type
                                                                                            	**type**\:  :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                            
                                                                                            .. attribute:: flow_key_data
                                                                                            
                                                                                            	Flow key structure
                                                                                            	**type**\:  :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id
                                                                                            
                                                                                            	Dhcp Client ID
                                                                                            	**type**\:  :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id_regex
                                                                                            
                                                                                            	Dhcp Client ID RegEx
                                                                                            	**type**\:  :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                            
                                                                                            .. attribute:: circuit_id
                                                                                            
                                                                                            	Circuit ID
                                                                                            	**type**\:  :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                            
                                                                                            .. attribute:: circuit_id_regex
                                                                                            
                                                                                            	Circuit ID RegEx
                                                                                            	**type**\:  :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                            
                                                                                            .. attribute:: remote_id
                                                                                            
                                                                                            	Remote ID
                                                                                            	**type**\:  :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                            
                                                                                            .. attribute:: remote_id_regex
                                                                                            
                                                                                            	Remote ID RegEx
                                                                                            	**type**\:  :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                            
                                                                                            .. attribute:: src_port
                                                                                            
                                                                                            	Source port
                                                                                            	**type**\:  :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                            
                                                                                            .. attribute:: dst_port
                                                                                            
                                                                                            	Destination port
                                                                                            	**type**\:  :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	type
                                                                                            	**type**\:  :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                            
                                                                                            .. attribute:: mpls_top_eos
                                                                                            
                                                                                            	MPLS Topmost EOS
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: fragment_type
                                                                                            
                                                                                            	Fragment type
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: authen_status
                                                                                            
                                                                                            	Authentication Status
                                                                                            	**type**\:  :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                            
                                                                                            .. attribute:: mlp_negotiated
                                                                                            
                                                                                            	MLP Negotiated
                                                                                            	**type**\:  :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                                self.yang_name = "match-data"
                                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("ipv4-dscp", ("ipv4_dscp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp)), ("ipv6-dscp", ("ipv6_dscp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp)), ("dscp", ("dscp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp)), ("ipv4-prec", ("ipv4_prec", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec)), ("ipv6-prec", ("ipv6_prec", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec)), ("prec", ("prec", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec)), ("discard-class", ("discard_class", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass)), ("qos-group", ("qos_group", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup)), ("traffic-class", ("traffic_class", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass)), ("proto", ("proto", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto)), ("icmp-v4", ("icmp_v4", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4)), ("icmp-v6", ("icmp_v6", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6)), ("ipv4-packet-len", ("ipv4_packet_len", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen)), ("ipv6-packet-len", ("ipv6_packet_len", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen)), ("packet-len", ("packet_len", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen)), ("flow-tag", ("flow_tag", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag)), ("tcp-flag", ("tcp_flag", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag)), ("icmpv4-type", ("icmpv4_type", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type)), ("icmpv4-code", ("icmpv4_code", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code)), ("icmpv6-type", ("icmpv6_type", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type)), ("icmpv6-code", ("icmpv6_code", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code)), ("mpls-exp", ("mpls_exp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp)), ("mpls-exp-imp", ("mpls_exp_imp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp)), ("mpls-disp-ipv4-acl", ("mpls_disp_ipv4_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl)), ("mpls-disp-ipv6-acl", ("mpls_disp_ipv6_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl)), ("mpls-top-label", ("mpls_top_label", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel)), ("cos", ("cos", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos)), ("cos-inr", ("cos_inr", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr)), ("dei", ("dei", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei)), ("dei-inr", ("dei_inr", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr)), ("vlan", ("vlan", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan)), ("vlan-inr", ("vlan_inr", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)), ("fr-dlci", ("fr_dlci", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci)), ("src-mac", ("src_mac", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac)), ("dst-mac", ("dst_mac", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac)), ("atm-clp", ("atm_clp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp)), ("fr-de", ("fr_de", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe)), ("ipv4-acl", ("ipv4_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl)), ("ipv6-acl", ("ipv6_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl)), ("ether-service-acl", ("ether_service_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl)), ("avail-id", ("avail_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId)), ("media-type", ("media_type", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType)), ("subs-protocol", ("subs_protocol", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol)), ("dnis", ("dnis", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis)), ("dnis-regex", ("dnis_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex)), ("domain", ("domain", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain)), ("domain-regex", ("domain_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex)), ("nas-port", ("nas_port", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort)), ("service-name", ("service_name", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName)), ("service-name-regex", ("service_name_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex)), ("src-addr-ipv4", ("src_addr_ipv4", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4)), ("dst-addr-ipv4", ("dst_addr_ipv4", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4)), ("src-addr-ipv6", ("src_addr_ipv6", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6)), ("dst-addr-ipv6", ("dst_addr_ipv6", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6)), ("src-addr-mac", ("src_addr_mac", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac)), ("timer", ("timer", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer)), ("timer-regexp", ("timer_regexp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp)), ("tunnel-name", ("tunnel_name", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName)), ("tunnel-name-regex", ("tunnel_name_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex)), ("user-name", ("user_name", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName)), ("user-name-regex", ("user_name_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex)), ("auth-username", ("auth_username", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername)), ("auth-username-regex", ("auth_username_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex)), ("unauth-username", ("unauth_username", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername)), ("unauth-username-regex", ("unauth_username_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex)), ("auth-domain", ("auth_domain", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain)), ("auth-domain-regex", ("auth_domain_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex)), ("unauth-domain", ("unauth_domain", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain)), ("unauth-domain-regex", ("unauth_domain_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex)), ("vendor-id", ("vendor_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId)), ("vendor-id-regex", ("vendor_id_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex)), ("access-interface", ("access_interface", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface)), ("input-interface", ("input_interface", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface)), ("input-intfhdl", ("input_intfhdl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl)), ("ethertype", ("ethertype", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype)), ("flow-key-data", ("flow_key_data", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData)), ("dhcp-client-id", ("dhcp_client_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId)), ("dhcp-client-id-regex", ("dhcp_client_id_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex)), ("circuit-id", ("circuit_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId)), ("circuit-id-regex", ("circuit_id_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex)), ("remote-id", ("remote_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId)), ("remote-id-regex", ("remote_id_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex)), ("src-port", ("src_port", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort)), ("dst-port", ("dst_port", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort))])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchTypeEn', '')])),
                                                                                                    ('mpls_top_eos', (YLeaf(YType.uint8, 'mpls-top-eos'), ['int'])),
                                                                                                    ('fragment_type', (YLeaf(YType.uint8, 'fragment-type'), ['int'])),
                                                                                                    ('authen_status', (YLeaf(YType.enumeration, 'authen-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchAuthenStatusEn', '')])),
                                                                                                    ('mlp_negotiated', (YLeaf(YType.enumeration, 'mlp-negotiated'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchMlpNegotiatedEn', '')])),
                                                                                                ])
                                                                                                self.type = None
                                                                                                self.mpls_top_eos = None
                                                                                                self.fragment_type = None
                                                                                                self.authen_status = None
                                                                                                self.mlp_negotiated = None

                                                                                                self.ipv4_dscp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                                self.ipv4_dscp.parent = self
                                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"

                                                                                                self.ipv6_dscp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                                self.ipv6_dscp.parent = self
                                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"

                                                                                                self.dscp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                                self.dscp.parent = self
                                                                                                self._children_name_map["dscp"] = "dscp"

                                                                                                self.ipv4_prec = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                                self.ipv4_prec.parent = self
                                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"

                                                                                                self.ipv6_prec = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                                self.ipv6_prec.parent = self
                                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"

                                                                                                self.prec = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                                self.prec.parent = self
                                                                                                self._children_name_map["prec"] = "prec"

                                                                                                self.discard_class = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                                self.discard_class.parent = self
                                                                                                self._children_name_map["discard_class"] = "discard-class"

                                                                                                self.qos_group = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                                self.qos_group.parent = self
                                                                                                self._children_name_map["qos_group"] = "qos-group"

                                                                                                self.traffic_class = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                                self.traffic_class.parent = self
                                                                                                self._children_name_map["traffic_class"] = "traffic-class"

                                                                                                self.proto = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                                self.proto.parent = self
                                                                                                self._children_name_map["proto"] = "proto"

                                                                                                self.icmp_v4 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                                self.icmp_v4.parent = self
                                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"

                                                                                                self.icmp_v6 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                                self.icmp_v6.parent = self
                                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"

                                                                                                self.ipv4_packet_len = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                                self.ipv4_packet_len.parent = self
                                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"

                                                                                                self.ipv6_packet_len = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                                self.ipv6_packet_len.parent = self
                                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"

                                                                                                self.packet_len = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                                self.packet_len.parent = self
                                                                                                self._children_name_map["packet_len"] = "packet-len"

                                                                                                self.flow_tag = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                                self.flow_tag.parent = self
                                                                                                self._children_name_map["flow_tag"] = "flow-tag"

                                                                                                self.tcp_flag = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                                self.tcp_flag.parent = self
                                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"

                                                                                                self.icmpv4_type = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                                self.icmpv4_type.parent = self
                                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"

                                                                                                self.icmpv4_code = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                                self.icmpv4_code.parent = self
                                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"

                                                                                                self.icmpv6_type = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                                self.icmpv6_type.parent = self
                                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"

                                                                                                self.icmpv6_code = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                                self.icmpv6_code.parent = self
                                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"

                                                                                                self.mpls_exp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                                self.mpls_exp.parent = self
                                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"

                                                                                                self.mpls_exp_imp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                                self.mpls_exp_imp.parent = self
                                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"

                                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"

                                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"

                                                                                                self.mpls_top_label = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                                self.mpls_top_label.parent = self
                                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"

                                                                                                self.cos = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                                self.cos.parent = self
                                                                                                self._children_name_map["cos"] = "cos"

                                                                                                self.cos_inr = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                                self.cos_inr.parent = self
                                                                                                self._children_name_map["cos_inr"] = "cos-inr"

                                                                                                self.dei = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                                self.dei.parent = self
                                                                                                self._children_name_map["dei"] = "dei"

                                                                                                self.dei_inr = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                                self.dei_inr.parent = self
                                                                                                self._children_name_map["dei_inr"] = "dei-inr"

                                                                                                self.vlan = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                                self.vlan.parent = self
                                                                                                self._children_name_map["vlan"] = "vlan"

                                                                                                self.vlan_inr = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                                self.vlan_inr.parent = self
                                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"

                                                                                                self.fr_dlci = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                                self.fr_dlci.parent = self
                                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"

                                                                                                self.src_mac = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                                self.src_mac.parent = self
                                                                                                self._children_name_map["src_mac"] = "src-mac"

                                                                                                self.dst_mac = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                                self.dst_mac.parent = self
                                                                                                self._children_name_map["dst_mac"] = "dst-mac"

                                                                                                self.atm_clp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                                self.atm_clp.parent = self
                                                                                                self._children_name_map["atm_clp"] = "atm-clp"

                                                                                                self.fr_de = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                                self.fr_de.parent = self
                                                                                                self._children_name_map["fr_de"] = "fr-de"

                                                                                                self.ipv4_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                                self.ipv4_acl.parent = self
                                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"

                                                                                                self.ipv6_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                                self.ipv6_acl.parent = self
                                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"

                                                                                                self.ether_service_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                                self.ether_service_acl.parent = self
                                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"

                                                                                                self.avail_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                                self.avail_id.parent = self
                                                                                                self._children_name_map["avail_id"] = "avail-id"

                                                                                                self.media_type = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                                self.media_type.parent = self
                                                                                                self._children_name_map["media_type"] = "media-type"

                                                                                                self.subs_protocol = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                                self.subs_protocol.parent = self
                                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"

                                                                                                self.dnis = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                                self.dnis.parent = self
                                                                                                self._children_name_map["dnis"] = "dnis"

                                                                                                self.dnis_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                                self.dnis_regex.parent = self
                                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"

                                                                                                self.domain = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                                self.domain.parent = self
                                                                                                self._children_name_map["domain"] = "domain"

                                                                                                self.domain_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                                self.domain_regex.parent = self
                                                                                                self._children_name_map["domain_regex"] = "domain-regex"

                                                                                                self.nas_port = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                                self.nas_port.parent = self
                                                                                                self._children_name_map["nas_port"] = "nas-port"

                                                                                                self.service_name = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                                self.service_name.parent = self
                                                                                                self._children_name_map["service_name"] = "service-name"

                                                                                                self.service_name_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                                self.service_name_regex.parent = self
                                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"

                                                                                                self.src_addr_ipv4 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                                self.src_addr_ipv4.parent = self
                                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"

                                                                                                self.dst_addr_ipv4 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                                self.dst_addr_ipv4.parent = self
                                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"

                                                                                                self.src_addr_ipv6 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                                self.src_addr_ipv6.parent = self
                                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"

                                                                                                self.dst_addr_ipv6 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                                self.dst_addr_ipv6.parent = self
                                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"

                                                                                                self.src_addr_mac = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                                self.src_addr_mac.parent = self
                                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"

                                                                                                self.timer = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                                self.timer.parent = self
                                                                                                self._children_name_map["timer"] = "timer"

                                                                                                self.timer_regexp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                                self.timer_regexp.parent = self
                                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"

                                                                                                self.tunnel_name = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                                self.tunnel_name.parent = self
                                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"

                                                                                                self.tunnel_name_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                                self.tunnel_name_regex.parent = self
                                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"

                                                                                                self.user_name = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                                self.user_name.parent = self
                                                                                                self._children_name_map["user_name"] = "user-name"

                                                                                                self.user_name_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                                self.user_name_regex.parent = self
                                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"

                                                                                                self.auth_username = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                                self.auth_username.parent = self
                                                                                                self._children_name_map["auth_username"] = "auth-username"

                                                                                                self.auth_username_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                                self.auth_username_regex.parent = self
                                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"

                                                                                                self.unauth_username = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                                self.unauth_username.parent = self
                                                                                                self._children_name_map["unauth_username"] = "unauth-username"

                                                                                                self.unauth_username_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                                self.unauth_username_regex.parent = self
                                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"

                                                                                                self.auth_domain = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                                self.auth_domain.parent = self
                                                                                                self._children_name_map["auth_domain"] = "auth-domain"

                                                                                                self.auth_domain_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                                self.auth_domain_regex.parent = self
                                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"

                                                                                                self.unauth_domain = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                                self.unauth_domain.parent = self
                                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"

                                                                                                self.unauth_domain_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                                self.unauth_domain_regex.parent = self
                                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"

                                                                                                self.vendor_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                                self.vendor_id.parent = self
                                                                                                self._children_name_map["vendor_id"] = "vendor-id"

                                                                                                self.vendor_id_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                                self.vendor_id_regex.parent = self
                                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"

                                                                                                self.access_interface = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                                self.access_interface.parent = self
                                                                                                self._children_name_map["access_interface"] = "access-interface"

                                                                                                self.input_interface = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                                self.input_interface.parent = self
                                                                                                self._children_name_map["input_interface"] = "input-interface"

                                                                                                self.input_intfhdl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                                self.input_intfhdl.parent = self
                                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"

                                                                                                self.ethertype = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                                self.ethertype.parent = self
                                                                                                self._children_name_map["ethertype"] = "ethertype"

                                                                                                self.flow_key_data = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                                self.flow_key_data.parent = self
                                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"

                                                                                                self.dhcp_client_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                                self.dhcp_client_id.parent = self
                                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"

                                                                                                self.dhcp_client_id_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                                self.dhcp_client_id_regex.parent = self
                                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"

                                                                                                self.circuit_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                                self.circuit_id.parent = self
                                                                                                self._children_name_map["circuit_id"] = "circuit-id"

                                                                                                self.circuit_id_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                                self.circuit_id_regex.parent = self
                                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"

                                                                                                self.remote_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                                self.remote_id.parent = self
                                                                                                self._children_name_map["remote_id"] = "remote-id"

                                                                                                self.remote_id_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                                self.remote_id_regex.parent = self
                                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"

                                                                                                self.src_port = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                                self.src_port.parent = self
                                                                                                self._children_name_map["src_port"] = "src-port"

                                                                                                self.dst_port = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                                self.dst_port.parent = self
                                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                                self._segment_path = lambda: "match-data"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['type', 'mpls_top_eos', 'fragment_type', 'authen_status', 'mlp_negotiated'], name, value)


                                                                                            class Ipv4Dscp(Entity):
                                                                                                """
                                                                                                IPv4 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv4-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv6Dscp(Entity):
                                                                                                """
                                                                                                IPv6 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv6-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Dscp(Entity):
                                                                                                """
                                                                                                Match DSCP range array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                    self.yang_name = "dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv4Prec(Entity):
                                                                                                """
                                                                                                IPv4 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                    self.yang_name = "ipv4-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "ipv4-prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                            class Ipv6Prec(Entity):
                                                                                                """
                                                                                                IPv6 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                    self.yang_name = "ipv6-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "ipv6-prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                            class Prec(Entity):
                                                                                                """
                                                                                                Match Precedence array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                    self.yang_name = "prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                            class DiscardClass(Entity):
                                                                                                """
                                                                                                Match Discard Class array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                    self.yang_name = "discard-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "discard-class"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                            class QosGroup(Entity):
                                                                                                """
                                                                                                Match QoS group array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                    self.yang_name = "qos-group"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "qos-group"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "qos-group"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class TrafficClass(Entity):
                                                                                                """
                                                                                                Match Traffic class array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                    self.yang_name = "traffic-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "traffic-class"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "traffic-class"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Proto(Entity):
                                                                                                """
                                                                                                Match Protocol array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                    self.yang_name = "proto"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "proto"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "proto"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class IcmpV4(Entity):
                                                                                                """
                                                                                                Match ICMPV4 Protocol
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                    self.yang_name = "icmp-v4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                    ])
                                                                                                    self.type = None
                                                                                                    self.code = None
                                                                                                    self._segment_path = lambda: "icmp-v4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['type', 'code'], name, value)


                                                                                            class IcmpV6(Entity):
                                                                                                """
                                                                                                Match ICMPV6 Protocol array
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                    self.yang_name = "icmp-v6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                    ])
                                                                                                    self.type = None
                                                                                                    self.code = None
                                                                                                    self._segment_path = lambda: "icmp-v6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['type', 'code'], name, value)


                                                                                            class Ipv4PacketLen(Entity):
                                                                                                """
                                                                                                IPv4 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv6PacketLen(Entity):
                                                                                                """
                                                                                                IPv6 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class PacketLen(Entity):
                                                                                                """
                                                                                                Match packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                    self.yang_name = "packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FlowTag(Entity):
                                                                                                """
                                                                                                Match flow\-tag array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                    self.yang_name = "flow-tag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "flow-tag"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "flow-tag"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class TcpFlag(Entity):
                                                                                                """
                                                                                                Match tcp flag value
                                                                                                
                                                                                                .. attribute:: value
                                                                                                
                                                                                                	Value of TCP flag
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: match_any
                                                                                                
                                                                                                	Match any TCP flag bit
                                                                                                	**type**\: bool
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                    self.yang_name = "tcp-flag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                                        ('match_any', (YLeaf(YType.boolean, 'match-any'), ['bool'])),
                                                                                                    ])
                                                                                                    self.value = None
                                                                                                    self.match_any = None
                                                                                                    self._segment_path = lambda: "tcp-flag"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['value', 'match_any'], name, value)


                                                                                            class Icmpv4Type(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                    self.yang_name = "icmpv4-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv4Code(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                    self.yang_name = "icmpv4-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-code"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv6Type(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                    self.yang_name = "icmpv6-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv6Code(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                    self.yang_name = "icmpv6-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-code"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class MplsExp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental topmost array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "mpls-exp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                            class MplsExpImp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental imposition array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "mpls-exp-imp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                            class MplsDispIpv4Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                            class MplsDispIpv6Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                            class MplsTopLabel(Entity):
                                                                                                """
                                                                                                MPLS Topmost LABEL
                                                                                                
                                                                                                .. attribute:: uint32_rng_array
                                                                                                
                                                                                                	uint32 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                    self.yang_name = "mpls-top-label"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint32_rng_array", ("uint32_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint32_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "mpls-top-label"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                                class Uint32RngArray(Entity):
                                                                                                    """
                                                                                                    uint32 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                        self.yang_name = "uint32_rng_array"
                                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint32, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint32, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint32_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['min', 'max'], name, value)


                                                                                            class Cos(Entity):
                                                                                                """
                                                                                                Match CoS array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                    self.yang_name = "cos"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "cos"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                            class CosInr(Entity):
                                                                                                """
                                                                                                Match inner header CoS
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                    self.yang_name = "cos-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "cos-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                            class Dei(Entity):
                                                                                                """
                                                                                                Match DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                    self.yang_name = "dei"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                    ])
                                                                                                    self.bit_value = None
                                                                                                    self._segment_path = lambda: "dei"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                            class DeiInr(Entity):
                                                                                                """
                                                                                                Match inner DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                    self.yang_name = "dei-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                    ])
                                                                                                    self.bit_value = None
                                                                                                    self._segment_path = lambda: "dei-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                            class Vlan(Entity):
                                                                                                """
                                                                                                Match VLAN array
                                                                                                
                                                                                                .. attribute:: vlan_id_array
                                                                                                
                                                                                                	vlan id array
                                                                                                	**type**\: list of  		 :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                    self.yang_name = "vlan"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("vlan-id-array", ("vlan_id_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.vlan_id_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                                class VlanIdArray(Entity):
                                                                                                    """
                                                                                                    vlan id array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	VLAN mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                        self.yang_name = "vlan-id-array"
                                                                                                        self.yang_parent_name = "vlan"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ('mask', (YLeaf(YType.uint16, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "vlan-id-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['min', 'max', 'mask'], name, value)


                                                                                            class VlanInr(Entity):
                                                                                                """
                                                                                                Match inner header VLAN range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                    self.yang_name = "vlan-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FrDlci(Entity):
                                                                                                """
                                                                                                Match FR DLCI range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                    self.yang_name = "fr-dlci"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "fr-dlci"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class SrcMac(Entity):
                                                                                                """
                                                                                                Match Source MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                    self.yang_name = "src-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.mac_addr = []
                                                                                                    self.mask = []
                                                                                                    self._segment_path = lambda: "src-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                            class DstMac(Entity):
                                                                                                """
                                                                                                Match Destination MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                    self.yang_name = "dst-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.mac_addr = []
                                                                                                    self.mask = []
                                                                                                    self._segment_path = lambda: "dst-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                            class AtmClp(Entity):
                                                                                                """
                                                                                                Match ATM CLP level
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                    self.yang_name = "atm-clp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "atm-clp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                            class FrDe(Entity):
                                                                                                """
                                                                                                Match FR DE value
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                    self.yang_name = "fr-de"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "fr-de"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                            class Ipv4Acl(Entity):
                                                                                                """
                                                                                                IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                    self.yang_name = "ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ipv4-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                            class Ipv6Acl(Entity):
                                                                                                """
                                                                                                IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                    self.yang_name = "ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ipv6-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                            class EtherServiceAcl(Entity):
                                                                                                """
                                                                                                Ethernet\-Services Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                    self.yang_name = "ether-service-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ether-service-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                            class AvailId(Entity):
                                                                                                """
                                                                                                Available Identifiers
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                    self.yang_name = "avail-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "avail-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                            class MediaType(Entity):
                                                                                                """
                                                                                                Media Type
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                    self.yang_name = "media-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "media-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                            class SubsProtocol(Entity):
                                                                                                """
                                                                                                Protocol
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                    self.yang_name = "subs-protocol"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "subs-protocol"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                            class Dnis(Entity):
                                                                                                """
                                                                                                DNIS
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                    self.yang_name = "dnis"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dnis"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                            class DnisRegex(Entity):
                                                                                                """
                                                                                                DNIS Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                    self.yang_name = "dnis-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dnis-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                            class Domain(Entity):
                                                                                                """
                                                                                                Domain Name
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                    self.yang_name = "domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                        ])
                                                                                                        self.domain_name = None
                                                                                                        self.format_name = None
                                                                                                        self._segment_path = lambda: "domain-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class DomainRegex(Entity):
                                                                                                """
                                                                                                Domain Regular Expression
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                    self.yang_name = "domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain-regex"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                        ])
                                                                                                        self.domain_name = None
                                                                                                        self.format_name = None
                                                                                                        self._segment_path = lambda: "domain-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class NasPort(Entity):
                                                                                                """
                                                                                                NAS Port
                                                                                                
                                                                                                .. attribute:: nas_port_array
                                                                                                
                                                                                                	nas port array
                                                                                                	**type**\: list of  		 :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                    self.yang_name = "nas-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("nas-port-array", ("nas_port_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.nas_port_array = YList(self)
                                                                                                    self._segment_path = lambda: "nas-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                                class NasPortArray(Entity):
                                                                                                    """
                                                                                                    nas port array
                                                                                                    
                                                                                                    .. attribute:: sub_id
                                                                                                    
                                                                                                    	sub id
                                                                                                    	**type**\:  :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                    
                                                                                                    .. attribute:: operator
                                                                                                    
                                                                                                    	operator
                                                                                                    	**type**\:  :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	value
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                        self.yang_name = "nas-port-array"
                                                                                                        self.yang_parent_name = "nas-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('sub_id', (YLeaf(YType.enumeration, 'sub-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchNasPortSubIdEn', '')])),
                                                                                                            ('operator', (YLeaf(YType.enumeration, 'operator'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchLogicalOperatorEn', '')])),
                                                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                                        ])
                                                                                                        self.sub_id = None
                                                                                                        self.operator = None
                                                                                                        self.value = None
                                                                                                        self._segment_path = lambda: "nas-port-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['sub_id', 'operator', 'value'], name, value)


                                                                                            class ServiceName(Entity):
                                                                                                """
                                                                                                Service Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                    self.yang_name = "service-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "service-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                            class ServiceNameRegex(Entity):
                                                                                                """
                                                                                                Service Name Regular Exp
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                    self.yang_name = "service-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "service-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                            class SrcAddrIpv4(Entity):
                                                                                                """
                                                                                                Source Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class DstAddrIpv4(Entity):
                                                                                                """
                                                                                                Destination Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class SrcAddrIpv6(Entity):
                                                                                                """
                                                                                                Source Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class DstAddrIpv6(Entity):
                                                                                                """
                                                                                                Destination Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class SrcAddrMac(Entity):
                                                                                                """
                                                                                                Source Address MAC
                                                                                                
                                                                                                .. attribute:: mac_addr_array
                                                                                                
                                                                                                	mac addr array
                                                                                                	**type**\: list of  		 :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                    self.yang_name = "src-addr-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("mac-addr-array", ("mac_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.mac_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                                class MacAddrArray(Entity):
                                                                                                    """
                                                                                                    mac addr array
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                        self.yang_name = "mac-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                            ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.mac_addr = []
                                                                                                        self.mask = []
                                                                                                        self._segment_path = lambda: "mac-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                            class Timer(Entity):
                                                                                                """
                                                                                                Timer
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                    self.yang_name = "timer"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "timer"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                            class TimerRegexp(Entity):
                                                                                                """
                                                                                                Timer Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                    self.yang_name = "timer-regexp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "timer-regexp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                            class TunnelName(Entity):
                                                                                                """
                                                                                                Tunnel Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                    self.yang_name = "tunnel-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "tunnel-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                            class TunnelNameRegex(Entity):
                                                                                                """
                                                                                                Tunnel Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "tunnel-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                            class UserName(Entity):
                                                                                                """
                                                                                                User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                    self.yang_name = "user-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "user-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                            class UserNameRegex(Entity):
                                                                                                """
                                                                                                User Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                    self.yang_name = "user-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "user-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                            class AuthUsername(Entity):
                                                                                                """
                                                                                                Authenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                    self.yang_name = "auth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-username"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                            class AuthUsernameRegex(Entity):
                                                                                                """
                                                                                                Authenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "auth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-username-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                            class UnauthUsername(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                    self.yang_name = "unauth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-username"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                            class UnauthUsernameRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-username-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                            class AuthDomain(Entity):
                                                                                                """
                                                                                                Authenticated domain name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                    self.yang_name = "auth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                            class AuthDomainRegex(Entity):
                                                                                                """
                                                                                                Authenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "auth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                            class UnauthDomain(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                    self.yang_name = "unauth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                            class UnauthDomainRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                            class VendorId(Entity):
                                                                                                """
                                                                                                Vendor ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                    self.yang_name = "vendor-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "vendor-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                            class VendorIdRegex(Entity):
                                                                                                """
                                                                                                Vendor ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                    self.yang_name = "vendor-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "vendor-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                            class AccessInterface(Entity):
                                                                                                """
                                                                                                Access interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                    self.yang_name = "access-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "access-interface"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                            class InputInterface(Entity):
                                                                                                """
                                                                                                Input interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                    self.yang_name = "input-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "input-interface"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                            class InputIntfhdl(Entity):
                                                                                                """
                                                                                                Input interface handle
                                                                                                
                                                                                                .. attribute:: uint64_array
                                                                                                
                                                                                                	uint64 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..18446744073709551615
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                    self.yang_name = "input-intfhdl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint64_array', (YLeafList(YType.uint64, 'uint64_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint64_array = []
                                                                                                    self._segment_path = lambda: "input-intfhdl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                            class Ethertype(Entity):
                                                                                                """
                                                                                                Ethernet type
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                    self.yang_name = "ethertype"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ethertype"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ethertype"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FlowKeyData(Entity):
                                                                                                """
                                                                                                Flow key structure
                                                                                                
                                                                                                .. attribute:: flow_keys
                                                                                                
                                                                                                	flow keys
                                                                                                	**type**\:  :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                                
                                                                                                .. attribute:: max_count
                                                                                                
                                                                                                	Maximum count of flows
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: idle_timeout
                                                                                                
                                                                                                	Idle timeout of flows (in seconds)
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                	**units**\: second
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                    self.yang_name = "flow-key-data"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("flow-keys", ("flow_keys", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys))])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('max_count', (YLeaf(YType.uint16, 'max-count'), ['int'])),
                                                                                                        ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                                                    ])
                                                                                                    self.max_count = None
                                                                                                    self.idle_timeout = None

                                                                                                    self.flow_keys = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                    self.flow_keys.parent = self
                                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                    self._segment_path = lambda: "flow-key-data"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['max_count', 'idle_timeout'], name, value)


                                                                                                class FlowKeys(Entity):
                                                                                                    """
                                                                                                    flow keys
                                                                                                    
                                                                                                    .. attribute:: keys
                                                                                                    
                                                                                                    	keys
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                    
                                                                                                    .. attribute:: num
                                                                                                    
                                                                                                    	num
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                        self.yang_name = "flow-keys"
                                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('keys', (YLeaf(YType.str, 'keys'), ['str'])),
                                                                                                            ('num', (YLeaf(YType.uint8, 'num'), ['int'])),
                                                                                                        ])
                                                                                                        self.keys = None
                                                                                                        self.num = None
                                                                                                        self._segment_path = lambda: "flow-keys"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                            class DhcpClientId(Entity):
                                                                                                """
                                                                                                Dhcp Client ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dhcp-client-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                            class DhcpClientIdRegex(Entity):
                                                                                                """
                                                                                                Dhcp Client ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                            class CircuitId(Entity):
                                                                                                """
                                                                                                Circuit ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                    self.yang_name = "circuit-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "circuit-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                            class CircuitIdRegex(Entity):
                                                                                                """
                                                                                                Circuit ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                    self.yang_name = "circuit-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "circuit-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                            class RemoteId(Entity):
                                                                                                """
                                                                                                Remote ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                    self.yang_name = "remote-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "remote-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                            class RemoteIdRegex(Entity):
                                                                                                """
                                                                                                Remote ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                    self.yang_name = "remote-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "remote-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                            class SrcPort(Entity):
                                                                                                """
                                                                                                Source port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                    self.yang_name = "src-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "src-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class DstPort(Entity):
                                                                                                """
                                                                                                Destination port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                    self.yang_name = "dst-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "dst-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                        class ExcdclassEncode(Entity):
                                                                            """
                                                                            excdclass encode
                                                                            
                                                                            .. attribute:: inline_cmap
                                                                            
                                                                            	inline cmap
                                                                            	**type**\:  :py:class:`InlineCmap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap>`
                                                                            
                                                                            .. attribute:: enc
                                                                            
                                                                            	enc
                                                                            	**type**\:  :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                            
                                                                            .. attribute:: class_name
                                                                            
                                                                            	class name
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..65
                                                                            
                                                                            .. attribute:: hd
                                                                            
                                                                            	hd
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: idx
                                                                            
                                                                            	idx
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode, self).__init__()

                                                                                self.yang_name = "excdclass-encode"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("inline-cmap", ("inline_cmap", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('enc', (YLeaf(YType.enumeration, 'enc'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyObjEncEn', '')])),
                                                                                    ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                                                    ('hd', (YLeaf(YType.uint64, 'hd'), ['int'])),
                                                                                    ('idx', (YLeaf(YType.uint8, 'idx'), ['int'])),
                                                                                ])
                                                                                self.enc = None
                                                                                self.class_name = None
                                                                                self.hd = None
                                                                                self.idx = None

                                                                                self.inline_cmap = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap()
                                                                                self.inline_cmap.parent = self
                                                                                self._children_name_map["inline_cmap"] = "inline-cmap"
                                                                                self._segment_path = lambda: "excdclass-encode"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode, ['enc', 'class_name', 'hd', 'idx'], name, value)


                                                                            class InlineCmap(Entity):
                                                                                """
                                                                                inline cmap
                                                                                
                                                                                .. attribute:: match_infop
                                                                                
                                                                                	Pointer to the first Match info
                                                                                	**type**\:  :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop>`
                                                                                
                                                                                .. attribute:: mode
                                                                                
                                                                                	Inline Class\-Map Mode Match any/all
                                                                                	**type**\:  :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                                
                                                                                .. attribute:: flags
                                                                                
                                                                                	Inline Class\-Map flags
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: match_count
                                                                                
                                                                                	Number of Match infos
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap, self).__init__()

                                                                                    self.yang_name = "inline-cmap"
                                                                                    self.yang_parent_name = "excdclass-encode"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("match-infop", ("match_infop", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapModeEn', '')])),
                                                                                        ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                        ('match_count', (YLeaf(YType.uint32, 'match-count'), ['int'])),
                                                                                    ])
                                                                                    self.mode = None
                                                                                    self.flags = None
                                                                                    self.match_count = None

                                                                                    self.match_infop = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop()
                                                                                    self.match_infop.parent = self
                                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                                    self._segment_path = lambda: "inline-cmap"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap, ['mode', 'flags', 'match_count'], name, value)


                                                                                class MatchInfop(Entity):
                                                                                    """
                                                                                    Pointer to the first Match info
                                                                                    
                                                                                    .. attribute:: class_match_info_st
                                                                                    
                                                                                    	class match info st
                                                                                    	**type**\: list of  		 :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop, self).__init__()

                                                                                        self.yang_name = "match-infop"
                                                                                        self.yang_parent_name = "inline-cmap"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("class-match-info-st", ("class_match_info_st", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.class_match_info_st = YList(self)
                                                                                        self._segment_path = lambda: "match-infop"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop, [], name, value)


                                                                                    class ClassMatchInfoSt(Entity):
                                                                                        """
                                                                                        class match info st
                                                                                        
                                                                                        .. attribute:: match_data
                                                                                        
                                                                                        	Match criteria
                                                                                        	**type**\:  :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                        
                                                                                        .. attribute:: flags
                                                                                        
                                                                                        	Flags
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                            self.yang_name = "class-match-info-st"
                                                                                            self.yang_parent_name = "match-infop"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("match-data", ("match_data", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData))])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                            ])
                                                                                            self.flags = None

                                                                                            self.match_data = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                            self.match_data.parent = self
                                                                                            self._children_name_map["match_data"] = "match-data"
                                                                                            self._segment_path = lambda: "class-match-info-st"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                        class MatchData(Entity):
                                                                                            """
                                                                                            Match criteria
                                                                                            
                                                                                            .. attribute:: ipv4_dscp
                                                                                            
                                                                                            	IPv4 DSCP
                                                                                            	**type**\:  :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv6_dscp
                                                                                            
                                                                                            	IPv6 DSCP
                                                                                            	**type**\:  :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                            
                                                                                            .. attribute:: dscp
                                                                                            
                                                                                            	Match DSCP range array
                                                                                            	**type**\:  :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv4_prec
                                                                                            
                                                                                            	IPv4 Precedence
                                                                                            	**type**\:  :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                            
                                                                                            .. attribute:: ipv6_prec
                                                                                            
                                                                                            	IPv6 Precedence
                                                                                            	**type**\:  :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                            
                                                                                            .. attribute:: prec
                                                                                            
                                                                                            	Match Precedence array
                                                                                            	**type**\:  :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                            
                                                                                            .. attribute:: discard_class
                                                                                            
                                                                                            	Match Discard Class array
                                                                                            	**type**\:  :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                            
                                                                                            .. attribute:: qos_group
                                                                                            
                                                                                            	Match QoS group array
                                                                                            	**type**\:  :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                            
                                                                                            .. attribute:: traffic_class
                                                                                            
                                                                                            	Match Traffic class array
                                                                                            	**type**\:  :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                            
                                                                                            .. attribute:: proto
                                                                                            
                                                                                            	Match Protocol array
                                                                                            	**type**\:  :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                            
                                                                                            .. attribute:: icmp_v4
                                                                                            
                                                                                            	Match ICMPV4 Protocol
                                                                                            	**type**\:  :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                            
                                                                                            .. attribute:: icmp_v6
                                                                                            
                                                                                            	Match ICMPV6 Protocol array
                                                                                            	**type**\:  :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                            
                                                                                            .. attribute:: ipv4_packet_len
                                                                                            
                                                                                            	IPv4 packet length array
                                                                                            	**type**\:  :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv6_packet_len
                                                                                            
                                                                                            	IPv6 packet length array
                                                                                            	**type**\:  :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                            
                                                                                            .. attribute:: packet_len
                                                                                            
                                                                                            	Match packet length array
                                                                                            	**type**\:  :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                            
                                                                                            .. attribute:: flow_tag
                                                                                            
                                                                                            	Match flow\-tag array
                                                                                            	**type**\:  :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                            
                                                                                            .. attribute:: tcp_flag
                                                                                            
                                                                                            	Match tcp flag value
                                                                                            	**type**\:  :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                            
                                                                                            .. attribute:: icmpv4_type
                                                                                            
                                                                                            	Match ipv4 icmp type
                                                                                            	**type**\:  :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                            
                                                                                            .. attribute:: icmpv4_code
                                                                                            
                                                                                            	Match ipv4 icmp code
                                                                                            	**type**\:  :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                            
                                                                                            .. attribute:: icmpv6_type
                                                                                            
                                                                                            	Match ipv6 icmp type
                                                                                            	**type**\:  :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                            
                                                                                            .. attribute:: icmpv6_code
                                                                                            
                                                                                            	Match ipv6 icmp code
                                                                                            	**type**\:  :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                            
                                                                                            .. attribute:: mpls_exp
                                                                                            
                                                                                            	Match MPLS experimental topmost array
                                                                                            	**type**\:  :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                            
                                                                                            .. attribute:: mpls_exp_imp
                                                                                            
                                                                                            	Match MPLS experimental imposition array
                                                                                            	**type**\:  :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                                            
                                                                                            	MPLS Disposition IPv4 Access\-list
                                                                                            	**type**\:  :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                                            
                                                                                            	MPLS Disposition IPv6 Access\-list
                                                                                            	**type**\:  :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_top_label
                                                                                            
                                                                                            	MPLS Topmost LABEL
                                                                                            	**type**\:  :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                            
                                                                                            .. attribute:: cos
                                                                                            
                                                                                            	Match CoS array
                                                                                            	**type**\:  :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                            
                                                                                            .. attribute:: cos_inr
                                                                                            
                                                                                            	Match inner header CoS
                                                                                            	**type**\:  :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                            
                                                                                            .. attribute:: dei
                                                                                            
                                                                                            	Match DEI Bit
                                                                                            	**type**\:  :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                            
                                                                                            .. attribute:: dei_inr
                                                                                            
                                                                                            	Match inner DEI Bit
                                                                                            	**type**\:  :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                            
                                                                                            .. attribute:: vlan
                                                                                            
                                                                                            	Match VLAN array
                                                                                            	**type**\:  :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                            
                                                                                            .. attribute:: vlan_inr
                                                                                            
                                                                                            	Match inner header VLAN range array
                                                                                            	**type**\:  :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                            
                                                                                            .. attribute:: fr_dlci
                                                                                            
                                                                                            	Match FR DLCI range array
                                                                                            	**type**\:  :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                            
                                                                                            .. attribute:: src_mac
                                                                                            
                                                                                            	Match Source MAC address
                                                                                            	**type**\:  :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                            
                                                                                            .. attribute:: dst_mac
                                                                                            
                                                                                            	Match Destination MAC address
                                                                                            	**type**\:  :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                            
                                                                                            .. attribute:: atm_clp
                                                                                            
                                                                                            	Match ATM CLP level
                                                                                            	**type**\:  :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                            
                                                                                            .. attribute:: fr_de
                                                                                            
                                                                                            	Match FR DE value
                                                                                            	**type**\:  :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                            
                                                                                            .. attribute:: ipv4_acl
                                                                                            
                                                                                            	IPv4 Access\-list
                                                                                            	**type**\:  :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                            
                                                                                            .. attribute:: ipv6_acl
                                                                                            
                                                                                            	IPv6 Access\-list
                                                                                            	**type**\:  :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                            
                                                                                            .. attribute:: ether_service_acl
                                                                                            
                                                                                            	Ethernet\-Services Access\-list
                                                                                            	**type**\:  :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                            
                                                                                            .. attribute:: avail_id
                                                                                            
                                                                                            	Available Identifiers
                                                                                            	**type**\:  :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                            
                                                                                            .. attribute:: media_type
                                                                                            
                                                                                            	Media Type
                                                                                            	**type**\:  :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                            
                                                                                            .. attribute:: subs_protocol
                                                                                            
                                                                                            	Protocol
                                                                                            	**type**\:  :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                            
                                                                                            .. attribute:: dnis
                                                                                            
                                                                                            	DNIS
                                                                                            	**type**\:  :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                            
                                                                                            .. attribute:: dnis_regex
                                                                                            
                                                                                            	DNIS Regular Expression
                                                                                            	**type**\:  :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                            
                                                                                            .. attribute:: domain
                                                                                            
                                                                                            	Domain Name
                                                                                            	**type**\:  :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                            
                                                                                            .. attribute:: domain_regex
                                                                                            
                                                                                            	Domain Regular Expression
                                                                                            	**type**\:  :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                            
                                                                                            .. attribute:: nas_port
                                                                                            
                                                                                            	NAS Port
                                                                                            	**type**\:  :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                            
                                                                                            .. attribute:: service_name
                                                                                            
                                                                                            	Service Name
                                                                                            	**type**\:  :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                            
                                                                                            .. attribute:: service_name_regex
                                                                                            
                                                                                            	Service Name Regular Exp
                                                                                            	**type**\:  :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv4
                                                                                            
                                                                                            	Source Address IPV4
                                                                                            	**type**\:  :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv4
                                                                                            
                                                                                            	Destination Address IPV4
                                                                                            	**type**\:  :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv6
                                                                                            
                                                                                            	Source Address IPV6
                                                                                            	**type**\:  :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv6
                                                                                            
                                                                                            	Destination Address IPV6
                                                                                            	**type**\:  :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: src_addr_mac
                                                                                            
                                                                                            	Source Address MAC
                                                                                            	**type**\:  :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                            
                                                                                            .. attribute:: timer
                                                                                            
                                                                                            	Timer
                                                                                            	**type**\:  :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                            
                                                                                            .. attribute:: timer_regexp
                                                                                            
                                                                                            	Timer Regular Expression
                                                                                            	**type**\:  :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                            
                                                                                            .. attribute:: tunnel_name
                                                                                            
                                                                                            	Tunnel Name
                                                                                            	**type**\:  :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                            
                                                                                            .. attribute:: tunnel_name_regex
                                                                                            
                                                                                            	Tunnel Name Regular Expression
                                                                                            	**type**\:  :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                            
                                                                                            .. attribute:: user_name
                                                                                            
                                                                                            	User Name
                                                                                            	**type**\:  :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                            
                                                                                            .. attribute:: user_name_regex
                                                                                            
                                                                                            	User Name Regular Expression
                                                                                            	**type**\:  :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                            
                                                                                            .. attribute:: auth_username
                                                                                            
                                                                                            	Authenticated User Name
                                                                                            	**type**\:  :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                            
                                                                                            .. attribute:: auth_username_regex
                                                                                            
                                                                                            	Authenticated User Name RegEx
                                                                                            	**type**\:  :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_username
                                                                                            
                                                                                            	Unauthenticated User Name
                                                                                            	**type**\:  :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                            
                                                                                            .. attribute:: unauth_username_regex
                                                                                            
                                                                                            	Unauthenticated User Name RegEx
                                                                                            	**type**\:  :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: auth_domain
                                                                                            
                                                                                            	Authenticated domain name
                                                                                            	**type**\:  :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                            
                                                                                            .. attribute:: auth_domain_regex
                                                                                            
                                                                                            	Authenticated Domain Name RegEx
                                                                                            	**type**\:  :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_domain
                                                                                            
                                                                                            	Unauthenticated Domain Name
                                                                                            	**type**\:  :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                            
                                                                                            .. attribute:: unauth_domain_regex
                                                                                            
                                                                                            	Unauthenticated Domain Name RegEx
                                                                                            	**type**\:  :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: vendor_id
                                                                                            
                                                                                            	Vendor ID
                                                                                            	**type**\:  :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                            
                                                                                            .. attribute:: vendor_id_regex
                                                                                            
                                                                                            	Vendor ID RegEx
                                                                                            	**type**\:  :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                            
                                                                                            .. attribute:: access_interface
                                                                                            
                                                                                            	Access interface
                                                                                            	**type**\:  :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                            
                                                                                            .. attribute:: input_interface
                                                                                            
                                                                                            	Input interface
                                                                                            	**type**\:  :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                            
                                                                                            .. attribute:: input_intfhdl
                                                                                            
                                                                                            	Input interface handle
                                                                                            	**type**\:  :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                            
                                                                                            .. attribute:: ethertype
                                                                                            
                                                                                            	Ethernet type
                                                                                            	**type**\:  :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                            
                                                                                            .. attribute:: flow_key_data
                                                                                            
                                                                                            	Flow key structure
                                                                                            	**type**\:  :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id
                                                                                            
                                                                                            	Dhcp Client ID
                                                                                            	**type**\:  :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id_regex
                                                                                            
                                                                                            	Dhcp Client ID RegEx
                                                                                            	**type**\:  :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                            
                                                                                            .. attribute:: circuit_id
                                                                                            
                                                                                            	Circuit ID
                                                                                            	**type**\:  :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                            
                                                                                            .. attribute:: circuit_id_regex
                                                                                            
                                                                                            	Circuit ID RegEx
                                                                                            	**type**\:  :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                            
                                                                                            .. attribute:: remote_id
                                                                                            
                                                                                            	Remote ID
                                                                                            	**type**\:  :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                            
                                                                                            .. attribute:: remote_id_regex
                                                                                            
                                                                                            	Remote ID RegEx
                                                                                            	**type**\:  :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                            
                                                                                            .. attribute:: src_port
                                                                                            
                                                                                            	Source port
                                                                                            	**type**\:  :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                            
                                                                                            .. attribute:: dst_port
                                                                                            
                                                                                            	Destination port
                                                                                            	**type**\:  :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	type
                                                                                            	**type**\:  :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                            
                                                                                            .. attribute:: mpls_top_eos
                                                                                            
                                                                                            	MPLS Topmost EOS
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: fragment_type
                                                                                            
                                                                                            	Fragment type
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: authen_status
                                                                                            
                                                                                            	Authentication Status
                                                                                            	**type**\:  :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                            
                                                                                            .. attribute:: mlp_negotiated
                                                                                            
                                                                                            	MLP Negotiated
                                                                                            	**type**\:  :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                                self.yang_name = "match-data"
                                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("ipv4-dscp", ("ipv4_dscp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp)), ("ipv6-dscp", ("ipv6_dscp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp)), ("dscp", ("dscp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp)), ("ipv4-prec", ("ipv4_prec", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec)), ("ipv6-prec", ("ipv6_prec", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec)), ("prec", ("prec", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec)), ("discard-class", ("discard_class", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass)), ("qos-group", ("qos_group", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup)), ("traffic-class", ("traffic_class", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass)), ("proto", ("proto", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto)), ("icmp-v4", ("icmp_v4", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4)), ("icmp-v6", ("icmp_v6", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6)), ("ipv4-packet-len", ("ipv4_packet_len", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen)), ("ipv6-packet-len", ("ipv6_packet_len", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen)), ("packet-len", ("packet_len", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen)), ("flow-tag", ("flow_tag", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag)), ("tcp-flag", ("tcp_flag", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag)), ("icmpv4-type", ("icmpv4_type", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type)), ("icmpv4-code", ("icmpv4_code", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code)), ("icmpv6-type", ("icmpv6_type", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type)), ("icmpv6-code", ("icmpv6_code", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code)), ("mpls-exp", ("mpls_exp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp)), ("mpls-exp-imp", ("mpls_exp_imp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp)), ("mpls-disp-ipv4-acl", ("mpls_disp_ipv4_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl)), ("mpls-disp-ipv6-acl", ("mpls_disp_ipv6_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl)), ("mpls-top-label", ("mpls_top_label", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel)), ("cos", ("cos", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos)), ("cos-inr", ("cos_inr", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr)), ("dei", ("dei", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei)), ("dei-inr", ("dei_inr", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr)), ("vlan", ("vlan", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan)), ("vlan-inr", ("vlan_inr", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)), ("fr-dlci", ("fr_dlci", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci)), ("src-mac", ("src_mac", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac)), ("dst-mac", ("dst_mac", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac)), ("atm-clp", ("atm_clp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp)), ("fr-de", ("fr_de", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe)), ("ipv4-acl", ("ipv4_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl)), ("ipv6-acl", ("ipv6_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl)), ("ether-service-acl", ("ether_service_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl)), ("avail-id", ("avail_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId)), ("media-type", ("media_type", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType)), ("subs-protocol", ("subs_protocol", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol)), ("dnis", ("dnis", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis)), ("dnis-regex", ("dnis_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex)), ("domain", ("domain", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain)), ("domain-regex", ("domain_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex)), ("nas-port", ("nas_port", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort)), ("service-name", ("service_name", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName)), ("service-name-regex", ("service_name_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex)), ("src-addr-ipv4", ("src_addr_ipv4", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4)), ("dst-addr-ipv4", ("dst_addr_ipv4", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4)), ("src-addr-ipv6", ("src_addr_ipv6", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6)), ("dst-addr-ipv6", ("dst_addr_ipv6", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6)), ("src-addr-mac", ("src_addr_mac", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac)), ("timer", ("timer", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer)), ("timer-regexp", ("timer_regexp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp)), ("tunnel-name", ("tunnel_name", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName)), ("tunnel-name-regex", ("tunnel_name_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex)), ("user-name", ("user_name", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName)), ("user-name-regex", ("user_name_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex)), ("auth-username", ("auth_username", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername)), ("auth-username-regex", ("auth_username_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex)), ("unauth-username", ("unauth_username", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername)), ("unauth-username-regex", ("unauth_username_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex)), ("auth-domain", ("auth_domain", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain)), ("auth-domain-regex", ("auth_domain_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex)), ("unauth-domain", ("unauth_domain", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain)), ("unauth-domain-regex", ("unauth_domain_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex)), ("vendor-id", ("vendor_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId)), ("vendor-id-regex", ("vendor_id_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex)), ("access-interface", ("access_interface", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface)), ("input-interface", ("input_interface", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface)), ("input-intfhdl", ("input_intfhdl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl)), ("ethertype", ("ethertype", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype)), ("flow-key-data", ("flow_key_data", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData)), ("dhcp-client-id", ("dhcp_client_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId)), ("dhcp-client-id-regex", ("dhcp_client_id_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex)), ("circuit-id", ("circuit_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId)), ("circuit-id-regex", ("circuit_id_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex)), ("remote-id", ("remote_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId)), ("remote-id-regex", ("remote_id_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex)), ("src-port", ("src_port", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort)), ("dst-port", ("dst_port", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort))])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchTypeEn', '')])),
                                                                                                    ('mpls_top_eos', (YLeaf(YType.uint8, 'mpls-top-eos'), ['int'])),
                                                                                                    ('fragment_type', (YLeaf(YType.uint8, 'fragment-type'), ['int'])),
                                                                                                    ('authen_status', (YLeaf(YType.enumeration, 'authen-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchAuthenStatusEn', '')])),
                                                                                                    ('mlp_negotiated', (YLeaf(YType.enumeration, 'mlp-negotiated'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchMlpNegotiatedEn', '')])),
                                                                                                ])
                                                                                                self.type = None
                                                                                                self.mpls_top_eos = None
                                                                                                self.fragment_type = None
                                                                                                self.authen_status = None
                                                                                                self.mlp_negotiated = None

                                                                                                self.ipv4_dscp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                                self.ipv4_dscp.parent = self
                                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"

                                                                                                self.ipv6_dscp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                                self.ipv6_dscp.parent = self
                                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"

                                                                                                self.dscp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                                self.dscp.parent = self
                                                                                                self._children_name_map["dscp"] = "dscp"

                                                                                                self.ipv4_prec = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                                self.ipv4_prec.parent = self
                                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"

                                                                                                self.ipv6_prec = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                                self.ipv6_prec.parent = self
                                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"

                                                                                                self.prec = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                                self.prec.parent = self
                                                                                                self._children_name_map["prec"] = "prec"

                                                                                                self.discard_class = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                                self.discard_class.parent = self
                                                                                                self._children_name_map["discard_class"] = "discard-class"

                                                                                                self.qos_group = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                                self.qos_group.parent = self
                                                                                                self._children_name_map["qos_group"] = "qos-group"

                                                                                                self.traffic_class = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                                self.traffic_class.parent = self
                                                                                                self._children_name_map["traffic_class"] = "traffic-class"

                                                                                                self.proto = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                                self.proto.parent = self
                                                                                                self._children_name_map["proto"] = "proto"

                                                                                                self.icmp_v4 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                                self.icmp_v4.parent = self
                                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"

                                                                                                self.icmp_v6 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                                self.icmp_v6.parent = self
                                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"

                                                                                                self.ipv4_packet_len = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                                self.ipv4_packet_len.parent = self
                                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"

                                                                                                self.ipv6_packet_len = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                                self.ipv6_packet_len.parent = self
                                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"

                                                                                                self.packet_len = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                                self.packet_len.parent = self
                                                                                                self._children_name_map["packet_len"] = "packet-len"

                                                                                                self.flow_tag = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                                self.flow_tag.parent = self
                                                                                                self._children_name_map["flow_tag"] = "flow-tag"

                                                                                                self.tcp_flag = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                                self.tcp_flag.parent = self
                                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"

                                                                                                self.icmpv4_type = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                                self.icmpv4_type.parent = self
                                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"

                                                                                                self.icmpv4_code = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                                self.icmpv4_code.parent = self
                                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"

                                                                                                self.icmpv6_type = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                                self.icmpv6_type.parent = self
                                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"

                                                                                                self.icmpv6_code = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                                self.icmpv6_code.parent = self
                                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"

                                                                                                self.mpls_exp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                                self.mpls_exp.parent = self
                                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"

                                                                                                self.mpls_exp_imp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                                self.mpls_exp_imp.parent = self
                                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"

                                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"

                                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"

                                                                                                self.mpls_top_label = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                                self.mpls_top_label.parent = self
                                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"

                                                                                                self.cos = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                                self.cos.parent = self
                                                                                                self._children_name_map["cos"] = "cos"

                                                                                                self.cos_inr = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                                self.cos_inr.parent = self
                                                                                                self._children_name_map["cos_inr"] = "cos-inr"

                                                                                                self.dei = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                                self.dei.parent = self
                                                                                                self._children_name_map["dei"] = "dei"

                                                                                                self.dei_inr = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                                self.dei_inr.parent = self
                                                                                                self._children_name_map["dei_inr"] = "dei-inr"

                                                                                                self.vlan = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                                self.vlan.parent = self
                                                                                                self._children_name_map["vlan"] = "vlan"

                                                                                                self.vlan_inr = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                                self.vlan_inr.parent = self
                                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"

                                                                                                self.fr_dlci = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                                self.fr_dlci.parent = self
                                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"

                                                                                                self.src_mac = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                                self.src_mac.parent = self
                                                                                                self._children_name_map["src_mac"] = "src-mac"

                                                                                                self.dst_mac = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                                self.dst_mac.parent = self
                                                                                                self._children_name_map["dst_mac"] = "dst-mac"

                                                                                                self.atm_clp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                                self.atm_clp.parent = self
                                                                                                self._children_name_map["atm_clp"] = "atm-clp"

                                                                                                self.fr_de = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                                self.fr_de.parent = self
                                                                                                self._children_name_map["fr_de"] = "fr-de"

                                                                                                self.ipv4_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                                self.ipv4_acl.parent = self
                                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"

                                                                                                self.ipv6_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                                self.ipv6_acl.parent = self
                                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"

                                                                                                self.ether_service_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                                self.ether_service_acl.parent = self
                                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"

                                                                                                self.avail_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                                self.avail_id.parent = self
                                                                                                self._children_name_map["avail_id"] = "avail-id"

                                                                                                self.media_type = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                                self.media_type.parent = self
                                                                                                self._children_name_map["media_type"] = "media-type"

                                                                                                self.subs_protocol = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                                self.subs_protocol.parent = self
                                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"

                                                                                                self.dnis = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                                self.dnis.parent = self
                                                                                                self._children_name_map["dnis"] = "dnis"

                                                                                                self.dnis_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                                self.dnis_regex.parent = self
                                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"

                                                                                                self.domain = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                                self.domain.parent = self
                                                                                                self._children_name_map["domain"] = "domain"

                                                                                                self.domain_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                                self.domain_regex.parent = self
                                                                                                self._children_name_map["domain_regex"] = "domain-regex"

                                                                                                self.nas_port = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                                self.nas_port.parent = self
                                                                                                self._children_name_map["nas_port"] = "nas-port"

                                                                                                self.service_name = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                                self.service_name.parent = self
                                                                                                self._children_name_map["service_name"] = "service-name"

                                                                                                self.service_name_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                                self.service_name_regex.parent = self
                                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"

                                                                                                self.src_addr_ipv4 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                                self.src_addr_ipv4.parent = self
                                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"

                                                                                                self.dst_addr_ipv4 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                                self.dst_addr_ipv4.parent = self
                                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"

                                                                                                self.src_addr_ipv6 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                                self.src_addr_ipv6.parent = self
                                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"

                                                                                                self.dst_addr_ipv6 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                                self.dst_addr_ipv6.parent = self
                                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"

                                                                                                self.src_addr_mac = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                                self.src_addr_mac.parent = self
                                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"

                                                                                                self.timer = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                                self.timer.parent = self
                                                                                                self._children_name_map["timer"] = "timer"

                                                                                                self.timer_regexp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                                self.timer_regexp.parent = self
                                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"

                                                                                                self.tunnel_name = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                                self.tunnel_name.parent = self
                                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"

                                                                                                self.tunnel_name_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                                self.tunnel_name_regex.parent = self
                                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"

                                                                                                self.user_name = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                                self.user_name.parent = self
                                                                                                self._children_name_map["user_name"] = "user-name"

                                                                                                self.user_name_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                                self.user_name_regex.parent = self
                                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"

                                                                                                self.auth_username = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                                self.auth_username.parent = self
                                                                                                self._children_name_map["auth_username"] = "auth-username"

                                                                                                self.auth_username_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                                self.auth_username_regex.parent = self
                                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"

                                                                                                self.unauth_username = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                                self.unauth_username.parent = self
                                                                                                self._children_name_map["unauth_username"] = "unauth-username"

                                                                                                self.unauth_username_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                                self.unauth_username_regex.parent = self
                                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"

                                                                                                self.auth_domain = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                                self.auth_domain.parent = self
                                                                                                self._children_name_map["auth_domain"] = "auth-domain"

                                                                                                self.auth_domain_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                                self.auth_domain_regex.parent = self
                                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"

                                                                                                self.unauth_domain = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                                self.unauth_domain.parent = self
                                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"

                                                                                                self.unauth_domain_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                                self.unauth_domain_regex.parent = self
                                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"

                                                                                                self.vendor_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                                self.vendor_id.parent = self
                                                                                                self._children_name_map["vendor_id"] = "vendor-id"

                                                                                                self.vendor_id_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                                self.vendor_id_regex.parent = self
                                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"

                                                                                                self.access_interface = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                                self.access_interface.parent = self
                                                                                                self._children_name_map["access_interface"] = "access-interface"

                                                                                                self.input_interface = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                                self.input_interface.parent = self
                                                                                                self._children_name_map["input_interface"] = "input-interface"

                                                                                                self.input_intfhdl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                                self.input_intfhdl.parent = self
                                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"

                                                                                                self.ethertype = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                                self.ethertype.parent = self
                                                                                                self._children_name_map["ethertype"] = "ethertype"

                                                                                                self.flow_key_data = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                                self.flow_key_data.parent = self
                                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"

                                                                                                self.dhcp_client_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                                self.dhcp_client_id.parent = self
                                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"

                                                                                                self.dhcp_client_id_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                                self.dhcp_client_id_regex.parent = self
                                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"

                                                                                                self.circuit_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                                self.circuit_id.parent = self
                                                                                                self._children_name_map["circuit_id"] = "circuit-id"

                                                                                                self.circuit_id_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                                self.circuit_id_regex.parent = self
                                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"

                                                                                                self.remote_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                                self.remote_id.parent = self
                                                                                                self._children_name_map["remote_id"] = "remote-id"

                                                                                                self.remote_id_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                                self.remote_id_regex.parent = self
                                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"

                                                                                                self.src_port = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                                self.src_port.parent = self
                                                                                                self._children_name_map["src_port"] = "src-port"

                                                                                                self.dst_port = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                                self.dst_port.parent = self
                                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                                self._segment_path = lambda: "match-data"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, ['type', 'mpls_top_eos', 'fragment_type', 'authen_status', 'mlp_negotiated'], name, value)


                                                                                            class Ipv4Dscp(Entity):
                                                                                                """
                                                                                                IPv4 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv4-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv6Dscp(Entity):
                                                                                                """
                                                                                                IPv6 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv6-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Dscp(Entity):
                                                                                                """
                                                                                                Match DSCP range array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                    self.yang_name = "dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv4Prec(Entity):
                                                                                                """
                                                                                                IPv4 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                    self.yang_name = "ipv4-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "ipv4-prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                            class Ipv6Prec(Entity):
                                                                                                """
                                                                                                IPv6 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                    self.yang_name = "ipv6-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "ipv6-prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                            class Prec(Entity):
                                                                                                """
                                                                                                Match Precedence array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                    self.yang_name = "prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                            class DiscardClass(Entity):
                                                                                                """
                                                                                                Match Discard Class array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                    self.yang_name = "discard-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "discard-class"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                            class QosGroup(Entity):
                                                                                                """
                                                                                                Match QoS group array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                    self.yang_name = "qos-group"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "qos-group"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "qos-group"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class TrafficClass(Entity):
                                                                                                """
                                                                                                Match Traffic class array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                    self.yang_name = "traffic-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "traffic-class"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "traffic-class"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Proto(Entity):
                                                                                                """
                                                                                                Match Protocol array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                    self.yang_name = "proto"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "proto"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "proto"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class IcmpV4(Entity):
                                                                                                """
                                                                                                Match ICMPV4 Protocol
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                    self.yang_name = "icmp-v4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                    ])
                                                                                                    self.type = None
                                                                                                    self.code = None
                                                                                                    self._segment_path = lambda: "icmp-v4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['type', 'code'], name, value)


                                                                                            class IcmpV6(Entity):
                                                                                                """
                                                                                                Match ICMPV6 Protocol array
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                    self.yang_name = "icmp-v6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                    ])
                                                                                                    self.type = None
                                                                                                    self.code = None
                                                                                                    self._segment_path = lambda: "icmp-v6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['type', 'code'], name, value)


                                                                                            class Ipv4PacketLen(Entity):
                                                                                                """
                                                                                                IPv4 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv6PacketLen(Entity):
                                                                                                """
                                                                                                IPv6 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class PacketLen(Entity):
                                                                                                """
                                                                                                Match packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                    self.yang_name = "packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FlowTag(Entity):
                                                                                                """
                                                                                                Match flow\-tag array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                    self.yang_name = "flow-tag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "flow-tag"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "flow-tag"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class TcpFlag(Entity):
                                                                                                """
                                                                                                Match tcp flag value
                                                                                                
                                                                                                .. attribute:: value
                                                                                                
                                                                                                	Value of TCP flag
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: match_any
                                                                                                
                                                                                                	Match any TCP flag bit
                                                                                                	**type**\: bool
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                    self.yang_name = "tcp-flag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                                        ('match_any', (YLeaf(YType.boolean, 'match-any'), ['bool'])),
                                                                                                    ])
                                                                                                    self.value = None
                                                                                                    self.match_any = None
                                                                                                    self._segment_path = lambda: "tcp-flag"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['value', 'match_any'], name, value)


                                                                                            class Icmpv4Type(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                    self.yang_name = "icmpv4-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv4Code(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                    self.yang_name = "icmpv4-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-code"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv6Type(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                    self.yang_name = "icmpv6-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv6Code(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                    self.yang_name = "icmpv6-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-code"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class MplsExp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental topmost array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "mpls-exp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                            class MplsExpImp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental imposition array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "mpls-exp-imp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                            class MplsDispIpv4Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                            class MplsDispIpv6Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                            class MplsTopLabel(Entity):
                                                                                                """
                                                                                                MPLS Topmost LABEL
                                                                                                
                                                                                                .. attribute:: uint32_rng_array
                                                                                                
                                                                                                	uint32 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                    self.yang_name = "mpls-top-label"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint32_rng_array", ("uint32_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint32_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "mpls-top-label"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                                class Uint32RngArray(Entity):
                                                                                                    """
                                                                                                    uint32 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                        self.yang_name = "uint32_rng_array"
                                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint32, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint32, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint32_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['min', 'max'], name, value)


                                                                                            class Cos(Entity):
                                                                                                """
                                                                                                Match CoS array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                    self.yang_name = "cos"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "cos"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                            class CosInr(Entity):
                                                                                                """
                                                                                                Match inner header CoS
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                    self.yang_name = "cos-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "cos-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                            class Dei(Entity):
                                                                                                """
                                                                                                Match DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                    self.yang_name = "dei"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                    ])
                                                                                                    self.bit_value = None
                                                                                                    self._segment_path = lambda: "dei"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                            class DeiInr(Entity):
                                                                                                """
                                                                                                Match inner DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                    self.yang_name = "dei-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                    ])
                                                                                                    self.bit_value = None
                                                                                                    self._segment_path = lambda: "dei-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                            class Vlan(Entity):
                                                                                                """
                                                                                                Match VLAN array
                                                                                                
                                                                                                .. attribute:: vlan_id_array
                                                                                                
                                                                                                	vlan id array
                                                                                                	**type**\: list of  		 :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                    self.yang_name = "vlan"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("vlan-id-array", ("vlan_id_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.vlan_id_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                                class VlanIdArray(Entity):
                                                                                                    """
                                                                                                    vlan id array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	VLAN mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                        self.yang_name = "vlan-id-array"
                                                                                                        self.yang_parent_name = "vlan"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ('mask', (YLeaf(YType.uint16, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "vlan-id-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['min', 'max', 'mask'], name, value)


                                                                                            class VlanInr(Entity):
                                                                                                """
                                                                                                Match inner header VLAN range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                    self.yang_name = "vlan-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FrDlci(Entity):
                                                                                                """
                                                                                                Match FR DLCI range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                    self.yang_name = "fr-dlci"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "fr-dlci"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class SrcMac(Entity):
                                                                                                """
                                                                                                Match Source MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                    self.yang_name = "src-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.mac_addr = []
                                                                                                    self.mask = []
                                                                                                    self._segment_path = lambda: "src-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                            class DstMac(Entity):
                                                                                                """
                                                                                                Match Destination MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                    self.yang_name = "dst-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.mac_addr = []
                                                                                                    self.mask = []
                                                                                                    self._segment_path = lambda: "dst-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                            class AtmClp(Entity):
                                                                                                """
                                                                                                Match ATM CLP level
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                    self.yang_name = "atm-clp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "atm-clp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                            class FrDe(Entity):
                                                                                                """
                                                                                                Match FR DE value
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                    self.yang_name = "fr-de"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "fr-de"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                            class Ipv4Acl(Entity):
                                                                                                """
                                                                                                IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                    self.yang_name = "ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ipv4-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                            class Ipv6Acl(Entity):
                                                                                                """
                                                                                                IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                    self.yang_name = "ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ipv6-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                            class EtherServiceAcl(Entity):
                                                                                                """
                                                                                                Ethernet\-Services Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                    self.yang_name = "ether-service-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ether-service-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                            class AvailId(Entity):
                                                                                                """
                                                                                                Available Identifiers
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                    self.yang_name = "avail-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "avail-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                            class MediaType(Entity):
                                                                                                """
                                                                                                Media Type
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                    self.yang_name = "media-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "media-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                            class SubsProtocol(Entity):
                                                                                                """
                                                                                                Protocol
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                    self.yang_name = "subs-protocol"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "subs-protocol"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                            class Dnis(Entity):
                                                                                                """
                                                                                                DNIS
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                    self.yang_name = "dnis"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dnis"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                            class DnisRegex(Entity):
                                                                                                """
                                                                                                DNIS Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                    self.yang_name = "dnis-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dnis-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                            class Domain(Entity):
                                                                                                """
                                                                                                Domain Name
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                    self.yang_name = "domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                        ])
                                                                                                        self.domain_name = None
                                                                                                        self.format_name = None
                                                                                                        self._segment_path = lambda: "domain-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class DomainRegex(Entity):
                                                                                                """
                                                                                                Domain Regular Expression
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                    self.yang_name = "domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain-regex"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                        ])
                                                                                                        self.domain_name = None
                                                                                                        self.format_name = None
                                                                                                        self._segment_path = lambda: "domain-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class NasPort(Entity):
                                                                                                """
                                                                                                NAS Port
                                                                                                
                                                                                                .. attribute:: nas_port_array
                                                                                                
                                                                                                	nas port array
                                                                                                	**type**\: list of  		 :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                    self.yang_name = "nas-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("nas-port-array", ("nas_port_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.nas_port_array = YList(self)
                                                                                                    self._segment_path = lambda: "nas-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                                class NasPortArray(Entity):
                                                                                                    """
                                                                                                    nas port array
                                                                                                    
                                                                                                    .. attribute:: sub_id
                                                                                                    
                                                                                                    	sub id
                                                                                                    	**type**\:  :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                    
                                                                                                    .. attribute:: operator
                                                                                                    
                                                                                                    	operator
                                                                                                    	**type**\:  :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	value
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                        self.yang_name = "nas-port-array"
                                                                                                        self.yang_parent_name = "nas-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('sub_id', (YLeaf(YType.enumeration, 'sub-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchNasPortSubIdEn', '')])),
                                                                                                            ('operator', (YLeaf(YType.enumeration, 'operator'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchLogicalOperatorEn', '')])),
                                                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                                        ])
                                                                                                        self.sub_id = None
                                                                                                        self.operator = None
                                                                                                        self.value = None
                                                                                                        self._segment_path = lambda: "nas-port-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['sub_id', 'operator', 'value'], name, value)


                                                                                            class ServiceName(Entity):
                                                                                                """
                                                                                                Service Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                    self.yang_name = "service-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "service-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                            class ServiceNameRegex(Entity):
                                                                                                """
                                                                                                Service Name Regular Exp
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                    self.yang_name = "service-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "service-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                            class SrcAddrIpv4(Entity):
                                                                                                """
                                                                                                Source Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class DstAddrIpv4(Entity):
                                                                                                """
                                                                                                Destination Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class SrcAddrIpv6(Entity):
                                                                                                """
                                                                                                Source Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class DstAddrIpv6(Entity):
                                                                                                """
                                                                                                Destination Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class SrcAddrMac(Entity):
                                                                                                """
                                                                                                Source Address MAC
                                                                                                
                                                                                                .. attribute:: mac_addr_array
                                                                                                
                                                                                                	mac addr array
                                                                                                	**type**\: list of  		 :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                    self.yang_name = "src-addr-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("mac-addr-array", ("mac_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.mac_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                                class MacAddrArray(Entity):
                                                                                                    """
                                                                                                    mac addr array
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                        self.yang_name = "mac-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                            ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.mac_addr = []
                                                                                                        self.mask = []
                                                                                                        self._segment_path = lambda: "mac-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                            class Timer(Entity):
                                                                                                """
                                                                                                Timer
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                    self.yang_name = "timer"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "timer"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                            class TimerRegexp(Entity):
                                                                                                """
                                                                                                Timer Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                    self.yang_name = "timer-regexp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "timer-regexp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                            class TunnelName(Entity):
                                                                                                """
                                                                                                Tunnel Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                    self.yang_name = "tunnel-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "tunnel-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                            class TunnelNameRegex(Entity):
                                                                                                """
                                                                                                Tunnel Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "tunnel-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                            class UserName(Entity):
                                                                                                """
                                                                                                User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                    self.yang_name = "user-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "user-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                            class UserNameRegex(Entity):
                                                                                                """
                                                                                                User Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                    self.yang_name = "user-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "user-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                            class AuthUsername(Entity):
                                                                                                """
                                                                                                Authenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                    self.yang_name = "auth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-username"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                            class AuthUsernameRegex(Entity):
                                                                                                """
                                                                                                Authenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "auth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-username-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                            class UnauthUsername(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                    self.yang_name = "unauth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-username"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                            class UnauthUsernameRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-username-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                            class AuthDomain(Entity):
                                                                                                """
                                                                                                Authenticated domain name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                    self.yang_name = "auth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                            class AuthDomainRegex(Entity):
                                                                                                """
                                                                                                Authenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "auth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                            class UnauthDomain(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                    self.yang_name = "unauth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                            class UnauthDomainRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                            class VendorId(Entity):
                                                                                                """
                                                                                                Vendor ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                    self.yang_name = "vendor-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "vendor-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                            class VendorIdRegex(Entity):
                                                                                                """
                                                                                                Vendor ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                    self.yang_name = "vendor-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "vendor-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                            class AccessInterface(Entity):
                                                                                                """
                                                                                                Access interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                    self.yang_name = "access-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "access-interface"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                            class InputInterface(Entity):
                                                                                                """
                                                                                                Input interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                    self.yang_name = "input-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "input-interface"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                            class InputIntfhdl(Entity):
                                                                                                """
                                                                                                Input interface handle
                                                                                                
                                                                                                .. attribute:: uint64_array
                                                                                                
                                                                                                	uint64 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..18446744073709551615
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                    self.yang_name = "input-intfhdl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint64_array', (YLeafList(YType.uint64, 'uint64_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint64_array = []
                                                                                                    self._segment_path = lambda: "input-intfhdl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                            class Ethertype(Entity):
                                                                                                """
                                                                                                Ethernet type
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                    self.yang_name = "ethertype"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ethertype"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ethertype"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FlowKeyData(Entity):
                                                                                                """
                                                                                                Flow key structure
                                                                                                
                                                                                                .. attribute:: flow_keys
                                                                                                
                                                                                                	flow keys
                                                                                                	**type**\:  :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                                
                                                                                                .. attribute:: max_count
                                                                                                
                                                                                                	Maximum count of flows
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: idle_timeout
                                                                                                
                                                                                                	Idle timeout of flows (in seconds)
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                	**units**\: second
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                    self.yang_name = "flow-key-data"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("flow-keys", ("flow_keys", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys))])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('max_count', (YLeaf(YType.uint16, 'max-count'), ['int'])),
                                                                                                        ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                                                    ])
                                                                                                    self.max_count = None
                                                                                                    self.idle_timeout = None

                                                                                                    self.flow_keys = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                    self.flow_keys.parent = self
                                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                    self._segment_path = lambda: "flow-key-data"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['max_count', 'idle_timeout'], name, value)


                                                                                                class FlowKeys(Entity):
                                                                                                    """
                                                                                                    flow keys
                                                                                                    
                                                                                                    .. attribute:: keys
                                                                                                    
                                                                                                    	keys
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                    
                                                                                                    .. attribute:: num
                                                                                                    
                                                                                                    	num
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                        self.yang_name = "flow-keys"
                                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('keys', (YLeaf(YType.str, 'keys'), ['str'])),
                                                                                                            ('num', (YLeaf(YType.uint8, 'num'), ['int'])),
                                                                                                        ])
                                                                                                        self.keys = None
                                                                                                        self.num = None
                                                                                                        self._segment_path = lambda: "flow-keys"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                            class DhcpClientId(Entity):
                                                                                                """
                                                                                                Dhcp Client ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dhcp-client-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                            class DhcpClientIdRegex(Entity):
                                                                                                """
                                                                                                Dhcp Client ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                            class CircuitId(Entity):
                                                                                                """
                                                                                                Circuit ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                    self.yang_name = "circuit-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "circuit-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                            class CircuitIdRegex(Entity):
                                                                                                """
                                                                                                Circuit ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                    self.yang_name = "circuit-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "circuit-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                            class RemoteId(Entity):
                                                                                                """
                                                                                                Remote ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                    self.yang_name = "remote-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "remote-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                            class RemoteIdRegex(Entity):
                                                                                                """
                                                                                                Remote ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                    self.yang_name = "remote-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "remote-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                            class SrcPort(Entity):
                                                                                                """
                                                                                                Source port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                    self.yang_name = "src-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "src-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class DstPort(Entity):
                                                                                                """
                                                                                                Destination port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                    self.yang_name = "dst-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "dst-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                        class ExcdclassP(Entity):
                                                                            """
                                                                            excdclass p
                                                                            
                                                                            .. attribute:: class_map_bg
                                                                            
                                                                            	class map bg
                                                                            	**type**\: list of  		 :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP, self).__init__()

                                                                                self.yang_name = "excdclass-p"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("class-map-bg", ("class_map_bg", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg))])
                                                                                self._leafs = OrderedDict()

                                                                                self.class_map_bg = YList(self)
                                                                                self._segment_path = lambda: "excdclass-p"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP, [], name, value)


                                                                            class ClassMapBg(Entity):
                                                                                """
                                                                                class map bg
                                                                                
                                                                                .. attribute:: match_infop
                                                                                
                                                                                	Pointer to the first Match info
                                                                                	**type**\:  :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop>`
                                                                                
                                                                                .. attribute:: name
                                                                                
                                                                                	Name of the class\-map
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..65
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Class\-Map Type QoS/PBR/Netflow/..
                                                                                	**type**\:  :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                                                
                                                                                .. attribute:: mode
                                                                                
                                                                                	Class\-Map Mode Match any/Match all
                                                                                	**type**\:  :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                                
                                                                                .. attribute:: description
                                                                                
                                                                                	description
                                                                                	**type**\: str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg, self).__init__()

                                                                                    self.yang_name = "class-map-bg"
                                                                                    self.yang_parent_name = "excdclass-p"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("match-infop", ("match_infop", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapTypeEn', '')])),
                                                                                        ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapModeEn', '')])),
                                                                                        ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                    ])
                                                                                    self.name = None
                                                                                    self.type = None
                                                                                    self.mode = None
                                                                                    self.description = None

                                                                                    self.match_infop = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop()
                                                                                    self.match_infop.parent = self
                                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                                    self._segment_path = lambda: "class-map-bg"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg, ['name', 'type', 'mode', 'description'], name, value)


                                                                                class MatchInfop(Entity):
                                                                                    """
                                                                                    Pointer to the first Match info
                                                                                    
                                                                                    .. attribute:: class_match_info_st
                                                                                    
                                                                                    	class match info st
                                                                                    	**type**\: list of  		 :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop, self).__init__()

                                                                                        self.yang_name = "match-infop"
                                                                                        self.yang_parent_name = "class-map-bg"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("class-match-info-st", ("class_match_info_st", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.class_match_info_st = YList(self)
                                                                                        self._segment_path = lambda: "match-infop"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop, [], name, value)


                                                                                    class ClassMatchInfoSt(Entity):
                                                                                        """
                                                                                        class match info st
                                                                                        
                                                                                        .. attribute:: match_data
                                                                                        
                                                                                        	Match criteria
                                                                                        	**type**\:  :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                        
                                                                                        .. attribute:: flags
                                                                                        
                                                                                        	Flags
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                            self.yang_name = "class-match-info-st"
                                                                                            self.yang_parent_name = "match-infop"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("match-data", ("match_data", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData))])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                            ])
                                                                                            self.flags = None

                                                                                            self.match_data = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                            self.match_data.parent = self
                                                                                            self._children_name_map["match_data"] = "match-data"
                                                                                            self._segment_path = lambda: "class-match-info-st"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                        class MatchData(Entity):
                                                                                            """
                                                                                            Match criteria
                                                                                            
                                                                                            .. attribute:: ipv4_dscp
                                                                                            
                                                                                            	IPv4 DSCP
                                                                                            	**type**\:  :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv6_dscp
                                                                                            
                                                                                            	IPv6 DSCP
                                                                                            	**type**\:  :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                            
                                                                                            .. attribute:: dscp
                                                                                            
                                                                                            	Match DSCP range array
                                                                                            	**type**\:  :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv4_prec
                                                                                            
                                                                                            	IPv4 Precedence
                                                                                            	**type**\:  :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                            
                                                                                            .. attribute:: ipv6_prec
                                                                                            
                                                                                            	IPv6 Precedence
                                                                                            	**type**\:  :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                            
                                                                                            .. attribute:: prec
                                                                                            
                                                                                            	Match Precedence array
                                                                                            	**type**\:  :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                            
                                                                                            .. attribute:: discard_class
                                                                                            
                                                                                            	Match Discard Class array
                                                                                            	**type**\:  :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                            
                                                                                            .. attribute:: qos_group
                                                                                            
                                                                                            	Match QoS group array
                                                                                            	**type**\:  :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                            
                                                                                            .. attribute:: traffic_class
                                                                                            
                                                                                            	Match Traffic class array
                                                                                            	**type**\:  :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                            
                                                                                            .. attribute:: proto
                                                                                            
                                                                                            	Match Protocol array
                                                                                            	**type**\:  :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                            
                                                                                            .. attribute:: icmp_v4
                                                                                            
                                                                                            	Match ICMPV4 Protocol
                                                                                            	**type**\:  :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                            
                                                                                            .. attribute:: icmp_v6
                                                                                            
                                                                                            	Match ICMPV6 Protocol array
                                                                                            	**type**\:  :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                            
                                                                                            .. attribute:: ipv4_packet_len
                                                                                            
                                                                                            	IPv4 packet length array
                                                                                            	**type**\:  :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv6_packet_len
                                                                                            
                                                                                            	IPv6 packet length array
                                                                                            	**type**\:  :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                            
                                                                                            .. attribute:: packet_len
                                                                                            
                                                                                            	Match packet length array
                                                                                            	**type**\:  :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                            
                                                                                            .. attribute:: flow_tag
                                                                                            
                                                                                            	Match flow\-tag array
                                                                                            	**type**\:  :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                            
                                                                                            .. attribute:: tcp_flag
                                                                                            
                                                                                            	Match tcp flag value
                                                                                            	**type**\:  :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                            
                                                                                            .. attribute:: icmpv4_type
                                                                                            
                                                                                            	Match ipv4 icmp type
                                                                                            	**type**\:  :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                            
                                                                                            .. attribute:: icmpv4_code
                                                                                            
                                                                                            	Match ipv4 icmp code
                                                                                            	**type**\:  :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                            
                                                                                            .. attribute:: icmpv6_type
                                                                                            
                                                                                            	Match ipv6 icmp type
                                                                                            	**type**\:  :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                            
                                                                                            .. attribute:: icmpv6_code
                                                                                            
                                                                                            	Match ipv6 icmp code
                                                                                            	**type**\:  :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                            
                                                                                            .. attribute:: mpls_exp
                                                                                            
                                                                                            	Match MPLS experimental topmost array
                                                                                            	**type**\:  :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                            
                                                                                            .. attribute:: mpls_exp_imp
                                                                                            
                                                                                            	Match MPLS experimental imposition array
                                                                                            	**type**\:  :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                                            
                                                                                            	MPLS Disposition IPv4 Access\-list
                                                                                            	**type**\:  :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                                            
                                                                                            	MPLS Disposition IPv6 Access\-list
                                                                                            	**type**\:  :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_top_label
                                                                                            
                                                                                            	MPLS Topmost LABEL
                                                                                            	**type**\:  :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                            
                                                                                            .. attribute:: cos
                                                                                            
                                                                                            	Match CoS array
                                                                                            	**type**\:  :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                            
                                                                                            .. attribute:: cos_inr
                                                                                            
                                                                                            	Match inner header CoS
                                                                                            	**type**\:  :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                            
                                                                                            .. attribute:: dei
                                                                                            
                                                                                            	Match DEI Bit
                                                                                            	**type**\:  :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                            
                                                                                            .. attribute:: dei_inr
                                                                                            
                                                                                            	Match inner DEI Bit
                                                                                            	**type**\:  :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                            
                                                                                            .. attribute:: vlan
                                                                                            
                                                                                            	Match VLAN array
                                                                                            	**type**\:  :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                            
                                                                                            .. attribute:: vlan_inr
                                                                                            
                                                                                            	Match inner header VLAN range array
                                                                                            	**type**\:  :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                            
                                                                                            .. attribute:: fr_dlci
                                                                                            
                                                                                            	Match FR DLCI range array
                                                                                            	**type**\:  :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                            
                                                                                            .. attribute:: src_mac
                                                                                            
                                                                                            	Match Source MAC address
                                                                                            	**type**\:  :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                            
                                                                                            .. attribute:: dst_mac
                                                                                            
                                                                                            	Match Destination MAC address
                                                                                            	**type**\:  :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                            
                                                                                            .. attribute:: atm_clp
                                                                                            
                                                                                            	Match ATM CLP level
                                                                                            	**type**\:  :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                            
                                                                                            .. attribute:: fr_de
                                                                                            
                                                                                            	Match FR DE value
                                                                                            	**type**\:  :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                            
                                                                                            .. attribute:: ipv4_acl
                                                                                            
                                                                                            	IPv4 Access\-list
                                                                                            	**type**\:  :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                            
                                                                                            .. attribute:: ipv6_acl
                                                                                            
                                                                                            	IPv6 Access\-list
                                                                                            	**type**\:  :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                            
                                                                                            .. attribute:: ether_service_acl
                                                                                            
                                                                                            	Ethernet\-Services Access\-list
                                                                                            	**type**\:  :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                            
                                                                                            .. attribute:: avail_id
                                                                                            
                                                                                            	Available Identifiers
                                                                                            	**type**\:  :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                            
                                                                                            .. attribute:: media_type
                                                                                            
                                                                                            	Media Type
                                                                                            	**type**\:  :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                            
                                                                                            .. attribute:: subs_protocol
                                                                                            
                                                                                            	Protocol
                                                                                            	**type**\:  :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                            
                                                                                            .. attribute:: dnis
                                                                                            
                                                                                            	DNIS
                                                                                            	**type**\:  :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                            
                                                                                            .. attribute:: dnis_regex
                                                                                            
                                                                                            	DNIS Regular Expression
                                                                                            	**type**\:  :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                            
                                                                                            .. attribute:: domain
                                                                                            
                                                                                            	Domain Name
                                                                                            	**type**\:  :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                            
                                                                                            .. attribute:: domain_regex
                                                                                            
                                                                                            	Domain Regular Expression
                                                                                            	**type**\:  :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                            
                                                                                            .. attribute:: nas_port
                                                                                            
                                                                                            	NAS Port
                                                                                            	**type**\:  :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                            
                                                                                            .. attribute:: service_name
                                                                                            
                                                                                            	Service Name
                                                                                            	**type**\:  :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                            
                                                                                            .. attribute:: service_name_regex
                                                                                            
                                                                                            	Service Name Regular Exp
                                                                                            	**type**\:  :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv4
                                                                                            
                                                                                            	Source Address IPV4
                                                                                            	**type**\:  :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv4
                                                                                            
                                                                                            	Destination Address IPV4
                                                                                            	**type**\:  :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv6
                                                                                            
                                                                                            	Source Address IPV6
                                                                                            	**type**\:  :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv6
                                                                                            
                                                                                            	Destination Address IPV6
                                                                                            	**type**\:  :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: src_addr_mac
                                                                                            
                                                                                            	Source Address MAC
                                                                                            	**type**\:  :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                            
                                                                                            .. attribute:: timer
                                                                                            
                                                                                            	Timer
                                                                                            	**type**\:  :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                            
                                                                                            .. attribute:: timer_regexp
                                                                                            
                                                                                            	Timer Regular Expression
                                                                                            	**type**\:  :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                            
                                                                                            .. attribute:: tunnel_name
                                                                                            
                                                                                            	Tunnel Name
                                                                                            	**type**\:  :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                            
                                                                                            .. attribute:: tunnel_name_regex
                                                                                            
                                                                                            	Tunnel Name Regular Expression
                                                                                            	**type**\:  :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                            
                                                                                            .. attribute:: user_name
                                                                                            
                                                                                            	User Name
                                                                                            	**type**\:  :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                            
                                                                                            .. attribute:: user_name_regex
                                                                                            
                                                                                            	User Name Regular Expression
                                                                                            	**type**\:  :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                            
                                                                                            .. attribute:: auth_username
                                                                                            
                                                                                            	Authenticated User Name
                                                                                            	**type**\:  :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                            
                                                                                            .. attribute:: auth_username_regex
                                                                                            
                                                                                            	Authenticated User Name RegEx
                                                                                            	**type**\:  :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_username
                                                                                            
                                                                                            	Unauthenticated User Name
                                                                                            	**type**\:  :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                            
                                                                                            .. attribute:: unauth_username_regex
                                                                                            
                                                                                            	Unauthenticated User Name RegEx
                                                                                            	**type**\:  :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: auth_domain
                                                                                            
                                                                                            	Authenticated domain name
                                                                                            	**type**\:  :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                            
                                                                                            .. attribute:: auth_domain_regex
                                                                                            
                                                                                            	Authenticated Domain Name RegEx
                                                                                            	**type**\:  :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_domain
                                                                                            
                                                                                            	Unauthenticated Domain Name
                                                                                            	**type**\:  :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                            
                                                                                            .. attribute:: unauth_domain_regex
                                                                                            
                                                                                            	Unauthenticated Domain Name RegEx
                                                                                            	**type**\:  :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: vendor_id
                                                                                            
                                                                                            	Vendor ID
                                                                                            	**type**\:  :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                            
                                                                                            .. attribute:: vendor_id_regex
                                                                                            
                                                                                            	Vendor ID RegEx
                                                                                            	**type**\:  :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                            
                                                                                            .. attribute:: access_interface
                                                                                            
                                                                                            	Access interface
                                                                                            	**type**\:  :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                            
                                                                                            .. attribute:: input_interface
                                                                                            
                                                                                            	Input interface
                                                                                            	**type**\:  :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                            
                                                                                            .. attribute:: input_intfhdl
                                                                                            
                                                                                            	Input interface handle
                                                                                            	**type**\:  :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                            
                                                                                            .. attribute:: ethertype
                                                                                            
                                                                                            	Ethernet type
                                                                                            	**type**\:  :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                            
                                                                                            .. attribute:: flow_key_data
                                                                                            
                                                                                            	Flow key structure
                                                                                            	**type**\:  :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id
                                                                                            
                                                                                            	Dhcp Client ID
                                                                                            	**type**\:  :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id_regex
                                                                                            
                                                                                            	Dhcp Client ID RegEx
                                                                                            	**type**\:  :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                            
                                                                                            .. attribute:: circuit_id
                                                                                            
                                                                                            	Circuit ID
                                                                                            	**type**\:  :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                            
                                                                                            .. attribute:: circuit_id_regex
                                                                                            
                                                                                            	Circuit ID RegEx
                                                                                            	**type**\:  :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                            
                                                                                            .. attribute:: remote_id
                                                                                            
                                                                                            	Remote ID
                                                                                            	**type**\:  :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                            
                                                                                            .. attribute:: remote_id_regex
                                                                                            
                                                                                            	Remote ID RegEx
                                                                                            	**type**\:  :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                            
                                                                                            .. attribute:: src_port
                                                                                            
                                                                                            	Source port
                                                                                            	**type**\:  :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                            
                                                                                            .. attribute:: dst_port
                                                                                            
                                                                                            	Destination port
                                                                                            	**type**\:  :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	type
                                                                                            	**type**\:  :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                            
                                                                                            .. attribute:: mpls_top_eos
                                                                                            
                                                                                            	MPLS Topmost EOS
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: fragment_type
                                                                                            
                                                                                            	Fragment type
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: authen_status
                                                                                            
                                                                                            	Authentication Status
                                                                                            	**type**\:  :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                            
                                                                                            .. attribute:: mlp_negotiated
                                                                                            
                                                                                            	MLP Negotiated
                                                                                            	**type**\:  :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                                self.yang_name = "match-data"
                                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("ipv4-dscp", ("ipv4_dscp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp)), ("ipv6-dscp", ("ipv6_dscp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp)), ("dscp", ("dscp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp)), ("ipv4-prec", ("ipv4_prec", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec)), ("ipv6-prec", ("ipv6_prec", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec)), ("prec", ("prec", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec)), ("discard-class", ("discard_class", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass)), ("qos-group", ("qos_group", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup)), ("traffic-class", ("traffic_class", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass)), ("proto", ("proto", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto)), ("icmp-v4", ("icmp_v4", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4)), ("icmp-v6", ("icmp_v6", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6)), ("ipv4-packet-len", ("ipv4_packet_len", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen)), ("ipv6-packet-len", ("ipv6_packet_len", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen)), ("packet-len", ("packet_len", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen)), ("flow-tag", ("flow_tag", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag)), ("tcp-flag", ("tcp_flag", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag)), ("icmpv4-type", ("icmpv4_type", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type)), ("icmpv4-code", ("icmpv4_code", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code)), ("icmpv6-type", ("icmpv6_type", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type)), ("icmpv6-code", ("icmpv6_code", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code)), ("mpls-exp", ("mpls_exp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp)), ("mpls-exp-imp", ("mpls_exp_imp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp)), ("mpls-disp-ipv4-acl", ("mpls_disp_ipv4_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl)), ("mpls-disp-ipv6-acl", ("mpls_disp_ipv6_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl)), ("mpls-top-label", ("mpls_top_label", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel)), ("cos", ("cos", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos)), ("cos-inr", ("cos_inr", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr)), ("dei", ("dei", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei)), ("dei-inr", ("dei_inr", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr)), ("vlan", ("vlan", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan)), ("vlan-inr", ("vlan_inr", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)), ("fr-dlci", ("fr_dlci", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci)), ("src-mac", ("src_mac", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac)), ("dst-mac", ("dst_mac", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac)), ("atm-clp", ("atm_clp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp)), ("fr-de", ("fr_de", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe)), ("ipv4-acl", ("ipv4_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl)), ("ipv6-acl", ("ipv6_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl)), ("ether-service-acl", ("ether_service_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl)), ("avail-id", ("avail_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId)), ("media-type", ("media_type", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType)), ("subs-protocol", ("subs_protocol", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol)), ("dnis", ("dnis", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis)), ("dnis-regex", ("dnis_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex)), ("domain", ("domain", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain)), ("domain-regex", ("domain_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex)), ("nas-port", ("nas_port", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort)), ("service-name", ("service_name", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName)), ("service-name-regex", ("service_name_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex)), ("src-addr-ipv4", ("src_addr_ipv4", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4)), ("dst-addr-ipv4", ("dst_addr_ipv4", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4)), ("src-addr-ipv6", ("src_addr_ipv6", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6)), ("dst-addr-ipv6", ("dst_addr_ipv6", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6)), ("src-addr-mac", ("src_addr_mac", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac)), ("timer", ("timer", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer)), ("timer-regexp", ("timer_regexp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp)), ("tunnel-name", ("tunnel_name", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName)), ("tunnel-name-regex", ("tunnel_name_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex)), ("user-name", ("user_name", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName)), ("user-name-regex", ("user_name_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex)), ("auth-username", ("auth_username", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername)), ("auth-username-regex", ("auth_username_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex)), ("unauth-username", ("unauth_username", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername)), ("unauth-username-regex", ("unauth_username_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex)), ("auth-domain", ("auth_domain", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain)), ("auth-domain-regex", ("auth_domain_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex)), ("unauth-domain", ("unauth_domain", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain)), ("unauth-domain-regex", ("unauth_domain_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex)), ("vendor-id", ("vendor_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId)), ("vendor-id-regex", ("vendor_id_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex)), ("access-interface", ("access_interface", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface)), ("input-interface", ("input_interface", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface)), ("input-intfhdl", ("input_intfhdl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl)), ("ethertype", ("ethertype", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype)), ("flow-key-data", ("flow_key_data", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData)), ("dhcp-client-id", ("dhcp_client_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId)), ("dhcp-client-id-regex", ("dhcp_client_id_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex)), ("circuit-id", ("circuit_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId)), ("circuit-id-regex", ("circuit_id_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex)), ("remote-id", ("remote_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId)), ("remote-id-regex", ("remote_id_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex)), ("src-port", ("src_port", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort)), ("dst-port", ("dst_port", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort))])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchTypeEn', '')])),
                                                                                                    ('mpls_top_eos', (YLeaf(YType.uint8, 'mpls-top-eos'), ['int'])),
                                                                                                    ('fragment_type', (YLeaf(YType.uint8, 'fragment-type'), ['int'])),
                                                                                                    ('authen_status', (YLeaf(YType.enumeration, 'authen-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchAuthenStatusEn', '')])),
                                                                                                    ('mlp_negotiated', (YLeaf(YType.enumeration, 'mlp-negotiated'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchMlpNegotiatedEn', '')])),
                                                                                                ])
                                                                                                self.type = None
                                                                                                self.mpls_top_eos = None
                                                                                                self.fragment_type = None
                                                                                                self.authen_status = None
                                                                                                self.mlp_negotiated = None

                                                                                                self.ipv4_dscp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                                self.ipv4_dscp.parent = self
                                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"

                                                                                                self.ipv6_dscp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                                self.ipv6_dscp.parent = self
                                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"

                                                                                                self.dscp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                                self.dscp.parent = self
                                                                                                self._children_name_map["dscp"] = "dscp"

                                                                                                self.ipv4_prec = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                                self.ipv4_prec.parent = self
                                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"

                                                                                                self.ipv6_prec = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                                self.ipv6_prec.parent = self
                                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"

                                                                                                self.prec = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                                self.prec.parent = self
                                                                                                self._children_name_map["prec"] = "prec"

                                                                                                self.discard_class = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                                self.discard_class.parent = self
                                                                                                self._children_name_map["discard_class"] = "discard-class"

                                                                                                self.qos_group = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                                self.qos_group.parent = self
                                                                                                self._children_name_map["qos_group"] = "qos-group"

                                                                                                self.traffic_class = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                                self.traffic_class.parent = self
                                                                                                self._children_name_map["traffic_class"] = "traffic-class"

                                                                                                self.proto = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                                self.proto.parent = self
                                                                                                self._children_name_map["proto"] = "proto"

                                                                                                self.icmp_v4 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                                self.icmp_v4.parent = self
                                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"

                                                                                                self.icmp_v6 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                                self.icmp_v6.parent = self
                                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"

                                                                                                self.ipv4_packet_len = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                                self.ipv4_packet_len.parent = self
                                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"

                                                                                                self.ipv6_packet_len = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                                self.ipv6_packet_len.parent = self
                                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"

                                                                                                self.packet_len = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                                self.packet_len.parent = self
                                                                                                self._children_name_map["packet_len"] = "packet-len"

                                                                                                self.flow_tag = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                                self.flow_tag.parent = self
                                                                                                self._children_name_map["flow_tag"] = "flow-tag"

                                                                                                self.tcp_flag = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                                self.tcp_flag.parent = self
                                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"

                                                                                                self.icmpv4_type = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                                self.icmpv4_type.parent = self
                                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"

                                                                                                self.icmpv4_code = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                                self.icmpv4_code.parent = self
                                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"

                                                                                                self.icmpv6_type = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                                self.icmpv6_type.parent = self
                                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"

                                                                                                self.icmpv6_code = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                                self.icmpv6_code.parent = self
                                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"

                                                                                                self.mpls_exp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                                self.mpls_exp.parent = self
                                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"

                                                                                                self.mpls_exp_imp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                                self.mpls_exp_imp.parent = self
                                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"

                                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"

                                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"

                                                                                                self.mpls_top_label = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                                self.mpls_top_label.parent = self
                                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"

                                                                                                self.cos = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                                self.cos.parent = self
                                                                                                self._children_name_map["cos"] = "cos"

                                                                                                self.cos_inr = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                                self.cos_inr.parent = self
                                                                                                self._children_name_map["cos_inr"] = "cos-inr"

                                                                                                self.dei = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                                self.dei.parent = self
                                                                                                self._children_name_map["dei"] = "dei"

                                                                                                self.dei_inr = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                                self.dei_inr.parent = self
                                                                                                self._children_name_map["dei_inr"] = "dei-inr"

                                                                                                self.vlan = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                                self.vlan.parent = self
                                                                                                self._children_name_map["vlan"] = "vlan"

                                                                                                self.vlan_inr = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                                self.vlan_inr.parent = self
                                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"

                                                                                                self.fr_dlci = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                                self.fr_dlci.parent = self
                                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"

                                                                                                self.src_mac = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                                self.src_mac.parent = self
                                                                                                self._children_name_map["src_mac"] = "src-mac"

                                                                                                self.dst_mac = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                                self.dst_mac.parent = self
                                                                                                self._children_name_map["dst_mac"] = "dst-mac"

                                                                                                self.atm_clp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                                self.atm_clp.parent = self
                                                                                                self._children_name_map["atm_clp"] = "atm-clp"

                                                                                                self.fr_de = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                                self.fr_de.parent = self
                                                                                                self._children_name_map["fr_de"] = "fr-de"

                                                                                                self.ipv4_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                                self.ipv4_acl.parent = self
                                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"

                                                                                                self.ipv6_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                                self.ipv6_acl.parent = self
                                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"

                                                                                                self.ether_service_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                                self.ether_service_acl.parent = self
                                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"

                                                                                                self.avail_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                                self.avail_id.parent = self
                                                                                                self._children_name_map["avail_id"] = "avail-id"

                                                                                                self.media_type = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                                self.media_type.parent = self
                                                                                                self._children_name_map["media_type"] = "media-type"

                                                                                                self.subs_protocol = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                                self.subs_protocol.parent = self
                                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"

                                                                                                self.dnis = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                                self.dnis.parent = self
                                                                                                self._children_name_map["dnis"] = "dnis"

                                                                                                self.dnis_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                                self.dnis_regex.parent = self
                                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"

                                                                                                self.domain = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                                self.domain.parent = self
                                                                                                self._children_name_map["domain"] = "domain"

                                                                                                self.domain_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                                self.domain_regex.parent = self
                                                                                                self._children_name_map["domain_regex"] = "domain-regex"

                                                                                                self.nas_port = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                                self.nas_port.parent = self
                                                                                                self._children_name_map["nas_port"] = "nas-port"

                                                                                                self.service_name = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                                self.service_name.parent = self
                                                                                                self._children_name_map["service_name"] = "service-name"

                                                                                                self.service_name_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                                self.service_name_regex.parent = self
                                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"

                                                                                                self.src_addr_ipv4 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                                self.src_addr_ipv4.parent = self
                                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"

                                                                                                self.dst_addr_ipv4 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                                self.dst_addr_ipv4.parent = self
                                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"

                                                                                                self.src_addr_ipv6 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                                self.src_addr_ipv6.parent = self
                                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"

                                                                                                self.dst_addr_ipv6 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                                self.dst_addr_ipv6.parent = self
                                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"

                                                                                                self.src_addr_mac = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                                self.src_addr_mac.parent = self
                                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"

                                                                                                self.timer = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                                self.timer.parent = self
                                                                                                self._children_name_map["timer"] = "timer"

                                                                                                self.timer_regexp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                                self.timer_regexp.parent = self
                                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"

                                                                                                self.tunnel_name = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                                self.tunnel_name.parent = self
                                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"

                                                                                                self.tunnel_name_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                                self.tunnel_name_regex.parent = self
                                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"

                                                                                                self.user_name = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                                self.user_name.parent = self
                                                                                                self._children_name_map["user_name"] = "user-name"

                                                                                                self.user_name_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                                self.user_name_regex.parent = self
                                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"

                                                                                                self.auth_username = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                                self.auth_username.parent = self
                                                                                                self._children_name_map["auth_username"] = "auth-username"

                                                                                                self.auth_username_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                                self.auth_username_regex.parent = self
                                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"

                                                                                                self.unauth_username = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                                self.unauth_username.parent = self
                                                                                                self._children_name_map["unauth_username"] = "unauth-username"

                                                                                                self.unauth_username_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                                self.unauth_username_regex.parent = self
                                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"

                                                                                                self.auth_domain = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                                self.auth_domain.parent = self
                                                                                                self._children_name_map["auth_domain"] = "auth-domain"

                                                                                                self.auth_domain_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                                self.auth_domain_regex.parent = self
                                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"

                                                                                                self.unauth_domain = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                                self.unauth_domain.parent = self
                                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"

                                                                                                self.unauth_domain_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                                self.unauth_domain_regex.parent = self
                                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"

                                                                                                self.vendor_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                                self.vendor_id.parent = self
                                                                                                self._children_name_map["vendor_id"] = "vendor-id"

                                                                                                self.vendor_id_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                                self.vendor_id_regex.parent = self
                                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"

                                                                                                self.access_interface = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                                self.access_interface.parent = self
                                                                                                self._children_name_map["access_interface"] = "access-interface"

                                                                                                self.input_interface = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                                self.input_interface.parent = self
                                                                                                self._children_name_map["input_interface"] = "input-interface"

                                                                                                self.input_intfhdl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                                self.input_intfhdl.parent = self
                                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"

                                                                                                self.ethertype = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                                self.ethertype.parent = self
                                                                                                self._children_name_map["ethertype"] = "ethertype"

                                                                                                self.flow_key_data = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                                self.flow_key_data.parent = self
                                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"

                                                                                                self.dhcp_client_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                                self.dhcp_client_id.parent = self
                                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"

                                                                                                self.dhcp_client_id_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                                self.dhcp_client_id_regex.parent = self
                                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"

                                                                                                self.circuit_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                                self.circuit_id.parent = self
                                                                                                self._children_name_map["circuit_id"] = "circuit-id"

                                                                                                self.circuit_id_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                                self.circuit_id_regex.parent = self
                                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"

                                                                                                self.remote_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                                self.remote_id.parent = self
                                                                                                self._children_name_map["remote_id"] = "remote-id"

                                                                                                self.remote_id_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                                self.remote_id_regex.parent = self
                                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"

                                                                                                self.src_port = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                                self.src_port.parent = self
                                                                                                self._children_name_map["src_port"] = "src-port"

                                                                                                self.dst_port = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                                self.dst_port.parent = self
                                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                                self._segment_path = lambda: "match-data"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['type', 'mpls_top_eos', 'fragment_type', 'authen_status', 'mlp_negotiated'], name, value)


                                                                                            class Ipv4Dscp(Entity):
                                                                                                """
                                                                                                IPv4 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv4-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv6Dscp(Entity):
                                                                                                """
                                                                                                IPv6 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv6-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Dscp(Entity):
                                                                                                """
                                                                                                Match DSCP range array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                    self.yang_name = "dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv4Prec(Entity):
                                                                                                """
                                                                                                IPv4 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                    self.yang_name = "ipv4-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "ipv4-prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                            class Ipv6Prec(Entity):
                                                                                                """
                                                                                                IPv6 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                    self.yang_name = "ipv6-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "ipv6-prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                            class Prec(Entity):
                                                                                                """
                                                                                                Match Precedence array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                    self.yang_name = "prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                            class DiscardClass(Entity):
                                                                                                """
                                                                                                Match Discard Class array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                    self.yang_name = "discard-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "discard-class"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                            class QosGroup(Entity):
                                                                                                """
                                                                                                Match QoS group array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                    self.yang_name = "qos-group"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "qos-group"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "qos-group"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class TrafficClass(Entity):
                                                                                                """
                                                                                                Match Traffic class array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                    self.yang_name = "traffic-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "traffic-class"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "traffic-class"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Proto(Entity):
                                                                                                """
                                                                                                Match Protocol array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                    self.yang_name = "proto"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "proto"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "proto"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class IcmpV4(Entity):
                                                                                                """
                                                                                                Match ICMPV4 Protocol
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                    self.yang_name = "icmp-v4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                    ])
                                                                                                    self.type = None
                                                                                                    self.code = None
                                                                                                    self._segment_path = lambda: "icmp-v4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['type', 'code'], name, value)


                                                                                            class IcmpV6(Entity):
                                                                                                """
                                                                                                Match ICMPV6 Protocol array
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                    self.yang_name = "icmp-v6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                    ])
                                                                                                    self.type = None
                                                                                                    self.code = None
                                                                                                    self._segment_path = lambda: "icmp-v6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['type', 'code'], name, value)


                                                                                            class Ipv4PacketLen(Entity):
                                                                                                """
                                                                                                IPv4 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv6PacketLen(Entity):
                                                                                                """
                                                                                                IPv6 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class PacketLen(Entity):
                                                                                                """
                                                                                                Match packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                    self.yang_name = "packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FlowTag(Entity):
                                                                                                """
                                                                                                Match flow\-tag array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                    self.yang_name = "flow-tag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "flow-tag"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "flow-tag"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class TcpFlag(Entity):
                                                                                                """
                                                                                                Match tcp flag value
                                                                                                
                                                                                                .. attribute:: value
                                                                                                
                                                                                                	Value of TCP flag
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: match_any
                                                                                                
                                                                                                	Match any TCP flag bit
                                                                                                	**type**\: bool
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                    self.yang_name = "tcp-flag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                                        ('match_any', (YLeaf(YType.boolean, 'match-any'), ['bool'])),
                                                                                                    ])
                                                                                                    self.value = None
                                                                                                    self.match_any = None
                                                                                                    self._segment_path = lambda: "tcp-flag"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['value', 'match_any'], name, value)


                                                                                            class Icmpv4Type(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                    self.yang_name = "icmpv4-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv4Code(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                    self.yang_name = "icmpv4-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-code"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv6Type(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                    self.yang_name = "icmpv6-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv6Code(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                    self.yang_name = "icmpv6-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-code"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class MplsExp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental topmost array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "mpls-exp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                            class MplsExpImp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental imposition array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "mpls-exp-imp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                            class MplsDispIpv4Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                            class MplsDispIpv6Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                            class MplsTopLabel(Entity):
                                                                                                """
                                                                                                MPLS Topmost LABEL
                                                                                                
                                                                                                .. attribute:: uint32_rng_array
                                                                                                
                                                                                                	uint32 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                    self.yang_name = "mpls-top-label"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint32_rng_array", ("uint32_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint32_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "mpls-top-label"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                                class Uint32RngArray(Entity):
                                                                                                    """
                                                                                                    uint32 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                        self.yang_name = "uint32_rng_array"
                                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint32, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint32, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint32_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['min', 'max'], name, value)


                                                                                            class Cos(Entity):
                                                                                                """
                                                                                                Match CoS array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                    self.yang_name = "cos"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "cos"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                            class CosInr(Entity):
                                                                                                """
                                                                                                Match inner header CoS
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                    self.yang_name = "cos-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "cos-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                            class Dei(Entity):
                                                                                                """
                                                                                                Match DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                    self.yang_name = "dei"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                    ])
                                                                                                    self.bit_value = None
                                                                                                    self._segment_path = lambda: "dei"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                            class DeiInr(Entity):
                                                                                                """
                                                                                                Match inner DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                    self.yang_name = "dei-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                    ])
                                                                                                    self.bit_value = None
                                                                                                    self._segment_path = lambda: "dei-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                            class Vlan(Entity):
                                                                                                """
                                                                                                Match VLAN array
                                                                                                
                                                                                                .. attribute:: vlan_id_array
                                                                                                
                                                                                                	vlan id array
                                                                                                	**type**\: list of  		 :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                    self.yang_name = "vlan"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("vlan-id-array", ("vlan_id_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.vlan_id_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                                class VlanIdArray(Entity):
                                                                                                    """
                                                                                                    vlan id array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	VLAN mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                        self.yang_name = "vlan-id-array"
                                                                                                        self.yang_parent_name = "vlan"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ('mask', (YLeaf(YType.uint16, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "vlan-id-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['min', 'max', 'mask'], name, value)


                                                                                            class VlanInr(Entity):
                                                                                                """
                                                                                                Match inner header VLAN range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                    self.yang_name = "vlan-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FrDlci(Entity):
                                                                                                """
                                                                                                Match FR DLCI range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                    self.yang_name = "fr-dlci"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "fr-dlci"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class SrcMac(Entity):
                                                                                                """
                                                                                                Match Source MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                    self.yang_name = "src-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.mac_addr = []
                                                                                                    self.mask = []
                                                                                                    self._segment_path = lambda: "src-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                            class DstMac(Entity):
                                                                                                """
                                                                                                Match Destination MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                    self.yang_name = "dst-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.mac_addr = []
                                                                                                    self.mask = []
                                                                                                    self._segment_path = lambda: "dst-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                            class AtmClp(Entity):
                                                                                                """
                                                                                                Match ATM CLP level
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                    self.yang_name = "atm-clp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "atm-clp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                            class FrDe(Entity):
                                                                                                """
                                                                                                Match FR DE value
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                    self.yang_name = "fr-de"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "fr-de"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                            class Ipv4Acl(Entity):
                                                                                                """
                                                                                                IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                    self.yang_name = "ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ipv4-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                            class Ipv6Acl(Entity):
                                                                                                """
                                                                                                IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                    self.yang_name = "ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ipv6-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                            class EtherServiceAcl(Entity):
                                                                                                """
                                                                                                Ethernet\-Services Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                    self.yang_name = "ether-service-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ether-service-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                            class AvailId(Entity):
                                                                                                """
                                                                                                Available Identifiers
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                    self.yang_name = "avail-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "avail-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                            class MediaType(Entity):
                                                                                                """
                                                                                                Media Type
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                    self.yang_name = "media-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "media-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                            class SubsProtocol(Entity):
                                                                                                """
                                                                                                Protocol
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                    self.yang_name = "subs-protocol"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "subs-protocol"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                            class Dnis(Entity):
                                                                                                """
                                                                                                DNIS
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                    self.yang_name = "dnis"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dnis"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                            class DnisRegex(Entity):
                                                                                                """
                                                                                                DNIS Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                    self.yang_name = "dnis-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dnis-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                            class Domain(Entity):
                                                                                                """
                                                                                                Domain Name
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                    self.yang_name = "domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                        ])
                                                                                                        self.domain_name = None
                                                                                                        self.format_name = None
                                                                                                        self._segment_path = lambda: "domain-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class DomainRegex(Entity):
                                                                                                """
                                                                                                Domain Regular Expression
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                    self.yang_name = "domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain-regex"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                        ])
                                                                                                        self.domain_name = None
                                                                                                        self.format_name = None
                                                                                                        self._segment_path = lambda: "domain-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class NasPort(Entity):
                                                                                                """
                                                                                                NAS Port
                                                                                                
                                                                                                .. attribute:: nas_port_array
                                                                                                
                                                                                                	nas port array
                                                                                                	**type**\: list of  		 :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                    self.yang_name = "nas-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("nas-port-array", ("nas_port_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.nas_port_array = YList(self)
                                                                                                    self._segment_path = lambda: "nas-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                                class NasPortArray(Entity):
                                                                                                    """
                                                                                                    nas port array
                                                                                                    
                                                                                                    .. attribute:: sub_id
                                                                                                    
                                                                                                    	sub id
                                                                                                    	**type**\:  :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                    
                                                                                                    .. attribute:: operator
                                                                                                    
                                                                                                    	operator
                                                                                                    	**type**\:  :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	value
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                        self.yang_name = "nas-port-array"
                                                                                                        self.yang_parent_name = "nas-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('sub_id', (YLeaf(YType.enumeration, 'sub-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchNasPortSubIdEn', '')])),
                                                                                                            ('operator', (YLeaf(YType.enumeration, 'operator'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchLogicalOperatorEn', '')])),
                                                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                                        ])
                                                                                                        self.sub_id = None
                                                                                                        self.operator = None
                                                                                                        self.value = None
                                                                                                        self._segment_path = lambda: "nas-port-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['sub_id', 'operator', 'value'], name, value)


                                                                                            class ServiceName(Entity):
                                                                                                """
                                                                                                Service Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                    self.yang_name = "service-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "service-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                            class ServiceNameRegex(Entity):
                                                                                                """
                                                                                                Service Name Regular Exp
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                    self.yang_name = "service-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "service-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                            class SrcAddrIpv4(Entity):
                                                                                                """
                                                                                                Source Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class DstAddrIpv4(Entity):
                                                                                                """
                                                                                                Destination Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class SrcAddrIpv6(Entity):
                                                                                                """
                                                                                                Source Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class DstAddrIpv6(Entity):
                                                                                                """
                                                                                                Destination Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class SrcAddrMac(Entity):
                                                                                                """
                                                                                                Source Address MAC
                                                                                                
                                                                                                .. attribute:: mac_addr_array
                                                                                                
                                                                                                	mac addr array
                                                                                                	**type**\: list of  		 :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                    self.yang_name = "src-addr-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("mac-addr-array", ("mac_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.mac_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                                class MacAddrArray(Entity):
                                                                                                    """
                                                                                                    mac addr array
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                        self.yang_name = "mac-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                            ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.mac_addr = []
                                                                                                        self.mask = []
                                                                                                        self._segment_path = lambda: "mac-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                            class Timer(Entity):
                                                                                                """
                                                                                                Timer
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                    self.yang_name = "timer"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "timer"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                            class TimerRegexp(Entity):
                                                                                                """
                                                                                                Timer Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                    self.yang_name = "timer-regexp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "timer-regexp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                            class TunnelName(Entity):
                                                                                                """
                                                                                                Tunnel Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                    self.yang_name = "tunnel-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "tunnel-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                            class TunnelNameRegex(Entity):
                                                                                                """
                                                                                                Tunnel Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "tunnel-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                            class UserName(Entity):
                                                                                                """
                                                                                                User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                    self.yang_name = "user-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "user-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                            class UserNameRegex(Entity):
                                                                                                """
                                                                                                User Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                    self.yang_name = "user-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "user-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                            class AuthUsername(Entity):
                                                                                                """
                                                                                                Authenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                    self.yang_name = "auth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-username"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                            class AuthUsernameRegex(Entity):
                                                                                                """
                                                                                                Authenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "auth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-username-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                            class UnauthUsername(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                    self.yang_name = "unauth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-username"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                            class UnauthUsernameRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-username-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                            class AuthDomain(Entity):
                                                                                                """
                                                                                                Authenticated domain name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                    self.yang_name = "auth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                            class AuthDomainRegex(Entity):
                                                                                                """
                                                                                                Authenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "auth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                            class UnauthDomain(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                    self.yang_name = "unauth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                            class UnauthDomainRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                            class VendorId(Entity):
                                                                                                """
                                                                                                Vendor ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                    self.yang_name = "vendor-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "vendor-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                            class VendorIdRegex(Entity):
                                                                                                """
                                                                                                Vendor ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                    self.yang_name = "vendor-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "vendor-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                            class AccessInterface(Entity):
                                                                                                """
                                                                                                Access interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                    self.yang_name = "access-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "access-interface"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                            class InputInterface(Entity):
                                                                                                """
                                                                                                Input interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                    self.yang_name = "input-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "input-interface"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                            class InputIntfhdl(Entity):
                                                                                                """
                                                                                                Input interface handle
                                                                                                
                                                                                                .. attribute:: uint64_array
                                                                                                
                                                                                                	uint64 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..18446744073709551615
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                    self.yang_name = "input-intfhdl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint64_array', (YLeafList(YType.uint64, 'uint64_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint64_array = []
                                                                                                    self._segment_path = lambda: "input-intfhdl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                            class Ethertype(Entity):
                                                                                                """
                                                                                                Ethernet type
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                    self.yang_name = "ethertype"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ethertype"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ethertype"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FlowKeyData(Entity):
                                                                                                """
                                                                                                Flow key structure
                                                                                                
                                                                                                .. attribute:: flow_keys
                                                                                                
                                                                                                	flow keys
                                                                                                	**type**\:  :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                                
                                                                                                .. attribute:: max_count
                                                                                                
                                                                                                	Maximum count of flows
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: idle_timeout
                                                                                                
                                                                                                	Idle timeout of flows (in seconds)
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                	**units**\: second
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                    self.yang_name = "flow-key-data"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("flow-keys", ("flow_keys", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys))])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('max_count', (YLeaf(YType.uint16, 'max-count'), ['int'])),
                                                                                                        ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                                                    ])
                                                                                                    self.max_count = None
                                                                                                    self.idle_timeout = None

                                                                                                    self.flow_keys = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                    self.flow_keys.parent = self
                                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                    self._segment_path = lambda: "flow-key-data"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['max_count', 'idle_timeout'], name, value)


                                                                                                class FlowKeys(Entity):
                                                                                                    """
                                                                                                    flow keys
                                                                                                    
                                                                                                    .. attribute:: keys
                                                                                                    
                                                                                                    	keys
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                    
                                                                                                    .. attribute:: num
                                                                                                    
                                                                                                    	num
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                        self.yang_name = "flow-keys"
                                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('keys', (YLeaf(YType.str, 'keys'), ['str'])),
                                                                                                            ('num', (YLeaf(YType.uint8, 'num'), ['int'])),
                                                                                                        ])
                                                                                                        self.keys = None
                                                                                                        self.num = None
                                                                                                        self._segment_path = lambda: "flow-keys"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                            class DhcpClientId(Entity):
                                                                                                """
                                                                                                Dhcp Client ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dhcp-client-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                            class DhcpClientIdRegex(Entity):
                                                                                                """
                                                                                                Dhcp Client ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                            class CircuitId(Entity):
                                                                                                """
                                                                                                Circuit ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                    self.yang_name = "circuit-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "circuit-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                            class CircuitIdRegex(Entity):
                                                                                                """
                                                                                                Circuit ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                    self.yang_name = "circuit-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "circuit-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                            class RemoteId(Entity):
                                                                                                """
                                                                                                Remote ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                    self.yang_name = "remote-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "remote-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                            class RemoteIdRegex(Entity):
                                                                                                """
                                                                                                Remote ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                    self.yang_name = "remote-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "remote-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                            class SrcPort(Entity):
                                                                                                """
                                                                                                Source port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                    self.yang_name = "src-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "src-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class DstPort(Entity):
                                                                                                """
                                                                                                Destination port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                    self.yang_name = "dst-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "dst-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                    class Shape(Entity):
                                                                        """
                                                                        shape
                                                                        
                                                                        .. attribute:: bw
                                                                        
                                                                        	bw
                                                                        	**type**\:  :py:class:`Bw <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw>`
                                                                        
                                                                        .. attribute:: be
                                                                        
                                                                        	be
                                                                        	**type**\:  :py:class:`Be <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape, self).__init__()

                                                                            self.yang_name = "shape"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("bw", ("bw", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw)), ("be", ("be", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be))])
                                                                            self._leafs = OrderedDict()

                                                                            self.bw = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw()
                                                                            self.bw.parent = self
                                                                            self._children_name_map["bw"] = "bw"

                                                                            self.be = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be()
                                                                            self.be.parent = self
                                                                            self._children_name_map["be"] = "be"
                                                                            self._segment_path = lambda: "shape"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape, [], name, value)


                                                                        class Bw(Entity):
                                                                            """
                                                                            bw
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw, self).__init__()

                                                                                self.yang_name = "bw"
                                                                                self.yang_parent_name = "shape"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "bw"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw, ['value', 'unit'], name, value)


                                                                        class Be(Entity):
                                                                            """
                                                                            be
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be, self).__init__()

                                                                                self.yang_name = "be"
                                                                                self.yang_parent_name = "shape"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "be"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be, ['value', 'unit'], name, value)


                                                                    class ChildPolicy(Entity):
                                                                        """
                                                                        child policy
                                                                        
                                                                        .. attribute:: info
                                                                        
                                                                        	info
                                                                        	**type**\:  :py:class:`Info <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info>`
                                                                        
                                                                        .. attribute:: hd_info
                                                                        
                                                                        	hd info
                                                                        	**type**\:  :py:class:`HdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo>`
                                                                        
                                                                        .. attribute:: enc
                                                                        
                                                                        	enc
                                                                        	**type**\:  :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy, self).__init__()

                                                                            self.yang_name = "child-policy"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("info", ("info", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info)), ("hd-info", ("hd_info", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo))])
                                                                            self._leafs = OrderedDict([
                                                                                ('enc', (YLeaf(YType.enumeration, 'enc'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyObjEncEn', '')])),
                                                                            ])
                                                                            self.enc = None

                                                                            self.info = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info()
                                                                            self.info.parent = self
                                                                            self._children_name_map["info"] = "info"

                                                                            self.hd_info = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo()
                                                                            self.hd_info.parent = self
                                                                            self._children_name_map["hd_info"] = "hd-info"
                                                                            self._segment_path = lambda: "child-policy"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy, ['enc'], name, value)


                                                                        class Info(Entity):
                                                                            """
                                                                            info
                                                                            
                                                                            .. attribute:: name
                                                                            
                                                                            	name
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..65
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:  :py:class:`PolicyMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyMapTypeEn>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info, self).__init__()

                                                                                self.yang_name = "info"
                                                                                self.yang_parent_name = "child-policy"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyMapTypeEn', '')])),
                                                                                ])
                                                                                self.name = None
                                                                                self.type = None
                                                                                self._segment_path = lambda: "info"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info, ['name', 'type'], name, value)


                                                                        class HdInfo(Entity):
                                                                            """
                                                                            hd info
                                                                            
                                                                            .. attribute:: data_hd
                                                                            
                                                                            	data hd
                                                                            	**type**\:  :py:class:`DataHd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd>`
                                                                            
                                                                            .. attribute:: hd
                                                                            
                                                                            	hd
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo, self).__init__()

                                                                                self.yang_name = "hd-info"
                                                                                self.yang_parent_name = "child-policy"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("data-hd", ("data_hd", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('hd', (YLeaf(YType.uint64, 'hd'), ['int'])),
                                                                                ])
                                                                                self.hd = None

                                                                                self.data_hd = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd()
                                                                                self.data_hd.parent = self
                                                                                self._children_name_map["data_hd"] = "data-hd"
                                                                                self._segment_path = lambda: "hd-info"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo, ['hd'], name, value)


                                                                            class DataHd(Entity):
                                                                                """
                                                                                data hd
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd, self).__init__()

                                                                                    self.yang_name = "data-hd"
                                                                                    self.yang_parent_name = "hd-info"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict()
                                                                                    self._segment_path = lambda: "data-hd"
                                                                                    self._is_frozen = True


                                                                    class Cac(Entity):
                                                                        """
                                                                        cac
                                                                        
                                                                        .. attribute:: flow_rate
                                                                        
                                                                        	flow rate
                                                                        	**type**\:  :py:class:`FlowRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate>`
                                                                        
                                                                        .. attribute:: rate
                                                                        
                                                                        	rate
                                                                        	**type**\:  :py:class:`Rate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate>`
                                                                        
                                                                        .. attribute:: cac_type
                                                                        
                                                                        	cac type
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: idle_timeout
                                                                        
                                                                        	idle timeout
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..65535
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac, self).__init__()

                                                                            self.yang_name = "cac"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("flow-rate", ("flow_rate", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate)), ("rate", ("rate", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate))])
                                                                            self._leafs = OrderedDict([
                                                                                ('cac_type', (YLeaf(YType.uint8, 'cac-type'), ['int'])),
                                                                                ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                            ])
                                                                            self.cac_type = None
                                                                            self.idle_timeout = None

                                                                            self.flow_rate = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate()
                                                                            self.flow_rate.parent = self
                                                                            self._children_name_map["flow_rate"] = "flow-rate"

                                                                            self.rate = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate()
                                                                            self.rate.parent = self
                                                                            self._children_name_map["rate"] = "rate"
                                                                            self._segment_path = lambda: "cac"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac, ['cac_type', 'idle_timeout'], name, value)


                                                                        class FlowRate(Entity):
                                                                            """
                                                                            flow rate
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate, self).__init__()

                                                                                self.yang_name = "flow-rate"
                                                                                self.yang_parent_name = "cac"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "flow-rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate, ['value', 'unit'], name, value)


                                                                        class Rate(Entity):
                                                                            """
                                                                            rate
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate, self).__init__()

                                                                                self.yang_name = "rate"
                                                                                self.yang_parent_name = "cac"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate, ['value', 'unit'], name, value)


                                                                    class Pfc(Entity):
                                                                        """
                                                                        pfc
                                                                        
                                                                        .. attribute:: buffer_size
                                                                        
                                                                        	buffer size
                                                                        	**type**\:  :py:class:`BufferSize <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize>`
                                                                        
                                                                        .. attribute:: pause_threshold
                                                                        
                                                                        	pause threshold
                                                                        	**type**\:  :py:class:`PauseThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold>`
                                                                        
                                                                        .. attribute:: resume_threshold
                                                                        
                                                                        	resume threshold
                                                                        	**type**\:  :py:class:`ResumeThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold>`
                                                                        
                                                                        .. attribute:: pfc_pause_set
                                                                        
                                                                        	pfc pause set
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: buffer_size_flag
                                                                        
                                                                        	buffer size flag
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc, self).__init__()

                                                                            self.yang_name = "pfc"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("buffer-size", ("buffer_size", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize)), ("pause-threshold", ("pause_threshold", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold)), ("resume-threshold", ("resume_threshold", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold))])
                                                                            self._leafs = OrderedDict([
                                                                                ('pfc_pause_set', (YLeaf(YType.uint32, 'pfc-pause-set'), ['int'])),
                                                                                ('buffer_size_flag', (YLeaf(YType.uint32, 'buffer-size-flag'), ['int'])),
                                                                            ])
                                                                            self.pfc_pause_set = None
                                                                            self.buffer_size_flag = None

                                                                            self.buffer_size = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize()
                                                                            self.buffer_size.parent = self
                                                                            self._children_name_map["buffer_size"] = "buffer-size"

                                                                            self.pause_threshold = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold()
                                                                            self.pause_threshold.parent = self
                                                                            self._children_name_map["pause_threshold"] = "pause-threshold"

                                                                            self.resume_threshold = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold()
                                                                            self.resume_threshold.parent = self
                                                                            self._children_name_map["resume_threshold"] = "resume-threshold"
                                                                            self._segment_path = lambda: "pfc"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc, ['pfc_pause_set', 'buffer_size_flag'], name, value)


                                                                        class BufferSize(Entity):
                                                                            """
                                                                            buffer size
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize, self).__init__()

                                                                                self.yang_name = "buffer-size"
                                                                                self.yang_parent_name = "pfc"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "buffer-size"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize, ['value', 'unit'], name, value)


                                                                        class PauseThreshold(Entity):
                                                                            """
                                                                            pause threshold
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold, self).__init__()

                                                                                self.yang_name = "pause-threshold"
                                                                                self.yang_parent_name = "pfc"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "pause-threshold"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold, ['value', 'unit'], name, value)


                                                                        class ResumeThreshold(Entity):
                                                                            """
                                                                            resume threshold
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold, self).__init__()

                                                                                self.yang_name = "resume-threshold"
                                                                                self.yang_parent_name = "pfc"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "resume-threshold"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold, ['value', 'unit'], name, value)


                                                                    class FlowParm(Entity):
                                                                        """
                                                                        flow parm
                                                                        
                                                                        .. attribute:: max_mon_flows
                                                                        
                                                                        	max simult flows monitored per policy class
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: mon_interval
                                                                        
                                                                        	monitored interval duration in secs
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: second
                                                                        
                                                                        .. attribute:: intvl_hist
                                                                        
                                                                        	num intervals of data stored on rtr
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: flow_timeout
                                                                        
                                                                        	timeout in secs
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: second
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm, self).__init__()

                                                                            self.yang_name = "flow-parm"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('max_mon_flows', (YLeaf(YType.uint32, 'max-mon-flows'), ['int'])),
                                                                                ('mon_interval', (YLeaf(YType.uint32, 'mon-interval'), ['int'])),
                                                                                ('intvl_hist', (YLeaf(YType.uint32, 'intvl-hist'), ['int'])),
                                                                                ('flow_timeout', (YLeaf(YType.uint32, 'flow-timeout'), ['int'])),
                                                                            ])
                                                                            self.max_mon_flows = None
                                                                            self.mon_interval = None
                                                                            self.intvl_hist = None
                                                                            self.flow_timeout = None
                                                                            self._segment_path = lambda: "flow-parm"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm, ['max_mon_flows', 'mon_interval', 'intvl_hist', 'flow_timeout'], name, value)


                                                                    class Ipcbr(Entity):
                                                                        """
                                                                        ipcbr
                                                                        
                                                                        .. attribute:: ip_bit_rate
                                                                        
                                                                        	data rate in bps
                                                                        	**type**\:  :py:class:`IpBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate>`
                                                                        
                                                                        .. attribute:: media_bit_rate
                                                                        
                                                                        	media data rate in bps
                                                                        	**type**\:  :py:class:`MediaBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate>`
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: ip_pkt_rate
                                                                        
                                                                        	packet rate in pps
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: media_pkt_size
                                                                        
                                                                        	media packet size in bytes
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: media_pkts_per_ip
                                                                        
                                                                        	media packets per ip pkt
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr, self).__init__()

                                                                            self.yang_name = "ipcbr"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("ip-bit-rate", ("ip_bit_rate", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate)), ("media-bit-rate", ("media_bit_rate", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate))])
                                                                            self._leafs = OrderedDict([
                                                                                ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                                ('ip_pkt_rate', (YLeaf(YType.uint32, 'ip-pkt-rate'), ['int'])),
                                                                                ('media_pkt_size', (YLeaf(YType.uint32, 'media-pkt-size'), ['int'])),
                                                                                ('media_pkts_per_ip', (YLeaf(YType.uint32, 'media-pkts-per-ip'), ['int'])),
                                                                            ])
                                                                            self.action_metric_type = None
                                                                            self.ip_pkt_rate = None
                                                                            self.media_pkt_size = None
                                                                            self.media_pkts_per_ip = None

                                                                            self.ip_bit_rate = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate()
                                                                            self.ip_bit_rate.parent = self
                                                                            self._children_name_map["ip_bit_rate"] = "ip-bit-rate"

                                                                            self.media_bit_rate = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate()
                                                                            self.media_bit_rate.parent = self
                                                                            self._children_name_map["media_bit_rate"] = "media-bit-rate"
                                                                            self._segment_path = lambda: "ipcbr"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr, ['action_metric_type', 'ip_pkt_rate', 'media_pkt_size', 'media_pkts_per_ip'], name, value)


                                                                        class IpBitRate(Entity):
                                                                            """
                                                                            data rate in bps
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate, self).__init__()

                                                                                self.yang_name = "ip-bit-rate"
                                                                                self.yang_parent_name = "ipcbr"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "ip-bit-rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate, ['value', 'unit'], name, value)


                                                                        class MediaBitRate(Entity):
                                                                            """
                                                                            media data rate in bps
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate, self).__init__()

                                                                                self.yang_name = "media-bit-rate"
                                                                                self.yang_parent_name = "ipcbr"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "media-bit-rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate, ['value', 'unit'], name, value)


                                                                    class Rtp(Entity):
                                                                        """
                                                                        rtp
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: min_sequential
                                                                        
                                                                        	min sequential
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_dropout
                                                                        
                                                                        	max dropout
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_misorder
                                                                        
                                                                        	max misorder
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: seq_ext_cop4
                                                                        
                                                                        	enable seq extension cop4
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: clock_rate
                                                                        
                                                                        	clock rate
                                                                        	**type**\: list of  		 :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp, self).__init__()

                                                                            self.yang_name = "rtp"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("clock-rate", ("clock_rate", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate))])
                                                                            self._leafs = OrderedDict([
                                                                                ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                                ('min_sequential', (YLeaf(YType.uint32, 'min-sequential'), ['int'])),
                                                                                ('max_dropout', (YLeaf(YType.uint32, 'max-dropout'), ['int'])),
                                                                                ('max_misorder', (YLeaf(YType.uint32, 'max-misorder'), ['int'])),
                                                                                ('seq_ext_cop4', (YLeaf(YType.uint32, 'seq-ext-cop4'), ['int'])),
                                                                            ])
                                                                            self.action_metric_type = None
                                                                            self.min_sequential = None
                                                                            self.max_dropout = None
                                                                            self.max_misorder = None
                                                                            self.seq_ext_cop4 = None

                                                                            self.clock_rate = YList(self)
                                                                            self._segment_path = lambda: "rtp"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp, ['action_metric_type', 'min_sequential', 'max_dropout', 'max_misorder', 'seq_ext_cop4'], name, value)


                                                                        class ClockRate(Entity):
                                                                            """
                                                                            clock rate
                                                                            
                                                                            .. attribute:: pt
                                                                            
                                                                            	pt
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: frequency
                                                                            
                                                                            	frequency
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate, self).__init__()

                                                                                self.yang_name = "clock-rate"
                                                                                self.yang_parent_name = "rtp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('pt', (YLeaf(YType.uint32, 'pt'), ['int'])),
                                                                                    ('frequency', (YLeaf(YType.uint32, 'frequency'), ['int'])),
                                                                                ])
                                                                                self.pt = None
                                                                                self.frequency = None
                                                                                self._segment_path = lambda: "clock-rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate, ['pt', 'frequency'], name, value)


                                                                    class RtpMmr(Entity):
                                                                        """
                                                                        rtp mmr
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: min_sequential
                                                                        
                                                                        	min sequential
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_dropout
                                                                        
                                                                        	max dropout
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_misorder
                                                                        
                                                                        	max misorder
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: seq_ext_cop4
                                                                        
                                                                        	enable seq extension cop4
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: clock_rate
                                                                        
                                                                        	clock rate
                                                                        	**type**\: list of  		 :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr, self).__init__()

                                                                            self.yang_name = "rtp-mmr"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("clock-rate", ("clock_rate", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate))])
                                                                            self._leafs = OrderedDict([
                                                                                ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                                ('min_sequential', (YLeaf(YType.uint32, 'min-sequential'), ['int'])),
                                                                                ('max_dropout', (YLeaf(YType.uint32, 'max-dropout'), ['int'])),
                                                                                ('max_misorder', (YLeaf(YType.uint32, 'max-misorder'), ['int'])),
                                                                                ('seq_ext_cop4', (YLeaf(YType.uint32, 'seq-ext-cop4'), ['int'])),
                                                                            ])
                                                                            self.action_metric_type = None
                                                                            self.min_sequential = None
                                                                            self.max_dropout = None
                                                                            self.max_misorder = None
                                                                            self.seq_ext_cop4 = None

                                                                            self.clock_rate = YList(self)
                                                                            self._segment_path = lambda: "rtp-mmr"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr, ['action_metric_type', 'min_sequential', 'max_dropout', 'max_misorder', 'seq_ext_cop4'], name, value)


                                                                        class ClockRate(Entity):
                                                                            """
                                                                            clock rate
                                                                            
                                                                            .. attribute:: pt
                                                                            
                                                                            	pt
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: frequency
                                                                            
                                                                            	frequency
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate, self).__init__()

                                                                                self.yang_name = "clock-rate"
                                                                                self.yang_parent_name = "rtp-mmr"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('pt', (YLeaf(YType.uint32, 'pt'), ['int'])),
                                                                                    ('frequency', (YLeaf(YType.uint32, 'frequency'), ['int'])),
                                                                                ])
                                                                                self.pt = None
                                                                                self.frequency = None
                                                                                self._segment_path = lambda: "clock-rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate, ['pt', 'frequency'], name, value)


                                                                    class RtpJ2k(Entity):
                                                                        """
                                                                        rtp j2k
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: min_sequential
                                                                        
                                                                        	min sequential
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_dropout
                                                                        
                                                                        	max dropout
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_misorder
                                                                        
                                                                        	max misorder
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: seq_ext_cop4
                                                                        
                                                                        	enable seq extension cop4
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: clock_rate
                                                                        
                                                                        	clock rate
                                                                        	**type**\: list of  		 :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k.ClockRate>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k, self).__init__()

                                                                            self.yang_name = "rtp-j2k"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("clock-rate", ("clock_rate", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k.ClockRate))])
                                                                            self._leafs = OrderedDict([
                                                                                ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                                ('min_sequential', (YLeaf(YType.uint32, 'min-sequential'), ['int'])),
                                                                                ('max_dropout', (YLeaf(YType.uint32, 'max-dropout'), ['int'])),
                                                                                ('max_misorder', (YLeaf(YType.uint32, 'max-misorder'), ['int'])),
                                                                                ('seq_ext_cop4', (YLeaf(YType.uint32, 'seq-ext-cop4'), ['int'])),
                                                                            ])
                                                                            self.action_metric_type = None
                                                                            self.min_sequential = None
                                                                            self.max_dropout = None
                                                                            self.max_misorder = None
                                                                            self.seq_ext_cop4 = None

                                                                            self.clock_rate = YList(self)
                                                                            self._segment_path = lambda: "rtp-j2k"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k, ['action_metric_type', 'min_sequential', 'max_dropout', 'max_misorder', 'seq_ext_cop4'], name, value)


                                                                        class ClockRate(Entity):
                                                                            """
                                                                            clock rate
                                                                            
                                                                            .. attribute:: pt
                                                                            
                                                                            	pt
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: frequency
                                                                            
                                                                            	frequency
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k.ClockRate, self).__init__()

                                                                                self.yang_name = "clock-rate"
                                                                                self.yang_parent_name = "rtp-j2k"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('pt', (YLeaf(YType.uint32, 'pt'), ['int'])),
                                                                                    ('frequency', (YLeaf(YType.uint32, 'frequency'), ['int'])),
                                                                                ])
                                                                                self.pt = None
                                                                                self.frequency = None
                                                                                self._segment_path = lambda: "clock-rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k.ClockRate, ['pt', 'frequency'], name, value)


                                                                    class RtpVoice(Entity):
                                                                        """
                                                                        rtp voice
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: min_sequential
                                                                        
                                                                        	min sequential
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_dropout
                                                                        
                                                                        	max dropout
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_misorder
                                                                        
                                                                        	max misorder
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: seq_ext_cop4
                                                                        
                                                                        	enable seq extension cop4
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: clock_rate
                                                                        
                                                                        	clock rate
                                                                        	**type**\: list of  		 :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice, self).__init__()

                                                                            self.yang_name = "rtp-voice"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("clock-rate", ("clock_rate", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate))])
                                                                            self._leafs = OrderedDict([
                                                                                ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                                ('min_sequential', (YLeaf(YType.uint32, 'min-sequential'), ['int'])),
                                                                                ('max_dropout', (YLeaf(YType.uint32, 'max-dropout'), ['int'])),
                                                                                ('max_misorder', (YLeaf(YType.uint32, 'max-misorder'), ['int'])),
                                                                                ('seq_ext_cop4', (YLeaf(YType.uint32, 'seq-ext-cop4'), ['int'])),
                                                                            ])
                                                                            self.action_metric_type = None
                                                                            self.min_sequential = None
                                                                            self.max_dropout = None
                                                                            self.max_misorder = None
                                                                            self.seq_ext_cop4 = None

                                                                            self.clock_rate = YList(self)
                                                                            self._segment_path = lambda: "rtp-voice"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice, ['action_metric_type', 'min_sequential', 'max_dropout', 'max_misorder', 'seq_ext_cop4'], name, value)


                                                                        class ClockRate(Entity):
                                                                            """
                                                                            clock rate
                                                                            
                                                                            .. attribute:: pt
                                                                            
                                                                            	pt
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: frequency
                                                                            
                                                                            	frequency
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate, self).__init__()

                                                                                self.yang_name = "clock-rate"
                                                                                self.yang_parent_name = "rtp-voice"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('pt', (YLeaf(YType.uint32, 'pt'), ['int'])),
                                                                                    ('frequency', (YLeaf(YType.uint32, 'frequency'), ['int'])),
                                                                                ])
                                                                                self.pt = None
                                                                                self.frequency = None
                                                                                self._segment_path = lambda: "clock-rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate, ['pt', 'frequency'], name, value)


                                                                    class Mdi(Entity):
                                                                        """
                                                                        mdi
                                                                        
                                                                        .. attribute:: ip_bit_rate
                                                                        
                                                                        	data rate in bps
                                                                        	**type**\:  :py:class:`IpBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate>`
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: filtered_pkt_rate
                                                                        
                                                                        	filtered packet rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: ip_pkt_rate
                                                                        
                                                                        	packet rate in pps
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: pids
                                                                        
                                                                        	array of monitoredcd  pids
                                                                        	**type**\: list of int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi, self).__init__()

                                                                            self.yang_name = "mdi"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("ip-bit-rate", ("ip_bit_rate", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate))])
                                                                            self._leafs = OrderedDict([
                                                                                ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                                ('filtered_pkt_rate', (YLeaf(YType.uint32, 'filtered-pkt-rate'), ['int'])),
                                                                                ('ip_pkt_rate', (YLeaf(YType.uint32, 'ip-pkt-rate'), ['int'])),
                                                                                ('pids', (YLeafList(YType.uint32, 'pids'), ['int'])),
                                                                            ])
                                                                            self.action_metric_type = None
                                                                            self.filtered_pkt_rate = None
                                                                            self.ip_pkt_rate = None
                                                                            self.pids = []

                                                                            self.ip_bit_rate = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate()
                                                                            self.ip_bit_rate.parent = self
                                                                            self._children_name_map["ip_bit_rate"] = "ip-bit-rate"
                                                                            self._segment_path = lambda: "mdi"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi, ['action_metric_type', 'filtered_pkt_rate', 'ip_pkt_rate', 'pids'], name, value)


                                                                        class IpBitRate(Entity):
                                                                            """
                                                                            data rate in bps
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate, self).__init__()

                                                                                self.yang_name = "ip-bit-rate"
                                                                                self.yang_parent_name = "mdi"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "ip-bit-rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate, ['value', 'unit'], name, value)


                                                                    class MdiRtp(Entity):
                                                                        """
                                                                        mdi rtp
                                                                        
                                                                        .. attribute:: ip_bit_rate
                                                                        
                                                                        	data rate in bps
                                                                        	**type**\:  :py:class:`IpBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate>`
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: filtered_pkt_rate
                                                                        
                                                                        	filtered packet rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: ip_pkt_rate
                                                                        
                                                                        	packet rate in pps
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: pids
                                                                        
                                                                        	array of monitoredcd  pids
                                                                        	**type**\: list of int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp, self).__init__()

                                                                            self.yang_name = "mdi-rtp"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("ip-bit-rate", ("ip_bit_rate", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate))])
                                                                            self._leafs = OrderedDict([
                                                                                ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                                ('filtered_pkt_rate', (YLeaf(YType.uint32, 'filtered-pkt-rate'), ['int'])),
                                                                                ('ip_pkt_rate', (YLeaf(YType.uint32, 'ip-pkt-rate'), ['int'])),
                                                                                ('pids', (YLeafList(YType.uint32, 'pids'), ['int'])),
                                                                            ])
                                                                            self.action_metric_type = None
                                                                            self.filtered_pkt_rate = None
                                                                            self.ip_pkt_rate = None
                                                                            self.pids = []

                                                                            self.ip_bit_rate = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate()
                                                                            self.ip_bit_rate.parent = self
                                                                            self._children_name_map["ip_bit_rate"] = "ip-bit-rate"
                                                                            self._segment_path = lambda: "mdi-rtp"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp, ['action_metric_type', 'filtered_pkt_rate', 'ip_pkt_rate', 'pids'], name, value)


                                                                        class IpBitRate(Entity):
                                                                            """
                                                                            data rate in bps
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate, self).__init__()

                                                                                self.yang_name = "ip-bit-rate"
                                                                                self.yang_parent_name = "mdi-rtp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "ip-bit-rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate, ['value', 'unit'], name, value)


                                                                    class Fmm(Entity):
                                                                        """
                                                                        fmm
                                                                        
                                                                        .. attribute:: fmm_name
                                                                        
                                                                        	flow monitor name
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..33
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm, self).__init__()

                                                                            self.yang_name = "fmm"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('fmm_name', (YLeaf(YType.str, 'fmm-name'), ['str'])),
                                                                            ])
                                                                            self.fmm_name = None
                                                                            self._segment_path = lambda: "fmm"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm, ['fmm_name'], name, value)


                                                                    class Pbf(Entity):
                                                                        """
                                                                        pbf
                                                                        
                                                                        .. attribute:: action_pbf_info_array
                                                                        
                                                                        	action pbf info array
                                                                        	**type**\: list of  		 :py:class:`ActionPbfInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf, self).__init__()

                                                                            self.yang_name = "pbf"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("action-pbf-info-array", ("action_pbf_info_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.action_pbf_info_array = YList(self)
                                                                            self._segment_path = lambda: "pbf"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf, [], name, value)


                                                                        class ActionPbfInfoArray(Entity):
                                                                            """
                                                                            action pbf info array
                                                                            
                                                                            .. attribute:: addr
                                                                            
                                                                            	v4 or v6 address
                                                                            	**type**\: str
                                                                            
                                                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                            
                                                                            .. attribute:: vrf
                                                                            
                                                                            	vrf name
                                                                            	**type**\: str
                                                                            
                                                                            .. attribute:: rt_type
                                                                            
                                                                            	route target type
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: rt
                                                                            
                                                                            	route target
                                                                            	**type**\: str
                                                                            
                                                                            	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray, self).__init__()

                                                                                self.yang_name = "action-pbf-info-array"
                                                                                self.yang_parent_name = "pbf"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('addr', (YLeaf(YType.str, 'addr'), ['str'])),
                                                                                    ('vrf', (YLeaf(YType.str, 'vrf'), ['str'])),
                                                                                    ('rt_type', (YLeaf(YType.uint8, 'rt-type'), ['int'])),
                                                                                    ('rt', (YLeaf(YType.str, 'rt'), ['str'])),
                                                                                ])
                                                                                self.addr = None
                                                                                self.vrf = None
                                                                                self.rt_type = None
                                                                                self.rt = None
                                                                                self._segment_path = lambda: "action-pbf-info-array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray, ['addr', 'vrf', 'rt_type', 'rt'], name, value)


                                                                    class Ipv4Nh(Entity):
                                                                        """
                                                                        ipv4 nh
                                                                        
                                                                        .. attribute:: action_ipv4_nh_info_array
                                                                        
                                                                        	action ipv4 nh info array
                                                                        	**type**\: list of  		 :py:class:`ActionIpv4NhInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh, self).__init__()

                                                                            self.yang_name = "ipv4-nh"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("action-ipv4-nh-info-array", ("action_ipv4_nh_info_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.action_ipv4_nh_info_array = YList(self)
                                                                            self._segment_path = lambda: "ipv4-nh"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh, [], name, value)


                                                                        class ActionIpv4NhInfoArray(Entity):
                                                                            """
                                                                            action ipv4 nh info array
                                                                            
                                                                            .. attribute:: nh_addr
                                                                            
                                                                            	nh addr
                                                                            	**type**\: str
                                                                            
                                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                            
                                                                            .. attribute:: vrf_name
                                                                            
                                                                            	Vrf name
                                                                            	**type**\: str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray, self).__init__()

                                                                                self.yang_name = "action-ipv4-nh-info-array"
                                                                                self.yang_parent_name = "ipv4-nh"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('nh_addr', (YLeaf(YType.str, 'nh-addr'), ['str'])),
                                                                                    ('vrf_name', (YLeaf(YType.str, 'vrf-name'), ['str'])),
                                                                                ])
                                                                                self.nh_addr = None
                                                                                self.vrf_name = None
                                                                                self._segment_path = lambda: "action-ipv4-nh-info-array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray, ['nh_addr', 'vrf_name'], name, value)


                                                                    class Ipv6Nh(Entity):
                                                                        """
                                                                        ipv6 nh
                                                                        
                                                                        .. attribute:: action_ipv6_nh_info_array
                                                                        
                                                                        	action ipv6 nh info array
                                                                        	**type**\: list of  		 :py:class:`ActionIpv6NhInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh, self).__init__()

                                                                            self.yang_name = "ipv6-nh"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("action-ipv6-nh-info-array", ("action_ipv6_nh_info_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.action_ipv6_nh_info_array = YList(self)
                                                                            self._segment_path = lambda: "ipv6-nh"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh, [], name, value)


                                                                        class ActionIpv6NhInfoArray(Entity):
                                                                            """
                                                                            action ipv6 nh info array
                                                                            
                                                                            .. attribute:: nh_addr
                                                                            
                                                                            	IPV6 Address
                                                                            	**type**\: str
                                                                            
                                                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                            
                                                                            .. attribute:: vrf_name
                                                                            
                                                                            	Vrf name
                                                                            	**type**\: str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray, self).__init__()

                                                                                self.yang_name = "action-ipv6-nh-info-array"
                                                                                self.yang_parent_name = "ipv6-nh"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('nh_addr', (YLeaf(YType.str, 'nh-addr'), ['str'])),
                                                                                    ('vrf_name', (YLeaf(YType.str, 'vrf-name'), ['str'])),
                                                                                ])
                                                                                self.nh_addr = None
                                                                                self.vrf_name = None
                                                                                self._segment_path = lambda: "action-ipv6-nh-info-array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray, ['nh_addr', 'vrf_name'], name, value)


                            class Definition(Entity):
                                """
                                Transient Policy\-map type name
                                
                                .. attribute:: policy_map_bg
                                
                                	policy map bg
                                	**type**\: list of  		 :py:class:`PolicyMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg>`
                                
                                

                                """

                                _prefix = 'infra-policymgr-oper'
                                _revision = '2018-01-17'

                                def __init__(self):
                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition, self).__init__()

                                    self.yang_name = "definition"
                                    self.yang_parent_name = "transient-policy-map-name"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("policy-map-bg", ("policy_map_bg", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg))])
                                    self._leafs = OrderedDict()

                                    self.policy_map_bg = YList(self)
                                    self._segment_path = lambda: "definition"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition, [], name, value)


                                class PolicyMapBg(Entity):
                                    """
                                    policy map bg
                                    
                                    .. attribute:: pmap_var_list
                                    
                                    	pmap var list
                                    	**type**\:  :py:class:`PmapVarList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.PmapVarList>`
                                    
                                    .. attribute:: event_infop
                                    
                                    	event infop
                                    	**type**\:  :py:class:`EventInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop>`
                                    
                                    .. attribute:: name
                                    
                                    	name
                                    	**type**\: str
                                    
                                    	**length:** 0..65
                                    
                                    .. attribute:: type
                                    
                                    	type
                                    	**type**\:  :py:class:`PolicyMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyMapTypeEn>`
                                    
                                    .. attribute:: description
                                    
                                    	description
                                    	**type**\: str
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2018-01-17'

                                    def __init__(self):
                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg, self).__init__()

                                        self.yang_name = "policy-map-bg"
                                        self.yang_parent_name = "definition"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("pmap-var-list", ("pmap_var_list", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.PmapVarList)), ("event-infop", ("event_infop", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop))])
                                        self._leafs = OrderedDict([
                                            ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyMapTypeEn', '')])),
                                            ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                        ])
                                        self.name = None
                                        self.type = None
                                        self.description = None

                                        self.pmap_var_list = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.PmapVarList()
                                        self.pmap_var_list.parent = self
                                        self._children_name_map["pmap_var_list"] = "pmap-var-list"

                                        self.event_infop = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop()
                                        self.event_infop.parent = self
                                        self._children_name_map["event_infop"] = "event-infop"
                                        self._segment_path = lambda: "policy-map-bg"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg, ['name', 'type', 'description'], name, value)


                                    class PmapVarList(Entity):
                                        """
                                        pmap var list
                                        
                                        .. attribute:: pmap_var_list_arr
                                        
                                        	pmap var list arr
                                        	**type**\: list of  		 :py:class:`PmapVarListArr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.PmapVarList.PmapVarListArr>`
                                        
                                        

                                        """

                                        _prefix = 'infra-policymgr-oper'
                                        _revision = '2018-01-17'

                                        def __init__(self):
                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.PmapVarList, self).__init__()

                                            self.yang_name = "pmap-var-list"
                                            self.yang_parent_name = "policy-map-bg"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("pmap-var-list-arr", ("pmap_var_list_arr", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.PmapVarList.PmapVarListArr))])
                                            self._leafs = OrderedDict()

                                            self.pmap_var_list_arr = YList(self)
                                            self._segment_path = lambda: "pmap-var-list"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.PmapVarList, [], name, value)


                                        class PmapVarListArr(Entity):
                                            """
                                            pmap var list arr
                                            
                                            .. attribute:: val
                                            
                                            	val
                                            	**type**\:  :py:class:`Val <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.PmapVarList.PmapVarListArr.Val>`
                                            
                                            .. attribute:: name
                                            
                                            	name
                                            	**type**\: str
                                            
                                            	**length:** 0..32
                                            
                                            .. attribute:: id
                                            
                                            	id
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'infra-policymgr-oper'
                                            _revision = '2018-01-17'

                                            def __init__(self):
                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.PmapVarList.PmapVarListArr, self).__init__()

                                                self.yang_name = "pmap-var-list-arr"
                                                self.yang_parent_name = "pmap-var-list"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("val", ("val", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.PmapVarList.PmapVarListArr.Val))])
                                                self._leafs = OrderedDict([
                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                    ('id', (YLeaf(YType.uint32, 'id'), ['int'])),
                                                ])
                                                self.name = None
                                                self.id = None

                                                self.val = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.PmapVarList.PmapVarListArr.Val()
                                                self.val.parent = self
                                                self._children_name_map["val"] = "val"
                                                self._segment_path = lambda: "pmap-var-list-arr"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.PmapVarList.PmapVarListArr, ['name', 'id'], name, value)


                                            class Val(Entity):
                                                """
                                                val
                                                
                                                .. attribute:: type
                                                
                                                	type
                                                	**type**\:  :py:class:`PlmgrVarTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrVarTypeEn>`
                                                
                                                .. attribute:: class_name
                                                
                                                	class name
                                                	**type**\: str
                                                
                                                	**length:** 0..65
                                                
                                                .. attribute:: uint8_val
                                                
                                                	uint8 val
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: uint16_val
                                                
                                                	uint16 val
                                                	**type**\: int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: uint32_val
                                                
                                                	uint32 val
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: param_uint32_val
                                                
                                                	param uint32 val
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: dscp_val
                                                
                                                	dscp val
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: prec_val
                                                
                                                	prec val
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.PmapVarList.PmapVarListArr.Val, self).__init__()

                                                    self.yang_name = "val"
                                                    self.yang_parent_name = "pmap-var-list-arr"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PlmgrVarTypeEn', '')])),
                                                        ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                        ('uint8_val', (YLeaf(YType.uint8, 'uint8_val'), ['int'])),
                                                        ('uint16_val', (YLeaf(YType.uint16, 'uint16_val'), ['int'])),
                                                        ('uint32_val', (YLeaf(YType.uint32, 'uint32_val'), ['int'])),
                                                        ('param_uint32_val', (YLeaf(YType.uint32, 'param-uint32-val'), ['int'])),
                                                        ('dscp_val', (YLeaf(YType.uint8, 'dscp-val'), ['int'])),
                                                        ('prec_val', (YLeaf(YType.uint8, 'prec-val'), ['int'])),
                                                    ])
                                                    self.type = None
                                                    self.class_name = None
                                                    self.uint8_val = None
                                                    self.uint16_val = None
                                                    self.uint32_val = None
                                                    self.param_uint32_val = None
                                                    self.dscp_val = None
                                                    self.prec_val = None
                                                    self._segment_path = lambda: "val"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.PmapVarList.PmapVarListArr.Val, ['type', 'class_name', 'uint8_val', 'uint16_val', 'uint32_val', 'param_uint32_val', 'dscp_val', 'prec_val'], name, value)


                                    class EventInfop(Entity):
                                        """
                                        event infop
                                        
                                        .. attribute:: policy_event_info_bg
                                        
                                        	policy event info bg
                                        	**type**\: list of  		 :py:class:`PolicyEventInfoBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg>`
                                        
                                        

                                        """

                                        _prefix = 'infra-policymgr-oper'
                                        _revision = '2018-01-17'

                                        def __init__(self):
                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop, self).__init__()

                                            self.yang_name = "event-infop"
                                            self.yang_parent_name = "policy-map-bg"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("policy-event-info-bg", ("policy_event_info_bg", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg))])
                                            self._leafs = OrderedDict()

                                            self.policy_event_info_bg = YList(self)
                                            self._segment_path = lambda: "event-infop"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop, [], name, value)


                                        class PolicyEventInfoBg(Entity):
                                            """
                                            policy event info bg
                                            
                                            .. attribute:: class_infop
                                            
                                            	class infop
                                            	**type**\:  :py:class:`ClassInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop>`
                                            
                                            .. attribute:: event_type
                                            
                                            	event type
                                            	**type**\:  :py:class:`PeventTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PeventTypeEn>`
                                            
                                            .. attribute:: cond_eval
                                            
                                            	cond eval
                                            	**type**\:  :py:class:`PeventCondEvalEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PeventCondEvalEn>`
                                            
                                            

                                            """

                                            _prefix = 'infra-policymgr-oper'
                                            _revision = '2018-01-17'

                                            def __init__(self):
                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg, self).__init__()

                                                self.yang_name = "policy-event-info-bg"
                                                self.yang_parent_name = "event-infop"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("class-infop", ("class_infop", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop))])
                                                self._leafs = OrderedDict([
                                                    ('event_type', (YLeaf(YType.enumeration, 'event-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PeventTypeEn', '')])),
                                                    ('cond_eval', (YLeaf(YType.enumeration, 'cond-eval'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PeventCondEvalEn', '')])),
                                                ])
                                                self.event_type = None
                                                self.cond_eval = None

                                                self.class_infop = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop()
                                                self.class_infop.parent = self
                                                self._children_name_map["class_infop"] = "class-infop"
                                                self._segment_path = lambda: "policy-event-info-bg"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg, ['event_type', 'cond_eval'], name, value)


                                            class ClassInfop(Entity):
                                                """
                                                class infop
                                                
                                                .. attribute:: policy_class_info_bg
                                                
                                                	policy class info bg
                                                	**type**\: list of  		 :py:class:`PolicyClassInfoBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop, self).__init__()

                                                    self.yang_name = "class-infop"
                                                    self.yang_parent_name = "policy-event-info-bg"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("policy-class-info-bg", ("policy_class_info_bg", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg))])
                                                    self._leafs = OrderedDict()

                                                    self.policy_class_info_bg = YList(self)
                                                    self._segment_path = lambda: "class-infop"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop, [], name, value)


                                                class PolicyClassInfoBg(Entity):
                                                    """
                                                    policy class info bg
                                                    
                                                    .. attribute:: cl_encode
                                                    
                                                    	cl encode
                                                    	**type**\:  :py:class:`ClEncode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode>`
                                                    
                                                    .. attribute:: clmp_p
                                                    
                                                    	clmp p
                                                    	**type**\:  :py:class:`ClmpP <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP>`
                                                    
                                                    .. attribute:: act_infop
                                                    
                                                    	act infop
                                                    	**type**\:  :py:class:`ActInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop>`
                                                    
                                                    .. attribute:: policy_class_hd
                                                    
                                                    	policy class hd
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: seq
                                                    
                                                    	seq
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: flags
                                                    
                                                    	flags
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: ctype
                                                    
                                                    	ctype
                                                    	**type**\:  :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                    
                                                    .. attribute:: num_actions
                                                    
                                                    	num actions
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: version
                                                    
                                                    	version
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: exe_strat
                                                    
                                                    	exe strat
                                                    	**type**\:  :py:class:`PclassExecStratEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PclassExecStratEn>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg, self).__init__()

                                                        self.yang_name = "policy-class-info-bg"
                                                        self.yang_parent_name = "class-infop"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("cl-encode", ("cl_encode", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode)), ("clmp-p", ("clmp_p", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP)), ("act-infop", ("act_infop", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop))])
                                                        self._leafs = OrderedDict([
                                                            ('policy_class_hd', (YLeaf(YType.uint32, 'policy-class-hd'), ['int'])),
                                                            ('seq', (YLeaf(YType.uint32, 'seq'), ['int'])),
                                                            ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                            ('ctype', (YLeaf(YType.enumeration, 'ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapTypeEn', '')])),
                                                            ('num_actions', (YLeaf(YType.uint16, 'num-actions'), ['int'])),
                                                            ('version', (YLeaf(YType.uint8, 'version'), ['int'])),
                                                            ('exe_strat', (YLeaf(YType.enumeration, 'exe-strat'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PclassExecStratEn', '')])),
                                                        ])
                                                        self.policy_class_hd = None
                                                        self.seq = None
                                                        self.flags = None
                                                        self.ctype = None
                                                        self.num_actions = None
                                                        self.version = None
                                                        self.exe_strat = None

                                                        self.cl_encode = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode()
                                                        self.cl_encode.parent = self
                                                        self._children_name_map["cl_encode"] = "cl-encode"

                                                        self.clmp_p = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP()
                                                        self.clmp_p.parent = self
                                                        self._children_name_map["clmp_p"] = "clmp-p"

                                                        self.act_infop = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop()
                                                        self.act_infop.parent = self
                                                        self._children_name_map["act_infop"] = "act-infop"
                                                        self._segment_path = lambda: "policy-class-info-bg"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg, ['policy_class_hd', 'seq', 'flags', 'ctype', 'num_actions', 'version', 'exe_strat'], name, value)


                                                    class ClEncode(Entity):
                                                        """
                                                        cl encode
                                                        
                                                        .. attribute:: inline_cmap
                                                        
                                                        	inline cmap
                                                        	**type**\:  :py:class:`InlineCmap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap>`
                                                        
                                                        .. attribute:: enc
                                                        
                                                        	enc
                                                        	**type**\:  :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                        
                                                        .. attribute:: class_name
                                                        
                                                        	class name
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..65
                                                        
                                                        .. attribute:: hd
                                                        
                                                        	hd
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: idx
                                                        
                                                        	idx
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2018-01-17'

                                                        def __init__(self):
                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode, self).__init__()

                                                            self.yang_name = "cl-encode"
                                                            self.yang_parent_name = "policy-class-info-bg"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("inline-cmap", ("inline_cmap", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap))])
                                                            self._leafs = OrderedDict([
                                                                ('enc', (YLeaf(YType.enumeration, 'enc'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyObjEncEn', '')])),
                                                                ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                                ('hd', (YLeaf(YType.uint64, 'hd'), ['int'])),
                                                                ('idx', (YLeaf(YType.uint8, 'idx'), ['int'])),
                                                            ])
                                                            self.enc = None
                                                            self.class_name = None
                                                            self.hd = None
                                                            self.idx = None

                                                            self.inline_cmap = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap()
                                                            self.inline_cmap.parent = self
                                                            self._children_name_map["inline_cmap"] = "inline-cmap"
                                                            self._segment_path = lambda: "cl-encode"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode, ['enc', 'class_name', 'hd', 'idx'], name, value)


                                                        class InlineCmap(Entity):
                                                            """
                                                            inline cmap
                                                            
                                                            .. attribute:: match_infop
                                                            
                                                            	Pointer to the first Match info
                                                            	**type**\:  :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop>`
                                                            
                                                            .. attribute:: mode
                                                            
                                                            	Inline Class\-Map Mode Match any/all
                                                            	**type**\:  :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                            
                                                            .. attribute:: flags
                                                            
                                                            	Inline Class\-Map flags
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: match_count
                                                            
                                                            	Number of Match infos
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'infra-policymgr-oper'
                                                            _revision = '2018-01-17'

                                                            def __init__(self):
                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap, self).__init__()

                                                                self.yang_name = "inline-cmap"
                                                                self.yang_parent_name = "cl-encode"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("match-infop", ("match_infop", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop))])
                                                                self._leafs = OrderedDict([
                                                                    ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapModeEn', '')])),
                                                                    ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                    ('match_count', (YLeaf(YType.uint32, 'match-count'), ['int'])),
                                                                ])
                                                                self.mode = None
                                                                self.flags = None
                                                                self.match_count = None

                                                                self.match_infop = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop()
                                                                self.match_infop.parent = self
                                                                self._children_name_map["match_infop"] = "match-infop"
                                                                self._segment_path = lambda: "inline-cmap"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap, ['mode', 'flags', 'match_count'], name, value)


                                                            class MatchInfop(Entity):
                                                                """
                                                                Pointer to the first Match info
                                                                
                                                                .. attribute:: class_match_info_st
                                                                
                                                                	class match info st
                                                                	**type**\: list of  		 :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop, self).__init__()

                                                                    self.yang_name = "match-infop"
                                                                    self.yang_parent_name = "inline-cmap"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("class-match-info-st", ("class_match_info_st", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt))])
                                                                    self._leafs = OrderedDict()

                                                                    self.class_match_info_st = YList(self)
                                                                    self._segment_path = lambda: "match-infop"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop, [], name, value)


                                                                class ClassMatchInfoSt(Entity):
                                                                    """
                                                                    class match info st
                                                                    
                                                                    .. attribute:: match_data
                                                                    
                                                                    	Match criteria
                                                                    	**type**\:  :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                    
                                                                    .. attribute:: flags
                                                                    
                                                                    	Flags
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                        self.yang_name = "class-match-info-st"
                                                                        self.yang_parent_name = "match-infop"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("match-data", ("match_data", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData))])
                                                                        self._leafs = OrderedDict([
                                                                            ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                        ])
                                                                        self.flags = None

                                                                        self.match_data = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                        self.match_data.parent = self
                                                                        self._children_name_map["match_data"] = "match-data"
                                                                        self._segment_path = lambda: "class-match-info-st"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                    class MatchData(Entity):
                                                                        """
                                                                        Match criteria
                                                                        
                                                                        .. attribute:: ipv4_dscp
                                                                        
                                                                        	IPv4 DSCP
                                                                        	**type**\:  :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                        
                                                                        .. attribute:: ipv6_dscp
                                                                        
                                                                        	IPv6 DSCP
                                                                        	**type**\:  :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                        
                                                                        .. attribute:: dscp
                                                                        
                                                                        	Match DSCP range array
                                                                        	**type**\:  :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                        
                                                                        .. attribute:: ipv4_prec
                                                                        
                                                                        	IPv4 Precedence
                                                                        	**type**\:  :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                        
                                                                        .. attribute:: ipv6_prec
                                                                        
                                                                        	IPv6 Precedence
                                                                        	**type**\:  :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                        
                                                                        .. attribute:: prec
                                                                        
                                                                        	Match Precedence array
                                                                        	**type**\:  :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                        
                                                                        .. attribute:: discard_class
                                                                        
                                                                        	Match Discard Class array
                                                                        	**type**\:  :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                        
                                                                        .. attribute:: qos_group
                                                                        
                                                                        	Match QoS group array
                                                                        	**type**\:  :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                        
                                                                        .. attribute:: traffic_class
                                                                        
                                                                        	Match Traffic class array
                                                                        	**type**\:  :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                        
                                                                        .. attribute:: proto
                                                                        
                                                                        	Match Protocol array
                                                                        	**type**\:  :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                        
                                                                        .. attribute:: icmp_v4
                                                                        
                                                                        	Match ICMPV4 Protocol
                                                                        	**type**\:  :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                        
                                                                        .. attribute:: icmp_v6
                                                                        
                                                                        	Match ICMPV6 Protocol array
                                                                        	**type**\:  :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                        
                                                                        .. attribute:: ipv4_packet_len
                                                                        
                                                                        	IPv4 packet length array
                                                                        	**type**\:  :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                        
                                                                        .. attribute:: ipv6_packet_len
                                                                        
                                                                        	IPv6 packet length array
                                                                        	**type**\:  :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                        
                                                                        .. attribute:: packet_len
                                                                        
                                                                        	Match packet length array
                                                                        	**type**\:  :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                        
                                                                        .. attribute:: flow_tag
                                                                        
                                                                        	Match flow\-tag array
                                                                        	**type**\:  :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                        
                                                                        .. attribute:: tcp_flag
                                                                        
                                                                        	Match tcp flag value
                                                                        	**type**\:  :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                        
                                                                        .. attribute:: icmpv4_type
                                                                        
                                                                        	Match ipv4 icmp type
                                                                        	**type**\:  :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                        
                                                                        .. attribute:: icmpv4_code
                                                                        
                                                                        	Match ipv4 icmp code
                                                                        	**type**\:  :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                        
                                                                        .. attribute:: icmpv6_type
                                                                        
                                                                        	Match ipv6 icmp type
                                                                        	**type**\:  :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                        
                                                                        .. attribute:: icmpv6_code
                                                                        
                                                                        	Match ipv6 icmp code
                                                                        	**type**\:  :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                        
                                                                        .. attribute:: mpls_exp
                                                                        
                                                                        	Match MPLS experimental topmost array
                                                                        	**type**\:  :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                        
                                                                        .. attribute:: mpls_exp_imp
                                                                        
                                                                        	Match MPLS experimental imposition array
                                                                        	**type**\:  :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                        
                                                                        .. attribute:: mpls_disp_ipv4_acl
                                                                        
                                                                        	MPLS Disposition IPv4 Access\-list
                                                                        	**type**\:  :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                        
                                                                        .. attribute:: mpls_disp_ipv6_acl
                                                                        
                                                                        	MPLS Disposition IPv6 Access\-list
                                                                        	**type**\:  :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                        
                                                                        .. attribute:: mpls_top_label
                                                                        
                                                                        	MPLS Topmost LABEL
                                                                        	**type**\:  :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                        
                                                                        .. attribute:: cos
                                                                        
                                                                        	Match CoS array
                                                                        	**type**\:  :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                        
                                                                        .. attribute:: cos_inr
                                                                        
                                                                        	Match inner header CoS
                                                                        	**type**\:  :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                        
                                                                        .. attribute:: dei
                                                                        
                                                                        	Match DEI Bit
                                                                        	**type**\:  :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                        
                                                                        .. attribute:: dei_inr
                                                                        
                                                                        	Match inner DEI Bit
                                                                        	**type**\:  :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                        
                                                                        .. attribute:: vlan
                                                                        
                                                                        	Match VLAN array
                                                                        	**type**\:  :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                        
                                                                        .. attribute:: vlan_inr
                                                                        
                                                                        	Match inner header VLAN range array
                                                                        	**type**\:  :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                        
                                                                        .. attribute:: fr_dlci
                                                                        
                                                                        	Match FR DLCI range array
                                                                        	**type**\:  :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                        
                                                                        .. attribute:: src_mac
                                                                        
                                                                        	Match Source MAC address
                                                                        	**type**\:  :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                        
                                                                        .. attribute:: dst_mac
                                                                        
                                                                        	Match Destination MAC address
                                                                        	**type**\:  :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                        
                                                                        .. attribute:: atm_clp
                                                                        
                                                                        	Match ATM CLP level
                                                                        	**type**\:  :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                        
                                                                        .. attribute:: fr_de
                                                                        
                                                                        	Match FR DE value
                                                                        	**type**\:  :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                        
                                                                        .. attribute:: ipv4_acl
                                                                        
                                                                        	IPv4 Access\-list
                                                                        	**type**\:  :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                        
                                                                        .. attribute:: ipv6_acl
                                                                        
                                                                        	IPv6 Access\-list
                                                                        	**type**\:  :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                        
                                                                        .. attribute:: ether_service_acl
                                                                        
                                                                        	Ethernet\-Services Access\-list
                                                                        	**type**\:  :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                        
                                                                        .. attribute:: avail_id
                                                                        
                                                                        	Available Identifiers
                                                                        	**type**\:  :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                        
                                                                        .. attribute:: media_type
                                                                        
                                                                        	Media Type
                                                                        	**type**\:  :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                        
                                                                        .. attribute:: subs_protocol
                                                                        
                                                                        	Protocol
                                                                        	**type**\:  :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                        
                                                                        .. attribute:: dnis
                                                                        
                                                                        	DNIS
                                                                        	**type**\:  :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                        
                                                                        .. attribute:: dnis_regex
                                                                        
                                                                        	DNIS Regular Expression
                                                                        	**type**\:  :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                        
                                                                        .. attribute:: domain
                                                                        
                                                                        	Domain Name
                                                                        	**type**\:  :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                        
                                                                        .. attribute:: domain_regex
                                                                        
                                                                        	Domain Regular Expression
                                                                        	**type**\:  :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                        
                                                                        .. attribute:: nas_port
                                                                        
                                                                        	NAS Port
                                                                        	**type**\:  :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                        
                                                                        .. attribute:: service_name
                                                                        
                                                                        	Service Name
                                                                        	**type**\:  :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                        
                                                                        .. attribute:: service_name_regex
                                                                        
                                                                        	Service Name Regular Exp
                                                                        	**type**\:  :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                        
                                                                        .. attribute:: src_addr_ipv4
                                                                        
                                                                        	Source Address IPV4
                                                                        	**type**\:  :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                        
                                                                        .. attribute:: dst_addr_ipv4
                                                                        
                                                                        	Destination Address IPV4
                                                                        	**type**\:  :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                        
                                                                        .. attribute:: src_addr_ipv6
                                                                        
                                                                        	Source Address IPV6
                                                                        	**type**\:  :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                        
                                                                        .. attribute:: dst_addr_ipv6
                                                                        
                                                                        	Destination Address IPV6
                                                                        	**type**\:  :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                        
                                                                        .. attribute:: src_addr_mac
                                                                        
                                                                        	Source Address MAC
                                                                        	**type**\:  :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                        
                                                                        .. attribute:: timer
                                                                        
                                                                        	Timer
                                                                        	**type**\:  :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                        
                                                                        .. attribute:: timer_regexp
                                                                        
                                                                        	Timer Regular Expression
                                                                        	**type**\:  :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                        
                                                                        .. attribute:: tunnel_name
                                                                        
                                                                        	Tunnel Name
                                                                        	**type**\:  :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                        
                                                                        .. attribute:: tunnel_name_regex
                                                                        
                                                                        	Tunnel Name Regular Expression
                                                                        	**type**\:  :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                        
                                                                        .. attribute:: user_name
                                                                        
                                                                        	User Name
                                                                        	**type**\:  :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                        
                                                                        .. attribute:: user_name_regex
                                                                        
                                                                        	User Name Regular Expression
                                                                        	**type**\:  :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                        
                                                                        .. attribute:: auth_username
                                                                        
                                                                        	Authenticated User Name
                                                                        	**type**\:  :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                        
                                                                        .. attribute:: auth_username_regex
                                                                        
                                                                        	Authenticated User Name RegEx
                                                                        	**type**\:  :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                        
                                                                        .. attribute:: unauth_username
                                                                        
                                                                        	Unauthenticated User Name
                                                                        	**type**\:  :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                        
                                                                        .. attribute:: unauth_username_regex
                                                                        
                                                                        	Unauthenticated User Name RegEx
                                                                        	**type**\:  :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                        
                                                                        .. attribute:: auth_domain
                                                                        
                                                                        	Authenticated domain name
                                                                        	**type**\:  :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                        
                                                                        .. attribute:: auth_domain_regex
                                                                        
                                                                        	Authenticated Domain Name RegEx
                                                                        	**type**\:  :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                        
                                                                        .. attribute:: unauth_domain
                                                                        
                                                                        	Unauthenticated Domain Name
                                                                        	**type**\:  :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                        
                                                                        .. attribute:: unauth_domain_regex
                                                                        
                                                                        	Unauthenticated Domain Name RegEx
                                                                        	**type**\:  :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                        
                                                                        .. attribute:: vendor_id
                                                                        
                                                                        	Vendor ID
                                                                        	**type**\:  :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                        
                                                                        .. attribute:: vendor_id_regex
                                                                        
                                                                        	Vendor ID RegEx
                                                                        	**type**\:  :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                        
                                                                        .. attribute:: access_interface
                                                                        
                                                                        	Access interface
                                                                        	**type**\:  :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                        
                                                                        .. attribute:: input_interface
                                                                        
                                                                        	Input interface
                                                                        	**type**\:  :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                        
                                                                        .. attribute:: input_intfhdl
                                                                        
                                                                        	Input interface handle
                                                                        	**type**\:  :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                        
                                                                        .. attribute:: ethertype
                                                                        
                                                                        	Ethernet type
                                                                        	**type**\:  :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                        
                                                                        .. attribute:: flow_key_data
                                                                        
                                                                        	Flow key structure
                                                                        	**type**\:  :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                        
                                                                        .. attribute:: dhcp_client_id
                                                                        
                                                                        	Dhcp Client ID
                                                                        	**type**\:  :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                        
                                                                        .. attribute:: dhcp_client_id_regex
                                                                        
                                                                        	Dhcp Client ID RegEx
                                                                        	**type**\:  :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                        
                                                                        .. attribute:: circuit_id
                                                                        
                                                                        	Circuit ID
                                                                        	**type**\:  :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                        
                                                                        .. attribute:: circuit_id_regex
                                                                        
                                                                        	Circuit ID RegEx
                                                                        	**type**\:  :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                        
                                                                        .. attribute:: remote_id
                                                                        
                                                                        	Remote ID
                                                                        	**type**\:  :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                        
                                                                        .. attribute:: remote_id_regex
                                                                        
                                                                        	Remote ID RegEx
                                                                        	**type**\:  :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                        
                                                                        .. attribute:: src_port
                                                                        
                                                                        	Source port
                                                                        	**type**\:  :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                        
                                                                        .. attribute:: dst_port
                                                                        
                                                                        	Destination port
                                                                        	**type**\:  :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                        
                                                                        .. attribute:: type
                                                                        
                                                                        	type
                                                                        	**type**\:  :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                        
                                                                        .. attribute:: mpls_top_eos
                                                                        
                                                                        	MPLS Topmost EOS
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: fragment_type
                                                                        
                                                                        	Fragment type
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: authen_status
                                                                        
                                                                        	Authentication Status
                                                                        	**type**\:  :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                        
                                                                        .. attribute:: mlp_negotiated
                                                                        
                                                                        	MLP Negotiated
                                                                        	**type**\:  :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                            self.yang_name = "match-data"
                                                                            self.yang_parent_name = "class-match-info-st"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("ipv4-dscp", ("ipv4_dscp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp)), ("ipv6-dscp", ("ipv6_dscp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp)), ("dscp", ("dscp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp)), ("ipv4-prec", ("ipv4_prec", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec)), ("ipv6-prec", ("ipv6_prec", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec)), ("prec", ("prec", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec)), ("discard-class", ("discard_class", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass)), ("qos-group", ("qos_group", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup)), ("traffic-class", ("traffic_class", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass)), ("proto", ("proto", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto)), ("icmp-v4", ("icmp_v4", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4)), ("icmp-v6", ("icmp_v6", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6)), ("ipv4-packet-len", ("ipv4_packet_len", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen)), ("ipv6-packet-len", ("ipv6_packet_len", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen)), ("packet-len", ("packet_len", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen)), ("flow-tag", ("flow_tag", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag)), ("tcp-flag", ("tcp_flag", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag)), ("icmpv4-type", ("icmpv4_type", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type)), ("icmpv4-code", ("icmpv4_code", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code)), ("icmpv6-type", ("icmpv6_type", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type)), ("icmpv6-code", ("icmpv6_code", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code)), ("mpls-exp", ("mpls_exp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp)), ("mpls-exp-imp", ("mpls_exp_imp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp)), ("mpls-disp-ipv4-acl", ("mpls_disp_ipv4_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl)), ("mpls-disp-ipv6-acl", ("mpls_disp_ipv6_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl)), ("mpls-top-label", ("mpls_top_label", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel)), ("cos", ("cos", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos)), ("cos-inr", ("cos_inr", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr)), ("dei", ("dei", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei)), ("dei-inr", ("dei_inr", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr)), ("vlan", ("vlan", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan)), ("vlan-inr", ("vlan_inr", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)), ("fr-dlci", ("fr_dlci", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci)), ("src-mac", ("src_mac", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac)), ("dst-mac", ("dst_mac", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac)), ("atm-clp", ("atm_clp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp)), ("fr-de", ("fr_de", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe)), ("ipv4-acl", ("ipv4_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl)), ("ipv6-acl", ("ipv6_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl)), ("ether-service-acl", ("ether_service_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl)), ("avail-id", ("avail_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId)), ("media-type", ("media_type", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType)), ("subs-protocol", ("subs_protocol", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol)), ("dnis", ("dnis", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis)), ("dnis-regex", ("dnis_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex)), ("domain", ("domain", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain)), ("domain-regex", ("domain_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex)), ("nas-port", ("nas_port", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort)), ("service-name", ("service_name", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName)), ("service-name-regex", ("service_name_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex)), ("src-addr-ipv4", ("src_addr_ipv4", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4)), ("dst-addr-ipv4", ("dst_addr_ipv4", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4)), ("src-addr-ipv6", ("src_addr_ipv6", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6)), ("dst-addr-ipv6", ("dst_addr_ipv6", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6)), ("src-addr-mac", ("src_addr_mac", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac)), ("timer", ("timer", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer)), ("timer-regexp", ("timer_regexp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp)), ("tunnel-name", ("tunnel_name", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName)), ("tunnel-name-regex", ("tunnel_name_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex)), ("user-name", ("user_name", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName)), ("user-name-regex", ("user_name_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex)), ("auth-username", ("auth_username", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername)), ("auth-username-regex", ("auth_username_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex)), ("unauth-username", ("unauth_username", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername)), ("unauth-username-regex", ("unauth_username_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex)), ("auth-domain", ("auth_domain", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain)), ("auth-domain-regex", ("auth_domain_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex)), ("unauth-domain", ("unauth_domain", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain)), ("unauth-domain-regex", ("unauth_domain_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex)), ("vendor-id", ("vendor_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId)), ("vendor-id-regex", ("vendor_id_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex)), ("access-interface", ("access_interface", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface)), ("input-interface", ("input_interface", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface)), ("input-intfhdl", ("input_intfhdl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl)), ("ethertype", ("ethertype", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype)), ("flow-key-data", ("flow_key_data", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData)), ("dhcp-client-id", ("dhcp_client_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId)), ("dhcp-client-id-regex", ("dhcp_client_id_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex)), ("circuit-id", ("circuit_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId)), ("circuit-id-regex", ("circuit_id_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex)), ("remote-id", ("remote_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId)), ("remote-id-regex", ("remote_id_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex)), ("src-port", ("src_port", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort)), ("dst-port", ("dst_port", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort))])
                                                                            self._leafs = OrderedDict([
                                                                                ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchTypeEn', '')])),
                                                                                ('mpls_top_eos', (YLeaf(YType.uint8, 'mpls-top-eos'), ['int'])),
                                                                                ('fragment_type', (YLeaf(YType.uint8, 'fragment-type'), ['int'])),
                                                                                ('authen_status', (YLeaf(YType.enumeration, 'authen-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchAuthenStatusEn', '')])),
                                                                                ('mlp_negotiated', (YLeaf(YType.enumeration, 'mlp-negotiated'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchMlpNegotiatedEn', '')])),
                                                                            ])
                                                                            self.type = None
                                                                            self.mpls_top_eos = None
                                                                            self.fragment_type = None
                                                                            self.authen_status = None
                                                                            self.mlp_negotiated = None

                                                                            self.ipv4_dscp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                            self.ipv4_dscp.parent = self
                                                                            self._children_name_map["ipv4_dscp"] = "ipv4-dscp"

                                                                            self.ipv6_dscp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                            self.ipv6_dscp.parent = self
                                                                            self._children_name_map["ipv6_dscp"] = "ipv6-dscp"

                                                                            self.dscp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                            self.dscp.parent = self
                                                                            self._children_name_map["dscp"] = "dscp"

                                                                            self.ipv4_prec = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                            self.ipv4_prec.parent = self
                                                                            self._children_name_map["ipv4_prec"] = "ipv4-prec"

                                                                            self.ipv6_prec = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                            self.ipv6_prec.parent = self
                                                                            self._children_name_map["ipv6_prec"] = "ipv6-prec"

                                                                            self.prec = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                            self.prec.parent = self
                                                                            self._children_name_map["prec"] = "prec"

                                                                            self.discard_class = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                            self.discard_class.parent = self
                                                                            self._children_name_map["discard_class"] = "discard-class"

                                                                            self.qos_group = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                            self.qos_group.parent = self
                                                                            self._children_name_map["qos_group"] = "qos-group"

                                                                            self.traffic_class = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                            self.traffic_class.parent = self
                                                                            self._children_name_map["traffic_class"] = "traffic-class"

                                                                            self.proto = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                            self.proto.parent = self
                                                                            self._children_name_map["proto"] = "proto"

                                                                            self.icmp_v4 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                            self.icmp_v4.parent = self
                                                                            self._children_name_map["icmp_v4"] = "icmp-v4"

                                                                            self.icmp_v6 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                            self.icmp_v6.parent = self
                                                                            self._children_name_map["icmp_v6"] = "icmp-v6"

                                                                            self.ipv4_packet_len = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                            self.ipv4_packet_len.parent = self
                                                                            self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"

                                                                            self.ipv6_packet_len = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                            self.ipv6_packet_len.parent = self
                                                                            self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"

                                                                            self.packet_len = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                            self.packet_len.parent = self
                                                                            self._children_name_map["packet_len"] = "packet-len"

                                                                            self.flow_tag = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                            self.flow_tag.parent = self
                                                                            self._children_name_map["flow_tag"] = "flow-tag"

                                                                            self.tcp_flag = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                            self.tcp_flag.parent = self
                                                                            self._children_name_map["tcp_flag"] = "tcp-flag"

                                                                            self.icmpv4_type = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                            self.icmpv4_type.parent = self
                                                                            self._children_name_map["icmpv4_type"] = "icmpv4-type"

                                                                            self.icmpv4_code = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                            self.icmpv4_code.parent = self
                                                                            self._children_name_map["icmpv4_code"] = "icmpv4-code"

                                                                            self.icmpv6_type = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                            self.icmpv6_type.parent = self
                                                                            self._children_name_map["icmpv6_type"] = "icmpv6-type"

                                                                            self.icmpv6_code = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                            self.icmpv6_code.parent = self
                                                                            self._children_name_map["icmpv6_code"] = "icmpv6-code"

                                                                            self.mpls_exp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                            self.mpls_exp.parent = self
                                                                            self._children_name_map["mpls_exp"] = "mpls-exp"

                                                                            self.mpls_exp_imp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                            self.mpls_exp_imp.parent = self
                                                                            self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"

                                                                            self.mpls_disp_ipv4_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                            self.mpls_disp_ipv4_acl.parent = self
                                                                            self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"

                                                                            self.mpls_disp_ipv6_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                            self.mpls_disp_ipv6_acl.parent = self
                                                                            self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"

                                                                            self.mpls_top_label = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                            self.mpls_top_label.parent = self
                                                                            self._children_name_map["mpls_top_label"] = "mpls-top-label"

                                                                            self.cos = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                            self.cos.parent = self
                                                                            self._children_name_map["cos"] = "cos"

                                                                            self.cos_inr = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                            self.cos_inr.parent = self
                                                                            self._children_name_map["cos_inr"] = "cos-inr"

                                                                            self.dei = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                            self.dei.parent = self
                                                                            self._children_name_map["dei"] = "dei"

                                                                            self.dei_inr = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                            self.dei_inr.parent = self
                                                                            self._children_name_map["dei_inr"] = "dei-inr"

                                                                            self.vlan = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                            self.vlan.parent = self
                                                                            self._children_name_map["vlan"] = "vlan"

                                                                            self.vlan_inr = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                            self.vlan_inr.parent = self
                                                                            self._children_name_map["vlan_inr"] = "vlan-inr"

                                                                            self.fr_dlci = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                            self.fr_dlci.parent = self
                                                                            self._children_name_map["fr_dlci"] = "fr-dlci"

                                                                            self.src_mac = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                            self.src_mac.parent = self
                                                                            self._children_name_map["src_mac"] = "src-mac"

                                                                            self.dst_mac = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                            self.dst_mac.parent = self
                                                                            self._children_name_map["dst_mac"] = "dst-mac"

                                                                            self.atm_clp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                            self.atm_clp.parent = self
                                                                            self._children_name_map["atm_clp"] = "atm-clp"

                                                                            self.fr_de = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                            self.fr_de.parent = self
                                                                            self._children_name_map["fr_de"] = "fr-de"

                                                                            self.ipv4_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                            self.ipv4_acl.parent = self
                                                                            self._children_name_map["ipv4_acl"] = "ipv4-acl"

                                                                            self.ipv6_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                            self.ipv6_acl.parent = self
                                                                            self._children_name_map["ipv6_acl"] = "ipv6-acl"

                                                                            self.ether_service_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                            self.ether_service_acl.parent = self
                                                                            self._children_name_map["ether_service_acl"] = "ether-service-acl"

                                                                            self.avail_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                            self.avail_id.parent = self
                                                                            self._children_name_map["avail_id"] = "avail-id"

                                                                            self.media_type = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                            self.media_type.parent = self
                                                                            self._children_name_map["media_type"] = "media-type"

                                                                            self.subs_protocol = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                            self.subs_protocol.parent = self
                                                                            self._children_name_map["subs_protocol"] = "subs-protocol"

                                                                            self.dnis = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                            self.dnis.parent = self
                                                                            self._children_name_map["dnis"] = "dnis"

                                                                            self.dnis_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                            self.dnis_regex.parent = self
                                                                            self._children_name_map["dnis_regex"] = "dnis-regex"

                                                                            self.domain = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                            self.domain.parent = self
                                                                            self._children_name_map["domain"] = "domain"

                                                                            self.domain_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                            self.domain_regex.parent = self
                                                                            self._children_name_map["domain_regex"] = "domain-regex"

                                                                            self.nas_port = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                            self.nas_port.parent = self
                                                                            self._children_name_map["nas_port"] = "nas-port"

                                                                            self.service_name = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                            self.service_name.parent = self
                                                                            self._children_name_map["service_name"] = "service-name"

                                                                            self.service_name_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                            self.service_name_regex.parent = self
                                                                            self._children_name_map["service_name_regex"] = "service-name-regex"

                                                                            self.src_addr_ipv4 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                            self.src_addr_ipv4.parent = self
                                                                            self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"

                                                                            self.dst_addr_ipv4 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                            self.dst_addr_ipv4.parent = self
                                                                            self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"

                                                                            self.src_addr_ipv6 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                            self.src_addr_ipv6.parent = self
                                                                            self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"

                                                                            self.dst_addr_ipv6 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                            self.dst_addr_ipv6.parent = self
                                                                            self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"

                                                                            self.src_addr_mac = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                            self.src_addr_mac.parent = self
                                                                            self._children_name_map["src_addr_mac"] = "src-addr-mac"

                                                                            self.timer = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                            self.timer.parent = self
                                                                            self._children_name_map["timer"] = "timer"

                                                                            self.timer_regexp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                            self.timer_regexp.parent = self
                                                                            self._children_name_map["timer_regexp"] = "timer-regexp"

                                                                            self.tunnel_name = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                            self.tunnel_name.parent = self
                                                                            self._children_name_map["tunnel_name"] = "tunnel-name"

                                                                            self.tunnel_name_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                            self.tunnel_name_regex.parent = self
                                                                            self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"

                                                                            self.user_name = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                            self.user_name.parent = self
                                                                            self._children_name_map["user_name"] = "user-name"

                                                                            self.user_name_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                            self.user_name_regex.parent = self
                                                                            self._children_name_map["user_name_regex"] = "user-name-regex"

                                                                            self.auth_username = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                            self.auth_username.parent = self
                                                                            self._children_name_map["auth_username"] = "auth-username"

                                                                            self.auth_username_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                            self.auth_username_regex.parent = self
                                                                            self._children_name_map["auth_username_regex"] = "auth-username-regex"

                                                                            self.unauth_username = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                            self.unauth_username.parent = self
                                                                            self._children_name_map["unauth_username"] = "unauth-username"

                                                                            self.unauth_username_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                            self.unauth_username_regex.parent = self
                                                                            self._children_name_map["unauth_username_regex"] = "unauth-username-regex"

                                                                            self.auth_domain = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                            self.auth_domain.parent = self
                                                                            self._children_name_map["auth_domain"] = "auth-domain"

                                                                            self.auth_domain_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                            self.auth_domain_regex.parent = self
                                                                            self._children_name_map["auth_domain_regex"] = "auth-domain-regex"

                                                                            self.unauth_domain = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                            self.unauth_domain.parent = self
                                                                            self._children_name_map["unauth_domain"] = "unauth-domain"

                                                                            self.unauth_domain_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                            self.unauth_domain_regex.parent = self
                                                                            self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"

                                                                            self.vendor_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                            self.vendor_id.parent = self
                                                                            self._children_name_map["vendor_id"] = "vendor-id"

                                                                            self.vendor_id_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                            self.vendor_id_regex.parent = self
                                                                            self._children_name_map["vendor_id_regex"] = "vendor-id-regex"

                                                                            self.access_interface = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                            self.access_interface.parent = self
                                                                            self._children_name_map["access_interface"] = "access-interface"

                                                                            self.input_interface = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                            self.input_interface.parent = self
                                                                            self._children_name_map["input_interface"] = "input-interface"

                                                                            self.input_intfhdl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                            self.input_intfhdl.parent = self
                                                                            self._children_name_map["input_intfhdl"] = "input-intfhdl"

                                                                            self.ethertype = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                            self.ethertype.parent = self
                                                                            self._children_name_map["ethertype"] = "ethertype"

                                                                            self.flow_key_data = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                            self.flow_key_data.parent = self
                                                                            self._children_name_map["flow_key_data"] = "flow-key-data"

                                                                            self.dhcp_client_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                            self.dhcp_client_id.parent = self
                                                                            self._children_name_map["dhcp_client_id"] = "dhcp-client-id"

                                                                            self.dhcp_client_id_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                            self.dhcp_client_id_regex.parent = self
                                                                            self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"

                                                                            self.circuit_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                            self.circuit_id.parent = self
                                                                            self._children_name_map["circuit_id"] = "circuit-id"

                                                                            self.circuit_id_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                            self.circuit_id_regex.parent = self
                                                                            self._children_name_map["circuit_id_regex"] = "circuit-id-regex"

                                                                            self.remote_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                            self.remote_id.parent = self
                                                                            self._children_name_map["remote_id"] = "remote-id"

                                                                            self.remote_id_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                            self.remote_id_regex.parent = self
                                                                            self._children_name_map["remote_id_regex"] = "remote-id-regex"

                                                                            self.src_port = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                            self.src_port.parent = self
                                                                            self._children_name_map["src_port"] = "src-port"

                                                                            self.dst_port = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                            self.dst_port.parent = self
                                                                            self._children_name_map["dst_port"] = "dst-port"
                                                                            self._segment_path = lambda: "match-data"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, ['type', 'mpls_top_eos', 'fragment_type', 'authen_status', 'mlp_negotiated'], name, value)


                                                                        class Ipv4Dscp(Entity):
                                                                            """
                                                                            IPv4 DSCP
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                self.yang_name = "ipv4-dscp"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "ipv4-dscp"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "ipv4-dscp"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                        class Ipv6Dscp(Entity):
                                                                            """
                                                                            IPv6 DSCP
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                self.yang_name = "ipv6-dscp"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "ipv6-dscp"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "ipv6-dscp"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                        class Dscp(Entity):
                                                                            """
                                                                            Match DSCP range array
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                self.yang_name = "dscp"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "dscp"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "dscp"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                        class Ipv4Prec(Entity):
                                                                            """
                                                                            IPv4 Precedence
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                self.yang_name = "ipv4-prec"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                ])
                                                                                self.uint8_array = []
                                                                                self._segment_path = lambda: "ipv4-prec"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                        class Ipv6Prec(Entity):
                                                                            """
                                                                            IPv6 Precedence
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                self.yang_name = "ipv6-prec"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                ])
                                                                                self.uint8_array = []
                                                                                self._segment_path = lambda: "ipv6-prec"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                        class Prec(Entity):
                                                                            """
                                                                            Match Precedence array
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                self.yang_name = "prec"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                ])
                                                                                self.uint8_array = []
                                                                                self._segment_path = lambda: "prec"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                        class DiscardClass(Entity):
                                                                            """
                                                                            Match Discard Class array
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                self.yang_name = "discard-class"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                ])
                                                                                self.uint8_array = []
                                                                                self._segment_path = lambda: "discard-class"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                        class QosGroup(Entity):
                                                                            """
                                                                            Match QoS group array
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                self.yang_name = "qos-group"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "qos-group"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "qos-group"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['min', 'max'], name, value)


                                                                        class TrafficClass(Entity):
                                                                            """
                                                                            Match Traffic class array
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                self.yang_name = "traffic-class"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "traffic-class"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "traffic-class"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['min', 'max'], name, value)


                                                                        class Proto(Entity):
                                                                            """
                                                                            Match Protocol array
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                self.yang_name = "proto"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "proto"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "proto"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['min', 'max'], name, value)


                                                                        class IcmpV4(Entity):
                                                                            """
                                                                            Match ICMPV4 Protocol
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	Protocol type
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: code
                                                                            
                                                                            	Protocol code
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                self.yang_name = "icmp-v4"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                    ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                ])
                                                                                self.type = None
                                                                                self.code = None
                                                                                self._segment_path = lambda: "icmp-v4"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['type', 'code'], name, value)


                                                                        class IcmpV6(Entity):
                                                                            """
                                                                            Match ICMPV6 Protocol array
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	Protocol type
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: code
                                                                            
                                                                            	Protocol code
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                self.yang_name = "icmp-v6"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                    ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                ])
                                                                                self.type = None
                                                                                self.code = None
                                                                                self._segment_path = lambda: "icmp-v6"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['type', 'code'], name, value)


                                                                        class Ipv4PacketLen(Entity):
                                                                            """
                                                                            IPv4 packet length array
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                self.yang_name = "ipv4-packet-len"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "ipv4-packet-len"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "ipv4-packet-len"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                        class Ipv6PacketLen(Entity):
                                                                            """
                                                                            IPv6 packet length array
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                self.yang_name = "ipv6-packet-len"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "ipv6-packet-len"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "ipv6-packet-len"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                        class PacketLen(Entity):
                                                                            """
                                                                            Match packet length array
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                self.yang_name = "packet-len"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "packet-len"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "packet-len"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                        class FlowTag(Entity):
                                                                            """
                                                                            Match flow\-tag array
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                self.yang_name = "flow-tag"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "flow-tag"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "flow-tag"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['min', 'max'], name, value)


                                                                        class TcpFlag(Entity):
                                                                            """
                                                                            Match tcp flag value
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	Value of TCP flag
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: match_any
                                                                            
                                                                            	Match any TCP flag bit
                                                                            	**type**\: bool
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                self.yang_name = "tcp-flag"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                    ('match_any', (YLeaf(YType.boolean, 'match-any'), ['bool'])),
                                                                                ])
                                                                                self.value = None
                                                                                self.match_any = None
                                                                                self._segment_path = lambda: "tcp-flag"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['value', 'match_any'], name, value)


                                                                        class Icmpv4Type(Entity):
                                                                            """
                                                                            Match ipv4 icmp type
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                self.yang_name = "icmpv4-type"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "icmpv4-type"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "icmpv4-type"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                        class Icmpv4Code(Entity):
                                                                            """
                                                                            Match ipv4 icmp code
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                self.yang_name = "icmpv4-code"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "icmpv4-code"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "icmpv4-code"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                        class Icmpv6Type(Entity):
                                                                            """
                                                                            Match ipv6 icmp type
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                self.yang_name = "icmpv6-type"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "icmpv6-type"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "icmpv6-type"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                        class Icmpv6Code(Entity):
                                                                            """
                                                                            Match ipv6 icmp code
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                self.yang_name = "icmpv6-code"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "icmpv6-code"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "icmpv6-code"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                        class MplsExp(Entity):
                                                                            """
                                                                            Match MPLS experimental topmost array
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                self.yang_name = "mpls-exp"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                ])
                                                                                self.uint8_array = []
                                                                                self._segment_path = lambda: "mpls-exp"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                        class MplsExpImp(Entity):
                                                                            """
                                                                            Match MPLS experimental imposition array
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                self.yang_name = "mpls-exp-imp"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                ])
                                                                                self.uint8_array = []
                                                                                self._segment_path = lambda: "mpls-exp-imp"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                        class MplsDispIpv4Acl(Entity):
                                                                            """
                                                                            MPLS Disposition IPv4 Access\-list
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                self.yang_name = "mpls-disp-ipv4-acl"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "mpls-disp-ipv4-acl"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                        class MplsDispIpv6Acl(Entity):
                                                                            """
                                                                            MPLS Disposition IPv6 Access\-list
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                self.yang_name = "mpls-disp-ipv6-acl"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "mpls-disp-ipv6-acl"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                        class MplsTopLabel(Entity):
                                                                            """
                                                                            MPLS Topmost LABEL
                                                                            
                                                                            .. attribute:: uint32_rng_array
                                                                            
                                                                            	uint32 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                self.yang_name = "mpls-top-label"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint32_rng_array", ("uint32_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint32_rng_array = YList(self)
                                                                                self._segment_path = lambda: "mpls-top-label"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                            class Uint32RngArray(Entity):
                                                                                """
                                                                                uint32 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                    self.yang_name = "uint32_rng_array"
                                                                                    self.yang_parent_name = "mpls-top-label"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint32, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint32, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint32_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['min', 'max'], name, value)


                                                                        class Cos(Entity):
                                                                            """
                                                                            Match CoS array
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                self.yang_name = "cos"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                ])
                                                                                self.uint8_array = []
                                                                                self._segment_path = lambda: "cos"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                        class CosInr(Entity):
                                                                            """
                                                                            Match inner header CoS
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                self.yang_name = "cos-inr"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                ])
                                                                                self.uint8_array = []
                                                                                self._segment_path = lambda: "cos-inr"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                        class Dei(Entity):
                                                                            """
                                                                            Match DEI Bit
                                                                            
                                                                            .. attribute:: bit_value
                                                                            
                                                                            	Value of the DEI bit
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                self.yang_name = "dei"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                ])
                                                                                self.bit_value = None
                                                                                self._segment_path = lambda: "dei"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                        class DeiInr(Entity):
                                                                            """
                                                                            Match inner DEI Bit
                                                                            
                                                                            .. attribute:: bit_value
                                                                            
                                                                            	Value of the DEI bit
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                self.yang_name = "dei-inr"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                ])
                                                                                self.bit_value = None
                                                                                self._segment_path = lambda: "dei-inr"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                        class Vlan(Entity):
                                                                            """
                                                                            Match VLAN array
                                                                            
                                                                            .. attribute:: vlan_id_array
                                                                            
                                                                            	vlan id array
                                                                            	**type**\: list of  		 :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                self.yang_name = "vlan"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("vlan-id-array", ("vlan_id_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.vlan_id_array = YList(self)
                                                                                self._segment_path = lambda: "vlan"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                            class VlanIdArray(Entity):
                                                                                """
                                                                                vlan id array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	VLAN mask
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                    self.yang_name = "vlan-id-array"
                                                                                    self.yang_parent_name = "vlan"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ('mask', (YLeaf(YType.uint16, 'mask'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self.mask = None
                                                                                    self._segment_path = lambda: "vlan-id-array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['min', 'max', 'mask'], name, value)


                                                                        class VlanInr(Entity):
                                                                            """
                                                                            Match inner header VLAN range array
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                self.yang_name = "vlan-inr"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "vlan-inr"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "vlan-inr"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['min', 'max'], name, value)


                                                                        class FrDlci(Entity):
                                                                            """
                                                                            Match FR DLCI range array
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                self.yang_name = "fr-dlci"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "fr-dlci"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "fr-dlci"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['min', 'max'], name, value)


                                                                        class SrcMac(Entity):
                                                                            """
                                                                            Match Source MAC address
                                                                            
                                                                            .. attribute:: mac_addr
                                                                            
                                                                            	MAC address
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: mask
                                                                            
                                                                            	MAC mask
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                self.yang_name = "src-mac"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                    ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                ])
                                                                                self.mac_addr = []
                                                                                self.mask = []
                                                                                self._segment_path = lambda: "src-mac"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                        class DstMac(Entity):
                                                                            """
                                                                            Match Destination MAC address
                                                                            
                                                                            .. attribute:: mac_addr
                                                                            
                                                                            	MAC address
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: mask
                                                                            
                                                                            	MAC mask
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                self.yang_name = "dst-mac"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                    ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                ])
                                                                                self.mac_addr = []
                                                                                self.mask = []
                                                                                self._segment_path = lambda: "dst-mac"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                        class AtmClp(Entity):
                                                                            """
                                                                            Match ATM CLP level
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                self.yang_name = "atm-clp"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                ])
                                                                                self.uint8_array = []
                                                                                self._segment_path = lambda: "atm-clp"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                        class FrDe(Entity):
                                                                            """
                                                                            Match FR DE value
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                self.yang_name = "fr-de"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                ])
                                                                                self.uint8_array = []
                                                                                self._segment_path = lambda: "fr-de"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                        class Ipv4Acl(Entity):
                                                                            """
                                                                            IPv4 Access\-list
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                self.yang_name = "ipv4-acl"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "ipv4-acl"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                        class Ipv6Acl(Entity):
                                                                            """
                                                                            IPv6 Access\-list
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                self.yang_name = "ipv6-acl"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "ipv6-acl"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                        class EtherServiceAcl(Entity):
                                                                            """
                                                                            Ethernet\-Services Access\-list
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                self.yang_name = "ether-service-acl"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "ether-service-acl"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                        class AvailId(Entity):
                                                                            """
                                                                            Available Identifiers
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                self.yang_name = "avail-id"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                ])
                                                                                self.uint8_array = []
                                                                                self._segment_path = lambda: "avail-id"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                        class MediaType(Entity):
                                                                            """
                                                                            Media Type
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                self.yang_name = "media-type"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                ])
                                                                                self.uint8_array = []
                                                                                self._segment_path = lambda: "media-type"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                        class SubsProtocol(Entity):
                                                                            """
                                                                            Protocol
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                self.yang_name = "subs-protocol"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                ])
                                                                                self.uint8_array = []
                                                                                self._segment_path = lambda: "subs-protocol"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                        class Dnis(Entity):
                                                                            """
                                                                            DNIS
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                self.yang_name = "dnis"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "dnis"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                        class DnisRegex(Entity):
                                                                            """
                                                                            DNIS Regular Expression
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                self.yang_name = "dnis-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "dnis-regex"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                        class Domain(Entity):
                                                                            """
                                                                            Domain Name
                                                                            
                                                                            .. attribute:: domain_array
                                                                            
                                                                            	domain array
                                                                            	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                self.yang_name = "domain"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.domain_array = YList(self)
                                                                                self._segment_path = lambda: "domain"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                            class DomainArray(Entity):
                                                                                """
                                                                                domain array
                                                                                
                                                                                .. attribute:: domain_name
                                                                                
                                                                                	domain name
                                                                                	**type**\: str
                                                                                
                                                                                .. attribute:: format_name
                                                                                
                                                                                	format name
                                                                                	**type**\: str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                    self.yang_name = "domain-array"
                                                                                    self.yang_parent_name = "domain"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                        ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                    ])
                                                                                    self.domain_name = None
                                                                                    self.format_name = None
                                                                                    self._segment_path = lambda: "domain-array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                        class DomainRegex(Entity):
                                                                            """
                                                                            Domain Regular Expression
                                                                            
                                                                            .. attribute:: domain_array
                                                                            
                                                                            	domain array
                                                                            	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                self.yang_name = "domain-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.domain_array = YList(self)
                                                                                self._segment_path = lambda: "domain-regex"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                            class DomainArray(Entity):
                                                                                """
                                                                                domain array
                                                                                
                                                                                .. attribute:: domain_name
                                                                                
                                                                                	domain name
                                                                                	**type**\: str
                                                                                
                                                                                .. attribute:: format_name
                                                                                
                                                                                	format name
                                                                                	**type**\: str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                    self.yang_name = "domain-array"
                                                                                    self.yang_parent_name = "domain-regex"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                        ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                    ])
                                                                                    self.domain_name = None
                                                                                    self.format_name = None
                                                                                    self._segment_path = lambda: "domain-array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                        class NasPort(Entity):
                                                                            """
                                                                            NAS Port
                                                                            
                                                                            .. attribute:: nas_port_array
                                                                            
                                                                            	nas port array
                                                                            	**type**\: list of  		 :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                self.yang_name = "nas-port"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("nas-port-array", ("nas_port_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.nas_port_array = YList(self)
                                                                                self._segment_path = lambda: "nas-port"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                            class NasPortArray(Entity):
                                                                                """
                                                                                nas port array
                                                                                
                                                                                .. attribute:: sub_id
                                                                                
                                                                                	sub id
                                                                                	**type**\:  :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                
                                                                                .. attribute:: operator
                                                                                
                                                                                	operator
                                                                                	**type**\:  :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                    self.yang_name = "nas-port-array"
                                                                                    self.yang_parent_name = "nas-port"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('sub_id', (YLeaf(YType.enumeration, 'sub-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchNasPortSubIdEn', '')])),
                                                                                        ('operator', (YLeaf(YType.enumeration, 'operator'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchLogicalOperatorEn', '')])),
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ])
                                                                                    self.sub_id = None
                                                                                    self.operator = None
                                                                                    self.value = None
                                                                                    self._segment_path = lambda: "nas-port-array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['sub_id', 'operator', 'value'], name, value)


                                                                        class ServiceName(Entity):
                                                                            """
                                                                            Service Name
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                self.yang_name = "service-name"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "service-name"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                        class ServiceNameRegex(Entity):
                                                                            """
                                                                            Service Name Regular Exp
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                self.yang_name = "service-name-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "service-name-regex"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                        class SrcAddrIpv4(Entity):
                                                                            """
                                                                            Source Address IPV4
                                                                            
                                                                            .. attribute:: ipv4_addr_array
                                                                            
                                                                            	ipv4 addr array
                                                                            	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                self.yang_name = "src-addr-ipv4"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.ipv4_addr_array = YList(self)
                                                                                self._segment_path = lambda: "src-addr-ipv4"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                            class Ipv4AddrArray(Entity):
                                                                                """
                                                                                ipv4 addr array
                                                                                
                                                                                .. attribute:: prefix
                                                                                
                                                                                	prefix
                                                                                	**type**\: str
                                                                                
                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	mask
                                                                                	**type**\: str
                                                                                
                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                    self.yang_name = "ipv4-addr-array"
                                                                                    self.yang_parent_name = "src-addr-ipv4"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                        ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                    ])
                                                                                    self.prefix = None
                                                                                    self.mask = None
                                                                                    self._segment_path = lambda: "ipv4-addr-array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                        class DstAddrIpv4(Entity):
                                                                            """
                                                                            Destination Address IPV4
                                                                            
                                                                            .. attribute:: ipv4_addr_array
                                                                            
                                                                            	ipv4 addr array
                                                                            	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                self.yang_name = "dst-addr-ipv4"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.ipv4_addr_array = YList(self)
                                                                                self._segment_path = lambda: "dst-addr-ipv4"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                            class Ipv4AddrArray(Entity):
                                                                                """
                                                                                ipv4 addr array
                                                                                
                                                                                .. attribute:: prefix
                                                                                
                                                                                	prefix
                                                                                	**type**\: str
                                                                                
                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	mask
                                                                                	**type**\: str
                                                                                
                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                    self.yang_name = "ipv4-addr-array"
                                                                                    self.yang_parent_name = "dst-addr-ipv4"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                        ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                    ])
                                                                                    self.prefix = None
                                                                                    self.mask = None
                                                                                    self._segment_path = lambda: "ipv4-addr-array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                        class SrcAddrIpv6(Entity):
                                                                            """
                                                                            Source Address IPV6
                                                                            
                                                                            .. attribute:: ipv6_addr_array
                                                                            
                                                                            	ipv6 addr array
                                                                            	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                self.yang_name = "src-addr-ipv6"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.ipv6_addr_array = YList(self)
                                                                                self._segment_path = lambda: "src-addr-ipv6"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                            class Ipv6AddrArray(Entity):
                                                                                """
                                                                                ipv6 addr array
                                                                                
                                                                                .. attribute:: prefix
                                                                                
                                                                                	IPV6 prefix
                                                                                	**type**\: str
                                                                                
                                                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	IPV6 mask
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                    self.yang_name = "ipv6-addr-array"
                                                                                    self.yang_parent_name = "src-addr-ipv6"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                        ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                    ])
                                                                                    self.prefix = None
                                                                                    self.mask = None
                                                                                    self._segment_path = lambda: "ipv6-addr-array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                        class DstAddrIpv6(Entity):
                                                                            """
                                                                            Destination Address IPV6
                                                                            
                                                                            .. attribute:: ipv6_addr_array
                                                                            
                                                                            	ipv6 addr array
                                                                            	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                self.yang_name = "dst-addr-ipv6"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.ipv6_addr_array = YList(self)
                                                                                self._segment_path = lambda: "dst-addr-ipv6"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                            class Ipv6AddrArray(Entity):
                                                                                """
                                                                                ipv6 addr array
                                                                                
                                                                                .. attribute:: prefix
                                                                                
                                                                                	IPV6 prefix
                                                                                	**type**\: str
                                                                                
                                                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	IPV6 mask
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                    self.yang_name = "ipv6-addr-array"
                                                                                    self.yang_parent_name = "dst-addr-ipv6"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                        ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                    ])
                                                                                    self.prefix = None
                                                                                    self.mask = None
                                                                                    self._segment_path = lambda: "ipv6-addr-array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                        class SrcAddrMac(Entity):
                                                                            """
                                                                            Source Address MAC
                                                                            
                                                                            .. attribute:: mac_addr_array
                                                                            
                                                                            	mac addr array
                                                                            	**type**\: list of  		 :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                self.yang_name = "src-addr-mac"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("mac-addr-array", ("mac_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.mac_addr_array = YList(self)
                                                                                self._segment_path = lambda: "src-addr-mac"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                            class MacAddrArray(Entity):
                                                                                """
                                                                                mac addr array
                                                                                
                                                                                .. attribute:: mac_addr
                                                                                
                                                                                	MAC address
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	MAC mask
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                    self.yang_name = "mac-addr-array"
                                                                                    self.yang_parent_name = "src-addr-mac"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                    ])
                                                                                    self.mac_addr = []
                                                                                    self.mask = []
                                                                                    self._segment_path = lambda: "mac-addr-array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                        class Timer(Entity):
                                                                            """
                                                                            Timer
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                self.yang_name = "timer"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "timer"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                        class TimerRegexp(Entity):
                                                                            """
                                                                            Timer Regular Expression
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                self.yang_name = "timer-regexp"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "timer-regexp"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                        class TunnelName(Entity):
                                                                            """
                                                                            Tunnel Name
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                self.yang_name = "tunnel-name"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "tunnel-name"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                        class TunnelNameRegex(Entity):
                                                                            """
                                                                            Tunnel Name Regular Expression
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                self.yang_name = "tunnel-name-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "tunnel-name-regex"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                        class UserName(Entity):
                                                                            """
                                                                            User Name
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                self.yang_name = "user-name"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "user-name"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                        class UserNameRegex(Entity):
                                                                            """
                                                                            User Name Regular Expression
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                self.yang_name = "user-name-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "user-name-regex"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                        class AuthUsername(Entity):
                                                                            """
                                                                            Authenticated User Name
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                self.yang_name = "auth-username"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "auth-username"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                        class AuthUsernameRegex(Entity):
                                                                            """
                                                                            Authenticated User Name RegEx
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                self.yang_name = "auth-username-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "auth-username-regex"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                        class UnauthUsername(Entity):
                                                                            """
                                                                            Unauthenticated User Name
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                self.yang_name = "unauth-username"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "unauth-username"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                        class UnauthUsernameRegex(Entity):
                                                                            """
                                                                            Unauthenticated User Name RegEx
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                self.yang_name = "unauth-username-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "unauth-username-regex"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                        class AuthDomain(Entity):
                                                                            """
                                                                            Authenticated domain name
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                self.yang_name = "auth-domain"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "auth-domain"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                        class AuthDomainRegex(Entity):
                                                                            """
                                                                            Authenticated Domain Name RegEx
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                self.yang_name = "auth-domain-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "auth-domain-regex"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                        class UnauthDomain(Entity):
                                                                            """
                                                                            Unauthenticated Domain Name
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                self.yang_name = "unauth-domain"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "unauth-domain"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                        class UnauthDomainRegex(Entity):
                                                                            """
                                                                            Unauthenticated Domain Name RegEx
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                self.yang_name = "unauth-domain-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "unauth-domain-regex"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                        class VendorId(Entity):
                                                                            """
                                                                            Vendor ID
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                self.yang_name = "vendor-id"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "vendor-id"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                        class VendorIdRegex(Entity):
                                                                            """
                                                                            Vendor ID RegEx
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                self.yang_name = "vendor-id-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "vendor-id-regex"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                        class AccessInterface(Entity):
                                                                            """
                                                                            Access interface
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                self.yang_name = "access-interface"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "access-interface"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                        class InputInterface(Entity):
                                                                            """
                                                                            Input interface
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                self.yang_name = "input-interface"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "input-interface"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                        class InputIntfhdl(Entity):
                                                                            """
                                                                            Input interface handle
                                                                            
                                                                            .. attribute:: uint64_array
                                                                            
                                                                            	uint64 array
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                self.yang_name = "input-intfhdl"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('uint64_array', (YLeafList(YType.uint64, 'uint64_array'), ['int'])),
                                                                                ])
                                                                                self.uint64_array = []
                                                                                self._segment_path = lambda: "input-intfhdl"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                        class Ethertype(Entity):
                                                                            """
                                                                            Ethernet type
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                self.yang_name = "ethertype"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "ethertype"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "ethertype"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['min', 'max'], name, value)


                                                                        class FlowKeyData(Entity):
                                                                            """
                                                                            Flow key structure
                                                                            
                                                                            .. attribute:: flow_keys
                                                                            
                                                                            	flow keys
                                                                            	**type**\:  :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                            
                                                                            .. attribute:: max_count
                                                                            
                                                                            	Maximum count of flows
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: idle_timeout
                                                                            
                                                                            	Idle timeout of flows (in seconds)
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            	**units**\: second
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                self.yang_name = "flow-key-data"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("flow-keys", ("flow_keys", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('max_count', (YLeaf(YType.uint16, 'max-count'), ['int'])),
                                                                                    ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                                ])
                                                                                self.max_count = None
                                                                                self.idle_timeout = None

                                                                                self.flow_keys = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                self.flow_keys.parent = self
                                                                                self._children_name_map["flow_keys"] = "flow-keys"
                                                                                self._segment_path = lambda: "flow-key-data"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['max_count', 'idle_timeout'], name, value)


                                                                            class FlowKeys(Entity):
                                                                                """
                                                                                flow keys
                                                                                
                                                                                .. attribute:: keys
                                                                                
                                                                                	keys
                                                                                	**type**\: str
                                                                                
                                                                                	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                
                                                                                .. attribute:: num
                                                                                
                                                                                	num
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                    self.yang_name = "flow-keys"
                                                                                    self.yang_parent_name = "flow-key-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('keys', (YLeaf(YType.str, 'keys'), ['str'])),
                                                                                        ('num', (YLeaf(YType.uint8, 'num'), ['int'])),
                                                                                    ])
                                                                                    self.keys = None
                                                                                    self.num = None
                                                                                    self._segment_path = lambda: "flow-keys"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                        class DhcpClientId(Entity):
                                                                            """
                                                                            Dhcp Client ID
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                self.yang_name = "dhcp-client-id"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "dhcp-client-id"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                        class DhcpClientIdRegex(Entity):
                                                                            """
                                                                            Dhcp Client ID RegEx
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                self.yang_name = "dhcp-client-id-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "dhcp-client-id-regex"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                        class CircuitId(Entity):
                                                                            """
                                                                            Circuit ID
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                self.yang_name = "circuit-id"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "circuit-id"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                        class CircuitIdRegex(Entity):
                                                                            """
                                                                            Circuit ID RegEx
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                self.yang_name = "circuit-id-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "circuit-id-regex"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                        class RemoteId(Entity):
                                                                            """
                                                                            Remote ID
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                self.yang_name = "remote-id"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "remote-id"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                        class RemoteIdRegex(Entity):
                                                                            """
                                                                            Remote ID RegEx
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                self.yang_name = "remote-id-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "remote-id-regex"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                        class SrcPort(Entity):
                                                                            """
                                                                            Source port
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                self.yang_name = "src-port"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "src-port"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "src-port"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                        class DstPort(Entity):
                                                                            """
                                                                            Destination port
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                self.yang_name = "dst-port"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "dst-port"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "dst-port"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['min', 'max'], name, value)


                                                    class ClmpP(Entity):
                                                        """
                                                        clmp p
                                                        
                                                        .. attribute:: class_map_bg
                                                        
                                                        	class map bg
                                                        	**type**\: list of  		 :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2018-01-17'

                                                        def __init__(self):
                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP, self).__init__()

                                                            self.yang_name = "clmp-p"
                                                            self.yang_parent_name = "policy-class-info-bg"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("class-map-bg", ("class_map_bg", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg))])
                                                            self._leafs = OrderedDict()

                                                            self.class_map_bg = YList(self)
                                                            self._segment_path = lambda: "clmp-p"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP, [], name, value)


                                                        class ClassMapBg(Entity):
                                                            """
                                                            class map bg
                                                            
                                                            .. attribute:: match_infop
                                                            
                                                            	Pointer to the first Match info
                                                            	**type**\:  :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop>`
                                                            
                                                            .. attribute:: name
                                                            
                                                            	Name of the class\-map
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..65
                                                            
                                                            .. attribute:: type
                                                            
                                                            	Class\-Map Type QoS/PBR/Netflow/..
                                                            	**type**\:  :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                            
                                                            .. attribute:: mode
                                                            
                                                            	Class\-Map Mode Match any/Match all
                                                            	**type**\:  :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                            
                                                            .. attribute:: description
                                                            
                                                            	description
                                                            	**type**\: str
                                                            
                                                            

                                                            """

                                                            _prefix = 'infra-policymgr-oper'
                                                            _revision = '2018-01-17'

                                                            def __init__(self):
                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg, self).__init__()

                                                                self.yang_name = "class-map-bg"
                                                                self.yang_parent_name = "clmp-p"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("match-infop", ("match_infop", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop))])
                                                                self._leafs = OrderedDict([
                                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapTypeEn', '')])),
                                                                    ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapModeEn', '')])),
                                                                    ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                ])
                                                                self.name = None
                                                                self.type = None
                                                                self.mode = None
                                                                self.description = None

                                                                self.match_infop = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop()
                                                                self.match_infop.parent = self
                                                                self._children_name_map["match_infop"] = "match-infop"
                                                                self._segment_path = lambda: "class-map-bg"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg, ['name', 'type', 'mode', 'description'], name, value)


                                                            class MatchInfop(Entity):
                                                                """
                                                                Pointer to the first Match info
                                                                
                                                                .. attribute:: class_match_info_st
                                                                
                                                                	class match info st
                                                                	**type**\: list of  		 :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop, self).__init__()

                                                                    self.yang_name = "match-infop"
                                                                    self.yang_parent_name = "class-map-bg"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("class-match-info-st", ("class_match_info_st", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt))])
                                                                    self._leafs = OrderedDict()

                                                                    self.class_match_info_st = YList(self)
                                                                    self._segment_path = lambda: "match-infop"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop, [], name, value)


                                                                class ClassMatchInfoSt(Entity):
                                                                    """
                                                                    class match info st
                                                                    
                                                                    .. attribute:: match_data
                                                                    
                                                                    	Match criteria
                                                                    	**type**\:  :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                    
                                                                    .. attribute:: flags
                                                                    
                                                                    	Flags
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                        self.yang_name = "class-match-info-st"
                                                                        self.yang_parent_name = "match-infop"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("match-data", ("match_data", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData))])
                                                                        self._leafs = OrderedDict([
                                                                            ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                        ])
                                                                        self.flags = None

                                                                        self.match_data = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                        self.match_data.parent = self
                                                                        self._children_name_map["match_data"] = "match-data"
                                                                        self._segment_path = lambda: "class-match-info-st"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                    class MatchData(Entity):
                                                                        """
                                                                        Match criteria
                                                                        
                                                                        .. attribute:: ipv4_dscp
                                                                        
                                                                        	IPv4 DSCP
                                                                        	**type**\:  :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                        
                                                                        .. attribute:: ipv6_dscp
                                                                        
                                                                        	IPv6 DSCP
                                                                        	**type**\:  :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                        
                                                                        .. attribute:: dscp
                                                                        
                                                                        	Match DSCP range array
                                                                        	**type**\:  :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                        
                                                                        .. attribute:: ipv4_prec
                                                                        
                                                                        	IPv4 Precedence
                                                                        	**type**\:  :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                        
                                                                        .. attribute:: ipv6_prec
                                                                        
                                                                        	IPv6 Precedence
                                                                        	**type**\:  :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                        
                                                                        .. attribute:: prec
                                                                        
                                                                        	Match Precedence array
                                                                        	**type**\:  :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                        
                                                                        .. attribute:: discard_class
                                                                        
                                                                        	Match Discard Class array
                                                                        	**type**\:  :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                        
                                                                        .. attribute:: qos_group
                                                                        
                                                                        	Match QoS group array
                                                                        	**type**\:  :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                        
                                                                        .. attribute:: traffic_class
                                                                        
                                                                        	Match Traffic class array
                                                                        	**type**\:  :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                        
                                                                        .. attribute:: proto
                                                                        
                                                                        	Match Protocol array
                                                                        	**type**\:  :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                        
                                                                        .. attribute:: icmp_v4
                                                                        
                                                                        	Match ICMPV4 Protocol
                                                                        	**type**\:  :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                        
                                                                        .. attribute:: icmp_v6
                                                                        
                                                                        	Match ICMPV6 Protocol array
                                                                        	**type**\:  :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                        
                                                                        .. attribute:: ipv4_packet_len
                                                                        
                                                                        	IPv4 packet length array
                                                                        	**type**\:  :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                        
                                                                        .. attribute:: ipv6_packet_len
                                                                        
                                                                        	IPv6 packet length array
                                                                        	**type**\:  :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                        
                                                                        .. attribute:: packet_len
                                                                        
                                                                        	Match packet length array
                                                                        	**type**\:  :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                        
                                                                        .. attribute:: flow_tag
                                                                        
                                                                        	Match flow\-tag array
                                                                        	**type**\:  :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                        
                                                                        .. attribute:: tcp_flag
                                                                        
                                                                        	Match tcp flag value
                                                                        	**type**\:  :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                        
                                                                        .. attribute:: icmpv4_type
                                                                        
                                                                        	Match ipv4 icmp type
                                                                        	**type**\:  :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                        
                                                                        .. attribute:: icmpv4_code
                                                                        
                                                                        	Match ipv4 icmp code
                                                                        	**type**\:  :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                        
                                                                        .. attribute:: icmpv6_type
                                                                        
                                                                        	Match ipv6 icmp type
                                                                        	**type**\:  :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                        
                                                                        .. attribute:: icmpv6_code
                                                                        
                                                                        	Match ipv6 icmp code
                                                                        	**type**\:  :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                        
                                                                        .. attribute:: mpls_exp
                                                                        
                                                                        	Match MPLS experimental topmost array
                                                                        	**type**\:  :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                        
                                                                        .. attribute:: mpls_exp_imp
                                                                        
                                                                        	Match MPLS experimental imposition array
                                                                        	**type**\:  :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                        
                                                                        .. attribute:: mpls_disp_ipv4_acl
                                                                        
                                                                        	MPLS Disposition IPv4 Access\-list
                                                                        	**type**\:  :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                        
                                                                        .. attribute:: mpls_disp_ipv6_acl
                                                                        
                                                                        	MPLS Disposition IPv6 Access\-list
                                                                        	**type**\:  :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                        
                                                                        .. attribute:: mpls_top_label
                                                                        
                                                                        	MPLS Topmost LABEL
                                                                        	**type**\:  :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                        
                                                                        .. attribute:: cos
                                                                        
                                                                        	Match CoS array
                                                                        	**type**\:  :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                        
                                                                        .. attribute:: cos_inr
                                                                        
                                                                        	Match inner header CoS
                                                                        	**type**\:  :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                        
                                                                        .. attribute:: dei
                                                                        
                                                                        	Match DEI Bit
                                                                        	**type**\:  :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                        
                                                                        .. attribute:: dei_inr
                                                                        
                                                                        	Match inner DEI Bit
                                                                        	**type**\:  :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                        
                                                                        .. attribute:: vlan
                                                                        
                                                                        	Match VLAN array
                                                                        	**type**\:  :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                        
                                                                        .. attribute:: vlan_inr
                                                                        
                                                                        	Match inner header VLAN range array
                                                                        	**type**\:  :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                        
                                                                        .. attribute:: fr_dlci
                                                                        
                                                                        	Match FR DLCI range array
                                                                        	**type**\:  :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                        
                                                                        .. attribute:: src_mac
                                                                        
                                                                        	Match Source MAC address
                                                                        	**type**\:  :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                        
                                                                        .. attribute:: dst_mac
                                                                        
                                                                        	Match Destination MAC address
                                                                        	**type**\:  :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                        
                                                                        .. attribute:: atm_clp
                                                                        
                                                                        	Match ATM CLP level
                                                                        	**type**\:  :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                        
                                                                        .. attribute:: fr_de
                                                                        
                                                                        	Match FR DE value
                                                                        	**type**\:  :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                        
                                                                        .. attribute:: ipv4_acl
                                                                        
                                                                        	IPv4 Access\-list
                                                                        	**type**\:  :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                        
                                                                        .. attribute:: ipv6_acl
                                                                        
                                                                        	IPv6 Access\-list
                                                                        	**type**\:  :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                        
                                                                        .. attribute:: ether_service_acl
                                                                        
                                                                        	Ethernet\-Services Access\-list
                                                                        	**type**\:  :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                        
                                                                        .. attribute:: avail_id
                                                                        
                                                                        	Available Identifiers
                                                                        	**type**\:  :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                        
                                                                        .. attribute:: media_type
                                                                        
                                                                        	Media Type
                                                                        	**type**\:  :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                        
                                                                        .. attribute:: subs_protocol
                                                                        
                                                                        	Protocol
                                                                        	**type**\:  :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                        
                                                                        .. attribute:: dnis
                                                                        
                                                                        	DNIS
                                                                        	**type**\:  :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                        
                                                                        .. attribute:: dnis_regex
                                                                        
                                                                        	DNIS Regular Expression
                                                                        	**type**\:  :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                        
                                                                        .. attribute:: domain
                                                                        
                                                                        	Domain Name
                                                                        	**type**\:  :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                        
                                                                        .. attribute:: domain_regex
                                                                        
                                                                        	Domain Regular Expression
                                                                        	**type**\:  :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                        
                                                                        .. attribute:: nas_port
                                                                        
                                                                        	NAS Port
                                                                        	**type**\:  :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                        
                                                                        .. attribute:: service_name
                                                                        
                                                                        	Service Name
                                                                        	**type**\:  :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                        
                                                                        .. attribute:: service_name_regex
                                                                        
                                                                        	Service Name Regular Exp
                                                                        	**type**\:  :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                        
                                                                        .. attribute:: src_addr_ipv4
                                                                        
                                                                        	Source Address IPV4
                                                                        	**type**\:  :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                        
                                                                        .. attribute:: dst_addr_ipv4
                                                                        
                                                                        	Destination Address IPV4
                                                                        	**type**\:  :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                        
                                                                        .. attribute:: src_addr_ipv6
                                                                        
                                                                        	Source Address IPV6
                                                                        	**type**\:  :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                        
                                                                        .. attribute:: dst_addr_ipv6
                                                                        
                                                                        	Destination Address IPV6
                                                                        	**type**\:  :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                        
                                                                        .. attribute:: src_addr_mac
                                                                        
                                                                        	Source Address MAC
                                                                        	**type**\:  :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                        
                                                                        .. attribute:: timer
                                                                        
                                                                        	Timer
                                                                        	**type**\:  :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                        
                                                                        .. attribute:: timer_regexp
                                                                        
                                                                        	Timer Regular Expression
                                                                        	**type**\:  :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                        
                                                                        .. attribute:: tunnel_name
                                                                        
                                                                        	Tunnel Name
                                                                        	**type**\:  :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                        
                                                                        .. attribute:: tunnel_name_regex
                                                                        
                                                                        	Tunnel Name Regular Expression
                                                                        	**type**\:  :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                        
                                                                        .. attribute:: user_name
                                                                        
                                                                        	User Name
                                                                        	**type**\:  :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                        
                                                                        .. attribute:: user_name_regex
                                                                        
                                                                        	User Name Regular Expression
                                                                        	**type**\:  :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                        
                                                                        .. attribute:: auth_username
                                                                        
                                                                        	Authenticated User Name
                                                                        	**type**\:  :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                        
                                                                        .. attribute:: auth_username_regex
                                                                        
                                                                        	Authenticated User Name RegEx
                                                                        	**type**\:  :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                        
                                                                        .. attribute:: unauth_username
                                                                        
                                                                        	Unauthenticated User Name
                                                                        	**type**\:  :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                        
                                                                        .. attribute:: unauth_username_regex
                                                                        
                                                                        	Unauthenticated User Name RegEx
                                                                        	**type**\:  :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                        
                                                                        .. attribute:: auth_domain
                                                                        
                                                                        	Authenticated domain name
                                                                        	**type**\:  :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                        
                                                                        .. attribute:: auth_domain_regex
                                                                        
                                                                        	Authenticated Domain Name RegEx
                                                                        	**type**\:  :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                        
                                                                        .. attribute:: unauth_domain
                                                                        
                                                                        	Unauthenticated Domain Name
                                                                        	**type**\:  :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                        
                                                                        .. attribute:: unauth_domain_regex
                                                                        
                                                                        	Unauthenticated Domain Name RegEx
                                                                        	**type**\:  :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                        
                                                                        .. attribute:: vendor_id
                                                                        
                                                                        	Vendor ID
                                                                        	**type**\:  :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                        
                                                                        .. attribute:: vendor_id_regex
                                                                        
                                                                        	Vendor ID RegEx
                                                                        	**type**\:  :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                        
                                                                        .. attribute:: access_interface
                                                                        
                                                                        	Access interface
                                                                        	**type**\:  :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                        
                                                                        .. attribute:: input_interface
                                                                        
                                                                        	Input interface
                                                                        	**type**\:  :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                        
                                                                        .. attribute:: input_intfhdl
                                                                        
                                                                        	Input interface handle
                                                                        	**type**\:  :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                        
                                                                        .. attribute:: ethertype
                                                                        
                                                                        	Ethernet type
                                                                        	**type**\:  :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                        
                                                                        .. attribute:: flow_key_data
                                                                        
                                                                        	Flow key structure
                                                                        	**type**\:  :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                        
                                                                        .. attribute:: dhcp_client_id
                                                                        
                                                                        	Dhcp Client ID
                                                                        	**type**\:  :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                        
                                                                        .. attribute:: dhcp_client_id_regex
                                                                        
                                                                        	Dhcp Client ID RegEx
                                                                        	**type**\:  :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                        
                                                                        .. attribute:: circuit_id
                                                                        
                                                                        	Circuit ID
                                                                        	**type**\:  :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                        
                                                                        .. attribute:: circuit_id_regex
                                                                        
                                                                        	Circuit ID RegEx
                                                                        	**type**\:  :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                        
                                                                        .. attribute:: remote_id
                                                                        
                                                                        	Remote ID
                                                                        	**type**\:  :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                        
                                                                        .. attribute:: remote_id_regex
                                                                        
                                                                        	Remote ID RegEx
                                                                        	**type**\:  :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                        
                                                                        .. attribute:: src_port
                                                                        
                                                                        	Source port
                                                                        	**type**\:  :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                        
                                                                        .. attribute:: dst_port
                                                                        
                                                                        	Destination port
                                                                        	**type**\:  :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                        
                                                                        .. attribute:: type
                                                                        
                                                                        	type
                                                                        	**type**\:  :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                        
                                                                        .. attribute:: mpls_top_eos
                                                                        
                                                                        	MPLS Topmost EOS
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: fragment_type
                                                                        
                                                                        	Fragment type
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: authen_status
                                                                        
                                                                        	Authentication Status
                                                                        	**type**\:  :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                        
                                                                        .. attribute:: mlp_negotiated
                                                                        
                                                                        	MLP Negotiated
                                                                        	**type**\:  :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                            self.yang_name = "match-data"
                                                                            self.yang_parent_name = "class-match-info-st"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("ipv4-dscp", ("ipv4_dscp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp)), ("ipv6-dscp", ("ipv6_dscp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp)), ("dscp", ("dscp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp)), ("ipv4-prec", ("ipv4_prec", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec)), ("ipv6-prec", ("ipv6_prec", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec)), ("prec", ("prec", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec)), ("discard-class", ("discard_class", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass)), ("qos-group", ("qos_group", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup)), ("traffic-class", ("traffic_class", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass)), ("proto", ("proto", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto)), ("icmp-v4", ("icmp_v4", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4)), ("icmp-v6", ("icmp_v6", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6)), ("ipv4-packet-len", ("ipv4_packet_len", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen)), ("ipv6-packet-len", ("ipv6_packet_len", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen)), ("packet-len", ("packet_len", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen)), ("flow-tag", ("flow_tag", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag)), ("tcp-flag", ("tcp_flag", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag)), ("icmpv4-type", ("icmpv4_type", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type)), ("icmpv4-code", ("icmpv4_code", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code)), ("icmpv6-type", ("icmpv6_type", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type)), ("icmpv6-code", ("icmpv6_code", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code)), ("mpls-exp", ("mpls_exp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp)), ("mpls-exp-imp", ("mpls_exp_imp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp)), ("mpls-disp-ipv4-acl", ("mpls_disp_ipv4_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl)), ("mpls-disp-ipv6-acl", ("mpls_disp_ipv6_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl)), ("mpls-top-label", ("mpls_top_label", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel)), ("cos", ("cos", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos)), ("cos-inr", ("cos_inr", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr)), ("dei", ("dei", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei)), ("dei-inr", ("dei_inr", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr)), ("vlan", ("vlan", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan)), ("vlan-inr", ("vlan_inr", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)), ("fr-dlci", ("fr_dlci", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci)), ("src-mac", ("src_mac", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac)), ("dst-mac", ("dst_mac", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac)), ("atm-clp", ("atm_clp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp)), ("fr-de", ("fr_de", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe)), ("ipv4-acl", ("ipv4_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl)), ("ipv6-acl", ("ipv6_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl)), ("ether-service-acl", ("ether_service_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl)), ("avail-id", ("avail_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId)), ("media-type", ("media_type", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType)), ("subs-protocol", ("subs_protocol", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol)), ("dnis", ("dnis", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis)), ("dnis-regex", ("dnis_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex)), ("domain", ("domain", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain)), ("domain-regex", ("domain_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex)), ("nas-port", ("nas_port", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort)), ("service-name", ("service_name", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName)), ("service-name-regex", ("service_name_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex)), ("src-addr-ipv4", ("src_addr_ipv4", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4)), ("dst-addr-ipv4", ("dst_addr_ipv4", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4)), ("src-addr-ipv6", ("src_addr_ipv6", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6)), ("dst-addr-ipv6", ("dst_addr_ipv6", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6)), ("src-addr-mac", ("src_addr_mac", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac)), ("timer", ("timer", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer)), ("timer-regexp", ("timer_regexp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp)), ("tunnel-name", ("tunnel_name", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName)), ("tunnel-name-regex", ("tunnel_name_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex)), ("user-name", ("user_name", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName)), ("user-name-regex", ("user_name_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex)), ("auth-username", ("auth_username", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername)), ("auth-username-regex", ("auth_username_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex)), ("unauth-username", ("unauth_username", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername)), ("unauth-username-regex", ("unauth_username_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex)), ("auth-domain", ("auth_domain", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain)), ("auth-domain-regex", ("auth_domain_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex)), ("unauth-domain", ("unauth_domain", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain)), ("unauth-domain-regex", ("unauth_domain_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex)), ("vendor-id", ("vendor_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId)), ("vendor-id-regex", ("vendor_id_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex)), ("access-interface", ("access_interface", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface)), ("input-interface", ("input_interface", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface)), ("input-intfhdl", ("input_intfhdl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl)), ("ethertype", ("ethertype", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype)), ("flow-key-data", ("flow_key_data", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData)), ("dhcp-client-id", ("dhcp_client_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId)), ("dhcp-client-id-regex", ("dhcp_client_id_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex)), ("circuit-id", ("circuit_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId)), ("circuit-id-regex", ("circuit_id_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex)), ("remote-id", ("remote_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId)), ("remote-id-regex", ("remote_id_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex)), ("src-port", ("src_port", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort)), ("dst-port", ("dst_port", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort))])
                                                                            self._leafs = OrderedDict([
                                                                                ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchTypeEn', '')])),
                                                                                ('mpls_top_eos', (YLeaf(YType.uint8, 'mpls-top-eos'), ['int'])),
                                                                                ('fragment_type', (YLeaf(YType.uint8, 'fragment-type'), ['int'])),
                                                                                ('authen_status', (YLeaf(YType.enumeration, 'authen-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchAuthenStatusEn', '')])),
                                                                                ('mlp_negotiated', (YLeaf(YType.enumeration, 'mlp-negotiated'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchMlpNegotiatedEn', '')])),
                                                                            ])
                                                                            self.type = None
                                                                            self.mpls_top_eos = None
                                                                            self.fragment_type = None
                                                                            self.authen_status = None
                                                                            self.mlp_negotiated = None

                                                                            self.ipv4_dscp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                            self.ipv4_dscp.parent = self
                                                                            self._children_name_map["ipv4_dscp"] = "ipv4-dscp"

                                                                            self.ipv6_dscp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                            self.ipv6_dscp.parent = self
                                                                            self._children_name_map["ipv6_dscp"] = "ipv6-dscp"

                                                                            self.dscp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                            self.dscp.parent = self
                                                                            self._children_name_map["dscp"] = "dscp"

                                                                            self.ipv4_prec = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                            self.ipv4_prec.parent = self
                                                                            self._children_name_map["ipv4_prec"] = "ipv4-prec"

                                                                            self.ipv6_prec = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                            self.ipv6_prec.parent = self
                                                                            self._children_name_map["ipv6_prec"] = "ipv6-prec"

                                                                            self.prec = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                            self.prec.parent = self
                                                                            self._children_name_map["prec"] = "prec"

                                                                            self.discard_class = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                            self.discard_class.parent = self
                                                                            self._children_name_map["discard_class"] = "discard-class"

                                                                            self.qos_group = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                            self.qos_group.parent = self
                                                                            self._children_name_map["qos_group"] = "qos-group"

                                                                            self.traffic_class = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                            self.traffic_class.parent = self
                                                                            self._children_name_map["traffic_class"] = "traffic-class"

                                                                            self.proto = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                            self.proto.parent = self
                                                                            self._children_name_map["proto"] = "proto"

                                                                            self.icmp_v4 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                            self.icmp_v4.parent = self
                                                                            self._children_name_map["icmp_v4"] = "icmp-v4"

                                                                            self.icmp_v6 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                            self.icmp_v6.parent = self
                                                                            self._children_name_map["icmp_v6"] = "icmp-v6"

                                                                            self.ipv4_packet_len = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                            self.ipv4_packet_len.parent = self
                                                                            self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"

                                                                            self.ipv6_packet_len = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                            self.ipv6_packet_len.parent = self
                                                                            self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"

                                                                            self.packet_len = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                            self.packet_len.parent = self
                                                                            self._children_name_map["packet_len"] = "packet-len"

                                                                            self.flow_tag = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                            self.flow_tag.parent = self
                                                                            self._children_name_map["flow_tag"] = "flow-tag"

                                                                            self.tcp_flag = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                            self.tcp_flag.parent = self
                                                                            self._children_name_map["tcp_flag"] = "tcp-flag"

                                                                            self.icmpv4_type = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                            self.icmpv4_type.parent = self
                                                                            self._children_name_map["icmpv4_type"] = "icmpv4-type"

                                                                            self.icmpv4_code = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                            self.icmpv4_code.parent = self
                                                                            self._children_name_map["icmpv4_code"] = "icmpv4-code"

                                                                            self.icmpv6_type = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                            self.icmpv6_type.parent = self
                                                                            self._children_name_map["icmpv6_type"] = "icmpv6-type"

                                                                            self.icmpv6_code = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                            self.icmpv6_code.parent = self
                                                                            self._children_name_map["icmpv6_code"] = "icmpv6-code"

                                                                            self.mpls_exp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                            self.mpls_exp.parent = self
                                                                            self._children_name_map["mpls_exp"] = "mpls-exp"

                                                                            self.mpls_exp_imp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                            self.mpls_exp_imp.parent = self
                                                                            self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"

                                                                            self.mpls_disp_ipv4_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                            self.mpls_disp_ipv4_acl.parent = self
                                                                            self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"

                                                                            self.mpls_disp_ipv6_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                            self.mpls_disp_ipv6_acl.parent = self
                                                                            self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"

                                                                            self.mpls_top_label = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                            self.mpls_top_label.parent = self
                                                                            self._children_name_map["mpls_top_label"] = "mpls-top-label"

                                                                            self.cos = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                            self.cos.parent = self
                                                                            self._children_name_map["cos"] = "cos"

                                                                            self.cos_inr = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                            self.cos_inr.parent = self
                                                                            self._children_name_map["cos_inr"] = "cos-inr"

                                                                            self.dei = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                            self.dei.parent = self
                                                                            self._children_name_map["dei"] = "dei"

                                                                            self.dei_inr = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                            self.dei_inr.parent = self
                                                                            self._children_name_map["dei_inr"] = "dei-inr"

                                                                            self.vlan = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                            self.vlan.parent = self
                                                                            self._children_name_map["vlan"] = "vlan"

                                                                            self.vlan_inr = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                            self.vlan_inr.parent = self
                                                                            self._children_name_map["vlan_inr"] = "vlan-inr"

                                                                            self.fr_dlci = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                            self.fr_dlci.parent = self
                                                                            self._children_name_map["fr_dlci"] = "fr-dlci"

                                                                            self.src_mac = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                            self.src_mac.parent = self
                                                                            self._children_name_map["src_mac"] = "src-mac"

                                                                            self.dst_mac = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                            self.dst_mac.parent = self
                                                                            self._children_name_map["dst_mac"] = "dst-mac"

                                                                            self.atm_clp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                            self.atm_clp.parent = self
                                                                            self._children_name_map["atm_clp"] = "atm-clp"

                                                                            self.fr_de = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                            self.fr_de.parent = self
                                                                            self._children_name_map["fr_de"] = "fr-de"

                                                                            self.ipv4_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                            self.ipv4_acl.parent = self
                                                                            self._children_name_map["ipv4_acl"] = "ipv4-acl"

                                                                            self.ipv6_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                            self.ipv6_acl.parent = self
                                                                            self._children_name_map["ipv6_acl"] = "ipv6-acl"

                                                                            self.ether_service_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                            self.ether_service_acl.parent = self
                                                                            self._children_name_map["ether_service_acl"] = "ether-service-acl"

                                                                            self.avail_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                            self.avail_id.parent = self
                                                                            self._children_name_map["avail_id"] = "avail-id"

                                                                            self.media_type = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                            self.media_type.parent = self
                                                                            self._children_name_map["media_type"] = "media-type"

                                                                            self.subs_protocol = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                            self.subs_protocol.parent = self
                                                                            self._children_name_map["subs_protocol"] = "subs-protocol"

                                                                            self.dnis = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                            self.dnis.parent = self
                                                                            self._children_name_map["dnis"] = "dnis"

                                                                            self.dnis_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                            self.dnis_regex.parent = self
                                                                            self._children_name_map["dnis_regex"] = "dnis-regex"

                                                                            self.domain = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                            self.domain.parent = self
                                                                            self._children_name_map["domain"] = "domain"

                                                                            self.domain_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                            self.domain_regex.parent = self
                                                                            self._children_name_map["domain_regex"] = "domain-regex"

                                                                            self.nas_port = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                            self.nas_port.parent = self
                                                                            self._children_name_map["nas_port"] = "nas-port"

                                                                            self.service_name = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                            self.service_name.parent = self
                                                                            self._children_name_map["service_name"] = "service-name"

                                                                            self.service_name_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                            self.service_name_regex.parent = self
                                                                            self._children_name_map["service_name_regex"] = "service-name-regex"

                                                                            self.src_addr_ipv4 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                            self.src_addr_ipv4.parent = self
                                                                            self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"

                                                                            self.dst_addr_ipv4 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                            self.dst_addr_ipv4.parent = self
                                                                            self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"

                                                                            self.src_addr_ipv6 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                            self.src_addr_ipv6.parent = self
                                                                            self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"

                                                                            self.dst_addr_ipv6 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                            self.dst_addr_ipv6.parent = self
                                                                            self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"

                                                                            self.src_addr_mac = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                            self.src_addr_mac.parent = self
                                                                            self._children_name_map["src_addr_mac"] = "src-addr-mac"

                                                                            self.timer = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                            self.timer.parent = self
                                                                            self._children_name_map["timer"] = "timer"

                                                                            self.timer_regexp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                            self.timer_regexp.parent = self
                                                                            self._children_name_map["timer_regexp"] = "timer-regexp"

                                                                            self.tunnel_name = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                            self.tunnel_name.parent = self
                                                                            self._children_name_map["tunnel_name"] = "tunnel-name"

                                                                            self.tunnel_name_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                            self.tunnel_name_regex.parent = self
                                                                            self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"

                                                                            self.user_name = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                            self.user_name.parent = self
                                                                            self._children_name_map["user_name"] = "user-name"

                                                                            self.user_name_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                            self.user_name_regex.parent = self
                                                                            self._children_name_map["user_name_regex"] = "user-name-regex"

                                                                            self.auth_username = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                            self.auth_username.parent = self
                                                                            self._children_name_map["auth_username"] = "auth-username"

                                                                            self.auth_username_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                            self.auth_username_regex.parent = self
                                                                            self._children_name_map["auth_username_regex"] = "auth-username-regex"

                                                                            self.unauth_username = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                            self.unauth_username.parent = self
                                                                            self._children_name_map["unauth_username"] = "unauth-username"

                                                                            self.unauth_username_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                            self.unauth_username_regex.parent = self
                                                                            self._children_name_map["unauth_username_regex"] = "unauth-username-regex"

                                                                            self.auth_domain = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                            self.auth_domain.parent = self
                                                                            self._children_name_map["auth_domain"] = "auth-domain"

                                                                            self.auth_domain_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                            self.auth_domain_regex.parent = self
                                                                            self._children_name_map["auth_domain_regex"] = "auth-domain-regex"

                                                                            self.unauth_domain = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                            self.unauth_domain.parent = self
                                                                            self._children_name_map["unauth_domain"] = "unauth-domain"

                                                                            self.unauth_domain_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                            self.unauth_domain_regex.parent = self
                                                                            self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"

                                                                            self.vendor_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                            self.vendor_id.parent = self
                                                                            self._children_name_map["vendor_id"] = "vendor-id"

                                                                            self.vendor_id_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                            self.vendor_id_regex.parent = self
                                                                            self._children_name_map["vendor_id_regex"] = "vendor-id-regex"

                                                                            self.access_interface = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                            self.access_interface.parent = self
                                                                            self._children_name_map["access_interface"] = "access-interface"

                                                                            self.input_interface = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                            self.input_interface.parent = self
                                                                            self._children_name_map["input_interface"] = "input-interface"

                                                                            self.input_intfhdl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                            self.input_intfhdl.parent = self
                                                                            self._children_name_map["input_intfhdl"] = "input-intfhdl"

                                                                            self.ethertype = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                            self.ethertype.parent = self
                                                                            self._children_name_map["ethertype"] = "ethertype"

                                                                            self.flow_key_data = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                            self.flow_key_data.parent = self
                                                                            self._children_name_map["flow_key_data"] = "flow-key-data"

                                                                            self.dhcp_client_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                            self.dhcp_client_id.parent = self
                                                                            self._children_name_map["dhcp_client_id"] = "dhcp-client-id"

                                                                            self.dhcp_client_id_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                            self.dhcp_client_id_regex.parent = self
                                                                            self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"

                                                                            self.circuit_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                            self.circuit_id.parent = self
                                                                            self._children_name_map["circuit_id"] = "circuit-id"

                                                                            self.circuit_id_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                            self.circuit_id_regex.parent = self
                                                                            self._children_name_map["circuit_id_regex"] = "circuit-id-regex"

                                                                            self.remote_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                            self.remote_id.parent = self
                                                                            self._children_name_map["remote_id"] = "remote-id"

                                                                            self.remote_id_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                            self.remote_id_regex.parent = self
                                                                            self._children_name_map["remote_id_regex"] = "remote-id-regex"

                                                                            self.src_port = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                            self.src_port.parent = self
                                                                            self._children_name_map["src_port"] = "src-port"

                                                                            self.dst_port = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                            self.dst_port.parent = self
                                                                            self._children_name_map["dst_port"] = "dst-port"
                                                                            self._segment_path = lambda: "match-data"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['type', 'mpls_top_eos', 'fragment_type', 'authen_status', 'mlp_negotiated'], name, value)


                                                                        class Ipv4Dscp(Entity):
                                                                            """
                                                                            IPv4 DSCP
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                self.yang_name = "ipv4-dscp"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "ipv4-dscp"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "ipv4-dscp"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                        class Ipv6Dscp(Entity):
                                                                            """
                                                                            IPv6 DSCP
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                self.yang_name = "ipv6-dscp"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "ipv6-dscp"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "ipv6-dscp"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                        class Dscp(Entity):
                                                                            """
                                                                            Match DSCP range array
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                self.yang_name = "dscp"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "dscp"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "dscp"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                        class Ipv4Prec(Entity):
                                                                            """
                                                                            IPv4 Precedence
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                self.yang_name = "ipv4-prec"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                ])
                                                                                self.uint8_array = []
                                                                                self._segment_path = lambda: "ipv4-prec"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                        class Ipv6Prec(Entity):
                                                                            """
                                                                            IPv6 Precedence
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                self.yang_name = "ipv6-prec"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                ])
                                                                                self.uint8_array = []
                                                                                self._segment_path = lambda: "ipv6-prec"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                        class Prec(Entity):
                                                                            """
                                                                            Match Precedence array
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                self.yang_name = "prec"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                ])
                                                                                self.uint8_array = []
                                                                                self._segment_path = lambda: "prec"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                        class DiscardClass(Entity):
                                                                            """
                                                                            Match Discard Class array
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                self.yang_name = "discard-class"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                ])
                                                                                self.uint8_array = []
                                                                                self._segment_path = lambda: "discard-class"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                        class QosGroup(Entity):
                                                                            """
                                                                            Match QoS group array
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                self.yang_name = "qos-group"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "qos-group"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "qos-group"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['min', 'max'], name, value)


                                                                        class TrafficClass(Entity):
                                                                            """
                                                                            Match Traffic class array
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                self.yang_name = "traffic-class"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "traffic-class"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "traffic-class"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['min', 'max'], name, value)


                                                                        class Proto(Entity):
                                                                            """
                                                                            Match Protocol array
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                self.yang_name = "proto"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "proto"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "proto"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['min', 'max'], name, value)


                                                                        class IcmpV4(Entity):
                                                                            """
                                                                            Match ICMPV4 Protocol
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	Protocol type
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: code
                                                                            
                                                                            	Protocol code
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                self.yang_name = "icmp-v4"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                    ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                ])
                                                                                self.type = None
                                                                                self.code = None
                                                                                self._segment_path = lambda: "icmp-v4"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['type', 'code'], name, value)


                                                                        class IcmpV6(Entity):
                                                                            """
                                                                            Match ICMPV6 Protocol array
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	Protocol type
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: code
                                                                            
                                                                            	Protocol code
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                self.yang_name = "icmp-v6"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                    ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                ])
                                                                                self.type = None
                                                                                self.code = None
                                                                                self._segment_path = lambda: "icmp-v6"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['type', 'code'], name, value)


                                                                        class Ipv4PacketLen(Entity):
                                                                            """
                                                                            IPv4 packet length array
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                self.yang_name = "ipv4-packet-len"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "ipv4-packet-len"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "ipv4-packet-len"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                        class Ipv6PacketLen(Entity):
                                                                            """
                                                                            IPv6 packet length array
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                self.yang_name = "ipv6-packet-len"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "ipv6-packet-len"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "ipv6-packet-len"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                        class PacketLen(Entity):
                                                                            """
                                                                            Match packet length array
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                self.yang_name = "packet-len"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "packet-len"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "packet-len"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                        class FlowTag(Entity):
                                                                            """
                                                                            Match flow\-tag array
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                self.yang_name = "flow-tag"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "flow-tag"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "flow-tag"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['min', 'max'], name, value)


                                                                        class TcpFlag(Entity):
                                                                            """
                                                                            Match tcp flag value
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	Value of TCP flag
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: match_any
                                                                            
                                                                            	Match any TCP flag bit
                                                                            	**type**\: bool
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                self.yang_name = "tcp-flag"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                    ('match_any', (YLeaf(YType.boolean, 'match-any'), ['bool'])),
                                                                                ])
                                                                                self.value = None
                                                                                self.match_any = None
                                                                                self._segment_path = lambda: "tcp-flag"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['value', 'match_any'], name, value)


                                                                        class Icmpv4Type(Entity):
                                                                            """
                                                                            Match ipv4 icmp type
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                self.yang_name = "icmpv4-type"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "icmpv4-type"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "icmpv4-type"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                        class Icmpv4Code(Entity):
                                                                            """
                                                                            Match ipv4 icmp code
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                self.yang_name = "icmpv4-code"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "icmpv4-code"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "icmpv4-code"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                        class Icmpv6Type(Entity):
                                                                            """
                                                                            Match ipv6 icmp type
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                self.yang_name = "icmpv6-type"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "icmpv6-type"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "icmpv6-type"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                        class Icmpv6Code(Entity):
                                                                            """
                                                                            Match ipv6 icmp code
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                self.yang_name = "icmpv6-code"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "icmpv6-code"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "icmpv6-code"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                        class MplsExp(Entity):
                                                                            """
                                                                            Match MPLS experimental topmost array
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                self.yang_name = "mpls-exp"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                ])
                                                                                self.uint8_array = []
                                                                                self._segment_path = lambda: "mpls-exp"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                        class MplsExpImp(Entity):
                                                                            """
                                                                            Match MPLS experimental imposition array
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                self.yang_name = "mpls-exp-imp"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                ])
                                                                                self.uint8_array = []
                                                                                self._segment_path = lambda: "mpls-exp-imp"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                        class MplsDispIpv4Acl(Entity):
                                                                            """
                                                                            MPLS Disposition IPv4 Access\-list
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                self.yang_name = "mpls-disp-ipv4-acl"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "mpls-disp-ipv4-acl"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                        class MplsDispIpv6Acl(Entity):
                                                                            """
                                                                            MPLS Disposition IPv6 Access\-list
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                self.yang_name = "mpls-disp-ipv6-acl"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "mpls-disp-ipv6-acl"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                        class MplsTopLabel(Entity):
                                                                            """
                                                                            MPLS Topmost LABEL
                                                                            
                                                                            .. attribute:: uint32_rng_array
                                                                            
                                                                            	uint32 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                self.yang_name = "mpls-top-label"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint32_rng_array", ("uint32_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint32_rng_array = YList(self)
                                                                                self._segment_path = lambda: "mpls-top-label"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                            class Uint32RngArray(Entity):
                                                                                """
                                                                                uint32 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                    self.yang_name = "uint32_rng_array"
                                                                                    self.yang_parent_name = "mpls-top-label"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint32, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint32, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint32_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['min', 'max'], name, value)


                                                                        class Cos(Entity):
                                                                            """
                                                                            Match CoS array
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                self.yang_name = "cos"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                ])
                                                                                self.uint8_array = []
                                                                                self._segment_path = lambda: "cos"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                        class CosInr(Entity):
                                                                            """
                                                                            Match inner header CoS
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                self.yang_name = "cos-inr"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                ])
                                                                                self.uint8_array = []
                                                                                self._segment_path = lambda: "cos-inr"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                        class Dei(Entity):
                                                                            """
                                                                            Match DEI Bit
                                                                            
                                                                            .. attribute:: bit_value
                                                                            
                                                                            	Value of the DEI bit
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                self.yang_name = "dei"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                ])
                                                                                self.bit_value = None
                                                                                self._segment_path = lambda: "dei"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                        class DeiInr(Entity):
                                                                            """
                                                                            Match inner DEI Bit
                                                                            
                                                                            .. attribute:: bit_value
                                                                            
                                                                            	Value of the DEI bit
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                self.yang_name = "dei-inr"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                ])
                                                                                self.bit_value = None
                                                                                self._segment_path = lambda: "dei-inr"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                        class Vlan(Entity):
                                                                            """
                                                                            Match VLAN array
                                                                            
                                                                            .. attribute:: vlan_id_array
                                                                            
                                                                            	vlan id array
                                                                            	**type**\: list of  		 :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                self.yang_name = "vlan"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("vlan-id-array", ("vlan_id_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.vlan_id_array = YList(self)
                                                                                self._segment_path = lambda: "vlan"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                            class VlanIdArray(Entity):
                                                                                """
                                                                                vlan id array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	VLAN mask
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                    self.yang_name = "vlan-id-array"
                                                                                    self.yang_parent_name = "vlan"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ('mask', (YLeaf(YType.uint16, 'mask'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self.mask = None
                                                                                    self._segment_path = lambda: "vlan-id-array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['min', 'max', 'mask'], name, value)


                                                                        class VlanInr(Entity):
                                                                            """
                                                                            Match inner header VLAN range array
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                self.yang_name = "vlan-inr"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "vlan-inr"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "vlan-inr"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['min', 'max'], name, value)


                                                                        class FrDlci(Entity):
                                                                            """
                                                                            Match FR DLCI range array
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                self.yang_name = "fr-dlci"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "fr-dlci"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "fr-dlci"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['min', 'max'], name, value)


                                                                        class SrcMac(Entity):
                                                                            """
                                                                            Match Source MAC address
                                                                            
                                                                            .. attribute:: mac_addr
                                                                            
                                                                            	MAC address
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: mask
                                                                            
                                                                            	MAC mask
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                self.yang_name = "src-mac"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                    ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                ])
                                                                                self.mac_addr = []
                                                                                self.mask = []
                                                                                self._segment_path = lambda: "src-mac"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                        class DstMac(Entity):
                                                                            """
                                                                            Match Destination MAC address
                                                                            
                                                                            .. attribute:: mac_addr
                                                                            
                                                                            	MAC address
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: mask
                                                                            
                                                                            	MAC mask
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                self.yang_name = "dst-mac"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                    ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                ])
                                                                                self.mac_addr = []
                                                                                self.mask = []
                                                                                self._segment_path = lambda: "dst-mac"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                        class AtmClp(Entity):
                                                                            """
                                                                            Match ATM CLP level
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                self.yang_name = "atm-clp"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                ])
                                                                                self.uint8_array = []
                                                                                self._segment_path = lambda: "atm-clp"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                        class FrDe(Entity):
                                                                            """
                                                                            Match FR DE value
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                self.yang_name = "fr-de"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                ])
                                                                                self.uint8_array = []
                                                                                self._segment_path = lambda: "fr-de"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                        class Ipv4Acl(Entity):
                                                                            """
                                                                            IPv4 Access\-list
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                self.yang_name = "ipv4-acl"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "ipv4-acl"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                        class Ipv6Acl(Entity):
                                                                            """
                                                                            IPv6 Access\-list
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                self.yang_name = "ipv6-acl"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "ipv6-acl"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                        class EtherServiceAcl(Entity):
                                                                            """
                                                                            Ethernet\-Services Access\-list
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                self.yang_name = "ether-service-acl"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "ether-service-acl"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                        class AvailId(Entity):
                                                                            """
                                                                            Available Identifiers
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                self.yang_name = "avail-id"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                ])
                                                                                self.uint8_array = []
                                                                                self._segment_path = lambda: "avail-id"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                        class MediaType(Entity):
                                                                            """
                                                                            Media Type
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                self.yang_name = "media-type"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                ])
                                                                                self.uint8_array = []
                                                                                self._segment_path = lambda: "media-type"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                        class SubsProtocol(Entity):
                                                                            """
                                                                            Protocol
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                self.yang_name = "subs-protocol"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                ])
                                                                                self.uint8_array = []
                                                                                self._segment_path = lambda: "subs-protocol"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                        class Dnis(Entity):
                                                                            """
                                                                            DNIS
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                self.yang_name = "dnis"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "dnis"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                        class DnisRegex(Entity):
                                                                            """
                                                                            DNIS Regular Expression
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                self.yang_name = "dnis-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "dnis-regex"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                        class Domain(Entity):
                                                                            """
                                                                            Domain Name
                                                                            
                                                                            .. attribute:: domain_array
                                                                            
                                                                            	domain array
                                                                            	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                self.yang_name = "domain"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.domain_array = YList(self)
                                                                                self._segment_path = lambda: "domain"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                            class DomainArray(Entity):
                                                                                """
                                                                                domain array
                                                                                
                                                                                .. attribute:: domain_name
                                                                                
                                                                                	domain name
                                                                                	**type**\: str
                                                                                
                                                                                .. attribute:: format_name
                                                                                
                                                                                	format name
                                                                                	**type**\: str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                    self.yang_name = "domain-array"
                                                                                    self.yang_parent_name = "domain"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                        ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                    ])
                                                                                    self.domain_name = None
                                                                                    self.format_name = None
                                                                                    self._segment_path = lambda: "domain-array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                        class DomainRegex(Entity):
                                                                            """
                                                                            Domain Regular Expression
                                                                            
                                                                            .. attribute:: domain_array
                                                                            
                                                                            	domain array
                                                                            	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                self.yang_name = "domain-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.domain_array = YList(self)
                                                                                self._segment_path = lambda: "domain-regex"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                            class DomainArray(Entity):
                                                                                """
                                                                                domain array
                                                                                
                                                                                .. attribute:: domain_name
                                                                                
                                                                                	domain name
                                                                                	**type**\: str
                                                                                
                                                                                .. attribute:: format_name
                                                                                
                                                                                	format name
                                                                                	**type**\: str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                    self.yang_name = "domain-array"
                                                                                    self.yang_parent_name = "domain-regex"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                        ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                    ])
                                                                                    self.domain_name = None
                                                                                    self.format_name = None
                                                                                    self._segment_path = lambda: "domain-array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                        class NasPort(Entity):
                                                                            """
                                                                            NAS Port
                                                                            
                                                                            .. attribute:: nas_port_array
                                                                            
                                                                            	nas port array
                                                                            	**type**\: list of  		 :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                self.yang_name = "nas-port"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("nas-port-array", ("nas_port_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.nas_port_array = YList(self)
                                                                                self._segment_path = lambda: "nas-port"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                            class NasPortArray(Entity):
                                                                                """
                                                                                nas port array
                                                                                
                                                                                .. attribute:: sub_id
                                                                                
                                                                                	sub id
                                                                                	**type**\:  :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                
                                                                                .. attribute:: operator
                                                                                
                                                                                	operator
                                                                                	**type**\:  :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                    self.yang_name = "nas-port-array"
                                                                                    self.yang_parent_name = "nas-port"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('sub_id', (YLeaf(YType.enumeration, 'sub-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchNasPortSubIdEn', '')])),
                                                                                        ('operator', (YLeaf(YType.enumeration, 'operator'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchLogicalOperatorEn', '')])),
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ])
                                                                                    self.sub_id = None
                                                                                    self.operator = None
                                                                                    self.value = None
                                                                                    self._segment_path = lambda: "nas-port-array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['sub_id', 'operator', 'value'], name, value)


                                                                        class ServiceName(Entity):
                                                                            """
                                                                            Service Name
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                self.yang_name = "service-name"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "service-name"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                        class ServiceNameRegex(Entity):
                                                                            """
                                                                            Service Name Regular Exp
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                self.yang_name = "service-name-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "service-name-regex"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                        class SrcAddrIpv4(Entity):
                                                                            """
                                                                            Source Address IPV4
                                                                            
                                                                            .. attribute:: ipv4_addr_array
                                                                            
                                                                            	ipv4 addr array
                                                                            	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                self.yang_name = "src-addr-ipv4"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.ipv4_addr_array = YList(self)
                                                                                self._segment_path = lambda: "src-addr-ipv4"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                            class Ipv4AddrArray(Entity):
                                                                                """
                                                                                ipv4 addr array
                                                                                
                                                                                .. attribute:: prefix
                                                                                
                                                                                	prefix
                                                                                	**type**\: str
                                                                                
                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	mask
                                                                                	**type**\: str
                                                                                
                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                    self.yang_name = "ipv4-addr-array"
                                                                                    self.yang_parent_name = "src-addr-ipv4"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                        ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                    ])
                                                                                    self.prefix = None
                                                                                    self.mask = None
                                                                                    self._segment_path = lambda: "ipv4-addr-array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                        class DstAddrIpv4(Entity):
                                                                            """
                                                                            Destination Address IPV4
                                                                            
                                                                            .. attribute:: ipv4_addr_array
                                                                            
                                                                            	ipv4 addr array
                                                                            	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                self.yang_name = "dst-addr-ipv4"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.ipv4_addr_array = YList(self)
                                                                                self._segment_path = lambda: "dst-addr-ipv4"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                            class Ipv4AddrArray(Entity):
                                                                                """
                                                                                ipv4 addr array
                                                                                
                                                                                .. attribute:: prefix
                                                                                
                                                                                	prefix
                                                                                	**type**\: str
                                                                                
                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	mask
                                                                                	**type**\: str
                                                                                
                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                    self.yang_name = "ipv4-addr-array"
                                                                                    self.yang_parent_name = "dst-addr-ipv4"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                        ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                    ])
                                                                                    self.prefix = None
                                                                                    self.mask = None
                                                                                    self._segment_path = lambda: "ipv4-addr-array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                        class SrcAddrIpv6(Entity):
                                                                            """
                                                                            Source Address IPV6
                                                                            
                                                                            .. attribute:: ipv6_addr_array
                                                                            
                                                                            	ipv6 addr array
                                                                            	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                self.yang_name = "src-addr-ipv6"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.ipv6_addr_array = YList(self)
                                                                                self._segment_path = lambda: "src-addr-ipv6"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                            class Ipv6AddrArray(Entity):
                                                                                """
                                                                                ipv6 addr array
                                                                                
                                                                                .. attribute:: prefix
                                                                                
                                                                                	IPV6 prefix
                                                                                	**type**\: str
                                                                                
                                                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	IPV6 mask
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                    self.yang_name = "ipv6-addr-array"
                                                                                    self.yang_parent_name = "src-addr-ipv6"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                        ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                    ])
                                                                                    self.prefix = None
                                                                                    self.mask = None
                                                                                    self._segment_path = lambda: "ipv6-addr-array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                        class DstAddrIpv6(Entity):
                                                                            """
                                                                            Destination Address IPV6
                                                                            
                                                                            .. attribute:: ipv6_addr_array
                                                                            
                                                                            	ipv6 addr array
                                                                            	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                self.yang_name = "dst-addr-ipv6"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.ipv6_addr_array = YList(self)
                                                                                self._segment_path = lambda: "dst-addr-ipv6"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                            class Ipv6AddrArray(Entity):
                                                                                """
                                                                                ipv6 addr array
                                                                                
                                                                                .. attribute:: prefix
                                                                                
                                                                                	IPV6 prefix
                                                                                	**type**\: str
                                                                                
                                                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	IPV6 mask
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                    self.yang_name = "ipv6-addr-array"
                                                                                    self.yang_parent_name = "dst-addr-ipv6"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                        ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                    ])
                                                                                    self.prefix = None
                                                                                    self.mask = None
                                                                                    self._segment_path = lambda: "ipv6-addr-array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                        class SrcAddrMac(Entity):
                                                                            """
                                                                            Source Address MAC
                                                                            
                                                                            .. attribute:: mac_addr_array
                                                                            
                                                                            	mac addr array
                                                                            	**type**\: list of  		 :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                self.yang_name = "src-addr-mac"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("mac-addr-array", ("mac_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.mac_addr_array = YList(self)
                                                                                self._segment_path = lambda: "src-addr-mac"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                            class MacAddrArray(Entity):
                                                                                """
                                                                                mac addr array
                                                                                
                                                                                .. attribute:: mac_addr
                                                                                
                                                                                	MAC address
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	MAC mask
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                    self.yang_name = "mac-addr-array"
                                                                                    self.yang_parent_name = "src-addr-mac"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                    ])
                                                                                    self.mac_addr = []
                                                                                    self.mask = []
                                                                                    self._segment_path = lambda: "mac-addr-array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                        class Timer(Entity):
                                                                            """
                                                                            Timer
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                self.yang_name = "timer"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "timer"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                        class TimerRegexp(Entity):
                                                                            """
                                                                            Timer Regular Expression
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                self.yang_name = "timer-regexp"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "timer-regexp"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                        class TunnelName(Entity):
                                                                            """
                                                                            Tunnel Name
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                self.yang_name = "tunnel-name"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "tunnel-name"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                        class TunnelNameRegex(Entity):
                                                                            """
                                                                            Tunnel Name Regular Expression
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                self.yang_name = "tunnel-name-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "tunnel-name-regex"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                        class UserName(Entity):
                                                                            """
                                                                            User Name
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                self.yang_name = "user-name"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "user-name"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                        class UserNameRegex(Entity):
                                                                            """
                                                                            User Name Regular Expression
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                self.yang_name = "user-name-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "user-name-regex"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                        class AuthUsername(Entity):
                                                                            """
                                                                            Authenticated User Name
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                self.yang_name = "auth-username"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "auth-username"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                        class AuthUsernameRegex(Entity):
                                                                            """
                                                                            Authenticated User Name RegEx
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                self.yang_name = "auth-username-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "auth-username-regex"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                        class UnauthUsername(Entity):
                                                                            """
                                                                            Unauthenticated User Name
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                self.yang_name = "unauth-username"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "unauth-username"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                        class UnauthUsernameRegex(Entity):
                                                                            """
                                                                            Unauthenticated User Name RegEx
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                self.yang_name = "unauth-username-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "unauth-username-regex"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                        class AuthDomain(Entity):
                                                                            """
                                                                            Authenticated domain name
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                self.yang_name = "auth-domain"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "auth-domain"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                        class AuthDomainRegex(Entity):
                                                                            """
                                                                            Authenticated Domain Name RegEx
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                self.yang_name = "auth-domain-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "auth-domain-regex"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                        class UnauthDomain(Entity):
                                                                            """
                                                                            Unauthenticated Domain Name
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                self.yang_name = "unauth-domain"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "unauth-domain"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                        class UnauthDomainRegex(Entity):
                                                                            """
                                                                            Unauthenticated Domain Name RegEx
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                self.yang_name = "unauth-domain-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "unauth-domain-regex"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                        class VendorId(Entity):
                                                                            """
                                                                            Vendor ID
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                self.yang_name = "vendor-id"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "vendor-id"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                        class VendorIdRegex(Entity):
                                                                            """
                                                                            Vendor ID RegEx
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                self.yang_name = "vendor-id-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "vendor-id-regex"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                        class AccessInterface(Entity):
                                                                            """
                                                                            Access interface
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                self.yang_name = "access-interface"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "access-interface"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                        class InputInterface(Entity):
                                                                            """
                                                                            Input interface
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                self.yang_name = "input-interface"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "input-interface"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                        class InputIntfhdl(Entity):
                                                                            """
                                                                            Input interface handle
                                                                            
                                                                            .. attribute:: uint64_array
                                                                            
                                                                            	uint64 array
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                self.yang_name = "input-intfhdl"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('uint64_array', (YLeafList(YType.uint64, 'uint64_array'), ['int'])),
                                                                                ])
                                                                                self.uint64_array = []
                                                                                self._segment_path = lambda: "input-intfhdl"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                        class Ethertype(Entity):
                                                                            """
                                                                            Ethernet type
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                self.yang_name = "ethertype"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "ethertype"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "ethertype"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['min', 'max'], name, value)


                                                                        class FlowKeyData(Entity):
                                                                            """
                                                                            Flow key structure
                                                                            
                                                                            .. attribute:: flow_keys
                                                                            
                                                                            	flow keys
                                                                            	**type**\:  :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                            
                                                                            .. attribute:: max_count
                                                                            
                                                                            	Maximum count of flows
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: idle_timeout
                                                                            
                                                                            	Idle timeout of flows (in seconds)
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            	**units**\: second
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                self.yang_name = "flow-key-data"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("flow-keys", ("flow_keys", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('max_count', (YLeaf(YType.uint16, 'max-count'), ['int'])),
                                                                                    ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                                ])
                                                                                self.max_count = None
                                                                                self.idle_timeout = None

                                                                                self.flow_keys = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                self.flow_keys.parent = self
                                                                                self._children_name_map["flow_keys"] = "flow-keys"
                                                                                self._segment_path = lambda: "flow-key-data"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['max_count', 'idle_timeout'], name, value)


                                                                            class FlowKeys(Entity):
                                                                                """
                                                                                flow keys
                                                                                
                                                                                .. attribute:: keys
                                                                                
                                                                                	keys
                                                                                	**type**\: str
                                                                                
                                                                                	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                
                                                                                .. attribute:: num
                                                                                
                                                                                	num
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                    self.yang_name = "flow-keys"
                                                                                    self.yang_parent_name = "flow-key-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('keys', (YLeaf(YType.str, 'keys'), ['str'])),
                                                                                        ('num', (YLeaf(YType.uint8, 'num'), ['int'])),
                                                                                    ])
                                                                                    self.keys = None
                                                                                    self.num = None
                                                                                    self._segment_path = lambda: "flow-keys"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                        class DhcpClientId(Entity):
                                                                            """
                                                                            Dhcp Client ID
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                self.yang_name = "dhcp-client-id"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "dhcp-client-id"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                        class DhcpClientIdRegex(Entity):
                                                                            """
                                                                            Dhcp Client ID RegEx
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                self.yang_name = "dhcp-client-id-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "dhcp-client-id-regex"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                        class CircuitId(Entity):
                                                                            """
                                                                            Circuit ID
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                self.yang_name = "circuit-id"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "circuit-id"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                        class CircuitIdRegex(Entity):
                                                                            """
                                                                            Circuit ID RegEx
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                self.yang_name = "circuit-id-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "circuit-id-regex"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                        class RemoteId(Entity):
                                                                            """
                                                                            Remote ID
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                self.yang_name = "remote-id"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "remote-id"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                        class RemoteIdRegex(Entity):
                                                                            """
                                                                            Remote ID RegEx
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                self.yang_name = "remote-id-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "remote-id-regex"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                        class SrcPort(Entity):
                                                                            """
                                                                            Source port
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                self.yang_name = "src-port"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "src-port"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "src-port"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                        class DstPort(Entity):
                                                                            """
                                                                            Destination port
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                self.yang_name = "dst-port"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "dst-port"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "dst-port"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['min', 'max'], name, value)


                                                    class ActInfop(Entity):
                                                        """
                                                        act infop
                                                        
                                                        .. attribute:: policy_action_info_st
                                                        
                                                        	policy action info st
                                                        	**type**\: list of  		 :py:class:`PolicyActionInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2018-01-17'

                                                        def __init__(self):
                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop, self).__init__()

                                                            self.yang_name = "act-infop"
                                                            self.yang_parent_name = "policy-class-info-bg"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("policy-action-info-st", ("policy_action_info_st", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt))])
                                                            self._leafs = OrderedDict()

                                                            self.policy_action_info_st = YList(self)
                                                            self._segment_path = lambda: "act-infop"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop, [], name, value)


                                                        class PolicyActionInfoSt(Entity):
                                                            """
                                                            policy action info st
                                                            
                                                            .. attribute:: actp
                                                            
                                                            	actp
                                                            	**type**\:  :py:class:`Actp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp>`
                                                            
                                                            .. attribute:: seq
                                                            
                                                            	seq
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..65535
                                                            
                                                            .. attribute:: flags
                                                            
                                                            	flags
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..65535
                                                            
                                                            

                                                            """

                                                            _prefix = 'infra-policymgr-oper'
                                                            _revision = '2018-01-17'

                                                            def __init__(self):
                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt, self).__init__()

                                                                self.yang_name = "policy-action-info-st"
                                                                self.yang_parent_name = "act-infop"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("actp", ("actp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp))])
                                                                self._leafs = OrderedDict([
                                                                    ('seq', (YLeaf(YType.uint16, 'seq'), ['int'])),
                                                                    ('flags', (YLeaf(YType.uint16, 'flags'), ['int'])),
                                                                ])
                                                                self.seq = None
                                                                self.flags = None

                                                                self.actp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp()
                                                                self.actp.parent = self
                                                                self._children_name_map["actp"] = "actp"
                                                                self._segment_path = lambda: "policy-action-info-st"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt, ['seq', 'flags'], name, value)


                                                            class Actp(Entity):
                                                                """
                                                                actp
                                                                
                                                                .. attribute:: mark
                                                                
                                                                	mark
                                                                	**type**\:  :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark>`
                                                                
                                                                .. attribute:: mark2
                                                                
                                                                	mark2
                                                                	**type**\:  :py:class:`Mark2 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2>`
                                                                
                                                                .. attribute:: wred
                                                                
                                                                	wred
                                                                	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred>`
                                                                
                                                                .. attribute:: encap
                                                                
                                                                	encap
                                                                	**type**\:  :py:class:`Encap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap>`
                                                                
                                                                .. attribute:: prio
                                                                
                                                                	prio
                                                                	**type**\:  :py:class:`Prio <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio>`
                                                                
                                                                .. attribute:: bwrem
                                                                
                                                                	bwrem
                                                                	**type**\:  :py:class:`Bwrem <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem>`
                                                                
                                                                .. attribute:: min_bw
                                                                
                                                                	min bw
                                                                	**type**\:  :py:class:`MinBw <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw>`
                                                                
                                                                .. attribute:: authen_aaa
                                                                
                                                                	authen aaa
                                                                	**type**\:  :py:class:`AuthenAaa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa>`
                                                                
                                                                .. attribute:: collect_id
                                                                
                                                                	collect id
                                                                	**type**\:  :py:class:`CollectId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId>`
                                                                
                                                                .. attribute:: decode_id
                                                                
                                                                	decode id
                                                                	**type**\:  :py:class:`DecodeId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId>`
                                                                
                                                                .. attribute:: set_timer
                                                                
                                                                	set timer
                                                                	**type**\:  :py:class:`SetTimer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer>`
                                                                
                                                                .. attribute:: stop_timer
                                                                
                                                                	stop timer
                                                                	**type**\:  :py:class:`StopTimer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer>`
                                                                
                                                                .. attribute:: acct_aaa_list
                                                                
                                                                	acct aaa list
                                                                	**type**\:  :py:class:`AcctAaaList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList>`
                                                                
                                                                .. attribute:: query_ancp
                                                                
                                                                	query ancp
                                                                	**type**\:  :py:class:`QueryAncp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp>`
                                                                
                                                                .. attribute:: prepaid_cfg
                                                                
                                                                	prepaid cfg
                                                                	**type**\:  :py:class:`PrepaidCfg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg>`
                                                                
                                                                .. attribute:: timeout_idle
                                                                
                                                                	timeout idle
                                                                	**type**\:  :py:class:`TimeoutIdle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle>`
                                                                
                                                                .. attribute:: proxy_aaa
                                                                
                                                                	proxy aaa
                                                                	**type**\:  :py:class:`ProxyAaa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa>`
                                                                
                                                                .. attribute:: act_template
                                                                
                                                                	act template
                                                                	**type**\:  :py:class:`ActTemplate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate>`
                                                                
                                                                .. attribute:: deact_template
                                                                
                                                                	deact template
                                                                	**type**\:  :py:class:`DeactTemplate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate>`
                                                                
                                                                .. attribute:: qlimit
                                                                
                                                                	qlimit
                                                                	**type**\:  :py:class:`Qlimit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit>`
                                                                
                                                                .. attribute:: accounting_event_aaa
                                                                
                                                                	accounting event aaa
                                                                	**type**\:  :py:class:`AccountingEventAaa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa>`
                                                                
                                                                .. attribute:: authorize_id
                                                                
                                                                	authorize id
                                                                	**type**\:  :py:class:`AuthorizeId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId>`
                                                                
                                                                .. attribute:: afm_react
                                                                
                                                                	afm react
                                                                	**type**\:  :py:class:`AfmReact <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact>`
                                                                
                                                                .. attribute:: httpr
                                                                
                                                                	httpr
                                                                	**type**\:  :py:class:`Httpr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr>`
                                                                
                                                                .. attribute:: punt
                                                                
                                                                	punt
                                                                	**type**\:  :py:class:`Punt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt>`
                                                                
                                                                .. attribute:: copy
                                                                
                                                                	copy
                                                                	**type**\:  :py:class:`Copy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy>`
                                                                
                                                                .. attribute:: sfrag
                                                                
                                                                	sfrag
                                                                	**type**\:  :py:class:`Sfrag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag>`
                                                                
                                                                .. attribute:: redirect
                                                                
                                                                	redirect
                                                                	**type**\:  :py:class:`Redirect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect>`
                                                                
                                                                .. attribute:: out_intf
                                                                
                                                                	out intf
                                                                	**type**\:  :py:class:`OutIntf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf>`
                                                                
                                                                .. attribute:: serv_func
                                                                
                                                                	serv func
                                                                	**type**\:  :py:class:`ServFunc <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc>`
                                                                
                                                                .. attribute:: police
                                                                
                                                                	police
                                                                	**type**\:  :py:class:`Police <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police>`
                                                                
                                                                .. attribute:: shape
                                                                
                                                                	shape
                                                                	**type**\:  :py:class:`Shape <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape>`
                                                                
                                                                .. attribute:: child_policy
                                                                
                                                                	child policy
                                                                	**type**\:  :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy>`
                                                                
                                                                .. attribute:: cac
                                                                
                                                                	cac
                                                                	**type**\:  :py:class:`Cac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac>`
                                                                
                                                                .. attribute:: pfc
                                                                
                                                                	pfc
                                                                	**type**\:  :py:class:`Pfc <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc>`
                                                                
                                                                .. attribute:: flow_parm
                                                                
                                                                	flow parm
                                                                	**type**\:  :py:class:`FlowParm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm>`
                                                                
                                                                .. attribute:: ipcbr
                                                                
                                                                	ipcbr
                                                                	**type**\:  :py:class:`Ipcbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr>`
                                                                
                                                                .. attribute:: rtp
                                                                
                                                                	rtp
                                                                	**type**\:  :py:class:`Rtp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp>`
                                                                
                                                                .. attribute:: rtp_mmr
                                                                
                                                                	rtp mmr
                                                                	**type**\:  :py:class:`RtpMmr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr>`
                                                                
                                                                .. attribute:: rtp_j2k
                                                                
                                                                	rtp j2k
                                                                	**type**\:  :py:class:`RtpJ2k <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k>`
                                                                
                                                                .. attribute:: rtp_voice
                                                                
                                                                	rtp voice
                                                                	**type**\:  :py:class:`RtpVoice <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice>`
                                                                
                                                                .. attribute:: mdi
                                                                
                                                                	mdi
                                                                	**type**\:  :py:class:`Mdi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi>`
                                                                
                                                                .. attribute:: mdi_rtp
                                                                
                                                                	mdi rtp
                                                                	**type**\:  :py:class:`MdiRtp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp>`
                                                                
                                                                .. attribute:: fmm
                                                                
                                                                	fmm
                                                                	**type**\:  :py:class:`Fmm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm>`
                                                                
                                                                .. attribute:: pbf
                                                                
                                                                	pbf
                                                                	**type**\:  :py:class:`Pbf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf>`
                                                                
                                                                .. attribute:: ipv4_nh
                                                                
                                                                	ipv4 nh
                                                                	**type**\:  :py:class:`Ipv4Nh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh>`
                                                                
                                                                .. attribute:: ipv6_nh
                                                                
                                                                	ipv6 nh
                                                                	**type**\:  :py:class:`Ipv6Nh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh>`
                                                                
                                                                .. attribute:: type
                                                                
                                                                	type
                                                                	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                
                                                                .. attribute:: data_p
                                                                
                                                                	data p
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp, self).__init__()

                                                                    self.yang_name = "actp"
                                                                    self.yang_parent_name = "policy-action-info-st"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("mark", ("mark", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark)), ("mark2", ("mark2", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2)), ("wred", ("wred", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred)), ("encap", ("encap", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap)), ("prio", ("prio", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio)), ("bwrem", ("bwrem", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem)), ("min-bw", ("min_bw", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw)), ("authen-aaa", ("authen_aaa", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa)), ("collect-id", ("collect_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId)), ("decode-id", ("decode_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId)), ("set-timer", ("set_timer", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer)), ("stop-timer", ("stop_timer", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer)), ("acct-aaa-list", ("acct_aaa_list", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList)), ("query-ancp", ("query_ancp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp)), ("prepaid-cfg", ("prepaid_cfg", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg)), ("timeout-idle", ("timeout_idle", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle)), ("proxy-aaa", ("proxy_aaa", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa)), ("act-template", ("act_template", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate)), ("deact-template", ("deact_template", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate)), ("qlimit", ("qlimit", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit)), ("accounting-event-aaa", ("accounting_event_aaa", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa)), ("authorize-id", ("authorize_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId)), ("afm-react", ("afm_react", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact)), ("httpr", ("httpr", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr)), ("punt", ("punt", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt)), ("copy", ("copy", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy)), ("sfrag", ("sfrag", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag)), ("redirect", ("redirect", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect)), ("out-intf", ("out_intf", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf)), ("serv-func", ("serv_func", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc)), ("police", ("police", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police)), ("shape", ("shape", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape)), ("child-policy", ("child_policy", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy)), ("cac", ("cac", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac)), ("pfc", ("pfc", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc)), ("flow-parm", ("flow_parm", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm)), ("ipcbr", ("ipcbr", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr)), ("rtp", ("rtp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp)), ("rtp-mmr", ("rtp_mmr", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr)), ("rtp-j2k", ("rtp_j2k", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k)), ("rtp-voice", ("rtp_voice", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice)), ("mdi", ("mdi", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi)), ("mdi-rtp", ("mdi_rtp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp)), ("fmm", ("fmm", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm)), ("pbf", ("pbf", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf)), ("ipv4-nh", ("ipv4_nh", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh)), ("ipv6-nh", ("ipv6_nh", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh))])
                                                                    self._leafs = OrderedDict([
                                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                        ('data_p', (YLeaf(YType.uint32, 'data-p'), ['int'])),
                                                                    ])
                                                                    self.type = None
                                                                    self.data_p = None

                                                                    self.mark = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark()
                                                                    self.mark.parent = self
                                                                    self._children_name_map["mark"] = "mark"

                                                                    self.mark2 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2()
                                                                    self.mark2.parent = self
                                                                    self._children_name_map["mark2"] = "mark2"

                                                                    self.wred = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred()
                                                                    self.wred.parent = self
                                                                    self._children_name_map["wred"] = "wred"

                                                                    self.encap = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap()
                                                                    self.encap.parent = self
                                                                    self._children_name_map["encap"] = "encap"

                                                                    self.prio = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio()
                                                                    self.prio.parent = self
                                                                    self._children_name_map["prio"] = "prio"

                                                                    self.bwrem = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem()
                                                                    self.bwrem.parent = self
                                                                    self._children_name_map["bwrem"] = "bwrem"

                                                                    self.min_bw = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw()
                                                                    self.min_bw.parent = self
                                                                    self._children_name_map["min_bw"] = "min-bw"

                                                                    self.authen_aaa = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa()
                                                                    self.authen_aaa.parent = self
                                                                    self._children_name_map["authen_aaa"] = "authen-aaa"

                                                                    self.collect_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId()
                                                                    self.collect_id.parent = self
                                                                    self._children_name_map["collect_id"] = "collect-id"

                                                                    self.decode_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId()
                                                                    self.decode_id.parent = self
                                                                    self._children_name_map["decode_id"] = "decode-id"

                                                                    self.set_timer = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer()
                                                                    self.set_timer.parent = self
                                                                    self._children_name_map["set_timer"] = "set-timer"

                                                                    self.stop_timer = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer()
                                                                    self.stop_timer.parent = self
                                                                    self._children_name_map["stop_timer"] = "stop-timer"

                                                                    self.acct_aaa_list = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList()
                                                                    self.acct_aaa_list.parent = self
                                                                    self._children_name_map["acct_aaa_list"] = "acct-aaa-list"

                                                                    self.query_ancp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp()
                                                                    self.query_ancp.parent = self
                                                                    self._children_name_map["query_ancp"] = "query-ancp"

                                                                    self.prepaid_cfg = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg()
                                                                    self.prepaid_cfg.parent = self
                                                                    self._children_name_map["prepaid_cfg"] = "prepaid-cfg"

                                                                    self.timeout_idle = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle()
                                                                    self.timeout_idle.parent = self
                                                                    self._children_name_map["timeout_idle"] = "timeout-idle"

                                                                    self.proxy_aaa = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa()
                                                                    self.proxy_aaa.parent = self
                                                                    self._children_name_map["proxy_aaa"] = "proxy-aaa"

                                                                    self.act_template = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate()
                                                                    self.act_template.parent = self
                                                                    self._children_name_map["act_template"] = "act-template"

                                                                    self.deact_template = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate()
                                                                    self.deact_template.parent = self
                                                                    self._children_name_map["deact_template"] = "deact-template"

                                                                    self.qlimit = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit()
                                                                    self.qlimit.parent = self
                                                                    self._children_name_map["qlimit"] = "qlimit"

                                                                    self.accounting_event_aaa = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa()
                                                                    self.accounting_event_aaa.parent = self
                                                                    self._children_name_map["accounting_event_aaa"] = "accounting-event-aaa"

                                                                    self.authorize_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId()
                                                                    self.authorize_id.parent = self
                                                                    self._children_name_map["authorize_id"] = "authorize-id"

                                                                    self.afm_react = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact()
                                                                    self.afm_react.parent = self
                                                                    self._children_name_map["afm_react"] = "afm-react"

                                                                    self.httpr = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr()
                                                                    self.httpr.parent = self
                                                                    self._children_name_map["httpr"] = "httpr"

                                                                    self.punt = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt()
                                                                    self.punt.parent = self
                                                                    self._children_name_map["punt"] = "punt"

                                                                    self.copy = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy()
                                                                    self.copy.parent = self
                                                                    self._children_name_map["copy"] = "copy"

                                                                    self.sfrag = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag()
                                                                    self.sfrag.parent = self
                                                                    self._children_name_map["sfrag"] = "sfrag"

                                                                    self.redirect = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect()
                                                                    self.redirect.parent = self
                                                                    self._children_name_map["redirect"] = "redirect"

                                                                    self.out_intf = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf()
                                                                    self.out_intf.parent = self
                                                                    self._children_name_map["out_intf"] = "out-intf"

                                                                    self.serv_func = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc()
                                                                    self.serv_func.parent = self
                                                                    self._children_name_map["serv_func"] = "serv-func"

                                                                    self.police = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police()
                                                                    self.police.parent = self
                                                                    self._children_name_map["police"] = "police"

                                                                    self.shape = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape()
                                                                    self.shape.parent = self
                                                                    self._children_name_map["shape"] = "shape"

                                                                    self.child_policy = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy()
                                                                    self.child_policy.parent = self
                                                                    self._children_name_map["child_policy"] = "child-policy"

                                                                    self.cac = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac()
                                                                    self.cac.parent = self
                                                                    self._children_name_map["cac"] = "cac"

                                                                    self.pfc = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc()
                                                                    self.pfc.parent = self
                                                                    self._children_name_map["pfc"] = "pfc"

                                                                    self.flow_parm = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm()
                                                                    self.flow_parm.parent = self
                                                                    self._children_name_map["flow_parm"] = "flow-parm"

                                                                    self.ipcbr = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr()
                                                                    self.ipcbr.parent = self
                                                                    self._children_name_map["ipcbr"] = "ipcbr"

                                                                    self.rtp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp()
                                                                    self.rtp.parent = self
                                                                    self._children_name_map["rtp"] = "rtp"

                                                                    self.rtp_mmr = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr()
                                                                    self.rtp_mmr.parent = self
                                                                    self._children_name_map["rtp_mmr"] = "rtp-mmr"

                                                                    self.rtp_j2k = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k()
                                                                    self.rtp_j2k.parent = self
                                                                    self._children_name_map["rtp_j2k"] = "rtp-j2k"

                                                                    self.rtp_voice = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice()
                                                                    self.rtp_voice.parent = self
                                                                    self._children_name_map["rtp_voice"] = "rtp-voice"

                                                                    self.mdi = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi()
                                                                    self.mdi.parent = self
                                                                    self._children_name_map["mdi"] = "mdi"

                                                                    self.mdi_rtp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp()
                                                                    self.mdi_rtp.parent = self
                                                                    self._children_name_map["mdi_rtp"] = "mdi-rtp"

                                                                    self.fmm = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm()
                                                                    self.fmm.parent = self
                                                                    self._children_name_map["fmm"] = "fmm"

                                                                    self.pbf = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf()
                                                                    self.pbf.parent = self
                                                                    self._children_name_map["pbf"] = "pbf"

                                                                    self.ipv4_nh = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh()
                                                                    self.ipv4_nh.parent = self
                                                                    self._children_name_map["ipv4_nh"] = "ipv4-nh"

                                                                    self.ipv6_nh = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh()
                                                                    self.ipv6_nh.parent = self
                                                                    self._children_name_map["ipv6_nh"] = "ipv6-nh"
                                                                    self._segment_path = lambda: "actp"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp, ['type', 'data_p'], name, value)


                                                                class Mark(Entity):
                                                                    """
                                                                    mark
                                                                    
                                                                    .. attribute:: action_mark_info
                                                                    
                                                                    	action mark info
                                                                    	**type**\: list of  		 :py:class:`ActionMarkInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark, self).__init__()

                                                                        self.yang_name = "mark"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("action-mark-info", ("action_mark_info", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo))])
                                                                        self._leafs = OrderedDict()

                                                                        self.action_mark_info = YList(self)
                                                                        self._segment_path = lambda: "mark"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark, [], name, value)


                                                                    class ActionMarkInfo(Entity):
                                                                        """
                                                                        action mark info
                                                                        
                                                                        .. attribute:: type
                                                                        
                                                                        	type
                                                                        	**type**\:  :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                        
                                                                        .. attribute:: mark_flags
                                                                        
                                                                        	mark flags
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..65535
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo, self).__init__()

                                                                            self.yang_name = "action-mark-info"
                                                                            self.yang_parent_name = "mark"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MarkTypeEn', '')])),
                                                                                ('mark_flags', (YLeaf(YType.uint32, 'mark-flags'), ['int'])),
                                                                                ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                            ])
                                                                            self.type = None
                                                                            self.mark_flags = None
                                                                            self.value = None
                                                                            self._segment_path = lambda: "action-mark-info"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo, ['type', 'mark_flags', 'value'], name, value)


                                                                class Mark2(Entity):
                                                                    """
                                                                    mark2
                                                                    
                                                                    .. attribute:: action_mark2_info
                                                                    
                                                                    	action mark2 info
                                                                    	**type**\: list of  		 :py:class:`ActionMark2Info <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2, self).__init__()

                                                                        self.yang_name = "mark2"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("action-mark2-info", ("action_mark2_info", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info))])
                                                                        self._leafs = OrderedDict()

                                                                        self.action_mark2_info = YList(self)
                                                                        self._segment_path = lambda: "mark2"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2, [], name, value)


                                                                    class ActionMark2Info(Entity):
                                                                        """
                                                                        action mark2 info
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: value_overflow
                                                                        
                                                                        	value overflow
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..65535
                                                                        
                                                                        .. attribute:: type
                                                                        
                                                                        	type
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: mark_flags
                                                                        
                                                                        	mark flags
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info, self).__init__()

                                                                            self.yang_name = "action-mark2-info"
                                                                            self.yang_parent_name = "mark2"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                ('value_overflow', (YLeaf(YType.uint16, 'value-overflow'), ['int'])),
                                                                                ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                ('mark_flags', (YLeaf(YType.uint8, 'mark-flags'), ['int'])),
                                                                            ])
                                                                            self.value = None
                                                                            self.value_overflow = None
                                                                            self.type = None
                                                                            self.mark_flags = None
                                                                            self._segment_path = lambda: "action-mark2-info"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info, ['value', 'value_overflow', 'type', 'mark_flags'], name, value)


                                                                class Wred(Entity):
                                                                    """
                                                                    wred
                                                                    
                                                                    .. attribute:: action_wred_info
                                                                    
                                                                    	action wred info
                                                                    	**type**\: list of  		 :py:class:`ActionWredInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred, self).__init__()

                                                                        self.yang_name = "wred"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("action-wred-info", ("action_wred_info", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo))])
                                                                        self._leafs = OrderedDict()

                                                                        self.action_wred_info = YList(self)
                                                                        self._segment_path = lambda: "wred"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred, [], name, value)


                                                                    class ActionWredInfo(Entity):
                                                                        """
                                                                        action wred info
                                                                        
                                                                        .. attribute:: match_ranges
                                                                        
                                                                        	match ranges
                                                                        	**type**\:  :py:class:`MatchRanges <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges>`
                                                                        
                                                                        .. attribute:: min_threshold
                                                                        
                                                                        	min threshold
                                                                        	**type**\:  :py:class:`MinThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold>`
                                                                        
                                                                        .. attribute:: max_threshold
                                                                        
                                                                        	max threshold
                                                                        	**type**\:  :py:class:`MaxThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold>`
                                                                        
                                                                        .. attribute:: type
                                                                        
                                                                        	cos/prec/dscp/ based WRED
                                                                        	**type**\:  :py:class:`WredTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.WredTypeEn>`
                                                                        
                                                                        .. attribute:: wred_flags
                                                                        
                                                                        	wred flags
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: probability
                                                                        
                                                                        	probability
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo, self).__init__()

                                                                            self.yang_name = "action-wred-info"
                                                                            self.yang_parent_name = "wred"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("match-ranges", ("match_ranges", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges)), ("min-threshold", ("min_threshold", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold)), ("max-threshold", ("max_threshold", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold))])
                                                                            self._leafs = OrderedDict([
                                                                                ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'WredTypeEn', '')])),
                                                                                ('wred_flags', (YLeaf(YType.uint32, 'wred-flags'), ['int'])),
                                                                                ('probability', (YLeaf(YType.uint32, 'probability'), ['int'])),
                                                                            ])
                                                                            self.type = None
                                                                            self.wred_flags = None
                                                                            self.probability = None

                                                                            self.match_ranges = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges()
                                                                            self.match_ranges.parent = self
                                                                            self._children_name_map["match_ranges"] = "match-ranges"

                                                                            self.min_threshold = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold()
                                                                            self.min_threshold.parent = self
                                                                            self._children_name_map["min_threshold"] = "min-threshold"

                                                                            self.max_threshold = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold()
                                                                            self.max_threshold.parent = self
                                                                            self._children_name_map["max_threshold"] = "max-threshold"
                                                                            self._segment_path = lambda: "action-wred-info"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo, ['type', 'wred_flags', 'probability'], name, value)


                                                                        class MatchRanges(Entity):
                                                                            """
                                                                            match ranges
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges, self).__init__()

                                                                                self.yang_name = "match-ranges"
                                                                                self.yang_parent_name = "action-wred-info"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "match-ranges"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "match-ranges"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray, ['min', 'max'], name, value)


                                                                        class MinThreshold(Entity):
                                                                            """
                                                                            min threshold
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold, self).__init__()

                                                                                self.yang_name = "min-threshold"
                                                                                self.yang_parent_name = "action-wred-info"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "min-threshold"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold, ['value', 'unit'], name, value)


                                                                        class MaxThreshold(Entity):
                                                                            """
                                                                            max threshold
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold, self).__init__()

                                                                                self.yang_name = "max-threshold"
                                                                                self.yang_parent_name = "action-wred-info"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "max-threshold"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold, ['value', 'unit'], name, value)


                                                                class Encap(Entity):
                                                                    """
                                                                    encap
                                                                    
                                                                    .. attribute:: seq
                                                                    
                                                                    	seq
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap, self).__init__()

                                                                        self.yang_name = "encap"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('seq', (YLeaf(YType.uint8, 'seq'), ['int'])),
                                                                        ])
                                                                        self.seq = None
                                                                        self._segment_path = lambda: "encap"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap, ['seq'], name, value)


                                                                class Prio(Entity):
                                                                    """
                                                                    prio
                                                                    
                                                                    .. attribute:: prio_lvl
                                                                    
                                                                    	prio lvl
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio, self).__init__()

                                                                        self.yang_name = "prio"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('prio_lvl', (YLeaf(YType.uint32, 'prio-lvl'), ['int'])),
                                                                        ])
                                                                        self.prio_lvl = None
                                                                        self._segment_path = lambda: "prio"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio, ['prio_lvl'], name, value)


                                                                class Bwrem(Entity):
                                                                    """
                                                                    bwrem
                                                                    
                                                                    .. attribute:: bwrem
                                                                    
                                                                    	bwrem
                                                                    	**type**\:  :py:class:`Bwrem_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem_>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem, self).__init__()

                                                                        self.yang_name = "bwrem"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("bwrem", ("bwrem", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem_))])
                                                                        self._leafs = OrderedDict()

                                                                        self.bwrem = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem_()
                                                                        self.bwrem.parent = self
                                                                        self._children_name_map["bwrem"] = "bwrem"
                                                                        self._segment_path = lambda: "bwrem"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem, [], name, value)


                                                                    class Bwrem_(Entity):
                                                                        """
                                                                        bwrem
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem_, self).__init__()

                                                                            self.yang_name = "bwrem"
                                                                            self.yang_parent_name = "bwrem"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                            ])
                                                                            self.value = None
                                                                            self.unit = None
                                                                            self._segment_path = lambda: "bwrem"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem_, ['value', 'unit'], name, value)


                                                                class MinBw(Entity):
                                                                    """
                                                                    min bw
                                                                    
                                                                    .. attribute:: bw
                                                                    
                                                                    	bw
                                                                    	**type**\:  :py:class:`Bw <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw, self).__init__()

                                                                        self.yang_name = "min-bw"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("bw", ("bw", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw))])
                                                                        self._leafs = OrderedDict()

                                                                        self.bw = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw()
                                                                        self.bw.parent = self
                                                                        self._children_name_map["bw"] = "bw"
                                                                        self._segment_path = lambda: "min-bw"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw, [], name, value)


                                                                    class Bw(Entity):
                                                                        """
                                                                        bw
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw, self).__init__()

                                                                            self.yang_name = "bw"
                                                                            self.yang_parent_name = "min-bw"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                            ])
                                                                            self.value = None
                                                                            self.unit = None
                                                                            self._segment_path = lambda: "bw"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw, ['value', 'unit'], name, value)


                                                                class AuthenAaa(Entity):
                                                                    """
                                                                    authen aaa
                                                                    
                                                                    .. attribute:: aaa_list_name
                                                                    
                                                                    	aaa list name
                                                                    	**type**\: str
                                                                    
                                                                    .. attribute:: authen_password
                                                                    
                                                                    	authen password
                                                                    	**type**\: str
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa, self).__init__()

                                                                        self.yang_name = "authen-aaa"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                            ('authen_password', (YLeaf(YType.str, 'authen-password'), ['str'])),
                                                                        ])
                                                                        self.aaa_list_name = None
                                                                        self.authen_password = None
                                                                        self._segment_path = lambda: "authen-aaa"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa, ['aaa_list_name', 'authen_password'], name, value)


                                                                class CollectId(Entity):
                                                                    """
                                                                    collect id
                                                                    
                                                                    .. attribute:: id
                                                                    
                                                                    	id
                                                                    	**type**\:  :py:class:`IdentifierEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.IdentifierEn>`
                                                                    
                                                                    .. attribute:: aaa_list_name
                                                                    
                                                                    	aaa list name
                                                                    	**type**\: str
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId, self).__init__()

                                                                        self.yang_name = "collect-id"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('id', (YLeaf(YType.enumeration, 'id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'IdentifierEn', '')])),
                                                                            ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                        ])
                                                                        self.id = None
                                                                        self.aaa_list_name = None
                                                                        self._segment_path = lambda: "collect-id"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId, ['id', 'aaa_list_name'], name, value)


                                                                class DecodeId(Entity):
                                                                    """
                                                                    decode id
                                                                    
                                                                    .. attribute:: id
                                                                    
                                                                    	id
                                                                    	**type**\:  :py:class:`DecodeIdentifierEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.DecodeIdentifierEn>`
                                                                    
                                                                    .. attribute:: format_name
                                                                    
                                                                    	format name
                                                                    	**type**\: str
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId, self).__init__()

                                                                        self.yang_name = "decode-id"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('id', (YLeaf(YType.enumeration, 'id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'DecodeIdentifierEn', '')])),
                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                        ])
                                                                        self.id = None
                                                                        self.format_name = None
                                                                        self._segment_path = lambda: "decode-id"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId, ['id', 'format_name'], name, value)


                                                                class SetTimer(Entity):
                                                                    """
                                                                    set timer
                                                                    
                                                                    .. attribute:: timer_name
                                                                    
                                                                    	timer name
                                                                    	**type**\: str
                                                                    
                                                                    .. attribute:: duration
                                                                    
                                                                    	duration
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: absolute_time
                                                                    
                                                                    	absolute time
                                                                    	**type**\: str
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer, self).__init__()

                                                                        self.yang_name = "set-timer"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('timer_name', (YLeaf(YType.str, 'timer-name'), ['str'])),
                                                                            ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                                            ('absolute_time', (YLeaf(YType.str, 'absolute-time'), ['str'])),
                                                                        ])
                                                                        self.timer_name = None
                                                                        self.duration = None
                                                                        self.absolute_time = None
                                                                        self._segment_path = lambda: "set-timer"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer, ['timer_name', 'duration', 'absolute_time'], name, value)


                                                                class StopTimer(Entity):
                                                                    """
                                                                    stop timer
                                                                    
                                                                    .. attribute:: timer_name
                                                                    
                                                                    	timer name
                                                                    	**type**\: str
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer, self).__init__()

                                                                        self.yang_name = "stop-timer"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('timer_name', (YLeaf(YType.str, 'timer-name'), ['str'])),
                                                                        ])
                                                                        self.timer_name = None
                                                                        self._segment_path = lambda: "stop-timer"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer, ['timer_name'], name, value)


                                                                class AcctAaaList(Entity):
                                                                    """
                                                                    acct aaa list
                                                                    
                                                                    .. attribute:: aaa_list_name
                                                                    
                                                                    	aaa list name
                                                                    	**type**\: str
                                                                    
                                                                    .. attribute:: secs
                                                                    
                                                                    	secs
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList, self).__init__()

                                                                        self.yang_name = "acct-aaa-list"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                            ('secs', (YLeaf(YType.uint32, 'secs'), ['int'])),
                                                                        ])
                                                                        self.aaa_list_name = None
                                                                        self.secs = None
                                                                        self._segment_path = lambda: "acct-aaa-list"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList, ['aaa_list_name', 'secs'], name, value)


                                                                class QueryAncp(Entity):
                                                                    """
                                                                    query ancp
                                                                    
                                                                    .. attribute:: enable
                                                                    
                                                                    	enable
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp, self).__init__()

                                                                        self.yang_name = "query-ancp"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('enable', (YLeaf(YType.uint8, 'enable'), ['int'])),
                                                                        ])
                                                                        self.enable = None
                                                                        self._segment_path = lambda: "query-ancp"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp, ['enable'], name, value)


                                                                class PrepaidCfg(Entity):
                                                                    """
                                                                    prepaid cfg
                                                                    
                                                                    .. attribute:: prepaid_config_profile_name
                                                                    
                                                                    	prepaid config profile name
                                                                    	**type**\: str
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg, self).__init__()

                                                                        self.yang_name = "prepaid-cfg"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('prepaid_config_profile_name', (YLeaf(YType.str, 'prepaid-config-profile-name'), ['str'])),
                                                                        ])
                                                                        self.prepaid_config_profile_name = None
                                                                        self._segment_path = lambda: "prepaid-cfg"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg, ['prepaid_config_profile_name'], name, value)


                                                                class TimeoutIdle(Entity):
                                                                    """
                                                                    timeout idle
                                                                    
                                                                    .. attribute:: secs
                                                                    
                                                                    	secs
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle, self).__init__()

                                                                        self.yang_name = "timeout-idle"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('secs', (YLeaf(YType.uint32, 'secs'), ['int'])),
                                                                        ])
                                                                        self.secs = None
                                                                        self._segment_path = lambda: "timeout-idle"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle, ['secs'], name, value)


                                                                class ProxyAaa(Entity):
                                                                    """
                                                                    proxy aaa
                                                                    
                                                                    .. attribute:: aaa_list_name
                                                                    
                                                                    	aaa list name
                                                                    	**type**\: str
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa, self).__init__()

                                                                        self.yang_name = "proxy-aaa"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                        ])
                                                                        self.aaa_list_name = None
                                                                        self._segment_path = lambda: "proxy-aaa"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa, ['aaa_list_name'], name, value)


                                                                class ActTemplate(Entity):
                                                                    """
                                                                    act template
                                                                    
                                                                    .. attribute:: template_name
                                                                    
                                                                    	template name
                                                                    	**type**\: str
                                                                    
                                                                    .. attribute:: aaa_list_name
                                                                    
                                                                    	aaa list name
                                                                    	**type**\: str
                                                                    
                                                                    .. attribute:: flags
                                                                    
                                                                    	flags
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate, self).__init__()

                                                                        self.yang_name = "act-template"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('template_name', (YLeaf(YType.str, 'template-name'), ['str'])),
                                                                            ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                            ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                        ])
                                                                        self.template_name = None
                                                                        self.aaa_list_name = None
                                                                        self.flags = None
                                                                        self._segment_path = lambda: "act-template"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate, ['template_name', 'aaa_list_name', 'flags'], name, value)


                                                                class DeactTemplate(Entity):
                                                                    """
                                                                    deact template
                                                                    
                                                                    .. attribute:: template_name
                                                                    
                                                                    	template name
                                                                    	**type**\: str
                                                                    
                                                                    .. attribute:: aaa_list_name
                                                                    
                                                                    	aaa list name
                                                                    	**type**\: str
                                                                    
                                                                    .. attribute:: flags
                                                                    
                                                                    	flags
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate, self).__init__()

                                                                        self.yang_name = "deact-template"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('template_name', (YLeaf(YType.str, 'template-name'), ['str'])),
                                                                            ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                            ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                        ])
                                                                        self.template_name = None
                                                                        self.aaa_list_name = None
                                                                        self.flags = None
                                                                        self._segment_path = lambda: "deact-template"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate, ['template_name', 'aaa_list_name', 'flags'], name, value)


                                                                class Qlimit(Entity):
                                                                    """
                                                                    qlimit
                                                                    
                                                                    .. attribute:: action_qlimit_info_array
                                                                    
                                                                    	action qlimit info array
                                                                    	**type**\: list of  		 :py:class:`ActionQlimitInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit, self).__init__()

                                                                        self.yang_name = "qlimit"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("action-qlimit-info-array", ("action_qlimit_info_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray))])
                                                                        self._leafs = OrderedDict()

                                                                        self.action_qlimit_info_array = YList(self)
                                                                        self._segment_path = lambda: "qlimit"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit, [], name, value)


                                                                    class ActionQlimitInfoArray(Entity):
                                                                        """
                                                                        action qlimit info array
                                                                        
                                                                        .. attribute:: qlim
                                                                        
                                                                        	qlim
                                                                        	**type**\:  :py:class:`Qlim <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim>`
                                                                        
                                                                        .. attribute:: atmclp_qlim
                                                                        
                                                                        	atmclp qlim
                                                                        	**type**\:  :py:class:`AtmclpQlim <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim>`
                                                                        
                                                                        .. attribute:: match_values
                                                                        
                                                                        	match values
                                                                        	**type**\:  :py:class:`MatchValues <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues>`
                                                                        
                                                                        .. attribute:: type
                                                                        
                                                                        	type
                                                                        	**type**\:  :py:class:`QlimitTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.QlimitTypeEn>`
                                                                        
                                                                        .. attribute:: qlimit_flags
                                                                        
                                                                        	qlimit flags
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray, self).__init__()

                                                                            self.yang_name = "action-qlimit-info-array"
                                                                            self.yang_parent_name = "qlimit"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("qlim", ("qlim", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim)), ("atmclp-qlim", ("atmclp_qlim", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim)), ("match-values", ("match_values", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues))])
                                                                            self._leafs = OrderedDict([
                                                                                ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'QlimitTypeEn', '')])),
                                                                                ('qlimit_flags', (YLeaf(YType.uint32, 'qlimit-flags'), ['int'])),
                                                                            ])
                                                                            self.type = None
                                                                            self.qlimit_flags = None

                                                                            self.qlim = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim()
                                                                            self.qlim.parent = self
                                                                            self._children_name_map["qlim"] = "qlim"

                                                                            self.atmclp_qlim = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim()
                                                                            self.atmclp_qlim.parent = self
                                                                            self._children_name_map["atmclp_qlim"] = "atmclp-qlim"

                                                                            self.match_values = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues()
                                                                            self.match_values.parent = self
                                                                            self._children_name_map["match_values"] = "match-values"
                                                                            self._segment_path = lambda: "action-qlimit-info-array"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray, ['type', 'qlimit_flags'], name, value)


                                                                        class Qlim(Entity):
                                                                            """
                                                                            qlim
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim, self).__init__()

                                                                                self.yang_name = "qlim"
                                                                                self.yang_parent_name = "action-qlimit-info-array"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "qlim"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim, ['value', 'unit'], name, value)


                                                                        class AtmclpQlim(Entity):
                                                                            """
                                                                            atmclp qlim
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim, self).__init__()

                                                                                self.yang_name = "atmclp-qlim"
                                                                                self.yang_parent_name = "action-qlimit-info-array"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "atmclp-qlim"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim, ['value', 'unit'], name, value)


                                                                        class MatchValues(Entity):
                                                                            """
                                                                            match values
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues, self).__init__()

                                                                                self.yang_name = "match-values"
                                                                                self.yang_parent_name = "action-qlimit-info-array"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "match-values"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "match-values"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray, ['min', 'max'], name, value)


                                                                class AccountingEventAaa(Entity):
                                                                    """
                                                                    accounting event aaa
                                                                    
                                                                    .. attribute:: action
                                                                    
                                                                    	action
                                                                    	**type**\:  :py:class:`AcctEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.AcctEn>`
                                                                    
                                                                    .. attribute:: aaa_list_name
                                                                    
                                                                    	aaa list name
                                                                    	**type**\: str
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa, self).__init__()

                                                                        self.yang_name = "accounting-event-aaa"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('action', (YLeaf(YType.enumeration, 'action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'AcctEn', '')])),
                                                                            ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                        ])
                                                                        self.action = None
                                                                        self.aaa_list_name = None
                                                                        self._segment_path = lambda: "accounting-event-aaa"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa, ['action', 'aaa_list_name'], name, value)


                                                                class AuthorizeId(Entity):
                                                                    """
                                                                    authorize id
                                                                    
                                                                    .. attribute:: id
                                                                    
                                                                    	id
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    .. attribute:: aaa_list_name
                                                                    
                                                                    	aaa list name
                                                                    	**type**\: str
                                                                    
                                                                    .. attribute:: format_name
                                                                    
                                                                    	format name
                                                                    	**type**\: str
                                                                    
                                                                    .. attribute:: password
                                                                    
                                                                    	password
                                                                    	**type**\: str
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId, self).__init__()

                                                                        self.yang_name = "authorize-id"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('id', (YLeaf(YType.uint8, 'id'), ['int'])),
                                                                            ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                            ('password', (YLeaf(YType.str, 'password'), ['str'])),
                                                                        ])
                                                                        self.id = None
                                                                        self.aaa_list_name = None
                                                                        self.format_name = None
                                                                        self.password = None
                                                                        self._segment_path = lambda: "authorize-id"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId, ['id', 'aaa_list_name', 'format_name', 'password'], name, value)


                                                                class AfmReact(Entity):
                                                                    """
                                                                    afm react
                                                                    
                                                                    .. attribute:: action_afmon_react_info
                                                                    
                                                                    	action afmon react info
                                                                    	**type**\: list of  		 :py:class:`ActionAfmonReactInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact, self).__init__()

                                                                        self.yang_name = "afm-react"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("action-afmon-react-info", ("action_afmon_react_info", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo))])
                                                                        self._leafs = OrderedDict()

                                                                        self.action_afmon_react_info = YList(self)
                                                                        self._segment_path = lambda: "afm-react"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact, [], name, value)


                                                                    class ActionAfmonReactInfo(Entity):
                                                                        """
                                                                        action afmon react info
                                                                        
                                                                        .. attribute:: oper_id
                                                                        
                                                                        	React Operation ID
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: description
                                                                        
                                                                        	Describing the oper
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: trig_num_intvls
                                                                        
                                                                        	Averaged over N intvls
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: clone_ifh
                                                                        
                                                                        	Clone interface handle
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: notif_actns
                                                                        
                                                                        	Bitmap of actions on alert
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: criterion
                                                                        
                                                                        	React Criterion
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: trig_type
                                                                        
                                                                        	Immediate or averaged thresh trigger
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: trig_relop
                                                                        
                                                                        	Trigger LT\|LE\|GT\|GE\|Range
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: trig_level_1
                                                                        
                                                                        	Trigger threshold 1/lower
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: trig_level_2
                                                                        
                                                                        	Trigger upper threshold for range
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: alm_grp_thresh
                                                                        
                                                                        	Num/percent in grp
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..65535
                                                                        
                                                                        	**units**\: percentage
                                                                        
                                                                        .. attribute:: alm_type
                                                                        
                                                                        	Discrete \| grouped alarm
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: alm_severity
                                                                        
                                                                        	Major\|Minor\|... alarm
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo, self).__init__()

                                                                            self.yang_name = "action-afmon-react-info"
                                                                            self.yang_parent_name = "afm-react"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('oper_id', (YLeaf(YType.uint32, 'oper-id'), ['int'])),
                                                                                ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                ('trig_num_intvls', (YLeaf(YType.uint32, 'trig-num-intvls'), ['int'])),
                                                                                ('clone_ifh', (YLeaf(YType.uint32, 'clone-ifh'), ['int'])),
                                                                                ('notif_actns', (YLeaf(YType.uint8, 'notif-actns'), ['int'])),
                                                                                ('criterion', (YLeaf(YType.uint8, 'criterion'), ['int'])),
                                                                                ('trig_type', (YLeaf(YType.uint8, 'trig-type'), ['int'])),
                                                                                ('trig_relop', (YLeaf(YType.uint8, 'trig-relop'), ['int'])),
                                                                                ('trig_level_1', (YLeaf(YType.str, 'trig-level-1'), ['str'])),
                                                                                ('trig_level_2', (YLeaf(YType.str, 'trig-level-2'), ['str'])),
                                                                                ('alm_grp_thresh', (YLeaf(YType.uint16, 'alm-grp-thresh'), ['int'])),
                                                                                ('alm_type', (YLeaf(YType.uint8, 'alm-type'), ['int'])),
                                                                                ('alm_severity', (YLeaf(YType.uint8, 'alm-severity'), ['int'])),
                                                                            ])
                                                                            self.oper_id = None
                                                                            self.description = None
                                                                            self.trig_num_intvls = None
                                                                            self.clone_ifh = None
                                                                            self.notif_actns = None
                                                                            self.criterion = None
                                                                            self.trig_type = None
                                                                            self.trig_relop = None
                                                                            self.trig_level_1 = None
                                                                            self.trig_level_2 = None
                                                                            self.alm_grp_thresh = None
                                                                            self.alm_type = None
                                                                            self.alm_severity = None
                                                                            self._segment_path = lambda: "action-afmon-react-info"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo, ['oper_id', 'description', 'trig_num_intvls', 'clone_ifh', 'notif_actns', 'criterion', 'trig_type', 'trig_relop', 'trig_level_1', 'trig_level_2', 'alm_grp_thresh', 'alm_type', 'alm_severity'], name, value)


                                                                class Httpr(Entity):
                                                                    """
                                                                    httpr
                                                                    
                                                                    .. attribute:: redirect_url
                                                                    
                                                                    	redirect url
                                                                    	**type**\: str
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr, self).__init__()

                                                                        self.yang_name = "httpr"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('redirect_url', (YLeaf(YType.str, 'redirect-url'), ['str'])),
                                                                        ])
                                                                        self.redirect_url = None
                                                                        self._segment_path = lambda: "httpr"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr, ['redirect_url'], name, value)


                                                                class Punt(Entity):
                                                                    """
                                                                    punt
                                                                    
                                                                    .. attribute:: sn_type
                                                                    
                                                                    	service node ID type
                                                                    	**type**\:  :py:class:`DpssSnidTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.DpssSnidTypeEn>`
                                                                    
                                                                    .. attribute:: sn_index
                                                                    
                                                                    	service node index
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: sn_name
                                                                    
                                                                    	service node name
                                                                    	**type**\: str
                                                                    
                                                                    .. attribute:: app_id
                                                                    
                                                                    	application ID
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: local_id
                                                                    
                                                                    	local ID
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: vsnode_type
                                                                    
                                                                    	vservice node type
                                                                    	**type**\:  :py:class:`VsvcServiceTypeT <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.VsvcServiceTypeT>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt, self).__init__()

                                                                        self.yang_name = "punt"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('sn_type', (YLeaf(YType.enumeration, 'sn-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'DpssSnidTypeEn', '')])),
                                                                            ('sn_index', (YLeaf(YType.uint32, 'sn-index'), ['int'])),
                                                                            ('sn_name', (YLeaf(YType.str, 'sn-name'), ['str'])),
                                                                            ('app_id', (YLeaf(YType.uint32, 'app-id'), ['int'])),
                                                                            ('local_id', (YLeaf(YType.uint32, 'local-id'), ['int'])),
                                                                            ('vsnode_type', (YLeaf(YType.enumeration, 'vsnode-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'VsvcServiceTypeT', '')])),
                                                                        ])
                                                                        self.sn_type = None
                                                                        self.sn_index = None
                                                                        self.sn_name = None
                                                                        self.app_id = None
                                                                        self.local_id = None
                                                                        self.vsnode_type = None
                                                                        self._segment_path = lambda: "punt"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt, ['sn_type', 'sn_index', 'sn_name', 'app_id', 'local_id', 'vsnode_type'], name, value)


                                                                class Copy(Entity):
                                                                    """
                                                                    copy
                                                                    
                                                                    .. attribute:: num_byte
                                                                    
                                                                    	number of bytes
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: sn_type
                                                                    
                                                                    	service node ID type
                                                                    	**type**\:  :py:class:`DpssSnidTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.DpssSnidTypeEn>`
                                                                    
                                                                    .. attribute:: sn_index
                                                                    
                                                                    	service node index
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: sn_name
                                                                    
                                                                    	service node url
                                                                    	**type**\: str
                                                                    
                                                                    .. attribute:: app_id
                                                                    
                                                                    	application ID
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: local_id
                                                                    
                                                                    	local ID
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: vsnode_type
                                                                    
                                                                    	vservice node type
                                                                    	**type**\:  :py:class:`VsvcServiceTypeT <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.VsvcServiceTypeT>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy, self).__init__()

                                                                        self.yang_name = "copy"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('num_byte', (YLeaf(YType.uint32, 'num-byte'), ['int'])),
                                                                            ('sn_type', (YLeaf(YType.enumeration, 'sn-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'DpssSnidTypeEn', '')])),
                                                                            ('sn_index', (YLeaf(YType.uint32, 'sn-index'), ['int'])),
                                                                            ('sn_name', (YLeaf(YType.str, 'sn-name'), ['str'])),
                                                                            ('app_id', (YLeaf(YType.uint32, 'app-id'), ['int'])),
                                                                            ('local_id', (YLeaf(YType.uint32, 'local-id'), ['int'])),
                                                                            ('vsnode_type', (YLeaf(YType.enumeration, 'vsnode-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'VsvcServiceTypeT', '')])),
                                                                        ])
                                                                        self.num_byte = None
                                                                        self.sn_type = None
                                                                        self.sn_index = None
                                                                        self.sn_name = None
                                                                        self.app_id = None
                                                                        self.local_id = None
                                                                        self.vsnode_type = None
                                                                        self._segment_path = lambda: "copy"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy, ['num_byte', 'sn_type', 'sn_index', 'sn_name', 'app_id', 'local_id', 'vsnode_type'], name, value)


                                                                class Sfrag(Entity):
                                                                    """
                                                                    sfrag
                                                                    
                                                                    .. attribute:: name
                                                                    
                                                                    	Service Fragment Name
                                                                    	**type**\: str
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag, self).__init__()

                                                                        self.yang_name = "sfrag"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                        ])
                                                                        self.name = None
                                                                        self._segment_path = lambda: "sfrag"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag, ['name'], name, value)


                                                                class Redirect(Entity):
                                                                    """
                                                                    redirect
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: type
                                                                    
                                                                    	type
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect, self).__init__()

                                                                        self.yang_name = "redirect"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                            ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                        ])
                                                                        self.value = None
                                                                        self.type = None
                                                                        self._segment_path = lambda: "redirect"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect, ['value', 'type'], name, value)


                                                                class OutIntf(Entity):
                                                                    """
                                                                    out intf
                                                                    
                                                                    .. attribute:: out_ifname
                                                                    
                                                                    	output interface name
                                                                    	**type**\: str
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf, self).__init__()

                                                                        self.yang_name = "out-intf"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('out_ifname', (YLeaf(YType.str, 'out-ifname'), ['str'])),
                                                                        ])
                                                                        self.out_ifname = None
                                                                        self._segment_path = lambda: "out-intf"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf, ['out_ifname'], name, value)


                                                                class ServFunc(Entity):
                                                                    """
                                                                    serv func
                                                                    
                                                                    .. attribute:: path_id
                                                                    
                                                                    	service path id
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: service_index
                                                                    
                                                                    	service path index
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    .. attribute:: meta_name
                                                                    
                                                                    	metadata name
                                                                    	**type**\: str
                                                                    
                                                                    .. attribute:: vs_index
                                                                    
                                                                    	vservice index
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc, self).__init__()

                                                                        self.yang_name = "serv-func"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('path_id', (YLeaf(YType.uint32, 'path-id'), ['int'])),
                                                                            ('service_index', (YLeaf(YType.uint8, 'service-index'), ['int'])),
                                                                            ('meta_name', (YLeaf(YType.str, 'meta-name'), ['str'])),
                                                                            ('vs_index', (YLeaf(YType.uint32, 'vs-index'), ['int'])),
                                                                        ])
                                                                        self.path_id = None
                                                                        self.service_index = None
                                                                        self.meta_name = None
                                                                        self.vs_index = None
                                                                        self._segment_path = lambda: "serv-func"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc, ['path_id', 'service_index', 'meta_name', 'vs_index'], name, value)


                                                                class Police(Entity):
                                                                    """
                                                                    police
                                                                    
                                                                    .. attribute:: rate
                                                                    
                                                                    	rate
                                                                    	**type**\:  :py:class:`Rate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate>`
                                                                    
                                                                    .. attribute:: burst
                                                                    
                                                                    	burst
                                                                    	**type**\:  :py:class:`Burst <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst>`
                                                                    
                                                                    .. attribute:: peak_rate
                                                                    
                                                                    	peak rate
                                                                    	**type**\:  :py:class:`PeakRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate>`
                                                                    
                                                                    .. attribute:: peak_burst
                                                                    
                                                                    	peak burst
                                                                    	**type**\:  :py:class:`PeakBurst <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst>`
                                                                    
                                                                    .. attribute:: cdvt
                                                                    
                                                                    	cdvt
                                                                    	**type**\:  :py:class:`Cdvt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt>`
                                                                    
                                                                    .. attribute:: conform_actns
                                                                    
                                                                    	conform actns
                                                                    	**type**\:  :py:class:`ConformActns <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns>`
                                                                    
                                                                    .. attribute:: exceed_actns
                                                                    
                                                                    	exceed actns
                                                                    	**type**\:  :py:class:`ExceedActns <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns>`
                                                                    
                                                                    .. attribute:: violate_actns
                                                                    
                                                                    	violate actns
                                                                    	**type**\:  :py:class:`ViolateActns <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns>`
                                                                    
                                                                    .. attribute:: confclass_encode
                                                                    
                                                                    	confclass encode
                                                                    	**type**\:  :py:class:`ConfclassEncode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode>`
                                                                    
                                                                    .. attribute:: confclass_p
                                                                    
                                                                    	confclass p
                                                                    	**type**\:  :py:class:`ConfclassP <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP>`
                                                                    
                                                                    .. attribute:: excdclass_encode
                                                                    
                                                                    	excdclass encode
                                                                    	**type**\:  :py:class:`ExcdclassEncode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode>`
                                                                    
                                                                    .. attribute:: excdclass_p
                                                                    
                                                                    	excdclass p
                                                                    	**type**\:  :py:class:`ExcdclassP <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP>`
                                                                    
                                                                    .. attribute:: flags
                                                                    
                                                                    	flags
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: police_flags
                                                                    
                                                                    	police flags
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: sbuck_name
                                                                    
                                                                    	sbuck name
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..65
                                                                    
                                                                    .. attribute:: sbuck_type
                                                                    
                                                                    	sbuck type
                                                                    	**type**\:  :py:class:`SharedBucketType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.SharedBucketType>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police, self).__init__()

                                                                        self.yang_name = "police"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("rate", ("rate", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate)), ("burst", ("burst", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst)), ("peak-rate", ("peak_rate", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate)), ("peak-burst", ("peak_burst", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst)), ("cdvt", ("cdvt", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt)), ("conform-actns", ("conform_actns", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns)), ("exceed-actns", ("exceed_actns", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns)), ("violate-actns", ("violate_actns", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns)), ("confclass-encode", ("confclass_encode", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode)), ("confclass-p", ("confclass_p", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP)), ("excdclass-encode", ("excdclass_encode", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode)), ("excdclass-p", ("excdclass_p", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP))])
                                                                        self._leafs = OrderedDict([
                                                                            ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                            ('police_flags', (YLeaf(YType.uint32, 'police-flags'), ['int'])),
                                                                            ('sbuck_name', (YLeaf(YType.str, 'sbuck-name'), ['str'])),
                                                                            ('sbuck_type', (YLeaf(YType.enumeration, 'sbuck-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'SharedBucketType', '')])),
                                                                        ])
                                                                        self.flags = None
                                                                        self.police_flags = None
                                                                        self.sbuck_name = None
                                                                        self.sbuck_type = None

                                                                        self.rate = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate()
                                                                        self.rate.parent = self
                                                                        self._children_name_map["rate"] = "rate"

                                                                        self.burst = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst()
                                                                        self.burst.parent = self
                                                                        self._children_name_map["burst"] = "burst"

                                                                        self.peak_rate = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate()
                                                                        self.peak_rate.parent = self
                                                                        self._children_name_map["peak_rate"] = "peak-rate"

                                                                        self.peak_burst = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst()
                                                                        self.peak_burst.parent = self
                                                                        self._children_name_map["peak_burst"] = "peak-burst"

                                                                        self.cdvt = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt()
                                                                        self.cdvt.parent = self
                                                                        self._children_name_map["cdvt"] = "cdvt"

                                                                        self.conform_actns = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns()
                                                                        self.conform_actns.parent = self
                                                                        self._children_name_map["conform_actns"] = "conform-actns"

                                                                        self.exceed_actns = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns()
                                                                        self.exceed_actns.parent = self
                                                                        self._children_name_map["exceed_actns"] = "exceed-actns"

                                                                        self.violate_actns = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns()
                                                                        self.violate_actns.parent = self
                                                                        self._children_name_map["violate_actns"] = "violate-actns"

                                                                        self.confclass_encode = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode()
                                                                        self.confclass_encode.parent = self
                                                                        self._children_name_map["confclass_encode"] = "confclass-encode"

                                                                        self.confclass_p = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP()
                                                                        self.confclass_p.parent = self
                                                                        self._children_name_map["confclass_p"] = "confclass-p"

                                                                        self.excdclass_encode = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode()
                                                                        self.excdclass_encode.parent = self
                                                                        self._children_name_map["excdclass_encode"] = "excdclass-encode"

                                                                        self.excdclass_p = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP()
                                                                        self.excdclass_p.parent = self
                                                                        self._children_name_map["excdclass_p"] = "excdclass-p"
                                                                        self._segment_path = lambda: "police"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police, ['flags', 'police_flags', 'sbuck_name', 'sbuck_type'], name, value)


                                                                    class Rate(Entity):
                                                                        """
                                                                        rate
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate, self).__init__()

                                                                            self.yang_name = "rate"
                                                                            self.yang_parent_name = "police"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                            ])
                                                                            self.value = None
                                                                            self.unit = None
                                                                            self._segment_path = lambda: "rate"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate, ['value', 'unit'], name, value)


                                                                    class Burst(Entity):
                                                                        """
                                                                        burst
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst, self).__init__()

                                                                            self.yang_name = "burst"
                                                                            self.yang_parent_name = "police"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                            ])
                                                                            self.value = None
                                                                            self.unit = None
                                                                            self._segment_path = lambda: "burst"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst, ['value', 'unit'], name, value)


                                                                    class PeakRate(Entity):
                                                                        """
                                                                        peak rate
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate, self).__init__()

                                                                            self.yang_name = "peak-rate"
                                                                            self.yang_parent_name = "police"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                            ])
                                                                            self.value = None
                                                                            self.unit = None
                                                                            self._segment_path = lambda: "peak-rate"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate, ['value', 'unit'], name, value)


                                                                    class PeakBurst(Entity):
                                                                        """
                                                                        peak burst
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst, self).__init__()

                                                                            self.yang_name = "peak-burst"
                                                                            self.yang_parent_name = "police"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                            ])
                                                                            self.value = None
                                                                            self.unit = None
                                                                            self._segment_path = lambda: "peak-burst"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst, ['value', 'unit'], name, value)


                                                                    class Cdvt(Entity):
                                                                        """
                                                                        cdvt
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt, self).__init__()

                                                                            self.yang_name = "cdvt"
                                                                            self.yang_parent_name = "police"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                            ])
                                                                            self.value = None
                                                                            self.unit = None
                                                                            self._segment_path = lambda: "cdvt"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt, ['value', 'unit'], name, value)


                                                                    class ConformActns(Entity):
                                                                        """
                                                                        conform actns
                                                                        
                                                                        .. attribute:: police_action_array
                                                                        
                                                                        	police action array
                                                                        	**type**\: list of  		 :py:class:`PoliceActionArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns, self).__init__()

                                                                            self.yang_name = "conform-actns"
                                                                            self.yang_parent_name = "police"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("police-action-array", ("police_action_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.police_action_array = YList(self)
                                                                            self._segment_path = lambda: "conform-actns"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns, [], name, value)


                                                                        class PoliceActionArray(Entity):
                                                                            """
                                                                            police action array
                                                                            
                                                                            .. attribute:: mark
                                                                            
                                                                            	mark
                                                                            	**type**\:  :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark>`
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:  :py:class:`PoliceActionTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PoliceActionTypeEn>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray, self).__init__()

                                                                                self.yang_name = "police-action-array"
                                                                                self.yang_parent_name = "conform-actns"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("mark", ("mark", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PoliceActionTypeEn', '')])),
                                                                                ])
                                                                                self.type = None

                                                                                self.mark = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark()
                                                                                self.mark.parent = self
                                                                                self._children_name_map["mark"] = "mark"
                                                                                self._segment_path = lambda: "police-action-array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray, ['type'], name, value)


                                                                            class Mark(Entity):
                                                                                """
                                                                                mark
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:  :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                                
                                                                                .. attribute:: mark_flags
                                                                                
                                                                                	mark flags
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark, self).__init__()

                                                                                    self.yang_name = "mark"
                                                                                    self.yang_parent_name = "police-action-array"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MarkTypeEn', '')])),
                                                                                        ('mark_flags', (YLeaf(YType.uint32, 'mark-flags'), ['int'])),
                                                                                        ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                    ])
                                                                                    self.type = None
                                                                                    self.mark_flags = None
                                                                                    self.value = None
                                                                                    self._segment_path = lambda: "mark"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark, ['type', 'mark_flags', 'value'], name, value)


                                                                    class ExceedActns(Entity):
                                                                        """
                                                                        exceed actns
                                                                        
                                                                        .. attribute:: police_action_array
                                                                        
                                                                        	police action array
                                                                        	**type**\: list of  		 :py:class:`PoliceActionArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns, self).__init__()

                                                                            self.yang_name = "exceed-actns"
                                                                            self.yang_parent_name = "police"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("police-action-array", ("police_action_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.police_action_array = YList(self)
                                                                            self._segment_path = lambda: "exceed-actns"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns, [], name, value)


                                                                        class PoliceActionArray(Entity):
                                                                            """
                                                                            police action array
                                                                            
                                                                            .. attribute:: mark
                                                                            
                                                                            	mark
                                                                            	**type**\:  :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark>`
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:  :py:class:`PoliceActionTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PoliceActionTypeEn>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray, self).__init__()

                                                                                self.yang_name = "police-action-array"
                                                                                self.yang_parent_name = "exceed-actns"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("mark", ("mark", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PoliceActionTypeEn', '')])),
                                                                                ])
                                                                                self.type = None

                                                                                self.mark = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark()
                                                                                self.mark.parent = self
                                                                                self._children_name_map["mark"] = "mark"
                                                                                self._segment_path = lambda: "police-action-array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray, ['type'], name, value)


                                                                            class Mark(Entity):
                                                                                """
                                                                                mark
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:  :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                                
                                                                                .. attribute:: mark_flags
                                                                                
                                                                                	mark flags
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark, self).__init__()

                                                                                    self.yang_name = "mark"
                                                                                    self.yang_parent_name = "police-action-array"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MarkTypeEn', '')])),
                                                                                        ('mark_flags', (YLeaf(YType.uint32, 'mark-flags'), ['int'])),
                                                                                        ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                    ])
                                                                                    self.type = None
                                                                                    self.mark_flags = None
                                                                                    self.value = None
                                                                                    self._segment_path = lambda: "mark"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark, ['type', 'mark_flags', 'value'], name, value)


                                                                    class ViolateActns(Entity):
                                                                        """
                                                                        violate actns
                                                                        
                                                                        .. attribute:: police_action_array
                                                                        
                                                                        	police action array
                                                                        	**type**\: list of  		 :py:class:`PoliceActionArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns, self).__init__()

                                                                            self.yang_name = "violate-actns"
                                                                            self.yang_parent_name = "police"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("police-action-array", ("police_action_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.police_action_array = YList(self)
                                                                            self._segment_path = lambda: "violate-actns"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns, [], name, value)


                                                                        class PoliceActionArray(Entity):
                                                                            """
                                                                            police action array
                                                                            
                                                                            .. attribute:: mark
                                                                            
                                                                            	mark
                                                                            	**type**\:  :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark>`
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:  :py:class:`PoliceActionTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PoliceActionTypeEn>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray, self).__init__()

                                                                                self.yang_name = "police-action-array"
                                                                                self.yang_parent_name = "violate-actns"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("mark", ("mark", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PoliceActionTypeEn', '')])),
                                                                                ])
                                                                                self.type = None

                                                                                self.mark = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark()
                                                                                self.mark.parent = self
                                                                                self._children_name_map["mark"] = "mark"
                                                                                self._segment_path = lambda: "police-action-array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray, ['type'], name, value)


                                                                            class Mark(Entity):
                                                                                """
                                                                                mark
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:  :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                                
                                                                                .. attribute:: mark_flags
                                                                                
                                                                                	mark flags
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark, self).__init__()

                                                                                    self.yang_name = "mark"
                                                                                    self.yang_parent_name = "police-action-array"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MarkTypeEn', '')])),
                                                                                        ('mark_flags', (YLeaf(YType.uint32, 'mark-flags'), ['int'])),
                                                                                        ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                    ])
                                                                                    self.type = None
                                                                                    self.mark_flags = None
                                                                                    self.value = None
                                                                                    self._segment_path = lambda: "mark"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark, ['type', 'mark_flags', 'value'], name, value)


                                                                    class ConfclassEncode(Entity):
                                                                        """
                                                                        confclass encode
                                                                        
                                                                        .. attribute:: inline_cmap
                                                                        
                                                                        	inline cmap
                                                                        	**type**\:  :py:class:`InlineCmap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap>`
                                                                        
                                                                        .. attribute:: enc
                                                                        
                                                                        	enc
                                                                        	**type**\:  :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                        
                                                                        .. attribute:: class_name
                                                                        
                                                                        	class name
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..65
                                                                        
                                                                        .. attribute:: hd
                                                                        
                                                                        	hd
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: idx
                                                                        
                                                                        	idx
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode, self).__init__()

                                                                            self.yang_name = "confclass-encode"
                                                                            self.yang_parent_name = "police"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("inline-cmap", ("inline_cmap", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap))])
                                                                            self._leafs = OrderedDict([
                                                                                ('enc', (YLeaf(YType.enumeration, 'enc'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyObjEncEn', '')])),
                                                                                ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                                                ('hd', (YLeaf(YType.uint64, 'hd'), ['int'])),
                                                                                ('idx', (YLeaf(YType.uint8, 'idx'), ['int'])),
                                                                            ])
                                                                            self.enc = None
                                                                            self.class_name = None
                                                                            self.hd = None
                                                                            self.idx = None

                                                                            self.inline_cmap = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap()
                                                                            self.inline_cmap.parent = self
                                                                            self._children_name_map["inline_cmap"] = "inline-cmap"
                                                                            self._segment_path = lambda: "confclass-encode"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode, ['enc', 'class_name', 'hd', 'idx'], name, value)


                                                                        class InlineCmap(Entity):
                                                                            """
                                                                            inline cmap
                                                                            
                                                                            .. attribute:: match_infop
                                                                            
                                                                            	Pointer to the first Match info
                                                                            	**type**\:  :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop>`
                                                                            
                                                                            .. attribute:: mode
                                                                            
                                                                            	Inline Class\-Map Mode Match any/all
                                                                            	**type**\:  :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                            
                                                                            .. attribute:: flags
                                                                            
                                                                            	Inline Class\-Map flags
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: match_count
                                                                            
                                                                            	Number of Match infos
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap, self).__init__()

                                                                                self.yang_name = "inline-cmap"
                                                                                self.yang_parent_name = "confclass-encode"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("match-infop", ("match_infop", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapModeEn', '')])),
                                                                                    ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                    ('match_count', (YLeaf(YType.uint32, 'match-count'), ['int'])),
                                                                                ])
                                                                                self.mode = None
                                                                                self.flags = None
                                                                                self.match_count = None

                                                                                self.match_infop = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop()
                                                                                self.match_infop.parent = self
                                                                                self._children_name_map["match_infop"] = "match-infop"
                                                                                self._segment_path = lambda: "inline-cmap"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap, ['mode', 'flags', 'match_count'], name, value)


                                                                            class MatchInfop(Entity):
                                                                                """
                                                                                Pointer to the first Match info
                                                                                
                                                                                .. attribute:: class_match_info_st
                                                                                
                                                                                	class match info st
                                                                                	**type**\: list of  		 :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop, self).__init__()

                                                                                    self.yang_name = "match-infop"
                                                                                    self.yang_parent_name = "inline-cmap"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("class-match-info-st", ("class_match_info_st", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.class_match_info_st = YList(self)
                                                                                    self._segment_path = lambda: "match-infop"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop, [], name, value)


                                                                                class ClassMatchInfoSt(Entity):
                                                                                    """
                                                                                    class match info st
                                                                                    
                                                                                    .. attribute:: match_data
                                                                                    
                                                                                    	Match criteria
                                                                                    	**type**\:  :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                    
                                                                                    .. attribute:: flags
                                                                                    
                                                                                    	Flags
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                        self.yang_name = "class-match-info-st"
                                                                                        self.yang_parent_name = "match-infop"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("match-data", ("match_data", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData))])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                        ])
                                                                                        self.flags = None

                                                                                        self.match_data = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                        self.match_data.parent = self
                                                                                        self._children_name_map["match_data"] = "match-data"
                                                                                        self._segment_path = lambda: "class-match-info-st"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                    class MatchData(Entity):
                                                                                        """
                                                                                        Match criteria
                                                                                        
                                                                                        .. attribute:: ipv4_dscp
                                                                                        
                                                                                        	IPv4 DSCP
                                                                                        	**type**\:  :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                        
                                                                                        .. attribute:: ipv6_dscp
                                                                                        
                                                                                        	IPv6 DSCP
                                                                                        	**type**\:  :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                        
                                                                                        .. attribute:: dscp
                                                                                        
                                                                                        	Match DSCP range array
                                                                                        	**type**\:  :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                        
                                                                                        .. attribute:: ipv4_prec
                                                                                        
                                                                                        	IPv4 Precedence
                                                                                        	**type**\:  :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                        
                                                                                        .. attribute:: ipv6_prec
                                                                                        
                                                                                        	IPv6 Precedence
                                                                                        	**type**\:  :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                        
                                                                                        .. attribute:: prec
                                                                                        
                                                                                        	Match Precedence array
                                                                                        	**type**\:  :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                        
                                                                                        .. attribute:: discard_class
                                                                                        
                                                                                        	Match Discard Class array
                                                                                        	**type**\:  :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                        
                                                                                        .. attribute:: qos_group
                                                                                        
                                                                                        	Match QoS group array
                                                                                        	**type**\:  :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                        
                                                                                        .. attribute:: traffic_class
                                                                                        
                                                                                        	Match Traffic class array
                                                                                        	**type**\:  :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                        
                                                                                        .. attribute:: proto
                                                                                        
                                                                                        	Match Protocol array
                                                                                        	**type**\:  :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                        
                                                                                        .. attribute:: icmp_v4
                                                                                        
                                                                                        	Match ICMPV4 Protocol
                                                                                        	**type**\:  :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                        
                                                                                        .. attribute:: icmp_v6
                                                                                        
                                                                                        	Match ICMPV6 Protocol array
                                                                                        	**type**\:  :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                        
                                                                                        .. attribute:: ipv4_packet_len
                                                                                        
                                                                                        	IPv4 packet length array
                                                                                        	**type**\:  :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                        
                                                                                        .. attribute:: ipv6_packet_len
                                                                                        
                                                                                        	IPv6 packet length array
                                                                                        	**type**\:  :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                        
                                                                                        .. attribute:: packet_len
                                                                                        
                                                                                        	Match packet length array
                                                                                        	**type**\:  :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                        
                                                                                        .. attribute:: flow_tag
                                                                                        
                                                                                        	Match flow\-tag array
                                                                                        	**type**\:  :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                        
                                                                                        .. attribute:: tcp_flag
                                                                                        
                                                                                        	Match tcp flag value
                                                                                        	**type**\:  :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                        
                                                                                        .. attribute:: icmpv4_type
                                                                                        
                                                                                        	Match ipv4 icmp type
                                                                                        	**type**\:  :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                        
                                                                                        .. attribute:: icmpv4_code
                                                                                        
                                                                                        	Match ipv4 icmp code
                                                                                        	**type**\:  :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                        
                                                                                        .. attribute:: icmpv6_type
                                                                                        
                                                                                        	Match ipv6 icmp type
                                                                                        	**type**\:  :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                        
                                                                                        .. attribute:: icmpv6_code
                                                                                        
                                                                                        	Match ipv6 icmp code
                                                                                        	**type**\:  :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                        
                                                                                        .. attribute:: mpls_exp
                                                                                        
                                                                                        	Match MPLS experimental topmost array
                                                                                        	**type**\:  :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                        
                                                                                        .. attribute:: mpls_exp_imp
                                                                                        
                                                                                        	Match MPLS experimental imposition array
                                                                                        	**type**\:  :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                        
                                                                                        .. attribute:: mpls_disp_ipv4_acl
                                                                                        
                                                                                        	MPLS Disposition IPv4 Access\-list
                                                                                        	**type**\:  :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                        
                                                                                        .. attribute:: mpls_disp_ipv6_acl
                                                                                        
                                                                                        	MPLS Disposition IPv6 Access\-list
                                                                                        	**type**\:  :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                        
                                                                                        .. attribute:: mpls_top_label
                                                                                        
                                                                                        	MPLS Topmost LABEL
                                                                                        	**type**\:  :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                        
                                                                                        .. attribute:: cos
                                                                                        
                                                                                        	Match CoS array
                                                                                        	**type**\:  :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                        
                                                                                        .. attribute:: cos_inr
                                                                                        
                                                                                        	Match inner header CoS
                                                                                        	**type**\:  :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                        
                                                                                        .. attribute:: dei
                                                                                        
                                                                                        	Match DEI Bit
                                                                                        	**type**\:  :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                        
                                                                                        .. attribute:: dei_inr
                                                                                        
                                                                                        	Match inner DEI Bit
                                                                                        	**type**\:  :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                        
                                                                                        .. attribute:: vlan
                                                                                        
                                                                                        	Match VLAN array
                                                                                        	**type**\:  :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                        
                                                                                        .. attribute:: vlan_inr
                                                                                        
                                                                                        	Match inner header VLAN range array
                                                                                        	**type**\:  :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                        
                                                                                        .. attribute:: fr_dlci
                                                                                        
                                                                                        	Match FR DLCI range array
                                                                                        	**type**\:  :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                        
                                                                                        .. attribute:: src_mac
                                                                                        
                                                                                        	Match Source MAC address
                                                                                        	**type**\:  :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                        
                                                                                        .. attribute:: dst_mac
                                                                                        
                                                                                        	Match Destination MAC address
                                                                                        	**type**\:  :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                        
                                                                                        .. attribute:: atm_clp
                                                                                        
                                                                                        	Match ATM CLP level
                                                                                        	**type**\:  :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                        
                                                                                        .. attribute:: fr_de
                                                                                        
                                                                                        	Match FR DE value
                                                                                        	**type**\:  :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                        
                                                                                        .. attribute:: ipv4_acl
                                                                                        
                                                                                        	IPv4 Access\-list
                                                                                        	**type**\:  :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                        
                                                                                        .. attribute:: ipv6_acl
                                                                                        
                                                                                        	IPv6 Access\-list
                                                                                        	**type**\:  :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                        
                                                                                        .. attribute:: ether_service_acl
                                                                                        
                                                                                        	Ethernet\-Services Access\-list
                                                                                        	**type**\:  :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                        
                                                                                        .. attribute:: avail_id
                                                                                        
                                                                                        	Available Identifiers
                                                                                        	**type**\:  :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                        
                                                                                        .. attribute:: media_type
                                                                                        
                                                                                        	Media Type
                                                                                        	**type**\:  :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                        
                                                                                        .. attribute:: subs_protocol
                                                                                        
                                                                                        	Protocol
                                                                                        	**type**\:  :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                        
                                                                                        .. attribute:: dnis
                                                                                        
                                                                                        	DNIS
                                                                                        	**type**\:  :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                        
                                                                                        .. attribute:: dnis_regex
                                                                                        
                                                                                        	DNIS Regular Expression
                                                                                        	**type**\:  :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                        
                                                                                        .. attribute:: domain
                                                                                        
                                                                                        	Domain Name
                                                                                        	**type**\:  :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                        
                                                                                        .. attribute:: domain_regex
                                                                                        
                                                                                        	Domain Regular Expression
                                                                                        	**type**\:  :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                        
                                                                                        .. attribute:: nas_port
                                                                                        
                                                                                        	NAS Port
                                                                                        	**type**\:  :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                        
                                                                                        .. attribute:: service_name
                                                                                        
                                                                                        	Service Name
                                                                                        	**type**\:  :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                        
                                                                                        .. attribute:: service_name_regex
                                                                                        
                                                                                        	Service Name Regular Exp
                                                                                        	**type**\:  :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                        
                                                                                        .. attribute:: src_addr_ipv4
                                                                                        
                                                                                        	Source Address IPV4
                                                                                        	**type**\:  :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                        
                                                                                        .. attribute:: dst_addr_ipv4
                                                                                        
                                                                                        	Destination Address IPV4
                                                                                        	**type**\:  :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                        
                                                                                        .. attribute:: src_addr_ipv6
                                                                                        
                                                                                        	Source Address IPV6
                                                                                        	**type**\:  :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                        
                                                                                        .. attribute:: dst_addr_ipv6
                                                                                        
                                                                                        	Destination Address IPV6
                                                                                        	**type**\:  :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                        
                                                                                        .. attribute:: src_addr_mac
                                                                                        
                                                                                        	Source Address MAC
                                                                                        	**type**\:  :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                        
                                                                                        .. attribute:: timer
                                                                                        
                                                                                        	Timer
                                                                                        	**type**\:  :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                        
                                                                                        .. attribute:: timer_regexp
                                                                                        
                                                                                        	Timer Regular Expression
                                                                                        	**type**\:  :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                        
                                                                                        .. attribute:: tunnel_name
                                                                                        
                                                                                        	Tunnel Name
                                                                                        	**type**\:  :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                        
                                                                                        .. attribute:: tunnel_name_regex
                                                                                        
                                                                                        	Tunnel Name Regular Expression
                                                                                        	**type**\:  :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                        
                                                                                        .. attribute:: user_name
                                                                                        
                                                                                        	User Name
                                                                                        	**type**\:  :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                        
                                                                                        .. attribute:: user_name_regex
                                                                                        
                                                                                        	User Name Regular Expression
                                                                                        	**type**\:  :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                        
                                                                                        .. attribute:: auth_username
                                                                                        
                                                                                        	Authenticated User Name
                                                                                        	**type**\:  :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                        
                                                                                        .. attribute:: auth_username_regex
                                                                                        
                                                                                        	Authenticated User Name RegEx
                                                                                        	**type**\:  :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                        
                                                                                        .. attribute:: unauth_username
                                                                                        
                                                                                        	Unauthenticated User Name
                                                                                        	**type**\:  :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                        
                                                                                        .. attribute:: unauth_username_regex
                                                                                        
                                                                                        	Unauthenticated User Name RegEx
                                                                                        	**type**\:  :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                        
                                                                                        .. attribute:: auth_domain
                                                                                        
                                                                                        	Authenticated domain name
                                                                                        	**type**\:  :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                        
                                                                                        .. attribute:: auth_domain_regex
                                                                                        
                                                                                        	Authenticated Domain Name RegEx
                                                                                        	**type**\:  :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                        
                                                                                        .. attribute:: unauth_domain
                                                                                        
                                                                                        	Unauthenticated Domain Name
                                                                                        	**type**\:  :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                        
                                                                                        .. attribute:: unauth_domain_regex
                                                                                        
                                                                                        	Unauthenticated Domain Name RegEx
                                                                                        	**type**\:  :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                        
                                                                                        .. attribute:: vendor_id
                                                                                        
                                                                                        	Vendor ID
                                                                                        	**type**\:  :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                        
                                                                                        .. attribute:: vendor_id_regex
                                                                                        
                                                                                        	Vendor ID RegEx
                                                                                        	**type**\:  :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                        
                                                                                        .. attribute:: access_interface
                                                                                        
                                                                                        	Access interface
                                                                                        	**type**\:  :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                        
                                                                                        .. attribute:: input_interface
                                                                                        
                                                                                        	Input interface
                                                                                        	**type**\:  :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                        
                                                                                        .. attribute:: input_intfhdl
                                                                                        
                                                                                        	Input interface handle
                                                                                        	**type**\:  :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                        
                                                                                        .. attribute:: ethertype
                                                                                        
                                                                                        	Ethernet type
                                                                                        	**type**\:  :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                        
                                                                                        .. attribute:: flow_key_data
                                                                                        
                                                                                        	Flow key structure
                                                                                        	**type**\:  :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                        
                                                                                        .. attribute:: dhcp_client_id
                                                                                        
                                                                                        	Dhcp Client ID
                                                                                        	**type**\:  :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                        
                                                                                        .. attribute:: dhcp_client_id_regex
                                                                                        
                                                                                        	Dhcp Client ID RegEx
                                                                                        	**type**\:  :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                        
                                                                                        .. attribute:: circuit_id
                                                                                        
                                                                                        	Circuit ID
                                                                                        	**type**\:  :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                        
                                                                                        .. attribute:: circuit_id_regex
                                                                                        
                                                                                        	Circuit ID RegEx
                                                                                        	**type**\:  :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                        
                                                                                        .. attribute:: remote_id
                                                                                        
                                                                                        	Remote ID
                                                                                        	**type**\:  :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                        
                                                                                        .. attribute:: remote_id_regex
                                                                                        
                                                                                        	Remote ID RegEx
                                                                                        	**type**\:  :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                        
                                                                                        .. attribute:: src_port
                                                                                        
                                                                                        	Source port
                                                                                        	**type**\:  :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                        
                                                                                        .. attribute:: dst_port
                                                                                        
                                                                                        	Destination port
                                                                                        	**type**\:  :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                        
                                                                                        .. attribute:: type
                                                                                        
                                                                                        	type
                                                                                        	**type**\:  :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                        
                                                                                        .. attribute:: mpls_top_eos
                                                                                        
                                                                                        	MPLS Topmost EOS
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: fragment_type
                                                                                        
                                                                                        	Fragment type
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: authen_status
                                                                                        
                                                                                        	Authentication Status
                                                                                        	**type**\:  :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                        
                                                                                        .. attribute:: mlp_negotiated
                                                                                        
                                                                                        	MLP Negotiated
                                                                                        	**type**\:  :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                            self.yang_name = "match-data"
                                                                                            self.yang_parent_name = "class-match-info-st"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("ipv4-dscp", ("ipv4_dscp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp)), ("ipv6-dscp", ("ipv6_dscp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp)), ("dscp", ("dscp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp)), ("ipv4-prec", ("ipv4_prec", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec)), ("ipv6-prec", ("ipv6_prec", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec)), ("prec", ("prec", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec)), ("discard-class", ("discard_class", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass)), ("qos-group", ("qos_group", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup)), ("traffic-class", ("traffic_class", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass)), ("proto", ("proto", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto)), ("icmp-v4", ("icmp_v4", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4)), ("icmp-v6", ("icmp_v6", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6)), ("ipv4-packet-len", ("ipv4_packet_len", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen)), ("ipv6-packet-len", ("ipv6_packet_len", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen)), ("packet-len", ("packet_len", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen)), ("flow-tag", ("flow_tag", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag)), ("tcp-flag", ("tcp_flag", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag)), ("icmpv4-type", ("icmpv4_type", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type)), ("icmpv4-code", ("icmpv4_code", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code)), ("icmpv6-type", ("icmpv6_type", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type)), ("icmpv6-code", ("icmpv6_code", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code)), ("mpls-exp", ("mpls_exp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp)), ("mpls-exp-imp", ("mpls_exp_imp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp)), ("mpls-disp-ipv4-acl", ("mpls_disp_ipv4_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl)), ("mpls-disp-ipv6-acl", ("mpls_disp_ipv6_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl)), ("mpls-top-label", ("mpls_top_label", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel)), ("cos", ("cos", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos)), ("cos-inr", ("cos_inr", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr)), ("dei", ("dei", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei)), ("dei-inr", ("dei_inr", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr)), ("vlan", ("vlan", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan)), ("vlan-inr", ("vlan_inr", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)), ("fr-dlci", ("fr_dlci", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci)), ("src-mac", ("src_mac", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac)), ("dst-mac", ("dst_mac", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac)), ("atm-clp", ("atm_clp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp)), ("fr-de", ("fr_de", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe)), ("ipv4-acl", ("ipv4_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl)), ("ipv6-acl", ("ipv6_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl)), ("ether-service-acl", ("ether_service_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl)), ("avail-id", ("avail_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId)), ("media-type", ("media_type", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType)), ("subs-protocol", ("subs_protocol", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol)), ("dnis", ("dnis", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis)), ("dnis-regex", ("dnis_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex)), ("domain", ("domain", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain)), ("domain-regex", ("domain_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex)), ("nas-port", ("nas_port", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort)), ("service-name", ("service_name", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName)), ("service-name-regex", ("service_name_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex)), ("src-addr-ipv4", ("src_addr_ipv4", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4)), ("dst-addr-ipv4", ("dst_addr_ipv4", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4)), ("src-addr-ipv6", ("src_addr_ipv6", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6)), ("dst-addr-ipv6", ("dst_addr_ipv6", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6)), ("src-addr-mac", ("src_addr_mac", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac)), ("timer", ("timer", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer)), ("timer-regexp", ("timer_regexp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp)), ("tunnel-name", ("tunnel_name", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName)), ("tunnel-name-regex", ("tunnel_name_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex)), ("user-name", ("user_name", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName)), ("user-name-regex", ("user_name_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex)), ("auth-username", ("auth_username", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername)), ("auth-username-regex", ("auth_username_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex)), ("unauth-username", ("unauth_username", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername)), ("unauth-username-regex", ("unauth_username_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex)), ("auth-domain", ("auth_domain", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain)), ("auth-domain-regex", ("auth_domain_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex)), ("unauth-domain", ("unauth_domain", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain)), ("unauth-domain-regex", ("unauth_domain_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex)), ("vendor-id", ("vendor_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId)), ("vendor-id-regex", ("vendor_id_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex)), ("access-interface", ("access_interface", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface)), ("input-interface", ("input_interface", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface)), ("input-intfhdl", ("input_intfhdl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl)), ("ethertype", ("ethertype", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype)), ("flow-key-data", ("flow_key_data", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData)), ("dhcp-client-id", ("dhcp_client_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId)), ("dhcp-client-id-regex", ("dhcp_client_id_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex)), ("circuit-id", ("circuit_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId)), ("circuit-id-regex", ("circuit_id_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex)), ("remote-id", ("remote_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId)), ("remote-id-regex", ("remote_id_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex)), ("src-port", ("src_port", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort)), ("dst-port", ("dst_port", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort))])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchTypeEn', '')])),
                                                                                                ('mpls_top_eos', (YLeaf(YType.uint8, 'mpls-top-eos'), ['int'])),
                                                                                                ('fragment_type', (YLeaf(YType.uint8, 'fragment-type'), ['int'])),
                                                                                                ('authen_status', (YLeaf(YType.enumeration, 'authen-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchAuthenStatusEn', '')])),
                                                                                                ('mlp_negotiated', (YLeaf(YType.enumeration, 'mlp-negotiated'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchMlpNegotiatedEn', '')])),
                                                                                            ])
                                                                                            self.type = None
                                                                                            self.mpls_top_eos = None
                                                                                            self.fragment_type = None
                                                                                            self.authen_status = None
                                                                                            self.mlp_negotiated = None

                                                                                            self.ipv4_dscp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                            self.ipv4_dscp.parent = self
                                                                                            self._children_name_map["ipv4_dscp"] = "ipv4-dscp"

                                                                                            self.ipv6_dscp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                            self.ipv6_dscp.parent = self
                                                                                            self._children_name_map["ipv6_dscp"] = "ipv6-dscp"

                                                                                            self.dscp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                            self.dscp.parent = self
                                                                                            self._children_name_map["dscp"] = "dscp"

                                                                                            self.ipv4_prec = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                            self.ipv4_prec.parent = self
                                                                                            self._children_name_map["ipv4_prec"] = "ipv4-prec"

                                                                                            self.ipv6_prec = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                            self.ipv6_prec.parent = self
                                                                                            self._children_name_map["ipv6_prec"] = "ipv6-prec"

                                                                                            self.prec = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                            self.prec.parent = self
                                                                                            self._children_name_map["prec"] = "prec"

                                                                                            self.discard_class = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                            self.discard_class.parent = self
                                                                                            self._children_name_map["discard_class"] = "discard-class"

                                                                                            self.qos_group = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                            self.qos_group.parent = self
                                                                                            self._children_name_map["qos_group"] = "qos-group"

                                                                                            self.traffic_class = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                            self.traffic_class.parent = self
                                                                                            self._children_name_map["traffic_class"] = "traffic-class"

                                                                                            self.proto = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                            self.proto.parent = self
                                                                                            self._children_name_map["proto"] = "proto"

                                                                                            self.icmp_v4 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                            self.icmp_v4.parent = self
                                                                                            self._children_name_map["icmp_v4"] = "icmp-v4"

                                                                                            self.icmp_v6 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                            self.icmp_v6.parent = self
                                                                                            self._children_name_map["icmp_v6"] = "icmp-v6"

                                                                                            self.ipv4_packet_len = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                            self.ipv4_packet_len.parent = self
                                                                                            self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"

                                                                                            self.ipv6_packet_len = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                            self.ipv6_packet_len.parent = self
                                                                                            self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"

                                                                                            self.packet_len = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                            self.packet_len.parent = self
                                                                                            self._children_name_map["packet_len"] = "packet-len"

                                                                                            self.flow_tag = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                            self.flow_tag.parent = self
                                                                                            self._children_name_map["flow_tag"] = "flow-tag"

                                                                                            self.tcp_flag = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                            self.tcp_flag.parent = self
                                                                                            self._children_name_map["tcp_flag"] = "tcp-flag"

                                                                                            self.icmpv4_type = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                            self.icmpv4_type.parent = self
                                                                                            self._children_name_map["icmpv4_type"] = "icmpv4-type"

                                                                                            self.icmpv4_code = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                            self.icmpv4_code.parent = self
                                                                                            self._children_name_map["icmpv4_code"] = "icmpv4-code"

                                                                                            self.icmpv6_type = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                            self.icmpv6_type.parent = self
                                                                                            self._children_name_map["icmpv6_type"] = "icmpv6-type"

                                                                                            self.icmpv6_code = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                            self.icmpv6_code.parent = self
                                                                                            self._children_name_map["icmpv6_code"] = "icmpv6-code"

                                                                                            self.mpls_exp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                            self.mpls_exp.parent = self
                                                                                            self._children_name_map["mpls_exp"] = "mpls-exp"

                                                                                            self.mpls_exp_imp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                            self.mpls_exp_imp.parent = self
                                                                                            self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"

                                                                                            self.mpls_disp_ipv4_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                            self.mpls_disp_ipv4_acl.parent = self
                                                                                            self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"

                                                                                            self.mpls_disp_ipv6_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                            self.mpls_disp_ipv6_acl.parent = self
                                                                                            self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"

                                                                                            self.mpls_top_label = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                            self.mpls_top_label.parent = self
                                                                                            self._children_name_map["mpls_top_label"] = "mpls-top-label"

                                                                                            self.cos = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                            self.cos.parent = self
                                                                                            self._children_name_map["cos"] = "cos"

                                                                                            self.cos_inr = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                            self.cos_inr.parent = self
                                                                                            self._children_name_map["cos_inr"] = "cos-inr"

                                                                                            self.dei = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                            self.dei.parent = self
                                                                                            self._children_name_map["dei"] = "dei"

                                                                                            self.dei_inr = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                            self.dei_inr.parent = self
                                                                                            self._children_name_map["dei_inr"] = "dei-inr"

                                                                                            self.vlan = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                            self.vlan.parent = self
                                                                                            self._children_name_map["vlan"] = "vlan"

                                                                                            self.vlan_inr = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                            self.vlan_inr.parent = self
                                                                                            self._children_name_map["vlan_inr"] = "vlan-inr"

                                                                                            self.fr_dlci = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                            self.fr_dlci.parent = self
                                                                                            self._children_name_map["fr_dlci"] = "fr-dlci"

                                                                                            self.src_mac = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                            self.src_mac.parent = self
                                                                                            self._children_name_map["src_mac"] = "src-mac"

                                                                                            self.dst_mac = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                            self.dst_mac.parent = self
                                                                                            self._children_name_map["dst_mac"] = "dst-mac"

                                                                                            self.atm_clp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                            self.atm_clp.parent = self
                                                                                            self._children_name_map["atm_clp"] = "atm-clp"

                                                                                            self.fr_de = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                            self.fr_de.parent = self
                                                                                            self._children_name_map["fr_de"] = "fr-de"

                                                                                            self.ipv4_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                            self.ipv4_acl.parent = self
                                                                                            self._children_name_map["ipv4_acl"] = "ipv4-acl"

                                                                                            self.ipv6_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                            self.ipv6_acl.parent = self
                                                                                            self._children_name_map["ipv6_acl"] = "ipv6-acl"

                                                                                            self.ether_service_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                            self.ether_service_acl.parent = self
                                                                                            self._children_name_map["ether_service_acl"] = "ether-service-acl"

                                                                                            self.avail_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                            self.avail_id.parent = self
                                                                                            self._children_name_map["avail_id"] = "avail-id"

                                                                                            self.media_type = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                            self.media_type.parent = self
                                                                                            self._children_name_map["media_type"] = "media-type"

                                                                                            self.subs_protocol = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                            self.subs_protocol.parent = self
                                                                                            self._children_name_map["subs_protocol"] = "subs-protocol"

                                                                                            self.dnis = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                            self.dnis.parent = self
                                                                                            self._children_name_map["dnis"] = "dnis"

                                                                                            self.dnis_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                            self.dnis_regex.parent = self
                                                                                            self._children_name_map["dnis_regex"] = "dnis-regex"

                                                                                            self.domain = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                            self.domain.parent = self
                                                                                            self._children_name_map["domain"] = "domain"

                                                                                            self.domain_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                            self.domain_regex.parent = self
                                                                                            self._children_name_map["domain_regex"] = "domain-regex"

                                                                                            self.nas_port = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                            self.nas_port.parent = self
                                                                                            self._children_name_map["nas_port"] = "nas-port"

                                                                                            self.service_name = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                            self.service_name.parent = self
                                                                                            self._children_name_map["service_name"] = "service-name"

                                                                                            self.service_name_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                            self.service_name_regex.parent = self
                                                                                            self._children_name_map["service_name_regex"] = "service-name-regex"

                                                                                            self.src_addr_ipv4 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                            self.src_addr_ipv4.parent = self
                                                                                            self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"

                                                                                            self.dst_addr_ipv4 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                            self.dst_addr_ipv4.parent = self
                                                                                            self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"

                                                                                            self.src_addr_ipv6 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                            self.src_addr_ipv6.parent = self
                                                                                            self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"

                                                                                            self.dst_addr_ipv6 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                            self.dst_addr_ipv6.parent = self
                                                                                            self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"

                                                                                            self.src_addr_mac = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                            self.src_addr_mac.parent = self
                                                                                            self._children_name_map["src_addr_mac"] = "src-addr-mac"

                                                                                            self.timer = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                            self.timer.parent = self
                                                                                            self._children_name_map["timer"] = "timer"

                                                                                            self.timer_regexp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                            self.timer_regexp.parent = self
                                                                                            self._children_name_map["timer_regexp"] = "timer-regexp"

                                                                                            self.tunnel_name = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                            self.tunnel_name.parent = self
                                                                                            self._children_name_map["tunnel_name"] = "tunnel-name"

                                                                                            self.tunnel_name_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                            self.tunnel_name_regex.parent = self
                                                                                            self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"

                                                                                            self.user_name = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                            self.user_name.parent = self
                                                                                            self._children_name_map["user_name"] = "user-name"

                                                                                            self.user_name_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                            self.user_name_regex.parent = self
                                                                                            self._children_name_map["user_name_regex"] = "user-name-regex"

                                                                                            self.auth_username = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                            self.auth_username.parent = self
                                                                                            self._children_name_map["auth_username"] = "auth-username"

                                                                                            self.auth_username_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                            self.auth_username_regex.parent = self
                                                                                            self._children_name_map["auth_username_regex"] = "auth-username-regex"

                                                                                            self.unauth_username = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                            self.unauth_username.parent = self
                                                                                            self._children_name_map["unauth_username"] = "unauth-username"

                                                                                            self.unauth_username_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                            self.unauth_username_regex.parent = self
                                                                                            self._children_name_map["unauth_username_regex"] = "unauth-username-regex"

                                                                                            self.auth_domain = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                            self.auth_domain.parent = self
                                                                                            self._children_name_map["auth_domain"] = "auth-domain"

                                                                                            self.auth_domain_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                            self.auth_domain_regex.parent = self
                                                                                            self._children_name_map["auth_domain_regex"] = "auth-domain-regex"

                                                                                            self.unauth_domain = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                            self.unauth_domain.parent = self
                                                                                            self._children_name_map["unauth_domain"] = "unauth-domain"

                                                                                            self.unauth_domain_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                            self.unauth_domain_regex.parent = self
                                                                                            self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"

                                                                                            self.vendor_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                            self.vendor_id.parent = self
                                                                                            self._children_name_map["vendor_id"] = "vendor-id"

                                                                                            self.vendor_id_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                            self.vendor_id_regex.parent = self
                                                                                            self._children_name_map["vendor_id_regex"] = "vendor-id-regex"

                                                                                            self.access_interface = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                            self.access_interface.parent = self
                                                                                            self._children_name_map["access_interface"] = "access-interface"

                                                                                            self.input_interface = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                            self.input_interface.parent = self
                                                                                            self._children_name_map["input_interface"] = "input-interface"

                                                                                            self.input_intfhdl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                            self.input_intfhdl.parent = self
                                                                                            self._children_name_map["input_intfhdl"] = "input-intfhdl"

                                                                                            self.ethertype = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                            self.ethertype.parent = self
                                                                                            self._children_name_map["ethertype"] = "ethertype"

                                                                                            self.flow_key_data = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                            self.flow_key_data.parent = self
                                                                                            self._children_name_map["flow_key_data"] = "flow-key-data"

                                                                                            self.dhcp_client_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                            self.dhcp_client_id.parent = self
                                                                                            self._children_name_map["dhcp_client_id"] = "dhcp-client-id"

                                                                                            self.dhcp_client_id_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                            self.dhcp_client_id_regex.parent = self
                                                                                            self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"

                                                                                            self.circuit_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                            self.circuit_id.parent = self
                                                                                            self._children_name_map["circuit_id"] = "circuit-id"

                                                                                            self.circuit_id_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                            self.circuit_id_regex.parent = self
                                                                                            self._children_name_map["circuit_id_regex"] = "circuit-id-regex"

                                                                                            self.remote_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                            self.remote_id.parent = self
                                                                                            self._children_name_map["remote_id"] = "remote-id"

                                                                                            self.remote_id_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                            self.remote_id_regex.parent = self
                                                                                            self._children_name_map["remote_id_regex"] = "remote-id-regex"

                                                                                            self.src_port = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                            self.src_port.parent = self
                                                                                            self._children_name_map["src_port"] = "src-port"

                                                                                            self.dst_port = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                            self.dst_port.parent = self
                                                                                            self._children_name_map["dst_port"] = "dst-port"
                                                                                            self._segment_path = lambda: "match-data"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, ['type', 'mpls_top_eos', 'fragment_type', 'authen_status', 'mlp_negotiated'], name, value)


                                                                                        class Ipv4Dscp(Entity):
                                                                                            """
                                                                                            IPv4 DSCP
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                self.yang_name = "ipv4-dscp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ipv4-dscp"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "ipv4-dscp"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                        class Ipv6Dscp(Entity):
                                                                                            """
                                                                                            IPv6 DSCP
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                self.yang_name = "ipv6-dscp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ipv6-dscp"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "ipv6-dscp"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                        class Dscp(Entity):
                                                                                            """
                                                                                            Match DSCP range array
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                self.yang_name = "dscp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "dscp"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "dscp"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                        class Ipv4Prec(Entity):
                                                                                            """
                                                                                            IPv4 Precedence
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                self.yang_name = "ipv4-prec"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "ipv4-prec"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                        class Ipv6Prec(Entity):
                                                                                            """
                                                                                            IPv6 Precedence
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                self.yang_name = "ipv6-prec"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "ipv6-prec"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                        class Prec(Entity):
                                                                                            """
                                                                                            Match Precedence array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                self.yang_name = "prec"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "prec"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                        class DiscardClass(Entity):
                                                                                            """
                                                                                            Match Discard Class array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                self.yang_name = "discard-class"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "discard-class"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                        class QosGroup(Entity):
                                                                                            """
                                                                                            Match QoS group array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                self.yang_name = "qos-group"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "qos-group"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "qos-group"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['min', 'max'], name, value)


                                                                                        class TrafficClass(Entity):
                                                                                            """
                                                                                            Match Traffic class array
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                self.yang_name = "traffic-class"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "traffic-class"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "traffic-class"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['min', 'max'], name, value)


                                                                                        class Proto(Entity):
                                                                                            """
                                                                                            Match Protocol array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                self.yang_name = "proto"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "proto"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "proto"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['min', 'max'], name, value)


                                                                                        class IcmpV4(Entity):
                                                                                            """
                                                                                            Match ICMPV4 Protocol
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	Protocol type
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: code
                                                                                            
                                                                                            	Protocol code
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                self.yang_name = "icmp-v4"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                    ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                ])
                                                                                                self.type = None
                                                                                                self.code = None
                                                                                                self._segment_path = lambda: "icmp-v4"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['type', 'code'], name, value)


                                                                                        class IcmpV6(Entity):
                                                                                            """
                                                                                            Match ICMPV6 Protocol array
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	Protocol type
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: code
                                                                                            
                                                                                            	Protocol code
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                self.yang_name = "icmp-v6"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                    ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                ])
                                                                                                self.type = None
                                                                                                self.code = None
                                                                                                self._segment_path = lambda: "icmp-v6"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['type', 'code'], name, value)


                                                                                        class Ipv4PacketLen(Entity):
                                                                                            """
                                                                                            IPv4 packet length array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                self.yang_name = "ipv4-packet-len"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ipv4-packet-len"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "ipv4-packet-len"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                        class Ipv6PacketLen(Entity):
                                                                                            """
                                                                                            IPv6 packet length array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                self.yang_name = "ipv6-packet-len"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ipv6-packet-len"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "ipv6-packet-len"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                        class PacketLen(Entity):
                                                                                            """
                                                                                            Match packet length array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                self.yang_name = "packet-len"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "packet-len"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "packet-len"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                        class FlowTag(Entity):
                                                                                            """
                                                                                            Match flow\-tag array
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                self.yang_name = "flow-tag"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "flow-tag"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "flow-tag"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['min', 'max'], name, value)


                                                                                        class TcpFlag(Entity):
                                                                                            """
                                                                                            Match tcp flag value
                                                                                            
                                                                                            .. attribute:: value
                                                                                            
                                                                                            	Value of TCP flag
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: match_any
                                                                                            
                                                                                            	Match any TCP flag bit
                                                                                            	**type**\: bool
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                self.yang_name = "tcp-flag"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                                    ('match_any', (YLeaf(YType.boolean, 'match-any'), ['bool'])),
                                                                                                ])
                                                                                                self.value = None
                                                                                                self.match_any = None
                                                                                                self._segment_path = lambda: "tcp-flag"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['value', 'match_any'], name, value)


                                                                                        class Icmpv4Type(Entity):
                                                                                            """
                                                                                            Match ipv4 icmp type
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                self.yang_name = "icmpv4-type"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "icmpv4-type"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "icmpv4-type"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                        class Icmpv4Code(Entity):
                                                                                            """
                                                                                            Match ipv4 icmp code
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                self.yang_name = "icmpv4-code"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "icmpv4-code"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "icmpv4-code"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                        class Icmpv6Type(Entity):
                                                                                            """
                                                                                            Match ipv6 icmp type
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                self.yang_name = "icmpv6-type"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "icmpv6-type"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "icmpv6-type"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                        class Icmpv6Code(Entity):
                                                                                            """
                                                                                            Match ipv6 icmp code
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                self.yang_name = "icmpv6-code"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "icmpv6-code"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "icmpv6-code"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                        class MplsExp(Entity):
                                                                                            """
                                                                                            Match MPLS experimental topmost array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                self.yang_name = "mpls-exp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "mpls-exp"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                        class MplsExpImp(Entity):
                                                                                            """
                                                                                            Match MPLS experimental imposition array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                self.yang_name = "mpls-exp-imp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "mpls-exp-imp"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                        class MplsDispIpv4Acl(Entity):
                                                                                            """
                                                                                            MPLS Disposition IPv4 Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "mpls-disp-ipv4-acl"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                        class MplsDispIpv6Acl(Entity):
                                                                                            """
                                                                                            MPLS Disposition IPv6 Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "mpls-disp-ipv6-acl"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                        class MplsTopLabel(Entity):
                                                                                            """
                                                                                            MPLS Topmost LABEL
                                                                                            
                                                                                            .. attribute:: uint32_rng_array
                                                                                            
                                                                                            	uint32 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                self.yang_name = "mpls-top-label"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint32_rng_array", ("uint32_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint32_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "mpls-top-label"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                            class Uint32RngArray(Entity):
                                                                                                """
                                                                                                uint32 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                    self.yang_name = "uint32_rng_array"
                                                                                                    self.yang_parent_name = "mpls-top-label"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint32, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint32, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint32_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['min', 'max'], name, value)


                                                                                        class Cos(Entity):
                                                                                            """
                                                                                            Match CoS array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                self.yang_name = "cos"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "cos"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                        class CosInr(Entity):
                                                                                            """
                                                                                            Match inner header CoS
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                self.yang_name = "cos-inr"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "cos-inr"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                        class Dei(Entity):
                                                                                            """
                                                                                            Match DEI Bit
                                                                                            
                                                                                            .. attribute:: bit_value
                                                                                            
                                                                                            	Value of the DEI bit
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                self.yang_name = "dei"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                ])
                                                                                                self.bit_value = None
                                                                                                self._segment_path = lambda: "dei"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                        class DeiInr(Entity):
                                                                                            """
                                                                                            Match inner DEI Bit
                                                                                            
                                                                                            .. attribute:: bit_value
                                                                                            
                                                                                            	Value of the DEI bit
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                self.yang_name = "dei-inr"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                ])
                                                                                                self.bit_value = None
                                                                                                self._segment_path = lambda: "dei-inr"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                        class Vlan(Entity):
                                                                                            """
                                                                                            Match VLAN array
                                                                                            
                                                                                            .. attribute:: vlan_id_array
                                                                                            
                                                                                            	vlan id array
                                                                                            	**type**\: list of  		 :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                self.yang_name = "vlan"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("vlan-id-array", ("vlan_id_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.vlan_id_array = YList(self)
                                                                                                self._segment_path = lambda: "vlan"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                            class VlanIdArray(Entity):
                                                                                                """
                                                                                                vlan id array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	VLAN mask
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                    self.yang_name = "vlan-id-array"
                                                                                                    self.yang_parent_name = "vlan"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ('mask', (YLeaf(YType.uint16, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self.mask = None
                                                                                                    self._segment_path = lambda: "vlan-id-array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['min', 'max', 'mask'], name, value)


                                                                                        class VlanInr(Entity):
                                                                                            """
                                                                                            Match inner header VLAN range array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                self.yang_name = "vlan-inr"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "vlan-inr"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "vlan-inr"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['min', 'max'], name, value)


                                                                                        class FrDlci(Entity):
                                                                                            """
                                                                                            Match FR DLCI range array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                self.yang_name = "fr-dlci"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "fr-dlci"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "fr-dlci"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['min', 'max'], name, value)


                                                                                        class SrcMac(Entity):
                                                                                            """
                                                                                            Match Source MAC address
                                                                                            
                                                                                            .. attribute:: mac_addr
                                                                                            
                                                                                            	MAC address
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	MAC mask
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                self.yang_name = "src-mac"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                    ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                ])
                                                                                                self.mac_addr = []
                                                                                                self.mask = []
                                                                                                self._segment_path = lambda: "src-mac"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                        class DstMac(Entity):
                                                                                            """
                                                                                            Match Destination MAC address
                                                                                            
                                                                                            .. attribute:: mac_addr
                                                                                            
                                                                                            	MAC address
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	MAC mask
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                self.yang_name = "dst-mac"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                    ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                ])
                                                                                                self.mac_addr = []
                                                                                                self.mask = []
                                                                                                self._segment_path = lambda: "dst-mac"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                        class AtmClp(Entity):
                                                                                            """
                                                                                            Match ATM CLP level
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                self.yang_name = "atm-clp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "atm-clp"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                        class FrDe(Entity):
                                                                                            """
                                                                                            Match FR DE value
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                self.yang_name = "fr-de"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "fr-de"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                        class Ipv4Acl(Entity):
                                                                                            """
                                                                                            IPv4 Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                self.yang_name = "ipv4-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "ipv4-acl"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                        class Ipv6Acl(Entity):
                                                                                            """
                                                                                            IPv6 Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                self.yang_name = "ipv6-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "ipv6-acl"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                        class EtherServiceAcl(Entity):
                                                                                            """
                                                                                            Ethernet\-Services Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                self.yang_name = "ether-service-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "ether-service-acl"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                        class AvailId(Entity):
                                                                                            """
                                                                                            Available Identifiers
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                self.yang_name = "avail-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "avail-id"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                        class MediaType(Entity):
                                                                                            """
                                                                                            Media Type
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                self.yang_name = "media-type"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "media-type"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                        class SubsProtocol(Entity):
                                                                                            """
                                                                                            Protocol
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                self.yang_name = "subs-protocol"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "subs-protocol"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                        class Dnis(Entity):
                                                                                            """
                                                                                            DNIS
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                self.yang_name = "dnis"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "dnis"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                        class DnisRegex(Entity):
                                                                                            """
                                                                                            DNIS Regular Expression
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                self.yang_name = "dnis-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "dnis-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                        class Domain(Entity):
                                                                                            """
                                                                                            Domain Name
                                                                                            
                                                                                            .. attribute:: domain_array
                                                                                            
                                                                                            	domain array
                                                                                            	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                self.yang_name = "domain"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.domain_array = YList(self)
                                                                                                self._segment_path = lambda: "domain"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                            class DomainArray(Entity):
                                                                                                """
                                                                                                domain array
                                                                                                
                                                                                                .. attribute:: domain_name
                                                                                                
                                                                                                	domain name
                                                                                                	**type**\: str
                                                                                                
                                                                                                .. attribute:: format_name
                                                                                                
                                                                                                	format name
                                                                                                	**type**\: str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                    self.yang_name = "domain-array"
                                                                                                    self.yang_parent_name = "domain"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                        ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                    ])
                                                                                                    self.domain_name = None
                                                                                                    self.format_name = None
                                                                                                    self._segment_path = lambda: "domain-array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                        class DomainRegex(Entity):
                                                                                            """
                                                                                            Domain Regular Expression
                                                                                            
                                                                                            .. attribute:: domain_array
                                                                                            
                                                                                            	domain array
                                                                                            	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                self.yang_name = "domain-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.domain_array = YList(self)
                                                                                                self._segment_path = lambda: "domain-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                            class DomainArray(Entity):
                                                                                                """
                                                                                                domain array
                                                                                                
                                                                                                .. attribute:: domain_name
                                                                                                
                                                                                                	domain name
                                                                                                	**type**\: str
                                                                                                
                                                                                                .. attribute:: format_name
                                                                                                
                                                                                                	format name
                                                                                                	**type**\: str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                    self.yang_name = "domain-array"
                                                                                                    self.yang_parent_name = "domain-regex"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                        ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                    ])
                                                                                                    self.domain_name = None
                                                                                                    self.format_name = None
                                                                                                    self._segment_path = lambda: "domain-array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                        class NasPort(Entity):
                                                                                            """
                                                                                            NAS Port
                                                                                            
                                                                                            .. attribute:: nas_port_array
                                                                                            
                                                                                            	nas port array
                                                                                            	**type**\: list of  		 :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                self.yang_name = "nas-port"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("nas-port-array", ("nas_port_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.nas_port_array = YList(self)
                                                                                                self._segment_path = lambda: "nas-port"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                            class NasPortArray(Entity):
                                                                                                """
                                                                                                nas port array
                                                                                                
                                                                                                .. attribute:: sub_id
                                                                                                
                                                                                                	sub id
                                                                                                	**type**\:  :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                
                                                                                                .. attribute:: operator
                                                                                                
                                                                                                	operator
                                                                                                	**type**\:  :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                
                                                                                                .. attribute:: value
                                                                                                
                                                                                                	value
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                    self.yang_name = "nas-port-array"
                                                                                                    self.yang_parent_name = "nas-port"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('sub_id', (YLeaf(YType.enumeration, 'sub-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchNasPortSubIdEn', '')])),
                                                                                                        ('operator', (YLeaf(YType.enumeration, 'operator'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchLogicalOperatorEn', '')])),
                                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                                    ])
                                                                                                    self.sub_id = None
                                                                                                    self.operator = None
                                                                                                    self.value = None
                                                                                                    self._segment_path = lambda: "nas-port-array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['sub_id', 'operator', 'value'], name, value)


                                                                                        class ServiceName(Entity):
                                                                                            """
                                                                                            Service Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                self.yang_name = "service-name"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "service-name"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                        class ServiceNameRegex(Entity):
                                                                                            """
                                                                                            Service Name Regular Exp
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                self.yang_name = "service-name-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "service-name-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                        class SrcAddrIpv4(Entity):
                                                                                            """
                                                                                            Source Address IPV4
                                                                                            
                                                                                            .. attribute:: ipv4_addr_array
                                                                                            
                                                                                            	ipv4 addr array
                                                                                            	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                self.yang_name = "src-addr-ipv4"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.ipv4_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "src-addr-ipv4"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                            class Ipv4AddrArray(Entity):
                                                                                                """
                                                                                                ipv4 addr array
                                                                                                
                                                                                                .. attribute:: prefix
                                                                                                
                                                                                                	prefix
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	mask
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                    self.yang_name = "ipv4-addr-array"
                                                                                                    self.yang_parent_name = "src-addr-ipv4"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                        ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                    ])
                                                                                                    self.prefix = None
                                                                                                    self.mask = None
                                                                                                    self._segment_path = lambda: "ipv4-addr-array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                        class DstAddrIpv4(Entity):
                                                                                            """
                                                                                            Destination Address IPV4
                                                                                            
                                                                                            .. attribute:: ipv4_addr_array
                                                                                            
                                                                                            	ipv4 addr array
                                                                                            	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                self.yang_name = "dst-addr-ipv4"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.ipv4_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "dst-addr-ipv4"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                            class Ipv4AddrArray(Entity):
                                                                                                """
                                                                                                ipv4 addr array
                                                                                                
                                                                                                .. attribute:: prefix
                                                                                                
                                                                                                	prefix
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	mask
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                    self.yang_name = "ipv4-addr-array"
                                                                                                    self.yang_parent_name = "dst-addr-ipv4"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                        ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                    ])
                                                                                                    self.prefix = None
                                                                                                    self.mask = None
                                                                                                    self._segment_path = lambda: "ipv4-addr-array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                        class SrcAddrIpv6(Entity):
                                                                                            """
                                                                                            Source Address IPV6
                                                                                            
                                                                                            .. attribute:: ipv6_addr_array
                                                                                            
                                                                                            	ipv6 addr array
                                                                                            	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                self.yang_name = "src-addr-ipv6"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.ipv6_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "src-addr-ipv6"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                            class Ipv6AddrArray(Entity):
                                                                                                """
                                                                                                ipv6 addr array
                                                                                                
                                                                                                .. attribute:: prefix
                                                                                                
                                                                                                	IPV6 prefix
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	IPV6 mask
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                    self.yang_name = "ipv6-addr-array"
                                                                                                    self.yang_parent_name = "src-addr-ipv6"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                        ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.prefix = None
                                                                                                    self.mask = None
                                                                                                    self._segment_path = lambda: "ipv6-addr-array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                        class DstAddrIpv6(Entity):
                                                                                            """
                                                                                            Destination Address IPV6
                                                                                            
                                                                                            .. attribute:: ipv6_addr_array
                                                                                            
                                                                                            	ipv6 addr array
                                                                                            	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                self.yang_name = "dst-addr-ipv6"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.ipv6_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "dst-addr-ipv6"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                            class Ipv6AddrArray(Entity):
                                                                                                """
                                                                                                ipv6 addr array
                                                                                                
                                                                                                .. attribute:: prefix
                                                                                                
                                                                                                	IPV6 prefix
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	IPV6 mask
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                    self.yang_name = "ipv6-addr-array"
                                                                                                    self.yang_parent_name = "dst-addr-ipv6"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                        ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.prefix = None
                                                                                                    self.mask = None
                                                                                                    self._segment_path = lambda: "ipv6-addr-array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                        class SrcAddrMac(Entity):
                                                                                            """
                                                                                            Source Address MAC
                                                                                            
                                                                                            .. attribute:: mac_addr_array
                                                                                            
                                                                                            	mac addr array
                                                                                            	**type**\: list of  		 :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                self.yang_name = "src-addr-mac"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("mac-addr-array", ("mac_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.mac_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "src-addr-mac"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                            class MacAddrArray(Entity):
                                                                                                """
                                                                                                mac addr array
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                    self.yang_name = "mac-addr-array"
                                                                                                    self.yang_parent_name = "src-addr-mac"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.mac_addr = []
                                                                                                    self.mask = []
                                                                                                    self._segment_path = lambda: "mac-addr-array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                        class Timer(Entity):
                                                                                            """
                                                                                            Timer
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                self.yang_name = "timer"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "timer"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                        class TimerRegexp(Entity):
                                                                                            """
                                                                                            Timer Regular Expression
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                self.yang_name = "timer-regexp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "timer-regexp"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                        class TunnelName(Entity):
                                                                                            """
                                                                                            Tunnel Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                self.yang_name = "tunnel-name"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "tunnel-name"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                        class TunnelNameRegex(Entity):
                                                                                            """
                                                                                            Tunnel Name Regular Expression
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                self.yang_name = "tunnel-name-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "tunnel-name-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                        class UserName(Entity):
                                                                                            """
                                                                                            User Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                self.yang_name = "user-name"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "user-name"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                        class UserNameRegex(Entity):
                                                                                            """
                                                                                            User Name Regular Expression
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                self.yang_name = "user-name-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "user-name-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                        class AuthUsername(Entity):
                                                                                            """
                                                                                            Authenticated User Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                self.yang_name = "auth-username"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "auth-username"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                        class AuthUsernameRegex(Entity):
                                                                                            """
                                                                                            Authenticated User Name RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                self.yang_name = "auth-username-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "auth-username-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                        class UnauthUsername(Entity):
                                                                                            """
                                                                                            Unauthenticated User Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                self.yang_name = "unauth-username"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "unauth-username"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                        class UnauthUsernameRegex(Entity):
                                                                                            """
                                                                                            Unauthenticated User Name RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                self.yang_name = "unauth-username-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "unauth-username-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                        class AuthDomain(Entity):
                                                                                            """
                                                                                            Authenticated domain name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                self.yang_name = "auth-domain"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "auth-domain"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                        class AuthDomainRegex(Entity):
                                                                                            """
                                                                                            Authenticated Domain Name RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                self.yang_name = "auth-domain-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "auth-domain-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                        class UnauthDomain(Entity):
                                                                                            """
                                                                                            Unauthenticated Domain Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                self.yang_name = "unauth-domain"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "unauth-domain"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                        class UnauthDomainRegex(Entity):
                                                                                            """
                                                                                            Unauthenticated Domain Name RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                self.yang_name = "unauth-domain-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "unauth-domain-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                        class VendorId(Entity):
                                                                                            """
                                                                                            Vendor ID
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                self.yang_name = "vendor-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "vendor-id"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                        class VendorIdRegex(Entity):
                                                                                            """
                                                                                            Vendor ID RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                self.yang_name = "vendor-id-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "vendor-id-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                        class AccessInterface(Entity):
                                                                                            """
                                                                                            Access interface
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                self.yang_name = "access-interface"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "access-interface"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                        class InputInterface(Entity):
                                                                                            """
                                                                                            Input interface
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                self.yang_name = "input-interface"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "input-interface"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                        class InputIntfhdl(Entity):
                                                                                            """
                                                                                            Input interface handle
                                                                                            
                                                                                            .. attribute:: uint64_array
                                                                                            
                                                                                            	uint64 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..18446744073709551615
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                self.yang_name = "input-intfhdl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint64_array', (YLeafList(YType.uint64, 'uint64_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint64_array = []
                                                                                                self._segment_path = lambda: "input-intfhdl"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                        class Ethertype(Entity):
                                                                                            """
                                                                                            Ethernet type
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                self.yang_name = "ethertype"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ethertype"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "ethertype"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['min', 'max'], name, value)


                                                                                        class FlowKeyData(Entity):
                                                                                            """
                                                                                            Flow key structure
                                                                                            
                                                                                            .. attribute:: flow_keys
                                                                                            
                                                                                            	flow keys
                                                                                            	**type**\:  :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                            
                                                                                            .. attribute:: max_count
                                                                                            
                                                                                            	Maximum count of flows
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: idle_timeout
                                                                                            
                                                                                            	Idle timeout of flows (in seconds)
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            	**units**\: second
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                self.yang_name = "flow-key-data"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("flow-keys", ("flow_keys", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys))])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('max_count', (YLeaf(YType.uint16, 'max-count'), ['int'])),
                                                                                                    ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                                                ])
                                                                                                self.max_count = None
                                                                                                self.idle_timeout = None

                                                                                                self.flow_keys = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                self.flow_keys.parent = self
                                                                                                self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                self._segment_path = lambda: "flow-key-data"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['max_count', 'idle_timeout'], name, value)


                                                                                            class FlowKeys(Entity):
                                                                                                """
                                                                                                flow keys
                                                                                                
                                                                                                .. attribute:: keys
                                                                                                
                                                                                                	keys
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                
                                                                                                .. attribute:: num
                                                                                                
                                                                                                	num
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                    self.yang_name = "flow-keys"
                                                                                                    self.yang_parent_name = "flow-key-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('keys', (YLeaf(YType.str, 'keys'), ['str'])),
                                                                                                        ('num', (YLeaf(YType.uint8, 'num'), ['int'])),
                                                                                                    ])
                                                                                                    self.keys = None
                                                                                                    self.num = None
                                                                                                    self._segment_path = lambda: "flow-keys"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                        class DhcpClientId(Entity):
                                                                                            """
                                                                                            Dhcp Client ID
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                self.yang_name = "dhcp-client-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "dhcp-client-id"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                        class DhcpClientIdRegex(Entity):
                                                                                            """
                                                                                            Dhcp Client ID RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                self.yang_name = "dhcp-client-id-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "dhcp-client-id-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                        class CircuitId(Entity):
                                                                                            """
                                                                                            Circuit ID
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                self.yang_name = "circuit-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "circuit-id"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                        class CircuitIdRegex(Entity):
                                                                                            """
                                                                                            Circuit ID RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                self.yang_name = "circuit-id-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "circuit-id-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                        class RemoteId(Entity):
                                                                                            """
                                                                                            Remote ID
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                self.yang_name = "remote-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "remote-id"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                        class RemoteIdRegex(Entity):
                                                                                            """
                                                                                            Remote ID RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                self.yang_name = "remote-id-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "remote-id-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                        class SrcPort(Entity):
                                                                                            """
                                                                                            Source port
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                self.yang_name = "src-port"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "src-port"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "src-port"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                                        class DstPort(Entity):
                                                                                            """
                                                                                            Destination port
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                self.yang_name = "dst-port"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "dst-port"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "dst-port"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                    class ConfclassP(Entity):
                                                                        """
                                                                        confclass p
                                                                        
                                                                        .. attribute:: class_map_bg
                                                                        
                                                                        	class map bg
                                                                        	**type**\: list of  		 :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP, self).__init__()

                                                                            self.yang_name = "confclass-p"
                                                                            self.yang_parent_name = "police"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("class-map-bg", ("class_map_bg", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg))])
                                                                            self._leafs = OrderedDict()

                                                                            self.class_map_bg = YList(self)
                                                                            self._segment_path = lambda: "confclass-p"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP, [], name, value)


                                                                        class ClassMapBg(Entity):
                                                                            """
                                                                            class map bg
                                                                            
                                                                            .. attribute:: match_infop
                                                                            
                                                                            	Pointer to the first Match info
                                                                            	**type**\:  :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop>`
                                                                            
                                                                            .. attribute:: name
                                                                            
                                                                            	Name of the class\-map
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..65
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	Class\-Map Type QoS/PBR/Netflow/..
                                                                            	**type**\:  :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                                            
                                                                            .. attribute:: mode
                                                                            
                                                                            	Class\-Map Mode Match any/Match all
                                                                            	**type**\:  :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                            
                                                                            .. attribute:: description
                                                                            
                                                                            	description
                                                                            	**type**\: str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg, self).__init__()

                                                                                self.yang_name = "class-map-bg"
                                                                                self.yang_parent_name = "confclass-p"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("match-infop", ("match_infop", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapTypeEn', '')])),
                                                                                    ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapModeEn', '')])),
                                                                                    ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                ])
                                                                                self.name = None
                                                                                self.type = None
                                                                                self.mode = None
                                                                                self.description = None

                                                                                self.match_infop = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop()
                                                                                self.match_infop.parent = self
                                                                                self._children_name_map["match_infop"] = "match-infop"
                                                                                self._segment_path = lambda: "class-map-bg"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg, ['name', 'type', 'mode', 'description'], name, value)


                                                                            class MatchInfop(Entity):
                                                                                """
                                                                                Pointer to the first Match info
                                                                                
                                                                                .. attribute:: class_match_info_st
                                                                                
                                                                                	class match info st
                                                                                	**type**\: list of  		 :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop, self).__init__()

                                                                                    self.yang_name = "match-infop"
                                                                                    self.yang_parent_name = "class-map-bg"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("class-match-info-st", ("class_match_info_st", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.class_match_info_st = YList(self)
                                                                                    self._segment_path = lambda: "match-infop"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop, [], name, value)


                                                                                class ClassMatchInfoSt(Entity):
                                                                                    """
                                                                                    class match info st
                                                                                    
                                                                                    .. attribute:: match_data
                                                                                    
                                                                                    	Match criteria
                                                                                    	**type**\:  :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                    
                                                                                    .. attribute:: flags
                                                                                    
                                                                                    	Flags
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                        self.yang_name = "class-match-info-st"
                                                                                        self.yang_parent_name = "match-infop"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("match-data", ("match_data", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData))])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                        ])
                                                                                        self.flags = None

                                                                                        self.match_data = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                        self.match_data.parent = self
                                                                                        self._children_name_map["match_data"] = "match-data"
                                                                                        self._segment_path = lambda: "class-match-info-st"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                    class MatchData(Entity):
                                                                                        """
                                                                                        Match criteria
                                                                                        
                                                                                        .. attribute:: ipv4_dscp
                                                                                        
                                                                                        	IPv4 DSCP
                                                                                        	**type**\:  :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                        
                                                                                        .. attribute:: ipv6_dscp
                                                                                        
                                                                                        	IPv6 DSCP
                                                                                        	**type**\:  :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                        
                                                                                        .. attribute:: dscp
                                                                                        
                                                                                        	Match DSCP range array
                                                                                        	**type**\:  :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                        
                                                                                        .. attribute:: ipv4_prec
                                                                                        
                                                                                        	IPv4 Precedence
                                                                                        	**type**\:  :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                        
                                                                                        .. attribute:: ipv6_prec
                                                                                        
                                                                                        	IPv6 Precedence
                                                                                        	**type**\:  :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                        
                                                                                        .. attribute:: prec
                                                                                        
                                                                                        	Match Precedence array
                                                                                        	**type**\:  :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                        
                                                                                        .. attribute:: discard_class
                                                                                        
                                                                                        	Match Discard Class array
                                                                                        	**type**\:  :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                        
                                                                                        .. attribute:: qos_group
                                                                                        
                                                                                        	Match QoS group array
                                                                                        	**type**\:  :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                        
                                                                                        .. attribute:: traffic_class
                                                                                        
                                                                                        	Match Traffic class array
                                                                                        	**type**\:  :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                        
                                                                                        .. attribute:: proto
                                                                                        
                                                                                        	Match Protocol array
                                                                                        	**type**\:  :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                        
                                                                                        .. attribute:: icmp_v4
                                                                                        
                                                                                        	Match ICMPV4 Protocol
                                                                                        	**type**\:  :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                        
                                                                                        .. attribute:: icmp_v6
                                                                                        
                                                                                        	Match ICMPV6 Protocol array
                                                                                        	**type**\:  :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                        
                                                                                        .. attribute:: ipv4_packet_len
                                                                                        
                                                                                        	IPv4 packet length array
                                                                                        	**type**\:  :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                        
                                                                                        .. attribute:: ipv6_packet_len
                                                                                        
                                                                                        	IPv6 packet length array
                                                                                        	**type**\:  :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                        
                                                                                        .. attribute:: packet_len
                                                                                        
                                                                                        	Match packet length array
                                                                                        	**type**\:  :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                        
                                                                                        .. attribute:: flow_tag
                                                                                        
                                                                                        	Match flow\-tag array
                                                                                        	**type**\:  :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                        
                                                                                        .. attribute:: tcp_flag
                                                                                        
                                                                                        	Match tcp flag value
                                                                                        	**type**\:  :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                        
                                                                                        .. attribute:: icmpv4_type
                                                                                        
                                                                                        	Match ipv4 icmp type
                                                                                        	**type**\:  :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                        
                                                                                        .. attribute:: icmpv4_code
                                                                                        
                                                                                        	Match ipv4 icmp code
                                                                                        	**type**\:  :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                        
                                                                                        .. attribute:: icmpv6_type
                                                                                        
                                                                                        	Match ipv6 icmp type
                                                                                        	**type**\:  :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                        
                                                                                        .. attribute:: icmpv6_code
                                                                                        
                                                                                        	Match ipv6 icmp code
                                                                                        	**type**\:  :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                        
                                                                                        .. attribute:: mpls_exp
                                                                                        
                                                                                        	Match MPLS experimental topmost array
                                                                                        	**type**\:  :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                        
                                                                                        .. attribute:: mpls_exp_imp
                                                                                        
                                                                                        	Match MPLS experimental imposition array
                                                                                        	**type**\:  :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                        
                                                                                        .. attribute:: mpls_disp_ipv4_acl
                                                                                        
                                                                                        	MPLS Disposition IPv4 Access\-list
                                                                                        	**type**\:  :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                        
                                                                                        .. attribute:: mpls_disp_ipv6_acl
                                                                                        
                                                                                        	MPLS Disposition IPv6 Access\-list
                                                                                        	**type**\:  :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                        
                                                                                        .. attribute:: mpls_top_label
                                                                                        
                                                                                        	MPLS Topmost LABEL
                                                                                        	**type**\:  :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                        
                                                                                        .. attribute:: cos
                                                                                        
                                                                                        	Match CoS array
                                                                                        	**type**\:  :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                        
                                                                                        .. attribute:: cos_inr
                                                                                        
                                                                                        	Match inner header CoS
                                                                                        	**type**\:  :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                        
                                                                                        .. attribute:: dei
                                                                                        
                                                                                        	Match DEI Bit
                                                                                        	**type**\:  :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                        
                                                                                        .. attribute:: dei_inr
                                                                                        
                                                                                        	Match inner DEI Bit
                                                                                        	**type**\:  :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                        
                                                                                        .. attribute:: vlan
                                                                                        
                                                                                        	Match VLAN array
                                                                                        	**type**\:  :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                        
                                                                                        .. attribute:: vlan_inr
                                                                                        
                                                                                        	Match inner header VLAN range array
                                                                                        	**type**\:  :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                        
                                                                                        .. attribute:: fr_dlci
                                                                                        
                                                                                        	Match FR DLCI range array
                                                                                        	**type**\:  :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                        
                                                                                        .. attribute:: src_mac
                                                                                        
                                                                                        	Match Source MAC address
                                                                                        	**type**\:  :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                        
                                                                                        .. attribute:: dst_mac
                                                                                        
                                                                                        	Match Destination MAC address
                                                                                        	**type**\:  :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                        
                                                                                        .. attribute:: atm_clp
                                                                                        
                                                                                        	Match ATM CLP level
                                                                                        	**type**\:  :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                        
                                                                                        .. attribute:: fr_de
                                                                                        
                                                                                        	Match FR DE value
                                                                                        	**type**\:  :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                        
                                                                                        .. attribute:: ipv4_acl
                                                                                        
                                                                                        	IPv4 Access\-list
                                                                                        	**type**\:  :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                        
                                                                                        .. attribute:: ipv6_acl
                                                                                        
                                                                                        	IPv6 Access\-list
                                                                                        	**type**\:  :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                        
                                                                                        .. attribute:: ether_service_acl
                                                                                        
                                                                                        	Ethernet\-Services Access\-list
                                                                                        	**type**\:  :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                        
                                                                                        .. attribute:: avail_id
                                                                                        
                                                                                        	Available Identifiers
                                                                                        	**type**\:  :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                        
                                                                                        .. attribute:: media_type
                                                                                        
                                                                                        	Media Type
                                                                                        	**type**\:  :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                        
                                                                                        .. attribute:: subs_protocol
                                                                                        
                                                                                        	Protocol
                                                                                        	**type**\:  :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                        
                                                                                        .. attribute:: dnis
                                                                                        
                                                                                        	DNIS
                                                                                        	**type**\:  :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                        
                                                                                        .. attribute:: dnis_regex
                                                                                        
                                                                                        	DNIS Regular Expression
                                                                                        	**type**\:  :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                        
                                                                                        .. attribute:: domain
                                                                                        
                                                                                        	Domain Name
                                                                                        	**type**\:  :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                        
                                                                                        .. attribute:: domain_regex
                                                                                        
                                                                                        	Domain Regular Expression
                                                                                        	**type**\:  :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                        
                                                                                        .. attribute:: nas_port
                                                                                        
                                                                                        	NAS Port
                                                                                        	**type**\:  :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                        
                                                                                        .. attribute:: service_name
                                                                                        
                                                                                        	Service Name
                                                                                        	**type**\:  :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                        
                                                                                        .. attribute:: service_name_regex
                                                                                        
                                                                                        	Service Name Regular Exp
                                                                                        	**type**\:  :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                        
                                                                                        .. attribute:: src_addr_ipv4
                                                                                        
                                                                                        	Source Address IPV4
                                                                                        	**type**\:  :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                        
                                                                                        .. attribute:: dst_addr_ipv4
                                                                                        
                                                                                        	Destination Address IPV4
                                                                                        	**type**\:  :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                        
                                                                                        .. attribute:: src_addr_ipv6
                                                                                        
                                                                                        	Source Address IPV6
                                                                                        	**type**\:  :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                        
                                                                                        .. attribute:: dst_addr_ipv6
                                                                                        
                                                                                        	Destination Address IPV6
                                                                                        	**type**\:  :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                        
                                                                                        .. attribute:: src_addr_mac
                                                                                        
                                                                                        	Source Address MAC
                                                                                        	**type**\:  :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                        
                                                                                        .. attribute:: timer
                                                                                        
                                                                                        	Timer
                                                                                        	**type**\:  :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                        
                                                                                        .. attribute:: timer_regexp
                                                                                        
                                                                                        	Timer Regular Expression
                                                                                        	**type**\:  :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                        
                                                                                        .. attribute:: tunnel_name
                                                                                        
                                                                                        	Tunnel Name
                                                                                        	**type**\:  :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                        
                                                                                        .. attribute:: tunnel_name_regex
                                                                                        
                                                                                        	Tunnel Name Regular Expression
                                                                                        	**type**\:  :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                        
                                                                                        .. attribute:: user_name
                                                                                        
                                                                                        	User Name
                                                                                        	**type**\:  :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                        
                                                                                        .. attribute:: user_name_regex
                                                                                        
                                                                                        	User Name Regular Expression
                                                                                        	**type**\:  :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                        
                                                                                        .. attribute:: auth_username
                                                                                        
                                                                                        	Authenticated User Name
                                                                                        	**type**\:  :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                        
                                                                                        .. attribute:: auth_username_regex
                                                                                        
                                                                                        	Authenticated User Name RegEx
                                                                                        	**type**\:  :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                        
                                                                                        .. attribute:: unauth_username
                                                                                        
                                                                                        	Unauthenticated User Name
                                                                                        	**type**\:  :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                        
                                                                                        .. attribute:: unauth_username_regex
                                                                                        
                                                                                        	Unauthenticated User Name RegEx
                                                                                        	**type**\:  :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                        
                                                                                        .. attribute:: auth_domain
                                                                                        
                                                                                        	Authenticated domain name
                                                                                        	**type**\:  :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                        
                                                                                        .. attribute:: auth_domain_regex
                                                                                        
                                                                                        	Authenticated Domain Name RegEx
                                                                                        	**type**\:  :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                        
                                                                                        .. attribute:: unauth_domain
                                                                                        
                                                                                        	Unauthenticated Domain Name
                                                                                        	**type**\:  :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                        
                                                                                        .. attribute:: unauth_domain_regex
                                                                                        
                                                                                        	Unauthenticated Domain Name RegEx
                                                                                        	**type**\:  :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                        
                                                                                        .. attribute:: vendor_id
                                                                                        
                                                                                        	Vendor ID
                                                                                        	**type**\:  :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                        
                                                                                        .. attribute:: vendor_id_regex
                                                                                        
                                                                                        	Vendor ID RegEx
                                                                                        	**type**\:  :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                        
                                                                                        .. attribute:: access_interface
                                                                                        
                                                                                        	Access interface
                                                                                        	**type**\:  :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                        
                                                                                        .. attribute:: input_interface
                                                                                        
                                                                                        	Input interface
                                                                                        	**type**\:  :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                        
                                                                                        .. attribute:: input_intfhdl
                                                                                        
                                                                                        	Input interface handle
                                                                                        	**type**\:  :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                        
                                                                                        .. attribute:: ethertype
                                                                                        
                                                                                        	Ethernet type
                                                                                        	**type**\:  :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                        
                                                                                        .. attribute:: flow_key_data
                                                                                        
                                                                                        	Flow key structure
                                                                                        	**type**\:  :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                        
                                                                                        .. attribute:: dhcp_client_id
                                                                                        
                                                                                        	Dhcp Client ID
                                                                                        	**type**\:  :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                        
                                                                                        .. attribute:: dhcp_client_id_regex
                                                                                        
                                                                                        	Dhcp Client ID RegEx
                                                                                        	**type**\:  :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                        
                                                                                        .. attribute:: circuit_id
                                                                                        
                                                                                        	Circuit ID
                                                                                        	**type**\:  :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                        
                                                                                        .. attribute:: circuit_id_regex
                                                                                        
                                                                                        	Circuit ID RegEx
                                                                                        	**type**\:  :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                        
                                                                                        .. attribute:: remote_id
                                                                                        
                                                                                        	Remote ID
                                                                                        	**type**\:  :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                        
                                                                                        .. attribute:: remote_id_regex
                                                                                        
                                                                                        	Remote ID RegEx
                                                                                        	**type**\:  :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                        
                                                                                        .. attribute:: src_port
                                                                                        
                                                                                        	Source port
                                                                                        	**type**\:  :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                        
                                                                                        .. attribute:: dst_port
                                                                                        
                                                                                        	Destination port
                                                                                        	**type**\:  :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                        
                                                                                        .. attribute:: type
                                                                                        
                                                                                        	type
                                                                                        	**type**\:  :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                        
                                                                                        .. attribute:: mpls_top_eos
                                                                                        
                                                                                        	MPLS Topmost EOS
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: fragment_type
                                                                                        
                                                                                        	Fragment type
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: authen_status
                                                                                        
                                                                                        	Authentication Status
                                                                                        	**type**\:  :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                        
                                                                                        .. attribute:: mlp_negotiated
                                                                                        
                                                                                        	MLP Negotiated
                                                                                        	**type**\:  :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                            self.yang_name = "match-data"
                                                                                            self.yang_parent_name = "class-match-info-st"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("ipv4-dscp", ("ipv4_dscp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp)), ("ipv6-dscp", ("ipv6_dscp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp)), ("dscp", ("dscp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp)), ("ipv4-prec", ("ipv4_prec", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec)), ("ipv6-prec", ("ipv6_prec", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec)), ("prec", ("prec", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec)), ("discard-class", ("discard_class", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass)), ("qos-group", ("qos_group", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup)), ("traffic-class", ("traffic_class", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass)), ("proto", ("proto", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto)), ("icmp-v4", ("icmp_v4", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4)), ("icmp-v6", ("icmp_v6", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6)), ("ipv4-packet-len", ("ipv4_packet_len", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen)), ("ipv6-packet-len", ("ipv6_packet_len", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen)), ("packet-len", ("packet_len", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen)), ("flow-tag", ("flow_tag", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag)), ("tcp-flag", ("tcp_flag", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag)), ("icmpv4-type", ("icmpv4_type", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type)), ("icmpv4-code", ("icmpv4_code", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code)), ("icmpv6-type", ("icmpv6_type", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type)), ("icmpv6-code", ("icmpv6_code", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code)), ("mpls-exp", ("mpls_exp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp)), ("mpls-exp-imp", ("mpls_exp_imp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp)), ("mpls-disp-ipv4-acl", ("mpls_disp_ipv4_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl)), ("mpls-disp-ipv6-acl", ("mpls_disp_ipv6_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl)), ("mpls-top-label", ("mpls_top_label", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel)), ("cos", ("cos", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos)), ("cos-inr", ("cos_inr", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr)), ("dei", ("dei", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei)), ("dei-inr", ("dei_inr", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr)), ("vlan", ("vlan", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan)), ("vlan-inr", ("vlan_inr", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)), ("fr-dlci", ("fr_dlci", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci)), ("src-mac", ("src_mac", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac)), ("dst-mac", ("dst_mac", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac)), ("atm-clp", ("atm_clp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp)), ("fr-de", ("fr_de", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe)), ("ipv4-acl", ("ipv4_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl)), ("ipv6-acl", ("ipv6_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl)), ("ether-service-acl", ("ether_service_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl)), ("avail-id", ("avail_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId)), ("media-type", ("media_type", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType)), ("subs-protocol", ("subs_protocol", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol)), ("dnis", ("dnis", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis)), ("dnis-regex", ("dnis_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex)), ("domain", ("domain", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain)), ("domain-regex", ("domain_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex)), ("nas-port", ("nas_port", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort)), ("service-name", ("service_name", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName)), ("service-name-regex", ("service_name_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex)), ("src-addr-ipv4", ("src_addr_ipv4", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4)), ("dst-addr-ipv4", ("dst_addr_ipv4", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4)), ("src-addr-ipv6", ("src_addr_ipv6", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6)), ("dst-addr-ipv6", ("dst_addr_ipv6", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6)), ("src-addr-mac", ("src_addr_mac", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac)), ("timer", ("timer", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer)), ("timer-regexp", ("timer_regexp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp)), ("tunnel-name", ("tunnel_name", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName)), ("tunnel-name-regex", ("tunnel_name_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex)), ("user-name", ("user_name", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName)), ("user-name-regex", ("user_name_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex)), ("auth-username", ("auth_username", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername)), ("auth-username-regex", ("auth_username_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex)), ("unauth-username", ("unauth_username", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername)), ("unauth-username-regex", ("unauth_username_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex)), ("auth-domain", ("auth_domain", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain)), ("auth-domain-regex", ("auth_domain_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex)), ("unauth-domain", ("unauth_domain", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain)), ("unauth-domain-regex", ("unauth_domain_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex)), ("vendor-id", ("vendor_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId)), ("vendor-id-regex", ("vendor_id_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex)), ("access-interface", ("access_interface", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface)), ("input-interface", ("input_interface", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface)), ("input-intfhdl", ("input_intfhdl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl)), ("ethertype", ("ethertype", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype)), ("flow-key-data", ("flow_key_data", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData)), ("dhcp-client-id", ("dhcp_client_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId)), ("dhcp-client-id-regex", ("dhcp_client_id_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex)), ("circuit-id", ("circuit_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId)), ("circuit-id-regex", ("circuit_id_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex)), ("remote-id", ("remote_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId)), ("remote-id-regex", ("remote_id_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex)), ("src-port", ("src_port", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort)), ("dst-port", ("dst_port", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort))])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchTypeEn', '')])),
                                                                                                ('mpls_top_eos', (YLeaf(YType.uint8, 'mpls-top-eos'), ['int'])),
                                                                                                ('fragment_type', (YLeaf(YType.uint8, 'fragment-type'), ['int'])),
                                                                                                ('authen_status', (YLeaf(YType.enumeration, 'authen-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchAuthenStatusEn', '')])),
                                                                                                ('mlp_negotiated', (YLeaf(YType.enumeration, 'mlp-negotiated'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchMlpNegotiatedEn', '')])),
                                                                                            ])
                                                                                            self.type = None
                                                                                            self.mpls_top_eos = None
                                                                                            self.fragment_type = None
                                                                                            self.authen_status = None
                                                                                            self.mlp_negotiated = None

                                                                                            self.ipv4_dscp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                            self.ipv4_dscp.parent = self
                                                                                            self._children_name_map["ipv4_dscp"] = "ipv4-dscp"

                                                                                            self.ipv6_dscp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                            self.ipv6_dscp.parent = self
                                                                                            self._children_name_map["ipv6_dscp"] = "ipv6-dscp"

                                                                                            self.dscp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                            self.dscp.parent = self
                                                                                            self._children_name_map["dscp"] = "dscp"

                                                                                            self.ipv4_prec = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                            self.ipv4_prec.parent = self
                                                                                            self._children_name_map["ipv4_prec"] = "ipv4-prec"

                                                                                            self.ipv6_prec = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                            self.ipv6_prec.parent = self
                                                                                            self._children_name_map["ipv6_prec"] = "ipv6-prec"

                                                                                            self.prec = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                            self.prec.parent = self
                                                                                            self._children_name_map["prec"] = "prec"

                                                                                            self.discard_class = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                            self.discard_class.parent = self
                                                                                            self._children_name_map["discard_class"] = "discard-class"

                                                                                            self.qos_group = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                            self.qos_group.parent = self
                                                                                            self._children_name_map["qos_group"] = "qos-group"

                                                                                            self.traffic_class = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                            self.traffic_class.parent = self
                                                                                            self._children_name_map["traffic_class"] = "traffic-class"

                                                                                            self.proto = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                            self.proto.parent = self
                                                                                            self._children_name_map["proto"] = "proto"

                                                                                            self.icmp_v4 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                            self.icmp_v4.parent = self
                                                                                            self._children_name_map["icmp_v4"] = "icmp-v4"

                                                                                            self.icmp_v6 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                            self.icmp_v6.parent = self
                                                                                            self._children_name_map["icmp_v6"] = "icmp-v6"

                                                                                            self.ipv4_packet_len = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                            self.ipv4_packet_len.parent = self
                                                                                            self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"

                                                                                            self.ipv6_packet_len = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                            self.ipv6_packet_len.parent = self
                                                                                            self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"

                                                                                            self.packet_len = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                            self.packet_len.parent = self
                                                                                            self._children_name_map["packet_len"] = "packet-len"

                                                                                            self.flow_tag = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                            self.flow_tag.parent = self
                                                                                            self._children_name_map["flow_tag"] = "flow-tag"

                                                                                            self.tcp_flag = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                            self.tcp_flag.parent = self
                                                                                            self._children_name_map["tcp_flag"] = "tcp-flag"

                                                                                            self.icmpv4_type = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                            self.icmpv4_type.parent = self
                                                                                            self._children_name_map["icmpv4_type"] = "icmpv4-type"

                                                                                            self.icmpv4_code = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                            self.icmpv4_code.parent = self
                                                                                            self._children_name_map["icmpv4_code"] = "icmpv4-code"

                                                                                            self.icmpv6_type = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                            self.icmpv6_type.parent = self
                                                                                            self._children_name_map["icmpv6_type"] = "icmpv6-type"

                                                                                            self.icmpv6_code = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                            self.icmpv6_code.parent = self
                                                                                            self._children_name_map["icmpv6_code"] = "icmpv6-code"

                                                                                            self.mpls_exp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                            self.mpls_exp.parent = self
                                                                                            self._children_name_map["mpls_exp"] = "mpls-exp"

                                                                                            self.mpls_exp_imp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                            self.mpls_exp_imp.parent = self
                                                                                            self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"

                                                                                            self.mpls_disp_ipv4_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                            self.mpls_disp_ipv4_acl.parent = self
                                                                                            self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"

                                                                                            self.mpls_disp_ipv6_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                            self.mpls_disp_ipv6_acl.parent = self
                                                                                            self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"

                                                                                            self.mpls_top_label = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                            self.mpls_top_label.parent = self
                                                                                            self._children_name_map["mpls_top_label"] = "mpls-top-label"

                                                                                            self.cos = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                            self.cos.parent = self
                                                                                            self._children_name_map["cos"] = "cos"

                                                                                            self.cos_inr = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                            self.cos_inr.parent = self
                                                                                            self._children_name_map["cos_inr"] = "cos-inr"

                                                                                            self.dei = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                            self.dei.parent = self
                                                                                            self._children_name_map["dei"] = "dei"

                                                                                            self.dei_inr = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                            self.dei_inr.parent = self
                                                                                            self._children_name_map["dei_inr"] = "dei-inr"

                                                                                            self.vlan = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                            self.vlan.parent = self
                                                                                            self._children_name_map["vlan"] = "vlan"

                                                                                            self.vlan_inr = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                            self.vlan_inr.parent = self
                                                                                            self._children_name_map["vlan_inr"] = "vlan-inr"

                                                                                            self.fr_dlci = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                            self.fr_dlci.parent = self
                                                                                            self._children_name_map["fr_dlci"] = "fr-dlci"

                                                                                            self.src_mac = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                            self.src_mac.parent = self
                                                                                            self._children_name_map["src_mac"] = "src-mac"

                                                                                            self.dst_mac = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                            self.dst_mac.parent = self
                                                                                            self._children_name_map["dst_mac"] = "dst-mac"

                                                                                            self.atm_clp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                            self.atm_clp.parent = self
                                                                                            self._children_name_map["atm_clp"] = "atm-clp"

                                                                                            self.fr_de = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                            self.fr_de.parent = self
                                                                                            self._children_name_map["fr_de"] = "fr-de"

                                                                                            self.ipv4_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                            self.ipv4_acl.parent = self
                                                                                            self._children_name_map["ipv4_acl"] = "ipv4-acl"

                                                                                            self.ipv6_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                            self.ipv6_acl.parent = self
                                                                                            self._children_name_map["ipv6_acl"] = "ipv6-acl"

                                                                                            self.ether_service_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                            self.ether_service_acl.parent = self
                                                                                            self._children_name_map["ether_service_acl"] = "ether-service-acl"

                                                                                            self.avail_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                            self.avail_id.parent = self
                                                                                            self._children_name_map["avail_id"] = "avail-id"

                                                                                            self.media_type = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                            self.media_type.parent = self
                                                                                            self._children_name_map["media_type"] = "media-type"

                                                                                            self.subs_protocol = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                            self.subs_protocol.parent = self
                                                                                            self._children_name_map["subs_protocol"] = "subs-protocol"

                                                                                            self.dnis = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                            self.dnis.parent = self
                                                                                            self._children_name_map["dnis"] = "dnis"

                                                                                            self.dnis_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                            self.dnis_regex.parent = self
                                                                                            self._children_name_map["dnis_regex"] = "dnis-regex"

                                                                                            self.domain = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                            self.domain.parent = self
                                                                                            self._children_name_map["domain"] = "domain"

                                                                                            self.domain_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                            self.domain_regex.parent = self
                                                                                            self._children_name_map["domain_regex"] = "domain-regex"

                                                                                            self.nas_port = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                            self.nas_port.parent = self
                                                                                            self._children_name_map["nas_port"] = "nas-port"

                                                                                            self.service_name = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                            self.service_name.parent = self
                                                                                            self._children_name_map["service_name"] = "service-name"

                                                                                            self.service_name_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                            self.service_name_regex.parent = self
                                                                                            self._children_name_map["service_name_regex"] = "service-name-regex"

                                                                                            self.src_addr_ipv4 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                            self.src_addr_ipv4.parent = self
                                                                                            self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"

                                                                                            self.dst_addr_ipv4 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                            self.dst_addr_ipv4.parent = self
                                                                                            self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"

                                                                                            self.src_addr_ipv6 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                            self.src_addr_ipv6.parent = self
                                                                                            self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"

                                                                                            self.dst_addr_ipv6 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                            self.dst_addr_ipv6.parent = self
                                                                                            self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"

                                                                                            self.src_addr_mac = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                            self.src_addr_mac.parent = self
                                                                                            self._children_name_map["src_addr_mac"] = "src-addr-mac"

                                                                                            self.timer = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                            self.timer.parent = self
                                                                                            self._children_name_map["timer"] = "timer"

                                                                                            self.timer_regexp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                            self.timer_regexp.parent = self
                                                                                            self._children_name_map["timer_regexp"] = "timer-regexp"

                                                                                            self.tunnel_name = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                            self.tunnel_name.parent = self
                                                                                            self._children_name_map["tunnel_name"] = "tunnel-name"

                                                                                            self.tunnel_name_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                            self.tunnel_name_regex.parent = self
                                                                                            self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"

                                                                                            self.user_name = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                            self.user_name.parent = self
                                                                                            self._children_name_map["user_name"] = "user-name"

                                                                                            self.user_name_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                            self.user_name_regex.parent = self
                                                                                            self._children_name_map["user_name_regex"] = "user-name-regex"

                                                                                            self.auth_username = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                            self.auth_username.parent = self
                                                                                            self._children_name_map["auth_username"] = "auth-username"

                                                                                            self.auth_username_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                            self.auth_username_regex.parent = self
                                                                                            self._children_name_map["auth_username_regex"] = "auth-username-regex"

                                                                                            self.unauth_username = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                            self.unauth_username.parent = self
                                                                                            self._children_name_map["unauth_username"] = "unauth-username"

                                                                                            self.unauth_username_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                            self.unauth_username_regex.parent = self
                                                                                            self._children_name_map["unauth_username_regex"] = "unauth-username-regex"

                                                                                            self.auth_domain = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                            self.auth_domain.parent = self
                                                                                            self._children_name_map["auth_domain"] = "auth-domain"

                                                                                            self.auth_domain_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                            self.auth_domain_regex.parent = self
                                                                                            self._children_name_map["auth_domain_regex"] = "auth-domain-regex"

                                                                                            self.unauth_domain = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                            self.unauth_domain.parent = self
                                                                                            self._children_name_map["unauth_domain"] = "unauth-domain"

                                                                                            self.unauth_domain_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                            self.unauth_domain_regex.parent = self
                                                                                            self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"

                                                                                            self.vendor_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                            self.vendor_id.parent = self
                                                                                            self._children_name_map["vendor_id"] = "vendor-id"

                                                                                            self.vendor_id_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                            self.vendor_id_regex.parent = self
                                                                                            self._children_name_map["vendor_id_regex"] = "vendor-id-regex"

                                                                                            self.access_interface = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                            self.access_interface.parent = self
                                                                                            self._children_name_map["access_interface"] = "access-interface"

                                                                                            self.input_interface = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                            self.input_interface.parent = self
                                                                                            self._children_name_map["input_interface"] = "input-interface"

                                                                                            self.input_intfhdl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                            self.input_intfhdl.parent = self
                                                                                            self._children_name_map["input_intfhdl"] = "input-intfhdl"

                                                                                            self.ethertype = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                            self.ethertype.parent = self
                                                                                            self._children_name_map["ethertype"] = "ethertype"

                                                                                            self.flow_key_data = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                            self.flow_key_data.parent = self
                                                                                            self._children_name_map["flow_key_data"] = "flow-key-data"

                                                                                            self.dhcp_client_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                            self.dhcp_client_id.parent = self
                                                                                            self._children_name_map["dhcp_client_id"] = "dhcp-client-id"

                                                                                            self.dhcp_client_id_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                            self.dhcp_client_id_regex.parent = self
                                                                                            self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"

                                                                                            self.circuit_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                            self.circuit_id.parent = self
                                                                                            self._children_name_map["circuit_id"] = "circuit-id"

                                                                                            self.circuit_id_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                            self.circuit_id_regex.parent = self
                                                                                            self._children_name_map["circuit_id_regex"] = "circuit-id-regex"

                                                                                            self.remote_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                            self.remote_id.parent = self
                                                                                            self._children_name_map["remote_id"] = "remote-id"

                                                                                            self.remote_id_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                            self.remote_id_regex.parent = self
                                                                                            self._children_name_map["remote_id_regex"] = "remote-id-regex"

                                                                                            self.src_port = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                            self.src_port.parent = self
                                                                                            self._children_name_map["src_port"] = "src-port"

                                                                                            self.dst_port = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                            self.dst_port.parent = self
                                                                                            self._children_name_map["dst_port"] = "dst-port"
                                                                                            self._segment_path = lambda: "match-data"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['type', 'mpls_top_eos', 'fragment_type', 'authen_status', 'mlp_negotiated'], name, value)


                                                                                        class Ipv4Dscp(Entity):
                                                                                            """
                                                                                            IPv4 DSCP
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                self.yang_name = "ipv4-dscp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ipv4-dscp"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "ipv4-dscp"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                        class Ipv6Dscp(Entity):
                                                                                            """
                                                                                            IPv6 DSCP
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                self.yang_name = "ipv6-dscp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ipv6-dscp"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "ipv6-dscp"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                        class Dscp(Entity):
                                                                                            """
                                                                                            Match DSCP range array
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                self.yang_name = "dscp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "dscp"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "dscp"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                        class Ipv4Prec(Entity):
                                                                                            """
                                                                                            IPv4 Precedence
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                self.yang_name = "ipv4-prec"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "ipv4-prec"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                        class Ipv6Prec(Entity):
                                                                                            """
                                                                                            IPv6 Precedence
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                self.yang_name = "ipv6-prec"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "ipv6-prec"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                        class Prec(Entity):
                                                                                            """
                                                                                            Match Precedence array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                self.yang_name = "prec"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "prec"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                        class DiscardClass(Entity):
                                                                                            """
                                                                                            Match Discard Class array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                self.yang_name = "discard-class"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "discard-class"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                        class QosGroup(Entity):
                                                                                            """
                                                                                            Match QoS group array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                self.yang_name = "qos-group"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "qos-group"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "qos-group"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['min', 'max'], name, value)


                                                                                        class TrafficClass(Entity):
                                                                                            """
                                                                                            Match Traffic class array
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                self.yang_name = "traffic-class"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "traffic-class"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "traffic-class"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['min', 'max'], name, value)


                                                                                        class Proto(Entity):
                                                                                            """
                                                                                            Match Protocol array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                self.yang_name = "proto"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "proto"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "proto"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['min', 'max'], name, value)


                                                                                        class IcmpV4(Entity):
                                                                                            """
                                                                                            Match ICMPV4 Protocol
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	Protocol type
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: code
                                                                                            
                                                                                            	Protocol code
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                self.yang_name = "icmp-v4"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                    ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                ])
                                                                                                self.type = None
                                                                                                self.code = None
                                                                                                self._segment_path = lambda: "icmp-v4"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['type', 'code'], name, value)


                                                                                        class IcmpV6(Entity):
                                                                                            """
                                                                                            Match ICMPV6 Protocol array
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	Protocol type
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: code
                                                                                            
                                                                                            	Protocol code
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                self.yang_name = "icmp-v6"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                    ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                ])
                                                                                                self.type = None
                                                                                                self.code = None
                                                                                                self._segment_path = lambda: "icmp-v6"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['type', 'code'], name, value)


                                                                                        class Ipv4PacketLen(Entity):
                                                                                            """
                                                                                            IPv4 packet length array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                self.yang_name = "ipv4-packet-len"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ipv4-packet-len"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "ipv4-packet-len"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                        class Ipv6PacketLen(Entity):
                                                                                            """
                                                                                            IPv6 packet length array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                self.yang_name = "ipv6-packet-len"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ipv6-packet-len"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "ipv6-packet-len"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                        class PacketLen(Entity):
                                                                                            """
                                                                                            Match packet length array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                self.yang_name = "packet-len"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "packet-len"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "packet-len"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                        class FlowTag(Entity):
                                                                                            """
                                                                                            Match flow\-tag array
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                self.yang_name = "flow-tag"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "flow-tag"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "flow-tag"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['min', 'max'], name, value)


                                                                                        class TcpFlag(Entity):
                                                                                            """
                                                                                            Match tcp flag value
                                                                                            
                                                                                            .. attribute:: value
                                                                                            
                                                                                            	Value of TCP flag
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: match_any
                                                                                            
                                                                                            	Match any TCP flag bit
                                                                                            	**type**\: bool
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                self.yang_name = "tcp-flag"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                                    ('match_any', (YLeaf(YType.boolean, 'match-any'), ['bool'])),
                                                                                                ])
                                                                                                self.value = None
                                                                                                self.match_any = None
                                                                                                self._segment_path = lambda: "tcp-flag"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['value', 'match_any'], name, value)


                                                                                        class Icmpv4Type(Entity):
                                                                                            """
                                                                                            Match ipv4 icmp type
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                self.yang_name = "icmpv4-type"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "icmpv4-type"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "icmpv4-type"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                        class Icmpv4Code(Entity):
                                                                                            """
                                                                                            Match ipv4 icmp code
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                self.yang_name = "icmpv4-code"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "icmpv4-code"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "icmpv4-code"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                        class Icmpv6Type(Entity):
                                                                                            """
                                                                                            Match ipv6 icmp type
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                self.yang_name = "icmpv6-type"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "icmpv6-type"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "icmpv6-type"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                        class Icmpv6Code(Entity):
                                                                                            """
                                                                                            Match ipv6 icmp code
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                self.yang_name = "icmpv6-code"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "icmpv6-code"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "icmpv6-code"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                        class MplsExp(Entity):
                                                                                            """
                                                                                            Match MPLS experimental topmost array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                self.yang_name = "mpls-exp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "mpls-exp"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                        class MplsExpImp(Entity):
                                                                                            """
                                                                                            Match MPLS experimental imposition array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                self.yang_name = "mpls-exp-imp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "mpls-exp-imp"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                        class MplsDispIpv4Acl(Entity):
                                                                                            """
                                                                                            MPLS Disposition IPv4 Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "mpls-disp-ipv4-acl"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                        class MplsDispIpv6Acl(Entity):
                                                                                            """
                                                                                            MPLS Disposition IPv6 Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "mpls-disp-ipv6-acl"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                        class MplsTopLabel(Entity):
                                                                                            """
                                                                                            MPLS Topmost LABEL
                                                                                            
                                                                                            .. attribute:: uint32_rng_array
                                                                                            
                                                                                            	uint32 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                self.yang_name = "mpls-top-label"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint32_rng_array", ("uint32_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint32_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "mpls-top-label"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                            class Uint32RngArray(Entity):
                                                                                                """
                                                                                                uint32 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                    self.yang_name = "uint32_rng_array"
                                                                                                    self.yang_parent_name = "mpls-top-label"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint32, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint32, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint32_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['min', 'max'], name, value)


                                                                                        class Cos(Entity):
                                                                                            """
                                                                                            Match CoS array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                self.yang_name = "cos"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "cos"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                        class CosInr(Entity):
                                                                                            """
                                                                                            Match inner header CoS
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                self.yang_name = "cos-inr"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "cos-inr"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                        class Dei(Entity):
                                                                                            """
                                                                                            Match DEI Bit
                                                                                            
                                                                                            .. attribute:: bit_value
                                                                                            
                                                                                            	Value of the DEI bit
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                self.yang_name = "dei"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                ])
                                                                                                self.bit_value = None
                                                                                                self._segment_path = lambda: "dei"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                        class DeiInr(Entity):
                                                                                            """
                                                                                            Match inner DEI Bit
                                                                                            
                                                                                            .. attribute:: bit_value
                                                                                            
                                                                                            	Value of the DEI bit
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                self.yang_name = "dei-inr"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                ])
                                                                                                self.bit_value = None
                                                                                                self._segment_path = lambda: "dei-inr"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                        class Vlan(Entity):
                                                                                            """
                                                                                            Match VLAN array
                                                                                            
                                                                                            .. attribute:: vlan_id_array
                                                                                            
                                                                                            	vlan id array
                                                                                            	**type**\: list of  		 :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                self.yang_name = "vlan"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("vlan-id-array", ("vlan_id_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.vlan_id_array = YList(self)
                                                                                                self._segment_path = lambda: "vlan"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                            class VlanIdArray(Entity):
                                                                                                """
                                                                                                vlan id array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	VLAN mask
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                    self.yang_name = "vlan-id-array"
                                                                                                    self.yang_parent_name = "vlan"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ('mask', (YLeaf(YType.uint16, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self.mask = None
                                                                                                    self._segment_path = lambda: "vlan-id-array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['min', 'max', 'mask'], name, value)


                                                                                        class VlanInr(Entity):
                                                                                            """
                                                                                            Match inner header VLAN range array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                self.yang_name = "vlan-inr"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "vlan-inr"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "vlan-inr"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['min', 'max'], name, value)


                                                                                        class FrDlci(Entity):
                                                                                            """
                                                                                            Match FR DLCI range array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                self.yang_name = "fr-dlci"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "fr-dlci"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "fr-dlci"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['min', 'max'], name, value)


                                                                                        class SrcMac(Entity):
                                                                                            """
                                                                                            Match Source MAC address
                                                                                            
                                                                                            .. attribute:: mac_addr
                                                                                            
                                                                                            	MAC address
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	MAC mask
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                self.yang_name = "src-mac"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                    ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                ])
                                                                                                self.mac_addr = []
                                                                                                self.mask = []
                                                                                                self._segment_path = lambda: "src-mac"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                        class DstMac(Entity):
                                                                                            """
                                                                                            Match Destination MAC address
                                                                                            
                                                                                            .. attribute:: mac_addr
                                                                                            
                                                                                            	MAC address
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	MAC mask
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                self.yang_name = "dst-mac"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                    ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                ])
                                                                                                self.mac_addr = []
                                                                                                self.mask = []
                                                                                                self._segment_path = lambda: "dst-mac"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                        class AtmClp(Entity):
                                                                                            """
                                                                                            Match ATM CLP level
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                self.yang_name = "atm-clp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "atm-clp"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                        class FrDe(Entity):
                                                                                            """
                                                                                            Match FR DE value
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                self.yang_name = "fr-de"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "fr-de"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                        class Ipv4Acl(Entity):
                                                                                            """
                                                                                            IPv4 Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                self.yang_name = "ipv4-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "ipv4-acl"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                        class Ipv6Acl(Entity):
                                                                                            """
                                                                                            IPv6 Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                self.yang_name = "ipv6-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "ipv6-acl"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                        class EtherServiceAcl(Entity):
                                                                                            """
                                                                                            Ethernet\-Services Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                self.yang_name = "ether-service-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "ether-service-acl"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                        class AvailId(Entity):
                                                                                            """
                                                                                            Available Identifiers
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                self.yang_name = "avail-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "avail-id"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                        class MediaType(Entity):
                                                                                            """
                                                                                            Media Type
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                self.yang_name = "media-type"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "media-type"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                        class SubsProtocol(Entity):
                                                                                            """
                                                                                            Protocol
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                self.yang_name = "subs-protocol"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "subs-protocol"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                        class Dnis(Entity):
                                                                                            """
                                                                                            DNIS
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                self.yang_name = "dnis"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "dnis"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                        class DnisRegex(Entity):
                                                                                            """
                                                                                            DNIS Regular Expression
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                self.yang_name = "dnis-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "dnis-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                        class Domain(Entity):
                                                                                            """
                                                                                            Domain Name
                                                                                            
                                                                                            .. attribute:: domain_array
                                                                                            
                                                                                            	domain array
                                                                                            	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                self.yang_name = "domain"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.domain_array = YList(self)
                                                                                                self._segment_path = lambda: "domain"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                            class DomainArray(Entity):
                                                                                                """
                                                                                                domain array
                                                                                                
                                                                                                .. attribute:: domain_name
                                                                                                
                                                                                                	domain name
                                                                                                	**type**\: str
                                                                                                
                                                                                                .. attribute:: format_name
                                                                                                
                                                                                                	format name
                                                                                                	**type**\: str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                    self.yang_name = "domain-array"
                                                                                                    self.yang_parent_name = "domain"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                        ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                    ])
                                                                                                    self.domain_name = None
                                                                                                    self.format_name = None
                                                                                                    self._segment_path = lambda: "domain-array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                        class DomainRegex(Entity):
                                                                                            """
                                                                                            Domain Regular Expression
                                                                                            
                                                                                            .. attribute:: domain_array
                                                                                            
                                                                                            	domain array
                                                                                            	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                self.yang_name = "domain-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.domain_array = YList(self)
                                                                                                self._segment_path = lambda: "domain-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                            class DomainArray(Entity):
                                                                                                """
                                                                                                domain array
                                                                                                
                                                                                                .. attribute:: domain_name
                                                                                                
                                                                                                	domain name
                                                                                                	**type**\: str
                                                                                                
                                                                                                .. attribute:: format_name
                                                                                                
                                                                                                	format name
                                                                                                	**type**\: str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                    self.yang_name = "domain-array"
                                                                                                    self.yang_parent_name = "domain-regex"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                        ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                    ])
                                                                                                    self.domain_name = None
                                                                                                    self.format_name = None
                                                                                                    self._segment_path = lambda: "domain-array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                        class NasPort(Entity):
                                                                                            """
                                                                                            NAS Port
                                                                                            
                                                                                            .. attribute:: nas_port_array
                                                                                            
                                                                                            	nas port array
                                                                                            	**type**\: list of  		 :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                self.yang_name = "nas-port"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("nas-port-array", ("nas_port_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.nas_port_array = YList(self)
                                                                                                self._segment_path = lambda: "nas-port"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                            class NasPortArray(Entity):
                                                                                                """
                                                                                                nas port array
                                                                                                
                                                                                                .. attribute:: sub_id
                                                                                                
                                                                                                	sub id
                                                                                                	**type**\:  :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                
                                                                                                .. attribute:: operator
                                                                                                
                                                                                                	operator
                                                                                                	**type**\:  :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                
                                                                                                .. attribute:: value
                                                                                                
                                                                                                	value
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                    self.yang_name = "nas-port-array"
                                                                                                    self.yang_parent_name = "nas-port"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('sub_id', (YLeaf(YType.enumeration, 'sub-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchNasPortSubIdEn', '')])),
                                                                                                        ('operator', (YLeaf(YType.enumeration, 'operator'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchLogicalOperatorEn', '')])),
                                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                                    ])
                                                                                                    self.sub_id = None
                                                                                                    self.operator = None
                                                                                                    self.value = None
                                                                                                    self._segment_path = lambda: "nas-port-array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['sub_id', 'operator', 'value'], name, value)


                                                                                        class ServiceName(Entity):
                                                                                            """
                                                                                            Service Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                self.yang_name = "service-name"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "service-name"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                        class ServiceNameRegex(Entity):
                                                                                            """
                                                                                            Service Name Regular Exp
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                self.yang_name = "service-name-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "service-name-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                        class SrcAddrIpv4(Entity):
                                                                                            """
                                                                                            Source Address IPV4
                                                                                            
                                                                                            .. attribute:: ipv4_addr_array
                                                                                            
                                                                                            	ipv4 addr array
                                                                                            	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                self.yang_name = "src-addr-ipv4"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.ipv4_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "src-addr-ipv4"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                            class Ipv4AddrArray(Entity):
                                                                                                """
                                                                                                ipv4 addr array
                                                                                                
                                                                                                .. attribute:: prefix
                                                                                                
                                                                                                	prefix
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	mask
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                    self.yang_name = "ipv4-addr-array"
                                                                                                    self.yang_parent_name = "src-addr-ipv4"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                        ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                    ])
                                                                                                    self.prefix = None
                                                                                                    self.mask = None
                                                                                                    self._segment_path = lambda: "ipv4-addr-array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                        class DstAddrIpv4(Entity):
                                                                                            """
                                                                                            Destination Address IPV4
                                                                                            
                                                                                            .. attribute:: ipv4_addr_array
                                                                                            
                                                                                            	ipv4 addr array
                                                                                            	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                self.yang_name = "dst-addr-ipv4"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.ipv4_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "dst-addr-ipv4"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                            class Ipv4AddrArray(Entity):
                                                                                                """
                                                                                                ipv4 addr array
                                                                                                
                                                                                                .. attribute:: prefix
                                                                                                
                                                                                                	prefix
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	mask
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                    self.yang_name = "ipv4-addr-array"
                                                                                                    self.yang_parent_name = "dst-addr-ipv4"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                        ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                    ])
                                                                                                    self.prefix = None
                                                                                                    self.mask = None
                                                                                                    self._segment_path = lambda: "ipv4-addr-array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                        class SrcAddrIpv6(Entity):
                                                                                            """
                                                                                            Source Address IPV6
                                                                                            
                                                                                            .. attribute:: ipv6_addr_array
                                                                                            
                                                                                            	ipv6 addr array
                                                                                            	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                self.yang_name = "src-addr-ipv6"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.ipv6_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "src-addr-ipv6"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                            class Ipv6AddrArray(Entity):
                                                                                                """
                                                                                                ipv6 addr array
                                                                                                
                                                                                                .. attribute:: prefix
                                                                                                
                                                                                                	IPV6 prefix
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	IPV6 mask
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                    self.yang_name = "ipv6-addr-array"
                                                                                                    self.yang_parent_name = "src-addr-ipv6"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                        ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.prefix = None
                                                                                                    self.mask = None
                                                                                                    self._segment_path = lambda: "ipv6-addr-array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                        class DstAddrIpv6(Entity):
                                                                                            """
                                                                                            Destination Address IPV6
                                                                                            
                                                                                            .. attribute:: ipv6_addr_array
                                                                                            
                                                                                            	ipv6 addr array
                                                                                            	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                self.yang_name = "dst-addr-ipv6"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.ipv6_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "dst-addr-ipv6"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                            class Ipv6AddrArray(Entity):
                                                                                                """
                                                                                                ipv6 addr array
                                                                                                
                                                                                                .. attribute:: prefix
                                                                                                
                                                                                                	IPV6 prefix
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	IPV6 mask
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                    self.yang_name = "ipv6-addr-array"
                                                                                                    self.yang_parent_name = "dst-addr-ipv6"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                        ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.prefix = None
                                                                                                    self.mask = None
                                                                                                    self._segment_path = lambda: "ipv6-addr-array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                        class SrcAddrMac(Entity):
                                                                                            """
                                                                                            Source Address MAC
                                                                                            
                                                                                            .. attribute:: mac_addr_array
                                                                                            
                                                                                            	mac addr array
                                                                                            	**type**\: list of  		 :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                self.yang_name = "src-addr-mac"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("mac-addr-array", ("mac_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.mac_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "src-addr-mac"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                            class MacAddrArray(Entity):
                                                                                                """
                                                                                                mac addr array
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                    self.yang_name = "mac-addr-array"
                                                                                                    self.yang_parent_name = "src-addr-mac"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.mac_addr = []
                                                                                                    self.mask = []
                                                                                                    self._segment_path = lambda: "mac-addr-array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                        class Timer(Entity):
                                                                                            """
                                                                                            Timer
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                self.yang_name = "timer"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "timer"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                        class TimerRegexp(Entity):
                                                                                            """
                                                                                            Timer Regular Expression
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                self.yang_name = "timer-regexp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "timer-regexp"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                        class TunnelName(Entity):
                                                                                            """
                                                                                            Tunnel Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                self.yang_name = "tunnel-name"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "tunnel-name"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                        class TunnelNameRegex(Entity):
                                                                                            """
                                                                                            Tunnel Name Regular Expression
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                self.yang_name = "tunnel-name-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "tunnel-name-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                        class UserName(Entity):
                                                                                            """
                                                                                            User Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                self.yang_name = "user-name"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "user-name"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                        class UserNameRegex(Entity):
                                                                                            """
                                                                                            User Name Regular Expression
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                self.yang_name = "user-name-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "user-name-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                        class AuthUsername(Entity):
                                                                                            """
                                                                                            Authenticated User Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                self.yang_name = "auth-username"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "auth-username"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                        class AuthUsernameRegex(Entity):
                                                                                            """
                                                                                            Authenticated User Name RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                self.yang_name = "auth-username-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "auth-username-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                        class UnauthUsername(Entity):
                                                                                            """
                                                                                            Unauthenticated User Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                self.yang_name = "unauth-username"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "unauth-username"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                        class UnauthUsernameRegex(Entity):
                                                                                            """
                                                                                            Unauthenticated User Name RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                self.yang_name = "unauth-username-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "unauth-username-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                        class AuthDomain(Entity):
                                                                                            """
                                                                                            Authenticated domain name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                self.yang_name = "auth-domain"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "auth-domain"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                        class AuthDomainRegex(Entity):
                                                                                            """
                                                                                            Authenticated Domain Name RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                self.yang_name = "auth-domain-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "auth-domain-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                        class UnauthDomain(Entity):
                                                                                            """
                                                                                            Unauthenticated Domain Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                self.yang_name = "unauth-domain"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "unauth-domain"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                        class UnauthDomainRegex(Entity):
                                                                                            """
                                                                                            Unauthenticated Domain Name RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                self.yang_name = "unauth-domain-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "unauth-domain-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                        class VendorId(Entity):
                                                                                            """
                                                                                            Vendor ID
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                self.yang_name = "vendor-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "vendor-id"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                        class VendorIdRegex(Entity):
                                                                                            """
                                                                                            Vendor ID RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                self.yang_name = "vendor-id-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "vendor-id-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                        class AccessInterface(Entity):
                                                                                            """
                                                                                            Access interface
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                self.yang_name = "access-interface"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "access-interface"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                        class InputInterface(Entity):
                                                                                            """
                                                                                            Input interface
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                self.yang_name = "input-interface"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "input-interface"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                        class InputIntfhdl(Entity):
                                                                                            """
                                                                                            Input interface handle
                                                                                            
                                                                                            .. attribute:: uint64_array
                                                                                            
                                                                                            	uint64 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..18446744073709551615
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                self.yang_name = "input-intfhdl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint64_array', (YLeafList(YType.uint64, 'uint64_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint64_array = []
                                                                                                self._segment_path = lambda: "input-intfhdl"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                        class Ethertype(Entity):
                                                                                            """
                                                                                            Ethernet type
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                self.yang_name = "ethertype"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ethertype"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "ethertype"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['min', 'max'], name, value)


                                                                                        class FlowKeyData(Entity):
                                                                                            """
                                                                                            Flow key structure
                                                                                            
                                                                                            .. attribute:: flow_keys
                                                                                            
                                                                                            	flow keys
                                                                                            	**type**\:  :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                            
                                                                                            .. attribute:: max_count
                                                                                            
                                                                                            	Maximum count of flows
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: idle_timeout
                                                                                            
                                                                                            	Idle timeout of flows (in seconds)
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            	**units**\: second
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                self.yang_name = "flow-key-data"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("flow-keys", ("flow_keys", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys))])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('max_count', (YLeaf(YType.uint16, 'max-count'), ['int'])),
                                                                                                    ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                                                ])
                                                                                                self.max_count = None
                                                                                                self.idle_timeout = None

                                                                                                self.flow_keys = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                self.flow_keys.parent = self
                                                                                                self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                self._segment_path = lambda: "flow-key-data"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['max_count', 'idle_timeout'], name, value)


                                                                                            class FlowKeys(Entity):
                                                                                                """
                                                                                                flow keys
                                                                                                
                                                                                                .. attribute:: keys
                                                                                                
                                                                                                	keys
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                
                                                                                                .. attribute:: num
                                                                                                
                                                                                                	num
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                    self.yang_name = "flow-keys"
                                                                                                    self.yang_parent_name = "flow-key-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('keys', (YLeaf(YType.str, 'keys'), ['str'])),
                                                                                                        ('num', (YLeaf(YType.uint8, 'num'), ['int'])),
                                                                                                    ])
                                                                                                    self.keys = None
                                                                                                    self.num = None
                                                                                                    self._segment_path = lambda: "flow-keys"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                        class DhcpClientId(Entity):
                                                                                            """
                                                                                            Dhcp Client ID
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                self.yang_name = "dhcp-client-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "dhcp-client-id"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                        class DhcpClientIdRegex(Entity):
                                                                                            """
                                                                                            Dhcp Client ID RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                self.yang_name = "dhcp-client-id-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "dhcp-client-id-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                        class CircuitId(Entity):
                                                                                            """
                                                                                            Circuit ID
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                self.yang_name = "circuit-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "circuit-id"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                        class CircuitIdRegex(Entity):
                                                                                            """
                                                                                            Circuit ID RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                self.yang_name = "circuit-id-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "circuit-id-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                        class RemoteId(Entity):
                                                                                            """
                                                                                            Remote ID
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                self.yang_name = "remote-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "remote-id"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                        class RemoteIdRegex(Entity):
                                                                                            """
                                                                                            Remote ID RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                self.yang_name = "remote-id-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "remote-id-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                        class SrcPort(Entity):
                                                                                            """
                                                                                            Source port
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                self.yang_name = "src-port"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "src-port"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "src-port"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                                        class DstPort(Entity):
                                                                                            """
                                                                                            Destination port
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                self.yang_name = "dst-port"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "dst-port"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "dst-port"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                    class ExcdclassEncode(Entity):
                                                                        """
                                                                        excdclass encode
                                                                        
                                                                        .. attribute:: inline_cmap
                                                                        
                                                                        	inline cmap
                                                                        	**type**\:  :py:class:`InlineCmap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap>`
                                                                        
                                                                        .. attribute:: enc
                                                                        
                                                                        	enc
                                                                        	**type**\:  :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                        
                                                                        .. attribute:: class_name
                                                                        
                                                                        	class name
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..65
                                                                        
                                                                        .. attribute:: hd
                                                                        
                                                                        	hd
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: idx
                                                                        
                                                                        	idx
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode, self).__init__()

                                                                            self.yang_name = "excdclass-encode"
                                                                            self.yang_parent_name = "police"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("inline-cmap", ("inline_cmap", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap))])
                                                                            self._leafs = OrderedDict([
                                                                                ('enc', (YLeaf(YType.enumeration, 'enc'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyObjEncEn', '')])),
                                                                                ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                                                ('hd', (YLeaf(YType.uint64, 'hd'), ['int'])),
                                                                                ('idx', (YLeaf(YType.uint8, 'idx'), ['int'])),
                                                                            ])
                                                                            self.enc = None
                                                                            self.class_name = None
                                                                            self.hd = None
                                                                            self.idx = None

                                                                            self.inline_cmap = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap()
                                                                            self.inline_cmap.parent = self
                                                                            self._children_name_map["inline_cmap"] = "inline-cmap"
                                                                            self._segment_path = lambda: "excdclass-encode"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode, ['enc', 'class_name', 'hd', 'idx'], name, value)


                                                                        class InlineCmap(Entity):
                                                                            """
                                                                            inline cmap
                                                                            
                                                                            .. attribute:: match_infop
                                                                            
                                                                            	Pointer to the first Match info
                                                                            	**type**\:  :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop>`
                                                                            
                                                                            .. attribute:: mode
                                                                            
                                                                            	Inline Class\-Map Mode Match any/all
                                                                            	**type**\:  :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                            
                                                                            .. attribute:: flags
                                                                            
                                                                            	Inline Class\-Map flags
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: match_count
                                                                            
                                                                            	Number of Match infos
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap, self).__init__()

                                                                                self.yang_name = "inline-cmap"
                                                                                self.yang_parent_name = "excdclass-encode"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("match-infop", ("match_infop", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapModeEn', '')])),
                                                                                    ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                    ('match_count', (YLeaf(YType.uint32, 'match-count'), ['int'])),
                                                                                ])
                                                                                self.mode = None
                                                                                self.flags = None
                                                                                self.match_count = None

                                                                                self.match_infop = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop()
                                                                                self.match_infop.parent = self
                                                                                self._children_name_map["match_infop"] = "match-infop"
                                                                                self._segment_path = lambda: "inline-cmap"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap, ['mode', 'flags', 'match_count'], name, value)


                                                                            class MatchInfop(Entity):
                                                                                """
                                                                                Pointer to the first Match info
                                                                                
                                                                                .. attribute:: class_match_info_st
                                                                                
                                                                                	class match info st
                                                                                	**type**\: list of  		 :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop, self).__init__()

                                                                                    self.yang_name = "match-infop"
                                                                                    self.yang_parent_name = "inline-cmap"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("class-match-info-st", ("class_match_info_st", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.class_match_info_st = YList(self)
                                                                                    self._segment_path = lambda: "match-infop"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop, [], name, value)


                                                                                class ClassMatchInfoSt(Entity):
                                                                                    """
                                                                                    class match info st
                                                                                    
                                                                                    .. attribute:: match_data
                                                                                    
                                                                                    	Match criteria
                                                                                    	**type**\:  :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                    
                                                                                    .. attribute:: flags
                                                                                    
                                                                                    	Flags
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                        self.yang_name = "class-match-info-st"
                                                                                        self.yang_parent_name = "match-infop"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("match-data", ("match_data", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData))])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                        ])
                                                                                        self.flags = None

                                                                                        self.match_data = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                        self.match_data.parent = self
                                                                                        self._children_name_map["match_data"] = "match-data"
                                                                                        self._segment_path = lambda: "class-match-info-st"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                    class MatchData(Entity):
                                                                                        """
                                                                                        Match criteria
                                                                                        
                                                                                        .. attribute:: ipv4_dscp
                                                                                        
                                                                                        	IPv4 DSCP
                                                                                        	**type**\:  :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                        
                                                                                        .. attribute:: ipv6_dscp
                                                                                        
                                                                                        	IPv6 DSCP
                                                                                        	**type**\:  :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                        
                                                                                        .. attribute:: dscp
                                                                                        
                                                                                        	Match DSCP range array
                                                                                        	**type**\:  :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                        
                                                                                        .. attribute:: ipv4_prec
                                                                                        
                                                                                        	IPv4 Precedence
                                                                                        	**type**\:  :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                        
                                                                                        .. attribute:: ipv6_prec
                                                                                        
                                                                                        	IPv6 Precedence
                                                                                        	**type**\:  :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                        
                                                                                        .. attribute:: prec
                                                                                        
                                                                                        	Match Precedence array
                                                                                        	**type**\:  :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                        
                                                                                        .. attribute:: discard_class
                                                                                        
                                                                                        	Match Discard Class array
                                                                                        	**type**\:  :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                        
                                                                                        .. attribute:: qos_group
                                                                                        
                                                                                        	Match QoS group array
                                                                                        	**type**\:  :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                        
                                                                                        .. attribute:: traffic_class
                                                                                        
                                                                                        	Match Traffic class array
                                                                                        	**type**\:  :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                        
                                                                                        .. attribute:: proto
                                                                                        
                                                                                        	Match Protocol array
                                                                                        	**type**\:  :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                        
                                                                                        .. attribute:: icmp_v4
                                                                                        
                                                                                        	Match ICMPV4 Protocol
                                                                                        	**type**\:  :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                        
                                                                                        .. attribute:: icmp_v6
                                                                                        
                                                                                        	Match ICMPV6 Protocol array
                                                                                        	**type**\:  :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                        
                                                                                        .. attribute:: ipv4_packet_len
                                                                                        
                                                                                        	IPv4 packet length array
                                                                                        	**type**\:  :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                        
                                                                                        .. attribute:: ipv6_packet_len
                                                                                        
                                                                                        	IPv6 packet length array
                                                                                        	**type**\:  :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                        
                                                                                        .. attribute:: packet_len
                                                                                        
                                                                                        	Match packet length array
                                                                                        	**type**\:  :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                        
                                                                                        .. attribute:: flow_tag
                                                                                        
                                                                                        	Match flow\-tag array
                                                                                        	**type**\:  :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                        
                                                                                        .. attribute:: tcp_flag
                                                                                        
                                                                                        	Match tcp flag value
                                                                                        	**type**\:  :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                        
                                                                                        .. attribute:: icmpv4_type
                                                                                        
                                                                                        	Match ipv4 icmp type
                                                                                        	**type**\:  :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                        
                                                                                        .. attribute:: icmpv4_code
                                                                                        
                                                                                        	Match ipv4 icmp code
                                                                                        	**type**\:  :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                        
                                                                                        .. attribute:: icmpv6_type
                                                                                        
                                                                                        	Match ipv6 icmp type
                                                                                        	**type**\:  :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                        
                                                                                        .. attribute:: icmpv6_code
                                                                                        
                                                                                        	Match ipv6 icmp code
                                                                                        	**type**\:  :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                        
                                                                                        .. attribute:: mpls_exp
                                                                                        
                                                                                        	Match MPLS experimental topmost array
                                                                                        	**type**\:  :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                        
                                                                                        .. attribute:: mpls_exp_imp
                                                                                        
                                                                                        	Match MPLS experimental imposition array
                                                                                        	**type**\:  :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                        
                                                                                        .. attribute:: mpls_disp_ipv4_acl
                                                                                        
                                                                                        	MPLS Disposition IPv4 Access\-list
                                                                                        	**type**\:  :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                        
                                                                                        .. attribute:: mpls_disp_ipv6_acl
                                                                                        
                                                                                        	MPLS Disposition IPv6 Access\-list
                                                                                        	**type**\:  :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                        
                                                                                        .. attribute:: mpls_top_label
                                                                                        
                                                                                        	MPLS Topmost LABEL
                                                                                        	**type**\:  :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                        
                                                                                        .. attribute:: cos
                                                                                        
                                                                                        	Match CoS array
                                                                                        	**type**\:  :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                        
                                                                                        .. attribute:: cos_inr
                                                                                        
                                                                                        	Match inner header CoS
                                                                                        	**type**\:  :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                        
                                                                                        .. attribute:: dei
                                                                                        
                                                                                        	Match DEI Bit
                                                                                        	**type**\:  :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                        
                                                                                        .. attribute:: dei_inr
                                                                                        
                                                                                        	Match inner DEI Bit
                                                                                        	**type**\:  :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                        
                                                                                        .. attribute:: vlan
                                                                                        
                                                                                        	Match VLAN array
                                                                                        	**type**\:  :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                        
                                                                                        .. attribute:: vlan_inr
                                                                                        
                                                                                        	Match inner header VLAN range array
                                                                                        	**type**\:  :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                        
                                                                                        .. attribute:: fr_dlci
                                                                                        
                                                                                        	Match FR DLCI range array
                                                                                        	**type**\:  :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                        
                                                                                        .. attribute:: src_mac
                                                                                        
                                                                                        	Match Source MAC address
                                                                                        	**type**\:  :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                        
                                                                                        .. attribute:: dst_mac
                                                                                        
                                                                                        	Match Destination MAC address
                                                                                        	**type**\:  :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                        
                                                                                        .. attribute:: atm_clp
                                                                                        
                                                                                        	Match ATM CLP level
                                                                                        	**type**\:  :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                        
                                                                                        .. attribute:: fr_de
                                                                                        
                                                                                        	Match FR DE value
                                                                                        	**type**\:  :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                        
                                                                                        .. attribute:: ipv4_acl
                                                                                        
                                                                                        	IPv4 Access\-list
                                                                                        	**type**\:  :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                        
                                                                                        .. attribute:: ipv6_acl
                                                                                        
                                                                                        	IPv6 Access\-list
                                                                                        	**type**\:  :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                        
                                                                                        .. attribute:: ether_service_acl
                                                                                        
                                                                                        	Ethernet\-Services Access\-list
                                                                                        	**type**\:  :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                        
                                                                                        .. attribute:: avail_id
                                                                                        
                                                                                        	Available Identifiers
                                                                                        	**type**\:  :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                        
                                                                                        .. attribute:: media_type
                                                                                        
                                                                                        	Media Type
                                                                                        	**type**\:  :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                        
                                                                                        .. attribute:: subs_protocol
                                                                                        
                                                                                        	Protocol
                                                                                        	**type**\:  :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                        
                                                                                        .. attribute:: dnis
                                                                                        
                                                                                        	DNIS
                                                                                        	**type**\:  :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                        
                                                                                        .. attribute:: dnis_regex
                                                                                        
                                                                                        	DNIS Regular Expression
                                                                                        	**type**\:  :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                        
                                                                                        .. attribute:: domain
                                                                                        
                                                                                        	Domain Name
                                                                                        	**type**\:  :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                        
                                                                                        .. attribute:: domain_regex
                                                                                        
                                                                                        	Domain Regular Expression
                                                                                        	**type**\:  :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                        
                                                                                        .. attribute:: nas_port
                                                                                        
                                                                                        	NAS Port
                                                                                        	**type**\:  :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                        
                                                                                        .. attribute:: service_name
                                                                                        
                                                                                        	Service Name
                                                                                        	**type**\:  :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                        
                                                                                        .. attribute:: service_name_regex
                                                                                        
                                                                                        	Service Name Regular Exp
                                                                                        	**type**\:  :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                        
                                                                                        .. attribute:: src_addr_ipv4
                                                                                        
                                                                                        	Source Address IPV4
                                                                                        	**type**\:  :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                        
                                                                                        .. attribute:: dst_addr_ipv4
                                                                                        
                                                                                        	Destination Address IPV4
                                                                                        	**type**\:  :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                        
                                                                                        .. attribute:: src_addr_ipv6
                                                                                        
                                                                                        	Source Address IPV6
                                                                                        	**type**\:  :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                        
                                                                                        .. attribute:: dst_addr_ipv6
                                                                                        
                                                                                        	Destination Address IPV6
                                                                                        	**type**\:  :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                        
                                                                                        .. attribute:: src_addr_mac
                                                                                        
                                                                                        	Source Address MAC
                                                                                        	**type**\:  :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                        
                                                                                        .. attribute:: timer
                                                                                        
                                                                                        	Timer
                                                                                        	**type**\:  :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                        
                                                                                        .. attribute:: timer_regexp
                                                                                        
                                                                                        	Timer Regular Expression
                                                                                        	**type**\:  :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                        
                                                                                        .. attribute:: tunnel_name
                                                                                        
                                                                                        	Tunnel Name
                                                                                        	**type**\:  :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                        
                                                                                        .. attribute:: tunnel_name_regex
                                                                                        
                                                                                        	Tunnel Name Regular Expression
                                                                                        	**type**\:  :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                        
                                                                                        .. attribute:: user_name
                                                                                        
                                                                                        	User Name
                                                                                        	**type**\:  :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                        
                                                                                        .. attribute:: user_name_regex
                                                                                        
                                                                                        	User Name Regular Expression
                                                                                        	**type**\:  :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                        
                                                                                        .. attribute:: auth_username
                                                                                        
                                                                                        	Authenticated User Name
                                                                                        	**type**\:  :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                        
                                                                                        .. attribute:: auth_username_regex
                                                                                        
                                                                                        	Authenticated User Name RegEx
                                                                                        	**type**\:  :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                        
                                                                                        .. attribute:: unauth_username
                                                                                        
                                                                                        	Unauthenticated User Name
                                                                                        	**type**\:  :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                        
                                                                                        .. attribute:: unauth_username_regex
                                                                                        
                                                                                        	Unauthenticated User Name RegEx
                                                                                        	**type**\:  :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                        
                                                                                        .. attribute:: auth_domain
                                                                                        
                                                                                        	Authenticated domain name
                                                                                        	**type**\:  :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                        
                                                                                        .. attribute:: auth_domain_regex
                                                                                        
                                                                                        	Authenticated Domain Name RegEx
                                                                                        	**type**\:  :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                        
                                                                                        .. attribute:: unauth_domain
                                                                                        
                                                                                        	Unauthenticated Domain Name
                                                                                        	**type**\:  :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                        
                                                                                        .. attribute:: unauth_domain_regex
                                                                                        
                                                                                        	Unauthenticated Domain Name RegEx
                                                                                        	**type**\:  :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                        
                                                                                        .. attribute:: vendor_id
                                                                                        
                                                                                        	Vendor ID
                                                                                        	**type**\:  :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                        
                                                                                        .. attribute:: vendor_id_regex
                                                                                        
                                                                                        	Vendor ID RegEx
                                                                                        	**type**\:  :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                        
                                                                                        .. attribute:: access_interface
                                                                                        
                                                                                        	Access interface
                                                                                        	**type**\:  :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                        
                                                                                        .. attribute:: input_interface
                                                                                        
                                                                                        	Input interface
                                                                                        	**type**\:  :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                        
                                                                                        .. attribute:: input_intfhdl
                                                                                        
                                                                                        	Input interface handle
                                                                                        	**type**\:  :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                        
                                                                                        .. attribute:: ethertype
                                                                                        
                                                                                        	Ethernet type
                                                                                        	**type**\:  :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                        
                                                                                        .. attribute:: flow_key_data
                                                                                        
                                                                                        	Flow key structure
                                                                                        	**type**\:  :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                        
                                                                                        .. attribute:: dhcp_client_id
                                                                                        
                                                                                        	Dhcp Client ID
                                                                                        	**type**\:  :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                        
                                                                                        .. attribute:: dhcp_client_id_regex
                                                                                        
                                                                                        	Dhcp Client ID RegEx
                                                                                        	**type**\:  :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                        
                                                                                        .. attribute:: circuit_id
                                                                                        
                                                                                        	Circuit ID
                                                                                        	**type**\:  :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                        
                                                                                        .. attribute:: circuit_id_regex
                                                                                        
                                                                                        	Circuit ID RegEx
                                                                                        	**type**\:  :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                        
                                                                                        .. attribute:: remote_id
                                                                                        
                                                                                        	Remote ID
                                                                                        	**type**\:  :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                        
                                                                                        .. attribute:: remote_id_regex
                                                                                        
                                                                                        	Remote ID RegEx
                                                                                        	**type**\:  :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                        
                                                                                        .. attribute:: src_port
                                                                                        
                                                                                        	Source port
                                                                                        	**type**\:  :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                        
                                                                                        .. attribute:: dst_port
                                                                                        
                                                                                        	Destination port
                                                                                        	**type**\:  :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                        
                                                                                        .. attribute:: type
                                                                                        
                                                                                        	type
                                                                                        	**type**\:  :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                        
                                                                                        .. attribute:: mpls_top_eos
                                                                                        
                                                                                        	MPLS Topmost EOS
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: fragment_type
                                                                                        
                                                                                        	Fragment type
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: authen_status
                                                                                        
                                                                                        	Authentication Status
                                                                                        	**type**\:  :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                        
                                                                                        .. attribute:: mlp_negotiated
                                                                                        
                                                                                        	MLP Negotiated
                                                                                        	**type**\:  :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                            self.yang_name = "match-data"
                                                                                            self.yang_parent_name = "class-match-info-st"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("ipv4-dscp", ("ipv4_dscp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp)), ("ipv6-dscp", ("ipv6_dscp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp)), ("dscp", ("dscp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp)), ("ipv4-prec", ("ipv4_prec", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec)), ("ipv6-prec", ("ipv6_prec", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec)), ("prec", ("prec", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec)), ("discard-class", ("discard_class", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass)), ("qos-group", ("qos_group", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup)), ("traffic-class", ("traffic_class", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass)), ("proto", ("proto", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto)), ("icmp-v4", ("icmp_v4", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4)), ("icmp-v6", ("icmp_v6", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6)), ("ipv4-packet-len", ("ipv4_packet_len", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen)), ("ipv6-packet-len", ("ipv6_packet_len", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen)), ("packet-len", ("packet_len", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen)), ("flow-tag", ("flow_tag", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag)), ("tcp-flag", ("tcp_flag", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag)), ("icmpv4-type", ("icmpv4_type", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type)), ("icmpv4-code", ("icmpv4_code", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code)), ("icmpv6-type", ("icmpv6_type", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type)), ("icmpv6-code", ("icmpv6_code", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code)), ("mpls-exp", ("mpls_exp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp)), ("mpls-exp-imp", ("mpls_exp_imp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp)), ("mpls-disp-ipv4-acl", ("mpls_disp_ipv4_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl)), ("mpls-disp-ipv6-acl", ("mpls_disp_ipv6_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl)), ("mpls-top-label", ("mpls_top_label", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel)), ("cos", ("cos", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos)), ("cos-inr", ("cos_inr", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr)), ("dei", ("dei", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei)), ("dei-inr", ("dei_inr", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr)), ("vlan", ("vlan", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan)), ("vlan-inr", ("vlan_inr", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)), ("fr-dlci", ("fr_dlci", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci)), ("src-mac", ("src_mac", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac)), ("dst-mac", ("dst_mac", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac)), ("atm-clp", ("atm_clp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp)), ("fr-de", ("fr_de", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe)), ("ipv4-acl", ("ipv4_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl)), ("ipv6-acl", ("ipv6_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl)), ("ether-service-acl", ("ether_service_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl)), ("avail-id", ("avail_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId)), ("media-type", ("media_type", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType)), ("subs-protocol", ("subs_protocol", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol)), ("dnis", ("dnis", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis)), ("dnis-regex", ("dnis_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex)), ("domain", ("domain", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain)), ("domain-regex", ("domain_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex)), ("nas-port", ("nas_port", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort)), ("service-name", ("service_name", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName)), ("service-name-regex", ("service_name_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex)), ("src-addr-ipv4", ("src_addr_ipv4", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4)), ("dst-addr-ipv4", ("dst_addr_ipv4", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4)), ("src-addr-ipv6", ("src_addr_ipv6", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6)), ("dst-addr-ipv6", ("dst_addr_ipv6", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6)), ("src-addr-mac", ("src_addr_mac", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac)), ("timer", ("timer", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer)), ("timer-regexp", ("timer_regexp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp)), ("tunnel-name", ("tunnel_name", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName)), ("tunnel-name-regex", ("tunnel_name_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex)), ("user-name", ("user_name", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName)), ("user-name-regex", ("user_name_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex)), ("auth-username", ("auth_username", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername)), ("auth-username-regex", ("auth_username_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex)), ("unauth-username", ("unauth_username", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername)), ("unauth-username-regex", ("unauth_username_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex)), ("auth-domain", ("auth_domain", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain)), ("auth-domain-regex", ("auth_domain_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex)), ("unauth-domain", ("unauth_domain", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain)), ("unauth-domain-regex", ("unauth_domain_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex)), ("vendor-id", ("vendor_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId)), ("vendor-id-regex", ("vendor_id_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex)), ("access-interface", ("access_interface", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface)), ("input-interface", ("input_interface", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface)), ("input-intfhdl", ("input_intfhdl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl)), ("ethertype", ("ethertype", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype)), ("flow-key-data", ("flow_key_data", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData)), ("dhcp-client-id", ("dhcp_client_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId)), ("dhcp-client-id-regex", ("dhcp_client_id_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex)), ("circuit-id", ("circuit_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId)), ("circuit-id-regex", ("circuit_id_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex)), ("remote-id", ("remote_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId)), ("remote-id-regex", ("remote_id_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex)), ("src-port", ("src_port", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort)), ("dst-port", ("dst_port", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort))])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchTypeEn', '')])),
                                                                                                ('mpls_top_eos', (YLeaf(YType.uint8, 'mpls-top-eos'), ['int'])),
                                                                                                ('fragment_type', (YLeaf(YType.uint8, 'fragment-type'), ['int'])),
                                                                                                ('authen_status', (YLeaf(YType.enumeration, 'authen-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchAuthenStatusEn', '')])),
                                                                                                ('mlp_negotiated', (YLeaf(YType.enumeration, 'mlp-negotiated'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchMlpNegotiatedEn', '')])),
                                                                                            ])
                                                                                            self.type = None
                                                                                            self.mpls_top_eos = None
                                                                                            self.fragment_type = None
                                                                                            self.authen_status = None
                                                                                            self.mlp_negotiated = None

                                                                                            self.ipv4_dscp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                            self.ipv4_dscp.parent = self
                                                                                            self._children_name_map["ipv4_dscp"] = "ipv4-dscp"

                                                                                            self.ipv6_dscp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                            self.ipv6_dscp.parent = self
                                                                                            self._children_name_map["ipv6_dscp"] = "ipv6-dscp"

                                                                                            self.dscp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                            self.dscp.parent = self
                                                                                            self._children_name_map["dscp"] = "dscp"

                                                                                            self.ipv4_prec = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                            self.ipv4_prec.parent = self
                                                                                            self._children_name_map["ipv4_prec"] = "ipv4-prec"

                                                                                            self.ipv6_prec = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                            self.ipv6_prec.parent = self
                                                                                            self._children_name_map["ipv6_prec"] = "ipv6-prec"

                                                                                            self.prec = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                            self.prec.parent = self
                                                                                            self._children_name_map["prec"] = "prec"

                                                                                            self.discard_class = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                            self.discard_class.parent = self
                                                                                            self._children_name_map["discard_class"] = "discard-class"

                                                                                            self.qos_group = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                            self.qos_group.parent = self
                                                                                            self._children_name_map["qos_group"] = "qos-group"

                                                                                            self.traffic_class = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                            self.traffic_class.parent = self
                                                                                            self._children_name_map["traffic_class"] = "traffic-class"

                                                                                            self.proto = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                            self.proto.parent = self
                                                                                            self._children_name_map["proto"] = "proto"

                                                                                            self.icmp_v4 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                            self.icmp_v4.parent = self
                                                                                            self._children_name_map["icmp_v4"] = "icmp-v4"

                                                                                            self.icmp_v6 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                            self.icmp_v6.parent = self
                                                                                            self._children_name_map["icmp_v6"] = "icmp-v6"

                                                                                            self.ipv4_packet_len = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                            self.ipv4_packet_len.parent = self
                                                                                            self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"

                                                                                            self.ipv6_packet_len = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                            self.ipv6_packet_len.parent = self
                                                                                            self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"

                                                                                            self.packet_len = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                            self.packet_len.parent = self
                                                                                            self._children_name_map["packet_len"] = "packet-len"

                                                                                            self.flow_tag = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                            self.flow_tag.parent = self
                                                                                            self._children_name_map["flow_tag"] = "flow-tag"

                                                                                            self.tcp_flag = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                            self.tcp_flag.parent = self
                                                                                            self._children_name_map["tcp_flag"] = "tcp-flag"

                                                                                            self.icmpv4_type = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                            self.icmpv4_type.parent = self
                                                                                            self._children_name_map["icmpv4_type"] = "icmpv4-type"

                                                                                            self.icmpv4_code = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                            self.icmpv4_code.parent = self
                                                                                            self._children_name_map["icmpv4_code"] = "icmpv4-code"

                                                                                            self.icmpv6_type = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                            self.icmpv6_type.parent = self
                                                                                            self._children_name_map["icmpv6_type"] = "icmpv6-type"

                                                                                            self.icmpv6_code = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                            self.icmpv6_code.parent = self
                                                                                            self._children_name_map["icmpv6_code"] = "icmpv6-code"

                                                                                            self.mpls_exp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                            self.mpls_exp.parent = self
                                                                                            self._children_name_map["mpls_exp"] = "mpls-exp"

                                                                                            self.mpls_exp_imp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                            self.mpls_exp_imp.parent = self
                                                                                            self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"

                                                                                            self.mpls_disp_ipv4_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                            self.mpls_disp_ipv4_acl.parent = self
                                                                                            self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"

                                                                                            self.mpls_disp_ipv6_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                            self.mpls_disp_ipv6_acl.parent = self
                                                                                            self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"

                                                                                            self.mpls_top_label = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                            self.mpls_top_label.parent = self
                                                                                            self._children_name_map["mpls_top_label"] = "mpls-top-label"

                                                                                            self.cos = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                            self.cos.parent = self
                                                                                            self._children_name_map["cos"] = "cos"

                                                                                            self.cos_inr = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                            self.cos_inr.parent = self
                                                                                            self._children_name_map["cos_inr"] = "cos-inr"

                                                                                            self.dei = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                            self.dei.parent = self
                                                                                            self._children_name_map["dei"] = "dei"

                                                                                            self.dei_inr = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                            self.dei_inr.parent = self
                                                                                            self._children_name_map["dei_inr"] = "dei-inr"

                                                                                            self.vlan = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                            self.vlan.parent = self
                                                                                            self._children_name_map["vlan"] = "vlan"

                                                                                            self.vlan_inr = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                            self.vlan_inr.parent = self
                                                                                            self._children_name_map["vlan_inr"] = "vlan-inr"

                                                                                            self.fr_dlci = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                            self.fr_dlci.parent = self
                                                                                            self._children_name_map["fr_dlci"] = "fr-dlci"

                                                                                            self.src_mac = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                            self.src_mac.parent = self
                                                                                            self._children_name_map["src_mac"] = "src-mac"

                                                                                            self.dst_mac = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                            self.dst_mac.parent = self
                                                                                            self._children_name_map["dst_mac"] = "dst-mac"

                                                                                            self.atm_clp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                            self.atm_clp.parent = self
                                                                                            self._children_name_map["atm_clp"] = "atm-clp"

                                                                                            self.fr_de = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                            self.fr_de.parent = self
                                                                                            self._children_name_map["fr_de"] = "fr-de"

                                                                                            self.ipv4_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                            self.ipv4_acl.parent = self
                                                                                            self._children_name_map["ipv4_acl"] = "ipv4-acl"

                                                                                            self.ipv6_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                            self.ipv6_acl.parent = self
                                                                                            self._children_name_map["ipv6_acl"] = "ipv6-acl"

                                                                                            self.ether_service_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                            self.ether_service_acl.parent = self
                                                                                            self._children_name_map["ether_service_acl"] = "ether-service-acl"

                                                                                            self.avail_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                            self.avail_id.parent = self
                                                                                            self._children_name_map["avail_id"] = "avail-id"

                                                                                            self.media_type = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                            self.media_type.parent = self
                                                                                            self._children_name_map["media_type"] = "media-type"

                                                                                            self.subs_protocol = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                            self.subs_protocol.parent = self
                                                                                            self._children_name_map["subs_protocol"] = "subs-protocol"

                                                                                            self.dnis = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                            self.dnis.parent = self
                                                                                            self._children_name_map["dnis"] = "dnis"

                                                                                            self.dnis_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                            self.dnis_regex.parent = self
                                                                                            self._children_name_map["dnis_regex"] = "dnis-regex"

                                                                                            self.domain = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                            self.domain.parent = self
                                                                                            self._children_name_map["domain"] = "domain"

                                                                                            self.domain_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                            self.domain_regex.parent = self
                                                                                            self._children_name_map["domain_regex"] = "domain-regex"

                                                                                            self.nas_port = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                            self.nas_port.parent = self
                                                                                            self._children_name_map["nas_port"] = "nas-port"

                                                                                            self.service_name = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                            self.service_name.parent = self
                                                                                            self._children_name_map["service_name"] = "service-name"

                                                                                            self.service_name_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                            self.service_name_regex.parent = self
                                                                                            self._children_name_map["service_name_regex"] = "service-name-regex"

                                                                                            self.src_addr_ipv4 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                            self.src_addr_ipv4.parent = self
                                                                                            self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"

                                                                                            self.dst_addr_ipv4 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                            self.dst_addr_ipv4.parent = self
                                                                                            self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"

                                                                                            self.src_addr_ipv6 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                            self.src_addr_ipv6.parent = self
                                                                                            self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"

                                                                                            self.dst_addr_ipv6 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                            self.dst_addr_ipv6.parent = self
                                                                                            self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"

                                                                                            self.src_addr_mac = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                            self.src_addr_mac.parent = self
                                                                                            self._children_name_map["src_addr_mac"] = "src-addr-mac"

                                                                                            self.timer = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                            self.timer.parent = self
                                                                                            self._children_name_map["timer"] = "timer"

                                                                                            self.timer_regexp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                            self.timer_regexp.parent = self
                                                                                            self._children_name_map["timer_regexp"] = "timer-regexp"

                                                                                            self.tunnel_name = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                            self.tunnel_name.parent = self
                                                                                            self._children_name_map["tunnel_name"] = "tunnel-name"

                                                                                            self.tunnel_name_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                            self.tunnel_name_regex.parent = self
                                                                                            self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"

                                                                                            self.user_name = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                            self.user_name.parent = self
                                                                                            self._children_name_map["user_name"] = "user-name"

                                                                                            self.user_name_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                            self.user_name_regex.parent = self
                                                                                            self._children_name_map["user_name_regex"] = "user-name-regex"

                                                                                            self.auth_username = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                            self.auth_username.parent = self
                                                                                            self._children_name_map["auth_username"] = "auth-username"

                                                                                            self.auth_username_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                            self.auth_username_regex.parent = self
                                                                                            self._children_name_map["auth_username_regex"] = "auth-username-regex"

                                                                                            self.unauth_username = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                            self.unauth_username.parent = self
                                                                                            self._children_name_map["unauth_username"] = "unauth-username"

                                                                                            self.unauth_username_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                            self.unauth_username_regex.parent = self
                                                                                            self._children_name_map["unauth_username_regex"] = "unauth-username-regex"

                                                                                            self.auth_domain = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                            self.auth_domain.parent = self
                                                                                            self._children_name_map["auth_domain"] = "auth-domain"

                                                                                            self.auth_domain_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                            self.auth_domain_regex.parent = self
                                                                                            self._children_name_map["auth_domain_regex"] = "auth-domain-regex"

                                                                                            self.unauth_domain = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                            self.unauth_domain.parent = self
                                                                                            self._children_name_map["unauth_domain"] = "unauth-domain"

                                                                                            self.unauth_domain_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                            self.unauth_domain_regex.parent = self
                                                                                            self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"

                                                                                            self.vendor_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                            self.vendor_id.parent = self
                                                                                            self._children_name_map["vendor_id"] = "vendor-id"

                                                                                            self.vendor_id_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                            self.vendor_id_regex.parent = self
                                                                                            self._children_name_map["vendor_id_regex"] = "vendor-id-regex"

                                                                                            self.access_interface = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                            self.access_interface.parent = self
                                                                                            self._children_name_map["access_interface"] = "access-interface"

                                                                                            self.input_interface = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                            self.input_interface.parent = self
                                                                                            self._children_name_map["input_interface"] = "input-interface"

                                                                                            self.input_intfhdl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                            self.input_intfhdl.parent = self
                                                                                            self._children_name_map["input_intfhdl"] = "input-intfhdl"

                                                                                            self.ethertype = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                            self.ethertype.parent = self
                                                                                            self._children_name_map["ethertype"] = "ethertype"

                                                                                            self.flow_key_data = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                            self.flow_key_data.parent = self
                                                                                            self._children_name_map["flow_key_data"] = "flow-key-data"

                                                                                            self.dhcp_client_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                            self.dhcp_client_id.parent = self
                                                                                            self._children_name_map["dhcp_client_id"] = "dhcp-client-id"

                                                                                            self.dhcp_client_id_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                            self.dhcp_client_id_regex.parent = self
                                                                                            self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"

                                                                                            self.circuit_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                            self.circuit_id.parent = self
                                                                                            self._children_name_map["circuit_id"] = "circuit-id"

                                                                                            self.circuit_id_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                            self.circuit_id_regex.parent = self
                                                                                            self._children_name_map["circuit_id_regex"] = "circuit-id-regex"

                                                                                            self.remote_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                            self.remote_id.parent = self
                                                                                            self._children_name_map["remote_id"] = "remote-id"

                                                                                            self.remote_id_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                            self.remote_id_regex.parent = self
                                                                                            self._children_name_map["remote_id_regex"] = "remote-id-regex"

                                                                                            self.src_port = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                            self.src_port.parent = self
                                                                                            self._children_name_map["src_port"] = "src-port"

                                                                                            self.dst_port = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                            self.dst_port.parent = self
                                                                                            self._children_name_map["dst_port"] = "dst-port"
                                                                                            self._segment_path = lambda: "match-data"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, ['type', 'mpls_top_eos', 'fragment_type', 'authen_status', 'mlp_negotiated'], name, value)


                                                                                        class Ipv4Dscp(Entity):
                                                                                            """
                                                                                            IPv4 DSCP
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                self.yang_name = "ipv4-dscp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ipv4-dscp"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "ipv4-dscp"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                        class Ipv6Dscp(Entity):
                                                                                            """
                                                                                            IPv6 DSCP
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                self.yang_name = "ipv6-dscp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ipv6-dscp"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "ipv6-dscp"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                        class Dscp(Entity):
                                                                                            """
                                                                                            Match DSCP range array
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                self.yang_name = "dscp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "dscp"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "dscp"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                        class Ipv4Prec(Entity):
                                                                                            """
                                                                                            IPv4 Precedence
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                self.yang_name = "ipv4-prec"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "ipv4-prec"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                        class Ipv6Prec(Entity):
                                                                                            """
                                                                                            IPv6 Precedence
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                self.yang_name = "ipv6-prec"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "ipv6-prec"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                        class Prec(Entity):
                                                                                            """
                                                                                            Match Precedence array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                self.yang_name = "prec"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "prec"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                        class DiscardClass(Entity):
                                                                                            """
                                                                                            Match Discard Class array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                self.yang_name = "discard-class"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "discard-class"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                        class QosGroup(Entity):
                                                                                            """
                                                                                            Match QoS group array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                self.yang_name = "qos-group"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "qos-group"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "qos-group"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['min', 'max'], name, value)


                                                                                        class TrafficClass(Entity):
                                                                                            """
                                                                                            Match Traffic class array
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                self.yang_name = "traffic-class"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "traffic-class"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "traffic-class"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['min', 'max'], name, value)


                                                                                        class Proto(Entity):
                                                                                            """
                                                                                            Match Protocol array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                self.yang_name = "proto"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "proto"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "proto"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['min', 'max'], name, value)


                                                                                        class IcmpV4(Entity):
                                                                                            """
                                                                                            Match ICMPV4 Protocol
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	Protocol type
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: code
                                                                                            
                                                                                            	Protocol code
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                self.yang_name = "icmp-v4"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                    ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                ])
                                                                                                self.type = None
                                                                                                self.code = None
                                                                                                self._segment_path = lambda: "icmp-v4"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['type', 'code'], name, value)


                                                                                        class IcmpV6(Entity):
                                                                                            """
                                                                                            Match ICMPV6 Protocol array
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	Protocol type
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: code
                                                                                            
                                                                                            	Protocol code
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                self.yang_name = "icmp-v6"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                    ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                ])
                                                                                                self.type = None
                                                                                                self.code = None
                                                                                                self._segment_path = lambda: "icmp-v6"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['type', 'code'], name, value)


                                                                                        class Ipv4PacketLen(Entity):
                                                                                            """
                                                                                            IPv4 packet length array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                self.yang_name = "ipv4-packet-len"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ipv4-packet-len"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "ipv4-packet-len"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                        class Ipv6PacketLen(Entity):
                                                                                            """
                                                                                            IPv6 packet length array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                self.yang_name = "ipv6-packet-len"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ipv6-packet-len"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "ipv6-packet-len"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                        class PacketLen(Entity):
                                                                                            """
                                                                                            Match packet length array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                self.yang_name = "packet-len"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "packet-len"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "packet-len"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                        class FlowTag(Entity):
                                                                                            """
                                                                                            Match flow\-tag array
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                self.yang_name = "flow-tag"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "flow-tag"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "flow-tag"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['min', 'max'], name, value)


                                                                                        class TcpFlag(Entity):
                                                                                            """
                                                                                            Match tcp flag value
                                                                                            
                                                                                            .. attribute:: value
                                                                                            
                                                                                            	Value of TCP flag
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: match_any
                                                                                            
                                                                                            	Match any TCP flag bit
                                                                                            	**type**\: bool
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                self.yang_name = "tcp-flag"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                                    ('match_any', (YLeaf(YType.boolean, 'match-any'), ['bool'])),
                                                                                                ])
                                                                                                self.value = None
                                                                                                self.match_any = None
                                                                                                self._segment_path = lambda: "tcp-flag"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['value', 'match_any'], name, value)


                                                                                        class Icmpv4Type(Entity):
                                                                                            """
                                                                                            Match ipv4 icmp type
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                self.yang_name = "icmpv4-type"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "icmpv4-type"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "icmpv4-type"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                        class Icmpv4Code(Entity):
                                                                                            """
                                                                                            Match ipv4 icmp code
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                self.yang_name = "icmpv4-code"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "icmpv4-code"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "icmpv4-code"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                        class Icmpv6Type(Entity):
                                                                                            """
                                                                                            Match ipv6 icmp type
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                self.yang_name = "icmpv6-type"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "icmpv6-type"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "icmpv6-type"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                        class Icmpv6Code(Entity):
                                                                                            """
                                                                                            Match ipv6 icmp code
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                self.yang_name = "icmpv6-code"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "icmpv6-code"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "icmpv6-code"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                        class MplsExp(Entity):
                                                                                            """
                                                                                            Match MPLS experimental topmost array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                self.yang_name = "mpls-exp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "mpls-exp"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                        class MplsExpImp(Entity):
                                                                                            """
                                                                                            Match MPLS experimental imposition array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                self.yang_name = "mpls-exp-imp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "mpls-exp-imp"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                        class MplsDispIpv4Acl(Entity):
                                                                                            """
                                                                                            MPLS Disposition IPv4 Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "mpls-disp-ipv4-acl"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                        class MplsDispIpv6Acl(Entity):
                                                                                            """
                                                                                            MPLS Disposition IPv6 Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "mpls-disp-ipv6-acl"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                        class MplsTopLabel(Entity):
                                                                                            """
                                                                                            MPLS Topmost LABEL
                                                                                            
                                                                                            .. attribute:: uint32_rng_array
                                                                                            
                                                                                            	uint32 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                self.yang_name = "mpls-top-label"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint32_rng_array", ("uint32_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint32_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "mpls-top-label"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                            class Uint32RngArray(Entity):
                                                                                                """
                                                                                                uint32 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                    self.yang_name = "uint32_rng_array"
                                                                                                    self.yang_parent_name = "mpls-top-label"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint32, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint32, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint32_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['min', 'max'], name, value)


                                                                                        class Cos(Entity):
                                                                                            """
                                                                                            Match CoS array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                self.yang_name = "cos"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "cos"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                        class CosInr(Entity):
                                                                                            """
                                                                                            Match inner header CoS
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                self.yang_name = "cos-inr"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "cos-inr"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                        class Dei(Entity):
                                                                                            """
                                                                                            Match DEI Bit
                                                                                            
                                                                                            .. attribute:: bit_value
                                                                                            
                                                                                            	Value of the DEI bit
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                self.yang_name = "dei"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                ])
                                                                                                self.bit_value = None
                                                                                                self._segment_path = lambda: "dei"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                        class DeiInr(Entity):
                                                                                            """
                                                                                            Match inner DEI Bit
                                                                                            
                                                                                            .. attribute:: bit_value
                                                                                            
                                                                                            	Value of the DEI bit
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                self.yang_name = "dei-inr"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                ])
                                                                                                self.bit_value = None
                                                                                                self._segment_path = lambda: "dei-inr"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                        class Vlan(Entity):
                                                                                            """
                                                                                            Match VLAN array
                                                                                            
                                                                                            .. attribute:: vlan_id_array
                                                                                            
                                                                                            	vlan id array
                                                                                            	**type**\: list of  		 :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                self.yang_name = "vlan"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("vlan-id-array", ("vlan_id_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.vlan_id_array = YList(self)
                                                                                                self._segment_path = lambda: "vlan"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                            class VlanIdArray(Entity):
                                                                                                """
                                                                                                vlan id array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	VLAN mask
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                    self.yang_name = "vlan-id-array"
                                                                                                    self.yang_parent_name = "vlan"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ('mask', (YLeaf(YType.uint16, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self.mask = None
                                                                                                    self._segment_path = lambda: "vlan-id-array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['min', 'max', 'mask'], name, value)


                                                                                        class VlanInr(Entity):
                                                                                            """
                                                                                            Match inner header VLAN range array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                self.yang_name = "vlan-inr"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "vlan-inr"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "vlan-inr"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['min', 'max'], name, value)


                                                                                        class FrDlci(Entity):
                                                                                            """
                                                                                            Match FR DLCI range array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                self.yang_name = "fr-dlci"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "fr-dlci"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "fr-dlci"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['min', 'max'], name, value)


                                                                                        class SrcMac(Entity):
                                                                                            """
                                                                                            Match Source MAC address
                                                                                            
                                                                                            .. attribute:: mac_addr
                                                                                            
                                                                                            	MAC address
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	MAC mask
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                self.yang_name = "src-mac"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                    ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                ])
                                                                                                self.mac_addr = []
                                                                                                self.mask = []
                                                                                                self._segment_path = lambda: "src-mac"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                        class DstMac(Entity):
                                                                                            """
                                                                                            Match Destination MAC address
                                                                                            
                                                                                            .. attribute:: mac_addr
                                                                                            
                                                                                            	MAC address
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	MAC mask
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                self.yang_name = "dst-mac"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                    ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                ])
                                                                                                self.mac_addr = []
                                                                                                self.mask = []
                                                                                                self._segment_path = lambda: "dst-mac"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                        class AtmClp(Entity):
                                                                                            """
                                                                                            Match ATM CLP level
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                self.yang_name = "atm-clp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "atm-clp"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                        class FrDe(Entity):
                                                                                            """
                                                                                            Match FR DE value
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                self.yang_name = "fr-de"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "fr-de"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                        class Ipv4Acl(Entity):
                                                                                            """
                                                                                            IPv4 Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                self.yang_name = "ipv4-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "ipv4-acl"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                        class Ipv6Acl(Entity):
                                                                                            """
                                                                                            IPv6 Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                self.yang_name = "ipv6-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "ipv6-acl"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                        class EtherServiceAcl(Entity):
                                                                                            """
                                                                                            Ethernet\-Services Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                self.yang_name = "ether-service-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "ether-service-acl"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                        class AvailId(Entity):
                                                                                            """
                                                                                            Available Identifiers
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                self.yang_name = "avail-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "avail-id"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                        class MediaType(Entity):
                                                                                            """
                                                                                            Media Type
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                self.yang_name = "media-type"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "media-type"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                        class SubsProtocol(Entity):
                                                                                            """
                                                                                            Protocol
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                self.yang_name = "subs-protocol"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "subs-protocol"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                        class Dnis(Entity):
                                                                                            """
                                                                                            DNIS
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                self.yang_name = "dnis"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "dnis"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                        class DnisRegex(Entity):
                                                                                            """
                                                                                            DNIS Regular Expression
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                self.yang_name = "dnis-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "dnis-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                        class Domain(Entity):
                                                                                            """
                                                                                            Domain Name
                                                                                            
                                                                                            .. attribute:: domain_array
                                                                                            
                                                                                            	domain array
                                                                                            	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                self.yang_name = "domain"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.domain_array = YList(self)
                                                                                                self._segment_path = lambda: "domain"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                            class DomainArray(Entity):
                                                                                                """
                                                                                                domain array
                                                                                                
                                                                                                .. attribute:: domain_name
                                                                                                
                                                                                                	domain name
                                                                                                	**type**\: str
                                                                                                
                                                                                                .. attribute:: format_name
                                                                                                
                                                                                                	format name
                                                                                                	**type**\: str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                    self.yang_name = "domain-array"
                                                                                                    self.yang_parent_name = "domain"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                        ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                    ])
                                                                                                    self.domain_name = None
                                                                                                    self.format_name = None
                                                                                                    self._segment_path = lambda: "domain-array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                        class DomainRegex(Entity):
                                                                                            """
                                                                                            Domain Regular Expression
                                                                                            
                                                                                            .. attribute:: domain_array
                                                                                            
                                                                                            	domain array
                                                                                            	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                self.yang_name = "domain-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.domain_array = YList(self)
                                                                                                self._segment_path = lambda: "domain-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                            class DomainArray(Entity):
                                                                                                """
                                                                                                domain array
                                                                                                
                                                                                                .. attribute:: domain_name
                                                                                                
                                                                                                	domain name
                                                                                                	**type**\: str
                                                                                                
                                                                                                .. attribute:: format_name
                                                                                                
                                                                                                	format name
                                                                                                	**type**\: str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                    self.yang_name = "domain-array"
                                                                                                    self.yang_parent_name = "domain-regex"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                        ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                    ])
                                                                                                    self.domain_name = None
                                                                                                    self.format_name = None
                                                                                                    self._segment_path = lambda: "domain-array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                        class NasPort(Entity):
                                                                                            """
                                                                                            NAS Port
                                                                                            
                                                                                            .. attribute:: nas_port_array
                                                                                            
                                                                                            	nas port array
                                                                                            	**type**\: list of  		 :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                self.yang_name = "nas-port"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("nas-port-array", ("nas_port_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.nas_port_array = YList(self)
                                                                                                self._segment_path = lambda: "nas-port"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                            class NasPortArray(Entity):
                                                                                                """
                                                                                                nas port array
                                                                                                
                                                                                                .. attribute:: sub_id
                                                                                                
                                                                                                	sub id
                                                                                                	**type**\:  :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                
                                                                                                .. attribute:: operator
                                                                                                
                                                                                                	operator
                                                                                                	**type**\:  :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                
                                                                                                .. attribute:: value
                                                                                                
                                                                                                	value
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                    self.yang_name = "nas-port-array"
                                                                                                    self.yang_parent_name = "nas-port"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('sub_id', (YLeaf(YType.enumeration, 'sub-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchNasPortSubIdEn', '')])),
                                                                                                        ('operator', (YLeaf(YType.enumeration, 'operator'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchLogicalOperatorEn', '')])),
                                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                                    ])
                                                                                                    self.sub_id = None
                                                                                                    self.operator = None
                                                                                                    self.value = None
                                                                                                    self._segment_path = lambda: "nas-port-array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['sub_id', 'operator', 'value'], name, value)


                                                                                        class ServiceName(Entity):
                                                                                            """
                                                                                            Service Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                self.yang_name = "service-name"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "service-name"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                        class ServiceNameRegex(Entity):
                                                                                            """
                                                                                            Service Name Regular Exp
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                self.yang_name = "service-name-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "service-name-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                        class SrcAddrIpv4(Entity):
                                                                                            """
                                                                                            Source Address IPV4
                                                                                            
                                                                                            .. attribute:: ipv4_addr_array
                                                                                            
                                                                                            	ipv4 addr array
                                                                                            	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                self.yang_name = "src-addr-ipv4"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.ipv4_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "src-addr-ipv4"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                            class Ipv4AddrArray(Entity):
                                                                                                """
                                                                                                ipv4 addr array
                                                                                                
                                                                                                .. attribute:: prefix
                                                                                                
                                                                                                	prefix
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	mask
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                    self.yang_name = "ipv4-addr-array"
                                                                                                    self.yang_parent_name = "src-addr-ipv4"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                        ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                    ])
                                                                                                    self.prefix = None
                                                                                                    self.mask = None
                                                                                                    self._segment_path = lambda: "ipv4-addr-array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                        class DstAddrIpv4(Entity):
                                                                                            """
                                                                                            Destination Address IPV4
                                                                                            
                                                                                            .. attribute:: ipv4_addr_array
                                                                                            
                                                                                            	ipv4 addr array
                                                                                            	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                self.yang_name = "dst-addr-ipv4"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.ipv4_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "dst-addr-ipv4"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                            class Ipv4AddrArray(Entity):
                                                                                                """
                                                                                                ipv4 addr array
                                                                                                
                                                                                                .. attribute:: prefix
                                                                                                
                                                                                                	prefix
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	mask
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                    self.yang_name = "ipv4-addr-array"
                                                                                                    self.yang_parent_name = "dst-addr-ipv4"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                        ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                    ])
                                                                                                    self.prefix = None
                                                                                                    self.mask = None
                                                                                                    self._segment_path = lambda: "ipv4-addr-array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                        class SrcAddrIpv6(Entity):
                                                                                            """
                                                                                            Source Address IPV6
                                                                                            
                                                                                            .. attribute:: ipv6_addr_array
                                                                                            
                                                                                            	ipv6 addr array
                                                                                            	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                self.yang_name = "src-addr-ipv6"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.ipv6_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "src-addr-ipv6"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                            class Ipv6AddrArray(Entity):
                                                                                                """
                                                                                                ipv6 addr array
                                                                                                
                                                                                                .. attribute:: prefix
                                                                                                
                                                                                                	IPV6 prefix
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	IPV6 mask
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                    self.yang_name = "ipv6-addr-array"
                                                                                                    self.yang_parent_name = "src-addr-ipv6"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                        ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.prefix = None
                                                                                                    self.mask = None
                                                                                                    self._segment_path = lambda: "ipv6-addr-array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                        class DstAddrIpv6(Entity):
                                                                                            """
                                                                                            Destination Address IPV6
                                                                                            
                                                                                            .. attribute:: ipv6_addr_array
                                                                                            
                                                                                            	ipv6 addr array
                                                                                            	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                self.yang_name = "dst-addr-ipv6"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.ipv6_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "dst-addr-ipv6"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                            class Ipv6AddrArray(Entity):
                                                                                                """
                                                                                                ipv6 addr array
                                                                                                
                                                                                                .. attribute:: prefix
                                                                                                
                                                                                                	IPV6 prefix
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	IPV6 mask
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                    self.yang_name = "ipv6-addr-array"
                                                                                                    self.yang_parent_name = "dst-addr-ipv6"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                        ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.prefix = None
                                                                                                    self.mask = None
                                                                                                    self._segment_path = lambda: "ipv6-addr-array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                        class SrcAddrMac(Entity):
                                                                                            """
                                                                                            Source Address MAC
                                                                                            
                                                                                            .. attribute:: mac_addr_array
                                                                                            
                                                                                            	mac addr array
                                                                                            	**type**\: list of  		 :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                self.yang_name = "src-addr-mac"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("mac-addr-array", ("mac_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.mac_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "src-addr-mac"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                            class MacAddrArray(Entity):
                                                                                                """
                                                                                                mac addr array
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                    self.yang_name = "mac-addr-array"
                                                                                                    self.yang_parent_name = "src-addr-mac"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.mac_addr = []
                                                                                                    self.mask = []
                                                                                                    self._segment_path = lambda: "mac-addr-array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                        class Timer(Entity):
                                                                                            """
                                                                                            Timer
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                self.yang_name = "timer"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "timer"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                        class TimerRegexp(Entity):
                                                                                            """
                                                                                            Timer Regular Expression
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                self.yang_name = "timer-regexp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "timer-regexp"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                        class TunnelName(Entity):
                                                                                            """
                                                                                            Tunnel Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                self.yang_name = "tunnel-name"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "tunnel-name"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                        class TunnelNameRegex(Entity):
                                                                                            """
                                                                                            Tunnel Name Regular Expression
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                self.yang_name = "tunnel-name-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "tunnel-name-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                        class UserName(Entity):
                                                                                            """
                                                                                            User Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                self.yang_name = "user-name"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "user-name"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                        class UserNameRegex(Entity):
                                                                                            """
                                                                                            User Name Regular Expression
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                self.yang_name = "user-name-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "user-name-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                        class AuthUsername(Entity):
                                                                                            """
                                                                                            Authenticated User Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                self.yang_name = "auth-username"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "auth-username"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                        class AuthUsernameRegex(Entity):
                                                                                            """
                                                                                            Authenticated User Name RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                self.yang_name = "auth-username-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "auth-username-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                        class UnauthUsername(Entity):
                                                                                            """
                                                                                            Unauthenticated User Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                self.yang_name = "unauth-username"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "unauth-username"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                        class UnauthUsernameRegex(Entity):
                                                                                            """
                                                                                            Unauthenticated User Name RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                self.yang_name = "unauth-username-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "unauth-username-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                        class AuthDomain(Entity):
                                                                                            """
                                                                                            Authenticated domain name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                self.yang_name = "auth-domain"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "auth-domain"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                        class AuthDomainRegex(Entity):
                                                                                            """
                                                                                            Authenticated Domain Name RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                self.yang_name = "auth-domain-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "auth-domain-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                        class UnauthDomain(Entity):
                                                                                            """
                                                                                            Unauthenticated Domain Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                self.yang_name = "unauth-domain"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "unauth-domain"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                        class UnauthDomainRegex(Entity):
                                                                                            """
                                                                                            Unauthenticated Domain Name RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                self.yang_name = "unauth-domain-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "unauth-domain-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                        class VendorId(Entity):
                                                                                            """
                                                                                            Vendor ID
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                self.yang_name = "vendor-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "vendor-id"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                        class VendorIdRegex(Entity):
                                                                                            """
                                                                                            Vendor ID RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                self.yang_name = "vendor-id-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "vendor-id-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                        class AccessInterface(Entity):
                                                                                            """
                                                                                            Access interface
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                self.yang_name = "access-interface"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "access-interface"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                        class InputInterface(Entity):
                                                                                            """
                                                                                            Input interface
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                self.yang_name = "input-interface"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "input-interface"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                        class InputIntfhdl(Entity):
                                                                                            """
                                                                                            Input interface handle
                                                                                            
                                                                                            .. attribute:: uint64_array
                                                                                            
                                                                                            	uint64 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..18446744073709551615
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                self.yang_name = "input-intfhdl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint64_array', (YLeafList(YType.uint64, 'uint64_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint64_array = []
                                                                                                self._segment_path = lambda: "input-intfhdl"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                        class Ethertype(Entity):
                                                                                            """
                                                                                            Ethernet type
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                self.yang_name = "ethertype"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ethertype"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "ethertype"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['min', 'max'], name, value)


                                                                                        class FlowKeyData(Entity):
                                                                                            """
                                                                                            Flow key structure
                                                                                            
                                                                                            .. attribute:: flow_keys
                                                                                            
                                                                                            	flow keys
                                                                                            	**type**\:  :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                            
                                                                                            .. attribute:: max_count
                                                                                            
                                                                                            	Maximum count of flows
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: idle_timeout
                                                                                            
                                                                                            	Idle timeout of flows (in seconds)
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            	**units**\: second
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                self.yang_name = "flow-key-data"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("flow-keys", ("flow_keys", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys))])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('max_count', (YLeaf(YType.uint16, 'max-count'), ['int'])),
                                                                                                    ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                                                ])
                                                                                                self.max_count = None
                                                                                                self.idle_timeout = None

                                                                                                self.flow_keys = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                self.flow_keys.parent = self
                                                                                                self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                self._segment_path = lambda: "flow-key-data"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['max_count', 'idle_timeout'], name, value)


                                                                                            class FlowKeys(Entity):
                                                                                                """
                                                                                                flow keys
                                                                                                
                                                                                                .. attribute:: keys
                                                                                                
                                                                                                	keys
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                
                                                                                                .. attribute:: num
                                                                                                
                                                                                                	num
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                    self.yang_name = "flow-keys"
                                                                                                    self.yang_parent_name = "flow-key-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('keys', (YLeaf(YType.str, 'keys'), ['str'])),
                                                                                                        ('num', (YLeaf(YType.uint8, 'num'), ['int'])),
                                                                                                    ])
                                                                                                    self.keys = None
                                                                                                    self.num = None
                                                                                                    self._segment_path = lambda: "flow-keys"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                        class DhcpClientId(Entity):
                                                                                            """
                                                                                            Dhcp Client ID
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                self.yang_name = "dhcp-client-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "dhcp-client-id"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                        class DhcpClientIdRegex(Entity):
                                                                                            """
                                                                                            Dhcp Client ID RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                self.yang_name = "dhcp-client-id-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "dhcp-client-id-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                        class CircuitId(Entity):
                                                                                            """
                                                                                            Circuit ID
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                self.yang_name = "circuit-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "circuit-id"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                        class CircuitIdRegex(Entity):
                                                                                            """
                                                                                            Circuit ID RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                self.yang_name = "circuit-id-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "circuit-id-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                        class RemoteId(Entity):
                                                                                            """
                                                                                            Remote ID
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                self.yang_name = "remote-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "remote-id"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                        class RemoteIdRegex(Entity):
                                                                                            """
                                                                                            Remote ID RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                self.yang_name = "remote-id-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "remote-id-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                        class SrcPort(Entity):
                                                                                            """
                                                                                            Source port
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                self.yang_name = "src-port"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "src-port"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "src-port"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                                        class DstPort(Entity):
                                                                                            """
                                                                                            Destination port
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                self.yang_name = "dst-port"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "dst-port"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "dst-port"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                    class ExcdclassP(Entity):
                                                                        """
                                                                        excdclass p
                                                                        
                                                                        .. attribute:: class_map_bg
                                                                        
                                                                        	class map bg
                                                                        	**type**\: list of  		 :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP, self).__init__()

                                                                            self.yang_name = "excdclass-p"
                                                                            self.yang_parent_name = "police"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("class-map-bg", ("class_map_bg", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg))])
                                                                            self._leafs = OrderedDict()

                                                                            self.class_map_bg = YList(self)
                                                                            self._segment_path = lambda: "excdclass-p"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP, [], name, value)


                                                                        class ClassMapBg(Entity):
                                                                            """
                                                                            class map bg
                                                                            
                                                                            .. attribute:: match_infop
                                                                            
                                                                            	Pointer to the first Match info
                                                                            	**type**\:  :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop>`
                                                                            
                                                                            .. attribute:: name
                                                                            
                                                                            	Name of the class\-map
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..65
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	Class\-Map Type QoS/PBR/Netflow/..
                                                                            	**type**\:  :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                                            
                                                                            .. attribute:: mode
                                                                            
                                                                            	Class\-Map Mode Match any/Match all
                                                                            	**type**\:  :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                            
                                                                            .. attribute:: description
                                                                            
                                                                            	description
                                                                            	**type**\: str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg, self).__init__()

                                                                                self.yang_name = "class-map-bg"
                                                                                self.yang_parent_name = "excdclass-p"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("match-infop", ("match_infop", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapTypeEn', '')])),
                                                                                    ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapModeEn', '')])),
                                                                                    ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                ])
                                                                                self.name = None
                                                                                self.type = None
                                                                                self.mode = None
                                                                                self.description = None

                                                                                self.match_infop = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop()
                                                                                self.match_infop.parent = self
                                                                                self._children_name_map["match_infop"] = "match-infop"
                                                                                self._segment_path = lambda: "class-map-bg"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg, ['name', 'type', 'mode', 'description'], name, value)


                                                                            class MatchInfop(Entity):
                                                                                """
                                                                                Pointer to the first Match info
                                                                                
                                                                                .. attribute:: class_match_info_st
                                                                                
                                                                                	class match info st
                                                                                	**type**\: list of  		 :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop, self).__init__()

                                                                                    self.yang_name = "match-infop"
                                                                                    self.yang_parent_name = "class-map-bg"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("class-match-info-st", ("class_match_info_st", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.class_match_info_st = YList(self)
                                                                                    self._segment_path = lambda: "match-infop"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop, [], name, value)


                                                                                class ClassMatchInfoSt(Entity):
                                                                                    """
                                                                                    class match info st
                                                                                    
                                                                                    .. attribute:: match_data
                                                                                    
                                                                                    	Match criteria
                                                                                    	**type**\:  :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                    
                                                                                    .. attribute:: flags
                                                                                    
                                                                                    	Flags
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                        self.yang_name = "class-match-info-st"
                                                                                        self.yang_parent_name = "match-infop"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("match-data", ("match_data", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData))])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                        ])
                                                                                        self.flags = None

                                                                                        self.match_data = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                        self.match_data.parent = self
                                                                                        self._children_name_map["match_data"] = "match-data"
                                                                                        self._segment_path = lambda: "class-match-info-st"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                    class MatchData(Entity):
                                                                                        """
                                                                                        Match criteria
                                                                                        
                                                                                        .. attribute:: ipv4_dscp
                                                                                        
                                                                                        	IPv4 DSCP
                                                                                        	**type**\:  :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                        
                                                                                        .. attribute:: ipv6_dscp
                                                                                        
                                                                                        	IPv6 DSCP
                                                                                        	**type**\:  :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                        
                                                                                        .. attribute:: dscp
                                                                                        
                                                                                        	Match DSCP range array
                                                                                        	**type**\:  :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                        
                                                                                        .. attribute:: ipv4_prec
                                                                                        
                                                                                        	IPv4 Precedence
                                                                                        	**type**\:  :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                        
                                                                                        .. attribute:: ipv6_prec
                                                                                        
                                                                                        	IPv6 Precedence
                                                                                        	**type**\:  :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                        
                                                                                        .. attribute:: prec
                                                                                        
                                                                                        	Match Precedence array
                                                                                        	**type**\:  :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                        
                                                                                        .. attribute:: discard_class
                                                                                        
                                                                                        	Match Discard Class array
                                                                                        	**type**\:  :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                        
                                                                                        .. attribute:: qos_group
                                                                                        
                                                                                        	Match QoS group array
                                                                                        	**type**\:  :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                        
                                                                                        .. attribute:: traffic_class
                                                                                        
                                                                                        	Match Traffic class array
                                                                                        	**type**\:  :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                        
                                                                                        .. attribute:: proto
                                                                                        
                                                                                        	Match Protocol array
                                                                                        	**type**\:  :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                        
                                                                                        .. attribute:: icmp_v4
                                                                                        
                                                                                        	Match ICMPV4 Protocol
                                                                                        	**type**\:  :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                        
                                                                                        .. attribute:: icmp_v6
                                                                                        
                                                                                        	Match ICMPV6 Protocol array
                                                                                        	**type**\:  :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                        
                                                                                        .. attribute:: ipv4_packet_len
                                                                                        
                                                                                        	IPv4 packet length array
                                                                                        	**type**\:  :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                        
                                                                                        .. attribute:: ipv6_packet_len
                                                                                        
                                                                                        	IPv6 packet length array
                                                                                        	**type**\:  :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                        
                                                                                        .. attribute:: packet_len
                                                                                        
                                                                                        	Match packet length array
                                                                                        	**type**\:  :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                        
                                                                                        .. attribute:: flow_tag
                                                                                        
                                                                                        	Match flow\-tag array
                                                                                        	**type**\:  :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                        
                                                                                        .. attribute:: tcp_flag
                                                                                        
                                                                                        	Match tcp flag value
                                                                                        	**type**\:  :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                        
                                                                                        .. attribute:: icmpv4_type
                                                                                        
                                                                                        	Match ipv4 icmp type
                                                                                        	**type**\:  :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                        
                                                                                        .. attribute:: icmpv4_code
                                                                                        
                                                                                        	Match ipv4 icmp code
                                                                                        	**type**\:  :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                        
                                                                                        .. attribute:: icmpv6_type
                                                                                        
                                                                                        	Match ipv6 icmp type
                                                                                        	**type**\:  :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                        
                                                                                        .. attribute:: icmpv6_code
                                                                                        
                                                                                        	Match ipv6 icmp code
                                                                                        	**type**\:  :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                        
                                                                                        .. attribute:: mpls_exp
                                                                                        
                                                                                        	Match MPLS experimental topmost array
                                                                                        	**type**\:  :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                        
                                                                                        .. attribute:: mpls_exp_imp
                                                                                        
                                                                                        	Match MPLS experimental imposition array
                                                                                        	**type**\:  :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                        
                                                                                        .. attribute:: mpls_disp_ipv4_acl
                                                                                        
                                                                                        	MPLS Disposition IPv4 Access\-list
                                                                                        	**type**\:  :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                        
                                                                                        .. attribute:: mpls_disp_ipv6_acl
                                                                                        
                                                                                        	MPLS Disposition IPv6 Access\-list
                                                                                        	**type**\:  :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                        
                                                                                        .. attribute:: mpls_top_label
                                                                                        
                                                                                        	MPLS Topmost LABEL
                                                                                        	**type**\:  :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                        
                                                                                        .. attribute:: cos
                                                                                        
                                                                                        	Match CoS array
                                                                                        	**type**\:  :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                        
                                                                                        .. attribute:: cos_inr
                                                                                        
                                                                                        	Match inner header CoS
                                                                                        	**type**\:  :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                        
                                                                                        .. attribute:: dei
                                                                                        
                                                                                        	Match DEI Bit
                                                                                        	**type**\:  :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                        
                                                                                        .. attribute:: dei_inr
                                                                                        
                                                                                        	Match inner DEI Bit
                                                                                        	**type**\:  :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                        
                                                                                        .. attribute:: vlan
                                                                                        
                                                                                        	Match VLAN array
                                                                                        	**type**\:  :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                        
                                                                                        .. attribute:: vlan_inr
                                                                                        
                                                                                        	Match inner header VLAN range array
                                                                                        	**type**\:  :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                        
                                                                                        .. attribute:: fr_dlci
                                                                                        
                                                                                        	Match FR DLCI range array
                                                                                        	**type**\:  :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                        
                                                                                        .. attribute:: src_mac
                                                                                        
                                                                                        	Match Source MAC address
                                                                                        	**type**\:  :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                        
                                                                                        .. attribute:: dst_mac
                                                                                        
                                                                                        	Match Destination MAC address
                                                                                        	**type**\:  :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                        
                                                                                        .. attribute:: atm_clp
                                                                                        
                                                                                        	Match ATM CLP level
                                                                                        	**type**\:  :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                        
                                                                                        .. attribute:: fr_de
                                                                                        
                                                                                        	Match FR DE value
                                                                                        	**type**\:  :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                        
                                                                                        .. attribute:: ipv4_acl
                                                                                        
                                                                                        	IPv4 Access\-list
                                                                                        	**type**\:  :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                        
                                                                                        .. attribute:: ipv6_acl
                                                                                        
                                                                                        	IPv6 Access\-list
                                                                                        	**type**\:  :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                        
                                                                                        .. attribute:: ether_service_acl
                                                                                        
                                                                                        	Ethernet\-Services Access\-list
                                                                                        	**type**\:  :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                        
                                                                                        .. attribute:: avail_id
                                                                                        
                                                                                        	Available Identifiers
                                                                                        	**type**\:  :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                        
                                                                                        .. attribute:: media_type
                                                                                        
                                                                                        	Media Type
                                                                                        	**type**\:  :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                        
                                                                                        .. attribute:: subs_protocol
                                                                                        
                                                                                        	Protocol
                                                                                        	**type**\:  :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                        
                                                                                        .. attribute:: dnis
                                                                                        
                                                                                        	DNIS
                                                                                        	**type**\:  :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                        
                                                                                        .. attribute:: dnis_regex
                                                                                        
                                                                                        	DNIS Regular Expression
                                                                                        	**type**\:  :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                        
                                                                                        .. attribute:: domain
                                                                                        
                                                                                        	Domain Name
                                                                                        	**type**\:  :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                        
                                                                                        .. attribute:: domain_regex
                                                                                        
                                                                                        	Domain Regular Expression
                                                                                        	**type**\:  :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                        
                                                                                        .. attribute:: nas_port
                                                                                        
                                                                                        	NAS Port
                                                                                        	**type**\:  :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                        
                                                                                        .. attribute:: service_name
                                                                                        
                                                                                        	Service Name
                                                                                        	**type**\:  :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                        
                                                                                        .. attribute:: service_name_regex
                                                                                        
                                                                                        	Service Name Regular Exp
                                                                                        	**type**\:  :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                        
                                                                                        .. attribute:: src_addr_ipv4
                                                                                        
                                                                                        	Source Address IPV4
                                                                                        	**type**\:  :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                        
                                                                                        .. attribute:: dst_addr_ipv4
                                                                                        
                                                                                        	Destination Address IPV4
                                                                                        	**type**\:  :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                        
                                                                                        .. attribute:: src_addr_ipv6
                                                                                        
                                                                                        	Source Address IPV6
                                                                                        	**type**\:  :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                        
                                                                                        .. attribute:: dst_addr_ipv6
                                                                                        
                                                                                        	Destination Address IPV6
                                                                                        	**type**\:  :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                        
                                                                                        .. attribute:: src_addr_mac
                                                                                        
                                                                                        	Source Address MAC
                                                                                        	**type**\:  :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                        
                                                                                        .. attribute:: timer
                                                                                        
                                                                                        	Timer
                                                                                        	**type**\:  :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                        
                                                                                        .. attribute:: timer_regexp
                                                                                        
                                                                                        	Timer Regular Expression
                                                                                        	**type**\:  :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                        
                                                                                        .. attribute:: tunnel_name
                                                                                        
                                                                                        	Tunnel Name
                                                                                        	**type**\:  :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                        
                                                                                        .. attribute:: tunnel_name_regex
                                                                                        
                                                                                        	Tunnel Name Regular Expression
                                                                                        	**type**\:  :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                        
                                                                                        .. attribute:: user_name
                                                                                        
                                                                                        	User Name
                                                                                        	**type**\:  :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                        
                                                                                        .. attribute:: user_name_regex
                                                                                        
                                                                                        	User Name Regular Expression
                                                                                        	**type**\:  :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                        
                                                                                        .. attribute:: auth_username
                                                                                        
                                                                                        	Authenticated User Name
                                                                                        	**type**\:  :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                        
                                                                                        .. attribute:: auth_username_regex
                                                                                        
                                                                                        	Authenticated User Name RegEx
                                                                                        	**type**\:  :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                        
                                                                                        .. attribute:: unauth_username
                                                                                        
                                                                                        	Unauthenticated User Name
                                                                                        	**type**\:  :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                        
                                                                                        .. attribute:: unauth_username_regex
                                                                                        
                                                                                        	Unauthenticated User Name RegEx
                                                                                        	**type**\:  :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                        
                                                                                        .. attribute:: auth_domain
                                                                                        
                                                                                        	Authenticated domain name
                                                                                        	**type**\:  :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                        
                                                                                        .. attribute:: auth_domain_regex
                                                                                        
                                                                                        	Authenticated Domain Name RegEx
                                                                                        	**type**\:  :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                        
                                                                                        .. attribute:: unauth_domain
                                                                                        
                                                                                        	Unauthenticated Domain Name
                                                                                        	**type**\:  :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                        
                                                                                        .. attribute:: unauth_domain_regex
                                                                                        
                                                                                        	Unauthenticated Domain Name RegEx
                                                                                        	**type**\:  :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                        
                                                                                        .. attribute:: vendor_id
                                                                                        
                                                                                        	Vendor ID
                                                                                        	**type**\:  :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                        
                                                                                        .. attribute:: vendor_id_regex
                                                                                        
                                                                                        	Vendor ID RegEx
                                                                                        	**type**\:  :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                        
                                                                                        .. attribute:: access_interface
                                                                                        
                                                                                        	Access interface
                                                                                        	**type**\:  :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                        
                                                                                        .. attribute:: input_interface
                                                                                        
                                                                                        	Input interface
                                                                                        	**type**\:  :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                        
                                                                                        .. attribute:: input_intfhdl
                                                                                        
                                                                                        	Input interface handle
                                                                                        	**type**\:  :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                        
                                                                                        .. attribute:: ethertype
                                                                                        
                                                                                        	Ethernet type
                                                                                        	**type**\:  :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                        
                                                                                        .. attribute:: flow_key_data
                                                                                        
                                                                                        	Flow key structure
                                                                                        	**type**\:  :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                        
                                                                                        .. attribute:: dhcp_client_id
                                                                                        
                                                                                        	Dhcp Client ID
                                                                                        	**type**\:  :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                        
                                                                                        .. attribute:: dhcp_client_id_regex
                                                                                        
                                                                                        	Dhcp Client ID RegEx
                                                                                        	**type**\:  :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                        
                                                                                        .. attribute:: circuit_id
                                                                                        
                                                                                        	Circuit ID
                                                                                        	**type**\:  :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                        
                                                                                        .. attribute:: circuit_id_regex
                                                                                        
                                                                                        	Circuit ID RegEx
                                                                                        	**type**\:  :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                        
                                                                                        .. attribute:: remote_id
                                                                                        
                                                                                        	Remote ID
                                                                                        	**type**\:  :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                        
                                                                                        .. attribute:: remote_id_regex
                                                                                        
                                                                                        	Remote ID RegEx
                                                                                        	**type**\:  :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                        
                                                                                        .. attribute:: src_port
                                                                                        
                                                                                        	Source port
                                                                                        	**type**\:  :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                        
                                                                                        .. attribute:: dst_port
                                                                                        
                                                                                        	Destination port
                                                                                        	**type**\:  :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                        
                                                                                        .. attribute:: type
                                                                                        
                                                                                        	type
                                                                                        	**type**\:  :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                        
                                                                                        .. attribute:: mpls_top_eos
                                                                                        
                                                                                        	MPLS Topmost EOS
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: fragment_type
                                                                                        
                                                                                        	Fragment type
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: authen_status
                                                                                        
                                                                                        	Authentication Status
                                                                                        	**type**\:  :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                        
                                                                                        .. attribute:: mlp_negotiated
                                                                                        
                                                                                        	MLP Negotiated
                                                                                        	**type**\:  :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                            self.yang_name = "match-data"
                                                                                            self.yang_parent_name = "class-match-info-st"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("ipv4-dscp", ("ipv4_dscp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp)), ("ipv6-dscp", ("ipv6_dscp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp)), ("dscp", ("dscp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp)), ("ipv4-prec", ("ipv4_prec", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec)), ("ipv6-prec", ("ipv6_prec", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec)), ("prec", ("prec", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec)), ("discard-class", ("discard_class", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass)), ("qos-group", ("qos_group", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup)), ("traffic-class", ("traffic_class", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass)), ("proto", ("proto", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto)), ("icmp-v4", ("icmp_v4", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4)), ("icmp-v6", ("icmp_v6", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6)), ("ipv4-packet-len", ("ipv4_packet_len", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen)), ("ipv6-packet-len", ("ipv6_packet_len", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen)), ("packet-len", ("packet_len", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen)), ("flow-tag", ("flow_tag", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag)), ("tcp-flag", ("tcp_flag", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag)), ("icmpv4-type", ("icmpv4_type", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type)), ("icmpv4-code", ("icmpv4_code", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code)), ("icmpv6-type", ("icmpv6_type", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type)), ("icmpv6-code", ("icmpv6_code", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code)), ("mpls-exp", ("mpls_exp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp)), ("mpls-exp-imp", ("mpls_exp_imp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp)), ("mpls-disp-ipv4-acl", ("mpls_disp_ipv4_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl)), ("mpls-disp-ipv6-acl", ("mpls_disp_ipv6_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl)), ("mpls-top-label", ("mpls_top_label", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel)), ("cos", ("cos", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos)), ("cos-inr", ("cos_inr", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr)), ("dei", ("dei", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei)), ("dei-inr", ("dei_inr", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr)), ("vlan", ("vlan", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan)), ("vlan-inr", ("vlan_inr", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)), ("fr-dlci", ("fr_dlci", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci)), ("src-mac", ("src_mac", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac)), ("dst-mac", ("dst_mac", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac)), ("atm-clp", ("atm_clp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp)), ("fr-de", ("fr_de", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe)), ("ipv4-acl", ("ipv4_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl)), ("ipv6-acl", ("ipv6_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl)), ("ether-service-acl", ("ether_service_acl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl)), ("avail-id", ("avail_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId)), ("media-type", ("media_type", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType)), ("subs-protocol", ("subs_protocol", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol)), ("dnis", ("dnis", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis)), ("dnis-regex", ("dnis_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex)), ("domain", ("domain", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain)), ("domain-regex", ("domain_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex)), ("nas-port", ("nas_port", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort)), ("service-name", ("service_name", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName)), ("service-name-regex", ("service_name_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex)), ("src-addr-ipv4", ("src_addr_ipv4", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4)), ("dst-addr-ipv4", ("dst_addr_ipv4", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4)), ("src-addr-ipv6", ("src_addr_ipv6", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6)), ("dst-addr-ipv6", ("dst_addr_ipv6", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6)), ("src-addr-mac", ("src_addr_mac", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac)), ("timer", ("timer", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer)), ("timer-regexp", ("timer_regexp", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp)), ("tunnel-name", ("tunnel_name", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName)), ("tunnel-name-regex", ("tunnel_name_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex)), ("user-name", ("user_name", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName)), ("user-name-regex", ("user_name_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex)), ("auth-username", ("auth_username", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername)), ("auth-username-regex", ("auth_username_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex)), ("unauth-username", ("unauth_username", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername)), ("unauth-username-regex", ("unauth_username_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex)), ("auth-domain", ("auth_domain", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain)), ("auth-domain-regex", ("auth_domain_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex)), ("unauth-domain", ("unauth_domain", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain)), ("unauth-domain-regex", ("unauth_domain_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex)), ("vendor-id", ("vendor_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId)), ("vendor-id-regex", ("vendor_id_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex)), ("access-interface", ("access_interface", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface)), ("input-interface", ("input_interface", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface)), ("input-intfhdl", ("input_intfhdl", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl)), ("ethertype", ("ethertype", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype)), ("flow-key-data", ("flow_key_data", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData)), ("dhcp-client-id", ("dhcp_client_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId)), ("dhcp-client-id-regex", ("dhcp_client_id_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex)), ("circuit-id", ("circuit_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId)), ("circuit-id-regex", ("circuit_id_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex)), ("remote-id", ("remote_id", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId)), ("remote-id-regex", ("remote_id_regex", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex)), ("src-port", ("src_port", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort)), ("dst-port", ("dst_port", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort))])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchTypeEn', '')])),
                                                                                                ('mpls_top_eos', (YLeaf(YType.uint8, 'mpls-top-eos'), ['int'])),
                                                                                                ('fragment_type', (YLeaf(YType.uint8, 'fragment-type'), ['int'])),
                                                                                                ('authen_status', (YLeaf(YType.enumeration, 'authen-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchAuthenStatusEn', '')])),
                                                                                                ('mlp_negotiated', (YLeaf(YType.enumeration, 'mlp-negotiated'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchMlpNegotiatedEn', '')])),
                                                                                            ])
                                                                                            self.type = None
                                                                                            self.mpls_top_eos = None
                                                                                            self.fragment_type = None
                                                                                            self.authen_status = None
                                                                                            self.mlp_negotiated = None

                                                                                            self.ipv4_dscp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                            self.ipv4_dscp.parent = self
                                                                                            self._children_name_map["ipv4_dscp"] = "ipv4-dscp"

                                                                                            self.ipv6_dscp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                            self.ipv6_dscp.parent = self
                                                                                            self._children_name_map["ipv6_dscp"] = "ipv6-dscp"

                                                                                            self.dscp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                            self.dscp.parent = self
                                                                                            self._children_name_map["dscp"] = "dscp"

                                                                                            self.ipv4_prec = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                            self.ipv4_prec.parent = self
                                                                                            self._children_name_map["ipv4_prec"] = "ipv4-prec"

                                                                                            self.ipv6_prec = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                            self.ipv6_prec.parent = self
                                                                                            self._children_name_map["ipv6_prec"] = "ipv6-prec"

                                                                                            self.prec = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                            self.prec.parent = self
                                                                                            self._children_name_map["prec"] = "prec"

                                                                                            self.discard_class = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                            self.discard_class.parent = self
                                                                                            self._children_name_map["discard_class"] = "discard-class"

                                                                                            self.qos_group = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                            self.qos_group.parent = self
                                                                                            self._children_name_map["qos_group"] = "qos-group"

                                                                                            self.traffic_class = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                            self.traffic_class.parent = self
                                                                                            self._children_name_map["traffic_class"] = "traffic-class"

                                                                                            self.proto = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                            self.proto.parent = self
                                                                                            self._children_name_map["proto"] = "proto"

                                                                                            self.icmp_v4 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                            self.icmp_v4.parent = self
                                                                                            self._children_name_map["icmp_v4"] = "icmp-v4"

                                                                                            self.icmp_v6 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                            self.icmp_v6.parent = self
                                                                                            self._children_name_map["icmp_v6"] = "icmp-v6"

                                                                                            self.ipv4_packet_len = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                            self.ipv4_packet_len.parent = self
                                                                                            self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"

                                                                                            self.ipv6_packet_len = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                            self.ipv6_packet_len.parent = self
                                                                                            self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"

                                                                                            self.packet_len = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                            self.packet_len.parent = self
                                                                                            self._children_name_map["packet_len"] = "packet-len"

                                                                                            self.flow_tag = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                            self.flow_tag.parent = self
                                                                                            self._children_name_map["flow_tag"] = "flow-tag"

                                                                                            self.tcp_flag = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                            self.tcp_flag.parent = self
                                                                                            self._children_name_map["tcp_flag"] = "tcp-flag"

                                                                                            self.icmpv4_type = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                            self.icmpv4_type.parent = self
                                                                                            self._children_name_map["icmpv4_type"] = "icmpv4-type"

                                                                                            self.icmpv4_code = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                            self.icmpv4_code.parent = self
                                                                                            self._children_name_map["icmpv4_code"] = "icmpv4-code"

                                                                                            self.icmpv6_type = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                            self.icmpv6_type.parent = self
                                                                                            self._children_name_map["icmpv6_type"] = "icmpv6-type"

                                                                                            self.icmpv6_code = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                            self.icmpv6_code.parent = self
                                                                                            self._children_name_map["icmpv6_code"] = "icmpv6-code"

                                                                                            self.mpls_exp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                            self.mpls_exp.parent = self
                                                                                            self._children_name_map["mpls_exp"] = "mpls-exp"

                                                                                            self.mpls_exp_imp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                            self.mpls_exp_imp.parent = self
                                                                                            self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"

                                                                                            self.mpls_disp_ipv4_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                            self.mpls_disp_ipv4_acl.parent = self
                                                                                            self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"

                                                                                            self.mpls_disp_ipv6_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                            self.mpls_disp_ipv6_acl.parent = self
                                                                                            self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"

                                                                                            self.mpls_top_label = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                            self.mpls_top_label.parent = self
                                                                                            self._children_name_map["mpls_top_label"] = "mpls-top-label"

                                                                                            self.cos = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                            self.cos.parent = self
                                                                                            self._children_name_map["cos"] = "cos"

                                                                                            self.cos_inr = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                            self.cos_inr.parent = self
                                                                                            self._children_name_map["cos_inr"] = "cos-inr"

                                                                                            self.dei = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                            self.dei.parent = self
                                                                                            self._children_name_map["dei"] = "dei"

                                                                                            self.dei_inr = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                            self.dei_inr.parent = self
                                                                                            self._children_name_map["dei_inr"] = "dei-inr"

                                                                                            self.vlan = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                            self.vlan.parent = self
                                                                                            self._children_name_map["vlan"] = "vlan"

                                                                                            self.vlan_inr = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                            self.vlan_inr.parent = self
                                                                                            self._children_name_map["vlan_inr"] = "vlan-inr"

                                                                                            self.fr_dlci = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                            self.fr_dlci.parent = self
                                                                                            self._children_name_map["fr_dlci"] = "fr-dlci"

                                                                                            self.src_mac = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                            self.src_mac.parent = self
                                                                                            self._children_name_map["src_mac"] = "src-mac"

                                                                                            self.dst_mac = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                            self.dst_mac.parent = self
                                                                                            self._children_name_map["dst_mac"] = "dst-mac"

                                                                                            self.atm_clp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                            self.atm_clp.parent = self
                                                                                            self._children_name_map["atm_clp"] = "atm-clp"

                                                                                            self.fr_de = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                            self.fr_de.parent = self
                                                                                            self._children_name_map["fr_de"] = "fr-de"

                                                                                            self.ipv4_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                            self.ipv4_acl.parent = self
                                                                                            self._children_name_map["ipv4_acl"] = "ipv4-acl"

                                                                                            self.ipv6_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                            self.ipv6_acl.parent = self
                                                                                            self._children_name_map["ipv6_acl"] = "ipv6-acl"

                                                                                            self.ether_service_acl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                            self.ether_service_acl.parent = self
                                                                                            self._children_name_map["ether_service_acl"] = "ether-service-acl"

                                                                                            self.avail_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                            self.avail_id.parent = self
                                                                                            self._children_name_map["avail_id"] = "avail-id"

                                                                                            self.media_type = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                            self.media_type.parent = self
                                                                                            self._children_name_map["media_type"] = "media-type"

                                                                                            self.subs_protocol = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                            self.subs_protocol.parent = self
                                                                                            self._children_name_map["subs_protocol"] = "subs-protocol"

                                                                                            self.dnis = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                            self.dnis.parent = self
                                                                                            self._children_name_map["dnis"] = "dnis"

                                                                                            self.dnis_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                            self.dnis_regex.parent = self
                                                                                            self._children_name_map["dnis_regex"] = "dnis-regex"

                                                                                            self.domain = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                            self.domain.parent = self
                                                                                            self._children_name_map["domain"] = "domain"

                                                                                            self.domain_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                            self.domain_regex.parent = self
                                                                                            self._children_name_map["domain_regex"] = "domain-regex"

                                                                                            self.nas_port = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                            self.nas_port.parent = self
                                                                                            self._children_name_map["nas_port"] = "nas-port"

                                                                                            self.service_name = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                            self.service_name.parent = self
                                                                                            self._children_name_map["service_name"] = "service-name"

                                                                                            self.service_name_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                            self.service_name_regex.parent = self
                                                                                            self._children_name_map["service_name_regex"] = "service-name-regex"

                                                                                            self.src_addr_ipv4 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                            self.src_addr_ipv4.parent = self
                                                                                            self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"

                                                                                            self.dst_addr_ipv4 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                            self.dst_addr_ipv4.parent = self
                                                                                            self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"

                                                                                            self.src_addr_ipv6 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                            self.src_addr_ipv6.parent = self
                                                                                            self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"

                                                                                            self.dst_addr_ipv6 = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                            self.dst_addr_ipv6.parent = self
                                                                                            self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"

                                                                                            self.src_addr_mac = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                            self.src_addr_mac.parent = self
                                                                                            self._children_name_map["src_addr_mac"] = "src-addr-mac"

                                                                                            self.timer = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                            self.timer.parent = self
                                                                                            self._children_name_map["timer"] = "timer"

                                                                                            self.timer_regexp = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                            self.timer_regexp.parent = self
                                                                                            self._children_name_map["timer_regexp"] = "timer-regexp"

                                                                                            self.tunnel_name = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                            self.tunnel_name.parent = self
                                                                                            self._children_name_map["tunnel_name"] = "tunnel-name"

                                                                                            self.tunnel_name_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                            self.tunnel_name_regex.parent = self
                                                                                            self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"

                                                                                            self.user_name = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                            self.user_name.parent = self
                                                                                            self._children_name_map["user_name"] = "user-name"

                                                                                            self.user_name_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                            self.user_name_regex.parent = self
                                                                                            self._children_name_map["user_name_regex"] = "user-name-regex"

                                                                                            self.auth_username = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                            self.auth_username.parent = self
                                                                                            self._children_name_map["auth_username"] = "auth-username"

                                                                                            self.auth_username_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                            self.auth_username_regex.parent = self
                                                                                            self._children_name_map["auth_username_regex"] = "auth-username-regex"

                                                                                            self.unauth_username = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                            self.unauth_username.parent = self
                                                                                            self._children_name_map["unauth_username"] = "unauth-username"

                                                                                            self.unauth_username_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                            self.unauth_username_regex.parent = self
                                                                                            self._children_name_map["unauth_username_regex"] = "unauth-username-regex"

                                                                                            self.auth_domain = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                            self.auth_domain.parent = self
                                                                                            self._children_name_map["auth_domain"] = "auth-domain"

                                                                                            self.auth_domain_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                            self.auth_domain_regex.parent = self
                                                                                            self._children_name_map["auth_domain_regex"] = "auth-domain-regex"

                                                                                            self.unauth_domain = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                            self.unauth_domain.parent = self
                                                                                            self._children_name_map["unauth_domain"] = "unauth-domain"

                                                                                            self.unauth_domain_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                            self.unauth_domain_regex.parent = self
                                                                                            self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"

                                                                                            self.vendor_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                            self.vendor_id.parent = self
                                                                                            self._children_name_map["vendor_id"] = "vendor-id"

                                                                                            self.vendor_id_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                            self.vendor_id_regex.parent = self
                                                                                            self._children_name_map["vendor_id_regex"] = "vendor-id-regex"

                                                                                            self.access_interface = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                            self.access_interface.parent = self
                                                                                            self._children_name_map["access_interface"] = "access-interface"

                                                                                            self.input_interface = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                            self.input_interface.parent = self
                                                                                            self._children_name_map["input_interface"] = "input-interface"

                                                                                            self.input_intfhdl = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                            self.input_intfhdl.parent = self
                                                                                            self._children_name_map["input_intfhdl"] = "input-intfhdl"

                                                                                            self.ethertype = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                            self.ethertype.parent = self
                                                                                            self._children_name_map["ethertype"] = "ethertype"

                                                                                            self.flow_key_data = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                            self.flow_key_data.parent = self
                                                                                            self._children_name_map["flow_key_data"] = "flow-key-data"

                                                                                            self.dhcp_client_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                            self.dhcp_client_id.parent = self
                                                                                            self._children_name_map["dhcp_client_id"] = "dhcp-client-id"

                                                                                            self.dhcp_client_id_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                            self.dhcp_client_id_regex.parent = self
                                                                                            self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"

                                                                                            self.circuit_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                            self.circuit_id.parent = self
                                                                                            self._children_name_map["circuit_id"] = "circuit-id"

                                                                                            self.circuit_id_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                            self.circuit_id_regex.parent = self
                                                                                            self._children_name_map["circuit_id_regex"] = "circuit-id-regex"

                                                                                            self.remote_id = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                            self.remote_id.parent = self
                                                                                            self._children_name_map["remote_id"] = "remote-id"

                                                                                            self.remote_id_regex = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                            self.remote_id_regex.parent = self
                                                                                            self._children_name_map["remote_id_regex"] = "remote-id-regex"

                                                                                            self.src_port = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                            self.src_port.parent = self
                                                                                            self._children_name_map["src_port"] = "src-port"

                                                                                            self.dst_port = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                            self.dst_port.parent = self
                                                                                            self._children_name_map["dst_port"] = "dst-port"
                                                                                            self._segment_path = lambda: "match-data"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['type', 'mpls_top_eos', 'fragment_type', 'authen_status', 'mlp_negotiated'], name, value)


                                                                                        class Ipv4Dscp(Entity):
                                                                                            """
                                                                                            IPv4 DSCP
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                self.yang_name = "ipv4-dscp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ipv4-dscp"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "ipv4-dscp"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                        class Ipv6Dscp(Entity):
                                                                                            """
                                                                                            IPv6 DSCP
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                self.yang_name = "ipv6-dscp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ipv6-dscp"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "ipv6-dscp"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                        class Dscp(Entity):
                                                                                            """
                                                                                            Match DSCP range array
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                self.yang_name = "dscp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "dscp"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "dscp"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                        class Ipv4Prec(Entity):
                                                                                            """
                                                                                            IPv4 Precedence
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                self.yang_name = "ipv4-prec"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "ipv4-prec"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                        class Ipv6Prec(Entity):
                                                                                            """
                                                                                            IPv6 Precedence
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                self.yang_name = "ipv6-prec"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "ipv6-prec"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                        class Prec(Entity):
                                                                                            """
                                                                                            Match Precedence array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                self.yang_name = "prec"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "prec"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                        class DiscardClass(Entity):
                                                                                            """
                                                                                            Match Discard Class array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                self.yang_name = "discard-class"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "discard-class"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                        class QosGroup(Entity):
                                                                                            """
                                                                                            Match QoS group array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                self.yang_name = "qos-group"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "qos-group"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "qos-group"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['min', 'max'], name, value)


                                                                                        class TrafficClass(Entity):
                                                                                            """
                                                                                            Match Traffic class array
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                self.yang_name = "traffic-class"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "traffic-class"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "traffic-class"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['min', 'max'], name, value)


                                                                                        class Proto(Entity):
                                                                                            """
                                                                                            Match Protocol array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                self.yang_name = "proto"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "proto"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "proto"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['min', 'max'], name, value)


                                                                                        class IcmpV4(Entity):
                                                                                            """
                                                                                            Match ICMPV4 Protocol
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	Protocol type
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: code
                                                                                            
                                                                                            	Protocol code
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                self.yang_name = "icmp-v4"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                    ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                ])
                                                                                                self.type = None
                                                                                                self.code = None
                                                                                                self._segment_path = lambda: "icmp-v4"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['type', 'code'], name, value)


                                                                                        class IcmpV6(Entity):
                                                                                            """
                                                                                            Match ICMPV6 Protocol array
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	Protocol type
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: code
                                                                                            
                                                                                            	Protocol code
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                self.yang_name = "icmp-v6"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                    ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                ])
                                                                                                self.type = None
                                                                                                self.code = None
                                                                                                self._segment_path = lambda: "icmp-v6"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['type', 'code'], name, value)


                                                                                        class Ipv4PacketLen(Entity):
                                                                                            """
                                                                                            IPv4 packet length array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                self.yang_name = "ipv4-packet-len"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ipv4-packet-len"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "ipv4-packet-len"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                        class Ipv6PacketLen(Entity):
                                                                                            """
                                                                                            IPv6 packet length array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                self.yang_name = "ipv6-packet-len"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ipv6-packet-len"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "ipv6-packet-len"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                        class PacketLen(Entity):
                                                                                            """
                                                                                            Match packet length array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                self.yang_name = "packet-len"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "packet-len"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "packet-len"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                        class FlowTag(Entity):
                                                                                            """
                                                                                            Match flow\-tag array
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                self.yang_name = "flow-tag"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "flow-tag"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "flow-tag"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['min', 'max'], name, value)


                                                                                        class TcpFlag(Entity):
                                                                                            """
                                                                                            Match tcp flag value
                                                                                            
                                                                                            .. attribute:: value
                                                                                            
                                                                                            	Value of TCP flag
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: match_any
                                                                                            
                                                                                            	Match any TCP flag bit
                                                                                            	**type**\: bool
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                self.yang_name = "tcp-flag"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                                    ('match_any', (YLeaf(YType.boolean, 'match-any'), ['bool'])),
                                                                                                ])
                                                                                                self.value = None
                                                                                                self.match_any = None
                                                                                                self._segment_path = lambda: "tcp-flag"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['value', 'match_any'], name, value)


                                                                                        class Icmpv4Type(Entity):
                                                                                            """
                                                                                            Match ipv4 icmp type
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                self.yang_name = "icmpv4-type"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "icmpv4-type"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "icmpv4-type"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                        class Icmpv4Code(Entity):
                                                                                            """
                                                                                            Match ipv4 icmp code
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                self.yang_name = "icmpv4-code"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "icmpv4-code"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "icmpv4-code"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                        class Icmpv6Type(Entity):
                                                                                            """
                                                                                            Match ipv6 icmp type
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                self.yang_name = "icmpv6-type"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "icmpv6-type"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "icmpv6-type"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                        class Icmpv6Code(Entity):
                                                                                            """
                                                                                            Match ipv6 icmp code
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                self.yang_name = "icmpv6-code"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "icmpv6-code"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "icmpv6-code"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                        class MplsExp(Entity):
                                                                                            """
                                                                                            Match MPLS experimental topmost array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                self.yang_name = "mpls-exp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "mpls-exp"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                        class MplsExpImp(Entity):
                                                                                            """
                                                                                            Match MPLS experimental imposition array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                self.yang_name = "mpls-exp-imp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "mpls-exp-imp"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                        class MplsDispIpv4Acl(Entity):
                                                                                            """
                                                                                            MPLS Disposition IPv4 Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "mpls-disp-ipv4-acl"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                        class MplsDispIpv6Acl(Entity):
                                                                                            """
                                                                                            MPLS Disposition IPv6 Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "mpls-disp-ipv6-acl"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                        class MplsTopLabel(Entity):
                                                                                            """
                                                                                            MPLS Topmost LABEL
                                                                                            
                                                                                            .. attribute:: uint32_rng_array
                                                                                            
                                                                                            	uint32 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                self.yang_name = "mpls-top-label"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint32_rng_array", ("uint32_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint32_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "mpls-top-label"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                            class Uint32RngArray(Entity):
                                                                                                """
                                                                                                uint32 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                    self.yang_name = "uint32_rng_array"
                                                                                                    self.yang_parent_name = "mpls-top-label"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint32, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint32, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint32_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['min', 'max'], name, value)


                                                                                        class Cos(Entity):
                                                                                            """
                                                                                            Match CoS array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                self.yang_name = "cos"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "cos"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                        class CosInr(Entity):
                                                                                            """
                                                                                            Match inner header CoS
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                self.yang_name = "cos-inr"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "cos-inr"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                        class Dei(Entity):
                                                                                            """
                                                                                            Match DEI Bit
                                                                                            
                                                                                            .. attribute:: bit_value
                                                                                            
                                                                                            	Value of the DEI bit
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                self.yang_name = "dei"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                ])
                                                                                                self.bit_value = None
                                                                                                self._segment_path = lambda: "dei"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                        class DeiInr(Entity):
                                                                                            """
                                                                                            Match inner DEI Bit
                                                                                            
                                                                                            .. attribute:: bit_value
                                                                                            
                                                                                            	Value of the DEI bit
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                self.yang_name = "dei-inr"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                ])
                                                                                                self.bit_value = None
                                                                                                self._segment_path = lambda: "dei-inr"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                        class Vlan(Entity):
                                                                                            """
                                                                                            Match VLAN array
                                                                                            
                                                                                            .. attribute:: vlan_id_array
                                                                                            
                                                                                            	vlan id array
                                                                                            	**type**\: list of  		 :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                self.yang_name = "vlan"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("vlan-id-array", ("vlan_id_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.vlan_id_array = YList(self)
                                                                                                self._segment_path = lambda: "vlan"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                            class VlanIdArray(Entity):
                                                                                                """
                                                                                                vlan id array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	VLAN mask
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                    self.yang_name = "vlan-id-array"
                                                                                                    self.yang_parent_name = "vlan"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ('mask', (YLeaf(YType.uint16, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self.mask = None
                                                                                                    self._segment_path = lambda: "vlan-id-array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['min', 'max', 'mask'], name, value)


                                                                                        class VlanInr(Entity):
                                                                                            """
                                                                                            Match inner header VLAN range array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                self.yang_name = "vlan-inr"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "vlan-inr"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "vlan-inr"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['min', 'max'], name, value)


                                                                                        class FrDlci(Entity):
                                                                                            """
                                                                                            Match FR DLCI range array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                self.yang_name = "fr-dlci"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "fr-dlci"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "fr-dlci"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['min', 'max'], name, value)


                                                                                        class SrcMac(Entity):
                                                                                            """
                                                                                            Match Source MAC address
                                                                                            
                                                                                            .. attribute:: mac_addr
                                                                                            
                                                                                            	MAC address
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	MAC mask
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                self.yang_name = "src-mac"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                    ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                ])
                                                                                                self.mac_addr = []
                                                                                                self.mask = []
                                                                                                self._segment_path = lambda: "src-mac"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                        class DstMac(Entity):
                                                                                            """
                                                                                            Match Destination MAC address
                                                                                            
                                                                                            .. attribute:: mac_addr
                                                                                            
                                                                                            	MAC address
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	MAC mask
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                self.yang_name = "dst-mac"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                    ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                ])
                                                                                                self.mac_addr = []
                                                                                                self.mask = []
                                                                                                self._segment_path = lambda: "dst-mac"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                        class AtmClp(Entity):
                                                                                            """
                                                                                            Match ATM CLP level
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                self.yang_name = "atm-clp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "atm-clp"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                        class FrDe(Entity):
                                                                                            """
                                                                                            Match FR DE value
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                self.yang_name = "fr-de"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "fr-de"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                        class Ipv4Acl(Entity):
                                                                                            """
                                                                                            IPv4 Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                self.yang_name = "ipv4-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "ipv4-acl"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                        class Ipv6Acl(Entity):
                                                                                            """
                                                                                            IPv6 Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                self.yang_name = "ipv6-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "ipv6-acl"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                        class EtherServiceAcl(Entity):
                                                                                            """
                                                                                            Ethernet\-Services Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                self.yang_name = "ether-service-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "ether-service-acl"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                        class AvailId(Entity):
                                                                                            """
                                                                                            Available Identifiers
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                self.yang_name = "avail-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "avail-id"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                        class MediaType(Entity):
                                                                                            """
                                                                                            Media Type
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                self.yang_name = "media-type"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "media-type"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                        class SubsProtocol(Entity):
                                                                                            """
                                                                                            Protocol
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                self.yang_name = "subs-protocol"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "subs-protocol"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                        class Dnis(Entity):
                                                                                            """
                                                                                            DNIS
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                self.yang_name = "dnis"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "dnis"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                        class DnisRegex(Entity):
                                                                                            """
                                                                                            DNIS Regular Expression
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                self.yang_name = "dnis-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "dnis-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                        class Domain(Entity):
                                                                                            """
                                                                                            Domain Name
                                                                                            
                                                                                            .. attribute:: domain_array
                                                                                            
                                                                                            	domain array
                                                                                            	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                self.yang_name = "domain"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.domain_array = YList(self)
                                                                                                self._segment_path = lambda: "domain"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                            class DomainArray(Entity):
                                                                                                """
                                                                                                domain array
                                                                                                
                                                                                                .. attribute:: domain_name
                                                                                                
                                                                                                	domain name
                                                                                                	**type**\: str
                                                                                                
                                                                                                .. attribute:: format_name
                                                                                                
                                                                                                	format name
                                                                                                	**type**\: str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                    self.yang_name = "domain-array"
                                                                                                    self.yang_parent_name = "domain"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                        ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                    ])
                                                                                                    self.domain_name = None
                                                                                                    self.format_name = None
                                                                                                    self._segment_path = lambda: "domain-array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                        class DomainRegex(Entity):
                                                                                            """
                                                                                            Domain Regular Expression
                                                                                            
                                                                                            .. attribute:: domain_array
                                                                                            
                                                                                            	domain array
                                                                                            	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                self.yang_name = "domain-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.domain_array = YList(self)
                                                                                                self._segment_path = lambda: "domain-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                            class DomainArray(Entity):
                                                                                                """
                                                                                                domain array
                                                                                                
                                                                                                .. attribute:: domain_name
                                                                                                
                                                                                                	domain name
                                                                                                	**type**\: str
                                                                                                
                                                                                                .. attribute:: format_name
                                                                                                
                                                                                                	format name
                                                                                                	**type**\: str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                    self.yang_name = "domain-array"
                                                                                                    self.yang_parent_name = "domain-regex"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                        ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                    ])
                                                                                                    self.domain_name = None
                                                                                                    self.format_name = None
                                                                                                    self._segment_path = lambda: "domain-array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                        class NasPort(Entity):
                                                                                            """
                                                                                            NAS Port
                                                                                            
                                                                                            .. attribute:: nas_port_array
                                                                                            
                                                                                            	nas port array
                                                                                            	**type**\: list of  		 :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                self.yang_name = "nas-port"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("nas-port-array", ("nas_port_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.nas_port_array = YList(self)
                                                                                                self._segment_path = lambda: "nas-port"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                            class NasPortArray(Entity):
                                                                                                """
                                                                                                nas port array
                                                                                                
                                                                                                .. attribute:: sub_id
                                                                                                
                                                                                                	sub id
                                                                                                	**type**\:  :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                
                                                                                                .. attribute:: operator
                                                                                                
                                                                                                	operator
                                                                                                	**type**\:  :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                
                                                                                                .. attribute:: value
                                                                                                
                                                                                                	value
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                    self.yang_name = "nas-port-array"
                                                                                                    self.yang_parent_name = "nas-port"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('sub_id', (YLeaf(YType.enumeration, 'sub-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchNasPortSubIdEn', '')])),
                                                                                                        ('operator', (YLeaf(YType.enumeration, 'operator'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchLogicalOperatorEn', '')])),
                                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                                    ])
                                                                                                    self.sub_id = None
                                                                                                    self.operator = None
                                                                                                    self.value = None
                                                                                                    self._segment_path = lambda: "nas-port-array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['sub_id', 'operator', 'value'], name, value)


                                                                                        class ServiceName(Entity):
                                                                                            """
                                                                                            Service Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                self.yang_name = "service-name"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "service-name"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                        class ServiceNameRegex(Entity):
                                                                                            """
                                                                                            Service Name Regular Exp
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                self.yang_name = "service-name-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "service-name-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                        class SrcAddrIpv4(Entity):
                                                                                            """
                                                                                            Source Address IPV4
                                                                                            
                                                                                            .. attribute:: ipv4_addr_array
                                                                                            
                                                                                            	ipv4 addr array
                                                                                            	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                self.yang_name = "src-addr-ipv4"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.ipv4_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "src-addr-ipv4"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                            class Ipv4AddrArray(Entity):
                                                                                                """
                                                                                                ipv4 addr array
                                                                                                
                                                                                                .. attribute:: prefix
                                                                                                
                                                                                                	prefix
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	mask
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                    self.yang_name = "ipv4-addr-array"
                                                                                                    self.yang_parent_name = "src-addr-ipv4"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                        ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                    ])
                                                                                                    self.prefix = None
                                                                                                    self.mask = None
                                                                                                    self._segment_path = lambda: "ipv4-addr-array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                        class DstAddrIpv4(Entity):
                                                                                            """
                                                                                            Destination Address IPV4
                                                                                            
                                                                                            .. attribute:: ipv4_addr_array
                                                                                            
                                                                                            	ipv4 addr array
                                                                                            	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                self.yang_name = "dst-addr-ipv4"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.ipv4_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "dst-addr-ipv4"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                            class Ipv4AddrArray(Entity):
                                                                                                """
                                                                                                ipv4 addr array
                                                                                                
                                                                                                .. attribute:: prefix
                                                                                                
                                                                                                	prefix
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	mask
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                    self.yang_name = "ipv4-addr-array"
                                                                                                    self.yang_parent_name = "dst-addr-ipv4"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                        ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                    ])
                                                                                                    self.prefix = None
                                                                                                    self.mask = None
                                                                                                    self._segment_path = lambda: "ipv4-addr-array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                        class SrcAddrIpv6(Entity):
                                                                                            """
                                                                                            Source Address IPV6
                                                                                            
                                                                                            .. attribute:: ipv6_addr_array
                                                                                            
                                                                                            	ipv6 addr array
                                                                                            	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                self.yang_name = "src-addr-ipv6"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.ipv6_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "src-addr-ipv6"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                            class Ipv6AddrArray(Entity):
                                                                                                """
                                                                                                ipv6 addr array
                                                                                                
                                                                                                .. attribute:: prefix
                                                                                                
                                                                                                	IPV6 prefix
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	IPV6 mask
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                    self.yang_name = "ipv6-addr-array"
                                                                                                    self.yang_parent_name = "src-addr-ipv6"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                        ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.prefix = None
                                                                                                    self.mask = None
                                                                                                    self._segment_path = lambda: "ipv6-addr-array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                        class DstAddrIpv6(Entity):
                                                                                            """
                                                                                            Destination Address IPV6
                                                                                            
                                                                                            .. attribute:: ipv6_addr_array
                                                                                            
                                                                                            	ipv6 addr array
                                                                                            	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                self.yang_name = "dst-addr-ipv6"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.ipv6_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "dst-addr-ipv6"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                            class Ipv6AddrArray(Entity):
                                                                                                """
                                                                                                ipv6 addr array
                                                                                                
                                                                                                .. attribute:: prefix
                                                                                                
                                                                                                	IPV6 prefix
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	IPV6 mask
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                    self.yang_name = "ipv6-addr-array"
                                                                                                    self.yang_parent_name = "dst-addr-ipv6"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                        ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.prefix = None
                                                                                                    self.mask = None
                                                                                                    self._segment_path = lambda: "ipv6-addr-array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                        class SrcAddrMac(Entity):
                                                                                            """
                                                                                            Source Address MAC
                                                                                            
                                                                                            .. attribute:: mac_addr_array
                                                                                            
                                                                                            	mac addr array
                                                                                            	**type**\: list of  		 :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                self.yang_name = "src-addr-mac"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("mac-addr-array", ("mac_addr_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.mac_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "src-addr-mac"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                            class MacAddrArray(Entity):
                                                                                                """
                                                                                                mac addr array
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                    self.yang_name = "mac-addr-array"
                                                                                                    self.yang_parent_name = "src-addr-mac"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.mac_addr = []
                                                                                                    self.mask = []
                                                                                                    self._segment_path = lambda: "mac-addr-array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                        class Timer(Entity):
                                                                                            """
                                                                                            Timer
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                self.yang_name = "timer"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "timer"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                        class TimerRegexp(Entity):
                                                                                            """
                                                                                            Timer Regular Expression
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                self.yang_name = "timer-regexp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "timer-regexp"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                        class TunnelName(Entity):
                                                                                            """
                                                                                            Tunnel Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                self.yang_name = "tunnel-name"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "tunnel-name"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                        class TunnelNameRegex(Entity):
                                                                                            """
                                                                                            Tunnel Name Regular Expression
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                self.yang_name = "tunnel-name-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "tunnel-name-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                        class UserName(Entity):
                                                                                            """
                                                                                            User Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                self.yang_name = "user-name"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "user-name"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                        class UserNameRegex(Entity):
                                                                                            """
                                                                                            User Name Regular Expression
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                self.yang_name = "user-name-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "user-name-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                        class AuthUsername(Entity):
                                                                                            """
                                                                                            Authenticated User Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                self.yang_name = "auth-username"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "auth-username"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                        class AuthUsernameRegex(Entity):
                                                                                            """
                                                                                            Authenticated User Name RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                self.yang_name = "auth-username-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "auth-username-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                        class UnauthUsername(Entity):
                                                                                            """
                                                                                            Unauthenticated User Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                self.yang_name = "unauth-username"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "unauth-username"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                        class UnauthUsernameRegex(Entity):
                                                                                            """
                                                                                            Unauthenticated User Name RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                self.yang_name = "unauth-username-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "unauth-username-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                        class AuthDomain(Entity):
                                                                                            """
                                                                                            Authenticated domain name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                self.yang_name = "auth-domain"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "auth-domain"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                        class AuthDomainRegex(Entity):
                                                                                            """
                                                                                            Authenticated Domain Name RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                self.yang_name = "auth-domain-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "auth-domain-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                        class UnauthDomain(Entity):
                                                                                            """
                                                                                            Unauthenticated Domain Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                self.yang_name = "unauth-domain"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "unauth-domain"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                        class UnauthDomainRegex(Entity):
                                                                                            """
                                                                                            Unauthenticated Domain Name RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                self.yang_name = "unauth-domain-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "unauth-domain-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                        class VendorId(Entity):
                                                                                            """
                                                                                            Vendor ID
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                self.yang_name = "vendor-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "vendor-id"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                        class VendorIdRegex(Entity):
                                                                                            """
                                                                                            Vendor ID RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                self.yang_name = "vendor-id-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "vendor-id-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                        class AccessInterface(Entity):
                                                                                            """
                                                                                            Access interface
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                self.yang_name = "access-interface"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "access-interface"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                        class InputInterface(Entity):
                                                                                            """
                                                                                            Input interface
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                self.yang_name = "input-interface"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "input-interface"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                        class InputIntfhdl(Entity):
                                                                                            """
                                                                                            Input interface handle
                                                                                            
                                                                                            .. attribute:: uint64_array
                                                                                            
                                                                                            	uint64 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..18446744073709551615
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                self.yang_name = "input-intfhdl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint64_array', (YLeafList(YType.uint64, 'uint64_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint64_array = []
                                                                                                self._segment_path = lambda: "input-intfhdl"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                        class Ethertype(Entity):
                                                                                            """
                                                                                            Ethernet type
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                self.yang_name = "ethertype"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ethertype"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "ethertype"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['min', 'max'], name, value)


                                                                                        class FlowKeyData(Entity):
                                                                                            """
                                                                                            Flow key structure
                                                                                            
                                                                                            .. attribute:: flow_keys
                                                                                            
                                                                                            	flow keys
                                                                                            	**type**\:  :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                            
                                                                                            .. attribute:: max_count
                                                                                            
                                                                                            	Maximum count of flows
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: idle_timeout
                                                                                            
                                                                                            	Idle timeout of flows (in seconds)
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            	**units**\: second
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                self.yang_name = "flow-key-data"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("flow-keys", ("flow_keys", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys))])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('max_count', (YLeaf(YType.uint16, 'max-count'), ['int'])),
                                                                                                    ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                                                ])
                                                                                                self.max_count = None
                                                                                                self.idle_timeout = None

                                                                                                self.flow_keys = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                self.flow_keys.parent = self
                                                                                                self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                self._segment_path = lambda: "flow-key-data"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['max_count', 'idle_timeout'], name, value)


                                                                                            class FlowKeys(Entity):
                                                                                                """
                                                                                                flow keys
                                                                                                
                                                                                                .. attribute:: keys
                                                                                                
                                                                                                	keys
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                
                                                                                                .. attribute:: num
                                                                                                
                                                                                                	num
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                    self.yang_name = "flow-keys"
                                                                                                    self.yang_parent_name = "flow-key-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('keys', (YLeaf(YType.str, 'keys'), ['str'])),
                                                                                                        ('num', (YLeaf(YType.uint8, 'num'), ['int'])),
                                                                                                    ])
                                                                                                    self.keys = None
                                                                                                    self.num = None
                                                                                                    self._segment_path = lambda: "flow-keys"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                        class DhcpClientId(Entity):
                                                                                            """
                                                                                            Dhcp Client ID
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                self.yang_name = "dhcp-client-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "dhcp-client-id"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                        class DhcpClientIdRegex(Entity):
                                                                                            """
                                                                                            Dhcp Client ID RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                self.yang_name = "dhcp-client-id-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "dhcp-client-id-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                        class CircuitId(Entity):
                                                                                            """
                                                                                            Circuit ID
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                self.yang_name = "circuit-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "circuit-id"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                        class CircuitIdRegex(Entity):
                                                                                            """
                                                                                            Circuit ID RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                self.yang_name = "circuit-id-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "circuit-id-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                        class RemoteId(Entity):
                                                                                            """
                                                                                            Remote ID
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                self.yang_name = "remote-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "remote-id"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                        class RemoteIdRegex(Entity):
                                                                                            """
                                                                                            Remote ID RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                self.yang_name = "remote-id-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "remote-id-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                        class SrcPort(Entity):
                                                                                            """
                                                                                            Source port
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                self.yang_name = "src-port"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "src-port"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "src-port"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                                        class DstPort(Entity):
                                                                                            """
                                                                                            Destination port
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                self.yang_name = "dst-port"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "dst-port"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "dst-port"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                class Shape(Entity):
                                                                    """
                                                                    shape
                                                                    
                                                                    .. attribute:: bw
                                                                    
                                                                    	bw
                                                                    	**type**\:  :py:class:`Bw <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw>`
                                                                    
                                                                    .. attribute:: be
                                                                    
                                                                    	be
                                                                    	**type**\:  :py:class:`Be <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape, self).__init__()

                                                                        self.yang_name = "shape"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("bw", ("bw", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw)), ("be", ("be", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be))])
                                                                        self._leafs = OrderedDict()

                                                                        self.bw = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw()
                                                                        self.bw.parent = self
                                                                        self._children_name_map["bw"] = "bw"

                                                                        self.be = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be()
                                                                        self.be.parent = self
                                                                        self._children_name_map["be"] = "be"
                                                                        self._segment_path = lambda: "shape"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape, [], name, value)


                                                                    class Bw(Entity):
                                                                        """
                                                                        bw
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw, self).__init__()

                                                                            self.yang_name = "bw"
                                                                            self.yang_parent_name = "shape"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                            ])
                                                                            self.value = None
                                                                            self.unit = None
                                                                            self._segment_path = lambda: "bw"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw, ['value', 'unit'], name, value)


                                                                    class Be(Entity):
                                                                        """
                                                                        be
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be, self).__init__()

                                                                            self.yang_name = "be"
                                                                            self.yang_parent_name = "shape"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                            ])
                                                                            self.value = None
                                                                            self.unit = None
                                                                            self._segment_path = lambda: "be"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be, ['value', 'unit'], name, value)


                                                                class ChildPolicy(Entity):
                                                                    """
                                                                    child policy
                                                                    
                                                                    .. attribute:: info
                                                                    
                                                                    	info
                                                                    	**type**\:  :py:class:`Info <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info>`
                                                                    
                                                                    .. attribute:: hd_info
                                                                    
                                                                    	hd info
                                                                    	**type**\:  :py:class:`HdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo>`
                                                                    
                                                                    .. attribute:: enc
                                                                    
                                                                    	enc
                                                                    	**type**\:  :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy, self).__init__()

                                                                        self.yang_name = "child-policy"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("info", ("info", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info)), ("hd-info", ("hd_info", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo))])
                                                                        self._leafs = OrderedDict([
                                                                            ('enc', (YLeaf(YType.enumeration, 'enc'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyObjEncEn', '')])),
                                                                        ])
                                                                        self.enc = None

                                                                        self.info = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info()
                                                                        self.info.parent = self
                                                                        self._children_name_map["info"] = "info"

                                                                        self.hd_info = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo()
                                                                        self.hd_info.parent = self
                                                                        self._children_name_map["hd_info"] = "hd-info"
                                                                        self._segment_path = lambda: "child-policy"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy, ['enc'], name, value)


                                                                    class Info(Entity):
                                                                        """
                                                                        info
                                                                        
                                                                        .. attribute:: name
                                                                        
                                                                        	name
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..65
                                                                        
                                                                        .. attribute:: type
                                                                        
                                                                        	type
                                                                        	**type**\:  :py:class:`PolicyMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyMapTypeEn>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info, self).__init__()

                                                                            self.yang_name = "info"
                                                                            self.yang_parent_name = "child-policy"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                                ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyMapTypeEn', '')])),
                                                                            ])
                                                                            self.name = None
                                                                            self.type = None
                                                                            self._segment_path = lambda: "info"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info, ['name', 'type'], name, value)


                                                                    class HdInfo(Entity):
                                                                        """
                                                                        hd info
                                                                        
                                                                        .. attribute:: data_hd
                                                                        
                                                                        	data hd
                                                                        	**type**\:  :py:class:`DataHd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd>`
                                                                        
                                                                        .. attribute:: hd
                                                                        
                                                                        	hd
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo, self).__init__()

                                                                            self.yang_name = "hd-info"
                                                                            self.yang_parent_name = "child-policy"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("data-hd", ("data_hd", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd))])
                                                                            self._leafs = OrderedDict([
                                                                                ('hd', (YLeaf(YType.uint64, 'hd'), ['int'])),
                                                                            ])
                                                                            self.hd = None

                                                                            self.data_hd = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd()
                                                                            self.data_hd.parent = self
                                                                            self._children_name_map["data_hd"] = "data-hd"
                                                                            self._segment_path = lambda: "hd-info"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo, ['hd'], name, value)


                                                                        class DataHd(Entity):
                                                                            """
                                                                            data hd
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd, self).__init__()

                                                                                self.yang_name = "data-hd"
                                                                                self.yang_parent_name = "hd-info"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict()
                                                                                self._segment_path = lambda: "data-hd"
                                                                                self._is_frozen = True


                                                                class Cac(Entity):
                                                                    """
                                                                    cac
                                                                    
                                                                    .. attribute:: flow_rate
                                                                    
                                                                    	flow rate
                                                                    	**type**\:  :py:class:`FlowRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate>`
                                                                    
                                                                    .. attribute:: rate
                                                                    
                                                                    	rate
                                                                    	**type**\:  :py:class:`Rate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate>`
                                                                    
                                                                    .. attribute:: cac_type
                                                                    
                                                                    	cac type
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    .. attribute:: idle_timeout
                                                                    
                                                                    	idle timeout
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..65535
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac, self).__init__()

                                                                        self.yang_name = "cac"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("flow-rate", ("flow_rate", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate)), ("rate", ("rate", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate))])
                                                                        self._leafs = OrderedDict([
                                                                            ('cac_type', (YLeaf(YType.uint8, 'cac-type'), ['int'])),
                                                                            ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                        ])
                                                                        self.cac_type = None
                                                                        self.idle_timeout = None

                                                                        self.flow_rate = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate()
                                                                        self.flow_rate.parent = self
                                                                        self._children_name_map["flow_rate"] = "flow-rate"

                                                                        self.rate = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate()
                                                                        self.rate.parent = self
                                                                        self._children_name_map["rate"] = "rate"
                                                                        self._segment_path = lambda: "cac"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac, ['cac_type', 'idle_timeout'], name, value)


                                                                    class FlowRate(Entity):
                                                                        """
                                                                        flow rate
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate, self).__init__()

                                                                            self.yang_name = "flow-rate"
                                                                            self.yang_parent_name = "cac"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                            ])
                                                                            self.value = None
                                                                            self.unit = None
                                                                            self._segment_path = lambda: "flow-rate"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate, ['value', 'unit'], name, value)


                                                                    class Rate(Entity):
                                                                        """
                                                                        rate
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate, self).__init__()

                                                                            self.yang_name = "rate"
                                                                            self.yang_parent_name = "cac"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                            ])
                                                                            self.value = None
                                                                            self.unit = None
                                                                            self._segment_path = lambda: "rate"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate, ['value', 'unit'], name, value)


                                                                class Pfc(Entity):
                                                                    """
                                                                    pfc
                                                                    
                                                                    .. attribute:: buffer_size
                                                                    
                                                                    	buffer size
                                                                    	**type**\:  :py:class:`BufferSize <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize>`
                                                                    
                                                                    .. attribute:: pause_threshold
                                                                    
                                                                    	pause threshold
                                                                    	**type**\:  :py:class:`PauseThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold>`
                                                                    
                                                                    .. attribute:: resume_threshold
                                                                    
                                                                    	resume threshold
                                                                    	**type**\:  :py:class:`ResumeThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold>`
                                                                    
                                                                    .. attribute:: pfc_pause_set
                                                                    
                                                                    	pfc pause set
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: buffer_size_flag
                                                                    
                                                                    	buffer size flag
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc, self).__init__()

                                                                        self.yang_name = "pfc"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("buffer-size", ("buffer_size", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize)), ("pause-threshold", ("pause_threshold", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold)), ("resume-threshold", ("resume_threshold", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold))])
                                                                        self._leafs = OrderedDict([
                                                                            ('pfc_pause_set', (YLeaf(YType.uint32, 'pfc-pause-set'), ['int'])),
                                                                            ('buffer_size_flag', (YLeaf(YType.uint32, 'buffer-size-flag'), ['int'])),
                                                                        ])
                                                                        self.pfc_pause_set = None
                                                                        self.buffer_size_flag = None

                                                                        self.buffer_size = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize()
                                                                        self.buffer_size.parent = self
                                                                        self._children_name_map["buffer_size"] = "buffer-size"

                                                                        self.pause_threshold = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold()
                                                                        self.pause_threshold.parent = self
                                                                        self._children_name_map["pause_threshold"] = "pause-threshold"

                                                                        self.resume_threshold = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold()
                                                                        self.resume_threshold.parent = self
                                                                        self._children_name_map["resume_threshold"] = "resume-threshold"
                                                                        self._segment_path = lambda: "pfc"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc, ['pfc_pause_set', 'buffer_size_flag'], name, value)


                                                                    class BufferSize(Entity):
                                                                        """
                                                                        buffer size
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize, self).__init__()

                                                                            self.yang_name = "buffer-size"
                                                                            self.yang_parent_name = "pfc"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                            ])
                                                                            self.value = None
                                                                            self.unit = None
                                                                            self._segment_path = lambda: "buffer-size"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize, ['value', 'unit'], name, value)


                                                                    class PauseThreshold(Entity):
                                                                        """
                                                                        pause threshold
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold, self).__init__()

                                                                            self.yang_name = "pause-threshold"
                                                                            self.yang_parent_name = "pfc"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                            ])
                                                                            self.value = None
                                                                            self.unit = None
                                                                            self._segment_path = lambda: "pause-threshold"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold, ['value', 'unit'], name, value)


                                                                    class ResumeThreshold(Entity):
                                                                        """
                                                                        resume threshold
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold, self).__init__()

                                                                            self.yang_name = "resume-threshold"
                                                                            self.yang_parent_name = "pfc"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                            ])
                                                                            self.value = None
                                                                            self.unit = None
                                                                            self._segment_path = lambda: "resume-threshold"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold, ['value', 'unit'], name, value)


                                                                class FlowParm(Entity):
                                                                    """
                                                                    flow parm
                                                                    
                                                                    .. attribute:: max_mon_flows
                                                                    
                                                                    	max simult flows monitored per policy class
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: mon_interval
                                                                    
                                                                    	monitored interval duration in secs
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: second
                                                                    
                                                                    .. attribute:: intvl_hist
                                                                    
                                                                    	num intervals of data stored on rtr
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: flow_timeout
                                                                    
                                                                    	timeout in secs
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: second
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm, self).__init__()

                                                                        self.yang_name = "flow-parm"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('max_mon_flows', (YLeaf(YType.uint32, 'max-mon-flows'), ['int'])),
                                                                            ('mon_interval', (YLeaf(YType.uint32, 'mon-interval'), ['int'])),
                                                                            ('intvl_hist', (YLeaf(YType.uint32, 'intvl-hist'), ['int'])),
                                                                            ('flow_timeout', (YLeaf(YType.uint32, 'flow-timeout'), ['int'])),
                                                                        ])
                                                                        self.max_mon_flows = None
                                                                        self.mon_interval = None
                                                                        self.intvl_hist = None
                                                                        self.flow_timeout = None
                                                                        self._segment_path = lambda: "flow-parm"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm, ['max_mon_flows', 'mon_interval', 'intvl_hist', 'flow_timeout'], name, value)


                                                                class Ipcbr(Entity):
                                                                    """
                                                                    ipcbr
                                                                    
                                                                    .. attribute:: ip_bit_rate
                                                                    
                                                                    	data rate in bps
                                                                    	**type**\:  :py:class:`IpBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate>`
                                                                    
                                                                    .. attribute:: media_bit_rate
                                                                    
                                                                    	media data rate in bps
                                                                    	**type**\:  :py:class:`MediaBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate>`
                                                                    
                                                                    .. attribute:: action_metric_type
                                                                    
                                                                    	metric type
                                                                    	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                    
                                                                    .. attribute:: ip_pkt_rate
                                                                    
                                                                    	packet rate in pps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: media_pkt_size
                                                                    
                                                                    	media packet size in bytes
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: media_pkts_per_ip
                                                                    
                                                                    	media packets per ip pkt
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr, self).__init__()

                                                                        self.yang_name = "ipcbr"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("ip-bit-rate", ("ip_bit_rate", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate)), ("media-bit-rate", ("media_bit_rate", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate))])
                                                                        self._leafs = OrderedDict([
                                                                            ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                            ('ip_pkt_rate', (YLeaf(YType.uint32, 'ip-pkt-rate'), ['int'])),
                                                                            ('media_pkt_size', (YLeaf(YType.uint32, 'media-pkt-size'), ['int'])),
                                                                            ('media_pkts_per_ip', (YLeaf(YType.uint32, 'media-pkts-per-ip'), ['int'])),
                                                                        ])
                                                                        self.action_metric_type = None
                                                                        self.ip_pkt_rate = None
                                                                        self.media_pkt_size = None
                                                                        self.media_pkts_per_ip = None

                                                                        self.ip_bit_rate = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate()
                                                                        self.ip_bit_rate.parent = self
                                                                        self._children_name_map["ip_bit_rate"] = "ip-bit-rate"

                                                                        self.media_bit_rate = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate()
                                                                        self.media_bit_rate.parent = self
                                                                        self._children_name_map["media_bit_rate"] = "media-bit-rate"
                                                                        self._segment_path = lambda: "ipcbr"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr, ['action_metric_type', 'ip_pkt_rate', 'media_pkt_size', 'media_pkts_per_ip'], name, value)


                                                                    class IpBitRate(Entity):
                                                                        """
                                                                        data rate in bps
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate, self).__init__()

                                                                            self.yang_name = "ip-bit-rate"
                                                                            self.yang_parent_name = "ipcbr"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                            ])
                                                                            self.value = None
                                                                            self.unit = None
                                                                            self._segment_path = lambda: "ip-bit-rate"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate, ['value', 'unit'], name, value)


                                                                    class MediaBitRate(Entity):
                                                                        """
                                                                        media data rate in bps
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate, self).__init__()

                                                                            self.yang_name = "media-bit-rate"
                                                                            self.yang_parent_name = "ipcbr"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                            ])
                                                                            self.value = None
                                                                            self.unit = None
                                                                            self._segment_path = lambda: "media-bit-rate"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate, ['value', 'unit'], name, value)


                                                                class Rtp(Entity):
                                                                    """
                                                                    rtp
                                                                    
                                                                    .. attribute:: action_metric_type
                                                                    
                                                                    	metric type
                                                                    	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                    
                                                                    .. attribute:: min_sequential
                                                                    
                                                                    	min sequential
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: max_dropout
                                                                    
                                                                    	max dropout
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: max_misorder
                                                                    
                                                                    	max misorder
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: seq_ext_cop4
                                                                    
                                                                    	enable seq extension cop4
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: clock_rate
                                                                    
                                                                    	clock rate
                                                                    	**type**\: list of  		 :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp, self).__init__()

                                                                        self.yang_name = "rtp"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("clock-rate", ("clock_rate", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate))])
                                                                        self._leafs = OrderedDict([
                                                                            ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                            ('min_sequential', (YLeaf(YType.uint32, 'min-sequential'), ['int'])),
                                                                            ('max_dropout', (YLeaf(YType.uint32, 'max-dropout'), ['int'])),
                                                                            ('max_misorder', (YLeaf(YType.uint32, 'max-misorder'), ['int'])),
                                                                            ('seq_ext_cop4', (YLeaf(YType.uint32, 'seq-ext-cop4'), ['int'])),
                                                                        ])
                                                                        self.action_metric_type = None
                                                                        self.min_sequential = None
                                                                        self.max_dropout = None
                                                                        self.max_misorder = None
                                                                        self.seq_ext_cop4 = None

                                                                        self.clock_rate = YList(self)
                                                                        self._segment_path = lambda: "rtp"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp, ['action_metric_type', 'min_sequential', 'max_dropout', 'max_misorder', 'seq_ext_cop4'], name, value)


                                                                    class ClockRate(Entity):
                                                                        """
                                                                        clock rate
                                                                        
                                                                        .. attribute:: pt
                                                                        
                                                                        	pt
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: frequency
                                                                        
                                                                        	frequency
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate, self).__init__()

                                                                            self.yang_name = "clock-rate"
                                                                            self.yang_parent_name = "rtp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('pt', (YLeaf(YType.uint32, 'pt'), ['int'])),
                                                                                ('frequency', (YLeaf(YType.uint32, 'frequency'), ['int'])),
                                                                            ])
                                                                            self.pt = None
                                                                            self.frequency = None
                                                                            self._segment_path = lambda: "clock-rate"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate, ['pt', 'frequency'], name, value)


                                                                class RtpMmr(Entity):
                                                                    """
                                                                    rtp mmr
                                                                    
                                                                    .. attribute:: action_metric_type
                                                                    
                                                                    	metric type
                                                                    	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                    
                                                                    .. attribute:: min_sequential
                                                                    
                                                                    	min sequential
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: max_dropout
                                                                    
                                                                    	max dropout
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: max_misorder
                                                                    
                                                                    	max misorder
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: seq_ext_cop4
                                                                    
                                                                    	enable seq extension cop4
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: clock_rate
                                                                    
                                                                    	clock rate
                                                                    	**type**\: list of  		 :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr, self).__init__()

                                                                        self.yang_name = "rtp-mmr"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("clock-rate", ("clock_rate", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate))])
                                                                        self._leafs = OrderedDict([
                                                                            ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                            ('min_sequential', (YLeaf(YType.uint32, 'min-sequential'), ['int'])),
                                                                            ('max_dropout', (YLeaf(YType.uint32, 'max-dropout'), ['int'])),
                                                                            ('max_misorder', (YLeaf(YType.uint32, 'max-misorder'), ['int'])),
                                                                            ('seq_ext_cop4', (YLeaf(YType.uint32, 'seq-ext-cop4'), ['int'])),
                                                                        ])
                                                                        self.action_metric_type = None
                                                                        self.min_sequential = None
                                                                        self.max_dropout = None
                                                                        self.max_misorder = None
                                                                        self.seq_ext_cop4 = None

                                                                        self.clock_rate = YList(self)
                                                                        self._segment_path = lambda: "rtp-mmr"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr, ['action_metric_type', 'min_sequential', 'max_dropout', 'max_misorder', 'seq_ext_cop4'], name, value)


                                                                    class ClockRate(Entity):
                                                                        """
                                                                        clock rate
                                                                        
                                                                        .. attribute:: pt
                                                                        
                                                                        	pt
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: frequency
                                                                        
                                                                        	frequency
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate, self).__init__()

                                                                            self.yang_name = "clock-rate"
                                                                            self.yang_parent_name = "rtp-mmr"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('pt', (YLeaf(YType.uint32, 'pt'), ['int'])),
                                                                                ('frequency', (YLeaf(YType.uint32, 'frequency'), ['int'])),
                                                                            ])
                                                                            self.pt = None
                                                                            self.frequency = None
                                                                            self._segment_path = lambda: "clock-rate"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate, ['pt', 'frequency'], name, value)


                                                                class RtpJ2k(Entity):
                                                                    """
                                                                    rtp j2k
                                                                    
                                                                    .. attribute:: action_metric_type
                                                                    
                                                                    	metric type
                                                                    	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                    
                                                                    .. attribute:: min_sequential
                                                                    
                                                                    	min sequential
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: max_dropout
                                                                    
                                                                    	max dropout
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: max_misorder
                                                                    
                                                                    	max misorder
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: seq_ext_cop4
                                                                    
                                                                    	enable seq extension cop4
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: clock_rate
                                                                    
                                                                    	clock rate
                                                                    	**type**\: list of  		 :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k.ClockRate>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k, self).__init__()

                                                                        self.yang_name = "rtp-j2k"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("clock-rate", ("clock_rate", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k.ClockRate))])
                                                                        self._leafs = OrderedDict([
                                                                            ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                            ('min_sequential', (YLeaf(YType.uint32, 'min-sequential'), ['int'])),
                                                                            ('max_dropout', (YLeaf(YType.uint32, 'max-dropout'), ['int'])),
                                                                            ('max_misorder', (YLeaf(YType.uint32, 'max-misorder'), ['int'])),
                                                                            ('seq_ext_cop4', (YLeaf(YType.uint32, 'seq-ext-cop4'), ['int'])),
                                                                        ])
                                                                        self.action_metric_type = None
                                                                        self.min_sequential = None
                                                                        self.max_dropout = None
                                                                        self.max_misorder = None
                                                                        self.seq_ext_cop4 = None

                                                                        self.clock_rate = YList(self)
                                                                        self._segment_path = lambda: "rtp-j2k"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k, ['action_metric_type', 'min_sequential', 'max_dropout', 'max_misorder', 'seq_ext_cop4'], name, value)


                                                                    class ClockRate(Entity):
                                                                        """
                                                                        clock rate
                                                                        
                                                                        .. attribute:: pt
                                                                        
                                                                        	pt
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: frequency
                                                                        
                                                                        	frequency
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k.ClockRate, self).__init__()

                                                                            self.yang_name = "clock-rate"
                                                                            self.yang_parent_name = "rtp-j2k"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('pt', (YLeaf(YType.uint32, 'pt'), ['int'])),
                                                                                ('frequency', (YLeaf(YType.uint32, 'frequency'), ['int'])),
                                                                            ])
                                                                            self.pt = None
                                                                            self.frequency = None
                                                                            self._segment_path = lambda: "clock-rate"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k.ClockRate, ['pt', 'frequency'], name, value)


                                                                class RtpVoice(Entity):
                                                                    """
                                                                    rtp voice
                                                                    
                                                                    .. attribute:: action_metric_type
                                                                    
                                                                    	metric type
                                                                    	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                    
                                                                    .. attribute:: min_sequential
                                                                    
                                                                    	min sequential
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: max_dropout
                                                                    
                                                                    	max dropout
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: max_misorder
                                                                    
                                                                    	max misorder
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: seq_ext_cop4
                                                                    
                                                                    	enable seq extension cop4
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: clock_rate
                                                                    
                                                                    	clock rate
                                                                    	**type**\: list of  		 :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice, self).__init__()

                                                                        self.yang_name = "rtp-voice"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("clock-rate", ("clock_rate", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate))])
                                                                        self._leafs = OrderedDict([
                                                                            ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                            ('min_sequential', (YLeaf(YType.uint32, 'min-sequential'), ['int'])),
                                                                            ('max_dropout', (YLeaf(YType.uint32, 'max-dropout'), ['int'])),
                                                                            ('max_misorder', (YLeaf(YType.uint32, 'max-misorder'), ['int'])),
                                                                            ('seq_ext_cop4', (YLeaf(YType.uint32, 'seq-ext-cop4'), ['int'])),
                                                                        ])
                                                                        self.action_metric_type = None
                                                                        self.min_sequential = None
                                                                        self.max_dropout = None
                                                                        self.max_misorder = None
                                                                        self.seq_ext_cop4 = None

                                                                        self.clock_rate = YList(self)
                                                                        self._segment_path = lambda: "rtp-voice"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice, ['action_metric_type', 'min_sequential', 'max_dropout', 'max_misorder', 'seq_ext_cop4'], name, value)


                                                                    class ClockRate(Entity):
                                                                        """
                                                                        clock rate
                                                                        
                                                                        .. attribute:: pt
                                                                        
                                                                        	pt
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: frequency
                                                                        
                                                                        	frequency
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate, self).__init__()

                                                                            self.yang_name = "clock-rate"
                                                                            self.yang_parent_name = "rtp-voice"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('pt', (YLeaf(YType.uint32, 'pt'), ['int'])),
                                                                                ('frequency', (YLeaf(YType.uint32, 'frequency'), ['int'])),
                                                                            ])
                                                                            self.pt = None
                                                                            self.frequency = None
                                                                            self._segment_path = lambda: "clock-rate"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate, ['pt', 'frequency'], name, value)


                                                                class Mdi(Entity):
                                                                    """
                                                                    mdi
                                                                    
                                                                    .. attribute:: ip_bit_rate
                                                                    
                                                                    	data rate in bps
                                                                    	**type**\:  :py:class:`IpBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate>`
                                                                    
                                                                    .. attribute:: action_metric_type
                                                                    
                                                                    	metric type
                                                                    	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                    
                                                                    .. attribute:: filtered_pkt_rate
                                                                    
                                                                    	filtered packet rate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: ip_pkt_rate
                                                                    
                                                                    	packet rate in pps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: pids
                                                                    
                                                                    	array of monitoredcd  pids
                                                                    	**type**\: list of int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi, self).__init__()

                                                                        self.yang_name = "mdi"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("ip-bit-rate", ("ip_bit_rate", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate))])
                                                                        self._leafs = OrderedDict([
                                                                            ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                            ('filtered_pkt_rate', (YLeaf(YType.uint32, 'filtered-pkt-rate'), ['int'])),
                                                                            ('ip_pkt_rate', (YLeaf(YType.uint32, 'ip-pkt-rate'), ['int'])),
                                                                            ('pids', (YLeafList(YType.uint32, 'pids'), ['int'])),
                                                                        ])
                                                                        self.action_metric_type = None
                                                                        self.filtered_pkt_rate = None
                                                                        self.ip_pkt_rate = None
                                                                        self.pids = []

                                                                        self.ip_bit_rate = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate()
                                                                        self.ip_bit_rate.parent = self
                                                                        self._children_name_map["ip_bit_rate"] = "ip-bit-rate"
                                                                        self._segment_path = lambda: "mdi"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi, ['action_metric_type', 'filtered_pkt_rate', 'ip_pkt_rate', 'pids'], name, value)


                                                                    class IpBitRate(Entity):
                                                                        """
                                                                        data rate in bps
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate, self).__init__()

                                                                            self.yang_name = "ip-bit-rate"
                                                                            self.yang_parent_name = "mdi"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                            ])
                                                                            self.value = None
                                                                            self.unit = None
                                                                            self._segment_path = lambda: "ip-bit-rate"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate, ['value', 'unit'], name, value)


                                                                class MdiRtp(Entity):
                                                                    """
                                                                    mdi rtp
                                                                    
                                                                    .. attribute:: ip_bit_rate
                                                                    
                                                                    	data rate in bps
                                                                    	**type**\:  :py:class:`IpBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate>`
                                                                    
                                                                    .. attribute:: action_metric_type
                                                                    
                                                                    	metric type
                                                                    	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                    
                                                                    .. attribute:: filtered_pkt_rate
                                                                    
                                                                    	filtered packet rate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: ip_pkt_rate
                                                                    
                                                                    	packet rate in pps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: pids
                                                                    
                                                                    	array of monitoredcd  pids
                                                                    	**type**\: list of int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp, self).__init__()

                                                                        self.yang_name = "mdi-rtp"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("ip-bit-rate", ("ip_bit_rate", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate))])
                                                                        self._leafs = OrderedDict([
                                                                            ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                            ('filtered_pkt_rate', (YLeaf(YType.uint32, 'filtered-pkt-rate'), ['int'])),
                                                                            ('ip_pkt_rate', (YLeaf(YType.uint32, 'ip-pkt-rate'), ['int'])),
                                                                            ('pids', (YLeafList(YType.uint32, 'pids'), ['int'])),
                                                                        ])
                                                                        self.action_metric_type = None
                                                                        self.filtered_pkt_rate = None
                                                                        self.ip_pkt_rate = None
                                                                        self.pids = []

                                                                        self.ip_bit_rate = PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate()
                                                                        self.ip_bit_rate.parent = self
                                                                        self._children_name_map["ip_bit_rate"] = "ip-bit-rate"
                                                                        self._segment_path = lambda: "mdi-rtp"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp, ['action_metric_type', 'filtered_pkt_rate', 'ip_pkt_rate', 'pids'], name, value)


                                                                    class IpBitRate(Entity):
                                                                        """
                                                                        data rate in bps
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate, self).__init__()

                                                                            self.yang_name = "ip-bit-rate"
                                                                            self.yang_parent_name = "mdi-rtp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                            ])
                                                                            self.value = None
                                                                            self.unit = None
                                                                            self._segment_path = lambda: "ip-bit-rate"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate, ['value', 'unit'], name, value)


                                                                class Fmm(Entity):
                                                                    """
                                                                    fmm
                                                                    
                                                                    .. attribute:: fmm_name
                                                                    
                                                                    	flow monitor name
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..33
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm, self).__init__()

                                                                        self.yang_name = "fmm"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('fmm_name', (YLeaf(YType.str, 'fmm-name'), ['str'])),
                                                                        ])
                                                                        self.fmm_name = None
                                                                        self._segment_path = lambda: "fmm"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm, ['fmm_name'], name, value)


                                                                class Pbf(Entity):
                                                                    """
                                                                    pbf
                                                                    
                                                                    .. attribute:: action_pbf_info_array
                                                                    
                                                                    	action pbf info array
                                                                    	**type**\: list of  		 :py:class:`ActionPbfInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf, self).__init__()

                                                                        self.yang_name = "pbf"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("action-pbf-info-array", ("action_pbf_info_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray))])
                                                                        self._leafs = OrderedDict()

                                                                        self.action_pbf_info_array = YList(self)
                                                                        self._segment_path = lambda: "pbf"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf, [], name, value)


                                                                    class ActionPbfInfoArray(Entity):
                                                                        """
                                                                        action pbf info array
                                                                        
                                                                        .. attribute:: addr
                                                                        
                                                                        	v4 or v6 address
                                                                        	**type**\: str
                                                                        
                                                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                        
                                                                        .. attribute:: vrf
                                                                        
                                                                        	vrf name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: rt_type
                                                                        
                                                                        	route target type
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: rt
                                                                        
                                                                        	route target
                                                                        	**type**\: str
                                                                        
                                                                        	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray, self).__init__()

                                                                            self.yang_name = "action-pbf-info-array"
                                                                            self.yang_parent_name = "pbf"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('addr', (YLeaf(YType.str, 'addr'), ['str'])),
                                                                                ('vrf', (YLeaf(YType.str, 'vrf'), ['str'])),
                                                                                ('rt_type', (YLeaf(YType.uint8, 'rt-type'), ['int'])),
                                                                                ('rt', (YLeaf(YType.str, 'rt'), ['str'])),
                                                                            ])
                                                                            self.addr = None
                                                                            self.vrf = None
                                                                            self.rt_type = None
                                                                            self.rt = None
                                                                            self._segment_path = lambda: "action-pbf-info-array"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray, ['addr', 'vrf', 'rt_type', 'rt'], name, value)


                                                                class Ipv4Nh(Entity):
                                                                    """
                                                                    ipv4 nh
                                                                    
                                                                    .. attribute:: action_ipv4_nh_info_array
                                                                    
                                                                    	action ipv4 nh info array
                                                                    	**type**\: list of  		 :py:class:`ActionIpv4NhInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh, self).__init__()

                                                                        self.yang_name = "ipv4-nh"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("action-ipv4-nh-info-array", ("action_ipv4_nh_info_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray))])
                                                                        self._leafs = OrderedDict()

                                                                        self.action_ipv4_nh_info_array = YList(self)
                                                                        self._segment_path = lambda: "ipv4-nh"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh, [], name, value)


                                                                    class ActionIpv4NhInfoArray(Entity):
                                                                        """
                                                                        action ipv4 nh info array
                                                                        
                                                                        .. attribute:: nh_addr
                                                                        
                                                                        	nh addr
                                                                        	**type**\: str
                                                                        
                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                        
                                                                        .. attribute:: vrf_name
                                                                        
                                                                        	Vrf name
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray, self).__init__()

                                                                            self.yang_name = "action-ipv4-nh-info-array"
                                                                            self.yang_parent_name = "ipv4-nh"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('nh_addr', (YLeaf(YType.str, 'nh-addr'), ['str'])),
                                                                                ('vrf_name', (YLeaf(YType.str, 'vrf-name'), ['str'])),
                                                                            ])
                                                                            self.nh_addr = None
                                                                            self.vrf_name = None
                                                                            self._segment_path = lambda: "action-ipv4-nh-info-array"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray, ['nh_addr', 'vrf_name'], name, value)


                                                                class Ipv6Nh(Entity):
                                                                    """
                                                                    ipv6 nh
                                                                    
                                                                    .. attribute:: action_ipv6_nh_info_array
                                                                    
                                                                    	action ipv6 nh info array
                                                                    	**type**\: list of  		 :py:class:`ActionIpv6NhInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh, self).__init__()

                                                                        self.yang_name = "ipv6-nh"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("action-ipv6-nh-info-array", ("action_ipv6_nh_info_array", PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray))])
                                                                        self._leafs = OrderedDict()

                                                                        self.action_ipv6_nh_info_array = YList(self)
                                                                        self._segment_path = lambda: "ipv6-nh"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh, [], name, value)


                                                                    class ActionIpv6NhInfoArray(Entity):
                                                                        """
                                                                        action ipv6 nh info array
                                                                        
                                                                        .. attribute:: nh_addr
                                                                        
                                                                        	IPV6 Address
                                                                        	**type**\: str
                                                                        
                                                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                        
                                                                        .. attribute:: vrf_name
                                                                        
                                                                        	Vrf name
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray, self).__init__()

                                                                            self.yang_name = "action-ipv6-nh-info-array"
                                                                            self.yang_parent_name = "ipv6-nh"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('nh_addr', (YLeaf(YType.str, 'nh-addr'), ['str'])),
                                                                                ('vrf_name', (YLeaf(YType.str, 'vrf-name'), ['str'])),
                                                                            ])
                                                                            self.nh_addr = None
                                                                            self.vrf_name = None
                                                                            self._segment_path = lambda: "action-ipv6-nh-info-array"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray, ['nh_addr', 'vrf_name'], name, value)


            class PolicyMapUnusedTypes(Entity):
                """
                Policy\-map unused table
                
                .. attribute:: policy_map_unused_type
                
                	Policy\-map unused
                	**type**\: list of  		 :py:class:`PolicyMapUnusedType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType>`
                
                

                """

                _prefix = 'infra-policymgr-oper'
                _revision = '2018-01-17'

                def __init__(self):
                    super(PolicyManager.Global.PolicyMap.PolicyMapUnusedTypes, self).__init__()

                    self.yang_name = "policy-map-unused-types"
                    self.yang_parent_name = "policy-map"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("policy-map-unused-type", ("policy_map_unused_type", PolicyManager.Global.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType))])
                    self._leafs = OrderedDict()

                    self.policy_map_unused_type = YList(self)
                    self._segment_path = lambda: "policy-map-unused-types"
                    self._absolute_path = lambda: "Cisco-IOS-XR-infra-policymgr-oper:policy-manager/global/policy-map/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapUnusedTypes, [], name, value)


                class PolicyMapUnusedType(Entity):
                    """
                    Policy\-map unused
                    
                    .. attribute:: type  (key)
                    
                    	The application type
                    	**type**\:  :py:class:`PolicymgrPolicyMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicymgrPolicyMap>`
                    
                    .. attribute:: unuseds
                    
                    	Policy\-map unused
                    	**type**\:  :py:class:`Unuseds <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds>`
                    
                    

                    """

                    _prefix = 'infra-policymgr-oper'
                    _revision = '2018-01-17'

                    def __init__(self):
                        super(PolicyManager.Global.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType, self).__init__()

                        self.yang_name = "policy-map-unused-type"
                        self.yang_parent_name = "policy-map-unused-types"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = ['type']
                        self._child_classes = OrderedDict([("unuseds", ("unuseds", PolicyManager.Global.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds))])
                        self._leafs = OrderedDict([
                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicymgrPolicyMap', '')])),
                        ])
                        self.type = None

                        self.unuseds = PolicyManager.Global.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds()
                        self.unuseds.parent = self
                        self._children_name_map["unuseds"] = "unuseds"
                        self._segment_path = lambda: "policy-map-unused-type" + "[type='" + str(self.type) + "']"
                        self._absolute_path = lambda: "Cisco-IOS-XR-infra-policymgr-oper:policy-manager/global/policy-map/policy-map-unused-types/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType, ['type'], name, value)


                    class Unuseds(Entity):
                        """
                        Policy\-map unused
                        
                        .. attribute:: unused
                        
                        	Policy\-map unused information
                        	**type**\: list of  		 :py:class:`Unused <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused>`
                        
                        

                        """

                        _prefix = 'infra-policymgr-oper'
                        _revision = '2018-01-17'

                        def __init__(self):
                            super(PolicyManager.Global.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds, self).__init__()

                            self.yang_name = "unuseds"
                            self.yang_parent_name = "policy-map-unused-type"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("unused", ("unused", PolicyManager.Global.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused))])
                            self._leafs = OrderedDict()

                            self.unused = YList(self)
                            self._segment_path = lambda: "unuseds"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds, [], name, value)


                        class Unused(Entity):
                            """
                            Policy\-map unused information
                            
                            .. attribute:: policy_map_name  (key)
                            
                            	Name of policy\-map
                            	**type**\: str
                            
                            	**length:** 1..63
                            
                            .. attribute:: object_type
                            
                            	Application type configured
                            	**type**\:  :py:class:`PlmgrApplnTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrApplnTypeEn>`
                            
                            .. attribute:: total_objects
                            
                            	Total number of objects configured for a specific object type
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: transient
                            
                            	Transient object
                            	**type**\: bool
                            
                            .. attribute:: reference
                            
                            	Each Policymap details
                            	**type**\: list of  		 :py:class:`Reference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused.Reference>`
                            
                            .. attribute:: objects
                            
                            	Each object details
                            	**type**\: list of  		 :py:class:`Objects <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused.Objects>`
                            
                            .. attribute:: class_map_reference
                            
                            	Each Classmapdetails
                            	**type**\: list of  		 :py:class:`ClassMapReference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused.ClassMapReference>`
                            
                            

                            """

                            _prefix = 'infra-policymgr-oper'
                            _revision = '2018-01-17'

                            def __init__(self):
                                super(PolicyManager.Global.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused, self).__init__()

                                self.yang_name = "unused"
                                self.yang_parent_name = "unuseds"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = ['policy_map_name']
                                self._child_classes = OrderedDict([("reference", ("reference", PolicyManager.Global.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused.Reference)), ("objects", ("objects", PolicyManager.Global.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused.Objects)), ("class-map-reference", ("class_map_reference", PolicyManager.Global.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused.ClassMapReference))])
                                self._leafs = OrderedDict([
                                    ('policy_map_name', (YLeaf(YType.str, 'policy-map-name'), ['str'])),
                                    ('object_type', (YLeaf(YType.enumeration, 'object-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PlmgrApplnTypeEn', '')])),
                                    ('total_objects', (YLeaf(YType.uint32, 'total-objects'), ['int'])),
                                    ('transient', (YLeaf(YType.boolean, 'transient'), ['bool'])),
                                ])
                                self.policy_map_name = None
                                self.object_type = None
                                self.total_objects = None
                                self.transient = None

                                self.reference = YList(self)
                                self.objects = YList(self)
                                self.class_map_reference = YList(self)
                                self._segment_path = lambda: "unused" + "[policy-map-name='" + str(self.policy_map_name) + "']"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused, ['policy_map_name', 'object_type', 'total_objects', 'transient'], name, value)


                            class Reference(Entity):
                                """
                                Each Policymap details
                                
                                .. attribute:: total_internal_reference_objects
                                
                                	Total number of internal reference objects
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: total_class_maps
                                
                                	Total number of Classmaps in a Policymap
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: total_flows
                                
                                	Total flows in a Policymap
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'infra-policymgr-oper'
                                _revision = '2018-01-17'

                                def __init__(self):
                                    super(PolicyManager.Global.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused.Reference, self).__init__()

                                    self.yang_name = "reference"
                                    self.yang_parent_name = "unused"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('total_internal_reference_objects', (YLeaf(YType.uint32, 'total-internal-reference-objects'), ['int'])),
                                        ('total_class_maps', (YLeaf(YType.uint32, 'total-class-maps'), ['int'])),
                                        ('total_flows', (YLeaf(YType.uint32, 'total-flows'), ['int'])),
                                    ])
                                    self.total_internal_reference_objects = None
                                    self.total_class_maps = None
                                    self.total_flows = None
                                    self._segment_path = lambda: "reference"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused.Reference, ['total_internal_reference_objects', 'total_class_maps', 'total_flows'], name, value)


                            class Objects(Entity):
                                """
                                Each object details
                                
                                .. attribute:: object_name
                                
                                	Name of object (Policymap/Classmap)
                                	**type**\: str
                                
                                	**length:** 0..64
                                
                                

                                """

                                _prefix = 'infra-policymgr-oper'
                                _revision = '2018-01-17'

                                def __init__(self):
                                    super(PolicyManager.Global.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused.Objects, self).__init__()

                                    self.yang_name = "objects"
                                    self.yang_parent_name = "unused"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('object_name', (YLeaf(YType.str, 'object-name'), ['str'])),
                                    ])
                                    self.object_name = None
                                    self._segment_path = lambda: "objects"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused.Objects, ['object_name'], name, value)


                            class ClassMapReference(Entity):
                                """
                                Each Classmapdetails
                                
                                .. attribute:: total_reference_objects
                                
                                	Total number of Policymaps referencing a Classmap
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: policy_map_reference
                                
                                	List of Policymaps referencing a Classmap
                                	**type**\: list of  		 :py:class:`PolicyMapReference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused.ClassMapReference.PolicyMapReference>`
                                
                                

                                """

                                _prefix = 'infra-policymgr-oper'
                                _revision = '2018-01-17'

                                def __init__(self):
                                    super(PolicyManager.Global.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused.ClassMapReference, self).__init__()

                                    self.yang_name = "class-map-reference"
                                    self.yang_parent_name = "unused"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("policy-map-reference", ("policy_map_reference", PolicyManager.Global.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused.ClassMapReference.PolicyMapReference))])
                                    self._leafs = OrderedDict([
                                        ('total_reference_objects', (YLeaf(YType.uint32, 'total-reference-objects'), ['int'])),
                                    ])
                                    self.total_reference_objects = None

                                    self.policy_map_reference = YList(self)
                                    self._segment_path = lambda: "class-map-reference"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused.ClassMapReference, ['total_reference_objects'], name, value)


                                class PolicyMapReference(Entity):
                                    """
                                    List of Policymaps referencing a Classmap
                                    
                                    .. attribute:: object_type
                                    
                                    	Application type configured
                                    	**type**\:  :py:class:`PlmgrApplnTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrApplnTypeEn>`
                                    
                                    .. attribute:: policy_map_name
                                    
                                    	Name of Policymap referencing a Classmap
                                    	**type**\: str
                                    
                                    	**length:** 0..64
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2018-01-17'

                                    def __init__(self):
                                        super(PolicyManager.Global.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused.ClassMapReference.PolicyMapReference, self).__init__()

                                        self.yang_name = "policy-map-reference"
                                        self.yang_parent_name = "class-map-reference"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('object_type', (YLeaf(YType.enumeration, 'object-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PlmgrApplnTypeEn', '')])),
                                            ('policy_map_name', (YLeaf(YType.str, 'policy-map-name'), ['str'])),
                                        ])
                                        self.object_type = None
                                        self.policy_map_name = None
                                        self._segment_path = lambda: "policy-map-reference"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused.ClassMapReference.PolicyMapReference, ['object_type', 'policy_map_name'], name, value)


            class PolicyMapTypes(Entity):
                """
                Application type of a policymap
                
                .. attribute:: policy_map_type
                
                	Policymgr application type
                	**type**\: list of  		 :py:class:`PolicyMapType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType>`
                
                

                """

                _prefix = 'infra-policymgr-oper'
                _revision = '2018-01-17'

                def __init__(self):
                    super(PolicyManager.Global.PolicyMap.PolicyMapTypes, self).__init__()

                    self.yang_name = "policy-map-types"
                    self.yang_parent_name = "policy-map"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("policy-map-type", ("policy_map_type", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType))])
                    self._leafs = OrderedDict()

                    self.policy_map_type = YList(self)
                    self._segment_path = lambda: "policy-map-types"
                    self._absolute_path = lambda: "Cisco-IOS-XR-infra-policymgr-oper:policy-manager/global/policy-map/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes, [], name, value)


                class PolicyMapType(Entity):
                    """
                    Policymgr application type
                    
                    .. attribute:: type  (key)
                    
                    	The application type
                    	**type**\:  :py:class:`PolicymgrPolicyMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicymgrPolicyMap>`
                    
                    .. attribute:: policy_maps
                    
                    	Policy\-map definition table
                    	**type**\:  :py:class:`PolicyMaps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps>`
                    
                    .. attribute:: policy_map_details
                    
                    	Policy\-map table
                    	**type**\:  :py:class:`PolicyMapDetails <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails>`
                    
                    

                    """

                    _prefix = 'infra-policymgr-oper'
                    _revision = '2018-01-17'

                    def __init__(self):
                        super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType, self).__init__()

                        self.yang_name = "policy-map-type"
                        self.yang_parent_name = "policy-map-types"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = ['type']
                        self._child_classes = OrderedDict([("policy-maps", ("policy_maps", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps)), ("policy-map-details", ("policy_map_details", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails))])
                        self._leafs = OrderedDict([
                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicymgrPolicyMap', '')])),
                        ])
                        self.type = None

                        self.policy_maps = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps()
                        self.policy_maps.parent = self
                        self._children_name_map["policy_maps"] = "policy-maps"

                        self.policy_map_details = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails()
                        self.policy_map_details.parent = self
                        self._children_name_map["policy_map_details"] = "policy-map-details"
                        self._segment_path = lambda: "policy-map-type" + "[type='" + str(self.type) + "']"
                        self._absolute_path = lambda: "Cisco-IOS-XR-infra-policymgr-oper:policy-manager/global/policy-map/policy-map-types/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType, ['type'], name, value)


                    class PolicyMaps(Entity):
                        """
                        Policy\-map definition table
                        
                        .. attribute:: policy_map
                        
                        	Policy\-map configuration
                        	**type**\: list of  		 :py:class:`PolicyMap_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_>`
                        
                        

                        """

                        _prefix = 'infra-policymgr-oper'
                        _revision = '2018-01-17'

                        def __init__(self):
                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps, self).__init__()

                            self.yang_name = "policy-maps"
                            self.yang_parent_name = "policy-map-type"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("policy-map", ("policy_map", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_))])
                            self._leafs = OrderedDict()

                            self.policy_map = YList(self)
                            self._segment_path = lambda: "policy-maps"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps, [], name, value)


                        class PolicyMap_(Entity):
                            """
                            Policy\-map configuration
                            
                            .. attribute:: policy_map_name  (key)
                            
                            	Name of policy\-map
                            	**type**\: str
                            
                            	**length:** 1..63
                            
                            .. attribute:: policy_map_bg
                            
                            	policy map bg
                            	**type**\: list of  		 :py:class:`PolicyMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg>`
                            
                            

                            """

                            _prefix = 'infra-policymgr-oper'
                            _revision = '2018-01-17'

                            def __init__(self):
                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_, self).__init__()

                                self.yang_name = "policy-map"
                                self.yang_parent_name = "policy-maps"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = ['policy_map_name']
                                self._child_classes = OrderedDict([("policy-map-bg", ("policy_map_bg", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg))])
                                self._leafs = OrderedDict([
                                    ('policy_map_name', (YLeaf(YType.str, 'policy-map-name'), ['str'])),
                                ])
                                self.policy_map_name = None

                                self.policy_map_bg = YList(self)
                                self._segment_path = lambda: "policy-map" + "[policy-map-name='" + str(self.policy_map_name) + "']"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_, ['policy_map_name'], name, value)


                            class PolicyMapBg(Entity):
                                """
                                policy map bg
                                
                                .. attribute:: pmap_var_list
                                
                                	pmap var list
                                	**type**\:  :py:class:`PmapVarList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.PmapVarList>`
                                
                                .. attribute:: event_infop
                                
                                	event infop
                                	**type**\:  :py:class:`EventInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop>`
                                
                                .. attribute:: name
                                
                                	name
                                	**type**\: str
                                
                                	**length:** 0..65
                                
                                .. attribute:: type
                                
                                	type
                                	**type**\:  :py:class:`PolicyMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyMapTypeEn>`
                                
                                .. attribute:: description
                                
                                	description
                                	**type**\: str
                                
                                

                                """

                                _prefix = 'infra-policymgr-oper'
                                _revision = '2018-01-17'

                                def __init__(self):
                                    super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg, self).__init__()

                                    self.yang_name = "policy-map-bg"
                                    self.yang_parent_name = "policy-map"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("pmap-var-list", ("pmap_var_list", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.PmapVarList)), ("event-infop", ("event_infop", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop))])
                                    self._leafs = OrderedDict([
                                        ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyMapTypeEn', '')])),
                                        ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                    ])
                                    self.name = None
                                    self.type = None
                                    self.description = None

                                    self.pmap_var_list = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.PmapVarList()
                                    self.pmap_var_list.parent = self
                                    self._children_name_map["pmap_var_list"] = "pmap-var-list"

                                    self.event_infop = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop()
                                    self.event_infop.parent = self
                                    self._children_name_map["event_infop"] = "event-infop"
                                    self._segment_path = lambda: "policy-map-bg"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg, ['name', 'type', 'description'], name, value)


                                class PmapVarList(Entity):
                                    """
                                    pmap var list
                                    
                                    .. attribute:: pmap_var_list_arr
                                    
                                    	pmap var list arr
                                    	**type**\: list of  		 :py:class:`PmapVarListArr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.PmapVarList.PmapVarListArr>`
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2018-01-17'

                                    def __init__(self):
                                        super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.PmapVarList, self).__init__()

                                        self.yang_name = "pmap-var-list"
                                        self.yang_parent_name = "policy-map-bg"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("pmap-var-list-arr", ("pmap_var_list_arr", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.PmapVarList.PmapVarListArr))])
                                        self._leafs = OrderedDict()

                                        self.pmap_var_list_arr = YList(self)
                                        self._segment_path = lambda: "pmap-var-list"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.PmapVarList, [], name, value)


                                    class PmapVarListArr(Entity):
                                        """
                                        pmap var list arr
                                        
                                        .. attribute:: val
                                        
                                        	val
                                        	**type**\:  :py:class:`Val <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.PmapVarList.PmapVarListArr.Val>`
                                        
                                        .. attribute:: name
                                        
                                        	name
                                        	**type**\: str
                                        
                                        	**length:** 0..32
                                        
                                        .. attribute:: id
                                        
                                        	id
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'infra-policymgr-oper'
                                        _revision = '2018-01-17'

                                        def __init__(self):
                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.PmapVarList.PmapVarListArr, self).__init__()

                                            self.yang_name = "pmap-var-list-arr"
                                            self.yang_parent_name = "pmap-var-list"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("val", ("val", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.PmapVarList.PmapVarListArr.Val))])
                                            self._leafs = OrderedDict([
                                                ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                ('id', (YLeaf(YType.uint32, 'id'), ['int'])),
                                            ])
                                            self.name = None
                                            self.id = None

                                            self.val = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.PmapVarList.PmapVarListArr.Val()
                                            self.val.parent = self
                                            self._children_name_map["val"] = "val"
                                            self._segment_path = lambda: "pmap-var-list-arr"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.PmapVarList.PmapVarListArr, ['name', 'id'], name, value)


                                        class Val(Entity):
                                            """
                                            val
                                            
                                            .. attribute:: type
                                            
                                            	type
                                            	**type**\:  :py:class:`PlmgrVarTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrVarTypeEn>`
                                            
                                            .. attribute:: class_name
                                            
                                            	class name
                                            	**type**\: str
                                            
                                            	**length:** 0..65
                                            
                                            .. attribute:: uint8_val
                                            
                                            	uint8 val
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: uint16_val
                                            
                                            	uint16 val
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: uint32_val
                                            
                                            	uint32 val
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: param_uint32_val
                                            
                                            	param uint32 val
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: dscp_val
                                            
                                            	dscp val
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: prec_val
                                            
                                            	prec val
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'infra-policymgr-oper'
                                            _revision = '2018-01-17'

                                            def __init__(self):
                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.PmapVarList.PmapVarListArr.Val, self).__init__()

                                                self.yang_name = "val"
                                                self.yang_parent_name = "pmap-var-list-arr"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PlmgrVarTypeEn', '')])),
                                                    ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                    ('uint8_val', (YLeaf(YType.uint8, 'uint8_val'), ['int'])),
                                                    ('uint16_val', (YLeaf(YType.uint16, 'uint16_val'), ['int'])),
                                                    ('uint32_val', (YLeaf(YType.uint32, 'uint32_val'), ['int'])),
                                                    ('param_uint32_val', (YLeaf(YType.uint32, 'param-uint32-val'), ['int'])),
                                                    ('dscp_val', (YLeaf(YType.uint8, 'dscp-val'), ['int'])),
                                                    ('prec_val', (YLeaf(YType.uint8, 'prec-val'), ['int'])),
                                                ])
                                                self.type = None
                                                self.class_name = None
                                                self.uint8_val = None
                                                self.uint16_val = None
                                                self.uint32_val = None
                                                self.param_uint32_val = None
                                                self.dscp_val = None
                                                self.prec_val = None
                                                self._segment_path = lambda: "val"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.PmapVarList.PmapVarListArr.Val, ['type', 'class_name', 'uint8_val', 'uint16_val', 'uint32_val', 'param_uint32_val', 'dscp_val', 'prec_val'], name, value)


                                class EventInfop(Entity):
                                    """
                                    event infop
                                    
                                    .. attribute:: policy_event_info_bg
                                    
                                    	policy event info bg
                                    	**type**\: list of  		 :py:class:`PolicyEventInfoBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg>`
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2018-01-17'

                                    def __init__(self):
                                        super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop, self).__init__()

                                        self.yang_name = "event-infop"
                                        self.yang_parent_name = "policy-map-bg"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("policy-event-info-bg", ("policy_event_info_bg", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg))])
                                        self._leafs = OrderedDict()

                                        self.policy_event_info_bg = YList(self)
                                        self._segment_path = lambda: "event-infop"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop, [], name, value)


                                    class PolicyEventInfoBg(Entity):
                                        """
                                        policy event info bg
                                        
                                        .. attribute:: class_infop
                                        
                                        	class infop
                                        	**type**\:  :py:class:`ClassInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop>`
                                        
                                        .. attribute:: event_type
                                        
                                        	event type
                                        	**type**\:  :py:class:`PeventTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PeventTypeEn>`
                                        
                                        .. attribute:: cond_eval
                                        
                                        	cond eval
                                        	**type**\:  :py:class:`PeventCondEvalEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PeventCondEvalEn>`
                                        
                                        

                                        """

                                        _prefix = 'infra-policymgr-oper'
                                        _revision = '2018-01-17'

                                        def __init__(self):
                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg, self).__init__()

                                            self.yang_name = "policy-event-info-bg"
                                            self.yang_parent_name = "event-infop"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("class-infop", ("class_infop", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop))])
                                            self._leafs = OrderedDict([
                                                ('event_type', (YLeaf(YType.enumeration, 'event-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PeventTypeEn', '')])),
                                                ('cond_eval', (YLeaf(YType.enumeration, 'cond-eval'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PeventCondEvalEn', '')])),
                                            ])
                                            self.event_type = None
                                            self.cond_eval = None

                                            self.class_infop = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop()
                                            self.class_infop.parent = self
                                            self._children_name_map["class_infop"] = "class-infop"
                                            self._segment_path = lambda: "policy-event-info-bg"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg, ['event_type', 'cond_eval'], name, value)


                                        class ClassInfop(Entity):
                                            """
                                            class infop
                                            
                                            .. attribute:: policy_class_info_bg
                                            
                                            	policy class info bg
                                            	**type**\: list of  		 :py:class:`PolicyClassInfoBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg>`
                                            
                                            

                                            """

                                            _prefix = 'infra-policymgr-oper'
                                            _revision = '2018-01-17'

                                            def __init__(self):
                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop, self).__init__()

                                                self.yang_name = "class-infop"
                                                self.yang_parent_name = "policy-event-info-bg"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("policy-class-info-bg", ("policy_class_info_bg", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg))])
                                                self._leafs = OrderedDict()

                                                self.policy_class_info_bg = YList(self)
                                                self._segment_path = lambda: "class-infop"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop, [], name, value)


                                            class PolicyClassInfoBg(Entity):
                                                """
                                                policy class info bg
                                                
                                                .. attribute:: cl_encode
                                                
                                                	cl encode
                                                	**type**\:  :py:class:`ClEncode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode>`
                                                
                                                .. attribute:: clmp_p
                                                
                                                	clmp p
                                                	**type**\:  :py:class:`ClmpP <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP>`
                                                
                                                .. attribute:: act_infop
                                                
                                                	act infop
                                                	**type**\:  :py:class:`ActInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop>`
                                                
                                                .. attribute:: policy_class_hd
                                                
                                                	policy class hd
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: seq
                                                
                                                	seq
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: flags
                                                
                                                	flags
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: ctype
                                                
                                                	ctype
                                                	**type**\:  :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                
                                                .. attribute:: num_actions
                                                
                                                	num actions
                                                	**type**\: int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: version
                                                
                                                	version
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: exe_strat
                                                
                                                	exe strat
                                                	**type**\:  :py:class:`PclassExecStratEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PclassExecStratEn>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg, self).__init__()

                                                    self.yang_name = "policy-class-info-bg"
                                                    self.yang_parent_name = "class-infop"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("cl-encode", ("cl_encode", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode)), ("clmp-p", ("clmp_p", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP)), ("act-infop", ("act_infop", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop))])
                                                    self._leafs = OrderedDict([
                                                        ('policy_class_hd', (YLeaf(YType.uint32, 'policy-class-hd'), ['int'])),
                                                        ('seq', (YLeaf(YType.uint32, 'seq'), ['int'])),
                                                        ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                        ('ctype', (YLeaf(YType.enumeration, 'ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapTypeEn', '')])),
                                                        ('num_actions', (YLeaf(YType.uint16, 'num-actions'), ['int'])),
                                                        ('version', (YLeaf(YType.uint8, 'version'), ['int'])),
                                                        ('exe_strat', (YLeaf(YType.enumeration, 'exe-strat'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PclassExecStratEn', '')])),
                                                    ])
                                                    self.policy_class_hd = None
                                                    self.seq = None
                                                    self.flags = None
                                                    self.ctype = None
                                                    self.num_actions = None
                                                    self.version = None
                                                    self.exe_strat = None

                                                    self.cl_encode = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode()
                                                    self.cl_encode.parent = self
                                                    self._children_name_map["cl_encode"] = "cl-encode"

                                                    self.clmp_p = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP()
                                                    self.clmp_p.parent = self
                                                    self._children_name_map["clmp_p"] = "clmp-p"

                                                    self.act_infop = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop()
                                                    self.act_infop.parent = self
                                                    self._children_name_map["act_infop"] = "act-infop"
                                                    self._segment_path = lambda: "policy-class-info-bg"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg, ['policy_class_hd', 'seq', 'flags', 'ctype', 'num_actions', 'version', 'exe_strat'], name, value)


                                                class ClEncode(Entity):
                                                    """
                                                    cl encode
                                                    
                                                    .. attribute:: inline_cmap
                                                    
                                                    	inline cmap
                                                    	**type**\:  :py:class:`InlineCmap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap>`
                                                    
                                                    .. attribute:: enc
                                                    
                                                    	enc
                                                    	**type**\:  :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                    
                                                    .. attribute:: class_name
                                                    
                                                    	class name
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..65
                                                    
                                                    .. attribute:: hd
                                                    
                                                    	hd
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: idx
                                                    
                                                    	idx
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode, self).__init__()

                                                        self.yang_name = "cl-encode"
                                                        self.yang_parent_name = "policy-class-info-bg"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("inline-cmap", ("inline_cmap", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap))])
                                                        self._leafs = OrderedDict([
                                                            ('enc', (YLeaf(YType.enumeration, 'enc'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyObjEncEn', '')])),
                                                            ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                            ('hd', (YLeaf(YType.uint64, 'hd'), ['int'])),
                                                            ('idx', (YLeaf(YType.uint8, 'idx'), ['int'])),
                                                        ])
                                                        self.enc = None
                                                        self.class_name = None
                                                        self.hd = None
                                                        self.idx = None

                                                        self.inline_cmap = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap()
                                                        self.inline_cmap.parent = self
                                                        self._children_name_map["inline_cmap"] = "inline-cmap"
                                                        self._segment_path = lambda: "cl-encode"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode, ['enc', 'class_name', 'hd', 'idx'], name, value)


                                                    class InlineCmap(Entity):
                                                        """
                                                        inline cmap
                                                        
                                                        .. attribute:: match_infop
                                                        
                                                        	Pointer to the first Match info
                                                        	**type**\:  :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop>`
                                                        
                                                        .. attribute:: mode
                                                        
                                                        	Inline Class\-Map Mode Match any/all
                                                        	**type**\:  :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                        
                                                        .. attribute:: flags
                                                        
                                                        	Inline Class\-Map flags
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: match_count
                                                        
                                                        	Number of Match infos
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2018-01-17'

                                                        def __init__(self):
                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap, self).__init__()

                                                            self.yang_name = "inline-cmap"
                                                            self.yang_parent_name = "cl-encode"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("match-infop", ("match_infop", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop))])
                                                            self._leafs = OrderedDict([
                                                                ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapModeEn', '')])),
                                                                ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                ('match_count', (YLeaf(YType.uint32, 'match-count'), ['int'])),
                                                            ])
                                                            self.mode = None
                                                            self.flags = None
                                                            self.match_count = None

                                                            self.match_infop = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop()
                                                            self.match_infop.parent = self
                                                            self._children_name_map["match_infop"] = "match-infop"
                                                            self._segment_path = lambda: "inline-cmap"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap, ['mode', 'flags', 'match_count'], name, value)


                                                        class MatchInfop(Entity):
                                                            """
                                                            Pointer to the first Match info
                                                            
                                                            .. attribute:: class_match_info_st
                                                            
                                                            	class match info st
                                                            	**type**\: list of  		 :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'infra-policymgr-oper'
                                                            _revision = '2018-01-17'

                                                            def __init__(self):
                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop, self).__init__()

                                                                self.yang_name = "match-infop"
                                                                self.yang_parent_name = "inline-cmap"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("class-match-info-st", ("class_match_info_st", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt))])
                                                                self._leafs = OrderedDict()

                                                                self.class_match_info_st = YList(self)
                                                                self._segment_path = lambda: "match-infop"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop, [], name, value)


                                                            class ClassMatchInfoSt(Entity):
                                                                """
                                                                class match info st
                                                                
                                                                .. attribute:: match_data
                                                                
                                                                	Match criteria
                                                                	**type**\:  :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                
                                                                .. attribute:: flags
                                                                
                                                                	Flags
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                    self.yang_name = "class-match-info-st"
                                                                    self.yang_parent_name = "match-infop"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("match-data", ("match_data", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData))])
                                                                    self._leafs = OrderedDict([
                                                                        ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                    ])
                                                                    self.flags = None

                                                                    self.match_data = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                    self.match_data.parent = self
                                                                    self._children_name_map["match_data"] = "match-data"
                                                                    self._segment_path = lambda: "class-match-info-st"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                class MatchData(Entity):
                                                                    """
                                                                    Match criteria
                                                                    
                                                                    .. attribute:: ipv4_dscp
                                                                    
                                                                    	IPv4 DSCP
                                                                    	**type**\:  :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                    
                                                                    .. attribute:: ipv6_dscp
                                                                    
                                                                    	IPv6 DSCP
                                                                    	**type**\:  :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                    
                                                                    .. attribute:: dscp
                                                                    
                                                                    	Match DSCP range array
                                                                    	**type**\:  :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                    
                                                                    .. attribute:: ipv4_prec
                                                                    
                                                                    	IPv4 Precedence
                                                                    	**type**\:  :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                    
                                                                    .. attribute:: ipv6_prec
                                                                    
                                                                    	IPv6 Precedence
                                                                    	**type**\:  :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                    
                                                                    .. attribute:: prec
                                                                    
                                                                    	Match Precedence array
                                                                    	**type**\:  :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                    
                                                                    .. attribute:: discard_class
                                                                    
                                                                    	Match Discard Class array
                                                                    	**type**\:  :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                    
                                                                    .. attribute:: qos_group
                                                                    
                                                                    	Match QoS group array
                                                                    	**type**\:  :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                    
                                                                    .. attribute:: traffic_class
                                                                    
                                                                    	Match Traffic class array
                                                                    	**type**\:  :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                    
                                                                    .. attribute:: proto
                                                                    
                                                                    	Match Protocol array
                                                                    	**type**\:  :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                    
                                                                    .. attribute:: icmp_v4
                                                                    
                                                                    	Match ICMPV4 Protocol
                                                                    	**type**\:  :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                    
                                                                    .. attribute:: icmp_v6
                                                                    
                                                                    	Match ICMPV6 Protocol array
                                                                    	**type**\:  :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                    
                                                                    .. attribute:: ipv4_packet_len
                                                                    
                                                                    	IPv4 packet length array
                                                                    	**type**\:  :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                    
                                                                    .. attribute:: ipv6_packet_len
                                                                    
                                                                    	IPv6 packet length array
                                                                    	**type**\:  :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                    
                                                                    .. attribute:: packet_len
                                                                    
                                                                    	Match packet length array
                                                                    	**type**\:  :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                    
                                                                    .. attribute:: flow_tag
                                                                    
                                                                    	Match flow\-tag array
                                                                    	**type**\:  :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                    
                                                                    .. attribute:: tcp_flag
                                                                    
                                                                    	Match tcp flag value
                                                                    	**type**\:  :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                    
                                                                    .. attribute:: icmpv4_type
                                                                    
                                                                    	Match ipv4 icmp type
                                                                    	**type**\:  :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                    
                                                                    .. attribute:: icmpv4_code
                                                                    
                                                                    	Match ipv4 icmp code
                                                                    	**type**\:  :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                    
                                                                    .. attribute:: icmpv6_type
                                                                    
                                                                    	Match ipv6 icmp type
                                                                    	**type**\:  :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                    
                                                                    .. attribute:: icmpv6_code
                                                                    
                                                                    	Match ipv6 icmp code
                                                                    	**type**\:  :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                    
                                                                    .. attribute:: mpls_exp
                                                                    
                                                                    	Match MPLS experimental topmost array
                                                                    	**type**\:  :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                    
                                                                    .. attribute:: mpls_exp_imp
                                                                    
                                                                    	Match MPLS experimental imposition array
                                                                    	**type**\:  :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                    
                                                                    .. attribute:: mpls_disp_ipv4_acl
                                                                    
                                                                    	MPLS Disposition IPv4 Access\-list
                                                                    	**type**\:  :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                    
                                                                    .. attribute:: mpls_disp_ipv6_acl
                                                                    
                                                                    	MPLS Disposition IPv6 Access\-list
                                                                    	**type**\:  :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                    
                                                                    .. attribute:: mpls_top_label
                                                                    
                                                                    	MPLS Topmost LABEL
                                                                    	**type**\:  :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                    
                                                                    .. attribute:: cos
                                                                    
                                                                    	Match CoS array
                                                                    	**type**\:  :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                    
                                                                    .. attribute:: cos_inr
                                                                    
                                                                    	Match inner header CoS
                                                                    	**type**\:  :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                    
                                                                    .. attribute:: dei
                                                                    
                                                                    	Match DEI Bit
                                                                    	**type**\:  :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                    
                                                                    .. attribute:: dei_inr
                                                                    
                                                                    	Match inner DEI Bit
                                                                    	**type**\:  :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                    
                                                                    .. attribute:: vlan
                                                                    
                                                                    	Match VLAN array
                                                                    	**type**\:  :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                    
                                                                    .. attribute:: vlan_inr
                                                                    
                                                                    	Match inner header VLAN range array
                                                                    	**type**\:  :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                    
                                                                    .. attribute:: fr_dlci
                                                                    
                                                                    	Match FR DLCI range array
                                                                    	**type**\:  :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                    
                                                                    .. attribute:: src_mac
                                                                    
                                                                    	Match Source MAC address
                                                                    	**type**\:  :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                    
                                                                    .. attribute:: dst_mac
                                                                    
                                                                    	Match Destination MAC address
                                                                    	**type**\:  :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                    
                                                                    .. attribute:: atm_clp
                                                                    
                                                                    	Match ATM CLP level
                                                                    	**type**\:  :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                    
                                                                    .. attribute:: fr_de
                                                                    
                                                                    	Match FR DE value
                                                                    	**type**\:  :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                    
                                                                    .. attribute:: ipv4_acl
                                                                    
                                                                    	IPv4 Access\-list
                                                                    	**type**\:  :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                    
                                                                    .. attribute:: ipv6_acl
                                                                    
                                                                    	IPv6 Access\-list
                                                                    	**type**\:  :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                    
                                                                    .. attribute:: ether_service_acl
                                                                    
                                                                    	Ethernet\-Services Access\-list
                                                                    	**type**\:  :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                    
                                                                    .. attribute:: avail_id
                                                                    
                                                                    	Available Identifiers
                                                                    	**type**\:  :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                    
                                                                    .. attribute:: media_type
                                                                    
                                                                    	Media Type
                                                                    	**type**\:  :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                    
                                                                    .. attribute:: subs_protocol
                                                                    
                                                                    	Protocol
                                                                    	**type**\:  :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                    
                                                                    .. attribute:: dnis
                                                                    
                                                                    	DNIS
                                                                    	**type**\:  :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                    
                                                                    .. attribute:: dnis_regex
                                                                    
                                                                    	DNIS Regular Expression
                                                                    	**type**\:  :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                    
                                                                    .. attribute:: domain
                                                                    
                                                                    	Domain Name
                                                                    	**type**\:  :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                    
                                                                    .. attribute:: domain_regex
                                                                    
                                                                    	Domain Regular Expression
                                                                    	**type**\:  :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                    
                                                                    .. attribute:: nas_port
                                                                    
                                                                    	NAS Port
                                                                    	**type**\:  :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                    
                                                                    .. attribute:: service_name
                                                                    
                                                                    	Service Name
                                                                    	**type**\:  :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                    
                                                                    .. attribute:: service_name_regex
                                                                    
                                                                    	Service Name Regular Exp
                                                                    	**type**\:  :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                    
                                                                    .. attribute:: src_addr_ipv4
                                                                    
                                                                    	Source Address IPV4
                                                                    	**type**\:  :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                    
                                                                    .. attribute:: dst_addr_ipv4
                                                                    
                                                                    	Destination Address IPV4
                                                                    	**type**\:  :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                    
                                                                    .. attribute:: src_addr_ipv6
                                                                    
                                                                    	Source Address IPV6
                                                                    	**type**\:  :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                    
                                                                    .. attribute:: dst_addr_ipv6
                                                                    
                                                                    	Destination Address IPV6
                                                                    	**type**\:  :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                    
                                                                    .. attribute:: src_addr_mac
                                                                    
                                                                    	Source Address MAC
                                                                    	**type**\:  :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                    
                                                                    .. attribute:: timer
                                                                    
                                                                    	Timer
                                                                    	**type**\:  :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                    
                                                                    .. attribute:: timer_regexp
                                                                    
                                                                    	Timer Regular Expression
                                                                    	**type**\:  :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                    
                                                                    .. attribute:: tunnel_name
                                                                    
                                                                    	Tunnel Name
                                                                    	**type**\:  :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                    
                                                                    .. attribute:: tunnel_name_regex
                                                                    
                                                                    	Tunnel Name Regular Expression
                                                                    	**type**\:  :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                    
                                                                    .. attribute:: user_name
                                                                    
                                                                    	User Name
                                                                    	**type**\:  :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                    
                                                                    .. attribute:: user_name_regex
                                                                    
                                                                    	User Name Regular Expression
                                                                    	**type**\:  :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                    
                                                                    .. attribute:: auth_username
                                                                    
                                                                    	Authenticated User Name
                                                                    	**type**\:  :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                    
                                                                    .. attribute:: auth_username_regex
                                                                    
                                                                    	Authenticated User Name RegEx
                                                                    	**type**\:  :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                    
                                                                    .. attribute:: unauth_username
                                                                    
                                                                    	Unauthenticated User Name
                                                                    	**type**\:  :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                    
                                                                    .. attribute:: unauth_username_regex
                                                                    
                                                                    	Unauthenticated User Name RegEx
                                                                    	**type**\:  :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                    
                                                                    .. attribute:: auth_domain
                                                                    
                                                                    	Authenticated domain name
                                                                    	**type**\:  :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                    
                                                                    .. attribute:: auth_domain_regex
                                                                    
                                                                    	Authenticated Domain Name RegEx
                                                                    	**type**\:  :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                    
                                                                    .. attribute:: unauth_domain
                                                                    
                                                                    	Unauthenticated Domain Name
                                                                    	**type**\:  :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                    
                                                                    .. attribute:: unauth_domain_regex
                                                                    
                                                                    	Unauthenticated Domain Name RegEx
                                                                    	**type**\:  :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                    
                                                                    .. attribute:: vendor_id
                                                                    
                                                                    	Vendor ID
                                                                    	**type**\:  :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                    
                                                                    .. attribute:: vendor_id_regex
                                                                    
                                                                    	Vendor ID RegEx
                                                                    	**type**\:  :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                    
                                                                    .. attribute:: access_interface
                                                                    
                                                                    	Access interface
                                                                    	**type**\:  :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                    
                                                                    .. attribute:: input_interface
                                                                    
                                                                    	Input interface
                                                                    	**type**\:  :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                    
                                                                    .. attribute:: input_intfhdl
                                                                    
                                                                    	Input interface handle
                                                                    	**type**\:  :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                    
                                                                    .. attribute:: ethertype
                                                                    
                                                                    	Ethernet type
                                                                    	**type**\:  :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                    
                                                                    .. attribute:: flow_key_data
                                                                    
                                                                    	Flow key structure
                                                                    	**type**\:  :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                    
                                                                    .. attribute:: dhcp_client_id
                                                                    
                                                                    	Dhcp Client ID
                                                                    	**type**\:  :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                    
                                                                    .. attribute:: dhcp_client_id_regex
                                                                    
                                                                    	Dhcp Client ID RegEx
                                                                    	**type**\:  :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                    
                                                                    .. attribute:: circuit_id
                                                                    
                                                                    	Circuit ID
                                                                    	**type**\:  :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                    
                                                                    .. attribute:: circuit_id_regex
                                                                    
                                                                    	Circuit ID RegEx
                                                                    	**type**\:  :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                    
                                                                    .. attribute:: remote_id
                                                                    
                                                                    	Remote ID
                                                                    	**type**\:  :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                    
                                                                    .. attribute:: remote_id_regex
                                                                    
                                                                    	Remote ID RegEx
                                                                    	**type**\:  :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                    
                                                                    .. attribute:: src_port
                                                                    
                                                                    	Source port
                                                                    	**type**\:  :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                    
                                                                    .. attribute:: dst_port
                                                                    
                                                                    	Destination port
                                                                    	**type**\:  :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                    
                                                                    .. attribute:: type
                                                                    
                                                                    	type
                                                                    	**type**\:  :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                    
                                                                    .. attribute:: mpls_top_eos
                                                                    
                                                                    	MPLS Topmost EOS
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    .. attribute:: fragment_type
                                                                    
                                                                    	Fragment type
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    .. attribute:: authen_status
                                                                    
                                                                    	Authentication Status
                                                                    	**type**\:  :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                    
                                                                    .. attribute:: mlp_negotiated
                                                                    
                                                                    	MLP Negotiated
                                                                    	**type**\:  :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                        self.yang_name = "match-data"
                                                                        self.yang_parent_name = "class-match-info-st"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("ipv4-dscp", ("ipv4_dscp", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp)), ("ipv6-dscp", ("ipv6_dscp", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp)), ("dscp", ("dscp", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp)), ("ipv4-prec", ("ipv4_prec", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec)), ("ipv6-prec", ("ipv6_prec", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec)), ("prec", ("prec", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec)), ("discard-class", ("discard_class", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass)), ("qos-group", ("qos_group", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup)), ("traffic-class", ("traffic_class", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass)), ("proto", ("proto", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto)), ("icmp-v4", ("icmp_v4", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4)), ("icmp-v6", ("icmp_v6", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6)), ("ipv4-packet-len", ("ipv4_packet_len", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen)), ("ipv6-packet-len", ("ipv6_packet_len", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen)), ("packet-len", ("packet_len", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen)), ("flow-tag", ("flow_tag", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag)), ("tcp-flag", ("tcp_flag", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag)), ("icmpv4-type", ("icmpv4_type", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type)), ("icmpv4-code", ("icmpv4_code", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code)), ("icmpv6-type", ("icmpv6_type", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type)), ("icmpv6-code", ("icmpv6_code", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code)), ("mpls-exp", ("mpls_exp", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp)), ("mpls-exp-imp", ("mpls_exp_imp", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp)), ("mpls-disp-ipv4-acl", ("mpls_disp_ipv4_acl", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl)), ("mpls-disp-ipv6-acl", ("mpls_disp_ipv6_acl", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl)), ("mpls-top-label", ("mpls_top_label", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel)), ("cos", ("cos", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos)), ("cos-inr", ("cos_inr", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr)), ("dei", ("dei", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei)), ("dei-inr", ("dei_inr", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr)), ("vlan", ("vlan", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan)), ("vlan-inr", ("vlan_inr", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)), ("fr-dlci", ("fr_dlci", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci)), ("src-mac", ("src_mac", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac)), ("dst-mac", ("dst_mac", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac)), ("atm-clp", ("atm_clp", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp)), ("fr-de", ("fr_de", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe)), ("ipv4-acl", ("ipv4_acl", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl)), ("ipv6-acl", ("ipv6_acl", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl)), ("ether-service-acl", ("ether_service_acl", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl)), ("avail-id", ("avail_id", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId)), ("media-type", ("media_type", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType)), ("subs-protocol", ("subs_protocol", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol)), ("dnis", ("dnis", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis)), ("dnis-regex", ("dnis_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex)), ("domain", ("domain", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain)), ("domain-regex", ("domain_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex)), ("nas-port", ("nas_port", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort)), ("service-name", ("service_name", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName)), ("service-name-regex", ("service_name_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex)), ("src-addr-ipv4", ("src_addr_ipv4", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4)), ("dst-addr-ipv4", ("dst_addr_ipv4", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4)), ("src-addr-ipv6", ("src_addr_ipv6", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6)), ("dst-addr-ipv6", ("dst_addr_ipv6", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6)), ("src-addr-mac", ("src_addr_mac", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac)), ("timer", ("timer", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer)), ("timer-regexp", ("timer_regexp", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp)), ("tunnel-name", ("tunnel_name", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName)), ("tunnel-name-regex", ("tunnel_name_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex)), ("user-name", ("user_name", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName)), ("user-name-regex", ("user_name_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex)), ("auth-username", ("auth_username", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername)), ("auth-username-regex", ("auth_username_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex)), ("unauth-username", ("unauth_username", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername)), ("unauth-username-regex", ("unauth_username_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex)), ("auth-domain", ("auth_domain", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain)), ("auth-domain-regex", ("auth_domain_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex)), ("unauth-domain", ("unauth_domain", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain)), ("unauth-domain-regex", ("unauth_domain_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex)), ("vendor-id", ("vendor_id", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId)), ("vendor-id-regex", ("vendor_id_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex)), ("access-interface", ("access_interface", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface)), ("input-interface", ("input_interface", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface)), ("input-intfhdl", ("input_intfhdl", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl)), ("ethertype", ("ethertype", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype)), ("flow-key-data", ("flow_key_data", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData)), ("dhcp-client-id", ("dhcp_client_id", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId)), ("dhcp-client-id-regex", ("dhcp_client_id_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex)), ("circuit-id", ("circuit_id", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId)), ("circuit-id-regex", ("circuit_id_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex)), ("remote-id", ("remote_id", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId)), ("remote-id-regex", ("remote_id_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex)), ("src-port", ("src_port", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort)), ("dst-port", ("dst_port", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort))])
                                                                        self._leafs = OrderedDict([
                                                                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchTypeEn', '')])),
                                                                            ('mpls_top_eos', (YLeaf(YType.uint8, 'mpls-top-eos'), ['int'])),
                                                                            ('fragment_type', (YLeaf(YType.uint8, 'fragment-type'), ['int'])),
                                                                            ('authen_status', (YLeaf(YType.enumeration, 'authen-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchAuthenStatusEn', '')])),
                                                                            ('mlp_negotiated', (YLeaf(YType.enumeration, 'mlp-negotiated'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchMlpNegotiatedEn', '')])),
                                                                        ])
                                                                        self.type = None
                                                                        self.mpls_top_eos = None
                                                                        self.fragment_type = None
                                                                        self.authen_status = None
                                                                        self.mlp_negotiated = None

                                                                        self.ipv4_dscp = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                        self.ipv4_dscp.parent = self
                                                                        self._children_name_map["ipv4_dscp"] = "ipv4-dscp"

                                                                        self.ipv6_dscp = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                        self.ipv6_dscp.parent = self
                                                                        self._children_name_map["ipv6_dscp"] = "ipv6-dscp"

                                                                        self.dscp = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                        self.dscp.parent = self
                                                                        self._children_name_map["dscp"] = "dscp"

                                                                        self.ipv4_prec = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                        self.ipv4_prec.parent = self
                                                                        self._children_name_map["ipv4_prec"] = "ipv4-prec"

                                                                        self.ipv6_prec = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                        self.ipv6_prec.parent = self
                                                                        self._children_name_map["ipv6_prec"] = "ipv6-prec"

                                                                        self.prec = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                        self.prec.parent = self
                                                                        self._children_name_map["prec"] = "prec"

                                                                        self.discard_class = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                        self.discard_class.parent = self
                                                                        self._children_name_map["discard_class"] = "discard-class"

                                                                        self.qos_group = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                        self.qos_group.parent = self
                                                                        self._children_name_map["qos_group"] = "qos-group"

                                                                        self.traffic_class = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                        self.traffic_class.parent = self
                                                                        self._children_name_map["traffic_class"] = "traffic-class"

                                                                        self.proto = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                        self.proto.parent = self
                                                                        self._children_name_map["proto"] = "proto"

                                                                        self.icmp_v4 = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                        self.icmp_v4.parent = self
                                                                        self._children_name_map["icmp_v4"] = "icmp-v4"

                                                                        self.icmp_v6 = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                        self.icmp_v6.parent = self
                                                                        self._children_name_map["icmp_v6"] = "icmp-v6"

                                                                        self.ipv4_packet_len = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                        self.ipv4_packet_len.parent = self
                                                                        self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"

                                                                        self.ipv6_packet_len = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                        self.ipv6_packet_len.parent = self
                                                                        self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"

                                                                        self.packet_len = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                        self.packet_len.parent = self
                                                                        self._children_name_map["packet_len"] = "packet-len"

                                                                        self.flow_tag = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                        self.flow_tag.parent = self
                                                                        self._children_name_map["flow_tag"] = "flow-tag"

                                                                        self.tcp_flag = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                        self.tcp_flag.parent = self
                                                                        self._children_name_map["tcp_flag"] = "tcp-flag"

                                                                        self.icmpv4_type = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                        self.icmpv4_type.parent = self
                                                                        self._children_name_map["icmpv4_type"] = "icmpv4-type"

                                                                        self.icmpv4_code = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                        self.icmpv4_code.parent = self
                                                                        self._children_name_map["icmpv4_code"] = "icmpv4-code"

                                                                        self.icmpv6_type = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                        self.icmpv6_type.parent = self
                                                                        self._children_name_map["icmpv6_type"] = "icmpv6-type"

                                                                        self.icmpv6_code = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                        self.icmpv6_code.parent = self
                                                                        self._children_name_map["icmpv6_code"] = "icmpv6-code"

                                                                        self.mpls_exp = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                        self.mpls_exp.parent = self
                                                                        self._children_name_map["mpls_exp"] = "mpls-exp"

                                                                        self.mpls_exp_imp = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                        self.mpls_exp_imp.parent = self
                                                                        self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"

                                                                        self.mpls_disp_ipv4_acl = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                        self.mpls_disp_ipv4_acl.parent = self
                                                                        self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"

                                                                        self.mpls_disp_ipv6_acl = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                        self.mpls_disp_ipv6_acl.parent = self
                                                                        self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"

                                                                        self.mpls_top_label = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                        self.mpls_top_label.parent = self
                                                                        self._children_name_map["mpls_top_label"] = "mpls-top-label"

                                                                        self.cos = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                        self.cos.parent = self
                                                                        self._children_name_map["cos"] = "cos"

                                                                        self.cos_inr = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                        self.cos_inr.parent = self
                                                                        self._children_name_map["cos_inr"] = "cos-inr"

                                                                        self.dei = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                        self.dei.parent = self
                                                                        self._children_name_map["dei"] = "dei"

                                                                        self.dei_inr = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                        self.dei_inr.parent = self
                                                                        self._children_name_map["dei_inr"] = "dei-inr"

                                                                        self.vlan = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                        self.vlan.parent = self
                                                                        self._children_name_map["vlan"] = "vlan"

                                                                        self.vlan_inr = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                        self.vlan_inr.parent = self
                                                                        self._children_name_map["vlan_inr"] = "vlan-inr"

                                                                        self.fr_dlci = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                        self.fr_dlci.parent = self
                                                                        self._children_name_map["fr_dlci"] = "fr-dlci"

                                                                        self.src_mac = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                        self.src_mac.parent = self
                                                                        self._children_name_map["src_mac"] = "src-mac"

                                                                        self.dst_mac = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                        self.dst_mac.parent = self
                                                                        self._children_name_map["dst_mac"] = "dst-mac"

                                                                        self.atm_clp = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                        self.atm_clp.parent = self
                                                                        self._children_name_map["atm_clp"] = "atm-clp"

                                                                        self.fr_de = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                        self.fr_de.parent = self
                                                                        self._children_name_map["fr_de"] = "fr-de"

                                                                        self.ipv4_acl = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                        self.ipv4_acl.parent = self
                                                                        self._children_name_map["ipv4_acl"] = "ipv4-acl"

                                                                        self.ipv6_acl = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                        self.ipv6_acl.parent = self
                                                                        self._children_name_map["ipv6_acl"] = "ipv6-acl"

                                                                        self.ether_service_acl = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                        self.ether_service_acl.parent = self
                                                                        self._children_name_map["ether_service_acl"] = "ether-service-acl"

                                                                        self.avail_id = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                        self.avail_id.parent = self
                                                                        self._children_name_map["avail_id"] = "avail-id"

                                                                        self.media_type = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                        self.media_type.parent = self
                                                                        self._children_name_map["media_type"] = "media-type"

                                                                        self.subs_protocol = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                        self.subs_protocol.parent = self
                                                                        self._children_name_map["subs_protocol"] = "subs-protocol"

                                                                        self.dnis = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                        self.dnis.parent = self
                                                                        self._children_name_map["dnis"] = "dnis"

                                                                        self.dnis_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                        self.dnis_regex.parent = self
                                                                        self._children_name_map["dnis_regex"] = "dnis-regex"

                                                                        self.domain = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                        self.domain.parent = self
                                                                        self._children_name_map["domain"] = "domain"

                                                                        self.domain_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                        self.domain_regex.parent = self
                                                                        self._children_name_map["domain_regex"] = "domain-regex"

                                                                        self.nas_port = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                        self.nas_port.parent = self
                                                                        self._children_name_map["nas_port"] = "nas-port"

                                                                        self.service_name = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                        self.service_name.parent = self
                                                                        self._children_name_map["service_name"] = "service-name"

                                                                        self.service_name_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                        self.service_name_regex.parent = self
                                                                        self._children_name_map["service_name_regex"] = "service-name-regex"

                                                                        self.src_addr_ipv4 = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                        self.src_addr_ipv4.parent = self
                                                                        self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"

                                                                        self.dst_addr_ipv4 = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                        self.dst_addr_ipv4.parent = self
                                                                        self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"

                                                                        self.src_addr_ipv6 = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                        self.src_addr_ipv6.parent = self
                                                                        self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"

                                                                        self.dst_addr_ipv6 = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                        self.dst_addr_ipv6.parent = self
                                                                        self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"

                                                                        self.src_addr_mac = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                        self.src_addr_mac.parent = self
                                                                        self._children_name_map["src_addr_mac"] = "src-addr-mac"

                                                                        self.timer = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                        self.timer.parent = self
                                                                        self._children_name_map["timer"] = "timer"

                                                                        self.timer_regexp = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                        self.timer_regexp.parent = self
                                                                        self._children_name_map["timer_regexp"] = "timer-regexp"

                                                                        self.tunnel_name = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                        self.tunnel_name.parent = self
                                                                        self._children_name_map["tunnel_name"] = "tunnel-name"

                                                                        self.tunnel_name_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                        self.tunnel_name_regex.parent = self
                                                                        self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"

                                                                        self.user_name = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                        self.user_name.parent = self
                                                                        self._children_name_map["user_name"] = "user-name"

                                                                        self.user_name_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                        self.user_name_regex.parent = self
                                                                        self._children_name_map["user_name_regex"] = "user-name-regex"

                                                                        self.auth_username = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                        self.auth_username.parent = self
                                                                        self._children_name_map["auth_username"] = "auth-username"

                                                                        self.auth_username_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                        self.auth_username_regex.parent = self
                                                                        self._children_name_map["auth_username_regex"] = "auth-username-regex"

                                                                        self.unauth_username = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                        self.unauth_username.parent = self
                                                                        self._children_name_map["unauth_username"] = "unauth-username"

                                                                        self.unauth_username_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                        self.unauth_username_regex.parent = self
                                                                        self._children_name_map["unauth_username_regex"] = "unauth-username-regex"

                                                                        self.auth_domain = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                        self.auth_domain.parent = self
                                                                        self._children_name_map["auth_domain"] = "auth-domain"

                                                                        self.auth_domain_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                        self.auth_domain_regex.parent = self
                                                                        self._children_name_map["auth_domain_regex"] = "auth-domain-regex"

                                                                        self.unauth_domain = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                        self.unauth_domain.parent = self
                                                                        self._children_name_map["unauth_domain"] = "unauth-domain"

                                                                        self.unauth_domain_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                        self.unauth_domain_regex.parent = self
                                                                        self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"

                                                                        self.vendor_id = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                        self.vendor_id.parent = self
                                                                        self._children_name_map["vendor_id"] = "vendor-id"

                                                                        self.vendor_id_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                        self.vendor_id_regex.parent = self
                                                                        self._children_name_map["vendor_id_regex"] = "vendor-id-regex"

                                                                        self.access_interface = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                        self.access_interface.parent = self
                                                                        self._children_name_map["access_interface"] = "access-interface"

                                                                        self.input_interface = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                        self.input_interface.parent = self
                                                                        self._children_name_map["input_interface"] = "input-interface"

                                                                        self.input_intfhdl = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                        self.input_intfhdl.parent = self
                                                                        self._children_name_map["input_intfhdl"] = "input-intfhdl"

                                                                        self.ethertype = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                        self.ethertype.parent = self
                                                                        self._children_name_map["ethertype"] = "ethertype"

                                                                        self.flow_key_data = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                        self.flow_key_data.parent = self
                                                                        self._children_name_map["flow_key_data"] = "flow-key-data"

                                                                        self.dhcp_client_id = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                        self.dhcp_client_id.parent = self
                                                                        self._children_name_map["dhcp_client_id"] = "dhcp-client-id"

                                                                        self.dhcp_client_id_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                        self.dhcp_client_id_regex.parent = self
                                                                        self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"

                                                                        self.circuit_id = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                        self.circuit_id.parent = self
                                                                        self._children_name_map["circuit_id"] = "circuit-id"

                                                                        self.circuit_id_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                        self.circuit_id_regex.parent = self
                                                                        self._children_name_map["circuit_id_regex"] = "circuit-id-regex"

                                                                        self.remote_id = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                        self.remote_id.parent = self
                                                                        self._children_name_map["remote_id"] = "remote-id"

                                                                        self.remote_id_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                        self.remote_id_regex.parent = self
                                                                        self._children_name_map["remote_id_regex"] = "remote-id-regex"

                                                                        self.src_port = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                        self.src_port.parent = self
                                                                        self._children_name_map["src_port"] = "src-port"

                                                                        self.dst_port = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                        self.dst_port.parent = self
                                                                        self._children_name_map["dst_port"] = "dst-port"
                                                                        self._segment_path = lambda: "match-data"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, ['type', 'mpls_top_eos', 'fragment_type', 'authen_status', 'mlp_negotiated'], name, value)


                                                                    class Ipv4Dscp(Entity):
                                                                        """
                                                                        IPv4 DSCP
                                                                        
                                                                        .. attribute:: uint8_rng_array
                                                                        
                                                                        	uint8 rng array
                                                                        	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                            self.yang_name = "ipv4-dscp"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.uint8_rng_array = YList(self)
                                                                            self._segment_path = lambda: "ipv4-dscp"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                        class Uint8RngArray(Entity):
                                                                            """
                                                                            uint8 rng array
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                self.yang_name = "uint8_rng_array"
                                                                                self.yang_parent_name = "ipv4-dscp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                    ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                ])
                                                                                self.min = None
                                                                                self.max = None
                                                                                self._segment_path = lambda: "uint8_rng_array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                    class Ipv6Dscp(Entity):
                                                                        """
                                                                        IPv6 DSCP
                                                                        
                                                                        .. attribute:: uint8_rng_array
                                                                        
                                                                        	uint8 rng array
                                                                        	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                            self.yang_name = "ipv6-dscp"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.uint8_rng_array = YList(self)
                                                                            self._segment_path = lambda: "ipv6-dscp"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                        class Uint8RngArray(Entity):
                                                                            """
                                                                            uint8 rng array
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                self.yang_name = "uint8_rng_array"
                                                                                self.yang_parent_name = "ipv6-dscp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                    ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                ])
                                                                                self.min = None
                                                                                self.max = None
                                                                                self._segment_path = lambda: "uint8_rng_array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                    class Dscp(Entity):
                                                                        """
                                                                        Match DSCP range array
                                                                        
                                                                        .. attribute:: uint8_rng_array
                                                                        
                                                                        	uint8 rng array
                                                                        	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                            self.yang_name = "dscp"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.uint8_rng_array = YList(self)
                                                                            self._segment_path = lambda: "dscp"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                        class Uint8RngArray(Entity):
                                                                            """
                                                                            uint8 rng array
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                self.yang_name = "uint8_rng_array"
                                                                                self.yang_parent_name = "dscp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                    ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                ])
                                                                                self.min = None
                                                                                self.max = None
                                                                                self._segment_path = lambda: "uint8_rng_array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                    class Ipv4Prec(Entity):
                                                                        """
                                                                        IPv4 Precedence
                                                                        
                                                                        .. attribute:: uint8_array
                                                                        
                                                                        	uint8 array
                                                                        	**type**\: list of int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                            self.yang_name = "ipv4-prec"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                            ])
                                                                            self.uint8_array = []
                                                                            self._segment_path = lambda: "ipv4-prec"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                    class Ipv6Prec(Entity):
                                                                        """
                                                                        IPv6 Precedence
                                                                        
                                                                        .. attribute:: uint8_array
                                                                        
                                                                        	uint8 array
                                                                        	**type**\: list of int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                            self.yang_name = "ipv6-prec"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                            ])
                                                                            self.uint8_array = []
                                                                            self._segment_path = lambda: "ipv6-prec"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                    class Prec(Entity):
                                                                        """
                                                                        Match Precedence array
                                                                        
                                                                        .. attribute:: uint8_array
                                                                        
                                                                        	uint8 array
                                                                        	**type**\: list of int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                            self.yang_name = "prec"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                            ])
                                                                            self.uint8_array = []
                                                                            self._segment_path = lambda: "prec"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                    class DiscardClass(Entity):
                                                                        """
                                                                        Match Discard Class array
                                                                        
                                                                        .. attribute:: uint8_array
                                                                        
                                                                        	uint8 array
                                                                        	**type**\: list of int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                            self.yang_name = "discard-class"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                            ])
                                                                            self.uint8_array = []
                                                                            self._segment_path = lambda: "discard-class"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                    class QosGroup(Entity):
                                                                        """
                                                                        Match QoS group array
                                                                        
                                                                        .. attribute:: uint16_rng_array
                                                                        
                                                                        	uint16 rng array
                                                                        	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                            self.yang_name = "qos-group"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.uint16_rng_array = YList(self)
                                                                            self._segment_path = lambda: "qos-group"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                        class Uint16RngArray(Entity):
                                                                            """
                                                                            uint16 rng array
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                self.yang_name = "uint16_rng_array"
                                                                                self.yang_parent_name = "qos-group"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                    ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                ])
                                                                                self.min = None
                                                                                self.max = None
                                                                                self._segment_path = lambda: "uint16_rng_array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['min', 'max'], name, value)


                                                                    class TrafficClass(Entity):
                                                                        """
                                                                        Match Traffic class array
                                                                        
                                                                        .. attribute:: uint8_rng_array
                                                                        
                                                                        	uint8 rng array
                                                                        	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                            self.yang_name = "traffic-class"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.uint8_rng_array = YList(self)
                                                                            self._segment_path = lambda: "traffic-class"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                        class Uint8RngArray(Entity):
                                                                            """
                                                                            uint8 rng array
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                self.yang_name = "uint8_rng_array"
                                                                                self.yang_parent_name = "traffic-class"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                    ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                ])
                                                                                self.min = None
                                                                                self.max = None
                                                                                self._segment_path = lambda: "uint8_rng_array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['min', 'max'], name, value)


                                                                    class Proto(Entity):
                                                                        """
                                                                        Match Protocol array
                                                                        
                                                                        .. attribute:: uint16_rng_array
                                                                        
                                                                        	uint16 rng array
                                                                        	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                            self.yang_name = "proto"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.uint16_rng_array = YList(self)
                                                                            self._segment_path = lambda: "proto"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                        class Uint16RngArray(Entity):
                                                                            """
                                                                            uint16 rng array
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                self.yang_name = "uint16_rng_array"
                                                                                self.yang_parent_name = "proto"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                    ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                ])
                                                                                self.min = None
                                                                                self.max = None
                                                                                self._segment_path = lambda: "uint16_rng_array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['min', 'max'], name, value)


                                                                    class IcmpV4(Entity):
                                                                        """
                                                                        Match ICMPV4 Protocol
                                                                        
                                                                        .. attribute:: type
                                                                        
                                                                        	Protocol type
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: code
                                                                        
                                                                        	Protocol code
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                            self.yang_name = "icmp-v4"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                            ])
                                                                            self.type = None
                                                                            self.code = None
                                                                            self._segment_path = lambda: "icmp-v4"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['type', 'code'], name, value)


                                                                    class IcmpV6(Entity):
                                                                        """
                                                                        Match ICMPV6 Protocol array
                                                                        
                                                                        .. attribute:: type
                                                                        
                                                                        	Protocol type
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: code
                                                                        
                                                                        	Protocol code
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                            self.yang_name = "icmp-v6"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                            ])
                                                                            self.type = None
                                                                            self.code = None
                                                                            self._segment_path = lambda: "icmp-v6"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['type', 'code'], name, value)


                                                                    class Ipv4PacketLen(Entity):
                                                                        """
                                                                        IPv4 packet length array
                                                                        
                                                                        .. attribute:: uint16_rng_array
                                                                        
                                                                        	uint16 rng array
                                                                        	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                            self.yang_name = "ipv4-packet-len"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.uint16_rng_array = YList(self)
                                                                            self._segment_path = lambda: "ipv4-packet-len"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                        class Uint16RngArray(Entity):
                                                                            """
                                                                            uint16 rng array
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                self.yang_name = "uint16_rng_array"
                                                                                self.yang_parent_name = "ipv4-packet-len"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                    ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                ])
                                                                                self.min = None
                                                                                self.max = None
                                                                                self._segment_path = lambda: "uint16_rng_array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                    class Ipv6PacketLen(Entity):
                                                                        """
                                                                        IPv6 packet length array
                                                                        
                                                                        .. attribute:: uint16_rng_array
                                                                        
                                                                        	uint16 rng array
                                                                        	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                            self.yang_name = "ipv6-packet-len"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.uint16_rng_array = YList(self)
                                                                            self._segment_path = lambda: "ipv6-packet-len"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                        class Uint16RngArray(Entity):
                                                                            """
                                                                            uint16 rng array
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                self.yang_name = "uint16_rng_array"
                                                                                self.yang_parent_name = "ipv6-packet-len"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                    ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                ])
                                                                                self.min = None
                                                                                self.max = None
                                                                                self._segment_path = lambda: "uint16_rng_array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                    class PacketLen(Entity):
                                                                        """
                                                                        Match packet length array
                                                                        
                                                                        .. attribute:: uint16_rng_array
                                                                        
                                                                        	uint16 rng array
                                                                        	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                            self.yang_name = "packet-len"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.uint16_rng_array = YList(self)
                                                                            self._segment_path = lambda: "packet-len"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                        class Uint16RngArray(Entity):
                                                                            """
                                                                            uint16 rng array
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                self.yang_name = "uint16_rng_array"
                                                                                self.yang_parent_name = "packet-len"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                    ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                ])
                                                                                self.min = None
                                                                                self.max = None
                                                                                self._segment_path = lambda: "uint16_rng_array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                    class FlowTag(Entity):
                                                                        """
                                                                        Match flow\-tag array
                                                                        
                                                                        .. attribute:: uint8_rng_array
                                                                        
                                                                        	uint8 rng array
                                                                        	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                            self.yang_name = "flow-tag"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.uint8_rng_array = YList(self)
                                                                            self._segment_path = lambda: "flow-tag"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                        class Uint8RngArray(Entity):
                                                                            """
                                                                            uint8 rng array
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                self.yang_name = "uint8_rng_array"
                                                                                self.yang_parent_name = "flow-tag"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                    ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                ])
                                                                                self.min = None
                                                                                self.max = None
                                                                                self._segment_path = lambda: "uint8_rng_array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['min', 'max'], name, value)


                                                                    class TcpFlag(Entity):
                                                                        """
                                                                        Match tcp flag value
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	Value of TCP flag
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..65535
                                                                        
                                                                        .. attribute:: match_any
                                                                        
                                                                        	Match any TCP flag bit
                                                                        	**type**\: bool
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                            self.yang_name = "tcp-flag"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                ('match_any', (YLeaf(YType.boolean, 'match-any'), ['bool'])),
                                                                            ])
                                                                            self.value = None
                                                                            self.match_any = None
                                                                            self._segment_path = lambda: "tcp-flag"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['value', 'match_any'], name, value)


                                                                    class Icmpv4Type(Entity):
                                                                        """
                                                                        Match ipv4 icmp type
                                                                        
                                                                        .. attribute:: uint8_rng_array
                                                                        
                                                                        	uint8 rng array
                                                                        	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                            self.yang_name = "icmpv4-type"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.uint8_rng_array = YList(self)
                                                                            self._segment_path = lambda: "icmpv4-type"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                        class Uint8RngArray(Entity):
                                                                            """
                                                                            uint8 rng array
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                self.yang_name = "uint8_rng_array"
                                                                                self.yang_parent_name = "icmpv4-type"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                    ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                ])
                                                                                self.min = None
                                                                                self.max = None
                                                                                self._segment_path = lambda: "uint8_rng_array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                    class Icmpv4Code(Entity):
                                                                        """
                                                                        Match ipv4 icmp code
                                                                        
                                                                        .. attribute:: uint8_rng_array
                                                                        
                                                                        	uint8 rng array
                                                                        	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                            self.yang_name = "icmpv4-code"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.uint8_rng_array = YList(self)
                                                                            self._segment_path = lambda: "icmpv4-code"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                        class Uint8RngArray(Entity):
                                                                            """
                                                                            uint8 rng array
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                self.yang_name = "uint8_rng_array"
                                                                                self.yang_parent_name = "icmpv4-code"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                    ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                ])
                                                                                self.min = None
                                                                                self.max = None
                                                                                self._segment_path = lambda: "uint8_rng_array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                    class Icmpv6Type(Entity):
                                                                        """
                                                                        Match ipv6 icmp type
                                                                        
                                                                        .. attribute:: uint8_rng_array
                                                                        
                                                                        	uint8 rng array
                                                                        	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                            self.yang_name = "icmpv6-type"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.uint8_rng_array = YList(self)
                                                                            self._segment_path = lambda: "icmpv6-type"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                        class Uint8RngArray(Entity):
                                                                            """
                                                                            uint8 rng array
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                self.yang_name = "uint8_rng_array"
                                                                                self.yang_parent_name = "icmpv6-type"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                    ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                ])
                                                                                self.min = None
                                                                                self.max = None
                                                                                self._segment_path = lambda: "uint8_rng_array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                    class Icmpv6Code(Entity):
                                                                        """
                                                                        Match ipv6 icmp code
                                                                        
                                                                        .. attribute:: uint8_rng_array
                                                                        
                                                                        	uint8 rng array
                                                                        	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                            self.yang_name = "icmpv6-code"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.uint8_rng_array = YList(self)
                                                                            self._segment_path = lambda: "icmpv6-code"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                        class Uint8RngArray(Entity):
                                                                            """
                                                                            uint8 rng array
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                self.yang_name = "uint8_rng_array"
                                                                                self.yang_parent_name = "icmpv6-code"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                    ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                ])
                                                                                self.min = None
                                                                                self.max = None
                                                                                self._segment_path = lambda: "uint8_rng_array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                    class MplsExp(Entity):
                                                                        """
                                                                        Match MPLS experimental topmost array
                                                                        
                                                                        .. attribute:: uint8_array
                                                                        
                                                                        	uint8 array
                                                                        	**type**\: list of int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                            self.yang_name = "mpls-exp"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                            ])
                                                                            self.uint8_array = []
                                                                            self._segment_path = lambda: "mpls-exp"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                    class MplsExpImp(Entity):
                                                                        """
                                                                        Match MPLS experimental imposition array
                                                                        
                                                                        .. attribute:: uint8_array
                                                                        
                                                                        	uint8 array
                                                                        	**type**\: list of int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                            self.yang_name = "mpls-exp-imp"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                            ])
                                                                            self.uint8_array = []
                                                                            self._segment_path = lambda: "mpls-exp-imp"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                    class MplsDispIpv4Acl(Entity):
                                                                        """
                                                                        MPLS Disposition IPv4 Access\-list
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\: list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                            self.yang_name = "mpls-disp-ipv4-acl"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                            ])
                                                                            self.string_array = []
                                                                            self._segment_path = lambda: "mpls-disp-ipv4-acl"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                    class MplsDispIpv6Acl(Entity):
                                                                        """
                                                                        MPLS Disposition IPv6 Access\-list
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\: list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                            self.yang_name = "mpls-disp-ipv6-acl"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                            ])
                                                                            self.string_array = []
                                                                            self._segment_path = lambda: "mpls-disp-ipv6-acl"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                    class MplsTopLabel(Entity):
                                                                        """
                                                                        MPLS Topmost LABEL
                                                                        
                                                                        .. attribute:: uint32_rng_array
                                                                        
                                                                        	uint32 rng array
                                                                        	**type**\: list of  		 :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                            self.yang_name = "mpls-top-label"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("uint32_rng_array", ("uint32_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.uint32_rng_array = YList(self)
                                                                            self._segment_path = lambda: "mpls-top-label"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                        class Uint32RngArray(Entity):
                                                                            """
                                                                            uint32 rng array
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                self.yang_name = "uint32_rng_array"
                                                                                self.yang_parent_name = "mpls-top-label"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('min', (YLeaf(YType.uint32, 'min'), ['int'])),
                                                                                    ('max', (YLeaf(YType.uint32, 'max'), ['int'])),
                                                                                ])
                                                                                self.min = None
                                                                                self.max = None
                                                                                self._segment_path = lambda: "uint32_rng_array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['min', 'max'], name, value)


                                                                    class Cos(Entity):
                                                                        """
                                                                        Match CoS array
                                                                        
                                                                        .. attribute:: uint8_array
                                                                        
                                                                        	uint8 array
                                                                        	**type**\: list of int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                            self.yang_name = "cos"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                            ])
                                                                            self.uint8_array = []
                                                                            self._segment_path = lambda: "cos"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                    class CosInr(Entity):
                                                                        """
                                                                        Match inner header CoS
                                                                        
                                                                        .. attribute:: uint8_array
                                                                        
                                                                        	uint8 array
                                                                        	**type**\: list of int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                            self.yang_name = "cos-inr"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                            ])
                                                                            self.uint8_array = []
                                                                            self._segment_path = lambda: "cos-inr"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                    class Dei(Entity):
                                                                        """
                                                                        Match DEI Bit
                                                                        
                                                                        .. attribute:: bit_value
                                                                        
                                                                        	Value of the DEI bit
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                            self.yang_name = "dei"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                            ])
                                                                            self.bit_value = None
                                                                            self._segment_path = lambda: "dei"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                    class DeiInr(Entity):
                                                                        """
                                                                        Match inner DEI Bit
                                                                        
                                                                        .. attribute:: bit_value
                                                                        
                                                                        	Value of the DEI bit
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                            self.yang_name = "dei-inr"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                            ])
                                                                            self.bit_value = None
                                                                            self._segment_path = lambda: "dei-inr"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                    class Vlan(Entity):
                                                                        """
                                                                        Match VLAN array
                                                                        
                                                                        .. attribute:: vlan_id_array
                                                                        
                                                                        	vlan id array
                                                                        	**type**\: list of  		 :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                            self.yang_name = "vlan"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("vlan-id-array", ("vlan_id_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.vlan_id_array = YList(self)
                                                                            self._segment_path = lambda: "vlan"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                        class VlanIdArray(Entity):
                                                                            """
                                                                            vlan id array
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: mask
                                                                            
                                                                            	VLAN mask
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                self.yang_name = "vlan-id-array"
                                                                                self.yang_parent_name = "vlan"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                    ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                    ('mask', (YLeaf(YType.uint16, 'mask'), ['int'])),
                                                                                ])
                                                                                self.min = None
                                                                                self.max = None
                                                                                self.mask = None
                                                                                self._segment_path = lambda: "vlan-id-array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['min', 'max', 'mask'], name, value)


                                                                    class VlanInr(Entity):
                                                                        """
                                                                        Match inner header VLAN range array
                                                                        
                                                                        .. attribute:: uint16_rng_array
                                                                        
                                                                        	uint16 rng array
                                                                        	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                            self.yang_name = "vlan-inr"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.uint16_rng_array = YList(self)
                                                                            self._segment_path = lambda: "vlan-inr"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                        class Uint16RngArray(Entity):
                                                                            """
                                                                            uint16 rng array
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                self.yang_name = "uint16_rng_array"
                                                                                self.yang_parent_name = "vlan-inr"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                    ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                ])
                                                                                self.min = None
                                                                                self.max = None
                                                                                self._segment_path = lambda: "uint16_rng_array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['min', 'max'], name, value)


                                                                    class FrDlci(Entity):
                                                                        """
                                                                        Match FR DLCI range array
                                                                        
                                                                        .. attribute:: uint16_rng_array
                                                                        
                                                                        	uint16 rng array
                                                                        	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                            self.yang_name = "fr-dlci"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.uint16_rng_array = YList(self)
                                                                            self._segment_path = lambda: "fr-dlci"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                        class Uint16RngArray(Entity):
                                                                            """
                                                                            uint16 rng array
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                self.yang_name = "uint16_rng_array"
                                                                                self.yang_parent_name = "fr-dlci"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                    ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                ])
                                                                                self.min = None
                                                                                self.max = None
                                                                                self._segment_path = lambda: "uint16_rng_array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['min', 'max'], name, value)


                                                                    class SrcMac(Entity):
                                                                        """
                                                                        Match Source MAC address
                                                                        
                                                                        .. attribute:: mac_addr
                                                                        
                                                                        	MAC address
                                                                        	**type**\: list of int
                                                                        
                                                                        	**range:** 0..65535
                                                                        
                                                                        .. attribute:: mask
                                                                        
                                                                        	MAC mask
                                                                        	**type**\: list of int
                                                                        
                                                                        	**range:** 0..65535
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                            self.yang_name = "src-mac"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                            ])
                                                                            self.mac_addr = []
                                                                            self.mask = []
                                                                            self._segment_path = lambda: "src-mac"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                    class DstMac(Entity):
                                                                        """
                                                                        Match Destination MAC address
                                                                        
                                                                        .. attribute:: mac_addr
                                                                        
                                                                        	MAC address
                                                                        	**type**\: list of int
                                                                        
                                                                        	**range:** 0..65535
                                                                        
                                                                        .. attribute:: mask
                                                                        
                                                                        	MAC mask
                                                                        	**type**\: list of int
                                                                        
                                                                        	**range:** 0..65535
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                            self.yang_name = "dst-mac"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                            ])
                                                                            self.mac_addr = []
                                                                            self.mask = []
                                                                            self._segment_path = lambda: "dst-mac"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                    class AtmClp(Entity):
                                                                        """
                                                                        Match ATM CLP level
                                                                        
                                                                        .. attribute:: uint8_array
                                                                        
                                                                        	uint8 array
                                                                        	**type**\: list of int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                            self.yang_name = "atm-clp"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                            ])
                                                                            self.uint8_array = []
                                                                            self._segment_path = lambda: "atm-clp"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                    class FrDe(Entity):
                                                                        """
                                                                        Match FR DE value
                                                                        
                                                                        .. attribute:: uint8_array
                                                                        
                                                                        	uint8 array
                                                                        	**type**\: list of int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                            self.yang_name = "fr-de"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                            ])
                                                                            self.uint8_array = []
                                                                            self._segment_path = lambda: "fr-de"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                    class Ipv4Acl(Entity):
                                                                        """
                                                                        IPv4 Access\-list
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\: list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                            self.yang_name = "ipv4-acl"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                            ])
                                                                            self.string_array = []
                                                                            self._segment_path = lambda: "ipv4-acl"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                    class Ipv6Acl(Entity):
                                                                        """
                                                                        IPv6 Access\-list
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\: list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                            self.yang_name = "ipv6-acl"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                            ])
                                                                            self.string_array = []
                                                                            self._segment_path = lambda: "ipv6-acl"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                    class EtherServiceAcl(Entity):
                                                                        """
                                                                        Ethernet\-Services Access\-list
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\: list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                            self.yang_name = "ether-service-acl"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                            ])
                                                                            self.string_array = []
                                                                            self._segment_path = lambda: "ether-service-acl"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                    class AvailId(Entity):
                                                                        """
                                                                        Available Identifiers
                                                                        
                                                                        .. attribute:: uint8_array
                                                                        
                                                                        	uint8 array
                                                                        	**type**\: list of int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                            self.yang_name = "avail-id"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                            ])
                                                                            self.uint8_array = []
                                                                            self._segment_path = lambda: "avail-id"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                    class MediaType(Entity):
                                                                        """
                                                                        Media Type
                                                                        
                                                                        .. attribute:: uint8_array
                                                                        
                                                                        	uint8 array
                                                                        	**type**\: list of int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                            self.yang_name = "media-type"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                            ])
                                                                            self.uint8_array = []
                                                                            self._segment_path = lambda: "media-type"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                    class SubsProtocol(Entity):
                                                                        """
                                                                        Protocol
                                                                        
                                                                        .. attribute:: uint8_array
                                                                        
                                                                        	uint8 array
                                                                        	**type**\: list of int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                            self.yang_name = "subs-protocol"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                            ])
                                                                            self.uint8_array = []
                                                                            self._segment_path = lambda: "subs-protocol"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                    class Dnis(Entity):
                                                                        """
                                                                        DNIS
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\: list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                            self.yang_name = "dnis"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                            ])
                                                                            self.string_array = []
                                                                            self._segment_path = lambda: "dnis"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                    class DnisRegex(Entity):
                                                                        """
                                                                        DNIS Regular Expression
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\: list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                            self.yang_name = "dnis-regex"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                            ])
                                                                            self.string_array = []
                                                                            self._segment_path = lambda: "dnis-regex"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                    class Domain(Entity):
                                                                        """
                                                                        Domain Name
                                                                        
                                                                        .. attribute:: domain_array
                                                                        
                                                                        	domain array
                                                                        	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                            self.yang_name = "domain"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.domain_array = YList(self)
                                                                            self._segment_path = lambda: "domain"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                        class DomainArray(Entity):
                                                                            """
                                                                            domain array
                                                                            
                                                                            .. attribute:: domain_name
                                                                            
                                                                            	domain name
                                                                            	**type**\: str
                                                                            
                                                                            .. attribute:: format_name
                                                                            
                                                                            	format name
                                                                            	**type**\: str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                self.yang_name = "domain-array"
                                                                                self.yang_parent_name = "domain"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                    ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                ])
                                                                                self.domain_name = None
                                                                                self.format_name = None
                                                                                self._segment_path = lambda: "domain-array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                    class DomainRegex(Entity):
                                                                        """
                                                                        Domain Regular Expression
                                                                        
                                                                        .. attribute:: domain_array
                                                                        
                                                                        	domain array
                                                                        	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                            self.yang_name = "domain-regex"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.domain_array = YList(self)
                                                                            self._segment_path = lambda: "domain-regex"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                        class DomainArray(Entity):
                                                                            """
                                                                            domain array
                                                                            
                                                                            .. attribute:: domain_name
                                                                            
                                                                            	domain name
                                                                            	**type**\: str
                                                                            
                                                                            .. attribute:: format_name
                                                                            
                                                                            	format name
                                                                            	**type**\: str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                self.yang_name = "domain-array"
                                                                                self.yang_parent_name = "domain-regex"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                    ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                ])
                                                                                self.domain_name = None
                                                                                self.format_name = None
                                                                                self._segment_path = lambda: "domain-array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                    class NasPort(Entity):
                                                                        """
                                                                        NAS Port
                                                                        
                                                                        .. attribute:: nas_port_array
                                                                        
                                                                        	nas port array
                                                                        	**type**\: list of  		 :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                            self.yang_name = "nas-port"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("nas-port-array", ("nas_port_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.nas_port_array = YList(self)
                                                                            self._segment_path = lambda: "nas-port"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                        class NasPortArray(Entity):
                                                                            """
                                                                            nas port array
                                                                            
                                                                            .. attribute:: sub_id
                                                                            
                                                                            	sub id
                                                                            	**type**\:  :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                            
                                                                            .. attribute:: operator
                                                                            
                                                                            	operator
                                                                            	**type**\:  :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                self.yang_name = "nas-port-array"
                                                                                self.yang_parent_name = "nas-port"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('sub_id', (YLeaf(YType.enumeration, 'sub-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchNasPortSubIdEn', '')])),
                                                                                    ('operator', (YLeaf(YType.enumeration, 'operator'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchLogicalOperatorEn', '')])),
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                ])
                                                                                self.sub_id = None
                                                                                self.operator = None
                                                                                self.value = None
                                                                                self._segment_path = lambda: "nas-port-array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['sub_id', 'operator', 'value'], name, value)


                                                                    class ServiceName(Entity):
                                                                        """
                                                                        Service Name
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\: list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                            self.yang_name = "service-name"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                            ])
                                                                            self.string_array = []
                                                                            self._segment_path = lambda: "service-name"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                    class ServiceNameRegex(Entity):
                                                                        """
                                                                        Service Name Regular Exp
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\: list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                            self.yang_name = "service-name-regex"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                            ])
                                                                            self.string_array = []
                                                                            self._segment_path = lambda: "service-name-regex"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                    class SrcAddrIpv4(Entity):
                                                                        """
                                                                        Source Address IPV4
                                                                        
                                                                        .. attribute:: ipv4_addr_array
                                                                        
                                                                        	ipv4 addr array
                                                                        	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                            self.yang_name = "src-addr-ipv4"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.ipv4_addr_array = YList(self)
                                                                            self._segment_path = lambda: "src-addr-ipv4"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                        class Ipv4AddrArray(Entity):
                                                                            """
                                                                            ipv4 addr array
                                                                            
                                                                            .. attribute:: prefix
                                                                            
                                                                            	prefix
                                                                            	**type**\: str
                                                                            
                                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                            
                                                                            .. attribute:: mask
                                                                            
                                                                            	mask
                                                                            	**type**\: str
                                                                            
                                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                self.yang_name = "ipv4-addr-array"
                                                                                self.yang_parent_name = "src-addr-ipv4"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                    ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                ])
                                                                                self.prefix = None
                                                                                self.mask = None
                                                                                self._segment_path = lambda: "ipv4-addr-array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                    class DstAddrIpv4(Entity):
                                                                        """
                                                                        Destination Address IPV4
                                                                        
                                                                        .. attribute:: ipv4_addr_array
                                                                        
                                                                        	ipv4 addr array
                                                                        	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                            self.yang_name = "dst-addr-ipv4"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.ipv4_addr_array = YList(self)
                                                                            self._segment_path = lambda: "dst-addr-ipv4"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                        class Ipv4AddrArray(Entity):
                                                                            """
                                                                            ipv4 addr array
                                                                            
                                                                            .. attribute:: prefix
                                                                            
                                                                            	prefix
                                                                            	**type**\: str
                                                                            
                                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                            
                                                                            .. attribute:: mask
                                                                            
                                                                            	mask
                                                                            	**type**\: str
                                                                            
                                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                self.yang_name = "ipv4-addr-array"
                                                                                self.yang_parent_name = "dst-addr-ipv4"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                    ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                ])
                                                                                self.prefix = None
                                                                                self.mask = None
                                                                                self._segment_path = lambda: "ipv4-addr-array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                    class SrcAddrIpv6(Entity):
                                                                        """
                                                                        Source Address IPV6
                                                                        
                                                                        .. attribute:: ipv6_addr_array
                                                                        
                                                                        	ipv6 addr array
                                                                        	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                            self.yang_name = "src-addr-ipv6"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.ipv6_addr_array = YList(self)
                                                                            self._segment_path = lambda: "src-addr-ipv6"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                        class Ipv6AddrArray(Entity):
                                                                            """
                                                                            ipv6 addr array
                                                                            
                                                                            .. attribute:: prefix
                                                                            
                                                                            	IPV6 prefix
                                                                            	**type**\: str
                                                                            
                                                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                            
                                                                            .. attribute:: mask
                                                                            
                                                                            	IPV6 mask
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                self.yang_name = "ipv6-addr-array"
                                                                                self.yang_parent_name = "src-addr-ipv6"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                    ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                ])
                                                                                self.prefix = None
                                                                                self.mask = None
                                                                                self._segment_path = lambda: "ipv6-addr-array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                    class DstAddrIpv6(Entity):
                                                                        """
                                                                        Destination Address IPV6
                                                                        
                                                                        .. attribute:: ipv6_addr_array
                                                                        
                                                                        	ipv6 addr array
                                                                        	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                            self.yang_name = "dst-addr-ipv6"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.ipv6_addr_array = YList(self)
                                                                            self._segment_path = lambda: "dst-addr-ipv6"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                        class Ipv6AddrArray(Entity):
                                                                            """
                                                                            ipv6 addr array
                                                                            
                                                                            .. attribute:: prefix
                                                                            
                                                                            	IPV6 prefix
                                                                            	**type**\: str
                                                                            
                                                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                            
                                                                            .. attribute:: mask
                                                                            
                                                                            	IPV6 mask
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                self.yang_name = "ipv6-addr-array"
                                                                                self.yang_parent_name = "dst-addr-ipv6"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                    ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                ])
                                                                                self.prefix = None
                                                                                self.mask = None
                                                                                self._segment_path = lambda: "ipv6-addr-array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                    class SrcAddrMac(Entity):
                                                                        """
                                                                        Source Address MAC
                                                                        
                                                                        .. attribute:: mac_addr_array
                                                                        
                                                                        	mac addr array
                                                                        	**type**\: list of  		 :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                            self.yang_name = "src-addr-mac"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("mac-addr-array", ("mac_addr_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.mac_addr_array = YList(self)
                                                                            self._segment_path = lambda: "src-addr-mac"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                        class MacAddrArray(Entity):
                                                                            """
                                                                            mac addr array
                                                                            
                                                                            .. attribute:: mac_addr
                                                                            
                                                                            	MAC address
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: mask
                                                                            
                                                                            	MAC mask
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                self.yang_name = "mac-addr-array"
                                                                                self.yang_parent_name = "src-addr-mac"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                    ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                ])
                                                                                self.mac_addr = []
                                                                                self.mask = []
                                                                                self._segment_path = lambda: "mac-addr-array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                    class Timer(Entity):
                                                                        """
                                                                        Timer
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\: list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                            self.yang_name = "timer"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                            ])
                                                                            self.string_array = []
                                                                            self._segment_path = lambda: "timer"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                    class TimerRegexp(Entity):
                                                                        """
                                                                        Timer Regular Expression
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\: list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                            self.yang_name = "timer-regexp"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                            ])
                                                                            self.string_array = []
                                                                            self._segment_path = lambda: "timer-regexp"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                    class TunnelName(Entity):
                                                                        """
                                                                        Tunnel Name
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\: list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                            self.yang_name = "tunnel-name"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                            ])
                                                                            self.string_array = []
                                                                            self._segment_path = lambda: "tunnel-name"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                    class TunnelNameRegex(Entity):
                                                                        """
                                                                        Tunnel Name Regular Expression
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\: list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                            self.yang_name = "tunnel-name-regex"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                            ])
                                                                            self.string_array = []
                                                                            self._segment_path = lambda: "tunnel-name-regex"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                    class UserName(Entity):
                                                                        """
                                                                        User Name
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\: list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                            self.yang_name = "user-name"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                            ])
                                                                            self.string_array = []
                                                                            self._segment_path = lambda: "user-name"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                    class UserNameRegex(Entity):
                                                                        """
                                                                        User Name Regular Expression
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\: list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                            self.yang_name = "user-name-regex"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                            ])
                                                                            self.string_array = []
                                                                            self._segment_path = lambda: "user-name-regex"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                    class AuthUsername(Entity):
                                                                        """
                                                                        Authenticated User Name
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\: list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                            self.yang_name = "auth-username"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                            ])
                                                                            self.string_array = []
                                                                            self._segment_path = lambda: "auth-username"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                    class AuthUsernameRegex(Entity):
                                                                        """
                                                                        Authenticated User Name RegEx
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\: list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                            self.yang_name = "auth-username-regex"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                            ])
                                                                            self.string_array = []
                                                                            self._segment_path = lambda: "auth-username-regex"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                    class UnauthUsername(Entity):
                                                                        """
                                                                        Unauthenticated User Name
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\: list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                            self.yang_name = "unauth-username"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                            ])
                                                                            self.string_array = []
                                                                            self._segment_path = lambda: "unauth-username"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                    class UnauthUsernameRegex(Entity):
                                                                        """
                                                                        Unauthenticated User Name RegEx
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\: list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                            self.yang_name = "unauth-username-regex"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                            ])
                                                                            self.string_array = []
                                                                            self._segment_path = lambda: "unauth-username-regex"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                    class AuthDomain(Entity):
                                                                        """
                                                                        Authenticated domain name
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\: list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                            self.yang_name = "auth-domain"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                            ])
                                                                            self.string_array = []
                                                                            self._segment_path = lambda: "auth-domain"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                    class AuthDomainRegex(Entity):
                                                                        """
                                                                        Authenticated Domain Name RegEx
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\: list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                            self.yang_name = "auth-domain-regex"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                            ])
                                                                            self.string_array = []
                                                                            self._segment_path = lambda: "auth-domain-regex"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                    class UnauthDomain(Entity):
                                                                        """
                                                                        Unauthenticated Domain Name
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\: list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                            self.yang_name = "unauth-domain"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                            ])
                                                                            self.string_array = []
                                                                            self._segment_path = lambda: "unauth-domain"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                    class UnauthDomainRegex(Entity):
                                                                        """
                                                                        Unauthenticated Domain Name RegEx
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\: list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                            self.yang_name = "unauth-domain-regex"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                            ])
                                                                            self.string_array = []
                                                                            self._segment_path = lambda: "unauth-domain-regex"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                    class VendorId(Entity):
                                                                        """
                                                                        Vendor ID
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\: list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                            self.yang_name = "vendor-id"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                            ])
                                                                            self.string_array = []
                                                                            self._segment_path = lambda: "vendor-id"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                    class VendorIdRegex(Entity):
                                                                        """
                                                                        Vendor ID RegEx
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\: list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                            self.yang_name = "vendor-id-regex"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                            ])
                                                                            self.string_array = []
                                                                            self._segment_path = lambda: "vendor-id-regex"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                    class AccessInterface(Entity):
                                                                        """
                                                                        Access interface
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\: list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                            self.yang_name = "access-interface"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                            ])
                                                                            self.string_array = []
                                                                            self._segment_path = lambda: "access-interface"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                    class InputInterface(Entity):
                                                                        """
                                                                        Input interface
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\: list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                            self.yang_name = "input-interface"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                            ])
                                                                            self.string_array = []
                                                                            self._segment_path = lambda: "input-interface"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                    class InputIntfhdl(Entity):
                                                                        """
                                                                        Input interface handle
                                                                        
                                                                        .. attribute:: uint64_array
                                                                        
                                                                        	uint64 array
                                                                        	**type**\: list of int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                            self.yang_name = "input-intfhdl"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('uint64_array', (YLeafList(YType.uint64, 'uint64_array'), ['int'])),
                                                                            ])
                                                                            self.uint64_array = []
                                                                            self._segment_path = lambda: "input-intfhdl"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                    class Ethertype(Entity):
                                                                        """
                                                                        Ethernet type
                                                                        
                                                                        .. attribute:: uint16_rng_array
                                                                        
                                                                        	uint16 rng array
                                                                        	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                            self.yang_name = "ethertype"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.uint16_rng_array = YList(self)
                                                                            self._segment_path = lambda: "ethertype"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                        class Uint16RngArray(Entity):
                                                                            """
                                                                            uint16 rng array
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                self.yang_name = "uint16_rng_array"
                                                                                self.yang_parent_name = "ethertype"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                    ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                ])
                                                                                self.min = None
                                                                                self.max = None
                                                                                self._segment_path = lambda: "uint16_rng_array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['min', 'max'], name, value)


                                                                    class FlowKeyData(Entity):
                                                                        """
                                                                        Flow key structure
                                                                        
                                                                        .. attribute:: flow_keys
                                                                        
                                                                        	flow keys
                                                                        	**type**\:  :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                        
                                                                        .. attribute:: max_count
                                                                        
                                                                        	Maximum count of flows
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..65535
                                                                        
                                                                        .. attribute:: idle_timeout
                                                                        
                                                                        	Idle timeout of flows (in seconds)
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..65535
                                                                        
                                                                        	**units**\: second
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                            self.yang_name = "flow-key-data"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("flow-keys", ("flow_keys", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys))])
                                                                            self._leafs = OrderedDict([
                                                                                ('max_count', (YLeaf(YType.uint16, 'max-count'), ['int'])),
                                                                                ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                            ])
                                                                            self.max_count = None
                                                                            self.idle_timeout = None

                                                                            self.flow_keys = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                            self.flow_keys.parent = self
                                                                            self._children_name_map["flow_keys"] = "flow-keys"
                                                                            self._segment_path = lambda: "flow-key-data"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['max_count', 'idle_timeout'], name, value)


                                                                        class FlowKeys(Entity):
                                                                            """
                                                                            flow keys
                                                                            
                                                                            .. attribute:: keys
                                                                            
                                                                            	keys
                                                                            	**type**\: str
                                                                            
                                                                            	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                            
                                                                            .. attribute:: num
                                                                            
                                                                            	num
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                self.yang_name = "flow-keys"
                                                                                self.yang_parent_name = "flow-key-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('keys', (YLeaf(YType.str, 'keys'), ['str'])),
                                                                                    ('num', (YLeaf(YType.uint8, 'num'), ['int'])),
                                                                                ])
                                                                                self.keys = None
                                                                                self.num = None
                                                                                self._segment_path = lambda: "flow-keys"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                    class DhcpClientId(Entity):
                                                                        """
                                                                        Dhcp Client ID
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\: list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                            self.yang_name = "dhcp-client-id"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                            ])
                                                                            self.string_array = []
                                                                            self._segment_path = lambda: "dhcp-client-id"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                    class DhcpClientIdRegex(Entity):
                                                                        """
                                                                        Dhcp Client ID RegEx
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\: list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                            self.yang_name = "dhcp-client-id-regex"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                            ])
                                                                            self.string_array = []
                                                                            self._segment_path = lambda: "dhcp-client-id-regex"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                    class CircuitId(Entity):
                                                                        """
                                                                        Circuit ID
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\: list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                            self.yang_name = "circuit-id"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                            ])
                                                                            self.string_array = []
                                                                            self._segment_path = lambda: "circuit-id"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                    class CircuitIdRegex(Entity):
                                                                        """
                                                                        Circuit ID RegEx
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\: list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                            self.yang_name = "circuit-id-regex"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                            ])
                                                                            self.string_array = []
                                                                            self._segment_path = lambda: "circuit-id-regex"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                    class RemoteId(Entity):
                                                                        """
                                                                        Remote ID
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\: list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                            self.yang_name = "remote-id"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                            ])
                                                                            self.string_array = []
                                                                            self._segment_path = lambda: "remote-id"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                    class RemoteIdRegex(Entity):
                                                                        """
                                                                        Remote ID RegEx
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\: list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                            self.yang_name = "remote-id-regex"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                            ])
                                                                            self.string_array = []
                                                                            self._segment_path = lambda: "remote-id-regex"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                    class SrcPort(Entity):
                                                                        """
                                                                        Source port
                                                                        
                                                                        .. attribute:: uint16_rng_array
                                                                        
                                                                        	uint16 rng array
                                                                        	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                            self.yang_name = "src-port"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.uint16_rng_array = YList(self)
                                                                            self._segment_path = lambda: "src-port"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                        class Uint16RngArray(Entity):
                                                                            """
                                                                            uint16 rng array
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                self.yang_name = "uint16_rng_array"
                                                                                self.yang_parent_name = "src-port"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                    ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                ])
                                                                                self.min = None
                                                                                self.max = None
                                                                                self._segment_path = lambda: "uint16_rng_array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                    class DstPort(Entity):
                                                                        """
                                                                        Destination port
                                                                        
                                                                        .. attribute:: uint16_rng_array
                                                                        
                                                                        	uint16 rng array
                                                                        	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                            self.yang_name = "dst-port"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.uint16_rng_array = YList(self)
                                                                            self._segment_path = lambda: "dst-port"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                        class Uint16RngArray(Entity):
                                                                            """
                                                                            uint16 rng array
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                self.yang_name = "uint16_rng_array"
                                                                                self.yang_parent_name = "dst-port"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                    ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                ])
                                                                                self.min = None
                                                                                self.max = None
                                                                                self._segment_path = lambda: "uint16_rng_array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['min', 'max'], name, value)


                                                class ClmpP(Entity):
                                                    """
                                                    clmp p
                                                    
                                                    .. attribute:: class_map_bg
                                                    
                                                    	class map bg
                                                    	**type**\: list of  		 :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP, self).__init__()

                                                        self.yang_name = "clmp-p"
                                                        self.yang_parent_name = "policy-class-info-bg"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("class-map-bg", ("class_map_bg", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg))])
                                                        self._leafs = OrderedDict()

                                                        self.class_map_bg = YList(self)
                                                        self._segment_path = lambda: "clmp-p"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP, [], name, value)


                                                    class ClassMapBg(Entity):
                                                        """
                                                        class map bg
                                                        
                                                        .. attribute:: match_infop
                                                        
                                                        	Pointer to the first Match info
                                                        	**type**\:  :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop>`
                                                        
                                                        .. attribute:: name
                                                        
                                                        	Name of the class\-map
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..65
                                                        
                                                        .. attribute:: type
                                                        
                                                        	Class\-Map Type QoS/PBR/Netflow/..
                                                        	**type**\:  :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                        
                                                        .. attribute:: mode
                                                        
                                                        	Class\-Map Mode Match any/Match all
                                                        	**type**\:  :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                        
                                                        .. attribute:: description
                                                        
                                                        	description
                                                        	**type**\: str
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2018-01-17'

                                                        def __init__(self):
                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg, self).__init__()

                                                            self.yang_name = "class-map-bg"
                                                            self.yang_parent_name = "clmp-p"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("match-infop", ("match_infop", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop))])
                                                            self._leafs = OrderedDict([
                                                                ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapTypeEn', '')])),
                                                                ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapModeEn', '')])),
                                                                ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                            ])
                                                            self.name = None
                                                            self.type = None
                                                            self.mode = None
                                                            self.description = None

                                                            self.match_infop = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop()
                                                            self.match_infop.parent = self
                                                            self._children_name_map["match_infop"] = "match-infop"
                                                            self._segment_path = lambda: "class-map-bg"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg, ['name', 'type', 'mode', 'description'], name, value)


                                                        class MatchInfop(Entity):
                                                            """
                                                            Pointer to the first Match info
                                                            
                                                            .. attribute:: class_match_info_st
                                                            
                                                            	class match info st
                                                            	**type**\: list of  		 :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'infra-policymgr-oper'
                                                            _revision = '2018-01-17'

                                                            def __init__(self):
                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop, self).__init__()

                                                                self.yang_name = "match-infop"
                                                                self.yang_parent_name = "class-map-bg"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("class-match-info-st", ("class_match_info_st", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt))])
                                                                self._leafs = OrderedDict()

                                                                self.class_match_info_st = YList(self)
                                                                self._segment_path = lambda: "match-infop"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop, [], name, value)


                                                            class ClassMatchInfoSt(Entity):
                                                                """
                                                                class match info st
                                                                
                                                                .. attribute:: match_data
                                                                
                                                                	Match criteria
                                                                	**type**\:  :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                
                                                                .. attribute:: flags
                                                                
                                                                	Flags
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                    self.yang_name = "class-match-info-st"
                                                                    self.yang_parent_name = "match-infop"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("match-data", ("match_data", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData))])
                                                                    self._leafs = OrderedDict([
                                                                        ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                    ])
                                                                    self.flags = None

                                                                    self.match_data = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                    self.match_data.parent = self
                                                                    self._children_name_map["match_data"] = "match-data"
                                                                    self._segment_path = lambda: "class-match-info-st"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                class MatchData(Entity):
                                                                    """
                                                                    Match criteria
                                                                    
                                                                    .. attribute:: ipv4_dscp
                                                                    
                                                                    	IPv4 DSCP
                                                                    	**type**\:  :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                    
                                                                    .. attribute:: ipv6_dscp
                                                                    
                                                                    	IPv6 DSCP
                                                                    	**type**\:  :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                    
                                                                    .. attribute:: dscp
                                                                    
                                                                    	Match DSCP range array
                                                                    	**type**\:  :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                    
                                                                    .. attribute:: ipv4_prec
                                                                    
                                                                    	IPv4 Precedence
                                                                    	**type**\:  :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                    
                                                                    .. attribute:: ipv6_prec
                                                                    
                                                                    	IPv6 Precedence
                                                                    	**type**\:  :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                    
                                                                    .. attribute:: prec
                                                                    
                                                                    	Match Precedence array
                                                                    	**type**\:  :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                    
                                                                    .. attribute:: discard_class
                                                                    
                                                                    	Match Discard Class array
                                                                    	**type**\:  :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                    
                                                                    .. attribute:: qos_group
                                                                    
                                                                    	Match QoS group array
                                                                    	**type**\:  :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                    
                                                                    .. attribute:: traffic_class
                                                                    
                                                                    	Match Traffic class array
                                                                    	**type**\:  :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                    
                                                                    .. attribute:: proto
                                                                    
                                                                    	Match Protocol array
                                                                    	**type**\:  :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                    
                                                                    .. attribute:: icmp_v4
                                                                    
                                                                    	Match ICMPV4 Protocol
                                                                    	**type**\:  :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                    
                                                                    .. attribute:: icmp_v6
                                                                    
                                                                    	Match ICMPV6 Protocol array
                                                                    	**type**\:  :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                    
                                                                    .. attribute:: ipv4_packet_len
                                                                    
                                                                    	IPv4 packet length array
                                                                    	**type**\:  :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                    
                                                                    .. attribute:: ipv6_packet_len
                                                                    
                                                                    	IPv6 packet length array
                                                                    	**type**\:  :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                    
                                                                    .. attribute:: packet_len
                                                                    
                                                                    	Match packet length array
                                                                    	**type**\:  :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                    
                                                                    .. attribute:: flow_tag
                                                                    
                                                                    	Match flow\-tag array
                                                                    	**type**\:  :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                    
                                                                    .. attribute:: tcp_flag
                                                                    
                                                                    	Match tcp flag value
                                                                    	**type**\:  :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                    
                                                                    .. attribute:: icmpv4_type
                                                                    
                                                                    	Match ipv4 icmp type
                                                                    	**type**\:  :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                    
                                                                    .. attribute:: icmpv4_code
                                                                    
                                                                    	Match ipv4 icmp code
                                                                    	**type**\:  :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                    
                                                                    .. attribute:: icmpv6_type
                                                                    
                                                                    	Match ipv6 icmp type
                                                                    	**type**\:  :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                    
                                                                    .. attribute:: icmpv6_code
                                                                    
                                                                    	Match ipv6 icmp code
                                                                    	**type**\:  :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                    
                                                                    .. attribute:: mpls_exp
                                                                    
                                                                    	Match MPLS experimental topmost array
                                                                    	**type**\:  :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                    
                                                                    .. attribute:: mpls_exp_imp
                                                                    
                                                                    	Match MPLS experimental imposition array
                                                                    	**type**\:  :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                    
                                                                    .. attribute:: mpls_disp_ipv4_acl
                                                                    
                                                                    	MPLS Disposition IPv4 Access\-list
                                                                    	**type**\:  :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                    
                                                                    .. attribute:: mpls_disp_ipv6_acl
                                                                    
                                                                    	MPLS Disposition IPv6 Access\-list
                                                                    	**type**\:  :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                    
                                                                    .. attribute:: mpls_top_label
                                                                    
                                                                    	MPLS Topmost LABEL
                                                                    	**type**\:  :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                    
                                                                    .. attribute:: cos
                                                                    
                                                                    	Match CoS array
                                                                    	**type**\:  :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                    
                                                                    .. attribute:: cos_inr
                                                                    
                                                                    	Match inner header CoS
                                                                    	**type**\:  :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                    
                                                                    .. attribute:: dei
                                                                    
                                                                    	Match DEI Bit
                                                                    	**type**\:  :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                    
                                                                    .. attribute:: dei_inr
                                                                    
                                                                    	Match inner DEI Bit
                                                                    	**type**\:  :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                    
                                                                    .. attribute:: vlan
                                                                    
                                                                    	Match VLAN array
                                                                    	**type**\:  :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                    
                                                                    .. attribute:: vlan_inr
                                                                    
                                                                    	Match inner header VLAN range array
                                                                    	**type**\:  :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                    
                                                                    .. attribute:: fr_dlci
                                                                    
                                                                    	Match FR DLCI range array
                                                                    	**type**\:  :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                    
                                                                    .. attribute:: src_mac
                                                                    
                                                                    	Match Source MAC address
                                                                    	**type**\:  :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                    
                                                                    .. attribute:: dst_mac
                                                                    
                                                                    	Match Destination MAC address
                                                                    	**type**\:  :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                    
                                                                    .. attribute:: atm_clp
                                                                    
                                                                    	Match ATM CLP level
                                                                    	**type**\:  :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                    
                                                                    .. attribute:: fr_de
                                                                    
                                                                    	Match FR DE value
                                                                    	**type**\:  :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                    
                                                                    .. attribute:: ipv4_acl
                                                                    
                                                                    	IPv4 Access\-list
                                                                    	**type**\:  :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                    
                                                                    .. attribute:: ipv6_acl
                                                                    
                                                                    	IPv6 Access\-list
                                                                    	**type**\:  :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                    
                                                                    .. attribute:: ether_service_acl
                                                                    
                                                                    	Ethernet\-Services Access\-list
                                                                    	**type**\:  :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                    
                                                                    .. attribute:: avail_id
                                                                    
                                                                    	Available Identifiers
                                                                    	**type**\:  :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                    
                                                                    .. attribute:: media_type
                                                                    
                                                                    	Media Type
                                                                    	**type**\:  :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                    
                                                                    .. attribute:: subs_protocol
                                                                    
                                                                    	Protocol
                                                                    	**type**\:  :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                    
                                                                    .. attribute:: dnis
                                                                    
                                                                    	DNIS
                                                                    	**type**\:  :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                    
                                                                    .. attribute:: dnis_regex
                                                                    
                                                                    	DNIS Regular Expression
                                                                    	**type**\:  :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                    
                                                                    .. attribute:: domain
                                                                    
                                                                    	Domain Name
                                                                    	**type**\:  :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                    
                                                                    .. attribute:: domain_regex
                                                                    
                                                                    	Domain Regular Expression
                                                                    	**type**\:  :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                    
                                                                    .. attribute:: nas_port
                                                                    
                                                                    	NAS Port
                                                                    	**type**\:  :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                    
                                                                    .. attribute:: service_name
                                                                    
                                                                    	Service Name
                                                                    	**type**\:  :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                    
                                                                    .. attribute:: service_name_regex
                                                                    
                                                                    	Service Name Regular Exp
                                                                    	**type**\:  :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                    
                                                                    .. attribute:: src_addr_ipv4
                                                                    
                                                                    	Source Address IPV4
                                                                    	**type**\:  :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                    
                                                                    .. attribute:: dst_addr_ipv4
                                                                    
                                                                    	Destination Address IPV4
                                                                    	**type**\:  :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                    
                                                                    .. attribute:: src_addr_ipv6
                                                                    
                                                                    	Source Address IPV6
                                                                    	**type**\:  :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                    
                                                                    .. attribute:: dst_addr_ipv6
                                                                    
                                                                    	Destination Address IPV6
                                                                    	**type**\:  :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                    
                                                                    .. attribute:: src_addr_mac
                                                                    
                                                                    	Source Address MAC
                                                                    	**type**\:  :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                    
                                                                    .. attribute:: timer
                                                                    
                                                                    	Timer
                                                                    	**type**\:  :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                    
                                                                    .. attribute:: timer_regexp
                                                                    
                                                                    	Timer Regular Expression
                                                                    	**type**\:  :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                    
                                                                    .. attribute:: tunnel_name
                                                                    
                                                                    	Tunnel Name
                                                                    	**type**\:  :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                    
                                                                    .. attribute:: tunnel_name_regex
                                                                    
                                                                    	Tunnel Name Regular Expression
                                                                    	**type**\:  :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                    
                                                                    .. attribute:: user_name
                                                                    
                                                                    	User Name
                                                                    	**type**\:  :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                    
                                                                    .. attribute:: user_name_regex
                                                                    
                                                                    	User Name Regular Expression
                                                                    	**type**\:  :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                    
                                                                    .. attribute:: auth_username
                                                                    
                                                                    	Authenticated User Name
                                                                    	**type**\:  :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                    
                                                                    .. attribute:: auth_username_regex
                                                                    
                                                                    	Authenticated User Name RegEx
                                                                    	**type**\:  :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                    
                                                                    .. attribute:: unauth_username
                                                                    
                                                                    	Unauthenticated User Name
                                                                    	**type**\:  :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                    
                                                                    .. attribute:: unauth_username_regex
                                                                    
                                                                    	Unauthenticated User Name RegEx
                                                                    	**type**\:  :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                    
                                                                    .. attribute:: auth_domain
                                                                    
                                                                    	Authenticated domain name
                                                                    	**type**\:  :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                    
                                                                    .. attribute:: auth_domain_regex
                                                                    
                                                                    	Authenticated Domain Name RegEx
                                                                    	**type**\:  :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                    
                                                                    .. attribute:: unauth_domain
                                                                    
                                                                    	Unauthenticated Domain Name
                                                                    	**type**\:  :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                    
                                                                    .. attribute:: unauth_domain_regex
                                                                    
                                                                    	Unauthenticated Domain Name RegEx
                                                                    	**type**\:  :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                    
                                                                    .. attribute:: vendor_id
                                                                    
                                                                    	Vendor ID
                                                                    	**type**\:  :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                    
                                                                    .. attribute:: vendor_id_regex
                                                                    
                                                                    	Vendor ID RegEx
                                                                    	**type**\:  :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                    
                                                                    .. attribute:: access_interface
                                                                    
                                                                    	Access interface
                                                                    	**type**\:  :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                    
                                                                    .. attribute:: input_interface
                                                                    
                                                                    	Input interface
                                                                    	**type**\:  :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                    
                                                                    .. attribute:: input_intfhdl
                                                                    
                                                                    	Input interface handle
                                                                    	**type**\:  :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                    
                                                                    .. attribute:: ethertype
                                                                    
                                                                    	Ethernet type
                                                                    	**type**\:  :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                    
                                                                    .. attribute:: flow_key_data
                                                                    
                                                                    	Flow key structure
                                                                    	**type**\:  :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                    
                                                                    .. attribute:: dhcp_client_id
                                                                    
                                                                    	Dhcp Client ID
                                                                    	**type**\:  :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                    
                                                                    .. attribute:: dhcp_client_id_regex
                                                                    
                                                                    	Dhcp Client ID RegEx
                                                                    	**type**\:  :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                    
                                                                    .. attribute:: circuit_id
                                                                    
                                                                    	Circuit ID
                                                                    	**type**\:  :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                    
                                                                    .. attribute:: circuit_id_regex
                                                                    
                                                                    	Circuit ID RegEx
                                                                    	**type**\:  :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                    
                                                                    .. attribute:: remote_id
                                                                    
                                                                    	Remote ID
                                                                    	**type**\:  :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                    
                                                                    .. attribute:: remote_id_regex
                                                                    
                                                                    	Remote ID RegEx
                                                                    	**type**\:  :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                    
                                                                    .. attribute:: src_port
                                                                    
                                                                    	Source port
                                                                    	**type**\:  :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                    
                                                                    .. attribute:: dst_port
                                                                    
                                                                    	Destination port
                                                                    	**type**\:  :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                    
                                                                    .. attribute:: type
                                                                    
                                                                    	type
                                                                    	**type**\:  :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                    
                                                                    .. attribute:: mpls_top_eos
                                                                    
                                                                    	MPLS Topmost EOS
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    .. attribute:: fragment_type
                                                                    
                                                                    	Fragment type
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    .. attribute:: authen_status
                                                                    
                                                                    	Authentication Status
                                                                    	**type**\:  :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                    
                                                                    .. attribute:: mlp_negotiated
                                                                    
                                                                    	MLP Negotiated
                                                                    	**type**\:  :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                        self.yang_name = "match-data"
                                                                        self.yang_parent_name = "class-match-info-st"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("ipv4-dscp", ("ipv4_dscp", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp)), ("ipv6-dscp", ("ipv6_dscp", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp)), ("dscp", ("dscp", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp)), ("ipv4-prec", ("ipv4_prec", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec)), ("ipv6-prec", ("ipv6_prec", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec)), ("prec", ("prec", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec)), ("discard-class", ("discard_class", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass)), ("qos-group", ("qos_group", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup)), ("traffic-class", ("traffic_class", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass)), ("proto", ("proto", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto)), ("icmp-v4", ("icmp_v4", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4)), ("icmp-v6", ("icmp_v6", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6)), ("ipv4-packet-len", ("ipv4_packet_len", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen)), ("ipv6-packet-len", ("ipv6_packet_len", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen)), ("packet-len", ("packet_len", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen)), ("flow-tag", ("flow_tag", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag)), ("tcp-flag", ("tcp_flag", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag)), ("icmpv4-type", ("icmpv4_type", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type)), ("icmpv4-code", ("icmpv4_code", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code)), ("icmpv6-type", ("icmpv6_type", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type)), ("icmpv6-code", ("icmpv6_code", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code)), ("mpls-exp", ("mpls_exp", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp)), ("mpls-exp-imp", ("mpls_exp_imp", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp)), ("mpls-disp-ipv4-acl", ("mpls_disp_ipv4_acl", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl)), ("mpls-disp-ipv6-acl", ("mpls_disp_ipv6_acl", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl)), ("mpls-top-label", ("mpls_top_label", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel)), ("cos", ("cos", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos)), ("cos-inr", ("cos_inr", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr)), ("dei", ("dei", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei)), ("dei-inr", ("dei_inr", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr)), ("vlan", ("vlan", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan)), ("vlan-inr", ("vlan_inr", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)), ("fr-dlci", ("fr_dlci", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci)), ("src-mac", ("src_mac", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac)), ("dst-mac", ("dst_mac", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac)), ("atm-clp", ("atm_clp", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp)), ("fr-de", ("fr_de", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe)), ("ipv4-acl", ("ipv4_acl", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl)), ("ipv6-acl", ("ipv6_acl", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl)), ("ether-service-acl", ("ether_service_acl", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl)), ("avail-id", ("avail_id", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId)), ("media-type", ("media_type", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType)), ("subs-protocol", ("subs_protocol", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol)), ("dnis", ("dnis", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis)), ("dnis-regex", ("dnis_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex)), ("domain", ("domain", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain)), ("domain-regex", ("domain_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex)), ("nas-port", ("nas_port", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort)), ("service-name", ("service_name", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName)), ("service-name-regex", ("service_name_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex)), ("src-addr-ipv4", ("src_addr_ipv4", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4)), ("dst-addr-ipv4", ("dst_addr_ipv4", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4)), ("src-addr-ipv6", ("src_addr_ipv6", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6)), ("dst-addr-ipv6", ("dst_addr_ipv6", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6)), ("src-addr-mac", ("src_addr_mac", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac)), ("timer", ("timer", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer)), ("timer-regexp", ("timer_regexp", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp)), ("tunnel-name", ("tunnel_name", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName)), ("tunnel-name-regex", ("tunnel_name_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex)), ("user-name", ("user_name", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName)), ("user-name-regex", ("user_name_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex)), ("auth-username", ("auth_username", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername)), ("auth-username-regex", ("auth_username_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex)), ("unauth-username", ("unauth_username", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername)), ("unauth-username-regex", ("unauth_username_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex)), ("auth-domain", ("auth_domain", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain)), ("auth-domain-regex", ("auth_domain_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex)), ("unauth-domain", ("unauth_domain", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain)), ("unauth-domain-regex", ("unauth_domain_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex)), ("vendor-id", ("vendor_id", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId)), ("vendor-id-regex", ("vendor_id_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex)), ("access-interface", ("access_interface", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface)), ("input-interface", ("input_interface", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface)), ("input-intfhdl", ("input_intfhdl", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl)), ("ethertype", ("ethertype", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype)), ("flow-key-data", ("flow_key_data", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData)), ("dhcp-client-id", ("dhcp_client_id", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId)), ("dhcp-client-id-regex", ("dhcp_client_id_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex)), ("circuit-id", ("circuit_id", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId)), ("circuit-id-regex", ("circuit_id_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex)), ("remote-id", ("remote_id", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId)), ("remote-id-regex", ("remote_id_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex)), ("src-port", ("src_port", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort)), ("dst-port", ("dst_port", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort))])
                                                                        self._leafs = OrderedDict([
                                                                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchTypeEn', '')])),
                                                                            ('mpls_top_eos', (YLeaf(YType.uint8, 'mpls-top-eos'), ['int'])),
                                                                            ('fragment_type', (YLeaf(YType.uint8, 'fragment-type'), ['int'])),
                                                                            ('authen_status', (YLeaf(YType.enumeration, 'authen-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchAuthenStatusEn', '')])),
                                                                            ('mlp_negotiated', (YLeaf(YType.enumeration, 'mlp-negotiated'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchMlpNegotiatedEn', '')])),
                                                                        ])
                                                                        self.type = None
                                                                        self.mpls_top_eos = None
                                                                        self.fragment_type = None
                                                                        self.authen_status = None
                                                                        self.mlp_negotiated = None

                                                                        self.ipv4_dscp = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                        self.ipv4_dscp.parent = self
                                                                        self._children_name_map["ipv4_dscp"] = "ipv4-dscp"

                                                                        self.ipv6_dscp = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                        self.ipv6_dscp.parent = self
                                                                        self._children_name_map["ipv6_dscp"] = "ipv6-dscp"

                                                                        self.dscp = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                        self.dscp.parent = self
                                                                        self._children_name_map["dscp"] = "dscp"

                                                                        self.ipv4_prec = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                        self.ipv4_prec.parent = self
                                                                        self._children_name_map["ipv4_prec"] = "ipv4-prec"

                                                                        self.ipv6_prec = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                        self.ipv6_prec.parent = self
                                                                        self._children_name_map["ipv6_prec"] = "ipv6-prec"

                                                                        self.prec = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                        self.prec.parent = self
                                                                        self._children_name_map["prec"] = "prec"

                                                                        self.discard_class = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                        self.discard_class.parent = self
                                                                        self._children_name_map["discard_class"] = "discard-class"

                                                                        self.qos_group = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                        self.qos_group.parent = self
                                                                        self._children_name_map["qos_group"] = "qos-group"

                                                                        self.traffic_class = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                        self.traffic_class.parent = self
                                                                        self._children_name_map["traffic_class"] = "traffic-class"

                                                                        self.proto = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                        self.proto.parent = self
                                                                        self._children_name_map["proto"] = "proto"

                                                                        self.icmp_v4 = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                        self.icmp_v4.parent = self
                                                                        self._children_name_map["icmp_v4"] = "icmp-v4"

                                                                        self.icmp_v6 = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                        self.icmp_v6.parent = self
                                                                        self._children_name_map["icmp_v6"] = "icmp-v6"

                                                                        self.ipv4_packet_len = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                        self.ipv4_packet_len.parent = self
                                                                        self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"

                                                                        self.ipv6_packet_len = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                        self.ipv6_packet_len.parent = self
                                                                        self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"

                                                                        self.packet_len = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                        self.packet_len.parent = self
                                                                        self._children_name_map["packet_len"] = "packet-len"

                                                                        self.flow_tag = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                        self.flow_tag.parent = self
                                                                        self._children_name_map["flow_tag"] = "flow-tag"

                                                                        self.tcp_flag = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                        self.tcp_flag.parent = self
                                                                        self._children_name_map["tcp_flag"] = "tcp-flag"

                                                                        self.icmpv4_type = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                        self.icmpv4_type.parent = self
                                                                        self._children_name_map["icmpv4_type"] = "icmpv4-type"

                                                                        self.icmpv4_code = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                        self.icmpv4_code.parent = self
                                                                        self._children_name_map["icmpv4_code"] = "icmpv4-code"

                                                                        self.icmpv6_type = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                        self.icmpv6_type.parent = self
                                                                        self._children_name_map["icmpv6_type"] = "icmpv6-type"

                                                                        self.icmpv6_code = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                        self.icmpv6_code.parent = self
                                                                        self._children_name_map["icmpv6_code"] = "icmpv6-code"

                                                                        self.mpls_exp = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                        self.mpls_exp.parent = self
                                                                        self._children_name_map["mpls_exp"] = "mpls-exp"

                                                                        self.mpls_exp_imp = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                        self.mpls_exp_imp.parent = self
                                                                        self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"

                                                                        self.mpls_disp_ipv4_acl = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                        self.mpls_disp_ipv4_acl.parent = self
                                                                        self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"

                                                                        self.mpls_disp_ipv6_acl = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                        self.mpls_disp_ipv6_acl.parent = self
                                                                        self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"

                                                                        self.mpls_top_label = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                        self.mpls_top_label.parent = self
                                                                        self._children_name_map["mpls_top_label"] = "mpls-top-label"

                                                                        self.cos = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                        self.cos.parent = self
                                                                        self._children_name_map["cos"] = "cos"

                                                                        self.cos_inr = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                        self.cos_inr.parent = self
                                                                        self._children_name_map["cos_inr"] = "cos-inr"

                                                                        self.dei = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                        self.dei.parent = self
                                                                        self._children_name_map["dei"] = "dei"

                                                                        self.dei_inr = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                        self.dei_inr.parent = self
                                                                        self._children_name_map["dei_inr"] = "dei-inr"

                                                                        self.vlan = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                        self.vlan.parent = self
                                                                        self._children_name_map["vlan"] = "vlan"

                                                                        self.vlan_inr = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                        self.vlan_inr.parent = self
                                                                        self._children_name_map["vlan_inr"] = "vlan-inr"

                                                                        self.fr_dlci = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                        self.fr_dlci.parent = self
                                                                        self._children_name_map["fr_dlci"] = "fr-dlci"

                                                                        self.src_mac = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                        self.src_mac.parent = self
                                                                        self._children_name_map["src_mac"] = "src-mac"

                                                                        self.dst_mac = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                        self.dst_mac.parent = self
                                                                        self._children_name_map["dst_mac"] = "dst-mac"

                                                                        self.atm_clp = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                        self.atm_clp.parent = self
                                                                        self._children_name_map["atm_clp"] = "atm-clp"

                                                                        self.fr_de = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                        self.fr_de.parent = self
                                                                        self._children_name_map["fr_de"] = "fr-de"

                                                                        self.ipv4_acl = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                        self.ipv4_acl.parent = self
                                                                        self._children_name_map["ipv4_acl"] = "ipv4-acl"

                                                                        self.ipv6_acl = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                        self.ipv6_acl.parent = self
                                                                        self._children_name_map["ipv6_acl"] = "ipv6-acl"

                                                                        self.ether_service_acl = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                        self.ether_service_acl.parent = self
                                                                        self._children_name_map["ether_service_acl"] = "ether-service-acl"

                                                                        self.avail_id = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                        self.avail_id.parent = self
                                                                        self._children_name_map["avail_id"] = "avail-id"

                                                                        self.media_type = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                        self.media_type.parent = self
                                                                        self._children_name_map["media_type"] = "media-type"

                                                                        self.subs_protocol = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                        self.subs_protocol.parent = self
                                                                        self._children_name_map["subs_protocol"] = "subs-protocol"

                                                                        self.dnis = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                        self.dnis.parent = self
                                                                        self._children_name_map["dnis"] = "dnis"

                                                                        self.dnis_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                        self.dnis_regex.parent = self
                                                                        self._children_name_map["dnis_regex"] = "dnis-regex"

                                                                        self.domain = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                        self.domain.parent = self
                                                                        self._children_name_map["domain"] = "domain"

                                                                        self.domain_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                        self.domain_regex.parent = self
                                                                        self._children_name_map["domain_regex"] = "domain-regex"

                                                                        self.nas_port = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                        self.nas_port.parent = self
                                                                        self._children_name_map["nas_port"] = "nas-port"

                                                                        self.service_name = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                        self.service_name.parent = self
                                                                        self._children_name_map["service_name"] = "service-name"

                                                                        self.service_name_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                        self.service_name_regex.parent = self
                                                                        self._children_name_map["service_name_regex"] = "service-name-regex"

                                                                        self.src_addr_ipv4 = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                        self.src_addr_ipv4.parent = self
                                                                        self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"

                                                                        self.dst_addr_ipv4 = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                        self.dst_addr_ipv4.parent = self
                                                                        self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"

                                                                        self.src_addr_ipv6 = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                        self.src_addr_ipv6.parent = self
                                                                        self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"

                                                                        self.dst_addr_ipv6 = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                        self.dst_addr_ipv6.parent = self
                                                                        self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"

                                                                        self.src_addr_mac = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                        self.src_addr_mac.parent = self
                                                                        self._children_name_map["src_addr_mac"] = "src-addr-mac"

                                                                        self.timer = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                        self.timer.parent = self
                                                                        self._children_name_map["timer"] = "timer"

                                                                        self.timer_regexp = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                        self.timer_regexp.parent = self
                                                                        self._children_name_map["timer_regexp"] = "timer-regexp"

                                                                        self.tunnel_name = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                        self.tunnel_name.parent = self
                                                                        self._children_name_map["tunnel_name"] = "tunnel-name"

                                                                        self.tunnel_name_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                        self.tunnel_name_regex.parent = self
                                                                        self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"

                                                                        self.user_name = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                        self.user_name.parent = self
                                                                        self._children_name_map["user_name"] = "user-name"

                                                                        self.user_name_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                        self.user_name_regex.parent = self
                                                                        self._children_name_map["user_name_regex"] = "user-name-regex"

                                                                        self.auth_username = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                        self.auth_username.parent = self
                                                                        self._children_name_map["auth_username"] = "auth-username"

                                                                        self.auth_username_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                        self.auth_username_regex.parent = self
                                                                        self._children_name_map["auth_username_regex"] = "auth-username-regex"

                                                                        self.unauth_username = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                        self.unauth_username.parent = self
                                                                        self._children_name_map["unauth_username"] = "unauth-username"

                                                                        self.unauth_username_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                        self.unauth_username_regex.parent = self
                                                                        self._children_name_map["unauth_username_regex"] = "unauth-username-regex"

                                                                        self.auth_domain = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                        self.auth_domain.parent = self
                                                                        self._children_name_map["auth_domain"] = "auth-domain"

                                                                        self.auth_domain_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                        self.auth_domain_regex.parent = self
                                                                        self._children_name_map["auth_domain_regex"] = "auth-domain-regex"

                                                                        self.unauth_domain = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                        self.unauth_domain.parent = self
                                                                        self._children_name_map["unauth_domain"] = "unauth-domain"

                                                                        self.unauth_domain_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                        self.unauth_domain_regex.parent = self
                                                                        self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"

                                                                        self.vendor_id = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                        self.vendor_id.parent = self
                                                                        self._children_name_map["vendor_id"] = "vendor-id"

                                                                        self.vendor_id_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                        self.vendor_id_regex.parent = self
                                                                        self._children_name_map["vendor_id_regex"] = "vendor-id-regex"

                                                                        self.access_interface = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                        self.access_interface.parent = self
                                                                        self._children_name_map["access_interface"] = "access-interface"

                                                                        self.input_interface = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                        self.input_interface.parent = self
                                                                        self._children_name_map["input_interface"] = "input-interface"

                                                                        self.input_intfhdl = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                        self.input_intfhdl.parent = self
                                                                        self._children_name_map["input_intfhdl"] = "input-intfhdl"

                                                                        self.ethertype = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                        self.ethertype.parent = self
                                                                        self._children_name_map["ethertype"] = "ethertype"

                                                                        self.flow_key_data = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                        self.flow_key_data.parent = self
                                                                        self._children_name_map["flow_key_data"] = "flow-key-data"

                                                                        self.dhcp_client_id = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                        self.dhcp_client_id.parent = self
                                                                        self._children_name_map["dhcp_client_id"] = "dhcp-client-id"

                                                                        self.dhcp_client_id_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                        self.dhcp_client_id_regex.parent = self
                                                                        self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"

                                                                        self.circuit_id = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                        self.circuit_id.parent = self
                                                                        self._children_name_map["circuit_id"] = "circuit-id"

                                                                        self.circuit_id_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                        self.circuit_id_regex.parent = self
                                                                        self._children_name_map["circuit_id_regex"] = "circuit-id-regex"

                                                                        self.remote_id = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                        self.remote_id.parent = self
                                                                        self._children_name_map["remote_id"] = "remote-id"

                                                                        self.remote_id_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                        self.remote_id_regex.parent = self
                                                                        self._children_name_map["remote_id_regex"] = "remote-id-regex"

                                                                        self.src_port = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                        self.src_port.parent = self
                                                                        self._children_name_map["src_port"] = "src-port"

                                                                        self.dst_port = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                        self.dst_port.parent = self
                                                                        self._children_name_map["dst_port"] = "dst-port"
                                                                        self._segment_path = lambda: "match-data"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['type', 'mpls_top_eos', 'fragment_type', 'authen_status', 'mlp_negotiated'], name, value)


                                                                    class Ipv4Dscp(Entity):
                                                                        """
                                                                        IPv4 DSCP
                                                                        
                                                                        .. attribute:: uint8_rng_array
                                                                        
                                                                        	uint8 rng array
                                                                        	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                            self.yang_name = "ipv4-dscp"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.uint8_rng_array = YList(self)
                                                                            self._segment_path = lambda: "ipv4-dscp"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                        class Uint8RngArray(Entity):
                                                                            """
                                                                            uint8 rng array
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                self.yang_name = "uint8_rng_array"
                                                                                self.yang_parent_name = "ipv4-dscp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                    ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                ])
                                                                                self.min = None
                                                                                self.max = None
                                                                                self._segment_path = lambda: "uint8_rng_array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                    class Ipv6Dscp(Entity):
                                                                        """
                                                                        IPv6 DSCP
                                                                        
                                                                        .. attribute:: uint8_rng_array
                                                                        
                                                                        	uint8 rng array
                                                                        	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                            self.yang_name = "ipv6-dscp"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.uint8_rng_array = YList(self)
                                                                            self._segment_path = lambda: "ipv6-dscp"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                        class Uint8RngArray(Entity):
                                                                            """
                                                                            uint8 rng array
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                self.yang_name = "uint8_rng_array"
                                                                                self.yang_parent_name = "ipv6-dscp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                    ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                ])
                                                                                self.min = None
                                                                                self.max = None
                                                                                self._segment_path = lambda: "uint8_rng_array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                    class Dscp(Entity):
                                                                        """
                                                                        Match DSCP range array
                                                                        
                                                                        .. attribute:: uint8_rng_array
                                                                        
                                                                        	uint8 rng array
                                                                        	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                            self.yang_name = "dscp"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.uint8_rng_array = YList(self)
                                                                            self._segment_path = lambda: "dscp"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                        class Uint8RngArray(Entity):
                                                                            """
                                                                            uint8 rng array
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                self.yang_name = "uint8_rng_array"
                                                                                self.yang_parent_name = "dscp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                    ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                ])
                                                                                self.min = None
                                                                                self.max = None
                                                                                self._segment_path = lambda: "uint8_rng_array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                    class Ipv4Prec(Entity):
                                                                        """
                                                                        IPv4 Precedence
                                                                        
                                                                        .. attribute:: uint8_array
                                                                        
                                                                        	uint8 array
                                                                        	**type**\: list of int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                            self.yang_name = "ipv4-prec"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                            ])
                                                                            self.uint8_array = []
                                                                            self._segment_path = lambda: "ipv4-prec"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                    class Ipv6Prec(Entity):
                                                                        """
                                                                        IPv6 Precedence
                                                                        
                                                                        .. attribute:: uint8_array
                                                                        
                                                                        	uint8 array
                                                                        	**type**\: list of int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                            self.yang_name = "ipv6-prec"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                            ])
                                                                            self.uint8_array = []
                                                                            self._segment_path = lambda: "ipv6-prec"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                    class Prec(Entity):
                                                                        """
                                                                        Match Precedence array
                                                                        
                                                                        .. attribute:: uint8_array
                                                                        
                                                                        	uint8 array
                                                                        	**type**\: list of int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                            self.yang_name = "prec"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                            ])
                                                                            self.uint8_array = []
                                                                            self._segment_path = lambda: "prec"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                    class DiscardClass(Entity):
                                                                        """
                                                                        Match Discard Class array
                                                                        
                                                                        .. attribute:: uint8_array
                                                                        
                                                                        	uint8 array
                                                                        	**type**\: list of int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                            self.yang_name = "discard-class"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                            ])
                                                                            self.uint8_array = []
                                                                            self._segment_path = lambda: "discard-class"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                    class QosGroup(Entity):
                                                                        """
                                                                        Match QoS group array
                                                                        
                                                                        .. attribute:: uint16_rng_array
                                                                        
                                                                        	uint16 rng array
                                                                        	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                            self.yang_name = "qos-group"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.uint16_rng_array = YList(self)
                                                                            self._segment_path = lambda: "qos-group"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                        class Uint16RngArray(Entity):
                                                                            """
                                                                            uint16 rng array
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                self.yang_name = "uint16_rng_array"
                                                                                self.yang_parent_name = "qos-group"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                    ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                ])
                                                                                self.min = None
                                                                                self.max = None
                                                                                self._segment_path = lambda: "uint16_rng_array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['min', 'max'], name, value)


                                                                    class TrafficClass(Entity):
                                                                        """
                                                                        Match Traffic class array
                                                                        
                                                                        .. attribute:: uint8_rng_array
                                                                        
                                                                        	uint8 rng array
                                                                        	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                            self.yang_name = "traffic-class"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.uint8_rng_array = YList(self)
                                                                            self._segment_path = lambda: "traffic-class"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                        class Uint8RngArray(Entity):
                                                                            """
                                                                            uint8 rng array
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                self.yang_name = "uint8_rng_array"
                                                                                self.yang_parent_name = "traffic-class"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                    ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                ])
                                                                                self.min = None
                                                                                self.max = None
                                                                                self._segment_path = lambda: "uint8_rng_array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['min', 'max'], name, value)


                                                                    class Proto(Entity):
                                                                        """
                                                                        Match Protocol array
                                                                        
                                                                        .. attribute:: uint16_rng_array
                                                                        
                                                                        	uint16 rng array
                                                                        	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                            self.yang_name = "proto"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.uint16_rng_array = YList(self)
                                                                            self._segment_path = lambda: "proto"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                        class Uint16RngArray(Entity):
                                                                            """
                                                                            uint16 rng array
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                self.yang_name = "uint16_rng_array"
                                                                                self.yang_parent_name = "proto"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                    ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                ])
                                                                                self.min = None
                                                                                self.max = None
                                                                                self._segment_path = lambda: "uint16_rng_array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['min', 'max'], name, value)


                                                                    class IcmpV4(Entity):
                                                                        """
                                                                        Match ICMPV4 Protocol
                                                                        
                                                                        .. attribute:: type
                                                                        
                                                                        	Protocol type
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: code
                                                                        
                                                                        	Protocol code
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                            self.yang_name = "icmp-v4"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                            ])
                                                                            self.type = None
                                                                            self.code = None
                                                                            self._segment_path = lambda: "icmp-v4"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['type', 'code'], name, value)


                                                                    class IcmpV6(Entity):
                                                                        """
                                                                        Match ICMPV6 Protocol array
                                                                        
                                                                        .. attribute:: type
                                                                        
                                                                        	Protocol type
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: code
                                                                        
                                                                        	Protocol code
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                            self.yang_name = "icmp-v6"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                            ])
                                                                            self.type = None
                                                                            self.code = None
                                                                            self._segment_path = lambda: "icmp-v6"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['type', 'code'], name, value)


                                                                    class Ipv4PacketLen(Entity):
                                                                        """
                                                                        IPv4 packet length array
                                                                        
                                                                        .. attribute:: uint16_rng_array
                                                                        
                                                                        	uint16 rng array
                                                                        	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                            self.yang_name = "ipv4-packet-len"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.uint16_rng_array = YList(self)
                                                                            self._segment_path = lambda: "ipv4-packet-len"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                        class Uint16RngArray(Entity):
                                                                            """
                                                                            uint16 rng array
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                self.yang_name = "uint16_rng_array"
                                                                                self.yang_parent_name = "ipv4-packet-len"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                    ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                ])
                                                                                self.min = None
                                                                                self.max = None
                                                                                self._segment_path = lambda: "uint16_rng_array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                    class Ipv6PacketLen(Entity):
                                                                        """
                                                                        IPv6 packet length array
                                                                        
                                                                        .. attribute:: uint16_rng_array
                                                                        
                                                                        	uint16 rng array
                                                                        	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                            self.yang_name = "ipv6-packet-len"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.uint16_rng_array = YList(self)
                                                                            self._segment_path = lambda: "ipv6-packet-len"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                        class Uint16RngArray(Entity):
                                                                            """
                                                                            uint16 rng array
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                self.yang_name = "uint16_rng_array"
                                                                                self.yang_parent_name = "ipv6-packet-len"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                    ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                ])
                                                                                self.min = None
                                                                                self.max = None
                                                                                self._segment_path = lambda: "uint16_rng_array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                    class PacketLen(Entity):
                                                                        """
                                                                        Match packet length array
                                                                        
                                                                        .. attribute:: uint16_rng_array
                                                                        
                                                                        	uint16 rng array
                                                                        	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                            self.yang_name = "packet-len"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.uint16_rng_array = YList(self)
                                                                            self._segment_path = lambda: "packet-len"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                        class Uint16RngArray(Entity):
                                                                            """
                                                                            uint16 rng array
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                self.yang_name = "uint16_rng_array"
                                                                                self.yang_parent_name = "packet-len"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                    ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                ])
                                                                                self.min = None
                                                                                self.max = None
                                                                                self._segment_path = lambda: "uint16_rng_array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                    class FlowTag(Entity):
                                                                        """
                                                                        Match flow\-tag array
                                                                        
                                                                        .. attribute:: uint8_rng_array
                                                                        
                                                                        	uint8 rng array
                                                                        	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                            self.yang_name = "flow-tag"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.uint8_rng_array = YList(self)
                                                                            self._segment_path = lambda: "flow-tag"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                        class Uint8RngArray(Entity):
                                                                            """
                                                                            uint8 rng array
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                self.yang_name = "uint8_rng_array"
                                                                                self.yang_parent_name = "flow-tag"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                    ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                ])
                                                                                self.min = None
                                                                                self.max = None
                                                                                self._segment_path = lambda: "uint8_rng_array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['min', 'max'], name, value)


                                                                    class TcpFlag(Entity):
                                                                        """
                                                                        Match tcp flag value
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	Value of TCP flag
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..65535
                                                                        
                                                                        .. attribute:: match_any
                                                                        
                                                                        	Match any TCP flag bit
                                                                        	**type**\: bool
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                            self.yang_name = "tcp-flag"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                ('match_any', (YLeaf(YType.boolean, 'match-any'), ['bool'])),
                                                                            ])
                                                                            self.value = None
                                                                            self.match_any = None
                                                                            self._segment_path = lambda: "tcp-flag"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['value', 'match_any'], name, value)


                                                                    class Icmpv4Type(Entity):
                                                                        """
                                                                        Match ipv4 icmp type
                                                                        
                                                                        .. attribute:: uint8_rng_array
                                                                        
                                                                        	uint8 rng array
                                                                        	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                            self.yang_name = "icmpv4-type"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.uint8_rng_array = YList(self)
                                                                            self._segment_path = lambda: "icmpv4-type"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                        class Uint8RngArray(Entity):
                                                                            """
                                                                            uint8 rng array
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                self.yang_name = "uint8_rng_array"
                                                                                self.yang_parent_name = "icmpv4-type"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                    ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                ])
                                                                                self.min = None
                                                                                self.max = None
                                                                                self._segment_path = lambda: "uint8_rng_array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                    class Icmpv4Code(Entity):
                                                                        """
                                                                        Match ipv4 icmp code
                                                                        
                                                                        .. attribute:: uint8_rng_array
                                                                        
                                                                        	uint8 rng array
                                                                        	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                            self.yang_name = "icmpv4-code"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.uint8_rng_array = YList(self)
                                                                            self._segment_path = lambda: "icmpv4-code"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                        class Uint8RngArray(Entity):
                                                                            """
                                                                            uint8 rng array
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                self.yang_name = "uint8_rng_array"
                                                                                self.yang_parent_name = "icmpv4-code"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                    ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                ])
                                                                                self.min = None
                                                                                self.max = None
                                                                                self._segment_path = lambda: "uint8_rng_array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                    class Icmpv6Type(Entity):
                                                                        """
                                                                        Match ipv6 icmp type
                                                                        
                                                                        .. attribute:: uint8_rng_array
                                                                        
                                                                        	uint8 rng array
                                                                        	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                            self.yang_name = "icmpv6-type"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.uint8_rng_array = YList(self)
                                                                            self._segment_path = lambda: "icmpv6-type"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                        class Uint8RngArray(Entity):
                                                                            """
                                                                            uint8 rng array
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                self.yang_name = "uint8_rng_array"
                                                                                self.yang_parent_name = "icmpv6-type"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                    ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                ])
                                                                                self.min = None
                                                                                self.max = None
                                                                                self._segment_path = lambda: "uint8_rng_array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                    class Icmpv6Code(Entity):
                                                                        """
                                                                        Match ipv6 icmp code
                                                                        
                                                                        .. attribute:: uint8_rng_array
                                                                        
                                                                        	uint8 rng array
                                                                        	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                            self.yang_name = "icmpv6-code"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.uint8_rng_array = YList(self)
                                                                            self._segment_path = lambda: "icmpv6-code"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                        class Uint8RngArray(Entity):
                                                                            """
                                                                            uint8 rng array
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                self.yang_name = "uint8_rng_array"
                                                                                self.yang_parent_name = "icmpv6-code"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                    ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                ])
                                                                                self.min = None
                                                                                self.max = None
                                                                                self._segment_path = lambda: "uint8_rng_array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                    class MplsExp(Entity):
                                                                        """
                                                                        Match MPLS experimental topmost array
                                                                        
                                                                        .. attribute:: uint8_array
                                                                        
                                                                        	uint8 array
                                                                        	**type**\: list of int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                            self.yang_name = "mpls-exp"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                            ])
                                                                            self.uint8_array = []
                                                                            self._segment_path = lambda: "mpls-exp"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                    class MplsExpImp(Entity):
                                                                        """
                                                                        Match MPLS experimental imposition array
                                                                        
                                                                        .. attribute:: uint8_array
                                                                        
                                                                        	uint8 array
                                                                        	**type**\: list of int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                            self.yang_name = "mpls-exp-imp"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                            ])
                                                                            self.uint8_array = []
                                                                            self._segment_path = lambda: "mpls-exp-imp"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                    class MplsDispIpv4Acl(Entity):
                                                                        """
                                                                        MPLS Disposition IPv4 Access\-list
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\: list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                            self.yang_name = "mpls-disp-ipv4-acl"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                            ])
                                                                            self.string_array = []
                                                                            self._segment_path = lambda: "mpls-disp-ipv4-acl"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                    class MplsDispIpv6Acl(Entity):
                                                                        """
                                                                        MPLS Disposition IPv6 Access\-list
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\: list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                            self.yang_name = "mpls-disp-ipv6-acl"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                            ])
                                                                            self.string_array = []
                                                                            self._segment_path = lambda: "mpls-disp-ipv6-acl"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                    class MplsTopLabel(Entity):
                                                                        """
                                                                        MPLS Topmost LABEL
                                                                        
                                                                        .. attribute:: uint32_rng_array
                                                                        
                                                                        	uint32 rng array
                                                                        	**type**\: list of  		 :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                            self.yang_name = "mpls-top-label"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("uint32_rng_array", ("uint32_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.uint32_rng_array = YList(self)
                                                                            self._segment_path = lambda: "mpls-top-label"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                        class Uint32RngArray(Entity):
                                                                            """
                                                                            uint32 rng array
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                self.yang_name = "uint32_rng_array"
                                                                                self.yang_parent_name = "mpls-top-label"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('min', (YLeaf(YType.uint32, 'min'), ['int'])),
                                                                                    ('max', (YLeaf(YType.uint32, 'max'), ['int'])),
                                                                                ])
                                                                                self.min = None
                                                                                self.max = None
                                                                                self._segment_path = lambda: "uint32_rng_array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['min', 'max'], name, value)


                                                                    class Cos(Entity):
                                                                        """
                                                                        Match CoS array
                                                                        
                                                                        .. attribute:: uint8_array
                                                                        
                                                                        	uint8 array
                                                                        	**type**\: list of int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                            self.yang_name = "cos"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                            ])
                                                                            self.uint8_array = []
                                                                            self._segment_path = lambda: "cos"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                    class CosInr(Entity):
                                                                        """
                                                                        Match inner header CoS
                                                                        
                                                                        .. attribute:: uint8_array
                                                                        
                                                                        	uint8 array
                                                                        	**type**\: list of int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                            self.yang_name = "cos-inr"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                            ])
                                                                            self.uint8_array = []
                                                                            self._segment_path = lambda: "cos-inr"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                    class Dei(Entity):
                                                                        """
                                                                        Match DEI Bit
                                                                        
                                                                        .. attribute:: bit_value
                                                                        
                                                                        	Value of the DEI bit
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                            self.yang_name = "dei"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                            ])
                                                                            self.bit_value = None
                                                                            self._segment_path = lambda: "dei"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                    class DeiInr(Entity):
                                                                        """
                                                                        Match inner DEI Bit
                                                                        
                                                                        .. attribute:: bit_value
                                                                        
                                                                        	Value of the DEI bit
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                            self.yang_name = "dei-inr"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                            ])
                                                                            self.bit_value = None
                                                                            self._segment_path = lambda: "dei-inr"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                    class Vlan(Entity):
                                                                        """
                                                                        Match VLAN array
                                                                        
                                                                        .. attribute:: vlan_id_array
                                                                        
                                                                        	vlan id array
                                                                        	**type**\: list of  		 :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                            self.yang_name = "vlan"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("vlan-id-array", ("vlan_id_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.vlan_id_array = YList(self)
                                                                            self._segment_path = lambda: "vlan"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                        class VlanIdArray(Entity):
                                                                            """
                                                                            vlan id array
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: mask
                                                                            
                                                                            	VLAN mask
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                self.yang_name = "vlan-id-array"
                                                                                self.yang_parent_name = "vlan"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                    ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                    ('mask', (YLeaf(YType.uint16, 'mask'), ['int'])),
                                                                                ])
                                                                                self.min = None
                                                                                self.max = None
                                                                                self.mask = None
                                                                                self._segment_path = lambda: "vlan-id-array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['min', 'max', 'mask'], name, value)


                                                                    class VlanInr(Entity):
                                                                        """
                                                                        Match inner header VLAN range array
                                                                        
                                                                        .. attribute:: uint16_rng_array
                                                                        
                                                                        	uint16 rng array
                                                                        	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                            self.yang_name = "vlan-inr"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.uint16_rng_array = YList(self)
                                                                            self._segment_path = lambda: "vlan-inr"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                        class Uint16RngArray(Entity):
                                                                            """
                                                                            uint16 rng array
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                self.yang_name = "uint16_rng_array"
                                                                                self.yang_parent_name = "vlan-inr"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                    ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                ])
                                                                                self.min = None
                                                                                self.max = None
                                                                                self._segment_path = lambda: "uint16_rng_array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['min', 'max'], name, value)


                                                                    class FrDlci(Entity):
                                                                        """
                                                                        Match FR DLCI range array
                                                                        
                                                                        .. attribute:: uint16_rng_array
                                                                        
                                                                        	uint16 rng array
                                                                        	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                            self.yang_name = "fr-dlci"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.uint16_rng_array = YList(self)
                                                                            self._segment_path = lambda: "fr-dlci"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                        class Uint16RngArray(Entity):
                                                                            """
                                                                            uint16 rng array
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                self.yang_name = "uint16_rng_array"
                                                                                self.yang_parent_name = "fr-dlci"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                    ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                ])
                                                                                self.min = None
                                                                                self.max = None
                                                                                self._segment_path = lambda: "uint16_rng_array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['min', 'max'], name, value)


                                                                    class SrcMac(Entity):
                                                                        """
                                                                        Match Source MAC address
                                                                        
                                                                        .. attribute:: mac_addr
                                                                        
                                                                        	MAC address
                                                                        	**type**\: list of int
                                                                        
                                                                        	**range:** 0..65535
                                                                        
                                                                        .. attribute:: mask
                                                                        
                                                                        	MAC mask
                                                                        	**type**\: list of int
                                                                        
                                                                        	**range:** 0..65535
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                            self.yang_name = "src-mac"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                            ])
                                                                            self.mac_addr = []
                                                                            self.mask = []
                                                                            self._segment_path = lambda: "src-mac"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                    class DstMac(Entity):
                                                                        """
                                                                        Match Destination MAC address
                                                                        
                                                                        .. attribute:: mac_addr
                                                                        
                                                                        	MAC address
                                                                        	**type**\: list of int
                                                                        
                                                                        	**range:** 0..65535
                                                                        
                                                                        .. attribute:: mask
                                                                        
                                                                        	MAC mask
                                                                        	**type**\: list of int
                                                                        
                                                                        	**range:** 0..65535
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                            self.yang_name = "dst-mac"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                            ])
                                                                            self.mac_addr = []
                                                                            self.mask = []
                                                                            self._segment_path = lambda: "dst-mac"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                    class AtmClp(Entity):
                                                                        """
                                                                        Match ATM CLP level
                                                                        
                                                                        .. attribute:: uint8_array
                                                                        
                                                                        	uint8 array
                                                                        	**type**\: list of int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                            self.yang_name = "atm-clp"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                            ])
                                                                            self.uint8_array = []
                                                                            self._segment_path = lambda: "atm-clp"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                    class FrDe(Entity):
                                                                        """
                                                                        Match FR DE value
                                                                        
                                                                        .. attribute:: uint8_array
                                                                        
                                                                        	uint8 array
                                                                        	**type**\: list of int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                            self.yang_name = "fr-de"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                            ])
                                                                            self.uint8_array = []
                                                                            self._segment_path = lambda: "fr-de"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                    class Ipv4Acl(Entity):
                                                                        """
                                                                        IPv4 Access\-list
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\: list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                            self.yang_name = "ipv4-acl"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                            ])
                                                                            self.string_array = []
                                                                            self._segment_path = lambda: "ipv4-acl"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                    class Ipv6Acl(Entity):
                                                                        """
                                                                        IPv6 Access\-list
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\: list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                            self.yang_name = "ipv6-acl"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                            ])
                                                                            self.string_array = []
                                                                            self._segment_path = lambda: "ipv6-acl"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                    class EtherServiceAcl(Entity):
                                                                        """
                                                                        Ethernet\-Services Access\-list
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\: list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                            self.yang_name = "ether-service-acl"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                            ])
                                                                            self.string_array = []
                                                                            self._segment_path = lambda: "ether-service-acl"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                    class AvailId(Entity):
                                                                        """
                                                                        Available Identifiers
                                                                        
                                                                        .. attribute:: uint8_array
                                                                        
                                                                        	uint8 array
                                                                        	**type**\: list of int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                            self.yang_name = "avail-id"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                            ])
                                                                            self.uint8_array = []
                                                                            self._segment_path = lambda: "avail-id"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                    class MediaType(Entity):
                                                                        """
                                                                        Media Type
                                                                        
                                                                        .. attribute:: uint8_array
                                                                        
                                                                        	uint8 array
                                                                        	**type**\: list of int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                            self.yang_name = "media-type"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                            ])
                                                                            self.uint8_array = []
                                                                            self._segment_path = lambda: "media-type"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                    class SubsProtocol(Entity):
                                                                        """
                                                                        Protocol
                                                                        
                                                                        .. attribute:: uint8_array
                                                                        
                                                                        	uint8 array
                                                                        	**type**\: list of int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                            self.yang_name = "subs-protocol"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                            ])
                                                                            self.uint8_array = []
                                                                            self._segment_path = lambda: "subs-protocol"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                    class Dnis(Entity):
                                                                        """
                                                                        DNIS
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\: list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                            self.yang_name = "dnis"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                            ])
                                                                            self.string_array = []
                                                                            self._segment_path = lambda: "dnis"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                    class DnisRegex(Entity):
                                                                        """
                                                                        DNIS Regular Expression
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\: list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                            self.yang_name = "dnis-regex"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                            ])
                                                                            self.string_array = []
                                                                            self._segment_path = lambda: "dnis-regex"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                    class Domain(Entity):
                                                                        """
                                                                        Domain Name
                                                                        
                                                                        .. attribute:: domain_array
                                                                        
                                                                        	domain array
                                                                        	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                            self.yang_name = "domain"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.domain_array = YList(self)
                                                                            self._segment_path = lambda: "domain"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                        class DomainArray(Entity):
                                                                            """
                                                                            domain array
                                                                            
                                                                            .. attribute:: domain_name
                                                                            
                                                                            	domain name
                                                                            	**type**\: str
                                                                            
                                                                            .. attribute:: format_name
                                                                            
                                                                            	format name
                                                                            	**type**\: str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                self.yang_name = "domain-array"
                                                                                self.yang_parent_name = "domain"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                    ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                ])
                                                                                self.domain_name = None
                                                                                self.format_name = None
                                                                                self._segment_path = lambda: "domain-array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                    class DomainRegex(Entity):
                                                                        """
                                                                        Domain Regular Expression
                                                                        
                                                                        .. attribute:: domain_array
                                                                        
                                                                        	domain array
                                                                        	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                            self.yang_name = "domain-regex"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.domain_array = YList(self)
                                                                            self._segment_path = lambda: "domain-regex"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                        class DomainArray(Entity):
                                                                            """
                                                                            domain array
                                                                            
                                                                            .. attribute:: domain_name
                                                                            
                                                                            	domain name
                                                                            	**type**\: str
                                                                            
                                                                            .. attribute:: format_name
                                                                            
                                                                            	format name
                                                                            	**type**\: str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                self.yang_name = "domain-array"
                                                                                self.yang_parent_name = "domain-regex"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                    ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                ])
                                                                                self.domain_name = None
                                                                                self.format_name = None
                                                                                self._segment_path = lambda: "domain-array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                    class NasPort(Entity):
                                                                        """
                                                                        NAS Port
                                                                        
                                                                        .. attribute:: nas_port_array
                                                                        
                                                                        	nas port array
                                                                        	**type**\: list of  		 :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                            self.yang_name = "nas-port"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("nas-port-array", ("nas_port_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.nas_port_array = YList(self)
                                                                            self._segment_path = lambda: "nas-port"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                        class NasPortArray(Entity):
                                                                            """
                                                                            nas port array
                                                                            
                                                                            .. attribute:: sub_id
                                                                            
                                                                            	sub id
                                                                            	**type**\:  :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                            
                                                                            .. attribute:: operator
                                                                            
                                                                            	operator
                                                                            	**type**\:  :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                self.yang_name = "nas-port-array"
                                                                                self.yang_parent_name = "nas-port"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('sub_id', (YLeaf(YType.enumeration, 'sub-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchNasPortSubIdEn', '')])),
                                                                                    ('operator', (YLeaf(YType.enumeration, 'operator'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchLogicalOperatorEn', '')])),
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                ])
                                                                                self.sub_id = None
                                                                                self.operator = None
                                                                                self.value = None
                                                                                self._segment_path = lambda: "nas-port-array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['sub_id', 'operator', 'value'], name, value)


                                                                    class ServiceName(Entity):
                                                                        """
                                                                        Service Name
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\: list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                            self.yang_name = "service-name"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                            ])
                                                                            self.string_array = []
                                                                            self._segment_path = lambda: "service-name"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                    class ServiceNameRegex(Entity):
                                                                        """
                                                                        Service Name Regular Exp
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\: list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                            self.yang_name = "service-name-regex"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                            ])
                                                                            self.string_array = []
                                                                            self._segment_path = lambda: "service-name-regex"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                    class SrcAddrIpv4(Entity):
                                                                        """
                                                                        Source Address IPV4
                                                                        
                                                                        .. attribute:: ipv4_addr_array
                                                                        
                                                                        	ipv4 addr array
                                                                        	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                            self.yang_name = "src-addr-ipv4"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.ipv4_addr_array = YList(self)
                                                                            self._segment_path = lambda: "src-addr-ipv4"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                        class Ipv4AddrArray(Entity):
                                                                            """
                                                                            ipv4 addr array
                                                                            
                                                                            .. attribute:: prefix
                                                                            
                                                                            	prefix
                                                                            	**type**\: str
                                                                            
                                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                            
                                                                            .. attribute:: mask
                                                                            
                                                                            	mask
                                                                            	**type**\: str
                                                                            
                                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                self.yang_name = "ipv4-addr-array"
                                                                                self.yang_parent_name = "src-addr-ipv4"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                    ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                ])
                                                                                self.prefix = None
                                                                                self.mask = None
                                                                                self._segment_path = lambda: "ipv4-addr-array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                    class DstAddrIpv4(Entity):
                                                                        """
                                                                        Destination Address IPV4
                                                                        
                                                                        .. attribute:: ipv4_addr_array
                                                                        
                                                                        	ipv4 addr array
                                                                        	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                            self.yang_name = "dst-addr-ipv4"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.ipv4_addr_array = YList(self)
                                                                            self._segment_path = lambda: "dst-addr-ipv4"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                        class Ipv4AddrArray(Entity):
                                                                            """
                                                                            ipv4 addr array
                                                                            
                                                                            .. attribute:: prefix
                                                                            
                                                                            	prefix
                                                                            	**type**\: str
                                                                            
                                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                            
                                                                            .. attribute:: mask
                                                                            
                                                                            	mask
                                                                            	**type**\: str
                                                                            
                                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                self.yang_name = "ipv4-addr-array"
                                                                                self.yang_parent_name = "dst-addr-ipv4"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                    ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                ])
                                                                                self.prefix = None
                                                                                self.mask = None
                                                                                self._segment_path = lambda: "ipv4-addr-array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                    class SrcAddrIpv6(Entity):
                                                                        """
                                                                        Source Address IPV6
                                                                        
                                                                        .. attribute:: ipv6_addr_array
                                                                        
                                                                        	ipv6 addr array
                                                                        	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                            self.yang_name = "src-addr-ipv6"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.ipv6_addr_array = YList(self)
                                                                            self._segment_path = lambda: "src-addr-ipv6"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                        class Ipv6AddrArray(Entity):
                                                                            """
                                                                            ipv6 addr array
                                                                            
                                                                            .. attribute:: prefix
                                                                            
                                                                            	IPV6 prefix
                                                                            	**type**\: str
                                                                            
                                                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                            
                                                                            .. attribute:: mask
                                                                            
                                                                            	IPV6 mask
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                self.yang_name = "ipv6-addr-array"
                                                                                self.yang_parent_name = "src-addr-ipv6"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                    ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                ])
                                                                                self.prefix = None
                                                                                self.mask = None
                                                                                self._segment_path = lambda: "ipv6-addr-array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                    class DstAddrIpv6(Entity):
                                                                        """
                                                                        Destination Address IPV6
                                                                        
                                                                        .. attribute:: ipv6_addr_array
                                                                        
                                                                        	ipv6 addr array
                                                                        	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                            self.yang_name = "dst-addr-ipv6"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.ipv6_addr_array = YList(self)
                                                                            self._segment_path = lambda: "dst-addr-ipv6"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                        class Ipv6AddrArray(Entity):
                                                                            """
                                                                            ipv6 addr array
                                                                            
                                                                            .. attribute:: prefix
                                                                            
                                                                            	IPV6 prefix
                                                                            	**type**\: str
                                                                            
                                                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                            
                                                                            .. attribute:: mask
                                                                            
                                                                            	IPV6 mask
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                self.yang_name = "ipv6-addr-array"
                                                                                self.yang_parent_name = "dst-addr-ipv6"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                    ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                ])
                                                                                self.prefix = None
                                                                                self.mask = None
                                                                                self._segment_path = lambda: "ipv6-addr-array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                    class SrcAddrMac(Entity):
                                                                        """
                                                                        Source Address MAC
                                                                        
                                                                        .. attribute:: mac_addr_array
                                                                        
                                                                        	mac addr array
                                                                        	**type**\: list of  		 :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                            self.yang_name = "src-addr-mac"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("mac-addr-array", ("mac_addr_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.mac_addr_array = YList(self)
                                                                            self._segment_path = lambda: "src-addr-mac"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                        class MacAddrArray(Entity):
                                                                            """
                                                                            mac addr array
                                                                            
                                                                            .. attribute:: mac_addr
                                                                            
                                                                            	MAC address
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: mask
                                                                            
                                                                            	MAC mask
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                self.yang_name = "mac-addr-array"
                                                                                self.yang_parent_name = "src-addr-mac"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                    ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                ])
                                                                                self.mac_addr = []
                                                                                self.mask = []
                                                                                self._segment_path = lambda: "mac-addr-array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                    class Timer(Entity):
                                                                        """
                                                                        Timer
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\: list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                            self.yang_name = "timer"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                            ])
                                                                            self.string_array = []
                                                                            self._segment_path = lambda: "timer"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                    class TimerRegexp(Entity):
                                                                        """
                                                                        Timer Regular Expression
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\: list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                            self.yang_name = "timer-regexp"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                            ])
                                                                            self.string_array = []
                                                                            self._segment_path = lambda: "timer-regexp"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                    class TunnelName(Entity):
                                                                        """
                                                                        Tunnel Name
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\: list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                            self.yang_name = "tunnel-name"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                            ])
                                                                            self.string_array = []
                                                                            self._segment_path = lambda: "tunnel-name"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                    class TunnelNameRegex(Entity):
                                                                        """
                                                                        Tunnel Name Regular Expression
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\: list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                            self.yang_name = "tunnel-name-regex"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                            ])
                                                                            self.string_array = []
                                                                            self._segment_path = lambda: "tunnel-name-regex"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                    class UserName(Entity):
                                                                        """
                                                                        User Name
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\: list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                            self.yang_name = "user-name"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                            ])
                                                                            self.string_array = []
                                                                            self._segment_path = lambda: "user-name"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                    class UserNameRegex(Entity):
                                                                        """
                                                                        User Name Regular Expression
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\: list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                            self.yang_name = "user-name-regex"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                            ])
                                                                            self.string_array = []
                                                                            self._segment_path = lambda: "user-name-regex"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                    class AuthUsername(Entity):
                                                                        """
                                                                        Authenticated User Name
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\: list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                            self.yang_name = "auth-username"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                            ])
                                                                            self.string_array = []
                                                                            self._segment_path = lambda: "auth-username"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                    class AuthUsernameRegex(Entity):
                                                                        """
                                                                        Authenticated User Name RegEx
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\: list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                            self.yang_name = "auth-username-regex"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                            ])
                                                                            self.string_array = []
                                                                            self._segment_path = lambda: "auth-username-regex"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                    class UnauthUsername(Entity):
                                                                        """
                                                                        Unauthenticated User Name
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\: list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                            self.yang_name = "unauth-username"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                            ])
                                                                            self.string_array = []
                                                                            self._segment_path = lambda: "unauth-username"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                    class UnauthUsernameRegex(Entity):
                                                                        """
                                                                        Unauthenticated User Name RegEx
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\: list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                            self.yang_name = "unauth-username-regex"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                            ])
                                                                            self.string_array = []
                                                                            self._segment_path = lambda: "unauth-username-regex"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                    class AuthDomain(Entity):
                                                                        """
                                                                        Authenticated domain name
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\: list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                            self.yang_name = "auth-domain"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                            ])
                                                                            self.string_array = []
                                                                            self._segment_path = lambda: "auth-domain"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                    class AuthDomainRegex(Entity):
                                                                        """
                                                                        Authenticated Domain Name RegEx
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\: list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                            self.yang_name = "auth-domain-regex"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                            ])
                                                                            self.string_array = []
                                                                            self._segment_path = lambda: "auth-domain-regex"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                    class UnauthDomain(Entity):
                                                                        """
                                                                        Unauthenticated Domain Name
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\: list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                            self.yang_name = "unauth-domain"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                            ])
                                                                            self.string_array = []
                                                                            self._segment_path = lambda: "unauth-domain"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                    class UnauthDomainRegex(Entity):
                                                                        """
                                                                        Unauthenticated Domain Name RegEx
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\: list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                            self.yang_name = "unauth-domain-regex"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                            ])
                                                                            self.string_array = []
                                                                            self._segment_path = lambda: "unauth-domain-regex"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                    class VendorId(Entity):
                                                                        """
                                                                        Vendor ID
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\: list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                            self.yang_name = "vendor-id"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                            ])
                                                                            self.string_array = []
                                                                            self._segment_path = lambda: "vendor-id"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                    class VendorIdRegex(Entity):
                                                                        """
                                                                        Vendor ID RegEx
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\: list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                            self.yang_name = "vendor-id-regex"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                            ])
                                                                            self.string_array = []
                                                                            self._segment_path = lambda: "vendor-id-regex"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                    class AccessInterface(Entity):
                                                                        """
                                                                        Access interface
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\: list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                            self.yang_name = "access-interface"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                            ])
                                                                            self.string_array = []
                                                                            self._segment_path = lambda: "access-interface"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                    class InputInterface(Entity):
                                                                        """
                                                                        Input interface
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\: list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                            self.yang_name = "input-interface"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                            ])
                                                                            self.string_array = []
                                                                            self._segment_path = lambda: "input-interface"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                    class InputIntfhdl(Entity):
                                                                        """
                                                                        Input interface handle
                                                                        
                                                                        .. attribute:: uint64_array
                                                                        
                                                                        	uint64 array
                                                                        	**type**\: list of int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                            self.yang_name = "input-intfhdl"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('uint64_array', (YLeafList(YType.uint64, 'uint64_array'), ['int'])),
                                                                            ])
                                                                            self.uint64_array = []
                                                                            self._segment_path = lambda: "input-intfhdl"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                    class Ethertype(Entity):
                                                                        """
                                                                        Ethernet type
                                                                        
                                                                        .. attribute:: uint16_rng_array
                                                                        
                                                                        	uint16 rng array
                                                                        	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                            self.yang_name = "ethertype"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.uint16_rng_array = YList(self)
                                                                            self._segment_path = lambda: "ethertype"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                        class Uint16RngArray(Entity):
                                                                            """
                                                                            uint16 rng array
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                self.yang_name = "uint16_rng_array"
                                                                                self.yang_parent_name = "ethertype"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                    ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                ])
                                                                                self.min = None
                                                                                self.max = None
                                                                                self._segment_path = lambda: "uint16_rng_array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['min', 'max'], name, value)


                                                                    class FlowKeyData(Entity):
                                                                        """
                                                                        Flow key structure
                                                                        
                                                                        .. attribute:: flow_keys
                                                                        
                                                                        	flow keys
                                                                        	**type**\:  :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                        
                                                                        .. attribute:: max_count
                                                                        
                                                                        	Maximum count of flows
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..65535
                                                                        
                                                                        .. attribute:: idle_timeout
                                                                        
                                                                        	Idle timeout of flows (in seconds)
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..65535
                                                                        
                                                                        	**units**\: second
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                            self.yang_name = "flow-key-data"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("flow-keys", ("flow_keys", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys))])
                                                                            self._leafs = OrderedDict([
                                                                                ('max_count', (YLeaf(YType.uint16, 'max-count'), ['int'])),
                                                                                ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                            ])
                                                                            self.max_count = None
                                                                            self.idle_timeout = None

                                                                            self.flow_keys = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                            self.flow_keys.parent = self
                                                                            self._children_name_map["flow_keys"] = "flow-keys"
                                                                            self._segment_path = lambda: "flow-key-data"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['max_count', 'idle_timeout'], name, value)


                                                                        class FlowKeys(Entity):
                                                                            """
                                                                            flow keys
                                                                            
                                                                            .. attribute:: keys
                                                                            
                                                                            	keys
                                                                            	**type**\: str
                                                                            
                                                                            	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                            
                                                                            .. attribute:: num
                                                                            
                                                                            	num
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                self.yang_name = "flow-keys"
                                                                                self.yang_parent_name = "flow-key-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('keys', (YLeaf(YType.str, 'keys'), ['str'])),
                                                                                    ('num', (YLeaf(YType.uint8, 'num'), ['int'])),
                                                                                ])
                                                                                self.keys = None
                                                                                self.num = None
                                                                                self._segment_path = lambda: "flow-keys"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                    class DhcpClientId(Entity):
                                                                        """
                                                                        Dhcp Client ID
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\: list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                            self.yang_name = "dhcp-client-id"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                            ])
                                                                            self.string_array = []
                                                                            self._segment_path = lambda: "dhcp-client-id"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                    class DhcpClientIdRegex(Entity):
                                                                        """
                                                                        Dhcp Client ID RegEx
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\: list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                            self.yang_name = "dhcp-client-id-regex"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                            ])
                                                                            self.string_array = []
                                                                            self._segment_path = lambda: "dhcp-client-id-regex"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                    class CircuitId(Entity):
                                                                        """
                                                                        Circuit ID
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\: list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                            self.yang_name = "circuit-id"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                            ])
                                                                            self.string_array = []
                                                                            self._segment_path = lambda: "circuit-id"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                    class CircuitIdRegex(Entity):
                                                                        """
                                                                        Circuit ID RegEx
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\: list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                            self.yang_name = "circuit-id-regex"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                            ])
                                                                            self.string_array = []
                                                                            self._segment_path = lambda: "circuit-id-regex"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                    class RemoteId(Entity):
                                                                        """
                                                                        Remote ID
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\: list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                            self.yang_name = "remote-id"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                            ])
                                                                            self.string_array = []
                                                                            self._segment_path = lambda: "remote-id"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                    class RemoteIdRegex(Entity):
                                                                        """
                                                                        Remote ID RegEx
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\: list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                            self.yang_name = "remote-id-regex"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                            ])
                                                                            self.string_array = []
                                                                            self._segment_path = lambda: "remote-id-regex"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                    class SrcPort(Entity):
                                                                        """
                                                                        Source port
                                                                        
                                                                        .. attribute:: uint16_rng_array
                                                                        
                                                                        	uint16 rng array
                                                                        	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                            self.yang_name = "src-port"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.uint16_rng_array = YList(self)
                                                                            self._segment_path = lambda: "src-port"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                        class Uint16RngArray(Entity):
                                                                            """
                                                                            uint16 rng array
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                self.yang_name = "uint16_rng_array"
                                                                                self.yang_parent_name = "src-port"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                    ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                ])
                                                                                self.min = None
                                                                                self.max = None
                                                                                self._segment_path = lambda: "uint16_rng_array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                    class DstPort(Entity):
                                                                        """
                                                                        Destination port
                                                                        
                                                                        .. attribute:: uint16_rng_array
                                                                        
                                                                        	uint16 rng array
                                                                        	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                            self.yang_name = "dst-port"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.uint16_rng_array = YList(self)
                                                                            self._segment_path = lambda: "dst-port"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                        class Uint16RngArray(Entity):
                                                                            """
                                                                            uint16 rng array
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                self.yang_name = "uint16_rng_array"
                                                                                self.yang_parent_name = "dst-port"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                    ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                ])
                                                                                self.min = None
                                                                                self.max = None
                                                                                self._segment_path = lambda: "uint16_rng_array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['min', 'max'], name, value)


                                                class ActInfop(Entity):
                                                    """
                                                    act infop
                                                    
                                                    .. attribute:: policy_action_info_st
                                                    
                                                    	policy action info st
                                                    	**type**\: list of  		 :py:class:`PolicyActionInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop, self).__init__()

                                                        self.yang_name = "act-infop"
                                                        self.yang_parent_name = "policy-class-info-bg"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("policy-action-info-st", ("policy_action_info_st", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt))])
                                                        self._leafs = OrderedDict()

                                                        self.policy_action_info_st = YList(self)
                                                        self._segment_path = lambda: "act-infop"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop, [], name, value)


                                                    class PolicyActionInfoSt(Entity):
                                                        """
                                                        policy action info st
                                                        
                                                        .. attribute:: actp
                                                        
                                                        	actp
                                                        	**type**\:  :py:class:`Actp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp>`
                                                        
                                                        .. attribute:: seq
                                                        
                                                        	seq
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: flags
                                                        
                                                        	flags
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2018-01-17'

                                                        def __init__(self):
                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt, self).__init__()

                                                            self.yang_name = "policy-action-info-st"
                                                            self.yang_parent_name = "act-infop"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("actp", ("actp", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp))])
                                                            self._leafs = OrderedDict([
                                                                ('seq', (YLeaf(YType.uint16, 'seq'), ['int'])),
                                                                ('flags', (YLeaf(YType.uint16, 'flags'), ['int'])),
                                                            ])
                                                            self.seq = None
                                                            self.flags = None

                                                            self.actp = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp()
                                                            self.actp.parent = self
                                                            self._children_name_map["actp"] = "actp"
                                                            self._segment_path = lambda: "policy-action-info-st"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt, ['seq', 'flags'], name, value)


                                                        class Actp(Entity):
                                                            """
                                                            actp
                                                            
                                                            .. attribute:: mark
                                                            
                                                            	mark
                                                            	**type**\:  :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark>`
                                                            
                                                            .. attribute:: mark2
                                                            
                                                            	mark2
                                                            	**type**\:  :py:class:`Mark2 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2>`
                                                            
                                                            .. attribute:: wred
                                                            
                                                            	wred
                                                            	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred>`
                                                            
                                                            .. attribute:: encap
                                                            
                                                            	encap
                                                            	**type**\:  :py:class:`Encap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap>`
                                                            
                                                            .. attribute:: prio
                                                            
                                                            	prio
                                                            	**type**\:  :py:class:`Prio <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio>`
                                                            
                                                            .. attribute:: bwrem
                                                            
                                                            	bwrem
                                                            	**type**\:  :py:class:`Bwrem <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem>`
                                                            
                                                            .. attribute:: min_bw
                                                            
                                                            	min bw
                                                            	**type**\:  :py:class:`MinBw <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw>`
                                                            
                                                            .. attribute:: authen_aaa
                                                            
                                                            	authen aaa
                                                            	**type**\:  :py:class:`AuthenAaa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa>`
                                                            
                                                            .. attribute:: collect_id
                                                            
                                                            	collect id
                                                            	**type**\:  :py:class:`CollectId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId>`
                                                            
                                                            .. attribute:: decode_id
                                                            
                                                            	decode id
                                                            	**type**\:  :py:class:`DecodeId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId>`
                                                            
                                                            .. attribute:: set_timer
                                                            
                                                            	set timer
                                                            	**type**\:  :py:class:`SetTimer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer>`
                                                            
                                                            .. attribute:: stop_timer
                                                            
                                                            	stop timer
                                                            	**type**\:  :py:class:`StopTimer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer>`
                                                            
                                                            .. attribute:: acct_aaa_list
                                                            
                                                            	acct aaa list
                                                            	**type**\:  :py:class:`AcctAaaList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList>`
                                                            
                                                            .. attribute:: query_ancp
                                                            
                                                            	query ancp
                                                            	**type**\:  :py:class:`QueryAncp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp>`
                                                            
                                                            .. attribute:: prepaid_cfg
                                                            
                                                            	prepaid cfg
                                                            	**type**\:  :py:class:`PrepaidCfg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg>`
                                                            
                                                            .. attribute:: timeout_idle
                                                            
                                                            	timeout idle
                                                            	**type**\:  :py:class:`TimeoutIdle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle>`
                                                            
                                                            .. attribute:: proxy_aaa
                                                            
                                                            	proxy aaa
                                                            	**type**\:  :py:class:`ProxyAaa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa>`
                                                            
                                                            .. attribute:: act_template
                                                            
                                                            	act template
                                                            	**type**\:  :py:class:`ActTemplate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate>`
                                                            
                                                            .. attribute:: deact_template
                                                            
                                                            	deact template
                                                            	**type**\:  :py:class:`DeactTemplate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate>`
                                                            
                                                            .. attribute:: qlimit
                                                            
                                                            	qlimit
                                                            	**type**\:  :py:class:`Qlimit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit>`
                                                            
                                                            .. attribute:: accounting_event_aaa
                                                            
                                                            	accounting event aaa
                                                            	**type**\:  :py:class:`AccountingEventAaa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa>`
                                                            
                                                            .. attribute:: authorize_id
                                                            
                                                            	authorize id
                                                            	**type**\:  :py:class:`AuthorizeId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId>`
                                                            
                                                            .. attribute:: afm_react
                                                            
                                                            	afm react
                                                            	**type**\:  :py:class:`AfmReact <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact>`
                                                            
                                                            .. attribute:: httpr
                                                            
                                                            	httpr
                                                            	**type**\:  :py:class:`Httpr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr>`
                                                            
                                                            .. attribute:: punt
                                                            
                                                            	punt
                                                            	**type**\:  :py:class:`Punt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt>`
                                                            
                                                            .. attribute:: copy
                                                            
                                                            	copy
                                                            	**type**\:  :py:class:`Copy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy>`
                                                            
                                                            .. attribute:: sfrag
                                                            
                                                            	sfrag
                                                            	**type**\:  :py:class:`Sfrag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag>`
                                                            
                                                            .. attribute:: redirect
                                                            
                                                            	redirect
                                                            	**type**\:  :py:class:`Redirect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect>`
                                                            
                                                            .. attribute:: out_intf
                                                            
                                                            	out intf
                                                            	**type**\:  :py:class:`OutIntf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf>`
                                                            
                                                            .. attribute:: serv_func
                                                            
                                                            	serv func
                                                            	**type**\:  :py:class:`ServFunc <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc>`
                                                            
                                                            .. attribute:: police
                                                            
                                                            	police
                                                            	**type**\:  :py:class:`Police <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police>`
                                                            
                                                            .. attribute:: shape
                                                            
                                                            	shape
                                                            	**type**\:  :py:class:`Shape <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape>`
                                                            
                                                            .. attribute:: child_policy
                                                            
                                                            	child policy
                                                            	**type**\:  :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy>`
                                                            
                                                            .. attribute:: cac
                                                            
                                                            	cac
                                                            	**type**\:  :py:class:`Cac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac>`
                                                            
                                                            .. attribute:: pfc
                                                            
                                                            	pfc
                                                            	**type**\:  :py:class:`Pfc <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc>`
                                                            
                                                            .. attribute:: flow_parm
                                                            
                                                            	flow parm
                                                            	**type**\:  :py:class:`FlowParm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm>`
                                                            
                                                            .. attribute:: ipcbr
                                                            
                                                            	ipcbr
                                                            	**type**\:  :py:class:`Ipcbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr>`
                                                            
                                                            .. attribute:: rtp
                                                            
                                                            	rtp
                                                            	**type**\:  :py:class:`Rtp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp>`
                                                            
                                                            .. attribute:: rtp_mmr
                                                            
                                                            	rtp mmr
                                                            	**type**\:  :py:class:`RtpMmr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr>`
                                                            
                                                            .. attribute:: rtp_j2k
                                                            
                                                            	rtp j2k
                                                            	**type**\:  :py:class:`RtpJ2k <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k>`
                                                            
                                                            .. attribute:: rtp_voice
                                                            
                                                            	rtp voice
                                                            	**type**\:  :py:class:`RtpVoice <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice>`
                                                            
                                                            .. attribute:: mdi
                                                            
                                                            	mdi
                                                            	**type**\:  :py:class:`Mdi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi>`
                                                            
                                                            .. attribute:: mdi_rtp
                                                            
                                                            	mdi rtp
                                                            	**type**\:  :py:class:`MdiRtp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp>`
                                                            
                                                            .. attribute:: fmm
                                                            
                                                            	fmm
                                                            	**type**\:  :py:class:`Fmm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm>`
                                                            
                                                            .. attribute:: pbf
                                                            
                                                            	pbf
                                                            	**type**\:  :py:class:`Pbf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf>`
                                                            
                                                            .. attribute:: ipv4_nh
                                                            
                                                            	ipv4 nh
                                                            	**type**\:  :py:class:`Ipv4Nh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh>`
                                                            
                                                            .. attribute:: ipv6_nh
                                                            
                                                            	ipv6 nh
                                                            	**type**\:  :py:class:`Ipv6Nh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh>`
                                                            
                                                            .. attribute:: type
                                                            
                                                            	type
                                                            	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                            
                                                            .. attribute:: data_p
                                                            
                                                            	data p
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'infra-policymgr-oper'
                                                            _revision = '2018-01-17'

                                                            def __init__(self):
                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp, self).__init__()

                                                                self.yang_name = "actp"
                                                                self.yang_parent_name = "policy-action-info-st"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("mark", ("mark", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark)), ("mark2", ("mark2", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2)), ("wred", ("wred", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred)), ("encap", ("encap", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap)), ("prio", ("prio", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio)), ("bwrem", ("bwrem", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem)), ("min-bw", ("min_bw", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw)), ("authen-aaa", ("authen_aaa", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa)), ("collect-id", ("collect_id", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId)), ("decode-id", ("decode_id", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId)), ("set-timer", ("set_timer", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer)), ("stop-timer", ("stop_timer", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer)), ("acct-aaa-list", ("acct_aaa_list", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList)), ("query-ancp", ("query_ancp", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp)), ("prepaid-cfg", ("prepaid_cfg", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg)), ("timeout-idle", ("timeout_idle", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle)), ("proxy-aaa", ("proxy_aaa", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa)), ("act-template", ("act_template", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate)), ("deact-template", ("deact_template", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate)), ("qlimit", ("qlimit", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit)), ("accounting-event-aaa", ("accounting_event_aaa", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa)), ("authorize-id", ("authorize_id", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId)), ("afm-react", ("afm_react", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact)), ("httpr", ("httpr", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr)), ("punt", ("punt", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt)), ("copy", ("copy", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy)), ("sfrag", ("sfrag", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag)), ("redirect", ("redirect", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect)), ("out-intf", ("out_intf", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf)), ("serv-func", ("serv_func", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc)), ("police", ("police", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police)), ("shape", ("shape", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape)), ("child-policy", ("child_policy", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy)), ("cac", ("cac", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac)), ("pfc", ("pfc", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc)), ("flow-parm", ("flow_parm", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm)), ("ipcbr", ("ipcbr", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr)), ("rtp", ("rtp", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp)), ("rtp-mmr", ("rtp_mmr", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr)), ("rtp-j2k", ("rtp_j2k", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k)), ("rtp-voice", ("rtp_voice", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice)), ("mdi", ("mdi", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi)), ("mdi-rtp", ("mdi_rtp", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp)), ("fmm", ("fmm", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm)), ("pbf", ("pbf", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf)), ("ipv4-nh", ("ipv4_nh", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh)), ("ipv6-nh", ("ipv6_nh", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh))])
                                                                self._leafs = OrderedDict([
                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                    ('data_p', (YLeaf(YType.uint32, 'data-p'), ['int'])),
                                                                ])
                                                                self.type = None
                                                                self.data_p = None

                                                                self.mark = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark()
                                                                self.mark.parent = self
                                                                self._children_name_map["mark"] = "mark"

                                                                self.mark2 = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2()
                                                                self.mark2.parent = self
                                                                self._children_name_map["mark2"] = "mark2"

                                                                self.wred = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred()
                                                                self.wred.parent = self
                                                                self._children_name_map["wred"] = "wred"

                                                                self.encap = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap()
                                                                self.encap.parent = self
                                                                self._children_name_map["encap"] = "encap"

                                                                self.prio = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio()
                                                                self.prio.parent = self
                                                                self._children_name_map["prio"] = "prio"

                                                                self.bwrem = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem()
                                                                self.bwrem.parent = self
                                                                self._children_name_map["bwrem"] = "bwrem"

                                                                self.min_bw = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw()
                                                                self.min_bw.parent = self
                                                                self._children_name_map["min_bw"] = "min-bw"

                                                                self.authen_aaa = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa()
                                                                self.authen_aaa.parent = self
                                                                self._children_name_map["authen_aaa"] = "authen-aaa"

                                                                self.collect_id = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId()
                                                                self.collect_id.parent = self
                                                                self._children_name_map["collect_id"] = "collect-id"

                                                                self.decode_id = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId()
                                                                self.decode_id.parent = self
                                                                self._children_name_map["decode_id"] = "decode-id"

                                                                self.set_timer = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer()
                                                                self.set_timer.parent = self
                                                                self._children_name_map["set_timer"] = "set-timer"

                                                                self.stop_timer = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer()
                                                                self.stop_timer.parent = self
                                                                self._children_name_map["stop_timer"] = "stop-timer"

                                                                self.acct_aaa_list = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList()
                                                                self.acct_aaa_list.parent = self
                                                                self._children_name_map["acct_aaa_list"] = "acct-aaa-list"

                                                                self.query_ancp = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp()
                                                                self.query_ancp.parent = self
                                                                self._children_name_map["query_ancp"] = "query-ancp"

                                                                self.prepaid_cfg = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg()
                                                                self.prepaid_cfg.parent = self
                                                                self._children_name_map["prepaid_cfg"] = "prepaid-cfg"

                                                                self.timeout_idle = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle()
                                                                self.timeout_idle.parent = self
                                                                self._children_name_map["timeout_idle"] = "timeout-idle"

                                                                self.proxy_aaa = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa()
                                                                self.proxy_aaa.parent = self
                                                                self._children_name_map["proxy_aaa"] = "proxy-aaa"

                                                                self.act_template = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate()
                                                                self.act_template.parent = self
                                                                self._children_name_map["act_template"] = "act-template"

                                                                self.deact_template = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate()
                                                                self.deact_template.parent = self
                                                                self._children_name_map["deact_template"] = "deact-template"

                                                                self.qlimit = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit()
                                                                self.qlimit.parent = self
                                                                self._children_name_map["qlimit"] = "qlimit"

                                                                self.accounting_event_aaa = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa()
                                                                self.accounting_event_aaa.parent = self
                                                                self._children_name_map["accounting_event_aaa"] = "accounting-event-aaa"

                                                                self.authorize_id = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId()
                                                                self.authorize_id.parent = self
                                                                self._children_name_map["authorize_id"] = "authorize-id"

                                                                self.afm_react = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact()
                                                                self.afm_react.parent = self
                                                                self._children_name_map["afm_react"] = "afm-react"

                                                                self.httpr = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr()
                                                                self.httpr.parent = self
                                                                self._children_name_map["httpr"] = "httpr"

                                                                self.punt = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt()
                                                                self.punt.parent = self
                                                                self._children_name_map["punt"] = "punt"

                                                                self.copy = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy()
                                                                self.copy.parent = self
                                                                self._children_name_map["copy"] = "copy"

                                                                self.sfrag = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag()
                                                                self.sfrag.parent = self
                                                                self._children_name_map["sfrag"] = "sfrag"

                                                                self.redirect = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect()
                                                                self.redirect.parent = self
                                                                self._children_name_map["redirect"] = "redirect"

                                                                self.out_intf = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf()
                                                                self.out_intf.parent = self
                                                                self._children_name_map["out_intf"] = "out-intf"

                                                                self.serv_func = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc()
                                                                self.serv_func.parent = self
                                                                self._children_name_map["serv_func"] = "serv-func"

                                                                self.police = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police()
                                                                self.police.parent = self
                                                                self._children_name_map["police"] = "police"

                                                                self.shape = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape()
                                                                self.shape.parent = self
                                                                self._children_name_map["shape"] = "shape"

                                                                self.child_policy = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy()
                                                                self.child_policy.parent = self
                                                                self._children_name_map["child_policy"] = "child-policy"

                                                                self.cac = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac()
                                                                self.cac.parent = self
                                                                self._children_name_map["cac"] = "cac"

                                                                self.pfc = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc()
                                                                self.pfc.parent = self
                                                                self._children_name_map["pfc"] = "pfc"

                                                                self.flow_parm = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm()
                                                                self.flow_parm.parent = self
                                                                self._children_name_map["flow_parm"] = "flow-parm"

                                                                self.ipcbr = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr()
                                                                self.ipcbr.parent = self
                                                                self._children_name_map["ipcbr"] = "ipcbr"

                                                                self.rtp = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp()
                                                                self.rtp.parent = self
                                                                self._children_name_map["rtp"] = "rtp"

                                                                self.rtp_mmr = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr()
                                                                self.rtp_mmr.parent = self
                                                                self._children_name_map["rtp_mmr"] = "rtp-mmr"

                                                                self.rtp_j2k = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k()
                                                                self.rtp_j2k.parent = self
                                                                self._children_name_map["rtp_j2k"] = "rtp-j2k"

                                                                self.rtp_voice = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice()
                                                                self.rtp_voice.parent = self
                                                                self._children_name_map["rtp_voice"] = "rtp-voice"

                                                                self.mdi = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi()
                                                                self.mdi.parent = self
                                                                self._children_name_map["mdi"] = "mdi"

                                                                self.mdi_rtp = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp()
                                                                self.mdi_rtp.parent = self
                                                                self._children_name_map["mdi_rtp"] = "mdi-rtp"

                                                                self.fmm = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm()
                                                                self.fmm.parent = self
                                                                self._children_name_map["fmm"] = "fmm"

                                                                self.pbf = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf()
                                                                self.pbf.parent = self
                                                                self._children_name_map["pbf"] = "pbf"

                                                                self.ipv4_nh = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh()
                                                                self.ipv4_nh.parent = self
                                                                self._children_name_map["ipv4_nh"] = "ipv4-nh"

                                                                self.ipv6_nh = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh()
                                                                self.ipv6_nh.parent = self
                                                                self._children_name_map["ipv6_nh"] = "ipv6-nh"
                                                                self._segment_path = lambda: "actp"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp, ['type', 'data_p'], name, value)


                                                            class Mark(Entity):
                                                                """
                                                                mark
                                                                
                                                                .. attribute:: action_mark_info
                                                                
                                                                	action mark info
                                                                	**type**\: list of  		 :py:class:`ActionMarkInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark, self).__init__()

                                                                    self.yang_name = "mark"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("action-mark-info", ("action_mark_info", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo))])
                                                                    self._leafs = OrderedDict()

                                                                    self.action_mark_info = YList(self)
                                                                    self._segment_path = lambda: "mark"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark, [], name, value)


                                                                class ActionMarkInfo(Entity):
                                                                    """
                                                                    action mark info
                                                                    
                                                                    .. attribute:: type
                                                                    
                                                                    	type
                                                                    	**type**\:  :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                    
                                                                    .. attribute:: mark_flags
                                                                    
                                                                    	mark flags
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..65535
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo, self).__init__()

                                                                        self.yang_name = "action-mark-info"
                                                                        self.yang_parent_name = "mark"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MarkTypeEn', '')])),
                                                                            ('mark_flags', (YLeaf(YType.uint32, 'mark-flags'), ['int'])),
                                                                            ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                        ])
                                                                        self.type = None
                                                                        self.mark_flags = None
                                                                        self.value = None
                                                                        self._segment_path = lambda: "action-mark-info"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo, ['type', 'mark_flags', 'value'], name, value)


                                                            class Mark2(Entity):
                                                                """
                                                                mark2
                                                                
                                                                .. attribute:: action_mark2_info
                                                                
                                                                	action mark2 info
                                                                	**type**\: list of  		 :py:class:`ActionMark2Info <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2, self).__init__()

                                                                    self.yang_name = "mark2"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("action-mark2-info", ("action_mark2_info", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info))])
                                                                    self._leafs = OrderedDict()

                                                                    self.action_mark2_info = YList(self)
                                                                    self._segment_path = lambda: "mark2"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2, [], name, value)


                                                                class ActionMark2Info(Entity):
                                                                    """
                                                                    action mark2 info
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: value_overflow
                                                                    
                                                                    	value overflow
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..65535
                                                                    
                                                                    .. attribute:: type
                                                                    
                                                                    	type
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    .. attribute:: mark_flags
                                                                    
                                                                    	mark flags
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info, self).__init__()

                                                                        self.yang_name = "action-mark2-info"
                                                                        self.yang_parent_name = "mark2"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                            ('value_overflow', (YLeaf(YType.uint16, 'value-overflow'), ['int'])),
                                                                            ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                            ('mark_flags', (YLeaf(YType.uint8, 'mark-flags'), ['int'])),
                                                                        ])
                                                                        self.value = None
                                                                        self.value_overflow = None
                                                                        self.type = None
                                                                        self.mark_flags = None
                                                                        self._segment_path = lambda: "action-mark2-info"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info, ['value', 'value_overflow', 'type', 'mark_flags'], name, value)


                                                            class Wred(Entity):
                                                                """
                                                                wred
                                                                
                                                                .. attribute:: action_wred_info
                                                                
                                                                	action wred info
                                                                	**type**\: list of  		 :py:class:`ActionWredInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred, self).__init__()

                                                                    self.yang_name = "wred"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("action-wred-info", ("action_wred_info", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo))])
                                                                    self._leafs = OrderedDict()

                                                                    self.action_wred_info = YList(self)
                                                                    self._segment_path = lambda: "wred"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred, [], name, value)


                                                                class ActionWredInfo(Entity):
                                                                    """
                                                                    action wred info
                                                                    
                                                                    .. attribute:: match_ranges
                                                                    
                                                                    	match ranges
                                                                    	**type**\:  :py:class:`MatchRanges <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges>`
                                                                    
                                                                    .. attribute:: min_threshold
                                                                    
                                                                    	min threshold
                                                                    	**type**\:  :py:class:`MinThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold>`
                                                                    
                                                                    .. attribute:: max_threshold
                                                                    
                                                                    	max threshold
                                                                    	**type**\:  :py:class:`MaxThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold>`
                                                                    
                                                                    .. attribute:: type
                                                                    
                                                                    	cos/prec/dscp/ based WRED
                                                                    	**type**\:  :py:class:`WredTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.WredTypeEn>`
                                                                    
                                                                    .. attribute:: wred_flags
                                                                    
                                                                    	wred flags
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: probability
                                                                    
                                                                    	probability
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo, self).__init__()

                                                                        self.yang_name = "action-wred-info"
                                                                        self.yang_parent_name = "wred"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("match-ranges", ("match_ranges", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges)), ("min-threshold", ("min_threshold", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold)), ("max-threshold", ("max_threshold", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold))])
                                                                        self._leafs = OrderedDict([
                                                                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'WredTypeEn', '')])),
                                                                            ('wred_flags', (YLeaf(YType.uint32, 'wred-flags'), ['int'])),
                                                                            ('probability', (YLeaf(YType.uint32, 'probability'), ['int'])),
                                                                        ])
                                                                        self.type = None
                                                                        self.wred_flags = None
                                                                        self.probability = None

                                                                        self.match_ranges = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges()
                                                                        self.match_ranges.parent = self
                                                                        self._children_name_map["match_ranges"] = "match-ranges"

                                                                        self.min_threshold = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold()
                                                                        self.min_threshold.parent = self
                                                                        self._children_name_map["min_threshold"] = "min-threshold"

                                                                        self.max_threshold = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold()
                                                                        self.max_threshold.parent = self
                                                                        self._children_name_map["max_threshold"] = "max-threshold"
                                                                        self._segment_path = lambda: "action-wred-info"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo, ['type', 'wred_flags', 'probability'], name, value)


                                                                    class MatchRanges(Entity):
                                                                        """
                                                                        match ranges
                                                                        
                                                                        .. attribute:: uint8_rng_array
                                                                        
                                                                        	uint8 rng array
                                                                        	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges, self).__init__()

                                                                            self.yang_name = "match-ranges"
                                                                            self.yang_parent_name = "action-wred-info"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.uint8_rng_array = YList(self)
                                                                            self._segment_path = lambda: "match-ranges"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges, [], name, value)


                                                                        class Uint8RngArray(Entity):
                                                                            """
                                                                            uint8 rng array
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray, self).__init__()

                                                                                self.yang_name = "uint8_rng_array"
                                                                                self.yang_parent_name = "match-ranges"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                    ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                ])
                                                                                self.min = None
                                                                                self.max = None
                                                                                self._segment_path = lambda: "uint8_rng_array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray, ['min', 'max'], name, value)


                                                                    class MinThreshold(Entity):
                                                                        """
                                                                        min threshold
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold, self).__init__()

                                                                            self.yang_name = "min-threshold"
                                                                            self.yang_parent_name = "action-wred-info"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                            ])
                                                                            self.value = None
                                                                            self.unit = None
                                                                            self._segment_path = lambda: "min-threshold"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold, ['value', 'unit'], name, value)


                                                                    class MaxThreshold(Entity):
                                                                        """
                                                                        max threshold
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold, self).__init__()

                                                                            self.yang_name = "max-threshold"
                                                                            self.yang_parent_name = "action-wred-info"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                            ])
                                                                            self.value = None
                                                                            self.unit = None
                                                                            self._segment_path = lambda: "max-threshold"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold, ['value', 'unit'], name, value)


                                                            class Encap(Entity):
                                                                """
                                                                encap
                                                                
                                                                .. attribute:: seq
                                                                
                                                                	seq
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..255
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap, self).__init__()

                                                                    self.yang_name = "encap"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('seq', (YLeaf(YType.uint8, 'seq'), ['int'])),
                                                                    ])
                                                                    self.seq = None
                                                                    self._segment_path = lambda: "encap"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap, ['seq'], name, value)


                                                            class Prio(Entity):
                                                                """
                                                                prio
                                                                
                                                                .. attribute:: prio_lvl
                                                                
                                                                	prio lvl
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio, self).__init__()

                                                                    self.yang_name = "prio"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('prio_lvl', (YLeaf(YType.uint32, 'prio-lvl'), ['int'])),
                                                                    ])
                                                                    self.prio_lvl = None
                                                                    self._segment_path = lambda: "prio"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio, ['prio_lvl'], name, value)


                                                            class Bwrem(Entity):
                                                                """
                                                                bwrem
                                                                
                                                                .. attribute:: bwrem
                                                                
                                                                	bwrem
                                                                	**type**\:  :py:class:`Bwrem_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem_>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem, self).__init__()

                                                                    self.yang_name = "bwrem"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("bwrem", ("bwrem", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem_))])
                                                                    self._leafs = OrderedDict()

                                                                    self.bwrem = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem_()
                                                                    self.bwrem.parent = self
                                                                    self._children_name_map["bwrem"] = "bwrem"
                                                                    self._segment_path = lambda: "bwrem"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem, [], name, value)


                                                                class Bwrem_(Entity):
                                                                    """
                                                                    bwrem
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem_, self).__init__()

                                                                        self.yang_name = "bwrem"
                                                                        self.yang_parent_name = "bwrem"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                        ])
                                                                        self.value = None
                                                                        self.unit = None
                                                                        self._segment_path = lambda: "bwrem"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem_, ['value', 'unit'], name, value)


                                                            class MinBw(Entity):
                                                                """
                                                                min bw
                                                                
                                                                .. attribute:: bw
                                                                
                                                                	bw
                                                                	**type**\:  :py:class:`Bw <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw, self).__init__()

                                                                    self.yang_name = "min-bw"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("bw", ("bw", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw))])
                                                                    self._leafs = OrderedDict()

                                                                    self.bw = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw()
                                                                    self.bw.parent = self
                                                                    self._children_name_map["bw"] = "bw"
                                                                    self._segment_path = lambda: "min-bw"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw, [], name, value)


                                                                class Bw(Entity):
                                                                    """
                                                                    bw
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw, self).__init__()

                                                                        self.yang_name = "bw"
                                                                        self.yang_parent_name = "min-bw"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                        ])
                                                                        self.value = None
                                                                        self.unit = None
                                                                        self._segment_path = lambda: "bw"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw, ['value', 'unit'], name, value)


                                                            class AuthenAaa(Entity):
                                                                """
                                                                authen aaa
                                                                
                                                                .. attribute:: aaa_list_name
                                                                
                                                                	aaa list name
                                                                	**type**\: str
                                                                
                                                                .. attribute:: authen_password
                                                                
                                                                	authen password
                                                                	**type**\: str
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa, self).__init__()

                                                                    self.yang_name = "authen-aaa"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                        ('authen_password', (YLeaf(YType.str, 'authen-password'), ['str'])),
                                                                    ])
                                                                    self.aaa_list_name = None
                                                                    self.authen_password = None
                                                                    self._segment_path = lambda: "authen-aaa"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa, ['aaa_list_name', 'authen_password'], name, value)


                                                            class CollectId(Entity):
                                                                """
                                                                collect id
                                                                
                                                                .. attribute:: id
                                                                
                                                                	id
                                                                	**type**\:  :py:class:`IdentifierEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.IdentifierEn>`
                                                                
                                                                .. attribute:: aaa_list_name
                                                                
                                                                	aaa list name
                                                                	**type**\: str
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId, self).__init__()

                                                                    self.yang_name = "collect-id"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('id', (YLeaf(YType.enumeration, 'id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'IdentifierEn', '')])),
                                                                        ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                    ])
                                                                    self.id = None
                                                                    self.aaa_list_name = None
                                                                    self._segment_path = lambda: "collect-id"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId, ['id', 'aaa_list_name'], name, value)


                                                            class DecodeId(Entity):
                                                                """
                                                                decode id
                                                                
                                                                .. attribute:: id
                                                                
                                                                	id
                                                                	**type**\:  :py:class:`DecodeIdentifierEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.DecodeIdentifierEn>`
                                                                
                                                                .. attribute:: format_name
                                                                
                                                                	format name
                                                                	**type**\: str
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId, self).__init__()

                                                                    self.yang_name = "decode-id"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('id', (YLeaf(YType.enumeration, 'id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'DecodeIdentifierEn', '')])),
                                                                        ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                    ])
                                                                    self.id = None
                                                                    self.format_name = None
                                                                    self._segment_path = lambda: "decode-id"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId, ['id', 'format_name'], name, value)


                                                            class SetTimer(Entity):
                                                                """
                                                                set timer
                                                                
                                                                .. attribute:: timer_name
                                                                
                                                                	timer name
                                                                	**type**\: str
                                                                
                                                                .. attribute:: duration
                                                                
                                                                	duration
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: absolute_time
                                                                
                                                                	absolute time
                                                                	**type**\: str
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer, self).__init__()

                                                                    self.yang_name = "set-timer"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('timer_name', (YLeaf(YType.str, 'timer-name'), ['str'])),
                                                                        ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                                        ('absolute_time', (YLeaf(YType.str, 'absolute-time'), ['str'])),
                                                                    ])
                                                                    self.timer_name = None
                                                                    self.duration = None
                                                                    self.absolute_time = None
                                                                    self._segment_path = lambda: "set-timer"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer, ['timer_name', 'duration', 'absolute_time'], name, value)


                                                            class StopTimer(Entity):
                                                                """
                                                                stop timer
                                                                
                                                                .. attribute:: timer_name
                                                                
                                                                	timer name
                                                                	**type**\: str
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer, self).__init__()

                                                                    self.yang_name = "stop-timer"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('timer_name', (YLeaf(YType.str, 'timer-name'), ['str'])),
                                                                    ])
                                                                    self.timer_name = None
                                                                    self._segment_path = lambda: "stop-timer"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer, ['timer_name'], name, value)


                                                            class AcctAaaList(Entity):
                                                                """
                                                                acct aaa list
                                                                
                                                                .. attribute:: aaa_list_name
                                                                
                                                                	aaa list name
                                                                	**type**\: str
                                                                
                                                                .. attribute:: secs
                                                                
                                                                	secs
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList, self).__init__()

                                                                    self.yang_name = "acct-aaa-list"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                        ('secs', (YLeaf(YType.uint32, 'secs'), ['int'])),
                                                                    ])
                                                                    self.aaa_list_name = None
                                                                    self.secs = None
                                                                    self._segment_path = lambda: "acct-aaa-list"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList, ['aaa_list_name', 'secs'], name, value)


                                                            class QueryAncp(Entity):
                                                                """
                                                                query ancp
                                                                
                                                                .. attribute:: enable
                                                                
                                                                	enable
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..255
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp, self).__init__()

                                                                    self.yang_name = "query-ancp"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('enable', (YLeaf(YType.uint8, 'enable'), ['int'])),
                                                                    ])
                                                                    self.enable = None
                                                                    self._segment_path = lambda: "query-ancp"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp, ['enable'], name, value)


                                                            class PrepaidCfg(Entity):
                                                                """
                                                                prepaid cfg
                                                                
                                                                .. attribute:: prepaid_config_profile_name
                                                                
                                                                	prepaid config profile name
                                                                	**type**\: str
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg, self).__init__()

                                                                    self.yang_name = "prepaid-cfg"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('prepaid_config_profile_name', (YLeaf(YType.str, 'prepaid-config-profile-name'), ['str'])),
                                                                    ])
                                                                    self.prepaid_config_profile_name = None
                                                                    self._segment_path = lambda: "prepaid-cfg"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg, ['prepaid_config_profile_name'], name, value)


                                                            class TimeoutIdle(Entity):
                                                                """
                                                                timeout idle
                                                                
                                                                .. attribute:: secs
                                                                
                                                                	secs
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle, self).__init__()

                                                                    self.yang_name = "timeout-idle"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('secs', (YLeaf(YType.uint32, 'secs'), ['int'])),
                                                                    ])
                                                                    self.secs = None
                                                                    self._segment_path = lambda: "timeout-idle"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle, ['secs'], name, value)


                                                            class ProxyAaa(Entity):
                                                                """
                                                                proxy aaa
                                                                
                                                                .. attribute:: aaa_list_name
                                                                
                                                                	aaa list name
                                                                	**type**\: str
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa, self).__init__()

                                                                    self.yang_name = "proxy-aaa"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                    ])
                                                                    self.aaa_list_name = None
                                                                    self._segment_path = lambda: "proxy-aaa"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa, ['aaa_list_name'], name, value)


                                                            class ActTemplate(Entity):
                                                                """
                                                                act template
                                                                
                                                                .. attribute:: template_name
                                                                
                                                                	template name
                                                                	**type**\: str
                                                                
                                                                .. attribute:: aaa_list_name
                                                                
                                                                	aaa list name
                                                                	**type**\: str
                                                                
                                                                .. attribute:: flags
                                                                
                                                                	flags
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate, self).__init__()

                                                                    self.yang_name = "act-template"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('template_name', (YLeaf(YType.str, 'template-name'), ['str'])),
                                                                        ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                        ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                    ])
                                                                    self.template_name = None
                                                                    self.aaa_list_name = None
                                                                    self.flags = None
                                                                    self._segment_path = lambda: "act-template"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate, ['template_name', 'aaa_list_name', 'flags'], name, value)


                                                            class DeactTemplate(Entity):
                                                                """
                                                                deact template
                                                                
                                                                .. attribute:: template_name
                                                                
                                                                	template name
                                                                	**type**\: str
                                                                
                                                                .. attribute:: aaa_list_name
                                                                
                                                                	aaa list name
                                                                	**type**\: str
                                                                
                                                                .. attribute:: flags
                                                                
                                                                	flags
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate, self).__init__()

                                                                    self.yang_name = "deact-template"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('template_name', (YLeaf(YType.str, 'template-name'), ['str'])),
                                                                        ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                        ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                    ])
                                                                    self.template_name = None
                                                                    self.aaa_list_name = None
                                                                    self.flags = None
                                                                    self._segment_path = lambda: "deact-template"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate, ['template_name', 'aaa_list_name', 'flags'], name, value)


                                                            class Qlimit(Entity):
                                                                """
                                                                qlimit
                                                                
                                                                .. attribute:: action_qlimit_info_array
                                                                
                                                                	action qlimit info array
                                                                	**type**\: list of  		 :py:class:`ActionQlimitInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit, self).__init__()

                                                                    self.yang_name = "qlimit"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("action-qlimit-info-array", ("action_qlimit_info_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray))])
                                                                    self._leafs = OrderedDict()

                                                                    self.action_qlimit_info_array = YList(self)
                                                                    self._segment_path = lambda: "qlimit"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit, [], name, value)


                                                                class ActionQlimitInfoArray(Entity):
                                                                    """
                                                                    action qlimit info array
                                                                    
                                                                    .. attribute:: qlim
                                                                    
                                                                    	qlim
                                                                    	**type**\:  :py:class:`Qlim <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim>`
                                                                    
                                                                    .. attribute:: atmclp_qlim
                                                                    
                                                                    	atmclp qlim
                                                                    	**type**\:  :py:class:`AtmclpQlim <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim>`
                                                                    
                                                                    .. attribute:: match_values
                                                                    
                                                                    	match values
                                                                    	**type**\:  :py:class:`MatchValues <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues>`
                                                                    
                                                                    .. attribute:: type
                                                                    
                                                                    	type
                                                                    	**type**\:  :py:class:`QlimitTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.QlimitTypeEn>`
                                                                    
                                                                    .. attribute:: qlimit_flags
                                                                    
                                                                    	qlimit flags
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray, self).__init__()

                                                                        self.yang_name = "action-qlimit-info-array"
                                                                        self.yang_parent_name = "qlimit"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("qlim", ("qlim", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim)), ("atmclp-qlim", ("atmclp_qlim", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim)), ("match-values", ("match_values", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues))])
                                                                        self._leafs = OrderedDict([
                                                                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'QlimitTypeEn', '')])),
                                                                            ('qlimit_flags', (YLeaf(YType.uint32, 'qlimit-flags'), ['int'])),
                                                                        ])
                                                                        self.type = None
                                                                        self.qlimit_flags = None

                                                                        self.qlim = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim()
                                                                        self.qlim.parent = self
                                                                        self._children_name_map["qlim"] = "qlim"

                                                                        self.atmclp_qlim = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim()
                                                                        self.atmclp_qlim.parent = self
                                                                        self._children_name_map["atmclp_qlim"] = "atmclp-qlim"

                                                                        self.match_values = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues()
                                                                        self.match_values.parent = self
                                                                        self._children_name_map["match_values"] = "match-values"
                                                                        self._segment_path = lambda: "action-qlimit-info-array"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray, ['type', 'qlimit_flags'], name, value)


                                                                    class Qlim(Entity):
                                                                        """
                                                                        qlim
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim, self).__init__()

                                                                            self.yang_name = "qlim"
                                                                            self.yang_parent_name = "action-qlimit-info-array"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                            ])
                                                                            self.value = None
                                                                            self.unit = None
                                                                            self._segment_path = lambda: "qlim"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim, ['value', 'unit'], name, value)


                                                                    class AtmclpQlim(Entity):
                                                                        """
                                                                        atmclp qlim
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim, self).__init__()

                                                                            self.yang_name = "atmclp-qlim"
                                                                            self.yang_parent_name = "action-qlimit-info-array"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                            ])
                                                                            self.value = None
                                                                            self.unit = None
                                                                            self._segment_path = lambda: "atmclp-qlim"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim, ['value', 'unit'], name, value)


                                                                    class MatchValues(Entity):
                                                                        """
                                                                        match values
                                                                        
                                                                        .. attribute:: uint8_rng_array
                                                                        
                                                                        	uint8 rng array
                                                                        	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues, self).__init__()

                                                                            self.yang_name = "match-values"
                                                                            self.yang_parent_name = "action-qlimit-info-array"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.uint8_rng_array = YList(self)
                                                                            self._segment_path = lambda: "match-values"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues, [], name, value)


                                                                        class Uint8RngArray(Entity):
                                                                            """
                                                                            uint8 rng array
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray, self).__init__()

                                                                                self.yang_name = "uint8_rng_array"
                                                                                self.yang_parent_name = "match-values"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                    ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                ])
                                                                                self.min = None
                                                                                self.max = None
                                                                                self._segment_path = lambda: "uint8_rng_array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray, ['min', 'max'], name, value)


                                                            class AccountingEventAaa(Entity):
                                                                """
                                                                accounting event aaa
                                                                
                                                                .. attribute:: action
                                                                
                                                                	action
                                                                	**type**\:  :py:class:`AcctEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.AcctEn>`
                                                                
                                                                .. attribute:: aaa_list_name
                                                                
                                                                	aaa list name
                                                                	**type**\: str
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa, self).__init__()

                                                                    self.yang_name = "accounting-event-aaa"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('action', (YLeaf(YType.enumeration, 'action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'AcctEn', '')])),
                                                                        ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                    ])
                                                                    self.action = None
                                                                    self.aaa_list_name = None
                                                                    self._segment_path = lambda: "accounting-event-aaa"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa, ['action', 'aaa_list_name'], name, value)


                                                            class AuthorizeId(Entity):
                                                                """
                                                                authorize id
                                                                
                                                                .. attribute:: id
                                                                
                                                                	id
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..255
                                                                
                                                                .. attribute:: aaa_list_name
                                                                
                                                                	aaa list name
                                                                	**type**\: str
                                                                
                                                                .. attribute:: format_name
                                                                
                                                                	format name
                                                                	**type**\: str
                                                                
                                                                .. attribute:: password
                                                                
                                                                	password
                                                                	**type**\: str
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId, self).__init__()

                                                                    self.yang_name = "authorize-id"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('id', (YLeaf(YType.uint8, 'id'), ['int'])),
                                                                        ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                        ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                        ('password', (YLeaf(YType.str, 'password'), ['str'])),
                                                                    ])
                                                                    self.id = None
                                                                    self.aaa_list_name = None
                                                                    self.format_name = None
                                                                    self.password = None
                                                                    self._segment_path = lambda: "authorize-id"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId, ['id', 'aaa_list_name', 'format_name', 'password'], name, value)


                                                            class AfmReact(Entity):
                                                                """
                                                                afm react
                                                                
                                                                .. attribute:: action_afmon_react_info
                                                                
                                                                	action afmon react info
                                                                	**type**\: list of  		 :py:class:`ActionAfmonReactInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact, self).__init__()

                                                                    self.yang_name = "afm-react"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("action-afmon-react-info", ("action_afmon_react_info", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo))])
                                                                    self._leafs = OrderedDict()

                                                                    self.action_afmon_react_info = YList(self)
                                                                    self._segment_path = lambda: "afm-react"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact, [], name, value)


                                                                class ActionAfmonReactInfo(Entity):
                                                                    """
                                                                    action afmon react info
                                                                    
                                                                    .. attribute:: oper_id
                                                                    
                                                                    	React Operation ID
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: description
                                                                    
                                                                    	Describing the oper
                                                                    	**type**\: str
                                                                    
                                                                    .. attribute:: trig_num_intvls
                                                                    
                                                                    	Averaged over N intvls
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: clone_ifh
                                                                    
                                                                    	Clone interface handle
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: notif_actns
                                                                    
                                                                    	Bitmap of actions on alert
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    .. attribute:: criterion
                                                                    
                                                                    	React Criterion
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    .. attribute:: trig_type
                                                                    
                                                                    	Immediate or averaged thresh trigger
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    .. attribute:: trig_relop
                                                                    
                                                                    	Trigger LT\|LE\|GT\|GE\|Range
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    .. attribute:: trig_level_1
                                                                    
                                                                    	Trigger threshold 1/lower
                                                                    	**type**\: str
                                                                    
                                                                    .. attribute:: trig_level_2
                                                                    
                                                                    	Trigger upper threshold for range
                                                                    	**type**\: str
                                                                    
                                                                    .. attribute:: alm_grp_thresh
                                                                    
                                                                    	Num/percent in grp
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..65535
                                                                    
                                                                    	**units**\: percentage
                                                                    
                                                                    .. attribute:: alm_type
                                                                    
                                                                    	Discrete \| grouped alarm
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    .. attribute:: alm_severity
                                                                    
                                                                    	Major\|Minor\|... alarm
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo, self).__init__()

                                                                        self.yang_name = "action-afmon-react-info"
                                                                        self.yang_parent_name = "afm-react"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('oper_id', (YLeaf(YType.uint32, 'oper-id'), ['int'])),
                                                                            ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                            ('trig_num_intvls', (YLeaf(YType.uint32, 'trig-num-intvls'), ['int'])),
                                                                            ('clone_ifh', (YLeaf(YType.uint32, 'clone-ifh'), ['int'])),
                                                                            ('notif_actns', (YLeaf(YType.uint8, 'notif-actns'), ['int'])),
                                                                            ('criterion', (YLeaf(YType.uint8, 'criterion'), ['int'])),
                                                                            ('trig_type', (YLeaf(YType.uint8, 'trig-type'), ['int'])),
                                                                            ('trig_relop', (YLeaf(YType.uint8, 'trig-relop'), ['int'])),
                                                                            ('trig_level_1', (YLeaf(YType.str, 'trig-level-1'), ['str'])),
                                                                            ('trig_level_2', (YLeaf(YType.str, 'trig-level-2'), ['str'])),
                                                                            ('alm_grp_thresh', (YLeaf(YType.uint16, 'alm-grp-thresh'), ['int'])),
                                                                            ('alm_type', (YLeaf(YType.uint8, 'alm-type'), ['int'])),
                                                                            ('alm_severity', (YLeaf(YType.uint8, 'alm-severity'), ['int'])),
                                                                        ])
                                                                        self.oper_id = None
                                                                        self.description = None
                                                                        self.trig_num_intvls = None
                                                                        self.clone_ifh = None
                                                                        self.notif_actns = None
                                                                        self.criterion = None
                                                                        self.trig_type = None
                                                                        self.trig_relop = None
                                                                        self.trig_level_1 = None
                                                                        self.trig_level_2 = None
                                                                        self.alm_grp_thresh = None
                                                                        self.alm_type = None
                                                                        self.alm_severity = None
                                                                        self._segment_path = lambda: "action-afmon-react-info"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo, ['oper_id', 'description', 'trig_num_intvls', 'clone_ifh', 'notif_actns', 'criterion', 'trig_type', 'trig_relop', 'trig_level_1', 'trig_level_2', 'alm_grp_thresh', 'alm_type', 'alm_severity'], name, value)


                                                            class Httpr(Entity):
                                                                """
                                                                httpr
                                                                
                                                                .. attribute:: redirect_url
                                                                
                                                                	redirect url
                                                                	**type**\: str
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr, self).__init__()

                                                                    self.yang_name = "httpr"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('redirect_url', (YLeaf(YType.str, 'redirect-url'), ['str'])),
                                                                    ])
                                                                    self.redirect_url = None
                                                                    self._segment_path = lambda: "httpr"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr, ['redirect_url'], name, value)


                                                            class Punt(Entity):
                                                                """
                                                                punt
                                                                
                                                                .. attribute:: sn_type
                                                                
                                                                	service node ID type
                                                                	**type**\:  :py:class:`DpssSnidTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.DpssSnidTypeEn>`
                                                                
                                                                .. attribute:: sn_index
                                                                
                                                                	service node index
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: sn_name
                                                                
                                                                	service node name
                                                                	**type**\: str
                                                                
                                                                .. attribute:: app_id
                                                                
                                                                	application ID
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: local_id
                                                                
                                                                	local ID
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: vsnode_type
                                                                
                                                                	vservice node type
                                                                	**type**\:  :py:class:`VsvcServiceTypeT <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.VsvcServiceTypeT>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt, self).__init__()

                                                                    self.yang_name = "punt"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('sn_type', (YLeaf(YType.enumeration, 'sn-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'DpssSnidTypeEn', '')])),
                                                                        ('sn_index', (YLeaf(YType.uint32, 'sn-index'), ['int'])),
                                                                        ('sn_name', (YLeaf(YType.str, 'sn-name'), ['str'])),
                                                                        ('app_id', (YLeaf(YType.uint32, 'app-id'), ['int'])),
                                                                        ('local_id', (YLeaf(YType.uint32, 'local-id'), ['int'])),
                                                                        ('vsnode_type', (YLeaf(YType.enumeration, 'vsnode-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'VsvcServiceTypeT', '')])),
                                                                    ])
                                                                    self.sn_type = None
                                                                    self.sn_index = None
                                                                    self.sn_name = None
                                                                    self.app_id = None
                                                                    self.local_id = None
                                                                    self.vsnode_type = None
                                                                    self._segment_path = lambda: "punt"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt, ['sn_type', 'sn_index', 'sn_name', 'app_id', 'local_id', 'vsnode_type'], name, value)


                                                            class Copy(Entity):
                                                                """
                                                                copy
                                                                
                                                                .. attribute:: num_byte
                                                                
                                                                	number of bytes
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: sn_type
                                                                
                                                                	service node ID type
                                                                	**type**\:  :py:class:`DpssSnidTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.DpssSnidTypeEn>`
                                                                
                                                                .. attribute:: sn_index
                                                                
                                                                	service node index
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: sn_name
                                                                
                                                                	service node url
                                                                	**type**\: str
                                                                
                                                                .. attribute:: app_id
                                                                
                                                                	application ID
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: local_id
                                                                
                                                                	local ID
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: vsnode_type
                                                                
                                                                	vservice node type
                                                                	**type**\:  :py:class:`VsvcServiceTypeT <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.VsvcServiceTypeT>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy, self).__init__()

                                                                    self.yang_name = "copy"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('num_byte', (YLeaf(YType.uint32, 'num-byte'), ['int'])),
                                                                        ('sn_type', (YLeaf(YType.enumeration, 'sn-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'DpssSnidTypeEn', '')])),
                                                                        ('sn_index', (YLeaf(YType.uint32, 'sn-index'), ['int'])),
                                                                        ('sn_name', (YLeaf(YType.str, 'sn-name'), ['str'])),
                                                                        ('app_id', (YLeaf(YType.uint32, 'app-id'), ['int'])),
                                                                        ('local_id', (YLeaf(YType.uint32, 'local-id'), ['int'])),
                                                                        ('vsnode_type', (YLeaf(YType.enumeration, 'vsnode-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'VsvcServiceTypeT', '')])),
                                                                    ])
                                                                    self.num_byte = None
                                                                    self.sn_type = None
                                                                    self.sn_index = None
                                                                    self.sn_name = None
                                                                    self.app_id = None
                                                                    self.local_id = None
                                                                    self.vsnode_type = None
                                                                    self._segment_path = lambda: "copy"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy, ['num_byte', 'sn_type', 'sn_index', 'sn_name', 'app_id', 'local_id', 'vsnode_type'], name, value)


                                                            class Sfrag(Entity):
                                                                """
                                                                sfrag
                                                                
                                                                .. attribute:: name
                                                                
                                                                	Service Fragment Name
                                                                	**type**\: str
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag, self).__init__()

                                                                    self.yang_name = "sfrag"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                    ])
                                                                    self.name = None
                                                                    self._segment_path = lambda: "sfrag"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag, ['name'], name, value)


                                                            class Redirect(Entity):
                                                                """
                                                                redirect
                                                                
                                                                .. attribute:: value
                                                                
                                                                	value
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: type
                                                                
                                                                	type
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..255
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect, self).__init__()

                                                                    self.yang_name = "redirect"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                    ])
                                                                    self.value = None
                                                                    self.type = None
                                                                    self._segment_path = lambda: "redirect"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect, ['value', 'type'], name, value)


                                                            class OutIntf(Entity):
                                                                """
                                                                out intf
                                                                
                                                                .. attribute:: out_ifname
                                                                
                                                                	output interface name
                                                                	**type**\: str
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf, self).__init__()

                                                                    self.yang_name = "out-intf"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('out_ifname', (YLeaf(YType.str, 'out-ifname'), ['str'])),
                                                                    ])
                                                                    self.out_ifname = None
                                                                    self._segment_path = lambda: "out-intf"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf, ['out_ifname'], name, value)


                                                            class ServFunc(Entity):
                                                                """
                                                                serv func
                                                                
                                                                .. attribute:: path_id
                                                                
                                                                	service path id
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: service_index
                                                                
                                                                	service path index
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..255
                                                                
                                                                .. attribute:: meta_name
                                                                
                                                                	metadata name
                                                                	**type**\: str
                                                                
                                                                .. attribute:: vs_index
                                                                
                                                                	vservice index
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc, self).__init__()

                                                                    self.yang_name = "serv-func"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('path_id', (YLeaf(YType.uint32, 'path-id'), ['int'])),
                                                                        ('service_index', (YLeaf(YType.uint8, 'service-index'), ['int'])),
                                                                        ('meta_name', (YLeaf(YType.str, 'meta-name'), ['str'])),
                                                                        ('vs_index', (YLeaf(YType.uint32, 'vs-index'), ['int'])),
                                                                    ])
                                                                    self.path_id = None
                                                                    self.service_index = None
                                                                    self.meta_name = None
                                                                    self.vs_index = None
                                                                    self._segment_path = lambda: "serv-func"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc, ['path_id', 'service_index', 'meta_name', 'vs_index'], name, value)


                                                            class Police(Entity):
                                                                """
                                                                police
                                                                
                                                                .. attribute:: rate
                                                                
                                                                	rate
                                                                	**type**\:  :py:class:`Rate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate>`
                                                                
                                                                .. attribute:: burst
                                                                
                                                                	burst
                                                                	**type**\:  :py:class:`Burst <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst>`
                                                                
                                                                .. attribute:: peak_rate
                                                                
                                                                	peak rate
                                                                	**type**\:  :py:class:`PeakRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate>`
                                                                
                                                                .. attribute:: peak_burst
                                                                
                                                                	peak burst
                                                                	**type**\:  :py:class:`PeakBurst <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst>`
                                                                
                                                                .. attribute:: cdvt
                                                                
                                                                	cdvt
                                                                	**type**\:  :py:class:`Cdvt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt>`
                                                                
                                                                .. attribute:: conform_actns
                                                                
                                                                	conform actns
                                                                	**type**\:  :py:class:`ConformActns <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns>`
                                                                
                                                                .. attribute:: exceed_actns
                                                                
                                                                	exceed actns
                                                                	**type**\:  :py:class:`ExceedActns <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns>`
                                                                
                                                                .. attribute:: violate_actns
                                                                
                                                                	violate actns
                                                                	**type**\:  :py:class:`ViolateActns <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns>`
                                                                
                                                                .. attribute:: confclass_encode
                                                                
                                                                	confclass encode
                                                                	**type**\:  :py:class:`ConfclassEncode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode>`
                                                                
                                                                .. attribute:: confclass_p
                                                                
                                                                	confclass p
                                                                	**type**\:  :py:class:`ConfclassP <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP>`
                                                                
                                                                .. attribute:: excdclass_encode
                                                                
                                                                	excdclass encode
                                                                	**type**\:  :py:class:`ExcdclassEncode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode>`
                                                                
                                                                .. attribute:: excdclass_p
                                                                
                                                                	excdclass p
                                                                	**type**\:  :py:class:`ExcdclassP <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP>`
                                                                
                                                                .. attribute:: flags
                                                                
                                                                	flags
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: police_flags
                                                                
                                                                	police flags
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: sbuck_name
                                                                
                                                                	sbuck name
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..65
                                                                
                                                                .. attribute:: sbuck_type
                                                                
                                                                	sbuck type
                                                                	**type**\:  :py:class:`SharedBucketType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.SharedBucketType>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police, self).__init__()

                                                                    self.yang_name = "police"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("rate", ("rate", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate)), ("burst", ("burst", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst)), ("peak-rate", ("peak_rate", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate)), ("peak-burst", ("peak_burst", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst)), ("cdvt", ("cdvt", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt)), ("conform-actns", ("conform_actns", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns)), ("exceed-actns", ("exceed_actns", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns)), ("violate-actns", ("violate_actns", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns)), ("confclass-encode", ("confclass_encode", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode)), ("confclass-p", ("confclass_p", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP)), ("excdclass-encode", ("excdclass_encode", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode)), ("excdclass-p", ("excdclass_p", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP))])
                                                                    self._leafs = OrderedDict([
                                                                        ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                        ('police_flags', (YLeaf(YType.uint32, 'police-flags'), ['int'])),
                                                                        ('sbuck_name', (YLeaf(YType.str, 'sbuck-name'), ['str'])),
                                                                        ('sbuck_type', (YLeaf(YType.enumeration, 'sbuck-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'SharedBucketType', '')])),
                                                                    ])
                                                                    self.flags = None
                                                                    self.police_flags = None
                                                                    self.sbuck_name = None
                                                                    self.sbuck_type = None

                                                                    self.rate = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate()
                                                                    self.rate.parent = self
                                                                    self._children_name_map["rate"] = "rate"

                                                                    self.burst = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst()
                                                                    self.burst.parent = self
                                                                    self._children_name_map["burst"] = "burst"

                                                                    self.peak_rate = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate()
                                                                    self.peak_rate.parent = self
                                                                    self._children_name_map["peak_rate"] = "peak-rate"

                                                                    self.peak_burst = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst()
                                                                    self.peak_burst.parent = self
                                                                    self._children_name_map["peak_burst"] = "peak-burst"

                                                                    self.cdvt = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt()
                                                                    self.cdvt.parent = self
                                                                    self._children_name_map["cdvt"] = "cdvt"

                                                                    self.conform_actns = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns()
                                                                    self.conform_actns.parent = self
                                                                    self._children_name_map["conform_actns"] = "conform-actns"

                                                                    self.exceed_actns = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns()
                                                                    self.exceed_actns.parent = self
                                                                    self._children_name_map["exceed_actns"] = "exceed-actns"

                                                                    self.violate_actns = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns()
                                                                    self.violate_actns.parent = self
                                                                    self._children_name_map["violate_actns"] = "violate-actns"

                                                                    self.confclass_encode = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode()
                                                                    self.confclass_encode.parent = self
                                                                    self._children_name_map["confclass_encode"] = "confclass-encode"

                                                                    self.confclass_p = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP()
                                                                    self.confclass_p.parent = self
                                                                    self._children_name_map["confclass_p"] = "confclass-p"

                                                                    self.excdclass_encode = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode()
                                                                    self.excdclass_encode.parent = self
                                                                    self._children_name_map["excdclass_encode"] = "excdclass-encode"

                                                                    self.excdclass_p = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP()
                                                                    self.excdclass_p.parent = self
                                                                    self._children_name_map["excdclass_p"] = "excdclass-p"
                                                                    self._segment_path = lambda: "police"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police, ['flags', 'police_flags', 'sbuck_name', 'sbuck_type'], name, value)


                                                                class Rate(Entity):
                                                                    """
                                                                    rate
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate, self).__init__()

                                                                        self.yang_name = "rate"
                                                                        self.yang_parent_name = "police"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                        ])
                                                                        self.value = None
                                                                        self.unit = None
                                                                        self._segment_path = lambda: "rate"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate, ['value', 'unit'], name, value)


                                                                class Burst(Entity):
                                                                    """
                                                                    burst
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst, self).__init__()

                                                                        self.yang_name = "burst"
                                                                        self.yang_parent_name = "police"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                        ])
                                                                        self.value = None
                                                                        self.unit = None
                                                                        self._segment_path = lambda: "burst"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst, ['value', 'unit'], name, value)


                                                                class PeakRate(Entity):
                                                                    """
                                                                    peak rate
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate, self).__init__()

                                                                        self.yang_name = "peak-rate"
                                                                        self.yang_parent_name = "police"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                        ])
                                                                        self.value = None
                                                                        self.unit = None
                                                                        self._segment_path = lambda: "peak-rate"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate, ['value', 'unit'], name, value)


                                                                class PeakBurst(Entity):
                                                                    """
                                                                    peak burst
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst, self).__init__()

                                                                        self.yang_name = "peak-burst"
                                                                        self.yang_parent_name = "police"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                        ])
                                                                        self.value = None
                                                                        self.unit = None
                                                                        self._segment_path = lambda: "peak-burst"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst, ['value', 'unit'], name, value)


                                                                class Cdvt(Entity):
                                                                    """
                                                                    cdvt
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt, self).__init__()

                                                                        self.yang_name = "cdvt"
                                                                        self.yang_parent_name = "police"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                        ])
                                                                        self.value = None
                                                                        self.unit = None
                                                                        self._segment_path = lambda: "cdvt"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt, ['value', 'unit'], name, value)


                                                                class ConformActns(Entity):
                                                                    """
                                                                    conform actns
                                                                    
                                                                    .. attribute:: police_action_array
                                                                    
                                                                    	police action array
                                                                    	**type**\: list of  		 :py:class:`PoliceActionArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns, self).__init__()

                                                                        self.yang_name = "conform-actns"
                                                                        self.yang_parent_name = "police"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("police-action-array", ("police_action_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray))])
                                                                        self._leafs = OrderedDict()

                                                                        self.police_action_array = YList(self)
                                                                        self._segment_path = lambda: "conform-actns"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns, [], name, value)


                                                                    class PoliceActionArray(Entity):
                                                                        """
                                                                        police action array
                                                                        
                                                                        .. attribute:: mark
                                                                        
                                                                        	mark
                                                                        	**type**\:  :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark>`
                                                                        
                                                                        .. attribute:: type
                                                                        
                                                                        	type
                                                                        	**type**\:  :py:class:`PoliceActionTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PoliceActionTypeEn>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray, self).__init__()

                                                                            self.yang_name = "police-action-array"
                                                                            self.yang_parent_name = "conform-actns"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("mark", ("mark", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark))])
                                                                            self._leafs = OrderedDict([
                                                                                ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PoliceActionTypeEn', '')])),
                                                                            ])
                                                                            self.type = None

                                                                            self.mark = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark()
                                                                            self.mark.parent = self
                                                                            self._children_name_map["mark"] = "mark"
                                                                            self._segment_path = lambda: "police-action-array"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray, ['type'], name, value)


                                                                        class Mark(Entity):
                                                                            """
                                                                            mark
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:  :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                            
                                                                            .. attribute:: mark_flags
                                                                            
                                                                            	mark flags
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark, self).__init__()

                                                                                self.yang_name = "mark"
                                                                                self.yang_parent_name = "police-action-array"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MarkTypeEn', '')])),
                                                                                    ('mark_flags', (YLeaf(YType.uint32, 'mark-flags'), ['int'])),
                                                                                    ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                ])
                                                                                self.type = None
                                                                                self.mark_flags = None
                                                                                self.value = None
                                                                                self._segment_path = lambda: "mark"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark, ['type', 'mark_flags', 'value'], name, value)


                                                                class ExceedActns(Entity):
                                                                    """
                                                                    exceed actns
                                                                    
                                                                    .. attribute:: police_action_array
                                                                    
                                                                    	police action array
                                                                    	**type**\: list of  		 :py:class:`PoliceActionArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns, self).__init__()

                                                                        self.yang_name = "exceed-actns"
                                                                        self.yang_parent_name = "police"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("police-action-array", ("police_action_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray))])
                                                                        self._leafs = OrderedDict()

                                                                        self.police_action_array = YList(self)
                                                                        self._segment_path = lambda: "exceed-actns"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns, [], name, value)


                                                                    class PoliceActionArray(Entity):
                                                                        """
                                                                        police action array
                                                                        
                                                                        .. attribute:: mark
                                                                        
                                                                        	mark
                                                                        	**type**\:  :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark>`
                                                                        
                                                                        .. attribute:: type
                                                                        
                                                                        	type
                                                                        	**type**\:  :py:class:`PoliceActionTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PoliceActionTypeEn>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray, self).__init__()

                                                                            self.yang_name = "police-action-array"
                                                                            self.yang_parent_name = "exceed-actns"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("mark", ("mark", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark))])
                                                                            self._leafs = OrderedDict([
                                                                                ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PoliceActionTypeEn', '')])),
                                                                            ])
                                                                            self.type = None

                                                                            self.mark = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark()
                                                                            self.mark.parent = self
                                                                            self._children_name_map["mark"] = "mark"
                                                                            self._segment_path = lambda: "police-action-array"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray, ['type'], name, value)


                                                                        class Mark(Entity):
                                                                            """
                                                                            mark
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:  :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                            
                                                                            .. attribute:: mark_flags
                                                                            
                                                                            	mark flags
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark, self).__init__()

                                                                                self.yang_name = "mark"
                                                                                self.yang_parent_name = "police-action-array"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MarkTypeEn', '')])),
                                                                                    ('mark_flags', (YLeaf(YType.uint32, 'mark-flags'), ['int'])),
                                                                                    ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                ])
                                                                                self.type = None
                                                                                self.mark_flags = None
                                                                                self.value = None
                                                                                self._segment_path = lambda: "mark"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark, ['type', 'mark_flags', 'value'], name, value)


                                                                class ViolateActns(Entity):
                                                                    """
                                                                    violate actns
                                                                    
                                                                    .. attribute:: police_action_array
                                                                    
                                                                    	police action array
                                                                    	**type**\: list of  		 :py:class:`PoliceActionArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns, self).__init__()

                                                                        self.yang_name = "violate-actns"
                                                                        self.yang_parent_name = "police"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("police-action-array", ("police_action_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray))])
                                                                        self._leafs = OrderedDict()

                                                                        self.police_action_array = YList(self)
                                                                        self._segment_path = lambda: "violate-actns"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns, [], name, value)


                                                                    class PoliceActionArray(Entity):
                                                                        """
                                                                        police action array
                                                                        
                                                                        .. attribute:: mark
                                                                        
                                                                        	mark
                                                                        	**type**\:  :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark>`
                                                                        
                                                                        .. attribute:: type
                                                                        
                                                                        	type
                                                                        	**type**\:  :py:class:`PoliceActionTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PoliceActionTypeEn>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray, self).__init__()

                                                                            self.yang_name = "police-action-array"
                                                                            self.yang_parent_name = "violate-actns"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("mark", ("mark", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark))])
                                                                            self._leafs = OrderedDict([
                                                                                ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PoliceActionTypeEn', '')])),
                                                                            ])
                                                                            self.type = None

                                                                            self.mark = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark()
                                                                            self.mark.parent = self
                                                                            self._children_name_map["mark"] = "mark"
                                                                            self._segment_path = lambda: "police-action-array"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray, ['type'], name, value)


                                                                        class Mark(Entity):
                                                                            """
                                                                            mark
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:  :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                            
                                                                            .. attribute:: mark_flags
                                                                            
                                                                            	mark flags
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark, self).__init__()

                                                                                self.yang_name = "mark"
                                                                                self.yang_parent_name = "police-action-array"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MarkTypeEn', '')])),
                                                                                    ('mark_flags', (YLeaf(YType.uint32, 'mark-flags'), ['int'])),
                                                                                    ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                ])
                                                                                self.type = None
                                                                                self.mark_flags = None
                                                                                self.value = None
                                                                                self._segment_path = lambda: "mark"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark, ['type', 'mark_flags', 'value'], name, value)


                                                                class ConfclassEncode(Entity):
                                                                    """
                                                                    confclass encode
                                                                    
                                                                    .. attribute:: inline_cmap
                                                                    
                                                                    	inline cmap
                                                                    	**type**\:  :py:class:`InlineCmap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap>`
                                                                    
                                                                    .. attribute:: enc
                                                                    
                                                                    	enc
                                                                    	**type**\:  :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                    
                                                                    .. attribute:: class_name
                                                                    
                                                                    	class name
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..65
                                                                    
                                                                    .. attribute:: hd
                                                                    
                                                                    	hd
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: idx
                                                                    
                                                                    	idx
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode, self).__init__()

                                                                        self.yang_name = "confclass-encode"
                                                                        self.yang_parent_name = "police"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("inline-cmap", ("inline_cmap", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap))])
                                                                        self._leafs = OrderedDict([
                                                                            ('enc', (YLeaf(YType.enumeration, 'enc'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyObjEncEn', '')])),
                                                                            ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                                            ('hd', (YLeaf(YType.uint64, 'hd'), ['int'])),
                                                                            ('idx', (YLeaf(YType.uint8, 'idx'), ['int'])),
                                                                        ])
                                                                        self.enc = None
                                                                        self.class_name = None
                                                                        self.hd = None
                                                                        self.idx = None

                                                                        self.inline_cmap = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap()
                                                                        self.inline_cmap.parent = self
                                                                        self._children_name_map["inline_cmap"] = "inline-cmap"
                                                                        self._segment_path = lambda: "confclass-encode"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode, ['enc', 'class_name', 'hd', 'idx'], name, value)


                                                                    class InlineCmap(Entity):
                                                                        """
                                                                        inline cmap
                                                                        
                                                                        .. attribute:: match_infop
                                                                        
                                                                        	Pointer to the first Match info
                                                                        	**type**\:  :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop>`
                                                                        
                                                                        .. attribute:: mode
                                                                        
                                                                        	Inline Class\-Map Mode Match any/all
                                                                        	**type**\:  :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                        
                                                                        .. attribute:: flags
                                                                        
                                                                        	Inline Class\-Map flags
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: match_count
                                                                        
                                                                        	Number of Match infos
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap, self).__init__()

                                                                            self.yang_name = "inline-cmap"
                                                                            self.yang_parent_name = "confclass-encode"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("match-infop", ("match_infop", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop))])
                                                                            self._leafs = OrderedDict([
                                                                                ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapModeEn', '')])),
                                                                                ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                ('match_count', (YLeaf(YType.uint32, 'match-count'), ['int'])),
                                                                            ])
                                                                            self.mode = None
                                                                            self.flags = None
                                                                            self.match_count = None

                                                                            self.match_infop = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop()
                                                                            self.match_infop.parent = self
                                                                            self._children_name_map["match_infop"] = "match-infop"
                                                                            self._segment_path = lambda: "inline-cmap"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap, ['mode', 'flags', 'match_count'], name, value)


                                                                        class MatchInfop(Entity):
                                                                            """
                                                                            Pointer to the first Match info
                                                                            
                                                                            .. attribute:: class_match_info_st
                                                                            
                                                                            	class match info st
                                                                            	**type**\: list of  		 :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop, self).__init__()

                                                                                self.yang_name = "match-infop"
                                                                                self.yang_parent_name = "inline-cmap"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("class-match-info-st", ("class_match_info_st", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt))])
                                                                                self._leafs = OrderedDict()

                                                                                self.class_match_info_st = YList(self)
                                                                                self._segment_path = lambda: "match-infop"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop, [], name, value)


                                                                            class ClassMatchInfoSt(Entity):
                                                                                """
                                                                                class match info st
                                                                                
                                                                                .. attribute:: match_data
                                                                                
                                                                                	Match criteria
                                                                                	**type**\:  :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                
                                                                                .. attribute:: flags
                                                                                
                                                                                	Flags
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                    self.yang_name = "class-match-info-st"
                                                                                    self.yang_parent_name = "match-infop"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("match-data", ("match_data", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                    ])
                                                                                    self.flags = None

                                                                                    self.match_data = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                    self.match_data.parent = self
                                                                                    self._children_name_map["match_data"] = "match-data"
                                                                                    self._segment_path = lambda: "class-match-info-st"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                class MatchData(Entity):
                                                                                    """
                                                                                    Match criteria
                                                                                    
                                                                                    .. attribute:: ipv4_dscp
                                                                                    
                                                                                    	IPv4 DSCP
                                                                                    	**type**\:  :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                    
                                                                                    .. attribute:: ipv6_dscp
                                                                                    
                                                                                    	IPv6 DSCP
                                                                                    	**type**\:  :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                    
                                                                                    .. attribute:: dscp
                                                                                    
                                                                                    	Match DSCP range array
                                                                                    	**type**\:  :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                    
                                                                                    .. attribute:: ipv4_prec
                                                                                    
                                                                                    	IPv4 Precedence
                                                                                    	**type**\:  :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                    
                                                                                    .. attribute:: ipv6_prec
                                                                                    
                                                                                    	IPv6 Precedence
                                                                                    	**type**\:  :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                    
                                                                                    .. attribute:: prec
                                                                                    
                                                                                    	Match Precedence array
                                                                                    	**type**\:  :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                    
                                                                                    .. attribute:: discard_class
                                                                                    
                                                                                    	Match Discard Class array
                                                                                    	**type**\:  :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                    
                                                                                    .. attribute:: qos_group
                                                                                    
                                                                                    	Match QoS group array
                                                                                    	**type**\:  :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                    
                                                                                    .. attribute:: traffic_class
                                                                                    
                                                                                    	Match Traffic class array
                                                                                    	**type**\:  :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                    
                                                                                    .. attribute:: proto
                                                                                    
                                                                                    	Match Protocol array
                                                                                    	**type**\:  :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                    
                                                                                    .. attribute:: icmp_v4
                                                                                    
                                                                                    	Match ICMPV4 Protocol
                                                                                    	**type**\:  :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                    
                                                                                    .. attribute:: icmp_v6
                                                                                    
                                                                                    	Match ICMPV6 Protocol array
                                                                                    	**type**\:  :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                    
                                                                                    .. attribute:: ipv4_packet_len
                                                                                    
                                                                                    	IPv4 packet length array
                                                                                    	**type**\:  :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                    
                                                                                    .. attribute:: ipv6_packet_len
                                                                                    
                                                                                    	IPv6 packet length array
                                                                                    	**type**\:  :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                    
                                                                                    .. attribute:: packet_len
                                                                                    
                                                                                    	Match packet length array
                                                                                    	**type**\:  :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                    
                                                                                    .. attribute:: flow_tag
                                                                                    
                                                                                    	Match flow\-tag array
                                                                                    	**type**\:  :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                    
                                                                                    .. attribute:: tcp_flag
                                                                                    
                                                                                    	Match tcp flag value
                                                                                    	**type**\:  :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                    
                                                                                    .. attribute:: icmpv4_type
                                                                                    
                                                                                    	Match ipv4 icmp type
                                                                                    	**type**\:  :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                    
                                                                                    .. attribute:: icmpv4_code
                                                                                    
                                                                                    	Match ipv4 icmp code
                                                                                    	**type**\:  :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                    
                                                                                    .. attribute:: icmpv6_type
                                                                                    
                                                                                    	Match ipv6 icmp type
                                                                                    	**type**\:  :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                    
                                                                                    .. attribute:: icmpv6_code
                                                                                    
                                                                                    	Match ipv6 icmp code
                                                                                    	**type**\:  :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                    
                                                                                    .. attribute:: mpls_exp
                                                                                    
                                                                                    	Match MPLS experimental topmost array
                                                                                    	**type**\:  :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                    
                                                                                    .. attribute:: mpls_exp_imp
                                                                                    
                                                                                    	Match MPLS experimental imposition array
                                                                                    	**type**\:  :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                    
                                                                                    .. attribute:: mpls_disp_ipv4_acl
                                                                                    
                                                                                    	MPLS Disposition IPv4 Access\-list
                                                                                    	**type**\:  :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                    
                                                                                    .. attribute:: mpls_disp_ipv6_acl
                                                                                    
                                                                                    	MPLS Disposition IPv6 Access\-list
                                                                                    	**type**\:  :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                    
                                                                                    .. attribute:: mpls_top_label
                                                                                    
                                                                                    	MPLS Topmost LABEL
                                                                                    	**type**\:  :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                    
                                                                                    .. attribute:: cos
                                                                                    
                                                                                    	Match CoS array
                                                                                    	**type**\:  :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                    
                                                                                    .. attribute:: cos_inr
                                                                                    
                                                                                    	Match inner header CoS
                                                                                    	**type**\:  :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                    
                                                                                    .. attribute:: dei
                                                                                    
                                                                                    	Match DEI Bit
                                                                                    	**type**\:  :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                    
                                                                                    .. attribute:: dei_inr
                                                                                    
                                                                                    	Match inner DEI Bit
                                                                                    	**type**\:  :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                    
                                                                                    .. attribute:: vlan
                                                                                    
                                                                                    	Match VLAN array
                                                                                    	**type**\:  :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                    
                                                                                    .. attribute:: vlan_inr
                                                                                    
                                                                                    	Match inner header VLAN range array
                                                                                    	**type**\:  :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                    
                                                                                    .. attribute:: fr_dlci
                                                                                    
                                                                                    	Match FR DLCI range array
                                                                                    	**type**\:  :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                    
                                                                                    .. attribute:: src_mac
                                                                                    
                                                                                    	Match Source MAC address
                                                                                    	**type**\:  :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                    
                                                                                    .. attribute:: dst_mac
                                                                                    
                                                                                    	Match Destination MAC address
                                                                                    	**type**\:  :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                    
                                                                                    .. attribute:: atm_clp
                                                                                    
                                                                                    	Match ATM CLP level
                                                                                    	**type**\:  :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                    
                                                                                    .. attribute:: fr_de
                                                                                    
                                                                                    	Match FR DE value
                                                                                    	**type**\:  :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                    
                                                                                    .. attribute:: ipv4_acl
                                                                                    
                                                                                    	IPv4 Access\-list
                                                                                    	**type**\:  :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                    
                                                                                    .. attribute:: ipv6_acl
                                                                                    
                                                                                    	IPv6 Access\-list
                                                                                    	**type**\:  :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                    
                                                                                    .. attribute:: ether_service_acl
                                                                                    
                                                                                    	Ethernet\-Services Access\-list
                                                                                    	**type**\:  :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                    
                                                                                    .. attribute:: avail_id
                                                                                    
                                                                                    	Available Identifiers
                                                                                    	**type**\:  :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                    
                                                                                    .. attribute:: media_type
                                                                                    
                                                                                    	Media Type
                                                                                    	**type**\:  :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                    
                                                                                    .. attribute:: subs_protocol
                                                                                    
                                                                                    	Protocol
                                                                                    	**type**\:  :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                    
                                                                                    .. attribute:: dnis
                                                                                    
                                                                                    	DNIS
                                                                                    	**type**\:  :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                    
                                                                                    .. attribute:: dnis_regex
                                                                                    
                                                                                    	DNIS Regular Expression
                                                                                    	**type**\:  :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                    
                                                                                    .. attribute:: domain
                                                                                    
                                                                                    	Domain Name
                                                                                    	**type**\:  :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                    
                                                                                    .. attribute:: domain_regex
                                                                                    
                                                                                    	Domain Regular Expression
                                                                                    	**type**\:  :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                    
                                                                                    .. attribute:: nas_port
                                                                                    
                                                                                    	NAS Port
                                                                                    	**type**\:  :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                    
                                                                                    .. attribute:: service_name
                                                                                    
                                                                                    	Service Name
                                                                                    	**type**\:  :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                    
                                                                                    .. attribute:: service_name_regex
                                                                                    
                                                                                    	Service Name Regular Exp
                                                                                    	**type**\:  :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                    
                                                                                    .. attribute:: src_addr_ipv4
                                                                                    
                                                                                    	Source Address IPV4
                                                                                    	**type**\:  :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                    
                                                                                    .. attribute:: dst_addr_ipv4
                                                                                    
                                                                                    	Destination Address IPV4
                                                                                    	**type**\:  :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                    
                                                                                    .. attribute:: src_addr_ipv6
                                                                                    
                                                                                    	Source Address IPV6
                                                                                    	**type**\:  :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                    
                                                                                    .. attribute:: dst_addr_ipv6
                                                                                    
                                                                                    	Destination Address IPV6
                                                                                    	**type**\:  :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                    
                                                                                    .. attribute:: src_addr_mac
                                                                                    
                                                                                    	Source Address MAC
                                                                                    	**type**\:  :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                    
                                                                                    .. attribute:: timer
                                                                                    
                                                                                    	Timer
                                                                                    	**type**\:  :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                    
                                                                                    .. attribute:: timer_regexp
                                                                                    
                                                                                    	Timer Regular Expression
                                                                                    	**type**\:  :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                    
                                                                                    .. attribute:: tunnel_name
                                                                                    
                                                                                    	Tunnel Name
                                                                                    	**type**\:  :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                    
                                                                                    .. attribute:: tunnel_name_regex
                                                                                    
                                                                                    	Tunnel Name Regular Expression
                                                                                    	**type**\:  :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                    
                                                                                    .. attribute:: user_name
                                                                                    
                                                                                    	User Name
                                                                                    	**type**\:  :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                    
                                                                                    .. attribute:: user_name_regex
                                                                                    
                                                                                    	User Name Regular Expression
                                                                                    	**type**\:  :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                    
                                                                                    .. attribute:: auth_username
                                                                                    
                                                                                    	Authenticated User Name
                                                                                    	**type**\:  :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                    
                                                                                    .. attribute:: auth_username_regex
                                                                                    
                                                                                    	Authenticated User Name RegEx
                                                                                    	**type**\:  :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                    
                                                                                    .. attribute:: unauth_username
                                                                                    
                                                                                    	Unauthenticated User Name
                                                                                    	**type**\:  :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                    
                                                                                    .. attribute:: unauth_username_regex
                                                                                    
                                                                                    	Unauthenticated User Name RegEx
                                                                                    	**type**\:  :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                    
                                                                                    .. attribute:: auth_domain
                                                                                    
                                                                                    	Authenticated domain name
                                                                                    	**type**\:  :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                    
                                                                                    .. attribute:: auth_domain_regex
                                                                                    
                                                                                    	Authenticated Domain Name RegEx
                                                                                    	**type**\:  :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                    
                                                                                    .. attribute:: unauth_domain
                                                                                    
                                                                                    	Unauthenticated Domain Name
                                                                                    	**type**\:  :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                    
                                                                                    .. attribute:: unauth_domain_regex
                                                                                    
                                                                                    	Unauthenticated Domain Name RegEx
                                                                                    	**type**\:  :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                    
                                                                                    .. attribute:: vendor_id
                                                                                    
                                                                                    	Vendor ID
                                                                                    	**type**\:  :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                    
                                                                                    .. attribute:: vendor_id_regex
                                                                                    
                                                                                    	Vendor ID RegEx
                                                                                    	**type**\:  :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                    
                                                                                    .. attribute:: access_interface
                                                                                    
                                                                                    	Access interface
                                                                                    	**type**\:  :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                    
                                                                                    .. attribute:: input_interface
                                                                                    
                                                                                    	Input interface
                                                                                    	**type**\:  :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                    
                                                                                    .. attribute:: input_intfhdl
                                                                                    
                                                                                    	Input interface handle
                                                                                    	**type**\:  :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                    
                                                                                    .. attribute:: ethertype
                                                                                    
                                                                                    	Ethernet type
                                                                                    	**type**\:  :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                    
                                                                                    .. attribute:: flow_key_data
                                                                                    
                                                                                    	Flow key structure
                                                                                    	**type**\:  :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                    
                                                                                    .. attribute:: dhcp_client_id
                                                                                    
                                                                                    	Dhcp Client ID
                                                                                    	**type**\:  :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                    
                                                                                    .. attribute:: dhcp_client_id_regex
                                                                                    
                                                                                    	Dhcp Client ID RegEx
                                                                                    	**type**\:  :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                    
                                                                                    .. attribute:: circuit_id
                                                                                    
                                                                                    	Circuit ID
                                                                                    	**type**\:  :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                    
                                                                                    .. attribute:: circuit_id_regex
                                                                                    
                                                                                    	Circuit ID RegEx
                                                                                    	**type**\:  :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                    
                                                                                    .. attribute:: remote_id
                                                                                    
                                                                                    	Remote ID
                                                                                    	**type**\:  :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                    
                                                                                    .. attribute:: remote_id_regex
                                                                                    
                                                                                    	Remote ID RegEx
                                                                                    	**type**\:  :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                    
                                                                                    .. attribute:: src_port
                                                                                    
                                                                                    	Source port
                                                                                    	**type**\:  :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                    
                                                                                    .. attribute:: dst_port
                                                                                    
                                                                                    	Destination port
                                                                                    	**type**\:  :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	type
                                                                                    	**type**\:  :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                    
                                                                                    .. attribute:: mpls_top_eos
                                                                                    
                                                                                    	MPLS Topmost EOS
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: fragment_type
                                                                                    
                                                                                    	Fragment type
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: authen_status
                                                                                    
                                                                                    	Authentication Status
                                                                                    	**type**\:  :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                    
                                                                                    .. attribute:: mlp_negotiated
                                                                                    
                                                                                    	MLP Negotiated
                                                                                    	**type**\:  :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                        self.yang_name = "match-data"
                                                                                        self.yang_parent_name = "class-match-info-st"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("ipv4-dscp", ("ipv4_dscp", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp)), ("ipv6-dscp", ("ipv6_dscp", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp)), ("dscp", ("dscp", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp)), ("ipv4-prec", ("ipv4_prec", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec)), ("ipv6-prec", ("ipv6_prec", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec)), ("prec", ("prec", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec)), ("discard-class", ("discard_class", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass)), ("qos-group", ("qos_group", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup)), ("traffic-class", ("traffic_class", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass)), ("proto", ("proto", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto)), ("icmp-v4", ("icmp_v4", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4)), ("icmp-v6", ("icmp_v6", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6)), ("ipv4-packet-len", ("ipv4_packet_len", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen)), ("ipv6-packet-len", ("ipv6_packet_len", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen)), ("packet-len", ("packet_len", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen)), ("flow-tag", ("flow_tag", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag)), ("tcp-flag", ("tcp_flag", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag)), ("icmpv4-type", ("icmpv4_type", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type)), ("icmpv4-code", ("icmpv4_code", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code)), ("icmpv6-type", ("icmpv6_type", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type)), ("icmpv6-code", ("icmpv6_code", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code)), ("mpls-exp", ("mpls_exp", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp)), ("mpls-exp-imp", ("mpls_exp_imp", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp)), ("mpls-disp-ipv4-acl", ("mpls_disp_ipv4_acl", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl)), ("mpls-disp-ipv6-acl", ("mpls_disp_ipv6_acl", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl)), ("mpls-top-label", ("mpls_top_label", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel)), ("cos", ("cos", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos)), ("cos-inr", ("cos_inr", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr)), ("dei", ("dei", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei)), ("dei-inr", ("dei_inr", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr)), ("vlan", ("vlan", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan)), ("vlan-inr", ("vlan_inr", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)), ("fr-dlci", ("fr_dlci", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci)), ("src-mac", ("src_mac", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac)), ("dst-mac", ("dst_mac", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac)), ("atm-clp", ("atm_clp", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp)), ("fr-de", ("fr_de", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe)), ("ipv4-acl", ("ipv4_acl", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl)), ("ipv6-acl", ("ipv6_acl", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl)), ("ether-service-acl", ("ether_service_acl", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl)), ("avail-id", ("avail_id", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId)), ("media-type", ("media_type", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType)), ("subs-protocol", ("subs_protocol", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol)), ("dnis", ("dnis", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis)), ("dnis-regex", ("dnis_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex)), ("domain", ("domain", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain)), ("domain-regex", ("domain_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex)), ("nas-port", ("nas_port", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort)), ("service-name", ("service_name", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName)), ("service-name-regex", ("service_name_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex)), ("src-addr-ipv4", ("src_addr_ipv4", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4)), ("dst-addr-ipv4", ("dst_addr_ipv4", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4)), ("src-addr-ipv6", ("src_addr_ipv6", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6)), ("dst-addr-ipv6", ("dst_addr_ipv6", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6)), ("src-addr-mac", ("src_addr_mac", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac)), ("timer", ("timer", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer)), ("timer-regexp", ("timer_regexp", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp)), ("tunnel-name", ("tunnel_name", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName)), ("tunnel-name-regex", ("tunnel_name_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex)), ("user-name", ("user_name", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName)), ("user-name-regex", ("user_name_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex)), ("auth-username", ("auth_username", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername)), ("auth-username-regex", ("auth_username_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex)), ("unauth-username", ("unauth_username", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername)), ("unauth-username-regex", ("unauth_username_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex)), ("auth-domain", ("auth_domain", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain)), ("auth-domain-regex", ("auth_domain_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex)), ("unauth-domain", ("unauth_domain", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain)), ("unauth-domain-regex", ("unauth_domain_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex)), ("vendor-id", ("vendor_id", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId)), ("vendor-id-regex", ("vendor_id_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex)), ("access-interface", ("access_interface", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface)), ("input-interface", ("input_interface", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface)), ("input-intfhdl", ("input_intfhdl", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl)), ("ethertype", ("ethertype", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype)), ("flow-key-data", ("flow_key_data", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData)), ("dhcp-client-id", ("dhcp_client_id", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId)), ("dhcp-client-id-regex", ("dhcp_client_id_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex)), ("circuit-id", ("circuit_id", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId)), ("circuit-id-regex", ("circuit_id_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex)), ("remote-id", ("remote_id", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId)), ("remote-id-regex", ("remote_id_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex)), ("src-port", ("src_port", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort)), ("dst-port", ("dst_port", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort))])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchTypeEn', '')])),
                                                                                            ('mpls_top_eos', (YLeaf(YType.uint8, 'mpls-top-eos'), ['int'])),
                                                                                            ('fragment_type', (YLeaf(YType.uint8, 'fragment-type'), ['int'])),
                                                                                            ('authen_status', (YLeaf(YType.enumeration, 'authen-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchAuthenStatusEn', '')])),
                                                                                            ('mlp_negotiated', (YLeaf(YType.enumeration, 'mlp-negotiated'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchMlpNegotiatedEn', '')])),
                                                                                        ])
                                                                                        self.type = None
                                                                                        self.mpls_top_eos = None
                                                                                        self.fragment_type = None
                                                                                        self.authen_status = None
                                                                                        self.mlp_negotiated = None

                                                                                        self.ipv4_dscp = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                        self.ipv4_dscp.parent = self
                                                                                        self._children_name_map["ipv4_dscp"] = "ipv4-dscp"

                                                                                        self.ipv6_dscp = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                        self.ipv6_dscp.parent = self
                                                                                        self._children_name_map["ipv6_dscp"] = "ipv6-dscp"

                                                                                        self.dscp = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                        self.dscp.parent = self
                                                                                        self._children_name_map["dscp"] = "dscp"

                                                                                        self.ipv4_prec = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                        self.ipv4_prec.parent = self
                                                                                        self._children_name_map["ipv4_prec"] = "ipv4-prec"

                                                                                        self.ipv6_prec = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                        self.ipv6_prec.parent = self
                                                                                        self._children_name_map["ipv6_prec"] = "ipv6-prec"

                                                                                        self.prec = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                        self.prec.parent = self
                                                                                        self._children_name_map["prec"] = "prec"

                                                                                        self.discard_class = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                        self.discard_class.parent = self
                                                                                        self._children_name_map["discard_class"] = "discard-class"

                                                                                        self.qos_group = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                        self.qos_group.parent = self
                                                                                        self._children_name_map["qos_group"] = "qos-group"

                                                                                        self.traffic_class = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                        self.traffic_class.parent = self
                                                                                        self._children_name_map["traffic_class"] = "traffic-class"

                                                                                        self.proto = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                        self.proto.parent = self
                                                                                        self._children_name_map["proto"] = "proto"

                                                                                        self.icmp_v4 = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                        self.icmp_v4.parent = self
                                                                                        self._children_name_map["icmp_v4"] = "icmp-v4"

                                                                                        self.icmp_v6 = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                        self.icmp_v6.parent = self
                                                                                        self._children_name_map["icmp_v6"] = "icmp-v6"

                                                                                        self.ipv4_packet_len = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                        self.ipv4_packet_len.parent = self
                                                                                        self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"

                                                                                        self.ipv6_packet_len = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                        self.ipv6_packet_len.parent = self
                                                                                        self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"

                                                                                        self.packet_len = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                        self.packet_len.parent = self
                                                                                        self._children_name_map["packet_len"] = "packet-len"

                                                                                        self.flow_tag = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                        self.flow_tag.parent = self
                                                                                        self._children_name_map["flow_tag"] = "flow-tag"

                                                                                        self.tcp_flag = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                        self.tcp_flag.parent = self
                                                                                        self._children_name_map["tcp_flag"] = "tcp-flag"

                                                                                        self.icmpv4_type = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                        self.icmpv4_type.parent = self
                                                                                        self._children_name_map["icmpv4_type"] = "icmpv4-type"

                                                                                        self.icmpv4_code = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                        self.icmpv4_code.parent = self
                                                                                        self._children_name_map["icmpv4_code"] = "icmpv4-code"

                                                                                        self.icmpv6_type = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                        self.icmpv6_type.parent = self
                                                                                        self._children_name_map["icmpv6_type"] = "icmpv6-type"

                                                                                        self.icmpv6_code = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                        self.icmpv6_code.parent = self
                                                                                        self._children_name_map["icmpv6_code"] = "icmpv6-code"

                                                                                        self.mpls_exp = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                        self.mpls_exp.parent = self
                                                                                        self._children_name_map["mpls_exp"] = "mpls-exp"

                                                                                        self.mpls_exp_imp = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                        self.mpls_exp_imp.parent = self
                                                                                        self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"

                                                                                        self.mpls_disp_ipv4_acl = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                        self.mpls_disp_ipv4_acl.parent = self
                                                                                        self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"

                                                                                        self.mpls_disp_ipv6_acl = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                        self.mpls_disp_ipv6_acl.parent = self
                                                                                        self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"

                                                                                        self.mpls_top_label = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                        self.mpls_top_label.parent = self
                                                                                        self._children_name_map["mpls_top_label"] = "mpls-top-label"

                                                                                        self.cos = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                        self.cos.parent = self
                                                                                        self._children_name_map["cos"] = "cos"

                                                                                        self.cos_inr = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                        self.cos_inr.parent = self
                                                                                        self._children_name_map["cos_inr"] = "cos-inr"

                                                                                        self.dei = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                        self.dei.parent = self
                                                                                        self._children_name_map["dei"] = "dei"

                                                                                        self.dei_inr = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                        self.dei_inr.parent = self
                                                                                        self._children_name_map["dei_inr"] = "dei-inr"

                                                                                        self.vlan = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                        self.vlan.parent = self
                                                                                        self._children_name_map["vlan"] = "vlan"

                                                                                        self.vlan_inr = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                        self.vlan_inr.parent = self
                                                                                        self._children_name_map["vlan_inr"] = "vlan-inr"

                                                                                        self.fr_dlci = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                        self.fr_dlci.parent = self
                                                                                        self._children_name_map["fr_dlci"] = "fr-dlci"

                                                                                        self.src_mac = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                        self.src_mac.parent = self
                                                                                        self._children_name_map["src_mac"] = "src-mac"

                                                                                        self.dst_mac = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                        self.dst_mac.parent = self
                                                                                        self._children_name_map["dst_mac"] = "dst-mac"

                                                                                        self.atm_clp = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                        self.atm_clp.parent = self
                                                                                        self._children_name_map["atm_clp"] = "atm-clp"

                                                                                        self.fr_de = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                        self.fr_de.parent = self
                                                                                        self._children_name_map["fr_de"] = "fr-de"

                                                                                        self.ipv4_acl = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                        self.ipv4_acl.parent = self
                                                                                        self._children_name_map["ipv4_acl"] = "ipv4-acl"

                                                                                        self.ipv6_acl = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                        self.ipv6_acl.parent = self
                                                                                        self._children_name_map["ipv6_acl"] = "ipv6-acl"

                                                                                        self.ether_service_acl = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                        self.ether_service_acl.parent = self
                                                                                        self._children_name_map["ether_service_acl"] = "ether-service-acl"

                                                                                        self.avail_id = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                        self.avail_id.parent = self
                                                                                        self._children_name_map["avail_id"] = "avail-id"

                                                                                        self.media_type = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                        self.media_type.parent = self
                                                                                        self._children_name_map["media_type"] = "media-type"

                                                                                        self.subs_protocol = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                        self.subs_protocol.parent = self
                                                                                        self._children_name_map["subs_protocol"] = "subs-protocol"

                                                                                        self.dnis = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                        self.dnis.parent = self
                                                                                        self._children_name_map["dnis"] = "dnis"

                                                                                        self.dnis_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                        self.dnis_regex.parent = self
                                                                                        self._children_name_map["dnis_regex"] = "dnis-regex"

                                                                                        self.domain = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                        self.domain.parent = self
                                                                                        self._children_name_map["domain"] = "domain"

                                                                                        self.domain_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                        self.domain_regex.parent = self
                                                                                        self._children_name_map["domain_regex"] = "domain-regex"

                                                                                        self.nas_port = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                        self.nas_port.parent = self
                                                                                        self._children_name_map["nas_port"] = "nas-port"

                                                                                        self.service_name = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                        self.service_name.parent = self
                                                                                        self._children_name_map["service_name"] = "service-name"

                                                                                        self.service_name_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                        self.service_name_regex.parent = self
                                                                                        self._children_name_map["service_name_regex"] = "service-name-regex"

                                                                                        self.src_addr_ipv4 = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                        self.src_addr_ipv4.parent = self
                                                                                        self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"

                                                                                        self.dst_addr_ipv4 = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                        self.dst_addr_ipv4.parent = self
                                                                                        self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"

                                                                                        self.src_addr_ipv6 = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                        self.src_addr_ipv6.parent = self
                                                                                        self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"

                                                                                        self.dst_addr_ipv6 = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                        self.dst_addr_ipv6.parent = self
                                                                                        self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"

                                                                                        self.src_addr_mac = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                        self.src_addr_mac.parent = self
                                                                                        self._children_name_map["src_addr_mac"] = "src-addr-mac"

                                                                                        self.timer = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                        self.timer.parent = self
                                                                                        self._children_name_map["timer"] = "timer"

                                                                                        self.timer_regexp = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                        self.timer_regexp.parent = self
                                                                                        self._children_name_map["timer_regexp"] = "timer-regexp"

                                                                                        self.tunnel_name = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                        self.tunnel_name.parent = self
                                                                                        self._children_name_map["tunnel_name"] = "tunnel-name"

                                                                                        self.tunnel_name_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                        self.tunnel_name_regex.parent = self
                                                                                        self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"

                                                                                        self.user_name = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                        self.user_name.parent = self
                                                                                        self._children_name_map["user_name"] = "user-name"

                                                                                        self.user_name_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                        self.user_name_regex.parent = self
                                                                                        self._children_name_map["user_name_regex"] = "user-name-regex"

                                                                                        self.auth_username = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                        self.auth_username.parent = self
                                                                                        self._children_name_map["auth_username"] = "auth-username"

                                                                                        self.auth_username_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                        self.auth_username_regex.parent = self
                                                                                        self._children_name_map["auth_username_regex"] = "auth-username-regex"

                                                                                        self.unauth_username = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                        self.unauth_username.parent = self
                                                                                        self._children_name_map["unauth_username"] = "unauth-username"

                                                                                        self.unauth_username_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                        self.unauth_username_regex.parent = self
                                                                                        self._children_name_map["unauth_username_regex"] = "unauth-username-regex"

                                                                                        self.auth_domain = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                        self.auth_domain.parent = self
                                                                                        self._children_name_map["auth_domain"] = "auth-domain"

                                                                                        self.auth_domain_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                        self.auth_domain_regex.parent = self
                                                                                        self._children_name_map["auth_domain_regex"] = "auth-domain-regex"

                                                                                        self.unauth_domain = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                        self.unauth_domain.parent = self
                                                                                        self._children_name_map["unauth_domain"] = "unauth-domain"

                                                                                        self.unauth_domain_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                        self.unauth_domain_regex.parent = self
                                                                                        self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"

                                                                                        self.vendor_id = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                        self.vendor_id.parent = self
                                                                                        self._children_name_map["vendor_id"] = "vendor-id"

                                                                                        self.vendor_id_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                        self.vendor_id_regex.parent = self
                                                                                        self._children_name_map["vendor_id_regex"] = "vendor-id-regex"

                                                                                        self.access_interface = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                        self.access_interface.parent = self
                                                                                        self._children_name_map["access_interface"] = "access-interface"

                                                                                        self.input_interface = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                        self.input_interface.parent = self
                                                                                        self._children_name_map["input_interface"] = "input-interface"

                                                                                        self.input_intfhdl = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                        self.input_intfhdl.parent = self
                                                                                        self._children_name_map["input_intfhdl"] = "input-intfhdl"

                                                                                        self.ethertype = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                        self.ethertype.parent = self
                                                                                        self._children_name_map["ethertype"] = "ethertype"

                                                                                        self.flow_key_data = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                        self.flow_key_data.parent = self
                                                                                        self._children_name_map["flow_key_data"] = "flow-key-data"

                                                                                        self.dhcp_client_id = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                        self.dhcp_client_id.parent = self
                                                                                        self._children_name_map["dhcp_client_id"] = "dhcp-client-id"

                                                                                        self.dhcp_client_id_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                        self.dhcp_client_id_regex.parent = self
                                                                                        self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"

                                                                                        self.circuit_id = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                        self.circuit_id.parent = self
                                                                                        self._children_name_map["circuit_id"] = "circuit-id"

                                                                                        self.circuit_id_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                        self.circuit_id_regex.parent = self
                                                                                        self._children_name_map["circuit_id_regex"] = "circuit-id-regex"

                                                                                        self.remote_id = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                        self.remote_id.parent = self
                                                                                        self._children_name_map["remote_id"] = "remote-id"

                                                                                        self.remote_id_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                        self.remote_id_regex.parent = self
                                                                                        self._children_name_map["remote_id_regex"] = "remote-id-regex"

                                                                                        self.src_port = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                        self.src_port.parent = self
                                                                                        self._children_name_map["src_port"] = "src-port"

                                                                                        self.dst_port = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                        self.dst_port.parent = self
                                                                                        self._children_name_map["dst_port"] = "dst-port"
                                                                                        self._segment_path = lambda: "match-data"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, ['type', 'mpls_top_eos', 'fragment_type', 'authen_status', 'mlp_negotiated'], name, value)


                                                                                    class Ipv4Dscp(Entity):
                                                                                        """
                                                                                        IPv4 DSCP
                                                                                        
                                                                                        .. attribute:: uint8_rng_array
                                                                                        
                                                                                        	uint8 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                            self.yang_name = "ipv4-dscp"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint8_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "ipv4-dscp"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                        class Uint8RngArray(Entity):
                                                                                            """
                                                                                            uint8 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                self.yang_name = "uint8_rng_array"
                                                                                                self.yang_parent_name = "ipv4-dscp"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint8_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                    class Ipv6Dscp(Entity):
                                                                                        """
                                                                                        IPv6 DSCP
                                                                                        
                                                                                        .. attribute:: uint8_rng_array
                                                                                        
                                                                                        	uint8 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                            self.yang_name = "ipv6-dscp"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint8_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "ipv6-dscp"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                        class Uint8RngArray(Entity):
                                                                                            """
                                                                                            uint8 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                self.yang_name = "uint8_rng_array"
                                                                                                self.yang_parent_name = "ipv6-dscp"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint8_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                    class Dscp(Entity):
                                                                                        """
                                                                                        Match DSCP range array
                                                                                        
                                                                                        .. attribute:: uint8_rng_array
                                                                                        
                                                                                        	uint8 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                            self.yang_name = "dscp"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint8_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "dscp"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                        class Uint8RngArray(Entity):
                                                                                            """
                                                                                            uint8 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                self.yang_name = "uint8_rng_array"
                                                                                                self.yang_parent_name = "dscp"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint8_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                    class Ipv4Prec(Entity):
                                                                                        """
                                                                                        IPv4 Precedence
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                            self.yang_name = "ipv4-prec"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                            ])
                                                                                            self.uint8_array = []
                                                                                            self._segment_path = lambda: "ipv4-prec"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                    class Ipv6Prec(Entity):
                                                                                        """
                                                                                        IPv6 Precedence
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                            self.yang_name = "ipv6-prec"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                            ])
                                                                                            self.uint8_array = []
                                                                                            self._segment_path = lambda: "ipv6-prec"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                    class Prec(Entity):
                                                                                        """
                                                                                        Match Precedence array
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                            self.yang_name = "prec"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                            ])
                                                                                            self.uint8_array = []
                                                                                            self._segment_path = lambda: "prec"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                    class DiscardClass(Entity):
                                                                                        """
                                                                                        Match Discard Class array
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                            self.yang_name = "discard-class"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                            ])
                                                                                            self.uint8_array = []
                                                                                            self._segment_path = lambda: "discard-class"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                    class QosGroup(Entity):
                                                                                        """
                                                                                        Match QoS group array
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                            self.yang_name = "qos-group"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "qos-group"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "qos-group"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint16_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['min', 'max'], name, value)


                                                                                    class TrafficClass(Entity):
                                                                                        """
                                                                                        Match Traffic class array
                                                                                        
                                                                                        .. attribute:: uint8_rng_array
                                                                                        
                                                                                        	uint8 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                            self.yang_name = "traffic-class"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint8_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "traffic-class"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                        class Uint8RngArray(Entity):
                                                                                            """
                                                                                            uint8 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                self.yang_name = "uint8_rng_array"
                                                                                                self.yang_parent_name = "traffic-class"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint8_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['min', 'max'], name, value)


                                                                                    class Proto(Entity):
                                                                                        """
                                                                                        Match Protocol array
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                            self.yang_name = "proto"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "proto"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "proto"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint16_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['min', 'max'], name, value)


                                                                                    class IcmpV4(Entity):
                                                                                        """
                                                                                        Match ICMPV4 Protocol
                                                                                        
                                                                                        .. attribute:: type
                                                                                        
                                                                                        	Protocol type
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: code
                                                                                        
                                                                                        	Protocol code
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                            self.yang_name = "icmp-v4"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                            ])
                                                                                            self.type = None
                                                                                            self.code = None
                                                                                            self._segment_path = lambda: "icmp-v4"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['type', 'code'], name, value)


                                                                                    class IcmpV6(Entity):
                                                                                        """
                                                                                        Match ICMPV6 Protocol array
                                                                                        
                                                                                        .. attribute:: type
                                                                                        
                                                                                        	Protocol type
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: code
                                                                                        
                                                                                        	Protocol code
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                            self.yang_name = "icmp-v6"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                            ])
                                                                                            self.type = None
                                                                                            self.code = None
                                                                                            self._segment_path = lambda: "icmp-v6"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['type', 'code'], name, value)


                                                                                    class Ipv4PacketLen(Entity):
                                                                                        """
                                                                                        IPv4 packet length array
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                            self.yang_name = "ipv4-packet-len"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "ipv4-packet-len"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "ipv4-packet-len"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint16_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                    class Ipv6PacketLen(Entity):
                                                                                        """
                                                                                        IPv6 packet length array
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                            self.yang_name = "ipv6-packet-len"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "ipv6-packet-len"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "ipv6-packet-len"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint16_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                    class PacketLen(Entity):
                                                                                        """
                                                                                        Match packet length array
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                            self.yang_name = "packet-len"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "packet-len"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "packet-len"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint16_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                    class FlowTag(Entity):
                                                                                        """
                                                                                        Match flow\-tag array
                                                                                        
                                                                                        .. attribute:: uint8_rng_array
                                                                                        
                                                                                        	uint8 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                            self.yang_name = "flow-tag"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint8_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "flow-tag"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                        class Uint8RngArray(Entity):
                                                                                            """
                                                                                            uint8 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                self.yang_name = "uint8_rng_array"
                                                                                                self.yang_parent_name = "flow-tag"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint8_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['min', 'max'], name, value)


                                                                                    class TcpFlag(Entity):
                                                                                        """
                                                                                        Match tcp flag value
                                                                                        
                                                                                        .. attribute:: value
                                                                                        
                                                                                        	Value of TCP flag
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: match_any
                                                                                        
                                                                                        	Match any TCP flag bit
                                                                                        	**type**\: bool
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                            self.yang_name = "tcp-flag"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                                ('match_any', (YLeaf(YType.boolean, 'match-any'), ['bool'])),
                                                                                            ])
                                                                                            self.value = None
                                                                                            self.match_any = None
                                                                                            self._segment_path = lambda: "tcp-flag"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['value', 'match_any'], name, value)


                                                                                    class Icmpv4Type(Entity):
                                                                                        """
                                                                                        Match ipv4 icmp type
                                                                                        
                                                                                        .. attribute:: uint8_rng_array
                                                                                        
                                                                                        	uint8 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                            self.yang_name = "icmpv4-type"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint8_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "icmpv4-type"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                        class Uint8RngArray(Entity):
                                                                                            """
                                                                                            uint8 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                self.yang_name = "uint8_rng_array"
                                                                                                self.yang_parent_name = "icmpv4-type"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint8_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                    class Icmpv4Code(Entity):
                                                                                        """
                                                                                        Match ipv4 icmp code
                                                                                        
                                                                                        .. attribute:: uint8_rng_array
                                                                                        
                                                                                        	uint8 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                            self.yang_name = "icmpv4-code"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint8_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "icmpv4-code"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                        class Uint8RngArray(Entity):
                                                                                            """
                                                                                            uint8 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                self.yang_name = "uint8_rng_array"
                                                                                                self.yang_parent_name = "icmpv4-code"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint8_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                    class Icmpv6Type(Entity):
                                                                                        """
                                                                                        Match ipv6 icmp type
                                                                                        
                                                                                        .. attribute:: uint8_rng_array
                                                                                        
                                                                                        	uint8 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                            self.yang_name = "icmpv6-type"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint8_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "icmpv6-type"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                        class Uint8RngArray(Entity):
                                                                                            """
                                                                                            uint8 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                self.yang_name = "uint8_rng_array"
                                                                                                self.yang_parent_name = "icmpv6-type"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint8_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                    class Icmpv6Code(Entity):
                                                                                        """
                                                                                        Match ipv6 icmp code
                                                                                        
                                                                                        .. attribute:: uint8_rng_array
                                                                                        
                                                                                        	uint8 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                            self.yang_name = "icmpv6-code"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint8_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "icmpv6-code"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                        class Uint8RngArray(Entity):
                                                                                            """
                                                                                            uint8 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                self.yang_name = "uint8_rng_array"
                                                                                                self.yang_parent_name = "icmpv6-code"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint8_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                    class MplsExp(Entity):
                                                                                        """
                                                                                        Match MPLS experimental topmost array
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                            self.yang_name = "mpls-exp"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                            ])
                                                                                            self.uint8_array = []
                                                                                            self._segment_path = lambda: "mpls-exp"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                    class MplsExpImp(Entity):
                                                                                        """
                                                                                        Match MPLS experimental imposition array
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                            self.yang_name = "mpls-exp-imp"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                            ])
                                                                                            self.uint8_array = []
                                                                                            self._segment_path = lambda: "mpls-exp-imp"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                    class MplsDispIpv4Acl(Entity):
                                                                                        """
                                                                                        MPLS Disposition IPv4 Access\-list
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                            self.yang_name = "mpls-disp-ipv4-acl"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "mpls-disp-ipv4-acl"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                    class MplsDispIpv6Acl(Entity):
                                                                                        """
                                                                                        MPLS Disposition IPv6 Access\-list
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                            self.yang_name = "mpls-disp-ipv6-acl"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "mpls-disp-ipv6-acl"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                    class MplsTopLabel(Entity):
                                                                                        """
                                                                                        MPLS Topmost LABEL
                                                                                        
                                                                                        .. attribute:: uint32_rng_array
                                                                                        
                                                                                        	uint32 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                            self.yang_name = "mpls-top-label"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint32_rng_array", ("uint32_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint32_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "mpls-top-label"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                        class Uint32RngArray(Entity):
                                                                                            """
                                                                                            uint32 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                self.yang_name = "uint32_rng_array"
                                                                                                self.yang_parent_name = "mpls-top-label"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint32, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint32, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint32_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['min', 'max'], name, value)


                                                                                    class Cos(Entity):
                                                                                        """
                                                                                        Match CoS array
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                            self.yang_name = "cos"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                            ])
                                                                                            self.uint8_array = []
                                                                                            self._segment_path = lambda: "cos"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                    class CosInr(Entity):
                                                                                        """
                                                                                        Match inner header CoS
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                            self.yang_name = "cos-inr"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                            ])
                                                                                            self.uint8_array = []
                                                                                            self._segment_path = lambda: "cos-inr"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                    class Dei(Entity):
                                                                                        """
                                                                                        Match DEI Bit
                                                                                        
                                                                                        .. attribute:: bit_value
                                                                                        
                                                                                        	Value of the DEI bit
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                            self.yang_name = "dei"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                            ])
                                                                                            self.bit_value = None
                                                                                            self._segment_path = lambda: "dei"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                    class DeiInr(Entity):
                                                                                        """
                                                                                        Match inner DEI Bit
                                                                                        
                                                                                        .. attribute:: bit_value
                                                                                        
                                                                                        	Value of the DEI bit
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                            self.yang_name = "dei-inr"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                            ])
                                                                                            self.bit_value = None
                                                                                            self._segment_path = lambda: "dei-inr"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                    class Vlan(Entity):
                                                                                        """
                                                                                        Match VLAN array
                                                                                        
                                                                                        .. attribute:: vlan_id_array
                                                                                        
                                                                                        	vlan id array
                                                                                        	**type**\: list of  		 :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                            self.yang_name = "vlan"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("vlan-id-array", ("vlan_id_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.vlan_id_array = YList(self)
                                                                                            self._segment_path = lambda: "vlan"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                        class VlanIdArray(Entity):
                                                                                            """
                                                                                            vlan id array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	VLAN mask
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                self.yang_name = "vlan-id-array"
                                                                                                self.yang_parent_name = "vlan"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ('mask', (YLeaf(YType.uint16, 'mask'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self.mask = None
                                                                                                self._segment_path = lambda: "vlan-id-array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['min', 'max', 'mask'], name, value)


                                                                                    class VlanInr(Entity):
                                                                                        """
                                                                                        Match inner header VLAN range array
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                            self.yang_name = "vlan-inr"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "vlan-inr"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "vlan-inr"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint16_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['min', 'max'], name, value)


                                                                                    class FrDlci(Entity):
                                                                                        """
                                                                                        Match FR DLCI range array
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                            self.yang_name = "fr-dlci"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "fr-dlci"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "fr-dlci"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint16_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['min', 'max'], name, value)


                                                                                    class SrcMac(Entity):
                                                                                        """
                                                                                        Match Source MAC address
                                                                                        
                                                                                        .. attribute:: mac_addr
                                                                                        
                                                                                        	MAC address
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: mask
                                                                                        
                                                                                        	MAC mask
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                            self.yang_name = "src-mac"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                            ])
                                                                                            self.mac_addr = []
                                                                                            self.mask = []
                                                                                            self._segment_path = lambda: "src-mac"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                    class DstMac(Entity):
                                                                                        """
                                                                                        Match Destination MAC address
                                                                                        
                                                                                        .. attribute:: mac_addr
                                                                                        
                                                                                        	MAC address
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: mask
                                                                                        
                                                                                        	MAC mask
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                            self.yang_name = "dst-mac"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                            ])
                                                                                            self.mac_addr = []
                                                                                            self.mask = []
                                                                                            self._segment_path = lambda: "dst-mac"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                    class AtmClp(Entity):
                                                                                        """
                                                                                        Match ATM CLP level
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                            self.yang_name = "atm-clp"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                            ])
                                                                                            self.uint8_array = []
                                                                                            self._segment_path = lambda: "atm-clp"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                    class FrDe(Entity):
                                                                                        """
                                                                                        Match FR DE value
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                            self.yang_name = "fr-de"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                            ])
                                                                                            self.uint8_array = []
                                                                                            self._segment_path = lambda: "fr-de"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                    class Ipv4Acl(Entity):
                                                                                        """
                                                                                        IPv4 Access\-list
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                            self.yang_name = "ipv4-acl"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "ipv4-acl"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                    class Ipv6Acl(Entity):
                                                                                        """
                                                                                        IPv6 Access\-list
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                            self.yang_name = "ipv6-acl"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "ipv6-acl"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                    class EtherServiceAcl(Entity):
                                                                                        """
                                                                                        Ethernet\-Services Access\-list
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                            self.yang_name = "ether-service-acl"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "ether-service-acl"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                    class AvailId(Entity):
                                                                                        """
                                                                                        Available Identifiers
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                            self.yang_name = "avail-id"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                            ])
                                                                                            self.uint8_array = []
                                                                                            self._segment_path = lambda: "avail-id"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                    class MediaType(Entity):
                                                                                        """
                                                                                        Media Type
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                            self.yang_name = "media-type"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                            ])
                                                                                            self.uint8_array = []
                                                                                            self._segment_path = lambda: "media-type"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                    class SubsProtocol(Entity):
                                                                                        """
                                                                                        Protocol
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                            self.yang_name = "subs-protocol"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                            ])
                                                                                            self.uint8_array = []
                                                                                            self._segment_path = lambda: "subs-protocol"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                    class Dnis(Entity):
                                                                                        """
                                                                                        DNIS
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                            self.yang_name = "dnis"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "dnis"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                    class DnisRegex(Entity):
                                                                                        """
                                                                                        DNIS Regular Expression
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                            self.yang_name = "dnis-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "dnis-regex"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                    class Domain(Entity):
                                                                                        """
                                                                                        Domain Name
                                                                                        
                                                                                        .. attribute:: domain_array
                                                                                        
                                                                                        	domain array
                                                                                        	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                            self.yang_name = "domain"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.domain_array = YList(self)
                                                                                            self._segment_path = lambda: "domain"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                        class DomainArray(Entity):
                                                                                            """
                                                                                            domain array
                                                                                            
                                                                                            .. attribute:: domain_name
                                                                                            
                                                                                            	domain name
                                                                                            	**type**\: str
                                                                                            
                                                                                            .. attribute:: format_name
                                                                                            
                                                                                            	format name
                                                                                            	**type**\: str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                self.yang_name = "domain-array"
                                                                                                self.yang_parent_name = "domain"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                    ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                ])
                                                                                                self.domain_name = None
                                                                                                self.format_name = None
                                                                                                self._segment_path = lambda: "domain-array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                    class DomainRegex(Entity):
                                                                                        """
                                                                                        Domain Regular Expression
                                                                                        
                                                                                        .. attribute:: domain_array
                                                                                        
                                                                                        	domain array
                                                                                        	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                            self.yang_name = "domain-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.domain_array = YList(self)
                                                                                            self._segment_path = lambda: "domain-regex"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                        class DomainArray(Entity):
                                                                                            """
                                                                                            domain array
                                                                                            
                                                                                            .. attribute:: domain_name
                                                                                            
                                                                                            	domain name
                                                                                            	**type**\: str
                                                                                            
                                                                                            .. attribute:: format_name
                                                                                            
                                                                                            	format name
                                                                                            	**type**\: str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                self.yang_name = "domain-array"
                                                                                                self.yang_parent_name = "domain-regex"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                    ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                ])
                                                                                                self.domain_name = None
                                                                                                self.format_name = None
                                                                                                self._segment_path = lambda: "domain-array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                    class NasPort(Entity):
                                                                                        """
                                                                                        NAS Port
                                                                                        
                                                                                        .. attribute:: nas_port_array
                                                                                        
                                                                                        	nas port array
                                                                                        	**type**\: list of  		 :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                            self.yang_name = "nas-port"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("nas-port-array", ("nas_port_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.nas_port_array = YList(self)
                                                                                            self._segment_path = lambda: "nas-port"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                        class NasPortArray(Entity):
                                                                                            """
                                                                                            nas port array
                                                                                            
                                                                                            .. attribute:: sub_id
                                                                                            
                                                                                            	sub id
                                                                                            	**type**\:  :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                            
                                                                                            .. attribute:: operator
                                                                                            
                                                                                            	operator
                                                                                            	**type**\:  :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                            
                                                                                            .. attribute:: value
                                                                                            
                                                                                            	value
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                self.yang_name = "nas-port-array"
                                                                                                self.yang_parent_name = "nas-port"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('sub_id', (YLeaf(YType.enumeration, 'sub-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchNasPortSubIdEn', '')])),
                                                                                                    ('operator', (YLeaf(YType.enumeration, 'operator'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchLogicalOperatorEn', '')])),
                                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                                ])
                                                                                                self.sub_id = None
                                                                                                self.operator = None
                                                                                                self.value = None
                                                                                                self._segment_path = lambda: "nas-port-array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['sub_id', 'operator', 'value'], name, value)


                                                                                    class ServiceName(Entity):
                                                                                        """
                                                                                        Service Name
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                            self.yang_name = "service-name"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "service-name"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                    class ServiceNameRegex(Entity):
                                                                                        """
                                                                                        Service Name Regular Exp
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                            self.yang_name = "service-name-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "service-name-regex"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                    class SrcAddrIpv4(Entity):
                                                                                        """
                                                                                        Source Address IPV4
                                                                                        
                                                                                        .. attribute:: ipv4_addr_array
                                                                                        
                                                                                        	ipv4 addr array
                                                                                        	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                            self.yang_name = "src-addr-ipv4"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.ipv4_addr_array = YList(self)
                                                                                            self._segment_path = lambda: "src-addr-ipv4"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                        class Ipv4AddrArray(Entity):
                                                                                            """
                                                                                            ipv4 addr array
                                                                                            
                                                                                            .. attribute:: prefix
                                                                                            
                                                                                            	prefix
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	mask
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                self.yang_name = "ipv4-addr-array"
                                                                                                self.yang_parent_name = "src-addr-ipv4"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                    ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                ])
                                                                                                self.prefix = None
                                                                                                self.mask = None
                                                                                                self._segment_path = lambda: "ipv4-addr-array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                    class DstAddrIpv4(Entity):
                                                                                        """
                                                                                        Destination Address IPV4
                                                                                        
                                                                                        .. attribute:: ipv4_addr_array
                                                                                        
                                                                                        	ipv4 addr array
                                                                                        	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                            self.yang_name = "dst-addr-ipv4"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.ipv4_addr_array = YList(self)
                                                                                            self._segment_path = lambda: "dst-addr-ipv4"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                        class Ipv4AddrArray(Entity):
                                                                                            """
                                                                                            ipv4 addr array
                                                                                            
                                                                                            .. attribute:: prefix
                                                                                            
                                                                                            	prefix
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	mask
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                self.yang_name = "ipv4-addr-array"
                                                                                                self.yang_parent_name = "dst-addr-ipv4"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                    ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                ])
                                                                                                self.prefix = None
                                                                                                self.mask = None
                                                                                                self._segment_path = lambda: "ipv4-addr-array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                    class SrcAddrIpv6(Entity):
                                                                                        """
                                                                                        Source Address IPV6
                                                                                        
                                                                                        .. attribute:: ipv6_addr_array
                                                                                        
                                                                                        	ipv6 addr array
                                                                                        	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                            self.yang_name = "src-addr-ipv6"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.ipv6_addr_array = YList(self)
                                                                                            self._segment_path = lambda: "src-addr-ipv6"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                        class Ipv6AddrArray(Entity):
                                                                                            """
                                                                                            ipv6 addr array
                                                                                            
                                                                                            .. attribute:: prefix
                                                                                            
                                                                                            	IPV6 prefix
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	IPV6 mask
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                self.yang_name = "ipv6-addr-array"
                                                                                                self.yang_parent_name = "src-addr-ipv6"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                    ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                ])
                                                                                                self.prefix = None
                                                                                                self.mask = None
                                                                                                self._segment_path = lambda: "ipv6-addr-array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                    class DstAddrIpv6(Entity):
                                                                                        """
                                                                                        Destination Address IPV6
                                                                                        
                                                                                        .. attribute:: ipv6_addr_array
                                                                                        
                                                                                        	ipv6 addr array
                                                                                        	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                            self.yang_name = "dst-addr-ipv6"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.ipv6_addr_array = YList(self)
                                                                                            self._segment_path = lambda: "dst-addr-ipv6"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                        class Ipv6AddrArray(Entity):
                                                                                            """
                                                                                            ipv6 addr array
                                                                                            
                                                                                            .. attribute:: prefix
                                                                                            
                                                                                            	IPV6 prefix
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	IPV6 mask
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                self.yang_name = "ipv6-addr-array"
                                                                                                self.yang_parent_name = "dst-addr-ipv6"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                    ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                ])
                                                                                                self.prefix = None
                                                                                                self.mask = None
                                                                                                self._segment_path = lambda: "ipv6-addr-array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                    class SrcAddrMac(Entity):
                                                                                        """
                                                                                        Source Address MAC
                                                                                        
                                                                                        .. attribute:: mac_addr_array
                                                                                        
                                                                                        	mac addr array
                                                                                        	**type**\: list of  		 :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                            self.yang_name = "src-addr-mac"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("mac-addr-array", ("mac_addr_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.mac_addr_array = YList(self)
                                                                                            self._segment_path = lambda: "src-addr-mac"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                        class MacAddrArray(Entity):
                                                                                            """
                                                                                            mac addr array
                                                                                            
                                                                                            .. attribute:: mac_addr
                                                                                            
                                                                                            	MAC address
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	MAC mask
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                self.yang_name = "mac-addr-array"
                                                                                                self.yang_parent_name = "src-addr-mac"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                    ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                ])
                                                                                                self.mac_addr = []
                                                                                                self.mask = []
                                                                                                self._segment_path = lambda: "mac-addr-array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                    class Timer(Entity):
                                                                                        """
                                                                                        Timer
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                            self.yang_name = "timer"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "timer"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                    class TimerRegexp(Entity):
                                                                                        """
                                                                                        Timer Regular Expression
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                            self.yang_name = "timer-regexp"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "timer-regexp"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                    class TunnelName(Entity):
                                                                                        """
                                                                                        Tunnel Name
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                            self.yang_name = "tunnel-name"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "tunnel-name"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                    class TunnelNameRegex(Entity):
                                                                                        """
                                                                                        Tunnel Name Regular Expression
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                            self.yang_name = "tunnel-name-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "tunnel-name-regex"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                    class UserName(Entity):
                                                                                        """
                                                                                        User Name
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                            self.yang_name = "user-name"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "user-name"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                    class UserNameRegex(Entity):
                                                                                        """
                                                                                        User Name Regular Expression
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                            self.yang_name = "user-name-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "user-name-regex"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                    class AuthUsername(Entity):
                                                                                        """
                                                                                        Authenticated User Name
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                            self.yang_name = "auth-username"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "auth-username"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                    class AuthUsernameRegex(Entity):
                                                                                        """
                                                                                        Authenticated User Name RegEx
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                            self.yang_name = "auth-username-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "auth-username-regex"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                    class UnauthUsername(Entity):
                                                                                        """
                                                                                        Unauthenticated User Name
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                            self.yang_name = "unauth-username"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "unauth-username"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                    class UnauthUsernameRegex(Entity):
                                                                                        """
                                                                                        Unauthenticated User Name RegEx
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                            self.yang_name = "unauth-username-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "unauth-username-regex"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                    class AuthDomain(Entity):
                                                                                        """
                                                                                        Authenticated domain name
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                            self.yang_name = "auth-domain"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "auth-domain"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                    class AuthDomainRegex(Entity):
                                                                                        """
                                                                                        Authenticated Domain Name RegEx
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                            self.yang_name = "auth-domain-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "auth-domain-regex"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                    class UnauthDomain(Entity):
                                                                                        """
                                                                                        Unauthenticated Domain Name
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                            self.yang_name = "unauth-domain"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "unauth-domain"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                    class UnauthDomainRegex(Entity):
                                                                                        """
                                                                                        Unauthenticated Domain Name RegEx
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                            self.yang_name = "unauth-domain-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "unauth-domain-regex"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                    class VendorId(Entity):
                                                                                        """
                                                                                        Vendor ID
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                            self.yang_name = "vendor-id"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "vendor-id"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                    class VendorIdRegex(Entity):
                                                                                        """
                                                                                        Vendor ID RegEx
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                            self.yang_name = "vendor-id-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "vendor-id-regex"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                    class AccessInterface(Entity):
                                                                                        """
                                                                                        Access interface
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                            self.yang_name = "access-interface"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "access-interface"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                    class InputInterface(Entity):
                                                                                        """
                                                                                        Input interface
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                            self.yang_name = "input-interface"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "input-interface"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                    class InputIntfhdl(Entity):
                                                                                        """
                                                                                        Input interface handle
                                                                                        
                                                                                        .. attribute:: uint64_array
                                                                                        
                                                                                        	uint64 array
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..18446744073709551615
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                            self.yang_name = "input-intfhdl"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('uint64_array', (YLeafList(YType.uint64, 'uint64_array'), ['int'])),
                                                                                            ])
                                                                                            self.uint64_array = []
                                                                                            self._segment_path = lambda: "input-intfhdl"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                    class Ethertype(Entity):
                                                                                        """
                                                                                        Ethernet type
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                            self.yang_name = "ethertype"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "ethertype"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "ethertype"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint16_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['min', 'max'], name, value)


                                                                                    class FlowKeyData(Entity):
                                                                                        """
                                                                                        Flow key structure
                                                                                        
                                                                                        .. attribute:: flow_keys
                                                                                        
                                                                                        	flow keys
                                                                                        	**type**\:  :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                        
                                                                                        .. attribute:: max_count
                                                                                        
                                                                                        	Maximum count of flows
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: idle_timeout
                                                                                        
                                                                                        	Idle timeout of flows (in seconds)
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        	**units**\: second
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                            self.yang_name = "flow-key-data"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("flow-keys", ("flow_keys", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys))])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('max_count', (YLeaf(YType.uint16, 'max-count'), ['int'])),
                                                                                                ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                                            ])
                                                                                            self.max_count = None
                                                                                            self.idle_timeout = None

                                                                                            self.flow_keys = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                            self.flow_keys.parent = self
                                                                                            self._children_name_map["flow_keys"] = "flow-keys"
                                                                                            self._segment_path = lambda: "flow-key-data"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['max_count', 'idle_timeout'], name, value)


                                                                                        class FlowKeys(Entity):
                                                                                            """
                                                                                            flow keys
                                                                                            
                                                                                            .. attribute:: keys
                                                                                            
                                                                                            	keys
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                            
                                                                                            .. attribute:: num
                                                                                            
                                                                                            	num
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                self.yang_name = "flow-keys"
                                                                                                self.yang_parent_name = "flow-key-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('keys', (YLeaf(YType.str, 'keys'), ['str'])),
                                                                                                    ('num', (YLeaf(YType.uint8, 'num'), ['int'])),
                                                                                                ])
                                                                                                self.keys = None
                                                                                                self.num = None
                                                                                                self._segment_path = lambda: "flow-keys"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                    class DhcpClientId(Entity):
                                                                                        """
                                                                                        Dhcp Client ID
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                            self.yang_name = "dhcp-client-id"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "dhcp-client-id"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                    class DhcpClientIdRegex(Entity):
                                                                                        """
                                                                                        Dhcp Client ID RegEx
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                            self.yang_name = "dhcp-client-id-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "dhcp-client-id-regex"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                    class CircuitId(Entity):
                                                                                        """
                                                                                        Circuit ID
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                            self.yang_name = "circuit-id"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "circuit-id"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                    class CircuitIdRegex(Entity):
                                                                                        """
                                                                                        Circuit ID RegEx
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                            self.yang_name = "circuit-id-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "circuit-id-regex"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                    class RemoteId(Entity):
                                                                                        """
                                                                                        Remote ID
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                            self.yang_name = "remote-id"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "remote-id"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                    class RemoteIdRegex(Entity):
                                                                                        """
                                                                                        Remote ID RegEx
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                            self.yang_name = "remote-id-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "remote-id-regex"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                    class SrcPort(Entity):
                                                                                        """
                                                                                        Source port
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                            self.yang_name = "src-port"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "src-port"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "src-port"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint16_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                                    class DstPort(Entity):
                                                                                        """
                                                                                        Destination port
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                            self.yang_name = "dst-port"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "dst-port"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "dst-port"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint16_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                class ConfclassP(Entity):
                                                                    """
                                                                    confclass p
                                                                    
                                                                    .. attribute:: class_map_bg
                                                                    
                                                                    	class map bg
                                                                    	**type**\: list of  		 :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP, self).__init__()

                                                                        self.yang_name = "confclass-p"
                                                                        self.yang_parent_name = "police"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("class-map-bg", ("class_map_bg", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg))])
                                                                        self._leafs = OrderedDict()

                                                                        self.class_map_bg = YList(self)
                                                                        self._segment_path = lambda: "confclass-p"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP, [], name, value)


                                                                    class ClassMapBg(Entity):
                                                                        """
                                                                        class map bg
                                                                        
                                                                        .. attribute:: match_infop
                                                                        
                                                                        	Pointer to the first Match info
                                                                        	**type**\:  :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop>`
                                                                        
                                                                        .. attribute:: name
                                                                        
                                                                        	Name of the class\-map
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..65
                                                                        
                                                                        .. attribute:: type
                                                                        
                                                                        	Class\-Map Type QoS/PBR/Netflow/..
                                                                        	**type**\:  :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                                        
                                                                        .. attribute:: mode
                                                                        
                                                                        	Class\-Map Mode Match any/Match all
                                                                        	**type**\:  :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                        
                                                                        .. attribute:: description
                                                                        
                                                                        	description
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg, self).__init__()

                                                                            self.yang_name = "class-map-bg"
                                                                            self.yang_parent_name = "confclass-p"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("match-infop", ("match_infop", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop))])
                                                                            self._leafs = OrderedDict([
                                                                                ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                                ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapTypeEn', '')])),
                                                                                ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapModeEn', '')])),
                                                                                ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                            ])
                                                                            self.name = None
                                                                            self.type = None
                                                                            self.mode = None
                                                                            self.description = None

                                                                            self.match_infop = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop()
                                                                            self.match_infop.parent = self
                                                                            self._children_name_map["match_infop"] = "match-infop"
                                                                            self._segment_path = lambda: "class-map-bg"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg, ['name', 'type', 'mode', 'description'], name, value)


                                                                        class MatchInfop(Entity):
                                                                            """
                                                                            Pointer to the first Match info
                                                                            
                                                                            .. attribute:: class_match_info_st
                                                                            
                                                                            	class match info st
                                                                            	**type**\: list of  		 :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop, self).__init__()

                                                                                self.yang_name = "match-infop"
                                                                                self.yang_parent_name = "class-map-bg"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("class-match-info-st", ("class_match_info_st", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt))])
                                                                                self._leafs = OrderedDict()

                                                                                self.class_match_info_st = YList(self)
                                                                                self._segment_path = lambda: "match-infop"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop, [], name, value)


                                                                            class ClassMatchInfoSt(Entity):
                                                                                """
                                                                                class match info st
                                                                                
                                                                                .. attribute:: match_data
                                                                                
                                                                                	Match criteria
                                                                                	**type**\:  :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                
                                                                                .. attribute:: flags
                                                                                
                                                                                	Flags
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                    self.yang_name = "class-match-info-st"
                                                                                    self.yang_parent_name = "match-infop"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("match-data", ("match_data", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                    ])
                                                                                    self.flags = None

                                                                                    self.match_data = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                    self.match_data.parent = self
                                                                                    self._children_name_map["match_data"] = "match-data"
                                                                                    self._segment_path = lambda: "class-match-info-st"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                class MatchData(Entity):
                                                                                    """
                                                                                    Match criteria
                                                                                    
                                                                                    .. attribute:: ipv4_dscp
                                                                                    
                                                                                    	IPv4 DSCP
                                                                                    	**type**\:  :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                    
                                                                                    .. attribute:: ipv6_dscp
                                                                                    
                                                                                    	IPv6 DSCP
                                                                                    	**type**\:  :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                    
                                                                                    .. attribute:: dscp
                                                                                    
                                                                                    	Match DSCP range array
                                                                                    	**type**\:  :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                    
                                                                                    .. attribute:: ipv4_prec
                                                                                    
                                                                                    	IPv4 Precedence
                                                                                    	**type**\:  :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                    
                                                                                    .. attribute:: ipv6_prec
                                                                                    
                                                                                    	IPv6 Precedence
                                                                                    	**type**\:  :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                    
                                                                                    .. attribute:: prec
                                                                                    
                                                                                    	Match Precedence array
                                                                                    	**type**\:  :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                    
                                                                                    .. attribute:: discard_class
                                                                                    
                                                                                    	Match Discard Class array
                                                                                    	**type**\:  :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                    
                                                                                    .. attribute:: qos_group
                                                                                    
                                                                                    	Match QoS group array
                                                                                    	**type**\:  :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                    
                                                                                    .. attribute:: traffic_class
                                                                                    
                                                                                    	Match Traffic class array
                                                                                    	**type**\:  :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                    
                                                                                    .. attribute:: proto
                                                                                    
                                                                                    	Match Protocol array
                                                                                    	**type**\:  :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                    
                                                                                    .. attribute:: icmp_v4
                                                                                    
                                                                                    	Match ICMPV4 Protocol
                                                                                    	**type**\:  :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                    
                                                                                    .. attribute:: icmp_v6
                                                                                    
                                                                                    	Match ICMPV6 Protocol array
                                                                                    	**type**\:  :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                    
                                                                                    .. attribute:: ipv4_packet_len
                                                                                    
                                                                                    	IPv4 packet length array
                                                                                    	**type**\:  :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                    
                                                                                    .. attribute:: ipv6_packet_len
                                                                                    
                                                                                    	IPv6 packet length array
                                                                                    	**type**\:  :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                    
                                                                                    .. attribute:: packet_len
                                                                                    
                                                                                    	Match packet length array
                                                                                    	**type**\:  :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                    
                                                                                    .. attribute:: flow_tag
                                                                                    
                                                                                    	Match flow\-tag array
                                                                                    	**type**\:  :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                    
                                                                                    .. attribute:: tcp_flag
                                                                                    
                                                                                    	Match tcp flag value
                                                                                    	**type**\:  :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                    
                                                                                    .. attribute:: icmpv4_type
                                                                                    
                                                                                    	Match ipv4 icmp type
                                                                                    	**type**\:  :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                    
                                                                                    .. attribute:: icmpv4_code
                                                                                    
                                                                                    	Match ipv4 icmp code
                                                                                    	**type**\:  :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                    
                                                                                    .. attribute:: icmpv6_type
                                                                                    
                                                                                    	Match ipv6 icmp type
                                                                                    	**type**\:  :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                    
                                                                                    .. attribute:: icmpv6_code
                                                                                    
                                                                                    	Match ipv6 icmp code
                                                                                    	**type**\:  :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                    
                                                                                    .. attribute:: mpls_exp
                                                                                    
                                                                                    	Match MPLS experimental topmost array
                                                                                    	**type**\:  :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                    
                                                                                    .. attribute:: mpls_exp_imp
                                                                                    
                                                                                    	Match MPLS experimental imposition array
                                                                                    	**type**\:  :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                    
                                                                                    .. attribute:: mpls_disp_ipv4_acl
                                                                                    
                                                                                    	MPLS Disposition IPv4 Access\-list
                                                                                    	**type**\:  :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                    
                                                                                    .. attribute:: mpls_disp_ipv6_acl
                                                                                    
                                                                                    	MPLS Disposition IPv6 Access\-list
                                                                                    	**type**\:  :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                    
                                                                                    .. attribute:: mpls_top_label
                                                                                    
                                                                                    	MPLS Topmost LABEL
                                                                                    	**type**\:  :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                    
                                                                                    .. attribute:: cos
                                                                                    
                                                                                    	Match CoS array
                                                                                    	**type**\:  :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                    
                                                                                    .. attribute:: cos_inr
                                                                                    
                                                                                    	Match inner header CoS
                                                                                    	**type**\:  :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                    
                                                                                    .. attribute:: dei
                                                                                    
                                                                                    	Match DEI Bit
                                                                                    	**type**\:  :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                    
                                                                                    .. attribute:: dei_inr
                                                                                    
                                                                                    	Match inner DEI Bit
                                                                                    	**type**\:  :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                    
                                                                                    .. attribute:: vlan
                                                                                    
                                                                                    	Match VLAN array
                                                                                    	**type**\:  :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                    
                                                                                    .. attribute:: vlan_inr
                                                                                    
                                                                                    	Match inner header VLAN range array
                                                                                    	**type**\:  :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                    
                                                                                    .. attribute:: fr_dlci
                                                                                    
                                                                                    	Match FR DLCI range array
                                                                                    	**type**\:  :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                    
                                                                                    .. attribute:: src_mac
                                                                                    
                                                                                    	Match Source MAC address
                                                                                    	**type**\:  :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                    
                                                                                    .. attribute:: dst_mac
                                                                                    
                                                                                    	Match Destination MAC address
                                                                                    	**type**\:  :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                    
                                                                                    .. attribute:: atm_clp
                                                                                    
                                                                                    	Match ATM CLP level
                                                                                    	**type**\:  :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                    
                                                                                    .. attribute:: fr_de
                                                                                    
                                                                                    	Match FR DE value
                                                                                    	**type**\:  :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                    
                                                                                    .. attribute:: ipv4_acl
                                                                                    
                                                                                    	IPv4 Access\-list
                                                                                    	**type**\:  :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                    
                                                                                    .. attribute:: ipv6_acl
                                                                                    
                                                                                    	IPv6 Access\-list
                                                                                    	**type**\:  :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                    
                                                                                    .. attribute:: ether_service_acl
                                                                                    
                                                                                    	Ethernet\-Services Access\-list
                                                                                    	**type**\:  :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                    
                                                                                    .. attribute:: avail_id
                                                                                    
                                                                                    	Available Identifiers
                                                                                    	**type**\:  :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                    
                                                                                    .. attribute:: media_type
                                                                                    
                                                                                    	Media Type
                                                                                    	**type**\:  :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                    
                                                                                    .. attribute:: subs_protocol
                                                                                    
                                                                                    	Protocol
                                                                                    	**type**\:  :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                    
                                                                                    .. attribute:: dnis
                                                                                    
                                                                                    	DNIS
                                                                                    	**type**\:  :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                    
                                                                                    .. attribute:: dnis_regex
                                                                                    
                                                                                    	DNIS Regular Expression
                                                                                    	**type**\:  :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                    
                                                                                    .. attribute:: domain
                                                                                    
                                                                                    	Domain Name
                                                                                    	**type**\:  :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                    
                                                                                    .. attribute:: domain_regex
                                                                                    
                                                                                    	Domain Regular Expression
                                                                                    	**type**\:  :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                    
                                                                                    .. attribute:: nas_port
                                                                                    
                                                                                    	NAS Port
                                                                                    	**type**\:  :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                    
                                                                                    .. attribute:: service_name
                                                                                    
                                                                                    	Service Name
                                                                                    	**type**\:  :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                    
                                                                                    .. attribute:: service_name_regex
                                                                                    
                                                                                    	Service Name Regular Exp
                                                                                    	**type**\:  :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                    
                                                                                    .. attribute:: src_addr_ipv4
                                                                                    
                                                                                    	Source Address IPV4
                                                                                    	**type**\:  :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                    
                                                                                    .. attribute:: dst_addr_ipv4
                                                                                    
                                                                                    	Destination Address IPV4
                                                                                    	**type**\:  :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                    
                                                                                    .. attribute:: src_addr_ipv6
                                                                                    
                                                                                    	Source Address IPV6
                                                                                    	**type**\:  :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                    
                                                                                    .. attribute:: dst_addr_ipv6
                                                                                    
                                                                                    	Destination Address IPV6
                                                                                    	**type**\:  :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                    
                                                                                    .. attribute:: src_addr_mac
                                                                                    
                                                                                    	Source Address MAC
                                                                                    	**type**\:  :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                    
                                                                                    .. attribute:: timer
                                                                                    
                                                                                    	Timer
                                                                                    	**type**\:  :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                    
                                                                                    .. attribute:: timer_regexp
                                                                                    
                                                                                    	Timer Regular Expression
                                                                                    	**type**\:  :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                    
                                                                                    .. attribute:: tunnel_name
                                                                                    
                                                                                    	Tunnel Name
                                                                                    	**type**\:  :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                    
                                                                                    .. attribute:: tunnel_name_regex
                                                                                    
                                                                                    	Tunnel Name Regular Expression
                                                                                    	**type**\:  :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                    
                                                                                    .. attribute:: user_name
                                                                                    
                                                                                    	User Name
                                                                                    	**type**\:  :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                    
                                                                                    .. attribute:: user_name_regex
                                                                                    
                                                                                    	User Name Regular Expression
                                                                                    	**type**\:  :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                    
                                                                                    .. attribute:: auth_username
                                                                                    
                                                                                    	Authenticated User Name
                                                                                    	**type**\:  :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                    
                                                                                    .. attribute:: auth_username_regex
                                                                                    
                                                                                    	Authenticated User Name RegEx
                                                                                    	**type**\:  :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                    
                                                                                    .. attribute:: unauth_username
                                                                                    
                                                                                    	Unauthenticated User Name
                                                                                    	**type**\:  :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                    
                                                                                    .. attribute:: unauth_username_regex
                                                                                    
                                                                                    	Unauthenticated User Name RegEx
                                                                                    	**type**\:  :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                    
                                                                                    .. attribute:: auth_domain
                                                                                    
                                                                                    	Authenticated domain name
                                                                                    	**type**\:  :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                    
                                                                                    .. attribute:: auth_domain_regex
                                                                                    
                                                                                    	Authenticated Domain Name RegEx
                                                                                    	**type**\:  :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                    
                                                                                    .. attribute:: unauth_domain
                                                                                    
                                                                                    	Unauthenticated Domain Name
                                                                                    	**type**\:  :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                    
                                                                                    .. attribute:: unauth_domain_regex
                                                                                    
                                                                                    	Unauthenticated Domain Name RegEx
                                                                                    	**type**\:  :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                    
                                                                                    .. attribute:: vendor_id
                                                                                    
                                                                                    	Vendor ID
                                                                                    	**type**\:  :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                    
                                                                                    .. attribute:: vendor_id_regex
                                                                                    
                                                                                    	Vendor ID RegEx
                                                                                    	**type**\:  :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                    
                                                                                    .. attribute:: access_interface
                                                                                    
                                                                                    	Access interface
                                                                                    	**type**\:  :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                    
                                                                                    .. attribute:: input_interface
                                                                                    
                                                                                    	Input interface
                                                                                    	**type**\:  :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                    
                                                                                    .. attribute:: input_intfhdl
                                                                                    
                                                                                    	Input interface handle
                                                                                    	**type**\:  :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                    
                                                                                    .. attribute:: ethertype
                                                                                    
                                                                                    	Ethernet type
                                                                                    	**type**\:  :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                    
                                                                                    .. attribute:: flow_key_data
                                                                                    
                                                                                    	Flow key structure
                                                                                    	**type**\:  :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                    
                                                                                    .. attribute:: dhcp_client_id
                                                                                    
                                                                                    	Dhcp Client ID
                                                                                    	**type**\:  :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                    
                                                                                    .. attribute:: dhcp_client_id_regex
                                                                                    
                                                                                    	Dhcp Client ID RegEx
                                                                                    	**type**\:  :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                    
                                                                                    .. attribute:: circuit_id
                                                                                    
                                                                                    	Circuit ID
                                                                                    	**type**\:  :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                    
                                                                                    .. attribute:: circuit_id_regex
                                                                                    
                                                                                    	Circuit ID RegEx
                                                                                    	**type**\:  :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                    
                                                                                    .. attribute:: remote_id
                                                                                    
                                                                                    	Remote ID
                                                                                    	**type**\:  :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                    
                                                                                    .. attribute:: remote_id_regex
                                                                                    
                                                                                    	Remote ID RegEx
                                                                                    	**type**\:  :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                    
                                                                                    .. attribute:: src_port
                                                                                    
                                                                                    	Source port
                                                                                    	**type**\:  :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                    
                                                                                    .. attribute:: dst_port
                                                                                    
                                                                                    	Destination port
                                                                                    	**type**\:  :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	type
                                                                                    	**type**\:  :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                    
                                                                                    .. attribute:: mpls_top_eos
                                                                                    
                                                                                    	MPLS Topmost EOS
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: fragment_type
                                                                                    
                                                                                    	Fragment type
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: authen_status
                                                                                    
                                                                                    	Authentication Status
                                                                                    	**type**\:  :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                    
                                                                                    .. attribute:: mlp_negotiated
                                                                                    
                                                                                    	MLP Negotiated
                                                                                    	**type**\:  :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                        self.yang_name = "match-data"
                                                                                        self.yang_parent_name = "class-match-info-st"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("ipv4-dscp", ("ipv4_dscp", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp)), ("ipv6-dscp", ("ipv6_dscp", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp)), ("dscp", ("dscp", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp)), ("ipv4-prec", ("ipv4_prec", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec)), ("ipv6-prec", ("ipv6_prec", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec)), ("prec", ("prec", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec)), ("discard-class", ("discard_class", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass)), ("qos-group", ("qos_group", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup)), ("traffic-class", ("traffic_class", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass)), ("proto", ("proto", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto)), ("icmp-v4", ("icmp_v4", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4)), ("icmp-v6", ("icmp_v6", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6)), ("ipv4-packet-len", ("ipv4_packet_len", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen)), ("ipv6-packet-len", ("ipv6_packet_len", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen)), ("packet-len", ("packet_len", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen)), ("flow-tag", ("flow_tag", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag)), ("tcp-flag", ("tcp_flag", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag)), ("icmpv4-type", ("icmpv4_type", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type)), ("icmpv4-code", ("icmpv4_code", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code)), ("icmpv6-type", ("icmpv6_type", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type)), ("icmpv6-code", ("icmpv6_code", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code)), ("mpls-exp", ("mpls_exp", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp)), ("mpls-exp-imp", ("mpls_exp_imp", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp)), ("mpls-disp-ipv4-acl", ("mpls_disp_ipv4_acl", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl)), ("mpls-disp-ipv6-acl", ("mpls_disp_ipv6_acl", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl)), ("mpls-top-label", ("mpls_top_label", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel)), ("cos", ("cos", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos)), ("cos-inr", ("cos_inr", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr)), ("dei", ("dei", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei)), ("dei-inr", ("dei_inr", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr)), ("vlan", ("vlan", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan)), ("vlan-inr", ("vlan_inr", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)), ("fr-dlci", ("fr_dlci", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci)), ("src-mac", ("src_mac", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac)), ("dst-mac", ("dst_mac", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac)), ("atm-clp", ("atm_clp", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp)), ("fr-de", ("fr_de", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe)), ("ipv4-acl", ("ipv4_acl", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl)), ("ipv6-acl", ("ipv6_acl", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl)), ("ether-service-acl", ("ether_service_acl", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl)), ("avail-id", ("avail_id", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId)), ("media-type", ("media_type", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType)), ("subs-protocol", ("subs_protocol", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol)), ("dnis", ("dnis", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis)), ("dnis-regex", ("dnis_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex)), ("domain", ("domain", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain)), ("domain-regex", ("domain_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex)), ("nas-port", ("nas_port", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort)), ("service-name", ("service_name", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName)), ("service-name-regex", ("service_name_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex)), ("src-addr-ipv4", ("src_addr_ipv4", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4)), ("dst-addr-ipv4", ("dst_addr_ipv4", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4)), ("src-addr-ipv6", ("src_addr_ipv6", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6)), ("dst-addr-ipv6", ("dst_addr_ipv6", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6)), ("src-addr-mac", ("src_addr_mac", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac)), ("timer", ("timer", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer)), ("timer-regexp", ("timer_regexp", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp)), ("tunnel-name", ("tunnel_name", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName)), ("tunnel-name-regex", ("tunnel_name_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex)), ("user-name", ("user_name", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName)), ("user-name-regex", ("user_name_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex)), ("auth-username", ("auth_username", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername)), ("auth-username-regex", ("auth_username_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex)), ("unauth-username", ("unauth_username", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername)), ("unauth-username-regex", ("unauth_username_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex)), ("auth-domain", ("auth_domain", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain)), ("auth-domain-regex", ("auth_domain_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex)), ("unauth-domain", ("unauth_domain", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain)), ("unauth-domain-regex", ("unauth_domain_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex)), ("vendor-id", ("vendor_id", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId)), ("vendor-id-regex", ("vendor_id_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex)), ("access-interface", ("access_interface", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface)), ("input-interface", ("input_interface", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface)), ("input-intfhdl", ("input_intfhdl", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl)), ("ethertype", ("ethertype", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype)), ("flow-key-data", ("flow_key_data", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData)), ("dhcp-client-id", ("dhcp_client_id", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId)), ("dhcp-client-id-regex", ("dhcp_client_id_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex)), ("circuit-id", ("circuit_id", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId)), ("circuit-id-regex", ("circuit_id_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex)), ("remote-id", ("remote_id", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId)), ("remote-id-regex", ("remote_id_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex)), ("src-port", ("src_port", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort)), ("dst-port", ("dst_port", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort))])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchTypeEn', '')])),
                                                                                            ('mpls_top_eos', (YLeaf(YType.uint8, 'mpls-top-eos'), ['int'])),
                                                                                            ('fragment_type', (YLeaf(YType.uint8, 'fragment-type'), ['int'])),
                                                                                            ('authen_status', (YLeaf(YType.enumeration, 'authen-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchAuthenStatusEn', '')])),
                                                                                            ('mlp_negotiated', (YLeaf(YType.enumeration, 'mlp-negotiated'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchMlpNegotiatedEn', '')])),
                                                                                        ])
                                                                                        self.type = None
                                                                                        self.mpls_top_eos = None
                                                                                        self.fragment_type = None
                                                                                        self.authen_status = None
                                                                                        self.mlp_negotiated = None

                                                                                        self.ipv4_dscp = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                        self.ipv4_dscp.parent = self
                                                                                        self._children_name_map["ipv4_dscp"] = "ipv4-dscp"

                                                                                        self.ipv6_dscp = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                        self.ipv6_dscp.parent = self
                                                                                        self._children_name_map["ipv6_dscp"] = "ipv6-dscp"

                                                                                        self.dscp = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                        self.dscp.parent = self
                                                                                        self._children_name_map["dscp"] = "dscp"

                                                                                        self.ipv4_prec = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                        self.ipv4_prec.parent = self
                                                                                        self._children_name_map["ipv4_prec"] = "ipv4-prec"

                                                                                        self.ipv6_prec = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                        self.ipv6_prec.parent = self
                                                                                        self._children_name_map["ipv6_prec"] = "ipv6-prec"

                                                                                        self.prec = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                        self.prec.parent = self
                                                                                        self._children_name_map["prec"] = "prec"

                                                                                        self.discard_class = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                        self.discard_class.parent = self
                                                                                        self._children_name_map["discard_class"] = "discard-class"

                                                                                        self.qos_group = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                        self.qos_group.parent = self
                                                                                        self._children_name_map["qos_group"] = "qos-group"

                                                                                        self.traffic_class = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                        self.traffic_class.parent = self
                                                                                        self._children_name_map["traffic_class"] = "traffic-class"

                                                                                        self.proto = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                        self.proto.parent = self
                                                                                        self._children_name_map["proto"] = "proto"

                                                                                        self.icmp_v4 = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                        self.icmp_v4.parent = self
                                                                                        self._children_name_map["icmp_v4"] = "icmp-v4"

                                                                                        self.icmp_v6 = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                        self.icmp_v6.parent = self
                                                                                        self._children_name_map["icmp_v6"] = "icmp-v6"

                                                                                        self.ipv4_packet_len = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                        self.ipv4_packet_len.parent = self
                                                                                        self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"

                                                                                        self.ipv6_packet_len = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                        self.ipv6_packet_len.parent = self
                                                                                        self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"

                                                                                        self.packet_len = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                        self.packet_len.parent = self
                                                                                        self._children_name_map["packet_len"] = "packet-len"

                                                                                        self.flow_tag = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                        self.flow_tag.parent = self
                                                                                        self._children_name_map["flow_tag"] = "flow-tag"

                                                                                        self.tcp_flag = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                        self.tcp_flag.parent = self
                                                                                        self._children_name_map["tcp_flag"] = "tcp-flag"

                                                                                        self.icmpv4_type = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                        self.icmpv4_type.parent = self
                                                                                        self._children_name_map["icmpv4_type"] = "icmpv4-type"

                                                                                        self.icmpv4_code = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                        self.icmpv4_code.parent = self
                                                                                        self._children_name_map["icmpv4_code"] = "icmpv4-code"

                                                                                        self.icmpv6_type = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                        self.icmpv6_type.parent = self
                                                                                        self._children_name_map["icmpv6_type"] = "icmpv6-type"

                                                                                        self.icmpv6_code = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                        self.icmpv6_code.parent = self
                                                                                        self._children_name_map["icmpv6_code"] = "icmpv6-code"

                                                                                        self.mpls_exp = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                        self.mpls_exp.parent = self
                                                                                        self._children_name_map["mpls_exp"] = "mpls-exp"

                                                                                        self.mpls_exp_imp = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                        self.mpls_exp_imp.parent = self
                                                                                        self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"

                                                                                        self.mpls_disp_ipv4_acl = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                        self.mpls_disp_ipv4_acl.parent = self
                                                                                        self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"

                                                                                        self.mpls_disp_ipv6_acl = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                        self.mpls_disp_ipv6_acl.parent = self
                                                                                        self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"

                                                                                        self.mpls_top_label = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                        self.mpls_top_label.parent = self
                                                                                        self._children_name_map["mpls_top_label"] = "mpls-top-label"

                                                                                        self.cos = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                        self.cos.parent = self
                                                                                        self._children_name_map["cos"] = "cos"

                                                                                        self.cos_inr = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                        self.cos_inr.parent = self
                                                                                        self._children_name_map["cos_inr"] = "cos-inr"

                                                                                        self.dei = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                        self.dei.parent = self
                                                                                        self._children_name_map["dei"] = "dei"

                                                                                        self.dei_inr = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                        self.dei_inr.parent = self
                                                                                        self._children_name_map["dei_inr"] = "dei-inr"

                                                                                        self.vlan = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                        self.vlan.parent = self
                                                                                        self._children_name_map["vlan"] = "vlan"

                                                                                        self.vlan_inr = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                        self.vlan_inr.parent = self
                                                                                        self._children_name_map["vlan_inr"] = "vlan-inr"

                                                                                        self.fr_dlci = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                        self.fr_dlci.parent = self
                                                                                        self._children_name_map["fr_dlci"] = "fr-dlci"

                                                                                        self.src_mac = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                        self.src_mac.parent = self
                                                                                        self._children_name_map["src_mac"] = "src-mac"

                                                                                        self.dst_mac = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                        self.dst_mac.parent = self
                                                                                        self._children_name_map["dst_mac"] = "dst-mac"

                                                                                        self.atm_clp = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                        self.atm_clp.parent = self
                                                                                        self._children_name_map["atm_clp"] = "atm-clp"

                                                                                        self.fr_de = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                        self.fr_de.parent = self
                                                                                        self._children_name_map["fr_de"] = "fr-de"

                                                                                        self.ipv4_acl = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                        self.ipv4_acl.parent = self
                                                                                        self._children_name_map["ipv4_acl"] = "ipv4-acl"

                                                                                        self.ipv6_acl = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                        self.ipv6_acl.parent = self
                                                                                        self._children_name_map["ipv6_acl"] = "ipv6-acl"

                                                                                        self.ether_service_acl = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                        self.ether_service_acl.parent = self
                                                                                        self._children_name_map["ether_service_acl"] = "ether-service-acl"

                                                                                        self.avail_id = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                        self.avail_id.parent = self
                                                                                        self._children_name_map["avail_id"] = "avail-id"

                                                                                        self.media_type = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                        self.media_type.parent = self
                                                                                        self._children_name_map["media_type"] = "media-type"

                                                                                        self.subs_protocol = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                        self.subs_protocol.parent = self
                                                                                        self._children_name_map["subs_protocol"] = "subs-protocol"

                                                                                        self.dnis = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                        self.dnis.parent = self
                                                                                        self._children_name_map["dnis"] = "dnis"

                                                                                        self.dnis_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                        self.dnis_regex.parent = self
                                                                                        self._children_name_map["dnis_regex"] = "dnis-regex"

                                                                                        self.domain = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                        self.domain.parent = self
                                                                                        self._children_name_map["domain"] = "domain"

                                                                                        self.domain_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                        self.domain_regex.parent = self
                                                                                        self._children_name_map["domain_regex"] = "domain-regex"

                                                                                        self.nas_port = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                        self.nas_port.parent = self
                                                                                        self._children_name_map["nas_port"] = "nas-port"

                                                                                        self.service_name = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                        self.service_name.parent = self
                                                                                        self._children_name_map["service_name"] = "service-name"

                                                                                        self.service_name_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                        self.service_name_regex.parent = self
                                                                                        self._children_name_map["service_name_regex"] = "service-name-regex"

                                                                                        self.src_addr_ipv4 = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                        self.src_addr_ipv4.parent = self
                                                                                        self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"

                                                                                        self.dst_addr_ipv4 = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                        self.dst_addr_ipv4.parent = self
                                                                                        self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"

                                                                                        self.src_addr_ipv6 = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                        self.src_addr_ipv6.parent = self
                                                                                        self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"

                                                                                        self.dst_addr_ipv6 = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                        self.dst_addr_ipv6.parent = self
                                                                                        self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"

                                                                                        self.src_addr_mac = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                        self.src_addr_mac.parent = self
                                                                                        self._children_name_map["src_addr_mac"] = "src-addr-mac"

                                                                                        self.timer = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                        self.timer.parent = self
                                                                                        self._children_name_map["timer"] = "timer"

                                                                                        self.timer_regexp = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                        self.timer_regexp.parent = self
                                                                                        self._children_name_map["timer_regexp"] = "timer-regexp"

                                                                                        self.tunnel_name = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                        self.tunnel_name.parent = self
                                                                                        self._children_name_map["tunnel_name"] = "tunnel-name"

                                                                                        self.tunnel_name_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                        self.tunnel_name_regex.parent = self
                                                                                        self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"

                                                                                        self.user_name = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                        self.user_name.parent = self
                                                                                        self._children_name_map["user_name"] = "user-name"

                                                                                        self.user_name_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                        self.user_name_regex.parent = self
                                                                                        self._children_name_map["user_name_regex"] = "user-name-regex"

                                                                                        self.auth_username = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                        self.auth_username.parent = self
                                                                                        self._children_name_map["auth_username"] = "auth-username"

                                                                                        self.auth_username_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                        self.auth_username_regex.parent = self
                                                                                        self._children_name_map["auth_username_regex"] = "auth-username-regex"

                                                                                        self.unauth_username = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                        self.unauth_username.parent = self
                                                                                        self._children_name_map["unauth_username"] = "unauth-username"

                                                                                        self.unauth_username_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                        self.unauth_username_regex.parent = self
                                                                                        self._children_name_map["unauth_username_regex"] = "unauth-username-regex"

                                                                                        self.auth_domain = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                        self.auth_domain.parent = self
                                                                                        self._children_name_map["auth_domain"] = "auth-domain"

                                                                                        self.auth_domain_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                        self.auth_domain_regex.parent = self
                                                                                        self._children_name_map["auth_domain_regex"] = "auth-domain-regex"

                                                                                        self.unauth_domain = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                        self.unauth_domain.parent = self
                                                                                        self._children_name_map["unauth_domain"] = "unauth-domain"

                                                                                        self.unauth_domain_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                        self.unauth_domain_regex.parent = self
                                                                                        self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"

                                                                                        self.vendor_id = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                        self.vendor_id.parent = self
                                                                                        self._children_name_map["vendor_id"] = "vendor-id"

                                                                                        self.vendor_id_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                        self.vendor_id_regex.parent = self
                                                                                        self._children_name_map["vendor_id_regex"] = "vendor-id-regex"

                                                                                        self.access_interface = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                        self.access_interface.parent = self
                                                                                        self._children_name_map["access_interface"] = "access-interface"

                                                                                        self.input_interface = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                        self.input_interface.parent = self
                                                                                        self._children_name_map["input_interface"] = "input-interface"

                                                                                        self.input_intfhdl = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                        self.input_intfhdl.parent = self
                                                                                        self._children_name_map["input_intfhdl"] = "input-intfhdl"

                                                                                        self.ethertype = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                        self.ethertype.parent = self
                                                                                        self._children_name_map["ethertype"] = "ethertype"

                                                                                        self.flow_key_data = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                        self.flow_key_data.parent = self
                                                                                        self._children_name_map["flow_key_data"] = "flow-key-data"

                                                                                        self.dhcp_client_id = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                        self.dhcp_client_id.parent = self
                                                                                        self._children_name_map["dhcp_client_id"] = "dhcp-client-id"

                                                                                        self.dhcp_client_id_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                        self.dhcp_client_id_regex.parent = self
                                                                                        self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"

                                                                                        self.circuit_id = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                        self.circuit_id.parent = self
                                                                                        self._children_name_map["circuit_id"] = "circuit-id"

                                                                                        self.circuit_id_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                        self.circuit_id_regex.parent = self
                                                                                        self._children_name_map["circuit_id_regex"] = "circuit-id-regex"

                                                                                        self.remote_id = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                        self.remote_id.parent = self
                                                                                        self._children_name_map["remote_id"] = "remote-id"

                                                                                        self.remote_id_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                        self.remote_id_regex.parent = self
                                                                                        self._children_name_map["remote_id_regex"] = "remote-id-regex"

                                                                                        self.src_port = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                        self.src_port.parent = self
                                                                                        self._children_name_map["src_port"] = "src-port"

                                                                                        self.dst_port = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                        self.dst_port.parent = self
                                                                                        self._children_name_map["dst_port"] = "dst-port"
                                                                                        self._segment_path = lambda: "match-data"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['type', 'mpls_top_eos', 'fragment_type', 'authen_status', 'mlp_negotiated'], name, value)


                                                                                    class Ipv4Dscp(Entity):
                                                                                        """
                                                                                        IPv4 DSCP
                                                                                        
                                                                                        .. attribute:: uint8_rng_array
                                                                                        
                                                                                        	uint8 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                            self.yang_name = "ipv4-dscp"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint8_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "ipv4-dscp"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                        class Uint8RngArray(Entity):
                                                                                            """
                                                                                            uint8 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                self.yang_name = "uint8_rng_array"
                                                                                                self.yang_parent_name = "ipv4-dscp"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint8_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                    class Ipv6Dscp(Entity):
                                                                                        """
                                                                                        IPv6 DSCP
                                                                                        
                                                                                        .. attribute:: uint8_rng_array
                                                                                        
                                                                                        	uint8 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                            self.yang_name = "ipv6-dscp"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint8_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "ipv6-dscp"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                        class Uint8RngArray(Entity):
                                                                                            """
                                                                                            uint8 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                self.yang_name = "uint8_rng_array"
                                                                                                self.yang_parent_name = "ipv6-dscp"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint8_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                    class Dscp(Entity):
                                                                                        """
                                                                                        Match DSCP range array
                                                                                        
                                                                                        .. attribute:: uint8_rng_array
                                                                                        
                                                                                        	uint8 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                            self.yang_name = "dscp"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint8_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "dscp"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                        class Uint8RngArray(Entity):
                                                                                            """
                                                                                            uint8 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                self.yang_name = "uint8_rng_array"
                                                                                                self.yang_parent_name = "dscp"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint8_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                    class Ipv4Prec(Entity):
                                                                                        """
                                                                                        IPv4 Precedence
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                            self.yang_name = "ipv4-prec"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                            ])
                                                                                            self.uint8_array = []
                                                                                            self._segment_path = lambda: "ipv4-prec"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                    class Ipv6Prec(Entity):
                                                                                        """
                                                                                        IPv6 Precedence
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                            self.yang_name = "ipv6-prec"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                            ])
                                                                                            self.uint8_array = []
                                                                                            self._segment_path = lambda: "ipv6-prec"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                    class Prec(Entity):
                                                                                        """
                                                                                        Match Precedence array
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                            self.yang_name = "prec"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                            ])
                                                                                            self.uint8_array = []
                                                                                            self._segment_path = lambda: "prec"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                    class DiscardClass(Entity):
                                                                                        """
                                                                                        Match Discard Class array
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                            self.yang_name = "discard-class"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                            ])
                                                                                            self.uint8_array = []
                                                                                            self._segment_path = lambda: "discard-class"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                    class QosGroup(Entity):
                                                                                        """
                                                                                        Match QoS group array
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                            self.yang_name = "qos-group"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "qos-group"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "qos-group"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint16_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['min', 'max'], name, value)


                                                                                    class TrafficClass(Entity):
                                                                                        """
                                                                                        Match Traffic class array
                                                                                        
                                                                                        .. attribute:: uint8_rng_array
                                                                                        
                                                                                        	uint8 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                            self.yang_name = "traffic-class"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint8_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "traffic-class"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                        class Uint8RngArray(Entity):
                                                                                            """
                                                                                            uint8 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                self.yang_name = "uint8_rng_array"
                                                                                                self.yang_parent_name = "traffic-class"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint8_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['min', 'max'], name, value)


                                                                                    class Proto(Entity):
                                                                                        """
                                                                                        Match Protocol array
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                            self.yang_name = "proto"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "proto"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "proto"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint16_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['min', 'max'], name, value)


                                                                                    class IcmpV4(Entity):
                                                                                        """
                                                                                        Match ICMPV4 Protocol
                                                                                        
                                                                                        .. attribute:: type
                                                                                        
                                                                                        	Protocol type
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: code
                                                                                        
                                                                                        	Protocol code
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                            self.yang_name = "icmp-v4"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                            ])
                                                                                            self.type = None
                                                                                            self.code = None
                                                                                            self._segment_path = lambda: "icmp-v4"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['type', 'code'], name, value)


                                                                                    class IcmpV6(Entity):
                                                                                        """
                                                                                        Match ICMPV6 Protocol array
                                                                                        
                                                                                        .. attribute:: type
                                                                                        
                                                                                        	Protocol type
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: code
                                                                                        
                                                                                        	Protocol code
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                            self.yang_name = "icmp-v6"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                            ])
                                                                                            self.type = None
                                                                                            self.code = None
                                                                                            self._segment_path = lambda: "icmp-v6"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['type', 'code'], name, value)


                                                                                    class Ipv4PacketLen(Entity):
                                                                                        """
                                                                                        IPv4 packet length array
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                            self.yang_name = "ipv4-packet-len"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "ipv4-packet-len"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "ipv4-packet-len"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint16_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                    class Ipv6PacketLen(Entity):
                                                                                        """
                                                                                        IPv6 packet length array
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                            self.yang_name = "ipv6-packet-len"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "ipv6-packet-len"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "ipv6-packet-len"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint16_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                    class PacketLen(Entity):
                                                                                        """
                                                                                        Match packet length array
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                            self.yang_name = "packet-len"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "packet-len"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "packet-len"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint16_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                    class FlowTag(Entity):
                                                                                        """
                                                                                        Match flow\-tag array
                                                                                        
                                                                                        .. attribute:: uint8_rng_array
                                                                                        
                                                                                        	uint8 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                            self.yang_name = "flow-tag"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint8_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "flow-tag"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                        class Uint8RngArray(Entity):
                                                                                            """
                                                                                            uint8 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                self.yang_name = "uint8_rng_array"
                                                                                                self.yang_parent_name = "flow-tag"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint8_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['min', 'max'], name, value)


                                                                                    class TcpFlag(Entity):
                                                                                        """
                                                                                        Match tcp flag value
                                                                                        
                                                                                        .. attribute:: value
                                                                                        
                                                                                        	Value of TCP flag
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: match_any
                                                                                        
                                                                                        	Match any TCP flag bit
                                                                                        	**type**\: bool
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                            self.yang_name = "tcp-flag"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                                ('match_any', (YLeaf(YType.boolean, 'match-any'), ['bool'])),
                                                                                            ])
                                                                                            self.value = None
                                                                                            self.match_any = None
                                                                                            self._segment_path = lambda: "tcp-flag"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['value', 'match_any'], name, value)


                                                                                    class Icmpv4Type(Entity):
                                                                                        """
                                                                                        Match ipv4 icmp type
                                                                                        
                                                                                        .. attribute:: uint8_rng_array
                                                                                        
                                                                                        	uint8 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                            self.yang_name = "icmpv4-type"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint8_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "icmpv4-type"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                        class Uint8RngArray(Entity):
                                                                                            """
                                                                                            uint8 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                self.yang_name = "uint8_rng_array"
                                                                                                self.yang_parent_name = "icmpv4-type"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint8_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                    class Icmpv4Code(Entity):
                                                                                        """
                                                                                        Match ipv4 icmp code
                                                                                        
                                                                                        .. attribute:: uint8_rng_array
                                                                                        
                                                                                        	uint8 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                            self.yang_name = "icmpv4-code"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint8_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "icmpv4-code"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                        class Uint8RngArray(Entity):
                                                                                            """
                                                                                            uint8 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                self.yang_name = "uint8_rng_array"
                                                                                                self.yang_parent_name = "icmpv4-code"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint8_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                    class Icmpv6Type(Entity):
                                                                                        """
                                                                                        Match ipv6 icmp type
                                                                                        
                                                                                        .. attribute:: uint8_rng_array
                                                                                        
                                                                                        	uint8 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                            self.yang_name = "icmpv6-type"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint8_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "icmpv6-type"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                        class Uint8RngArray(Entity):
                                                                                            """
                                                                                            uint8 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                self.yang_name = "uint8_rng_array"
                                                                                                self.yang_parent_name = "icmpv6-type"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint8_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                    class Icmpv6Code(Entity):
                                                                                        """
                                                                                        Match ipv6 icmp code
                                                                                        
                                                                                        .. attribute:: uint8_rng_array
                                                                                        
                                                                                        	uint8 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                            self.yang_name = "icmpv6-code"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint8_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "icmpv6-code"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                        class Uint8RngArray(Entity):
                                                                                            """
                                                                                            uint8 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                self.yang_name = "uint8_rng_array"
                                                                                                self.yang_parent_name = "icmpv6-code"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint8_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                    class MplsExp(Entity):
                                                                                        """
                                                                                        Match MPLS experimental topmost array
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                            self.yang_name = "mpls-exp"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                            ])
                                                                                            self.uint8_array = []
                                                                                            self._segment_path = lambda: "mpls-exp"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                    class MplsExpImp(Entity):
                                                                                        """
                                                                                        Match MPLS experimental imposition array
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                            self.yang_name = "mpls-exp-imp"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                            ])
                                                                                            self.uint8_array = []
                                                                                            self._segment_path = lambda: "mpls-exp-imp"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                    class MplsDispIpv4Acl(Entity):
                                                                                        """
                                                                                        MPLS Disposition IPv4 Access\-list
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                            self.yang_name = "mpls-disp-ipv4-acl"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "mpls-disp-ipv4-acl"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                    class MplsDispIpv6Acl(Entity):
                                                                                        """
                                                                                        MPLS Disposition IPv6 Access\-list
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                            self.yang_name = "mpls-disp-ipv6-acl"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "mpls-disp-ipv6-acl"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                    class MplsTopLabel(Entity):
                                                                                        """
                                                                                        MPLS Topmost LABEL
                                                                                        
                                                                                        .. attribute:: uint32_rng_array
                                                                                        
                                                                                        	uint32 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                            self.yang_name = "mpls-top-label"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint32_rng_array", ("uint32_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint32_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "mpls-top-label"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                        class Uint32RngArray(Entity):
                                                                                            """
                                                                                            uint32 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                self.yang_name = "uint32_rng_array"
                                                                                                self.yang_parent_name = "mpls-top-label"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint32, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint32, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint32_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['min', 'max'], name, value)


                                                                                    class Cos(Entity):
                                                                                        """
                                                                                        Match CoS array
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                            self.yang_name = "cos"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                            ])
                                                                                            self.uint8_array = []
                                                                                            self._segment_path = lambda: "cos"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                    class CosInr(Entity):
                                                                                        """
                                                                                        Match inner header CoS
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                            self.yang_name = "cos-inr"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                            ])
                                                                                            self.uint8_array = []
                                                                                            self._segment_path = lambda: "cos-inr"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                    class Dei(Entity):
                                                                                        """
                                                                                        Match DEI Bit
                                                                                        
                                                                                        .. attribute:: bit_value
                                                                                        
                                                                                        	Value of the DEI bit
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                            self.yang_name = "dei"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                            ])
                                                                                            self.bit_value = None
                                                                                            self._segment_path = lambda: "dei"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                    class DeiInr(Entity):
                                                                                        """
                                                                                        Match inner DEI Bit
                                                                                        
                                                                                        .. attribute:: bit_value
                                                                                        
                                                                                        	Value of the DEI bit
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                            self.yang_name = "dei-inr"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                            ])
                                                                                            self.bit_value = None
                                                                                            self._segment_path = lambda: "dei-inr"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                    class Vlan(Entity):
                                                                                        """
                                                                                        Match VLAN array
                                                                                        
                                                                                        .. attribute:: vlan_id_array
                                                                                        
                                                                                        	vlan id array
                                                                                        	**type**\: list of  		 :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                            self.yang_name = "vlan"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("vlan-id-array", ("vlan_id_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.vlan_id_array = YList(self)
                                                                                            self._segment_path = lambda: "vlan"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                        class VlanIdArray(Entity):
                                                                                            """
                                                                                            vlan id array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	VLAN mask
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                self.yang_name = "vlan-id-array"
                                                                                                self.yang_parent_name = "vlan"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ('mask', (YLeaf(YType.uint16, 'mask'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self.mask = None
                                                                                                self._segment_path = lambda: "vlan-id-array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['min', 'max', 'mask'], name, value)


                                                                                    class VlanInr(Entity):
                                                                                        """
                                                                                        Match inner header VLAN range array
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                            self.yang_name = "vlan-inr"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "vlan-inr"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "vlan-inr"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint16_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['min', 'max'], name, value)


                                                                                    class FrDlci(Entity):
                                                                                        """
                                                                                        Match FR DLCI range array
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                            self.yang_name = "fr-dlci"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "fr-dlci"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "fr-dlci"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint16_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['min', 'max'], name, value)


                                                                                    class SrcMac(Entity):
                                                                                        """
                                                                                        Match Source MAC address
                                                                                        
                                                                                        .. attribute:: mac_addr
                                                                                        
                                                                                        	MAC address
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: mask
                                                                                        
                                                                                        	MAC mask
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                            self.yang_name = "src-mac"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                            ])
                                                                                            self.mac_addr = []
                                                                                            self.mask = []
                                                                                            self._segment_path = lambda: "src-mac"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                    class DstMac(Entity):
                                                                                        """
                                                                                        Match Destination MAC address
                                                                                        
                                                                                        .. attribute:: mac_addr
                                                                                        
                                                                                        	MAC address
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: mask
                                                                                        
                                                                                        	MAC mask
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                            self.yang_name = "dst-mac"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                            ])
                                                                                            self.mac_addr = []
                                                                                            self.mask = []
                                                                                            self._segment_path = lambda: "dst-mac"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                    class AtmClp(Entity):
                                                                                        """
                                                                                        Match ATM CLP level
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                            self.yang_name = "atm-clp"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                            ])
                                                                                            self.uint8_array = []
                                                                                            self._segment_path = lambda: "atm-clp"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                    class FrDe(Entity):
                                                                                        """
                                                                                        Match FR DE value
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                            self.yang_name = "fr-de"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                            ])
                                                                                            self.uint8_array = []
                                                                                            self._segment_path = lambda: "fr-de"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                    class Ipv4Acl(Entity):
                                                                                        """
                                                                                        IPv4 Access\-list
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                            self.yang_name = "ipv4-acl"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "ipv4-acl"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                    class Ipv6Acl(Entity):
                                                                                        """
                                                                                        IPv6 Access\-list
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                            self.yang_name = "ipv6-acl"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "ipv6-acl"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                    class EtherServiceAcl(Entity):
                                                                                        """
                                                                                        Ethernet\-Services Access\-list
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                            self.yang_name = "ether-service-acl"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "ether-service-acl"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                    class AvailId(Entity):
                                                                                        """
                                                                                        Available Identifiers
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                            self.yang_name = "avail-id"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                            ])
                                                                                            self.uint8_array = []
                                                                                            self._segment_path = lambda: "avail-id"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                    class MediaType(Entity):
                                                                                        """
                                                                                        Media Type
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                            self.yang_name = "media-type"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                            ])
                                                                                            self.uint8_array = []
                                                                                            self._segment_path = lambda: "media-type"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                    class SubsProtocol(Entity):
                                                                                        """
                                                                                        Protocol
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                            self.yang_name = "subs-protocol"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                            ])
                                                                                            self.uint8_array = []
                                                                                            self._segment_path = lambda: "subs-protocol"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                    class Dnis(Entity):
                                                                                        """
                                                                                        DNIS
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                            self.yang_name = "dnis"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "dnis"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                    class DnisRegex(Entity):
                                                                                        """
                                                                                        DNIS Regular Expression
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                            self.yang_name = "dnis-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "dnis-regex"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                    class Domain(Entity):
                                                                                        """
                                                                                        Domain Name
                                                                                        
                                                                                        .. attribute:: domain_array
                                                                                        
                                                                                        	domain array
                                                                                        	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                            self.yang_name = "domain"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.domain_array = YList(self)
                                                                                            self._segment_path = lambda: "domain"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                        class DomainArray(Entity):
                                                                                            """
                                                                                            domain array
                                                                                            
                                                                                            .. attribute:: domain_name
                                                                                            
                                                                                            	domain name
                                                                                            	**type**\: str
                                                                                            
                                                                                            .. attribute:: format_name
                                                                                            
                                                                                            	format name
                                                                                            	**type**\: str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                self.yang_name = "domain-array"
                                                                                                self.yang_parent_name = "domain"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                    ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                ])
                                                                                                self.domain_name = None
                                                                                                self.format_name = None
                                                                                                self._segment_path = lambda: "domain-array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                    class DomainRegex(Entity):
                                                                                        """
                                                                                        Domain Regular Expression
                                                                                        
                                                                                        .. attribute:: domain_array
                                                                                        
                                                                                        	domain array
                                                                                        	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                            self.yang_name = "domain-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.domain_array = YList(self)
                                                                                            self._segment_path = lambda: "domain-regex"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                        class DomainArray(Entity):
                                                                                            """
                                                                                            domain array
                                                                                            
                                                                                            .. attribute:: domain_name
                                                                                            
                                                                                            	domain name
                                                                                            	**type**\: str
                                                                                            
                                                                                            .. attribute:: format_name
                                                                                            
                                                                                            	format name
                                                                                            	**type**\: str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                self.yang_name = "domain-array"
                                                                                                self.yang_parent_name = "domain-regex"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                    ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                ])
                                                                                                self.domain_name = None
                                                                                                self.format_name = None
                                                                                                self._segment_path = lambda: "domain-array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                    class NasPort(Entity):
                                                                                        """
                                                                                        NAS Port
                                                                                        
                                                                                        .. attribute:: nas_port_array
                                                                                        
                                                                                        	nas port array
                                                                                        	**type**\: list of  		 :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                            self.yang_name = "nas-port"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("nas-port-array", ("nas_port_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.nas_port_array = YList(self)
                                                                                            self._segment_path = lambda: "nas-port"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                        class NasPortArray(Entity):
                                                                                            """
                                                                                            nas port array
                                                                                            
                                                                                            .. attribute:: sub_id
                                                                                            
                                                                                            	sub id
                                                                                            	**type**\:  :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                            
                                                                                            .. attribute:: operator
                                                                                            
                                                                                            	operator
                                                                                            	**type**\:  :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                            
                                                                                            .. attribute:: value
                                                                                            
                                                                                            	value
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                self.yang_name = "nas-port-array"
                                                                                                self.yang_parent_name = "nas-port"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('sub_id', (YLeaf(YType.enumeration, 'sub-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchNasPortSubIdEn', '')])),
                                                                                                    ('operator', (YLeaf(YType.enumeration, 'operator'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchLogicalOperatorEn', '')])),
                                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                                ])
                                                                                                self.sub_id = None
                                                                                                self.operator = None
                                                                                                self.value = None
                                                                                                self._segment_path = lambda: "nas-port-array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['sub_id', 'operator', 'value'], name, value)


                                                                                    class ServiceName(Entity):
                                                                                        """
                                                                                        Service Name
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                            self.yang_name = "service-name"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "service-name"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                    class ServiceNameRegex(Entity):
                                                                                        """
                                                                                        Service Name Regular Exp
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                            self.yang_name = "service-name-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "service-name-regex"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                    class SrcAddrIpv4(Entity):
                                                                                        """
                                                                                        Source Address IPV4
                                                                                        
                                                                                        .. attribute:: ipv4_addr_array
                                                                                        
                                                                                        	ipv4 addr array
                                                                                        	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                            self.yang_name = "src-addr-ipv4"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.ipv4_addr_array = YList(self)
                                                                                            self._segment_path = lambda: "src-addr-ipv4"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                        class Ipv4AddrArray(Entity):
                                                                                            """
                                                                                            ipv4 addr array
                                                                                            
                                                                                            .. attribute:: prefix
                                                                                            
                                                                                            	prefix
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	mask
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                self.yang_name = "ipv4-addr-array"
                                                                                                self.yang_parent_name = "src-addr-ipv4"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                    ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                ])
                                                                                                self.prefix = None
                                                                                                self.mask = None
                                                                                                self._segment_path = lambda: "ipv4-addr-array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                    class DstAddrIpv4(Entity):
                                                                                        """
                                                                                        Destination Address IPV4
                                                                                        
                                                                                        .. attribute:: ipv4_addr_array
                                                                                        
                                                                                        	ipv4 addr array
                                                                                        	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                            self.yang_name = "dst-addr-ipv4"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.ipv4_addr_array = YList(self)
                                                                                            self._segment_path = lambda: "dst-addr-ipv4"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                        class Ipv4AddrArray(Entity):
                                                                                            """
                                                                                            ipv4 addr array
                                                                                            
                                                                                            .. attribute:: prefix
                                                                                            
                                                                                            	prefix
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	mask
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                self.yang_name = "ipv4-addr-array"
                                                                                                self.yang_parent_name = "dst-addr-ipv4"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                    ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                ])
                                                                                                self.prefix = None
                                                                                                self.mask = None
                                                                                                self._segment_path = lambda: "ipv4-addr-array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                    class SrcAddrIpv6(Entity):
                                                                                        """
                                                                                        Source Address IPV6
                                                                                        
                                                                                        .. attribute:: ipv6_addr_array
                                                                                        
                                                                                        	ipv6 addr array
                                                                                        	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                            self.yang_name = "src-addr-ipv6"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.ipv6_addr_array = YList(self)
                                                                                            self._segment_path = lambda: "src-addr-ipv6"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                        class Ipv6AddrArray(Entity):
                                                                                            """
                                                                                            ipv6 addr array
                                                                                            
                                                                                            .. attribute:: prefix
                                                                                            
                                                                                            	IPV6 prefix
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	IPV6 mask
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                self.yang_name = "ipv6-addr-array"
                                                                                                self.yang_parent_name = "src-addr-ipv6"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                    ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                ])
                                                                                                self.prefix = None
                                                                                                self.mask = None
                                                                                                self._segment_path = lambda: "ipv6-addr-array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                    class DstAddrIpv6(Entity):
                                                                                        """
                                                                                        Destination Address IPV6
                                                                                        
                                                                                        .. attribute:: ipv6_addr_array
                                                                                        
                                                                                        	ipv6 addr array
                                                                                        	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                            self.yang_name = "dst-addr-ipv6"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.ipv6_addr_array = YList(self)
                                                                                            self._segment_path = lambda: "dst-addr-ipv6"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                        class Ipv6AddrArray(Entity):
                                                                                            """
                                                                                            ipv6 addr array
                                                                                            
                                                                                            .. attribute:: prefix
                                                                                            
                                                                                            	IPV6 prefix
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	IPV6 mask
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                self.yang_name = "ipv6-addr-array"
                                                                                                self.yang_parent_name = "dst-addr-ipv6"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                    ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                ])
                                                                                                self.prefix = None
                                                                                                self.mask = None
                                                                                                self._segment_path = lambda: "ipv6-addr-array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                    class SrcAddrMac(Entity):
                                                                                        """
                                                                                        Source Address MAC
                                                                                        
                                                                                        .. attribute:: mac_addr_array
                                                                                        
                                                                                        	mac addr array
                                                                                        	**type**\: list of  		 :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                            self.yang_name = "src-addr-mac"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("mac-addr-array", ("mac_addr_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.mac_addr_array = YList(self)
                                                                                            self._segment_path = lambda: "src-addr-mac"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                        class MacAddrArray(Entity):
                                                                                            """
                                                                                            mac addr array
                                                                                            
                                                                                            .. attribute:: mac_addr
                                                                                            
                                                                                            	MAC address
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	MAC mask
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                self.yang_name = "mac-addr-array"
                                                                                                self.yang_parent_name = "src-addr-mac"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                    ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                ])
                                                                                                self.mac_addr = []
                                                                                                self.mask = []
                                                                                                self._segment_path = lambda: "mac-addr-array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                    class Timer(Entity):
                                                                                        """
                                                                                        Timer
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                            self.yang_name = "timer"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "timer"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                    class TimerRegexp(Entity):
                                                                                        """
                                                                                        Timer Regular Expression
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                            self.yang_name = "timer-regexp"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "timer-regexp"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                    class TunnelName(Entity):
                                                                                        """
                                                                                        Tunnel Name
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                            self.yang_name = "tunnel-name"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "tunnel-name"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                    class TunnelNameRegex(Entity):
                                                                                        """
                                                                                        Tunnel Name Regular Expression
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                            self.yang_name = "tunnel-name-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "tunnel-name-regex"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                    class UserName(Entity):
                                                                                        """
                                                                                        User Name
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                            self.yang_name = "user-name"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "user-name"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                    class UserNameRegex(Entity):
                                                                                        """
                                                                                        User Name Regular Expression
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                            self.yang_name = "user-name-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "user-name-regex"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                    class AuthUsername(Entity):
                                                                                        """
                                                                                        Authenticated User Name
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                            self.yang_name = "auth-username"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "auth-username"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                    class AuthUsernameRegex(Entity):
                                                                                        """
                                                                                        Authenticated User Name RegEx
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                            self.yang_name = "auth-username-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "auth-username-regex"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                    class UnauthUsername(Entity):
                                                                                        """
                                                                                        Unauthenticated User Name
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                            self.yang_name = "unauth-username"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "unauth-username"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                    class UnauthUsernameRegex(Entity):
                                                                                        """
                                                                                        Unauthenticated User Name RegEx
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                            self.yang_name = "unauth-username-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "unauth-username-regex"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                    class AuthDomain(Entity):
                                                                                        """
                                                                                        Authenticated domain name
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                            self.yang_name = "auth-domain"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "auth-domain"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                    class AuthDomainRegex(Entity):
                                                                                        """
                                                                                        Authenticated Domain Name RegEx
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                            self.yang_name = "auth-domain-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "auth-domain-regex"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                    class UnauthDomain(Entity):
                                                                                        """
                                                                                        Unauthenticated Domain Name
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                            self.yang_name = "unauth-domain"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "unauth-domain"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                    class UnauthDomainRegex(Entity):
                                                                                        """
                                                                                        Unauthenticated Domain Name RegEx
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                            self.yang_name = "unauth-domain-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "unauth-domain-regex"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                    class VendorId(Entity):
                                                                                        """
                                                                                        Vendor ID
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                            self.yang_name = "vendor-id"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "vendor-id"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                    class VendorIdRegex(Entity):
                                                                                        """
                                                                                        Vendor ID RegEx
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                            self.yang_name = "vendor-id-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "vendor-id-regex"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                    class AccessInterface(Entity):
                                                                                        """
                                                                                        Access interface
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                            self.yang_name = "access-interface"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "access-interface"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                    class InputInterface(Entity):
                                                                                        """
                                                                                        Input interface
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                            self.yang_name = "input-interface"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "input-interface"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                    class InputIntfhdl(Entity):
                                                                                        """
                                                                                        Input interface handle
                                                                                        
                                                                                        .. attribute:: uint64_array
                                                                                        
                                                                                        	uint64 array
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..18446744073709551615
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                            self.yang_name = "input-intfhdl"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('uint64_array', (YLeafList(YType.uint64, 'uint64_array'), ['int'])),
                                                                                            ])
                                                                                            self.uint64_array = []
                                                                                            self._segment_path = lambda: "input-intfhdl"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                    class Ethertype(Entity):
                                                                                        """
                                                                                        Ethernet type
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                            self.yang_name = "ethertype"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "ethertype"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "ethertype"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint16_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['min', 'max'], name, value)


                                                                                    class FlowKeyData(Entity):
                                                                                        """
                                                                                        Flow key structure
                                                                                        
                                                                                        .. attribute:: flow_keys
                                                                                        
                                                                                        	flow keys
                                                                                        	**type**\:  :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                        
                                                                                        .. attribute:: max_count
                                                                                        
                                                                                        	Maximum count of flows
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: idle_timeout
                                                                                        
                                                                                        	Idle timeout of flows (in seconds)
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        	**units**\: second
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                            self.yang_name = "flow-key-data"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("flow-keys", ("flow_keys", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys))])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('max_count', (YLeaf(YType.uint16, 'max-count'), ['int'])),
                                                                                                ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                                            ])
                                                                                            self.max_count = None
                                                                                            self.idle_timeout = None

                                                                                            self.flow_keys = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                            self.flow_keys.parent = self
                                                                                            self._children_name_map["flow_keys"] = "flow-keys"
                                                                                            self._segment_path = lambda: "flow-key-data"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['max_count', 'idle_timeout'], name, value)


                                                                                        class FlowKeys(Entity):
                                                                                            """
                                                                                            flow keys
                                                                                            
                                                                                            .. attribute:: keys
                                                                                            
                                                                                            	keys
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                            
                                                                                            .. attribute:: num
                                                                                            
                                                                                            	num
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                self.yang_name = "flow-keys"
                                                                                                self.yang_parent_name = "flow-key-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('keys', (YLeaf(YType.str, 'keys'), ['str'])),
                                                                                                    ('num', (YLeaf(YType.uint8, 'num'), ['int'])),
                                                                                                ])
                                                                                                self.keys = None
                                                                                                self.num = None
                                                                                                self._segment_path = lambda: "flow-keys"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                    class DhcpClientId(Entity):
                                                                                        """
                                                                                        Dhcp Client ID
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                            self.yang_name = "dhcp-client-id"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "dhcp-client-id"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                    class DhcpClientIdRegex(Entity):
                                                                                        """
                                                                                        Dhcp Client ID RegEx
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                            self.yang_name = "dhcp-client-id-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "dhcp-client-id-regex"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                    class CircuitId(Entity):
                                                                                        """
                                                                                        Circuit ID
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                            self.yang_name = "circuit-id"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "circuit-id"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                    class CircuitIdRegex(Entity):
                                                                                        """
                                                                                        Circuit ID RegEx
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                            self.yang_name = "circuit-id-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "circuit-id-regex"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                    class RemoteId(Entity):
                                                                                        """
                                                                                        Remote ID
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                            self.yang_name = "remote-id"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "remote-id"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                    class RemoteIdRegex(Entity):
                                                                                        """
                                                                                        Remote ID RegEx
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                            self.yang_name = "remote-id-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "remote-id-regex"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                    class SrcPort(Entity):
                                                                                        """
                                                                                        Source port
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                            self.yang_name = "src-port"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "src-port"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "src-port"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint16_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                                    class DstPort(Entity):
                                                                                        """
                                                                                        Destination port
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                            self.yang_name = "dst-port"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "dst-port"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "dst-port"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint16_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                class ExcdclassEncode(Entity):
                                                                    """
                                                                    excdclass encode
                                                                    
                                                                    .. attribute:: inline_cmap
                                                                    
                                                                    	inline cmap
                                                                    	**type**\:  :py:class:`InlineCmap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap>`
                                                                    
                                                                    .. attribute:: enc
                                                                    
                                                                    	enc
                                                                    	**type**\:  :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                    
                                                                    .. attribute:: class_name
                                                                    
                                                                    	class name
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..65
                                                                    
                                                                    .. attribute:: hd
                                                                    
                                                                    	hd
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: idx
                                                                    
                                                                    	idx
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode, self).__init__()

                                                                        self.yang_name = "excdclass-encode"
                                                                        self.yang_parent_name = "police"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("inline-cmap", ("inline_cmap", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap))])
                                                                        self._leafs = OrderedDict([
                                                                            ('enc', (YLeaf(YType.enumeration, 'enc'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyObjEncEn', '')])),
                                                                            ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                                            ('hd', (YLeaf(YType.uint64, 'hd'), ['int'])),
                                                                            ('idx', (YLeaf(YType.uint8, 'idx'), ['int'])),
                                                                        ])
                                                                        self.enc = None
                                                                        self.class_name = None
                                                                        self.hd = None
                                                                        self.idx = None

                                                                        self.inline_cmap = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap()
                                                                        self.inline_cmap.parent = self
                                                                        self._children_name_map["inline_cmap"] = "inline-cmap"
                                                                        self._segment_path = lambda: "excdclass-encode"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode, ['enc', 'class_name', 'hd', 'idx'], name, value)


                                                                    class InlineCmap(Entity):
                                                                        """
                                                                        inline cmap
                                                                        
                                                                        .. attribute:: match_infop
                                                                        
                                                                        	Pointer to the first Match info
                                                                        	**type**\:  :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop>`
                                                                        
                                                                        .. attribute:: mode
                                                                        
                                                                        	Inline Class\-Map Mode Match any/all
                                                                        	**type**\:  :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                        
                                                                        .. attribute:: flags
                                                                        
                                                                        	Inline Class\-Map flags
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: match_count
                                                                        
                                                                        	Number of Match infos
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap, self).__init__()

                                                                            self.yang_name = "inline-cmap"
                                                                            self.yang_parent_name = "excdclass-encode"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("match-infop", ("match_infop", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop))])
                                                                            self._leafs = OrderedDict([
                                                                                ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapModeEn', '')])),
                                                                                ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                ('match_count', (YLeaf(YType.uint32, 'match-count'), ['int'])),
                                                                            ])
                                                                            self.mode = None
                                                                            self.flags = None
                                                                            self.match_count = None

                                                                            self.match_infop = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop()
                                                                            self.match_infop.parent = self
                                                                            self._children_name_map["match_infop"] = "match-infop"
                                                                            self._segment_path = lambda: "inline-cmap"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap, ['mode', 'flags', 'match_count'], name, value)


                                                                        class MatchInfop(Entity):
                                                                            """
                                                                            Pointer to the first Match info
                                                                            
                                                                            .. attribute:: class_match_info_st
                                                                            
                                                                            	class match info st
                                                                            	**type**\: list of  		 :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop, self).__init__()

                                                                                self.yang_name = "match-infop"
                                                                                self.yang_parent_name = "inline-cmap"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("class-match-info-st", ("class_match_info_st", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt))])
                                                                                self._leafs = OrderedDict()

                                                                                self.class_match_info_st = YList(self)
                                                                                self._segment_path = lambda: "match-infop"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop, [], name, value)


                                                                            class ClassMatchInfoSt(Entity):
                                                                                """
                                                                                class match info st
                                                                                
                                                                                .. attribute:: match_data
                                                                                
                                                                                	Match criteria
                                                                                	**type**\:  :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                
                                                                                .. attribute:: flags
                                                                                
                                                                                	Flags
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                    self.yang_name = "class-match-info-st"
                                                                                    self.yang_parent_name = "match-infop"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("match-data", ("match_data", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                    ])
                                                                                    self.flags = None

                                                                                    self.match_data = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                    self.match_data.parent = self
                                                                                    self._children_name_map["match_data"] = "match-data"
                                                                                    self._segment_path = lambda: "class-match-info-st"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                class MatchData(Entity):
                                                                                    """
                                                                                    Match criteria
                                                                                    
                                                                                    .. attribute:: ipv4_dscp
                                                                                    
                                                                                    	IPv4 DSCP
                                                                                    	**type**\:  :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                    
                                                                                    .. attribute:: ipv6_dscp
                                                                                    
                                                                                    	IPv6 DSCP
                                                                                    	**type**\:  :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                    
                                                                                    .. attribute:: dscp
                                                                                    
                                                                                    	Match DSCP range array
                                                                                    	**type**\:  :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                    
                                                                                    .. attribute:: ipv4_prec
                                                                                    
                                                                                    	IPv4 Precedence
                                                                                    	**type**\:  :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                    
                                                                                    .. attribute:: ipv6_prec
                                                                                    
                                                                                    	IPv6 Precedence
                                                                                    	**type**\:  :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                    
                                                                                    .. attribute:: prec
                                                                                    
                                                                                    	Match Precedence array
                                                                                    	**type**\:  :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                    
                                                                                    .. attribute:: discard_class
                                                                                    
                                                                                    	Match Discard Class array
                                                                                    	**type**\:  :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                    
                                                                                    .. attribute:: qos_group
                                                                                    
                                                                                    	Match QoS group array
                                                                                    	**type**\:  :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                    
                                                                                    .. attribute:: traffic_class
                                                                                    
                                                                                    	Match Traffic class array
                                                                                    	**type**\:  :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                    
                                                                                    .. attribute:: proto
                                                                                    
                                                                                    	Match Protocol array
                                                                                    	**type**\:  :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                    
                                                                                    .. attribute:: icmp_v4
                                                                                    
                                                                                    	Match ICMPV4 Protocol
                                                                                    	**type**\:  :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                    
                                                                                    .. attribute:: icmp_v6
                                                                                    
                                                                                    	Match ICMPV6 Protocol array
                                                                                    	**type**\:  :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                    
                                                                                    .. attribute:: ipv4_packet_len
                                                                                    
                                                                                    	IPv4 packet length array
                                                                                    	**type**\:  :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                    
                                                                                    .. attribute:: ipv6_packet_len
                                                                                    
                                                                                    	IPv6 packet length array
                                                                                    	**type**\:  :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                    
                                                                                    .. attribute:: packet_len
                                                                                    
                                                                                    	Match packet length array
                                                                                    	**type**\:  :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                    
                                                                                    .. attribute:: flow_tag
                                                                                    
                                                                                    	Match flow\-tag array
                                                                                    	**type**\:  :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                    
                                                                                    .. attribute:: tcp_flag
                                                                                    
                                                                                    	Match tcp flag value
                                                                                    	**type**\:  :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                    
                                                                                    .. attribute:: icmpv4_type
                                                                                    
                                                                                    	Match ipv4 icmp type
                                                                                    	**type**\:  :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                    
                                                                                    .. attribute:: icmpv4_code
                                                                                    
                                                                                    	Match ipv4 icmp code
                                                                                    	**type**\:  :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                    
                                                                                    .. attribute:: icmpv6_type
                                                                                    
                                                                                    	Match ipv6 icmp type
                                                                                    	**type**\:  :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                    
                                                                                    .. attribute:: icmpv6_code
                                                                                    
                                                                                    	Match ipv6 icmp code
                                                                                    	**type**\:  :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                    
                                                                                    .. attribute:: mpls_exp
                                                                                    
                                                                                    	Match MPLS experimental topmost array
                                                                                    	**type**\:  :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                    
                                                                                    .. attribute:: mpls_exp_imp
                                                                                    
                                                                                    	Match MPLS experimental imposition array
                                                                                    	**type**\:  :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                    
                                                                                    .. attribute:: mpls_disp_ipv4_acl
                                                                                    
                                                                                    	MPLS Disposition IPv4 Access\-list
                                                                                    	**type**\:  :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                    
                                                                                    .. attribute:: mpls_disp_ipv6_acl
                                                                                    
                                                                                    	MPLS Disposition IPv6 Access\-list
                                                                                    	**type**\:  :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                    
                                                                                    .. attribute:: mpls_top_label
                                                                                    
                                                                                    	MPLS Topmost LABEL
                                                                                    	**type**\:  :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                    
                                                                                    .. attribute:: cos
                                                                                    
                                                                                    	Match CoS array
                                                                                    	**type**\:  :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                    
                                                                                    .. attribute:: cos_inr
                                                                                    
                                                                                    	Match inner header CoS
                                                                                    	**type**\:  :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                    
                                                                                    .. attribute:: dei
                                                                                    
                                                                                    	Match DEI Bit
                                                                                    	**type**\:  :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                    
                                                                                    .. attribute:: dei_inr
                                                                                    
                                                                                    	Match inner DEI Bit
                                                                                    	**type**\:  :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                    
                                                                                    .. attribute:: vlan
                                                                                    
                                                                                    	Match VLAN array
                                                                                    	**type**\:  :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                    
                                                                                    .. attribute:: vlan_inr
                                                                                    
                                                                                    	Match inner header VLAN range array
                                                                                    	**type**\:  :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                    
                                                                                    .. attribute:: fr_dlci
                                                                                    
                                                                                    	Match FR DLCI range array
                                                                                    	**type**\:  :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                    
                                                                                    .. attribute:: src_mac
                                                                                    
                                                                                    	Match Source MAC address
                                                                                    	**type**\:  :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                    
                                                                                    .. attribute:: dst_mac
                                                                                    
                                                                                    	Match Destination MAC address
                                                                                    	**type**\:  :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                    
                                                                                    .. attribute:: atm_clp
                                                                                    
                                                                                    	Match ATM CLP level
                                                                                    	**type**\:  :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                    
                                                                                    .. attribute:: fr_de
                                                                                    
                                                                                    	Match FR DE value
                                                                                    	**type**\:  :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                    
                                                                                    .. attribute:: ipv4_acl
                                                                                    
                                                                                    	IPv4 Access\-list
                                                                                    	**type**\:  :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                    
                                                                                    .. attribute:: ipv6_acl
                                                                                    
                                                                                    	IPv6 Access\-list
                                                                                    	**type**\:  :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                    
                                                                                    .. attribute:: ether_service_acl
                                                                                    
                                                                                    	Ethernet\-Services Access\-list
                                                                                    	**type**\:  :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                    
                                                                                    .. attribute:: avail_id
                                                                                    
                                                                                    	Available Identifiers
                                                                                    	**type**\:  :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                    
                                                                                    .. attribute:: media_type
                                                                                    
                                                                                    	Media Type
                                                                                    	**type**\:  :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                    
                                                                                    .. attribute:: subs_protocol
                                                                                    
                                                                                    	Protocol
                                                                                    	**type**\:  :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                    
                                                                                    .. attribute:: dnis
                                                                                    
                                                                                    	DNIS
                                                                                    	**type**\:  :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                    
                                                                                    .. attribute:: dnis_regex
                                                                                    
                                                                                    	DNIS Regular Expression
                                                                                    	**type**\:  :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                    
                                                                                    .. attribute:: domain
                                                                                    
                                                                                    	Domain Name
                                                                                    	**type**\:  :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                    
                                                                                    .. attribute:: domain_regex
                                                                                    
                                                                                    	Domain Regular Expression
                                                                                    	**type**\:  :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                    
                                                                                    .. attribute:: nas_port
                                                                                    
                                                                                    	NAS Port
                                                                                    	**type**\:  :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                    
                                                                                    .. attribute:: service_name
                                                                                    
                                                                                    	Service Name
                                                                                    	**type**\:  :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                    
                                                                                    .. attribute:: service_name_regex
                                                                                    
                                                                                    	Service Name Regular Exp
                                                                                    	**type**\:  :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                    
                                                                                    .. attribute:: src_addr_ipv4
                                                                                    
                                                                                    	Source Address IPV4
                                                                                    	**type**\:  :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                    
                                                                                    .. attribute:: dst_addr_ipv4
                                                                                    
                                                                                    	Destination Address IPV4
                                                                                    	**type**\:  :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                    
                                                                                    .. attribute:: src_addr_ipv6
                                                                                    
                                                                                    	Source Address IPV6
                                                                                    	**type**\:  :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                    
                                                                                    .. attribute:: dst_addr_ipv6
                                                                                    
                                                                                    	Destination Address IPV6
                                                                                    	**type**\:  :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                    
                                                                                    .. attribute:: src_addr_mac
                                                                                    
                                                                                    	Source Address MAC
                                                                                    	**type**\:  :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                    
                                                                                    .. attribute:: timer
                                                                                    
                                                                                    	Timer
                                                                                    	**type**\:  :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                    
                                                                                    .. attribute:: timer_regexp
                                                                                    
                                                                                    	Timer Regular Expression
                                                                                    	**type**\:  :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                    
                                                                                    .. attribute:: tunnel_name
                                                                                    
                                                                                    	Tunnel Name
                                                                                    	**type**\:  :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                    
                                                                                    .. attribute:: tunnel_name_regex
                                                                                    
                                                                                    	Tunnel Name Regular Expression
                                                                                    	**type**\:  :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                    
                                                                                    .. attribute:: user_name
                                                                                    
                                                                                    	User Name
                                                                                    	**type**\:  :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                    
                                                                                    .. attribute:: user_name_regex
                                                                                    
                                                                                    	User Name Regular Expression
                                                                                    	**type**\:  :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                    
                                                                                    .. attribute:: auth_username
                                                                                    
                                                                                    	Authenticated User Name
                                                                                    	**type**\:  :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                    
                                                                                    .. attribute:: auth_username_regex
                                                                                    
                                                                                    	Authenticated User Name RegEx
                                                                                    	**type**\:  :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                    
                                                                                    .. attribute:: unauth_username
                                                                                    
                                                                                    	Unauthenticated User Name
                                                                                    	**type**\:  :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                    
                                                                                    .. attribute:: unauth_username_regex
                                                                                    
                                                                                    	Unauthenticated User Name RegEx
                                                                                    	**type**\:  :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                    
                                                                                    .. attribute:: auth_domain
                                                                                    
                                                                                    	Authenticated domain name
                                                                                    	**type**\:  :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                    
                                                                                    .. attribute:: auth_domain_regex
                                                                                    
                                                                                    	Authenticated Domain Name RegEx
                                                                                    	**type**\:  :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                    
                                                                                    .. attribute:: unauth_domain
                                                                                    
                                                                                    	Unauthenticated Domain Name
                                                                                    	**type**\:  :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                    
                                                                                    .. attribute:: unauth_domain_regex
                                                                                    
                                                                                    	Unauthenticated Domain Name RegEx
                                                                                    	**type**\:  :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                    
                                                                                    .. attribute:: vendor_id
                                                                                    
                                                                                    	Vendor ID
                                                                                    	**type**\:  :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                    
                                                                                    .. attribute:: vendor_id_regex
                                                                                    
                                                                                    	Vendor ID RegEx
                                                                                    	**type**\:  :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                    
                                                                                    .. attribute:: access_interface
                                                                                    
                                                                                    	Access interface
                                                                                    	**type**\:  :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                    
                                                                                    .. attribute:: input_interface
                                                                                    
                                                                                    	Input interface
                                                                                    	**type**\:  :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                    
                                                                                    .. attribute:: input_intfhdl
                                                                                    
                                                                                    	Input interface handle
                                                                                    	**type**\:  :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                    
                                                                                    .. attribute:: ethertype
                                                                                    
                                                                                    	Ethernet type
                                                                                    	**type**\:  :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                    
                                                                                    .. attribute:: flow_key_data
                                                                                    
                                                                                    	Flow key structure
                                                                                    	**type**\:  :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                    
                                                                                    .. attribute:: dhcp_client_id
                                                                                    
                                                                                    	Dhcp Client ID
                                                                                    	**type**\:  :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                    
                                                                                    .. attribute:: dhcp_client_id_regex
                                                                                    
                                                                                    	Dhcp Client ID RegEx
                                                                                    	**type**\:  :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                    
                                                                                    .. attribute:: circuit_id
                                                                                    
                                                                                    	Circuit ID
                                                                                    	**type**\:  :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                    
                                                                                    .. attribute:: circuit_id_regex
                                                                                    
                                                                                    	Circuit ID RegEx
                                                                                    	**type**\:  :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                    
                                                                                    .. attribute:: remote_id
                                                                                    
                                                                                    	Remote ID
                                                                                    	**type**\:  :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                    
                                                                                    .. attribute:: remote_id_regex
                                                                                    
                                                                                    	Remote ID RegEx
                                                                                    	**type**\:  :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                    
                                                                                    .. attribute:: src_port
                                                                                    
                                                                                    	Source port
                                                                                    	**type**\:  :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                    
                                                                                    .. attribute:: dst_port
                                                                                    
                                                                                    	Destination port
                                                                                    	**type**\:  :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	type
                                                                                    	**type**\:  :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                    
                                                                                    .. attribute:: mpls_top_eos
                                                                                    
                                                                                    	MPLS Topmost EOS
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: fragment_type
                                                                                    
                                                                                    	Fragment type
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: authen_status
                                                                                    
                                                                                    	Authentication Status
                                                                                    	**type**\:  :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                    
                                                                                    .. attribute:: mlp_negotiated
                                                                                    
                                                                                    	MLP Negotiated
                                                                                    	**type**\:  :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                        self.yang_name = "match-data"
                                                                                        self.yang_parent_name = "class-match-info-st"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("ipv4-dscp", ("ipv4_dscp", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp)), ("ipv6-dscp", ("ipv6_dscp", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp)), ("dscp", ("dscp", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp)), ("ipv4-prec", ("ipv4_prec", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec)), ("ipv6-prec", ("ipv6_prec", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec)), ("prec", ("prec", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec)), ("discard-class", ("discard_class", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass)), ("qos-group", ("qos_group", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup)), ("traffic-class", ("traffic_class", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass)), ("proto", ("proto", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto)), ("icmp-v4", ("icmp_v4", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4)), ("icmp-v6", ("icmp_v6", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6)), ("ipv4-packet-len", ("ipv4_packet_len", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen)), ("ipv6-packet-len", ("ipv6_packet_len", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen)), ("packet-len", ("packet_len", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen)), ("flow-tag", ("flow_tag", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag)), ("tcp-flag", ("tcp_flag", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag)), ("icmpv4-type", ("icmpv4_type", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type)), ("icmpv4-code", ("icmpv4_code", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code)), ("icmpv6-type", ("icmpv6_type", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type)), ("icmpv6-code", ("icmpv6_code", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code)), ("mpls-exp", ("mpls_exp", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp)), ("mpls-exp-imp", ("mpls_exp_imp", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp)), ("mpls-disp-ipv4-acl", ("mpls_disp_ipv4_acl", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl)), ("mpls-disp-ipv6-acl", ("mpls_disp_ipv6_acl", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl)), ("mpls-top-label", ("mpls_top_label", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel)), ("cos", ("cos", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos)), ("cos-inr", ("cos_inr", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr)), ("dei", ("dei", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei)), ("dei-inr", ("dei_inr", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr)), ("vlan", ("vlan", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan)), ("vlan-inr", ("vlan_inr", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)), ("fr-dlci", ("fr_dlci", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci)), ("src-mac", ("src_mac", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac)), ("dst-mac", ("dst_mac", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac)), ("atm-clp", ("atm_clp", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp)), ("fr-de", ("fr_de", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe)), ("ipv4-acl", ("ipv4_acl", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl)), ("ipv6-acl", ("ipv6_acl", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl)), ("ether-service-acl", ("ether_service_acl", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl)), ("avail-id", ("avail_id", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId)), ("media-type", ("media_type", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType)), ("subs-protocol", ("subs_protocol", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol)), ("dnis", ("dnis", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis)), ("dnis-regex", ("dnis_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex)), ("domain", ("domain", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain)), ("domain-regex", ("domain_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex)), ("nas-port", ("nas_port", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort)), ("service-name", ("service_name", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName)), ("service-name-regex", ("service_name_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex)), ("src-addr-ipv4", ("src_addr_ipv4", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4)), ("dst-addr-ipv4", ("dst_addr_ipv4", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4)), ("src-addr-ipv6", ("src_addr_ipv6", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6)), ("dst-addr-ipv6", ("dst_addr_ipv6", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6)), ("src-addr-mac", ("src_addr_mac", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac)), ("timer", ("timer", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer)), ("timer-regexp", ("timer_regexp", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp)), ("tunnel-name", ("tunnel_name", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName)), ("tunnel-name-regex", ("tunnel_name_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex)), ("user-name", ("user_name", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName)), ("user-name-regex", ("user_name_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex)), ("auth-username", ("auth_username", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername)), ("auth-username-regex", ("auth_username_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex)), ("unauth-username", ("unauth_username", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername)), ("unauth-username-regex", ("unauth_username_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex)), ("auth-domain", ("auth_domain", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain)), ("auth-domain-regex", ("auth_domain_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex)), ("unauth-domain", ("unauth_domain", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain)), ("unauth-domain-regex", ("unauth_domain_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex)), ("vendor-id", ("vendor_id", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId)), ("vendor-id-regex", ("vendor_id_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex)), ("access-interface", ("access_interface", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface)), ("input-interface", ("input_interface", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface)), ("input-intfhdl", ("input_intfhdl", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl)), ("ethertype", ("ethertype", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype)), ("flow-key-data", ("flow_key_data", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData)), ("dhcp-client-id", ("dhcp_client_id", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId)), ("dhcp-client-id-regex", ("dhcp_client_id_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex)), ("circuit-id", ("circuit_id", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId)), ("circuit-id-regex", ("circuit_id_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex)), ("remote-id", ("remote_id", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId)), ("remote-id-regex", ("remote_id_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex)), ("src-port", ("src_port", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort)), ("dst-port", ("dst_port", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort))])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchTypeEn', '')])),
                                                                                            ('mpls_top_eos', (YLeaf(YType.uint8, 'mpls-top-eos'), ['int'])),
                                                                                            ('fragment_type', (YLeaf(YType.uint8, 'fragment-type'), ['int'])),
                                                                                            ('authen_status', (YLeaf(YType.enumeration, 'authen-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchAuthenStatusEn', '')])),
                                                                                            ('mlp_negotiated', (YLeaf(YType.enumeration, 'mlp-negotiated'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchMlpNegotiatedEn', '')])),
                                                                                        ])
                                                                                        self.type = None
                                                                                        self.mpls_top_eos = None
                                                                                        self.fragment_type = None
                                                                                        self.authen_status = None
                                                                                        self.mlp_negotiated = None

                                                                                        self.ipv4_dscp = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                        self.ipv4_dscp.parent = self
                                                                                        self._children_name_map["ipv4_dscp"] = "ipv4-dscp"

                                                                                        self.ipv6_dscp = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                        self.ipv6_dscp.parent = self
                                                                                        self._children_name_map["ipv6_dscp"] = "ipv6-dscp"

                                                                                        self.dscp = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                        self.dscp.parent = self
                                                                                        self._children_name_map["dscp"] = "dscp"

                                                                                        self.ipv4_prec = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                        self.ipv4_prec.parent = self
                                                                                        self._children_name_map["ipv4_prec"] = "ipv4-prec"

                                                                                        self.ipv6_prec = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                        self.ipv6_prec.parent = self
                                                                                        self._children_name_map["ipv6_prec"] = "ipv6-prec"

                                                                                        self.prec = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                        self.prec.parent = self
                                                                                        self._children_name_map["prec"] = "prec"

                                                                                        self.discard_class = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                        self.discard_class.parent = self
                                                                                        self._children_name_map["discard_class"] = "discard-class"

                                                                                        self.qos_group = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                        self.qos_group.parent = self
                                                                                        self._children_name_map["qos_group"] = "qos-group"

                                                                                        self.traffic_class = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                        self.traffic_class.parent = self
                                                                                        self._children_name_map["traffic_class"] = "traffic-class"

                                                                                        self.proto = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                        self.proto.parent = self
                                                                                        self._children_name_map["proto"] = "proto"

                                                                                        self.icmp_v4 = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                        self.icmp_v4.parent = self
                                                                                        self._children_name_map["icmp_v4"] = "icmp-v4"

                                                                                        self.icmp_v6 = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                        self.icmp_v6.parent = self
                                                                                        self._children_name_map["icmp_v6"] = "icmp-v6"

                                                                                        self.ipv4_packet_len = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                        self.ipv4_packet_len.parent = self
                                                                                        self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"

                                                                                        self.ipv6_packet_len = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                        self.ipv6_packet_len.parent = self
                                                                                        self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"

                                                                                        self.packet_len = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                        self.packet_len.parent = self
                                                                                        self._children_name_map["packet_len"] = "packet-len"

                                                                                        self.flow_tag = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                        self.flow_tag.parent = self
                                                                                        self._children_name_map["flow_tag"] = "flow-tag"

                                                                                        self.tcp_flag = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                        self.tcp_flag.parent = self
                                                                                        self._children_name_map["tcp_flag"] = "tcp-flag"

                                                                                        self.icmpv4_type = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                        self.icmpv4_type.parent = self
                                                                                        self._children_name_map["icmpv4_type"] = "icmpv4-type"

                                                                                        self.icmpv4_code = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                        self.icmpv4_code.parent = self
                                                                                        self._children_name_map["icmpv4_code"] = "icmpv4-code"

                                                                                        self.icmpv6_type = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                        self.icmpv6_type.parent = self
                                                                                        self._children_name_map["icmpv6_type"] = "icmpv6-type"

                                                                                        self.icmpv6_code = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                        self.icmpv6_code.parent = self
                                                                                        self._children_name_map["icmpv6_code"] = "icmpv6-code"

                                                                                        self.mpls_exp = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                        self.mpls_exp.parent = self
                                                                                        self._children_name_map["mpls_exp"] = "mpls-exp"

                                                                                        self.mpls_exp_imp = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                        self.mpls_exp_imp.parent = self
                                                                                        self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"

                                                                                        self.mpls_disp_ipv4_acl = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                        self.mpls_disp_ipv4_acl.parent = self
                                                                                        self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"

                                                                                        self.mpls_disp_ipv6_acl = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                        self.mpls_disp_ipv6_acl.parent = self
                                                                                        self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"

                                                                                        self.mpls_top_label = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                        self.mpls_top_label.parent = self
                                                                                        self._children_name_map["mpls_top_label"] = "mpls-top-label"

                                                                                        self.cos = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                        self.cos.parent = self
                                                                                        self._children_name_map["cos"] = "cos"

                                                                                        self.cos_inr = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                        self.cos_inr.parent = self
                                                                                        self._children_name_map["cos_inr"] = "cos-inr"

                                                                                        self.dei = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                        self.dei.parent = self
                                                                                        self._children_name_map["dei"] = "dei"

                                                                                        self.dei_inr = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                        self.dei_inr.parent = self
                                                                                        self._children_name_map["dei_inr"] = "dei-inr"

                                                                                        self.vlan = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                        self.vlan.parent = self
                                                                                        self._children_name_map["vlan"] = "vlan"

                                                                                        self.vlan_inr = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                        self.vlan_inr.parent = self
                                                                                        self._children_name_map["vlan_inr"] = "vlan-inr"

                                                                                        self.fr_dlci = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                        self.fr_dlci.parent = self
                                                                                        self._children_name_map["fr_dlci"] = "fr-dlci"

                                                                                        self.src_mac = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                        self.src_mac.parent = self
                                                                                        self._children_name_map["src_mac"] = "src-mac"

                                                                                        self.dst_mac = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                        self.dst_mac.parent = self
                                                                                        self._children_name_map["dst_mac"] = "dst-mac"

                                                                                        self.atm_clp = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                        self.atm_clp.parent = self
                                                                                        self._children_name_map["atm_clp"] = "atm-clp"

                                                                                        self.fr_de = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                        self.fr_de.parent = self
                                                                                        self._children_name_map["fr_de"] = "fr-de"

                                                                                        self.ipv4_acl = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                        self.ipv4_acl.parent = self
                                                                                        self._children_name_map["ipv4_acl"] = "ipv4-acl"

                                                                                        self.ipv6_acl = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                        self.ipv6_acl.parent = self
                                                                                        self._children_name_map["ipv6_acl"] = "ipv6-acl"

                                                                                        self.ether_service_acl = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                        self.ether_service_acl.parent = self
                                                                                        self._children_name_map["ether_service_acl"] = "ether-service-acl"

                                                                                        self.avail_id = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                        self.avail_id.parent = self
                                                                                        self._children_name_map["avail_id"] = "avail-id"

                                                                                        self.media_type = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                        self.media_type.parent = self
                                                                                        self._children_name_map["media_type"] = "media-type"

                                                                                        self.subs_protocol = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                        self.subs_protocol.parent = self
                                                                                        self._children_name_map["subs_protocol"] = "subs-protocol"

                                                                                        self.dnis = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                        self.dnis.parent = self
                                                                                        self._children_name_map["dnis"] = "dnis"

                                                                                        self.dnis_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                        self.dnis_regex.parent = self
                                                                                        self._children_name_map["dnis_regex"] = "dnis-regex"

                                                                                        self.domain = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                        self.domain.parent = self
                                                                                        self._children_name_map["domain"] = "domain"

                                                                                        self.domain_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                        self.domain_regex.parent = self
                                                                                        self._children_name_map["domain_regex"] = "domain-regex"

                                                                                        self.nas_port = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                        self.nas_port.parent = self
                                                                                        self._children_name_map["nas_port"] = "nas-port"

                                                                                        self.service_name = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                        self.service_name.parent = self
                                                                                        self._children_name_map["service_name"] = "service-name"

                                                                                        self.service_name_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                        self.service_name_regex.parent = self
                                                                                        self._children_name_map["service_name_regex"] = "service-name-regex"

                                                                                        self.src_addr_ipv4 = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                        self.src_addr_ipv4.parent = self
                                                                                        self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"

                                                                                        self.dst_addr_ipv4 = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                        self.dst_addr_ipv4.parent = self
                                                                                        self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"

                                                                                        self.src_addr_ipv6 = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                        self.src_addr_ipv6.parent = self
                                                                                        self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"

                                                                                        self.dst_addr_ipv6 = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                        self.dst_addr_ipv6.parent = self
                                                                                        self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"

                                                                                        self.src_addr_mac = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                        self.src_addr_mac.parent = self
                                                                                        self._children_name_map["src_addr_mac"] = "src-addr-mac"

                                                                                        self.timer = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                        self.timer.parent = self
                                                                                        self._children_name_map["timer"] = "timer"

                                                                                        self.timer_regexp = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                        self.timer_regexp.parent = self
                                                                                        self._children_name_map["timer_regexp"] = "timer-regexp"

                                                                                        self.tunnel_name = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                        self.tunnel_name.parent = self
                                                                                        self._children_name_map["tunnel_name"] = "tunnel-name"

                                                                                        self.tunnel_name_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                        self.tunnel_name_regex.parent = self
                                                                                        self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"

                                                                                        self.user_name = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                        self.user_name.parent = self
                                                                                        self._children_name_map["user_name"] = "user-name"

                                                                                        self.user_name_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                        self.user_name_regex.parent = self
                                                                                        self._children_name_map["user_name_regex"] = "user-name-regex"

                                                                                        self.auth_username = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                        self.auth_username.parent = self
                                                                                        self._children_name_map["auth_username"] = "auth-username"

                                                                                        self.auth_username_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                        self.auth_username_regex.parent = self
                                                                                        self._children_name_map["auth_username_regex"] = "auth-username-regex"

                                                                                        self.unauth_username = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                        self.unauth_username.parent = self
                                                                                        self._children_name_map["unauth_username"] = "unauth-username"

                                                                                        self.unauth_username_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                        self.unauth_username_regex.parent = self
                                                                                        self._children_name_map["unauth_username_regex"] = "unauth-username-regex"

                                                                                        self.auth_domain = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                        self.auth_domain.parent = self
                                                                                        self._children_name_map["auth_domain"] = "auth-domain"

                                                                                        self.auth_domain_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                        self.auth_domain_regex.parent = self
                                                                                        self._children_name_map["auth_domain_regex"] = "auth-domain-regex"

                                                                                        self.unauth_domain = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                        self.unauth_domain.parent = self
                                                                                        self._children_name_map["unauth_domain"] = "unauth-domain"

                                                                                        self.unauth_domain_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                        self.unauth_domain_regex.parent = self
                                                                                        self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"

                                                                                        self.vendor_id = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                        self.vendor_id.parent = self
                                                                                        self._children_name_map["vendor_id"] = "vendor-id"

                                                                                        self.vendor_id_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                        self.vendor_id_regex.parent = self
                                                                                        self._children_name_map["vendor_id_regex"] = "vendor-id-regex"

                                                                                        self.access_interface = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                        self.access_interface.parent = self
                                                                                        self._children_name_map["access_interface"] = "access-interface"

                                                                                        self.input_interface = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                        self.input_interface.parent = self
                                                                                        self._children_name_map["input_interface"] = "input-interface"

                                                                                        self.input_intfhdl = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                        self.input_intfhdl.parent = self
                                                                                        self._children_name_map["input_intfhdl"] = "input-intfhdl"

                                                                                        self.ethertype = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                        self.ethertype.parent = self
                                                                                        self._children_name_map["ethertype"] = "ethertype"

                                                                                        self.flow_key_data = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                        self.flow_key_data.parent = self
                                                                                        self._children_name_map["flow_key_data"] = "flow-key-data"

                                                                                        self.dhcp_client_id = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                        self.dhcp_client_id.parent = self
                                                                                        self._children_name_map["dhcp_client_id"] = "dhcp-client-id"

                                                                                        self.dhcp_client_id_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                        self.dhcp_client_id_regex.parent = self
                                                                                        self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"

                                                                                        self.circuit_id = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                        self.circuit_id.parent = self
                                                                                        self._children_name_map["circuit_id"] = "circuit-id"

                                                                                        self.circuit_id_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                        self.circuit_id_regex.parent = self
                                                                                        self._children_name_map["circuit_id_regex"] = "circuit-id-regex"

                                                                                        self.remote_id = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                        self.remote_id.parent = self
                                                                                        self._children_name_map["remote_id"] = "remote-id"

                                                                                        self.remote_id_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                        self.remote_id_regex.parent = self
                                                                                        self._children_name_map["remote_id_regex"] = "remote-id-regex"

                                                                                        self.src_port = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                        self.src_port.parent = self
                                                                                        self._children_name_map["src_port"] = "src-port"

                                                                                        self.dst_port = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                        self.dst_port.parent = self
                                                                                        self._children_name_map["dst_port"] = "dst-port"
                                                                                        self._segment_path = lambda: "match-data"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, ['type', 'mpls_top_eos', 'fragment_type', 'authen_status', 'mlp_negotiated'], name, value)


                                                                                    class Ipv4Dscp(Entity):
                                                                                        """
                                                                                        IPv4 DSCP
                                                                                        
                                                                                        .. attribute:: uint8_rng_array
                                                                                        
                                                                                        	uint8 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                            self.yang_name = "ipv4-dscp"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint8_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "ipv4-dscp"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                        class Uint8RngArray(Entity):
                                                                                            """
                                                                                            uint8 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                self.yang_name = "uint8_rng_array"
                                                                                                self.yang_parent_name = "ipv4-dscp"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint8_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                    class Ipv6Dscp(Entity):
                                                                                        """
                                                                                        IPv6 DSCP
                                                                                        
                                                                                        .. attribute:: uint8_rng_array
                                                                                        
                                                                                        	uint8 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                            self.yang_name = "ipv6-dscp"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint8_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "ipv6-dscp"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                        class Uint8RngArray(Entity):
                                                                                            """
                                                                                            uint8 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                self.yang_name = "uint8_rng_array"
                                                                                                self.yang_parent_name = "ipv6-dscp"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint8_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                    class Dscp(Entity):
                                                                                        """
                                                                                        Match DSCP range array
                                                                                        
                                                                                        .. attribute:: uint8_rng_array
                                                                                        
                                                                                        	uint8 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                            self.yang_name = "dscp"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint8_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "dscp"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                        class Uint8RngArray(Entity):
                                                                                            """
                                                                                            uint8 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                self.yang_name = "uint8_rng_array"
                                                                                                self.yang_parent_name = "dscp"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint8_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                    class Ipv4Prec(Entity):
                                                                                        """
                                                                                        IPv4 Precedence
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                            self.yang_name = "ipv4-prec"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                            ])
                                                                                            self.uint8_array = []
                                                                                            self._segment_path = lambda: "ipv4-prec"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                    class Ipv6Prec(Entity):
                                                                                        """
                                                                                        IPv6 Precedence
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                            self.yang_name = "ipv6-prec"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                            ])
                                                                                            self.uint8_array = []
                                                                                            self._segment_path = lambda: "ipv6-prec"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                    class Prec(Entity):
                                                                                        """
                                                                                        Match Precedence array
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                            self.yang_name = "prec"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                            ])
                                                                                            self.uint8_array = []
                                                                                            self._segment_path = lambda: "prec"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                    class DiscardClass(Entity):
                                                                                        """
                                                                                        Match Discard Class array
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                            self.yang_name = "discard-class"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                            ])
                                                                                            self.uint8_array = []
                                                                                            self._segment_path = lambda: "discard-class"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                    class QosGroup(Entity):
                                                                                        """
                                                                                        Match QoS group array
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                            self.yang_name = "qos-group"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "qos-group"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "qos-group"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint16_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['min', 'max'], name, value)


                                                                                    class TrafficClass(Entity):
                                                                                        """
                                                                                        Match Traffic class array
                                                                                        
                                                                                        .. attribute:: uint8_rng_array
                                                                                        
                                                                                        	uint8 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                            self.yang_name = "traffic-class"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint8_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "traffic-class"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                        class Uint8RngArray(Entity):
                                                                                            """
                                                                                            uint8 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                self.yang_name = "uint8_rng_array"
                                                                                                self.yang_parent_name = "traffic-class"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint8_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['min', 'max'], name, value)


                                                                                    class Proto(Entity):
                                                                                        """
                                                                                        Match Protocol array
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                            self.yang_name = "proto"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "proto"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "proto"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint16_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['min', 'max'], name, value)


                                                                                    class IcmpV4(Entity):
                                                                                        """
                                                                                        Match ICMPV4 Protocol
                                                                                        
                                                                                        .. attribute:: type
                                                                                        
                                                                                        	Protocol type
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: code
                                                                                        
                                                                                        	Protocol code
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                            self.yang_name = "icmp-v4"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                            ])
                                                                                            self.type = None
                                                                                            self.code = None
                                                                                            self._segment_path = lambda: "icmp-v4"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['type', 'code'], name, value)


                                                                                    class IcmpV6(Entity):
                                                                                        """
                                                                                        Match ICMPV6 Protocol array
                                                                                        
                                                                                        .. attribute:: type
                                                                                        
                                                                                        	Protocol type
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: code
                                                                                        
                                                                                        	Protocol code
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                            self.yang_name = "icmp-v6"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                            ])
                                                                                            self.type = None
                                                                                            self.code = None
                                                                                            self._segment_path = lambda: "icmp-v6"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['type', 'code'], name, value)


                                                                                    class Ipv4PacketLen(Entity):
                                                                                        """
                                                                                        IPv4 packet length array
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                            self.yang_name = "ipv4-packet-len"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "ipv4-packet-len"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "ipv4-packet-len"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint16_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                    class Ipv6PacketLen(Entity):
                                                                                        """
                                                                                        IPv6 packet length array
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                            self.yang_name = "ipv6-packet-len"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "ipv6-packet-len"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "ipv6-packet-len"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint16_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                    class PacketLen(Entity):
                                                                                        """
                                                                                        Match packet length array
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                            self.yang_name = "packet-len"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "packet-len"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "packet-len"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint16_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                    class FlowTag(Entity):
                                                                                        """
                                                                                        Match flow\-tag array
                                                                                        
                                                                                        .. attribute:: uint8_rng_array
                                                                                        
                                                                                        	uint8 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                            self.yang_name = "flow-tag"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint8_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "flow-tag"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                        class Uint8RngArray(Entity):
                                                                                            """
                                                                                            uint8 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                self.yang_name = "uint8_rng_array"
                                                                                                self.yang_parent_name = "flow-tag"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint8_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['min', 'max'], name, value)


                                                                                    class TcpFlag(Entity):
                                                                                        """
                                                                                        Match tcp flag value
                                                                                        
                                                                                        .. attribute:: value
                                                                                        
                                                                                        	Value of TCP flag
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: match_any
                                                                                        
                                                                                        	Match any TCP flag bit
                                                                                        	**type**\: bool
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                            self.yang_name = "tcp-flag"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                                ('match_any', (YLeaf(YType.boolean, 'match-any'), ['bool'])),
                                                                                            ])
                                                                                            self.value = None
                                                                                            self.match_any = None
                                                                                            self._segment_path = lambda: "tcp-flag"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['value', 'match_any'], name, value)


                                                                                    class Icmpv4Type(Entity):
                                                                                        """
                                                                                        Match ipv4 icmp type
                                                                                        
                                                                                        .. attribute:: uint8_rng_array
                                                                                        
                                                                                        	uint8 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                            self.yang_name = "icmpv4-type"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint8_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "icmpv4-type"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                        class Uint8RngArray(Entity):
                                                                                            """
                                                                                            uint8 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                self.yang_name = "uint8_rng_array"
                                                                                                self.yang_parent_name = "icmpv4-type"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint8_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                    class Icmpv4Code(Entity):
                                                                                        """
                                                                                        Match ipv4 icmp code
                                                                                        
                                                                                        .. attribute:: uint8_rng_array
                                                                                        
                                                                                        	uint8 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                            self.yang_name = "icmpv4-code"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint8_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "icmpv4-code"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                        class Uint8RngArray(Entity):
                                                                                            """
                                                                                            uint8 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                self.yang_name = "uint8_rng_array"
                                                                                                self.yang_parent_name = "icmpv4-code"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint8_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                    class Icmpv6Type(Entity):
                                                                                        """
                                                                                        Match ipv6 icmp type
                                                                                        
                                                                                        .. attribute:: uint8_rng_array
                                                                                        
                                                                                        	uint8 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                            self.yang_name = "icmpv6-type"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint8_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "icmpv6-type"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                        class Uint8RngArray(Entity):
                                                                                            """
                                                                                            uint8 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                self.yang_name = "uint8_rng_array"
                                                                                                self.yang_parent_name = "icmpv6-type"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint8_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                    class Icmpv6Code(Entity):
                                                                                        """
                                                                                        Match ipv6 icmp code
                                                                                        
                                                                                        .. attribute:: uint8_rng_array
                                                                                        
                                                                                        	uint8 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                            self.yang_name = "icmpv6-code"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint8_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "icmpv6-code"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                        class Uint8RngArray(Entity):
                                                                                            """
                                                                                            uint8 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                self.yang_name = "uint8_rng_array"
                                                                                                self.yang_parent_name = "icmpv6-code"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint8_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                    class MplsExp(Entity):
                                                                                        """
                                                                                        Match MPLS experimental topmost array
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                            self.yang_name = "mpls-exp"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                            ])
                                                                                            self.uint8_array = []
                                                                                            self._segment_path = lambda: "mpls-exp"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                    class MplsExpImp(Entity):
                                                                                        """
                                                                                        Match MPLS experimental imposition array
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                            self.yang_name = "mpls-exp-imp"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                            ])
                                                                                            self.uint8_array = []
                                                                                            self._segment_path = lambda: "mpls-exp-imp"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                    class MplsDispIpv4Acl(Entity):
                                                                                        """
                                                                                        MPLS Disposition IPv4 Access\-list
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                            self.yang_name = "mpls-disp-ipv4-acl"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "mpls-disp-ipv4-acl"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                    class MplsDispIpv6Acl(Entity):
                                                                                        """
                                                                                        MPLS Disposition IPv6 Access\-list
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                            self.yang_name = "mpls-disp-ipv6-acl"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "mpls-disp-ipv6-acl"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                    class MplsTopLabel(Entity):
                                                                                        """
                                                                                        MPLS Topmost LABEL
                                                                                        
                                                                                        .. attribute:: uint32_rng_array
                                                                                        
                                                                                        	uint32 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                            self.yang_name = "mpls-top-label"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint32_rng_array", ("uint32_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint32_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "mpls-top-label"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                        class Uint32RngArray(Entity):
                                                                                            """
                                                                                            uint32 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                self.yang_name = "uint32_rng_array"
                                                                                                self.yang_parent_name = "mpls-top-label"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint32, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint32, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint32_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['min', 'max'], name, value)


                                                                                    class Cos(Entity):
                                                                                        """
                                                                                        Match CoS array
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                            self.yang_name = "cos"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                            ])
                                                                                            self.uint8_array = []
                                                                                            self._segment_path = lambda: "cos"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                    class CosInr(Entity):
                                                                                        """
                                                                                        Match inner header CoS
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                            self.yang_name = "cos-inr"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                            ])
                                                                                            self.uint8_array = []
                                                                                            self._segment_path = lambda: "cos-inr"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                    class Dei(Entity):
                                                                                        """
                                                                                        Match DEI Bit
                                                                                        
                                                                                        .. attribute:: bit_value
                                                                                        
                                                                                        	Value of the DEI bit
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                            self.yang_name = "dei"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                            ])
                                                                                            self.bit_value = None
                                                                                            self._segment_path = lambda: "dei"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                    class DeiInr(Entity):
                                                                                        """
                                                                                        Match inner DEI Bit
                                                                                        
                                                                                        .. attribute:: bit_value
                                                                                        
                                                                                        	Value of the DEI bit
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                            self.yang_name = "dei-inr"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                            ])
                                                                                            self.bit_value = None
                                                                                            self._segment_path = lambda: "dei-inr"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                    class Vlan(Entity):
                                                                                        """
                                                                                        Match VLAN array
                                                                                        
                                                                                        .. attribute:: vlan_id_array
                                                                                        
                                                                                        	vlan id array
                                                                                        	**type**\: list of  		 :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                            self.yang_name = "vlan"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("vlan-id-array", ("vlan_id_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.vlan_id_array = YList(self)
                                                                                            self._segment_path = lambda: "vlan"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                        class VlanIdArray(Entity):
                                                                                            """
                                                                                            vlan id array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	VLAN mask
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                self.yang_name = "vlan-id-array"
                                                                                                self.yang_parent_name = "vlan"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ('mask', (YLeaf(YType.uint16, 'mask'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self.mask = None
                                                                                                self._segment_path = lambda: "vlan-id-array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['min', 'max', 'mask'], name, value)


                                                                                    class VlanInr(Entity):
                                                                                        """
                                                                                        Match inner header VLAN range array
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                            self.yang_name = "vlan-inr"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "vlan-inr"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "vlan-inr"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint16_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['min', 'max'], name, value)


                                                                                    class FrDlci(Entity):
                                                                                        """
                                                                                        Match FR DLCI range array
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                            self.yang_name = "fr-dlci"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "fr-dlci"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "fr-dlci"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint16_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['min', 'max'], name, value)


                                                                                    class SrcMac(Entity):
                                                                                        """
                                                                                        Match Source MAC address
                                                                                        
                                                                                        .. attribute:: mac_addr
                                                                                        
                                                                                        	MAC address
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: mask
                                                                                        
                                                                                        	MAC mask
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                            self.yang_name = "src-mac"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                            ])
                                                                                            self.mac_addr = []
                                                                                            self.mask = []
                                                                                            self._segment_path = lambda: "src-mac"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                    class DstMac(Entity):
                                                                                        """
                                                                                        Match Destination MAC address
                                                                                        
                                                                                        .. attribute:: mac_addr
                                                                                        
                                                                                        	MAC address
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: mask
                                                                                        
                                                                                        	MAC mask
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                            self.yang_name = "dst-mac"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                            ])
                                                                                            self.mac_addr = []
                                                                                            self.mask = []
                                                                                            self._segment_path = lambda: "dst-mac"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                    class AtmClp(Entity):
                                                                                        """
                                                                                        Match ATM CLP level
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                            self.yang_name = "atm-clp"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                            ])
                                                                                            self.uint8_array = []
                                                                                            self._segment_path = lambda: "atm-clp"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                    class FrDe(Entity):
                                                                                        """
                                                                                        Match FR DE value
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                            self.yang_name = "fr-de"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                            ])
                                                                                            self.uint8_array = []
                                                                                            self._segment_path = lambda: "fr-de"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                    class Ipv4Acl(Entity):
                                                                                        """
                                                                                        IPv4 Access\-list
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                            self.yang_name = "ipv4-acl"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "ipv4-acl"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                    class Ipv6Acl(Entity):
                                                                                        """
                                                                                        IPv6 Access\-list
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                            self.yang_name = "ipv6-acl"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "ipv6-acl"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                    class EtherServiceAcl(Entity):
                                                                                        """
                                                                                        Ethernet\-Services Access\-list
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                            self.yang_name = "ether-service-acl"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "ether-service-acl"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                    class AvailId(Entity):
                                                                                        """
                                                                                        Available Identifiers
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                            self.yang_name = "avail-id"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                            ])
                                                                                            self.uint8_array = []
                                                                                            self._segment_path = lambda: "avail-id"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                    class MediaType(Entity):
                                                                                        """
                                                                                        Media Type
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                            self.yang_name = "media-type"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                            ])
                                                                                            self.uint8_array = []
                                                                                            self._segment_path = lambda: "media-type"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                    class SubsProtocol(Entity):
                                                                                        """
                                                                                        Protocol
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                            self.yang_name = "subs-protocol"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                            ])
                                                                                            self.uint8_array = []
                                                                                            self._segment_path = lambda: "subs-protocol"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                    class Dnis(Entity):
                                                                                        """
                                                                                        DNIS
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                            self.yang_name = "dnis"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "dnis"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                    class DnisRegex(Entity):
                                                                                        """
                                                                                        DNIS Regular Expression
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                            self.yang_name = "dnis-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "dnis-regex"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                    class Domain(Entity):
                                                                                        """
                                                                                        Domain Name
                                                                                        
                                                                                        .. attribute:: domain_array
                                                                                        
                                                                                        	domain array
                                                                                        	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                            self.yang_name = "domain"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.domain_array = YList(self)
                                                                                            self._segment_path = lambda: "domain"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                        class DomainArray(Entity):
                                                                                            """
                                                                                            domain array
                                                                                            
                                                                                            .. attribute:: domain_name
                                                                                            
                                                                                            	domain name
                                                                                            	**type**\: str
                                                                                            
                                                                                            .. attribute:: format_name
                                                                                            
                                                                                            	format name
                                                                                            	**type**\: str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                self.yang_name = "domain-array"
                                                                                                self.yang_parent_name = "domain"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                    ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                ])
                                                                                                self.domain_name = None
                                                                                                self.format_name = None
                                                                                                self._segment_path = lambda: "domain-array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                    class DomainRegex(Entity):
                                                                                        """
                                                                                        Domain Regular Expression
                                                                                        
                                                                                        .. attribute:: domain_array
                                                                                        
                                                                                        	domain array
                                                                                        	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                            self.yang_name = "domain-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.domain_array = YList(self)
                                                                                            self._segment_path = lambda: "domain-regex"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                        class DomainArray(Entity):
                                                                                            """
                                                                                            domain array
                                                                                            
                                                                                            .. attribute:: domain_name
                                                                                            
                                                                                            	domain name
                                                                                            	**type**\: str
                                                                                            
                                                                                            .. attribute:: format_name
                                                                                            
                                                                                            	format name
                                                                                            	**type**\: str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                self.yang_name = "domain-array"
                                                                                                self.yang_parent_name = "domain-regex"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                    ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                ])
                                                                                                self.domain_name = None
                                                                                                self.format_name = None
                                                                                                self._segment_path = lambda: "domain-array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                    class NasPort(Entity):
                                                                                        """
                                                                                        NAS Port
                                                                                        
                                                                                        .. attribute:: nas_port_array
                                                                                        
                                                                                        	nas port array
                                                                                        	**type**\: list of  		 :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                            self.yang_name = "nas-port"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("nas-port-array", ("nas_port_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.nas_port_array = YList(self)
                                                                                            self._segment_path = lambda: "nas-port"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                        class NasPortArray(Entity):
                                                                                            """
                                                                                            nas port array
                                                                                            
                                                                                            .. attribute:: sub_id
                                                                                            
                                                                                            	sub id
                                                                                            	**type**\:  :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                            
                                                                                            .. attribute:: operator
                                                                                            
                                                                                            	operator
                                                                                            	**type**\:  :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                            
                                                                                            .. attribute:: value
                                                                                            
                                                                                            	value
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                self.yang_name = "nas-port-array"
                                                                                                self.yang_parent_name = "nas-port"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('sub_id', (YLeaf(YType.enumeration, 'sub-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchNasPortSubIdEn', '')])),
                                                                                                    ('operator', (YLeaf(YType.enumeration, 'operator'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchLogicalOperatorEn', '')])),
                                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                                ])
                                                                                                self.sub_id = None
                                                                                                self.operator = None
                                                                                                self.value = None
                                                                                                self._segment_path = lambda: "nas-port-array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['sub_id', 'operator', 'value'], name, value)


                                                                                    class ServiceName(Entity):
                                                                                        """
                                                                                        Service Name
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                            self.yang_name = "service-name"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "service-name"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                    class ServiceNameRegex(Entity):
                                                                                        """
                                                                                        Service Name Regular Exp
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                            self.yang_name = "service-name-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "service-name-regex"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                    class SrcAddrIpv4(Entity):
                                                                                        """
                                                                                        Source Address IPV4
                                                                                        
                                                                                        .. attribute:: ipv4_addr_array
                                                                                        
                                                                                        	ipv4 addr array
                                                                                        	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                            self.yang_name = "src-addr-ipv4"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.ipv4_addr_array = YList(self)
                                                                                            self._segment_path = lambda: "src-addr-ipv4"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                        class Ipv4AddrArray(Entity):
                                                                                            """
                                                                                            ipv4 addr array
                                                                                            
                                                                                            .. attribute:: prefix
                                                                                            
                                                                                            	prefix
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	mask
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                self.yang_name = "ipv4-addr-array"
                                                                                                self.yang_parent_name = "src-addr-ipv4"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                    ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                ])
                                                                                                self.prefix = None
                                                                                                self.mask = None
                                                                                                self._segment_path = lambda: "ipv4-addr-array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                    class DstAddrIpv4(Entity):
                                                                                        """
                                                                                        Destination Address IPV4
                                                                                        
                                                                                        .. attribute:: ipv4_addr_array
                                                                                        
                                                                                        	ipv4 addr array
                                                                                        	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                            self.yang_name = "dst-addr-ipv4"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.ipv4_addr_array = YList(self)
                                                                                            self._segment_path = lambda: "dst-addr-ipv4"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                        class Ipv4AddrArray(Entity):
                                                                                            """
                                                                                            ipv4 addr array
                                                                                            
                                                                                            .. attribute:: prefix
                                                                                            
                                                                                            	prefix
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	mask
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                self.yang_name = "ipv4-addr-array"
                                                                                                self.yang_parent_name = "dst-addr-ipv4"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                    ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                ])
                                                                                                self.prefix = None
                                                                                                self.mask = None
                                                                                                self._segment_path = lambda: "ipv4-addr-array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                    class SrcAddrIpv6(Entity):
                                                                                        """
                                                                                        Source Address IPV6
                                                                                        
                                                                                        .. attribute:: ipv6_addr_array
                                                                                        
                                                                                        	ipv6 addr array
                                                                                        	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                            self.yang_name = "src-addr-ipv6"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.ipv6_addr_array = YList(self)
                                                                                            self._segment_path = lambda: "src-addr-ipv6"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                        class Ipv6AddrArray(Entity):
                                                                                            """
                                                                                            ipv6 addr array
                                                                                            
                                                                                            .. attribute:: prefix
                                                                                            
                                                                                            	IPV6 prefix
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	IPV6 mask
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                self.yang_name = "ipv6-addr-array"
                                                                                                self.yang_parent_name = "src-addr-ipv6"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                    ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                ])
                                                                                                self.prefix = None
                                                                                                self.mask = None
                                                                                                self._segment_path = lambda: "ipv6-addr-array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                    class DstAddrIpv6(Entity):
                                                                                        """
                                                                                        Destination Address IPV6
                                                                                        
                                                                                        .. attribute:: ipv6_addr_array
                                                                                        
                                                                                        	ipv6 addr array
                                                                                        	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                            self.yang_name = "dst-addr-ipv6"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.ipv6_addr_array = YList(self)
                                                                                            self._segment_path = lambda: "dst-addr-ipv6"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                        class Ipv6AddrArray(Entity):
                                                                                            """
                                                                                            ipv6 addr array
                                                                                            
                                                                                            .. attribute:: prefix
                                                                                            
                                                                                            	IPV6 prefix
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	IPV6 mask
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                self.yang_name = "ipv6-addr-array"
                                                                                                self.yang_parent_name = "dst-addr-ipv6"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                    ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                ])
                                                                                                self.prefix = None
                                                                                                self.mask = None
                                                                                                self._segment_path = lambda: "ipv6-addr-array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                    class SrcAddrMac(Entity):
                                                                                        """
                                                                                        Source Address MAC
                                                                                        
                                                                                        .. attribute:: mac_addr_array
                                                                                        
                                                                                        	mac addr array
                                                                                        	**type**\: list of  		 :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                            self.yang_name = "src-addr-mac"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("mac-addr-array", ("mac_addr_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.mac_addr_array = YList(self)
                                                                                            self._segment_path = lambda: "src-addr-mac"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                        class MacAddrArray(Entity):
                                                                                            """
                                                                                            mac addr array
                                                                                            
                                                                                            .. attribute:: mac_addr
                                                                                            
                                                                                            	MAC address
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	MAC mask
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                self.yang_name = "mac-addr-array"
                                                                                                self.yang_parent_name = "src-addr-mac"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                    ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                ])
                                                                                                self.mac_addr = []
                                                                                                self.mask = []
                                                                                                self._segment_path = lambda: "mac-addr-array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                    class Timer(Entity):
                                                                                        """
                                                                                        Timer
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                            self.yang_name = "timer"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "timer"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                    class TimerRegexp(Entity):
                                                                                        """
                                                                                        Timer Regular Expression
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                            self.yang_name = "timer-regexp"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "timer-regexp"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                    class TunnelName(Entity):
                                                                                        """
                                                                                        Tunnel Name
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                            self.yang_name = "tunnel-name"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "tunnel-name"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                    class TunnelNameRegex(Entity):
                                                                                        """
                                                                                        Tunnel Name Regular Expression
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                            self.yang_name = "tunnel-name-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "tunnel-name-regex"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                    class UserName(Entity):
                                                                                        """
                                                                                        User Name
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                            self.yang_name = "user-name"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "user-name"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                    class UserNameRegex(Entity):
                                                                                        """
                                                                                        User Name Regular Expression
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                            self.yang_name = "user-name-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "user-name-regex"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                    class AuthUsername(Entity):
                                                                                        """
                                                                                        Authenticated User Name
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                            self.yang_name = "auth-username"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "auth-username"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                    class AuthUsernameRegex(Entity):
                                                                                        """
                                                                                        Authenticated User Name RegEx
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                            self.yang_name = "auth-username-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "auth-username-regex"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                    class UnauthUsername(Entity):
                                                                                        """
                                                                                        Unauthenticated User Name
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                            self.yang_name = "unauth-username"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "unauth-username"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                    class UnauthUsernameRegex(Entity):
                                                                                        """
                                                                                        Unauthenticated User Name RegEx
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                            self.yang_name = "unauth-username-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "unauth-username-regex"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                    class AuthDomain(Entity):
                                                                                        """
                                                                                        Authenticated domain name
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                            self.yang_name = "auth-domain"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "auth-domain"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                    class AuthDomainRegex(Entity):
                                                                                        """
                                                                                        Authenticated Domain Name RegEx
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                            self.yang_name = "auth-domain-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "auth-domain-regex"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                    class UnauthDomain(Entity):
                                                                                        """
                                                                                        Unauthenticated Domain Name
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                            self.yang_name = "unauth-domain"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "unauth-domain"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                    class UnauthDomainRegex(Entity):
                                                                                        """
                                                                                        Unauthenticated Domain Name RegEx
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                            self.yang_name = "unauth-domain-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "unauth-domain-regex"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                    class VendorId(Entity):
                                                                                        """
                                                                                        Vendor ID
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                            self.yang_name = "vendor-id"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "vendor-id"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                    class VendorIdRegex(Entity):
                                                                                        """
                                                                                        Vendor ID RegEx
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                            self.yang_name = "vendor-id-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "vendor-id-regex"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                    class AccessInterface(Entity):
                                                                                        """
                                                                                        Access interface
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                            self.yang_name = "access-interface"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "access-interface"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                    class InputInterface(Entity):
                                                                                        """
                                                                                        Input interface
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                            self.yang_name = "input-interface"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "input-interface"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                    class InputIntfhdl(Entity):
                                                                                        """
                                                                                        Input interface handle
                                                                                        
                                                                                        .. attribute:: uint64_array
                                                                                        
                                                                                        	uint64 array
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..18446744073709551615
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                            self.yang_name = "input-intfhdl"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('uint64_array', (YLeafList(YType.uint64, 'uint64_array'), ['int'])),
                                                                                            ])
                                                                                            self.uint64_array = []
                                                                                            self._segment_path = lambda: "input-intfhdl"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                    class Ethertype(Entity):
                                                                                        """
                                                                                        Ethernet type
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                            self.yang_name = "ethertype"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "ethertype"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "ethertype"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint16_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['min', 'max'], name, value)


                                                                                    class FlowKeyData(Entity):
                                                                                        """
                                                                                        Flow key structure
                                                                                        
                                                                                        .. attribute:: flow_keys
                                                                                        
                                                                                        	flow keys
                                                                                        	**type**\:  :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                        
                                                                                        .. attribute:: max_count
                                                                                        
                                                                                        	Maximum count of flows
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: idle_timeout
                                                                                        
                                                                                        	Idle timeout of flows (in seconds)
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        	**units**\: second
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                            self.yang_name = "flow-key-data"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("flow-keys", ("flow_keys", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys))])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('max_count', (YLeaf(YType.uint16, 'max-count'), ['int'])),
                                                                                                ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                                            ])
                                                                                            self.max_count = None
                                                                                            self.idle_timeout = None

                                                                                            self.flow_keys = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                            self.flow_keys.parent = self
                                                                                            self._children_name_map["flow_keys"] = "flow-keys"
                                                                                            self._segment_path = lambda: "flow-key-data"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['max_count', 'idle_timeout'], name, value)


                                                                                        class FlowKeys(Entity):
                                                                                            """
                                                                                            flow keys
                                                                                            
                                                                                            .. attribute:: keys
                                                                                            
                                                                                            	keys
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                            
                                                                                            .. attribute:: num
                                                                                            
                                                                                            	num
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                self.yang_name = "flow-keys"
                                                                                                self.yang_parent_name = "flow-key-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('keys', (YLeaf(YType.str, 'keys'), ['str'])),
                                                                                                    ('num', (YLeaf(YType.uint8, 'num'), ['int'])),
                                                                                                ])
                                                                                                self.keys = None
                                                                                                self.num = None
                                                                                                self._segment_path = lambda: "flow-keys"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                    class DhcpClientId(Entity):
                                                                                        """
                                                                                        Dhcp Client ID
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                            self.yang_name = "dhcp-client-id"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "dhcp-client-id"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                    class DhcpClientIdRegex(Entity):
                                                                                        """
                                                                                        Dhcp Client ID RegEx
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                            self.yang_name = "dhcp-client-id-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "dhcp-client-id-regex"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                    class CircuitId(Entity):
                                                                                        """
                                                                                        Circuit ID
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                            self.yang_name = "circuit-id"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "circuit-id"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                    class CircuitIdRegex(Entity):
                                                                                        """
                                                                                        Circuit ID RegEx
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                            self.yang_name = "circuit-id-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "circuit-id-regex"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                    class RemoteId(Entity):
                                                                                        """
                                                                                        Remote ID
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                            self.yang_name = "remote-id"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "remote-id"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                    class RemoteIdRegex(Entity):
                                                                                        """
                                                                                        Remote ID RegEx
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                            self.yang_name = "remote-id-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "remote-id-regex"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                    class SrcPort(Entity):
                                                                                        """
                                                                                        Source port
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                            self.yang_name = "src-port"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "src-port"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "src-port"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint16_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                                    class DstPort(Entity):
                                                                                        """
                                                                                        Destination port
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                            self.yang_name = "dst-port"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "dst-port"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "dst-port"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint16_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                class ExcdclassP(Entity):
                                                                    """
                                                                    excdclass p
                                                                    
                                                                    .. attribute:: class_map_bg
                                                                    
                                                                    	class map bg
                                                                    	**type**\: list of  		 :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP, self).__init__()

                                                                        self.yang_name = "excdclass-p"
                                                                        self.yang_parent_name = "police"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("class-map-bg", ("class_map_bg", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg))])
                                                                        self._leafs = OrderedDict()

                                                                        self.class_map_bg = YList(self)
                                                                        self._segment_path = lambda: "excdclass-p"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP, [], name, value)


                                                                    class ClassMapBg(Entity):
                                                                        """
                                                                        class map bg
                                                                        
                                                                        .. attribute:: match_infop
                                                                        
                                                                        	Pointer to the first Match info
                                                                        	**type**\:  :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop>`
                                                                        
                                                                        .. attribute:: name
                                                                        
                                                                        	Name of the class\-map
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..65
                                                                        
                                                                        .. attribute:: type
                                                                        
                                                                        	Class\-Map Type QoS/PBR/Netflow/..
                                                                        	**type**\:  :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                                        
                                                                        .. attribute:: mode
                                                                        
                                                                        	Class\-Map Mode Match any/Match all
                                                                        	**type**\:  :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                        
                                                                        .. attribute:: description
                                                                        
                                                                        	description
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg, self).__init__()

                                                                            self.yang_name = "class-map-bg"
                                                                            self.yang_parent_name = "excdclass-p"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("match-infop", ("match_infop", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop))])
                                                                            self._leafs = OrderedDict([
                                                                                ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                                ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapTypeEn', '')])),
                                                                                ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapModeEn', '')])),
                                                                                ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                            ])
                                                                            self.name = None
                                                                            self.type = None
                                                                            self.mode = None
                                                                            self.description = None

                                                                            self.match_infop = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop()
                                                                            self.match_infop.parent = self
                                                                            self._children_name_map["match_infop"] = "match-infop"
                                                                            self._segment_path = lambda: "class-map-bg"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg, ['name', 'type', 'mode', 'description'], name, value)


                                                                        class MatchInfop(Entity):
                                                                            """
                                                                            Pointer to the first Match info
                                                                            
                                                                            .. attribute:: class_match_info_st
                                                                            
                                                                            	class match info st
                                                                            	**type**\: list of  		 :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop, self).__init__()

                                                                                self.yang_name = "match-infop"
                                                                                self.yang_parent_name = "class-map-bg"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("class-match-info-st", ("class_match_info_st", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt))])
                                                                                self._leafs = OrderedDict()

                                                                                self.class_match_info_st = YList(self)
                                                                                self._segment_path = lambda: "match-infop"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop, [], name, value)


                                                                            class ClassMatchInfoSt(Entity):
                                                                                """
                                                                                class match info st
                                                                                
                                                                                .. attribute:: match_data
                                                                                
                                                                                	Match criteria
                                                                                	**type**\:  :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                
                                                                                .. attribute:: flags
                                                                                
                                                                                	Flags
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                    self.yang_name = "class-match-info-st"
                                                                                    self.yang_parent_name = "match-infop"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("match-data", ("match_data", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                    ])
                                                                                    self.flags = None

                                                                                    self.match_data = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                    self.match_data.parent = self
                                                                                    self._children_name_map["match_data"] = "match-data"
                                                                                    self._segment_path = lambda: "class-match-info-st"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                class MatchData(Entity):
                                                                                    """
                                                                                    Match criteria
                                                                                    
                                                                                    .. attribute:: ipv4_dscp
                                                                                    
                                                                                    	IPv4 DSCP
                                                                                    	**type**\:  :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                    
                                                                                    .. attribute:: ipv6_dscp
                                                                                    
                                                                                    	IPv6 DSCP
                                                                                    	**type**\:  :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                    
                                                                                    .. attribute:: dscp
                                                                                    
                                                                                    	Match DSCP range array
                                                                                    	**type**\:  :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                    
                                                                                    .. attribute:: ipv4_prec
                                                                                    
                                                                                    	IPv4 Precedence
                                                                                    	**type**\:  :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                    
                                                                                    .. attribute:: ipv6_prec
                                                                                    
                                                                                    	IPv6 Precedence
                                                                                    	**type**\:  :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                    
                                                                                    .. attribute:: prec
                                                                                    
                                                                                    	Match Precedence array
                                                                                    	**type**\:  :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                    
                                                                                    .. attribute:: discard_class
                                                                                    
                                                                                    	Match Discard Class array
                                                                                    	**type**\:  :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                    
                                                                                    .. attribute:: qos_group
                                                                                    
                                                                                    	Match QoS group array
                                                                                    	**type**\:  :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                    
                                                                                    .. attribute:: traffic_class
                                                                                    
                                                                                    	Match Traffic class array
                                                                                    	**type**\:  :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                    
                                                                                    .. attribute:: proto
                                                                                    
                                                                                    	Match Protocol array
                                                                                    	**type**\:  :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                    
                                                                                    .. attribute:: icmp_v4
                                                                                    
                                                                                    	Match ICMPV4 Protocol
                                                                                    	**type**\:  :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                    
                                                                                    .. attribute:: icmp_v6
                                                                                    
                                                                                    	Match ICMPV6 Protocol array
                                                                                    	**type**\:  :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                    
                                                                                    .. attribute:: ipv4_packet_len
                                                                                    
                                                                                    	IPv4 packet length array
                                                                                    	**type**\:  :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                    
                                                                                    .. attribute:: ipv6_packet_len
                                                                                    
                                                                                    	IPv6 packet length array
                                                                                    	**type**\:  :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                    
                                                                                    .. attribute:: packet_len
                                                                                    
                                                                                    	Match packet length array
                                                                                    	**type**\:  :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                    
                                                                                    .. attribute:: flow_tag
                                                                                    
                                                                                    	Match flow\-tag array
                                                                                    	**type**\:  :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                    
                                                                                    .. attribute:: tcp_flag
                                                                                    
                                                                                    	Match tcp flag value
                                                                                    	**type**\:  :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                    
                                                                                    .. attribute:: icmpv4_type
                                                                                    
                                                                                    	Match ipv4 icmp type
                                                                                    	**type**\:  :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                    
                                                                                    .. attribute:: icmpv4_code
                                                                                    
                                                                                    	Match ipv4 icmp code
                                                                                    	**type**\:  :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                    
                                                                                    .. attribute:: icmpv6_type
                                                                                    
                                                                                    	Match ipv6 icmp type
                                                                                    	**type**\:  :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                    
                                                                                    .. attribute:: icmpv6_code
                                                                                    
                                                                                    	Match ipv6 icmp code
                                                                                    	**type**\:  :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                    
                                                                                    .. attribute:: mpls_exp
                                                                                    
                                                                                    	Match MPLS experimental topmost array
                                                                                    	**type**\:  :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                    
                                                                                    .. attribute:: mpls_exp_imp
                                                                                    
                                                                                    	Match MPLS experimental imposition array
                                                                                    	**type**\:  :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                    
                                                                                    .. attribute:: mpls_disp_ipv4_acl
                                                                                    
                                                                                    	MPLS Disposition IPv4 Access\-list
                                                                                    	**type**\:  :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                    
                                                                                    .. attribute:: mpls_disp_ipv6_acl
                                                                                    
                                                                                    	MPLS Disposition IPv6 Access\-list
                                                                                    	**type**\:  :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                    
                                                                                    .. attribute:: mpls_top_label
                                                                                    
                                                                                    	MPLS Topmost LABEL
                                                                                    	**type**\:  :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                    
                                                                                    .. attribute:: cos
                                                                                    
                                                                                    	Match CoS array
                                                                                    	**type**\:  :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                    
                                                                                    .. attribute:: cos_inr
                                                                                    
                                                                                    	Match inner header CoS
                                                                                    	**type**\:  :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                    
                                                                                    .. attribute:: dei
                                                                                    
                                                                                    	Match DEI Bit
                                                                                    	**type**\:  :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                    
                                                                                    .. attribute:: dei_inr
                                                                                    
                                                                                    	Match inner DEI Bit
                                                                                    	**type**\:  :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                    
                                                                                    .. attribute:: vlan
                                                                                    
                                                                                    	Match VLAN array
                                                                                    	**type**\:  :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                    
                                                                                    .. attribute:: vlan_inr
                                                                                    
                                                                                    	Match inner header VLAN range array
                                                                                    	**type**\:  :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                    
                                                                                    .. attribute:: fr_dlci
                                                                                    
                                                                                    	Match FR DLCI range array
                                                                                    	**type**\:  :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                    
                                                                                    .. attribute:: src_mac
                                                                                    
                                                                                    	Match Source MAC address
                                                                                    	**type**\:  :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                    
                                                                                    .. attribute:: dst_mac
                                                                                    
                                                                                    	Match Destination MAC address
                                                                                    	**type**\:  :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                    
                                                                                    .. attribute:: atm_clp
                                                                                    
                                                                                    	Match ATM CLP level
                                                                                    	**type**\:  :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                    
                                                                                    .. attribute:: fr_de
                                                                                    
                                                                                    	Match FR DE value
                                                                                    	**type**\:  :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                    
                                                                                    .. attribute:: ipv4_acl
                                                                                    
                                                                                    	IPv4 Access\-list
                                                                                    	**type**\:  :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                    
                                                                                    .. attribute:: ipv6_acl
                                                                                    
                                                                                    	IPv6 Access\-list
                                                                                    	**type**\:  :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                    
                                                                                    .. attribute:: ether_service_acl
                                                                                    
                                                                                    	Ethernet\-Services Access\-list
                                                                                    	**type**\:  :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                    
                                                                                    .. attribute:: avail_id
                                                                                    
                                                                                    	Available Identifiers
                                                                                    	**type**\:  :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                    
                                                                                    .. attribute:: media_type
                                                                                    
                                                                                    	Media Type
                                                                                    	**type**\:  :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                    
                                                                                    .. attribute:: subs_protocol
                                                                                    
                                                                                    	Protocol
                                                                                    	**type**\:  :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                    
                                                                                    .. attribute:: dnis
                                                                                    
                                                                                    	DNIS
                                                                                    	**type**\:  :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                    
                                                                                    .. attribute:: dnis_regex
                                                                                    
                                                                                    	DNIS Regular Expression
                                                                                    	**type**\:  :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                    
                                                                                    .. attribute:: domain
                                                                                    
                                                                                    	Domain Name
                                                                                    	**type**\:  :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                    
                                                                                    .. attribute:: domain_regex
                                                                                    
                                                                                    	Domain Regular Expression
                                                                                    	**type**\:  :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                    
                                                                                    .. attribute:: nas_port
                                                                                    
                                                                                    	NAS Port
                                                                                    	**type**\:  :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                    
                                                                                    .. attribute:: service_name
                                                                                    
                                                                                    	Service Name
                                                                                    	**type**\:  :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                    
                                                                                    .. attribute:: service_name_regex
                                                                                    
                                                                                    	Service Name Regular Exp
                                                                                    	**type**\:  :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                    
                                                                                    .. attribute:: src_addr_ipv4
                                                                                    
                                                                                    	Source Address IPV4
                                                                                    	**type**\:  :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                    
                                                                                    .. attribute:: dst_addr_ipv4
                                                                                    
                                                                                    	Destination Address IPV4
                                                                                    	**type**\:  :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                    
                                                                                    .. attribute:: src_addr_ipv6
                                                                                    
                                                                                    	Source Address IPV6
                                                                                    	**type**\:  :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                    
                                                                                    .. attribute:: dst_addr_ipv6
                                                                                    
                                                                                    	Destination Address IPV6
                                                                                    	**type**\:  :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                    
                                                                                    .. attribute:: src_addr_mac
                                                                                    
                                                                                    	Source Address MAC
                                                                                    	**type**\:  :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                    
                                                                                    .. attribute:: timer
                                                                                    
                                                                                    	Timer
                                                                                    	**type**\:  :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                    
                                                                                    .. attribute:: timer_regexp
                                                                                    
                                                                                    	Timer Regular Expression
                                                                                    	**type**\:  :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                    
                                                                                    .. attribute:: tunnel_name
                                                                                    
                                                                                    	Tunnel Name
                                                                                    	**type**\:  :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                    
                                                                                    .. attribute:: tunnel_name_regex
                                                                                    
                                                                                    	Tunnel Name Regular Expression
                                                                                    	**type**\:  :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                    
                                                                                    .. attribute:: user_name
                                                                                    
                                                                                    	User Name
                                                                                    	**type**\:  :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                    
                                                                                    .. attribute:: user_name_regex
                                                                                    
                                                                                    	User Name Regular Expression
                                                                                    	**type**\:  :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                    
                                                                                    .. attribute:: auth_username
                                                                                    
                                                                                    	Authenticated User Name
                                                                                    	**type**\:  :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                    
                                                                                    .. attribute:: auth_username_regex
                                                                                    
                                                                                    	Authenticated User Name RegEx
                                                                                    	**type**\:  :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                    
                                                                                    .. attribute:: unauth_username
                                                                                    
                                                                                    	Unauthenticated User Name
                                                                                    	**type**\:  :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                    
                                                                                    .. attribute:: unauth_username_regex
                                                                                    
                                                                                    	Unauthenticated User Name RegEx
                                                                                    	**type**\:  :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                    
                                                                                    .. attribute:: auth_domain
                                                                                    
                                                                                    	Authenticated domain name
                                                                                    	**type**\:  :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                    
                                                                                    .. attribute:: auth_domain_regex
                                                                                    
                                                                                    	Authenticated Domain Name RegEx
                                                                                    	**type**\:  :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                    
                                                                                    .. attribute:: unauth_domain
                                                                                    
                                                                                    	Unauthenticated Domain Name
                                                                                    	**type**\:  :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                    
                                                                                    .. attribute:: unauth_domain_regex
                                                                                    
                                                                                    	Unauthenticated Domain Name RegEx
                                                                                    	**type**\:  :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                    
                                                                                    .. attribute:: vendor_id
                                                                                    
                                                                                    	Vendor ID
                                                                                    	**type**\:  :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                    
                                                                                    .. attribute:: vendor_id_regex
                                                                                    
                                                                                    	Vendor ID RegEx
                                                                                    	**type**\:  :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                    
                                                                                    .. attribute:: access_interface
                                                                                    
                                                                                    	Access interface
                                                                                    	**type**\:  :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                    
                                                                                    .. attribute:: input_interface
                                                                                    
                                                                                    	Input interface
                                                                                    	**type**\:  :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                    
                                                                                    .. attribute:: input_intfhdl
                                                                                    
                                                                                    	Input interface handle
                                                                                    	**type**\:  :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                    
                                                                                    .. attribute:: ethertype
                                                                                    
                                                                                    	Ethernet type
                                                                                    	**type**\:  :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                    
                                                                                    .. attribute:: flow_key_data
                                                                                    
                                                                                    	Flow key structure
                                                                                    	**type**\:  :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                    
                                                                                    .. attribute:: dhcp_client_id
                                                                                    
                                                                                    	Dhcp Client ID
                                                                                    	**type**\:  :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                    
                                                                                    .. attribute:: dhcp_client_id_regex
                                                                                    
                                                                                    	Dhcp Client ID RegEx
                                                                                    	**type**\:  :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                    
                                                                                    .. attribute:: circuit_id
                                                                                    
                                                                                    	Circuit ID
                                                                                    	**type**\:  :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                    
                                                                                    .. attribute:: circuit_id_regex
                                                                                    
                                                                                    	Circuit ID RegEx
                                                                                    	**type**\:  :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                    
                                                                                    .. attribute:: remote_id
                                                                                    
                                                                                    	Remote ID
                                                                                    	**type**\:  :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                    
                                                                                    .. attribute:: remote_id_regex
                                                                                    
                                                                                    	Remote ID RegEx
                                                                                    	**type**\:  :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                    
                                                                                    .. attribute:: src_port
                                                                                    
                                                                                    	Source port
                                                                                    	**type**\:  :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                    
                                                                                    .. attribute:: dst_port
                                                                                    
                                                                                    	Destination port
                                                                                    	**type**\:  :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	type
                                                                                    	**type**\:  :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                    
                                                                                    .. attribute:: mpls_top_eos
                                                                                    
                                                                                    	MPLS Topmost EOS
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: fragment_type
                                                                                    
                                                                                    	Fragment type
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: authen_status
                                                                                    
                                                                                    	Authentication Status
                                                                                    	**type**\:  :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                    
                                                                                    .. attribute:: mlp_negotiated
                                                                                    
                                                                                    	MLP Negotiated
                                                                                    	**type**\:  :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                        self.yang_name = "match-data"
                                                                                        self.yang_parent_name = "class-match-info-st"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("ipv4-dscp", ("ipv4_dscp", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp)), ("ipv6-dscp", ("ipv6_dscp", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp)), ("dscp", ("dscp", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp)), ("ipv4-prec", ("ipv4_prec", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec)), ("ipv6-prec", ("ipv6_prec", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec)), ("prec", ("prec", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec)), ("discard-class", ("discard_class", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass)), ("qos-group", ("qos_group", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup)), ("traffic-class", ("traffic_class", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass)), ("proto", ("proto", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto)), ("icmp-v4", ("icmp_v4", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4)), ("icmp-v6", ("icmp_v6", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6)), ("ipv4-packet-len", ("ipv4_packet_len", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen)), ("ipv6-packet-len", ("ipv6_packet_len", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen)), ("packet-len", ("packet_len", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen)), ("flow-tag", ("flow_tag", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag)), ("tcp-flag", ("tcp_flag", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag)), ("icmpv4-type", ("icmpv4_type", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type)), ("icmpv4-code", ("icmpv4_code", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code)), ("icmpv6-type", ("icmpv6_type", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type)), ("icmpv6-code", ("icmpv6_code", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code)), ("mpls-exp", ("mpls_exp", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp)), ("mpls-exp-imp", ("mpls_exp_imp", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp)), ("mpls-disp-ipv4-acl", ("mpls_disp_ipv4_acl", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl)), ("mpls-disp-ipv6-acl", ("mpls_disp_ipv6_acl", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl)), ("mpls-top-label", ("mpls_top_label", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel)), ("cos", ("cos", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos)), ("cos-inr", ("cos_inr", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr)), ("dei", ("dei", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei)), ("dei-inr", ("dei_inr", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr)), ("vlan", ("vlan", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan)), ("vlan-inr", ("vlan_inr", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)), ("fr-dlci", ("fr_dlci", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci)), ("src-mac", ("src_mac", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac)), ("dst-mac", ("dst_mac", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac)), ("atm-clp", ("atm_clp", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp)), ("fr-de", ("fr_de", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe)), ("ipv4-acl", ("ipv4_acl", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl)), ("ipv6-acl", ("ipv6_acl", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl)), ("ether-service-acl", ("ether_service_acl", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl)), ("avail-id", ("avail_id", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId)), ("media-type", ("media_type", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType)), ("subs-protocol", ("subs_protocol", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol)), ("dnis", ("dnis", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis)), ("dnis-regex", ("dnis_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex)), ("domain", ("domain", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain)), ("domain-regex", ("domain_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex)), ("nas-port", ("nas_port", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort)), ("service-name", ("service_name", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName)), ("service-name-regex", ("service_name_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex)), ("src-addr-ipv4", ("src_addr_ipv4", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4)), ("dst-addr-ipv4", ("dst_addr_ipv4", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4)), ("src-addr-ipv6", ("src_addr_ipv6", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6)), ("dst-addr-ipv6", ("dst_addr_ipv6", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6)), ("src-addr-mac", ("src_addr_mac", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac)), ("timer", ("timer", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer)), ("timer-regexp", ("timer_regexp", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp)), ("tunnel-name", ("tunnel_name", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName)), ("tunnel-name-regex", ("tunnel_name_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex)), ("user-name", ("user_name", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName)), ("user-name-regex", ("user_name_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex)), ("auth-username", ("auth_username", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername)), ("auth-username-regex", ("auth_username_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex)), ("unauth-username", ("unauth_username", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername)), ("unauth-username-regex", ("unauth_username_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex)), ("auth-domain", ("auth_domain", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain)), ("auth-domain-regex", ("auth_domain_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex)), ("unauth-domain", ("unauth_domain", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain)), ("unauth-domain-regex", ("unauth_domain_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex)), ("vendor-id", ("vendor_id", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId)), ("vendor-id-regex", ("vendor_id_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex)), ("access-interface", ("access_interface", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface)), ("input-interface", ("input_interface", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface)), ("input-intfhdl", ("input_intfhdl", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl)), ("ethertype", ("ethertype", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype)), ("flow-key-data", ("flow_key_data", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData)), ("dhcp-client-id", ("dhcp_client_id", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId)), ("dhcp-client-id-regex", ("dhcp_client_id_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex)), ("circuit-id", ("circuit_id", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId)), ("circuit-id-regex", ("circuit_id_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex)), ("remote-id", ("remote_id", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId)), ("remote-id-regex", ("remote_id_regex", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex)), ("src-port", ("src_port", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort)), ("dst-port", ("dst_port", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort))])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchTypeEn', '')])),
                                                                                            ('mpls_top_eos', (YLeaf(YType.uint8, 'mpls-top-eos'), ['int'])),
                                                                                            ('fragment_type', (YLeaf(YType.uint8, 'fragment-type'), ['int'])),
                                                                                            ('authen_status', (YLeaf(YType.enumeration, 'authen-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchAuthenStatusEn', '')])),
                                                                                            ('mlp_negotiated', (YLeaf(YType.enumeration, 'mlp-negotiated'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchMlpNegotiatedEn', '')])),
                                                                                        ])
                                                                                        self.type = None
                                                                                        self.mpls_top_eos = None
                                                                                        self.fragment_type = None
                                                                                        self.authen_status = None
                                                                                        self.mlp_negotiated = None

                                                                                        self.ipv4_dscp = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                        self.ipv4_dscp.parent = self
                                                                                        self._children_name_map["ipv4_dscp"] = "ipv4-dscp"

                                                                                        self.ipv6_dscp = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                        self.ipv6_dscp.parent = self
                                                                                        self._children_name_map["ipv6_dscp"] = "ipv6-dscp"

                                                                                        self.dscp = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                        self.dscp.parent = self
                                                                                        self._children_name_map["dscp"] = "dscp"

                                                                                        self.ipv4_prec = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                        self.ipv4_prec.parent = self
                                                                                        self._children_name_map["ipv4_prec"] = "ipv4-prec"

                                                                                        self.ipv6_prec = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                        self.ipv6_prec.parent = self
                                                                                        self._children_name_map["ipv6_prec"] = "ipv6-prec"

                                                                                        self.prec = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                        self.prec.parent = self
                                                                                        self._children_name_map["prec"] = "prec"

                                                                                        self.discard_class = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                        self.discard_class.parent = self
                                                                                        self._children_name_map["discard_class"] = "discard-class"

                                                                                        self.qos_group = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                        self.qos_group.parent = self
                                                                                        self._children_name_map["qos_group"] = "qos-group"

                                                                                        self.traffic_class = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                        self.traffic_class.parent = self
                                                                                        self._children_name_map["traffic_class"] = "traffic-class"

                                                                                        self.proto = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                        self.proto.parent = self
                                                                                        self._children_name_map["proto"] = "proto"

                                                                                        self.icmp_v4 = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                        self.icmp_v4.parent = self
                                                                                        self._children_name_map["icmp_v4"] = "icmp-v4"

                                                                                        self.icmp_v6 = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                        self.icmp_v6.parent = self
                                                                                        self._children_name_map["icmp_v6"] = "icmp-v6"

                                                                                        self.ipv4_packet_len = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                        self.ipv4_packet_len.parent = self
                                                                                        self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"

                                                                                        self.ipv6_packet_len = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                        self.ipv6_packet_len.parent = self
                                                                                        self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"

                                                                                        self.packet_len = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                        self.packet_len.parent = self
                                                                                        self._children_name_map["packet_len"] = "packet-len"

                                                                                        self.flow_tag = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                        self.flow_tag.parent = self
                                                                                        self._children_name_map["flow_tag"] = "flow-tag"

                                                                                        self.tcp_flag = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                        self.tcp_flag.parent = self
                                                                                        self._children_name_map["tcp_flag"] = "tcp-flag"

                                                                                        self.icmpv4_type = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                        self.icmpv4_type.parent = self
                                                                                        self._children_name_map["icmpv4_type"] = "icmpv4-type"

                                                                                        self.icmpv4_code = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                        self.icmpv4_code.parent = self
                                                                                        self._children_name_map["icmpv4_code"] = "icmpv4-code"

                                                                                        self.icmpv6_type = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                        self.icmpv6_type.parent = self
                                                                                        self._children_name_map["icmpv6_type"] = "icmpv6-type"

                                                                                        self.icmpv6_code = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                        self.icmpv6_code.parent = self
                                                                                        self._children_name_map["icmpv6_code"] = "icmpv6-code"

                                                                                        self.mpls_exp = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                        self.mpls_exp.parent = self
                                                                                        self._children_name_map["mpls_exp"] = "mpls-exp"

                                                                                        self.mpls_exp_imp = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                        self.mpls_exp_imp.parent = self
                                                                                        self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"

                                                                                        self.mpls_disp_ipv4_acl = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                        self.mpls_disp_ipv4_acl.parent = self
                                                                                        self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"

                                                                                        self.mpls_disp_ipv6_acl = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                        self.mpls_disp_ipv6_acl.parent = self
                                                                                        self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"

                                                                                        self.mpls_top_label = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                        self.mpls_top_label.parent = self
                                                                                        self._children_name_map["mpls_top_label"] = "mpls-top-label"

                                                                                        self.cos = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                        self.cos.parent = self
                                                                                        self._children_name_map["cos"] = "cos"

                                                                                        self.cos_inr = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                        self.cos_inr.parent = self
                                                                                        self._children_name_map["cos_inr"] = "cos-inr"

                                                                                        self.dei = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                        self.dei.parent = self
                                                                                        self._children_name_map["dei"] = "dei"

                                                                                        self.dei_inr = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                        self.dei_inr.parent = self
                                                                                        self._children_name_map["dei_inr"] = "dei-inr"

                                                                                        self.vlan = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                        self.vlan.parent = self
                                                                                        self._children_name_map["vlan"] = "vlan"

                                                                                        self.vlan_inr = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                        self.vlan_inr.parent = self
                                                                                        self._children_name_map["vlan_inr"] = "vlan-inr"

                                                                                        self.fr_dlci = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                        self.fr_dlci.parent = self
                                                                                        self._children_name_map["fr_dlci"] = "fr-dlci"

                                                                                        self.src_mac = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                        self.src_mac.parent = self
                                                                                        self._children_name_map["src_mac"] = "src-mac"

                                                                                        self.dst_mac = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                        self.dst_mac.parent = self
                                                                                        self._children_name_map["dst_mac"] = "dst-mac"

                                                                                        self.atm_clp = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                        self.atm_clp.parent = self
                                                                                        self._children_name_map["atm_clp"] = "atm-clp"

                                                                                        self.fr_de = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                        self.fr_de.parent = self
                                                                                        self._children_name_map["fr_de"] = "fr-de"

                                                                                        self.ipv4_acl = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                        self.ipv4_acl.parent = self
                                                                                        self._children_name_map["ipv4_acl"] = "ipv4-acl"

                                                                                        self.ipv6_acl = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                        self.ipv6_acl.parent = self
                                                                                        self._children_name_map["ipv6_acl"] = "ipv6-acl"

                                                                                        self.ether_service_acl = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                        self.ether_service_acl.parent = self
                                                                                        self._children_name_map["ether_service_acl"] = "ether-service-acl"

                                                                                        self.avail_id = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                        self.avail_id.parent = self
                                                                                        self._children_name_map["avail_id"] = "avail-id"

                                                                                        self.media_type = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                        self.media_type.parent = self
                                                                                        self._children_name_map["media_type"] = "media-type"

                                                                                        self.subs_protocol = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                        self.subs_protocol.parent = self
                                                                                        self._children_name_map["subs_protocol"] = "subs-protocol"

                                                                                        self.dnis = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                        self.dnis.parent = self
                                                                                        self._children_name_map["dnis"] = "dnis"

                                                                                        self.dnis_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                        self.dnis_regex.parent = self
                                                                                        self._children_name_map["dnis_regex"] = "dnis-regex"

                                                                                        self.domain = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                        self.domain.parent = self
                                                                                        self._children_name_map["domain"] = "domain"

                                                                                        self.domain_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                        self.domain_regex.parent = self
                                                                                        self._children_name_map["domain_regex"] = "domain-regex"

                                                                                        self.nas_port = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                        self.nas_port.parent = self
                                                                                        self._children_name_map["nas_port"] = "nas-port"

                                                                                        self.service_name = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                        self.service_name.parent = self
                                                                                        self._children_name_map["service_name"] = "service-name"

                                                                                        self.service_name_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                        self.service_name_regex.parent = self
                                                                                        self._children_name_map["service_name_regex"] = "service-name-regex"

                                                                                        self.src_addr_ipv4 = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                        self.src_addr_ipv4.parent = self
                                                                                        self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"

                                                                                        self.dst_addr_ipv4 = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                        self.dst_addr_ipv4.parent = self
                                                                                        self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"

                                                                                        self.src_addr_ipv6 = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                        self.src_addr_ipv6.parent = self
                                                                                        self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"

                                                                                        self.dst_addr_ipv6 = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                        self.dst_addr_ipv6.parent = self
                                                                                        self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"

                                                                                        self.src_addr_mac = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                        self.src_addr_mac.parent = self
                                                                                        self._children_name_map["src_addr_mac"] = "src-addr-mac"

                                                                                        self.timer = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                        self.timer.parent = self
                                                                                        self._children_name_map["timer"] = "timer"

                                                                                        self.timer_regexp = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                        self.timer_regexp.parent = self
                                                                                        self._children_name_map["timer_regexp"] = "timer-regexp"

                                                                                        self.tunnel_name = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                        self.tunnel_name.parent = self
                                                                                        self._children_name_map["tunnel_name"] = "tunnel-name"

                                                                                        self.tunnel_name_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                        self.tunnel_name_regex.parent = self
                                                                                        self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"

                                                                                        self.user_name = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                        self.user_name.parent = self
                                                                                        self._children_name_map["user_name"] = "user-name"

                                                                                        self.user_name_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                        self.user_name_regex.parent = self
                                                                                        self._children_name_map["user_name_regex"] = "user-name-regex"

                                                                                        self.auth_username = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                        self.auth_username.parent = self
                                                                                        self._children_name_map["auth_username"] = "auth-username"

                                                                                        self.auth_username_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                        self.auth_username_regex.parent = self
                                                                                        self._children_name_map["auth_username_regex"] = "auth-username-regex"

                                                                                        self.unauth_username = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                        self.unauth_username.parent = self
                                                                                        self._children_name_map["unauth_username"] = "unauth-username"

                                                                                        self.unauth_username_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                        self.unauth_username_regex.parent = self
                                                                                        self._children_name_map["unauth_username_regex"] = "unauth-username-regex"

                                                                                        self.auth_domain = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                        self.auth_domain.parent = self
                                                                                        self._children_name_map["auth_domain"] = "auth-domain"

                                                                                        self.auth_domain_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                        self.auth_domain_regex.parent = self
                                                                                        self._children_name_map["auth_domain_regex"] = "auth-domain-regex"

                                                                                        self.unauth_domain = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                        self.unauth_domain.parent = self
                                                                                        self._children_name_map["unauth_domain"] = "unauth-domain"

                                                                                        self.unauth_domain_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                        self.unauth_domain_regex.parent = self
                                                                                        self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"

                                                                                        self.vendor_id = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                        self.vendor_id.parent = self
                                                                                        self._children_name_map["vendor_id"] = "vendor-id"

                                                                                        self.vendor_id_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                        self.vendor_id_regex.parent = self
                                                                                        self._children_name_map["vendor_id_regex"] = "vendor-id-regex"

                                                                                        self.access_interface = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                        self.access_interface.parent = self
                                                                                        self._children_name_map["access_interface"] = "access-interface"

                                                                                        self.input_interface = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                        self.input_interface.parent = self
                                                                                        self._children_name_map["input_interface"] = "input-interface"

                                                                                        self.input_intfhdl = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                        self.input_intfhdl.parent = self
                                                                                        self._children_name_map["input_intfhdl"] = "input-intfhdl"

                                                                                        self.ethertype = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                        self.ethertype.parent = self
                                                                                        self._children_name_map["ethertype"] = "ethertype"

                                                                                        self.flow_key_data = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                        self.flow_key_data.parent = self
                                                                                        self._children_name_map["flow_key_data"] = "flow-key-data"

                                                                                        self.dhcp_client_id = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                        self.dhcp_client_id.parent = self
                                                                                        self._children_name_map["dhcp_client_id"] = "dhcp-client-id"

                                                                                        self.dhcp_client_id_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                        self.dhcp_client_id_regex.parent = self
                                                                                        self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"

                                                                                        self.circuit_id = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                        self.circuit_id.parent = self
                                                                                        self._children_name_map["circuit_id"] = "circuit-id"

                                                                                        self.circuit_id_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                        self.circuit_id_regex.parent = self
                                                                                        self._children_name_map["circuit_id_regex"] = "circuit-id-regex"

                                                                                        self.remote_id = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                        self.remote_id.parent = self
                                                                                        self._children_name_map["remote_id"] = "remote-id"

                                                                                        self.remote_id_regex = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                        self.remote_id_regex.parent = self
                                                                                        self._children_name_map["remote_id_regex"] = "remote-id-regex"

                                                                                        self.src_port = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                        self.src_port.parent = self
                                                                                        self._children_name_map["src_port"] = "src-port"

                                                                                        self.dst_port = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                        self.dst_port.parent = self
                                                                                        self._children_name_map["dst_port"] = "dst-port"
                                                                                        self._segment_path = lambda: "match-data"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['type', 'mpls_top_eos', 'fragment_type', 'authen_status', 'mlp_negotiated'], name, value)


                                                                                    class Ipv4Dscp(Entity):
                                                                                        """
                                                                                        IPv4 DSCP
                                                                                        
                                                                                        .. attribute:: uint8_rng_array
                                                                                        
                                                                                        	uint8 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                            self.yang_name = "ipv4-dscp"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint8_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "ipv4-dscp"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                        class Uint8RngArray(Entity):
                                                                                            """
                                                                                            uint8 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                self.yang_name = "uint8_rng_array"
                                                                                                self.yang_parent_name = "ipv4-dscp"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint8_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                    class Ipv6Dscp(Entity):
                                                                                        """
                                                                                        IPv6 DSCP
                                                                                        
                                                                                        .. attribute:: uint8_rng_array
                                                                                        
                                                                                        	uint8 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                            self.yang_name = "ipv6-dscp"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint8_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "ipv6-dscp"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                        class Uint8RngArray(Entity):
                                                                                            """
                                                                                            uint8 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                self.yang_name = "uint8_rng_array"
                                                                                                self.yang_parent_name = "ipv6-dscp"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint8_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                    class Dscp(Entity):
                                                                                        """
                                                                                        Match DSCP range array
                                                                                        
                                                                                        .. attribute:: uint8_rng_array
                                                                                        
                                                                                        	uint8 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                            self.yang_name = "dscp"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint8_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "dscp"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                        class Uint8RngArray(Entity):
                                                                                            """
                                                                                            uint8 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                self.yang_name = "uint8_rng_array"
                                                                                                self.yang_parent_name = "dscp"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint8_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                    class Ipv4Prec(Entity):
                                                                                        """
                                                                                        IPv4 Precedence
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                            self.yang_name = "ipv4-prec"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                            ])
                                                                                            self.uint8_array = []
                                                                                            self._segment_path = lambda: "ipv4-prec"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                    class Ipv6Prec(Entity):
                                                                                        """
                                                                                        IPv6 Precedence
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                            self.yang_name = "ipv6-prec"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                            ])
                                                                                            self.uint8_array = []
                                                                                            self._segment_path = lambda: "ipv6-prec"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                    class Prec(Entity):
                                                                                        """
                                                                                        Match Precedence array
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                            self.yang_name = "prec"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                            ])
                                                                                            self.uint8_array = []
                                                                                            self._segment_path = lambda: "prec"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                    class DiscardClass(Entity):
                                                                                        """
                                                                                        Match Discard Class array
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                            self.yang_name = "discard-class"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                            ])
                                                                                            self.uint8_array = []
                                                                                            self._segment_path = lambda: "discard-class"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                    class QosGroup(Entity):
                                                                                        """
                                                                                        Match QoS group array
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                            self.yang_name = "qos-group"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "qos-group"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "qos-group"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint16_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['min', 'max'], name, value)


                                                                                    class TrafficClass(Entity):
                                                                                        """
                                                                                        Match Traffic class array
                                                                                        
                                                                                        .. attribute:: uint8_rng_array
                                                                                        
                                                                                        	uint8 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                            self.yang_name = "traffic-class"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint8_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "traffic-class"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                        class Uint8RngArray(Entity):
                                                                                            """
                                                                                            uint8 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                self.yang_name = "uint8_rng_array"
                                                                                                self.yang_parent_name = "traffic-class"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint8_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['min', 'max'], name, value)


                                                                                    class Proto(Entity):
                                                                                        """
                                                                                        Match Protocol array
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                            self.yang_name = "proto"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "proto"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "proto"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint16_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['min', 'max'], name, value)


                                                                                    class IcmpV4(Entity):
                                                                                        """
                                                                                        Match ICMPV4 Protocol
                                                                                        
                                                                                        .. attribute:: type
                                                                                        
                                                                                        	Protocol type
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: code
                                                                                        
                                                                                        	Protocol code
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                            self.yang_name = "icmp-v4"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                            ])
                                                                                            self.type = None
                                                                                            self.code = None
                                                                                            self._segment_path = lambda: "icmp-v4"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['type', 'code'], name, value)


                                                                                    class IcmpV6(Entity):
                                                                                        """
                                                                                        Match ICMPV6 Protocol array
                                                                                        
                                                                                        .. attribute:: type
                                                                                        
                                                                                        	Protocol type
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: code
                                                                                        
                                                                                        	Protocol code
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                            self.yang_name = "icmp-v6"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                            ])
                                                                                            self.type = None
                                                                                            self.code = None
                                                                                            self._segment_path = lambda: "icmp-v6"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['type', 'code'], name, value)


                                                                                    class Ipv4PacketLen(Entity):
                                                                                        """
                                                                                        IPv4 packet length array
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                            self.yang_name = "ipv4-packet-len"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "ipv4-packet-len"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "ipv4-packet-len"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint16_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                    class Ipv6PacketLen(Entity):
                                                                                        """
                                                                                        IPv6 packet length array
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                            self.yang_name = "ipv6-packet-len"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "ipv6-packet-len"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "ipv6-packet-len"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint16_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                    class PacketLen(Entity):
                                                                                        """
                                                                                        Match packet length array
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                            self.yang_name = "packet-len"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "packet-len"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "packet-len"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint16_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                    class FlowTag(Entity):
                                                                                        """
                                                                                        Match flow\-tag array
                                                                                        
                                                                                        .. attribute:: uint8_rng_array
                                                                                        
                                                                                        	uint8 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                            self.yang_name = "flow-tag"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint8_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "flow-tag"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                        class Uint8RngArray(Entity):
                                                                                            """
                                                                                            uint8 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                self.yang_name = "uint8_rng_array"
                                                                                                self.yang_parent_name = "flow-tag"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint8_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['min', 'max'], name, value)


                                                                                    class TcpFlag(Entity):
                                                                                        """
                                                                                        Match tcp flag value
                                                                                        
                                                                                        .. attribute:: value
                                                                                        
                                                                                        	Value of TCP flag
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: match_any
                                                                                        
                                                                                        	Match any TCP flag bit
                                                                                        	**type**\: bool
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                            self.yang_name = "tcp-flag"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                                ('match_any', (YLeaf(YType.boolean, 'match-any'), ['bool'])),
                                                                                            ])
                                                                                            self.value = None
                                                                                            self.match_any = None
                                                                                            self._segment_path = lambda: "tcp-flag"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['value', 'match_any'], name, value)


                                                                                    class Icmpv4Type(Entity):
                                                                                        """
                                                                                        Match ipv4 icmp type
                                                                                        
                                                                                        .. attribute:: uint8_rng_array
                                                                                        
                                                                                        	uint8 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                            self.yang_name = "icmpv4-type"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint8_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "icmpv4-type"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                        class Uint8RngArray(Entity):
                                                                                            """
                                                                                            uint8 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                self.yang_name = "uint8_rng_array"
                                                                                                self.yang_parent_name = "icmpv4-type"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint8_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                    class Icmpv4Code(Entity):
                                                                                        """
                                                                                        Match ipv4 icmp code
                                                                                        
                                                                                        .. attribute:: uint8_rng_array
                                                                                        
                                                                                        	uint8 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                            self.yang_name = "icmpv4-code"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint8_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "icmpv4-code"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                        class Uint8RngArray(Entity):
                                                                                            """
                                                                                            uint8 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                self.yang_name = "uint8_rng_array"
                                                                                                self.yang_parent_name = "icmpv4-code"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint8_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                    class Icmpv6Type(Entity):
                                                                                        """
                                                                                        Match ipv6 icmp type
                                                                                        
                                                                                        .. attribute:: uint8_rng_array
                                                                                        
                                                                                        	uint8 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                            self.yang_name = "icmpv6-type"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint8_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "icmpv6-type"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                        class Uint8RngArray(Entity):
                                                                                            """
                                                                                            uint8 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                self.yang_name = "uint8_rng_array"
                                                                                                self.yang_parent_name = "icmpv6-type"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint8_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                    class Icmpv6Code(Entity):
                                                                                        """
                                                                                        Match ipv6 icmp code
                                                                                        
                                                                                        .. attribute:: uint8_rng_array
                                                                                        
                                                                                        	uint8 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                            self.yang_name = "icmpv6-code"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint8_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "icmpv6-code"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                        class Uint8RngArray(Entity):
                                                                                            """
                                                                                            uint8 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                self.yang_name = "uint8_rng_array"
                                                                                                self.yang_parent_name = "icmpv6-code"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint8_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                    class MplsExp(Entity):
                                                                                        """
                                                                                        Match MPLS experimental topmost array
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                            self.yang_name = "mpls-exp"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                            ])
                                                                                            self.uint8_array = []
                                                                                            self._segment_path = lambda: "mpls-exp"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                    class MplsExpImp(Entity):
                                                                                        """
                                                                                        Match MPLS experimental imposition array
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                            self.yang_name = "mpls-exp-imp"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                            ])
                                                                                            self.uint8_array = []
                                                                                            self._segment_path = lambda: "mpls-exp-imp"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                    class MplsDispIpv4Acl(Entity):
                                                                                        """
                                                                                        MPLS Disposition IPv4 Access\-list
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                            self.yang_name = "mpls-disp-ipv4-acl"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "mpls-disp-ipv4-acl"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                    class MplsDispIpv6Acl(Entity):
                                                                                        """
                                                                                        MPLS Disposition IPv6 Access\-list
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                            self.yang_name = "mpls-disp-ipv6-acl"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "mpls-disp-ipv6-acl"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                    class MplsTopLabel(Entity):
                                                                                        """
                                                                                        MPLS Topmost LABEL
                                                                                        
                                                                                        .. attribute:: uint32_rng_array
                                                                                        
                                                                                        	uint32 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                            self.yang_name = "mpls-top-label"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint32_rng_array", ("uint32_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint32_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "mpls-top-label"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                        class Uint32RngArray(Entity):
                                                                                            """
                                                                                            uint32 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                self.yang_name = "uint32_rng_array"
                                                                                                self.yang_parent_name = "mpls-top-label"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint32, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint32, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint32_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['min', 'max'], name, value)


                                                                                    class Cos(Entity):
                                                                                        """
                                                                                        Match CoS array
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                            self.yang_name = "cos"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                            ])
                                                                                            self.uint8_array = []
                                                                                            self._segment_path = lambda: "cos"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                    class CosInr(Entity):
                                                                                        """
                                                                                        Match inner header CoS
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                            self.yang_name = "cos-inr"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                            ])
                                                                                            self.uint8_array = []
                                                                                            self._segment_path = lambda: "cos-inr"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                    class Dei(Entity):
                                                                                        """
                                                                                        Match DEI Bit
                                                                                        
                                                                                        .. attribute:: bit_value
                                                                                        
                                                                                        	Value of the DEI bit
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                            self.yang_name = "dei"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                            ])
                                                                                            self.bit_value = None
                                                                                            self._segment_path = lambda: "dei"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                    class DeiInr(Entity):
                                                                                        """
                                                                                        Match inner DEI Bit
                                                                                        
                                                                                        .. attribute:: bit_value
                                                                                        
                                                                                        	Value of the DEI bit
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                            self.yang_name = "dei-inr"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                            ])
                                                                                            self.bit_value = None
                                                                                            self._segment_path = lambda: "dei-inr"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                    class Vlan(Entity):
                                                                                        """
                                                                                        Match VLAN array
                                                                                        
                                                                                        .. attribute:: vlan_id_array
                                                                                        
                                                                                        	vlan id array
                                                                                        	**type**\: list of  		 :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                            self.yang_name = "vlan"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("vlan-id-array", ("vlan_id_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.vlan_id_array = YList(self)
                                                                                            self._segment_path = lambda: "vlan"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                        class VlanIdArray(Entity):
                                                                                            """
                                                                                            vlan id array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	VLAN mask
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                self.yang_name = "vlan-id-array"
                                                                                                self.yang_parent_name = "vlan"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ('mask', (YLeaf(YType.uint16, 'mask'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self.mask = None
                                                                                                self._segment_path = lambda: "vlan-id-array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['min', 'max', 'mask'], name, value)


                                                                                    class VlanInr(Entity):
                                                                                        """
                                                                                        Match inner header VLAN range array
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                            self.yang_name = "vlan-inr"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "vlan-inr"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "vlan-inr"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint16_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['min', 'max'], name, value)


                                                                                    class FrDlci(Entity):
                                                                                        """
                                                                                        Match FR DLCI range array
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                            self.yang_name = "fr-dlci"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "fr-dlci"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "fr-dlci"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint16_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['min', 'max'], name, value)


                                                                                    class SrcMac(Entity):
                                                                                        """
                                                                                        Match Source MAC address
                                                                                        
                                                                                        .. attribute:: mac_addr
                                                                                        
                                                                                        	MAC address
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: mask
                                                                                        
                                                                                        	MAC mask
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                            self.yang_name = "src-mac"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                            ])
                                                                                            self.mac_addr = []
                                                                                            self.mask = []
                                                                                            self._segment_path = lambda: "src-mac"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                    class DstMac(Entity):
                                                                                        """
                                                                                        Match Destination MAC address
                                                                                        
                                                                                        .. attribute:: mac_addr
                                                                                        
                                                                                        	MAC address
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: mask
                                                                                        
                                                                                        	MAC mask
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                            self.yang_name = "dst-mac"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                            ])
                                                                                            self.mac_addr = []
                                                                                            self.mask = []
                                                                                            self._segment_path = lambda: "dst-mac"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                    class AtmClp(Entity):
                                                                                        """
                                                                                        Match ATM CLP level
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                            self.yang_name = "atm-clp"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                            ])
                                                                                            self.uint8_array = []
                                                                                            self._segment_path = lambda: "atm-clp"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                    class FrDe(Entity):
                                                                                        """
                                                                                        Match FR DE value
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                            self.yang_name = "fr-de"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                            ])
                                                                                            self.uint8_array = []
                                                                                            self._segment_path = lambda: "fr-de"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                    class Ipv4Acl(Entity):
                                                                                        """
                                                                                        IPv4 Access\-list
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                            self.yang_name = "ipv4-acl"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "ipv4-acl"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                    class Ipv6Acl(Entity):
                                                                                        """
                                                                                        IPv6 Access\-list
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                            self.yang_name = "ipv6-acl"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "ipv6-acl"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                    class EtherServiceAcl(Entity):
                                                                                        """
                                                                                        Ethernet\-Services Access\-list
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                            self.yang_name = "ether-service-acl"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "ether-service-acl"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                    class AvailId(Entity):
                                                                                        """
                                                                                        Available Identifiers
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                            self.yang_name = "avail-id"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                            ])
                                                                                            self.uint8_array = []
                                                                                            self._segment_path = lambda: "avail-id"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                    class MediaType(Entity):
                                                                                        """
                                                                                        Media Type
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                            self.yang_name = "media-type"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                            ])
                                                                                            self.uint8_array = []
                                                                                            self._segment_path = lambda: "media-type"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                    class SubsProtocol(Entity):
                                                                                        """
                                                                                        Protocol
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                            self.yang_name = "subs-protocol"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                            ])
                                                                                            self.uint8_array = []
                                                                                            self._segment_path = lambda: "subs-protocol"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                    class Dnis(Entity):
                                                                                        """
                                                                                        DNIS
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                            self.yang_name = "dnis"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "dnis"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                    class DnisRegex(Entity):
                                                                                        """
                                                                                        DNIS Regular Expression
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                            self.yang_name = "dnis-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "dnis-regex"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                    class Domain(Entity):
                                                                                        """
                                                                                        Domain Name
                                                                                        
                                                                                        .. attribute:: domain_array
                                                                                        
                                                                                        	domain array
                                                                                        	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                            self.yang_name = "domain"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.domain_array = YList(self)
                                                                                            self._segment_path = lambda: "domain"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                        class DomainArray(Entity):
                                                                                            """
                                                                                            domain array
                                                                                            
                                                                                            .. attribute:: domain_name
                                                                                            
                                                                                            	domain name
                                                                                            	**type**\: str
                                                                                            
                                                                                            .. attribute:: format_name
                                                                                            
                                                                                            	format name
                                                                                            	**type**\: str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                self.yang_name = "domain-array"
                                                                                                self.yang_parent_name = "domain"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                    ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                ])
                                                                                                self.domain_name = None
                                                                                                self.format_name = None
                                                                                                self._segment_path = lambda: "domain-array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                    class DomainRegex(Entity):
                                                                                        """
                                                                                        Domain Regular Expression
                                                                                        
                                                                                        .. attribute:: domain_array
                                                                                        
                                                                                        	domain array
                                                                                        	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                            self.yang_name = "domain-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.domain_array = YList(self)
                                                                                            self._segment_path = lambda: "domain-regex"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                        class DomainArray(Entity):
                                                                                            """
                                                                                            domain array
                                                                                            
                                                                                            .. attribute:: domain_name
                                                                                            
                                                                                            	domain name
                                                                                            	**type**\: str
                                                                                            
                                                                                            .. attribute:: format_name
                                                                                            
                                                                                            	format name
                                                                                            	**type**\: str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                self.yang_name = "domain-array"
                                                                                                self.yang_parent_name = "domain-regex"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                    ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                ])
                                                                                                self.domain_name = None
                                                                                                self.format_name = None
                                                                                                self._segment_path = lambda: "domain-array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                    class NasPort(Entity):
                                                                                        """
                                                                                        NAS Port
                                                                                        
                                                                                        .. attribute:: nas_port_array
                                                                                        
                                                                                        	nas port array
                                                                                        	**type**\: list of  		 :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                            self.yang_name = "nas-port"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("nas-port-array", ("nas_port_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.nas_port_array = YList(self)
                                                                                            self._segment_path = lambda: "nas-port"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                        class NasPortArray(Entity):
                                                                                            """
                                                                                            nas port array
                                                                                            
                                                                                            .. attribute:: sub_id
                                                                                            
                                                                                            	sub id
                                                                                            	**type**\:  :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                            
                                                                                            .. attribute:: operator
                                                                                            
                                                                                            	operator
                                                                                            	**type**\:  :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                            
                                                                                            .. attribute:: value
                                                                                            
                                                                                            	value
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                self.yang_name = "nas-port-array"
                                                                                                self.yang_parent_name = "nas-port"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('sub_id', (YLeaf(YType.enumeration, 'sub-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchNasPortSubIdEn', '')])),
                                                                                                    ('operator', (YLeaf(YType.enumeration, 'operator'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchLogicalOperatorEn', '')])),
                                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                                ])
                                                                                                self.sub_id = None
                                                                                                self.operator = None
                                                                                                self.value = None
                                                                                                self._segment_path = lambda: "nas-port-array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['sub_id', 'operator', 'value'], name, value)


                                                                                    class ServiceName(Entity):
                                                                                        """
                                                                                        Service Name
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                            self.yang_name = "service-name"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "service-name"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                    class ServiceNameRegex(Entity):
                                                                                        """
                                                                                        Service Name Regular Exp
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                            self.yang_name = "service-name-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "service-name-regex"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                    class SrcAddrIpv4(Entity):
                                                                                        """
                                                                                        Source Address IPV4
                                                                                        
                                                                                        .. attribute:: ipv4_addr_array
                                                                                        
                                                                                        	ipv4 addr array
                                                                                        	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                            self.yang_name = "src-addr-ipv4"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.ipv4_addr_array = YList(self)
                                                                                            self._segment_path = lambda: "src-addr-ipv4"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                        class Ipv4AddrArray(Entity):
                                                                                            """
                                                                                            ipv4 addr array
                                                                                            
                                                                                            .. attribute:: prefix
                                                                                            
                                                                                            	prefix
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	mask
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                self.yang_name = "ipv4-addr-array"
                                                                                                self.yang_parent_name = "src-addr-ipv4"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                    ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                ])
                                                                                                self.prefix = None
                                                                                                self.mask = None
                                                                                                self._segment_path = lambda: "ipv4-addr-array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                    class DstAddrIpv4(Entity):
                                                                                        """
                                                                                        Destination Address IPV4
                                                                                        
                                                                                        .. attribute:: ipv4_addr_array
                                                                                        
                                                                                        	ipv4 addr array
                                                                                        	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                            self.yang_name = "dst-addr-ipv4"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.ipv4_addr_array = YList(self)
                                                                                            self._segment_path = lambda: "dst-addr-ipv4"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                        class Ipv4AddrArray(Entity):
                                                                                            """
                                                                                            ipv4 addr array
                                                                                            
                                                                                            .. attribute:: prefix
                                                                                            
                                                                                            	prefix
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	mask
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                self.yang_name = "ipv4-addr-array"
                                                                                                self.yang_parent_name = "dst-addr-ipv4"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                    ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                ])
                                                                                                self.prefix = None
                                                                                                self.mask = None
                                                                                                self._segment_path = lambda: "ipv4-addr-array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                    class SrcAddrIpv6(Entity):
                                                                                        """
                                                                                        Source Address IPV6
                                                                                        
                                                                                        .. attribute:: ipv6_addr_array
                                                                                        
                                                                                        	ipv6 addr array
                                                                                        	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                            self.yang_name = "src-addr-ipv6"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.ipv6_addr_array = YList(self)
                                                                                            self._segment_path = lambda: "src-addr-ipv6"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                        class Ipv6AddrArray(Entity):
                                                                                            """
                                                                                            ipv6 addr array
                                                                                            
                                                                                            .. attribute:: prefix
                                                                                            
                                                                                            	IPV6 prefix
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	IPV6 mask
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                self.yang_name = "ipv6-addr-array"
                                                                                                self.yang_parent_name = "src-addr-ipv6"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                    ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                ])
                                                                                                self.prefix = None
                                                                                                self.mask = None
                                                                                                self._segment_path = lambda: "ipv6-addr-array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                    class DstAddrIpv6(Entity):
                                                                                        """
                                                                                        Destination Address IPV6
                                                                                        
                                                                                        .. attribute:: ipv6_addr_array
                                                                                        
                                                                                        	ipv6 addr array
                                                                                        	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                            self.yang_name = "dst-addr-ipv6"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.ipv6_addr_array = YList(self)
                                                                                            self._segment_path = lambda: "dst-addr-ipv6"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                        class Ipv6AddrArray(Entity):
                                                                                            """
                                                                                            ipv6 addr array
                                                                                            
                                                                                            .. attribute:: prefix
                                                                                            
                                                                                            	IPV6 prefix
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	IPV6 mask
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                self.yang_name = "ipv6-addr-array"
                                                                                                self.yang_parent_name = "dst-addr-ipv6"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                    ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                ])
                                                                                                self.prefix = None
                                                                                                self.mask = None
                                                                                                self._segment_path = lambda: "ipv6-addr-array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                    class SrcAddrMac(Entity):
                                                                                        """
                                                                                        Source Address MAC
                                                                                        
                                                                                        .. attribute:: mac_addr_array
                                                                                        
                                                                                        	mac addr array
                                                                                        	**type**\: list of  		 :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                            self.yang_name = "src-addr-mac"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("mac-addr-array", ("mac_addr_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.mac_addr_array = YList(self)
                                                                                            self._segment_path = lambda: "src-addr-mac"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                        class MacAddrArray(Entity):
                                                                                            """
                                                                                            mac addr array
                                                                                            
                                                                                            .. attribute:: mac_addr
                                                                                            
                                                                                            	MAC address
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	MAC mask
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                self.yang_name = "mac-addr-array"
                                                                                                self.yang_parent_name = "src-addr-mac"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                    ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                ])
                                                                                                self.mac_addr = []
                                                                                                self.mask = []
                                                                                                self._segment_path = lambda: "mac-addr-array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                    class Timer(Entity):
                                                                                        """
                                                                                        Timer
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                            self.yang_name = "timer"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "timer"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                    class TimerRegexp(Entity):
                                                                                        """
                                                                                        Timer Regular Expression
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                            self.yang_name = "timer-regexp"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "timer-regexp"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                    class TunnelName(Entity):
                                                                                        """
                                                                                        Tunnel Name
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                            self.yang_name = "tunnel-name"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "tunnel-name"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                    class TunnelNameRegex(Entity):
                                                                                        """
                                                                                        Tunnel Name Regular Expression
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                            self.yang_name = "tunnel-name-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "tunnel-name-regex"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                    class UserName(Entity):
                                                                                        """
                                                                                        User Name
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                            self.yang_name = "user-name"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "user-name"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                    class UserNameRegex(Entity):
                                                                                        """
                                                                                        User Name Regular Expression
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                            self.yang_name = "user-name-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "user-name-regex"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                    class AuthUsername(Entity):
                                                                                        """
                                                                                        Authenticated User Name
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                            self.yang_name = "auth-username"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "auth-username"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                    class AuthUsernameRegex(Entity):
                                                                                        """
                                                                                        Authenticated User Name RegEx
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                            self.yang_name = "auth-username-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "auth-username-regex"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                    class UnauthUsername(Entity):
                                                                                        """
                                                                                        Unauthenticated User Name
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                            self.yang_name = "unauth-username"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "unauth-username"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                    class UnauthUsernameRegex(Entity):
                                                                                        """
                                                                                        Unauthenticated User Name RegEx
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                            self.yang_name = "unauth-username-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "unauth-username-regex"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                    class AuthDomain(Entity):
                                                                                        """
                                                                                        Authenticated domain name
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                            self.yang_name = "auth-domain"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "auth-domain"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                    class AuthDomainRegex(Entity):
                                                                                        """
                                                                                        Authenticated Domain Name RegEx
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                            self.yang_name = "auth-domain-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "auth-domain-regex"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                    class UnauthDomain(Entity):
                                                                                        """
                                                                                        Unauthenticated Domain Name
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                            self.yang_name = "unauth-domain"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "unauth-domain"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                    class UnauthDomainRegex(Entity):
                                                                                        """
                                                                                        Unauthenticated Domain Name RegEx
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                            self.yang_name = "unauth-domain-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "unauth-domain-regex"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                    class VendorId(Entity):
                                                                                        """
                                                                                        Vendor ID
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                            self.yang_name = "vendor-id"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "vendor-id"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                    class VendorIdRegex(Entity):
                                                                                        """
                                                                                        Vendor ID RegEx
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                            self.yang_name = "vendor-id-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "vendor-id-regex"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                    class AccessInterface(Entity):
                                                                                        """
                                                                                        Access interface
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                            self.yang_name = "access-interface"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "access-interface"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                    class InputInterface(Entity):
                                                                                        """
                                                                                        Input interface
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                            self.yang_name = "input-interface"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "input-interface"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                    class InputIntfhdl(Entity):
                                                                                        """
                                                                                        Input interface handle
                                                                                        
                                                                                        .. attribute:: uint64_array
                                                                                        
                                                                                        	uint64 array
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..18446744073709551615
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                            self.yang_name = "input-intfhdl"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('uint64_array', (YLeafList(YType.uint64, 'uint64_array'), ['int'])),
                                                                                            ])
                                                                                            self.uint64_array = []
                                                                                            self._segment_path = lambda: "input-intfhdl"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                    class Ethertype(Entity):
                                                                                        """
                                                                                        Ethernet type
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                            self.yang_name = "ethertype"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "ethertype"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "ethertype"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint16_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['min', 'max'], name, value)


                                                                                    class FlowKeyData(Entity):
                                                                                        """
                                                                                        Flow key structure
                                                                                        
                                                                                        .. attribute:: flow_keys
                                                                                        
                                                                                        	flow keys
                                                                                        	**type**\:  :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                        
                                                                                        .. attribute:: max_count
                                                                                        
                                                                                        	Maximum count of flows
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: idle_timeout
                                                                                        
                                                                                        	Idle timeout of flows (in seconds)
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        	**units**\: second
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                            self.yang_name = "flow-key-data"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("flow-keys", ("flow_keys", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys))])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('max_count', (YLeaf(YType.uint16, 'max-count'), ['int'])),
                                                                                                ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                                            ])
                                                                                            self.max_count = None
                                                                                            self.idle_timeout = None

                                                                                            self.flow_keys = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                            self.flow_keys.parent = self
                                                                                            self._children_name_map["flow_keys"] = "flow-keys"
                                                                                            self._segment_path = lambda: "flow-key-data"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['max_count', 'idle_timeout'], name, value)


                                                                                        class FlowKeys(Entity):
                                                                                            """
                                                                                            flow keys
                                                                                            
                                                                                            .. attribute:: keys
                                                                                            
                                                                                            	keys
                                                                                            	**type**\: str
                                                                                            
                                                                                            	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                            
                                                                                            .. attribute:: num
                                                                                            
                                                                                            	num
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                self.yang_name = "flow-keys"
                                                                                                self.yang_parent_name = "flow-key-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('keys', (YLeaf(YType.str, 'keys'), ['str'])),
                                                                                                    ('num', (YLeaf(YType.uint8, 'num'), ['int'])),
                                                                                                ])
                                                                                                self.keys = None
                                                                                                self.num = None
                                                                                                self._segment_path = lambda: "flow-keys"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                    class DhcpClientId(Entity):
                                                                                        """
                                                                                        Dhcp Client ID
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                            self.yang_name = "dhcp-client-id"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "dhcp-client-id"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                    class DhcpClientIdRegex(Entity):
                                                                                        """
                                                                                        Dhcp Client ID RegEx
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                            self.yang_name = "dhcp-client-id-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "dhcp-client-id-regex"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                    class CircuitId(Entity):
                                                                                        """
                                                                                        Circuit ID
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                            self.yang_name = "circuit-id"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "circuit-id"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                    class CircuitIdRegex(Entity):
                                                                                        """
                                                                                        Circuit ID RegEx
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                            self.yang_name = "circuit-id-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "circuit-id-regex"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                    class RemoteId(Entity):
                                                                                        """
                                                                                        Remote ID
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                            self.yang_name = "remote-id"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "remote-id"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                    class RemoteIdRegex(Entity):
                                                                                        """
                                                                                        Remote ID RegEx
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\: list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                            self.yang_name = "remote-id-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                            ])
                                                                                            self.string_array = []
                                                                                            self._segment_path = lambda: "remote-id-regex"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                    class SrcPort(Entity):
                                                                                        """
                                                                                        Source port
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                            self.yang_name = "src-port"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "src-port"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "src-port"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint16_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                                    class DstPort(Entity):
                                                                                        """
                                                                                        Destination port
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                            self.yang_name = "dst-port"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "dst-port"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "dst-port"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                    ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                ])
                                                                                                self.min = None
                                                                                                self.max = None
                                                                                                self._segment_path = lambda: "uint16_rng_array"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['min', 'max'], name, value)


                                                            class Shape(Entity):
                                                                """
                                                                shape
                                                                
                                                                .. attribute:: bw
                                                                
                                                                	bw
                                                                	**type**\:  :py:class:`Bw <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw>`
                                                                
                                                                .. attribute:: be
                                                                
                                                                	be
                                                                	**type**\:  :py:class:`Be <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape, self).__init__()

                                                                    self.yang_name = "shape"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("bw", ("bw", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw)), ("be", ("be", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be))])
                                                                    self._leafs = OrderedDict()

                                                                    self.bw = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw()
                                                                    self.bw.parent = self
                                                                    self._children_name_map["bw"] = "bw"

                                                                    self.be = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be()
                                                                    self.be.parent = self
                                                                    self._children_name_map["be"] = "be"
                                                                    self._segment_path = lambda: "shape"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape, [], name, value)


                                                                class Bw(Entity):
                                                                    """
                                                                    bw
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw, self).__init__()

                                                                        self.yang_name = "bw"
                                                                        self.yang_parent_name = "shape"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                        ])
                                                                        self.value = None
                                                                        self.unit = None
                                                                        self._segment_path = lambda: "bw"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw, ['value', 'unit'], name, value)


                                                                class Be(Entity):
                                                                    """
                                                                    be
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be, self).__init__()

                                                                        self.yang_name = "be"
                                                                        self.yang_parent_name = "shape"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                        ])
                                                                        self.value = None
                                                                        self.unit = None
                                                                        self._segment_path = lambda: "be"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be, ['value', 'unit'], name, value)


                                                            class ChildPolicy(Entity):
                                                                """
                                                                child policy
                                                                
                                                                .. attribute:: info
                                                                
                                                                	info
                                                                	**type**\:  :py:class:`Info <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info>`
                                                                
                                                                .. attribute:: hd_info
                                                                
                                                                	hd info
                                                                	**type**\:  :py:class:`HdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo>`
                                                                
                                                                .. attribute:: enc
                                                                
                                                                	enc
                                                                	**type**\:  :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy, self).__init__()

                                                                    self.yang_name = "child-policy"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("info", ("info", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info)), ("hd-info", ("hd_info", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo))])
                                                                    self._leafs = OrderedDict([
                                                                        ('enc', (YLeaf(YType.enumeration, 'enc'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyObjEncEn', '')])),
                                                                    ])
                                                                    self.enc = None

                                                                    self.info = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info()
                                                                    self.info.parent = self
                                                                    self._children_name_map["info"] = "info"

                                                                    self.hd_info = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo()
                                                                    self.hd_info.parent = self
                                                                    self._children_name_map["hd_info"] = "hd-info"
                                                                    self._segment_path = lambda: "child-policy"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy, ['enc'], name, value)


                                                                class Info(Entity):
                                                                    """
                                                                    info
                                                                    
                                                                    .. attribute:: name
                                                                    
                                                                    	name
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..65
                                                                    
                                                                    .. attribute:: type
                                                                    
                                                                    	type
                                                                    	**type**\:  :py:class:`PolicyMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyMapTypeEn>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info, self).__init__()

                                                                        self.yang_name = "info"
                                                                        self.yang_parent_name = "child-policy"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyMapTypeEn', '')])),
                                                                        ])
                                                                        self.name = None
                                                                        self.type = None
                                                                        self._segment_path = lambda: "info"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info, ['name', 'type'], name, value)


                                                                class HdInfo(Entity):
                                                                    """
                                                                    hd info
                                                                    
                                                                    .. attribute:: data_hd
                                                                    
                                                                    	data hd
                                                                    	**type**\:  :py:class:`DataHd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd>`
                                                                    
                                                                    .. attribute:: hd
                                                                    
                                                                    	hd
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo, self).__init__()

                                                                        self.yang_name = "hd-info"
                                                                        self.yang_parent_name = "child-policy"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("data-hd", ("data_hd", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd))])
                                                                        self._leafs = OrderedDict([
                                                                            ('hd', (YLeaf(YType.uint64, 'hd'), ['int'])),
                                                                        ])
                                                                        self.hd = None

                                                                        self.data_hd = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd()
                                                                        self.data_hd.parent = self
                                                                        self._children_name_map["data_hd"] = "data-hd"
                                                                        self._segment_path = lambda: "hd-info"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo, ['hd'], name, value)


                                                                    class DataHd(Entity):
                                                                        """
                                                                        data hd
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd, self).__init__()

                                                                            self.yang_name = "data-hd"
                                                                            self.yang_parent_name = "hd-info"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict()
                                                                            self._segment_path = lambda: "data-hd"
                                                                            self._is_frozen = True


                                                            class Cac(Entity):
                                                                """
                                                                cac
                                                                
                                                                .. attribute:: flow_rate
                                                                
                                                                	flow rate
                                                                	**type**\:  :py:class:`FlowRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate>`
                                                                
                                                                .. attribute:: rate
                                                                
                                                                	rate
                                                                	**type**\:  :py:class:`Rate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate>`
                                                                
                                                                .. attribute:: cac_type
                                                                
                                                                	cac type
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..255
                                                                
                                                                .. attribute:: idle_timeout
                                                                
                                                                	idle timeout
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..65535
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac, self).__init__()

                                                                    self.yang_name = "cac"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("flow-rate", ("flow_rate", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate)), ("rate", ("rate", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate))])
                                                                    self._leafs = OrderedDict([
                                                                        ('cac_type', (YLeaf(YType.uint8, 'cac-type'), ['int'])),
                                                                        ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                    ])
                                                                    self.cac_type = None
                                                                    self.idle_timeout = None

                                                                    self.flow_rate = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate()
                                                                    self.flow_rate.parent = self
                                                                    self._children_name_map["flow_rate"] = "flow-rate"

                                                                    self.rate = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate()
                                                                    self.rate.parent = self
                                                                    self._children_name_map["rate"] = "rate"
                                                                    self._segment_path = lambda: "cac"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac, ['cac_type', 'idle_timeout'], name, value)


                                                                class FlowRate(Entity):
                                                                    """
                                                                    flow rate
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate, self).__init__()

                                                                        self.yang_name = "flow-rate"
                                                                        self.yang_parent_name = "cac"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                        ])
                                                                        self.value = None
                                                                        self.unit = None
                                                                        self._segment_path = lambda: "flow-rate"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate, ['value', 'unit'], name, value)


                                                                class Rate(Entity):
                                                                    """
                                                                    rate
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate, self).__init__()

                                                                        self.yang_name = "rate"
                                                                        self.yang_parent_name = "cac"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                        ])
                                                                        self.value = None
                                                                        self.unit = None
                                                                        self._segment_path = lambda: "rate"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate, ['value', 'unit'], name, value)


                                                            class Pfc(Entity):
                                                                """
                                                                pfc
                                                                
                                                                .. attribute:: buffer_size
                                                                
                                                                	buffer size
                                                                	**type**\:  :py:class:`BufferSize <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize>`
                                                                
                                                                .. attribute:: pause_threshold
                                                                
                                                                	pause threshold
                                                                	**type**\:  :py:class:`PauseThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold>`
                                                                
                                                                .. attribute:: resume_threshold
                                                                
                                                                	resume threshold
                                                                	**type**\:  :py:class:`ResumeThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold>`
                                                                
                                                                .. attribute:: pfc_pause_set
                                                                
                                                                	pfc pause set
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: buffer_size_flag
                                                                
                                                                	buffer size flag
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc, self).__init__()

                                                                    self.yang_name = "pfc"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("buffer-size", ("buffer_size", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize)), ("pause-threshold", ("pause_threshold", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold)), ("resume-threshold", ("resume_threshold", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold))])
                                                                    self._leafs = OrderedDict([
                                                                        ('pfc_pause_set', (YLeaf(YType.uint32, 'pfc-pause-set'), ['int'])),
                                                                        ('buffer_size_flag', (YLeaf(YType.uint32, 'buffer-size-flag'), ['int'])),
                                                                    ])
                                                                    self.pfc_pause_set = None
                                                                    self.buffer_size_flag = None

                                                                    self.buffer_size = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize()
                                                                    self.buffer_size.parent = self
                                                                    self._children_name_map["buffer_size"] = "buffer-size"

                                                                    self.pause_threshold = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold()
                                                                    self.pause_threshold.parent = self
                                                                    self._children_name_map["pause_threshold"] = "pause-threshold"

                                                                    self.resume_threshold = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold()
                                                                    self.resume_threshold.parent = self
                                                                    self._children_name_map["resume_threshold"] = "resume-threshold"
                                                                    self._segment_path = lambda: "pfc"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc, ['pfc_pause_set', 'buffer_size_flag'], name, value)


                                                                class BufferSize(Entity):
                                                                    """
                                                                    buffer size
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize, self).__init__()

                                                                        self.yang_name = "buffer-size"
                                                                        self.yang_parent_name = "pfc"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                        ])
                                                                        self.value = None
                                                                        self.unit = None
                                                                        self._segment_path = lambda: "buffer-size"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize, ['value', 'unit'], name, value)


                                                                class PauseThreshold(Entity):
                                                                    """
                                                                    pause threshold
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold, self).__init__()

                                                                        self.yang_name = "pause-threshold"
                                                                        self.yang_parent_name = "pfc"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                        ])
                                                                        self.value = None
                                                                        self.unit = None
                                                                        self._segment_path = lambda: "pause-threshold"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold, ['value', 'unit'], name, value)


                                                                class ResumeThreshold(Entity):
                                                                    """
                                                                    resume threshold
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold, self).__init__()

                                                                        self.yang_name = "resume-threshold"
                                                                        self.yang_parent_name = "pfc"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                        ])
                                                                        self.value = None
                                                                        self.unit = None
                                                                        self._segment_path = lambda: "resume-threshold"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold, ['value', 'unit'], name, value)


                                                            class FlowParm(Entity):
                                                                """
                                                                flow parm
                                                                
                                                                .. attribute:: max_mon_flows
                                                                
                                                                	max simult flows monitored per policy class
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: mon_interval
                                                                
                                                                	monitored interval duration in secs
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: second
                                                                
                                                                .. attribute:: intvl_hist
                                                                
                                                                	num intervals of data stored on rtr
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: flow_timeout
                                                                
                                                                	timeout in secs
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: second
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm, self).__init__()

                                                                    self.yang_name = "flow-parm"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('max_mon_flows', (YLeaf(YType.uint32, 'max-mon-flows'), ['int'])),
                                                                        ('mon_interval', (YLeaf(YType.uint32, 'mon-interval'), ['int'])),
                                                                        ('intvl_hist', (YLeaf(YType.uint32, 'intvl-hist'), ['int'])),
                                                                        ('flow_timeout', (YLeaf(YType.uint32, 'flow-timeout'), ['int'])),
                                                                    ])
                                                                    self.max_mon_flows = None
                                                                    self.mon_interval = None
                                                                    self.intvl_hist = None
                                                                    self.flow_timeout = None
                                                                    self._segment_path = lambda: "flow-parm"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm, ['max_mon_flows', 'mon_interval', 'intvl_hist', 'flow_timeout'], name, value)


                                                            class Ipcbr(Entity):
                                                                """
                                                                ipcbr
                                                                
                                                                .. attribute:: ip_bit_rate
                                                                
                                                                	data rate in bps
                                                                	**type**\:  :py:class:`IpBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate>`
                                                                
                                                                .. attribute:: media_bit_rate
                                                                
                                                                	media data rate in bps
                                                                	**type**\:  :py:class:`MediaBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate>`
                                                                
                                                                .. attribute:: action_metric_type
                                                                
                                                                	metric type
                                                                	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                
                                                                .. attribute:: ip_pkt_rate
                                                                
                                                                	packet rate in pps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: media_pkt_size
                                                                
                                                                	media packet size in bytes
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: media_pkts_per_ip
                                                                
                                                                	media packets per ip pkt
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr, self).__init__()

                                                                    self.yang_name = "ipcbr"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("ip-bit-rate", ("ip_bit_rate", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate)), ("media-bit-rate", ("media_bit_rate", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate))])
                                                                    self._leafs = OrderedDict([
                                                                        ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                        ('ip_pkt_rate', (YLeaf(YType.uint32, 'ip-pkt-rate'), ['int'])),
                                                                        ('media_pkt_size', (YLeaf(YType.uint32, 'media-pkt-size'), ['int'])),
                                                                        ('media_pkts_per_ip', (YLeaf(YType.uint32, 'media-pkts-per-ip'), ['int'])),
                                                                    ])
                                                                    self.action_metric_type = None
                                                                    self.ip_pkt_rate = None
                                                                    self.media_pkt_size = None
                                                                    self.media_pkts_per_ip = None

                                                                    self.ip_bit_rate = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate()
                                                                    self.ip_bit_rate.parent = self
                                                                    self._children_name_map["ip_bit_rate"] = "ip-bit-rate"

                                                                    self.media_bit_rate = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate()
                                                                    self.media_bit_rate.parent = self
                                                                    self._children_name_map["media_bit_rate"] = "media-bit-rate"
                                                                    self._segment_path = lambda: "ipcbr"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr, ['action_metric_type', 'ip_pkt_rate', 'media_pkt_size', 'media_pkts_per_ip'], name, value)


                                                                class IpBitRate(Entity):
                                                                    """
                                                                    data rate in bps
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate, self).__init__()

                                                                        self.yang_name = "ip-bit-rate"
                                                                        self.yang_parent_name = "ipcbr"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                        ])
                                                                        self.value = None
                                                                        self.unit = None
                                                                        self._segment_path = lambda: "ip-bit-rate"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate, ['value', 'unit'], name, value)


                                                                class MediaBitRate(Entity):
                                                                    """
                                                                    media data rate in bps
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate, self).__init__()

                                                                        self.yang_name = "media-bit-rate"
                                                                        self.yang_parent_name = "ipcbr"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                        ])
                                                                        self.value = None
                                                                        self.unit = None
                                                                        self._segment_path = lambda: "media-bit-rate"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate, ['value', 'unit'], name, value)


                                                            class Rtp(Entity):
                                                                """
                                                                rtp
                                                                
                                                                .. attribute:: action_metric_type
                                                                
                                                                	metric type
                                                                	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                
                                                                .. attribute:: min_sequential
                                                                
                                                                	min sequential
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: max_dropout
                                                                
                                                                	max dropout
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: max_misorder
                                                                
                                                                	max misorder
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: seq_ext_cop4
                                                                
                                                                	enable seq extension cop4
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: clock_rate
                                                                
                                                                	clock rate
                                                                	**type**\: list of  		 :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp, self).__init__()

                                                                    self.yang_name = "rtp"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("clock-rate", ("clock_rate", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate))])
                                                                    self._leafs = OrderedDict([
                                                                        ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                        ('min_sequential', (YLeaf(YType.uint32, 'min-sequential'), ['int'])),
                                                                        ('max_dropout', (YLeaf(YType.uint32, 'max-dropout'), ['int'])),
                                                                        ('max_misorder', (YLeaf(YType.uint32, 'max-misorder'), ['int'])),
                                                                        ('seq_ext_cop4', (YLeaf(YType.uint32, 'seq-ext-cop4'), ['int'])),
                                                                    ])
                                                                    self.action_metric_type = None
                                                                    self.min_sequential = None
                                                                    self.max_dropout = None
                                                                    self.max_misorder = None
                                                                    self.seq_ext_cop4 = None

                                                                    self.clock_rate = YList(self)
                                                                    self._segment_path = lambda: "rtp"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp, ['action_metric_type', 'min_sequential', 'max_dropout', 'max_misorder', 'seq_ext_cop4'], name, value)


                                                                class ClockRate(Entity):
                                                                    """
                                                                    clock rate
                                                                    
                                                                    .. attribute:: pt
                                                                    
                                                                    	pt
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: frequency
                                                                    
                                                                    	frequency
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate, self).__init__()

                                                                        self.yang_name = "clock-rate"
                                                                        self.yang_parent_name = "rtp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('pt', (YLeaf(YType.uint32, 'pt'), ['int'])),
                                                                            ('frequency', (YLeaf(YType.uint32, 'frequency'), ['int'])),
                                                                        ])
                                                                        self.pt = None
                                                                        self.frequency = None
                                                                        self._segment_path = lambda: "clock-rate"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate, ['pt', 'frequency'], name, value)


                                                            class RtpMmr(Entity):
                                                                """
                                                                rtp mmr
                                                                
                                                                .. attribute:: action_metric_type
                                                                
                                                                	metric type
                                                                	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                
                                                                .. attribute:: min_sequential
                                                                
                                                                	min sequential
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: max_dropout
                                                                
                                                                	max dropout
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: max_misorder
                                                                
                                                                	max misorder
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: seq_ext_cop4
                                                                
                                                                	enable seq extension cop4
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: clock_rate
                                                                
                                                                	clock rate
                                                                	**type**\: list of  		 :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr, self).__init__()

                                                                    self.yang_name = "rtp-mmr"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("clock-rate", ("clock_rate", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate))])
                                                                    self._leafs = OrderedDict([
                                                                        ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                        ('min_sequential', (YLeaf(YType.uint32, 'min-sequential'), ['int'])),
                                                                        ('max_dropout', (YLeaf(YType.uint32, 'max-dropout'), ['int'])),
                                                                        ('max_misorder', (YLeaf(YType.uint32, 'max-misorder'), ['int'])),
                                                                        ('seq_ext_cop4', (YLeaf(YType.uint32, 'seq-ext-cop4'), ['int'])),
                                                                    ])
                                                                    self.action_metric_type = None
                                                                    self.min_sequential = None
                                                                    self.max_dropout = None
                                                                    self.max_misorder = None
                                                                    self.seq_ext_cop4 = None

                                                                    self.clock_rate = YList(self)
                                                                    self._segment_path = lambda: "rtp-mmr"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr, ['action_metric_type', 'min_sequential', 'max_dropout', 'max_misorder', 'seq_ext_cop4'], name, value)


                                                                class ClockRate(Entity):
                                                                    """
                                                                    clock rate
                                                                    
                                                                    .. attribute:: pt
                                                                    
                                                                    	pt
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: frequency
                                                                    
                                                                    	frequency
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate, self).__init__()

                                                                        self.yang_name = "clock-rate"
                                                                        self.yang_parent_name = "rtp-mmr"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('pt', (YLeaf(YType.uint32, 'pt'), ['int'])),
                                                                            ('frequency', (YLeaf(YType.uint32, 'frequency'), ['int'])),
                                                                        ])
                                                                        self.pt = None
                                                                        self.frequency = None
                                                                        self._segment_path = lambda: "clock-rate"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate, ['pt', 'frequency'], name, value)


                                                            class RtpJ2k(Entity):
                                                                """
                                                                rtp j2k
                                                                
                                                                .. attribute:: action_metric_type
                                                                
                                                                	metric type
                                                                	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                
                                                                .. attribute:: min_sequential
                                                                
                                                                	min sequential
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: max_dropout
                                                                
                                                                	max dropout
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: max_misorder
                                                                
                                                                	max misorder
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: seq_ext_cop4
                                                                
                                                                	enable seq extension cop4
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: clock_rate
                                                                
                                                                	clock rate
                                                                	**type**\: list of  		 :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k.ClockRate>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k, self).__init__()

                                                                    self.yang_name = "rtp-j2k"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("clock-rate", ("clock_rate", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k.ClockRate))])
                                                                    self._leafs = OrderedDict([
                                                                        ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                        ('min_sequential', (YLeaf(YType.uint32, 'min-sequential'), ['int'])),
                                                                        ('max_dropout', (YLeaf(YType.uint32, 'max-dropout'), ['int'])),
                                                                        ('max_misorder', (YLeaf(YType.uint32, 'max-misorder'), ['int'])),
                                                                        ('seq_ext_cop4', (YLeaf(YType.uint32, 'seq-ext-cop4'), ['int'])),
                                                                    ])
                                                                    self.action_metric_type = None
                                                                    self.min_sequential = None
                                                                    self.max_dropout = None
                                                                    self.max_misorder = None
                                                                    self.seq_ext_cop4 = None

                                                                    self.clock_rate = YList(self)
                                                                    self._segment_path = lambda: "rtp-j2k"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k, ['action_metric_type', 'min_sequential', 'max_dropout', 'max_misorder', 'seq_ext_cop4'], name, value)


                                                                class ClockRate(Entity):
                                                                    """
                                                                    clock rate
                                                                    
                                                                    .. attribute:: pt
                                                                    
                                                                    	pt
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: frequency
                                                                    
                                                                    	frequency
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k.ClockRate, self).__init__()

                                                                        self.yang_name = "clock-rate"
                                                                        self.yang_parent_name = "rtp-j2k"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('pt', (YLeaf(YType.uint32, 'pt'), ['int'])),
                                                                            ('frequency', (YLeaf(YType.uint32, 'frequency'), ['int'])),
                                                                        ])
                                                                        self.pt = None
                                                                        self.frequency = None
                                                                        self._segment_path = lambda: "clock-rate"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k.ClockRate, ['pt', 'frequency'], name, value)


                                                            class RtpVoice(Entity):
                                                                """
                                                                rtp voice
                                                                
                                                                .. attribute:: action_metric_type
                                                                
                                                                	metric type
                                                                	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                
                                                                .. attribute:: min_sequential
                                                                
                                                                	min sequential
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: max_dropout
                                                                
                                                                	max dropout
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: max_misorder
                                                                
                                                                	max misorder
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: seq_ext_cop4
                                                                
                                                                	enable seq extension cop4
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: clock_rate
                                                                
                                                                	clock rate
                                                                	**type**\: list of  		 :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice, self).__init__()

                                                                    self.yang_name = "rtp-voice"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("clock-rate", ("clock_rate", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate))])
                                                                    self._leafs = OrderedDict([
                                                                        ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                        ('min_sequential', (YLeaf(YType.uint32, 'min-sequential'), ['int'])),
                                                                        ('max_dropout', (YLeaf(YType.uint32, 'max-dropout'), ['int'])),
                                                                        ('max_misorder', (YLeaf(YType.uint32, 'max-misorder'), ['int'])),
                                                                        ('seq_ext_cop4', (YLeaf(YType.uint32, 'seq-ext-cop4'), ['int'])),
                                                                    ])
                                                                    self.action_metric_type = None
                                                                    self.min_sequential = None
                                                                    self.max_dropout = None
                                                                    self.max_misorder = None
                                                                    self.seq_ext_cop4 = None

                                                                    self.clock_rate = YList(self)
                                                                    self._segment_path = lambda: "rtp-voice"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice, ['action_metric_type', 'min_sequential', 'max_dropout', 'max_misorder', 'seq_ext_cop4'], name, value)


                                                                class ClockRate(Entity):
                                                                    """
                                                                    clock rate
                                                                    
                                                                    .. attribute:: pt
                                                                    
                                                                    	pt
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: frequency
                                                                    
                                                                    	frequency
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate, self).__init__()

                                                                        self.yang_name = "clock-rate"
                                                                        self.yang_parent_name = "rtp-voice"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('pt', (YLeaf(YType.uint32, 'pt'), ['int'])),
                                                                            ('frequency', (YLeaf(YType.uint32, 'frequency'), ['int'])),
                                                                        ])
                                                                        self.pt = None
                                                                        self.frequency = None
                                                                        self._segment_path = lambda: "clock-rate"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate, ['pt', 'frequency'], name, value)


                                                            class Mdi(Entity):
                                                                """
                                                                mdi
                                                                
                                                                .. attribute:: ip_bit_rate
                                                                
                                                                	data rate in bps
                                                                	**type**\:  :py:class:`IpBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate>`
                                                                
                                                                .. attribute:: action_metric_type
                                                                
                                                                	metric type
                                                                	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                
                                                                .. attribute:: filtered_pkt_rate
                                                                
                                                                	filtered packet rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: ip_pkt_rate
                                                                
                                                                	packet rate in pps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: pids
                                                                
                                                                	array of monitoredcd  pids
                                                                	**type**\: list of int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi, self).__init__()

                                                                    self.yang_name = "mdi"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("ip-bit-rate", ("ip_bit_rate", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate))])
                                                                    self._leafs = OrderedDict([
                                                                        ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                        ('filtered_pkt_rate', (YLeaf(YType.uint32, 'filtered-pkt-rate'), ['int'])),
                                                                        ('ip_pkt_rate', (YLeaf(YType.uint32, 'ip-pkt-rate'), ['int'])),
                                                                        ('pids', (YLeafList(YType.uint32, 'pids'), ['int'])),
                                                                    ])
                                                                    self.action_metric_type = None
                                                                    self.filtered_pkt_rate = None
                                                                    self.ip_pkt_rate = None
                                                                    self.pids = []

                                                                    self.ip_bit_rate = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate()
                                                                    self.ip_bit_rate.parent = self
                                                                    self._children_name_map["ip_bit_rate"] = "ip-bit-rate"
                                                                    self._segment_path = lambda: "mdi"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi, ['action_metric_type', 'filtered_pkt_rate', 'ip_pkt_rate', 'pids'], name, value)


                                                                class IpBitRate(Entity):
                                                                    """
                                                                    data rate in bps
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate, self).__init__()

                                                                        self.yang_name = "ip-bit-rate"
                                                                        self.yang_parent_name = "mdi"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                        ])
                                                                        self.value = None
                                                                        self.unit = None
                                                                        self._segment_path = lambda: "ip-bit-rate"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate, ['value', 'unit'], name, value)


                                                            class MdiRtp(Entity):
                                                                """
                                                                mdi rtp
                                                                
                                                                .. attribute:: ip_bit_rate
                                                                
                                                                	data rate in bps
                                                                	**type**\:  :py:class:`IpBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate>`
                                                                
                                                                .. attribute:: action_metric_type
                                                                
                                                                	metric type
                                                                	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                
                                                                .. attribute:: filtered_pkt_rate
                                                                
                                                                	filtered packet rate
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: ip_pkt_rate
                                                                
                                                                	packet rate in pps
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: pids
                                                                
                                                                	array of monitoredcd  pids
                                                                	**type**\: list of int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp, self).__init__()

                                                                    self.yang_name = "mdi-rtp"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("ip-bit-rate", ("ip_bit_rate", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate))])
                                                                    self._leafs = OrderedDict([
                                                                        ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                        ('filtered_pkt_rate', (YLeaf(YType.uint32, 'filtered-pkt-rate'), ['int'])),
                                                                        ('ip_pkt_rate', (YLeaf(YType.uint32, 'ip-pkt-rate'), ['int'])),
                                                                        ('pids', (YLeafList(YType.uint32, 'pids'), ['int'])),
                                                                    ])
                                                                    self.action_metric_type = None
                                                                    self.filtered_pkt_rate = None
                                                                    self.ip_pkt_rate = None
                                                                    self.pids = []

                                                                    self.ip_bit_rate = PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate()
                                                                    self.ip_bit_rate.parent = self
                                                                    self._children_name_map["ip_bit_rate"] = "ip-bit-rate"
                                                                    self._segment_path = lambda: "mdi-rtp"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp, ['action_metric_type', 'filtered_pkt_rate', 'ip_pkt_rate', 'pids'], name, value)


                                                                class IpBitRate(Entity):
                                                                    """
                                                                    data rate in bps
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate, self).__init__()

                                                                        self.yang_name = "ip-bit-rate"
                                                                        self.yang_parent_name = "mdi-rtp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                        ])
                                                                        self.value = None
                                                                        self.unit = None
                                                                        self._segment_path = lambda: "ip-bit-rate"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate, ['value', 'unit'], name, value)


                                                            class Fmm(Entity):
                                                                """
                                                                fmm
                                                                
                                                                .. attribute:: fmm_name
                                                                
                                                                	flow monitor name
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..33
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm, self).__init__()

                                                                    self.yang_name = "fmm"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([])
                                                                    self._leafs = OrderedDict([
                                                                        ('fmm_name', (YLeaf(YType.str, 'fmm-name'), ['str'])),
                                                                    ])
                                                                    self.fmm_name = None
                                                                    self._segment_path = lambda: "fmm"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm, ['fmm_name'], name, value)


                                                            class Pbf(Entity):
                                                                """
                                                                pbf
                                                                
                                                                .. attribute:: action_pbf_info_array
                                                                
                                                                	action pbf info array
                                                                	**type**\: list of  		 :py:class:`ActionPbfInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf, self).__init__()

                                                                    self.yang_name = "pbf"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("action-pbf-info-array", ("action_pbf_info_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray))])
                                                                    self._leafs = OrderedDict()

                                                                    self.action_pbf_info_array = YList(self)
                                                                    self._segment_path = lambda: "pbf"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf, [], name, value)


                                                                class ActionPbfInfoArray(Entity):
                                                                    """
                                                                    action pbf info array
                                                                    
                                                                    .. attribute:: addr
                                                                    
                                                                    	v4 or v6 address
                                                                    	**type**\: str
                                                                    
                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                    
                                                                    .. attribute:: vrf
                                                                    
                                                                    	vrf name
                                                                    	**type**\: str
                                                                    
                                                                    .. attribute:: rt_type
                                                                    
                                                                    	route target type
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    .. attribute:: rt
                                                                    
                                                                    	route target
                                                                    	**type**\: str
                                                                    
                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray, self).__init__()

                                                                        self.yang_name = "action-pbf-info-array"
                                                                        self.yang_parent_name = "pbf"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('addr', (YLeaf(YType.str, 'addr'), ['str'])),
                                                                            ('vrf', (YLeaf(YType.str, 'vrf'), ['str'])),
                                                                            ('rt_type', (YLeaf(YType.uint8, 'rt-type'), ['int'])),
                                                                            ('rt', (YLeaf(YType.str, 'rt'), ['str'])),
                                                                        ])
                                                                        self.addr = None
                                                                        self.vrf = None
                                                                        self.rt_type = None
                                                                        self.rt = None
                                                                        self._segment_path = lambda: "action-pbf-info-array"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray, ['addr', 'vrf', 'rt_type', 'rt'], name, value)


                                                            class Ipv4Nh(Entity):
                                                                """
                                                                ipv4 nh
                                                                
                                                                .. attribute:: action_ipv4_nh_info_array
                                                                
                                                                	action ipv4 nh info array
                                                                	**type**\: list of  		 :py:class:`ActionIpv4NhInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh, self).__init__()

                                                                    self.yang_name = "ipv4-nh"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("action-ipv4-nh-info-array", ("action_ipv4_nh_info_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray))])
                                                                    self._leafs = OrderedDict()

                                                                    self.action_ipv4_nh_info_array = YList(self)
                                                                    self._segment_path = lambda: "ipv4-nh"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh, [], name, value)


                                                                class ActionIpv4NhInfoArray(Entity):
                                                                    """
                                                                    action ipv4 nh info array
                                                                    
                                                                    .. attribute:: nh_addr
                                                                    
                                                                    	nh addr
                                                                    	**type**\: str
                                                                    
                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                    
                                                                    .. attribute:: vrf_name
                                                                    
                                                                    	Vrf name
                                                                    	**type**\: str
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray, self).__init__()

                                                                        self.yang_name = "action-ipv4-nh-info-array"
                                                                        self.yang_parent_name = "ipv4-nh"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('nh_addr', (YLeaf(YType.str, 'nh-addr'), ['str'])),
                                                                            ('vrf_name', (YLeaf(YType.str, 'vrf-name'), ['str'])),
                                                                        ])
                                                                        self.nh_addr = None
                                                                        self.vrf_name = None
                                                                        self._segment_path = lambda: "action-ipv4-nh-info-array"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray, ['nh_addr', 'vrf_name'], name, value)


                                                            class Ipv6Nh(Entity):
                                                                """
                                                                ipv6 nh
                                                                
                                                                .. attribute:: action_ipv6_nh_info_array
                                                                
                                                                	action ipv6 nh info array
                                                                	**type**\: list of  		 :py:class:`ActionIpv6NhInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh, self).__init__()

                                                                    self.yang_name = "ipv6-nh"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("action-ipv6-nh-info-array", ("action_ipv6_nh_info_array", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray))])
                                                                    self._leafs = OrderedDict()

                                                                    self.action_ipv6_nh_info_array = YList(self)
                                                                    self._segment_path = lambda: "ipv6-nh"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh, [], name, value)


                                                                class ActionIpv6NhInfoArray(Entity):
                                                                    """
                                                                    action ipv6 nh info array
                                                                    
                                                                    .. attribute:: nh_addr
                                                                    
                                                                    	IPV6 Address
                                                                    	**type**\: str
                                                                    
                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                    
                                                                    .. attribute:: vrf_name
                                                                    
                                                                    	Vrf name
                                                                    	**type**\: str
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray, self).__init__()

                                                                        self.yang_name = "action-ipv6-nh-info-array"
                                                                        self.yang_parent_name = "ipv6-nh"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('nh_addr', (YLeaf(YType.str, 'nh-addr'), ['str'])),
                                                                            ('vrf_name', (YLeaf(YType.str, 'vrf-name'), ['str'])),
                                                                        ])
                                                                        self.nh_addr = None
                                                                        self.vrf_name = None
                                                                        self._segment_path = lambda: "action-ipv6-nh-info-array"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray, ['nh_addr', 'vrf_name'], name, value)


                    class PolicyMapDetails(Entity):
                        """
                        Policy\-map table
                        
                        .. attribute:: policy_map_detail
                        
                        	Policy\-map detail information
                        	**type**\: list of  		 :py:class:`PolicyMapDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail>`
                        
                        

                        """

                        _prefix = 'infra-policymgr-oper'
                        _revision = '2018-01-17'

                        def __init__(self):
                            super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails, self).__init__()

                            self.yang_name = "policy-map-details"
                            self.yang_parent_name = "policy-map-type"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("policy-map-detail", ("policy_map_detail", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail))])
                            self._leafs = OrderedDict()

                            self.policy_map_detail = YList(self)
                            self._segment_path = lambda: "policy-map-details"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails, [], name, value)


                        class PolicyMapDetail(Entity):
                            """
                            Policy\-map detail information
                            
                            .. attribute:: policy_map_name  (key)
                            
                            	Name of policy\-map
                            	**type**\: str
                            
                            	**length:** 1..63
                            
                            .. attribute:: object_type
                            
                            	Application type configured
                            	**type**\:  :py:class:`PlmgrApplnTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrApplnTypeEn>`
                            
                            .. attribute:: total_objects
                            
                            	Total number of objects configured for a specific object type
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: transient
                            
                            	Transient object
                            	**type**\: bool
                            
                            .. attribute:: reference
                            
                            	Each Policymap details
                            	**type**\: list of  		 :py:class:`Reference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail.Reference>`
                            
                            .. attribute:: objects
                            
                            	Each object details
                            	**type**\: list of  		 :py:class:`Objects <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail.Objects>`
                            
                            .. attribute:: class_map_reference
                            
                            	Each Classmapdetails
                            	**type**\: list of  		 :py:class:`ClassMapReference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail.ClassMapReference>`
                            
                            

                            """

                            _prefix = 'infra-policymgr-oper'
                            _revision = '2018-01-17'

                            def __init__(self):
                                super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail, self).__init__()

                                self.yang_name = "policy-map-detail"
                                self.yang_parent_name = "policy-map-details"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = ['policy_map_name']
                                self._child_classes = OrderedDict([("reference", ("reference", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail.Reference)), ("objects", ("objects", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail.Objects)), ("class-map-reference", ("class_map_reference", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail.ClassMapReference))])
                                self._leafs = OrderedDict([
                                    ('policy_map_name', (YLeaf(YType.str, 'policy-map-name'), ['str'])),
                                    ('object_type', (YLeaf(YType.enumeration, 'object-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PlmgrApplnTypeEn', '')])),
                                    ('total_objects', (YLeaf(YType.uint32, 'total-objects'), ['int'])),
                                    ('transient', (YLeaf(YType.boolean, 'transient'), ['bool'])),
                                ])
                                self.policy_map_name = None
                                self.object_type = None
                                self.total_objects = None
                                self.transient = None

                                self.reference = YList(self)
                                self.objects = YList(self)
                                self.class_map_reference = YList(self)
                                self._segment_path = lambda: "policy-map-detail" + "[policy-map-name='" + str(self.policy_map_name) + "']"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail, ['policy_map_name', 'object_type', 'total_objects', 'transient'], name, value)


                            class Reference(Entity):
                                """
                                Each Policymap details
                                
                                .. attribute:: total_internal_reference_objects
                                
                                	Total number of internal reference objects
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: total_class_maps
                                
                                	Total number of Classmaps in a Policymap
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: total_flows
                                
                                	Total flows in a Policymap
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'infra-policymgr-oper'
                                _revision = '2018-01-17'

                                def __init__(self):
                                    super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail.Reference, self).__init__()

                                    self.yang_name = "reference"
                                    self.yang_parent_name = "policy-map-detail"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('total_internal_reference_objects', (YLeaf(YType.uint32, 'total-internal-reference-objects'), ['int'])),
                                        ('total_class_maps', (YLeaf(YType.uint32, 'total-class-maps'), ['int'])),
                                        ('total_flows', (YLeaf(YType.uint32, 'total-flows'), ['int'])),
                                    ])
                                    self.total_internal_reference_objects = None
                                    self.total_class_maps = None
                                    self.total_flows = None
                                    self._segment_path = lambda: "reference"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail.Reference, ['total_internal_reference_objects', 'total_class_maps', 'total_flows'], name, value)


                            class Objects(Entity):
                                """
                                Each object details
                                
                                .. attribute:: object_name
                                
                                	Name of object (Policymap/Classmap)
                                	**type**\: str
                                
                                	**length:** 0..64
                                
                                

                                """

                                _prefix = 'infra-policymgr-oper'
                                _revision = '2018-01-17'

                                def __init__(self):
                                    super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail.Objects, self).__init__()

                                    self.yang_name = "objects"
                                    self.yang_parent_name = "policy-map-detail"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('object_name', (YLeaf(YType.str, 'object-name'), ['str'])),
                                    ])
                                    self.object_name = None
                                    self._segment_path = lambda: "objects"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail.Objects, ['object_name'], name, value)


                            class ClassMapReference(Entity):
                                """
                                Each Classmapdetails
                                
                                .. attribute:: total_reference_objects
                                
                                	Total number of Policymaps referencing a Classmap
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: policy_map_reference
                                
                                	List of Policymaps referencing a Classmap
                                	**type**\: list of  		 :py:class:`PolicyMapReference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail.ClassMapReference.PolicyMapReference>`
                                
                                

                                """

                                _prefix = 'infra-policymgr-oper'
                                _revision = '2018-01-17'

                                def __init__(self):
                                    super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail.ClassMapReference, self).__init__()

                                    self.yang_name = "class-map-reference"
                                    self.yang_parent_name = "policy-map-detail"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("policy-map-reference", ("policy_map_reference", PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail.ClassMapReference.PolicyMapReference))])
                                    self._leafs = OrderedDict([
                                        ('total_reference_objects', (YLeaf(YType.uint32, 'total-reference-objects'), ['int'])),
                                    ])
                                    self.total_reference_objects = None

                                    self.policy_map_reference = YList(self)
                                    self._segment_path = lambda: "class-map-reference"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail.ClassMapReference, ['total_reference_objects'], name, value)


                                class PolicyMapReference(Entity):
                                    """
                                    List of Policymaps referencing a Classmap
                                    
                                    .. attribute:: object_type
                                    
                                    	Application type configured
                                    	**type**\:  :py:class:`PlmgrApplnTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrApplnTypeEn>`
                                    
                                    .. attribute:: policy_map_name
                                    
                                    	Name of Policymap referencing a Classmap
                                    	**type**\: str
                                    
                                    	**length:** 0..64
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2018-01-17'

                                    def __init__(self):
                                        super(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail.ClassMapReference.PolicyMapReference, self).__init__()

                                        self.yang_name = "policy-map-reference"
                                        self.yang_parent_name = "class-map-reference"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('object_type', (YLeaf(YType.enumeration, 'object-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PlmgrApplnTypeEn', '')])),
                                            ('policy_map_name', (YLeaf(YType.str, 'policy-map-name'), ['str'])),
                                        ])
                                        self.object_type = None
                                        self.policy_map_name = None
                                        self._segment_path = lambda: "policy-map-reference"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Global.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail.ClassMapReference.PolicyMapReference, ['object_type', 'policy_map_name'], name, value)


            class TransientPolicyMapTypes(Entity):
                """
                Application type of transient policy\-map list
                
                .. attribute:: transient_policy_map_type
                
                	Transient policy\-map type
                	**type**\: list of  		 :py:class:`TransientPolicyMapType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType>`
                
                

                """

                _prefix = 'infra-policymgr-oper'
                _revision = '2018-01-17'

                def __init__(self):
                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypes, self).__init__()

                    self.yang_name = "transient-policy-map-types"
                    self.yang_parent_name = "policy-map"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("transient-policy-map-type", ("transient_policy_map_type", PolicyManager.Global.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType))])
                    self._leafs = OrderedDict()

                    self.transient_policy_map_type = YList(self)
                    self._segment_path = lambda: "transient-policy-map-types"
                    self._absolute_path = lambda: "Cisco-IOS-XR-infra-policymgr-oper:policy-manager/global/policy-map/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypes, [], name, value)


                class TransientPolicyMapType(Entity):
                    """
                    Transient policy\-map type
                    
                    .. attribute:: type  (key)
                    
                    	The application type
                    	**type**\:  :py:class:`PolicymgrPolicyMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicymgrPolicyMap>`
                    
                    .. attribute:: transient_list_unuseds
                    
                    	Transient policy\-map list unused table
                    	**type**\:  :py:class:`TransientListUnuseds <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds>`
                    
                    

                    """

                    _prefix = 'infra-policymgr-oper'
                    _revision = '2018-01-17'

                    def __init__(self):
                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType, self).__init__()

                        self.yang_name = "transient-policy-map-type"
                        self.yang_parent_name = "transient-policy-map-types"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = ['type']
                        self._child_classes = OrderedDict([("transient-list-unuseds", ("transient_list_unuseds", PolicyManager.Global.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds))])
                        self._leafs = OrderedDict([
                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicymgrPolicyMap', '')])),
                        ])
                        self.type = None

                        self.transient_list_unuseds = PolicyManager.Global.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds()
                        self.transient_list_unuseds.parent = self
                        self._children_name_map["transient_list_unuseds"] = "transient-list-unuseds"
                        self._segment_path = lambda: "transient-policy-map-type" + "[type='" + str(self.type) + "']"
                        self._absolute_path = lambda: "Cisco-IOS-XR-infra-policymgr-oper:policy-manager/global/policy-map/transient-policy-map-types/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType, ['type'], name, value)


                    class TransientListUnuseds(Entity):
                        """
                        Transient policy\-map list unused table
                        
                        .. attribute:: transient_list_unused
                        
                        	Policy\-map list unused
                        	**type**\: list of  		 :py:class:`TransientListUnused <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused>`
                        
                        

                        """

                        _prefix = 'infra-policymgr-oper'
                        _revision = '2018-01-17'

                        def __init__(self):
                            super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds, self).__init__()

                            self.yang_name = "transient-list-unuseds"
                            self.yang_parent_name = "transient-policy-map-type"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("transient-list-unused", ("transient_list_unused", PolicyManager.Global.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused))])
                            self._leafs = OrderedDict()

                            self.transient_list_unused = YList(self)
                            self._segment_path = lambda: "transient-list-unuseds"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds, [], name, value)


                        class TransientListUnused(Entity):
                            """
                            Policy\-map list unused
                            
                            .. attribute:: policy_map_name  (key)
                            
                            	Name of policy\-map
                            	**type**\: str
                            
                            	**length:** 1..63
                            
                            .. attribute:: object_type
                            
                            	Application type configured
                            	**type**\:  :py:class:`PlmgrApplnTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrApplnTypeEn>`
                            
                            .. attribute:: total_objects
                            
                            	Total number of objects configured for a specific object type
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: transient
                            
                            	Transient object
                            	**type**\: bool
                            
                            .. attribute:: reference
                            
                            	Each Policymap details
                            	**type**\: list of  		 :py:class:`Reference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused.Reference>`
                            
                            .. attribute:: objects
                            
                            	Each object details
                            	**type**\: list of  		 :py:class:`Objects <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused.Objects>`
                            
                            .. attribute:: class_map_reference
                            
                            	Each Classmapdetails
                            	**type**\: list of  		 :py:class:`ClassMapReference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused.ClassMapReference>`
                            
                            

                            """

                            _prefix = 'infra-policymgr-oper'
                            _revision = '2018-01-17'

                            def __init__(self):
                                super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused, self).__init__()

                                self.yang_name = "transient-list-unused"
                                self.yang_parent_name = "transient-list-unuseds"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = ['policy_map_name']
                                self._child_classes = OrderedDict([("reference", ("reference", PolicyManager.Global.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused.Reference)), ("objects", ("objects", PolicyManager.Global.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused.Objects)), ("class-map-reference", ("class_map_reference", PolicyManager.Global.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused.ClassMapReference))])
                                self._leafs = OrderedDict([
                                    ('policy_map_name', (YLeaf(YType.str, 'policy-map-name'), ['str'])),
                                    ('object_type', (YLeaf(YType.enumeration, 'object-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PlmgrApplnTypeEn', '')])),
                                    ('total_objects', (YLeaf(YType.uint32, 'total-objects'), ['int'])),
                                    ('transient', (YLeaf(YType.boolean, 'transient'), ['bool'])),
                                ])
                                self.policy_map_name = None
                                self.object_type = None
                                self.total_objects = None
                                self.transient = None

                                self.reference = YList(self)
                                self.objects = YList(self)
                                self.class_map_reference = YList(self)
                                self._segment_path = lambda: "transient-list-unused" + "[policy-map-name='" + str(self.policy_map_name) + "']"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused, ['policy_map_name', 'object_type', 'total_objects', 'transient'], name, value)


                            class Reference(Entity):
                                """
                                Each Policymap details
                                
                                .. attribute:: total_internal_reference_objects
                                
                                	Total number of internal reference objects
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: total_class_maps
                                
                                	Total number of Classmaps in a Policymap
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: total_flows
                                
                                	Total flows in a Policymap
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'infra-policymgr-oper'
                                _revision = '2018-01-17'

                                def __init__(self):
                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused.Reference, self).__init__()

                                    self.yang_name = "reference"
                                    self.yang_parent_name = "transient-list-unused"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('total_internal_reference_objects', (YLeaf(YType.uint32, 'total-internal-reference-objects'), ['int'])),
                                        ('total_class_maps', (YLeaf(YType.uint32, 'total-class-maps'), ['int'])),
                                        ('total_flows', (YLeaf(YType.uint32, 'total-flows'), ['int'])),
                                    ])
                                    self.total_internal_reference_objects = None
                                    self.total_class_maps = None
                                    self.total_flows = None
                                    self._segment_path = lambda: "reference"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused.Reference, ['total_internal_reference_objects', 'total_class_maps', 'total_flows'], name, value)


                            class Objects(Entity):
                                """
                                Each object details
                                
                                .. attribute:: object_name
                                
                                	Name of object (Policymap/Classmap)
                                	**type**\: str
                                
                                	**length:** 0..64
                                
                                

                                """

                                _prefix = 'infra-policymgr-oper'
                                _revision = '2018-01-17'

                                def __init__(self):
                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused.Objects, self).__init__()

                                    self.yang_name = "objects"
                                    self.yang_parent_name = "transient-list-unused"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('object_name', (YLeaf(YType.str, 'object-name'), ['str'])),
                                    ])
                                    self.object_name = None
                                    self._segment_path = lambda: "objects"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused.Objects, ['object_name'], name, value)


                            class ClassMapReference(Entity):
                                """
                                Each Classmapdetails
                                
                                .. attribute:: total_reference_objects
                                
                                	Total number of Policymaps referencing a Classmap
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: policy_map_reference
                                
                                	List of Policymaps referencing a Classmap
                                	**type**\: list of  		 :py:class:`PolicyMapReference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused.ClassMapReference.PolicyMapReference>`
                                
                                

                                """

                                _prefix = 'infra-policymgr-oper'
                                _revision = '2018-01-17'

                                def __init__(self):
                                    super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused.ClassMapReference, self).__init__()

                                    self.yang_name = "class-map-reference"
                                    self.yang_parent_name = "transient-list-unused"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("policy-map-reference", ("policy_map_reference", PolicyManager.Global.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused.ClassMapReference.PolicyMapReference))])
                                    self._leafs = OrderedDict([
                                        ('total_reference_objects', (YLeaf(YType.uint32, 'total-reference-objects'), ['int'])),
                                    ])
                                    self.total_reference_objects = None

                                    self.policy_map_reference = YList(self)
                                    self._segment_path = lambda: "class-map-reference"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused.ClassMapReference, ['total_reference_objects'], name, value)


                                class PolicyMapReference(Entity):
                                    """
                                    List of Policymaps referencing a Classmap
                                    
                                    .. attribute:: object_type
                                    
                                    	Application type configured
                                    	**type**\:  :py:class:`PlmgrApplnTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrApplnTypeEn>`
                                    
                                    .. attribute:: policy_map_name
                                    
                                    	Name of Policymap referencing a Classmap
                                    	**type**\: str
                                    
                                    	**length:** 0..64
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2018-01-17'

                                    def __init__(self):
                                        super(PolicyManager.Global.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused.ClassMapReference.PolicyMapReference, self).__init__()

                                        self.yang_name = "policy-map-reference"
                                        self.yang_parent_name = "class-map-reference"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('object_type', (YLeaf(YType.enumeration, 'object-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PlmgrApplnTypeEn', '')])),
                                            ('policy_map_name', (YLeaf(YType.str, 'policy-map-name'), ['str'])),
                                        ])
                                        self.object_type = None
                                        self.policy_map_name = None
                                        self._segment_path = lambda: "policy-map-reference"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Global.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused.ClassMapReference.PolicyMapReference, ['object_type', 'policy_map_name'], name, value)


        class Summary(Entity):
            """
            Summary of policy\-maps and class\-maps configured
            
            .. attribute:: total_class_maps
            
            	Total number of Classmaps configured
            	**type**\: int
            
            	**range:** 0..4294967295
            
            .. attribute:: total_class_map_types
            
            	Total number of Classmap types configured
            	**type**\: int
            
            	**range:** 0..4294967295
            
            .. attribute:: total_policy_maps
            
            	Total number of Policymaps configured
            	**type**\: int
            
            	**range:** 0..4294967295
            
            .. attribute:: total_policy_map_types
            
            	Total number of Policymap types configured
            	**type**\: int
            
            	**range:** 0..4294967295
            
            .. attribute:: class_maps
            
            	Summary of Classmap database
            	**type**\: list of  		 :py:class:`ClassMaps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.Summary.ClassMaps>`
            
            .. attribute:: policy_maps
            
            	Summary of Policymap database
            	**type**\: list of  		 :py:class:`PolicyMaps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.Summary.PolicyMaps>`
            
            

            """

            _prefix = 'infra-policymgr-oper'
            _revision = '2018-01-17'

            def __init__(self):
                super(PolicyManager.Global.Summary, self).__init__()

                self.yang_name = "summary"
                self.yang_parent_name = "global"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("class-maps", ("class_maps", PolicyManager.Global.Summary.ClassMaps)), ("policy-maps", ("policy_maps", PolicyManager.Global.Summary.PolicyMaps))])
                self._leafs = OrderedDict([
                    ('total_class_maps', (YLeaf(YType.uint32, 'total-class-maps'), ['int'])),
                    ('total_class_map_types', (YLeaf(YType.uint32, 'total-class-map-types'), ['int'])),
                    ('total_policy_maps', (YLeaf(YType.uint32, 'total-policy-maps'), ['int'])),
                    ('total_policy_map_types', (YLeaf(YType.uint32, 'total-policy-map-types'), ['int'])),
                ])
                self.total_class_maps = None
                self.total_class_map_types = None
                self.total_policy_maps = None
                self.total_policy_map_types = None

                self.class_maps = YList(self)
                self.policy_maps = YList(self)
                self._segment_path = lambda: "summary"
                self._absolute_path = lambda: "Cisco-IOS-XR-infra-policymgr-oper:policy-manager/global/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(PolicyManager.Global.Summary, ['total_class_maps', 'total_class_map_types', 'total_policy_maps', 'total_policy_map_types'], name, value)


            class ClassMaps(Entity):
                """
                Summary of Classmap database
                
                .. attribute:: object_type
                
                	Application type configured
                	**type**\:  :py:class:`PlmgrApplnTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrApplnTypeEn>`
                
                .. attribute:: total_objects
                
                	Total number of objects configured for a specific object type
                	**type**\: int
                
                	**range:** 0..4294967295
                
                .. attribute:: transient
                
                	Transient object
                	**type**\: bool
                
                .. attribute:: reference
                
                	Each Policymap details
                	**type**\: list of  		 :py:class:`Reference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.Summary.ClassMaps.Reference>`
                
                .. attribute:: objects
                
                	Each object details
                	**type**\: list of  		 :py:class:`Objects <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.Summary.ClassMaps.Objects>`
                
                .. attribute:: class_map_reference
                
                	Each Classmapdetails
                	**type**\: list of  		 :py:class:`ClassMapReference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.Summary.ClassMaps.ClassMapReference>`
                
                

                """

                _prefix = 'infra-policymgr-oper'
                _revision = '2018-01-17'

                def __init__(self):
                    super(PolicyManager.Global.Summary.ClassMaps, self).__init__()

                    self.yang_name = "class-maps"
                    self.yang_parent_name = "summary"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("reference", ("reference", PolicyManager.Global.Summary.ClassMaps.Reference)), ("objects", ("objects", PolicyManager.Global.Summary.ClassMaps.Objects)), ("class-map-reference", ("class_map_reference", PolicyManager.Global.Summary.ClassMaps.ClassMapReference))])
                    self._leafs = OrderedDict([
                        ('object_type', (YLeaf(YType.enumeration, 'object-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PlmgrApplnTypeEn', '')])),
                        ('total_objects', (YLeaf(YType.uint32, 'total-objects'), ['int'])),
                        ('transient', (YLeaf(YType.boolean, 'transient'), ['bool'])),
                    ])
                    self.object_type = None
                    self.total_objects = None
                    self.transient = None

                    self.reference = YList(self)
                    self.objects = YList(self)
                    self.class_map_reference = YList(self)
                    self._segment_path = lambda: "class-maps"
                    self._absolute_path = lambda: "Cisco-IOS-XR-infra-policymgr-oper:policy-manager/global/summary/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(PolicyManager.Global.Summary.ClassMaps, ['object_type', 'total_objects', 'transient'], name, value)


                class Reference(Entity):
                    """
                    Each Policymap details
                    
                    .. attribute:: total_internal_reference_objects
                    
                    	Total number of internal reference objects
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: total_class_maps
                    
                    	Total number of Classmaps in a Policymap
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: total_flows
                    
                    	Total flows in a Policymap
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'infra-policymgr-oper'
                    _revision = '2018-01-17'

                    def __init__(self):
                        super(PolicyManager.Global.Summary.ClassMaps.Reference, self).__init__()

                        self.yang_name = "reference"
                        self.yang_parent_name = "class-maps"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('total_internal_reference_objects', (YLeaf(YType.uint32, 'total-internal-reference-objects'), ['int'])),
                            ('total_class_maps', (YLeaf(YType.uint32, 'total-class-maps'), ['int'])),
                            ('total_flows', (YLeaf(YType.uint32, 'total-flows'), ['int'])),
                        ])
                        self.total_internal_reference_objects = None
                        self.total_class_maps = None
                        self.total_flows = None
                        self._segment_path = lambda: "reference"
                        self._absolute_path = lambda: "Cisco-IOS-XR-infra-policymgr-oper:policy-manager/global/summary/class-maps/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(PolicyManager.Global.Summary.ClassMaps.Reference, ['total_internal_reference_objects', 'total_class_maps', 'total_flows'], name, value)


                class Objects(Entity):
                    """
                    Each object details
                    
                    .. attribute:: object_name
                    
                    	Name of object (Policymap/Classmap)
                    	**type**\: str
                    
                    	**length:** 0..64
                    
                    

                    """

                    _prefix = 'infra-policymgr-oper'
                    _revision = '2018-01-17'

                    def __init__(self):
                        super(PolicyManager.Global.Summary.ClassMaps.Objects, self).__init__()

                        self.yang_name = "objects"
                        self.yang_parent_name = "class-maps"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('object_name', (YLeaf(YType.str, 'object-name'), ['str'])),
                        ])
                        self.object_name = None
                        self._segment_path = lambda: "objects"
                        self._absolute_path = lambda: "Cisco-IOS-XR-infra-policymgr-oper:policy-manager/global/summary/class-maps/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(PolicyManager.Global.Summary.ClassMaps.Objects, ['object_name'], name, value)


                class ClassMapReference(Entity):
                    """
                    Each Classmapdetails
                    
                    .. attribute:: total_reference_objects
                    
                    	Total number of Policymaps referencing a Classmap
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: policy_map_reference
                    
                    	List of Policymaps referencing a Classmap
                    	**type**\: list of  		 :py:class:`PolicyMapReference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.Summary.ClassMaps.ClassMapReference.PolicyMapReference>`
                    
                    

                    """

                    _prefix = 'infra-policymgr-oper'
                    _revision = '2018-01-17'

                    def __init__(self):
                        super(PolicyManager.Global.Summary.ClassMaps.ClassMapReference, self).__init__()

                        self.yang_name = "class-map-reference"
                        self.yang_parent_name = "class-maps"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("policy-map-reference", ("policy_map_reference", PolicyManager.Global.Summary.ClassMaps.ClassMapReference.PolicyMapReference))])
                        self._leafs = OrderedDict([
                            ('total_reference_objects', (YLeaf(YType.uint32, 'total-reference-objects'), ['int'])),
                        ])
                        self.total_reference_objects = None

                        self.policy_map_reference = YList(self)
                        self._segment_path = lambda: "class-map-reference"
                        self._absolute_path = lambda: "Cisco-IOS-XR-infra-policymgr-oper:policy-manager/global/summary/class-maps/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(PolicyManager.Global.Summary.ClassMaps.ClassMapReference, ['total_reference_objects'], name, value)


                    class PolicyMapReference(Entity):
                        """
                        List of Policymaps referencing a Classmap
                        
                        .. attribute:: object_type
                        
                        	Application type configured
                        	**type**\:  :py:class:`PlmgrApplnTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrApplnTypeEn>`
                        
                        .. attribute:: policy_map_name
                        
                        	Name of Policymap referencing a Classmap
                        	**type**\: str
                        
                        	**length:** 0..64
                        
                        

                        """

                        _prefix = 'infra-policymgr-oper'
                        _revision = '2018-01-17'

                        def __init__(self):
                            super(PolicyManager.Global.Summary.ClassMaps.ClassMapReference.PolicyMapReference, self).__init__()

                            self.yang_name = "policy-map-reference"
                            self.yang_parent_name = "class-map-reference"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('object_type', (YLeaf(YType.enumeration, 'object-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PlmgrApplnTypeEn', '')])),
                                ('policy_map_name', (YLeaf(YType.str, 'policy-map-name'), ['str'])),
                            ])
                            self.object_type = None
                            self.policy_map_name = None
                            self._segment_path = lambda: "policy-map-reference"
                            self._absolute_path = lambda: "Cisco-IOS-XR-infra-policymgr-oper:policy-manager/global/summary/class-maps/class-map-reference/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(PolicyManager.Global.Summary.ClassMaps.ClassMapReference.PolicyMapReference, ['object_type', 'policy_map_name'], name, value)


            class PolicyMaps(Entity):
                """
                Summary of Policymap database
                
                .. attribute:: object_type
                
                	Application type configured
                	**type**\:  :py:class:`PlmgrApplnTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrApplnTypeEn>`
                
                .. attribute:: total_objects
                
                	Total number of objects configured for a specific object type
                	**type**\: int
                
                	**range:** 0..4294967295
                
                .. attribute:: transient
                
                	Transient object
                	**type**\: bool
                
                .. attribute:: reference
                
                	Each Policymap details
                	**type**\: list of  		 :py:class:`Reference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.Summary.PolicyMaps.Reference>`
                
                .. attribute:: objects
                
                	Each object details
                	**type**\: list of  		 :py:class:`Objects <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.Summary.PolicyMaps.Objects>`
                
                .. attribute:: class_map_reference
                
                	Each Classmapdetails
                	**type**\: list of  		 :py:class:`ClassMapReference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.Summary.PolicyMaps.ClassMapReference>`
                
                

                """

                _prefix = 'infra-policymgr-oper'
                _revision = '2018-01-17'

                def __init__(self):
                    super(PolicyManager.Global.Summary.PolicyMaps, self).__init__()

                    self.yang_name = "policy-maps"
                    self.yang_parent_name = "summary"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("reference", ("reference", PolicyManager.Global.Summary.PolicyMaps.Reference)), ("objects", ("objects", PolicyManager.Global.Summary.PolicyMaps.Objects)), ("class-map-reference", ("class_map_reference", PolicyManager.Global.Summary.PolicyMaps.ClassMapReference))])
                    self._leafs = OrderedDict([
                        ('object_type', (YLeaf(YType.enumeration, 'object-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PlmgrApplnTypeEn', '')])),
                        ('total_objects', (YLeaf(YType.uint32, 'total-objects'), ['int'])),
                        ('transient', (YLeaf(YType.boolean, 'transient'), ['bool'])),
                    ])
                    self.object_type = None
                    self.total_objects = None
                    self.transient = None

                    self.reference = YList(self)
                    self.objects = YList(self)
                    self.class_map_reference = YList(self)
                    self._segment_path = lambda: "policy-maps"
                    self._absolute_path = lambda: "Cisco-IOS-XR-infra-policymgr-oper:policy-manager/global/summary/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(PolicyManager.Global.Summary.PolicyMaps, ['object_type', 'total_objects', 'transient'], name, value)


                class Reference(Entity):
                    """
                    Each Policymap details
                    
                    .. attribute:: total_internal_reference_objects
                    
                    	Total number of internal reference objects
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: total_class_maps
                    
                    	Total number of Classmaps in a Policymap
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: total_flows
                    
                    	Total flows in a Policymap
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'infra-policymgr-oper'
                    _revision = '2018-01-17'

                    def __init__(self):
                        super(PolicyManager.Global.Summary.PolicyMaps.Reference, self).__init__()

                        self.yang_name = "reference"
                        self.yang_parent_name = "policy-maps"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('total_internal_reference_objects', (YLeaf(YType.uint32, 'total-internal-reference-objects'), ['int'])),
                            ('total_class_maps', (YLeaf(YType.uint32, 'total-class-maps'), ['int'])),
                            ('total_flows', (YLeaf(YType.uint32, 'total-flows'), ['int'])),
                        ])
                        self.total_internal_reference_objects = None
                        self.total_class_maps = None
                        self.total_flows = None
                        self._segment_path = lambda: "reference"
                        self._absolute_path = lambda: "Cisco-IOS-XR-infra-policymgr-oper:policy-manager/global/summary/policy-maps/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(PolicyManager.Global.Summary.PolicyMaps.Reference, ['total_internal_reference_objects', 'total_class_maps', 'total_flows'], name, value)


                class Objects(Entity):
                    """
                    Each object details
                    
                    .. attribute:: object_name
                    
                    	Name of object (Policymap/Classmap)
                    	**type**\: str
                    
                    	**length:** 0..64
                    
                    

                    """

                    _prefix = 'infra-policymgr-oper'
                    _revision = '2018-01-17'

                    def __init__(self):
                        super(PolicyManager.Global.Summary.PolicyMaps.Objects, self).__init__()

                        self.yang_name = "objects"
                        self.yang_parent_name = "policy-maps"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('object_name', (YLeaf(YType.str, 'object-name'), ['str'])),
                        ])
                        self.object_name = None
                        self._segment_path = lambda: "objects"
                        self._absolute_path = lambda: "Cisco-IOS-XR-infra-policymgr-oper:policy-manager/global/summary/policy-maps/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(PolicyManager.Global.Summary.PolicyMaps.Objects, ['object_name'], name, value)


                class ClassMapReference(Entity):
                    """
                    Each Classmapdetails
                    
                    .. attribute:: total_reference_objects
                    
                    	Total number of Policymaps referencing a Classmap
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: policy_map_reference
                    
                    	List of Policymaps referencing a Classmap
                    	**type**\: list of  		 :py:class:`PolicyMapReference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global.Summary.PolicyMaps.ClassMapReference.PolicyMapReference>`
                    
                    

                    """

                    _prefix = 'infra-policymgr-oper'
                    _revision = '2018-01-17'

                    def __init__(self):
                        super(PolicyManager.Global.Summary.PolicyMaps.ClassMapReference, self).__init__()

                        self.yang_name = "class-map-reference"
                        self.yang_parent_name = "policy-maps"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("policy-map-reference", ("policy_map_reference", PolicyManager.Global.Summary.PolicyMaps.ClassMapReference.PolicyMapReference))])
                        self._leafs = OrderedDict([
                            ('total_reference_objects', (YLeaf(YType.uint32, 'total-reference-objects'), ['int'])),
                        ])
                        self.total_reference_objects = None

                        self.policy_map_reference = YList(self)
                        self._segment_path = lambda: "class-map-reference"
                        self._absolute_path = lambda: "Cisco-IOS-XR-infra-policymgr-oper:policy-manager/global/summary/policy-maps/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(PolicyManager.Global.Summary.PolicyMaps.ClassMapReference, ['total_reference_objects'], name, value)


                    class PolicyMapReference(Entity):
                        """
                        List of Policymaps referencing a Classmap
                        
                        .. attribute:: object_type
                        
                        	Application type configured
                        	**type**\:  :py:class:`PlmgrApplnTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrApplnTypeEn>`
                        
                        .. attribute:: policy_map_name
                        
                        	Name of Policymap referencing a Classmap
                        	**type**\: str
                        
                        	**length:** 0..64
                        
                        

                        """

                        _prefix = 'infra-policymgr-oper'
                        _revision = '2018-01-17'

                        def __init__(self):
                            super(PolicyManager.Global.Summary.PolicyMaps.ClassMapReference.PolicyMapReference, self).__init__()

                            self.yang_name = "policy-map-reference"
                            self.yang_parent_name = "class-map-reference"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('object_type', (YLeaf(YType.enumeration, 'object-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PlmgrApplnTypeEn', '')])),
                                ('policy_map_name', (YLeaf(YType.str, 'policy-map-name'), ['str'])),
                            ])
                            self.object_type = None
                            self.policy_map_name = None
                            self._segment_path = lambda: "policy-map-reference"
                            self._absolute_path = lambda: "Cisco-IOS-XR-infra-policymgr-oper:policy-manager/global/summary/policy-maps/class-map-reference/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(PolicyManager.Global.Summary.PolicyMaps.ClassMapReference.PolicyMapReference, ['object_type', 'policy_map_name'], name, value)


    class Nodes(Entity):
        """
        Node\-specific Policymgr operational data
        
        .. attribute:: node
        
        	Policymgr operational data for a particular node
        	**type**\: list of  		 :py:class:`Node <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node>`
        
        

        """

        _prefix = 'infra-policymgr-oper'
        _revision = '2018-01-17'

        def __init__(self):
            super(PolicyManager.Nodes, self).__init__()

            self.yang_name = "nodes"
            self.yang_parent_name = "policy-manager"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("node", ("node", PolicyManager.Nodes.Node))])
            self._leafs = OrderedDict()

            self.node = YList(self)
            self._segment_path = lambda: "nodes"
            self._absolute_path = lambda: "Cisco-IOS-XR-infra-policymgr-oper:policy-manager/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(PolicyManager.Nodes, [], name, value)


        class Node(Entity):
            """
            Policymgr operational data for a particular
            node
            
            .. attribute:: node_name  (key)
            
            	Node name
            	**type**\: str
            
            	**pattern:** ([a\-zA\-Z0\-9\_]\*\\d+/){1,2}([a\-zA\-Z0\-9\_]\*\\d+)
            
            .. attribute:: target_policy_map_types
            
            	Targets of a policymap
            	**type**\:  :py:class:`TargetPolicyMapTypes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.TargetPolicyMapTypes>`
            
            .. attribute:: class_map
            
            	List of classmap details
            	**type**\:  :py:class:`ClassMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap>`
            
            .. attribute:: policy_map
            
            	List of policymap details
            	**type**\:  :py:class:`PolicyMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap>`
            
            .. attribute:: summary
            
            	Summary of policy\-maps and class\-maps configured
            	**type**\:  :py:class:`Summary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.Summary>`
            
            

            """

            _prefix = 'infra-policymgr-oper'
            _revision = '2018-01-17'

            def __init__(self):
                super(PolicyManager.Nodes.Node, self).__init__()

                self.yang_name = "node"
                self.yang_parent_name = "nodes"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = ['node_name']
                self._child_classes = OrderedDict([("target-policy-map-types", ("target_policy_map_types", PolicyManager.Nodes.Node.TargetPolicyMapTypes)), ("class-map", ("class_map", PolicyManager.Nodes.Node.ClassMap)), ("policy-map", ("policy_map", PolicyManager.Nodes.Node.PolicyMap)), ("summary", ("summary", PolicyManager.Nodes.Node.Summary))])
                self._leafs = OrderedDict([
                    ('node_name', (YLeaf(YType.str, 'node-name'), ['str'])),
                ])
                self.node_name = None

                self.target_policy_map_types = PolicyManager.Nodes.Node.TargetPolicyMapTypes()
                self.target_policy_map_types.parent = self
                self._children_name_map["target_policy_map_types"] = "target-policy-map-types"

                self.class_map = PolicyManager.Nodes.Node.ClassMap()
                self.class_map.parent = self
                self._children_name_map["class_map"] = "class-map"

                self.policy_map = PolicyManager.Nodes.Node.PolicyMap()
                self.policy_map.parent = self
                self._children_name_map["policy_map"] = "policy-map"

                self.summary = PolicyManager.Nodes.Node.Summary()
                self.summary.parent = self
                self._children_name_map["summary"] = "summary"
                self._segment_path = lambda: "node" + "[node-name='" + str(self.node_name) + "']"
                self._absolute_path = lambda: "Cisco-IOS-XR-infra-policymgr-oper:policy-manager/nodes/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(PolicyManager.Nodes.Node, ['node_name'], name, value)


            class TargetPolicyMapTypes(Entity):
                """
                Targets of a policymap
                
                .. attribute:: target_policy_map_type
                
                	Policymgr application type
                	**type**\: list of  		 :py:class:`TargetPolicyMapType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.TargetPolicyMapTypes.TargetPolicyMapType>`
                
                

                """

                _prefix = 'infra-policymgr-oper'
                _revision = '2018-01-17'

                def __init__(self):
                    super(PolicyManager.Nodes.Node.TargetPolicyMapTypes, self).__init__()

                    self.yang_name = "target-policy-map-types"
                    self.yang_parent_name = "node"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("target-policy-map-type", ("target_policy_map_type", PolicyManager.Nodes.Node.TargetPolicyMapTypes.TargetPolicyMapType))])
                    self._leafs = OrderedDict()

                    self.target_policy_map_type = YList(self)
                    self._segment_path = lambda: "target-policy-map-types"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(PolicyManager.Nodes.Node.TargetPolicyMapTypes, [], name, value)


                class TargetPolicyMapType(Entity):
                    """
                    Policymgr application type
                    
                    .. attribute:: type  (key)
                    
                    	The application type
                    	**type**\:  :py:class:`PolicymgrPolicyMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicymgrPolicyMap>`
                    
                    .. attribute:: policy_map_targets
                    
                    	Policy\-map table
                    	**type**\:  :py:class:`PolicyMapTargets <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.TargetPolicyMapTypes.TargetPolicyMapType.PolicyMapTargets>`
                    
                    .. attribute:: policy_map_target_summary
                    
                    	Policy\-map table
                    	**type**\:  :py:class:`PolicyMapTargetSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.TargetPolicyMapTypes.TargetPolicyMapType.PolicyMapTargetSummary>`
                    
                    .. attribute:: target_summary_per_policy_maps
                    
                    	Policy\-map table per Policy\-map
                    	**type**\:  :py:class:`TargetSummaryPerPolicyMaps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.TargetPolicyMapTypes.TargetPolicyMapType.TargetSummaryPerPolicyMaps>`
                    
                    

                    """

                    _prefix = 'infra-policymgr-oper'
                    _revision = '2018-01-17'

                    def __init__(self):
                        super(PolicyManager.Nodes.Node.TargetPolicyMapTypes.TargetPolicyMapType, self).__init__()

                        self.yang_name = "target-policy-map-type"
                        self.yang_parent_name = "target-policy-map-types"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = ['type']
                        self._child_classes = OrderedDict([("policy-map-targets", ("policy_map_targets", PolicyManager.Nodes.Node.TargetPolicyMapTypes.TargetPolicyMapType.PolicyMapTargets)), ("policy-map-target-summary", ("policy_map_target_summary", PolicyManager.Nodes.Node.TargetPolicyMapTypes.TargetPolicyMapType.PolicyMapTargetSummary)), ("target-summary-per-policy-maps", ("target_summary_per_policy_maps", PolicyManager.Nodes.Node.TargetPolicyMapTypes.TargetPolicyMapType.TargetSummaryPerPolicyMaps))])
                        self._leafs = OrderedDict([
                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicymgrPolicyMap', '')])),
                        ])
                        self.type = None

                        self.policy_map_targets = PolicyManager.Nodes.Node.TargetPolicyMapTypes.TargetPolicyMapType.PolicyMapTargets()
                        self.policy_map_targets.parent = self
                        self._children_name_map["policy_map_targets"] = "policy-map-targets"

                        self.policy_map_target_summary = PolicyManager.Nodes.Node.TargetPolicyMapTypes.TargetPolicyMapType.PolicyMapTargetSummary()
                        self.policy_map_target_summary.parent = self
                        self._children_name_map["policy_map_target_summary"] = "policy-map-target-summary"

                        self.target_summary_per_policy_maps = PolicyManager.Nodes.Node.TargetPolicyMapTypes.TargetPolicyMapType.TargetSummaryPerPolicyMaps()
                        self.target_summary_per_policy_maps.parent = self
                        self._children_name_map["target_summary_per_policy_maps"] = "target-summary-per-policy-maps"
                        self._segment_path = lambda: "target-policy-map-type" + "[type='" + str(self.type) + "']"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(PolicyManager.Nodes.Node.TargetPolicyMapTypes.TargetPolicyMapType, ['type'], name, value)


                    class PolicyMapTargets(Entity):
                        """
                        Policy\-map table
                        
                        .. attribute:: policy_map_target
                        
                        	Policy\-map targets
                        	**type**\: list of  		 :py:class:`PolicyMapTarget <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.TargetPolicyMapTypes.TargetPolicyMapType.PolicyMapTargets.PolicyMapTarget>`
                        
                        

                        """

                        _prefix = 'infra-policymgr-oper'
                        _revision = '2018-01-17'

                        def __init__(self):
                            super(PolicyManager.Nodes.Node.TargetPolicyMapTypes.TargetPolicyMapType.PolicyMapTargets, self).__init__()

                            self.yang_name = "policy-map-targets"
                            self.yang_parent_name = "target-policy-map-type"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("policy-map-target", ("policy_map_target", PolicyManager.Nodes.Node.TargetPolicyMapTypes.TargetPolicyMapType.PolicyMapTargets.PolicyMapTarget))])
                            self._leafs = OrderedDict()

                            self.policy_map_target = YList(self)
                            self._segment_path = lambda: "policy-map-targets"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(PolicyManager.Nodes.Node.TargetPolicyMapTypes.TargetPolicyMapType.PolicyMapTargets, [], name, value)


                        class PolicyMapTarget(Entity):
                            """
                            Policy\-map targets
                            
                            .. attribute:: policy_map_name  (key)
                            
                            	Name of policy\-map
                            	**type**\: str
                            
                            	**length:** 1..63
                            
                            .. attribute:: targets
                            
                            	targets
                            	**type**\: list of str
                            
                            .. attribute:: parent_targets
                            
                            	parent targets
                            	**type**\: list of str
                            
                            

                            """

                            _prefix = 'infra-policymgr-oper'
                            _revision = '2018-01-17'

                            def __init__(self):
                                super(PolicyManager.Nodes.Node.TargetPolicyMapTypes.TargetPolicyMapType.PolicyMapTargets.PolicyMapTarget, self).__init__()

                                self.yang_name = "policy-map-target"
                                self.yang_parent_name = "policy-map-targets"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = ['policy_map_name']
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('policy_map_name', (YLeaf(YType.str, 'policy-map-name'), ['str'])),
                                    ('targets', (YLeafList(YType.str, 'targets'), ['str'])),
                                    ('parent_targets', (YLeafList(YType.str, 'parent-targets'), ['str'])),
                                ])
                                self.policy_map_name = None
                                self.targets = []
                                self.parent_targets = []
                                self._segment_path = lambda: "policy-map-target" + "[policy-map-name='" + str(self.policy_map_name) + "']"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(PolicyManager.Nodes.Node.TargetPolicyMapTypes.TargetPolicyMapType.PolicyMapTargets.PolicyMapTarget, ['policy_map_name', 'targets', 'parent_targets'], name, value)


                    class PolicyMapTargetSummary(Entity):
                        """
                        Policy\-map table
                        
                        .. attribute:: total_policy_maps_input_direction
                        
                        	Total policymapsin the input direction
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: total_policy_maps_output_direction
                        
                        	Total policymapsin the output direction
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: total_child_policy_maps_input_direction
                        
                        	Totalpolicymaps applied as child policy in the input direction
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: total_child_policy_maps_output_direction
                        
                        	Totalpolicymaps applied as child policy in the output direction
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: total_interfaces_input_direction
                        
                        	Totalinterfaces with service\-policy in the input direction
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: total_interfaces_output_direction
                        
                        	Totalinterfaces with service\-policy in the output direction
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'infra-policymgr-oper'
                        _revision = '2018-01-17'

                        def __init__(self):
                            super(PolicyManager.Nodes.Node.TargetPolicyMapTypes.TargetPolicyMapType.PolicyMapTargetSummary, self).__init__()

                            self.yang_name = "policy-map-target-summary"
                            self.yang_parent_name = "target-policy-map-type"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('total_policy_maps_input_direction', (YLeaf(YType.uint32, 'total-policy-maps-input-direction'), ['int'])),
                                ('total_policy_maps_output_direction', (YLeaf(YType.uint32, 'total-policy-maps-output-direction'), ['int'])),
                                ('total_child_policy_maps_input_direction', (YLeaf(YType.uint32, 'total-child-policy-maps-input-direction'), ['int'])),
                                ('total_child_policy_maps_output_direction', (YLeaf(YType.uint32, 'total-child-policy-maps-output-direction'), ['int'])),
                                ('total_interfaces_input_direction', (YLeaf(YType.uint32, 'total-interfaces-input-direction'), ['int'])),
                                ('total_interfaces_output_direction', (YLeaf(YType.uint32, 'total-interfaces-output-direction'), ['int'])),
                            ])
                            self.total_policy_maps_input_direction = None
                            self.total_policy_maps_output_direction = None
                            self.total_child_policy_maps_input_direction = None
                            self.total_child_policy_maps_output_direction = None
                            self.total_interfaces_input_direction = None
                            self.total_interfaces_output_direction = None
                            self._segment_path = lambda: "policy-map-target-summary"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(PolicyManager.Nodes.Node.TargetPolicyMapTypes.TargetPolicyMapType.PolicyMapTargetSummary, ['total_policy_maps_input_direction', 'total_policy_maps_output_direction', 'total_child_policy_maps_input_direction', 'total_child_policy_maps_output_direction', 'total_interfaces_input_direction', 'total_interfaces_output_direction'], name, value)


                    class TargetSummaryPerPolicyMaps(Entity):
                        """
                        Policy\-map table per Policy\-map
                        
                        .. attribute:: target_summary_per_policy_map
                        
                        	Policy\-map targets summary
                        	**type**\: list of  		 :py:class:`TargetSummaryPerPolicyMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.TargetPolicyMapTypes.TargetPolicyMapType.TargetSummaryPerPolicyMaps.TargetSummaryPerPolicyMap>`
                        
                        

                        """

                        _prefix = 'infra-policymgr-oper'
                        _revision = '2018-01-17'

                        def __init__(self):
                            super(PolicyManager.Nodes.Node.TargetPolicyMapTypes.TargetPolicyMapType.TargetSummaryPerPolicyMaps, self).__init__()

                            self.yang_name = "target-summary-per-policy-maps"
                            self.yang_parent_name = "target-policy-map-type"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("target-summary-per-policy-map", ("target_summary_per_policy_map", PolicyManager.Nodes.Node.TargetPolicyMapTypes.TargetPolicyMapType.TargetSummaryPerPolicyMaps.TargetSummaryPerPolicyMap))])
                            self._leafs = OrderedDict()

                            self.target_summary_per_policy_map = YList(self)
                            self._segment_path = lambda: "target-summary-per-policy-maps"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(PolicyManager.Nodes.Node.TargetPolicyMapTypes.TargetPolicyMapType.TargetSummaryPerPolicyMaps, [], name, value)


                        class TargetSummaryPerPolicyMap(Entity):
                            """
                            Policy\-map targets summary
                            
                            .. attribute:: policy_map_name  (key)
                            
                            	Name of policy\-map
                            	**type**\: str
                            
                            	**length:** 1..63
                            
                            .. attribute:: total_policy_maps_input_direction
                            
                            	Total policymapsin the input direction
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: total_policy_maps_output_direction
                            
                            	Total policymapsin the output direction
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: total_child_policy_maps_input_direction
                            
                            	Totalpolicymaps applied as child policy in the input direction
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: total_child_policy_maps_output_direction
                            
                            	Totalpolicymaps applied as child policy in the output direction
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: total_interfaces_input_direction
                            
                            	Totalinterfaces with service\-policy in the input direction
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: total_interfaces_output_direction
                            
                            	Totalinterfaces with service\-policy in the output direction
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'infra-policymgr-oper'
                            _revision = '2018-01-17'

                            def __init__(self):
                                super(PolicyManager.Nodes.Node.TargetPolicyMapTypes.TargetPolicyMapType.TargetSummaryPerPolicyMaps.TargetSummaryPerPolicyMap, self).__init__()

                                self.yang_name = "target-summary-per-policy-map"
                                self.yang_parent_name = "target-summary-per-policy-maps"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = ['policy_map_name']
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('policy_map_name', (YLeaf(YType.str, 'policy-map-name'), ['str'])),
                                    ('total_policy_maps_input_direction', (YLeaf(YType.uint32, 'total-policy-maps-input-direction'), ['int'])),
                                    ('total_policy_maps_output_direction', (YLeaf(YType.uint32, 'total-policy-maps-output-direction'), ['int'])),
                                    ('total_child_policy_maps_input_direction', (YLeaf(YType.uint32, 'total-child-policy-maps-input-direction'), ['int'])),
                                    ('total_child_policy_maps_output_direction', (YLeaf(YType.uint32, 'total-child-policy-maps-output-direction'), ['int'])),
                                    ('total_interfaces_input_direction', (YLeaf(YType.uint32, 'total-interfaces-input-direction'), ['int'])),
                                    ('total_interfaces_output_direction', (YLeaf(YType.uint32, 'total-interfaces-output-direction'), ['int'])),
                                ])
                                self.policy_map_name = None
                                self.total_policy_maps_input_direction = None
                                self.total_policy_maps_output_direction = None
                                self.total_child_policy_maps_input_direction = None
                                self.total_child_policy_maps_output_direction = None
                                self.total_interfaces_input_direction = None
                                self.total_interfaces_output_direction = None
                                self._segment_path = lambda: "target-summary-per-policy-map" + "[policy-map-name='" + str(self.policy_map_name) + "']"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(PolicyManager.Nodes.Node.TargetPolicyMapTypes.TargetPolicyMapType.TargetSummaryPerPolicyMaps.TargetSummaryPerPolicyMap, ['policy_map_name', 'total_policy_maps_input_direction', 'total_policy_maps_output_direction', 'total_child_policy_maps_input_direction', 'total_child_policy_maps_output_direction', 'total_interfaces_input_direction', 'total_interfaces_output_direction'], name, value)


            class ClassMap(Entity):
                """
                List of classmap details
                
                .. attribute:: class_map_types
                
                	Application type of a classmap
                	**type**\:  :py:class:`ClassMapTypes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes>`
                
                

                """

                _prefix = 'infra-policymgr-oper'
                _revision = '2018-01-17'

                def __init__(self):
                    super(PolicyManager.Nodes.Node.ClassMap, self).__init__()

                    self.yang_name = "class-map"
                    self.yang_parent_name = "node"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("class-map-types", ("class_map_types", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes))])
                    self._leafs = OrderedDict()

                    self.class_map_types = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes()
                    self.class_map_types.parent = self
                    self._children_name_map["class_map_types"] = "class-map-types"
                    self._segment_path = lambda: "class-map"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(PolicyManager.Nodes.Node.ClassMap, [], name, value)


                class ClassMapTypes(Entity):
                    """
                    Application type of a classmap
                    
                    .. attribute:: class_map_type
                    
                    	Policymgr application type
                    	**type**\: list of  		 :py:class:`ClassMapType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType>`
                    
                    

                    """

                    _prefix = 'infra-policymgr-oper'
                    _revision = '2018-01-17'

                    def __init__(self):
                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes, self).__init__()

                        self.yang_name = "class-map-types"
                        self.yang_parent_name = "class-map"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("class-map-type", ("class_map_type", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType))])
                        self._leafs = OrderedDict()

                        self.class_map_type = YList(self)
                        self._segment_path = lambda: "class-map-types"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes, [], name, value)


                    class ClassMapType(Entity):
                        """
                        Policymgr application type
                        
                        .. attribute:: type  (key)
                        
                        	The application type
                        	**type**\:  :py:class:`PolicymgrClassMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicymgrClassMap>`
                        
                        .. attribute:: class_map_details
                        
                        	Class\-map detail table
                        	**type**\:  :py:class:`ClassMapDetails <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails>`
                        
                        .. attribute:: class_maps
                        
                        	Class\-map definition table
                        	**type**\:  :py:class:`ClassMaps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps>`
                        
                        .. attribute:: class_map_briefs
                        
                        	Class\-map brief table
                        	**type**\:  :py:class:`ClassMapBriefs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs>`
                        
                        

                        """

                        _prefix = 'infra-policymgr-oper'
                        _revision = '2018-01-17'

                        def __init__(self):
                            super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType, self).__init__()

                            self.yang_name = "class-map-type"
                            self.yang_parent_name = "class-map-types"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = ['type']
                            self._child_classes = OrderedDict([("class-map-details", ("class_map_details", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails)), ("class-maps", ("class_maps", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps)), ("class-map-briefs", ("class_map_briefs", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs))])
                            self._leafs = OrderedDict([
                                ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicymgrClassMap', '')])),
                            ])
                            self.type = None

                            self.class_map_details = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails()
                            self.class_map_details.parent = self
                            self._children_name_map["class_map_details"] = "class-map-details"

                            self.class_maps = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps()
                            self.class_maps.parent = self
                            self._children_name_map["class_maps"] = "class-maps"

                            self.class_map_briefs = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs()
                            self.class_map_briefs.parent = self
                            self._children_name_map["class_map_briefs"] = "class-map-briefs"
                            self._segment_path = lambda: "class-map-type" + "[type='" + str(self.type) + "']"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType, ['type'], name, value)


                        class ClassMapDetails(Entity):
                            """
                            Class\-map detail table
                            
                            .. attribute:: class_map_detail
                            
                            	Class\-map detail information
                            	**type**\: list of  		 :py:class:`ClassMapDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail>`
                            
                            

                            """

                            _prefix = 'infra-policymgr-oper'
                            _revision = '2018-01-17'

                            def __init__(self):
                                super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails, self).__init__()

                                self.yang_name = "class-map-details"
                                self.yang_parent_name = "class-map-type"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("class-map-detail", ("class_map_detail", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail))])
                                self._leafs = OrderedDict()

                                self.class_map_detail = YList(self)
                                self._segment_path = lambda: "class-map-details"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails, [], name, value)


                            class ClassMapDetail(Entity):
                                """
                                Class\-map detail information
                                
                                .. attribute:: class_map_name  (key)
                                
                                	Name of class\-map
                                	**type**\: str
                                
                                	**length:** 1..63
                                
                                .. attribute:: object_type
                                
                                	Application type configured
                                	**type**\:  :py:class:`PlmgrApplnTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrApplnTypeEn>`
                                
                                .. attribute:: total_objects
                                
                                	Total number of objects configured for a specific object type
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: transient
                                
                                	Transient object
                                	**type**\: bool
                                
                                .. attribute:: reference
                                
                                	Each Policymap details
                                	**type**\: list of  		 :py:class:`Reference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail.Reference>`
                                
                                .. attribute:: objects
                                
                                	Each object details
                                	**type**\: list of  		 :py:class:`Objects <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail.Objects>`
                                
                                .. attribute:: class_map_reference
                                
                                	Each Classmapdetails
                                	**type**\: list of  		 :py:class:`ClassMapReference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail.ClassMapReference>`
                                
                                

                                """

                                _prefix = 'infra-policymgr-oper'
                                _revision = '2018-01-17'

                                def __init__(self):
                                    super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail, self).__init__()

                                    self.yang_name = "class-map-detail"
                                    self.yang_parent_name = "class-map-details"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = ['class_map_name']
                                    self._child_classes = OrderedDict([("reference", ("reference", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail.Reference)), ("objects", ("objects", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail.Objects)), ("class-map-reference", ("class_map_reference", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail.ClassMapReference))])
                                    self._leafs = OrderedDict([
                                        ('class_map_name', (YLeaf(YType.str, 'class-map-name'), ['str'])),
                                        ('object_type', (YLeaf(YType.enumeration, 'object-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PlmgrApplnTypeEn', '')])),
                                        ('total_objects', (YLeaf(YType.uint32, 'total-objects'), ['int'])),
                                        ('transient', (YLeaf(YType.boolean, 'transient'), ['bool'])),
                                    ])
                                    self.class_map_name = None
                                    self.object_type = None
                                    self.total_objects = None
                                    self.transient = None

                                    self.reference = YList(self)
                                    self.objects = YList(self)
                                    self.class_map_reference = YList(self)
                                    self._segment_path = lambda: "class-map-detail" + "[class-map-name='" + str(self.class_map_name) + "']"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail, ['class_map_name', 'object_type', 'total_objects', 'transient'], name, value)


                                class Reference(Entity):
                                    """
                                    Each Policymap details
                                    
                                    .. attribute:: total_internal_reference_objects
                                    
                                    	Total number of internal reference objects
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: total_class_maps
                                    
                                    	Total number of Classmaps in a Policymap
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: total_flows
                                    
                                    	Total flows in a Policymap
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2018-01-17'

                                    def __init__(self):
                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail.Reference, self).__init__()

                                        self.yang_name = "reference"
                                        self.yang_parent_name = "class-map-detail"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('total_internal_reference_objects', (YLeaf(YType.uint32, 'total-internal-reference-objects'), ['int'])),
                                            ('total_class_maps', (YLeaf(YType.uint32, 'total-class-maps'), ['int'])),
                                            ('total_flows', (YLeaf(YType.uint32, 'total-flows'), ['int'])),
                                        ])
                                        self.total_internal_reference_objects = None
                                        self.total_class_maps = None
                                        self.total_flows = None
                                        self._segment_path = lambda: "reference"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail.Reference, ['total_internal_reference_objects', 'total_class_maps', 'total_flows'], name, value)


                                class Objects(Entity):
                                    """
                                    Each object details
                                    
                                    .. attribute:: object_name
                                    
                                    	Name of object (Policymap/Classmap)
                                    	**type**\: str
                                    
                                    	**length:** 0..64
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2018-01-17'

                                    def __init__(self):
                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail.Objects, self).__init__()

                                        self.yang_name = "objects"
                                        self.yang_parent_name = "class-map-detail"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('object_name', (YLeaf(YType.str, 'object-name'), ['str'])),
                                        ])
                                        self.object_name = None
                                        self._segment_path = lambda: "objects"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail.Objects, ['object_name'], name, value)


                                class ClassMapReference(Entity):
                                    """
                                    Each Classmapdetails
                                    
                                    .. attribute:: total_reference_objects
                                    
                                    	Total number of Policymaps referencing a Classmap
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: policy_map_reference
                                    
                                    	List of Policymaps referencing a Classmap
                                    	**type**\: list of  		 :py:class:`PolicyMapReference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail.ClassMapReference.PolicyMapReference>`
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2018-01-17'

                                    def __init__(self):
                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail.ClassMapReference, self).__init__()

                                        self.yang_name = "class-map-reference"
                                        self.yang_parent_name = "class-map-detail"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("policy-map-reference", ("policy_map_reference", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail.ClassMapReference.PolicyMapReference))])
                                        self._leafs = OrderedDict([
                                            ('total_reference_objects', (YLeaf(YType.uint32, 'total-reference-objects'), ['int'])),
                                        ])
                                        self.total_reference_objects = None

                                        self.policy_map_reference = YList(self)
                                        self._segment_path = lambda: "class-map-reference"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail.ClassMapReference, ['total_reference_objects'], name, value)


                                    class PolicyMapReference(Entity):
                                        """
                                        List of Policymaps referencing a Classmap
                                        
                                        .. attribute:: object_type
                                        
                                        	Application type configured
                                        	**type**\:  :py:class:`PlmgrApplnTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrApplnTypeEn>`
                                        
                                        .. attribute:: policy_map_name
                                        
                                        	Name of Policymap referencing a Classmap
                                        	**type**\: str
                                        
                                        	**length:** 0..64
                                        
                                        

                                        """

                                        _prefix = 'infra-policymgr-oper'
                                        _revision = '2018-01-17'

                                        def __init__(self):
                                            super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail.ClassMapReference.PolicyMapReference, self).__init__()

                                            self.yang_name = "policy-map-reference"
                                            self.yang_parent_name = "class-map-reference"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('object_type', (YLeaf(YType.enumeration, 'object-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PlmgrApplnTypeEn', '')])),
                                                ('policy_map_name', (YLeaf(YType.str, 'policy-map-name'), ['str'])),
                                            ])
                                            self.object_type = None
                                            self.policy_map_name = None
                                            self._segment_path = lambda: "policy-map-reference"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail.ClassMapReference.PolicyMapReference, ['object_type', 'policy_map_name'], name, value)


                        class ClassMaps(Entity):
                            """
                            Class\-map definition table
                            
                            .. attribute:: class_map
                            
                            	Class\-map configuration
                            	**type**\: list of  		 :py:class:`ClassMap_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_>`
                            
                            

                            """

                            _prefix = 'infra-policymgr-oper'
                            _revision = '2018-01-17'

                            def __init__(self):
                                super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps, self).__init__()

                                self.yang_name = "class-maps"
                                self.yang_parent_name = "class-map-type"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("class-map", ("class_map", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_))])
                                self._leafs = OrderedDict()

                                self.class_map = YList(self)
                                self._segment_path = lambda: "class-maps"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps, [], name, value)


                            class ClassMap_(Entity):
                                """
                                Class\-map configuration
                                
                                .. attribute:: class_map_name  (key)
                                
                                	Name of class\-map
                                	**type**\: str
                                
                                	**length:** 1..63
                                
                                .. attribute:: class_map_bg
                                
                                	class map bg
                                	**type**\: list of  		 :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg>`
                                
                                

                                """

                                _prefix = 'infra-policymgr-oper'
                                _revision = '2018-01-17'

                                def __init__(self):
                                    super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_, self).__init__()

                                    self.yang_name = "class-map"
                                    self.yang_parent_name = "class-maps"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = ['class_map_name']
                                    self._child_classes = OrderedDict([("class-map-bg", ("class_map_bg", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg))])
                                    self._leafs = OrderedDict([
                                        ('class_map_name', (YLeaf(YType.str, 'class-map-name'), ['str'])),
                                    ])
                                    self.class_map_name = None

                                    self.class_map_bg = YList(self)
                                    self._segment_path = lambda: "class-map" + "[class-map-name='" + str(self.class_map_name) + "']"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_, ['class_map_name'], name, value)


                                class ClassMapBg(Entity):
                                    """
                                    class map bg
                                    
                                    .. attribute:: match_infop
                                    
                                    	Pointer to the first Match info
                                    	**type**\:  :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop>`
                                    
                                    .. attribute:: name
                                    
                                    	Name of the class\-map
                                    	**type**\: str
                                    
                                    	**length:** 0..65
                                    
                                    .. attribute:: type
                                    
                                    	Class\-Map Type QoS/PBR/Netflow/..
                                    	**type**\:  :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                    
                                    .. attribute:: mode
                                    
                                    	Class\-Map Mode Match any/Match all
                                    	**type**\:  :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                    
                                    .. attribute:: description
                                    
                                    	description
                                    	**type**\: str
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2018-01-17'

                                    def __init__(self):
                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg, self).__init__()

                                        self.yang_name = "class-map-bg"
                                        self.yang_parent_name = "class-map"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("match-infop", ("match_infop", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop))])
                                        self._leafs = OrderedDict([
                                            ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapTypeEn', '')])),
                                            ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapModeEn', '')])),
                                            ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                        ])
                                        self.name = None
                                        self.type = None
                                        self.mode = None
                                        self.description = None

                                        self.match_infop = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop()
                                        self.match_infop.parent = self
                                        self._children_name_map["match_infop"] = "match-infop"
                                        self._segment_path = lambda: "class-map-bg"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg, ['name', 'type', 'mode', 'description'], name, value)


                                    class MatchInfop(Entity):
                                        """
                                        Pointer to the first Match info
                                        
                                        .. attribute:: class_match_info_st
                                        
                                        	class match info st
                                        	**type**\: list of  		 :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                        
                                        

                                        """

                                        _prefix = 'infra-policymgr-oper'
                                        _revision = '2018-01-17'

                                        def __init__(self):
                                            super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop, self).__init__()

                                            self.yang_name = "match-infop"
                                            self.yang_parent_name = "class-map-bg"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("class-match-info-st", ("class_match_info_st", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt))])
                                            self._leafs = OrderedDict()

                                            self.class_match_info_st = YList(self)
                                            self._segment_path = lambda: "match-infop"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop, [], name, value)


                                        class ClassMatchInfoSt(Entity):
                                            """
                                            class match info st
                                            
                                            .. attribute:: match_data
                                            
                                            	Match criteria
                                            	**type**\:  :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                            
                                            .. attribute:: flags
                                            
                                            	Flags
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'infra-policymgr-oper'
                                            _revision = '2018-01-17'

                                            def __init__(self):
                                                super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                self.yang_name = "class-match-info-st"
                                                self.yang_parent_name = "match-infop"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("match-data", ("match_data", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData))])
                                                self._leafs = OrderedDict([
                                                    ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                ])
                                                self.flags = None

                                                self.match_data = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                                self.match_data.parent = self
                                                self._children_name_map["match_data"] = "match-data"
                                                self._segment_path = lambda: "class-match-info-st"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                            class MatchData(Entity):
                                                """
                                                Match criteria
                                                
                                                .. attribute:: ipv4_dscp
                                                
                                                	IPv4 DSCP
                                                	**type**\:  :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                
                                                .. attribute:: ipv6_dscp
                                                
                                                	IPv6 DSCP
                                                	**type**\:  :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                
                                                .. attribute:: dscp
                                                
                                                	Match DSCP range array
                                                	**type**\:  :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                
                                                .. attribute:: ipv4_prec
                                                
                                                	IPv4 Precedence
                                                	**type**\:  :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                
                                                .. attribute:: ipv6_prec
                                                
                                                	IPv6 Precedence
                                                	**type**\:  :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                
                                                .. attribute:: prec
                                                
                                                	Match Precedence array
                                                	**type**\:  :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                
                                                .. attribute:: discard_class
                                                
                                                	Match Discard Class array
                                                	**type**\:  :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                
                                                .. attribute:: qos_group
                                                
                                                	Match QoS group array
                                                	**type**\:  :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                
                                                .. attribute:: traffic_class
                                                
                                                	Match Traffic class array
                                                	**type**\:  :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                
                                                .. attribute:: proto
                                                
                                                	Match Protocol array
                                                	**type**\:  :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                
                                                .. attribute:: icmp_v4
                                                
                                                	Match ICMPV4 Protocol
                                                	**type**\:  :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                
                                                .. attribute:: icmp_v6
                                                
                                                	Match ICMPV6 Protocol array
                                                	**type**\:  :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                
                                                .. attribute:: ipv4_packet_len
                                                
                                                	IPv4 packet length array
                                                	**type**\:  :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                
                                                .. attribute:: ipv6_packet_len
                                                
                                                	IPv6 packet length array
                                                	**type**\:  :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                
                                                .. attribute:: packet_len
                                                
                                                	Match packet length array
                                                	**type**\:  :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                
                                                .. attribute:: flow_tag
                                                
                                                	Match flow\-tag array
                                                	**type**\:  :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                
                                                .. attribute:: tcp_flag
                                                
                                                	Match tcp flag value
                                                	**type**\:  :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                
                                                .. attribute:: icmpv4_type
                                                
                                                	Match ipv4 icmp type
                                                	**type**\:  :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                
                                                .. attribute:: icmpv4_code
                                                
                                                	Match ipv4 icmp code
                                                	**type**\:  :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                
                                                .. attribute:: icmpv6_type
                                                
                                                	Match ipv6 icmp type
                                                	**type**\:  :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                
                                                .. attribute:: icmpv6_code
                                                
                                                	Match ipv6 icmp code
                                                	**type**\:  :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                
                                                .. attribute:: mpls_exp
                                                
                                                	Match MPLS experimental topmost array
                                                	**type**\:  :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                
                                                .. attribute:: mpls_exp_imp
                                                
                                                	Match MPLS experimental imposition array
                                                	**type**\:  :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                
                                                .. attribute:: mpls_disp_ipv4_acl
                                                
                                                	MPLS Disposition IPv4 Access\-list
                                                	**type**\:  :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                
                                                .. attribute:: mpls_disp_ipv6_acl
                                                
                                                	MPLS Disposition IPv6 Access\-list
                                                	**type**\:  :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                
                                                .. attribute:: mpls_top_label
                                                
                                                	MPLS Topmost LABEL
                                                	**type**\:  :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                
                                                .. attribute:: cos
                                                
                                                	Match CoS array
                                                	**type**\:  :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                
                                                .. attribute:: cos_inr
                                                
                                                	Match inner header CoS
                                                	**type**\:  :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                
                                                .. attribute:: dei
                                                
                                                	Match DEI Bit
                                                	**type**\:  :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                
                                                .. attribute:: dei_inr
                                                
                                                	Match inner DEI Bit
                                                	**type**\:  :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                
                                                .. attribute:: vlan
                                                
                                                	Match VLAN array
                                                	**type**\:  :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                
                                                .. attribute:: vlan_inr
                                                
                                                	Match inner header VLAN range array
                                                	**type**\:  :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                
                                                .. attribute:: fr_dlci
                                                
                                                	Match FR DLCI range array
                                                	**type**\:  :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                
                                                .. attribute:: src_mac
                                                
                                                	Match Source MAC address
                                                	**type**\:  :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                
                                                .. attribute:: dst_mac
                                                
                                                	Match Destination MAC address
                                                	**type**\:  :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                
                                                .. attribute:: atm_clp
                                                
                                                	Match ATM CLP level
                                                	**type**\:  :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                
                                                .. attribute:: fr_de
                                                
                                                	Match FR DE value
                                                	**type**\:  :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                
                                                .. attribute:: ipv4_acl
                                                
                                                	IPv4 Access\-list
                                                	**type**\:  :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                
                                                .. attribute:: ipv6_acl
                                                
                                                	IPv6 Access\-list
                                                	**type**\:  :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                
                                                .. attribute:: ether_service_acl
                                                
                                                	Ethernet\-Services Access\-list
                                                	**type**\:  :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                
                                                .. attribute:: avail_id
                                                
                                                	Available Identifiers
                                                	**type**\:  :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                
                                                .. attribute:: media_type
                                                
                                                	Media Type
                                                	**type**\:  :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                
                                                .. attribute:: subs_protocol
                                                
                                                	Protocol
                                                	**type**\:  :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                
                                                .. attribute:: dnis
                                                
                                                	DNIS
                                                	**type**\:  :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                
                                                .. attribute:: dnis_regex
                                                
                                                	DNIS Regular Expression
                                                	**type**\:  :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                
                                                .. attribute:: domain
                                                
                                                	Domain Name
                                                	**type**\:  :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                
                                                .. attribute:: domain_regex
                                                
                                                	Domain Regular Expression
                                                	**type**\:  :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                
                                                .. attribute:: nas_port
                                                
                                                	NAS Port
                                                	**type**\:  :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                
                                                .. attribute:: service_name
                                                
                                                	Service Name
                                                	**type**\:  :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                
                                                .. attribute:: service_name_regex
                                                
                                                	Service Name Regular Exp
                                                	**type**\:  :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                
                                                .. attribute:: src_addr_ipv4
                                                
                                                	Source Address IPV4
                                                	**type**\:  :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                
                                                .. attribute:: dst_addr_ipv4
                                                
                                                	Destination Address IPV4
                                                	**type**\:  :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                
                                                .. attribute:: src_addr_ipv6
                                                
                                                	Source Address IPV6
                                                	**type**\:  :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                
                                                .. attribute:: dst_addr_ipv6
                                                
                                                	Destination Address IPV6
                                                	**type**\:  :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                
                                                .. attribute:: src_addr_mac
                                                
                                                	Source Address MAC
                                                	**type**\:  :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                
                                                .. attribute:: timer
                                                
                                                	Timer
                                                	**type**\:  :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                
                                                .. attribute:: timer_regexp
                                                
                                                	Timer Regular Expression
                                                	**type**\:  :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                
                                                .. attribute:: tunnel_name
                                                
                                                	Tunnel Name
                                                	**type**\:  :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                
                                                .. attribute:: tunnel_name_regex
                                                
                                                	Tunnel Name Regular Expression
                                                	**type**\:  :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                
                                                .. attribute:: user_name
                                                
                                                	User Name
                                                	**type**\:  :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                
                                                .. attribute:: user_name_regex
                                                
                                                	User Name Regular Expression
                                                	**type**\:  :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                
                                                .. attribute:: auth_username
                                                
                                                	Authenticated User Name
                                                	**type**\:  :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                
                                                .. attribute:: auth_username_regex
                                                
                                                	Authenticated User Name RegEx
                                                	**type**\:  :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                
                                                .. attribute:: unauth_username
                                                
                                                	Unauthenticated User Name
                                                	**type**\:  :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                
                                                .. attribute:: unauth_username_regex
                                                
                                                	Unauthenticated User Name RegEx
                                                	**type**\:  :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                
                                                .. attribute:: auth_domain
                                                
                                                	Authenticated domain name
                                                	**type**\:  :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                
                                                .. attribute:: auth_domain_regex
                                                
                                                	Authenticated Domain Name RegEx
                                                	**type**\:  :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                
                                                .. attribute:: unauth_domain
                                                
                                                	Unauthenticated Domain Name
                                                	**type**\:  :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                
                                                .. attribute:: unauth_domain_regex
                                                
                                                	Unauthenticated Domain Name RegEx
                                                	**type**\:  :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                
                                                .. attribute:: vendor_id
                                                
                                                	Vendor ID
                                                	**type**\:  :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                
                                                .. attribute:: vendor_id_regex
                                                
                                                	Vendor ID RegEx
                                                	**type**\:  :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                
                                                .. attribute:: access_interface
                                                
                                                	Access interface
                                                	**type**\:  :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                
                                                .. attribute:: input_interface
                                                
                                                	Input interface
                                                	**type**\:  :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                
                                                .. attribute:: input_intfhdl
                                                
                                                	Input interface handle
                                                	**type**\:  :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                
                                                .. attribute:: ethertype
                                                
                                                	Ethernet type
                                                	**type**\:  :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                
                                                .. attribute:: flow_key_data
                                                
                                                	Flow key structure
                                                	**type**\:  :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                
                                                .. attribute:: dhcp_client_id
                                                
                                                	Dhcp Client ID
                                                	**type**\:  :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                
                                                .. attribute:: dhcp_client_id_regex
                                                
                                                	Dhcp Client ID RegEx
                                                	**type**\:  :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                
                                                .. attribute:: circuit_id
                                                
                                                	Circuit ID
                                                	**type**\:  :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                
                                                .. attribute:: circuit_id_regex
                                                
                                                	Circuit ID RegEx
                                                	**type**\:  :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                
                                                .. attribute:: remote_id
                                                
                                                	Remote ID
                                                	**type**\:  :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                
                                                .. attribute:: remote_id_regex
                                                
                                                	Remote ID RegEx
                                                	**type**\:  :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                
                                                .. attribute:: src_port
                                                
                                                	Source port
                                                	**type**\:  :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                
                                                .. attribute:: dst_port
                                                
                                                	Destination port
                                                	**type**\:  :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                
                                                .. attribute:: type
                                                
                                                	type
                                                	**type**\:  :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                
                                                .. attribute:: mpls_top_eos
                                                
                                                	MPLS Topmost EOS
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: fragment_type
                                                
                                                	Fragment type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: authen_status
                                                
                                                	Authentication Status
                                                	**type**\:  :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                
                                                .. attribute:: mlp_negotiated
                                                
                                                	MLP Negotiated
                                                	**type**\:  :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                    self.yang_name = "match-data"
                                                    self.yang_parent_name = "class-match-info-st"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("ipv4-dscp", ("ipv4_dscp", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp)), ("ipv6-dscp", ("ipv6_dscp", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp)), ("dscp", ("dscp", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp)), ("ipv4-prec", ("ipv4_prec", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec)), ("ipv6-prec", ("ipv6_prec", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec)), ("prec", ("prec", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec)), ("discard-class", ("discard_class", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass)), ("qos-group", ("qos_group", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup)), ("traffic-class", ("traffic_class", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass)), ("proto", ("proto", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto)), ("icmp-v4", ("icmp_v4", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4)), ("icmp-v6", ("icmp_v6", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6)), ("ipv4-packet-len", ("ipv4_packet_len", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen)), ("ipv6-packet-len", ("ipv6_packet_len", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen)), ("packet-len", ("packet_len", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen)), ("flow-tag", ("flow_tag", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag)), ("tcp-flag", ("tcp_flag", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag)), ("icmpv4-type", ("icmpv4_type", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type)), ("icmpv4-code", ("icmpv4_code", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code)), ("icmpv6-type", ("icmpv6_type", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type)), ("icmpv6-code", ("icmpv6_code", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code)), ("mpls-exp", ("mpls_exp", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp)), ("mpls-exp-imp", ("mpls_exp_imp", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp)), ("mpls-disp-ipv4-acl", ("mpls_disp_ipv4_acl", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl)), ("mpls-disp-ipv6-acl", ("mpls_disp_ipv6_acl", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl)), ("mpls-top-label", ("mpls_top_label", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel)), ("cos", ("cos", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos)), ("cos-inr", ("cos_inr", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr)), ("dei", ("dei", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei)), ("dei-inr", ("dei_inr", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr)), ("vlan", ("vlan", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan)), ("vlan-inr", ("vlan_inr", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)), ("fr-dlci", ("fr_dlci", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci)), ("src-mac", ("src_mac", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac)), ("dst-mac", ("dst_mac", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac)), ("atm-clp", ("atm_clp", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp)), ("fr-de", ("fr_de", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe)), ("ipv4-acl", ("ipv4_acl", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl)), ("ipv6-acl", ("ipv6_acl", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl)), ("ether-service-acl", ("ether_service_acl", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl)), ("avail-id", ("avail_id", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId)), ("media-type", ("media_type", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType)), ("subs-protocol", ("subs_protocol", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol)), ("dnis", ("dnis", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis)), ("dnis-regex", ("dnis_regex", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex)), ("domain", ("domain", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain)), ("domain-regex", ("domain_regex", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex)), ("nas-port", ("nas_port", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort)), ("service-name", ("service_name", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName)), ("service-name-regex", ("service_name_regex", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex)), ("src-addr-ipv4", ("src_addr_ipv4", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4)), ("dst-addr-ipv4", ("dst_addr_ipv4", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4)), ("src-addr-ipv6", ("src_addr_ipv6", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6)), ("dst-addr-ipv6", ("dst_addr_ipv6", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6)), ("src-addr-mac", ("src_addr_mac", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac)), ("timer", ("timer", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer)), ("timer-regexp", ("timer_regexp", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp)), ("tunnel-name", ("tunnel_name", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName)), ("tunnel-name-regex", ("tunnel_name_regex", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex)), ("user-name", ("user_name", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName)), ("user-name-regex", ("user_name_regex", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex)), ("auth-username", ("auth_username", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername)), ("auth-username-regex", ("auth_username_regex", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex)), ("unauth-username", ("unauth_username", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername)), ("unauth-username-regex", ("unauth_username_regex", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex)), ("auth-domain", ("auth_domain", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain)), ("auth-domain-regex", ("auth_domain_regex", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex)), ("unauth-domain", ("unauth_domain", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain)), ("unauth-domain-regex", ("unauth_domain_regex", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex)), ("vendor-id", ("vendor_id", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId)), ("vendor-id-regex", ("vendor_id_regex", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex)), ("access-interface", ("access_interface", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface)), ("input-interface", ("input_interface", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface)), ("input-intfhdl", ("input_intfhdl", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl)), ("ethertype", ("ethertype", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype)), ("flow-key-data", ("flow_key_data", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData)), ("dhcp-client-id", ("dhcp_client_id", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId)), ("dhcp-client-id-regex", ("dhcp_client_id_regex", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex)), ("circuit-id", ("circuit_id", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId)), ("circuit-id-regex", ("circuit_id_regex", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex)), ("remote-id", ("remote_id", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId)), ("remote-id-regex", ("remote_id_regex", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex)), ("src-port", ("src_port", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort)), ("dst-port", ("dst_port", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort))])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchTypeEn', '')])),
                                                        ('mpls_top_eos', (YLeaf(YType.uint8, 'mpls-top-eos'), ['int'])),
                                                        ('fragment_type', (YLeaf(YType.uint8, 'fragment-type'), ['int'])),
                                                        ('authen_status', (YLeaf(YType.enumeration, 'authen-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchAuthenStatusEn', '')])),
                                                        ('mlp_negotiated', (YLeaf(YType.enumeration, 'mlp-negotiated'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchMlpNegotiatedEn', '')])),
                                                    ])
                                                    self.type = None
                                                    self.mpls_top_eos = None
                                                    self.fragment_type = None
                                                    self.authen_status = None
                                                    self.mlp_negotiated = None

                                                    self.ipv4_dscp = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                    self.ipv4_dscp.parent = self
                                                    self._children_name_map["ipv4_dscp"] = "ipv4-dscp"

                                                    self.ipv6_dscp = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                    self.ipv6_dscp.parent = self
                                                    self._children_name_map["ipv6_dscp"] = "ipv6-dscp"

                                                    self.dscp = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                    self.dscp.parent = self
                                                    self._children_name_map["dscp"] = "dscp"

                                                    self.ipv4_prec = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                    self.ipv4_prec.parent = self
                                                    self._children_name_map["ipv4_prec"] = "ipv4-prec"

                                                    self.ipv6_prec = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                    self.ipv6_prec.parent = self
                                                    self._children_name_map["ipv6_prec"] = "ipv6-prec"

                                                    self.prec = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                    self.prec.parent = self
                                                    self._children_name_map["prec"] = "prec"

                                                    self.discard_class = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                    self.discard_class.parent = self
                                                    self._children_name_map["discard_class"] = "discard-class"

                                                    self.qos_group = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                    self.qos_group.parent = self
                                                    self._children_name_map["qos_group"] = "qos-group"

                                                    self.traffic_class = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                    self.traffic_class.parent = self
                                                    self._children_name_map["traffic_class"] = "traffic-class"

                                                    self.proto = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                    self.proto.parent = self
                                                    self._children_name_map["proto"] = "proto"

                                                    self.icmp_v4 = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                    self.icmp_v4.parent = self
                                                    self._children_name_map["icmp_v4"] = "icmp-v4"

                                                    self.icmp_v6 = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                    self.icmp_v6.parent = self
                                                    self._children_name_map["icmp_v6"] = "icmp-v6"

                                                    self.ipv4_packet_len = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                    self.ipv4_packet_len.parent = self
                                                    self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"

                                                    self.ipv6_packet_len = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                    self.ipv6_packet_len.parent = self
                                                    self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"

                                                    self.packet_len = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                    self.packet_len.parent = self
                                                    self._children_name_map["packet_len"] = "packet-len"

                                                    self.flow_tag = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                    self.flow_tag.parent = self
                                                    self._children_name_map["flow_tag"] = "flow-tag"

                                                    self.tcp_flag = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                    self.tcp_flag.parent = self
                                                    self._children_name_map["tcp_flag"] = "tcp-flag"

                                                    self.icmpv4_type = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                    self.icmpv4_type.parent = self
                                                    self._children_name_map["icmpv4_type"] = "icmpv4-type"

                                                    self.icmpv4_code = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                    self.icmpv4_code.parent = self
                                                    self._children_name_map["icmpv4_code"] = "icmpv4-code"

                                                    self.icmpv6_type = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                    self.icmpv6_type.parent = self
                                                    self._children_name_map["icmpv6_type"] = "icmpv6-type"

                                                    self.icmpv6_code = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                    self.icmpv6_code.parent = self
                                                    self._children_name_map["icmpv6_code"] = "icmpv6-code"

                                                    self.mpls_exp = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                    self.mpls_exp.parent = self
                                                    self._children_name_map["mpls_exp"] = "mpls-exp"

                                                    self.mpls_exp_imp = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                    self.mpls_exp_imp.parent = self
                                                    self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"

                                                    self.mpls_disp_ipv4_acl = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                    self.mpls_disp_ipv4_acl.parent = self
                                                    self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"

                                                    self.mpls_disp_ipv6_acl = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                    self.mpls_disp_ipv6_acl.parent = self
                                                    self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"

                                                    self.mpls_top_label = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                    self.mpls_top_label.parent = self
                                                    self._children_name_map["mpls_top_label"] = "mpls-top-label"

                                                    self.cos = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                    self.cos.parent = self
                                                    self._children_name_map["cos"] = "cos"

                                                    self.cos_inr = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                    self.cos_inr.parent = self
                                                    self._children_name_map["cos_inr"] = "cos-inr"

                                                    self.dei = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                    self.dei.parent = self
                                                    self._children_name_map["dei"] = "dei"

                                                    self.dei_inr = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                    self.dei_inr.parent = self
                                                    self._children_name_map["dei_inr"] = "dei-inr"

                                                    self.vlan = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                    self.vlan.parent = self
                                                    self._children_name_map["vlan"] = "vlan"

                                                    self.vlan_inr = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                    self.vlan_inr.parent = self
                                                    self._children_name_map["vlan_inr"] = "vlan-inr"

                                                    self.fr_dlci = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                    self.fr_dlci.parent = self
                                                    self._children_name_map["fr_dlci"] = "fr-dlci"

                                                    self.src_mac = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                    self.src_mac.parent = self
                                                    self._children_name_map["src_mac"] = "src-mac"

                                                    self.dst_mac = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                    self.dst_mac.parent = self
                                                    self._children_name_map["dst_mac"] = "dst-mac"

                                                    self.atm_clp = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                    self.atm_clp.parent = self
                                                    self._children_name_map["atm_clp"] = "atm-clp"

                                                    self.fr_de = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                    self.fr_de.parent = self
                                                    self._children_name_map["fr_de"] = "fr-de"

                                                    self.ipv4_acl = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                    self.ipv4_acl.parent = self
                                                    self._children_name_map["ipv4_acl"] = "ipv4-acl"

                                                    self.ipv6_acl = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                    self.ipv6_acl.parent = self
                                                    self._children_name_map["ipv6_acl"] = "ipv6-acl"

                                                    self.ether_service_acl = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                    self.ether_service_acl.parent = self
                                                    self._children_name_map["ether_service_acl"] = "ether-service-acl"

                                                    self.avail_id = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                    self.avail_id.parent = self
                                                    self._children_name_map["avail_id"] = "avail-id"

                                                    self.media_type = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                    self.media_type.parent = self
                                                    self._children_name_map["media_type"] = "media-type"

                                                    self.subs_protocol = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                    self.subs_protocol.parent = self
                                                    self._children_name_map["subs_protocol"] = "subs-protocol"

                                                    self.dnis = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                    self.dnis.parent = self
                                                    self._children_name_map["dnis"] = "dnis"

                                                    self.dnis_regex = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                    self.dnis_regex.parent = self
                                                    self._children_name_map["dnis_regex"] = "dnis-regex"

                                                    self.domain = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                    self.domain.parent = self
                                                    self._children_name_map["domain"] = "domain"

                                                    self.domain_regex = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                    self.domain_regex.parent = self
                                                    self._children_name_map["domain_regex"] = "domain-regex"

                                                    self.nas_port = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                    self.nas_port.parent = self
                                                    self._children_name_map["nas_port"] = "nas-port"

                                                    self.service_name = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                    self.service_name.parent = self
                                                    self._children_name_map["service_name"] = "service-name"

                                                    self.service_name_regex = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                    self.service_name_regex.parent = self
                                                    self._children_name_map["service_name_regex"] = "service-name-regex"

                                                    self.src_addr_ipv4 = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                    self.src_addr_ipv4.parent = self
                                                    self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"

                                                    self.dst_addr_ipv4 = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                    self.dst_addr_ipv4.parent = self
                                                    self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"

                                                    self.src_addr_ipv6 = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                    self.src_addr_ipv6.parent = self
                                                    self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"

                                                    self.dst_addr_ipv6 = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                    self.dst_addr_ipv6.parent = self
                                                    self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"

                                                    self.src_addr_mac = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                    self.src_addr_mac.parent = self
                                                    self._children_name_map["src_addr_mac"] = "src-addr-mac"

                                                    self.timer = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                    self.timer.parent = self
                                                    self._children_name_map["timer"] = "timer"

                                                    self.timer_regexp = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                    self.timer_regexp.parent = self
                                                    self._children_name_map["timer_regexp"] = "timer-regexp"

                                                    self.tunnel_name = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                    self.tunnel_name.parent = self
                                                    self._children_name_map["tunnel_name"] = "tunnel-name"

                                                    self.tunnel_name_regex = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                    self.tunnel_name_regex.parent = self
                                                    self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"

                                                    self.user_name = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                    self.user_name.parent = self
                                                    self._children_name_map["user_name"] = "user-name"

                                                    self.user_name_regex = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                    self.user_name_regex.parent = self
                                                    self._children_name_map["user_name_regex"] = "user-name-regex"

                                                    self.auth_username = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                    self.auth_username.parent = self
                                                    self._children_name_map["auth_username"] = "auth-username"

                                                    self.auth_username_regex = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                    self.auth_username_regex.parent = self
                                                    self._children_name_map["auth_username_regex"] = "auth-username-regex"

                                                    self.unauth_username = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                    self.unauth_username.parent = self
                                                    self._children_name_map["unauth_username"] = "unauth-username"

                                                    self.unauth_username_regex = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                    self.unauth_username_regex.parent = self
                                                    self._children_name_map["unauth_username_regex"] = "unauth-username-regex"

                                                    self.auth_domain = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                    self.auth_domain.parent = self
                                                    self._children_name_map["auth_domain"] = "auth-domain"

                                                    self.auth_domain_regex = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                    self.auth_domain_regex.parent = self
                                                    self._children_name_map["auth_domain_regex"] = "auth-domain-regex"

                                                    self.unauth_domain = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                    self.unauth_domain.parent = self
                                                    self._children_name_map["unauth_domain"] = "unauth-domain"

                                                    self.unauth_domain_regex = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                    self.unauth_domain_regex.parent = self
                                                    self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"

                                                    self.vendor_id = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                    self.vendor_id.parent = self
                                                    self._children_name_map["vendor_id"] = "vendor-id"

                                                    self.vendor_id_regex = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                    self.vendor_id_regex.parent = self
                                                    self._children_name_map["vendor_id_regex"] = "vendor-id-regex"

                                                    self.access_interface = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                    self.access_interface.parent = self
                                                    self._children_name_map["access_interface"] = "access-interface"

                                                    self.input_interface = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                    self.input_interface.parent = self
                                                    self._children_name_map["input_interface"] = "input-interface"

                                                    self.input_intfhdl = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                    self.input_intfhdl.parent = self
                                                    self._children_name_map["input_intfhdl"] = "input-intfhdl"

                                                    self.ethertype = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                    self.ethertype.parent = self
                                                    self._children_name_map["ethertype"] = "ethertype"

                                                    self.flow_key_data = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                    self.flow_key_data.parent = self
                                                    self._children_name_map["flow_key_data"] = "flow-key-data"

                                                    self.dhcp_client_id = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                    self.dhcp_client_id.parent = self
                                                    self._children_name_map["dhcp_client_id"] = "dhcp-client-id"

                                                    self.dhcp_client_id_regex = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                    self.dhcp_client_id_regex.parent = self
                                                    self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"

                                                    self.circuit_id = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                    self.circuit_id.parent = self
                                                    self._children_name_map["circuit_id"] = "circuit-id"

                                                    self.circuit_id_regex = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                    self.circuit_id_regex.parent = self
                                                    self._children_name_map["circuit_id_regex"] = "circuit-id-regex"

                                                    self.remote_id = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                    self.remote_id.parent = self
                                                    self._children_name_map["remote_id"] = "remote-id"

                                                    self.remote_id_regex = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                    self.remote_id_regex.parent = self
                                                    self._children_name_map["remote_id_regex"] = "remote-id-regex"

                                                    self.src_port = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                    self.src_port.parent = self
                                                    self._children_name_map["src_port"] = "src-port"

                                                    self.dst_port = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                    self.dst_port.parent = self
                                                    self._children_name_map["dst_port"] = "dst-port"
                                                    self._segment_path = lambda: "match-data"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['type', 'mpls_top_eos', 'fragment_type', 'authen_status', 'mlp_negotiated'], name, value)


                                                class Ipv4Dscp(Entity):
                                                    """
                                                    IPv4 DSCP
                                                    
                                                    .. attribute:: uint8_rng_array
                                                    
                                                    	uint8 rng array
                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                        self.yang_name = "ipv4-dscp"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray))])
                                                        self._leafs = OrderedDict()

                                                        self.uint8_rng_array = YList(self)
                                                        self._segment_path = lambda: "ipv4-dscp"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                    class Uint8RngArray(Entity):
                                                        """
                                                        uint8 rng array
                                                        
                                                        .. attribute:: min
                                                        
                                                        	Lower limit of the range
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        .. attribute:: max
                                                        
                                                        	Upper limit of the range
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2018-01-17'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                            self.yang_name = "uint8_rng_array"
                                                            self.yang_parent_name = "ipv4-dscp"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                            ])
                                                            self.min = None
                                                            self.max = None
                                                            self._segment_path = lambda: "uint8_rng_array"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                class Ipv6Dscp(Entity):
                                                    """
                                                    IPv6 DSCP
                                                    
                                                    .. attribute:: uint8_rng_array
                                                    
                                                    	uint8 rng array
                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                        self.yang_name = "ipv6-dscp"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray))])
                                                        self._leafs = OrderedDict()

                                                        self.uint8_rng_array = YList(self)
                                                        self._segment_path = lambda: "ipv6-dscp"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                    class Uint8RngArray(Entity):
                                                        """
                                                        uint8 rng array
                                                        
                                                        .. attribute:: min
                                                        
                                                        	Lower limit of the range
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        .. attribute:: max
                                                        
                                                        	Upper limit of the range
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2018-01-17'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                            self.yang_name = "uint8_rng_array"
                                                            self.yang_parent_name = "ipv6-dscp"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                            ])
                                                            self.min = None
                                                            self.max = None
                                                            self._segment_path = lambda: "uint8_rng_array"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                class Dscp(Entity):
                                                    """
                                                    Match DSCP range array
                                                    
                                                    .. attribute:: uint8_rng_array
                                                    
                                                    	uint8 rng array
                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                        self.yang_name = "dscp"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray))])
                                                        self._leafs = OrderedDict()

                                                        self.uint8_rng_array = YList(self)
                                                        self._segment_path = lambda: "dscp"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                    class Uint8RngArray(Entity):
                                                        """
                                                        uint8 rng array
                                                        
                                                        .. attribute:: min
                                                        
                                                        	Lower limit of the range
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        .. attribute:: max
                                                        
                                                        	Upper limit of the range
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2018-01-17'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                            self.yang_name = "uint8_rng_array"
                                                            self.yang_parent_name = "dscp"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                            ])
                                                            self.min = None
                                                            self.max = None
                                                            self._segment_path = lambda: "uint8_rng_array"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                class Ipv4Prec(Entity):
                                                    """
                                                    IPv4 Precedence
                                                    
                                                    .. attribute:: uint8_array
                                                    
                                                    	uint8 array
                                                    	**type**\: list of int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                        self.yang_name = "ipv4-prec"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                        ])
                                                        self.uint8_array = []
                                                        self._segment_path = lambda: "ipv4-prec"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                class Ipv6Prec(Entity):
                                                    """
                                                    IPv6 Precedence
                                                    
                                                    .. attribute:: uint8_array
                                                    
                                                    	uint8 array
                                                    	**type**\: list of int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                        self.yang_name = "ipv6-prec"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                        ])
                                                        self.uint8_array = []
                                                        self._segment_path = lambda: "ipv6-prec"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                class Prec(Entity):
                                                    """
                                                    Match Precedence array
                                                    
                                                    .. attribute:: uint8_array
                                                    
                                                    	uint8 array
                                                    	**type**\: list of int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                        self.yang_name = "prec"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                        ])
                                                        self.uint8_array = []
                                                        self._segment_path = lambda: "prec"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                class DiscardClass(Entity):
                                                    """
                                                    Match Discard Class array
                                                    
                                                    .. attribute:: uint8_array
                                                    
                                                    	uint8 array
                                                    	**type**\: list of int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                        self.yang_name = "discard-class"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                        ])
                                                        self.uint8_array = []
                                                        self._segment_path = lambda: "discard-class"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                class QosGroup(Entity):
                                                    """
                                                    Match QoS group array
                                                    
                                                    .. attribute:: uint16_rng_array
                                                    
                                                    	uint16 rng array
                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                        self.yang_name = "qos-group"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray))])
                                                        self._leafs = OrderedDict()

                                                        self.uint16_rng_array = YList(self)
                                                        self._segment_path = lambda: "qos-group"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                    class Uint16RngArray(Entity):
                                                        """
                                                        uint16 rng array
                                                        
                                                        .. attribute:: min
                                                        
                                                        	Lower limit of the range
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: max
                                                        
                                                        	Upper limit of the range
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2018-01-17'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                            self.yang_name = "uint16_rng_array"
                                                            self.yang_parent_name = "qos-group"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                            ])
                                                            self.min = None
                                                            self.max = None
                                                            self._segment_path = lambda: "uint16_rng_array"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['min', 'max'], name, value)


                                                class TrafficClass(Entity):
                                                    """
                                                    Match Traffic class array
                                                    
                                                    .. attribute:: uint8_rng_array
                                                    
                                                    	uint8 rng array
                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                        self.yang_name = "traffic-class"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray))])
                                                        self._leafs = OrderedDict()

                                                        self.uint8_rng_array = YList(self)
                                                        self._segment_path = lambda: "traffic-class"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                    class Uint8RngArray(Entity):
                                                        """
                                                        uint8 rng array
                                                        
                                                        .. attribute:: min
                                                        
                                                        	Lower limit of the range
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        .. attribute:: max
                                                        
                                                        	Upper limit of the range
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2018-01-17'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                            self.yang_name = "uint8_rng_array"
                                                            self.yang_parent_name = "traffic-class"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                            ])
                                                            self.min = None
                                                            self.max = None
                                                            self._segment_path = lambda: "uint8_rng_array"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['min', 'max'], name, value)


                                                class Proto(Entity):
                                                    """
                                                    Match Protocol array
                                                    
                                                    .. attribute:: uint16_rng_array
                                                    
                                                    	uint16 rng array
                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                        self.yang_name = "proto"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray))])
                                                        self._leafs = OrderedDict()

                                                        self.uint16_rng_array = YList(self)
                                                        self._segment_path = lambda: "proto"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                    class Uint16RngArray(Entity):
                                                        """
                                                        uint16 rng array
                                                        
                                                        .. attribute:: min
                                                        
                                                        	Lower limit of the range
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: max
                                                        
                                                        	Upper limit of the range
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2018-01-17'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                            self.yang_name = "uint16_rng_array"
                                                            self.yang_parent_name = "proto"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                            ])
                                                            self.min = None
                                                            self.max = None
                                                            self._segment_path = lambda: "uint16_rng_array"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['min', 'max'], name, value)


                                                class IcmpV4(Entity):
                                                    """
                                                    Match ICMPV4 Protocol
                                                    
                                                    .. attribute:: type
                                                    
                                                    	Protocol type
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: code
                                                    
                                                    	Protocol code
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                        self.yang_name = "icmp-v4"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                            ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                        ])
                                                        self.type = None
                                                        self.code = None
                                                        self._segment_path = lambda: "icmp-v4"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['type', 'code'], name, value)


                                                class IcmpV6(Entity):
                                                    """
                                                    Match ICMPV6 Protocol array
                                                    
                                                    .. attribute:: type
                                                    
                                                    	Protocol type
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: code
                                                    
                                                    	Protocol code
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                        self.yang_name = "icmp-v6"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                            ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                        ])
                                                        self.type = None
                                                        self.code = None
                                                        self._segment_path = lambda: "icmp-v6"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['type', 'code'], name, value)


                                                class Ipv4PacketLen(Entity):
                                                    """
                                                    IPv4 packet length array
                                                    
                                                    .. attribute:: uint16_rng_array
                                                    
                                                    	uint16 rng array
                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                        self.yang_name = "ipv4-packet-len"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray))])
                                                        self._leafs = OrderedDict()

                                                        self.uint16_rng_array = YList(self)
                                                        self._segment_path = lambda: "ipv4-packet-len"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                    class Uint16RngArray(Entity):
                                                        """
                                                        uint16 rng array
                                                        
                                                        .. attribute:: min
                                                        
                                                        	Lower limit of the range
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: max
                                                        
                                                        	Upper limit of the range
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2018-01-17'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                            self.yang_name = "uint16_rng_array"
                                                            self.yang_parent_name = "ipv4-packet-len"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                            ])
                                                            self.min = None
                                                            self.max = None
                                                            self._segment_path = lambda: "uint16_rng_array"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                class Ipv6PacketLen(Entity):
                                                    """
                                                    IPv6 packet length array
                                                    
                                                    .. attribute:: uint16_rng_array
                                                    
                                                    	uint16 rng array
                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                        self.yang_name = "ipv6-packet-len"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray))])
                                                        self._leafs = OrderedDict()

                                                        self.uint16_rng_array = YList(self)
                                                        self._segment_path = lambda: "ipv6-packet-len"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                    class Uint16RngArray(Entity):
                                                        """
                                                        uint16 rng array
                                                        
                                                        .. attribute:: min
                                                        
                                                        	Lower limit of the range
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: max
                                                        
                                                        	Upper limit of the range
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2018-01-17'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                            self.yang_name = "uint16_rng_array"
                                                            self.yang_parent_name = "ipv6-packet-len"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                            ])
                                                            self.min = None
                                                            self.max = None
                                                            self._segment_path = lambda: "uint16_rng_array"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                class PacketLen(Entity):
                                                    """
                                                    Match packet length array
                                                    
                                                    .. attribute:: uint16_rng_array
                                                    
                                                    	uint16 rng array
                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                        self.yang_name = "packet-len"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray))])
                                                        self._leafs = OrderedDict()

                                                        self.uint16_rng_array = YList(self)
                                                        self._segment_path = lambda: "packet-len"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                    class Uint16RngArray(Entity):
                                                        """
                                                        uint16 rng array
                                                        
                                                        .. attribute:: min
                                                        
                                                        	Lower limit of the range
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: max
                                                        
                                                        	Upper limit of the range
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2018-01-17'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                            self.yang_name = "uint16_rng_array"
                                                            self.yang_parent_name = "packet-len"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                            ])
                                                            self.min = None
                                                            self.max = None
                                                            self._segment_path = lambda: "uint16_rng_array"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                class FlowTag(Entity):
                                                    """
                                                    Match flow\-tag array
                                                    
                                                    .. attribute:: uint8_rng_array
                                                    
                                                    	uint8 rng array
                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                        self.yang_name = "flow-tag"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray))])
                                                        self._leafs = OrderedDict()

                                                        self.uint8_rng_array = YList(self)
                                                        self._segment_path = lambda: "flow-tag"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                    class Uint8RngArray(Entity):
                                                        """
                                                        uint8 rng array
                                                        
                                                        .. attribute:: min
                                                        
                                                        	Lower limit of the range
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        .. attribute:: max
                                                        
                                                        	Upper limit of the range
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2018-01-17'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                            self.yang_name = "uint8_rng_array"
                                                            self.yang_parent_name = "flow-tag"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                            ])
                                                            self.min = None
                                                            self.max = None
                                                            self._segment_path = lambda: "uint8_rng_array"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['min', 'max'], name, value)


                                                class TcpFlag(Entity):
                                                    """
                                                    Match tcp flag value
                                                    
                                                    .. attribute:: value
                                                    
                                                    	Value of TCP flag
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: match_any
                                                    
                                                    	Match any TCP flag bit
                                                    	**type**\: bool
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                        self.yang_name = "tcp-flag"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                            ('match_any', (YLeaf(YType.boolean, 'match-any'), ['bool'])),
                                                        ])
                                                        self.value = None
                                                        self.match_any = None
                                                        self._segment_path = lambda: "tcp-flag"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['value', 'match_any'], name, value)


                                                class Icmpv4Type(Entity):
                                                    """
                                                    Match ipv4 icmp type
                                                    
                                                    .. attribute:: uint8_rng_array
                                                    
                                                    	uint8 rng array
                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                        self.yang_name = "icmpv4-type"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray))])
                                                        self._leafs = OrderedDict()

                                                        self.uint8_rng_array = YList(self)
                                                        self._segment_path = lambda: "icmpv4-type"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                    class Uint8RngArray(Entity):
                                                        """
                                                        uint8 rng array
                                                        
                                                        .. attribute:: min
                                                        
                                                        	Lower limit of the range
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        .. attribute:: max
                                                        
                                                        	Upper limit of the range
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2018-01-17'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                            self.yang_name = "uint8_rng_array"
                                                            self.yang_parent_name = "icmpv4-type"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                            ])
                                                            self.min = None
                                                            self.max = None
                                                            self._segment_path = lambda: "uint8_rng_array"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['min', 'max'], name, value)


                                                class Icmpv4Code(Entity):
                                                    """
                                                    Match ipv4 icmp code
                                                    
                                                    .. attribute:: uint8_rng_array
                                                    
                                                    	uint8 rng array
                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                        self.yang_name = "icmpv4-code"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray))])
                                                        self._leafs = OrderedDict()

                                                        self.uint8_rng_array = YList(self)
                                                        self._segment_path = lambda: "icmpv4-code"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                    class Uint8RngArray(Entity):
                                                        """
                                                        uint8 rng array
                                                        
                                                        .. attribute:: min
                                                        
                                                        	Lower limit of the range
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        .. attribute:: max
                                                        
                                                        	Upper limit of the range
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2018-01-17'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                            self.yang_name = "uint8_rng_array"
                                                            self.yang_parent_name = "icmpv4-code"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                            ])
                                                            self.min = None
                                                            self.max = None
                                                            self._segment_path = lambda: "uint8_rng_array"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['min', 'max'], name, value)


                                                class Icmpv6Type(Entity):
                                                    """
                                                    Match ipv6 icmp type
                                                    
                                                    .. attribute:: uint8_rng_array
                                                    
                                                    	uint8 rng array
                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                        self.yang_name = "icmpv6-type"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray))])
                                                        self._leafs = OrderedDict()

                                                        self.uint8_rng_array = YList(self)
                                                        self._segment_path = lambda: "icmpv6-type"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                    class Uint8RngArray(Entity):
                                                        """
                                                        uint8 rng array
                                                        
                                                        .. attribute:: min
                                                        
                                                        	Lower limit of the range
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        .. attribute:: max
                                                        
                                                        	Upper limit of the range
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2018-01-17'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                            self.yang_name = "uint8_rng_array"
                                                            self.yang_parent_name = "icmpv6-type"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                            ])
                                                            self.min = None
                                                            self.max = None
                                                            self._segment_path = lambda: "uint8_rng_array"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['min', 'max'], name, value)


                                                class Icmpv6Code(Entity):
                                                    """
                                                    Match ipv6 icmp code
                                                    
                                                    .. attribute:: uint8_rng_array
                                                    
                                                    	uint8 rng array
                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                        self.yang_name = "icmpv6-code"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray))])
                                                        self._leafs = OrderedDict()

                                                        self.uint8_rng_array = YList(self)
                                                        self._segment_path = lambda: "icmpv6-code"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                    class Uint8RngArray(Entity):
                                                        """
                                                        uint8 rng array
                                                        
                                                        .. attribute:: min
                                                        
                                                        	Lower limit of the range
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        .. attribute:: max
                                                        
                                                        	Upper limit of the range
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2018-01-17'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                            self.yang_name = "uint8_rng_array"
                                                            self.yang_parent_name = "icmpv6-code"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                            ])
                                                            self.min = None
                                                            self.max = None
                                                            self._segment_path = lambda: "uint8_rng_array"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['min', 'max'], name, value)


                                                class MplsExp(Entity):
                                                    """
                                                    Match MPLS experimental topmost array
                                                    
                                                    .. attribute:: uint8_array
                                                    
                                                    	uint8 array
                                                    	**type**\: list of int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                        self.yang_name = "mpls-exp"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                        ])
                                                        self.uint8_array = []
                                                        self._segment_path = lambda: "mpls-exp"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                class MplsExpImp(Entity):
                                                    """
                                                    Match MPLS experimental imposition array
                                                    
                                                    .. attribute:: uint8_array
                                                    
                                                    	uint8 array
                                                    	**type**\: list of int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                        self.yang_name = "mpls-exp-imp"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                        ])
                                                        self.uint8_array = []
                                                        self._segment_path = lambda: "mpls-exp-imp"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                class MplsDispIpv4Acl(Entity):
                                                    """
                                                    MPLS Disposition IPv4 Access\-list
                                                    
                                                    .. attribute:: string_array
                                                    
                                                    	string array
                                                    	**type**\: list of str
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                        self.yang_name = "mpls-disp-ipv4-acl"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                        ])
                                                        self.string_array = []
                                                        self._segment_path = lambda: "mpls-disp-ipv4-acl"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                class MplsDispIpv6Acl(Entity):
                                                    """
                                                    MPLS Disposition IPv6 Access\-list
                                                    
                                                    .. attribute:: string_array
                                                    
                                                    	string array
                                                    	**type**\: list of str
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                        self.yang_name = "mpls-disp-ipv6-acl"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                        ])
                                                        self.string_array = []
                                                        self._segment_path = lambda: "mpls-disp-ipv6-acl"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                class MplsTopLabel(Entity):
                                                    """
                                                    MPLS Topmost LABEL
                                                    
                                                    .. attribute:: uint32_rng_array
                                                    
                                                    	uint32 rng array
                                                    	**type**\: list of  		 :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                        self.yang_name = "mpls-top-label"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("uint32_rng_array", ("uint32_rng_array", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray))])
                                                        self._leafs = OrderedDict()

                                                        self.uint32_rng_array = YList(self)
                                                        self._segment_path = lambda: "mpls-top-label"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                    class Uint32RngArray(Entity):
                                                        """
                                                        uint32 rng array
                                                        
                                                        .. attribute:: min
                                                        
                                                        	Lower limit of the range
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: max
                                                        
                                                        	Upper limit of the range
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2018-01-17'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                            self.yang_name = "uint32_rng_array"
                                                            self.yang_parent_name = "mpls-top-label"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('min', (YLeaf(YType.uint32, 'min'), ['int'])),
                                                                ('max', (YLeaf(YType.uint32, 'max'), ['int'])),
                                                            ])
                                                            self.min = None
                                                            self.max = None
                                                            self._segment_path = lambda: "uint32_rng_array"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['min', 'max'], name, value)


                                                class Cos(Entity):
                                                    """
                                                    Match CoS array
                                                    
                                                    .. attribute:: uint8_array
                                                    
                                                    	uint8 array
                                                    	**type**\: list of int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                        self.yang_name = "cos"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                        ])
                                                        self.uint8_array = []
                                                        self._segment_path = lambda: "cos"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                class CosInr(Entity):
                                                    """
                                                    Match inner header CoS
                                                    
                                                    .. attribute:: uint8_array
                                                    
                                                    	uint8 array
                                                    	**type**\: list of int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                        self.yang_name = "cos-inr"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                        ])
                                                        self.uint8_array = []
                                                        self._segment_path = lambda: "cos-inr"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                class Dei(Entity):
                                                    """
                                                    Match DEI Bit
                                                    
                                                    .. attribute:: bit_value
                                                    
                                                    	Value of the DEI bit
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                        self.yang_name = "dei"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                        ])
                                                        self.bit_value = None
                                                        self._segment_path = lambda: "dei"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                class DeiInr(Entity):
                                                    """
                                                    Match inner DEI Bit
                                                    
                                                    .. attribute:: bit_value
                                                    
                                                    	Value of the DEI bit
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                        self.yang_name = "dei-inr"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                        ])
                                                        self.bit_value = None
                                                        self._segment_path = lambda: "dei-inr"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                class Vlan(Entity):
                                                    """
                                                    Match VLAN array
                                                    
                                                    .. attribute:: vlan_id_array
                                                    
                                                    	vlan id array
                                                    	**type**\: list of  		 :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                        self.yang_name = "vlan"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("vlan-id-array", ("vlan_id_array", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray))])
                                                        self._leafs = OrderedDict()

                                                        self.vlan_id_array = YList(self)
                                                        self._segment_path = lambda: "vlan"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                    class VlanIdArray(Entity):
                                                        """
                                                        vlan id array
                                                        
                                                        .. attribute:: min
                                                        
                                                        	Lower limit of the range
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: max
                                                        
                                                        	Upper limit of the range
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: mask
                                                        
                                                        	VLAN mask
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2018-01-17'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                            self.yang_name = "vlan-id-array"
                                                            self.yang_parent_name = "vlan"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                ('mask', (YLeaf(YType.uint16, 'mask'), ['int'])),
                                                            ])
                                                            self.min = None
                                                            self.max = None
                                                            self.mask = None
                                                            self._segment_path = lambda: "vlan-id-array"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['min', 'max', 'mask'], name, value)


                                                class VlanInr(Entity):
                                                    """
                                                    Match inner header VLAN range array
                                                    
                                                    .. attribute:: uint16_rng_array
                                                    
                                                    	uint16 rng array
                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                        self.yang_name = "vlan-inr"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray))])
                                                        self._leafs = OrderedDict()

                                                        self.uint16_rng_array = YList(self)
                                                        self._segment_path = lambda: "vlan-inr"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                    class Uint16RngArray(Entity):
                                                        """
                                                        uint16 rng array
                                                        
                                                        .. attribute:: min
                                                        
                                                        	Lower limit of the range
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: max
                                                        
                                                        	Upper limit of the range
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2018-01-17'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                            self.yang_name = "uint16_rng_array"
                                                            self.yang_parent_name = "vlan-inr"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                            ])
                                                            self.min = None
                                                            self.max = None
                                                            self._segment_path = lambda: "uint16_rng_array"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['min', 'max'], name, value)


                                                class FrDlci(Entity):
                                                    """
                                                    Match FR DLCI range array
                                                    
                                                    .. attribute:: uint16_rng_array
                                                    
                                                    	uint16 rng array
                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                        self.yang_name = "fr-dlci"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray))])
                                                        self._leafs = OrderedDict()

                                                        self.uint16_rng_array = YList(self)
                                                        self._segment_path = lambda: "fr-dlci"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                    class Uint16RngArray(Entity):
                                                        """
                                                        uint16 rng array
                                                        
                                                        .. attribute:: min
                                                        
                                                        	Lower limit of the range
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: max
                                                        
                                                        	Upper limit of the range
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2018-01-17'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                            self.yang_name = "uint16_rng_array"
                                                            self.yang_parent_name = "fr-dlci"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                            ])
                                                            self.min = None
                                                            self.max = None
                                                            self._segment_path = lambda: "uint16_rng_array"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['min', 'max'], name, value)


                                                class SrcMac(Entity):
                                                    """
                                                    Match Source MAC address
                                                    
                                                    .. attribute:: mac_addr
                                                    
                                                    	MAC address
                                                    	**type**\: list of int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: mask
                                                    
                                                    	MAC mask
                                                    	**type**\: list of int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                        self.yang_name = "src-mac"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                            ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                        ])
                                                        self.mac_addr = []
                                                        self.mask = []
                                                        self._segment_path = lambda: "src-mac"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                class DstMac(Entity):
                                                    """
                                                    Match Destination MAC address
                                                    
                                                    .. attribute:: mac_addr
                                                    
                                                    	MAC address
                                                    	**type**\: list of int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: mask
                                                    
                                                    	MAC mask
                                                    	**type**\: list of int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                        self.yang_name = "dst-mac"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                            ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                        ])
                                                        self.mac_addr = []
                                                        self.mask = []
                                                        self._segment_path = lambda: "dst-mac"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                class AtmClp(Entity):
                                                    """
                                                    Match ATM CLP level
                                                    
                                                    .. attribute:: uint8_array
                                                    
                                                    	uint8 array
                                                    	**type**\: list of int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                        self.yang_name = "atm-clp"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                        ])
                                                        self.uint8_array = []
                                                        self._segment_path = lambda: "atm-clp"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                class FrDe(Entity):
                                                    """
                                                    Match FR DE value
                                                    
                                                    .. attribute:: uint8_array
                                                    
                                                    	uint8 array
                                                    	**type**\: list of int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                        self.yang_name = "fr-de"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                        ])
                                                        self.uint8_array = []
                                                        self._segment_path = lambda: "fr-de"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                class Ipv4Acl(Entity):
                                                    """
                                                    IPv4 Access\-list
                                                    
                                                    .. attribute:: string_array
                                                    
                                                    	string array
                                                    	**type**\: list of str
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                        self.yang_name = "ipv4-acl"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                        ])
                                                        self.string_array = []
                                                        self._segment_path = lambda: "ipv4-acl"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                class Ipv6Acl(Entity):
                                                    """
                                                    IPv6 Access\-list
                                                    
                                                    .. attribute:: string_array
                                                    
                                                    	string array
                                                    	**type**\: list of str
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                        self.yang_name = "ipv6-acl"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                        ])
                                                        self.string_array = []
                                                        self._segment_path = lambda: "ipv6-acl"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                class EtherServiceAcl(Entity):
                                                    """
                                                    Ethernet\-Services Access\-list
                                                    
                                                    .. attribute:: string_array
                                                    
                                                    	string array
                                                    	**type**\: list of str
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                        self.yang_name = "ether-service-acl"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                        ])
                                                        self.string_array = []
                                                        self._segment_path = lambda: "ether-service-acl"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                class AvailId(Entity):
                                                    """
                                                    Available Identifiers
                                                    
                                                    .. attribute:: uint8_array
                                                    
                                                    	uint8 array
                                                    	**type**\: list of int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                        self.yang_name = "avail-id"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                        ])
                                                        self.uint8_array = []
                                                        self._segment_path = lambda: "avail-id"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                class MediaType(Entity):
                                                    """
                                                    Media Type
                                                    
                                                    .. attribute:: uint8_array
                                                    
                                                    	uint8 array
                                                    	**type**\: list of int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                        self.yang_name = "media-type"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                        ])
                                                        self.uint8_array = []
                                                        self._segment_path = lambda: "media-type"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                class SubsProtocol(Entity):
                                                    """
                                                    Protocol
                                                    
                                                    .. attribute:: uint8_array
                                                    
                                                    	uint8 array
                                                    	**type**\: list of int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                        self.yang_name = "subs-protocol"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                        ])
                                                        self.uint8_array = []
                                                        self._segment_path = lambda: "subs-protocol"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                class Dnis(Entity):
                                                    """
                                                    DNIS
                                                    
                                                    .. attribute:: string_array
                                                    
                                                    	string array
                                                    	**type**\: list of str
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                        self.yang_name = "dnis"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                        ])
                                                        self.string_array = []
                                                        self._segment_path = lambda: "dnis"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                class DnisRegex(Entity):
                                                    """
                                                    DNIS Regular Expression
                                                    
                                                    .. attribute:: string_array
                                                    
                                                    	string array
                                                    	**type**\: list of str
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                        self.yang_name = "dnis-regex"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                        ])
                                                        self.string_array = []
                                                        self._segment_path = lambda: "dnis-regex"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                class Domain(Entity):
                                                    """
                                                    Domain Name
                                                    
                                                    .. attribute:: domain_array
                                                    
                                                    	domain array
                                                    	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                        self.yang_name = "domain"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray))])
                                                        self._leafs = OrderedDict()

                                                        self.domain_array = YList(self)
                                                        self._segment_path = lambda: "domain"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                    class DomainArray(Entity):
                                                        """
                                                        domain array
                                                        
                                                        .. attribute:: domain_name
                                                        
                                                        	domain name
                                                        	**type**\: str
                                                        
                                                        .. attribute:: format_name
                                                        
                                                        	format name
                                                        	**type**\: str
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2018-01-17'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                            self.yang_name = "domain-array"
                                                            self.yang_parent_name = "domain"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                            ])
                                                            self.domain_name = None
                                                            self.format_name = None
                                                            self._segment_path = lambda: "domain-array"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                class DomainRegex(Entity):
                                                    """
                                                    Domain Regular Expression
                                                    
                                                    .. attribute:: domain_array
                                                    
                                                    	domain array
                                                    	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                        self.yang_name = "domain-regex"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray))])
                                                        self._leafs = OrderedDict()

                                                        self.domain_array = YList(self)
                                                        self._segment_path = lambda: "domain-regex"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                    class DomainArray(Entity):
                                                        """
                                                        domain array
                                                        
                                                        .. attribute:: domain_name
                                                        
                                                        	domain name
                                                        	**type**\: str
                                                        
                                                        .. attribute:: format_name
                                                        
                                                        	format name
                                                        	**type**\: str
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2018-01-17'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                            self.yang_name = "domain-array"
                                                            self.yang_parent_name = "domain-regex"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                            ])
                                                            self.domain_name = None
                                                            self.format_name = None
                                                            self._segment_path = lambda: "domain-array"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                class NasPort(Entity):
                                                    """
                                                    NAS Port
                                                    
                                                    .. attribute:: nas_port_array
                                                    
                                                    	nas port array
                                                    	**type**\: list of  		 :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                        self.yang_name = "nas-port"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("nas-port-array", ("nas_port_array", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray))])
                                                        self._leafs = OrderedDict()

                                                        self.nas_port_array = YList(self)
                                                        self._segment_path = lambda: "nas-port"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                    class NasPortArray(Entity):
                                                        """
                                                        nas port array
                                                        
                                                        .. attribute:: sub_id
                                                        
                                                        	sub id
                                                        	**type**\:  :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                        
                                                        .. attribute:: operator
                                                        
                                                        	operator
                                                        	**type**\:  :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2018-01-17'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                            self.yang_name = "nas-port-array"
                                                            self.yang_parent_name = "nas-port"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('sub_id', (YLeaf(YType.enumeration, 'sub-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchNasPortSubIdEn', '')])),
                                                                ('operator', (YLeaf(YType.enumeration, 'operator'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchLogicalOperatorEn', '')])),
                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                            ])
                                                            self.sub_id = None
                                                            self.operator = None
                                                            self.value = None
                                                            self._segment_path = lambda: "nas-port-array"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['sub_id', 'operator', 'value'], name, value)


                                                class ServiceName(Entity):
                                                    """
                                                    Service Name
                                                    
                                                    .. attribute:: string_array
                                                    
                                                    	string array
                                                    	**type**\: list of str
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                        self.yang_name = "service-name"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                        ])
                                                        self.string_array = []
                                                        self._segment_path = lambda: "service-name"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                class ServiceNameRegex(Entity):
                                                    """
                                                    Service Name Regular Exp
                                                    
                                                    .. attribute:: string_array
                                                    
                                                    	string array
                                                    	**type**\: list of str
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                        self.yang_name = "service-name-regex"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                        ])
                                                        self.string_array = []
                                                        self._segment_path = lambda: "service-name-regex"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                class SrcAddrIpv4(Entity):
                                                    """
                                                    Source Address IPV4
                                                    
                                                    .. attribute:: ipv4_addr_array
                                                    
                                                    	ipv4 addr array
                                                    	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                        self.yang_name = "src-addr-ipv4"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray))])
                                                        self._leafs = OrderedDict()

                                                        self.ipv4_addr_array = YList(self)
                                                        self._segment_path = lambda: "src-addr-ipv4"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                    class Ipv4AddrArray(Entity):
                                                        """
                                                        ipv4 addr array
                                                        
                                                        .. attribute:: prefix
                                                        
                                                        	prefix
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: mask
                                                        
                                                        	mask
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2018-01-17'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                            self.yang_name = "ipv4-addr-array"
                                                            self.yang_parent_name = "src-addr-ipv4"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                            ])
                                                            self.prefix = None
                                                            self.mask = None
                                                            self._segment_path = lambda: "ipv4-addr-array"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                class DstAddrIpv4(Entity):
                                                    """
                                                    Destination Address IPV4
                                                    
                                                    .. attribute:: ipv4_addr_array
                                                    
                                                    	ipv4 addr array
                                                    	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                        self.yang_name = "dst-addr-ipv4"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray))])
                                                        self._leafs = OrderedDict()

                                                        self.ipv4_addr_array = YList(self)
                                                        self._segment_path = lambda: "dst-addr-ipv4"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                    class Ipv4AddrArray(Entity):
                                                        """
                                                        ipv4 addr array
                                                        
                                                        .. attribute:: prefix
                                                        
                                                        	prefix
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: mask
                                                        
                                                        	mask
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2018-01-17'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                            self.yang_name = "ipv4-addr-array"
                                                            self.yang_parent_name = "dst-addr-ipv4"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                            ])
                                                            self.prefix = None
                                                            self.mask = None
                                                            self._segment_path = lambda: "ipv4-addr-array"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                class SrcAddrIpv6(Entity):
                                                    """
                                                    Source Address IPV6
                                                    
                                                    .. attribute:: ipv6_addr_array
                                                    
                                                    	ipv6 addr array
                                                    	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                        self.yang_name = "src-addr-ipv6"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray))])
                                                        self._leafs = OrderedDict()

                                                        self.ipv6_addr_array = YList(self)
                                                        self._segment_path = lambda: "src-addr-ipv6"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                    class Ipv6AddrArray(Entity):
                                                        """
                                                        ipv6 addr array
                                                        
                                                        .. attribute:: prefix
                                                        
                                                        	IPV6 prefix
                                                        	**type**\: str
                                                        
                                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: mask
                                                        
                                                        	IPV6 mask
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2018-01-17'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                            self.yang_name = "ipv6-addr-array"
                                                            self.yang_parent_name = "src-addr-ipv6"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                            ])
                                                            self.prefix = None
                                                            self.mask = None
                                                            self._segment_path = lambda: "ipv6-addr-array"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                class DstAddrIpv6(Entity):
                                                    """
                                                    Destination Address IPV6
                                                    
                                                    .. attribute:: ipv6_addr_array
                                                    
                                                    	ipv6 addr array
                                                    	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                        self.yang_name = "dst-addr-ipv6"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray))])
                                                        self._leafs = OrderedDict()

                                                        self.ipv6_addr_array = YList(self)
                                                        self._segment_path = lambda: "dst-addr-ipv6"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                    class Ipv6AddrArray(Entity):
                                                        """
                                                        ipv6 addr array
                                                        
                                                        .. attribute:: prefix
                                                        
                                                        	IPV6 prefix
                                                        	**type**\: str
                                                        
                                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: mask
                                                        
                                                        	IPV6 mask
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2018-01-17'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                            self.yang_name = "ipv6-addr-array"
                                                            self.yang_parent_name = "dst-addr-ipv6"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                            ])
                                                            self.prefix = None
                                                            self.mask = None
                                                            self._segment_path = lambda: "ipv6-addr-array"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                class SrcAddrMac(Entity):
                                                    """
                                                    Source Address MAC
                                                    
                                                    .. attribute:: mac_addr_array
                                                    
                                                    	mac addr array
                                                    	**type**\: list of  		 :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                        self.yang_name = "src-addr-mac"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("mac-addr-array", ("mac_addr_array", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray))])
                                                        self._leafs = OrderedDict()

                                                        self.mac_addr_array = YList(self)
                                                        self._segment_path = lambda: "src-addr-mac"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                    class MacAddrArray(Entity):
                                                        """
                                                        mac addr array
                                                        
                                                        .. attribute:: mac_addr
                                                        
                                                        	MAC address
                                                        	**type**\: list of int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: mask
                                                        
                                                        	MAC mask
                                                        	**type**\: list of int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2018-01-17'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                            self.yang_name = "mac-addr-array"
                                                            self.yang_parent_name = "src-addr-mac"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                            ])
                                                            self.mac_addr = []
                                                            self.mask = []
                                                            self._segment_path = lambda: "mac-addr-array"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                class Timer(Entity):
                                                    """
                                                    Timer
                                                    
                                                    .. attribute:: string_array
                                                    
                                                    	string array
                                                    	**type**\: list of str
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                        self.yang_name = "timer"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                        ])
                                                        self.string_array = []
                                                        self._segment_path = lambda: "timer"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                class TimerRegexp(Entity):
                                                    """
                                                    Timer Regular Expression
                                                    
                                                    .. attribute:: string_array
                                                    
                                                    	string array
                                                    	**type**\: list of str
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                        self.yang_name = "timer-regexp"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                        ])
                                                        self.string_array = []
                                                        self._segment_path = lambda: "timer-regexp"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                class TunnelName(Entity):
                                                    """
                                                    Tunnel Name
                                                    
                                                    .. attribute:: string_array
                                                    
                                                    	string array
                                                    	**type**\: list of str
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                        self.yang_name = "tunnel-name"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                        ])
                                                        self.string_array = []
                                                        self._segment_path = lambda: "tunnel-name"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                class TunnelNameRegex(Entity):
                                                    """
                                                    Tunnel Name Regular Expression
                                                    
                                                    .. attribute:: string_array
                                                    
                                                    	string array
                                                    	**type**\: list of str
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                        self.yang_name = "tunnel-name-regex"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                        ])
                                                        self.string_array = []
                                                        self._segment_path = lambda: "tunnel-name-regex"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                class UserName(Entity):
                                                    """
                                                    User Name
                                                    
                                                    .. attribute:: string_array
                                                    
                                                    	string array
                                                    	**type**\: list of str
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                        self.yang_name = "user-name"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                        ])
                                                        self.string_array = []
                                                        self._segment_path = lambda: "user-name"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                class UserNameRegex(Entity):
                                                    """
                                                    User Name Regular Expression
                                                    
                                                    .. attribute:: string_array
                                                    
                                                    	string array
                                                    	**type**\: list of str
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                        self.yang_name = "user-name-regex"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                        ])
                                                        self.string_array = []
                                                        self._segment_path = lambda: "user-name-regex"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                class AuthUsername(Entity):
                                                    """
                                                    Authenticated User Name
                                                    
                                                    .. attribute:: string_array
                                                    
                                                    	string array
                                                    	**type**\: list of str
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                        self.yang_name = "auth-username"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                        ])
                                                        self.string_array = []
                                                        self._segment_path = lambda: "auth-username"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                class AuthUsernameRegex(Entity):
                                                    """
                                                    Authenticated User Name RegEx
                                                    
                                                    .. attribute:: string_array
                                                    
                                                    	string array
                                                    	**type**\: list of str
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                        self.yang_name = "auth-username-regex"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                        ])
                                                        self.string_array = []
                                                        self._segment_path = lambda: "auth-username-regex"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                class UnauthUsername(Entity):
                                                    """
                                                    Unauthenticated User Name
                                                    
                                                    .. attribute:: string_array
                                                    
                                                    	string array
                                                    	**type**\: list of str
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                        self.yang_name = "unauth-username"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                        ])
                                                        self.string_array = []
                                                        self._segment_path = lambda: "unauth-username"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                class UnauthUsernameRegex(Entity):
                                                    """
                                                    Unauthenticated User Name RegEx
                                                    
                                                    .. attribute:: string_array
                                                    
                                                    	string array
                                                    	**type**\: list of str
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                        self.yang_name = "unauth-username-regex"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                        ])
                                                        self.string_array = []
                                                        self._segment_path = lambda: "unauth-username-regex"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                class AuthDomain(Entity):
                                                    """
                                                    Authenticated domain name
                                                    
                                                    .. attribute:: string_array
                                                    
                                                    	string array
                                                    	**type**\: list of str
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                        self.yang_name = "auth-domain"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                        ])
                                                        self.string_array = []
                                                        self._segment_path = lambda: "auth-domain"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                class AuthDomainRegex(Entity):
                                                    """
                                                    Authenticated Domain Name RegEx
                                                    
                                                    .. attribute:: string_array
                                                    
                                                    	string array
                                                    	**type**\: list of str
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                        self.yang_name = "auth-domain-regex"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                        ])
                                                        self.string_array = []
                                                        self._segment_path = lambda: "auth-domain-regex"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                class UnauthDomain(Entity):
                                                    """
                                                    Unauthenticated Domain Name
                                                    
                                                    .. attribute:: string_array
                                                    
                                                    	string array
                                                    	**type**\: list of str
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                        self.yang_name = "unauth-domain"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                        ])
                                                        self.string_array = []
                                                        self._segment_path = lambda: "unauth-domain"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                class UnauthDomainRegex(Entity):
                                                    """
                                                    Unauthenticated Domain Name RegEx
                                                    
                                                    .. attribute:: string_array
                                                    
                                                    	string array
                                                    	**type**\: list of str
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                        self.yang_name = "unauth-domain-regex"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                        ])
                                                        self.string_array = []
                                                        self._segment_path = lambda: "unauth-domain-regex"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                class VendorId(Entity):
                                                    """
                                                    Vendor ID
                                                    
                                                    .. attribute:: string_array
                                                    
                                                    	string array
                                                    	**type**\: list of str
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                        self.yang_name = "vendor-id"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                        ])
                                                        self.string_array = []
                                                        self._segment_path = lambda: "vendor-id"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                class VendorIdRegex(Entity):
                                                    """
                                                    Vendor ID RegEx
                                                    
                                                    .. attribute:: string_array
                                                    
                                                    	string array
                                                    	**type**\: list of str
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                        self.yang_name = "vendor-id-regex"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                        ])
                                                        self.string_array = []
                                                        self._segment_path = lambda: "vendor-id-regex"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                class AccessInterface(Entity):
                                                    """
                                                    Access interface
                                                    
                                                    .. attribute:: string_array
                                                    
                                                    	string array
                                                    	**type**\: list of str
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                        self.yang_name = "access-interface"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                        ])
                                                        self.string_array = []
                                                        self._segment_path = lambda: "access-interface"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                class InputInterface(Entity):
                                                    """
                                                    Input interface
                                                    
                                                    .. attribute:: string_array
                                                    
                                                    	string array
                                                    	**type**\: list of str
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                        self.yang_name = "input-interface"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                        ])
                                                        self.string_array = []
                                                        self._segment_path = lambda: "input-interface"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                class InputIntfhdl(Entity):
                                                    """
                                                    Input interface handle
                                                    
                                                    .. attribute:: uint64_array
                                                    
                                                    	uint64 array
                                                    	**type**\: list of int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                        self.yang_name = "input-intfhdl"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('uint64_array', (YLeafList(YType.uint64, 'uint64_array'), ['int'])),
                                                        ])
                                                        self.uint64_array = []
                                                        self._segment_path = lambda: "input-intfhdl"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                class Ethertype(Entity):
                                                    """
                                                    Ethernet type
                                                    
                                                    .. attribute:: uint16_rng_array
                                                    
                                                    	uint16 rng array
                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                        self.yang_name = "ethertype"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray))])
                                                        self._leafs = OrderedDict()

                                                        self.uint16_rng_array = YList(self)
                                                        self._segment_path = lambda: "ethertype"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                    class Uint16RngArray(Entity):
                                                        """
                                                        uint16 rng array
                                                        
                                                        .. attribute:: min
                                                        
                                                        	Lower limit of the range
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: max
                                                        
                                                        	Upper limit of the range
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2018-01-17'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                            self.yang_name = "uint16_rng_array"
                                                            self.yang_parent_name = "ethertype"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                            ])
                                                            self.min = None
                                                            self.max = None
                                                            self._segment_path = lambda: "uint16_rng_array"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['min', 'max'], name, value)


                                                class FlowKeyData(Entity):
                                                    """
                                                    Flow key structure
                                                    
                                                    .. attribute:: flow_keys
                                                    
                                                    	flow keys
                                                    	**type**\:  :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                    
                                                    .. attribute:: max_count
                                                    
                                                    	Maximum count of flows
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: idle_timeout
                                                    
                                                    	Idle timeout of flows (in seconds)
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**units**\: second
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                        self.yang_name = "flow-key-data"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("flow-keys", ("flow_keys", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys))])
                                                        self._leafs = OrderedDict([
                                                            ('max_count', (YLeaf(YType.uint16, 'max-count'), ['int'])),
                                                            ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                        ])
                                                        self.max_count = None
                                                        self.idle_timeout = None

                                                        self.flow_keys = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                        self.flow_keys.parent = self
                                                        self._children_name_map["flow_keys"] = "flow-keys"
                                                        self._segment_path = lambda: "flow-key-data"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['max_count', 'idle_timeout'], name, value)


                                                    class FlowKeys(Entity):
                                                        """
                                                        flow keys
                                                        
                                                        .. attribute:: keys
                                                        
                                                        	keys
                                                        	**type**\: str
                                                        
                                                        	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                        
                                                        .. attribute:: num
                                                        
                                                        	num
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2018-01-17'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                            self.yang_name = "flow-keys"
                                                            self.yang_parent_name = "flow-key-data"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('keys', (YLeaf(YType.str, 'keys'), ['str'])),
                                                                ('num', (YLeaf(YType.uint8, 'num'), ['int'])),
                                                            ])
                                                            self.keys = None
                                                            self.num = None
                                                            self._segment_path = lambda: "flow-keys"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                class DhcpClientId(Entity):
                                                    """
                                                    Dhcp Client ID
                                                    
                                                    .. attribute:: string_array
                                                    
                                                    	string array
                                                    	**type**\: list of str
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                        self.yang_name = "dhcp-client-id"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                        ])
                                                        self.string_array = []
                                                        self._segment_path = lambda: "dhcp-client-id"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                class DhcpClientIdRegex(Entity):
                                                    """
                                                    Dhcp Client ID RegEx
                                                    
                                                    .. attribute:: string_array
                                                    
                                                    	string array
                                                    	**type**\: list of str
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                        self.yang_name = "dhcp-client-id-regex"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                        ])
                                                        self.string_array = []
                                                        self._segment_path = lambda: "dhcp-client-id-regex"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                class CircuitId(Entity):
                                                    """
                                                    Circuit ID
                                                    
                                                    .. attribute:: string_array
                                                    
                                                    	string array
                                                    	**type**\: list of str
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                        self.yang_name = "circuit-id"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                        ])
                                                        self.string_array = []
                                                        self._segment_path = lambda: "circuit-id"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                class CircuitIdRegex(Entity):
                                                    """
                                                    Circuit ID RegEx
                                                    
                                                    .. attribute:: string_array
                                                    
                                                    	string array
                                                    	**type**\: list of str
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                        self.yang_name = "circuit-id-regex"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                        ])
                                                        self.string_array = []
                                                        self._segment_path = lambda: "circuit-id-regex"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                class RemoteId(Entity):
                                                    """
                                                    Remote ID
                                                    
                                                    .. attribute:: string_array
                                                    
                                                    	string array
                                                    	**type**\: list of str
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                        self.yang_name = "remote-id"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                        ])
                                                        self.string_array = []
                                                        self._segment_path = lambda: "remote-id"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                class RemoteIdRegex(Entity):
                                                    """
                                                    Remote ID RegEx
                                                    
                                                    .. attribute:: string_array
                                                    
                                                    	string array
                                                    	**type**\: list of str
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                        self.yang_name = "remote-id-regex"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                        ])
                                                        self.string_array = []
                                                        self._segment_path = lambda: "remote-id-regex"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                class SrcPort(Entity):
                                                    """
                                                    Source port
                                                    
                                                    .. attribute:: uint16_rng_array
                                                    
                                                    	uint16 rng array
                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                        self.yang_name = "src-port"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray))])
                                                        self._leafs = OrderedDict()

                                                        self.uint16_rng_array = YList(self)
                                                        self._segment_path = lambda: "src-port"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                    class Uint16RngArray(Entity):
                                                        """
                                                        uint16 rng array
                                                        
                                                        .. attribute:: min
                                                        
                                                        	Lower limit of the range
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: max
                                                        
                                                        	Upper limit of the range
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2018-01-17'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                            self.yang_name = "uint16_rng_array"
                                                            self.yang_parent_name = "src-port"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                            ])
                                                            self.min = None
                                                            self.max = None
                                                            self._segment_path = lambda: "uint16_rng_array"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['min', 'max'], name, value)


                                                class DstPort(Entity):
                                                    """
                                                    Destination port
                                                    
                                                    .. attribute:: uint16_rng_array
                                                    
                                                    	uint16 rng array
                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                        self.yang_name = "dst-port"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray))])
                                                        self._leafs = OrderedDict()

                                                        self.uint16_rng_array = YList(self)
                                                        self._segment_path = lambda: "dst-port"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                    class Uint16RngArray(Entity):
                                                        """
                                                        uint16 rng array
                                                        
                                                        .. attribute:: min
                                                        
                                                        	Lower limit of the range
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: max
                                                        
                                                        	Upper limit of the range
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2018-01-17'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                            self.yang_name = "uint16_rng_array"
                                                            self.yang_parent_name = "dst-port"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                            ])
                                                            self.min = None
                                                            self.max = None
                                                            self._segment_path = lambda: "uint16_rng_array"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap_.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['min', 'max'], name, value)


                        class ClassMapBriefs(Entity):
                            """
                            Class\-map brief table
                            
                            .. attribute:: class_map_brief
                            
                            	Class\-map brief information
                            	**type**\: list of  		 :py:class:`ClassMapBrief <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief>`
                            
                            

                            """

                            _prefix = 'infra-policymgr-oper'
                            _revision = '2018-01-17'

                            def __init__(self):
                                super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs, self).__init__()

                                self.yang_name = "class-map-briefs"
                                self.yang_parent_name = "class-map-type"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("class-map-brief", ("class_map_brief", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief))])
                                self._leafs = OrderedDict()

                                self.class_map_brief = YList(self)
                                self._segment_path = lambda: "class-map-briefs"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs, [], name, value)


                            class ClassMapBrief(Entity):
                                """
                                Class\-map brief information
                                
                                .. attribute:: class_map_name  (key)
                                
                                	Name of class\-map
                                	**type**\: str
                                
                                	**length:** 1..63
                                
                                .. attribute:: object_type
                                
                                	Application type configured
                                	**type**\:  :py:class:`PlmgrApplnTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrApplnTypeEn>`
                                
                                .. attribute:: total_objects
                                
                                	Total number of objects configured for a specific object type
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: transient
                                
                                	Transient object
                                	**type**\: bool
                                
                                .. attribute:: reference
                                
                                	Each Policymap details
                                	**type**\: list of  		 :py:class:`Reference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief.Reference>`
                                
                                .. attribute:: objects
                                
                                	Each object details
                                	**type**\: list of  		 :py:class:`Objects <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief.Objects>`
                                
                                .. attribute:: class_map_reference
                                
                                	Each Classmapdetails
                                	**type**\: list of  		 :py:class:`ClassMapReference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief.ClassMapReference>`
                                
                                

                                """

                                _prefix = 'infra-policymgr-oper'
                                _revision = '2018-01-17'

                                def __init__(self):
                                    super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief, self).__init__()

                                    self.yang_name = "class-map-brief"
                                    self.yang_parent_name = "class-map-briefs"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = ['class_map_name']
                                    self._child_classes = OrderedDict([("reference", ("reference", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief.Reference)), ("objects", ("objects", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief.Objects)), ("class-map-reference", ("class_map_reference", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief.ClassMapReference))])
                                    self._leafs = OrderedDict([
                                        ('class_map_name', (YLeaf(YType.str, 'class-map-name'), ['str'])),
                                        ('object_type', (YLeaf(YType.enumeration, 'object-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PlmgrApplnTypeEn', '')])),
                                        ('total_objects', (YLeaf(YType.uint32, 'total-objects'), ['int'])),
                                        ('transient', (YLeaf(YType.boolean, 'transient'), ['bool'])),
                                    ])
                                    self.class_map_name = None
                                    self.object_type = None
                                    self.total_objects = None
                                    self.transient = None

                                    self.reference = YList(self)
                                    self.objects = YList(self)
                                    self.class_map_reference = YList(self)
                                    self._segment_path = lambda: "class-map-brief" + "[class-map-name='" + str(self.class_map_name) + "']"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief, ['class_map_name', 'object_type', 'total_objects', 'transient'], name, value)


                                class Reference(Entity):
                                    """
                                    Each Policymap details
                                    
                                    .. attribute:: total_internal_reference_objects
                                    
                                    	Total number of internal reference objects
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: total_class_maps
                                    
                                    	Total number of Classmaps in a Policymap
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: total_flows
                                    
                                    	Total flows in a Policymap
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2018-01-17'

                                    def __init__(self):
                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief.Reference, self).__init__()

                                        self.yang_name = "reference"
                                        self.yang_parent_name = "class-map-brief"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('total_internal_reference_objects', (YLeaf(YType.uint32, 'total-internal-reference-objects'), ['int'])),
                                            ('total_class_maps', (YLeaf(YType.uint32, 'total-class-maps'), ['int'])),
                                            ('total_flows', (YLeaf(YType.uint32, 'total-flows'), ['int'])),
                                        ])
                                        self.total_internal_reference_objects = None
                                        self.total_class_maps = None
                                        self.total_flows = None
                                        self._segment_path = lambda: "reference"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief.Reference, ['total_internal_reference_objects', 'total_class_maps', 'total_flows'], name, value)


                                class Objects(Entity):
                                    """
                                    Each object details
                                    
                                    .. attribute:: object_name
                                    
                                    	Name of object (Policymap/Classmap)
                                    	**type**\: str
                                    
                                    	**length:** 0..64
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2018-01-17'

                                    def __init__(self):
                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief.Objects, self).__init__()

                                        self.yang_name = "objects"
                                        self.yang_parent_name = "class-map-brief"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('object_name', (YLeaf(YType.str, 'object-name'), ['str'])),
                                        ])
                                        self.object_name = None
                                        self._segment_path = lambda: "objects"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief.Objects, ['object_name'], name, value)


                                class ClassMapReference(Entity):
                                    """
                                    Each Classmapdetails
                                    
                                    .. attribute:: total_reference_objects
                                    
                                    	Total number of Policymaps referencing a Classmap
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: policy_map_reference
                                    
                                    	List of Policymaps referencing a Classmap
                                    	**type**\: list of  		 :py:class:`PolicyMapReference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief.ClassMapReference.PolicyMapReference>`
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2018-01-17'

                                    def __init__(self):
                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief.ClassMapReference, self).__init__()

                                        self.yang_name = "class-map-reference"
                                        self.yang_parent_name = "class-map-brief"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("policy-map-reference", ("policy_map_reference", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief.ClassMapReference.PolicyMapReference))])
                                        self._leafs = OrderedDict([
                                            ('total_reference_objects', (YLeaf(YType.uint32, 'total-reference-objects'), ['int'])),
                                        ])
                                        self.total_reference_objects = None

                                        self.policy_map_reference = YList(self)
                                        self._segment_path = lambda: "class-map-reference"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief.ClassMapReference, ['total_reference_objects'], name, value)


                                    class PolicyMapReference(Entity):
                                        """
                                        List of Policymaps referencing a Classmap
                                        
                                        .. attribute:: object_type
                                        
                                        	Application type configured
                                        	**type**\:  :py:class:`PlmgrApplnTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrApplnTypeEn>`
                                        
                                        .. attribute:: policy_map_name
                                        
                                        	Name of Policymap referencing a Classmap
                                        	**type**\: str
                                        
                                        	**length:** 0..64
                                        
                                        

                                        """

                                        _prefix = 'infra-policymgr-oper'
                                        _revision = '2018-01-17'

                                        def __init__(self):
                                            super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief.ClassMapReference.PolicyMapReference, self).__init__()

                                            self.yang_name = "policy-map-reference"
                                            self.yang_parent_name = "class-map-reference"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('object_type', (YLeaf(YType.enumeration, 'object-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PlmgrApplnTypeEn', '')])),
                                                ('policy_map_name', (YLeaf(YType.str, 'policy-map-name'), ['str'])),
                                            ])
                                            self.object_type = None
                                            self.policy_map_name = None
                                            self._segment_path = lambda: "policy-map-reference"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief.ClassMapReference.PolicyMapReference, ['object_type', 'policy_map_name'], name, value)


            class PolicyMap(Entity):
                """
                List of policymap details
                
                .. attribute:: transient_policy_map_type_xr
                
                	Application type of transient policy\-map
                	**type**\:  :py:class:`TransientPolicyMapTypeXr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr>`
                
                .. attribute:: policy_map_unused_types
                
                	Policy\-map unused table
                	**type**\:  :py:class:`PolicyMapUnusedTypes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapUnusedTypes>`
                
                .. attribute:: policy_map_types
                
                	Application type of a policymap
                	**type**\:  :py:class:`PolicyMapTypes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes>`
                
                .. attribute:: transient_policy_map_types
                
                	Application type of transient policy\-map list
                	**type**\:  :py:class:`TransientPolicyMapTypes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypes>`
                
                

                """

                _prefix = 'infra-policymgr-oper'
                _revision = '2018-01-17'

                def __init__(self):
                    super(PolicyManager.Nodes.Node.PolicyMap, self).__init__()

                    self.yang_name = "policy-map"
                    self.yang_parent_name = "node"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("transient-policy-map-type-xr", ("transient_policy_map_type_xr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr)), ("policy-map-unused-types", ("policy_map_unused_types", PolicyManager.Nodes.Node.PolicyMap.PolicyMapUnusedTypes)), ("policy-map-types", ("policy_map_types", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes)), ("transient-policy-map-types", ("transient_policy_map_types", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypes))])
                    self._leafs = OrderedDict()

                    self.transient_policy_map_type_xr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr()
                    self.transient_policy_map_type_xr.parent = self
                    self._children_name_map["transient_policy_map_type_xr"] = "transient-policy-map-type-xr"

                    self.policy_map_unused_types = PolicyManager.Nodes.Node.PolicyMap.PolicyMapUnusedTypes()
                    self.policy_map_unused_types.parent = self
                    self._children_name_map["policy_map_unused_types"] = "policy-map-unused-types"

                    self.policy_map_types = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes()
                    self.policy_map_types.parent = self
                    self._children_name_map["policy_map_types"] = "policy-map-types"

                    self.transient_policy_map_types = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypes()
                    self.transient_policy_map_types.parent = self
                    self._children_name_map["transient_policy_map_types"] = "transient-policy-map-types"
                    self._segment_path = lambda: "policy-map"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap, [], name, value)


                class TransientPolicyMapTypeXr(Entity):
                    """
                    Application type of transient policy\-map
                    
                    .. attribute:: transient_policy_map_type
                    
                    	Transient policy\-map type
                    	**type**\: list of  		 :py:class:`TransientPolicyMapType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType>`
                    
                    

                    """

                    _prefix = 'infra-policymgr-oper'
                    _revision = '2018-01-17'

                    def __init__(self):
                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr, self).__init__()

                        self.yang_name = "transient-policy-map-type-xr"
                        self.yang_parent_name = "policy-map"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("transient-policy-map-type", ("transient_policy_map_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType))])
                        self._leafs = OrderedDict()

                        self.transient_policy_map_type = YList(self)
                        self._segment_path = lambda: "transient-policy-map-type-xr"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr, [], name, value)


                    class TransientPolicyMapType(Entity):
                        """
                        Transient policy\-map type
                        
                        .. attribute:: type  (key)
                        
                        	The application type
                        	**type**\:  :py:class:`PolicymgrPolicyMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicymgrPolicyMap>`
                        
                        .. attribute:: transient_policy_map_names
                        
                        	Transient policy\-map definition table
                        	**type**\:  :py:class:`TransientPolicyMapNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames>`
                        
                        

                        """

                        _prefix = 'infra-policymgr-oper'
                        _revision = '2018-01-17'

                        def __init__(self):
                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType, self).__init__()

                            self.yang_name = "transient-policy-map-type"
                            self.yang_parent_name = "transient-policy-map-type-xr"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = ['type']
                            self._child_classes = OrderedDict([("transient-policy-map-names", ("transient_policy_map_names", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames))])
                            self._leafs = OrderedDict([
                                ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicymgrPolicyMap', '')])),
                            ])
                            self.type = None

                            self.transient_policy_map_names = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames()
                            self.transient_policy_map_names.parent = self
                            self._children_name_map["transient_policy_map_names"] = "transient-policy-map-names"
                            self._segment_path = lambda: "transient-policy-map-type" + "[type='" + str(self.type) + "']"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType, ['type'], name, value)


                        class TransientPolicyMapNames(Entity):
                            """
                            Transient policy\-map definition table
                            
                            .. attribute:: transient_policy_map_name
                            
                            	Transient policy\-map definition table
                            	**type**\: list of  		 :py:class:`TransientPolicyMapName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName>`
                            
                            

                            """

                            _prefix = 'infra-policymgr-oper'
                            _revision = '2018-01-17'

                            def __init__(self):
                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames, self).__init__()

                                self.yang_name = "transient-policy-map-names"
                                self.yang_parent_name = "transient-policy-map-type"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("transient-policy-map-name", ("transient_policy_map_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName))])
                                self._leafs = OrderedDict()

                                self.transient_policy_map_name = YList(self)
                                self._segment_path = lambda: "transient-policy-map-names"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames, [], name, value)


                            class TransientPolicyMapName(Entity):
                                """
                                Transient policy\-map definition table
                                
                                .. attribute:: policy_map_name  (key)
                                
                                	Name of policy\-map
                                	**type**\: str
                                
                                	**length:** 1..63
                                
                                .. attribute:: class_handles
                                
                                	Transient policy\-map class handle table
                                	**type**\:  :py:class:`ClassHandles <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles>`
                                
                                .. attribute:: class_seq_nums
                                
                                	Transient policy\-map sequence number table
                                	**type**\:  :py:class:`ClassSeqNums <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums>`
                                
                                .. attribute:: definition
                                
                                	Transient Policy\-map type name
                                	**type**\:  :py:class:`Definition <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition>`
                                
                                

                                """

                                _prefix = 'infra-policymgr-oper'
                                _revision = '2018-01-17'

                                def __init__(self):
                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName, self).__init__()

                                    self.yang_name = "transient-policy-map-name"
                                    self.yang_parent_name = "transient-policy-map-names"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = ['policy_map_name']
                                    self._child_classes = OrderedDict([("class-handles", ("class_handles", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles)), ("class-seq-nums", ("class_seq_nums", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums)), ("definition", ("definition", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition))])
                                    self._leafs = OrderedDict([
                                        ('policy_map_name', (YLeaf(YType.str, 'policy-map-name'), ['str'])),
                                    ])
                                    self.policy_map_name = None

                                    self.class_handles = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles()
                                    self.class_handles.parent = self
                                    self._children_name_map["class_handles"] = "class-handles"

                                    self.class_seq_nums = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums()
                                    self.class_seq_nums.parent = self
                                    self._children_name_map["class_seq_nums"] = "class-seq-nums"

                                    self.definition = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition()
                                    self.definition.parent = self
                                    self._children_name_map["definition"] = "definition"
                                    self._segment_path = lambda: "transient-policy-map-name" + "[policy-map-name='" + str(self.policy_map_name) + "']"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName, ['policy_map_name'], name, value)


                                class ClassHandles(Entity):
                                    """
                                    Transient policy\-map class handle table
                                    
                                    .. attribute:: class_handle
                                    
                                    	Transient policy\-map class handle
                                    	**type**\: list of  		 :py:class:`ClassHandle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle>`
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2018-01-17'

                                    def __init__(self):
                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles, self).__init__()

                                        self.yang_name = "class-handles"
                                        self.yang_parent_name = "transient-policy-map-name"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("class-handle", ("class_handle", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle))])
                                        self._leafs = OrderedDict()

                                        self.class_handle = YList(self)
                                        self._segment_path = lambda: "class-handles"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles, [], name, value)


                                    class ClassHandle(Entity):
                                        """
                                        Transient policy\-map class handle
                                        
                                        .. attribute:: inline_classhandle  (key)
                                        
                                        	inline class handle
                                        	**type**\: int
                                        
                                        	**range:** \-2147483648..2147483647
                                        
                                        .. attribute:: policy_map_bg
                                        
                                        	policy map bg
                                        	**type**\: list of  		 :py:class:`PolicyMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg>`
                                        
                                        

                                        """

                                        _prefix = 'infra-policymgr-oper'
                                        _revision = '2018-01-17'

                                        def __init__(self):
                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle, self).__init__()

                                            self.yang_name = "class-handle"
                                            self.yang_parent_name = "class-handles"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = ['inline_classhandle']
                                            self._child_classes = OrderedDict([("policy-map-bg", ("policy_map_bg", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg))])
                                            self._leafs = OrderedDict([
                                                ('inline_classhandle', (YLeaf(YType.int32, 'inline-classhandle'), ['int'])),
                                            ])
                                            self.inline_classhandle = None

                                            self.policy_map_bg = YList(self)
                                            self._segment_path = lambda: "class-handle" + "[inline-classhandle='" + str(self.inline_classhandle) + "']"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle, ['inline_classhandle'], name, value)


                                        class PolicyMapBg(Entity):
                                            """
                                            policy map bg
                                            
                                            .. attribute:: pmap_var_list
                                            
                                            	pmap var list
                                            	**type**\:  :py:class:`PmapVarList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.PmapVarList>`
                                            
                                            .. attribute:: event_infop
                                            
                                            	event infop
                                            	**type**\:  :py:class:`EventInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop>`
                                            
                                            .. attribute:: name
                                            
                                            	name
                                            	**type**\: str
                                            
                                            	**length:** 0..65
                                            
                                            .. attribute:: type
                                            
                                            	type
                                            	**type**\:  :py:class:`PolicyMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyMapTypeEn>`
                                            
                                            .. attribute:: description
                                            
                                            	description
                                            	**type**\: str
                                            
                                            

                                            """

                                            _prefix = 'infra-policymgr-oper'
                                            _revision = '2018-01-17'

                                            def __init__(self):
                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg, self).__init__()

                                                self.yang_name = "policy-map-bg"
                                                self.yang_parent_name = "class-handle"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("pmap-var-list", ("pmap_var_list", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.PmapVarList)), ("event-infop", ("event_infop", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop))])
                                                self._leafs = OrderedDict([
                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyMapTypeEn', '')])),
                                                    ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                ])
                                                self.name = None
                                                self.type = None
                                                self.description = None

                                                self.pmap_var_list = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.PmapVarList()
                                                self.pmap_var_list.parent = self
                                                self._children_name_map["pmap_var_list"] = "pmap-var-list"

                                                self.event_infop = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop()
                                                self.event_infop.parent = self
                                                self._children_name_map["event_infop"] = "event-infop"
                                                self._segment_path = lambda: "policy-map-bg"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg, ['name', 'type', 'description'], name, value)


                                            class PmapVarList(Entity):
                                                """
                                                pmap var list
                                                
                                                .. attribute:: pmap_var_list_arr
                                                
                                                	pmap var list arr
                                                	**type**\: list of  		 :py:class:`PmapVarListArr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.PmapVarList.PmapVarListArr>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.PmapVarList, self).__init__()

                                                    self.yang_name = "pmap-var-list"
                                                    self.yang_parent_name = "policy-map-bg"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("pmap-var-list-arr", ("pmap_var_list_arr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.PmapVarList.PmapVarListArr))])
                                                    self._leafs = OrderedDict()

                                                    self.pmap_var_list_arr = YList(self)
                                                    self._segment_path = lambda: "pmap-var-list"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.PmapVarList, [], name, value)


                                                class PmapVarListArr(Entity):
                                                    """
                                                    pmap var list arr
                                                    
                                                    .. attribute:: val
                                                    
                                                    	val
                                                    	**type**\:  :py:class:`Val <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.PmapVarList.PmapVarListArr.Val>`
                                                    
                                                    .. attribute:: name
                                                    
                                                    	name
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..32
                                                    
                                                    .. attribute:: id
                                                    
                                                    	id
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.PmapVarList.PmapVarListArr, self).__init__()

                                                        self.yang_name = "pmap-var-list-arr"
                                                        self.yang_parent_name = "pmap-var-list"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("val", ("val", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.PmapVarList.PmapVarListArr.Val))])
                                                        self._leafs = OrderedDict([
                                                            ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                            ('id', (YLeaf(YType.uint32, 'id'), ['int'])),
                                                        ])
                                                        self.name = None
                                                        self.id = None

                                                        self.val = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.PmapVarList.PmapVarListArr.Val()
                                                        self.val.parent = self
                                                        self._children_name_map["val"] = "val"
                                                        self._segment_path = lambda: "pmap-var-list-arr"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.PmapVarList.PmapVarListArr, ['name', 'id'], name, value)


                                                    class Val(Entity):
                                                        """
                                                        val
                                                        
                                                        .. attribute:: type
                                                        
                                                        	type
                                                        	**type**\:  :py:class:`PlmgrVarTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrVarTypeEn>`
                                                        
                                                        .. attribute:: class_name
                                                        
                                                        	class name
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..65
                                                        
                                                        .. attribute:: uint8_val
                                                        
                                                        	uint8 val
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        .. attribute:: uint16_val
                                                        
                                                        	uint16 val
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: uint32_val
                                                        
                                                        	uint32 val
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: param_uint32_val
                                                        
                                                        	param uint32 val
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: dscp_val
                                                        
                                                        	dscp val
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        .. attribute:: prec_val
                                                        
                                                        	prec val
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2018-01-17'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.PmapVarList.PmapVarListArr.Val, self).__init__()

                                                            self.yang_name = "val"
                                                            self.yang_parent_name = "pmap-var-list-arr"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PlmgrVarTypeEn', '')])),
                                                                ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                                ('uint8_val', (YLeaf(YType.uint8, 'uint8_val'), ['int'])),
                                                                ('uint16_val', (YLeaf(YType.uint16, 'uint16_val'), ['int'])),
                                                                ('uint32_val', (YLeaf(YType.uint32, 'uint32_val'), ['int'])),
                                                                ('param_uint32_val', (YLeaf(YType.uint32, 'param-uint32-val'), ['int'])),
                                                                ('dscp_val', (YLeaf(YType.uint8, 'dscp-val'), ['int'])),
                                                                ('prec_val', (YLeaf(YType.uint8, 'prec-val'), ['int'])),
                                                            ])
                                                            self.type = None
                                                            self.class_name = None
                                                            self.uint8_val = None
                                                            self.uint16_val = None
                                                            self.uint32_val = None
                                                            self.param_uint32_val = None
                                                            self.dscp_val = None
                                                            self.prec_val = None
                                                            self._segment_path = lambda: "val"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.PmapVarList.PmapVarListArr.Val, ['type', 'class_name', 'uint8_val', 'uint16_val', 'uint32_val', 'param_uint32_val', 'dscp_val', 'prec_val'], name, value)


                                            class EventInfop(Entity):
                                                """
                                                event infop
                                                
                                                .. attribute:: policy_event_info_bg
                                                
                                                	policy event info bg
                                                	**type**\: list of  		 :py:class:`PolicyEventInfoBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop, self).__init__()

                                                    self.yang_name = "event-infop"
                                                    self.yang_parent_name = "policy-map-bg"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("policy-event-info-bg", ("policy_event_info_bg", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg))])
                                                    self._leafs = OrderedDict()

                                                    self.policy_event_info_bg = YList(self)
                                                    self._segment_path = lambda: "event-infop"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop, [], name, value)


                                                class PolicyEventInfoBg(Entity):
                                                    """
                                                    policy event info bg
                                                    
                                                    .. attribute:: class_infop
                                                    
                                                    	class infop
                                                    	**type**\:  :py:class:`ClassInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop>`
                                                    
                                                    .. attribute:: event_type
                                                    
                                                    	event type
                                                    	**type**\:  :py:class:`PeventTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PeventTypeEn>`
                                                    
                                                    .. attribute:: cond_eval
                                                    
                                                    	cond eval
                                                    	**type**\:  :py:class:`PeventCondEvalEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PeventCondEvalEn>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg, self).__init__()

                                                        self.yang_name = "policy-event-info-bg"
                                                        self.yang_parent_name = "event-infop"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("class-infop", ("class_infop", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop))])
                                                        self._leafs = OrderedDict([
                                                            ('event_type', (YLeaf(YType.enumeration, 'event-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PeventTypeEn', '')])),
                                                            ('cond_eval', (YLeaf(YType.enumeration, 'cond-eval'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PeventCondEvalEn', '')])),
                                                        ])
                                                        self.event_type = None
                                                        self.cond_eval = None

                                                        self.class_infop = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop()
                                                        self.class_infop.parent = self
                                                        self._children_name_map["class_infop"] = "class-infop"
                                                        self._segment_path = lambda: "policy-event-info-bg"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg, ['event_type', 'cond_eval'], name, value)


                                                    class ClassInfop(Entity):
                                                        """
                                                        class infop
                                                        
                                                        .. attribute:: policy_class_info_bg
                                                        
                                                        	policy class info bg
                                                        	**type**\: list of  		 :py:class:`PolicyClassInfoBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2018-01-17'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop, self).__init__()

                                                            self.yang_name = "class-infop"
                                                            self.yang_parent_name = "policy-event-info-bg"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("policy-class-info-bg", ("policy_class_info_bg", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg))])
                                                            self._leafs = OrderedDict()

                                                            self.policy_class_info_bg = YList(self)
                                                            self._segment_path = lambda: "class-infop"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop, [], name, value)


                                                        class PolicyClassInfoBg(Entity):
                                                            """
                                                            policy class info bg
                                                            
                                                            .. attribute:: cl_encode
                                                            
                                                            	cl encode
                                                            	**type**\:  :py:class:`ClEncode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode>`
                                                            
                                                            .. attribute:: clmp_p
                                                            
                                                            	clmp p
                                                            	**type**\:  :py:class:`ClmpP <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP>`
                                                            
                                                            .. attribute:: act_infop
                                                            
                                                            	act infop
                                                            	**type**\:  :py:class:`ActInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop>`
                                                            
                                                            .. attribute:: policy_class_hd
                                                            
                                                            	policy class hd
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: seq
                                                            
                                                            	seq
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: flags
                                                            
                                                            	flags
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: ctype
                                                            
                                                            	ctype
                                                            	**type**\:  :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                            
                                                            .. attribute:: num_actions
                                                            
                                                            	num actions
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..65535
                                                            
                                                            .. attribute:: version
                                                            
                                                            	version
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..255
                                                            
                                                            .. attribute:: exe_strat
                                                            
                                                            	exe strat
                                                            	**type**\:  :py:class:`PclassExecStratEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PclassExecStratEn>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'infra-policymgr-oper'
                                                            _revision = '2018-01-17'

                                                            def __init__(self):
                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg, self).__init__()

                                                                self.yang_name = "policy-class-info-bg"
                                                                self.yang_parent_name = "class-infop"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("cl-encode", ("cl_encode", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode)), ("clmp-p", ("clmp_p", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP)), ("act-infop", ("act_infop", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop))])
                                                                self._leafs = OrderedDict([
                                                                    ('policy_class_hd', (YLeaf(YType.uint32, 'policy-class-hd'), ['int'])),
                                                                    ('seq', (YLeaf(YType.uint32, 'seq'), ['int'])),
                                                                    ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                    ('ctype', (YLeaf(YType.enumeration, 'ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapTypeEn', '')])),
                                                                    ('num_actions', (YLeaf(YType.uint16, 'num-actions'), ['int'])),
                                                                    ('version', (YLeaf(YType.uint8, 'version'), ['int'])),
                                                                    ('exe_strat', (YLeaf(YType.enumeration, 'exe-strat'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PclassExecStratEn', '')])),
                                                                ])
                                                                self.policy_class_hd = None
                                                                self.seq = None
                                                                self.flags = None
                                                                self.ctype = None
                                                                self.num_actions = None
                                                                self.version = None
                                                                self.exe_strat = None

                                                                self.cl_encode = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode()
                                                                self.cl_encode.parent = self
                                                                self._children_name_map["cl_encode"] = "cl-encode"

                                                                self.clmp_p = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP()
                                                                self.clmp_p.parent = self
                                                                self._children_name_map["clmp_p"] = "clmp-p"

                                                                self.act_infop = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop()
                                                                self.act_infop.parent = self
                                                                self._children_name_map["act_infop"] = "act-infop"
                                                                self._segment_path = lambda: "policy-class-info-bg"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg, ['policy_class_hd', 'seq', 'flags', 'ctype', 'num_actions', 'version', 'exe_strat'], name, value)


                                                            class ClEncode(Entity):
                                                                """
                                                                cl encode
                                                                
                                                                .. attribute:: inline_cmap
                                                                
                                                                	inline cmap
                                                                	**type**\:  :py:class:`InlineCmap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap>`
                                                                
                                                                .. attribute:: enc
                                                                
                                                                	enc
                                                                	**type**\:  :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                
                                                                .. attribute:: class_name
                                                                
                                                                	class name
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..65
                                                                
                                                                .. attribute:: hd
                                                                
                                                                	hd
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: idx
                                                                
                                                                	idx
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..255
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode, self).__init__()

                                                                    self.yang_name = "cl-encode"
                                                                    self.yang_parent_name = "policy-class-info-bg"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("inline-cmap", ("inline_cmap", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap))])
                                                                    self._leafs = OrderedDict([
                                                                        ('enc', (YLeaf(YType.enumeration, 'enc'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyObjEncEn', '')])),
                                                                        ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                                        ('hd', (YLeaf(YType.uint64, 'hd'), ['int'])),
                                                                        ('idx', (YLeaf(YType.uint8, 'idx'), ['int'])),
                                                                    ])
                                                                    self.enc = None
                                                                    self.class_name = None
                                                                    self.hd = None
                                                                    self.idx = None

                                                                    self.inline_cmap = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap()
                                                                    self.inline_cmap.parent = self
                                                                    self._children_name_map["inline_cmap"] = "inline-cmap"
                                                                    self._segment_path = lambda: "cl-encode"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode, ['enc', 'class_name', 'hd', 'idx'], name, value)


                                                                class InlineCmap(Entity):
                                                                    """
                                                                    inline cmap
                                                                    
                                                                    .. attribute:: match_infop
                                                                    
                                                                    	Pointer to the first Match info
                                                                    	**type**\:  :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop>`
                                                                    
                                                                    .. attribute:: mode
                                                                    
                                                                    	Inline Class\-Map Mode Match any/all
                                                                    	**type**\:  :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                    
                                                                    .. attribute:: flags
                                                                    
                                                                    	Inline Class\-Map flags
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: match_count
                                                                    
                                                                    	Number of Match infos
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap, self).__init__()

                                                                        self.yang_name = "inline-cmap"
                                                                        self.yang_parent_name = "cl-encode"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("match-infop", ("match_infop", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop))])
                                                                        self._leafs = OrderedDict([
                                                                            ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapModeEn', '')])),
                                                                            ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                            ('match_count', (YLeaf(YType.uint32, 'match-count'), ['int'])),
                                                                        ])
                                                                        self.mode = None
                                                                        self.flags = None
                                                                        self.match_count = None

                                                                        self.match_infop = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop()
                                                                        self.match_infop.parent = self
                                                                        self._children_name_map["match_infop"] = "match-infop"
                                                                        self._segment_path = lambda: "inline-cmap"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap, ['mode', 'flags', 'match_count'], name, value)


                                                                    class MatchInfop(Entity):
                                                                        """
                                                                        Pointer to the first Match info
                                                                        
                                                                        .. attribute:: class_match_info_st
                                                                        
                                                                        	class match info st
                                                                        	**type**\: list of  		 :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop, self).__init__()

                                                                            self.yang_name = "match-infop"
                                                                            self.yang_parent_name = "inline-cmap"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("class-match-info-st", ("class_match_info_st", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt))])
                                                                            self._leafs = OrderedDict()

                                                                            self.class_match_info_st = YList(self)
                                                                            self._segment_path = lambda: "match-infop"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop, [], name, value)


                                                                        class ClassMatchInfoSt(Entity):
                                                                            """
                                                                            class match info st
                                                                            
                                                                            .. attribute:: match_data
                                                                            
                                                                            	Match criteria
                                                                            	**type**\:  :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                            
                                                                            .. attribute:: flags
                                                                            
                                                                            	Flags
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                self.yang_name = "class-match-info-st"
                                                                                self.yang_parent_name = "match-infop"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("match-data", ("match_data", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                ])
                                                                                self.flags = None

                                                                                self.match_data = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                self.match_data.parent = self
                                                                                self._children_name_map["match_data"] = "match-data"
                                                                                self._segment_path = lambda: "class-match-info-st"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                            class MatchData(Entity):
                                                                                """
                                                                                Match criteria
                                                                                
                                                                                .. attribute:: ipv4_dscp
                                                                                
                                                                                	IPv4 DSCP
                                                                                	**type**\:  :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                
                                                                                .. attribute:: ipv6_dscp
                                                                                
                                                                                	IPv6 DSCP
                                                                                	**type**\:  :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                
                                                                                .. attribute:: dscp
                                                                                
                                                                                	Match DSCP range array
                                                                                	**type**\:  :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                
                                                                                .. attribute:: ipv4_prec
                                                                                
                                                                                	IPv4 Precedence
                                                                                	**type**\:  :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                
                                                                                .. attribute:: ipv6_prec
                                                                                
                                                                                	IPv6 Precedence
                                                                                	**type**\:  :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                
                                                                                .. attribute:: prec
                                                                                
                                                                                	Match Precedence array
                                                                                	**type**\:  :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                
                                                                                .. attribute:: discard_class
                                                                                
                                                                                	Match Discard Class array
                                                                                	**type**\:  :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                
                                                                                .. attribute:: qos_group
                                                                                
                                                                                	Match QoS group array
                                                                                	**type**\:  :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                
                                                                                .. attribute:: traffic_class
                                                                                
                                                                                	Match Traffic class array
                                                                                	**type**\:  :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                
                                                                                .. attribute:: proto
                                                                                
                                                                                	Match Protocol array
                                                                                	**type**\:  :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                
                                                                                .. attribute:: icmp_v4
                                                                                
                                                                                	Match ICMPV4 Protocol
                                                                                	**type**\:  :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                
                                                                                .. attribute:: icmp_v6
                                                                                
                                                                                	Match ICMPV6 Protocol array
                                                                                	**type**\:  :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                
                                                                                .. attribute:: ipv4_packet_len
                                                                                
                                                                                	IPv4 packet length array
                                                                                	**type**\:  :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                
                                                                                .. attribute:: ipv6_packet_len
                                                                                
                                                                                	IPv6 packet length array
                                                                                	**type**\:  :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                
                                                                                .. attribute:: packet_len
                                                                                
                                                                                	Match packet length array
                                                                                	**type**\:  :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                
                                                                                .. attribute:: flow_tag
                                                                                
                                                                                	Match flow\-tag array
                                                                                	**type**\:  :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                
                                                                                .. attribute:: tcp_flag
                                                                                
                                                                                	Match tcp flag value
                                                                                	**type**\:  :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                
                                                                                .. attribute:: icmpv4_type
                                                                                
                                                                                	Match ipv4 icmp type
                                                                                	**type**\:  :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                
                                                                                .. attribute:: icmpv4_code
                                                                                
                                                                                	Match ipv4 icmp code
                                                                                	**type**\:  :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                
                                                                                .. attribute:: icmpv6_type
                                                                                
                                                                                	Match ipv6 icmp type
                                                                                	**type**\:  :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                
                                                                                .. attribute:: icmpv6_code
                                                                                
                                                                                	Match ipv6 icmp code
                                                                                	**type**\:  :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                
                                                                                .. attribute:: mpls_exp
                                                                                
                                                                                	Match MPLS experimental topmost array
                                                                                	**type**\:  :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                
                                                                                .. attribute:: mpls_exp_imp
                                                                                
                                                                                	Match MPLS experimental imposition array
                                                                                	**type**\:  :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                
                                                                                .. attribute:: mpls_disp_ipv4_acl
                                                                                
                                                                                	MPLS Disposition IPv4 Access\-list
                                                                                	**type**\:  :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                
                                                                                .. attribute:: mpls_disp_ipv6_acl
                                                                                
                                                                                	MPLS Disposition IPv6 Access\-list
                                                                                	**type**\:  :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                
                                                                                .. attribute:: mpls_top_label
                                                                                
                                                                                	MPLS Topmost LABEL
                                                                                	**type**\:  :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                
                                                                                .. attribute:: cos
                                                                                
                                                                                	Match CoS array
                                                                                	**type**\:  :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                
                                                                                .. attribute:: cos_inr
                                                                                
                                                                                	Match inner header CoS
                                                                                	**type**\:  :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                
                                                                                .. attribute:: dei
                                                                                
                                                                                	Match DEI Bit
                                                                                	**type**\:  :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                
                                                                                .. attribute:: dei_inr
                                                                                
                                                                                	Match inner DEI Bit
                                                                                	**type**\:  :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                
                                                                                .. attribute:: vlan
                                                                                
                                                                                	Match VLAN array
                                                                                	**type**\:  :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                
                                                                                .. attribute:: vlan_inr
                                                                                
                                                                                	Match inner header VLAN range array
                                                                                	**type**\:  :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                
                                                                                .. attribute:: fr_dlci
                                                                                
                                                                                	Match FR DLCI range array
                                                                                	**type**\:  :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                
                                                                                .. attribute:: src_mac
                                                                                
                                                                                	Match Source MAC address
                                                                                	**type**\:  :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                
                                                                                .. attribute:: dst_mac
                                                                                
                                                                                	Match Destination MAC address
                                                                                	**type**\:  :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                
                                                                                .. attribute:: atm_clp
                                                                                
                                                                                	Match ATM CLP level
                                                                                	**type**\:  :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                
                                                                                .. attribute:: fr_de
                                                                                
                                                                                	Match FR DE value
                                                                                	**type**\:  :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                
                                                                                .. attribute:: ipv4_acl
                                                                                
                                                                                	IPv4 Access\-list
                                                                                	**type**\:  :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                
                                                                                .. attribute:: ipv6_acl
                                                                                
                                                                                	IPv6 Access\-list
                                                                                	**type**\:  :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                
                                                                                .. attribute:: ether_service_acl
                                                                                
                                                                                	Ethernet\-Services Access\-list
                                                                                	**type**\:  :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                
                                                                                .. attribute:: avail_id
                                                                                
                                                                                	Available Identifiers
                                                                                	**type**\:  :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                
                                                                                .. attribute:: media_type
                                                                                
                                                                                	Media Type
                                                                                	**type**\:  :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                
                                                                                .. attribute:: subs_protocol
                                                                                
                                                                                	Protocol
                                                                                	**type**\:  :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                
                                                                                .. attribute:: dnis
                                                                                
                                                                                	DNIS
                                                                                	**type**\:  :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                
                                                                                .. attribute:: dnis_regex
                                                                                
                                                                                	DNIS Regular Expression
                                                                                	**type**\:  :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                
                                                                                .. attribute:: domain
                                                                                
                                                                                	Domain Name
                                                                                	**type**\:  :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                
                                                                                .. attribute:: domain_regex
                                                                                
                                                                                	Domain Regular Expression
                                                                                	**type**\:  :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                
                                                                                .. attribute:: nas_port
                                                                                
                                                                                	NAS Port
                                                                                	**type**\:  :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                
                                                                                .. attribute:: service_name
                                                                                
                                                                                	Service Name
                                                                                	**type**\:  :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                
                                                                                .. attribute:: service_name_regex
                                                                                
                                                                                	Service Name Regular Exp
                                                                                	**type**\:  :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                
                                                                                .. attribute:: src_addr_ipv4
                                                                                
                                                                                	Source Address IPV4
                                                                                	**type**\:  :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                
                                                                                .. attribute:: dst_addr_ipv4
                                                                                
                                                                                	Destination Address IPV4
                                                                                	**type**\:  :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                
                                                                                .. attribute:: src_addr_ipv6
                                                                                
                                                                                	Source Address IPV6
                                                                                	**type**\:  :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                
                                                                                .. attribute:: dst_addr_ipv6
                                                                                
                                                                                	Destination Address IPV6
                                                                                	**type**\:  :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                
                                                                                .. attribute:: src_addr_mac
                                                                                
                                                                                	Source Address MAC
                                                                                	**type**\:  :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                
                                                                                .. attribute:: timer
                                                                                
                                                                                	Timer
                                                                                	**type**\:  :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                
                                                                                .. attribute:: timer_regexp
                                                                                
                                                                                	Timer Regular Expression
                                                                                	**type**\:  :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                
                                                                                .. attribute:: tunnel_name
                                                                                
                                                                                	Tunnel Name
                                                                                	**type**\:  :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                
                                                                                .. attribute:: tunnel_name_regex
                                                                                
                                                                                	Tunnel Name Regular Expression
                                                                                	**type**\:  :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                
                                                                                .. attribute:: user_name
                                                                                
                                                                                	User Name
                                                                                	**type**\:  :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                
                                                                                .. attribute:: user_name_regex
                                                                                
                                                                                	User Name Regular Expression
                                                                                	**type**\:  :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                
                                                                                .. attribute:: auth_username
                                                                                
                                                                                	Authenticated User Name
                                                                                	**type**\:  :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                
                                                                                .. attribute:: auth_username_regex
                                                                                
                                                                                	Authenticated User Name RegEx
                                                                                	**type**\:  :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                
                                                                                .. attribute:: unauth_username
                                                                                
                                                                                	Unauthenticated User Name
                                                                                	**type**\:  :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                
                                                                                .. attribute:: unauth_username_regex
                                                                                
                                                                                	Unauthenticated User Name RegEx
                                                                                	**type**\:  :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                
                                                                                .. attribute:: auth_domain
                                                                                
                                                                                	Authenticated domain name
                                                                                	**type**\:  :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                
                                                                                .. attribute:: auth_domain_regex
                                                                                
                                                                                	Authenticated Domain Name RegEx
                                                                                	**type**\:  :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                
                                                                                .. attribute:: unauth_domain
                                                                                
                                                                                	Unauthenticated Domain Name
                                                                                	**type**\:  :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                
                                                                                .. attribute:: unauth_domain_regex
                                                                                
                                                                                	Unauthenticated Domain Name RegEx
                                                                                	**type**\:  :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                
                                                                                .. attribute:: vendor_id
                                                                                
                                                                                	Vendor ID
                                                                                	**type**\:  :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                
                                                                                .. attribute:: vendor_id_regex
                                                                                
                                                                                	Vendor ID RegEx
                                                                                	**type**\:  :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                
                                                                                .. attribute:: access_interface
                                                                                
                                                                                	Access interface
                                                                                	**type**\:  :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                
                                                                                .. attribute:: input_interface
                                                                                
                                                                                	Input interface
                                                                                	**type**\:  :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                
                                                                                .. attribute:: input_intfhdl
                                                                                
                                                                                	Input interface handle
                                                                                	**type**\:  :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                
                                                                                .. attribute:: ethertype
                                                                                
                                                                                	Ethernet type
                                                                                	**type**\:  :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                
                                                                                .. attribute:: flow_key_data
                                                                                
                                                                                	Flow key structure
                                                                                	**type**\:  :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                
                                                                                .. attribute:: dhcp_client_id
                                                                                
                                                                                	Dhcp Client ID
                                                                                	**type**\:  :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                
                                                                                .. attribute:: dhcp_client_id_regex
                                                                                
                                                                                	Dhcp Client ID RegEx
                                                                                	**type**\:  :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                
                                                                                .. attribute:: circuit_id
                                                                                
                                                                                	Circuit ID
                                                                                	**type**\:  :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                
                                                                                .. attribute:: circuit_id_regex
                                                                                
                                                                                	Circuit ID RegEx
                                                                                	**type**\:  :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                
                                                                                .. attribute:: remote_id
                                                                                
                                                                                	Remote ID
                                                                                	**type**\:  :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                
                                                                                .. attribute:: remote_id_regex
                                                                                
                                                                                	Remote ID RegEx
                                                                                	**type**\:  :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                
                                                                                .. attribute:: src_port
                                                                                
                                                                                	Source port
                                                                                	**type**\:  :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                
                                                                                .. attribute:: dst_port
                                                                                
                                                                                	Destination port
                                                                                	**type**\:  :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:  :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                
                                                                                .. attribute:: mpls_top_eos
                                                                                
                                                                                	MPLS Topmost EOS
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: fragment_type
                                                                                
                                                                                	Fragment type
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: authen_status
                                                                                
                                                                                	Authentication Status
                                                                                	**type**\:  :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                
                                                                                .. attribute:: mlp_negotiated
                                                                                
                                                                                	MLP Negotiated
                                                                                	**type**\:  :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                    self.yang_name = "match-data"
                                                                                    self.yang_parent_name = "class-match-info-st"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("ipv4-dscp", ("ipv4_dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp)), ("ipv6-dscp", ("ipv6_dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp)), ("dscp", ("dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp)), ("ipv4-prec", ("ipv4_prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec)), ("ipv6-prec", ("ipv6_prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec)), ("prec", ("prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec)), ("discard-class", ("discard_class", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass)), ("qos-group", ("qos_group", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup)), ("traffic-class", ("traffic_class", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass)), ("proto", ("proto", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto)), ("icmp-v4", ("icmp_v4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4)), ("icmp-v6", ("icmp_v6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6)), ("ipv4-packet-len", ("ipv4_packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen)), ("ipv6-packet-len", ("ipv6_packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen)), ("packet-len", ("packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen)), ("flow-tag", ("flow_tag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag)), ("tcp-flag", ("tcp_flag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag)), ("icmpv4-type", ("icmpv4_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type)), ("icmpv4-code", ("icmpv4_code", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code)), ("icmpv6-type", ("icmpv6_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type)), ("icmpv6-code", ("icmpv6_code", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code)), ("mpls-exp", ("mpls_exp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp)), ("mpls-exp-imp", ("mpls_exp_imp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp)), ("mpls-disp-ipv4-acl", ("mpls_disp_ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl)), ("mpls-disp-ipv6-acl", ("mpls_disp_ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl)), ("mpls-top-label", ("mpls_top_label", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel)), ("cos", ("cos", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos)), ("cos-inr", ("cos_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr)), ("dei", ("dei", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei)), ("dei-inr", ("dei_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr)), ("vlan", ("vlan", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan)), ("vlan-inr", ("vlan_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)), ("fr-dlci", ("fr_dlci", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci)), ("src-mac", ("src_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac)), ("dst-mac", ("dst_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac)), ("atm-clp", ("atm_clp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp)), ("fr-de", ("fr_de", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe)), ("ipv4-acl", ("ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl)), ("ipv6-acl", ("ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl)), ("ether-service-acl", ("ether_service_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl)), ("avail-id", ("avail_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId)), ("media-type", ("media_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType)), ("subs-protocol", ("subs_protocol", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol)), ("dnis", ("dnis", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis)), ("dnis-regex", ("dnis_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex)), ("domain", ("domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain)), ("domain-regex", ("domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex)), ("nas-port", ("nas_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort)), ("service-name", ("service_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName)), ("service-name-regex", ("service_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex)), ("src-addr-ipv4", ("src_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4)), ("dst-addr-ipv4", ("dst_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4)), ("src-addr-ipv6", ("src_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6)), ("dst-addr-ipv6", ("dst_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6)), ("src-addr-mac", ("src_addr_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac)), ("timer", ("timer", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer)), ("timer-regexp", ("timer_regexp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp)), ("tunnel-name", ("tunnel_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName)), ("tunnel-name-regex", ("tunnel_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex)), ("user-name", ("user_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName)), ("user-name-regex", ("user_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex)), ("auth-username", ("auth_username", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername)), ("auth-username-regex", ("auth_username_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex)), ("unauth-username", ("unauth_username", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername)), ("unauth-username-regex", ("unauth_username_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex)), ("auth-domain", ("auth_domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain)), ("auth-domain-regex", ("auth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex)), ("unauth-domain", ("unauth_domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain)), ("unauth-domain-regex", ("unauth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex)), ("vendor-id", ("vendor_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId)), ("vendor-id-regex", ("vendor_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex)), ("access-interface", ("access_interface", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface)), ("input-interface", ("input_interface", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface)), ("input-intfhdl", ("input_intfhdl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl)), ("ethertype", ("ethertype", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype)), ("flow-key-data", ("flow_key_data", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData)), ("dhcp-client-id", ("dhcp_client_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId)), ("dhcp-client-id-regex", ("dhcp_client_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex)), ("circuit-id", ("circuit_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId)), ("circuit-id-regex", ("circuit_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex)), ("remote-id", ("remote_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId)), ("remote-id-regex", ("remote_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex)), ("src-port", ("src_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort)), ("dst-port", ("dst_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchTypeEn', '')])),
                                                                                        ('mpls_top_eos', (YLeaf(YType.uint8, 'mpls-top-eos'), ['int'])),
                                                                                        ('fragment_type', (YLeaf(YType.uint8, 'fragment-type'), ['int'])),
                                                                                        ('authen_status', (YLeaf(YType.enumeration, 'authen-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchAuthenStatusEn', '')])),
                                                                                        ('mlp_negotiated', (YLeaf(YType.enumeration, 'mlp-negotiated'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchMlpNegotiatedEn', '')])),
                                                                                    ])
                                                                                    self.type = None
                                                                                    self.mpls_top_eos = None
                                                                                    self.fragment_type = None
                                                                                    self.authen_status = None
                                                                                    self.mlp_negotiated = None

                                                                                    self.ipv4_dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                    self.ipv4_dscp.parent = self
                                                                                    self._children_name_map["ipv4_dscp"] = "ipv4-dscp"

                                                                                    self.ipv6_dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                    self.ipv6_dscp.parent = self
                                                                                    self._children_name_map["ipv6_dscp"] = "ipv6-dscp"

                                                                                    self.dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                    self.dscp.parent = self
                                                                                    self._children_name_map["dscp"] = "dscp"

                                                                                    self.ipv4_prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                    self.ipv4_prec.parent = self
                                                                                    self._children_name_map["ipv4_prec"] = "ipv4-prec"

                                                                                    self.ipv6_prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                    self.ipv6_prec.parent = self
                                                                                    self._children_name_map["ipv6_prec"] = "ipv6-prec"

                                                                                    self.prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                    self.prec.parent = self
                                                                                    self._children_name_map["prec"] = "prec"

                                                                                    self.discard_class = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                    self.discard_class.parent = self
                                                                                    self._children_name_map["discard_class"] = "discard-class"

                                                                                    self.qos_group = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                    self.qos_group.parent = self
                                                                                    self._children_name_map["qos_group"] = "qos-group"

                                                                                    self.traffic_class = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                    self.traffic_class.parent = self
                                                                                    self._children_name_map["traffic_class"] = "traffic-class"

                                                                                    self.proto = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                    self.proto.parent = self
                                                                                    self._children_name_map["proto"] = "proto"

                                                                                    self.icmp_v4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                    self.icmp_v4.parent = self
                                                                                    self._children_name_map["icmp_v4"] = "icmp-v4"

                                                                                    self.icmp_v6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                    self.icmp_v6.parent = self
                                                                                    self._children_name_map["icmp_v6"] = "icmp-v6"

                                                                                    self.ipv4_packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                    self.ipv4_packet_len.parent = self
                                                                                    self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"

                                                                                    self.ipv6_packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                    self.ipv6_packet_len.parent = self
                                                                                    self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"

                                                                                    self.packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                    self.packet_len.parent = self
                                                                                    self._children_name_map["packet_len"] = "packet-len"

                                                                                    self.flow_tag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                    self.flow_tag.parent = self
                                                                                    self._children_name_map["flow_tag"] = "flow-tag"

                                                                                    self.tcp_flag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                    self.tcp_flag.parent = self
                                                                                    self._children_name_map["tcp_flag"] = "tcp-flag"

                                                                                    self.icmpv4_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                    self.icmpv4_type.parent = self
                                                                                    self._children_name_map["icmpv4_type"] = "icmpv4-type"

                                                                                    self.icmpv4_code = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                    self.icmpv4_code.parent = self
                                                                                    self._children_name_map["icmpv4_code"] = "icmpv4-code"

                                                                                    self.icmpv6_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                    self.icmpv6_type.parent = self
                                                                                    self._children_name_map["icmpv6_type"] = "icmpv6-type"

                                                                                    self.icmpv6_code = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                    self.icmpv6_code.parent = self
                                                                                    self._children_name_map["icmpv6_code"] = "icmpv6-code"

                                                                                    self.mpls_exp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                    self.mpls_exp.parent = self
                                                                                    self._children_name_map["mpls_exp"] = "mpls-exp"

                                                                                    self.mpls_exp_imp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                    self.mpls_exp_imp.parent = self
                                                                                    self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"

                                                                                    self.mpls_disp_ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                    self.mpls_disp_ipv4_acl.parent = self
                                                                                    self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"

                                                                                    self.mpls_disp_ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                    self.mpls_disp_ipv6_acl.parent = self
                                                                                    self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"

                                                                                    self.mpls_top_label = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                    self.mpls_top_label.parent = self
                                                                                    self._children_name_map["mpls_top_label"] = "mpls-top-label"

                                                                                    self.cos = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                    self.cos.parent = self
                                                                                    self._children_name_map["cos"] = "cos"

                                                                                    self.cos_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                    self.cos_inr.parent = self
                                                                                    self._children_name_map["cos_inr"] = "cos-inr"

                                                                                    self.dei = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                    self.dei.parent = self
                                                                                    self._children_name_map["dei"] = "dei"

                                                                                    self.dei_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                    self.dei_inr.parent = self
                                                                                    self._children_name_map["dei_inr"] = "dei-inr"

                                                                                    self.vlan = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                    self.vlan.parent = self
                                                                                    self._children_name_map["vlan"] = "vlan"

                                                                                    self.vlan_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                    self.vlan_inr.parent = self
                                                                                    self._children_name_map["vlan_inr"] = "vlan-inr"

                                                                                    self.fr_dlci = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                    self.fr_dlci.parent = self
                                                                                    self._children_name_map["fr_dlci"] = "fr-dlci"

                                                                                    self.src_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                    self.src_mac.parent = self
                                                                                    self._children_name_map["src_mac"] = "src-mac"

                                                                                    self.dst_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                    self.dst_mac.parent = self
                                                                                    self._children_name_map["dst_mac"] = "dst-mac"

                                                                                    self.atm_clp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                    self.atm_clp.parent = self
                                                                                    self._children_name_map["atm_clp"] = "atm-clp"

                                                                                    self.fr_de = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                    self.fr_de.parent = self
                                                                                    self._children_name_map["fr_de"] = "fr-de"

                                                                                    self.ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                    self.ipv4_acl.parent = self
                                                                                    self._children_name_map["ipv4_acl"] = "ipv4-acl"

                                                                                    self.ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                    self.ipv6_acl.parent = self
                                                                                    self._children_name_map["ipv6_acl"] = "ipv6-acl"

                                                                                    self.ether_service_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                    self.ether_service_acl.parent = self
                                                                                    self._children_name_map["ether_service_acl"] = "ether-service-acl"

                                                                                    self.avail_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                    self.avail_id.parent = self
                                                                                    self._children_name_map["avail_id"] = "avail-id"

                                                                                    self.media_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                    self.media_type.parent = self
                                                                                    self._children_name_map["media_type"] = "media-type"

                                                                                    self.subs_protocol = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                    self.subs_protocol.parent = self
                                                                                    self._children_name_map["subs_protocol"] = "subs-protocol"

                                                                                    self.dnis = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                    self.dnis.parent = self
                                                                                    self._children_name_map["dnis"] = "dnis"

                                                                                    self.dnis_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                    self.dnis_regex.parent = self
                                                                                    self._children_name_map["dnis_regex"] = "dnis-regex"

                                                                                    self.domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                    self.domain.parent = self
                                                                                    self._children_name_map["domain"] = "domain"

                                                                                    self.domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                    self.domain_regex.parent = self
                                                                                    self._children_name_map["domain_regex"] = "domain-regex"

                                                                                    self.nas_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                    self.nas_port.parent = self
                                                                                    self._children_name_map["nas_port"] = "nas-port"

                                                                                    self.service_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                    self.service_name.parent = self
                                                                                    self._children_name_map["service_name"] = "service-name"

                                                                                    self.service_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                    self.service_name_regex.parent = self
                                                                                    self._children_name_map["service_name_regex"] = "service-name-regex"

                                                                                    self.src_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                    self.src_addr_ipv4.parent = self
                                                                                    self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"

                                                                                    self.dst_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                    self.dst_addr_ipv4.parent = self
                                                                                    self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"

                                                                                    self.src_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                    self.src_addr_ipv6.parent = self
                                                                                    self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"

                                                                                    self.dst_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                    self.dst_addr_ipv6.parent = self
                                                                                    self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"

                                                                                    self.src_addr_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                    self.src_addr_mac.parent = self
                                                                                    self._children_name_map["src_addr_mac"] = "src-addr-mac"

                                                                                    self.timer = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                    self.timer.parent = self
                                                                                    self._children_name_map["timer"] = "timer"

                                                                                    self.timer_regexp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                    self.timer_regexp.parent = self
                                                                                    self._children_name_map["timer_regexp"] = "timer-regexp"

                                                                                    self.tunnel_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                    self.tunnel_name.parent = self
                                                                                    self._children_name_map["tunnel_name"] = "tunnel-name"

                                                                                    self.tunnel_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                    self.tunnel_name_regex.parent = self
                                                                                    self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"

                                                                                    self.user_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                    self.user_name.parent = self
                                                                                    self._children_name_map["user_name"] = "user-name"

                                                                                    self.user_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                    self.user_name_regex.parent = self
                                                                                    self._children_name_map["user_name_regex"] = "user-name-regex"

                                                                                    self.auth_username = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                    self.auth_username.parent = self
                                                                                    self._children_name_map["auth_username"] = "auth-username"

                                                                                    self.auth_username_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                    self.auth_username_regex.parent = self
                                                                                    self._children_name_map["auth_username_regex"] = "auth-username-regex"

                                                                                    self.unauth_username = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                    self.unauth_username.parent = self
                                                                                    self._children_name_map["unauth_username"] = "unauth-username"

                                                                                    self.unauth_username_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                    self.unauth_username_regex.parent = self
                                                                                    self._children_name_map["unauth_username_regex"] = "unauth-username-regex"

                                                                                    self.auth_domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                    self.auth_domain.parent = self
                                                                                    self._children_name_map["auth_domain"] = "auth-domain"

                                                                                    self.auth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                    self.auth_domain_regex.parent = self
                                                                                    self._children_name_map["auth_domain_regex"] = "auth-domain-regex"

                                                                                    self.unauth_domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                    self.unauth_domain.parent = self
                                                                                    self._children_name_map["unauth_domain"] = "unauth-domain"

                                                                                    self.unauth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                    self.unauth_domain_regex.parent = self
                                                                                    self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"

                                                                                    self.vendor_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                    self.vendor_id.parent = self
                                                                                    self._children_name_map["vendor_id"] = "vendor-id"

                                                                                    self.vendor_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                    self.vendor_id_regex.parent = self
                                                                                    self._children_name_map["vendor_id_regex"] = "vendor-id-regex"

                                                                                    self.access_interface = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                    self.access_interface.parent = self
                                                                                    self._children_name_map["access_interface"] = "access-interface"

                                                                                    self.input_interface = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                    self.input_interface.parent = self
                                                                                    self._children_name_map["input_interface"] = "input-interface"

                                                                                    self.input_intfhdl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                    self.input_intfhdl.parent = self
                                                                                    self._children_name_map["input_intfhdl"] = "input-intfhdl"

                                                                                    self.ethertype = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                    self.ethertype.parent = self
                                                                                    self._children_name_map["ethertype"] = "ethertype"

                                                                                    self.flow_key_data = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                    self.flow_key_data.parent = self
                                                                                    self._children_name_map["flow_key_data"] = "flow-key-data"

                                                                                    self.dhcp_client_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                    self.dhcp_client_id.parent = self
                                                                                    self._children_name_map["dhcp_client_id"] = "dhcp-client-id"

                                                                                    self.dhcp_client_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                    self.dhcp_client_id_regex.parent = self
                                                                                    self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"

                                                                                    self.circuit_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                    self.circuit_id.parent = self
                                                                                    self._children_name_map["circuit_id"] = "circuit-id"

                                                                                    self.circuit_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                    self.circuit_id_regex.parent = self
                                                                                    self._children_name_map["circuit_id_regex"] = "circuit-id-regex"

                                                                                    self.remote_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                    self.remote_id.parent = self
                                                                                    self._children_name_map["remote_id"] = "remote-id"

                                                                                    self.remote_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                    self.remote_id_regex.parent = self
                                                                                    self._children_name_map["remote_id_regex"] = "remote-id-regex"

                                                                                    self.src_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                    self.src_port.parent = self
                                                                                    self._children_name_map["src_port"] = "src-port"

                                                                                    self.dst_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                    self.dst_port.parent = self
                                                                                    self._children_name_map["dst_port"] = "dst-port"
                                                                                    self._segment_path = lambda: "match-data"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, ['type', 'mpls_top_eos', 'fragment_type', 'authen_status', 'mlp_negotiated'], name, value)


                                                                                class Ipv4Dscp(Entity):
                                                                                    """
                                                                                    IPv4 DSCP
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                        self.yang_name = "ipv4-dscp"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "ipv4-dscp"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "ipv4-dscp"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                class Ipv6Dscp(Entity):
                                                                                    """
                                                                                    IPv6 DSCP
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                        self.yang_name = "ipv6-dscp"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "ipv6-dscp"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "ipv6-dscp"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                class Dscp(Entity):
                                                                                    """
                                                                                    Match DSCP range array
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                        self.yang_name = "dscp"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "dscp"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "dscp"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                class Ipv4Prec(Entity):
                                                                                    """
                                                                                    IPv4 Precedence
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                        self.yang_name = "ipv4-prec"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                        ])
                                                                                        self.uint8_array = []
                                                                                        self._segment_path = lambda: "ipv4-prec"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                class Ipv6Prec(Entity):
                                                                                    """
                                                                                    IPv6 Precedence
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                        self.yang_name = "ipv6-prec"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                        ])
                                                                                        self.uint8_array = []
                                                                                        self._segment_path = lambda: "ipv6-prec"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                class Prec(Entity):
                                                                                    """
                                                                                    Match Precedence array
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                        self.yang_name = "prec"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                        ])
                                                                                        self.uint8_array = []
                                                                                        self._segment_path = lambda: "prec"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                class DiscardClass(Entity):
                                                                                    """
                                                                                    Match Discard Class array
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                        self.yang_name = "discard-class"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                        ])
                                                                                        self.uint8_array = []
                                                                                        self._segment_path = lambda: "discard-class"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                class QosGroup(Entity):
                                                                                    """
                                                                                    Match QoS group array
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                        self.yang_name = "qos-group"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "qos-group"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "qos-group"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['min', 'max'], name, value)


                                                                                class TrafficClass(Entity):
                                                                                    """
                                                                                    Match Traffic class array
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                        self.yang_name = "traffic-class"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "traffic-class"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "traffic-class"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['min', 'max'], name, value)


                                                                                class Proto(Entity):
                                                                                    """
                                                                                    Match Protocol array
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                        self.yang_name = "proto"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "proto"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "proto"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['min', 'max'], name, value)


                                                                                class IcmpV4(Entity):
                                                                                    """
                                                                                    Match ICMPV4 Protocol
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	Protocol type
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: code
                                                                                    
                                                                                    	Protocol code
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                        self.yang_name = "icmp-v4"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                            ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                        ])
                                                                                        self.type = None
                                                                                        self.code = None
                                                                                        self._segment_path = lambda: "icmp-v4"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['type', 'code'], name, value)


                                                                                class IcmpV6(Entity):
                                                                                    """
                                                                                    Match ICMPV6 Protocol array
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	Protocol type
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: code
                                                                                    
                                                                                    	Protocol code
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                        self.yang_name = "icmp-v6"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                            ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                        ])
                                                                                        self.type = None
                                                                                        self.code = None
                                                                                        self._segment_path = lambda: "icmp-v6"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['type', 'code'], name, value)


                                                                                class Ipv4PacketLen(Entity):
                                                                                    """
                                                                                    IPv4 packet length array
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                        self.yang_name = "ipv4-packet-len"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "ipv4-packet-len"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "ipv4-packet-len"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                class Ipv6PacketLen(Entity):
                                                                                    """
                                                                                    IPv6 packet length array
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                        self.yang_name = "ipv6-packet-len"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "ipv6-packet-len"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "ipv6-packet-len"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                class PacketLen(Entity):
                                                                                    """
                                                                                    Match packet length array
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                        self.yang_name = "packet-len"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "packet-len"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "packet-len"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                class FlowTag(Entity):
                                                                                    """
                                                                                    Match flow\-tag array
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                        self.yang_name = "flow-tag"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "flow-tag"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "flow-tag"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['min', 'max'], name, value)


                                                                                class TcpFlag(Entity):
                                                                                    """
                                                                                    Match tcp flag value
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	Value of TCP flag
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: match_any
                                                                                    
                                                                                    	Match any TCP flag bit
                                                                                    	**type**\: bool
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                        self.yang_name = "tcp-flag"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                            ('match_any', (YLeaf(YType.boolean, 'match-any'), ['bool'])),
                                                                                        ])
                                                                                        self.value = None
                                                                                        self.match_any = None
                                                                                        self._segment_path = lambda: "tcp-flag"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['value', 'match_any'], name, value)


                                                                                class Icmpv4Type(Entity):
                                                                                    """
                                                                                    Match ipv4 icmp type
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                        self.yang_name = "icmpv4-type"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "icmpv4-type"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "icmpv4-type"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                class Icmpv4Code(Entity):
                                                                                    """
                                                                                    Match ipv4 icmp code
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                        self.yang_name = "icmpv4-code"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "icmpv4-code"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "icmpv4-code"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                class Icmpv6Type(Entity):
                                                                                    """
                                                                                    Match ipv6 icmp type
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                        self.yang_name = "icmpv6-type"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "icmpv6-type"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "icmpv6-type"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                class Icmpv6Code(Entity):
                                                                                    """
                                                                                    Match ipv6 icmp code
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                        self.yang_name = "icmpv6-code"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "icmpv6-code"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "icmpv6-code"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                class MplsExp(Entity):
                                                                                    """
                                                                                    Match MPLS experimental topmost array
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                        self.yang_name = "mpls-exp"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                        ])
                                                                                        self.uint8_array = []
                                                                                        self._segment_path = lambda: "mpls-exp"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                class MplsExpImp(Entity):
                                                                                    """
                                                                                    Match MPLS experimental imposition array
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                        self.yang_name = "mpls-exp-imp"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                        ])
                                                                                        self.uint8_array = []
                                                                                        self._segment_path = lambda: "mpls-exp-imp"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                class MplsDispIpv4Acl(Entity):
                                                                                    """
                                                                                    MPLS Disposition IPv4 Access\-list
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                        self.yang_name = "mpls-disp-ipv4-acl"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "mpls-disp-ipv4-acl"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                class MplsDispIpv6Acl(Entity):
                                                                                    """
                                                                                    MPLS Disposition IPv6 Access\-list
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                        self.yang_name = "mpls-disp-ipv6-acl"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "mpls-disp-ipv6-acl"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                class MplsTopLabel(Entity):
                                                                                    """
                                                                                    MPLS Topmost LABEL
                                                                                    
                                                                                    .. attribute:: uint32_rng_array
                                                                                    
                                                                                    	uint32 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                        self.yang_name = "mpls-top-label"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint32_rng_array", ("uint32_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint32_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "mpls-top-label"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                    class Uint32RngArray(Entity):
                                                                                        """
                                                                                        uint32 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                            self.yang_name = "uint32_rng_array"
                                                                                            self.yang_parent_name = "mpls-top-label"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint32, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint32, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint32_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['min', 'max'], name, value)


                                                                                class Cos(Entity):
                                                                                    """
                                                                                    Match CoS array
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                        self.yang_name = "cos"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                        ])
                                                                                        self.uint8_array = []
                                                                                        self._segment_path = lambda: "cos"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                class CosInr(Entity):
                                                                                    """
                                                                                    Match inner header CoS
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                        self.yang_name = "cos-inr"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                        ])
                                                                                        self.uint8_array = []
                                                                                        self._segment_path = lambda: "cos-inr"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                class Dei(Entity):
                                                                                    """
                                                                                    Match DEI Bit
                                                                                    
                                                                                    .. attribute:: bit_value
                                                                                    
                                                                                    	Value of the DEI bit
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                        self.yang_name = "dei"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                        ])
                                                                                        self.bit_value = None
                                                                                        self._segment_path = lambda: "dei"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                class DeiInr(Entity):
                                                                                    """
                                                                                    Match inner DEI Bit
                                                                                    
                                                                                    .. attribute:: bit_value
                                                                                    
                                                                                    	Value of the DEI bit
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                        self.yang_name = "dei-inr"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                        ])
                                                                                        self.bit_value = None
                                                                                        self._segment_path = lambda: "dei-inr"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                class Vlan(Entity):
                                                                                    """
                                                                                    Match VLAN array
                                                                                    
                                                                                    .. attribute:: vlan_id_array
                                                                                    
                                                                                    	vlan id array
                                                                                    	**type**\: list of  		 :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                        self.yang_name = "vlan"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("vlan-id-array", ("vlan_id_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.vlan_id_array = YList(self)
                                                                                        self._segment_path = lambda: "vlan"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                    class VlanIdArray(Entity):
                                                                                        """
                                                                                        vlan id array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: mask
                                                                                        
                                                                                        	VLAN mask
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                            self.yang_name = "vlan-id-array"
                                                                                            self.yang_parent_name = "vlan"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                ('mask', (YLeaf(YType.uint16, 'mask'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self.mask = None
                                                                                            self._segment_path = lambda: "vlan-id-array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['min', 'max', 'mask'], name, value)


                                                                                class VlanInr(Entity):
                                                                                    """
                                                                                    Match inner header VLAN range array
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                        self.yang_name = "vlan-inr"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "vlan-inr"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "vlan-inr"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['min', 'max'], name, value)


                                                                                class FrDlci(Entity):
                                                                                    """
                                                                                    Match FR DLCI range array
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                        self.yang_name = "fr-dlci"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "fr-dlci"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "fr-dlci"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['min', 'max'], name, value)


                                                                                class SrcMac(Entity):
                                                                                    """
                                                                                    Match Source MAC address
                                                                                    
                                                                                    .. attribute:: mac_addr
                                                                                    
                                                                                    	MAC address
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	MAC mask
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                        self.yang_name = "src-mac"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                            ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                        ])
                                                                                        self.mac_addr = []
                                                                                        self.mask = []
                                                                                        self._segment_path = lambda: "src-mac"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                class DstMac(Entity):
                                                                                    """
                                                                                    Match Destination MAC address
                                                                                    
                                                                                    .. attribute:: mac_addr
                                                                                    
                                                                                    	MAC address
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	MAC mask
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                        self.yang_name = "dst-mac"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                            ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                        ])
                                                                                        self.mac_addr = []
                                                                                        self.mask = []
                                                                                        self._segment_path = lambda: "dst-mac"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                class AtmClp(Entity):
                                                                                    """
                                                                                    Match ATM CLP level
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                        self.yang_name = "atm-clp"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                        ])
                                                                                        self.uint8_array = []
                                                                                        self._segment_path = lambda: "atm-clp"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                class FrDe(Entity):
                                                                                    """
                                                                                    Match FR DE value
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                        self.yang_name = "fr-de"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                        ])
                                                                                        self.uint8_array = []
                                                                                        self._segment_path = lambda: "fr-de"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                class Ipv4Acl(Entity):
                                                                                    """
                                                                                    IPv4 Access\-list
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                        self.yang_name = "ipv4-acl"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "ipv4-acl"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                class Ipv6Acl(Entity):
                                                                                    """
                                                                                    IPv6 Access\-list
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                        self.yang_name = "ipv6-acl"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "ipv6-acl"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                class EtherServiceAcl(Entity):
                                                                                    """
                                                                                    Ethernet\-Services Access\-list
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                        self.yang_name = "ether-service-acl"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "ether-service-acl"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                class AvailId(Entity):
                                                                                    """
                                                                                    Available Identifiers
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                        self.yang_name = "avail-id"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                        ])
                                                                                        self.uint8_array = []
                                                                                        self._segment_path = lambda: "avail-id"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                class MediaType(Entity):
                                                                                    """
                                                                                    Media Type
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                        self.yang_name = "media-type"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                        ])
                                                                                        self.uint8_array = []
                                                                                        self._segment_path = lambda: "media-type"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                class SubsProtocol(Entity):
                                                                                    """
                                                                                    Protocol
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                        self.yang_name = "subs-protocol"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                        ])
                                                                                        self.uint8_array = []
                                                                                        self._segment_path = lambda: "subs-protocol"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                class Dnis(Entity):
                                                                                    """
                                                                                    DNIS
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                        self.yang_name = "dnis"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "dnis"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                class DnisRegex(Entity):
                                                                                    """
                                                                                    DNIS Regular Expression
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                        self.yang_name = "dnis-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "dnis-regex"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                class Domain(Entity):
                                                                                    """
                                                                                    Domain Name
                                                                                    
                                                                                    .. attribute:: domain_array
                                                                                    
                                                                                    	domain array
                                                                                    	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                        self.yang_name = "domain"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.domain_array = YList(self)
                                                                                        self._segment_path = lambda: "domain"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                    class DomainArray(Entity):
                                                                                        """
                                                                                        domain array
                                                                                        
                                                                                        .. attribute:: domain_name
                                                                                        
                                                                                        	domain name
                                                                                        	**type**\: str
                                                                                        
                                                                                        .. attribute:: format_name
                                                                                        
                                                                                        	format name
                                                                                        	**type**\: str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                            self.yang_name = "domain-array"
                                                                                            self.yang_parent_name = "domain"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                            ])
                                                                                            self.domain_name = None
                                                                                            self.format_name = None
                                                                                            self._segment_path = lambda: "domain-array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                class DomainRegex(Entity):
                                                                                    """
                                                                                    Domain Regular Expression
                                                                                    
                                                                                    .. attribute:: domain_array
                                                                                    
                                                                                    	domain array
                                                                                    	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                        self.yang_name = "domain-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.domain_array = YList(self)
                                                                                        self._segment_path = lambda: "domain-regex"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                    class DomainArray(Entity):
                                                                                        """
                                                                                        domain array
                                                                                        
                                                                                        .. attribute:: domain_name
                                                                                        
                                                                                        	domain name
                                                                                        	**type**\: str
                                                                                        
                                                                                        .. attribute:: format_name
                                                                                        
                                                                                        	format name
                                                                                        	**type**\: str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                            self.yang_name = "domain-array"
                                                                                            self.yang_parent_name = "domain-regex"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                            ])
                                                                                            self.domain_name = None
                                                                                            self.format_name = None
                                                                                            self._segment_path = lambda: "domain-array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                class NasPort(Entity):
                                                                                    """
                                                                                    NAS Port
                                                                                    
                                                                                    .. attribute:: nas_port_array
                                                                                    
                                                                                    	nas port array
                                                                                    	**type**\: list of  		 :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                        self.yang_name = "nas-port"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("nas-port-array", ("nas_port_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.nas_port_array = YList(self)
                                                                                        self._segment_path = lambda: "nas-port"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                    class NasPortArray(Entity):
                                                                                        """
                                                                                        nas port array
                                                                                        
                                                                                        .. attribute:: sub_id
                                                                                        
                                                                                        	sub id
                                                                                        	**type**\:  :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                        
                                                                                        .. attribute:: operator
                                                                                        
                                                                                        	operator
                                                                                        	**type**\:  :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                        
                                                                                        .. attribute:: value
                                                                                        
                                                                                        	value
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                            self.yang_name = "nas-port-array"
                                                                                            self.yang_parent_name = "nas-port"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('sub_id', (YLeaf(YType.enumeration, 'sub-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchNasPortSubIdEn', '')])),
                                                                                                ('operator', (YLeaf(YType.enumeration, 'operator'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchLogicalOperatorEn', '')])),
                                                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                            ])
                                                                                            self.sub_id = None
                                                                                            self.operator = None
                                                                                            self.value = None
                                                                                            self._segment_path = lambda: "nas-port-array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['sub_id', 'operator', 'value'], name, value)


                                                                                class ServiceName(Entity):
                                                                                    """
                                                                                    Service Name
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                        self.yang_name = "service-name"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "service-name"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                class ServiceNameRegex(Entity):
                                                                                    """
                                                                                    Service Name Regular Exp
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                        self.yang_name = "service-name-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "service-name-regex"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                class SrcAddrIpv4(Entity):
                                                                                    """
                                                                                    Source Address IPV4
                                                                                    
                                                                                    .. attribute:: ipv4_addr_array
                                                                                    
                                                                                    	ipv4 addr array
                                                                                    	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                        self.yang_name = "src-addr-ipv4"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.ipv4_addr_array = YList(self)
                                                                                        self._segment_path = lambda: "src-addr-ipv4"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                    class Ipv4AddrArray(Entity):
                                                                                        """
                                                                                        ipv4 addr array
                                                                                        
                                                                                        .. attribute:: prefix
                                                                                        
                                                                                        	prefix
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                        
                                                                                        .. attribute:: mask
                                                                                        
                                                                                        	mask
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                            self.yang_name = "ipv4-addr-array"
                                                                                            self.yang_parent_name = "src-addr-ipv4"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                            ])
                                                                                            self.prefix = None
                                                                                            self.mask = None
                                                                                            self._segment_path = lambda: "ipv4-addr-array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                class DstAddrIpv4(Entity):
                                                                                    """
                                                                                    Destination Address IPV4
                                                                                    
                                                                                    .. attribute:: ipv4_addr_array
                                                                                    
                                                                                    	ipv4 addr array
                                                                                    	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                        self.yang_name = "dst-addr-ipv4"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.ipv4_addr_array = YList(self)
                                                                                        self._segment_path = lambda: "dst-addr-ipv4"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                    class Ipv4AddrArray(Entity):
                                                                                        """
                                                                                        ipv4 addr array
                                                                                        
                                                                                        .. attribute:: prefix
                                                                                        
                                                                                        	prefix
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                        
                                                                                        .. attribute:: mask
                                                                                        
                                                                                        	mask
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                            self.yang_name = "ipv4-addr-array"
                                                                                            self.yang_parent_name = "dst-addr-ipv4"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                            ])
                                                                                            self.prefix = None
                                                                                            self.mask = None
                                                                                            self._segment_path = lambda: "ipv4-addr-array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                class SrcAddrIpv6(Entity):
                                                                                    """
                                                                                    Source Address IPV6
                                                                                    
                                                                                    .. attribute:: ipv6_addr_array
                                                                                    
                                                                                    	ipv6 addr array
                                                                                    	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                        self.yang_name = "src-addr-ipv6"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.ipv6_addr_array = YList(self)
                                                                                        self._segment_path = lambda: "src-addr-ipv6"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                    class Ipv6AddrArray(Entity):
                                                                                        """
                                                                                        ipv6 addr array
                                                                                        
                                                                                        .. attribute:: prefix
                                                                                        
                                                                                        	IPV6 prefix
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                        
                                                                                        .. attribute:: mask
                                                                                        
                                                                                        	IPV6 mask
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                            self.yang_name = "ipv6-addr-array"
                                                                                            self.yang_parent_name = "src-addr-ipv6"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                            ])
                                                                                            self.prefix = None
                                                                                            self.mask = None
                                                                                            self._segment_path = lambda: "ipv6-addr-array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                class DstAddrIpv6(Entity):
                                                                                    """
                                                                                    Destination Address IPV6
                                                                                    
                                                                                    .. attribute:: ipv6_addr_array
                                                                                    
                                                                                    	ipv6 addr array
                                                                                    	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                        self.yang_name = "dst-addr-ipv6"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.ipv6_addr_array = YList(self)
                                                                                        self._segment_path = lambda: "dst-addr-ipv6"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                    class Ipv6AddrArray(Entity):
                                                                                        """
                                                                                        ipv6 addr array
                                                                                        
                                                                                        .. attribute:: prefix
                                                                                        
                                                                                        	IPV6 prefix
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                        
                                                                                        .. attribute:: mask
                                                                                        
                                                                                        	IPV6 mask
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                            self.yang_name = "ipv6-addr-array"
                                                                                            self.yang_parent_name = "dst-addr-ipv6"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                            ])
                                                                                            self.prefix = None
                                                                                            self.mask = None
                                                                                            self._segment_path = lambda: "ipv6-addr-array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                class SrcAddrMac(Entity):
                                                                                    """
                                                                                    Source Address MAC
                                                                                    
                                                                                    .. attribute:: mac_addr_array
                                                                                    
                                                                                    	mac addr array
                                                                                    	**type**\: list of  		 :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                        self.yang_name = "src-addr-mac"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("mac-addr-array", ("mac_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.mac_addr_array = YList(self)
                                                                                        self._segment_path = lambda: "src-addr-mac"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                    class MacAddrArray(Entity):
                                                                                        """
                                                                                        mac addr array
                                                                                        
                                                                                        .. attribute:: mac_addr
                                                                                        
                                                                                        	MAC address
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: mask
                                                                                        
                                                                                        	MAC mask
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                            self.yang_name = "mac-addr-array"
                                                                                            self.yang_parent_name = "src-addr-mac"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                            ])
                                                                                            self.mac_addr = []
                                                                                            self.mask = []
                                                                                            self._segment_path = lambda: "mac-addr-array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                class Timer(Entity):
                                                                                    """
                                                                                    Timer
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                        self.yang_name = "timer"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "timer"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                class TimerRegexp(Entity):
                                                                                    """
                                                                                    Timer Regular Expression
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                        self.yang_name = "timer-regexp"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "timer-regexp"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                class TunnelName(Entity):
                                                                                    """
                                                                                    Tunnel Name
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                        self.yang_name = "tunnel-name"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "tunnel-name"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                class TunnelNameRegex(Entity):
                                                                                    """
                                                                                    Tunnel Name Regular Expression
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                        self.yang_name = "tunnel-name-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "tunnel-name-regex"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                class UserName(Entity):
                                                                                    """
                                                                                    User Name
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                        self.yang_name = "user-name"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "user-name"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                class UserNameRegex(Entity):
                                                                                    """
                                                                                    User Name Regular Expression
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                        self.yang_name = "user-name-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "user-name-regex"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                class AuthUsername(Entity):
                                                                                    """
                                                                                    Authenticated User Name
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                        self.yang_name = "auth-username"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "auth-username"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                class AuthUsernameRegex(Entity):
                                                                                    """
                                                                                    Authenticated User Name RegEx
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                        self.yang_name = "auth-username-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "auth-username-regex"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                class UnauthUsername(Entity):
                                                                                    """
                                                                                    Unauthenticated User Name
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                        self.yang_name = "unauth-username"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "unauth-username"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                class UnauthUsernameRegex(Entity):
                                                                                    """
                                                                                    Unauthenticated User Name RegEx
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                        self.yang_name = "unauth-username-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "unauth-username-regex"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                class AuthDomain(Entity):
                                                                                    """
                                                                                    Authenticated domain name
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                        self.yang_name = "auth-domain"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "auth-domain"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                class AuthDomainRegex(Entity):
                                                                                    """
                                                                                    Authenticated Domain Name RegEx
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                        self.yang_name = "auth-domain-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "auth-domain-regex"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                class UnauthDomain(Entity):
                                                                                    """
                                                                                    Unauthenticated Domain Name
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                        self.yang_name = "unauth-domain"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "unauth-domain"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                class UnauthDomainRegex(Entity):
                                                                                    """
                                                                                    Unauthenticated Domain Name RegEx
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                        self.yang_name = "unauth-domain-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "unauth-domain-regex"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                class VendorId(Entity):
                                                                                    """
                                                                                    Vendor ID
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                        self.yang_name = "vendor-id"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "vendor-id"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                class VendorIdRegex(Entity):
                                                                                    """
                                                                                    Vendor ID RegEx
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                        self.yang_name = "vendor-id-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "vendor-id-regex"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                class AccessInterface(Entity):
                                                                                    """
                                                                                    Access interface
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                        self.yang_name = "access-interface"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "access-interface"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                class InputInterface(Entity):
                                                                                    """
                                                                                    Input interface
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                        self.yang_name = "input-interface"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "input-interface"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                class InputIntfhdl(Entity):
                                                                                    """
                                                                                    Input interface handle
                                                                                    
                                                                                    .. attribute:: uint64_array
                                                                                    
                                                                                    	uint64 array
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..18446744073709551615
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                        self.yang_name = "input-intfhdl"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('uint64_array', (YLeafList(YType.uint64, 'uint64_array'), ['int'])),
                                                                                        ])
                                                                                        self.uint64_array = []
                                                                                        self._segment_path = lambda: "input-intfhdl"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                class Ethertype(Entity):
                                                                                    """
                                                                                    Ethernet type
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                        self.yang_name = "ethertype"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "ethertype"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "ethertype"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['min', 'max'], name, value)


                                                                                class FlowKeyData(Entity):
                                                                                    """
                                                                                    Flow key structure
                                                                                    
                                                                                    .. attribute:: flow_keys
                                                                                    
                                                                                    	flow keys
                                                                                    	**type**\:  :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                    
                                                                                    .. attribute:: max_count
                                                                                    
                                                                                    	Maximum count of flows
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: idle_timeout
                                                                                    
                                                                                    	Idle timeout of flows (in seconds)
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    	**units**\: second
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                        self.yang_name = "flow-key-data"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("flow-keys", ("flow_keys", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys))])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('max_count', (YLeaf(YType.uint16, 'max-count'), ['int'])),
                                                                                            ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                                        ])
                                                                                        self.max_count = None
                                                                                        self.idle_timeout = None

                                                                                        self.flow_keys = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                        self.flow_keys.parent = self
                                                                                        self._children_name_map["flow_keys"] = "flow-keys"
                                                                                        self._segment_path = lambda: "flow-key-data"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['max_count', 'idle_timeout'], name, value)


                                                                                    class FlowKeys(Entity):
                                                                                        """
                                                                                        flow keys
                                                                                        
                                                                                        .. attribute:: keys
                                                                                        
                                                                                        	keys
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                        
                                                                                        .. attribute:: num
                                                                                        
                                                                                        	num
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                            self.yang_name = "flow-keys"
                                                                                            self.yang_parent_name = "flow-key-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('keys', (YLeaf(YType.str, 'keys'), ['str'])),
                                                                                                ('num', (YLeaf(YType.uint8, 'num'), ['int'])),
                                                                                            ])
                                                                                            self.keys = None
                                                                                            self.num = None
                                                                                            self._segment_path = lambda: "flow-keys"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                class DhcpClientId(Entity):
                                                                                    """
                                                                                    Dhcp Client ID
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                        self.yang_name = "dhcp-client-id"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "dhcp-client-id"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                class DhcpClientIdRegex(Entity):
                                                                                    """
                                                                                    Dhcp Client ID RegEx
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                        self.yang_name = "dhcp-client-id-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "dhcp-client-id-regex"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                class CircuitId(Entity):
                                                                                    """
                                                                                    Circuit ID
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                        self.yang_name = "circuit-id"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "circuit-id"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                class CircuitIdRegex(Entity):
                                                                                    """
                                                                                    Circuit ID RegEx
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                        self.yang_name = "circuit-id-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "circuit-id-regex"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                class RemoteId(Entity):
                                                                                    """
                                                                                    Remote ID
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                        self.yang_name = "remote-id"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "remote-id"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                class RemoteIdRegex(Entity):
                                                                                    """
                                                                                    Remote ID RegEx
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                        self.yang_name = "remote-id-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "remote-id-regex"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                class SrcPort(Entity):
                                                                                    """
                                                                                    Source port
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                        self.yang_name = "src-port"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "src-port"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "src-port"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                                class DstPort(Entity):
                                                                                    """
                                                                                    Destination port
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                        self.yang_name = "dst-port"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "dst-port"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "dst-port"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['min', 'max'], name, value)


                                                            class ClmpP(Entity):
                                                                """
                                                                clmp p
                                                                
                                                                .. attribute:: class_map_bg
                                                                
                                                                	class map bg
                                                                	**type**\: list of  		 :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP, self).__init__()

                                                                    self.yang_name = "clmp-p"
                                                                    self.yang_parent_name = "policy-class-info-bg"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("class-map-bg", ("class_map_bg", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg))])
                                                                    self._leafs = OrderedDict()

                                                                    self.class_map_bg = YList(self)
                                                                    self._segment_path = lambda: "clmp-p"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP, [], name, value)


                                                                class ClassMapBg(Entity):
                                                                    """
                                                                    class map bg
                                                                    
                                                                    .. attribute:: match_infop
                                                                    
                                                                    	Pointer to the first Match info
                                                                    	**type**\:  :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop>`
                                                                    
                                                                    .. attribute:: name
                                                                    
                                                                    	Name of the class\-map
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..65
                                                                    
                                                                    .. attribute:: type
                                                                    
                                                                    	Class\-Map Type QoS/PBR/Netflow/..
                                                                    	**type**\:  :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                                    
                                                                    .. attribute:: mode
                                                                    
                                                                    	Class\-Map Mode Match any/Match all
                                                                    	**type**\:  :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                    
                                                                    .. attribute:: description
                                                                    
                                                                    	description
                                                                    	**type**\: str
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg, self).__init__()

                                                                        self.yang_name = "class-map-bg"
                                                                        self.yang_parent_name = "clmp-p"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("match-infop", ("match_infop", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop))])
                                                                        self._leafs = OrderedDict([
                                                                            ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapTypeEn', '')])),
                                                                            ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapModeEn', '')])),
                                                                            ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                        ])
                                                                        self.name = None
                                                                        self.type = None
                                                                        self.mode = None
                                                                        self.description = None

                                                                        self.match_infop = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop()
                                                                        self.match_infop.parent = self
                                                                        self._children_name_map["match_infop"] = "match-infop"
                                                                        self._segment_path = lambda: "class-map-bg"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg, ['name', 'type', 'mode', 'description'], name, value)


                                                                    class MatchInfop(Entity):
                                                                        """
                                                                        Pointer to the first Match info
                                                                        
                                                                        .. attribute:: class_match_info_st
                                                                        
                                                                        	class match info st
                                                                        	**type**\: list of  		 :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop, self).__init__()

                                                                            self.yang_name = "match-infop"
                                                                            self.yang_parent_name = "class-map-bg"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("class-match-info-st", ("class_match_info_st", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt))])
                                                                            self._leafs = OrderedDict()

                                                                            self.class_match_info_st = YList(self)
                                                                            self._segment_path = lambda: "match-infop"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop, [], name, value)


                                                                        class ClassMatchInfoSt(Entity):
                                                                            """
                                                                            class match info st
                                                                            
                                                                            .. attribute:: match_data
                                                                            
                                                                            	Match criteria
                                                                            	**type**\:  :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                            
                                                                            .. attribute:: flags
                                                                            
                                                                            	Flags
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                self.yang_name = "class-match-info-st"
                                                                                self.yang_parent_name = "match-infop"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("match-data", ("match_data", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                ])
                                                                                self.flags = None

                                                                                self.match_data = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                self.match_data.parent = self
                                                                                self._children_name_map["match_data"] = "match-data"
                                                                                self._segment_path = lambda: "class-match-info-st"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                            class MatchData(Entity):
                                                                                """
                                                                                Match criteria
                                                                                
                                                                                .. attribute:: ipv4_dscp
                                                                                
                                                                                	IPv4 DSCP
                                                                                	**type**\:  :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                
                                                                                .. attribute:: ipv6_dscp
                                                                                
                                                                                	IPv6 DSCP
                                                                                	**type**\:  :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                
                                                                                .. attribute:: dscp
                                                                                
                                                                                	Match DSCP range array
                                                                                	**type**\:  :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                
                                                                                .. attribute:: ipv4_prec
                                                                                
                                                                                	IPv4 Precedence
                                                                                	**type**\:  :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                
                                                                                .. attribute:: ipv6_prec
                                                                                
                                                                                	IPv6 Precedence
                                                                                	**type**\:  :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                
                                                                                .. attribute:: prec
                                                                                
                                                                                	Match Precedence array
                                                                                	**type**\:  :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                
                                                                                .. attribute:: discard_class
                                                                                
                                                                                	Match Discard Class array
                                                                                	**type**\:  :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                
                                                                                .. attribute:: qos_group
                                                                                
                                                                                	Match QoS group array
                                                                                	**type**\:  :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                
                                                                                .. attribute:: traffic_class
                                                                                
                                                                                	Match Traffic class array
                                                                                	**type**\:  :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                
                                                                                .. attribute:: proto
                                                                                
                                                                                	Match Protocol array
                                                                                	**type**\:  :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                
                                                                                .. attribute:: icmp_v4
                                                                                
                                                                                	Match ICMPV4 Protocol
                                                                                	**type**\:  :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                
                                                                                .. attribute:: icmp_v6
                                                                                
                                                                                	Match ICMPV6 Protocol array
                                                                                	**type**\:  :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                
                                                                                .. attribute:: ipv4_packet_len
                                                                                
                                                                                	IPv4 packet length array
                                                                                	**type**\:  :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                
                                                                                .. attribute:: ipv6_packet_len
                                                                                
                                                                                	IPv6 packet length array
                                                                                	**type**\:  :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                
                                                                                .. attribute:: packet_len
                                                                                
                                                                                	Match packet length array
                                                                                	**type**\:  :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                
                                                                                .. attribute:: flow_tag
                                                                                
                                                                                	Match flow\-tag array
                                                                                	**type**\:  :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                
                                                                                .. attribute:: tcp_flag
                                                                                
                                                                                	Match tcp flag value
                                                                                	**type**\:  :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                
                                                                                .. attribute:: icmpv4_type
                                                                                
                                                                                	Match ipv4 icmp type
                                                                                	**type**\:  :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                
                                                                                .. attribute:: icmpv4_code
                                                                                
                                                                                	Match ipv4 icmp code
                                                                                	**type**\:  :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                
                                                                                .. attribute:: icmpv6_type
                                                                                
                                                                                	Match ipv6 icmp type
                                                                                	**type**\:  :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                
                                                                                .. attribute:: icmpv6_code
                                                                                
                                                                                	Match ipv6 icmp code
                                                                                	**type**\:  :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                
                                                                                .. attribute:: mpls_exp
                                                                                
                                                                                	Match MPLS experimental topmost array
                                                                                	**type**\:  :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                
                                                                                .. attribute:: mpls_exp_imp
                                                                                
                                                                                	Match MPLS experimental imposition array
                                                                                	**type**\:  :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                
                                                                                .. attribute:: mpls_disp_ipv4_acl
                                                                                
                                                                                	MPLS Disposition IPv4 Access\-list
                                                                                	**type**\:  :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                
                                                                                .. attribute:: mpls_disp_ipv6_acl
                                                                                
                                                                                	MPLS Disposition IPv6 Access\-list
                                                                                	**type**\:  :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                
                                                                                .. attribute:: mpls_top_label
                                                                                
                                                                                	MPLS Topmost LABEL
                                                                                	**type**\:  :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                
                                                                                .. attribute:: cos
                                                                                
                                                                                	Match CoS array
                                                                                	**type**\:  :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                
                                                                                .. attribute:: cos_inr
                                                                                
                                                                                	Match inner header CoS
                                                                                	**type**\:  :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                
                                                                                .. attribute:: dei
                                                                                
                                                                                	Match DEI Bit
                                                                                	**type**\:  :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                
                                                                                .. attribute:: dei_inr
                                                                                
                                                                                	Match inner DEI Bit
                                                                                	**type**\:  :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                
                                                                                .. attribute:: vlan
                                                                                
                                                                                	Match VLAN array
                                                                                	**type**\:  :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                
                                                                                .. attribute:: vlan_inr
                                                                                
                                                                                	Match inner header VLAN range array
                                                                                	**type**\:  :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                
                                                                                .. attribute:: fr_dlci
                                                                                
                                                                                	Match FR DLCI range array
                                                                                	**type**\:  :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                
                                                                                .. attribute:: src_mac
                                                                                
                                                                                	Match Source MAC address
                                                                                	**type**\:  :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                
                                                                                .. attribute:: dst_mac
                                                                                
                                                                                	Match Destination MAC address
                                                                                	**type**\:  :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                
                                                                                .. attribute:: atm_clp
                                                                                
                                                                                	Match ATM CLP level
                                                                                	**type**\:  :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                
                                                                                .. attribute:: fr_de
                                                                                
                                                                                	Match FR DE value
                                                                                	**type**\:  :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                
                                                                                .. attribute:: ipv4_acl
                                                                                
                                                                                	IPv4 Access\-list
                                                                                	**type**\:  :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                
                                                                                .. attribute:: ipv6_acl
                                                                                
                                                                                	IPv6 Access\-list
                                                                                	**type**\:  :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                
                                                                                .. attribute:: ether_service_acl
                                                                                
                                                                                	Ethernet\-Services Access\-list
                                                                                	**type**\:  :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                
                                                                                .. attribute:: avail_id
                                                                                
                                                                                	Available Identifiers
                                                                                	**type**\:  :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                
                                                                                .. attribute:: media_type
                                                                                
                                                                                	Media Type
                                                                                	**type**\:  :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                
                                                                                .. attribute:: subs_protocol
                                                                                
                                                                                	Protocol
                                                                                	**type**\:  :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                
                                                                                .. attribute:: dnis
                                                                                
                                                                                	DNIS
                                                                                	**type**\:  :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                
                                                                                .. attribute:: dnis_regex
                                                                                
                                                                                	DNIS Regular Expression
                                                                                	**type**\:  :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                
                                                                                .. attribute:: domain
                                                                                
                                                                                	Domain Name
                                                                                	**type**\:  :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                
                                                                                .. attribute:: domain_regex
                                                                                
                                                                                	Domain Regular Expression
                                                                                	**type**\:  :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                
                                                                                .. attribute:: nas_port
                                                                                
                                                                                	NAS Port
                                                                                	**type**\:  :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                
                                                                                .. attribute:: service_name
                                                                                
                                                                                	Service Name
                                                                                	**type**\:  :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                
                                                                                .. attribute:: service_name_regex
                                                                                
                                                                                	Service Name Regular Exp
                                                                                	**type**\:  :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                
                                                                                .. attribute:: src_addr_ipv4
                                                                                
                                                                                	Source Address IPV4
                                                                                	**type**\:  :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                
                                                                                .. attribute:: dst_addr_ipv4
                                                                                
                                                                                	Destination Address IPV4
                                                                                	**type**\:  :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                
                                                                                .. attribute:: src_addr_ipv6
                                                                                
                                                                                	Source Address IPV6
                                                                                	**type**\:  :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                
                                                                                .. attribute:: dst_addr_ipv6
                                                                                
                                                                                	Destination Address IPV6
                                                                                	**type**\:  :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                
                                                                                .. attribute:: src_addr_mac
                                                                                
                                                                                	Source Address MAC
                                                                                	**type**\:  :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                
                                                                                .. attribute:: timer
                                                                                
                                                                                	Timer
                                                                                	**type**\:  :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                
                                                                                .. attribute:: timer_regexp
                                                                                
                                                                                	Timer Regular Expression
                                                                                	**type**\:  :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                
                                                                                .. attribute:: tunnel_name
                                                                                
                                                                                	Tunnel Name
                                                                                	**type**\:  :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                
                                                                                .. attribute:: tunnel_name_regex
                                                                                
                                                                                	Tunnel Name Regular Expression
                                                                                	**type**\:  :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                
                                                                                .. attribute:: user_name
                                                                                
                                                                                	User Name
                                                                                	**type**\:  :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                
                                                                                .. attribute:: user_name_regex
                                                                                
                                                                                	User Name Regular Expression
                                                                                	**type**\:  :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                
                                                                                .. attribute:: auth_username
                                                                                
                                                                                	Authenticated User Name
                                                                                	**type**\:  :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                
                                                                                .. attribute:: auth_username_regex
                                                                                
                                                                                	Authenticated User Name RegEx
                                                                                	**type**\:  :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                
                                                                                .. attribute:: unauth_username
                                                                                
                                                                                	Unauthenticated User Name
                                                                                	**type**\:  :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                
                                                                                .. attribute:: unauth_username_regex
                                                                                
                                                                                	Unauthenticated User Name RegEx
                                                                                	**type**\:  :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                
                                                                                .. attribute:: auth_domain
                                                                                
                                                                                	Authenticated domain name
                                                                                	**type**\:  :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                
                                                                                .. attribute:: auth_domain_regex
                                                                                
                                                                                	Authenticated Domain Name RegEx
                                                                                	**type**\:  :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                
                                                                                .. attribute:: unauth_domain
                                                                                
                                                                                	Unauthenticated Domain Name
                                                                                	**type**\:  :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                
                                                                                .. attribute:: unauth_domain_regex
                                                                                
                                                                                	Unauthenticated Domain Name RegEx
                                                                                	**type**\:  :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                
                                                                                .. attribute:: vendor_id
                                                                                
                                                                                	Vendor ID
                                                                                	**type**\:  :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                
                                                                                .. attribute:: vendor_id_regex
                                                                                
                                                                                	Vendor ID RegEx
                                                                                	**type**\:  :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                
                                                                                .. attribute:: access_interface
                                                                                
                                                                                	Access interface
                                                                                	**type**\:  :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                
                                                                                .. attribute:: input_interface
                                                                                
                                                                                	Input interface
                                                                                	**type**\:  :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                
                                                                                .. attribute:: input_intfhdl
                                                                                
                                                                                	Input interface handle
                                                                                	**type**\:  :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                
                                                                                .. attribute:: ethertype
                                                                                
                                                                                	Ethernet type
                                                                                	**type**\:  :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                
                                                                                .. attribute:: flow_key_data
                                                                                
                                                                                	Flow key structure
                                                                                	**type**\:  :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                
                                                                                .. attribute:: dhcp_client_id
                                                                                
                                                                                	Dhcp Client ID
                                                                                	**type**\:  :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                
                                                                                .. attribute:: dhcp_client_id_regex
                                                                                
                                                                                	Dhcp Client ID RegEx
                                                                                	**type**\:  :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                
                                                                                .. attribute:: circuit_id
                                                                                
                                                                                	Circuit ID
                                                                                	**type**\:  :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                
                                                                                .. attribute:: circuit_id_regex
                                                                                
                                                                                	Circuit ID RegEx
                                                                                	**type**\:  :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                
                                                                                .. attribute:: remote_id
                                                                                
                                                                                	Remote ID
                                                                                	**type**\:  :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                
                                                                                .. attribute:: remote_id_regex
                                                                                
                                                                                	Remote ID RegEx
                                                                                	**type**\:  :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                
                                                                                .. attribute:: src_port
                                                                                
                                                                                	Source port
                                                                                	**type**\:  :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                
                                                                                .. attribute:: dst_port
                                                                                
                                                                                	Destination port
                                                                                	**type**\:  :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:  :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                
                                                                                .. attribute:: mpls_top_eos
                                                                                
                                                                                	MPLS Topmost EOS
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: fragment_type
                                                                                
                                                                                	Fragment type
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: authen_status
                                                                                
                                                                                	Authentication Status
                                                                                	**type**\:  :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                
                                                                                .. attribute:: mlp_negotiated
                                                                                
                                                                                	MLP Negotiated
                                                                                	**type**\:  :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                    self.yang_name = "match-data"
                                                                                    self.yang_parent_name = "class-match-info-st"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("ipv4-dscp", ("ipv4_dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp)), ("ipv6-dscp", ("ipv6_dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp)), ("dscp", ("dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp)), ("ipv4-prec", ("ipv4_prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec)), ("ipv6-prec", ("ipv6_prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec)), ("prec", ("prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec)), ("discard-class", ("discard_class", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass)), ("qos-group", ("qos_group", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup)), ("traffic-class", ("traffic_class", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass)), ("proto", ("proto", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto)), ("icmp-v4", ("icmp_v4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4)), ("icmp-v6", ("icmp_v6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6)), ("ipv4-packet-len", ("ipv4_packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen)), ("ipv6-packet-len", ("ipv6_packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen)), ("packet-len", ("packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen)), ("flow-tag", ("flow_tag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag)), ("tcp-flag", ("tcp_flag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag)), ("icmpv4-type", ("icmpv4_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type)), ("icmpv4-code", ("icmpv4_code", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code)), ("icmpv6-type", ("icmpv6_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type)), ("icmpv6-code", ("icmpv6_code", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code)), ("mpls-exp", ("mpls_exp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp)), ("mpls-exp-imp", ("mpls_exp_imp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp)), ("mpls-disp-ipv4-acl", ("mpls_disp_ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl)), ("mpls-disp-ipv6-acl", ("mpls_disp_ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl)), ("mpls-top-label", ("mpls_top_label", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel)), ("cos", ("cos", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos)), ("cos-inr", ("cos_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr)), ("dei", ("dei", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei)), ("dei-inr", ("dei_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr)), ("vlan", ("vlan", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan)), ("vlan-inr", ("vlan_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)), ("fr-dlci", ("fr_dlci", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci)), ("src-mac", ("src_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac)), ("dst-mac", ("dst_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac)), ("atm-clp", ("atm_clp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp)), ("fr-de", ("fr_de", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe)), ("ipv4-acl", ("ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl)), ("ipv6-acl", ("ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl)), ("ether-service-acl", ("ether_service_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl)), ("avail-id", ("avail_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId)), ("media-type", ("media_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType)), ("subs-protocol", ("subs_protocol", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol)), ("dnis", ("dnis", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis)), ("dnis-regex", ("dnis_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex)), ("domain", ("domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain)), ("domain-regex", ("domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex)), ("nas-port", ("nas_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort)), ("service-name", ("service_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName)), ("service-name-regex", ("service_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex)), ("src-addr-ipv4", ("src_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4)), ("dst-addr-ipv4", ("dst_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4)), ("src-addr-ipv6", ("src_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6)), ("dst-addr-ipv6", ("dst_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6)), ("src-addr-mac", ("src_addr_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac)), ("timer", ("timer", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer)), ("timer-regexp", ("timer_regexp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp)), ("tunnel-name", ("tunnel_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName)), ("tunnel-name-regex", ("tunnel_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex)), ("user-name", ("user_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName)), ("user-name-regex", ("user_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex)), ("auth-username", ("auth_username", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername)), ("auth-username-regex", ("auth_username_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex)), ("unauth-username", ("unauth_username", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername)), ("unauth-username-regex", ("unauth_username_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex)), ("auth-domain", ("auth_domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain)), ("auth-domain-regex", ("auth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex)), ("unauth-domain", ("unauth_domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain)), ("unauth-domain-regex", ("unauth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex)), ("vendor-id", ("vendor_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId)), ("vendor-id-regex", ("vendor_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex)), ("access-interface", ("access_interface", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface)), ("input-interface", ("input_interface", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface)), ("input-intfhdl", ("input_intfhdl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl)), ("ethertype", ("ethertype", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype)), ("flow-key-data", ("flow_key_data", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData)), ("dhcp-client-id", ("dhcp_client_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId)), ("dhcp-client-id-regex", ("dhcp_client_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex)), ("circuit-id", ("circuit_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId)), ("circuit-id-regex", ("circuit_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex)), ("remote-id", ("remote_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId)), ("remote-id-regex", ("remote_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex)), ("src-port", ("src_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort)), ("dst-port", ("dst_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchTypeEn', '')])),
                                                                                        ('mpls_top_eos', (YLeaf(YType.uint8, 'mpls-top-eos'), ['int'])),
                                                                                        ('fragment_type', (YLeaf(YType.uint8, 'fragment-type'), ['int'])),
                                                                                        ('authen_status', (YLeaf(YType.enumeration, 'authen-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchAuthenStatusEn', '')])),
                                                                                        ('mlp_negotiated', (YLeaf(YType.enumeration, 'mlp-negotiated'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchMlpNegotiatedEn', '')])),
                                                                                    ])
                                                                                    self.type = None
                                                                                    self.mpls_top_eos = None
                                                                                    self.fragment_type = None
                                                                                    self.authen_status = None
                                                                                    self.mlp_negotiated = None

                                                                                    self.ipv4_dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                    self.ipv4_dscp.parent = self
                                                                                    self._children_name_map["ipv4_dscp"] = "ipv4-dscp"

                                                                                    self.ipv6_dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                    self.ipv6_dscp.parent = self
                                                                                    self._children_name_map["ipv6_dscp"] = "ipv6-dscp"

                                                                                    self.dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                    self.dscp.parent = self
                                                                                    self._children_name_map["dscp"] = "dscp"

                                                                                    self.ipv4_prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                    self.ipv4_prec.parent = self
                                                                                    self._children_name_map["ipv4_prec"] = "ipv4-prec"

                                                                                    self.ipv6_prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                    self.ipv6_prec.parent = self
                                                                                    self._children_name_map["ipv6_prec"] = "ipv6-prec"

                                                                                    self.prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                    self.prec.parent = self
                                                                                    self._children_name_map["prec"] = "prec"

                                                                                    self.discard_class = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                    self.discard_class.parent = self
                                                                                    self._children_name_map["discard_class"] = "discard-class"

                                                                                    self.qos_group = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                    self.qos_group.parent = self
                                                                                    self._children_name_map["qos_group"] = "qos-group"

                                                                                    self.traffic_class = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                    self.traffic_class.parent = self
                                                                                    self._children_name_map["traffic_class"] = "traffic-class"

                                                                                    self.proto = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                    self.proto.parent = self
                                                                                    self._children_name_map["proto"] = "proto"

                                                                                    self.icmp_v4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                    self.icmp_v4.parent = self
                                                                                    self._children_name_map["icmp_v4"] = "icmp-v4"

                                                                                    self.icmp_v6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                    self.icmp_v6.parent = self
                                                                                    self._children_name_map["icmp_v6"] = "icmp-v6"

                                                                                    self.ipv4_packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                    self.ipv4_packet_len.parent = self
                                                                                    self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"

                                                                                    self.ipv6_packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                    self.ipv6_packet_len.parent = self
                                                                                    self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"

                                                                                    self.packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                    self.packet_len.parent = self
                                                                                    self._children_name_map["packet_len"] = "packet-len"

                                                                                    self.flow_tag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                    self.flow_tag.parent = self
                                                                                    self._children_name_map["flow_tag"] = "flow-tag"

                                                                                    self.tcp_flag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                    self.tcp_flag.parent = self
                                                                                    self._children_name_map["tcp_flag"] = "tcp-flag"

                                                                                    self.icmpv4_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                    self.icmpv4_type.parent = self
                                                                                    self._children_name_map["icmpv4_type"] = "icmpv4-type"

                                                                                    self.icmpv4_code = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                    self.icmpv4_code.parent = self
                                                                                    self._children_name_map["icmpv4_code"] = "icmpv4-code"

                                                                                    self.icmpv6_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                    self.icmpv6_type.parent = self
                                                                                    self._children_name_map["icmpv6_type"] = "icmpv6-type"

                                                                                    self.icmpv6_code = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                    self.icmpv6_code.parent = self
                                                                                    self._children_name_map["icmpv6_code"] = "icmpv6-code"

                                                                                    self.mpls_exp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                    self.mpls_exp.parent = self
                                                                                    self._children_name_map["mpls_exp"] = "mpls-exp"

                                                                                    self.mpls_exp_imp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                    self.mpls_exp_imp.parent = self
                                                                                    self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"

                                                                                    self.mpls_disp_ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                    self.mpls_disp_ipv4_acl.parent = self
                                                                                    self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"

                                                                                    self.mpls_disp_ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                    self.mpls_disp_ipv6_acl.parent = self
                                                                                    self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"

                                                                                    self.mpls_top_label = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                    self.mpls_top_label.parent = self
                                                                                    self._children_name_map["mpls_top_label"] = "mpls-top-label"

                                                                                    self.cos = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                    self.cos.parent = self
                                                                                    self._children_name_map["cos"] = "cos"

                                                                                    self.cos_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                    self.cos_inr.parent = self
                                                                                    self._children_name_map["cos_inr"] = "cos-inr"

                                                                                    self.dei = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                    self.dei.parent = self
                                                                                    self._children_name_map["dei"] = "dei"

                                                                                    self.dei_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                    self.dei_inr.parent = self
                                                                                    self._children_name_map["dei_inr"] = "dei-inr"

                                                                                    self.vlan = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                    self.vlan.parent = self
                                                                                    self._children_name_map["vlan"] = "vlan"

                                                                                    self.vlan_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                    self.vlan_inr.parent = self
                                                                                    self._children_name_map["vlan_inr"] = "vlan-inr"

                                                                                    self.fr_dlci = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                    self.fr_dlci.parent = self
                                                                                    self._children_name_map["fr_dlci"] = "fr-dlci"

                                                                                    self.src_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                    self.src_mac.parent = self
                                                                                    self._children_name_map["src_mac"] = "src-mac"

                                                                                    self.dst_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                    self.dst_mac.parent = self
                                                                                    self._children_name_map["dst_mac"] = "dst-mac"

                                                                                    self.atm_clp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                    self.atm_clp.parent = self
                                                                                    self._children_name_map["atm_clp"] = "atm-clp"

                                                                                    self.fr_de = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                    self.fr_de.parent = self
                                                                                    self._children_name_map["fr_de"] = "fr-de"

                                                                                    self.ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                    self.ipv4_acl.parent = self
                                                                                    self._children_name_map["ipv4_acl"] = "ipv4-acl"

                                                                                    self.ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                    self.ipv6_acl.parent = self
                                                                                    self._children_name_map["ipv6_acl"] = "ipv6-acl"

                                                                                    self.ether_service_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                    self.ether_service_acl.parent = self
                                                                                    self._children_name_map["ether_service_acl"] = "ether-service-acl"

                                                                                    self.avail_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                    self.avail_id.parent = self
                                                                                    self._children_name_map["avail_id"] = "avail-id"

                                                                                    self.media_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                    self.media_type.parent = self
                                                                                    self._children_name_map["media_type"] = "media-type"

                                                                                    self.subs_protocol = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                    self.subs_protocol.parent = self
                                                                                    self._children_name_map["subs_protocol"] = "subs-protocol"

                                                                                    self.dnis = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                    self.dnis.parent = self
                                                                                    self._children_name_map["dnis"] = "dnis"

                                                                                    self.dnis_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                    self.dnis_regex.parent = self
                                                                                    self._children_name_map["dnis_regex"] = "dnis-regex"

                                                                                    self.domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                    self.domain.parent = self
                                                                                    self._children_name_map["domain"] = "domain"

                                                                                    self.domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                    self.domain_regex.parent = self
                                                                                    self._children_name_map["domain_regex"] = "domain-regex"

                                                                                    self.nas_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                    self.nas_port.parent = self
                                                                                    self._children_name_map["nas_port"] = "nas-port"

                                                                                    self.service_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                    self.service_name.parent = self
                                                                                    self._children_name_map["service_name"] = "service-name"

                                                                                    self.service_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                    self.service_name_regex.parent = self
                                                                                    self._children_name_map["service_name_regex"] = "service-name-regex"

                                                                                    self.src_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                    self.src_addr_ipv4.parent = self
                                                                                    self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"

                                                                                    self.dst_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                    self.dst_addr_ipv4.parent = self
                                                                                    self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"

                                                                                    self.src_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                    self.src_addr_ipv6.parent = self
                                                                                    self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"

                                                                                    self.dst_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                    self.dst_addr_ipv6.parent = self
                                                                                    self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"

                                                                                    self.src_addr_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                    self.src_addr_mac.parent = self
                                                                                    self._children_name_map["src_addr_mac"] = "src-addr-mac"

                                                                                    self.timer = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                    self.timer.parent = self
                                                                                    self._children_name_map["timer"] = "timer"

                                                                                    self.timer_regexp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                    self.timer_regexp.parent = self
                                                                                    self._children_name_map["timer_regexp"] = "timer-regexp"

                                                                                    self.tunnel_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                    self.tunnel_name.parent = self
                                                                                    self._children_name_map["tunnel_name"] = "tunnel-name"

                                                                                    self.tunnel_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                    self.tunnel_name_regex.parent = self
                                                                                    self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"

                                                                                    self.user_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                    self.user_name.parent = self
                                                                                    self._children_name_map["user_name"] = "user-name"

                                                                                    self.user_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                    self.user_name_regex.parent = self
                                                                                    self._children_name_map["user_name_regex"] = "user-name-regex"

                                                                                    self.auth_username = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                    self.auth_username.parent = self
                                                                                    self._children_name_map["auth_username"] = "auth-username"

                                                                                    self.auth_username_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                    self.auth_username_regex.parent = self
                                                                                    self._children_name_map["auth_username_regex"] = "auth-username-regex"

                                                                                    self.unauth_username = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                    self.unauth_username.parent = self
                                                                                    self._children_name_map["unauth_username"] = "unauth-username"

                                                                                    self.unauth_username_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                    self.unauth_username_regex.parent = self
                                                                                    self._children_name_map["unauth_username_regex"] = "unauth-username-regex"

                                                                                    self.auth_domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                    self.auth_domain.parent = self
                                                                                    self._children_name_map["auth_domain"] = "auth-domain"

                                                                                    self.auth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                    self.auth_domain_regex.parent = self
                                                                                    self._children_name_map["auth_domain_regex"] = "auth-domain-regex"

                                                                                    self.unauth_domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                    self.unauth_domain.parent = self
                                                                                    self._children_name_map["unauth_domain"] = "unauth-domain"

                                                                                    self.unauth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                    self.unauth_domain_regex.parent = self
                                                                                    self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"

                                                                                    self.vendor_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                    self.vendor_id.parent = self
                                                                                    self._children_name_map["vendor_id"] = "vendor-id"

                                                                                    self.vendor_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                    self.vendor_id_regex.parent = self
                                                                                    self._children_name_map["vendor_id_regex"] = "vendor-id-regex"

                                                                                    self.access_interface = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                    self.access_interface.parent = self
                                                                                    self._children_name_map["access_interface"] = "access-interface"

                                                                                    self.input_interface = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                    self.input_interface.parent = self
                                                                                    self._children_name_map["input_interface"] = "input-interface"

                                                                                    self.input_intfhdl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                    self.input_intfhdl.parent = self
                                                                                    self._children_name_map["input_intfhdl"] = "input-intfhdl"

                                                                                    self.ethertype = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                    self.ethertype.parent = self
                                                                                    self._children_name_map["ethertype"] = "ethertype"

                                                                                    self.flow_key_data = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                    self.flow_key_data.parent = self
                                                                                    self._children_name_map["flow_key_data"] = "flow-key-data"

                                                                                    self.dhcp_client_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                    self.dhcp_client_id.parent = self
                                                                                    self._children_name_map["dhcp_client_id"] = "dhcp-client-id"

                                                                                    self.dhcp_client_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                    self.dhcp_client_id_regex.parent = self
                                                                                    self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"

                                                                                    self.circuit_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                    self.circuit_id.parent = self
                                                                                    self._children_name_map["circuit_id"] = "circuit-id"

                                                                                    self.circuit_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                    self.circuit_id_regex.parent = self
                                                                                    self._children_name_map["circuit_id_regex"] = "circuit-id-regex"

                                                                                    self.remote_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                    self.remote_id.parent = self
                                                                                    self._children_name_map["remote_id"] = "remote-id"

                                                                                    self.remote_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                    self.remote_id_regex.parent = self
                                                                                    self._children_name_map["remote_id_regex"] = "remote-id-regex"

                                                                                    self.src_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                    self.src_port.parent = self
                                                                                    self._children_name_map["src_port"] = "src-port"

                                                                                    self.dst_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                    self.dst_port.parent = self
                                                                                    self._children_name_map["dst_port"] = "dst-port"
                                                                                    self._segment_path = lambda: "match-data"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['type', 'mpls_top_eos', 'fragment_type', 'authen_status', 'mlp_negotiated'], name, value)


                                                                                class Ipv4Dscp(Entity):
                                                                                    """
                                                                                    IPv4 DSCP
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                        self.yang_name = "ipv4-dscp"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "ipv4-dscp"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "ipv4-dscp"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                class Ipv6Dscp(Entity):
                                                                                    """
                                                                                    IPv6 DSCP
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                        self.yang_name = "ipv6-dscp"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "ipv6-dscp"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "ipv6-dscp"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                class Dscp(Entity):
                                                                                    """
                                                                                    Match DSCP range array
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                        self.yang_name = "dscp"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "dscp"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "dscp"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                class Ipv4Prec(Entity):
                                                                                    """
                                                                                    IPv4 Precedence
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                        self.yang_name = "ipv4-prec"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                        ])
                                                                                        self.uint8_array = []
                                                                                        self._segment_path = lambda: "ipv4-prec"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                class Ipv6Prec(Entity):
                                                                                    """
                                                                                    IPv6 Precedence
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                        self.yang_name = "ipv6-prec"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                        ])
                                                                                        self.uint8_array = []
                                                                                        self._segment_path = lambda: "ipv6-prec"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                class Prec(Entity):
                                                                                    """
                                                                                    Match Precedence array
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                        self.yang_name = "prec"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                        ])
                                                                                        self.uint8_array = []
                                                                                        self._segment_path = lambda: "prec"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                class DiscardClass(Entity):
                                                                                    """
                                                                                    Match Discard Class array
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                        self.yang_name = "discard-class"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                        ])
                                                                                        self.uint8_array = []
                                                                                        self._segment_path = lambda: "discard-class"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                class QosGroup(Entity):
                                                                                    """
                                                                                    Match QoS group array
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                        self.yang_name = "qos-group"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "qos-group"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "qos-group"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['min', 'max'], name, value)


                                                                                class TrafficClass(Entity):
                                                                                    """
                                                                                    Match Traffic class array
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                        self.yang_name = "traffic-class"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "traffic-class"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "traffic-class"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['min', 'max'], name, value)


                                                                                class Proto(Entity):
                                                                                    """
                                                                                    Match Protocol array
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                        self.yang_name = "proto"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "proto"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "proto"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['min', 'max'], name, value)


                                                                                class IcmpV4(Entity):
                                                                                    """
                                                                                    Match ICMPV4 Protocol
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	Protocol type
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: code
                                                                                    
                                                                                    	Protocol code
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                        self.yang_name = "icmp-v4"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                            ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                        ])
                                                                                        self.type = None
                                                                                        self.code = None
                                                                                        self._segment_path = lambda: "icmp-v4"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['type', 'code'], name, value)


                                                                                class IcmpV6(Entity):
                                                                                    """
                                                                                    Match ICMPV6 Protocol array
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	Protocol type
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: code
                                                                                    
                                                                                    	Protocol code
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                        self.yang_name = "icmp-v6"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                            ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                        ])
                                                                                        self.type = None
                                                                                        self.code = None
                                                                                        self._segment_path = lambda: "icmp-v6"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['type', 'code'], name, value)


                                                                                class Ipv4PacketLen(Entity):
                                                                                    """
                                                                                    IPv4 packet length array
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                        self.yang_name = "ipv4-packet-len"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "ipv4-packet-len"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "ipv4-packet-len"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                class Ipv6PacketLen(Entity):
                                                                                    """
                                                                                    IPv6 packet length array
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                        self.yang_name = "ipv6-packet-len"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "ipv6-packet-len"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "ipv6-packet-len"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                class PacketLen(Entity):
                                                                                    """
                                                                                    Match packet length array
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                        self.yang_name = "packet-len"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "packet-len"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "packet-len"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                class FlowTag(Entity):
                                                                                    """
                                                                                    Match flow\-tag array
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                        self.yang_name = "flow-tag"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "flow-tag"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "flow-tag"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['min', 'max'], name, value)


                                                                                class TcpFlag(Entity):
                                                                                    """
                                                                                    Match tcp flag value
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	Value of TCP flag
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: match_any
                                                                                    
                                                                                    	Match any TCP flag bit
                                                                                    	**type**\: bool
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                        self.yang_name = "tcp-flag"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                            ('match_any', (YLeaf(YType.boolean, 'match-any'), ['bool'])),
                                                                                        ])
                                                                                        self.value = None
                                                                                        self.match_any = None
                                                                                        self._segment_path = lambda: "tcp-flag"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['value', 'match_any'], name, value)


                                                                                class Icmpv4Type(Entity):
                                                                                    """
                                                                                    Match ipv4 icmp type
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                        self.yang_name = "icmpv4-type"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "icmpv4-type"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "icmpv4-type"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                class Icmpv4Code(Entity):
                                                                                    """
                                                                                    Match ipv4 icmp code
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                        self.yang_name = "icmpv4-code"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "icmpv4-code"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "icmpv4-code"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                class Icmpv6Type(Entity):
                                                                                    """
                                                                                    Match ipv6 icmp type
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                        self.yang_name = "icmpv6-type"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "icmpv6-type"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "icmpv6-type"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                class Icmpv6Code(Entity):
                                                                                    """
                                                                                    Match ipv6 icmp code
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                        self.yang_name = "icmpv6-code"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "icmpv6-code"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "icmpv6-code"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                class MplsExp(Entity):
                                                                                    """
                                                                                    Match MPLS experimental topmost array
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                        self.yang_name = "mpls-exp"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                        ])
                                                                                        self.uint8_array = []
                                                                                        self._segment_path = lambda: "mpls-exp"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                class MplsExpImp(Entity):
                                                                                    """
                                                                                    Match MPLS experimental imposition array
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                        self.yang_name = "mpls-exp-imp"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                        ])
                                                                                        self.uint8_array = []
                                                                                        self._segment_path = lambda: "mpls-exp-imp"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                class MplsDispIpv4Acl(Entity):
                                                                                    """
                                                                                    MPLS Disposition IPv4 Access\-list
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                        self.yang_name = "mpls-disp-ipv4-acl"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "mpls-disp-ipv4-acl"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                class MplsDispIpv6Acl(Entity):
                                                                                    """
                                                                                    MPLS Disposition IPv6 Access\-list
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                        self.yang_name = "mpls-disp-ipv6-acl"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "mpls-disp-ipv6-acl"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                class MplsTopLabel(Entity):
                                                                                    """
                                                                                    MPLS Topmost LABEL
                                                                                    
                                                                                    .. attribute:: uint32_rng_array
                                                                                    
                                                                                    	uint32 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                        self.yang_name = "mpls-top-label"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint32_rng_array", ("uint32_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint32_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "mpls-top-label"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                    class Uint32RngArray(Entity):
                                                                                        """
                                                                                        uint32 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                            self.yang_name = "uint32_rng_array"
                                                                                            self.yang_parent_name = "mpls-top-label"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint32, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint32, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint32_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['min', 'max'], name, value)


                                                                                class Cos(Entity):
                                                                                    """
                                                                                    Match CoS array
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                        self.yang_name = "cos"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                        ])
                                                                                        self.uint8_array = []
                                                                                        self._segment_path = lambda: "cos"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                class CosInr(Entity):
                                                                                    """
                                                                                    Match inner header CoS
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                        self.yang_name = "cos-inr"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                        ])
                                                                                        self.uint8_array = []
                                                                                        self._segment_path = lambda: "cos-inr"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                class Dei(Entity):
                                                                                    """
                                                                                    Match DEI Bit
                                                                                    
                                                                                    .. attribute:: bit_value
                                                                                    
                                                                                    	Value of the DEI bit
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                        self.yang_name = "dei"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                        ])
                                                                                        self.bit_value = None
                                                                                        self._segment_path = lambda: "dei"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                class DeiInr(Entity):
                                                                                    """
                                                                                    Match inner DEI Bit
                                                                                    
                                                                                    .. attribute:: bit_value
                                                                                    
                                                                                    	Value of the DEI bit
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                        self.yang_name = "dei-inr"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                        ])
                                                                                        self.bit_value = None
                                                                                        self._segment_path = lambda: "dei-inr"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                class Vlan(Entity):
                                                                                    """
                                                                                    Match VLAN array
                                                                                    
                                                                                    .. attribute:: vlan_id_array
                                                                                    
                                                                                    	vlan id array
                                                                                    	**type**\: list of  		 :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                        self.yang_name = "vlan"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("vlan-id-array", ("vlan_id_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.vlan_id_array = YList(self)
                                                                                        self._segment_path = lambda: "vlan"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                    class VlanIdArray(Entity):
                                                                                        """
                                                                                        vlan id array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: mask
                                                                                        
                                                                                        	VLAN mask
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                            self.yang_name = "vlan-id-array"
                                                                                            self.yang_parent_name = "vlan"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                ('mask', (YLeaf(YType.uint16, 'mask'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self.mask = None
                                                                                            self._segment_path = lambda: "vlan-id-array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['min', 'max', 'mask'], name, value)


                                                                                class VlanInr(Entity):
                                                                                    """
                                                                                    Match inner header VLAN range array
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                        self.yang_name = "vlan-inr"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "vlan-inr"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "vlan-inr"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['min', 'max'], name, value)


                                                                                class FrDlci(Entity):
                                                                                    """
                                                                                    Match FR DLCI range array
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                        self.yang_name = "fr-dlci"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "fr-dlci"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "fr-dlci"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['min', 'max'], name, value)


                                                                                class SrcMac(Entity):
                                                                                    """
                                                                                    Match Source MAC address
                                                                                    
                                                                                    .. attribute:: mac_addr
                                                                                    
                                                                                    	MAC address
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	MAC mask
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                        self.yang_name = "src-mac"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                            ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                        ])
                                                                                        self.mac_addr = []
                                                                                        self.mask = []
                                                                                        self._segment_path = lambda: "src-mac"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                class DstMac(Entity):
                                                                                    """
                                                                                    Match Destination MAC address
                                                                                    
                                                                                    .. attribute:: mac_addr
                                                                                    
                                                                                    	MAC address
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	MAC mask
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                        self.yang_name = "dst-mac"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                            ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                        ])
                                                                                        self.mac_addr = []
                                                                                        self.mask = []
                                                                                        self._segment_path = lambda: "dst-mac"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                class AtmClp(Entity):
                                                                                    """
                                                                                    Match ATM CLP level
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                        self.yang_name = "atm-clp"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                        ])
                                                                                        self.uint8_array = []
                                                                                        self._segment_path = lambda: "atm-clp"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                class FrDe(Entity):
                                                                                    """
                                                                                    Match FR DE value
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                        self.yang_name = "fr-de"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                        ])
                                                                                        self.uint8_array = []
                                                                                        self._segment_path = lambda: "fr-de"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                class Ipv4Acl(Entity):
                                                                                    """
                                                                                    IPv4 Access\-list
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                        self.yang_name = "ipv4-acl"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "ipv4-acl"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                class Ipv6Acl(Entity):
                                                                                    """
                                                                                    IPv6 Access\-list
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                        self.yang_name = "ipv6-acl"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "ipv6-acl"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                class EtherServiceAcl(Entity):
                                                                                    """
                                                                                    Ethernet\-Services Access\-list
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                        self.yang_name = "ether-service-acl"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "ether-service-acl"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                class AvailId(Entity):
                                                                                    """
                                                                                    Available Identifiers
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                        self.yang_name = "avail-id"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                        ])
                                                                                        self.uint8_array = []
                                                                                        self._segment_path = lambda: "avail-id"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                class MediaType(Entity):
                                                                                    """
                                                                                    Media Type
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                        self.yang_name = "media-type"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                        ])
                                                                                        self.uint8_array = []
                                                                                        self._segment_path = lambda: "media-type"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                class SubsProtocol(Entity):
                                                                                    """
                                                                                    Protocol
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                        self.yang_name = "subs-protocol"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                        ])
                                                                                        self.uint8_array = []
                                                                                        self._segment_path = lambda: "subs-protocol"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                class Dnis(Entity):
                                                                                    """
                                                                                    DNIS
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                        self.yang_name = "dnis"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "dnis"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                class DnisRegex(Entity):
                                                                                    """
                                                                                    DNIS Regular Expression
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                        self.yang_name = "dnis-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "dnis-regex"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                class Domain(Entity):
                                                                                    """
                                                                                    Domain Name
                                                                                    
                                                                                    .. attribute:: domain_array
                                                                                    
                                                                                    	domain array
                                                                                    	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                        self.yang_name = "domain"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.domain_array = YList(self)
                                                                                        self._segment_path = lambda: "domain"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                    class DomainArray(Entity):
                                                                                        """
                                                                                        domain array
                                                                                        
                                                                                        .. attribute:: domain_name
                                                                                        
                                                                                        	domain name
                                                                                        	**type**\: str
                                                                                        
                                                                                        .. attribute:: format_name
                                                                                        
                                                                                        	format name
                                                                                        	**type**\: str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                            self.yang_name = "domain-array"
                                                                                            self.yang_parent_name = "domain"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                            ])
                                                                                            self.domain_name = None
                                                                                            self.format_name = None
                                                                                            self._segment_path = lambda: "domain-array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                class DomainRegex(Entity):
                                                                                    """
                                                                                    Domain Regular Expression
                                                                                    
                                                                                    .. attribute:: domain_array
                                                                                    
                                                                                    	domain array
                                                                                    	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                        self.yang_name = "domain-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.domain_array = YList(self)
                                                                                        self._segment_path = lambda: "domain-regex"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                    class DomainArray(Entity):
                                                                                        """
                                                                                        domain array
                                                                                        
                                                                                        .. attribute:: domain_name
                                                                                        
                                                                                        	domain name
                                                                                        	**type**\: str
                                                                                        
                                                                                        .. attribute:: format_name
                                                                                        
                                                                                        	format name
                                                                                        	**type**\: str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                            self.yang_name = "domain-array"
                                                                                            self.yang_parent_name = "domain-regex"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                            ])
                                                                                            self.domain_name = None
                                                                                            self.format_name = None
                                                                                            self._segment_path = lambda: "domain-array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                class NasPort(Entity):
                                                                                    """
                                                                                    NAS Port
                                                                                    
                                                                                    .. attribute:: nas_port_array
                                                                                    
                                                                                    	nas port array
                                                                                    	**type**\: list of  		 :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                        self.yang_name = "nas-port"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("nas-port-array", ("nas_port_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.nas_port_array = YList(self)
                                                                                        self._segment_path = lambda: "nas-port"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                    class NasPortArray(Entity):
                                                                                        """
                                                                                        nas port array
                                                                                        
                                                                                        .. attribute:: sub_id
                                                                                        
                                                                                        	sub id
                                                                                        	**type**\:  :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                        
                                                                                        .. attribute:: operator
                                                                                        
                                                                                        	operator
                                                                                        	**type**\:  :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                        
                                                                                        .. attribute:: value
                                                                                        
                                                                                        	value
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                            self.yang_name = "nas-port-array"
                                                                                            self.yang_parent_name = "nas-port"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('sub_id', (YLeaf(YType.enumeration, 'sub-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchNasPortSubIdEn', '')])),
                                                                                                ('operator', (YLeaf(YType.enumeration, 'operator'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchLogicalOperatorEn', '')])),
                                                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                            ])
                                                                                            self.sub_id = None
                                                                                            self.operator = None
                                                                                            self.value = None
                                                                                            self._segment_path = lambda: "nas-port-array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['sub_id', 'operator', 'value'], name, value)


                                                                                class ServiceName(Entity):
                                                                                    """
                                                                                    Service Name
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                        self.yang_name = "service-name"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "service-name"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                class ServiceNameRegex(Entity):
                                                                                    """
                                                                                    Service Name Regular Exp
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                        self.yang_name = "service-name-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "service-name-regex"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                class SrcAddrIpv4(Entity):
                                                                                    """
                                                                                    Source Address IPV4
                                                                                    
                                                                                    .. attribute:: ipv4_addr_array
                                                                                    
                                                                                    	ipv4 addr array
                                                                                    	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                        self.yang_name = "src-addr-ipv4"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.ipv4_addr_array = YList(self)
                                                                                        self._segment_path = lambda: "src-addr-ipv4"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                    class Ipv4AddrArray(Entity):
                                                                                        """
                                                                                        ipv4 addr array
                                                                                        
                                                                                        .. attribute:: prefix
                                                                                        
                                                                                        	prefix
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                        
                                                                                        .. attribute:: mask
                                                                                        
                                                                                        	mask
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                            self.yang_name = "ipv4-addr-array"
                                                                                            self.yang_parent_name = "src-addr-ipv4"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                            ])
                                                                                            self.prefix = None
                                                                                            self.mask = None
                                                                                            self._segment_path = lambda: "ipv4-addr-array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                class DstAddrIpv4(Entity):
                                                                                    """
                                                                                    Destination Address IPV4
                                                                                    
                                                                                    .. attribute:: ipv4_addr_array
                                                                                    
                                                                                    	ipv4 addr array
                                                                                    	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                        self.yang_name = "dst-addr-ipv4"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.ipv4_addr_array = YList(self)
                                                                                        self._segment_path = lambda: "dst-addr-ipv4"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                    class Ipv4AddrArray(Entity):
                                                                                        """
                                                                                        ipv4 addr array
                                                                                        
                                                                                        .. attribute:: prefix
                                                                                        
                                                                                        	prefix
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                        
                                                                                        .. attribute:: mask
                                                                                        
                                                                                        	mask
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                            self.yang_name = "ipv4-addr-array"
                                                                                            self.yang_parent_name = "dst-addr-ipv4"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                            ])
                                                                                            self.prefix = None
                                                                                            self.mask = None
                                                                                            self._segment_path = lambda: "ipv4-addr-array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                class SrcAddrIpv6(Entity):
                                                                                    """
                                                                                    Source Address IPV6
                                                                                    
                                                                                    .. attribute:: ipv6_addr_array
                                                                                    
                                                                                    	ipv6 addr array
                                                                                    	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                        self.yang_name = "src-addr-ipv6"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.ipv6_addr_array = YList(self)
                                                                                        self._segment_path = lambda: "src-addr-ipv6"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                    class Ipv6AddrArray(Entity):
                                                                                        """
                                                                                        ipv6 addr array
                                                                                        
                                                                                        .. attribute:: prefix
                                                                                        
                                                                                        	IPV6 prefix
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                        
                                                                                        .. attribute:: mask
                                                                                        
                                                                                        	IPV6 mask
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                            self.yang_name = "ipv6-addr-array"
                                                                                            self.yang_parent_name = "src-addr-ipv6"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                            ])
                                                                                            self.prefix = None
                                                                                            self.mask = None
                                                                                            self._segment_path = lambda: "ipv6-addr-array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                class DstAddrIpv6(Entity):
                                                                                    """
                                                                                    Destination Address IPV6
                                                                                    
                                                                                    .. attribute:: ipv6_addr_array
                                                                                    
                                                                                    	ipv6 addr array
                                                                                    	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                        self.yang_name = "dst-addr-ipv6"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.ipv6_addr_array = YList(self)
                                                                                        self._segment_path = lambda: "dst-addr-ipv6"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                    class Ipv6AddrArray(Entity):
                                                                                        """
                                                                                        ipv6 addr array
                                                                                        
                                                                                        .. attribute:: prefix
                                                                                        
                                                                                        	IPV6 prefix
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                        
                                                                                        .. attribute:: mask
                                                                                        
                                                                                        	IPV6 mask
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                            self.yang_name = "ipv6-addr-array"
                                                                                            self.yang_parent_name = "dst-addr-ipv6"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                            ])
                                                                                            self.prefix = None
                                                                                            self.mask = None
                                                                                            self._segment_path = lambda: "ipv6-addr-array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                class SrcAddrMac(Entity):
                                                                                    """
                                                                                    Source Address MAC
                                                                                    
                                                                                    .. attribute:: mac_addr_array
                                                                                    
                                                                                    	mac addr array
                                                                                    	**type**\: list of  		 :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                        self.yang_name = "src-addr-mac"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("mac-addr-array", ("mac_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.mac_addr_array = YList(self)
                                                                                        self._segment_path = lambda: "src-addr-mac"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                    class MacAddrArray(Entity):
                                                                                        """
                                                                                        mac addr array
                                                                                        
                                                                                        .. attribute:: mac_addr
                                                                                        
                                                                                        	MAC address
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: mask
                                                                                        
                                                                                        	MAC mask
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                            self.yang_name = "mac-addr-array"
                                                                                            self.yang_parent_name = "src-addr-mac"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                            ])
                                                                                            self.mac_addr = []
                                                                                            self.mask = []
                                                                                            self._segment_path = lambda: "mac-addr-array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                class Timer(Entity):
                                                                                    """
                                                                                    Timer
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                        self.yang_name = "timer"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "timer"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                class TimerRegexp(Entity):
                                                                                    """
                                                                                    Timer Regular Expression
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                        self.yang_name = "timer-regexp"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "timer-regexp"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                class TunnelName(Entity):
                                                                                    """
                                                                                    Tunnel Name
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                        self.yang_name = "tunnel-name"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "tunnel-name"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                class TunnelNameRegex(Entity):
                                                                                    """
                                                                                    Tunnel Name Regular Expression
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                        self.yang_name = "tunnel-name-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "tunnel-name-regex"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                class UserName(Entity):
                                                                                    """
                                                                                    User Name
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                        self.yang_name = "user-name"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "user-name"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                class UserNameRegex(Entity):
                                                                                    """
                                                                                    User Name Regular Expression
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                        self.yang_name = "user-name-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "user-name-regex"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                class AuthUsername(Entity):
                                                                                    """
                                                                                    Authenticated User Name
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                        self.yang_name = "auth-username"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "auth-username"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                class AuthUsernameRegex(Entity):
                                                                                    """
                                                                                    Authenticated User Name RegEx
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                        self.yang_name = "auth-username-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "auth-username-regex"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                class UnauthUsername(Entity):
                                                                                    """
                                                                                    Unauthenticated User Name
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                        self.yang_name = "unauth-username"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "unauth-username"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                class UnauthUsernameRegex(Entity):
                                                                                    """
                                                                                    Unauthenticated User Name RegEx
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                        self.yang_name = "unauth-username-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "unauth-username-regex"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                class AuthDomain(Entity):
                                                                                    """
                                                                                    Authenticated domain name
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                        self.yang_name = "auth-domain"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "auth-domain"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                class AuthDomainRegex(Entity):
                                                                                    """
                                                                                    Authenticated Domain Name RegEx
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                        self.yang_name = "auth-domain-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "auth-domain-regex"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                class UnauthDomain(Entity):
                                                                                    """
                                                                                    Unauthenticated Domain Name
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                        self.yang_name = "unauth-domain"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "unauth-domain"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                class UnauthDomainRegex(Entity):
                                                                                    """
                                                                                    Unauthenticated Domain Name RegEx
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                        self.yang_name = "unauth-domain-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "unauth-domain-regex"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                class VendorId(Entity):
                                                                                    """
                                                                                    Vendor ID
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                        self.yang_name = "vendor-id"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "vendor-id"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                class VendorIdRegex(Entity):
                                                                                    """
                                                                                    Vendor ID RegEx
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                        self.yang_name = "vendor-id-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "vendor-id-regex"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                class AccessInterface(Entity):
                                                                                    """
                                                                                    Access interface
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                        self.yang_name = "access-interface"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "access-interface"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                class InputInterface(Entity):
                                                                                    """
                                                                                    Input interface
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                        self.yang_name = "input-interface"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "input-interface"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                class InputIntfhdl(Entity):
                                                                                    """
                                                                                    Input interface handle
                                                                                    
                                                                                    .. attribute:: uint64_array
                                                                                    
                                                                                    	uint64 array
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..18446744073709551615
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                        self.yang_name = "input-intfhdl"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('uint64_array', (YLeafList(YType.uint64, 'uint64_array'), ['int'])),
                                                                                        ])
                                                                                        self.uint64_array = []
                                                                                        self._segment_path = lambda: "input-intfhdl"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                class Ethertype(Entity):
                                                                                    """
                                                                                    Ethernet type
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                        self.yang_name = "ethertype"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "ethertype"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "ethertype"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['min', 'max'], name, value)


                                                                                class FlowKeyData(Entity):
                                                                                    """
                                                                                    Flow key structure
                                                                                    
                                                                                    .. attribute:: flow_keys
                                                                                    
                                                                                    	flow keys
                                                                                    	**type**\:  :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                    
                                                                                    .. attribute:: max_count
                                                                                    
                                                                                    	Maximum count of flows
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: idle_timeout
                                                                                    
                                                                                    	Idle timeout of flows (in seconds)
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    	**units**\: second
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                        self.yang_name = "flow-key-data"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("flow-keys", ("flow_keys", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys))])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('max_count', (YLeaf(YType.uint16, 'max-count'), ['int'])),
                                                                                            ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                                        ])
                                                                                        self.max_count = None
                                                                                        self.idle_timeout = None

                                                                                        self.flow_keys = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                        self.flow_keys.parent = self
                                                                                        self._children_name_map["flow_keys"] = "flow-keys"
                                                                                        self._segment_path = lambda: "flow-key-data"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['max_count', 'idle_timeout'], name, value)


                                                                                    class FlowKeys(Entity):
                                                                                        """
                                                                                        flow keys
                                                                                        
                                                                                        .. attribute:: keys
                                                                                        
                                                                                        	keys
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                        
                                                                                        .. attribute:: num
                                                                                        
                                                                                        	num
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                            self.yang_name = "flow-keys"
                                                                                            self.yang_parent_name = "flow-key-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('keys', (YLeaf(YType.str, 'keys'), ['str'])),
                                                                                                ('num', (YLeaf(YType.uint8, 'num'), ['int'])),
                                                                                            ])
                                                                                            self.keys = None
                                                                                            self.num = None
                                                                                            self._segment_path = lambda: "flow-keys"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                class DhcpClientId(Entity):
                                                                                    """
                                                                                    Dhcp Client ID
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                        self.yang_name = "dhcp-client-id"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "dhcp-client-id"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                class DhcpClientIdRegex(Entity):
                                                                                    """
                                                                                    Dhcp Client ID RegEx
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                        self.yang_name = "dhcp-client-id-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "dhcp-client-id-regex"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                class CircuitId(Entity):
                                                                                    """
                                                                                    Circuit ID
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                        self.yang_name = "circuit-id"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "circuit-id"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                class CircuitIdRegex(Entity):
                                                                                    """
                                                                                    Circuit ID RegEx
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                        self.yang_name = "circuit-id-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "circuit-id-regex"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                class RemoteId(Entity):
                                                                                    """
                                                                                    Remote ID
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                        self.yang_name = "remote-id"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "remote-id"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                class RemoteIdRegex(Entity):
                                                                                    """
                                                                                    Remote ID RegEx
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                        self.yang_name = "remote-id-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "remote-id-regex"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                class SrcPort(Entity):
                                                                                    """
                                                                                    Source port
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                        self.yang_name = "src-port"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "src-port"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "src-port"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                                class DstPort(Entity):
                                                                                    """
                                                                                    Destination port
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                        self.yang_name = "dst-port"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "dst-port"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "dst-port"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['min', 'max'], name, value)


                                                            class ActInfop(Entity):
                                                                """
                                                                act infop
                                                                
                                                                .. attribute:: policy_action_info_st
                                                                
                                                                	policy action info st
                                                                	**type**\: list of  		 :py:class:`PolicyActionInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop, self).__init__()

                                                                    self.yang_name = "act-infop"
                                                                    self.yang_parent_name = "policy-class-info-bg"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("policy-action-info-st", ("policy_action_info_st", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt))])
                                                                    self._leafs = OrderedDict()

                                                                    self.policy_action_info_st = YList(self)
                                                                    self._segment_path = lambda: "act-infop"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop, [], name, value)


                                                                class PolicyActionInfoSt(Entity):
                                                                    """
                                                                    policy action info st
                                                                    
                                                                    .. attribute:: actp
                                                                    
                                                                    	actp
                                                                    	**type**\:  :py:class:`Actp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp>`
                                                                    
                                                                    .. attribute:: seq
                                                                    
                                                                    	seq
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..65535
                                                                    
                                                                    .. attribute:: flags
                                                                    
                                                                    	flags
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..65535
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt, self).__init__()

                                                                        self.yang_name = "policy-action-info-st"
                                                                        self.yang_parent_name = "act-infop"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("actp", ("actp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp))])
                                                                        self._leafs = OrderedDict([
                                                                            ('seq', (YLeaf(YType.uint16, 'seq'), ['int'])),
                                                                            ('flags', (YLeaf(YType.uint16, 'flags'), ['int'])),
                                                                        ])
                                                                        self.seq = None
                                                                        self.flags = None

                                                                        self.actp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp()
                                                                        self.actp.parent = self
                                                                        self._children_name_map["actp"] = "actp"
                                                                        self._segment_path = lambda: "policy-action-info-st"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt, ['seq', 'flags'], name, value)


                                                                    class Actp(Entity):
                                                                        """
                                                                        actp
                                                                        
                                                                        .. attribute:: mark
                                                                        
                                                                        	mark
                                                                        	**type**\:  :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark>`
                                                                        
                                                                        .. attribute:: mark2
                                                                        
                                                                        	mark2
                                                                        	**type**\:  :py:class:`Mark2 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2>`
                                                                        
                                                                        .. attribute:: wred
                                                                        
                                                                        	wred
                                                                        	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred>`
                                                                        
                                                                        .. attribute:: encap
                                                                        
                                                                        	encap
                                                                        	**type**\:  :py:class:`Encap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap>`
                                                                        
                                                                        .. attribute:: prio
                                                                        
                                                                        	prio
                                                                        	**type**\:  :py:class:`Prio <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio>`
                                                                        
                                                                        .. attribute:: bwrem
                                                                        
                                                                        	bwrem
                                                                        	**type**\:  :py:class:`Bwrem <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem>`
                                                                        
                                                                        .. attribute:: min_bw
                                                                        
                                                                        	min bw
                                                                        	**type**\:  :py:class:`MinBw <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw>`
                                                                        
                                                                        .. attribute:: authen_aaa
                                                                        
                                                                        	authen aaa
                                                                        	**type**\:  :py:class:`AuthenAaa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa>`
                                                                        
                                                                        .. attribute:: collect_id
                                                                        
                                                                        	collect id
                                                                        	**type**\:  :py:class:`CollectId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId>`
                                                                        
                                                                        .. attribute:: decode_id
                                                                        
                                                                        	decode id
                                                                        	**type**\:  :py:class:`DecodeId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId>`
                                                                        
                                                                        .. attribute:: set_timer
                                                                        
                                                                        	set timer
                                                                        	**type**\:  :py:class:`SetTimer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer>`
                                                                        
                                                                        .. attribute:: stop_timer
                                                                        
                                                                        	stop timer
                                                                        	**type**\:  :py:class:`StopTimer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer>`
                                                                        
                                                                        .. attribute:: acct_aaa_list
                                                                        
                                                                        	acct aaa list
                                                                        	**type**\:  :py:class:`AcctAaaList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList>`
                                                                        
                                                                        .. attribute:: query_ancp
                                                                        
                                                                        	query ancp
                                                                        	**type**\:  :py:class:`QueryAncp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp>`
                                                                        
                                                                        .. attribute:: prepaid_cfg
                                                                        
                                                                        	prepaid cfg
                                                                        	**type**\:  :py:class:`PrepaidCfg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg>`
                                                                        
                                                                        .. attribute:: timeout_idle
                                                                        
                                                                        	timeout idle
                                                                        	**type**\:  :py:class:`TimeoutIdle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle>`
                                                                        
                                                                        .. attribute:: proxy_aaa
                                                                        
                                                                        	proxy aaa
                                                                        	**type**\:  :py:class:`ProxyAaa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa>`
                                                                        
                                                                        .. attribute:: act_template
                                                                        
                                                                        	act template
                                                                        	**type**\:  :py:class:`ActTemplate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate>`
                                                                        
                                                                        .. attribute:: deact_template
                                                                        
                                                                        	deact template
                                                                        	**type**\:  :py:class:`DeactTemplate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate>`
                                                                        
                                                                        .. attribute:: qlimit
                                                                        
                                                                        	qlimit
                                                                        	**type**\:  :py:class:`Qlimit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit>`
                                                                        
                                                                        .. attribute:: accounting_event_aaa
                                                                        
                                                                        	accounting event aaa
                                                                        	**type**\:  :py:class:`AccountingEventAaa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa>`
                                                                        
                                                                        .. attribute:: authorize_id
                                                                        
                                                                        	authorize id
                                                                        	**type**\:  :py:class:`AuthorizeId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId>`
                                                                        
                                                                        .. attribute:: afm_react
                                                                        
                                                                        	afm react
                                                                        	**type**\:  :py:class:`AfmReact <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact>`
                                                                        
                                                                        .. attribute:: httpr
                                                                        
                                                                        	httpr
                                                                        	**type**\:  :py:class:`Httpr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr>`
                                                                        
                                                                        .. attribute:: punt
                                                                        
                                                                        	punt
                                                                        	**type**\:  :py:class:`Punt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt>`
                                                                        
                                                                        .. attribute:: copy
                                                                        
                                                                        	copy
                                                                        	**type**\:  :py:class:`Copy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy>`
                                                                        
                                                                        .. attribute:: sfrag
                                                                        
                                                                        	sfrag
                                                                        	**type**\:  :py:class:`Sfrag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag>`
                                                                        
                                                                        .. attribute:: redirect
                                                                        
                                                                        	redirect
                                                                        	**type**\:  :py:class:`Redirect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect>`
                                                                        
                                                                        .. attribute:: out_intf
                                                                        
                                                                        	out intf
                                                                        	**type**\:  :py:class:`OutIntf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf>`
                                                                        
                                                                        .. attribute:: serv_func
                                                                        
                                                                        	serv func
                                                                        	**type**\:  :py:class:`ServFunc <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc>`
                                                                        
                                                                        .. attribute:: police
                                                                        
                                                                        	police
                                                                        	**type**\:  :py:class:`Police <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police>`
                                                                        
                                                                        .. attribute:: shape
                                                                        
                                                                        	shape
                                                                        	**type**\:  :py:class:`Shape <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape>`
                                                                        
                                                                        .. attribute:: child_policy
                                                                        
                                                                        	child policy
                                                                        	**type**\:  :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy>`
                                                                        
                                                                        .. attribute:: cac
                                                                        
                                                                        	cac
                                                                        	**type**\:  :py:class:`Cac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac>`
                                                                        
                                                                        .. attribute:: pfc
                                                                        
                                                                        	pfc
                                                                        	**type**\:  :py:class:`Pfc <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc>`
                                                                        
                                                                        .. attribute:: flow_parm
                                                                        
                                                                        	flow parm
                                                                        	**type**\:  :py:class:`FlowParm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm>`
                                                                        
                                                                        .. attribute:: ipcbr
                                                                        
                                                                        	ipcbr
                                                                        	**type**\:  :py:class:`Ipcbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr>`
                                                                        
                                                                        .. attribute:: rtp
                                                                        
                                                                        	rtp
                                                                        	**type**\:  :py:class:`Rtp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp>`
                                                                        
                                                                        .. attribute:: rtp_mmr
                                                                        
                                                                        	rtp mmr
                                                                        	**type**\:  :py:class:`RtpMmr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr>`
                                                                        
                                                                        .. attribute:: rtp_j2k
                                                                        
                                                                        	rtp j2k
                                                                        	**type**\:  :py:class:`RtpJ2k <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k>`
                                                                        
                                                                        .. attribute:: rtp_voice
                                                                        
                                                                        	rtp voice
                                                                        	**type**\:  :py:class:`RtpVoice <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice>`
                                                                        
                                                                        .. attribute:: mdi
                                                                        
                                                                        	mdi
                                                                        	**type**\:  :py:class:`Mdi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi>`
                                                                        
                                                                        .. attribute:: mdi_rtp
                                                                        
                                                                        	mdi rtp
                                                                        	**type**\:  :py:class:`MdiRtp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp>`
                                                                        
                                                                        .. attribute:: fmm
                                                                        
                                                                        	fmm
                                                                        	**type**\:  :py:class:`Fmm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm>`
                                                                        
                                                                        .. attribute:: pbf
                                                                        
                                                                        	pbf
                                                                        	**type**\:  :py:class:`Pbf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf>`
                                                                        
                                                                        .. attribute:: ipv4_nh
                                                                        
                                                                        	ipv4 nh
                                                                        	**type**\:  :py:class:`Ipv4Nh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh>`
                                                                        
                                                                        .. attribute:: ipv6_nh
                                                                        
                                                                        	ipv6 nh
                                                                        	**type**\:  :py:class:`Ipv6Nh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh>`
                                                                        
                                                                        .. attribute:: type
                                                                        
                                                                        	type
                                                                        	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: data_p
                                                                        
                                                                        	data p
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp, self).__init__()

                                                                            self.yang_name = "actp"
                                                                            self.yang_parent_name = "policy-action-info-st"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("mark", ("mark", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark)), ("mark2", ("mark2", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2)), ("wred", ("wred", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred)), ("encap", ("encap", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap)), ("prio", ("prio", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio)), ("bwrem", ("bwrem", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem)), ("min-bw", ("min_bw", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw)), ("authen-aaa", ("authen_aaa", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa)), ("collect-id", ("collect_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId)), ("decode-id", ("decode_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId)), ("set-timer", ("set_timer", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer)), ("stop-timer", ("stop_timer", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer)), ("acct-aaa-list", ("acct_aaa_list", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList)), ("query-ancp", ("query_ancp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp)), ("prepaid-cfg", ("prepaid_cfg", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg)), ("timeout-idle", ("timeout_idle", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle)), ("proxy-aaa", ("proxy_aaa", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa)), ("act-template", ("act_template", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate)), ("deact-template", ("deact_template", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate)), ("qlimit", ("qlimit", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit)), ("accounting-event-aaa", ("accounting_event_aaa", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa)), ("authorize-id", ("authorize_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId)), ("afm-react", ("afm_react", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact)), ("httpr", ("httpr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr)), ("punt", ("punt", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt)), ("copy", ("copy", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy)), ("sfrag", ("sfrag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag)), ("redirect", ("redirect", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect)), ("out-intf", ("out_intf", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf)), ("serv-func", ("serv_func", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc)), ("police", ("police", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police)), ("shape", ("shape", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape)), ("child-policy", ("child_policy", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy)), ("cac", ("cac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac)), ("pfc", ("pfc", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc)), ("flow-parm", ("flow_parm", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm)), ("ipcbr", ("ipcbr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr)), ("rtp", ("rtp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp)), ("rtp-mmr", ("rtp_mmr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr)), ("rtp-j2k", ("rtp_j2k", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k)), ("rtp-voice", ("rtp_voice", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice)), ("mdi", ("mdi", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi)), ("mdi-rtp", ("mdi_rtp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp)), ("fmm", ("fmm", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm)), ("pbf", ("pbf", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf)), ("ipv4-nh", ("ipv4_nh", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh)), ("ipv6-nh", ("ipv6_nh", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh))])
                                                                            self._leafs = OrderedDict([
                                                                                ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                                ('data_p', (YLeaf(YType.uint32, 'data-p'), ['int'])),
                                                                            ])
                                                                            self.type = None
                                                                            self.data_p = None

                                                                            self.mark = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark()
                                                                            self.mark.parent = self
                                                                            self._children_name_map["mark"] = "mark"

                                                                            self.mark2 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2()
                                                                            self.mark2.parent = self
                                                                            self._children_name_map["mark2"] = "mark2"

                                                                            self.wred = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred()
                                                                            self.wred.parent = self
                                                                            self._children_name_map["wred"] = "wred"

                                                                            self.encap = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap()
                                                                            self.encap.parent = self
                                                                            self._children_name_map["encap"] = "encap"

                                                                            self.prio = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio()
                                                                            self.prio.parent = self
                                                                            self._children_name_map["prio"] = "prio"

                                                                            self.bwrem = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem()
                                                                            self.bwrem.parent = self
                                                                            self._children_name_map["bwrem"] = "bwrem"

                                                                            self.min_bw = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw()
                                                                            self.min_bw.parent = self
                                                                            self._children_name_map["min_bw"] = "min-bw"

                                                                            self.authen_aaa = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa()
                                                                            self.authen_aaa.parent = self
                                                                            self._children_name_map["authen_aaa"] = "authen-aaa"

                                                                            self.collect_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId()
                                                                            self.collect_id.parent = self
                                                                            self._children_name_map["collect_id"] = "collect-id"

                                                                            self.decode_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId()
                                                                            self.decode_id.parent = self
                                                                            self._children_name_map["decode_id"] = "decode-id"

                                                                            self.set_timer = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer()
                                                                            self.set_timer.parent = self
                                                                            self._children_name_map["set_timer"] = "set-timer"

                                                                            self.stop_timer = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer()
                                                                            self.stop_timer.parent = self
                                                                            self._children_name_map["stop_timer"] = "stop-timer"

                                                                            self.acct_aaa_list = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList()
                                                                            self.acct_aaa_list.parent = self
                                                                            self._children_name_map["acct_aaa_list"] = "acct-aaa-list"

                                                                            self.query_ancp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp()
                                                                            self.query_ancp.parent = self
                                                                            self._children_name_map["query_ancp"] = "query-ancp"

                                                                            self.prepaid_cfg = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg()
                                                                            self.prepaid_cfg.parent = self
                                                                            self._children_name_map["prepaid_cfg"] = "prepaid-cfg"

                                                                            self.timeout_idle = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle()
                                                                            self.timeout_idle.parent = self
                                                                            self._children_name_map["timeout_idle"] = "timeout-idle"

                                                                            self.proxy_aaa = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa()
                                                                            self.proxy_aaa.parent = self
                                                                            self._children_name_map["proxy_aaa"] = "proxy-aaa"

                                                                            self.act_template = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate()
                                                                            self.act_template.parent = self
                                                                            self._children_name_map["act_template"] = "act-template"

                                                                            self.deact_template = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate()
                                                                            self.deact_template.parent = self
                                                                            self._children_name_map["deact_template"] = "deact-template"

                                                                            self.qlimit = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit()
                                                                            self.qlimit.parent = self
                                                                            self._children_name_map["qlimit"] = "qlimit"

                                                                            self.accounting_event_aaa = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa()
                                                                            self.accounting_event_aaa.parent = self
                                                                            self._children_name_map["accounting_event_aaa"] = "accounting-event-aaa"

                                                                            self.authorize_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId()
                                                                            self.authorize_id.parent = self
                                                                            self._children_name_map["authorize_id"] = "authorize-id"

                                                                            self.afm_react = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact()
                                                                            self.afm_react.parent = self
                                                                            self._children_name_map["afm_react"] = "afm-react"

                                                                            self.httpr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr()
                                                                            self.httpr.parent = self
                                                                            self._children_name_map["httpr"] = "httpr"

                                                                            self.punt = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt()
                                                                            self.punt.parent = self
                                                                            self._children_name_map["punt"] = "punt"

                                                                            self.copy = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy()
                                                                            self.copy.parent = self
                                                                            self._children_name_map["copy"] = "copy"

                                                                            self.sfrag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag()
                                                                            self.sfrag.parent = self
                                                                            self._children_name_map["sfrag"] = "sfrag"

                                                                            self.redirect = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect()
                                                                            self.redirect.parent = self
                                                                            self._children_name_map["redirect"] = "redirect"

                                                                            self.out_intf = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf()
                                                                            self.out_intf.parent = self
                                                                            self._children_name_map["out_intf"] = "out-intf"

                                                                            self.serv_func = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc()
                                                                            self.serv_func.parent = self
                                                                            self._children_name_map["serv_func"] = "serv-func"

                                                                            self.police = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police()
                                                                            self.police.parent = self
                                                                            self._children_name_map["police"] = "police"

                                                                            self.shape = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape()
                                                                            self.shape.parent = self
                                                                            self._children_name_map["shape"] = "shape"

                                                                            self.child_policy = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy()
                                                                            self.child_policy.parent = self
                                                                            self._children_name_map["child_policy"] = "child-policy"

                                                                            self.cac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac()
                                                                            self.cac.parent = self
                                                                            self._children_name_map["cac"] = "cac"

                                                                            self.pfc = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc()
                                                                            self.pfc.parent = self
                                                                            self._children_name_map["pfc"] = "pfc"

                                                                            self.flow_parm = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm()
                                                                            self.flow_parm.parent = self
                                                                            self._children_name_map["flow_parm"] = "flow-parm"

                                                                            self.ipcbr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr()
                                                                            self.ipcbr.parent = self
                                                                            self._children_name_map["ipcbr"] = "ipcbr"

                                                                            self.rtp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp()
                                                                            self.rtp.parent = self
                                                                            self._children_name_map["rtp"] = "rtp"

                                                                            self.rtp_mmr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr()
                                                                            self.rtp_mmr.parent = self
                                                                            self._children_name_map["rtp_mmr"] = "rtp-mmr"

                                                                            self.rtp_j2k = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k()
                                                                            self.rtp_j2k.parent = self
                                                                            self._children_name_map["rtp_j2k"] = "rtp-j2k"

                                                                            self.rtp_voice = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice()
                                                                            self.rtp_voice.parent = self
                                                                            self._children_name_map["rtp_voice"] = "rtp-voice"

                                                                            self.mdi = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi()
                                                                            self.mdi.parent = self
                                                                            self._children_name_map["mdi"] = "mdi"

                                                                            self.mdi_rtp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp()
                                                                            self.mdi_rtp.parent = self
                                                                            self._children_name_map["mdi_rtp"] = "mdi-rtp"

                                                                            self.fmm = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm()
                                                                            self.fmm.parent = self
                                                                            self._children_name_map["fmm"] = "fmm"

                                                                            self.pbf = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf()
                                                                            self.pbf.parent = self
                                                                            self._children_name_map["pbf"] = "pbf"

                                                                            self.ipv4_nh = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh()
                                                                            self.ipv4_nh.parent = self
                                                                            self._children_name_map["ipv4_nh"] = "ipv4-nh"

                                                                            self.ipv6_nh = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh()
                                                                            self.ipv6_nh.parent = self
                                                                            self._children_name_map["ipv6_nh"] = "ipv6-nh"
                                                                            self._segment_path = lambda: "actp"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp, ['type', 'data_p'], name, value)


                                                                        class Mark(Entity):
                                                                            """
                                                                            mark
                                                                            
                                                                            .. attribute:: action_mark_info
                                                                            
                                                                            	action mark info
                                                                            	**type**\: list of  		 :py:class:`ActionMarkInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark, self).__init__()

                                                                                self.yang_name = "mark"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("action-mark-info", ("action_mark_info", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo))])
                                                                                self._leafs = OrderedDict()

                                                                                self.action_mark_info = YList(self)
                                                                                self._segment_path = lambda: "mark"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark, [], name, value)


                                                                            class ActionMarkInfo(Entity):
                                                                                """
                                                                                action mark info
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:  :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                                
                                                                                .. attribute:: mark_flags
                                                                                
                                                                                	mark flags
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo, self).__init__()

                                                                                    self.yang_name = "action-mark-info"
                                                                                    self.yang_parent_name = "mark"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MarkTypeEn', '')])),
                                                                                        ('mark_flags', (YLeaf(YType.uint32, 'mark-flags'), ['int'])),
                                                                                        ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                    ])
                                                                                    self.type = None
                                                                                    self.mark_flags = None
                                                                                    self.value = None
                                                                                    self._segment_path = lambda: "action-mark-info"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo, ['type', 'mark_flags', 'value'], name, value)


                                                                        class Mark2(Entity):
                                                                            """
                                                                            mark2
                                                                            
                                                                            .. attribute:: action_mark2_info
                                                                            
                                                                            	action mark2 info
                                                                            	**type**\: list of  		 :py:class:`ActionMark2Info <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2, self).__init__()

                                                                                self.yang_name = "mark2"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("action-mark2-info", ("action_mark2_info", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info))])
                                                                                self._leafs = OrderedDict()

                                                                                self.action_mark2_info = YList(self)
                                                                                self._segment_path = lambda: "mark2"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2, [], name, value)


                                                                            class ActionMark2Info(Entity):
                                                                                """
                                                                                action mark2 info
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: value_overflow
                                                                                
                                                                                	value overflow
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: mark_flags
                                                                                
                                                                                	mark flags
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info, self).__init__()

                                                                                    self.yang_name = "action-mark2-info"
                                                                                    self.yang_parent_name = "mark2"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ('value_overflow', (YLeaf(YType.uint16, 'value-overflow'), ['int'])),
                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                        ('mark_flags', (YLeaf(YType.uint8, 'mark-flags'), ['int'])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.value_overflow = None
                                                                                    self.type = None
                                                                                    self.mark_flags = None
                                                                                    self._segment_path = lambda: "action-mark2-info"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info, ['value', 'value_overflow', 'type', 'mark_flags'], name, value)


                                                                        class Wred(Entity):
                                                                            """
                                                                            wred
                                                                            
                                                                            .. attribute:: action_wred_info
                                                                            
                                                                            	action wred info
                                                                            	**type**\: list of  		 :py:class:`ActionWredInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred, self).__init__()

                                                                                self.yang_name = "wred"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("action-wred-info", ("action_wred_info", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo))])
                                                                                self._leafs = OrderedDict()

                                                                                self.action_wred_info = YList(self)
                                                                                self._segment_path = lambda: "wred"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred, [], name, value)


                                                                            class ActionWredInfo(Entity):
                                                                                """
                                                                                action wred info
                                                                                
                                                                                .. attribute:: match_ranges
                                                                                
                                                                                	match ranges
                                                                                	**type**\:  :py:class:`MatchRanges <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges>`
                                                                                
                                                                                .. attribute:: min_threshold
                                                                                
                                                                                	min threshold
                                                                                	**type**\:  :py:class:`MinThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold>`
                                                                                
                                                                                .. attribute:: max_threshold
                                                                                
                                                                                	max threshold
                                                                                	**type**\:  :py:class:`MaxThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold>`
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	cos/prec/dscp/ based WRED
                                                                                	**type**\:  :py:class:`WredTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.WredTypeEn>`
                                                                                
                                                                                .. attribute:: wred_flags
                                                                                
                                                                                	wred flags
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: probability
                                                                                
                                                                                	probability
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo, self).__init__()

                                                                                    self.yang_name = "action-wred-info"
                                                                                    self.yang_parent_name = "wred"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("match-ranges", ("match_ranges", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges)), ("min-threshold", ("min_threshold", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold)), ("max-threshold", ("max_threshold", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'WredTypeEn', '')])),
                                                                                        ('wred_flags', (YLeaf(YType.uint32, 'wred-flags'), ['int'])),
                                                                                        ('probability', (YLeaf(YType.uint32, 'probability'), ['int'])),
                                                                                    ])
                                                                                    self.type = None
                                                                                    self.wred_flags = None
                                                                                    self.probability = None

                                                                                    self.match_ranges = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges()
                                                                                    self.match_ranges.parent = self
                                                                                    self._children_name_map["match_ranges"] = "match-ranges"

                                                                                    self.min_threshold = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold()
                                                                                    self.min_threshold.parent = self
                                                                                    self._children_name_map["min_threshold"] = "min-threshold"

                                                                                    self.max_threshold = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold()
                                                                                    self.max_threshold.parent = self
                                                                                    self._children_name_map["max_threshold"] = "max-threshold"
                                                                                    self._segment_path = lambda: "action-wred-info"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo, ['type', 'wred_flags', 'probability'], name, value)


                                                                                class MatchRanges(Entity):
                                                                                    """
                                                                                    match ranges
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges, self).__init__()

                                                                                        self.yang_name = "match-ranges"
                                                                                        self.yang_parent_name = "action-wred-info"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "match-ranges"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "match-ranges"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray, ['min', 'max'], name, value)


                                                                                class MinThreshold(Entity):
                                                                                    """
                                                                                    min threshold
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: unit
                                                                                    
                                                                                    	unit
                                                                                    	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold, self).__init__()

                                                                                        self.yang_name = "min-threshold"
                                                                                        self.yang_parent_name = "action-wred-info"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                        ])
                                                                                        self.value = None
                                                                                        self.unit = None
                                                                                        self._segment_path = lambda: "min-threshold"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold, ['value', 'unit'], name, value)


                                                                                class MaxThreshold(Entity):
                                                                                    """
                                                                                    max threshold
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: unit
                                                                                    
                                                                                    	unit
                                                                                    	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold, self).__init__()

                                                                                        self.yang_name = "max-threshold"
                                                                                        self.yang_parent_name = "action-wred-info"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                        ])
                                                                                        self.value = None
                                                                                        self.unit = None
                                                                                        self._segment_path = lambda: "max-threshold"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold, ['value', 'unit'], name, value)


                                                                        class Encap(Entity):
                                                                            """
                                                                            encap
                                                                            
                                                                            .. attribute:: seq
                                                                            
                                                                            	seq
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap, self).__init__()

                                                                                self.yang_name = "encap"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('seq', (YLeaf(YType.uint8, 'seq'), ['int'])),
                                                                                ])
                                                                                self.seq = None
                                                                                self._segment_path = lambda: "encap"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap, ['seq'], name, value)


                                                                        class Prio(Entity):
                                                                            """
                                                                            prio
                                                                            
                                                                            .. attribute:: prio_lvl
                                                                            
                                                                            	prio lvl
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio, self).__init__()

                                                                                self.yang_name = "prio"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('prio_lvl', (YLeaf(YType.uint32, 'prio-lvl'), ['int'])),
                                                                                ])
                                                                                self.prio_lvl = None
                                                                                self._segment_path = lambda: "prio"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio, ['prio_lvl'], name, value)


                                                                        class Bwrem(Entity):
                                                                            """
                                                                            bwrem
                                                                            
                                                                            .. attribute:: bwrem
                                                                            
                                                                            	bwrem
                                                                            	**type**\:  :py:class:`Bwrem_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem_>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem, self).__init__()

                                                                                self.yang_name = "bwrem"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("bwrem", ("bwrem", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem_))])
                                                                                self._leafs = OrderedDict()

                                                                                self.bwrem = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem_()
                                                                                self.bwrem.parent = self
                                                                                self._children_name_map["bwrem"] = "bwrem"
                                                                                self._segment_path = lambda: "bwrem"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem, [], name, value)


                                                                            class Bwrem_(Entity):
                                                                                """
                                                                                bwrem
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem_, self).__init__()

                                                                                    self.yang_name = "bwrem"
                                                                                    self.yang_parent_name = "bwrem"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.unit = None
                                                                                    self._segment_path = lambda: "bwrem"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem_, ['value', 'unit'], name, value)


                                                                        class MinBw(Entity):
                                                                            """
                                                                            min bw
                                                                            
                                                                            .. attribute:: bw
                                                                            
                                                                            	bw
                                                                            	**type**\:  :py:class:`Bw <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw, self).__init__()

                                                                                self.yang_name = "min-bw"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("bw", ("bw", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw))])
                                                                                self._leafs = OrderedDict()

                                                                                self.bw = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw()
                                                                                self.bw.parent = self
                                                                                self._children_name_map["bw"] = "bw"
                                                                                self._segment_path = lambda: "min-bw"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw, [], name, value)


                                                                            class Bw(Entity):
                                                                                """
                                                                                bw
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw, self).__init__()

                                                                                    self.yang_name = "bw"
                                                                                    self.yang_parent_name = "min-bw"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.unit = None
                                                                                    self._segment_path = lambda: "bw"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw, ['value', 'unit'], name, value)


                                                                        class AuthenAaa(Entity):
                                                                            """
                                                                            authen aaa
                                                                            
                                                                            .. attribute:: aaa_list_name
                                                                            
                                                                            	aaa list name
                                                                            	**type**\: str
                                                                            
                                                                            .. attribute:: authen_password
                                                                            
                                                                            	authen password
                                                                            	**type**\: str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa, self).__init__()

                                                                                self.yang_name = "authen-aaa"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                                    ('authen_password', (YLeaf(YType.str, 'authen-password'), ['str'])),
                                                                                ])
                                                                                self.aaa_list_name = None
                                                                                self.authen_password = None
                                                                                self._segment_path = lambda: "authen-aaa"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa, ['aaa_list_name', 'authen_password'], name, value)


                                                                        class CollectId(Entity):
                                                                            """
                                                                            collect id
                                                                            
                                                                            .. attribute:: id
                                                                            
                                                                            	id
                                                                            	**type**\:  :py:class:`IdentifierEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.IdentifierEn>`
                                                                            
                                                                            .. attribute:: aaa_list_name
                                                                            
                                                                            	aaa list name
                                                                            	**type**\: str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId, self).__init__()

                                                                                self.yang_name = "collect-id"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('id', (YLeaf(YType.enumeration, 'id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'IdentifierEn', '')])),
                                                                                    ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                                ])
                                                                                self.id = None
                                                                                self.aaa_list_name = None
                                                                                self._segment_path = lambda: "collect-id"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId, ['id', 'aaa_list_name'], name, value)


                                                                        class DecodeId(Entity):
                                                                            """
                                                                            decode id
                                                                            
                                                                            .. attribute:: id
                                                                            
                                                                            	id
                                                                            	**type**\:  :py:class:`DecodeIdentifierEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.DecodeIdentifierEn>`
                                                                            
                                                                            .. attribute:: format_name
                                                                            
                                                                            	format name
                                                                            	**type**\: str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId, self).__init__()

                                                                                self.yang_name = "decode-id"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('id', (YLeaf(YType.enumeration, 'id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'DecodeIdentifierEn', '')])),
                                                                                    ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                ])
                                                                                self.id = None
                                                                                self.format_name = None
                                                                                self._segment_path = lambda: "decode-id"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId, ['id', 'format_name'], name, value)


                                                                        class SetTimer(Entity):
                                                                            """
                                                                            set timer
                                                                            
                                                                            .. attribute:: timer_name
                                                                            
                                                                            	timer name
                                                                            	**type**\: str
                                                                            
                                                                            .. attribute:: duration
                                                                            
                                                                            	duration
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: absolute_time
                                                                            
                                                                            	absolute time
                                                                            	**type**\: str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer, self).__init__()

                                                                                self.yang_name = "set-timer"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('timer_name', (YLeaf(YType.str, 'timer-name'), ['str'])),
                                                                                    ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                                                    ('absolute_time', (YLeaf(YType.str, 'absolute-time'), ['str'])),
                                                                                ])
                                                                                self.timer_name = None
                                                                                self.duration = None
                                                                                self.absolute_time = None
                                                                                self._segment_path = lambda: "set-timer"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer, ['timer_name', 'duration', 'absolute_time'], name, value)


                                                                        class StopTimer(Entity):
                                                                            """
                                                                            stop timer
                                                                            
                                                                            .. attribute:: timer_name
                                                                            
                                                                            	timer name
                                                                            	**type**\: str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer, self).__init__()

                                                                                self.yang_name = "stop-timer"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('timer_name', (YLeaf(YType.str, 'timer-name'), ['str'])),
                                                                                ])
                                                                                self.timer_name = None
                                                                                self._segment_path = lambda: "stop-timer"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer, ['timer_name'], name, value)


                                                                        class AcctAaaList(Entity):
                                                                            """
                                                                            acct aaa list
                                                                            
                                                                            .. attribute:: aaa_list_name
                                                                            
                                                                            	aaa list name
                                                                            	**type**\: str
                                                                            
                                                                            .. attribute:: secs
                                                                            
                                                                            	secs
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList, self).__init__()

                                                                                self.yang_name = "acct-aaa-list"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                                    ('secs', (YLeaf(YType.uint32, 'secs'), ['int'])),
                                                                                ])
                                                                                self.aaa_list_name = None
                                                                                self.secs = None
                                                                                self._segment_path = lambda: "acct-aaa-list"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList, ['aaa_list_name', 'secs'], name, value)


                                                                        class QueryAncp(Entity):
                                                                            """
                                                                            query ancp
                                                                            
                                                                            .. attribute:: enable
                                                                            
                                                                            	enable
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp, self).__init__()

                                                                                self.yang_name = "query-ancp"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('enable', (YLeaf(YType.uint8, 'enable'), ['int'])),
                                                                                ])
                                                                                self.enable = None
                                                                                self._segment_path = lambda: "query-ancp"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp, ['enable'], name, value)


                                                                        class PrepaidCfg(Entity):
                                                                            """
                                                                            prepaid cfg
                                                                            
                                                                            .. attribute:: prepaid_config_profile_name
                                                                            
                                                                            	prepaid config profile name
                                                                            	**type**\: str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg, self).__init__()

                                                                                self.yang_name = "prepaid-cfg"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('prepaid_config_profile_name', (YLeaf(YType.str, 'prepaid-config-profile-name'), ['str'])),
                                                                                ])
                                                                                self.prepaid_config_profile_name = None
                                                                                self._segment_path = lambda: "prepaid-cfg"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg, ['prepaid_config_profile_name'], name, value)


                                                                        class TimeoutIdle(Entity):
                                                                            """
                                                                            timeout idle
                                                                            
                                                                            .. attribute:: secs
                                                                            
                                                                            	secs
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle, self).__init__()

                                                                                self.yang_name = "timeout-idle"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('secs', (YLeaf(YType.uint32, 'secs'), ['int'])),
                                                                                ])
                                                                                self.secs = None
                                                                                self._segment_path = lambda: "timeout-idle"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle, ['secs'], name, value)


                                                                        class ProxyAaa(Entity):
                                                                            """
                                                                            proxy aaa
                                                                            
                                                                            .. attribute:: aaa_list_name
                                                                            
                                                                            	aaa list name
                                                                            	**type**\: str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa, self).__init__()

                                                                                self.yang_name = "proxy-aaa"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                                ])
                                                                                self.aaa_list_name = None
                                                                                self._segment_path = lambda: "proxy-aaa"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa, ['aaa_list_name'], name, value)


                                                                        class ActTemplate(Entity):
                                                                            """
                                                                            act template
                                                                            
                                                                            .. attribute:: template_name
                                                                            
                                                                            	template name
                                                                            	**type**\: str
                                                                            
                                                                            .. attribute:: aaa_list_name
                                                                            
                                                                            	aaa list name
                                                                            	**type**\: str
                                                                            
                                                                            .. attribute:: flags
                                                                            
                                                                            	flags
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate, self).__init__()

                                                                                self.yang_name = "act-template"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('template_name', (YLeaf(YType.str, 'template-name'), ['str'])),
                                                                                    ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                                    ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                ])
                                                                                self.template_name = None
                                                                                self.aaa_list_name = None
                                                                                self.flags = None
                                                                                self._segment_path = lambda: "act-template"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate, ['template_name', 'aaa_list_name', 'flags'], name, value)


                                                                        class DeactTemplate(Entity):
                                                                            """
                                                                            deact template
                                                                            
                                                                            .. attribute:: template_name
                                                                            
                                                                            	template name
                                                                            	**type**\: str
                                                                            
                                                                            .. attribute:: aaa_list_name
                                                                            
                                                                            	aaa list name
                                                                            	**type**\: str
                                                                            
                                                                            .. attribute:: flags
                                                                            
                                                                            	flags
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate, self).__init__()

                                                                                self.yang_name = "deact-template"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('template_name', (YLeaf(YType.str, 'template-name'), ['str'])),
                                                                                    ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                                    ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                ])
                                                                                self.template_name = None
                                                                                self.aaa_list_name = None
                                                                                self.flags = None
                                                                                self._segment_path = lambda: "deact-template"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate, ['template_name', 'aaa_list_name', 'flags'], name, value)


                                                                        class Qlimit(Entity):
                                                                            """
                                                                            qlimit
                                                                            
                                                                            .. attribute:: action_qlimit_info_array
                                                                            
                                                                            	action qlimit info array
                                                                            	**type**\: list of  		 :py:class:`ActionQlimitInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit, self).__init__()

                                                                                self.yang_name = "qlimit"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("action-qlimit-info-array", ("action_qlimit_info_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.action_qlimit_info_array = YList(self)
                                                                                self._segment_path = lambda: "qlimit"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit, [], name, value)


                                                                            class ActionQlimitInfoArray(Entity):
                                                                                """
                                                                                action qlimit info array
                                                                                
                                                                                .. attribute:: qlim
                                                                                
                                                                                	qlim
                                                                                	**type**\:  :py:class:`Qlim <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim>`
                                                                                
                                                                                .. attribute:: atmclp_qlim
                                                                                
                                                                                	atmclp qlim
                                                                                	**type**\:  :py:class:`AtmclpQlim <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim>`
                                                                                
                                                                                .. attribute:: match_values
                                                                                
                                                                                	match values
                                                                                	**type**\:  :py:class:`MatchValues <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues>`
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:  :py:class:`QlimitTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.QlimitTypeEn>`
                                                                                
                                                                                .. attribute:: qlimit_flags
                                                                                
                                                                                	qlimit flags
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray, self).__init__()

                                                                                    self.yang_name = "action-qlimit-info-array"
                                                                                    self.yang_parent_name = "qlimit"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("qlim", ("qlim", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim)), ("atmclp-qlim", ("atmclp_qlim", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim)), ("match-values", ("match_values", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'QlimitTypeEn', '')])),
                                                                                        ('qlimit_flags', (YLeaf(YType.uint32, 'qlimit-flags'), ['int'])),
                                                                                    ])
                                                                                    self.type = None
                                                                                    self.qlimit_flags = None

                                                                                    self.qlim = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim()
                                                                                    self.qlim.parent = self
                                                                                    self._children_name_map["qlim"] = "qlim"

                                                                                    self.atmclp_qlim = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim()
                                                                                    self.atmclp_qlim.parent = self
                                                                                    self._children_name_map["atmclp_qlim"] = "atmclp-qlim"

                                                                                    self.match_values = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues()
                                                                                    self.match_values.parent = self
                                                                                    self._children_name_map["match_values"] = "match-values"
                                                                                    self._segment_path = lambda: "action-qlimit-info-array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray, ['type', 'qlimit_flags'], name, value)


                                                                                class Qlim(Entity):
                                                                                    """
                                                                                    qlim
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: unit
                                                                                    
                                                                                    	unit
                                                                                    	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim, self).__init__()

                                                                                        self.yang_name = "qlim"
                                                                                        self.yang_parent_name = "action-qlimit-info-array"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                        ])
                                                                                        self.value = None
                                                                                        self.unit = None
                                                                                        self._segment_path = lambda: "qlim"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim, ['value', 'unit'], name, value)


                                                                                class AtmclpQlim(Entity):
                                                                                    """
                                                                                    atmclp qlim
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: unit
                                                                                    
                                                                                    	unit
                                                                                    	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim, self).__init__()

                                                                                        self.yang_name = "atmclp-qlim"
                                                                                        self.yang_parent_name = "action-qlimit-info-array"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                        ])
                                                                                        self.value = None
                                                                                        self.unit = None
                                                                                        self._segment_path = lambda: "atmclp-qlim"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim, ['value', 'unit'], name, value)


                                                                                class MatchValues(Entity):
                                                                                    """
                                                                                    match values
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues, self).__init__()

                                                                                        self.yang_name = "match-values"
                                                                                        self.yang_parent_name = "action-qlimit-info-array"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "match-values"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "match-values"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray, ['min', 'max'], name, value)


                                                                        class AccountingEventAaa(Entity):
                                                                            """
                                                                            accounting event aaa
                                                                            
                                                                            .. attribute:: action
                                                                            
                                                                            	action
                                                                            	**type**\:  :py:class:`AcctEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.AcctEn>`
                                                                            
                                                                            .. attribute:: aaa_list_name
                                                                            
                                                                            	aaa list name
                                                                            	**type**\: str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa, self).__init__()

                                                                                self.yang_name = "accounting-event-aaa"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('action', (YLeaf(YType.enumeration, 'action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'AcctEn', '')])),
                                                                                    ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                                ])
                                                                                self.action = None
                                                                                self.aaa_list_name = None
                                                                                self._segment_path = lambda: "accounting-event-aaa"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa, ['action', 'aaa_list_name'], name, value)


                                                                        class AuthorizeId(Entity):
                                                                            """
                                                                            authorize id
                                                                            
                                                                            .. attribute:: id
                                                                            
                                                                            	id
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: aaa_list_name
                                                                            
                                                                            	aaa list name
                                                                            	**type**\: str
                                                                            
                                                                            .. attribute:: format_name
                                                                            
                                                                            	format name
                                                                            	**type**\: str
                                                                            
                                                                            .. attribute:: password
                                                                            
                                                                            	password
                                                                            	**type**\: str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId, self).__init__()

                                                                                self.yang_name = "authorize-id"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('id', (YLeaf(YType.uint8, 'id'), ['int'])),
                                                                                    ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                                    ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                    ('password', (YLeaf(YType.str, 'password'), ['str'])),
                                                                                ])
                                                                                self.id = None
                                                                                self.aaa_list_name = None
                                                                                self.format_name = None
                                                                                self.password = None
                                                                                self._segment_path = lambda: "authorize-id"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId, ['id', 'aaa_list_name', 'format_name', 'password'], name, value)


                                                                        class AfmReact(Entity):
                                                                            """
                                                                            afm react
                                                                            
                                                                            .. attribute:: action_afmon_react_info
                                                                            
                                                                            	action afmon react info
                                                                            	**type**\: list of  		 :py:class:`ActionAfmonReactInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact, self).__init__()

                                                                                self.yang_name = "afm-react"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("action-afmon-react-info", ("action_afmon_react_info", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo))])
                                                                                self._leafs = OrderedDict()

                                                                                self.action_afmon_react_info = YList(self)
                                                                                self._segment_path = lambda: "afm-react"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact, [], name, value)


                                                                            class ActionAfmonReactInfo(Entity):
                                                                                """
                                                                                action afmon react info
                                                                                
                                                                                .. attribute:: oper_id
                                                                                
                                                                                	React Operation ID
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: description
                                                                                
                                                                                	Describing the oper
                                                                                	**type**\: str
                                                                                
                                                                                .. attribute:: trig_num_intvls
                                                                                
                                                                                	Averaged over N intvls
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: clone_ifh
                                                                                
                                                                                	Clone interface handle
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: notif_actns
                                                                                
                                                                                	Bitmap of actions on alert
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: criterion
                                                                                
                                                                                	React Criterion
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: trig_type
                                                                                
                                                                                	Immediate or averaged thresh trigger
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: trig_relop
                                                                                
                                                                                	Trigger LT\|LE\|GT\|GE\|Range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: trig_level_1
                                                                                
                                                                                	Trigger threshold 1/lower
                                                                                	**type**\: str
                                                                                
                                                                                .. attribute:: trig_level_2
                                                                                
                                                                                	Trigger upper threshold for range
                                                                                	**type**\: str
                                                                                
                                                                                .. attribute:: alm_grp_thresh
                                                                                
                                                                                	Num/percent in grp
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                	**units**\: percentage
                                                                                
                                                                                .. attribute:: alm_type
                                                                                
                                                                                	Discrete \| grouped alarm
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: alm_severity
                                                                                
                                                                                	Major\|Minor\|... alarm
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo, self).__init__()

                                                                                    self.yang_name = "action-afmon-react-info"
                                                                                    self.yang_parent_name = "afm-react"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('oper_id', (YLeaf(YType.uint32, 'oper-id'), ['int'])),
                                                                                        ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                        ('trig_num_intvls', (YLeaf(YType.uint32, 'trig-num-intvls'), ['int'])),
                                                                                        ('clone_ifh', (YLeaf(YType.uint32, 'clone-ifh'), ['int'])),
                                                                                        ('notif_actns', (YLeaf(YType.uint8, 'notif-actns'), ['int'])),
                                                                                        ('criterion', (YLeaf(YType.uint8, 'criterion'), ['int'])),
                                                                                        ('trig_type', (YLeaf(YType.uint8, 'trig-type'), ['int'])),
                                                                                        ('trig_relop', (YLeaf(YType.uint8, 'trig-relop'), ['int'])),
                                                                                        ('trig_level_1', (YLeaf(YType.str, 'trig-level-1'), ['str'])),
                                                                                        ('trig_level_2', (YLeaf(YType.str, 'trig-level-2'), ['str'])),
                                                                                        ('alm_grp_thresh', (YLeaf(YType.uint16, 'alm-grp-thresh'), ['int'])),
                                                                                        ('alm_type', (YLeaf(YType.uint8, 'alm-type'), ['int'])),
                                                                                        ('alm_severity', (YLeaf(YType.uint8, 'alm-severity'), ['int'])),
                                                                                    ])
                                                                                    self.oper_id = None
                                                                                    self.description = None
                                                                                    self.trig_num_intvls = None
                                                                                    self.clone_ifh = None
                                                                                    self.notif_actns = None
                                                                                    self.criterion = None
                                                                                    self.trig_type = None
                                                                                    self.trig_relop = None
                                                                                    self.trig_level_1 = None
                                                                                    self.trig_level_2 = None
                                                                                    self.alm_grp_thresh = None
                                                                                    self.alm_type = None
                                                                                    self.alm_severity = None
                                                                                    self._segment_path = lambda: "action-afmon-react-info"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo, ['oper_id', 'description', 'trig_num_intvls', 'clone_ifh', 'notif_actns', 'criterion', 'trig_type', 'trig_relop', 'trig_level_1', 'trig_level_2', 'alm_grp_thresh', 'alm_type', 'alm_severity'], name, value)


                                                                        class Httpr(Entity):
                                                                            """
                                                                            httpr
                                                                            
                                                                            .. attribute:: redirect_url
                                                                            
                                                                            	redirect url
                                                                            	**type**\: str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr, self).__init__()

                                                                                self.yang_name = "httpr"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('redirect_url', (YLeaf(YType.str, 'redirect-url'), ['str'])),
                                                                                ])
                                                                                self.redirect_url = None
                                                                                self._segment_path = lambda: "httpr"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr, ['redirect_url'], name, value)


                                                                        class Punt(Entity):
                                                                            """
                                                                            punt
                                                                            
                                                                            .. attribute:: sn_type
                                                                            
                                                                            	service node ID type
                                                                            	**type**\:  :py:class:`DpssSnidTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.DpssSnidTypeEn>`
                                                                            
                                                                            .. attribute:: sn_index
                                                                            
                                                                            	service node index
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: sn_name
                                                                            
                                                                            	service node name
                                                                            	**type**\: str
                                                                            
                                                                            .. attribute:: app_id
                                                                            
                                                                            	application ID
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: local_id
                                                                            
                                                                            	local ID
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: vsnode_type
                                                                            
                                                                            	vservice node type
                                                                            	**type**\:  :py:class:`VsvcServiceTypeT <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.VsvcServiceTypeT>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt, self).__init__()

                                                                                self.yang_name = "punt"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('sn_type', (YLeaf(YType.enumeration, 'sn-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'DpssSnidTypeEn', '')])),
                                                                                    ('sn_index', (YLeaf(YType.uint32, 'sn-index'), ['int'])),
                                                                                    ('sn_name', (YLeaf(YType.str, 'sn-name'), ['str'])),
                                                                                    ('app_id', (YLeaf(YType.uint32, 'app-id'), ['int'])),
                                                                                    ('local_id', (YLeaf(YType.uint32, 'local-id'), ['int'])),
                                                                                    ('vsnode_type', (YLeaf(YType.enumeration, 'vsnode-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'VsvcServiceTypeT', '')])),
                                                                                ])
                                                                                self.sn_type = None
                                                                                self.sn_index = None
                                                                                self.sn_name = None
                                                                                self.app_id = None
                                                                                self.local_id = None
                                                                                self.vsnode_type = None
                                                                                self._segment_path = lambda: "punt"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt, ['sn_type', 'sn_index', 'sn_name', 'app_id', 'local_id', 'vsnode_type'], name, value)


                                                                        class Copy(Entity):
                                                                            """
                                                                            copy
                                                                            
                                                                            .. attribute:: num_byte
                                                                            
                                                                            	number of bytes
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: sn_type
                                                                            
                                                                            	service node ID type
                                                                            	**type**\:  :py:class:`DpssSnidTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.DpssSnidTypeEn>`
                                                                            
                                                                            .. attribute:: sn_index
                                                                            
                                                                            	service node index
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: sn_name
                                                                            
                                                                            	service node url
                                                                            	**type**\: str
                                                                            
                                                                            .. attribute:: app_id
                                                                            
                                                                            	application ID
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: local_id
                                                                            
                                                                            	local ID
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: vsnode_type
                                                                            
                                                                            	vservice node type
                                                                            	**type**\:  :py:class:`VsvcServiceTypeT <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.VsvcServiceTypeT>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy, self).__init__()

                                                                                self.yang_name = "copy"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('num_byte', (YLeaf(YType.uint32, 'num-byte'), ['int'])),
                                                                                    ('sn_type', (YLeaf(YType.enumeration, 'sn-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'DpssSnidTypeEn', '')])),
                                                                                    ('sn_index', (YLeaf(YType.uint32, 'sn-index'), ['int'])),
                                                                                    ('sn_name', (YLeaf(YType.str, 'sn-name'), ['str'])),
                                                                                    ('app_id', (YLeaf(YType.uint32, 'app-id'), ['int'])),
                                                                                    ('local_id', (YLeaf(YType.uint32, 'local-id'), ['int'])),
                                                                                    ('vsnode_type', (YLeaf(YType.enumeration, 'vsnode-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'VsvcServiceTypeT', '')])),
                                                                                ])
                                                                                self.num_byte = None
                                                                                self.sn_type = None
                                                                                self.sn_index = None
                                                                                self.sn_name = None
                                                                                self.app_id = None
                                                                                self.local_id = None
                                                                                self.vsnode_type = None
                                                                                self._segment_path = lambda: "copy"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy, ['num_byte', 'sn_type', 'sn_index', 'sn_name', 'app_id', 'local_id', 'vsnode_type'], name, value)


                                                                        class Sfrag(Entity):
                                                                            """
                                                                            sfrag
                                                                            
                                                                            .. attribute:: name
                                                                            
                                                                            	Service Fragment Name
                                                                            	**type**\: str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag, self).__init__()

                                                                                self.yang_name = "sfrag"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                                ])
                                                                                self.name = None
                                                                                self._segment_path = lambda: "sfrag"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag, ['name'], name, value)


                                                                        class Redirect(Entity):
                                                                            """
                                                                            redirect
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect, self).__init__()

                                                                                self.yang_name = "redirect"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                ])
                                                                                self.value = None
                                                                                self.type = None
                                                                                self._segment_path = lambda: "redirect"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect, ['value', 'type'], name, value)


                                                                        class OutIntf(Entity):
                                                                            """
                                                                            out intf
                                                                            
                                                                            .. attribute:: out_ifname
                                                                            
                                                                            	output interface name
                                                                            	**type**\: str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf, self).__init__()

                                                                                self.yang_name = "out-intf"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('out_ifname', (YLeaf(YType.str, 'out-ifname'), ['str'])),
                                                                                ])
                                                                                self.out_ifname = None
                                                                                self._segment_path = lambda: "out-intf"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf, ['out_ifname'], name, value)


                                                                        class ServFunc(Entity):
                                                                            """
                                                                            serv func
                                                                            
                                                                            .. attribute:: path_id
                                                                            
                                                                            	service path id
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: service_index
                                                                            
                                                                            	service path index
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: meta_name
                                                                            
                                                                            	metadata name
                                                                            	**type**\: str
                                                                            
                                                                            .. attribute:: vs_index
                                                                            
                                                                            	vservice index
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc, self).__init__()

                                                                                self.yang_name = "serv-func"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('path_id', (YLeaf(YType.uint32, 'path-id'), ['int'])),
                                                                                    ('service_index', (YLeaf(YType.uint8, 'service-index'), ['int'])),
                                                                                    ('meta_name', (YLeaf(YType.str, 'meta-name'), ['str'])),
                                                                                    ('vs_index', (YLeaf(YType.uint32, 'vs-index'), ['int'])),
                                                                                ])
                                                                                self.path_id = None
                                                                                self.service_index = None
                                                                                self.meta_name = None
                                                                                self.vs_index = None
                                                                                self._segment_path = lambda: "serv-func"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc, ['path_id', 'service_index', 'meta_name', 'vs_index'], name, value)


                                                                        class Police(Entity):
                                                                            """
                                                                            police
                                                                            
                                                                            .. attribute:: rate
                                                                            
                                                                            	rate
                                                                            	**type**\:  :py:class:`Rate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate>`
                                                                            
                                                                            .. attribute:: burst
                                                                            
                                                                            	burst
                                                                            	**type**\:  :py:class:`Burst <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst>`
                                                                            
                                                                            .. attribute:: peak_rate
                                                                            
                                                                            	peak rate
                                                                            	**type**\:  :py:class:`PeakRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate>`
                                                                            
                                                                            .. attribute:: peak_burst
                                                                            
                                                                            	peak burst
                                                                            	**type**\:  :py:class:`PeakBurst <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst>`
                                                                            
                                                                            .. attribute:: cdvt
                                                                            
                                                                            	cdvt
                                                                            	**type**\:  :py:class:`Cdvt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt>`
                                                                            
                                                                            .. attribute:: conform_actns
                                                                            
                                                                            	conform actns
                                                                            	**type**\:  :py:class:`ConformActns <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns>`
                                                                            
                                                                            .. attribute:: exceed_actns
                                                                            
                                                                            	exceed actns
                                                                            	**type**\:  :py:class:`ExceedActns <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns>`
                                                                            
                                                                            .. attribute:: violate_actns
                                                                            
                                                                            	violate actns
                                                                            	**type**\:  :py:class:`ViolateActns <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns>`
                                                                            
                                                                            .. attribute:: confclass_encode
                                                                            
                                                                            	confclass encode
                                                                            	**type**\:  :py:class:`ConfclassEncode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode>`
                                                                            
                                                                            .. attribute:: confclass_p
                                                                            
                                                                            	confclass p
                                                                            	**type**\:  :py:class:`ConfclassP <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP>`
                                                                            
                                                                            .. attribute:: excdclass_encode
                                                                            
                                                                            	excdclass encode
                                                                            	**type**\:  :py:class:`ExcdclassEncode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode>`
                                                                            
                                                                            .. attribute:: excdclass_p
                                                                            
                                                                            	excdclass p
                                                                            	**type**\:  :py:class:`ExcdclassP <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP>`
                                                                            
                                                                            .. attribute:: flags
                                                                            
                                                                            	flags
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: police_flags
                                                                            
                                                                            	police flags
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: sbuck_name
                                                                            
                                                                            	sbuck name
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..65
                                                                            
                                                                            .. attribute:: sbuck_type
                                                                            
                                                                            	sbuck type
                                                                            	**type**\:  :py:class:`SharedBucketType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.SharedBucketType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police, self).__init__()

                                                                                self.yang_name = "police"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("rate", ("rate", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate)), ("burst", ("burst", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst)), ("peak-rate", ("peak_rate", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate)), ("peak-burst", ("peak_burst", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst)), ("cdvt", ("cdvt", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt)), ("conform-actns", ("conform_actns", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns)), ("exceed-actns", ("exceed_actns", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns)), ("violate-actns", ("violate_actns", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns)), ("confclass-encode", ("confclass_encode", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode)), ("confclass-p", ("confclass_p", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP)), ("excdclass-encode", ("excdclass_encode", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode)), ("excdclass-p", ("excdclass_p", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                    ('police_flags', (YLeaf(YType.uint32, 'police-flags'), ['int'])),
                                                                                    ('sbuck_name', (YLeaf(YType.str, 'sbuck-name'), ['str'])),
                                                                                    ('sbuck_type', (YLeaf(YType.enumeration, 'sbuck-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'SharedBucketType', '')])),
                                                                                ])
                                                                                self.flags = None
                                                                                self.police_flags = None
                                                                                self.sbuck_name = None
                                                                                self.sbuck_type = None

                                                                                self.rate = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate()
                                                                                self.rate.parent = self
                                                                                self._children_name_map["rate"] = "rate"

                                                                                self.burst = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst()
                                                                                self.burst.parent = self
                                                                                self._children_name_map["burst"] = "burst"

                                                                                self.peak_rate = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate()
                                                                                self.peak_rate.parent = self
                                                                                self._children_name_map["peak_rate"] = "peak-rate"

                                                                                self.peak_burst = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst()
                                                                                self.peak_burst.parent = self
                                                                                self._children_name_map["peak_burst"] = "peak-burst"

                                                                                self.cdvt = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt()
                                                                                self.cdvt.parent = self
                                                                                self._children_name_map["cdvt"] = "cdvt"

                                                                                self.conform_actns = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns()
                                                                                self.conform_actns.parent = self
                                                                                self._children_name_map["conform_actns"] = "conform-actns"

                                                                                self.exceed_actns = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns()
                                                                                self.exceed_actns.parent = self
                                                                                self._children_name_map["exceed_actns"] = "exceed-actns"

                                                                                self.violate_actns = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns()
                                                                                self.violate_actns.parent = self
                                                                                self._children_name_map["violate_actns"] = "violate-actns"

                                                                                self.confclass_encode = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode()
                                                                                self.confclass_encode.parent = self
                                                                                self._children_name_map["confclass_encode"] = "confclass-encode"

                                                                                self.confclass_p = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP()
                                                                                self.confclass_p.parent = self
                                                                                self._children_name_map["confclass_p"] = "confclass-p"

                                                                                self.excdclass_encode = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode()
                                                                                self.excdclass_encode.parent = self
                                                                                self._children_name_map["excdclass_encode"] = "excdclass-encode"

                                                                                self.excdclass_p = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP()
                                                                                self.excdclass_p.parent = self
                                                                                self._children_name_map["excdclass_p"] = "excdclass-p"
                                                                                self._segment_path = lambda: "police"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police, ['flags', 'police_flags', 'sbuck_name', 'sbuck_type'], name, value)


                                                                            class Rate(Entity):
                                                                                """
                                                                                rate
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate, self).__init__()

                                                                                    self.yang_name = "rate"
                                                                                    self.yang_parent_name = "police"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.unit = None
                                                                                    self._segment_path = lambda: "rate"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate, ['value', 'unit'], name, value)


                                                                            class Burst(Entity):
                                                                                """
                                                                                burst
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst, self).__init__()

                                                                                    self.yang_name = "burst"
                                                                                    self.yang_parent_name = "police"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.unit = None
                                                                                    self._segment_path = lambda: "burst"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst, ['value', 'unit'], name, value)


                                                                            class PeakRate(Entity):
                                                                                """
                                                                                peak rate
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate, self).__init__()

                                                                                    self.yang_name = "peak-rate"
                                                                                    self.yang_parent_name = "police"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.unit = None
                                                                                    self._segment_path = lambda: "peak-rate"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate, ['value', 'unit'], name, value)


                                                                            class PeakBurst(Entity):
                                                                                """
                                                                                peak burst
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst, self).__init__()

                                                                                    self.yang_name = "peak-burst"
                                                                                    self.yang_parent_name = "police"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.unit = None
                                                                                    self._segment_path = lambda: "peak-burst"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst, ['value', 'unit'], name, value)


                                                                            class Cdvt(Entity):
                                                                                """
                                                                                cdvt
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt, self).__init__()

                                                                                    self.yang_name = "cdvt"
                                                                                    self.yang_parent_name = "police"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.unit = None
                                                                                    self._segment_path = lambda: "cdvt"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt, ['value', 'unit'], name, value)


                                                                            class ConformActns(Entity):
                                                                                """
                                                                                conform actns
                                                                                
                                                                                .. attribute:: police_action_array
                                                                                
                                                                                	police action array
                                                                                	**type**\: list of  		 :py:class:`PoliceActionArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns, self).__init__()

                                                                                    self.yang_name = "conform-actns"
                                                                                    self.yang_parent_name = "police"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("police-action-array", ("police_action_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.police_action_array = YList(self)
                                                                                    self._segment_path = lambda: "conform-actns"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns, [], name, value)


                                                                                class PoliceActionArray(Entity):
                                                                                    """
                                                                                    police action array
                                                                                    
                                                                                    .. attribute:: mark
                                                                                    
                                                                                    	mark
                                                                                    	**type**\:  :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark>`
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	type
                                                                                    	**type**\:  :py:class:`PoliceActionTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PoliceActionTypeEn>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray, self).__init__()

                                                                                        self.yang_name = "police-action-array"
                                                                                        self.yang_parent_name = "conform-actns"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("mark", ("mark", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark))])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PoliceActionTypeEn', '')])),
                                                                                        ])
                                                                                        self.type = None

                                                                                        self.mark = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark()
                                                                                        self.mark.parent = self
                                                                                        self._children_name_map["mark"] = "mark"
                                                                                        self._segment_path = lambda: "police-action-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray, ['type'], name, value)


                                                                                    class Mark(Entity):
                                                                                        """
                                                                                        mark
                                                                                        
                                                                                        .. attribute:: type
                                                                                        
                                                                                        	type
                                                                                        	**type**\:  :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                                        
                                                                                        .. attribute:: mark_flags
                                                                                        
                                                                                        	mark flags
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        .. attribute:: value
                                                                                        
                                                                                        	value
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark, self).__init__()

                                                                                            self.yang_name = "mark"
                                                                                            self.yang_parent_name = "police-action-array"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MarkTypeEn', '')])),
                                                                                                ('mark_flags', (YLeaf(YType.uint32, 'mark-flags'), ['int'])),
                                                                                                ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                            ])
                                                                                            self.type = None
                                                                                            self.mark_flags = None
                                                                                            self.value = None
                                                                                            self._segment_path = lambda: "mark"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark, ['type', 'mark_flags', 'value'], name, value)


                                                                            class ExceedActns(Entity):
                                                                                """
                                                                                exceed actns
                                                                                
                                                                                .. attribute:: police_action_array
                                                                                
                                                                                	police action array
                                                                                	**type**\: list of  		 :py:class:`PoliceActionArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns, self).__init__()

                                                                                    self.yang_name = "exceed-actns"
                                                                                    self.yang_parent_name = "police"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("police-action-array", ("police_action_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.police_action_array = YList(self)
                                                                                    self._segment_path = lambda: "exceed-actns"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns, [], name, value)


                                                                                class PoliceActionArray(Entity):
                                                                                    """
                                                                                    police action array
                                                                                    
                                                                                    .. attribute:: mark
                                                                                    
                                                                                    	mark
                                                                                    	**type**\:  :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark>`
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	type
                                                                                    	**type**\:  :py:class:`PoliceActionTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PoliceActionTypeEn>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray, self).__init__()

                                                                                        self.yang_name = "police-action-array"
                                                                                        self.yang_parent_name = "exceed-actns"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("mark", ("mark", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark))])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PoliceActionTypeEn', '')])),
                                                                                        ])
                                                                                        self.type = None

                                                                                        self.mark = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark()
                                                                                        self.mark.parent = self
                                                                                        self._children_name_map["mark"] = "mark"
                                                                                        self._segment_path = lambda: "police-action-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray, ['type'], name, value)


                                                                                    class Mark(Entity):
                                                                                        """
                                                                                        mark
                                                                                        
                                                                                        .. attribute:: type
                                                                                        
                                                                                        	type
                                                                                        	**type**\:  :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                                        
                                                                                        .. attribute:: mark_flags
                                                                                        
                                                                                        	mark flags
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        .. attribute:: value
                                                                                        
                                                                                        	value
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark, self).__init__()

                                                                                            self.yang_name = "mark"
                                                                                            self.yang_parent_name = "police-action-array"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MarkTypeEn', '')])),
                                                                                                ('mark_flags', (YLeaf(YType.uint32, 'mark-flags'), ['int'])),
                                                                                                ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                            ])
                                                                                            self.type = None
                                                                                            self.mark_flags = None
                                                                                            self.value = None
                                                                                            self._segment_path = lambda: "mark"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark, ['type', 'mark_flags', 'value'], name, value)


                                                                            class ViolateActns(Entity):
                                                                                """
                                                                                violate actns
                                                                                
                                                                                .. attribute:: police_action_array
                                                                                
                                                                                	police action array
                                                                                	**type**\: list of  		 :py:class:`PoliceActionArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns, self).__init__()

                                                                                    self.yang_name = "violate-actns"
                                                                                    self.yang_parent_name = "police"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("police-action-array", ("police_action_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.police_action_array = YList(self)
                                                                                    self._segment_path = lambda: "violate-actns"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns, [], name, value)


                                                                                class PoliceActionArray(Entity):
                                                                                    """
                                                                                    police action array
                                                                                    
                                                                                    .. attribute:: mark
                                                                                    
                                                                                    	mark
                                                                                    	**type**\:  :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark>`
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	type
                                                                                    	**type**\:  :py:class:`PoliceActionTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PoliceActionTypeEn>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray, self).__init__()

                                                                                        self.yang_name = "police-action-array"
                                                                                        self.yang_parent_name = "violate-actns"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("mark", ("mark", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark))])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PoliceActionTypeEn', '')])),
                                                                                        ])
                                                                                        self.type = None

                                                                                        self.mark = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark()
                                                                                        self.mark.parent = self
                                                                                        self._children_name_map["mark"] = "mark"
                                                                                        self._segment_path = lambda: "police-action-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray, ['type'], name, value)


                                                                                    class Mark(Entity):
                                                                                        """
                                                                                        mark
                                                                                        
                                                                                        .. attribute:: type
                                                                                        
                                                                                        	type
                                                                                        	**type**\:  :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                                        
                                                                                        .. attribute:: mark_flags
                                                                                        
                                                                                        	mark flags
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        .. attribute:: value
                                                                                        
                                                                                        	value
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark, self).__init__()

                                                                                            self.yang_name = "mark"
                                                                                            self.yang_parent_name = "police-action-array"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MarkTypeEn', '')])),
                                                                                                ('mark_flags', (YLeaf(YType.uint32, 'mark-flags'), ['int'])),
                                                                                                ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                            ])
                                                                                            self.type = None
                                                                                            self.mark_flags = None
                                                                                            self.value = None
                                                                                            self._segment_path = lambda: "mark"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark, ['type', 'mark_flags', 'value'], name, value)


                                                                            class ConfclassEncode(Entity):
                                                                                """
                                                                                confclass encode
                                                                                
                                                                                .. attribute:: inline_cmap
                                                                                
                                                                                	inline cmap
                                                                                	**type**\:  :py:class:`InlineCmap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap>`
                                                                                
                                                                                .. attribute:: enc
                                                                                
                                                                                	enc
                                                                                	**type**\:  :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                                
                                                                                .. attribute:: class_name
                                                                                
                                                                                	class name
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..65
                                                                                
                                                                                .. attribute:: hd
                                                                                
                                                                                	hd
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..18446744073709551615
                                                                                
                                                                                .. attribute:: idx
                                                                                
                                                                                	idx
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode, self).__init__()

                                                                                    self.yang_name = "confclass-encode"
                                                                                    self.yang_parent_name = "police"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("inline-cmap", ("inline_cmap", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('enc', (YLeaf(YType.enumeration, 'enc'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyObjEncEn', '')])),
                                                                                        ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                                                        ('hd', (YLeaf(YType.uint64, 'hd'), ['int'])),
                                                                                        ('idx', (YLeaf(YType.uint8, 'idx'), ['int'])),
                                                                                    ])
                                                                                    self.enc = None
                                                                                    self.class_name = None
                                                                                    self.hd = None
                                                                                    self.idx = None

                                                                                    self.inline_cmap = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap()
                                                                                    self.inline_cmap.parent = self
                                                                                    self._children_name_map["inline_cmap"] = "inline-cmap"
                                                                                    self._segment_path = lambda: "confclass-encode"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode, ['enc', 'class_name', 'hd', 'idx'], name, value)


                                                                                class InlineCmap(Entity):
                                                                                    """
                                                                                    inline cmap
                                                                                    
                                                                                    .. attribute:: match_infop
                                                                                    
                                                                                    	Pointer to the first Match info
                                                                                    	**type**\:  :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop>`
                                                                                    
                                                                                    .. attribute:: mode
                                                                                    
                                                                                    	Inline Class\-Map Mode Match any/all
                                                                                    	**type**\:  :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                                    
                                                                                    .. attribute:: flags
                                                                                    
                                                                                    	Inline Class\-Map flags
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: match_count
                                                                                    
                                                                                    	Number of Match infos
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap, self).__init__()

                                                                                        self.yang_name = "inline-cmap"
                                                                                        self.yang_parent_name = "confclass-encode"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("match-infop", ("match_infop", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop))])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapModeEn', '')])),
                                                                                            ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                            ('match_count', (YLeaf(YType.uint32, 'match-count'), ['int'])),
                                                                                        ])
                                                                                        self.mode = None
                                                                                        self.flags = None
                                                                                        self.match_count = None

                                                                                        self.match_infop = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop()
                                                                                        self.match_infop.parent = self
                                                                                        self._children_name_map["match_infop"] = "match-infop"
                                                                                        self._segment_path = lambda: "inline-cmap"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap, ['mode', 'flags', 'match_count'], name, value)


                                                                                    class MatchInfop(Entity):
                                                                                        """
                                                                                        Pointer to the first Match info
                                                                                        
                                                                                        .. attribute:: class_match_info_st
                                                                                        
                                                                                        	class match info st
                                                                                        	**type**\: list of  		 :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop, self).__init__()

                                                                                            self.yang_name = "match-infop"
                                                                                            self.yang_parent_name = "inline-cmap"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("class-match-info-st", ("class_match_info_st", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.class_match_info_st = YList(self)
                                                                                            self._segment_path = lambda: "match-infop"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop, [], name, value)


                                                                                        class ClassMatchInfoSt(Entity):
                                                                                            """
                                                                                            class match info st
                                                                                            
                                                                                            .. attribute:: match_data
                                                                                            
                                                                                            	Match criteria
                                                                                            	**type**\:  :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                            
                                                                                            .. attribute:: flags
                                                                                            
                                                                                            	Flags
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                                self.yang_name = "class-match-info-st"
                                                                                                self.yang_parent_name = "match-infop"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("match-data", ("match_data", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData))])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                                ])
                                                                                                self.flags = None

                                                                                                self.match_data = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                                self.match_data.parent = self
                                                                                                self._children_name_map["match_data"] = "match-data"
                                                                                                self._segment_path = lambda: "class-match-info-st"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                            class MatchData(Entity):
                                                                                                """
                                                                                                Match criteria
                                                                                                
                                                                                                .. attribute:: ipv4_dscp
                                                                                                
                                                                                                	IPv4 DSCP
                                                                                                	**type**\:  :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                                
                                                                                                .. attribute:: ipv6_dscp
                                                                                                
                                                                                                	IPv6 DSCP
                                                                                                	**type**\:  :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                                
                                                                                                .. attribute:: dscp
                                                                                                
                                                                                                	Match DSCP range array
                                                                                                	**type**\:  :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                                
                                                                                                .. attribute:: ipv4_prec
                                                                                                
                                                                                                	IPv4 Precedence
                                                                                                	**type**\:  :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                                
                                                                                                .. attribute:: ipv6_prec
                                                                                                
                                                                                                	IPv6 Precedence
                                                                                                	**type**\:  :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                                
                                                                                                .. attribute:: prec
                                                                                                
                                                                                                	Match Precedence array
                                                                                                	**type**\:  :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                                
                                                                                                .. attribute:: discard_class
                                                                                                
                                                                                                	Match Discard Class array
                                                                                                	**type**\:  :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                                
                                                                                                .. attribute:: qos_group
                                                                                                
                                                                                                	Match QoS group array
                                                                                                	**type**\:  :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                                
                                                                                                .. attribute:: traffic_class
                                                                                                
                                                                                                	Match Traffic class array
                                                                                                	**type**\:  :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                                
                                                                                                .. attribute:: proto
                                                                                                
                                                                                                	Match Protocol array
                                                                                                	**type**\:  :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                                
                                                                                                .. attribute:: icmp_v4
                                                                                                
                                                                                                	Match ICMPV4 Protocol
                                                                                                	**type**\:  :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                                
                                                                                                .. attribute:: icmp_v6
                                                                                                
                                                                                                	Match ICMPV6 Protocol array
                                                                                                	**type**\:  :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                                
                                                                                                .. attribute:: ipv4_packet_len
                                                                                                
                                                                                                	IPv4 packet length array
                                                                                                	**type**\:  :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                                
                                                                                                .. attribute:: ipv6_packet_len
                                                                                                
                                                                                                	IPv6 packet length array
                                                                                                	**type**\:  :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                                
                                                                                                .. attribute:: packet_len
                                                                                                
                                                                                                	Match packet length array
                                                                                                	**type**\:  :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                                
                                                                                                .. attribute:: flow_tag
                                                                                                
                                                                                                	Match flow\-tag array
                                                                                                	**type**\:  :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                                
                                                                                                .. attribute:: tcp_flag
                                                                                                
                                                                                                	Match tcp flag value
                                                                                                	**type**\:  :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                                
                                                                                                .. attribute:: icmpv4_type
                                                                                                
                                                                                                	Match ipv4 icmp type
                                                                                                	**type**\:  :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                                
                                                                                                .. attribute:: icmpv4_code
                                                                                                
                                                                                                	Match ipv4 icmp code
                                                                                                	**type**\:  :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                                
                                                                                                .. attribute:: icmpv6_type
                                                                                                
                                                                                                	Match ipv6 icmp type
                                                                                                	**type**\:  :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                                
                                                                                                .. attribute:: icmpv6_code
                                                                                                
                                                                                                	Match ipv6 icmp code
                                                                                                	**type**\:  :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                                
                                                                                                .. attribute:: mpls_exp
                                                                                                
                                                                                                	Match MPLS experimental topmost array
                                                                                                	**type**\:  :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                                
                                                                                                .. attribute:: mpls_exp_imp
                                                                                                
                                                                                                	Match MPLS experimental imposition array
                                                                                                	**type**\:  :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                                
                                                                                                .. attribute:: mpls_disp_ipv4_acl
                                                                                                
                                                                                                	MPLS Disposition IPv4 Access\-list
                                                                                                	**type**\:  :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                                
                                                                                                .. attribute:: mpls_disp_ipv6_acl
                                                                                                
                                                                                                	MPLS Disposition IPv6 Access\-list
                                                                                                	**type**\:  :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                                
                                                                                                .. attribute:: mpls_top_label
                                                                                                
                                                                                                	MPLS Topmost LABEL
                                                                                                	**type**\:  :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                                
                                                                                                .. attribute:: cos
                                                                                                
                                                                                                	Match CoS array
                                                                                                	**type**\:  :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                                
                                                                                                .. attribute:: cos_inr
                                                                                                
                                                                                                	Match inner header CoS
                                                                                                	**type**\:  :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                                
                                                                                                .. attribute:: dei
                                                                                                
                                                                                                	Match DEI Bit
                                                                                                	**type**\:  :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                                
                                                                                                .. attribute:: dei_inr
                                                                                                
                                                                                                	Match inner DEI Bit
                                                                                                	**type**\:  :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                                
                                                                                                .. attribute:: vlan
                                                                                                
                                                                                                	Match VLAN array
                                                                                                	**type**\:  :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                                
                                                                                                .. attribute:: vlan_inr
                                                                                                
                                                                                                	Match inner header VLAN range array
                                                                                                	**type**\:  :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                                
                                                                                                .. attribute:: fr_dlci
                                                                                                
                                                                                                	Match FR DLCI range array
                                                                                                	**type**\:  :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                                
                                                                                                .. attribute:: src_mac
                                                                                                
                                                                                                	Match Source MAC address
                                                                                                	**type**\:  :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                                
                                                                                                .. attribute:: dst_mac
                                                                                                
                                                                                                	Match Destination MAC address
                                                                                                	**type**\:  :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                                
                                                                                                .. attribute:: atm_clp
                                                                                                
                                                                                                	Match ATM CLP level
                                                                                                	**type**\:  :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                                
                                                                                                .. attribute:: fr_de
                                                                                                
                                                                                                	Match FR DE value
                                                                                                	**type**\:  :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                                
                                                                                                .. attribute:: ipv4_acl
                                                                                                
                                                                                                	IPv4 Access\-list
                                                                                                	**type**\:  :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                                
                                                                                                .. attribute:: ipv6_acl
                                                                                                
                                                                                                	IPv6 Access\-list
                                                                                                	**type**\:  :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                                
                                                                                                .. attribute:: ether_service_acl
                                                                                                
                                                                                                	Ethernet\-Services Access\-list
                                                                                                	**type**\:  :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                                
                                                                                                .. attribute:: avail_id
                                                                                                
                                                                                                	Available Identifiers
                                                                                                	**type**\:  :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                                
                                                                                                .. attribute:: media_type
                                                                                                
                                                                                                	Media Type
                                                                                                	**type**\:  :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                                
                                                                                                .. attribute:: subs_protocol
                                                                                                
                                                                                                	Protocol
                                                                                                	**type**\:  :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                                
                                                                                                .. attribute:: dnis
                                                                                                
                                                                                                	DNIS
                                                                                                	**type**\:  :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                                
                                                                                                .. attribute:: dnis_regex
                                                                                                
                                                                                                	DNIS Regular Expression
                                                                                                	**type**\:  :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                                
                                                                                                .. attribute:: domain
                                                                                                
                                                                                                	Domain Name
                                                                                                	**type**\:  :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                                
                                                                                                .. attribute:: domain_regex
                                                                                                
                                                                                                	Domain Regular Expression
                                                                                                	**type**\:  :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                                
                                                                                                .. attribute:: nas_port
                                                                                                
                                                                                                	NAS Port
                                                                                                	**type**\:  :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                                
                                                                                                .. attribute:: service_name
                                                                                                
                                                                                                	Service Name
                                                                                                	**type**\:  :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                                
                                                                                                .. attribute:: service_name_regex
                                                                                                
                                                                                                	Service Name Regular Exp
                                                                                                	**type**\:  :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                                
                                                                                                .. attribute:: src_addr_ipv4
                                                                                                
                                                                                                	Source Address IPV4
                                                                                                	**type**\:  :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                                
                                                                                                .. attribute:: dst_addr_ipv4
                                                                                                
                                                                                                	Destination Address IPV4
                                                                                                	**type**\:  :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                                
                                                                                                .. attribute:: src_addr_ipv6
                                                                                                
                                                                                                	Source Address IPV6
                                                                                                	**type**\:  :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                                
                                                                                                .. attribute:: dst_addr_ipv6
                                                                                                
                                                                                                	Destination Address IPV6
                                                                                                	**type**\:  :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                                
                                                                                                .. attribute:: src_addr_mac
                                                                                                
                                                                                                	Source Address MAC
                                                                                                	**type**\:  :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                                
                                                                                                .. attribute:: timer
                                                                                                
                                                                                                	Timer
                                                                                                	**type**\:  :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                                
                                                                                                .. attribute:: timer_regexp
                                                                                                
                                                                                                	Timer Regular Expression
                                                                                                	**type**\:  :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                                
                                                                                                .. attribute:: tunnel_name
                                                                                                
                                                                                                	Tunnel Name
                                                                                                	**type**\:  :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                                
                                                                                                .. attribute:: tunnel_name_regex
                                                                                                
                                                                                                	Tunnel Name Regular Expression
                                                                                                	**type**\:  :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                                
                                                                                                .. attribute:: user_name
                                                                                                
                                                                                                	User Name
                                                                                                	**type**\:  :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                                
                                                                                                .. attribute:: user_name_regex
                                                                                                
                                                                                                	User Name Regular Expression
                                                                                                	**type**\:  :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                                
                                                                                                .. attribute:: auth_username
                                                                                                
                                                                                                	Authenticated User Name
                                                                                                	**type**\:  :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                                
                                                                                                .. attribute:: auth_username_regex
                                                                                                
                                                                                                	Authenticated User Name RegEx
                                                                                                	**type**\:  :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                                
                                                                                                .. attribute:: unauth_username
                                                                                                
                                                                                                	Unauthenticated User Name
                                                                                                	**type**\:  :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                                
                                                                                                .. attribute:: unauth_username_regex
                                                                                                
                                                                                                	Unauthenticated User Name RegEx
                                                                                                	**type**\:  :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                                
                                                                                                .. attribute:: auth_domain
                                                                                                
                                                                                                	Authenticated domain name
                                                                                                	**type**\:  :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                                
                                                                                                .. attribute:: auth_domain_regex
                                                                                                
                                                                                                	Authenticated Domain Name RegEx
                                                                                                	**type**\:  :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                                
                                                                                                .. attribute:: unauth_domain
                                                                                                
                                                                                                	Unauthenticated Domain Name
                                                                                                	**type**\:  :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                                
                                                                                                .. attribute:: unauth_domain_regex
                                                                                                
                                                                                                	Unauthenticated Domain Name RegEx
                                                                                                	**type**\:  :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                                
                                                                                                .. attribute:: vendor_id
                                                                                                
                                                                                                	Vendor ID
                                                                                                	**type**\:  :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                                
                                                                                                .. attribute:: vendor_id_regex
                                                                                                
                                                                                                	Vendor ID RegEx
                                                                                                	**type**\:  :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                                
                                                                                                .. attribute:: access_interface
                                                                                                
                                                                                                	Access interface
                                                                                                	**type**\:  :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                                
                                                                                                .. attribute:: input_interface
                                                                                                
                                                                                                	Input interface
                                                                                                	**type**\:  :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                                
                                                                                                .. attribute:: input_intfhdl
                                                                                                
                                                                                                	Input interface handle
                                                                                                	**type**\:  :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                                
                                                                                                .. attribute:: ethertype
                                                                                                
                                                                                                	Ethernet type
                                                                                                	**type**\:  :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                                
                                                                                                .. attribute:: flow_key_data
                                                                                                
                                                                                                	Flow key structure
                                                                                                	**type**\:  :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                                
                                                                                                .. attribute:: dhcp_client_id
                                                                                                
                                                                                                	Dhcp Client ID
                                                                                                	**type**\:  :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                                
                                                                                                .. attribute:: dhcp_client_id_regex
                                                                                                
                                                                                                	Dhcp Client ID RegEx
                                                                                                	**type**\:  :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                                
                                                                                                .. attribute:: circuit_id
                                                                                                
                                                                                                	Circuit ID
                                                                                                	**type**\:  :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                                
                                                                                                .. attribute:: circuit_id_regex
                                                                                                
                                                                                                	Circuit ID RegEx
                                                                                                	**type**\:  :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                                
                                                                                                .. attribute:: remote_id
                                                                                                
                                                                                                	Remote ID
                                                                                                	**type**\:  :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                                
                                                                                                .. attribute:: remote_id_regex
                                                                                                
                                                                                                	Remote ID RegEx
                                                                                                	**type**\:  :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                                
                                                                                                .. attribute:: src_port
                                                                                                
                                                                                                	Source port
                                                                                                	**type**\:  :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                                
                                                                                                .. attribute:: dst_port
                                                                                                
                                                                                                	Destination port
                                                                                                	**type**\:  :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	type
                                                                                                	**type**\:  :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                                
                                                                                                .. attribute:: mpls_top_eos
                                                                                                
                                                                                                	MPLS Topmost EOS
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: fragment_type
                                                                                                
                                                                                                	Fragment type
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: authen_status
                                                                                                
                                                                                                	Authentication Status
                                                                                                	**type**\:  :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                                
                                                                                                .. attribute:: mlp_negotiated
                                                                                                
                                                                                                	MLP Negotiated
                                                                                                	**type**\:  :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                                    self.yang_name = "match-data"
                                                                                                    self.yang_parent_name = "class-match-info-st"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv4-dscp", ("ipv4_dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp)), ("ipv6-dscp", ("ipv6_dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp)), ("dscp", ("dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp)), ("ipv4-prec", ("ipv4_prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec)), ("ipv6-prec", ("ipv6_prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec)), ("prec", ("prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec)), ("discard-class", ("discard_class", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass)), ("qos-group", ("qos_group", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup)), ("traffic-class", ("traffic_class", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass)), ("proto", ("proto", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto)), ("icmp-v4", ("icmp_v4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4)), ("icmp-v6", ("icmp_v6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6)), ("ipv4-packet-len", ("ipv4_packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen)), ("ipv6-packet-len", ("ipv6_packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen)), ("packet-len", ("packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen)), ("flow-tag", ("flow_tag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag)), ("tcp-flag", ("tcp_flag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag)), ("icmpv4-type", ("icmpv4_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type)), ("icmpv4-code", ("icmpv4_code", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code)), ("icmpv6-type", ("icmpv6_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type)), ("icmpv6-code", ("icmpv6_code", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code)), ("mpls-exp", ("mpls_exp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp)), ("mpls-exp-imp", ("mpls_exp_imp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp)), ("mpls-disp-ipv4-acl", ("mpls_disp_ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl)), ("mpls-disp-ipv6-acl", ("mpls_disp_ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl)), ("mpls-top-label", ("mpls_top_label", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel)), ("cos", ("cos", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos)), ("cos-inr", ("cos_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr)), ("dei", ("dei", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei)), ("dei-inr", ("dei_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr)), ("vlan", ("vlan", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan)), ("vlan-inr", ("vlan_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)), ("fr-dlci", ("fr_dlci", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci)), ("src-mac", ("src_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac)), ("dst-mac", ("dst_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac)), ("atm-clp", ("atm_clp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp)), ("fr-de", ("fr_de", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe)), ("ipv4-acl", ("ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl)), ("ipv6-acl", ("ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl)), ("ether-service-acl", ("ether_service_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl)), ("avail-id", ("avail_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId)), ("media-type", ("media_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType)), ("subs-protocol", ("subs_protocol", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol)), ("dnis", ("dnis", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis)), ("dnis-regex", ("dnis_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex)), ("domain", ("domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain)), ("domain-regex", ("domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex)), ("nas-port", ("nas_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort)), ("service-name", ("service_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName)), ("service-name-regex", ("service_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex)), ("src-addr-ipv4", ("src_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4)), ("dst-addr-ipv4", ("dst_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4)), ("src-addr-ipv6", ("src_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6)), ("dst-addr-ipv6", ("dst_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6)), ("src-addr-mac", ("src_addr_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac)), ("timer", ("timer", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer)), ("timer-regexp", ("timer_regexp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp)), ("tunnel-name", ("tunnel_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName)), ("tunnel-name-regex", ("tunnel_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex)), ("user-name", ("user_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName)), ("user-name-regex", ("user_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex)), ("auth-username", ("auth_username", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername)), ("auth-username-regex", ("auth_username_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex)), ("unauth-username", ("unauth_username", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername)), ("unauth-username-regex", ("unauth_username_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex)), ("auth-domain", ("auth_domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain)), ("auth-domain-regex", ("auth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex)), ("unauth-domain", ("unauth_domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain)), ("unauth-domain-regex", ("unauth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex)), ("vendor-id", ("vendor_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId)), ("vendor-id-regex", ("vendor_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex)), ("access-interface", ("access_interface", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface)), ("input-interface", ("input_interface", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface)), ("input-intfhdl", ("input_intfhdl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl)), ("ethertype", ("ethertype", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype)), ("flow-key-data", ("flow_key_data", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData)), ("dhcp-client-id", ("dhcp_client_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId)), ("dhcp-client-id-regex", ("dhcp_client_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex)), ("circuit-id", ("circuit_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId)), ("circuit-id-regex", ("circuit_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex)), ("remote-id", ("remote_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId)), ("remote-id-regex", ("remote_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex)), ("src-port", ("src_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort)), ("dst-port", ("dst_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort))])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchTypeEn', '')])),
                                                                                                        ('mpls_top_eos', (YLeaf(YType.uint8, 'mpls-top-eos'), ['int'])),
                                                                                                        ('fragment_type', (YLeaf(YType.uint8, 'fragment-type'), ['int'])),
                                                                                                        ('authen_status', (YLeaf(YType.enumeration, 'authen-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchAuthenStatusEn', '')])),
                                                                                                        ('mlp_negotiated', (YLeaf(YType.enumeration, 'mlp-negotiated'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchMlpNegotiatedEn', '')])),
                                                                                                    ])
                                                                                                    self.type = None
                                                                                                    self.mpls_top_eos = None
                                                                                                    self.fragment_type = None
                                                                                                    self.authen_status = None
                                                                                                    self.mlp_negotiated = None

                                                                                                    self.ipv4_dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                                    self.ipv4_dscp.parent = self
                                                                                                    self._children_name_map["ipv4_dscp"] = "ipv4-dscp"

                                                                                                    self.ipv6_dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                                    self.ipv6_dscp.parent = self
                                                                                                    self._children_name_map["ipv6_dscp"] = "ipv6-dscp"

                                                                                                    self.dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                                    self.dscp.parent = self
                                                                                                    self._children_name_map["dscp"] = "dscp"

                                                                                                    self.ipv4_prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                                    self.ipv4_prec.parent = self
                                                                                                    self._children_name_map["ipv4_prec"] = "ipv4-prec"

                                                                                                    self.ipv6_prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                                    self.ipv6_prec.parent = self
                                                                                                    self._children_name_map["ipv6_prec"] = "ipv6-prec"

                                                                                                    self.prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                                    self.prec.parent = self
                                                                                                    self._children_name_map["prec"] = "prec"

                                                                                                    self.discard_class = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                                    self.discard_class.parent = self
                                                                                                    self._children_name_map["discard_class"] = "discard-class"

                                                                                                    self.qos_group = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                                    self.qos_group.parent = self
                                                                                                    self._children_name_map["qos_group"] = "qos-group"

                                                                                                    self.traffic_class = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                                    self.traffic_class.parent = self
                                                                                                    self._children_name_map["traffic_class"] = "traffic-class"

                                                                                                    self.proto = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                                    self.proto.parent = self
                                                                                                    self._children_name_map["proto"] = "proto"

                                                                                                    self.icmp_v4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                                    self.icmp_v4.parent = self
                                                                                                    self._children_name_map["icmp_v4"] = "icmp-v4"

                                                                                                    self.icmp_v6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                                    self.icmp_v6.parent = self
                                                                                                    self._children_name_map["icmp_v6"] = "icmp-v6"

                                                                                                    self.ipv4_packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                                    self.ipv4_packet_len.parent = self
                                                                                                    self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"

                                                                                                    self.ipv6_packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                                    self.ipv6_packet_len.parent = self
                                                                                                    self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"

                                                                                                    self.packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                                    self.packet_len.parent = self
                                                                                                    self._children_name_map["packet_len"] = "packet-len"

                                                                                                    self.flow_tag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                                    self.flow_tag.parent = self
                                                                                                    self._children_name_map["flow_tag"] = "flow-tag"

                                                                                                    self.tcp_flag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                                    self.tcp_flag.parent = self
                                                                                                    self._children_name_map["tcp_flag"] = "tcp-flag"

                                                                                                    self.icmpv4_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                                    self.icmpv4_type.parent = self
                                                                                                    self._children_name_map["icmpv4_type"] = "icmpv4-type"

                                                                                                    self.icmpv4_code = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                                    self.icmpv4_code.parent = self
                                                                                                    self._children_name_map["icmpv4_code"] = "icmpv4-code"

                                                                                                    self.icmpv6_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                                    self.icmpv6_type.parent = self
                                                                                                    self._children_name_map["icmpv6_type"] = "icmpv6-type"

                                                                                                    self.icmpv6_code = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                                    self.icmpv6_code.parent = self
                                                                                                    self._children_name_map["icmpv6_code"] = "icmpv6-code"

                                                                                                    self.mpls_exp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                                    self.mpls_exp.parent = self
                                                                                                    self._children_name_map["mpls_exp"] = "mpls-exp"

                                                                                                    self.mpls_exp_imp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                                    self.mpls_exp_imp.parent = self
                                                                                                    self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"

                                                                                                    self.mpls_disp_ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                                    self.mpls_disp_ipv4_acl.parent = self
                                                                                                    self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"

                                                                                                    self.mpls_disp_ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                                    self.mpls_disp_ipv6_acl.parent = self
                                                                                                    self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"

                                                                                                    self.mpls_top_label = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                                    self.mpls_top_label.parent = self
                                                                                                    self._children_name_map["mpls_top_label"] = "mpls-top-label"

                                                                                                    self.cos = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                                    self.cos.parent = self
                                                                                                    self._children_name_map["cos"] = "cos"

                                                                                                    self.cos_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                                    self.cos_inr.parent = self
                                                                                                    self._children_name_map["cos_inr"] = "cos-inr"

                                                                                                    self.dei = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                                    self.dei.parent = self
                                                                                                    self._children_name_map["dei"] = "dei"

                                                                                                    self.dei_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                                    self.dei_inr.parent = self
                                                                                                    self._children_name_map["dei_inr"] = "dei-inr"

                                                                                                    self.vlan = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                                    self.vlan.parent = self
                                                                                                    self._children_name_map["vlan"] = "vlan"

                                                                                                    self.vlan_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                                    self.vlan_inr.parent = self
                                                                                                    self._children_name_map["vlan_inr"] = "vlan-inr"

                                                                                                    self.fr_dlci = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                                    self.fr_dlci.parent = self
                                                                                                    self._children_name_map["fr_dlci"] = "fr-dlci"

                                                                                                    self.src_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                                    self.src_mac.parent = self
                                                                                                    self._children_name_map["src_mac"] = "src-mac"

                                                                                                    self.dst_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                                    self.dst_mac.parent = self
                                                                                                    self._children_name_map["dst_mac"] = "dst-mac"

                                                                                                    self.atm_clp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                                    self.atm_clp.parent = self
                                                                                                    self._children_name_map["atm_clp"] = "atm-clp"

                                                                                                    self.fr_de = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                                    self.fr_de.parent = self
                                                                                                    self._children_name_map["fr_de"] = "fr-de"

                                                                                                    self.ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                                    self.ipv4_acl.parent = self
                                                                                                    self._children_name_map["ipv4_acl"] = "ipv4-acl"

                                                                                                    self.ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                                    self.ipv6_acl.parent = self
                                                                                                    self._children_name_map["ipv6_acl"] = "ipv6-acl"

                                                                                                    self.ether_service_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                                    self.ether_service_acl.parent = self
                                                                                                    self._children_name_map["ether_service_acl"] = "ether-service-acl"

                                                                                                    self.avail_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                                    self.avail_id.parent = self
                                                                                                    self._children_name_map["avail_id"] = "avail-id"

                                                                                                    self.media_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                                    self.media_type.parent = self
                                                                                                    self._children_name_map["media_type"] = "media-type"

                                                                                                    self.subs_protocol = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                                    self.subs_protocol.parent = self
                                                                                                    self._children_name_map["subs_protocol"] = "subs-protocol"

                                                                                                    self.dnis = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                                    self.dnis.parent = self
                                                                                                    self._children_name_map["dnis"] = "dnis"

                                                                                                    self.dnis_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                                    self.dnis_regex.parent = self
                                                                                                    self._children_name_map["dnis_regex"] = "dnis-regex"

                                                                                                    self.domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                                    self.domain.parent = self
                                                                                                    self._children_name_map["domain"] = "domain"

                                                                                                    self.domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                                    self.domain_regex.parent = self
                                                                                                    self._children_name_map["domain_regex"] = "domain-regex"

                                                                                                    self.nas_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                                    self.nas_port.parent = self
                                                                                                    self._children_name_map["nas_port"] = "nas-port"

                                                                                                    self.service_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                                    self.service_name.parent = self
                                                                                                    self._children_name_map["service_name"] = "service-name"

                                                                                                    self.service_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                                    self.service_name_regex.parent = self
                                                                                                    self._children_name_map["service_name_regex"] = "service-name-regex"

                                                                                                    self.src_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                                    self.src_addr_ipv4.parent = self
                                                                                                    self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"

                                                                                                    self.dst_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                                    self.dst_addr_ipv4.parent = self
                                                                                                    self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"

                                                                                                    self.src_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                                    self.src_addr_ipv6.parent = self
                                                                                                    self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"

                                                                                                    self.dst_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                                    self.dst_addr_ipv6.parent = self
                                                                                                    self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"

                                                                                                    self.src_addr_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                                    self.src_addr_mac.parent = self
                                                                                                    self._children_name_map["src_addr_mac"] = "src-addr-mac"

                                                                                                    self.timer = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                                    self.timer.parent = self
                                                                                                    self._children_name_map["timer"] = "timer"

                                                                                                    self.timer_regexp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                                    self.timer_regexp.parent = self
                                                                                                    self._children_name_map["timer_regexp"] = "timer-regexp"

                                                                                                    self.tunnel_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                                    self.tunnel_name.parent = self
                                                                                                    self._children_name_map["tunnel_name"] = "tunnel-name"

                                                                                                    self.tunnel_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                                    self.tunnel_name_regex.parent = self
                                                                                                    self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"

                                                                                                    self.user_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                                    self.user_name.parent = self
                                                                                                    self._children_name_map["user_name"] = "user-name"

                                                                                                    self.user_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                                    self.user_name_regex.parent = self
                                                                                                    self._children_name_map["user_name_regex"] = "user-name-regex"

                                                                                                    self.auth_username = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                                    self.auth_username.parent = self
                                                                                                    self._children_name_map["auth_username"] = "auth-username"

                                                                                                    self.auth_username_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                                    self.auth_username_regex.parent = self
                                                                                                    self._children_name_map["auth_username_regex"] = "auth-username-regex"

                                                                                                    self.unauth_username = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                                    self.unauth_username.parent = self
                                                                                                    self._children_name_map["unauth_username"] = "unauth-username"

                                                                                                    self.unauth_username_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                                    self.unauth_username_regex.parent = self
                                                                                                    self._children_name_map["unauth_username_regex"] = "unauth-username-regex"

                                                                                                    self.auth_domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                                    self.auth_domain.parent = self
                                                                                                    self._children_name_map["auth_domain"] = "auth-domain"

                                                                                                    self.auth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                                    self.auth_domain_regex.parent = self
                                                                                                    self._children_name_map["auth_domain_regex"] = "auth-domain-regex"

                                                                                                    self.unauth_domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                                    self.unauth_domain.parent = self
                                                                                                    self._children_name_map["unauth_domain"] = "unauth-domain"

                                                                                                    self.unauth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                                    self.unauth_domain_regex.parent = self
                                                                                                    self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"

                                                                                                    self.vendor_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                                    self.vendor_id.parent = self
                                                                                                    self._children_name_map["vendor_id"] = "vendor-id"

                                                                                                    self.vendor_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                                    self.vendor_id_regex.parent = self
                                                                                                    self._children_name_map["vendor_id_regex"] = "vendor-id-regex"

                                                                                                    self.access_interface = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                                    self.access_interface.parent = self
                                                                                                    self._children_name_map["access_interface"] = "access-interface"

                                                                                                    self.input_interface = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                                    self.input_interface.parent = self
                                                                                                    self._children_name_map["input_interface"] = "input-interface"

                                                                                                    self.input_intfhdl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                                    self.input_intfhdl.parent = self
                                                                                                    self._children_name_map["input_intfhdl"] = "input-intfhdl"

                                                                                                    self.ethertype = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                                    self.ethertype.parent = self
                                                                                                    self._children_name_map["ethertype"] = "ethertype"

                                                                                                    self.flow_key_data = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                                    self.flow_key_data.parent = self
                                                                                                    self._children_name_map["flow_key_data"] = "flow-key-data"

                                                                                                    self.dhcp_client_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                                    self.dhcp_client_id.parent = self
                                                                                                    self._children_name_map["dhcp_client_id"] = "dhcp-client-id"

                                                                                                    self.dhcp_client_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                                    self.dhcp_client_id_regex.parent = self
                                                                                                    self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"

                                                                                                    self.circuit_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                                    self.circuit_id.parent = self
                                                                                                    self._children_name_map["circuit_id"] = "circuit-id"

                                                                                                    self.circuit_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                                    self.circuit_id_regex.parent = self
                                                                                                    self._children_name_map["circuit_id_regex"] = "circuit-id-regex"

                                                                                                    self.remote_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                                    self.remote_id.parent = self
                                                                                                    self._children_name_map["remote_id"] = "remote-id"

                                                                                                    self.remote_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                                    self.remote_id_regex.parent = self
                                                                                                    self._children_name_map["remote_id_regex"] = "remote-id-regex"

                                                                                                    self.src_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                                    self.src_port.parent = self
                                                                                                    self._children_name_map["src_port"] = "src-port"

                                                                                                    self.dst_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                                    self.dst_port.parent = self
                                                                                                    self._children_name_map["dst_port"] = "dst-port"
                                                                                                    self._segment_path = lambda: "match-data"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, ['type', 'mpls_top_eos', 'fragment_type', 'authen_status', 'mlp_negotiated'], name, value)


                                                                                                class Ipv4Dscp(Entity):
                                                                                                    """
                                                                                                    IPv4 DSCP
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                        self.yang_name = "ipv4-dscp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ipv4-dscp"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "ipv4-dscp"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                                class Ipv6Dscp(Entity):
                                                                                                    """
                                                                                                    IPv6 DSCP
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                        self.yang_name = "ipv6-dscp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ipv6-dscp"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "ipv6-dscp"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                                class Dscp(Entity):
                                                                                                    """
                                                                                                    Match DSCP range array
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                        self.yang_name = "dscp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "dscp"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "dscp"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                                class Ipv4Prec(Entity):
                                                                                                    """
                                                                                                    IPv4 Precedence
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                        self.yang_name = "ipv4-prec"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "ipv4-prec"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                                class Ipv6Prec(Entity):
                                                                                                    """
                                                                                                    IPv6 Precedence
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                        self.yang_name = "ipv6-prec"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "ipv6-prec"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                                class Prec(Entity):
                                                                                                    """
                                                                                                    Match Precedence array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                        self.yang_name = "prec"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "prec"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                                class DiscardClass(Entity):
                                                                                                    """
                                                                                                    Match Discard Class array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                        self.yang_name = "discard-class"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "discard-class"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                                class QosGroup(Entity):
                                                                                                    """
                                                                                                    Match QoS group array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                        self.yang_name = "qos-group"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "qos-group"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "qos-group"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['min', 'max'], name, value)


                                                                                                class TrafficClass(Entity):
                                                                                                    """
                                                                                                    Match Traffic class array
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                        self.yang_name = "traffic-class"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "traffic-class"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "traffic-class"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['min', 'max'], name, value)


                                                                                                class Proto(Entity):
                                                                                                    """
                                                                                                    Match Protocol array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                        self.yang_name = "proto"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "proto"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "proto"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['min', 'max'], name, value)


                                                                                                class IcmpV4(Entity):
                                                                                                    """
                                                                                                    Match ICMPV4 Protocol
                                                                                                    
                                                                                                    .. attribute:: type
                                                                                                    
                                                                                                    	Protocol type
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: code
                                                                                                    
                                                                                                    	Protocol code
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                        self.yang_name = "icmp-v4"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                            ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                        ])
                                                                                                        self.type = None
                                                                                                        self.code = None
                                                                                                        self._segment_path = lambda: "icmp-v4"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['type', 'code'], name, value)


                                                                                                class IcmpV6(Entity):
                                                                                                    """
                                                                                                    Match ICMPV6 Protocol array
                                                                                                    
                                                                                                    .. attribute:: type
                                                                                                    
                                                                                                    	Protocol type
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: code
                                                                                                    
                                                                                                    	Protocol code
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                        self.yang_name = "icmp-v6"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                            ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                        ])
                                                                                                        self.type = None
                                                                                                        self.code = None
                                                                                                        self._segment_path = lambda: "icmp-v6"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['type', 'code'], name, value)


                                                                                                class Ipv4PacketLen(Entity):
                                                                                                    """
                                                                                                    IPv4 packet length array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                        self.yang_name = "ipv4-packet-len"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ipv4-packet-len"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "ipv4-packet-len"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                                class Ipv6PacketLen(Entity):
                                                                                                    """
                                                                                                    IPv6 packet length array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                        self.yang_name = "ipv6-packet-len"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ipv6-packet-len"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "ipv6-packet-len"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                                class PacketLen(Entity):
                                                                                                    """
                                                                                                    Match packet length array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                        self.yang_name = "packet-len"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "packet-len"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "packet-len"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                                class FlowTag(Entity):
                                                                                                    """
                                                                                                    Match flow\-tag array
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                        self.yang_name = "flow-tag"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "flow-tag"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "flow-tag"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['min', 'max'], name, value)


                                                                                                class TcpFlag(Entity):
                                                                                                    """
                                                                                                    Match tcp flag value
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	Value of TCP flag
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: match_any
                                                                                                    
                                                                                                    	Match any TCP flag bit
                                                                                                    	**type**\: bool
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                        self.yang_name = "tcp-flag"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                                            ('match_any', (YLeaf(YType.boolean, 'match-any'), ['bool'])),
                                                                                                        ])
                                                                                                        self.value = None
                                                                                                        self.match_any = None
                                                                                                        self._segment_path = lambda: "tcp-flag"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['value', 'match_any'], name, value)


                                                                                                class Icmpv4Type(Entity):
                                                                                                    """
                                                                                                    Match ipv4 icmp type
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                        self.yang_name = "icmpv4-type"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "icmpv4-type"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "icmpv4-type"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                                class Icmpv4Code(Entity):
                                                                                                    """
                                                                                                    Match ipv4 icmp code
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                        self.yang_name = "icmpv4-code"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "icmpv4-code"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "icmpv4-code"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                                class Icmpv6Type(Entity):
                                                                                                    """
                                                                                                    Match ipv6 icmp type
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                        self.yang_name = "icmpv6-type"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "icmpv6-type"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "icmpv6-type"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                                class Icmpv6Code(Entity):
                                                                                                    """
                                                                                                    Match ipv6 icmp code
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                        self.yang_name = "icmpv6-code"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "icmpv6-code"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "icmpv6-code"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                                class MplsExp(Entity):
                                                                                                    """
                                                                                                    Match MPLS experimental topmost array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                        self.yang_name = "mpls-exp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "mpls-exp"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                                class MplsExpImp(Entity):
                                                                                                    """
                                                                                                    Match MPLS experimental imposition array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                        self.yang_name = "mpls-exp-imp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "mpls-exp-imp"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                                class MplsDispIpv4Acl(Entity):
                                                                                                    """
                                                                                                    MPLS Disposition IPv4 Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                        self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "mpls-disp-ipv4-acl"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                                class MplsDispIpv6Acl(Entity):
                                                                                                    """
                                                                                                    MPLS Disposition IPv6 Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                        self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "mpls-disp-ipv6-acl"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                                class MplsTopLabel(Entity):
                                                                                                    """
                                                                                                    MPLS Topmost LABEL
                                                                                                    
                                                                                                    .. attribute:: uint32_rng_array
                                                                                                    
                                                                                                    	uint32 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                        self.yang_name = "mpls-top-label"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint32_rng_array", ("uint32_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint32_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "mpls-top-label"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                                    class Uint32RngArray(Entity):
                                                                                                        """
                                                                                                        uint32 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                            self.yang_name = "uint32_rng_array"
                                                                                                            self.yang_parent_name = "mpls-top-label"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint32, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint32, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint32_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['min', 'max'], name, value)


                                                                                                class Cos(Entity):
                                                                                                    """
                                                                                                    Match CoS array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                        self.yang_name = "cos"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "cos"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                                class CosInr(Entity):
                                                                                                    """
                                                                                                    Match inner header CoS
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                        self.yang_name = "cos-inr"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "cos-inr"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                                class Dei(Entity):
                                                                                                    """
                                                                                                    Match DEI Bit
                                                                                                    
                                                                                                    .. attribute:: bit_value
                                                                                                    
                                                                                                    	Value of the DEI bit
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                        self.yang_name = "dei"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                        ])
                                                                                                        self.bit_value = None
                                                                                                        self._segment_path = lambda: "dei"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                                class DeiInr(Entity):
                                                                                                    """
                                                                                                    Match inner DEI Bit
                                                                                                    
                                                                                                    .. attribute:: bit_value
                                                                                                    
                                                                                                    	Value of the DEI bit
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                        self.yang_name = "dei-inr"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                        ])
                                                                                                        self.bit_value = None
                                                                                                        self._segment_path = lambda: "dei-inr"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                                class Vlan(Entity):
                                                                                                    """
                                                                                                    Match VLAN array
                                                                                                    
                                                                                                    .. attribute:: vlan_id_array
                                                                                                    
                                                                                                    	vlan id array
                                                                                                    	**type**\: list of  		 :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                        self.yang_name = "vlan"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("vlan-id-array", ("vlan_id_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.vlan_id_array = YList(self)
                                                                                                        self._segment_path = lambda: "vlan"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                                    class VlanIdArray(Entity):
                                                                                                        """
                                                                                                        vlan id array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	VLAN mask
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                            self.yang_name = "vlan-id-array"
                                                                                                            self.yang_parent_name = "vlan"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                                ('mask', (YLeaf(YType.uint16, 'mask'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self.mask = None
                                                                                                            self._segment_path = lambda: "vlan-id-array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['min', 'max', 'mask'], name, value)


                                                                                                class VlanInr(Entity):
                                                                                                    """
                                                                                                    Match inner header VLAN range array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                        self.yang_name = "vlan-inr"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "vlan-inr"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "vlan-inr"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['min', 'max'], name, value)


                                                                                                class FrDlci(Entity):
                                                                                                    """
                                                                                                    Match FR DLCI range array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                        self.yang_name = "fr-dlci"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "fr-dlci"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "fr-dlci"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['min', 'max'], name, value)


                                                                                                class SrcMac(Entity):
                                                                                                    """
                                                                                                    Match Source MAC address
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                        self.yang_name = "src-mac"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                            ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.mac_addr = []
                                                                                                        self.mask = []
                                                                                                        self._segment_path = lambda: "src-mac"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                                class DstMac(Entity):
                                                                                                    """
                                                                                                    Match Destination MAC address
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                        self.yang_name = "dst-mac"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                            ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.mac_addr = []
                                                                                                        self.mask = []
                                                                                                        self._segment_path = lambda: "dst-mac"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                                class AtmClp(Entity):
                                                                                                    """
                                                                                                    Match ATM CLP level
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                        self.yang_name = "atm-clp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "atm-clp"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                                class FrDe(Entity):
                                                                                                    """
                                                                                                    Match FR DE value
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                        self.yang_name = "fr-de"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "fr-de"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                                class Ipv4Acl(Entity):
                                                                                                    """
                                                                                                    IPv4 Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                        self.yang_name = "ipv4-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "ipv4-acl"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                                class Ipv6Acl(Entity):
                                                                                                    """
                                                                                                    IPv6 Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                        self.yang_name = "ipv6-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "ipv6-acl"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                                class EtherServiceAcl(Entity):
                                                                                                    """
                                                                                                    Ethernet\-Services Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                        self.yang_name = "ether-service-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "ether-service-acl"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                                class AvailId(Entity):
                                                                                                    """
                                                                                                    Available Identifiers
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                        self.yang_name = "avail-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "avail-id"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                                class MediaType(Entity):
                                                                                                    """
                                                                                                    Media Type
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                        self.yang_name = "media-type"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "media-type"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                                class SubsProtocol(Entity):
                                                                                                    """
                                                                                                    Protocol
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                        self.yang_name = "subs-protocol"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "subs-protocol"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                                class Dnis(Entity):
                                                                                                    """
                                                                                                    DNIS
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                        self.yang_name = "dnis"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "dnis"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                                class DnisRegex(Entity):
                                                                                                    """
                                                                                                    DNIS Regular Expression
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                        self.yang_name = "dnis-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "dnis-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                                class Domain(Entity):
                                                                                                    """
                                                                                                    Domain Name
                                                                                                    
                                                                                                    .. attribute:: domain_array
                                                                                                    
                                                                                                    	domain array
                                                                                                    	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                        self.yang_name = "domain"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.domain_array = YList(self)
                                                                                                        self._segment_path = lambda: "domain"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                                    class DomainArray(Entity):
                                                                                                        """
                                                                                                        domain array
                                                                                                        
                                                                                                        .. attribute:: domain_name
                                                                                                        
                                                                                                        	domain name
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        .. attribute:: format_name
                                                                                                        
                                                                                                        	format name
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                            self.yang_name = "domain-array"
                                                                                                            self.yang_parent_name = "domain"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                                ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                            ])
                                                                                                            self.domain_name = None
                                                                                                            self.format_name = None
                                                                                                            self._segment_path = lambda: "domain-array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                                class DomainRegex(Entity):
                                                                                                    """
                                                                                                    Domain Regular Expression
                                                                                                    
                                                                                                    .. attribute:: domain_array
                                                                                                    
                                                                                                    	domain array
                                                                                                    	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                        self.yang_name = "domain-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.domain_array = YList(self)
                                                                                                        self._segment_path = lambda: "domain-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                                    class DomainArray(Entity):
                                                                                                        """
                                                                                                        domain array
                                                                                                        
                                                                                                        .. attribute:: domain_name
                                                                                                        
                                                                                                        	domain name
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        .. attribute:: format_name
                                                                                                        
                                                                                                        	format name
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                            self.yang_name = "domain-array"
                                                                                                            self.yang_parent_name = "domain-regex"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                                ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                            ])
                                                                                                            self.domain_name = None
                                                                                                            self.format_name = None
                                                                                                            self._segment_path = lambda: "domain-array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                                class NasPort(Entity):
                                                                                                    """
                                                                                                    NAS Port
                                                                                                    
                                                                                                    .. attribute:: nas_port_array
                                                                                                    
                                                                                                    	nas port array
                                                                                                    	**type**\: list of  		 :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                        self.yang_name = "nas-port"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("nas-port-array", ("nas_port_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.nas_port_array = YList(self)
                                                                                                        self._segment_path = lambda: "nas-port"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                                    class NasPortArray(Entity):
                                                                                                        """
                                                                                                        nas port array
                                                                                                        
                                                                                                        .. attribute:: sub_id
                                                                                                        
                                                                                                        	sub id
                                                                                                        	**type**\:  :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                        
                                                                                                        .. attribute:: operator
                                                                                                        
                                                                                                        	operator
                                                                                                        	**type**\:  :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                        
                                                                                                        .. attribute:: value
                                                                                                        
                                                                                                        	value
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                            self.yang_name = "nas-port-array"
                                                                                                            self.yang_parent_name = "nas-port"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('sub_id', (YLeaf(YType.enumeration, 'sub-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchNasPortSubIdEn', '')])),
                                                                                                                ('operator', (YLeaf(YType.enumeration, 'operator'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchLogicalOperatorEn', '')])),
                                                                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                                            ])
                                                                                                            self.sub_id = None
                                                                                                            self.operator = None
                                                                                                            self.value = None
                                                                                                            self._segment_path = lambda: "nas-port-array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['sub_id', 'operator', 'value'], name, value)


                                                                                                class ServiceName(Entity):
                                                                                                    """
                                                                                                    Service Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                        self.yang_name = "service-name"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "service-name"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                                class ServiceNameRegex(Entity):
                                                                                                    """
                                                                                                    Service Name Regular Exp
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                        self.yang_name = "service-name-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "service-name-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                                class SrcAddrIpv4(Entity):
                                                                                                    """
                                                                                                    Source Address IPV4
                                                                                                    
                                                                                                    .. attribute:: ipv4_addr_array
                                                                                                    
                                                                                                    	ipv4 addr array
                                                                                                    	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                        self.yang_name = "src-addr-ipv4"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.ipv4_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "src-addr-ipv4"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                                    class Ipv4AddrArray(Entity):
                                                                                                        """
                                                                                                        ipv4 addr array
                                                                                                        
                                                                                                        .. attribute:: prefix
                                                                                                        
                                                                                                        	prefix
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	mask
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                            self.yang_name = "ipv4-addr-array"
                                                                                                            self.yang_parent_name = "src-addr-ipv4"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                                ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                            ])
                                                                                                            self.prefix = None
                                                                                                            self.mask = None
                                                                                                            self._segment_path = lambda: "ipv4-addr-array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                                class DstAddrIpv4(Entity):
                                                                                                    """
                                                                                                    Destination Address IPV4
                                                                                                    
                                                                                                    .. attribute:: ipv4_addr_array
                                                                                                    
                                                                                                    	ipv4 addr array
                                                                                                    	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                        self.yang_name = "dst-addr-ipv4"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.ipv4_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "dst-addr-ipv4"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                                    class Ipv4AddrArray(Entity):
                                                                                                        """
                                                                                                        ipv4 addr array
                                                                                                        
                                                                                                        .. attribute:: prefix
                                                                                                        
                                                                                                        	prefix
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	mask
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                            self.yang_name = "ipv4-addr-array"
                                                                                                            self.yang_parent_name = "dst-addr-ipv4"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                                ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                            ])
                                                                                                            self.prefix = None
                                                                                                            self.mask = None
                                                                                                            self._segment_path = lambda: "ipv4-addr-array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                                class SrcAddrIpv6(Entity):
                                                                                                    """
                                                                                                    Source Address IPV6
                                                                                                    
                                                                                                    .. attribute:: ipv6_addr_array
                                                                                                    
                                                                                                    	ipv6 addr array
                                                                                                    	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                        self.yang_name = "src-addr-ipv6"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.ipv6_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "src-addr-ipv6"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                                    class Ipv6AddrArray(Entity):
                                                                                                        """
                                                                                                        ipv6 addr array
                                                                                                        
                                                                                                        .. attribute:: prefix
                                                                                                        
                                                                                                        	IPV6 prefix
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	IPV6 mask
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                            self.yang_name = "ipv6-addr-array"
                                                                                                            self.yang_parent_name = "src-addr-ipv6"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                                ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                            ])
                                                                                                            self.prefix = None
                                                                                                            self.mask = None
                                                                                                            self._segment_path = lambda: "ipv6-addr-array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                                class DstAddrIpv6(Entity):
                                                                                                    """
                                                                                                    Destination Address IPV6
                                                                                                    
                                                                                                    .. attribute:: ipv6_addr_array
                                                                                                    
                                                                                                    	ipv6 addr array
                                                                                                    	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                        self.yang_name = "dst-addr-ipv6"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.ipv6_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "dst-addr-ipv6"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                                    class Ipv6AddrArray(Entity):
                                                                                                        """
                                                                                                        ipv6 addr array
                                                                                                        
                                                                                                        .. attribute:: prefix
                                                                                                        
                                                                                                        	IPV6 prefix
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	IPV6 mask
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                            self.yang_name = "ipv6-addr-array"
                                                                                                            self.yang_parent_name = "dst-addr-ipv6"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                                ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                            ])
                                                                                                            self.prefix = None
                                                                                                            self.mask = None
                                                                                                            self._segment_path = lambda: "ipv6-addr-array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                                class SrcAddrMac(Entity):
                                                                                                    """
                                                                                                    Source Address MAC
                                                                                                    
                                                                                                    .. attribute:: mac_addr_array
                                                                                                    
                                                                                                    	mac addr array
                                                                                                    	**type**\: list of  		 :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                        self.yang_name = "src-addr-mac"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("mac-addr-array", ("mac_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.mac_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "src-addr-mac"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                                    class MacAddrArray(Entity):
                                                                                                        """
                                                                                                        mac addr array
                                                                                                        
                                                                                                        .. attribute:: mac_addr
                                                                                                        
                                                                                                        	MAC address
                                                                                                        	**type**\: list of int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	MAC mask
                                                                                                        	**type**\: list of int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                            self.yang_name = "mac-addr-array"
                                                                                                            self.yang_parent_name = "src-addr-mac"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                                ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                            ])
                                                                                                            self.mac_addr = []
                                                                                                            self.mask = []
                                                                                                            self._segment_path = lambda: "mac-addr-array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                                class Timer(Entity):
                                                                                                    """
                                                                                                    Timer
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                        self.yang_name = "timer"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "timer"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                                class TimerRegexp(Entity):
                                                                                                    """
                                                                                                    Timer Regular Expression
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                        self.yang_name = "timer-regexp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "timer-regexp"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                                class TunnelName(Entity):
                                                                                                    """
                                                                                                    Tunnel Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                        self.yang_name = "tunnel-name"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "tunnel-name"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                                class TunnelNameRegex(Entity):
                                                                                                    """
                                                                                                    Tunnel Name Regular Expression
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                        self.yang_name = "tunnel-name-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "tunnel-name-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                                class UserName(Entity):
                                                                                                    """
                                                                                                    User Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                        self.yang_name = "user-name"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "user-name"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                                class UserNameRegex(Entity):
                                                                                                    """
                                                                                                    User Name Regular Expression
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                        self.yang_name = "user-name-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "user-name-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                                class AuthUsername(Entity):
                                                                                                    """
                                                                                                    Authenticated User Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                        self.yang_name = "auth-username"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "auth-username"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                                class AuthUsernameRegex(Entity):
                                                                                                    """
                                                                                                    Authenticated User Name RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                        self.yang_name = "auth-username-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "auth-username-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                                class UnauthUsername(Entity):
                                                                                                    """
                                                                                                    Unauthenticated User Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                        self.yang_name = "unauth-username"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "unauth-username"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                                class UnauthUsernameRegex(Entity):
                                                                                                    """
                                                                                                    Unauthenticated User Name RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                        self.yang_name = "unauth-username-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "unauth-username-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                                class AuthDomain(Entity):
                                                                                                    """
                                                                                                    Authenticated domain name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                        self.yang_name = "auth-domain"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "auth-domain"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                                class AuthDomainRegex(Entity):
                                                                                                    """
                                                                                                    Authenticated Domain Name RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                        self.yang_name = "auth-domain-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "auth-domain-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                                class UnauthDomain(Entity):
                                                                                                    """
                                                                                                    Unauthenticated Domain Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                        self.yang_name = "unauth-domain"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "unauth-domain"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                                class UnauthDomainRegex(Entity):
                                                                                                    """
                                                                                                    Unauthenticated Domain Name RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                        self.yang_name = "unauth-domain-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "unauth-domain-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                                class VendorId(Entity):
                                                                                                    """
                                                                                                    Vendor ID
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                        self.yang_name = "vendor-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "vendor-id"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                                class VendorIdRegex(Entity):
                                                                                                    """
                                                                                                    Vendor ID RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                        self.yang_name = "vendor-id-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "vendor-id-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                                class AccessInterface(Entity):
                                                                                                    """
                                                                                                    Access interface
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                        self.yang_name = "access-interface"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "access-interface"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                                class InputInterface(Entity):
                                                                                                    """
                                                                                                    Input interface
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                        self.yang_name = "input-interface"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "input-interface"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                                class InputIntfhdl(Entity):
                                                                                                    """
                                                                                                    Input interface handle
                                                                                                    
                                                                                                    .. attribute:: uint64_array
                                                                                                    
                                                                                                    	uint64 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..18446744073709551615
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                        self.yang_name = "input-intfhdl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint64_array', (YLeafList(YType.uint64, 'uint64_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint64_array = []
                                                                                                        self._segment_path = lambda: "input-intfhdl"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                                class Ethertype(Entity):
                                                                                                    """
                                                                                                    Ethernet type
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                        self.yang_name = "ethertype"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ethertype"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "ethertype"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['min', 'max'], name, value)


                                                                                                class FlowKeyData(Entity):
                                                                                                    """
                                                                                                    Flow key structure
                                                                                                    
                                                                                                    .. attribute:: flow_keys
                                                                                                    
                                                                                                    	flow keys
                                                                                                    	**type**\:  :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                                    
                                                                                                    .. attribute:: max_count
                                                                                                    
                                                                                                    	Maximum count of flows
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: idle_timeout
                                                                                                    
                                                                                                    	Idle timeout of flows (in seconds)
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    	**units**\: second
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                        self.yang_name = "flow-key-data"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("flow-keys", ("flow_keys", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys))])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('max_count', (YLeaf(YType.uint16, 'max-count'), ['int'])),
                                                                                                            ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                                                        ])
                                                                                                        self.max_count = None
                                                                                                        self.idle_timeout = None

                                                                                                        self.flow_keys = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                        self.flow_keys.parent = self
                                                                                                        self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                        self._segment_path = lambda: "flow-key-data"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['max_count', 'idle_timeout'], name, value)


                                                                                                    class FlowKeys(Entity):
                                                                                                        """
                                                                                                        flow keys
                                                                                                        
                                                                                                        .. attribute:: keys
                                                                                                        
                                                                                                        	keys
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                        
                                                                                                        .. attribute:: num
                                                                                                        
                                                                                                        	num
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                            self.yang_name = "flow-keys"
                                                                                                            self.yang_parent_name = "flow-key-data"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('keys', (YLeaf(YType.str, 'keys'), ['str'])),
                                                                                                                ('num', (YLeaf(YType.uint8, 'num'), ['int'])),
                                                                                                            ])
                                                                                                            self.keys = None
                                                                                                            self.num = None
                                                                                                            self._segment_path = lambda: "flow-keys"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                                class DhcpClientId(Entity):
                                                                                                    """
                                                                                                    Dhcp Client ID
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                        self.yang_name = "dhcp-client-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "dhcp-client-id"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                                class DhcpClientIdRegex(Entity):
                                                                                                    """
                                                                                                    Dhcp Client ID RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                        self.yang_name = "dhcp-client-id-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "dhcp-client-id-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                                class CircuitId(Entity):
                                                                                                    """
                                                                                                    Circuit ID
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                        self.yang_name = "circuit-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "circuit-id"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                                class CircuitIdRegex(Entity):
                                                                                                    """
                                                                                                    Circuit ID RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                        self.yang_name = "circuit-id-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "circuit-id-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                                class RemoteId(Entity):
                                                                                                    """
                                                                                                    Remote ID
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                        self.yang_name = "remote-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "remote-id"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                                class RemoteIdRegex(Entity):
                                                                                                    """
                                                                                                    Remote ID RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                        self.yang_name = "remote-id-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "remote-id-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                                class SrcPort(Entity):
                                                                                                    """
                                                                                                    Source port
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                        self.yang_name = "src-port"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "src-port"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "src-port"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                                                class DstPort(Entity):
                                                                                                    """
                                                                                                    Destination port
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                        self.yang_name = "dst-port"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "dst-port"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "dst-port"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class ConfclassP(Entity):
                                                                                """
                                                                                confclass p
                                                                                
                                                                                .. attribute:: class_map_bg
                                                                                
                                                                                	class map bg
                                                                                	**type**\: list of  		 :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP, self).__init__()

                                                                                    self.yang_name = "confclass-p"
                                                                                    self.yang_parent_name = "police"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("class-map-bg", ("class_map_bg", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.class_map_bg = YList(self)
                                                                                    self._segment_path = lambda: "confclass-p"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP, [], name, value)


                                                                                class ClassMapBg(Entity):
                                                                                    """
                                                                                    class map bg
                                                                                    
                                                                                    .. attribute:: match_infop
                                                                                    
                                                                                    	Pointer to the first Match info
                                                                                    	**type**\:  :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop>`
                                                                                    
                                                                                    .. attribute:: name
                                                                                    
                                                                                    	Name of the class\-map
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..65
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	Class\-Map Type QoS/PBR/Netflow/..
                                                                                    	**type**\:  :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                                                    
                                                                                    .. attribute:: mode
                                                                                    
                                                                                    	Class\-Map Mode Match any/Match all
                                                                                    	**type**\:  :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                                    
                                                                                    .. attribute:: description
                                                                                    
                                                                                    	description
                                                                                    	**type**\: str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg, self).__init__()

                                                                                        self.yang_name = "class-map-bg"
                                                                                        self.yang_parent_name = "confclass-p"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("match-infop", ("match_infop", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop))])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapTypeEn', '')])),
                                                                                            ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapModeEn', '')])),
                                                                                            ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                        ])
                                                                                        self.name = None
                                                                                        self.type = None
                                                                                        self.mode = None
                                                                                        self.description = None

                                                                                        self.match_infop = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop()
                                                                                        self.match_infop.parent = self
                                                                                        self._children_name_map["match_infop"] = "match-infop"
                                                                                        self._segment_path = lambda: "class-map-bg"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg, ['name', 'type', 'mode', 'description'], name, value)


                                                                                    class MatchInfop(Entity):
                                                                                        """
                                                                                        Pointer to the first Match info
                                                                                        
                                                                                        .. attribute:: class_match_info_st
                                                                                        
                                                                                        	class match info st
                                                                                        	**type**\: list of  		 :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop, self).__init__()

                                                                                            self.yang_name = "match-infop"
                                                                                            self.yang_parent_name = "class-map-bg"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("class-match-info-st", ("class_match_info_st", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.class_match_info_st = YList(self)
                                                                                            self._segment_path = lambda: "match-infop"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop, [], name, value)


                                                                                        class ClassMatchInfoSt(Entity):
                                                                                            """
                                                                                            class match info st
                                                                                            
                                                                                            .. attribute:: match_data
                                                                                            
                                                                                            	Match criteria
                                                                                            	**type**\:  :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                            
                                                                                            .. attribute:: flags
                                                                                            
                                                                                            	Flags
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                                self.yang_name = "class-match-info-st"
                                                                                                self.yang_parent_name = "match-infop"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("match-data", ("match_data", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData))])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                                ])
                                                                                                self.flags = None

                                                                                                self.match_data = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                                self.match_data.parent = self
                                                                                                self._children_name_map["match_data"] = "match-data"
                                                                                                self._segment_path = lambda: "class-match-info-st"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                            class MatchData(Entity):
                                                                                                """
                                                                                                Match criteria
                                                                                                
                                                                                                .. attribute:: ipv4_dscp
                                                                                                
                                                                                                	IPv4 DSCP
                                                                                                	**type**\:  :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                                
                                                                                                .. attribute:: ipv6_dscp
                                                                                                
                                                                                                	IPv6 DSCP
                                                                                                	**type**\:  :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                                
                                                                                                .. attribute:: dscp
                                                                                                
                                                                                                	Match DSCP range array
                                                                                                	**type**\:  :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                                
                                                                                                .. attribute:: ipv4_prec
                                                                                                
                                                                                                	IPv4 Precedence
                                                                                                	**type**\:  :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                                
                                                                                                .. attribute:: ipv6_prec
                                                                                                
                                                                                                	IPv6 Precedence
                                                                                                	**type**\:  :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                                
                                                                                                .. attribute:: prec
                                                                                                
                                                                                                	Match Precedence array
                                                                                                	**type**\:  :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                                
                                                                                                .. attribute:: discard_class
                                                                                                
                                                                                                	Match Discard Class array
                                                                                                	**type**\:  :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                                
                                                                                                .. attribute:: qos_group
                                                                                                
                                                                                                	Match QoS group array
                                                                                                	**type**\:  :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                                
                                                                                                .. attribute:: traffic_class
                                                                                                
                                                                                                	Match Traffic class array
                                                                                                	**type**\:  :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                                
                                                                                                .. attribute:: proto
                                                                                                
                                                                                                	Match Protocol array
                                                                                                	**type**\:  :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                                
                                                                                                .. attribute:: icmp_v4
                                                                                                
                                                                                                	Match ICMPV4 Protocol
                                                                                                	**type**\:  :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                                
                                                                                                .. attribute:: icmp_v6
                                                                                                
                                                                                                	Match ICMPV6 Protocol array
                                                                                                	**type**\:  :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                                
                                                                                                .. attribute:: ipv4_packet_len
                                                                                                
                                                                                                	IPv4 packet length array
                                                                                                	**type**\:  :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                                
                                                                                                .. attribute:: ipv6_packet_len
                                                                                                
                                                                                                	IPv6 packet length array
                                                                                                	**type**\:  :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                                
                                                                                                .. attribute:: packet_len
                                                                                                
                                                                                                	Match packet length array
                                                                                                	**type**\:  :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                                
                                                                                                .. attribute:: flow_tag
                                                                                                
                                                                                                	Match flow\-tag array
                                                                                                	**type**\:  :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                                
                                                                                                .. attribute:: tcp_flag
                                                                                                
                                                                                                	Match tcp flag value
                                                                                                	**type**\:  :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                                
                                                                                                .. attribute:: icmpv4_type
                                                                                                
                                                                                                	Match ipv4 icmp type
                                                                                                	**type**\:  :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                                
                                                                                                .. attribute:: icmpv4_code
                                                                                                
                                                                                                	Match ipv4 icmp code
                                                                                                	**type**\:  :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                                
                                                                                                .. attribute:: icmpv6_type
                                                                                                
                                                                                                	Match ipv6 icmp type
                                                                                                	**type**\:  :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                                
                                                                                                .. attribute:: icmpv6_code
                                                                                                
                                                                                                	Match ipv6 icmp code
                                                                                                	**type**\:  :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                                
                                                                                                .. attribute:: mpls_exp
                                                                                                
                                                                                                	Match MPLS experimental topmost array
                                                                                                	**type**\:  :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                                
                                                                                                .. attribute:: mpls_exp_imp
                                                                                                
                                                                                                	Match MPLS experimental imposition array
                                                                                                	**type**\:  :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                                
                                                                                                .. attribute:: mpls_disp_ipv4_acl
                                                                                                
                                                                                                	MPLS Disposition IPv4 Access\-list
                                                                                                	**type**\:  :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                                
                                                                                                .. attribute:: mpls_disp_ipv6_acl
                                                                                                
                                                                                                	MPLS Disposition IPv6 Access\-list
                                                                                                	**type**\:  :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                                
                                                                                                .. attribute:: mpls_top_label
                                                                                                
                                                                                                	MPLS Topmost LABEL
                                                                                                	**type**\:  :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                                
                                                                                                .. attribute:: cos
                                                                                                
                                                                                                	Match CoS array
                                                                                                	**type**\:  :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                                
                                                                                                .. attribute:: cos_inr
                                                                                                
                                                                                                	Match inner header CoS
                                                                                                	**type**\:  :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                                
                                                                                                .. attribute:: dei
                                                                                                
                                                                                                	Match DEI Bit
                                                                                                	**type**\:  :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                                
                                                                                                .. attribute:: dei_inr
                                                                                                
                                                                                                	Match inner DEI Bit
                                                                                                	**type**\:  :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                                
                                                                                                .. attribute:: vlan
                                                                                                
                                                                                                	Match VLAN array
                                                                                                	**type**\:  :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                                
                                                                                                .. attribute:: vlan_inr
                                                                                                
                                                                                                	Match inner header VLAN range array
                                                                                                	**type**\:  :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                                
                                                                                                .. attribute:: fr_dlci
                                                                                                
                                                                                                	Match FR DLCI range array
                                                                                                	**type**\:  :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                                
                                                                                                .. attribute:: src_mac
                                                                                                
                                                                                                	Match Source MAC address
                                                                                                	**type**\:  :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                                
                                                                                                .. attribute:: dst_mac
                                                                                                
                                                                                                	Match Destination MAC address
                                                                                                	**type**\:  :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                                
                                                                                                .. attribute:: atm_clp
                                                                                                
                                                                                                	Match ATM CLP level
                                                                                                	**type**\:  :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                                
                                                                                                .. attribute:: fr_de
                                                                                                
                                                                                                	Match FR DE value
                                                                                                	**type**\:  :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                                
                                                                                                .. attribute:: ipv4_acl
                                                                                                
                                                                                                	IPv4 Access\-list
                                                                                                	**type**\:  :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                                
                                                                                                .. attribute:: ipv6_acl
                                                                                                
                                                                                                	IPv6 Access\-list
                                                                                                	**type**\:  :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                                
                                                                                                .. attribute:: ether_service_acl
                                                                                                
                                                                                                	Ethernet\-Services Access\-list
                                                                                                	**type**\:  :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                                
                                                                                                .. attribute:: avail_id
                                                                                                
                                                                                                	Available Identifiers
                                                                                                	**type**\:  :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                                
                                                                                                .. attribute:: media_type
                                                                                                
                                                                                                	Media Type
                                                                                                	**type**\:  :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                                
                                                                                                .. attribute:: subs_protocol
                                                                                                
                                                                                                	Protocol
                                                                                                	**type**\:  :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                                
                                                                                                .. attribute:: dnis
                                                                                                
                                                                                                	DNIS
                                                                                                	**type**\:  :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                                
                                                                                                .. attribute:: dnis_regex
                                                                                                
                                                                                                	DNIS Regular Expression
                                                                                                	**type**\:  :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                                
                                                                                                .. attribute:: domain
                                                                                                
                                                                                                	Domain Name
                                                                                                	**type**\:  :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                                
                                                                                                .. attribute:: domain_regex
                                                                                                
                                                                                                	Domain Regular Expression
                                                                                                	**type**\:  :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                                
                                                                                                .. attribute:: nas_port
                                                                                                
                                                                                                	NAS Port
                                                                                                	**type**\:  :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                                
                                                                                                .. attribute:: service_name
                                                                                                
                                                                                                	Service Name
                                                                                                	**type**\:  :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                                
                                                                                                .. attribute:: service_name_regex
                                                                                                
                                                                                                	Service Name Regular Exp
                                                                                                	**type**\:  :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                                
                                                                                                .. attribute:: src_addr_ipv4
                                                                                                
                                                                                                	Source Address IPV4
                                                                                                	**type**\:  :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                                
                                                                                                .. attribute:: dst_addr_ipv4
                                                                                                
                                                                                                	Destination Address IPV4
                                                                                                	**type**\:  :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                                
                                                                                                .. attribute:: src_addr_ipv6
                                                                                                
                                                                                                	Source Address IPV6
                                                                                                	**type**\:  :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                                
                                                                                                .. attribute:: dst_addr_ipv6
                                                                                                
                                                                                                	Destination Address IPV6
                                                                                                	**type**\:  :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                                
                                                                                                .. attribute:: src_addr_mac
                                                                                                
                                                                                                	Source Address MAC
                                                                                                	**type**\:  :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                                
                                                                                                .. attribute:: timer
                                                                                                
                                                                                                	Timer
                                                                                                	**type**\:  :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                                
                                                                                                .. attribute:: timer_regexp
                                                                                                
                                                                                                	Timer Regular Expression
                                                                                                	**type**\:  :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                                
                                                                                                .. attribute:: tunnel_name
                                                                                                
                                                                                                	Tunnel Name
                                                                                                	**type**\:  :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                                
                                                                                                .. attribute:: tunnel_name_regex
                                                                                                
                                                                                                	Tunnel Name Regular Expression
                                                                                                	**type**\:  :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                                
                                                                                                .. attribute:: user_name
                                                                                                
                                                                                                	User Name
                                                                                                	**type**\:  :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                                
                                                                                                .. attribute:: user_name_regex
                                                                                                
                                                                                                	User Name Regular Expression
                                                                                                	**type**\:  :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                                
                                                                                                .. attribute:: auth_username
                                                                                                
                                                                                                	Authenticated User Name
                                                                                                	**type**\:  :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                                
                                                                                                .. attribute:: auth_username_regex
                                                                                                
                                                                                                	Authenticated User Name RegEx
                                                                                                	**type**\:  :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                                
                                                                                                .. attribute:: unauth_username
                                                                                                
                                                                                                	Unauthenticated User Name
                                                                                                	**type**\:  :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                                
                                                                                                .. attribute:: unauth_username_regex
                                                                                                
                                                                                                	Unauthenticated User Name RegEx
                                                                                                	**type**\:  :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                                
                                                                                                .. attribute:: auth_domain
                                                                                                
                                                                                                	Authenticated domain name
                                                                                                	**type**\:  :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                                
                                                                                                .. attribute:: auth_domain_regex
                                                                                                
                                                                                                	Authenticated Domain Name RegEx
                                                                                                	**type**\:  :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                                
                                                                                                .. attribute:: unauth_domain
                                                                                                
                                                                                                	Unauthenticated Domain Name
                                                                                                	**type**\:  :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                                
                                                                                                .. attribute:: unauth_domain_regex
                                                                                                
                                                                                                	Unauthenticated Domain Name RegEx
                                                                                                	**type**\:  :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                                
                                                                                                .. attribute:: vendor_id
                                                                                                
                                                                                                	Vendor ID
                                                                                                	**type**\:  :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                                
                                                                                                .. attribute:: vendor_id_regex
                                                                                                
                                                                                                	Vendor ID RegEx
                                                                                                	**type**\:  :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                                
                                                                                                .. attribute:: access_interface
                                                                                                
                                                                                                	Access interface
                                                                                                	**type**\:  :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                                
                                                                                                .. attribute:: input_interface
                                                                                                
                                                                                                	Input interface
                                                                                                	**type**\:  :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                                
                                                                                                .. attribute:: input_intfhdl
                                                                                                
                                                                                                	Input interface handle
                                                                                                	**type**\:  :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                                
                                                                                                .. attribute:: ethertype
                                                                                                
                                                                                                	Ethernet type
                                                                                                	**type**\:  :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                                
                                                                                                .. attribute:: flow_key_data
                                                                                                
                                                                                                	Flow key structure
                                                                                                	**type**\:  :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                                
                                                                                                .. attribute:: dhcp_client_id
                                                                                                
                                                                                                	Dhcp Client ID
                                                                                                	**type**\:  :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                                
                                                                                                .. attribute:: dhcp_client_id_regex
                                                                                                
                                                                                                	Dhcp Client ID RegEx
                                                                                                	**type**\:  :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                                
                                                                                                .. attribute:: circuit_id
                                                                                                
                                                                                                	Circuit ID
                                                                                                	**type**\:  :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                                
                                                                                                .. attribute:: circuit_id_regex
                                                                                                
                                                                                                	Circuit ID RegEx
                                                                                                	**type**\:  :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                                
                                                                                                .. attribute:: remote_id
                                                                                                
                                                                                                	Remote ID
                                                                                                	**type**\:  :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                                
                                                                                                .. attribute:: remote_id_regex
                                                                                                
                                                                                                	Remote ID RegEx
                                                                                                	**type**\:  :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                                
                                                                                                .. attribute:: src_port
                                                                                                
                                                                                                	Source port
                                                                                                	**type**\:  :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                                
                                                                                                .. attribute:: dst_port
                                                                                                
                                                                                                	Destination port
                                                                                                	**type**\:  :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	type
                                                                                                	**type**\:  :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                                
                                                                                                .. attribute:: mpls_top_eos
                                                                                                
                                                                                                	MPLS Topmost EOS
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: fragment_type
                                                                                                
                                                                                                	Fragment type
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: authen_status
                                                                                                
                                                                                                	Authentication Status
                                                                                                	**type**\:  :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                                
                                                                                                .. attribute:: mlp_negotiated
                                                                                                
                                                                                                	MLP Negotiated
                                                                                                	**type**\:  :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                                    self.yang_name = "match-data"
                                                                                                    self.yang_parent_name = "class-match-info-st"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv4-dscp", ("ipv4_dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp)), ("ipv6-dscp", ("ipv6_dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp)), ("dscp", ("dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp)), ("ipv4-prec", ("ipv4_prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec)), ("ipv6-prec", ("ipv6_prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec)), ("prec", ("prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec)), ("discard-class", ("discard_class", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass)), ("qos-group", ("qos_group", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup)), ("traffic-class", ("traffic_class", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass)), ("proto", ("proto", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto)), ("icmp-v4", ("icmp_v4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4)), ("icmp-v6", ("icmp_v6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6)), ("ipv4-packet-len", ("ipv4_packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen)), ("ipv6-packet-len", ("ipv6_packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen)), ("packet-len", ("packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen)), ("flow-tag", ("flow_tag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag)), ("tcp-flag", ("tcp_flag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag)), ("icmpv4-type", ("icmpv4_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type)), ("icmpv4-code", ("icmpv4_code", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code)), ("icmpv6-type", ("icmpv6_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type)), ("icmpv6-code", ("icmpv6_code", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code)), ("mpls-exp", ("mpls_exp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp)), ("mpls-exp-imp", ("mpls_exp_imp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp)), ("mpls-disp-ipv4-acl", ("mpls_disp_ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl)), ("mpls-disp-ipv6-acl", ("mpls_disp_ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl)), ("mpls-top-label", ("mpls_top_label", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel)), ("cos", ("cos", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos)), ("cos-inr", ("cos_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr)), ("dei", ("dei", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei)), ("dei-inr", ("dei_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr)), ("vlan", ("vlan", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan)), ("vlan-inr", ("vlan_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)), ("fr-dlci", ("fr_dlci", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci)), ("src-mac", ("src_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac)), ("dst-mac", ("dst_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac)), ("atm-clp", ("atm_clp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp)), ("fr-de", ("fr_de", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe)), ("ipv4-acl", ("ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl)), ("ipv6-acl", ("ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl)), ("ether-service-acl", ("ether_service_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl)), ("avail-id", ("avail_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId)), ("media-type", ("media_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType)), ("subs-protocol", ("subs_protocol", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol)), ("dnis", ("dnis", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis)), ("dnis-regex", ("dnis_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex)), ("domain", ("domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain)), ("domain-regex", ("domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex)), ("nas-port", ("nas_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort)), ("service-name", ("service_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName)), ("service-name-regex", ("service_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex)), ("src-addr-ipv4", ("src_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4)), ("dst-addr-ipv4", ("dst_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4)), ("src-addr-ipv6", ("src_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6)), ("dst-addr-ipv6", ("dst_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6)), ("src-addr-mac", ("src_addr_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac)), ("timer", ("timer", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer)), ("timer-regexp", ("timer_regexp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp)), ("tunnel-name", ("tunnel_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName)), ("tunnel-name-regex", ("tunnel_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex)), ("user-name", ("user_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName)), ("user-name-regex", ("user_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex)), ("auth-username", ("auth_username", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername)), ("auth-username-regex", ("auth_username_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex)), ("unauth-username", ("unauth_username", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername)), ("unauth-username-regex", ("unauth_username_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex)), ("auth-domain", ("auth_domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain)), ("auth-domain-regex", ("auth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex)), ("unauth-domain", ("unauth_domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain)), ("unauth-domain-regex", ("unauth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex)), ("vendor-id", ("vendor_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId)), ("vendor-id-regex", ("vendor_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex)), ("access-interface", ("access_interface", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface)), ("input-interface", ("input_interface", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface)), ("input-intfhdl", ("input_intfhdl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl)), ("ethertype", ("ethertype", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype)), ("flow-key-data", ("flow_key_data", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData)), ("dhcp-client-id", ("dhcp_client_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId)), ("dhcp-client-id-regex", ("dhcp_client_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex)), ("circuit-id", ("circuit_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId)), ("circuit-id-regex", ("circuit_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex)), ("remote-id", ("remote_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId)), ("remote-id-regex", ("remote_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex)), ("src-port", ("src_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort)), ("dst-port", ("dst_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort))])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchTypeEn', '')])),
                                                                                                        ('mpls_top_eos', (YLeaf(YType.uint8, 'mpls-top-eos'), ['int'])),
                                                                                                        ('fragment_type', (YLeaf(YType.uint8, 'fragment-type'), ['int'])),
                                                                                                        ('authen_status', (YLeaf(YType.enumeration, 'authen-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchAuthenStatusEn', '')])),
                                                                                                        ('mlp_negotiated', (YLeaf(YType.enumeration, 'mlp-negotiated'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchMlpNegotiatedEn', '')])),
                                                                                                    ])
                                                                                                    self.type = None
                                                                                                    self.mpls_top_eos = None
                                                                                                    self.fragment_type = None
                                                                                                    self.authen_status = None
                                                                                                    self.mlp_negotiated = None

                                                                                                    self.ipv4_dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                                    self.ipv4_dscp.parent = self
                                                                                                    self._children_name_map["ipv4_dscp"] = "ipv4-dscp"

                                                                                                    self.ipv6_dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                                    self.ipv6_dscp.parent = self
                                                                                                    self._children_name_map["ipv6_dscp"] = "ipv6-dscp"

                                                                                                    self.dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                                    self.dscp.parent = self
                                                                                                    self._children_name_map["dscp"] = "dscp"

                                                                                                    self.ipv4_prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                                    self.ipv4_prec.parent = self
                                                                                                    self._children_name_map["ipv4_prec"] = "ipv4-prec"

                                                                                                    self.ipv6_prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                                    self.ipv6_prec.parent = self
                                                                                                    self._children_name_map["ipv6_prec"] = "ipv6-prec"

                                                                                                    self.prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                                    self.prec.parent = self
                                                                                                    self._children_name_map["prec"] = "prec"

                                                                                                    self.discard_class = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                                    self.discard_class.parent = self
                                                                                                    self._children_name_map["discard_class"] = "discard-class"

                                                                                                    self.qos_group = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                                    self.qos_group.parent = self
                                                                                                    self._children_name_map["qos_group"] = "qos-group"

                                                                                                    self.traffic_class = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                                    self.traffic_class.parent = self
                                                                                                    self._children_name_map["traffic_class"] = "traffic-class"

                                                                                                    self.proto = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                                    self.proto.parent = self
                                                                                                    self._children_name_map["proto"] = "proto"

                                                                                                    self.icmp_v4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                                    self.icmp_v4.parent = self
                                                                                                    self._children_name_map["icmp_v4"] = "icmp-v4"

                                                                                                    self.icmp_v6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                                    self.icmp_v6.parent = self
                                                                                                    self._children_name_map["icmp_v6"] = "icmp-v6"

                                                                                                    self.ipv4_packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                                    self.ipv4_packet_len.parent = self
                                                                                                    self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"

                                                                                                    self.ipv6_packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                                    self.ipv6_packet_len.parent = self
                                                                                                    self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"

                                                                                                    self.packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                                    self.packet_len.parent = self
                                                                                                    self._children_name_map["packet_len"] = "packet-len"

                                                                                                    self.flow_tag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                                    self.flow_tag.parent = self
                                                                                                    self._children_name_map["flow_tag"] = "flow-tag"

                                                                                                    self.tcp_flag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                                    self.tcp_flag.parent = self
                                                                                                    self._children_name_map["tcp_flag"] = "tcp-flag"

                                                                                                    self.icmpv4_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                                    self.icmpv4_type.parent = self
                                                                                                    self._children_name_map["icmpv4_type"] = "icmpv4-type"

                                                                                                    self.icmpv4_code = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                                    self.icmpv4_code.parent = self
                                                                                                    self._children_name_map["icmpv4_code"] = "icmpv4-code"

                                                                                                    self.icmpv6_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                                    self.icmpv6_type.parent = self
                                                                                                    self._children_name_map["icmpv6_type"] = "icmpv6-type"

                                                                                                    self.icmpv6_code = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                                    self.icmpv6_code.parent = self
                                                                                                    self._children_name_map["icmpv6_code"] = "icmpv6-code"

                                                                                                    self.mpls_exp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                                    self.mpls_exp.parent = self
                                                                                                    self._children_name_map["mpls_exp"] = "mpls-exp"

                                                                                                    self.mpls_exp_imp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                                    self.mpls_exp_imp.parent = self
                                                                                                    self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"

                                                                                                    self.mpls_disp_ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                                    self.mpls_disp_ipv4_acl.parent = self
                                                                                                    self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"

                                                                                                    self.mpls_disp_ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                                    self.mpls_disp_ipv6_acl.parent = self
                                                                                                    self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"

                                                                                                    self.mpls_top_label = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                                    self.mpls_top_label.parent = self
                                                                                                    self._children_name_map["mpls_top_label"] = "mpls-top-label"

                                                                                                    self.cos = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                                    self.cos.parent = self
                                                                                                    self._children_name_map["cos"] = "cos"

                                                                                                    self.cos_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                                    self.cos_inr.parent = self
                                                                                                    self._children_name_map["cos_inr"] = "cos-inr"

                                                                                                    self.dei = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                                    self.dei.parent = self
                                                                                                    self._children_name_map["dei"] = "dei"

                                                                                                    self.dei_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                                    self.dei_inr.parent = self
                                                                                                    self._children_name_map["dei_inr"] = "dei-inr"

                                                                                                    self.vlan = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                                    self.vlan.parent = self
                                                                                                    self._children_name_map["vlan"] = "vlan"

                                                                                                    self.vlan_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                                    self.vlan_inr.parent = self
                                                                                                    self._children_name_map["vlan_inr"] = "vlan-inr"

                                                                                                    self.fr_dlci = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                                    self.fr_dlci.parent = self
                                                                                                    self._children_name_map["fr_dlci"] = "fr-dlci"

                                                                                                    self.src_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                                    self.src_mac.parent = self
                                                                                                    self._children_name_map["src_mac"] = "src-mac"

                                                                                                    self.dst_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                                    self.dst_mac.parent = self
                                                                                                    self._children_name_map["dst_mac"] = "dst-mac"

                                                                                                    self.atm_clp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                                    self.atm_clp.parent = self
                                                                                                    self._children_name_map["atm_clp"] = "atm-clp"

                                                                                                    self.fr_de = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                                    self.fr_de.parent = self
                                                                                                    self._children_name_map["fr_de"] = "fr-de"

                                                                                                    self.ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                                    self.ipv4_acl.parent = self
                                                                                                    self._children_name_map["ipv4_acl"] = "ipv4-acl"

                                                                                                    self.ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                                    self.ipv6_acl.parent = self
                                                                                                    self._children_name_map["ipv6_acl"] = "ipv6-acl"

                                                                                                    self.ether_service_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                                    self.ether_service_acl.parent = self
                                                                                                    self._children_name_map["ether_service_acl"] = "ether-service-acl"

                                                                                                    self.avail_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                                    self.avail_id.parent = self
                                                                                                    self._children_name_map["avail_id"] = "avail-id"

                                                                                                    self.media_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                                    self.media_type.parent = self
                                                                                                    self._children_name_map["media_type"] = "media-type"

                                                                                                    self.subs_protocol = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                                    self.subs_protocol.parent = self
                                                                                                    self._children_name_map["subs_protocol"] = "subs-protocol"

                                                                                                    self.dnis = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                                    self.dnis.parent = self
                                                                                                    self._children_name_map["dnis"] = "dnis"

                                                                                                    self.dnis_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                                    self.dnis_regex.parent = self
                                                                                                    self._children_name_map["dnis_regex"] = "dnis-regex"

                                                                                                    self.domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                                    self.domain.parent = self
                                                                                                    self._children_name_map["domain"] = "domain"

                                                                                                    self.domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                                    self.domain_regex.parent = self
                                                                                                    self._children_name_map["domain_regex"] = "domain-regex"

                                                                                                    self.nas_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                                    self.nas_port.parent = self
                                                                                                    self._children_name_map["nas_port"] = "nas-port"

                                                                                                    self.service_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                                    self.service_name.parent = self
                                                                                                    self._children_name_map["service_name"] = "service-name"

                                                                                                    self.service_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                                    self.service_name_regex.parent = self
                                                                                                    self._children_name_map["service_name_regex"] = "service-name-regex"

                                                                                                    self.src_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                                    self.src_addr_ipv4.parent = self
                                                                                                    self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"

                                                                                                    self.dst_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                                    self.dst_addr_ipv4.parent = self
                                                                                                    self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"

                                                                                                    self.src_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                                    self.src_addr_ipv6.parent = self
                                                                                                    self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"

                                                                                                    self.dst_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                                    self.dst_addr_ipv6.parent = self
                                                                                                    self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"

                                                                                                    self.src_addr_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                                    self.src_addr_mac.parent = self
                                                                                                    self._children_name_map["src_addr_mac"] = "src-addr-mac"

                                                                                                    self.timer = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                                    self.timer.parent = self
                                                                                                    self._children_name_map["timer"] = "timer"

                                                                                                    self.timer_regexp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                                    self.timer_regexp.parent = self
                                                                                                    self._children_name_map["timer_regexp"] = "timer-regexp"

                                                                                                    self.tunnel_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                                    self.tunnel_name.parent = self
                                                                                                    self._children_name_map["tunnel_name"] = "tunnel-name"

                                                                                                    self.tunnel_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                                    self.tunnel_name_regex.parent = self
                                                                                                    self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"

                                                                                                    self.user_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                                    self.user_name.parent = self
                                                                                                    self._children_name_map["user_name"] = "user-name"

                                                                                                    self.user_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                                    self.user_name_regex.parent = self
                                                                                                    self._children_name_map["user_name_regex"] = "user-name-regex"

                                                                                                    self.auth_username = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                                    self.auth_username.parent = self
                                                                                                    self._children_name_map["auth_username"] = "auth-username"

                                                                                                    self.auth_username_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                                    self.auth_username_regex.parent = self
                                                                                                    self._children_name_map["auth_username_regex"] = "auth-username-regex"

                                                                                                    self.unauth_username = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                                    self.unauth_username.parent = self
                                                                                                    self._children_name_map["unauth_username"] = "unauth-username"

                                                                                                    self.unauth_username_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                                    self.unauth_username_regex.parent = self
                                                                                                    self._children_name_map["unauth_username_regex"] = "unauth-username-regex"

                                                                                                    self.auth_domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                                    self.auth_domain.parent = self
                                                                                                    self._children_name_map["auth_domain"] = "auth-domain"

                                                                                                    self.auth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                                    self.auth_domain_regex.parent = self
                                                                                                    self._children_name_map["auth_domain_regex"] = "auth-domain-regex"

                                                                                                    self.unauth_domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                                    self.unauth_domain.parent = self
                                                                                                    self._children_name_map["unauth_domain"] = "unauth-domain"

                                                                                                    self.unauth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                                    self.unauth_domain_regex.parent = self
                                                                                                    self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"

                                                                                                    self.vendor_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                                    self.vendor_id.parent = self
                                                                                                    self._children_name_map["vendor_id"] = "vendor-id"

                                                                                                    self.vendor_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                                    self.vendor_id_regex.parent = self
                                                                                                    self._children_name_map["vendor_id_regex"] = "vendor-id-regex"

                                                                                                    self.access_interface = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                                    self.access_interface.parent = self
                                                                                                    self._children_name_map["access_interface"] = "access-interface"

                                                                                                    self.input_interface = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                                    self.input_interface.parent = self
                                                                                                    self._children_name_map["input_interface"] = "input-interface"

                                                                                                    self.input_intfhdl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                                    self.input_intfhdl.parent = self
                                                                                                    self._children_name_map["input_intfhdl"] = "input-intfhdl"

                                                                                                    self.ethertype = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                                    self.ethertype.parent = self
                                                                                                    self._children_name_map["ethertype"] = "ethertype"

                                                                                                    self.flow_key_data = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                                    self.flow_key_data.parent = self
                                                                                                    self._children_name_map["flow_key_data"] = "flow-key-data"

                                                                                                    self.dhcp_client_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                                    self.dhcp_client_id.parent = self
                                                                                                    self._children_name_map["dhcp_client_id"] = "dhcp-client-id"

                                                                                                    self.dhcp_client_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                                    self.dhcp_client_id_regex.parent = self
                                                                                                    self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"

                                                                                                    self.circuit_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                                    self.circuit_id.parent = self
                                                                                                    self._children_name_map["circuit_id"] = "circuit-id"

                                                                                                    self.circuit_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                                    self.circuit_id_regex.parent = self
                                                                                                    self._children_name_map["circuit_id_regex"] = "circuit-id-regex"

                                                                                                    self.remote_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                                    self.remote_id.parent = self
                                                                                                    self._children_name_map["remote_id"] = "remote-id"

                                                                                                    self.remote_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                                    self.remote_id_regex.parent = self
                                                                                                    self._children_name_map["remote_id_regex"] = "remote-id-regex"

                                                                                                    self.src_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                                    self.src_port.parent = self
                                                                                                    self._children_name_map["src_port"] = "src-port"

                                                                                                    self.dst_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                                    self.dst_port.parent = self
                                                                                                    self._children_name_map["dst_port"] = "dst-port"
                                                                                                    self._segment_path = lambda: "match-data"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['type', 'mpls_top_eos', 'fragment_type', 'authen_status', 'mlp_negotiated'], name, value)


                                                                                                class Ipv4Dscp(Entity):
                                                                                                    """
                                                                                                    IPv4 DSCP
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                        self.yang_name = "ipv4-dscp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ipv4-dscp"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "ipv4-dscp"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                                class Ipv6Dscp(Entity):
                                                                                                    """
                                                                                                    IPv6 DSCP
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                        self.yang_name = "ipv6-dscp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ipv6-dscp"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "ipv6-dscp"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                                class Dscp(Entity):
                                                                                                    """
                                                                                                    Match DSCP range array
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                        self.yang_name = "dscp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "dscp"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "dscp"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                                class Ipv4Prec(Entity):
                                                                                                    """
                                                                                                    IPv4 Precedence
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                        self.yang_name = "ipv4-prec"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "ipv4-prec"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                                class Ipv6Prec(Entity):
                                                                                                    """
                                                                                                    IPv6 Precedence
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                        self.yang_name = "ipv6-prec"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "ipv6-prec"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                                class Prec(Entity):
                                                                                                    """
                                                                                                    Match Precedence array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                        self.yang_name = "prec"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "prec"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                                class DiscardClass(Entity):
                                                                                                    """
                                                                                                    Match Discard Class array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                        self.yang_name = "discard-class"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "discard-class"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                                class QosGroup(Entity):
                                                                                                    """
                                                                                                    Match QoS group array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                        self.yang_name = "qos-group"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "qos-group"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "qos-group"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['min', 'max'], name, value)


                                                                                                class TrafficClass(Entity):
                                                                                                    """
                                                                                                    Match Traffic class array
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                        self.yang_name = "traffic-class"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "traffic-class"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "traffic-class"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['min', 'max'], name, value)


                                                                                                class Proto(Entity):
                                                                                                    """
                                                                                                    Match Protocol array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                        self.yang_name = "proto"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "proto"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "proto"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['min', 'max'], name, value)


                                                                                                class IcmpV4(Entity):
                                                                                                    """
                                                                                                    Match ICMPV4 Protocol
                                                                                                    
                                                                                                    .. attribute:: type
                                                                                                    
                                                                                                    	Protocol type
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: code
                                                                                                    
                                                                                                    	Protocol code
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                        self.yang_name = "icmp-v4"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                            ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                        ])
                                                                                                        self.type = None
                                                                                                        self.code = None
                                                                                                        self._segment_path = lambda: "icmp-v4"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['type', 'code'], name, value)


                                                                                                class IcmpV6(Entity):
                                                                                                    """
                                                                                                    Match ICMPV6 Protocol array
                                                                                                    
                                                                                                    .. attribute:: type
                                                                                                    
                                                                                                    	Protocol type
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: code
                                                                                                    
                                                                                                    	Protocol code
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                        self.yang_name = "icmp-v6"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                            ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                        ])
                                                                                                        self.type = None
                                                                                                        self.code = None
                                                                                                        self._segment_path = lambda: "icmp-v6"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['type', 'code'], name, value)


                                                                                                class Ipv4PacketLen(Entity):
                                                                                                    """
                                                                                                    IPv4 packet length array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                        self.yang_name = "ipv4-packet-len"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ipv4-packet-len"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "ipv4-packet-len"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                                class Ipv6PacketLen(Entity):
                                                                                                    """
                                                                                                    IPv6 packet length array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                        self.yang_name = "ipv6-packet-len"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ipv6-packet-len"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "ipv6-packet-len"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                                class PacketLen(Entity):
                                                                                                    """
                                                                                                    Match packet length array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                        self.yang_name = "packet-len"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "packet-len"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "packet-len"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                                class FlowTag(Entity):
                                                                                                    """
                                                                                                    Match flow\-tag array
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                        self.yang_name = "flow-tag"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "flow-tag"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "flow-tag"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['min', 'max'], name, value)


                                                                                                class TcpFlag(Entity):
                                                                                                    """
                                                                                                    Match tcp flag value
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	Value of TCP flag
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: match_any
                                                                                                    
                                                                                                    	Match any TCP flag bit
                                                                                                    	**type**\: bool
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                        self.yang_name = "tcp-flag"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                                            ('match_any', (YLeaf(YType.boolean, 'match-any'), ['bool'])),
                                                                                                        ])
                                                                                                        self.value = None
                                                                                                        self.match_any = None
                                                                                                        self._segment_path = lambda: "tcp-flag"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['value', 'match_any'], name, value)


                                                                                                class Icmpv4Type(Entity):
                                                                                                    """
                                                                                                    Match ipv4 icmp type
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                        self.yang_name = "icmpv4-type"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "icmpv4-type"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "icmpv4-type"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                                class Icmpv4Code(Entity):
                                                                                                    """
                                                                                                    Match ipv4 icmp code
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                        self.yang_name = "icmpv4-code"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "icmpv4-code"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "icmpv4-code"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                                class Icmpv6Type(Entity):
                                                                                                    """
                                                                                                    Match ipv6 icmp type
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                        self.yang_name = "icmpv6-type"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "icmpv6-type"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "icmpv6-type"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                                class Icmpv6Code(Entity):
                                                                                                    """
                                                                                                    Match ipv6 icmp code
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                        self.yang_name = "icmpv6-code"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "icmpv6-code"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "icmpv6-code"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                                class MplsExp(Entity):
                                                                                                    """
                                                                                                    Match MPLS experimental topmost array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                        self.yang_name = "mpls-exp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "mpls-exp"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                                class MplsExpImp(Entity):
                                                                                                    """
                                                                                                    Match MPLS experimental imposition array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                        self.yang_name = "mpls-exp-imp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "mpls-exp-imp"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                                class MplsDispIpv4Acl(Entity):
                                                                                                    """
                                                                                                    MPLS Disposition IPv4 Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                        self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "mpls-disp-ipv4-acl"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                                class MplsDispIpv6Acl(Entity):
                                                                                                    """
                                                                                                    MPLS Disposition IPv6 Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                        self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "mpls-disp-ipv6-acl"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                                class MplsTopLabel(Entity):
                                                                                                    """
                                                                                                    MPLS Topmost LABEL
                                                                                                    
                                                                                                    .. attribute:: uint32_rng_array
                                                                                                    
                                                                                                    	uint32 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                        self.yang_name = "mpls-top-label"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint32_rng_array", ("uint32_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint32_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "mpls-top-label"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                                    class Uint32RngArray(Entity):
                                                                                                        """
                                                                                                        uint32 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                            self.yang_name = "uint32_rng_array"
                                                                                                            self.yang_parent_name = "mpls-top-label"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint32, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint32, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint32_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['min', 'max'], name, value)


                                                                                                class Cos(Entity):
                                                                                                    """
                                                                                                    Match CoS array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                        self.yang_name = "cos"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "cos"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                                class CosInr(Entity):
                                                                                                    """
                                                                                                    Match inner header CoS
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                        self.yang_name = "cos-inr"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "cos-inr"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                                class Dei(Entity):
                                                                                                    """
                                                                                                    Match DEI Bit
                                                                                                    
                                                                                                    .. attribute:: bit_value
                                                                                                    
                                                                                                    	Value of the DEI bit
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                        self.yang_name = "dei"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                        ])
                                                                                                        self.bit_value = None
                                                                                                        self._segment_path = lambda: "dei"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                                class DeiInr(Entity):
                                                                                                    """
                                                                                                    Match inner DEI Bit
                                                                                                    
                                                                                                    .. attribute:: bit_value
                                                                                                    
                                                                                                    	Value of the DEI bit
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                        self.yang_name = "dei-inr"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                        ])
                                                                                                        self.bit_value = None
                                                                                                        self._segment_path = lambda: "dei-inr"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                                class Vlan(Entity):
                                                                                                    """
                                                                                                    Match VLAN array
                                                                                                    
                                                                                                    .. attribute:: vlan_id_array
                                                                                                    
                                                                                                    	vlan id array
                                                                                                    	**type**\: list of  		 :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                        self.yang_name = "vlan"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("vlan-id-array", ("vlan_id_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.vlan_id_array = YList(self)
                                                                                                        self._segment_path = lambda: "vlan"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                                    class VlanIdArray(Entity):
                                                                                                        """
                                                                                                        vlan id array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	VLAN mask
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                            self.yang_name = "vlan-id-array"
                                                                                                            self.yang_parent_name = "vlan"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                                ('mask', (YLeaf(YType.uint16, 'mask'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self.mask = None
                                                                                                            self._segment_path = lambda: "vlan-id-array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['min', 'max', 'mask'], name, value)


                                                                                                class VlanInr(Entity):
                                                                                                    """
                                                                                                    Match inner header VLAN range array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                        self.yang_name = "vlan-inr"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "vlan-inr"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "vlan-inr"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['min', 'max'], name, value)


                                                                                                class FrDlci(Entity):
                                                                                                    """
                                                                                                    Match FR DLCI range array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                        self.yang_name = "fr-dlci"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "fr-dlci"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "fr-dlci"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['min', 'max'], name, value)


                                                                                                class SrcMac(Entity):
                                                                                                    """
                                                                                                    Match Source MAC address
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                        self.yang_name = "src-mac"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                            ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.mac_addr = []
                                                                                                        self.mask = []
                                                                                                        self._segment_path = lambda: "src-mac"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                                class DstMac(Entity):
                                                                                                    """
                                                                                                    Match Destination MAC address
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                        self.yang_name = "dst-mac"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                            ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.mac_addr = []
                                                                                                        self.mask = []
                                                                                                        self._segment_path = lambda: "dst-mac"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                                class AtmClp(Entity):
                                                                                                    """
                                                                                                    Match ATM CLP level
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                        self.yang_name = "atm-clp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "atm-clp"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                                class FrDe(Entity):
                                                                                                    """
                                                                                                    Match FR DE value
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                        self.yang_name = "fr-de"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "fr-de"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                                class Ipv4Acl(Entity):
                                                                                                    """
                                                                                                    IPv4 Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                        self.yang_name = "ipv4-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "ipv4-acl"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                                class Ipv6Acl(Entity):
                                                                                                    """
                                                                                                    IPv6 Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                        self.yang_name = "ipv6-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "ipv6-acl"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                                class EtherServiceAcl(Entity):
                                                                                                    """
                                                                                                    Ethernet\-Services Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                        self.yang_name = "ether-service-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "ether-service-acl"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                                class AvailId(Entity):
                                                                                                    """
                                                                                                    Available Identifiers
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                        self.yang_name = "avail-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "avail-id"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                                class MediaType(Entity):
                                                                                                    """
                                                                                                    Media Type
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                        self.yang_name = "media-type"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "media-type"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                                class SubsProtocol(Entity):
                                                                                                    """
                                                                                                    Protocol
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                        self.yang_name = "subs-protocol"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "subs-protocol"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                                class Dnis(Entity):
                                                                                                    """
                                                                                                    DNIS
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                        self.yang_name = "dnis"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "dnis"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                                class DnisRegex(Entity):
                                                                                                    """
                                                                                                    DNIS Regular Expression
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                        self.yang_name = "dnis-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "dnis-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                                class Domain(Entity):
                                                                                                    """
                                                                                                    Domain Name
                                                                                                    
                                                                                                    .. attribute:: domain_array
                                                                                                    
                                                                                                    	domain array
                                                                                                    	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                        self.yang_name = "domain"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.domain_array = YList(self)
                                                                                                        self._segment_path = lambda: "domain"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                                    class DomainArray(Entity):
                                                                                                        """
                                                                                                        domain array
                                                                                                        
                                                                                                        .. attribute:: domain_name
                                                                                                        
                                                                                                        	domain name
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        .. attribute:: format_name
                                                                                                        
                                                                                                        	format name
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                            self.yang_name = "domain-array"
                                                                                                            self.yang_parent_name = "domain"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                                ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                            ])
                                                                                                            self.domain_name = None
                                                                                                            self.format_name = None
                                                                                                            self._segment_path = lambda: "domain-array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                                class DomainRegex(Entity):
                                                                                                    """
                                                                                                    Domain Regular Expression
                                                                                                    
                                                                                                    .. attribute:: domain_array
                                                                                                    
                                                                                                    	domain array
                                                                                                    	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                        self.yang_name = "domain-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.domain_array = YList(self)
                                                                                                        self._segment_path = lambda: "domain-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                                    class DomainArray(Entity):
                                                                                                        """
                                                                                                        domain array
                                                                                                        
                                                                                                        .. attribute:: domain_name
                                                                                                        
                                                                                                        	domain name
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        .. attribute:: format_name
                                                                                                        
                                                                                                        	format name
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                            self.yang_name = "domain-array"
                                                                                                            self.yang_parent_name = "domain-regex"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                                ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                            ])
                                                                                                            self.domain_name = None
                                                                                                            self.format_name = None
                                                                                                            self._segment_path = lambda: "domain-array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                                class NasPort(Entity):
                                                                                                    """
                                                                                                    NAS Port
                                                                                                    
                                                                                                    .. attribute:: nas_port_array
                                                                                                    
                                                                                                    	nas port array
                                                                                                    	**type**\: list of  		 :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                        self.yang_name = "nas-port"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("nas-port-array", ("nas_port_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.nas_port_array = YList(self)
                                                                                                        self._segment_path = lambda: "nas-port"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                                    class NasPortArray(Entity):
                                                                                                        """
                                                                                                        nas port array
                                                                                                        
                                                                                                        .. attribute:: sub_id
                                                                                                        
                                                                                                        	sub id
                                                                                                        	**type**\:  :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                        
                                                                                                        .. attribute:: operator
                                                                                                        
                                                                                                        	operator
                                                                                                        	**type**\:  :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                        
                                                                                                        .. attribute:: value
                                                                                                        
                                                                                                        	value
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                            self.yang_name = "nas-port-array"
                                                                                                            self.yang_parent_name = "nas-port"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('sub_id', (YLeaf(YType.enumeration, 'sub-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchNasPortSubIdEn', '')])),
                                                                                                                ('operator', (YLeaf(YType.enumeration, 'operator'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchLogicalOperatorEn', '')])),
                                                                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                                            ])
                                                                                                            self.sub_id = None
                                                                                                            self.operator = None
                                                                                                            self.value = None
                                                                                                            self._segment_path = lambda: "nas-port-array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['sub_id', 'operator', 'value'], name, value)


                                                                                                class ServiceName(Entity):
                                                                                                    """
                                                                                                    Service Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                        self.yang_name = "service-name"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "service-name"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                                class ServiceNameRegex(Entity):
                                                                                                    """
                                                                                                    Service Name Regular Exp
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                        self.yang_name = "service-name-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "service-name-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                                class SrcAddrIpv4(Entity):
                                                                                                    """
                                                                                                    Source Address IPV4
                                                                                                    
                                                                                                    .. attribute:: ipv4_addr_array
                                                                                                    
                                                                                                    	ipv4 addr array
                                                                                                    	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                        self.yang_name = "src-addr-ipv4"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.ipv4_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "src-addr-ipv4"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                                    class Ipv4AddrArray(Entity):
                                                                                                        """
                                                                                                        ipv4 addr array
                                                                                                        
                                                                                                        .. attribute:: prefix
                                                                                                        
                                                                                                        	prefix
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	mask
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                            self.yang_name = "ipv4-addr-array"
                                                                                                            self.yang_parent_name = "src-addr-ipv4"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                                ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                            ])
                                                                                                            self.prefix = None
                                                                                                            self.mask = None
                                                                                                            self._segment_path = lambda: "ipv4-addr-array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                                class DstAddrIpv4(Entity):
                                                                                                    """
                                                                                                    Destination Address IPV4
                                                                                                    
                                                                                                    .. attribute:: ipv4_addr_array
                                                                                                    
                                                                                                    	ipv4 addr array
                                                                                                    	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                        self.yang_name = "dst-addr-ipv4"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.ipv4_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "dst-addr-ipv4"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                                    class Ipv4AddrArray(Entity):
                                                                                                        """
                                                                                                        ipv4 addr array
                                                                                                        
                                                                                                        .. attribute:: prefix
                                                                                                        
                                                                                                        	prefix
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	mask
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                            self.yang_name = "ipv4-addr-array"
                                                                                                            self.yang_parent_name = "dst-addr-ipv4"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                                ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                            ])
                                                                                                            self.prefix = None
                                                                                                            self.mask = None
                                                                                                            self._segment_path = lambda: "ipv4-addr-array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                                class SrcAddrIpv6(Entity):
                                                                                                    """
                                                                                                    Source Address IPV6
                                                                                                    
                                                                                                    .. attribute:: ipv6_addr_array
                                                                                                    
                                                                                                    	ipv6 addr array
                                                                                                    	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                        self.yang_name = "src-addr-ipv6"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.ipv6_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "src-addr-ipv6"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                                    class Ipv6AddrArray(Entity):
                                                                                                        """
                                                                                                        ipv6 addr array
                                                                                                        
                                                                                                        .. attribute:: prefix
                                                                                                        
                                                                                                        	IPV6 prefix
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	IPV6 mask
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                            self.yang_name = "ipv6-addr-array"
                                                                                                            self.yang_parent_name = "src-addr-ipv6"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                                ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                            ])
                                                                                                            self.prefix = None
                                                                                                            self.mask = None
                                                                                                            self._segment_path = lambda: "ipv6-addr-array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                                class DstAddrIpv6(Entity):
                                                                                                    """
                                                                                                    Destination Address IPV6
                                                                                                    
                                                                                                    .. attribute:: ipv6_addr_array
                                                                                                    
                                                                                                    	ipv6 addr array
                                                                                                    	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                        self.yang_name = "dst-addr-ipv6"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.ipv6_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "dst-addr-ipv6"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                                    class Ipv6AddrArray(Entity):
                                                                                                        """
                                                                                                        ipv6 addr array
                                                                                                        
                                                                                                        .. attribute:: prefix
                                                                                                        
                                                                                                        	IPV6 prefix
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	IPV6 mask
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                            self.yang_name = "ipv6-addr-array"
                                                                                                            self.yang_parent_name = "dst-addr-ipv6"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                                ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                            ])
                                                                                                            self.prefix = None
                                                                                                            self.mask = None
                                                                                                            self._segment_path = lambda: "ipv6-addr-array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                                class SrcAddrMac(Entity):
                                                                                                    """
                                                                                                    Source Address MAC
                                                                                                    
                                                                                                    .. attribute:: mac_addr_array
                                                                                                    
                                                                                                    	mac addr array
                                                                                                    	**type**\: list of  		 :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                        self.yang_name = "src-addr-mac"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("mac-addr-array", ("mac_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.mac_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "src-addr-mac"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                                    class MacAddrArray(Entity):
                                                                                                        """
                                                                                                        mac addr array
                                                                                                        
                                                                                                        .. attribute:: mac_addr
                                                                                                        
                                                                                                        	MAC address
                                                                                                        	**type**\: list of int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	MAC mask
                                                                                                        	**type**\: list of int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                            self.yang_name = "mac-addr-array"
                                                                                                            self.yang_parent_name = "src-addr-mac"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                                ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                            ])
                                                                                                            self.mac_addr = []
                                                                                                            self.mask = []
                                                                                                            self._segment_path = lambda: "mac-addr-array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                                class Timer(Entity):
                                                                                                    """
                                                                                                    Timer
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                        self.yang_name = "timer"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "timer"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                                class TimerRegexp(Entity):
                                                                                                    """
                                                                                                    Timer Regular Expression
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                        self.yang_name = "timer-regexp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "timer-regexp"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                                class TunnelName(Entity):
                                                                                                    """
                                                                                                    Tunnel Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                        self.yang_name = "tunnel-name"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "tunnel-name"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                                class TunnelNameRegex(Entity):
                                                                                                    """
                                                                                                    Tunnel Name Regular Expression
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                        self.yang_name = "tunnel-name-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "tunnel-name-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                                class UserName(Entity):
                                                                                                    """
                                                                                                    User Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                        self.yang_name = "user-name"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "user-name"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                                class UserNameRegex(Entity):
                                                                                                    """
                                                                                                    User Name Regular Expression
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                        self.yang_name = "user-name-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "user-name-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                                class AuthUsername(Entity):
                                                                                                    """
                                                                                                    Authenticated User Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                        self.yang_name = "auth-username"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "auth-username"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                                class AuthUsernameRegex(Entity):
                                                                                                    """
                                                                                                    Authenticated User Name RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                        self.yang_name = "auth-username-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "auth-username-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                                class UnauthUsername(Entity):
                                                                                                    """
                                                                                                    Unauthenticated User Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                        self.yang_name = "unauth-username"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "unauth-username"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                                class UnauthUsernameRegex(Entity):
                                                                                                    """
                                                                                                    Unauthenticated User Name RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                        self.yang_name = "unauth-username-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "unauth-username-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                                class AuthDomain(Entity):
                                                                                                    """
                                                                                                    Authenticated domain name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                        self.yang_name = "auth-domain"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "auth-domain"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                                class AuthDomainRegex(Entity):
                                                                                                    """
                                                                                                    Authenticated Domain Name RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                        self.yang_name = "auth-domain-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "auth-domain-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                                class UnauthDomain(Entity):
                                                                                                    """
                                                                                                    Unauthenticated Domain Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                        self.yang_name = "unauth-domain"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "unauth-domain"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                                class UnauthDomainRegex(Entity):
                                                                                                    """
                                                                                                    Unauthenticated Domain Name RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                        self.yang_name = "unauth-domain-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "unauth-domain-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                                class VendorId(Entity):
                                                                                                    """
                                                                                                    Vendor ID
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                        self.yang_name = "vendor-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "vendor-id"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                                class VendorIdRegex(Entity):
                                                                                                    """
                                                                                                    Vendor ID RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                        self.yang_name = "vendor-id-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "vendor-id-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                                class AccessInterface(Entity):
                                                                                                    """
                                                                                                    Access interface
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                        self.yang_name = "access-interface"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "access-interface"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                                class InputInterface(Entity):
                                                                                                    """
                                                                                                    Input interface
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                        self.yang_name = "input-interface"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "input-interface"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                                class InputIntfhdl(Entity):
                                                                                                    """
                                                                                                    Input interface handle
                                                                                                    
                                                                                                    .. attribute:: uint64_array
                                                                                                    
                                                                                                    	uint64 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..18446744073709551615
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                        self.yang_name = "input-intfhdl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint64_array', (YLeafList(YType.uint64, 'uint64_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint64_array = []
                                                                                                        self._segment_path = lambda: "input-intfhdl"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                                class Ethertype(Entity):
                                                                                                    """
                                                                                                    Ethernet type
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                        self.yang_name = "ethertype"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ethertype"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "ethertype"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['min', 'max'], name, value)


                                                                                                class FlowKeyData(Entity):
                                                                                                    """
                                                                                                    Flow key structure
                                                                                                    
                                                                                                    .. attribute:: flow_keys
                                                                                                    
                                                                                                    	flow keys
                                                                                                    	**type**\:  :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                                    
                                                                                                    .. attribute:: max_count
                                                                                                    
                                                                                                    	Maximum count of flows
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: idle_timeout
                                                                                                    
                                                                                                    	Idle timeout of flows (in seconds)
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    	**units**\: second
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                        self.yang_name = "flow-key-data"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("flow-keys", ("flow_keys", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys))])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('max_count', (YLeaf(YType.uint16, 'max-count'), ['int'])),
                                                                                                            ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                                                        ])
                                                                                                        self.max_count = None
                                                                                                        self.idle_timeout = None

                                                                                                        self.flow_keys = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                        self.flow_keys.parent = self
                                                                                                        self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                        self._segment_path = lambda: "flow-key-data"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['max_count', 'idle_timeout'], name, value)


                                                                                                    class FlowKeys(Entity):
                                                                                                        """
                                                                                                        flow keys
                                                                                                        
                                                                                                        .. attribute:: keys
                                                                                                        
                                                                                                        	keys
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                        
                                                                                                        .. attribute:: num
                                                                                                        
                                                                                                        	num
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                            self.yang_name = "flow-keys"
                                                                                                            self.yang_parent_name = "flow-key-data"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('keys', (YLeaf(YType.str, 'keys'), ['str'])),
                                                                                                                ('num', (YLeaf(YType.uint8, 'num'), ['int'])),
                                                                                                            ])
                                                                                                            self.keys = None
                                                                                                            self.num = None
                                                                                                            self._segment_path = lambda: "flow-keys"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                                class DhcpClientId(Entity):
                                                                                                    """
                                                                                                    Dhcp Client ID
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                        self.yang_name = "dhcp-client-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "dhcp-client-id"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                                class DhcpClientIdRegex(Entity):
                                                                                                    """
                                                                                                    Dhcp Client ID RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                        self.yang_name = "dhcp-client-id-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "dhcp-client-id-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                                class CircuitId(Entity):
                                                                                                    """
                                                                                                    Circuit ID
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                        self.yang_name = "circuit-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "circuit-id"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                                class CircuitIdRegex(Entity):
                                                                                                    """
                                                                                                    Circuit ID RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                        self.yang_name = "circuit-id-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "circuit-id-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                                class RemoteId(Entity):
                                                                                                    """
                                                                                                    Remote ID
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                        self.yang_name = "remote-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "remote-id"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                                class RemoteIdRegex(Entity):
                                                                                                    """
                                                                                                    Remote ID RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                        self.yang_name = "remote-id-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "remote-id-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                                class SrcPort(Entity):
                                                                                                    """
                                                                                                    Source port
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                        self.yang_name = "src-port"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "src-port"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "src-port"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                                                class DstPort(Entity):
                                                                                                    """
                                                                                                    Destination port
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                        self.yang_name = "dst-port"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "dst-port"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "dst-port"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class ExcdclassEncode(Entity):
                                                                                """
                                                                                excdclass encode
                                                                                
                                                                                .. attribute:: inline_cmap
                                                                                
                                                                                	inline cmap
                                                                                	**type**\:  :py:class:`InlineCmap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap>`
                                                                                
                                                                                .. attribute:: enc
                                                                                
                                                                                	enc
                                                                                	**type**\:  :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                                
                                                                                .. attribute:: class_name
                                                                                
                                                                                	class name
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..65
                                                                                
                                                                                .. attribute:: hd
                                                                                
                                                                                	hd
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..18446744073709551615
                                                                                
                                                                                .. attribute:: idx
                                                                                
                                                                                	idx
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode, self).__init__()

                                                                                    self.yang_name = "excdclass-encode"
                                                                                    self.yang_parent_name = "police"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("inline-cmap", ("inline_cmap", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('enc', (YLeaf(YType.enumeration, 'enc'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyObjEncEn', '')])),
                                                                                        ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                                                        ('hd', (YLeaf(YType.uint64, 'hd'), ['int'])),
                                                                                        ('idx', (YLeaf(YType.uint8, 'idx'), ['int'])),
                                                                                    ])
                                                                                    self.enc = None
                                                                                    self.class_name = None
                                                                                    self.hd = None
                                                                                    self.idx = None

                                                                                    self.inline_cmap = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap()
                                                                                    self.inline_cmap.parent = self
                                                                                    self._children_name_map["inline_cmap"] = "inline-cmap"
                                                                                    self._segment_path = lambda: "excdclass-encode"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode, ['enc', 'class_name', 'hd', 'idx'], name, value)


                                                                                class InlineCmap(Entity):
                                                                                    """
                                                                                    inline cmap
                                                                                    
                                                                                    .. attribute:: match_infop
                                                                                    
                                                                                    	Pointer to the first Match info
                                                                                    	**type**\:  :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop>`
                                                                                    
                                                                                    .. attribute:: mode
                                                                                    
                                                                                    	Inline Class\-Map Mode Match any/all
                                                                                    	**type**\:  :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                                    
                                                                                    .. attribute:: flags
                                                                                    
                                                                                    	Inline Class\-Map flags
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: match_count
                                                                                    
                                                                                    	Number of Match infos
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap, self).__init__()

                                                                                        self.yang_name = "inline-cmap"
                                                                                        self.yang_parent_name = "excdclass-encode"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("match-infop", ("match_infop", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop))])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapModeEn', '')])),
                                                                                            ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                            ('match_count', (YLeaf(YType.uint32, 'match-count'), ['int'])),
                                                                                        ])
                                                                                        self.mode = None
                                                                                        self.flags = None
                                                                                        self.match_count = None

                                                                                        self.match_infop = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop()
                                                                                        self.match_infop.parent = self
                                                                                        self._children_name_map["match_infop"] = "match-infop"
                                                                                        self._segment_path = lambda: "inline-cmap"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap, ['mode', 'flags', 'match_count'], name, value)


                                                                                    class MatchInfop(Entity):
                                                                                        """
                                                                                        Pointer to the first Match info
                                                                                        
                                                                                        .. attribute:: class_match_info_st
                                                                                        
                                                                                        	class match info st
                                                                                        	**type**\: list of  		 :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop, self).__init__()

                                                                                            self.yang_name = "match-infop"
                                                                                            self.yang_parent_name = "inline-cmap"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("class-match-info-st", ("class_match_info_st", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.class_match_info_st = YList(self)
                                                                                            self._segment_path = lambda: "match-infop"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop, [], name, value)


                                                                                        class ClassMatchInfoSt(Entity):
                                                                                            """
                                                                                            class match info st
                                                                                            
                                                                                            .. attribute:: match_data
                                                                                            
                                                                                            	Match criteria
                                                                                            	**type**\:  :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                            
                                                                                            .. attribute:: flags
                                                                                            
                                                                                            	Flags
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                                self.yang_name = "class-match-info-st"
                                                                                                self.yang_parent_name = "match-infop"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("match-data", ("match_data", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData))])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                                ])
                                                                                                self.flags = None

                                                                                                self.match_data = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                                self.match_data.parent = self
                                                                                                self._children_name_map["match_data"] = "match-data"
                                                                                                self._segment_path = lambda: "class-match-info-st"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                            class MatchData(Entity):
                                                                                                """
                                                                                                Match criteria
                                                                                                
                                                                                                .. attribute:: ipv4_dscp
                                                                                                
                                                                                                	IPv4 DSCP
                                                                                                	**type**\:  :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                                
                                                                                                .. attribute:: ipv6_dscp
                                                                                                
                                                                                                	IPv6 DSCP
                                                                                                	**type**\:  :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                                
                                                                                                .. attribute:: dscp
                                                                                                
                                                                                                	Match DSCP range array
                                                                                                	**type**\:  :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                                
                                                                                                .. attribute:: ipv4_prec
                                                                                                
                                                                                                	IPv4 Precedence
                                                                                                	**type**\:  :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                                
                                                                                                .. attribute:: ipv6_prec
                                                                                                
                                                                                                	IPv6 Precedence
                                                                                                	**type**\:  :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                                
                                                                                                .. attribute:: prec
                                                                                                
                                                                                                	Match Precedence array
                                                                                                	**type**\:  :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                                
                                                                                                .. attribute:: discard_class
                                                                                                
                                                                                                	Match Discard Class array
                                                                                                	**type**\:  :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                                
                                                                                                .. attribute:: qos_group
                                                                                                
                                                                                                	Match QoS group array
                                                                                                	**type**\:  :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                                
                                                                                                .. attribute:: traffic_class
                                                                                                
                                                                                                	Match Traffic class array
                                                                                                	**type**\:  :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                                
                                                                                                .. attribute:: proto
                                                                                                
                                                                                                	Match Protocol array
                                                                                                	**type**\:  :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                                
                                                                                                .. attribute:: icmp_v4
                                                                                                
                                                                                                	Match ICMPV4 Protocol
                                                                                                	**type**\:  :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                                
                                                                                                .. attribute:: icmp_v6
                                                                                                
                                                                                                	Match ICMPV6 Protocol array
                                                                                                	**type**\:  :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                                
                                                                                                .. attribute:: ipv4_packet_len
                                                                                                
                                                                                                	IPv4 packet length array
                                                                                                	**type**\:  :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                                
                                                                                                .. attribute:: ipv6_packet_len
                                                                                                
                                                                                                	IPv6 packet length array
                                                                                                	**type**\:  :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                                
                                                                                                .. attribute:: packet_len
                                                                                                
                                                                                                	Match packet length array
                                                                                                	**type**\:  :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                                
                                                                                                .. attribute:: flow_tag
                                                                                                
                                                                                                	Match flow\-tag array
                                                                                                	**type**\:  :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                                
                                                                                                .. attribute:: tcp_flag
                                                                                                
                                                                                                	Match tcp flag value
                                                                                                	**type**\:  :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                                
                                                                                                .. attribute:: icmpv4_type
                                                                                                
                                                                                                	Match ipv4 icmp type
                                                                                                	**type**\:  :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                                
                                                                                                .. attribute:: icmpv4_code
                                                                                                
                                                                                                	Match ipv4 icmp code
                                                                                                	**type**\:  :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                                
                                                                                                .. attribute:: icmpv6_type
                                                                                                
                                                                                                	Match ipv6 icmp type
                                                                                                	**type**\:  :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                                
                                                                                                .. attribute:: icmpv6_code
                                                                                                
                                                                                                	Match ipv6 icmp code
                                                                                                	**type**\:  :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                                
                                                                                                .. attribute:: mpls_exp
                                                                                                
                                                                                                	Match MPLS experimental topmost array
                                                                                                	**type**\:  :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                                
                                                                                                .. attribute:: mpls_exp_imp
                                                                                                
                                                                                                	Match MPLS experimental imposition array
                                                                                                	**type**\:  :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                                
                                                                                                .. attribute:: mpls_disp_ipv4_acl
                                                                                                
                                                                                                	MPLS Disposition IPv4 Access\-list
                                                                                                	**type**\:  :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                                
                                                                                                .. attribute:: mpls_disp_ipv6_acl
                                                                                                
                                                                                                	MPLS Disposition IPv6 Access\-list
                                                                                                	**type**\:  :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                                
                                                                                                .. attribute:: mpls_top_label
                                                                                                
                                                                                                	MPLS Topmost LABEL
                                                                                                	**type**\:  :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                                
                                                                                                .. attribute:: cos
                                                                                                
                                                                                                	Match CoS array
                                                                                                	**type**\:  :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                                
                                                                                                .. attribute:: cos_inr
                                                                                                
                                                                                                	Match inner header CoS
                                                                                                	**type**\:  :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                                
                                                                                                .. attribute:: dei
                                                                                                
                                                                                                	Match DEI Bit
                                                                                                	**type**\:  :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                                
                                                                                                .. attribute:: dei_inr
                                                                                                
                                                                                                	Match inner DEI Bit
                                                                                                	**type**\:  :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                                
                                                                                                .. attribute:: vlan
                                                                                                
                                                                                                	Match VLAN array
                                                                                                	**type**\:  :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                                
                                                                                                .. attribute:: vlan_inr
                                                                                                
                                                                                                	Match inner header VLAN range array
                                                                                                	**type**\:  :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                                
                                                                                                .. attribute:: fr_dlci
                                                                                                
                                                                                                	Match FR DLCI range array
                                                                                                	**type**\:  :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                                
                                                                                                .. attribute:: src_mac
                                                                                                
                                                                                                	Match Source MAC address
                                                                                                	**type**\:  :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                                
                                                                                                .. attribute:: dst_mac
                                                                                                
                                                                                                	Match Destination MAC address
                                                                                                	**type**\:  :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                                
                                                                                                .. attribute:: atm_clp
                                                                                                
                                                                                                	Match ATM CLP level
                                                                                                	**type**\:  :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                                
                                                                                                .. attribute:: fr_de
                                                                                                
                                                                                                	Match FR DE value
                                                                                                	**type**\:  :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                                
                                                                                                .. attribute:: ipv4_acl
                                                                                                
                                                                                                	IPv4 Access\-list
                                                                                                	**type**\:  :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                                
                                                                                                .. attribute:: ipv6_acl
                                                                                                
                                                                                                	IPv6 Access\-list
                                                                                                	**type**\:  :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                                
                                                                                                .. attribute:: ether_service_acl
                                                                                                
                                                                                                	Ethernet\-Services Access\-list
                                                                                                	**type**\:  :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                                
                                                                                                .. attribute:: avail_id
                                                                                                
                                                                                                	Available Identifiers
                                                                                                	**type**\:  :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                                
                                                                                                .. attribute:: media_type
                                                                                                
                                                                                                	Media Type
                                                                                                	**type**\:  :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                                
                                                                                                .. attribute:: subs_protocol
                                                                                                
                                                                                                	Protocol
                                                                                                	**type**\:  :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                                
                                                                                                .. attribute:: dnis
                                                                                                
                                                                                                	DNIS
                                                                                                	**type**\:  :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                                
                                                                                                .. attribute:: dnis_regex
                                                                                                
                                                                                                	DNIS Regular Expression
                                                                                                	**type**\:  :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                                
                                                                                                .. attribute:: domain
                                                                                                
                                                                                                	Domain Name
                                                                                                	**type**\:  :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                                
                                                                                                .. attribute:: domain_regex
                                                                                                
                                                                                                	Domain Regular Expression
                                                                                                	**type**\:  :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                                
                                                                                                .. attribute:: nas_port
                                                                                                
                                                                                                	NAS Port
                                                                                                	**type**\:  :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                                
                                                                                                .. attribute:: service_name
                                                                                                
                                                                                                	Service Name
                                                                                                	**type**\:  :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                                
                                                                                                .. attribute:: service_name_regex
                                                                                                
                                                                                                	Service Name Regular Exp
                                                                                                	**type**\:  :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                                
                                                                                                .. attribute:: src_addr_ipv4
                                                                                                
                                                                                                	Source Address IPV4
                                                                                                	**type**\:  :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                                
                                                                                                .. attribute:: dst_addr_ipv4
                                                                                                
                                                                                                	Destination Address IPV4
                                                                                                	**type**\:  :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                                
                                                                                                .. attribute:: src_addr_ipv6
                                                                                                
                                                                                                	Source Address IPV6
                                                                                                	**type**\:  :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                                
                                                                                                .. attribute:: dst_addr_ipv6
                                                                                                
                                                                                                	Destination Address IPV6
                                                                                                	**type**\:  :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                                
                                                                                                .. attribute:: src_addr_mac
                                                                                                
                                                                                                	Source Address MAC
                                                                                                	**type**\:  :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                                
                                                                                                .. attribute:: timer
                                                                                                
                                                                                                	Timer
                                                                                                	**type**\:  :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                                
                                                                                                .. attribute:: timer_regexp
                                                                                                
                                                                                                	Timer Regular Expression
                                                                                                	**type**\:  :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                                
                                                                                                .. attribute:: tunnel_name
                                                                                                
                                                                                                	Tunnel Name
                                                                                                	**type**\:  :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                                
                                                                                                .. attribute:: tunnel_name_regex
                                                                                                
                                                                                                	Tunnel Name Regular Expression
                                                                                                	**type**\:  :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                                
                                                                                                .. attribute:: user_name
                                                                                                
                                                                                                	User Name
                                                                                                	**type**\:  :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                                
                                                                                                .. attribute:: user_name_regex
                                                                                                
                                                                                                	User Name Regular Expression
                                                                                                	**type**\:  :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                                
                                                                                                .. attribute:: auth_username
                                                                                                
                                                                                                	Authenticated User Name
                                                                                                	**type**\:  :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                                
                                                                                                .. attribute:: auth_username_regex
                                                                                                
                                                                                                	Authenticated User Name RegEx
                                                                                                	**type**\:  :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                                
                                                                                                .. attribute:: unauth_username
                                                                                                
                                                                                                	Unauthenticated User Name
                                                                                                	**type**\:  :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                                
                                                                                                .. attribute:: unauth_username_regex
                                                                                                
                                                                                                	Unauthenticated User Name RegEx
                                                                                                	**type**\:  :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                                
                                                                                                .. attribute:: auth_domain
                                                                                                
                                                                                                	Authenticated domain name
                                                                                                	**type**\:  :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                                
                                                                                                .. attribute:: auth_domain_regex
                                                                                                
                                                                                                	Authenticated Domain Name RegEx
                                                                                                	**type**\:  :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                                
                                                                                                .. attribute:: unauth_domain
                                                                                                
                                                                                                	Unauthenticated Domain Name
                                                                                                	**type**\:  :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                                
                                                                                                .. attribute:: unauth_domain_regex
                                                                                                
                                                                                                	Unauthenticated Domain Name RegEx
                                                                                                	**type**\:  :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                                
                                                                                                .. attribute:: vendor_id
                                                                                                
                                                                                                	Vendor ID
                                                                                                	**type**\:  :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                                
                                                                                                .. attribute:: vendor_id_regex
                                                                                                
                                                                                                	Vendor ID RegEx
                                                                                                	**type**\:  :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                                
                                                                                                .. attribute:: access_interface
                                                                                                
                                                                                                	Access interface
                                                                                                	**type**\:  :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                                
                                                                                                .. attribute:: input_interface
                                                                                                
                                                                                                	Input interface
                                                                                                	**type**\:  :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                                
                                                                                                .. attribute:: input_intfhdl
                                                                                                
                                                                                                	Input interface handle
                                                                                                	**type**\:  :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                                
                                                                                                .. attribute:: ethertype
                                                                                                
                                                                                                	Ethernet type
                                                                                                	**type**\:  :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                                
                                                                                                .. attribute:: flow_key_data
                                                                                                
                                                                                                	Flow key structure
                                                                                                	**type**\:  :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                                
                                                                                                .. attribute:: dhcp_client_id
                                                                                                
                                                                                                	Dhcp Client ID
                                                                                                	**type**\:  :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                                
                                                                                                .. attribute:: dhcp_client_id_regex
                                                                                                
                                                                                                	Dhcp Client ID RegEx
                                                                                                	**type**\:  :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                                
                                                                                                .. attribute:: circuit_id
                                                                                                
                                                                                                	Circuit ID
                                                                                                	**type**\:  :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                                
                                                                                                .. attribute:: circuit_id_regex
                                                                                                
                                                                                                	Circuit ID RegEx
                                                                                                	**type**\:  :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                                
                                                                                                .. attribute:: remote_id
                                                                                                
                                                                                                	Remote ID
                                                                                                	**type**\:  :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                                
                                                                                                .. attribute:: remote_id_regex
                                                                                                
                                                                                                	Remote ID RegEx
                                                                                                	**type**\:  :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                                
                                                                                                .. attribute:: src_port
                                                                                                
                                                                                                	Source port
                                                                                                	**type**\:  :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                                
                                                                                                .. attribute:: dst_port
                                                                                                
                                                                                                	Destination port
                                                                                                	**type**\:  :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	type
                                                                                                	**type**\:  :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                                
                                                                                                .. attribute:: mpls_top_eos
                                                                                                
                                                                                                	MPLS Topmost EOS
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: fragment_type
                                                                                                
                                                                                                	Fragment type
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: authen_status
                                                                                                
                                                                                                	Authentication Status
                                                                                                	**type**\:  :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                                
                                                                                                .. attribute:: mlp_negotiated
                                                                                                
                                                                                                	MLP Negotiated
                                                                                                	**type**\:  :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                                    self.yang_name = "match-data"
                                                                                                    self.yang_parent_name = "class-match-info-st"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv4-dscp", ("ipv4_dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp)), ("ipv6-dscp", ("ipv6_dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp)), ("dscp", ("dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp)), ("ipv4-prec", ("ipv4_prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec)), ("ipv6-prec", ("ipv6_prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec)), ("prec", ("prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec)), ("discard-class", ("discard_class", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass)), ("qos-group", ("qos_group", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup)), ("traffic-class", ("traffic_class", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass)), ("proto", ("proto", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto)), ("icmp-v4", ("icmp_v4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4)), ("icmp-v6", ("icmp_v6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6)), ("ipv4-packet-len", ("ipv4_packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen)), ("ipv6-packet-len", ("ipv6_packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen)), ("packet-len", ("packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen)), ("flow-tag", ("flow_tag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag)), ("tcp-flag", ("tcp_flag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag)), ("icmpv4-type", ("icmpv4_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type)), ("icmpv4-code", ("icmpv4_code", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code)), ("icmpv6-type", ("icmpv6_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type)), ("icmpv6-code", ("icmpv6_code", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code)), ("mpls-exp", ("mpls_exp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp)), ("mpls-exp-imp", ("mpls_exp_imp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp)), ("mpls-disp-ipv4-acl", ("mpls_disp_ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl)), ("mpls-disp-ipv6-acl", ("mpls_disp_ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl)), ("mpls-top-label", ("mpls_top_label", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel)), ("cos", ("cos", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos)), ("cos-inr", ("cos_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr)), ("dei", ("dei", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei)), ("dei-inr", ("dei_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr)), ("vlan", ("vlan", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan)), ("vlan-inr", ("vlan_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)), ("fr-dlci", ("fr_dlci", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci)), ("src-mac", ("src_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac)), ("dst-mac", ("dst_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac)), ("atm-clp", ("atm_clp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp)), ("fr-de", ("fr_de", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe)), ("ipv4-acl", ("ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl)), ("ipv6-acl", ("ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl)), ("ether-service-acl", ("ether_service_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl)), ("avail-id", ("avail_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId)), ("media-type", ("media_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType)), ("subs-protocol", ("subs_protocol", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol)), ("dnis", ("dnis", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis)), ("dnis-regex", ("dnis_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex)), ("domain", ("domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain)), ("domain-regex", ("domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex)), ("nas-port", ("nas_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort)), ("service-name", ("service_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName)), ("service-name-regex", ("service_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex)), ("src-addr-ipv4", ("src_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4)), ("dst-addr-ipv4", ("dst_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4)), ("src-addr-ipv6", ("src_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6)), ("dst-addr-ipv6", ("dst_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6)), ("src-addr-mac", ("src_addr_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac)), ("timer", ("timer", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer)), ("timer-regexp", ("timer_regexp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp)), ("tunnel-name", ("tunnel_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName)), ("tunnel-name-regex", ("tunnel_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex)), ("user-name", ("user_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName)), ("user-name-regex", ("user_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex)), ("auth-username", ("auth_username", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername)), ("auth-username-regex", ("auth_username_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex)), ("unauth-username", ("unauth_username", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername)), ("unauth-username-regex", ("unauth_username_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex)), ("auth-domain", ("auth_domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain)), ("auth-domain-regex", ("auth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex)), ("unauth-domain", ("unauth_domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain)), ("unauth-domain-regex", ("unauth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex)), ("vendor-id", ("vendor_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId)), ("vendor-id-regex", ("vendor_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex)), ("access-interface", ("access_interface", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface)), ("input-interface", ("input_interface", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface)), ("input-intfhdl", ("input_intfhdl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl)), ("ethertype", ("ethertype", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype)), ("flow-key-data", ("flow_key_data", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData)), ("dhcp-client-id", ("dhcp_client_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId)), ("dhcp-client-id-regex", ("dhcp_client_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex)), ("circuit-id", ("circuit_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId)), ("circuit-id-regex", ("circuit_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex)), ("remote-id", ("remote_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId)), ("remote-id-regex", ("remote_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex)), ("src-port", ("src_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort)), ("dst-port", ("dst_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort))])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchTypeEn', '')])),
                                                                                                        ('mpls_top_eos', (YLeaf(YType.uint8, 'mpls-top-eos'), ['int'])),
                                                                                                        ('fragment_type', (YLeaf(YType.uint8, 'fragment-type'), ['int'])),
                                                                                                        ('authen_status', (YLeaf(YType.enumeration, 'authen-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchAuthenStatusEn', '')])),
                                                                                                        ('mlp_negotiated', (YLeaf(YType.enumeration, 'mlp-negotiated'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchMlpNegotiatedEn', '')])),
                                                                                                    ])
                                                                                                    self.type = None
                                                                                                    self.mpls_top_eos = None
                                                                                                    self.fragment_type = None
                                                                                                    self.authen_status = None
                                                                                                    self.mlp_negotiated = None

                                                                                                    self.ipv4_dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                                    self.ipv4_dscp.parent = self
                                                                                                    self._children_name_map["ipv4_dscp"] = "ipv4-dscp"

                                                                                                    self.ipv6_dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                                    self.ipv6_dscp.parent = self
                                                                                                    self._children_name_map["ipv6_dscp"] = "ipv6-dscp"

                                                                                                    self.dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                                    self.dscp.parent = self
                                                                                                    self._children_name_map["dscp"] = "dscp"

                                                                                                    self.ipv4_prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                                    self.ipv4_prec.parent = self
                                                                                                    self._children_name_map["ipv4_prec"] = "ipv4-prec"

                                                                                                    self.ipv6_prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                                    self.ipv6_prec.parent = self
                                                                                                    self._children_name_map["ipv6_prec"] = "ipv6-prec"

                                                                                                    self.prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                                    self.prec.parent = self
                                                                                                    self._children_name_map["prec"] = "prec"

                                                                                                    self.discard_class = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                                    self.discard_class.parent = self
                                                                                                    self._children_name_map["discard_class"] = "discard-class"

                                                                                                    self.qos_group = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                                    self.qos_group.parent = self
                                                                                                    self._children_name_map["qos_group"] = "qos-group"

                                                                                                    self.traffic_class = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                                    self.traffic_class.parent = self
                                                                                                    self._children_name_map["traffic_class"] = "traffic-class"

                                                                                                    self.proto = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                                    self.proto.parent = self
                                                                                                    self._children_name_map["proto"] = "proto"

                                                                                                    self.icmp_v4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                                    self.icmp_v4.parent = self
                                                                                                    self._children_name_map["icmp_v4"] = "icmp-v4"

                                                                                                    self.icmp_v6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                                    self.icmp_v6.parent = self
                                                                                                    self._children_name_map["icmp_v6"] = "icmp-v6"

                                                                                                    self.ipv4_packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                                    self.ipv4_packet_len.parent = self
                                                                                                    self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"

                                                                                                    self.ipv6_packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                                    self.ipv6_packet_len.parent = self
                                                                                                    self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"

                                                                                                    self.packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                                    self.packet_len.parent = self
                                                                                                    self._children_name_map["packet_len"] = "packet-len"

                                                                                                    self.flow_tag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                                    self.flow_tag.parent = self
                                                                                                    self._children_name_map["flow_tag"] = "flow-tag"

                                                                                                    self.tcp_flag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                                    self.tcp_flag.parent = self
                                                                                                    self._children_name_map["tcp_flag"] = "tcp-flag"

                                                                                                    self.icmpv4_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                                    self.icmpv4_type.parent = self
                                                                                                    self._children_name_map["icmpv4_type"] = "icmpv4-type"

                                                                                                    self.icmpv4_code = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                                    self.icmpv4_code.parent = self
                                                                                                    self._children_name_map["icmpv4_code"] = "icmpv4-code"

                                                                                                    self.icmpv6_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                                    self.icmpv6_type.parent = self
                                                                                                    self._children_name_map["icmpv6_type"] = "icmpv6-type"

                                                                                                    self.icmpv6_code = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                                    self.icmpv6_code.parent = self
                                                                                                    self._children_name_map["icmpv6_code"] = "icmpv6-code"

                                                                                                    self.mpls_exp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                                    self.mpls_exp.parent = self
                                                                                                    self._children_name_map["mpls_exp"] = "mpls-exp"

                                                                                                    self.mpls_exp_imp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                                    self.mpls_exp_imp.parent = self
                                                                                                    self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"

                                                                                                    self.mpls_disp_ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                                    self.mpls_disp_ipv4_acl.parent = self
                                                                                                    self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"

                                                                                                    self.mpls_disp_ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                                    self.mpls_disp_ipv6_acl.parent = self
                                                                                                    self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"

                                                                                                    self.mpls_top_label = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                                    self.mpls_top_label.parent = self
                                                                                                    self._children_name_map["mpls_top_label"] = "mpls-top-label"

                                                                                                    self.cos = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                                    self.cos.parent = self
                                                                                                    self._children_name_map["cos"] = "cos"

                                                                                                    self.cos_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                                    self.cos_inr.parent = self
                                                                                                    self._children_name_map["cos_inr"] = "cos-inr"

                                                                                                    self.dei = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                                    self.dei.parent = self
                                                                                                    self._children_name_map["dei"] = "dei"

                                                                                                    self.dei_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                                    self.dei_inr.parent = self
                                                                                                    self._children_name_map["dei_inr"] = "dei-inr"

                                                                                                    self.vlan = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                                    self.vlan.parent = self
                                                                                                    self._children_name_map["vlan"] = "vlan"

                                                                                                    self.vlan_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                                    self.vlan_inr.parent = self
                                                                                                    self._children_name_map["vlan_inr"] = "vlan-inr"

                                                                                                    self.fr_dlci = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                                    self.fr_dlci.parent = self
                                                                                                    self._children_name_map["fr_dlci"] = "fr-dlci"

                                                                                                    self.src_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                                    self.src_mac.parent = self
                                                                                                    self._children_name_map["src_mac"] = "src-mac"

                                                                                                    self.dst_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                                    self.dst_mac.parent = self
                                                                                                    self._children_name_map["dst_mac"] = "dst-mac"

                                                                                                    self.atm_clp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                                    self.atm_clp.parent = self
                                                                                                    self._children_name_map["atm_clp"] = "atm-clp"

                                                                                                    self.fr_de = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                                    self.fr_de.parent = self
                                                                                                    self._children_name_map["fr_de"] = "fr-de"

                                                                                                    self.ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                                    self.ipv4_acl.parent = self
                                                                                                    self._children_name_map["ipv4_acl"] = "ipv4-acl"

                                                                                                    self.ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                                    self.ipv6_acl.parent = self
                                                                                                    self._children_name_map["ipv6_acl"] = "ipv6-acl"

                                                                                                    self.ether_service_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                                    self.ether_service_acl.parent = self
                                                                                                    self._children_name_map["ether_service_acl"] = "ether-service-acl"

                                                                                                    self.avail_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                                    self.avail_id.parent = self
                                                                                                    self._children_name_map["avail_id"] = "avail-id"

                                                                                                    self.media_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                                    self.media_type.parent = self
                                                                                                    self._children_name_map["media_type"] = "media-type"

                                                                                                    self.subs_protocol = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                                    self.subs_protocol.parent = self
                                                                                                    self._children_name_map["subs_protocol"] = "subs-protocol"

                                                                                                    self.dnis = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                                    self.dnis.parent = self
                                                                                                    self._children_name_map["dnis"] = "dnis"

                                                                                                    self.dnis_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                                    self.dnis_regex.parent = self
                                                                                                    self._children_name_map["dnis_regex"] = "dnis-regex"

                                                                                                    self.domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                                    self.domain.parent = self
                                                                                                    self._children_name_map["domain"] = "domain"

                                                                                                    self.domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                                    self.domain_regex.parent = self
                                                                                                    self._children_name_map["domain_regex"] = "domain-regex"

                                                                                                    self.nas_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                                    self.nas_port.parent = self
                                                                                                    self._children_name_map["nas_port"] = "nas-port"

                                                                                                    self.service_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                                    self.service_name.parent = self
                                                                                                    self._children_name_map["service_name"] = "service-name"

                                                                                                    self.service_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                                    self.service_name_regex.parent = self
                                                                                                    self._children_name_map["service_name_regex"] = "service-name-regex"

                                                                                                    self.src_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                                    self.src_addr_ipv4.parent = self
                                                                                                    self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"

                                                                                                    self.dst_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                                    self.dst_addr_ipv4.parent = self
                                                                                                    self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"

                                                                                                    self.src_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                                    self.src_addr_ipv6.parent = self
                                                                                                    self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"

                                                                                                    self.dst_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                                    self.dst_addr_ipv6.parent = self
                                                                                                    self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"

                                                                                                    self.src_addr_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                                    self.src_addr_mac.parent = self
                                                                                                    self._children_name_map["src_addr_mac"] = "src-addr-mac"

                                                                                                    self.timer = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                                    self.timer.parent = self
                                                                                                    self._children_name_map["timer"] = "timer"

                                                                                                    self.timer_regexp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                                    self.timer_regexp.parent = self
                                                                                                    self._children_name_map["timer_regexp"] = "timer-regexp"

                                                                                                    self.tunnel_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                                    self.tunnel_name.parent = self
                                                                                                    self._children_name_map["tunnel_name"] = "tunnel-name"

                                                                                                    self.tunnel_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                                    self.tunnel_name_regex.parent = self
                                                                                                    self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"

                                                                                                    self.user_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                                    self.user_name.parent = self
                                                                                                    self._children_name_map["user_name"] = "user-name"

                                                                                                    self.user_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                                    self.user_name_regex.parent = self
                                                                                                    self._children_name_map["user_name_regex"] = "user-name-regex"

                                                                                                    self.auth_username = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                                    self.auth_username.parent = self
                                                                                                    self._children_name_map["auth_username"] = "auth-username"

                                                                                                    self.auth_username_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                                    self.auth_username_regex.parent = self
                                                                                                    self._children_name_map["auth_username_regex"] = "auth-username-regex"

                                                                                                    self.unauth_username = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                                    self.unauth_username.parent = self
                                                                                                    self._children_name_map["unauth_username"] = "unauth-username"

                                                                                                    self.unauth_username_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                                    self.unauth_username_regex.parent = self
                                                                                                    self._children_name_map["unauth_username_regex"] = "unauth-username-regex"

                                                                                                    self.auth_domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                                    self.auth_domain.parent = self
                                                                                                    self._children_name_map["auth_domain"] = "auth-domain"

                                                                                                    self.auth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                                    self.auth_domain_regex.parent = self
                                                                                                    self._children_name_map["auth_domain_regex"] = "auth-domain-regex"

                                                                                                    self.unauth_domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                                    self.unauth_domain.parent = self
                                                                                                    self._children_name_map["unauth_domain"] = "unauth-domain"

                                                                                                    self.unauth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                                    self.unauth_domain_regex.parent = self
                                                                                                    self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"

                                                                                                    self.vendor_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                                    self.vendor_id.parent = self
                                                                                                    self._children_name_map["vendor_id"] = "vendor-id"

                                                                                                    self.vendor_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                                    self.vendor_id_regex.parent = self
                                                                                                    self._children_name_map["vendor_id_regex"] = "vendor-id-regex"

                                                                                                    self.access_interface = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                                    self.access_interface.parent = self
                                                                                                    self._children_name_map["access_interface"] = "access-interface"

                                                                                                    self.input_interface = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                                    self.input_interface.parent = self
                                                                                                    self._children_name_map["input_interface"] = "input-interface"

                                                                                                    self.input_intfhdl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                                    self.input_intfhdl.parent = self
                                                                                                    self._children_name_map["input_intfhdl"] = "input-intfhdl"

                                                                                                    self.ethertype = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                                    self.ethertype.parent = self
                                                                                                    self._children_name_map["ethertype"] = "ethertype"

                                                                                                    self.flow_key_data = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                                    self.flow_key_data.parent = self
                                                                                                    self._children_name_map["flow_key_data"] = "flow-key-data"

                                                                                                    self.dhcp_client_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                                    self.dhcp_client_id.parent = self
                                                                                                    self._children_name_map["dhcp_client_id"] = "dhcp-client-id"

                                                                                                    self.dhcp_client_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                                    self.dhcp_client_id_regex.parent = self
                                                                                                    self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"

                                                                                                    self.circuit_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                                    self.circuit_id.parent = self
                                                                                                    self._children_name_map["circuit_id"] = "circuit-id"

                                                                                                    self.circuit_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                                    self.circuit_id_regex.parent = self
                                                                                                    self._children_name_map["circuit_id_regex"] = "circuit-id-regex"

                                                                                                    self.remote_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                                    self.remote_id.parent = self
                                                                                                    self._children_name_map["remote_id"] = "remote-id"

                                                                                                    self.remote_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                                    self.remote_id_regex.parent = self
                                                                                                    self._children_name_map["remote_id_regex"] = "remote-id-regex"

                                                                                                    self.src_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                                    self.src_port.parent = self
                                                                                                    self._children_name_map["src_port"] = "src-port"

                                                                                                    self.dst_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                                    self.dst_port.parent = self
                                                                                                    self._children_name_map["dst_port"] = "dst-port"
                                                                                                    self._segment_path = lambda: "match-data"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, ['type', 'mpls_top_eos', 'fragment_type', 'authen_status', 'mlp_negotiated'], name, value)


                                                                                                class Ipv4Dscp(Entity):
                                                                                                    """
                                                                                                    IPv4 DSCP
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                        self.yang_name = "ipv4-dscp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ipv4-dscp"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "ipv4-dscp"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                                class Ipv6Dscp(Entity):
                                                                                                    """
                                                                                                    IPv6 DSCP
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                        self.yang_name = "ipv6-dscp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ipv6-dscp"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "ipv6-dscp"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                                class Dscp(Entity):
                                                                                                    """
                                                                                                    Match DSCP range array
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                        self.yang_name = "dscp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "dscp"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "dscp"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                                class Ipv4Prec(Entity):
                                                                                                    """
                                                                                                    IPv4 Precedence
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                        self.yang_name = "ipv4-prec"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "ipv4-prec"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                                class Ipv6Prec(Entity):
                                                                                                    """
                                                                                                    IPv6 Precedence
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                        self.yang_name = "ipv6-prec"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "ipv6-prec"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                                class Prec(Entity):
                                                                                                    """
                                                                                                    Match Precedence array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                        self.yang_name = "prec"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "prec"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                                class DiscardClass(Entity):
                                                                                                    """
                                                                                                    Match Discard Class array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                        self.yang_name = "discard-class"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "discard-class"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                                class QosGroup(Entity):
                                                                                                    """
                                                                                                    Match QoS group array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                        self.yang_name = "qos-group"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "qos-group"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "qos-group"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['min', 'max'], name, value)


                                                                                                class TrafficClass(Entity):
                                                                                                    """
                                                                                                    Match Traffic class array
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                        self.yang_name = "traffic-class"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "traffic-class"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "traffic-class"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['min', 'max'], name, value)


                                                                                                class Proto(Entity):
                                                                                                    """
                                                                                                    Match Protocol array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                        self.yang_name = "proto"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "proto"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "proto"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['min', 'max'], name, value)


                                                                                                class IcmpV4(Entity):
                                                                                                    """
                                                                                                    Match ICMPV4 Protocol
                                                                                                    
                                                                                                    .. attribute:: type
                                                                                                    
                                                                                                    	Protocol type
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: code
                                                                                                    
                                                                                                    	Protocol code
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                        self.yang_name = "icmp-v4"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                            ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                        ])
                                                                                                        self.type = None
                                                                                                        self.code = None
                                                                                                        self._segment_path = lambda: "icmp-v4"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['type', 'code'], name, value)


                                                                                                class IcmpV6(Entity):
                                                                                                    """
                                                                                                    Match ICMPV6 Protocol array
                                                                                                    
                                                                                                    .. attribute:: type
                                                                                                    
                                                                                                    	Protocol type
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: code
                                                                                                    
                                                                                                    	Protocol code
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                        self.yang_name = "icmp-v6"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                            ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                        ])
                                                                                                        self.type = None
                                                                                                        self.code = None
                                                                                                        self._segment_path = lambda: "icmp-v6"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['type', 'code'], name, value)


                                                                                                class Ipv4PacketLen(Entity):
                                                                                                    """
                                                                                                    IPv4 packet length array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                        self.yang_name = "ipv4-packet-len"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ipv4-packet-len"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "ipv4-packet-len"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                                class Ipv6PacketLen(Entity):
                                                                                                    """
                                                                                                    IPv6 packet length array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                        self.yang_name = "ipv6-packet-len"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ipv6-packet-len"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "ipv6-packet-len"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                                class PacketLen(Entity):
                                                                                                    """
                                                                                                    Match packet length array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                        self.yang_name = "packet-len"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "packet-len"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "packet-len"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                                class FlowTag(Entity):
                                                                                                    """
                                                                                                    Match flow\-tag array
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                        self.yang_name = "flow-tag"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "flow-tag"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "flow-tag"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['min', 'max'], name, value)


                                                                                                class TcpFlag(Entity):
                                                                                                    """
                                                                                                    Match tcp flag value
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	Value of TCP flag
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: match_any
                                                                                                    
                                                                                                    	Match any TCP flag bit
                                                                                                    	**type**\: bool
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                        self.yang_name = "tcp-flag"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                                            ('match_any', (YLeaf(YType.boolean, 'match-any'), ['bool'])),
                                                                                                        ])
                                                                                                        self.value = None
                                                                                                        self.match_any = None
                                                                                                        self._segment_path = lambda: "tcp-flag"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['value', 'match_any'], name, value)


                                                                                                class Icmpv4Type(Entity):
                                                                                                    """
                                                                                                    Match ipv4 icmp type
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                        self.yang_name = "icmpv4-type"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "icmpv4-type"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "icmpv4-type"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                                class Icmpv4Code(Entity):
                                                                                                    """
                                                                                                    Match ipv4 icmp code
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                        self.yang_name = "icmpv4-code"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "icmpv4-code"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "icmpv4-code"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                                class Icmpv6Type(Entity):
                                                                                                    """
                                                                                                    Match ipv6 icmp type
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                        self.yang_name = "icmpv6-type"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "icmpv6-type"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "icmpv6-type"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                                class Icmpv6Code(Entity):
                                                                                                    """
                                                                                                    Match ipv6 icmp code
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                        self.yang_name = "icmpv6-code"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "icmpv6-code"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "icmpv6-code"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                                class MplsExp(Entity):
                                                                                                    """
                                                                                                    Match MPLS experimental topmost array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                        self.yang_name = "mpls-exp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "mpls-exp"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                                class MplsExpImp(Entity):
                                                                                                    """
                                                                                                    Match MPLS experimental imposition array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                        self.yang_name = "mpls-exp-imp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "mpls-exp-imp"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                                class MplsDispIpv4Acl(Entity):
                                                                                                    """
                                                                                                    MPLS Disposition IPv4 Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                        self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "mpls-disp-ipv4-acl"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                                class MplsDispIpv6Acl(Entity):
                                                                                                    """
                                                                                                    MPLS Disposition IPv6 Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                        self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "mpls-disp-ipv6-acl"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                                class MplsTopLabel(Entity):
                                                                                                    """
                                                                                                    MPLS Topmost LABEL
                                                                                                    
                                                                                                    .. attribute:: uint32_rng_array
                                                                                                    
                                                                                                    	uint32 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                        self.yang_name = "mpls-top-label"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint32_rng_array", ("uint32_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint32_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "mpls-top-label"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                                    class Uint32RngArray(Entity):
                                                                                                        """
                                                                                                        uint32 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                            self.yang_name = "uint32_rng_array"
                                                                                                            self.yang_parent_name = "mpls-top-label"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint32, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint32, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint32_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['min', 'max'], name, value)


                                                                                                class Cos(Entity):
                                                                                                    """
                                                                                                    Match CoS array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                        self.yang_name = "cos"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "cos"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                                class CosInr(Entity):
                                                                                                    """
                                                                                                    Match inner header CoS
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                        self.yang_name = "cos-inr"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "cos-inr"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                                class Dei(Entity):
                                                                                                    """
                                                                                                    Match DEI Bit
                                                                                                    
                                                                                                    .. attribute:: bit_value
                                                                                                    
                                                                                                    	Value of the DEI bit
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                        self.yang_name = "dei"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                        ])
                                                                                                        self.bit_value = None
                                                                                                        self._segment_path = lambda: "dei"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                                class DeiInr(Entity):
                                                                                                    """
                                                                                                    Match inner DEI Bit
                                                                                                    
                                                                                                    .. attribute:: bit_value
                                                                                                    
                                                                                                    	Value of the DEI bit
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                        self.yang_name = "dei-inr"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                        ])
                                                                                                        self.bit_value = None
                                                                                                        self._segment_path = lambda: "dei-inr"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                                class Vlan(Entity):
                                                                                                    """
                                                                                                    Match VLAN array
                                                                                                    
                                                                                                    .. attribute:: vlan_id_array
                                                                                                    
                                                                                                    	vlan id array
                                                                                                    	**type**\: list of  		 :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                        self.yang_name = "vlan"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("vlan-id-array", ("vlan_id_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.vlan_id_array = YList(self)
                                                                                                        self._segment_path = lambda: "vlan"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                                    class VlanIdArray(Entity):
                                                                                                        """
                                                                                                        vlan id array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	VLAN mask
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                            self.yang_name = "vlan-id-array"
                                                                                                            self.yang_parent_name = "vlan"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                                ('mask', (YLeaf(YType.uint16, 'mask'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self.mask = None
                                                                                                            self._segment_path = lambda: "vlan-id-array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['min', 'max', 'mask'], name, value)


                                                                                                class VlanInr(Entity):
                                                                                                    """
                                                                                                    Match inner header VLAN range array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                        self.yang_name = "vlan-inr"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "vlan-inr"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "vlan-inr"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['min', 'max'], name, value)


                                                                                                class FrDlci(Entity):
                                                                                                    """
                                                                                                    Match FR DLCI range array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                        self.yang_name = "fr-dlci"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "fr-dlci"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "fr-dlci"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['min', 'max'], name, value)


                                                                                                class SrcMac(Entity):
                                                                                                    """
                                                                                                    Match Source MAC address
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                        self.yang_name = "src-mac"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                            ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.mac_addr = []
                                                                                                        self.mask = []
                                                                                                        self._segment_path = lambda: "src-mac"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                                class DstMac(Entity):
                                                                                                    """
                                                                                                    Match Destination MAC address
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                        self.yang_name = "dst-mac"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                            ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.mac_addr = []
                                                                                                        self.mask = []
                                                                                                        self._segment_path = lambda: "dst-mac"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                                class AtmClp(Entity):
                                                                                                    """
                                                                                                    Match ATM CLP level
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                        self.yang_name = "atm-clp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "atm-clp"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                                class FrDe(Entity):
                                                                                                    """
                                                                                                    Match FR DE value
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                        self.yang_name = "fr-de"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "fr-de"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                                class Ipv4Acl(Entity):
                                                                                                    """
                                                                                                    IPv4 Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                        self.yang_name = "ipv4-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "ipv4-acl"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                                class Ipv6Acl(Entity):
                                                                                                    """
                                                                                                    IPv6 Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                        self.yang_name = "ipv6-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "ipv6-acl"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                                class EtherServiceAcl(Entity):
                                                                                                    """
                                                                                                    Ethernet\-Services Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                        self.yang_name = "ether-service-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "ether-service-acl"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                                class AvailId(Entity):
                                                                                                    """
                                                                                                    Available Identifiers
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                        self.yang_name = "avail-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "avail-id"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                                class MediaType(Entity):
                                                                                                    """
                                                                                                    Media Type
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                        self.yang_name = "media-type"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "media-type"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                                class SubsProtocol(Entity):
                                                                                                    """
                                                                                                    Protocol
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                        self.yang_name = "subs-protocol"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "subs-protocol"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                                class Dnis(Entity):
                                                                                                    """
                                                                                                    DNIS
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                        self.yang_name = "dnis"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "dnis"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                                class DnisRegex(Entity):
                                                                                                    """
                                                                                                    DNIS Regular Expression
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                        self.yang_name = "dnis-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "dnis-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                                class Domain(Entity):
                                                                                                    """
                                                                                                    Domain Name
                                                                                                    
                                                                                                    .. attribute:: domain_array
                                                                                                    
                                                                                                    	domain array
                                                                                                    	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                        self.yang_name = "domain"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.domain_array = YList(self)
                                                                                                        self._segment_path = lambda: "domain"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                                    class DomainArray(Entity):
                                                                                                        """
                                                                                                        domain array
                                                                                                        
                                                                                                        .. attribute:: domain_name
                                                                                                        
                                                                                                        	domain name
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        .. attribute:: format_name
                                                                                                        
                                                                                                        	format name
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                            self.yang_name = "domain-array"
                                                                                                            self.yang_parent_name = "domain"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                                ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                            ])
                                                                                                            self.domain_name = None
                                                                                                            self.format_name = None
                                                                                                            self._segment_path = lambda: "domain-array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                                class DomainRegex(Entity):
                                                                                                    """
                                                                                                    Domain Regular Expression
                                                                                                    
                                                                                                    .. attribute:: domain_array
                                                                                                    
                                                                                                    	domain array
                                                                                                    	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                        self.yang_name = "domain-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.domain_array = YList(self)
                                                                                                        self._segment_path = lambda: "domain-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                                    class DomainArray(Entity):
                                                                                                        """
                                                                                                        domain array
                                                                                                        
                                                                                                        .. attribute:: domain_name
                                                                                                        
                                                                                                        	domain name
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        .. attribute:: format_name
                                                                                                        
                                                                                                        	format name
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                            self.yang_name = "domain-array"
                                                                                                            self.yang_parent_name = "domain-regex"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                                ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                            ])
                                                                                                            self.domain_name = None
                                                                                                            self.format_name = None
                                                                                                            self._segment_path = lambda: "domain-array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                                class NasPort(Entity):
                                                                                                    """
                                                                                                    NAS Port
                                                                                                    
                                                                                                    .. attribute:: nas_port_array
                                                                                                    
                                                                                                    	nas port array
                                                                                                    	**type**\: list of  		 :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                        self.yang_name = "nas-port"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("nas-port-array", ("nas_port_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.nas_port_array = YList(self)
                                                                                                        self._segment_path = lambda: "nas-port"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                                    class NasPortArray(Entity):
                                                                                                        """
                                                                                                        nas port array
                                                                                                        
                                                                                                        .. attribute:: sub_id
                                                                                                        
                                                                                                        	sub id
                                                                                                        	**type**\:  :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                        
                                                                                                        .. attribute:: operator
                                                                                                        
                                                                                                        	operator
                                                                                                        	**type**\:  :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                        
                                                                                                        .. attribute:: value
                                                                                                        
                                                                                                        	value
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                            self.yang_name = "nas-port-array"
                                                                                                            self.yang_parent_name = "nas-port"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('sub_id', (YLeaf(YType.enumeration, 'sub-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchNasPortSubIdEn', '')])),
                                                                                                                ('operator', (YLeaf(YType.enumeration, 'operator'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchLogicalOperatorEn', '')])),
                                                                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                                            ])
                                                                                                            self.sub_id = None
                                                                                                            self.operator = None
                                                                                                            self.value = None
                                                                                                            self._segment_path = lambda: "nas-port-array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['sub_id', 'operator', 'value'], name, value)


                                                                                                class ServiceName(Entity):
                                                                                                    """
                                                                                                    Service Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                        self.yang_name = "service-name"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "service-name"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                                class ServiceNameRegex(Entity):
                                                                                                    """
                                                                                                    Service Name Regular Exp
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                        self.yang_name = "service-name-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "service-name-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                                class SrcAddrIpv4(Entity):
                                                                                                    """
                                                                                                    Source Address IPV4
                                                                                                    
                                                                                                    .. attribute:: ipv4_addr_array
                                                                                                    
                                                                                                    	ipv4 addr array
                                                                                                    	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                        self.yang_name = "src-addr-ipv4"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.ipv4_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "src-addr-ipv4"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                                    class Ipv4AddrArray(Entity):
                                                                                                        """
                                                                                                        ipv4 addr array
                                                                                                        
                                                                                                        .. attribute:: prefix
                                                                                                        
                                                                                                        	prefix
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	mask
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                            self.yang_name = "ipv4-addr-array"
                                                                                                            self.yang_parent_name = "src-addr-ipv4"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                                ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                            ])
                                                                                                            self.prefix = None
                                                                                                            self.mask = None
                                                                                                            self._segment_path = lambda: "ipv4-addr-array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                                class DstAddrIpv4(Entity):
                                                                                                    """
                                                                                                    Destination Address IPV4
                                                                                                    
                                                                                                    .. attribute:: ipv4_addr_array
                                                                                                    
                                                                                                    	ipv4 addr array
                                                                                                    	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                        self.yang_name = "dst-addr-ipv4"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.ipv4_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "dst-addr-ipv4"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                                    class Ipv4AddrArray(Entity):
                                                                                                        """
                                                                                                        ipv4 addr array
                                                                                                        
                                                                                                        .. attribute:: prefix
                                                                                                        
                                                                                                        	prefix
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	mask
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                            self.yang_name = "ipv4-addr-array"
                                                                                                            self.yang_parent_name = "dst-addr-ipv4"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                                ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                            ])
                                                                                                            self.prefix = None
                                                                                                            self.mask = None
                                                                                                            self._segment_path = lambda: "ipv4-addr-array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                                class SrcAddrIpv6(Entity):
                                                                                                    """
                                                                                                    Source Address IPV6
                                                                                                    
                                                                                                    .. attribute:: ipv6_addr_array
                                                                                                    
                                                                                                    	ipv6 addr array
                                                                                                    	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                        self.yang_name = "src-addr-ipv6"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.ipv6_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "src-addr-ipv6"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                                    class Ipv6AddrArray(Entity):
                                                                                                        """
                                                                                                        ipv6 addr array
                                                                                                        
                                                                                                        .. attribute:: prefix
                                                                                                        
                                                                                                        	IPV6 prefix
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	IPV6 mask
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                            self.yang_name = "ipv6-addr-array"
                                                                                                            self.yang_parent_name = "src-addr-ipv6"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                                ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                            ])
                                                                                                            self.prefix = None
                                                                                                            self.mask = None
                                                                                                            self._segment_path = lambda: "ipv6-addr-array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                                class DstAddrIpv6(Entity):
                                                                                                    """
                                                                                                    Destination Address IPV6
                                                                                                    
                                                                                                    .. attribute:: ipv6_addr_array
                                                                                                    
                                                                                                    	ipv6 addr array
                                                                                                    	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                        self.yang_name = "dst-addr-ipv6"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.ipv6_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "dst-addr-ipv6"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                                    class Ipv6AddrArray(Entity):
                                                                                                        """
                                                                                                        ipv6 addr array
                                                                                                        
                                                                                                        .. attribute:: prefix
                                                                                                        
                                                                                                        	IPV6 prefix
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	IPV6 mask
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                            self.yang_name = "ipv6-addr-array"
                                                                                                            self.yang_parent_name = "dst-addr-ipv6"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                                ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                            ])
                                                                                                            self.prefix = None
                                                                                                            self.mask = None
                                                                                                            self._segment_path = lambda: "ipv6-addr-array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                                class SrcAddrMac(Entity):
                                                                                                    """
                                                                                                    Source Address MAC
                                                                                                    
                                                                                                    .. attribute:: mac_addr_array
                                                                                                    
                                                                                                    	mac addr array
                                                                                                    	**type**\: list of  		 :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                        self.yang_name = "src-addr-mac"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("mac-addr-array", ("mac_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.mac_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "src-addr-mac"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                                    class MacAddrArray(Entity):
                                                                                                        """
                                                                                                        mac addr array
                                                                                                        
                                                                                                        .. attribute:: mac_addr
                                                                                                        
                                                                                                        	MAC address
                                                                                                        	**type**\: list of int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	MAC mask
                                                                                                        	**type**\: list of int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                            self.yang_name = "mac-addr-array"
                                                                                                            self.yang_parent_name = "src-addr-mac"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                                ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                            ])
                                                                                                            self.mac_addr = []
                                                                                                            self.mask = []
                                                                                                            self._segment_path = lambda: "mac-addr-array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                                class Timer(Entity):
                                                                                                    """
                                                                                                    Timer
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                        self.yang_name = "timer"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "timer"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                                class TimerRegexp(Entity):
                                                                                                    """
                                                                                                    Timer Regular Expression
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                        self.yang_name = "timer-regexp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "timer-regexp"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                                class TunnelName(Entity):
                                                                                                    """
                                                                                                    Tunnel Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                        self.yang_name = "tunnel-name"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "tunnel-name"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                                class TunnelNameRegex(Entity):
                                                                                                    """
                                                                                                    Tunnel Name Regular Expression
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                        self.yang_name = "tunnel-name-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "tunnel-name-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                                class UserName(Entity):
                                                                                                    """
                                                                                                    User Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                        self.yang_name = "user-name"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "user-name"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                                class UserNameRegex(Entity):
                                                                                                    """
                                                                                                    User Name Regular Expression
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                        self.yang_name = "user-name-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "user-name-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                                class AuthUsername(Entity):
                                                                                                    """
                                                                                                    Authenticated User Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                        self.yang_name = "auth-username"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "auth-username"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                                class AuthUsernameRegex(Entity):
                                                                                                    """
                                                                                                    Authenticated User Name RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                        self.yang_name = "auth-username-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "auth-username-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                                class UnauthUsername(Entity):
                                                                                                    """
                                                                                                    Unauthenticated User Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                        self.yang_name = "unauth-username"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "unauth-username"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                                class UnauthUsernameRegex(Entity):
                                                                                                    """
                                                                                                    Unauthenticated User Name RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                        self.yang_name = "unauth-username-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "unauth-username-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                                class AuthDomain(Entity):
                                                                                                    """
                                                                                                    Authenticated domain name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                        self.yang_name = "auth-domain"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "auth-domain"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                                class AuthDomainRegex(Entity):
                                                                                                    """
                                                                                                    Authenticated Domain Name RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                        self.yang_name = "auth-domain-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "auth-domain-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                                class UnauthDomain(Entity):
                                                                                                    """
                                                                                                    Unauthenticated Domain Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                        self.yang_name = "unauth-domain"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "unauth-domain"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                                class UnauthDomainRegex(Entity):
                                                                                                    """
                                                                                                    Unauthenticated Domain Name RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                        self.yang_name = "unauth-domain-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "unauth-domain-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                                class VendorId(Entity):
                                                                                                    """
                                                                                                    Vendor ID
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                        self.yang_name = "vendor-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "vendor-id"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                                class VendorIdRegex(Entity):
                                                                                                    """
                                                                                                    Vendor ID RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                        self.yang_name = "vendor-id-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "vendor-id-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                                class AccessInterface(Entity):
                                                                                                    """
                                                                                                    Access interface
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                        self.yang_name = "access-interface"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "access-interface"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                                class InputInterface(Entity):
                                                                                                    """
                                                                                                    Input interface
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                        self.yang_name = "input-interface"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "input-interface"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                                class InputIntfhdl(Entity):
                                                                                                    """
                                                                                                    Input interface handle
                                                                                                    
                                                                                                    .. attribute:: uint64_array
                                                                                                    
                                                                                                    	uint64 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..18446744073709551615
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                        self.yang_name = "input-intfhdl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint64_array', (YLeafList(YType.uint64, 'uint64_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint64_array = []
                                                                                                        self._segment_path = lambda: "input-intfhdl"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                                class Ethertype(Entity):
                                                                                                    """
                                                                                                    Ethernet type
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                        self.yang_name = "ethertype"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ethertype"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "ethertype"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['min', 'max'], name, value)


                                                                                                class FlowKeyData(Entity):
                                                                                                    """
                                                                                                    Flow key structure
                                                                                                    
                                                                                                    .. attribute:: flow_keys
                                                                                                    
                                                                                                    	flow keys
                                                                                                    	**type**\:  :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                                    
                                                                                                    .. attribute:: max_count
                                                                                                    
                                                                                                    	Maximum count of flows
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: idle_timeout
                                                                                                    
                                                                                                    	Idle timeout of flows (in seconds)
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    	**units**\: second
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                        self.yang_name = "flow-key-data"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("flow-keys", ("flow_keys", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys))])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('max_count', (YLeaf(YType.uint16, 'max-count'), ['int'])),
                                                                                                            ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                                                        ])
                                                                                                        self.max_count = None
                                                                                                        self.idle_timeout = None

                                                                                                        self.flow_keys = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                        self.flow_keys.parent = self
                                                                                                        self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                        self._segment_path = lambda: "flow-key-data"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['max_count', 'idle_timeout'], name, value)


                                                                                                    class FlowKeys(Entity):
                                                                                                        """
                                                                                                        flow keys
                                                                                                        
                                                                                                        .. attribute:: keys
                                                                                                        
                                                                                                        	keys
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                        
                                                                                                        .. attribute:: num
                                                                                                        
                                                                                                        	num
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                            self.yang_name = "flow-keys"
                                                                                                            self.yang_parent_name = "flow-key-data"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('keys', (YLeaf(YType.str, 'keys'), ['str'])),
                                                                                                                ('num', (YLeaf(YType.uint8, 'num'), ['int'])),
                                                                                                            ])
                                                                                                            self.keys = None
                                                                                                            self.num = None
                                                                                                            self._segment_path = lambda: "flow-keys"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                                class DhcpClientId(Entity):
                                                                                                    """
                                                                                                    Dhcp Client ID
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                        self.yang_name = "dhcp-client-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "dhcp-client-id"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                                class DhcpClientIdRegex(Entity):
                                                                                                    """
                                                                                                    Dhcp Client ID RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                        self.yang_name = "dhcp-client-id-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "dhcp-client-id-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                                class CircuitId(Entity):
                                                                                                    """
                                                                                                    Circuit ID
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                        self.yang_name = "circuit-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "circuit-id"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                                class CircuitIdRegex(Entity):
                                                                                                    """
                                                                                                    Circuit ID RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                        self.yang_name = "circuit-id-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "circuit-id-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                                class RemoteId(Entity):
                                                                                                    """
                                                                                                    Remote ID
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                        self.yang_name = "remote-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "remote-id"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                                class RemoteIdRegex(Entity):
                                                                                                    """
                                                                                                    Remote ID RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                        self.yang_name = "remote-id-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "remote-id-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                                class SrcPort(Entity):
                                                                                                    """
                                                                                                    Source port
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                        self.yang_name = "src-port"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "src-port"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "src-port"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                                                class DstPort(Entity):
                                                                                                    """
                                                                                                    Destination port
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                        self.yang_name = "dst-port"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "dst-port"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "dst-port"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class ExcdclassP(Entity):
                                                                                """
                                                                                excdclass p
                                                                                
                                                                                .. attribute:: class_map_bg
                                                                                
                                                                                	class map bg
                                                                                	**type**\: list of  		 :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP, self).__init__()

                                                                                    self.yang_name = "excdclass-p"
                                                                                    self.yang_parent_name = "police"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("class-map-bg", ("class_map_bg", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.class_map_bg = YList(self)
                                                                                    self._segment_path = lambda: "excdclass-p"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP, [], name, value)


                                                                                class ClassMapBg(Entity):
                                                                                    """
                                                                                    class map bg
                                                                                    
                                                                                    .. attribute:: match_infop
                                                                                    
                                                                                    	Pointer to the first Match info
                                                                                    	**type**\:  :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop>`
                                                                                    
                                                                                    .. attribute:: name
                                                                                    
                                                                                    	Name of the class\-map
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..65
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	Class\-Map Type QoS/PBR/Netflow/..
                                                                                    	**type**\:  :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                                                    
                                                                                    .. attribute:: mode
                                                                                    
                                                                                    	Class\-Map Mode Match any/Match all
                                                                                    	**type**\:  :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                                    
                                                                                    .. attribute:: description
                                                                                    
                                                                                    	description
                                                                                    	**type**\: str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg, self).__init__()

                                                                                        self.yang_name = "class-map-bg"
                                                                                        self.yang_parent_name = "excdclass-p"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("match-infop", ("match_infop", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop))])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapTypeEn', '')])),
                                                                                            ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapModeEn', '')])),
                                                                                            ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                        ])
                                                                                        self.name = None
                                                                                        self.type = None
                                                                                        self.mode = None
                                                                                        self.description = None

                                                                                        self.match_infop = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop()
                                                                                        self.match_infop.parent = self
                                                                                        self._children_name_map["match_infop"] = "match-infop"
                                                                                        self._segment_path = lambda: "class-map-bg"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg, ['name', 'type', 'mode', 'description'], name, value)


                                                                                    class MatchInfop(Entity):
                                                                                        """
                                                                                        Pointer to the first Match info
                                                                                        
                                                                                        .. attribute:: class_match_info_st
                                                                                        
                                                                                        	class match info st
                                                                                        	**type**\: list of  		 :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop, self).__init__()

                                                                                            self.yang_name = "match-infop"
                                                                                            self.yang_parent_name = "class-map-bg"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("class-match-info-st", ("class_match_info_st", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.class_match_info_st = YList(self)
                                                                                            self._segment_path = lambda: "match-infop"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop, [], name, value)


                                                                                        class ClassMatchInfoSt(Entity):
                                                                                            """
                                                                                            class match info st
                                                                                            
                                                                                            .. attribute:: match_data
                                                                                            
                                                                                            	Match criteria
                                                                                            	**type**\:  :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                            
                                                                                            .. attribute:: flags
                                                                                            
                                                                                            	Flags
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                                self.yang_name = "class-match-info-st"
                                                                                                self.yang_parent_name = "match-infop"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("match-data", ("match_data", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData))])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                                ])
                                                                                                self.flags = None

                                                                                                self.match_data = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                                self.match_data.parent = self
                                                                                                self._children_name_map["match_data"] = "match-data"
                                                                                                self._segment_path = lambda: "class-match-info-st"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                            class MatchData(Entity):
                                                                                                """
                                                                                                Match criteria
                                                                                                
                                                                                                .. attribute:: ipv4_dscp
                                                                                                
                                                                                                	IPv4 DSCP
                                                                                                	**type**\:  :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                                
                                                                                                .. attribute:: ipv6_dscp
                                                                                                
                                                                                                	IPv6 DSCP
                                                                                                	**type**\:  :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                                
                                                                                                .. attribute:: dscp
                                                                                                
                                                                                                	Match DSCP range array
                                                                                                	**type**\:  :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                                
                                                                                                .. attribute:: ipv4_prec
                                                                                                
                                                                                                	IPv4 Precedence
                                                                                                	**type**\:  :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                                
                                                                                                .. attribute:: ipv6_prec
                                                                                                
                                                                                                	IPv6 Precedence
                                                                                                	**type**\:  :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                                
                                                                                                .. attribute:: prec
                                                                                                
                                                                                                	Match Precedence array
                                                                                                	**type**\:  :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                                
                                                                                                .. attribute:: discard_class
                                                                                                
                                                                                                	Match Discard Class array
                                                                                                	**type**\:  :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                                
                                                                                                .. attribute:: qos_group
                                                                                                
                                                                                                	Match QoS group array
                                                                                                	**type**\:  :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                                
                                                                                                .. attribute:: traffic_class
                                                                                                
                                                                                                	Match Traffic class array
                                                                                                	**type**\:  :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                                
                                                                                                .. attribute:: proto
                                                                                                
                                                                                                	Match Protocol array
                                                                                                	**type**\:  :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                                
                                                                                                .. attribute:: icmp_v4
                                                                                                
                                                                                                	Match ICMPV4 Protocol
                                                                                                	**type**\:  :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                                
                                                                                                .. attribute:: icmp_v6
                                                                                                
                                                                                                	Match ICMPV6 Protocol array
                                                                                                	**type**\:  :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                                
                                                                                                .. attribute:: ipv4_packet_len
                                                                                                
                                                                                                	IPv4 packet length array
                                                                                                	**type**\:  :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                                
                                                                                                .. attribute:: ipv6_packet_len
                                                                                                
                                                                                                	IPv6 packet length array
                                                                                                	**type**\:  :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                                
                                                                                                .. attribute:: packet_len
                                                                                                
                                                                                                	Match packet length array
                                                                                                	**type**\:  :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                                
                                                                                                .. attribute:: flow_tag
                                                                                                
                                                                                                	Match flow\-tag array
                                                                                                	**type**\:  :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                                
                                                                                                .. attribute:: tcp_flag
                                                                                                
                                                                                                	Match tcp flag value
                                                                                                	**type**\:  :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                                
                                                                                                .. attribute:: icmpv4_type
                                                                                                
                                                                                                	Match ipv4 icmp type
                                                                                                	**type**\:  :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                                
                                                                                                .. attribute:: icmpv4_code
                                                                                                
                                                                                                	Match ipv4 icmp code
                                                                                                	**type**\:  :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                                
                                                                                                .. attribute:: icmpv6_type
                                                                                                
                                                                                                	Match ipv6 icmp type
                                                                                                	**type**\:  :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                                
                                                                                                .. attribute:: icmpv6_code
                                                                                                
                                                                                                	Match ipv6 icmp code
                                                                                                	**type**\:  :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                                
                                                                                                .. attribute:: mpls_exp
                                                                                                
                                                                                                	Match MPLS experimental topmost array
                                                                                                	**type**\:  :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                                
                                                                                                .. attribute:: mpls_exp_imp
                                                                                                
                                                                                                	Match MPLS experimental imposition array
                                                                                                	**type**\:  :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                                
                                                                                                .. attribute:: mpls_disp_ipv4_acl
                                                                                                
                                                                                                	MPLS Disposition IPv4 Access\-list
                                                                                                	**type**\:  :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                                
                                                                                                .. attribute:: mpls_disp_ipv6_acl
                                                                                                
                                                                                                	MPLS Disposition IPv6 Access\-list
                                                                                                	**type**\:  :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                                
                                                                                                .. attribute:: mpls_top_label
                                                                                                
                                                                                                	MPLS Topmost LABEL
                                                                                                	**type**\:  :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                                
                                                                                                .. attribute:: cos
                                                                                                
                                                                                                	Match CoS array
                                                                                                	**type**\:  :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                                
                                                                                                .. attribute:: cos_inr
                                                                                                
                                                                                                	Match inner header CoS
                                                                                                	**type**\:  :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                                
                                                                                                .. attribute:: dei
                                                                                                
                                                                                                	Match DEI Bit
                                                                                                	**type**\:  :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                                
                                                                                                .. attribute:: dei_inr
                                                                                                
                                                                                                	Match inner DEI Bit
                                                                                                	**type**\:  :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                                
                                                                                                .. attribute:: vlan
                                                                                                
                                                                                                	Match VLAN array
                                                                                                	**type**\:  :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                                
                                                                                                .. attribute:: vlan_inr
                                                                                                
                                                                                                	Match inner header VLAN range array
                                                                                                	**type**\:  :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                                
                                                                                                .. attribute:: fr_dlci
                                                                                                
                                                                                                	Match FR DLCI range array
                                                                                                	**type**\:  :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                                
                                                                                                .. attribute:: src_mac
                                                                                                
                                                                                                	Match Source MAC address
                                                                                                	**type**\:  :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                                
                                                                                                .. attribute:: dst_mac
                                                                                                
                                                                                                	Match Destination MAC address
                                                                                                	**type**\:  :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                                
                                                                                                .. attribute:: atm_clp
                                                                                                
                                                                                                	Match ATM CLP level
                                                                                                	**type**\:  :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                                
                                                                                                .. attribute:: fr_de
                                                                                                
                                                                                                	Match FR DE value
                                                                                                	**type**\:  :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                                
                                                                                                .. attribute:: ipv4_acl
                                                                                                
                                                                                                	IPv4 Access\-list
                                                                                                	**type**\:  :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                                
                                                                                                .. attribute:: ipv6_acl
                                                                                                
                                                                                                	IPv6 Access\-list
                                                                                                	**type**\:  :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                                
                                                                                                .. attribute:: ether_service_acl
                                                                                                
                                                                                                	Ethernet\-Services Access\-list
                                                                                                	**type**\:  :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                                
                                                                                                .. attribute:: avail_id
                                                                                                
                                                                                                	Available Identifiers
                                                                                                	**type**\:  :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                                
                                                                                                .. attribute:: media_type
                                                                                                
                                                                                                	Media Type
                                                                                                	**type**\:  :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                                
                                                                                                .. attribute:: subs_protocol
                                                                                                
                                                                                                	Protocol
                                                                                                	**type**\:  :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                                
                                                                                                .. attribute:: dnis
                                                                                                
                                                                                                	DNIS
                                                                                                	**type**\:  :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                                
                                                                                                .. attribute:: dnis_regex
                                                                                                
                                                                                                	DNIS Regular Expression
                                                                                                	**type**\:  :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                                
                                                                                                .. attribute:: domain
                                                                                                
                                                                                                	Domain Name
                                                                                                	**type**\:  :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                                
                                                                                                .. attribute:: domain_regex
                                                                                                
                                                                                                	Domain Regular Expression
                                                                                                	**type**\:  :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                                
                                                                                                .. attribute:: nas_port
                                                                                                
                                                                                                	NAS Port
                                                                                                	**type**\:  :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                                
                                                                                                .. attribute:: service_name
                                                                                                
                                                                                                	Service Name
                                                                                                	**type**\:  :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                                
                                                                                                .. attribute:: service_name_regex
                                                                                                
                                                                                                	Service Name Regular Exp
                                                                                                	**type**\:  :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                                
                                                                                                .. attribute:: src_addr_ipv4
                                                                                                
                                                                                                	Source Address IPV4
                                                                                                	**type**\:  :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                                
                                                                                                .. attribute:: dst_addr_ipv4
                                                                                                
                                                                                                	Destination Address IPV4
                                                                                                	**type**\:  :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                                
                                                                                                .. attribute:: src_addr_ipv6
                                                                                                
                                                                                                	Source Address IPV6
                                                                                                	**type**\:  :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                                
                                                                                                .. attribute:: dst_addr_ipv6
                                                                                                
                                                                                                	Destination Address IPV6
                                                                                                	**type**\:  :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                                
                                                                                                .. attribute:: src_addr_mac
                                                                                                
                                                                                                	Source Address MAC
                                                                                                	**type**\:  :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                                
                                                                                                .. attribute:: timer
                                                                                                
                                                                                                	Timer
                                                                                                	**type**\:  :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                                
                                                                                                .. attribute:: timer_regexp
                                                                                                
                                                                                                	Timer Regular Expression
                                                                                                	**type**\:  :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                                
                                                                                                .. attribute:: tunnel_name
                                                                                                
                                                                                                	Tunnel Name
                                                                                                	**type**\:  :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                                
                                                                                                .. attribute:: tunnel_name_regex
                                                                                                
                                                                                                	Tunnel Name Regular Expression
                                                                                                	**type**\:  :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                                
                                                                                                .. attribute:: user_name
                                                                                                
                                                                                                	User Name
                                                                                                	**type**\:  :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                                
                                                                                                .. attribute:: user_name_regex
                                                                                                
                                                                                                	User Name Regular Expression
                                                                                                	**type**\:  :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                                
                                                                                                .. attribute:: auth_username
                                                                                                
                                                                                                	Authenticated User Name
                                                                                                	**type**\:  :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                                
                                                                                                .. attribute:: auth_username_regex
                                                                                                
                                                                                                	Authenticated User Name RegEx
                                                                                                	**type**\:  :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                                
                                                                                                .. attribute:: unauth_username
                                                                                                
                                                                                                	Unauthenticated User Name
                                                                                                	**type**\:  :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                                
                                                                                                .. attribute:: unauth_username_regex
                                                                                                
                                                                                                	Unauthenticated User Name RegEx
                                                                                                	**type**\:  :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                                
                                                                                                .. attribute:: auth_domain
                                                                                                
                                                                                                	Authenticated domain name
                                                                                                	**type**\:  :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                                
                                                                                                .. attribute:: auth_domain_regex
                                                                                                
                                                                                                	Authenticated Domain Name RegEx
                                                                                                	**type**\:  :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                                
                                                                                                .. attribute:: unauth_domain
                                                                                                
                                                                                                	Unauthenticated Domain Name
                                                                                                	**type**\:  :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                                
                                                                                                .. attribute:: unauth_domain_regex
                                                                                                
                                                                                                	Unauthenticated Domain Name RegEx
                                                                                                	**type**\:  :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                                
                                                                                                .. attribute:: vendor_id
                                                                                                
                                                                                                	Vendor ID
                                                                                                	**type**\:  :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                                
                                                                                                .. attribute:: vendor_id_regex
                                                                                                
                                                                                                	Vendor ID RegEx
                                                                                                	**type**\:  :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                                
                                                                                                .. attribute:: access_interface
                                                                                                
                                                                                                	Access interface
                                                                                                	**type**\:  :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                                
                                                                                                .. attribute:: input_interface
                                                                                                
                                                                                                	Input interface
                                                                                                	**type**\:  :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                                
                                                                                                .. attribute:: input_intfhdl
                                                                                                
                                                                                                	Input interface handle
                                                                                                	**type**\:  :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                                
                                                                                                .. attribute:: ethertype
                                                                                                
                                                                                                	Ethernet type
                                                                                                	**type**\:  :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                                
                                                                                                .. attribute:: flow_key_data
                                                                                                
                                                                                                	Flow key structure
                                                                                                	**type**\:  :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                                
                                                                                                .. attribute:: dhcp_client_id
                                                                                                
                                                                                                	Dhcp Client ID
                                                                                                	**type**\:  :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                                
                                                                                                .. attribute:: dhcp_client_id_regex
                                                                                                
                                                                                                	Dhcp Client ID RegEx
                                                                                                	**type**\:  :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                                
                                                                                                .. attribute:: circuit_id
                                                                                                
                                                                                                	Circuit ID
                                                                                                	**type**\:  :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                                
                                                                                                .. attribute:: circuit_id_regex
                                                                                                
                                                                                                	Circuit ID RegEx
                                                                                                	**type**\:  :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                                
                                                                                                .. attribute:: remote_id
                                                                                                
                                                                                                	Remote ID
                                                                                                	**type**\:  :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                                
                                                                                                .. attribute:: remote_id_regex
                                                                                                
                                                                                                	Remote ID RegEx
                                                                                                	**type**\:  :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                                
                                                                                                .. attribute:: src_port
                                                                                                
                                                                                                	Source port
                                                                                                	**type**\:  :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                                
                                                                                                .. attribute:: dst_port
                                                                                                
                                                                                                	Destination port
                                                                                                	**type**\:  :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	type
                                                                                                	**type**\:  :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                                
                                                                                                .. attribute:: mpls_top_eos
                                                                                                
                                                                                                	MPLS Topmost EOS
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: fragment_type
                                                                                                
                                                                                                	Fragment type
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: authen_status
                                                                                                
                                                                                                	Authentication Status
                                                                                                	**type**\:  :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                                
                                                                                                .. attribute:: mlp_negotiated
                                                                                                
                                                                                                	MLP Negotiated
                                                                                                	**type**\:  :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                                    self.yang_name = "match-data"
                                                                                                    self.yang_parent_name = "class-match-info-st"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv4-dscp", ("ipv4_dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp)), ("ipv6-dscp", ("ipv6_dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp)), ("dscp", ("dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp)), ("ipv4-prec", ("ipv4_prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec)), ("ipv6-prec", ("ipv6_prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec)), ("prec", ("prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec)), ("discard-class", ("discard_class", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass)), ("qos-group", ("qos_group", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup)), ("traffic-class", ("traffic_class", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass)), ("proto", ("proto", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto)), ("icmp-v4", ("icmp_v4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4)), ("icmp-v6", ("icmp_v6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6)), ("ipv4-packet-len", ("ipv4_packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen)), ("ipv6-packet-len", ("ipv6_packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen)), ("packet-len", ("packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen)), ("flow-tag", ("flow_tag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag)), ("tcp-flag", ("tcp_flag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag)), ("icmpv4-type", ("icmpv4_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type)), ("icmpv4-code", ("icmpv4_code", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code)), ("icmpv6-type", ("icmpv6_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type)), ("icmpv6-code", ("icmpv6_code", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code)), ("mpls-exp", ("mpls_exp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp)), ("mpls-exp-imp", ("mpls_exp_imp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp)), ("mpls-disp-ipv4-acl", ("mpls_disp_ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl)), ("mpls-disp-ipv6-acl", ("mpls_disp_ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl)), ("mpls-top-label", ("mpls_top_label", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel)), ("cos", ("cos", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos)), ("cos-inr", ("cos_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr)), ("dei", ("dei", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei)), ("dei-inr", ("dei_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr)), ("vlan", ("vlan", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan)), ("vlan-inr", ("vlan_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)), ("fr-dlci", ("fr_dlci", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci)), ("src-mac", ("src_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac)), ("dst-mac", ("dst_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac)), ("atm-clp", ("atm_clp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp)), ("fr-de", ("fr_de", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe)), ("ipv4-acl", ("ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl)), ("ipv6-acl", ("ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl)), ("ether-service-acl", ("ether_service_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl)), ("avail-id", ("avail_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId)), ("media-type", ("media_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType)), ("subs-protocol", ("subs_protocol", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol)), ("dnis", ("dnis", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis)), ("dnis-regex", ("dnis_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex)), ("domain", ("domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain)), ("domain-regex", ("domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex)), ("nas-port", ("nas_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort)), ("service-name", ("service_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName)), ("service-name-regex", ("service_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex)), ("src-addr-ipv4", ("src_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4)), ("dst-addr-ipv4", ("dst_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4)), ("src-addr-ipv6", ("src_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6)), ("dst-addr-ipv6", ("dst_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6)), ("src-addr-mac", ("src_addr_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac)), ("timer", ("timer", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer)), ("timer-regexp", ("timer_regexp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp)), ("tunnel-name", ("tunnel_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName)), ("tunnel-name-regex", ("tunnel_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex)), ("user-name", ("user_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName)), ("user-name-regex", ("user_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex)), ("auth-username", ("auth_username", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername)), ("auth-username-regex", ("auth_username_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex)), ("unauth-username", ("unauth_username", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername)), ("unauth-username-regex", ("unauth_username_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex)), ("auth-domain", ("auth_domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain)), ("auth-domain-regex", ("auth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex)), ("unauth-domain", ("unauth_domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain)), ("unauth-domain-regex", ("unauth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex)), ("vendor-id", ("vendor_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId)), ("vendor-id-regex", ("vendor_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex)), ("access-interface", ("access_interface", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface)), ("input-interface", ("input_interface", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface)), ("input-intfhdl", ("input_intfhdl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl)), ("ethertype", ("ethertype", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype)), ("flow-key-data", ("flow_key_data", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData)), ("dhcp-client-id", ("dhcp_client_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId)), ("dhcp-client-id-regex", ("dhcp_client_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex)), ("circuit-id", ("circuit_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId)), ("circuit-id-regex", ("circuit_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex)), ("remote-id", ("remote_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId)), ("remote-id-regex", ("remote_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex)), ("src-port", ("src_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort)), ("dst-port", ("dst_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort))])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchTypeEn', '')])),
                                                                                                        ('mpls_top_eos', (YLeaf(YType.uint8, 'mpls-top-eos'), ['int'])),
                                                                                                        ('fragment_type', (YLeaf(YType.uint8, 'fragment-type'), ['int'])),
                                                                                                        ('authen_status', (YLeaf(YType.enumeration, 'authen-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchAuthenStatusEn', '')])),
                                                                                                        ('mlp_negotiated', (YLeaf(YType.enumeration, 'mlp-negotiated'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchMlpNegotiatedEn', '')])),
                                                                                                    ])
                                                                                                    self.type = None
                                                                                                    self.mpls_top_eos = None
                                                                                                    self.fragment_type = None
                                                                                                    self.authen_status = None
                                                                                                    self.mlp_negotiated = None

                                                                                                    self.ipv4_dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                                    self.ipv4_dscp.parent = self
                                                                                                    self._children_name_map["ipv4_dscp"] = "ipv4-dscp"

                                                                                                    self.ipv6_dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                                    self.ipv6_dscp.parent = self
                                                                                                    self._children_name_map["ipv6_dscp"] = "ipv6-dscp"

                                                                                                    self.dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                                    self.dscp.parent = self
                                                                                                    self._children_name_map["dscp"] = "dscp"

                                                                                                    self.ipv4_prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                                    self.ipv4_prec.parent = self
                                                                                                    self._children_name_map["ipv4_prec"] = "ipv4-prec"

                                                                                                    self.ipv6_prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                                    self.ipv6_prec.parent = self
                                                                                                    self._children_name_map["ipv6_prec"] = "ipv6-prec"

                                                                                                    self.prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                                    self.prec.parent = self
                                                                                                    self._children_name_map["prec"] = "prec"

                                                                                                    self.discard_class = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                                    self.discard_class.parent = self
                                                                                                    self._children_name_map["discard_class"] = "discard-class"

                                                                                                    self.qos_group = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                                    self.qos_group.parent = self
                                                                                                    self._children_name_map["qos_group"] = "qos-group"

                                                                                                    self.traffic_class = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                                    self.traffic_class.parent = self
                                                                                                    self._children_name_map["traffic_class"] = "traffic-class"

                                                                                                    self.proto = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                                    self.proto.parent = self
                                                                                                    self._children_name_map["proto"] = "proto"

                                                                                                    self.icmp_v4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                                    self.icmp_v4.parent = self
                                                                                                    self._children_name_map["icmp_v4"] = "icmp-v4"

                                                                                                    self.icmp_v6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                                    self.icmp_v6.parent = self
                                                                                                    self._children_name_map["icmp_v6"] = "icmp-v6"

                                                                                                    self.ipv4_packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                                    self.ipv4_packet_len.parent = self
                                                                                                    self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"

                                                                                                    self.ipv6_packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                                    self.ipv6_packet_len.parent = self
                                                                                                    self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"

                                                                                                    self.packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                                    self.packet_len.parent = self
                                                                                                    self._children_name_map["packet_len"] = "packet-len"

                                                                                                    self.flow_tag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                                    self.flow_tag.parent = self
                                                                                                    self._children_name_map["flow_tag"] = "flow-tag"

                                                                                                    self.tcp_flag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                                    self.tcp_flag.parent = self
                                                                                                    self._children_name_map["tcp_flag"] = "tcp-flag"

                                                                                                    self.icmpv4_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                                    self.icmpv4_type.parent = self
                                                                                                    self._children_name_map["icmpv4_type"] = "icmpv4-type"

                                                                                                    self.icmpv4_code = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                                    self.icmpv4_code.parent = self
                                                                                                    self._children_name_map["icmpv4_code"] = "icmpv4-code"

                                                                                                    self.icmpv6_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                                    self.icmpv6_type.parent = self
                                                                                                    self._children_name_map["icmpv6_type"] = "icmpv6-type"

                                                                                                    self.icmpv6_code = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                                    self.icmpv6_code.parent = self
                                                                                                    self._children_name_map["icmpv6_code"] = "icmpv6-code"

                                                                                                    self.mpls_exp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                                    self.mpls_exp.parent = self
                                                                                                    self._children_name_map["mpls_exp"] = "mpls-exp"

                                                                                                    self.mpls_exp_imp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                                    self.mpls_exp_imp.parent = self
                                                                                                    self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"

                                                                                                    self.mpls_disp_ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                                    self.mpls_disp_ipv4_acl.parent = self
                                                                                                    self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"

                                                                                                    self.mpls_disp_ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                                    self.mpls_disp_ipv6_acl.parent = self
                                                                                                    self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"

                                                                                                    self.mpls_top_label = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                                    self.mpls_top_label.parent = self
                                                                                                    self._children_name_map["mpls_top_label"] = "mpls-top-label"

                                                                                                    self.cos = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                                    self.cos.parent = self
                                                                                                    self._children_name_map["cos"] = "cos"

                                                                                                    self.cos_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                                    self.cos_inr.parent = self
                                                                                                    self._children_name_map["cos_inr"] = "cos-inr"

                                                                                                    self.dei = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                                    self.dei.parent = self
                                                                                                    self._children_name_map["dei"] = "dei"

                                                                                                    self.dei_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                                    self.dei_inr.parent = self
                                                                                                    self._children_name_map["dei_inr"] = "dei-inr"

                                                                                                    self.vlan = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                                    self.vlan.parent = self
                                                                                                    self._children_name_map["vlan"] = "vlan"

                                                                                                    self.vlan_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                                    self.vlan_inr.parent = self
                                                                                                    self._children_name_map["vlan_inr"] = "vlan-inr"

                                                                                                    self.fr_dlci = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                                    self.fr_dlci.parent = self
                                                                                                    self._children_name_map["fr_dlci"] = "fr-dlci"

                                                                                                    self.src_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                                    self.src_mac.parent = self
                                                                                                    self._children_name_map["src_mac"] = "src-mac"

                                                                                                    self.dst_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                                    self.dst_mac.parent = self
                                                                                                    self._children_name_map["dst_mac"] = "dst-mac"

                                                                                                    self.atm_clp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                                    self.atm_clp.parent = self
                                                                                                    self._children_name_map["atm_clp"] = "atm-clp"

                                                                                                    self.fr_de = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                                    self.fr_de.parent = self
                                                                                                    self._children_name_map["fr_de"] = "fr-de"

                                                                                                    self.ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                                    self.ipv4_acl.parent = self
                                                                                                    self._children_name_map["ipv4_acl"] = "ipv4-acl"

                                                                                                    self.ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                                    self.ipv6_acl.parent = self
                                                                                                    self._children_name_map["ipv6_acl"] = "ipv6-acl"

                                                                                                    self.ether_service_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                                    self.ether_service_acl.parent = self
                                                                                                    self._children_name_map["ether_service_acl"] = "ether-service-acl"

                                                                                                    self.avail_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                                    self.avail_id.parent = self
                                                                                                    self._children_name_map["avail_id"] = "avail-id"

                                                                                                    self.media_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                                    self.media_type.parent = self
                                                                                                    self._children_name_map["media_type"] = "media-type"

                                                                                                    self.subs_protocol = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                                    self.subs_protocol.parent = self
                                                                                                    self._children_name_map["subs_protocol"] = "subs-protocol"

                                                                                                    self.dnis = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                                    self.dnis.parent = self
                                                                                                    self._children_name_map["dnis"] = "dnis"

                                                                                                    self.dnis_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                                    self.dnis_regex.parent = self
                                                                                                    self._children_name_map["dnis_regex"] = "dnis-regex"

                                                                                                    self.domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                                    self.domain.parent = self
                                                                                                    self._children_name_map["domain"] = "domain"

                                                                                                    self.domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                                    self.domain_regex.parent = self
                                                                                                    self._children_name_map["domain_regex"] = "domain-regex"

                                                                                                    self.nas_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                                    self.nas_port.parent = self
                                                                                                    self._children_name_map["nas_port"] = "nas-port"

                                                                                                    self.service_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                                    self.service_name.parent = self
                                                                                                    self._children_name_map["service_name"] = "service-name"

                                                                                                    self.service_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                                    self.service_name_regex.parent = self
                                                                                                    self._children_name_map["service_name_regex"] = "service-name-regex"

                                                                                                    self.src_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                                    self.src_addr_ipv4.parent = self
                                                                                                    self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"

                                                                                                    self.dst_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                                    self.dst_addr_ipv4.parent = self
                                                                                                    self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"

                                                                                                    self.src_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                                    self.src_addr_ipv6.parent = self
                                                                                                    self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"

                                                                                                    self.dst_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                                    self.dst_addr_ipv6.parent = self
                                                                                                    self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"

                                                                                                    self.src_addr_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                                    self.src_addr_mac.parent = self
                                                                                                    self._children_name_map["src_addr_mac"] = "src-addr-mac"

                                                                                                    self.timer = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                                    self.timer.parent = self
                                                                                                    self._children_name_map["timer"] = "timer"

                                                                                                    self.timer_regexp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                                    self.timer_regexp.parent = self
                                                                                                    self._children_name_map["timer_regexp"] = "timer-regexp"

                                                                                                    self.tunnel_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                                    self.tunnel_name.parent = self
                                                                                                    self._children_name_map["tunnel_name"] = "tunnel-name"

                                                                                                    self.tunnel_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                                    self.tunnel_name_regex.parent = self
                                                                                                    self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"

                                                                                                    self.user_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                                    self.user_name.parent = self
                                                                                                    self._children_name_map["user_name"] = "user-name"

                                                                                                    self.user_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                                    self.user_name_regex.parent = self
                                                                                                    self._children_name_map["user_name_regex"] = "user-name-regex"

                                                                                                    self.auth_username = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                                    self.auth_username.parent = self
                                                                                                    self._children_name_map["auth_username"] = "auth-username"

                                                                                                    self.auth_username_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                                    self.auth_username_regex.parent = self
                                                                                                    self._children_name_map["auth_username_regex"] = "auth-username-regex"

                                                                                                    self.unauth_username = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                                    self.unauth_username.parent = self
                                                                                                    self._children_name_map["unauth_username"] = "unauth-username"

                                                                                                    self.unauth_username_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                                    self.unauth_username_regex.parent = self
                                                                                                    self._children_name_map["unauth_username_regex"] = "unauth-username-regex"

                                                                                                    self.auth_domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                                    self.auth_domain.parent = self
                                                                                                    self._children_name_map["auth_domain"] = "auth-domain"

                                                                                                    self.auth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                                    self.auth_domain_regex.parent = self
                                                                                                    self._children_name_map["auth_domain_regex"] = "auth-domain-regex"

                                                                                                    self.unauth_domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                                    self.unauth_domain.parent = self
                                                                                                    self._children_name_map["unauth_domain"] = "unauth-domain"

                                                                                                    self.unauth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                                    self.unauth_domain_regex.parent = self
                                                                                                    self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"

                                                                                                    self.vendor_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                                    self.vendor_id.parent = self
                                                                                                    self._children_name_map["vendor_id"] = "vendor-id"

                                                                                                    self.vendor_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                                    self.vendor_id_regex.parent = self
                                                                                                    self._children_name_map["vendor_id_regex"] = "vendor-id-regex"

                                                                                                    self.access_interface = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                                    self.access_interface.parent = self
                                                                                                    self._children_name_map["access_interface"] = "access-interface"

                                                                                                    self.input_interface = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                                    self.input_interface.parent = self
                                                                                                    self._children_name_map["input_interface"] = "input-interface"

                                                                                                    self.input_intfhdl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                                    self.input_intfhdl.parent = self
                                                                                                    self._children_name_map["input_intfhdl"] = "input-intfhdl"

                                                                                                    self.ethertype = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                                    self.ethertype.parent = self
                                                                                                    self._children_name_map["ethertype"] = "ethertype"

                                                                                                    self.flow_key_data = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                                    self.flow_key_data.parent = self
                                                                                                    self._children_name_map["flow_key_data"] = "flow-key-data"

                                                                                                    self.dhcp_client_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                                    self.dhcp_client_id.parent = self
                                                                                                    self._children_name_map["dhcp_client_id"] = "dhcp-client-id"

                                                                                                    self.dhcp_client_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                                    self.dhcp_client_id_regex.parent = self
                                                                                                    self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"

                                                                                                    self.circuit_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                                    self.circuit_id.parent = self
                                                                                                    self._children_name_map["circuit_id"] = "circuit-id"

                                                                                                    self.circuit_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                                    self.circuit_id_regex.parent = self
                                                                                                    self._children_name_map["circuit_id_regex"] = "circuit-id-regex"

                                                                                                    self.remote_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                                    self.remote_id.parent = self
                                                                                                    self._children_name_map["remote_id"] = "remote-id"

                                                                                                    self.remote_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                                    self.remote_id_regex.parent = self
                                                                                                    self._children_name_map["remote_id_regex"] = "remote-id-regex"

                                                                                                    self.src_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                                    self.src_port.parent = self
                                                                                                    self._children_name_map["src_port"] = "src-port"

                                                                                                    self.dst_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                                    self.dst_port.parent = self
                                                                                                    self._children_name_map["dst_port"] = "dst-port"
                                                                                                    self._segment_path = lambda: "match-data"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['type', 'mpls_top_eos', 'fragment_type', 'authen_status', 'mlp_negotiated'], name, value)


                                                                                                class Ipv4Dscp(Entity):
                                                                                                    """
                                                                                                    IPv4 DSCP
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                        self.yang_name = "ipv4-dscp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ipv4-dscp"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "ipv4-dscp"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                                class Ipv6Dscp(Entity):
                                                                                                    """
                                                                                                    IPv6 DSCP
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                        self.yang_name = "ipv6-dscp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ipv6-dscp"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "ipv6-dscp"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                                class Dscp(Entity):
                                                                                                    """
                                                                                                    Match DSCP range array
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                        self.yang_name = "dscp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "dscp"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "dscp"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                                class Ipv4Prec(Entity):
                                                                                                    """
                                                                                                    IPv4 Precedence
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                        self.yang_name = "ipv4-prec"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "ipv4-prec"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                                class Ipv6Prec(Entity):
                                                                                                    """
                                                                                                    IPv6 Precedence
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                        self.yang_name = "ipv6-prec"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "ipv6-prec"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                                class Prec(Entity):
                                                                                                    """
                                                                                                    Match Precedence array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                        self.yang_name = "prec"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "prec"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                                class DiscardClass(Entity):
                                                                                                    """
                                                                                                    Match Discard Class array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                        self.yang_name = "discard-class"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "discard-class"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                                class QosGroup(Entity):
                                                                                                    """
                                                                                                    Match QoS group array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                        self.yang_name = "qos-group"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "qos-group"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "qos-group"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['min', 'max'], name, value)


                                                                                                class TrafficClass(Entity):
                                                                                                    """
                                                                                                    Match Traffic class array
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                        self.yang_name = "traffic-class"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "traffic-class"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "traffic-class"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['min', 'max'], name, value)


                                                                                                class Proto(Entity):
                                                                                                    """
                                                                                                    Match Protocol array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                        self.yang_name = "proto"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "proto"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "proto"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['min', 'max'], name, value)


                                                                                                class IcmpV4(Entity):
                                                                                                    """
                                                                                                    Match ICMPV4 Protocol
                                                                                                    
                                                                                                    .. attribute:: type
                                                                                                    
                                                                                                    	Protocol type
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: code
                                                                                                    
                                                                                                    	Protocol code
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                        self.yang_name = "icmp-v4"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                            ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                        ])
                                                                                                        self.type = None
                                                                                                        self.code = None
                                                                                                        self._segment_path = lambda: "icmp-v4"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['type', 'code'], name, value)


                                                                                                class IcmpV6(Entity):
                                                                                                    """
                                                                                                    Match ICMPV6 Protocol array
                                                                                                    
                                                                                                    .. attribute:: type
                                                                                                    
                                                                                                    	Protocol type
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: code
                                                                                                    
                                                                                                    	Protocol code
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                        self.yang_name = "icmp-v6"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                            ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                        ])
                                                                                                        self.type = None
                                                                                                        self.code = None
                                                                                                        self._segment_path = lambda: "icmp-v6"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['type', 'code'], name, value)


                                                                                                class Ipv4PacketLen(Entity):
                                                                                                    """
                                                                                                    IPv4 packet length array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                        self.yang_name = "ipv4-packet-len"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ipv4-packet-len"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "ipv4-packet-len"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                                class Ipv6PacketLen(Entity):
                                                                                                    """
                                                                                                    IPv6 packet length array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                        self.yang_name = "ipv6-packet-len"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ipv6-packet-len"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "ipv6-packet-len"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                                class PacketLen(Entity):
                                                                                                    """
                                                                                                    Match packet length array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                        self.yang_name = "packet-len"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "packet-len"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "packet-len"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                                class FlowTag(Entity):
                                                                                                    """
                                                                                                    Match flow\-tag array
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                        self.yang_name = "flow-tag"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "flow-tag"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "flow-tag"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['min', 'max'], name, value)


                                                                                                class TcpFlag(Entity):
                                                                                                    """
                                                                                                    Match tcp flag value
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	Value of TCP flag
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: match_any
                                                                                                    
                                                                                                    	Match any TCP flag bit
                                                                                                    	**type**\: bool
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                        self.yang_name = "tcp-flag"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                                            ('match_any', (YLeaf(YType.boolean, 'match-any'), ['bool'])),
                                                                                                        ])
                                                                                                        self.value = None
                                                                                                        self.match_any = None
                                                                                                        self._segment_path = lambda: "tcp-flag"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['value', 'match_any'], name, value)


                                                                                                class Icmpv4Type(Entity):
                                                                                                    """
                                                                                                    Match ipv4 icmp type
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                        self.yang_name = "icmpv4-type"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "icmpv4-type"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "icmpv4-type"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                                class Icmpv4Code(Entity):
                                                                                                    """
                                                                                                    Match ipv4 icmp code
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                        self.yang_name = "icmpv4-code"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "icmpv4-code"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "icmpv4-code"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                                class Icmpv6Type(Entity):
                                                                                                    """
                                                                                                    Match ipv6 icmp type
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                        self.yang_name = "icmpv6-type"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "icmpv6-type"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "icmpv6-type"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                                class Icmpv6Code(Entity):
                                                                                                    """
                                                                                                    Match ipv6 icmp code
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                        self.yang_name = "icmpv6-code"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "icmpv6-code"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "icmpv6-code"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                                class MplsExp(Entity):
                                                                                                    """
                                                                                                    Match MPLS experimental topmost array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                        self.yang_name = "mpls-exp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "mpls-exp"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                                class MplsExpImp(Entity):
                                                                                                    """
                                                                                                    Match MPLS experimental imposition array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                        self.yang_name = "mpls-exp-imp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "mpls-exp-imp"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                                class MplsDispIpv4Acl(Entity):
                                                                                                    """
                                                                                                    MPLS Disposition IPv4 Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                        self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "mpls-disp-ipv4-acl"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                                class MplsDispIpv6Acl(Entity):
                                                                                                    """
                                                                                                    MPLS Disposition IPv6 Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                        self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "mpls-disp-ipv6-acl"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                                class MplsTopLabel(Entity):
                                                                                                    """
                                                                                                    MPLS Topmost LABEL
                                                                                                    
                                                                                                    .. attribute:: uint32_rng_array
                                                                                                    
                                                                                                    	uint32 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                        self.yang_name = "mpls-top-label"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint32_rng_array", ("uint32_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint32_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "mpls-top-label"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                                    class Uint32RngArray(Entity):
                                                                                                        """
                                                                                                        uint32 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                            self.yang_name = "uint32_rng_array"
                                                                                                            self.yang_parent_name = "mpls-top-label"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint32, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint32, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint32_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['min', 'max'], name, value)


                                                                                                class Cos(Entity):
                                                                                                    """
                                                                                                    Match CoS array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                        self.yang_name = "cos"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "cos"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                                class CosInr(Entity):
                                                                                                    """
                                                                                                    Match inner header CoS
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                        self.yang_name = "cos-inr"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "cos-inr"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                                class Dei(Entity):
                                                                                                    """
                                                                                                    Match DEI Bit
                                                                                                    
                                                                                                    .. attribute:: bit_value
                                                                                                    
                                                                                                    	Value of the DEI bit
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                        self.yang_name = "dei"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                        ])
                                                                                                        self.bit_value = None
                                                                                                        self._segment_path = lambda: "dei"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                                class DeiInr(Entity):
                                                                                                    """
                                                                                                    Match inner DEI Bit
                                                                                                    
                                                                                                    .. attribute:: bit_value
                                                                                                    
                                                                                                    	Value of the DEI bit
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                        self.yang_name = "dei-inr"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                        ])
                                                                                                        self.bit_value = None
                                                                                                        self._segment_path = lambda: "dei-inr"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                                class Vlan(Entity):
                                                                                                    """
                                                                                                    Match VLAN array
                                                                                                    
                                                                                                    .. attribute:: vlan_id_array
                                                                                                    
                                                                                                    	vlan id array
                                                                                                    	**type**\: list of  		 :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                        self.yang_name = "vlan"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("vlan-id-array", ("vlan_id_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.vlan_id_array = YList(self)
                                                                                                        self._segment_path = lambda: "vlan"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                                    class VlanIdArray(Entity):
                                                                                                        """
                                                                                                        vlan id array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	VLAN mask
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                            self.yang_name = "vlan-id-array"
                                                                                                            self.yang_parent_name = "vlan"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                                ('mask', (YLeaf(YType.uint16, 'mask'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self.mask = None
                                                                                                            self._segment_path = lambda: "vlan-id-array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['min', 'max', 'mask'], name, value)


                                                                                                class VlanInr(Entity):
                                                                                                    """
                                                                                                    Match inner header VLAN range array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                        self.yang_name = "vlan-inr"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "vlan-inr"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "vlan-inr"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['min', 'max'], name, value)


                                                                                                class FrDlci(Entity):
                                                                                                    """
                                                                                                    Match FR DLCI range array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                        self.yang_name = "fr-dlci"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "fr-dlci"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "fr-dlci"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['min', 'max'], name, value)


                                                                                                class SrcMac(Entity):
                                                                                                    """
                                                                                                    Match Source MAC address
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                        self.yang_name = "src-mac"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                            ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.mac_addr = []
                                                                                                        self.mask = []
                                                                                                        self._segment_path = lambda: "src-mac"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                                class DstMac(Entity):
                                                                                                    """
                                                                                                    Match Destination MAC address
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                        self.yang_name = "dst-mac"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                            ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.mac_addr = []
                                                                                                        self.mask = []
                                                                                                        self._segment_path = lambda: "dst-mac"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                                class AtmClp(Entity):
                                                                                                    """
                                                                                                    Match ATM CLP level
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                        self.yang_name = "atm-clp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "atm-clp"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                                class FrDe(Entity):
                                                                                                    """
                                                                                                    Match FR DE value
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                        self.yang_name = "fr-de"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "fr-de"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                                class Ipv4Acl(Entity):
                                                                                                    """
                                                                                                    IPv4 Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                        self.yang_name = "ipv4-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "ipv4-acl"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                                class Ipv6Acl(Entity):
                                                                                                    """
                                                                                                    IPv6 Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                        self.yang_name = "ipv6-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "ipv6-acl"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                                class EtherServiceAcl(Entity):
                                                                                                    """
                                                                                                    Ethernet\-Services Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                        self.yang_name = "ether-service-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "ether-service-acl"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                                class AvailId(Entity):
                                                                                                    """
                                                                                                    Available Identifiers
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                        self.yang_name = "avail-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "avail-id"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                                class MediaType(Entity):
                                                                                                    """
                                                                                                    Media Type
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                        self.yang_name = "media-type"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "media-type"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                                class SubsProtocol(Entity):
                                                                                                    """
                                                                                                    Protocol
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                        self.yang_name = "subs-protocol"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "subs-protocol"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                                class Dnis(Entity):
                                                                                                    """
                                                                                                    DNIS
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                        self.yang_name = "dnis"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "dnis"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                                class DnisRegex(Entity):
                                                                                                    """
                                                                                                    DNIS Regular Expression
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                        self.yang_name = "dnis-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "dnis-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                                class Domain(Entity):
                                                                                                    """
                                                                                                    Domain Name
                                                                                                    
                                                                                                    .. attribute:: domain_array
                                                                                                    
                                                                                                    	domain array
                                                                                                    	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                        self.yang_name = "domain"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.domain_array = YList(self)
                                                                                                        self._segment_path = lambda: "domain"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                                    class DomainArray(Entity):
                                                                                                        """
                                                                                                        domain array
                                                                                                        
                                                                                                        .. attribute:: domain_name
                                                                                                        
                                                                                                        	domain name
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        .. attribute:: format_name
                                                                                                        
                                                                                                        	format name
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                            self.yang_name = "domain-array"
                                                                                                            self.yang_parent_name = "domain"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                                ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                            ])
                                                                                                            self.domain_name = None
                                                                                                            self.format_name = None
                                                                                                            self._segment_path = lambda: "domain-array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                                class DomainRegex(Entity):
                                                                                                    """
                                                                                                    Domain Regular Expression
                                                                                                    
                                                                                                    .. attribute:: domain_array
                                                                                                    
                                                                                                    	domain array
                                                                                                    	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                        self.yang_name = "domain-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.domain_array = YList(self)
                                                                                                        self._segment_path = lambda: "domain-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                                    class DomainArray(Entity):
                                                                                                        """
                                                                                                        domain array
                                                                                                        
                                                                                                        .. attribute:: domain_name
                                                                                                        
                                                                                                        	domain name
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        .. attribute:: format_name
                                                                                                        
                                                                                                        	format name
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                            self.yang_name = "domain-array"
                                                                                                            self.yang_parent_name = "domain-regex"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                                ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                            ])
                                                                                                            self.domain_name = None
                                                                                                            self.format_name = None
                                                                                                            self._segment_path = lambda: "domain-array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                                class NasPort(Entity):
                                                                                                    """
                                                                                                    NAS Port
                                                                                                    
                                                                                                    .. attribute:: nas_port_array
                                                                                                    
                                                                                                    	nas port array
                                                                                                    	**type**\: list of  		 :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                        self.yang_name = "nas-port"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("nas-port-array", ("nas_port_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.nas_port_array = YList(self)
                                                                                                        self._segment_path = lambda: "nas-port"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                                    class NasPortArray(Entity):
                                                                                                        """
                                                                                                        nas port array
                                                                                                        
                                                                                                        .. attribute:: sub_id
                                                                                                        
                                                                                                        	sub id
                                                                                                        	**type**\:  :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                        
                                                                                                        .. attribute:: operator
                                                                                                        
                                                                                                        	operator
                                                                                                        	**type**\:  :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                        
                                                                                                        .. attribute:: value
                                                                                                        
                                                                                                        	value
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                            self.yang_name = "nas-port-array"
                                                                                                            self.yang_parent_name = "nas-port"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('sub_id', (YLeaf(YType.enumeration, 'sub-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchNasPortSubIdEn', '')])),
                                                                                                                ('operator', (YLeaf(YType.enumeration, 'operator'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchLogicalOperatorEn', '')])),
                                                                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                                            ])
                                                                                                            self.sub_id = None
                                                                                                            self.operator = None
                                                                                                            self.value = None
                                                                                                            self._segment_path = lambda: "nas-port-array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['sub_id', 'operator', 'value'], name, value)


                                                                                                class ServiceName(Entity):
                                                                                                    """
                                                                                                    Service Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                        self.yang_name = "service-name"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "service-name"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                                class ServiceNameRegex(Entity):
                                                                                                    """
                                                                                                    Service Name Regular Exp
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                        self.yang_name = "service-name-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "service-name-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                                class SrcAddrIpv4(Entity):
                                                                                                    """
                                                                                                    Source Address IPV4
                                                                                                    
                                                                                                    .. attribute:: ipv4_addr_array
                                                                                                    
                                                                                                    	ipv4 addr array
                                                                                                    	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                        self.yang_name = "src-addr-ipv4"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.ipv4_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "src-addr-ipv4"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                                    class Ipv4AddrArray(Entity):
                                                                                                        """
                                                                                                        ipv4 addr array
                                                                                                        
                                                                                                        .. attribute:: prefix
                                                                                                        
                                                                                                        	prefix
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	mask
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                            self.yang_name = "ipv4-addr-array"
                                                                                                            self.yang_parent_name = "src-addr-ipv4"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                                ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                            ])
                                                                                                            self.prefix = None
                                                                                                            self.mask = None
                                                                                                            self._segment_path = lambda: "ipv4-addr-array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                                class DstAddrIpv4(Entity):
                                                                                                    """
                                                                                                    Destination Address IPV4
                                                                                                    
                                                                                                    .. attribute:: ipv4_addr_array
                                                                                                    
                                                                                                    	ipv4 addr array
                                                                                                    	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                        self.yang_name = "dst-addr-ipv4"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.ipv4_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "dst-addr-ipv4"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                                    class Ipv4AddrArray(Entity):
                                                                                                        """
                                                                                                        ipv4 addr array
                                                                                                        
                                                                                                        .. attribute:: prefix
                                                                                                        
                                                                                                        	prefix
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	mask
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                            self.yang_name = "ipv4-addr-array"
                                                                                                            self.yang_parent_name = "dst-addr-ipv4"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                                ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                            ])
                                                                                                            self.prefix = None
                                                                                                            self.mask = None
                                                                                                            self._segment_path = lambda: "ipv4-addr-array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                                class SrcAddrIpv6(Entity):
                                                                                                    """
                                                                                                    Source Address IPV6
                                                                                                    
                                                                                                    .. attribute:: ipv6_addr_array
                                                                                                    
                                                                                                    	ipv6 addr array
                                                                                                    	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                        self.yang_name = "src-addr-ipv6"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.ipv6_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "src-addr-ipv6"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                                    class Ipv6AddrArray(Entity):
                                                                                                        """
                                                                                                        ipv6 addr array
                                                                                                        
                                                                                                        .. attribute:: prefix
                                                                                                        
                                                                                                        	IPV6 prefix
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	IPV6 mask
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                            self.yang_name = "ipv6-addr-array"
                                                                                                            self.yang_parent_name = "src-addr-ipv6"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                                ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                            ])
                                                                                                            self.prefix = None
                                                                                                            self.mask = None
                                                                                                            self._segment_path = lambda: "ipv6-addr-array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                                class DstAddrIpv6(Entity):
                                                                                                    """
                                                                                                    Destination Address IPV6
                                                                                                    
                                                                                                    .. attribute:: ipv6_addr_array
                                                                                                    
                                                                                                    	ipv6 addr array
                                                                                                    	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                        self.yang_name = "dst-addr-ipv6"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.ipv6_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "dst-addr-ipv6"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                                    class Ipv6AddrArray(Entity):
                                                                                                        """
                                                                                                        ipv6 addr array
                                                                                                        
                                                                                                        .. attribute:: prefix
                                                                                                        
                                                                                                        	IPV6 prefix
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	IPV6 mask
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                            self.yang_name = "ipv6-addr-array"
                                                                                                            self.yang_parent_name = "dst-addr-ipv6"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                                ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                            ])
                                                                                                            self.prefix = None
                                                                                                            self.mask = None
                                                                                                            self._segment_path = lambda: "ipv6-addr-array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                                class SrcAddrMac(Entity):
                                                                                                    """
                                                                                                    Source Address MAC
                                                                                                    
                                                                                                    .. attribute:: mac_addr_array
                                                                                                    
                                                                                                    	mac addr array
                                                                                                    	**type**\: list of  		 :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                        self.yang_name = "src-addr-mac"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("mac-addr-array", ("mac_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.mac_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "src-addr-mac"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                                    class MacAddrArray(Entity):
                                                                                                        """
                                                                                                        mac addr array
                                                                                                        
                                                                                                        .. attribute:: mac_addr
                                                                                                        
                                                                                                        	MAC address
                                                                                                        	**type**\: list of int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	MAC mask
                                                                                                        	**type**\: list of int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                            self.yang_name = "mac-addr-array"
                                                                                                            self.yang_parent_name = "src-addr-mac"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                                ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                            ])
                                                                                                            self.mac_addr = []
                                                                                                            self.mask = []
                                                                                                            self._segment_path = lambda: "mac-addr-array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                                class Timer(Entity):
                                                                                                    """
                                                                                                    Timer
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                        self.yang_name = "timer"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "timer"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                                class TimerRegexp(Entity):
                                                                                                    """
                                                                                                    Timer Regular Expression
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                        self.yang_name = "timer-regexp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "timer-regexp"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                                class TunnelName(Entity):
                                                                                                    """
                                                                                                    Tunnel Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                        self.yang_name = "tunnel-name"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "tunnel-name"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                                class TunnelNameRegex(Entity):
                                                                                                    """
                                                                                                    Tunnel Name Regular Expression
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                        self.yang_name = "tunnel-name-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "tunnel-name-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                                class UserName(Entity):
                                                                                                    """
                                                                                                    User Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                        self.yang_name = "user-name"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "user-name"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                                class UserNameRegex(Entity):
                                                                                                    """
                                                                                                    User Name Regular Expression
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                        self.yang_name = "user-name-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "user-name-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                                class AuthUsername(Entity):
                                                                                                    """
                                                                                                    Authenticated User Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                        self.yang_name = "auth-username"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "auth-username"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                                class AuthUsernameRegex(Entity):
                                                                                                    """
                                                                                                    Authenticated User Name RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                        self.yang_name = "auth-username-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "auth-username-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                                class UnauthUsername(Entity):
                                                                                                    """
                                                                                                    Unauthenticated User Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                        self.yang_name = "unauth-username"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "unauth-username"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                                class UnauthUsernameRegex(Entity):
                                                                                                    """
                                                                                                    Unauthenticated User Name RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                        self.yang_name = "unauth-username-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "unauth-username-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                                class AuthDomain(Entity):
                                                                                                    """
                                                                                                    Authenticated domain name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                        self.yang_name = "auth-domain"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "auth-domain"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                                class AuthDomainRegex(Entity):
                                                                                                    """
                                                                                                    Authenticated Domain Name RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                        self.yang_name = "auth-domain-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "auth-domain-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                                class UnauthDomain(Entity):
                                                                                                    """
                                                                                                    Unauthenticated Domain Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                        self.yang_name = "unauth-domain"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "unauth-domain"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                                class UnauthDomainRegex(Entity):
                                                                                                    """
                                                                                                    Unauthenticated Domain Name RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                        self.yang_name = "unauth-domain-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "unauth-domain-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                                class VendorId(Entity):
                                                                                                    """
                                                                                                    Vendor ID
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                        self.yang_name = "vendor-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "vendor-id"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                                class VendorIdRegex(Entity):
                                                                                                    """
                                                                                                    Vendor ID RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                        self.yang_name = "vendor-id-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "vendor-id-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                                class AccessInterface(Entity):
                                                                                                    """
                                                                                                    Access interface
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                        self.yang_name = "access-interface"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "access-interface"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                                class InputInterface(Entity):
                                                                                                    """
                                                                                                    Input interface
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                        self.yang_name = "input-interface"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "input-interface"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                                class InputIntfhdl(Entity):
                                                                                                    """
                                                                                                    Input interface handle
                                                                                                    
                                                                                                    .. attribute:: uint64_array
                                                                                                    
                                                                                                    	uint64 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..18446744073709551615
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                        self.yang_name = "input-intfhdl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint64_array', (YLeafList(YType.uint64, 'uint64_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint64_array = []
                                                                                                        self._segment_path = lambda: "input-intfhdl"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                                class Ethertype(Entity):
                                                                                                    """
                                                                                                    Ethernet type
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                        self.yang_name = "ethertype"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ethertype"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "ethertype"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['min', 'max'], name, value)


                                                                                                class FlowKeyData(Entity):
                                                                                                    """
                                                                                                    Flow key structure
                                                                                                    
                                                                                                    .. attribute:: flow_keys
                                                                                                    
                                                                                                    	flow keys
                                                                                                    	**type**\:  :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                                    
                                                                                                    .. attribute:: max_count
                                                                                                    
                                                                                                    	Maximum count of flows
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: idle_timeout
                                                                                                    
                                                                                                    	Idle timeout of flows (in seconds)
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    	**units**\: second
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                        self.yang_name = "flow-key-data"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("flow-keys", ("flow_keys", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys))])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('max_count', (YLeaf(YType.uint16, 'max-count'), ['int'])),
                                                                                                            ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                                                        ])
                                                                                                        self.max_count = None
                                                                                                        self.idle_timeout = None

                                                                                                        self.flow_keys = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                        self.flow_keys.parent = self
                                                                                                        self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                        self._segment_path = lambda: "flow-key-data"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['max_count', 'idle_timeout'], name, value)


                                                                                                    class FlowKeys(Entity):
                                                                                                        """
                                                                                                        flow keys
                                                                                                        
                                                                                                        .. attribute:: keys
                                                                                                        
                                                                                                        	keys
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                        
                                                                                                        .. attribute:: num
                                                                                                        
                                                                                                        	num
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                            self.yang_name = "flow-keys"
                                                                                                            self.yang_parent_name = "flow-key-data"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('keys', (YLeaf(YType.str, 'keys'), ['str'])),
                                                                                                                ('num', (YLeaf(YType.uint8, 'num'), ['int'])),
                                                                                                            ])
                                                                                                            self.keys = None
                                                                                                            self.num = None
                                                                                                            self._segment_path = lambda: "flow-keys"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                                class DhcpClientId(Entity):
                                                                                                    """
                                                                                                    Dhcp Client ID
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                        self.yang_name = "dhcp-client-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "dhcp-client-id"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                                class DhcpClientIdRegex(Entity):
                                                                                                    """
                                                                                                    Dhcp Client ID RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                        self.yang_name = "dhcp-client-id-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "dhcp-client-id-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                                class CircuitId(Entity):
                                                                                                    """
                                                                                                    Circuit ID
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                        self.yang_name = "circuit-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "circuit-id"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                                class CircuitIdRegex(Entity):
                                                                                                    """
                                                                                                    Circuit ID RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                        self.yang_name = "circuit-id-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "circuit-id-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                                class RemoteId(Entity):
                                                                                                    """
                                                                                                    Remote ID
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                        self.yang_name = "remote-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "remote-id"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                                class RemoteIdRegex(Entity):
                                                                                                    """
                                                                                                    Remote ID RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                        self.yang_name = "remote-id-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "remote-id-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                                class SrcPort(Entity):
                                                                                                    """
                                                                                                    Source port
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                        self.yang_name = "src-port"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "src-port"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "src-port"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                                                class DstPort(Entity):
                                                                                                    """
                                                                                                    Destination port
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                        self.yang_name = "dst-port"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "dst-port"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "dst-port"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                        class Shape(Entity):
                                                                            """
                                                                            shape
                                                                            
                                                                            .. attribute:: bw
                                                                            
                                                                            	bw
                                                                            	**type**\:  :py:class:`Bw <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw>`
                                                                            
                                                                            .. attribute:: be
                                                                            
                                                                            	be
                                                                            	**type**\:  :py:class:`Be <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape, self).__init__()

                                                                                self.yang_name = "shape"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("bw", ("bw", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw)), ("be", ("be", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be))])
                                                                                self._leafs = OrderedDict()

                                                                                self.bw = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw()
                                                                                self.bw.parent = self
                                                                                self._children_name_map["bw"] = "bw"

                                                                                self.be = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be()
                                                                                self.be.parent = self
                                                                                self._children_name_map["be"] = "be"
                                                                                self._segment_path = lambda: "shape"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape, [], name, value)


                                                                            class Bw(Entity):
                                                                                """
                                                                                bw
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw, self).__init__()

                                                                                    self.yang_name = "bw"
                                                                                    self.yang_parent_name = "shape"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.unit = None
                                                                                    self._segment_path = lambda: "bw"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw, ['value', 'unit'], name, value)


                                                                            class Be(Entity):
                                                                                """
                                                                                be
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be, self).__init__()

                                                                                    self.yang_name = "be"
                                                                                    self.yang_parent_name = "shape"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.unit = None
                                                                                    self._segment_path = lambda: "be"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be, ['value', 'unit'], name, value)


                                                                        class ChildPolicy(Entity):
                                                                            """
                                                                            child policy
                                                                            
                                                                            .. attribute:: info
                                                                            
                                                                            	info
                                                                            	**type**\:  :py:class:`Info <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info>`
                                                                            
                                                                            .. attribute:: hd_info
                                                                            
                                                                            	hd info
                                                                            	**type**\:  :py:class:`HdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo>`
                                                                            
                                                                            .. attribute:: enc
                                                                            
                                                                            	enc
                                                                            	**type**\:  :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy, self).__init__()

                                                                                self.yang_name = "child-policy"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("info", ("info", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info)), ("hd-info", ("hd_info", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('enc', (YLeaf(YType.enumeration, 'enc'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyObjEncEn', '')])),
                                                                                ])
                                                                                self.enc = None

                                                                                self.info = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info()
                                                                                self.info.parent = self
                                                                                self._children_name_map["info"] = "info"

                                                                                self.hd_info = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo()
                                                                                self.hd_info.parent = self
                                                                                self._children_name_map["hd_info"] = "hd-info"
                                                                                self._segment_path = lambda: "child-policy"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy, ['enc'], name, value)


                                                                            class Info(Entity):
                                                                                """
                                                                                info
                                                                                
                                                                                .. attribute:: name
                                                                                
                                                                                	name
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..65
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:  :py:class:`PolicyMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyMapTypeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info, self).__init__()

                                                                                    self.yang_name = "info"
                                                                                    self.yang_parent_name = "child-policy"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyMapTypeEn', '')])),
                                                                                    ])
                                                                                    self.name = None
                                                                                    self.type = None
                                                                                    self._segment_path = lambda: "info"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info, ['name', 'type'], name, value)


                                                                            class HdInfo(Entity):
                                                                                """
                                                                                hd info
                                                                                
                                                                                .. attribute:: data_hd
                                                                                
                                                                                	data hd
                                                                                	**type**\:  :py:class:`DataHd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd>`
                                                                                
                                                                                .. attribute:: hd
                                                                                
                                                                                	hd
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..18446744073709551615
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo, self).__init__()

                                                                                    self.yang_name = "hd-info"
                                                                                    self.yang_parent_name = "child-policy"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("data-hd", ("data_hd", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('hd', (YLeaf(YType.uint64, 'hd'), ['int'])),
                                                                                    ])
                                                                                    self.hd = None

                                                                                    self.data_hd = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd()
                                                                                    self.data_hd.parent = self
                                                                                    self._children_name_map["data_hd"] = "data-hd"
                                                                                    self._segment_path = lambda: "hd-info"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo, ['hd'], name, value)


                                                                                class DataHd(Entity):
                                                                                    """
                                                                                    data hd
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd, self).__init__()

                                                                                        self.yang_name = "data-hd"
                                                                                        self.yang_parent_name = "hd-info"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict()
                                                                                        self._segment_path = lambda: "data-hd"
                                                                                        self._is_frozen = True


                                                                        class Cac(Entity):
                                                                            """
                                                                            cac
                                                                            
                                                                            .. attribute:: flow_rate
                                                                            
                                                                            	flow rate
                                                                            	**type**\:  :py:class:`FlowRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate>`
                                                                            
                                                                            .. attribute:: rate
                                                                            
                                                                            	rate
                                                                            	**type**\:  :py:class:`Rate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate>`
                                                                            
                                                                            .. attribute:: cac_type
                                                                            
                                                                            	cac type
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: idle_timeout
                                                                            
                                                                            	idle timeout
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac, self).__init__()

                                                                                self.yang_name = "cac"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("flow-rate", ("flow_rate", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate)), ("rate", ("rate", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('cac_type', (YLeaf(YType.uint8, 'cac-type'), ['int'])),
                                                                                    ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                                ])
                                                                                self.cac_type = None
                                                                                self.idle_timeout = None

                                                                                self.flow_rate = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate()
                                                                                self.flow_rate.parent = self
                                                                                self._children_name_map["flow_rate"] = "flow-rate"

                                                                                self.rate = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate()
                                                                                self.rate.parent = self
                                                                                self._children_name_map["rate"] = "rate"
                                                                                self._segment_path = lambda: "cac"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac, ['cac_type', 'idle_timeout'], name, value)


                                                                            class FlowRate(Entity):
                                                                                """
                                                                                flow rate
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate, self).__init__()

                                                                                    self.yang_name = "flow-rate"
                                                                                    self.yang_parent_name = "cac"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.unit = None
                                                                                    self._segment_path = lambda: "flow-rate"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate, ['value', 'unit'], name, value)


                                                                            class Rate(Entity):
                                                                                """
                                                                                rate
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate, self).__init__()

                                                                                    self.yang_name = "rate"
                                                                                    self.yang_parent_name = "cac"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.unit = None
                                                                                    self._segment_path = lambda: "rate"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate, ['value', 'unit'], name, value)


                                                                        class Pfc(Entity):
                                                                            """
                                                                            pfc
                                                                            
                                                                            .. attribute:: buffer_size
                                                                            
                                                                            	buffer size
                                                                            	**type**\:  :py:class:`BufferSize <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize>`
                                                                            
                                                                            .. attribute:: pause_threshold
                                                                            
                                                                            	pause threshold
                                                                            	**type**\:  :py:class:`PauseThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold>`
                                                                            
                                                                            .. attribute:: resume_threshold
                                                                            
                                                                            	resume threshold
                                                                            	**type**\:  :py:class:`ResumeThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold>`
                                                                            
                                                                            .. attribute:: pfc_pause_set
                                                                            
                                                                            	pfc pause set
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: buffer_size_flag
                                                                            
                                                                            	buffer size flag
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc, self).__init__()

                                                                                self.yang_name = "pfc"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("buffer-size", ("buffer_size", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize)), ("pause-threshold", ("pause_threshold", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold)), ("resume-threshold", ("resume_threshold", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('pfc_pause_set', (YLeaf(YType.uint32, 'pfc-pause-set'), ['int'])),
                                                                                    ('buffer_size_flag', (YLeaf(YType.uint32, 'buffer-size-flag'), ['int'])),
                                                                                ])
                                                                                self.pfc_pause_set = None
                                                                                self.buffer_size_flag = None

                                                                                self.buffer_size = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize()
                                                                                self.buffer_size.parent = self
                                                                                self._children_name_map["buffer_size"] = "buffer-size"

                                                                                self.pause_threshold = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold()
                                                                                self.pause_threshold.parent = self
                                                                                self._children_name_map["pause_threshold"] = "pause-threshold"

                                                                                self.resume_threshold = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold()
                                                                                self.resume_threshold.parent = self
                                                                                self._children_name_map["resume_threshold"] = "resume-threshold"
                                                                                self._segment_path = lambda: "pfc"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc, ['pfc_pause_set', 'buffer_size_flag'], name, value)


                                                                            class BufferSize(Entity):
                                                                                """
                                                                                buffer size
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize, self).__init__()

                                                                                    self.yang_name = "buffer-size"
                                                                                    self.yang_parent_name = "pfc"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.unit = None
                                                                                    self._segment_path = lambda: "buffer-size"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize, ['value', 'unit'], name, value)


                                                                            class PauseThreshold(Entity):
                                                                                """
                                                                                pause threshold
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold, self).__init__()

                                                                                    self.yang_name = "pause-threshold"
                                                                                    self.yang_parent_name = "pfc"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.unit = None
                                                                                    self._segment_path = lambda: "pause-threshold"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold, ['value', 'unit'], name, value)


                                                                            class ResumeThreshold(Entity):
                                                                                """
                                                                                resume threshold
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold, self).__init__()

                                                                                    self.yang_name = "resume-threshold"
                                                                                    self.yang_parent_name = "pfc"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.unit = None
                                                                                    self._segment_path = lambda: "resume-threshold"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold, ['value', 'unit'], name, value)


                                                                        class FlowParm(Entity):
                                                                            """
                                                                            flow parm
                                                                            
                                                                            .. attribute:: max_mon_flows
                                                                            
                                                                            	max simult flows monitored per policy class
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: mon_interval
                                                                            
                                                                            	monitored interval duration in secs
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**units**\: second
                                                                            
                                                                            .. attribute:: intvl_hist
                                                                            
                                                                            	num intervals of data stored on rtr
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: flow_timeout
                                                                            
                                                                            	timeout in secs
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**units**\: second
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm, self).__init__()

                                                                                self.yang_name = "flow-parm"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('max_mon_flows', (YLeaf(YType.uint32, 'max-mon-flows'), ['int'])),
                                                                                    ('mon_interval', (YLeaf(YType.uint32, 'mon-interval'), ['int'])),
                                                                                    ('intvl_hist', (YLeaf(YType.uint32, 'intvl-hist'), ['int'])),
                                                                                    ('flow_timeout', (YLeaf(YType.uint32, 'flow-timeout'), ['int'])),
                                                                                ])
                                                                                self.max_mon_flows = None
                                                                                self.mon_interval = None
                                                                                self.intvl_hist = None
                                                                                self.flow_timeout = None
                                                                                self._segment_path = lambda: "flow-parm"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm, ['max_mon_flows', 'mon_interval', 'intvl_hist', 'flow_timeout'], name, value)


                                                                        class Ipcbr(Entity):
                                                                            """
                                                                            ipcbr
                                                                            
                                                                            .. attribute:: ip_bit_rate
                                                                            
                                                                            	data rate in bps
                                                                            	**type**\:  :py:class:`IpBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate>`
                                                                            
                                                                            .. attribute:: media_bit_rate
                                                                            
                                                                            	media data rate in bps
                                                                            	**type**\:  :py:class:`MediaBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate>`
                                                                            
                                                                            .. attribute:: action_metric_type
                                                                            
                                                                            	metric type
                                                                            	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                            
                                                                            .. attribute:: ip_pkt_rate
                                                                            
                                                                            	packet rate in pps
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: media_pkt_size
                                                                            
                                                                            	media packet size in bytes
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: media_pkts_per_ip
                                                                            
                                                                            	media packets per ip pkt
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr, self).__init__()

                                                                                self.yang_name = "ipcbr"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("ip-bit-rate", ("ip_bit_rate", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate)), ("media-bit-rate", ("media_bit_rate", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                                    ('ip_pkt_rate', (YLeaf(YType.uint32, 'ip-pkt-rate'), ['int'])),
                                                                                    ('media_pkt_size', (YLeaf(YType.uint32, 'media-pkt-size'), ['int'])),
                                                                                    ('media_pkts_per_ip', (YLeaf(YType.uint32, 'media-pkts-per-ip'), ['int'])),
                                                                                ])
                                                                                self.action_metric_type = None
                                                                                self.ip_pkt_rate = None
                                                                                self.media_pkt_size = None
                                                                                self.media_pkts_per_ip = None

                                                                                self.ip_bit_rate = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate()
                                                                                self.ip_bit_rate.parent = self
                                                                                self._children_name_map["ip_bit_rate"] = "ip-bit-rate"

                                                                                self.media_bit_rate = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate()
                                                                                self.media_bit_rate.parent = self
                                                                                self._children_name_map["media_bit_rate"] = "media-bit-rate"
                                                                                self._segment_path = lambda: "ipcbr"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr, ['action_metric_type', 'ip_pkt_rate', 'media_pkt_size', 'media_pkts_per_ip'], name, value)


                                                                            class IpBitRate(Entity):
                                                                                """
                                                                                data rate in bps
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate, self).__init__()

                                                                                    self.yang_name = "ip-bit-rate"
                                                                                    self.yang_parent_name = "ipcbr"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.unit = None
                                                                                    self._segment_path = lambda: "ip-bit-rate"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate, ['value', 'unit'], name, value)


                                                                            class MediaBitRate(Entity):
                                                                                """
                                                                                media data rate in bps
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate, self).__init__()

                                                                                    self.yang_name = "media-bit-rate"
                                                                                    self.yang_parent_name = "ipcbr"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.unit = None
                                                                                    self._segment_path = lambda: "media-bit-rate"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate, ['value', 'unit'], name, value)


                                                                        class Rtp(Entity):
                                                                            """
                                                                            rtp
                                                                            
                                                                            .. attribute:: action_metric_type
                                                                            
                                                                            	metric type
                                                                            	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                            
                                                                            .. attribute:: min_sequential
                                                                            
                                                                            	min sequential
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: max_dropout
                                                                            
                                                                            	max dropout
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: max_misorder
                                                                            
                                                                            	max misorder
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: seq_ext_cop4
                                                                            
                                                                            	enable seq extension cop4
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: clock_rate
                                                                            
                                                                            	clock rate
                                                                            	**type**\: list of  		 :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp, self).__init__()

                                                                                self.yang_name = "rtp"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("clock-rate", ("clock_rate", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                                    ('min_sequential', (YLeaf(YType.uint32, 'min-sequential'), ['int'])),
                                                                                    ('max_dropout', (YLeaf(YType.uint32, 'max-dropout'), ['int'])),
                                                                                    ('max_misorder', (YLeaf(YType.uint32, 'max-misorder'), ['int'])),
                                                                                    ('seq_ext_cop4', (YLeaf(YType.uint32, 'seq-ext-cop4'), ['int'])),
                                                                                ])
                                                                                self.action_metric_type = None
                                                                                self.min_sequential = None
                                                                                self.max_dropout = None
                                                                                self.max_misorder = None
                                                                                self.seq_ext_cop4 = None

                                                                                self.clock_rate = YList(self)
                                                                                self._segment_path = lambda: "rtp"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp, ['action_metric_type', 'min_sequential', 'max_dropout', 'max_misorder', 'seq_ext_cop4'], name, value)


                                                                            class ClockRate(Entity):
                                                                                """
                                                                                clock rate
                                                                                
                                                                                .. attribute:: pt
                                                                                
                                                                                	pt
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: frequency
                                                                                
                                                                                	frequency
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate, self).__init__()

                                                                                    self.yang_name = "clock-rate"
                                                                                    self.yang_parent_name = "rtp"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('pt', (YLeaf(YType.uint32, 'pt'), ['int'])),
                                                                                        ('frequency', (YLeaf(YType.uint32, 'frequency'), ['int'])),
                                                                                    ])
                                                                                    self.pt = None
                                                                                    self.frequency = None
                                                                                    self._segment_path = lambda: "clock-rate"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate, ['pt', 'frequency'], name, value)


                                                                        class RtpMmr(Entity):
                                                                            """
                                                                            rtp mmr
                                                                            
                                                                            .. attribute:: action_metric_type
                                                                            
                                                                            	metric type
                                                                            	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                            
                                                                            .. attribute:: min_sequential
                                                                            
                                                                            	min sequential
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: max_dropout
                                                                            
                                                                            	max dropout
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: max_misorder
                                                                            
                                                                            	max misorder
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: seq_ext_cop4
                                                                            
                                                                            	enable seq extension cop4
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: clock_rate
                                                                            
                                                                            	clock rate
                                                                            	**type**\: list of  		 :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr, self).__init__()

                                                                                self.yang_name = "rtp-mmr"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("clock-rate", ("clock_rate", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                                    ('min_sequential', (YLeaf(YType.uint32, 'min-sequential'), ['int'])),
                                                                                    ('max_dropout', (YLeaf(YType.uint32, 'max-dropout'), ['int'])),
                                                                                    ('max_misorder', (YLeaf(YType.uint32, 'max-misorder'), ['int'])),
                                                                                    ('seq_ext_cop4', (YLeaf(YType.uint32, 'seq-ext-cop4'), ['int'])),
                                                                                ])
                                                                                self.action_metric_type = None
                                                                                self.min_sequential = None
                                                                                self.max_dropout = None
                                                                                self.max_misorder = None
                                                                                self.seq_ext_cop4 = None

                                                                                self.clock_rate = YList(self)
                                                                                self._segment_path = lambda: "rtp-mmr"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr, ['action_metric_type', 'min_sequential', 'max_dropout', 'max_misorder', 'seq_ext_cop4'], name, value)


                                                                            class ClockRate(Entity):
                                                                                """
                                                                                clock rate
                                                                                
                                                                                .. attribute:: pt
                                                                                
                                                                                	pt
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: frequency
                                                                                
                                                                                	frequency
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate, self).__init__()

                                                                                    self.yang_name = "clock-rate"
                                                                                    self.yang_parent_name = "rtp-mmr"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('pt', (YLeaf(YType.uint32, 'pt'), ['int'])),
                                                                                        ('frequency', (YLeaf(YType.uint32, 'frequency'), ['int'])),
                                                                                    ])
                                                                                    self.pt = None
                                                                                    self.frequency = None
                                                                                    self._segment_path = lambda: "clock-rate"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate, ['pt', 'frequency'], name, value)


                                                                        class RtpJ2k(Entity):
                                                                            """
                                                                            rtp j2k
                                                                            
                                                                            .. attribute:: action_metric_type
                                                                            
                                                                            	metric type
                                                                            	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                            
                                                                            .. attribute:: min_sequential
                                                                            
                                                                            	min sequential
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: max_dropout
                                                                            
                                                                            	max dropout
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: max_misorder
                                                                            
                                                                            	max misorder
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: seq_ext_cop4
                                                                            
                                                                            	enable seq extension cop4
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: clock_rate
                                                                            
                                                                            	clock rate
                                                                            	**type**\: list of  		 :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k.ClockRate>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k, self).__init__()

                                                                                self.yang_name = "rtp-j2k"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("clock-rate", ("clock_rate", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k.ClockRate))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                                    ('min_sequential', (YLeaf(YType.uint32, 'min-sequential'), ['int'])),
                                                                                    ('max_dropout', (YLeaf(YType.uint32, 'max-dropout'), ['int'])),
                                                                                    ('max_misorder', (YLeaf(YType.uint32, 'max-misorder'), ['int'])),
                                                                                    ('seq_ext_cop4', (YLeaf(YType.uint32, 'seq-ext-cop4'), ['int'])),
                                                                                ])
                                                                                self.action_metric_type = None
                                                                                self.min_sequential = None
                                                                                self.max_dropout = None
                                                                                self.max_misorder = None
                                                                                self.seq_ext_cop4 = None

                                                                                self.clock_rate = YList(self)
                                                                                self._segment_path = lambda: "rtp-j2k"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k, ['action_metric_type', 'min_sequential', 'max_dropout', 'max_misorder', 'seq_ext_cop4'], name, value)


                                                                            class ClockRate(Entity):
                                                                                """
                                                                                clock rate
                                                                                
                                                                                .. attribute:: pt
                                                                                
                                                                                	pt
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: frequency
                                                                                
                                                                                	frequency
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k.ClockRate, self).__init__()

                                                                                    self.yang_name = "clock-rate"
                                                                                    self.yang_parent_name = "rtp-j2k"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('pt', (YLeaf(YType.uint32, 'pt'), ['int'])),
                                                                                        ('frequency', (YLeaf(YType.uint32, 'frequency'), ['int'])),
                                                                                    ])
                                                                                    self.pt = None
                                                                                    self.frequency = None
                                                                                    self._segment_path = lambda: "clock-rate"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k.ClockRate, ['pt', 'frequency'], name, value)


                                                                        class RtpVoice(Entity):
                                                                            """
                                                                            rtp voice
                                                                            
                                                                            .. attribute:: action_metric_type
                                                                            
                                                                            	metric type
                                                                            	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                            
                                                                            .. attribute:: min_sequential
                                                                            
                                                                            	min sequential
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: max_dropout
                                                                            
                                                                            	max dropout
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: max_misorder
                                                                            
                                                                            	max misorder
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: seq_ext_cop4
                                                                            
                                                                            	enable seq extension cop4
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: clock_rate
                                                                            
                                                                            	clock rate
                                                                            	**type**\: list of  		 :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice, self).__init__()

                                                                                self.yang_name = "rtp-voice"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("clock-rate", ("clock_rate", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                                    ('min_sequential', (YLeaf(YType.uint32, 'min-sequential'), ['int'])),
                                                                                    ('max_dropout', (YLeaf(YType.uint32, 'max-dropout'), ['int'])),
                                                                                    ('max_misorder', (YLeaf(YType.uint32, 'max-misorder'), ['int'])),
                                                                                    ('seq_ext_cop4', (YLeaf(YType.uint32, 'seq-ext-cop4'), ['int'])),
                                                                                ])
                                                                                self.action_metric_type = None
                                                                                self.min_sequential = None
                                                                                self.max_dropout = None
                                                                                self.max_misorder = None
                                                                                self.seq_ext_cop4 = None

                                                                                self.clock_rate = YList(self)
                                                                                self._segment_path = lambda: "rtp-voice"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice, ['action_metric_type', 'min_sequential', 'max_dropout', 'max_misorder', 'seq_ext_cop4'], name, value)


                                                                            class ClockRate(Entity):
                                                                                """
                                                                                clock rate
                                                                                
                                                                                .. attribute:: pt
                                                                                
                                                                                	pt
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: frequency
                                                                                
                                                                                	frequency
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate, self).__init__()

                                                                                    self.yang_name = "clock-rate"
                                                                                    self.yang_parent_name = "rtp-voice"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('pt', (YLeaf(YType.uint32, 'pt'), ['int'])),
                                                                                        ('frequency', (YLeaf(YType.uint32, 'frequency'), ['int'])),
                                                                                    ])
                                                                                    self.pt = None
                                                                                    self.frequency = None
                                                                                    self._segment_path = lambda: "clock-rate"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate, ['pt', 'frequency'], name, value)


                                                                        class Mdi(Entity):
                                                                            """
                                                                            mdi
                                                                            
                                                                            .. attribute:: ip_bit_rate
                                                                            
                                                                            	data rate in bps
                                                                            	**type**\:  :py:class:`IpBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate>`
                                                                            
                                                                            .. attribute:: action_metric_type
                                                                            
                                                                            	metric type
                                                                            	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                            
                                                                            .. attribute:: filtered_pkt_rate
                                                                            
                                                                            	filtered packet rate
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: ip_pkt_rate
                                                                            
                                                                            	packet rate in pps
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: pids
                                                                            
                                                                            	array of monitoredcd  pids
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi, self).__init__()

                                                                                self.yang_name = "mdi"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("ip-bit-rate", ("ip_bit_rate", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                                    ('filtered_pkt_rate', (YLeaf(YType.uint32, 'filtered-pkt-rate'), ['int'])),
                                                                                    ('ip_pkt_rate', (YLeaf(YType.uint32, 'ip-pkt-rate'), ['int'])),
                                                                                    ('pids', (YLeafList(YType.uint32, 'pids'), ['int'])),
                                                                                ])
                                                                                self.action_metric_type = None
                                                                                self.filtered_pkt_rate = None
                                                                                self.ip_pkt_rate = None
                                                                                self.pids = []

                                                                                self.ip_bit_rate = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate()
                                                                                self.ip_bit_rate.parent = self
                                                                                self._children_name_map["ip_bit_rate"] = "ip-bit-rate"
                                                                                self._segment_path = lambda: "mdi"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi, ['action_metric_type', 'filtered_pkt_rate', 'ip_pkt_rate', 'pids'], name, value)


                                                                            class IpBitRate(Entity):
                                                                                """
                                                                                data rate in bps
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate, self).__init__()

                                                                                    self.yang_name = "ip-bit-rate"
                                                                                    self.yang_parent_name = "mdi"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.unit = None
                                                                                    self._segment_path = lambda: "ip-bit-rate"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate, ['value', 'unit'], name, value)


                                                                        class MdiRtp(Entity):
                                                                            """
                                                                            mdi rtp
                                                                            
                                                                            .. attribute:: ip_bit_rate
                                                                            
                                                                            	data rate in bps
                                                                            	**type**\:  :py:class:`IpBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate>`
                                                                            
                                                                            .. attribute:: action_metric_type
                                                                            
                                                                            	metric type
                                                                            	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                            
                                                                            .. attribute:: filtered_pkt_rate
                                                                            
                                                                            	filtered packet rate
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: ip_pkt_rate
                                                                            
                                                                            	packet rate in pps
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: pids
                                                                            
                                                                            	array of monitoredcd  pids
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp, self).__init__()

                                                                                self.yang_name = "mdi-rtp"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("ip-bit-rate", ("ip_bit_rate", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                                    ('filtered_pkt_rate', (YLeaf(YType.uint32, 'filtered-pkt-rate'), ['int'])),
                                                                                    ('ip_pkt_rate', (YLeaf(YType.uint32, 'ip-pkt-rate'), ['int'])),
                                                                                    ('pids', (YLeafList(YType.uint32, 'pids'), ['int'])),
                                                                                ])
                                                                                self.action_metric_type = None
                                                                                self.filtered_pkt_rate = None
                                                                                self.ip_pkt_rate = None
                                                                                self.pids = []

                                                                                self.ip_bit_rate = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate()
                                                                                self.ip_bit_rate.parent = self
                                                                                self._children_name_map["ip_bit_rate"] = "ip-bit-rate"
                                                                                self._segment_path = lambda: "mdi-rtp"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp, ['action_metric_type', 'filtered_pkt_rate', 'ip_pkt_rate', 'pids'], name, value)


                                                                            class IpBitRate(Entity):
                                                                                """
                                                                                data rate in bps
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate, self).__init__()

                                                                                    self.yang_name = "ip-bit-rate"
                                                                                    self.yang_parent_name = "mdi-rtp"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.unit = None
                                                                                    self._segment_path = lambda: "ip-bit-rate"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate, ['value', 'unit'], name, value)


                                                                        class Fmm(Entity):
                                                                            """
                                                                            fmm
                                                                            
                                                                            .. attribute:: fmm_name
                                                                            
                                                                            	flow monitor name
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..33
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm, self).__init__()

                                                                                self.yang_name = "fmm"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('fmm_name', (YLeaf(YType.str, 'fmm-name'), ['str'])),
                                                                                ])
                                                                                self.fmm_name = None
                                                                                self._segment_path = lambda: "fmm"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm, ['fmm_name'], name, value)


                                                                        class Pbf(Entity):
                                                                            """
                                                                            pbf
                                                                            
                                                                            .. attribute:: action_pbf_info_array
                                                                            
                                                                            	action pbf info array
                                                                            	**type**\: list of  		 :py:class:`ActionPbfInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf, self).__init__()

                                                                                self.yang_name = "pbf"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("action-pbf-info-array", ("action_pbf_info_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.action_pbf_info_array = YList(self)
                                                                                self._segment_path = lambda: "pbf"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf, [], name, value)


                                                                            class ActionPbfInfoArray(Entity):
                                                                                """
                                                                                action pbf info array
                                                                                
                                                                                .. attribute:: addr
                                                                                
                                                                                	v4 or v6 address
                                                                                	**type**\: str
                                                                                
                                                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                
                                                                                .. attribute:: vrf
                                                                                
                                                                                	vrf name
                                                                                	**type**\: str
                                                                                
                                                                                .. attribute:: rt_type
                                                                                
                                                                                	route target type
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: rt
                                                                                
                                                                                	route target
                                                                                	**type**\: str
                                                                                
                                                                                	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray, self).__init__()

                                                                                    self.yang_name = "action-pbf-info-array"
                                                                                    self.yang_parent_name = "pbf"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('addr', (YLeaf(YType.str, 'addr'), ['str'])),
                                                                                        ('vrf', (YLeaf(YType.str, 'vrf'), ['str'])),
                                                                                        ('rt_type', (YLeaf(YType.uint8, 'rt-type'), ['int'])),
                                                                                        ('rt', (YLeaf(YType.str, 'rt'), ['str'])),
                                                                                    ])
                                                                                    self.addr = None
                                                                                    self.vrf = None
                                                                                    self.rt_type = None
                                                                                    self.rt = None
                                                                                    self._segment_path = lambda: "action-pbf-info-array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray, ['addr', 'vrf', 'rt_type', 'rt'], name, value)


                                                                        class Ipv4Nh(Entity):
                                                                            """
                                                                            ipv4 nh
                                                                            
                                                                            .. attribute:: action_ipv4_nh_info_array
                                                                            
                                                                            	action ipv4 nh info array
                                                                            	**type**\: list of  		 :py:class:`ActionIpv4NhInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh, self).__init__()

                                                                                self.yang_name = "ipv4-nh"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("action-ipv4-nh-info-array", ("action_ipv4_nh_info_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.action_ipv4_nh_info_array = YList(self)
                                                                                self._segment_path = lambda: "ipv4-nh"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh, [], name, value)


                                                                            class ActionIpv4NhInfoArray(Entity):
                                                                                """
                                                                                action ipv4 nh info array
                                                                                
                                                                                .. attribute:: nh_addr
                                                                                
                                                                                	nh addr
                                                                                	**type**\: str
                                                                                
                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                
                                                                                .. attribute:: vrf_name
                                                                                
                                                                                	Vrf name
                                                                                	**type**\: str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray, self).__init__()

                                                                                    self.yang_name = "action-ipv4-nh-info-array"
                                                                                    self.yang_parent_name = "ipv4-nh"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('nh_addr', (YLeaf(YType.str, 'nh-addr'), ['str'])),
                                                                                        ('vrf_name', (YLeaf(YType.str, 'vrf-name'), ['str'])),
                                                                                    ])
                                                                                    self.nh_addr = None
                                                                                    self.vrf_name = None
                                                                                    self._segment_path = lambda: "action-ipv4-nh-info-array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray, ['nh_addr', 'vrf_name'], name, value)


                                                                        class Ipv6Nh(Entity):
                                                                            """
                                                                            ipv6 nh
                                                                            
                                                                            .. attribute:: action_ipv6_nh_info_array
                                                                            
                                                                            	action ipv6 nh info array
                                                                            	**type**\: list of  		 :py:class:`ActionIpv6NhInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh, self).__init__()

                                                                                self.yang_name = "ipv6-nh"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("action-ipv6-nh-info-array", ("action_ipv6_nh_info_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.action_ipv6_nh_info_array = YList(self)
                                                                                self._segment_path = lambda: "ipv6-nh"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh, [], name, value)


                                                                            class ActionIpv6NhInfoArray(Entity):
                                                                                """
                                                                                action ipv6 nh info array
                                                                                
                                                                                .. attribute:: nh_addr
                                                                                
                                                                                	IPV6 Address
                                                                                	**type**\: str
                                                                                
                                                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                
                                                                                .. attribute:: vrf_name
                                                                                
                                                                                	Vrf name
                                                                                	**type**\: str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray, self).__init__()

                                                                                    self.yang_name = "action-ipv6-nh-info-array"
                                                                                    self.yang_parent_name = "ipv6-nh"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('nh_addr', (YLeaf(YType.str, 'nh-addr'), ['str'])),
                                                                                        ('vrf_name', (YLeaf(YType.str, 'vrf-name'), ['str'])),
                                                                                    ])
                                                                                    self.nh_addr = None
                                                                                    self.vrf_name = None
                                                                                    self._segment_path = lambda: "action-ipv6-nh-info-array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray, ['nh_addr', 'vrf_name'], name, value)


                                class ClassSeqNums(Entity):
                                    """
                                    Transient policy\-map sequence number table
                                    
                                    .. attribute:: class_seq_num
                                    
                                    	Transient policy\-map sequence number
                                    	**type**\: list of  		 :py:class:`ClassSeqNum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum>`
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2018-01-17'

                                    def __init__(self):
                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums, self).__init__()

                                        self.yang_name = "class-seq-nums"
                                        self.yang_parent_name = "transient-policy-map-name"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("class-seq-num", ("class_seq_num", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum))])
                                        self._leafs = OrderedDict()

                                        self.class_seq_num = YList(self)
                                        self._segment_path = lambda: "class-seq-nums"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums, [], name, value)


                                    class ClassSeqNum(Entity):
                                        """
                                        Transient policy\-map sequence number
                                        
                                        .. attribute:: sequence_num  (key)
                                        
                                        	sequence number
                                        	**type**\: int
                                        
                                        	**range:** \-2147483648..2147483647
                                        
                                        .. attribute:: policy_map_bg
                                        
                                        	policy map bg
                                        	**type**\: list of  		 :py:class:`PolicyMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg>`
                                        
                                        

                                        """

                                        _prefix = 'infra-policymgr-oper'
                                        _revision = '2018-01-17'

                                        def __init__(self):
                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum, self).__init__()

                                            self.yang_name = "class-seq-num"
                                            self.yang_parent_name = "class-seq-nums"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = ['sequence_num']
                                            self._child_classes = OrderedDict([("policy-map-bg", ("policy_map_bg", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg))])
                                            self._leafs = OrderedDict([
                                                ('sequence_num', (YLeaf(YType.int32, 'sequence-num'), ['int'])),
                                            ])
                                            self.sequence_num = None

                                            self.policy_map_bg = YList(self)
                                            self._segment_path = lambda: "class-seq-num" + "[sequence-num='" + str(self.sequence_num) + "']"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum, ['sequence_num'], name, value)


                                        class PolicyMapBg(Entity):
                                            """
                                            policy map bg
                                            
                                            .. attribute:: pmap_var_list
                                            
                                            	pmap var list
                                            	**type**\:  :py:class:`PmapVarList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.PmapVarList>`
                                            
                                            .. attribute:: event_infop
                                            
                                            	event infop
                                            	**type**\:  :py:class:`EventInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop>`
                                            
                                            .. attribute:: name
                                            
                                            	name
                                            	**type**\: str
                                            
                                            	**length:** 0..65
                                            
                                            .. attribute:: type
                                            
                                            	type
                                            	**type**\:  :py:class:`PolicyMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyMapTypeEn>`
                                            
                                            .. attribute:: description
                                            
                                            	description
                                            	**type**\: str
                                            
                                            

                                            """

                                            _prefix = 'infra-policymgr-oper'
                                            _revision = '2018-01-17'

                                            def __init__(self):
                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg, self).__init__()

                                                self.yang_name = "policy-map-bg"
                                                self.yang_parent_name = "class-seq-num"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("pmap-var-list", ("pmap_var_list", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.PmapVarList)), ("event-infop", ("event_infop", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop))])
                                                self._leafs = OrderedDict([
                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyMapTypeEn', '')])),
                                                    ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                ])
                                                self.name = None
                                                self.type = None
                                                self.description = None

                                                self.pmap_var_list = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.PmapVarList()
                                                self.pmap_var_list.parent = self
                                                self._children_name_map["pmap_var_list"] = "pmap-var-list"

                                                self.event_infop = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop()
                                                self.event_infop.parent = self
                                                self._children_name_map["event_infop"] = "event-infop"
                                                self._segment_path = lambda: "policy-map-bg"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg, ['name', 'type', 'description'], name, value)


                                            class PmapVarList(Entity):
                                                """
                                                pmap var list
                                                
                                                .. attribute:: pmap_var_list_arr
                                                
                                                	pmap var list arr
                                                	**type**\: list of  		 :py:class:`PmapVarListArr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.PmapVarList.PmapVarListArr>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.PmapVarList, self).__init__()

                                                    self.yang_name = "pmap-var-list"
                                                    self.yang_parent_name = "policy-map-bg"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("pmap-var-list-arr", ("pmap_var_list_arr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.PmapVarList.PmapVarListArr))])
                                                    self._leafs = OrderedDict()

                                                    self.pmap_var_list_arr = YList(self)
                                                    self._segment_path = lambda: "pmap-var-list"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.PmapVarList, [], name, value)


                                                class PmapVarListArr(Entity):
                                                    """
                                                    pmap var list arr
                                                    
                                                    .. attribute:: val
                                                    
                                                    	val
                                                    	**type**\:  :py:class:`Val <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.PmapVarList.PmapVarListArr.Val>`
                                                    
                                                    .. attribute:: name
                                                    
                                                    	name
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..32
                                                    
                                                    .. attribute:: id
                                                    
                                                    	id
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.PmapVarList.PmapVarListArr, self).__init__()

                                                        self.yang_name = "pmap-var-list-arr"
                                                        self.yang_parent_name = "pmap-var-list"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("val", ("val", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.PmapVarList.PmapVarListArr.Val))])
                                                        self._leafs = OrderedDict([
                                                            ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                            ('id', (YLeaf(YType.uint32, 'id'), ['int'])),
                                                        ])
                                                        self.name = None
                                                        self.id = None

                                                        self.val = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.PmapVarList.PmapVarListArr.Val()
                                                        self.val.parent = self
                                                        self._children_name_map["val"] = "val"
                                                        self._segment_path = lambda: "pmap-var-list-arr"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.PmapVarList.PmapVarListArr, ['name', 'id'], name, value)


                                                    class Val(Entity):
                                                        """
                                                        val
                                                        
                                                        .. attribute:: type
                                                        
                                                        	type
                                                        	**type**\:  :py:class:`PlmgrVarTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrVarTypeEn>`
                                                        
                                                        .. attribute:: class_name
                                                        
                                                        	class name
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..65
                                                        
                                                        .. attribute:: uint8_val
                                                        
                                                        	uint8 val
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        .. attribute:: uint16_val
                                                        
                                                        	uint16 val
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: uint32_val
                                                        
                                                        	uint32 val
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: param_uint32_val
                                                        
                                                        	param uint32 val
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: dscp_val
                                                        
                                                        	dscp val
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        .. attribute:: prec_val
                                                        
                                                        	prec val
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2018-01-17'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.PmapVarList.PmapVarListArr.Val, self).__init__()

                                                            self.yang_name = "val"
                                                            self.yang_parent_name = "pmap-var-list-arr"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PlmgrVarTypeEn', '')])),
                                                                ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                                ('uint8_val', (YLeaf(YType.uint8, 'uint8_val'), ['int'])),
                                                                ('uint16_val', (YLeaf(YType.uint16, 'uint16_val'), ['int'])),
                                                                ('uint32_val', (YLeaf(YType.uint32, 'uint32_val'), ['int'])),
                                                                ('param_uint32_val', (YLeaf(YType.uint32, 'param-uint32-val'), ['int'])),
                                                                ('dscp_val', (YLeaf(YType.uint8, 'dscp-val'), ['int'])),
                                                                ('prec_val', (YLeaf(YType.uint8, 'prec-val'), ['int'])),
                                                            ])
                                                            self.type = None
                                                            self.class_name = None
                                                            self.uint8_val = None
                                                            self.uint16_val = None
                                                            self.uint32_val = None
                                                            self.param_uint32_val = None
                                                            self.dscp_val = None
                                                            self.prec_val = None
                                                            self._segment_path = lambda: "val"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.PmapVarList.PmapVarListArr.Val, ['type', 'class_name', 'uint8_val', 'uint16_val', 'uint32_val', 'param_uint32_val', 'dscp_val', 'prec_val'], name, value)


                                            class EventInfop(Entity):
                                                """
                                                event infop
                                                
                                                .. attribute:: policy_event_info_bg
                                                
                                                	policy event info bg
                                                	**type**\: list of  		 :py:class:`PolicyEventInfoBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop, self).__init__()

                                                    self.yang_name = "event-infop"
                                                    self.yang_parent_name = "policy-map-bg"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("policy-event-info-bg", ("policy_event_info_bg", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg))])
                                                    self._leafs = OrderedDict()

                                                    self.policy_event_info_bg = YList(self)
                                                    self._segment_path = lambda: "event-infop"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop, [], name, value)


                                                class PolicyEventInfoBg(Entity):
                                                    """
                                                    policy event info bg
                                                    
                                                    .. attribute:: class_infop
                                                    
                                                    	class infop
                                                    	**type**\:  :py:class:`ClassInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop>`
                                                    
                                                    .. attribute:: event_type
                                                    
                                                    	event type
                                                    	**type**\:  :py:class:`PeventTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PeventTypeEn>`
                                                    
                                                    .. attribute:: cond_eval
                                                    
                                                    	cond eval
                                                    	**type**\:  :py:class:`PeventCondEvalEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PeventCondEvalEn>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg, self).__init__()

                                                        self.yang_name = "policy-event-info-bg"
                                                        self.yang_parent_name = "event-infop"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("class-infop", ("class_infop", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop))])
                                                        self._leafs = OrderedDict([
                                                            ('event_type', (YLeaf(YType.enumeration, 'event-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PeventTypeEn', '')])),
                                                            ('cond_eval', (YLeaf(YType.enumeration, 'cond-eval'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PeventCondEvalEn', '')])),
                                                        ])
                                                        self.event_type = None
                                                        self.cond_eval = None

                                                        self.class_infop = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop()
                                                        self.class_infop.parent = self
                                                        self._children_name_map["class_infop"] = "class-infop"
                                                        self._segment_path = lambda: "policy-event-info-bg"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg, ['event_type', 'cond_eval'], name, value)


                                                    class ClassInfop(Entity):
                                                        """
                                                        class infop
                                                        
                                                        .. attribute:: policy_class_info_bg
                                                        
                                                        	policy class info bg
                                                        	**type**\: list of  		 :py:class:`PolicyClassInfoBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2018-01-17'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop, self).__init__()

                                                            self.yang_name = "class-infop"
                                                            self.yang_parent_name = "policy-event-info-bg"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("policy-class-info-bg", ("policy_class_info_bg", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg))])
                                                            self._leafs = OrderedDict()

                                                            self.policy_class_info_bg = YList(self)
                                                            self._segment_path = lambda: "class-infop"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop, [], name, value)


                                                        class PolicyClassInfoBg(Entity):
                                                            """
                                                            policy class info bg
                                                            
                                                            .. attribute:: cl_encode
                                                            
                                                            	cl encode
                                                            	**type**\:  :py:class:`ClEncode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode>`
                                                            
                                                            .. attribute:: clmp_p
                                                            
                                                            	clmp p
                                                            	**type**\:  :py:class:`ClmpP <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP>`
                                                            
                                                            .. attribute:: act_infop
                                                            
                                                            	act infop
                                                            	**type**\:  :py:class:`ActInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop>`
                                                            
                                                            .. attribute:: policy_class_hd
                                                            
                                                            	policy class hd
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: seq
                                                            
                                                            	seq
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: flags
                                                            
                                                            	flags
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: ctype
                                                            
                                                            	ctype
                                                            	**type**\:  :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                            
                                                            .. attribute:: num_actions
                                                            
                                                            	num actions
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..65535
                                                            
                                                            .. attribute:: version
                                                            
                                                            	version
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..255
                                                            
                                                            .. attribute:: exe_strat
                                                            
                                                            	exe strat
                                                            	**type**\:  :py:class:`PclassExecStratEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PclassExecStratEn>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'infra-policymgr-oper'
                                                            _revision = '2018-01-17'

                                                            def __init__(self):
                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg, self).__init__()

                                                                self.yang_name = "policy-class-info-bg"
                                                                self.yang_parent_name = "class-infop"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("cl-encode", ("cl_encode", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode)), ("clmp-p", ("clmp_p", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP)), ("act-infop", ("act_infop", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop))])
                                                                self._leafs = OrderedDict([
                                                                    ('policy_class_hd', (YLeaf(YType.uint32, 'policy-class-hd'), ['int'])),
                                                                    ('seq', (YLeaf(YType.uint32, 'seq'), ['int'])),
                                                                    ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                    ('ctype', (YLeaf(YType.enumeration, 'ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapTypeEn', '')])),
                                                                    ('num_actions', (YLeaf(YType.uint16, 'num-actions'), ['int'])),
                                                                    ('version', (YLeaf(YType.uint8, 'version'), ['int'])),
                                                                    ('exe_strat', (YLeaf(YType.enumeration, 'exe-strat'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PclassExecStratEn', '')])),
                                                                ])
                                                                self.policy_class_hd = None
                                                                self.seq = None
                                                                self.flags = None
                                                                self.ctype = None
                                                                self.num_actions = None
                                                                self.version = None
                                                                self.exe_strat = None

                                                                self.cl_encode = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode()
                                                                self.cl_encode.parent = self
                                                                self._children_name_map["cl_encode"] = "cl-encode"

                                                                self.clmp_p = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP()
                                                                self.clmp_p.parent = self
                                                                self._children_name_map["clmp_p"] = "clmp-p"

                                                                self.act_infop = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop()
                                                                self.act_infop.parent = self
                                                                self._children_name_map["act_infop"] = "act-infop"
                                                                self._segment_path = lambda: "policy-class-info-bg"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg, ['policy_class_hd', 'seq', 'flags', 'ctype', 'num_actions', 'version', 'exe_strat'], name, value)


                                                            class ClEncode(Entity):
                                                                """
                                                                cl encode
                                                                
                                                                .. attribute:: inline_cmap
                                                                
                                                                	inline cmap
                                                                	**type**\:  :py:class:`InlineCmap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap>`
                                                                
                                                                .. attribute:: enc
                                                                
                                                                	enc
                                                                	**type**\:  :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                
                                                                .. attribute:: class_name
                                                                
                                                                	class name
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..65
                                                                
                                                                .. attribute:: hd
                                                                
                                                                	hd
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: idx
                                                                
                                                                	idx
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..255
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode, self).__init__()

                                                                    self.yang_name = "cl-encode"
                                                                    self.yang_parent_name = "policy-class-info-bg"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("inline-cmap", ("inline_cmap", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap))])
                                                                    self._leafs = OrderedDict([
                                                                        ('enc', (YLeaf(YType.enumeration, 'enc'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyObjEncEn', '')])),
                                                                        ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                                        ('hd', (YLeaf(YType.uint64, 'hd'), ['int'])),
                                                                        ('idx', (YLeaf(YType.uint8, 'idx'), ['int'])),
                                                                    ])
                                                                    self.enc = None
                                                                    self.class_name = None
                                                                    self.hd = None
                                                                    self.idx = None

                                                                    self.inline_cmap = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap()
                                                                    self.inline_cmap.parent = self
                                                                    self._children_name_map["inline_cmap"] = "inline-cmap"
                                                                    self._segment_path = lambda: "cl-encode"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode, ['enc', 'class_name', 'hd', 'idx'], name, value)


                                                                class InlineCmap(Entity):
                                                                    """
                                                                    inline cmap
                                                                    
                                                                    .. attribute:: match_infop
                                                                    
                                                                    	Pointer to the first Match info
                                                                    	**type**\:  :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop>`
                                                                    
                                                                    .. attribute:: mode
                                                                    
                                                                    	Inline Class\-Map Mode Match any/all
                                                                    	**type**\:  :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                    
                                                                    .. attribute:: flags
                                                                    
                                                                    	Inline Class\-Map flags
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: match_count
                                                                    
                                                                    	Number of Match infos
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap, self).__init__()

                                                                        self.yang_name = "inline-cmap"
                                                                        self.yang_parent_name = "cl-encode"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("match-infop", ("match_infop", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop))])
                                                                        self._leafs = OrderedDict([
                                                                            ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapModeEn', '')])),
                                                                            ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                            ('match_count', (YLeaf(YType.uint32, 'match-count'), ['int'])),
                                                                        ])
                                                                        self.mode = None
                                                                        self.flags = None
                                                                        self.match_count = None

                                                                        self.match_infop = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop()
                                                                        self.match_infop.parent = self
                                                                        self._children_name_map["match_infop"] = "match-infop"
                                                                        self._segment_path = lambda: "inline-cmap"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap, ['mode', 'flags', 'match_count'], name, value)


                                                                    class MatchInfop(Entity):
                                                                        """
                                                                        Pointer to the first Match info
                                                                        
                                                                        .. attribute:: class_match_info_st
                                                                        
                                                                        	class match info st
                                                                        	**type**\: list of  		 :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop, self).__init__()

                                                                            self.yang_name = "match-infop"
                                                                            self.yang_parent_name = "inline-cmap"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("class-match-info-st", ("class_match_info_st", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt))])
                                                                            self._leafs = OrderedDict()

                                                                            self.class_match_info_st = YList(self)
                                                                            self._segment_path = lambda: "match-infop"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop, [], name, value)


                                                                        class ClassMatchInfoSt(Entity):
                                                                            """
                                                                            class match info st
                                                                            
                                                                            .. attribute:: match_data
                                                                            
                                                                            	Match criteria
                                                                            	**type**\:  :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                            
                                                                            .. attribute:: flags
                                                                            
                                                                            	Flags
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                self.yang_name = "class-match-info-st"
                                                                                self.yang_parent_name = "match-infop"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("match-data", ("match_data", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                ])
                                                                                self.flags = None

                                                                                self.match_data = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                self.match_data.parent = self
                                                                                self._children_name_map["match_data"] = "match-data"
                                                                                self._segment_path = lambda: "class-match-info-st"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                            class MatchData(Entity):
                                                                                """
                                                                                Match criteria
                                                                                
                                                                                .. attribute:: ipv4_dscp
                                                                                
                                                                                	IPv4 DSCP
                                                                                	**type**\:  :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                
                                                                                .. attribute:: ipv6_dscp
                                                                                
                                                                                	IPv6 DSCP
                                                                                	**type**\:  :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                
                                                                                .. attribute:: dscp
                                                                                
                                                                                	Match DSCP range array
                                                                                	**type**\:  :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                
                                                                                .. attribute:: ipv4_prec
                                                                                
                                                                                	IPv4 Precedence
                                                                                	**type**\:  :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                
                                                                                .. attribute:: ipv6_prec
                                                                                
                                                                                	IPv6 Precedence
                                                                                	**type**\:  :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                
                                                                                .. attribute:: prec
                                                                                
                                                                                	Match Precedence array
                                                                                	**type**\:  :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                
                                                                                .. attribute:: discard_class
                                                                                
                                                                                	Match Discard Class array
                                                                                	**type**\:  :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                
                                                                                .. attribute:: qos_group
                                                                                
                                                                                	Match QoS group array
                                                                                	**type**\:  :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                
                                                                                .. attribute:: traffic_class
                                                                                
                                                                                	Match Traffic class array
                                                                                	**type**\:  :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                
                                                                                .. attribute:: proto
                                                                                
                                                                                	Match Protocol array
                                                                                	**type**\:  :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                
                                                                                .. attribute:: icmp_v4
                                                                                
                                                                                	Match ICMPV4 Protocol
                                                                                	**type**\:  :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                
                                                                                .. attribute:: icmp_v6
                                                                                
                                                                                	Match ICMPV6 Protocol array
                                                                                	**type**\:  :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                
                                                                                .. attribute:: ipv4_packet_len
                                                                                
                                                                                	IPv4 packet length array
                                                                                	**type**\:  :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                
                                                                                .. attribute:: ipv6_packet_len
                                                                                
                                                                                	IPv6 packet length array
                                                                                	**type**\:  :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                
                                                                                .. attribute:: packet_len
                                                                                
                                                                                	Match packet length array
                                                                                	**type**\:  :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                
                                                                                .. attribute:: flow_tag
                                                                                
                                                                                	Match flow\-tag array
                                                                                	**type**\:  :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                
                                                                                .. attribute:: tcp_flag
                                                                                
                                                                                	Match tcp flag value
                                                                                	**type**\:  :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                
                                                                                .. attribute:: icmpv4_type
                                                                                
                                                                                	Match ipv4 icmp type
                                                                                	**type**\:  :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                
                                                                                .. attribute:: icmpv4_code
                                                                                
                                                                                	Match ipv4 icmp code
                                                                                	**type**\:  :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                
                                                                                .. attribute:: icmpv6_type
                                                                                
                                                                                	Match ipv6 icmp type
                                                                                	**type**\:  :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                
                                                                                .. attribute:: icmpv6_code
                                                                                
                                                                                	Match ipv6 icmp code
                                                                                	**type**\:  :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                
                                                                                .. attribute:: mpls_exp
                                                                                
                                                                                	Match MPLS experimental topmost array
                                                                                	**type**\:  :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                
                                                                                .. attribute:: mpls_exp_imp
                                                                                
                                                                                	Match MPLS experimental imposition array
                                                                                	**type**\:  :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                
                                                                                .. attribute:: mpls_disp_ipv4_acl
                                                                                
                                                                                	MPLS Disposition IPv4 Access\-list
                                                                                	**type**\:  :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                
                                                                                .. attribute:: mpls_disp_ipv6_acl
                                                                                
                                                                                	MPLS Disposition IPv6 Access\-list
                                                                                	**type**\:  :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                
                                                                                .. attribute:: mpls_top_label
                                                                                
                                                                                	MPLS Topmost LABEL
                                                                                	**type**\:  :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                
                                                                                .. attribute:: cos
                                                                                
                                                                                	Match CoS array
                                                                                	**type**\:  :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                
                                                                                .. attribute:: cos_inr
                                                                                
                                                                                	Match inner header CoS
                                                                                	**type**\:  :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                
                                                                                .. attribute:: dei
                                                                                
                                                                                	Match DEI Bit
                                                                                	**type**\:  :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                
                                                                                .. attribute:: dei_inr
                                                                                
                                                                                	Match inner DEI Bit
                                                                                	**type**\:  :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                
                                                                                .. attribute:: vlan
                                                                                
                                                                                	Match VLAN array
                                                                                	**type**\:  :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                
                                                                                .. attribute:: vlan_inr
                                                                                
                                                                                	Match inner header VLAN range array
                                                                                	**type**\:  :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                
                                                                                .. attribute:: fr_dlci
                                                                                
                                                                                	Match FR DLCI range array
                                                                                	**type**\:  :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                
                                                                                .. attribute:: src_mac
                                                                                
                                                                                	Match Source MAC address
                                                                                	**type**\:  :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                
                                                                                .. attribute:: dst_mac
                                                                                
                                                                                	Match Destination MAC address
                                                                                	**type**\:  :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                
                                                                                .. attribute:: atm_clp
                                                                                
                                                                                	Match ATM CLP level
                                                                                	**type**\:  :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                
                                                                                .. attribute:: fr_de
                                                                                
                                                                                	Match FR DE value
                                                                                	**type**\:  :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                
                                                                                .. attribute:: ipv4_acl
                                                                                
                                                                                	IPv4 Access\-list
                                                                                	**type**\:  :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                
                                                                                .. attribute:: ipv6_acl
                                                                                
                                                                                	IPv6 Access\-list
                                                                                	**type**\:  :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                
                                                                                .. attribute:: ether_service_acl
                                                                                
                                                                                	Ethernet\-Services Access\-list
                                                                                	**type**\:  :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                
                                                                                .. attribute:: avail_id
                                                                                
                                                                                	Available Identifiers
                                                                                	**type**\:  :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                
                                                                                .. attribute:: media_type
                                                                                
                                                                                	Media Type
                                                                                	**type**\:  :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                
                                                                                .. attribute:: subs_protocol
                                                                                
                                                                                	Protocol
                                                                                	**type**\:  :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                
                                                                                .. attribute:: dnis
                                                                                
                                                                                	DNIS
                                                                                	**type**\:  :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                
                                                                                .. attribute:: dnis_regex
                                                                                
                                                                                	DNIS Regular Expression
                                                                                	**type**\:  :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                
                                                                                .. attribute:: domain
                                                                                
                                                                                	Domain Name
                                                                                	**type**\:  :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                
                                                                                .. attribute:: domain_regex
                                                                                
                                                                                	Domain Regular Expression
                                                                                	**type**\:  :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                
                                                                                .. attribute:: nas_port
                                                                                
                                                                                	NAS Port
                                                                                	**type**\:  :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                
                                                                                .. attribute:: service_name
                                                                                
                                                                                	Service Name
                                                                                	**type**\:  :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                
                                                                                .. attribute:: service_name_regex
                                                                                
                                                                                	Service Name Regular Exp
                                                                                	**type**\:  :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                
                                                                                .. attribute:: src_addr_ipv4
                                                                                
                                                                                	Source Address IPV4
                                                                                	**type**\:  :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                
                                                                                .. attribute:: dst_addr_ipv4
                                                                                
                                                                                	Destination Address IPV4
                                                                                	**type**\:  :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                
                                                                                .. attribute:: src_addr_ipv6
                                                                                
                                                                                	Source Address IPV6
                                                                                	**type**\:  :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                
                                                                                .. attribute:: dst_addr_ipv6
                                                                                
                                                                                	Destination Address IPV6
                                                                                	**type**\:  :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                
                                                                                .. attribute:: src_addr_mac
                                                                                
                                                                                	Source Address MAC
                                                                                	**type**\:  :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                
                                                                                .. attribute:: timer
                                                                                
                                                                                	Timer
                                                                                	**type**\:  :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                
                                                                                .. attribute:: timer_regexp
                                                                                
                                                                                	Timer Regular Expression
                                                                                	**type**\:  :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                
                                                                                .. attribute:: tunnel_name
                                                                                
                                                                                	Tunnel Name
                                                                                	**type**\:  :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                
                                                                                .. attribute:: tunnel_name_regex
                                                                                
                                                                                	Tunnel Name Regular Expression
                                                                                	**type**\:  :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                
                                                                                .. attribute:: user_name
                                                                                
                                                                                	User Name
                                                                                	**type**\:  :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                
                                                                                .. attribute:: user_name_regex
                                                                                
                                                                                	User Name Regular Expression
                                                                                	**type**\:  :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                
                                                                                .. attribute:: auth_username
                                                                                
                                                                                	Authenticated User Name
                                                                                	**type**\:  :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                
                                                                                .. attribute:: auth_username_regex
                                                                                
                                                                                	Authenticated User Name RegEx
                                                                                	**type**\:  :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                
                                                                                .. attribute:: unauth_username
                                                                                
                                                                                	Unauthenticated User Name
                                                                                	**type**\:  :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                
                                                                                .. attribute:: unauth_username_regex
                                                                                
                                                                                	Unauthenticated User Name RegEx
                                                                                	**type**\:  :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                
                                                                                .. attribute:: auth_domain
                                                                                
                                                                                	Authenticated domain name
                                                                                	**type**\:  :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                
                                                                                .. attribute:: auth_domain_regex
                                                                                
                                                                                	Authenticated Domain Name RegEx
                                                                                	**type**\:  :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                
                                                                                .. attribute:: unauth_domain
                                                                                
                                                                                	Unauthenticated Domain Name
                                                                                	**type**\:  :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                
                                                                                .. attribute:: unauth_domain_regex
                                                                                
                                                                                	Unauthenticated Domain Name RegEx
                                                                                	**type**\:  :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                
                                                                                .. attribute:: vendor_id
                                                                                
                                                                                	Vendor ID
                                                                                	**type**\:  :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                
                                                                                .. attribute:: vendor_id_regex
                                                                                
                                                                                	Vendor ID RegEx
                                                                                	**type**\:  :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                
                                                                                .. attribute:: access_interface
                                                                                
                                                                                	Access interface
                                                                                	**type**\:  :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                
                                                                                .. attribute:: input_interface
                                                                                
                                                                                	Input interface
                                                                                	**type**\:  :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                
                                                                                .. attribute:: input_intfhdl
                                                                                
                                                                                	Input interface handle
                                                                                	**type**\:  :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                
                                                                                .. attribute:: ethertype
                                                                                
                                                                                	Ethernet type
                                                                                	**type**\:  :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                
                                                                                .. attribute:: flow_key_data
                                                                                
                                                                                	Flow key structure
                                                                                	**type**\:  :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                
                                                                                .. attribute:: dhcp_client_id
                                                                                
                                                                                	Dhcp Client ID
                                                                                	**type**\:  :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                
                                                                                .. attribute:: dhcp_client_id_regex
                                                                                
                                                                                	Dhcp Client ID RegEx
                                                                                	**type**\:  :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                
                                                                                .. attribute:: circuit_id
                                                                                
                                                                                	Circuit ID
                                                                                	**type**\:  :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                
                                                                                .. attribute:: circuit_id_regex
                                                                                
                                                                                	Circuit ID RegEx
                                                                                	**type**\:  :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                
                                                                                .. attribute:: remote_id
                                                                                
                                                                                	Remote ID
                                                                                	**type**\:  :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                
                                                                                .. attribute:: remote_id_regex
                                                                                
                                                                                	Remote ID RegEx
                                                                                	**type**\:  :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                
                                                                                .. attribute:: src_port
                                                                                
                                                                                	Source port
                                                                                	**type**\:  :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                
                                                                                .. attribute:: dst_port
                                                                                
                                                                                	Destination port
                                                                                	**type**\:  :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:  :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                
                                                                                .. attribute:: mpls_top_eos
                                                                                
                                                                                	MPLS Topmost EOS
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: fragment_type
                                                                                
                                                                                	Fragment type
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: authen_status
                                                                                
                                                                                	Authentication Status
                                                                                	**type**\:  :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                
                                                                                .. attribute:: mlp_negotiated
                                                                                
                                                                                	MLP Negotiated
                                                                                	**type**\:  :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                    self.yang_name = "match-data"
                                                                                    self.yang_parent_name = "class-match-info-st"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("ipv4-dscp", ("ipv4_dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp)), ("ipv6-dscp", ("ipv6_dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp)), ("dscp", ("dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp)), ("ipv4-prec", ("ipv4_prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec)), ("ipv6-prec", ("ipv6_prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec)), ("prec", ("prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec)), ("discard-class", ("discard_class", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass)), ("qos-group", ("qos_group", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup)), ("traffic-class", ("traffic_class", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass)), ("proto", ("proto", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto)), ("icmp-v4", ("icmp_v4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4)), ("icmp-v6", ("icmp_v6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6)), ("ipv4-packet-len", ("ipv4_packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen)), ("ipv6-packet-len", ("ipv6_packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen)), ("packet-len", ("packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen)), ("flow-tag", ("flow_tag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag)), ("tcp-flag", ("tcp_flag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag)), ("icmpv4-type", ("icmpv4_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type)), ("icmpv4-code", ("icmpv4_code", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code)), ("icmpv6-type", ("icmpv6_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type)), ("icmpv6-code", ("icmpv6_code", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code)), ("mpls-exp", ("mpls_exp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp)), ("mpls-exp-imp", ("mpls_exp_imp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp)), ("mpls-disp-ipv4-acl", ("mpls_disp_ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl)), ("mpls-disp-ipv6-acl", ("mpls_disp_ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl)), ("mpls-top-label", ("mpls_top_label", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel)), ("cos", ("cos", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos)), ("cos-inr", ("cos_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr)), ("dei", ("dei", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei)), ("dei-inr", ("dei_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr)), ("vlan", ("vlan", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan)), ("vlan-inr", ("vlan_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)), ("fr-dlci", ("fr_dlci", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci)), ("src-mac", ("src_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac)), ("dst-mac", ("dst_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac)), ("atm-clp", ("atm_clp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp)), ("fr-de", ("fr_de", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe)), ("ipv4-acl", ("ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl)), ("ipv6-acl", ("ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl)), ("ether-service-acl", ("ether_service_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl)), ("avail-id", ("avail_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId)), ("media-type", ("media_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType)), ("subs-protocol", ("subs_protocol", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol)), ("dnis", ("dnis", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis)), ("dnis-regex", ("dnis_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex)), ("domain", ("domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain)), ("domain-regex", ("domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex)), ("nas-port", ("nas_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort)), ("service-name", ("service_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName)), ("service-name-regex", ("service_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex)), ("src-addr-ipv4", ("src_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4)), ("dst-addr-ipv4", ("dst_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4)), ("src-addr-ipv6", ("src_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6)), ("dst-addr-ipv6", ("dst_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6)), ("src-addr-mac", ("src_addr_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac)), ("timer", ("timer", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer)), ("timer-regexp", ("timer_regexp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp)), ("tunnel-name", ("tunnel_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName)), ("tunnel-name-regex", ("tunnel_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex)), ("user-name", ("user_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName)), ("user-name-regex", ("user_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex)), ("auth-username", ("auth_username", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername)), ("auth-username-regex", ("auth_username_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex)), ("unauth-username", ("unauth_username", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername)), ("unauth-username-regex", ("unauth_username_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex)), ("auth-domain", ("auth_domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain)), ("auth-domain-regex", ("auth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex)), ("unauth-domain", ("unauth_domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain)), ("unauth-domain-regex", ("unauth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex)), ("vendor-id", ("vendor_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId)), ("vendor-id-regex", ("vendor_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex)), ("access-interface", ("access_interface", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface)), ("input-interface", ("input_interface", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface)), ("input-intfhdl", ("input_intfhdl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl)), ("ethertype", ("ethertype", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype)), ("flow-key-data", ("flow_key_data", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData)), ("dhcp-client-id", ("dhcp_client_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId)), ("dhcp-client-id-regex", ("dhcp_client_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex)), ("circuit-id", ("circuit_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId)), ("circuit-id-regex", ("circuit_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex)), ("remote-id", ("remote_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId)), ("remote-id-regex", ("remote_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex)), ("src-port", ("src_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort)), ("dst-port", ("dst_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchTypeEn', '')])),
                                                                                        ('mpls_top_eos', (YLeaf(YType.uint8, 'mpls-top-eos'), ['int'])),
                                                                                        ('fragment_type', (YLeaf(YType.uint8, 'fragment-type'), ['int'])),
                                                                                        ('authen_status', (YLeaf(YType.enumeration, 'authen-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchAuthenStatusEn', '')])),
                                                                                        ('mlp_negotiated', (YLeaf(YType.enumeration, 'mlp-negotiated'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchMlpNegotiatedEn', '')])),
                                                                                    ])
                                                                                    self.type = None
                                                                                    self.mpls_top_eos = None
                                                                                    self.fragment_type = None
                                                                                    self.authen_status = None
                                                                                    self.mlp_negotiated = None

                                                                                    self.ipv4_dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                    self.ipv4_dscp.parent = self
                                                                                    self._children_name_map["ipv4_dscp"] = "ipv4-dscp"

                                                                                    self.ipv6_dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                    self.ipv6_dscp.parent = self
                                                                                    self._children_name_map["ipv6_dscp"] = "ipv6-dscp"

                                                                                    self.dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                    self.dscp.parent = self
                                                                                    self._children_name_map["dscp"] = "dscp"

                                                                                    self.ipv4_prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                    self.ipv4_prec.parent = self
                                                                                    self._children_name_map["ipv4_prec"] = "ipv4-prec"

                                                                                    self.ipv6_prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                    self.ipv6_prec.parent = self
                                                                                    self._children_name_map["ipv6_prec"] = "ipv6-prec"

                                                                                    self.prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                    self.prec.parent = self
                                                                                    self._children_name_map["prec"] = "prec"

                                                                                    self.discard_class = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                    self.discard_class.parent = self
                                                                                    self._children_name_map["discard_class"] = "discard-class"

                                                                                    self.qos_group = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                    self.qos_group.parent = self
                                                                                    self._children_name_map["qos_group"] = "qos-group"

                                                                                    self.traffic_class = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                    self.traffic_class.parent = self
                                                                                    self._children_name_map["traffic_class"] = "traffic-class"

                                                                                    self.proto = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                    self.proto.parent = self
                                                                                    self._children_name_map["proto"] = "proto"

                                                                                    self.icmp_v4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                    self.icmp_v4.parent = self
                                                                                    self._children_name_map["icmp_v4"] = "icmp-v4"

                                                                                    self.icmp_v6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                    self.icmp_v6.parent = self
                                                                                    self._children_name_map["icmp_v6"] = "icmp-v6"

                                                                                    self.ipv4_packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                    self.ipv4_packet_len.parent = self
                                                                                    self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"

                                                                                    self.ipv6_packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                    self.ipv6_packet_len.parent = self
                                                                                    self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"

                                                                                    self.packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                    self.packet_len.parent = self
                                                                                    self._children_name_map["packet_len"] = "packet-len"

                                                                                    self.flow_tag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                    self.flow_tag.parent = self
                                                                                    self._children_name_map["flow_tag"] = "flow-tag"

                                                                                    self.tcp_flag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                    self.tcp_flag.parent = self
                                                                                    self._children_name_map["tcp_flag"] = "tcp-flag"

                                                                                    self.icmpv4_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                    self.icmpv4_type.parent = self
                                                                                    self._children_name_map["icmpv4_type"] = "icmpv4-type"

                                                                                    self.icmpv4_code = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                    self.icmpv4_code.parent = self
                                                                                    self._children_name_map["icmpv4_code"] = "icmpv4-code"

                                                                                    self.icmpv6_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                    self.icmpv6_type.parent = self
                                                                                    self._children_name_map["icmpv6_type"] = "icmpv6-type"

                                                                                    self.icmpv6_code = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                    self.icmpv6_code.parent = self
                                                                                    self._children_name_map["icmpv6_code"] = "icmpv6-code"

                                                                                    self.mpls_exp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                    self.mpls_exp.parent = self
                                                                                    self._children_name_map["mpls_exp"] = "mpls-exp"

                                                                                    self.mpls_exp_imp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                    self.mpls_exp_imp.parent = self
                                                                                    self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"

                                                                                    self.mpls_disp_ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                    self.mpls_disp_ipv4_acl.parent = self
                                                                                    self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"

                                                                                    self.mpls_disp_ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                    self.mpls_disp_ipv6_acl.parent = self
                                                                                    self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"

                                                                                    self.mpls_top_label = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                    self.mpls_top_label.parent = self
                                                                                    self._children_name_map["mpls_top_label"] = "mpls-top-label"

                                                                                    self.cos = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                    self.cos.parent = self
                                                                                    self._children_name_map["cos"] = "cos"

                                                                                    self.cos_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                    self.cos_inr.parent = self
                                                                                    self._children_name_map["cos_inr"] = "cos-inr"

                                                                                    self.dei = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                    self.dei.parent = self
                                                                                    self._children_name_map["dei"] = "dei"

                                                                                    self.dei_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                    self.dei_inr.parent = self
                                                                                    self._children_name_map["dei_inr"] = "dei-inr"

                                                                                    self.vlan = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                    self.vlan.parent = self
                                                                                    self._children_name_map["vlan"] = "vlan"

                                                                                    self.vlan_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                    self.vlan_inr.parent = self
                                                                                    self._children_name_map["vlan_inr"] = "vlan-inr"

                                                                                    self.fr_dlci = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                    self.fr_dlci.parent = self
                                                                                    self._children_name_map["fr_dlci"] = "fr-dlci"

                                                                                    self.src_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                    self.src_mac.parent = self
                                                                                    self._children_name_map["src_mac"] = "src-mac"

                                                                                    self.dst_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                    self.dst_mac.parent = self
                                                                                    self._children_name_map["dst_mac"] = "dst-mac"

                                                                                    self.atm_clp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                    self.atm_clp.parent = self
                                                                                    self._children_name_map["atm_clp"] = "atm-clp"

                                                                                    self.fr_de = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                    self.fr_de.parent = self
                                                                                    self._children_name_map["fr_de"] = "fr-de"

                                                                                    self.ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                    self.ipv4_acl.parent = self
                                                                                    self._children_name_map["ipv4_acl"] = "ipv4-acl"

                                                                                    self.ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                    self.ipv6_acl.parent = self
                                                                                    self._children_name_map["ipv6_acl"] = "ipv6-acl"

                                                                                    self.ether_service_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                    self.ether_service_acl.parent = self
                                                                                    self._children_name_map["ether_service_acl"] = "ether-service-acl"

                                                                                    self.avail_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                    self.avail_id.parent = self
                                                                                    self._children_name_map["avail_id"] = "avail-id"

                                                                                    self.media_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                    self.media_type.parent = self
                                                                                    self._children_name_map["media_type"] = "media-type"

                                                                                    self.subs_protocol = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                    self.subs_protocol.parent = self
                                                                                    self._children_name_map["subs_protocol"] = "subs-protocol"

                                                                                    self.dnis = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                    self.dnis.parent = self
                                                                                    self._children_name_map["dnis"] = "dnis"

                                                                                    self.dnis_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                    self.dnis_regex.parent = self
                                                                                    self._children_name_map["dnis_regex"] = "dnis-regex"

                                                                                    self.domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                    self.domain.parent = self
                                                                                    self._children_name_map["domain"] = "domain"

                                                                                    self.domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                    self.domain_regex.parent = self
                                                                                    self._children_name_map["domain_regex"] = "domain-regex"

                                                                                    self.nas_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                    self.nas_port.parent = self
                                                                                    self._children_name_map["nas_port"] = "nas-port"

                                                                                    self.service_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                    self.service_name.parent = self
                                                                                    self._children_name_map["service_name"] = "service-name"

                                                                                    self.service_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                    self.service_name_regex.parent = self
                                                                                    self._children_name_map["service_name_regex"] = "service-name-regex"

                                                                                    self.src_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                    self.src_addr_ipv4.parent = self
                                                                                    self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"

                                                                                    self.dst_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                    self.dst_addr_ipv4.parent = self
                                                                                    self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"

                                                                                    self.src_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                    self.src_addr_ipv6.parent = self
                                                                                    self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"

                                                                                    self.dst_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                    self.dst_addr_ipv6.parent = self
                                                                                    self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"

                                                                                    self.src_addr_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                    self.src_addr_mac.parent = self
                                                                                    self._children_name_map["src_addr_mac"] = "src-addr-mac"

                                                                                    self.timer = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                    self.timer.parent = self
                                                                                    self._children_name_map["timer"] = "timer"

                                                                                    self.timer_regexp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                    self.timer_regexp.parent = self
                                                                                    self._children_name_map["timer_regexp"] = "timer-regexp"

                                                                                    self.tunnel_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                    self.tunnel_name.parent = self
                                                                                    self._children_name_map["tunnel_name"] = "tunnel-name"

                                                                                    self.tunnel_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                    self.tunnel_name_regex.parent = self
                                                                                    self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"

                                                                                    self.user_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                    self.user_name.parent = self
                                                                                    self._children_name_map["user_name"] = "user-name"

                                                                                    self.user_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                    self.user_name_regex.parent = self
                                                                                    self._children_name_map["user_name_regex"] = "user-name-regex"

                                                                                    self.auth_username = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                    self.auth_username.parent = self
                                                                                    self._children_name_map["auth_username"] = "auth-username"

                                                                                    self.auth_username_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                    self.auth_username_regex.parent = self
                                                                                    self._children_name_map["auth_username_regex"] = "auth-username-regex"

                                                                                    self.unauth_username = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                    self.unauth_username.parent = self
                                                                                    self._children_name_map["unauth_username"] = "unauth-username"

                                                                                    self.unauth_username_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                    self.unauth_username_regex.parent = self
                                                                                    self._children_name_map["unauth_username_regex"] = "unauth-username-regex"

                                                                                    self.auth_domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                    self.auth_domain.parent = self
                                                                                    self._children_name_map["auth_domain"] = "auth-domain"

                                                                                    self.auth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                    self.auth_domain_regex.parent = self
                                                                                    self._children_name_map["auth_domain_regex"] = "auth-domain-regex"

                                                                                    self.unauth_domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                    self.unauth_domain.parent = self
                                                                                    self._children_name_map["unauth_domain"] = "unauth-domain"

                                                                                    self.unauth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                    self.unauth_domain_regex.parent = self
                                                                                    self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"

                                                                                    self.vendor_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                    self.vendor_id.parent = self
                                                                                    self._children_name_map["vendor_id"] = "vendor-id"

                                                                                    self.vendor_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                    self.vendor_id_regex.parent = self
                                                                                    self._children_name_map["vendor_id_regex"] = "vendor-id-regex"

                                                                                    self.access_interface = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                    self.access_interface.parent = self
                                                                                    self._children_name_map["access_interface"] = "access-interface"

                                                                                    self.input_interface = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                    self.input_interface.parent = self
                                                                                    self._children_name_map["input_interface"] = "input-interface"

                                                                                    self.input_intfhdl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                    self.input_intfhdl.parent = self
                                                                                    self._children_name_map["input_intfhdl"] = "input-intfhdl"

                                                                                    self.ethertype = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                    self.ethertype.parent = self
                                                                                    self._children_name_map["ethertype"] = "ethertype"

                                                                                    self.flow_key_data = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                    self.flow_key_data.parent = self
                                                                                    self._children_name_map["flow_key_data"] = "flow-key-data"

                                                                                    self.dhcp_client_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                    self.dhcp_client_id.parent = self
                                                                                    self._children_name_map["dhcp_client_id"] = "dhcp-client-id"

                                                                                    self.dhcp_client_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                    self.dhcp_client_id_regex.parent = self
                                                                                    self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"

                                                                                    self.circuit_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                    self.circuit_id.parent = self
                                                                                    self._children_name_map["circuit_id"] = "circuit-id"

                                                                                    self.circuit_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                    self.circuit_id_regex.parent = self
                                                                                    self._children_name_map["circuit_id_regex"] = "circuit-id-regex"

                                                                                    self.remote_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                    self.remote_id.parent = self
                                                                                    self._children_name_map["remote_id"] = "remote-id"

                                                                                    self.remote_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                    self.remote_id_regex.parent = self
                                                                                    self._children_name_map["remote_id_regex"] = "remote-id-regex"

                                                                                    self.src_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                    self.src_port.parent = self
                                                                                    self._children_name_map["src_port"] = "src-port"

                                                                                    self.dst_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                    self.dst_port.parent = self
                                                                                    self._children_name_map["dst_port"] = "dst-port"
                                                                                    self._segment_path = lambda: "match-data"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, ['type', 'mpls_top_eos', 'fragment_type', 'authen_status', 'mlp_negotiated'], name, value)


                                                                                class Ipv4Dscp(Entity):
                                                                                    """
                                                                                    IPv4 DSCP
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                        self.yang_name = "ipv4-dscp"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "ipv4-dscp"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "ipv4-dscp"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                class Ipv6Dscp(Entity):
                                                                                    """
                                                                                    IPv6 DSCP
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                        self.yang_name = "ipv6-dscp"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "ipv6-dscp"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "ipv6-dscp"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                class Dscp(Entity):
                                                                                    """
                                                                                    Match DSCP range array
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                        self.yang_name = "dscp"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "dscp"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "dscp"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                class Ipv4Prec(Entity):
                                                                                    """
                                                                                    IPv4 Precedence
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                        self.yang_name = "ipv4-prec"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                        ])
                                                                                        self.uint8_array = []
                                                                                        self._segment_path = lambda: "ipv4-prec"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                class Ipv6Prec(Entity):
                                                                                    """
                                                                                    IPv6 Precedence
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                        self.yang_name = "ipv6-prec"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                        ])
                                                                                        self.uint8_array = []
                                                                                        self._segment_path = lambda: "ipv6-prec"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                class Prec(Entity):
                                                                                    """
                                                                                    Match Precedence array
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                        self.yang_name = "prec"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                        ])
                                                                                        self.uint8_array = []
                                                                                        self._segment_path = lambda: "prec"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                class DiscardClass(Entity):
                                                                                    """
                                                                                    Match Discard Class array
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                        self.yang_name = "discard-class"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                        ])
                                                                                        self.uint8_array = []
                                                                                        self._segment_path = lambda: "discard-class"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                class QosGroup(Entity):
                                                                                    """
                                                                                    Match QoS group array
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                        self.yang_name = "qos-group"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "qos-group"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "qos-group"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['min', 'max'], name, value)


                                                                                class TrafficClass(Entity):
                                                                                    """
                                                                                    Match Traffic class array
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                        self.yang_name = "traffic-class"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "traffic-class"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "traffic-class"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['min', 'max'], name, value)


                                                                                class Proto(Entity):
                                                                                    """
                                                                                    Match Protocol array
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                        self.yang_name = "proto"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "proto"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "proto"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['min', 'max'], name, value)


                                                                                class IcmpV4(Entity):
                                                                                    """
                                                                                    Match ICMPV4 Protocol
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	Protocol type
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: code
                                                                                    
                                                                                    	Protocol code
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                        self.yang_name = "icmp-v4"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                            ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                        ])
                                                                                        self.type = None
                                                                                        self.code = None
                                                                                        self._segment_path = lambda: "icmp-v4"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['type', 'code'], name, value)


                                                                                class IcmpV6(Entity):
                                                                                    """
                                                                                    Match ICMPV6 Protocol array
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	Protocol type
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: code
                                                                                    
                                                                                    	Protocol code
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                        self.yang_name = "icmp-v6"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                            ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                        ])
                                                                                        self.type = None
                                                                                        self.code = None
                                                                                        self._segment_path = lambda: "icmp-v6"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['type', 'code'], name, value)


                                                                                class Ipv4PacketLen(Entity):
                                                                                    """
                                                                                    IPv4 packet length array
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                        self.yang_name = "ipv4-packet-len"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "ipv4-packet-len"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "ipv4-packet-len"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                class Ipv6PacketLen(Entity):
                                                                                    """
                                                                                    IPv6 packet length array
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                        self.yang_name = "ipv6-packet-len"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "ipv6-packet-len"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "ipv6-packet-len"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                class PacketLen(Entity):
                                                                                    """
                                                                                    Match packet length array
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                        self.yang_name = "packet-len"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "packet-len"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "packet-len"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                class FlowTag(Entity):
                                                                                    """
                                                                                    Match flow\-tag array
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                        self.yang_name = "flow-tag"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "flow-tag"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "flow-tag"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['min', 'max'], name, value)


                                                                                class TcpFlag(Entity):
                                                                                    """
                                                                                    Match tcp flag value
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	Value of TCP flag
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: match_any
                                                                                    
                                                                                    	Match any TCP flag bit
                                                                                    	**type**\: bool
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                        self.yang_name = "tcp-flag"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                            ('match_any', (YLeaf(YType.boolean, 'match-any'), ['bool'])),
                                                                                        ])
                                                                                        self.value = None
                                                                                        self.match_any = None
                                                                                        self._segment_path = lambda: "tcp-flag"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['value', 'match_any'], name, value)


                                                                                class Icmpv4Type(Entity):
                                                                                    """
                                                                                    Match ipv4 icmp type
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                        self.yang_name = "icmpv4-type"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "icmpv4-type"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "icmpv4-type"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                class Icmpv4Code(Entity):
                                                                                    """
                                                                                    Match ipv4 icmp code
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                        self.yang_name = "icmpv4-code"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "icmpv4-code"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "icmpv4-code"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                class Icmpv6Type(Entity):
                                                                                    """
                                                                                    Match ipv6 icmp type
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                        self.yang_name = "icmpv6-type"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "icmpv6-type"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "icmpv6-type"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                class Icmpv6Code(Entity):
                                                                                    """
                                                                                    Match ipv6 icmp code
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                        self.yang_name = "icmpv6-code"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "icmpv6-code"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "icmpv6-code"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                class MplsExp(Entity):
                                                                                    """
                                                                                    Match MPLS experimental topmost array
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                        self.yang_name = "mpls-exp"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                        ])
                                                                                        self.uint8_array = []
                                                                                        self._segment_path = lambda: "mpls-exp"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                class MplsExpImp(Entity):
                                                                                    """
                                                                                    Match MPLS experimental imposition array
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                        self.yang_name = "mpls-exp-imp"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                        ])
                                                                                        self.uint8_array = []
                                                                                        self._segment_path = lambda: "mpls-exp-imp"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                class MplsDispIpv4Acl(Entity):
                                                                                    """
                                                                                    MPLS Disposition IPv4 Access\-list
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                        self.yang_name = "mpls-disp-ipv4-acl"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "mpls-disp-ipv4-acl"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                class MplsDispIpv6Acl(Entity):
                                                                                    """
                                                                                    MPLS Disposition IPv6 Access\-list
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                        self.yang_name = "mpls-disp-ipv6-acl"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "mpls-disp-ipv6-acl"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                class MplsTopLabel(Entity):
                                                                                    """
                                                                                    MPLS Topmost LABEL
                                                                                    
                                                                                    .. attribute:: uint32_rng_array
                                                                                    
                                                                                    	uint32 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                        self.yang_name = "mpls-top-label"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint32_rng_array", ("uint32_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint32_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "mpls-top-label"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                    class Uint32RngArray(Entity):
                                                                                        """
                                                                                        uint32 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                            self.yang_name = "uint32_rng_array"
                                                                                            self.yang_parent_name = "mpls-top-label"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint32, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint32, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint32_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['min', 'max'], name, value)


                                                                                class Cos(Entity):
                                                                                    """
                                                                                    Match CoS array
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                        self.yang_name = "cos"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                        ])
                                                                                        self.uint8_array = []
                                                                                        self._segment_path = lambda: "cos"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                class CosInr(Entity):
                                                                                    """
                                                                                    Match inner header CoS
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                        self.yang_name = "cos-inr"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                        ])
                                                                                        self.uint8_array = []
                                                                                        self._segment_path = lambda: "cos-inr"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                class Dei(Entity):
                                                                                    """
                                                                                    Match DEI Bit
                                                                                    
                                                                                    .. attribute:: bit_value
                                                                                    
                                                                                    	Value of the DEI bit
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                        self.yang_name = "dei"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                        ])
                                                                                        self.bit_value = None
                                                                                        self._segment_path = lambda: "dei"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                class DeiInr(Entity):
                                                                                    """
                                                                                    Match inner DEI Bit
                                                                                    
                                                                                    .. attribute:: bit_value
                                                                                    
                                                                                    	Value of the DEI bit
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                        self.yang_name = "dei-inr"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                        ])
                                                                                        self.bit_value = None
                                                                                        self._segment_path = lambda: "dei-inr"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                class Vlan(Entity):
                                                                                    """
                                                                                    Match VLAN array
                                                                                    
                                                                                    .. attribute:: vlan_id_array
                                                                                    
                                                                                    	vlan id array
                                                                                    	**type**\: list of  		 :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                        self.yang_name = "vlan"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("vlan-id-array", ("vlan_id_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.vlan_id_array = YList(self)
                                                                                        self._segment_path = lambda: "vlan"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                    class VlanIdArray(Entity):
                                                                                        """
                                                                                        vlan id array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: mask
                                                                                        
                                                                                        	VLAN mask
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                            self.yang_name = "vlan-id-array"
                                                                                            self.yang_parent_name = "vlan"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                ('mask', (YLeaf(YType.uint16, 'mask'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self.mask = None
                                                                                            self._segment_path = lambda: "vlan-id-array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['min', 'max', 'mask'], name, value)


                                                                                class VlanInr(Entity):
                                                                                    """
                                                                                    Match inner header VLAN range array
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                        self.yang_name = "vlan-inr"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "vlan-inr"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "vlan-inr"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['min', 'max'], name, value)


                                                                                class FrDlci(Entity):
                                                                                    """
                                                                                    Match FR DLCI range array
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                        self.yang_name = "fr-dlci"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "fr-dlci"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "fr-dlci"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['min', 'max'], name, value)


                                                                                class SrcMac(Entity):
                                                                                    """
                                                                                    Match Source MAC address
                                                                                    
                                                                                    .. attribute:: mac_addr
                                                                                    
                                                                                    	MAC address
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	MAC mask
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                        self.yang_name = "src-mac"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                            ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                        ])
                                                                                        self.mac_addr = []
                                                                                        self.mask = []
                                                                                        self._segment_path = lambda: "src-mac"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                class DstMac(Entity):
                                                                                    """
                                                                                    Match Destination MAC address
                                                                                    
                                                                                    .. attribute:: mac_addr
                                                                                    
                                                                                    	MAC address
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	MAC mask
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                        self.yang_name = "dst-mac"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                            ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                        ])
                                                                                        self.mac_addr = []
                                                                                        self.mask = []
                                                                                        self._segment_path = lambda: "dst-mac"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                class AtmClp(Entity):
                                                                                    """
                                                                                    Match ATM CLP level
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                        self.yang_name = "atm-clp"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                        ])
                                                                                        self.uint8_array = []
                                                                                        self._segment_path = lambda: "atm-clp"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                class FrDe(Entity):
                                                                                    """
                                                                                    Match FR DE value
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                        self.yang_name = "fr-de"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                        ])
                                                                                        self.uint8_array = []
                                                                                        self._segment_path = lambda: "fr-de"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                class Ipv4Acl(Entity):
                                                                                    """
                                                                                    IPv4 Access\-list
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                        self.yang_name = "ipv4-acl"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "ipv4-acl"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                class Ipv6Acl(Entity):
                                                                                    """
                                                                                    IPv6 Access\-list
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                        self.yang_name = "ipv6-acl"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "ipv6-acl"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                class EtherServiceAcl(Entity):
                                                                                    """
                                                                                    Ethernet\-Services Access\-list
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                        self.yang_name = "ether-service-acl"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "ether-service-acl"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                class AvailId(Entity):
                                                                                    """
                                                                                    Available Identifiers
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                        self.yang_name = "avail-id"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                        ])
                                                                                        self.uint8_array = []
                                                                                        self._segment_path = lambda: "avail-id"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                class MediaType(Entity):
                                                                                    """
                                                                                    Media Type
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                        self.yang_name = "media-type"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                        ])
                                                                                        self.uint8_array = []
                                                                                        self._segment_path = lambda: "media-type"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                class SubsProtocol(Entity):
                                                                                    """
                                                                                    Protocol
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                        self.yang_name = "subs-protocol"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                        ])
                                                                                        self.uint8_array = []
                                                                                        self._segment_path = lambda: "subs-protocol"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                class Dnis(Entity):
                                                                                    """
                                                                                    DNIS
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                        self.yang_name = "dnis"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "dnis"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                class DnisRegex(Entity):
                                                                                    """
                                                                                    DNIS Regular Expression
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                        self.yang_name = "dnis-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "dnis-regex"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                class Domain(Entity):
                                                                                    """
                                                                                    Domain Name
                                                                                    
                                                                                    .. attribute:: domain_array
                                                                                    
                                                                                    	domain array
                                                                                    	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                        self.yang_name = "domain"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.domain_array = YList(self)
                                                                                        self._segment_path = lambda: "domain"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                    class DomainArray(Entity):
                                                                                        """
                                                                                        domain array
                                                                                        
                                                                                        .. attribute:: domain_name
                                                                                        
                                                                                        	domain name
                                                                                        	**type**\: str
                                                                                        
                                                                                        .. attribute:: format_name
                                                                                        
                                                                                        	format name
                                                                                        	**type**\: str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                            self.yang_name = "domain-array"
                                                                                            self.yang_parent_name = "domain"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                            ])
                                                                                            self.domain_name = None
                                                                                            self.format_name = None
                                                                                            self._segment_path = lambda: "domain-array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                class DomainRegex(Entity):
                                                                                    """
                                                                                    Domain Regular Expression
                                                                                    
                                                                                    .. attribute:: domain_array
                                                                                    
                                                                                    	domain array
                                                                                    	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                        self.yang_name = "domain-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.domain_array = YList(self)
                                                                                        self._segment_path = lambda: "domain-regex"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                    class DomainArray(Entity):
                                                                                        """
                                                                                        domain array
                                                                                        
                                                                                        .. attribute:: domain_name
                                                                                        
                                                                                        	domain name
                                                                                        	**type**\: str
                                                                                        
                                                                                        .. attribute:: format_name
                                                                                        
                                                                                        	format name
                                                                                        	**type**\: str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                            self.yang_name = "domain-array"
                                                                                            self.yang_parent_name = "domain-regex"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                            ])
                                                                                            self.domain_name = None
                                                                                            self.format_name = None
                                                                                            self._segment_path = lambda: "domain-array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                class NasPort(Entity):
                                                                                    """
                                                                                    NAS Port
                                                                                    
                                                                                    .. attribute:: nas_port_array
                                                                                    
                                                                                    	nas port array
                                                                                    	**type**\: list of  		 :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                        self.yang_name = "nas-port"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("nas-port-array", ("nas_port_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.nas_port_array = YList(self)
                                                                                        self._segment_path = lambda: "nas-port"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                    class NasPortArray(Entity):
                                                                                        """
                                                                                        nas port array
                                                                                        
                                                                                        .. attribute:: sub_id
                                                                                        
                                                                                        	sub id
                                                                                        	**type**\:  :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                        
                                                                                        .. attribute:: operator
                                                                                        
                                                                                        	operator
                                                                                        	**type**\:  :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                        
                                                                                        .. attribute:: value
                                                                                        
                                                                                        	value
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                            self.yang_name = "nas-port-array"
                                                                                            self.yang_parent_name = "nas-port"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('sub_id', (YLeaf(YType.enumeration, 'sub-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchNasPortSubIdEn', '')])),
                                                                                                ('operator', (YLeaf(YType.enumeration, 'operator'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchLogicalOperatorEn', '')])),
                                                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                            ])
                                                                                            self.sub_id = None
                                                                                            self.operator = None
                                                                                            self.value = None
                                                                                            self._segment_path = lambda: "nas-port-array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['sub_id', 'operator', 'value'], name, value)


                                                                                class ServiceName(Entity):
                                                                                    """
                                                                                    Service Name
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                        self.yang_name = "service-name"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "service-name"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                class ServiceNameRegex(Entity):
                                                                                    """
                                                                                    Service Name Regular Exp
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                        self.yang_name = "service-name-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "service-name-regex"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                class SrcAddrIpv4(Entity):
                                                                                    """
                                                                                    Source Address IPV4
                                                                                    
                                                                                    .. attribute:: ipv4_addr_array
                                                                                    
                                                                                    	ipv4 addr array
                                                                                    	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                        self.yang_name = "src-addr-ipv4"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.ipv4_addr_array = YList(self)
                                                                                        self._segment_path = lambda: "src-addr-ipv4"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                    class Ipv4AddrArray(Entity):
                                                                                        """
                                                                                        ipv4 addr array
                                                                                        
                                                                                        .. attribute:: prefix
                                                                                        
                                                                                        	prefix
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                        
                                                                                        .. attribute:: mask
                                                                                        
                                                                                        	mask
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                            self.yang_name = "ipv4-addr-array"
                                                                                            self.yang_parent_name = "src-addr-ipv4"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                            ])
                                                                                            self.prefix = None
                                                                                            self.mask = None
                                                                                            self._segment_path = lambda: "ipv4-addr-array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                class DstAddrIpv4(Entity):
                                                                                    """
                                                                                    Destination Address IPV4
                                                                                    
                                                                                    .. attribute:: ipv4_addr_array
                                                                                    
                                                                                    	ipv4 addr array
                                                                                    	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                        self.yang_name = "dst-addr-ipv4"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.ipv4_addr_array = YList(self)
                                                                                        self._segment_path = lambda: "dst-addr-ipv4"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                    class Ipv4AddrArray(Entity):
                                                                                        """
                                                                                        ipv4 addr array
                                                                                        
                                                                                        .. attribute:: prefix
                                                                                        
                                                                                        	prefix
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                        
                                                                                        .. attribute:: mask
                                                                                        
                                                                                        	mask
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                            self.yang_name = "ipv4-addr-array"
                                                                                            self.yang_parent_name = "dst-addr-ipv4"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                            ])
                                                                                            self.prefix = None
                                                                                            self.mask = None
                                                                                            self._segment_path = lambda: "ipv4-addr-array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                class SrcAddrIpv6(Entity):
                                                                                    """
                                                                                    Source Address IPV6
                                                                                    
                                                                                    .. attribute:: ipv6_addr_array
                                                                                    
                                                                                    	ipv6 addr array
                                                                                    	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                        self.yang_name = "src-addr-ipv6"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.ipv6_addr_array = YList(self)
                                                                                        self._segment_path = lambda: "src-addr-ipv6"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                    class Ipv6AddrArray(Entity):
                                                                                        """
                                                                                        ipv6 addr array
                                                                                        
                                                                                        .. attribute:: prefix
                                                                                        
                                                                                        	IPV6 prefix
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                        
                                                                                        .. attribute:: mask
                                                                                        
                                                                                        	IPV6 mask
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                            self.yang_name = "ipv6-addr-array"
                                                                                            self.yang_parent_name = "src-addr-ipv6"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                            ])
                                                                                            self.prefix = None
                                                                                            self.mask = None
                                                                                            self._segment_path = lambda: "ipv6-addr-array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                class DstAddrIpv6(Entity):
                                                                                    """
                                                                                    Destination Address IPV6
                                                                                    
                                                                                    .. attribute:: ipv6_addr_array
                                                                                    
                                                                                    	ipv6 addr array
                                                                                    	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                        self.yang_name = "dst-addr-ipv6"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.ipv6_addr_array = YList(self)
                                                                                        self._segment_path = lambda: "dst-addr-ipv6"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                    class Ipv6AddrArray(Entity):
                                                                                        """
                                                                                        ipv6 addr array
                                                                                        
                                                                                        .. attribute:: prefix
                                                                                        
                                                                                        	IPV6 prefix
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                        
                                                                                        .. attribute:: mask
                                                                                        
                                                                                        	IPV6 mask
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                            self.yang_name = "ipv6-addr-array"
                                                                                            self.yang_parent_name = "dst-addr-ipv6"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                            ])
                                                                                            self.prefix = None
                                                                                            self.mask = None
                                                                                            self._segment_path = lambda: "ipv6-addr-array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                class SrcAddrMac(Entity):
                                                                                    """
                                                                                    Source Address MAC
                                                                                    
                                                                                    .. attribute:: mac_addr_array
                                                                                    
                                                                                    	mac addr array
                                                                                    	**type**\: list of  		 :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                        self.yang_name = "src-addr-mac"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("mac-addr-array", ("mac_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.mac_addr_array = YList(self)
                                                                                        self._segment_path = lambda: "src-addr-mac"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                    class MacAddrArray(Entity):
                                                                                        """
                                                                                        mac addr array
                                                                                        
                                                                                        .. attribute:: mac_addr
                                                                                        
                                                                                        	MAC address
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: mask
                                                                                        
                                                                                        	MAC mask
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                            self.yang_name = "mac-addr-array"
                                                                                            self.yang_parent_name = "src-addr-mac"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                            ])
                                                                                            self.mac_addr = []
                                                                                            self.mask = []
                                                                                            self._segment_path = lambda: "mac-addr-array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                class Timer(Entity):
                                                                                    """
                                                                                    Timer
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                        self.yang_name = "timer"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "timer"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                class TimerRegexp(Entity):
                                                                                    """
                                                                                    Timer Regular Expression
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                        self.yang_name = "timer-regexp"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "timer-regexp"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                class TunnelName(Entity):
                                                                                    """
                                                                                    Tunnel Name
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                        self.yang_name = "tunnel-name"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "tunnel-name"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                class TunnelNameRegex(Entity):
                                                                                    """
                                                                                    Tunnel Name Regular Expression
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                        self.yang_name = "tunnel-name-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "tunnel-name-regex"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                class UserName(Entity):
                                                                                    """
                                                                                    User Name
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                        self.yang_name = "user-name"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "user-name"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                class UserNameRegex(Entity):
                                                                                    """
                                                                                    User Name Regular Expression
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                        self.yang_name = "user-name-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "user-name-regex"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                class AuthUsername(Entity):
                                                                                    """
                                                                                    Authenticated User Name
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                        self.yang_name = "auth-username"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "auth-username"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                class AuthUsernameRegex(Entity):
                                                                                    """
                                                                                    Authenticated User Name RegEx
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                        self.yang_name = "auth-username-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "auth-username-regex"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                class UnauthUsername(Entity):
                                                                                    """
                                                                                    Unauthenticated User Name
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                        self.yang_name = "unauth-username"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "unauth-username"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                class UnauthUsernameRegex(Entity):
                                                                                    """
                                                                                    Unauthenticated User Name RegEx
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                        self.yang_name = "unauth-username-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "unauth-username-regex"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                class AuthDomain(Entity):
                                                                                    """
                                                                                    Authenticated domain name
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                        self.yang_name = "auth-domain"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "auth-domain"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                class AuthDomainRegex(Entity):
                                                                                    """
                                                                                    Authenticated Domain Name RegEx
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                        self.yang_name = "auth-domain-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "auth-domain-regex"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                class UnauthDomain(Entity):
                                                                                    """
                                                                                    Unauthenticated Domain Name
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                        self.yang_name = "unauth-domain"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "unauth-domain"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                class UnauthDomainRegex(Entity):
                                                                                    """
                                                                                    Unauthenticated Domain Name RegEx
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                        self.yang_name = "unauth-domain-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "unauth-domain-regex"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                class VendorId(Entity):
                                                                                    """
                                                                                    Vendor ID
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                        self.yang_name = "vendor-id"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "vendor-id"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                class VendorIdRegex(Entity):
                                                                                    """
                                                                                    Vendor ID RegEx
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                        self.yang_name = "vendor-id-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "vendor-id-regex"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                class AccessInterface(Entity):
                                                                                    """
                                                                                    Access interface
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                        self.yang_name = "access-interface"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "access-interface"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                class InputInterface(Entity):
                                                                                    """
                                                                                    Input interface
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                        self.yang_name = "input-interface"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "input-interface"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                class InputIntfhdl(Entity):
                                                                                    """
                                                                                    Input interface handle
                                                                                    
                                                                                    .. attribute:: uint64_array
                                                                                    
                                                                                    	uint64 array
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..18446744073709551615
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                        self.yang_name = "input-intfhdl"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('uint64_array', (YLeafList(YType.uint64, 'uint64_array'), ['int'])),
                                                                                        ])
                                                                                        self.uint64_array = []
                                                                                        self._segment_path = lambda: "input-intfhdl"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                class Ethertype(Entity):
                                                                                    """
                                                                                    Ethernet type
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                        self.yang_name = "ethertype"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "ethertype"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "ethertype"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['min', 'max'], name, value)


                                                                                class FlowKeyData(Entity):
                                                                                    """
                                                                                    Flow key structure
                                                                                    
                                                                                    .. attribute:: flow_keys
                                                                                    
                                                                                    	flow keys
                                                                                    	**type**\:  :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                    
                                                                                    .. attribute:: max_count
                                                                                    
                                                                                    	Maximum count of flows
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: idle_timeout
                                                                                    
                                                                                    	Idle timeout of flows (in seconds)
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    	**units**\: second
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                        self.yang_name = "flow-key-data"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("flow-keys", ("flow_keys", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys))])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('max_count', (YLeaf(YType.uint16, 'max-count'), ['int'])),
                                                                                            ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                                        ])
                                                                                        self.max_count = None
                                                                                        self.idle_timeout = None

                                                                                        self.flow_keys = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                        self.flow_keys.parent = self
                                                                                        self._children_name_map["flow_keys"] = "flow-keys"
                                                                                        self._segment_path = lambda: "flow-key-data"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['max_count', 'idle_timeout'], name, value)


                                                                                    class FlowKeys(Entity):
                                                                                        """
                                                                                        flow keys
                                                                                        
                                                                                        .. attribute:: keys
                                                                                        
                                                                                        	keys
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                        
                                                                                        .. attribute:: num
                                                                                        
                                                                                        	num
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                            self.yang_name = "flow-keys"
                                                                                            self.yang_parent_name = "flow-key-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('keys', (YLeaf(YType.str, 'keys'), ['str'])),
                                                                                                ('num', (YLeaf(YType.uint8, 'num'), ['int'])),
                                                                                            ])
                                                                                            self.keys = None
                                                                                            self.num = None
                                                                                            self._segment_path = lambda: "flow-keys"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                class DhcpClientId(Entity):
                                                                                    """
                                                                                    Dhcp Client ID
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                        self.yang_name = "dhcp-client-id"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "dhcp-client-id"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                class DhcpClientIdRegex(Entity):
                                                                                    """
                                                                                    Dhcp Client ID RegEx
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                        self.yang_name = "dhcp-client-id-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "dhcp-client-id-regex"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                class CircuitId(Entity):
                                                                                    """
                                                                                    Circuit ID
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                        self.yang_name = "circuit-id"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "circuit-id"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                class CircuitIdRegex(Entity):
                                                                                    """
                                                                                    Circuit ID RegEx
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                        self.yang_name = "circuit-id-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "circuit-id-regex"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                class RemoteId(Entity):
                                                                                    """
                                                                                    Remote ID
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                        self.yang_name = "remote-id"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "remote-id"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                class RemoteIdRegex(Entity):
                                                                                    """
                                                                                    Remote ID RegEx
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                        self.yang_name = "remote-id-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "remote-id-regex"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                class SrcPort(Entity):
                                                                                    """
                                                                                    Source port
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                        self.yang_name = "src-port"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "src-port"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "src-port"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                                class DstPort(Entity):
                                                                                    """
                                                                                    Destination port
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                        self.yang_name = "dst-port"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "dst-port"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "dst-port"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['min', 'max'], name, value)


                                                            class ClmpP(Entity):
                                                                """
                                                                clmp p
                                                                
                                                                .. attribute:: class_map_bg
                                                                
                                                                	class map bg
                                                                	**type**\: list of  		 :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP, self).__init__()

                                                                    self.yang_name = "clmp-p"
                                                                    self.yang_parent_name = "policy-class-info-bg"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("class-map-bg", ("class_map_bg", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg))])
                                                                    self._leafs = OrderedDict()

                                                                    self.class_map_bg = YList(self)
                                                                    self._segment_path = lambda: "clmp-p"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP, [], name, value)


                                                                class ClassMapBg(Entity):
                                                                    """
                                                                    class map bg
                                                                    
                                                                    .. attribute:: match_infop
                                                                    
                                                                    	Pointer to the first Match info
                                                                    	**type**\:  :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop>`
                                                                    
                                                                    .. attribute:: name
                                                                    
                                                                    	Name of the class\-map
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..65
                                                                    
                                                                    .. attribute:: type
                                                                    
                                                                    	Class\-Map Type QoS/PBR/Netflow/..
                                                                    	**type**\:  :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                                    
                                                                    .. attribute:: mode
                                                                    
                                                                    	Class\-Map Mode Match any/Match all
                                                                    	**type**\:  :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                    
                                                                    .. attribute:: description
                                                                    
                                                                    	description
                                                                    	**type**\: str
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg, self).__init__()

                                                                        self.yang_name = "class-map-bg"
                                                                        self.yang_parent_name = "clmp-p"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("match-infop", ("match_infop", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop))])
                                                                        self._leafs = OrderedDict([
                                                                            ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapTypeEn', '')])),
                                                                            ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapModeEn', '')])),
                                                                            ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                        ])
                                                                        self.name = None
                                                                        self.type = None
                                                                        self.mode = None
                                                                        self.description = None

                                                                        self.match_infop = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop()
                                                                        self.match_infop.parent = self
                                                                        self._children_name_map["match_infop"] = "match-infop"
                                                                        self._segment_path = lambda: "class-map-bg"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg, ['name', 'type', 'mode', 'description'], name, value)


                                                                    class MatchInfop(Entity):
                                                                        """
                                                                        Pointer to the first Match info
                                                                        
                                                                        .. attribute:: class_match_info_st
                                                                        
                                                                        	class match info st
                                                                        	**type**\: list of  		 :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop, self).__init__()

                                                                            self.yang_name = "match-infop"
                                                                            self.yang_parent_name = "class-map-bg"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("class-match-info-st", ("class_match_info_st", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt))])
                                                                            self._leafs = OrderedDict()

                                                                            self.class_match_info_st = YList(self)
                                                                            self._segment_path = lambda: "match-infop"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop, [], name, value)


                                                                        class ClassMatchInfoSt(Entity):
                                                                            """
                                                                            class match info st
                                                                            
                                                                            .. attribute:: match_data
                                                                            
                                                                            	Match criteria
                                                                            	**type**\:  :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                            
                                                                            .. attribute:: flags
                                                                            
                                                                            	Flags
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                self.yang_name = "class-match-info-st"
                                                                                self.yang_parent_name = "match-infop"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("match-data", ("match_data", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                ])
                                                                                self.flags = None

                                                                                self.match_data = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                self.match_data.parent = self
                                                                                self._children_name_map["match_data"] = "match-data"
                                                                                self._segment_path = lambda: "class-match-info-st"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                            class MatchData(Entity):
                                                                                """
                                                                                Match criteria
                                                                                
                                                                                .. attribute:: ipv4_dscp
                                                                                
                                                                                	IPv4 DSCP
                                                                                	**type**\:  :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                
                                                                                .. attribute:: ipv6_dscp
                                                                                
                                                                                	IPv6 DSCP
                                                                                	**type**\:  :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                
                                                                                .. attribute:: dscp
                                                                                
                                                                                	Match DSCP range array
                                                                                	**type**\:  :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                
                                                                                .. attribute:: ipv4_prec
                                                                                
                                                                                	IPv4 Precedence
                                                                                	**type**\:  :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                
                                                                                .. attribute:: ipv6_prec
                                                                                
                                                                                	IPv6 Precedence
                                                                                	**type**\:  :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                
                                                                                .. attribute:: prec
                                                                                
                                                                                	Match Precedence array
                                                                                	**type**\:  :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                
                                                                                .. attribute:: discard_class
                                                                                
                                                                                	Match Discard Class array
                                                                                	**type**\:  :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                
                                                                                .. attribute:: qos_group
                                                                                
                                                                                	Match QoS group array
                                                                                	**type**\:  :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                
                                                                                .. attribute:: traffic_class
                                                                                
                                                                                	Match Traffic class array
                                                                                	**type**\:  :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                
                                                                                .. attribute:: proto
                                                                                
                                                                                	Match Protocol array
                                                                                	**type**\:  :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                
                                                                                .. attribute:: icmp_v4
                                                                                
                                                                                	Match ICMPV4 Protocol
                                                                                	**type**\:  :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                
                                                                                .. attribute:: icmp_v6
                                                                                
                                                                                	Match ICMPV6 Protocol array
                                                                                	**type**\:  :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                
                                                                                .. attribute:: ipv4_packet_len
                                                                                
                                                                                	IPv4 packet length array
                                                                                	**type**\:  :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                
                                                                                .. attribute:: ipv6_packet_len
                                                                                
                                                                                	IPv6 packet length array
                                                                                	**type**\:  :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                
                                                                                .. attribute:: packet_len
                                                                                
                                                                                	Match packet length array
                                                                                	**type**\:  :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                
                                                                                .. attribute:: flow_tag
                                                                                
                                                                                	Match flow\-tag array
                                                                                	**type**\:  :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                
                                                                                .. attribute:: tcp_flag
                                                                                
                                                                                	Match tcp flag value
                                                                                	**type**\:  :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                
                                                                                .. attribute:: icmpv4_type
                                                                                
                                                                                	Match ipv4 icmp type
                                                                                	**type**\:  :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                
                                                                                .. attribute:: icmpv4_code
                                                                                
                                                                                	Match ipv4 icmp code
                                                                                	**type**\:  :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                
                                                                                .. attribute:: icmpv6_type
                                                                                
                                                                                	Match ipv6 icmp type
                                                                                	**type**\:  :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                
                                                                                .. attribute:: icmpv6_code
                                                                                
                                                                                	Match ipv6 icmp code
                                                                                	**type**\:  :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                
                                                                                .. attribute:: mpls_exp
                                                                                
                                                                                	Match MPLS experimental topmost array
                                                                                	**type**\:  :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                
                                                                                .. attribute:: mpls_exp_imp
                                                                                
                                                                                	Match MPLS experimental imposition array
                                                                                	**type**\:  :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                
                                                                                .. attribute:: mpls_disp_ipv4_acl
                                                                                
                                                                                	MPLS Disposition IPv4 Access\-list
                                                                                	**type**\:  :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                
                                                                                .. attribute:: mpls_disp_ipv6_acl
                                                                                
                                                                                	MPLS Disposition IPv6 Access\-list
                                                                                	**type**\:  :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                
                                                                                .. attribute:: mpls_top_label
                                                                                
                                                                                	MPLS Topmost LABEL
                                                                                	**type**\:  :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                
                                                                                .. attribute:: cos
                                                                                
                                                                                	Match CoS array
                                                                                	**type**\:  :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                
                                                                                .. attribute:: cos_inr
                                                                                
                                                                                	Match inner header CoS
                                                                                	**type**\:  :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                
                                                                                .. attribute:: dei
                                                                                
                                                                                	Match DEI Bit
                                                                                	**type**\:  :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                
                                                                                .. attribute:: dei_inr
                                                                                
                                                                                	Match inner DEI Bit
                                                                                	**type**\:  :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                
                                                                                .. attribute:: vlan
                                                                                
                                                                                	Match VLAN array
                                                                                	**type**\:  :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                
                                                                                .. attribute:: vlan_inr
                                                                                
                                                                                	Match inner header VLAN range array
                                                                                	**type**\:  :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                
                                                                                .. attribute:: fr_dlci
                                                                                
                                                                                	Match FR DLCI range array
                                                                                	**type**\:  :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                
                                                                                .. attribute:: src_mac
                                                                                
                                                                                	Match Source MAC address
                                                                                	**type**\:  :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                
                                                                                .. attribute:: dst_mac
                                                                                
                                                                                	Match Destination MAC address
                                                                                	**type**\:  :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                
                                                                                .. attribute:: atm_clp
                                                                                
                                                                                	Match ATM CLP level
                                                                                	**type**\:  :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                
                                                                                .. attribute:: fr_de
                                                                                
                                                                                	Match FR DE value
                                                                                	**type**\:  :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                
                                                                                .. attribute:: ipv4_acl
                                                                                
                                                                                	IPv4 Access\-list
                                                                                	**type**\:  :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                
                                                                                .. attribute:: ipv6_acl
                                                                                
                                                                                	IPv6 Access\-list
                                                                                	**type**\:  :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                
                                                                                .. attribute:: ether_service_acl
                                                                                
                                                                                	Ethernet\-Services Access\-list
                                                                                	**type**\:  :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                
                                                                                .. attribute:: avail_id
                                                                                
                                                                                	Available Identifiers
                                                                                	**type**\:  :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                
                                                                                .. attribute:: media_type
                                                                                
                                                                                	Media Type
                                                                                	**type**\:  :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                
                                                                                .. attribute:: subs_protocol
                                                                                
                                                                                	Protocol
                                                                                	**type**\:  :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                
                                                                                .. attribute:: dnis
                                                                                
                                                                                	DNIS
                                                                                	**type**\:  :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                
                                                                                .. attribute:: dnis_regex
                                                                                
                                                                                	DNIS Regular Expression
                                                                                	**type**\:  :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                
                                                                                .. attribute:: domain
                                                                                
                                                                                	Domain Name
                                                                                	**type**\:  :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                
                                                                                .. attribute:: domain_regex
                                                                                
                                                                                	Domain Regular Expression
                                                                                	**type**\:  :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                
                                                                                .. attribute:: nas_port
                                                                                
                                                                                	NAS Port
                                                                                	**type**\:  :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                
                                                                                .. attribute:: service_name
                                                                                
                                                                                	Service Name
                                                                                	**type**\:  :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                
                                                                                .. attribute:: service_name_regex
                                                                                
                                                                                	Service Name Regular Exp
                                                                                	**type**\:  :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                
                                                                                .. attribute:: src_addr_ipv4
                                                                                
                                                                                	Source Address IPV4
                                                                                	**type**\:  :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                
                                                                                .. attribute:: dst_addr_ipv4
                                                                                
                                                                                	Destination Address IPV4
                                                                                	**type**\:  :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                
                                                                                .. attribute:: src_addr_ipv6
                                                                                
                                                                                	Source Address IPV6
                                                                                	**type**\:  :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                
                                                                                .. attribute:: dst_addr_ipv6
                                                                                
                                                                                	Destination Address IPV6
                                                                                	**type**\:  :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                
                                                                                .. attribute:: src_addr_mac
                                                                                
                                                                                	Source Address MAC
                                                                                	**type**\:  :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                
                                                                                .. attribute:: timer
                                                                                
                                                                                	Timer
                                                                                	**type**\:  :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                
                                                                                .. attribute:: timer_regexp
                                                                                
                                                                                	Timer Regular Expression
                                                                                	**type**\:  :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                
                                                                                .. attribute:: tunnel_name
                                                                                
                                                                                	Tunnel Name
                                                                                	**type**\:  :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                
                                                                                .. attribute:: tunnel_name_regex
                                                                                
                                                                                	Tunnel Name Regular Expression
                                                                                	**type**\:  :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                
                                                                                .. attribute:: user_name
                                                                                
                                                                                	User Name
                                                                                	**type**\:  :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                
                                                                                .. attribute:: user_name_regex
                                                                                
                                                                                	User Name Regular Expression
                                                                                	**type**\:  :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                
                                                                                .. attribute:: auth_username
                                                                                
                                                                                	Authenticated User Name
                                                                                	**type**\:  :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                
                                                                                .. attribute:: auth_username_regex
                                                                                
                                                                                	Authenticated User Name RegEx
                                                                                	**type**\:  :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                
                                                                                .. attribute:: unauth_username
                                                                                
                                                                                	Unauthenticated User Name
                                                                                	**type**\:  :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                
                                                                                .. attribute:: unauth_username_regex
                                                                                
                                                                                	Unauthenticated User Name RegEx
                                                                                	**type**\:  :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                
                                                                                .. attribute:: auth_domain
                                                                                
                                                                                	Authenticated domain name
                                                                                	**type**\:  :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                
                                                                                .. attribute:: auth_domain_regex
                                                                                
                                                                                	Authenticated Domain Name RegEx
                                                                                	**type**\:  :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                
                                                                                .. attribute:: unauth_domain
                                                                                
                                                                                	Unauthenticated Domain Name
                                                                                	**type**\:  :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                
                                                                                .. attribute:: unauth_domain_regex
                                                                                
                                                                                	Unauthenticated Domain Name RegEx
                                                                                	**type**\:  :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                
                                                                                .. attribute:: vendor_id
                                                                                
                                                                                	Vendor ID
                                                                                	**type**\:  :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                
                                                                                .. attribute:: vendor_id_regex
                                                                                
                                                                                	Vendor ID RegEx
                                                                                	**type**\:  :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                
                                                                                .. attribute:: access_interface
                                                                                
                                                                                	Access interface
                                                                                	**type**\:  :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                
                                                                                .. attribute:: input_interface
                                                                                
                                                                                	Input interface
                                                                                	**type**\:  :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                
                                                                                .. attribute:: input_intfhdl
                                                                                
                                                                                	Input interface handle
                                                                                	**type**\:  :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                
                                                                                .. attribute:: ethertype
                                                                                
                                                                                	Ethernet type
                                                                                	**type**\:  :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                
                                                                                .. attribute:: flow_key_data
                                                                                
                                                                                	Flow key structure
                                                                                	**type**\:  :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                
                                                                                .. attribute:: dhcp_client_id
                                                                                
                                                                                	Dhcp Client ID
                                                                                	**type**\:  :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                
                                                                                .. attribute:: dhcp_client_id_regex
                                                                                
                                                                                	Dhcp Client ID RegEx
                                                                                	**type**\:  :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                
                                                                                .. attribute:: circuit_id
                                                                                
                                                                                	Circuit ID
                                                                                	**type**\:  :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                
                                                                                .. attribute:: circuit_id_regex
                                                                                
                                                                                	Circuit ID RegEx
                                                                                	**type**\:  :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                
                                                                                .. attribute:: remote_id
                                                                                
                                                                                	Remote ID
                                                                                	**type**\:  :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                
                                                                                .. attribute:: remote_id_regex
                                                                                
                                                                                	Remote ID RegEx
                                                                                	**type**\:  :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                
                                                                                .. attribute:: src_port
                                                                                
                                                                                	Source port
                                                                                	**type**\:  :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                
                                                                                .. attribute:: dst_port
                                                                                
                                                                                	Destination port
                                                                                	**type**\:  :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:  :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                
                                                                                .. attribute:: mpls_top_eos
                                                                                
                                                                                	MPLS Topmost EOS
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: fragment_type
                                                                                
                                                                                	Fragment type
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: authen_status
                                                                                
                                                                                	Authentication Status
                                                                                	**type**\:  :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                
                                                                                .. attribute:: mlp_negotiated
                                                                                
                                                                                	MLP Negotiated
                                                                                	**type**\:  :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                    self.yang_name = "match-data"
                                                                                    self.yang_parent_name = "class-match-info-st"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("ipv4-dscp", ("ipv4_dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp)), ("ipv6-dscp", ("ipv6_dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp)), ("dscp", ("dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp)), ("ipv4-prec", ("ipv4_prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec)), ("ipv6-prec", ("ipv6_prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec)), ("prec", ("prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec)), ("discard-class", ("discard_class", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass)), ("qos-group", ("qos_group", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup)), ("traffic-class", ("traffic_class", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass)), ("proto", ("proto", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto)), ("icmp-v4", ("icmp_v4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4)), ("icmp-v6", ("icmp_v6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6)), ("ipv4-packet-len", ("ipv4_packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen)), ("ipv6-packet-len", ("ipv6_packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen)), ("packet-len", ("packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen)), ("flow-tag", ("flow_tag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag)), ("tcp-flag", ("tcp_flag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag)), ("icmpv4-type", ("icmpv4_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type)), ("icmpv4-code", ("icmpv4_code", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code)), ("icmpv6-type", ("icmpv6_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type)), ("icmpv6-code", ("icmpv6_code", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code)), ("mpls-exp", ("mpls_exp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp)), ("mpls-exp-imp", ("mpls_exp_imp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp)), ("mpls-disp-ipv4-acl", ("mpls_disp_ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl)), ("mpls-disp-ipv6-acl", ("mpls_disp_ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl)), ("mpls-top-label", ("mpls_top_label", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel)), ("cos", ("cos", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos)), ("cos-inr", ("cos_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr)), ("dei", ("dei", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei)), ("dei-inr", ("dei_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr)), ("vlan", ("vlan", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan)), ("vlan-inr", ("vlan_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)), ("fr-dlci", ("fr_dlci", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci)), ("src-mac", ("src_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac)), ("dst-mac", ("dst_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac)), ("atm-clp", ("atm_clp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp)), ("fr-de", ("fr_de", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe)), ("ipv4-acl", ("ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl)), ("ipv6-acl", ("ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl)), ("ether-service-acl", ("ether_service_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl)), ("avail-id", ("avail_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId)), ("media-type", ("media_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType)), ("subs-protocol", ("subs_protocol", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol)), ("dnis", ("dnis", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis)), ("dnis-regex", ("dnis_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex)), ("domain", ("domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain)), ("domain-regex", ("domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex)), ("nas-port", ("nas_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort)), ("service-name", ("service_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName)), ("service-name-regex", ("service_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex)), ("src-addr-ipv4", ("src_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4)), ("dst-addr-ipv4", ("dst_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4)), ("src-addr-ipv6", ("src_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6)), ("dst-addr-ipv6", ("dst_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6)), ("src-addr-mac", ("src_addr_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac)), ("timer", ("timer", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer)), ("timer-regexp", ("timer_regexp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp)), ("tunnel-name", ("tunnel_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName)), ("tunnel-name-regex", ("tunnel_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex)), ("user-name", ("user_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName)), ("user-name-regex", ("user_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex)), ("auth-username", ("auth_username", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername)), ("auth-username-regex", ("auth_username_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex)), ("unauth-username", ("unauth_username", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername)), ("unauth-username-regex", ("unauth_username_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex)), ("auth-domain", ("auth_domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain)), ("auth-domain-regex", ("auth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex)), ("unauth-domain", ("unauth_domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain)), ("unauth-domain-regex", ("unauth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex)), ("vendor-id", ("vendor_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId)), ("vendor-id-regex", ("vendor_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex)), ("access-interface", ("access_interface", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface)), ("input-interface", ("input_interface", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface)), ("input-intfhdl", ("input_intfhdl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl)), ("ethertype", ("ethertype", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype)), ("flow-key-data", ("flow_key_data", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData)), ("dhcp-client-id", ("dhcp_client_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId)), ("dhcp-client-id-regex", ("dhcp_client_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex)), ("circuit-id", ("circuit_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId)), ("circuit-id-regex", ("circuit_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex)), ("remote-id", ("remote_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId)), ("remote-id-regex", ("remote_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex)), ("src-port", ("src_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort)), ("dst-port", ("dst_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchTypeEn', '')])),
                                                                                        ('mpls_top_eos', (YLeaf(YType.uint8, 'mpls-top-eos'), ['int'])),
                                                                                        ('fragment_type', (YLeaf(YType.uint8, 'fragment-type'), ['int'])),
                                                                                        ('authen_status', (YLeaf(YType.enumeration, 'authen-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchAuthenStatusEn', '')])),
                                                                                        ('mlp_negotiated', (YLeaf(YType.enumeration, 'mlp-negotiated'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchMlpNegotiatedEn', '')])),
                                                                                    ])
                                                                                    self.type = None
                                                                                    self.mpls_top_eos = None
                                                                                    self.fragment_type = None
                                                                                    self.authen_status = None
                                                                                    self.mlp_negotiated = None

                                                                                    self.ipv4_dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                    self.ipv4_dscp.parent = self
                                                                                    self._children_name_map["ipv4_dscp"] = "ipv4-dscp"

                                                                                    self.ipv6_dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                    self.ipv6_dscp.parent = self
                                                                                    self._children_name_map["ipv6_dscp"] = "ipv6-dscp"

                                                                                    self.dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                    self.dscp.parent = self
                                                                                    self._children_name_map["dscp"] = "dscp"

                                                                                    self.ipv4_prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                    self.ipv4_prec.parent = self
                                                                                    self._children_name_map["ipv4_prec"] = "ipv4-prec"

                                                                                    self.ipv6_prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                    self.ipv6_prec.parent = self
                                                                                    self._children_name_map["ipv6_prec"] = "ipv6-prec"

                                                                                    self.prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                    self.prec.parent = self
                                                                                    self._children_name_map["prec"] = "prec"

                                                                                    self.discard_class = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                    self.discard_class.parent = self
                                                                                    self._children_name_map["discard_class"] = "discard-class"

                                                                                    self.qos_group = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                    self.qos_group.parent = self
                                                                                    self._children_name_map["qos_group"] = "qos-group"

                                                                                    self.traffic_class = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                    self.traffic_class.parent = self
                                                                                    self._children_name_map["traffic_class"] = "traffic-class"

                                                                                    self.proto = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                    self.proto.parent = self
                                                                                    self._children_name_map["proto"] = "proto"

                                                                                    self.icmp_v4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                    self.icmp_v4.parent = self
                                                                                    self._children_name_map["icmp_v4"] = "icmp-v4"

                                                                                    self.icmp_v6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                    self.icmp_v6.parent = self
                                                                                    self._children_name_map["icmp_v6"] = "icmp-v6"

                                                                                    self.ipv4_packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                    self.ipv4_packet_len.parent = self
                                                                                    self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"

                                                                                    self.ipv6_packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                    self.ipv6_packet_len.parent = self
                                                                                    self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"

                                                                                    self.packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                    self.packet_len.parent = self
                                                                                    self._children_name_map["packet_len"] = "packet-len"

                                                                                    self.flow_tag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                    self.flow_tag.parent = self
                                                                                    self._children_name_map["flow_tag"] = "flow-tag"

                                                                                    self.tcp_flag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                    self.tcp_flag.parent = self
                                                                                    self._children_name_map["tcp_flag"] = "tcp-flag"

                                                                                    self.icmpv4_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                    self.icmpv4_type.parent = self
                                                                                    self._children_name_map["icmpv4_type"] = "icmpv4-type"

                                                                                    self.icmpv4_code = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                    self.icmpv4_code.parent = self
                                                                                    self._children_name_map["icmpv4_code"] = "icmpv4-code"

                                                                                    self.icmpv6_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                    self.icmpv6_type.parent = self
                                                                                    self._children_name_map["icmpv6_type"] = "icmpv6-type"

                                                                                    self.icmpv6_code = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                    self.icmpv6_code.parent = self
                                                                                    self._children_name_map["icmpv6_code"] = "icmpv6-code"

                                                                                    self.mpls_exp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                    self.mpls_exp.parent = self
                                                                                    self._children_name_map["mpls_exp"] = "mpls-exp"

                                                                                    self.mpls_exp_imp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                    self.mpls_exp_imp.parent = self
                                                                                    self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"

                                                                                    self.mpls_disp_ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                    self.mpls_disp_ipv4_acl.parent = self
                                                                                    self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"

                                                                                    self.mpls_disp_ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                    self.mpls_disp_ipv6_acl.parent = self
                                                                                    self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"

                                                                                    self.mpls_top_label = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                    self.mpls_top_label.parent = self
                                                                                    self._children_name_map["mpls_top_label"] = "mpls-top-label"

                                                                                    self.cos = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                    self.cos.parent = self
                                                                                    self._children_name_map["cos"] = "cos"

                                                                                    self.cos_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                    self.cos_inr.parent = self
                                                                                    self._children_name_map["cos_inr"] = "cos-inr"

                                                                                    self.dei = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                    self.dei.parent = self
                                                                                    self._children_name_map["dei"] = "dei"

                                                                                    self.dei_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                    self.dei_inr.parent = self
                                                                                    self._children_name_map["dei_inr"] = "dei-inr"

                                                                                    self.vlan = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                    self.vlan.parent = self
                                                                                    self._children_name_map["vlan"] = "vlan"

                                                                                    self.vlan_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                    self.vlan_inr.parent = self
                                                                                    self._children_name_map["vlan_inr"] = "vlan-inr"

                                                                                    self.fr_dlci = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                    self.fr_dlci.parent = self
                                                                                    self._children_name_map["fr_dlci"] = "fr-dlci"

                                                                                    self.src_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                    self.src_mac.parent = self
                                                                                    self._children_name_map["src_mac"] = "src-mac"

                                                                                    self.dst_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                    self.dst_mac.parent = self
                                                                                    self._children_name_map["dst_mac"] = "dst-mac"

                                                                                    self.atm_clp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                    self.atm_clp.parent = self
                                                                                    self._children_name_map["atm_clp"] = "atm-clp"

                                                                                    self.fr_de = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                    self.fr_de.parent = self
                                                                                    self._children_name_map["fr_de"] = "fr-de"

                                                                                    self.ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                    self.ipv4_acl.parent = self
                                                                                    self._children_name_map["ipv4_acl"] = "ipv4-acl"

                                                                                    self.ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                    self.ipv6_acl.parent = self
                                                                                    self._children_name_map["ipv6_acl"] = "ipv6-acl"

                                                                                    self.ether_service_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                    self.ether_service_acl.parent = self
                                                                                    self._children_name_map["ether_service_acl"] = "ether-service-acl"

                                                                                    self.avail_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                    self.avail_id.parent = self
                                                                                    self._children_name_map["avail_id"] = "avail-id"

                                                                                    self.media_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                    self.media_type.parent = self
                                                                                    self._children_name_map["media_type"] = "media-type"

                                                                                    self.subs_protocol = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                    self.subs_protocol.parent = self
                                                                                    self._children_name_map["subs_protocol"] = "subs-protocol"

                                                                                    self.dnis = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                    self.dnis.parent = self
                                                                                    self._children_name_map["dnis"] = "dnis"

                                                                                    self.dnis_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                    self.dnis_regex.parent = self
                                                                                    self._children_name_map["dnis_regex"] = "dnis-regex"

                                                                                    self.domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                    self.domain.parent = self
                                                                                    self._children_name_map["domain"] = "domain"

                                                                                    self.domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                    self.domain_regex.parent = self
                                                                                    self._children_name_map["domain_regex"] = "domain-regex"

                                                                                    self.nas_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                    self.nas_port.parent = self
                                                                                    self._children_name_map["nas_port"] = "nas-port"

                                                                                    self.service_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                    self.service_name.parent = self
                                                                                    self._children_name_map["service_name"] = "service-name"

                                                                                    self.service_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                    self.service_name_regex.parent = self
                                                                                    self._children_name_map["service_name_regex"] = "service-name-regex"

                                                                                    self.src_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                    self.src_addr_ipv4.parent = self
                                                                                    self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"

                                                                                    self.dst_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                    self.dst_addr_ipv4.parent = self
                                                                                    self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"

                                                                                    self.src_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                    self.src_addr_ipv6.parent = self
                                                                                    self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"

                                                                                    self.dst_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                    self.dst_addr_ipv6.parent = self
                                                                                    self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"

                                                                                    self.src_addr_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                    self.src_addr_mac.parent = self
                                                                                    self._children_name_map["src_addr_mac"] = "src-addr-mac"

                                                                                    self.timer = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                    self.timer.parent = self
                                                                                    self._children_name_map["timer"] = "timer"

                                                                                    self.timer_regexp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                    self.timer_regexp.parent = self
                                                                                    self._children_name_map["timer_regexp"] = "timer-regexp"

                                                                                    self.tunnel_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                    self.tunnel_name.parent = self
                                                                                    self._children_name_map["tunnel_name"] = "tunnel-name"

                                                                                    self.tunnel_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                    self.tunnel_name_regex.parent = self
                                                                                    self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"

                                                                                    self.user_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                    self.user_name.parent = self
                                                                                    self._children_name_map["user_name"] = "user-name"

                                                                                    self.user_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                    self.user_name_regex.parent = self
                                                                                    self._children_name_map["user_name_regex"] = "user-name-regex"

                                                                                    self.auth_username = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                    self.auth_username.parent = self
                                                                                    self._children_name_map["auth_username"] = "auth-username"

                                                                                    self.auth_username_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                    self.auth_username_regex.parent = self
                                                                                    self._children_name_map["auth_username_regex"] = "auth-username-regex"

                                                                                    self.unauth_username = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                    self.unauth_username.parent = self
                                                                                    self._children_name_map["unauth_username"] = "unauth-username"

                                                                                    self.unauth_username_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                    self.unauth_username_regex.parent = self
                                                                                    self._children_name_map["unauth_username_regex"] = "unauth-username-regex"

                                                                                    self.auth_domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                    self.auth_domain.parent = self
                                                                                    self._children_name_map["auth_domain"] = "auth-domain"

                                                                                    self.auth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                    self.auth_domain_regex.parent = self
                                                                                    self._children_name_map["auth_domain_regex"] = "auth-domain-regex"

                                                                                    self.unauth_domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                    self.unauth_domain.parent = self
                                                                                    self._children_name_map["unauth_domain"] = "unauth-domain"

                                                                                    self.unauth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                    self.unauth_domain_regex.parent = self
                                                                                    self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"

                                                                                    self.vendor_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                    self.vendor_id.parent = self
                                                                                    self._children_name_map["vendor_id"] = "vendor-id"

                                                                                    self.vendor_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                    self.vendor_id_regex.parent = self
                                                                                    self._children_name_map["vendor_id_regex"] = "vendor-id-regex"

                                                                                    self.access_interface = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                    self.access_interface.parent = self
                                                                                    self._children_name_map["access_interface"] = "access-interface"

                                                                                    self.input_interface = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                    self.input_interface.parent = self
                                                                                    self._children_name_map["input_interface"] = "input-interface"

                                                                                    self.input_intfhdl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                    self.input_intfhdl.parent = self
                                                                                    self._children_name_map["input_intfhdl"] = "input-intfhdl"

                                                                                    self.ethertype = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                    self.ethertype.parent = self
                                                                                    self._children_name_map["ethertype"] = "ethertype"

                                                                                    self.flow_key_data = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                    self.flow_key_data.parent = self
                                                                                    self._children_name_map["flow_key_data"] = "flow-key-data"

                                                                                    self.dhcp_client_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                    self.dhcp_client_id.parent = self
                                                                                    self._children_name_map["dhcp_client_id"] = "dhcp-client-id"

                                                                                    self.dhcp_client_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                    self.dhcp_client_id_regex.parent = self
                                                                                    self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"

                                                                                    self.circuit_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                    self.circuit_id.parent = self
                                                                                    self._children_name_map["circuit_id"] = "circuit-id"

                                                                                    self.circuit_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                    self.circuit_id_regex.parent = self
                                                                                    self._children_name_map["circuit_id_regex"] = "circuit-id-regex"

                                                                                    self.remote_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                    self.remote_id.parent = self
                                                                                    self._children_name_map["remote_id"] = "remote-id"

                                                                                    self.remote_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                    self.remote_id_regex.parent = self
                                                                                    self._children_name_map["remote_id_regex"] = "remote-id-regex"

                                                                                    self.src_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                    self.src_port.parent = self
                                                                                    self._children_name_map["src_port"] = "src-port"

                                                                                    self.dst_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                    self.dst_port.parent = self
                                                                                    self._children_name_map["dst_port"] = "dst-port"
                                                                                    self._segment_path = lambda: "match-data"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['type', 'mpls_top_eos', 'fragment_type', 'authen_status', 'mlp_negotiated'], name, value)


                                                                                class Ipv4Dscp(Entity):
                                                                                    """
                                                                                    IPv4 DSCP
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                        self.yang_name = "ipv4-dscp"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "ipv4-dscp"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "ipv4-dscp"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                class Ipv6Dscp(Entity):
                                                                                    """
                                                                                    IPv6 DSCP
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                        self.yang_name = "ipv6-dscp"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "ipv6-dscp"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "ipv6-dscp"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                class Dscp(Entity):
                                                                                    """
                                                                                    Match DSCP range array
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                        self.yang_name = "dscp"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "dscp"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "dscp"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                class Ipv4Prec(Entity):
                                                                                    """
                                                                                    IPv4 Precedence
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                        self.yang_name = "ipv4-prec"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                        ])
                                                                                        self.uint8_array = []
                                                                                        self._segment_path = lambda: "ipv4-prec"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                class Ipv6Prec(Entity):
                                                                                    """
                                                                                    IPv6 Precedence
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                        self.yang_name = "ipv6-prec"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                        ])
                                                                                        self.uint8_array = []
                                                                                        self._segment_path = lambda: "ipv6-prec"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                class Prec(Entity):
                                                                                    """
                                                                                    Match Precedence array
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                        self.yang_name = "prec"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                        ])
                                                                                        self.uint8_array = []
                                                                                        self._segment_path = lambda: "prec"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                class DiscardClass(Entity):
                                                                                    """
                                                                                    Match Discard Class array
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                        self.yang_name = "discard-class"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                        ])
                                                                                        self.uint8_array = []
                                                                                        self._segment_path = lambda: "discard-class"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                class QosGroup(Entity):
                                                                                    """
                                                                                    Match QoS group array
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                        self.yang_name = "qos-group"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "qos-group"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "qos-group"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['min', 'max'], name, value)


                                                                                class TrafficClass(Entity):
                                                                                    """
                                                                                    Match Traffic class array
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                        self.yang_name = "traffic-class"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "traffic-class"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "traffic-class"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['min', 'max'], name, value)


                                                                                class Proto(Entity):
                                                                                    """
                                                                                    Match Protocol array
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                        self.yang_name = "proto"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "proto"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "proto"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['min', 'max'], name, value)


                                                                                class IcmpV4(Entity):
                                                                                    """
                                                                                    Match ICMPV4 Protocol
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	Protocol type
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: code
                                                                                    
                                                                                    	Protocol code
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                        self.yang_name = "icmp-v4"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                            ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                        ])
                                                                                        self.type = None
                                                                                        self.code = None
                                                                                        self._segment_path = lambda: "icmp-v4"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['type', 'code'], name, value)


                                                                                class IcmpV6(Entity):
                                                                                    """
                                                                                    Match ICMPV6 Protocol array
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	Protocol type
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: code
                                                                                    
                                                                                    	Protocol code
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                        self.yang_name = "icmp-v6"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                            ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                        ])
                                                                                        self.type = None
                                                                                        self.code = None
                                                                                        self._segment_path = lambda: "icmp-v6"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['type', 'code'], name, value)


                                                                                class Ipv4PacketLen(Entity):
                                                                                    """
                                                                                    IPv4 packet length array
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                        self.yang_name = "ipv4-packet-len"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "ipv4-packet-len"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "ipv4-packet-len"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                class Ipv6PacketLen(Entity):
                                                                                    """
                                                                                    IPv6 packet length array
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                        self.yang_name = "ipv6-packet-len"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "ipv6-packet-len"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "ipv6-packet-len"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                class PacketLen(Entity):
                                                                                    """
                                                                                    Match packet length array
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                        self.yang_name = "packet-len"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "packet-len"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "packet-len"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                class FlowTag(Entity):
                                                                                    """
                                                                                    Match flow\-tag array
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                        self.yang_name = "flow-tag"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "flow-tag"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "flow-tag"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['min', 'max'], name, value)


                                                                                class TcpFlag(Entity):
                                                                                    """
                                                                                    Match tcp flag value
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	Value of TCP flag
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: match_any
                                                                                    
                                                                                    	Match any TCP flag bit
                                                                                    	**type**\: bool
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                        self.yang_name = "tcp-flag"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                            ('match_any', (YLeaf(YType.boolean, 'match-any'), ['bool'])),
                                                                                        ])
                                                                                        self.value = None
                                                                                        self.match_any = None
                                                                                        self._segment_path = lambda: "tcp-flag"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['value', 'match_any'], name, value)


                                                                                class Icmpv4Type(Entity):
                                                                                    """
                                                                                    Match ipv4 icmp type
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                        self.yang_name = "icmpv4-type"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "icmpv4-type"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "icmpv4-type"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                class Icmpv4Code(Entity):
                                                                                    """
                                                                                    Match ipv4 icmp code
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                        self.yang_name = "icmpv4-code"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "icmpv4-code"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "icmpv4-code"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                class Icmpv6Type(Entity):
                                                                                    """
                                                                                    Match ipv6 icmp type
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                        self.yang_name = "icmpv6-type"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "icmpv6-type"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "icmpv6-type"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                class Icmpv6Code(Entity):
                                                                                    """
                                                                                    Match ipv6 icmp code
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                        self.yang_name = "icmpv6-code"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "icmpv6-code"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "icmpv6-code"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                class MplsExp(Entity):
                                                                                    """
                                                                                    Match MPLS experimental topmost array
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                        self.yang_name = "mpls-exp"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                        ])
                                                                                        self.uint8_array = []
                                                                                        self._segment_path = lambda: "mpls-exp"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                class MplsExpImp(Entity):
                                                                                    """
                                                                                    Match MPLS experimental imposition array
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                        self.yang_name = "mpls-exp-imp"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                        ])
                                                                                        self.uint8_array = []
                                                                                        self._segment_path = lambda: "mpls-exp-imp"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                class MplsDispIpv4Acl(Entity):
                                                                                    """
                                                                                    MPLS Disposition IPv4 Access\-list
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                        self.yang_name = "mpls-disp-ipv4-acl"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "mpls-disp-ipv4-acl"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                class MplsDispIpv6Acl(Entity):
                                                                                    """
                                                                                    MPLS Disposition IPv6 Access\-list
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                        self.yang_name = "mpls-disp-ipv6-acl"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "mpls-disp-ipv6-acl"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                class MplsTopLabel(Entity):
                                                                                    """
                                                                                    MPLS Topmost LABEL
                                                                                    
                                                                                    .. attribute:: uint32_rng_array
                                                                                    
                                                                                    	uint32 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                        self.yang_name = "mpls-top-label"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint32_rng_array", ("uint32_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint32_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "mpls-top-label"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                    class Uint32RngArray(Entity):
                                                                                        """
                                                                                        uint32 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                            self.yang_name = "uint32_rng_array"
                                                                                            self.yang_parent_name = "mpls-top-label"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint32, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint32, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint32_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['min', 'max'], name, value)


                                                                                class Cos(Entity):
                                                                                    """
                                                                                    Match CoS array
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                        self.yang_name = "cos"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                        ])
                                                                                        self.uint8_array = []
                                                                                        self._segment_path = lambda: "cos"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                class CosInr(Entity):
                                                                                    """
                                                                                    Match inner header CoS
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                        self.yang_name = "cos-inr"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                        ])
                                                                                        self.uint8_array = []
                                                                                        self._segment_path = lambda: "cos-inr"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                class Dei(Entity):
                                                                                    """
                                                                                    Match DEI Bit
                                                                                    
                                                                                    .. attribute:: bit_value
                                                                                    
                                                                                    	Value of the DEI bit
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                        self.yang_name = "dei"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                        ])
                                                                                        self.bit_value = None
                                                                                        self._segment_path = lambda: "dei"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                class DeiInr(Entity):
                                                                                    """
                                                                                    Match inner DEI Bit
                                                                                    
                                                                                    .. attribute:: bit_value
                                                                                    
                                                                                    	Value of the DEI bit
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                        self.yang_name = "dei-inr"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                        ])
                                                                                        self.bit_value = None
                                                                                        self._segment_path = lambda: "dei-inr"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                class Vlan(Entity):
                                                                                    """
                                                                                    Match VLAN array
                                                                                    
                                                                                    .. attribute:: vlan_id_array
                                                                                    
                                                                                    	vlan id array
                                                                                    	**type**\: list of  		 :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                        self.yang_name = "vlan"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("vlan-id-array", ("vlan_id_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.vlan_id_array = YList(self)
                                                                                        self._segment_path = lambda: "vlan"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                    class VlanIdArray(Entity):
                                                                                        """
                                                                                        vlan id array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: mask
                                                                                        
                                                                                        	VLAN mask
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                            self.yang_name = "vlan-id-array"
                                                                                            self.yang_parent_name = "vlan"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                ('mask', (YLeaf(YType.uint16, 'mask'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self.mask = None
                                                                                            self._segment_path = lambda: "vlan-id-array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['min', 'max', 'mask'], name, value)


                                                                                class VlanInr(Entity):
                                                                                    """
                                                                                    Match inner header VLAN range array
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                        self.yang_name = "vlan-inr"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "vlan-inr"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "vlan-inr"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['min', 'max'], name, value)


                                                                                class FrDlci(Entity):
                                                                                    """
                                                                                    Match FR DLCI range array
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                        self.yang_name = "fr-dlci"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "fr-dlci"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "fr-dlci"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['min', 'max'], name, value)


                                                                                class SrcMac(Entity):
                                                                                    """
                                                                                    Match Source MAC address
                                                                                    
                                                                                    .. attribute:: mac_addr
                                                                                    
                                                                                    	MAC address
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	MAC mask
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                        self.yang_name = "src-mac"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                            ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                        ])
                                                                                        self.mac_addr = []
                                                                                        self.mask = []
                                                                                        self._segment_path = lambda: "src-mac"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                class DstMac(Entity):
                                                                                    """
                                                                                    Match Destination MAC address
                                                                                    
                                                                                    .. attribute:: mac_addr
                                                                                    
                                                                                    	MAC address
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	MAC mask
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                        self.yang_name = "dst-mac"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                            ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                        ])
                                                                                        self.mac_addr = []
                                                                                        self.mask = []
                                                                                        self._segment_path = lambda: "dst-mac"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                class AtmClp(Entity):
                                                                                    """
                                                                                    Match ATM CLP level
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                        self.yang_name = "atm-clp"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                        ])
                                                                                        self.uint8_array = []
                                                                                        self._segment_path = lambda: "atm-clp"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                class FrDe(Entity):
                                                                                    """
                                                                                    Match FR DE value
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                        self.yang_name = "fr-de"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                        ])
                                                                                        self.uint8_array = []
                                                                                        self._segment_path = lambda: "fr-de"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                class Ipv4Acl(Entity):
                                                                                    """
                                                                                    IPv4 Access\-list
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                        self.yang_name = "ipv4-acl"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "ipv4-acl"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                class Ipv6Acl(Entity):
                                                                                    """
                                                                                    IPv6 Access\-list
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                        self.yang_name = "ipv6-acl"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "ipv6-acl"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                class EtherServiceAcl(Entity):
                                                                                    """
                                                                                    Ethernet\-Services Access\-list
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                        self.yang_name = "ether-service-acl"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "ether-service-acl"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                class AvailId(Entity):
                                                                                    """
                                                                                    Available Identifiers
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                        self.yang_name = "avail-id"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                        ])
                                                                                        self.uint8_array = []
                                                                                        self._segment_path = lambda: "avail-id"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                class MediaType(Entity):
                                                                                    """
                                                                                    Media Type
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                        self.yang_name = "media-type"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                        ])
                                                                                        self.uint8_array = []
                                                                                        self._segment_path = lambda: "media-type"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                class SubsProtocol(Entity):
                                                                                    """
                                                                                    Protocol
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                        self.yang_name = "subs-protocol"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                        ])
                                                                                        self.uint8_array = []
                                                                                        self._segment_path = lambda: "subs-protocol"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                class Dnis(Entity):
                                                                                    """
                                                                                    DNIS
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                        self.yang_name = "dnis"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "dnis"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                class DnisRegex(Entity):
                                                                                    """
                                                                                    DNIS Regular Expression
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                        self.yang_name = "dnis-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "dnis-regex"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                class Domain(Entity):
                                                                                    """
                                                                                    Domain Name
                                                                                    
                                                                                    .. attribute:: domain_array
                                                                                    
                                                                                    	domain array
                                                                                    	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                        self.yang_name = "domain"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.domain_array = YList(self)
                                                                                        self._segment_path = lambda: "domain"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                    class DomainArray(Entity):
                                                                                        """
                                                                                        domain array
                                                                                        
                                                                                        .. attribute:: domain_name
                                                                                        
                                                                                        	domain name
                                                                                        	**type**\: str
                                                                                        
                                                                                        .. attribute:: format_name
                                                                                        
                                                                                        	format name
                                                                                        	**type**\: str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                            self.yang_name = "domain-array"
                                                                                            self.yang_parent_name = "domain"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                            ])
                                                                                            self.domain_name = None
                                                                                            self.format_name = None
                                                                                            self._segment_path = lambda: "domain-array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                class DomainRegex(Entity):
                                                                                    """
                                                                                    Domain Regular Expression
                                                                                    
                                                                                    .. attribute:: domain_array
                                                                                    
                                                                                    	domain array
                                                                                    	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                        self.yang_name = "domain-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.domain_array = YList(self)
                                                                                        self._segment_path = lambda: "domain-regex"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                    class DomainArray(Entity):
                                                                                        """
                                                                                        domain array
                                                                                        
                                                                                        .. attribute:: domain_name
                                                                                        
                                                                                        	domain name
                                                                                        	**type**\: str
                                                                                        
                                                                                        .. attribute:: format_name
                                                                                        
                                                                                        	format name
                                                                                        	**type**\: str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                            self.yang_name = "domain-array"
                                                                                            self.yang_parent_name = "domain-regex"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                            ])
                                                                                            self.domain_name = None
                                                                                            self.format_name = None
                                                                                            self._segment_path = lambda: "domain-array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                class NasPort(Entity):
                                                                                    """
                                                                                    NAS Port
                                                                                    
                                                                                    .. attribute:: nas_port_array
                                                                                    
                                                                                    	nas port array
                                                                                    	**type**\: list of  		 :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                        self.yang_name = "nas-port"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("nas-port-array", ("nas_port_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.nas_port_array = YList(self)
                                                                                        self._segment_path = lambda: "nas-port"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                    class NasPortArray(Entity):
                                                                                        """
                                                                                        nas port array
                                                                                        
                                                                                        .. attribute:: sub_id
                                                                                        
                                                                                        	sub id
                                                                                        	**type**\:  :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                        
                                                                                        .. attribute:: operator
                                                                                        
                                                                                        	operator
                                                                                        	**type**\:  :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                        
                                                                                        .. attribute:: value
                                                                                        
                                                                                        	value
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                            self.yang_name = "nas-port-array"
                                                                                            self.yang_parent_name = "nas-port"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('sub_id', (YLeaf(YType.enumeration, 'sub-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchNasPortSubIdEn', '')])),
                                                                                                ('operator', (YLeaf(YType.enumeration, 'operator'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchLogicalOperatorEn', '')])),
                                                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                            ])
                                                                                            self.sub_id = None
                                                                                            self.operator = None
                                                                                            self.value = None
                                                                                            self._segment_path = lambda: "nas-port-array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['sub_id', 'operator', 'value'], name, value)


                                                                                class ServiceName(Entity):
                                                                                    """
                                                                                    Service Name
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                        self.yang_name = "service-name"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "service-name"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                class ServiceNameRegex(Entity):
                                                                                    """
                                                                                    Service Name Regular Exp
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                        self.yang_name = "service-name-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "service-name-regex"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                class SrcAddrIpv4(Entity):
                                                                                    """
                                                                                    Source Address IPV4
                                                                                    
                                                                                    .. attribute:: ipv4_addr_array
                                                                                    
                                                                                    	ipv4 addr array
                                                                                    	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                        self.yang_name = "src-addr-ipv4"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.ipv4_addr_array = YList(self)
                                                                                        self._segment_path = lambda: "src-addr-ipv4"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                    class Ipv4AddrArray(Entity):
                                                                                        """
                                                                                        ipv4 addr array
                                                                                        
                                                                                        .. attribute:: prefix
                                                                                        
                                                                                        	prefix
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                        
                                                                                        .. attribute:: mask
                                                                                        
                                                                                        	mask
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                            self.yang_name = "ipv4-addr-array"
                                                                                            self.yang_parent_name = "src-addr-ipv4"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                            ])
                                                                                            self.prefix = None
                                                                                            self.mask = None
                                                                                            self._segment_path = lambda: "ipv4-addr-array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                class DstAddrIpv4(Entity):
                                                                                    """
                                                                                    Destination Address IPV4
                                                                                    
                                                                                    .. attribute:: ipv4_addr_array
                                                                                    
                                                                                    	ipv4 addr array
                                                                                    	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                        self.yang_name = "dst-addr-ipv4"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.ipv4_addr_array = YList(self)
                                                                                        self._segment_path = lambda: "dst-addr-ipv4"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                    class Ipv4AddrArray(Entity):
                                                                                        """
                                                                                        ipv4 addr array
                                                                                        
                                                                                        .. attribute:: prefix
                                                                                        
                                                                                        	prefix
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                        
                                                                                        .. attribute:: mask
                                                                                        
                                                                                        	mask
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                            self.yang_name = "ipv4-addr-array"
                                                                                            self.yang_parent_name = "dst-addr-ipv4"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                            ])
                                                                                            self.prefix = None
                                                                                            self.mask = None
                                                                                            self._segment_path = lambda: "ipv4-addr-array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                class SrcAddrIpv6(Entity):
                                                                                    """
                                                                                    Source Address IPV6
                                                                                    
                                                                                    .. attribute:: ipv6_addr_array
                                                                                    
                                                                                    	ipv6 addr array
                                                                                    	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                        self.yang_name = "src-addr-ipv6"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.ipv6_addr_array = YList(self)
                                                                                        self._segment_path = lambda: "src-addr-ipv6"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                    class Ipv6AddrArray(Entity):
                                                                                        """
                                                                                        ipv6 addr array
                                                                                        
                                                                                        .. attribute:: prefix
                                                                                        
                                                                                        	IPV6 prefix
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                        
                                                                                        .. attribute:: mask
                                                                                        
                                                                                        	IPV6 mask
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                            self.yang_name = "ipv6-addr-array"
                                                                                            self.yang_parent_name = "src-addr-ipv6"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                            ])
                                                                                            self.prefix = None
                                                                                            self.mask = None
                                                                                            self._segment_path = lambda: "ipv6-addr-array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                class DstAddrIpv6(Entity):
                                                                                    """
                                                                                    Destination Address IPV6
                                                                                    
                                                                                    .. attribute:: ipv6_addr_array
                                                                                    
                                                                                    	ipv6 addr array
                                                                                    	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                        self.yang_name = "dst-addr-ipv6"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.ipv6_addr_array = YList(self)
                                                                                        self._segment_path = lambda: "dst-addr-ipv6"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                    class Ipv6AddrArray(Entity):
                                                                                        """
                                                                                        ipv6 addr array
                                                                                        
                                                                                        .. attribute:: prefix
                                                                                        
                                                                                        	IPV6 prefix
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                        
                                                                                        .. attribute:: mask
                                                                                        
                                                                                        	IPV6 mask
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                            self.yang_name = "ipv6-addr-array"
                                                                                            self.yang_parent_name = "dst-addr-ipv6"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                            ])
                                                                                            self.prefix = None
                                                                                            self.mask = None
                                                                                            self._segment_path = lambda: "ipv6-addr-array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                class SrcAddrMac(Entity):
                                                                                    """
                                                                                    Source Address MAC
                                                                                    
                                                                                    .. attribute:: mac_addr_array
                                                                                    
                                                                                    	mac addr array
                                                                                    	**type**\: list of  		 :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                        self.yang_name = "src-addr-mac"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("mac-addr-array", ("mac_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.mac_addr_array = YList(self)
                                                                                        self._segment_path = lambda: "src-addr-mac"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                    class MacAddrArray(Entity):
                                                                                        """
                                                                                        mac addr array
                                                                                        
                                                                                        .. attribute:: mac_addr
                                                                                        
                                                                                        	MAC address
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: mask
                                                                                        
                                                                                        	MAC mask
                                                                                        	**type**\: list of int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                            self.yang_name = "mac-addr-array"
                                                                                            self.yang_parent_name = "src-addr-mac"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                            ])
                                                                                            self.mac_addr = []
                                                                                            self.mask = []
                                                                                            self._segment_path = lambda: "mac-addr-array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                class Timer(Entity):
                                                                                    """
                                                                                    Timer
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                        self.yang_name = "timer"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "timer"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                class TimerRegexp(Entity):
                                                                                    """
                                                                                    Timer Regular Expression
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                        self.yang_name = "timer-regexp"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "timer-regexp"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                class TunnelName(Entity):
                                                                                    """
                                                                                    Tunnel Name
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                        self.yang_name = "tunnel-name"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "tunnel-name"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                class TunnelNameRegex(Entity):
                                                                                    """
                                                                                    Tunnel Name Regular Expression
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                        self.yang_name = "tunnel-name-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "tunnel-name-regex"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                class UserName(Entity):
                                                                                    """
                                                                                    User Name
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                        self.yang_name = "user-name"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "user-name"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                class UserNameRegex(Entity):
                                                                                    """
                                                                                    User Name Regular Expression
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                        self.yang_name = "user-name-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "user-name-regex"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                class AuthUsername(Entity):
                                                                                    """
                                                                                    Authenticated User Name
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                        self.yang_name = "auth-username"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "auth-username"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                class AuthUsernameRegex(Entity):
                                                                                    """
                                                                                    Authenticated User Name RegEx
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                        self.yang_name = "auth-username-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "auth-username-regex"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                class UnauthUsername(Entity):
                                                                                    """
                                                                                    Unauthenticated User Name
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                        self.yang_name = "unauth-username"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "unauth-username"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                class UnauthUsernameRegex(Entity):
                                                                                    """
                                                                                    Unauthenticated User Name RegEx
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                        self.yang_name = "unauth-username-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "unauth-username-regex"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                class AuthDomain(Entity):
                                                                                    """
                                                                                    Authenticated domain name
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                        self.yang_name = "auth-domain"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "auth-domain"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                class AuthDomainRegex(Entity):
                                                                                    """
                                                                                    Authenticated Domain Name RegEx
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                        self.yang_name = "auth-domain-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "auth-domain-regex"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                class UnauthDomain(Entity):
                                                                                    """
                                                                                    Unauthenticated Domain Name
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                        self.yang_name = "unauth-domain"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "unauth-domain"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                class UnauthDomainRegex(Entity):
                                                                                    """
                                                                                    Unauthenticated Domain Name RegEx
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                        self.yang_name = "unauth-domain-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "unauth-domain-regex"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                class VendorId(Entity):
                                                                                    """
                                                                                    Vendor ID
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                        self.yang_name = "vendor-id"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "vendor-id"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                class VendorIdRegex(Entity):
                                                                                    """
                                                                                    Vendor ID RegEx
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                        self.yang_name = "vendor-id-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "vendor-id-regex"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                class AccessInterface(Entity):
                                                                                    """
                                                                                    Access interface
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                        self.yang_name = "access-interface"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "access-interface"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                class InputInterface(Entity):
                                                                                    """
                                                                                    Input interface
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                        self.yang_name = "input-interface"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "input-interface"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                class InputIntfhdl(Entity):
                                                                                    """
                                                                                    Input interface handle
                                                                                    
                                                                                    .. attribute:: uint64_array
                                                                                    
                                                                                    	uint64 array
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..18446744073709551615
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                        self.yang_name = "input-intfhdl"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('uint64_array', (YLeafList(YType.uint64, 'uint64_array'), ['int'])),
                                                                                        ])
                                                                                        self.uint64_array = []
                                                                                        self._segment_path = lambda: "input-intfhdl"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                class Ethertype(Entity):
                                                                                    """
                                                                                    Ethernet type
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                        self.yang_name = "ethertype"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "ethertype"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "ethertype"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['min', 'max'], name, value)


                                                                                class FlowKeyData(Entity):
                                                                                    """
                                                                                    Flow key structure
                                                                                    
                                                                                    .. attribute:: flow_keys
                                                                                    
                                                                                    	flow keys
                                                                                    	**type**\:  :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                    
                                                                                    .. attribute:: max_count
                                                                                    
                                                                                    	Maximum count of flows
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: idle_timeout
                                                                                    
                                                                                    	Idle timeout of flows (in seconds)
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    	**units**\: second
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                        self.yang_name = "flow-key-data"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("flow-keys", ("flow_keys", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys))])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('max_count', (YLeaf(YType.uint16, 'max-count'), ['int'])),
                                                                                            ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                                        ])
                                                                                        self.max_count = None
                                                                                        self.idle_timeout = None

                                                                                        self.flow_keys = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                        self.flow_keys.parent = self
                                                                                        self._children_name_map["flow_keys"] = "flow-keys"
                                                                                        self._segment_path = lambda: "flow-key-data"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['max_count', 'idle_timeout'], name, value)


                                                                                    class FlowKeys(Entity):
                                                                                        """
                                                                                        flow keys
                                                                                        
                                                                                        .. attribute:: keys
                                                                                        
                                                                                        	keys
                                                                                        	**type**\: str
                                                                                        
                                                                                        	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                        
                                                                                        .. attribute:: num
                                                                                        
                                                                                        	num
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                            self.yang_name = "flow-keys"
                                                                                            self.yang_parent_name = "flow-key-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('keys', (YLeaf(YType.str, 'keys'), ['str'])),
                                                                                                ('num', (YLeaf(YType.uint8, 'num'), ['int'])),
                                                                                            ])
                                                                                            self.keys = None
                                                                                            self.num = None
                                                                                            self._segment_path = lambda: "flow-keys"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                class DhcpClientId(Entity):
                                                                                    """
                                                                                    Dhcp Client ID
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                        self.yang_name = "dhcp-client-id"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "dhcp-client-id"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                class DhcpClientIdRegex(Entity):
                                                                                    """
                                                                                    Dhcp Client ID RegEx
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                        self.yang_name = "dhcp-client-id-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "dhcp-client-id-regex"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                class CircuitId(Entity):
                                                                                    """
                                                                                    Circuit ID
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                        self.yang_name = "circuit-id"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "circuit-id"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                class CircuitIdRegex(Entity):
                                                                                    """
                                                                                    Circuit ID RegEx
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                        self.yang_name = "circuit-id-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "circuit-id-regex"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                class RemoteId(Entity):
                                                                                    """
                                                                                    Remote ID
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                        self.yang_name = "remote-id"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "remote-id"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                class RemoteIdRegex(Entity):
                                                                                    """
                                                                                    Remote ID RegEx
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\: list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                        self.yang_name = "remote-id-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                        ])
                                                                                        self.string_array = []
                                                                                        self._segment_path = lambda: "remote-id-regex"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                class SrcPort(Entity):
                                                                                    """
                                                                                    Source port
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                        self.yang_name = "src-port"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "src-port"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "src-port"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                                class DstPort(Entity):
                                                                                    """
                                                                                    Destination port
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                        self.yang_name = "dst-port"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "dst-port"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "dst-port"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['min', 'max'], name, value)


                                                            class ActInfop(Entity):
                                                                """
                                                                act infop
                                                                
                                                                .. attribute:: policy_action_info_st
                                                                
                                                                	policy action info st
                                                                	**type**\: list of  		 :py:class:`PolicyActionInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop, self).__init__()

                                                                    self.yang_name = "act-infop"
                                                                    self.yang_parent_name = "policy-class-info-bg"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("policy-action-info-st", ("policy_action_info_st", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt))])
                                                                    self._leafs = OrderedDict()

                                                                    self.policy_action_info_st = YList(self)
                                                                    self._segment_path = lambda: "act-infop"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop, [], name, value)


                                                                class PolicyActionInfoSt(Entity):
                                                                    """
                                                                    policy action info st
                                                                    
                                                                    .. attribute:: actp
                                                                    
                                                                    	actp
                                                                    	**type**\:  :py:class:`Actp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp>`
                                                                    
                                                                    .. attribute:: seq
                                                                    
                                                                    	seq
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..65535
                                                                    
                                                                    .. attribute:: flags
                                                                    
                                                                    	flags
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..65535
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt, self).__init__()

                                                                        self.yang_name = "policy-action-info-st"
                                                                        self.yang_parent_name = "act-infop"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("actp", ("actp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp))])
                                                                        self._leafs = OrderedDict([
                                                                            ('seq', (YLeaf(YType.uint16, 'seq'), ['int'])),
                                                                            ('flags', (YLeaf(YType.uint16, 'flags'), ['int'])),
                                                                        ])
                                                                        self.seq = None
                                                                        self.flags = None

                                                                        self.actp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp()
                                                                        self.actp.parent = self
                                                                        self._children_name_map["actp"] = "actp"
                                                                        self._segment_path = lambda: "policy-action-info-st"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt, ['seq', 'flags'], name, value)


                                                                    class Actp(Entity):
                                                                        """
                                                                        actp
                                                                        
                                                                        .. attribute:: mark
                                                                        
                                                                        	mark
                                                                        	**type**\:  :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark>`
                                                                        
                                                                        .. attribute:: mark2
                                                                        
                                                                        	mark2
                                                                        	**type**\:  :py:class:`Mark2 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2>`
                                                                        
                                                                        .. attribute:: wred
                                                                        
                                                                        	wred
                                                                        	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred>`
                                                                        
                                                                        .. attribute:: encap
                                                                        
                                                                        	encap
                                                                        	**type**\:  :py:class:`Encap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap>`
                                                                        
                                                                        .. attribute:: prio
                                                                        
                                                                        	prio
                                                                        	**type**\:  :py:class:`Prio <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio>`
                                                                        
                                                                        .. attribute:: bwrem
                                                                        
                                                                        	bwrem
                                                                        	**type**\:  :py:class:`Bwrem <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem>`
                                                                        
                                                                        .. attribute:: min_bw
                                                                        
                                                                        	min bw
                                                                        	**type**\:  :py:class:`MinBw <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw>`
                                                                        
                                                                        .. attribute:: authen_aaa
                                                                        
                                                                        	authen aaa
                                                                        	**type**\:  :py:class:`AuthenAaa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa>`
                                                                        
                                                                        .. attribute:: collect_id
                                                                        
                                                                        	collect id
                                                                        	**type**\:  :py:class:`CollectId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId>`
                                                                        
                                                                        .. attribute:: decode_id
                                                                        
                                                                        	decode id
                                                                        	**type**\:  :py:class:`DecodeId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId>`
                                                                        
                                                                        .. attribute:: set_timer
                                                                        
                                                                        	set timer
                                                                        	**type**\:  :py:class:`SetTimer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer>`
                                                                        
                                                                        .. attribute:: stop_timer
                                                                        
                                                                        	stop timer
                                                                        	**type**\:  :py:class:`StopTimer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer>`
                                                                        
                                                                        .. attribute:: acct_aaa_list
                                                                        
                                                                        	acct aaa list
                                                                        	**type**\:  :py:class:`AcctAaaList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList>`
                                                                        
                                                                        .. attribute:: query_ancp
                                                                        
                                                                        	query ancp
                                                                        	**type**\:  :py:class:`QueryAncp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp>`
                                                                        
                                                                        .. attribute:: prepaid_cfg
                                                                        
                                                                        	prepaid cfg
                                                                        	**type**\:  :py:class:`PrepaidCfg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg>`
                                                                        
                                                                        .. attribute:: timeout_idle
                                                                        
                                                                        	timeout idle
                                                                        	**type**\:  :py:class:`TimeoutIdle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle>`
                                                                        
                                                                        .. attribute:: proxy_aaa
                                                                        
                                                                        	proxy aaa
                                                                        	**type**\:  :py:class:`ProxyAaa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa>`
                                                                        
                                                                        .. attribute:: act_template
                                                                        
                                                                        	act template
                                                                        	**type**\:  :py:class:`ActTemplate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate>`
                                                                        
                                                                        .. attribute:: deact_template
                                                                        
                                                                        	deact template
                                                                        	**type**\:  :py:class:`DeactTemplate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate>`
                                                                        
                                                                        .. attribute:: qlimit
                                                                        
                                                                        	qlimit
                                                                        	**type**\:  :py:class:`Qlimit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit>`
                                                                        
                                                                        .. attribute:: accounting_event_aaa
                                                                        
                                                                        	accounting event aaa
                                                                        	**type**\:  :py:class:`AccountingEventAaa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa>`
                                                                        
                                                                        .. attribute:: authorize_id
                                                                        
                                                                        	authorize id
                                                                        	**type**\:  :py:class:`AuthorizeId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId>`
                                                                        
                                                                        .. attribute:: afm_react
                                                                        
                                                                        	afm react
                                                                        	**type**\:  :py:class:`AfmReact <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact>`
                                                                        
                                                                        .. attribute:: httpr
                                                                        
                                                                        	httpr
                                                                        	**type**\:  :py:class:`Httpr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr>`
                                                                        
                                                                        .. attribute:: punt
                                                                        
                                                                        	punt
                                                                        	**type**\:  :py:class:`Punt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt>`
                                                                        
                                                                        .. attribute:: copy
                                                                        
                                                                        	copy
                                                                        	**type**\:  :py:class:`Copy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy>`
                                                                        
                                                                        .. attribute:: sfrag
                                                                        
                                                                        	sfrag
                                                                        	**type**\:  :py:class:`Sfrag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag>`
                                                                        
                                                                        .. attribute:: redirect
                                                                        
                                                                        	redirect
                                                                        	**type**\:  :py:class:`Redirect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect>`
                                                                        
                                                                        .. attribute:: out_intf
                                                                        
                                                                        	out intf
                                                                        	**type**\:  :py:class:`OutIntf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf>`
                                                                        
                                                                        .. attribute:: serv_func
                                                                        
                                                                        	serv func
                                                                        	**type**\:  :py:class:`ServFunc <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc>`
                                                                        
                                                                        .. attribute:: police
                                                                        
                                                                        	police
                                                                        	**type**\:  :py:class:`Police <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police>`
                                                                        
                                                                        .. attribute:: shape
                                                                        
                                                                        	shape
                                                                        	**type**\:  :py:class:`Shape <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape>`
                                                                        
                                                                        .. attribute:: child_policy
                                                                        
                                                                        	child policy
                                                                        	**type**\:  :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy>`
                                                                        
                                                                        .. attribute:: cac
                                                                        
                                                                        	cac
                                                                        	**type**\:  :py:class:`Cac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac>`
                                                                        
                                                                        .. attribute:: pfc
                                                                        
                                                                        	pfc
                                                                        	**type**\:  :py:class:`Pfc <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc>`
                                                                        
                                                                        .. attribute:: flow_parm
                                                                        
                                                                        	flow parm
                                                                        	**type**\:  :py:class:`FlowParm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm>`
                                                                        
                                                                        .. attribute:: ipcbr
                                                                        
                                                                        	ipcbr
                                                                        	**type**\:  :py:class:`Ipcbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr>`
                                                                        
                                                                        .. attribute:: rtp
                                                                        
                                                                        	rtp
                                                                        	**type**\:  :py:class:`Rtp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp>`
                                                                        
                                                                        .. attribute:: rtp_mmr
                                                                        
                                                                        	rtp mmr
                                                                        	**type**\:  :py:class:`RtpMmr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr>`
                                                                        
                                                                        .. attribute:: rtp_j2k
                                                                        
                                                                        	rtp j2k
                                                                        	**type**\:  :py:class:`RtpJ2k <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k>`
                                                                        
                                                                        .. attribute:: rtp_voice
                                                                        
                                                                        	rtp voice
                                                                        	**type**\:  :py:class:`RtpVoice <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice>`
                                                                        
                                                                        .. attribute:: mdi
                                                                        
                                                                        	mdi
                                                                        	**type**\:  :py:class:`Mdi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi>`
                                                                        
                                                                        .. attribute:: mdi_rtp
                                                                        
                                                                        	mdi rtp
                                                                        	**type**\:  :py:class:`MdiRtp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp>`
                                                                        
                                                                        .. attribute:: fmm
                                                                        
                                                                        	fmm
                                                                        	**type**\:  :py:class:`Fmm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm>`
                                                                        
                                                                        .. attribute:: pbf
                                                                        
                                                                        	pbf
                                                                        	**type**\:  :py:class:`Pbf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf>`
                                                                        
                                                                        .. attribute:: ipv4_nh
                                                                        
                                                                        	ipv4 nh
                                                                        	**type**\:  :py:class:`Ipv4Nh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh>`
                                                                        
                                                                        .. attribute:: ipv6_nh
                                                                        
                                                                        	ipv6 nh
                                                                        	**type**\:  :py:class:`Ipv6Nh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh>`
                                                                        
                                                                        .. attribute:: type
                                                                        
                                                                        	type
                                                                        	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: data_p
                                                                        
                                                                        	data p
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp, self).__init__()

                                                                            self.yang_name = "actp"
                                                                            self.yang_parent_name = "policy-action-info-st"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("mark", ("mark", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark)), ("mark2", ("mark2", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2)), ("wred", ("wred", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred)), ("encap", ("encap", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap)), ("prio", ("prio", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio)), ("bwrem", ("bwrem", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem)), ("min-bw", ("min_bw", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw)), ("authen-aaa", ("authen_aaa", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa)), ("collect-id", ("collect_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId)), ("decode-id", ("decode_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId)), ("set-timer", ("set_timer", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer)), ("stop-timer", ("stop_timer", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer)), ("acct-aaa-list", ("acct_aaa_list", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList)), ("query-ancp", ("query_ancp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp)), ("prepaid-cfg", ("prepaid_cfg", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg)), ("timeout-idle", ("timeout_idle", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle)), ("proxy-aaa", ("proxy_aaa", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa)), ("act-template", ("act_template", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate)), ("deact-template", ("deact_template", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate)), ("qlimit", ("qlimit", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit)), ("accounting-event-aaa", ("accounting_event_aaa", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa)), ("authorize-id", ("authorize_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId)), ("afm-react", ("afm_react", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact)), ("httpr", ("httpr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr)), ("punt", ("punt", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt)), ("copy", ("copy", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy)), ("sfrag", ("sfrag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag)), ("redirect", ("redirect", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect)), ("out-intf", ("out_intf", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf)), ("serv-func", ("serv_func", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc)), ("police", ("police", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police)), ("shape", ("shape", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape)), ("child-policy", ("child_policy", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy)), ("cac", ("cac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac)), ("pfc", ("pfc", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc)), ("flow-parm", ("flow_parm", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm)), ("ipcbr", ("ipcbr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr)), ("rtp", ("rtp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp)), ("rtp-mmr", ("rtp_mmr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr)), ("rtp-j2k", ("rtp_j2k", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k)), ("rtp-voice", ("rtp_voice", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice)), ("mdi", ("mdi", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi)), ("mdi-rtp", ("mdi_rtp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp)), ("fmm", ("fmm", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm)), ("pbf", ("pbf", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf)), ("ipv4-nh", ("ipv4_nh", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh)), ("ipv6-nh", ("ipv6_nh", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh))])
                                                                            self._leafs = OrderedDict([
                                                                                ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                                ('data_p', (YLeaf(YType.uint32, 'data-p'), ['int'])),
                                                                            ])
                                                                            self.type = None
                                                                            self.data_p = None

                                                                            self.mark = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark()
                                                                            self.mark.parent = self
                                                                            self._children_name_map["mark"] = "mark"

                                                                            self.mark2 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2()
                                                                            self.mark2.parent = self
                                                                            self._children_name_map["mark2"] = "mark2"

                                                                            self.wred = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred()
                                                                            self.wred.parent = self
                                                                            self._children_name_map["wred"] = "wred"

                                                                            self.encap = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap()
                                                                            self.encap.parent = self
                                                                            self._children_name_map["encap"] = "encap"

                                                                            self.prio = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio()
                                                                            self.prio.parent = self
                                                                            self._children_name_map["prio"] = "prio"

                                                                            self.bwrem = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem()
                                                                            self.bwrem.parent = self
                                                                            self._children_name_map["bwrem"] = "bwrem"

                                                                            self.min_bw = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw()
                                                                            self.min_bw.parent = self
                                                                            self._children_name_map["min_bw"] = "min-bw"

                                                                            self.authen_aaa = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa()
                                                                            self.authen_aaa.parent = self
                                                                            self._children_name_map["authen_aaa"] = "authen-aaa"

                                                                            self.collect_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId()
                                                                            self.collect_id.parent = self
                                                                            self._children_name_map["collect_id"] = "collect-id"

                                                                            self.decode_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId()
                                                                            self.decode_id.parent = self
                                                                            self._children_name_map["decode_id"] = "decode-id"

                                                                            self.set_timer = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer()
                                                                            self.set_timer.parent = self
                                                                            self._children_name_map["set_timer"] = "set-timer"

                                                                            self.stop_timer = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer()
                                                                            self.stop_timer.parent = self
                                                                            self._children_name_map["stop_timer"] = "stop-timer"

                                                                            self.acct_aaa_list = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList()
                                                                            self.acct_aaa_list.parent = self
                                                                            self._children_name_map["acct_aaa_list"] = "acct-aaa-list"

                                                                            self.query_ancp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp()
                                                                            self.query_ancp.parent = self
                                                                            self._children_name_map["query_ancp"] = "query-ancp"

                                                                            self.prepaid_cfg = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg()
                                                                            self.prepaid_cfg.parent = self
                                                                            self._children_name_map["prepaid_cfg"] = "prepaid-cfg"

                                                                            self.timeout_idle = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle()
                                                                            self.timeout_idle.parent = self
                                                                            self._children_name_map["timeout_idle"] = "timeout-idle"

                                                                            self.proxy_aaa = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa()
                                                                            self.proxy_aaa.parent = self
                                                                            self._children_name_map["proxy_aaa"] = "proxy-aaa"

                                                                            self.act_template = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate()
                                                                            self.act_template.parent = self
                                                                            self._children_name_map["act_template"] = "act-template"

                                                                            self.deact_template = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate()
                                                                            self.deact_template.parent = self
                                                                            self._children_name_map["deact_template"] = "deact-template"

                                                                            self.qlimit = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit()
                                                                            self.qlimit.parent = self
                                                                            self._children_name_map["qlimit"] = "qlimit"

                                                                            self.accounting_event_aaa = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa()
                                                                            self.accounting_event_aaa.parent = self
                                                                            self._children_name_map["accounting_event_aaa"] = "accounting-event-aaa"

                                                                            self.authorize_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId()
                                                                            self.authorize_id.parent = self
                                                                            self._children_name_map["authorize_id"] = "authorize-id"

                                                                            self.afm_react = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact()
                                                                            self.afm_react.parent = self
                                                                            self._children_name_map["afm_react"] = "afm-react"

                                                                            self.httpr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr()
                                                                            self.httpr.parent = self
                                                                            self._children_name_map["httpr"] = "httpr"

                                                                            self.punt = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt()
                                                                            self.punt.parent = self
                                                                            self._children_name_map["punt"] = "punt"

                                                                            self.copy = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy()
                                                                            self.copy.parent = self
                                                                            self._children_name_map["copy"] = "copy"

                                                                            self.sfrag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag()
                                                                            self.sfrag.parent = self
                                                                            self._children_name_map["sfrag"] = "sfrag"

                                                                            self.redirect = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect()
                                                                            self.redirect.parent = self
                                                                            self._children_name_map["redirect"] = "redirect"

                                                                            self.out_intf = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf()
                                                                            self.out_intf.parent = self
                                                                            self._children_name_map["out_intf"] = "out-intf"

                                                                            self.serv_func = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc()
                                                                            self.serv_func.parent = self
                                                                            self._children_name_map["serv_func"] = "serv-func"

                                                                            self.police = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police()
                                                                            self.police.parent = self
                                                                            self._children_name_map["police"] = "police"

                                                                            self.shape = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape()
                                                                            self.shape.parent = self
                                                                            self._children_name_map["shape"] = "shape"

                                                                            self.child_policy = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy()
                                                                            self.child_policy.parent = self
                                                                            self._children_name_map["child_policy"] = "child-policy"

                                                                            self.cac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac()
                                                                            self.cac.parent = self
                                                                            self._children_name_map["cac"] = "cac"

                                                                            self.pfc = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc()
                                                                            self.pfc.parent = self
                                                                            self._children_name_map["pfc"] = "pfc"

                                                                            self.flow_parm = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm()
                                                                            self.flow_parm.parent = self
                                                                            self._children_name_map["flow_parm"] = "flow-parm"

                                                                            self.ipcbr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr()
                                                                            self.ipcbr.parent = self
                                                                            self._children_name_map["ipcbr"] = "ipcbr"

                                                                            self.rtp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp()
                                                                            self.rtp.parent = self
                                                                            self._children_name_map["rtp"] = "rtp"

                                                                            self.rtp_mmr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr()
                                                                            self.rtp_mmr.parent = self
                                                                            self._children_name_map["rtp_mmr"] = "rtp-mmr"

                                                                            self.rtp_j2k = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k()
                                                                            self.rtp_j2k.parent = self
                                                                            self._children_name_map["rtp_j2k"] = "rtp-j2k"

                                                                            self.rtp_voice = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice()
                                                                            self.rtp_voice.parent = self
                                                                            self._children_name_map["rtp_voice"] = "rtp-voice"

                                                                            self.mdi = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi()
                                                                            self.mdi.parent = self
                                                                            self._children_name_map["mdi"] = "mdi"

                                                                            self.mdi_rtp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp()
                                                                            self.mdi_rtp.parent = self
                                                                            self._children_name_map["mdi_rtp"] = "mdi-rtp"

                                                                            self.fmm = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm()
                                                                            self.fmm.parent = self
                                                                            self._children_name_map["fmm"] = "fmm"

                                                                            self.pbf = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf()
                                                                            self.pbf.parent = self
                                                                            self._children_name_map["pbf"] = "pbf"

                                                                            self.ipv4_nh = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh()
                                                                            self.ipv4_nh.parent = self
                                                                            self._children_name_map["ipv4_nh"] = "ipv4-nh"

                                                                            self.ipv6_nh = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh()
                                                                            self.ipv6_nh.parent = self
                                                                            self._children_name_map["ipv6_nh"] = "ipv6-nh"
                                                                            self._segment_path = lambda: "actp"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp, ['type', 'data_p'], name, value)


                                                                        class Mark(Entity):
                                                                            """
                                                                            mark
                                                                            
                                                                            .. attribute:: action_mark_info
                                                                            
                                                                            	action mark info
                                                                            	**type**\: list of  		 :py:class:`ActionMarkInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark, self).__init__()

                                                                                self.yang_name = "mark"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("action-mark-info", ("action_mark_info", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo))])
                                                                                self._leafs = OrderedDict()

                                                                                self.action_mark_info = YList(self)
                                                                                self._segment_path = lambda: "mark"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark, [], name, value)


                                                                            class ActionMarkInfo(Entity):
                                                                                """
                                                                                action mark info
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:  :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                                
                                                                                .. attribute:: mark_flags
                                                                                
                                                                                	mark flags
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo, self).__init__()

                                                                                    self.yang_name = "action-mark-info"
                                                                                    self.yang_parent_name = "mark"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MarkTypeEn', '')])),
                                                                                        ('mark_flags', (YLeaf(YType.uint32, 'mark-flags'), ['int'])),
                                                                                        ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                    ])
                                                                                    self.type = None
                                                                                    self.mark_flags = None
                                                                                    self.value = None
                                                                                    self._segment_path = lambda: "action-mark-info"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo, ['type', 'mark_flags', 'value'], name, value)


                                                                        class Mark2(Entity):
                                                                            """
                                                                            mark2
                                                                            
                                                                            .. attribute:: action_mark2_info
                                                                            
                                                                            	action mark2 info
                                                                            	**type**\: list of  		 :py:class:`ActionMark2Info <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2, self).__init__()

                                                                                self.yang_name = "mark2"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("action-mark2-info", ("action_mark2_info", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info))])
                                                                                self._leafs = OrderedDict()

                                                                                self.action_mark2_info = YList(self)
                                                                                self._segment_path = lambda: "mark2"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2, [], name, value)


                                                                            class ActionMark2Info(Entity):
                                                                                """
                                                                                action mark2 info
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: value_overflow
                                                                                
                                                                                	value overflow
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: mark_flags
                                                                                
                                                                                	mark flags
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info, self).__init__()

                                                                                    self.yang_name = "action-mark2-info"
                                                                                    self.yang_parent_name = "mark2"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ('value_overflow', (YLeaf(YType.uint16, 'value-overflow'), ['int'])),
                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                        ('mark_flags', (YLeaf(YType.uint8, 'mark-flags'), ['int'])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.value_overflow = None
                                                                                    self.type = None
                                                                                    self.mark_flags = None
                                                                                    self._segment_path = lambda: "action-mark2-info"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info, ['value', 'value_overflow', 'type', 'mark_flags'], name, value)


                                                                        class Wred(Entity):
                                                                            """
                                                                            wred
                                                                            
                                                                            .. attribute:: action_wred_info
                                                                            
                                                                            	action wred info
                                                                            	**type**\: list of  		 :py:class:`ActionWredInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred, self).__init__()

                                                                                self.yang_name = "wred"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("action-wred-info", ("action_wred_info", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo))])
                                                                                self._leafs = OrderedDict()

                                                                                self.action_wred_info = YList(self)
                                                                                self._segment_path = lambda: "wred"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred, [], name, value)


                                                                            class ActionWredInfo(Entity):
                                                                                """
                                                                                action wred info
                                                                                
                                                                                .. attribute:: match_ranges
                                                                                
                                                                                	match ranges
                                                                                	**type**\:  :py:class:`MatchRanges <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges>`
                                                                                
                                                                                .. attribute:: min_threshold
                                                                                
                                                                                	min threshold
                                                                                	**type**\:  :py:class:`MinThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold>`
                                                                                
                                                                                .. attribute:: max_threshold
                                                                                
                                                                                	max threshold
                                                                                	**type**\:  :py:class:`MaxThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold>`
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	cos/prec/dscp/ based WRED
                                                                                	**type**\:  :py:class:`WredTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.WredTypeEn>`
                                                                                
                                                                                .. attribute:: wred_flags
                                                                                
                                                                                	wred flags
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: probability
                                                                                
                                                                                	probability
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo, self).__init__()

                                                                                    self.yang_name = "action-wred-info"
                                                                                    self.yang_parent_name = "wred"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("match-ranges", ("match_ranges", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges)), ("min-threshold", ("min_threshold", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold)), ("max-threshold", ("max_threshold", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'WredTypeEn', '')])),
                                                                                        ('wred_flags', (YLeaf(YType.uint32, 'wred-flags'), ['int'])),
                                                                                        ('probability', (YLeaf(YType.uint32, 'probability'), ['int'])),
                                                                                    ])
                                                                                    self.type = None
                                                                                    self.wred_flags = None
                                                                                    self.probability = None

                                                                                    self.match_ranges = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges()
                                                                                    self.match_ranges.parent = self
                                                                                    self._children_name_map["match_ranges"] = "match-ranges"

                                                                                    self.min_threshold = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold()
                                                                                    self.min_threshold.parent = self
                                                                                    self._children_name_map["min_threshold"] = "min-threshold"

                                                                                    self.max_threshold = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold()
                                                                                    self.max_threshold.parent = self
                                                                                    self._children_name_map["max_threshold"] = "max-threshold"
                                                                                    self._segment_path = lambda: "action-wred-info"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo, ['type', 'wred_flags', 'probability'], name, value)


                                                                                class MatchRanges(Entity):
                                                                                    """
                                                                                    match ranges
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges, self).__init__()

                                                                                        self.yang_name = "match-ranges"
                                                                                        self.yang_parent_name = "action-wred-info"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "match-ranges"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "match-ranges"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray, ['min', 'max'], name, value)


                                                                                class MinThreshold(Entity):
                                                                                    """
                                                                                    min threshold
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: unit
                                                                                    
                                                                                    	unit
                                                                                    	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold, self).__init__()

                                                                                        self.yang_name = "min-threshold"
                                                                                        self.yang_parent_name = "action-wred-info"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                        ])
                                                                                        self.value = None
                                                                                        self.unit = None
                                                                                        self._segment_path = lambda: "min-threshold"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold, ['value', 'unit'], name, value)


                                                                                class MaxThreshold(Entity):
                                                                                    """
                                                                                    max threshold
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: unit
                                                                                    
                                                                                    	unit
                                                                                    	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold, self).__init__()

                                                                                        self.yang_name = "max-threshold"
                                                                                        self.yang_parent_name = "action-wred-info"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                        ])
                                                                                        self.value = None
                                                                                        self.unit = None
                                                                                        self._segment_path = lambda: "max-threshold"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold, ['value', 'unit'], name, value)


                                                                        class Encap(Entity):
                                                                            """
                                                                            encap
                                                                            
                                                                            .. attribute:: seq
                                                                            
                                                                            	seq
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap, self).__init__()

                                                                                self.yang_name = "encap"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('seq', (YLeaf(YType.uint8, 'seq'), ['int'])),
                                                                                ])
                                                                                self.seq = None
                                                                                self._segment_path = lambda: "encap"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap, ['seq'], name, value)


                                                                        class Prio(Entity):
                                                                            """
                                                                            prio
                                                                            
                                                                            .. attribute:: prio_lvl
                                                                            
                                                                            	prio lvl
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio, self).__init__()

                                                                                self.yang_name = "prio"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('prio_lvl', (YLeaf(YType.uint32, 'prio-lvl'), ['int'])),
                                                                                ])
                                                                                self.prio_lvl = None
                                                                                self._segment_path = lambda: "prio"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio, ['prio_lvl'], name, value)


                                                                        class Bwrem(Entity):
                                                                            """
                                                                            bwrem
                                                                            
                                                                            .. attribute:: bwrem
                                                                            
                                                                            	bwrem
                                                                            	**type**\:  :py:class:`Bwrem_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem_>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem, self).__init__()

                                                                                self.yang_name = "bwrem"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("bwrem", ("bwrem", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem_))])
                                                                                self._leafs = OrderedDict()

                                                                                self.bwrem = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem_()
                                                                                self.bwrem.parent = self
                                                                                self._children_name_map["bwrem"] = "bwrem"
                                                                                self._segment_path = lambda: "bwrem"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem, [], name, value)


                                                                            class Bwrem_(Entity):
                                                                                """
                                                                                bwrem
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem_, self).__init__()

                                                                                    self.yang_name = "bwrem"
                                                                                    self.yang_parent_name = "bwrem"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.unit = None
                                                                                    self._segment_path = lambda: "bwrem"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem_, ['value', 'unit'], name, value)


                                                                        class MinBw(Entity):
                                                                            """
                                                                            min bw
                                                                            
                                                                            .. attribute:: bw
                                                                            
                                                                            	bw
                                                                            	**type**\:  :py:class:`Bw <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw, self).__init__()

                                                                                self.yang_name = "min-bw"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("bw", ("bw", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw))])
                                                                                self._leafs = OrderedDict()

                                                                                self.bw = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw()
                                                                                self.bw.parent = self
                                                                                self._children_name_map["bw"] = "bw"
                                                                                self._segment_path = lambda: "min-bw"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw, [], name, value)


                                                                            class Bw(Entity):
                                                                                """
                                                                                bw
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw, self).__init__()

                                                                                    self.yang_name = "bw"
                                                                                    self.yang_parent_name = "min-bw"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.unit = None
                                                                                    self._segment_path = lambda: "bw"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw, ['value', 'unit'], name, value)


                                                                        class AuthenAaa(Entity):
                                                                            """
                                                                            authen aaa
                                                                            
                                                                            .. attribute:: aaa_list_name
                                                                            
                                                                            	aaa list name
                                                                            	**type**\: str
                                                                            
                                                                            .. attribute:: authen_password
                                                                            
                                                                            	authen password
                                                                            	**type**\: str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa, self).__init__()

                                                                                self.yang_name = "authen-aaa"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                                    ('authen_password', (YLeaf(YType.str, 'authen-password'), ['str'])),
                                                                                ])
                                                                                self.aaa_list_name = None
                                                                                self.authen_password = None
                                                                                self._segment_path = lambda: "authen-aaa"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa, ['aaa_list_name', 'authen_password'], name, value)


                                                                        class CollectId(Entity):
                                                                            """
                                                                            collect id
                                                                            
                                                                            .. attribute:: id
                                                                            
                                                                            	id
                                                                            	**type**\:  :py:class:`IdentifierEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.IdentifierEn>`
                                                                            
                                                                            .. attribute:: aaa_list_name
                                                                            
                                                                            	aaa list name
                                                                            	**type**\: str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId, self).__init__()

                                                                                self.yang_name = "collect-id"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('id', (YLeaf(YType.enumeration, 'id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'IdentifierEn', '')])),
                                                                                    ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                                ])
                                                                                self.id = None
                                                                                self.aaa_list_name = None
                                                                                self._segment_path = lambda: "collect-id"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId, ['id', 'aaa_list_name'], name, value)


                                                                        class DecodeId(Entity):
                                                                            """
                                                                            decode id
                                                                            
                                                                            .. attribute:: id
                                                                            
                                                                            	id
                                                                            	**type**\:  :py:class:`DecodeIdentifierEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.DecodeIdentifierEn>`
                                                                            
                                                                            .. attribute:: format_name
                                                                            
                                                                            	format name
                                                                            	**type**\: str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId, self).__init__()

                                                                                self.yang_name = "decode-id"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('id', (YLeaf(YType.enumeration, 'id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'DecodeIdentifierEn', '')])),
                                                                                    ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                ])
                                                                                self.id = None
                                                                                self.format_name = None
                                                                                self._segment_path = lambda: "decode-id"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId, ['id', 'format_name'], name, value)


                                                                        class SetTimer(Entity):
                                                                            """
                                                                            set timer
                                                                            
                                                                            .. attribute:: timer_name
                                                                            
                                                                            	timer name
                                                                            	**type**\: str
                                                                            
                                                                            .. attribute:: duration
                                                                            
                                                                            	duration
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: absolute_time
                                                                            
                                                                            	absolute time
                                                                            	**type**\: str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer, self).__init__()

                                                                                self.yang_name = "set-timer"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('timer_name', (YLeaf(YType.str, 'timer-name'), ['str'])),
                                                                                    ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                                                    ('absolute_time', (YLeaf(YType.str, 'absolute-time'), ['str'])),
                                                                                ])
                                                                                self.timer_name = None
                                                                                self.duration = None
                                                                                self.absolute_time = None
                                                                                self._segment_path = lambda: "set-timer"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer, ['timer_name', 'duration', 'absolute_time'], name, value)


                                                                        class StopTimer(Entity):
                                                                            """
                                                                            stop timer
                                                                            
                                                                            .. attribute:: timer_name
                                                                            
                                                                            	timer name
                                                                            	**type**\: str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer, self).__init__()

                                                                                self.yang_name = "stop-timer"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('timer_name', (YLeaf(YType.str, 'timer-name'), ['str'])),
                                                                                ])
                                                                                self.timer_name = None
                                                                                self._segment_path = lambda: "stop-timer"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer, ['timer_name'], name, value)


                                                                        class AcctAaaList(Entity):
                                                                            """
                                                                            acct aaa list
                                                                            
                                                                            .. attribute:: aaa_list_name
                                                                            
                                                                            	aaa list name
                                                                            	**type**\: str
                                                                            
                                                                            .. attribute:: secs
                                                                            
                                                                            	secs
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList, self).__init__()

                                                                                self.yang_name = "acct-aaa-list"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                                    ('secs', (YLeaf(YType.uint32, 'secs'), ['int'])),
                                                                                ])
                                                                                self.aaa_list_name = None
                                                                                self.secs = None
                                                                                self._segment_path = lambda: "acct-aaa-list"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList, ['aaa_list_name', 'secs'], name, value)


                                                                        class QueryAncp(Entity):
                                                                            """
                                                                            query ancp
                                                                            
                                                                            .. attribute:: enable
                                                                            
                                                                            	enable
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp, self).__init__()

                                                                                self.yang_name = "query-ancp"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('enable', (YLeaf(YType.uint8, 'enable'), ['int'])),
                                                                                ])
                                                                                self.enable = None
                                                                                self._segment_path = lambda: "query-ancp"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp, ['enable'], name, value)


                                                                        class PrepaidCfg(Entity):
                                                                            """
                                                                            prepaid cfg
                                                                            
                                                                            .. attribute:: prepaid_config_profile_name
                                                                            
                                                                            	prepaid config profile name
                                                                            	**type**\: str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg, self).__init__()

                                                                                self.yang_name = "prepaid-cfg"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('prepaid_config_profile_name', (YLeaf(YType.str, 'prepaid-config-profile-name'), ['str'])),
                                                                                ])
                                                                                self.prepaid_config_profile_name = None
                                                                                self._segment_path = lambda: "prepaid-cfg"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg, ['prepaid_config_profile_name'], name, value)


                                                                        class TimeoutIdle(Entity):
                                                                            """
                                                                            timeout idle
                                                                            
                                                                            .. attribute:: secs
                                                                            
                                                                            	secs
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle, self).__init__()

                                                                                self.yang_name = "timeout-idle"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('secs', (YLeaf(YType.uint32, 'secs'), ['int'])),
                                                                                ])
                                                                                self.secs = None
                                                                                self._segment_path = lambda: "timeout-idle"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle, ['secs'], name, value)


                                                                        class ProxyAaa(Entity):
                                                                            """
                                                                            proxy aaa
                                                                            
                                                                            .. attribute:: aaa_list_name
                                                                            
                                                                            	aaa list name
                                                                            	**type**\: str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa, self).__init__()

                                                                                self.yang_name = "proxy-aaa"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                                ])
                                                                                self.aaa_list_name = None
                                                                                self._segment_path = lambda: "proxy-aaa"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa, ['aaa_list_name'], name, value)


                                                                        class ActTemplate(Entity):
                                                                            """
                                                                            act template
                                                                            
                                                                            .. attribute:: template_name
                                                                            
                                                                            	template name
                                                                            	**type**\: str
                                                                            
                                                                            .. attribute:: aaa_list_name
                                                                            
                                                                            	aaa list name
                                                                            	**type**\: str
                                                                            
                                                                            .. attribute:: flags
                                                                            
                                                                            	flags
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate, self).__init__()

                                                                                self.yang_name = "act-template"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('template_name', (YLeaf(YType.str, 'template-name'), ['str'])),
                                                                                    ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                                    ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                ])
                                                                                self.template_name = None
                                                                                self.aaa_list_name = None
                                                                                self.flags = None
                                                                                self._segment_path = lambda: "act-template"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate, ['template_name', 'aaa_list_name', 'flags'], name, value)


                                                                        class DeactTemplate(Entity):
                                                                            """
                                                                            deact template
                                                                            
                                                                            .. attribute:: template_name
                                                                            
                                                                            	template name
                                                                            	**type**\: str
                                                                            
                                                                            .. attribute:: aaa_list_name
                                                                            
                                                                            	aaa list name
                                                                            	**type**\: str
                                                                            
                                                                            .. attribute:: flags
                                                                            
                                                                            	flags
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate, self).__init__()

                                                                                self.yang_name = "deact-template"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('template_name', (YLeaf(YType.str, 'template-name'), ['str'])),
                                                                                    ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                                    ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                ])
                                                                                self.template_name = None
                                                                                self.aaa_list_name = None
                                                                                self.flags = None
                                                                                self._segment_path = lambda: "deact-template"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate, ['template_name', 'aaa_list_name', 'flags'], name, value)


                                                                        class Qlimit(Entity):
                                                                            """
                                                                            qlimit
                                                                            
                                                                            .. attribute:: action_qlimit_info_array
                                                                            
                                                                            	action qlimit info array
                                                                            	**type**\: list of  		 :py:class:`ActionQlimitInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit, self).__init__()

                                                                                self.yang_name = "qlimit"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("action-qlimit-info-array", ("action_qlimit_info_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.action_qlimit_info_array = YList(self)
                                                                                self._segment_path = lambda: "qlimit"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit, [], name, value)


                                                                            class ActionQlimitInfoArray(Entity):
                                                                                """
                                                                                action qlimit info array
                                                                                
                                                                                .. attribute:: qlim
                                                                                
                                                                                	qlim
                                                                                	**type**\:  :py:class:`Qlim <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim>`
                                                                                
                                                                                .. attribute:: atmclp_qlim
                                                                                
                                                                                	atmclp qlim
                                                                                	**type**\:  :py:class:`AtmclpQlim <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim>`
                                                                                
                                                                                .. attribute:: match_values
                                                                                
                                                                                	match values
                                                                                	**type**\:  :py:class:`MatchValues <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues>`
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:  :py:class:`QlimitTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.QlimitTypeEn>`
                                                                                
                                                                                .. attribute:: qlimit_flags
                                                                                
                                                                                	qlimit flags
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray, self).__init__()

                                                                                    self.yang_name = "action-qlimit-info-array"
                                                                                    self.yang_parent_name = "qlimit"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("qlim", ("qlim", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim)), ("atmclp-qlim", ("atmclp_qlim", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim)), ("match-values", ("match_values", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'QlimitTypeEn', '')])),
                                                                                        ('qlimit_flags', (YLeaf(YType.uint32, 'qlimit-flags'), ['int'])),
                                                                                    ])
                                                                                    self.type = None
                                                                                    self.qlimit_flags = None

                                                                                    self.qlim = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim()
                                                                                    self.qlim.parent = self
                                                                                    self._children_name_map["qlim"] = "qlim"

                                                                                    self.atmclp_qlim = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim()
                                                                                    self.atmclp_qlim.parent = self
                                                                                    self._children_name_map["atmclp_qlim"] = "atmclp-qlim"

                                                                                    self.match_values = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues()
                                                                                    self.match_values.parent = self
                                                                                    self._children_name_map["match_values"] = "match-values"
                                                                                    self._segment_path = lambda: "action-qlimit-info-array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray, ['type', 'qlimit_flags'], name, value)


                                                                                class Qlim(Entity):
                                                                                    """
                                                                                    qlim
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: unit
                                                                                    
                                                                                    	unit
                                                                                    	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim, self).__init__()

                                                                                        self.yang_name = "qlim"
                                                                                        self.yang_parent_name = "action-qlimit-info-array"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                        ])
                                                                                        self.value = None
                                                                                        self.unit = None
                                                                                        self._segment_path = lambda: "qlim"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim, ['value', 'unit'], name, value)


                                                                                class AtmclpQlim(Entity):
                                                                                    """
                                                                                    atmclp qlim
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: unit
                                                                                    
                                                                                    	unit
                                                                                    	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim, self).__init__()

                                                                                        self.yang_name = "atmclp-qlim"
                                                                                        self.yang_parent_name = "action-qlimit-info-array"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                            ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                        ])
                                                                                        self.value = None
                                                                                        self.unit = None
                                                                                        self._segment_path = lambda: "atmclp-qlim"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim, ['value', 'unit'], name, value)


                                                                                class MatchValues(Entity):
                                                                                    """
                                                                                    match values
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues, self).__init__()

                                                                                        self.yang_name = "match-values"
                                                                                        self.yang_parent_name = "action-qlimit-info-array"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "match-values"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "match-values"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                            ])
                                                                                            self.min = None
                                                                                            self.max = None
                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray, ['min', 'max'], name, value)


                                                                        class AccountingEventAaa(Entity):
                                                                            """
                                                                            accounting event aaa
                                                                            
                                                                            .. attribute:: action
                                                                            
                                                                            	action
                                                                            	**type**\:  :py:class:`AcctEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.AcctEn>`
                                                                            
                                                                            .. attribute:: aaa_list_name
                                                                            
                                                                            	aaa list name
                                                                            	**type**\: str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa, self).__init__()

                                                                                self.yang_name = "accounting-event-aaa"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('action', (YLeaf(YType.enumeration, 'action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'AcctEn', '')])),
                                                                                    ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                                ])
                                                                                self.action = None
                                                                                self.aaa_list_name = None
                                                                                self._segment_path = lambda: "accounting-event-aaa"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa, ['action', 'aaa_list_name'], name, value)


                                                                        class AuthorizeId(Entity):
                                                                            """
                                                                            authorize id
                                                                            
                                                                            .. attribute:: id
                                                                            
                                                                            	id
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: aaa_list_name
                                                                            
                                                                            	aaa list name
                                                                            	**type**\: str
                                                                            
                                                                            .. attribute:: format_name
                                                                            
                                                                            	format name
                                                                            	**type**\: str
                                                                            
                                                                            .. attribute:: password
                                                                            
                                                                            	password
                                                                            	**type**\: str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId, self).__init__()

                                                                                self.yang_name = "authorize-id"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('id', (YLeaf(YType.uint8, 'id'), ['int'])),
                                                                                    ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                                    ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                    ('password', (YLeaf(YType.str, 'password'), ['str'])),
                                                                                ])
                                                                                self.id = None
                                                                                self.aaa_list_name = None
                                                                                self.format_name = None
                                                                                self.password = None
                                                                                self._segment_path = lambda: "authorize-id"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId, ['id', 'aaa_list_name', 'format_name', 'password'], name, value)


                                                                        class AfmReact(Entity):
                                                                            """
                                                                            afm react
                                                                            
                                                                            .. attribute:: action_afmon_react_info
                                                                            
                                                                            	action afmon react info
                                                                            	**type**\: list of  		 :py:class:`ActionAfmonReactInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact, self).__init__()

                                                                                self.yang_name = "afm-react"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("action-afmon-react-info", ("action_afmon_react_info", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo))])
                                                                                self._leafs = OrderedDict()

                                                                                self.action_afmon_react_info = YList(self)
                                                                                self._segment_path = lambda: "afm-react"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact, [], name, value)


                                                                            class ActionAfmonReactInfo(Entity):
                                                                                """
                                                                                action afmon react info
                                                                                
                                                                                .. attribute:: oper_id
                                                                                
                                                                                	React Operation ID
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: description
                                                                                
                                                                                	Describing the oper
                                                                                	**type**\: str
                                                                                
                                                                                .. attribute:: trig_num_intvls
                                                                                
                                                                                	Averaged over N intvls
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: clone_ifh
                                                                                
                                                                                	Clone interface handle
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: notif_actns
                                                                                
                                                                                	Bitmap of actions on alert
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: criterion
                                                                                
                                                                                	React Criterion
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: trig_type
                                                                                
                                                                                	Immediate or averaged thresh trigger
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: trig_relop
                                                                                
                                                                                	Trigger LT\|LE\|GT\|GE\|Range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: trig_level_1
                                                                                
                                                                                	Trigger threshold 1/lower
                                                                                	**type**\: str
                                                                                
                                                                                .. attribute:: trig_level_2
                                                                                
                                                                                	Trigger upper threshold for range
                                                                                	**type**\: str
                                                                                
                                                                                .. attribute:: alm_grp_thresh
                                                                                
                                                                                	Num/percent in grp
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                	**units**\: percentage
                                                                                
                                                                                .. attribute:: alm_type
                                                                                
                                                                                	Discrete \| grouped alarm
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: alm_severity
                                                                                
                                                                                	Major\|Minor\|... alarm
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo, self).__init__()

                                                                                    self.yang_name = "action-afmon-react-info"
                                                                                    self.yang_parent_name = "afm-react"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('oper_id', (YLeaf(YType.uint32, 'oper-id'), ['int'])),
                                                                                        ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                        ('trig_num_intvls', (YLeaf(YType.uint32, 'trig-num-intvls'), ['int'])),
                                                                                        ('clone_ifh', (YLeaf(YType.uint32, 'clone-ifh'), ['int'])),
                                                                                        ('notif_actns', (YLeaf(YType.uint8, 'notif-actns'), ['int'])),
                                                                                        ('criterion', (YLeaf(YType.uint8, 'criterion'), ['int'])),
                                                                                        ('trig_type', (YLeaf(YType.uint8, 'trig-type'), ['int'])),
                                                                                        ('trig_relop', (YLeaf(YType.uint8, 'trig-relop'), ['int'])),
                                                                                        ('trig_level_1', (YLeaf(YType.str, 'trig-level-1'), ['str'])),
                                                                                        ('trig_level_2', (YLeaf(YType.str, 'trig-level-2'), ['str'])),
                                                                                        ('alm_grp_thresh', (YLeaf(YType.uint16, 'alm-grp-thresh'), ['int'])),
                                                                                        ('alm_type', (YLeaf(YType.uint8, 'alm-type'), ['int'])),
                                                                                        ('alm_severity', (YLeaf(YType.uint8, 'alm-severity'), ['int'])),
                                                                                    ])
                                                                                    self.oper_id = None
                                                                                    self.description = None
                                                                                    self.trig_num_intvls = None
                                                                                    self.clone_ifh = None
                                                                                    self.notif_actns = None
                                                                                    self.criterion = None
                                                                                    self.trig_type = None
                                                                                    self.trig_relop = None
                                                                                    self.trig_level_1 = None
                                                                                    self.trig_level_2 = None
                                                                                    self.alm_grp_thresh = None
                                                                                    self.alm_type = None
                                                                                    self.alm_severity = None
                                                                                    self._segment_path = lambda: "action-afmon-react-info"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo, ['oper_id', 'description', 'trig_num_intvls', 'clone_ifh', 'notif_actns', 'criterion', 'trig_type', 'trig_relop', 'trig_level_1', 'trig_level_2', 'alm_grp_thresh', 'alm_type', 'alm_severity'], name, value)


                                                                        class Httpr(Entity):
                                                                            """
                                                                            httpr
                                                                            
                                                                            .. attribute:: redirect_url
                                                                            
                                                                            	redirect url
                                                                            	**type**\: str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr, self).__init__()

                                                                                self.yang_name = "httpr"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('redirect_url', (YLeaf(YType.str, 'redirect-url'), ['str'])),
                                                                                ])
                                                                                self.redirect_url = None
                                                                                self._segment_path = lambda: "httpr"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr, ['redirect_url'], name, value)


                                                                        class Punt(Entity):
                                                                            """
                                                                            punt
                                                                            
                                                                            .. attribute:: sn_type
                                                                            
                                                                            	service node ID type
                                                                            	**type**\:  :py:class:`DpssSnidTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.DpssSnidTypeEn>`
                                                                            
                                                                            .. attribute:: sn_index
                                                                            
                                                                            	service node index
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: sn_name
                                                                            
                                                                            	service node name
                                                                            	**type**\: str
                                                                            
                                                                            .. attribute:: app_id
                                                                            
                                                                            	application ID
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: local_id
                                                                            
                                                                            	local ID
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: vsnode_type
                                                                            
                                                                            	vservice node type
                                                                            	**type**\:  :py:class:`VsvcServiceTypeT <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.VsvcServiceTypeT>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt, self).__init__()

                                                                                self.yang_name = "punt"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('sn_type', (YLeaf(YType.enumeration, 'sn-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'DpssSnidTypeEn', '')])),
                                                                                    ('sn_index', (YLeaf(YType.uint32, 'sn-index'), ['int'])),
                                                                                    ('sn_name', (YLeaf(YType.str, 'sn-name'), ['str'])),
                                                                                    ('app_id', (YLeaf(YType.uint32, 'app-id'), ['int'])),
                                                                                    ('local_id', (YLeaf(YType.uint32, 'local-id'), ['int'])),
                                                                                    ('vsnode_type', (YLeaf(YType.enumeration, 'vsnode-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'VsvcServiceTypeT', '')])),
                                                                                ])
                                                                                self.sn_type = None
                                                                                self.sn_index = None
                                                                                self.sn_name = None
                                                                                self.app_id = None
                                                                                self.local_id = None
                                                                                self.vsnode_type = None
                                                                                self._segment_path = lambda: "punt"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt, ['sn_type', 'sn_index', 'sn_name', 'app_id', 'local_id', 'vsnode_type'], name, value)


                                                                        class Copy(Entity):
                                                                            """
                                                                            copy
                                                                            
                                                                            .. attribute:: num_byte
                                                                            
                                                                            	number of bytes
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: sn_type
                                                                            
                                                                            	service node ID type
                                                                            	**type**\:  :py:class:`DpssSnidTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.DpssSnidTypeEn>`
                                                                            
                                                                            .. attribute:: sn_index
                                                                            
                                                                            	service node index
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: sn_name
                                                                            
                                                                            	service node url
                                                                            	**type**\: str
                                                                            
                                                                            .. attribute:: app_id
                                                                            
                                                                            	application ID
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: local_id
                                                                            
                                                                            	local ID
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: vsnode_type
                                                                            
                                                                            	vservice node type
                                                                            	**type**\:  :py:class:`VsvcServiceTypeT <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.VsvcServiceTypeT>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy, self).__init__()

                                                                                self.yang_name = "copy"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('num_byte', (YLeaf(YType.uint32, 'num-byte'), ['int'])),
                                                                                    ('sn_type', (YLeaf(YType.enumeration, 'sn-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'DpssSnidTypeEn', '')])),
                                                                                    ('sn_index', (YLeaf(YType.uint32, 'sn-index'), ['int'])),
                                                                                    ('sn_name', (YLeaf(YType.str, 'sn-name'), ['str'])),
                                                                                    ('app_id', (YLeaf(YType.uint32, 'app-id'), ['int'])),
                                                                                    ('local_id', (YLeaf(YType.uint32, 'local-id'), ['int'])),
                                                                                    ('vsnode_type', (YLeaf(YType.enumeration, 'vsnode-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'VsvcServiceTypeT', '')])),
                                                                                ])
                                                                                self.num_byte = None
                                                                                self.sn_type = None
                                                                                self.sn_index = None
                                                                                self.sn_name = None
                                                                                self.app_id = None
                                                                                self.local_id = None
                                                                                self.vsnode_type = None
                                                                                self._segment_path = lambda: "copy"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy, ['num_byte', 'sn_type', 'sn_index', 'sn_name', 'app_id', 'local_id', 'vsnode_type'], name, value)


                                                                        class Sfrag(Entity):
                                                                            """
                                                                            sfrag
                                                                            
                                                                            .. attribute:: name
                                                                            
                                                                            	Service Fragment Name
                                                                            	**type**\: str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag, self).__init__()

                                                                                self.yang_name = "sfrag"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                                ])
                                                                                self.name = None
                                                                                self._segment_path = lambda: "sfrag"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag, ['name'], name, value)


                                                                        class Redirect(Entity):
                                                                            """
                                                                            redirect
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect, self).__init__()

                                                                                self.yang_name = "redirect"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                ])
                                                                                self.value = None
                                                                                self.type = None
                                                                                self._segment_path = lambda: "redirect"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect, ['value', 'type'], name, value)


                                                                        class OutIntf(Entity):
                                                                            """
                                                                            out intf
                                                                            
                                                                            .. attribute:: out_ifname
                                                                            
                                                                            	output interface name
                                                                            	**type**\: str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf, self).__init__()

                                                                                self.yang_name = "out-intf"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('out_ifname', (YLeaf(YType.str, 'out-ifname'), ['str'])),
                                                                                ])
                                                                                self.out_ifname = None
                                                                                self._segment_path = lambda: "out-intf"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf, ['out_ifname'], name, value)


                                                                        class ServFunc(Entity):
                                                                            """
                                                                            serv func
                                                                            
                                                                            .. attribute:: path_id
                                                                            
                                                                            	service path id
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: service_index
                                                                            
                                                                            	service path index
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: meta_name
                                                                            
                                                                            	metadata name
                                                                            	**type**\: str
                                                                            
                                                                            .. attribute:: vs_index
                                                                            
                                                                            	vservice index
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc, self).__init__()

                                                                                self.yang_name = "serv-func"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('path_id', (YLeaf(YType.uint32, 'path-id'), ['int'])),
                                                                                    ('service_index', (YLeaf(YType.uint8, 'service-index'), ['int'])),
                                                                                    ('meta_name', (YLeaf(YType.str, 'meta-name'), ['str'])),
                                                                                    ('vs_index', (YLeaf(YType.uint32, 'vs-index'), ['int'])),
                                                                                ])
                                                                                self.path_id = None
                                                                                self.service_index = None
                                                                                self.meta_name = None
                                                                                self.vs_index = None
                                                                                self._segment_path = lambda: "serv-func"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc, ['path_id', 'service_index', 'meta_name', 'vs_index'], name, value)


                                                                        class Police(Entity):
                                                                            """
                                                                            police
                                                                            
                                                                            .. attribute:: rate
                                                                            
                                                                            	rate
                                                                            	**type**\:  :py:class:`Rate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate>`
                                                                            
                                                                            .. attribute:: burst
                                                                            
                                                                            	burst
                                                                            	**type**\:  :py:class:`Burst <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst>`
                                                                            
                                                                            .. attribute:: peak_rate
                                                                            
                                                                            	peak rate
                                                                            	**type**\:  :py:class:`PeakRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate>`
                                                                            
                                                                            .. attribute:: peak_burst
                                                                            
                                                                            	peak burst
                                                                            	**type**\:  :py:class:`PeakBurst <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst>`
                                                                            
                                                                            .. attribute:: cdvt
                                                                            
                                                                            	cdvt
                                                                            	**type**\:  :py:class:`Cdvt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt>`
                                                                            
                                                                            .. attribute:: conform_actns
                                                                            
                                                                            	conform actns
                                                                            	**type**\:  :py:class:`ConformActns <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns>`
                                                                            
                                                                            .. attribute:: exceed_actns
                                                                            
                                                                            	exceed actns
                                                                            	**type**\:  :py:class:`ExceedActns <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns>`
                                                                            
                                                                            .. attribute:: violate_actns
                                                                            
                                                                            	violate actns
                                                                            	**type**\:  :py:class:`ViolateActns <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns>`
                                                                            
                                                                            .. attribute:: confclass_encode
                                                                            
                                                                            	confclass encode
                                                                            	**type**\:  :py:class:`ConfclassEncode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode>`
                                                                            
                                                                            .. attribute:: confclass_p
                                                                            
                                                                            	confclass p
                                                                            	**type**\:  :py:class:`ConfclassP <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP>`
                                                                            
                                                                            .. attribute:: excdclass_encode
                                                                            
                                                                            	excdclass encode
                                                                            	**type**\:  :py:class:`ExcdclassEncode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode>`
                                                                            
                                                                            .. attribute:: excdclass_p
                                                                            
                                                                            	excdclass p
                                                                            	**type**\:  :py:class:`ExcdclassP <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP>`
                                                                            
                                                                            .. attribute:: flags
                                                                            
                                                                            	flags
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: police_flags
                                                                            
                                                                            	police flags
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: sbuck_name
                                                                            
                                                                            	sbuck name
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..65
                                                                            
                                                                            .. attribute:: sbuck_type
                                                                            
                                                                            	sbuck type
                                                                            	**type**\:  :py:class:`SharedBucketType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.SharedBucketType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police, self).__init__()

                                                                                self.yang_name = "police"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("rate", ("rate", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate)), ("burst", ("burst", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst)), ("peak-rate", ("peak_rate", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate)), ("peak-burst", ("peak_burst", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst)), ("cdvt", ("cdvt", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt)), ("conform-actns", ("conform_actns", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns)), ("exceed-actns", ("exceed_actns", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns)), ("violate-actns", ("violate_actns", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns)), ("confclass-encode", ("confclass_encode", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode)), ("confclass-p", ("confclass_p", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP)), ("excdclass-encode", ("excdclass_encode", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode)), ("excdclass-p", ("excdclass_p", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                    ('police_flags', (YLeaf(YType.uint32, 'police-flags'), ['int'])),
                                                                                    ('sbuck_name', (YLeaf(YType.str, 'sbuck-name'), ['str'])),
                                                                                    ('sbuck_type', (YLeaf(YType.enumeration, 'sbuck-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'SharedBucketType', '')])),
                                                                                ])
                                                                                self.flags = None
                                                                                self.police_flags = None
                                                                                self.sbuck_name = None
                                                                                self.sbuck_type = None

                                                                                self.rate = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate()
                                                                                self.rate.parent = self
                                                                                self._children_name_map["rate"] = "rate"

                                                                                self.burst = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst()
                                                                                self.burst.parent = self
                                                                                self._children_name_map["burst"] = "burst"

                                                                                self.peak_rate = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate()
                                                                                self.peak_rate.parent = self
                                                                                self._children_name_map["peak_rate"] = "peak-rate"

                                                                                self.peak_burst = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst()
                                                                                self.peak_burst.parent = self
                                                                                self._children_name_map["peak_burst"] = "peak-burst"

                                                                                self.cdvt = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt()
                                                                                self.cdvt.parent = self
                                                                                self._children_name_map["cdvt"] = "cdvt"

                                                                                self.conform_actns = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns()
                                                                                self.conform_actns.parent = self
                                                                                self._children_name_map["conform_actns"] = "conform-actns"

                                                                                self.exceed_actns = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns()
                                                                                self.exceed_actns.parent = self
                                                                                self._children_name_map["exceed_actns"] = "exceed-actns"

                                                                                self.violate_actns = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns()
                                                                                self.violate_actns.parent = self
                                                                                self._children_name_map["violate_actns"] = "violate-actns"

                                                                                self.confclass_encode = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode()
                                                                                self.confclass_encode.parent = self
                                                                                self._children_name_map["confclass_encode"] = "confclass-encode"

                                                                                self.confclass_p = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP()
                                                                                self.confclass_p.parent = self
                                                                                self._children_name_map["confclass_p"] = "confclass-p"

                                                                                self.excdclass_encode = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode()
                                                                                self.excdclass_encode.parent = self
                                                                                self._children_name_map["excdclass_encode"] = "excdclass-encode"

                                                                                self.excdclass_p = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP()
                                                                                self.excdclass_p.parent = self
                                                                                self._children_name_map["excdclass_p"] = "excdclass-p"
                                                                                self._segment_path = lambda: "police"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police, ['flags', 'police_flags', 'sbuck_name', 'sbuck_type'], name, value)


                                                                            class Rate(Entity):
                                                                                """
                                                                                rate
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate, self).__init__()

                                                                                    self.yang_name = "rate"
                                                                                    self.yang_parent_name = "police"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.unit = None
                                                                                    self._segment_path = lambda: "rate"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate, ['value', 'unit'], name, value)


                                                                            class Burst(Entity):
                                                                                """
                                                                                burst
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst, self).__init__()

                                                                                    self.yang_name = "burst"
                                                                                    self.yang_parent_name = "police"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.unit = None
                                                                                    self._segment_path = lambda: "burst"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst, ['value', 'unit'], name, value)


                                                                            class PeakRate(Entity):
                                                                                """
                                                                                peak rate
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate, self).__init__()

                                                                                    self.yang_name = "peak-rate"
                                                                                    self.yang_parent_name = "police"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.unit = None
                                                                                    self._segment_path = lambda: "peak-rate"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate, ['value', 'unit'], name, value)


                                                                            class PeakBurst(Entity):
                                                                                """
                                                                                peak burst
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst, self).__init__()

                                                                                    self.yang_name = "peak-burst"
                                                                                    self.yang_parent_name = "police"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.unit = None
                                                                                    self._segment_path = lambda: "peak-burst"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst, ['value', 'unit'], name, value)


                                                                            class Cdvt(Entity):
                                                                                """
                                                                                cdvt
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt, self).__init__()

                                                                                    self.yang_name = "cdvt"
                                                                                    self.yang_parent_name = "police"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.unit = None
                                                                                    self._segment_path = lambda: "cdvt"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt, ['value', 'unit'], name, value)


                                                                            class ConformActns(Entity):
                                                                                """
                                                                                conform actns
                                                                                
                                                                                .. attribute:: police_action_array
                                                                                
                                                                                	police action array
                                                                                	**type**\: list of  		 :py:class:`PoliceActionArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns, self).__init__()

                                                                                    self.yang_name = "conform-actns"
                                                                                    self.yang_parent_name = "police"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("police-action-array", ("police_action_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.police_action_array = YList(self)
                                                                                    self._segment_path = lambda: "conform-actns"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns, [], name, value)


                                                                                class PoliceActionArray(Entity):
                                                                                    """
                                                                                    police action array
                                                                                    
                                                                                    .. attribute:: mark
                                                                                    
                                                                                    	mark
                                                                                    	**type**\:  :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark>`
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	type
                                                                                    	**type**\:  :py:class:`PoliceActionTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PoliceActionTypeEn>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray, self).__init__()

                                                                                        self.yang_name = "police-action-array"
                                                                                        self.yang_parent_name = "conform-actns"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("mark", ("mark", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark))])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PoliceActionTypeEn', '')])),
                                                                                        ])
                                                                                        self.type = None

                                                                                        self.mark = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark()
                                                                                        self.mark.parent = self
                                                                                        self._children_name_map["mark"] = "mark"
                                                                                        self._segment_path = lambda: "police-action-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray, ['type'], name, value)


                                                                                    class Mark(Entity):
                                                                                        """
                                                                                        mark
                                                                                        
                                                                                        .. attribute:: type
                                                                                        
                                                                                        	type
                                                                                        	**type**\:  :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                                        
                                                                                        .. attribute:: mark_flags
                                                                                        
                                                                                        	mark flags
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        .. attribute:: value
                                                                                        
                                                                                        	value
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark, self).__init__()

                                                                                            self.yang_name = "mark"
                                                                                            self.yang_parent_name = "police-action-array"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MarkTypeEn', '')])),
                                                                                                ('mark_flags', (YLeaf(YType.uint32, 'mark-flags'), ['int'])),
                                                                                                ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                            ])
                                                                                            self.type = None
                                                                                            self.mark_flags = None
                                                                                            self.value = None
                                                                                            self._segment_path = lambda: "mark"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark, ['type', 'mark_flags', 'value'], name, value)


                                                                            class ExceedActns(Entity):
                                                                                """
                                                                                exceed actns
                                                                                
                                                                                .. attribute:: police_action_array
                                                                                
                                                                                	police action array
                                                                                	**type**\: list of  		 :py:class:`PoliceActionArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns, self).__init__()

                                                                                    self.yang_name = "exceed-actns"
                                                                                    self.yang_parent_name = "police"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("police-action-array", ("police_action_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.police_action_array = YList(self)
                                                                                    self._segment_path = lambda: "exceed-actns"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns, [], name, value)


                                                                                class PoliceActionArray(Entity):
                                                                                    """
                                                                                    police action array
                                                                                    
                                                                                    .. attribute:: mark
                                                                                    
                                                                                    	mark
                                                                                    	**type**\:  :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark>`
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	type
                                                                                    	**type**\:  :py:class:`PoliceActionTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PoliceActionTypeEn>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray, self).__init__()

                                                                                        self.yang_name = "police-action-array"
                                                                                        self.yang_parent_name = "exceed-actns"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("mark", ("mark", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark))])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PoliceActionTypeEn', '')])),
                                                                                        ])
                                                                                        self.type = None

                                                                                        self.mark = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark()
                                                                                        self.mark.parent = self
                                                                                        self._children_name_map["mark"] = "mark"
                                                                                        self._segment_path = lambda: "police-action-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray, ['type'], name, value)


                                                                                    class Mark(Entity):
                                                                                        """
                                                                                        mark
                                                                                        
                                                                                        .. attribute:: type
                                                                                        
                                                                                        	type
                                                                                        	**type**\:  :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                                        
                                                                                        .. attribute:: mark_flags
                                                                                        
                                                                                        	mark flags
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        .. attribute:: value
                                                                                        
                                                                                        	value
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark, self).__init__()

                                                                                            self.yang_name = "mark"
                                                                                            self.yang_parent_name = "police-action-array"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MarkTypeEn', '')])),
                                                                                                ('mark_flags', (YLeaf(YType.uint32, 'mark-flags'), ['int'])),
                                                                                                ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                            ])
                                                                                            self.type = None
                                                                                            self.mark_flags = None
                                                                                            self.value = None
                                                                                            self._segment_path = lambda: "mark"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark, ['type', 'mark_flags', 'value'], name, value)


                                                                            class ViolateActns(Entity):
                                                                                """
                                                                                violate actns
                                                                                
                                                                                .. attribute:: police_action_array
                                                                                
                                                                                	police action array
                                                                                	**type**\: list of  		 :py:class:`PoliceActionArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns, self).__init__()

                                                                                    self.yang_name = "violate-actns"
                                                                                    self.yang_parent_name = "police"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("police-action-array", ("police_action_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.police_action_array = YList(self)
                                                                                    self._segment_path = lambda: "violate-actns"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns, [], name, value)


                                                                                class PoliceActionArray(Entity):
                                                                                    """
                                                                                    police action array
                                                                                    
                                                                                    .. attribute:: mark
                                                                                    
                                                                                    	mark
                                                                                    	**type**\:  :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark>`
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	type
                                                                                    	**type**\:  :py:class:`PoliceActionTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PoliceActionTypeEn>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray, self).__init__()

                                                                                        self.yang_name = "police-action-array"
                                                                                        self.yang_parent_name = "violate-actns"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("mark", ("mark", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark))])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PoliceActionTypeEn', '')])),
                                                                                        ])
                                                                                        self.type = None

                                                                                        self.mark = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark()
                                                                                        self.mark.parent = self
                                                                                        self._children_name_map["mark"] = "mark"
                                                                                        self._segment_path = lambda: "police-action-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray, ['type'], name, value)


                                                                                    class Mark(Entity):
                                                                                        """
                                                                                        mark
                                                                                        
                                                                                        .. attribute:: type
                                                                                        
                                                                                        	type
                                                                                        	**type**\:  :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                                        
                                                                                        .. attribute:: mark_flags
                                                                                        
                                                                                        	mark flags
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        .. attribute:: value
                                                                                        
                                                                                        	value
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark, self).__init__()

                                                                                            self.yang_name = "mark"
                                                                                            self.yang_parent_name = "police-action-array"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MarkTypeEn', '')])),
                                                                                                ('mark_flags', (YLeaf(YType.uint32, 'mark-flags'), ['int'])),
                                                                                                ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                            ])
                                                                                            self.type = None
                                                                                            self.mark_flags = None
                                                                                            self.value = None
                                                                                            self._segment_path = lambda: "mark"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark, ['type', 'mark_flags', 'value'], name, value)


                                                                            class ConfclassEncode(Entity):
                                                                                """
                                                                                confclass encode
                                                                                
                                                                                .. attribute:: inline_cmap
                                                                                
                                                                                	inline cmap
                                                                                	**type**\:  :py:class:`InlineCmap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap>`
                                                                                
                                                                                .. attribute:: enc
                                                                                
                                                                                	enc
                                                                                	**type**\:  :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                                
                                                                                .. attribute:: class_name
                                                                                
                                                                                	class name
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..65
                                                                                
                                                                                .. attribute:: hd
                                                                                
                                                                                	hd
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..18446744073709551615
                                                                                
                                                                                .. attribute:: idx
                                                                                
                                                                                	idx
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode, self).__init__()

                                                                                    self.yang_name = "confclass-encode"
                                                                                    self.yang_parent_name = "police"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("inline-cmap", ("inline_cmap", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('enc', (YLeaf(YType.enumeration, 'enc'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyObjEncEn', '')])),
                                                                                        ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                                                        ('hd', (YLeaf(YType.uint64, 'hd'), ['int'])),
                                                                                        ('idx', (YLeaf(YType.uint8, 'idx'), ['int'])),
                                                                                    ])
                                                                                    self.enc = None
                                                                                    self.class_name = None
                                                                                    self.hd = None
                                                                                    self.idx = None

                                                                                    self.inline_cmap = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap()
                                                                                    self.inline_cmap.parent = self
                                                                                    self._children_name_map["inline_cmap"] = "inline-cmap"
                                                                                    self._segment_path = lambda: "confclass-encode"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode, ['enc', 'class_name', 'hd', 'idx'], name, value)


                                                                                class InlineCmap(Entity):
                                                                                    """
                                                                                    inline cmap
                                                                                    
                                                                                    .. attribute:: match_infop
                                                                                    
                                                                                    	Pointer to the first Match info
                                                                                    	**type**\:  :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop>`
                                                                                    
                                                                                    .. attribute:: mode
                                                                                    
                                                                                    	Inline Class\-Map Mode Match any/all
                                                                                    	**type**\:  :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                                    
                                                                                    .. attribute:: flags
                                                                                    
                                                                                    	Inline Class\-Map flags
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: match_count
                                                                                    
                                                                                    	Number of Match infos
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap, self).__init__()

                                                                                        self.yang_name = "inline-cmap"
                                                                                        self.yang_parent_name = "confclass-encode"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("match-infop", ("match_infop", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop))])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapModeEn', '')])),
                                                                                            ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                            ('match_count', (YLeaf(YType.uint32, 'match-count'), ['int'])),
                                                                                        ])
                                                                                        self.mode = None
                                                                                        self.flags = None
                                                                                        self.match_count = None

                                                                                        self.match_infop = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop()
                                                                                        self.match_infop.parent = self
                                                                                        self._children_name_map["match_infop"] = "match-infop"
                                                                                        self._segment_path = lambda: "inline-cmap"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap, ['mode', 'flags', 'match_count'], name, value)


                                                                                    class MatchInfop(Entity):
                                                                                        """
                                                                                        Pointer to the first Match info
                                                                                        
                                                                                        .. attribute:: class_match_info_st
                                                                                        
                                                                                        	class match info st
                                                                                        	**type**\: list of  		 :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop, self).__init__()

                                                                                            self.yang_name = "match-infop"
                                                                                            self.yang_parent_name = "inline-cmap"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("class-match-info-st", ("class_match_info_st", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.class_match_info_st = YList(self)
                                                                                            self._segment_path = lambda: "match-infop"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop, [], name, value)


                                                                                        class ClassMatchInfoSt(Entity):
                                                                                            """
                                                                                            class match info st
                                                                                            
                                                                                            .. attribute:: match_data
                                                                                            
                                                                                            	Match criteria
                                                                                            	**type**\:  :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                            
                                                                                            .. attribute:: flags
                                                                                            
                                                                                            	Flags
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                                self.yang_name = "class-match-info-st"
                                                                                                self.yang_parent_name = "match-infop"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("match-data", ("match_data", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData))])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                                ])
                                                                                                self.flags = None

                                                                                                self.match_data = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                                self.match_data.parent = self
                                                                                                self._children_name_map["match_data"] = "match-data"
                                                                                                self._segment_path = lambda: "class-match-info-st"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                            class MatchData(Entity):
                                                                                                """
                                                                                                Match criteria
                                                                                                
                                                                                                .. attribute:: ipv4_dscp
                                                                                                
                                                                                                	IPv4 DSCP
                                                                                                	**type**\:  :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                                
                                                                                                .. attribute:: ipv6_dscp
                                                                                                
                                                                                                	IPv6 DSCP
                                                                                                	**type**\:  :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                                
                                                                                                .. attribute:: dscp
                                                                                                
                                                                                                	Match DSCP range array
                                                                                                	**type**\:  :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                                
                                                                                                .. attribute:: ipv4_prec
                                                                                                
                                                                                                	IPv4 Precedence
                                                                                                	**type**\:  :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                                
                                                                                                .. attribute:: ipv6_prec
                                                                                                
                                                                                                	IPv6 Precedence
                                                                                                	**type**\:  :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                                
                                                                                                .. attribute:: prec
                                                                                                
                                                                                                	Match Precedence array
                                                                                                	**type**\:  :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                                
                                                                                                .. attribute:: discard_class
                                                                                                
                                                                                                	Match Discard Class array
                                                                                                	**type**\:  :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                                
                                                                                                .. attribute:: qos_group
                                                                                                
                                                                                                	Match QoS group array
                                                                                                	**type**\:  :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                                
                                                                                                .. attribute:: traffic_class
                                                                                                
                                                                                                	Match Traffic class array
                                                                                                	**type**\:  :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                                
                                                                                                .. attribute:: proto
                                                                                                
                                                                                                	Match Protocol array
                                                                                                	**type**\:  :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                                
                                                                                                .. attribute:: icmp_v4
                                                                                                
                                                                                                	Match ICMPV4 Protocol
                                                                                                	**type**\:  :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                                
                                                                                                .. attribute:: icmp_v6
                                                                                                
                                                                                                	Match ICMPV6 Protocol array
                                                                                                	**type**\:  :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                                
                                                                                                .. attribute:: ipv4_packet_len
                                                                                                
                                                                                                	IPv4 packet length array
                                                                                                	**type**\:  :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                                
                                                                                                .. attribute:: ipv6_packet_len
                                                                                                
                                                                                                	IPv6 packet length array
                                                                                                	**type**\:  :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                                
                                                                                                .. attribute:: packet_len
                                                                                                
                                                                                                	Match packet length array
                                                                                                	**type**\:  :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                                
                                                                                                .. attribute:: flow_tag
                                                                                                
                                                                                                	Match flow\-tag array
                                                                                                	**type**\:  :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                                
                                                                                                .. attribute:: tcp_flag
                                                                                                
                                                                                                	Match tcp flag value
                                                                                                	**type**\:  :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                                
                                                                                                .. attribute:: icmpv4_type
                                                                                                
                                                                                                	Match ipv4 icmp type
                                                                                                	**type**\:  :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                                
                                                                                                .. attribute:: icmpv4_code
                                                                                                
                                                                                                	Match ipv4 icmp code
                                                                                                	**type**\:  :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                                
                                                                                                .. attribute:: icmpv6_type
                                                                                                
                                                                                                	Match ipv6 icmp type
                                                                                                	**type**\:  :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                                
                                                                                                .. attribute:: icmpv6_code
                                                                                                
                                                                                                	Match ipv6 icmp code
                                                                                                	**type**\:  :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                                
                                                                                                .. attribute:: mpls_exp
                                                                                                
                                                                                                	Match MPLS experimental topmost array
                                                                                                	**type**\:  :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                                
                                                                                                .. attribute:: mpls_exp_imp
                                                                                                
                                                                                                	Match MPLS experimental imposition array
                                                                                                	**type**\:  :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                                
                                                                                                .. attribute:: mpls_disp_ipv4_acl
                                                                                                
                                                                                                	MPLS Disposition IPv4 Access\-list
                                                                                                	**type**\:  :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                                
                                                                                                .. attribute:: mpls_disp_ipv6_acl
                                                                                                
                                                                                                	MPLS Disposition IPv6 Access\-list
                                                                                                	**type**\:  :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                                
                                                                                                .. attribute:: mpls_top_label
                                                                                                
                                                                                                	MPLS Topmost LABEL
                                                                                                	**type**\:  :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                                
                                                                                                .. attribute:: cos
                                                                                                
                                                                                                	Match CoS array
                                                                                                	**type**\:  :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                                
                                                                                                .. attribute:: cos_inr
                                                                                                
                                                                                                	Match inner header CoS
                                                                                                	**type**\:  :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                                
                                                                                                .. attribute:: dei
                                                                                                
                                                                                                	Match DEI Bit
                                                                                                	**type**\:  :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                                
                                                                                                .. attribute:: dei_inr
                                                                                                
                                                                                                	Match inner DEI Bit
                                                                                                	**type**\:  :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                                
                                                                                                .. attribute:: vlan
                                                                                                
                                                                                                	Match VLAN array
                                                                                                	**type**\:  :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                                
                                                                                                .. attribute:: vlan_inr
                                                                                                
                                                                                                	Match inner header VLAN range array
                                                                                                	**type**\:  :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                                
                                                                                                .. attribute:: fr_dlci
                                                                                                
                                                                                                	Match FR DLCI range array
                                                                                                	**type**\:  :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                                
                                                                                                .. attribute:: src_mac
                                                                                                
                                                                                                	Match Source MAC address
                                                                                                	**type**\:  :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                                
                                                                                                .. attribute:: dst_mac
                                                                                                
                                                                                                	Match Destination MAC address
                                                                                                	**type**\:  :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                                
                                                                                                .. attribute:: atm_clp
                                                                                                
                                                                                                	Match ATM CLP level
                                                                                                	**type**\:  :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                                
                                                                                                .. attribute:: fr_de
                                                                                                
                                                                                                	Match FR DE value
                                                                                                	**type**\:  :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                                
                                                                                                .. attribute:: ipv4_acl
                                                                                                
                                                                                                	IPv4 Access\-list
                                                                                                	**type**\:  :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                                
                                                                                                .. attribute:: ipv6_acl
                                                                                                
                                                                                                	IPv6 Access\-list
                                                                                                	**type**\:  :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                                
                                                                                                .. attribute:: ether_service_acl
                                                                                                
                                                                                                	Ethernet\-Services Access\-list
                                                                                                	**type**\:  :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                                
                                                                                                .. attribute:: avail_id
                                                                                                
                                                                                                	Available Identifiers
                                                                                                	**type**\:  :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                                
                                                                                                .. attribute:: media_type
                                                                                                
                                                                                                	Media Type
                                                                                                	**type**\:  :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                                
                                                                                                .. attribute:: subs_protocol
                                                                                                
                                                                                                	Protocol
                                                                                                	**type**\:  :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                                
                                                                                                .. attribute:: dnis
                                                                                                
                                                                                                	DNIS
                                                                                                	**type**\:  :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                                
                                                                                                .. attribute:: dnis_regex
                                                                                                
                                                                                                	DNIS Regular Expression
                                                                                                	**type**\:  :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                                
                                                                                                .. attribute:: domain
                                                                                                
                                                                                                	Domain Name
                                                                                                	**type**\:  :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                                
                                                                                                .. attribute:: domain_regex
                                                                                                
                                                                                                	Domain Regular Expression
                                                                                                	**type**\:  :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                                
                                                                                                .. attribute:: nas_port
                                                                                                
                                                                                                	NAS Port
                                                                                                	**type**\:  :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                                
                                                                                                .. attribute:: service_name
                                                                                                
                                                                                                	Service Name
                                                                                                	**type**\:  :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                                
                                                                                                .. attribute:: service_name_regex
                                                                                                
                                                                                                	Service Name Regular Exp
                                                                                                	**type**\:  :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                                
                                                                                                .. attribute:: src_addr_ipv4
                                                                                                
                                                                                                	Source Address IPV4
                                                                                                	**type**\:  :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                                
                                                                                                .. attribute:: dst_addr_ipv4
                                                                                                
                                                                                                	Destination Address IPV4
                                                                                                	**type**\:  :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                                
                                                                                                .. attribute:: src_addr_ipv6
                                                                                                
                                                                                                	Source Address IPV6
                                                                                                	**type**\:  :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                                
                                                                                                .. attribute:: dst_addr_ipv6
                                                                                                
                                                                                                	Destination Address IPV6
                                                                                                	**type**\:  :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                                
                                                                                                .. attribute:: src_addr_mac
                                                                                                
                                                                                                	Source Address MAC
                                                                                                	**type**\:  :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                                
                                                                                                .. attribute:: timer
                                                                                                
                                                                                                	Timer
                                                                                                	**type**\:  :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                                
                                                                                                .. attribute:: timer_regexp
                                                                                                
                                                                                                	Timer Regular Expression
                                                                                                	**type**\:  :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                                
                                                                                                .. attribute:: tunnel_name
                                                                                                
                                                                                                	Tunnel Name
                                                                                                	**type**\:  :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                                
                                                                                                .. attribute:: tunnel_name_regex
                                                                                                
                                                                                                	Tunnel Name Regular Expression
                                                                                                	**type**\:  :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                                
                                                                                                .. attribute:: user_name
                                                                                                
                                                                                                	User Name
                                                                                                	**type**\:  :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                                
                                                                                                .. attribute:: user_name_regex
                                                                                                
                                                                                                	User Name Regular Expression
                                                                                                	**type**\:  :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                                
                                                                                                .. attribute:: auth_username
                                                                                                
                                                                                                	Authenticated User Name
                                                                                                	**type**\:  :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                                
                                                                                                .. attribute:: auth_username_regex
                                                                                                
                                                                                                	Authenticated User Name RegEx
                                                                                                	**type**\:  :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                                
                                                                                                .. attribute:: unauth_username
                                                                                                
                                                                                                	Unauthenticated User Name
                                                                                                	**type**\:  :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                                
                                                                                                .. attribute:: unauth_username_regex
                                                                                                
                                                                                                	Unauthenticated User Name RegEx
                                                                                                	**type**\:  :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                                
                                                                                                .. attribute:: auth_domain
                                                                                                
                                                                                                	Authenticated domain name
                                                                                                	**type**\:  :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                                
                                                                                                .. attribute:: auth_domain_regex
                                                                                                
                                                                                                	Authenticated Domain Name RegEx
                                                                                                	**type**\:  :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                                
                                                                                                .. attribute:: unauth_domain
                                                                                                
                                                                                                	Unauthenticated Domain Name
                                                                                                	**type**\:  :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                                
                                                                                                .. attribute:: unauth_domain_regex
                                                                                                
                                                                                                	Unauthenticated Domain Name RegEx
                                                                                                	**type**\:  :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                                
                                                                                                .. attribute:: vendor_id
                                                                                                
                                                                                                	Vendor ID
                                                                                                	**type**\:  :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                                
                                                                                                .. attribute:: vendor_id_regex
                                                                                                
                                                                                                	Vendor ID RegEx
                                                                                                	**type**\:  :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                                
                                                                                                .. attribute:: access_interface
                                                                                                
                                                                                                	Access interface
                                                                                                	**type**\:  :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                                
                                                                                                .. attribute:: input_interface
                                                                                                
                                                                                                	Input interface
                                                                                                	**type**\:  :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                                
                                                                                                .. attribute:: input_intfhdl
                                                                                                
                                                                                                	Input interface handle
                                                                                                	**type**\:  :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                                
                                                                                                .. attribute:: ethertype
                                                                                                
                                                                                                	Ethernet type
                                                                                                	**type**\:  :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                                
                                                                                                .. attribute:: flow_key_data
                                                                                                
                                                                                                	Flow key structure
                                                                                                	**type**\:  :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                                
                                                                                                .. attribute:: dhcp_client_id
                                                                                                
                                                                                                	Dhcp Client ID
                                                                                                	**type**\:  :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                                
                                                                                                .. attribute:: dhcp_client_id_regex
                                                                                                
                                                                                                	Dhcp Client ID RegEx
                                                                                                	**type**\:  :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                                
                                                                                                .. attribute:: circuit_id
                                                                                                
                                                                                                	Circuit ID
                                                                                                	**type**\:  :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                                
                                                                                                .. attribute:: circuit_id_regex
                                                                                                
                                                                                                	Circuit ID RegEx
                                                                                                	**type**\:  :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                                
                                                                                                .. attribute:: remote_id
                                                                                                
                                                                                                	Remote ID
                                                                                                	**type**\:  :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                                
                                                                                                .. attribute:: remote_id_regex
                                                                                                
                                                                                                	Remote ID RegEx
                                                                                                	**type**\:  :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                                
                                                                                                .. attribute:: src_port
                                                                                                
                                                                                                	Source port
                                                                                                	**type**\:  :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                                
                                                                                                .. attribute:: dst_port
                                                                                                
                                                                                                	Destination port
                                                                                                	**type**\:  :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	type
                                                                                                	**type**\:  :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                                
                                                                                                .. attribute:: mpls_top_eos
                                                                                                
                                                                                                	MPLS Topmost EOS
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: fragment_type
                                                                                                
                                                                                                	Fragment type
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: authen_status
                                                                                                
                                                                                                	Authentication Status
                                                                                                	**type**\:  :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                                
                                                                                                .. attribute:: mlp_negotiated
                                                                                                
                                                                                                	MLP Negotiated
                                                                                                	**type**\:  :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                                    self.yang_name = "match-data"
                                                                                                    self.yang_parent_name = "class-match-info-st"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv4-dscp", ("ipv4_dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp)), ("ipv6-dscp", ("ipv6_dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp)), ("dscp", ("dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp)), ("ipv4-prec", ("ipv4_prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec)), ("ipv6-prec", ("ipv6_prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec)), ("prec", ("prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec)), ("discard-class", ("discard_class", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass)), ("qos-group", ("qos_group", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup)), ("traffic-class", ("traffic_class", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass)), ("proto", ("proto", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto)), ("icmp-v4", ("icmp_v4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4)), ("icmp-v6", ("icmp_v6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6)), ("ipv4-packet-len", ("ipv4_packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen)), ("ipv6-packet-len", ("ipv6_packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen)), ("packet-len", ("packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen)), ("flow-tag", ("flow_tag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag)), ("tcp-flag", ("tcp_flag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag)), ("icmpv4-type", ("icmpv4_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type)), ("icmpv4-code", ("icmpv4_code", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code)), ("icmpv6-type", ("icmpv6_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type)), ("icmpv6-code", ("icmpv6_code", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code)), ("mpls-exp", ("mpls_exp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp)), ("mpls-exp-imp", ("mpls_exp_imp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp)), ("mpls-disp-ipv4-acl", ("mpls_disp_ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl)), ("mpls-disp-ipv6-acl", ("mpls_disp_ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl)), ("mpls-top-label", ("mpls_top_label", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel)), ("cos", ("cos", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos)), ("cos-inr", ("cos_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr)), ("dei", ("dei", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei)), ("dei-inr", ("dei_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr)), ("vlan", ("vlan", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan)), ("vlan-inr", ("vlan_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)), ("fr-dlci", ("fr_dlci", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci)), ("src-mac", ("src_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac)), ("dst-mac", ("dst_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac)), ("atm-clp", ("atm_clp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp)), ("fr-de", ("fr_de", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe)), ("ipv4-acl", ("ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl)), ("ipv6-acl", ("ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl)), ("ether-service-acl", ("ether_service_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl)), ("avail-id", ("avail_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId)), ("media-type", ("media_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType)), ("subs-protocol", ("subs_protocol", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol)), ("dnis", ("dnis", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis)), ("dnis-regex", ("dnis_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex)), ("domain", ("domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain)), ("domain-regex", ("domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex)), ("nas-port", ("nas_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort)), ("service-name", ("service_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName)), ("service-name-regex", ("service_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex)), ("src-addr-ipv4", ("src_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4)), ("dst-addr-ipv4", ("dst_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4)), ("src-addr-ipv6", ("src_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6)), ("dst-addr-ipv6", ("dst_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6)), ("src-addr-mac", ("src_addr_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac)), ("timer", ("timer", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer)), ("timer-regexp", ("timer_regexp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp)), ("tunnel-name", ("tunnel_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName)), ("tunnel-name-regex", ("tunnel_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex)), ("user-name", ("user_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName)), ("user-name-regex", ("user_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex)), ("auth-username", ("auth_username", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername)), ("auth-username-regex", ("auth_username_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex)), ("unauth-username", ("unauth_username", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername)), ("unauth-username-regex", ("unauth_username_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex)), ("auth-domain", ("auth_domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain)), ("auth-domain-regex", ("auth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex)), ("unauth-domain", ("unauth_domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain)), ("unauth-domain-regex", ("unauth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex)), ("vendor-id", ("vendor_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId)), ("vendor-id-regex", ("vendor_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex)), ("access-interface", ("access_interface", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface)), ("input-interface", ("input_interface", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface)), ("input-intfhdl", ("input_intfhdl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl)), ("ethertype", ("ethertype", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype)), ("flow-key-data", ("flow_key_data", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData)), ("dhcp-client-id", ("dhcp_client_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId)), ("dhcp-client-id-regex", ("dhcp_client_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex)), ("circuit-id", ("circuit_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId)), ("circuit-id-regex", ("circuit_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex)), ("remote-id", ("remote_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId)), ("remote-id-regex", ("remote_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex)), ("src-port", ("src_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort)), ("dst-port", ("dst_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort))])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchTypeEn', '')])),
                                                                                                        ('mpls_top_eos', (YLeaf(YType.uint8, 'mpls-top-eos'), ['int'])),
                                                                                                        ('fragment_type', (YLeaf(YType.uint8, 'fragment-type'), ['int'])),
                                                                                                        ('authen_status', (YLeaf(YType.enumeration, 'authen-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchAuthenStatusEn', '')])),
                                                                                                        ('mlp_negotiated', (YLeaf(YType.enumeration, 'mlp-negotiated'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchMlpNegotiatedEn', '')])),
                                                                                                    ])
                                                                                                    self.type = None
                                                                                                    self.mpls_top_eos = None
                                                                                                    self.fragment_type = None
                                                                                                    self.authen_status = None
                                                                                                    self.mlp_negotiated = None

                                                                                                    self.ipv4_dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                                    self.ipv4_dscp.parent = self
                                                                                                    self._children_name_map["ipv4_dscp"] = "ipv4-dscp"

                                                                                                    self.ipv6_dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                                    self.ipv6_dscp.parent = self
                                                                                                    self._children_name_map["ipv6_dscp"] = "ipv6-dscp"

                                                                                                    self.dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                                    self.dscp.parent = self
                                                                                                    self._children_name_map["dscp"] = "dscp"

                                                                                                    self.ipv4_prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                                    self.ipv4_prec.parent = self
                                                                                                    self._children_name_map["ipv4_prec"] = "ipv4-prec"

                                                                                                    self.ipv6_prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                                    self.ipv6_prec.parent = self
                                                                                                    self._children_name_map["ipv6_prec"] = "ipv6-prec"

                                                                                                    self.prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                                    self.prec.parent = self
                                                                                                    self._children_name_map["prec"] = "prec"

                                                                                                    self.discard_class = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                                    self.discard_class.parent = self
                                                                                                    self._children_name_map["discard_class"] = "discard-class"

                                                                                                    self.qos_group = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                                    self.qos_group.parent = self
                                                                                                    self._children_name_map["qos_group"] = "qos-group"

                                                                                                    self.traffic_class = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                                    self.traffic_class.parent = self
                                                                                                    self._children_name_map["traffic_class"] = "traffic-class"

                                                                                                    self.proto = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                                    self.proto.parent = self
                                                                                                    self._children_name_map["proto"] = "proto"

                                                                                                    self.icmp_v4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                                    self.icmp_v4.parent = self
                                                                                                    self._children_name_map["icmp_v4"] = "icmp-v4"

                                                                                                    self.icmp_v6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                                    self.icmp_v6.parent = self
                                                                                                    self._children_name_map["icmp_v6"] = "icmp-v6"

                                                                                                    self.ipv4_packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                                    self.ipv4_packet_len.parent = self
                                                                                                    self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"

                                                                                                    self.ipv6_packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                                    self.ipv6_packet_len.parent = self
                                                                                                    self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"

                                                                                                    self.packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                                    self.packet_len.parent = self
                                                                                                    self._children_name_map["packet_len"] = "packet-len"

                                                                                                    self.flow_tag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                                    self.flow_tag.parent = self
                                                                                                    self._children_name_map["flow_tag"] = "flow-tag"

                                                                                                    self.tcp_flag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                                    self.tcp_flag.parent = self
                                                                                                    self._children_name_map["tcp_flag"] = "tcp-flag"

                                                                                                    self.icmpv4_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                                    self.icmpv4_type.parent = self
                                                                                                    self._children_name_map["icmpv4_type"] = "icmpv4-type"

                                                                                                    self.icmpv4_code = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                                    self.icmpv4_code.parent = self
                                                                                                    self._children_name_map["icmpv4_code"] = "icmpv4-code"

                                                                                                    self.icmpv6_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                                    self.icmpv6_type.parent = self
                                                                                                    self._children_name_map["icmpv6_type"] = "icmpv6-type"

                                                                                                    self.icmpv6_code = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                                    self.icmpv6_code.parent = self
                                                                                                    self._children_name_map["icmpv6_code"] = "icmpv6-code"

                                                                                                    self.mpls_exp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                                    self.mpls_exp.parent = self
                                                                                                    self._children_name_map["mpls_exp"] = "mpls-exp"

                                                                                                    self.mpls_exp_imp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                                    self.mpls_exp_imp.parent = self
                                                                                                    self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"

                                                                                                    self.mpls_disp_ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                                    self.mpls_disp_ipv4_acl.parent = self
                                                                                                    self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"

                                                                                                    self.mpls_disp_ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                                    self.mpls_disp_ipv6_acl.parent = self
                                                                                                    self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"

                                                                                                    self.mpls_top_label = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                                    self.mpls_top_label.parent = self
                                                                                                    self._children_name_map["mpls_top_label"] = "mpls-top-label"

                                                                                                    self.cos = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                                    self.cos.parent = self
                                                                                                    self._children_name_map["cos"] = "cos"

                                                                                                    self.cos_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                                    self.cos_inr.parent = self
                                                                                                    self._children_name_map["cos_inr"] = "cos-inr"

                                                                                                    self.dei = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                                    self.dei.parent = self
                                                                                                    self._children_name_map["dei"] = "dei"

                                                                                                    self.dei_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                                    self.dei_inr.parent = self
                                                                                                    self._children_name_map["dei_inr"] = "dei-inr"

                                                                                                    self.vlan = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                                    self.vlan.parent = self
                                                                                                    self._children_name_map["vlan"] = "vlan"

                                                                                                    self.vlan_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                                    self.vlan_inr.parent = self
                                                                                                    self._children_name_map["vlan_inr"] = "vlan-inr"

                                                                                                    self.fr_dlci = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                                    self.fr_dlci.parent = self
                                                                                                    self._children_name_map["fr_dlci"] = "fr-dlci"

                                                                                                    self.src_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                                    self.src_mac.parent = self
                                                                                                    self._children_name_map["src_mac"] = "src-mac"

                                                                                                    self.dst_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                                    self.dst_mac.parent = self
                                                                                                    self._children_name_map["dst_mac"] = "dst-mac"

                                                                                                    self.atm_clp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                                    self.atm_clp.parent = self
                                                                                                    self._children_name_map["atm_clp"] = "atm-clp"

                                                                                                    self.fr_de = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                                    self.fr_de.parent = self
                                                                                                    self._children_name_map["fr_de"] = "fr-de"

                                                                                                    self.ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                                    self.ipv4_acl.parent = self
                                                                                                    self._children_name_map["ipv4_acl"] = "ipv4-acl"

                                                                                                    self.ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                                    self.ipv6_acl.parent = self
                                                                                                    self._children_name_map["ipv6_acl"] = "ipv6-acl"

                                                                                                    self.ether_service_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                                    self.ether_service_acl.parent = self
                                                                                                    self._children_name_map["ether_service_acl"] = "ether-service-acl"

                                                                                                    self.avail_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                                    self.avail_id.parent = self
                                                                                                    self._children_name_map["avail_id"] = "avail-id"

                                                                                                    self.media_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                                    self.media_type.parent = self
                                                                                                    self._children_name_map["media_type"] = "media-type"

                                                                                                    self.subs_protocol = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                                    self.subs_protocol.parent = self
                                                                                                    self._children_name_map["subs_protocol"] = "subs-protocol"

                                                                                                    self.dnis = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                                    self.dnis.parent = self
                                                                                                    self._children_name_map["dnis"] = "dnis"

                                                                                                    self.dnis_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                                    self.dnis_regex.parent = self
                                                                                                    self._children_name_map["dnis_regex"] = "dnis-regex"

                                                                                                    self.domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                                    self.domain.parent = self
                                                                                                    self._children_name_map["domain"] = "domain"

                                                                                                    self.domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                                    self.domain_regex.parent = self
                                                                                                    self._children_name_map["domain_regex"] = "domain-regex"

                                                                                                    self.nas_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                                    self.nas_port.parent = self
                                                                                                    self._children_name_map["nas_port"] = "nas-port"

                                                                                                    self.service_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                                    self.service_name.parent = self
                                                                                                    self._children_name_map["service_name"] = "service-name"

                                                                                                    self.service_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                                    self.service_name_regex.parent = self
                                                                                                    self._children_name_map["service_name_regex"] = "service-name-regex"

                                                                                                    self.src_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                                    self.src_addr_ipv4.parent = self
                                                                                                    self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"

                                                                                                    self.dst_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                                    self.dst_addr_ipv4.parent = self
                                                                                                    self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"

                                                                                                    self.src_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                                    self.src_addr_ipv6.parent = self
                                                                                                    self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"

                                                                                                    self.dst_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                                    self.dst_addr_ipv6.parent = self
                                                                                                    self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"

                                                                                                    self.src_addr_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                                    self.src_addr_mac.parent = self
                                                                                                    self._children_name_map["src_addr_mac"] = "src-addr-mac"

                                                                                                    self.timer = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                                    self.timer.parent = self
                                                                                                    self._children_name_map["timer"] = "timer"

                                                                                                    self.timer_regexp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                                    self.timer_regexp.parent = self
                                                                                                    self._children_name_map["timer_regexp"] = "timer-regexp"

                                                                                                    self.tunnel_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                                    self.tunnel_name.parent = self
                                                                                                    self._children_name_map["tunnel_name"] = "tunnel-name"

                                                                                                    self.tunnel_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                                    self.tunnel_name_regex.parent = self
                                                                                                    self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"

                                                                                                    self.user_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                                    self.user_name.parent = self
                                                                                                    self._children_name_map["user_name"] = "user-name"

                                                                                                    self.user_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                                    self.user_name_regex.parent = self
                                                                                                    self._children_name_map["user_name_regex"] = "user-name-regex"

                                                                                                    self.auth_username = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                                    self.auth_username.parent = self
                                                                                                    self._children_name_map["auth_username"] = "auth-username"

                                                                                                    self.auth_username_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                                    self.auth_username_regex.parent = self
                                                                                                    self._children_name_map["auth_username_regex"] = "auth-username-regex"

                                                                                                    self.unauth_username = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                                    self.unauth_username.parent = self
                                                                                                    self._children_name_map["unauth_username"] = "unauth-username"

                                                                                                    self.unauth_username_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                                    self.unauth_username_regex.parent = self
                                                                                                    self._children_name_map["unauth_username_regex"] = "unauth-username-regex"

                                                                                                    self.auth_domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                                    self.auth_domain.parent = self
                                                                                                    self._children_name_map["auth_domain"] = "auth-domain"

                                                                                                    self.auth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                                    self.auth_domain_regex.parent = self
                                                                                                    self._children_name_map["auth_domain_regex"] = "auth-domain-regex"

                                                                                                    self.unauth_domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                                    self.unauth_domain.parent = self
                                                                                                    self._children_name_map["unauth_domain"] = "unauth-domain"

                                                                                                    self.unauth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                                    self.unauth_domain_regex.parent = self
                                                                                                    self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"

                                                                                                    self.vendor_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                                    self.vendor_id.parent = self
                                                                                                    self._children_name_map["vendor_id"] = "vendor-id"

                                                                                                    self.vendor_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                                    self.vendor_id_regex.parent = self
                                                                                                    self._children_name_map["vendor_id_regex"] = "vendor-id-regex"

                                                                                                    self.access_interface = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                                    self.access_interface.parent = self
                                                                                                    self._children_name_map["access_interface"] = "access-interface"

                                                                                                    self.input_interface = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                                    self.input_interface.parent = self
                                                                                                    self._children_name_map["input_interface"] = "input-interface"

                                                                                                    self.input_intfhdl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                                    self.input_intfhdl.parent = self
                                                                                                    self._children_name_map["input_intfhdl"] = "input-intfhdl"

                                                                                                    self.ethertype = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                                    self.ethertype.parent = self
                                                                                                    self._children_name_map["ethertype"] = "ethertype"

                                                                                                    self.flow_key_data = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                                    self.flow_key_data.parent = self
                                                                                                    self._children_name_map["flow_key_data"] = "flow-key-data"

                                                                                                    self.dhcp_client_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                                    self.dhcp_client_id.parent = self
                                                                                                    self._children_name_map["dhcp_client_id"] = "dhcp-client-id"

                                                                                                    self.dhcp_client_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                                    self.dhcp_client_id_regex.parent = self
                                                                                                    self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"

                                                                                                    self.circuit_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                                    self.circuit_id.parent = self
                                                                                                    self._children_name_map["circuit_id"] = "circuit-id"

                                                                                                    self.circuit_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                                    self.circuit_id_regex.parent = self
                                                                                                    self._children_name_map["circuit_id_regex"] = "circuit-id-regex"

                                                                                                    self.remote_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                                    self.remote_id.parent = self
                                                                                                    self._children_name_map["remote_id"] = "remote-id"

                                                                                                    self.remote_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                                    self.remote_id_regex.parent = self
                                                                                                    self._children_name_map["remote_id_regex"] = "remote-id-regex"

                                                                                                    self.src_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                                    self.src_port.parent = self
                                                                                                    self._children_name_map["src_port"] = "src-port"

                                                                                                    self.dst_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                                    self.dst_port.parent = self
                                                                                                    self._children_name_map["dst_port"] = "dst-port"
                                                                                                    self._segment_path = lambda: "match-data"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, ['type', 'mpls_top_eos', 'fragment_type', 'authen_status', 'mlp_negotiated'], name, value)


                                                                                                class Ipv4Dscp(Entity):
                                                                                                    """
                                                                                                    IPv4 DSCP
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                        self.yang_name = "ipv4-dscp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ipv4-dscp"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "ipv4-dscp"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                                class Ipv6Dscp(Entity):
                                                                                                    """
                                                                                                    IPv6 DSCP
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                        self.yang_name = "ipv6-dscp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ipv6-dscp"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "ipv6-dscp"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                                class Dscp(Entity):
                                                                                                    """
                                                                                                    Match DSCP range array
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                        self.yang_name = "dscp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "dscp"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "dscp"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                                class Ipv4Prec(Entity):
                                                                                                    """
                                                                                                    IPv4 Precedence
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                        self.yang_name = "ipv4-prec"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "ipv4-prec"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                                class Ipv6Prec(Entity):
                                                                                                    """
                                                                                                    IPv6 Precedence
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                        self.yang_name = "ipv6-prec"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "ipv6-prec"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                                class Prec(Entity):
                                                                                                    """
                                                                                                    Match Precedence array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                        self.yang_name = "prec"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "prec"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                                class DiscardClass(Entity):
                                                                                                    """
                                                                                                    Match Discard Class array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                        self.yang_name = "discard-class"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "discard-class"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                                class QosGroup(Entity):
                                                                                                    """
                                                                                                    Match QoS group array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                        self.yang_name = "qos-group"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "qos-group"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "qos-group"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['min', 'max'], name, value)


                                                                                                class TrafficClass(Entity):
                                                                                                    """
                                                                                                    Match Traffic class array
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                        self.yang_name = "traffic-class"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "traffic-class"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "traffic-class"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['min', 'max'], name, value)


                                                                                                class Proto(Entity):
                                                                                                    """
                                                                                                    Match Protocol array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                        self.yang_name = "proto"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "proto"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "proto"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['min', 'max'], name, value)


                                                                                                class IcmpV4(Entity):
                                                                                                    """
                                                                                                    Match ICMPV4 Protocol
                                                                                                    
                                                                                                    .. attribute:: type
                                                                                                    
                                                                                                    	Protocol type
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: code
                                                                                                    
                                                                                                    	Protocol code
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                        self.yang_name = "icmp-v4"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                            ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                        ])
                                                                                                        self.type = None
                                                                                                        self.code = None
                                                                                                        self._segment_path = lambda: "icmp-v4"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['type', 'code'], name, value)


                                                                                                class IcmpV6(Entity):
                                                                                                    """
                                                                                                    Match ICMPV6 Protocol array
                                                                                                    
                                                                                                    .. attribute:: type
                                                                                                    
                                                                                                    	Protocol type
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: code
                                                                                                    
                                                                                                    	Protocol code
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                        self.yang_name = "icmp-v6"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                            ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                        ])
                                                                                                        self.type = None
                                                                                                        self.code = None
                                                                                                        self._segment_path = lambda: "icmp-v6"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['type', 'code'], name, value)


                                                                                                class Ipv4PacketLen(Entity):
                                                                                                    """
                                                                                                    IPv4 packet length array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                        self.yang_name = "ipv4-packet-len"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ipv4-packet-len"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "ipv4-packet-len"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                                class Ipv6PacketLen(Entity):
                                                                                                    """
                                                                                                    IPv6 packet length array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                        self.yang_name = "ipv6-packet-len"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ipv6-packet-len"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "ipv6-packet-len"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                                class PacketLen(Entity):
                                                                                                    """
                                                                                                    Match packet length array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                        self.yang_name = "packet-len"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "packet-len"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "packet-len"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                                class FlowTag(Entity):
                                                                                                    """
                                                                                                    Match flow\-tag array
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                        self.yang_name = "flow-tag"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "flow-tag"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "flow-tag"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['min', 'max'], name, value)


                                                                                                class TcpFlag(Entity):
                                                                                                    """
                                                                                                    Match tcp flag value
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	Value of TCP flag
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: match_any
                                                                                                    
                                                                                                    	Match any TCP flag bit
                                                                                                    	**type**\: bool
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                        self.yang_name = "tcp-flag"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                                            ('match_any', (YLeaf(YType.boolean, 'match-any'), ['bool'])),
                                                                                                        ])
                                                                                                        self.value = None
                                                                                                        self.match_any = None
                                                                                                        self._segment_path = lambda: "tcp-flag"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['value', 'match_any'], name, value)


                                                                                                class Icmpv4Type(Entity):
                                                                                                    """
                                                                                                    Match ipv4 icmp type
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                        self.yang_name = "icmpv4-type"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "icmpv4-type"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "icmpv4-type"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                                class Icmpv4Code(Entity):
                                                                                                    """
                                                                                                    Match ipv4 icmp code
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                        self.yang_name = "icmpv4-code"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "icmpv4-code"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "icmpv4-code"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                                class Icmpv6Type(Entity):
                                                                                                    """
                                                                                                    Match ipv6 icmp type
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                        self.yang_name = "icmpv6-type"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "icmpv6-type"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "icmpv6-type"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                                class Icmpv6Code(Entity):
                                                                                                    """
                                                                                                    Match ipv6 icmp code
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                        self.yang_name = "icmpv6-code"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "icmpv6-code"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "icmpv6-code"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                                class MplsExp(Entity):
                                                                                                    """
                                                                                                    Match MPLS experimental topmost array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                        self.yang_name = "mpls-exp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "mpls-exp"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                                class MplsExpImp(Entity):
                                                                                                    """
                                                                                                    Match MPLS experimental imposition array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                        self.yang_name = "mpls-exp-imp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "mpls-exp-imp"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                                class MplsDispIpv4Acl(Entity):
                                                                                                    """
                                                                                                    MPLS Disposition IPv4 Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                        self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "mpls-disp-ipv4-acl"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                                class MplsDispIpv6Acl(Entity):
                                                                                                    """
                                                                                                    MPLS Disposition IPv6 Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                        self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "mpls-disp-ipv6-acl"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                                class MplsTopLabel(Entity):
                                                                                                    """
                                                                                                    MPLS Topmost LABEL
                                                                                                    
                                                                                                    .. attribute:: uint32_rng_array
                                                                                                    
                                                                                                    	uint32 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                        self.yang_name = "mpls-top-label"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint32_rng_array", ("uint32_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint32_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "mpls-top-label"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                                    class Uint32RngArray(Entity):
                                                                                                        """
                                                                                                        uint32 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                            self.yang_name = "uint32_rng_array"
                                                                                                            self.yang_parent_name = "mpls-top-label"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint32, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint32, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint32_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['min', 'max'], name, value)


                                                                                                class Cos(Entity):
                                                                                                    """
                                                                                                    Match CoS array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                        self.yang_name = "cos"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "cos"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                                class CosInr(Entity):
                                                                                                    """
                                                                                                    Match inner header CoS
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                        self.yang_name = "cos-inr"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "cos-inr"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                                class Dei(Entity):
                                                                                                    """
                                                                                                    Match DEI Bit
                                                                                                    
                                                                                                    .. attribute:: bit_value
                                                                                                    
                                                                                                    	Value of the DEI bit
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                        self.yang_name = "dei"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                        ])
                                                                                                        self.bit_value = None
                                                                                                        self._segment_path = lambda: "dei"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                                class DeiInr(Entity):
                                                                                                    """
                                                                                                    Match inner DEI Bit
                                                                                                    
                                                                                                    .. attribute:: bit_value
                                                                                                    
                                                                                                    	Value of the DEI bit
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                        self.yang_name = "dei-inr"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                        ])
                                                                                                        self.bit_value = None
                                                                                                        self._segment_path = lambda: "dei-inr"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                                class Vlan(Entity):
                                                                                                    """
                                                                                                    Match VLAN array
                                                                                                    
                                                                                                    .. attribute:: vlan_id_array
                                                                                                    
                                                                                                    	vlan id array
                                                                                                    	**type**\: list of  		 :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                        self.yang_name = "vlan"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("vlan-id-array", ("vlan_id_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.vlan_id_array = YList(self)
                                                                                                        self._segment_path = lambda: "vlan"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                                    class VlanIdArray(Entity):
                                                                                                        """
                                                                                                        vlan id array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	VLAN mask
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                            self.yang_name = "vlan-id-array"
                                                                                                            self.yang_parent_name = "vlan"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                                ('mask', (YLeaf(YType.uint16, 'mask'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self.mask = None
                                                                                                            self._segment_path = lambda: "vlan-id-array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['min', 'max', 'mask'], name, value)


                                                                                                class VlanInr(Entity):
                                                                                                    """
                                                                                                    Match inner header VLAN range array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                        self.yang_name = "vlan-inr"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "vlan-inr"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "vlan-inr"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['min', 'max'], name, value)


                                                                                                class FrDlci(Entity):
                                                                                                    """
                                                                                                    Match FR DLCI range array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                        self.yang_name = "fr-dlci"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "fr-dlci"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "fr-dlci"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['min', 'max'], name, value)


                                                                                                class SrcMac(Entity):
                                                                                                    """
                                                                                                    Match Source MAC address
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                        self.yang_name = "src-mac"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                            ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.mac_addr = []
                                                                                                        self.mask = []
                                                                                                        self._segment_path = lambda: "src-mac"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                                class DstMac(Entity):
                                                                                                    """
                                                                                                    Match Destination MAC address
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                        self.yang_name = "dst-mac"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                            ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.mac_addr = []
                                                                                                        self.mask = []
                                                                                                        self._segment_path = lambda: "dst-mac"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                                class AtmClp(Entity):
                                                                                                    """
                                                                                                    Match ATM CLP level
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                        self.yang_name = "atm-clp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "atm-clp"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                                class FrDe(Entity):
                                                                                                    """
                                                                                                    Match FR DE value
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                        self.yang_name = "fr-de"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "fr-de"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                                class Ipv4Acl(Entity):
                                                                                                    """
                                                                                                    IPv4 Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                        self.yang_name = "ipv4-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "ipv4-acl"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                                class Ipv6Acl(Entity):
                                                                                                    """
                                                                                                    IPv6 Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                        self.yang_name = "ipv6-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "ipv6-acl"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                                class EtherServiceAcl(Entity):
                                                                                                    """
                                                                                                    Ethernet\-Services Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                        self.yang_name = "ether-service-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "ether-service-acl"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                                class AvailId(Entity):
                                                                                                    """
                                                                                                    Available Identifiers
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                        self.yang_name = "avail-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "avail-id"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                                class MediaType(Entity):
                                                                                                    """
                                                                                                    Media Type
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                        self.yang_name = "media-type"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "media-type"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                                class SubsProtocol(Entity):
                                                                                                    """
                                                                                                    Protocol
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                        self.yang_name = "subs-protocol"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "subs-protocol"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                                class Dnis(Entity):
                                                                                                    """
                                                                                                    DNIS
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                        self.yang_name = "dnis"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "dnis"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                                class DnisRegex(Entity):
                                                                                                    """
                                                                                                    DNIS Regular Expression
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                        self.yang_name = "dnis-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "dnis-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                                class Domain(Entity):
                                                                                                    """
                                                                                                    Domain Name
                                                                                                    
                                                                                                    .. attribute:: domain_array
                                                                                                    
                                                                                                    	domain array
                                                                                                    	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                        self.yang_name = "domain"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.domain_array = YList(self)
                                                                                                        self._segment_path = lambda: "domain"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                                    class DomainArray(Entity):
                                                                                                        """
                                                                                                        domain array
                                                                                                        
                                                                                                        .. attribute:: domain_name
                                                                                                        
                                                                                                        	domain name
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        .. attribute:: format_name
                                                                                                        
                                                                                                        	format name
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                            self.yang_name = "domain-array"
                                                                                                            self.yang_parent_name = "domain"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                                ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                            ])
                                                                                                            self.domain_name = None
                                                                                                            self.format_name = None
                                                                                                            self._segment_path = lambda: "domain-array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                                class DomainRegex(Entity):
                                                                                                    """
                                                                                                    Domain Regular Expression
                                                                                                    
                                                                                                    .. attribute:: domain_array
                                                                                                    
                                                                                                    	domain array
                                                                                                    	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                        self.yang_name = "domain-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.domain_array = YList(self)
                                                                                                        self._segment_path = lambda: "domain-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                                    class DomainArray(Entity):
                                                                                                        """
                                                                                                        domain array
                                                                                                        
                                                                                                        .. attribute:: domain_name
                                                                                                        
                                                                                                        	domain name
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        .. attribute:: format_name
                                                                                                        
                                                                                                        	format name
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                            self.yang_name = "domain-array"
                                                                                                            self.yang_parent_name = "domain-regex"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                                ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                            ])
                                                                                                            self.domain_name = None
                                                                                                            self.format_name = None
                                                                                                            self._segment_path = lambda: "domain-array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                                class NasPort(Entity):
                                                                                                    """
                                                                                                    NAS Port
                                                                                                    
                                                                                                    .. attribute:: nas_port_array
                                                                                                    
                                                                                                    	nas port array
                                                                                                    	**type**\: list of  		 :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                        self.yang_name = "nas-port"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("nas-port-array", ("nas_port_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.nas_port_array = YList(self)
                                                                                                        self._segment_path = lambda: "nas-port"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                                    class NasPortArray(Entity):
                                                                                                        """
                                                                                                        nas port array
                                                                                                        
                                                                                                        .. attribute:: sub_id
                                                                                                        
                                                                                                        	sub id
                                                                                                        	**type**\:  :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                        
                                                                                                        .. attribute:: operator
                                                                                                        
                                                                                                        	operator
                                                                                                        	**type**\:  :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                        
                                                                                                        .. attribute:: value
                                                                                                        
                                                                                                        	value
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                            self.yang_name = "nas-port-array"
                                                                                                            self.yang_parent_name = "nas-port"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('sub_id', (YLeaf(YType.enumeration, 'sub-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchNasPortSubIdEn', '')])),
                                                                                                                ('operator', (YLeaf(YType.enumeration, 'operator'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchLogicalOperatorEn', '')])),
                                                                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                                            ])
                                                                                                            self.sub_id = None
                                                                                                            self.operator = None
                                                                                                            self.value = None
                                                                                                            self._segment_path = lambda: "nas-port-array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['sub_id', 'operator', 'value'], name, value)


                                                                                                class ServiceName(Entity):
                                                                                                    """
                                                                                                    Service Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                        self.yang_name = "service-name"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "service-name"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                                class ServiceNameRegex(Entity):
                                                                                                    """
                                                                                                    Service Name Regular Exp
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                        self.yang_name = "service-name-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "service-name-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                                class SrcAddrIpv4(Entity):
                                                                                                    """
                                                                                                    Source Address IPV4
                                                                                                    
                                                                                                    .. attribute:: ipv4_addr_array
                                                                                                    
                                                                                                    	ipv4 addr array
                                                                                                    	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                        self.yang_name = "src-addr-ipv4"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.ipv4_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "src-addr-ipv4"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                                    class Ipv4AddrArray(Entity):
                                                                                                        """
                                                                                                        ipv4 addr array
                                                                                                        
                                                                                                        .. attribute:: prefix
                                                                                                        
                                                                                                        	prefix
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	mask
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                            self.yang_name = "ipv4-addr-array"
                                                                                                            self.yang_parent_name = "src-addr-ipv4"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                                ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                            ])
                                                                                                            self.prefix = None
                                                                                                            self.mask = None
                                                                                                            self._segment_path = lambda: "ipv4-addr-array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                                class DstAddrIpv4(Entity):
                                                                                                    """
                                                                                                    Destination Address IPV4
                                                                                                    
                                                                                                    .. attribute:: ipv4_addr_array
                                                                                                    
                                                                                                    	ipv4 addr array
                                                                                                    	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                        self.yang_name = "dst-addr-ipv4"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.ipv4_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "dst-addr-ipv4"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                                    class Ipv4AddrArray(Entity):
                                                                                                        """
                                                                                                        ipv4 addr array
                                                                                                        
                                                                                                        .. attribute:: prefix
                                                                                                        
                                                                                                        	prefix
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	mask
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                            self.yang_name = "ipv4-addr-array"
                                                                                                            self.yang_parent_name = "dst-addr-ipv4"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                                ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                            ])
                                                                                                            self.prefix = None
                                                                                                            self.mask = None
                                                                                                            self._segment_path = lambda: "ipv4-addr-array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                                class SrcAddrIpv6(Entity):
                                                                                                    """
                                                                                                    Source Address IPV6
                                                                                                    
                                                                                                    .. attribute:: ipv6_addr_array
                                                                                                    
                                                                                                    	ipv6 addr array
                                                                                                    	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                        self.yang_name = "src-addr-ipv6"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.ipv6_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "src-addr-ipv6"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                                    class Ipv6AddrArray(Entity):
                                                                                                        """
                                                                                                        ipv6 addr array
                                                                                                        
                                                                                                        .. attribute:: prefix
                                                                                                        
                                                                                                        	IPV6 prefix
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	IPV6 mask
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                            self.yang_name = "ipv6-addr-array"
                                                                                                            self.yang_parent_name = "src-addr-ipv6"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                                ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                            ])
                                                                                                            self.prefix = None
                                                                                                            self.mask = None
                                                                                                            self._segment_path = lambda: "ipv6-addr-array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                                class DstAddrIpv6(Entity):
                                                                                                    """
                                                                                                    Destination Address IPV6
                                                                                                    
                                                                                                    .. attribute:: ipv6_addr_array
                                                                                                    
                                                                                                    	ipv6 addr array
                                                                                                    	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                        self.yang_name = "dst-addr-ipv6"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.ipv6_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "dst-addr-ipv6"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                                    class Ipv6AddrArray(Entity):
                                                                                                        """
                                                                                                        ipv6 addr array
                                                                                                        
                                                                                                        .. attribute:: prefix
                                                                                                        
                                                                                                        	IPV6 prefix
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	IPV6 mask
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                            self.yang_name = "ipv6-addr-array"
                                                                                                            self.yang_parent_name = "dst-addr-ipv6"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                                ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                            ])
                                                                                                            self.prefix = None
                                                                                                            self.mask = None
                                                                                                            self._segment_path = lambda: "ipv6-addr-array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                                class SrcAddrMac(Entity):
                                                                                                    """
                                                                                                    Source Address MAC
                                                                                                    
                                                                                                    .. attribute:: mac_addr_array
                                                                                                    
                                                                                                    	mac addr array
                                                                                                    	**type**\: list of  		 :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                        self.yang_name = "src-addr-mac"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("mac-addr-array", ("mac_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.mac_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "src-addr-mac"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                                    class MacAddrArray(Entity):
                                                                                                        """
                                                                                                        mac addr array
                                                                                                        
                                                                                                        .. attribute:: mac_addr
                                                                                                        
                                                                                                        	MAC address
                                                                                                        	**type**\: list of int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	MAC mask
                                                                                                        	**type**\: list of int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                            self.yang_name = "mac-addr-array"
                                                                                                            self.yang_parent_name = "src-addr-mac"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                                ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                            ])
                                                                                                            self.mac_addr = []
                                                                                                            self.mask = []
                                                                                                            self._segment_path = lambda: "mac-addr-array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                                class Timer(Entity):
                                                                                                    """
                                                                                                    Timer
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                        self.yang_name = "timer"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "timer"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                                class TimerRegexp(Entity):
                                                                                                    """
                                                                                                    Timer Regular Expression
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                        self.yang_name = "timer-regexp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "timer-regexp"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                                class TunnelName(Entity):
                                                                                                    """
                                                                                                    Tunnel Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                        self.yang_name = "tunnel-name"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "tunnel-name"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                                class TunnelNameRegex(Entity):
                                                                                                    """
                                                                                                    Tunnel Name Regular Expression
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                        self.yang_name = "tunnel-name-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "tunnel-name-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                                class UserName(Entity):
                                                                                                    """
                                                                                                    User Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                        self.yang_name = "user-name"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "user-name"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                                class UserNameRegex(Entity):
                                                                                                    """
                                                                                                    User Name Regular Expression
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                        self.yang_name = "user-name-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "user-name-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                                class AuthUsername(Entity):
                                                                                                    """
                                                                                                    Authenticated User Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                        self.yang_name = "auth-username"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "auth-username"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                                class AuthUsernameRegex(Entity):
                                                                                                    """
                                                                                                    Authenticated User Name RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                        self.yang_name = "auth-username-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "auth-username-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                                class UnauthUsername(Entity):
                                                                                                    """
                                                                                                    Unauthenticated User Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                        self.yang_name = "unauth-username"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "unauth-username"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                                class UnauthUsernameRegex(Entity):
                                                                                                    """
                                                                                                    Unauthenticated User Name RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                        self.yang_name = "unauth-username-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "unauth-username-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                                class AuthDomain(Entity):
                                                                                                    """
                                                                                                    Authenticated domain name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                        self.yang_name = "auth-domain"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "auth-domain"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                                class AuthDomainRegex(Entity):
                                                                                                    """
                                                                                                    Authenticated Domain Name RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                        self.yang_name = "auth-domain-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "auth-domain-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                                class UnauthDomain(Entity):
                                                                                                    """
                                                                                                    Unauthenticated Domain Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                        self.yang_name = "unauth-domain"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "unauth-domain"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                                class UnauthDomainRegex(Entity):
                                                                                                    """
                                                                                                    Unauthenticated Domain Name RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                        self.yang_name = "unauth-domain-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "unauth-domain-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                                class VendorId(Entity):
                                                                                                    """
                                                                                                    Vendor ID
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                        self.yang_name = "vendor-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "vendor-id"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                                class VendorIdRegex(Entity):
                                                                                                    """
                                                                                                    Vendor ID RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                        self.yang_name = "vendor-id-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "vendor-id-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                                class AccessInterface(Entity):
                                                                                                    """
                                                                                                    Access interface
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                        self.yang_name = "access-interface"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "access-interface"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                                class InputInterface(Entity):
                                                                                                    """
                                                                                                    Input interface
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                        self.yang_name = "input-interface"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "input-interface"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                                class InputIntfhdl(Entity):
                                                                                                    """
                                                                                                    Input interface handle
                                                                                                    
                                                                                                    .. attribute:: uint64_array
                                                                                                    
                                                                                                    	uint64 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..18446744073709551615
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                        self.yang_name = "input-intfhdl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint64_array', (YLeafList(YType.uint64, 'uint64_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint64_array = []
                                                                                                        self._segment_path = lambda: "input-intfhdl"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                                class Ethertype(Entity):
                                                                                                    """
                                                                                                    Ethernet type
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                        self.yang_name = "ethertype"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ethertype"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "ethertype"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['min', 'max'], name, value)


                                                                                                class FlowKeyData(Entity):
                                                                                                    """
                                                                                                    Flow key structure
                                                                                                    
                                                                                                    .. attribute:: flow_keys
                                                                                                    
                                                                                                    	flow keys
                                                                                                    	**type**\:  :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                                    
                                                                                                    .. attribute:: max_count
                                                                                                    
                                                                                                    	Maximum count of flows
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: idle_timeout
                                                                                                    
                                                                                                    	Idle timeout of flows (in seconds)
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    	**units**\: second
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                        self.yang_name = "flow-key-data"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("flow-keys", ("flow_keys", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys))])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('max_count', (YLeaf(YType.uint16, 'max-count'), ['int'])),
                                                                                                            ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                                                        ])
                                                                                                        self.max_count = None
                                                                                                        self.idle_timeout = None

                                                                                                        self.flow_keys = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                        self.flow_keys.parent = self
                                                                                                        self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                        self._segment_path = lambda: "flow-key-data"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['max_count', 'idle_timeout'], name, value)


                                                                                                    class FlowKeys(Entity):
                                                                                                        """
                                                                                                        flow keys
                                                                                                        
                                                                                                        .. attribute:: keys
                                                                                                        
                                                                                                        	keys
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                        
                                                                                                        .. attribute:: num
                                                                                                        
                                                                                                        	num
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                            self.yang_name = "flow-keys"
                                                                                                            self.yang_parent_name = "flow-key-data"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('keys', (YLeaf(YType.str, 'keys'), ['str'])),
                                                                                                                ('num', (YLeaf(YType.uint8, 'num'), ['int'])),
                                                                                                            ])
                                                                                                            self.keys = None
                                                                                                            self.num = None
                                                                                                            self._segment_path = lambda: "flow-keys"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                                class DhcpClientId(Entity):
                                                                                                    """
                                                                                                    Dhcp Client ID
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                        self.yang_name = "dhcp-client-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "dhcp-client-id"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                                class DhcpClientIdRegex(Entity):
                                                                                                    """
                                                                                                    Dhcp Client ID RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                        self.yang_name = "dhcp-client-id-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "dhcp-client-id-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                                class CircuitId(Entity):
                                                                                                    """
                                                                                                    Circuit ID
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                        self.yang_name = "circuit-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "circuit-id"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                                class CircuitIdRegex(Entity):
                                                                                                    """
                                                                                                    Circuit ID RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                        self.yang_name = "circuit-id-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "circuit-id-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                                class RemoteId(Entity):
                                                                                                    """
                                                                                                    Remote ID
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                        self.yang_name = "remote-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "remote-id"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                                class RemoteIdRegex(Entity):
                                                                                                    """
                                                                                                    Remote ID RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                        self.yang_name = "remote-id-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "remote-id-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                                class SrcPort(Entity):
                                                                                                    """
                                                                                                    Source port
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                        self.yang_name = "src-port"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "src-port"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "src-port"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                                                class DstPort(Entity):
                                                                                                    """
                                                                                                    Destination port
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                        self.yang_name = "dst-port"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "dst-port"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "dst-port"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class ConfclassP(Entity):
                                                                                """
                                                                                confclass p
                                                                                
                                                                                .. attribute:: class_map_bg
                                                                                
                                                                                	class map bg
                                                                                	**type**\: list of  		 :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP, self).__init__()

                                                                                    self.yang_name = "confclass-p"
                                                                                    self.yang_parent_name = "police"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("class-map-bg", ("class_map_bg", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.class_map_bg = YList(self)
                                                                                    self._segment_path = lambda: "confclass-p"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP, [], name, value)


                                                                                class ClassMapBg(Entity):
                                                                                    """
                                                                                    class map bg
                                                                                    
                                                                                    .. attribute:: match_infop
                                                                                    
                                                                                    	Pointer to the first Match info
                                                                                    	**type**\:  :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop>`
                                                                                    
                                                                                    .. attribute:: name
                                                                                    
                                                                                    	Name of the class\-map
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..65
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	Class\-Map Type QoS/PBR/Netflow/..
                                                                                    	**type**\:  :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                                                    
                                                                                    .. attribute:: mode
                                                                                    
                                                                                    	Class\-Map Mode Match any/Match all
                                                                                    	**type**\:  :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                                    
                                                                                    .. attribute:: description
                                                                                    
                                                                                    	description
                                                                                    	**type**\: str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg, self).__init__()

                                                                                        self.yang_name = "class-map-bg"
                                                                                        self.yang_parent_name = "confclass-p"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("match-infop", ("match_infop", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop))])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapTypeEn', '')])),
                                                                                            ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapModeEn', '')])),
                                                                                            ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                        ])
                                                                                        self.name = None
                                                                                        self.type = None
                                                                                        self.mode = None
                                                                                        self.description = None

                                                                                        self.match_infop = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop()
                                                                                        self.match_infop.parent = self
                                                                                        self._children_name_map["match_infop"] = "match-infop"
                                                                                        self._segment_path = lambda: "class-map-bg"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg, ['name', 'type', 'mode', 'description'], name, value)


                                                                                    class MatchInfop(Entity):
                                                                                        """
                                                                                        Pointer to the first Match info
                                                                                        
                                                                                        .. attribute:: class_match_info_st
                                                                                        
                                                                                        	class match info st
                                                                                        	**type**\: list of  		 :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop, self).__init__()

                                                                                            self.yang_name = "match-infop"
                                                                                            self.yang_parent_name = "class-map-bg"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("class-match-info-st", ("class_match_info_st", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.class_match_info_st = YList(self)
                                                                                            self._segment_path = lambda: "match-infop"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop, [], name, value)


                                                                                        class ClassMatchInfoSt(Entity):
                                                                                            """
                                                                                            class match info st
                                                                                            
                                                                                            .. attribute:: match_data
                                                                                            
                                                                                            	Match criteria
                                                                                            	**type**\:  :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                            
                                                                                            .. attribute:: flags
                                                                                            
                                                                                            	Flags
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                                self.yang_name = "class-match-info-st"
                                                                                                self.yang_parent_name = "match-infop"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("match-data", ("match_data", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData))])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                                ])
                                                                                                self.flags = None

                                                                                                self.match_data = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                                self.match_data.parent = self
                                                                                                self._children_name_map["match_data"] = "match-data"
                                                                                                self._segment_path = lambda: "class-match-info-st"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                            class MatchData(Entity):
                                                                                                """
                                                                                                Match criteria
                                                                                                
                                                                                                .. attribute:: ipv4_dscp
                                                                                                
                                                                                                	IPv4 DSCP
                                                                                                	**type**\:  :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                                
                                                                                                .. attribute:: ipv6_dscp
                                                                                                
                                                                                                	IPv6 DSCP
                                                                                                	**type**\:  :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                                
                                                                                                .. attribute:: dscp
                                                                                                
                                                                                                	Match DSCP range array
                                                                                                	**type**\:  :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                                
                                                                                                .. attribute:: ipv4_prec
                                                                                                
                                                                                                	IPv4 Precedence
                                                                                                	**type**\:  :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                                
                                                                                                .. attribute:: ipv6_prec
                                                                                                
                                                                                                	IPv6 Precedence
                                                                                                	**type**\:  :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                                
                                                                                                .. attribute:: prec
                                                                                                
                                                                                                	Match Precedence array
                                                                                                	**type**\:  :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                                
                                                                                                .. attribute:: discard_class
                                                                                                
                                                                                                	Match Discard Class array
                                                                                                	**type**\:  :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                                
                                                                                                .. attribute:: qos_group
                                                                                                
                                                                                                	Match QoS group array
                                                                                                	**type**\:  :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                                
                                                                                                .. attribute:: traffic_class
                                                                                                
                                                                                                	Match Traffic class array
                                                                                                	**type**\:  :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                                
                                                                                                .. attribute:: proto
                                                                                                
                                                                                                	Match Protocol array
                                                                                                	**type**\:  :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                                
                                                                                                .. attribute:: icmp_v4
                                                                                                
                                                                                                	Match ICMPV4 Protocol
                                                                                                	**type**\:  :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                                
                                                                                                .. attribute:: icmp_v6
                                                                                                
                                                                                                	Match ICMPV6 Protocol array
                                                                                                	**type**\:  :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                                
                                                                                                .. attribute:: ipv4_packet_len
                                                                                                
                                                                                                	IPv4 packet length array
                                                                                                	**type**\:  :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                                
                                                                                                .. attribute:: ipv6_packet_len
                                                                                                
                                                                                                	IPv6 packet length array
                                                                                                	**type**\:  :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                                
                                                                                                .. attribute:: packet_len
                                                                                                
                                                                                                	Match packet length array
                                                                                                	**type**\:  :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                                
                                                                                                .. attribute:: flow_tag
                                                                                                
                                                                                                	Match flow\-tag array
                                                                                                	**type**\:  :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                                
                                                                                                .. attribute:: tcp_flag
                                                                                                
                                                                                                	Match tcp flag value
                                                                                                	**type**\:  :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                                
                                                                                                .. attribute:: icmpv4_type
                                                                                                
                                                                                                	Match ipv4 icmp type
                                                                                                	**type**\:  :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                                
                                                                                                .. attribute:: icmpv4_code
                                                                                                
                                                                                                	Match ipv4 icmp code
                                                                                                	**type**\:  :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                                
                                                                                                .. attribute:: icmpv6_type
                                                                                                
                                                                                                	Match ipv6 icmp type
                                                                                                	**type**\:  :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                                
                                                                                                .. attribute:: icmpv6_code
                                                                                                
                                                                                                	Match ipv6 icmp code
                                                                                                	**type**\:  :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                                
                                                                                                .. attribute:: mpls_exp
                                                                                                
                                                                                                	Match MPLS experimental topmost array
                                                                                                	**type**\:  :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                                
                                                                                                .. attribute:: mpls_exp_imp
                                                                                                
                                                                                                	Match MPLS experimental imposition array
                                                                                                	**type**\:  :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                                
                                                                                                .. attribute:: mpls_disp_ipv4_acl
                                                                                                
                                                                                                	MPLS Disposition IPv4 Access\-list
                                                                                                	**type**\:  :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                                
                                                                                                .. attribute:: mpls_disp_ipv6_acl
                                                                                                
                                                                                                	MPLS Disposition IPv6 Access\-list
                                                                                                	**type**\:  :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                                
                                                                                                .. attribute:: mpls_top_label
                                                                                                
                                                                                                	MPLS Topmost LABEL
                                                                                                	**type**\:  :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                                
                                                                                                .. attribute:: cos
                                                                                                
                                                                                                	Match CoS array
                                                                                                	**type**\:  :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                                
                                                                                                .. attribute:: cos_inr
                                                                                                
                                                                                                	Match inner header CoS
                                                                                                	**type**\:  :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                                
                                                                                                .. attribute:: dei
                                                                                                
                                                                                                	Match DEI Bit
                                                                                                	**type**\:  :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                                
                                                                                                .. attribute:: dei_inr
                                                                                                
                                                                                                	Match inner DEI Bit
                                                                                                	**type**\:  :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                                
                                                                                                .. attribute:: vlan
                                                                                                
                                                                                                	Match VLAN array
                                                                                                	**type**\:  :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                                
                                                                                                .. attribute:: vlan_inr
                                                                                                
                                                                                                	Match inner header VLAN range array
                                                                                                	**type**\:  :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                                
                                                                                                .. attribute:: fr_dlci
                                                                                                
                                                                                                	Match FR DLCI range array
                                                                                                	**type**\:  :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                                
                                                                                                .. attribute:: src_mac
                                                                                                
                                                                                                	Match Source MAC address
                                                                                                	**type**\:  :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                                
                                                                                                .. attribute:: dst_mac
                                                                                                
                                                                                                	Match Destination MAC address
                                                                                                	**type**\:  :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                                
                                                                                                .. attribute:: atm_clp
                                                                                                
                                                                                                	Match ATM CLP level
                                                                                                	**type**\:  :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                                
                                                                                                .. attribute:: fr_de
                                                                                                
                                                                                                	Match FR DE value
                                                                                                	**type**\:  :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                                
                                                                                                .. attribute:: ipv4_acl
                                                                                                
                                                                                                	IPv4 Access\-list
                                                                                                	**type**\:  :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                                
                                                                                                .. attribute:: ipv6_acl
                                                                                                
                                                                                                	IPv6 Access\-list
                                                                                                	**type**\:  :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                                
                                                                                                .. attribute:: ether_service_acl
                                                                                                
                                                                                                	Ethernet\-Services Access\-list
                                                                                                	**type**\:  :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                                
                                                                                                .. attribute:: avail_id
                                                                                                
                                                                                                	Available Identifiers
                                                                                                	**type**\:  :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                                
                                                                                                .. attribute:: media_type
                                                                                                
                                                                                                	Media Type
                                                                                                	**type**\:  :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                                
                                                                                                .. attribute:: subs_protocol
                                                                                                
                                                                                                	Protocol
                                                                                                	**type**\:  :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                                
                                                                                                .. attribute:: dnis
                                                                                                
                                                                                                	DNIS
                                                                                                	**type**\:  :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                                
                                                                                                .. attribute:: dnis_regex
                                                                                                
                                                                                                	DNIS Regular Expression
                                                                                                	**type**\:  :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                                
                                                                                                .. attribute:: domain
                                                                                                
                                                                                                	Domain Name
                                                                                                	**type**\:  :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                                
                                                                                                .. attribute:: domain_regex
                                                                                                
                                                                                                	Domain Regular Expression
                                                                                                	**type**\:  :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                                
                                                                                                .. attribute:: nas_port
                                                                                                
                                                                                                	NAS Port
                                                                                                	**type**\:  :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                                
                                                                                                .. attribute:: service_name
                                                                                                
                                                                                                	Service Name
                                                                                                	**type**\:  :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                                
                                                                                                .. attribute:: service_name_regex
                                                                                                
                                                                                                	Service Name Regular Exp
                                                                                                	**type**\:  :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                                
                                                                                                .. attribute:: src_addr_ipv4
                                                                                                
                                                                                                	Source Address IPV4
                                                                                                	**type**\:  :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                                
                                                                                                .. attribute:: dst_addr_ipv4
                                                                                                
                                                                                                	Destination Address IPV4
                                                                                                	**type**\:  :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                                
                                                                                                .. attribute:: src_addr_ipv6
                                                                                                
                                                                                                	Source Address IPV6
                                                                                                	**type**\:  :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                                
                                                                                                .. attribute:: dst_addr_ipv6
                                                                                                
                                                                                                	Destination Address IPV6
                                                                                                	**type**\:  :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                                
                                                                                                .. attribute:: src_addr_mac
                                                                                                
                                                                                                	Source Address MAC
                                                                                                	**type**\:  :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                                
                                                                                                .. attribute:: timer
                                                                                                
                                                                                                	Timer
                                                                                                	**type**\:  :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                                
                                                                                                .. attribute:: timer_regexp
                                                                                                
                                                                                                	Timer Regular Expression
                                                                                                	**type**\:  :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                                
                                                                                                .. attribute:: tunnel_name
                                                                                                
                                                                                                	Tunnel Name
                                                                                                	**type**\:  :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                                
                                                                                                .. attribute:: tunnel_name_regex
                                                                                                
                                                                                                	Tunnel Name Regular Expression
                                                                                                	**type**\:  :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                                
                                                                                                .. attribute:: user_name
                                                                                                
                                                                                                	User Name
                                                                                                	**type**\:  :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                                
                                                                                                .. attribute:: user_name_regex
                                                                                                
                                                                                                	User Name Regular Expression
                                                                                                	**type**\:  :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                                
                                                                                                .. attribute:: auth_username
                                                                                                
                                                                                                	Authenticated User Name
                                                                                                	**type**\:  :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                                
                                                                                                .. attribute:: auth_username_regex
                                                                                                
                                                                                                	Authenticated User Name RegEx
                                                                                                	**type**\:  :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                                
                                                                                                .. attribute:: unauth_username
                                                                                                
                                                                                                	Unauthenticated User Name
                                                                                                	**type**\:  :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                                
                                                                                                .. attribute:: unauth_username_regex
                                                                                                
                                                                                                	Unauthenticated User Name RegEx
                                                                                                	**type**\:  :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                                
                                                                                                .. attribute:: auth_domain
                                                                                                
                                                                                                	Authenticated domain name
                                                                                                	**type**\:  :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                                
                                                                                                .. attribute:: auth_domain_regex
                                                                                                
                                                                                                	Authenticated Domain Name RegEx
                                                                                                	**type**\:  :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                                
                                                                                                .. attribute:: unauth_domain
                                                                                                
                                                                                                	Unauthenticated Domain Name
                                                                                                	**type**\:  :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                                
                                                                                                .. attribute:: unauth_domain_regex
                                                                                                
                                                                                                	Unauthenticated Domain Name RegEx
                                                                                                	**type**\:  :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                                
                                                                                                .. attribute:: vendor_id
                                                                                                
                                                                                                	Vendor ID
                                                                                                	**type**\:  :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                                
                                                                                                .. attribute:: vendor_id_regex
                                                                                                
                                                                                                	Vendor ID RegEx
                                                                                                	**type**\:  :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                                
                                                                                                .. attribute:: access_interface
                                                                                                
                                                                                                	Access interface
                                                                                                	**type**\:  :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                                
                                                                                                .. attribute:: input_interface
                                                                                                
                                                                                                	Input interface
                                                                                                	**type**\:  :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                                
                                                                                                .. attribute:: input_intfhdl
                                                                                                
                                                                                                	Input interface handle
                                                                                                	**type**\:  :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                                
                                                                                                .. attribute:: ethertype
                                                                                                
                                                                                                	Ethernet type
                                                                                                	**type**\:  :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                                
                                                                                                .. attribute:: flow_key_data
                                                                                                
                                                                                                	Flow key structure
                                                                                                	**type**\:  :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                                
                                                                                                .. attribute:: dhcp_client_id
                                                                                                
                                                                                                	Dhcp Client ID
                                                                                                	**type**\:  :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                                
                                                                                                .. attribute:: dhcp_client_id_regex
                                                                                                
                                                                                                	Dhcp Client ID RegEx
                                                                                                	**type**\:  :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                                
                                                                                                .. attribute:: circuit_id
                                                                                                
                                                                                                	Circuit ID
                                                                                                	**type**\:  :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                                
                                                                                                .. attribute:: circuit_id_regex
                                                                                                
                                                                                                	Circuit ID RegEx
                                                                                                	**type**\:  :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                                
                                                                                                .. attribute:: remote_id
                                                                                                
                                                                                                	Remote ID
                                                                                                	**type**\:  :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                                
                                                                                                .. attribute:: remote_id_regex
                                                                                                
                                                                                                	Remote ID RegEx
                                                                                                	**type**\:  :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                                
                                                                                                .. attribute:: src_port
                                                                                                
                                                                                                	Source port
                                                                                                	**type**\:  :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                                
                                                                                                .. attribute:: dst_port
                                                                                                
                                                                                                	Destination port
                                                                                                	**type**\:  :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	type
                                                                                                	**type**\:  :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                                
                                                                                                .. attribute:: mpls_top_eos
                                                                                                
                                                                                                	MPLS Topmost EOS
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: fragment_type
                                                                                                
                                                                                                	Fragment type
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: authen_status
                                                                                                
                                                                                                	Authentication Status
                                                                                                	**type**\:  :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                                
                                                                                                .. attribute:: mlp_negotiated
                                                                                                
                                                                                                	MLP Negotiated
                                                                                                	**type**\:  :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                                    self.yang_name = "match-data"
                                                                                                    self.yang_parent_name = "class-match-info-st"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv4-dscp", ("ipv4_dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp)), ("ipv6-dscp", ("ipv6_dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp)), ("dscp", ("dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp)), ("ipv4-prec", ("ipv4_prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec)), ("ipv6-prec", ("ipv6_prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec)), ("prec", ("prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec)), ("discard-class", ("discard_class", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass)), ("qos-group", ("qos_group", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup)), ("traffic-class", ("traffic_class", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass)), ("proto", ("proto", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto)), ("icmp-v4", ("icmp_v4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4)), ("icmp-v6", ("icmp_v6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6)), ("ipv4-packet-len", ("ipv4_packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen)), ("ipv6-packet-len", ("ipv6_packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen)), ("packet-len", ("packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen)), ("flow-tag", ("flow_tag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag)), ("tcp-flag", ("tcp_flag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag)), ("icmpv4-type", ("icmpv4_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type)), ("icmpv4-code", ("icmpv4_code", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code)), ("icmpv6-type", ("icmpv6_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type)), ("icmpv6-code", ("icmpv6_code", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code)), ("mpls-exp", ("mpls_exp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp)), ("mpls-exp-imp", ("mpls_exp_imp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp)), ("mpls-disp-ipv4-acl", ("mpls_disp_ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl)), ("mpls-disp-ipv6-acl", ("mpls_disp_ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl)), ("mpls-top-label", ("mpls_top_label", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel)), ("cos", ("cos", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos)), ("cos-inr", ("cos_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr)), ("dei", ("dei", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei)), ("dei-inr", ("dei_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr)), ("vlan", ("vlan", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan)), ("vlan-inr", ("vlan_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)), ("fr-dlci", ("fr_dlci", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci)), ("src-mac", ("src_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac)), ("dst-mac", ("dst_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac)), ("atm-clp", ("atm_clp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp)), ("fr-de", ("fr_de", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe)), ("ipv4-acl", ("ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl)), ("ipv6-acl", ("ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl)), ("ether-service-acl", ("ether_service_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl)), ("avail-id", ("avail_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId)), ("media-type", ("media_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType)), ("subs-protocol", ("subs_protocol", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol)), ("dnis", ("dnis", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis)), ("dnis-regex", ("dnis_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex)), ("domain", ("domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain)), ("domain-regex", ("domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex)), ("nas-port", ("nas_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort)), ("service-name", ("service_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName)), ("service-name-regex", ("service_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex)), ("src-addr-ipv4", ("src_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4)), ("dst-addr-ipv4", ("dst_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4)), ("src-addr-ipv6", ("src_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6)), ("dst-addr-ipv6", ("dst_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6)), ("src-addr-mac", ("src_addr_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac)), ("timer", ("timer", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer)), ("timer-regexp", ("timer_regexp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp)), ("tunnel-name", ("tunnel_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName)), ("tunnel-name-regex", ("tunnel_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex)), ("user-name", ("user_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName)), ("user-name-regex", ("user_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex)), ("auth-username", ("auth_username", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername)), ("auth-username-regex", ("auth_username_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex)), ("unauth-username", ("unauth_username", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername)), ("unauth-username-regex", ("unauth_username_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex)), ("auth-domain", ("auth_domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain)), ("auth-domain-regex", ("auth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex)), ("unauth-domain", ("unauth_domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain)), ("unauth-domain-regex", ("unauth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex)), ("vendor-id", ("vendor_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId)), ("vendor-id-regex", ("vendor_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex)), ("access-interface", ("access_interface", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface)), ("input-interface", ("input_interface", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface)), ("input-intfhdl", ("input_intfhdl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl)), ("ethertype", ("ethertype", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype)), ("flow-key-data", ("flow_key_data", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData)), ("dhcp-client-id", ("dhcp_client_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId)), ("dhcp-client-id-regex", ("dhcp_client_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex)), ("circuit-id", ("circuit_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId)), ("circuit-id-regex", ("circuit_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex)), ("remote-id", ("remote_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId)), ("remote-id-regex", ("remote_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex)), ("src-port", ("src_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort)), ("dst-port", ("dst_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort))])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchTypeEn', '')])),
                                                                                                        ('mpls_top_eos', (YLeaf(YType.uint8, 'mpls-top-eos'), ['int'])),
                                                                                                        ('fragment_type', (YLeaf(YType.uint8, 'fragment-type'), ['int'])),
                                                                                                        ('authen_status', (YLeaf(YType.enumeration, 'authen-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchAuthenStatusEn', '')])),
                                                                                                        ('mlp_negotiated', (YLeaf(YType.enumeration, 'mlp-negotiated'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchMlpNegotiatedEn', '')])),
                                                                                                    ])
                                                                                                    self.type = None
                                                                                                    self.mpls_top_eos = None
                                                                                                    self.fragment_type = None
                                                                                                    self.authen_status = None
                                                                                                    self.mlp_negotiated = None

                                                                                                    self.ipv4_dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                                    self.ipv4_dscp.parent = self
                                                                                                    self._children_name_map["ipv4_dscp"] = "ipv4-dscp"

                                                                                                    self.ipv6_dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                                    self.ipv6_dscp.parent = self
                                                                                                    self._children_name_map["ipv6_dscp"] = "ipv6-dscp"

                                                                                                    self.dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                                    self.dscp.parent = self
                                                                                                    self._children_name_map["dscp"] = "dscp"

                                                                                                    self.ipv4_prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                                    self.ipv4_prec.parent = self
                                                                                                    self._children_name_map["ipv4_prec"] = "ipv4-prec"

                                                                                                    self.ipv6_prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                                    self.ipv6_prec.parent = self
                                                                                                    self._children_name_map["ipv6_prec"] = "ipv6-prec"

                                                                                                    self.prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                                    self.prec.parent = self
                                                                                                    self._children_name_map["prec"] = "prec"

                                                                                                    self.discard_class = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                                    self.discard_class.parent = self
                                                                                                    self._children_name_map["discard_class"] = "discard-class"

                                                                                                    self.qos_group = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                                    self.qos_group.parent = self
                                                                                                    self._children_name_map["qos_group"] = "qos-group"

                                                                                                    self.traffic_class = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                                    self.traffic_class.parent = self
                                                                                                    self._children_name_map["traffic_class"] = "traffic-class"

                                                                                                    self.proto = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                                    self.proto.parent = self
                                                                                                    self._children_name_map["proto"] = "proto"

                                                                                                    self.icmp_v4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                                    self.icmp_v4.parent = self
                                                                                                    self._children_name_map["icmp_v4"] = "icmp-v4"

                                                                                                    self.icmp_v6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                                    self.icmp_v6.parent = self
                                                                                                    self._children_name_map["icmp_v6"] = "icmp-v6"

                                                                                                    self.ipv4_packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                                    self.ipv4_packet_len.parent = self
                                                                                                    self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"

                                                                                                    self.ipv6_packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                                    self.ipv6_packet_len.parent = self
                                                                                                    self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"

                                                                                                    self.packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                                    self.packet_len.parent = self
                                                                                                    self._children_name_map["packet_len"] = "packet-len"

                                                                                                    self.flow_tag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                                    self.flow_tag.parent = self
                                                                                                    self._children_name_map["flow_tag"] = "flow-tag"

                                                                                                    self.tcp_flag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                                    self.tcp_flag.parent = self
                                                                                                    self._children_name_map["tcp_flag"] = "tcp-flag"

                                                                                                    self.icmpv4_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                                    self.icmpv4_type.parent = self
                                                                                                    self._children_name_map["icmpv4_type"] = "icmpv4-type"

                                                                                                    self.icmpv4_code = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                                    self.icmpv4_code.parent = self
                                                                                                    self._children_name_map["icmpv4_code"] = "icmpv4-code"

                                                                                                    self.icmpv6_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                                    self.icmpv6_type.parent = self
                                                                                                    self._children_name_map["icmpv6_type"] = "icmpv6-type"

                                                                                                    self.icmpv6_code = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                                    self.icmpv6_code.parent = self
                                                                                                    self._children_name_map["icmpv6_code"] = "icmpv6-code"

                                                                                                    self.mpls_exp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                                    self.mpls_exp.parent = self
                                                                                                    self._children_name_map["mpls_exp"] = "mpls-exp"

                                                                                                    self.mpls_exp_imp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                                    self.mpls_exp_imp.parent = self
                                                                                                    self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"

                                                                                                    self.mpls_disp_ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                                    self.mpls_disp_ipv4_acl.parent = self
                                                                                                    self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"

                                                                                                    self.mpls_disp_ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                                    self.mpls_disp_ipv6_acl.parent = self
                                                                                                    self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"

                                                                                                    self.mpls_top_label = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                                    self.mpls_top_label.parent = self
                                                                                                    self._children_name_map["mpls_top_label"] = "mpls-top-label"

                                                                                                    self.cos = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                                    self.cos.parent = self
                                                                                                    self._children_name_map["cos"] = "cos"

                                                                                                    self.cos_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                                    self.cos_inr.parent = self
                                                                                                    self._children_name_map["cos_inr"] = "cos-inr"

                                                                                                    self.dei = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                                    self.dei.parent = self
                                                                                                    self._children_name_map["dei"] = "dei"

                                                                                                    self.dei_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                                    self.dei_inr.parent = self
                                                                                                    self._children_name_map["dei_inr"] = "dei-inr"

                                                                                                    self.vlan = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                                    self.vlan.parent = self
                                                                                                    self._children_name_map["vlan"] = "vlan"

                                                                                                    self.vlan_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                                    self.vlan_inr.parent = self
                                                                                                    self._children_name_map["vlan_inr"] = "vlan-inr"

                                                                                                    self.fr_dlci = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                                    self.fr_dlci.parent = self
                                                                                                    self._children_name_map["fr_dlci"] = "fr-dlci"

                                                                                                    self.src_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                                    self.src_mac.parent = self
                                                                                                    self._children_name_map["src_mac"] = "src-mac"

                                                                                                    self.dst_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                                    self.dst_mac.parent = self
                                                                                                    self._children_name_map["dst_mac"] = "dst-mac"

                                                                                                    self.atm_clp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                                    self.atm_clp.parent = self
                                                                                                    self._children_name_map["atm_clp"] = "atm-clp"

                                                                                                    self.fr_de = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                                    self.fr_de.parent = self
                                                                                                    self._children_name_map["fr_de"] = "fr-de"

                                                                                                    self.ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                                    self.ipv4_acl.parent = self
                                                                                                    self._children_name_map["ipv4_acl"] = "ipv4-acl"

                                                                                                    self.ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                                    self.ipv6_acl.parent = self
                                                                                                    self._children_name_map["ipv6_acl"] = "ipv6-acl"

                                                                                                    self.ether_service_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                                    self.ether_service_acl.parent = self
                                                                                                    self._children_name_map["ether_service_acl"] = "ether-service-acl"

                                                                                                    self.avail_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                                    self.avail_id.parent = self
                                                                                                    self._children_name_map["avail_id"] = "avail-id"

                                                                                                    self.media_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                                    self.media_type.parent = self
                                                                                                    self._children_name_map["media_type"] = "media-type"

                                                                                                    self.subs_protocol = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                                    self.subs_protocol.parent = self
                                                                                                    self._children_name_map["subs_protocol"] = "subs-protocol"

                                                                                                    self.dnis = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                                    self.dnis.parent = self
                                                                                                    self._children_name_map["dnis"] = "dnis"

                                                                                                    self.dnis_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                                    self.dnis_regex.parent = self
                                                                                                    self._children_name_map["dnis_regex"] = "dnis-regex"

                                                                                                    self.domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                                    self.domain.parent = self
                                                                                                    self._children_name_map["domain"] = "domain"

                                                                                                    self.domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                                    self.domain_regex.parent = self
                                                                                                    self._children_name_map["domain_regex"] = "domain-regex"

                                                                                                    self.nas_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                                    self.nas_port.parent = self
                                                                                                    self._children_name_map["nas_port"] = "nas-port"

                                                                                                    self.service_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                                    self.service_name.parent = self
                                                                                                    self._children_name_map["service_name"] = "service-name"

                                                                                                    self.service_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                                    self.service_name_regex.parent = self
                                                                                                    self._children_name_map["service_name_regex"] = "service-name-regex"

                                                                                                    self.src_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                                    self.src_addr_ipv4.parent = self
                                                                                                    self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"

                                                                                                    self.dst_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                                    self.dst_addr_ipv4.parent = self
                                                                                                    self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"

                                                                                                    self.src_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                                    self.src_addr_ipv6.parent = self
                                                                                                    self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"

                                                                                                    self.dst_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                                    self.dst_addr_ipv6.parent = self
                                                                                                    self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"

                                                                                                    self.src_addr_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                                    self.src_addr_mac.parent = self
                                                                                                    self._children_name_map["src_addr_mac"] = "src-addr-mac"

                                                                                                    self.timer = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                                    self.timer.parent = self
                                                                                                    self._children_name_map["timer"] = "timer"

                                                                                                    self.timer_regexp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                                    self.timer_regexp.parent = self
                                                                                                    self._children_name_map["timer_regexp"] = "timer-regexp"

                                                                                                    self.tunnel_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                                    self.tunnel_name.parent = self
                                                                                                    self._children_name_map["tunnel_name"] = "tunnel-name"

                                                                                                    self.tunnel_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                                    self.tunnel_name_regex.parent = self
                                                                                                    self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"

                                                                                                    self.user_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                                    self.user_name.parent = self
                                                                                                    self._children_name_map["user_name"] = "user-name"

                                                                                                    self.user_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                                    self.user_name_regex.parent = self
                                                                                                    self._children_name_map["user_name_regex"] = "user-name-regex"

                                                                                                    self.auth_username = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                                    self.auth_username.parent = self
                                                                                                    self._children_name_map["auth_username"] = "auth-username"

                                                                                                    self.auth_username_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                                    self.auth_username_regex.parent = self
                                                                                                    self._children_name_map["auth_username_regex"] = "auth-username-regex"

                                                                                                    self.unauth_username = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                                    self.unauth_username.parent = self
                                                                                                    self._children_name_map["unauth_username"] = "unauth-username"

                                                                                                    self.unauth_username_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                                    self.unauth_username_regex.parent = self
                                                                                                    self._children_name_map["unauth_username_regex"] = "unauth-username-regex"

                                                                                                    self.auth_domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                                    self.auth_domain.parent = self
                                                                                                    self._children_name_map["auth_domain"] = "auth-domain"

                                                                                                    self.auth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                                    self.auth_domain_regex.parent = self
                                                                                                    self._children_name_map["auth_domain_regex"] = "auth-domain-regex"

                                                                                                    self.unauth_domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                                    self.unauth_domain.parent = self
                                                                                                    self._children_name_map["unauth_domain"] = "unauth-domain"

                                                                                                    self.unauth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                                    self.unauth_domain_regex.parent = self
                                                                                                    self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"

                                                                                                    self.vendor_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                                    self.vendor_id.parent = self
                                                                                                    self._children_name_map["vendor_id"] = "vendor-id"

                                                                                                    self.vendor_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                                    self.vendor_id_regex.parent = self
                                                                                                    self._children_name_map["vendor_id_regex"] = "vendor-id-regex"

                                                                                                    self.access_interface = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                                    self.access_interface.parent = self
                                                                                                    self._children_name_map["access_interface"] = "access-interface"

                                                                                                    self.input_interface = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                                    self.input_interface.parent = self
                                                                                                    self._children_name_map["input_interface"] = "input-interface"

                                                                                                    self.input_intfhdl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                                    self.input_intfhdl.parent = self
                                                                                                    self._children_name_map["input_intfhdl"] = "input-intfhdl"

                                                                                                    self.ethertype = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                                    self.ethertype.parent = self
                                                                                                    self._children_name_map["ethertype"] = "ethertype"

                                                                                                    self.flow_key_data = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                                    self.flow_key_data.parent = self
                                                                                                    self._children_name_map["flow_key_data"] = "flow-key-data"

                                                                                                    self.dhcp_client_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                                    self.dhcp_client_id.parent = self
                                                                                                    self._children_name_map["dhcp_client_id"] = "dhcp-client-id"

                                                                                                    self.dhcp_client_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                                    self.dhcp_client_id_regex.parent = self
                                                                                                    self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"

                                                                                                    self.circuit_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                                    self.circuit_id.parent = self
                                                                                                    self._children_name_map["circuit_id"] = "circuit-id"

                                                                                                    self.circuit_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                                    self.circuit_id_regex.parent = self
                                                                                                    self._children_name_map["circuit_id_regex"] = "circuit-id-regex"

                                                                                                    self.remote_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                                    self.remote_id.parent = self
                                                                                                    self._children_name_map["remote_id"] = "remote-id"

                                                                                                    self.remote_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                                    self.remote_id_regex.parent = self
                                                                                                    self._children_name_map["remote_id_regex"] = "remote-id-regex"

                                                                                                    self.src_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                                    self.src_port.parent = self
                                                                                                    self._children_name_map["src_port"] = "src-port"

                                                                                                    self.dst_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                                    self.dst_port.parent = self
                                                                                                    self._children_name_map["dst_port"] = "dst-port"
                                                                                                    self._segment_path = lambda: "match-data"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['type', 'mpls_top_eos', 'fragment_type', 'authen_status', 'mlp_negotiated'], name, value)


                                                                                                class Ipv4Dscp(Entity):
                                                                                                    """
                                                                                                    IPv4 DSCP
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                        self.yang_name = "ipv4-dscp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ipv4-dscp"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "ipv4-dscp"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                                class Ipv6Dscp(Entity):
                                                                                                    """
                                                                                                    IPv6 DSCP
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                        self.yang_name = "ipv6-dscp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ipv6-dscp"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "ipv6-dscp"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                                class Dscp(Entity):
                                                                                                    """
                                                                                                    Match DSCP range array
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                        self.yang_name = "dscp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "dscp"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "dscp"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                                class Ipv4Prec(Entity):
                                                                                                    """
                                                                                                    IPv4 Precedence
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                        self.yang_name = "ipv4-prec"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "ipv4-prec"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                                class Ipv6Prec(Entity):
                                                                                                    """
                                                                                                    IPv6 Precedence
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                        self.yang_name = "ipv6-prec"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "ipv6-prec"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                                class Prec(Entity):
                                                                                                    """
                                                                                                    Match Precedence array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                        self.yang_name = "prec"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "prec"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                                class DiscardClass(Entity):
                                                                                                    """
                                                                                                    Match Discard Class array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                        self.yang_name = "discard-class"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "discard-class"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                                class QosGroup(Entity):
                                                                                                    """
                                                                                                    Match QoS group array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                        self.yang_name = "qos-group"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "qos-group"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "qos-group"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['min', 'max'], name, value)


                                                                                                class TrafficClass(Entity):
                                                                                                    """
                                                                                                    Match Traffic class array
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                        self.yang_name = "traffic-class"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "traffic-class"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "traffic-class"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['min', 'max'], name, value)


                                                                                                class Proto(Entity):
                                                                                                    """
                                                                                                    Match Protocol array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                        self.yang_name = "proto"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "proto"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "proto"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['min', 'max'], name, value)


                                                                                                class IcmpV4(Entity):
                                                                                                    """
                                                                                                    Match ICMPV4 Protocol
                                                                                                    
                                                                                                    .. attribute:: type
                                                                                                    
                                                                                                    	Protocol type
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: code
                                                                                                    
                                                                                                    	Protocol code
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                        self.yang_name = "icmp-v4"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                            ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                        ])
                                                                                                        self.type = None
                                                                                                        self.code = None
                                                                                                        self._segment_path = lambda: "icmp-v4"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['type', 'code'], name, value)


                                                                                                class IcmpV6(Entity):
                                                                                                    """
                                                                                                    Match ICMPV6 Protocol array
                                                                                                    
                                                                                                    .. attribute:: type
                                                                                                    
                                                                                                    	Protocol type
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: code
                                                                                                    
                                                                                                    	Protocol code
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                        self.yang_name = "icmp-v6"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                            ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                        ])
                                                                                                        self.type = None
                                                                                                        self.code = None
                                                                                                        self._segment_path = lambda: "icmp-v6"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['type', 'code'], name, value)


                                                                                                class Ipv4PacketLen(Entity):
                                                                                                    """
                                                                                                    IPv4 packet length array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                        self.yang_name = "ipv4-packet-len"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ipv4-packet-len"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "ipv4-packet-len"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                                class Ipv6PacketLen(Entity):
                                                                                                    """
                                                                                                    IPv6 packet length array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                        self.yang_name = "ipv6-packet-len"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ipv6-packet-len"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "ipv6-packet-len"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                                class PacketLen(Entity):
                                                                                                    """
                                                                                                    Match packet length array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                        self.yang_name = "packet-len"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "packet-len"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "packet-len"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                                class FlowTag(Entity):
                                                                                                    """
                                                                                                    Match flow\-tag array
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                        self.yang_name = "flow-tag"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "flow-tag"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "flow-tag"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['min', 'max'], name, value)


                                                                                                class TcpFlag(Entity):
                                                                                                    """
                                                                                                    Match tcp flag value
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	Value of TCP flag
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: match_any
                                                                                                    
                                                                                                    	Match any TCP flag bit
                                                                                                    	**type**\: bool
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                        self.yang_name = "tcp-flag"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                                            ('match_any', (YLeaf(YType.boolean, 'match-any'), ['bool'])),
                                                                                                        ])
                                                                                                        self.value = None
                                                                                                        self.match_any = None
                                                                                                        self._segment_path = lambda: "tcp-flag"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['value', 'match_any'], name, value)


                                                                                                class Icmpv4Type(Entity):
                                                                                                    """
                                                                                                    Match ipv4 icmp type
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                        self.yang_name = "icmpv4-type"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "icmpv4-type"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "icmpv4-type"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                                class Icmpv4Code(Entity):
                                                                                                    """
                                                                                                    Match ipv4 icmp code
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                        self.yang_name = "icmpv4-code"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "icmpv4-code"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "icmpv4-code"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                                class Icmpv6Type(Entity):
                                                                                                    """
                                                                                                    Match ipv6 icmp type
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                        self.yang_name = "icmpv6-type"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "icmpv6-type"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "icmpv6-type"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                                class Icmpv6Code(Entity):
                                                                                                    """
                                                                                                    Match ipv6 icmp code
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                        self.yang_name = "icmpv6-code"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "icmpv6-code"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "icmpv6-code"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                                class MplsExp(Entity):
                                                                                                    """
                                                                                                    Match MPLS experimental topmost array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                        self.yang_name = "mpls-exp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "mpls-exp"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                                class MplsExpImp(Entity):
                                                                                                    """
                                                                                                    Match MPLS experimental imposition array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                        self.yang_name = "mpls-exp-imp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "mpls-exp-imp"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                                class MplsDispIpv4Acl(Entity):
                                                                                                    """
                                                                                                    MPLS Disposition IPv4 Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                        self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "mpls-disp-ipv4-acl"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                                class MplsDispIpv6Acl(Entity):
                                                                                                    """
                                                                                                    MPLS Disposition IPv6 Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                        self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "mpls-disp-ipv6-acl"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                                class MplsTopLabel(Entity):
                                                                                                    """
                                                                                                    MPLS Topmost LABEL
                                                                                                    
                                                                                                    .. attribute:: uint32_rng_array
                                                                                                    
                                                                                                    	uint32 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                        self.yang_name = "mpls-top-label"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint32_rng_array", ("uint32_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint32_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "mpls-top-label"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                                    class Uint32RngArray(Entity):
                                                                                                        """
                                                                                                        uint32 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                            self.yang_name = "uint32_rng_array"
                                                                                                            self.yang_parent_name = "mpls-top-label"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint32, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint32, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint32_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['min', 'max'], name, value)


                                                                                                class Cos(Entity):
                                                                                                    """
                                                                                                    Match CoS array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                        self.yang_name = "cos"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "cos"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                                class CosInr(Entity):
                                                                                                    """
                                                                                                    Match inner header CoS
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                        self.yang_name = "cos-inr"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "cos-inr"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                                class Dei(Entity):
                                                                                                    """
                                                                                                    Match DEI Bit
                                                                                                    
                                                                                                    .. attribute:: bit_value
                                                                                                    
                                                                                                    	Value of the DEI bit
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                        self.yang_name = "dei"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                        ])
                                                                                                        self.bit_value = None
                                                                                                        self._segment_path = lambda: "dei"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                                class DeiInr(Entity):
                                                                                                    """
                                                                                                    Match inner DEI Bit
                                                                                                    
                                                                                                    .. attribute:: bit_value
                                                                                                    
                                                                                                    	Value of the DEI bit
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                        self.yang_name = "dei-inr"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                        ])
                                                                                                        self.bit_value = None
                                                                                                        self._segment_path = lambda: "dei-inr"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                                class Vlan(Entity):
                                                                                                    """
                                                                                                    Match VLAN array
                                                                                                    
                                                                                                    .. attribute:: vlan_id_array
                                                                                                    
                                                                                                    	vlan id array
                                                                                                    	**type**\: list of  		 :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                        self.yang_name = "vlan"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("vlan-id-array", ("vlan_id_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.vlan_id_array = YList(self)
                                                                                                        self._segment_path = lambda: "vlan"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                                    class VlanIdArray(Entity):
                                                                                                        """
                                                                                                        vlan id array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	VLAN mask
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                            self.yang_name = "vlan-id-array"
                                                                                                            self.yang_parent_name = "vlan"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                                ('mask', (YLeaf(YType.uint16, 'mask'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self.mask = None
                                                                                                            self._segment_path = lambda: "vlan-id-array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['min', 'max', 'mask'], name, value)


                                                                                                class VlanInr(Entity):
                                                                                                    """
                                                                                                    Match inner header VLAN range array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                        self.yang_name = "vlan-inr"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "vlan-inr"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "vlan-inr"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['min', 'max'], name, value)


                                                                                                class FrDlci(Entity):
                                                                                                    """
                                                                                                    Match FR DLCI range array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                        self.yang_name = "fr-dlci"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "fr-dlci"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "fr-dlci"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['min', 'max'], name, value)


                                                                                                class SrcMac(Entity):
                                                                                                    """
                                                                                                    Match Source MAC address
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                        self.yang_name = "src-mac"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                            ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.mac_addr = []
                                                                                                        self.mask = []
                                                                                                        self._segment_path = lambda: "src-mac"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                                class DstMac(Entity):
                                                                                                    """
                                                                                                    Match Destination MAC address
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                        self.yang_name = "dst-mac"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                            ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.mac_addr = []
                                                                                                        self.mask = []
                                                                                                        self._segment_path = lambda: "dst-mac"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                                class AtmClp(Entity):
                                                                                                    """
                                                                                                    Match ATM CLP level
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                        self.yang_name = "atm-clp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "atm-clp"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                                class FrDe(Entity):
                                                                                                    """
                                                                                                    Match FR DE value
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                        self.yang_name = "fr-de"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "fr-de"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                                class Ipv4Acl(Entity):
                                                                                                    """
                                                                                                    IPv4 Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                        self.yang_name = "ipv4-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "ipv4-acl"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                                class Ipv6Acl(Entity):
                                                                                                    """
                                                                                                    IPv6 Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                        self.yang_name = "ipv6-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "ipv6-acl"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                                class EtherServiceAcl(Entity):
                                                                                                    """
                                                                                                    Ethernet\-Services Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                        self.yang_name = "ether-service-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "ether-service-acl"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                                class AvailId(Entity):
                                                                                                    """
                                                                                                    Available Identifiers
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                        self.yang_name = "avail-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "avail-id"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                                class MediaType(Entity):
                                                                                                    """
                                                                                                    Media Type
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                        self.yang_name = "media-type"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "media-type"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                                class SubsProtocol(Entity):
                                                                                                    """
                                                                                                    Protocol
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                        self.yang_name = "subs-protocol"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "subs-protocol"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                                class Dnis(Entity):
                                                                                                    """
                                                                                                    DNIS
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                        self.yang_name = "dnis"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "dnis"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                                class DnisRegex(Entity):
                                                                                                    """
                                                                                                    DNIS Regular Expression
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                        self.yang_name = "dnis-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "dnis-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                                class Domain(Entity):
                                                                                                    """
                                                                                                    Domain Name
                                                                                                    
                                                                                                    .. attribute:: domain_array
                                                                                                    
                                                                                                    	domain array
                                                                                                    	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                        self.yang_name = "domain"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.domain_array = YList(self)
                                                                                                        self._segment_path = lambda: "domain"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                                    class DomainArray(Entity):
                                                                                                        """
                                                                                                        domain array
                                                                                                        
                                                                                                        .. attribute:: domain_name
                                                                                                        
                                                                                                        	domain name
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        .. attribute:: format_name
                                                                                                        
                                                                                                        	format name
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                            self.yang_name = "domain-array"
                                                                                                            self.yang_parent_name = "domain"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                                ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                            ])
                                                                                                            self.domain_name = None
                                                                                                            self.format_name = None
                                                                                                            self._segment_path = lambda: "domain-array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                                class DomainRegex(Entity):
                                                                                                    """
                                                                                                    Domain Regular Expression
                                                                                                    
                                                                                                    .. attribute:: domain_array
                                                                                                    
                                                                                                    	domain array
                                                                                                    	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                        self.yang_name = "domain-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.domain_array = YList(self)
                                                                                                        self._segment_path = lambda: "domain-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                                    class DomainArray(Entity):
                                                                                                        """
                                                                                                        domain array
                                                                                                        
                                                                                                        .. attribute:: domain_name
                                                                                                        
                                                                                                        	domain name
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        .. attribute:: format_name
                                                                                                        
                                                                                                        	format name
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                            self.yang_name = "domain-array"
                                                                                                            self.yang_parent_name = "domain-regex"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                                ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                            ])
                                                                                                            self.domain_name = None
                                                                                                            self.format_name = None
                                                                                                            self._segment_path = lambda: "domain-array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                                class NasPort(Entity):
                                                                                                    """
                                                                                                    NAS Port
                                                                                                    
                                                                                                    .. attribute:: nas_port_array
                                                                                                    
                                                                                                    	nas port array
                                                                                                    	**type**\: list of  		 :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                        self.yang_name = "nas-port"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("nas-port-array", ("nas_port_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.nas_port_array = YList(self)
                                                                                                        self._segment_path = lambda: "nas-port"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                                    class NasPortArray(Entity):
                                                                                                        """
                                                                                                        nas port array
                                                                                                        
                                                                                                        .. attribute:: sub_id
                                                                                                        
                                                                                                        	sub id
                                                                                                        	**type**\:  :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                        
                                                                                                        .. attribute:: operator
                                                                                                        
                                                                                                        	operator
                                                                                                        	**type**\:  :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                        
                                                                                                        .. attribute:: value
                                                                                                        
                                                                                                        	value
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                            self.yang_name = "nas-port-array"
                                                                                                            self.yang_parent_name = "nas-port"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('sub_id', (YLeaf(YType.enumeration, 'sub-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchNasPortSubIdEn', '')])),
                                                                                                                ('operator', (YLeaf(YType.enumeration, 'operator'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchLogicalOperatorEn', '')])),
                                                                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                                            ])
                                                                                                            self.sub_id = None
                                                                                                            self.operator = None
                                                                                                            self.value = None
                                                                                                            self._segment_path = lambda: "nas-port-array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['sub_id', 'operator', 'value'], name, value)


                                                                                                class ServiceName(Entity):
                                                                                                    """
                                                                                                    Service Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                        self.yang_name = "service-name"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "service-name"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                                class ServiceNameRegex(Entity):
                                                                                                    """
                                                                                                    Service Name Regular Exp
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                        self.yang_name = "service-name-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "service-name-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                                class SrcAddrIpv4(Entity):
                                                                                                    """
                                                                                                    Source Address IPV4
                                                                                                    
                                                                                                    .. attribute:: ipv4_addr_array
                                                                                                    
                                                                                                    	ipv4 addr array
                                                                                                    	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                        self.yang_name = "src-addr-ipv4"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.ipv4_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "src-addr-ipv4"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                                    class Ipv4AddrArray(Entity):
                                                                                                        """
                                                                                                        ipv4 addr array
                                                                                                        
                                                                                                        .. attribute:: prefix
                                                                                                        
                                                                                                        	prefix
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	mask
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                            self.yang_name = "ipv4-addr-array"
                                                                                                            self.yang_parent_name = "src-addr-ipv4"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                                ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                            ])
                                                                                                            self.prefix = None
                                                                                                            self.mask = None
                                                                                                            self._segment_path = lambda: "ipv4-addr-array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                                class DstAddrIpv4(Entity):
                                                                                                    """
                                                                                                    Destination Address IPV4
                                                                                                    
                                                                                                    .. attribute:: ipv4_addr_array
                                                                                                    
                                                                                                    	ipv4 addr array
                                                                                                    	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                        self.yang_name = "dst-addr-ipv4"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.ipv4_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "dst-addr-ipv4"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                                    class Ipv4AddrArray(Entity):
                                                                                                        """
                                                                                                        ipv4 addr array
                                                                                                        
                                                                                                        .. attribute:: prefix
                                                                                                        
                                                                                                        	prefix
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	mask
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                            self.yang_name = "ipv4-addr-array"
                                                                                                            self.yang_parent_name = "dst-addr-ipv4"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                                ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                            ])
                                                                                                            self.prefix = None
                                                                                                            self.mask = None
                                                                                                            self._segment_path = lambda: "ipv4-addr-array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                                class SrcAddrIpv6(Entity):
                                                                                                    """
                                                                                                    Source Address IPV6
                                                                                                    
                                                                                                    .. attribute:: ipv6_addr_array
                                                                                                    
                                                                                                    	ipv6 addr array
                                                                                                    	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                        self.yang_name = "src-addr-ipv6"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.ipv6_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "src-addr-ipv6"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                                    class Ipv6AddrArray(Entity):
                                                                                                        """
                                                                                                        ipv6 addr array
                                                                                                        
                                                                                                        .. attribute:: prefix
                                                                                                        
                                                                                                        	IPV6 prefix
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	IPV6 mask
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                            self.yang_name = "ipv6-addr-array"
                                                                                                            self.yang_parent_name = "src-addr-ipv6"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                                ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                            ])
                                                                                                            self.prefix = None
                                                                                                            self.mask = None
                                                                                                            self._segment_path = lambda: "ipv6-addr-array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                                class DstAddrIpv6(Entity):
                                                                                                    """
                                                                                                    Destination Address IPV6
                                                                                                    
                                                                                                    .. attribute:: ipv6_addr_array
                                                                                                    
                                                                                                    	ipv6 addr array
                                                                                                    	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                        self.yang_name = "dst-addr-ipv6"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.ipv6_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "dst-addr-ipv6"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                                    class Ipv6AddrArray(Entity):
                                                                                                        """
                                                                                                        ipv6 addr array
                                                                                                        
                                                                                                        .. attribute:: prefix
                                                                                                        
                                                                                                        	IPV6 prefix
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	IPV6 mask
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                            self.yang_name = "ipv6-addr-array"
                                                                                                            self.yang_parent_name = "dst-addr-ipv6"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                                ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                            ])
                                                                                                            self.prefix = None
                                                                                                            self.mask = None
                                                                                                            self._segment_path = lambda: "ipv6-addr-array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                                class SrcAddrMac(Entity):
                                                                                                    """
                                                                                                    Source Address MAC
                                                                                                    
                                                                                                    .. attribute:: mac_addr_array
                                                                                                    
                                                                                                    	mac addr array
                                                                                                    	**type**\: list of  		 :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                        self.yang_name = "src-addr-mac"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("mac-addr-array", ("mac_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.mac_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "src-addr-mac"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                                    class MacAddrArray(Entity):
                                                                                                        """
                                                                                                        mac addr array
                                                                                                        
                                                                                                        .. attribute:: mac_addr
                                                                                                        
                                                                                                        	MAC address
                                                                                                        	**type**\: list of int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	MAC mask
                                                                                                        	**type**\: list of int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                            self.yang_name = "mac-addr-array"
                                                                                                            self.yang_parent_name = "src-addr-mac"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                                ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                            ])
                                                                                                            self.mac_addr = []
                                                                                                            self.mask = []
                                                                                                            self._segment_path = lambda: "mac-addr-array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                                class Timer(Entity):
                                                                                                    """
                                                                                                    Timer
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                        self.yang_name = "timer"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "timer"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                                class TimerRegexp(Entity):
                                                                                                    """
                                                                                                    Timer Regular Expression
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                        self.yang_name = "timer-regexp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "timer-regexp"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                                class TunnelName(Entity):
                                                                                                    """
                                                                                                    Tunnel Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                        self.yang_name = "tunnel-name"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "tunnel-name"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                                class TunnelNameRegex(Entity):
                                                                                                    """
                                                                                                    Tunnel Name Regular Expression
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                        self.yang_name = "tunnel-name-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "tunnel-name-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                                class UserName(Entity):
                                                                                                    """
                                                                                                    User Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                        self.yang_name = "user-name"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "user-name"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                                class UserNameRegex(Entity):
                                                                                                    """
                                                                                                    User Name Regular Expression
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                        self.yang_name = "user-name-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "user-name-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                                class AuthUsername(Entity):
                                                                                                    """
                                                                                                    Authenticated User Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                        self.yang_name = "auth-username"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "auth-username"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                                class AuthUsernameRegex(Entity):
                                                                                                    """
                                                                                                    Authenticated User Name RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                        self.yang_name = "auth-username-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "auth-username-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                                class UnauthUsername(Entity):
                                                                                                    """
                                                                                                    Unauthenticated User Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                        self.yang_name = "unauth-username"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "unauth-username"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                                class UnauthUsernameRegex(Entity):
                                                                                                    """
                                                                                                    Unauthenticated User Name RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                        self.yang_name = "unauth-username-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "unauth-username-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                                class AuthDomain(Entity):
                                                                                                    """
                                                                                                    Authenticated domain name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                        self.yang_name = "auth-domain"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "auth-domain"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                                class AuthDomainRegex(Entity):
                                                                                                    """
                                                                                                    Authenticated Domain Name RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                        self.yang_name = "auth-domain-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "auth-domain-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                                class UnauthDomain(Entity):
                                                                                                    """
                                                                                                    Unauthenticated Domain Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                        self.yang_name = "unauth-domain"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "unauth-domain"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                                class UnauthDomainRegex(Entity):
                                                                                                    """
                                                                                                    Unauthenticated Domain Name RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                        self.yang_name = "unauth-domain-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "unauth-domain-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                                class VendorId(Entity):
                                                                                                    """
                                                                                                    Vendor ID
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                        self.yang_name = "vendor-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "vendor-id"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                                class VendorIdRegex(Entity):
                                                                                                    """
                                                                                                    Vendor ID RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                        self.yang_name = "vendor-id-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "vendor-id-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                                class AccessInterface(Entity):
                                                                                                    """
                                                                                                    Access interface
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                        self.yang_name = "access-interface"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "access-interface"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                                class InputInterface(Entity):
                                                                                                    """
                                                                                                    Input interface
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                        self.yang_name = "input-interface"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "input-interface"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                                class InputIntfhdl(Entity):
                                                                                                    """
                                                                                                    Input interface handle
                                                                                                    
                                                                                                    .. attribute:: uint64_array
                                                                                                    
                                                                                                    	uint64 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..18446744073709551615
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                        self.yang_name = "input-intfhdl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint64_array', (YLeafList(YType.uint64, 'uint64_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint64_array = []
                                                                                                        self._segment_path = lambda: "input-intfhdl"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                                class Ethertype(Entity):
                                                                                                    """
                                                                                                    Ethernet type
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                        self.yang_name = "ethertype"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ethertype"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "ethertype"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['min', 'max'], name, value)


                                                                                                class FlowKeyData(Entity):
                                                                                                    """
                                                                                                    Flow key structure
                                                                                                    
                                                                                                    .. attribute:: flow_keys
                                                                                                    
                                                                                                    	flow keys
                                                                                                    	**type**\:  :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                                    
                                                                                                    .. attribute:: max_count
                                                                                                    
                                                                                                    	Maximum count of flows
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: idle_timeout
                                                                                                    
                                                                                                    	Idle timeout of flows (in seconds)
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    	**units**\: second
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                        self.yang_name = "flow-key-data"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("flow-keys", ("flow_keys", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys))])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('max_count', (YLeaf(YType.uint16, 'max-count'), ['int'])),
                                                                                                            ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                                                        ])
                                                                                                        self.max_count = None
                                                                                                        self.idle_timeout = None

                                                                                                        self.flow_keys = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                        self.flow_keys.parent = self
                                                                                                        self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                        self._segment_path = lambda: "flow-key-data"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['max_count', 'idle_timeout'], name, value)


                                                                                                    class FlowKeys(Entity):
                                                                                                        """
                                                                                                        flow keys
                                                                                                        
                                                                                                        .. attribute:: keys
                                                                                                        
                                                                                                        	keys
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                        
                                                                                                        .. attribute:: num
                                                                                                        
                                                                                                        	num
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                            self.yang_name = "flow-keys"
                                                                                                            self.yang_parent_name = "flow-key-data"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('keys', (YLeaf(YType.str, 'keys'), ['str'])),
                                                                                                                ('num', (YLeaf(YType.uint8, 'num'), ['int'])),
                                                                                                            ])
                                                                                                            self.keys = None
                                                                                                            self.num = None
                                                                                                            self._segment_path = lambda: "flow-keys"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                                class DhcpClientId(Entity):
                                                                                                    """
                                                                                                    Dhcp Client ID
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                        self.yang_name = "dhcp-client-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "dhcp-client-id"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                                class DhcpClientIdRegex(Entity):
                                                                                                    """
                                                                                                    Dhcp Client ID RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                        self.yang_name = "dhcp-client-id-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "dhcp-client-id-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                                class CircuitId(Entity):
                                                                                                    """
                                                                                                    Circuit ID
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                        self.yang_name = "circuit-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "circuit-id"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                                class CircuitIdRegex(Entity):
                                                                                                    """
                                                                                                    Circuit ID RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                        self.yang_name = "circuit-id-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "circuit-id-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                                class RemoteId(Entity):
                                                                                                    """
                                                                                                    Remote ID
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                        self.yang_name = "remote-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "remote-id"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                                class RemoteIdRegex(Entity):
                                                                                                    """
                                                                                                    Remote ID RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                        self.yang_name = "remote-id-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "remote-id-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                                class SrcPort(Entity):
                                                                                                    """
                                                                                                    Source port
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                        self.yang_name = "src-port"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "src-port"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "src-port"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                                                class DstPort(Entity):
                                                                                                    """
                                                                                                    Destination port
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                        self.yang_name = "dst-port"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "dst-port"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "dst-port"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class ExcdclassEncode(Entity):
                                                                                """
                                                                                excdclass encode
                                                                                
                                                                                .. attribute:: inline_cmap
                                                                                
                                                                                	inline cmap
                                                                                	**type**\:  :py:class:`InlineCmap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap>`
                                                                                
                                                                                .. attribute:: enc
                                                                                
                                                                                	enc
                                                                                	**type**\:  :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                                
                                                                                .. attribute:: class_name
                                                                                
                                                                                	class name
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..65
                                                                                
                                                                                .. attribute:: hd
                                                                                
                                                                                	hd
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..18446744073709551615
                                                                                
                                                                                .. attribute:: idx
                                                                                
                                                                                	idx
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode, self).__init__()

                                                                                    self.yang_name = "excdclass-encode"
                                                                                    self.yang_parent_name = "police"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("inline-cmap", ("inline_cmap", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('enc', (YLeaf(YType.enumeration, 'enc'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyObjEncEn', '')])),
                                                                                        ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                                                        ('hd', (YLeaf(YType.uint64, 'hd'), ['int'])),
                                                                                        ('idx', (YLeaf(YType.uint8, 'idx'), ['int'])),
                                                                                    ])
                                                                                    self.enc = None
                                                                                    self.class_name = None
                                                                                    self.hd = None
                                                                                    self.idx = None

                                                                                    self.inline_cmap = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap()
                                                                                    self.inline_cmap.parent = self
                                                                                    self._children_name_map["inline_cmap"] = "inline-cmap"
                                                                                    self._segment_path = lambda: "excdclass-encode"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode, ['enc', 'class_name', 'hd', 'idx'], name, value)


                                                                                class InlineCmap(Entity):
                                                                                    """
                                                                                    inline cmap
                                                                                    
                                                                                    .. attribute:: match_infop
                                                                                    
                                                                                    	Pointer to the first Match info
                                                                                    	**type**\:  :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop>`
                                                                                    
                                                                                    .. attribute:: mode
                                                                                    
                                                                                    	Inline Class\-Map Mode Match any/all
                                                                                    	**type**\:  :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                                    
                                                                                    .. attribute:: flags
                                                                                    
                                                                                    	Inline Class\-Map flags
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: match_count
                                                                                    
                                                                                    	Number of Match infos
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap, self).__init__()

                                                                                        self.yang_name = "inline-cmap"
                                                                                        self.yang_parent_name = "excdclass-encode"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("match-infop", ("match_infop", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop))])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapModeEn', '')])),
                                                                                            ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                            ('match_count', (YLeaf(YType.uint32, 'match-count'), ['int'])),
                                                                                        ])
                                                                                        self.mode = None
                                                                                        self.flags = None
                                                                                        self.match_count = None

                                                                                        self.match_infop = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop()
                                                                                        self.match_infop.parent = self
                                                                                        self._children_name_map["match_infop"] = "match-infop"
                                                                                        self._segment_path = lambda: "inline-cmap"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap, ['mode', 'flags', 'match_count'], name, value)


                                                                                    class MatchInfop(Entity):
                                                                                        """
                                                                                        Pointer to the first Match info
                                                                                        
                                                                                        .. attribute:: class_match_info_st
                                                                                        
                                                                                        	class match info st
                                                                                        	**type**\: list of  		 :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop, self).__init__()

                                                                                            self.yang_name = "match-infop"
                                                                                            self.yang_parent_name = "inline-cmap"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("class-match-info-st", ("class_match_info_st", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.class_match_info_st = YList(self)
                                                                                            self._segment_path = lambda: "match-infop"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop, [], name, value)


                                                                                        class ClassMatchInfoSt(Entity):
                                                                                            """
                                                                                            class match info st
                                                                                            
                                                                                            .. attribute:: match_data
                                                                                            
                                                                                            	Match criteria
                                                                                            	**type**\:  :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                            
                                                                                            .. attribute:: flags
                                                                                            
                                                                                            	Flags
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                                self.yang_name = "class-match-info-st"
                                                                                                self.yang_parent_name = "match-infop"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("match-data", ("match_data", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData))])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                                ])
                                                                                                self.flags = None

                                                                                                self.match_data = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                                self.match_data.parent = self
                                                                                                self._children_name_map["match_data"] = "match-data"
                                                                                                self._segment_path = lambda: "class-match-info-st"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                            class MatchData(Entity):
                                                                                                """
                                                                                                Match criteria
                                                                                                
                                                                                                .. attribute:: ipv4_dscp
                                                                                                
                                                                                                	IPv4 DSCP
                                                                                                	**type**\:  :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                                
                                                                                                .. attribute:: ipv6_dscp
                                                                                                
                                                                                                	IPv6 DSCP
                                                                                                	**type**\:  :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                                
                                                                                                .. attribute:: dscp
                                                                                                
                                                                                                	Match DSCP range array
                                                                                                	**type**\:  :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                                
                                                                                                .. attribute:: ipv4_prec
                                                                                                
                                                                                                	IPv4 Precedence
                                                                                                	**type**\:  :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                                
                                                                                                .. attribute:: ipv6_prec
                                                                                                
                                                                                                	IPv6 Precedence
                                                                                                	**type**\:  :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                                
                                                                                                .. attribute:: prec
                                                                                                
                                                                                                	Match Precedence array
                                                                                                	**type**\:  :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                                
                                                                                                .. attribute:: discard_class
                                                                                                
                                                                                                	Match Discard Class array
                                                                                                	**type**\:  :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                                
                                                                                                .. attribute:: qos_group
                                                                                                
                                                                                                	Match QoS group array
                                                                                                	**type**\:  :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                                
                                                                                                .. attribute:: traffic_class
                                                                                                
                                                                                                	Match Traffic class array
                                                                                                	**type**\:  :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                                
                                                                                                .. attribute:: proto
                                                                                                
                                                                                                	Match Protocol array
                                                                                                	**type**\:  :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                                
                                                                                                .. attribute:: icmp_v4
                                                                                                
                                                                                                	Match ICMPV4 Protocol
                                                                                                	**type**\:  :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                                
                                                                                                .. attribute:: icmp_v6
                                                                                                
                                                                                                	Match ICMPV6 Protocol array
                                                                                                	**type**\:  :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                                
                                                                                                .. attribute:: ipv4_packet_len
                                                                                                
                                                                                                	IPv4 packet length array
                                                                                                	**type**\:  :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                                
                                                                                                .. attribute:: ipv6_packet_len
                                                                                                
                                                                                                	IPv6 packet length array
                                                                                                	**type**\:  :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                                
                                                                                                .. attribute:: packet_len
                                                                                                
                                                                                                	Match packet length array
                                                                                                	**type**\:  :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                                
                                                                                                .. attribute:: flow_tag
                                                                                                
                                                                                                	Match flow\-tag array
                                                                                                	**type**\:  :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                                
                                                                                                .. attribute:: tcp_flag
                                                                                                
                                                                                                	Match tcp flag value
                                                                                                	**type**\:  :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                                
                                                                                                .. attribute:: icmpv4_type
                                                                                                
                                                                                                	Match ipv4 icmp type
                                                                                                	**type**\:  :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                                
                                                                                                .. attribute:: icmpv4_code
                                                                                                
                                                                                                	Match ipv4 icmp code
                                                                                                	**type**\:  :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                                
                                                                                                .. attribute:: icmpv6_type
                                                                                                
                                                                                                	Match ipv6 icmp type
                                                                                                	**type**\:  :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                                
                                                                                                .. attribute:: icmpv6_code
                                                                                                
                                                                                                	Match ipv6 icmp code
                                                                                                	**type**\:  :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                                
                                                                                                .. attribute:: mpls_exp
                                                                                                
                                                                                                	Match MPLS experimental topmost array
                                                                                                	**type**\:  :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                                
                                                                                                .. attribute:: mpls_exp_imp
                                                                                                
                                                                                                	Match MPLS experimental imposition array
                                                                                                	**type**\:  :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                                
                                                                                                .. attribute:: mpls_disp_ipv4_acl
                                                                                                
                                                                                                	MPLS Disposition IPv4 Access\-list
                                                                                                	**type**\:  :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                                
                                                                                                .. attribute:: mpls_disp_ipv6_acl
                                                                                                
                                                                                                	MPLS Disposition IPv6 Access\-list
                                                                                                	**type**\:  :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                                
                                                                                                .. attribute:: mpls_top_label
                                                                                                
                                                                                                	MPLS Topmost LABEL
                                                                                                	**type**\:  :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                                
                                                                                                .. attribute:: cos
                                                                                                
                                                                                                	Match CoS array
                                                                                                	**type**\:  :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                                
                                                                                                .. attribute:: cos_inr
                                                                                                
                                                                                                	Match inner header CoS
                                                                                                	**type**\:  :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                                
                                                                                                .. attribute:: dei
                                                                                                
                                                                                                	Match DEI Bit
                                                                                                	**type**\:  :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                                
                                                                                                .. attribute:: dei_inr
                                                                                                
                                                                                                	Match inner DEI Bit
                                                                                                	**type**\:  :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                                
                                                                                                .. attribute:: vlan
                                                                                                
                                                                                                	Match VLAN array
                                                                                                	**type**\:  :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                                
                                                                                                .. attribute:: vlan_inr
                                                                                                
                                                                                                	Match inner header VLAN range array
                                                                                                	**type**\:  :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                                
                                                                                                .. attribute:: fr_dlci
                                                                                                
                                                                                                	Match FR DLCI range array
                                                                                                	**type**\:  :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                                
                                                                                                .. attribute:: src_mac
                                                                                                
                                                                                                	Match Source MAC address
                                                                                                	**type**\:  :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                                
                                                                                                .. attribute:: dst_mac
                                                                                                
                                                                                                	Match Destination MAC address
                                                                                                	**type**\:  :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                                
                                                                                                .. attribute:: atm_clp
                                                                                                
                                                                                                	Match ATM CLP level
                                                                                                	**type**\:  :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                                
                                                                                                .. attribute:: fr_de
                                                                                                
                                                                                                	Match FR DE value
                                                                                                	**type**\:  :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                                
                                                                                                .. attribute:: ipv4_acl
                                                                                                
                                                                                                	IPv4 Access\-list
                                                                                                	**type**\:  :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                                
                                                                                                .. attribute:: ipv6_acl
                                                                                                
                                                                                                	IPv6 Access\-list
                                                                                                	**type**\:  :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                                
                                                                                                .. attribute:: ether_service_acl
                                                                                                
                                                                                                	Ethernet\-Services Access\-list
                                                                                                	**type**\:  :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                                
                                                                                                .. attribute:: avail_id
                                                                                                
                                                                                                	Available Identifiers
                                                                                                	**type**\:  :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                                
                                                                                                .. attribute:: media_type
                                                                                                
                                                                                                	Media Type
                                                                                                	**type**\:  :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                                
                                                                                                .. attribute:: subs_protocol
                                                                                                
                                                                                                	Protocol
                                                                                                	**type**\:  :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                                
                                                                                                .. attribute:: dnis
                                                                                                
                                                                                                	DNIS
                                                                                                	**type**\:  :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                                
                                                                                                .. attribute:: dnis_regex
                                                                                                
                                                                                                	DNIS Regular Expression
                                                                                                	**type**\:  :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                                
                                                                                                .. attribute:: domain
                                                                                                
                                                                                                	Domain Name
                                                                                                	**type**\:  :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                                
                                                                                                .. attribute:: domain_regex
                                                                                                
                                                                                                	Domain Regular Expression
                                                                                                	**type**\:  :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                                
                                                                                                .. attribute:: nas_port
                                                                                                
                                                                                                	NAS Port
                                                                                                	**type**\:  :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                                
                                                                                                .. attribute:: service_name
                                                                                                
                                                                                                	Service Name
                                                                                                	**type**\:  :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                                
                                                                                                .. attribute:: service_name_regex
                                                                                                
                                                                                                	Service Name Regular Exp
                                                                                                	**type**\:  :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                                
                                                                                                .. attribute:: src_addr_ipv4
                                                                                                
                                                                                                	Source Address IPV4
                                                                                                	**type**\:  :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                                
                                                                                                .. attribute:: dst_addr_ipv4
                                                                                                
                                                                                                	Destination Address IPV4
                                                                                                	**type**\:  :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                                
                                                                                                .. attribute:: src_addr_ipv6
                                                                                                
                                                                                                	Source Address IPV6
                                                                                                	**type**\:  :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                                
                                                                                                .. attribute:: dst_addr_ipv6
                                                                                                
                                                                                                	Destination Address IPV6
                                                                                                	**type**\:  :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                                
                                                                                                .. attribute:: src_addr_mac
                                                                                                
                                                                                                	Source Address MAC
                                                                                                	**type**\:  :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                                
                                                                                                .. attribute:: timer
                                                                                                
                                                                                                	Timer
                                                                                                	**type**\:  :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                                
                                                                                                .. attribute:: timer_regexp
                                                                                                
                                                                                                	Timer Regular Expression
                                                                                                	**type**\:  :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                                
                                                                                                .. attribute:: tunnel_name
                                                                                                
                                                                                                	Tunnel Name
                                                                                                	**type**\:  :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                                
                                                                                                .. attribute:: tunnel_name_regex
                                                                                                
                                                                                                	Tunnel Name Regular Expression
                                                                                                	**type**\:  :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                                
                                                                                                .. attribute:: user_name
                                                                                                
                                                                                                	User Name
                                                                                                	**type**\:  :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                                
                                                                                                .. attribute:: user_name_regex
                                                                                                
                                                                                                	User Name Regular Expression
                                                                                                	**type**\:  :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                                
                                                                                                .. attribute:: auth_username
                                                                                                
                                                                                                	Authenticated User Name
                                                                                                	**type**\:  :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                                
                                                                                                .. attribute:: auth_username_regex
                                                                                                
                                                                                                	Authenticated User Name RegEx
                                                                                                	**type**\:  :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                                
                                                                                                .. attribute:: unauth_username
                                                                                                
                                                                                                	Unauthenticated User Name
                                                                                                	**type**\:  :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                                
                                                                                                .. attribute:: unauth_username_regex
                                                                                                
                                                                                                	Unauthenticated User Name RegEx
                                                                                                	**type**\:  :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                                
                                                                                                .. attribute:: auth_domain
                                                                                                
                                                                                                	Authenticated domain name
                                                                                                	**type**\:  :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                                
                                                                                                .. attribute:: auth_domain_regex
                                                                                                
                                                                                                	Authenticated Domain Name RegEx
                                                                                                	**type**\:  :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                                
                                                                                                .. attribute:: unauth_domain
                                                                                                
                                                                                                	Unauthenticated Domain Name
                                                                                                	**type**\:  :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                                
                                                                                                .. attribute:: unauth_domain_regex
                                                                                                
                                                                                                	Unauthenticated Domain Name RegEx
                                                                                                	**type**\:  :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                                
                                                                                                .. attribute:: vendor_id
                                                                                                
                                                                                                	Vendor ID
                                                                                                	**type**\:  :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                                
                                                                                                .. attribute:: vendor_id_regex
                                                                                                
                                                                                                	Vendor ID RegEx
                                                                                                	**type**\:  :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                                
                                                                                                .. attribute:: access_interface
                                                                                                
                                                                                                	Access interface
                                                                                                	**type**\:  :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                                
                                                                                                .. attribute:: input_interface
                                                                                                
                                                                                                	Input interface
                                                                                                	**type**\:  :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                                
                                                                                                .. attribute:: input_intfhdl
                                                                                                
                                                                                                	Input interface handle
                                                                                                	**type**\:  :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                                
                                                                                                .. attribute:: ethertype
                                                                                                
                                                                                                	Ethernet type
                                                                                                	**type**\:  :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                                
                                                                                                .. attribute:: flow_key_data
                                                                                                
                                                                                                	Flow key structure
                                                                                                	**type**\:  :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                                
                                                                                                .. attribute:: dhcp_client_id
                                                                                                
                                                                                                	Dhcp Client ID
                                                                                                	**type**\:  :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                                
                                                                                                .. attribute:: dhcp_client_id_regex
                                                                                                
                                                                                                	Dhcp Client ID RegEx
                                                                                                	**type**\:  :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                                
                                                                                                .. attribute:: circuit_id
                                                                                                
                                                                                                	Circuit ID
                                                                                                	**type**\:  :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                                
                                                                                                .. attribute:: circuit_id_regex
                                                                                                
                                                                                                	Circuit ID RegEx
                                                                                                	**type**\:  :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                                
                                                                                                .. attribute:: remote_id
                                                                                                
                                                                                                	Remote ID
                                                                                                	**type**\:  :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                                
                                                                                                .. attribute:: remote_id_regex
                                                                                                
                                                                                                	Remote ID RegEx
                                                                                                	**type**\:  :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                                
                                                                                                .. attribute:: src_port
                                                                                                
                                                                                                	Source port
                                                                                                	**type**\:  :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                                
                                                                                                .. attribute:: dst_port
                                                                                                
                                                                                                	Destination port
                                                                                                	**type**\:  :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	type
                                                                                                	**type**\:  :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                                
                                                                                                .. attribute:: mpls_top_eos
                                                                                                
                                                                                                	MPLS Topmost EOS
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: fragment_type
                                                                                                
                                                                                                	Fragment type
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: authen_status
                                                                                                
                                                                                                	Authentication Status
                                                                                                	**type**\:  :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                                
                                                                                                .. attribute:: mlp_negotiated
                                                                                                
                                                                                                	MLP Negotiated
                                                                                                	**type**\:  :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                                    self.yang_name = "match-data"
                                                                                                    self.yang_parent_name = "class-match-info-st"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv4-dscp", ("ipv4_dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp)), ("ipv6-dscp", ("ipv6_dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp)), ("dscp", ("dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp)), ("ipv4-prec", ("ipv4_prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec)), ("ipv6-prec", ("ipv6_prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec)), ("prec", ("prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec)), ("discard-class", ("discard_class", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass)), ("qos-group", ("qos_group", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup)), ("traffic-class", ("traffic_class", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass)), ("proto", ("proto", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto)), ("icmp-v4", ("icmp_v4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4)), ("icmp-v6", ("icmp_v6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6)), ("ipv4-packet-len", ("ipv4_packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen)), ("ipv6-packet-len", ("ipv6_packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen)), ("packet-len", ("packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen)), ("flow-tag", ("flow_tag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag)), ("tcp-flag", ("tcp_flag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag)), ("icmpv4-type", ("icmpv4_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type)), ("icmpv4-code", ("icmpv4_code", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code)), ("icmpv6-type", ("icmpv6_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type)), ("icmpv6-code", ("icmpv6_code", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code)), ("mpls-exp", ("mpls_exp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp)), ("mpls-exp-imp", ("mpls_exp_imp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp)), ("mpls-disp-ipv4-acl", ("mpls_disp_ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl)), ("mpls-disp-ipv6-acl", ("mpls_disp_ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl)), ("mpls-top-label", ("mpls_top_label", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel)), ("cos", ("cos", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos)), ("cos-inr", ("cos_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr)), ("dei", ("dei", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei)), ("dei-inr", ("dei_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr)), ("vlan", ("vlan", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan)), ("vlan-inr", ("vlan_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)), ("fr-dlci", ("fr_dlci", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci)), ("src-mac", ("src_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac)), ("dst-mac", ("dst_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac)), ("atm-clp", ("atm_clp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp)), ("fr-de", ("fr_de", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe)), ("ipv4-acl", ("ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl)), ("ipv6-acl", ("ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl)), ("ether-service-acl", ("ether_service_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl)), ("avail-id", ("avail_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId)), ("media-type", ("media_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType)), ("subs-protocol", ("subs_protocol", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol)), ("dnis", ("dnis", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis)), ("dnis-regex", ("dnis_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex)), ("domain", ("domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain)), ("domain-regex", ("domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex)), ("nas-port", ("nas_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort)), ("service-name", ("service_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName)), ("service-name-regex", ("service_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex)), ("src-addr-ipv4", ("src_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4)), ("dst-addr-ipv4", ("dst_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4)), ("src-addr-ipv6", ("src_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6)), ("dst-addr-ipv6", ("dst_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6)), ("src-addr-mac", ("src_addr_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac)), ("timer", ("timer", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer)), ("timer-regexp", ("timer_regexp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp)), ("tunnel-name", ("tunnel_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName)), ("tunnel-name-regex", ("tunnel_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex)), ("user-name", ("user_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName)), ("user-name-regex", ("user_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex)), ("auth-username", ("auth_username", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername)), ("auth-username-regex", ("auth_username_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex)), ("unauth-username", ("unauth_username", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername)), ("unauth-username-regex", ("unauth_username_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex)), ("auth-domain", ("auth_domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain)), ("auth-domain-regex", ("auth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex)), ("unauth-domain", ("unauth_domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain)), ("unauth-domain-regex", ("unauth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex)), ("vendor-id", ("vendor_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId)), ("vendor-id-regex", ("vendor_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex)), ("access-interface", ("access_interface", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface)), ("input-interface", ("input_interface", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface)), ("input-intfhdl", ("input_intfhdl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl)), ("ethertype", ("ethertype", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype)), ("flow-key-data", ("flow_key_data", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData)), ("dhcp-client-id", ("dhcp_client_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId)), ("dhcp-client-id-regex", ("dhcp_client_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex)), ("circuit-id", ("circuit_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId)), ("circuit-id-regex", ("circuit_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex)), ("remote-id", ("remote_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId)), ("remote-id-regex", ("remote_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex)), ("src-port", ("src_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort)), ("dst-port", ("dst_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort))])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchTypeEn', '')])),
                                                                                                        ('mpls_top_eos', (YLeaf(YType.uint8, 'mpls-top-eos'), ['int'])),
                                                                                                        ('fragment_type', (YLeaf(YType.uint8, 'fragment-type'), ['int'])),
                                                                                                        ('authen_status', (YLeaf(YType.enumeration, 'authen-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchAuthenStatusEn', '')])),
                                                                                                        ('mlp_negotiated', (YLeaf(YType.enumeration, 'mlp-negotiated'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchMlpNegotiatedEn', '')])),
                                                                                                    ])
                                                                                                    self.type = None
                                                                                                    self.mpls_top_eos = None
                                                                                                    self.fragment_type = None
                                                                                                    self.authen_status = None
                                                                                                    self.mlp_negotiated = None

                                                                                                    self.ipv4_dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                                    self.ipv4_dscp.parent = self
                                                                                                    self._children_name_map["ipv4_dscp"] = "ipv4-dscp"

                                                                                                    self.ipv6_dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                                    self.ipv6_dscp.parent = self
                                                                                                    self._children_name_map["ipv6_dscp"] = "ipv6-dscp"

                                                                                                    self.dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                                    self.dscp.parent = self
                                                                                                    self._children_name_map["dscp"] = "dscp"

                                                                                                    self.ipv4_prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                                    self.ipv4_prec.parent = self
                                                                                                    self._children_name_map["ipv4_prec"] = "ipv4-prec"

                                                                                                    self.ipv6_prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                                    self.ipv6_prec.parent = self
                                                                                                    self._children_name_map["ipv6_prec"] = "ipv6-prec"

                                                                                                    self.prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                                    self.prec.parent = self
                                                                                                    self._children_name_map["prec"] = "prec"

                                                                                                    self.discard_class = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                                    self.discard_class.parent = self
                                                                                                    self._children_name_map["discard_class"] = "discard-class"

                                                                                                    self.qos_group = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                                    self.qos_group.parent = self
                                                                                                    self._children_name_map["qos_group"] = "qos-group"

                                                                                                    self.traffic_class = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                                    self.traffic_class.parent = self
                                                                                                    self._children_name_map["traffic_class"] = "traffic-class"

                                                                                                    self.proto = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                                    self.proto.parent = self
                                                                                                    self._children_name_map["proto"] = "proto"

                                                                                                    self.icmp_v4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                                    self.icmp_v4.parent = self
                                                                                                    self._children_name_map["icmp_v4"] = "icmp-v4"

                                                                                                    self.icmp_v6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                                    self.icmp_v6.parent = self
                                                                                                    self._children_name_map["icmp_v6"] = "icmp-v6"

                                                                                                    self.ipv4_packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                                    self.ipv4_packet_len.parent = self
                                                                                                    self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"

                                                                                                    self.ipv6_packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                                    self.ipv6_packet_len.parent = self
                                                                                                    self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"

                                                                                                    self.packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                                    self.packet_len.parent = self
                                                                                                    self._children_name_map["packet_len"] = "packet-len"

                                                                                                    self.flow_tag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                                    self.flow_tag.parent = self
                                                                                                    self._children_name_map["flow_tag"] = "flow-tag"

                                                                                                    self.tcp_flag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                                    self.tcp_flag.parent = self
                                                                                                    self._children_name_map["tcp_flag"] = "tcp-flag"

                                                                                                    self.icmpv4_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                                    self.icmpv4_type.parent = self
                                                                                                    self._children_name_map["icmpv4_type"] = "icmpv4-type"

                                                                                                    self.icmpv4_code = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                                    self.icmpv4_code.parent = self
                                                                                                    self._children_name_map["icmpv4_code"] = "icmpv4-code"

                                                                                                    self.icmpv6_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                                    self.icmpv6_type.parent = self
                                                                                                    self._children_name_map["icmpv6_type"] = "icmpv6-type"

                                                                                                    self.icmpv6_code = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                                    self.icmpv6_code.parent = self
                                                                                                    self._children_name_map["icmpv6_code"] = "icmpv6-code"

                                                                                                    self.mpls_exp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                                    self.mpls_exp.parent = self
                                                                                                    self._children_name_map["mpls_exp"] = "mpls-exp"

                                                                                                    self.mpls_exp_imp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                                    self.mpls_exp_imp.parent = self
                                                                                                    self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"

                                                                                                    self.mpls_disp_ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                                    self.mpls_disp_ipv4_acl.parent = self
                                                                                                    self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"

                                                                                                    self.mpls_disp_ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                                    self.mpls_disp_ipv6_acl.parent = self
                                                                                                    self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"

                                                                                                    self.mpls_top_label = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                                    self.mpls_top_label.parent = self
                                                                                                    self._children_name_map["mpls_top_label"] = "mpls-top-label"

                                                                                                    self.cos = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                                    self.cos.parent = self
                                                                                                    self._children_name_map["cos"] = "cos"

                                                                                                    self.cos_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                                    self.cos_inr.parent = self
                                                                                                    self._children_name_map["cos_inr"] = "cos-inr"

                                                                                                    self.dei = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                                    self.dei.parent = self
                                                                                                    self._children_name_map["dei"] = "dei"

                                                                                                    self.dei_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                                    self.dei_inr.parent = self
                                                                                                    self._children_name_map["dei_inr"] = "dei-inr"

                                                                                                    self.vlan = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                                    self.vlan.parent = self
                                                                                                    self._children_name_map["vlan"] = "vlan"

                                                                                                    self.vlan_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                                    self.vlan_inr.parent = self
                                                                                                    self._children_name_map["vlan_inr"] = "vlan-inr"

                                                                                                    self.fr_dlci = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                                    self.fr_dlci.parent = self
                                                                                                    self._children_name_map["fr_dlci"] = "fr-dlci"

                                                                                                    self.src_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                                    self.src_mac.parent = self
                                                                                                    self._children_name_map["src_mac"] = "src-mac"

                                                                                                    self.dst_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                                    self.dst_mac.parent = self
                                                                                                    self._children_name_map["dst_mac"] = "dst-mac"

                                                                                                    self.atm_clp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                                    self.atm_clp.parent = self
                                                                                                    self._children_name_map["atm_clp"] = "atm-clp"

                                                                                                    self.fr_de = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                                    self.fr_de.parent = self
                                                                                                    self._children_name_map["fr_de"] = "fr-de"

                                                                                                    self.ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                                    self.ipv4_acl.parent = self
                                                                                                    self._children_name_map["ipv4_acl"] = "ipv4-acl"

                                                                                                    self.ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                                    self.ipv6_acl.parent = self
                                                                                                    self._children_name_map["ipv6_acl"] = "ipv6-acl"

                                                                                                    self.ether_service_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                                    self.ether_service_acl.parent = self
                                                                                                    self._children_name_map["ether_service_acl"] = "ether-service-acl"

                                                                                                    self.avail_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                                    self.avail_id.parent = self
                                                                                                    self._children_name_map["avail_id"] = "avail-id"

                                                                                                    self.media_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                                    self.media_type.parent = self
                                                                                                    self._children_name_map["media_type"] = "media-type"

                                                                                                    self.subs_protocol = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                                    self.subs_protocol.parent = self
                                                                                                    self._children_name_map["subs_protocol"] = "subs-protocol"

                                                                                                    self.dnis = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                                    self.dnis.parent = self
                                                                                                    self._children_name_map["dnis"] = "dnis"

                                                                                                    self.dnis_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                                    self.dnis_regex.parent = self
                                                                                                    self._children_name_map["dnis_regex"] = "dnis-regex"

                                                                                                    self.domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                                    self.domain.parent = self
                                                                                                    self._children_name_map["domain"] = "domain"

                                                                                                    self.domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                                    self.domain_regex.parent = self
                                                                                                    self._children_name_map["domain_regex"] = "domain-regex"

                                                                                                    self.nas_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                                    self.nas_port.parent = self
                                                                                                    self._children_name_map["nas_port"] = "nas-port"

                                                                                                    self.service_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                                    self.service_name.parent = self
                                                                                                    self._children_name_map["service_name"] = "service-name"

                                                                                                    self.service_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                                    self.service_name_regex.parent = self
                                                                                                    self._children_name_map["service_name_regex"] = "service-name-regex"

                                                                                                    self.src_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                                    self.src_addr_ipv4.parent = self
                                                                                                    self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"

                                                                                                    self.dst_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                                    self.dst_addr_ipv4.parent = self
                                                                                                    self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"

                                                                                                    self.src_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                                    self.src_addr_ipv6.parent = self
                                                                                                    self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"

                                                                                                    self.dst_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                                    self.dst_addr_ipv6.parent = self
                                                                                                    self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"

                                                                                                    self.src_addr_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                                    self.src_addr_mac.parent = self
                                                                                                    self._children_name_map["src_addr_mac"] = "src-addr-mac"

                                                                                                    self.timer = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                                    self.timer.parent = self
                                                                                                    self._children_name_map["timer"] = "timer"

                                                                                                    self.timer_regexp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                                    self.timer_regexp.parent = self
                                                                                                    self._children_name_map["timer_regexp"] = "timer-regexp"

                                                                                                    self.tunnel_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                                    self.tunnel_name.parent = self
                                                                                                    self._children_name_map["tunnel_name"] = "tunnel-name"

                                                                                                    self.tunnel_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                                    self.tunnel_name_regex.parent = self
                                                                                                    self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"

                                                                                                    self.user_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                                    self.user_name.parent = self
                                                                                                    self._children_name_map["user_name"] = "user-name"

                                                                                                    self.user_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                                    self.user_name_regex.parent = self
                                                                                                    self._children_name_map["user_name_regex"] = "user-name-regex"

                                                                                                    self.auth_username = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                                    self.auth_username.parent = self
                                                                                                    self._children_name_map["auth_username"] = "auth-username"

                                                                                                    self.auth_username_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                                    self.auth_username_regex.parent = self
                                                                                                    self._children_name_map["auth_username_regex"] = "auth-username-regex"

                                                                                                    self.unauth_username = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                                    self.unauth_username.parent = self
                                                                                                    self._children_name_map["unauth_username"] = "unauth-username"

                                                                                                    self.unauth_username_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                                    self.unauth_username_regex.parent = self
                                                                                                    self._children_name_map["unauth_username_regex"] = "unauth-username-regex"

                                                                                                    self.auth_domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                                    self.auth_domain.parent = self
                                                                                                    self._children_name_map["auth_domain"] = "auth-domain"

                                                                                                    self.auth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                                    self.auth_domain_regex.parent = self
                                                                                                    self._children_name_map["auth_domain_regex"] = "auth-domain-regex"

                                                                                                    self.unauth_domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                                    self.unauth_domain.parent = self
                                                                                                    self._children_name_map["unauth_domain"] = "unauth-domain"

                                                                                                    self.unauth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                                    self.unauth_domain_regex.parent = self
                                                                                                    self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"

                                                                                                    self.vendor_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                                    self.vendor_id.parent = self
                                                                                                    self._children_name_map["vendor_id"] = "vendor-id"

                                                                                                    self.vendor_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                                    self.vendor_id_regex.parent = self
                                                                                                    self._children_name_map["vendor_id_regex"] = "vendor-id-regex"

                                                                                                    self.access_interface = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                                    self.access_interface.parent = self
                                                                                                    self._children_name_map["access_interface"] = "access-interface"

                                                                                                    self.input_interface = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                                    self.input_interface.parent = self
                                                                                                    self._children_name_map["input_interface"] = "input-interface"

                                                                                                    self.input_intfhdl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                                    self.input_intfhdl.parent = self
                                                                                                    self._children_name_map["input_intfhdl"] = "input-intfhdl"

                                                                                                    self.ethertype = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                                    self.ethertype.parent = self
                                                                                                    self._children_name_map["ethertype"] = "ethertype"

                                                                                                    self.flow_key_data = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                                    self.flow_key_data.parent = self
                                                                                                    self._children_name_map["flow_key_data"] = "flow-key-data"

                                                                                                    self.dhcp_client_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                                    self.dhcp_client_id.parent = self
                                                                                                    self._children_name_map["dhcp_client_id"] = "dhcp-client-id"

                                                                                                    self.dhcp_client_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                                    self.dhcp_client_id_regex.parent = self
                                                                                                    self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"

                                                                                                    self.circuit_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                                    self.circuit_id.parent = self
                                                                                                    self._children_name_map["circuit_id"] = "circuit-id"

                                                                                                    self.circuit_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                                    self.circuit_id_regex.parent = self
                                                                                                    self._children_name_map["circuit_id_regex"] = "circuit-id-regex"

                                                                                                    self.remote_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                                    self.remote_id.parent = self
                                                                                                    self._children_name_map["remote_id"] = "remote-id"

                                                                                                    self.remote_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                                    self.remote_id_regex.parent = self
                                                                                                    self._children_name_map["remote_id_regex"] = "remote-id-regex"

                                                                                                    self.src_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                                    self.src_port.parent = self
                                                                                                    self._children_name_map["src_port"] = "src-port"

                                                                                                    self.dst_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                                    self.dst_port.parent = self
                                                                                                    self._children_name_map["dst_port"] = "dst-port"
                                                                                                    self._segment_path = lambda: "match-data"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, ['type', 'mpls_top_eos', 'fragment_type', 'authen_status', 'mlp_negotiated'], name, value)


                                                                                                class Ipv4Dscp(Entity):
                                                                                                    """
                                                                                                    IPv4 DSCP
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                        self.yang_name = "ipv4-dscp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ipv4-dscp"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "ipv4-dscp"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                                class Ipv6Dscp(Entity):
                                                                                                    """
                                                                                                    IPv6 DSCP
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                        self.yang_name = "ipv6-dscp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ipv6-dscp"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "ipv6-dscp"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                                class Dscp(Entity):
                                                                                                    """
                                                                                                    Match DSCP range array
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                        self.yang_name = "dscp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "dscp"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "dscp"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                                class Ipv4Prec(Entity):
                                                                                                    """
                                                                                                    IPv4 Precedence
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                        self.yang_name = "ipv4-prec"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "ipv4-prec"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                                class Ipv6Prec(Entity):
                                                                                                    """
                                                                                                    IPv6 Precedence
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                        self.yang_name = "ipv6-prec"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "ipv6-prec"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                                class Prec(Entity):
                                                                                                    """
                                                                                                    Match Precedence array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                        self.yang_name = "prec"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "prec"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                                class DiscardClass(Entity):
                                                                                                    """
                                                                                                    Match Discard Class array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                        self.yang_name = "discard-class"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "discard-class"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                                class QosGroup(Entity):
                                                                                                    """
                                                                                                    Match QoS group array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                        self.yang_name = "qos-group"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "qos-group"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "qos-group"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['min', 'max'], name, value)


                                                                                                class TrafficClass(Entity):
                                                                                                    """
                                                                                                    Match Traffic class array
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                        self.yang_name = "traffic-class"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "traffic-class"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "traffic-class"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['min', 'max'], name, value)


                                                                                                class Proto(Entity):
                                                                                                    """
                                                                                                    Match Protocol array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                        self.yang_name = "proto"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "proto"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "proto"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['min', 'max'], name, value)


                                                                                                class IcmpV4(Entity):
                                                                                                    """
                                                                                                    Match ICMPV4 Protocol
                                                                                                    
                                                                                                    .. attribute:: type
                                                                                                    
                                                                                                    	Protocol type
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: code
                                                                                                    
                                                                                                    	Protocol code
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                        self.yang_name = "icmp-v4"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                            ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                        ])
                                                                                                        self.type = None
                                                                                                        self.code = None
                                                                                                        self._segment_path = lambda: "icmp-v4"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['type', 'code'], name, value)


                                                                                                class IcmpV6(Entity):
                                                                                                    """
                                                                                                    Match ICMPV6 Protocol array
                                                                                                    
                                                                                                    .. attribute:: type
                                                                                                    
                                                                                                    	Protocol type
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: code
                                                                                                    
                                                                                                    	Protocol code
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                        self.yang_name = "icmp-v6"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                            ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                        ])
                                                                                                        self.type = None
                                                                                                        self.code = None
                                                                                                        self._segment_path = lambda: "icmp-v6"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['type', 'code'], name, value)


                                                                                                class Ipv4PacketLen(Entity):
                                                                                                    """
                                                                                                    IPv4 packet length array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                        self.yang_name = "ipv4-packet-len"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ipv4-packet-len"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "ipv4-packet-len"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                                class Ipv6PacketLen(Entity):
                                                                                                    """
                                                                                                    IPv6 packet length array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                        self.yang_name = "ipv6-packet-len"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ipv6-packet-len"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "ipv6-packet-len"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                                class PacketLen(Entity):
                                                                                                    """
                                                                                                    Match packet length array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                        self.yang_name = "packet-len"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "packet-len"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "packet-len"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                                class FlowTag(Entity):
                                                                                                    """
                                                                                                    Match flow\-tag array
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                        self.yang_name = "flow-tag"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "flow-tag"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "flow-tag"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['min', 'max'], name, value)


                                                                                                class TcpFlag(Entity):
                                                                                                    """
                                                                                                    Match tcp flag value
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	Value of TCP flag
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: match_any
                                                                                                    
                                                                                                    	Match any TCP flag bit
                                                                                                    	**type**\: bool
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                        self.yang_name = "tcp-flag"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                                            ('match_any', (YLeaf(YType.boolean, 'match-any'), ['bool'])),
                                                                                                        ])
                                                                                                        self.value = None
                                                                                                        self.match_any = None
                                                                                                        self._segment_path = lambda: "tcp-flag"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['value', 'match_any'], name, value)


                                                                                                class Icmpv4Type(Entity):
                                                                                                    """
                                                                                                    Match ipv4 icmp type
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                        self.yang_name = "icmpv4-type"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "icmpv4-type"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "icmpv4-type"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                                class Icmpv4Code(Entity):
                                                                                                    """
                                                                                                    Match ipv4 icmp code
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                        self.yang_name = "icmpv4-code"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "icmpv4-code"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "icmpv4-code"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                                class Icmpv6Type(Entity):
                                                                                                    """
                                                                                                    Match ipv6 icmp type
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                        self.yang_name = "icmpv6-type"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "icmpv6-type"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "icmpv6-type"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                                class Icmpv6Code(Entity):
                                                                                                    """
                                                                                                    Match ipv6 icmp code
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                        self.yang_name = "icmpv6-code"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "icmpv6-code"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "icmpv6-code"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                                class MplsExp(Entity):
                                                                                                    """
                                                                                                    Match MPLS experimental topmost array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                        self.yang_name = "mpls-exp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "mpls-exp"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                                class MplsExpImp(Entity):
                                                                                                    """
                                                                                                    Match MPLS experimental imposition array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                        self.yang_name = "mpls-exp-imp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "mpls-exp-imp"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                                class MplsDispIpv4Acl(Entity):
                                                                                                    """
                                                                                                    MPLS Disposition IPv4 Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                        self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "mpls-disp-ipv4-acl"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                                class MplsDispIpv6Acl(Entity):
                                                                                                    """
                                                                                                    MPLS Disposition IPv6 Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                        self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "mpls-disp-ipv6-acl"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                                class MplsTopLabel(Entity):
                                                                                                    """
                                                                                                    MPLS Topmost LABEL
                                                                                                    
                                                                                                    .. attribute:: uint32_rng_array
                                                                                                    
                                                                                                    	uint32 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                        self.yang_name = "mpls-top-label"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint32_rng_array", ("uint32_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint32_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "mpls-top-label"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                                    class Uint32RngArray(Entity):
                                                                                                        """
                                                                                                        uint32 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                            self.yang_name = "uint32_rng_array"
                                                                                                            self.yang_parent_name = "mpls-top-label"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint32, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint32, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint32_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['min', 'max'], name, value)


                                                                                                class Cos(Entity):
                                                                                                    """
                                                                                                    Match CoS array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                        self.yang_name = "cos"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "cos"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                                class CosInr(Entity):
                                                                                                    """
                                                                                                    Match inner header CoS
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                        self.yang_name = "cos-inr"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "cos-inr"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                                class Dei(Entity):
                                                                                                    """
                                                                                                    Match DEI Bit
                                                                                                    
                                                                                                    .. attribute:: bit_value
                                                                                                    
                                                                                                    	Value of the DEI bit
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                        self.yang_name = "dei"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                        ])
                                                                                                        self.bit_value = None
                                                                                                        self._segment_path = lambda: "dei"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                                class DeiInr(Entity):
                                                                                                    """
                                                                                                    Match inner DEI Bit
                                                                                                    
                                                                                                    .. attribute:: bit_value
                                                                                                    
                                                                                                    	Value of the DEI bit
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                        self.yang_name = "dei-inr"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                        ])
                                                                                                        self.bit_value = None
                                                                                                        self._segment_path = lambda: "dei-inr"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                                class Vlan(Entity):
                                                                                                    """
                                                                                                    Match VLAN array
                                                                                                    
                                                                                                    .. attribute:: vlan_id_array
                                                                                                    
                                                                                                    	vlan id array
                                                                                                    	**type**\: list of  		 :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                        self.yang_name = "vlan"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("vlan-id-array", ("vlan_id_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.vlan_id_array = YList(self)
                                                                                                        self._segment_path = lambda: "vlan"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                                    class VlanIdArray(Entity):
                                                                                                        """
                                                                                                        vlan id array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	VLAN mask
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                            self.yang_name = "vlan-id-array"
                                                                                                            self.yang_parent_name = "vlan"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                                ('mask', (YLeaf(YType.uint16, 'mask'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self.mask = None
                                                                                                            self._segment_path = lambda: "vlan-id-array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['min', 'max', 'mask'], name, value)


                                                                                                class VlanInr(Entity):
                                                                                                    """
                                                                                                    Match inner header VLAN range array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                        self.yang_name = "vlan-inr"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "vlan-inr"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "vlan-inr"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['min', 'max'], name, value)


                                                                                                class FrDlci(Entity):
                                                                                                    """
                                                                                                    Match FR DLCI range array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                        self.yang_name = "fr-dlci"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "fr-dlci"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "fr-dlci"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['min', 'max'], name, value)


                                                                                                class SrcMac(Entity):
                                                                                                    """
                                                                                                    Match Source MAC address
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                        self.yang_name = "src-mac"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                            ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.mac_addr = []
                                                                                                        self.mask = []
                                                                                                        self._segment_path = lambda: "src-mac"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                                class DstMac(Entity):
                                                                                                    """
                                                                                                    Match Destination MAC address
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                        self.yang_name = "dst-mac"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                            ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.mac_addr = []
                                                                                                        self.mask = []
                                                                                                        self._segment_path = lambda: "dst-mac"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                                class AtmClp(Entity):
                                                                                                    """
                                                                                                    Match ATM CLP level
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                        self.yang_name = "atm-clp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "atm-clp"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                                class FrDe(Entity):
                                                                                                    """
                                                                                                    Match FR DE value
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                        self.yang_name = "fr-de"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "fr-de"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                                class Ipv4Acl(Entity):
                                                                                                    """
                                                                                                    IPv4 Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                        self.yang_name = "ipv4-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "ipv4-acl"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                                class Ipv6Acl(Entity):
                                                                                                    """
                                                                                                    IPv6 Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                        self.yang_name = "ipv6-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "ipv6-acl"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                                class EtherServiceAcl(Entity):
                                                                                                    """
                                                                                                    Ethernet\-Services Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                        self.yang_name = "ether-service-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "ether-service-acl"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                                class AvailId(Entity):
                                                                                                    """
                                                                                                    Available Identifiers
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                        self.yang_name = "avail-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "avail-id"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                                class MediaType(Entity):
                                                                                                    """
                                                                                                    Media Type
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                        self.yang_name = "media-type"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "media-type"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                                class SubsProtocol(Entity):
                                                                                                    """
                                                                                                    Protocol
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                        self.yang_name = "subs-protocol"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "subs-protocol"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                                class Dnis(Entity):
                                                                                                    """
                                                                                                    DNIS
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                        self.yang_name = "dnis"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "dnis"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                                class DnisRegex(Entity):
                                                                                                    """
                                                                                                    DNIS Regular Expression
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                        self.yang_name = "dnis-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "dnis-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                                class Domain(Entity):
                                                                                                    """
                                                                                                    Domain Name
                                                                                                    
                                                                                                    .. attribute:: domain_array
                                                                                                    
                                                                                                    	domain array
                                                                                                    	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                        self.yang_name = "domain"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.domain_array = YList(self)
                                                                                                        self._segment_path = lambda: "domain"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                                    class DomainArray(Entity):
                                                                                                        """
                                                                                                        domain array
                                                                                                        
                                                                                                        .. attribute:: domain_name
                                                                                                        
                                                                                                        	domain name
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        .. attribute:: format_name
                                                                                                        
                                                                                                        	format name
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                            self.yang_name = "domain-array"
                                                                                                            self.yang_parent_name = "domain"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                                ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                            ])
                                                                                                            self.domain_name = None
                                                                                                            self.format_name = None
                                                                                                            self._segment_path = lambda: "domain-array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                                class DomainRegex(Entity):
                                                                                                    """
                                                                                                    Domain Regular Expression
                                                                                                    
                                                                                                    .. attribute:: domain_array
                                                                                                    
                                                                                                    	domain array
                                                                                                    	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                        self.yang_name = "domain-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.domain_array = YList(self)
                                                                                                        self._segment_path = lambda: "domain-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                                    class DomainArray(Entity):
                                                                                                        """
                                                                                                        domain array
                                                                                                        
                                                                                                        .. attribute:: domain_name
                                                                                                        
                                                                                                        	domain name
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        .. attribute:: format_name
                                                                                                        
                                                                                                        	format name
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                            self.yang_name = "domain-array"
                                                                                                            self.yang_parent_name = "domain-regex"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                                ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                            ])
                                                                                                            self.domain_name = None
                                                                                                            self.format_name = None
                                                                                                            self._segment_path = lambda: "domain-array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                                class NasPort(Entity):
                                                                                                    """
                                                                                                    NAS Port
                                                                                                    
                                                                                                    .. attribute:: nas_port_array
                                                                                                    
                                                                                                    	nas port array
                                                                                                    	**type**\: list of  		 :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                        self.yang_name = "nas-port"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("nas-port-array", ("nas_port_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.nas_port_array = YList(self)
                                                                                                        self._segment_path = lambda: "nas-port"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                                    class NasPortArray(Entity):
                                                                                                        """
                                                                                                        nas port array
                                                                                                        
                                                                                                        .. attribute:: sub_id
                                                                                                        
                                                                                                        	sub id
                                                                                                        	**type**\:  :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                        
                                                                                                        .. attribute:: operator
                                                                                                        
                                                                                                        	operator
                                                                                                        	**type**\:  :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                        
                                                                                                        .. attribute:: value
                                                                                                        
                                                                                                        	value
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                            self.yang_name = "nas-port-array"
                                                                                                            self.yang_parent_name = "nas-port"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('sub_id', (YLeaf(YType.enumeration, 'sub-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchNasPortSubIdEn', '')])),
                                                                                                                ('operator', (YLeaf(YType.enumeration, 'operator'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchLogicalOperatorEn', '')])),
                                                                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                                            ])
                                                                                                            self.sub_id = None
                                                                                                            self.operator = None
                                                                                                            self.value = None
                                                                                                            self._segment_path = lambda: "nas-port-array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['sub_id', 'operator', 'value'], name, value)


                                                                                                class ServiceName(Entity):
                                                                                                    """
                                                                                                    Service Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                        self.yang_name = "service-name"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "service-name"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                                class ServiceNameRegex(Entity):
                                                                                                    """
                                                                                                    Service Name Regular Exp
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                        self.yang_name = "service-name-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "service-name-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                                class SrcAddrIpv4(Entity):
                                                                                                    """
                                                                                                    Source Address IPV4
                                                                                                    
                                                                                                    .. attribute:: ipv4_addr_array
                                                                                                    
                                                                                                    	ipv4 addr array
                                                                                                    	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                        self.yang_name = "src-addr-ipv4"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.ipv4_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "src-addr-ipv4"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                                    class Ipv4AddrArray(Entity):
                                                                                                        """
                                                                                                        ipv4 addr array
                                                                                                        
                                                                                                        .. attribute:: prefix
                                                                                                        
                                                                                                        	prefix
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	mask
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                            self.yang_name = "ipv4-addr-array"
                                                                                                            self.yang_parent_name = "src-addr-ipv4"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                                ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                            ])
                                                                                                            self.prefix = None
                                                                                                            self.mask = None
                                                                                                            self._segment_path = lambda: "ipv4-addr-array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                                class DstAddrIpv4(Entity):
                                                                                                    """
                                                                                                    Destination Address IPV4
                                                                                                    
                                                                                                    .. attribute:: ipv4_addr_array
                                                                                                    
                                                                                                    	ipv4 addr array
                                                                                                    	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                        self.yang_name = "dst-addr-ipv4"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.ipv4_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "dst-addr-ipv4"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                                    class Ipv4AddrArray(Entity):
                                                                                                        """
                                                                                                        ipv4 addr array
                                                                                                        
                                                                                                        .. attribute:: prefix
                                                                                                        
                                                                                                        	prefix
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	mask
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                            self.yang_name = "ipv4-addr-array"
                                                                                                            self.yang_parent_name = "dst-addr-ipv4"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                                ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                            ])
                                                                                                            self.prefix = None
                                                                                                            self.mask = None
                                                                                                            self._segment_path = lambda: "ipv4-addr-array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                                class SrcAddrIpv6(Entity):
                                                                                                    """
                                                                                                    Source Address IPV6
                                                                                                    
                                                                                                    .. attribute:: ipv6_addr_array
                                                                                                    
                                                                                                    	ipv6 addr array
                                                                                                    	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                        self.yang_name = "src-addr-ipv6"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.ipv6_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "src-addr-ipv6"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                                    class Ipv6AddrArray(Entity):
                                                                                                        """
                                                                                                        ipv6 addr array
                                                                                                        
                                                                                                        .. attribute:: prefix
                                                                                                        
                                                                                                        	IPV6 prefix
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	IPV6 mask
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                            self.yang_name = "ipv6-addr-array"
                                                                                                            self.yang_parent_name = "src-addr-ipv6"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                                ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                            ])
                                                                                                            self.prefix = None
                                                                                                            self.mask = None
                                                                                                            self._segment_path = lambda: "ipv6-addr-array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                                class DstAddrIpv6(Entity):
                                                                                                    """
                                                                                                    Destination Address IPV6
                                                                                                    
                                                                                                    .. attribute:: ipv6_addr_array
                                                                                                    
                                                                                                    	ipv6 addr array
                                                                                                    	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                        self.yang_name = "dst-addr-ipv6"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.ipv6_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "dst-addr-ipv6"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                                    class Ipv6AddrArray(Entity):
                                                                                                        """
                                                                                                        ipv6 addr array
                                                                                                        
                                                                                                        .. attribute:: prefix
                                                                                                        
                                                                                                        	IPV6 prefix
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	IPV6 mask
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                            self.yang_name = "ipv6-addr-array"
                                                                                                            self.yang_parent_name = "dst-addr-ipv6"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                                ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                            ])
                                                                                                            self.prefix = None
                                                                                                            self.mask = None
                                                                                                            self._segment_path = lambda: "ipv6-addr-array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                                class SrcAddrMac(Entity):
                                                                                                    """
                                                                                                    Source Address MAC
                                                                                                    
                                                                                                    .. attribute:: mac_addr_array
                                                                                                    
                                                                                                    	mac addr array
                                                                                                    	**type**\: list of  		 :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                        self.yang_name = "src-addr-mac"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("mac-addr-array", ("mac_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.mac_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "src-addr-mac"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                                    class MacAddrArray(Entity):
                                                                                                        """
                                                                                                        mac addr array
                                                                                                        
                                                                                                        .. attribute:: mac_addr
                                                                                                        
                                                                                                        	MAC address
                                                                                                        	**type**\: list of int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	MAC mask
                                                                                                        	**type**\: list of int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                            self.yang_name = "mac-addr-array"
                                                                                                            self.yang_parent_name = "src-addr-mac"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                                ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                            ])
                                                                                                            self.mac_addr = []
                                                                                                            self.mask = []
                                                                                                            self._segment_path = lambda: "mac-addr-array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                                class Timer(Entity):
                                                                                                    """
                                                                                                    Timer
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                        self.yang_name = "timer"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "timer"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                                class TimerRegexp(Entity):
                                                                                                    """
                                                                                                    Timer Regular Expression
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                        self.yang_name = "timer-regexp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "timer-regexp"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                                class TunnelName(Entity):
                                                                                                    """
                                                                                                    Tunnel Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                        self.yang_name = "tunnel-name"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "tunnel-name"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                                class TunnelNameRegex(Entity):
                                                                                                    """
                                                                                                    Tunnel Name Regular Expression
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                        self.yang_name = "tunnel-name-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "tunnel-name-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                                class UserName(Entity):
                                                                                                    """
                                                                                                    User Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                        self.yang_name = "user-name"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "user-name"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                                class UserNameRegex(Entity):
                                                                                                    """
                                                                                                    User Name Regular Expression
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                        self.yang_name = "user-name-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "user-name-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                                class AuthUsername(Entity):
                                                                                                    """
                                                                                                    Authenticated User Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                        self.yang_name = "auth-username"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "auth-username"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                                class AuthUsernameRegex(Entity):
                                                                                                    """
                                                                                                    Authenticated User Name RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                        self.yang_name = "auth-username-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "auth-username-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                                class UnauthUsername(Entity):
                                                                                                    """
                                                                                                    Unauthenticated User Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                        self.yang_name = "unauth-username"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "unauth-username"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                                class UnauthUsernameRegex(Entity):
                                                                                                    """
                                                                                                    Unauthenticated User Name RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                        self.yang_name = "unauth-username-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "unauth-username-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                                class AuthDomain(Entity):
                                                                                                    """
                                                                                                    Authenticated domain name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                        self.yang_name = "auth-domain"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "auth-domain"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                                class AuthDomainRegex(Entity):
                                                                                                    """
                                                                                                    Authenticated Domain Name RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                        self.yang_name = "auth-domain-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "auth-domain-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                                class UnauthDomain(Entity):
                                                                                                    """
                                                                                                    Unauthenticated Domain Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                        self.yang_name = "unauth-domain"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "unauth-domain"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                                class UnauthDomainRegex(Entity):
                                                                                                    """
                                                                                                    Unauthenticated Domain Name RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                        self.yang_name = "unauth-domain-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "unauth-domain-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                                class VendorId(Entity):
                                                                                                    """
                                                                                                    Vendor ID
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                        self.yang_name = "vendor-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "vendor-id"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                                class VendorIdRegex(Entity):
                                                                                                    """
                                                                                                    Vendor ID RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                        self.yang_name = "vendor-id-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "vendor-id-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                                class AccessInterface(Entity):
                                                                                                    """
                                                                                                    Access interface
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                        self.yang_name = "access-interface"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "access-interface"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                                class InputInterface(Entity):
                                                                                                    """
                                                                                                    Input interface
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                        self.yang_name = "input-interface"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "input-interface"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                                class InputIntfhdl(Entity):
                                                                                                    """
                                                                                                    Input interface handle
                                                                                                    
                                                                                                    .. attribute:: uint64_array
                                                                                                    
                                                                                                    	uint64 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..18446744073709551615
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                        self.yang_name = "input-intfhdl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint64_array', (YLeafList(YType.uint64, 'uint64_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint64_array = []
                                                                                                        self._segment_path = lambda: "input-intfhdl"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                                class Ethertype(Entity):
                                                                                                    """
                                                                                                    Ethernet type
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                        self.yang_name = "ethertype"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ethertype"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "ethertype"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['min', 'max'], name, value)


                                                                                                class FlowKeyData(Entity):
                                                                                                    """
                                                                                                    Flow key structure
                                                                                                    
                                                                                                    .. attribute:: flow_keys
                                                                                                    
                                                                                                    	flow keys
                                                                                                    	**type**\:  :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                                    
                                                                                                    .. attribute:: max_count
                                                                                                    
                                                                                                    	Maximum count of flows
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: idle_timeout
                                                                                                    
                                                                                                    	Idle timeout of flows (in seconds)
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    	**units**\: second
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                        self.yang_name = "flow-key-data"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("flow-keys", ("flow_keys", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys))])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('max_count', (YLeaf(YType.uint16, 'max-count'), ['int'])),
                                                                                                            ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                                                        ])
                                                                                                        self.max_count = None
                                                                                                        self.idle_timeout = None

                                                                                                        self.flow_keys = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                        self.flow_keys.parent = self
                                                                                                        self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                        self._segment_path = lambda: "flow-key-data"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['max_count', 'idle_timeout'], name, value)


                                                                                                    class FlowKeys(Entity):
                                                                                                        """
                                                                                                        flow keys
                                                                                                        
                                                                                                        .. attribute:: keys
                                                                                                        
                                                                                                        	keys
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                        
                                                                                                        .. attribute:: num
                                                                                                        
                                                                                                        	num
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                            self.yang_name = "flow-keys"
                                                                                                            self.yang_parent_name = "flow-key-data"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('keys', (YLeaf(YType.str, 'keys'), ['str'])),
                                                                                                                ('num', (YLeaf(YType.uint8, 'num'), ['int'])),
                                                                                                            ])
                                                                                                            self.keys = None
                                                                                                            self.num = None
                                                                                                            self._segment_path = lambda: "flow-keys"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                                class DhcpClientId(Entity):
                                                                                                    """
                                                                                                    Dhcp Client ID
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                        self.yang_name = "dhcp-client-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "dhcp-client-id"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                                class DhcpClientIdRegex(Entity):
                                                                                                    """
                                                                                                    Dhcp Client ID RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                        self.yang_name = "dhcp-client-id-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "dhcp-client-id-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                                class CircuitId(Entity):
                                                                                                    """
                                                                                                    Circuit ID
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                        self.yang_name = "circuit-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "circuit-id"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                                class CircuitIdRegex(Entity):
                                                                                                    """
                                                                                                    Circuit ID RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                        self.yang_name = "circuit-id-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "circuit-id-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                                class RemoteId(Entity):
                                                                                                    """
                                                                                                    Remote ID
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                        self.yang_name = "remote-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "remote-id"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                                class RemoteIdRegex(Entity):
                                                                                                    """
                                                                                                    Remote ID RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                        self.yang_name = "remote-id-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "remote-id-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                                class SrcPort(Entity):
                                                                                                    """
                                                                                                    Source port
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                        self.yang_name = "src-port"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "src-port"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "src-port"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                                                class DstPort(Entity):
                                                                                                    """
                                                                                                    Destination port
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                        self.yang_name = "dst-port"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "dst-port"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "dst-port"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class ExcdclassP(Entity):
                                                                                """
                                                                                excdclass p
                                                                                
                                                                                .. attribute:: class_map_bg
                                                                                
                                                                                	class map bg
                                                                                	**type**\: list of  		 :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP, self).__init__()

                                                                                    self.yang_name = "excdclass-p"
                                                                                    self.yang_parent_name = "police"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("class-map-bg", ("class_map_bg", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.class_map_bg = YList(self)
                                                                                    self._segment_path = lambda: "excdclass-p"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP, [], name, value)


                                                                                class ClassMapBg(Entity):
                                                                                    """
                                                                                    class map bg
                                                                                    
                                                                                    .. attribute:: match_infop
                                                                                    
                                                                                    	Pointer to the first Match info
                                                                                    	**type**\:  :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop>`
                                                                                    
                                                                                    .. attribute:: name
                                                                                    
                                                                                    	Name of the class\-map
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**length:** 0..65
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	Class\-Map Type QoS/PBR/Netflow/..
                                                                                    	**type**\:  :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                                                    
                                                                                    .. attribute:: mode
                                                                                    
                                                                                    	Class\-Map Mode Match any/Match all
                                                                                    	**type**\:  :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                                    
                                                                                    .. attribute:: description
                                                                                    
                                                                                    	description
                                                                                    	**type**\: str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg, self).__init__()

                                                                                        self.yang_name = "class-map-bg"
                                                                                        self.yang_parent_name = "excdclass-p"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("match-infop", ("match_infop", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop))])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapTypeEn', '')])),
                                                                                            ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapModeEn', '')])),
                                                                                            ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                        ])
                                                                                        self.name = None
                                                                                        self.type = None
                                                                                        self.mode = None
                                                                                        self.description = None

                                                                                        self.match_infop = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop()
                                                                                        self.match_infop.parent = self
                                                                                        self._children_name_map["match_infop"] = "match-infop"
                                                                                        self._segment_path = lambda: "class-map-bg"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg, ['name', 'type', 'mode', 'description'], name, value)


                                                                                    class MatchInfop(Entity):
                                                                                        """
                                                                                        Pointer to the first Match info
                                                                                        
                                                                                        .. attribute:: class_match_info_st
                                                                                        
                                                                                        	class match info st
                                                                                        	**type**\: list of  		 :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop, self).__init__()

                                                                                            self.yang_name = "match-infop"
                                                                                            self.yang_parent_name = "class-map-bg"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("class-match-info-st", ("class_match_info_st", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt))])
                                                                                            self._leafs = OrderedDict()

                                                                                            self.class_match_info_st = YList(self)
                                                                                            self._segment_path = lambda: "match-infop"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop, [], name, value)


                                                                                        class ClassMatchInfoSt(Entity):
                                                                                            """
                                                                                            class match info st
                                                                                            
                                                                                            .. attribute:: match_data
                                                                                            
                                                                                            	Match criteria
                                                                                            	**type**\:  :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                            
                                                                                            .. attribute:: flags
                                                                                            
                                                                                            	Flags
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                                self.yang_name = "class-match-info-st"
                                                                                                self.yang_parent_name = "match-infop"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("match-data", ("match_data", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData))])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                                ])
                                                                                                self.flags = None

                                                                                                self.match_data = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                                self.match_data.parent = self
                                                                                                self._children_name_map["match_data"] = "match-data"
                                                                                                self._segment_path = lambda: "class-match-info-st"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                            class MatchData(Entity):
                                                                                                """
                                                                                                Match criteria
                                                                                                
                                                                                                .. attribute:: ipv4_dscp
                                                                                                
                                                                                                	IPv4 DSCP
                                                                                                	**type**\:  :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                                
                                                                                                .. attribute:: ipv6_dscp
                                                                                                
                                                                                                	IPv6 DSCP
                                                                                                	**type**\:  :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                                
                                                                                                .. attribute:: dscp
                                                                                                
                                                                                                	Match DSCP range array
                                                                                                	**type**\:  :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                                
                                                                                                .. attribute:: ipv4_prec
                                                                                                
                                                                                                	IPv4 Precedence
                                                                                                	**type**\:  :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                                
                                                                                                .. attribute:: ipv6_prec
                                                                                                
                                                                                                	IPv6 Precedence
                                                                                                	**type**\:  :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                                
                                                                                                .. attribute:: prec
                                                                                                
                                                                                                	Match Precedence array
                                                                                                	**type**\:  :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                                
                                                                                                .. attribute:: discard_class
                                                                                                
                                                                                                	Match Discard Class array
                                                                                                	**type**\:  :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                                
                                                                                                .. attribute:: qos_group
                                                                                                
                                                                                                	Match QoS group array
                                                                                                	**type**\:  :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                                
                                                                                                .. attribute:: traffic_class
                                                                                                
                                                                                                	Match Traffic class array
                                                                                                	**type**\:  :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                                
                                                                                                .. attribute:: proto
                                                                                                
                                                                                                	Match Protocol array
                                                                                                	**type**\:  :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                                
                                                                                                .. attribute:: icmp_v4
                                                                                                
                                                                                                	Match ICMPV4 Protocol
                                                                                                	**type**\:  :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                                
                                                                                                .. attribute:: icmp_v6
                                                                                                
                                                                                                	Match ICMPV6 Protocol array
                                                                                                	**type**\:  :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                                
                                                                                                .. attribute:: ipv4_packet_len
                                                                                                
                                                                                                	IPv4 packet length array
                                                                                                	**type**\:  :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                                
                                                                                                .. attribute:: ipv6_packet_len
                                                                                                
                                                                                                	IPv6 packet length array
                                                                                                	**type**\:  :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                                
                                                                                                .. attribute:: packet_len
                                                                                                
                                                                                                	Match packet length array
                                                                                                	**type**\:  :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                                
                                                                                                .. attribute:: flow_tag
                                                                                                
                                                                                                	Match flow\-tag array
                                                                                                	**type**\:  :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                                
                                                                                                .. attribute:: tcp_flag
                                                                                                
                                                                                                	Match tcp flag value
                                                                                                	**type**\:  :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                                
                                                                                                .. attribute:: icmpv4_type
                                                                                                
                                                                                                	Match ipv4 icmp type
                                                                                                	**type**\:  :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                                
                                                                                                .. attribute:: icmpv4_code
                                                                                                
                                                                                                	Match ipv4 icmp code
                                                                                                	**type**\:  :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                                
                                                                                                .. attribute:: icmpv6_type
                                                                                                
                                                                                                	Match ipv6 icmp type
                                                                                                	**type**\:  :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                                
                                                                                                .. attribute:: icmpv6_code
                                                                                                
                                                                                                	Match ipv6 icmp code
                                                                                                	**type**\:  :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                                
                                                                                                .. attribute:: mpls_exp
                                                                                                
                                                                                                	Match MPLS experimental topmost array
                                                                                                	**type**\:  :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                                
                                                                                                .. attribute:: mpls_exp_imp
                                                                                                
                                                                                                	Match MPLS experimental imposition array
                                                                                                	**type**\:  :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                                
                                                                                                .. attribute:: mpls_disp_ipv4_acl
                                                                                                
                                                                                                	MPLS Disposition IPv4 Access\-list
                                                                                                	**type**\:  :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                                
                                                                                                .. attribute:: mpls_disp_ipv6_acl
                                                                                                
                                                                                                	MPLS Disposition IPv6 Access\-list
                                                                                                	**type**\:  :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                                
                                                                                                .. attribute:: mpls_top_label
                                                                                                
                                                                                                	MPLS Topmost LABEL
                                                                                                	**type**\:  :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                                
                                                                                                .. attribute:: cos
                                                                                                
                                                                                                	Match CoS array
                                                                                                	**type**\:  :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                                
                                                                                                .. attribute:: cos_inr
                                                                                                
                                                                                                	Match inner header CoS
                                                                                                	**type**\:  :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                                
                                                                                                .. attribute:: dei
                                                                                                
                                                                                                	Match DEI Bit
                                                                                                	**type**\:  :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                                
                                                                                                .. attribute:: dei_inr
                                                                                                
                                                                                                	Match inner DEI Bit
                                                                                                	**type**\:  :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                                
                                                                                                .. attribute:: vlan
                                                                                                
                                                                                                	Match VLAN array
                                                                                                	**type**\:  :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                                
                                                                                                .. attribute:: vlan_inr
                                                                                                
                                                                                                	Match inner header VLAN range array
                                                                                                	**type**\:  :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                                
                                                                                                .. attribute:: fr_dlci
                                                                                                
                                                                                                	Match FR DLCI range array
                                                                                                	**type**\:  :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                                
                                                                                                .. attribute:: src_mac
                                                                                                
                                                                                                	Match Source MAC address
                                                                                                	**type**\:  :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                                
                                                                                                .. attribute:: dst_mac
                                                                                                
                                                                                                	Match Destination MAC address
                                                                                                	**type**\:  :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                                
                                                                                                .. attribute:: atm_clp
                                                                                                
                                                                                                	Match ATM CLP level
                                                                                                	**type**\:  :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                                
                                                                                                .. attribute:: fr_de
                                                                                                
                                                                                                	Match FR DE value
                                                                                                	**type**\:  :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                                
                                                                                                .. attribute:: ipv4_acl
                                                                                                
                                                                                                	IPv4 Access\-list
                                                                                                	**type**\:  :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                                
                                                                                                .. attribute:: ipv6_acl
                                                                                                
                                                                                                	IPv6 Access\-list
                                                                                                	**type**\:  :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                                
                                                                                                .. attribute:: ether_service_acl
                                                                                                
                                                                                                	Ethernet\-Services Access\-list
                                                                                                	**type**\:  :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                                
                                                                                                .. attribute:: avail_id
                                                                                                
                                                                                                	Available Identifiers
                                                                                                	**type**\:  :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                                
                                                                                                .. attribute:: media_type
                                                                                                
                                                                                                	Media Type
                                                                                                	**type**\:  :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                                
                                                                                                .. attribute:: subs_protocol
                                                                                                
                                                                                                	Protocol
                                                                                                	**type**\:  :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                                
                                                                                                .. attribute:: dnis
                                                                                                
                                                                                                	DNIS
                                                                                                	**type**\:  :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                                
                                                                                                .. attribute:: dnis_regex
                                                                                                
                                                                                                	DNIS Regular Expression
                                                                                                	**type**\:  :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                                
                                                                                                .. attribute:: domain
                                                                                                
                                                                                                	Domain Name
                                                                                                	**type**\:  :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                                
                                                                                                .. attribute:: domain_regex
                                                                                                
                                                                                                	Domain Regular Expression
                                                                                                	**type**\:  :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                                
                                                                                                .. attribute:: nas_port
                                                                                                
                                                                                                	NAS Port
                                                                                                	**type**\:  :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                                
                                                                                                .. attribute:: service_name
                                                                                                
                                                                                                	Service Name
                                                                                                	**type**\:  :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                                
                                                                                                .. attribute:: service_name_regex
                                                                                                
                                                                                                	Service Name Regular Exp
                                                                                                	**type**\:  :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                                
                                                                                                .. attribute:: src_addr_ipv4
                                                                                                
                                                                                                	Source Address IPV4
                                                                                                	**type**\:  :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                                
                                                                                                .. attribute:: dst_addr_ipv4
                                                                                                
                                                                                                	Destination Address IPV4
                                                                                                	**type**\:  :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                                
                                                                                                .. attribute:: src_addr_ipv6
                                                                                                
                                                                                                	Source Address IPV6
                                                                                                	**type**\:  :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                                
                                                                                                .. attribute:: dst_addr_ipv6
                                                                                                
                                                                                                	Destination Address IPV6
                                                                                                	**type**\:  :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                                
                                                                                                .. attribute:: src_addr_mac
                                                                                                
                                                                                                	Source Address MAC
                                                                                                	**type**\:  :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                                
                                                                                                .. attribute:: timer
                                                                                                
                                                                                                	Timer
                                                                                                	**type**\:  :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                                
                                                                                                .. attribute:: timer_regexp
                                                                                                
                                                                                                	Timer Regular Expression
                                                                                                	**type**\:  :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                                
                                                                                                .. attribute:: tunnel_name
                                                                                                
                                                                                                	Tunnel Name
                                                                                                	**type**\:  :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                                
                                                                                                .. attribute:: tunnel_name_regex
                                                                                                
                                                                                                	Tunnel Name Regular Expression
                                                                                                	**type**\:  :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                                
                                                                                                .. attribute:: user_name
                                                                                                
                                                                                                	User Name
                                                                                                	**type**\:  :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                                
                                                                                                .. attribute:: user_name_regex
                                                                                                
                                                                                                	User Name Regular Expression
                                                                                                	**type**\:  :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                                
                                                                                                .. attribute:: auth_username
                                                                                                
                                                                                                	Authenticated User Name
                                                                                                	**type**\:  :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                                
                                                                                                .. attribute:: auth_username_regex
                                                                                                
                                                                                                	Authenticated User Name RegEx
                                                                                                	**type**\:  :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                                
                                                                                                .. attribute:: unauth_username
                                                                                                
                                                                                                	Unauthenticated User Name
                                                                                                	**type**\:  :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                                
                                                                                                .. attribute:: unauth_username_regex
                                                                                                
                                                                                                	Unauthenticated User Name RegEx
                                                                                                	**type**\:  :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                                
                                                                                                .. attribute:: auth_domain
                                                                                                
                                                                                                	Authenticated domain name
                                                                                                	**type**\:  :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                                
                                                                                                .. attribute:: auth_domain_regex
                                                                                                
                                                                                                	Authenticated Domain Name RegEx
                                                                                                	**type**\:  :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                                
                                                                                                .. attribute:: unauth_domain
                                                                                                
                                                                                                	Unauthenticated Domain Name
                                                                                                	**type**\:  :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                                
                                                                                                .. attribute:: unauth_domain_regex
                                                                                                
                                                                                                	Unauthenticated Domain Name RegEx
                                                                                                	**type**\:  :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                                
                                                                                                .. attribute:: vendor_id
                                                                                                
                                                                                                	Vendor ID
                                                                                                	**type**\:  :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                                
                                                                                                .. attribute:: vendor_id_regex
                                                                                                
                                                                                                	Vendor ID RegEx
                                                                                                	**type**\:  :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                                
                                                                                                .. attribute:: access_interface
                                                                                                
                                                                                                	Access interface
                                                                                                	**type**\:  :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                                
                                                                                                .. attribute:: input_interface
                                                                                                
                                                                                                	Input interface
                                                                                                	**type**\:  :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                                
                                                                                                .. attribute:: input_intfhdl
                                                                                                
                                                                                                	Input interface handle
                                                                                                	**type**\:  :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                                
                                                                                                .. attribute:: ethertype
                                                                                                
                                                                                                	Ethernet type
                                                                                                	**type**\:  :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                                
                                                                                                .. attribute:: flow_key_data
                                                                                                
                                                                                                	Flow key structure
                                                                                                	**type**\:  :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                                
                                                                                                .. attribute:: dhcp_client_id
                                                                                                
                                                                                                	Dhcp Client ID
                                                                                                	**type**\:  :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                                
                                                                                                .. attribute:: dhcp_client_id_regex
                                                                                                
                                                                                                	Dhcp Client ID RegEx
                                                                                                	**type**\:  :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                                
                                                                                                .. attribute:: circuit_id
                                                                                                
                                                                                                	Circuit ID
                                                                                                	**type**\:  :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                                
                                                                                                .. attribute:: circuit_id_regex
                                                                                                
                                                                                                	Circuit ID RegEx
                                                                                                	**type**\:  :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                                
                                                                                                .. attribute:: remote_id
                                                                                                
                                                                                                	Remote ID
                                                                                                	**type**\:  :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                                
                                                                                                .. attribute:: remote_id_regex
                                                                                                
                                                                                                	Remote ID RegEx
                                                                                                	**type**\:  :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                                
                                                                                                .. attribute:: src_port
                                                                                                
                                                                                                	Source port
                                                                                                	**type**\:  :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                                
                                                                                                .. attribute:: dst_port
                                                                                                
                                                                                                	Destination port
                                                                                                	**type**\:  :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	type
                                                                                                	**type**\:  :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                                
                                                                                                .. attribute:: mpls_top_eos
                                                                                                
                                                                                                	MPLS Topmost EOS
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: fragment_type
                                                                                                
                                                                                                	Fragment type
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: authen_status
                                                                                                
                                                                                                	Authentication Status
                                                                                                	**type**\:  :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                                
                                                                                                .. attribute:: mlp_negotiated
                                                                                                
                                                                                                	MLP Negotiated
                                                                                                	**type**\:  :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                                    self.yang_name = "match-data"
                                                                                                    self.yang_parent_name = "class-match-info-st"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv4-dscp", ("ipv4_dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp)), ("ipv6-dscp", ("ipv6_dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp)), ("dscp", ("dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp)), ("ipv4-prec", ("ipv4_prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec)), ("ipv6-prec", ("ipv6_prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec)), ("prec", ("prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec)), ("discard-class", ("discard_class", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass)), ("qos-group", ("qos_group", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup)), ("traffic-class", ("traffic_class", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass)), ("proto", ("proto", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto)), ("icmp-v4", ("icmp_v4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4)), ("icmp-v6", ("icmp_v6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6)), ("ipv4-packet-len", ("ipv4_packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen)), ("ipv6-packet-len", ("ipv6_packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen)), ("packet-len", ("packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen)), ("flow-tag", ("flow_tag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag)), ("tcp-flag", ("tcp_flag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag)), ("icmpv4-type", ("icmpv4_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type)), ("icmpv4-code", ("icmpv4_code", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code)), ("icmpv6-type", ("icmpv6_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type)), ("icmpv6-code", ("icmpv6_code", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code)), ("mpls-exp", ("mpls_exp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp)), ("mpls-exp-imp", ("mpls_exp_imp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp)), ("mpls-disp-ipv4-acl", ("mpls_disp_ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl)), ("mpls-disp-ipv6-acl", ("mpls_disp_ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl)), ("mpls-top-label", ("mpls_top_label", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel)), ("cos", ("cos", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos)), ("cos-inr", ("cos_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr)), ("dei", ("dei", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei)), ("dei-inr", ("dei_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr)), ("vlan", ("vlan", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan)), ("vlan-inr", ("vlan_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)), ("fr-dlci", ("fr_dlci", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci)), ("src-mac", ("src_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac)), ("dst-mac", ("dst_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac)), ("atm-clp", ("atm_clp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp)), ("fr-de", ("fr_de", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe)), ("ipv4-acl", ("ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl)), ("ipv6-acl", ("ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl)), ("ether-service-acl", ("ether_service_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl)), ("avail-id", ("avail_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId)), ("media-type", ("media_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType)), ("subs-protocol", ("subs_protocol", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol)), ("dnis", ("dnis", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis)), ("dnis-regex", ("dnis_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex)), ("domain", ("domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain)), ("domain-regex", ("domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex)), ("nas-port", ("nas_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort)), ("service-name", ("service_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName)), ("service-name-regex", ("service_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex)), ("src-addr-ipv4", ("src_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4)), ("dst-addr-ipv4", ("dst_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4)), ("src-addr-ipv6", ("src_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6)), ("dst-addr-ipv6", ("dst_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6)), ("src-addr-mac", ("src_addr_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac)), ("timer", ("timer", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer)), ("timer-regexp", ("timer_regexp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp)), ("tunnel-name", ("tunnel_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName)), ("tunnel-name-regex", ("tunnel_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex)), ("user-name", ("user_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName)), ("user-name-regex", ("user_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex)), ("auth-username", ("auth_username", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername)), ("auth-username-regex", ("auth_username_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex)), ("unauth-username", ("unauth_username", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername)), ("unauth-username-regex", ("unauth_username_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex)), ("auth-domain", ("auth_domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain)), ("auth-domain-regex", ("auth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex)), ("unauth-domain", ("unauth_domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain)), ("unauth-domain-regex", ("unauth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex)), ("vendor-id", ("vendor_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId)), ("vendor-id-regex", ("vendor_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex)), ("access-interface", ("access_interface", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface)), ("input-interface", ("input_interface", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface)), ("input-intfhdl", ("input_intfhdl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl)), ("ethertype", ("ethertype", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype)), ("flow-key-data", ("flow_key_data", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData)), ("dhcp-client-id", ("dhcp_client_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId)), ("dhcp-client-id-regex", ("dhcp_client_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex)), ("circuit-id", ("circuit_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId)), ("circuit-id-regex", ("circuit_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex)), ("remote-id", ("remote_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId)), ("remote-id-regex", ("remote_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex)), ("src-port", ("src_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort)), ("dst-port", ("dst_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort))])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchTypeEn', '')])),
                                                                                                        ('mpls_top_eos', (YLeaf(YType.uint8, 'mpls-top-eos'), ['int'])),
                                                                                                        ('fragment_type', (YLeaf(YType.uint8, 'fragment-type'), ['int'])),
                                                                                                        ('authen_status', (YLeaf(YType.enumeration, 'authen-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchAuthenStatusEn', '')])),
                                                                                                        ('mlp_negotiated', (YLeaf(YType.enumeration, 'mlp-negotiated'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchMlpNegotiatedEn', '')])),
                                                                                                    ])
                                                                                                    self.type = None
                                                                                                    self.mpls_top_eos = None
                                                                                                    self.fragment_type = None
                                                                                                    self.authen_status = None
                                                                                                    self.mlp_negotiated = None

                                                                                                    self.ipv4_dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                                    self.ipv4_dscp.parent = self
                                                                                                    self._children_name_map["ipv4_dscp"] = "ipv4-dscp"

                                                                                                    self.ipv6_dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                                    self.ipv6_dscp.parent = self
                                                                                                    self._children_name_map["ipv6_dscp"] = "ipv6-dscp"

                                                                                                    self.dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                                    self.dscp.parent = self
                                                                                                    self._children_name_map["dscp"] = "dscp"

                                                                                                    self.ipv4_prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                                    self.ipv4_prec.parent = self
                                                                                                    self._children_name_map["ipv4_prec"] = "ipv4-prec"

                                                                                                    self.ipv6_prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                                    self.ipv6_prec.parent = self
                                                                                                    self._children_name_map["ipv6_prec"] = "ipv6-prec"

                                                                                                    self.prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                                    self.prec.parent = self
                                                                                                    self._children_name_map["prec"] = "prec"

                                                                                                    self.discard_class = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                                    self.discard_class.parent = self
                                                                                                    self._children_name_map["discard_class"] = "discard-class"

                                                                                                    self.qos_group = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                                    self.qos_group.parent = self
                                                                                                    self._children_name_map["qos_group"] = "qos-group"

                                                                                                    self.traffic_class = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                                    self.traffic_class.parent = self
                                                                                                    self._children_name_map["traffic_class"] = "traffic-class"

                                                                                                    self.proto = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                                    self.proto.parent = self
                                                                                                    self._children_name_map["proto"] = "proto"

                                                                                                    self.icmp_v4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                                    self.icmp_v4.parent = self
                                                                                                    self._children_name_map["icmp_v4"] = "icmp-v4"

                                                                                                    self.icmp_v6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                                    self.icmp_v6.parent = self
                                                                                                    self._children_name_map["icmp_v6"] = "icmp-v6"

                                                                                                    self.ipv4_packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                                    self.ipv4_packet_len.parent = self
                                                                                                    self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"

                                                                                                    self.ipv6_packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                                    self.ipv6_packet_len.parent = self
                                                                                                    self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"

                                                                                                    self.packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                                    self.packet_len.parent = self
                                                                                                    self._children_name_map["packet_len"] = "packet-len"

                                                                                                    self.flow_tag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                                    self.flow_tag.parent = self
                                                                                                    self._children_name_map["flow_tag"] = "flow-tag"

                                                                                                    self.tcp_flag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                                    self.tcp_flag.parent = self
                                                                                                    self._children_name_map["tcp_flag"] = "tcp-flag"

                                                                                                    self.icmpv4_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                                    self.icmpv4_type.parent = self
                                                                                                    self._children_name_map["icmpv4_type"] = "icmpv4-type"

                                                                                                    self.icmpv4_code = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                                    self.icmpv4_code.parent = self
                                                                                                    self._children_name_map["icmpv4_code"] = "icmpv4-code"

                                                                                                    self.icmpv6_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                                    self.icmpv6_type.parent = self
                                                                                                    self._children_name_map["icmpv6_type"] = "icmpv6-type"

                                                                                                    self.icmpv6_code = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                                    self.icmpv6_code.parent = self
                                                                                                    self._children_name_map["icmpv6_code"] = "icmpv6-code"

                                                                                                    self.mpls_exp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                                    self.mpls_exp.parent = self
                                                                                                    self._children_name_map["mpls_exp"] = "mpls-exp"

                                                                                                    self.mpls_exp_imp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                                    self.mpls_exp_imp.parent = self
                                                                                                    self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"

                                                                                                    self.mpls_disp_ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                                    self.mpls_disp_ipv4_acl.parent = self
                                                                                                    self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"

                                                                                                    self.mpls_disp_ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                                    self.mpls_disp_ipv6_acl.parent = self
                                                                                                    self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"

                                                                                                    self.mpls_top_label = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                                    self.mpls_top_label.parent = self
                                                                                                    self._children_name_map["mpls_top_label"] = "mpls-top-label"

                                                                                                    self.cos = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                                    self.cos.parent = self
                                                                                                    self._children_name_map["cos"] = "cos"

                                                                                                    self.cos_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                                    self.cos_inr.parent = self
                                                                                                    self._children_name_map["cos_inr"] = "cos-inr"

                                                                                                    self.dei = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                                    self.dei.parent = self
                                                                                                    self._children_name_map["dei"] = "dei"

                                                                                                    self.dei_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                                    self.dei_inr.parent = self
                                                                                                    self._children_name_map["dei_inr"] = "dei-inr"

                                                                                                    self.vlan = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                                    self.vlan.parent = self
                                                                                                    self._children_name_map["vlan"] = "vlan"

                                                                                                    self.vlan_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                                    self.vlan_inr.parent = self
                                                                                                    self._children_name_map["vlan_inr"] = "vlan-inr"

                                                                                                    self.fr_dlci = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                                    self.fr_dlci.parent = self
                                                                                                    self._children_name_map["fr_dlci"] = "fr-dlci"

                                                                                                    self.src_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                                    self.src_mac.parent = self
                                                                                                    self._children_name_map["src_mac"] = "src-mac"

                                                                                                    self.dst_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                                    self.dst_mac.parent = self
                                                                                                    self._children_name_map["dst_mac"] = "dst-mac"

                                                                                                    self.atm_clp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                                    self.atm_clp.parent = self
                                                                                                    self._children_name_map["atm_clp"] = "atm-clp"

                                                                                                    self.fr_de = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                                    self.fr_de.parent = self
                                                                                                    self._children_name_map["fr_de"] = "fr-de"

                                                                                                    self.ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                                    self.ipv4_acl.parent = self
                                                                                                    self._children_name_map["ipv4_acl"] = "ipv4-acl"

                                                                                                    self.ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                                    self.ipv6_acl.parent = self
                                                                                                    self._children_name_map["ipv6_acl"] = "ipv6-acl"

                                                                                                    self.ether_service_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                                    self.ether_service_acl.parent = self
                                                                                                    self._children_name_map["ether_service_acl"] = "ether-service-acl"

                                                                                                    self.avail_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                                    self.avail_id.parent = self
                                                                                                    self._children_name_map["avail_id"] = "avail-id"

                                                                                                    self.media_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                                    self.media_type.parent = self
                                                                                                    self._children_name_map["media_type"] = "media-type"

                                                                                                    self.subs_protocol = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                                    self.subs_protocol.parent = self
                                                                                                    self._children_name_map["subs_protocol"] = "subs-protocol"

                                                                                                    self.dnis = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                                    self.dnis.parent = self
                                                                                                    self._children_name_map["dnis"] = "dnis"

                                                                                                    self.dnis_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                                    self.dnis_regex.parent = self
                                                                                                    self._children_name_map["dnis_regex"] = "dnis-regex"

                                                                                                    self.domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                                    self.domain.parent = self
                                                                                                    self._children_name_map["domain"] = "domain"

                                                                                                    self.domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                                    self.domain_regex.parent = self
                                                                                                    self._children_name_map["domain_regex"] = "domain-regex"

                                                                                                    self.nas_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                                    self.nas_port.parent = self
                                                                                                    self._children_name_map["nas_port"] = "nas-port"

                                                                                                    self.service_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                                    self.service_name.parent = self
                                                                                                    self._children_name_map["service_name"] = "service-name"

                                                                                                    self.service_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                                    self.service_name_regex.parent = self
                                                                                                    self._children_name_map["service_name_regex"] = "service-name-regex"

                                                                                                    self.src_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                                    self.src_addr_ipv4.parent = self
                                                                                                    self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"

                                                                                                    self.dst_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                                    self.dst_addr_ipv4.parent = self
                                                                                                    self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"

                                                                                                    self.src_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                                    self.src_addr_ipv6.parent = self
                                                                                                    self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"

                                                                                                    self.dst_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                                    self.dst_addr_ipv6.parent = self
                                                                                                    self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"

                                                                                                    self.src_addr_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                                    self.src_addr_mac.parent = self
                                                                                                    self._children_name_map["src_addr_mac"] = "src-addr-mac"

                                                                                                    self.timer = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                                    self.timer.parent = self
                                                                                                    self._children_name_map["timer"] = "timer"

                                                                                                    self.timer_regexp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                                    self.timer_regexp.parent = self
                                                                                                    self._children_name_map["timer_regexp"] = "timer-regexp"

                                                                                                    self.tunnel_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                                    self.tunnel_name.parent = self
                                                                                                    self._children_name_map["tunnel_name"] = "tunnel-name"

                                                                                                    self.tunnel_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                                    self.tunnel_name_regex.parent = self
                                                                                                    self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"

                                                                                                    self.user_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                                    self.user_name.parent = self
                                                                                                    self._children_name_map["user_name"] = "user-name"

                                                                                                    self.user_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                                    self.user_name_regex.parent = self
                                                                                                    self._children_name_map["user_name_regex"] = "user-name-regex"

                                                                                                    self.auth_username = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                                    self.auth_username.parent = self
                                                                                                    self._children_name_map["auth_username"] = "auth-username"

                                                                                                    self.auth_username_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                                    self.auth_username_regex.parent = self
                                                                                                    self._children_name_map["auth_username_regex"] = "auth-username-regex"

                                                                                                    self.unauth_username = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                                    self.unauth_username.parent = self
                                                                                                    self._children_name_map["unauth_username"] = "unauth-username"

                                                                                                    self.unauth_username_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                                    self.unauth_username_regex.parent = self
                                                                                                    self._children_name_map["unauth_username_regex"] = "unauth-username-regex"

                                                                                                    self.auth_domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                                    self.auth_domain.parent = self
                                                                                                    self._children_name_map["auth_domain"] = "auth-domain"

                                                                                                    self.auth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                                    self.auth_domain_regex.parent = self
                                                                                                    self._children_name_map["auth_domain_regex"] = "auth-domain-regex"

                                                                                                    self.unauth_domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                                    self.unauth_domain.parent = self
                                                                                                    self._children_name_map["unauth_domain"] = "unauth-domain"

                                                                                                    self.unauth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                                    self.unauth_domain_regex.parent = self
                                                                                                    self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"

                                                                                                    self.vendor_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                                    self.vendor_id.parent = self
                                                                                                    self._children_name_map["vendor_id"] = "vendor-id"

                                                                                                    self.vendor_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                                    self.vendor_id_regex.parent = self
                                                                                                    self._children_name_map["vendor_id_regex"] = "vendor-id-regex"

                                                                                                    self.access_interface = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                                    self.access_interface.parent = self
                                                                                                    self._children_name_map["access_interface"] = "access-interface"

                                                                                                    self.input_interface = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                                    self.input_interface.parent = self
                                                                                                    self._children_name_map["input_interface"] = "input-interface"

                                                                                                    self.input_intfhdl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                                    self.input_intfhdl.parent = self
                                                                                                    self._children_name_map["input_intfhdl"] = "input-intfhdl"

                                                                                                    self.ethertype = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                                    self.ethertype.parent = self
                                                                                                    self._children_name_map["ethertype"] = "ethertype"

                                                                                                    self.flow_key_data = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                                    self.flow_key_data.parent = self
                                                                                                    self._children_name_map["flow_key_data"] = "flow-key-data"

                                                                                                    self.dhcp_client_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                                    self.dhcp_client_id.parent = self
                                                                                                    self._children_name_map["dhcp_client_id"] = "dhcp-client-id"

                                                                                                    self.dhcp_client_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                                    self.dhcp_client_id_regex.parent = self
                                                                                                    self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"

                                                                                                    self.circuit_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                                    self.circuit_id.parent = self
                                                                                                    self._children_name_map["circuit_id"] = "circuit-id"

                                                                                                    self.circuit_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                                    self.circuit_id_regex.parent = self
                                                                                                    self._children_name_map["circuit_id_regex"] = "circuit-id-regex"

                                                                                                    self.remote_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                                    self.remote_id.parent = self
                                                                                                    self._children_name_map["remote_id"] = "remote-id"

                                                                                                    self.remote_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                                    self.remote_id_regex.parent = self
                                                                                                    self._children_name_map["remote_id_regex"] = "remote-id-regex"

                                                                                                    self.src_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                                    self.src_port.parent = self
                                                                                                    self._children_name_map["src_port"] = "src-port"

                                                                                                    self.dst_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                                    self.dst_port.parent = self
                                                                                                    self._children_name_map["dst_port"] = "dst-port"
                                                                                                    self._segment_path = lambda: "match-data"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['type', 'mpls_top_eos', 'fragment_type', 'authen_status', 'mlp_negotiated'], name, value)


                                                                                                class Ipv4Dscp(Entity):
                                                                                                    """
                                                                                                    IPv4 DSCP
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                        self.yang_name = "ipv4-dscp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ipv4-dscp"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "ipv4-dscp"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                                class Ipv6Dscp(Entity):
                                                                                                    """
                                                                                                    IPv6 DSCP
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                        self.yang_name = "ipv6-dscp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ipv6-dscp"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "ipv6-dscp"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                                class Dscp(Entity):
                                                                                                    """
                                                                                                    Match DSCP range array
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                        self.yang_name = "dscp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "dscp"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "dscp"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                                class Ipv4Prec(Entity):
                                                                                                    """
                                                                                                    IPv4 Precedence
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                        self.yang_name = "ipv4-prec"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "ipv4-prec"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                                class Ipv6Prec(Entity):
                                                                                                    """
                                                                                                    IPv6 Precedence
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                        self.yang_name = "ipv6-prec"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "ipv6-prec"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                                class Prec(Entity):
                                                                                                    """
                                                                                                    Match Precedence array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                        self.yang_name = "prec"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "prec"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                                class DiscardClass(Entity):
                                                                                                    """
                                                                                                    Match Discard Class array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                        self.yang_name = "discard-class"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "discard-class"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                                class QosGroup(Entity):
                                                                                                    """
                                                                                                    Match QoS group array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                        self.yang_name = "qos-group"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "qos-group"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "qos-group"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['min', 'max'], name, value)


                                                                                                class TrafficClass(Entity):
                                                                                                    """
                                                                                                    Match Traffic class array
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                        self.yang_name = "traffic-class"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "traffic-class"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "traffic-class"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['min', 'max'], name, value)


                                                                                                class Proto(Entity):
                                                                                                    """
                                                                                                    Match Protocol array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                        self.yang_name = "proto"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "proto"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "proto"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['min', 'max'], name, value)


                                                                                                class IcmpV4(Entity):
                                                                                                    """
                                                                                                    Match ICMPV4 Protocol
                                                                                                    
                                                                                                    .. attribute:: type
                                                                                                    
                                                                                                    	Protocol type
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: code
                                                                                                    
                                                                                                    	Protocol code
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                        self.yang_name = "icmp-v4"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                            ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                        ])
                                                                                                        self.type = None
                                                                                                        self.code = None
                                                                                                        self._segment_path = lambda: "icmp-v4"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['type', 'code'], name, value)


                                                                                                class IcmpV6(Entity):
                                                                                                    """
                                                                                                    Match ICMPV6 Protocol array
                                                                                                    
                                                                                                    .. attribute:: type
                                                                                                    
                                                                                                    	Protocol type
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: code
                                                                                                    
                                                                                                    	Protocol code
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                        self.yang_name = "icmp-v6"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                            ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                        ])
                                                                                                        self.type = None
                                                                                                        self.code = None
                                                                                                        self._segment_path = lambda: "icmp-v6"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['type', 'code'], name, value)


                                                                                                class Ipv4PacketLen(Entity):
                                                                                                    """
                                                                                                    IPv4 packet length array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                        self.yang_name = "ipv4-packet-len"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ipv4-packet-len"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "ipv4-packet-len"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                                class Ipv6PacketLen(Entity):
                                                                                                    """
                                                                                                    IPv6 packet length array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                        self.yang_name = "ipv6-packet-len"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ipv6-packet-len"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "ipv6-packet-len"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                                class PacketLen(Entity):
                                                                                                    """
                                                                                                    Match packet length array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                        self.yang_name = "packet-len"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "packet-len"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "packet-len"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                                class FlowTag(Entity):
                                                                                                    """
                                                                                                    Match flow\-tag array
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                        self.yang_name = "flow-tag"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "flow-tag"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "flow-tag"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['min', 'max'], name, value)


                                                                                                class TcpFlag(Entity):
                                                                                                    """
                                                                                                    Match tcp flag value
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	Value of TCP flag
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: match_any
                                                                                                    
                                                                                                    	Match any TCP flag bit
                                                                                                    	**type**\: bool
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                        self.yang_name = "tcp-flag"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                                            ('match_any', (YLeaf(YType.boolean, 'match-any'), ['bool'])),
                                                                                                        ])
                                                                                                        self.value = None
                                                                                                        self.match_any = None
                                                                                                        self._segment_path = lambda: "tcp-flag"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['value', 'match_any'], name, value)


                                                                                                class Icmpv4Type(Entity):
                                                                                                    """
                                                                                                    Match ipv4 icmp type
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                        self.yang_name = "icmpv4-type"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "icmpv4-type"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "icmpv4-type"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                                class Icmpv4Code(Entity):
                                                                                                    """
                                                                                                    Match ipv4 icmp code
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                        self.yang_name = "icmpv4-code"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "icmpv4-code"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "icmpv4-code"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                                class Icmpv6Type(Entity):
                                                                                                    """
                                                                                                    Match ipv6 icmp type
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                        self.yang_name = "icmpv6-type"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "icmpv6-type"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "icmpv6-type"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                                class Icmpv6Code(Entity):
                                                                                                    """
                                                                                                    Match ipv6 icmp code
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                        self.yang_name = "icmpv6-code"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "icmpv6-code"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "icmpv6-code"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint8_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                                class MplsExp(Entity):
                                                                                                    """
                                                                                                    Match MPLS experimental topmost array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                        self.yang_name = "mpls-exp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "mpls-exp"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                                class MplsExpImp(Entity):
                                                                                                    """
                                                                                                    Match MPLS experimental imposition array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                        self.yang_name = "mpls-exp-imp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "mpls-exp-imp"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                                class MplsDispIpv4Acl(Entity):
                                                                                                    """
                                                                                                    MPLS Disposition IPv4 Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                        self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "mpls-disp-ipv4-acl"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                                class MplsDispIpv6Acl(Entity):
                                                                                                    """
                                                                                                    MPLS Disposition IPv6 Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                        self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "mpls-disp-ipv6-acl"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                                class MplsTopLabel(Entity):
                                                                                                    """
                                                                                                    MPLS Topmost LABEL
                                                                                                    
                                                                                                    .. attribute:: uint32_rng_array
                                                                                                    
                                                                                                    	uint32 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                        self.yang_name = "mpls-top-label"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint32_rng_array", ("uint32_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint32_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "mpls-top-label"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                                    class Uint32RngArray(Entity):
                                                                                                        """
                                                                                                        uint32 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                            self.yang_name = "uint32_rng_array"
                                                                                                            self.yang_parent_name = "mpls-top-label"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint32, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint32, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint32_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['min', 'max'], name, value)


                                                                                                class Cos(Entity):
                                                                                                    """
                                                                                                    Match CoS array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                        self.yang_name = "cos"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "cos"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                                class CosInr(Entity):
                                                                                                    """
                                                                                                    Match inner header CoS
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                        self.yang_name = "cos-inr"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "cos-inr"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                                class Dei(Entity):
                                                                                                    """
                                                                                                    Match DEI Bit
                                                                                                    
                                                                                                    .. attribute:: bit_value
                                                                                                    
                                                                                                    	Value of the DEI bit
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                        self.yang_name = "dei"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                        ])
                                                                                                        self.bit_value = None
                                                                                                        self._segment_path = lambda: "dei"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                                class DeiInr(Entity):
                                                                                                    """
                                                                                                    Match inner DEI Bit
                                                                                                    
                                                                                                    .. attribute:: bit_value
                                                                                                    
                                                                                                    	Value of the DEI bit
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                        self.yang_name = "dei-inr"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                        ])
                                                                                                        self.bit_value = None
                                                                                                        self._segment_path = lambda: "dei-inr"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                                class Vlan(Entity):
                                                                                                    """
                                                                                                    Match VLAN array
                                                                                                    
                                                                                                    .. attribute:: vlan_id_array
                                                                                                    
                                                                                                    	vlan id array
                                                                                                    	**type**\: list of  		 :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                        self.yang_name = "vlan"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("vlan-id-array", ("vlan_id_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.vlan_id_array = YList(self)
                                                                                                        self._segment_path = lambda: "vlan"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                                    class VlanIdArray(Entity):
                                                                                                        """
                                                                                                        vlan id array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	VLAN mask
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                            self.yang_name = "vlan-id-array"
                                                                                                            self.yang_parent_name = "vlan"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                                ('mask', (YLeaf(YType.uint16, 'mask'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self.mask = None
                                                                                                            self._segment_path = lambda: "vlan-id-array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['min', 'max', 'mask'], name, value)


                                                                                                class VlanInr(Entity):
                                                                                                    """
                                                                                                    Match inner header VLAN range array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                        self.yang_name = "vlan-inr"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "vlan-inr"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "vlan-inr"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['min', 'max'], name, value)


                                                                                                class FrDlci(Entity):
                                                                                                    """
                                                                                                    Match FR DLCI range array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                        self.yang_name = "fr-dlci"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "fr-dlci"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "fr-dlci"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['min', 'max'], name, value)


                                                                                                class SrcMac(Entity):
                                                                                                    """
                                                                                                    Match Source MAC address
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                        self.yang_name = "src-mac"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                            ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.mac_addr = []
                                                                                                        self.mask = []
                                                                                                        self._segment_path = lambda: "src-mac"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                                class DstMac(Entity):
                                                                                                    """
                                                                                                    Match Destination MAC address
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                        self.yang_name = "dst-mac"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                            ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.mac_addr = []
                                                                                                        self.mask = []
                                                                                                        self._segment_path = lambda: "dst-mac"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                                class AtmClp(Entity):
                                                                                                    """
                                                                                                    Match ATM CLP level
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                        self.yang_name = "atm-clp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "atm-clp"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                                class FrDe(Entity):
                                                                                                    """
                                                                                                    Match FR DE value
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                        self.yang_name = "fr-de"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "fr-de"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                                class Ipv4Acl(Entity):
                                                                                                    """
                                                                                                    IPv4 Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                        self.yang_name = "ipv4-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "ipv4-acl"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                                class Ipv6Acl(Entity):
                                                                                                    """
                                                                                                    IPv6 Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                        self.yang_name = "ipv6-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "ipv6-acl"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                                class EtherServiceAcl(Entity):
                                                                                                    """
                                                                                                    Ethernet\-Services Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                        self.yang_name = "ether-service-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "ether-service-acl"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                                class AvailId(Entity):
                                                                                                    """
                                                                                                    Available Identifiers
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                        self.yang_name = "avail-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "avail-id"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                                class MediaType(Entity):
                                                                                                    """
                                                                                                    Media Type
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                        self.yang_name = "media-type"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "media-type"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                                class SubsProtocol(Entity):
                                                                                                    """
                                                                                                    Protocol
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                        self.yang_name = "subs-protocol"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint8_array = []
                                                                                                        self._segment_path = lambda: "subs-protocol"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                                class Dnis(Entity):
                                                                                                    """
                                                                                                    DNIS
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                        self.yang_name = "dnis"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "dnis"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                                class DnisRegex(Entity):
                                                                                                    """
                                                                                                    DNIS Regular Expression
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                        self.yang_name = "dnis-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "dnis-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                                class Domain(Entity):
                                                                                                    """
                                                                                                    Domain Name
                                                                                                    
                                                                                                    .. attribute:: domain_array
                                                                                                    
                                                                                                    	domain array
                                                                                                    	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                        self.yang_name = "domain"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.domain_array = YList(self)
                                                                                                        self._segment_path = lambda: "domain"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                                    class DomainArray(Entity):
                                                                                                        """
                                                                                                        domain array
                                                                                                        
                                                                                                        .. attribute:: domain_name
                                                                                                        
                                                                                                        	domain name
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        .. attribute:: format_name
                                                                                                        
                                                                                                        	format name
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                            self.yang_name = "domain-array"
                                                                                                            self.yang_parent_name = "domain"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                                ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                            ])
                                                                                                            self.domain_name = None
                                                                                                            self.format_name = None
                                                                                                            self._segment_path = lambda: "domain-array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                                class DomainRegex(Entity):
                                                                                                    """
                                                                                                    Domain Regular Expression
                                                                                                    
                                                                                                    .. attribute:: domain_array
                                                                                                    
                                                                                                    	domain array
                                                                                                    	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                        self.yang_name = "domain-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.domain_array = YList(self)
                                                                                                        self._segment_path = lambda: "domain-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                                    class DomainArray(Entity):
                                                                                                        """
                                                                                                        domain array
                                                                                                        
                                                                                                        .. attribute:: domain_name
                                                                                                        
                                                                                                        	domain name
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        .. attribute:: format_name
                                                                                                        
                                                                                                        	format name
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                            self.yang_name = "domain-array"
                                                                                                            self.yang_parent_name = "domain-regex"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                                ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                            ])
                                                                                                            self.domain_name = None
                                                                                                            self.format_name = None
                                                                                                            self._segment_path = lambda: "domain-array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                                class NasPort(Entity):
                                                                                                    """
                                                                                                    NAS Port
                                                                                                    
                                                                                                    .. attribute:: nas_port_array
                                                                                                    
                                                                                                    	nas port array
                                                                                                    	**type**\: list of  		 :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                        self.yang_name = "nas-port"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("nas-port-array", ("nas_port_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.nas_port_array = YList(self)
                                                                                                        self._segment_path = lambda: "nas-port"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                                    class NasPortArray(Entity):
                                                                                                        """
                                                                                                        nas port array
                                                                                                        
                                                                                                        .. attribute:: sub_id
                                                                                                        
                                                                                                        	sub id
                                                                                                        	**type**\:  :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                        
                                                                                                        .. attribute:: operator
                                                                                                        
                                                                                                        	operator
                                                                                                        	**type**\:  :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                        
                                                                                                        .. attribute:: value
                                                                                                        
                                                                                                        	value
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                            self.yang_name = "nas-port-array"
                                                                                                            self.yang_parent_name = "nas-port"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('sub_id', (YLeaf(YType.enumeration, 'sub-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchNasPortSubIdEn', '')])),
                                                                                                                ('operator', (YLeaf(YType.enumeration, 'operator'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchLogicalOperatorEn', '')])),
                                                                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                                            ])
                                                                                                            self.sub_id = None
                                                                                                            self.operator = None
                                                                                                            self.value = None
                                                                                                            self._segment_path = lambda: "nas-port-array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['sub_id', 'operator', 'value'], name, value)


                                                                                                class ServiceName(Entity):
                                                                                                    """
                                                                                                    Service Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                        self.yang_name = "service-name"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "service-name"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                                class ServiceNameRegex(Entity):
                                                                                                    """
                                                                                                    Service Name Regular Exp
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                        self.yang_name = "service-name-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "service-name-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                                class SrcAddrIpv4(Entity):
                                                                                                    """
                                                                                                    Source Address IPV4
                                                                                                    
                                                                                                    .. attribute:: ipv4_addr_array
                                                                                                    
                                                                                                    	ipv4 addr array
                                                                                                    	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                        self.yang_name = "src-addr-ipv4"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.ipv4_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "src-addr-ipv4"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                                    class Ipv4AddrArray(Entity):
                                                                                                        """
                                                                                                        ipv4 addr array
                                                                                                        
                                                                                                        .. attribute:: prefix
                                                                                                        
                                                                                                        	prefix
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	mask
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                            self.yang_name = "ipv4-addr-array"
                                                                                                            self.yang_parent_name = "src-addr-ipv4"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                                ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                            ])
                                                                                                            self.prefix = None
                                                                                                            self.mask = None
                                                                                                            self._segment_path = lambda: "ipv4-addr-array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                                class DstAddrIpv4(Entity):
                                                                                                    """
                                                                                                    Destination Address IPV4
                                                                                                    
                                                                                                    .. attribute:: ipv4_addr_array
                                                                                                    
                                                                                                    	ipv4 addr array
                                                                                                    	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                        self.yang_name = "dst-addr-ipv4"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.ipv4_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "dst-addr-ipv4"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                                    class Ipv4AddrArray(Entity):
                                                                                                        """
                                                                                                        ipv4 addr array
                                                                                                        
                                                                                                        .. attribute:: prefix
                                                                                                        
                                                                                                        	prefix
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	mask
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                            self.yang_name = "ipv4-addr-array"
                                                                                                            self.yang_parent_name = "dst-addr-ipv4"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                                ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                            ])
                                                                                                            self.prefix = None
                                                                                                            self.mask = None
                                                                                                            self._segment_path = lambda: "ipv4-addr-array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                                class SrcAddrIpv6(Entity):
                                                                                                    """
                                                                                                    Source Address IPV6
                                                                                                    
                                                                                                    .. attribute:: ipv6_addr_array
                                                                                                    
                                                                                                    	ipv6 addr array
                                                                                                    	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                        self.yang_name = "src-addr-ipv6"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.ipv6_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "src-addr-ipv6"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                                    class Ipv6AddrArray(Entity):
                                                                                                        """
                                                                                                        ipv6 addr array
                                                                                                        
                                                                                                        .. attribute:: prefix
                                                                                                        
                                                                                                        	IPV6 prefix
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	IPV6 mask
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                            self.yang_name = "ipv6-addr-array"
                                                                                                            self.yang_parent_name = "src-addr-ipv6"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                                ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                            ])
                                                                                                            self.prefix = None
                                                                                                            self.mask = None
                                                                                                            self._segment_path = lambda: "ipv6-addr-array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                                class DstAddrIpv6(Entity):
                                                                                                    """
                                                                                                    Destination Address IPV6
                                                                                                    
                                                                                                    .. attribute:: ipv6_addr_array
                                                                                                    
                                                                                                    	ipv6 addr array
                                                                                                    	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                        self.yang_name = "dst-addr-ipv6"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.ipv6_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "dst-addr-ipv6"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                                    class Ipv6AddrArray(Entity):
                                                                                                        """
                                                                                                        ipv6 addr array
                                                                                                        
                                                                                                        .. attribute:: prefix
                                                                                                        
                                                                                                        	IPV6 prefix
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	IPV6 mask
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                            self.yang_name = "ipv6-addr-array"
                                                                                                            self.yang_parent_name = "dst-addr-ipv6"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                                ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                            ])
                                                                                                            self.prefix = None
                                                                                                            self.mask = None
                                                                                                            self._segment_path = lambda: "ipv6-addr-array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                                class SrcAddrMac(Entity):
                                                                                                    """
                                                                                                    Source Address MAC
                                                                                                    
                                                                                                    .. attribute:: mac_addr_array
                                                                                                    
                                                                                                    	mac addr array
                                                                                                    	**type**\: list of  		 :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                        self.yang_name = "src-addr-mac"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("mac-addr-array", ("mac_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.mac_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "src-addr-mac"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                                    class MacAddrArray(Entity):
                                                                                                        """
                                                                                                        mac addr array
                                                                                                        
                                                                                                        .. attribute:: mac_addr
                                                                                                        
                                                                                                        	MAC address
                                                                                                        	**type**\: list of int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	MAC mask
                                                                                                        	**type**\: list of int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                            self.yang_name = "mac-addr-array"
                                                                                                            self.yang_parent_name = "src-addr-mac"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                                ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                            ])
                                                                                                            self.mac_addr = []
                                                                                                            self.mask = []
                                                                                                            self._segment_path = lambda: "mac-addr-array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                                class Timer(Entity):
                                                                                                    """
                                                                                                    Timer
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                        self.yang_name = "timer"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "timer"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                                class TimerRegexp(Entity):
                                                                                                    """
                                                                                                    Timer Regular Expression
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                        self.yang_name = "timer-regexp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "timer-regexp"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                                class TunnelName(Entity):
                                                                                                    """
                                                                                                    Tunnel Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                        self.yang_name = "tunnel-name"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "tunnel-name"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                                class TunnelNameRegex(Entity):
                                                                                                    """
                                                                                                    Tunnel Name Regular Expression
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                        self.yang_name = "tunnel-name-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "tunnel-name-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                                class UserName(Entity):
                                                                                                    """
                                                                                                    User Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                        self.yang_name = "user-name"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "user-name"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                                class UserNameRegex(Entity):
                                                                                                    """
                                                                                                    User Name Regular Expression
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                        self.yang_name = "user-name-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "user-name-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                                class AuthUsername(Entity):
                                                                                                    """
                                                                                                    Authenticated User Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                        self.yang_name = "auth-username"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "auth-username"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                                class AuthUsernameRegex(Entity):
                                                                                                    """
                                                                                                    Authenticated User Name RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                        self.yang_name = "auth-username-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "auth-username-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                                class UnauthUsername(Entity):
                                                                                                    """
                                                                                                    Unauthenticated User Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                        self.yang_name = "unauth-username"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "unauth-username"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                                class UnauthUsernameRegex(Entity):
                                                                                                    """
                                                                                                    Unauthenticated User Name RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                        self.yang_name = "unauth-username-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "unauth-username-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                                class AuthDomain(Entity):
                                                                                                    """
                                                                                                    Authenticated domain name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                        self.yang_name = "auth-domain"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "auth-domain"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                                class AuthDomainRegex(Entity):
                                                                                                    """
                                                                                                    Authenticated Domain Name RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                        self.yang_name = "auth-domain-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "auth-domain-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                                class UnauthDomain(Entity):
                                                                                                    """
                                                                                                    Unauthenticated Domain Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                        self.yang_name = "unauth-domain"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "unauth-domain"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                                class UnauthDomainRegex(Entity):
                                                                                                    """
                                                                                                    Unauthenticated Domain Name RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                        self.yang_name = "unauth-domain-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "unauth-domain-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                                class VendorId(Entity):
                                                                                                    """
                                                                                                    Vendor ID
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                        self.yang_name = "vendor-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "vendor-id"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                                class VendorIdRegex(Entity):
                                                                                                    """
                                                                                                    Vendor ID RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                        self.yang_name = "vendor-id-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "vendor-id-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                                class AccessInterface(Entity):
                                                                                                    """
                                                                                                    Access interface
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                        self.yang_name = "access-interface"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "access-interface"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                                class InputInterface(Entity):
                                                                                                    """
                                                                                                    Input interface
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                        self.yang_name = "input-interface"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "input-interface"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                                class InputIntfhdl(Entity):
                                                                                                    """
                                                                                                    Input interface handle
                                                                                                    
                                                                                                    .. attribute:: uint64_array
                                                                                                    
                                                                                                    	uint64 array
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..18446744073709551615
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                        self.yang_name = "input-intfhdl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('uint64_array', (YLeafList(YType.uint64, 'uint64_array'), ['int'])),
                                                                                                        ])
                                                                                                        self.uint64_array = []
                                                                                                        self._segment_path = lambda: "input-intfhdl"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                                class Ethertype(Entity):
                                                                                                    """
                                                                                                    Ethernet type
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                        self.yang_name = "ethertype"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ethertype"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "ethertype"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['min', 'max'], name, value)


                                                                                                class FlowKeyData(Entity):
                                                                                                    """
                                                                                                    Flow key structure
                                                                                                    
                                                                                                    .. attribute:: flow_keys
                                                                                                    
                                                                                                    	flow keys
                                                                                                    	**type**\:  :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                                    
                                                                                                    .. attribute:: max_count
                                                                                                    
                                                                                                    	Maximum count of flows
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: idle_timeout
                                                                                                    
                                                                                                    	Idle timeout of flows (in seconds)
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    	**units**\: second
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                        self.yang_name = "flow-key-data"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("flow-keys", ("flow_keys", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys))])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('max_count', (YLeaf(YType.uint16, 'max-count'), ['int'])),
                                                                                                            ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                                                        ])
                                                                                                        self.max_count = None
                                                                                                        self.idle_timeout = None

                                                                                                        self.flow_keys = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                        self.flow_keys.parent = self
                                                                                                        self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                        self._segment_path = lambda: "flow-key-data"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['max_count', 'idle_timeout'], name, value)


                                                                                                    class FlowKeys(Entity):
                                                                                                        """
                                                                                                        flow keys
                                                                                                        
                                                                                                        .. attribute:: keys
                                                                                                        
                                                                                                        	keys
                                                                                                        	**type**\: str
                                                                                                        
                                                                                                        	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                        
                                                                                                        .. attribute:: num
                                                                                                        
                                                                                                        	num
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                            self.yang_name = "flow-keys"
                                                                                                            self.yang_parent_name = "flow-key-data"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('keys', (YLeaf(YType.str, 'keys'), ['str'])),
                                                                                                                ('num', (YLeaf(YType.uint8, 'num'), ['int'])),
                                                                                                            ])
                                                                                                            self.keys = None
                                                                                                            self.num = None
                                                                                                            self._segment_path = lambda: "flow-keys"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                                class DhcpClientId(Entity):
                                                                                                    """
                                                                                                    Dhcp Client ID
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                        self.yang_name = "dhcp-client-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "dhcp-client-id"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                                class DhcpClientIdRegex(Entity):
                                                                                                    """
                                                                                                    Dhcp Client ID RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                        self.yang_name = "dhcp-client-id-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "dhcp-client-id-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                                class CircuitId(Entity):
                                                                                                    """
                                                                                                    Circuit ID
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                        self.yang_name = "circuit-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "circuit-id"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                                class CircuitIdRegex(Entity):
                                                                                                    """
                                                                                                    Circuit ID RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                        self.yang_name = "circuit-id-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "circuit-id-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                                class RemoteId(Entity):
                                                                                                    """
                                                                                                    Remote ID
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                        self.yang_name = "remote-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "remote-id"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                                class RemoteIdRegex(Entity):
                                                                                                    """
                                                                                                    Remote ID RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\: list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                        self.yang_name = "remote-id-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                        ])
                                                                                                        self.string_array = []
                                                                                                        self._segment_path = lambda: "remote-id-regex"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                                class SrcPort(Entity):
                                                                                                    """
                                                                                                    Source port
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                        self.yang_name = "src-port"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "src-port"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "src-port"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                                                class DstPort(Entity):
                                                                                                    """
                                                                                                    Destination port
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                        self.yang_name = "dst-port"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray))])
                                                                                                        self._leafs = OrderedDict()

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "dst-port"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\: int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2018-01-17'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "dst-port"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self.ylist_key_names = []
                                                                                                            self._child_classes = OrderedDict([])
                                                                                                            self._leafs = OrderedDict([
                                                                                                                ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                                ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ])
                                                                                                            self.min = None
                                                                                                            self.max = None
                                                                                                            self._segment_path = lambda: "uint16_rng_array"
                                                                                                            self._is_frozen = True

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                        class Shape(Entity):
                                                                            """
                                                                            shape
                                                                            
                                                                            .. attribute:: bw
                                                                            
                                                                            	bw
                                                                            	**type**\:  :py:class:`Bw <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw>`
                                                                            
                                                                            .. attribute:: be
                                                                            
                                                                            	be
                                                                            	**type**\:  :py:class:`Be <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape, self).__init__()

                                                                                self.yang_name = "shape"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("bw", ("bw", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw)), ("be", ("be", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be))])
                                                                                self._leafs = OrderedDict()

                                                                                self.bw = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw()
                                                                                self.bw.parent = self
                                                                                self._children_name_map["bw"] = "bw"

                                                                                self.be = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be()
                                                                                self.be.parent = self
                                                                                self._children_name_map["be"] = "be"
                                                                                self._segment_path = lambda: "shape"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape, [], name, value)


                                                                            class Bw(Entity):
                                                                                """
                                                                                bw
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw, self).__init__()

                                                                                    self.yang_name = "bw"
                                                                                    self.yang_parent_name = "shape"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.unit = None
                                                                                    self._segment_path = lambda: "bw"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw, ['value', 'unit'], name, value)


                                                                            class Be(Entity):
                                                                                """
                                                                                be
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be, self).__init__()

                                                                                    self.yang_name = "be"
                                                                                    self.yang_parent_name = "shape"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.unit = None
                                                                                    self._segment_path = lambda: "be"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be, ['value', 'unit'], name, value)


                                                                        class ChildPolicy(Entity):
                                                                            """
                                                                            child policy
                                                                            
                                                                            .. attribute:: info
                                                                            
                                                                            	info
                                                                            	**type**\:  :py:class:`Info <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info>`
                                                                            
                                                                            .. attribute:: hd_info
                                                                            
                                                                            	hd info
                                                                            	**type**\:  :py:class:`HdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo>`
                                                                            
                                                                            .. attribute:: enc
                                                                            
                                                                            	enc
                                                                            	**type**\:  :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy, self).__init__()

                                                                                self.yang_name = "child-policy"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("info", ("info", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info)), ("hd-info", ("hd_info", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('enc', (YLeaf(YType.enumeration, 'enc'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyObjEncEn', '')])),
                                                                                ])
                                                                                self.enc = None

                                                                                self.info = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info()
                                                                                self.info.parent = self
                                                                                self._children_name_map["info"] = "info"

                                                                                self.hd_info = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo()
                                                                                self.hd_info.parent = self
                                                                                self._children_name_map["hd_info"] = "hd-info"
                                                                                self._segment_path = lambda: "child-policy"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy, ['enc'], name, value)


                                                                            class Info(Entity):
                                                                                """
                                                                                info
                                                                                
                                                                                .. attribute:: name
                                                                                
                                                                                	name
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..65
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:  :py:class:`PolicyMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyMapTypeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info, self).__init__()

                                                                                    self.yang_name = "info"
                                                                                    self.yang_parent_name = "child-policy"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyMapTypeEn', '')])),
                                                                                    ])
                                                                                    self.name = None
                                                                                    self.type = None
                                                                                    self._segment_path = lambda: "info"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info, ['name', 'type'], name, value)


                                                                            class HdInfo(Entity):
                                                                                """
                                                                                hd info
                                                                                
                                                                                .. attribute:: data_hd
                                                                                
                                                                                	data hd
                                                                                	**type**\:  :py:class:`DataHd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd>`
                                                                                
                                                                                .. attribute:: hd
                                                                                
                                                                                	hd
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..18446744073709551615
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo, self).__init__()

                                                                                    self.yang_name = "hd-info"
                                                                                    self.yang_parent_name = "child-policy"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("data-hd", ("data_hd", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('hd', (YLeaf(YType.uint64, 'hd'), ['int'])),
                                                                                    ])
                                                                                    self.hd = None

                                                                                    self.data_hd = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd()
                                                                                    self.data_hd.parent = self
                                                                                    self._children_name_map["data_hd"] = "data-hd"
                                                                                    self._segment_path = lambda: "hd-info"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo, ['hd'], name, value)


                                                                                class DataHd(Entity):
                                                                                    """
                                                                                    data hd
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd, self).__init__()

                                                                                        self.yang_name = "data-hd"
                                                                                        self.yang_parent_name = "hd-info"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict()
                                                                                        self._segment_path = lambda: "data-hd"
                                                                                        self._is_frozen = True


                                                                        class Cac(Entity):
                                                                            """
                                                                            cac
                                                                            
                                                                            .. attribute:: flow_rate
                                                                            
                                                                            	flow rate
                                                                            	**type**\:  :py:class:`FlowRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate>`
                                                                            
                                                                            .. attribute:: rate
                                                                            
                                                                            	rate
                                                                            	**type**\:  :py:class:`Rate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate>`
                                                                            
                                                                            .. attribute:: cac_type
                                                                            
                                                                            	cac type
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: idle_timeout
                                                                            
                                                                            	idle timeout
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac, self).__init__()

                                                                                self.yang_name = "cac"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("flow-rate", ("flow_rate", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate)), ("rate", ("rate", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('cac_type', (YLeaf(YType.uint8, 'cac-type'), ['int'])),
                                                                                    ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                                ])
                                                                                self.cac_type = None
                                                                                self.idle_timeout = None

                                                                                self.flow_rate = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate()
                                                                                self.flow_rate.parent = self
                                                                                self._children_name_map["flow_rate"] = "flow-rate"

                                                                                self.rate = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate()
                                                                                self.rate.parent = self
                                                                                self._children_name_map["rate"] = "rate"
                                                                                self._segment_path = lambda: "cac"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac, ['cac_type', 'idle_timeout'], name, value)


                                                                            class FlowRate(Entity):
                                                                                """
                                                                                flow rate
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate, self).__init__()

                                                                                    self.yang_name = "flow-rate"
                                                                                    self.yang_parent_name = "cac"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.unit = None
                                                                                    self._segment_path = lambda: "flow-rate"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate, ['value', 'unit'], name, value)


                                                                            class Rate(Entity):
                                                                                """
                                                                                rate
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate, self).__init__()

                                                                                    self.yang_name = "rate"
                                                                                    self.yang_parent_name = "cac"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.unit = None
                                                                                    self._segment_path = lambda: "rate"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate, ['value', 'unit'], name, value)


                                                                        class Pfc(Entity):
                                                                            """
                                                                            pfc
                                                                            
                                                                            .. attribute:: buffer_size
                                                                            
                                                                            	buffer size
                                                                            	**type**\:  :py:class:`BufferSize <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize>`
                                                                            
                                                                            .. attribute:: pause_threshold
                                                                            
                                                                            	pause threshold
                                                                            	**type**\:  :py:class:`PauseThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold>`
                                                                            
                                                                            .. attribute:: resume_threshold
                                                                            
                                                                            	resume threshold
                                                                            	**type**\:  :py:class:`ResumeThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold>`
                                                                            
                                                                            .. attribute:: pfc_pause_set
                                                                            
                                                                            	pfc pause set
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: buffer_size_flag
                                                                            
                                                                            	buffer size flag
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc, self).__init__()

                                                                                self.yang_name = "pfc"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("buffer-size", ("buffer_size", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize)), ("pause-threshold", ("pause_threshold", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold)), ("resume-threshold", ("resume_threshold", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('pfc_pause_set', (YLeaf(YType.uint32, 'pfc-pause-set'), ['int'])),
                                                                                    ('buffer_size_flag', (YLeaf(YType.uint32, 'buffer-size-flag'), ['int'])),
                                                                                ])
                                                                                self.pfc_pause_set = None
                                                                                self.buffer_size_flag = None

                                                                                self.buffer_size = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize()
                                                                                self.buffer_size.parent = self
                                                                                self._children_name_map["buffer_size"] = "buffer-size"

                                                                                self.pause_threshold = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold()
                                                                                self.pause_threshold.parent = self
                                                                                self._children_name_map["pause_threshold"] = "pause-threshold"

                                                                                self.resume_threshold = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold()
                                                                                self.resume_threshold.parent = self
                                                                                self._children_name_map["resume_threshold"] = "resume-threshold"
                                                                                self._segment_path = lambda: "pfc"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc, ['pfc_pause_set', 'buffer_size_flag'], name, value)


                                                                            class BufferSize(Entity):
                                                                                """
                                                                                buffer size
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize, self).__init__()

                                                                                    self.yang_name = "buffer-size"
                                                                                    self.yang_parent_name = "pfc"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.unit = None
                                                                                    self._segment_path = lambda: "buffer-size"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize, ['value', 'unit'], name, value)


                                                                            class PauseThreshold(Entity):
                                                                                """
                                                                                pause threshold
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold, self).__init__()

                                                                                    self.yang_name = "pause-threshold"
                                                                                    self.yang_parent_name = "pfc"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.unit = None
                                                                                    self._segment_path = lambda: "pause-threshold"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold, ['value', 'unit'], name, value)


                                                                            class ResumeThreshold(Entity):
                                                                                """
                                                                                resume threshold
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold, self).__init__()

                                                                                    self.yang_name = "resume-threshold"
                                                                                    self.yang_parent_name = "pfc"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.unit = None
                                                                                    self._segment_path = lambda: "resume-threshold"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold, ['value', 'unit'], name, value)


                                                                        class FlowParm(Entity):
                                                                            """
                                                                            flow parm
                                                                            
                                                                            .. attribute:: max_mon_flows
                                                                            
                                                                            	max simult flows monitored per policy class
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: mon_interval
                                                                            
                                                                            	monitored interval duration in secs
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**units**\: second
                                                                            
                                                                            .. attribute:: intvl_hist
                                                                            
                                                                            	num intervals of data stored on rtr
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: flow_timeout
                                                                            
                                                                            	timeout in secs
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**units**\: second
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm, self).__init__()

                                                                                self.yang_name = "flow-parm"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('max_mon_flows', (YLeaf(YType.uint32, 'max-mon-flows'), ['int'])),
                                                                                    ('mon_interval', (YLeaf(YType.uint32, 'mon-interval'), ['int'])),
                                                                                    ('intvl_hist', (YLeaf(YType.uint32, 'intvl-hist'), ['int'])),
                                                                                    ('flow_timeout', (YLeaf(YType.uint32, 'flow-timeout'), ['int'])),
                                                                                ])
                                                                                self.max_mon_flows = None
                                                                                self.mon_interval = None
                                                                                self.intvl_hist = None
                                                                                self.flow_timeout = None
                                                                                self._segment_path = lambda: "flow-parm"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm, ['max_mon_flows', 'mon_interval', 'intvl_hist', 'flow_timeout'], name, value)


                                                                        class Ipcbr(Entity):
                                                                            """
                                                                            ipcbr
                                                                            
                                                                            .. attribute:: ip_bit_rate
                                                                            
                                                                            	data rate in bps
                                                                            	**type**\:  :py:class:`IpBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate>`
                                                                            
                                                                            .. attribute:: media_bit_rate
                                                                            
                                                                            	media data rate in bps
                                                                            	**type**\:  :py:class:`MediaBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate>`
                                                                            
                                                                            .. attribute:: action_metric_type
                                                                            
                                                                            	metric type
                                                                            	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                            
                                                                            .. attribute:: ip_pkt_rate
                                                                            
                                                                            	packet rate in pps
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: media_pkt_size
                                                                            
                                                                            	media packet size in bytes
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: media_pkts_per_ip
                                                                            
                                                                            	media packets per ip pkt
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr, self).__init__()

                                                                                self.yang_name = "ipcbr"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("ip-bit-rate", ("ip_bit_rate", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate)), ("media-bit-rate", ("media_bit_rate", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                                    ('ip_pkt_rate', (YLeaf(YType.uint32, 'ip-pkt-rate'), ['int'])),
                                                                                    ('media_pkt_size', (YLeaf(YType.uint32, 'media-pkt-size'), ['int'])),
                                                                                    ('media_pkts_per_ip', (YLeaf(YType.uint32, 'media-pkts-per-ip'), ['int'])),
                                                                                ])
                                                                                self.action_metric_type = None
                                                                                self.ip_pkt_rate = None
                                                                                self.media_pkt_size = None
                                                                                self.media_pkts_per_ip = None

                                                                                self.ip_bit_rate = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate()
                                                                                self.ip_bit_rate.parent = self
                                                                                self._children_name_map["ip_bit_rate"] = "ip-bit-rate"

                                                                                self.media_bit_rate = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate()
                                                                                self.media_bit_rate.parent = self
                                                                                self._children_name_map["media_bit_rate"] = "media-bit-rate"
                                                                                self._segment_path = lambda: "ipcbr"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr, ['action_metric_type', 'ip_pkt_rate', 'media_pkt_size', 'media_pkts_per_ip'], name, value)


                                                                            class IpBitRate(Entity):
                                                                                """
                                                                                data rate in bps
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate, self).__init__()

                                                                                    self.yang_name = "ip-bit-rate"
                                                                                    self.yang_parent_name = "ipcbr"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.unit = None
                                                                                    self._segment_path = lambda: "ip-bit-rate"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate, ['value', 'unit'], name, value)


                                                                            class MediaBitRate(Entity):
                                                                                """
                                                                                media data rate in bps
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate, self).__init__()

                                                                                    self.yang_name = "media-bit-rate"
                                                                                    self.yang_parent_name = "ipcbr"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.unit = None
                                                                                    self._segment_path = lambda: "media-bit-rate"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate, ['value', 'unit'], name, value)


                                                                        class Rtp(Entity):
                                                                            """
                                                                            rtp
                                                                            
                                                                            .. attribute:: action_metric_type
                                                                            
                                                                            	metric type
                                                                            	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                            
                                                                            .. attribute:: min_sequential
                                                                            
                                                                            	min sequential
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: max_dropout
                                                                            
                                                                            	max dropout
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: max_misorder
                                                                            
                                                                            	max misorder
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: seq_ext_cop4
                                                                            
                                                                            	enable seq extension cop4
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: clock_rate
                                                                            
                                                                            	clock rate
                                                                            	**type**\: list of  		 :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp, self).__init__()

                                                                                self.yang_name = "rtp"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("clock-rate", ("clock_rate", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                                    ('min_sequential', (YLeaf(YType.uint32, 'min-sequential'), ['int'])),
                                                                                    ('max_dropout', (YLeaf(YType.uint32, 'max-dropout'), ['int'])),
                                                                                    ('max_misorder', (YLeaf(YType.uint32, 'max-misorder'), ['int'])),
                                                                                    ('seq_ext_cop4', (YLeaf(YType.uint32, 'seq-ext-cop4'), ['int'])),
                                                                                ])
                                                                                self.action_metric_type = None
                                                                                self.min_sequential = None
                                                                                self.max_dropout = None
                                                                                self.max_misorder = None
                                                                                self.seq_ext_cop4 = None

                                                                                self.clock_rate = YList(self)
                                                                                self._segment_path = lambda: "rtp"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp, ['action_metric_type', 'min_sequential', 'max_dropout', 'max_misorder', 'seq_ext_cop4'], name, value)


                                                                            class ClockRate(Entity):
                                                                                """
                                                                                clock rate
                                                                                
                                                                                .. attribute:: pt
                                                                                
                                                                                	pt
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: frequency
                                                                                
                                                                                	frequency
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate, self).__init__()

                                                                                    self.yang_name = "clock-rate"
                                                                                    self.yang_parent_name = "rtp"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('pt', (YLeaf(YType.uint32, 'pt'), ['int'])),
                                                                                        ('frequency', (YLeaf(YType.uint32, 'frequency'), ['int'])),
                                                                                    ])
                                                                                    self.pt = None
                                                                                    self.frequency = None
                                                                                    self._segment_path = lambda: "clock-rate"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate, ['pt', 'frequency'], name, value)


                                                                        class RtpMmr(Entity):
                                                                            """
                                                                            rtp mmr
                                                                            
                                                                            .. attribute:: action_metric_type
                                                                            
                                                                            	metric type
                                                                            	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                            
                                                                            .. attribute:: min_sequential
                                                                            
                                                                            	min sequential
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: max_dropout
                                                                            
                                                                            	max dropout
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: max_misorder
                                                                            
                                                                            	max misorder
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: seq_ext_cop4
                                                                            
                                                                            	enable seq extension cop4
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: clock_rate
                                                                            
                                                                            	clock rate
                                                                            	**type**\: list of  		 :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr, self).__init__()

                                                                                self.yang_name = "rtp-mmr"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("clock-rate", ("clock_rate", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                                    ('min_sequential', (YLeaf(YType.uint32, 'min-sequential'), ['int'])),
                                                                                    ('max_dropout', (YLeaf(YType.uint32, 'max-dropout'), ['int'])),
                                                                                    ('max_misorder', (YLeaf(YType.uint32, 'max-misorder'), ['int'])),
                                                                                    ('seq_ext_cop4', (YLeaf(YType.uint32, 'seq-ext-cop4'), ['int'])),
                                                                                ])
                                                                                self.action_metric_type = None
                                                                                self.min_sequential = None
                                                                                self.max_dropout = None
                                                                                self.max_misorder = None
                                                                                self.seq_ext_cop4 = None

                                                                                self.clock_rate = YList(self)
                                                                                self._segment_path = lambda: "rtp-mmr"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr, ['action_metric_type', 'min_sequential', 'max_dropout', 'max_misorder', 'seq_ext_cop4'], name, value)


                                                                            class ClockRate(Entity):
                                                                                """
                                                                                clock rate
                                                                                
                                                                                .. attribute:: pt
                                                                                
                                                                                	pt
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: frequency
                                                                                
                                                                                	frequency
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate, self).__init__()

                                                                                    self.yang_name = "clock-rate"
                                                                                    self.yang_parent_name = "rtp-mmr"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('pt', (YLeaf(YType.uint32, 'pt'), ['int'])),
                                                                                        ('frequency', (YLeaf(YType.uint32, 'frequency'), ['int'])),
                                                                                    ])
                                                                                    self.pt = None
                                                                                    self.frequency = None
                                                                                    self._segment_path = lambda: "clock-rate"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate, ['pt', 'frequency'], name, value)


                                                                        class RtpJ2k(Entity):
                                                                            """
                                                                            rtp j2k
                                                                            
                                                                            .. attribute:: action_metric_type
                                                                            
                                                                            	metric type
                                                                            	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                            
                                                                            .. attribute:: min_sequential
                                                                            
                                                                            	min sequential
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: max_dropout
                                                                            
                                                                            	max dropout
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: max_misorder
                                                                            
                                                                            	max misorder
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: seq_ext_cop4
                                                                            
                                                                            	enable seq extension cop4
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: clock_rate
                                                                            
                                                                            	clock rate
                                                                            	**type**\: list of  		 :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k.ClockRate>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k, self).__init__()

                                                                                self.yang_name = "rtp-j2k"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("clock-rate", ("clock_rate", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k.ClockRate))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                                    ('min_sequential', (YLeaf(YType.uint32, 'min-sequential'), ['int'])),
                                                                                    ('max_dropout', (YLeaf(YType.uint32, 'max-dropout'), ['int'])),
                                                                                    ('max_misorder', (YLeaf(YType.uint32, 'max-misorder'), ['int'])),
                                                                                    ('seq_ext_cop4', (YLeaf(YType.uint32, 'seq-ext-cop4'), ['int'])),
                                                                                ])
                                                                                self.action_metric_type = None
                                                                                self.min_sequential = None
                                                                                self.max_dropout = None
                                                                                self.max_misorder = None
                                                                                self.seq_ext_cop4 = None

                                                                                self.clock_rate = YList(self)
                                                                                self._segment_path = lambda: "rtp-j2k"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k, ['action_metric_type', 'min_sequential', 'max_dropout', 'max_misorder', 'seq_ext_cop4'], name, value)


                                                                            class ClockRate(Entity):
                                                                                """
                                                                                clock rate
                                                                                
                                                                                .. attribute:: pt
                                                                                
                                                                                	pt
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: frequency
                                                                                
                                                                                	frequency
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k.ClockRate, self).__init__()

                                                                                    self.yang_name = "clock-rate"
                                                                                    self.yang_parent_name = "rtp-j2k"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('pt', (YLeaf(YType.uint32, 'pt'), ['int'])),
                                                                                        ('frequency', (YLeaf(YType.uint32, 'frequency'), ['int'])),
                                                                                    ])
                                                                                    self.pt = None
                                                                                    self.frequency = None
                                                                                    self._segment_path = lambda: "clock-rate"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k.ClockRate, ['pt', 'frequency'], name, value)


                                                                        class RtpVoice(Entity):
                                                                            """
                                                                            rtp voice
                                                                            
                                                                            .. attribute:: action_metric_type
                                                                            
                                                                            	metric type
                                                                            	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                            
                                                                            .. attribute:: min_sequential
                                                                            
                                                                            	min sequential
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: max_dropout
                                                                            
                                                                            	max dropout
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: max_misorder
                                                                            
                                                                            	max misorder
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: seq_ext_cop4
                                                                            
                                                                            	enable seq extension cop4
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: clock_rate
                                                                            
                                                                            	clock rate
                                                                            	**type**\: list of  		 :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice, self).__init__()

                                                                                self.yang_name = "rtp-voice"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("clock-rate", ("clock_rate", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                                    ('min_sequential', (YLeaf(YType.uint32, 'min-sequential'), ['int'])),
                                                                                    ('max_dropout', (YLeaf(YType.uint32, 'max-dropout'), ['int'])),
                                                                                    ('max_misorder', (YLeaf(YType.uint32, 'max-misorder'), ['int'])),
                                                                                    ('seq_ext_cop4', (YLeaf(YType.uint32, 'seq-ext-cop4'), ['int'])),
                                                                                ])
                                                                                self.action_metric_type = None
                                                                                self.min_sequential = None
                                                                                self.max_dropout = None
                                                                                self.max_misorder = None
                                                                                self.seq_ext_cop4 = None

                                                                                self.clock_rate = YList(self)
                                                                                self._segment_path = lambda: "rtp-voice"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice, ['action_metric_type', 'min_sequential', 'max_dropout', 'max_misorder', 'seq_ext_cop4'], name, value)


                                                                            class ClockRate(Entity):
                                                                                """
                                                                                clock rate
                                                                                
                                                                                .. attribute:: pt
                                                                                
                                                                                	pt
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: frequency
                                                                                
                                                                                	frequency
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate, self).__init__()

                                                                                    self.yang_name = "clock-rate"
                                                                                    self.yang_parent_name = "rtp-voice"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('pt', (YLeaf(YType.uint32, 'pt'), ['int'])),
                                                                                        ('frequency', (YLeaf(YType.uint32, 'frequency'), ['int'])),
                                                                                    ])
                                                                                    self.pt = None
                                                                                    self.frequency = None
                                                                                    self._segment_path = lambda: "clock-rate"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate, ['pt', 'frequency'], name, value)


                                                                        class Mdi(Entity):
                                                                            """
                                                                            mdi
                                                                            
                                                                            .. attribute:: ip_bit_rate
                                                                            
                                                                            	data rate in bps
                                                                            	**type**\:  :py:class:`IpBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate>`
                                                                            
                                                                            .. attribute:: action_metric_type
                                                                            
                                                                            	metric type
                                                                            	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                            
                                                                            .. attribute:: filtered_pkt_rate
                                                                            
                                                                            	filtered packet rate
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: ip_pkt_rate
                                                                            
                                                                            	packet rate in pps
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: pids
                                                                            
                                                                            	array of monitoredcd  pids
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi, self).__init__()

                                                                                self.yang_name = "mdi"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("ip-bit-rate", ("ip_bit_rate", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                                    ('filtered_pkt_rate', (YLeaf(YType.uint32, 'filtered-pkt-rate'), ['int'])),
                                                                                    ('ip_pkt_rate', (YLeaf(YType.uint32, 'ip-pkt-rate'), ['int'])),
                                                                                    ('pids', (YLeafList(YType.uint32, 'pids'), ['int'])),
                                                                                ])
                                                                                self.action_metric_type = None
                                                                                self.filtered_pkt_rate = None
                                                                                self.ip_pkt_rate = None
                                                                                self.pids = []

                                                                                self.ip_bit_rate = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate()
                                                                                self.ip_bit_rate.parent = self
                                                                                self._children_name_map["ip_bit_rate"] = "ip-bit-rate"
                                                                                self._segment_path = lambda: "mdi"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi, ['action_metric_type', 'filtered_pkt_rate', 'ip_pkt_rate', 'pids'], name, value)


                                                                            class IpBitRate(Entity):
                                                                                """
                                                                                data rate in bps
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate, self).__init__()

                                                                                    self.yang_name = "ip-bit-rate"
                                                                                    self.yang_parent_name = "mdi"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.unit = None
                                                                                    self._segment_path = lambda: "ip-bit-rate"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate, ['value', 'unit'], name, value)


                                                                        class MdiRtp(Entity):
                                                                            """
                                                                            mdi rtp
                                                                            
                                                                            .. attribute:: ip_bit_rate
                                                                            
                                                                            	data rate in bps
                                                                            	**type**\:  :py:class:`IpBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate>`
                                                                            
                                                                            .. attribute:: action_metric_type
                                                                            
                                                                            	metric type
                                                                            	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                            
                                                                            .. attribute:: filtered_pkt_rate
                                                                            
                                                                            	filtered packet rate
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: ip_pkt_rate
                                                                            
                                                                            	packet rate in pps
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: pids
                                                                            
                                                                            	array of monitoredcd  pids
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp, self).__init__()

                                                                                self.yang_name = "mdi-rtp"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("ip-bit-rate", ("ip_bit_rate", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                                    ('filtered_pkt_rate', (YLeaf(YType.uint32, 'filtered-pkt-rate'), ['int'])),
                                                                                    ('ip_pkt_rate', (YLeaf(YType.uint32, 'ip-pkt-rate'), ['int'])),
                                                                                    ('pids', (YLeafList(YType.uint32, 'pids'), ['int'])),
                                                                                ])
                                                                                self.action_metric_type = None
                                                                                self.filtered_pkt_rate = None
                                                                                self.ip_pkt_rate = None
                                                                                self.pids = []

                                                                                self.ip_bit_rate = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate()
                                                                                self.ip_bit_rate.parent = self
                                                                                self._children_name_map["ip_bit_rate"] = "ip-bit-rate"
                                                                                self._segment_path = lambda: "mdi-rtp"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp, ['action_metric_type', 'filtered_pkt_rate', 'ip_pkt_rate', 'pids'], name, value)


                                                                            class IpBitRate(Entity):
                                                                                """
                                                                                data rate in bps
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate, self).__init__()

                                                                                    self.yang_name = "ip-bit-rate"
                                                                                    self.yang_parent_name = "mdi-rtp"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.unit = None
                                                                                    self._segment_path = lambda: "ip-bit-rate"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate, ['value', 'unit'], name, value)


                                                                        class Fmm(Entity):
                                                                            """
                                                                            fmm
                                                                            
                                                                            .. attribute:: fmm_name
                                                                            
                                                                            	flow monitor name
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..33
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm, self).__init__()

                                                                                self.yang_name = "fmm"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('fmm_name', (YLeaf(YType.str, 'fmm-name'), ['str'])),
                                                                                ])
                                                                                self.fmm_name = None
                                                                                self._segment_path = lambda: "fmm"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm, ['fmm_name'], name, value)


                                                                        class Pbf(Entity):
                                                                            """
                                                                            pbf
                                                                            
                                                                            .. attribute:: action_pbf_info_array
                                                                            
                                                                            	action pbf info array
                                                                            	**type**\: list of  		 :py:class:`ActionPbfInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf, self).__init__()

                                                                                self.yang_name = "pbf"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("action-pbf-info-array", ("action_pbf_info_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.action_pbf_info_array = YList(self)
                                                                                self._segment_path = lambda: "pbf"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf, [], name, value)


                                                                            class ActionPbfInfoArray(Entity):
                                                                                """
                                                                                action pbf info array
                                                                                
                                                                                .. attribute:: addr
                                                                                
                                                                                	v4 or v6 address
                                                                                	**type**\: str
                                                                                
                                                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                
                                                                                .. attribute:: vrf
                                                                                
                                                                                	vrf name
                                                                                	**type**\: str
                                                                                
                                                                                .. attribute:: rt_type
                                                                                
                                                                                	route target type
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: rt
                                                                                
                                                                                	route target
                                                                                	**type**\: str
                                                                                
                                                                                	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray, self).__init__()

                                                                                    self.yang_name = "action-pbf-info-array"
                                                                                    self.yang_parent_name = "pbf"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('addr', (YLeaf(YType.str, 'addr'), ['str'])),
                                                                                        ('vrf', (YLeaf(YType.str, 'vrf'), ['str'])),
                                                                                        ('rt_type', (YLeaf(YType.uint8, 'rt-type'), ['int'])),
                                                                                        ('rt', (YLeaf(YType.str, 'rt'), ['str'])),
                                                                                    ])
                                                                                    self.addr = None
                                                                                    self.vrf = None
                                                                                    self.rt_type = None
                                                                                    self.rt = None
                                                                                    self._segment_path = lambda: "action-pbf-info-array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray, ['addr', 'vrf', 'rt_type', 'rt'], name, value)


                                                                        class Ipv4Nh(Entity):
                                                                            """
                                                                            ipv4 nh
                                                                            
                                                                            .. attribute:: action_ipv4_nh_info_array
                                                                            
                                                                            	action ipv4 nh info array
                                                                            	**type**\: list of  		 :py:class:`ActionIpv4NhInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh, self).__init__()

                                                                                self.yang_name = "ipv4-nh"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("action-ipv4-nh-info-array", ("action_ipv4_nh_info_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.action_ipv4_nh_info_array = YList(self)
                                                                                self._segment_path = lambda: "ipv4-nh"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh, [], name, value)


                                                                            class ActionIpv4NhInfoArray(Entity):
                                                                                """
                                                                                action ipv4 nh info array
                                                                                
                                                                                .. attribute:: nh_addr
                                                                                
                                                                                	nh addr
                                                                                	**type**\: str
                                                                                
                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                
                                                                                .. attribute:: vrf_name
                                                                                
                                                                                	Vrf name
                                                                                	**type**\: str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray, self).__init__()

                                                                                    self.yang_name = "action-ipv4-nh-info-array"
                                                                                    self.yang_parent_name = "ipv4-nh"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('nh_addr', (YLeaf(YType.str, 'nh-addr'), ['str'])),
                                                                                        ('vrf_name', (YLeaf(YType.str, 'vrf-name'), ['str'])),
                                                                                    ])
                                                                                    self.nh_addr = None
                                                                                    self.vrf_name = None
                                                                                    self._segment_path = lambda: "action-ipv4-nh-info-array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray, ['nh_addr', 'vrf_name'], name, value)


                                                                        class Ipv6Nh(Entity):
                                                                            """
                                                                            ipv6 nh
                                                                            
                                                                            .. attribute:: action_ipv6_nh_info_array
                                                                            
                                                                            	action ipv6 nh info array
                                                                            	**type**\: list of  		 :py:class:`ActionIpv6NhInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh, self).__init__()

                                                                                self.yang_name = "ipv6-nh"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("action-ipv6-nh-info-array", ("action_ipv6_nh_info_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.action_ipv6_nh_info_array = YList(self)
                                                                                self._segment_path = lambda: "ipv6-nh"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh, [], name, value)


                                                                            class ActionIpv6NhInfoArray(Entity):
                                                                                """
                                                                                action ipv6 nh info array
                                                                                
                                                                                .. attribute:: nh_addr
                                                                                
                                                                                	IPV6 Address
                                                                                	**type**\: str
                                                                                
                                                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                
                                                                                .. attribute:: vrf_name
                                                                                
                                                                                	Vrf name
                                                                                	**type**\: str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray, self).__init__()

                                                                                    self.yang_name = "action-ipv6-nh-info-array"
                                                                                    self.yang_parent_name = "ipv6-nh"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('nh_addr', (YLeaf(YType.str, 'nh-addr'), ['str'])),
                                                                                        ('vrf_name', (YLeaf(YType.str, 'vrf-name'), ['str'])),
                                                                                    ])
                                                                                    self.nh_addr = None
                                                                                    self.vrf_name = None
                                                                                    self._segment_path = lambda: "action-ipv6-nh-info-array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray, ['nh_addr', 'vrf_name'], name, value)


                                class Definition(Entity):
                                    """
                                    Transient Policy\-map type name
                                    
                                    .. attribute:: policy_map_bg
                                    
                                    	policy map bg
                                    	**type**\: list of  		 :py:class:`PolicyMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg>`
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2018-01-17'

                                    def __init__(self):
                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition, self).__init__()

                                        self.yang_name = "definition"
                                        self.yang_parent_name = "transient-policy-map-name"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("policy-map-bg", ("policy_map_bg", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg))])
                                        self._leafs = OrderedDict()

                                        self.policy_map_bg = YList(self)
                                        self._segment_path = lambda: "definition"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition, [], name, value)


                                    class PolicyMapBg(Entity):
                                        """
                                        policy map bg
                                        
                                        .. attribute:: pmap_var_list
                                        
                                        	pmap var list
                                        	**type**\:  :py:class:`PmapVarList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.PmapVarList>`
                                        
                                        .. attribute:: event_infop
                                        
                                        	event infop
                                        	**type**\:  :py:class:`EventInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop>`
                                        
                                        .. attribute:: name
                                        
                                        	name
                                        	**type**\: str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: type
                                        
                                        	type
                                        	**type**\:  :py:class:`PolicyMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyMapTypeEn>`
                                        
                                        .. attribute:: description
                                        
                                        	description
                                        	**type**\: str
                                        
                                        

                                        """

                                        _prefix = 'infra-policymgr-oper'
                                        _revision = '2018-01-17'

                                        def __init__(self):
                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg, self).__init__()

                                            self.yang_name = "policy-map-bg"
                                            self.yang_parent_name = "definition"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("pmap-var-list", ("pmap_var_list", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.PmapVarList)), ("event-infop", ("event_infop", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop))])
                                            self._leafs = OrderedDict([
                                                ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyMapTypeEn', '')])),
                                                ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                            ])
                                            self.name = None
                                            self.type = None
                                            self.description = None

                                            self.pmap_var_list = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.PmapVarList()
                                            self.pmap_var_list.parent = self
                                            self._children_name_map["pmap_var_list"] = "pmap-var-list"

                                            self.event_infop = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop()
                                            self.event_infop.parent = self
                                            self._children_name_map["event_infop"] = "event-infop"
                                            self._segment_path = lambda: "policy-map-bg"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg, ['name', 'type', 'description'], name, value)


                                        class PmapVarList(Entity):
                                            """
                                            pmap var list
                                            
                                            .. attribute:: pmap_var_list_arr
                                            
                                            	pmap var list arr
                                            	**type**\: list of  		 :py:class:`PmapVarListArr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.PmapVarList.PmapVarListArr>`
                                            
                                            

                                            """

                                            _prefix = 'infra-policymgr-oper'
                                            _revision = '2018-01-17'

                                            def __init__(self):
                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.PmapVarList, self).__init__()

                                                self.yang_name = "pmap-var-list"
                                                self.yang_parent_name = "policy-map-bg"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("pmap-var-list-arr", ("pmap_var_list_arr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.PmapVarList.PmapVarListArr))])
                                                self._leafs = OrderedDict()

                                                self.pmap_var_list_arr = YList(self)
                                                self._segment_path = lambda: "pmap-var-list"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.PmapVarList, [], name, value)


                                            class PmapVarListArr(Entity):
                                                """
                                                pmap var list arr
                                                
                                                .. attribute:: val
                                                
                                                	val
                                                	**type**\:  :py:class:`Val <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.PmapVarList.PmapVarListArr.Val>`
                                                
                                                .. attribute:: name
                                                
                                                	name
                                                	**type**\: str
                                                
                                                	**length:** 0..32
                                                
                                                .. attribute:: id
                                                
                                                	id
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.PmapVarList.PmapVarListArr, self).__init__()

                                                    self.yang_name = "pmap-var-list-arr"
                                                    self.yang_parent_name = "pmap-var-list"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("val", ("val", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.PmapVarList.PmapVarListArr.Val))])
                                                    self._leafs = OrderedDict([
                                                        ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                        ('id', (YLeaf(YType.uint32, 'id'), ['int'])),
                                                    ])
                                                    self.name = None
                                                    self.id = None

                                                    self.val = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.PmapVarList.PmapVarListArr.Val()
                                                    self.val.parent = self
                                                    self._children_name_map["val"] = "val"
                                                    self._segment_path = lambda: "pmap-var-list-arr"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.PmapVarList.PmapVarListArr, ['name', 'id'], name, value)


                                                class Val(Entity):
                                                    """
                                                    val
                                                    
                                                    .. attribute:: type
                                                    
                                                    	type
                                                    	**type**\:  :py:class:`PlmgrVarTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrVarTypeEn>`
                                                    
                                                    .. attribute:: class_name
                                                    
                                                    	class name
                                                    	**type**\: str
                                                    
                                                    	**length:** 0..65
                                                    
                                                    .. attribute:: uint8_val
                                                    
                                                    	uint8 val
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: uint16_val
                                                    
                                                    	uint16 val
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: uint32_val
                                                    
                                                    	uint32 val
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: param_uint32_val
                                                    
                                                    	param uint32 val
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: dscp_val
                                                    
                                                    	dscp val
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: prec_val
                                                    
                                                    	prec val
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.PmapVarList.PmapVarListArr.Val, self).__init__()

                                                        self.yang_name = "val"
                                                        self.yang_parent_name = "pmap-var-list-arr"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PlmgrVarTypeEn', '')])),
                                                            ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                            ('uint8_val', (YLeaf(YType.uint8, 'uint8_val'), ['int'])),
                                                            ('uint16_val', (YLeaf(YType.uint16, 'uint16_val'), ['int'])),
                                                            ('uint32_val', (YLeaf(YType.uint32, 'uint32_val'), ['int'])),
                                                            ('param_uint32_val', (YLeaf(YType.uint32, 'param-uint32-val'), ['int'])),
                                                            ('dscp_val', (YLeaf(YType.uint8, 'dscp-val'), ['int'])),
                                                            ('prec_val', (YLeaf(YType.uint8, 'prec-val'), ['int'])),
                                                        ])
                                                        self.type = None
                                                        self.class_name = None
                                                        self.uint8_val = None
                                                        self.uint16_val = None
                                                        self.uint32_val = None
                                                        self.param_uint32_val = None
                                                        self.dscp_val = None
                                                        self.prec_val = None
                                                        self._segment_path = lambda: "val"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.PmapVarList.PmapVarListArr.Val, ['type', 'class_name', 'uint8_val', 'uint16_val', 'uint32_val', 'param_uint32_val', 'dscp_val', 'prec_val'], name, value)


                                        class EventInfop(Entity):
                                            """
                                            event infop
                                            
                                            .. attribute:: policy_event_info_bg
                                            
                                            	policy event info bg
                                            	**type**\: list of  		 :py:class:`PolicyEventInfoBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg>`
                                            
                                            

                                            """

                                            _prefix = 'infra-policymgr-oper'
                                            _revision = '2018-01-17'

                                            def __init__(self):
                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop, self).__init__()

                                                self.yang_name = "event-infop"
                                                self.yang_parent_name = "policy-map-bg"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("policy-event-info-bg", ("policy_event_info_bg", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg))])
                                                self._leafs = OrderedDict()

                                                self.policy_event_info_bg = YList(self)
                                                self._segment_path = lambda: "event-infop"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop, [], name, value)


                                            class PolicyEventInfoBg(Entity):
                                                """
                                                policy event info bg
                                                
                                                .. attribute:: class_infop
                                                
                                                	class infop
                                                	**type**\:  :py:class:`ClassInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop>`
                                                
                                                .. attribute:: event_type
                                                
                                                	event type
                                                	**type**\:  :py:class:`PeventTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PeventTypeEn>`
                                                
                                                .. attribute:: cond_eval
                                                
                                                	cond eval
                                                	**type**\:  :py:class:`PeventCondEvalEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PeventCondEvalEn>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg, self).__init__()

                                                    self.yang_name = "policy-event-info-bg"
                                                    self.yang_parent_name = "event-infop"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("class-infop", ("class_infop", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop))])
                                                    self._leafs = OrderedDict([
                                                        ('event_type', (YLeaf(YType.enumeration, 'event-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PeventTypeEn', '')])),
                                                        ('cond_eval', (YLeaf(YType.enumeration, 'cond-eval'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PeventCondEvalEn', '')])),
                                                    ])
                                                    self.event_type = None
                                                    self.cond_eval = None

                                                    self.class_infop = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop()
                                                    self.class_infop.parent = self
                                                    self._children_name_map["class_infop"] = "class-infop"
                                                    self._segment_path = lambda: "policy-event-info-bg"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg, ['event_type', 'cond_eval'], name, value)


                                                class ClassInfop(Entity):
                                                    """
                                                    class infop
                                                    
                                                    .. attribute:: policy_class_info_bg
                                                    
                                                    	policy class info bg
                                                    	**type**\: list of  		 :py:class:`PolicyClassInfoBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop, self).__init__()

                                                        self.yang_name = "class-infop"
                                                        self.yang_parent_name = "policy-event-info-bg"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("policy-class-info-bg", ("policy_class_info_bg", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg))])
                                                        self._leafs = OrderedDict()

                                                        self.policy_class_info_bg = YList(self)
                                                        self._segment_path = lambda: "class-infop"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop, [], name, value)


                                                    class PolicyClassInfoBg(Entity):
                                                        """
                                                        policy class info bg
                                                        
                                                        .. attribute:: cl_encode
                                                        
                                                        	cl encode
                                                        	**type**\:  :py:class:`ClEncode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode>`
                                                        
                                                        .. attribute:: clmp_p
                                                        
                                                        	clmp p
                                                        	**type**\:  :py:class:`ClmpP <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP>`
                                                        
                                                        .. attribute:: act_infop
                                                        
                                                        	act infop
                                                        	**type**\:  :py:class:`ActInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop>`
                                                        
                                                        .. attribute:: policy_class_hd
                                                        
                                                        	policy class hd
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: seq
                                                        
                                                        	seq
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: flags
                                                        
                                                        	flags
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: ctype
                                                        
                                                        	ctype
                                                        	**type**\:  :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                        
                                                        .. attribute:: num_actions
                                                        
                                                        	num actions
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: version
                                                        
                                                        	version
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        .. attribute:: exe_strat
                                                        
                                                        	exe strat
                                                        	**type**\:  :py:class:`PclassExecStratEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PclassExecStratEn>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2018-01-17'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg, self).__init__()

                                                            self.yang_name = "policy-class-info-bg"
                                                            self.yang_parent_name = "class-infop"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("cl-encode", ("cl_encode", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode)), ("clmp-p", ("clmp_p", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP)), ("act-infop", ("act_infop", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop))])
                                                            self._leafs = OrderedDict([
                                                                ('policy_class_hd', (YLeaf(YType.uint32, 'policy-class-hd'), ['int'])),
                                                                ('seq', (YLeaf(YType.uint32, 'seq'), ['int'])),
                                                                ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                ('ctype', (YLeaf(YType.enumeration, 'ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapTypeEn', '')])),
                                                                ('num_actions', (YLeaf(YType.uint16, 'num-actions'), ['int'])),
                                                                ('version', (YLeaf(YType.uint8, 'version'), ['int'])),
                                                                ('exe_strat', (YLeaf(YType.enumeration, 'exe-strat'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PclassExecStratEn', '')])),
                                                            ])
                                                            self.policy_class_hd = None
                                                            self.seq = None
                                                            self.flags = None
                                                            self.ctype = None
                                                            self.num_actions = None
                                                            self.version = None
                                                            self.exe_strat = None

                                                            self.cl_encode = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode()
                                                            self.cl_encode.parent = self
                                                            self._children_name_map["cl_encode"] = "cl-encode"

                                                            self.clmp_p = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP()
                                                            self.clmp_p.parent = self
                                                            self._children_name_map["clmp_p"] = "clmp-p"

                                                            self.act_infop = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop()
                                                            self.act_infop.parent = self
                                                            self._children_name_map["act_infop"] = "act-infop"
                                                            self._segment_path = lambda: "policy-class-info-bg"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg, ['policy_class_hd', 'seq', 'flags', 'ctype', 'num_actions', 'version', 'exe_strat'], name, value)


                                                        class ClEncode(Entity):
                                                            """
                                                            cl encode
                                                            
                                                            .. attribute:: inline_cmap
                                                            
                                                            	inline cmap
                                                            	**type**\:  :py:class:`InlineCmap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap>`
                                                            
                                                            .. attribute:: enc
                                                            
                                                            	enc
                                                            	**type**\:  :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                            
                                                            .. attribute:: class_name
                                                            
                                                            	class name
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..65
                                                            
                                                            .. attribute:: hd
                                                            
                                                            	hd
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: idx
                                                            
                                                            	idx
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..255
                                                            
                                                            

                                                            """

                                                            _prefix = 'infra-policymgr-oper'
                                                            _revision = '2018-01-17'

                                                            def __init__(self):
                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode, self).__init__()

                                                                self.yang_name = "cl-encode"
                                                                self.yang_parent_name = "policy-class-info-bg"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("inline-cmap", ("inline_cmap", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap))])
                                                                self._leafs = OrderedDict([
                                                                    ('enc', (YLeaf(YType.enumeration, 'enc'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyObjEncEn', '')])),
                                                                    ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                                    ('hd', (YLeaf(YType.uint64, 'hd'), ['int'])),
                                                                    ('idx', (YLeaf(YType.uint8, 'idx'), ['int'])),
                                                                ])
                                                                self.enc = None
                                                                self.class_name = None
                                                                self.hd = None
                                                                self.idx = None

                                                                self.inline_cmap = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap()
                                                                self.inline_cmap.parent = self
                                                                self._children_name_map["inline_cmap"] = "inline-cmap"
                                                                self._segment_path = lambda: "cl-encode"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode, ['enc', 'class_name', 'hd', 'idx'], name, value)


                                                            class InlineCmap(Entity):
                                                                """
                                                                inline cmap
                                                                
                                                                .. attribute:: match_infop
                                                                
                                                                	Pointer to the first Match info
                                                                	**type**\:  :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop>`
                                                                
                                                                .. attribute:: mode
                                                                
                                                                	Inline Class\-Map Mode Match any/all
                                                                	**type**\:  :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                
                                                                .. attribute:: flags
                                                                
                                                                	Inline Class\-Map flags
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: match_count
                                                                
                                                                	Number of Match infos
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap, self).__init__()

                                                                    self.yang_name = "inline-cmap"
                                                                    self.yang_parent_name = "cl-encode"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("match-infop", ("match_infop", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop))])
                                                                    self._leafs = OrderedDict([
                                                                        ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapModeEn', '')])),
                                                                        ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                        ('match_count', (YLeaf(YType.uint32, 'match-count'), ['int'])),
                                                                    ])
                                                                    self.mode = None
                                                                    self.flags = None
                                                                    self.match_count = None

                                                                    self.match_infop = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop()
                                                                    self.match_infop.parent = self
                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                    self._segment_path = lambda: "inline-cmap"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap, ['mode', 'flags', 'match_count'], name, value)


                                                                class MatchInfop(Entity):
                                                                    """
                                                                    Pointer to the first Match info
                                                                    
                                                                    .. attribute:: class_match_info_st
                                                                    
                                                                    	class match info st
                                                                    	**type**\: list of  		 :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop, self).__init__()

                                                                        self.yang_name = "match-infop"
                                                                        self.yang_parent_name = "inline-cmap"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("class-match-info-st", ("class_match_info_st", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt))])
                                                                        self._leafs = OrderedDict()

                                                                        self.class_match_info_st = YList(self)
                                                                        self._segment_path = lambda: "match-infop"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop, [], name, value)


                                                                    class ClassMatchInfoSt(Entity):
                                                                        """
                                                                        class match info st
                                                                        
                                                                        .. attribute:: match_data
                                                                        
                                                                        	Match criteria
                                                                        	**type**\:  :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                        
                                                                        .. attribute:: flags
                                                                        
                                                                        	Flags
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                            self.yang_name = "class-match-info-st"
                                                                            self.yang_parent_name = "match-infop"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("match-data", ("match_data", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData))])
                                                                            self._leafs = OrderedDict([
                                                                                ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                            ])
                                                                            self.flags = None

                                                                            self.match_data = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                            self.match_data.parent = self
                                                                            self._children_name_map["match_data"] = "match-data"
                                                                            self._segment_path = lambda: "class-match-info-st"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                        class MatchData(Entity):
                                                                            """
                                                                            Match criteria
                                                                            
                                                                            .. attribute:: ipv4_dscp
                                                                            
                                                                            	IPv4 DSCP
                                                                            	**type**\:  :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                            
                                                                            .. attribute:: ipv6_dscp
                                                                            
                                                                            	IPv6 DSCP
                                                                            	**type**\:  :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                            
                                                                            .. attribute:: dscp
                                                                            
                                                                            	Match DSCP range array
                                                                            	**type**\:  :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                            
                                                                            .. attribute:: ipv4_prec
                                                                            
                                                                            	IPv4 Precedence
                                                                            	**type**\:  :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                            
                                                                            .. attribute:: ipv6_prec
                                                                            
                                                                            	IPv6 Precedence
                                                                            	**type**\:  :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                            
                                                                            .. attribute:: prec
                                                                            
                                                                            	Match Precedence array
                                                                            	**type**\:  :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                            
                                                                            .. attribute:: discard_class
                                                                            
                                                                            	Match Discard Class array
                                                                            	**type**\:  :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                            
                                                                            .. attribute:: qos_group
                                                                            
                                                                            	Match QoS group array
                                                                            	**type**\:  :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                            
                                                                            .. attribute:: traffic_class
                                                                            
                                                                            	Match Traffic class array
                                                                            	**type**\:  :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                            
                                                                            .. attribute:: proto
                                                                            
                                                                            	Match Protocol array
                                                                            	**type**\:  :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                            
                                                                            .. attribute:: icmp_v4
                                                                            
                                                                            	Match ICMPV4 Protocol
                                                                            	**type**\:  :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                            
                                                                            .. attribute:: icmp_v6
                                                                            
                                                                            	Match ICMPV6 Protocol array
                                                                            	**type**\:  :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                            
                                                                            .. attribute:: ipv4_packet_len
                                                                            
                                                                            	IPv4 packet length array
                                                                            	**type**\:  :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                            
                                                                            .. attribute:: ipv6_packet_len
                                                                            
                                                                            	IPv6 packet length array
                                                                            	**type**\:  :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                            
                                                                            .. attribute:: packet_len
                                                                            
                                                                            	Match packet length array
                                                                            	**type**\:  :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                            
                                                                            .. attribute:: flow_tag
                                                                            
                                                                            	Match flow\-tag array
                                                                            	**type**\:  :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                            
                                                                            .. attribute:: tcp_flag
                                                                            
                                                                            	Match tcp flag value
                                                                            	**type**\:  :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                            
                                                                            .. attribute:: icmpv4_type
                                                                            
                                                                            	Match ipv4 icmp type
                                                                            	**type**\:  :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                            
                                                                            .. attribute:: icmpv4_code
                                                                            
                                                                            	Match ipv4 icmp code
                                                                            	**type**\:  :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                            
                                                                            .. attribute:: icmpv6_type
                                                                            
                                                                            	Match ipv6 icmp type
                                                                            	**type**\:  :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                            
                                                                            .. attribute:: icmpv6_code
                                                                            
                                                                            	Match ipv6 icmp code
                                                                            	**type**\:  :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                            
                                                                            .. attribute:: mpls_exp
                                                                            
                                                                            	Match MPLS experimental topmost array
                                                                            	**type**\:  :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                            
                                                                            .. attribute:: mpls_exp_imp
                                                                            
                                                                            	Match MPLS experimental imposition array
                                                                            	**type**\:  :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                            
                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                            
                                                                            	MPLS Disposition IPv4 Access\-list
                                                                            	**type**\:  :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                            
                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                            
                                                                            	MPLS Disposition IPv6 Access\-list
                                                                            	**type**\:  :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                            
                                                                            .. attribute:: mpls_top_label
                                                                            
                                                                            	MPLS Topmost LABEL
                                                                            	**type**\:  :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                            
                                                                            .. attribute:: cos
                                                                            
                                                                            	Match CoS array
                                                                            	**type**\:  :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                            
                                                                            .. attribute:: cos_inr
                                                                            
                                                                            	Match inner header CoS
                                                                            	**type**\:  :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                            
                                                                            .. attribute:: dei
                                                                            
                                                                            	Match DEI Bit
                                                                            	**type**\:  :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                            
                                                                            .. attribute:: dei_inr
                                                                            
                                                                            	Match inner DEI Bit
                                                                            	**type**\:  :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                            
                                                                            .. attribute:: vlan
                                                                            
                                                                            	Match VLAN array
                                                                            	**type**\:  :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                            
                                                                            .. attribute:: vlan_inr
                                                                            
                                                                            	Match inner header VLAN range array
                                                                            	**type**\:  :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                            
                                                                            .. attribute:: fr_dlci
                                                                            
                                                                            	Match FR DLCI range array
                                                                            	**type**\:  :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                            
                                                                            .. attribute:: src_mac
                                                                            
                                                                            	Match Source MAC address
                                                                            	**type**\:  :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                            
                                                                            .. attribute:: dst_mac
                                                                            
                                                                            	Match Destination MAC address
                                                                            	**type**\:  :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                            
                                                                            .. attribute:: atm_clp
                                                                            
                                                                            	Match ATM CLP level
                                                                            	**type**\:  :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                            
                                                                            .. attribute:: fr_de
                                                                            
                                                                            	Match FR DE value
                                                                            	**type**\:  :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                            
                                                                            .. attribute:: ipv4_acl
                                                                            
                                                                            	IPv4 Access\-list
                                                                            	**type**\:  :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                            
                                                                            .. attribute:: ipv6_acl
                                                                            
                                                                            	IPv6 Access\-list
                                                                            	**type**\:  :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                            
                                                                            .. attribute:: ether_service_acl
                                                                            
                                                                            	Ethernet\-Services Access\-list
                                                                            	**type**\:  :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                            
                                                                            .. attribute:: avail_id
                                                                            
                                                                            	Available Identifiers
                                                                            	**type**\:  :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                            
                                                                            .. attribute:: media_type
                                                                            
                                                                            	Media Type
                                                                            	**type**\:  :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                            
                                                                            .. attribute:: subs_protocol
                                                                            
                                                                            	Protocol
                                                                            	**type**\:  :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                            
                                                                            .. attribute:: dnis
                                                                            
                                                                            	DNIS
                                                                            	**type**\:  :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                            
                                                                            .. attribute:: dnis_regex
                                                                            
                                                                            	DNIS Regular Expression
                                                                            	**type**\:  :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                            
                                                                            .. attribute:: domain
                                                                            
                                                                            	Domain Name
                                                                            	**type**\:  :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                            
                                                                            .. attribute:: domain_regex
                                                                            
                                                                            	Domain Regular Expression
                                                                            	**type**\:  :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                            
                                                                            .. attribute:: nas_port
                                                                            
                                                                            	NAS Port
                                                                            	**type**\:  :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                            
                                                                            .. attribute:: service_name
                                                                            
                                                                            	Service Name
                                                                            	**type**\:  :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                            
                                                                            .. attribute:: service_name_regex
                                                                            
                                                                            	Service Name Regular Exp
                                                                            	**type**\:  :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                            
                                                                            .. attribute:: src_addr_ipv4
                                                                            
                                                                            	Source Address IPV4
                                                                            	**type**\:  :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                            
                                                                            .. attribute:: dst_addr_ipv4
                                                                            
                                                                            	Destination Address IPV4
                                                                            	**type**\:  :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                            
                                                                            .. attribute:: src_addr_ipv6
                                                                            
                                                                            	Source Address IPV6
                                                                            	**type**\:  :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                            
                                                                            .. attribute:: dst_addr_ipv6
                                                                            
                                                                            	Destination Address IPV6
                                                                            	**type**\:  :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                            
                                                                            .. attribute:: src_addr_mac
                                                                            
                                                                            	Source Address MAC
                                                                            	**type**\:  :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                            
                                                                            .. attribute:: timer
                                                                            
                                                                            	Timer
                                                                            	**type**\:  :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                            
                                                                            .. attribute:: timer_regexp
                                                                            
                                                                            	Timer Regular Expression
                                                                            	**type**\:  :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                            
                                                                            .. attribute:: tunnel_name
                                                                            
                                                                            	Tunnel Name
                                                                            	**type**\:  :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                            
                                                                            .. attribute:: tunnel_name_regex
                                                                            
                                                                            	Tunnel Name Regular Expression
                                                                            	**type**\:  :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                            
                                                                            .. attribute:: user_name
                                                                            
                                                                            	User Name
                                                                            	**type**\:  :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                            
                                                                            .. attribute:: user_name_regex
                                                                            
                                                                            	User Name Regular Expression
                                                                            	**type**\:  :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                            
                                                                            .. attribute:: auth_username
                                                                            
                                                                            	Authenticated User Name
                                                                            	**type**\:  :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                            
                                                                            .. attribute:: auth_username_regex
                                                                            
                                                                            	Authenticated User Name RegEx
                                                                            	**type**\:  :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                            
                                                                            .. attribute:: unauth_username
                                                                            
                                                                            	Unauthenticated User Name
                                                                            	**type**\:  :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                            
                                                                            .. attribute:: unauth_username_regex
                                                                            
                                                                            	Unauthenticated User Name RegEx
                                                                            	**type**\:  :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                            
                                                                            .. attribute:: auth_domain
                                                                            
                                                                            	Authenticated domain name
                                                                            	**type**\:  :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                            
                                                                            .. attribute:: auth_domain_regex
                                                                            
                                                                            	Authenticated Domain Name RegEx
                                                                            	**type**\:  :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                            
                                                                            .. attribute:: unauth_domain
                                                                            
                                                                            	Unauthenticated Domain Name
                                                                            	**type**\:  :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                            
                                                                            .. attribute:: unauth_domain_regex
                                                                            
                                                                            	Unauthenticated Domain Name RegEx
                                                                            	**type**\:  :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                            
                                                                            .. attribute:: vendor_id
                                                                            
                                                                            	Vendor ID
                                                                            	**type**\:  :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                            
                                                                            .. attribute:: vendor_id_regex
                                                                            
                                                                            	Vendor ID RegEx
                                                                            	**type**\:  :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                            
                                                                            .. attribute:: access_interface
                                                                            
                                                                            	Access interface
                                                                            	**type**\:  :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                            
                                                                            .. attribute:: input_interface
                                                                            
                                                                            	Input interface
                                                                            	**type**\:  :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                            
                                                                            .. attribute:: input_intfhdl
                                                                            
                                                                            	Input interface handle
                                                                            	**type**\:  :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                            
                                                                            .. attribute:: ethertype
                                                                            
                                                                            	Ethernet type
                                                                            	**type**\:  :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                            
                                                                            .. attribute:: flow_key_data
                                                                            
                                                                            	Flow key structure
                                                                            	**type**\:  :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                            
                                                                            .. attribute:: dhcp_client_id
                                                                            
                                                                            	Dhcp Client ID
                                                                            	**type**\:  :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                            
                                                                            .. attribute:: dhcp_client_id_regex
                                                                            
                                                                            	Dhcp Client ID RegEx
                                                                            	**type**\:  :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                            
                                                                            .. attribute:: circuit_id
                                                                            
                                                                            	Circuit ID
                                                                            	**type**\:  :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                            
                                                                            .. attribute:: circuit_id_regex
                                                                            
                                                                            	Circuit ID RegEx
                                                                            	**type**\:  :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                            
                                                                            .. attribute:: remote_id
                                                                            
                                                                            	Remote ID
                                                                            	**type**\:  :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                            
                                                                            .. attribute:: remote_id_regex
                                                                            
                                                                            	Remote ID RegEx
                                                                            	**type**\:  :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                            
                                                                            .. attribute:: src_port
                                                                            
                                                                            	Source port
                                                                            	**type**\:  :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                            
                                                                            .. attribute:: dst_port
                                                                            
                                                                            	Destination port
                                                                            	**type**\:  :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:  :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                            
                                                                            .. attribute:: mpls_top_eos
                                                                            
                                                                            	MPLS Topmost EOS
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: fragment_type
                                                                            
                                                                            	Fragment type
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: authen_status
                                                                            
                                                                            	Authentication Status
                                                                            	**type**\:  :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                            
                                                                            .. attribute:: mlp_negotiated
                                                                            
                                                                            	MLP Negotiated
                                                                            	**type**\:  :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                self.yang_name = "match-data"
                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("ipv4-dscp", ("ipv4_dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp)), ("ipv6-dscp", ("ipv6_dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp)), ("dscp", ("dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp)), ("ipv4-prec", ("ipv4_prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec)), ("ipv6-prec", ("ipv6_prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec)), ("prec", ("prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec)), ("discard-class", ("discard_class", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass)), ("qos-group", ("qos_group", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup)), ("traffic-class", ("traffic_class", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass)), ("proto", ("proto", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto)), ("icmp-v4", ("icmp_v4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4)), ("icmp-v6", ("icmp_v6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6)), ("ipv4-packet-len", ("ipv4_packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen)), ("ipv6-packet-len", ("ipv6_packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen)), ("packet-len", ("packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen)), ("flow-tag", ("flow_tag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag)), ("tcp-flag", ("tcp_flag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag)), ("icmpv4-type", ("icmpv4_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type)), ("icmpv4-code", ("icmpv4_code", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code)), ("icmpv6-type", ("icmpv6_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type)), ("icmpv6-code", ("icmpv6_code", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code)), ("mpls-exp", ("mpls_exp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp)), ("mpls-exp-imp", ("mpls_exp_imp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp)), ("mpls-disp-ipv4-acl", ("mpls_disp_ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl)), ("mpls-disp-ipv6-acl", ("mpls_disp_ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl)), ("mpls-top-label", ("mpls_top_label", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel)), ("cos", ("cos", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos)), ("cos-inr", ("cos_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr)), ("dei", ("dei", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei)), ("dei-inr", ("dei_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr)), ("vlan", ("vlan", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan)), ("vlan-inr", ("vlan_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)), ("fr-dlci", ("fr_dlci", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci)), ("src-mac", ("src_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac)), ("dst-mac", ("dst_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac)), ("atm-clp", ("atm_clp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp)), ("fr-de", ("fr_de", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe)), ("ipv4-acl", ("ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl)), ("ipv6-acl", ("ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl)), ("ether-service-acl", ("ether_service_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl)), ("avail-id", ("avail_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId)), ("media-type", ("media_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType)), ("subs-protocol", ("subs_protocol", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol)), ("dnis", ("dnis", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis)), ("dnis-regex", ("dnis_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex)), ("domain", ("domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain)), ("domain-regex", ("domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex)), ("nas-port", ("nas_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort)), ("service-name", ("service_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName)), ("service-name-regex", ("service_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex)), ("src-addr-ipv4", ("src_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4)), ("dst-addr-ipv4", ("dst_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4)), ("src-addr-ipv6", ("src_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6)), ("dst-addr-ipv6", ("dst_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6)), ("src-addr-mac", ("src_addr_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac)), ("timer", ("timer", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer)), ("timer-regexp", ("timer_regexp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp)), ("tunnel-name", ("tunnel_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName)), ("tunnel-name-regex", ("tunnel_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex)), ("user-name", ("user_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName)), ("user-name-regex", ("user_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex)), ("auth-username", ("auth_username", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername)), ("auth-username-regex", ("auth_username_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex)), ("unauth-username", ("unauth_username", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername)), ("unauth-username-regex", ("unauth_username_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex)), ("auth-domain", ("auth_domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain)), ("auth-domain-regex", ("auth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex)), ("unauth-domain", ("unauth_domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain)), ("unauth-domain-regex", ("unauth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex)), ("vendor-id", ("vendor_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId)), ("vendor-id-regex", ("vendor_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex)), ("access-interface", ("access_interface", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface)), ("input-interface", ("input_interface", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface)), ("input-intfhdl", ("input_intfhdl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl)), ("ethertype", ("ethertype", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype)), ("flow-key-data", ("flow_key_data", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData)), ("dhcp-client-id", ("dhcp_client_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId)), ("dhcp-client-id-regex", ("dhcp_client_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex)), ("circuit-id", ("circuit_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId)), ("circuit-id-regex", ("circuit_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex)), ("remote-id", ("remote_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId)), ("remote-id-regex", ("remote_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex)), ("src-port", ("src_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort)), ("dst-port", ("dst_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchTypeEn', '')])),
                                                                                    ('mpls_top_eos', (YLeaf(YType.uint8, 'mpls-top-eos'), ['int'])),
                                                                                    ('fragment_type', (YLeaf(YType.uint8, 'fragment-type'), ['int'])),
                                                                                    ('authen_status', (YLeaf(YType.enumeration, 'authen-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchAuthenStatusEn', '')])),
                                                                                    ('mlp_negotiated', (YLeaf(YType.enumeration, 'mlp-negotiated'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchMlpNegotiatedEn', '')])),
                                                                                ])
                                                                                self.type = None
                                                                                self.mpls_top_eos = None
                                                                                self.fragment_type = None
                                                                                self.authen_status = None
                                                                                self.mlp_negotiated = None

                                                                                self.ipv4_dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                self.ipv4_dscp.parent = self
                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"

                                                                                self.ipv6_dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                self.ipv6_dscp.parent = self
                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"

                                                                                self.dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                self.dscp.parent = self
                                                                                self._children_name_map["dscp"] = "dscp"

                                                                                self.ipv4_prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                self.ipv4_prec.parent = self
                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"

                                                                                self.ipv6_prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                self.ipv6_prec.parent = self
                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"

                                                                                self.prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                self.prec.parent = self
                                                                                self._children_name_map["prec"] = "prec"

                                                                                self.discard_class = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                self.discard_class.parent = self
                                                                                self._children_name_map["discard_class"] = "discard-class"

                                                                                self.qos_group = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                self.qos_group.parent = self
                                                                                self._children_name_map["qos_group"] = "qos-group"

                                                                                self.traffic_class = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                self.traffic_class.parent = self
                                                                                self._children_name_map["traffic_class"] = "traffic-class"

                                                                                self.proto = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                self.proto.parent = self
                                                                                self._children_name_map["proto"] = "proto"

                                                                                self.icmp_v4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                self.icmp_v4.parent = self
                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"

                                                                                self.icmp_v6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                self.icmp_v6.parent = self
                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"

                                                                                self.ipv4_packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                self.ipv4_packet_len.parent = self
                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"

                                                                                self.ipv6_packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                self.ipv6_packet_len.parent = self
                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"

                                                                                self.packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                self.packet_len.parent = self
                                                                                self._children_name_map["packet_len"] = "packet-len"

                                                                                self.flow_tag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                self.flow_tag.parent = self
                                                                                self._children_name_map["flow_tag"] = "flow-tag"

                                                                                self.tcp_flag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                self.tcp_flag.parent = self
                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"

                                                                                self.icmpv4_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                self.icmpv4_type.parent = self
                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"

                                                                                self.icmpv4_code = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                self.icmpv4_code.parent = self
                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"

                                                                                self.icmpv6_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                self.icmpv6_type.parent = self
                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"

                                                                                self.icmpv6_code = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                self.icmpv6_code.parent = self
                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"

                                                                                self.mpls_exp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                self.mpls_exp.parent = self
                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"

                                                                                self.mpls_exp_imp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                self.mpls_exp_imp.parent = self
                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"

                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"

                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"

                                                                                self.mpls_top_label = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                self.mpls_top_label.parent = self
                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"

                                                                                self.cos = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                self.cos.parent = self
                                                                                self._children_name_map["cos"] = "cos"

                                                                                self.cos_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                self.cos_inr.parent = self
                                                                                self._children_name_map["cos_inr"] = "cos-inr"

                                                                                self.dei = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                self.dei.parent = self
                                                                                self._children_name_map["dei"] = "dei"

                                                                                self.dei_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                self.dei_inr.parent = self
                                                                                self._children_name_map["dei_inr"] = "dei-inr"

                                                                                self.vlan = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                self.vlan.parent = self
                                                                                self._children_name_map["vlan"] = "vlan"

                                                                                self.vlan_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                self.vlan_inr.parent = self
                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"

                                                                                self.fr_dlci = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                self.fr_dlci.parent = self
                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"

                                                                                self.src_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                self.src_mac.parent = self
                                                                                self._children_name_map["src_mac"] = "src-mac"

                                                                                self.dst_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                self.dst_mac.parent = self
                                                                                self._children_name_map["dst_mac"] = "dst-mac"

                                                                                self.atm_clp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                self.atm_clp.parent = self
                                                                                self._children_name_map["atm_clp"] = "atm-clp"

                                                                                self.fr_de = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                self.fr_de.parent = self
                                                                                self._children_name_map["fr_de"] = "fr-de"

                                                                                self.ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                self.ipv4_acl.parent = self
                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"

                                                                                self.ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                self.ipv6_acl.parent = self
                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"

                                                                                self.ether_service_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                self.ether_service_acl.parent = self
                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"

                                                                                self.avail_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                self.avail_id.parent = self
                                                                                self._children_name_map["avail_id"] = "avail-id"

                                                                                self.media_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                self.media_type.parent = self
                                                                                self._children_name_map["media_type"] = "media-type"

                                                                                self.subs_protocol = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                self.subs_protocol.parent = self
                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"

                                                                                self.dnis = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                self.dnis.parent = self
                                                                                self._children_name_map["dnis"] = "dnis"

                                                                                self.dnis_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                self.dnis_regex.parent = self
                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"

                                                                                self.domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                self.domain.parent = self
                                                                                self._children_name_map["domain"] = "domain"

                                                                                self.domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                self.domain_regex.parent = self
                                                                                self._children_name_map["domain_regex"] = "domain-regex"

                                                                                self.nas_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                self.nas_port.parent = self
                                                                                self._children_name_map["nas_port"] = "nas-port"

                                                                                self.service_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                self.service_name.parent = self
                                                                                self._children_name_map["service_name"] = "service-name"

                                                                                self.service_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                self.service_name_regex.parent = self
                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"

                                                                                self.src_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                self.src_addr_ipv4.parent = self
                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"

                                                                                self.dst_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                self.dst_addr_ipv4.parent = self
                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"

                                                                                self.src_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                self.src_addr_ipv6.parent = self
                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"

                                                                                self.dst_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                self.dst_addr_ipv6.parent = self
                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"

                                                                                self.src_addr_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                self.src_addr_mac.parent = self
                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"

                                                                                self.timer = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                self.timer.parent = self
                                                                                self._children_name_map["timer"] = "timer"

                                                                                self.timer_regexp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                self.timer_regexp.parent = self
                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"

                                                                                self.tunnel_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                self.tunnel_name.parent = self
                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"

                                                                                self.tunnel_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                self.tunnel_name_regex.parent = self
                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"

                                                                                self.user_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                self.user_name.parent = self
                                                                                self._children_name_map["user_name"] = "user-name"

                                                                                self.user_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                self.user_name_regex.parent = self
                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"

                                                                                self.auth_username = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                self.auth_username.parent = self
                                                                                self._children_name_map["auth_username"] = "auth-username"

                                                                                self.auth_username_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                self.auth_username_regex.parent = self
                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"

                                                                                self.unauth_username = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                self.unauth_username.parent = self
                                                                                self._children_name_map["unauth_username"] = "unauth-username"

                                                                                self.unauth_username_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                self.unauth_username_regex.parent = self
                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"

                                                                                self.auth_domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                self.auth_domain.parent = self
                                                                                self._children_name_map["auth_domain"] = "auth-domain"

                                                                                self.auth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                self.auth_domain_regex.parent = self
                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"

                                                                                self.unauth_domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                self.unauth_domain.parent = self
                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"

                                                                                self.unauth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                self.unauth_domain_regex.parent = self
                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"

                                                                                self.vendor_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                self.vendor_id.parent = self
                                                                                self._children_name_map["vendor_id"] = "vendor-id"

                                                                                self.vendor_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                self.vendor_id_regex.parent = self
                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"

                                                                                self.access_interface = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                self.access_interface.parent = self
                                                                                self._children_name_map["access_interface"] = "access-interface"

                                                                                self.input_interface = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                self.input_interface.parent = self
                                                                                self._children_name_map["input_interface"] = "input-interface"

                                                                                self.input_intfhdl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                self.input_intfhdl.parent = self
                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"

                                                                                self.ethertype = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                self.ethertype.parent = self
                                                                                self._children_name_map["ethertype"] = "ethertype"

                                                                                self.flow_key_data = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                self.flow_key_data.parent = self
                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"

                                                                                self.dhcp_client_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                self.dhcp_client_id.parent = self
                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"

                                                                                self.dhcp_client_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                self.dhcp_client_id_regex.parent = self
                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"

                                                                                self.circuit_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                self.circuit_id.parent = self
                                                                                self._children_name_map["circuit_id"] = "circuit-id"

                                                                                self.circuit_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                self.circuit_id_regex.parent = self
                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"

                                                                                self.remote_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                self.remote_id.parent = self
                                                                                self._children_name_map["remote_id"] = "remote-id"

                                                                                self.remote_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                self.remote_id_regex.parent = self
                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"

                                                                                self.src_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                self.src_port.parent = self
                                                                                self._children_name_map["src_port"] = "src-port"

                                                                                self.dst_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                self.dst_port.parent = self
                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                self._segment_path = lambda: "match-data"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, ['type', 'mpls_top_eos', 'fragment_type', 'authen_status', 'mlp_negotiated'], name, value)


                                                                            class Ipv4Dscp(Entity):
                                                                                """
                                                                                IPv4 DSCP
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                    self.yang_name = "ipv4-dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv4-dscp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Ipv6Dscp(Entity):
                                                                                """
                                                                                IPv6 DSCP
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                    self.yang_name = "ipv6-dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv6-dscp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Dscp(Entity):
                                                                                """
                                                                                Match DSCP range array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                    self.yang_name = "dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "dscp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Ipv4Prec(Entity):
                                                                                """
                                                                                IPv4 Precedence
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                    self.yang_name = "ipv4-prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "ipv4-prec"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                            class Ipv6Prec(Entity):
                                                                                """
                                                                                IPv6 Precedence
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                    self.yang_name = "ipv6-prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "ipv6-prec"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                            class Prec(Entity):
                                                                                """
                                                                                Match Precedence array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                    self.yang_name = "prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "prec"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                            class DiscardClass(Entity):
                                                                                """
                                                                                Match Discard Class array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                    self.yang_name = "discard-class"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "discard-class"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                            class QosGroup(Entity):
                                                                                """
                                                                                Match QoS group array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                    self.yang_name = "qos-group"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "qos-group"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "qos-group"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class TrafficClass(Entity):
                                                                                """
                                                                                Match Traffic class array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                    self.yang_name = "traffic-class"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "traffic-class"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "traffic-class"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Proto(Entity):
                                                                                """
                                                                                Match Protocol array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                    self.yang_name = "proto"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "proto"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "proto"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class IcmpV4(Entity):
                                                                                """
                                                                                Match ICMPV4 Protocol
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Protocol type
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: code
                                                                                
                                                                                	Protocol code
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                    self.yang_name = "icmp-v4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                    ])
                                                                                    self.type = None
                                                                                    self.code = None
                                                                                    self._segment_path = lambda: "icmp-v4"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['type', 'code'], name, value)


                                                                            class IcmpV6(Entity):
                                                                                """
                                                                                Match ICMPV6 Protocol array
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Protocol type
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: code
                                                                                
                                                                                	Protocol code
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                    self.yang_name = "icmp-v6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                    ])
                                                                                    self.type = None
                                                                                    self.code = None
                                                                                    self._segment_path = lambda: "icmp-v6"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['type', 'code'], name, value)


                                                                            class Ipv4PacketLen(Entity):
                                                                                """
                                                                                IPv4 packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv4-packet-len"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class Ipv6PacketLen(Entity):
                                                                                """
                                                                                IPv6 packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv6-packet-len"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class PacketLen(Entity):
                                                                                """
                                                                                Match packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                    self.yang_name = "packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "packet-len"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class FlowTag(Entity):
                                                                                """
                                                                                Match flow\-tag array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                    self.yang_name = "flow-tag"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "flow-tag"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "flow-tag"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class TcpFlag(Entity):
                                                                                """
                                                                                Match tcp flag value
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	Value of TCP flag
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: match_any
                                                                                
                                                                                	Match any TCP flag bit
                                                                                	**type**\: bool
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                    self.yang_name = "tcp-flag"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                        ('match_any', (YLeaf(YType.boolean, 'match-any'), ['bool'])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.match_any = None
                                                                                    self._segment_path = lambda: "tcp-flag"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['value', 'match_any'], name, value)


                                                                            class Icmpv4Type(Entity):
                                                                                """
                                                                                Match ipv4 icmp type
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                    self.yang_name = "icmpv4-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv4-type"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Icmpv4Code(Entity):
                                                                                """
                                                                                Match ipv4 icmp code
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                    self.yang_name = "icmpv4-code"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv4-code"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Icmpv6Type(Entity):
                                                                                """
                                                                                Match ipv6 icmp type
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                    self.yang_name = "icmpv6-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv6-type"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Icmpv6Code(Entity):
                                                                                """
                                                                                Match ipv6 icmp code
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                    self.yang_name = "icmpv6-code"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv6-code"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class MplsExp(Entity):
                                                                                """
                                                                                Match MPLS experimental topmost array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                    self.yang_name = "mpls-exp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "mpls-exp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                            class MplsExpImp(Entity):
                                                                                """
                                                                                Match MPLS experimental imposition array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "mpls-exp-imp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                            class MplsDispIpv4Acl(Entity):
                                                                                """
                                                                                MPLS Disposition IPv4 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                            class MplsDispIpv6Acl(Entity):
                                                                                """
                                                                                MPLS Disposition IPv6 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                            class MplsTopLabel(Entity):
                                                                                """
                                                                                MPLS Topmost LABEL
                                                                                
                                                                                .. attribute:: uint32_rng_array
                                                                                
                                                                                	uint32 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                    self.yang_name = "mpls-top-label"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint32_rng_array", ("uint32_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint32_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "mpls-top-label"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                class Uint32RngArray(Entity):
                                                                                    """
                                                                                    uint32 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                        self.yang_name = "uint32_rng_array"
                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint32, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint32, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint32_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['min', 'max'], name, value)


                                                                            class Cos(Entity):
                                                                                """
                                                                                Match CoS array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                    self.yang_name = "cos"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "cos"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                            class CosInr(Entity):
                                                                                """
                                                                                Match inner header CoS
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                    self.yang_name = "cos-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "cos-inr"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                            class Dei(Entity):
                                                                                """
                                                                                Match DEI Bit
                                                                                
                                                                                .. attribute:: bit_value
                                                                                
                                                                                	Value of the DEI bit
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                    self.yang_name = "dei"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                    ])
                                                                                    self.bit_value = None
                                                                                    self._segment_path = lambda: "dei"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                            class DeiInr(Entity):
                                                                                """
                                                                                Match inner DEI Bit
                                                                                
                                                                                .. attribute:: bit_value
                                                                                
                                                                                	Value of the DEI bit
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                    self.yang_name = "dei-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                    ])
                                                                                    self.bit_value = None
                                                                                    self._segment_path = lambda: "dei-inr"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                            class Vlan(Entity):
                                                                                """
                                                                                Match VLAN array
                                                                                
                                                                                .. attribute:: vlan_id_array
                                                                                
                                                                                	vlan id array
                                                                                	**type**\: list of  		 :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                    self.yang_name = "vlan"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("vlan-id-array", ("vlan_id_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.vlan_id_array = YList(self)
                                                                                    self._segment_path = lambda: "vlan"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                class VlanIdArray(Entity):
                                                                                    """
                                                                                    vlan id array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	VLAN mask
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                        self.yang_name = "vlan-id-array"
                                                                                        self.yang_parent_name = "vlan"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                            ('mask', (YLeaf(YType.uint16, 'mask'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self.mask = None
                                                                                        self._segment_path = lambda: "vlan-id-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['min', 'max', 'mask'], name, value)


                                                                            class VlanInr(Entity):
                                                                                """
                                                                                Match inner header VLAN range array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                    self.yang_name = "vlan-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "vlan-inr"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class FrDlci(Entity):
                                                                                """
                                                                                Match FR DLCI range array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                    self.yang_name = "fr-dlci"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "fr-dlci"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class SrcMac(Entity):
                                                                                """
                                                                                Match Source MAC address
                                                                                
                                                                                .. attribute:: mac_addr
                                                                                
                                                                                	MAC address
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	MAC mask
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                    self.yang_name = "src-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                    ])
                                                                                    self.mac_addr = []
                                                                                    self.mask = []
                                                                                    self._segment_path = lambda: "src-mac"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                            class DstMac(Entity):
                                                                                """
                                                                                Match Destination MAC address
                                                                                
                                                                                .. attribute:: mac_addr
                                                                                
                                                                                	MAC address
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	MAC mask
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                    self.yang_name = "dst-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                    ])
                                                                                    self.mac_addr = []
                                                                                    self.mask = []
                                                                                    self._segment_path = lambda: "dst-mac"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                            class AtmClp(Entity):
                                                                                """
                                                                                Match ATM CLP level
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                    self.yang_name = "atm-clp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "atm-clp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                            class FrDe(Entity):
                                                                                """
                                                                                Match FR DE value
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                    self.yang_name = "fr-de"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "fr-de"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                            class Ipv4Acl(Entity):
                                                                                """
                                                                                IPv4 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                    self.yang_name = "ipv4-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "ipv4-acl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                            class Ipv6Acl(Entity):
                                                                                """
                                                                                IPv6 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                    self.yang_name = "ipv6-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "ipv6-acl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                            class EtherServiceAcl(Entity):
                                                                                """
                                                                                Ethernet\-Services Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                    self.yang_name = "ether-service-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "ether-service-acl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                            class AvailId(Entity):
                                                                                """
                                                                                Available Identifiers
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                    self.yang_name = "avail-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "avail-id"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                            class MediaType(Entity):
                                                                                """
                                                                                Media Type
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                    self.yang_name = "media-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "media-type"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                            class SubsProtocol(Entity):
                                                                                """
                                                                                Protocol
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                    self.yang_name = "subs-protocol"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "subs-protocol"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                            class Dnis(Entity):
                                                                                """
                                                                                DNIS
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                    self.yang_name = "dnis"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "dnis"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                            class DnisRegex(Entity):
                                                                                """
                                                                                DNIS Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                    self.yang_name = "dnis-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "dnis-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                            class Domain(Entity):
                                                                                """
                                                                                Domain Name
                                                                                
                                                                                .. attribute:: domain_array
                                                                                
                                                                                	domain array
                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                    self.yang_name = "domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.domain_array = YList(self)
                                                                                    self._segment_path = lambda: "domain"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                class DomainArray(Entity):
                                                                                    """
                                                                                    domain array
                                                                                    
                                                                                    .. attribute:: domain_name
                                                                                    
                                                                                    	domain name
                                                                                    	**type**\: str
                                                                                    
                                                                                    .. attribute:: format_name
                                                                                    
                                                                                    	format name
                                                                                    	**type**\: str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                        self.yang_name = "domain-array"
                                                                                        self.yang_parent_name = "domain"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                        ])
                                                                                        self.domain_name = None
                                                                                        self.format_name = None
                                                                                        self._segment_path = lambda: "domain-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                            class DomainRegex(Entity):
                                                                                """
                                                                                Domain Regular Expression
                                                                                
                                                                                .. attribute:: domain_array
                                                                                
                                                                                	domain array
                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                    self.yang_name = "domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.domain_array = YList(self)
                                                                                    self._segment_path = lambda: "domain-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                class DomainArray(Entity):
                                                                                    """
                                                                                    domain array
                                                                                    
                                                                                    .. attribute:: domain_name
                                                                                    
                                                                                    	domain name
                                                                                    	**type**\: str
                                                                                    
                                                                                    .. attribute:: format_name
                                                                                    
                                                                                    	format name
                                                                                    	**type**\: str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                        self.yang_name = "domain-array"
                                                                                        self.yang_parent_name = "domain-regex"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                        ])
                                                                                        self.domain_name = None
                                                                                        self.format_name = None
                                                                                        self._segment_path = lambda: "domain-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                            class NasPort(Entity):
                                                                                """
                                                                                NAS Port
                                                                                
                                                                                .. attribute:: nas_port_array
                                                                                
                                                                                	nas port array
                                                                                	**type**\: list of  		 :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                    self.yang_name = "nas-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("nas-port-array", ("nas_port_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.nas_port_array = YList(self)
                                                                                    self._segment_path = lambda: "nas-port"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                class NasPortArray(Entity):
                                                                                    """
                                                                                    nas port array
                                                                                    
                                                                                    .. attribute:: sub_id
                                                                                    
                                                                                    	sub id
                                                                                    	**type**\:  :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                    
                                                                                    .. attribute:: operator
                                                                                    
                                                                                    	operator
                                                                                    	**type**\:  :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                        self.yang_name = "nas-port-array"
                                                                                        self.yang_parent_name = "nas-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('sub_id', (YLeaf(YType.enumeration, 'sub-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchNasPortSubIdEn', '')])),
                                                                                            ('operator', (YLeaf(YType.enumeration, 'operator'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchLogicalOperatorEn', '')])),
                                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ])
                                                                                        self.sub_id = None
                                                                                        self.operator = None
                                                                                        self.value = None
                                                                                        self._segment_path = lambda: "nas-port-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['sub_id', 'operator', 'value'], name, value)


                                                                            class ServiceName(Entity):
                                                                                """
                                                                                Service Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                    self.yang_name = "service-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "service-name"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                            class ServiceNameRegex(Entity):
                                                                                """
                                                                                Service Name Regular Exp
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                    self.yang_name = "service-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "service-name-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                            class SrcAddrIpv4(Entity):
                                                                                """
                                                                                Source Address IPV4
                                                                                
                                                                                .. attribute:: ipv4_addr_array
                                                                                
                                                                                	ipv4 addr array
                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.ipv4_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-ipv4"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                class Ipv4AddrArray(Entity):
                                                                                    """
                                                                                    ipv4 addr array
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	prefix
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	mask
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                        ])
                                                                                        self.prefix = None
                                                                                        self.mask = None
                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                            class DstAddrIpv4(Entity):
                                                                                """
                                                                                Destination Address IPV4
                                                                                
                                                                                .. attribute:: ipv4_addr_array
                                                                                
                                                                                	ipv4 addr array
                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.ipv4_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-addr-ipv4"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                class Ipv4AddrArray(Entity):
                                                                                    """
                                                                                    ipv4 addr array
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	prefix
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	mask
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                        ])
                                                                                        self.prefix = None
                                                                                        self.mask = None
                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                            class SrcAddrIpv6(Entity):
                                                                                """
                                                                                Source Address IPV6
                                                                                
                                                                                .. attribute:: ipv6_addr_array
                                                                                
                                                                                	ipv6 addr array
                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.ipv6_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-ipv6"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                class Ipv6AddrArray(Entity):
                                                                                    """
                                                                                    ipv6 addr array
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	IPV6 prefix
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	IPV6 mask
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                        ])
                                                                                        self.prefix = None
                                                                                        self.mask = None
                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                            class DstAddrIpv6(Entity):
                                                                                """
                                                                                Destination Address IPV6
                                                                                
                                                                                .. attribute:: ipv6_addr_array
                                                                                
                                                                                	ipv6 addr array
                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.ipv6_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-addr-ipv6"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                class Ipv6AddrArray(Entity):
                                                                                    """
                                                                                    ipv6 addr array
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	IPV6 prefix
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	IPV6 mask
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                        ])
                                                                                        self.prefix = None
                                                                                        self.mask = None
                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                            class SrcAddrMac(Entity):
                                                                                """
                                                                                Source Address MAC
                                                                                
                                                                                .. attribute:: mac_addr_array
                                                                                
                                                                                	mac addr array
                                                                                	**type**\: list of  		 :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                    self.yang_name = "src-addr-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("mac-addr-array", ("mac_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.mac_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-mac"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                class MacAddrArray(Entity):
                                                                                    """
                                                                                    mac addr array
                                                                                    
                                                                                    .. attribute:: mac_addr
                                                                                    
                                                                                    	MAC address
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	MAC mask
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                        self.yang_name = "mac-addr-array"
                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                            ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                        ])
                                                                                        self.mac_addr = []
                                                                                        self.mask = []
                                                                                        self._segment_path = lambda: "mac-addr-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                            class Timer(Entity):
                                                                                """
                                                                                Timer
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                    self.yang_name = "timer"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "timer"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                            class TimerRegexp(Entity):
                                                                                """
                                                                                Timer Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                    self.yang_name = "timer-regexp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "timer-regexp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                            class TunnelName(Entity):
                                                                                """
                                                                                Tunnel Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                    self.yang_name = "tunnel-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "tunnel-name"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                            class TunnelNameRegex(Entity):
                                                                                """
                                                                                Tunnel Name Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "tunnel-name-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                            class UserName(Entity):
                                                                                """
                                                                                User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                    self.yang_name = "user-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "user-name"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                            class UserNameRegex(Entity):
                                                                                """
                                                                                User Name Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                    self.yang_name = "user-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "user-name-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                            class AuthUsername(Entity):
                                                                                """
                                                                                Authenticated User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                    self.yang_name = "auth-username"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "auth-username"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                            class AuthUsernameRegex(Entity):
                                                                                """
                                                                                Authenticated User Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                    self.yang_name = "auth-username-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "auth-username-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                            class UnauthUsername(Entity):
                                                                                """
                                                                                Unauthenticated User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                    self.yang_name = "unauth-username"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "unauth-username"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                            class UnauthUsernameRegex(Entity):
                                                                                """
                                                                                Unauthenticated User Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                    self.yang_name = "unauth-username-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "unauth-username-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                            class AuthDomain(Entity):
                                                                                """
                                                                                Authenticated domain name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                    self.yang_name = "auth-domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "auth-domain"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                            class AuthDomainRegex(Entity):
                                                                                """
                                                                                Authenticated Domain Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                    self.yang_name = "auth-domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "auth-domain-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                            class UnauthDomain(Entity):
                                                                                """
                                                                                Unauthenticated Domain Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                    self.yang_name = "unauth-domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "unauth-domain"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                            class UnauthDomainRegex(Entity):
                                                                                """
                                                                                Unauthenticated Domain Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "unauth-domain-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                            class VendorId(Entity):
                                                                                """
                                                                                Vendor ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                    self.yang_name = "vendor-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "vendor-id"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                            class VendorIdRegex(Entity):
                                                                                """
                                                                                Vendor ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                    self.yang_name = "vendor-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "vendor-id-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                            class AccessInterface(Entity):
                                                                                """
                                                                                Access interface
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                    self.yang_name = "access-interface"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "access-interface"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                            class InputInterface(Entity):
                                                                                """
                                                                                Input interface
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                    self.yang_name = "input-interface"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "input-interface"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                            class InputIntfhdl(Entity):
                                                                                """
                                                                                Input interface handle
                                                                                
                                                                                .. attribute:: uint64_array
                                                                                
                                                                                	uint64 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..18446744073709551615
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                    self.yang_name = "input-intfhdl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint64_array', (YLeafList(YType.uint64, 'uint64_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint64_array = []
                                                                                    self._segment_path = lambda: "input-intfhdl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                            class Ethertype(Entity):
                                                                                """
                                                                                Ethernet type
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                    self.yang_name = "ethertype"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ethertype"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ethertype"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class FlowKeyData(Entity):
                                                                                """
                                                                                Flow key structure
                                                                                
                                                                                .. attribute:: flow_keys
                                                                                
                                                                                	flow keys
                                                                                	**type**\:  :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                
                                                                                .. attribute:: max_count
                                                                                
                                                                                	Maximum count of flows
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: idle_timeout
                                                                                
                                                                                	Idle timeout of flows (in seconds)
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                	**units**\: second
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                    self.yang_name = "flow-key-data"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("flow-keys", ("flow_keys", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('max_count', (YLeaf(YType.uint16, 'max-count'), ['int'])),
                                                                                        ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                                    ])
                                                                                    self.max_count = None
                                                                                    self.idle_timeout = None

                                                                                    self.flow_keys = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                    self.flow_keys.parent = self
                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                    self._segment_path = lambda: "flow-key-data"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['max_count', 'idle_timeout'], name, value)


                                                                                class FlowKeys(Entity):
                                                                                    """
                                                                                    flow keys
                                                                                    
                                                                                    .. attribute:: keys
                                                                                    
                                                                                    	keys
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                    
                                                                                    .. attribute:: num
                                                                                    
                                                                                    	num
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                        self.yang_name = "flow-keys"
                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('keys', (YLeaf(YType.str, 'keys'), ['str'])),
                                                                                            ('num', (YLeaf(YType.uint8, 'num'), ['int'])),
                                                                                        ])
                                                                                        self.keys = None
                                                                                        self.num = None
                                                                                        self._segment_path = lambda: "flow-keys"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                            class DhcpClientId(Entity):
                                                                                """
                                                                                Dhcp Client ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                    self.yang_name = "dhcp-client-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "dhcp-client-id"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                            class DhcpClientIdRegex(Entity):
                                                                                """
                                                                                Dhcp Client ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                            class CircuitId(Entity):
                                                                                """
                                                                                Circuit ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                    self.yang_name = "circuit-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "circuit-id"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                            class CircuitIdRegex(Entity):
                                                                                """
                                                                                Circuit ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                    self.yang_name = "circuit-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "circuit-id-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                            class RemoteId(Entity):
                                                                                """
                                                                                Remote ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                    self.yang_name = "remote-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "remote-id"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                            class RemoteIdRegex(Entity):
                                                                                """
                                                                                Remote ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                    self.yang_name = "remote-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "remote-id-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                            class SrcPort(Entity):
                                                                                """
                                                                                Source port
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                    self.yang_name = "src-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "src-port"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "src-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class DstPort(Entity):
                                                                                """
                                                                                Destination port
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                    self.yang_name = "dst-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-port"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "dst-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['min', 'max'], name, value)


                                                        class ClmpP(Entity):
                                                            """
                                                            clmp p
                                                            
                                                            .. attribute:: class_map_bg
                                                            
                                                            	class map bg
                                                            	**type**\: list of  		 :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'infra-policymgr-oper'
                                                            _revision = '2018-01-17'

                                                            def __init__(self):
                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP, self).__init__()

                                                                self.yang_name = "clmp-p"
                                                                self.yang_parent_name = "policy-class-info-bg"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("class-map-bg", ("class_map_bg", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg))])
                                                                self._leafs = OrderedDict()

                                                                self.class_map_bg = YList(self)
                                                                self._segment_path = lambda: "clmp-p"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP, [], name, value)


                                                            class ClassMapBg(Entity):
                                                                """
                                                                class map bg
                                                                
                                                                .. attribute:: match_infop
                                                                
                                                                	Pointer to the first Match info
                                                                	**type**\:  :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop>`
                                                                
                                                                .. attribute:: name
                                                                
                                                                	Name of the class\-map
                                                                	**type**\: str
                                                                
                                                                	**length:** 0..65
                                                                
                                                                .. attribute:: type
                                                                
                                                                	Class\-Map Type QoS/PBR/Netflow/..
                                                                	**type**\:  :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                                
                                                                .. attribute:: mode
                                                                
                                                                	Class\-Map Mode Match any/Match all
                                                                	**type**\:  :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                
                                                                .. attribute:: description
                                                                
                                                                	description
                                                                	**type**\: str
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg, self).__init__()

                                                                    self.yang_name = "class-map-bg"
                                                                    self.yang_parent_name = "clmp-p"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("match-infop", ("match_infop", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop))])
                                                                    self._leafs = OrderedDict([
                                                                        ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapTypeEn', '')])),
                                                                        ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapModeEn', '')])),
                                                                        ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                    ])
                                                                    self.name = None
                                                                    self.type = None
                                                                    self.mode = None
                                                                    self.description = None

                                                                    self.match_infop = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop()
                                                                    self.match_infop.parent = self
                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                    self._segment_path = lambda: "class-map-bg"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg, ['name', 'type', 'mode', 'description'], name, value)


                                                                class MatchInfop(Entity):
                                                                    """
                                                                    Pointer to the first Match info
                                                                    
                                                                    .. attribute:: class_match_info_st
                                                                    
                                                                    	class match info st
                                                                    	**type**\: list of  		 :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop, self).__init__()

                                                                        self.yang_name = "match-infop"
                                                                        self.yang_parent_name = "class-map-bg"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("class-match-info-st", ("class_match_info_st", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt))])
                                                                        self._leafs = OrderedDict()

                                                                        self.class_match_info_st = YList(self)
                                                                        self._segment_path = lambda: "match-infop"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop, [], name, value)


                                                                    class ClassMatchInfoSt(Entity):
                                                                        """
                                                                        class match info st
                                                                        
                                                                        .. attribute:: match_data
                                                                        
                                                                        	Match criteria
                                                                        	**type**\:  :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                        
                                                                        .. attribute:: flags
                                                                        
                                                                        	Flags
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                            self.yang_name = "class-match-info-st"
                                                                            self.yang_parent_name = "match-infop"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("match-data", ("match_data", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData))])
                                                                            self._leafs = OrderedDict([
                                                                                ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                            ])
                                                                            self.flags = None

                                                                            self.match_data = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                            self.match_data.parent = self
                                                                            self._children_name_map["match_data"] = "match-data"
                                                                            self._segment_path = lambda: "class-match-info-st"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                        class MatchData(Entity):
                                                                            """
                                                                            Match criteria
                                                                            
                                                                            .. attribute:: ipv4_dscp
                                                                            
                                                                            	IPv4 DSCP
                                                                            	**type**\:  :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                            
                                                                            .. attribute:: ipv6_dscp
                                                                            
                                                                            	IPv6 DSCP
                                                                            	**type**\:  :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                            
                                                                            .. attribute:: dscp
                                                                            
                                                                            	Match DSCP range array
                                                                            	**type**\:  :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                            
                                                                            .. attribute:: ipv4_prec
                                                                            
                                                                            	IPv4 Precedence
                                                                            	**type**\:  :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                            
                                                                            .. attribute:: ipv6_prec
                                                                            
                                                                            	IPv6 Precedence
                                                                            	**type**\:  :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                            
                                                                            .. attribute:: prec
                                                                            
                                                                            	Match Precedence array
                                                                            	**type**\:  :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                            
                                                                            .. attribute:: discard_class
                                                                            
                                                                            	Match Discard Class array
                                                                            	**type**\:  :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                            
                                                                            .. attribute:: qos_group
                                                                            
                                                                            	Match QoS group array
                                                                            	**type**\:  :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                            
                                                                            .. attribute:: traffic_class
                                                                            
                                                                            	Match Traffic class array
                                                                            	**type**\:  :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                            
                                                                            .. attribute:: proto
                                                                            
                                                                            	Match Protocol array
                                                                            	**type**\:  :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                            
                                                                            .. attribute:: icmp_v4
                                                                            
                                                                            	Match ICMPV4 Protocol
                                                                            	**type**\:  :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                            
                                                                            .. attribute:: icmp_v6
                                                                            
                                                                            	Match ICMPV6 Protocol array
                                                                            	**type**\:  :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                            
                                                                            .. attribute:: ipv4_packet_len
                                                                            
                                                                            	IPv4 packet length array
                                                                            	**type**\:  :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                            
                                                                            .. attribute:: ipv6_packet_len
                                                                            
                                                                            	IPv6 packet length array
                                                                            	**type**\:  :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                            
                                                                            .. attribute:: packet_len
                                                                            
                                                                            	Match packet length array
                                                                            	**type**\:  :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                            
                                                                            .. attribute:: flow_tag
                                                                            
                                                                            	Match flow\-tag array
                                                                            	**type**\:  :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                            
                                                                            .. attribute:: tcp_flag
                                                                            
                                                                            	Match tcp flag value
                                                                            	**type**\:  :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                            
                                                                            .. attribute:: icmpv4_type
                                                                            
                                                                            	Match ipv4 icmp type
                                                                            	**type**\:  :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                            
                                                                            .. attribute:: icmpv4_code
                                                                            
                                                                            	Match ipv4 icmp code
                                                                            	**type**\:  :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                            
                                                                            .. attribute:: icmpv6_type
                                                                            
                                                                            	Match ipv6 icmp type
                                                                            	**type**\:  :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                            
                                                                            .. attribute:: icmpv6_code
                                                                            
                                                                            	Match ipv6 icmp code
                                                                            	**type**\:  :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                            
                                                                            .. attribute:: mpls_exp
                                                                            
                                                                            	Match MPLS experimental topmost array
                                                                            	**type**\:  :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                            
                                                                            .. attribute:: mpls_exp_imp
                                                                            
                                                                            	Match MPLS experimental imposition array
                                                                            	**type**\:  :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                            
                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                            
                                                                            	MPLS Disposition IPv4 Access\-list
                                                                            	**type**\:  :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                            
                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                            
                                                                            	MPLS Disposition IPv6 Access\-list
                                                                            	**type**\:  :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                            
                                                                            .. attribute:: mpls_top_label
                                                                            
                                                                            	MPLS Topmost LABEL
                                                                            	**type**\:  :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                            
                                                                            .. attribute:: cos
                                                                            
                                                                            	Match CoS array
                                                                            	**type**\:  :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                            
                                                                            .. attribute:: cos_inr
                                                                            
                                                                            	Match inner header CoS
                                                                            	**type**\:  :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                            
                                                                            .. attribute:: dei
                                                                            
                                                                            	Match DEI Bit
                                                                            	**type**\:  :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                            
                                                                            .. attribute:: dei_inr
                                                                            
                                                                            	Match inner DEI Bit
                                                                            	**type**\:  :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                            
                                                                            .. attribute:: vlan
                                                                            
                                                                            	Match VLAN array
                                                                            	**type**\:  :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                            
                                                                            .. attribute:: vlan_inr
                                                                            
                                                                            	Match inner header VLAN range array
                                                                            	**type**\:  :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                            
                                                                            .. attribute:: fr_dlci
                                                                            
                                                                            	Match FR DLCI range array
                                                                            	**type**\:  :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                            
                                                                            .. attribute:: src_mac
                                                                            
                                                                            	Match Source MAC address
                                                                            	**type**\:  :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                            
                                                                            .. attribute:: dst_mac
                                                                            
                                                                            	Match Destination MAC address
                                                                            	**type**\:  :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                            
                                                                            .. attribute:: atm_clp
                                                                            
                                                                            	Match ATM CLP level
                                                                            	**type**\:  :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                            
                                                                            .. attribute:: fr_de
                                                                            
                                                                            	Match FR DE value
                                                                            	**type**\:  :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                            
                                                                            .. attribute:: ipv4_acl
                                                                            
                                                                            	IPv4 Access\-list
                                                                            	**type**\:  :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                            
                                                                            .. attribute:: ipv6_acl
                                                                            
                                                                            	IPv6 Access\-list
                                                                            	**type**\:  :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                            
                                                                            .. attribute:: ether_service_acl
                                                                            
                                                                            	Ethernet\-Services Access\-list
                                                                            	**type**\:  :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                            
                                                                            .. attribute:: avail_id
                                                                            
                                                                            	Available Identifiers
                                                                            	**type**\:  :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                            
                                                                            .. attribute:: media_type
                                                                            
                                                                            	Media Type
                                                                            	**type**\:  :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                            
                                                                            .. attribute:: subs_protocol
                                                                            
                                                                            	Protocol
                                                                            	**type**\:  :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                            
                                                                            .. attribute:: dnis
                                                                            
                                                                            	DNIS
                                                                            	**type**\:  :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                            
                                                                            .. attribute:: dnis_regex
                                                                            
                                                                            	DNIS Regular Expression
                                                                            	**type**\:  :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                            
                                                                            .. attribute:: domain
                                                                            
                                                                            	Domain Name
                                                                            	**type**\:  :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                            
                                                                            .. attribute:: domain_regex
                                                                            
                                                                            	Domain Regular Expression
                                                                            	**type**\:  :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                            
                                                                            .. attribute:: nas_port
                                                                            
                                                                            	NAS Port
                                                                            	**type**\:  :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                            
                                                                            .. attribute:: service_name
                                                                            
                                                                            	Service Name
                                                                            	**type**\:  :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                            
                                                                            .. attribute:: service_name_regex
                                                                            
                                                                            	Service Name Regular Exp
                                                                            	**type**\:  :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                            
                                                                            .. attribute:: src_addr_ipv4
                                                                            
                                                                            	Source Address IPV4
                                                                            	**type**\:  :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                            
                                                                            .. attribute:: dst_addr_ipv4
                                                                            
                                                                            	Destination Address IPV4
                                                                            	**type**\:  :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                            
                                                                            .. attribute:: src_addr_ipv6
                                                                            
                                                                            	Source Address IPV6
                                                                            	**type**\:  :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                            
                                                                            .. attribute:: dst_addr_ipv6
                                                                            
                                                                            	Destination Address IPV6
                                                                            	**type**\:  :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                            
                                                                            .. attribute:: src_addr_mac
                                                                            
                                                                            	Source Address MAC
                                                                            	**type**\:  :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                            
                                                                            .. attribute:: timer
                                                                            
                                                                            	Timer
                                                                            	**type**\:  :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                            
                                                                            .. attribute:: timer_regexp
                                                                            
                                                                            	Timer Regular Expression
                                                                            	**type**\:  :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                            
                                                                            .. attribute:: tunnel_name
                                                                            
                                                                            	Tunnel Name
                                                                            	**type**\:  :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                            
                                                                            .. attribute:: tunnel_name_regex
                                                                            
                                                                            	Tunnel Name Regular Expression
                                                                            	**type**\:  :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                            
                                                                            .. attribute:: user_name
                                                                            
                                                                            	User Name
                                                                            	**type**\:  :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                            
                                                                            .. attribute:: user_name_regex
                                                                            
                                                                            	User Name Regular Expression
                                                                            	**type**\:  :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                            
                                                                            .. attribute:: auth_username
                                                                            
                                                                            	Authenticated User Name
                                                                            	**type**\:  :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                            
                                                                            .. attribute:: auth_username_regex
                                                                            
                                                                            	Authenticated User Name RegEx
                                                                            	**type**\:  :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                            
                                                                            .. attribute:: unauth_username
                                                                            
                                                                            	Unauthenticated User Name
                                                                            	**type**\:  :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                            
                                                                            .. attribute:: unauth_username_regex
                                                                            
                                                                            	Unauthenticated User Name RegEx
                                                                            	**type**\:  :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                            
                                                                            .. attribute:: auth_domain
                                                                            
                                                                            	Authenticated domain name
                                                                            	**type**\:  :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                            
                                                                            .. attribute:: auth_domain_regex
                                                                            
                                                                            	Authenticated Domain Name RegEx
                                                                            	**type**\:  :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                            
                                                                            .. attribute:: unauth_domain
                                                                            
                                                                            	Unauthenticated Domain Name
                                                                            	**type**\:  :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                            
                                                                            .. attribute:: unauth_domain_regex
                                                                            
                                                                            	Unauthenticated Domain Name RegEx
                                                                            	**type**\:  :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                            
                                                                            .. attribute:: vendor_id
                                                                            
                                                                            	Vendor ID
                                                                            	**type**\:  :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                            
                                                                            .. attribute:: vendor_id_regex
                                                                            
                                                                            	Vendor ID RegEx
                                                                            	**type**\:  :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                            
                                                                            .. attribute:: access_interface
                                                                            
                                                                            	Access interface
                                                                            	**type**\:  :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                            
                                                                            .. attribute:: input_interface
                                                                            
                                                                            	Input interface
                                                                            	**type**\:  :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                            
                                                                            .. attribute:: input_intfhdl
                                                                            
                                                                            	Input interface handle
                                                                            	**type**\:  :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                            
                                                                            .. attribute:: ethertype
                                                                            
                                                                            	Ethernet type
                                                                            	**type**\:  :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                            
                                                                            .. attribute:: flow_key_data
                                                                            
                                                                            	Flow key structure
                                                                            	**type**\:  :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                            
                                                                            .. attribute:: dhcp_client_id
                                                                            
                                                                            	Dhcp Client ID
                                                                            	**type**\:  :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                            
                                                                            .. attribute:: dhcp_client_id_regex
                                                                            
                                                                            	Dhcp Client ID RegEx
                                                                            	**type**\:  :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                            
                                                                            .. attribute:: circuit_id
                                                                            
                                                                            	Circuit ID
                                                                            	**type**\:  :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                            
                                                                            .. attribute:: circuit_id_regex
                                                                            
                                                                            	Circuit ID RegEx
                                                                            	**type**\:  :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                            
                                                                            .. attribute:: remote_id
                                                                            
                                                                            	Remote ID
                                                                            	**type**\:  :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                            
                                                                            .. attribute:: remote_id_regex
                                                                            
                                                                            	Remote ID RegEx
                                                                            	**type**\:  :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                            
                                                                            .. attribute:: src_port
                                                                            
                                                                            	Source port
                                                                            	**type**\:  :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                            
                                                                            .. attribute:: dst_port
                                                                            
                                                                            	Destination port
                                                                            	**type**\:  :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:  :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                            
                                                                            .. attribute:: mpls_top_eos
                                                                            
                                                                            	MPLS Topmost EOS
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: fragment_type
                                                                            
                                                                            	Fragment type
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: authen_status
                                                                            
                                                                            	Authentication Status
                                                                            	**type**\:  :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                            
                                                                            .. attribute:: mlp_negotiated
                                                                            
                                                                            	MLP Negotiated
                                                                            	**type**\:  :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                self.yang_name = "match-data"
                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("ipv4-dscp", ("ipv4_dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp)), ("ipv6-dscp", ("ipv6_dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp)), ("dscp", ("dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp)), ("ipv4-prec", ("ipv4_prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec)), ("ipv6-prec", ("ipv6_prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec)), ("prec", ("prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec)), ("discard-class", ("discard_class", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass)), ("qos-group", ("qos_group", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup)), ("traffic-class", ("traffic_class", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass)), ("proto", ("proto", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto)), ("icmp-v4", ("icmp_v4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4)), ("icmp-v6", ("icmp_v6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6)), ("ipv4-packet-len", ("ipv4_packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen)), ("ipv6-packet-len", ("ipv6_packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen)), ("packet-len", ("packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen)), ("flow-tag", ("flow_tag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag)), ("tcp-flag", ("tcp_flag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag)), ("icmpv4-type", ("icmpv4_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type)), ("icmpv4-code", ("icmpv4_code", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code)), ("icmpv6-type", ("icmpv6_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type)), ("icmpv6-code", ("icmpv6_code", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code)), ("mpls-exp", ("mpls_exp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp)), ("mpls-exp-imp", ("mpls_exp_imp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp)), ("mpls-disp-ipv4-acl", ("mpls_disp_ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl)), ("mpls-disp-ipv6-acl", ("mpls_disp_ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl)), ("mpls-top-label", ("mpls_top_label", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel)), ("cos", ("cos", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos)), ("cos-inr", ("cos_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr)), ("dei", ("dei", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei)), ("dei-inr", ("dei_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr)), ("vlan", ("vlan", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan)), ("vlan-inr", ("vlan_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)), ("fr-dlci", ("fr_dlci", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci)), ("src-mac", ("src_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac)), ("dst-mac", ("dst_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac)), ("atm-clp", ("atm_clp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp)), ("fr-de", ("fr_de", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe)), ("ipv4-acl", ("ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl)), ("ipv6-acl", ("ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl)), ("ether-service-acl", ("ether_service_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl)), ("avail-id", ("avail_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId)), ("media-type", ("media_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType)), ("subs-protocol", ("subs_protocol", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol)), ("dnis", ("dnis", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis)), ("dnis-regex", ("dnis_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex)), ("domain", ("domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain)), ("domain-regex", ("domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex)), ("nas-port", ("nas_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort)), ("service-name", ("service_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName)), ("service-name-regex", ("service_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex)), ("src-addr-ipv4", ("src_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4)), ("dst-addr-ipv4", ("dst_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4)), ("src-addr-ipv6", ("src_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6)), ("dst-addr-ipv6", ("dst_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6)), ("src-addr-mac", ("src_addr_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac)), ("timer", ("timer", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer)), ("timer-regexp", ("timer_regexp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp)), ("tunnel-name", ("tunnel_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName)), ("tunnel-name-regex", ("tunnel_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex)), ("user-name", ("user_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName)), ("user-name-regex", ("user_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex)), ("auth-username", ("auth_username", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername)), ("auth-username-regex", ("auth_username_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex)), ("unauth-username", ("unauth_username", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername)), ("unauth-username-regex", ("unauth_username_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex)), ("auth-domain", ("auth_domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain)), ("auth-domain-regex", ("auth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex)), ("unauth-domain", ("unauth_domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain)), ("unauth-domain-regex", ("unauth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex)), ("vendor-id", ("vendor_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId)), ("vendor-id-regex", ("vendor_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex)), ("access-interface", ("access_interface", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface)), ("input-interface", ("input_interface", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface)), ("input-intfhdl", ("input_intfhdl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl)), ("ethertype", ("ethertype", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype)), ("flow-key-data", ("flow_key_data", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData)), ("dhcp-client-id", ("dhcp_client_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId)), ("dhcp-client-id-regex", ("dhcp_client_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex)), ("circuit-id", ("circuit_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId)), ("circuit-id-regex", ("circuit_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex)), ("remote-id", ("remote_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId)), ("remote-id-regex", ("remote_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex)), ("src-port", ("src_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort)), ("dst-port", ("dst_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchTypeEn', '')])),
                                                                                    ('mpls_top_eos', (YLeaf(YType.uint8, 'mpls-top-eos'), ['int'])),
                                                                                    ('fragment_type', (YLeaf(YType.uint8, 'fragment-type'), ['int'])),
                                                                                    ('authen_status', (YLeaf(YType.enumeration, 'authen-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchAuthenStatusEn', '')])),
                                                                                    ('mlp_negotiated', (YLeaf(YType.enumeration, 'mlp-negotiated'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchMlpNegotiatedEn', '')])),
                                                                                ])
                                                                                self.type = None
                                                                                self.mpls_top_eos = None
                                                                                self.fragment_type = None
                                                                                self.authen_status = None
                                                                                self.mlp_negotiated = None

                                                                                self.ipv4_dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                self.ipv4_dscp.parent = self
                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"

                                                                                self.ipv6_dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                self.ipv6_dscp.parent = self
                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"

                                                                                self.dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                self.dscp.parent = self
                                                                                self._children_name_map["dscp"] = "dscp"

                                                                                self.ipv4_prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                self.ipv4_prec.parent = self
                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"

                                                                                self.ipv6_prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                self.ipv6_prec.parent = self
                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"

                                                                                self.prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                self.prec.parent = self
                                                                                self._children_name_map["prec"] = "prec"

                                                                                self.discard_class = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                self.discard_class.parent = self
                                                                                self._children_name_map["discard_class"] = "discard-class"

                                                                                self.qos_group = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                self.qos_group.parent = self
                                                                                self._children_name_map["qos_group"] = "qos-group"

                                                                                self.traffic_class = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                self.traffic_class.parent = self
                                                                                self._children_name_map["traffic_class"] = "traffic-class"

                                                                                self.proto = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                self.proto.parent = self
                                                                                self._children_name_map["proto"] = "proto"

                                                                                self.icmp_v4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                self.icmp_v4.parent = self
                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"

                                                                                self.icmp_v6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                self.icmp_v6.parent = self
                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"

                                                                                self.ipv4_packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                self.ipv4_packet_len.parent = self
                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"

                                                                                self.ipv6_packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                self.ipv6_packet_len.parent = self
                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"

                                                                                self.packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                self.packet_len.parent = self
                                                                                self._children_name_map["packet_len"] = "packet-len"

                                                                                self.flow_tag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                self.flow_tag.parent = self
                                                                                self._children_name_map["flow_tag"] = "flow-tag"

                                                                                self.tcp_flag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                self.tcp_flag.parent = self
                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"

                                                                                self.icmpv4_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                self.icmpv4_type.parent = self
                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"

                                                                                self.icmpv4_code = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                self.icmpv4_code.parent = self
                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"

                                                                                self.icmpv6_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                self.icmpv6_type.parent = self
                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"

                                                                                self.icmpv6_code = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                self.icmpv6_code.parent = self
                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"

                                                                                self.mpls_exp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                self.mpls_exp.parent = self
                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"

                                                                                self.mpls_exp_imp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                self.mpls_exp_imp.parent = self
                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"

                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"

                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"

                                                                                self.mpls_top_label = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                self.mpls_top_label.parent = self
                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"

                                                                                self.cos = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                self.cos.parent = self
                                                                                self._children_name_map["cos"] = "cos"

                                                                                self.cos_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                self.cos_inr.parent = self
                                                                                self._children_name_map["cos_inr"] = "cos-inr"

                                                                                self.dei = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                self.dei.parent = self
                                                                                self._children_name_map["dei"] = "dei"

                                                                                self.dei_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                self.dei_inr.parent = self
                                                                                self._children_name_map["dei_inr"] = "dei-inr"

                                                                                self.vlan = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                self.vlan.parent = self
                                                                                self._children_name_map["vlan"] = "vlan"

                                                                                self.vlan_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                self.vlan_inr.parent = self
                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"

                                                                                self.fr_dlci = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                self.fr_dlci.parent = self
                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"

                                                                                self.src_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                self.src_mac.parent = self
                                                                                self._children_name_map["src_mac"] = "src-mac"

                                                                                self.dst_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                self.dst_mac.parent = self
                                                                                self._children_name_map["dst_mac"] = "dst-mac"

                                                                                self.atm_clp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                self.atm_clp.parent = self
                                                                                self._children_name_map["atm_clp"] = "atm-clp"

                                                                                self.fr_de = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                self.fr_de.parent = self
                                                                                self._children_name_map["fr_de"] = "fr-de"

                                                                                self.ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                self.ipv4_acl.parent = self
                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"

                                                                                self.ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                self.ipv6_acl.parent = self
                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"

                                                                                self.ether_service_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                self.ether_service_acl.parent = self
                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"

                                                                                self.avail_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                self.avail_id.parent = self
                                                                                self._children_name_map["avail_id"] = "avail-id"

                                                                                self.media_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                self.media_type.parent = self
                                                                                self._children_name_map["media_type"] = "media-type"

                                                                                self.subs_protocol = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                self.subs_protocol.parent = self
                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"

                                                                                self.dnis = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                self.dnis.parent = self
                                                                                self._children_name_map["dnis"] = "dnis"

                                                                                self.dnis_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                self.dnis_regex.parent = self
                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"

                                                                                self.domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                self.domain.parent = self
                                                                                self._children_name_map["domain"] = "domain"

                                                                                self.domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                self.domain_regex.parent = self
                                                                                self._children_name_map["domain_regex"] = "domain-regex"

                                                                                self.nas_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                self.nas_port.parent = self
                                                                                self._children_name_map["nas_port"] = "nas-port"

                                                                                self.service_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                self.service_name.parent = self
                                                                                self._children_name_map["service_name"] = "service-name"

                                                                                self.service_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                self.service_name_regex.parent = self
                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"

                                                                                self.src_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                self.src_addr_ipv4.parent = self
                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"

                                                                                self.dst_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                self.dst_addr_ipv4.parent = self
                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"

                                                                                self.src_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                self.src_addr_ipv6.parent = self
                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"

                                                                                self.dst_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                self.dst_addr_ipv6.parent = self
                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"

                                                                                self.src_addr_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                self.src_addr_mac.parent = self
                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"

                                                                                self.timer = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                self.timer.parent = self
                                                                                self._children_name_map["timer"] = "timer"

                                                                                self.timer_regexp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                self.timer_regexp.parent = self
                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"

                                                                                self.tunnel_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                self.tunnel_name.parent = self
                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"

                                                                                self.tunnel_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                self.tunnel_name_regex.parent = self
                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"

                                                                                self.user_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                self.user_name.parent = self
                                                                                self._children_name_map["user_name"] = "user-name"

                                                                                self.user_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                self.user_name_regex.parent = self
                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"

                                                                                self.auth_username = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                self.auth_username.parent = self
                                                                                self._children_name_map["auth_username"] = "auth-username"

                                                                                self.auth_username_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                self.auth_username_regex.parent = self
                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"

                                                                                self.unauth_username = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                self.unauth_username.parent = self
                                                                                self._children_name_map["unauth_username"] = "unauth-username"

                                                                                self.unauth_username_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                self.unauth_username_regex.parent = self
                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"

                                                                                self.auth_domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                self.auth_domain.parent = self
                                                                                self._children_name_map["auth_domain"] = "auth-domain"

                                                                                self.auth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                self.auth_domain_regex.parent = self
                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"

                                                                                self.unauth_domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                self.unauth_domain.parent = self
                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"

                                                                                self.unauth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                self.unauth_domain_regex.parent = self
                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"

                                                                                self.vendor_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                self.vendor_id.parent = self
                                                                                self._children_name_map["vendor_id"] = "vendor-id"

                                                                                self.vendor_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                self.vendor_id_regex.parent = self
                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"

                                                                                self.access_interface = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                self.access_interface.parent = self
                                                                                self._children_name_map["access_interface"] = "access-interface"

                                                                                self.input_interface = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                self.input_interface.parent = self
                                                                                self._children_name_map["input_interface"] = "input-interface"

                                                                                self.input_intfhdl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                self.input_intfhdl.parent = self
                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"

                                                                                self.ethertype = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                self.ethertype.parent = self
                                                                                self._children_name_map["ethertype"] = "ethertype"

                                                                                self.flow_key_data = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                self.flow_key_data.parent = self
                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"

                                                                                self.dhcp_client_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                self.dhcp_client_id.parent = self
                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"

                                                                                self.dhcp_client_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                self.dhcp_client_id_regex.parent = self
                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"

                                                                                self.circuit_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                self.circuit_id.parent = self
                                                                                self._children_name_map["circuit_id"] = "circuit-id"

                                                                                self.circuit_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                self.circuit_id_regex.parent = self
                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"

                                                                                self.remote_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                self.remote_id.parent = self
                                                                                self._children_name_map["remote_id"] = "remote-id"

                                                                                self.remote_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                self.remote_id_regex.parent = self
                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"

                                                                                self.src_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                self.src_port.parent = self
                                                                                self._children_name_map["src_port"] = "src-port"

                                                                                self.dst_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                self.dst_port.parent = self
                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                self._segment_path = lambda: "match-data"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['type', 'mpls_top_eos', 'fragment_type', 'authen_status', 'mlp_negotiated'], name, value)


                                                                            class Ipv4Dscp(Entity):
                                                                                """
                                                                                IPv4 DSCP
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                    self.yang_name = "ipv4-dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv4-dscp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Ipv6Dscp(Entity):
                                                                                """
                                                                                IPv6 DSCP
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                    self.yang_name = "ipv6-dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv6-dscp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Dscp(Entity):
                                                                                """
                                                                                Match DSCP range array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                    self.yang_name = "dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "dscp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Ipv4Prec(Entity):
                                                                                """
                                                                                IPv4 Precedence
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                    self.yang_name = "ipv4-prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "ipv4-prec"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                            class Ipv6Prec(Entity):
                                                                                """
                                                                                IPv6 Precedence
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                    self.yang_name = "ipv6-prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "ipv6-prec"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                            class Prec(Entity):
                                                                                """
                                                                                Match Precedence array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                    self.yang_name = "prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "prec"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                            class DiscardClass(Entity):
                                                                                """
                                                                                Match Discard Class array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                    self.yang_name = "discard-class"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "discard-class"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                            class QosGroup(Entity):
                                                                                """
                                                                                Match QoS group array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                    self.yang_name = "qos-group"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "qos-group"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "qos-group"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class TrafficClass(Entity):
                                                                                """
                                                                                Match Traffic class array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                    self.yang_name = "traffic-class"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "traffic-class"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "traffic-class"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Proto(Entity):
                                                                                """
                                                                                Match Protocol array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                    self.yang_name = "proto"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "proto"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "proto"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class IcmpV4(Entity):
                                                                                """
                                                                                Match ICMPV4 Protocol
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Protocol type
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: code
                                                                                
                                                                                	Protocol code
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                    self.yang_name = "icmp-v4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                    ])
                                                                                    self.type = None
                                                                                    self.code = None
                                                                                    self._segment_path = lambda: "icmp-v4"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['type', 'code'], name, value)


                                                                            class IcmpV6(Entity):
                                                                                """
                                                                                Match ICMPV6 Protocol array
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Protocol type
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: code
                                                                                
                                                                                	Protocol code
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                    self.yang_name = "icmp-v6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                    ])
                                                                                    self.type = None
                                                                                    self.code = None
                                                                                    self._segment_path = lambda: "icmp-v6"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['type', 'code'], name, value)


                                                                            class Ipv4PacketLen(Entity):
                                                                                """
                                                                                IPv4 packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv4-packet-len"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class Ipv6PacketLen(Entity):
                                                                                """
                                                                                IPv6 packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv6-packet-len"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class PacketLen(Entity):
                                                                                """
                                                                                Match packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                    self.yang_name = "packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "packet-len"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class FlowTag(Entity):
                                                                                """
                                                                                Match flow\-tag array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                    self.yang_name = "flow-tag"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "flow-tag"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "flow-tag"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class TcpFlag(Entity):
                                                                                """
                                                                                Match tcp flag value
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	Value of TCP flag
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: match_any
                                                                                
                                                                                	Match any TCP flag bit
                                                                                	**type**\: bool
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                    self.yang_name = "tcp-flag"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                        ('match_any', (YLeaf(YType.boolean, 'match-any'), ['bool'])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.match_any = None
                                                                                    self._segment_path = lambda: "tcp-flag"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['value', 'match_any'], name, value)


                                                                            class Icmpv4Type(Entity):
                                                                                """
                                                                                Match ipv4 icmp type
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                    self.yang_name = "icmpv4-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv4-type"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Icmpv4Code(Entity):
                                                                                """
                                                                                Match ipv4 icmp code
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                    self.yang_name = "icmpv4-code"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv4-code"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Icmpv6Type(Entity):
                                                                                """
                                                                                Match ipv6 icmp type
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                    self.yang_name = "icmpv6-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv6-type"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class Icmpv6Code(Entity):
                                                                                """
                                                                                Match ipv6 icmp code
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                    self.yang_name = "icmpv6-code"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv6-code"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class MplsExp(Entity):
                                                                                """
                                                                                Match MPLS experimental topmost array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                    self.yang_name = "mpls-exp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "mpls-exp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                            class MplsExpImp(Entity):
                                                                                """
                                                                                Match MPLS experimental imposition array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "mpls-exp-imp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                            class MplsDispIpv4Acl(Entity):
                                                                                """
                                                                                MPLS Disposition IPv4 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                            class MplsDispIpv6Acl(Entity):
                                                                                """
                                                                                MPLS Disposition IPv6 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                            class MplsTopLabel(Entity):
                                                                                """
                                                                                MPLS Topmost LABEL
                                                                                
                                                                                .. attribute:: uint32_rng_array
                                                                                
                                                                                	uint32 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                    self.yang_name = "mpls-top-label"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint32_rng_array", ("uint32_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint32_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "mpls-top-label"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                class Uint32RngArray(Entity):
                                                                                    """
                                                                                    uint32 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                        self.yang_name = "uint32_rng_array"
                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint32, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint32, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint32_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['min', 'max'], name, value)


                                                                            class Cos(Entity):
                                                                                """
                                                                                Match CoS array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                    self.yang_name = "cos"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "cos"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                            class CosInr(Entity):
                                                                                """
                                                                                Match inner header CoS
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                    self.yang_name = "cos-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "cos-inr"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                            class Dei(Entity):
                                                                                """
                                                                                Match DEI Bit
                                                                                
                                                                                .. attribute:: bit_value
                                                                                
                                                                                	Value of the DEI bit
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                    self.yang_name = "dei"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                    ])
                                                                                    self.bit_value = None
                                                                                    self._segment_path = lambda: "dei"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                            class DeiInr(Entity):
                                                                                """
                                                                                Match inner DEI Bit
                                                                                
                                                                                .. attribute:: bit_value
                                                                                
                                                                                	Value of the DEI bit
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                    self.yang_name = "dei-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                    ])
                                                                                    self.bit_value = None
                                                                                    self._segment_path = lambda: "dei-inr"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                            class Vlan(Entity):
                                                                                """
                                                                                Match VLAN array
                                                                                
                                                                                .. attribute:: vlan_id_array
                                                                                
                                                                                	vlan id array
                                                                                	**type**\: list of  		 :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                    self.yang_name = "vlan"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("vlan-id-array", ("vlan_id_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.vlan_id_array = YList(self)
                                                                                    self._segment_path = lambda: "vlan"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                class VlanIdArray(Entity):
                                                                                    """
                                                                                    vlan id array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	VLAN mask
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                        self.yang_name = "vlan-id-array"
                                                                                        self.yang_parent_name = "vlan"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                            ('mask', (YLeaf(YType.uint16, 'mask'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self.mask = None
                                                                                        self._segment_path = lambda: "vlan-id-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['min', 'max', 'mask'], name, value)


                                                                            class VlanInr(Entity):
                                                                                """
                                                                                Match inner header VLAN range array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                    self.yang_name = "vlan-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "vlan-inr"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class FrDlci(Entity):
                                                                                """
                                                                                Match FR DLCI range array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                    self.yang_name = "fr-dlci"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "fr-dlci"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class SrcMac(Entity):
                                                                                """
                                                                                Match Source MAC address
                                                                                
                                                                                .. attribute:: mac_addr
                                                                                
                                                                                	MAC address
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	MAC mask
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                    self.yang_name = "src-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                    ])
                                                                                    self.mac_addr = []
                                                                                    self.mask = []
                                                                                    self._segment_path = lambda: "src-mac"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                            class DstMac(Entity):
                                                                                """
                                                                                Match Destination MAC address
                                                                                
                                                                                .. attribute:: mac_addr
                                                                                
                                                                                	MAC address
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	MAC mask
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                    self.yang_name = "dst-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                    ])
                                                                                    self.mac_addr = []
                                                                                    self.mask = []
                                                                                    self._segment_path = lambda: "dst-mac"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                            class AtmClp(Entity):
                                                                                """
                                                                                Match ATM CLP level
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                    self.yang_name = "atm-clp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "atm-clp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                            class FrDe(Entity):
                                                                                """
                                                                                Match FR DE value
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                    self.yang_name = "fr-de"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "fr-de"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                            class Ipv4Acl(Entity):
                                                                                """
                                                                                IPv4 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                    self.yang_name = "ipv4-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "ipv4-acl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                            class Ipv6Acl(Entity):
                                                                                """
                                                                                IPv6 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                    self.yang_name = "ipv6-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "ipv6-acl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                            class EtherServiceAcl(Entity):
                                                                                """
                                                                                Ethernet\-Services Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                    self.yang_name = "ether-service-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "ether-service-acl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                            class AvailId(Entity):
                                                                                """
                                                                                Available Identifiers
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                    self.yang_name = "avail-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "avail-id"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                            class MediaType(Entity):
                                                                                """
                                                                                Media Type
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                    self.yang_name = "media-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "media-type"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                            class SubsProtocol(Entity):
                                                                                """
                                                                                Protocol
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                    self.yang_name = "subs-protocol"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint8_array = []
                                                                                    self._segment_path = lambda: "subs-protocol"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                            class Dnis(Entity):
                                                                                """
                                                                                DNIS
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                    self.yang_name = "dnis"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "dnis"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                            class DnisRegex(Entity):
                                                                                """
                                                                                DNIS Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                    self.yang_name = "dnis-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "dnis-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                            class Domain(Entity):
                                                                                """
                                                                                Domain Name
                                                                                
                                                                                .. attribute:: domain_array
                                                                                
                                                                                	domain array
                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                    self.yang_name = "domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.domain_array = YList(self)
                                                                                    self._segment_path = lambda: "domain"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                class DomainArray(Entity):
                                                                                    """
                                                                                    domain array
                                                                                    
                                                                                    .. attribute:: domain_name
                                                                                    
                                                                                    	domain name
                                                                                    	**type**\: str
                                                                                    
                                                                                    .. attribute:: format_name
                                                                                    
                                                                                    	format name
                                                                                    	**type**\: str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                        self.yang_name = "domain-array"
                                                                                        self.yang_parent_name = "domain"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                        ])
                                                                                        self.domain_name = None
                                                                                        self.format_name = None
                                                                                        self._segment_path = lambda: "domain-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                            class DomainRegex(Entity):
                                                                                """
                                                                                Domain Regular Expression
                                                                                
                                                                                .. attribute:: domain_array
                                                                                
                                                                                	domain array
                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                    self.yang_name = "domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.domain_array = YList(self)
                                                                                    self._segment_path = lambda: "domain-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                class DomainArray(Entity):
                                                                                    """
                                                                                    domain array
                                                                                    
                                                                                    .. attribute:: domain_name
                                                                                    
                                                                                    	domain name
                                                                                    	**type**\: str
                                                                                    
                                                                                    .. attribute:: format_name
                                                                                    
                                                                                    	format name
                                                                                    	**type**\: str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                        self.yang_name = "domain-array"
                                                                                        self.yang_parent_name = "domain-regex"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                        ])
                                                                                        self.domain_name = None
                                                                                        self.format_name = None
                                                                                        self._segment_path = lambda: "domain-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                            class NasPort(Entity):
                                                                                """
                                                                                NAS Port
                                                                                
                                                                                .. attribute:: nas_port_array
                                                                                
                                                                                	nas port array
                                                                                	**type**\: list of  		 :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                    self.yang_name = "nas-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("nas-port-array", ("nas_port_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.nas_port_array = YList(self)
                                                                                    self._segment_path = lambda: "nas-port"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                class NasPortArray(Entity):
                                                                                    """
                                                                                    nas port array
                                                                                    
                                                                                    .. attribute:: sub_id
                                                                                    
                                                                                    	sub id
                                                                                    	**type**\:  :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                    
                                                                                    .. attribute:: operator
                                                                                    
                                                                                    	operator
                                                                                    	**type**\:  :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                        self.yang_name = "nas-port-array"
                                                                                        self.yang_parent_name = "nas-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('sub_id', (YLeaf(YType.enumeration, 'sub-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchNasPortSubIdEn', '')])),
                                                                                            ('operator', (YLeaf(YType.enumeration, 'operator'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchLogicalOperatorEn', '')])),
                                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ])
                                                                                        self.sub_id = None
                                                                                        self.operator = None
                                                                                        self.value = None
                                                                                        self._segment_path = lambda: "nas-port-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['sub_id', 'operator', 'value'], name, value)


                                                                            class ServiceName(Entity):
                                                                                """
                                                                                Service Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                    self.yang_name = "service-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "service-name"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                            class ServiceNameRegex(Entity):
                                                                                """
                                                                                Service Name Regular Exp
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                    self.yang_name = "service-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "service-name-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                            class SrcAddrIpv4(Entity):
                                                                                """
                                                                                Source Address IPV4
                                                                                
                                                                                .. attribute:: ipv4_addr_array
                                                                                
                                                                                	ipv4 addr array
                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.ipv4_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-ipv4"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                class Ipv4AddrArray(Entity):
                                                                                    """
                                                                                    ipv4 addr array
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	prefix
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	mask
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                        ])
                                                                                        self.prefix = None
                                                                                        self.mask = None
                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                            class DstAddrIpv4(Entity):
                                                                                """
                                                                                Destination Address IPV4
                                                                                
                                                                                .. attribute:: ipv4_addr_array
                                                                                
                                                                                	ipv4 addr array
                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.ipv4_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-addr-ipv4"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                class Ipv4AddrArray(Entity):
                                                                                    """
                                                                                    ipv4 addr array
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	prefix
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	mask
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                        ])
                                                                                        self.prefix = None
                                                                                        self.mask = None
                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                            class SrcAddrIpv6(Entity):
                                                                                """
                                                                                Source Address IPV6
                                                                                
                                                                                .. attribute:: ipv6_addr_array
                                                                                
                                                                                	ipv6 addr array
                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.ipv6_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-ipv6"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                class Ipv6AddrArray(Entity):
                                                                                    """
                                                                                    ipv6 addr array
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	IPV6 prefix
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	IPV6 mask
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                        ])
                                                                                        self.prefix = None
                                                                                        self.mask = None
                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                            class DstAddrIpv6(Entity):
                                                                                """
                                                                                Destination Address IPV6
                                                                                
                                                                                .. attribute:: ipv6_addr_array
                                                                                
                                                                                	ipv6 addr array
                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.ipv6_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-addr-ipv6"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                class Ipv6AddrArray(Entity):
                                                                                    """
                                                                                    ipv6 addr array
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	IPV6 prefix
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	IPV6 mask
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                        ])
                                                                                        self.prefix = None
                                                                                        self.mask = None
                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                            class SrcAddrMac(Entity):
                                                                                """
                                                                                Source Address MAC
                                                                                
                                                                                .. attribute:: mac_addr_array
                                                                                
                                                                                	mac addr array
                                                                                	**type**\: list of  		 :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                    self.yang_name = "src-addr-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("mac-addr-array", ("mac_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.mac_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-mac"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                class MacAddrArray(Entity):
                                                                                    """
                                                                                    mac addr array
                                                                                    
                                                                                    .. attribute:: mac_addr
                                                                                    
                                                                                    	MAC address
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	MAC mask
                                                                                    	**type**\: list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                        self.yang_name = "mac-addr-array"
                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                            ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                        ])
                                                                                        self.mac_addr = []
                                                                                        self.mask = []
                                                                                        self._segment_path = lambda: "mac-addr-array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                            class Timer(Entity):
                                                                                """
                                                                                Timer
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                    self.yang_name = "timer"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "timer"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                            class TimerRegexp(Entity):
                                                                                """
                                                                                Timer Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                    self.yang_name = "timer-regexp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "timer-regexp"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                            class TunnelName(Entity):
                                                                                """
                                                                                Tunnel Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                    self.yang_name = "tunnel-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "tunnel-name"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                            class TunnelNameRegex(Entity):
                                                                                """
                                                                                Tunnel Name Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "tunnel-name-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                            class UserName(Entity):
                                                                                """
                                                                                User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                    self.yang_name = "user-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "user-name"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                            class UserNameRegex(Entity):
                                                                                """
                                                                                User Name Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                    self.yang_name = "user-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "user-name-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                            class AuthUsername(Entity):
                                                                                """
                                                                                Authenticated User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                    self.yang_name = "auth-username"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "auth-username"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                            class AuthUsernameRegex(Entity):
                                                                                """
                                                                                Authenticated User Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                    self.yang_name = "auth-username-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "auth-username-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                            class UnauthUsername(Entity):
                                                                                """
                                                                                Unauthenticated User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                    self.yang_name = "unauth-username"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "unauth-username"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                            class UnauthUsernameRegex(Entity):
                                                                                """
                                                                                Unauthenticated User Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                    self.yang_name = "unauth-username-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "unauth-username-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                            class AuthDomain(Entity):
                                                                                """
                                                                                Authenticated domain name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                    self.yang_name = "auth-domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "auth-domain"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                            class AuthDomainRegex(Entity):
                                                                                """
                                                                                Authenticated Domain Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                    self.yang_name = "auth-domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "auth-domain-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                            class UnauthDomain(Entity):
                                                                                """
                                                                                Unauthenticated Domain Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                    self.yang_name = "unauth-domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "unauth-domain"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                            class UnauthDomainRegex(Entity):
                                                                                """
                                                                                Unauthenticated Domain Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "unauth-domain-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                            class VendorId(Entity):
                                                                                """
                                                                                Vendor ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                    self.yang_name = "vendor-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "vendor-id"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                            class VendorIdRegex(Entity):
                                                                                """
                                                                                Vendor ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                    self.yang_name = "vendor-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "vendor-id-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                            class AccessInterface(Entity):
                                                                                """
                                                                                Access interface
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                    self.yang_name = "access-interface"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "access-interface"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                            class InputInterface(Entity):
                                                                                """
                                                                                Input interface
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                    self.yang_name = "input-interface"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "input-interface"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                            class InputIntfhdl(Entity):
                                                                                """
                                                                                Input interface handle
                                                                                
                                                                                .. attribute:: uint64_array
                                                                                
                                                                                	uint64 array
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..18446744073709551615
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                    self.yang_name = "input-intfhdl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('uint64_array', (YLeafList(YType.uint64, 'uint64_array'), ['int'])),
                                                                                    ])
                                                                                    self.uint64_array = []
                                                                                    self._segment_path = lambda: "input-intfhdl"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                            class Ethertype(Entity):
                                                                                """
                                                                                Ethernet type
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                    self.yang_name = "ethertype"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ethertype"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ethertype"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class FlowKeyData(Entity):
                                                                                """
                                                                                Flow key structure
                                                                                
                                                                                .. attribute:: flow_keys
                                                                                
                                                                                	flow keys
                                                                                	**type**\:  :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                
                                                                                .. attribute:: max_count
                                                                                
                                                                                	Maximum count of flows
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: idle_timeout
                                                                                
                                                                                	Idle timeout of flows (in seconds)
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                	**units**\: second
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                    self.yang_name = "flow-key-data"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("flow-keys", ("flow_keys", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('max_count', (YLeaf(YType.uint16, 'max-count'), ['int'])),
                                                                                        ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                                    ])
                                                                                    self.max_count = None
                                                                                    self.idle_timeout = None

                                                                                    self.flow_keys = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                    self.flow_keys.parent = self
                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                    self._segment_path = lambda: "flow-key-data"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['max_count', 'idle_timeout'], name, value)


                                                                                class FlowKeys(Entity):
                                                                                    """
                                                                                    flow keys
                                                                                    
                                                                                    .. attribute:: keys
                                                                                    
                                                                                    	keys
                                                                                    	**type**\: str
                                                                                    
                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                    
                                                                                    .. attribute:: num
                                                                                    
                                                                                    	num
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                        self.yang_name = "flow-keys"
                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('keys', (YLeaf(YType.str, 'keys'), ['str'])),
                                                                                            ('num', (YLeaf(YType.uint8, 'num'), ['int'])),
                                                                                        ])
                                                                                        self.keys = None
                                                                                        self.num = None
                                                                                        self._segment_path = lambda: "flow-keys"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                            class DhcpClientId(Entity):
                                                                                """
                                                                                Dhcp Client ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                    self.yang_name = "dhcp-client-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "dhcp-client-id"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                            class DhcpClientIdRegex(Entity):
                                                                                """
                                                                                Dhcp Client ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                            class CircuitId(Entity):
                                                                                """
                                                                                Circuit ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                    self.yang_name = "circuit-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "circuit-id"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                            class CircuitIdRegex(Entity):
                                                                                """
                                                                                Circuit ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                    self.yang_name = "circuit-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "circuit-id-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                            class RemoteId(Entity):
                                                                                """
                                                                                Remote ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                    self.yang_name = "remote-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "remote-id"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                            class RemoteIdRegex(Entity):
                                                                                """
                                                                                Remote ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\: list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                    self.yang_name = "remote-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                    ])
                                                                                    self.string_array = []
                                                                                    self._segment_path = lambda: "remote-id-regex"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                            class SrcPort(Entity):
                                                                                """
                                                                                Source port
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                    self.yang_name = "src-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "src-port"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "src-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                            class DstPort(Entity):
                                                                                """
                                                                                Destination port
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                    self.yang_name = "dst-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-port"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "dst-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['min', 'max'], name, value)


                                                        class ActInfop(Entity):
                                                            """
                                                            act infop
                                                            
                                                            .. attribute:: policy_action_info_st
                                                            
                                                            	policy action info st
                                                            	**type**\: list of  		 :py:class:`PolicyActionInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'infra-policymgr-oper'
                                                            _revision = '2018-01-17'

                                                            def __init__(self):
                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop, self).__init__()

                                                                self.yang_name = "act-infop"
                                                                self.yang_parent_name = "policy-class-info-bg"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("policy-action-info-st", ("policy_action_info_st", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt))])
                                                                self._leafs = OrderedDict()

                                                                self.policy_action_info_st = YList(self)
                                                                self._segment_path = lambda: "act-infop"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop, [], name, value)


                                                            class PolicyActionInfoSt(Entity):
                                                                """
                                                                policy action info st
                                                                
                                                                .. attribute:: actp
                                                                
                                                                	actp
                                                                	**type**\:  :py:class:`Actp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp>`
                                                                
                                                                .. attribute:: seq
                                                                
                                                                	seq
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..65535
                                                                
                                                                .. attribute:: flags
                                                                
                                                                	flags
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..65535
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt, self).__init__()

                                                                    self.yang_name = "policy-action-info-st"
                                                                    self.yang_parent_name = "act-infop"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("actp", ("actp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp))])
                                                                    self._leafs = OrderedDict([
                                                                        ('seq', (YLeaf(YType.uint16, 'seq'), ['int'])),
                                                                        ('flags', (YLeaf(YType.uint16, 'flags'), ['int'])),
                                                                    ])
                                                                    self.seq = None
                                                                    self.flags = None

                                                                    self.actp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp()
                                                                    self.actp.parent = self
                                                                    self._children_name_map["actp"] = "actp"
                                                                    self._segment_path = lambda: "policy-action-info-st"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt, ['seq', 'flags'], name, value)


                                                                class Actp(Entity):
                                                                    """
                                                                    actp
                                                                    
                                                                    .. attribute:: mark
                                                                    
                                                                    	mark
                                                                    	**type**\:  :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark>`
                                                                    
                                                                    .. attribute:: mark2
                                                                    
                                                                    	mark2
                                                                    	**type**\:  :py:class:`Mark2 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2>`
                                                                    
                                                                    .. attribute:: wred
                                                                    
                                                                    	wred
                                                                    	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred>`
                                                                    
                                                                    .. attribute:: encap
                                                                    
                                                                    	encap
                                                                    	**type**\:  :py:class:`Encap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap>`
                                                                    
                                                                    .. attribute:: prio
                                                                    
                                                                    	prio
                                                                    	**type**\:  :py:class:`Prio <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio>`
                                                                    
                                                                    .. attribute:: bwrem
                                                                    
                                                                    	bwrem
                                                                    	**type**\:  :py:class:`Bwrem <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem>`
                                                                    
                                                                    .. attribute:: min_bw
                                                                    
                                                                    	min bw
                                                                    	**type**\:  :py:class:`MinBw <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw>`
                                                                    
                                                                    .. attribute:: authen_aaa
                                                                    
                                                                    	authen aaa
                                                                    	**type**\:  :py:class:`AuthenAaa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa>`
                                                                    
                                                                    .. attribute:: collect_id
                                                                    
                                                                    	collect id
                                                                    	**type**\:  :py:class:`CollectId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId>`
                                                                    
                                                                    .. attribute:: decode_id
                                                                    
                                                                    	decode id
                                                                    	**type**\:  :py:class:`DecodeId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId>`
                                                                    
                                                                    .. attribute:: set_timer
                                                                    
                                                                    	set timer
                                                                    	**type**\:  :py:class:`SetTimer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer>`
                                                                    
                                                                    .. attribute:: stop_timer
                                                                    
                                                                    	stop timer
                                                                    	**type**\:  :py:class:`StopTimer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer>`
                                                                    
                                                                    .. attribute:: acct_aaa_list
                                                                    
                                                                    	acct aaa list
                                                                    	**type**\:  :py:class:`AcctAaaList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList>`
                                                                    
                                                                    .. attribute:: query_ancp
                                                                    
                                                                    	query ancp
                                                                    	**type**\:  :py:class:`QueryAncp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp>`
                                                                    
                                                                    .. attribute:: prepaid_cfg
                                                                    
                                                                    	prepaid cfg
                                                                    	**type**\:  :py:class:`PrepaidCfg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg>`
                                                                    
                                                                    .. attribute:: timeout_idle
                                                                    
                                                                    	timeout idle
                                                                    	**type**\:  :py:class:`TimeoutIdle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle>`
                                                                    
                                                                    .. attribute:: proxy_aaa
                                                                    
                                                                    	proxy aaa
                                                                    	**type**\:  :py:class:`ProxyAaa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa>`
                                                                    
                                                                    .. attribute:: act_template
                                                                    
                                                                    	act template
                                                                    	**type**\:  :py:class:`ActTemplate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate>`
                                                                    
                                                                    .. attribute:: deact_template
                                                                    
                                                                    	deact template
                                                                    	**type**\:  :py:class:`DeactTemplate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate>`
                                                                    
                                                                    .. attribute:: qlimit
                                                                    
                                                                    	qlimit
                                                                    	**type**\:  :py:class:`Qlimit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit>`
                                                                    
                                                                    .. attribute:: accounting_event_aaa
                                                                    
                                                                    	accounting event aaa
                                                                    	**type**\:  :py:class:`AccountingEventAaa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa>`
                                                                    
                                                                    .. attribute:: authorize_id
                                                                    
                                                                    	authorize id
                                                                    	**type**\:  :py:class:`AuthorizeId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId>`
                                                                    
                                                                    .. attribute:: afm_react
                                                                    
                                                                    	afm react
                                                                    	**type**\:  :py:class:`AfmReact <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact>`
                                                                    
                                                                    .. attribute:: httpr
                                                                    
                                                                    	httpr
                                                                    	**type**\:  :py:class:`Httpr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr>`
                                                                    
                                                                    .. attribute:: punt
                                                                    
                                                                    	punt
                                                                    	**type**\:  :py:class:`Punt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt>`
                                                                    
                                                                    .. attribute:: copy
                                                                    
                                                                    	copy
                                                                    	**type**\:  :py:class:`Copy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy>`
                                                                    
                                                                    .. attribute:: sfrag
                                                                    
                                                                    	sfrag
                                                                    	**type**\:  :py:class:`Sfrag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag>`
                                                                    
                                                                    .. attribute:: redirect
                                                                    
                                                                    	redirect
                                                                    	**type**\:  :py:class:`Redirect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect>`
                                                                    
                                                                    .. attribute:: out_intf
                                                                    
                                                                    	out intf
                                                                    	**type**\:  :py:class:`OutIntf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf>`
                                                                    
                                                                    .. attribute:: serv_func
                                                                    
                                                                    	serv func
                                                                    	**type**\:  :py:class:`ServFunc <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc>`
                                                                    
                                                                    .. attribute:: police
                                                                    
                                                                    	police
                                                                    	**type**\:  :py:class:`Police <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police>`
                                                                    
                                                                    .. attribute:: shape
                                                                    
                                                                    	shape
                                                                    	**type**\:  :py:class:`Shape <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape>`
                                                                    
                                                                    .. attribute:: child_policy
                                                                    
                                                                    	child policy
                                                                    	**type**\:  :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy>`
                                                                    
                                                                    .. attribute:: cac
                                                                    
                                                                    	cac
                                                                    	**type**\:  :py:class:`Cac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac>`
                                                                    
                                                                    .. attribute:: pfc
                                                                    
                                                                    	pfc
                                                                    	**type**\:  :py:class:`Pfc <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc>`
                                                                    
                                                                    .. attribute:: flow_parm
                                                                    
                                                                    	flow parm
                                                                    	**type**\:  :py:class:`FlowParm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm>`
                                                                    
                                                                    .. attribute:: ipcbr
                                                                    
                                                                    	ipcbr
                                                                    	**type**\:  :py:class:`Ipcbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr>`
                                                                    
                                                                    .. attribute:: rtp
                                                                    
                                                                    	rtp
                                                                    	**type**\:  :py:class:`Rtp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp>`
                                                                    
                                                                    .. attribute:: rtp_mmr
                                                                    
                                                                    	rtp mmr
                                                                    	**type**\:  :py:class:`RtpMmr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr>`
                                                                    
                                                                    .. attribute:: rtp_j2k
                                                                    
                                                                    	rtp j2k
                                                                    	**type**\:  :py:class:`RtpJ2k <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k>`
                                                                    
                                                                    .. attribute:: rtp_voice
                                                                    
                                                                    	rtp voice
                                                                    	**type**\:  :py:class:`RtpVoice <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice>`
                                                                    
                                                                    .. attribute:: mdi
                                                                    
                                                                    	mdi
                                                                    	**type**\:  :py:class:`Mdi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi>`
                                                                    
                                                                    .. attribute:: mdi_rtp
                                                                    
                                                                    	mdi rtp
                                                                    	**type**\:  :py:class:`MdiRtp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp>`
                                                                    
                                                                    .. attribute:: fmm
                                                                    
                                                                    	fmm
                                                                    	**type**\:  :py:class:`Fmm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm>`
                                                                    
                                                                    .. attribute:: pbf
                                                                    
                                                                    	pbf
                                                                    	**type**\:  :py:class:`Pbf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf>`
                                                                    
                                                                    .. attribute:: ipv4_nh
                                                                    
                                                                    	ipv4 nh
                                                                    	**type**\:  :py:class:`Ipv4Nh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh>`
                                                                    
                                                                    .. attribute:: ipv6_nh
                                                                    
                                                                    	ipv6 nh
                                                                    	**type**\:  :py:class:`Ipv6Nh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh>`
                                                                    
                                                                    .. attribute:: type
                                                                    
                                                                    	type
                                                                    	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                    
                                                                    .. attribute:: data_p
                                                                    
                                                                    	data p
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp, self).__init__()

                                                                        self.yang_name = "actp"
                                                                        self.yang_parent_name = "policy-action-info-st"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("mark", ("mark", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark)), ("mark2", ("mark2", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2)), ("wred", ("wred", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred)), ("encap", ("encap", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap)), ("prio", ("prio", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio)), ("bwrem", ("bwrem", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem)), ("min-bw", ("min_bw", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw)), ("authen-aaa", ("authen_aaa", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa)), ("collect-id", ("collect_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId)), ("decode-id", ("decode_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId)), ("set-timer", ("set_timer", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer)), ("stop-timer", ("stop_timer", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer)), ("acct-aaa-list", ("acct_aaa_list", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList)), ("query-ancp", ("query_ancp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp)), ("prepaid-cfg", ("prepaid_cfg", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg)), ("timeout-idle", ("timeout_idle", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle)), ("proxy-aaa", ("proxy_aaa", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa)), ("act-template", ("act_template", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate)), ("deact-template", ("deact_template", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate)), ("qlimit", ("qlimit", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit)), ("accounting-event-aaa", ("accounting_event_aaa", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa)), ("authorize-id", ("authorize_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId)), ("afm-react", ("afm_react", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact)), ("httpr", ("httpr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr)), ("punt", ("punt", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt)), ("copy", ("copy", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy)), ("sfrag", ("sfrag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag)), ("redirect", ("redirect", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect)), ("out-intf", ("out_intf", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf)), ("serv-func", ("serv_func", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc)), ("police", ("police", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police)), ("shape", ("shape", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape)), ("child-policy", ("child_policy", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy)), ("cac", ("cac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac)), ("pfc", ("pfc", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc)), ("flow-parm", ("flow_parm", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm)), ("ipcbr", ("ipcbr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr)), ("rtp", ("rtp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp)), ("rtp-mmr", ("rtp_mmr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr)), ("rtp-j2k", ("rtp_j2k", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k)), ("rtp-voice", ("rtp_voice", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice)), ("mdi", ("mdi", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi)), ("mdi-rtp", ("mdi_rtp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp)), ("fmm", ("fmm", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm)), ("pbf", ("pbf", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf)), ("ipv4-nh", ("ipv4_nh", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh)), ("ipv6-nh", ("ipv6_nh", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh))])
                                                                        self._leafs = OrderedDict([
                                                                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                            ('data_p', (YLeaf(YType.uint32, 'data-p'), ['int'])),
                                                                        ])
                                                                        self.type = None
                                                                        self.data_p = None

                                                                        self.mark = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark()
                                                                        self.mark.parent = self
                                                                        self._children_name_map["mark"] = "mark"

                                                                        self.mark2 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2()
                                                                        self.mark2.parent = self
                                                                        self._children_name_map["mark2"] = "mark2"

                                                                        self.wred = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred()
                                                                        self.wred.parent = self
                                                                        self._children_name_map["wred"] = "wred"

                                                                        self.encap = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap()
                                                                        self.encap.parent = self
                                                                        self._children_name_map["encap"] = "encap"

                                                                        self.prio = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio()
                                                                        self.prio.parent = self
                                                                        self._children_name_map["prio"] = "prio"

                                                                        self.bwrem = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem()
                                                                        self.bwrem.parent = self
                                                                        self._children_name_map["bwrem"] = "bwrem"

                                                                        self.min_bw = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw()
                                                                        self.min_bw.parent = self
                                                                        self._children_name_map["min_bw"] = "min-bw"

                                                                        self.authen_aaa = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa()
                                                                        self.authen_aaa.parent = self
                                                                        self._children_name_map["authen_aaa"] = "authen-aaa"

                                                                        self.collect_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId()
                                                                        self.collect_id.parent = self
                                                                        self._children_name_map["collect_id"] = "collect-id"

                                                                        self.decode_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId()
                                                                        self.decode_id.parent = self
                                                                        self._children_name_map["decode_id"] = "decode-id"

                                                                        self.set_timer = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer()
                                                                        self.set_timer.parent = self
                                                                        self._children_name_map["set_timer"] = "set-timer"

                                                                        self.stop_timer = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer()
                                                                        self.stop_timer.parent = self
                                                                        self._children_name_map["stop_timer"] = "stop-timer"

                                                                        self.acct_aaa_list = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList()
                                                                        self.acct_aaa_list.parent = self
                                                                        self._children_name_map["acct_aaa_list"] = "acct-aaa-list"

                                                                        self.query_ancp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp()
                                                                        self.query_ancp.parent = self
                                                                        self._children_name_map["query_ancp"] = "query-ancp"

                                                                        self.prepaid_cfg = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg()
                                                                        self.prepaid_cfg.parent = self
                                                                        self._children_name_map["prepaid_cfg"] = "prepaid-cfg"

                                                                        self.timeout_idle = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle()
                                                                        self.timeout_idle.parent = self
                                                                        self._children_name_map["timeout_idle"] = "timeout-idle"

                                                                        self.proxy_aaa = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa()
                                                                        self.proxy_aaa.parent = self
                                                                        self._children_name_map["proxy_aaa"] = "proxy-aaa"

                                                                        self.act_template = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate()
                                                                        self.act_template.parent = self
                                                                        self._children_name_map["act_template"] = "act-template"

                                                                        self.deact_template = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate()
                                                                        self.deact_template.parent = self
                                                                        self._children_name_map["deact_template"] = "deact-template"

                                                                        self.qlimit = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit()
                                                                        self.qlimit.parent = self
                                                                        self._children_name_map["qlimit"] = "qlimit"

                                                                        self.accounting_event_aaa = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa()
                                                                        self.accounting_event_aaa.parent = self
                                                                        self._children_name_map["accounting_event_aaa"] = "accounting-event-aaa"

                                                                        self.authorize_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId()
                                                                        self.authorize_id.parent = self
                                                                        self._children_name_map["authorize_id"] = "authorize-id"

                                                                        self.afm_react = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact()
                                                                        self.afm_react.parent = self
                                                                        self._children_name_map["afm_react"] = "afm-react"

                                                                        self.httpr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr()
                                                                        self.httpr.parent = self
                                                                        self._children_name_map["httpr"] = "httpr"

                                                                        self.punt = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt()
                                                                        self.punt.parent = self
                                                                        self._children_name_map["punt"] = "punt"

                                                                        self.copy = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy()
                                                                        self.copy.parent = self
                                                                        self._children_name_map["copy"] = "copy"

                                                                        self.sfrag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag()
                                                                        self.sfrag.parent = self
                                                                        self._children_name_map["sfrag"] = "sfrag"

                                                                        self.redirect = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect()
                                                                        self.redirect.parent = self
                                                                        self._children_name_map["redirect"] = "redirect"

                                                                        self.out_intf = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf()
                                                                        self.out_intf.parent = self
                                                                        self._children_name_map["out_intf"] = "out-intf"

                                                                        self.serv_func = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc()
                                                                        self.serv_func.parent = self
                                                                        self._children_name_map["serv_func"] = "serv-func"

                                                                        self.police = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police()
                                                                        self.police.parent = self
                                                                        self._children_name_map["police"] = "police"

                                                                        self.shape = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape()
                                                                        self.shape.parent = self
                                                                        self._children_name_map["shape"] = "shape"

                                                                        self.child_policy = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy()
                                                                        self.child_policy.parent = self
                                                                        self._children_name_map["child_policy"] = "child-policy"

                                                                        self.cac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac()
                                                                        self.cac.parent = self
                                                                        self._children_name_map["cac"] = "cac"

                                                                        self.pfc = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc()
                                                                        self.pfc.parent = self
                                                                        self._children_name_map["pfc"] = "pfc"

                                                                        self.flow_parm = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm()
                                                                        self.flow_parm.parent = self
                                                                        self._children_name_map["flow_parm"] = "flow-parm"

                                                                        self.ipcbr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr()
                                                                        self.ipcbr.parent = self
                                                                        self._children_name_map["ipcbr"] = "ipcbr"

                                                                        self.rtp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp()
                                                                        self.rtp.parent = self
                                                                        self._children_name_map["rtp"] = "rtp"

                                                                        self.rtp_mmr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr()
                                                                        self.rtp_mmr.parent = self
                                                                        self._children_name_map["rtp_mmr"] = "rtp-mmr"

                                                                        self.rtp_j2k = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k()
                                                                        self.rtp_j2k.parent = self
                                                                        self._children_name_map["rtp_j2k"] = "rtp-j2k"

                                                                        self.rtp_voice = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice()
                                                                        self.rtp_voice.parent = self
                                                                        self._children_name_map["rtp_voice"] = "rtp-voice"

                                                                        self.mdi = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi()
                                                                        self.mdi.parent = self
                                                                        self._children_name_map["mdi"] = "mdi"

                                                                        self.mdi_rtp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp()
                                                                        self.mdi_rtp.parent = self
                                                                        self._children_name_map["mdi_rtp"] = "mdi-rtp"

                                                                        self.fmm = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm()
                                                                        self.fmm.parent = self
                                                                        self._children_name_map["fmm"] = "fmm"

                                                                        self.pbf = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf()
                                                                        self.pbf.parent = self
                                                                        self._children_name_map["pbf"] = "pbf"

                                                                        self.ipv4_nh = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh()
                                                                        self.ipv4_nh.parent = self
                                                                        self._children_name_map["ipv4_nh"] = "ipv4-nh"

                                                                        self.ipv6_nh = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh()
                                                                        self.ipv6_nh.parent = self
                                                                        self._children_name_map["ipv6_nh"] = "ipv6-nh"
                                                                        self._segment_path = lambda: "actp"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp, ['type', 'data_p'], name, value)


                                                                    class Mark(Entity):
                                                                        """
                                                                        mark
                                                                        
                                                                        .. attribute:: action_mark_info
                                                                        
                                                                        	action mark info
                                                                        	**type**\: list of  		 :py:class:`ActionMarkInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark, self).__init__()

                                                                            self.yang_name = "mark"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("action-mark-info", ("action_mark_info", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo))])
                                                                            self._leafs = OrderedDict()

                                                                            self.action_mark_info = YList(self)
                                                                            self._segment_path = lambda: "mark"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark, [], name, value)


                                                                        class ActionMarkInfo(Entity):
                                                                            """
                                                                            action mark info
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:  :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                            
                                                                            .. attribute:: mark_flags
                                                                            
                                                                            	mark flags
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo, self).__init__()

                                                                                self.yang_name = "action-mark-info"
                                                                                self.yang_parent_name = "mark"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MarkTypeEn', '')])),
                                                                                    ('mark_flags', (YLeaf(YType.uint32, 'mark-flags'), ['int'])),
                                                                                    ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                ])
                                                                                self.type = None
                                                                                self.mark_flags = None
                                                                                self.value = None
                                                                                self._segment_path = lambda: "action-mark-info"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo, ['type', 'mark_flags', 'value'], name, value)


                                                                    class Mark2(Entity):
                                                                        """
                                                                        mark2
                                                                        
                                                                        .. attribute:: action_mark2_info
                                                                        
                                                                        	action mark2 info
                                                                        	**type**\: list of  		 :py:class:`ActionMark2Info <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2, self).__init__()

                                                                            self.yang_name = "mark2"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("action-mark2-info", ("action_mark2_info", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info))])
                                                                            self._leafs = OrderedDict()

                                                                            self.action_mark2_info = YList(self)
                                                                            self._segment_path = lambda: "mark2"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2, [], name, value)


                                                                        class ActionMark2Info(Entity):
                                                                            """
                                                                            action mark2 info
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: value_overflow
                                                                            
                                                                            	value overflow
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: mark_flags
                                                                            
                                                                            	mark flags
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info, self).__init__()

                                                                                self.yang_name = "action-mark2-info"
                                                                                self.yang_parent_name = "mark2"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('value_overflow', (YLeaf(YType.uint16, 'value-overflow'), ['int'])),
                                                                                    ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                    ('mark_flags', (YLeaf(YType.uint8, 'mark-flags'), ['int'])),
                                                                                ])
                                                                                self.value = None
                                                                                self.value_overflow = None
                                                                                self.type = None
                                                                                self.mark_flags = None
                                                                                self._segment_path = lambda: "action-mark2-info"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info, ['value', 'value_overflow', 'type', 'mark_flags'], name, value)


                                                                    class Wred(Entity):
                                                                        """
                                                                        wred
                                                                        
                                                                        .. attribute:: action_wred_info
                                                                        
                                                                        	action wred info
                                                                        	**type**\: list of  		 :py:class:`ActionWredInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred, self).__init__()

                                                                            self.yang_name = "wred"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("action-wred-info", ("action_wred_info", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo))])
                                                                            self._leafs = OrderedDict()

                                                                            self.action_wred_info = YList(self)
                                                                            self._segment_path = lambda: "wred"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred, [], name, value)


                                                                        class ActionWredInfo(Entity):
                                                                            """
                                                                            action wred info
                                                                            
                                                                            .. attribute:: match_ranges
                                                                            
                                                                            	match ranges
                                                                            	**type**\:  :py:class:`MatchRanges <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges>`
                                                                            
                                                                            .. attribute:: min_threshold
                                                                            
                                                                            	min threshold
                                                                            	**type**\:  :py:class:`MinThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold>`
                                                                            
                                                                            .. attribute:: max_threshold
                                                                            
                                                                            	max threshold
                                                                            	**type**\:  :py:class:`MaxThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold>`
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	cos/prec/dscp/ based WRED
                                                                            	**type**\:  :py:class:`WredTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.WredTypeEn>`
                                                                            
                                                                            .. attribute:: wred_flags
                                                                            
                                                                            	wred flags
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: probability
                                                                            
                                                                            	probability
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo, self).__init__()

                                                                                self.yang_name = "action-wred-info"
                                                                                self.yang_parent_name = "wred"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("match-ranges", ("match_ranges", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges)), ("min-threshold", ("min_threshold", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold)), ("max-threshold", ("max_threshold", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'WredTypeEn', '')])),
                                                                                    ('wred_flags', (YLeaf(YType.uint32, 'wred-flags'), ['int'])),
                                                                                    ('probability', (YLeaf(YType.uint32, 'probability'), ['int'])),
                                                                                ])
                                                                                self.type = None
                                                                                self.wred_flags = None
                                                                                self.probability = None

                                                                                self.match_ranges = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges()
                                                                                self.match_ranges.parent = self
                                                                                self._children_name_map["match_ranges"] = "match-ranges"

                                                                                self.min_threshold = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold()
                                                                                self.min_threshold.parent = self
                                                                                self._children_name_map["min_threshold"] = "min-threshold"

                                                                                self.max_threshold = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold()
                                                                                self.max_threshold.parent = self
                                                                                self._children_name_map["max_threshold"] = "max-threshold"
                                                                                self._segment_path = lambda: "action-wred-info"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo, ['type', 'wred_flags', 'probability'], name, value)


                                                                            class MatchRanges(Entity):
                                                                                """
                                                                                match ranges
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges, self).__init__()

                                                                                    self.yang_name = "match-ranges"
                                                                                    self.yang_parent_name = "action-wred-info"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "match-ranges"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "match-ranges"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray, ['min', 'max'], name, value)


                                                                            class MinThreshold(Entity):
                                                                                """
                                                                                min threshold
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold, self).__init__()

                                                                                    self.yang_name = "min-threshold"
                                                                                    self.yang_parent_name = "action-wred-info"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.unit = None
                                                                                    self._segment_path = lambda: "min-threshold"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold, ['value', 'unit'], name, value)


                                                                            class MaxThreshold(Entity):
                                                                                """
                                                                                max threshold
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold, self).__init__()

                                                                                    self.yang_name = "max-threshold"
                                                                                    self.yang_parent_name = "action-wred-info"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.unit = None
                                                                                    self._segment_path = lambda: "max-threshold"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold, ['value', 'unit'], name, value)


                                                                    class Encap(Entity):
                                                                        """
                                                                        encap
                                                                        
                                                                        .. attribute:: seq
                                                                        
                                                                        	seq
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap, self).__init__()

                                                                            self.yang_name = "encap"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('seq', (YLeaf(YType.uint8, 'seq'), ['int'])),
                                                                            ])
                                                                            self.seq = None
                                                                            self._segment_path = lambda: "encap"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap, ['seq'], name, value)


                                                                    class Prio(Entity):
                                                                        """
                                                                        prio
                                                                        
                                                                        .. attribute:: prio_lvl
                                                                        
                                                                        	prio lvl
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio, self).__init__()

                                                                            self.yang_name = "prio"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('prio_lvl', (YLeaf(YType.uint32, 'prio-lvl'), ['int'])),
                                                                            ])
                                                                            self.prio_lvl = None
                                                                            self._segment_path = lambda: "prio"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio, ['prio_lvl'], name, value)


                                                                    class Bwrem(Entity):
                                                                        """
                                                                        bwrem
                                                                        
                                                                        .. attribute:: bwrem
                                                                        
                                                                        	bwrem
                                                                        	**type**\:  :py:class:`Bwrem_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem_>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem, self).__init__()

                                                                            self.yang_name = "bwrem"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("bwrem", ("bwrem", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem_))])
                                                                            self._leafs = OrderedDict()

                                                                            self.bwrem = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem_()
                                                                            self.bwrem.parent = self
                                                                            self._children_name_map["bwrem"] = "bwrem"
                                                                            self._segment_path = lambda: "bwrem"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem, [], name, value)


                                                                        class Bwrem_(Entity):
                                                                            """
                                                                            bwrem
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem_, self).__init__()

                                                                                self.yang_name = "bwrem"
                                                                                self.yang_parent_name = "bwrem"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "bwrem"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem_, ['value', 'unit'], name, value)


                                                                    class MinBw(Entity):
                                                                        """
                                                                        min bw
                                                                        
                                                                        .. attribute:: bw
                                                                        
                                                                        	bw
                                                                        	**type**\:  :py:class:`Bw <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw, self).__init__()

                                                                            self.yang_name = "min-bw"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("bw", ("bw", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw))])
                                                                            self._leafs = OrderedDict()

                                                                            self.bw = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw()
                                                                            self.bw.parent = self
                                                                            self._children_name_map["bw"] = "bw"
                                                                            self._segment_path = lambda: "min-bw"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw, [], name, value)


                                                                        class Bw(Entity):
                                                                            """
                                                                            bw
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw, self).__init__()

                                                                                self.yang_name = "bw"
                                                                                self.yang_parent_name = "min-bw"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "bw"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw, ['value', 'unit'], name, value)


                                                                    class AuthenAaa(Entity):
                                                                        """
                                                                        authen aaa
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: authen_password
                                                                        
                                                                        	authen password
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa, self).__init__()

                                                                            self.yang_name = "authen-aaa"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                                ('authen_password', (YLeaf(YType.str, 'authen-password'), ['str'])),
                                                                            ])
                                                                            self.aaa_list_name = None
                                                                            self.authen_password = None
                                                                            self._segment_path = lambda: "authen-aaa"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa, ['aaa_list_name', 'authen_password'], name, value)


                                                                    class CollectId(Entity):
                                                                        """
                                                                        collect id
                                                                        
                                                                        .. attribute:: id
                                                                        
                                                                        	id
                                                                        	**type**\:  :py:class:`IdentifierEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.IdentifierEn>`
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId, self).__init__()

                                                                            self.yang_name = "collect-id"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('id', (YLeaf(YType.enumeration, 'id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'IdentifierEn', '')])),
                                                                                ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                            ])
                                                                            self.id = None
                                                                            self.aaa_list_name = None
                                                                            self._segment_path = lambda: "collect-id"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId, ['id', 'aaa_list_name'], name, value)


                                                                    class DecodeId(Entity):
                                                                        """
                                                                        decode id
                                                                        
                                                                        .. attribute:: id
                                                                        
                                                                        	id
                                                                        	**type**\:  :py:class:`DecodeIdentifierEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.DecodeIdentifierEn>`
                                                                        
                                                                        .. attribute:: format_name
                                                                        
                                                                        	format name
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId, self).__init__()

                                                                            self.yang_name = "decode-id"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('id', (YLeaf(YType.enumeration, 'id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'DecodeIdentifierEn', '')])),
                                                                                ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                            ])
                                                                            self.id = None
                                                                            self.format_name = None
                                                                            self._segment_path = lambda: "decode-id"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId, ['id', 'format_name'], name, value)


                                                                    class SetTimer(Entity):
                                                                        """
                                                                        set timer
                                                                        
                                                                        .. attribute:: timer_name
                                                                        
                                                                        	timer name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: duration
                                                                        
                                                                        	duration
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: absolute_time
                                                                        
                                                                        	absolute time
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer, self).__init__()

                                                                            self.yang_name = "set-timer"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('timer_name', (YLeaf(YType.str, 'timer-name'), ['str'])),
                                                                                ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                                                ('absolute_time', (YLeaf(YType.str, 'absolute-time'), ['str'])),
                                                                            ])
                                                                            self.timer_name = None
                                                                            self.duration = None
                                                                            self.absolute_time = None
                                                                            self._segment_path = lambda: "set-timer"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer, ['timer_name', 'duration', 'absolute_time'], name, value)


                                                                    class StopTimer(Entity):
                                                                        """
                                                                        stop timer
                                                                        
                                                                        .. attribute:: timer_name
                                                                        
                                                                        	timer name
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer, self).__init__()

                                                                            self.yang_name = "stop-timer"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('timer_name', (YLeaf(YType.str, 'timer-name'), ['str'])),
                                                                            ])
                                                                            self.timer_name = None
                                                                            self._segment_path = lambda: "stop-timer"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer, ['timer_name'], name, value)


                                                                    class AcctAaaList(Entity):
                                                                        """
                                                                        acct aaa list
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: secs
                                                                        
                                                                        	secs
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList, self).__init__()

                                                                            self.yang_name = "acct-aaa-list"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                                ('secs', (YLeaf(YType.uint32, 'secs'), ['int'])),
                                                                            ])
                                                                            self.aaa_list_name = None
                                                                            self.secs = None
                                                                            self._segment_path = lambda: "acct-aaa-list"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList, ['aaa_list_name', 'secs'], name, value)


                                                                    class QueryAncp(Entity):
                                                                        """
                                                                        query ancp
                                                                        
                                                                        .. attribute:: enable
                                                                        
                                                                        	enable
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp, self).__init__()

                                                                            self.yang_name = "query-ancp"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('enable', (YLeaf(YType.uint8, 'enable'), ['int'])),
                                                                            ])
                                                                            self.enable = None
                                                                            self._segment_path = lambda: "query-ancp"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp, ['enable'], name, value)


                                                                    class PrepaidCfg(Entity):
                                                                        """
                                                                        prepaid cfg
                                                                        
                                                                        .. attribute:: prepaid_config_profile_name
                                                                        
                                                                        	prepaid config profile name
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg, self).__init__()

                                                                            self.yang_name = "prepaid-cfg"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('prepaid_config_profile_name', (YLeaf(YType.str, 'prepaid-config-profile-name'), ['str'])),
                                                                            ])
                                                                            self.prepaid_config_profile_name = None
                                                                            self._segment_path = lambda: "prepaid-cfg"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg, ['prepaid_config_profile_name'], name, value)


                                                                    class TimeoutIdle(Entity):
                                                                        """
                                                                        timeout idle
                                                                        
                                                                        .. attribute:: secs
                                                                        
                                                                        	secs
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle, self).__init__()

                                                                            self.yang_name = "timeout-idle"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('secs', (YLeaf(YType.uint32, 'secs'), ['int'])),
                                                                            ])
                                                                            self.secs = None
                                                                            self._segment_path = lambda: "timeout-idle"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle, ['secs'], name, value)


                                                                    class ProxyAaa(Entity):
                                                                        """
                                                                        proxy aaa
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa, self).__init__()

                                                                            self.yang_name = "proxy-aaa"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                            ])
                                                                            self.aaa_list_name = None
                                                                            self._segment_path = lambda: "proxy-aaa"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa, ['aaa_list_name'], name, value)


                                                                    class ActTemplate(Entity):
                                                                        """
                                                                        act template
                                                                        
                                                                        .. attribute:: template_name
                                                                        
                                                                        	template name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: flags
                                                                        
                                                                        	flags
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate, self).__init__()

                                                                            self.yang_name = "act-template"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('template_name', (YLeaf(YType.str, 'template-name'), ['str'])),
                                                                                ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                                ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                            ])
                                                                            self.template_name = None
                                                                            self.aaa_list_name = None
                                                                            self.flags = None
                                                                            self._segment_path = lambda: "act-template"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate, ['template_name', 'aaa_list_name', 'flags'], name, value)


                                                                    class DeactTemplate(Entity):
                                                                        """
                                                                        deact template
                                                                        
                                                                        .. attribute:: template_name
                                                                        
                                                                        	template name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: flags
                                                                        
                                                                        	flags
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate, self).__init__()

                                                                            self.yang_name = "deact-template"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('template_name', (YLeaf(YType.str, 'template-name'), ['str'])),
                                                                                ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                                ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                            ])
                                                                            self.template_name = None
                                                                            self.aaa_list_name = None
                                                                            self.flags = None
                                                                            self._segment_path = lambda: "deact-template"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate, ['template_name', 'aaa_list_name', 'flags'], name, value)


                                                                    class Qlimit(Entity):
                                                                        """
                                                                        qlimit
                                                                        
                                                                        .. attribute:: action_qlimit_info_array
                                                                        
                                                                        	action qlimit info array
                                                                        	**type**\: list of  		 :py:class:`ActionQlimitInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit, self).__init__()

                                                                            self.yang_name = "qlimit"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("action-qlimit-info-array", ("action_qlimit_info_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.action_qlimit_info_array = YList(self)
                                                                            self._segment_path = lambda: "qlimit"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit, [], name, value)


                                                                        class ActionQlimitInfoArray(Entity):
                                                                            """
                                                                            action qlimit info array
                                                                            
                                                                            .. attribute:: qlim
                                                                            
                                                                            	qlim
                                                                            	**type**\:  :py:class:`Qlim <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim>`
                                                                            
                                                                            .. attribute:: atmclp_qlim
                                                                            
                                                                            	atmclp qlim
                                                                            	**type**\:  :py:class:`AtmclpQlim <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim>`
                                                                            
                                                                            .. attribute:: match_values
                                                                            
                                                                            	match values
                                                                            	**type**\:  :py:class:`MatchValues <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues>`
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:  :py:class:`QlimitTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.QlimitTypeEn>`
                                                                            
                                                                            .. attribute:: qlimit_flags
                                                                            
                                                                            	qlimit flags
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray, self).__init__()

                                                                                self.yang_name = "action-qlimit-info-array"
                                                                                self.yang_parent_name = "qlimit"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("qlim", ("qlim", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim)), ("atmclp-qlim", ("atmclp_qlim", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim)), ("match-values", ("match_values", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'QlimitTypeEn', '')])),
                                                                                    ('qlimit_flags', (YLeaf(YType.uint32, 'qlimit-flags'), ['int'])),
                                                                                ])
                                                                                self.type = None
                                                                                self.qlimit_flags = None

                                                                                self.qlim = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim()
                                                                                self.qlim.parent = self
                                                                                self._children_name_map["qlim"] = "qlim"

                                                                                self.atmclp_qlim = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim()
                                                                                self.atmclp_qlim.parent = self
                                                                                self._children_name_map["atmclp_qlim"] = "atmclp-qlim"

                                                                                self.match_values = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues()
                                                                                self.match_values.parent = self
                                                                                self._children_name_map["match_values"] = "match-values"
                                                                                self._segment_path = lambda: "action-qlimit-info-array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray, ['type', 'qlimit_flags'], name, value)


                                                                            class Qlim(Entity):
                                                                                """
                                                                                qlim
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim, self).__init__()

                                                                                    self.yang_name = "qlim"
                                                                                    self.yang_parent_name = "action-qlimit-info-array"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.unit = None
                                                                                    self._segment_path = lambda: "qlim"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim, ['value', 'unit'], name, value)


                                                                            class AtmclpQlim(Entity):
                                                                                """
                                                                                atmclp qlim
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim, self).__init__()

                                                                                    self.yang_name = "atmclp-qlim"
                                                                                    self.yang_parent_name = "action-qlimit-info-array"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                        ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                    ])
                                                                                    self.value = None
                                                                                    self.unit = None
                                                                                    self._segment_path = lambda: "atmclp-qlim"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim, ['value', 'unit'], name, value)


                                                                            class MatchValues(Entity):
                                                                                """
                                                                                match values
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues, self).__init__()

                                                                                    self.yang_name = "match-values"
                                                                                    self.yang_parent_name = "action-qlimit-info-array"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "match-values"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "match-values"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                        ])
                                                                                        self.min = None
                                                                                        self.max = None
                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray, ['min', 'max'], name, value)


                                                                    class AccountingEventAaa(Entity):
                                                                        """
                                                                        accounting event aaa
                                                                        
                                                                        .. attribute:: action
                                                                        
                                                                        	action
                                                                        	**type**\:  :py:class:`AcctEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.AcctEn>`
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa, self).__init__()

                                                                            self.yang_name = "accounting-event-aaa"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('action', (YLeaf(YType.enumeration, 'action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'AcctEn', '')])),
                                                                                ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                            ])
                                                                            self.action = None
                                                                            self.aaa_list_name = None
                                                                            self._segment_path = lambda: "accounting-event-aaa"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa, ['action', 'aaa_list_name'], name, value)


                                                                    class AuthorizeId(Entity):
                                                                        """
                                                                        authorize id
                                                                        
                                                                        .. attribute:: id
                                                                        
                                                                        	id
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: format_name
                                                                        
                                                                        	format name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: password
                                                                        
                                                                        	password
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId, self).__init__()

                                                                            self.yang_name = "authorize-id"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('id', (YLeaf(YType.uint8, 'id'), ['int'])),
                                                                                ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                                ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                ('password', (YLeaf(YType.str, 'password'), ['str'])),
                                                                            ])
                                                                            self.id = None
                                                                            self.aaa_list_name = None
                                                                            self.format_name = None
                                                                            self.password = None
                                                                            self._segment_path = lambda: "authorize-id"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId, ['id', 'aaa_list_name', 'format_name', 'password'], name, value)


                                                                    class AfmReact(Entity):
                                                                        """
                                                                        afm react
                                                                        
                                                                        .. attribute:: action_afmon_react_info
                                                                        
                                                                        	action afmon react info
                                                                        	**type**\: list of  		 :py:class:`ActionAfmonReactInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact, self).__init__()

                                                                            self.yang_name = "afm-react"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("action-afmon-react-info", ("action_afmon_react_info", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo))])
                                                                            self._leafs = OrderedDict()

                                                                            self.action_afmon_react_info = YList(self)
                                                                            self._segment_path = lambda: "afm-react"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact, [], name, value)


                                                                        class ActionAfmonReactInfo(Entity):
                                                                            """
                                                                            action afmon react info
                                                                            
                                                                            .. attribute:: oper_id
                                                                            
                                                                            	React Operation ID
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: description
                                                                            
                                                                            	Describing the oper
                                                                            	**type**\: str
                                                                            
                                                                            .. attribute:: trig_num_intvls
                                                                            
                                                                            	Averaged over N intvls
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: clone_ifh
                                                                            
                                                                            	Clone interface handle
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: notif_actns
                                                                            
                                                                            	Bitmap of actions on alert
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: criterion
                                                                            
                                                                            	React Criterion
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: trig_type
                                                                            
                                                                            	Immediate or averaged thresh trigger
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: trig_relop
                                                                            
                                                                            	Trigger LT\|LE\|GT\|GE\|Range
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: trig_level_1
                                                                            
                                                                            	Trigger threshold 1/lower
                                                                            	**type**\: str
                                                                            
                                                                            .. attribute:: trig_level_2
                                                                            
                                                                            	Trigger upper threshold for range
                                                                            	**type**\: str
                                                                            
                                                                            .. attribute:: alm_grp_thresh
                                                                            
                                                                            	Num/percent in grp
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            	**units**\: percentage
                                                                            
                                                                            .. attribute:: alm_type
                                                                            
                                                                            	Discrete \| grouped alarm
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: alm_severity
                                                                            
                                                                            	Major\|Minor\|... alarm
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo, self).__init__()

                                                                                self.yang_name = "action-afmon-react-info"
                                                                                self.yang_parent_name = "afm-react"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('oper_id', (YLeaf(YType.uint32, 'oper-id'), ['int'])),
                                                                                    ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                    ('trig_num_intvls', (YLeaf(YType.uint32, 'trig-num-intvls'), ['int'])),
                                                                                    ('clone_ifh', (YLeaf(YType.uint32, 'clone-ifh'), ['int'])),
                                                                                    ('notif_actns', (YLeaf(YType.uint8, 'notif-actns'), ['int'])),
                                                                                    ('criterion', (YLeaf(YType.uint8, 'criterion'), ['int'])),
                                                                                    ('trig_type', (YLeaf(YType.uint8, 'trig-type'), ['int'])),
                                                                                    ('trig_relop', (YLeaf(YType.uint8, 'trig-relop'), ['int'])),
                                                                                    ('trig_level_1', (YLeaf(YType.str, 'trig-level-1'), ['str'])),
                                                                                    ('trig_level_2', (YLeaf(YType.str, 'trig-level-2'), ['str'])),
                                                                                    ('alm_grp_thresh', (YLeaf(YType.uint16, 'alm-grp-thresh'), ['int'])),
                                                                                    ('alm_type', (YLeaf(YType.uint8, 'alm-type'), ['int'])),
                                                                                    ('alm_severity', (YLeaf(YType.uint8, 'alm-severity'), ['int'])),
                                                                                ])
                                                                                self.oper_id = None
                                                                                self.description = None
                                                                                self.trig_num_intvls = None
                                                                                self.clone_ifh = None
                                                                                self.notif_actns = None
                                                                                self.criterion = None
                                                                                self.trig_type = None
                                                                                self.trig_relop = None
                                                                                self.trig_level_1 = None
                                                                                self.trig_level_2 = None
                                                                                self.alm_grp_thresh = None
                                                                                self.alm_type = None
                                                                                self.alm_severity = None
                                                                                self._segment_path = lambda: "action-afmon-react-info"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo, ['oper_id', 'description', 'trig_num_intvls', 'clone_ifh', 'notif_actns', 'criterion', 'trig_type', 'trig_relop', 'trig_level_1', 'trig_level_2', 'alm_grp_thresh', 'alm_type', 'alm_severity'], name, value)


                                                                    class Httpr(Entity):
                                                                        """
                                                                        httpr
                                                                        
                                                                        .. attribute:: redirect_url
                                                                        
                                                                        	redirect url
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr, self).__init__()

                                                                            self.yang_name = "httpr"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('redirect_url', (YLeaf(YType.str, 'redirect-url'), ['str'])),
                                                                            ])
                                                                            self.redirect_url = None
                                                                            self._segment_path = lambda: "httpr"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr, ['redirect_url'], name, value)


                                                                    class Punt(Entity):
                                                                        """
                                                                        punt
                                                                        
                                                                        .. attribute:: sn_type
                                                                        
                                                                        	service node ID type
                                                                        	**type**\:  :py:class:`DpssSnidTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.DpssSnidTypeEn>`
                                                                        
                                                                        .. attribute:: sn_index
                                                                        
                                                                        	service node index
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: sn_name
                                                                        
                                                                        	service node name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: app_id
                                                                        
                                                                        	application ID
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: local_id
                                                                        
                                                                        	local ID
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: vsnode_type
                                                                        
                                                                        	vservice node type
                                                                        	**type**\:  :py:class:`VsvcServiceTypeT <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.VsvcServiceTypeT>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt, self).__init__()

                                                                            self.yang_name = "punt"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('sn_type', (YLeaf(YType.enumeration, 'sn-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'DpssSnidTypeEn', '')])),
                                                                                ('sn_index', (YLeaf(YType.uint32, 'sn-index'), ['int'])),
                                                                                ('sn_name', (YLeaf(YType.str, 'sn-name'), ['str'])),
                                                                                ('app_id', (YLeaf(YType.uint32, 'app-id'), ['int'])),
                                                                                ('local_id', (YLeaf(YType.uint32, 'local-id'), ['int'])),
                                                                                ('vsnode_type', (YLeaf(YType.enumeration, 'vsnode-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'VsvcServiceTypeT', '')])),
                                                                            ])
                                                                            self.sn_type = None
                                                                            self.sn_index = None
                                                                            self.sn_name = None
                                                                            self.app_id = None
                                                                            self.local_id = None
                                                                            self.vsnode_type = None
                                                                            self._segment_path = lambda: "punt"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt, ['sn_type', 'sn_index', 'sn_name', 'app_id', 'local_id', 'vsnode_type'], name, value)


                                                                    class Copy(Entity):
                                                                        """
                                                                        copy
                                                                        
                                                                        .. attribute:: num_byte
                                                                        
                                                                        	number of bytes
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: sn_type
                                                                        
                                                                        	service node ID type
                                                                        	**type**\:  :py:class:`DpssSnidTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.DpssSnidTypeEn>`
                                                                        
                                                                        .. attribute:: sn_index
                                                                        
                                                                        	service node index
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: sn_name
                                                                        
                                                                        	service node url
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: app_id
                                                                        
                                                                        	application ID
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: local_id
                                                                        
                                                                        	local ID
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: vsnode_type
                                                                        
                                                                        	vservice node type
                                                                        	**type**\:  :py:class:`VsvcServiceTypeT <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.VsvcServiceTypeT>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy, self).__init__()

                                                                            self.yang_name = "copy"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('num_byte', (YLeaf(YType.uint32, 'num-byte'), ['int'])),
                                                                                ('sn_type', (YLeaf(YType.enumeration, 'sn-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'DpssSnidTypeEn', '')])),
                                                                                ('sn_index', (YLeaf(YType.uint32, 'sn-index'), ['int'])),
                                                                                ('sn_name', (YLeaf(YType.str, 'sn-name'), ['str'])),
                                                                                ('app_id', (YLeaf(YType.uint32, 'app-id'), ['int'])),
                                                                                ('local_id', (YLeaf(YType.uint32, 'local-id'), ['int'])),
                                                                                ('vsnode_type', (YLeaf(YType.enumeration, 'vsnode-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'VsvcServiceTypeT', '')])),
                                                                            ])
                                                                            self.num_byte = None
                                                                            self.sn_type = None
                                                                            self.sn_index = None
                                                                            self.sn_name = None
                                                                            self.app_id = None
                                                                            self.local_id = None
                                                                            self.vsnode_type = None
                                                                            self._segment_path = lambda: "copy"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy, ['num_byte', 'sn_type', 'sn_index', 'sn_name', 'app_id', 'local_id', 'vsnode_type'], name, value)


                                                                    class Sfrag(Entity):
                                                                        """
                                                                        sfrag
                                                                        
                                                                        .. attribute:: name
                                                                        
                                                                        	Service Fragment Name
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag, self).__init__()

                                                                            self.yang_name = "sfrag"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                            ])
                                                                            self.name = None
                                                                            self._segment_path = lambda: "sfrag"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag, ['name'], name, value)


                                                                    class Redirect(Entity):
                                                                        """
                                                                        redirect
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: type
                                                                        
                                                                        	type
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect, self).__init__()

                                                                            self.yang_name = "redirect"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                            ])
                                                                            self.value = None
                                                                            self.type = None
                                                                            self._segment_path = lambda: "redirect"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect, ['value', 'type'], name, value)


                                                                    class OutIntf(Entity):
                                                                        """
                                                                        out intf
                                                                        
                                                                        .. attribute:: out_ifname
                                                                        
                                                                        	output interface name
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf, self).__init__()

                                                                            self.yang_name = "out-intf"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('out_ifname', (YLeaf(YType.str, 'out-ifname'), ['str'])),
                                                                            ])
                                                                            self.out_ifname = None
                                                                            self._segment_path = lambda: "out-intf"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf, ['out_ifname'], name, value)


                                                                    class ServFunc(Entity):
                                                                        """
                                                                        serv func
                                                                        
                                                                        .. attribute:: path_id
                                                                        
                                                                        	service path id
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: service_index
                                                                        
                                                                        	service path index
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: meta_name
                                                                        
                                                                        	metadata name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: vs_index
                                                                        
                                                                        	vservice index
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc, self).__init__()

                                                                            self.yang_name = "serv-func"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('path_id', (YLeaf(YType.uint32, 'path-id'), ['int'])),
                                                                                ('service_index', (YLeaf(YType.uint8, 'service-index'), ['int'])),
                                                                                ('meta_name', (YLeaf(YType.str, 'meta-name'), ['str'])),
                                                                                ('vs_index', (YLeaf(YType.uint32, 'vs-index'), ['int'])),
                                                                            ])
                                                                            self.path_id = None
                                                                            self.service_index = None
                                                                            self.meta_name = None
                                                                            self.vs_index = None
                                                                            self._segment_path = lambda: "serv-func"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc, ['path_id', 'service_index', 'meta_name', 'vs_index'], name, value)


                                                                    class Police(Entity):
                                                                        """
                                                                        police
                                                                        
                                                                        .. attribute:: rate
                                                                        
                                                                        	rate
                                                                        	**type**\:  :py:class:`Rate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate>`
                                                                        
                                                                        .. attribute:: burst
                                                                        
                                                                        	burst
                                                                        	**type**\:  :py:class:`Burst <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst>`
                                                                        
                                                                        .. attribute:: peak_rate
                                                                        
                                                                        	peak rate
                                                                        	**type**\:  :py:class:`PeakRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate>`
                                                                        
                                                                        .. attribute:: peak_burst
                                                                        
                                                                        	peak burst
                                                                        	**type**\:  :py:class:`PeakBurst <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst>`
                                                                        
                                                                        .. attribute:: cdvt
                                                                        
                                                                        	cdvt
                                                                        	**type**\:  :py:class:`Cdvt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt>`
                                                                        
                                                                        .. attribute:: conform_actns
                                                                        
                                                                        	conform actns
                                                                        	**type**\:  :py:class:`ConformActns <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns>`
                                                                        
                                                                        .. attribute:: exceed_actns
                                                                        
                                                                        	exceed actns
                                                                        	**type**\:  :py:class:`ExceedActns <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns>`
                                                                        
                                                                        .. attribute:: violate_actns
                                                                        
                                                                        	violate actns
                                                                        	**type**\:  :py:class:`ViolateActns <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns>`
                                                                        
                                                                        .. attribute:: confclass_encode
                                                                        
                                                                        	confclass encode
                                                                        	**type**\:  :py:class:`ConfclassEncode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode>`
                                                                        
                                                                        .. attribute:: confclass_p
                                                                        
                                                                        	confclass p
                                                                        	**type**\:  :py:class:`ConfclassP <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP>`
                                                                        
                                                                        .. attribute:: excdclass_encode
                                                                        
                                                                        	excdclass encode
                                                                        	**type**\:  :py:class:`ExcdclassEncode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode>`
                                                                        
                                                                        .. attribute:: excdclass_p
                                                                        
                                                                        	excdclass p
                                                                        	**type**\:  :py:class:`ExcdclassP <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP>`
                                                                        
                                                                        .. attribute:: flags
                                                                        
                                                                        	flags
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: police_flags
                                                                        
                                                                        	police flags
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: sbuck_name
                                                                        
                                                                        	sbuck name
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..65
                                                                        
                                                                        .. attribute:: sbuck_type
                                                                        
                                                                        	sbuck type
                                                                        	**type**\:  :py:class:`SharedBucketType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.SharedBucketType>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police, self).__init__()

                                                                            self.yang_name = "police"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("rate", ("rate", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate)), ("burst", ("burst", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst)), ("peak-rate", ("peak_rate", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate)), ("peak-burst", ("peak_burst", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst)), ("cdvt", ("cdvt", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt)), ("conform-actns", ("conform_actns", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns)), ("exceed-actns", ("exceed_actns", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns)), ("violate-actns", ("violate_actns", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns)), ("confclass-encode", ("confclass_encode", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode)), ("confclass-p", ("confclass_p", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP)), ("excdclass-encode", ("excdclass_encode", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode)), ("excdclass-p", ("excdclass_p", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP))])
                                                                            self._leafs = OrderedDict([
                                                                                ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                ('police_flags', (YLeaf(YType.uint32, 'police-flags'), ['int'])),
                                                                                ('sbuck_name', (YLeaf(YType.str, 'sbuck-name'), ['str'])),
                                                                                ('sbuck_type', (YLeaf(YType.enumeration, 'sbuck-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'SharedBucketType', '')])),
                                                                            ])
                                                                            self.flags = None
                                                                            self.police_flags = None
                                                                            self.sbuck_name = None
                                                                            self.sbuck_type = None

                                                                            self.rate = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate()
                                                                            self.rate.parent = self
                                                                            self._children_name_map["rate"] = "rate"

                                                                            self.burst = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst()
                                                                            self.burst.parent = self
                                                                            self._children_name_map["burst"] = "burst"

                                                                            self.peak_rate = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate()
                                                                            self.peak_rate.parent = self
                                                                            self._children_name_map["peak_rate"] = "peak-rate"

                                                                            self.peak_burst = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst()
                                                                            self.peak_burst.parent = self
                                                                            self._children_name_map["peak_burst"] = "peak-burst"

                                                                            self.cdvt = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt()
                                                                            self.cdvt.parent = self
                                                                            self._children_name_map["cdvt"] = "cdvt"

                                                                            self.conform_actns = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns()
                                                                            self.conform_actns.parent = self
                                                                            self._children_name_map["conform_actns"] = "conform-actns"

                                                                            self.exceed_actns = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns()
                                                                            self.exceed_actns.parent = self
                                                                            self._children_name_map["exceed_actns"] = "exceed-actns"

                                                                            self.violate_actns = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns()
                                                                            self.violate_actns.parent = self
                                                                            self._children_name_map["violate_actns"] = "violate-actns"

                                                                            self.confclass_encode = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode()
                                                                            self.confclass_encode.parent = self
                                                                            self._children_name_map["confclass_encode"] = "confclass-encode"

                                                                            self.confclass_p = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP()
                                                                            self.confclass_p.parent = self
                                                                            self._children_name_map["confclass_p"] = "confclass-p"

                                                                            self.excdclass_encode = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode()
                                                                            self.excdclass_encode.parent = self
                                                                            self._children_name_map["excdclass_encode"] = "excdclass-encode"

                                                                            self.excdclass_p = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP()
                                                                            self.excdclass_p.parent = self
                                                                            self._children_name_map["excdclass_p"] = "excdclass-p"
                                                                            self._segment_path = lambda: "police"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police, ['flags', 'police_flags', 'sbuck_name', 'sbuck_type'], name, value)


                                                                        class Rate(Entity):
                                                                            """
                                                                            rate
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate, self).__init__()

                                                                                self.yang_name = "rate"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate, ['value', 'unit'], name, value)


                                                                        class Burst(Entity):
                                                                            """
                                                                            burst
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst, self).__init__()

                                                                                self.yang_name = "burst"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "burst"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst, ['value', 'unit'], name, value)


                                                                        class PeakRate(Entity):
                                                                            """
                                                                            peak rate
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate, self).__init__()

                                                                                self.yang_name = "peak-rate"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "peak-rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate, ['value', 'unit'], name, value)


                                                                        class PeakBurst(Entity):
                                                                            """
                                                                            peak burst
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst, self).__init__()

                                                                                self.yang_name = "peak-burst"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "peak-burst"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst, ['value', 'unit'], name, value)


                                                                        class Cdvt(Entity):
                                                                            """
                                                                            cdvt
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt, self).__init__()

                                                                                self.yang_name = "cdvt"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "cdvt"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt, ['value', 'unit'], name, value)


                                                                        class ConformActns(Entity):
                                                                            """
                                                                            conform actns
                                                                            
                                                                            .. attribute:: police_action_array
                                                                            
                                                                            	police action array
                                                                            	**type**\: list of  		 :py:class:`PoliceActionArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns, self).__init__()

                                                                                self.yang_name = "conform-actns"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("police-action-array", ("police_action_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.police_action_array = YList(self)
                                                                                self._segment_path = lambda: "conform-actns"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns, [], name, value)


                                                                            class PoliceActionArray(Entity):
                                                                                """
                                                                                police action array
                                                                                
                                                                                .. attribute:: mark
                                                                                
                                                                                	mark
                                                                                	**type**\:  :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark>`
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:  :py:class:`PoliceActionTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PoliceActionTypeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray, self).__init__()

                                                                                    self.yang_name = "police-action-array"
                                                                                    self.yang_parent_name = "conform-actns"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("mark", ("mark", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PoliceActionTypeEn', '')])),
                                                                                    ])
                                                                                    self.type = None

                                                                                    self.mark = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark()
                                                                                    self.mark.parent = self
                                                                                    self._children_name_map["mark"] = "mark"
                                                                                    self._segment_path = lambda: "police-action-array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray, ['type'], name, value)


                                                                                class Mark(Entity):
                                                                                    """
                                                                                    mark
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	type
                                                                                    	**type**\:  :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                                    
                                                                                    .. attribute:: mark_flags
                                                                                    
                                                                                    	mark flags
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark, self).__init__()

                                                                                        self.yang_name = "mark"
                                                                                        self.yang_parent_name = "police-action-array"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MarkTypeEn', '')])),
                                                                                            ('mark_flags', (YLeaf(YType.uint32, 'mark-flags'), ['int'])),
                                                                                            ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                        ])
                                                                                        self.type = None
                                                                                        self.mark_flags = None
                                                                                        self.value = None
                                                                                        self._segment_path = lambda: "mark"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark, ['type', 'mark_flags', 'value'], name, value)


                                                                        class ExceedActns(Entity):
                                                                            """
                                                                            exceed actns
                                                                            
                                                                            .. attribute:: police_action_array
                                                                            
                                                                            	police action array
                                                                            	**type**\: list of  		 :py:class:`PoliceActionArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns, self).__init__()

                                                                                self.yang_name = "exceed-actns"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("police-action-array", ("police_action_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.police_action_array = YList(self)
                                                                                self._segment_path = lambda: "exceed-actns"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns, [], name, value)


                                                                            class PoliceActionArray(Entity):
                                                                                """
                                                                                police action array
                                                                                
                                                                                .. attribute:: mark
                                                                                
                                                                                	mark
                                                                                	**type**\:  :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark>`
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:  :py:class:`PoliceActionTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PoliceActionTypeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray, self).__init__()

                                                                                    self.yang_name = "police-action-array"
                                                                                    self.yang_parent_name = "exceed-actns"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("mark", ("mark", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PoliceActionTypeEn', '')])),
                                                                                    ])
                                                                                    self.type = None

                                                                                    self.mark = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark()
                                                                                    self.mark.parent = self
                                                                                    self._children_name_map["mark"] = "mark"
                                                                                    self._segment_path = lambda: "police-action-array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray, ['type'], name, value)


                                                                                class Mark(Entity):
                                                                                    """
                                                                                    mark
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	type
                                                                                    	**type**\:  :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                                    
                                                                                    .. attribute:: mark_flags
                                                                                    
                                                                                    	mark flags
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark, self).__init__()

                                                                                        self.yang_name = "mark"
                                                                                        self.yang_parent_name = "police-action-array"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MarkTypeEn', '')])),
                                                                                            ('mark_flags', (YLeaf(YType.uint32, 'mark-flags'), ['int'])),
                                                                                            ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                        ])
                                                                                        self.type = None
                                                                                        self.mark_flags = None
                                                                                        self.value = None
                                                                                        self._segment_path = lambda: "mark"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark, ['type', 'mark_flags', 'value'], name, value)


                                                                        class ViolateActns(Entity):
                                                                            """
                                                                            violate actns
                                                                            
                                                                            .. attribute:: police_action_array
                                                                            
                                                                            	police action array
                                                                            	**type**\: list of  		 :py:class:`PoliceActionArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns, self).__init__()

                                                                                self.yang_name = "violate-actns"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("police-action-array", ("police_action_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.police_action_array = YList(self)
                                                                                self._segment_path = lambda: "violate-actns"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns, [], name, value)


                                                                            class PoliceActionArray(Entity):
                                                                                """
                                                                                police action array
                                                                                
                                                                                .. attribute:: mark
                                                                                
                                                                                	mark
                                                                                	**type**\:  :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark>`
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:  :py:class:`PoliceActionTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PoliceActionTypeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray, self).__init__()

                                                                                    self.yang_name = "police-action-array"
                                                                                    self.yang_parent_name = "violate-actns"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("mark", ("mark", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PoliceActionTypeEn', '')])),
                                                                                    ])
                                                                                    self.type = None

                                                                                    self.mark = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark()
                                                                                    self.mark.parent = self
                                                                                    self._children_name_map["mark"] = "mark"
                                                                                    self._segment_path = lambda: "police-action-array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray, ['type'], name, value)


                                                                                class Mark(Entity):
                                                                                    """
                                                                                    mark
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	type
                                                                                    	**type**\:  :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                                    
                                                                                    .. attribute:: mark_flags
                                                                                    
                                                                                    	mark flags
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark, self).__init__()

                                                                                        self.yang_name = "mark"
                                                                                        self.yang_parent_name = "police-action-array"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MarkTypeEn', '')])),
                                                                                            ('mark_flags', (YLeaf(YType.uint32, 'mark-flags'), ['int'])),
                                                                                            ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                        ])
                                                                                        self.type = None
                                                                                        self.mark_flags = None
                                                                                        self.value = None
                                                                                        self._segment_path = lambda: "mark"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark, ['type', 'mark_flags', 'value'], name, value)


                                                                        class ConfclassEncode(Entity):
                                                                            """
                                                                            confclass encode
                                                                            
                                                                            .. attribute:: inline_cmap
                                                                            
                                                                            	inline cmap
                                                                            	**type**\:  :py:class:`InlineCmap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap>`
                                                                            
                                                                            .. attribute:: enc
                                                                            
                                                                            	enc
                                                                            	**type**\:  :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                            
                                                                            .. attribute:: class_name
                                                                            
                                                                            	class name
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..65
                                                                            
                                                                            .. attribute:: hd
                                                                            
                                                                            	hd
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: idx
                                                                            
                                                                            	idx
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode, self).__init__()

                                                                                self.yang_name = "confclass-encode"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("inline-cmap", ("inline_cmap", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('enc', (YLeaf(YType.enumeration, 'enc'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyObjEncEn', '')])),
                                                                                    ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                                                    ('hd', (YLeaf(YType.uint64, 'hd'), ['int'])),
                                                                                    ('idx', (YLeaf(YType.uint8, 'idx'), ['int'])),
                                                                                ])
                                                                                self.enc = None
                                                                                self.class_name = None
                                                                                self.hd = None
                                                                                self.idx = None

                                                                                self.inline_cmap = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap()
                                                                                self.inline_cmap.parent = self
                                                                                self._children_name_map["inline_cmap"] = "inline-cmap"
                                                                                self._segment_path = lambda: "confclass-encode"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode, ['enc', 'class_name', 'hd', 'idx'], name, value)


                                                                            class InlineCmap(Entity):
                                                                                """
                                                                                inline cmap
                                                                                
                                                                                .. attribute:: match_infop
                                                                                
                                                                                	Pointer to the first Match info
                                                                                	**type**\:  :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop>`
                                                                                
                                                                                .. attribute:: mode
                                                                                
                                                                                	Inline Class\-Map Mode Match any/all
                                                                                	**type**\:  :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                                
                                                                                .. attribute:: flags
                                                                                
                                                                                	Inline Class\-Map flags
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: match_count
                                                                                
                                                                                	Number of Match infos
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap, self).__init__()

                                                                                    self.yang_name = "inline-cmap"
                                                                                    self.yang_parent_name = "confclass-encode"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("match-infop", ("match_infop", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapModeEn', '')])),
                                                                                        ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                        ('match_count', (YLeaf(YType.uint32, 'match-count'), ['int'])),
                                                                                    ])
                                                                                    self.mode = None
                                                                                    self.flags = None
                                                                                    self.match_count = None

                                                                                    self.match_infop = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop()
                                                                                    self.match_infop.parent = self
                                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                                    self._segment_path = lambda: "inline-cmap"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap, ['mode', 'flags', 'match_count'], name, value)


                                                                                class MatchInfop(Entity):
                                                                                    """
                                                                                    Pointer to the first Match info
                                                                                    
                                                                                    .. attribute:: class_match_info_st
                                                                                    
                                                                                    	class match info st
                                                                                    	**type**\: list of  		 :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop, self).__init__()

                                                                                        self.yang_name = "match-infop"
                                                                                        self.yang_parent_name = "inline-cmap"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("class-match-info-st", ("class_match_info_st", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.class_match_info_st = YList(self)
                                                                                        self._segment_path = lambda: "match-infop"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop, [], name, value)


                                                                                    class ClassMatchInfoSt(Entity):
                                                                                        """
                                                                                        class match info st
                                                                                        
                                                                                        .. attribute:: match_data
                                                                                        
                                                                                        	Match criteria
                                                                                        	**type**\:  :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                        
                                                                                        .. attribute:: flags
                                                                                        
                                                                                        	Flags
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                            self.yang_name = "class-match-info-st"
                                                                                            self.yang_parent_name = "match-infop"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("match-data", ("match_data", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData))])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                            ])
                                                                                            self.flags = None

                                                                                            self.match_data = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                            self.match_data.parent = self
                                                                                            self._children_name_map["match_data"] = "match-data"
                                                                                            self._segment_path = lambda: "class-match-info-st"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                        class MatchData(Entity):
                                                                                            """
                                                                                            Match criteria
                                                                                            
                                                                                            .. attribute:: ipv4_dscp
                                                                                            
                                                                                            	IPv4 DSCP
                                                                                            	**type**\:  :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv6_dscp
                                                                                            
                                                                                            	IPv6 DSCP
                                                                                            	**type**\:  :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                            
                                                                                            .. attribute:: dscp
                                                                                            
                                                                                            	Match DSCP range array
                                                                                            	**type**\:  :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv4_prec
                                                                                            
                                                                                            	IPv4 Precedence
                                                                                            	**type**\:  :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                            
                                                                                            .. attribute:: ipv6_prec
                                                                                            
                                                                                            	IPv6 Precedence
                                                                                            	**type**\:  :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                            
                                                                                            .. attribute:: prec
                                                                                            
                                                                                            	Match Precedence array
                                                                                            	**type**\:  :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                            
                                                                                            .. attribute:: discard_class
                                                                                            
                                                                                            	Match Discard Class array
                                                                                            	**type**\:  :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                            
                                                                                            .. attribute:: qos_group
                                                                                            
                                                                                            	Match QoS group array
                                                                                            	**type**\:  :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                            
                                                                                            .. attribute:: traffic_class
                                                                                            
                                                                                            	Match Traffic class array
                                                                                            	**type**\:  :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                            
                                                                                            .. attribute:: proto
                                                                                            
                                                                                            	Match Protocol array
                                                                                            	**type**\:  :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                            
                                                                                            .. attribute:: icmp_v4
                                                                                            
                                                                                            	Match ICMPV4 Protocol
                                                                                            	**type**\:  :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                            
                                                                                            .. attribute:: icmp_v6
                                                                                            
                                                                                            	Match ICMPV6 Protocol array
                                                                                            	**type**\:  :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                            
                                                                                            .. attribute:: ipv4_packet_len
                                                                                            
                                                                                            	IPv4 packet length array
                                                                                            	**type**\:  :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv6_packet_len
                                                                                            
                                                                                            	IPv6 packet length array
                                                                                            	**type**\:  :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                            
                                                                                            .. attribute:: packet_len
                                                                                            
                                                                                            	Match packet length array
                                                                                            	**type**\:  :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                            
                                                                                            .. attribute:: flow_tag
                                                                                            
                                                                                            	Match flow\-tag array
                                                                                            	**type**\:  :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                            
                                                                                            .. attribute:: tcp_flag
                                                                                            
                                                                                            	Match tcp flag value
                                                                                            	**type**\:  :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                            
                                                                                            .. attribute:: icmpv4_type
                                                                                            
                                                                                            	Match ipv4 icmp type
                                                                                            	**type**\:  :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                            
                                                                                            .. attribute:: icmpv4_code
                                                                                            
                                                                                            	Match ipv4 icmp code
                                                                                            	**type**\:  :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                            
                                                                                            .. attribute:: icmpv6_type
                                                                                            
                                                                                            	Match ipv6 icmp type
                                                                                            	**type**\:  :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                            
                                                                                            .. attribute:: icmpv6_code
                                                                                            
                                                                                            	Match ipv6 icmp code
                                                                                            	**type**\:  :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                            
                                                                                            .. attribute:: mpls_exp
                                                                                            
                                                                                            	Match MPLS experimental topmost array
                                                                                            	**type**\:  :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                            
                                                                                            .. attribute:: mpls_exp_imp
                                                                                            
                                                                                            	Match MPLS experimental imposition array
                                                                                            	**type**\:  :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                                            
                                                                                            	MPLS Disposition IPv4 Access\-list
                                                                                            	**type**\:  :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                                            
                                                                                            	MPLS Disposition IPv6 Access\-list
                                                                                            	**type**\:  :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_top_label
                                                                                            
                                                                                            	MPLS Topmost LABEL
                                                                                            	**type**\:  :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                            
                                                                                            .. attribute:: cos
                                                                                            
                                                                                            	Match CoS array
                                                                                            	**type**\:  :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                            
                                                                                            .. attribute:: cos_inr
                                                                                            
                                                                                            	Match inner header CoS
                                                                                            	**type**\:  :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                            
                                                                                            .. attribute:: dei
                                                                                            
                                                                                            	Match DEI Bit
                                                                                            	**type**\:  :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                            
                                                                                            .. attribute:: dei_inr
                                                                                            
                                                                                            	Match inner DEI Bit
                                                                                            	**type**\:  :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                            
                                                                                            .. attribute:: vlan
                                                                                            
                                                                                            	Match VLAN array
                                                                                            	**type**\:  :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                            
                                                                                            .. attribute:: vlan_inr
                                                                                            
                                                                                            	Match inner header VLAN range array
                                                                                            	**type**\:  :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                            
                                                                                            .. attribute:: fr_dlci
                                                                                            
                                                                                            	Match FR DLCI range array
                                                                                            	**type**\:  :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                            
                                                                                            .. attribute:: src_mac
                                                                                            
                                                                                            	Match Source MAC address
                                                                                            	**type**\:  :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                            
                                                                                            .. attribute:: dst_mac
                                                                                            
                                                                                            	Match Destination MAC address
                                                                                            	**type**\:  :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                            
                                                                                            .. attribute:: atm_clp
                                                                                            
                                                                                            	Match ATM CLP level
                                                                                            	**type**\:  :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                            
                                                                                            .. attribute:: fr_de
                                                                                            
                                                                                            	Match FR DE value
                                                                                            	**type**\:  :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                            
                                                                                            .. attribute:: ipv4_acl
                                                                                            
                                                                                            	IPv4 Access\-list
                                                                                            	**type**\:  :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                            
                                                                                            .. attribute:: ipv6_acl
                                                                                            
                                                                                            	IPv6 Access\-list
                                                                                            	**type**\:  :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                            
                                                                                            .. attribute:: ether_service_acl
                                                                                            
                                                                                            	Ethernet\-Services Access\-list
                                                                                            	**type**\:  :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                            
                                                                                            .. attribute:: avail_id
                                                                                            
                                                                                            	Available Identifiers
                                                                                            	**type**\:  :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                            
                                                                                            .. attribute:: media_type
                                                                                            
                                                                                            	Media Type
                                                                                            	**type**\:  :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                            
                                                                                            .. attribute:: subs_protocol
                                                                                            
                                                                                            	Protocol
                                                                                            	**type**\:  :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                            
                                                                                            .. attribute:: dnis
                                                                                            
                                                                                            	DNIS
                                                                                            	**type**\:  :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                            
                                                                                            .. attribute:: dnis_regex
                                                                                            
                                                                                            	DNIS Regular Expression
                                                                                            	**type**\:  :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                            
                                                                                            .. attribute:: domain
                                                                                            
                                                                                            	Domain Name
                                                                                            	**type**\:  :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                            
                                                                                            .. attribute:: domain_regex
                                                                                            
                                                                                            	Domain Regular Expression
                                                                                            	**type**\:  :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                            
                                                                                            .. attribute:: nas_port
                                                                                            
                                                                                            	NAS Port
                                                                                            	**type**\:  :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                            
                                                                                            .. attribute:: service_name
                                                                                            
                                                                                            	Service Name
                                                                                            	**type**\:  :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                            
                                                                                            .. attribute:: service_name_regex
                                                                                            
                                                                                            	Service Name Regular Exp
                                                                                            	**type**\:  :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv4
                                                                                            
                                                                                            	Source Address IPV4
                                                                                            	**type**\:  :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv4
                                                                                            
                                                                                            	Destination Address IPV4
                                                                                            	**type**\:  :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv6
                                                                                            
                                                                                            	Source Address IPV6
                                                                                            	**type**\:  :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv6
                                                                                            
                                                                                            	Destination Address IPV6
                                                                                            	**type**\:  :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: src_addr_mac
                                                                                            
                                                                                            	Source Address MAC
                                                                                            	**type**\:  :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                            
                                                                                            .. attribute:: timer
                                                                                            
                                                                                            	Timer
                                                                                            	**type**\:  :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                            
                                                                                            .. attribute:: timer_regexp
                                                                                            
                                                                                            	Timer Regular Expression
                                                                                            	**type**\:  :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                            
                                                                                            .. attribute:: tunnel_name
                                                                                            
                                                                                            	Tunnel Name
                                                                                            	**type**\:  :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                            
                                                                                            .. attribute:: tunnel_name_regex
                                                                                            
                                                                                            	Tunnel Name Regular Expression
                                                                                            	**type**\:  :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                            
                                                                                            .. attribute:: user_name
                                                                                            
                                                                                            	User Name
                                                                                            	**type**\:  :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                            
                                                                                            .. attribute:: user_name_regex
                                                                                            
                                                                                            	User Name Regular Expression
                                                                                            	**type**\:  :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                            
                                                                                            .. attribute:: auth_username
                                                                                            
                                                                                            	Authenticated User Name
                                                                                            	**type**\:  :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                            
                                                                                            .. attribute:: auth_username_regex
                                                                                            
                                                                                            	Authenticated User Name RegEx
                                                                                            	**type**\:  :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_username
                                                                                            
                                                                                            	Unauthenticated User Name
                                                                                            	**type**\:  :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                            
                                                                                            .. attribute:: unauth_username_regex
                                                                                            
                                                                                            	Unauthenticated User Name RegEx
                                                                                            	**type**\:  :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: auth_domain
                                                                                            
                                                                                            	Authenticated domain name
                                                                                            	**type**\:  :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                            
                                                                                            .. attribute:: auth_domain_regex
                                                                                            
                                                                                            	Authenticated Domain Name RegEx
                                                                                            	**type**\:  :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_domain
                                                                                            
                                                                                            	Unauthenticated Domain Name
                                                                                            	**type**\:  :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                            
                                                                                            .. attribute:: unauth_domain_regex
                                                                                            
                                                                                            	Unauthenticated Domain Name RegEx
                                                                                            	**type**\:  :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: vendor_id
                                                                                            
                                                                                            	Vendor ID
                                                                                            	**type**\:  :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                            
                                                                                            .. attribute:: vendor_id_regex
                                                                                            
                                                                                            	Vendor ID RegEx
                                                                                            	**type**\:  :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                            
                                                                                            .. attribute:: access_interface
                                                                                            
                                                                                            	Access interface
                                                                                            	**type**\:  :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                            
                                                                                            .. attribute:: input_interface
                                                                                            
                                                                                            	Input interface
                                                                                            	**type**\:  :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                            
                                                                                            .. attribute:: input_intfhdl
                                                                                            
                                                                                            	Input interface handle
                                                                                            	**type**\:  :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                            
                                                                                            .. attribute:: ethertype
                                                                                            
                                                                                            	Ethernet type
                                                                                            	**type**\:  :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                            
                                                                                            .. attribute:: flow_key_data
                                                                                            
                                                                                            	Flow key structure
                                                                                            	**type**\:  :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id
                                                                                            
                                                                                            	Dhcp Client ID
                                                                                            	**type**\:  :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id_regex
                                                                                            
                                                                                            	Dhcp Client ID RegEx
                                                                                            	**type**\:  :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                            
                                                                                            .. attribute:: circuit_id
                                                                                            
                                                                                            	Circuit ID
                                                                                            	**type**\:  :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                            
                                                                                            .. attribute:: circuit_id_regex
                                                                                            
                                                                                            	Circuit ID RegEx
                                                                                            	**type**\:  :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                            
                                                                                            .. attribute:: remote_id
                                                                                            
                                                                                            	Remote ID
                                                                                            	**type**\:  :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                            
                                                                                            .. attribute:: remote_id_regex
                                                                                            
                                                                                            	Remote ID RegEx
                                                                                            	**type**\:  :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                            
                                                                                            .. attribute:: src_port
                                                                                            
                                                                                            	Source port
                                                                                            	**type**\:  :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                            
                                                                                            .. attribute:: dst_port
                                                                                            
                                                                                            	Destination port
                                                                                            	**type**\:  :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	type
                                                                                            	**type**\:  :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                            
                                                                                            .. attribute:: mpls_top_eos
                                                                                            
                                                                                            	MPLS Topmost EOS
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: fragment_type
                                                                                            
                                                                                            	Fragment type
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: authen_status
                                                                                            
                                                                                            	Authentication Status
                                                                                            	**type**\:  :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                            
                                                                                            .. attribute:: mlp_negotiated
                                                                                            
                                                                                            	MLP Negotiated
                                                                                            	**type**\:  :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                                self.yang_name = "match-data"
                                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("ipv4-dscp", ("ipv4_dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp)), ("ipv6-dscp", ("ipv6_dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp)), ("dscp", ("dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp)), ("ipv4-prec", ("ipv4_prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec)), ("ipv6-prec", ("ipv6_prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec)), ("prec", ("prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec)), ("discard-class", ("discard_class", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass)), ("qos-group", ("qos_group", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup)), ("traffic-class", ("traffic_class", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass)), ("proto", ("proto", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto)), ("icmp-v4", ("icmp_v4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4)), ("icmp-v6", ("icmp_v6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6)), ("ipv4-packet-len", ("ipv4_packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen)), ("ipv6-packet-len", ("ipv6_packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen)), ("packet-len", ("packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen)), ("flow-tag", ("flow_tag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag)), ("tcp-flag", ("tcp_flag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag)), ("icmpv4-type", ("icmpv4_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type)), ("icmpv4-code", ("icmpv4_code", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code)), ("icmpv6-type", ("icmpv6_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type)), ("icmpv6-code", ("icmpv6_code", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code)), ("mpls-exp", ("mpls_exp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp)), ("mpls-exp-imp", ("mpls_exp_imp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp)), ("mpls-disp-ipv4-acl", ("mpls_disp_ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl)), ("mpls-disp-ipv6-acl", ("mpls_disp_ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl)), ("mpls-top-label", ("mpls_top_label", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel)), ("cos", ("cos", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos)), ("cos-inr", ("cos_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr)), ("dei", ("dei", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei)), ("dei-inr", ("dei_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr)), ("vlan", ("vlan", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan)), ("vlan-inr", ("vlan_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)), ("fr-dlci", ("fr_dlci", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci)), ("src-mac", ("src_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac)), ("dst-mac", ("dst_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac)), ("atm-clp", ("atm_clp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp)), ("fr-de", ("fr_de", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe)), ("ipv4-acl", ("ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl)), ("ipv6-acl", ("ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl)), ("ether-service-acl", ("ether_service_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl)), ("avail-id", ("avail_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId)), ("media-type", ("media_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType)), ("subs-protocol", ("subs_protocol", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol)), ("dnis", ("dnis", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis)), ("dnis-regex", ("dnis_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex)), ("domain", ("domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain)), ("domain-regex", ("domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex)), ("nas-port", ("nas_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort)), ("service-name", ("service_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName)), ("service-name-regex", ("service_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex)), ("src-addr-ipv4", ("src_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4)), ("dst-addr-ipv4", ("dst_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4)), ("src-addr-ipv6", ("src_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6)), ("dst-addr-ipv6", ("dst_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6)), ("src-addr-mac", ("src_addr_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac)), ("timer", ("timer", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer)), ("timer-regexp", ("timer_regexp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp)), ("tunnel-name", ("tunnel_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName)), ("tunnel-name-regex", ("tunnel_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex)), ("user-name", ("user_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName)), ("user-name-regex", ("user_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex)), ("auth-username", ("auth_username", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername)), ("auth-username-regex", ("auth_username_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex)), ("unauth-username", ("unauth_username", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername)), ("unauth-username-regex", ("unauth_username_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex)), ("auth-domain", ("auth_domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain)), ("auth-domain-regex", ("auth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex)), ("unauth-domain", ("unauth_domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain)), ("unauth-domain-regex", ("unauth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex)), ("vendor-id", ("vendor_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId)), ("vendor-id-regex", ("vendor_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex)), ("access-interface", ("access_interface", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface)), ("input-interface", ("input_interface", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface)), ("input-intfhdl", ("input_intfhdl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl)), ("ethertype", ("ethertype", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype)), ("flow-key-data", ("flow_key_data", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData)), ("dhcp-client-id", ("dhcp_client_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId)), ("dhcp-client-id-regex", ("dhcp_client_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex)), ("circuit-id", ("circuit_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId)), ("circuit-id-regex", ("circuit_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex)), ("remote-id", ("remote_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId)), ("remote-id-regex", ("remote_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex)), ("src-port", ("src_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort)), ("dst-port", ("dst_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort))])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchTypeEn', '')])),
                                                                                                    ('mpls_top_eos', (YLeaf(YType.uint8, 'mpls-top-eos'), ['int'])),
                                                                                                    ('fragment_type', (YLeaf(YType.uint8, 'fragment-type'), ['int'])),
                                                                                                    ('authen_status', (YLeaf(YType.enumeration, 'authen-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchAuthenStatusEn', '')])),
                                                                                                    ('mlp_negotiated', (YLeaf(YType.enumeration, 'mlp-negotiated'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchMlpNegotiatedEn', '')])),
                                                                                                ])
                                                                                                self.type = None
                                                                                                self.mpls_top_eos = None
                                                                                                self.fragment_type = None
                                                                                                self.authen_status = None
                                                                                                self.mlp_negotiated = None

                                                                                                self.ipv4_dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                                self.ipv4_dscp.parent = self
                                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"

                                                                                                self.ipv6_dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                                self.ipv6_dscp.parent = self
                                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"

                                                                                                self.dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                                self.dscp.parent = self
                                                                                                self._children_name_map["dscp"] = "dscp"

                                                                                                self.ipv4_prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                                self.ipv4_prec.parent = self
                                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"

                                                                                                self.ipv6_prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                                self.ipv6_prec.parent = self
                                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"

                                                                                                self.prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                                self.prec.parent = self
                                                                                                self._children_name_map["prec"] = "prec"

                                                                                                self.discard_class = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                                self.discard_class.parent = self
                                                                                                self._children_name_map["discard_class"] = "discard-class"

                                                                                                self.qos_group = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                                self.qos_group.parent = self
                                                                                                self._children_name_map["qos_group"] = "qos-group"

                                                                                                self.traffic_class = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                                self.traffic_class.parent = self
                                                                                                self._children_name_map["traffic_class"] = "traffic-class"

                                                                                                self.proto = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                                self.proto.parent = self
                                                                                                self._children_name_map["proto"] = "proto"

                                                                                                self.icmp_v4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                                self.icmp_v4.parent = self
                                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"

                                                                                                self.icmp_v6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                                self.icmp_v6.parent = self
                                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"

                                                                                                self.ipv4_packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                                self.ipv4_packet_len.parent = self
                                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"

                                                                                                self.ipv6_packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                                self.ipv6_packet_len.parent = self
                                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"

                                                                                                self.packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                                self.packet_len.parent = self
                                                                                                self._children_name_map["packet_len"] = "packet-len"

                                                                                                self.flow_tag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                                self.flow_tag.parent = self
                                                                                                self._children_name_map["flow_tag"] = "flow-tag"

                                                                                                self.tcp_flag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                                self.tcp_flag.parent = self
                                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"

                                                                                                self.icmpv4_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                                self.icmpv4_type.parent = self
                                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"

                                                                                                self.icmpv4_code = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                                self.icmpv4_code.parent = self
                                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"

                                                                                                self.icmpv6_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                                self.icmpv6_type.parent = self
                                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"

                                                                                                self.icmpv6_code = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                                self.icmpv6_code.parent = self
                                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"

                                                                                                self.mpls_exp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                                self.mpls_exp.parent = self
                                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"

                                                                                                self.mpls_exp_imp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                                self.mpls_exp_imp.parent = self
                                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"

                                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"

                                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"

                                                                                                self.mpls_top_label = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                                self.mpls_top_label.parent = self
                                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"

                                                                                                self.cos = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                                self.cos.parent = self
                                                                                                self._children_name_map["cos"] = "cos"

                                                                                                self.cos_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                                self.cos_inr.parent = self
                                                                                                self._children_name_map["cos_inr"] = "cos-inr"

                                                                                                self.dei = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                                self.dei.parent = self
                                                                                                self._children_name_map["dei"] = "dei"

                                                                                                self.dei_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                                self.dei_inr.parent = self
                                                                                                self._children_name_map["dei_inr"] = "dei-inr"

                                                                                                self.vlan = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                                self.vlan.parent = self
                                                                                                self._children_name_map["vlan"] = "vlan"

                                                                                                self.vlan_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                                self.vlan_inr.parent = self
                                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"

                                                                                                self.fr_dlci = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                                self.fr_dlci.parent = self
                                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"

                                                                                                self.src_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                                self.src_mac.parent = self
                                                                                                self._children_name_map["src_mac"] = "src-mac"

                                                                                                self.dst_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                                self.dst_mac.parent = self
                                                                                                self._children_name_map["dst_mac"] = "dst-mac"

                                                                                                self.atm_clp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                                self.atm_clp.parent = self
                                                                                                self._children_name_map["atm_clp"] = "atm-clp"

                                                                                                self.fr_de = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                                self.fr_de.parent = self
                                                                                                self._children_name_map["fr_de"] = "fr-de"

                                                                                                self.ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                                self.ipv4_acl.parent = self
                                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"

                                                                                                self.ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                                self.ipv6_acl.parent = self
                                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"

                                                                                                self.ether_service_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                                self.ether_service_acl.parent = self
                                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"

                                                                                                self.avail_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                                self.avail_id.parent = self
                                                                                                self._children_name_map["avail_id"] = "avail-id"

                                                                                                self.media_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                                self.media_type.parent = self
                                                                                                self._children_name_map["media_type"] = "media-type"

                                                                                                self.subs_protocol = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                                self.subs_protocol.parent = self
                                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"

                                                                                                self.dnis = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                                self.dnis.parent = self
                                                                                                self._children_name_map["dnis"] = "dnis"

                                                                                                self.dnis_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                                self.dnis_regex.parent = self
                                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"

                                                                                                self.domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                                self.domain.parent = self
                                                                                                self._children_name_map["domain"] = "domain"

                                                                                                self.domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                                self.domain_regex.parent = self
                                                                                                self._children_name_map["domain_regex"] = "domain-regex"

                                                                                                self.nas_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                                self.nas_port.parent = self
                                                                                                self._children_name_map["nas_port"] = "nas-port"

                                                                                                self.service_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                                self.service_name.parent = self
                                                                                                self._children_name_map["service_name"] = "service-name"

                                                                                                self.service_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                                self.service_name_regex.parent = self
                                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"

                                                                                                self.src_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                                self.src_addr_ipv4.parent = self
                                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"

                                                                                                self.dst_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                                self.dst_addr_ipv4.parent = self
                                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"

                                                                                                self.src_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                                self.src_addr_ipv6.parent = self
                                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"

                                                                                                self.dst_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                                self.dst_addr_ipv6.parent = self
                                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"

                                                                                                self.src_addr_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                                self.src_addr_mac.parent = self
                                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"

                                                                                                self.timer = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                                self.timer.parent = self
                                                                                                self._children_name_map["timer"] = "timer"

                                                                                                self.timer_regexp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                                self.timer_regexp.parent = self
                                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"

                                                                                                self.tunnel_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                                self.tunnel_name.parent = self
                                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"

                                                                                                self.tunnel_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                                self.tunnel_name_regex.parent = self
                                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"

                                                                                                self.user_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                                self.user_name.parent = self
                                                                                                self._children_name_map["user_name"] = "user-name"

                                                                                                self.user_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                                self.user_name_regex.parent = self
                                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"

                                                                                                self.auth_username = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                                self.auth_username.parent = self
                                                                                                self._children_name_map["auth_username"] = "auth-username"

                                                                                                self.auth_username_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                                self.auth_username_regex.parent = self
                                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"

                                                                                                self.unauth_username = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                                self.unauth_username.parent = self
                                                                                                self._children_name_map["unauth_username"] = "unauth-username"

                                                                                                self.unauth_username_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                                self.unauth_username_regex.parent = self
                                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"

                                                                                                self.auth_domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                                self.auth_domain.parent = self
                                                                                                self._children_name_map["auth_domain"] = "auth-domain"

                                                                                                self.auth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                                self.auth_domain_regex.parent = self
                                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"

                                                                                                self.unauth_domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                                self.unauth_domain.parent = self
                                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"

                                                                                                self.unauth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                                self.unauth_domain_regex.parent = self
                                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"

                                                                                                self.vendor_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                                self.vendor_id.parent = self
                                                                                                self._children_name_map["vendor_id"] = "vendor-id"

                                                                                                self.vendor_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                                self.vendor_id_regex.parent = self
                                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"

                                                                                                self.access_interface = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                                self.access_interface.parent = self
                                                                                                self._children_name_map["access_interface"] = "access-interface"

                                                                                                self.input_interface = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                                self.input_interface.parent = self
                                                                                                self._children_name_map["input_interface"] = "input-interface"

                                                                                                self.input_intfhdl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                                self.input_intfhdl.parent = self
                                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"

                                                                                                self.ethertype = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                                self.ethertype.parent = self
                                                                                                self._children_name_map["ethertype"] = "ethertype"

                                                                                                self.flow_key_data = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                                self.flow_key_data.parent = self
                                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"

                                                                                                self.dhcp_client_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                                self.dhcp_client_id.parent = self
                                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"

                                                                                                self.dhcp_client_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                                self.dhcp_client_id_regex.parent = self
                                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"

                                                                                                self.circuit_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                                self.circuit_id.parent = self
                                                                                                self._children_name_map["circuit_id"] = "circuit-id"

                                                                                                self.circuit_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                                self.circuit_id_regex.parent = self
                                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"

                                                                                                self.remote_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                                self.remote_id.parent = self
                                                                                                self._children_name_map["remote_id"] = "remote-id"

                                                                                                self.remote_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                                self.remote_id_regex.parent = self
                                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"

                                                                                                self.src_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                                self.src_port.parent = self
                                                                                                self._children_name_map["src_port"] = "src-port"

                                                                                                self.dst_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                                self.dst_port.parent = self
                                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                                self._segment_path = lambda: "match-data"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, ['type', 'mpls_top_eos', 'fragment_type', 'authen_status', 'mlp_negotiated'], name, value)


                                                                                            class Ipv4Dscp(Entity):
                                                                                                """
                                                                                                IPv4 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv4-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv6Dscp(Entity):
                                                                                                """
                                                                                                IPv6 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv6-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Dscp(Entity):
                                                                                                """
                                                                                                Match DSCP range array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                    self.yang_name = "dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv4Prec(Entity):
                                                                                                """
                                                                                                IPv4 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                    self.yang_name = "ipv4-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "ipv4-prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                            class Ipv6Prec(Entity):
                                                                                                """
                                                                                                IPv6 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                    self.yang_name = "ipv6-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "ipv6-prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                            class Prec(Entity):
                                                                                                """
                                                                                                Match Precedence array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                    self.yang_name = "prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                            class DiscardClass(Entity):
                                                                                                """
                                                                                                Match Discard Class array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                    self.yang_name = "discard-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "discard-class"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                            class QosGroup(Entity):
                                                                                                """
                                                                                                Match QoS group array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                    self.yang_name = "qos-group"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "qos-group"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "qos-group"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class TrafficClass(Entity):
                                                                                                """
                                                                                                Match Traffic class array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                    self.yang_name = "traffic-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "traffic-class"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "traffic-class"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Proto(Entity):
                                                                                                """
                                                                                                Match Protocol array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                    self.yang_name = "proto"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "proto"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "proto"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class IcmpV4(Entity):
                                                                                                """
                                                                                                Match ICMPV4 Protocol
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                    self.yang_name = "icmp-v4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                    ])
                                                                                                    self.type = None
                                                                                                    self.code = None
                                                                                                    self._segment_path = lambda: "icmp-v4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['type', 'code'], name, value)


                                                                                            class IcmpV6(Entity):
                                                                                                """
                                                                                                Match ICMPV6 Protocol array
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                    self.yang_name = "icmp-v6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                    ])
                                                                                                    self.type = None
                                                                                                    self.code = None
                                                                                                    self._segment_path = lambda: "icmp-v6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['type', 'code'], name, value)


                                                                                            class Ipv4PacketLen(Entity):
                                                                                                """
                                                                                                IPv4 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv6PacketLen(Entity):
                                                                                                """
                                                                                                IPv6 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class PacketLen(Entity):
                                                                                                """
                                                                                                Match packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                    self.yang_name = "packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FlowTag(Entity):
                                                                                                """
                                                                                                Match flow\-tag array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                    self.yang_name = "flow-tag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "flow-tag"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "flow-tag"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class TcpFlag(Entity):
                                                                                                """
                                                                                                Match tcp flag value
                                                                                                
                                                                                                .. attribute:: value
                                                                                                
                                                                                                	Value of TCP flag
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: match_any
                                                                                                
                                                                                                	Match any TCP flag bit
                                                                                                	**type**\: bool
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                    self.yang_name = "tcp-flag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                                        ('match_any', (YLeaf(YType.boolean, 'match-any'), ['bool'])),
                                                                                                    ])
                                                                                                    self.value = None
                                                                                                    self.match_any = None
                                                                                                    self._segment_path = lambda: "tcp-flag"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['value', 'match_any'], name, value)


                                                                                            class Icmpv4Type(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                    self.yang_name = "icmpv4-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv4Code(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                    self.yang_name = "icmpv4-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-code"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv6Type(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                    self.yang_name = "icmpv6-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv6Code(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                    self.yang_name = "icmpv6-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-code"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class MplsExp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental topmost array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "mpls-exp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                            class MplsExpImp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental imposition array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "mpls-exp-imp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                            class MplsDispIpv4Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                            class MplsDispIpv6Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                            class MplsTopLabel(Entity):
                                                                                                """
                                                                                                MPLS Topmost LABEL
                                                                                                
                                                                                                .. attribute:: uint32_rng_array
                                                                                                
                                                                                                	uint32 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                    self.yang_name = "mpls-top-label"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint32_rng_array", ("uint32_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint32_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "mpls-top-label"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                                class Uint32RngArray(Entity):
                                                                                                    """
                                                                                                    uint32 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                        self.yang_name = "uint32_rng_array"
                                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint32, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint32, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint32_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['min', 'max'], name, value)


                                                                                            class Cos(Entity):
                                                                                                """
                                                                                                Match CoS array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                    self.yang_name = "cos"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "cos"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                            class CosInr(Entity):
                                                                                                """
                                                                                                Match inner header CoS
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                    self.yang_name = "cos-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "cos-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                            class Dei(Entity):
                                                                                                """
                                                                                                Match DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                    self.yang_name = "dei"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                    ])
                                                                                                    self.bit_value = None
                                                                                                    self._segment_path = lambda: "dei"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                            class DeiInr(Entity):
                                                                                                """
                                                                                                Match inner DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                    self.yang_name = "dei-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                    ])
                                                                                                    self.bit_value = None
                                                                                                    self._segment_path = lambda: "dei-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                            class Vlan(Entity):
                                                                                                """
                                                                                                Match VLAN array
                                                                                                
                                                                                                .. attribute:: vlan_id_array
                                                                                                
                                                                                                	vlan id array
                                                                                                	**type**\: list of  		 :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                    self.yang_name = "vlan"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("vlan-id-array", ("vlan_id_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.vlan_id_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                                class VlanIdArray(Entity):
                                                                                                    """
                                                                                                    vlan id array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	VLAN mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                        self.yang_name = "vlan-id-array"
                                                                                                        self.yang_parent_name = "vlan"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ('mask', (YLeaf(YType.uint16, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "vlan-id-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['min', 'max', 'mask'], name, value)


                                                                                            class VlanInr(Entity):
                                                                                                """
                                                                                                Match inner header VLAN range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                    self.yang_name = "vlan-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FrDlci(Entity):
                                                                                                """
                                                                                                Match FR DLCI range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                    self.yang_name = "fr-dlci"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "fr-dlci"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class SrcMac(Entity):
                                                                                                """
                                                                                                Match Source MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                    self.yang_name = "src-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.mac_addr = []
                                                                                                    self.mask = []
                                                                                                    self._segment_path = lambda: "src-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                            class DstMac(Entity):
                                                                                                """
                                                                                                Match Destination MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                    self.yang_name = "dst-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.mac_addr = []
                                                                                                    self.mask = []
                                                                                                    self._segment_path = lambda: "dst-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                            class AtmClp(Entity):
                                                                                                """
                                                                                                Match ATM CLP level
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                    self.yang_name = "atm-clp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "atm-clp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                            class FrDe(Entity):
                                                                                                """
                                                                                                Match FR DE value
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                    self.yang_name = "fr-de"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "fr-de"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                            class Ipv4Acl(Entity):
                                                                                                """
                                                                                                IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                    self.yang_name = "ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ipv4-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                            class Ipv6Acl(Entity):
                                                                                                """
                                                                                                IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                    self.yang_name = "ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ipv6-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                            class EtherServiceAcl(Entity):
                                                                                                """
                                                                                                Ethernet\-Services Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                    self.yang_name = "ether-service-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ether-service-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                            class AvailId(Entity):
                                                                                                """
                                                                                                Available Identifiers
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                    self.yang_name = "avail-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "avail-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                            class MediaType(Entity):
                                                                                                """
                                                                                                Media Type
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                    self.yang_name = "media-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "media-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                            class SubsProtocol(Entity):
                                                                                                """
                                                                                                Protocol
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                    self.yang_name = "subs-protocol"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "subs-protocol"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                            class Dnis(Entity):
                                                                                                """
                                                                                                DNIS
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                    self.yang_name = "dnis"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dnis"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                            class DnisRegex(Entity):
                                                                                                """
                                                                                                DNIS Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                    self.yang_name = "dnis-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dnis-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                            class Domain(Entity):
                                                                                                """
                                                                                                Domain Name
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                    self.yang_name = "domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                        ])
                                                                                                        self.domain_name = None
                                                                                                        self.format_name = None
                                                                                                        self._segment_path = lambda: "domain-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class DomainRegex(Entity):
                                                                                                """
                                                                                                Domain Regular Expression
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                    self.yang_name = "domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain-regex"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                        ])
                                                                                                        self.domain_name = None
                                                                                                        self.format_name = None
                                                                                                        self._segment_path = lambda: "domain-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class NasPort(Entity):
                                                                                                """
                                                                                                NAS Port
                                                                                                
                                                                                                .. attribute:: nas_port_array
                                                                                                
                                                                                                	nas port array
                                                                                                	**type**\: list of  		 :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                    self.yang_name = "nas-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("nas-port-array", ("nas_port_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.nas_port_array = YList(self)
                                                                                                    self._segment_path = lambda: "nas-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                                class NasPortArray(Entity):
                                                                                                    """
                                                                                                    nas port array
                                                                                                    
                                                                                                    .. attribute:: sub_id
                                                                                                    
                                                                                                    	sub id
                                                                                                    	**type**\:  :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                    
                                                                                                    .. attribute:: operator
                                                                                                    
                                                                                                    	operator
                                                                                                    	**type**\:  :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	value
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                        self.yang_name = "nas-port-array"
                                                                                                        self.yang_parent_name = "nas-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('sub_id', (YLeaf(YType.enumeration, 'sub-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchNasPortSubIdEn', '')])),
                                                                                                            ('operator', (YLeaf(YType.enumeration, 'operator'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchLogicalOperatorEn', '')])),
                                                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                                        ])
                                                                                                        self.sub_id = None
                                                                                                        self.operator = None
                                                                                                        self.value = None
                                                                                                        self._segment_path = lambda: "nas-port-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['sub_id', 'operator', 'value'], name, value)


                                                                                            class ServiceName(Entity):
                                                                                                """
                                                                                                Service Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                    self.yang_name = "service-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "service-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                            class ServiceNameRegex(Entity):
                                                                                                """
                                                                                                Service Name Regular Exp
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                    self.yang_name = "service-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "service-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                            class SrcAddrIpv4(Entity):
                                                                                                """
                                                                                                Source Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class DstAddrIpv4(Entity):
                                                                                                """
                                                                                                Destination Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class SrcAddrIpv6(Entity):
                                                                                                """
                                                                                                Source Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class DstAddrIpv6(Entity):
                                                                                                """
                                                                                                Destination Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class SrcAddrMac(Entity):
                                                                                                """
                                                                                                Source Address MAC
                                                                                                
                                                                                                .. attribute:: mac_addr_array
                                                                                                
                                                                                                	mac addr array
                                                                                                	**type**\: list of  		 :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                    self.yang_name = "src-addr-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("mac-addr-array", ("mac_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.mac_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                                class MacAddrArray(Entity):
                                                                                                    """
                                                                                                    mac addr array
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                        self.yang_name = "mac-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                            ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.mac_addr = []
                                                                                                        self.mask = []
                                                                                                        self._segment_path = lambda: "mac-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                            class Timer(Entity):
                                                                                                """
                                                                                                Timer
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                    self.yang_name = "timer"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "timer"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                            class TimerRegexp(Entity):
                                                                                                """
                                                                                                Timer Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                    self.yang_name = "timer-regexp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "timer-regexp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                            class TunnelName(Entity):
                                                                                                """
                                                                                                Tunnel Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                    self.yang_name = "tunnel-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "tunnel-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                            class TunnelNameRegex(Entity):
                                                                                                """
                                                                                                Tunnel Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "tunnel-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                            class UserName(Entity):
                                                                                                """
                                                                                                User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                    self.yang_name = "user-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "user-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                            class UserNameRegex(Entity):
                                                                                                """
                                                                                                User Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                    self.yang_name = "user-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "user-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                            class AuthUsername(Entity):
                                                                                                """
                                                                                                Authenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                    self.yang_name = "auth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-username"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                            class AuthUsernameRegex(Entity):
                                                                                                """
                                                                                                Authenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "auth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-username-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                            class UnauthUsername(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                    self.yang_name = "unauth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-username"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                            class UnauthUsernameRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-username-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                            class AuthDomain(Entity):
                                                                                                """
                                                                                                Authenticated domain name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                    self.yang_name = "auth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                            class AuthDomainRegex(Entity):
                                                                                                """
                                                                                                Authenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "auth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                            class UnauthDomain(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                    self.yang_name = "unauth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                            class UnauthDomainRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                            class VendorId(Entity):
                                                                                                """
                                                                                                Vendor ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                    self.yang_name = "vendor-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "vendor-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                            class VendorIdRegex(Entity):
                                                                                                """
                                                                                                Vendor ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                    self.yang_name = "vendor-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "vendor-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                            class AccessInterface(Entity):
                                                                                                """
                                                                                                Access interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                    self.yang_name = "access-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "access-interface"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                            class InputInterface(Entity):
                                                                                                """
                                                                                                Input interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                    self.yang_name = "input-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "input-interface"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                            class InputIntfhdl(Entity):
                                                                                                """
                                                                                                Input interface handle
                                                                                                
                                                                                                .. attribute:: uint64_array
                                                                                                
                                                                                                	uint64 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..18446744073709551615
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                    self.yang_name = "input-intfhdl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint64_array', (YLeafList(YType.uint64, 'uint64_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint64_array = []
                                                                                                    self._segment_path = lambda: "input-intfhdl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                            class Ethertype(Entity):
                                                                                                """
                                                                                                Ethernet type
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                    self.yang_name = "ethertype"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ethertype"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ethertype"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FlowKeyData(Entity):
                                                                                                """
                                                                                                Flow key structure
                                                                                                
                                                                                                .. attribute:: flow_keys
                                                                                                
                                                                                                	flow keys
                                                                                                	**type**\:  :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                                
                                                                                                .. attribute:: max_count
                                                                                                
                                                                                                	Maximum count of flows
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: idle_timeout
                                                                                                
                                                                                                	Idle timeout of flows (in seconds)
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                	**units**\: second
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                    self.yang_name = "flow-key-data"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("flow-keys", ("flow_keys", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys))])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('max_count', (YLeaf(YType.uint16, 'max-count'), ['int'])),
                                                                                                        ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                                                    ])
                                                                                                    self.max_count = None
                                                                                                    self.idle_timeout = None

                                                                                                    self.flow_keys = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                    self.flow_keys.parent = self
                                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                    self._segment_path = lambda: "flow-key-data"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['max_count', 'idle_timeout'], name, value)


                                                                                                class FlowKeys(Entity):
                                                                                                    """
                                                                                                    flow keys
                                                                                                    
                                                                                                    .. attribute:: keys
                                                                                                    
                                                                                                    	keys
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                    
                                                                                                    .. attribute:: num
                                                                                                    
                                                                                                    	num
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                        self.yang_name = "flow-keys"
                                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('keys', (YLeaf(YType.str, 'keys'), ['str'])),
                                                                                                            ('num', (YLeaf(YType.uint8, 'num'), ['int'])),
                                                                                                        ])
                                                                                                        self.keys = None
                                                                                                        self.num = None
                                                                                                        self._segment_path = lambda: "flow-keys"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                            class DhcpClientId(Entity):
                                                                                                """
                                                                                                Dhcp Client ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dhcp-client-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                            class DhcpClientIdRegex(Entity):
                                                                                                """
                                                                                                Dhcp Client ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                            class CircuitId(Entity):
                                                                                                """
                                                                                                Circuit ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                    self.yang_name = "circuit-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "circuit-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                            class CircuitIdRegex(Entity):
                                                                                                """
                                                                                                Circuit ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                    self.yang_name = "circuit-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "circuit-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                            class RemoteId(Entity):
                                                                                                """
                                                                                                Remote ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                    self.yang_name = "remote-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "remote-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                            class RemoteIdRegex(Entity):
                                                                                                """
                                                                                                Remote ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                    self.yang_name = "remote-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "remote-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                            class SrcPort(Entity):
                                                                                                """
                                                                                                Source port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                    self.yang_name = "src-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "src-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class DstPort(Entity):
                                                                                                """
                                                                                                Destination port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                    self.yang_name = "dst-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "dst-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                        class ConfclassP(Entity):
                                                                            """
                                                                            confclass p
                                                                            
                                                                            .. attribute:: class_map_bg
                                                                            
                                                                            	class map bg
                                                                            	**type**\: list of  		 :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP, self).__init__()

                                                                                self.yang_name = "confclass-p"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("class-map-bg", ("class_map_bg", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg))])
                                                                                self._leafs = OrderedDict()

                                                                                self.class_map_bg = YList(self)
                                                                                self._segment_path = lambda: "confclass-p"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP, [], name, value)


                                                                            class ClassMapBg(Entity):
                                                                                """
                                                                                class map bg
                                                                                
                                                                                .. attribute:: match_infop
                                                                                
                                                                                	Pointer to the first Match info
                                                                                	**type**\:  :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop>`
                                                                                
                                                                                .. attribute:: name
                                                                                
                                                                                	Name of the class\-map
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..65
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Class\-Map Type QoS/PBR/Netflow/..
                                                                                	**type**\:  :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                                                
                                                                                .. attribute:: mode
                                                                                
                                                                                	Class\-Map Mode Match any/Match all
                                                                                	**type**\:  :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                                
                                                                                .. attribute:: description
                                                                                
                                                                                	description
                                                                                	**type**\: str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg, self).__init__()

                                                                                    self.yang_name = "class-map-bg"
                                                                                    self.yang_parent_name = "confclass-p"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("match-infop", ("match_infop", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapTypeEn', '')])),
                                                                                        ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapModeEn', '')])),
                                                                                        ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                    ])
                                                                                    self.name = None
                                                                                    self.type = None
                                                                                    self.mode = None
                                                                                    self.description = None

                                                                                    self.match_infop = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop()
                                                                                    self.match_infop.parent = self
                                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                                    self._segment_path = lambda: "class-map-bg"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg, ['name', 'type', 'mode', 'description'], name, value)


                                                                                class MatchInfop(Entity):
                                                                                    """
                                                                                    Pointer to the first Match info
                                                                                    
                                                                                    .. attribute:: class_match_info_st
                                                                                    
                                                                                    	class match info st
                                                                                    	**type**\: list of  		 :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop, self).__init__()

                                                                                        self.yang_name = "match-infop"
                                                                                        self.yang_parent_name = "class-map-bg"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("class-match-info-st", ("class_match_info_st", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.class_match_info_st = YList(self)
                                                                                        self._segment_path = lambda: "match-infop"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop, [], name, value)


                                                                                    class ClassMatchInfoSt(Entity):
                                                                                        """
                                                                                        class match info st
                                                                                        
                                                                                        .. attribute:: match_data
                                                                                        
                                                                                        	Match criteria
                                                                                        	**type**\:  :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                        
                                                                                        .. attribute:: flags
                                                                                        
                                                                                        	Flags
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                            self.yang_name = "class-match-info-st"
                                                                                            self.yang_parent_name = "match-infop"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("match-data", ("match_data", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData))])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                            ])
                                                                                            self.flags = None

                                                                                            self.match_data = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                            self.match_data.parent = self
                                                                                            self._children_name_map["match_data"] = "match-data"
                                                                                            self._segment_path = lambda: "class-match-info-st"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                        class MatchData(Entity):
                                                                                            """
                                                                                            Match criteria
                                                                                            
                                                                                            .. attribute:: ipv4_dscp
                                                                                            
                                                                                            	IPv4 DSCP
                                                                                            	**type**\:  :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv6_dscp
                                                                                            
                                                                                            	IPv6 DSCP
                                                                                            	**type**\:  :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                            
                                                                                            .. attribute:: dscp
                                                                                            
                                                                                            	Match DSCP range array
                                                                                            	**type**\:  :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv4_prec
                                                                                            
                                                                                            	IPv4 Precedence
                                                                                            	**type**\:  :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                            
                                                                                            .. attribute:: ipv6_prec
                                                                                            
                                                                                            	IPv6 Precedence
                                                                                            	**type**\:  :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                            
                                                                                            .. attribute:: prec
                                                                                            
                                                                                            	Match Precedence array
                                                                                            	**type**\:  :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                            
                                                                                            .. attribute:: discard_class
                                                                                            
                                                                                            	Match Discard Class array
                                                                                            	**type**\:  :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                            
                                                                                            .. attribute:: qos_group
                                                                                            
                                                                                            	Match QoS group array
                                                                                            	**type**\:  :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                            
                                                                                            .. attribute:: traffic_class
                                                                                            
                                                                                            	Match Traffic class array
                                                                                            	**type**\:  :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                            
                                                                                            .. attribute:: proto
                                                                                            
                                                                                            	Match Protocol array
                                                                                            	**type**\:  :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                            
                                                                                            .. attribute:: icmp_v4
                                                                                            
                                                                                            	Match ICMPV4 Protocol
                                                                                            	**type**\:  :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                            
                                                                                            .. attribute:: icmp_v6
                                                                                            
                                                                                            	Match ICMPV6 Protocol array
                                                                                            	**type**\:  :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                            
                                                                                            .. attribute:: ipv4_packet_len
                                                                                            
                                                                                            	IPv4 packet length array
                                                                                            	**type**\:  :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv6_packet_len
                                                                                            
                                                                                            	IPv6 packet length array
                                                                                            	**type**\:  :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                            
                                                                                            .. attribute:: packet_len
                                                                                            
                                                                                            	Match packet length array
                                                                                            	**type**\:  :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                            
                                                                                            .. attribute:: flow_tag
                                                                                            
                                                                                            	Match flow\-tag array
                                                                                            	**type**\:  :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                            
                                                                                            .. attribute:: tcp_flag
                                                                                            
                                                                                            	Match tcp flag value
                                                                                            	**type**\:  :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                            
                                                                                            .. attribute:: icmpv4_type
                                                                                            
                                                                                            	Match ipv4 icmp type
                                                                                            	**type**\:  :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                            
                                                                                            .. attribute:: icmpv4_code
                                                                                            
                                                                                            	Match ipv4 icmp code
                                                                                            	**type**\:  :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                            
                                                                                            .. attribute:: icmpv6_type
                                                                                            
                                                                                            	Match ipv6 icmp type
                                                                                            	**type**\:  :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                            
                                                                                            .. attribute:: icmpv6_code
                                                                                            
                                                                                            	Match ipv6 icmp code
                                                                                            	**type**\:  :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                            
                                                                                            .. attribute:: mpls_exp
                                                                                            
                                                                                            	Match MPLS experimental topmost array
                                                                                            	**type**\:  :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                            
                                                                                            .. attribute:: mpls_exp_imp
                                                                                            
                                                                                            	Match MPLS experimental imposition array
                                                                                            	**type**\:  :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                                            
                                                                                            	MPLS Disposition IPv4 Access\-list
                                                                                            	**type**\:  :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                                            
                                                                                            	MPLS Disposition IPv6 Access\-list
                                                                                            	**type**\:  :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_top_label
                                                                                            
                                                                                            	MPLS Topmost LABEL
                                                                                            	**type**\:  :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                            
                                                                                            .. attribute:: cos
                                                                                            
                                                                                            	Match CoS array
                                                                                            	**type**\:  :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                            
                                                                                            .. attribute:: cos_inr
                                                                                            
                                                                                            	Match inner header CoS
                                                                                            	**type**\:  :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                            
                                                                                            .. attribute:: dei
                                                                                            
                                                                                            	Match DEI Bit
                                                                                            	**type**\:  :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                            
                                                                                            .. attribute:: dei_inr
                                                                                            
                                                                                            	Match inner DEI Bit
                                                                                            	**type**\:  :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                            
                                                                                            .. attribute:: vlan
                                                                                            
                                                                                            	Match VLAN array
                                                                                            	**type**\:  :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                            
                                                                                            .. attribute:: vlan_inr
                                                                                            
                                                                                            	Match inner header VLAN range array
                                                                                            	**type**\:  :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                            
                                                                                            .. attribute:: fr_dlci
                                                                                            
                                                                                            	Match FR DLCI range array
                                                                                            	**type**\:  :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                            
                                                                                            .. attribute:: src_mac
                                                                                            
                                                                                            	Match Source MAC address
                                                                                            	**type**\:  :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                            
                                                                                            .. attribute:: dst_mac
                                                                                            
                                                                                            	Match Destination MAC address
                                                                                            	**type**\:  :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                            
                                                                                            .. attribute:: atm_clp
                                                                                            
                                                                                            	Match ATM CLP level
                                                                                            	**type**\:  :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                            
                                                                                            .. attribute:: fr_de
                                                                                            
                                                                                            	Match FR DE value
                                                                                            	**type**\:  :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                            
                                                                                            .. attribute:: ipv4_acl
                                                                                            
                                                                                            	IPv4 Access\-list
                                                                                            	**type**\:  :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                            
                                                                                            .. attribute:: ipv6_acl
                                                                                            
                                                                                            	IPv6 Access\-list
                                                                                            	**type**\:  :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                            
                                                                                            .. attribute:: ether_service_acl
                                                                                            
                                                                                            	Ethernet\-Services Access\-list
                                                                                            	**type**\:  :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                            
                                                                                            .. attribute:: avail_id
                                                                                            
                                                                                            	Available Identifiers
                                                                                            	**type**\:  :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                            
                                                                                            .. attribute:: media_type
                                                                                            
                                                                                            	Media Type
                                                                                            	**type**\:  :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                            
                                                                                            .. attribute:: subs_protocol
                                                                                            
                                                                                            	Protocol
                                                                                            	**type**\:  :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                            
                                                                                            .. attribute:: dnis
                                                                                            
                                                                                            	DNIS
                                                                                            	**type**\:  :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                            
                                                                                            .. attribute:: dnis_regex
                                                                                            
                                                                                            	DNIS Regular Expression
                                                                                            	**type**\:  :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                            
                                                                                            .. attribute:: domain
                                                                                            
                                                                                            	Domain Name
                                                                                            	**type**\:  :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                            
                                                                                            .. attribute:: domain_regex
                                                                                            
                                                                                            	Domain Regular Expression
                                                                                            	**type**\:  :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                            
                                                                                            .. attribute:: nas_port
                                                                                            
                                                                                            	NAS Port
                                                                                            	**type**\:  :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                            
                                                                                            .. attribute:: service_name
                                                                                            
                                                                                            	Service Name
                                                                                            	**type**\:  :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                            
                                                                                            .. attribute:: service_name_regex
                                                                                            
                                                                                            	Service Name Regular Exp
                                                                                            	**type**\:  :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv4
                                                                                            
                                                                                            	Source Address IPV4
                                                                                            	**type**\:  :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv4
                                                                                            
                                                                                            	Destination Address IPV4
                                                                                            	**type**\:  :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv6
                                                                                            
                                                                                            	Source Address IPV6
                                                                                            	**type**\:  :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv6
                                                                                            
                                                                                            	Destination Address IPV6
                                                                                            	**type**\:  :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: src_addr_mac
                                                                                            
                                                                                            	Source Address MAC
                                                                                            	**type**\:  :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                            
                                                                                            .. attribute:: timer
                                                                                            
                                                                                            	Timer
                                                                                            	**type**\:  :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                            
                                                                                            .. attribute:: timer_regexp
                                                                                            
                                                                                            	Timer Regular Expression
                                                                                            	**type**\:  :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                            
                                                                                            .. attribute:: tunnel_name
                                                                                            
                                                                                            	Tunnel Name
                                                                                            	**type**\:  :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                            
                                                                                            .. attribute:: tunnel_name_regex
                                                                                            
                                                                                            	Tunnel Name Regular Expression
                                                                                            	**type**\:  :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                            
                                                                                            .. attribute:: user_name
                                                                                            
                                                                                            	User Name
                                                                                            	**type**\:  :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                            
                                                                                            .. attribute:: user_name_regex
                                                                                            
                                                                                            	User Name Regular Expression
                                                                                            	**type**\:  :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                            
                                                                                            .. attribute:: auth_username
                                                                                            
                                                                                            	Authenticated User Name
                                                                                            	**type**\:  :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                            
                                                                                            .. attribute:: auth_username_regex
                                                                                            
                                                                                            	Authenticated User Name RegEx
                                                                                            	**type**\:  :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_username
                                                                                            
                                                                                            	Unauthenticated User Name
                                                                                            	**type**\:  :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                            
                                                                                            .. attribute:: unauth_username_regex
                                                                                            
                                                                                            	Unauthenticated User Name RegEx
                                                                                            	**type**\:  :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: auth_domain
                                                                                            
                                                                                            	Authenticated domain name
                                                                                            	**type**\:  :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                            
                                                                                            .. attribute:: auth_domain_regex
                                                                                            
                                                                                            	Authenticated Domain Name RegEx
                                                                                            	**type**\:  :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_domain
                                                                                            
                                                                                            	Unauthenticated Domain Name
                                                                                            	**type**\:  :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                            
                                                                                            .. attribute:: unauth_domain_regex
                                                                                            
                                                                                            	Unauthenticated Domain Name RegEx
                                                                                            	**type**\:  :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: vendor_id
                                                                                            
                                                                                            	Vendor ID
                                                                                            	**type**\:  :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                            
                                                                                            .. attribute:: vendor_id_regex
                                                                                            
                                                                                            	Vendor ID RegEx
                                                                                            	**type**\:  :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                            
                                                                                            .. attribute:: access_interface
                                                                                            
                                                                                            	Access interface
                                                                                            	**type**\:  :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                            
                                                                                            .. attribute:: input_interface
                                                                                            
                                                                                            	Input interface
                                                                                            	**type**\:  :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                            
                                                                                            .. attribute:: input_intfhdl
                                                                                            
                                                                                            	Input interface handle
                                                                                            	**type**\:  :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                            
                                                                                            .. attribute:: ethertype
                                                                                            
                                                                                            	Ethernet type
                                                                                            	**type**\:  :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                            
                                                                                            .. attribute:: flow_key_data
                                                                                            
                                                                                            	Flow key structure
                                                                                            	**type**\:  :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id
                                                                                            
                                                                                            	Dhcp Client ID
                                                                                            	**type**\:  :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id_regex
                                                                                            
                                                                                            	Dhcp Client ID RegEx
                                                                                            	**type**\:  :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                            
                                                                                            .. attribute:: circuit_id
                                                                                            
                                                                                            	Circuit ID
                                                                                            	**type**\:  :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                            
                                                                                            .. attribute:: circuit_id_regex
                                                                                            
                                                                                            	Circuit ID RegEx
                                                                                            	**type**\:  :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                            
                                                                                            .. attribute:: remote_id
                                                                                            
                                                                                            	Remote ID
                                                                                            	**type**\:  :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                            
                                                                                            .. attribute:: remote_id_regex
                                                                                            
                                                                                            	Remote ID RegEx
                                                                                            	**type**\:  :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                            
                                                                                            .. attribute:: src_port
                                                                                            
                                                                                            	Source port
                                                                                            	**type**\:  :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                            
                                                                                            .. attribute:: dst_port
                                                                                            
                                                                                            	Destination port
                                                                                            	**type**\:  :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	type
                                                                                            	**type**\:  :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                            
                                                                                            .. attribute:: mpls_top_eos
                                                                                            
                                                                                            	MPLS Topmost EOS
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: fragment_type
                                                                                            
                                                                                            	Fragment type
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: authen_status
                                                                                            
                                                                                            	Authentication Status
                                                                                            	**type**\:  :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                            
                                                                                            .. attribute:: mlp_negotiated
                                                                                            
                                                                                            	MLP Negotiated
                                                                                            	**type**\:  :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                                self.yang_name = "match-data"
                                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("ipv4-dscp", ("ipv4_dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp)), ("ipv6-dscp", ("ipv6_dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp)), ("dscp", ("dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp)), ("ipv4-prec", ("ipv4_prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec)), ("ipv6-prec", ("ipv6_prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec)), ("prec", ("prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec)), ("discard-class", ("discard_class", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass)), ("qos-group", ("qos_group", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup)), ("traffic-class", ("traffic_class", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass)), ("proto", ("proto", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto)), ("icmp-v4", ("icmp_v4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4)), ("icmp-v6", ("icmp_v6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6)), ("ipv4-packet-len", ("ipv4_packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen)), ("ipv6-packet-len", ("ipv6_packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen)), ("packet-len", ("packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen)), ("flow-tag", ("flow_tag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag)), ("tcp-flag", ("tcp_flag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag)), ("icmpv4-type", ("icmpv4_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type)), ("icmpv4-code", ("icmpv4_code", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code)), ("icmpv6-type", ("icmpv6_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type)), ("icmpv6-code", ("icmpv6_code", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code)), ("mpls-exp", ("mpls_exp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp)), ("mpls-exp-imp", ("mpls_exp_imp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp)), ("mpls-disp-ipv4-acl", ("mpls_disp_ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl)), ("mpls-disp-ipv6-acl", ("mpls_disp_ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl)), ("mpls-top-label", ("mpls_top_label", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel)), ("cos", ("cos", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos)), ("cos-inr", ("cos_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr)), ("dei", ("dei", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei)), ("dei-inr", ("dei_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr)), ("vlan", ("vlan", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan)), ("vlan-inr", ("vlan_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)), ("fr-dlci", ("fr_dlci", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci)), ("src-mac", ("src_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac)), ("dst-mac", ("dst_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac)), ("atm-clp", ("atm_clp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp)), ("fr-de", ("fr_de", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe)), ("ipv4-acl", ("ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl)), ("ipv6-acl", ("ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl)), ("ether-service-acl", ("ether_service_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl)), ("avail-id", ("avail_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId)), ("media-type", ("media_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType)), ("subs-protocol", ("subs_protocol", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol)), ("dnis", ("dnis", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis)), ("dnis-regex", ("dnis_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex)), ("domain", ("domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain)), ("domain-regex", ("domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex)), ("nas-port", ("nas_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort)), ("service-name", ("service_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName)), ("service-name-regex", ("service_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex)), ("src-addr-ipv4", ("src_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4)), ("dst-addr-ipv4", ("dst_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4)), ("src-addr-ipv6", ("src_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6)), ("dst-addr-ipv6", ("dst_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6)), ("src-addr-mac", ("src_addr_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac)), ("timer", ("timer", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer)), ("timer-regexp", ("timer_regexp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp)), ("tunnel-name", ("tunnel_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName)), ("tunnel-name-regex", ("tunnel_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex)), ("user-name", ("user_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName)), ("user-name-regex", ("user_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex)), ("auth-username", ("auth_username", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername)), ("auth-username-regex", ("auth_username_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex)), ("unauth-username", ("unauth_username", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername)), ("unauth-username-regex", ("unauth_username_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex)), ("auth-domain", ("auth_domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain)), ("auth-domain-regex", ("auth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex)), ("unauth-domain", ("unauth_domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain)), ("unauth-domain-regex", ("unauth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex)), ("vendor-id", ("vendor_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId)), ("vendor-id-regex", ("vendor_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex)), ("access-interface", ("access_interface", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface)), ("input-interface", ("input_interface", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface)), ("input-intfhdl", ("input_intfhdl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl)), ("ethertype", ("ethertype", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype)), ("flow-key-data", ("flow_key_data", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData)), ("dhcp-client-id", ("dhcp_client_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId)), ("dhcp-client-id-regex", ("dhcp_client_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex)), ("circuit-id", ("circuit_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId)), ("circuit-id-regex", ("circuit_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex)), ("remote-id", ("remote_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId)), ("remote-id-regex", ("remote_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex)), ("src-port", ("src_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort)), ("dst-port", ("dst_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort))])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchTypeEn', '')])),
                                                                                                    ('mpls_top_eos', (YLeaf(YType.uint8, 'mpls-top-eos'), ['int'])),
                                                                                                    ('fragment_type', (YLeaf(YType.uint8, 'fragment-type'), ['int'])),
                                                                                                    ('authen_status', (YLeaf(YType.enumeration, 'authen-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchAuthenStatusEn', '')])),
                                                                                                    ('mlp_negotiated', (YLeaf(YType.enumeration, 'mlp-negotiated'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchMlpNegotiatedEn', '')])),
                                                                                                ])
                                                                                                self.type = None
                                                                                                self.mpls_top_eos = None
                                                                                                self.fragment_type = None
                                                                                                self.authen_status = None
                                                                                                self.mlp_negotiated = None

                                                                                                self.ipv4_dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                                self.ipv4_dscp.parent = self
                                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"

                                                                                                self.ipv6_dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                                self.ipv6_dscp.parent = self
                                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"

                                                                                                self.dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                                self.dscp.parent = self
                                                                                                self._children_name_map["dscp"] = "dscp"

                                                                                                self.ipv4_prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                                self.ipv4_prec.parent = self
                                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"

                                                                                                self.ipv6_prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                                self.ipv6_prec.parent = self
                                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"

                                                                                                self.prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                                self.prec.parent = self
                                                                                                self._children_name_map["prec"] = "prec"

                                                                                                self.discard_class = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                                self.discard_class.parent = self
                                                                                                self._children_name_map["discard_class"] = "discard-class"

                                                                                                self.qos_group = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                                self.qos_group.parent = self
                                                                                                self._children_name_map["qos_group"] = "qos-group"

                                                                                                self.traffic_class = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                                self.traffic_class.parent = self
                                                                                                self._children_name_map["traffic_class"] = "traffic-class"

                                                                                                self.proto = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                                self.proto.parent = self
                                                                                                self._children_name_map["proto"] = "proto"

                                                                                                self.icmp_v4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                                self.icmp_v4.parent = self
                                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"

                                                                                                self.icmp_v6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                                self.icmp_v6.parent = self
                                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"

                                                                                                self.ipv4_packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                                self.ipv4_packet_len.parent = self
                                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"

                                                                                                self.ipv6_packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                                self.ipv6_packet_len.parent = self
                                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"

                                                                                                self.packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                                self.packet_len.parent = self
                                                                                                self._children_name_map["packet_len"] = "packet-len"

                                                                                                self.flow_tag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                                self.flow_tag.parent = self
                                                                                                self._children_name_map["flow_tag"] = "flow-tag"

                                                                                                self.tcp_flag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                                self.tcp_flag.parent = self
                                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"

                                                                                                self.icmpv4_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                                self.icmpv4_type.parent = self
                                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"

                                                                                                self.icmpv4_code = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                                self.icmpv4_code.parent = self
                                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"

                                                                                                self.icmpv6_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                                self.icmpv6_type.parent = self
                                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"

                                                                                                self.icmpv6_code = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                                self.icmpv6_code.parent = self
                                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"

                                                                                                self.mpls_exp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                                self.mpls_exp.parent = self
                                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"

                                                                                                self.mpls_exp_imp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                                self.mpls_exp_imp.parent = self
                                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"

                                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"

                                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"

                                                                                                self.mpls_top_label = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                                self.mpls_top_label.parent = self
                                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"

                                                                                                self.cos = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                                self.cos.parent = self
                                                                                                self._children_name_map["cos"] = "cos"

                                                                                                self.cos_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                                self.cos_inr.parent = self
                                                                                                self._children_name_map["cos_inr"] = "cos-inr"

                                                                                                self.dei = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                                self.dei.parent = self
                                                                                                self._children_name_map["dei"] = "dei"

                                                                                                self.dei_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                                self.dei_inr.parent = self
                                                                                                self._children_name_map["dei_inr"] = "dei-inr"

                                                                                                self.vlan = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                                self.vlan.parent = self
                                                                                                self._children_name_map["vlan"] = "vlan"

                                                                                                self.vlan_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                                self.vlan_inr.parent = self
                                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"

                                                                                                self.fr_dlci = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                                self.fr_dlci.parent = self
                                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"

                                                                                                self.src_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                                self.src_mac.parent = self
                                                                                                self._children_name_map["src_mac"] = "src-mac"

                                                                                                self.dst_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                                self.dst_mac.parent = self
                                                                                                self._children_name_map["dst_mac"] = "dst-mac"

                                                                                                self.atm_clp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                                self.atm_clp.parent = self
                                                                                                self._children_name_map["atm_clp"] = "atm-clp"

                                                                                                self.fr_de = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                                self.fr_de.parent = self
                                                                                                self._children_name_map["fr_de"] = "fr-de"

                                                                                                self.ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                                self.ipv4_acl.parent = self
                                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"

                                                                                                self.ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                                self.ipv6_acl.parent = self
                                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"

                                                                                                self.ether_service_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                                self.ether_service_acl.parent = self
                                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"

                                                                                                self.avail_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                                self.avail_id.parent = self
                                                                                                self._children_name_map["avail_id"] = "avail-id"

                                                                                                self.media_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                                self.media_type.parent = self
                                                                                                self._children_name_map["media_type"] = "media-type"

                                                                                                self.subs_protocol = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                                self.subs_protocol.parent = self
                                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"

                                                                                                self.dnis = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                                self.dnis.parent = self
                                                                                                self._children_name_map["dnis"] = "dnis"

                                                                                                self.dnis_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                                self.dnis_regex.parent = self
                                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"

                                                                                                self.domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                                self.domain.parent = self
                                                                                                self._children_name_map["domain"] = "domain"

                                                                                                self.domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                                self.domain_regex.parent = self
                                                                                                self._children_name_map["domain_regex"] = "domain-regex"

                                                                                                self.nas_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                                self.nas_port.parent = self
                                                                                                self._children_name_map["nas_port"] = "nas-port"

                                                                                                self.service_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                                self.service_name.parent = self
                                                                                                self._children_name_map["service_name"] = "service-name"

                                                                                                self.service_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                                self.service_name_regex.parent = self
                                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"

                                                                                                self.src_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                                self.src_addr_ipv4.parent = self
                                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"

                                                                                                self.dst_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                                self.dst_addr_ipv4.parent = self
                                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"

                                                                                                self.src_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                                self.src_addr_ipv6.parent = self
                                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"

                                                                                                self.dst_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                                self.dst_addr_ipv6.parent = self
                                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"

                                                                                                self.src_addr_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                                self.src_addr_mac.parent = self
                                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"

                                                                                                self.timer = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                                self.timer.parent = self
                                                                                                self._children_name_map["timer"] = "timer"

                                                                                                self.timer_regexp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                                self.timer_regexp.parent = self
                                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"

                                                                                                self.tunnel_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                                self.tunnel_name.parent = self
                                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"

                                                                                                self.tunnel_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                                self.tunnel_name_regex.parent = self
                                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"

                                                                                                self.user_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                                self.user_name.parent = self
                                                                                                self._children_name_map["user_name"] = "user-name"

                                                                                                self.user_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                                self.user_name_regex.parent = self
                                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"

                                                                                                self.auth_username = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                                self.auth_username.parent = self
                                                                                                self._children_name_map["auth_username"] = "auth-username"

                                                                                                self.auth_username_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                                self.auth_username_regex.parent = self
                                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"

                                                                                                self.unauth_username = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                                self.unauth_username.parent = self
                                                                                                self._children_name_map["unauth_username"] = "unauth-username"

                                                                                                self.unauth_username_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                                self.unauth_username_regex.parent = self
                                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"

                                                                                                self.auth_domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                                self.auth_domain.parent = self
                                                                                                self._children_name_map["auth_domain"] = "auth-domain"

                                                                                                self.auth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                                self.auth_domain_regex.parent = self
                                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"

                                                                                                self.unauth_domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                                self.unauth_domain.parent = self
                                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"

                                                                                                self.unauth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                                self.unauth_domain_regex.parent = self
                                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"

                                                                                                self.vendor_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                                self.vendor_id.parent = self
                                                                                                self._children_name_map["vendor_id"] = "vendor-id"

                                                                                                self.vendor_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                                self.vendor_id_regex.parent = self
                                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"

                                                                                                self.access_interface = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                                self.access_interface.parent = self
                                                                                                self._children_name_map["access_interface"] = "access-interface"

                                                                                                self.input_interface = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                                self.input_interface.parent = self
                                                                                                self._children_name_map["input_interface"] = "input-interface"

                                                                                                self.input_intfhdl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                                self.input_intfhdl.parent = self
                                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"

                                                                                                self.ethertype = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                                self.ethertype.parent = self
                                                                                                self._children_name_map["ethertype"] = "ethertype"

                                                                                                self.flow_key_data = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                                self.flow_key_data.parent = self
                                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"

                                                                                                self.dhcp_client_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                                self.dhcp_client_id.parent = self
                                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"

                                                                                                self.dhcp_client_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                                self.dhcp_client_id_regex.parent = self
                                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"

                                                                                                self.circuit_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                                self.circuit_id.parent = self
                                                                                                self._children_name_map["circuit_id"] = "circuit-id"

                                                                                                self.circuit_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                                self.circuit_id_regex.parent = self
                                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"

                                                                                                self.remote_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                                self.remote_id.parent = self
                                                                                                self._children_name_map["remote_id"] = "remote-id"

                                                                                                self.remote_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                                self.remote_id_regex.parent = self
                                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"

                                                                                                self.src_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                                self.src_port.parent = self
                                                                                                self._children_name_map["src_port"] = "src-port"

                                                                                                self.dst_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                                self.dst_port.parent = self
                                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                                self._segment_path = lambda: "match-data"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['type', 'mpls_top_eos', 'fragment_type', 'authen_status', 'mlp_negotiated'], name, value)


                                                                                            class Ipv4Dscp(Entity):
                                                                                                """
                                                                                                IPv4 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv4-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv6Dscp(Entity):
                                                                                                """
                                                                                                IPv6 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv6-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Dscp(Entity):
                                                                                                """
                                                                                                Match DSCP range array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                    self.yang_name = "dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv4Prec(Entity):
                                                                                                """
                                                                                                IPv4 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                    self.yang_name = "ipv4-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "ipv4-prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                            class Ipv6Prec(Entity):
                                                                                                """
                                                                                                IPv6 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                    self.yang_name = "ipv6-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "ipv6-prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                            class Prec(Entity):
                                                                                                """
                                                                                                Match Precedence array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                    self.yang_name = "prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                            class DiscardClass(Entity):
                                                                                                """
                                                                                                Match Discard Class array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                    self.yang_name = "discard-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "discard-class"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                            class QosGroup(Entity):
                                                                                                """
                                                                                                Match QoS group array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                    self.yang_name = "qos-group"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "qos-group"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "qos-group"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class TrafficClass(Entity):
                                                                                                """
                                                                                                Match Traffic class array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                    self.yang_name = "traffic-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "traffic-class"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "traffic-class"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Proto(Entity):
                                                                                                """
                                                                                                Match Protocol array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                    self.yang_name = "proto"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "proto"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "proto"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class IcmpV4(Entity):
                                                                                                """
                                                                                                Match ICMPV4 Protocol
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                    self.yang_name = "icmp-v4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                    ])
                                                                                                    self.type = None
                                                                                                    self.code = None
                                                                                                    self._segment_path = lambda: "icmp-v4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['type', 'code'], name, value)


                                                                                            class IcmpV6(Entity):
                                                                                                """
                                                                                                Match ICMPV6 Protocol array
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                    self.yang_name = "icmp-v6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                    ])
                                                                                                    self.type = None
                                                                                                    self.code = None
                                                                                                    self._segment_path = lambda: "icmp-v6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['type', 'code'], name, value)


                                                                                            class Ipv4PacketLen(Entity):
                                                                                                """
                                                                                                IPv4 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv6PacketLen(Entity):
                                                                                                """
                                                                                                IPv6 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class PacketLen(Entity):
                                                                                                """
                                                                                                Match packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                    self.yang_name = "packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FlowTag(Entity):
                                                                                                """
                                                                                                Match flow\-tag array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                    self.yang_name = "flow-tag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "flow-tag"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "flow-tag"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class TcpFlag(Entity):
                                                                                                """
                                                                                                Match tcp flag value
                                                                                                
                                                                                                .. attribute:: value
                                                                                                
                                                                                                	Value of TCP flag
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: match_any
                                                                                                
                                                                                                	Match any TCP flag bit
                                                                                                	**type**\: bool
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                    self.yang_name = "tcp-flag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                                        ('match_any', (YLeaf(YType.boolean, 'match-any'), ['bool'])),
                                                                                                    ])
                                                                                                    self.value = None
                                                                                                    self.match_any = None
                                                                                                    self._segment_path = lambda: "tcp-flag"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['value', 'match_any'], name, value)


                                                                                            class Icmpv4Type(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                    self.yang_name = "icmpv4-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv4Code(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                    self.yang_name = "icmpv4-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-code"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv6Type(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                    self.yang_name = "icmpv6-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv6Code(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                    self.yang_name = "icmpv6-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-code"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class MplsExp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental topmost array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "mpls-exp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                            class MplsExpImp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental imposition array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "mpls-exp-imp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                            class MplsDispIpv4Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                            class MplsDispIpv6Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                            class MplsTopLabel(Entity):
                                                                                                """
                                                                                                MPLS Topmost LABEL
                                                                                                
                                                                                                .. attribute:: uint32_rng_array
                                                                                                
                                                                                                	uint32 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                    self.yang_name = "mpls-top-label"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint32_rng_array", ("uint32_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint32_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "mpls-top-label"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                                class Uint32RngArray(Entity):
                                                                                                    """
                                                                                                    uint32 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                        self.yang_name = "uint32_rng_array"
                                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint32, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint32, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint32_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['min', 'max'], name, value)


                                                                                            class Cos(Entity):
                                                                                                """
                                                                                                Match CoS array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                    self.yang_name = "cos"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "cos"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                            class CosInr(Entity):
                                                                                                """
                                                                                                Match inner header CoS
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                    self.yang_name = "cos-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "cos-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                            class Dei(Entity):
                                                                                                """
                                                                                                Match DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                    self.yang_name = "dei"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                    ])
                                                                                                    self.bit_value = None
                                                                                                    self._segment_path = lambda: "dei"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                            class DeiInr(Entity):
                                                                                                """
                                                                                                Match inner DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                    self.yang_name = "dei-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                    ])
                                                                                                    self.bit_value = None
                                                                                                    self._segment_path = lambda: "dei-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                            class Vlan(Entity):
                                                                                                """
                                                                                                Match VLAN array
                                                                                                
                                                                                                .. attribute:: vlan_id_array
                                                                                                
                                                                                                	vlan id array
                                                                                                	**type**\: list of  		 :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                    self.yang_name = "vlan"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("vlan-id-array", ("vlan_id_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.vlan_id_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                                class VlanIdArray(Entity):
                                                                                                    """
                                                                                                    vlan id array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	VLAN mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                        self.yang_name = "vlan-id-array"
                                                                                                        self.yang_parent_name = "vlan"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ('mask', (YLeaf(YType.uint16, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "vlan-id-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['min', 'max', 'mask'], name, value)


                                                                                            class VlanInr(Entity):
                                                                                                """
                                                                                                Match inner header VLAN range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                    self.yang_name = "vlan-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FrDlci(Entity):
                                                                                                """
                                                                                                Match FR DLCI range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                    self.yang_name = "fr-dlci"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "fr-dlci"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class SrcMac(Entity):
                                                                                                """
                                                                                                Match Source MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                    self.yang_name = "src-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.mac_addr = []
                                                                                                    self.mask = []
                                                                                                    self._segment_path = lambda: "src-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                            class DstMac(Entity):
                                                                                                """
                                                                                                Match Destination MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                    self.yang_name = "dst-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.mac_addr = []
                                                                                                    self.mask = []
                                                                                                    self._segment_path = lambda: "dst-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                            class AtmClp(Entity):
                                                                                                """
                                                                                                Match ATM CLP level
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                    self.yang_name = "atm-clp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "atm-clp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                            class FrDe(Entity):
                                                                                                """
                                                                                                Match FR DE value
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                    self.yang_name = "fr-de"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "fr-de"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                            class Ipv4Acl(Entity):
                                                                                                """
                                                                                                IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                    self.yang_name = "ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ipv4-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                            class Ipv6Acl(Entity):
                                                                                                """
                                                                                                IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                    self.yang_name = "ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ipv6-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                            class EtherServiceAcl(Entity):
                                                                                                """
                                                                                                Ethernet\-Services Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                    self.yang_name = "ether-service-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ether-service-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                            class AvailId(Entity):
                                                                                                """
                                                                                                Available Identifiers
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                    self.yang_name = "avail-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "avail-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                            class MediaType(Entity):
                                                                                                """
                                                                                                Media Type
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                    self.yang_name = "media-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "media-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                            class SubsProtocol(Entity):
                                                                                                """
                                                                                                Protocol
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                    self.yang_name = "subs-protocol"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "subs-protocol"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                            class Dnis(Entity):
                                                                                                """
                                                                                                DNIS
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                    self.yang_name = "dnis"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dnis"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                            class DnisRegex(Entity):
                                                                                                """
                                                                                                DNIS Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                    self.yang_name = "dnis-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dnis-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                            class Domain(Entity):
                                                                                                """
                                                                                                Domain Name
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                    self.yang_name = "domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                        ])
                                                                                                        self.domain_name = None
                                                                                                        self.format_name = None
                                                                                                        self._segment_path = lambda: "domain-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class DomainRegex(Entity):
                                                                                                """
                                                                                                Domain Regular Expression
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                    self.yang_name = "domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain-regex"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                        ])
                                                                                                        self.domain_name = None
                                                                                                        self.format_name = None
                                                                                                        self._segment_path = lambda: "domain-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class NasPort(Entity):
                                                                                                """
                                                                                                NAS Port
                                                                                                
                                                                                                .. attribute:: nas_port_array
                                                                                                
                                                                                                	nas port array
                                                                                                	**type**\: list of  		 :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                    self.yang_name = "nas-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("nas-port-array", ("nas_port_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.nas_port_array = YList(self)
                                                                                                    self._segment_path = lambda: "nas-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                                class NasPortArray(Entity):
                                                                                                    """
                                                                                                    nas port array
                                                                                                    
                                                                                                    .. attribute:: sub_id
                                                                                                    
                                                                                                    	sub id
                                                                                                    	**type**\:  :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                    
                                                                                                    .. attribute:: operator
                                                                                                    
                                                                                                    	operator
                                                                                                    	**type**\:  :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	value
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                        self.yang_name = "nas-port-array"
                                                                                                        self.yang_parent_name = "nas-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('sub_id', (YLeaf(YType.enumeration, 'sub-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchNasPortSubIdEn', '')])),
                                                                                                            ('operator', (YLeaf(YType.enumeration, 'operator'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchLogicalOperatorEn', '')])),
                                                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                                        ])
                                                                                                        self.sub_id = None
                                                                                                        self.operator = None
                                                                                                        self.value = None
                                                                                                        self._segment_path = lambda: "nas-port-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['sub_id', 'operator', 'value'], name, value)


                                                                                            class ServiceName(Entity):
                                                                                                """
                                                                                                Service Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                    self.yang_name = "service-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "service-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                            class ServiceNameRegex(Entity):
                                                                                                """
                                                                                                Service Name Regular Exp
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                    self.yang_name = "service-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "service-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                            class SrcAddrIpv4(Entity):
                                                                                                """
                                                                                                Source Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class DstAddrIpv4(Entity):
                                                                                                """
                                                                                                Destination Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class SrcAddrIpv6(Entity):
                                                                                                """
                                                                                                Source Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class DstAddrIpv6(Entity):
                                                                                                """
                                                                                                Destination Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class SrcAddrMac(Entity):
                                                                                                """
                                                                                                Source Address MAC
                                                                                                
                                                                                                .. attribute:: mac_addr_array
                                                                                                
                                                                                                	mac addr array
                                                                                                	**type**\: list of  		 :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                    self.yang_name = "src-addr-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("mac-addr-array", ("mac_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.mac_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                                class MacAddrArray(Entity):
                                                                                                    """
                                                                                                    mac addr array
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                        self.yang_name = "mac-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                            ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.mac_addr = []
                                                                                                        self.mask = []
                                                                                                        self._segment_path = lambda: "mac-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                            class Timer(Entity):
                                                                                                """
                                                                                                Timer
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                    self.yang_name = "timer"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "timer"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                            class TimerRegexp(Entity):
                                                                                                """
                                                                                                Timer Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                    self.yang_name = "timer-regexp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "timer-regexp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                            class TunnelName(Entity):
                                                                                                """
                                                                                                Tunnel Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                    self.yang_name = "tunnel-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "tunnel-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                            class TunnelNameRegex(Entity):
                                                                                                """
                                                                                                Tunnel Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "tunnel-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                            class UserName(Entity):
                                                                                                """
                                                                                                User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                    self.yang_name = "user-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "user-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                            class UserNameRegex(Entity):
                                                                                                """
                                                                                                User Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                    self.yang_name = "user-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "user-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                            class AuthUsername(Entity):
                                                                                                """
                                                                                                Authenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                    self.yang_name = "auth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-username"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                            class AuthUsernameRegex(Entity):
                                                                                                """
                                                                                                Authenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "auth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-username-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                            class UnauthUsername(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                    self.yang_name = "unauth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-username"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                            class UnauthUsernameRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-username-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                            class AuthDomain(Entity):
                                                                                                """
                                                                                                Authenticated domain name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                    self.yang_name = "auth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                            class AuthDomainRegex(Entity):
                                                                                                """
                                                                                                Authenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "auth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                            class UnauthDomain(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                    self.yang_name = "unauth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                            class UnauthDomainRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                            class VendorId(Entity):
                                                                                                """
                                                                                                Vendor ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                    self.yang_name = "vendor-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "vendor-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                            class VendorIdRegex(Entity):
                                                                                                """
                                                                                                Vendor ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                    self.yang_name = "vendor-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "vendor-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                            class AccessInterface(Entity):
                                                                                                """
                                                                                                Access interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                    self.yang_name = "access-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "access-interface"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                            class InputInterface(Entity):
                                                                                                """
                                                                                                Input interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                    self.yang_name = "input-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "input-interface"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                            class InputIntfhdl(Entity):
                                                                                                """
                                                                                                Input interface handle
                                                                                                
                                                                                                .. attribute:: uint64_array
                                                                                                
                                                                                                	uint64 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..18446744073709551615
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                    self.yang_name = "input-intfhdl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint64_array', (YLeafList(YType.uint64, 'uint64_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint64_array = []
                                                                                                    self._segment_path = lambda: "input-intfhdl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                            class Ethertype(Entity):
                                                                                                """
                                                                                                Ethernet type
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                    self.yang_name = "ethertype"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ethertype"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ethertype"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FlowKeyData(Entity):
                                                                                                """
                                                                                                Flow key structure
                                                                                                
                                                                                                .. attribute:: flow_keys
                                                                                                
                                                                                                	flow keys
                                                                                                	**type**\:  :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                                
                                                                                                .. attribute:: max_count
                                                                                                
                                                                                                	Maximum count of flows
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: idle_timeout
                                                                                                
                                                                                                	Idle timeout of flows (in seconds)
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                	**units**\: second
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                    self.yang_name = "flow-key-data"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("flow-keys", ("flow_keys", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys))])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('max_count', (YLeaf(YType.uint16, 'max-count'), ['int'])),
                                                                                                        ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                                                    ])
                                                                                                    self.max_count = None
                                                                                                    self.idle_timeout = None

                                                                                                    self.flow_keys = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                    self.flow_keys.parent = self
                                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                    self._segment_path = lambda: "flow-key-data"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['max_count', 'idle_timeout'], name, value)


                                                                                                class FlowKeys(Entity):
                                                                                                    """
                                                                                                    flow keys
                                                                                                    
                                                                                                    .. attribute:: keys
                                                                                                    
                                                                                                    	keys
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                    
                                                                                                    .. attribute:: num
                                                                                                    
                                                                                                    	num
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                        self.yang_name = "flow-keys"
                                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('keys', (YLeaf(YType.str, 'keys'), ['str'])),
                                                                                                            ('num', (YLeaf(YType.uint8, 'num'), ['int'])),
                                                                                                        ])
                                                                                                        self.keys = None
                                                                                                        self.num = None
                                                                                                        self._segment_path = lambda: "flow-keys"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                            class DhcpClientId(Entity):
                                                                                                """
                                                                                                Dhcp Client ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dhcp-client-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                            class DhcpClientIdRegex(Entity):
                                                                                                """
                                                                                                Dhcp Client ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                            class CircuitId(Entity):
                                                                                                """
                                                                                                Circuit ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                    self.yang_name = "circuit-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "circuit-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                            class CircuitIdRegex(Entity):
                                                                                                """
                                                                                                Circuit ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                    self.yang_name = "circuit-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "circuit-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                            class RemoteId(Entity):
                                                                                                """
                                                                                                Remote ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                    self.yang_name = "remote-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "remote-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                            class RemoteIdRegex(Entity):
                                                                                                """
                                                                                                Remote ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                    self.yang_name = "remote-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "remote-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                            class SrcPort(Entity):
                                                                                                """
                                                                                                Source port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                    self.yang_name = "src-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "src-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class DstPort(Entity):
                                                                                                """
                                                                                                Destination port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                    self.yang_name = "dst-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "dst-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                        class ExcdclassEncode(Entity):
                                                                            """
                                                                            excdclass encode
                                                                            
                                                                            .. attribute:: inline_cmap
                                                                            
                                                                            	inline cmap
                                                                            	**type**\:  :py:class:`InlineCmap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap>`
                                                                            
                                                                            .. attribute:: enc
                                                                            
                                                                            	enc
                                                                            	**type**\:  :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                            
                                                                            .. attribute:: class_name
                                                                            
                                                                            	class name
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..65
                                                                            
                                                                            .. attribute:: hd
                                                                            
                                                                            	hd
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: idx
                                                                            
                                                                            	idx
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode, self).__init__()

                                                                                self.yang_name = "excdclass-encode"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("inline-cmap", ("inline_cmap", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('enc', (YLeaf(YType.enumeration, 'enc'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyObjEncEn', '')])),
                                                                                    ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                                                    ('hd', (YLeaf(YType.uint64, 'hd'), ['int'])),
                                                                                    ('idx', (YLeaf(YType.uint8, 'idx'), ['int'])),
                                                                                ])
                                                                                self.enc = None
                                                                                self.class_name = None
                                                                                self.hd = None
                                                                                self.idx = None

                                                                                self.inline_cmap = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap()
                                                                                self.inline_cmap.parent = self
                                                                                self._children_name_map["inline_cmap"] = "inline-cmap"
                                                                                self._segment_path = lambda: "excdclass-encode"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode, ['enc', 'class_name', 'hd', 'idx'], name, value)


                                                                            class InlineCmap(Entity):
                                                                                """
                                                                                inline cmap
                                                                                
                                                                                .. attribute:: match_infop
                                                                                
                                                                                	Pointer to the first Match info
                                                                                	**type**\:  :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop>`
                                                                                
                                                                                .. attribute:: mode
                                                                                
                                                                                	Inline Class\-Map Mode Match any/all
                                                                                	**type**\:  :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                                
                                                                                .. attribute:: flags
                                                                                
                                                                                	Inline Class\-Map flags
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: match_count
                                                                                
                                                                                	Number of Match infos
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap, self).__init__()

                                                                                    self.yang_name = "inline-cmap"
                                                                                    self.yang_parent_name = "excdclass-encode"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("match-infop", ("match_infop", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapModeEn', '')])),
                                                                                        ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                        ('match_count', (YLeaf(YType.uint32, 'match-count'), ['int'])),
                                                                                    ])
                                                                                    self.mode = None
                                                                                    self.flags = None
                                                                                    self.match_count = None

                                                                                    self.match_infop = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop()
                                                                                    self.match_infop.parent = self
                                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                                    self._segment_path = lambda: "inline-cmap"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap, ['mode', 'flags', 'match_count'], name, value)


                                                                                class MatchInfop(Entity):
                                                                                    """
                                                                                    Pointer to the first Match info
                                                                                    
                                                                                    .. attribute:: class_match_info_st
                                                                                    
                                                                                    	class match info st
                                                                                    	**type**\: list of  		 :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop, self).__init__()

                                                                                        self.yang_name = "match-infop"
                                                                                        self.yang_parent_name = "inline-cmap"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("class-match-info-st", ("class_match_info_st", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.class_match_info_st = YList(self)
                                                                                        self._segment_path = lambda: "match-infop"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop, [], name, value)


                                                                                    class ClassMatchInfoSt(Entity):
                                                                                        """
                                                                                        class match info st
                                                                                        
                                                                                        .. attribute:: match_data
                                                                                        
                                                                                        	Match criteria
                                                                                        	**type**\:  :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                        
                                                                                        .. attribute:: flags
                                                                                        
                                                                                        	Flags
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                            self.yang_name = "class-match-info-st"
                                                                                            self.yang_parent_name = "match-infop"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("match-data", ("match_data", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData))])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                            ])
                                                                                            self.flags = None

                                                                                            self.match_data = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                            self.match_data.parent = self
                                                                                            self._children_name_map["match_data"] = "match-data"
                                                                                            self._segment_path = lambda: "class-match-info-st"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                        class MatchData(Entity):
                                                                                            """
                                                                                            Match criteria
                                                                                            
                                                                                            .. attribute:: ipv4_dscp
                                                                                            
                                                                                            	IPv4 DSCP
                                                                                            	**type**\:  :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv6_dscp
                                                                                            
                                                                                            	IPv6 DSCP
                                                                                            	**type**\:  :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                            
                                                                                            .. attribute:: dscp
                                                                                            
                                                                                            	Match DSCP range array
                                                                                            	**type**\:  :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv4_prec
                                                                                            
                                                                                            	IPv4 Precedence
                                                                                            	**type**\:  :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                            
                                                                                            .. attribute:: ipv6_prec
                                                                                            
                                                                                            	IPv6 Precedence
                                                                                            	**type**\:  :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                            
                                                                                            .. attribute:: prec
                                                                                            
                                                                                            	Match Precedence array
                                                                                            	**type**\:  :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                            
                                                                                            .. attribute:: discard_class
                                                                                            
                                                                                            	Match Discard Class array
                                                                                            	**type**\:  :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                            
                                                                                            .. attribute:: qos_group
                                                                                            
                                                                                            	Match QoS group array
                                                                                            	**type**\:  :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                            
                                                                                            .. attribute:: traffic_class
                                                                                            
                                                                                            	Match Traffic class array
                                                                                            	**type**\:  :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                            
                                                                                            .. attribute:: proto
                                                                                            
                                                                                            	Match Protocol array
                                                                                            	**type**\:  :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                            
                                                                                            .. attribute:: icmp_v4
                                                                                            
                                                                                            	Match ICMPV4 Protocol
                                                                                            	**type**\:  :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                            
                                                                                            .. attribute:: icmp_v6
                                                                                            
                                                                                            	Match ICMPV6 Protocol array
                                                                                            	**type**\:  :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                            
                                                                                            .. attribute:: ipv4_packet_len
                                                                                            
                                                                                            	IPv4 packet length array
                                                                                            	**type**\:  :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv6_packet_len
                                                                                            
                                                                                            	IPv6 packet length array
                                                                                            	**type**\:  :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                            
                                                                                            .. attribute:: packet_len
                                                                                            
                                                                                            	Match packet length array
                                                                                            	**type**\:  :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                            
                                                                                            .. attribute:: flow_tag
                                                                                            
                                                                                            	Match flow\-tag array
                                                                                            	**type**\:  :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                            
                                                                                            .. attribute:: tcp_flag
                                                                                            
                                                                                            	Match tcp flag value
                                                                                            	**type**\:  :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                            
                                                                                            .. attribute:: icmpv4_type
                                                                                            
                                                                                            	Match ipv4 icmp type
                                                                                            	**type**\:  :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                            
                                                                                            .. attribute:: icmpv4_code
                                                                                            
                                                                                            	Match ipv4 icmp code
                                                                                            	**type**\:  :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                            
                                                                                            .. attribute:: icmpv6_type
                                                                                            
                                                                                            	Match ipv6 icmp type
                                                                                            	**type**\:  :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                            
                                                                                            .. attribute:: icmpv6_code
                                                                                            
                                                                                            	Match ipv6 icmp code
                                                                                            	**type**\:  :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                            
                                                                                            .. attribute:: mpls_exp
                                                                                            
                                                                                            	Match MPLS experimental topmost array
                                                                                            	**type**\:  :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                            
                                                                                            .. attribute:: mpls_exp_imp
                                                                                            
                                                                                            	Match MPLS experimental imposition array
                                                                                            	**type**\:  :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                                            
                                                                                            	MPLS Disposition IPv4 Access\-list
                                                                                            	**type**\:  :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                                            
                                                                                            	MPLS Disposition IPv6 Access\-list
                                                                                            	**type**\:  :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_top_label
                                                                                            
                                                                                            	MPLS Topmost LABEL
                                                                                            	**type**\:  :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                            
                                                                                            .. attribute:: cos
                                                                                            
                                                                                            	Match CoS array
                                                                                            	**type**\:  :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                            
                                                                                            .. attribute:: cos_inr
                                                                                            
                                                                                            	Match inner header CoS
                                                                                            	**type**\:  :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                            
                                                                                            .. attribute:: dei
                                                                                            
                                                                                            	Match DEI Bit
                                                                                            	**type**\:  :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                            
                                                                                            .. attribute:: dei_inr
                                                                                            
                                                                                            	Match inner DEI Bit
                                                                                            	**type**\:  :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                            
                                                                                            .. attribute:: vlan
                                                                                            
                                                                                            	Match VLAN array
                                                                                            	**type**\:  :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                            
                                                                                            .. attribute:: vlan_inr
                                                                                            
                                                                                            	Match inner header VLAN range array
                                                                                            	**type**\:  :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                            
                                                                                            .. attribute:: fr_dlci
                                                                                            
                                                                                            	Match FR DLCI range array
                                                                                            	**type**\:  :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                            
                                                                                            .. attribute:: src_mac
                                                                                            
                                                                                            	Match Source MAC address
                                                                                            	**type**\:  :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                            
                                                                                            .. attribute:: dst_mac
                                                                                            
                                                                                            	Match Destination MAC address
                                                                                            	**type**\:  :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                            
                                                                                            .. attribute:: atm_clp
                                                                                            
                                                                                            	Match ATM CLP level
                                                                                            	**type**\:  :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                            
                                                                                            .. attribute:: fr_de
                                                                                            
                                                                                            	Match FR DE value
                                                                                            	**type**\:  :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                            
                                                                                            .. attribute:: ipv4_acl
                                                                                            
                                                                                            	IPv4 Access\-list
                                                                                            	**type**\:  :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                            
                                                                                            .. attribute:: ipv6_acl
                                                                                            
                                                                                            	IPv6 Access\-list
                                                                                            	**type**\:  :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                            
                                                                                            .. attribute:: ether_service_acl
                                                                                            
                                                                                            	Ethernet\-Services Access\-list
                                                                                            	**type**\:  :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                            
                                                                                            .. attribute:: avail_id
                                                                                            
                                                                                            	Available Identifiers
                                                                                            	**type**\:  :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                            
                                                                                            .. attribute:: media_type
                                                                                            
                                                                                            	Media Type
                                                                                            	**type**\:  :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                            
                                                                                            .. attribute:: subs_protocol
                                                                                            
                                                                                            	Protocol
                                                                                            	**type**\:  :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                            
                                                                                            .. attribute:: dnis
                                                                                            
                                                                                            	DNIS
                                                                                            	**type**\:  :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                            
                                                                                            .. attribute:: dnis_regex
                                                                                            
                                                                                            	DNIS Regular Expression
                                                                                            	**type**\:  :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                            
                                                                                            .. attribute:: domain
                                                                                            
                                                                                            	Domain Name
                                                                                            	**type**\:  :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                            
                                                                                            .. attribute:: domain_regex
                                                                                            
                                                                                            	Domain Regular Expression
                                                                                            	**type**\:  :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                            
                                                                                            .. attribute:: nas_port
                                                                                            
                                                                                            	NAS Port
                                                                                            	**type**\:  :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                            
                                                                                            .. attribute:: service_name
                                                                                            
                                                                                            	Service Name
                                                                                            	**type**\:  :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                            
                                                                                            .. attribute:: service_name_regex
                                                                                            
                                                                                            	Service Name Regular Exp
                                                                                            	**type**\:  :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv4
                                                                                            
                                                                                            	Source Address IPV4
                                                                                            	**type**\:  :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv4
                                                                                            
                                                                                            	Destination Address IPV4
                                                                                            	**type**\:  :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv6
                                                                                            
                                                                                            	Source Address IPV6
                                                                                            	**type**\:  :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv6
                                                                                            
                                                                                            	Destination Address IPV6
                                                                                            	**type**\:  :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: src_addr_mac
                                                                                            
                                                                                            	Source Address MAC
                                                                                            	**type**\:  :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                            
                                                                                            .. attribute:: timer
                                                                                            
                                                                                            	Timer
                                                                                            	**type**\:  :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                            
                                                                                            .. attribute:: timer_regexp
                                                                                            
                                                                                            	Timer Regular Expression
                                                                                            	**type**\:  :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                            
                                                                                            .. attribute:: tunnel_name
                                                                                            
                                                                                            	Tunnel Name
                                                                                            	**type**\:  :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                            
                                                                                            .. attribute:: tunnel_name_regex
                                                                                            
                                                                                            	Tunnel Name Regular Expression
                                                                                            	**type**\:  :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                            
                                                                                            .. attribute:: user_name
                                                                                            
                                                                                            	User Name
                                                                                            	**type**\:  :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                            
                                                                                            .. attribute:: user_name_regex
                                                                                            
                                                                                            	User Name Regular Expression
                                                                                            	**type**\:  :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                            
                                                                                            .. attribute:: auth_username
                                                                                            
                                                                                            	Authenticated User Name
                                                                                            	**type**\:  :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                            
                                                                                            .. attribute:: auth_username_regex
                                                                                            
                                                                                            	Authenticated User Name RegEx
                                                                                            	**type**\:  :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_username
                                                                                            
                                                                                            	Unauthenticated User Name
                                                                                            	**type**\:  :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                            
                                                                                            .. attribute:: unauth_username_regex
                                                                                            
                                                                                            	Unauthenticated User Name RegEx
                                                                                            	**type**\:  :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: auth_domain
                                                                                            
                                                                                            	Authenticated domain name
                                                                                            	**type**\:  :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                            
                                                                                            .. attribute:: auth_domain_regex
                                                                                            
                                                                                            	Authenticated Domain Name RegEx
                                                                                            	**type**\:  :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_domain
                                                                                            
                                                                                            	Unauthenticated Domain Name
                                                                                            	**type**\:  :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                            
                                                                                            .. attribute:: unauth_domain_regex
                                                                                            
                                                                                            	Unauthenticated Domain Name RegEx
                                                                                            	**type**\:  :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: vendor_id
                                                                                            
                                                                                            	Vendor ID
                                                                                            	**type**\:  :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                            
                                                                                            .. attribute:: vendor_id_regex
                                                                                            
                                                                                            	Vendor ID RegEx
                                                                                            	**type**\:  :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                            
                                                                                            .. attribute:: access_interface
                                                                                            
                                                                                            	Access interface
                                                                                            	**type**\:  :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                            
                                                                                            .. attribute:: input_interface
                                                                                            
                                                                                            	Input interface
                                                                                            	**type**\:  :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                            
                                                                                            .. attribute:: input_intfhdl
                                                                                            
                                                                                            	Input interface handle
                                                                                            	**type**\:  :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                            
                                                                                            .. attribute:: ethertype
                                                                                            
                                                                                            	Ethernet type
                                                                                            	**type**\:  :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                            
                                                                                            .. attribute:: flow_key_data
                                                                                            
                                                                                            	Flow key structure
                                                                                            	**type**\:  :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id
                                                                                            
                                                                                            	Dhcp Client ID
                                                                                            	**type**\:  :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id_regex
                                                                                            
                                                                                            	Dhcp Client ID RegEx
                                                                                            	**type**\:  :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                            
                                                                                            .. attribute:: circuit_id
                                                                                            
                                                                                            	Circuit ID
                                                                                            	**type**\:  :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                            
                                                                                            .. attribute:: circuit_id_regex
                                                                                            
                                                                                            	Circuit ID RegEx
                                                                                            	**type**\:  :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                            
                                                                                            .. attribute:: remote_id
                                                                                            
                                                                                            	Remote ID
                                                                                            	**type**\:  :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                            
                                                                                            .. attribute:: remote_id_regex
                                                                                            
                                                                                            	Remote ID RegEx
                                                                                            	**type**\:  :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                            
                                                                                            .. attribute:: src_port
                                                                                            
                                                                                            	Source port
                                                                                            	**type**\:  :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                            
                                                                                            .. attribute:: dst_port
                                                                                            
                                                                                            	Destination port
                                                                                            	**type**\:  :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	type
                                                                                            	**type**\:  :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                            
                                                                                            .. attribute:: mpls_top_eos
                                                                                            
                                                                                            	MPLS Topmost EOS
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: fragment_type
                                                                                            
                                                                                            	Fragment type
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: authen_status
                                                                                            
                                                                                            	Authentication Status
                                                                                            	**type**\:  :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                            
                                                                                            .. attribute:: mlp_negotiated
                                                                                            
                                                                                            	MLP Negotiated
                                                                                            	**type**\:  :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                                self.yang_name = "match-data"
                                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("ipv4-dscp", ("ipv4_dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp)), ("ipv6-dscp", ("ipv6_dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp)), ("dscp", ("dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp)), ("ipv4-prec", ("ipv4_prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec)), ("ipv6-prec", ("ipv6_prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec)), ("prec", ("prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec)), ("discard-class", ("discard_class", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass)), ("qos-group", ("qos_group", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup)), ("traffic-class", ("traffic_class", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass)), ("proto", ("proto", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto)), ("icmp-v4", ("icmp_v4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4)), ("icmp-v6", ("icmp_v6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6)), ("ipv4-packet-len", ("ipv4_packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen)), ("ipv6-packet-len", ("ipv6_packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen)), ("packet-len", ("packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen)), ("flow-tag", ("flow_tag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag)), ("tcp-flag", ("tcp_flag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag)), ("icmpv4-type", ("icmpv4_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type)), ("icmpv4-code", ("icmpv4_code", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code)), ("icmpv6-type", ("icmpv6_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type)), ("icmpv6-code", ("icmpv6_code", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code)), ("mpls-exp", ("mpls_exp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp)), ("mpls-exp-imp", ("mpls_exp_imp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp)), ("mpls-disp-ipv4-acl", ("mpls_disp_ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl)), ("mpls-disp-ipv6-acl", ("mpls_disp_ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl)), ("mpls-top-label", ("mpls_top_label", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel)), ("cos", ("cos", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos)), ("cos-inr", ("cos_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr)), ("dei", ("dei", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei)), ("dei-inr", ("dei_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr)), ("vlan", ("vlan", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan)), ("vlan-inr", ("vlan_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)), ("fr-dlci", ("fr_dlci", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci)), ("src-mac", ("src_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac)), ("dst-mac", ("dst_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac)), ("atm-clp", ("atm_clp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp)), ("fr-de", ("fr_de", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe)), ("ipv4-acl", ("ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl)), ("ipv6-acl", ("ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl)), ("ether-service-acl", ("ether_service_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl)), ("avail-id", ("avail_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId)), ("media-type", ("media_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType)), ("subs-protocol", ("subs_protocol", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol)), ("dnis", ("dnis", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis)), ("dnis-regex", ("dnis_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex)), ("domain", ("domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain)), ("domain-regex", ("domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex)), ("nas-port", ("nas_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort)), ("service-name", ("service_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName)), ("service-name-regex", ("service_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex)), ("src-addr-ipv4", ("src_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4)), ("dst-addr-ipv4", ("dst_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4)), ("src-addr-ipv6", ("src_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6)), ("dst-addr-ipv6", ("dst_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6)), ("src-addr-mac", ("src_addr_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac)), ("timer", ("timer", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer)), ("timer-regexp", ("timer_regexp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp)), ("tunnel-name", ("tunnel_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName)), ("tunnel-name-regex", ("tunnel_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex)), ("user-name", ("user_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName)), ("user-name-regex", ("user_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex)), ("auth-username", ("auth_username", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername)), ("auth-username-regex", ("auth_username_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex)), ("unauth-username", ("unauth_username", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername)), ("unauth-username-regex", ("unauth_username_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex)), ("auth-domain", ("auth_domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain)), ("auth-domain-regex", ("auth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex)), ("unauth-domain", ("unauth_domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain)), ("unauth-domain-regex", ("unauth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex)), ("vendor-id", ("vendor_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId)), ("vendor-id-regex", ("vendor_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex)), ("access-interface", ("access_interface", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface)), ("input-interface", ("input_interface", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface)), ("input-intfhdl", ("input_intfhdl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl)), ("ethertype", ("ethertype", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype)), ("flow-key-data", ("flow_key_data", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData)), ("dhcp-client-id", ("dhcp_client_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId)), ("dhcp-client-id-regex", ("dhcp_client_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex)), ("circuit-id", ("circuit_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId)), ("circuit-id-regex", ("circuit_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex)), ("remote-id", ("remote_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId)), ("remote-id-regex", ("remote_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex)), ("src-port", ("src_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort)), ("dst-port", ("dst_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort))])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchTypeEn', '')])),
                                                                                                    ('mpls_top_eos', (YLeaf(YType.uint8, 'mpls-top-eos'), ['int'])),
                                                                                                    ('fragment_type', (YLeaf(YType.uint8, 'fragment-type'), ['int'])),
                                                                                                    ('authen_status', (YLeaf(YType.enumeration, 'authen-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchAuthenStatusEn', '')])),
                                                                                                    ('mlp_negotiated', (YLeaf(YType.enumeration, 'mlp-negotiated'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchMlpNegotiatedEn', '')])),
                                                                                                ])
                                                                                                self.type = None
                                                                                                self.mpls_top_eos = None
                                                                                                self.fragment_type = None
                                                                                                self.authen_status = None
                                                                                                self.mlp_negotiated = None

                                                                                                self.ipv4_dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                                self.ipv4_dscp.parent = self
                                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"

                                                                                                self.ipv6_dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                                self.ipv6_dscp.parent = self
                                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"

                                                                                                self.dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                                self.dscp.parent = self
                                                                                                self._children_name_map["dscp"] = "dscp"

                                                                                                self.ipv4_prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                                self.ipv4_prec.parent = self
                                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"

                                                                                                self.ipv6_prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                                self.ipv6_prec.parent = self
                                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"

                                                                                                self.prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                                self.prec.parent = self
                                                                                                self._children_name_map["prec"] = "prec"

                                                                                                self.discard_class = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                                self.discard_class.parent = self
                                                                                                self._children_name_map["discard_class"] = "discard-class"

                                                                                                self.qos_group = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                                self.qos_group.parent = self
                                                                                                self._children_name_map["qos_group"] = "qos-group"

                                                                                                self.traffic_class = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                                self.traffic_class.parent = self
                                                                                                self._children_name_map["traffic_class"] = "traffic-class"

                                                                                                self.proto = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                                self.proto.parent = self
                                                                                                self._children_name_map["proto"] = "proto"

                                                                                                self.icmp_v4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                                self.icmp_v4.parent = self
                                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"

                                                                                                self.icmp_v6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                                self.icmp_v6.parent = self
                                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"

                                                                                                self.ipv4_packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                                self.ipv4_packet_len.parent = self
                                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"

                                                                                                self.ipv6_packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                                self.ipv6_packet_len.parent = self
                                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"

                                                                                                self.packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                                self.packet_len.parent = self
                                                                                                self._children_name_map["packet_len"] = "packet-len"

                                                                                                self.flow_tag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                                self.flow_tag.parent = self
                                                                                                self._children_name_map["flow_tag"] = "flow-tag"

                                                                                                self.tcp_flag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                                self.tcp_flag.parent = self
                                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"

                                                                                                self.icmpv4_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                                self.icmpv4_type.parent = self
                                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"

                                                                                                self.icmpv4_code = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                                self.icmpv4_code.parent = self
                                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"

                                                                                                self.icmpv6_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                                self.icmpv6_type.parent = self
                                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"

                                                                                                self.icmpv6_code = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                                self.icmpv6_code.parent = self
                                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"

                                                                                                self.mpls_exp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                                self.mpls_exp.parent = self
                                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"

                                                                                                self.mpls_exp_imp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                                self.mpls_exp_imp.parent = self
                                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"

                                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"

                                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"

                                                                                                self.mpls_top_label = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                                self.mpls_top_label.parent = self
                                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"

                                                                                                self.cos = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                                self.cos.parent = self
                                                                                                self._children_name_map["cos"] = "cos"

                                                                                                self.cos_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                                self.cos_inr.parent = self
                                                                                                self._children_name_map["cos_inr"] = "cos-inr"

                                                                                                self.dei = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                                self.dei.parent = self
                                                                                                self._children_name_map["dei"] = "dei"

                                                                                                self.dei_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                                self.dei_inr.parent = self
                                                                                                self._children_name_map["dei_inr"] = "dei-inr"

                                                                                                self.vlan = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                                self.vlan.parent = self
                                                                                                self._children_name_map["vlan"] = "vlan"

                                                                                                self.vlan_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                                self.vlan_inr.parent = self
                                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"

                                                                                                self.fr_dlci = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                                self.fr_dlci.parent = self
                                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"

                                                                                                self.src_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                                self.src_mac.parent = self
                                                                                                self._children_name_map["src_mac"] = "src-mac"

                                                                                                self.dst_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                                self.dst_mac.parent = self
                                                                                                self._children_name_map["dst_mac"] = "dst-mac"

                                                                                                self.atm_clp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                                self.atm_clp.parent = self
                                                                                                self._children_name_map["atm_clp"] = "atm-clp"

                                                                                                self.fr_de = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                                self.fr_de.parent = self
                                                                                                self._children_name_map["fr_de"] = "fr-de"

                                                                                                self.ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                                self.ipv4_acl.parent = self
                                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"

                                                                                                self.ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                                self.ipv6_acl.parent = self
                                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"

                                                                                                self.ether_service_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                                self.ether_service_acl.parent = self
                                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"

                                                                                                self.avail_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                                self.avail_id.parent = self
                                                                                                self._children_name_map["avail_id"] = "avail-id"

                                                                                                self.media_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                                self.media_type.parent = self
                                                                                                self._children_name_map["media_type"] = "media-type"

                                                                                                self.subs_protocol = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                                self.subs_protocol.parent = self
                                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"

                                                                                                self.dnis = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                                self.dnis.parent = self
                                                                                                self._children_name_map["dnis"] = "dnis"

                                                                                                self.dnis_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                                self.dnis_regex.parent = self
                                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"

                                                                                                self.domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                                self.domain.parent = self
                                                                                                self._children_name_map["domain"] = "domain"

                                                                                                self.domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                                self.domain_regex.parent = self
                                                                                                self._children_name_map["domain_regex"] = "domain-regex"

                                                                                                self.nas_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                                self.nas_port.parent = self
                                                                                                self._children_name_map["nas_port"] = "nas-port"

                                                                                                self.service_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                                self.service_name.parent = self
                                                                                                self._children_name_map["service_name"] = "service-name"

                                                                                                self.service_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                                self.service_name_regex.parent = self
                                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"

                                                                                                self.src_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                                self.src_addr_ipv4.parent = self
                                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"

                                                                                                self.dst_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                                self.dst_addr_ipv4.parent = self
                                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"

                                                                                                self.src_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                                self.src_addr_ipv6.parent = self
                                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"

                                                                                                self.dst_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                                self.dst_addr_ipv6.parent = self
                                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"

                                                                                                self.src_addr_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                                self.src_addr_mac.parent = self
                                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"

                                                                                                self.timer = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                                self.timer.parent = self
                                                                                                self._children_name_map["timer"] = "timer"

                                                                                                self.timer_regexp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                                self.timer_regexp.parent = self
                                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"

                                                                                                self.tunnel_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                                self.tunnel_name.parent = self
                                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"

                                                                                                self.tunnel_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                                self.tunnel_name_regex.parent = self
                                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"

                                                                                                self.user_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                                self.user_name.parent = self
                                                                                                self._children_name_map["user_name"] = "user-name"

                                                                                                self.user_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                                self.user_name_regex.parent = self
                                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"

                                                                                                self.auth_username = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                                self.auth_username.parent = self
                                                                                                self._children_name_map["auth_username"] = "auth-username"

                                                                                                self.auth_username_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                                self.auth_username_regex.parent = self
                                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"

                                                                                                self.unauth_username = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                                self.unauth_username.parent = self
                                                                                                self._children_name_map["unauth_username"] = "unauth-username"

                                                                                                self.unauth_username_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                                self.unauth_username_regex.parent = self
                                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"

                                                                                                self.auth_domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                                self.auth_domain.parent = self
                                                                                                self._children_name_map["auth_domain"] = "auth-domain"

                                                                                                self.auth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                                self.auth_domain_regex.parent = self
                                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"

                                                                                                self.unauth_domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                                self.unauth_domain.parent = self
                                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"

                                                                                                self.unauth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                                self.unauth_domain_regex.parent = self
                                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"

                                                                                                self.vendor_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                                self.vendor_id.parent = self
                                                                                                self._children_name_map["vendor_id"] = "vendor-id"

                                                                                                self.vendor_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                                self.vendor_id_regex.parent = self
                                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"

                                                                                                self.access_interface = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                                self.access_interface.parent = self
                                                                                                self._children_name_map["access_interface"] = "access-interface"

                                                                                                self.input_interface = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                                self.input_interface.parent = self
                                                                                                self._children_name_map["input_interface"] = "input-interface"

                                                                                                self.input_intfhdl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                                self.input_intfhdl.parent = self
                                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"

                                                                                                self.ethertype = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                                self.ethertype.parent = self
                                                                                                self._children_name_map["ethertype"] = "ethertype"

                                                                                                self.flow_key_data = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                                self.flow_key_data.parent = self
                                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"

                                                                                                self.dhcp_client_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                                self.dhcp_client_id.parent = self
                                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"

                                                                                                self.dhcp_client_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                                self.dhcp_client_id_regex.parent = self
                                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"

                                                                                                self.circuit_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                                self.circuit_id.parent = self
                                                                                                self._children_name_map["circuit_id"] = "circuit-id"

                                                                                                self.circuit_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                                self.circuit_id_regex.parent = self
                                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"

                                                                                                self.remote_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                                self.remote_id.parent = self
                                                                                                self._children_name_map["remote_id"] = "remote-id"

                                                                                                self.remote_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                                self.remote_id_regex.parent = self
                                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"

                                                                                                self.src_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                                self.src_port.parent = self
                                                                                                self._children_name_map["src_port"] = "src-port"

                                                                                                self.dst_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                                self.dst_port.parent = self
                                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                                self._segment_path = lambda: "match-data"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, ['type', 'mpls_top_eos', 'fragment_type', 'authen_status', 'mlp_negotiated'], name, value)


                                                                                            class Ipv4Dscp(Entity):
                                                                                                """
                                                                                                IPv4 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv4-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv6Dscp(Entity):
                                                                                                """
                                                                                                IPv6 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv6-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Dscp(Entity):
                                                                                                """
                                                                                                Match DSCP range array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                    self.yang_name = "dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv4Prec(Entity):
                                                                                                """
                                                                                                IPv4 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                    self.yang_name = "ipv4-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "ipv4-prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                            class Ipv6Prec(Entity):
                                                                                                """
                                                                                                IPv6 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                    self.yang_name = "ipv6-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "ipv6-prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                            class Prec(Entity):
                                                                                                """
                                                                                                Match Precedence array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                    self.yang_name = "prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                            class DiscardClass(Entity):
                                                                                                """
                                                                                                Match Discard Class array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                    self.yang_name = "discard-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "discard-class"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                            class QosGroup(Entity):
                                                                                                """
                                                                                                Match QoS group array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                    self.yang_name = "qos-group"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "qos-group"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "qos-group"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class TrafficClass(Entity):
                                                                                                """
                                                                                                Match Traffic class array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                    self.yang_name = "traffic-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "traffic-class"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "traffic-class"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Proto(Entity):
                                                                                                """
                                                                                                Match Protocol array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                    self.yang_name = "proto"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "proto"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "proto"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class IcmpV4(Entity):
                                                                                                """
                                                                                                Match ICMPV4 Protocol
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                    self.yang_name = "icmp-v4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                    ])
                                                                                                    self.type = None
                                                                                                    self.code = None
                                                                                                    self._segment_path = lambda: "icmp-v4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['type', 'code'], name, value)


                                                                                            class IcmpV6(Entity):
                                                                                                """
                                                                                                Match ICMPV6 Protocol array
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                    self.yang_name = "icmp-v6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                    ])
                                                                                                    self.type = None
                                                                                                    self.code = None
                                                                                                    self._segment_path = lambda: "icmp-v6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['type', 'code'], name, value)


                                                                                            class Ipv4PacketLen(Entity):
                                                                                                """
                                                                                                IPv4 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv6PacketLen(Entity):
                                                                                                """
                                                                                                IPv6 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class PacketLen(Entity):
                                                                                                """
                                                                                                Match packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                    self.yang_name = "packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FlowTag(Entity):
                                                                                                """
                                                                                                Match flow\-tag array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                    self.yang_name = "flow-tag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "flow-tag"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "flow-tag"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class TcpFlag(Entity):
                                                                                                """
                                                                                                Match tcp flag value
                                                                                                
                                                                                                .. attribute:: value
                                                                                                
                                                                                                	Value of TCP flag
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: match_any
                                                                                                
                                                                                                	Match any TCP flag bit
                                                                                                	**type**\: bool
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                    self.yang_name = "tcp-flag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                                        ('match_any', (YLeaf(YType.boolean, 'match-any'), ['bool'])),
                                                                                                    ])
                                                                                                    self.value = None
                                                                                                    self.match_any = None
                                                                                                    self._segment_path = lambda: "tcp-flag"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['value', 'match_any'], name, value)


                                                                                            class Icmpv4Type(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                    self.yang_name = "icmpv4-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv4Code(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                    self.yang_name = "icmpv4-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-code"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv6Type(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                    self.yang_name = "icmpv6-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv6Code(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                    self.yang_name = "icmpv6-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-code"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class MplsExp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental topmost array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "mpls-exp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                            class MplsExpImp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental imposition array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "mpls-exp-imp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                            class MplsDispIpv4Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                            class MplsDispIpv6Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                            class MplsTopLabel(Entity):
                                                                                                """
                                                                                                MPLS Topmost LABEL
                                                                                                
                                                                                                .. attribute:: uint32_rng_array
                                                                                                
                                                                                                	uint32 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                    self.yang_name = "mpls-top-label"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint32_rng_array", ("uint32_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint32_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "mpls-top-label"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                                class Uint32RngArray(Entity):
                                                                                                    """
                                                                                                    uint32 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                        self.yang_name = "uint32_rng_array"
                                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint32, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint32, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint32_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['min', 'max'], name, value)


                                                                                            class Cos(Entity):
                                                                                                """
                                                                                                Match CoS array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                    self.yang_name = "cos"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "cos"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                            class CosInr(Entity):
                                                                                                """
                                                                                                Match inner header CoS
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                    self.yang_name = "cos-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "cos-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                            class Dei(Entity):
                                                                                                """
                                                                                                Match DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                    self.yang_name = "dei"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                    ])
                                                                                                    self.bit_value = None
                                                                                                    self._segment_path = lambda: "dei"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                            class DeiInr(Entity):
                                                                                                """
                                                                                                Match inner DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                    self.yang_name = "dei-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                    ])
                                                                                                    self.bit_value = None
                                                                                                    self._segment_path = lambda: "dei-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                            class Vlan(Entity):
                                                                                                """
                                                                                                Match VLAN array
                                                                                                
                                                                                                .. attribute:: vlan_id_array
                                                                                                
                                                                                                	vlan id array
                                                                                                	**type**\: list of  		 :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                    self.yang_name = "vlan"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("vlan-id-array", ("vlan_id_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.vlan_id_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                                class VlanIdArray(Entity):
                                                                                                    """
                                                                                                    vlan id array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	VLAN mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                        self.yang_name = "vlan-id-array"
                                                                                                        self.yang_parent_name = "vlan"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ('mask', (YLeaf(YType.uint16, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "vlan-id-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['min', 'max', 'mask'], name, value)


                                                                                            class VlanInr(Entity):
                                                                                                """
                                                                                                Match inner header VLAN range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                    self.yang_name = "vlan-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FrDlci(Entity):
                                                                                                """
                                                                                                Match FR DLCI range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                    self.yang_name = "fr-dlci"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "fr-dlci"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class SrcMac(Entity):
                                                                                                """
                                                                                                Match Source MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                    self.yang_name = "src-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.mac_addr = []
                                                                                                    self.mask = []
                                                                                                    self._segment_path = lambda: "src-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                            class DstMac(Entity):
                                                                                                """
                                                                                                Match Destination MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                    self.yang_name = "dst-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.mac_addr = []
                                                                                                    self.mask = []
                                                                                                    self._segment_path = lambda: "dst-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                            class AtmClp(Entity):
                                                                                                """
                                                                                                Match ATM CLP level
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                    self.yang_name = "atm-clp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "atm-clp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                            class FrDe(Entity):
                                                                                                """
                                                                                                Match FR DE value
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                    self.yang_name = "fr-de"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "fr-de"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                            class Ipv4Acl(Entity):
                                                                                                """
                                                                                                IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                    self.yang_name = "ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ipv4-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                            class Ipv6Acl(Entity):
                                                                                                """
                                                                                                IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                    self.yang_name = "ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ipv6-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                            class EtherServiceAcl(Entity):
                                                                                                """
                                                                                                Ethernet\-Services Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                    self.yang_name = "ether-service-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ether-service-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                            class AvailId(Entity):
                                                                                                """
                                                                                                Available Identifiers
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                    self.yang_name = "avail-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "avail-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                            class MediaType(Entity):
                                                                                                """
                                                                                                Media Type
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                    self.yang_name = "media-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "media-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                            class SubsProtocol(Entity):
                                                                                                """
                                                                                                Protocol
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                    self.yang_name = "subs-protocol"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "subs-protocol"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                            class Dnis(Entity):
                                                                                                """
                                                                                                DNIS
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                    self.yang_name = "dnis"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dnis"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                            class DnisRegex(Entity):
                                                                                                """
                                                                                                DNIS Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                    self.yang_name = "dnis-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dnis-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                            class Domain(Entity):
                                                                                                """
                                                                                                Domain Name
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                    self.yang_name = "domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                        ])
                                                                                                        self.domain_name = None
                                                                                                        self.format_name = None
                                                                                                        self._segment_path = lambda: "domain-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class DomainRegex(Entity):
                                                                                                """
                                                                                                Domain Regular Expression
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                    self.yang_name = "domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain-regex"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                        ])
                                                                                                        self.domain_name = None
                                                                                                        self.format_name = None
                                                                                                        self._segment_path = lambda: "domain-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class NasPort(Entity):
                                                                                                """
                                                                                                NAS Port
                                                                                                
                                                                                                .. attribute:: nas_port_array
                                                                                                
                                                                                                	nas port array
                                                                                                	**type**\: list of  		 :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                    self.yang_name = "nas-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("nas-port-array", ("nas_port_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.nas_port_array = YList(self)
                                                                                                    self._segment_path = lambda: "nas-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                                class NasPortArray(Entity):
                                                                                                    """
                                                                                                    nas port array
                                                                                                    
                                                                                                    .. attribute:: sub_id
                                                                                                    
                                                                                                    	sub id
                                                                                                    	**type**\:  :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                    
                                                                                                    .. attribute:: operator
                                                                                                    
                                                                                                    	operator
                                                                                                    	**type**\:  :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	value
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                        self.yang_name = "nas-port-array"
                                                                                                        self.yang_parent_name = "nas-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('sub_id', (YLeaf(YType.enumeration, 'sub-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchNasPortSubIdEn', '')])),
                                                                                                            ('operator', (YLeaf(YType.enumeration, 'operator'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchLogicalOperatorEn', '')])),
                                                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                                        ])
                                                                                                        self.sub_id = None
                                                                                                        self.operator = None
                                                                                                        self.value = None
                                                                                                        self._segment_path = lambda: "nas-port-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['sub_id', 'operator', 'value'], name, value)


                                                                                            class ServiceName(Entity):
                                                                                                """
                                                                                                Service Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                    self.yang_name = "service-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "service-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                            class ServiceNameRegex(Entity):
                                                                                                """
                                                                                                Service Name Regular Exp
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                    self.yang_name = "service-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "service-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                            class SrcAddrIpv4(Entity):
                                                                                                """
                                                                                                Source Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class DstAddrIpv4(Entity):
                                                                                                """
                                                                                                Destination Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class SrcAddrIpv6(Entity):
                                                                                                """
                                                                                                Source Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class DstAddrIpv6(Entity):
                                                                                                """
                                                                                                Destination Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class SrcAddrMac(Entity):
                                                                                                """
                                                                                                Source Address MAC
                                                                                                
                                                                                                .. attribute:: mac_addr_array
                                                                                                
                                                                                                	mac addr array
                                                                                                	**type**\: list of  		 :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                    self.yang_name = "src-addr-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("mac-addr-array", ("mac_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.mac_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                                class MacAddrArray(Entity):
                                                                                                    """
                                                                                                    mac addr array
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                        self.yang_name = "mac-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                            ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.mac_addr = []
                                                                                                        self.mask = []
                                                                                                        self._segment_path = lambda: "mac-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                            class Timer(Entity):
                                                                                                """
                                                                                                Timer
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                    self.yang_name = "timer"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "timer"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                            class TimerRegexp(Entity):
                                                                                                """
                                                                                                Timer Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                    self.yang_name = "timer-regexp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "timer-regexp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                            class TunnelName(Entity):
                                                                                                """
                                                                                                Tunnel Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                    self.yang_name = "tunnel-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "tunnel-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                            class TunnelNameRegex(Entity):
                                                                                                """
                                                                                                Tunnel Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "tunnel-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                            class UserName(Entity):
                                                                                                """
                                                                                                User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                    self.yang_name = "user-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "user-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                            class UserNameRegex(Entity):
                                                                                                """
                                                                                                User Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                    self.yang_name = "user-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "user-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                            class AuthUsername(Entity):
                                                                                                """
                                                                                                Authenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                    self.yang_name = "auth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-username"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                            class AuthUsernameRegex(Entity):
                                                                                                """
                                                                                                Authenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "auth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-username-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                            class UnauthUsername(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                    self.yang_name = "unauth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-username"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                            class UnauthUsernameRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-username-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                            class AuthDomain(Entity):
                                                                                                """
                                                                                                Authenticated domain name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                    self.yang_name = "auth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                            class AuthDomainRegex(Entity):
                                                                                                """
                                                                                                Authenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "auth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                            class UnauthDomain(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                    self.yang_name = "unauth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                            class UnauthDomainRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                            class VendorId(Entity):
                                                                                                """
                                                                                                Vendor ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                    self.yang_name = "vendor-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "vendor-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                            class VendorIdRegex(Entity):
                                                                                                """
                                                                                                Vendor ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                    self.yang_name = "vendor-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "vendor-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                            class AccessInterface(Entity):
                                                                                                """
                                                                                                Access interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                    self.yang_name = "access-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "access-interface"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                            class InputInterface(Entity):
                                                                                                """
                                                                                                Input interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                    self.yang_name = "input-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "input-interface"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                            class InputIntfhdl(Entity):
                                                                                                """
                                                                                                Input interface handle
                                                                                                
                                                                                                .. attribute:: uint64_array
                                                                                                
                                                                                                	uint64 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..18446744073709551615
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                    self.yang_name = "input-intfhdl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint64_array', (YLeafList(YType.uint64, 'uint64_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint64_array = []
                                                                                                    self._segment_path = lambda: "input-intfhdl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                            class Ethertype(Entity):
                                                                                                """
                                                                                                Ethernet type
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                    self.yang_name = "ethertype"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ethertype"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ethertype"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FlowKeyData(Entity):
                                                                                                """
                                                                                                Flow key structure
                                                                                                
                                                                                                .. attribute:: flow_keys
                                                                                                
                                                                                                	flow keys
                                                                                                	**type**\:  :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                                
                                                                                                .. attribute:: max_count
                                                                                                
                                                                                                	Maximum count of flows
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: idle_timeout
                                                                                                
                                                                                                	Idle timeout of flows (in seconds)
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                	**units**\: second
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                    self.yang_name = "flow-key-data"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("flow-keys", ("flow_keys", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys))])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('max_count', (YLeaf(YType.uint16, 'max-count'), ['int'])),
                                                                                                        ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                                                    ])
                                                                                                    self.max_count = None
                                                                                                    self.idle_timeout = None

                                                                                                    self.flow_keys = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                    self.flow_keys.parent = self
                                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                    self._segment_path = lambda: "flow-key-data"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['max_count', 'idle_timeout'], name, value)


                                                                                                class FlowKeys(Entity):
                                                                                                    """
                                                                                                    flow keys
                                                                                                    
                                                                                                    .. attribute:: keys
                                                                                                    
                                                                                                    	keys
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                    
                                                                                                    .. attribute:: num
                                                                                                    
                                                                                                    	num
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                        self.yang_name = "flow-keys"
                                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('keys', (YLeaf(YType.str, 'keys'), ['str'])),
                                                                                                            ('num', (YLeaf(YType.uint8, 'num'), ['int'])),
                                                                                                        ])
                                                                                                        self.keys = None
                                                                                                        self.num = None
                                                                                                        self._segment_path = lambda: "flow-keys"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                            class DhcpClientId(Entity):
                                                                                                """
                                                                                                Dhcp Client ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dhcp-client-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                            class DhcpClientIdRegex(Entity):
                                                                                                """
                                                                                                Dhcp Client ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                            class CircuitId(Entity):
                                                                                                """
                                                                                                Circuit ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                    self.yang_name = "circuit-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "circuit-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                            class CircuitIdRegex(Entity):
                                                                                                """
                                                                                                Circuit ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                    self.yang_name = "circuit-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "circuit-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                            class RemoteId(Entity):
                                                                                                """
                                                                                                Remote ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                    self.yang_name = "remote-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "remote-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                            class RemoteIdRegex(Entity):
                                                                                                """
                                                                                                Remote ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                    self.yang_name = "remote-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "remote-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                            class SrcPort(Entity):
                                                                                                """
                                                                                                Source port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                    self.yang_name = "src-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "src-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class DstPort(Entity):
                                                                                                """
                                                                                                Destination port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                    self.yang_name = "dst-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "dst-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                        class ExcdclassP(Entity):
                                                                            """
                                                                            excdclass p
                                                                            
                                                                            .. attribute:: class_map_bg
                                                                            
                                                                            	class map bg
                                                                            	**type**\: list of  		 :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP, self).__init__()

                                                                                self.yang_name = "excdclass-p"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("class-map-bg", ("class_map_bg", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg))])
                                                                                self._leafs = OrderedDict()

                                                                                self.class_map_bg = YList(self)
                                                                                self._segment_path = lambda: "excdclass-p"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP, [], name, value)


                                                                            class ClassMapBg(Entity):
                                                                                """
                                                                                class map bg
                                                                                
                                                                                .. attribute:: match_infop
                                                                                
                                                                                	Pointer to the first Match info
                                                                                	**type**\:  :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop>`
                                                                                
                                                                                .. attribute:: name
                                                                                
                                                                                	Name of the class\-map
                                                                                	**type**\: str
                                                                                
                                                                                	**length:** 0..65
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Class\-Map Type QoS/PBR/Netflow/..
                                                                                	**type**\:  :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                                                
                                                                                .. attribute:: mode
                                                                                
                                                                                	Class\-Map Mode Match any/Match all
                                                                                	**type**\:  :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                                
                                                                                .. attribute:: description
                                                                                
                                                                                	description
                                                                                	**type**\: str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg, self).__init__()

                                                                                    self.yang_name = "class-map-bg"
                                                                                    self.yang_parent_name = "excdclass-p"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("match-infop", ("match_infop", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop))])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapTypeEn', '')])),
                                                                                        ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapModeEn', '')])),
                                                                                        ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                    ])
                                                                                    self.name = None
                                                                                    self.type = None
                                                                                    self.mode = None
                                                                                    self.description = None

                                                                                    self.match_infop = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop()
                                                                                    self.match_infop.parent = self
                                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                                    self._segment_path = lambda: "class-map-bg"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg, ['name', 'type', 'mode', 'description'], name, value)


                                                                                class MatchInfop(Entity):
                                                                                    """
                                                                                    Pointer to the first Match info
                                                                                    
                                                                                    .. attribute:: class_match_info_st
                                                                                    
                                                                                    	class match info st
                                                                                    	**type**\: list of  		 :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop, self).__init__()

                                                                                        self.yang_name = "match-infop"
                                                                                        self.yang_parent_name = "class-map-bg"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("class-match-info-st", ("class_match_info_st", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt))])
                                                                                        self._leafs = OrderedDict()

                                                                                        self.class_match_info_st = YList(self)
                                                                                        self._segment_path = lambda: "match-infop"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop, [], name, value)


                                                                                    class ClassMatchInfoSt(Entity):
                                                                                        """
                                                                                        class match info st
                                                                                        
                                                                                        .. attribute:: match_data
                                                                                        
                                                                                        	Match criteria
                                                                                        	**type**\:  :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                        
                                                                                        .. attribute:: flags
                                                                                        
                                                                                        	Flags
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                            self.yang_name = "class-match-info-st"
                                                                                            self.yang_parent_name = "match-infop"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("match-data", ("match_data", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData))])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                            ])
                                                                                            self.flags = None

                                                                                            self.match_data = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                            self.match_data.parent = self
                                                                                            self._children_name_map["match_data"] = "match-data"
                                                                                            self._segment_path = lambda: "class-match-info-st"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                        class MatchData(Entity):
                                                                                            """
                                                                                            Match criteria
                                                                                            
                                                                                            .. attribute:: ipv4_dscp
                                                                                            
                                                                                            	IPv4 DSCP
                                                                                            	**type**\:  :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv6_dscp
                                                                                            
                                                                                            	IPv6 DSCP
                                                                                            	**type**\:  :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                            
                                                                                            .. attribute:: dscp
                                                                                            
                                                                                            	Match DSCP range array
                                                                                            	**type**\:  :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv4_prec
                                                                                            
                                                                                            	IPv4 Precedence
                                                                                            	**type**\:  :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                            
                                                                                            .. attribute:: ipv6_prec
                                                                                            
                                                                                            	IPv6 Precedence
                                                                                            	**type**\:  :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                            
                                                                                            .. attribute:: prec
                                                                                            
                                                                                            	Match Precedence array
                                                                                            	**type**\:  :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                            
                                                                                            .. attribute:: discard_class
                                                                                            
                                                                                            	Match Discard Class array
                                                                                            	**type**\:  :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                            
                                                                                            .. attribute:: qos_group
                                                                                            
                                                                                            	Match QoS group array
                                                                                            	**type**\:  :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                            
                                                                                            .. attribute:: traffic_class
                                                                                            
                                                                                            	Match Traffic class array
                                                                                            	**type**\:  :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                            
                                                                                            .. attribute:: proto
                                                                                            
                                                                                            	Match Protocol array
                                                                                            	**type**\:  :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                            
                                                                                            .. attribute:: icmp_v4
                                                                                            
                                                                                            	Match ICMPV4 Protocol
                                                                                            	**type**\:  :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                            
                                                                                            .. attribute:: icmp_v6
                                                                                            
                                                                                            	Match ICMPV6 Protocol array
                                                                                            	**type**\:  :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                            
                                                                                            .. attribute:: ipv4_packet_len
                                                                                            
                                                                                            	IPv4 packet length array
                                                                                            	**type**\:  :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv6_packet_len
                                                                                            
                                                                                            	IPv6 packet length array
                                                                                            	**type**\:  :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                            
                                                                                            .. attribute:: packet_len
                                                                                            
                                                                                            	Match packet length array
                                                                                            	**type**\:  :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                            
                                                                                            .. attribute:: flow_tag
                                                                                            
                                                                                            	Match flow\-tag array
                                                                                            	**type**\:  :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                            
                                                                                            .. attribute:: tcp_flag
                                                                                            
                                                                                            	Match tcp flag value
                                                                                            	**type**\:  :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                            
                                                                                            .. attribute:: icmpv4_type
                                                                                            
                                                                                            	Match ipv4 icmp type
                                                                                            	**type**\:  :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                            
                                                                                            .. attribute:: icmpv4_code
                                                                                            
                                                                                            	Match ipv4 icmp code
                                                                                            	**type**\:  :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                            
                                                                                            .. attribute:: icmpv6_type
                                                                                            
                                                                                            	Match ipv6 icmp type
                                                                                            	**type**\:  :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                            
                                                                                            .. attribute:: icmpv6_code
                                                                                            
                                                                                            	Match ipv6 icmp code
                                                                                            	**type**\:  :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                            
                                                                                            .. attribute:: mpls_exp
                                                                                            
                                                                                            	Match MPLS experimental topmost array
                                                                                            	**type**\:  :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                            
                                                                                            .. attribute:: mpls_exp_imp
                                                                                            
                                                                                            	Match MPLS experimental imposition array
                                                                                            	**type**\:  :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                                            
                                                                                            	MPLS Disposition IPv4 Access\-list
                                                                                            	**type**\:  :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                                            
                                                                                            	MPLS Disposition IPv6 Access\-list
                                                                                            	**type**\:  :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_top_label
                                                                                            
                                                                                            	MPLS Topmost LABEL
                                                                                            	**type**\:  :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                            
                                                                                            .. attribute:: cos
                                                                                            
                                                                                            	Match CoS array
                                                                                            	**type**\:  :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                            
                                                                                            .. attribute:: cos_inr
                                                                                            
                                                                                            	Match inner header CoS
                                                                                            	**type**\:  :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                            
                                                                                            .. attribute:: dei
                                                                                            
                                                                                            	Match DEI Bit
                                                                                            	**type**\:  :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                            
                                                                                            .. attribute:: dei_inr
                                                                                            
                                                                                            	Match inner DEI Bit
                                                                                            	**type**\:  :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                            
                                                                                            .. attribute:: vlan
                                                                                            
                                                                                            	Match VLAN array
                                                                                            	**type**\:  :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                            
                                                                                            .. attribute:: vlan_inr
                                                                                            
                                                                                            	Match inner header VLAN range array
                                                                                            	**type**\:  :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                            
                                                                                            .. attribute:: fr_dlci
                                                                                            
                                                                                            	Match FR DLCI range array
                                                                                            	**type**\:  :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                            
                                                                                            .. attribute:: src_mac
                                                                                            
                                                                                            	Match Source MAC address
                                                                                            	**type**\:  :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                            
                                                                                            .. attribute:: dst_mac
                                                                                            
                                                                                            	Match Destination MAC address
                                                                                            	**type**\:  :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                            
                                                                                            .. attribute:: atm_clp
                                                                                            
                                                                                            	Match ATM CLP level
                                                                                            	**type**\:  :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                            
                                                                                            .. attribute:: fr_de
                                                                                            
                                                                                            	Match FR DE value
                                                                                            	**type**\:  :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                            
                                                                                            .. attribute:: ipv4_acl
                                                                                            
                                                                                            	IPv4 Access\-list
                                                                                            	**type**\:  :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                            
                                                                                            .. attribute:: ipv6_acl
                                                                                            
                                                                                            	IPv6 Access\-list
                                                                                            	**type**\:  :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                            
                                                                                            .. attribute:: ether_service_acl
                                                                                            
                                                                                            	Ethernet\-Services Access\-list
                                                                                            	**type**\:  :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                            
                                                                                            .. attribute:: avail_id
                                                                                            
                                                                                            	Available Identifiers
                                                                                            	**type**\:  :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                            
                                                                                            .. attribute:: media_type
                                                                                            
                                                                                            	Media Type
                                                                                            	**type**\:  :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                            
                                                                                            .. attribute:: subs_protocol
                                                                                            
                                                                                            	Protocol
                                                                                            	**type**\:  :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                            
                                                                                            .. attribute:: dnis
                                                                                            
                                                                                            	DNIS
                                                                                            	**type**\:  :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                            
                                                                                            .. attribute:: dnis_regex
                                                                                            
                                                                                            	DNIS Regular Expression
                                                                                            	**type**\:  :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                            
                                                                                            .. attribute:: domain
                                                                                            
                                                                                            	Domain Name
                                                                                            	**type**\:  :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                            
                                                                                            .. attribute:: domain_regex
                                                                                            
                                                                                            	Domain Regular Expression
                                                                                            	**type**\:  :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                            
                                                                                            .. attribute:: nas_port
                                                                                            
                                                                                            	NAS Port
                                                                                            	**type**\:  :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                            
                                                                                            .. attribute:: service_name
                                                                                            
                                                                                            	Service Name
                                                                                            	**type**\:  :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                            
                                                                                            .. attribute:: service_name_regex
                                                                                            
                                                                                            	Service Name Regular Exp
                                                                                            	**type**\:  :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv4
                                                                                            
                                                                                            	Source Address IPV4
                                                                                            	**type**\:  :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv4
                                                                                            
                                                                                            	Destination Address IPV4
                                                                                            	**type**\:  :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv6
                                                                                            
                                                                                            	Source Address IPV6
                                                                                            	**type**\:  :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv6
                                                                                            
                                                                                            	Destination Address IPV6
                                                                                            	**type**\:  :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: src_addr_mac
                                                                                            
                                                                                            	Source Address MAC
                                                                                            	**type**\:  :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                            
                                                                                            .. attribute:: timer
                                                                                            
                                                                                            	Timer
                                                                                            	**type**\:  :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                            
                                                                                            .. attribute:: timer_regexp
                                                                                            
                                                                                            	Timer Regular Expression
                                                                                            	**type**\:  :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                            
                                                                                            .. attribute:: tunnel_name
                                                                                            
                                                                                            	Tunnel Name
                                                                                            	**type**\:  :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                            
                                                                                            .. attribute:: tunnel_name_regex
                                                                                            
                                                                                            	Tunnel Name Regular Expression
                                                                                            	**type**\:  :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                            
                                                                                            .. attribute:: user_name
                                                                                            
                                                                                            	User Name
                                                                                            	**type**\:  :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                            
                                                                                            .. attribute:: user_name_regex
                                                                                            
                                                                                            	User Name Regular Expression
                                                                                            	**type**\:  :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                            
                                                                                            .. attribute:: auth_username
                                                                                            
                                                                                            	Authenticated User Name
                                                                                            	**type**\:  :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                            
                                                                                            .. attribute:: auth_username_regex
                                                                                            
                                                                                            	Authenticated User Name RegEx
                                                                                            	**type**\:  :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_username
                                                                                            
                                                                                            	Unauthenticated User Name
                                                                                            	**type**\:  :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                            
                                                                                            .. attribute:: unauth_username_regex
                                                                                            
                                                                                            	Unauthenticated User Name RegEx
                                                                                            	**type**\:  :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: auth_domain
                                                                                            
                                                                                            	Authenticated domain name
                                                                                            	**type**\:  :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                            
                                                                                            .. attribute:: auth_domain_regex
                                                                                            
                                                                                            	Authenticated Domain Name RegEx
                                                                                            	**type**\:  :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_domain
                                                                                            
                                                                                            	Unauthenticated Domain Name
                                                                                            	**type**\:  :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                            
                                                                                            .. attribute:: unauth_domain_regex
                                                                                            
                                                                                            	Unauthenticated Domain Name RegEx
                                                                                            	**type**\:  :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: vendor_id
                                                                                            
                                                                                            	Vendor ID
                                                                                            	**type**\:  :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                            
                                                                                            .. attribute:: vendor_id_regex
                                                                                            
                                                                                            	Vendor ID RegEx
                                                                                            	**type**\:  :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                            
                                                                                            .. attribute:: access_interface
                                                                                            
                                                                                            	Access interface
                                                                                            	**type**\:  :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                            
                                                                                            .. attribute:: input_interface
                                                                                            
                                                                                            	Input interface
                                                                                            	**type**\:  :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                            
                                                                                            .. attribute:: input_intfhdl
                                                                                            
                                                                                            	Input interface handle
                                                                                            	**type**\:  :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                            
                                                                                            .. attribute:: ethertype
                                                                                            
                                                                                            	Ethernet type
                                                                                            	**type**\:  :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                            
                                                                                            .. attribute:: flow_key_data
                                                                                            
                                                                                            	Flow key structure
                                                                                            	**type**\:  :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id
                                                                                            
                                                                                            	Dhcp Client ID
                                                                                            	**type**\:  :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id_regex
                                                                                            
                                                                                            	Dhcp Client ID RegEx
                                                                                            	**type**\:  :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                            
                                                                                            .. attribute:: circuit_id
                                                                                            
                                                                                            	Circuit ID
                                                                                            	**type**\:  :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                            
                                                                                            .. attribute:: circuit_id_regex
                                                                                            
                                                                                            	Circuit ID RegEx
                                                                                            	**type**\:  :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                            
                                                                                            .. attribute:: remote_id
                                                                                            
                                                                                            	Remote ID
                                                                                            	**type**\:  :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                            
                                                                                            .. attribute:: remote_id_regex
                                                                                            
                                                                                            	Remote ID RegEx
                                                                                            	**type**\:  :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                            
                                                                                            .. attribute:: src_port
                                                                                            
                                                                                            	Source port
                                                                                            	**type**\:  :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                            
                                                                                            .. attribute:: dst_port
                                                                                            
                                                                                            	Destination port
                                                                                            	**type**\:  :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	type
                                                                                            	**type**\:  :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                            
                                                                                            .. attribute:: mpls_top_eos
                                                                                            
                                                                                            	MPLS Topmost EOS
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: fragment_type
                                                                                            
                                                                                            	Fragment type
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: authen_status
                                                                                            
                                                                                            	Authentication Status
                                                                                            	**type**\:  :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                            
                                                                                            .. attribute:: mlp_negotiated
                                                                                            
                                                                                            	MLP Negotiated
                                                                                            	**type**\:  :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                                self.yang_name = "match-data"
                                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("ipv4-dscp", ("ipv4_dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp)), ("ipv6-dscp", ("ipv6_dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp)), ("dscp", ("dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp)), ("ipv4-prec", ("ipv4_prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec)), ("ipv6-prec", ("ipv6_prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec)), ("prec", ("prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec)), ("discard-class", ("discard_class", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass)), ("qos-group", ("qos_group", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup)), ("traffic-class", ("traffic_class", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass)), ("proto", ("proto", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto)), ("icmp-v4", ("icmp_v4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4)), ("icmp-v6", ("icmp_v6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6)), ("ipv4-packet-len", ("ipv4_packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen)), ("ipv6-packet-len", ("ipv6_packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen)), ("packet-len", ("packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen)), ("flow-tag", ("flow_tag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag)), ("tcp-flag", ("tcp_flag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag)), ("icmpv4-type", ("icmpv4_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type)), ("icmpv4-code", ("icmpv4_code", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code)), ("icmpv6-type", ("icmpv6_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type)), ("icmpv6-code", ("icmpv6_code", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code)), ("mpls-exp", ("mpls_exp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp)), ("mpls-exp-imp", ("mpls_exp_imp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp)), ("mpls-disp-ipv4-acl", ("mpls_disp_ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl)), ("mpls-disp-ipv6-acl", ("mpls_disp_ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl)), ("mpls-top-label", ("mpls_top_label", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel)), ("cos", ("cos", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos)), ("cos-inr", ("cos_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr)), ("dei", ("dei", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei)), ("dei-inr", ("dei_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr)), ("vlan", ("vlan", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan)), ("vlan-inr", ("vlan_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)), ("fr-dlci", ("fr_dlci", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci)), ("src-mac", ("src_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac)), ("dst-mac", ("dst_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac)), ("atm-clp", ("atm_clp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp)), ("fr-de", ("fr_de", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe)), ("ipv4-acl", ("ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl)), ("ipv6-acl", ("ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl)), ("ether-service-acl", ("ether_service_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl)), ("avail-id", ("avail_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId)), ("media-type", ("media_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType)), ("subs-protocol", ("subs_protocol", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol)), ("dnis", ("dnis", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis)), ("dnis-regex", ("dnis_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex)), ("domain", ("domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain)), ("domain-regex", ("domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex)), ("nas-port", ("nas_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort)), ("service-name", ("service_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName)), ("service-name-regex", ("service_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex)), ("src-addr-ipv4", ("src_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4)), ("dst-addr-ipv4", ("dst_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4)), ("src-addr-ipv6", ("src_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6)), ("dst-addr-ipv6", ("dst_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6)), ("src-addr-mac", ("src_addr_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac)), ("timer", ("timer", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer)), ("timer-regexp", ("timer_regexp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp)), ("tunnel-name", ("tunnel_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName)), ("tunnel-name-regex", ("tunnel_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex)), ("user-name", ("user_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName)), ("user-name-regex", ("user_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex)), ("auth-username", ("auth_username", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername)), ("auth-username-regex", ("auth_username_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex)), ("unauth-username", ("unauth_username", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername)), ("unauth-username-regex", ("unauth_username_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex)), ("auth-domain", ("auth_domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain)), ("auth-domain-regex", ("auth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex)), ("unauth-domain", ("unauth_domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain)), ("unauth-domain-regex", ("unauth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex)), ("vendor-id", ("vendor_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId)), ("vendor-id-regex", ("vendor_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex)), ("access-interface", ("access_interface", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface)), ("input-interface", ("input_interface", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface)), ("input-intfhdl", ("input_intfhdl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl)), ("ethertype", ("ethertype", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype)), ("flow-key-data", ("flow_key_data", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData)), ("dhcp-client-id", ("dhcp_client_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId)), ("dhcp-client-id-regex", ("dhcp_client_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex)), ("circuit-id", ("circuit_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId)), ("circuit-id-regex", ("circuit_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex)), ("remote-id", ("remote_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId)), ("remote-id-regex", ("remote_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex)), ("src-port", ("src_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort)), ("dst-port", ("dst_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort))])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchTypeEn', '')])),
                                                                                                    ('mpls_top_eos', (YLeaf(YType.uint8, 'mpls-top-eos'), ['int'])),
                                                                                                    ('fragment_type', (YLeaf(YType.uint8, 'fragment-type'), ['int'])),
                                                                                                    ('authen_status', (YLeaf(YType.enumeration, 'authen-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchAuthenStatusEn', '')])),
                                                                                                    ('mlp_negotiated', (YLeaf(YType.enumeration, 'mlp-negotiated'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchMlpNegotiatedEn', '')])),
                                                                                                ])
                                                                                                self.type = None
                                                                                                self.mpls_top_eos = None
                                                                                                self.fragment_type = None
                                                                                                self.authen_status = None
                                                                                                self.mlp_negotiated = None

                                                                                                self.ipv4_dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                                self.ipv4_dscp.parent = self
                                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"

                                                                                                self.ipv6_dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                                self.ipv6_dscp.parent = self
                                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"

                                                                                                self.dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                                self.dscp.parent = self
                                                                                                self._children_name_map["dscp"] = "dscp"

                                                                                                self.ipv4_prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                                self.ipv4_prec.parent = self
                                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"

                                                                                                self.ipv6_prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                                self.ipv6_prec.parent = self
                                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"

                                                                                                self.prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                                self.prec.parent = self
                                                                                                self._children_name_map["prec"] = "prec"

                                                                                                self.discard_class = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                                self.discard_class.parent = self
                                                                                                self._children_name_map["discard_class"] = "discard-class"

                                                                                                self.qos_group = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                                self.qos_group.parent = self
                                                                                                self._children_name_map["qos_group"] = "qos-group"

                                                                                                self.traffic_class = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                                self.traffic_class.parent = self
                                                                                                self._children_name_map["traffic_class"] = "traffic-class"

                                                                                                self.proto = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                                self.proto.parent = self
                                                                                                self._children_name_map["proto"] = "proto"

                                                                                                self.icmp_v4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                                self.icmp_v4.parent = self
                                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"

                                                                                                self.icmp_v6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                                self.icmp_v6.parent = self
                                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"

                                                                                                self.ipv4_packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                                self.ipv4_packet_len.parent = self
                                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"

                                                                                                self.ipv6_packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                                self.ipv6_packet_len.parent = self
                                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"

                                                                                                self.packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                                self.packet_len.parent = self
                                                                                                self._children_name_map["packet_len"] = "packet-len"

                                                                                                self.flow_tag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                                self.flow_tag.parent = self
                                                                                                self._children_name_map["flow_tag"] = "flow-tag"

                                                                                                self.tcp_flag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                                self.tcp_flag.parent = self
                                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"

                                                                                                self.icmpv4_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                                self.icmpv4_type.parent = self
                                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"

                                                                                                self.icmpv4_code = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                                self.icmpv4_code.parent = self
                                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"

                                                                                                self.icmpv6_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                                self.icmpv6_type.parent = self
                                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"

                                                                                                self.icmpv6_code = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                                self.icmpv6_code.parent = self
                                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"

                                                                                                self.mpls_exp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                                self.mpls_exp.parent = self
                                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"

                                                                                                self.mpls_exp_imp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                                self.mpls_exp_imp.parent = self
                                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"

                                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"

                                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"

                                                                                                self.mpls_top_label = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                                self.mpls_top_label.parent = self
                                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"

                                                                                                self.cos = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                                self.cos.parent = self
                                                                                                self._children_name_map["cos"] = "cos"

                                                                                                self.cos_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                                self.cos_inr.parent = self
                                                                                                self._children_name_map["cos_inr"] = "cos-inr"

                                                                                                self.dei = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                                self.dei.parent = self
                                                                                                self._children_name_map["dei"] = "dei"

                                                                                                self.dei_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                                self.dei_inr.parent = self
                                                                                                self._children_name_map["dei_inr"] = "dei-inr"

                                                                                                self.vlan = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                                self.vlan.parent = self
                                                                                                self._children_name_map["vlan"] = "vlan"

                                                                                                self.vlan_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                                self.vlan_inr.parent = self
                                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"

                                                                                                self.fr_dlci = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                                self.fr_dlci.parent = self
                                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"

                                                                                                self.src_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                                self.src_mac.parent = self
                                                                                                self._children_name_map["src_mac"] = "src-mac"

                                                                                                self.dst_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                                self.dst_mac.parent = self
                                                                                                self._children_name_map["dst_mac"] = "dst-mac"

                                                                                                self.atm_clp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                                self.atm_clp.parent = self
                                                                                                self._children_name_map["atm_clp"] = "atm-clp"

                                                                                                self.fr_de = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                                self.fr_de.parent = self
                                                                                                self._children_name_map["fr_de"] = "fr-de"

                                                                                                self.ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                                self.ipv4_acl.parent = self
                                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"

                                                                                                self.ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                                self.ipv6_acl.parent = self
                                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"

                                                                                                self.ether_service_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                                self.ether_service_acl.parent = self
                                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"

                                                                                                self.avail_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                                self.avail_id.parent = self
                                                                                                self._children_name_map["avail_id"] = "avail-id"

                                                                                                self.media_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                                self.media_type.parent = self
                                                                                                self._children_name_map["media_type"] = "media-type"

                                                                                                self.subs_protocol = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                                self.subs_protocol.parent = self
                                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"

                                                                                                self.dnis = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                                self.dnis.parent = self
                                                                                                self._children_name_map["dnis"] = "dnis"

                                                                                                self.dnis_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                                self.dnis_regex.parent = self
                                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"

                                                                                                self.domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                                self.domain.parent = self
                                                                                                self._children_name_map["domain"] = "domain"

                                                                                                self.domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                                self.domain_regex.parent = self
                                                                                                self._children_name_map["domain_regex"] = "domain-regex"

                                                                                                self.nas_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                                self.nas_port.parent = self
                                                                                                self._children_name_map["nas_port"] = "nas-port"

                                                                                                self.service_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                                self.service_name.parent = self
                                                                                                self._children_name_map["service_name"] = "service-name"

                                                                                                self.service_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                                self.service_name_regex.parent = self
                                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"

                                                                                                self.src_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                                self.src_addr_ipv4.parent = self
                                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"

                                                                                                self.dst_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                                self.dst_addr_ipv4.parent = self
                                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"

                                                                                                self.src_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                                self.src_addr_ipv6.parent = self
                                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"

                                                                                                self.dst_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                                self.dst_addr_ipv6.parent = self
                                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"

                                                                                                self.src_addr_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                                self.src_addr_mac.parent = self
                                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"

                                                                                                self.timer = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                                self.timer.parent = self
                                                                                                self._children_name_map["timer"] = "timer"

                                                                                                self.timer_regexp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                                self.timer_regexp.parent = self
                                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"

                                                                                                self.tunnel_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                                self.tunnel_name.parent = self
                                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"

                                                                                                self.tunnel_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                                self.tunnel_name_regex.parent = self
                                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"

                                                                                                self.user_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                                self.user_name.parent = self
                                                                                                self._children_name_map["user_name"] = "user-name"

                                                                                                self.user_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                                self.user_name_regex.parent = self
                                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"

                                                                                                self.auth_username = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                                self.auth_username.parent = self
                                                                                                self._children_name_map["auth_username"] = "auth-username"

                                                                                                self.auth_username_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                                self.auth_username_regex.parent = self
                                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"

                                                                                                self.unauth_username = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                                self.unauth_username.parent = self
                                                                                                self._children_name_map["unauth_username"] = "unauth-username"

                                                                                                self.unauth_username_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                                self.unauth_username_regex.parent = self
                                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"

                                                                                                self.auth_domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                                self.auth_domain.parent = self
                                                                                                self._children_name_map["auth_domain"] = "auth-domain"

                                                                                                self.auth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                                self.auth_domain_regex.parent = self
                                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"

                                                                                                self.unauth_domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                                self.unauth_domain.parent = self
                                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"

                                                                                                self.unauth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                                self.unauth_domain_regex.parent = self
                                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"

                                                                                                self.vendor_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                                self.vendor_id.parent = self
                                                                                                self._children_name_map["vendor_id"] = "vendor-id"

                                                                                                self.vendor_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                                self.vendor_id_regex.parent = self
                                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"

                                                                                                self.access_interface = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                                self.access_interface.parent = self
                                                                                                self._children_name_map["access_interface"] = "access-interface"

                                                                                                self.input_interface = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                                self.input_interface.parent = self
                                                                                                self._children_name_map["input_interface"] = "input-interface"

                                                                                                self.input_intfhdl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                                self.input_intfhdl.parent = self
                                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"

                                                                                                self.ethertype = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                                self.ethertype.parent = self
                                                                                                self._children_name_map["ethertype"] = "ethertype"

                                                                                                self.flow_key_data = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                                self.flow_key_data.parent = self
                                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"

                                                                                                self.dhcp_client_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                                self.dhcp_client_id.parent = self
                                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"

                                                                                                self.dhcp_client_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                                self.dhcp_client_id_regex.parent = self
                                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"

                                                                                                self.circuit_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                                self.circuit_id.parent = self
                                                                                                self._children_name_map["circuit_id"] = "circuit-id"

                                                                                                self.circuit_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                                self.circuit_id_regex.parent = self
                                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"

                                                                                                self.remote_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                                self.remote_id.parent = self
                                                                                                self._children_name_map["remote_id"] = "remote-id"

                                                                                                self.remote_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                                self.remote_id_regex.parent = self
                                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"

                                                                                                self.src_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                                self.src_port.parent = self
                                                                                                self._children_name_map["src_port"] = "src-port"

                                                                                                self.dst_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                                self.dst_port.parent = self
                                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                                self._segment_path = lambda: "match-data"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['type', 'mpls_top_eos', 'fragment_type', 'authen_status', 'mlp_negotiated'], name, value)


                                                                                            class Ipv4Dscp(Entity):
                                                                                                """
                                                                                                IPv4 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv4-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv6Dscp(Entity):
                                                                                                """
                                                                                                IPv6 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv6-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Dscp(Entity):
                                                                                                """
                                                                                                Match DSCP range array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                    self.yang_name = "dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dscp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv4Prec(Entity):
                                                                                                """
                                                                                                IPv4 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                    self.yang_name = "ipv4-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "ipv4-prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                            class Ipv6Prec(Entity):
                                                                                                """
                                                                                                IPv6 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                    self.yang_name = "ipv6-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "ipv6-prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                            class Prec(Entity):
                                                                                                """
                                                                                                Match Precedence array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                    self.yang_name = "prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "prec"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                            class DiscardClass(Entity):
                                                                                                """
                                                                                                Match Discard Class array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                    self.yang_name = "discard-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "discard-class"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                            class QosGroup(Entity):
                                                                                                """
                                                                                                Match QoS group array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                    self.yang_name = "qos-group"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "qos-group"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "qos-group"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class TrafficClass(Entity):
                                                                                                """
                                                                                                Match Traffic class array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                    self.yang_name = "traffic-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "traffic-class"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "traffic-class"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Proto(Entity):
                                                                                                """
                                                                                                Match Protocol array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                    self.yang_name = "proto"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "proto"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "proto"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class IcmpV4(Entity):
                                                                                                """
                                                                                                Match ICMPV4 Protocol
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                    self.yang_name = "icmp-v4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                    ])
                                                                                                    self.type = None
                                                                                                    self.code = None
                                                                                                    self._segment_path = lambda: "icmp-v4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['type', 'code'], name, value)


                                                                                            class IcmpV6(Entity):
                                                                                                """
                                                                                                Match ICMPV6 Protocol array
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                    self.yang_name = "icmp-v6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                        ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                    ])
                                                                                                    self.type = None
                                                                                                    self.code = None
                                                                                                    self._segment_path = lambda: "icmp-v6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['type', 'code'], name, value)


                                                                                            class Ipv4PacketLen(Entity):
                                                                                                """
                                                                                                IPv4 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class Ipv6PacketLen(Entity):
                                                                                                """
                                                                                                IPv6 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class PacketLen(Entity):
                                                                                                """
                                                                                                Match packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                    self.yang_name = "packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "packet-len"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FlowTag(Entity):
                                                                                                """
                                                                                                Match flow\-tag array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                    self.yang_name = "flow-tag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "flow-tag"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "flow-tag"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class TcpFlag(Entity):
                                                                                                """
                                                                                                Match tcp flag value
                                                                                                
                                                                                                .. attribute:: value
                                                                                                
                                                                                                	Value of TCP flag
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: match_any
                                                                                                
                                                                                                	Match any TCP flag bit
                                                                                                	**type**\: bool
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                    self.yang_name = "tcp-flag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                                        ('match_any', (YLeaf(YType.boolean, 'match-any'), ['bool'])),
                                                                                                    ])
                                                                                                    self.value = None
                                                                                                    self.match_any = None
                                                                                                    self._segment_path = lambda: "tcp-flag"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['value', 'match_any'], name, value)


                                                                                            class Icmpv4Type(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                    self.yang_name = "icmpv4-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv4Code(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                    self.yang_name = "icmpv4-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-code"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv6Type(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                    self.yang_name = "icmpv6-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class Icmpv6Code(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                    self.yang_name = "icmpv6-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-code"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint8_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                            class MplsExp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental topmost array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "mpls-exp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                            class MplsExpImp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental imposition array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "mpls-exp-imp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                            class MplsDispIpv4Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                            class MplsDispIpv6Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                            class MplsTopLabel(Entity):
                                                                                                """
                                                                                                MPLS Topmost LABEL
                                                                                                
                                                                                                .. attribute:: uint32_rng_array
                                                                                                
                                                                                                	uint32 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                    self.yang_name = "mpls-top-label"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint32_rng_array", ("uint32_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint32_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "mpls-top-label"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                                class Uint32RngArray(Entity):
                                                                                                    """
                                                                                                    uint32 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                        self.yang_name = "uint32_rng_array"
                                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint32, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint32, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint32_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['min', 'max'], name, value)


                                                                                            class Cos(Entity):
                                                                                                """
                                                                                                Match CoS array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                    self.yang_name = "cos"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "cos"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                            class CosInr(Entity):
                                                                                                """
                                                                                                Match inner header CoS
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                    self.yang_name = "cos-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "cos-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                            class Dei(Entity):
                                                                                                """
                                                                                                Match DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                    self.yang_name = "dei"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                    ])
                                                                                                    self.bit_value = None
                                                                                                    self._segment_path = lambda: "dei"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                            class DeiInr(Entity):
                                                                                                """
                                                                                                Match inner DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                    self.yang_name = "dei-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                    ])
                                                                                                    self.bit_value = None
                                                                                                    self._segment_path = lambda: "dei-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                            class Vlan(Entity):
                                                                                                """
                                                                                                Match VLAN array
                                                                                                
                                                                                                .. attribute:: vlan_id_array
                                                                                                
                                                                                                	vlan id array
                                                                                                	**type**\: list of  		 :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                    self.yang_name = "vlan"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("vlan-id-array", ("vlan_id_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.vlan_id_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                                class VlanIdArray(Entity):
                                                                                                    """
                                                                                                    vlan id array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	VLAN mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                        self.yang_name = "vlan-id-array"
                                                                                                        self.yang_parent_name = "vlan"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                            ('mask', (YLeaf(YType.uint16, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "vlan-id-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['min', 'max', 'mask'], name, value)


                                                                                            class VlanInr(Entity):
                                                                                                """
                                                                                                Match inner header VLAN range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                    self.yang_name = "vlan-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan-inr"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FrDlci(Entity):
                                                                                                """
                                                                                                Match FR DLCI range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                    self.yang_name = "fr-dlci"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "fr-dlci"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class SrcMac(Entity):
                                                                                                """
                                                                                                Match Source MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                    self.yang_name = "src-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.mac_addr = []
                                                                                                    self.mask = []
                                                                                                    self._segment_path = lambda: "src-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                            class DstMac(Entity):
                                                                                                """
                                                                                                Match Destination MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                    self.yang_name = "dst-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.mac_addr = []
                                                                                                    self.mask = []
                                                                                                    self._segment_path = lambda: "dst-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                            class AtmClp(Entity):
                                                                                                """
                                                                                                Match ATM CLP level
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                    self.yang_name = "atm-clp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "atm-clp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                            class FrDe(Entity):
                                                                                                """
                                                                                                Match FR DE value
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                    self.yang_name = "fr-de"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "fr-de"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                            class Ipv4Acl(Entity):
                                                                                                """
                                                                                                IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                    self.yang_name = "ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ipv4-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                            class Ipv6Acl(Entity):
                                                                                                """
                                                                                                IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                    self.yang_name = "ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ipv6-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                            class EtherServiceAcl(Entity):
                                                                                                """
                                                                                                Ethernet\-Services Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                    self.yang_name = "ether-service-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "ether-service-acl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                            class AvailId(Entity):
                                                                                                """
                                                                                                Available Identifiers
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                    self.yang_name = "avail-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "avail-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                            class MediaType(Entity):
                                                                                                """
                                                                                                Media Type
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                    self.yang_name = "media-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "media-type"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                            class SubsProtocol(Entity):
                                                                                                """
                                                                                                Protocol
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                    self.yang_name = "subs-protocol"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint8_array = []
                                                                                                    self._segment_path = lambda: "subs-protocol"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                            class Dnis(Entity):
                                                                                                """
                                                                                                DNIS
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                    self.yang_name = "dnis"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dnis"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                            class DnisRegex(Entity):
                                                                                                """
                                                                                                DNIS Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                    self.yang_name = "dnis-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dnis-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                            class Domain(Entity):
                                                                                                """
                                                                                                Domain Name
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                    self.yang_name = "domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                        ])
                                                                                                        self.domain_name = None
                                                                                                        self.format_name = None
                                                                                                        self._segment_path = lambda: "domain-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class DomainRegex(Entity):
                                                                                                """
                                                                                                Domain Regular Expression
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                    self.yang_name = "domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain-regex"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                        ])
                                                                                                        self.domain_name = None
                                                                                                        self.format_name = None
                                                                                                        self._segment_path = lambda: "domain-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class NasPort(Entity):
                                                                                                """
                                                                                                NAS Port
                                                                                                
                                                                                                .. attribute:: nas_port_array
                                                                                                
                                                                                                	nas port array
                                                                                                	**type**\: list of  		 :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                    self.yang_name = "nas-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("nas-port-array", ("nas_port_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.nas_port_array = YList(self)
                                                                                                    self._segment_path = lambda: "nas-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                                class NasPortArray(Entity):
                                                                                                    """
                                                                                                    nas port array
                                                                                                    
                                                                                                    .. attribute:: sub_id
                                                                                                    
                                                                                                    	sub id
                                                                                                    	**type**\:  :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                    
                                                                                                    .. attribute:: operator
                                                                                                    
                                                                                                    	operator
                                                                                                    	**type**\:  :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	value
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                        self.yang_name = "nas-port-array"
                                                                                                        self.yang_parent_name = "nas-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('sub_id', (YLeaf(YType.enumeration, 'sub-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchNasPortSubIdEn', '')])),
                                                                                                            ('operator', (YLeaf(YType.enumeration, 'operator'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchLogicalOperatorEn', '')])),
                                                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                                        ])
                                                                                                        self.sub_id = None
                                                                                                        self.operator = None
                                                                                                        self.value = None
                                                                                                        self._segment_path = lambda: "nas-port-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['sub_id', 'operator', 'value'], name, value)


                                                                                            class ServiceName(Entity):
                                                                                                """
                                                                                                Service Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                    self.yang_name = "service-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "service-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                            class ServiceNameRegex(Entity):
                                                                                                """
                                                                                                Service Name Regular Exp
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                    self.yang_name = "service-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "service-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                            class SrcAddrIpv4(Entity):
                                                                                                """
                                                                                                Source Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class DstAddrIpv4(Entity):
                                                                                                """
                                                                                                Destination Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv4"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class SrcAddrIpv6(Entity):
                                                                                                """
                                                                                                Source Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class DstAddrIpv6(Entity):
                                                                                                """
                                                                                                Destination Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv6"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                            ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.prefix = None
                                                                                                        self.mask = None
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                            class SrcAddrMac(Entity):
                                                                                                """
                                                                                                Source Address MAC
                                                                                                
                                                                                                .. attribute:: mac_addr_array
                                                                                                
                                                                                                	mac addr array
                                                                                                	**type**\: list of  		 :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                    self.yang_name = "src-addr-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("mac-addr-array", ("mac_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.mac_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-mac"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                                class MacAddrArray(Entity):
                                                                                                    """
                                                                                                    mac addr array
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\: list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                        self.yang_name = "mac-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                            ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                        ])
                                                                                                        self.mac_addr = []
                                                                                                        self.mask = []
                                                                                                        self._segment_path = lambda: "mac-addr-array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                            class Timer(Entity):
                                                                                                """
                                                                                                Timer
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                    self.yang_name = "timer"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "timer"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                            class TimerRegexp(Entity):
                                                                                                """
                                                                                                Timer Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                    self.yang_name = "timer-regexp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "timer-regexp"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                            class TunnelName(Entity):
                                                                                                """
                                                                                                Tunnel Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                    self.yang_name = "tunnel-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "tunnel-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                            class TunnelNameRegex(Entity):
                                                                                                """
                                                                                                Tunnel Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "tunnel-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                            class UserName(Entity):
                                                                                                """
                                                                                                User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                    self.yang_name = "user-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "user-name"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                            class UserNameRegex(Entity):
                                                                                                """
                                                                                                User Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                    self.yang_name = "user-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "user-name-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                            class AuthUsername(Entity):
                                                                                                """
                                                                                                Authenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                    self.yang_name = "auth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-username"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                            class AuthUsernameRegex(Entity):
                                                                                                """
                                                                                                Authenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "auth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-username-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                            class UnauthUsername(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                    self.yang_name = "unauth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-username"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                            class UnauthUsernameRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-username-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                            class AuthDomain(Entity):
                                                                                                """
                                                                                                Authenticated domain name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                    self.yang_name = "auth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                            class AuthDomainRegex(Entity):
                                                                                                """
                                                                                                Authenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "auth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "auth-domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                            class UnauthDomain(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                    self.yang_name = "unauth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-domain"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                            class UnauthDomainRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "unauth-domain-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                            class VendorId(Entity):
                                                                                                """
                                                                                                Vendor ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                    self.yang_name = "vendor-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "vendor-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                            class VendorIdRegex(Entity):
                                                                                                """
                                                                                                Vendor ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                    self.yang_name = "vendor-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "vendor-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                            class AccessInterface(Entity):
                                                                                                """
                                                                                                Access interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                    self.yang_name = "access-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "access-interface"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                            class InputInterface(Entity):
                                                                                                """
                                                                                                Input interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                    self.yang_name = "input-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "input-interface"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                            class InputIntfhdl(Entity):
                                                                                                """
                                                                                                Input interface handle
                                                                                                
                                                                                                .. attribute:: uint64_array
                                                                                                
                                                                                                	uint64 array
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..18446744073709551615
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                    self.yang_name = "input-intfhdl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('uint64_array', (YLeafList(YType.uint64, 'uint64_array'), ['int'])),
                                                                                                    ])
                                                                                                    self.uint64_array = []
                                                                                                    self._segment_path = lambda: "input-intfhdl"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                            class Ethertype(Entity):
                                                                                                """
                                                                                                Ethernet type
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                    self.yang_name = "ethertype"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ethertype"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ethertype"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class FlowKeyData(Entity):
                                                                                                """
                                                                                                Flow key structure
                                                                                                
                                                                                                .. attribute:: flow_keys
                                                                                                
                                                                                                	flow keys
                                                                                                	**type**\:  :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                                
                                                                                                .. attribute:: max_count
                                                                                                
                                                                                                	Maximum count of flows
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: idle_timeout
                                                                                                
                                                                                                	Idle timeout of flows (in seconds)
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                	**units**\: second
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                    self.yang_name = "flow-key-data"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("flow-keys", ("flow_keys", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys))])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('max_count', (YLeaf(YType.uint16, 'max-count'), ['int'])),
                                                                                                        ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                                                    ])
                                                                                                    self.max_count = None
                                                                                                    self.idle_timeout = None

                                                                                                    self.flow_keys = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                    self.flow_keys.parent = self
                                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                    self._segment_path = lambda: "flow-key-data"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['max_count', 'idle_timeout'], name, value)


                                                                                                class FlowKeys(Entity):
                                                                                                    """
                                                                                                    flow keys
                                                                                                    
                                                                                                    .. attribute:: keys
                                                                                                    
                                                                                                    	keys
                                                                                                    	**type**\: str
                                                                                                    
                                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                    
                                                                                                    .. attribute:: num
                                                                                                    
                                                                                                    	num
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                        self.yang_name = "flow-keys"
                                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('keys', (YLeaf(YType.str, 'keys'), ['str'])),
                                                                                                            ('num', (YLeaf(YType.uint8, 'num'), ['int'])),
                                                                                                        ])
                                                                                                        self.keys = None
                                                                                                        self.num = None
                                                                                                        self._segment_path = lambda: "flow-keys"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                            class DhcpClientId(Entity):
                                                                                                """
                                                                                                Dhcp Client ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dhcp-client-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                            class DhcpClientIdRegex(Entity):
                                                                                                """
                                                                                                Dhcp Client ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                            class CircuitId(Entity):
                                                                                                """
                                                                                                Circuit ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                    self.yang_name = "circuit-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "circuit-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                            class CircuitIdRegex(Entity):
                                                                                                """
                                                                                                Circuit ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                    self.yang_name = "circuit-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "circuit-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                            class RemoteId(Entity):
                                                                                                """
                                                                                                Remote ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                    self.yang_name = "remote-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "remote-id"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                            class RemoteIdRegex(Entity):
                                                                                                """
                                                                                                Remote ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\: list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                    self.yang_name = "remote-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                    ])
                                                                                                    self.string_array = []
                                                                                                    self._segment_path = lambda: "remote-id-regex"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                            class SrcPort(Entity):
                                                                                                """
                                                                                                Source port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                    self.yang_name = "src-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "src-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                                            class DstPort(Entity):
                                                                                                """
                                                                                                Destination port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                    self.yang_name = "dst-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray))])
                                                                                                    self._leafs = OrderedDict()

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-port"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\: int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2018-01-17'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "dst-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self.ylist_key_names = []
                                                                                                        self._child_classes = OrderedDict([])
                                                                                                        self._leafs = OrderedDict([
                                                                                                            ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                            ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ])
                                                                                                        self.min = None
                                                                                                        self.max = None
                                                                                                        self._segment_path = lambda: "uint16_rng_array"
                                                                                                        self._is_frozen = True

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                    class Shape(Entity):
                                                                        """
                                                                        shape
                                                                        
                                                                        .. attribute:: bw
                                                                        
                                                                        	bw
                                                                        	**type**\:  :py:class:`Bw <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw>`
                                                                        
                                                                        .. attribute:: be
                                                                        
                                                                        	be
                                                                        	**type**\:  :py:class:`Be <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape, self).__init__()

                                                                            self.yang_name = "shape"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("bw", ("bw", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw)), ("be", ("be", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be))])
                                                                            self._leafs = OrderedDict()

                                                                            self.bw = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw()
                                                                            self.bw.parent = self
                                                                            self._children_name_map["bw"] = "bw"

                                                                            self.be = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be()
                                                                            self.be.parent = self
                                                                            self._children_name_map["be"] = "be"
                                                                            self._segment_path = lambda: "shape"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape, [], name, value)


                                                                        class Bw(Entity):
                                                                            """
                                                                            bw
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw, self).__init__()

                                                                                self.yang_name = "bw"
                                                                                self.yang_parent_name = "shape"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "bw"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw, ['value', 'unit'], name, value)


                                                                        class Be(Entity):
                                                                            """
                                                                            be
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be, self).__init__()

                                                                                self.yang_name = "be"
                                                                                self.yang_parent_name = "shape"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "be"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be, ['value', 'unit'], name, value)


                                                                    class ChildPolicy(Entity):
                                                                        """
                                                                        child policy
                                                                        
                                                                        .. attribute:: info
                                                                        
                                                                        	info
                                                                        	**type**\:  :py:class:`Info <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info>`
                                                                        
                                                                        .. attribute:: hd_info
                                                                        
                                                                        	hd info
                                                                        	**type**\:  :py:class:`HdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo>`
                                                                        
                                                                        .. attribute:: enc
                                                                        
                                                                        	enc
                                                                        	**type**\:  :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy, self).__init__()

                                                                            self.yang_name = "child-policy"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("info", ("info", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info)), ("hd-info", ("hd_info", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo))])
                                                                            self._leafs = OrderedDict([
                                                                                ('enc', (YLeaf(YType.enumeration, 'enc'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyObjEncEn', '')])),
                                                                            ])
                                                                            self.enc = None

                                                                            self.info = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info()
                                                                            self.info.parent = self
                                                                            self._children_name_map["info"] = "info"

                                                                            self.hd_info = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo()
                                                                            self.hd_info.parent = self
                                                                            self._children_name_map["hd_info"] = "hd-info"
                                                                            self._segment_path = lambda: "child-policy"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy, ['enc'], name, value)


                                                                        class Info(Entity):
                                                                            """
                                                                            info
                                                                            
                                                                            .. attribute:: name
                                                                            
                                                                            	name
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..65
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:  :py:class:`PolicyMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyMapTypeEn>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info, self).__init__()

                                                                                self.yang_name = "info"
                                                                                self.yang_parent_name = "child-policy"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyMapTypeEn', '')])),
                                                                                ])
                                                                                self.name = None
                                                                                self.type = None
                                                                                self._segment_path = lambda: "info"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info, ['name', 'type'], name, value)


                                                                        class HdInfo(Entity):
                                                                            """
                                                                            hd info
                                                                            
                                                                            .. attribute:: data_hd
                                                                            
                                                                            	data hd
                                                                            	**type**\:  :py:class:`DataHd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd>`
                                                                            
                                                                            .. attribute:: hd
                                                                            
                                                                            	hd
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo, self).__init__()

                                                                                self.yang_name = "hd-info"
                                                                                self.yang_parent_name = "child-policy"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("data-hd", ("data_hd", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('hd', (YLeaf(YType.uint64, 'hd'), ['int'])),
                                                                                ])
                                                                                self.hd = None

                                                                                self.data_hd = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd()
                                                                                self.data_hd.parent = self
                                                                                self._children_name_map["data_hd"] = "data-hd"
                                                                                self._segment_path = lambda: "hd-info"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo, ['hd'], name, value)


                                                                            class DataHd(Entity):
                                                                                """
                                                                                data hd
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd, self).__init__()

                                                                                    self.yang_name = "data-hd"
                                                                                    self.yang_parent_name = "hd-info"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict()
                                                                                    self._segment_path = lambda: "data-hd"
                                                                                    self._is_frozen = True


                                                                    class Cac(Entity):
                                                                        """
                                                                        cac
                                                                        
                                                                        .. attribute:: flow_rate
                                                                        
                                                                        	flow rate
                                                                        	**type**\:  :py:class:`FlowRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate>`
                                                                        
                                                                        .. attribute:: rate
                                                                        
                                                                        	rate
                                                                        	**type**\:  :py:class:`Rate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate>`
                                                                        
                                                                        .. attribute:: cac_type
                                                                        
                                                                        	cac type
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: idle_timeout
                                                                        
                                                                        	idle timeout
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..65535
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac, self).__init__()

                                                                            self.yang_name = "cac"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("flow-rate", ("flow_rate", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate)), ("rate", ("rate", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate))])
                                                                            self._leafs = OrderedDict([
                                                                                ('cac_type', (YLeaf(YType.uint8, 'cac-type'), ['int'])),
                                                                                ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                            ])
                                                                            self.cac_type = None
                                                                            self.idle_timeout = None

                                                                            self.flow_rate = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate()
                                                                            self.flow_rate.parent = self
                                                                            self._children_name_map["flow_rate"] = "flow-rate"

                                                                            self.rate = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate()
                                                                            self.rate.parent = self
                                                                            self._children_name_map["rate"] = "rate"
                                                                            self._segment_path = lambda: "cac"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac, ['cac_type', 'idle_timeout'], name, value)


                                                                        class FlowRate(Entity):
                                                                            """
                                                                            flow rate
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate, self).__init__()

                                                                                self.yang_name = "flow-rate"
                                                                                self.yang_parent_name = "cac"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "flow-rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate, ['value', 'unit'], name, value)


                                                                        class Rate(Entity):
                                                                            """
                                                                            rate
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate, self).__init__()

                                                                                self.yang_name = "rate"
                                                                                self.yang_parent_name = "cac"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate, ['value', 'unit'], name, value)


                                                                    class Pfc(Entity):
                                                                        """
                                                                        pfc
                                                                        
                                                                        .. attribute:: buffer_size
                                                                        
                                                                        	buffer size
                                                                        	**type**\:  :py:class:`BufferSize <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize>`
                                                                        
                                                                        .. attribute:: pause_threshold
                                                                        
                                                                        	pause threshold
                                                                        	**type**\:  :py:class:`PauseThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold>`
                                                                        
                                                                        .. attribute:: resume_threshold
                                                                        
                                                                        	resume threshold
                                                                        	**type**\:  :py:class:`ResumeThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold>`
                                                                        
                                                                        .. attribute:: pfc_pause_set
                                                                        
                                                                        	pfc pause set
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: buffer_size_flag
                                                                        
                                                                        	buffer size flag
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc, self).__init__()

                                                                            self.yang_name = "pfc"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("buffer-size", ("buffer_size", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize)), ("pause-threshold", ("pause_threshold", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold)), ("resume-threshold", ("resume_threshold", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold))])
                                                                            self._leafs = OrderedDict([
                                                                                ('pfc_pause_set', (YLeaf(YType.uint32, 'pfc-pause-set'), ['int'])),
                                                                                ('buffer_size_flag', (YLeaf(YType.uint32, 'buffer-size-flag'), ['int'])),
                                                                            ])
                                                                            self.pfc_pause_set = None
                                                                            self.buffer_size_flag = None

                                                                            self.buffer_size = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize()
                                                                            self.buffer_size.parent = self
                                                                            self._children_name_map["buffer_size"] = "buffer-size"

                                                                            self.pause_threshold = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold()
                                                                            self.pause_threshold.parent = self
                                                                            self._children_name_map["pause_threshold"] = "pause-threshold"

                                                                            self.resume_threshold = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold()
                                                                            self.resume_threshold.parent = self
                                                                            self._children_name_map["resume_threshold"] = "resume-threshold"
                                                                            self._segment_path = lambda: "pfc"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc, ['pfc_pause_set', 'buffer_size_flag'], name, value)


                                                                        class BufferSize(Entity):
                                                                            """
                                                                            buffer size
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize, self).__init__()

                                                                                self.yang_name = "buffer-size"
                                                                                self.yang_parent_name = "pfc"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "buffer-size"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize, ['value', 'unit'], name, value)


                                                                        class PauseThreshold(Entity):
                                                                            """
                                                                            pause threshold
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold, self).__init__()

                                                                                self.yang_name = "pause-threshold"
                                                                                self.yang_parent_name = "pfc"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "pause-threshold"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold, ['value', 'unit'], name, value)


                                                                        class ResumeThreshold(Entity):
                                                                            """
                                                                            resume threshold
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold, self).__init__()

                                                                                self.yang_name = "resume-threshold"
                                                                                self.yang_parent_name = "pfc"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "resume-threshold"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold, ['value', 'unit'], name, value)


                                                                    class FlowParm(Entity):
                                                                        """
                                                                        flow parm
                                                                        
                                                                        .. attribute:: max_mon_flows
                                                                        
                                                                        	max simult flows monitored per policy class
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: mon_interval
                                                                        
                                                                        	monitored interval duration in secs
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: second
                                                                        
                                                                        .. attribute:: intvl_hist
                                                                        
                                                                        	num intervals of data stored on rtr
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: flow_timeout
                                                                        
                                                                        	timeout in secs
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: second
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm, self).__init__()

                                                                            self.yang_name = "flow-parm"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('max_mon_flows', (YLeaf(YType.uint32, 'max-mon-flows'), ['int'])),
                                                                                ('mon_interval', (YLeaf(YType.uint32, 'mon-interval'), ['int'])),
                                                                                ('intvl_hist', (YLeaf(YType.uint32, 'intvl-hist'), ['int'])),
                                                                                ('flow_timeout', (YLeaf(YType.uint32, 'flow-timeout'), ['int'])),
                                                                            ])
                                                                            self.max_mon_flows = None
                                                                            self.mon_interval = None
                                                                            self.intvl_hist = None
                                                                            self.flow_timeout = None
                                                                            self._segment_path = lambda: "flow-parm"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm, ['max_mon_flows', 'mon_interval', 'intvl_hist', 'flow_timeout'], name, value)


                                                                    class Ipcbr(Entity):
                                                                        """
                                                                        ipcbr
                                                                        
                                                                        .. attribute:: ip_bit_rate
                                                                        
                                                                        	data rate in bps
                                                                        	**type**\:  :py:class:`IpBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate>`
                                                                        
                                                                        .. attribute:: media_bit_rate
                                                                        
                                                                        	media data rate in bps
                                                                        	**type**\:  :py:class:`MediaBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate>`
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: ip_pkt_rate
                                                                        
                                                                        	packet rate in pps
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: media_pkt_size
                                                                        
                                                                        	media packet size in bytes
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: media_pkts_per_ip
                                                                        
                                                                        	media packets per ip pkt
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr, self).__init__()

                                                                            self.yang_name = "ipcbr"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("ip-bit-rate", ("ip_bit_rate", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate)), ("media-bit-rate", ("media_bit_rate", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate))])
                                                                            self._leafs = OrderedDict([
                                                                                ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                                ('ip_pkt_rate', (YLeaf(YType.uint32, 'ip-pkt-rate'), ['int'])),
                                                                                ('media_pkt_size', (YLeaf(YType.uint32, 'media-pkt-size'), ['int'])),
                                                                                ('media_pkts_per_ip', (YLeaf(YType.uint32, 'media-pkts-per-ip'), ['int'])),
                                                                            ])
                                                                            self.action_metric_type = None
                                                                            self.ip_pkt_rate = None
                                                                            self.media_pkt_size = None
                                                                            self.media_pkts_per_ip = None

                                                                            self.ip_bit_rate = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate()
                                                                            self.ip_bit_rate.parent = self
                                                                            self._children_name_map["ip_bit_rate"] = "ip-bit-rate"

                                                                            self.media_bit_rate = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate()
                                                                            self.media_bit_rate.parent = self
                                                                            self._children_name_map["media_bit_rate"] = "media-bit-rate"
                                                                            self._segment_path = lambda: "ipcbr"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr, ['action_metric_type', 'ip_pkt_rate', 'media_pkt_size', 'media_pkts_per_ip'], name, value)


                                                                        class IpBitRate(Entity):
                                                                            """
                                                                            data rate in bps
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate, self).__init__()

                                                                                self.yang_name = "ip-bit-rate"
                                                                                self.yang_parent_name = "ipcbr"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "ip-bit-rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate, ['value', 'unit'], name, value)


                                                                        class MediaBitRate(Entity):
                                                                            """
                                                                            media data rate in bps
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate, self).__init__()

                                                                                self.yang_name = "media-bit-rate"
                                                                                self.yang_parent_name = "ipcbr"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "media-bit-rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate, ['value', 'unit'], name, value)


                                                                    class Rtp(Entity):
                                                                        """
                                                                        rtp
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: min_sequential
                                                                        
                                                                        	min sequential
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_dropout
                                                                        
                                                                        	max dropout
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_misorder
                                                                        
                                                                        	max misorder
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: seq_ext_cop4
                                                                        
                                                                        	enable seq extension cop4
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: clock_rate
                                                                        
                                                                        	clock rate
                                                                        	**type**\: list of  		 :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp, self).__init__()

                                                                            self.yang_name = "rtp"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("clock-rate", ("clock_rate", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate))])
                                                                            self._leafs = OrderedDict([
                                                                                ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                                ('min_sequential', (YLeaf(YType.uint32, 'min-sequential'), ['int'])),
                                                                                ('max_dropout', (YLeaf(YType.uint32, 'max-dropout'), ['int'])),
                                                                                ('max_misorder', (YLeaf(YType.uint32, 'max-misorder'), ['int'])),
                                                                                ('seq_ext_cop4', (YLeaf(YType.uint32, 'seq-ext-cop4'), ['int'])),
                                                                            ])
                                                                            self.action_metric_type = None
                                                                            self.min_sequential = None
                                                                            self.max_dropout = None
                                                                            self.max_misorder = None
                                                                            self.seq_ext_cop4 = None

                                                                            self.clock_rate = YList(self)
                                                                            self._segment_path = lambda: "rtp"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp, ['action_metric_type', 'min_sequential', 'max_dropout', 'max_misorder', 'seq_ext_cop4'], name, value)


                                                                        class ClockRate(Entity):
                                                                            """
                                                                            clock rate
                                                                            
                                                                            .. attribute:: pt
                                                                            
                                                                            	pt
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: frequency
                                                                            
                                                                            	frequency
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate, self).__init__()

                                                                                self.yang_name = "clock-rate"
                                                                                self.yang_parent_name = "rtp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('pt', (YLeaf(YType.uint32, 'pt'), ['int'])),
                                                                                    ('frequency', (YLeaf(YType.uint32, 'frequency'), ['int'])),
                                                                                ])
                                                                                self.pt = None
                                                                                self.frequency = None
                                                                                self._segment_path = lambda: "clock-rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate, ['pt', 'frequency'], name, value)


                                                                    class RtpMmr(Entity):
                                                                        """
                                                                        rtp mmr
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: min_sequential
                                                                        
                                                                        	min sequential
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_dropout
                                                                        
                                                                        	max dropout
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_misorder
                                                                        
                                                                        	max misorder
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: seq_ext_cop4
                                                                        
                                                                        	enable seq extension cop4
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: clock_rate
                                                                        
                                                                        	clock rate
                                                                        	**type**\: list of  		 :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr, self).__init__()

                                                                            self.yang_name = "rtp-mmr"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("clock-rate", ("clock_rate", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate))])
                                                                            self._leafs = OrderedDict([
                                                                                ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                                ('min_sequential', (YLeaf(YType.uint32, 'min-sequential'), ['int'])),
                                                                                ('max_dropout', (YLeaf(YType.uint32, 'max-dropout'), ['int'])),
                                                                                ('max_misorder', (YLeaf(YType.uint32, 'max-misorder'), ['int'])),
                                                                                ('seq_ext_cop4', (YLeaf(YType.uint32, 'seq-ext-cop4'), ['int'])),
                                                                            ])
                                                                            self.action_metric_type = None
                                                                            self.min_sequential = None
                                                                            self.max_dropout = None
                                                                            self.max_misorder = None
                                                                            self.seq_ext_cop4 = None

                                                                            self.clock_rate = YList(self)
                                                                            self._segment_path = lambda: "rtp-mmr"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr, ['action_metric_type', 'min_sequential', 'max_dropout', 'max_misorder', 'seq_ext_cop4'], name, value)


                                                                        class ClockRate(Entity):
                                                                            """
                                                                            clock rate
                                                                            
                                                                            .. attribute:: pt
                                                                            
                                                                            	pt
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: frequency
                                                                            
                                                                            	frequency
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate, self).__init__()

                                                                                self.yang_name = "clock-rate"
                                                                                self.yang_parent_name = "rtp-mmr"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('pt', (YLeaf(YType.uint32, 'pt'), ['int'])),
                                                                                    ('frequency', (YLeaf(YType.uint32, 'frequency'), ['int'])),
                                                                                ])
                                                                                self.pt = None
                                                                                self.frequency = None
                                                                                self._segment_path = lambda: "clock-rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate, ['pt', 'frequency'], name, value)


                                                                    class RtpJ2k(Entity):
                                                                        """
                                                                        rtp j2k
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: min_sequential
                                                                        
                                                                        	min sequential
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_dropout
                                                                        
                                                                        	max dropout
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_misorder
                                                                        
                                                                        	max misorder
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: seq_ext_cop4
                                                                        
                                                                        	enable seq extension cop4
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: clock_rate
                                                                        
                                                                        	clock rate
                                                                        	**type**\: list of  		 :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k.ClockRate>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k, self).__init__()

                                                                            self.yang_name = "rtp-j2k"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("clock-rate", ("clock_rate", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k.ClockRate))])
                                                                            self._leafs = OrderedDict([
                                                                                ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                                ('min_sequential', (YLeaf(YType.uint32, 'min-sequential'), ['int'])),
                                                                                ('max_dropout', (YLeaf(YType.uint32, 'max-dropout'), ['int'])),
                                                                                ('max_misorder', (YLeaf(YType.uint32, 'max-misorder'), ['int'])),
                                                                                ('seq_ext_cop4', (YLeaf(YType.uint32, 'seq-ext-cop4'), ['int'])),
                                                                            ])
                                                                            self.action_metric_type = None
                                                                            self.min_sequential = None
                                                                            self.max_dropout = None
                                                                            self.max_misorder = None
                                                                            self.seq_ext_cop4 = None

                                                                            self.clock_rate = YList(self)
                                                                            self._segment_path = lambda: "rtp-j2k"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k, ['action_metric_type', 'min_sequential', 'max_dropout', 'max_misorder', 'seq_ext_cop4'], name, value)


                                                                        class ClockRate(Entity):
                                                                            """
                                                                            clock rate
                                                                            
                                                                            .. attribute:: pt
                                                                            
                                                                            	pt
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: frequency
                                                                            
                                                                            	frequency
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k.ClockRate, self).__init__()

                                                                                self.yang_name = "clock-rate"
                                                                                self.yang_parent_name = "rtp-j2k"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('pt', (YLeaf(YType.uint32, 'pt'), ['int'])),
                                                                                    ('frequency', (YLeaf(YType.uint32, 'frequency'), ['int'])),
                                                                                ])
                                                                                self.pt = None
                                                                                self.frequency = None
                                                                                self._segment_path = lambda: "clock-rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k.ClockRate, ['pt', 'frequency'], name, value)


                                                                    class RtpVoice(Entity):
                                                                        """
                                                                        rtp voice
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: min_sequential
                                                                        
                                                                        	min sequential
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_dropout
                                                                        
                                                                        	max dropout
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_misorder
                                                                        
                                                                        	max misorder
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: seq_ext_cop4
                                                                        
                                                                        	enable seq extension cop4
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: clock_rate
                                                                        
                                                                        	clock rate
                                                                        	**type**\: list of  		 :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice, self).__init__()

                                                                            self.yang_name = "rtp-voice"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("clock-rate", ("clock_rate", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate))])
                                                                            self._leafs = OrderedDict([
                                                                                ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                                ('min_sequential', (YLeaf(YType.uint32, 'min-sequential'), ['int'])),
                                                                                ('max_dropout', (YLeaf(YType.uint32, 'max-dropout'), ['int'])),
                                                                                ('max_misorder', (YLeaf(YType.uint32, 'max-misorder'), ['int'])),
                                                                                ('seq_ext_cop4', (YLeaf(YType.uint32, 'seq-ext-cop4'), ['int'])),
                                                                            ])
                                                                            self.action_metric_type = None
                                                                            self.min_sequential = None
                                                                            self.max_dropout = None
                                                                            self.max_misorder = None
                                                                            self.seq_ext_cop4 = None

                                                                            self.clock_rate = YList(self)
                                                                            self._segment_path = lambda: "rtp-voice"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice, ['action_metric_type', 'min_sequential', 'max_dropout', 'max_misorder', 'seq_ext_cop4'], name, value)


                                                                        class ClockRate(Entity):
                                                                            """
                                                                            clock rate
                                                                            
                                                                            .. attribute:: pt
                                                                            
                                                                            	pt
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: frequency
                                                                            
                                                                            	frequency
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate, self).__init__()

                                                                                self.yang_name = "clock-rate"
                                                                                self.yang_parent_name = "rtp-voice"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('pt', (YLeaf(YType.uint32, 'pt'), ['int'])),
                                                                                    ('frequency', (YLeaf(YType.uint32, 'frequency'), ['int'])),
                                                                                ])
                                                                                self.pt = None
                                                                                self.frequency = None
                                                                                self._segment_path = lambda: "clock-rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate, ['pt', 'frequency'], name, value)


                                                                    class Mdi(Entity):
                                                                        """
                                                                        mdi
                                                                        
                                                                        .. attribute:: ip_bit_rate
                                                                        
                                                                        	data rate in bps
                                                                        	**type**\:  :py:class:`IpBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate>`
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: filtered_pkt_rate
                                                                        
                                                                        	filtered packet rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: ip_pkt_rate
                                                                        
                                                                        	packet rate in pps
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: pids
                                                                        
                                                                        	array of monitoredcd  pids
                                                                        	**type**\: list of int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi, self).__init__()

                                                                            self.yang_name = "mdi"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("ip-bit-rate", ("ip_bit_rate", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate))])
                                                                            self._leafs = OrderedDict([
                                                                                ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                                ('filtered_pkt_rate', (YLeaf(YType.uint32, 'filtered-pkt-rate'), ['int'])),
                                                                                ('ip_pkt_rate', (YLeaf(YType.uint32, 'ip-pkt-rate'), ['int'])),
                                                                                ('pids', (YLeafList(YType.uint32, 'pids'), ['int'])),
                                                                            ])
                                                                            self.action_metric_type = None
                                                                            self.filtered_pkt_rate = None
                                                                            self.ip_pkt_rate = None
                                                                            self.pids = []

                                                                            self.ip_bit_rate = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate()
                                                                            self.ip_bit_rate.parent = self
                                                                            self._children_name_map["ip_bit_rate"] = "ip-bit-rate"
                                                                            self._segment_path = lambda: "mdi"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi, ['action_metric_type', 'filtered_pkt_rate', 'ip_pkt_rate', 'pids'], name, value)


                                                                        class IpBitRate(Entity):
                                                                            """
                                                                            data rate in bps
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate, self).__init__()

                                                                                self.yang_name = "ip-bit-rate"
                                                                                self.yang_parent_name = "mdi"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "ip-bit-rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate, ['value', 'unit'], name, value)


                                                                    class MdiRtp(Entity):
                                                                        """
                                                                        mdi rtp
                                                                        
                                                                        .. attribute:: ip_bit_rate
                                                                        
                                                                        	data rate in bps
                                                                        	**type**\:  :py:class:`IpBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate>`
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: filtered_pkt_rate
                                                                        
                                                                        	filtered packet rate
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: ip_pkt_rate
                                                                        
                                                                        	packet rate in pps
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: pids
                                                                        
                                                                        	array of monitoredcd  pids
                                                                        	**type**\: list of int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp, self).__init__()

                                                                            self.yang_name = "mdi-rtp"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("ip-bit-rate", ("ip_bit_rate", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate))])
                                                                            self._leafs = OrderedDict([
                                                                                ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                                ('filtered_pkt_rate', (YLeaf(YType.uint32, 'filtered-pkt-rate'), ['int'])),
                                                                                ('ip_pkt_rate', (YLeaf(YType.uint32, 'ip-pkt-rate'), ['int'])),
                                                                                ('pids', (YLeafList(YType.uint32, 'pids'), ['int'])),
                                                                            ])
                                                                            self.action_metric_type = None
                                                                            self.filtered_pkt_rate = None
                                                                            self.ip_pkt_rate = None
                                                                            self.pids = []

                                                                            self.ip_bit_rate = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate()
                                                                            self.ip_bit_rate.parent = self
                                                                            self._children_name_map["ip_bit_rate"] = "ip-bit-rate"
                                                                            self._segment_path = lambda: "mdi-rtp"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp, ['action_metric_type', 'filtered_pkt_rate', 'ip_pkt_rate', 'pids'], name, value)


                                                                        class IpBitRate(Entity):
                                                                            """
                                                                            data rate in bps
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate, self).__init__()

                                                                                self.yang_name = "ip-bit-rate"
                                                                                self.yang_parent_name = "mdi-rtp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "ip-bit-rate"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate, ['value', 'unit'], name, value)


                                                                    class Fmm(Entity):
                                                                        """
                                                                        fmm
                                                                        
                                                                        .. attribute:: fmm_name
                                                                        
                                                                        	flow monitor name
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..33
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm, self).__init__()

                                                                            self.yang_name = "fmm"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('fmm_name', (YLeaf(YType.str, 'fmm-name'), ['str'])),
                                                                            ])
                                                                            self.fmm_name = None
                                                                            self._segment_path = lambda: "fmm"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm, ['fmm_name'], name, value)


                                                                    class Pbf(Entity):
                                                                        """
                                                                        pbf
                                                                        
                                                                        .. attribute:: action_pbf_info_array
                                                                        
                                                                        	action pbf info array
                                                                        	**type**\: list of  		 :py:class:`ActionPbfInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf, self).__init__()

                                                                            self.yang_name = "pbf"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("action-pbf-info-array", ("action_pbf_info_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.action_pbf_info_array = YList(self)
                                                                            self._segment_path = lambda: "pbf"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf, [], name, value)


                                                                        class ActionPbfInfoArray(Entity):
                                                                            """
                                                                            action pbf info array
                                                                            
                                                                            .. attribute:: addr
                                                                            
                                                                            	v4 or v6 address
                                                                            	**type**\: str
                                                                            
                                                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                            
                                                                            .. attribute:: vrf
                                                                            
                                                                            	vrf name
                                                                            	**type**\: str
                                                                            
                                                                            .. attribute:: rt_type
                                                                            
                                                                            	route target type
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: rt
                                                                            
                                                                            	route target
                                                                            	**type**\: str
                                                                            
                                                                            	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray, self).__init__()

                                                                                self.yang_name = "action-pbf-info-array"
                                                                                self.yang_parent_name = "pbf"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('addr', (YLeaf(YType.str, 'addr'), ['str'])),
                                                                                    ('vrf', (YLeaf(YType.str, 'vrf'), ['str'])),
                                                                                    ('rt_type', (YLeaf(YType.uint8, 'rt-type'), ['int'])),
                                                                                    ('rt', (YLeaf(YType.str, 'rt'), ['str'])),
                                                                                ])
                                                                                self.addr = None
                                                                                self.vrf = None
                                                                                self.rt_type = None
                                                                                self.rt = None
                                                                                self._segment_path = lambda: "action-pbf-info-array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray, ['addr', 'vrf', 'rt_type', 'rt'], name, value)


                                                                    class Ipv4Nh(Entity):
                                                                        """
                                                                        ipv4 nh
                                                                        
                                                                        .. attribute:: action_ipv4_nh_info_array
                                                                        
                                                                        	action ipv4 nh info array
                                                                        	**type**\: list of  		 :py:class:`ActionIpv4NhInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh, self).__init__()

                                                                            self.yang_name = "ipv4-nh"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("action-ipv4-nh-info-array", ("action_ipv4_nh_info_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.action_ipv4_nh_info_array = YList(self)
                                                                            self._segment_path = lambda: "ipv4-nh"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh, [], name, value)


                                                                        class ActionIpv4NhInfoArray(Entity):
                                                                            """
                                                                            action ipv4 nh info array
                                                                            
                                                                            .. attribute:: nh_addr
                                                                            
                                                                            	nh addr
                                                                            	**type**\: str
                                                                            
                                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                            
                                                                            .. attribute:: vrf_name
                                                                            
                                                                            	Vrf name
                                                                            	**type**\: str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray, self).__init__()

                                                                                self.yang_name = "action-ipv4-nh-info-array"
                                                                                self.yang_parent_name = "ipv4-nh"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('nh_addr', (YLeaf(YType.str, 'nh-addr'), ['str'])),
                                                                                    ('vrf_name', (YLeaf(YType.str, 'vrf-name'), ['str'])),
                                                                                ])
                                                                                self.nh_addr = None
                                                                                self.vrf_name = None
                                                                                self._segment_path = lambda: "action-ipv4-nh-info-array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray, ['nh_addr', 'vrf_name'], name, value)


                                                                    class Ipv6Nh(Entity):
                                                                        """
                                                                        ipv6 nh
                                                                        
                                                                        .. attribute:: action_ipv6_nh_info_array
                                                                        
                                                                        	action ipv6 nh info array
                                                                        	**type**\: list of  		 :py:class:`ActionIpv6NhInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh, self).__init__()

                                                                            self.yang_name = "ipv6-nh"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("action-ipv6-nh-info-array", ("action_ipv6_nh_info_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.action_ipv6_nh_info_array = YList(self)
                                                                            self._segment_path = lambda: "ipv6-nh"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh, [], name, value)


                                                                        class ActionIpv6NhInfoArray(Entity):
                                                                            """
                                                                            action ipv6 nh info array
                                                                            
                                                                            .. attribute:: nh_addr
                                                                            
                                                                            	IPV6 Address
                                                                            	**type**\: str
                                                                            
                                                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                            
                                                                            .. attribute:: vrf_name
                                                                            
                                                                            	Vrf name
                                                                            	**type**\: str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray, self).__init__()

                                                                                self.yang_name = "action-ipv6-nh-info-array"
                                                                                self.yang_parent_name = "ipv6-nh"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('nh_addr', (YLeaf(YType.str, 'nh-addr'), ['str'])),
                                                                                    ('vrf_name', (YLeaf(YType.str, 'vrf-name'), ['str'])),
                                                                                ])
                                                                                self.nh_addr = None
                                                                                self.vrf_name = None
                                                                                self._segment_path = lambda: "action-ipv6-nh-info-array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray, ['nh_addr', 'vrf_name'], name, value)


                class PolicyMapUnusedTypes(Entity):
                    """
                    Policy\-map unused table
                    
                    .. attribute:: policy_map_unused_type
                    
                    	Policy\-map unused
                    	**type**\: list of  		 :py:class:`PolicyMapUnusedType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType>`
                    
                    

                    """

                    _prefix = 'infra-policymgr-oper'
                    _revision = '2018-01-17'

                    def __init__(self):
                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapUnusedTypes, self).__init__()

                        self.yang_name = "policy-map-unused-types"
                        self.yang_parent_name = "policy-map"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("policy-map-unused-type", ("policy_map_unused_type", PolicyManager.Nodes.Node.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType))])
                        self._leafs = OrderedDict()

                        self.policy_map_unused_type = YList(self)
                        self._segment_path = lambda: "policy-map-unused-types"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapUnusedTypes, [], name, value)


                    class PolicyMapUnusedType(Entity):
                        """
                        Policy\-map unused
                        
                        .. attribute:: type  (key)
                        
                        	The application type
                        	**type**\:  :py:class:`PolicymgrPolicyMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicymgrPolicyMap>`
                        
                        .. attribute:: unuseds
                        
                        	Policy\-map unused
                        	**type**\:  :py:class:`Unuseds <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds>`
                        
                        

                        """

                        _prefix = 'infra-policymgr-oper'
                        _revision = '2018-01-17'

                        def __init__(self):
                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType, self).__init__()

                            self.yang_name = "policy-map-unused-type"
                            self.yang_parent_name = "policy-map-unused-types"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = ['type']
                            self._child_classes = OrderedDict([("unuseds", ("unuseds", PolicyManager.Nodes.Node.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds))])
                            self._leafs = OrderedDict([
                                ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicymgrPolicyMap', '')])),
                            ])
                            self.type = None

                            self.unuseds = PolicyManager.Nodes.Node.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds()
                            self.unuseds.parent = self
                            self._children_name_map["unuseds"] = "unuseds"
                            self._segment_path = lambda: "policy-map-unused-type" + "[type='" + str(self.type) + "']"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType, ['type'], name, value)


                        class Unuseds(Entity):
                            """
                            Policy\-map unused
                            
                            .. attribute:: unused
                            
                            	Policy\-map unused information
                            	**type**\: list of  		 :py:class:`Unused <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused>`
                            
                            

                            """

                            _prefix = 'infra-policymgr-oper'
                            _revision = '2018-01-17'

                            def __init__(self):
                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds, self).__init__()

                                self.yang_name = "unuseds"
                                self.yang_parent_name = "policy-map-unused-type"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("unused", ("unused", PolicyManager.Nodes.Node.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused))])
                                self._leafs = OrderedDict()

                                self.unused = YList(self)
                                self._segment_path = lambda: "unuseds"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds, [], name, value)


                            class Unused(Entity):
                                """
                                Policy\-map unused information
                                
                                .. attribute:: policy_map_name  (key)
                                
                                	Name of policy\-map
                                	**type**\: str
                                
                                	**length:** 1..63
                                
                                .. attribute:: object_type
                                
                                	Application type configured
                                	**type**\:  :py:class:`PlmgrApplnTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrApplnTypeEn>`
                                
                                .. attribute:: total_objects
                                
                                	Total number of objects configured for a specific object type
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: transient
                                
                                	Transient object
                                	**type**\: bool
                                
                                .. attribute:: reference
                                
                                	Each Policymap details
                                	**type**\: list of  		 :py:class:`Reference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused.Reference>`
                                
                                .. attribute:: objects
                                
                                	Each object details
                                	**type**\: list of  		 :py:class:`Objects <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused.Objects>`
                                
                                .. attribute:: class_map_reference
                                
                                	Each Classmapdetails
                                	**type**\: list of  		 :py:class:`ClassMapReference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused.ClassMapReference>`
                                
                                

                                """

                                _prefix = 'infra-policymgr-oper'
                                _revision = '2018-01-17'

                                def __init__(self):
                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused, self).__init__()

                                    self.yang_name = "unused"
                                    self.yang_parent_name = "unuseds"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = ['policy_map_name']
                                    self._child_classes = OrderedDict([("reference", ("reference", PolicyManager.Nodes.Node.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused.Reference)), ("objects", ("objects", PolicyManager.Nodes.Node.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused.Objects)), ("class-map-reference", ("class_map_reference", PolicyManager.Nodes.Node.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused.ClassMapReference))])
                                    self._leafs = OrderedDict([
                                        ('policy_map_name', (YLeaf(YType.str, 'policy-map-name'), ['str'])),
                                        ('object_type', (YLeaf(YType.enumeration, 'object-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PlmgrApplnTypeEn', '')])),
                                        ('total_objects', (YLeaf(YType.uint32, 'total-objects'), ['int'])),
                                        ('transient', (YLeaf(YType.boolean, 'transient'), ['bool'])),
                                    ])
                                    self.policy_map_name = None
                                    self.object_type = None
                                    self.total_objects = None
                                    self.transient = None

                                    self.reference = YList(self)
                                    self.objects = YList(self)
                                    self.class_map_reference = YList(self)
                                    self._segment_path = lambda: "unused" + "[policy-map-name='" + str(self.policy_map_name) + "']"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused, ['policy_map_name', 'object_type', 'total_objects', 'transient'], name, value)


                                class Reference(Entity):
                                    """
                                    Each Policymap details
                                    
                                    .. attribute:: total_internal_reference_objects
                                    
                                    	Total number of internal reference objects
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: total_class_maps
                                    
                                    	Total number of Classmaps in a Policymap
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: total_flows
                                    
                                    	Total flows in a Policymap
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2018-01-17'

                                    def __init__(self):
                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused.Reference, self).__init__()

                                        self.yang_name = "reference"
                                        self.yang_parent_name = "unused"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('total_internal_reference_objects', (YLeaf(YType.uint32, 'total-internal-reference-objects'), ['int'])),
                                            ('total_class_maps', (YLeaf(YType.uint32, 'total-class-maps'), ['int'])),
                                            ('total_flows', (YLeaf(YType.uint32, 'total-flows'), ['int'])),
                                        ])
                                        self.total_internal_reference_objects = None
                                        self.total_class_maps = None
                                        self.total_flows = None
                                        self._segment_path = lambda: "reference"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused.Reference, ['total_internal_reference_objects', 'total_class_maps', 'total_flows'], name, value)


                                class Objects(Entity):
                                    """
                                    Each object details
                                    
                                    .. attribute:: object_name
                                    
                                    	Name of object (Policymap/Classmap)
                                    	**type**\: str
                                    
                                    	**length:** 0..64
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2018-01-17'

                                    def __init__(self):
                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused.Objects, self).__init__()

                                        self.yang_name = "objects"
                                        self.yang_parent_name = "unused"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('object_name', (YLeaf(YType.str, 'object-name'), ['str'])),
                                        ])
                                        self.object_name = None
                                        self._segment_path = lambda: "objects"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused.Objects, ['object_name'], name, value)


                                class ClassMapReference(Entity):
                                    """
                                    Each Classmapdetails
                                    
                                    .. attribute:: total_reference_objects
                                    
                                    	Total number of Policymaps referencing a Classmap
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: policy_map_reference
                                    
                                    	List of Policymaps referencing a Classmap
                                    	**type**\: list of  		 :py:class:`PolicyMapReference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused.ClassMapReference.PolicyMapReference>`
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2018-01-17'

                                    def __init__(self):
                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused.ClassMapReference, self).__init__()

                                        self.yang_name = "class-map-reference"
                                        self.yang_parent_name = "unused"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("policy-map-reference", ("policy_map_reference", PolicyManager.Nodes.Node.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused.ClassMapReference.PolicyMapReference))])
                                        self._leafs = OrderedDict([
                                            ('total_reference_objects', (YLeaf(YType.uint32, 'total-reference-objects'), ['int'])),
                                        ])
                                        self.total_reference_objects = None

                                        self.policy_map_reference = YList(self)
                                        self._segment_path = lambda: "class-map-reference"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused.ClassMapReference, ['total_reference_objects'], name, value)


                                    class PolicyMapReference(Entity):
                                        """
                                        List of Policymaps referencing a Classmap
                                        
                                        .. attribute:: object_type
                                        
                                        	Application type configured
                                        	**type**\:  :py:class:`PlmgrApplnTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrApplnTypeEn>`
                                        
                                        .. attribute:: policy_map_name
                                        
                                        	Name of Policymap referencing a Classmap
                                        	**type**\: str
                                        
                                        	**length:** 0..64
                                        
                                        

                                        """

                                        _prefix = 'infra-policymgr-oper'
                                        _revision = '2018-01-17'

                                        def __init__(self):
                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused.ClassMapReference.PolicyMapReference, self).__init__()

                                            self.yang_name = "policy-map-reference"
                                            self.yang_parent_name = "class-map-reference"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('object_type', (YLeaf(YType.enumeration, 'object-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PlmgrApplnTypeEn', '')])),
                                                ('policy_map_name', (YLeaf(YType.str, 'policy-map-name'), ['str'])),
                                            ])
                                            self.object_type = None
                                            self.policy_map_name = None
                                            self._segment_path = lambda: "policy-map-reference"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused.ClassMapReference.PolicyMapReference, ['object_type', 'policy_map_name'], name, value)


                class PolicyMapTypes(Entity):
                    """
                    Application type of a policymap
                    
                    .. attribute:: policy_map_type
                    
                    	Policymgr application type
                    	**type**\: list of  		 :py:class:`PolicyMapType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType>`
                    
                    

                    """

                    _prefix = 'infra-policymgr-oper'
                    _revision = '2018-01-17'

                    def __init__(self):
                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes, self).__init__()

                        self.yang_name = "policy-map-types"
                        self.yang_parent_name = "policy-map"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("policy-map-type", ("policy_map_type", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType))])
                        self._leafs = OrderedDict()

                        self.policy_map_type = YList(self)
                        self._segment_path = lambda: "policy-map-types"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes, [], name, value)


                    class PolicyMapType(Entity):
                        """
                        Policymgr application type
                        
                        .. attribute:: type  (key)
                        
                        	The application type
                        	**type**\:  :py:class:`PolicymgrPolicyMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicymgrPolicyMap>`
                        
                        .. attribute:: policy_maps
                        
                        	Policy\-map definition table
                        	**type**\:  :py:class:`PolicyMaps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps>`
                        
                        .. attribute:: policy_map_details
                        
                        	Policy\-map table
                        	**type**\:  :py:class:`PolicyMapDetails <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails>`
                        
                        

                        """

                        _prefix = 'infra-policymgr-oper'
                        _revision = '2018-01-17'

                        def __init__(self):
                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType, self).__init__()

                            self.yang_name = "policy-map-type"
                            self.yang_parent_name = "policy-map-types"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = ['type']
                            self._child_classes = OrderedDict([("policy-maps", ("policy_maps", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps)), ("policy-map-details", ("policy_map_details", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails))])
                            self._leafs = OrderedDict([
                                ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicymgrPolicyMap', '')])),
                            ])
                            self.type = None

                            self.policy_maps = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps()
                            self.policy_maps.parent = self
                            self._children_name_map["policy_maps"] = "policy-maps"

                            self.policy_map_details = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails()
                            self.policy_map_details.parent = self
                            self._children_name_map["policy_map_details"] = "policy-map-details"
                            self._segment_path = lambda: "policy-map-type" + "[type='" + str(self.type) + "']"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType, ['type'], name, value)


                        class PolicyMaps(Entity):
                            """
                            Policy\-map definition table
                            
                            .. attribute:: policy_map
                            
                            	Policy\-map configuration
                            	**type**\: list of  		 :py:class:`PolicyMap_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_>`
                            
                            

                            """

                            _prefix = 'infra-policymgr-oper'
                            _revision = '2018-01-17'

                            def __init__(self):
                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps, self).__init__()

                                self.yang_name = "policy-maps"
                                self.yang_parent_name = "policy-map-type"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("policy-map", ("policy_map", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_))])
                                self._leafs = OrderedDict()

                                self.policy_map = YList(self)
                                self._segment_path = lambda: "policy-maps"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps, [], name, value)


                            class PolicyMap_(Entity):
                                """
                                Policy\-map configuration
                                
                                .. attribute:: policy_map_name  (key)
                                
                                	Name of policy\-map
                                	**type**\: str
                                
                                	**length:** 1..63
                                
                                .. attribute:: policy_map_bg
                                
                                	policy map bg
                                	**type**\: list of  		 :py:class:`PolicyMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg>`
                                
                                

                                """

                                _prefix = 'infra-policymgr-oper'
                                _revision = '2018-01-17'

                                def __init__(self):
                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_, self).__init__()

                                    self.yang_name = "policy-map"
                                    self.yang_parent_name = "policy-maps"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = ['policy_map_name']
                                    self._child_classes = OrderedDict([("policy-map-bg", ("policy_map_bg", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg))])
                                    self._leafs = OrderedDict([
                                        ('policy_map_name', (YLeaf(YType.str, 'policy-map-name'), ['str'])),
                                    ])
                                    self.policy_map_name = None

                                    self.policy_map_bg = YList(self)
                                    self._segment_path = lambda: "policy-map" + "[policy-map-name='" + str(self.policy_map_name) + "']"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_, ['policy_map_name'], name, value)


                                class PolicyMapBg(Entity):
                                    """
                                    policy map bg
                                    
                                    .. attribute:: pmap_var_list
                                    
                                    	pmap var list
                                    	**type**\:  :py:class:`PmapVarList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.PmapVarList>`
                                    
                                    .. attribute:: event_infop
                                    
                                    	event infop
                                    	**type**\:  :py:class:`EventInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop>`
                                    
                                    .. attribute:: name
                                    
                                    	name
                                    	**type**\: str
                                    
                                    	**length:** 0..65
                                    
                                    .. attribute:: type
                                    
                                    	type
                                    	**type**\:  :py:class:`PolicyMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyMapTypeEn>`
                                    
                                    .. attribute:: description
                                    
                                    	description
                                    	**type**\: str
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2018-01-17'

                                    def __init__(self):
                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg, self).__init__()

                                        self.yang_name = "policy-map-bg"
                                        self.yang_parent_name = "policy-map"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("pmap-var-list", ("pmap_var_list", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.PmapVarList)), ("event-infop", ("event_infop", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop))])
                                        self._leafs = OrderedDict([
                                            ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyMapTypeEn', '')])),
                                            ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                        ])
                                        self.name = None
                                        self.type = None
                                        self.description = None

                                        self.pmap_var_list = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.PmapVarList()
                                        self.pmap_var_list.parent = self
                                        self._children_name_map["pmap_var_list"] = "pmap-var-list"

                                        self.event_infop = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop()
                                        self.event_infop.parent = self
                                        self._children_name_map["event_infop"] = "event-infop"
                                        self._segment_path = lambda: "policy-map-bg"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg, ['name', 'type', 'description'], name, value)


                                    class PmapVarList(Entity):
                                        """
                                        pmap var list
                                        
                                        .. attribute:: pmap_var_list_arr
                                        
                                        	pmap var list arr
                                        	**type**\: list of  		 :py:class:`PmapVarListArr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.PmapVarList.PmapVarListArr>`
                                        
                                        

                                        """

                                        _prefix = 'infra-policymgr-oper'
                                        _revision = '2018-01-17'

                                        def __init__(self):
                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.PmapVarList, self).__init__()

                                            self.yang_name = "pmap-var-list"
                                            self.yang_parent_name = "policy-map-bg"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("pmap-var-list-arr", ("pmap_var_list_arr", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.PmapVarList.PmapVarListArr))])
                                            self._leafs = OrderedDict()

                                            self.pmap_var_list_arr = YList(self)
                                            self._segment_path = lambda: "pmap-var-list"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.PmapVarList, [], name, value)


                                        class PmapVarListArr(Entity):
                                            """
                                            pmap var list arr
                                            
                                            .. attribute:: val
                                            
                                            	val
                                            	**type**\:  :py:class:`Val <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.PmapVarList.PmapVarListArr.Val>`
                                            
                                            .. attribute:: name
                                            
                                            	name
                                            	**type**\: str
                                            
                                            	**length:** 0..32
                                            
                                            .. attribute:: id
                                            
                                            	id
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'infra-policymgr-oper'
                                            _revision = '2018-01-17'

                                            def __init__(self):
                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.PmapVarList.PmapVarListArr, self).__init__()

                                                self.yang_name = "pmap-var-list-arr"
                                                self.yang_parent_name = "pmap-var-list"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("val", ("val", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.PmapVarList.PmapVarListArr.Val))])
                                                self._leafs = OrderedDict([
                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                    ('id', (YLeaf(YType.uint32, 'id'), ['int'])),
                                                ])
                                                self.name = None
                                                self.id = None

                                                self.val = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.PmapVarList.PmapVarListArr.Val()
                                                self.val.parent = self
                                                self._children_name_map["val"] = "val"
                                                self._segment_path = lambda: "pmap-var-list-arr"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.PmapVarList.PmapVarListArr, ['name', 'id'], name, value)


                                            class Val(Entity):
                                                """
                                                val
                                                
                                                .. attribute:: type
                                                
                                                	type
                                                	**type**\:  :py:class:`PlmgrVarTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrVarTypeEn>`
                                                
                                                .. attribute:: class_name
                                                
                                                	class name
                                                	**type**\: str
                                                
                                                	**length:** 0..65
                                                
                                                .. attribute:: uint8_val
                                                
                                                	uint8 val
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: uint16_val
                                                
                                                	uint16 val
                                                	**type**\: int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: uint32_val
                                                
                                                	uint32 val
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: param_uint32_val
                                                
                                                	param uint32 val
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: dscp_val
                                                
                                                	dscp val
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: prec_val
                                                
                                                	prec val
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.PmapVarList.PmapVarListArr.Val, self).__init__()

                                                    self.yang_name = "val"
                                                    self.yang_parent_name = "pmap-var-list-arr"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PlmgrVarTypeEn', '')])),
                                                        ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                        ('uint8_val', (YLeaf(YType.uint8, 'uint8_val'), ['int'])),
                                                        ('uint16_val', (YLeaf(YType.uint16, 'uint16_val'), ['int'])),
                                                        ('uint32_val', (YLeaf(YType.uint32, 'uint32_val'), ['int'])),
                                                        ('param_uint32_val', (YLeaf(YType.uint32, 'param-uint32-val'), ['int'])),
                                                        ('dscp_val', (YLeaf(YType.uint8, 'dscp-val'), ['int'])),
                                                        ('prec_val', (YLeaf(YType.uint8, 'prec-val'), ['int'])),
                                                    ])
                                                    self.type = None
                                                    self.class_name = None
                                                    self.uint8_val = None
                                                    self.uint16_val = None
                                                    self.uint32_val = None
                                                    self.param_uint32_val = None
                                                    self.dscp_val = None
                                                    self.prec_val = None
                                                    self._segment_path = lambda: "val"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.PmapVarList.PmapVarListArr.Val, ['type', 'class_name', 'uint8_val', 'uint16_val', 'uint32_val', 'param_uint32_val', 'dscp_val', 'prec_val'], name, value)


                                    class EventInfop(Entity):
                                        """
                                        event infop
                                        
                                        .. attribute:: policy_event_info_bg
                                        
                                        	policy event info bg
                                        	**type**\: list of  		 :py:class:`PolicyEventInfoBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg>`
                                        
                                        

                                        """

                                        _prefix = 'infra-policymgr-oper'
                                        _revision = '2018-01-17'

                                        def __init__(self):
                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop, self).__init__()

                                            self.yang_name = "event-infop"
                                            self.yang_parent_name = "policy-map-bg"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("policy-event-info-bg", ("policy_event_info_bg", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg))])
                                            self._leafs = OrderedDict()

                                            self.policy_event_info_bg = YList(self)
                                            self._segment_path = lambda: "event-infop"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop, [], name, value)


                                        class PolicyEventInfoBg(Entity):
                                            """
                                            policy event info bg
                                            
                                            .. attribute:: class_infop
                                            
                                            	class infop
                                            	**type**\:  :py:class:`ClassInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop>`
                                            
                                            .. attribute:: event_type
                                            
                                            	event type
                                            	**type**\:  :py:class:`PeventTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PeventTypeEn>`
                                            
                                            .. attribute:: cond_eval
                                            
                                            	cond eval
                                            	**type**\:  :py:class:`PeventCondEvalEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PeventCondEvalEn>`
                                            
                                            

                                            """

                                            _prefix = 'infra-policymgr-oper'
                                            _revision = '2018-01-17'

                                            def __init__(self):
                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg, self).__init__()

                                                self.yang_name = "policy-event-info-bg"
                                                self.yang_parent_name = "event-infop"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("class-infop", ("class_infop", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop))])
                                                self._leafs = OrderedDict([
                                                    ('event_type', (YLeaf(YType.enumeration, 'event-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PeventTypeEn', '')])),
                                                    ('cond_eval', (YLeaf(YType.enumeration, 'cond-eval'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PeventCondEvalEn', '')])),
                                                ])
                                                self.event_type = None
                                                self.cond_eval = None

                                                self.class_infop = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop()
                                                self.class_infop.parent = self
                                                self._children_name_map["class_infop"] = "class-infop"
                                                self._segment_path = lambda: "policy-event-info-bg"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg, ['event_type', 'cond_eval'], name, value)


                                            class ClassInfop(Entity):
                                                """
                                                class infop
                                                
                                                .. attribute:: policy_class_info_bg
                                                
                                                	policy class info bg
                                                	**type**\: list of  		 :py:class:`PolicyClassInfoBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2018-01-17'

                                                def __init__(self):
                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop, self).__init__()

                                                    self.yang_name = "class-infop"
                                                    self.yang_parent_name = "policy-event-info-bg"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("policy-class-info-bg", ("policy_class_info_bg", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg))])
                                                    self._leafs = OrderedDict()

                                                    self.policy_class_info_bg = YList(self)
                                                    self._segment_path = lambda: "class-infop"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop, [], name, value)


                                                class PolicyClassInfoBg(Entity):
                                                    """
                                                    policy class info bg
                                                    
                                                    .. attribute:: cl_encode
                                                    
                                                    	cl encode
                                                    	**type**\:  :py:class:`ClEncode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode>`
                                                    
                                                    .. attribute:: clmp_p
                                                    
                                                    	clmp p
                                                    	**type**\:  :py:class:`ClmpP <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP>`
                                                    
                                                    .. attribute:: act_infop
                                                    
                                                    	act infop
                                                    	**type**\:  :py:class:`ActInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop>`
                                                    
                                                    .. attribute:: policy_class_hd
                                                    
                                                    	policy class hd
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: seq
                                                    
                                                    	seq
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: flags
                                                    
                                                    	flags
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: ctype
                                                    
                                                    	ctype
                                                    	**type**\:  :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                    
                                                    .. attribute:: num_actions
                                                    
                                                    	num actions
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: version
                                                    
                                                    	version
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: exe_strat
                                                    
                                                    	exe strat
                                                    	**type**\:  :py:class:`PclassExecStratEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PclassExecStratEn>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2018-01-17'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg, self).__init__()

                                                        self.yang_name = "policy-class-info-bg"
                                                        self.yang_parent_name = "class-infop"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("cl-encode", ("cl_encode", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode)), ("clmp-p", ("clmp_p", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP)), ("act-infop", ("act_infop", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop))])
                                                        self._leafs = OrderedDict([
                                                            ('policy_class_hd', (YLeaf(YType.uint32, 'policy-class-hd'), ['int'])),
                                                            ('seq', (YLeaf(YType.uint32, 'seq'), ['int'])),
                                                            ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                            ('ctype', (YLeaf(YType.enumeration, 'ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapTypeEn', '')])),
                                                            ('num_actions', (YLeaf(YType.uint16, 'num-actions'), ['int'])),
                                                            ('version', (YLeaf(YType.uint8, 'version'), ['int'])),
                                                            ('exe_strat', (YLeaf(YType.enumeration, 'exe-strat'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PclassExecStratEn', '')])),
                                                        ])
                                                        self.policy_class_hd = None
                                                        self.seq = None
                                                        self.flags = None
                                                        self.ctype = None
                                                        self.num_actions = None
                                                        self.version = None
                                                        self.exe_strat = None

                                                        self.cl_encode = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode()
                                                        self.cl_encode.parent = self
                                                        self._children_name_map["cl_encode"] = "cl-encode"

                                                        self.clmp_p = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP()
                                                        self.clmp_p.parent = self
                                                        self._children_name_map["clmp_p"] = "clmp-p"

                                                        self.act_infop = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop()
                                                        self.act_infop.parent = self
                                                        self._children_name_map["act_infop"] = "act-infop"
                                                        self._segment_path = lambda: "policy-class-info-bg"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg, ['policy_class_hd', 'seq', 'flags', 'ctype', 'num_actions', 'version', 'exe_strat'], name, value)


                                                    class ClEncode(Entity):
                                                        """
                                                        cl encode
                                                        
                                                        .. attribute:: inline_cmap
                                                        
                                                        	inline cmap
                                                        	**type**\:  :py:class:`InlineCmap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap>`
                                                        
                                                        .. attribute:: enc
                                                        
                                                        	enc
                                                        	**type**\:  :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                        
                                                        .. attribute:: class_name
                                                        
                                                        	class name
                                                        	**type**\: str
                                                        
                                                        	**length:** 0..65
                                                        
                                                        .. attribute:: hd
                                                        
                                                        	hd
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: idx
                                                        
                                                        	idx
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2018-01-17'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode, self).__init__()

                                                            self.yang_name = "cl-encode"
                                                            self.yang_parent_name = "policy-class-info-bg"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("inline-cmap", ("inline_cmap", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap))])
                                                            self._leafs = OrderedDict([
                                                                ('enc', (YLeaf(YType.enumeration, 'enc'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyObjEncEn', '')])),
                                                                ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                                ('hd', (YLeaf(YType.uint64, 'hd'), ['int'])),
                                                                ('idx', (YLeaf(YType.uint8, 'idx'), ['int'])),
                                                            ])
                                                            self.enc = None
                                                            self.class_name = None
                                                            self.hd = None
                                                            self.idx = None

                                                            self.inline_cmap = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap()
                                                            self.inline_cmap.parent = self
                                                            self._children_name_map["inline_cmap"] = "inline-cmap"
                                                            self._segment_path = lambda: "cl-encode"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode, ['enc', 'class_name', 'hd', 'idx'], name, value)


                                                        class InlineCmap(Entity):
                                                            """
                                                            inline cmap
                                                            
                                                            .. attribute:: match_infop
                                                            
                                                            	Pointer to the first Match info
                                                            	**type**\:  :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop>`
                                                            
                                                            .. attribute:: mode
                                                            
                                                            	Inline Class\-Map Mode Match any/all
                                                            	**type**\:  :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                            
                                                            .. attribute:: flags
                                                            
                                                            	Inline Class\-Map flags
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: match_count
                                                            
                                                            	Number of Match infos
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'infra-policymgr-oper'
                                                            _revision = '2018-01-17'

                                                            def __init__(self):
                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap, self).__init__()

                                                                self.yang_name = "inline-cmap"
                                                                self.yang_parent_name = "cl-encode"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("match-infop", ("match_infop", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop))])
                                                                self._leafs = OrderedDict([
                                                                    ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapModeEn', '')])),
                                                                    ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                    ('match_count', (YLeaf(YType.uint32, 'match-count'), ['int'])),
                                                                ])
                                                                self.mode = None
                                                                self.flags = None
                                                                self.match_count = None

                                                                self.match_infop = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop()
                                                                self.match_infop.parent = self
                                                                self._children_name_map["match_infop"] = "match-infop"
                                                                self._segment_path = lambda: "inline-cmap"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap, ['mode', 'flags', 'match_count'], name, value)


                                                            class MatchInfop(Entity):
                                                                """
                                                                Pointer to the first Match info
                                                                
                                                                .. attribute:: class_match_info_st
                                                                
                                                                	class match info st
                                                                	**type**\: list of  		 :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop, self).__init__()

                                                                    self.yang_name = "match-infop"
                                                                    self.yang_parent_name = "inline-cmap"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("class-match-info-st", ("class_match_info_st", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt))])
                                                                    self._leafs = OrderedDict()

                                                                    self.class_match_info_st = YList(self)
                                                                    self._segment_path = lambda: "match-infop"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop, [], name, value)


                                                                class ClassMatchInfoSt(Entity):
                                                                    """
                                                                    class match info st
                                                                    
                                                                    .. attribute:: match_data
                                                                    
                                                                    	Match criteria
                                                                    	**type**\:  :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                    
                                                                    .. attribute:: flags
                                                                    
                                                                    	Flags
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                        self.yang_name = "class-match-info-st"
                                                                        self.yang_parent_name = "match-infop"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("match-data", ("match_data", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData))])
                                                                        self._leafs = OrderedDict([
                                                                            ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                        ])
                                                                        self.flags = None

                                                                        self.match_data = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                        self.match_data.parent = self
                                                                        self._children_name_map["match_data"] = "match-data"
                                                                        self._segment_path = lambda: "class-match-info-st"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                    class MatchData(Entity):
                                                                        """
                                                                        Match criteria
                                                                        
                                                                        .. attribute:: ipv4_dscp
                                                                        
                                                                        	IPv4 DSCP
                                                                        	**type**\:  :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                        
                                                                        .. attribute:: ipv6_dscp
                                                                        
                                                                        	IPv6 DSCP
                                                                        	**type**\:  :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                        
                                                                        .. attribute:: dscp
                                                                        
                                                                        	Match DSCP range array
                                                                        	**type**\:  :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                        
                                                                        .. attribute:: ipv4_prec
                                                                        
                                                                        	IPv4 Precedence
                                                                        	**type**\:  :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                        
                                                                        .. attribute:: ipv6_prec
                                                                        
                                                                        	IPv6 Precedence
                                                                        	**type**\:  :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                        
                                                                        .. attribute:: prec
                                                                        
                                                                        	Match Precedence array
                                                                        	**type**\:  :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                        
                                                                        .. attribute:: discard_class
                                                                        
                                                                        	Match Discard Class array
                                                                        	**type**\:  :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                        
                                                                        .. attribute:: qos_group
                                                                        
                                                                        	Match QoS group array
                                                                        	**type**\:  :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                        
                                                                        .. attribute:: traffic_class
                                                                        
                                                                        	Match Traffic class array
                                                                        	**type**\:  :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                        
                                                                        .. attribute:: proto
                                                                        
                                                                        	Match Protocol array
                                                                        	**type**\:  :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                        
                                                                        .. attribute:: icmp_v4
                                                                        
                                                                        	Match ICMPV4 Protocol
                                                                        	**type**\:  :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                        
                                                                        .. attribute:: icmp_v6
                                                                        
                                                                        	Match ICMPV6 Protocol array
                                                                        	**type**\:  :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                        
                                                                        .. attribute:: ipv4_packet_len
                                                                        
                                                                        	IPv4 packet length array
                                                                        	**type**\:  :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                        
                                                                        .. attribute:: ipv6_packet_len
                                                                        
                                                                        	IPv6 packet length array
                                                                        	**type**\:  :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                        
                                                                        .. attribute:: packet_len
                                                                        
                                                                        	Match packet length array
                                                                        	**type**\:  :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                        
                                                                        .. attribute:: flow_tag
                                                                        
                                                                        	Match flow\-tag array
                                                                        	**type**\:  :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                        
                                                                        .. attribute:: tcp_flag
                                                                        
                                                                        	Match tcp flag value
                                                                        	**type**\:  :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                        
                                                                        .. attribute:: icmpv4_type
                                                                        
                                                                        	Match ipv4 icmp type
                                                                        	**type**\:  :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                        
                                                                        .. attribute:: icmpv4_code
                                                                        
                                                                        	Match ipv4 icmp code
                                                                        	**type**\:  :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                        
                                                                        .. attribute:: icmpv6_type
                                                                        
                                                                        	Match ipv6 icmp type
                                                                        	**type**\:  :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                        
                                                                        .. attribute:: icmpv6_code
                                                                        
                                                                        	Match ipv6 icmp code
                                                                        	**type**\:  :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                        
                                                                        .. attribute:: mpls_exp
                                                                        
                                                                        	Match MPLS experimental topmost array
                                                                        	**type**\:  :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                        
                                                                        .. attribute:: mpls_exp_imp
                                                                        
                                                                        	Match MPLS experimental imposition array
                                                                        	**type**\:  :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                        
                                                                        .. attribute:: mpls_disp_ipv4_acl
                                                                        
                                                                        	MPLS Disposition IPv4 Access\-list
                                                                        	**type**\:  :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                        
                                                                        .. attribute:: mpls_disp_ipv6_acl
                                                                        
                                                                        	MPLS Disposition IPv6 Access\-list
                                                                        	**type**\:  :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                        
                                                                        .. attribute:: mpls_top_label
                                                                        
                                                                        	MPLS Topmost LABEL
                                                                        	**type**\:  :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                        
                                                                        .. attribute:: cos
                                                                        
                                                                        	Match CoS array
                                                                        	**type**\:  :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                        
                                                                        .. attribute:: cos_inr
                                                                        
                                                                        	Match inner header CoS
                                                                        	**type**\:  :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                        
                                                                        .. attribute:: dei
                                                                        
                                                                        	Match DEI Bit
                                                                        	**type**\:  :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                        
                                                                        .. attribute:: dei_inr
                                                                        
                                                                        	Match inner DEI Bit
                                                                        	**type**\:  :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                        
                                                                        .. attribute:: vlan
                                                                        
                                                                        	Match VLAN array
                                                                        	**type**\:  :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                        
                                                                        .. attribute:: vlan_inr
                                                                        
                                                                        	Match inner header VLAN range array
                                                                        	**type**\:  :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                        
                                                                        .. attribute:: fr_dlci
                                                                        
                                                                        	Match FR DLCI range array
                                                                        	**type**\:  :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                        
                                                                        .. attribute:: src_mac
                                                                        
                                                                        	Match Source MAC address
                                                                        	**type**\:  :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                        
                                                                        .. attribute:: dst_mac
                                                                        
                                                                        	Match Destination MAC address
                                                                        	**type**\:  :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                        
                                                                        .. attribute:: atm_clp
                                                                        
                                                                        	Match ATM CLP level
                                                                        	**type**\:  :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                        
                                                                        .. attribute:: fr_de
                                                                        
                                                                        	Match FR DE value
                                                                        	**type**\:  :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                        
                                                                        .. attribute:: ipv4_acl
                                                                        
                                                                        	IPv4 Access\-list
                                                                        	**type**\:  :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                        
                                                                        .. attribute:: ipv6_acl
                                                                        
                                                                        	IPv6 Access\-list
                                                                        	**type**\:  :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                        
                                                                        .. attribute:: ether_service_acl
                                                                        
                                                                        	Ethernet\-Services Access\-list
                                                                        	**type**\:  :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                        
                                                                        .. attribute:: avail_id
                                                                        
                                                                        	Available Identifiers
                                                                        	**type**\:  :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                        
                                                                        .. attribute:: media_type
                                                                        
                                                                        	Media Type
                                                                        	**type**\:  :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                        
                                                                        .. attribute:: subs_protocol
                                                                        
                                                                        	Protocol
                                                                        	**type**\:  :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                        
                                                                        .. attribute:: dnis
                                                                        
                                                                        	DNIS
                                                                        	**type**\:  :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                        
                                                                        .. attribute:: dnis_regex
                                                                        
                                                                        	DNIS Regular Expression
                                                                        	**type**\:  :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                        
                                                                        .. attribute:: domain
                                                                        
                                                                        	Domain Name
                                                                        	**type**\:  :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                        
                                                                        .. attribute:: domain_regex
                                                                        
                                                                        	Domain Regular Expression
                                                                        	**type**\:  :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                        
                                                                        .. attribute:: nas_port
                                                                        
                                                                        	NAS Port
                                                                        	**type**\:  :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                        
                                                                        .. attribute:: service_name
                                                                        
                                                                        	Service Name
                                                                        	**type**\:  :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                        
                                                                        .. attribute:: service_name_regex
                                                                        
                                                                        	Service Name Regular Exp
                                                                        	**type**\:  :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                        
                                                                        .. attribute:: src_addr_ipv4
                                                                        
                                                                        	Source Address IPV4
                                                                        	**type**\:  :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                        
                                                                        .. attribute:: dst_addr_ipv4
                                                                        
                                                                        	Destination Address IPV4
                                                                        	**type**\:  :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                        
                                                                        .. attribute:: src_addr_ipv6
                                                                        
                                                                        	Source Address IPV6
                                                                        	**type**\:  :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                        
                                                                        .. attribute:: dst_addr_ipv6
                                                                        
                                                                        	Destination Address IPV6
                                                                        	**type**\:  :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                        
                                                                        .. attribute:: src_addr_mac
                                                                        
                                                                        	Source Address MAC
                                                                        	**type**\:  :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                        
                                                                        .. attribute:: timer
                                                                        
                                                                        	Timer
                                                                        	**type**\:  :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                        
                                                                        .. attribute:: timer_regexp
                                                                        
                                                                        	Timer Regular Expression
                                                                        	**type**\:  :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                        
                                                                        .. attribute:: tunnel_name
                                                                        
                                                                        	Tunnel Name
                                                                        	**type**\:  :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                        
                                                                        .. attribute:: tunnel_name_regex
                                                                        
                                                                        	Tunnel Name Regular Expression
                                                                        	**type**\:  :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                        
                                                                        .. attribute:: user_name
                                                                        
                                                                        	User Name
                                                                        	**type**\:  :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                        
                                                                        .. attribute:: user_name_regex
                                                                        
                                                                        	User Name Regular Expression
                                                                        	**type**\:  :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                        
                                                                        .. attribute:: auth_username
                                                                        
                                                                        	Authenticated User Name
                                                                        	**type**\:  :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                        
                                                                        .. attribute:: auth_username_regex
                                                                        
                                                                        	Authenticated User Name RegEx
                                                                        	**type**\:  :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                        
                                                                        .. attribute:: unauth_username
                                                                        
                                                                        	Unauthenticated User Name
                                                                        	**type**\:  :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                        
                                                                        .. attribute:: unauth_username_regex
                                                                        
                                                                        	Unauthenticated User Name RegEx
                                                                        	**type**\:  :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                        
                                                                        .. attribute:: auth_domain
                                                                        
                                                                        	Authenticated domain name
                                                                        	**type**\:  :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                        
                                                                        .. attribute:: auth_domain_regex
                                                                        
                                                                        	Authenticated Domain Name RegEx
                                                                        	**type**\:  :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                        
                                                                        .. attribute:: unauth_domain
                                                                        
                                                                        	Unauthenticated Domain Name
                                                                        	**type**\:  :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                        
                                                                        .. attribute:: unauth_domain_regex
                                                                        
                                                                        	Unauthenticated Domain Name RegEx
                                                                        	**type**\:  :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                        
                                                                        .. attribute:: vendor_id
                                                                        
                                                                        	Vendor ID
                                                                        	**type**\:  :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                        
                                                                        .. attribute:: vendor_id_regex
                                                                        
                                                                        	Vendor ID RegEx
                                                                        	**type**\:  :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                        
                                                                        .. attribute:: access_interface
                                                                        
                                                                        	Access interface
                                                                        	**type**\:  :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                        
                                                                        .. attribute:: input_interface
                                                                        
                                                                        	Input interface
                                                                        	**type**\:  :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                        
                                                                        .. attribute:: input_intfhdl
                                                                        
                                                                        	Input interface handle
                                                                        	**type**\:  :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                        
                                                                        .. attribute:: ethertype
                                                                        
                                                                        	Ethernet type
                                                                        	**type**\:  :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                        
                                                                        .. attribute:: flow_key_data
                                                                        
                                                                        	Flow key structure
                                                                        	**type**\:  :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                        
                                                                        .. attribute:: dhcp_client_id
                                                                        
                                                                        	Dhcp Client ID
                                                                        	**type**\:  :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                        
                                                                        .. attribute:: dhcp_client_id_regex
                                                                        
                                                                        	Dhcp Client ID RegEx
                                                                        	**type**\:  :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                        
                                                                        .. attribute:: circuit_id
                                                                        
                                                                        	Circuit ID
                                                                        	**type**\:  :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                        
                                                                        .. attribute:: circuit_id_regex
                                                                        
                                                                        	Circuit ID RegEx
                                                                        	**type**\:  :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                        
                                                                        .. attribute:: remote_id
                                                                        
                                                                        	Remote ID
                                                                        	**type**\:  :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                        
                                                                        .. attribute:: remote_id_regex
                                                                        
                                                                        	Remote ID RegEx
                                                                        	**type**\:  :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                        
                                                                        .. attribute:: src_port
                                                                        
                                                                        	Source port
                                                                        	**type**\:  :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                        
                                                                        .. attribute:: dst_port
                                                                        
                                                                        	Destination port
                                                                        	**type**\:  :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                        
                                                                        .. attribute:: type
                                                                        
                                                                        	type
                                                                        	**type**\:  :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                        
                                                                        .. attribute:: mpls_top_eos
                                                                        
                                                                        	MPLS Topmost EOS
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: fragment_type
                                                                        
                                                                        	Fragment type
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: authen_status
                                                                        
                                                                        	Authentication Status
                                                                        	**type**\:  :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                        
                                                                        .. attribute:: mlp_negotiated
                                                                        
                                                                        	MLP Negotiated
                                                                        	**type**\:  :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                            self.yang_name = "match-data"
                                                                            self.yang_parent_name = "class-match-info-st"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("ipv4-dscp", ("ipv4_dscp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp)), ("ipv6-dscp", ("ipv6_dscp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp)), ("dscp", ("dscp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp)), ("ipv4-prec", ("ipv4_prec", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec)), ("ipv6-prec", ("ipv6_prec", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec)), ("prec", ("prec", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec)), ("discard-class", ("discard_class", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass)), ("qos-group", ("qos_group", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup)), ("traffic-class", ("traffic_class", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass)), ("proto", ("proto", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto)), ("icmp-v4", ("icmp_v4", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4)), ("icmp-v6", ("icmp_v6", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6)), ("ipv4-packet-len", ("ipv4_packet_len", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen)), ("ipv6-packet-len", ("ipv6_packet_len", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen)), ("packet-len", ("packet_len", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen)), ("flow-tag", ("flow_tag", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag)), ("tcp-flag", ("tcp_flag", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag)), ("icmpv4-type", ("icmpv4_type", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type)), ("icmpv4-code", ("icmpv4_code", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code)), ("icmpv6-type", ("icmpv6_type", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type)), ("icmpv6-code", ("icmpv6_code", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code)), ("mpls-exp", ("mpls_exp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp)), ("mpls-exp-imp", ("mpls_exp_imp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp)), ("mpls-disp-ipv4-acl", ("mpls_disp_ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl)), ("mpls-disp-ipv6-acl", ("mpls_disp_ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl)), ("mpls-top-label", ("mpls_top_label", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel)), ("cos", ("cos", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos)), ("cos-inr", ("cos_inr", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr)), ("dei", ("dei", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei)), ("dei-inr", ("dei_inr", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr)), ("vlan", ("vlan", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan)), ("vlan-inr", ("vlan_inr", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)), ("fr-dlci", ("fr_dlci", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci)), ("src-mac", ("src_mac", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac)), ("dst-mac", ("dst_mac", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac)), ("atm-clp", ("atm_clp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp)), ("fr-de", ("fr_de", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe)), ("ipv4-acl", ("ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl)), ("ipv6-acl", ("ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl)), ("ether-service-acl", ("ether_service_acl", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl)), ("avail-id", ("avail_id", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId)), ("media-type", ("media_type", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType)), ("subs-protocol", ("subs_protocol", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol)), ("dnis", ("dnis", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis)), ("dnis-regex", ("dnis_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex)), ("domain", ("domain", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain)), ("domain-regex", ("domain_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex)), ("nas-port", ("nas_port", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort)), ("service-name", ("service_name", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName)), ("service-name-regex", ("service_name_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex)), ("src-addr-ipv4", ("src_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4)), ("dst-addr-ipv4", ("dst_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4)), ("src-addr-ipv6", ("src_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6)), ("dst-addr-ipv6", ("dst_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6)), ("src-addr-mac", ("src_addr_mac", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac)), ("timer", ("timer", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer)), ("timer-regexp", ("timer_regexp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp)), ("tunnel-name", ("tunnel_name", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName)), ("tunnel-name-regex", ("tunnel_name_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex)), ("user-name", ("user_name", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName)), ("user-name-regex", ("user_name_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex)), ("auth-username", ("auth_username", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername)), ("auth-username-regex", ("auth_username_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex)), ("unauth-username", ("unauth_username", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername)), ("unauth-username-regex", ("unauth_username_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex)), ("auth-domain", ("auth_domain", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain)), ("auth-domain-regex", ("auth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex)), ("unauth-domain", ("unauth_domain", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain)), ("unauth-domain-regex", ("unauth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex)), ("vendor-id", ("vendor_id", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId)), ("vendor-id-regex", ("vendor_id_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex)), ("access-interface", ("access_interface", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface)), ("input-interface", ("input_interface", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface)), ("input-intfhdl", ("input_intfhdl", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl)), ("ethertype", ("ethertype", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype)), ("flow-key-data", ("flow_key_data", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData)), ("dhcp-client-id", ("dhcp_client_id", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId)), ("dhcp-client-id-regex", ("dhcp_client_id_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex)), ("circuit-id", ("circuit_id", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId)), ("circuit-id-regex", ("circuit_id_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex)), ("remote-id", ("remote_id", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId)), ("remote-id-regex", ("remote_id_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex)), ("src-port", ("src_port", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort)), ("dst-port", ("dst_port", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort))])
                                                                            self._leafs = OrderedDict([
                                                                                ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchTypeEn', '')])),
                                                                                ('mpls_top_eos', (YLeaf(YType.uint8, 'mpls-top-eos'), ['int'])),
                                                                                ('fragment_type', (YLeaf(YType.uint8, 'fragment-type'), ['int'])),
                                                                                ('authen_status', (YLeaf(YType.enumeration, 'authen-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchAuthenStatusEn', '')])),
                                                                                ('mlp_negotiated', (YLeaf(YType.enumeration, 'mlp-negotiated'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchMlpNegotiatedEn', '')])),
                                                                            ])
                                                                            self.type = None
                                                                            self.mpls_top_eos = None
                                                                            self.fragment_type = None
                                                                            self.authen_status = None
                                                                            self.mlp_negotiated = None

                                                                            self.ipv4_dscp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                            self.ipv4_dscp.parent = self
                                                                            self._children_name_map["ipv4_dscp"] = "ipv4-dscp"

                                                                            self.ipv6_dscp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                            self.ipv6_dscp.parent = self
                                                                            self._children_name_map["ipv6_dscp"] = "ipv6-dscp"

                                                                            self.dscp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                            self.dscp.parent = self
                                                                            self._children_name_map["dscp"] = "dscp"

                                                                            self.ipv4_prec = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                            self.ipv4_prec.parent = self
                                                                            self._children_name_map["ipv4_prec"] = "ipv4-prec"

                                                                            self.ipv6_prec = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                            self.ipv6_prec.parent = self
                                                                            self._children_name_map["ipv6_prec"] = "ipv6-prec"

                                                                            self.prec = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                            self.prec.parent = self
                                                                            self._children_name_map["prec"] = "prec"

                                                                            self.discard_class = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                            self.discard_class.parent = self
                                                                            self._children_name_map["discard_class"] = "discard-class"

                                                                            self.qos_group = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                            self.qos_group.parent = self
                                                                            self._children_name_map["qos_group"] = "qos-group"

                                                                            self.traffic_class = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                            self.traffic_class.parent = self
                                                                            self._children_name_map["traffic_class"] = "traffic-class"

                                                                            self.proto = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                            self.proto.parent = self
                                                                            self._children_name_map["proto"] = "proto"

                                                                            self.icmp_v4 = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                            self.icmp_v4.parent = self
                                                                            self._children_name_map["icmp_v4"] = "icmp-v4"

                                                                            self.icmp_v6 = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                            self.icmp_v6.parent = self
                                                                            self._children_name_map["icmp_v6"] = "icmp-v6"

                                                                            self.ipv4_packet_len = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                            self.ipv4_packet_len.parent = self
                                                                            self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"

                                                                            self.ipv6_packet_len = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                            self.ipv6_packet_len.parent = self
                                                                            self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"

                                                                            self.packet_len = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                            self.packet_len.parent = self
                                                                            self._children_name_map["packet_len"] = "packet-len"

                                                                            self.flow_tag = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                            self.flow_tag.parent = self
                                                                            self._children_name_map["flow_tag"] = "flow-tag"

                                                                            self.tcp_flag = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                            self.tcp_flag.parent = self
                                                                            self._children_name_map["tcp_flag"] = "tcp-flag"

                                                                            self.icmpv4_type = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                            self.icmpv4_type.parent = self
                                                                            self._children_name_map["icmpv4_type"] = "icmpv4-type"

                                                                            self.icmpv4_code = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                            self.icmpv4_code.parent = self
                                                                            self._children_name_map["icmpv4_code"] = "icmpv4-code"

                                                                            self.icmpv6_type = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                            self.icmpv6_type.parent = self
                                                                            self._children_name_map["icmpv6_type"] = "icmpv6-type"

                                                                            self.icmpv6_code = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                            self.icmpv6_code.parent = self
                                                                            self._children_name_map["icmpv6_code"] = "icmpv6-code"

                                                                            self.mpls_exp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                            self.mpls_exp.parent = self
                                                                            self._children_name_map["mpls_exp"] = "mpls-exp"

                                                                            self.mpls_exp_imp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                            self.mpls_exp_imp.parent = self
                                                                            self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"

                                                                            self.mpls_disp_ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                            self.mpls_disp_ipv4_acl.parent = self
                                                                            self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"

                                                                            self.mpls_disp_ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                            self.mpls_disp_ipv6_acl.parent = self
                                                                            self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"

                                                                            self.mpls_top_label = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                            self.mpls_top_label.parent = self
                                                                            self._children_name_map["mpls_top_label"] = "mpls-top-label"

                                                                            self.cos = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                            self.cos.parent = self
                                                                            self._children_name_map["cos"] = "cos"

                                                                            self.cos_inr = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                            self.cos_inr.parent = self
                                                                            self._children_name_map["cos_inr"] = "cos-inr"

                                                                            self.dei = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                            self.dei.parent = self
                                                                            self._children_name_map["dei"] = "dei"

                                                                            self.dei_inr = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                            self.dei_inr.parent = self
                                                                            self._children_name_map["dei_inr"] = "dei-inr"

                                                                            self.vlan = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                            self.vlan.parent = self
                                                                            self._children_name_map["vlan"] = "vlan"

                                                                            self.vlan_inr = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                            self.vlan_inr.parent = self
                                                                            self._children_name_map["vlan_inr"] = "vlan-inr"

                                                                            self.fr_dlci = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                            self.fr_dlci.parent = self
                                                                            self._children_name_map["fr_dlci"] = "fr-dlci"

                                                                            self.src_mac = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                            self.src_mac.parent = self
                                                                            self._children_name_map["src_mac"] = "src-mac"

                                                                            self.dst_mac = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                            self.dst_mac.parent = self
                                                                            self._children_name_map["dst_mac"] = "dst-mac"

                                                                            self.atm_clp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                            self.atm_clp.parent = self
                                                                            self._children_name_map["atm_clp"] = "atm-clp"

                                                                            self.fr_de = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                            self.fr_de.parent = self
                                                                            self._children_name_map["fr_de"] = "fr-de"

                                                                            self.ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                            self.ipv4_acl.parent = self
                                                                            self._children_name_map["ipv4_acl"] = "ipv4-acl"

                                                                            self.ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                            self.ipv6_acl.parent = self
                                                                            self._children_name_map["ipv6_acl"] = "ipv6-acl"

                                                                            self.ether_service_acl = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                            self.ether_service_acl.parent = self
                                                                            self._children_name_map["ether_service_acl"] = "ether-service-acl"

                                                                            self.avail_id = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                            self.avail_id.parent = self
                                                                            self._children_name_map["avail_id"] = "avail-id"

                                                                            self.media_type = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                            self.media_type.parent = self
                                                                            self._children_name_map["media_type"] = "media-type"

                                                                            self.subs_protocol = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                            self.subs_protocol.parent = self
                                                                            self._children_name_map["subs_protocol"] = "subs-protocol"

                                                                            self.dnis = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                            self.dnis.parent = self
                                                                            self._children_name_map["dnis"] = "dnis"

                                                                            self.dnis_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                            self.dnis_regex.parent = self
                                                                            self._children_name_map["dnis_regex"] = "dnis-regex"

                                                                            self.domain = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                            self.domain.parent = self
                                                                            self._children_name_map["domain"] = "domain"

                                                                            self.domain_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                            self.domain_regex.parent = self
                                                                            self._children_name_map["domain_regex"] = "domain-regex"

                                                                            self.nas_port = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                            self.nas_port.parent = self
                                                                            self._children_name_map["nas_port"] = "nas-port"

                                                                            self.service_name = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                            self.service_name.parent = self
                                                                            self._children_name_map["service_name"] = "service-name"

                                                                            self.service_name_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                            self.service_name_regex.parent = self
                                                                            self._children_name_map["service_name_regex"] = "service-name-regex"

                                                                            self.src_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                            self.src_addr_ipv4.parent = self
                                                                            self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"

                                                                            self.dst_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                            self.dst_addr_ipv4.parent = self
                                                                            self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"

                                                                            self.src_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                            self.src_addr_ipv6.parent = self
                                                                            self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"

                                                                            self.dst_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                            self.dst_addr_ipv6.parent = self
                                                                            self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"

                                                                            self.src_addr_mac = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                            self.src_addr_mac.parent = self
                                                                            self._children_name_map["src_addr_mac"] = "src-addr-mac"

                                                                            self.timer = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                            self.timer.parent = self
                                                                            self._children_name_map["timer"] = "timer"

                                                                            self.timer_regexp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                            self.timer_regexp.parent = self
                                                                            self._children_name_map["timer_regexp"] = "timer-regexp"

                                                                            self.tunnel_name = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                            self.tunnel_name.parent = self
                                                                            self._children_name_map["tunnel_name"] = "tunnel-name"

                                                                            self.tunnel_name_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                            self.tunnel_name_regex.parent = self
                                                                            self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"

                                                                            self.user_name = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                            self.user_name.parent = self
                                                                            self._children_name_map["user_name"] = "user-name"

                                                                            self.user_name_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                            self.user_name_regex.parent = self
                                                                            self._children_name_map["user_name_regex"] = "user-name-regex"

                                                                            self.auth_username = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                            self.auth_username.parent = self
                                                                            self._children_name_map["auth_username"] = "auth-username"

                                                                            self.auth_username_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                            self.auth_username_regex.parent = self
                                                                            self._children_name_map["auth_username_regex"] = "auth-username-regex"

                                                                            self.unauth_username = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                            self.unauth_username.parent = self
                                                                            self._children_name_map["unauth_username"] = "unauth-username"

                                                                            self.unauth_username_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                            self.unauth_username_regex.parent = self
                                                                            self._children_name_map["unauth_username_regex"] = "unauth-username-regex"

                                                                            self.auth_domain = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                            self.auth_domain.parent = self
                                                                            self._children_name_map["auth_domain"] = "auth-domain"

                                                                            self.auth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                            self.auth_domain_regex.parent = self
                                                                            self._children_name_map["auth_domain_regex"] = "auth-domain-regex"

                                                                            self.unauth_domain = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                            self.unauth_domain.parent = self
                                                                            self._children_name_map["unauth_domain"] = "unauth-domain"

                                                                            self.unauth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                            self.unauth_domain_regex.parent = self
                                                                            self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"

                                                                            self.vendor_id = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                            self.vendor_id.parent = self
                                                                            self._children_name_map["vendor_id"] = "vendor-id"

                                                                            self.vendor_id_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                            self.vendor_id_regex.parent = self
                                                                            self._children_name_map["vendor_id_regex"] = "vendor-id-regex"

                                                                            self.access_interface = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                            self.access_interface.parent = self
                                                                            self._children_name_map["access_interface"] = "access-interface"

                                                                            self.input_interface = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                            self.input_interface.parent = self
                                                                            self._children_name_map["input_interface"] = "input-interface"

                                                                            self.input_intfhdl = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                            self.input_intfhdl.parent = self
                                                                            self._children_name_map["input_intfhdl"] = "input-intfhdl"

                                                                            self.ethertype = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                            self.ethertype.parent = self
                                                                            self._children_name_map["ethertype"] = "ethertype"

                                                                            self.flow_key_data = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                            self.flow_key_data.parent = self
                                                                            self._children_name_map["flow_key_data"] = "flow-key-data"

                                                                            self.dhcp_client_id = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                            self.dhcp_client_id.parent = self
                                                                            self._children_name_map["dhcp_client_id"] = "dhcp-client-id"

                                                                            self.dhcp_client_id_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                            self.dhcp_client_id_regex.parent = self
                                                                            self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"

                                                                            self.circuit_id = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                            self.circuit_id.parent = self
                                                                            self._children_name_map["circuit_id"] = "circuit-id"

                                                                            self.circuit_id_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                            self.circuit_id_regex.parent = self
                                                                            self._children_name_map["circuit_id_regex"] = "circuit-id-regex"

                                                                            self.remote_id = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                            self.remote_id.parent = self
                                                                            self._children_name_map["remote_id"] = "remote-id"

                                                                            self.remote_id_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                            self.remote_id_regex.parent = self
                                                                            self._children_name_map["remote_id_regex"] = "remote-id-regex"

                                                                            self.src_port = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                            self.src_port.parent = self
                                                                            self._children_name_map["src_port"] = "src-port"

                                                                            self.dst_port = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                            self.dst_port.parent = self
                                                                            self._children_name_map["dst_port"] = "dst-port"
                                                                            self._segment_path = lambda: "match-data"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, ['type', 'mpls_top_eos', 'fragment_type', 'authen_status', 'mlp_negotiated'], name, value)


                                                                        class Ipv4Dscp(Entity):
                                                                            """
                                                                            IPv4 DSCP
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                self.yang_name = "ipv4-dscp"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "ipv4-dscp"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "ipv4-dscp"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                        class Ipv6Dscp(Entity):
                                                                            """
                                                                            IPv6 DSCP
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                self.yang_name = "ipv6-dscp"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "ipv6-dscp"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "ipv6-dscp"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                        class Dscp(Entity):
                                                                            """
                                                                            Match DSCP range array
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                self.yang_name = "dscp"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "dscp"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "dscp"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                        class Ipv4Prec(Entity):
                                                                            """
                                                                            IPv4 Precedence
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                self.yang_name = "ipv4-prec"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                ])
                                                                                self.uint8_array = []
                                                                                self._segment_path = lambda: "ipv4-prec"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                        class Ipv6Prec(Entity):
                                                                            """
                                                                            IPv6 Precedence
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                self.yang_name = "ipv6-prec"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                ])
                                                                                self.uint8_array = []
                                                                                self._segment_path = lambda: "ipv6-prec"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                        class Prec(Entity):
                                                                            """
                                                                            Match Precedence array
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                self.yang_name = "prec"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                ])
                                                                                self.uint8_array = []
                                                                                self._segment_path = lambda: "prec"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                        class DiscardClass(Entity):
                                                                            """
                                                                            Match Discard Class array
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                self.yang_name = "discard-class"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                ])
                                                                                self.uint8_array = []
                                                                                self._segment_path = lambda: "discard-class"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                        class QosGroup(Entity):
                                                                            """
                                                                            Match QoS group array
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                self.yang_name = "qos-group"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "qos-group"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "qos-group"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['min', 'max'], name, value)


                                                                        class TrafficClass(Entity):
                                                                            """
                                                                            Match Traffic class array
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                self.yang_name = "traffic-class"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "traffic-class"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "traffic-class"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['min', 'max'], name, value)


                                                                        class Proto(Entity):
                                                                            """
                                                                            Match Protocol array
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                self.yang_name = "proto"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "proto"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "proto"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['min', 'max'], name, value)


                                                                        class IcmpV4(Entity):
                                                                            """
                                                                            Match ICMPV4 Protocol
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	Protocol type
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: code
                                                                            
                                                                            	Protocol code
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                self.yang_name = "icmp-v4"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                    ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                ])
                                                                                self.type = None
                                                                                self.code = None
                                                                                self._segment_path = lambda: "icmp-v4"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['type', 'code'], name, value)


                                                                        class IcmpV6(Entity):
                                                                            """
                                                                            Match ICMPV6 Protocol array
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	Protocol type
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: code
                                                                            
                                                                            	Protocol code
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                self.yang_name = "icmp-v6"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                    ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                ])
                                                                                self.type = None
                                                                                self.code = None
                                                                                self._segment_path = lambda: "icmp-v6"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['type', 'code'], name, value)


                                                                        class Ipv4PacketLen(Entity):
                                                                            """
                                                                            IPv4 packet length array
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                self.yang_name = "ipv4-packet-len"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "ipv4-packet-len"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "ipv4-packet-len"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                        class Ipv6PacketLen(Entity):
                                                                            """
                                                                            IPv6 packet length array
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                self.yang_name = "ipv6-packet-len"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "ipv6-packet-len"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "ipv6-packet-len"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                        class PacketLen(Entity):
                                                                            """
                                                                            Match packet length array
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                self.yang_name = "packet-len"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "packet-len"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "packet-len"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                        class FlowTag(Entity):
                                                                            """
                                                                            Match flow\-tag array
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                self.yang_name = "flow-tag"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "flow-tag"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "flow-tag"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['min', 'max'], name, value)


                                                                        class TcpFlag(Entity):
                                                                            """
                                                                            Match tcp flag value
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	Value of TCP flag
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: match_any
                                                                            
                                                                            	Match any TCP flag bit
                                                                            	**type**\: bool
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                self.yang_name = "tcp-flag"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                    ('match_any', (YLeaf(YType.boolean, 'match-any'), ['bool'])),
                                                                                ])
                                                                                self.value = None
                                                                                self.match_any = None
                                                                                self._segment_path = lambda: "tcp-flag"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['value', 'match_any'], name, value)


                                                                        class Icmpv4Type(Entity):
                                                                            """
                                                                            Match ipv4 icmp type
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                self.yang_name = "icmpv4-type"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "icmpv4-type"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "icmpv4-type"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                        class Icmpv4Code(Entity):
                                                                            """
                                                                            Match ipv4 icmp code
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                self.yang_name = "icmpv4-code"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "icmpv4-code"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "icmpv4-code"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                        class Icmpv6Type(Entity):
                                                                            """
                                                                            Match ipv6 icmp type
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                self.yang_name = "icmpv6-type"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "icmpv6-type"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "icmpv6-type"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                        class Icmpv6Code(Entity):
                                                                            """
                                                                            Match ipv6 icmp code
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                self.yang_name = "icmpv6-code"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "icmpv6-code"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "icmpv6-code"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                        class MplsExp(Entity):
                                                                            """
                                                                            Match MPLS experimental topmost array
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                self.yang_name = "mpls-exp"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                ])
                                                                                self.uint8_array = []
                                                                                self._segment_path = lambda: "mpls-exp"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                        class MplsExpImp(Entity):
                                                                            """
                                                                            Match MPLS experimental imposition array
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                self.yang_name = "mpls-exp-imp"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                ])
                                                                                self.uint8_array = []
                                                                                self._segment_path = lambda: "mpls-exp-imp"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                        class MplsDispIpv4Acl(Entity):
                                                                            """
                                                                            MPLS Disposition IPv4 Access\-list
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                self.yang_name = "mpls-disp-ipv4-acl"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "mpls-disp-ipv4-acl"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                        class MplsDispIpv6Acl(Entity):
                                                                            """
                                                                            MPLS Disposition IPv6 Access\-list
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                self.yang_name = "mpls-disp-ipv6-acl"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "mpls-disp-ipv6-acl"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                        class MplsTopLabel(Entity):
                                                                            """
                                                                            MPLS Topmost LABEL
                                                                            
                                                                            .. attribute:: uint32_rng_array
                                                                            
                                                                            	uint32 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                self.yang_name = "mpls-top-label"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint32_rng_array", ("uint32_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint32_rng_array = YList(self)
                                                                                self._segment_path = lambda: "mpls-top-label"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                            class Uint32RngArray(Entity):
                                                                                """
                                                                                uint32 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                    self.yang_name = "uint32_rng_array"
                                                                                    self.yang_parent_name = "mpls-top-label"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint32, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint32, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint32_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['min', 'max'], name, value)


                                                                        class Cos(Entity):
                                                                            """
                                                                            Match CoS array
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                self.yang_name = "cos"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                ])
                                                                                self.uint8_array = []
                                                                                self._segment_path = lambda: "cos"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                        class CosInr(Entity):
                                                                            """
                                                                            Match inner header CoS
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                self.yang_name = "cos-inr"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                ])
                                                                                self.uint8_array = []
                                                                                self._segment_path = lambda: "cos-inr"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                        class Dei(Entity):
                                                                            """
                                                                            Match DEI Bit
                                                                            
                                                                            .. attribute:: bit_value
                                                                            
                                                                            	Value of the DEI bit
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                self.yang_name = "dei"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                ])
                                                                                self.bit_value = None
                                                                                self._segment_path = lambda: "dei"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                        class DeiInr(Entity):
                                                                            """
                                                                            Match inner DEI Bit
                                                                            
                                                                            .. attribute:: bit_value
                                                                            
                                                                            	Value of the DEI bit
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                self.yang_name = "dei-inr"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                ])
                                                                                self.bit_value = None
                                                                                self._segment_path = lambda: "dei-inr"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                        class Vlan(Entity):
                                                                            """
                                                                            Match VLAN array
                                                                            
                                                                            .. attribute:: vlan_id_array
                                                                            
                                                                            	vlan id array
                                                                            	**type**\: list of  		 :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                self.yang_name = "vlan"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("vlan-id-array", ("vlan_id_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.vlan_id_array = YList(self)
                                                                                self._segment_path = lambda: "vlan"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                            class VlanIdArray(Entity):
                                                                                """
                                                                                vlan id array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	VLAN mask
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                    self.yang_name = "vlan-id-array"
                                                                                    self.yang_parent_name = "vlan"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ('mask', (YLeaf(YType.uint16, 'mask'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self.mask = None
                                                                                    self._segment_path = lambda: "vlan-id-array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['min', 'max', 'mask'], name, value)


                                                                        class VlanInr(Entity):
                                                                            """
                                                                            Match inner header VLAN range array
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                self.yang_name = "vlan-inr"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "vlan-inr"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "vlan-inr"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['min', 'max'], name, value)


                                                                        class FrDlci(Entity):
                                                                            """
                                                                            Match FR DLCI range array
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                self.yang_name = "fr-dlci"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "fr-dlci"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "fr-dlci"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['min', 'max'], name, value)


                                                                        class SrcMac(Entity):
                                                                            """
                                                                            Match Source MAC address
                                                                            
                                                                            .. attribute:: mac_addr
                                                                            
                                                                            	MAC address
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: mask
                                                                            
                                                                            	MAC mask
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                self.yang_name = "src-mac"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                    ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                ])
                                                                                self.mac_addr = []
                                                                                self.mask = []
                                                                                self._segment_path = lambda: "src-mac"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                        class DstMac(Entity):
                                                                            """
                                                                            Match Destination MAC address
                                                                            
                                                                            .. attribute:: mac_addr
                                                                            
                                                                            	MAC address
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: mask
                                                                            
                                                                            	MAC mask
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                self.yang_name = "dst-mac"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                    ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                ])
                                                                                self.mac_addr = []
                                                                                self.mask = []
                                                                                self._segment_path = lambda: "dst-mac"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                        class AtmClp(Entity):
                                                                            """
                                                                            Match ATM CLP level
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                self.yang_name = "atm-clp"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                ])
                                                                                self.uint8_array = []
                                                                                self._segment_path = lambda: "atm-clp"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                        class FrDe(Entity):
                                                                            """
                                                                            Match FR DE value
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                self.yang_name = "fr-de"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                ])
                                                                                self.uint8_array = []
                                                                                self._segment_path = lambda: "fr-de"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                        class Ipv4Acl(Entity):
                                                                            """
                                                                            IPv4 Access\-list
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                self.yang_name = "ipv4-acl"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "ipv4-acl"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                        class Ipv6Acl(Entity):
                                                                            """
                                                                            IPv6 Access\-list
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                self.yang_name = "ipv6-acl"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "ipv6-acl"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                        class EtherServiceAcl(Entity):
                                                                            """
                                                                            Ethernet\-Services Access\-list
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                self.yang_name = "ether-service-acl"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "ether-service-acl"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                        class AvailId(Entity):
                                                                            """
                                                                            Available Identifiers
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                self.yang_name = "avail-id"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                ])
                                                                                self.uint8_array = []
                                                                                self._segment_path = lambda: "avail-id"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                        class MediaType(Entity):
                                                                            """
                                                                            Media Type
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                self.yang_name = "media-type"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                ])
                                                                                self.uint8_array = []
                                                                                self._segment_path = lambda: "media-type"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                        class SubsProtocol(Entity):
                                                                            """
                                                                            Protocol
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                self.yang_name = "subs-protocol"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                ])
                                                                                self.uint8_array = []
                                                                                self._segment_path = lambda: "subs-protocol"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                        class Dnis(Entity):
                                                                            """
                                                                            DNIS
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                self.yang_name = "dnis"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "dnis"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                        class DnisRegex(Entity):
                                                                            """
                                                                            DNIS Regular Expression
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                self.yang_name = "dnis-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "dnis-regex"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                        class Domain(Entity):
                                                                            """
                                                                            Domain Name
                                                                            
                                                                            .. attribute:: domain_array
                                                                            
                                                                            	domain array
                                                                            	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                self.yang_name = "domain"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.domain_array = YList(self)
                                                                                self._segment_path = lambda: "domain"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                            class DomainArray(Entity):
                                                                                """
                                                                                domain array
                                                                                
                                                                                .. attribute:: domain_name
                                                                                
                                                                                	domain name
                                                                                	**type**\: str
                                                                                
                                                                                .. attribute:: format_name
                                                                                
                                                                                	format name
                                                                                	**type**\: str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                    self.yang_name = "domain-array"
                                                                                    self.yang_parent_name = "domain"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                        ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                    ])
                                                                                    self.domain_name = None
                                                                                    self.format_name = None
                                                                                    self._segment_path = lambda: "domain-array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                        class DomainRegex(Entity):
                                                                            """
                                                                            Domain Regular Expression
                                                                            
                                                                            .. attribute:: domain_array
                                                                            
                                                                            	domain array
                                                                            	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                self.yang_name = "domain-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.domain_array = YList(self)
                                                                                self._segment_path = lambda: "domain-regex"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                            class DomainArray(Entity):
                                                                                """
                                                                                domain array
                                                                                
                                                                                .. attribute:: domain_name
                                                                                
                                                                                	domain name
                                                                                	**type**\: str
                                                                                
                                                                                .. attribute:: format_name
                                                                                
                                                                                	format name
                                                                                	**type**\: str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                    self.yang_name = "domain-array"
                                                                                    self.yang_parent_name = "domain-regex"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                        ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                    ])
                                                                                    self.domain_name = None
                                                                                    self.format_name = None
                                                                                    self._segment_path = lambda: "domain-array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                        class NasPort(Entity):
                                                                            """
                                                                            NAS Port
                                                                            
                                                                            .. attribute:: nas_port_array
                                                                            
                                                                            	nas port array
                                                                            	**type**\: list of  		 :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                self.yang_name = "nas-port"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("nas-port-array", ("nas_port_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.nas_port_array = YList(self)
                                                                                self._segment_path = lambda: "nas-port"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                            class NasPortArray(Entity):
                                                                                """
                                                                                nas port array
                                                                                
                                                                                .. attribute:: sub_id
                                                                                
                                                                                	sub id
                                                                                	**type**\:  :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                
                                                                                .. attribute:: operator
                                                                                
                                                                                	operator
                                                                                	**type**\:  :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                    self.yang_name = "nas-port-array"
                                                                                    self.yang_parent_name = "nas-port"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('sub_id', (YLeaf(YType.enumeration, 'sub-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchNasPortSubIdEn', '')])),
                                                                                        ('operator', (YLeaf(YType.enumeration, 'operator'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchLogicalOperatorEn', '')])),
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ])
                                                                                    self.sub_id = None
                                                                                    self.operator = None
                                                                                    self.value = None
                                                                                    self._segment_path = lambda: "nas-port-array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['sub_id', 'operator', 'value'], name, value)


                                                                        class ServiceName(Entity):
                                                                            """
                                                                            Service Name
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                self.yang_name = "service-name"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "service-name"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                        class ServiceNameRegex(Entity):
                                                                            """
                                                                            Service Name Regular Exp
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                self.yang_name = "service-name-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "service-name-regex"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                        class SrcAddrIpv4(Entity):
                                                                            """
                                                                            Source Address IPV4
                                                                            
                                                                            .. attribute:: ipv4_addr_array
                                                                            
                                                                            	ipv4 addr array
                                                                            	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                self.yang_name = "src-addr-ipv4"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.ipv4_addr_array = YList(self)
                                                                                self._segment_path = lambda: "src-addr-ipv4"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                            class Ipv4AddrArray(Entity):
                                                                                """
                                                                                ipv4 addr array
                                                                                
                                                                                .. attribute:: prefix
                                                                                
                                                                                	prefix
                                                                                	**type**\: str
                                                                                
                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	mask
                                                                                	**type**\: str
                                                                                
                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                    self.yang_name = "ipv4-addr-array"
                                                                                    self.yang_parent_name = "src-addr-ipv4"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                        ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                    ])
                                                                                    self.prefix = None
                                                                                    self.mask = None
                                                                                    self._segment_path = lambda: "ipv4-addr-array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                        class DstAddrIpv4(Entity):
                                                                            """
                                                                            Destination Address IPV4
                                                                            
                                                                            .. attribute:: ipv4_addr_array
                                                                            
                                                                            	ipv4 addr array
                                                                            	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                self.yang_name = "dst-addr-ipv4"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.ipv4_addr_array = YList(self)
                                                                                self._segment_path = lambda: "dst-addr-ipv4"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                            class Ipv4AddrArray(Entity):
                                                                                """
                                                                                ipv4 addr array
                                                                                
                                                                                .. attribute:: prefix
                                                                                
                                                                                	prefix
                                                                                	**type**\: str
                                                                                
                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	mask
                                                                                	**type**\: str
                                                                                
                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                    self.yang_name = "ipv4-addr-array"
                                                                                    self.yang_parent_name = "dst-addr-ipv4"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                        ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                    ])
                                                                                    self.prefix = None
                                                                                    self.mask = None
                                                                                    self._segment_path = lambda: "ipv4-addr-array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                        class SrcAddrIpv6(Entity):
                                                                            """
                                                                            Source Address IPV6
                                                                            
                                                                            .. attribute:: ipv6_addr_array
                                                                            
                                                                            	ipv6 addr array
                                                                            	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                self.yang_name = "src-addr-ipv6"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.ipv6_addr_array = YList(self)
                                                                                self._segment_path = lambda: "src-addr-ipv6"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                            class Ipv6AddrArray(Entity):
                                                                                """
                                                                                ipv6 addr array
                                                                                
                                                                                .. attribute:: prefix
                                                                                
                                                                                	IPV6 prefix
                                                                                	**type**\: str
                                                                                
                                                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	IPV6 mask
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                    self.yang_name = "ipv6-addr-array"
                                                                                    self.yang_parent_name = "src-addr-ipv6"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                        ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                    ])
                                                                                    self.prefix = None
                                                                                    self.mask = None
                                                                                    self._segment_path = lambda: "ipv6-addr-array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                        class DstAddrIpv6(Entity):
                                                                            """
                                                                            Destination Address IPV6
                                                                            
                                                                            .. attribute:: ipv6_addr_array
                                                                            
                                                                            	ipv6 addr array
                                                                            	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                self.yang_name = "dst-addr-ipv6"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.ipv6_addr_array = YList(self)
                                                                                self._segment_path = lambda: "dst-addr-ipv6"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                            class Ipv6AddrArray(Entity):
                                                                                """
                                                                                ipv6 addr array
                                                                                
                                                                                .. attribute:: prefix
                                                                                
                                                                                	IPV6 prefix
                                                                                	**type**\: str
                                                                                
                                                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	IPV6 mask
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                    self.yang_name = "ipv6-addr-array"
                                                                                    self.yang_parent_name = "dst-addr-ipv6"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                        ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                    ])
                                                                                    self.prefix = None
                                                                                    self.mask = None
                                                                                    self._segment_path = lambda: "ipv6-addr-array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                        class SrcAddrMac(Entity):
                                                                            """
                                                                            Source Address MAC
                                                                            
                                                                            .. attribute:: mac_addr_array
                                                                            
                                                                            	mac addr array
                                                                            	**type**\: list of  		 :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                self.yang_name = "src-addr-mac"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("mac-addr-array", ("mac_addr_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.mac_addr_array = YList(self)
                                                                                self._segment_path = lambda: "src-addr-mac"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                            class MacAddrArray(Entity):
                                                                                """
                                                                                mac addr array
                                                                                
                                                                                .. attribute:: mac_addr
                                                                                
                                                                                	MAC address
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	MAC mask
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                    self.yang_name = "mac-addr-array"
                                                                                    self.yang_parent_name = "src-addr-mac"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                    ])
                                                                                    self.mac_addr = []
                                                                                    self.mask = []
                                                                                    self._segment_path = lambda: "mac-addr-array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                        class Timer(Entity):
                                                                            """
                                                                            Timer
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                self.yang_name = "timer"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "timer"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                        class TimerRegexp(Entity):
                                                                            """
                                                                            Timer Regular Expression
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                self.yang_name = "timer-regexp"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "timer-regexp"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                        class TunnelName(Entity):
                                                                            """
                                                                            Tunnel Name
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                self.yang_name = "tunnel-name"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "tunnel-name"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                        class TunnelNameRegex(Entity):
                                                                            """
                                                                            Tunnel Name Regular Expression
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                self.yang_name = "tunnel-name-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "tunnel-name-regex"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                        class UserName(Entity):
                                                                            """
                                                                            User Name
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                self.yang_name = "user-name"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "user-name"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                        class UserNameRegex(Entity):
                                                                            """
                                                                            User Name Regular Expression
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                self.yang_name = "user-name-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "user-name-regex"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                        class AuthUsername(Entity):
                                                                            """
                                                                            Authenticated User Name
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                self.yang_name = "auth-username"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "auth-username"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                        class AuthUsernameRegex(Entity):
                                                                            """
                                                                            Authenticated User Name RegEx
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                self.yang_name = "auth-username-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "auth-username-regex"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                        class UnauthUsername(Entity):
                                                                            """
                                                                            Unauthenticated User Name
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                self.yang_name = "unauth-username"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "unauth-username"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                        class UnauthUsernameRegex(Entity):
                                                                            """
                                                                            Unauthenticated User Name RegEx
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                self.yang_name = "unauth-username-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "unauth-username-regex"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                        class AuthDomain(Entity):
                                                                            """
                                                                            Authenticated domain name
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                self.yang_name = "auth-domain"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "auth-domain"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                        class AuthDomainRegex(Entity):
                                                                            """
                                                                            Authenticated Domain Name RegEx
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                self.yang_name = "auth-domain-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "auth-domain-regex"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                        class UnauthDomain(Entity):
                                                                            """
                                                                            Unauthenticated Domain Name
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                self.yang_name = "unauth-domain"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "unauth-domain"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                        class UnauthDomainRegex(Entity):
                                                                            """
                                                                            Unauthenticated Domain Name RegEx
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                self.yang_name = "unauth-domain-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "unauth-domain-regex"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                        class VendorId(Entity):
                                                                            """
                                                                            Vendor ID
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                self.yang_name = "vendor-id"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "vendor-id"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                        class VendorIdRegex(Entity):
                                                                            """
                                                                            Vendor ID RegEx
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                self.yang_name = "vendor-id-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "vendor-id-regex"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                        class AccessInterface(Entity):
                                                                            """
                                                                            Access interface
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                self.yang_name = "access-interface"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "access-interface"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                        class InputInterface(Entity):
                                                                            """
                                                                            Input interface
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                self.yang_name = "input-interface"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "input-interface"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                        class InputIntfhdl(Entity):
                                                                            """
                                                                            Input interface handle
                                                                            
                                                                            .. attribute:: uint64_array
                                                                            
                                                                            	uint64 array
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                self.yang_name = "input-intfhdl"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('uint64_array', (YLeafList(YType.uint64, 'uint64_array'), ['int'])),
                                                                                ])
                                                                                self.uint64_array = []
                                                                                self._segment_path = lambda: "input-intfhdl"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                        class Ethertype(Entity):
                                                                            """
                                                                            Ethernet type
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                self.yang_name = "ethertype"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "ethertype"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "ethertype"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['min', 'max'], name, value)


                                                                        class FlowKeyData(Entity):
                                                                            """
                                                                            Flow key structure
                                                                            
                                                                            .. attribute:: flow_keys
                                                                            
                                                                            	flow keys
                                                                            	**type**\:  :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                            
                                                                            .. attribute:: max_count
                                                                            
                                                                            	Maximum count of flows
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: idle_timeout
                                                                            
                                                                            	Idle timeout of flows (in seconds)
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            	**units**\: second
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                self.yang_name = "flow-key-data"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("flow-keys", ("flow_keys", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('max_count', (YLeaf(YType.uint16, 'max-count'), ['int'])),
                                                                                    ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                                ])
                                                                                self.max_count = None
                                                                                self.idle_timeout = None

                                                                                self.flow_keys = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                self.flow_keys.parent = self
                                                                                self._children_name_map["flow_keys"] = "flow-keys"
                                                                                self._segment_path = lambda: "flow-key-data"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['max_count', 'idle_timeout'], name, value)


                                                                            class FlowKeys(Entity):
                                                                                """
                                                                                flow keys
                                                                                
                                                                                .. attribute:: keys
                                                                                
                                                                                	keys
                                                                                	**type**\: str
                                                                                
                                                                                	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                
                                                                                .. attribute:: num
                                                                                
                                                                                	num
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                    self.yang_name = "flow-keys"
                                                                                    self.yang_parent_name = "flow-key-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('keys', (YLeaf(YType.str, 'keys'), ['str'])),
                                                                                        ('num', (YLeaf(YType.uint8, 'num'), ['int'])),
                                                                                    ])
                                                                                    self.keys = None
                                                                                    self.num = None
                                                                                    self._segment_path = lambda: "flow-keys"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                        class DhcpClientId(Entity):
                                                                            """
                                                                            Dhcp Client ID
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                self.yang_name = "dhcp-client-id"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "dhcp-client-id"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                        class DhcpClientIdRegex(Entity):
                                                                            """
                                                                            Dhcp Client ID RegEx
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                self.yang_name = "dhcp-client-id-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "dhcp-client-id-regex"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                        class CircuitId(Entity):
                                                                            """
                                                                            Circuit ID
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                self.yang_name = "circuit-id"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "circuit-id"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                        class CircuitIdRegex(Entity):
                                                                            """
                                                                            Circuit ID RegEx
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                self.yang_name = "circuit-id-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "circuit-id-regex"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                        class RemoteId(Entity):
                                                                            """
                                                                            Remote ID
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                self.yang_name = "remote-id"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "remote-id"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                        class RemoteIdRegex(Entity):
                                                                            """
                                                                            Remote ID RegEx
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                self.yang_name = "remote-id-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "remote-id-regex"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                        class SrcPort(Entity):
                                                                            """
                                                                            Source port
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                self.yang_name = "src-port"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "src-port"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "src-port"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                        class DstPort(Entity):
                                                                            """
                                                                            Destination port
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                self.yang_name = "dst-port"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "dst-port"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "dst-port"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['min', 'max'], name, value)


                                                    class ClmpP(Entity):
                                                        """
                                                        clmp p
                                                        
                                                        .. attribute:: class_map_bg
                                                        
                                                        	class map bg
                                                        	**type**\: list of  		 :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2018-01-17'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP, self).__init__()

                                                            self.yang_name = "clmp-p"
                                                            self.yang_parent_name = "policy-class-info-bg"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("class-map-bg", ("class_map_bg", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg))])
                                                            self._leafs = OrderedDict()

                                                            self.class_map_bg = YList(self)
                                                            self._segment_path = lambda: "clmp-p"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP, [], name, value)


                                                        class ClassMapBg(Entity):
                                                            """
                                                            class map bg
                                                            
                                                            .. attribute:: match_infop
                                                            
                                                            	Pointer to the first Match info
                                                            	**type**\:  :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop>`
                                                            
                                                            .. attribute:: name
                                                            
                                                            	Name of the class\-map
                                                            	**type**\: str
                                                            
                                                            	**length:** 0..65
                                                            
                                                            .. attribute:: type
                                                            
                                                            	Class\-Map Type QoS/PBR/Netflow/..
                                                            	**type**\:  :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                            
                                                            .. attribute:: mode
                                                            
                                                            	Class\-Map Mode Match any/Match all
                                                            	**type**\:  :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                            
                                                            .. attribute:: description
                                                            
                                                            	description
                                                            	**type**\: str
                                                            
                                                            

                                                            """

                                                            _prefix = 'infra-policymgr-oper'
                                                            _revision = '2018-01-17'

                                                            def __init__(self):
                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg, self).__init__()

                                                                self.yang_name = "class-map-bg"
                                                                self.yang_parent_name = "clmp-p"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("match-infop", ("match_infop", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop))])
                                                                self._leafs = OrderedDict([
                                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapTypeEn', '')])),
                                                                    ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapModeEn', '')])),
                                                                    ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                ])
                                                                self.name = None
                                                                self.type = None
                                                                self.mode = None
                                                                self.description = None

                                                                self.match_infop = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop()
                                                                self.match_infop.parent = self
                                                                self._children_name_map["match_infop"] = "match-infop"
                                                                self._segment_path = lambda: "class-map-bg"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg, ['name', 'type', 'mode', 'description'], name, value)


                                                            class MatchInfop(Entity):
                                                                """
                                                                Pointer to the first Match info
                                                                
                                                                .. attribute:: class_match_info_st
                                                                
                                                                	class match info st
                                                                	**type**\: list of  		 :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop, self).__init__()

                                                                    self.yang_name = "match-infop"
                                                                    self.yang_parent_name = "class-map-bg"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("class-match-info-st", ("class_match_info_st", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt))])
                                                                    self._leafs = OrderedDict()

                                                                    self.class_match_info_st = YList(self)
                                                                    self._segment_path = lambda: "match-infop"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop, [], name, value)


                                                                class ClassMatchInfoSt(Entity):
                                                                    """
                                                                    class match info st
                                                                    
                                                                    .. attribute:: match_data
                                                                    
                                                                    	Match criteria
                                                                    	**type**\:  :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                    
                                                                    .. attribute:: flags
                                                                    
                                                                    	Flags
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                        self.yang_name = "class-match-info-st"
                                                                        self.yang_parent_name = "match-infop"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("match-data", ("match_data", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData))])
                                                                        self._leafs = OrderedDict([
                                                                            ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                        ])
                                                                        self.flags = None

                                                                        self.match_data = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                        self.match_data.parent = self
                                                                        self._children_name_map["match_data"] = "match-data"
                                                                        self._segment_path = lambda: "class-match-info-st"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                    class MatchData(Entity):
                                                                        """
                                                                        Match criteria
                                                                        
                                                                        .. attribute:: ipv4_dscp
                                                                        
                                                                        	IPv4 DSCP
                                                                        	**type**\:  :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                        
                                                                        .. attribute:: ipv6_dscp
                                                                        
                                                                        	IPv6 DSCP
                                                                        	**type**\:  :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                        
                                                                        .. attribute:: dscp
                                                                        
                                                                        	Match DSCP range array
                                                                        	**type**\:  :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                        
                                                                        .. attribute:: ipv4_prec
                                                                        
                                                                        	IPv4 Precedence
                                                                        	**type**\:  :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                        
                                                                        .. attribute:: ipv6_prec
                                                                        
                                                                        	IPv6 Precedence
                                                                        	**type**\:  :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                        
                                                                        .. attribute:: prec
                                                                        
                                                                        	Match Precedence array
                                                                        	**type**\:  :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                        
                                                                        .. attribute:: discard_class
                                                                        
                                                                        	Match Discard Class array
                                                                        	**type**\:  :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                        
                                                                        .. attribute:: qos_group
                                                                        
                                                                        	Match QoS group array
                                                                        	**type**\:  :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                        
                                                                        .. attribute:: traffic_class
                                                                        
                                                                        	Match Traffic class array
                                                                        	**type**\:  :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                        
                                                                        .. attribute:: proto
                                                                        
                                                                        	Match Protocol array
                                                                        	**type**\:  :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                        
                                                                        .. attribute:: icmp_v4
                                                                        
                                                                        	Match ICMPV4 Protocol
                                                                        	**type**\:  :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                        
                                                                        .. attribute:: icmp_v6
                                                                        
                                                                        	Match ICMPV6 Protocol array
                                                                        	**type**\:  :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                        
                                                                        .. attribute:: ipv4_packet_len
                                                                        
                                                                        	IPv4 packet length array
                                                                        	**type**\:  :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                        
                                                                        .. attribute:: ipv6_packet_len
                                                                        
                                                                        	IPv6 packet length array
                                                                        	**type**\:  :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                        
                                                                        .. attribute:: packet_len
                                                                        
                                                                        	Match packet length array
                                                                        	**type**\:  :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                        
                                                                        .. attribute:: flow_tag
                                                                        
                                                                        	Match flow\-tag array
                                                                        	**type**\:  :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                        
                                                                        .. attribute:: tcp_flag
                                                                        
                                                                        	Match tcp flag value
                                                                        	**type**\:  :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                        
                                                                        .. attribute:: icmpv4_type
                                                                        
                                                                        	Match ipv4 icmp type
                                                                        	**type**\:  :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                        
                                                                        .. attribute:: icmpv4_code
                                                                        
                                                                        	Match ipv4 icmp code
                                                                        	**type**\:  :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                        
                                                                        .. attribute:: icmpv6_type
                                                                        
                                                                        	Match ipv6 icmp type
                                                                        	**type**\:  :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                        
                                                                        .. attribute:: icmpv6_code
                                                                        
                                                                        	Match ipv6 icmp code
                                                                        	**type**\:  :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                        
                                                                        .. attribute:: mpls_exp
                                                                        
                                                                        	Match MPLS experimental topmost array
                                                                        	**type**\:  :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                        
                                                                        .. attribute:: mpls_exp_imp
                                                                        
                                                                        	Match MPLS experimental imposition array
                                                                        	**type**\:  :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                        
                                                                        .. attribute:: mpls_disp_ipv4_acl
                                                                        
                                                                        	MPLS Disposition IPv4 Access\-list
                                                                        	**type**\:  :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                        
                                                                        .. attribute:: mpls_disp_ipv6_acl
                                                                        
                                                                        	MPLS Disposition IPv6 Access\-list
                                                                        	**type**\:  :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                        
                                                                        .. attribute:: mpls_top_label
                                                                        
                                                                        	MPLS Topmost LABEL
                                                                        	**type**\:  :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                        
                                                                        .. attribute:: cos
                                                                        
                                                                        	Match CoS array
                                                                        	**type**\:  :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                        
                                                                        .. attribute:: cos_inr
                                                                        
                                                                        	Match inner header CoS
                                                                        	**type**\:  :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                        
                                                                        .. attribute:: dei
                                                                        
                                                                        	Match DEI Bit
                                                                        	**type**\:  :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                        
                                                                        .. attribute:: dei_inr
                                                                        
                                                                        	Match inner DEI Bit
                                                                        	**type**\:  :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                        
                                                                        .. attribute:: vlan
                                                                        
                                                                        	Match VLAN array
                                                                        	**type**\:  :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                        
                                                                        .. attribute:: vlan_inr
                                                                        
                                                                        	Match inner header VLAN range array
                                                                        	**type**\:  :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                        
                                                                        .. attribute:: fr_dlci
                                                                        
                                                                        	Match FR DLCI range array
                                                                        	**type**\:  :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                        
                                                                        .. attribute:: src_mac
                                                                        
                                                                        	Match Source MAC address
                                                                        	**type**\:  :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                        
                                                                        .. attribute:: dst_mac
                                                                        
                                                                        	Match Destination MAC address
                                                                        	**type**\:  :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                        
                                                                        .. attribute:: atm_clp
                                                                        
                                                                        	Match ATM CLP level
                                                                        	**type**\:  :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                        
                                                                        .. attribute:: fr_de
                                                                        
                                                                        	Match FR DE value
                                                                        	**type**\:  :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                        
                                                                        .. attribute:: ipv4_acl
                                                                        
                                                                        	IPv4 Access\-list
                                                                        	**type**\:  :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                        
                                                                        .. attribute:: ipv6_acl
                                                                        
                                                                        	IPv6 Access\-list
                                                                        	**type**\:  :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                        
                                                                        .. attribute:: ether_service_acl
                                                                        
                                                                        	Ethernet\-Services Access\-list
                                                                        	**type**\:  :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                        
                                                                        .. attribute:: avail_id
                                                                        
                                                                        	Available Identifiers
                                                                        	**type**\:  :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                        
                                                                        .. attribute:: media_type
                                                                        
                                                                        	Media Type
                                                                        	**type**\:  :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                        
                                                                        .. attribute:: subs_protocol
                                                                        
                                                                        	Protocol
                                                                        	**type**\:  :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                        
                                                                        .. attribute:: dnis
                                                                        
                                                                        	DNIS
                                                                        	**type**\:  :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                        
                                                                        .. attribute:: dnis_regex
                                                                        
                                                                        	DNIS Regular Expression
                                                                        	**type**\:  :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                        
                                                                        .. attribute:: domain
                                                                        
                                                                        	Domain Name
                                                                        	**type**\:  :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                        
                                                                        .. attribute:: domain_regex
                                                                        
                                                                        	Domain Regular Expression
                                                                        	**type**\:  :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                        
                                                                        .. attribute:: nas_port
                                                                        
                                                                        	NAS Port
                                                                        	**type**\:  :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                        
                                                                        .. attribute:: service_name
                                                                        
                                                                        	Service Name
                                                                        	**type**\:  :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                        
                                                                        .. attribute:: service_name_regex
                                                                        
                                                                        	Service Name Regular Exp
                                                                        	**type**\:  :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                        
                                                                        .. attribute:: src_addr_ipv4
                                                                        
                                                                        	Source Address IPV4
                                                                        	**type**\:  :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                        
                                                                        .. attribute:: dst_addr_ipv4
                                                                        
                                                                        	Destination Address IPV4
                                                                        	**type**\:  :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                        
                                                                        .. attribute:: src_addr_ipv6
                                                                        
                                                                        	Source Address IPV6
                                                                        	**type**\:  :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                        
                                                                        .. attribute:: dst_addr_ipv6
                                                                        
                                                                        	Destination Address IPV6
                                                                        	**type**\:  :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                        
                                                                        .. attribute:: src_addr_mac
                                                                        
                                                                        	Source Address MAC
                                                                        	**type**\:  :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                        
                                                                        .. attribute:: timer
                                                                        
                                                                        	Timer
                                                                        	**type**\:  :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                        
                                                                        .. attribute:: timer_regexp
                                                                        
                                                                        	Timer Regular Expression
                                                                        	**type**\:  :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                        
                                                                        .. attribute:: tunnel_name
                                                                        
                                                                        	Tunnel Name
                                                                        	**type**\:  :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                        
                                                                        .. attribute:: tunnel_name_regex
                                                                        
                                                                        	Tunnel Name Regular Expression
                                                                        	**type**\:  :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                        
                                                                        .. attribute:: user_name
                                                                        
                                                                        	User Name
                                                                        	**type**\:  :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                        
                                                                        .. attribute:: user_name_regex
                                                                        
                                                                        	User Name Regular Expression
                                                                        	**type**\:  :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                        
                                                                        .. attribute:: auth_username
                                                                        
                                                                        	Authenticated User Name
                                                                        	**type**\:  :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                        
                                                                        .. attribute:: auth_username_regex
                                                                        
                                                                        	Authenticated User Name RegEx
                                                                        	**type**\:  :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                        
                                                                        .. attribute:: unauth_username
                                                                        
                                                                        	Unauthenticated User Name
                                                                        	**type**\:  :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                        
                                                                        .. attribute:: unauth_username_regex
                                                                        
                                                                        	Unauthenticated User Name RegEx
                                                                        	**type**\:  :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                        
                                                                        .. attribute:: auth_domain
                                                                        
                                                                        	Authenticated domain name
                                                                        	**type**\:  :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                        
                                                                        .. attribute:: auth_domain_regex
                                                                        
                                                                        	Authenticated Domain Name RegEx
                                                                        	**type**\:  :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                        
                                                                        .. attribute:: unauth_domain
                                                                        
                                                                        	Unauthenticated Domain Name
                                                                        	**type**\:  :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                        
                                                                        .. attribute:: unauth_domain_regex
                                                                        
                                                                        	Unauthenticated Domain Name RegEx
                                                                        	**type**\:  :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                        
                                                                        .. attribute:: vendor_id
                                                                        
                                                                        	Vendor ID
                                                                        	**type**\:  :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                        
                                                                        .. attribute:: vendor_id_regex
                                                                        
                                                                        	Vendor ID RegEx
                                                                        	**type**\:  :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                        
                                                                        .. attribute:: access_interface
                                                                        
                                                                        	Access interface
                                                                        	**type**\:  :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                        
                                                                        .. attribute:: input_interface
                                                                        
                                                                        	Input interface
                                                                        	**type**\:  :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                        
                                                                        .. attribute:: input_intfhdl
                                                                        
                                                                        	Input interface handle
                                                                        	**type**\:  :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                        
                                                                        .. attribute:: ethertype
                                                                        
                                                                        	Ethernet type
                                                                        	**type**\:  :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                        
                                                                        .. attribute:: flow_key_data
                                                                        
                                                                        	Flow key structure
                                                                        	**type**\:  :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                        
                                                                        .. attribute:: dhcp_client_id
                                                                        
                                                                        	Dhcp Client ID
                                                                        	**type**\:  :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                        
                                                                        .. attribute:: dhcp_client_id_regex
                                                                        
                                                                        	Dhcp Client ID RegEx
                                                                        	**type**\:  :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                        
                                                                        .. attribute:: circuit_id
                                                                        
                                                                        	Circuit ID
                                                                        	**type**\:  :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                        
                                                                        .. attribute:: circuit_id_regex
                                                                        
                                                                        	Circuit ID RegEx
                                                                        	**type**\:  :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                        
                                                                        .. attribute:: remote_id
                                                                        
                                                                        	Remote ID
                                                                        	**type**\:  :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                        
                                                                        .. attribute:: remote_id_regex
                                                                        
                                                                        	Remote ID RegEx
                                                                        	**type**\:  :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                        
                                                                        .. attribute:: src_port
                                                                        
                                                                        	Source port
                                                                        	**type**\:  :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                        
                                                                        .. attribute:: dst_port
                                                                        
                                                                        	Destination port
                                                                        	**type**\:  :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                        
                                                                        .. attribute:: type
                                                                        
                                                                        	type
                                                                        	**type**\:  :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                        
                                                                        .. attribute:: mpls_top_eos
                                                                        
                                                                        	MPLS Topmost EOS
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: fragment_type
                                                                        
                                                                        	Fragment type
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: authen_status
                                                                        
                                                                        	Authentication Status
                                                                        	**type**\:  :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                        
                                                                        .. attribute:: mlp_negotiated
                                                                        
                                                                        	MLP Negotiated
                                                                        	**type**\:  :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                            self.yang_name = "match-data"
                                                                            self.yang_parent_name = "class-match-info-st"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("ipv4-dscp", ("ipv4_dscp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp)), ("ipv6-dscp", ("ipv6_dscp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp)), ("dscp", ("dscp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp)), ("ipv4-prec", ("ipv4_prec", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec)), ("ipv6-prec", ("ipv6_prec", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec)), ("prec", ("prec", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec)), ("discard-class", ("discard_class", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass)), ("qos-group", ("qos_group", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup)), ("traffic-class", ("traffic_class", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass)), ("proto", ("proto", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto)), ("icmp-v4", ("icmp_v4", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4)), ("icmp-v6", ("icmp_v6", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6)), ("ipv4-packet-len", ("ipv4_packet_len", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen)), ("ipv6-packet-len", ("ipv6_packet_len", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen)), ("packet-len", ("packet_len", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen)), ("flow-tag", ("flow_tag", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag)), ("tcp-flag", ("tcp_flag", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag)), ("icmpv4-type", ("icmpv4_type", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type)), ("icmpv4-code", ("icmpv4_code", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code)), ("icmpv6-type", ("icmpv6_type", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type)), ("icmpv6-code", ("icmpv6_code", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code)), ("mpls-exp", ("mpls_exp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp)), ("mpls-exp-imp", ("mpls_exp_imp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp)), ("mpls-disp-ipv4-acl", ("mpls_disp_ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl)), ("mpls-disp-ipv6-acl", ("mpls_disp_ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl)), ("mpls-top-label", ("mpls_top_label", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel)), ("cos", ("cos", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos)), ("cos-inr", ("cos_inr", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr)), ("dei", ("dei", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei)), ("dei-inr", ("dei_inr", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr)), ("vlan", ("vlan", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan)), ("vlan-inr", ("vlan_inr", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)), ("fr-dlci", ("fr_dlci", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci)), ("src-mac", ("src_mac", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac)), ("dst-mac", ("dst_mac", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac)), ("atm-clp", ("atm_clp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp)), ("fr-de", ("fr_de", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe)), ("ipv4-acl", ("ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl)), ("ipv6-acl", ("ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl)), ("ether-service-acl", ("ether_service_acl", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl)), ("avail-id", ("avail_id", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId)), ("media-type", ("media_type", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType)), ("subs-protocol", ("subs_protocol", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol)), ("dnis", ("dnis", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis)), ("dnis-regex", ("dnis_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex)), ("domain", ("domain", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain)), ("domain-regex", ("domain_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex)), ("nas-port", ("nas_port", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort)), ("service-name", ("service_name", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName)), ("service-name-regex", ("service_name_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex)), ("src-addr-ipv4", ("src_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4)), ("dst-addr-ipv4", ("dst_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4)), ("src-addr-ipv6", ("src_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6)), ("dst-addr-ipv6", ("dst_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6)), ("src-addr-mac", ("src_addr_mac", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac)), ("timer", ("timer", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer)), ("timer-regexp", ("timer_regexp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp)), ("tunnel-name", ("tunnel_name", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName)), ("tunnel-name-regex", ("tunnel_name_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex)), ("user-name", ("user_name", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName)), ("user-name-regex", ("user_name_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex)), ("auth-username", ("auth_username", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername)), ("auth-username-regex", ("auth_username_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex)), ("unauth-username", ("unauth_username", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername)), ("unauth-username-regex", ("unauth_username_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex)), ("auth-domain", ("auth_domain", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain)), ("auth-domain-regex", ("auth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex)), ("unauth-domain", ("unauth_domain", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain)), ("unauth-domain-regex", ("unauth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex)), ("vendor-id", ("vendor_id", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId)), ("vendor-id-regex", ("vendor_id_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex)), ("access-interface", ("access_interface", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface)), ("input-interface", ("input_interface", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface)), ("input-intfhdl", ("input_intfhdl", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl)), ("ethertype", ("ethertype", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype)), ("flow-key-data", ("flow_key_data", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData)), ("dhcp-client-id", ("dhcp_client_id", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId)), ("dhcp-client-id-regex", ("dhcp_client_id_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex)), ("circuit-id", ("circuit_id", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId)), ("circuit-id-regex", ("circuit_id_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex)), ("remote-id", ("remote_id", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId)), ("remote-id-regex", ("remote_id_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex)), ("src-port", ("src_port", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort)), ("dst-port", ("dst_port", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort))])
                                                                            self._leafs = OrderedDict([
                                                                                ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchTypeEn', '')])),
                                                                                ('mpls_top_eos', (YLeaf(YType.uint8, 'mpls-top-eos'), ['int'])),
                                                                                ('fragment_type', (YLeaf(YType.uint8, 'fragment-type'), ['int'])),
                                                                                ('authen_status', (YLeaf(YType.enumeration, 'authen-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchAuthenStatusEn', '')])),
                                                                                ('mlp_negotiated', (YLeaf(YType.enumeration, 'mlp-negotiated'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchMlpNegotiatedEn', '')])),
                                                                            ])
                                                                            self.type = None
                                                                            self.mpls_top_eos = None
                                                                            self.fragment_type = None
                                                                            self.authen_status = None
                                                                            self.mlp_negotiated = None

                                                                            self.ipv4_dscp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                            self.ipv4_dscp.parent = self
                                                                            self._children_name_map["ipv4_dscp"] = "ipv4-dscp"

                                                                            self.ipv6_dscp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                            self.ipv6_dscp.parent = self
                                                                            self._children_name_map["ipv6_dscp"] = "ipv6-dscp"

                                                                            self.dscp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                            self.dscp.parent = self
                                                                            self._children_name_map["dscp"] = "dscp"

                                                                            self.ipv4_prec = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                            self.ipv4_prec.parent = self
                                                                            self._children_name_map["ipv4_prec"] = "ipv4-prec"

                                                                            self.ipv6_prec = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                            self.ipv6_prec.parent = self
                                                                            self._children_name_map["ipv6_prec"] = "ipv6-prec"

                                                                            self.prec = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                            self.prec.parent = self
                                                                            self._children_name_map["prec"] = "prec"

                                                                            self.discard_class = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                            self.discard_class.parent = self
                                                                            self._children_name_map["discard_class"] = "discard-class"

                                                                            self.qos_group = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                            self.qos_group.parent = self
                                                                            self._children_name_map["qos_group"] = "qos-group"

                                                                            self.traffic_class = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                            self.traffic_class.parent = self
                                                                            self._children_name_map["traffic_class"] = "traffic-class"

                                                                            self.proto = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                            self.proto.parent = self
                                                                            self._children_name_map["proto"] = "proto"

                                                                            self.icmp_v4 = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                            self.icmp_v4.parent = self
                                                                            self._children_name_map["icmp_v4"] = "icmp-v4"

                                                                            self.icmp_v6 = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                            self.icmp_v6.parent = self
                                                                            self._children_name_map["icmp_v6"] = "icmp-v6"

                                                                            self.ipv4_packet_len = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                            self.ipv4_packet_len.parent = self
                                                                            self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"

                                                                            self.ipv6_packet_len = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                            self.ipv6_packet_len.parent = self
                                                                            self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"

                                                                            self.packet_len = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                            self.packet_len.parent = self
                                                                            self._children_name_map["packet_len"] = "packet-len"

                                                                            self.flow_tag = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                            self.flow_tag.parent = self
                                                                            self._children_name_map["flow_tag"] = "flow-tag"

                                                                            self.tcp_flag = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                            self.tcp_flag.parent = self
                                                                            self._children_name_map["tcp_flag"] = "tcp-flag"

                                                                            self.icmpv4_type = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                            self.icmpv4_type.parent = self
                                                                            self._children_name_map["icmpv4_type"] = "icmpv4-type"

                                                                            self.icmpv4_code = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                            self.icmpv4_code.parent = self
                                                                            self._children_name_map["icmpv4_code"] = "icmpv4-code"

                                                                            self.icmpv6_type = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                            self.icmpv6_type.parent = self
                                                                            self._children_name_map["icmpv6_type"] = "icmpv6-type"

                                                                            self.icmpv6_code = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                            self.icmpv6_code.parent = self
                                                                            self._children_name_map["icmpv6_code"] = "icmpv6-code"

                                                                            self.mpls_exp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                            self.mpls_exp.parent = self
                                                                            self._children_name_map["mpls_exp"] = "mpls-exp"

                                                                            self.mpls_exp_imp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                            self.mpls_exp_imp.parent = self
                                                                            self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"

                                                                            self.mpls_disp_ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                            self.mpls_disp_ipv4_acl.parent = self
                                                                            self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"

                                                                            self.mpls_disp_ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                            self.mpls_disp_ipv6_acl.parent = self
                                                                            self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"

                                                                            self.mpls_top_label = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                            self.mpls_top_label.parent = self
                                                                            self._children_name_map["mpls_top_label"] = "mpls-top-label"

                                                                            self.cos = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                            self.cos.parent = self
                                                                            self._children_name_map["cos"] = "cos"

                                                                            self.cos_inr = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                            self.cos_inr.parent = self
                                                                            self._children_name_map["cos_inr"] = "cos-inr"

                                                                            self.dei = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                            self.dei.parent = self
                                                                            self._children_name_map["dei"] = "dei"

                                                                            self.dei_inr = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                            self.dei_inr.parent = self
                                                                            self._children_name_map["dei_inr"] = "dei-inr"

                                                                            self.vlan = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                            self.vlan.parent = self
                                                                            self._children_name_map["vlan"] = "vlan"

                                                                            self.vlan_inr = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                            self.vlan_inr.parent = self
                                                                            self._children_name_map["vlan_inr"] = "vlan-inr"

                                                                            self.fr_dlci = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                            self.fr_dlci.parent = self
                                                                            self._children_name_map["fr_dlci"] = "fr-dlci"

                                                                            self.src_mac = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                            self.src_mac.parent = self
                                                                            self._children_name_map["src_mac"] = "src-mac"

                                                                            self.dst_mac = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                            self.dst_mac.parent = self
                                                                            self._children_name_map["dst_mac"] = "dst-mac"

                                                                            self.atm_clp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                            self.atm_clp.parent = self
                                                                            self._children_name_map["atm_clp"] = "atm-clp"

                                                                            self.fr_de = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                            self.fr_de.parent = self
                                                                            self._children_name_map["fr_de"] = "fr-de"

                                                                            self.ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                            self.ipv4_acl.parent = self
                                                                            self._children_name_map["ipv4_acl"] = "ipv4-acl"

                                                                            self.ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                            self.ipv6_acl.parent = self
                                                                            self._children_name_map["ipv6_acl"] = "ipv6-acl"

                                                                            self.ether_service_acl = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                            self.ether_service_acl.parent = self
                                                                            self._children_name_map["ether_service_acl"] = "ether-service-acl"

                                                                            self.avail_id = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                            self.avail_id.parent = self
                                                                            self._children_name_map["avail_id"] = "avail-id"

                                                                            self.media_type = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                            self.media_type.parent = self
                                                                            self._children_name_map["media_type"] = "media-type"

                                                                            self.subs_protocol = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                            self.subs_protocol.parent = self
                                                                            self._children_name_map["subs_protocol"] = "subs-protocol"

                                                                            self.dnis = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                            self.dnis.parent = self
                                                                            self._children_name_map["dnis"] = "dnis"

                                                                            self.dnis_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                            self.dnis_regex.parent = self
                                                                            self._children_name_map["dnis_regex"] = "dnis-regex"

                                                                            self.domain = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                            self.domain.parent = self
                                                                            self._children_name_map["domain"] = "domain"

                                                                            self.domain_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                            self.domain_regex.parent = self
                                                                            self._children_name_map["domain_regex"] = "domain-regex"

                                                                            self.nas_port = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                            self.nas_port.parent = self
                                                                            self._children_name_map["nas_port"] = "nas-port"

                                                                            self.service_name = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                            self.service_name.parent = self
                                                                            self._children_name_map["service_name"] = "service-name"

                                                                            self.service_name_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                            self.service_name_regex.parent = self
                                                                            self._children_name_map["service_name_regex"] = "service-name-regex"

                                                                            self.src_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                            self.src_addr_ipv4.parent = self
                                                                            self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"

                                                                            self.dst_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                            self.dst_addr_ipv4.parent = self
                                                                            self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"

                                                                            self.src_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                            self.src_addr_ipv6.parent = self
                                                                            self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"

                                                                            self.dst_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                            self.dst_addr_ipv6.parent = self
                                                                            self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"

                                                                            self.src_addr_mac = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                            self.src_addr_mac.parent = self
                                                                            self._children_name_map["src_addr_mac"] = "src-addr-mac"

                                                                            self.timer = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                            self.timer.parent = self
                                                                            self._children_name_map["timer"] = "timer"

                                                                            self.timer_regexp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                            self.timer_regexp.parent = self
                                                                            self._children_name_map["timer_regexp"] = "timer-regexp"

                                                                            self.tunnel_name = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                            self.tunnel_name.parent = self
                                                                            self._children_name_map["tunnel_name"] = "tunnel-name"

                                                                            self.tunnel_name_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                            self.tunnel_name_regex.parent = self
                                                                            self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"

                                                                            self.user_name = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                            self.user_name.parent = self
                                                                            self._children_name_map["user_name"] = "user-name"

                                                                            self.user_name_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                            self.user_name_regex.parent = self
                                                                            self._children_name_map["user_name_regex"] = "user-name-regex"

                                                                            self.auth_username = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                            self.auth_username.parent = self
                                                                            self._children_name_map["auth_username"] = "auth-username"

                                                                            self.auth_username_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                            self.auth_username_regex.parent = self
                                                                            self._children_name_map["auth_username_regex"] = "auth-username-regex"

                                                                            self.unauth_username = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                            self.unauth_username.parent = self
                                                                            self._children_name_map["unauth_username"] = "unauth-username"

                                                                            self.unauth_username_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                            self.unauth_username_regex.parent = self
                                                                            self._children_name_map["unauth_username_regex"] = "unauth-username-regex"

                                                                            self.auth_domain = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                            self.auth_domain.parent = self
                                                                            self._children_name_map["auth_domain"] = "auth-domain"

                                                                            self.auth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                            self.auth_domain_regex.parent = self
                                                                            self._children_name_map["auth_domain_regex"] = "auth-domain-regex"

                                                                            self.unauth_domain = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                            self.unauth_domain.parent = self
                                                                            self._children_name_map["unauth_domain"] = "unauth-domain"

                                                                            self.unauth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                            self.unauth_domain_regex.parent = self
                                                                            self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"

                                                                            self.vendor_id = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                            self.vendor_id.parent = self
                                                                            self._children_name_map["vendor_id"] = "vendor-id"

                                                                            self.vendor_id_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                            self.vendor_id_regex.parent = self
                                                                            self._children_name_map["vendor_id_regex"] = "vendor-id-regex"

                                                                            self.access_interface = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                            self.access_interface.parent = self
                                                                            self._children_name_map["access_interface"] = "access-interface"

                                                                            self.input_interface = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                            self.input_interface.parent = self
                                                                            self._children_name_map["input_interface"] = "input-interface"

                                                                            self.input_intfhdl = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                            self.input_intfhdl.parent = self
                                                                            self._children_name_map["input_intfhdl"] = "input-intfhdl"

                                                                            self.ethertype = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                            self.ethertype.parent = self
                                                                            self._children_name_map["ethertype"] = "ethertype"

                                                                            self.flow_key_data = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                            self.flow_key_data.parent = self
                                                                            self._children_name_map["flow_key_data"] = "flow-key-data"

                                                                            self.dhcp_client_id = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                            self.dhcp_client_id.parent = self
                                                                            self._children_name_map["dhcp_client_id"] = "dhcp-client-id"

                                                                            self.dhcp_client_id_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                            self.dhcp_client_id_regex.parent = self
                                                                            self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"

                                                                            self.circuit_id = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                            self.circuit_id.parent = self
                                                                            self._children_name_map["circuit_id"] = "circuit-id"

                                                                            self.circuit_id_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                            self.circuit_id_regex.parent = self
                                                                            self._children_name_map["circuit_id_regex"] = "circuit-id-regex"

                                                                            self.remote_id = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                            self.remote_id.parent = self
                                                                            self._children_name_map["remote_id"] = "remote-id"

                                                                            self.remote_id_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                            self.remote_id_regex.parent = self
                                                                            self._children_name_map["remote_id_regex"] = "remote-id-regex"

                                                                            self.src_port = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                            self.src_port.parent = self
                                                                            self._children_name_map["src_port"] = "src-port"

                                                                            self.dst_port = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                            self.dst_port.parent = self
                                                                            self._children_name_map["dst_port"] = "dst-port"
                                                                            self._segment_path = lambda: "match-data"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['type', 'mpls_top_eos', 'fragment_type', 'authen_status', 'mlp_negotiated'], name, value)


                                                                        class Ipv4Dscp(Entity):
                                                                            """
                                                                            IPv4 DSCP
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                self.yang_name = "ipv4-dscp"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "ipv4-dscp"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "ipv4-dscp"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                        class Ipv6Dscp(Entity):
                                                                            """
                                                                            IPv6 DSCP
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                self.yang_name = "ipv6-dscp"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "ipv6-dscp"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "ipv6-dscp"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                        class Dscp(Entity):
                                                                            """
                                                                            Match DSCP range array
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                self.yang_name = "dscp"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "dscp"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "dscp"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                        class Ipv4Prec(Entity):
                                                                            """
                                                                            IPv4 Precedence
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                self.yang_name = "ipv4-prec"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                ])
                                                                                self.uint8_array = []
                                                                                self._segment_path = lambda: "ipv4-prec"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                        class Ipv6Prec(Entity):
                                                                            """
                                                                            IPv6 Precedence
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                self.yang_name = "ipv6-prec"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                ])
                                                                                self.uint8_array = []
                                                                                self._segment_path = lambda: "ipv6-prec"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                        class Prec(Entity):
                                                                            """
                                                                            Match Precedence array
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                self.yang_name = "prec"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                ])
                                                                                self.uint8_array = []
                                                                                self._segment_path = lambda: "prec"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                        class DiscardClass(Entity):
                                                                            """
                                                                            Match Discard Class array
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                self.yang_name = "discard-class"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                ])
                                                                                self.uint8_array = []
                                                                                self._segment_path = lambda: "discard-class"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                        class QosGroup(Entity):
                                                                            """
                                                                            Match QoS group array
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                self.yang_name = "qos-group"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "qos-group"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "qos-group"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['min', 'max'], name, value)


                                                                        class TrafficClass(Entity):
                                                                            """
                                                                            Match Traffic class array
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                self.yang_name = "traffic-class"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "traffic-class"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "traffic-class"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['min', 'max'], name, value)


                                                                        class Proto(Entity):
                                                                            """
                                                                            Match Protocol array
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                self.yang_name = "proto"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "proto"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "proto"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['min', 'max'], name, value)


                                                                        class IcmpV4(Entity):
                                                                            """
                                                                            Match ICMPV4 Protocol
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	Protocol type
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: code
                                                                            
                                                                            	Protocol code
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                self.yang_name = "icmp-v4"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                    ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                ])
                                                                                self.type = None
                                                                                self.code = None
                                                                                self._segment_path = lambda: "icmp-v4"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['type', 'code'], name, value)


                                                                        class IcmpV6(Entity):
                                                                            """
                                                                            Match ICMPV6 Protocol array
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	Protocol type
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: code
                                                                            
                                                                            	Protocol code
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                self.yang_name = "icmp-v6"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                    ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                ])
                                                                                self.type = None
                                                                                self.code = None
                                                                                self._segment_path = lambda: "icmp-v6"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['type', 'code'], name, value)


                                                                        class Ipv4PacketLen(Entity):
                                                                            """
                                                                            IPv4 packet length array
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                self.yang_name = "ipv4-packet-len"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "ipv4-packet-len"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "ipv4-packet-len"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                        class Ipv6PacketLen(Entity):
                                                                            """
                                                                            IPv6 packet length array
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                self.yang_name = "ipv6-packet-len"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "ipv6-packet-len"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "ipv6-packet-len"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                        class PacketLen(Entity):
                                                                            """
                                                                            Match packet length array
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                self.yang_name = "packet-len"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "packet-len"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "packet-len"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                        class FlowTag(Entity):
                                                                            """
                                                                            Match flow\-tag array
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                self.yang_name = "flow-tag"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "flow-tag"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "flow-tag"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['min', 'max'], name, value)


                                                                        class TcpFlag(Entity):
                                                                            """
                                                                            Match tcp flag value
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	Value of TCP flag
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: match_any
                                                                            
                                                                            	Match any TCP flag bit
                                                                            	**type**\: bool
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                self.yang_name = "tcp-flag"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                    ('match_any', (YLeaf(YType.boolean, 'match-any'), ['bool'])),
                                                                                ])
                                                                                self.value = None
                                                                                self.match_any = None
                                                                                self._segment_path = lambda: "tcp-flag"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['value', 'match_any'], name, value)


                                                                        class Icmpv4Type(Entity):
                                                                            """
                                                                            Match ipv4 icmp type
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                self.yang_name = "icmpv4-type"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "icmpv4-type"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "icmpv4-type"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                        class Icmpv4Code(Entity):
                                                                            """
                                                                            Match ipv4 icmp code
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                self.yang_name = "icmpv4-code"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "icmpv4-code"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "icmpv4-code"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                        class Icmpv6Type(Entity):
                                                                            """
                                                                            Match ipv6 icmp type
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                self.yang_name = "icmpv6-type"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "icmpv6-type"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "icmpv6-type"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                        class Icmpv6Code(Entity):
                                                                            """
                                                                            Match ipv6 icmp code
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                self.yang_name = "icmpv6-code"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "icmpv6-code"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "icmpv6-code"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                        class MplsExp(Entity):
                                                                            """
                                                                            Match MPLS experimental topmost array
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                self.yang_name = "mpls-exp"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                ])
                                                                                self.uint8_array = []
                                                                                self._segment_path = lambda: "mpls-exp"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                        class MplsExpImp(Entity):
                                                                            """
                                                                            Match MPLS experimental imposition array
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                self.yang_name = "mpls-exp-imp"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                ])
                                                                                self.uint8_array = []
                                                                                self._segment_path = lambda: "mpls-exp-imp"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                        class MplsDispIpv4Acl(Entity):
                                                                            """
                                                                            MPLS Disposition IPv4 Access\-list
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                self.yang_name = "mpls-disp-ipv4-acl"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "mpls-disp-ipv4-acl"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                        class MplsDispIpv6Acl(Entity):
                                                                            """
                                                                            MPLS Disposition IPv6 Access\-list
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                self.yang_name = "mpls-disp-ipv6-acl"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "mpls-disp-ipv6-acl"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                        class MplsTopLabel(Entity):
                                                                            """
                                                                            MPLS Topmost LABEL
                                                                            
                                                                            .. attribute:: uint32_rng_array
                                                                            
                                                                            	uint32 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                self.yang_name = "mpls-top-label"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint32_rng_array", ("uint32_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint32_rng_array = YList(self)
                                                                                self._segment_path = lambda: "mpls-top-label"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                            class Uint32RngArray(Entity):
                                                                                """
                                                                                uint32 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                    self.yang_name = "uint32_rng_array"
                                                                                    self.yang_parent_name = "mpls-top-label"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint32, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint32, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint32_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['min', 'max'], name, value)


                                                                        class Cos(Entity):
                                                                            """
                                                                            Match CoS array
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                self.yang_name = "cos"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                ])
                                                                                self.uint8_array = []
                                                                                self._segment_path = lambda: "cos"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                        class CosInr(Entity):
                                                                            """
                                                                            Match inner header CoS
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                self.yang_name = "cos-inr"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                ])
                                                                                self.uint8_array = []
                                                                                self._segment_path = lambda: "cos-inr"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                        class Dei(Entity):
                                                                            """
                                                                            Match DEI Bit
                                                                            
                                                                            .. attribute:: bit_value
                                                                            
                                                                            	Value of the DEI bit
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                self.yang_name = "dei"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                ])
                                                                                self.bit_value = None
                                                                                self._segment_path = lambda: "dei"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                        class DeiInr(Entity):
                                                                            """
                                                                            Match inner DEI Bit
                                                                            
                                                                            .. attribute:: bit_value
                                                                            
                                                                            	Value of the DEI bit
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                self.yang_name = "dei-inr"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                ])
                                                                                self.bit_value = None
                                                                                self._segment_path = lambda: "dei-inr"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                        class Vlan(Entity):
                                                                            """
                                                                            Match VLAN array
                                                                            
                                                                            .. attribute:: vlan_id_array
                                                                            
                                                                            	vlan id array
                                                                            	**type**\: list of  		 :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                self.yang_name = "vlan"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("vlan-id-array", ("vlan_id_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.vlan_id_array = YList(self)
                                                                                self._segment_path = lambda: "vlan"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                            class VlanIdArray(Entity):
                                                                                """
                                                                                vlan id array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	VLAN mask
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                    self.yang_name = "vlan-id-array"
                                                                                    self.yang_parent_name = "vlan"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                        ('mask', (YLeaf(YType.uint16, 'mask'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self.mask = None
                                                                                    self._segment_path = lambda: "vlan-id-array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['min', 'max', 'mask'], name, value)


                                                                        class VlanInr(Entity):
                                                                            """
                                                                            Match inner header VLAN range array
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                self.yang_name = "vlan-inr"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "vlan-inr"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "vlan-inr"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['min', 'max'], name, value)


                                                                        class FrDlci(Entity):
                                                                            """
                                                                            Match FR DLCI range array
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                self.yang_name = "fr-dlci"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "fr-dlci"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "fr-dlci"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['min', 'max'], name, value)


                                                                        class SrcMac(Entity):
                                                                            """
                                                                            Match Source MAC address
                                                                            
                                                                            .. attribute:: mac_addr
                                                                            
                                                                            	MAC address
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: mask
                                                                            
                                                                            	MAC mask
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                self.yang_name = "src-mac"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                    ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                ])
                                                                                self.mac_addr = []
                                                                                self.mask = []
                                                                                self._segment_path = lambda: "src-mac"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                        class DstMac(Entity):
                                                                            """
                                                                            Match Destination MAC address
                                                                            
                                                                            .. attribute:: mac_addr
                                                                            
                                                                            	MAC address
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: mask
                                                                            
                                                                            	MAC mask
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                self.yang_name = "dst-mac"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                    ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                ])
                                                                                self.mac_addr = []
                                                                                self.mask = []
                                                                                self._segment_path = lambda: "dst-mac"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                        class AtmClp(Entity):
                                                                            """
                                                                            Match ATM CLP level
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                self.yang_name = "atm-clp"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                ])
                                                                                self.uint8_array = []
                                                                                self._segment_path = lambda: "atm-clp"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                        class FrDe(Entity):
                                                                            """
                                                                            Match FR DE value
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                self.yang_name = "fr-de"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                ])
                                                                                self.uint8_array = []
                                                                                self._segment_path = lambda: "fr-de"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                        class Ipv4Acl(Entity):
                                                                            """
                                                                            IPv4 Access\-list
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                self.yang_name = "ipv4-acl"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "ipv4-acl"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                        class Ipv6Acl(Entity):
                                                                            """
                                                                            IPv6 Access\-list
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                self.yang_name = "ipv6-acl"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "ipv6-acl"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                        class EtherServiceAcl(Entity):
                                                                            """
                                                                            Ethernet\-Services Access\-list
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                self.yang_name = "ether-service-acl"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "ether-service-acl"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                        class AvailId(Entity):
                                                                            """
                                                                            Available Identifiers
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                self.yang_name = "avail-id"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                ])
                                                                                self.uint8_array = []
                                                                                self._segment_path = lambda: "avail-id"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                        class MediaType(Entity):
                                                                            """
                                                                            Media Type
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                self.yang_name = "media-type"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                ])
                                                                                self.uint8_array = []
                                                                                self._segment_path = lambda: "media-type"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                        class SubsProtocol(Entity):
                                                                            """
                                                                            Protocol
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                self.yang_name = "subs-protocol"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                ])
                                                                                self.uint8_array = []
                                                                                self._segment_path = lambda: "subs-protocol"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                        class Dnis(Entity):
                                                                            """
                                                                            DNIS
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                self.yang_name = "dnis"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "dnis"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                        class DnisRegex(Entity):
                                                                            """
                                                                            DNIS Regular Expression
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                self.yang_name = "dnis-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "dnis-regex"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                        class Domain(Entity):
                                                                            """
                                                                            Domain Name
                                                                            
                                                                            .. attribute:: domain_array
                                                                            
                                                                            	domain array
                                                                            	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                self.yang_name = "domain"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.domain_array = YList(self)
                                                                                self._segment_path = lambda: "domain"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                            class DomainArray(Entity):
                                                                                """
                                                                                domain array
                                                                                
                                                                                .. attribute:: domain_name
                                                                                
                                                                                	domain name
                                                                                	**type**\: str
                                                                                
                                                                                .. attribute:: format_name
                                                                                
                                                                                	format name
                                                                                	**type**\: str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                    self.yang_name = "domain-array"
                                                                                    self.yang_parent_name = "domain"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                        ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                    ])
                                                                                    self.domain_name = None
                                                                                    self.format_name = None
                                                                                    self._segment_path = lambda: "domain-array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                        class DomainRegex(Entity):
                                                                            """
                                                                            Domain Regular Expression
                                                                            
                                                                            .. attribute:: domain_array
                                                                            
                                                                            	domain array
                                                                            	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                self.yang_name = "domain-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.domain_array = YList(self)
                                                                                self._segment_path = lambda: "domain-regex"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                            class DomainArray(Entity):
                                                                                """
                                                                                domain array
                                                                                
                                                                                .. attribute:: domain_name
                                                                                
                                                                                	domain name
                                                                                	**type**\: str
                                                                                
                                                                                .. attribute:: format_name
                                                                                
                                                                                	format name
                                                                                	**type**\: str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                    self.yang_name = "domain-array"
                                                                                    self.yang_parent_name = "domain-regex"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                        ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                    ])
                                                                                    self.domain_name = None
                                                                                    self.format_name = None
                                                                                    self._segment_path = lambda: "domain-array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                        class NasPort(Entity):
                                                                            """
                                                                            NAS Port
                                                                            
                                                                            .. attribute:: nas_port_array
                                                                            
                                                                            	nas port array
                                                                            	**type**\: list of  		 :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                self.yang_name = "nas-port"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("nas-port-array", ("nas_port_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.nas_port_array = YList(self)
                                                                                self._segment_path = lambda: "nas-port"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                            class NasPortArray(Entity):
                                                                                """
                                                                                nas port array
                                                                                
                                                                                .. attribute:: sub_id
                                                                                
                                                                                	sub id
                                                                                	**type**\:  :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                
                                                                                .. attribute:: operator
                                                                                
                                                                                	operator
                                                                                	**type**\:  :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                    self.yang_name = "nas-port-array"
                                                                                    self.yang_parent_name = "nas-port"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('sub_id', (YLeaf(YType.enumeration, 'sub-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchNasPortSubIdEn', '')])),
                                                                                        ('operator', (YLeaf(YType.enumeration, 'operator'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchLogicalOperatorEn', '')])),
                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ])
                                                                                    self.sub_id = None
                                                                                    self.operator = None
                                                                                    self.value = None
                                                                                    self._segment_path = lambda: "nas-port-array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['sub_id', 'operator', 'value'], name, value)


                                                                        class ServiceName(Entity):
                                                                            """
                                                                            Service Name
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                self.yang_name = "service-name"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "service-name"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                        class ServiceNameRegex(Entity):
                                                                            """
                                                                            Service Name Regular Exp
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                self.yang_name = "service-name-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "service-name-regex"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                        class SrcAddrIpv4(Entity):
                                                                            """
                                                                            Source Address IPV4
                                                                            
                                                                            .. attribute:: ipv4_addr_array
                                                                            
                                                                            	ipv4 addr array
                                                                            	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                self.yang_name = "src-addr-ipv4"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.ipv4_addr_array = YList(self)
                                                                                self._segment_path = lambda: "src-addr-ipv4"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                            class Ipv4AddrArray(Entity):
                                                                                """
                                                                                ipv4 addr array
                                                                                
                                                                                .. attribute:: prefix
                                                                                
                                                                                	prefix
                                                                                	**type**\: str
                                                                                
                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	mask
                                                                                	**type**\: str
                                                                                
                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                    self.yang_name = "ipv4-addr-array"
                                                                                    self.yang_parent_name = "src-addr-ipv4"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                        ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                    ])
                                                                                    self.prefix = None
                                                                                    self.mask = None
                                                                                    self._segment_path = lambda: "ipv4-addr-array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                        class DstAddrIpv4(Entity):
                                                                            """
                                                                            Destination Address IPV4
                                                                            
                                                                            .. attribute:: ipv4_addr_array
                                                                            
                                                                            	ipv4 addr array
                                                                            	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                self.yang_name = "dst-addr-ipv4"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.ipv4_addr_array = YList(self)
                                                                                self._segment_path = lambda: "dst-addr-ipv4"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                            class Ipv4AddrArray(Entity):
                                                                                """
                                                                                ipv4 addr array
                                                                                
                                                                                .. attribute:: prefix
                                                                                
                                                                                	prefix
                                                                                	**type**\: str
                                                                                
                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	mask
                                                                                	**type**\: str
                                                                                
                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                    self.yang_name = "ipv4-addr-array"
                                                                                    self.yang_parent_name = "dst-addr-ipv4"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                        ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                    ])
                                                                                    self.prefix = None
                                                                                    self.mask = None
                                                                                    self._segment_path = lambda: "ipv4-addr-array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                        class SrcAddrIpv6(Entity):
                                                                            """
                                                                            Source Address IPV6
                                                                            
                                                                            .. attribute:: ipv6_addr_array
                                                                            
                                                                            	ipv6 addr array
                                                                            	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                self.yang_name = "src-addr-ipv6"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.ipv6_addr_array = YList(self)
                                                                                self._segment_path = lambda: "src-addr-ipv6"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                            class Ipv6AddrArray(Entity):
                                                                                """
                                                                                ipv6 addr array
                                                                                
                                                                                .. attribute:: prefix
                                                                                
                                                                                	IPV6 prefix
                                                                                	**type**\: str
                                                                                
                                                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	IPV6 mask
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                    self.yang_name = "ipv6-addr-array"
                                                                                    self.yang_parent_name = "src-addr-ipv6"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                        ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                    ])
                                                                                    self.prefix = None
                                                                                    self.mask = None
                                                                                    self._segment_path = lambda: "ipv6-addr-array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                        class DstAddrIpv6(Entity):
                                                                            """
                                                                            Destination Address IPV6
                                                                            
                                                                            .. attribute:: ipv6_addr_array
                                                                            
                                                                            	ipv6 addr array
                                                                            	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                self.yang_name = "dst-addr-ipv6"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.ipv6_addr_array = YList(self)
                                                                                self._segment_path = lambda: "dst-addr-ipv6"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                            class Ipv6AddrArray(Entity):
                                                                                """
                                                                                ipv6 addr array
                                                                                
                                                                                .. attribute:: prefix
                                                                                
                                                                                	IPV6 prefix
                                                                                	**type**\: str
                                                                                
                                                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	IPV6 mask
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                    self.yang_name = "ipv6-addr-array"
                                                                                    self.yang_parent_name = "dst-addr-ipv6"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                        ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                    ])
                                                                                    self.prefix = None
                                                                                    self.mask = None
                                                                                    self._segment_path = lambda: "ipv6-addr-array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                        class SrcAddrMac(Entity):
                                                                            """
                                                                            Source Address MAC
                                                                            
                                                                            .. attribute:: mac_addr_array
                                                                            
                                                                            	mac addr array
                                                                            	**type**\: list of  		 :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                self.yang_name = "src-addr-mac"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("mac-addr-array", ("mac_addr_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.mac_addr_array = YList(self)
                                                                                self._segment_path = lambda: "src-addr-mac"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                            class MacAddrArray(Entity):
                                                                                """
                                                                                mac addr array
                                                                                
                                                                                .. attribute:: mac_addr
                                                                                
                                                                                	MAC address
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	MAC mask
                                                                                	**type**\: list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                    self.yang_name = "mac-addr-array"
                                                                                    self.yang_parent_name = "src-addr-mac"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                    ])
                                                                                    self.mac_addr = []
                                                                                    self.mask = []
                                                                                    self._segment_path = lambda: "mac-addr-array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                        class Timer(Entity):
                                                                            """
                                                                            Timer
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                self.yang_name = "timer"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "timer"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                        class TimerRegexp(Entity):
                                                                            """
                                                                            Timer Regular Expression
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                self.yang_name = "timer-regexp"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "timer-regexp"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                        class TunnelName(Entity):
                                                                            """
                                                                            Tunnel Name
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                self.yang_name = "tunnel-name"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "tunnel-name"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                        class TunnelNameRegex(Entity):
                                                                            """
                                                                            Tunnel Name Regular Expression
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                self.yang_name = "tunnel-name-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "tunnel-name-regex"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                        class UserName(Entity):
                                                                            """
                                                                            User Name
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                self.yang_name = "user-name"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "user-name"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                        class UserNameRegex(Entity):
                                                                            """
                                                                            User Name Regular Expression
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                self.yang_name = "user-name-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "user-name-regex"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                        class AuthUsername(Entity):
                                                                            """
                                                                            Authenticated User Name
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                self.yang_name = "auth-username"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "auth-username"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                        class AuthUsernameRegex(Entity):
                                                                            """
                                                                            Authenticated User Name RegEx
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                self.yang_name = "auth-username-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "auth-username-regex"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                        class UnauthUsername(Entity):
                                                                            """
                                                                            Unauthenticated User Name
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                self.yang_name = "unauth-username"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "unauth-username"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                        class UnauthUsernameRegex(Entity):
                                                                            """
                                                                            Unauthenticated User Name RegEx
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                self.yang_name = "unauth-username-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "unauth-username-regex"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                        class AuthDomain(Entity):
                                                                            """
                                                                            Authenticated domain name
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                self.yang_name = "auth-domain"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "auth-domain"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                        class AuthDomainRegex(Entity):
                                                                            """
                                                                            Authenticated Domain Name RegEx
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                self.yang_name = "auth-domain-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "auth-domain-regex"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                        class UnauthDomain(Entity):
                                                                            """
                                                                            Unauthenticated Domain Name
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                self.yang_name = "unauth-domain"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "unauth-domain"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                        class UnauthDomainRegex(Entity):
                                                                            """
                                                                            Unauthenticated Domain Name RegEx
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                self.yang_name = "unauth-domain-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "unauth-domain-regex"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                        class VendorId(Entity):
                                                                            """
                                                                            Vendor ID
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                self.yang_name = "vendor-id"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "vendor-id"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                        class VendorIdRegex(Entity):
                                                                            """
                                                                            Vendor ID RegEx
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                self.yang_name = "vendor-id-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "vendor-id-regex"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                        class AccessInterface(Entity):
                                                                            """
                                                                            Access interface
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                self.yang_name = "access-interface"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "access-interface"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                        class InputInterface(Entity):
                                                                            """
                                                                            Input interface
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                self.yang_name = "input-interface"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "input-interface"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                        class InputIntfhdl(Entity):
                                                                            """
                                                                            Input interface handle
                                                                            
                                                                            .. attribute:: uint64_array
                                                                            
                                                                            	uint64 array
                                                                            	**type**\: list of int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                self.yang_name = "input-intfhdl"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('uint64_array', (YLeafList(YType.uint64, 'uint64_array'), ['int'])),
                                                                                ])
                                                                                self.uint64_array = []
                                                                                self._segment_path = lambda: "input-intfhdl"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                        class Ethertype(Entity):
                                                                            """
                                                                            Ethernet type
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                self.yang_name = "ethertype"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "ethertype"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "ethertype"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['min', 'max'], name, value)


                                                                        class FlowKeyData(Entity):
                                                                            """
                                                                            Flow key structure
                                                                            
                                                                            .. attribute:: flow_keys
                                                                            
                                                                            	flow keys
                                                                            	**type**\:  :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                            
                                                                            .. attribute:: max_count
                                                                            
                                                                            	Maximum count of flows
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: idle_timeout
                                                                            
                                                                            	Idle timeout of flows (in seconds)
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            	**units**\: second
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                self.yang_name = "flow-key-data"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("flow-keys", ("flow_keys", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('max_count', (YLeaf(YType.uint16, 'max-count'), ['int'])),
                                                                                    ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                                ])
                                                                                self.max_count = None
                                                                                self.idle_timeout = None

                                                                                self.flow_keys = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                self.flow_keys.parent = self
                                                                                self._children_name_map["flow_keys"] = "flow-keys"
                                                                                self._segment_path = lambda: "flow-key-data"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['max_count', 'idle_timeout'], name, value)


                                                                            class FlowKeys(Entity):
                                                                                """
                                                                                flow keys
                                                                                
                                                                                .. attribute:: keys
                                                                                
                                                                                	keys
                                                                                	**type**\: str
                                                                                
                                                                                	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                
                                                                                .. attribute:: num
                                                                                
                                                                                	num
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                    self.yang_name = "flow-keys"
                                                                                    self.yang_parent_name = "flow-key-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('keys', (YLeaf(YType.str, 'keys'), ['str'])),
                                                                                        ('num', (YLeaf(YType.uint8, 'num'), ['int'])),
                                                                                    ])
                                                                                    self.keys = None
                                                                                    self.num = None
                                                                                    self._segment_path = lambda: "flow-keys"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                        class DhcpClientId(Entity):
                                                                            """
                                                                            Dhcp Client ID
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                self.yang_name = "dhcp-client-id"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "dhcp-client-id"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                        class DhcpClientIdRegex(Entity):
                                                                            """
                                                                            Dhcp Client ID RegEx
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                self.yang_name = "dhcp-client-id-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "dhcp-client-id-regex"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                        class CircuitId(Entity):
                                                                            """
                                                                            Circuit ID
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                self.yang_name = "circuit-id"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "circuit-id"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                        class CircuitIdRegex(Entity):
                                                                            """
                                                                            Circuit ID RegEx
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                self.yang_name = "circuit-id-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "circuit-id-regex"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                        class RemoteId(Entity):
                                                                            """
                                                                            Remote ID
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                self.yang_name = "remote-id"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "remote-id"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                        class RemoteIdRegex(Entity):
                                                                            """
                                                                            Remote ID RegEx
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\: list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                self.yang_name = "remote-id-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                ])
                                                                                self.string_array = []
                                                                                self._segment_path = lambda: "remote-id-regex"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                        class SrcPort(Entity):
                                                                            """
                                                                            Source port
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                self.yang_name = "src-port"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "src-port"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "src-port"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                        class DstPort(Entity):
                                                                            """
                                                                            Destination port
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                self.yang_name = "dst-port"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "dst-port"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "dst-port"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['min', 'max'], name, value)


                                                    class ActInfop(Entity):
                                                        """
                                                        act infop
                                                        
                                                        .. attribute:: policy_action_info_st
                                                        
                                                        	policy action info st
                                                        	**type**\: list of  		 :py:class:`PolicyActionInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2018-01-17'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop, self).__init__()

                                                            self.yang_name = "act-infop"
                                                            self.yang_parent_name = "policy-class-info-bg"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("policy-action-info-st", ("policy_action_info_st", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt))])
                                                            self._leafs = OrderedDict()

                                                            self.policy_action_info_st = YList(self)
                                                            self._segment_path = lambda: "act-infop"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop, [], name, value)


                                                        class PolicyActionInfoSt(Entity):
                                                            """
                                                            policy action info st
                                                            
                                                            .. attribute:: actp
                                                            
                                                            	actp
                                                            	**type**\:  :py:class:`Actp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp>`
                                                            
                                                            .. attribute:: seq
                                                            
                                                            	seq
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..65535
                                                            
                                                            .. attribute:: flags
                                                            
                                                            	flags
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..65535
                                                            
                                                            

                                                            """

                                                            _prefix = 'infra-policymgr-oper'
                                                            _revision = '2018-01-17'

                                                            def __init__(self):
                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt, self).__init__()

                                                                self.yang_name = "policy-action-info-st"
                                                                self.yang_parent_name = "act-infop"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([("actp", ("actp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp))])
                                                                self._leafs = OrderedDict([
                                                                    ('seq', (YLeaf(YType.uint16, 'seq'), ['int'])),
                                                                    ('flags', (YLeaf(YType.uint16, 'flags'), ['int'])),
                                                                ])
                                                                self.seq = None
                                                                self.flags = None

                                                                self.actp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp()
                                                                self.actp.parent = self
                                                                self._children_name_map["actp"] = "actp"
                                                                self._segment_path = lambda: "policy-action-info-st"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt, ['seq', 'flags'], name, value)


                                                            class Actp(Entity):
                                                                """
                                                                actp
                                                                
                                                                .. attribute:: mark
                                                                
                                                                	mark
                                                                	**type**\:  :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark>`
                                                                
                                                                .. attribute:: mark2
                                                                
                                                                	mark2
                                                                	**type**\:  :py:class:`Mark2 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2>`
                                                                
                                                                .. attribute:: wred
                                                                
                                                                	wred
                                                                	**type**\:  :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred>`
                                                                
                                                                .. attribute:: encap
                                                                
                                                                	encap
                                                                	**type**\:  :py:class:`Encap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap>`
                                                                
                                                                .. attribute:: prio
                                                                
                                                                	prio
                                                                	**type**\:  :py:class:`Prio <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio>`
                                                                
                                                                .. attribute:: bwrem
                                                                
                                                                	bwrem
                                                                	**type**\:  :py:class:`Bwrem <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem>`
                                                                
                                                                .. attribute:: min_bw
                                                                
                                                                	min bw
                                                                	**type**\:  :py:class:`MinBw <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw>`
                                                                
                                                                .. attribute:: authen_aaa
                                                                
                                                                	authen aaa
                                                                	**type**\:  :py:class:`AuthenAaa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa>`
                                                                
                                                                .. attribute:: collect_id
                                                                
                                                                	collect id
                                                                	**type**\:  :py:class:`CollectId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId>`
                                                                
                                                                .. attribute:: decode_id
                                                                
                                                                	decode id
                                                                	**type**\:  :py:class:`DecodeId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId>`
                                                                
                                                                .. attribute:: set_timer
                                                                
                                                                	set timer
                                                                	**type**\:  :py:class:`SetTimer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer>`
                                                                
                                                                .. attribute:: stop_timer
                                                                
                                                                	stop timer
                                                                	**type**\:  :py:class:`StopTimer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer>`
                                                                
                                                                .. attribute:: acct_aaa_list
                                                                
                                                                	acct aaa list
                                                                	**type**\:  :py:class:`AcctAaaList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList>`
                                                                
                                                                .. attribute:: query_ancp
                                                                
                                                                	query ancp
                                                                	**type**\:  :py:class:`QueryAncp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp>`
                                                                
                                                                .. attribute:: prepaid_cfg
                                                                
                                                                	prepaid cfg
                                                                	**type**\:  :py:class:`PrepaidCfg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg>`
                                                                
                                                                .. attribute:: timeout_idle
                                                                
                                                                	timeout idle
                                                                	**type**\:  :py:class:`TimeoutIdle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle>`
                                                                
                                                                .. attribute:: proxy_aaa
                                                                
                                                                	proxy aaa
                                                                	**type**\:  :py:class:`ProxyAaa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa>`
                                                                
                                                                .. attribute:: act_template
                                                                
                                                                	act template
                                                                	**type**\:  :py:class:`ActTemplate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate>`
                                                                
                                                                .. attribute:: deact_template
                                                                
                                                                	deact template
                                                                	**type**\:  :py:class:`DeactTemplate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate>`
                                                                
                                                                .. attribute:: qlimit
                                                                
                                                                	qlimit
                                                                	**type**\:  :py:class:`Qlimit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit>`
                                                                
                                                                .. attribute:: accounting_event_aaa
                                                                
                                                                	accounting event aaa
                                                                	**type**\:  :py:class:`AccountingEventAaa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa>`
                                                                
                                                                .. attribute:: authorize_id
                                                                
                                                                	authorize id
                                                                	**type**\:  :py:class:`AuthorizeId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId>`
                                                                
                                                                .. attribute:: afm_react
                                                                
                                                                	afm react
                                                                	**type**\:  :py:class:`AfmReact <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact>`
                                                                
                                                                .. attribute:: httpr
                                                                
                                                                	httpr
                                                                	**type**\:  :py:class:`Httpr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr>`
                                                                
                                                                .. attribute:: punt
                                                                
                                                                	punt
                                                                	**type**\:  :py:class:`Punt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt>`
                                                                
                                                                .. attribute:: copy
                                                                
                                                                	copy
                                                                	**type**\:  :py:class:`Copy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy>`
                                                                
                                                                .. attribute:: sfrag
                                                                
                                                                	sfrag
                                                                	**type**\:  :py:class:`Sfrag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag>`
                                                                
                                                                .. attribute:: redirect
                                                                
                                                                	redirect
                                                                	**type**\:  :py:class:`Redirect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect>`
                                                                
                                                                .. attribute:: out_intf
                                                                
                                                                	out intf
                                                                	**type**\:  :py:class:`OutIntf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf>`
                                                                
                                                                .. attribute:: serv_func
                                                                
                                                                	serv func
                                                                	**type**\:  :py:class:`ServFunc <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc>`
                                                                
                                                                .. attribute:: police
                                                                
                                                                	police
                                                                	**type**\:  :py:class:`Police <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police>`
                                                                
                                                                .. attribute:: shape
                                                                
                                                                	shape
                                                                	**type**\:  :py:class:`Shape <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape>`
                                                                
                                                                .. attribute:: child_policy
                                                                
                                                                	child policy
                                                                	**type**\:  :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy>`
                                                                
                                                                .. attribute:: cac
                                                                
                                                                	cac
                                                                	**type**\:  :py:class:`Cac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac>`
                                                                
                                                                .. attribute:: pfc
                                                                
                                                                	pfc
                                                                	**type**\:  :py:class:`Pfc <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc>`
                                                                
                                                                .. attribute:: flow_parm
                                                                
                                                                	flow parm
                                                                	**type**\:  :py:class:`FlowParm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm>`
                                                                
                                                                .. attribute:: ipcbr
                                                                
                                                                	ipcbr
                                                                	**type**\:  :py:class:`Ipcbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr>`
                                                                
                                                                .. attribute:: rtp
                                                                
                                                                	rtp
                                                                	**type**\:  :py:class:`Rtp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp>`
                                                                
                                                                .. attribute:: rtp_mmr
                                                                
                                                                	rtp mmr
                                                                	**type**\:  :py:class:`RtpMmr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr>`
                                                                
                                                                .. attribute:: rtp_j2k
                                                                
                                                                	rtp j2k
                                                                	**type**\:  :py:class:`RtpJ2k <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k>`
                                                                
                                                                .. attribute:: rtp_voice
                                                                
                                                                	rtp voice
                                                                	**type**\:  :py:class:`RtpVoice <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice>`
                                                                
                                                                .. attribute:: mdi
                                                                
                                                                	mdi
                                                                	**type**\:  :py:class:`Mdi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi>`
                                                                
                                                                .. attribute:: mdi_rtp
                                                                
                                                                	mdi rtp
                                                                	**type**\:  :py:class:`MdiRtp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp>`
                                                                
                                                                .. attribute:: fmm
                                                                
                                                                	fmm
                                                                	**type**\:  :py:class:`Fmm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm>`
                                                                
                                                                .. attribute:: pbf
                                                                
                                                                	pbf
                                                                	**type**\:  :py:class:`Pbf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf>`
                                                                
                                                                .. attribute:: ipv4_nh
                                                                
                                                                	ipv4 nh
                                                                	**type**\:  :py:class:`Ipv4Nh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh>`
                                                                
                                                                .. attribute:: ipv6_nh
                                                                
                                                                	ipv6 nh
                                                                	**type**\:  :py:class:`Ipv6Nh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh>`
                                                                
                                                                .. attribute:: type
                                                                
                                                                	type
                                                                	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                
                                                                .. attribute:: data_p
                                                                
                                                                	data p
                                                                	**type**\: int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2018-01-17'

                                                                def __init__(self):
                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp, self).__init__()

                                                                    self.yang_name = "actp"
                                                                    self.yang_parent_name = "policy-action-info-st"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self.ylist_key_names = []
                                                                    self._child_classes = OrderedDict([("mark", ("mark", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark)), ("mark2", ("mark2", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2)), ("wred", ("wred", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred)), ("encap", ("encap", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap)), ("prio", ("prio", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio)), ("bwrem", ("bwrem", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem)), ("min-bw", ("min_bw", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw)), ("authen-aaa", ("authen_aaa", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa)), ("collect-id", ("collect_id", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId)), ("decode-id", ("decode_id", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId)), ("set-timer", ("set_timer", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer)), ("stop-timer", ("stop_timer", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer)), ("acct-aaa-list", ("acct_aaa_list", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList)), ("query-ancp", ("query_ancp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp)), ("prepaid-cfg", ("prepaid_cfg", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg)), ("timeout-idle", ("timeout_idle", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle)), ("proxy-aaa", ("proxy_aaa", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa)), ("act-template", ("act_template", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate)), ("deact-template", ("deact_template", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate)), ("qlimit", ("qlimit", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit)), ("accounting-event-aaa", ("accounting_event_aaa", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa)), ("authorize-id", ("authorize_id", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId)), ("afm-react", ("afm_react", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact)), ("httpr", ("httpr", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr)), ("punt", ("punt", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt)), ("copy", ("copy", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy)), ("sfrag", ("sfrag", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag)), ("redirect", ("redirect", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect)), ("out-intf", ("out_intf", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf)), ("serv-func", ("serv_func", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc)), ("police", ("police", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police)), ("shape", ("shape", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape)), ("child-policy", ("child_policy", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy)), ("cac", ("cac", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac)), ("pfc", ("pfc", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc)), ("flow-parm", ("flow_parm", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm)), ("ipcbr", ("ipcbr", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr)), ("rtp", ("rtp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp)), ("rtp-mmr", ("rtp_mmr", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr)), ("rtp-j2k", ("rtp_j2k", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k)), ("rtp-voice", ("rtp_voice", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice)), ("mdi", ("mdi", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi)), ("mdi-rtp", ("mdi_rtp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp)), ("fmm", ("fmm", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm)), ("pbf", ("pbf", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf)), ("ipv4-nh", ("ipv4_nh", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh)), ("ipv6-nh", ("ipv6_nh", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh))])
                                                                    self._leafs = OrderedDict([
                                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                        ('data_p', (YLeaf(YType.uint32, 'data-p'), ['int'])),
                                                                    ])
                                                                    self.type = None
                                                                    self.data_p = None

                                                                    self.mark = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark()
                                                                    self.mark.parent = self
                                                                    self._children_name_map["mark"] = "mark"

                                                                    self.mark2 = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2()
                                                                    self.mark2.parent = self
                                                                    self._children_name_map["mark2"] = "mark2"

                                                                    self.wred = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred()
                                                                    self.wred.parent = self
                                                                    self._children_name_map["wred"] = "wred"

                                                                    self.encap = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap()
                                                                    self.encap.parent = self
                                                                    self._children_name_map["encap"] = "encap"

                                                                    self.prio = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio()
                                                                    self.prio.parent = self
                                                                    self._children_name_map["prio"] = "prio"

                                                                    self.bwrem = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem()
                                                                    self.bwrem.parent = self
                                                                    self._children_name_map["bwrem"] = "bwrem"

                                                                    self.min_bw = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw()
                                                                    self.min_bw.parent = self
                                                                    self._children_name_map["min_bw"] = "min-bw"

                                                                    self.authen_aaa = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa()
                                                                    self.authen_aaa.parent = self
                                                                    self._children_name_map["authen_aaa"] = "authen-aaa"

                                                                    self.collect_id = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId()
                                                                    self.collect_id.parent = self
                                                                    self._children_name_map["collect_id"] = "collect-id"

                                                                    self.decode_id = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId()
                                                                    self.decode_id.parent = self
                                                                    self._children_name_map["decode_id"] = "decode-id"

                                                                    self.set_timer = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer()
                                                                    self.set_timer.parent = self
                                                                    self._children_name_map["set_timer"] = "set-timer"

                                                                    self.stop_timer = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer()
                                                                    self.stop_timer.parent = self
                                                                    self._children_name_map["stop_timer"] = "stop-timer"

                                                                    self.acct_aaa_list = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList()
                                                                    self.acct_aaa_list.parent = self
                                                                    self._children_name_map["acct_aaa_list"] = "acct-aaa-list"

                                                                    self.query_ancp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp()
                                                                    self.query_ancp.parent = self
                                                                    self._children_name_map["query_ancp"] = "query-ancp"

                                                                    self.prepaid_cfg = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg()
                                                                    self.prepaid_cfg.parent = self
                                                                    self._children_name_map["prepaid_cfg"] = "prepaid-cfg"

                                                                    self.timeout_idle = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle()
                                                                    self.timeout_idle.parent = self
                                                                    self._children_name_map["timeout_idle"] = "timeout-idle"

                                                                    self.proxy_aaa = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa()
                                                                    self.proxy_aaa.parent = self
                                                                    self._children_name_map["proxy_aaa"] = "proxy-aaa"

                                                                    self.act_template = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate()
                                                                    self.act_template.parent = self
                                                                    self._children_name_map["act_template"] = "act-template"

                                                                    self.deact_template = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate()
                                                                    self.deact_template.parent = self
                                                                    self._children_name_map["deact_template"] = "deact-template"

                                                                    self.qlimit = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit()
                                                                    self.qlimit.parent = self
                                                                    self._children_name_map["qlimit"] = "qlimit"

                                                                    self.accounting_event_aaa = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa()
                                                                    self.accounting_event_aaa.parent = self
                                                                    self._children_name_map["accounting_event_aaa"] = "accounting-event-aaa"

                                                                    self.authorize_id = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId()
                                                                    self.authorize_id.parent = self
                                                                    self._children_name_map["authorize_id"] = "authorize-id"

                                                                    self.afm_react = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact()
                                                                    self.afm_react.parent = self
                                                                    self._children_name_map["afm_react"] = "afm-react"

                                                                    self.httpr = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr()
                                                                    self.httpr.parent = self
                                                                    self._children_name_map["httpr"] = "httpr"

                                                                    self.punt = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt()
                                                                    self.punt.parent = self
                                                                    self._children_name_map["punt"] = "punt"

                                                                    self.copy = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy()
                                                                    self.copy.parent = self
                                                                    self._children_name_map["copy"] = "copy"

                                                                    self.sfrag = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag()
                                                                    self.sfrag.parent = self
                                                                    self._children_name_map["sfrag"] = "sfrag"

                                                                    self.redirect = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect()
                                                                    self.redirect.parent = self
                                                                    self._children_name_map["redirect"] = "redirect"

                                                                    self.out_intf = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf()
                                                                    self.out_intf.parent = self
                                                                    self._children_name_map["out_intf"] = "out-intf"

                                                                    self.serv_func = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc()
                                                                    self.serv_func.parent = self
                                                                    self._children_name_map["serv_func"] = "serv-func"

                                                                    self.police = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police()
                                                                    self.police.parent = self
                                                                    self._children_name_map["police"] = "police"

                                                                    self.shape = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape()
                                                                    self.shape.parent = self
                                                                    self._children_name_map["shape"] = "shape"

                                                                    self.child_policy = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy()
                                                                    self.child_policy.parent = self
                                                                    self._children_name_map["child_policy"] = "child-policy"

                                                                    self.cac = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac()
                                                                    self.cac.parent = self
                                                                    self._children_name_map["cac"] = "cac"

                                                                    self.pfc = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc()
                                                                    self.pfc.parent = self
                                                                    self._children_name_map["pfc"] = "pfc"

                                                                    self.flow_parm = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm()
                                                                    self.flow_parm.parent = self
                                                                    self._children_name_map["flow_parm"] = "flow-parm"

                                                                    self.ipcbr = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr()
                                                                    self.ipcbr.parent = self
                                                                    self._children_name_map["ipcbr"] = "ipcbr"

                                                                    self.rtp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp()
                                                                    self.rtp.parent = self
                                                                    self._children_name_map["rtp"] = "rtp"

                                                                    self.rtp_mmr = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr()
                                                                    self.rtp_mmr.parent = self
                                                                    self._children_name_map["rtp_mmr"] = "rtp-mmr"

                                                                    self.rtp_j2k = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k()
                                                                    self.rtp_j2k.parent = self
                                                                    self._children_name_map["rtp_j2k"] = "rtp-j2k"

                                                                    self.rtp_voice = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice()
                                                                    self.rtp_voice.parent = self
                                                                    self._children_name_map["rtp_voice"] = "rtp-voice"

                                                                    self.mdi = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi()
                                                                    self.mdi.parent = self
                                                                    self._children_name_map["mdi"] = "mdi"

                                                                    self.mdi_rtp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp()
                                                                    self.mdi_rtp.parent = self
                                                                    self._children_name_map["mdi_rtp"] = "mdi-rtp"

                                                                    self.fmm = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm()
                                                                    self.fmm.parent = self
                                                                    self._children_name_map["fmm"] = "fmm"

                                                                    self.pbf = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf()
                                                                    self.pbf.parent = self
                                                                    self._children_name_map["pbf"] = "pbf"

                                                                    self.ipv4_nh = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh()
                                                                    self.ipv4_nh.parent = self
                                                                    self._children_name_map["ipv4_nh"] = "ipv4-nh"

                                                                    self.ipv6_nh = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh()
                                                                    self.ipv6_nh.parent = self
                                                                    self._children_name_map["ipv6_nh"] = "ipv6-nh"
                                                                    self._segment_path = lambda: "actp"
                                                                    self._is_frozen = True

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp, ['type', 'data_p'], name, value)


                                                                class Mark(Entity):
                                                                    """
                                                                    mark
                                                                    
                                                                    .. attribute:: action_mark_info
                                                                    
                                                                    	action mark info
                                                                    	**type**\: list of  		 :py:class:`ActionMarkInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark, self).__init__()

                                                                        self.yang_name = "mark"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("action-mark-info", ("action_mark_info", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo))])
                                                                        self._leafs = OrderedDict()

                                                                        self.action_mark_info = YList(self)
                                                                        self._segment_path = lambda: "mark"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark, [], name, value)


                                                                    class ActionMarkInfo(Entity):
                                                                        """
                                                                        action mark info
                                                                        
                                                                        .. attribute:: type
                                                                        
                                                                        	type
                                                                        	**type**\:  :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                        
                                                                        .. attribute:: mark_flags
                                                                        
                                                                        	mark flags
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..65535
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo, self).__init__()

                                                                            self.yang_name = "action-mark-info"
                                                                            self.yang_parent_name = "mark"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MarkTypeEn', '')])),
                                                                                ('mark_flags', (YLeaf(YType.uint32, 'mark-flags'), ['int'])),
                                                                                ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                            ])
                                                                            self.type = None
                                                                            self.mark_flags = None
                                                                            self.value = None
                                                                            self._segment_path = lambda: "action-mark-info"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo, ['type', 'mark_flags', 'value'], name, value)


                                                                class Mark2(Entity):
                                                                    """
                                                                    mark2
                                                                    
                                                                    .. attribute:: action_mark2_info
                                                                    
                                                                    	action mark2 info
                                                                    	**type**\: list of  		 :py:class:`ActionMark2Info <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2, self).__init__()

                                                                        self.yang_name = "mark2"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("action-mark2-info", ("action_mark2_info", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info))])
                                                                        self._leafs = OrderedDict()

                                                                        self.action_mark2_info = YList(self)
                                                                        self._segment_path = lambda: "mark2"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2, [], name, value)


                                                                    class ActionMark2Info(Entity):
                                                                        """
                                                                        action mark2 info
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: value_overflow
                                                                        
                                                                        	value overflow
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..65535
                                                                        
                                                                        .. attribute:: type
                                                                        
                                                                        	type
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: mark_flags
                                                                        
                                                                        	mark flags
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info, self).__init__()

                                                                            self.yang_name = "action-mark2-info"
                                                                            self.yang_parent_name = "mark2"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                ('value_overflow', (YLeaf(YType.uint16, 'value-overflow'), ['int'])),
                                                                                ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                ('mark_flags', (YLeaf(YType.uint8, 'mark-flags'), ['int'])),
                                                                            ])
                                                                            self.value = None
                                                                            self.value_overflow = None
                                                                            self.type = None
                                                                            self.mark_flags = None
                                                                            self._segment_path = lambda: "action-mark2-info"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info, ['value', 'value_overflow', 'type', 'mark_flags'], name, value)


                                                                class Wred(Entity):
                                                                    """
                                                                    wred
                                                                    
                                                                    .. attribute:: action_wred_info
                                                                    
                                                                    	action wred info
                                                                    	**type**\: list of  		 :py:class:`ActionWredInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred, self).__init__()

                                                                        self.yang_name = "wred"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("action-wred-info", ("action_wred_info", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo))])
                                                                        self._leafs = OrderedDict()

                                                                        self.action_wred_info = YList(self)
                                                                        self._segment_path = lambda: "wred"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred, [], name, value)


                                                                    class ActionWredInfo(Entity):
                                                                        """
                                                                        action wred info
                                                                        
                                                                        .. attribute:: match_ranges
                                                                        
                                                                        	match ranges
                                                                        	**type**\:  :py:class:`MatchRanges <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges>`
                                                                        
                                                                        .. attribute:: min_threshold
                                                                        
                                                                        	min threshold
                                                                        	**type**\:  :py:class:`MinThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold>`
                                                                        
                                                                        .. attribute:: max_threshold
                                                                        
                                                                        	max threshold
                                                                        	**type**\:  :py:class:`MaxThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold>`
                                                                        
                                                                        .. attribute:: type
                                                                        
                                                                        	cos/prec/dscp/ based WRED
                                                                        	**type**\:  :py:class:`WredTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.WredTypeEn>`
                                                                        
                                                                        .. attribute:: wred_flags
                                                                        
                                                                        	wred flags
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: probability
                                                                        
                                                                        	probability
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo, self).__init__()

                                                                            self.yang_name = "action-wred-info"
                                                                            self.yang_parent_name = "wred"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("match-ranges", ("match_ranges", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges)), ("min-threshold", ("min_threshold", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold)), ("max-threshold", ("max_threshold", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold))])
                                                                            self._leafs = OrderedDict([
                                                                                ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'WredTypeEn', '')])),
                                                                                ('wred_flags', (YLeaf(YType.uint32, 'wred-flags'), ['int'])),
                                                                                ('probability', (YLeaf(YType.uint32, 'probability'), ['int'])),
                                                                            ])
                                                                            self.type = None
                                                                            self.wred_flags = None
                                                                            self.probability = None

                                                                            self.match_ranges = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges()
                                                                            self.match_ranges.parent = self
                                                                            self._children_name_map["match_ranges"] = "match-ranges"

                                                                            self.min_threshold = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold()
                                                                            self.min_threshold.parent = self
                                                                            self._children_name_map["min_threshold"] = "min-threshold"

                                                                            self.max_threshold = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold()
                                                                            self.max_threshold.parent = self
                                                                            self._children_name_map["max_threshold"] = "max-threshold"
                                                                            self._segment_path = lambda: "action-wred-info"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo, ['type', 'wred_flags', 'probability'], name, value)


                                                                        class MatchRanges(Entity):
                                                                            """
                                                                            match ranges
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges, self).__init__()

                                                                                self.yang_name = "match-ranges"
                                                                                self.yang_parent_name = "action-wred-info"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "match-ranges"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "match-ranges"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray, ['min', 'max'], name, value)


                                                                        class MinThreshold(Entity):
                                                                            """
                                                                            min threshold
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold, self).__init__()

                                                                                self.yang_name = "min-threshold"
                                                                                self.yang_parent_name = "action-wred-info"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "min-threshold"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold, ['value', 'unit'], name, value)


                                                                        class MaxThreshold(Entity):
                                                                            """
                                                                            max threshold
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold, self).__init__()

                                                                                self.yang_name = "max-threshold"
                                                                                self.yang_parent_name = "action-wred-info"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "max-threshold"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold, ['value', 'unit'], name, value)


                                                                class Encap(Entity):
                                                                    """
                                                                    encap
                                                                    
                                                                    .. attribute:: seq
                                                                    
                                                                    	seq
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap, self).__init__()

                                                                        self.yang_name = "encap"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('seq', (YLeaf(YType.uint8, 'seq'), ['int'])),
                                                                        ])
                                                                        self.seq = None
                                                                        self._segment_path = lambda: "encap"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap, ['seq'], name, value)


                                                                class Prio(Entity):
                                                                    """
                                                                    prio
                                                                    
                                                                    .. attribute:: prio_lvl
                                                                    
                                                                    	prio lvl
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio, self).__init__()

                                                                        self.yang_name = "prio"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('prio_lvl', (YLeaf(YType.uint32, 'prio-lvl'), ['int'])),
                                                                        ])
                                                                        self.prio_lvl = None
                                                                        self._segment_path = lambda: "prio"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio, ['prio_lvl'], name, value)


                                                                class Bwrem(Entity):
                                                                    """
                                                                    bwrem
                                                                    
                                                                    .. attribute:: bwrem
                                                                    
                                                                    	bwrem
                                                                    	**type**\:  :py:class:`Bwrem_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem_>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem, self).__init__()

                                                                        self.yang_name = "bwrem"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("bwrem", ("bwrem", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem_))])
                                                                        self._leafs = OrderedDict()

                                                                        self.bwrem = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem_()
                                                                        self.bwrem.parent = self
                                                                        self._children_name_map["bwrem"] = "bwrem"
                                                                        self._segment_path = lambda: "bwrem"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem, [], name, value)


                                                                    class Bwrem_(Entity):
                                                                        """
                                                                        bwrem
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem_, self).__init__()

                                                                            self.yang_name = "bwrem"
                                                                            self.yang_parent_name = "bwrem"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                            ])
                                                                            self.value = None
                                                                            self.unit = None
                                                                            self._segment_path = lambda: "bwrem"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem_, ['value', 'unit'], name, value)


                                                                class MinBw(Entity):
                                                                    """
                                                                    min bw
                                                                    
                                                                    .. attribute:: bw
                                                                    
                                                                    	bw
                                                                    	**type**\:  :py:class:`Bw <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw, self).__init__()

                                                                        self.yang_name = "min-bw"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("bw", ("bw", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw))])
                                                                        self._leafs = OrderedDict()

                                                                        self.bw = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw()
                                                                        self.bw.parent = self
                                                                        self._children_name_map["bw"] = "bw"
                                                                        self._segment_path = lambda: "min-bw"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw, [], name, value)


                                                                    class Bw(Entity):
                                                                        """
                                                                        bw
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw, self).__init__()

                                                                            self.yang_name = "bw"
                                                                            self.yang_parent_name = "min-bw"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                            ])
                                                                            self.value = None
                                                                            self.unit = None
                                                                            self._segment_path = lambda: "bw"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw, ['value', 'unit'], name, value)


                                                                class AuthenAaa(Entity):
                                                                    """
                                                                    authen aaa
                                                                    
                                                                    .. attribute:: aaa_list_name
                                                                    
                                                                    	aaa list name
                                                                    	**type**\: str
                                                                    
                                                                    .. attribute:: authen_password
                                                                    
                                                                    	authen password
                                                                    	**type**\: str
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa, self).__init__()

                                                                        self.yang_name = "authen-aaa"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                            ('authen_password', (YLeaf(YType.str, 'authen-password'), ['str'])),
                                                                        ])
                                                                        self.aaa_list_name = None
                                                                        self.authen_password = None
                                                                        self._segment_path = lambda: "authen-aaa"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa, ['aaa_list_name', 'authen_password'], name, value)


                                                                class CollectId(Entity):
                                                                    """
                                                                    collect id
                                                                    
                                                                    .. attribute:: id
                                                                    
                                                                    	id
                                                                    	**type**\:  :py:class:`IdentifierEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.IdentifierEn>`
                                                                    
                                                                    .. attribute:: aaa_list_name
                                                                    
                                                                    	aaa list name
                                                                    	**type**\: str
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId, self).__init__()

                                                                        self.yang_name = "collect-id"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('id', (YLeaf(YType.enumeration, 'id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'IdentifierEn', '')])),
                                                                            ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                        ])
                                                                        self.id = None
                                                                        self.aaa_list_name = None
                                                                        self._segment_path = lambda: "collect-id"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId, ['id', 'aaa_list_name'], name, value)


                                                                class DecodeId(Entity):
                                                                    """
                                                                    decode id
                                                                    
                                                                    .. attribute:: id
                                                                    
                                                                    	id
                                                                    	**type**\:  :py:class:`DecodeIdentifierEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.DecodeIdentifierEn>`
                                                                    
                                                                    .. attribute:: format_name
                                                                    
                                                                    	format name
                                                                    	**type**\: str
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId, self).__init__()

                                                                        self.yang_name = "decode-id"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('id', (YLeaf(YType.enumeration, 'id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'DecodeIdentifierEn', '')])),
                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                        ])
                                                                        self.id = None
                                                                        self.format_name = None
                                                                        self._segment_path = lambda: "decode-id"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId, ['id', 'format_name'], name, value)


                                                                class SetTimer(Entity):
                                                                    """
                                                                    set timer
                                                                    
                                                                    .. attribute:: timer_name
                                                                    
                                                                    	timer name
                                                                    	**type**\: str
                                                                    
                                                                    .. attribute:: duration
                                                                    
                                                                    	duration
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: absolute_time
                                                                    
                                                                    	absolute time
                                                                    	**type**\: str
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer, self).__init__()

                                                                        self.yang_name = "set-timer"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('timer_name', (YLeaf(YType.str, 'timer-name'), ['str'])),
                                                                            ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                                            ('absolute_time', (YLeaf(YType.str, 'absolute-time'), ['str'])),
                                                                        ])
                                                                        self.timer_name = None
                                                                        self.duration = None
                                                                        self.absolute_time = None
                                                                        self._segment_path = lambda: "set-timer"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer, ['timer_name', 'duration', 'absolute_time'], name, value)


                                                                class StopTimer(Entity):
                                                                    """
                                                                    stop timer
                                                                    
                                                                    .. attribute:: timer_name
                                                                    
                                                                    	timer name
                                                                    	**type**\: str
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer, self).__init__()

                                                                        self.yang_name = "stop-timer"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('timer_name', (YLeaf(YType.str, 'timer-name'), ['str'])),
                                                                        ])
                                                                        self.timer_name = None
                                                                        self._segment_path = lambda: "stop-timer"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer, ['timer_name'], name, value)


                                                                class AcctAaaList(Entity):
                                                                    """
                                                                    acct aaa list
                                                                    
                                                                    .. attribute:: aaa_list_name
                                                                    
                                                                    	aaa list name
                                                                    	**type**\: str
                                                                    
                                                                    .. attribute:: secs
                                                                    
                                                                    	secs
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList, self).__init__()

                                                                        self.yang_name = "acct-aaa-list"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                            ('secs', (YLeaf(YType.uint32, 'secs'), ['int'])),
                                                                        ])
                                                                        self.aaa_list_name = None
                                                                        self.secs = None
                                                                        self._segment_path = lambda: "acct-aaa-list"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList, ['aaa_list_name', 'secs'], name, value)


                                                                class QueryAncp(Entity):
                                                                    """
                                                                    query ancp
                                                                    
                                                                    .. attribute:: enable
                                                                    
                                                                    	enable
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp, self).__init__()

                                                                        self.yang_name = "query-ancp"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('enable', (YLeaf(YType.uint8, 'enable'), ['int'])),
                                                                        ])
                                                                        self.enable = None
                                                                        self._segment_path = lambda: "query-ancp"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp, ['enable'], name, value)


                                                                class PrepaidCfg(Entity):
                                                                    """
                                                                    prepaid cfg
                                                                    
                                                                    .. attribute:: prepaid_config_profile_name
                                                                    
                                                                    	prepaid config profile name
                                                                    	**type**\: str
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg, self).__init__()

                                                                        self.yang_name = "prepaid-cfg"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('prepaid_config_profile_name', (YLeaf(YType.str, 'prepaid-config-profile-name'), ['str'])),
                                                                        ])
                                                                        self.prepaid_config_profile_name = None
                                                                        self._segment_path = lambda: "prepaid-cfg"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg, ['prepaid_config_profile_name'], name, value)


                                                                class TimeoutIdle(Entity):
                                                                    """
                                                                    timeout idle
                                                                    
                                                                    .. attribute:: secs
                                                                    
                                                                    	secs
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle, self).__init__()

                                                                        self.yang_name = "timeout-idle"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('secs', (YLeaf(YType.uint32, 'secs'), ['int'])),
                                                                        ])
                                                                        self.secs = None
                                                                        self._segment_path = lambda: "timeout-idle"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle, ['secs'], name, value)


                                                                class ProxyAaa(Entity):
                                                                    """
                                                                    proxy aaa
                                                                    
                                                                    .. attribute:: aaa_list_name
                                                                    
                                                                    	aaa list name
                                                                    	**type**\: str
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa, self).__init__()

                                                                        self.yang_name = "proxy-aaa"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                        ])
                                                                        self.aaa_list_name = None
                                                                        self._segment_path = lambda: "proxy-aaa"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa, ['aaa_list_name'], name, value)


                                                                class ActTemplate(Entity):
                                                                    """
                                                                    act template
                                                                    
                                                                    .. attribute:: template_name
                                                                    
                                                                    	template name
                                                                    	**type**\: str
                                                                    
                                                                    .. attribute:: aaa_list_name
                                                                    
                                                                    	aaa list name
                                                                    	**type**\: str
                                                                    
                                                                    .. attribute:: flags
                                                                    
                                                                    	flags
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate, self).__init__()

                                                                        self.yang_name = "act-template"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('template_name', (YLeaf(YType.str, 'template-name'), ['str'])),
                                                                            ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                            ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                        ])
                                                                        self.template_name = None
                                                                        self.aaa_list_name = None
                                                                        self.flags = None
                                                                        self._segment_path = lambda: "act-template"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate, ['template_name', 'aaa_list_name', 'flags'], name, value)


                                                                class DeactTemplate(Entity):
                                                                    """
                                                                    deact template
                                                                    
                                                                    .. attribute:: template_name
                                                                    
                                                                    	template name
                                                                    	**type**\: str
                                                                    
                                                                    .. attribute:: aaa_list_name
                                                                    
                                                                    	aaa list name
                                                                    	**type**\: str
                                                                    
                                                                    .. attribute:: flags
                                                                    
                                                                    	flags
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate, self).__init__()

                                                                        self.yang_name = "deact-template"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('template_name', (YLeaf(YType.str, 'template-name'), ['str'])),
                                                                            ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                            ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                        ])
                                                                        self.template_name = None
                                                                        self.aaa_list_name = None
                                                                        self.flags = None
                                                                        self._segment_path = lambda: "deact-template"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate, ['template_name', 'aaa_list_name', 'flags'], name, value)


                                                                class Qlimit(Entity):
                                                                    """
                                                                    qlimit
                                                                    
                                                                    .. attribute:: action_qlimit_info_array
                                                                    
                                                                    	action qlimit info array
                                                                    	**type**\: list of  		 :py:class:`ActionQlimitInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit, self).__init__()

                                                                        self.yang_name = "qlimit"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("action-qlimit-info-array", ("action_qlimit_info_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray))])
                                                                        self._leafs = OrderedDict()

                                                                        self.action_qlimit_info_array = YList(self)
                                                                        self._segment_path = lambda: "qlimit"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit, [], name, value)


                                                                    class ActionQlimitInfoArray(Entity):
                                                                        """
                                                                        action qlimit info array
                                                                        
                                                                        .. attribute:: qlim
                                                                        
                                                                        	qlim
                                                                        	**type**\:  :py:class:`Qlim <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim>`
                                                                        
                                                                        .. attribute:: atmclp_qlim
                                                                        
                                                                        	atmclp qlim
                                                                        	**type**\:  :py:class:`AtmclpQlim <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim>`
                                                                        
                                                                        .. attribute:: match_values
                                                                        
                                                                        	match values
                                                                        	**type**\:  :py:class:`MatchValues <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues>`
                                                                        
                                                                        .. attribute:: type
                                                                        
                                                                        	type
                                                                        	**type**\:  :py:class:`QlimitTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.QlimitTypeEn>`
                                                                        
                                                                        .. attribute:: qlimit_flags
                                                                        
                                                                        	qlimit flags
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray, self).__init__()

                                                                            self.yang_name = "action-qlimit-info-array"
                                                                            self.yang_parent_name = "qlimit"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("qlim", ("qlim", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim)), ("atmclp-qlim", ("atmclp_qlim", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim)), ("match-values", ("match_values", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues))])
                                                                            self._leafs = OrderedDict([
                                                                                ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'QlimitTypeEn', '')])),
                                                                                ('qlimit_flags', (YLeaf(YType.uint32, 'qlimit-flags'), ['int'])),
                                                                            ])
                                                                            self.type = None
                                                                            self.qlimit_flags = None

                                                                            self.qlim = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim()
                                                                            self.qlim.parent = self
                                                                            self._children_name_map["qlim"] = "qlim"

                                                                            self.atmclp_qlim = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim()
                                                                            self.atmclp_qlim.parent = self
                                                                            self._children_name_map["atmclp_qlim"] = "atmclp-qlim"

                                                                            self.match_values = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues()
                                                                            self.match_values.parent = self
                                                                            self._children_name_map["match_values"] = "match-values"
                                                                            self._segment_path = lambda: "action-qlimit-info-array"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray, ['type', 'qlimit_flags'], name, value)


                                                                        class Qlim(Entity):
                                                                            """
                                                                            qlim
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim, self).__init__()

                                                                                self.yang_name = "qlim"
                                                                                self.yang_parent_name = "action-qlimit-info-array"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "qlim"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim, ['value', 'unit'], name, value)


                                                                        class AtmclpQlim(Entity):
                                                                            """
                                                                            atmclp qlim
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim, self).__init__()

                                                                                self.yang_name = "atmclp-qlim"
                                                                                self.yang_parent_name = "action-qlimit-info-array"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict([
                                                                                    ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                    ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                                ])
                                                                                self.value = None
                                                                                self.unit = None
                                                                                self._segment_path = lambda: "atmclp-qlim"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim, ['value', 'unit'], name, value)


                                                                        class MatchValues(Entity):
                                                                            """
                                                                            match values
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues, self).__init__()

                                                                                self.yang_name = "match-values"
                                                                                self.yang_parent_name = "action-qlimit-info-array"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray))])
                                                                                self._leafs = OrderedDict()

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "match-values"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "match-values"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                    ])
                                                                                    self.min = None
                                                                                    self.max = None
                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray, ['min', 'max'], name, value)


                                                                class AccountingEventAaa(Entity):
                                                                    """
                                                                    accounting event aaa
                                                                    
                                                                    .. attribute:: action
                                                                    
                                                                    	action
                                                                    	**type**\:  :py:class:`AcctEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.AcctEn>`
                                                                    
                                                                    .. attribute:: aaa_list_name
                                                                    
                                                                    	aaa list name
                                                                    	**type**\: str
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa, self).__init__()

                                                                        self.yang_name = "accounting-event-aaa"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('action', (YLeaf(YType.enumeration, 'action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'AcctEn', '')])),
                                                                            ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                        ])
                                                                        self.action = None
                                                                        self.aaa_list_name = None
                                                                        self._segment_path = lambda: "accounting-event-aaa"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa, ['action', 'aaa_list_name'], name, value)


                                                                class AuthorizeId(Entity):
                                                                    """
                                                                    authorize id
                                                                    
                                                                    .. attribute:: id
                                                                    
                                                                    	id
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    .. attribute:: aaa_list_name
                                                                    
                                                                    	aaa list name
                                                                    	**type**\: str
                                                                    
                                                                    .. attribute:: format_name
                                                                    
                                                                    	format name
                                                                    	**type**\: str
                                                                    
                                                                    .. attribute:: password
                                                                    
                                                                    	password
                                                                    	**type**\: str
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId, self).__init__()

                                                                        self.yang_name = "authorize-id"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('id', (YLeaf(YType.uint8, 'id'), ['int'])),
                                                                            ('aaa_list_name', (YLeaf(YType.str, 'aaa-list-name'), ['str'])),
                                                                            ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                            ('password', (YLeaf(YType.str, 'password'), ['str'])),
                                                                        ])
                                                                        self.id = None
                                                                        self.aaa_list_name = None
                                                                        self.format_name = None
                                                                        self.password = None
                                                                        self._segment_path = lambda: "authorize-id"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId, ['id', 'aaa_list_name', 'format_name', 'password'], name, value)


                                                                class AfmReact(Entity):
                                                                    """
                                                                    afm react
                                                                    
                                                                    .. attribute:: action_afmon_react_info
                                                                    
                                                                    	action afmon react info
                                                                    	**type**\: list of  		 :py:class:`ActionAfmonReactInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact, self).__init__()

                                                                        self.yang_name = "afm-react"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("action-afmon-react-info", ("action_afmon_react_info", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo))])
                                                                        self._leafs = OrderedDict()

                                                                        self.action_afmon_react_info = YList(self)
                                                                        self._segment_path = lambda: "afm-react"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact, [], name, value)


                                                                    class ActionAfmonReactInfo(Entity):
                                                                        """
                                                                        action afmon react info
                                                                        
                                                                        .. attribute:: oper_id
                                                                        
                                                                        	React Operation ID
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: description
                                                                        
                                                                        	Describing the oper
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: trig_num_intvls
                                                                        
                                                                        	Averaged over N intvls
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: clone_ifh
                                                                        
                                                                        	Clone interface handle
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: notif_actns
                                                                        
                                                                        	Bitmap of actions on alert
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: criterion
                                                                        
                                                                        	React Criterion
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: trig_type
                                                                        
                                                                        	Immediate or averaged thresh trigger
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: trig_relop
                                                                        
                                                                        	Trigger LT\|LE\|GT\|GE\|Range
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: trig_level_1
                                                                        
                                                                        	Trigger threshold 1/lower
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: trig_level_2
                                                                        
                                                                        	Trigger upper threshold for range
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: alm_grp_thresh
                                                                        
                                                                        	Num/percent in grp
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..65535
                                                                        
                                                                        	**units**\: percentage
                                                                        
                                                                        .. attribute:: alm_type
                                                                        
                                                                        	Discrete \| grouped alarm
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: alm_severity
                                                                        
                                                                        	Major\|Minor\|... alarm
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo, self).__init__()

                                                                            self.yang_name = "action-afmon-react-info"
                                                                            self.yang_parent_name = "afm-react"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('oper_id', (YLeaf(YType.uint32, 'oper-id'), ['int'])),
                                                                                ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                ('trig_num_intvls', (YLeaf(YType.uint32, 'trig-num-intvls'), ['int'])),
                                                                                ('clone_ifh', (YLeaf(YType.uint32, 'clone-ifh'), ['int'])),
                                                                                ('notif_actns', (YLeaf(YType.uint8, 'notif-actns'), ['int'])),
                                                                                ('criterion', (YLeaf(YType.uint8, 'criterion'), ['int'])),
                                                                                ('trig_type', (YLeaf(YType.uint8, 'trig-type'), ['int'])),
                                                                                ('trig_relop', (YLeaf(YType.uint8, 'trig-relop'), ['int'])),
                                                                                ('trig_level_1', (YLeaf(YType.str, 'trig-level-1'), ['str'])),
                                                                                ('trig_level_2', (YLeaf(YType.str, 'trig-level-2'), ['str'])),
                                                                                ('alm_grp_thresh', (YLeaf(YType.uint16, 'alm-grp-thresh'), ['int'])),
                                                                                ('alm_type', (YLeaf(YType.uint8, 'alm-type'), ['int'])),
                                                                                ('alm_severity', (YLeaf(YType.uint8, 'alm-severity'), ['int'])),
                                                                            ])
                                                                            self.oper_id = None
                                                                            self.description = None
                                                                            self.trig_num_intvls = None
                                                                            self.clone_ifh = None
                                                                            self.notif_actns = None
                                                                            self.criterion = None
                                                                            self.trig_type = None
                                                                            self.trig_relop = None
                                                                            self.trig_level_1 = None
                                                                            self.trig_level_2 = None
                                                                            self.alm_grp_thresh = None
                                                                            self.alm_type = None
                                                                            self.alm_severity = None
                                                                            self._segment_path = lambda: "action-afmon-react-info"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo, ['oper_id', 'description', 'trig_num_intvls', 'clone_ifh', 'notif_actns', 'criterion', 'trig_type', 'trig_relop', 'trig_level_1', 'trig_level_2', 'alm_grp_thresh', 'alm_type', 'alm_severity'], name, value)


                                                                class Httpr(Entity):
                                                                    """
                                                                    httpr
                                                                    
                                                                    .. attribute:: redirect_url
                                                                    
                                                                    	redirect url
                                                                    	**type**\: str
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr, self).__init__()

                                                                        self.yang_name = "httpr"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('redirect_url', (YLeaf(YType.str, 'redirect-url'), ['str'])),
                                                                        ])
                                                                        self.redirect_url = None
                                                                        self._segment_path = lambda: "httpr"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr, ['redirect_url'], name, value)


                                                                class Punt(Entity):
                                                                    """
                                                                    punt
                                                                    
                                                                    .. attribute:: sn_type
                                                                    
                                                                    	service node ID type
                                                                    	**type**\:  :py:class:`DpssSnidTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.DpssSnidTypeEn>`
                                                                    
                                                                    .. attribute:: sn_index
                                                                    
                                                                    	service node index
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: sn_name
                                                                    
                                                                    	service node name
                                                                    	**type**\: str
                                                                    
                                                                    .. attribute:: app_id
                                                                    
                                                                    	application ID
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: local_id
                                                                    
                                                                    	local ID
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: vsnode_type
                                                                    
                                                                    	vservice node type
                                                                    	**type**\:  :py:class:`VsvcServiceTypeT <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.VsvcServiceTypeT>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt, self).__init__()

                                                                        self.yang_name = "punt"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('sn_type', (YLeaf(YType.enumeration, 'sn-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'DpssSnidTypeEn', '')])),
                                                                            ('sn_index', (YLeaf(YType.uint32, 'sn-index'), ['int'])),
                                                                            ('sn_name', (YLeaf(YType.str, 'sn-name'), ['str'])),
                                                                            ('app_id', (YLeaf(YType.uint32, 'app-id'), ['int'])),
                                                                            ('local_id', (YLeaf(YType.uint32, 'local-id'), ['int'])),
                                                                            ('vsnode_type', (YLeaf(YType.enumeration, 'vsnode-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'VsvcServiceTypeT', '')])),
                                                                        ])
                                                                        self.sn_type = None
                                                                        self.sn_index = None
                                                                        self.sn_name = None
                                                                        self.app_id = None
                                                                        self.local_id = None
                                                                        self.vsnode_type = None
                                                                        self._segment_path = lambda: "punt"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt, ['sn_type', 'sn_index', 'sn_name', 'app_id', 'local_id', 'vsnode_type'], name, value)


                                                                class Copy(Entity):
                                                                    """
                                                                    copy
                                                                    
                                                                    .. attribute:: num_byte
                                                                    
                                                                    	number of bytes
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: sn_type
                                                                    
                                                                    	service node ID type
                                                                    	**type**\:  :py:class:`DpssSnidTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.DpssSnidTypeEn>`
                                                                    
                                                                    .. attribute:: sn_index
                                                                    
                                                                    	service node index
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: sn_name
                                                                    
                                                                    	service node url
                                                                    	**type**\: str
                                                                    
                                                                    .. attribute:: app_id
                                                                    
                                                                    	application ID
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: local_id
                                                                    
                                                                    	local ID
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: vsnode_type
                                                                    
                                                                    	vservice node type
                                                                    	**type**\:  :py:class:`VsvcServiceTypeT <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.VsvcServiceTypeT>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy, self).__init__()

                                                                        self.yang_name = "copy"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('num_byte', (YLeaf(YType.uint32, 'num-byte'), ['int'])),
                                                                            ('sn_type', (YLeaf(YType.enumeration, 'sn-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'DpssSnidTypeEn', '')])),
                                                                            ('sn_index', (YLeaf(YType.uint32, 'sn-index'), ['int'])),
                                                                            ('sn_name', (YLeaf(YType.str, 'sn-name'), ['str'])),
                                                                            ('app_id', (YLeaf(YType.uint32, 'app-id'), ['int'])),
                                                                            ('local_id', (YLeaf(YType.uint32, 'local-id'), ['int'])),
                                                                            ('vsnode_type', (YLeaf(YType.enumeration, 'vsnode-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'VsvcServiceTypeT', '')])),
                                                                        ])
                                                                        self.num_byte = None
                                                                        self.sn_type = None
                                                                        self.sn_index = None
                                                                        self.sn_name = None
                                                                        self.app_id = None
                                                                        self.local_id = None
                                                                        self.vsnode_type = None
                                                                        self._segment_path = lambda: "copy"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy, ['num_byte', 'sn_type', 'sn_index', 'sn_name', 'app_id', 'local_id', 'vsnode_type'], name, value)


                                                                class Sfrag(Entity):
                                                                    """
                                                                    sfrag
                                                                    
                                                                    .. attribute:: name
                                                                    
                                                                    	Service Fragment Name
                                                                    	**type**\: str
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag, self).__init__()

                                                                        self.yang_name = "sfrag"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                        ])
                                                                        self.name = None
                                                                        self._segment_path = lambda: "sfrag"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag, ['name'], name, value)


                                                                class Redirect(Entity):
                                                                    """
                                                                    redirect
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: type
                                                                    
                                                                    	type
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect, self).__init__()

                                                                        self.yang_name = "redirect"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                            ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                        ])
                                                                        self.value = None
                                                                        self.type = None
                                                                        self._segment_path = lambda: "redirect"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect, ['value', 'type'], name, value)


                                                                class OutIntf(Entity):
                                                                    """
                                                                    out intf
                                                                    
                                                                    .. attribute:: out_ifname
                                                                    
                                                                    	output interface name
                                                                    	**type**\: str
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf, self).__init__()

                                                                        self.yang_name = "out-intf"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('out_ifname', (YLeaf(YType.str, 'out-ifname'), ['str'])),
                                                                        ])
                                                                        self.out_ifname = None
                                                                        self._segment_path = lambda: "out-intf"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf, ['out_ifname'], name, value)


                                                                class ServFunc(Entity):
                                                                    """
                                                                    serv func
                                                                    
                                                                    .. attribute:: path_id
                                                                    
                                                                    	service path id
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: service_index
                                                                    
                                                                    	service path index
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    .. attribute:: meta_name
                                                                    
                                                                    	metadata name
                                                                    	**type**\: str
                                                                    
                                                                    .. attribute:: vs_index
                                                                    
                                                                    	vservice index
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc, self).__init__()

                                                                        self.yang_name = "serv-func"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('path_id', (YLeaf(YType.uint32, 'path-id'), ['int'])),
                                                                            ('service_index', (YLeaf(YType.uint8, 'service-index'), ['int'])),
                                                                            ('meta_name', (YLeaf(YType.str, 'meta-name'), ['str'])),
                                                                            ('vs_index', (YLeaf(YType.uint32, 'vs-index'), ['int'])),
                                                                        ])
                                                                        self.path_id = None
                                                                        self.service_index = None
                                                                        self.meta_name = None
                                                                        self.vs_index = None
                                                                        self._segment_path = lambda: "serv-func"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc, ['path_id', 'service_index', 'meta_name', 'vs_index'], name, value)


                                                                class Police(Entity):
                                                                    """
                                                                    police
                                                                    
                                                                    .. attribute:: rate
                                                                    
                                                                    	rate
                                                                    	**type**\:  :py:class:`Rate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate>`
                                                                    
                                                                    .. attribute:: burst
                                                                    
                                                                    	burst
                                                                    	**type**\:  :py:class:`Burst <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst>`
                                                                    
                                                                    .. attribute:: peak_rate
                                                                    
                                                                    	peak rate
                                                                    	**type**\:  :py:class:`PeakRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate>`
                                                                    
                                                                    .. attribute:: peak_burst
                                                                    
                                                                    	peak burst
                                                                    	**type**\:  :py:class:`PeakBurst <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst>`
                                                                    
                                                                    .. attribute:: cdvt
                                                                    
                                                                    	cdvt
                                                                    	**type**\:  :py:class:`Cdvt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt>`
                                                                    
                                                                    .. attribute:: conform_actns
                                                                    
                                                                    	conform actns
                                                                    	**type**\:  :py:class:`ConformActns <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns>`
                                                                    
                                                                    .. attribute:: exceed_actns
                                                                    
                                                                    	exceed actns
                                                                    	**type**\:  :py:class:`ExceedActns <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns>`
                                                                    
                                                                    .. attribute:: violate_actns
                                                                    
                                                                    	violate actns
                                                                    	**type**\:  :py:class:`ViolateActns <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns>`
                                                                    
                                                                    .. attribute:: confclass_encode
                                                                    
                                                                    	confclass encode
                                                                    	**type**\:  :py:class:`ConfclassEncode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode>`
                                                                    
                                                                    .. attribute:: confclass_p
                                                                    
                                                                    	confclass p
                                                                    	**type**\:  :py:class:`ConfclassP <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP>`
                                                                    
                                                                    .. attribute:: excdclass_encode
                                                                    
                                                                    	excdclass encode
                                                                    	**type**\:  :py:class:`ExcdclassEncode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode>`
                                                                    
                                                                    .. attribute:: excdclass_p
                                                                    
                                                                    	excdclass p
                                                                    	**type**\:  :py:class:`ExcdclassP <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP>`
                                                                    
                                                                    .. attribute:: flags
                                                                    
                                                                    	flags
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: police_flags
                                                                    
                                                                    	police flags
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: sbuck_name
                                                                    
                                                                    	sbuck name
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..65
                                                                    
                                                                    .. attribute:: sbuck_type
                                                                    
                                                                    	sbuck type
                                                                    	**type**\:  :py:class:`SharedBucketType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.SharedBucketType>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police, self).__init__()

                                                                        self.yang_name = "police"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("rate", ("rate", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate)), ("burst", ("burst", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst)), ("peak-rate", ("peak_rate", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate)), ("peak-burst", ("peak_burst", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst)), ("cdvt", ("cdvt", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt)), ("conform-actns", ("conform_actns", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns)), ("exceed-actns", ("exceed_actns", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns)), ("violate-actns", ("violate_actns", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns)), ("confclass-encode", ("confclass_encode", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode)), ("confclass-p", ("confclass_p", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP)), ("excdclass-encode", ("excdclass_encode", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode)), ("excdclass-p", ("excdclass_p", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP))])
                                                                        self._leafs = OrderedDict([
                                                                            ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                            ('police_flags', (YLeaf(YType.uint32, 'police-flags'), ['int'])),
                                                                            ('sbuck_name', (YLeaf(YType.str, 'sbuck-name'), ['str'])),
                                                                            ('sbuck_type', (YLeaf(YType.enumeration, 'sbuck-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'SharedBucketType', '')])),
                                                                        ])
                                                                        self.flags = None
                                                                        self.police_flags = None
                                                                        self.sbuck_name = None
                                                                        self.sbuck_type = None

                                                                        self.rate = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate()
                                                                        self.rate.parent = self
                                                                        self._children_name_map["rate"] = "rate"

                                                                        self.burst = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst()
                                                                        self.burst.parent = self
                                                                        self._children_name_map["burst"] = "burst"

                                                                        self.peak_rate = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate()
                                                                        self.peak_rate.parent = self
                                                                        self._children_name_map["peak_rate"] = "peak-rate"

                                                                        self.peak_burst = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst()
                                                                        self.peak_burst.parent = self
                                                                        self._children_name_map["peak_burst"] = "peak-burst"

                                                                        self.cdvt = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt()
                                                                        self.cdvt.parent = self
                                                                        self._children_name_map["cdvt"] = "cdvt"

                                                                        self.conform_actns = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns()
                                                                        self.conform_actns.parent = self
                                                                        self._children_name_map["conform_actns"] = "conform-actns"

                                                                        self.exceed_actns = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns()
                                                                        self.exceed_actns.parent = self
                                                                        self._children_name_map["exceed_actns"] = "exceed-actns"

                                                                        self.violate_actns = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns()
                                                                        self.violate_actns.parent = self
                                                                        self._children_name_map["violate_actns"] = "violate-actns"

                                                                        self.confclass_encode = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode()
                                                                        self.confclass_encode.parent = self
                                                                        self._children_name_map["confclass_encode"] = "confclass-encode"

                                                                        self.confclass_p = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP()
                                                                        self.confclass_p.parent = self
                                                                        self._children_name_map["confclass_p"] = "confclass-p"

                                                                        self.excdclass_encode = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode()
                                                                        self.excdclass_encode.parent = self
                                                                        self._children_name_map["excdclass_encode"] = "excdclass-encode"

                                                                        self.excdclass_p = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP()
                                                                        self.excdclass_p.parent = self
                                                                        self._children_name_map["excdclass_p"] = "excdclass-p"
                                                                        self._segment_path = lambda: "police"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police, ['flags', 'police_flags', 'sbuck_name', 'sbuck_type'], name, value)


                                                                    class Rate(Entity):
                                                                        """
                                                                        rate
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate, self).__init__()

                                                                            self.yang_name = "rate"
                                                                            self.yang_parent_name = "police"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                            ])
                                                                            self.value = None
                                                                            self.unit = None
                                                                            self._segment_path = lambda: "rate"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate, ['value', 'unit'], name, value)


                                                                    class Burst(Entity):
                                                                        """
                                                                        burst
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst, self).__init__()

                                                                            self.yang_name = "burst"
                                                                            self.yang_parent_name = "police"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                            ])
                                                                            self.value = None
                                                                            self.unit = None
                                                                            self._segment_path = lambda: "burst"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst, ['value', 'unit'], name, value)


                                                                    class PeakRate(Entity):
                                                                        """
                                                                        peak rate
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate, self).__init__()

                                                                            self.yang_name = "peak-rate"
                                                                            self.yang_parent_name = "police"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                            ])
                                                                            self.value = None
                                                                            self.unit = None
                                                                            self._segment_path = lambda: "peak-rate"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate, ['value', 'unit'], name, value)


                                                                    class PeakBurst(Entity):
                                                                        """
                                                                        peak burst
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst, self).__init__()

                                                                            self.yang_name = "peak-burst"
                                                                            self.yang_parent_name = "police"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                            ])
                                                                            self.value = None
                                                                            self.unit = None
                                                                            self._segment_path = lambda: "peak-burst"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst, ['value', 'unit'], name, value)


                                                                    class Cdvt(Entity):
                                                                        """
                                                                        cdvt
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt, self).__init__()

                                                                            self.yang_name = "cdvt"
                                                                            self.yang_parent_name = "police"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                            ])
                                                                            self.value = None
                                                                            self.unit = None
                                                                            self._segment_path = lambda: "cdvt"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt, ['value', 'unit'], name, value)


                                                                    class ConformActns(Entity):
                                                                        """
                                                                        conform actns
                                                                        
                                                                        .. attribute:: police_action_array
                                                                        
                                                                        	police action array
                                                                        	**type**\: list of  		 :py:class:`PoliceActionArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns, self).__init__()

                                                                            self.yang_name = "conform-actns"
                                                                            self.yang_parent_name = "police"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("police-action-array", ("police_action_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.police_action_array = YList(self)
                                                                            self._segment_path = lambda: "conform-actns"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns, [], name, value)


                                                                        class PoliceActionArray(Entity):
                                                                            """
                                                                            police action array
                                                                            
                                                                            .. attribute:: mark
                                                                            
                                                                            	mark
                                                                            	**type**\:  :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark>`
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:  :py:class:`PoliceActionTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PoliceActionTypeEn>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray, self).__init__()

                                                                                self.yang_name = "police-action-array"
                                                                                self.yang_parent_name = "conform-actns"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("mark", ("mark", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PoliceActionTypeEn', '')])),
                                                                                ])
                                                                                self.type = None

                                                                                self.mark = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark()
                                                                                self.mark.parent = self
                                                                                self._children_name_map["mark"] = "mark"
                                                                                self._segment_path = lambda: "police-action-array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray, ['type'], name, value)


                                                                            class Mark(Entity):
                                                                                """
                                                                                mark
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:  :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                                
                                                                                .. attribute:: mark_flags
                                                                                
                                                                                	mark flags
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark, self).__init__()

                                                                                    self.yang_name = "mark"
                                                                                    self.yang_parent_name = "police-action-array"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MarkTypeEn', '')])),
                                                                                        ('mark_flags', (YLeaf(YType.uint32, 'mark-flags'), ['int'])),
                                                                                        ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                    ])
                                                                                    self.type = None
                                                                                    self.mark_flags = None
                                                                                    self.value = None
                                                                                    self._segment_path = lambda: "mark"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark, ['type', 'mark_flags', 'value'], name, value)


                                                                    class ExceedActns(Entity):
                                                                        """
                                                                        exceed actns
                                                                        
                                                                        .. attribute:: police_action_array
                                                                        
                                                                        	police action array
                                                                        	**type**\: list of  		 :py:class:`PoliceActionArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns, self).__init__()

                                                                            self.yang_name = "exceed-actns"
                                                                            self.yang_parent_name = "police"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("police-action-array", ("police_action_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.police_action_array = YList(self)
                                                                            self._segment_path = lambda: "exceed-actns"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns, [], name, value)


                                                                        class PoliceActionArray(Entity):
                                                                            """
                                                                            police action array
                                                                            
                                                                            .. attribute:: mark
                                                                            
                                                                            	mark
                                                                            	**type**\:  :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark>`
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:  :py:class:`PoliceActionTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PoliceActionTypeEn>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray, self).__init__()

                                                                                self.yang_name = "police-action-array"
                                                                                self.yang_parent_name = "exceed-actns"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("mark", ("mark", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PoliceActionTypeEn', '')])),
                                                                                ])
                                                                                self.type = None

                                                                                self.mark = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark()
                                                                                self.mark.parent = self
                                                                                self._children_name_map["mark"] = "mark"
                                                                                self._segment_path = lambda: "police-action-array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray, ['type'], name, value)


                                                                            class Mark(Entity):
                                                                                """
                                                                                mark
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:  :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                                
                                                                                .. attribute:: mark_flags
                                                                                
                                                                                	mark flags
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark, self).__init__()

                                                                                    self.yang_name = "mark"
                                                                                    self.yang_parent_name = "police-action-array"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MarkTypeEn', '')])),
                                                                                        ('mark_flags', (YLeaf(YType.uint32, 'mark-flags'), ['int'])),
                                                                                        ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                    ])
                                                                                    self.type = None
                                                                                    self.mark_flags = None
                                                                                    self.value = None
                                                                                    self._segment_path = lambda: "mark"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark, ['type', 'mark_flags', 'value'], name, value)


                                                                    class ViolateActns(Entity):
                                                                        """
                                                                        violate actns
                                                                        
                                                                        .. attribute:: police_action_array
                                                                        
                                                                        	police action array
                                                                        	**type**\: list of  		 :py:class:`PoliceActionArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns, self).__init__()

                                                                            self.yang_name = "violate-actns"
                                                                            self.yang_parent_name = "police"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("police-action-array", ("police_action_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray))])
                                                                            self._leafs = OrderedDict()

                                                                            self.police_action_array = YList(self)
                                                                            self._segment_path = lambda: "violate-actns"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns, [], name, value)


                                                                        class PoliceActionArray(Entity):
                                                                            """
                                                                            police action array
                                                                            
                                                                            .. attribute:: mark
                                                                            
                                                                            	mark
                                                                            	**type**\:  :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark>`
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:  :py:class:`PoliceActionTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PoliceActionTypeEn>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray, self).__init__()

                                                                                self.yang_name = "police-action-array"
                                                                                self.yang_parent_name = "violate-actns"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("mark", ("mark", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PoliceActionTypeEn', '')])),
                                                                                ])
                                                                                self.type = None

                                                                                self.mark = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark()
                                                                                self.mark.parent = self
                                                                                self._children_name_map["mark"] = "mark"
                                                                                self._segment_path = lambda: "police-action-array"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray, ['type'], name, value)


                                                                            class Mark(Entity):
                                                                                """
                                                                                mark
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:  :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                                
                                                                                .. attribute:: mark_flags
                                                                                
                                                                                	mark flags
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\: int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark, self).__init__()

                                                                                    self.yang_name = "mark"
                                                                                    self.yang_parent_name = "police-action-array"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([])
                                                                                    self._leafs = OrderedDict([
                                                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MarkTypeEn', '')])),
                                                                                        ('mark_flags', (YLeaf(YType.uint32, 'mark-flags'), ['int'])),
                                                                                        ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                    ])
                                                                                    self.type = None
                                                                                    self.mark_flags = None
                                                                                    self.value = None
                                                                                    self._segment_path = lambda: "mark"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark, ['type', 'mark_flags', 'value'], name, value)


                                                                    class ConfclassEncode(Entity):
                                                                        """
                                                                        confclass encode
                                                                        
                                                                        .. attribute:: inline_cmap
                                                                        
                                                                        	inline cmap
                                                                        	**type**\:  :py:class:`InlineCmap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap>`
                                                                        
                                                                        .. attribute:: enc
                                                                        
                                                                        	enc
                                                                        	**type**\:  :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                        
                                                                        .. attribute:: class_name
                                                                        
                                                                        	class name
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..65
                                                                        
                                                                        .. attribute:: hd
                                                                        
                                                                        	hd
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: idx
                                                                        
                                                                        	idx
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode, self).__init__()

                                                                            self.yang_name = "confclass-encode"
                                                                            self.yang_parent_name = "police"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("inline-cmap", ("inline_cmap", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap))])
                                                                            self._leafs = OrderedDict([
                                                                                ('enc', (YLeaf(YType.enumeration, 'enc'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyObjEncEn', '')])),
                                                                                ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                                                ('hd', (YLeaf(YType.uint64, 'hd'), ['int'])),
                                                                                ('idx', (YLeaf(YType.uint8, 'idx'), ['int'])),
                                                                            ])
                                                                            self.enc = None
                                                                            self.class_name = None
                                                                            self.hd = None
                                                                            self.idx = None

                                                                            self.inline_cmap = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap()
                                                                            self.inline_cmap.parent = self
                                                                            self._children_name_map["inline_cmap"] = "inline-cmap"
                                                                            self._segment_path = lambda: "confclass-encode"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode, ['enc', 'class_name', 'hd', 'idx'], name, value)


                                                                        class InlineCmap(Entity):
                                                                            """
                                                                            inline cmap
                                                                            
                                                                            .. attribute:: match_infop
                                                                            
                                                                            	Pointer to the first Match info
                                                                            	**type**\:  :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop>`
                                                                            
                                                                            .. attribute:: mode
                                                                            
                                                                            	Inline Class\-Map Mode Match any/all
                                                                            	**type**\:  :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                            
                                                                            .. attribute:: flags
                                                                            
                                                                            	Inline Class\-Map flags
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: match_count
                                                                            
                                                                            	Number of Match infos
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap, self).__init__()

                                                                                self.yang_name = "inline-cmap"
                                                                                self.yang_parent_name = "confclass-encode"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("match-infop", ("match_infop", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapModeEn', '')])),
                                                                                    ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                    ('match_count', (YLeaf(YType.uint32, 'match-count'), ['int'])),
                                                                                ])
                                                                                self.mode = None
                                                                                self.flags = None
                                                                                self.match_count = None

                                                                                self.match_infop = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop()
                                                                                self.match_infop.parent = self
                                                                                self._children_name_map["match_infop"] = "match-infop"
                                                                                self._segment_path = lambda: "inline-cmap"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap, ['mode', 'flags', 'match_count'], name, value)


                                                                            class MatchInfop(Entity):
                                                                                """
                                                                                Pointer to the first Match info
                                                                                
                                                                                .. attribute:: class_match_info_st
                                                                                
                                                                                	class match info st
                                                                                	**type**\: list of  		 :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop, self).__init__()

                                                                                    self.yang_name = "match-infop"
                                                                                    self.yang_parent_name = "inline-cmap"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("class-match-info-st", ("class_match_info_st", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.class_match_info_st = YList(self)
                                                                                    self._segment_path = lambda: "match-infop"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop, [], name, value)


                                                                                class ClassMatchInfoSt(Entity):
                                                                                    """
                                                                                    class match info st
                                                                                    
                                                                                    .. attribute:: match_data
                                                                                    
                                                                                    	Match criteria
                                                                                    	**type**\:  :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                    
                                                                                    .. attribute:: flags
                                                                                    
                                                                                    	Flags
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                        self.yang_name = "class-match-info-st"
                                                                                        self.yang_parent_name = "match-infop"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("match-data", ("match_data", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData))])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                        ])
                                                                                        self.flags = None

                                                                                        self.match_data = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                        self.match_data.parent = self
                                                                                        self._children_name_map["match_data"] = "match-data"
                                                                                        self._segment_path = lambda: "class-match-info-st"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                    class MatchData(Entity):
                                                                                        """
                                                                                        Match criteria
                                                                                        
                                                                                        .. attribute:: ipv4_dscp
                                                                                        
                                                                                        	IPv4 DSCP
                                                                                        	**type**\:  :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                        
                                                                                        .. attribute:: ipv6_dscp
                                                                                        
                                                                                        	IPv6 DSCP
                                                                                        	**type**\:  :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                        
                                                                                        .. attribute:: dscp
                                                                                        
                                                                                        	Match DSCP range array
                                                                                        	**type**\:  :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                        
                                                                                        .. attribute:: ipv4_prec
                                                                                        
                                                                                        	IPv4 Precedence
                                                                                        	**type**\:  :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                        
                                                                                        .. attribute:: ipv6_prec
                                                                                        
                                                                                        	IPv6 Precedence
                                                                                        	**type**\:  :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                        
                                                                                        .. attribute:: prec
                                                                                        
                                                                                        	Match Precedence array
                                                                                        	**type**\:  :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                        
                                                                                        .. attribute:: discard_class
                                                                                        
                                                                                        	Match Discard Class array
                                                                                        	**type**\:  :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                        
                                                                                        .. attribute:: qos_group
                                                                                        
                                                                                        	Match QoS group array
                                                                                        	**type**\:  :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                        
                                                                                        .. attribute:: traffic_class
                                                                                        
                                                                                        	Match Traffic class array
                                                                                        	**type**\:  :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                        
                                                                                        .. attribute:: proto
                                                                                        
                                                                                        	Match Protocol array
                                                                                        	**type**\:  :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                        
                                                                                        .. attribute:: icmp_v4
                                                                                        
                                                                                        	Match ICMPV4 Protocol
                                                                                        	**type**\:  :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                        
                                                                                        .. attribute:: icmp_v6
                                                                                        
                                                                                        	Match ICMPV6 Protocol array
                                                                                        	**type**\:  :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                        
                                                                                        .. attribute:: ipv4_packet_len
                                                                                        
                                                                                        	IPv4 packet length array
                                                                                        	**type**\:  :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                        
                                                                                        .. attribute:: ipv6_packet_len
                                                                                        
                                                                                        	IPv6 packet length array
                                                                                        	**type**\:  :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                        
                                                                                        .. attribute:: packet_len
                                                                                        
                                                                                        	Match packet length array
                                                                                        	**type**\:  :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                        
                                                                                        .. attribute:: flow_tag
                                                                                        
                                                                                        	Match flow\-tag array
                                                                                        	**type**\:  :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                        
                                                                                        .. attribute:: tcp_flag
                                                                                        
                                                                                        	Match tcp flag value
                                                                                        	**type**\:  :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                        
                                                                                        .. attribute:: icmpv4_type
                                                                                        
                                                                                        	Match ipv4 icmp type
                                                                                        	**type**\:  :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                        
                                                                                        .. attribute:: icmpv4_code
                                                                                        
                                                                                        	Match ipv4 icmp code
                                                                                        	**type**\:  :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                        
                                                                                        .. attribute:: icmpv6_type
                                                                                        
                                                                                        	Match ipv6 icmp type
                                                                                        	**type**\:  :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                        
                                                                                        .. attribute:: icmpv6_code
                                                                                        
                                                                                        	Match ipv6 icmp code
                                                                                        	**type**\:  :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                        
                                                                                        .. attribute:: mpls_exp
                                                                                        
                                                                                        	Match MPLS experimental topmost array
                                                                                        	**type**\:  :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                        
                                                                                        .. attribute:: mpls_exp_imp
                                                                                        
                                                                                        	Match MPLS experimental imposition array
                                                                                        	**type**\:  :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                        
                                                                                        .. attribute:: mpls_disp_ipv4_acl
                                                                                        
                                                                                        	MPLS Disposition IPv4 Access\-list
                                                                                        	**type**\:  :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                        
                                                                                        .. attribute:: mpls_disp_ipv6_acl
                                                                                        
                                                                                        	MPLS Disposition IPv6 Access\-list
                                                                                        	**type**\:  :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                        
                                                                                        .. attribute:: mpls_top_label
                                                                                        
                                                                                        	MPLS Topmost LABEL
                                                                                        	**type**\:  :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                        
                                                                                        .. attribute:: cos
                                                                                        
                                                                                        	Match CoS array
                                                                                        	**type**\:  :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                        
                                                                                        .. attribute:: cos_inr
                                                                                        
                                                                                        	Match inner header CoS
                                                                                        	**type**\:  :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                        
                                                                                        .. attribute:: dei
                                                                                        
                                                                                        	Match DEI Bit
                                                                                        	**type**\:  :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                        
                                                                                        .. attribute:: dei_inr
                                                                                        
                                                                                        	Match inner DEI Bit
                                                                                        	**type**\:  :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                        
                                                                                        .. attribute:: vlan
                                                                                        
                                                                                        	Match VLAN array
                                                                                        	**type**\:  :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                        
                                                                                        .. attribute:: vlan_inr
                                                                                        
                                                                                        	Match inner header VLAN range array
                                                                                        	**type**\:  :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                        
                                                                                        .. attribute:: fr_dlci
                                                                                        
                                                                                        	Match FR DLCI range array
                                                                                        	**type**\:  :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                        
                                                                                        .. attribute:: src_mac
                                                                                        
                                                                                        	Match Source MAC address
                                                                                        	**type**\:  :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                        
                                                                                        .. attribute:: dst_mac
                                                                                        
                                                                                        	Match Destination MAC address
                                                                                        	**type**\:  :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                        
                                                                                        .. attribute:: atm_clp
                                                                                        
                                                                                        	Match ATM CLP level
                                                                                        	**type**\:  :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                        
                                                                                        .. attribute:: fr_de
                                                                                        
                                                                                        	Match FR DE value
                                                                                        	**type**\:  :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                        
                                                                                        .. attribute:: ipv4_acl
                                                                                        
                                                                                        	IPv4 Access\-list
                                                                                        	**type**\:  :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                        
                                                                                        .. attribute:: ipv6_acl
                                                                                        
                                                                                        	IPv6 Access\-list
                                                                                        	**type**\:  :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                        
                                                                                        .. attribute:: ether_service_acl
                                                                                        
                                                                                        	Ethernet\-Services Access\-list
                                                                                        	**type**\:  :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                        
                                                                                        .. attribute:: avail_id
                                                                                        
                                                                                        	Available Identifiers
                                                                                        	**type**\:  :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                        
                                                                                        .. attribute:: media_type
                                                                                        
                                                                                        	Media Type
                                                                                        	**type**\:  :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                        
                                                                                        .. attribute:: subs_protocol
                                                                                        
                                                                                        	Protocol
                                                                                        	**type**\:  :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                        
                                                                                        .. attribute:: dnis
                                                                                        
                                                                                        	DNIS
                                                                                        	**type**\:  :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                        
                                                                                        .. attribute:: dnis_regex
                                                                                        
                                                                                        	DNIS Regular Expression
                                                                                        	**type**\:  :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                        
                                                                                        .. attribute:: domain
                                                                                        
                                                                                        	Domain Name
                                                                                        	**type**\:  :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                        
                                                                                        .. attribute:: domain_regex
                                                                                        
                                                                                        	Domain Regular Expression
                                                                                        	**type**\:  :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                        
                                                                                        .. attribute:: nas_port
                                                                                        
                                                                                        	NAS Port
                                                                                        	**type**\:  :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                        
                                                                                        .. attribute:: service_name
                                                                                        
                                                                                        	Service Name
                                                                                        	**type**\:  :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                        
                                                                                        .. attribute:: service_name_regex
                                                                                        
                                                                                        	Service Name Regular Exp
                                                                                        	**type**\:  :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                        
                                                                                        .. attribute:: src_addr_ipv4
                                                                                        
                                                                                        	Source Address IPV4
                                                                                        	**type**\:  :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                        
                                                                                        .. attribute:: dst_addr_ipv4
                                                                                        
                                                                                        	Destination Address IPV4
                                                                                        	**type**\:  :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                        
                                                                                        .. attribute:: src_addr_ipv6
                                                                                        
                                                                                        	Source Address IPV6
                                                                                        	**type**\:  :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                        
                                                                                        .. attribute:: dst_addr_ipv6
                                                                                        
                                                                                        	Destination Address IPV6
                                                                                        	**type**\:  :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                        
                                                                                        .. attribute:: src_addr_mac
                                                                                        
                                                                                        	Source Address MAC
                                                                                        	**type**\:  :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                        
                                                                                        .. attribute:: timer
                                                                                        
                                                                                        	Timer
                                                                                        	**type**\:  :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                        
                                                                                        .. attribute:: timer_regexp
                                                                                        
                                                                                        	Timer Regular Expression
                                                                                        	**type**\:  :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                        
                                                                                        .. attribute:: tunnel_name
                                                                                        
                                                                                        	Tunnel Name
                                                                                        	**type**\:  :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                        
                                                                                        .. attribute:: tunnel_name_regex
                                                                                        
                                                                                        	Tunnel Name Regular Expression
                                                                                        	**type**\:  :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                        
                                                                                        .. attribute:: user_name
                                                                                        
                                                                                        	User Name
                                                                                        	**type**\:  :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                        
                                                                                        .. attribute:: user_name_regex
                                                                                        
                                                                                        	User Name Regular Expression
                                                                                        	**type**\:  :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                        
                                                                                        .. attribute:: auth_username
                                                                                        
                                                                                        	Authenticated User Name
                                                                                        	**type**\:  :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                        
                                                                                        .. attribute:: auth_username_regex
                                                                                        
                                                                                        	Authenticated User Name RegEx
                                                                                        	**type**\:  :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                        
                                                                                        .. attribute:: unauth_username
                                                                                        
                                                                                        	Unauthenticated User Name
                                                                                        	**type**\:  :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                        
                                                                                        .. attribute:: unauth_username_regex
                                                                                        
                                                                                        	Unauthenticated User Name RegEx
                                                                                        	**type**\:  :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                        
                                                                                        .. attribute:: auth_domain
                                                                                        
                                                                                        	Authenticated domain name
                                                                                        	**type**\:  :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                        
                                                                                        .. attribute:: auth_domain_regex
                                                                                        
                                                                                        	Authenticated Domain Name RegEx
                                                                                        	**type**\:  :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                        
                                                                                        .. attribute:: unauth_domain
                                                                                        
                                                                                        	Unauthenticated Domain Name
                                                                                        	**type**\:  :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                        
                                                                                        .. attribute:: unauth_domain_regex
                                                                                        
                                                                                        	Unauthenticated Domain Name RegEx
                                                                                        	**type**\:  :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                        
                                                                                        .. attribute:: vendor_id
                                                                                        
                                                                                        	Vendor ID
                                                                                        	**type**\:  :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                        
                                                                                        .. attribute:: vendor_id_regex
                                                                                        
                                                                                        	Vendor ID RegEx
                                                                                        	**type**\:  :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                        
                                                                                        .. attribute:: access_interface
                                                                                        
                                                                                        	Access interface
                                                                                        	**type**\:  :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                        
                                                                                        .. attribute:: input_interface
                                                                                        
                                                                                        	Input interface
                                                                                        	**type**\:  :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                        
                                                                                        .. attribute:: input_intfhdl
                                                                                        
                                                                                        	Input interface handle
                                                                                        	**type**\:  :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                        
                                                                                        .. attribute:: ethertype
                                                                                        
                                                                                        	Ethernet type
                                                                                        	**type**\:  :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                        
                                                                                        .. attribute:: flow_key_data
                                                                                        
                                                                                        	Flow key structure
                                                                                        	**type**\:  :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                        
                                                                                        .. attribute:: dhcp_client_id
                                                                                        
                                                                                        	Dhcp Client ID
                                                                                        	**type**\:  :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                        
                                                                                        .. attribute:: dhcp_client_id_regex
                                                                                        
                                                                                        	Dhcp Client ID RegEx
                                                                                        	**type**\:  :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                        
                                                                                        .. attribute:: circuit_id
                                                                                        
                                                                                        	Circuit ID
                                                                                        	**type**\:  :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                        
                                                                                        .. attribute:: circuit_id_regex
                                                                                        
                                                                                        	Circuit ID RegEx
                                                                                        	**type**\:  :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                        
                                                                                        .. attribute:: remote_id
                                                                                        
                                                                                        	Remote ID
                                                                                        	**type**\:  :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                        
                                                                                        .. attribute:: remote_id_regex
                                                                                        
                                                                                        	Remote ID RegEx
                                                                                        	**type**\:  :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                        
                                                                                        .. attribute:: src_port
                                                                                        
                                                                                        	Source port
                                                                                        	**type**\:  :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                        
                                                                                        .. attribute:: dst_port
                                                                                        
                                                                                        	Destination port
                                                                                        	**type**\:  :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                        
                                                                                        .. attribute:: type
                                                                                        
                                                                                        	type
                                                                                        	**type**\:  :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                        
                                                                                        .. attribute:: mpls_top_eos
                                                                                        
                                                                                        	MPLS Topmost EOS
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: fragment_type
                                                                                        
                                                                                        	Fragment type
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: authen_status
                                                                                        
                                                                                        	Authentication Status
                                                                                        	**type**\:  :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                        
                                                                                        .. attribute:: mlp_negotiated
                                                                                        
                                                                                        	MLP Negotiated
                                                                                        	**type**\:  :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                            self.yang_name = "match-data"
                                                                                            self.yang_parent_name = "class-match-info-st"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("ipv4-dscp", ("ipv4_dscp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp)), ("ipv6-dscp", ("ipv6_dscp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp)), ("dscp", ("dscp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp)), ("ipv4-prec", ("ipv4_prec", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec)), ("ipv6-prec", ("ipv6_prec", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec)), ("prec", ("prec", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec)), ("discard-class", ("discard_class", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass)), ("qos-group", ("qos_group", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup)), ("traffic-class", ("traffic_class", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass)), ("proto", ("proto", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto)), ("icmp-v4", ("icmp_v4", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4)), ("icmp-v6", ("icmp_v6", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6)), ("ipv4-packet-len", ("ipv4_packet_len", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen)), ("ipv6-packet-len", ("ipv6_packet_len", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen)), ("packet-len", ("packet_len", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen)), ("flow-tag", ("flow_tag", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag)), ("tcp-flag", ("tcp_flag", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag)), ("icmpv4-type", ("icmpv4_type", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type)), ("icmpv4-code", ("icmpv4_code", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code)), ("icmpv6-type", ("icmpv6_type", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type)), ("icmpv6-code", ("icmpv6_code", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code)), ("mpls-exp", ("mpls_exp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp)), ("mpls-exp-imp", ("mpls_exp_imp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp)), ("mpls-disp-ipv4-acl", ("mpls_disp_ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl)), ("mpls-disp-ipv6-acl", ("mpls_disp_ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl)), ("mpls-top-label", ("mpls_top_label", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel)), ("cos", ("cos", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos)), ("cos-inr", ("cos_inr", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr)), ("dei", ("dei", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei)), ("dei-inr", ("dei_inr", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr)), ("vlan", ("vlan", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan)), ("vlan-inr", ("vlan_inr", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)), ("fr-dlci", ("fr_dlci", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci)), ("src-mac", ("src_mac", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac)), ("dst-mac", ("dst_mac", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac)), ("atm-clp", ("atm_clp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp)), ("fr-de", ("fr_de", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe)), ("ipv4-acl", ("ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl)), ("ipv6-acl", ("ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl)), ("ether-service-acl", ("ether_service_acl", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl)), ("avail-id", ("avail_id", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId)), ("media-type", ("media_type", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType)), ("subs-protocol", ("subs_protocol", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol)), ("dnis", ("dnis", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis)), ("dnis-regex", ("dnis_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex)), ("domain", ("domain", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain)), ("domain-regex", ("domain_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex)), ("nas-port", ("nas_port", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort)), ("service-name", ("service_name", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName)), ("service-name-regex", ("service_name_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex)), ("src-addr-ipv4", ("src_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4)), ("dst-addr-ipv4", ("dst_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4)), ("src-addr-ipv6", ("src_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6)), ("dst-addr-ipv6", ("dst_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6)), ("src-addr-mac", ("src_addr_mac", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac)), ("timer", ("timer", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer)), ("timer-regexp", ("timer_regexp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp)), ("tunnel-name", ("tunnel_name", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName)), ("tunnel-name-regex", ("tunnel_name_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex)), ("user-name", ("user_name", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName)), ("user-name-regex", ("user_name_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex)), ("auth-username", ("auth_username", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername)), ("auth-username-regex", ("auth_username_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex)), ("unauth-username", ("unauth_username", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername)), ("unauth-username-regex", ("unauth_username_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex)), ("auth-domain", ("auth_domain", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain)), ("auth-domain-regex", ("auth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex)), ("unauth-domain", ("unauth_domain", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain)), ("unauth-domain-regex", ("unauth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex)), ("vendor-id", ("vendor_id", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId)), ("vendor-id-regex", ("vendor_id_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex)), ("access-interface", ("access_interface", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface)), ("input-interface", ("input_interface", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface)), ("input-intfhdl", ("input_intfhdl", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl)), ("ethertype", ("ethertype", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype)), ("flow-key-data", ("flow_key_data", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData)), ("dhcp-client-id", ("dhcp_client_id", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId)), ("dhcp-client-id-regex", ("dhcp_client_id_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex)), ("circuit-id", ("circuit_id", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId)), ("circuit-id-regex", ("circuit_id_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex)), ("remote-id", ("remote_id", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId)), ("remote-id-regex", ("remote_id_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex)), ("src-port", ("src_port", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort)), ("dst-port", ("dst_port", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort))])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchTypeEn', '')])),
                                                                                                ('mpls_top_eos', (YLeaf(YType.uint8, 'mpls-top-eos'), ['int'])),
                                                                                                ('fragment_type', (YLeaf(YType.uint8, 'fragment-type'), ['int'])),
                                                                                                ('authen_status', (YLeaf(YType.enumeration, 'authen-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchAuthenStatusEn', '')])),
                                                                                                ('mlp_negotiated', (YLeaf(YType.enumeration, 'mlp-negotiated'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchMlpNegotiatedEn', '')])),
                                                                                            ])
                                                                                            self.type = None
                                                                                            self.mpls_top_eos = None
                                                                                            self.fragment_type = None
                                                                                            self.authen_status = None
                                                                                            self.mlp_negotiated = None

                                                                                            self.ipv4_dscp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                            self.ipv4_dscp.parent = self
                                                                                            self._children_name_map["ipv4_dscp"] = "ipv4-dscp"

                                                                                            self.ipv6_dscp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                            self.ipv6_dscp.parent = self
                                                                                            self._children_name_map["ipv6_dscp"] = "ipv6-dscp"

                                                                                            self.dscp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                            self.dscp.parent = self
                                                                                            self._children_name_map["dscp"] = "dscp"

                                                                                            self.ipv4_prec = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                            self.ipv4_prec.parent = self
                                                                                            self._children_name_map["ipv4_prec"] = "ipv4-prec"

                                                                                            self.ipv6_prec = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                            self.ipv6_prec.parent = self
                                                                                            self._children_name_map["ipv6_prec"] = "ipv6-prec"

                                                                                            self.prec = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                            self.prec.parent = self
                                                                                            self._children_name_map["prec"] = "prec"

                                                                                            self.discard_class = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                            self.discard_class.parent = self
                                                                                            self._children_name_map["discard_class"] = "discard-class"

                                                                                            self.qos_group = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                            self.qos_group.parent = self
                                                                                            self._children_name_map["qos_group"] = "qos-group"

                                                                                            self.traffic_class = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                            self.traffic_class.parent = self
                                                                                            self._children_name_map["traffic_class"] = "traffic-class"

                                                                                            self.proto = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                            self.proto.parent = self
                                                                                            self._children_name_map["proto"] = "proto"

                                                                                            self.icmp_v4 = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                            self.icmp_v4.parent = self
                                                                                            self._children_name_map["icmp_v4"] = "icmp-v4"

                                                                                            self.icmp_v6 = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                            self.icmp_v6.parent = self
                                                                                            self._children_name_map["icmp_v6"] = "icmp-v6"

                                                                                            self.ipv4_packet_len = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                            self.ipv4_packet_len.parent = self
                                                                                            self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"

                                                                                            self.ipv6_packet_len = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                            self.ipv6_packet_len.parent = self
                                                                                            self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"

                                                                                            self.packet_len = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                            self.packet_len.parent = self
                                                                                            self._children_name_map["packet_len"] = "packet-len"

                                                                                            self.flow_tag = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                            self.flow_tag.parent = self
                                                                                            self._children_name_map["flow_tag"] = "flow-tag"

                                                                                            self.tcp_flag = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                            self.tcp_flag.parent = self
                                                                                            self._children_name_map["tcp_flag"] = "tcp-flag"

                                                                                            self.icmpv4_type = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                            self.icmpv4_type.parent = self
                                                                                            self._children_name_map["icmpv4_type"] = "icmpv4-type"

                                                                                            self.icmpv4_code = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                            self.icmpv4_code.parent = self
                                                                                            self._children_name_map["icmpv4_code"] = "icmpv4-code"

                                                                                            self.icmpv6_type = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                            self.icmpv6_type.parent = self
                                                                                            self._children_name_map["icmpv6_type"] = "icmpv6-type"

                                                                                            self.icmpv6_code = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                            self.icmpv6_code.parent = self
                                                                                            self._children_name_map["icmpv6_code"] = "icmpv6-code"

                                                                                            self.mpls_exp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                            self.mpls_exp.parent = self
                                                                                            self._children_name_map["mpls_exp"] = "mpls-exp"

                                                                                            self.mpls_exp_imp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                            self.mpls_exp_imp.parent = self
                                                                                            self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"

                                                                                            self.mpls_disp_ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                            self.mpls_disp_ipv4_acl.parent = self
                                                                                            self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"

                                                                                            self.mpls_disp_ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                            self.mpls_disp_ipv6_acl.parent = self
                                                                                            self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"

                                                                                            self.mpls_top_label = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                            self.mpls_top_label.parent = self
                                                                                            self._children_name_map["mpls_top_label"] = "mpls-top-label"

                                                                                            self.cos = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                            self.cos.parent = self
                                                                                            self._children_name_map["cos"] = "cos"

                                                                                            self.cos_inr = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                            self.cos_inr.parent = self
                                                                                            self._children_name_map["cos_inr"] = "cos-inr"

                                                                                            self.dei = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                            self.dei.parent = self
                                                                                            self._children_name_map["dei"] = "dei"

                                                                                            self.dei_inr = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                            self.dei_inr.parent = self
                                                                                            self._children_name_map["dei_inr"] = "dei-inr"

                                                                                            self.vlan = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                            self.vlan.parent = self
                                                                                            self._children_name_map["vlan"] = "vlan"

                                                                                            self.vlan_inr = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                            self.vlan_inr.parent = self
                                                                                            self._children_name_map["vlan_inr"] = "vlan-inr"

                                                                                            self.fr_dlci = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                            self.fr_dlci.parent = self
                                                                                            self._children_name_map["fr_dlci"] = "fr-dlci"

                                                                                            self.src_mac = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                            self.src_mac.parent = self
                                                                                            self._children_name_map["src_mac"] = "src-mac"

                                                                                            self.dst_mac = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                            self.dst_mac.parent = self
                                                                                            self._children_name_map["dst_mac"] = "dst-mac"

                                                                                            self.atm_clp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                            self.atm_clp.parent = self
                                                                                            self._children_name_map["atm_clp"] = "atm-clp"

                                                                                            self.fr_de = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                            self.fr_de.parent = self
                                                                                            self._children_name_map["fr_de"] = "fr-de"

                                                                                            self.ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                            self.ipv4_acl.parent = self
                                                                                            self._children_name_map["ipv4_acl"] = "ipv4-acl"

                                                                                            self.ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                            self.ipv6_acl.parent = self
                                                                                            self._children_name_map["ipv6_acl"] = "ipv6-acl"

                                                                                            self.ether_service_acl = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                            self.ether_service_acl.parent = self
                                                                                            self._children_name_map["ether_service_acl"] = "ether-service-acl"

                                                                                            self.avail_id = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                            self.avail_id.parent = self
                                                                                            self._children_name_map["avail_id"] = "avail-id"

                                                                                            self.media_type = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                            self.media_type.parent = self
                                                                                            self._children_name_map["media_type"] = "media-type"

                                                                                            self.subs_protocol = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                            self.subs_protocol.parent = self
                                                                                            self._children_name_map["subs_protocol"] = "subs-protocol"

                                                                                            self.dnis = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                            self.dnis.parent = self
                                                                                            self._children_name_map["dnis"] = "dnis"

                                                                                            self.dnis_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                            self.dnis_regex.parent = self
                                                                                            self._children_name_map["dnis_regex"] = "dnis-regex"

                                                                                            self.domain = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                            self.domain.parent = self
                                                                                            self._children_name_map["domain"] = "domain"

                                                                                            self.domain_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                            self.domain_regex.parent = self
                                                                                            self._children_name_map["domain_regex"] = "domain-regex"

                                                                                            self.nas_port = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                            self.nas_port.parent = self
                                                                                            self._children_name_map["nas_port"] = "nas-port"

                                                                                            self.service_name = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                            self.service_name.parent = self
                                                                                            self._children_name_map["service_name"] = "service-name"

                                                                                            self.service_name_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                            self.service_name_regex.parent = self
                                                                                            self._children_name_map["service_name_regex"] = "service-name-regex"

                                                                                            self.src_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                            self.src_addr_ipv4.parent = self
                                                                                            self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"

                                                                                            self.dst_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                            self.dst_addr_ipv4.parent = self
                                                                                            self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"

                                                                                            self.src_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                            self.src_addr_ipv6.parent = self
                                                                                            self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"

                                                                                            self.dst_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                            self.dst_addr_ipv6.parent = self
                                                                                            self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"

                                                                                            self.src_addr_mac = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                            self.src_addr_mac.parent = self
                                                                                            self._children_name_map["src_addr_mac"] = "src-addr-mac"

                                                                                            self.timer = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                            self.timer.parent = self
                                                                                            self._children_name_map["timer"] = "timer"

                                                                                            self.timer_regexp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                            self.timer_regexp.parent = self
                                                                                            self._children_name_map["timer_regexp"] = "timer-regexp"

                                                                                            self.tunnel_name = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                            self.tunnel_name.parent = self
                                                                                            self._children_name_map["tunnel_name"] = "tunnel-name"

                                                                                            self.tunnel_name_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                            self.tunnel_name_regex.parent = self
                                                                                            self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"

                                                                                            self.user_name = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                            self.user_name.parent = self
                                                                                            self._children_name_map["user_name"] = "user-name"

                                                                                            self.user_name_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                            self.user_name_regex.parent = self
                                                                                            self._children_name_map["user_name_regex"] = "user-name-regex"

                                                                                            self.auth_username = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                            self.auth_username.parent = self
                                                                                            self._children_name_map["auth_username"] = "auth-username"

                                                                                            self.auth_username_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                            self.auth_username_regex.parent = self
                                                                                            self._children_name_map["auth_username_regex"] = "auth-username-regex"

                                                                                            self.unauth_username = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                            self.unauth_username.parent = self
                                                                                            self._children_name_map["unauth_username"] = "unauth-username"

                                                                                            self.unauth_username_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                            self.unauth_username_regex.parent = self
                                                                                            self._children_name_map["unauth_username_regex"] = "unauth-username-regex"

                                                                                            self.auth_domain = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                            self.auth_domain.parent = self
                                                                                            self._children_name_map["auth_domain"] = "auth-domain"

                                                                                            self.auth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                            self.auth_domain_regex.parent = self
                                                                                            self._children_name_map["auth_domain_regex"] = "auth-domain-regex"

                                                                                            self.unauth_domain = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                            self.unauth_domain.parent = self
                                                                                            self._children_name_map["unauth_domain"] = "unauth-domain"

                                                                                            self.unauth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                            self.unauth_domain_regex.parent = self
                                                                                            self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"

                                                                                            self.vendor_id = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                            self.vendor_id.parent = self
                                                                                            self._children_name_map["vendor_id"] = "vendor-id"

                                                                                            self.vendor_id_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                            self.vendor_id_regex.parent = self
                                                                                            self._children_name_map["vendor_id_regex"] = "vendor-id-regex"

                                                                                            self.access_interface = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                            self.access_interface.parent = self
                                                                                            self._children_name_map["access_interface"] = "access-interface"

                                                                                            self.input_interface = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                            self.input_interface.parent = self
                                                                                            self._children_name_map["input_interface"] = "input-interface"

                                                                                            self.input_intfhdl = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                            self.input_intfhdl.parent = self
                                                                                            self._children_name_map["input_intfhdl"] = "input-intfhdl"

                                                                                            self.ethertype = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                            self.ethertype.parent = self
                                                                                            self._children_name_map["ethertype"] = "ethertype"

                                                                                            self.flow_key_data = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                            self.flow_key_data.parent = self
                                                                                            self._children_name_map["flow_key_data"] = "flow-key-data"

                                                                                            self.dhcp_client_id = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                            self.dhcp_client_id.parent = self
                                                                                            self._children_name_map["dhcp_client_id"] = "dhcp-client-id"

                                                                                            self.dhcp_client_id_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                            self.dhcp_client_id_regex.parent = self
                                                                                            self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"

                                                                                            self.circuit_id = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                            self.circuit_id.parent = self
                                                                                            self._children_name_map["circuit_id"] = "circuit-id"

                                                                                            self.circuit_id_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                            self.circuit_id_regex.parent = self
                                                                                            self._children_name_map["circuit_id_regex"] = "circuit-id-regex"

                                                                                            self.remote_id = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                            self.remote_id.parent = self
                                                                                            self._children_name_map["remote_id"] = "remote-id"

                                                                                            self.remote_id_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                            self.remote_id_regex.parent = self
                                                                                            self._children_name_map["remote_id_regex"] = "remote-id-regex"

                                                                                            self.src_port = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                            self.src_port.parent = self
                                                                                            self._children_name_map["src_port"] = "src-port"

                                                                                            self.dst_port = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                            self.dst_port.parent = self
                                                                                            self._children_name_map["dst_port"] = "dst-port"
                                                                                            self._segment_path = lambda: "match-data"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, ['type', 'mpls_top_eos', 'fragment_type', 'authen_status', 'mlp_negotiated'], name, value)


                                                                                        class Ipv4Dscp(Entity):
                                                                                            """
                                                                                            IPv4 DSCP
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                self.yang_name = "ipv4-dscp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ipv4-dscp"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "ipv4-dscp"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                        class Ipv6Dscp(Entity):
                                                                                            """
                                                                                            IPv6 DSCP
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                self.yang_name = "ipv6-dscp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ipv6-dscp"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "ipv6-dscp"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                        class Dscp(Entity):
                                                                                            """
                                                                                            Match DSCP range array
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                self.yang_name = "dscp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "dscp"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "dscp"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                        class Ipv4Prec(Entity):
                                                                                            """
                                                                                            IPv4 Precedence
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                self.yang_name = "ipv4-prec"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "ipv4-prec"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                        class Ipv6Prec(Entity):
                                                                                            """
                                                                                            IPv6 Precedence
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                self.yang_name = "ipv6-prec"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "ipv6-prec"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                        class Prec(Entity):
                                                                                            """
                                                                                            Match Precedence array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                self.yang_name = "prec"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "prec"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                        class DiscardClass(Entity):
                                                                                            """
                                                                                            Match Discard Class array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                self.yang_name = "discard-class"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "discard-class"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                        class QosGroup(Entity):
                                                                                            """
                                                                                            Match QoS group array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                self.yang_name = "qos-group"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "qos-group"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "qos-group"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['min', 'max'], name, value)


                                                                                        class TrafficClass(Entity):
                                                                                            """
                                                                                            Match Traffic class array
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                self.yang_name = "traffic-class"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "traffic-class"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "traffic-class"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['min', 'max'], name, value)


                                                                                        class Proto(Entity):
                                                                                            """
                                                                                            Match Protocol array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                self.yang_name = "proto"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "proto"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "proto"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['min', 'max'], name, value)


                                                                                        class IcmpV4(Entity):
                                                                                            """
                                                                                            Match ICMPV4 Protocol
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	Protocol type
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: code
                                                                                            
                                                                                            	Protocol code
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                self.yang_name = "icmp-v4"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                    ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                ])
                                                                                                self.type = None
                                                                                                self.code = None
                                                                                                self._segment_path = lambda: "icmp-v4"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['type', 'code'], name, value)


                                                                                        class IcmpV6(Entity):
                                                                                            """
                                                                                            Match ICMPV6 Protocol array
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	Protocol type
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: code
                                                                                            
                                                                                            	Protocol code
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                self.yang_name = "icmp-v6"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                    ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                ])
                                                                                                self.type = None
                                                                                                self.code = None
                                                                                                self._segment_path = lambda: "icmp-v6"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['type', 'code'], name, value)


                                                                                        class Ipv4PacketLen(Entity):
                                                                                            """
                                                                                            IPv4 packet length array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                self.yang_name = "ipv4-packet-len"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ipv4-packet-len"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "ipv4-packet-len"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                        class Ipv6PacketLen(Entity):
                                                                                            """
                                                                                            IPv6 packet length array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                self.yang_name = "ipv6-packet-len"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ipv6-packet-len"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "ipv6-packet-len"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                        class PacketLen(Entity):
                                                                                            """
                                                                                            Match packet length array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                self.yang_name = "packet-len"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "packet-len"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "packet-len"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                        class FlowTag(Entity):
                                                                                            """
                                                                                            Match flow\-tag array
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                self.yang_name = "flow-tag"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "flow-tag"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "flow-tag"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['min', 'max'], name, value)


                                                                                        class TcpFlag(Entity):
                                                                                            """
                                                                                            Match tcp flag value
                                                                                            
                                                                                            .. attribute:: value
                                                                                            
                                                                                            	Value of TCP flag
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: match_any
                                                                                            
                                                                                            	Match any TCP flag bit
                                                                                            	**type**\: bool
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                self.yang_name = "tcp-flag"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                                    ('match_any', (YLeaf(YType.boolean, 'match-any'), ['bool'])),
                                                                                                ])
                                                                                                self.value = None
                                                                                                self.match_any = None
                                                                                                self._segment_path = lambda: "tcp-flag"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['value', 'match_any'], name, value)


                                                                                        class Icmpv4Type(Entity):
                                                                                            """
                                                                                            Match ipv4 icmp type
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                self.yang_name = "icmpv4-type"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "icmpv4-type"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "icmpv4-type"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                        class Icmpv4Code(Entity):
                                                                                            """
                                                                                            Match ipv4 icmp code
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                self.yang_name = "icmpv4-code"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "icmpv4-code"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "icmpv4-code"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                        class Icmpv6Type(Entity):
                                                                                            """
                                                                                            Match ipv6 icmp type
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                self.yang_name = "icmpv6-type"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "icmpv6-type"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "icmpv6-type"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                        class Icmpv6Code(Entity):
                                                                                            """
                                                                                            Match ipv6 icmp code
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                self.yang_name = "icmpv6-code"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "icmpv6-code"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "icmpv6-code"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                        class MplsExp(Entity):
                                                                                            """
                                                                                            Match MPLS experimental topmost array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                self.yang_name = "mpls-exp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "mpls-exp"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                        class MplsExpImp(Entity):
                                                                                            """
                                                                                            Match MPLS experimental imposition array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                self.yang_name = "mpls-exp-imp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "mpls-exp-imp"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                        class MplsDispIpv4Acl(Entity):
                                                                                            """
                                                                                            MPLS Disposition IPv4 Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "mpls-disp-ipv4-acl"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                        class MplsDispIpv6Acl(Entity):
                                                                                            """
                                                                                            MPLS Disposition IPv6 Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "mpls-disp-ipv6-acl"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                        class MplsTopLabel(Entity):
                                                                                            """
                                                                                            MPLS Topmost LABEL
                                                                                            
                                                                                            .. attribute:: uint32_rng_array
                                                                                            
                                                                                            	uint32 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                self.yang_name = "mpls-top-label"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint32_rng_array", ("uint32_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint32_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "mpls-top-label"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                            class Uint32RngArray(Entity):
                                                                                                """
                                                                                                uint32 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                    self.yang_name = "uint32_rng_array"
                                                                                                    self.yang_parent_name = "mpls-top-label"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint32, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint32, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint32_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['min', 'max'], name, value)


                                                                                        class Cos(Entity):
                                                                                            """
                                                                                            Match CoS array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                self.yang_name = "cos"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "cos"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                        class CosInr(Entity):
                                                                                            """
                                                                                            Match inner header CoS
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                self.yang_name = "cos-inr"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "cos-inr"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                        class Dei(Entity):
                                                                                            """
                                                                                            Match DEI Bit
                                                                                            
                                                                                            .. attribute:: bit_value
                                                                                            
                                                                                            	Value of the DEI bit
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                self.yang_name = "dei"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                ])
                                                                                                self.bit_value = None
                                                                                                self._segment_path = lambda: "dei"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                        class DeiInr(Entity):
                                                                                            """
                                                                                            Match inner DEI Bit
                                                                                            
                                                                                            .. attribute:: bit_value
                                                                                            
                                                                                            	Value of the DEI bit
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                self.yang_name = "dei-inr"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                ])
                                                                                                self.bit_value = None
                                                                                                self._segment_path = lambda: "dei-inr"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                        class Vlan(Entity):
                                                                                            """
                                                                                            Match VLAN array
                                                                                            
                                                                                            .. attribute:: vlan_id_array
                                                                                            
                                                                                            	vlan id array
                                                                                            	**type**\: list of  		 :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                self.yang_name = "vlan"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("vlan-id-array", ("vlan_id_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.vlan_id_array = YList(self)
                                                                                                self._segment_path = lambda: "vlan"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                            class VlanIdArray(Entity):
                                                                                                """
                                                                                                vlan id array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	VLAN mask
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                    self.yang_name = "vlan-id-array"
                                                                                                    self.yang_parent_name = "vlan"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ('mask', (YLeaf(YType.uint16, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self.mask = None
                                                                                                    self._segment_path = lambda: "vlan-id-array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['min', 'max', 'mask'], name, value)


                                                                                        class VlanInr(Entity):
                                                                                            """
                                                                                            Match inner header VLAN range array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                self.yang_name = "vlan-inr"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "vlan-inr"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "vlan-inr"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['min', 'max'], name, value)


                                                                                        class FrDlci(Entity):
                                                                                            """
                                                                                            Match FR DLCI range array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                self.yang_name = "fr-dlci"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "fr-dlci"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "fr-dlci"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['min', 'max'], name, value)


                                                                                        class SrcMac(Entity):
                                                                                            """
                                                                                            Match Source MAC address
                                                                                            
                                                                                            .. attribute:: mac_addr
                                                                                            
                                                                                            	MAC address
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	MAC mask
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                self.yang_name = "src-mac"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                    ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                ])
                                                                                                self.mac_addr = []
                                                                                                self.mask = []
                                                                                                self._segment_path = lambda: "src-mac"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                        class DstMac(Entity):
                                                                                            """
                                                                                            Match Destination MAC address
                                                                                            
                                                                                            .. attribute:: mac_addr
                                                                                            
                                                                                            	MAC address
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	MAC mask
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                self.yang_name = "dst-mac"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                    ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                ])
                                                                                                self.mac_addr = []
                                                                                                self.mask = []
                                                                                                self._segment_path = lambda: "dst-mac"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                        class AtmClp(Entity):
                                                                                            """
                                                                                            Match ATM CLP level
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                self.yang_name = "atm-clp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "atm-clp"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                        class FrDe(Entity):
                                                                                            """
                                                                                            Match FR DE value
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                self.yang_name = "fr-de"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "fr-de"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                        class Ipv4Acl(Entity):
                                                                                            """
                                                                                            IPv4 Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                self.yang_name = "ipv4-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "ipv4-acl"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                        class Ipv6Acl(Entity):
                                                                                            """
                                                                                            IPv6 Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                self.yang_name = "ipv6-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "ipv6-acl"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                        class EtherServiceAcl(Entity):
                                                                                            """
                                                                                            Ethernet\-Services Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                self.yang_name = "ether-service-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "ether-service-acl"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                        class AvailId(Entity):
                                                                                            """
                                                                                            Available Identifiers
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                self.yang_name = "avail-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "avail-id"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                        class MediaType(Entity):
                                                                                            """
                                                                                            Media Type
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                self.yang_name = "media-type"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "media-type"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                        class SubsProtocol(Entity):
                                                                                            """
                                                                                            Protocol
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                self.yang_name = "subs-protocol"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "subs-protocol"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                        class Dnis(Entity):
                                                                                            """
                                                                                            DNIS
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                self.yang_name = "dnis"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "dnis"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                        class DnisRegex(Entity):
                                                                                            """
                                                                                            DNIS Regular Expression
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                self.yang_name = "dnis-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "dnis-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                        class Domain(Entity):
                                                                                            """
                                                                                            Domain Name
                                                                                            
                                                                                            .. attribute:: domain_array
                                                                                            
                                                                                            	domain array
                                                                                            	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                self.yang_name = "domain"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.domain_array = YList(self)
                                                                                                self._segment_path = lambda: "domain"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                            class DomainArray(Entity):
                                                                                                """
                                                                                                domain array
                                                                                                
                                                                                                .. attribute:: domain_name
                                                                                                
                                                                                                	domain name
                                                                                                	**type**\: str
                                                                                                
                                                                                                .. attribute:: format_name
                                                                                                
                                                                                                	format name
                                                                                                	**type**\: str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                    self.yang_name = "domain-array"
                                                                                                    self.yang_parent_name = "domain"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                        ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                    ])
                                                                                                    self.domain_name = None
                                                                                                    self.format_name = None
                                                                                                    self._segment_path = lambda: "domain-array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                        class DomainRegex(Entity):
                                                                                            """
                                                                                            Domain Regular Expression
                                                                                            
                                                                                            .. attribute:: domain_array
                                                                                            
                                                                                            	domain array
                                                                                            	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                self.yang_name = "domain-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.domain_array = YList(self)
                                                                                                self._segment_path = lambda: "domain-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                            class DomainArray(Entity):
                                                                                                """
                                                                                                domain array
                                                                                                
                                                                                                .. attribute:: domain_name
                                                                                                
                                                                                                	domain name
                                                                                                	**type**\: str
                                                                                                
                                                                                                .. attribute:: format_name
                                                                                                
                                                                                                	format name
                                                                                                	**type**\: str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                    self.yang_name = "domain-array"
                                                                                                    self.yang_parent_name = "domain-regex"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                        ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                    ])
                                                                                                    self.domain_name = None
                                                                                                    self.format_name = None
                                                                                                    self._segment_path = lambda: "domain-array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                        class NasPort(Entity):
                                                                                            """
                                                                                            NAS Port
                                                                                            
                                                                                            .. attribute:: nas_port_array
                                                                                            
                                                                                            	nas port array
                                                                                            	**type**\: list of  		 :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                self.yang_name = "nas-port"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("nas-port-array", ("nas_port_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.nas_port_array = YList(self)
                                                                                                self._segment_path = lambda: "nas-port"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                            class NasPortArray(Entity):
                                                                                                """
                                                                                                nas port array
                                                                                                
                                                                                                .. attribute:: sub_id
                                                                                                
                                                                                                	sub id
                                                                                                	**type**\:  :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                
                                                                                                .. attribute:: operator
                                                                                                
                                                                                                	operator
                                                                                                	**type**\:  :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                
                                                                                                .. attribute:: value
                                                                                                
                                                                                                	value
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                    self.yang_name = "nas-port-array"
                                                                                                    self.yang_parent_name = "nas-port"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('sub_id', (YLeaf(YType.enumeration, 'sub-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchNasPortSubIdEn', '')])),
                                                                                                        ('operator', (YLeaf(YType.enumeration, 'operator'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchLogicalOperatorEn', '')])),
                                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                                    ])
                                                                                                    self.sub_id = None
                                                                                                    self.operator = None
                                                                                                    self.value = None
                                                                                                    self._segment_path = lambda: "nas-port-array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['sub_id', 'operator', 'value'], name, value)


                                                                                        class ServiceName(Entity):
                                                                                            """
                                                                                            Service Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                self.yang_name = "service-name"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "service-name"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                        class ServiceNameRegex(Entity):
                                                                                            """
                                                                                            Service Name Regular Exp
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                self.yang_name = "service-name-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "service-name-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                        class SrcAddrIpv4(Entity):
                                                                                            """
                                                                                            Source Address IPV4
                                                                                            
                                                                                            .. attribute:: ipv4_addr_array
                                                                                            
                                                                                            	ipv4 addr array
                                                                                            	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                self.yang_name = "src-addr-ipv4"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.ipv4_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "src-addr-ipv4"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                            class Ipv4AddrArray(Entity):
                                                                                                """
                                                                                                ipv4 addr array
                                                                                                
                                                                                                .. attribute:: prefix
                                                                                                
                                                                                                	prefix
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	mask
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                    self.yang_name = "ipv4-addr-array"
                                                                                                    self.yang_parent_name = "src-addr-ipv4"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                        ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                    ])
                                                                                                    self.prefix = None
                                                                                                    self.mask = None
                                                                                                    self._segment_path = lambda: "ipv4-addr-array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                        class DstAddrIpv4(Entity):
                                                                                            """
                                                                                            Destination Address IPV4
                                                                                            
                                                                                            .. attribute:: ipv4_addr_array
                                                                                            
                                                                                            	ipv4 addr array
                                                                                            	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                self.yang_name = "dst-addr-ipv4"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.ipv4_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "dst-addr-ipv4"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                            class Ipv4AddrArray(Entity):
                                                                                                """
                                                                                                ipv4 addr array
                                                                                                
                                                                                                .. attribute:: prefix
                                                                                                
                                                                                                	prefix
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	mask
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                    self.yang_name = "ipv4-addr-array"
                                                                                                    self.yang_parent_name = "dst-addr-ipv4"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                        ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                    ])
                                                                                                    self.prefix = None
                                                                                                    self.mask = None
                                                                                                    self._segment_path = lambda: "ipv4-addr-array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                        class SrcAddrIpv6(Entity):
                                                                                            """
                                                                                            Source Address IPV6
                                                                                            
                                                                                            .. attribute:: ipv6_addr_array
                                                                                            
                                                                                            	ipv6 addr array
                                                                                            	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                self.yang_name = "src-addr-ipv6"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.ipv6_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "src-addr-ipv6"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                            class Ipv6AddrArray(Entity):
                                                                                                """
                                                                                                ipv6 addr array
                                                                                                
                                                                                                .. attribute:: prefix
                                                                                                
                                                                                                	IPV6 prefix
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	IPV6 mask
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                    self.yang_name = "ipv6-addr-array"
                                                                                                    self.yang_parent_name = "src-addr-ipv6"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                        ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.prefix = None
                                                                                                    self.mask = None
                                                                                                    self._segment_path = lambda: "ipv6-addr-array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                        class DstAddrIpv6(Entity):
                                                                                            """
                                                                                            Destination Address IPV6
                                                                                            
                                                                                            .. attribute:: ipv6_addr_array
                                                                                            
                                                                                            	ipv6 addr array
                                                                                            	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                self.yang_name = "dst-addr-ipv6"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.ipv6_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "dst-addr-ipv6"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                            class Ipv6AddrArray(Entity):
                                                                                                """
                                                                                                ipv6 addr array
                                                                                                
                                                                                                .. attribute:: prefix
                                                                                                
                                                                                                	IPV6 prefix
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	IPV6 mask
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                    self.yang_name = "ipv6-addr-array"
                                                                                                    self.yang_parent_name = "dst-addr-ipv6"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                        ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.prefix = None
                                                                                                    self.mask = None
                                                                                                    self._segment_path = lambda: "ipv6-addr-array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                        class SrcAddrMac(Entity):
                                                                                            """
                                                                                            Source Address MAC
                                                                                            
                                                                                            .. attribute:: mac_addr_array
                                                                                            
                                                                                            	mac addr array
                                                                                            	**type**\: list of  		 :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                self.yang_name = "src-addr-mac"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("mac-addr-array", ("mac_addr_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.mac_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "src-addr-mac"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                            class MacAddrArray(Entity):
                                                                                                """
                                                                                                mac addr array
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                    self.yang_name = "mac-addr-array"
                                                                                                    self.yang_parent_name = "src-addr-mac"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.mac_addr = []
                                                                                                    self.mask = []
                                                                                                    self._segment_path = lambda: "mac-addr-array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                        class Timer(Entity):
                                                                                            """
                                                                                            Timer
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                self.yang_name = "timer"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "timer"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                        class TimerRegexp(Entity):
                                                                                            """
                                                                                            Timer Regular Expression
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                self.yang_name = "timer-regexp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "timer-regexp"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                        class TunnelName(Entity):
                                                                                            """
                                                                                            Tunnel Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                self.yang_name = "tunnel-name"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "tunnel-name"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                        class TunnelNameRegex(Entity):
                                                                                            """
                                                                                            Tunnel Name Regular Expression
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                self.yang_name = "tunnel-name-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "tunnel-name-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                        class UserName(Entity):
                                                                                            """
                                                                                            User Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                self.yang_name = "user-name"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "user-name"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                        class UserNameRegex(Entity):
                                                                                            """
                                                                                            User Name Regular Expression
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                self.yang_name = "user-name-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "user-name-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                        class AuthUsername(Entity):
                                                                                            """
                                                                                            Authenticated User Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                self.yang_name = "auth-username"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "auth-username"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                        class AuthUsernameRegex(Entity):
                                                                                            """
                                                                                            Authenticated User Name RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                self.yang_name = "auth-username-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "auth-username-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                        class UnauthUsername(Entity):
                                                                                            """
                                                                                            Unauthenticated User Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                self.yang_name = "unauth-username"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "unauth-username"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                        class UnauthUsernameRegex(Entity):
                                                                                            """
                                                                                            Unauthenticated User Name RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                self.yang_name = "unauth-username-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "unauth-username-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                        class AuthDomain(Entity):
                                                                                            """
                                                                                            Authenticated domain name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                self.yang_name = "auth-domain"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "auth-domain"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                        class AuthDomainRegex(Entity):
                                                                                            """
                                                                                            Authenticated Domain Name RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                self.yang_name = "auth-domain-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "auth-domain-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                        class UnauthDomain(Entity):
                                                                                            """
                                                                                            Unauthenticated Domain Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                self.yang_name = "unauth-domain"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "unauth-domain"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                        class UnauthDomainRegex(Entity):
                                                                                            """
                                                                                            Unauthenticated Domain Name RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                self.yang_name = "unauth-domain-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "unauth-domain-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                        class VendorId(Entity):
                                                                                            """
                                                                                            Vendor ID
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                self.yang_name = "vendor-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "vendor-id"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                        class VendorIdRegex(Entity):
                                                                                            """
                                                                                            Vendor ID RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                self.yang_name = "vendor-id-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "vendor-id-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                        class AccessInterface(Entity):
                                                                                            """
                                                                                            Access interface
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                self.yang_name = "access-interface"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "access-interface"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                        class InputInterface(Entity):
                                                                                            """
                                                                                            Input interface
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                self.yang_name = "input-interface"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "input-interface"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                        class InputIntfhdl(Entity):
                                                                                            """
                                                                                            Input interface handle
                                                                                            
                                                                                            .. attribute:: uint64_array
                                                                                            
                                                                                            	uint64 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..18446744073709551615
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                self.yang_name = "input-intfhdl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint64_array', (YLeafList(YType.uint64, 'uint64_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint64_array = []
                                                                                                self._segment_path = lambda: "input-intfhdl"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                        class Ethertype(Entity):
                                                                                            """
                                                                                            Ethernet type
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                self.yang_name = "ethertype"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ethertype"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "ethertype"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['min', 'max'], name, value)


                                                                                        class FlowKeyData(Entity):
                                                                                            """
                                                                                            Flow key structure
                                                                                            
                                                                                            .. attribute:: flow_keys
                                                                                            
                                                                                            	flow keys
                                                                                            	**type**\:  :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                            
                                                                                            .. attribute:: max_count
                                                                                            
                                                                                            	Maximum count of flows
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: idle_timeout
                                                                                            
                                                                                            	Idle timeout of flows (in seconds)
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            	**units**\: second
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                self.yang_name = "flow-key-data"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("flow-keys", ("flow_keys", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys))])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('max_count', (YLeaf(YType.uint16, 'max-count'), ['int'])),
                                                                                                    ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                                                ])
                                                                                                self.max_count = None
                                                                                                self.idle_timeout = None

                                                                                                self.flow_keys = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                self.flow_keys.parent = self
                                                                                                self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                self._segment_path = lambda: "flow-key-data"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['max_count', 'idle_timeout'], name, value)


                                                                                            class FlowKeys(Entity):
                                                                                                """
                                                                                                flow keys
                                                                                                
                                                                                                .. attribute:: keys
                                                                                                
                                                                                                	keys
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                
                                                                                                .. attribute:: num
                                                                                                
                                                                                                	num
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                    self.yang_name = "flow-keys"
                                                                                                    self.yang_parent_name = "flow-key-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('keys', (YLeaf(YType.str, 'keys'), ['str'])),
                                                                                                        ('num', (YLeaf(YType.uint8, 'num'), ['int'])),
                                                                                                    ])
                                                                                                    self.keys = None
                                                                                                    self.num = None
                                                                                                    self._segment_path = lambda: "flow-keys"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                        class DhcpClientId(Entity):
                                                                                            """
                                                                                            Dhcp Client ID
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                self.yang_name = "dhcp-client-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "dhcp-client-id"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                        class DhcpClientIdRegex(Entity):
                                                                                            """
                                                                                            Dhcp Client ID RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                self.yang_name = "dhcp-client-id-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "dhcp-client-id-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                        class CircuitId(Entity):
                                                                                            """
                                                                                            Circuit ID
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                self.yang_name = "circuit-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "circuit-id"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                        class CircuitIdRegex(Entity):
                                                                                            """
                                                                                            Circuit ID RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                self.yang_name = "circuit-id-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "circuit-id-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                        class RemoteId(Entity):
                                                                                            """
                                                                                            Remote ID
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                self.yang_name = "remote-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "remote-id"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                        class RemoteIdRegex(Entity):
                                                                                            """
                                                                                            Remote ID RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                self.yang_name = "remote-id-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "remote-id-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                        class SrcPort(Entity):
                                                                                            """
                                                                                            Source port
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                self.yang_name = "src-port"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "src-port"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "src-port"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                                        class DstPort(Entity):
                                                                                            """
                                                                                            Destination port
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                self.yang_name = "dst-port"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "dst-port"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "dst-port"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                    class ConfclassP(Entity):
                                                                        """
                                                                        confclass p
                                                                        
                                                                        .. attribute:: class_map_bg
                                                                        
                                                                        	class map bg
                                                                        	**type**\: list of  		 :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP, self).__init__()

                                                                            self.yang_name = "confclass-p"
                                                                            self.yang_parent_name = "police"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("class-map-bg", ("class_map_bg", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg))])
                                                                            self._leafs = OrderedDict()

                                                                            self.class_map_bg = YList(self)
                                                                            self._segment_path = lambda: "confclass-p"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP, [], name, value)


                                                                        class ClassMapBg(Entity):
                                                                            """
                                                                            class map bg
                                                                            
                                                                            .. attribute:: match_infop
                                                                            
                                                                            	Pointer to the first Match info
                                                                            	**type**\:  :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop>`
                                                                            
                                                                            .. attribute:: name
                                                                            
                                                                            	Name of the class\-map
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..65
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	Class\-Map Type QoS/PBR/Netflow/..
                                                                            	**type**\:  :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                                            
                                                                            .. attribute:: mode
                                                                            
                                                                            	Class\-Map Mode Match any/Match all
                                                                            	**type**\:  :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                            
                                                                            .. attribute:: description
                                                                            
                                                                            	description
                                                                            	**type**\: str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg, self).__init__()

                                                                                self.yang_name = "class-map-bg"
                                                                                self.yang_parent_name = "confclass-p"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("match-infop", ("match_infop", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapTypeEn', '')])),
                                                                                    ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapModeEn', '')])),
                                                                                    ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                ])
                                                                                self.name = None
                                                                                self.type = None
                                                                                self.mode = None
                                                                                self.description = None

                                                                                self.match_infop = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop()
                                                                                self.match_infop.parent = self
                                                                                self._children_name_map["match_infop"] = "match-infop"
                                                                                self._segment_path = lambda: "class-map-bg"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg, ['name', 'type', 'mode', 'description'], name, value)


                                                                            class MatchInfop(Entity):
                                                                                """
                                                                                Pointer to the first Match info
                                                                                
                                                                                .. attribute:: class_match_info_st
                                                                                
                                                                                	class match info st
                                                                                	**type**\: list of  		 :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop, self).__init__()

                                                                                    self.yang_name = "match-infop"
                                                                                    self.yang_parent_name = "class-map-bg"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("class-match-info-st", ("class_match_info_st", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.class_match_info_st = YList(self)
                                                                                    self._segment_path = lambda: "match-infop"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop, [], name, value)


                                                                                class ClassMatchInfoSt(Entity):
                                                                                    """
                                                                                    class match info st
                                                                                    
                                                                                    .. attribute:: match_data
                                                                                    
                                                                                    	Match criteria
                                                                                    	**type**\:  :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                    
                                                                                    .. attribute:: flags
                                                                                    
                                                                                    	Flags
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                        self.yang_name = "class-match-info-st"
                                                                                        self.yang_parent_name = "match-infop"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("match-data", ("match_data", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData))])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                        ])
                                                                                        self.flags = None

                                                                                        self.match_data = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                        self.match_data.parent = self
                                                                                        self._children_name_map["match_data"] = "match-data"
                                                                                        self._segment_path = lambda: "class-match-info-st"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                    class MatchData(Entity):
                                                                                        """
                                                                                        Match criteria
                                                                                        
                                                                                        .. attribute:: ipv4_dscp
                                                                                        
                                                                                        	IPv4 DSCP
                                                                                        	**type**\:  :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                        
                                                                                        .. attribute:: ipv6_dscp
                                                                                        
                                                                                        	IPv6 DSCP
                                                                                        	**type**\:  :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                        
                                                                                        .. attribute:: dscp
                                                                                        
                                                                                        	Match DSCP range array
                                                                                        	**type**\:  :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                        
                                                                                        .. attribute:: ipv4_prec
                                                                                        
                                                                                        	IPv4 Precedence
                                                                                        	**type**\:  :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                        
                                                                                        .. attribute:: ipv6_prec
                                                                                        
                                                                                        	IPv6 Precedence
                                                                                        	**type**\:  :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                        
                                                                                        .. attribute:: prec
                                                                                        
                                                                                        	Match Precedence array
                                                                                        	**type**\:  :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                        
                                                                                        .. attribute:: discard_class
                                                                                        
                                                                                        	Match Discard Class array
                                                                                        	**type**\:  :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                        
                                                                                        .. attribute:: qos_group
                                                                                        
                                                                                        	Match QoS group array
                                                                                        	**type**\:  :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                        
                                                                                        .. attribute:: traffic_class
                                                                                        
                                                                                        	Match Traffic class array
                                                                                        	**type**\:  :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                        
                                                                                        .. attribute:: proto
                                                                                        
                                                                                        	Match Protocol array
                                                                                        	**type**\:  :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                        
                                                                                        .. attribute:: icmp_v4
                                                                                        
                                                                                        	Match ICMPV4 Protocol
                                                                                        	**type**\:  :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                        
                                                                                        .. attribute:: icmp_v6
                                                                                        
                                                                                        	Match ICMPV6 Protocol array
                                                                                        	**type**\:  :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                        
                                                                                        .. attribute:: ipv4_packet_len
                                                                                        
                                                                                        	IPv4 packet length array
                                                                                        	**type**\:  :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                        
                                                                                        .. attribute:: ipv6_packet_len
                                                                                        
                                                                                        	IPv6 packet length array
                                                                                        	**type**\:  :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                        
                                                                                        .. attribute:: packet_len
                                                                                        
                                                                                        	Match packet length array
                                                                                        	**type**\:  :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                        
                                                                                        .. attribute:: flow_tag
                                                                                        
                                                                                        	Match flow\-tag array
                                                                                        	**type**\:  :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                        
                                                                                        .. attribute:: tcp_flag
                                                                                        
                                                                                        	Match tcp flag value
                                                                                        	**type**\:  :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                        
                                                                                        .. attribute:: icmpv4_type
                                                                                        
                                                                                        	Match ipv4 icmp type
                                                                                        	**type**\:  :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                        
                                                                                        .. attribute:: icmpv4_code
                                                                                        
                                                                                        	Match ipv4 icmp code
                                                                                        	**type**\:  :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                        
                                                                                        .. attribute:: icmpv6_type
                                                                                        
                                                                                        	Match ipv6 icmp type
                                                                                        	**type**\:  :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                        
                                                                                        .. attribute:: icmpv6_code
                                                                                        
                                                                                        	Match ipv6 icmp code
                                                                                        	**type**\:  :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                        
                                                                                        .. attribute:: mpls_exp
                                                                                        
                                                                                        	Match MPLS experimental topmost array
                                                                                        	**type**\:  :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                        
                                                                                        .. attribute:: mpls_exp_imp
                                                                                        
                                                                                        	Match MPLS experimental imposition array
                                                                                        	**type**\:  :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                        
                                                                                        .. attribute:: mpls_disp_ipv4_acl
                                                                                        
                                                                                        	MPLS Disposition IPv4 Access\-list
                                                                                        	**type**\:  :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                        
                                                                                        .. attribute:: mpls_disp_ipv6_acl
                                                                                        
                                                                                        	MPLS Disposition IPv6 Access\-list
                                                                                        	**type**\:  :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                        
                                                                                        .. attribute:: mpls_top_label
                                                                                        
                                                                                        	MPLS Topmost LABEL
                                                                                        	**type**\:  :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                        
                                                                                        .. attribute:: cos
                                                                                        
                                                                                        	Match CoS array
                                                                                        	**type**\:  :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                        
                                                                                        .. attribute:: cos_inr
                                                                                        
                                                                                        	Match inner header CoS
                                                                                        	**type**\:  :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                        
                                                                                        .. attribute:: dei
                                                                                        
                                                                                        	Match DEI Bit
                                                                                        	**type**\:  :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                        
                                                                                        .. attribute:: dei_inr
                                                                                        
                                                                                        	Match inner DEI Bit
                                                                                        	**type**\:  :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                        
                                                                                        .. attribute:: vlan
                                                                                        
                                                                                        	Match VLAN array
                                                                                        	**type**\:  :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                        
                                                                                        .. attribute:: vlan_inr
                                                                                        
                                                                                        	Match inner header VLAN range array
                                                                                        	**type**\:  :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                        
                                                                                        .. attribute:: fr_dlci
                                                                                        
                                                                                        	Match FR DLCI range array
                                                                                        	**type**\:  :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                        
                                                                                        .. attribute:: src_mac
                                                                                        
                                                                                        	Match Source MAC address
                                                                                        	**type**\:  :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                        
                                                                                        .. attribute:: dst_mac
                                                                                        
                                                                                        	Match Destination MAC address
                                                                                        	**type**\:  :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                        
                                                                                        .. attribute:: atm_clp
                                                                                        
                                                                                        	Match ATM CLP level
                                                                                        	**type**\:  :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                        
                                                                                        .. attribute:: fr_de
                                                                                        
                                                                                        	Match FR DE value
                                                                                        	**type**\:  :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                        
                                                                                        .. attribute:: ipv4_acl
                                                                                        
                                                                                        	IPv4 Access\-list
                                                                                        	**type**\:  :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                        
                                                                                        .. attribute:: ipv6_acl
                                                                                        
                                                                                        	IPv6 Access\-list
                                                                                        	**type**\:  :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                        
                                                                                        .. attribute:: ether_service_acl
                                                                                        
                                                                                        	Ethernet\-Services Access\-list
                                                                                        	**type**\:  :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                        
                                                                                        .. attribute:: avail_id
                                                                                        
                                                                                        	Available Identifiers
                                                                                        	**type**\:  :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                        
                                                                                        .. attribute:: media_type
                                                                                        
                                                                                        	Media Type
                                                                                        	**type**\:  :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                        
                                                                                        .. attribute:: subs_protocol
                                                                                        
                                                                                        	Protocol
                                                                                        	**type**\:  :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                        
                                                                                        .. attribute:: dnis
                                                                                        
                                                                                        	DNIS
                                                                                        	**type**\:  :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                        
                                                                                        .. attribute:: dnis_regex
                                                                                        
                                                                                        	DNIS Regular Expression
                                                                                        	**type**\:  :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                        
                                                                                        .. attribute:: domain
                                                                                        
                                                                                        	Domain Name
                                                                                        	**type**\:  :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                        
                                                                                        .. attribute:: domain_regex
                                                                                        
                                                                                        	Domain Regular Expression
                                                                                        	**type**\:  :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                        
                                                                                        .. attribute:: nas_port
                                                                                        
                                                                                        	NAS Port
                                                                                        	**type**\:  :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                        
                                                                                        .. attribute:: service_name
                                                                                        
                                                                                        	Service Name
                                                                                        	**type**\:  :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                        
                                                                                        .. attribute:: service_name_regex
                                                                                        
                                                                                        	Service Name Regular Exp
                                                                                        	**type**\:  :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                        
                                                                                        .. attribute:: src_addr_ipv4
                                                                                        
                                                                                        	Source Address IPV4
                                                                                        	**type**\:  :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                        
                                                                                        .. attribute:: dst_addr_ipv4
                                                                                        
                                                                                        	Destination Address IPV4
                                                                                        	**type**\:  :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                        
                                                                                        .. attribute:: src_addr_ipv6
                                                                                        
                                                                                        	Source Address IPV6
                                                                                        	**type**\:  :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                        
                                                                                        .. attribute:: dst_addr_ipv6
                                                                                        
                                                                                        	Destination Address IPV6
                                                                                        	**type**\:  :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                        
                                                                                        .. attribute:: src_addr_mac
                                                                                        
                                                                                        	Source Address MAC
                                                                                        	**type**\:  :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                        
                                                                                        .. attribute:: timer
                                                                                        
                                                                                        	Timer
                                                                                        	**type**\:  :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                        
                                                                                        .. attribute:: timer_regexp
                                                                                        
                                                                                        	Timer Regular Expression
                                                                                        	**type**\:  :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                        
                                                                                        .. attribute:: tunnel_name
                                                                                        
                                                                                        	Tunnel Name
                                                                                        	**type**\:  :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                        
                                                                                        .. attribute:: tunnel_name_regex
                                                                                        
                                                                                        	Tunnel Name Regular Expression
                                                                                        	**type**\:  :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                        
                                                                                        .. attribute:: user_name
                                                                                        
                                                                                        	User Name
                                                                                        	**type**\:  :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                        
                                                                                        .. attribute:: user_name_regex
                                                                                        
                                                                                        	User Name Regular Expression
                                                                                        	**type**\:  :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                        
                                                                                        .. attribute:: auth_username
                                                                                        
                                                                                        	Authenticated User Name
                                                                                        	**type**\:  :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                        
                                                                                        .. attribute:: auth_username_regex
                                                                                        
                                                                                        	Authenticated User Name RegEx
                                                                                        	**type**\:  :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                        
                                                                                        .. attribute:: unauth_username
                                                                                        
                                                                                        	Unauthenticated User Name
                                                                                        	**type**\:  :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                        
                                                                                        .. attribute:: unauth_username_regex
                                                                                        
                                                                                        	Unauthenticated User Name RegEx
                                                                                        	**type**\:  :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                        
                                                                                        .. attribute:: auth_domain
                                                                                        
                                                                                        	Authenticated domain name
                                                                                        	**type**\:  :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                        
                                                                                        .. attribute:: auth_domain_regex
                                                                                        
                                                                                        	Authenticated Domain Name RegEx
                                                                                        	**type**\:  :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                        
                                                                                        .. attribute:: unauth_domain
                                                                                        
                                                                                        	Unauthenticated Domain Name
                                                                                        	**type**\:  :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                        
                                                                                        .. attribute:: unauth_domain_regex
                                                                                        
                                                                                        	Unauthenticated Domain Name RegEx
                                                                                        	**type**\:  :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                        
                                                                                        .. attribute:: vendor_id
                                                                                        
                                                                                        	Vendor ID
                                                                                        	**type**\:  :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                        
                                                                                        .. attribute:: vendor_id_regex
                                                                                        
                                                                                        	Vendor ID RegEx
                                                                                        	**type**\:  :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                        
                                                                                        .. attribute:: access_interface
                                                                                        
                                                                                        	Access interface
                                                                                        	**type**\:  :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                        
                                                                                        .. attribute:: input_interface
                                                                                        
                                                                                        	Input interface
                                                                                        	**type**\:  :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                        
                                                                                        .. attribute:: input_intfhdl
                                                                                        
                                                                                        	Input interface handle
                                                                                        	**type**\:  :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                        
                                                                                        .. attribute:: ethertype
                                                                                        
                                                                                        	Ethernet type
                                                                                        	**type**\:  :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                        
                                                                                        .. attribute:: flow_key_data
                                                                                        
                                                                                        	Flow key structure
                                                                                        	**type**\:  :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                        
                                                                                        .. attribute:: dhcp_client_id
                                                                                        
                                                                                        	Dhcp Client ID
                                                                                        	**type**\:  :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                        
                                                                                        .. attribute:: dhcp_client_id_regex
                                                                                        
                                                                                        	Dhcp Client ID RegEx
                                                                                        	**type**\:  :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                        
                                                                                        .. attribute:: circuit_id
                                                                                        
                                                                                        	Circuit ID
                                                                                        	**type**\:  :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                        
                                                                                        .. attribute:: circuit_id_regex
                                                                                        
                                                                                        	Circuit ID RegEx
                                                                                        	**type**\:  :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                        
                                                                                        .. attribute:: remote_id
                                                                                        
                                                                                        	Remote ID
                                                                                        	**type**\:  :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                        
                                                                                        .. attribute:: remote_id_regex
                                                                                        
                                                                                        	Remote ID RegEx
                                                                                        	**type**\:  :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                        
                                                                                        .. attribute:: src_port
                                                                                        
                                                                                        	Source port
                                                                                        	**type**\:  :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                        
                                                                                        .. attribute:: dst_port
                                                                                        
                                                                                        	Destination port
                                                                                        	**type**\:  :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                        
                                                                                        .. attribute:: type
                                                                                        
                                                                                        	type
                                                                                        	**type**\:  :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                        
                                                                                        .. attribute:: mpls_top_eos
                                                                                        
                                                                                        	MPLS Topmost EOS
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: fragment_type
                                                                                        
                                                                                        	Fragment type
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: authen_status
                                                                                        
                                                                                        	Authentication Status
                                                                                        	**type**\:  :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                        
                                                                                        .. attribute:: mlp_negotiated
                                                                                        
                                                                                        	MLP Negotiated
                                                                                        	**type**\:  :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                            self.yang_name = "match-data"
                                                                                            self.yang_parent_name = "class-match-info-st"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("ipv4-dscp", ("ipv4_dscp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp)), ("ipv6-dscp", ("ipv6_dscp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp)), ("dscp", ("dscp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp)), ("ipv4-prec", ("ipv4_prec", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec)), ("ipv6-prec", ("ipv6_prec", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec)), ("prec", ("prec", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec)), ("discard-class", ("discard_class", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass)), ("qos-group", ("qos_group", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup)), ("traffic-class", ("traffic_class", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass)), ("proto", ("proto", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto)), ("icmp-v4", ("icmp_v4", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4)), ("icmp-v6", ("icmp_v6", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6)), ("ipv4-packet-len", ("ipv4_packet_len", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen)), ("ipv6-packet-len", ("ipv6_packet_len", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen)), ("packet-len", ("packet_len", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen)), ("flow-tag", ("flow_tag", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag)), ("tcp-flag", ("tcp_flag", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag)), ("icmpv4-type", ("icmpv4_type", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type)), ("icmpv4-code", ("icmpv4_code", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code)), ("icmpv6-type", ("icmpv6_type", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type)), ("icmpv6-code", ("icmpv6_code", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code)), ("mpls-exp", ("mpls_exp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp)), ("mpls-exp-imp", ("mpls_exp_imp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp)), ("mpls-disp-ipv4-acl", ("mpls_disp_ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl)), ("mpls-disp-ipv6-acl", ("mpls_disp_ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl)), ("mpls-top-label", ("mpls_top_label", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel)), ("cos", ("cos", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos)), ("cos-inr", ("cos_inr", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr)), ("dei", ("dei", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei)), ("dei-inr", ("dei_inr", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr)), ("vlan", ("vlan", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan)), ("vlan-inr", ("vlan_inr", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)), ("fr-dlci", ("fr_dlci", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci)), ("src-mac", ("src_mac", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac)), ("dst-mac", ("dst_mac", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac)), ("atm-clp", ("atm_clp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp)), ("fr-de", ("fr_de", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe)), ("ipv4-acl", ("ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl)), ("ipv6-acl", ("ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl)), ("ether-service-acl", ("ether_service_acl", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl)), ("avail-id", ("avail_id", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId)), ("media-type", ("media_type", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType)), ("subs-protocol", ("subs_protocol", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol)), ("dnis", ("dnis", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis)), ("dnis-regex", ("dnis_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex)), ("domain", ("domain", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain)), ("domain-regex", ("domain_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex)), ("nas-port", ("nas_port", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort)), ("service-name", ("service_name", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName)), ("service-name-regex", ("service_name_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex)), ("src-addr-ipv4", ("src_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4)), ("dst-addr-ipv4", ("dst_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4)), ("src-addr-ipv6", ("src_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6)), ("dst-addr-ipv6", ("dst_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6)), ("src-addr-mac", ("src_addr_mac", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac)), ("timer", ("timer", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer)), ("timer-regexp", ("timer_regexp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp)), ("tunnel-name", ("tunnel_name", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName)), ("tunnel-name-regex", ("tunnel_name_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex)), ("user-name", ("user_name", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName)), ("user-name-regex", ("user_name_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex)), ("auth-username", ("auth_username", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername)), ("auth-username-regex", ("auth_username_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex)), ("unauth-username", ("unauth_username", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername)), ("unauth-username-regex", ("unauth_username_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex)), ("auth-domain", ("auth_domain", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain)), ("auth-domain-regex", ("auth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex)), ("unauth-domain", ("unauth_domain", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain)), ("unauth-domain-regex", ("unauth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex)), ("vendor-id", ("vendor_id", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId)), ("vendor-id-regex", ("vendor_id_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex)), ("access-interface", ("access_interface", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface)), ("input-interface", ("input_interface", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface)), ("input-intfhdl", ("input_intfhdl", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl)), ("ethertype", ("ethertype", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype)), ("flow-key-data", ("flow_key_data", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData)), ("dhcp-client-id", ("dhcp_client_id", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId)), ("dhcp-client-id-regex", ("dhcp_client_id_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex)), ("circuit-id", ("circuit_id", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId)), ("circuit-id-regex", ("circuit_id_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex)), ("remote-id", ("remote_id", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId)), ("remote-id-regex", ("remote_id_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex)), ("src-port", ("src_port", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort)), ("dst-port", ("dst_port", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort))])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchTypeEn', '')])),
                                                                                                ('mpls_top_eos', (YLeaf(YType.uint8, 'mpls-top-eos'), ['int'])),
                                                                                                ('fragment_type', (YLeaf(YType.uint8, 'fragment-type'), ['int'])),
                                                                                                ('authen_status', (YLeaf(YType.enumeration, 'authen-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchAuthenStatusEn', '')])),
                                                                                                ('mlp_negotiated', (YLeaf(YType.enumeration, 'mlp-negotiated'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchMlpNegotiatedEn', '')])),
                                                                                            ])
                                                                                            self.type = None
                                                                                            self.mpls_top_eos = None
                                                                                            self.fragment_type = None
                                                                                            self.authen_status = None
                                                                                            self.mlp_negotiated = None

                                                                                            self.ipv4_dscp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                            self.ipv4_dscp.parent = self
                                                                                            self._children_name_map["ipv4_dscp"] = "ipv4-dscp"

                                                                                            self.ipv6_dscp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                            self.ipv6_dscp.parent = self
                                                                                            self._children_name_map["ipv6_dscp"] = "ipv6-dscp"

                                                                                            self.dscp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                            self.dscp.parent = self
                                                                                            self._children_name_map["dscp"] = "dscp"

                                                                                            self.ipv4_prec = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                            self.ipv4_prec.parent = self
                                                                                            self._children_name_map["ipv4_prec"] = "ipv4-prec"

                                                                                            self.ipv6_prec = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                            self.ipv6_prec.parent = self
                                                                                            self._children_name_map["ipv6_prec"] = "ipv6-prec"

                                                                                            self.prec = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                            self.prec.parent = self
                                                                                            self._children_name_map["prec"] = "prec"

                                                                                            self.discard_class = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                            self.discard_class.parent = self
                                                                                            self._children_name_map["discard_class"] = "discard-class"

                                                                                            self.qos_group = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                            self.qos_group.parent = self
                                                                                            self._children_name_map["qos_group"] = "qos-group"

                                                                                            self.traffic_class = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                            self.traffic_class.parent = self
                                                                                            self._children_name_map["traffic_class"] = "traffic-class"

                                                                                            self.proto = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                            self.proto.parent = self
                                                                                            self._children_name_map["proto"] = "proto"

                                                                                            self.icmp_v4 = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                            self.icmp_v4.parent = self
                                                                                            self._children_name_map["icmp_v4"] = "icmp-v4"

                                                                                            self.icmp_v6 = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                            self.icmp_v6.parent = self
                                                                                            self._children_name_map["icmp_v6"] = "icmp-v6"

                                                                                            self.ipv4_packet_len = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                            self.ipv4_packet_len.parent = self
                                                                                            self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"

                                                                                            self.ipv6_packet_len = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                            self.ipv6_packet_len.parent = self
                                                                                            self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"

                                                                                            self.packet_len = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                            self.packet_len.parent = self
                                                                                            self._children_name_map["packet_len"] = "packet-len"

                                                                                            self.flow_tag = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                            self.flow_tag.parent = self
                                                                                            self._children_name_map["flow_tag"] = "flow-tag"

                                                                                            self.tcp_flag = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                            self.tcp_flag.parent = self
                                                                                            self._children_name_map["tcp_flag"] = "tcp-flag"

                                                                                            self.icmpv4_type = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                            self.icmpv4_type.parent = self
                                                                                            self._children_name_map["icmpv4_type"] = "icmpv4-type"

                                                                                            self.icmpv4_code = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                            self.icmpv4_code.parent = self
                                                                                            self._children_name_map["icmpv4_code"] = "icmpv4-code"

                                                                                            self.icmpv6_type = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                            self.icmpv6_type.parent = self
                                                                                            self._children_name_map["icmpv6_type"] = "icmpv6-type"

                                                                                            self.icmpv6_code = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                            self.icmpv6_code.parent = self
                                                                                            self._children_name_map["icmpv6_code"] = "icmpv6-code"

                                                                                            self.mpls_exp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                            self.mpls_exp.parent = self
                                                                                            self._children_name_map["mpls_exp"] = "mpls-exp"

                                                                                            self.mpls_exp_imp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                            self.mpls_exp_imp.parent = self
                                                                                            self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"

                                                                                            self.mpls_disp_ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                            self.mpls_disp_ipv4_acl.parent = self
                                                                                            self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"

                                                                                            self.mpls_disp_ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                            self.mpls_disp_ipv6_acl.parent = self
                                                                                            self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"

                                                                                            self.mpls_top_label = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                            self.mpls_top_label.parent = self
                                                                                            self._children_name_map["mpls_top_label"] = "mpls-top-label"

                                                                                            self.cos = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                            self.cos.parent = self
                                                                                            self._children_name_map["cos"] = "cos"

                                                                                            self.cos_inr = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                            self.cos_inr.parent = self
                                                                                            self._children_name_map["cos_inr"] = "cos-inr"

                                                                                            self.dei = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                            self.dei.parent = self
                                                                                            self._children_name_map["dei"] = "dei"

                                                                                            self.dei_inr = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                            self.dei_inr.parent = self
                                                                                            self._children_name_map["dei_inr"] = "dei-inr"

                                                                                            self.vlan = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                            self.vlan.parent = self
                                                                                            self._children_name_map["vlan"] = "vlan"

                                                                                            self.vlan_inr = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                            self.vlan_inr.parent = self
                                                                                            self._children_name_map["vlan_inr"] = "vlan-inr"

                                                                                            self.fr_dlci = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                            self.fr_dlci.parent = self
                                                                                            self._children_name_map["fr_dlci"] = "fr-dlci"

                                                                                            self.src_mac = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                            self.src_mac.parent = self
                                                                                            self._children_name_map["src_mac"] = "src-mac"

                                                                                            self.dst_mac = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                            self.dst_mac.parent = self
                                                                                            self._children_name_map["dst_mac"] = "dst-mac"

                                                                                            self.atm_clp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                            self.atm_clp.parent = self
                                                                                            self._children_name_map["atm_clp"] = "atm-clp"

                                                                                            self.fr_de = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                            self.fr_de.parent = self
                                                                                            self._children_name_map["fr_de"] = "fr-de"

                                                                                            self.ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                            self.ipv4_acl.parent = self
                                                                                            self._children_name_map["ipv4_acl"] = "ipv4-acl"

                                                                                            self.ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                            self.ipv6_acl.parent = self
                                                                                            self._children_name_map["ipv6_acl"] = "ipv6-acl"

                                                                                            self.ether_service_acl = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                            self.ether_service_acl.parent = self
                                                                                            self._children_name_map["ether_service_acl"] = "ether-service-acl"

                                                                                            self.avail_id = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                            self.avail_id.parent = self
                                                                                            self._children_name_map["avail_id"] = "avail-id"

                                                                                            self.media_type = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                            self.media_type.parent = self
                                                                                            self._children_name_map["media_type"] = "media-type"

                                                                                            self.subs_protocol = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                            self.subs_protocol.parent = self
                                                                                            self._children_name_map["subs_protocol"] = "subs-protocol"

                                                                                            self.dnis = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                            self.dnis.parent = self
                                                                                            self._children_name_map["dnis"] = "dnis"

                                                                                            self.dnis_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                            self.dnis_regex.parent = self
                                                                                            self._children_name_map["dnis_regex"] = "dnis-regex"

                                                                                            self.domain = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                            self.domain.parent = self
                                                                                            self._children_name_map["domain"] = "domain"

                                                                                            self.domain_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                            self.domain_regex.parent = self
                                                                                            self._children_name_map["domain_regex"] = "domain-regex"

                                                                                            self.nas_port = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                            self.nas_port.parent = self
                                                                                            self._children_name_map["nas_port"] = "nas-port"

                                                                                            self.service_name = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                            self.service_name.parent = self
                                                                                            self._children_name_map["service_name"] = "service-name"

                                                                                            self.service_name_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                            self.service_name_regex.parent = self
                                                                                            self._children_name_map["service_name_regex"] = "service-name-regex"

                                                                                            self.src_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                            self.src_addr_ipv4.parent = self
                                                                                            self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"

                                                                                            self.dst_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                            self.dst_addr_ipv4.parent = self
                                                                                            self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"

                                                                                            self.src_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                            self.src_addr_ipv6.parent = self
                                                                                            self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"

                                                                                            self.dst_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                            self.dst_addr_ipv6.parent = self
                                                                                            self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"

                                                                                            self.src_addr_mac = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                            self.src_addr_mac.parent = self
                                                                                            self._children_name_map["src_addr_mac"] = "src-addr-mac"

                                                                                            self.timer = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                            self.timer.parent = self
                                                                                            self._children_name_map["timer"] = "timer"

                                                                                            self.timer_regexp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                            self.timer_regexp.parent = self
                                                                                            self._children_name_map["timer_regexp"] = "timer-regexp"

                                                                                            self.tunnel_name = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                            self.tunnel_name.parent = self
                                                                                            self._children_name_map["tunnel_name"] = "tunnel-name"

                                                                                            self.tunnel_name_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                            self.tunnel_name_regex.parent = self
                                                                                            self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"

                                                                                            self.user_name = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                            self.user_name.parent = self
                                                                                            self._children_name_map["user_name"] = "user-name"

                                                                                            self.user_name_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                            self.user_name_regex.parent = self
                                                                                            self._children_name_map["user_name_regex"] = "user-name-regex"

                                                                                            self.auth_username = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                            self.auth_username.parent = self
                                                                                            self._children_name_map["auth_username"] = "auth-username"

                                                                                            self.auth_username_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                            self.auth_username_regex.parent = self
                                                                                            self._children_name_map["auth_username_regex"] = "auth-username-regex"

                                                                                            self.unauth_username = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                            self.unauth_username.parent = self
                                                                                            self._children_name_map["unauth_username"] = "unauth-username"

                                                                                            self.unauth_username_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                            self.unauth_username_regex.parent = self
                                                                                            self._children_name_map["unauth_username_regex"] = "unauth-username-regex"

                                                                                            self.auth_domain = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                            self.auth_domain.parent = self
                                                                                            self._children_name_map["auth_domain"] = "auth-domain"

                                                                                            self.auth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                            self.auth_domain_regex.parent = self
                                                                                            self._children_name_map["auth_domain_regex"] = "auth-domain-regex"

                                                                                            self.unauth_domain = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                            self.unauth_domain.parent = self
                                                                                            self._children_name_map["unauth_domain"] = "unauth-domain"

                                                                                            self.unauth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                            self.unauth_domain_regex.parent = self
                                                                                            self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"

                                                                                            self.vendor_id = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                            self.vendor_id.parent = self
                                                                                            self._children_name_map["vendor_id"] = "vendor-id"

                                                                                            self.vendor_id_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                            self.vendor_id_regex.parent = self
                                                                                            self._children_name_map["vendor_id_regex"] = "vendor-id-regex"

                                                                                            self.access_interface = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                            self.access_interface.parent = self
                                                                                            self._children_name_map["access_interface"] = "access-interface"

                                                                                            self.input_interface = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                            self.input_interface.parent = self
                                                                                            self._children_name_map["input_interface"] = "input-interface"

                                                                                            self.input_intfhdl = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                            self.input_intfhdl.parent = self
                                                                                            self._children_name_map["input_intfhdl"] = "input-intfhdl"

                                                                                            self.ethertype = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                            self.ethertype.parent = self
                                                                                            self._children_name_map["ethertype"] = "ethertype"

                                                                                            self.flow_key_data = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                            self.flow_key_data.parent = self
                                                                                            self._children_name_map["flow_key_data"] = "flow-key-data"

                                                                                            self.dhcp_client_id = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                            self.dhcp_client_id.parent = self
                                                                                            self._children_name_map["dhcp_client_id"] = "dhcp-client-id"

                                                                                            self.dhcp_client_id_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                            self.dhcp_client_id_regex.parent = self
                                                                                            self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"

                                                                                            self.circuit_id = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                            self.circuit_id.parent = self
                                                                                            self._children_name_map["circuit_id"] = "circuit-id"

                                                                                            self.circuit_id_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                            self.circuit_id_regex.parent = self
                                                                                            self._children_name_map["circuit_id_regex"] = "circuit-id-regex"

                                                                                            self.remote_id = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                            self.remote_id.parent = self
                                                                                            self._children_name_map["remote_id"] = "remote-id"

                                                                                            self.remote_id_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                            self.remote_id_regex.parent = self
                                                                                            self._children_name_map["remote_id_regex"] = "remote-id-regex"

                                                                                            self.src_port = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                            self.src_port.parent = self
                                                                                            self._children_name_map["src_port"] = "src-port"

                                                                                            self.dst_port = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                            self.dst_port.parent = self
                                                                                            self._children_name_map["dst_port"] = "dst-port"
                                                                                            self._segment_path = lambda: "match-data"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['type', 'mpls_top_eos', 'fragment_type', 'authen_status', 'mlp_negotiated'], name, value)


                                                                                        class Ipv4Dscp(Entity):
                                                                                            """
                                                                                            IPv4 DSCP
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                self.yang_name = "ipv4-dscp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ipv4-dscp"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "ipv4-dscp"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                        class Ipv6Dscp(Entity):
                                                                                            """
                                                                                            IPv6 DSCP
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                self.yang_name = "ipv6-dscp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ipv6-dscp"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "ipv6-dscp"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                        class Dscp(Entity):
                                                                                            """
                                                                                            Match DSCP range array
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                self.yang_name = "dscp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "dscp"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "dscp"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                        class Ipv4Prec(Entity):
                                                                                            """
                                                                                            IPv4 Precedence
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                self.yang_name = "ipv4-prec"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "ipv4-prec"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                        class Ipv6Prec(Entity):
                                                                                            """
                                                                                            IPv6 Precedence
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                self.yang_name = "ipv6-prec"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "ipv6-prec"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                        class Prec(Entity):
                                                                                            """
                                                                                            Match Precedence array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                self.yang_name = "prec"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "prec"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                        class DiscardClass(Entity):
                                                                                            """
                                                                                            Match Discard Class array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                self.yang_name = "discard-class"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "discard-class"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                        class QosGroup(Entity):
                                                                                            """
                                                                                            Match QoS group array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                self.yang_name = "qos-group"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "qos-group"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "qos-group"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['min', 'max'], name, value)


                                                                                        class TrafficClass(Entity):
                                                                                            """
                                                                                            Match Traffic class array
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                self.yang_name = "traffic-class"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "traffic-class"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "traffic-class"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['min', 'max'], name, value)


                                                                                        class Proto(Entity):
                                                                                            """
                                                                                            Match Protocol array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                self.yang_name = "proto"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "proto"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "proto"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['min', 'max'], name, value)


                                                                                        class IcmpV4(Entity):
                                                                                            """
                                                                                            Match ICMPV4 Protocol
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	Protocol type
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: code
                                                                                            
                                                                                            	Protocol code
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                self.yang_name = "icmp-v4"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                    ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                ])
                                                                                                self.type = None
                                                                                                self.code = None
                                                                                                self._segment_path = lambda: "icmp-v4"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['type', 'code'], name, value)


                                                                                        class IcmpV6(Entity):
                                                                                            """
                                                                                            Match ICMPV6 Protocol array
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	Protocol type
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: code
                                                                                            
                                                                                            	Protocol code
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                self.yang_name = "icmp-v6"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                    ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                ])
                                                                                                self.type = None
                                                                                                self.code = None
                                                                                                self._segment_path = lambda: "icmp-v6"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['type', 'code'], name, value)


                                                                                        class Ipv4PacketLen(Entity):
                                                                                            """
                                                                                            IPv4 packet length array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                self.yang_name = "ipv4-packet-len"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ipv4-packet-len"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "ipv4-packet-len"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                        class Ipv6PacketLen(Entity):
                                                                                            """
                                                                                            IPv6 packet length array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                self.yang_name = "ipv6-packet-len"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ipv6-packet-len"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "ipv6-packet-len"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                        class PacketLen(Entity):
                                                                                            """
                                                                                            Match packet length array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                self.yang_name = "packet-len"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "packet-len"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "packet-len"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                        class FlowTag(Entity):
                                                                                            """
                                                                                            Match flow\-tag array
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                self.yang_name = "flow-tag"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "flow-tag"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "flow-tag"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['min', 'max'], name, value)


                                                                                        class TcpFlag(Entity):
                                                                                            """
                                                                                            Match tcp flag value
                                                                                            
                                                                                            .. attribute:: value
                                                                                            
                                                                                            	Value of TCP flag
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: match_any
                                                                                            
                                                                                            	Match any TCP flag bit
                                                                                            	**type**\: bool
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                self.yang_name = "tcp-flag"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                                    ('match_any', (YLeaf(YType.boolean, 'match-any'), ['bool'])),
                                                                                                ])
                                                                                                self.value = None
                                                                                                self.match_any = None
                                                                                                self._segment_path = lambda: "tcp-flag"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['value', 'match_any'], name, value)


                                                                                        class Icmpv4Type(Entity):
                                                                                            """
                                                                                            Match ipv4 icmp type
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                self.yang_name = "icmpv4-type"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "icmpv4-type"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "icmpv4-type"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                        class Icmpv4Code(Entity):
                                                                                            """
                                                                                            Match ipv4 icmp code
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                self.yang_name = "icmpv4-code"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "icmpv4-code"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "icmpv4-code"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                        class Icmpv6Type(Entity):
                                                                                            """
                                                                                            Match ipv6 icmp type
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                self.yang_name = "icmpv6-type"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "icmpv6-type"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "icmpv6-type"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                        class Icmpv6Code(Entity):
                                                                                            """
                                                                                            Match ipv6 icmp code
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                self.yang_name = "icmpv6-code"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "icmpv6-code"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "icmpv6-code"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                        class MplsExp(Entity):
                                                                                            """
                                                                                            Match MPLS experimental topmost array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                self.yang_name = "mpls-exp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "mpls-exp"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                        class MplsExpImp(Entity):
                                                                                            """
                                                                                            Match MPLS experimental imposition array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                self.yang_name = "mpls-exp-imp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "mpls-exp-imp"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                        class MplsDispIpv4Acl(Entity):
                                                                                            """
                                                                                            MPLS Disposition IPv4 Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "mpls-disp-ipv4-acl"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                        class MplsDispIpv6Acl(Entity):
                                                                                            """
                                                                                            MPLS Disposition IPv6 Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "mpls-disp-ipv6-acl"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                        class MplsTopLabel(Entity):
                                                                                            """
                                                                                            MPLS Topmost LABEL
                                                                                            
                                                                                            .. attribute:: uint32_rng_array
                                                                                            
                                                                                            	uint32 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                self.yang_name = "mpls-top-label"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint32_rng_array", ("uint32_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint32_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "mpls-top-label"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                            class Uint32RngArray(Entity):
                                                                                                """
                                                                                                uint32 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                    self.yang_name = "uint32_rng_array"
                                                                                                    self.yang_parent_name = "mpls-top-label"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint32, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint32, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint32_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['min', 'max'], name, value)


                                                                                        class Cos(Entity):
                                                                                            """
                                                                                            Match CoS array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                self.yang_name = "cos"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "cos"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                        class CosInr(Entity):
                                                                                            """
                                                                                            Match inner header CoS
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                self.yang_name = "cos-inr"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "cos-inr"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                        class Dei(Entity):
                                                                                            """
                                                                                            Match DEI Bit
                                                                                            
                                                                                            .. attribute:: bit_value
                                                                                            
                                                                                            	Value of the DEI bit
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                self.yang_name = "dei"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                ])
                                                                                                self.bit_value = None
                                                                                                self._segment_path = lambda: "dei"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                        class DeiInr(Entity):
                                                                                            """
                                                                                            Match inner DEI Bit
                                                                                            
                                                                                            .. attribute:: bit_value
                                                                                            
                                                                                            	Value of the DEI bit
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                self.yang_name = "dei-inr"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                ])
                                                                                                self.bit_value = None
                                                                                                self._segment_path = lambda: "dei-inr"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                        class Vlan(Entity):
                                                                                            """
                                                                                            Match VLAN array
                                                                                            
                                                                                            .. attribute:: vlan_id_array
                                                                                            
                                                                                            	vlan id array
                                                                                            	**type**\: list of  		 :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                self.yang_name = "vlan"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("vlan-id-array", ("vlan_id_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.vlan_id_array = YList(self)
                                                                                                self._segment_path = lambda: "vlan"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                            class VlanIdArray(Entity):
                                                                                                """
                                                                                                vlan id array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	VLAN mask
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                    self.yang_name = "vlan-id-array"
                                                                                                    self.yang_parent_name = "vlan"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ('mask', (YLeaf(YType.uint16, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self.mask = None
                                                                                                    self._segment_path = lambda: "vlan-id-array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['min', 'max', 'mask'], name, value)


                                                                                        class VlanInr(Entity):
                                                                                            """
                                                                                            Match inner header VLAN range array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                self.yang_name = "vlan-inr"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "vlan-inr"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "vlan-inr"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['min', 'max'], name, value)


                                                                                        class FrDlci(Entity):
                                                                                            """
                                                                                            Match FR DLCI range array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                self.yang_name = "fr-dlci"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "fr-dlci"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "fr-dlci"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['min', 'max'], name, value)


                                                                                        class SrcMac(Entity):
                                                                                            """
                                                                                            Match Source MAC address
                                                                                            
                                                                                            .. attribute:: mac_addr
                                                                                            
                                                                                            	MAC address
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	MAC mask
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                self.yang_name = "src-mac"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                    ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                ])
                                                                                                self.mac_addr = []
                                                                                                self.mask = []
                                                                                                self._segment_path = lambda: "src-mac"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                        class DstMac(Entity):
                                                                                            """
                                                                                            Match Destination MAC address
                                                                                            
                                                                                            .. attribute:: mac_addr
                                                                                            
                                                                                            	MAC address
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	MAC mask
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                self.yang_name = "dst-mac"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                    ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                ])
                                                                                                self.mac_addr = []
                                                                                                self.mask = []
                                                                                                self._segment_path = lambda: "dst-mac"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                        class AtmClp(Entity):
                                                                                            """
                                                                                            Match ATM CLP level
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                self.yang_name = "atm-clp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "atm-clp"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                        class FrDe(Entity):
                                                                                            """
                                                                                            Match FR DE value
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                self.yang_name = "fr-de"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "fr-de"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                        class Ipv4Acl(Entity):
                                                                                            """
                                                                                            IPv4 Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                self.yang_name = "ipv4-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "ipv4-acl"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                        class Ipv6Acl(Entity):
                                                                                            """
                                                                                            IPv6 Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                self.yang_name = "ipv6-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "ipv6-acl"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                        class EtherServiceAcl(Entity):
                                                                                            """
                                                                                            Ethernet\-Services Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                self.yang_name = "ether-service-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "ether-service-acl"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                        class AvailId(Entity):
                                                                                            """
                                                                                            Available Identifiers
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                self.yang_name = "avail-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "avail-id"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                        class MediaType(Entity):
                                                                                            """
                                                                                            Media Type
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                self.yang_name = "media-type"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "media-type"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                        class SubsProtocol(Entity):
                                                                                            """
                                                                                            Protocol
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                self.yang_name = "subs-protocol"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "subs-protocol"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                        class Dnis(Entity):
                                                                                            """
                                                                                            DNIS
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                self.yang_name = "dnis"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "dnis"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                        class DnisRegex(Entity):
                                                                                            """
                                                                                            DNIS Regular Expression
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                self.yang_name = "dnis-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "dnis-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                        class Domain(Entity):
                                                                                            """
                                                                                            Domain Name
                                                                                            
                                                                                            .. attribute:: domain_array
                                                                                            
                                                                                            	domain array
                                                                                            	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                self.yang_name = "domain"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.domain_array = YList(self)
                                                                                                self._segment_path = lambda: "domain"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                            class DomainArray(Entity):
                                                                                                """
                                                                                                domain array
                                                                                                
                                                                                                .. attribute:: domain_name
                                                                                                
                                                                                                	domain name
                                                                                                	**type**\: str
                                                                                                
                                                                                                .. attribute:: format_name
                                                                                                
                                                                                                	format name
                                                                                                	**type**\: str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                    self.yang_name = "domain-array"
                                                                                                    self.yang_parent_name = "domain"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                        ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                    ])
                                                                                                    self.domain_name = None
                                                                                                    self.format_name = None
                                                                                                    self._segment_path = lambda: "domain-array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                        class DomainRegex(Entity):
                                                                                            """
                                                                                            Domain Regular Expression
                                                                                            
                                                                                            .. attribute:: domain_array
                                                                                            
                                                                                            	domain array
                                                                                            	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                self.yang_name = "domain-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.domain_array = YList(self)
                                                                                                self._segment_path = lambda: "domain-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                            class DomainArray(Entity):
                                                                                                """
                                                                                                domain array
                                                                                                
                                                                                                .. attribute:: domain_name
                                                                                                
                                                                                                	domain name
                                                                                                	**type**\: str
                                                                                                
                                                                                                .. attribute:: format_name
                                                                                                
                                                                                                	format name
                                                                                                	**type**\: str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                    self.yang_name = "domain-array"
                                                                                                    self.yang_parent_name = "domain-regex"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                        ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                    ])
                                                                                                    self.domain_name = None
                                                                                                    self.format_name = None
                                                                                                    self._segment_path = lambda: "domain-array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                        class NasPort(Entity):
                                                                                            """
                                                                                            NAS Port
                                                                                            
                                                                                            .. attribute:: nas_port_array
                                                                                            
                                                                                            	nas port array
                                                                                            	**type**\: list of  		 :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                self.yang_name = "nas-port"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("nas-port-array", ("nas_port_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.nas_port_array = YList(self)
                                                                                                self._segment_path = lambda: "nas-port"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                            class NasPortArray(Entity):
                                                                                                """
                                                                                                nas port array
                                                                                                
                                                                                                .. attribute:: sub_id
                                                                                                
                                                                                                	sub id
                                                                                                	**type**\:  :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                
                                                                                                .. attribute:: operator
                                                                                                
                                                                                                	operator
                                                                                                	**type**\:  :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                
                                                                                                .. attribute:: value
                                                                                                
                                                                                                	value
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                    self.yang_name = "nas-port-array"
                                                                                                    self.yang_parent_name = "nas-port"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('sub_id', (YLeaf(YType.enumeration, 'sub-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchNasPortSubIdEn', '')])),
                                                                                                        ('operator', (YLeaf(YType.enumeration, 'operator'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchLogicalOperatorEn', '')])),
                                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                                    ])
                                                                                                    self.sub_id = None
                                                                                                    self.operator = None
                                                                                                    self.value = None
                                                                                                    self._segment_path = lambda: "nas-port-array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['sub_id', 'operator', 'value'], name, value)


                                                                                        class ServiceName(Entity):
                                                                                            """
                                                                                            Service Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                self.yang_name = "service-name"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "service-name"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                        class ServiceNameRegex(Entity):
                                                                                            """
                                                                                            Service Name Regular Exp
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                self.yang_name = "service-name-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "service-name-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                        class SrcAddrIpv4(Entity):
                                                                                            """
                                                                                            Source Address IPV4
                                                                                            
                                                                                            .. attribute:: ipv4_addr_array
                                                                                            
                                                                                            	ipv4 addr array
                                                                                            	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                self.yang_name = "src-addr-ipv4"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.ipv4_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "src-addr-ipv4"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                            class Ipv4AddrArray(Entity):
                                                                                                """
                                                                                                ipv4 addr array
                                                                                                
                                                                                                .. attribute:: prefix
                                                                                                
                                                                                                	prefix
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	mask
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                    self.yang_name = "ipv4-addr-array"
                                                                                                    self.yang_parent_name = "src-addr-ipv4"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                        ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                    ])
                                                                                                    self.prefix = None
                                                                                                    self.mask = None
                                                                                                    self._segment_path = lambda: "ipv4-addr-array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                        class DstAddrIpv4(Entity):
                                                                                            """
                                                                                            Destination Address IPV4
                                                                                            
                                                                                            .. attribute:: ipv4_addr_array
                                                                                            
                                                                                            	ipv4 addr array
                                                                                            	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                self.yang_name = "dst-addr-ipv4"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.ipv4_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "dst-addr-ipv4"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                            class Ipv4AddrArray(Entity):
                                                                                                """
                                                                                                ipv4 addr array
                                                                                                
                                                                                                .. attribute:: prefix
                                                                                                
                                                                                                	prefix
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	mask
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                    self.yang_name = "ipv4-addr-array"
                                                                                                    self.yang_parent_name = "dst-addr-ipv4"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                        ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                    ])
                                                                                                    self.prefix = None
                                                                                                    self.mask = None
                                                                                                    self._segment_path = lambda: "ipv4-addr-array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                        class SrcAddrIpv6(Entity):
                                                                                            """
                                                                                            Source Address IPV6
                                                                                            
                                                                                            .. attribute:: ipv6_addr_array
                                                                                            
                                                                                            	ipv6 addr array
                                                                                            	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                self.yang_name = "src-addr-ipv6"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.ipv6_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "src-addr-ipv6"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                            class Ipv6AddrArray(Entity):
                                                                                                """
                                                                                                ipv6 addr array
                                                                                                
                                                                                                .. attribute:: prefix
                                                                                                
                                                                                                	IPV6 prefix
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	IPV6 mask
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                    self.yang_name = "ipv6-addr-array"
                                                                                                    self.yang_parent_name = "src-addr-ipv6"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                        ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.prefix = None
                                                                                                    self.mask = None
                                                                                                    self._segment_path = lambda: "ipv6-addr-array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                        class DstAddrIpv6(Entity):
                                                                                            """
                                                                                            Destination Address IPV6
                                                                                            
                                                                                            .. attribute:: ipv6_addr_array
                                                                                            
                                                                                            	ipv6 addr array
                                                                                            	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                self.yang_name = "dst-addr-ipv6"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.ipv6_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "dst-addr-ipv6"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                            class Ipv6AddrArray(Entity):
                                                                                                """
                                                                                                ipv6 addr array
                                                                                                
                                                                                                .. attribute:: prefix
                                                                                                
                                                                                                	IPV6 prefix
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	IPV6 mask
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                    self.yang_name = "ipv6-addr-array"
                                                                                                    self.yang_parent_name = "dst-addr-ipv6"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                        ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.prefix = None
                                                                                                    self.mask = None
                                                                                                    self._segment_path = lambda: "ipv6-addr-array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                        class SrcAddrMac(Entity):
                                                                                            """
                                                                                            Source Address MAC
                                                                                            
                                                                                            .. attribute:: mac_addr_array
                                                                                            
                                                                                            	mac addr array
                                                                                            	**type**\: list of  		 :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                self.yang_name = "src-addr-mac"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("mac-addr-array", ("mac_addr_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.mac_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "src-addr-mac"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                            class MacAddrArray(Entity):
                                                                                                """
                                                                                                mac addr array
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                    self.yang_name = "mac-addr-array"
                                                                                                    self.yang_parent_name = "src-addr-mac"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.mac_addr = []
                                                                                                    self.mask = []
                                                                                                    self._segment_path = lambda: "mac-addr-array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                        class Timer(Entity):
                                                                                            """
                                                                                            Timer
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                self.yang_name = "timer"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "timer"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                        class TimerRegexp(Entity):
                                                                                            """
                                                                                            Timer Regular Expression
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                self.yang_name = "timer-regexp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "timer-regexp"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                        class TunnelName(Entity):
                                                                                            """
                                                                                            Tunnel Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                self.yang_name = "tunnel-name"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "tunnel-name"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                        class TunnelNameRegex(Entity):
                                                                                            """
                                                                                            Tunnel Name Regular Expression
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                self.yang_name = "tunnel-name-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "tunnel-name-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                        class UserName(Entity):
                                                                                            """
                                                                                            User Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                self.yang_name = "user-name"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "user-name"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                        class UserNameRegex(Entity):
                                                                                            """
                                                                                            User Name Regular Expression
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                self.yang_name = "user-name-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "user-name-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                        class AuthUsername(Entity):
                                                                                            """
                                                                                            Authenticated User Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                self.yang_name = "auth-username"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "auth-username"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                        class AuthUsernameRegex(Entity):
                                                                                            """
                                                                                            Authenticated User Name RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                self.yang_name = "auth-username-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "auth-username-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                        class UnauthUsername(Entity):
                                                                                            """
                                                                                            Unauthenticated User Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                self.yang_name = "unauth-username"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "unauth-username"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                        class UnauthUsernameRegex(Entity):
                                                                                            """
                                                                                            Unauthenticated User Name RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                self.yang_name = "unauth-username-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "unauth-username-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                        class AuthDomain(Entity):
                                                                                            """
                                                                                            Authenticated domain name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                self.yang_name = "auth-domain"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "auth-domain"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                        class AuthDomainRegex(Entity):
                                                                                            """
                                                                                            Authenticated Domain Name RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                self.yang_name = "auth-domain-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "auth-domain-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                        class UnauthDomain(Entity):
                                                                                            """
                                                                                            Unauthenticated Domain Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                self.yang_name = "unauth-domain"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "unauth-domain"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                        class UnauthDomainRegex(Entity):
                                                                                            """
                                                                                            Unauthenticated Domain Name RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                self.yang_name = "unauth-domain-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "unauth-domain-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                        class VendorId(Entity):
                                                                                            """
                                                                                            Vendor ID
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                self.yang_name = "vendor-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "vendor-id"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                        class VendorIdRegex(Entity):
                                                                                            """
                                                                                            Vendor ID RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                self.yang_name = "vendor-id-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "vendor-id-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                        class AccessInterface(Entity):
                                                                                            """
                                                                                            Access interface
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                self.yang_name = "access-interface"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "access-interface"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                        class InputInterface(Entity):
                                                                                            """
                                                                                            Input interface
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                self.yang_name = "input-interface"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "input-interface"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                        class InputIntfhdl(Entity):
                                                                                            """
                                                                                            Input interface handle
                                                                                            
                                                                                            .. attribute:: uint64_array
                                                                                            
                                                                                            	uint64 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..18446744073709551615
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                self.yang_name = "input-intfhdl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint64_array', (YLeafList(YType.uint64, 'uint64_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint64_array = []
                                                                                                self._segment_path = lambda: "input-intfhdl"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                        class Ethertype(Entity):
                                                                                            """
                                                                                            Ethernet type
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                self.yang_name = "ethertype"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ethertype"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "ethertype"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['min', 'max'], name, value)


                                                                                        class FlowKeyData(Entity):
                                                                                            """
                                                                                            Flow key structure
                                                                                            
                                                                                            .. attribute:: flow_keys
                                                                                            
                                                                                            	flow keys
                                                                                            	**type**\:  :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                            
                                                                                            .. attribute:: max_count
                                                                                            
                                                                                            	Maximum count of flows
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: idle_timeout
                                                                                            
                                                                                            	Idle timeout of flows (in seconds)
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            	**units**\: second
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                self.yang_name = "flow-key-data"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("flow-keys", ("flow_keys", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys))])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('max_count', (YLeaf(YType.uint16, 'max-count'), ['int'])),
                                                                                                    ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                                                ])
                                                                                                self.max_count = None
                                                                                                self.idle_timeout = None

                                                                                                self.flow_keys = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                self.flow_keys.parent = self
                                                                                                self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                self._segment_path = lambda: "flow-key-data"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['max_count', 'idle_timeout'], name, value)


                                                                                            class FlowKeys(Entity):
                                                                                                """
                                                                                                flow keys
                                                                                                
                                                                                                .. attribute:: keys
                                                                                                
                                                                                                	keys
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                
                                                                                                .. attribute:: num
                                                                                                
                                                                                                	num
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                    self.yang_name = "flow-keys"
                                                                                                    self.yang_parent_name = "flow-key-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('keys', (YLeaf(YType.str, 'keys'), ['str'])),
                                                                                                        ('num', (YLeaf(YType.uint8, 'num'), ['int'])),
                                                                                                    ])
                                                                                                    self.keys = None
                                                                                                    self.num = None
                                                                                                    self._segment_path = lambda: "flow-keys"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                        class DhcpClientId(Entity):
                                                                                            """
                                                                                            Dhcp Client ID
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                self.yang_name = "dhcp-client-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "dhcp-client-id"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                        class DhcpClientIdRegex(Entity):
                                                                                            """
                                                                                            Dhcp Client ID RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                self.yang_name = "dhcp-client-id-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "dhcp-client-id-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                        class CircuitId(Entity):
                                                                                            """
                                                                                            Circuit ID
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                self.yang_name = "circuit-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "circuit-id"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                        class CircuitIdRegex(Entity):
                                                                                            """
                                                                                            Circuit ID RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                self.yang_name = "circuit-id-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "circuit-id-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                        class RemoteId(Entity):
                                                                                            """
                                                                                            Remote ID
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                self.yang_name = "remote-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "remote-id"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                        class RemoteIdRegex(Entity):
                                                                                            """
                                                                                            Remote ID RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                self.yang_name = "remote-id-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "remote-id-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                        class SrcPort(Entity):
                                                                                            """
                                                                                            Source port
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                self.yang_name = "src-port"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "src-port"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "src-port"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                                        class DstPort(Entity):
                                                                                            """
                                                                                            Destination port
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                self.yang_name = "dst-port"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "dst-port"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "dst-port"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                    class ExcdclassEncode(Entity):
                                                                        """
                                                                        excdclass encode
                                                                        
                                                                        .. attribute:: inline_cmap
                                                                        
                                                                        	inline cmap
                                                                        	**type**\:  :py:class:`InlineCmap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap>`
                                                                        
                                                                        .. attribute:: enc
                                                                        
                                                                        	enc
                                                                        	**type**\:  :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                        
                                                                        .. attribute:: class_name
                                                                        
                                                                        	class name
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..65
                                                                        
                                                                        .. attribute:: hd
                                                                        
                                                                        	hd
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: idx
                                                                        
                                                                        	idx
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode, self).__init__()

                                                                            self.yang_name = "excdclass-encode"
                                                                            self.yang_parent_name = "police"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("inline-cmap", ("inline_cmap", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap))])
                                                                            self._leafs = OrderedDict([
                                                                                ('enc', (YLeaf(YType.enumeration, 'enc'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyObjEncEn', '')])),
                                                                                ('class_name', (YLeaf(YType.str, 'class-name'), ['str'])),
                                                                                ('hd', (YLeaf(YType.uint64, 'hd'), ['int'])),
                                                                                ('idx', (YLeaf(YType.uint8, 'idx'), ['int'])),
                                                                            ])
                                                                            self.enc = None
                                                                            self.class_name = None
                                                                            self.hd = None
                                                                            self.idx = None

                                                                            self.inline_cmap = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap()
                                                                            self.inline_cmap.parent = self
                                                                            self._children_name_map["inline_cmap"] = "inline-cmap"
                                                                            self._segment_path = lambda: "excdclass-encode"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode, ['enc', 'class_name', 'hd', 'idx'], name, value)


                                                                        class InlineCmap(Entity):
                                                                            """
                                                                            inline cmap
                                                                            
                                                                            .. attribute:: match_infop
                                                                            
                                                                            	Pointer to the first Match info
                                                                            	**type**\:  :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop>`
                                                                            
                                                                            .. attribute:: mode
                                                                            
                                                                            	Inline Class\-Map Mode Match any/all
                                                                            	**type**\:  :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                            
                                                                            .. attribute:: flags
                                                                            
                                                                            	Inline Class\-Map flags
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: match_count
                                                                            
                                                                            	Number of Match infos
                                                                            	**type**\: int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap, self).__init__()

                                                                                self.yang_name = "inline-cmap"
                                                                                self.yang_parent_name = "excdclass-encode"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("match-infop", ("match_infop", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapModeEn', '')])),
                                                                                    ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                    ('match_count', (YLeaf(YType.uint32, 'match-count'), ['int'])),
                                                                                ])
                                                                                self.mode = None
                                                                                self.flags = None
                                                                                self.match_count = None

                                                                                self.match_infop = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop()
                                                                                self.match_infop.parent = self
                                                                                self._children_name_map["match_infop"] = "match-infop"
                                                                                self._segment_path = lambda: "inline-cmap"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap, ['mode', 'flags', 'match_count'], name, value)


                                                                            class MatchInfop(Entity):
                                                                                """
                                                                                Pointer to the first Match info
                                                                                
                                                                                .. attribute:: class_match_info_st
                                                                                
                                                                                	class match info st
                                                                                	**type**\: list of  		 :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop, self).__init__()

                                                                                    self.yang_name = "match-infop"
                                                                                    self.yang_parent_name = "inline-cmap"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("class-match-info-st", ("class_match_info_st", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.class_match_info_st = YList(self)
                                                                                    self._segment_path = lambda: "match-infop"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop, [], name, value)


                                                                                class ClassMatchInfoSt(Entity):
                                                                                    """
                                                                                    class match info st
                                                                                    
                                                                                    .. attribute:: match_data
                                                                                    
                                                                                    	Match criteria
                                                                                    	**type**\:  :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                    
                                                                                    .. attribute:: flags
                                                                                    
                                                                                    	Flags
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                        self.yang_name = "class-match-info-st"
                                                                                        self.yang_parent_name = "match-infop"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("match-data", ("match_data", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData))])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                        ])
                                                                                        self.flags = None

                                                                                        self.match_data = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                        self.match_data.parent = self
                                                                                        self._children_name_map["match_data"] = "match-data"
                                                                                        self._segment_path = lambda: "class-match-info-st"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                    class MatchData(Entity):
                                                                                        """
                                                                                        Match criteria
                                                                                        
                                                                                        .. attribute:: ipv4_dscp
                                                                                        
                                                                                        	IPv4 DSCP
                                                                                        	**type**\:  :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                        
                                                                                        .. attribute:: ipv6_dscp
                                                                                        
                                                                                        	IPv6 DSCP
                                                                                        	**type**\:  :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                        
                                                                                        .. attribute:: dscp
                                                                                        
                                                                                        	Match DSCP range array
                                                                                        	**type**\:  :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                        
                                                                                        .. attribute:: ipv4_prec
                                                                                        
                                                                                        	IPv4 Precedence
                                                                                        	**type**\:  :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                        
                                                                                        .. attribute:: ipv6_prec
                                                                                        
                                                                                        	IPv6 Precedence
                                                                                        	**type**\:  :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                        
                                                                                        .. attribute:: prec
                                                                                        
                                                                                        	Match Precedence array
                                                                                        	**type**\:  :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                        
                                                                                        .. attribute:: discard_class
                                                                                        
                                                                                        	Match Discard Class array
                                                                                        	**type**\:  :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                        
                                                                                        .. attribute:: qos_group
                                                                                        
                                                                                        	Match QoS group array
                                                                                        	**type**\:  :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                        
                                                                                        .. attribute:: traffic_class
                                                                                        
                                                                                        	Match Traffic class array
                                                                                        	**type**\:  :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                        
                                                                                        .. attribute:: proto
                                                                                        
                                                                                        	Match Protocol array
                                                                                        	**type**\:  :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                        
                                                                                        .. attribute:: icmp_v4
                                                                                        
                                                                                        	Match ICMPV4 Protocol
                                                                                        	**type**\:  :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                        
                                                                                        .. attribute:: icmp_v6
                                                                                        
                                                                                        	Match ICMPV6 Protocol array
                                                                                        	**type**\:  :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                        
                                                                                        .. attribute:: ipv4_packet_len
                                                                                        
                                                                                        	IPv4 packet length array
                                                                                        	**type**\:  :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                        
                                                                                        .. attribute:: ipv6_packet_len
                                                                                        
                                                                                        	IPv6 packet length array
                                                                                        	**type**\:  :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                        
                                                                                        .. attribute:: packet_len
                                                                                        
                                                                                        	Match packet length array
                                                                                        	**type**\:  :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                        
                                                                                        .. attribute:: flow_tag
                                                                                        
                                                                                        	Match flow\-tag array
                                                                                        	**type**\:  :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                        
                                                                                        .. attribute:: tcp_flag
                                                                                        
                                                                                        	Match tcp flag value
                                                                                        	**type**\:  :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                        
                                                                                        .. attribute:: icmpv4_type
                                                                                        
                                                                                        	Match ipv4 icmp type
                                                                                        	**type**\:  :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                        
                                                                                        .. attribute:: icmpv4_code
                                                                                        
                                                                                        	Match ipv4 icmp code
                                                                                        	**type**\:  :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                        
                                                                                        .. attribute:: icmpv6_type
                                                                                        
                                                                                        	Match ipv6 icmp type
                                                                                        	**type**\:  :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                        
                                                                                        .. attribute:: icmpv6_code
                                                                                        
                                                                                        	Match ipv6 icmp code
                                                                                        	**type**\:  :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                        
                                                                                        .. attribute:: mpls_exp
                                                                                        
                                                                                        	Match MPLS experimental topmost array
                                                                                        	**type**\:  :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                        
                                                                                        .. attribute:: mpls_exp_imp
                                                                                        
                                                                                        	Match MPLS experimental imposition array
                                                                                        	**type**\:  :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                        
                                                                                        .. attribute:: mpls_disp_ipv4_acl
                                                                                        
                                                                                        	MPLS Disposition IPv4 Access\-list
                                                                                        	**type**\:  :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                        
                                                                                        .. attribute:: mpls_disp_ipv6_acl
                                                                                        
                                                                                        	MPLS Disposition IPv6 Access\-list
                                                                                        	**type**\:  :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                        
                                                                                        .. attribute:: mpls_top_label
                                                                                        
                                                                                        	MPLS Topmost LABEL
                                                                                        	**type**\:  :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                        
                                                                                        .. attribute:: cos
                                                                                        
                                                                                        	Match CoS array
                                                                                        	**type**\:  :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                        
                                                                                        .. attribute:: cos_inr
                                                                                        
                                                                                        	Match inner header CoS
                                                                                        	**type**\:  :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                        
                                                                                        .. attribute:: dei
                                                                                        
                                                                                        	Match DEI Bit
                                                                                        	**type**\:  :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                        
                                                                                        .. attribute:: dei_inr
                                                                                        
                                                                                        	Match inner DEI Bit
                                                                                        	**type**\:  :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                        
                                                                                        .. attribute:: vlan
                                                                                        
                                                                                        	Match VLAN array
                                                                                        	**type**\:  :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                        
                                                                                        .. attribute:: vlan_inr
                                                                                        
                                                                                        	Match inner header VLAN range array
                                                                                        	**type**\:  :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                        
                                                                                        .. attribute:: fr_dlci
                                                                                        
                                                                                        	Match FR DLCI range array
                                                                                        	**type**\:  :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                        
                                                                                        .. attribute:: src_mac
                                                                                        
                                                                                        	Match Source MAC address
                                                                                        	**type**\:  :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                        
                                                                                        .. attribute:: dst_mac
                                                                                        
                                                                                        	Match Destination MAC address
                                                                                        	**type**\:  :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                        
                                                                                        .. attribute:: atm_clp
                                                                                        
                                                                                        	Match ATM CLP level
                                                                                        	**type**\:  :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                        
                                                                                        .. attribute:: fr_de
                                                                                        
                                                                                        	Match FR DE value
                                                                                        	**type**\:  :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                        
                                                                                        .. attribute:: ipv4_acl
                                                                                        
                                                                                        	IPv4 Access\-list
                                                                                        	**type**\:  :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                        
                                                                                        .. attribute:: ipv6_acl
                                                                                        
                                                                                        	IPv6 Access\-list
                                                                                        	**type**\:  :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                        
                                                                                        .. attribute:: ether_service_acl
                                                                                        
                                                                                        	Ethernet\-Services Access\-list
                                                                                        	**type**\:  :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                        
                                                                                        .. attribute:: avail_id
                                                                                        
                                                                                        	Available Identifiers
                                                                                        	**type**\:  :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                        
                                                                                        .. attribute:: media_type
                                                                                        
                                                                                        	Media Type
                                                                                        	**type**\:  :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                        
                                                                                        .. attribute:: subs_protocol
                                                                                        
                                                                                        	Protocol
                                                                                        	**type**\:  :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                        
                                                                                        .. attribute:: dnis
                                                                                        
                                                                                        	DNIS
                                                                                        	**type**\:  :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                        
                                                                                        .. attribute:: dnis_regex
                                                                                        
                                                                                        	DNIS Regular Expression
                                                                                        	**type**\:  :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                        
                                                                                        .. attribute:: domain
                                                                                        
                                                                                        	Domain Name
                                                                                        	**type**\:  :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                        
                                                                                        .. attribute:: domain_regex
                                                                                        
                                                                                        	Domain Regular Expression
                                                                                        	**type**\:  :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                        
                                                                                        .. attribute:: nas_port
                                                                                        
                                                                                        	NAS Port
                                                                                        	**type**\:  :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                        
                                                                                        .. attribute:: service_name
                                                                                        
                                                                                        	Service Name
                                                                                        	**type**\:  :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                        
                                                                                        .. attribute:: service_name_regex
                                                                                        
                                                                                        	Service Name Regular Exp
                                                                                        	**type**\:  :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                        
                                                                                        .. attribute:: src_addr_ipv4
                                                                                        
                                                                                        	Source Address IPV4
                                                                                        	**type**\:  :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                        
                                                                                        .. attribute:: dst_addr_ipv4
                                                                                        
                                                                                        	Destination Address IPV4
                                                                                        	**type**\:  :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                        
                                                                                        .. attribute:: src_addr_ipv6
                                                                                        
                                                                                        	Source Address IPV6
                                                                                        	**type**\:  :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                        
                                                                                        .. attribute:: dst_addr_ipv6
                                                                                        
                                                                                        	Destination Address IPV6
                                                                                        	**type**\:  :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                        
                                                                                        .. attribute:: src_addr_mac
                                                                                        
                                                                                        	Source Address MAC
                                                                                        	**type**\:  :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                        
                                                                                        .. attribute:: timer
                                                                                        
                                                                                        	Timer
                                                                                        	**type**\:  :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                        
                                                                                        .. attribute:: timer_regexp
                                                                                        
                                                                                        	Timer Regular Expression
                                                                                        	**type**\:  :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                        
                                                                                        .. attribute:: tunnel_name
                                                                                        
                                                                                        	Tunnel Name
                                                                                        	**type**\:  :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                        
                                                                                        .. attribute:: tunnel_name_regex
                                                                                        
                                                                                        	Tunnel Name Regular Expression
                                                                                        	**type**\:  :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                        
                                                                                        .. attribute:: user_name
                                                                                        
                                                                                        	User Name
                                                                                        	**type**\:  :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                        
                                                                                        .. attribute:: user_name_regex
                                                                                        
                                                                                        	User Name Regular Expression
                                                                                        	**type**\:  :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                        
                                                                                        .. attribute:: auth_username
                                                                                        
                                                                                        	Authenticated User Name
                                                                                        	**type**\:  :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                        
                                                                                        .. attribute:: auth_username_regex
                                                                                        
                                                                                        	Authenticated User Name RegEx
                                                                                        	**type**\:  :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                        
                                                                                        .. attribute:: unauth_username
                                                                                        
                                                                                        	Unauthenticated User Name
                                                                                        	**type**\:  :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                        
                                                                                        .. attribute:: unauth_username_regex
                                                                                        
                                                                                        	Unauthenticated User Name RegEx
                                                                                        	**type**\:  :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                        
                                                                                        .. attribute:: auth_domain
                                                                                        
                                                                                        	Authenticated domain name
                                                                                        	**type**\:  :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                        
                                                                                        .. attribute:: auth_domain_regex
                                                                                        
                                                                                        	Authenticated Domain Name RegEx
                                                                                        	**type**\:  :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                        
                                                                                        .. attribute:: unauth_domain
                                                                                        
                                                                                        	Unauthenticated Domain Name
                                                                                        	**type**\:  :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                        
                                                                                        .. attribute:: unauth_domain_regex
                                                                                        
                                                                                        	Unauthenticated Domain Name RegEx
                                                                                        	**type**\:  :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                        
                                                                                        .. attribute:: vendor_id
                                                                                        
                                                                                        	Vendor ID
                                                                                        	**type**\:  :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                        
                                                                                        .. attribute:: vendor_id_regex
                                                                                        
                                                                                        	Vendor ID RegEx
                                                                                        	**type**\:  :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                        
                                                                                        .. attribute:: access_interface
                                                                                        
                                                                                        	Access interface
                                                                                        	**type**\:  :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                        
                                                                                        .. attribute:: input_interface
                                                                                        
                                                                                        	Input interface
                                                                                        	**type**\:  :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                        
                                                                                        .. attribute:: input_intfhdl
                                                                                        
                                                                                        	Input interface handle
                                                                                        	**type**\:  :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                        
                                                                                        .. attribute:: ethertype
                                                                                        
                                                                                        	Ethernet type
                                                                                        	**type**\:  :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                        
                                                                                        .. attribute:: flow_key_data
                                                                                        
                                                                                        	Flow key structure
                                                                                        	**type**\:  :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                        
                                                                                        .. attribute:: dhcp_client_id
                                                                                        
                                                                                        	Dhcp Client ID
                                                                                        	**type**\:  :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                        
                                                                                        .. attribute:: dhcp_client_id_regex
                                                                                        
                                                                                        	Dhcp Client ID RegEx
                                                                                        	**type**\:  :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                        
                                                                                        .. attribute:: circuit_id
                                                                                        
                                                                                        	Circuit ID
                                                                                        	**type**\:  :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                        
                                                                                        .. attribute:: circuit_id_regex
                                                                                        
                                                                                        	Circuit ID RegEx
                                                                                        	**type**\:  :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                        
                                                                                        .. attribute:: remote_id
                                                                                        
                                                                                        	Remote ID
                                                                                        	**type**\:  :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                        
                                                                                        .. attribute:: remote_id_regex
                                                                                        
                                                                                        	Remote ID RegEx
                                                                                        	**type**\:  :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                        
                                                                                        .. attribute:: src_port
                                                                                        
                                                                                        	Source port
                                                                                        	**type**\:  :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                        
                                                                                        .. attribute:: dst_port
                                                                                        
                                                                                        	Destination port
                                                                                        	**type**\:  :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                        
                                                                                        .. attribute:: type
                                                                                        
                                                                                        	type
                                                                                        	**type**\:  :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                        
                                                                                        .. attribute:: mpls_top_eos
                                                                                        
                                                                                        	MPLS Topmost EOS
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: fragment_type
                                                                                        
                                                                                        	Fragment type
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: authen_status
                                                                                        
                                                                                        	Authentication Status
                                                                                        	**type**\:  :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                        
                                                                                        .. attribute:: mlp_negotiated
                                                                                        
                                                                                        	MLP Negotiated
                                                                                        	**type**\:  :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                            self.yang_name = "match-data"
                                                                                            self.yang_parent_name = "class-match-info-st"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("ipv4-dscp", ("ipv4_dscp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp)), ("ipv6-dscp", ("ipv6_dscp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp)), ("dscp", ("dscp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp)), ("ipv4-prec", ("ipv4_prec", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec)), ("ipv6-prec", ("ipv6_prec", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec)), ("prec", ("prec", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec)), ("discard-class", ("discard_class", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass)), ("qos-group", ("qos_group", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup)), ("traffic-class", ("traffic_class", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass)), ("proto", ("proto", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto)), ("icmp-v4", ("icmp_v4", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4)), ("icmp-v6", ("icmp_v6", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6)), ("ipv4-packet-len", ("ipv4_packet_len", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen)), ("ipv6-packet-len", ("ipv6_packet_len", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen)), ("packet-len", ("packet_len", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen)), ("flow-tag", ("flow_tag", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag)), ("tcp-flag", ("tcp_flag", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag)), ("icmpv4-type", ("icmpv4_type", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type)), ("icmpv4-code", ("icmpv4_code", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code)), ("icmpv6-type", ("icmpv6_type", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type)), ("icmpv6-code", ("icmpv6_code", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code)), ("mpls-exp", ("mpls_exp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp)), ("mpls-exp-imp", ("mpls_exp_imp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp)), ("mpls-disp-ipv4-acl", ("mpls_disp_ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl)), ("mpls-disp-ipv6-acl", ("mpls_disp_ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl)), ("mpls-top-label", ("mpls_top_label", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel)), ("cos", ("cos", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos)), ("cos-inr", ("cos_inr", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr)), ("dei", ("dei", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei)), ("dei-inr", ("dei_inr", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr)), ("vlan", ("vlan", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan)), ("vlan-inr", ("vlan_inr", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)), ("fr-dlci", ("fr_dlci", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci)), ("src-mac", ("src_mac", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac)), ("dst-mac", ("dst_mac", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac)), ("atm-clp", ("atm_clp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp)), ("fr-de", ("fr_de", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe)), ("ipv4-acl", ("ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl)), ("ipv6-acl", ("ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl)), ("ether-service-acl", ("ether_service_acl", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl)), ("avail-id", ("avail_id", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId)), ("media-type", ("media_type", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType)), ("subs-protocol", ("subs_protocol", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol)), ("dnis", ("dnis", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis)), ("dnis-regex", ("dnis_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex)), ("domain", ("domain", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain)), ("domain-regex", ("domain_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex)), ("nas-port", ("nas_port", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort)), ("service-name", ("service_name", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName)), ("service-name-regex", ("service_name_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex)), ("src-addr-ipv4", ("src_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4)), ("dst-addr-ipv4", ("dst_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4)), ("src-addr-ipv6", ("src_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6)), ("dst-addr-ipv6", ("dst_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6)), ("src-addr-mac", ("src_addr_mac", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac)), ("timer", ("timer", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer)), ("timer-regexp", ("timer_regexp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp)), ("tunnel-name", ("tunnel_name", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName)), ("tunnel-name-regex", ("tunnel_name_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex)), ("user-name", ("user_name", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName)), ("user-name-regex", ("user_name_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex)), ("auth-username", ("auth_username", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername)), ("auth-username-regex", ("auth_username_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex)), ("unauth-username", ("unauth_username", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername)), ("unauth-username-regex", ("unauth_username_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex)), ("auth-domain", ("auth_domain", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain)), ("auth-domain-regex", ("auth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex)), ("unauth-domain", ("unauth_domain", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain)), ("unauth-domain-regex", ("unauth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex)), ("vendor-id", ("vendor_id", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId)), ("vendor-id-regex", ("vendor_id_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex)), ("access-interface", ("access_interface", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface)), ("input-interface", ("input_interface", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface)), ("input-intfhdl", ("input_intfhdl", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl)), ("ethertype", ("ethertype", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype)), ("flow-key-data", ("flow_key_data", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData)), ("dhcp-client-id", ("dhcp_client_id", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId)), ("dhcp-client-id-regex", ("dhcp_client_id_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex)), ("circuit-id", ("circuit_id", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId)), ("circuit-id-regex", ("circuit_id_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex)), ("remote-id", ("remote_id", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId)), ("remote-id-regex", ("remote_id_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex)), ("src-port", ("src_port", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort)), ("dst-port", ("dst_port", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort))])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchTypeEn', '')])),
                                                                                                ('mpls_top_eos', (YLeaf(YType.uint8, 'mpls-top-eos'), ['int'])),
                                                                                                ('fragment_type', (YLeaf(YType.uint8, 'fragment-type'), ['int'])),
                                                                                                ('authen_status', (YLeaf(YType.enumeration, 'authen-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchAuthenStatusEn', '')])),
                                                                                                ('mlp_negotiated', (YLeaf(YType.enumeration, 'mlp-negotiated'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchMlpNegotiatedEn', '')])),
                                                                                            ])
                                                                                            self.type = None
                                                                                            self.mpls_top_eos = None
                                                                                            self.fragment_type = None
                                                                                            self.authen_status = None
                                                                                            self.mlp_negotiated = None

                                                                                            self.ipv4_dscp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                            self.ipv4_dscp.parent = self
                                                                                            self._children_name_map["ipv4_dscp"] = "ipv4-dscp"

                                                                                            self.ipv6_dscp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                            self.ipv6_dscp.parent = self
                                                                                            self._children_name_map["ipv6_dscp"] = "ipv6-dscp"

                                                                                            self.dscp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                            self.dscp.parent = self
                                                                                            self._children_name_map["dscp"] = "dscp"

                                                                                            self.ipv4_prec = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                            self.ipv4_prec.parent = self
                                                                                            self._children_name_map["ipv4_prec"] = "ipv4-prec"

                                                                                            self.ipv6_prec = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                            self.ipv6_prec.parent = self
                                                                                            self._children_name_map["ipv6_prec"] = "ipv6-prec"

                                                                                            self.prec = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                            self.prec.parent = self
                                                                                            self._children_name_map["prec"] = "prec"

                                                                                            self.discard_class = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                            self.discard_class.parent = self
                                                                                            self._children_name_map["discard_class"] = "discard-class"

                                                                                            self.qos_group = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                            self.qos_group.parent = self
                                                                                            self._children_name_map["qos_group"] = "qos-group"

                                                                                            self.traffic_class = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                            self.traffic_class.parent = self
                                                                                            self._children_name_map["traffic_class"] = "traffic-class"

                                                                                            self.proto = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                            self.proto.parent = self
                                                                                            self._children_name_map["proto"] = "proto"

                                                                                            self.icmp_v4 = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                            self.icmp_v4.parent = self
                                                                                            self._children_name_map["icmp_v4"] = "icmp-v4"

                                                                                            self.icmp_v6 = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                            self.icmp_v6.parent = self
                                                                                            self._children_name_map["icmp_v6"] = "icmp-v6"

                                                                                            self.ipv4_packet_len = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                            self.ipv4_packet_len.parent = self
                                                                                            self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"

                                                                                            self.ipv6_packet_len = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                            self.ipv6_packet_len.parent = self
                                                                                            self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"

                                                                                            self.packet_len = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                            self.packet_len.parent = self
                                                                                            self._children_name_map["packet_len"] = "packet-len"

                                                                                            self.flow_tag = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                            self.flow_tag.parent = self
                                                                                            self._children_name_map["flow_tag"] = "flow-tag"

                                                                                            self.tcp_flag = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                            self.tcp_flag.parent = self
                                                                                            self._children_name_map["tcp_flag"] = "tcp-flag"

                                                                                            self.icmpv4_type = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                            self.icmpv4_type.parent = self
                                                                                            self._children_name_map["icmpv4_type"] = "icmpv4-type"

                                                                                            self.icmpv4_code = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                            self.icmpv4_code.parent = self
                                                                                            self._children_name_map["icmpv4_code"] = "icmpv4-code"

                                                                                            self.icmpv6_type = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                            self.icmpv6_type.parent = self
                                                                                            self._children_name_map["icmpv6_type"] = "icmpv6-type"

                                                                                            self.icmpv6_code = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                            self.icmpv6_code.parent = self
                                                                                            self._children_name_map["icmpv6_code"] = "icmpv6-code"

                                                                                            self.mpls_exp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                            self.mpls_exp.parent = self
                                                                                            self._children_name_map["mpls_exp"] = "mpls-exp"

                                                                                            self.mpls_exp_imp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                            self.mpls_exp_imp.parent = self
                                                                                            self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"

                                                                                            self.mpls_disp_ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                            self.mpls_disp_ipv4_acl.parent = self
                                                                                            self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"

                                                                                            self.mpls_disp_ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                            self.mpls_disp_ipv6_acl.parent = self
                                                                                            self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"

                                                                                            self.mpls_top_label = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                            self.mpls_top_label.parent = self
                                                                                            self._children_name_map["mpls_top_label"] = "mpls-top-label"

                                                                                            self.cos = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                            self.cos.parent = self
                                                                                            self._children_name_map["cos"] = "cos"

                                                                                            self.cos_inr = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                            self.cos_inr.parent = self
                                                                                            self._children_name_map["cos_inr"] = "cos-inr"

                                                                                            self.dei = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                            self.dei.parent = self
                                                                                            self._children_name_map["dei"] = "dei"

                                                                                            self.dei_inr = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                            self.dei_inr.parent = self
                                                                                            self._children_name_map["dei_inr"] = "dei-inr"

                                                                                            self.vlan = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                            self.vlan.parent = self
                                                                                            self._children_name_map["vlan"] = "vlan"

                                                                                            self.vlan_inr = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                            self.vlan_inr.parent = self
                                                                                            self._children_name_map["vlan_inr"] = "vlan-inr"

                                                                                            self.fr_dlci = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                            self.fr_dlci.parent = self
                                                                                            self._children_name_map["fr_dlci"] = "fr-dlci"

                                                                                            self.src_mac = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                            self.src_mac.parent = self
                                                                                            self._children_name_map["src_mac"] = "src-mac"

                                                                                            self.dst_mac = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                            self.dst_mac.parent = self
                                                                                            self._children_name_map["dst_mac"] = "dst-mac"

                                                                                            self.atm_clp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                            self.atm_clp.parent = self
                                                                                            self._children_name_map["atm_clp"] = "atm-clp"

                                                                                            self.fr_de = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                            self.fr_de.parent = self
                                                                                            self._children_name_map["fr_de"] = "fr-de"

                                                                                            self.ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                            self.ipv4_acl.parent = self
                                                                                            self._children_name_map["ipv4_acl"] = "ipv4-acl"

                                                                                            self.ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                            self.ipv6_acl.parent = self
                                                                                            self._children_name_map["ipv6_acl"] = "ipv6-acl"

                                                                                            self.ether_service_acl = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                            self.ether_service_acl.parent = self
                                                                                            self._children_name_map["ether_service_acl"] = "ether-service-acl"

                                                                                            self.avail_id = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                            self.avail_id.parent = self
                                                                                            self._children_name_map["avail_id"] = "avail-id"

                                                                                            self.media_type = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                            self.media_type.parent = self
                                                                                            self._children_name_map["media_type"] = "media-type"

                                                                                            self.subs_protocol = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                            self.subs_protocol.parent = self
                                                                                            self._children_name_map["subs_protocol"] = "subs-protocol"

                                                                                            self.dnis = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                            self.dnis.parent = self
                                                                                            self._children_name_map["dnis"] = "dnis"

                                                                                            self.dnis_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                            self.dnis_regex.parent = self
                                                                                            self._children_name_map["dnis_regex"] = "dnis-regex"

                                                                                            self.domain = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                            self.domain.parent = self
                                                                                            self._children_name_map["domain"] = "domain"

                                                                                            self.domain_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                            self.domain_regex.parent = self
                                                                                            self._children_name_map["domain_regex"] = "domain-regex"

                                                                                            self.nas_port = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                            self.nas_port.parent = self
                                                                                            self._children_name_map["nas_port"] = "nas-port"

                                                                                            self.service_name = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                            self.service_name.parent = self
                                                                                            self._children_name_map["service_name"] = "service-name"

                                                                                            self.service_name_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                            self.service_name_regex.parent = self
                                                                                            self._children_name_map["service_name_regex"] = "service-name-regex"

                                                                                            self.src_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                            self.src_addr_ipv4.parent = self
                                                                                            self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"

                                                                                            self.dst_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                            self.dst_addr_ipv4.parent = self
                                                                                            self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"

                                                                                            self.src_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                            self.src_addr_ipv6.parent = self
                                                                                            self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"

                                                                                            self.dst_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                            self.dst_addr_ipv6.parent = self
                                                                                            self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"

                                                                                            self.src_addr_mac = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                            self.src_addr_mac.parent = self
                                                                                            self._children_name_map["src_addr_mac"] = "src-addr-mac"

                                                                                            self.timer = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                            self.timer.parent = self
                                                                                            self._children_name_map["timer"] = "timer"

                                                                                            self.timer_regexp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                            self.timer_regexp.parent = self
                                                                                            self._children_name_map["timer_regexp"] = "timer-regexp"

                                                                                            self.tunnel_name = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                            self.tunnel_name.parent = self
                                                                                            self._children_name_map["tunnel_name"] = "tunnel-name"

                                                                                            self.tunnel_name_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                            self.tunnel_name_regex.parent = self
                                                                                            self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"

                                                                                            self.user_name = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                            self.user_name.parent = self
                                                                                            self._children_name_map["user_name"] = "user-name"

                                                                                            self.user_name_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                            self.user_name_regex.parent = self
                                                                                            self._children_name_map["user_name_regex"] = "user-name-regex"

                                                                                            self.auth_username = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                            self.auth_username.parent = self
                                                                                            self._children_name_map["auth_username"] = "auth-username"

                                                                                            self.auth_username_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                            self.auth_username_regex.parent = self
                                                                                            self._children_name_map["auth_username_regex"] = "auth-username-regex"

                                                                                            self.unauth_username = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                            self.unauth_username.parent = self
                                                                                            self._children_name_map["unauth_username"] = "unauth-username"

                                                                                            self.unauth_username_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                            self.unauth_username_regex.parent = self
                                                                                            self._children_name_map["unauth_username_regex"] = "unauth-username-regex"

                                                                                            self.auth_domain = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                            self.auth_domain.parent = self
                                                                                            self._children_name_map["auth_domain"] = "auth-domain"

                                                                                            self.auth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                            self.auth_domain_regex.parent = self
                                                                                            self._children_name_map["auth_domain_regex"] = "auth-domain-regex"

                                                                                            self.unauth_domain = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                            self.unauth_domain.parent = self
                                                                                            self._children_name_map["unauth_domain"] = "unauth-domain"

                                                                                            self.unauth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                            self.unauth_domain_regex.parent = self
                                                                                            self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"

                                                                                            self.vendor_id = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                            self.vendor_id.parent = self
                                                                                            self._children_name_map["vendor_id"] = "vendor-id"

                                                                                            self.vendor_id_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                            self.vendor_id_regex.parent = self
                                                                                            self._children_name_map["vendor_id_regex"] = "vendor-id-regex"

                                                                                            self.access_interface = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                            self.access_interface.parent = self
                                                                                            self._children_name_map["access_interface"] = "access-interface"

                                                                                            self.input_interface = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                            self.input_interface.parent = self
                                                                                            self._children_name_map["input_interface"] = "input-interface"

                                                                                            self.input_intfhdl = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                            self.input_intfhdl.parent = self
                                                                                            self._children_name_map["input_intfhdl"] = "input-intfhdl"

                                                                                            self.ethertype = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                            self.ethertype.parent = self
                                                                                            self._children_name_map["ethertype"] = "ethertype"

                                                                                            self.flow_key_data = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                            self.flow_key_data.parent = self
                                                                                            self._children_name_map["flow_key_data"] = "flow-key-data"

                                                                                            self.dhcp_client_id = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                            self.dhcp_client_id.parent = self
                                                                                            self._children_name_map["dhcp_client_id"] = "dhcp-client-id"

                                                                                            self.dhcp_client_id_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                            self.dhcp_client_id_regex.parent = self
                                                                                            self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"

                                                                                            self.circuit_id = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                            self.circuit_id.parent = self
                                                                                            self._children_name_map["circuit_id"] = "circuit-id"

                                                                                            self.circuit_id_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                            self.circuit_id_regex.parent = self
                                                                                            self._children_name_map["circuit_id_regex"] = "circuit-id-regex"

                                                                                            self.remote_id = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                            self.remote_id.parent = self
                                                                                            self._children_name_map["remote_id"] = "remote-id"

                                                                                            self.remote_id_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                            self.remote_id_regex.parent = self
                                                                                            self._children_name_map["remote_id_regex"] = "remote-id-regex"

                                                                                            self.src_port = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                            self.src_port.parent = self
                                                                                            self._children_name_map["src_port"] = "src-port"

                                                                                            self.dst_port = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                            self.dst_port.parent = self
                                                                                            self._children_name_map["dst_port"] = "dst-port"
                                                                                            self._segment_path = lambda: "match-data"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, ['type', 'mpls_top_eos', 'fragment_type', 'authen_status', 'mlp_negotiated'], name, value)


                                                                                        class Ipv4Dscp(Entity):
                                                                                            """
                                                                                            IPv4 DSCP
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                self.yang_name = "ipv4-dscp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ipv4-dscp"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "ipv4-dscp"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                        class Ipv6Dscp(Entity):
                                                                                            """
                                                                                            IPv6 DSCP
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                self.yang_name = "ipv6-dscp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ipv6-dscp"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "ipv6-dscp"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                        class Dscp(Entity):
                                                                                            """
                                                                                            Match DSCP range array
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                self.yang_name = "dscp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "dscp"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "dscp"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                        class Ipv4Prec(Entity):
                                                                                            """
                                                                                            IPv4 Precedence
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                self.yang_name = "ipv4-prec"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "ipv4-prec"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                        class Ipv6Prec(Entity):
                                                                                            """
                                                                                            IPv6 Precedence
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                self.yang_name = "ipv6-prec"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "ipv6-prec"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                        class Prec(Entity):
                                                                                            """
                                                                                            Match Precedence array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                self.yang_name = "prec"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "prec"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                        class DiscardClass(Entity):
                                                                                            """
                                                                                            Match Discard Class array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                self.yang_name = "discard-class"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "discard-class"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                        class QosGroup(Entity):
                                                                                            """
                                                                                            Match QoS group array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                self.yang_name = "qos-group"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "qos-group"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "qos-group"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['min', 'max'], name, value)


                                                                                        class TrafficClass(Entity):
                                                                                            """
                                                                                            Match Traffic class array
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                self.yang_name = "traffic-class"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "traffic-class"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "traffic-class"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['min', 'max'], name, value)


                                                                                        class Proto(Entity):
                                                                                            """
                                                                                            Match Protocol array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                self.yang_name = "proto"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "proto"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "proto"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['min', 'max'], name, value)


                                                                                        class IcmpV4(Entity):
                                                                                            """
                                                                                            Match ICMPV4 Protocol
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	Protocol type
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: code
                                                                                            
                                                                                            	Protocol code
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                self.yang_name = "icmp-v4"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                    ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                ])
                                                                                                self.type = None
                                                                                                self.code = None
                                                                                                self._segment_path = lambda: "icmp-v4"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['type', 'code'], name, value)


                                                                                        class IcmpV6(Entity):
                                                                                            """
                                                                                            Match ICMPV6 Protocol array
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	Protocol type
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: code
                                                                                            
                                                                                            	Protocol code
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                self.yang_name = "icmp-v6"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                    ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                ])
                                                                                                self.type = None
                                                                                                self.code = None
                                                                                                self._segment_path = lambda: "icmp-v6"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['type', 'code'], name, value)


                                                                                        class Ipv4PacketLen(Entity):
                                                                                            """
                                                                                            IPv4 packet length array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                self.yang_name = "ipv4-packet-len"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ipv4-packet-len"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "ipv4-packet-len"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                        class Ipv6PacketLen(Entity):
                                                                                            """
                                                                                            IPv6 packet length array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                self.yang_name = "ipv6-packet-len"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ipv6-packet-len"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "ipv6-packet-len"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                        class PacketLen(Entity):
                                                                                            """
                                                                                            Match packet length array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                self.yang_name = "packet-len"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "packet-len"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "packet-len"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                        class FlowTag(Entity):
                                                                                            """
                                                                                            Match flow\-tag array
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                self.yang_name = "flow-tag"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "flow-tag"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "flow-tag"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['min', 'max'], name, value)


                                                                                        class TcpFlag(Entity):
                                                                                            """
                                                                                            Match tcp flag value
                                                                                            
                                                                                            .. attribute:: value
                                                                                            
                                                                                            	Value of TCP flag
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: match_any
                                                                                            
                                                                                            	Match any TCP flag bit
                                                                                            	**type**\: bool
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                self.yang_name = "tcp-flag"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                                    ('match_any', (YLeaf(YType.boolean, 'match-any'), ['bool'])),
                                                                                                ])
                                                                                                self.value = None
                                                                                                self.match_any = None
                                                                                                self._segment_path = lambda: "tcp-flag"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['value', 'match_any'], name, value)


                                                                                        class Icmpv4Type(Entity):
                                                                                            """
                                                                                            Match ipv4 icmp type
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                self.yang_name = "icmpv4-type"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "icmpv4-type"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "icmpv4-type"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                        class Icmpv4Code(Entity):
                                                                                            """
                                                                                            Match ipv4 icmp code
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                self.yang_name = "icmpv4-code"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "icmpv4-code"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "icmpv4-code"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                        class Icmpv6Type(Entity):
                                                                                            """
                                                                                            Match ipv6 icmp type
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                self.yang_name = "icmpv6-type"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "icmpv6-type"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "icmpv6-type"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                        class Icmpv6Code(Entity):
                                                                                            """
                                                                                            Match ipv6 icmp code
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                self.yang_name = "icmpv6-code"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "icmpv6-code"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "icmpv6-code"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                        class MplsExp(Entity):
                                                                                            """
                                                                                            Match MPLS experimental topmost array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                self.yang_name = "mpls-exp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "mpls-exp"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                        class MplsExpImp(Entity):
                                                                                            """
                                                                                            Match MPLS experimental imposition array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                self.yang_name = "mpls-exp-imp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "mpls-exp-imp"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                        class MplsDispIpv4Acl(Entity):
                                                                                            """
                                                                                            MPLS Disposition IPv4 Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "mpls-disp-ipv4-acl"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                        class MplsDispIpv6Acl(Entity):
                                                                                            """
                                                                                            MPLS Disposition IPv6 Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "mpls-disp-ipv6-acl"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                        class MplsTopLabel(Entity):
                                                                                            """
                                                                                            MPLS Topmost LABEL
                                                                                            
                                                                                            .. attribute:: uint32_rng_array
                                                                                            
                                                                                            	uint32 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                self.yang_name = "mpls-top-label"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint32_rng_array", ("uint32_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint32_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "mpls-top-label"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                            class Uint32RngArray(Entity):
                                                                                                """
                                                                                                uint32 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                    self.yang_name = "uint32_rng_array"
                                                                                                    self.yang_parent_name = "mpls-top-label"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint32, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint32, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint32_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['min', 'max'], name, value)


                                                                                        class Cos(Entity):
                                                                                            """
                                                                                            Match CoS array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                self.yang_name = "cos"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "cos"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                        class CosInr(Entity):
                                                                                            """
                                                                                            Match inner header CoS
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                self.yang_name = "cos-inr"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "cos-inr"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                        class Dei(Entity):
                                                                                            """
                                                                                            Match DEI Bit
                                                                                            
                                                                                            .. attribute:: bit_value
                                                                                            
                                                                                            	Value of the DEI bit
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                self.yang_name = "dei"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                ])
                                                                                                self.bit_value = None
                                                                                                self._segment_path = lambda: "dei"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                        class DeiInr(Entity):
                                                                                            """
                                                                                            Match inner DEI Bit
                                                                                            
                                                                                            .. attribute:: bit_value
                                                                                            
                                                                                            	Value of the DEI bit
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                self.yang_name = "dei-inr"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                ])
                                                                                                self.bit_value = None
                                                                                                self._segment_path = lambda: "dei-inr"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                        class Vlan(Entity):
                                                                                            """
                                                                                            Match VLAN array
                                                                                            
                                                                                            .. attribute:: vlan_id_array
                                                                                            
                                                                                            	vlan id array
                                                                                            	**type**\: list of  		 :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                self.yang_name = "vlan"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("vlan-id-array", ("vlan_id_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.vlan_id_array = YList(self)
                                                                                                self._segment_path = lambda: "vlan"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                            class VlanIdArray(Entity):
                                                                                                """
                                                                                                vlan id array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	VLAN mask
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                    self.yang_name = "vlan-id-array"
                                                                                                    self.yang_parent_name = "vlan"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ('mask', (YLeaf(YType.uint16, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self.mask = None
                                                                                                    self._segment_path = lambda: "vlan-id-array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['min', 'max', 'mask'], name, value)


                                                                                        class VlanInr(Entity):
                                                                                            """
                                                                                            Match inner header VLAN range array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                self.yang_name = "vlan-inr"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "vlan-inr"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "vlan-inr"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['min', 'max'], name, value)


                                                                                        class FrDlci(Entity):
                                                                                            """
                                                                                            Match FR DLCI range array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                self.yang_name = "fr-dlci"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "fr-dlci"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "fr-dlci"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['min', 'max'], name, value)


                                                                                        class SrcMac(Entity):
                                                                                            """
                                                                                            Match Source MAC address
                                                                                            
                                                                                            .. attribute:: mac_addr
                                                                                            
                                                                                            	MAC address
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	MAC mask
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                self.yang_name = "src-mac"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                    ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                ])
                                                                                                self.mac_addr = []
                                                                                                self.mask = []
                                                                                                self._segment_path = lambda: "src-mac"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                        class DstMac(Entity):
                                                                                            """
                                                                                            Match Destination MAC address
                                                                                            
                                                                                            .. attribute:: mac_addr
                                                                                            
                                                                                            	MAC address
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	MAC mask
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                self.yang_name = "dst-mac"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                    ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                ])
                                                                                                self.mac_addr = []
                                                                                                self.mask = []
                                                                                                self._segment_path = lambda: "dst-mac"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                        class AtmClp(Entity):
                                                                                            """
                                                                                            Match ATM CLP level
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                self.yang_name = "atm-clp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "atm-clp"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                        class FrDe(Entity):
                                                                                            """
                                                                                            Match FR DE value
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                self.yang_name = "fr-de"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "fr-de"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                        class Ipv4Acl(Entity):
                                                                                            """
                                                                                            IPv4 Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                self.yang_name = "ipv4-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "ipv4-acl"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                        class Ipv6Acl(Entity):
                                                                                            """
                                                                                            IPv6 Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                self.yang_name = "ipv6-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "ipv6-acl"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                        class EtherServiceAcl(Entity):
                                                                                            """
                                                                                            Ethernet\-Services Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                self.yang_name = "ether-service-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "ether-service-acl"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                        class AvailId(Entity):
                                                                                            """
                                                                                            Available Identifiers
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                self.yang_name = "avail-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "avail-id"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                        class MediaType(Entity):
                                                                                            """
                                                                                            Media Type
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                self.yang_name = "media-type"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "media-type"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                        class SubsProtocol(Entity):
                                                                                            """
                                                                                            Protocol
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                self.yang_name = "subs-protocol"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "subs-protocol"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                        class Dnis(Entity):
                                                                                            """
                                                                                            DNIS
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                self.yang_name = "dnis"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "dnis"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                        class DnisRegex(Entity):
                                                                                            """
                                                                                            DNIS Regular Expression
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                self.yang_name = "dnis-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "dnis-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                        class Domain(Entity):
                                                                                            """
                                                                                            Domain Name
                                                                                            
                                                                                            .. attribute:: domain_array
                                                                                            
                                                                                            	domain array
                                                                                            	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                self.yang_name = "domain"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.domain_array = YList(self)
                                                                                                self._segment_path = lambda: "domain"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                            class DomainArray(Entity):
                                                                                                """
                                                                                                domain array
                                                                                                
                                                                                                .. attribute:: domain_name
                                                                                                
                                                                                                	domain name
                                                                                                	**type**\: str
                                                                                                
                                                                                                .. attribute:: format_name
                                                                                                
                                                                                                	format name
                                                                                                	**type**\: str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                    self.yang_name = "domain-array"
                                                                                                    self.yang_parent_name = "domain"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                        ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                    ])
                                                                                                    self.domain_name = None
                                                                                                    self.format_name = None
                                                                                                    self._segment_path = lambda: "domain-array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                        class DomainRegex(Entity):
                                                                                            """
                                                                                            Domain Regular Expression
                                                                                            
                                                                                            .. attribute:: domain_array
                                                                                            
                                                                                            	domain array
                                                                                            	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                self.yang_name = "domain-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.domain_array = YList(self)
                                                                                                self._segment_path = lambda: "domain-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                            class DomainArray(Entity):
                                                                                                """
                                                                                                domain array
                                                                                                
                                                                                                .. attribute:: domain_name
                                                                                                
                                                                                                	domain name
                                                                                                	**type**\: str
                                                                                                
                                                                                                .. attribute:: format_name
                                                                                                
                                                                                                	format name
                                                                                                	**type**\: str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                    self.yang_name = "domain-array"
                                                                                                    self.yang_parent_name = "domain-regex"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                        ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                    ])
                                                                                                    self.domain_name = None
                                                                                                    self.format_name = None
                                                                                                    self._segment_path = lambda: "domain-array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                        class NasPort(Entity):
                                                                                            """
                                                                                            NAS Port
                                                                                            
                                                                                            .. attribute:: nas_port_array
                                                                                            
                                                                                            	nas port array
                                                                                            	**type**\: list of  		 :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                self.yang_name = "nas-port"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("nas-port-array", ("nas_port_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.nas_port_array = YList(self)
                                                                                                self._segment_path = lambda: "nas-port"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                            class NasPortArray(Entity):
                                                                                                """
                                                                                                nas port array
                                                                                                
                                                                                                .. attribute:: sub_id
                                                                                                
                                                                                                	sub id
                                                                                                	**type**\:  :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                
                                                                                                .. attribute:: operator
                                                                                                
                                                                                                	operator
                                                                                                	**type**\:  :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                
                                                                                                .. attribute:: value
                                                                                                
                                                                                                	value
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                    self.yang_name = "nas-port-array"
                                                                                                    self.yang_parent_name = "nas-port"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('sub_id', (YLeaf(YType.enumeration, 'sub-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchNasPortSubIdEn', '')])),
                                                                                                        ('operator', (YLeaf(YType.enumeration, 'operator'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchLogicalOperatorEn', '')])),
                                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                                    ])
                                                                                                    self.sub_id = None
                                                                                                    self.operator = None
                                                                                                    self.value = None
                                                                                                    self._segment_path = lambda: "nas-port-array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['sub_id', 'operator', 'value'], name, value)


                                                                                        class ServiceName(Entity):
                                                                                            """
                                                                                            Service Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                self.yang_name = "service-name"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "service-name"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                        class ServiceNameRegex(Entity):
                                                                                            """
                                                                                            Service Name Regular Exp
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                self.yang_name = "service-name-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "service-name-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                        class SrcAddrIpv4(Entity):
                                                                                            """
                                                                                            Source Address IPV4
                                                                                            
                                                                                            .. attribute:: ipv4_addr_array
                                                                                            
                                                                                            	ipv4 addr array
                                                                                            	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                self.yang_name = "src-addr-ipv4"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.ipv4_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "src-addr-ipv4"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                            class Ipv4AddrArray(Entity):
                                                                                                """
                                                                                                ipv4 addr array
                                                                                                
                                                                                                .. attribute:: prefix
                                                                                                
                                                                                                	prefix
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	mask
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                    self.yang_name = "ipv4-addr-array"
                                                                                                    self.yang_parent_name = "src-addr-ipv4"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                        ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                    ])
                                                                                                    self.prefix = None
                                                                                                    self.mask = None
                                                                                                    self._segment_path = lambda: "ipv4-addr-array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                        class DstAddrIpv4(Entity):
                                                                                            """
                                                                                            Destination Address IPV4
                                                                                            
                                                                                            .. attribute:: ipv4_addr_array
                                                                                            
                                                                                            	ipv4 addr array
                                                                                            	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                self.yang_name = "dst-addr-ipv4"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.ipv4_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "dst-addr-ipv4"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                            class Ipv4AddrArray(Entity):
                                                                                                """
                                                                                                ipv4 addr array
                                                                                                
                                                                                                .. attribute:: prefix
                                                                                                
                                                                                                	prefix
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	mask
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                    self.yang_name = "ipv4-addr-array"
                                                                                                    self.yang_parent_name = "dst-addr-ipv4"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                        ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                    ])
                                                                                                    self.prefix = None
                                                                                                    self.mask = None
                                                                                                    self._segment_path = lambda: "ipv4-addr-array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                        class SrcAddrIpv6(Entity):
                                                                                            """
                                                                                            Source Address IPV6
                                                                                            
                                                                                            .. attribute:: ipv6_addr_array
                                                                                            
                                                                                            	ipv6 addr array
                                                                                            	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                self.yang_name = "src-addr-ipv6"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.ipv6_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "src-addr-ipv6"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                            class Ipv6AddrArray(Entity):
                                                                                                """
                                                                                                ipv6 addr array
                                                                                                
                                                                                                .. attribute:: prefix
                                                                                                
                                                                                                	IPV6 prefix
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	IPV6 mask
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                    self.yang_name = "ipv6-addr-array"
                                                                                                    self.yang_parent_name = "src-addr-ipv6"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                        ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.prefix = None
                                                                                                    self.mask = None
                                                                                                    self._segment_path = lambda: "ipv6-addr-array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                        class DstAddrIpv6(Entity):
                                                                                            """
                                                                                            Destination Address IPV6
                                                                                            
                                                                                            .. attribute:: ipv6_addr_array
                                                                                            
                                                                                            	ipv6 addr array
                                                                                            	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                self.yang_name = "dst-addr-ipv6"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.ipv6_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "dst-addr-ipv6"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                            class Ipv6AddrArray(Entity):
                                                                                                """
                                                                                                ipv6 addr array
                                                                                                
                                                                                                .. attribute:: prefix
                                                                                                
                                                                                                	IPV6 prefix
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	IPV6 mask
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                    self.yang_name = "ipv6-addr-array"
                                                                                                    self.yang_parent_name = "dst-addr-ipv6"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                        ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.prefix = None
                                                                                                    self.mask = None
                                                                                                    self._segment_path = lambda: "ipv6-addr-array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                        class SrcAddrMac(Entity):
                                                                                            """
                                                                                            Source Address MAC
                                                                                            
                                                                                            .. attribute:: mac_addr_array
                                                                                            
                                                                                            	mac addr array
                                                                                            	**type**\: list of  		 :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                self.yang_name = "src-addr-mac"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("mac-addr-array", ("mac_addr_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.mac_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "src-addr-mac"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                            class MacAddrArray(Entity):
                                                                                                """
                                                                                                mac addr array
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                    self.yang_name = "mac-addr-array"
                                                                                                    self.yang_parent_name = "src-addr-mac"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.mac_addr = []
                                                                                                    self.mask = []
                                                                                                    self._segment_path = lambda: "mac-addr-array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                        class Timer(Entity):
                                                                                            """
                                                                                            Timer
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                self.yang_name = "timer"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "timer"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                        class TimerRegexp(Entity):
                                                                                            """
                                                                                            Timer Regular Expression
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                self.yang_name = "timer-regexp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "timer-regexp"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                        class TunnelName(Entity):
                                                                                            """
                                                                                            Tunnel Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                self.yang_name = "tunnel-name"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "tunnel-name"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                        class TunnelNameRegex(Entity):
                                                                                            """
                                                                                            Tunnel Name Regular Expression
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                self.yang_name = "tunnel-name-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "tunnel-name-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                        class UserName(Entity):
                                                                                            """
                                                                                            User Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                self.yang_name = "user-name"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "user-name"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                        class UserNameRegex(Entity):
                                                                                            """
                                                                                            User Name Regular Expression
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                self.yang_name = "user-name-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "user-name-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                        class AuthUsername(Entity):
                                                                                            """
                                                                                            Authenticated User Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                self.yang_name = "auth-username"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "auth-username"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                        class AuthUsernameRegex(Entity):
                                                                                            """
                                                                                            Authenticated User Name RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                self.yang_name = "auth-username-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "auth-username-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                        class UnauthUsername(Entity):
                                                                                            """
                                                                                            Unauthenticated User Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                self.yang_name = "unauth-username"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "unauth-username"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                        class UnauthUsernameRegex(Entity):
                                                                                            """
                                                                                            Unauthenticated User Name RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                self.yang_name = "unauth-username-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "unauth-username-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                        class AuthDomain(Entity):
                                                                                            """
                                                                                            Authenticated domain name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                self.yang_name = "auth-domain"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "auth-domain"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                        class AuthDomainRegex(Entity):
                                                                                            """
                                                                                            Authenticated Domain Name RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                self.yang_name = "auth-domain-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "auth-domain-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                        class UnauthDomain(Entity):
                                                                                            """
                                                                                            Unauthenticated Domain Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                self.yang_name = "unauth-domain"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "unauth-domain"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                        class UnauthDomainRegex(Entity):
                                                                                            """
                                                                                            Unauthenticated Domain Name RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                self.yang_name = "unauth-domain-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "unauth-domain-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                        class VendorId(Entity):
                                                                                            """
                                                                                            Vendor ID
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                self.yang_name = "vendor-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "vendor-id"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                        class VendorIdRegex(Entity):
                                                                                            """
                                                                                            Vendor ID RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                self.yang_name = "vendor-id-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "vendor-id-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                        class AccessInterface(Entity):
                                                                                            """
                                                                                            Access interface
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                self.yang_name = "access-interface"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "access-interface"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                        class InputInterface(Entity):
                                                                                            """
                                                                                            Input interface
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                self.yang_name = "input-interface"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "input-interface"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                        class InputIntfhdl(Entity):
                                                                                            """
                                                                                            Input interface handle
                                                                                            
                                                                                            .. attribute:: uint64_array
                                                                                            
                                                                                            	uint64 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..18446744073709551615
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                self.yang_name = "input-intfhdl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint64_array', (YLeafList(YType.uint64, 'uint64_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint64_array = []
                                                                                                self._segment_path = lambda: "input-intfhdl"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                        class Ethertype(Entity):
                                                                                            """
                                                                                            Ethernet type
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                self.yang_name = "ethertype"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ethertype"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "ethertype"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['min', 'max'], name, value)


                                                                                        class FlowKeyData(Entity):
                                                                                            """
                                                                                            Flow key structure
                                                                                            
                                                                                            .. attribute:: flow_keys
                                                                                            
                                                                                            	flow keys
                                                                                            	**type**\:  :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                            
                                                                                            .. attribute:: max_count
                                                                                            
                                                                                            	Maximum count of flows
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: idle_timeout
                                                                                            
                                                                                            	Idle timeout of flows (in seconds)
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            	**units**\: second
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                self.yang_name = "flow-key-data"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("flow-keys", ("flow_keys", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys))])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('max_count', (YLeaf(YType.uint16, 'max-count'), ['int'])),
                                                                                                    ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                                                ])
                                                                                                self.max_count = None
                                                                                                self.idle_timeout = None

                                                                                                self.flow_keys = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                self.flow_keys.parent = self
                                                                                                self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                self._segment_path = lambda: "flow-key-data"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['max_count', 'idle_timeout'], name, value)


                                                                                            class FlowKeys(Entity):
                                                                                                """
                                                                                                flow keys
                                                                                                
                                                                                                .. attribute:: keys
                                                                                                
                                                                                                	keys
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                
                                                                                                .. attribute:: num
                                                                                                
                                                                                                	num
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                    self.yang_name = "flow-keys"
                                                                                                    self.yang_parent_name = "flow-key-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('keys', (YLeaf(YType.str, 'keys'), ['str'])),
                                                                                                        ('num', (YLeaf(YType.uint8, 'num'), ['int'])),
                                                                                                    ])
                                                                                                    self.keys = None
                                                                                                    self.num = None
                                                                                                    self._segment_path = lambda: "flow-keys"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                        class DhcpClientId(Entity):
                                                                                            """
                                                                                            Dhcp Client ID
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                self.yang_name = "dhcp-client-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "dhcp-client-id"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                        class DhcpClientIdRegex(Entity):
                                                                                            """
                                                                                            Dhcp Client ID RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                self.yang_name = "dhcp-client-id-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "dhcp-client-id-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                        class CircuitId(Entity):
                                                                                            """
                                                                                            Circuit ID
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                self.yang_name = "circuit-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "circuit-id"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                        class CircuitIdRegex(Entity):
                                                                                            """
                                                                                            Circuit ID RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                self.yang_name = "circuit-id-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "circuit-id-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                        class RemoteId(Entity):
                                                                                            """
                                                                                            Remote ID
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                self.yang_name = "remote-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "remote-id"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                        class RemoteIdRegex(Entity):
                                                                                            """
                                                                                            Remote ID RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                self.yang_name = "remote-id-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "remote-id-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                        class SrcPort(Entity):
                                                                                            """
                                                                                            Source port
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                self.yang_name = "src-port"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "src-port"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "src-port"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                                        class DstPort(Entity):
                                                                                            """
                                                                                            Destination port
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                self.yang_name = "dst-port"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "dst-port"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "dst-port"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                    class ExcdclassP(Entity):
                                                                        """
                                                                        excdclass p
                                                                        
                                                                        .. attribute:: class_map_bg
                                                                        
                                                                        	class map bg
                                                                        	**type**\: list of  		 :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP, self).__init__()

                                                                            self.yang_name = "excdclass-p"
                                                                            self.yang_parent_name = "police"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("class-map-bg", ("class_map_bg", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg))])
                                                                            self._leafs = OrderedDict()

                                                                            self.class_map_bg = YList(self)
                                                                            self._segment_path = lambda: "excdclass-p"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP, [], name, value)


                                                                        class ClassMapBg(Entity):
                                                                            """
                                                                            class map bg
                                                                            
                                                                            .. attribute:: match_infop
                                                                            
                                                                            	Pointer to the first Match info
                                                                            	**type**\:  :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop>`
                                                                            
                                                                            .. attribute:: name
                                                                            
                                                                            	Name of the class\-map
                                                                            	**type**\: str
                                                                            
                                                                            	**length:** 0..65
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	Class\-Map Type QoS/PBR/Netflow/..
                                                                            	**type**\:  :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                                            
                                                                            .. attribute:: mode
                                                                            
                                                                            	Class\-Map Mode Match any/Match all
                                                                            	**type**\:  :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                            
                                                                            .. attribute:: description
                                                                            
                                                                            	description
                                                                            	**type**\: str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg, self).__init__()

                                                                                self.yang_name = "class-map-bg"
                                                                                self.yang_parent_name = "excdclass-p"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([("match-infop", ("match_infop", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop))])
                                                                                self._leafs = OrderedDict([
                                                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapTypeEn', '')])),
                                                                                    ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'ClassMapModeEn', '')])),
                                                                                    ('description', (YLeaf(YType.str, 'description'), ['str'])),
                                                                                ])
                                                                                self.name = None
                                                                                self.type = None
                                                                                self.mode = None
                                                                                self.description = None

                                                                                self.match_infop = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop()
                                                                                self.match_infop.parent = self
                                                                                self._children_name_map["match_infop"] = "match-infop"
                                                                                self._segment_path = lambda: "class-map-bg"
                                                                                self._is_frozen = True

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg, ['name', 'type', 'mode', 'description'], name, value)


                                                                            class MatchInfop(Entity):
                                                                                """
                                                                                Pointer to the first Match info
                                                                                
                                                                                .. attribute:: class_match_info_st
                                                                                
                                                                                	class match info st
                                                                                	**type**\: list of  		 :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2018-01-17'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop, self).__init__()

                                                                                    self.yang_name = "match-infop"
                                                                                    self.yang_parent_name = "class-map-bg"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self.ylist_key_names = []
                                                                                    self._child_classes = OrderedDict([("class-match-info-st", ("class_match_info_st", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt))])
                                                                                    self._leafs = OrderedDict()

                                                                                    self.class_match_info_st = YList(self)
                                                                                    self._segment_path = lambda: "match-infop"
                                                                                    self._is_frozen = True

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop, [], name, value)


                                                                                class ClassMatchInfoSt(Entity):
                                                                                    """
                                                                                    class match info st
                                                                                    
                                                                                    .. attribute:: match_data
                                                                                    
                                                                                    	Match criteria
                                                                                    	**type**\:  :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                    
                                                                                    .. attribute:: flags
                                                                                    
                                                                                    	Flags
                                                                                    	**type**\: int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2018-01-17'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                        self.yang_name = "class-match-info-st"
                                                                                        self.yang_parent_name = "match-infop"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self.ylist_key_names = []
                                                                                        self._child_classes = OrderedDict([("match-data", ("match_data", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData))])
                                                                                        self._leafs = OrderedDict([
                                                                                            ('flags', (YLeaf(YType.uint32, 'flags'), ['int'])),
                                                                                        ])
                                                                                        self.flags = None

                                                                                        self.match_data = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                        self.match_data.parent = self
                                                                                        self._children_name_map["match_data"] = "match-data"
                                                                                        self._segment_path = lambda: "class-match-info-st"
                                                                                        self._is_frozen = True

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                    class MatchData(Entity):
                                                                                        """
                                                                                        Match criteria
                                                                                        
                                                                                        .. attribute:: ipv4_dscp
                                                                                        
                                                                                        	IPv4 DSCP
                                                                                        	**type**\:  :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                        
                                                                                        .. attribute:: ipv6_dscp
                                                                                        
                                                                                        	IPv6 DSCP
                                                                                        	**type**\:  :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                        
                                                                                        .. attribute:: dscp
                                                                                        
                                                                                        	Match DSCP range array
                                                                                        	**type**\:  :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                        
                                                                                        .. attribute:: ipv4_prec
                                                                                        
                                                                                        	IPv4 Precedence
                                                                                        	**type**\:  :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                        
                                                                                        .. attribute:: ipv6_prec
                                                                                        
                                                                                        	IPv6 Precedence
                                                                                        	**type**\:  :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                        
                                                                                        .. attribute:: prec
                                                                                        
                                                                                        	Match Precedence array
                                                                                        	**type**\:  :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                        
                                                                                        .. attribute:: discard_class
                                                                                        
                                                                                        	Match Discard Class array
                                                                                        	**type**\:  :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                        
                                                                                        .. attribute:: qos_group
                                                                                        
                                                                                        	Match QoS group array
                                                                                        	**type**\:  :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                        
                                                                                        .. attribute:: traffic_class
                                                                                        
                                                                                        	Match Traffic class array
                                                                                        	**type**\:  :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                        
                                                                                        .. attribute:: proto
                                                                                        
                                                                                        	Match Protocol array
                                                                                        	**type**\:  :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                        
                                                                                        .. attribute:: icmp_v4
                                                                                        
                                                                                        	Match ICMPV4 Protocol
                                                                                        	**type**\:  :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                        
                                                                                        .. attribute:: icmp_v6
                                                                                        
                                                                                        	Match ICMPV6 Protocol array
                                                                                        	**type**\:  :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                        
                                                                                        .. attribute:: ipv4_packet_len
                                                                                        
                                                                                        	IPv4 packet length array
                                                                                        	**type**\:  :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                        
                                                                                        .. attribute:: ipv6_packet_len
                                                                                        
                                                                                        	IPv6 packet length array
                                                                                        	**type**\:  :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                        
                                                                                        .. attribute:: packet_len
                                                                                        
                                                                                        	Match packet length array
                                                                                        	**type**\:  :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                        
                                                                                        .. attribute:: flow_tag
                                                                                        
                                                                                        	Match flow\-tag array
                                                                                        	**type**\:  :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                        
                                                                                        .. attribute:: tcp_flag
                                                                                        
                                                                                        	Match tcp flag value
                                                                                        	**type**\:  :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                        
                                                                                        .. attribute:: icmpv4_type
                                                                                        
                                                                                        	Match ipv4 icmp type
                                                                                        	**type**\:  :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                        
                                                                                        .. attribute:: icmpv4_code
                                                                                        
                                                                                        	Match ipv4 icmp code
                                                                                        	**type**\:  :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                        
                                                                                        .. attribute:: icmpv6_type
                                                                                        
                                                                                        	Match ipv6 icmp type
                                                                                        	**type**\:  :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                        
                                                                                        .. attribute:: icmpv6_code
                                                                                        
                                                                                        	Match ipv6 icmp code
                                                                                        	**type**\:  :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                        
                                                                                        .. attribute:: mpls_exp
                                                                                        
                                                                                        	Match MPLS experimental topmost array
                                                                                        	**type**\:  :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                        
                                                                                        .. attribute:: mpls_exp_imp
                                                                                        
                                                                                        	Match MPLS experimental imposition array
                                                                                        	**type**\:  :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                        
                                                                                        .. attribute:: mpls_disp_ipv4_acl
                                                                                        
                                                                                        	MPLS Disposition IPv4 Access\-list
                                                                                        	**type**\:  :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                        
                                                                                        .. attribute:: mpls_disp_ipv6_acl
                                                                                        
                                                                                        	MPLS Disposition IPv6 Access\-list
                                                                                        	**type**\:  :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                        
                                                                                        .. attribute:: mpls_top_label
                                                                                        
                                                                                        	MPLS Topmost LABEL
                                                                                        	**type**\:  :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                        
                                                                                        .. attribute:: cos
                                                                                        
                                                                                        	Match CoS array
                                                                                        	**type**\:  :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                        
                                                                                        .. attribute:: cos_inr
                                                                                        
                                                                                        	Match inner header CoS
                                                                                        	**type**\:  :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                        
                                                                                        .. attribute:: dei
                                                                                        
                                                                                        	Match DEI Bit
                                                                                        	**type**\:  :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                        
                                                                                        .. attribute:: dei_inr
                                                                                        
                                                                                        	Match inner DEI Bit
                                                                                        	**type**\:  :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                        
                                                                                        .. attribute:: vlan
                                                                                        
                                                                                        	Match VLAN array
                                                                                        	**type**\:  :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                        
                                                                                        .. attribute:: vlan_inr
                                                                                        
                                                                                        	Match inner header VLAN range array
                                                                                        	**type**\:  :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                        
                                                                                        .. attribute:: fr_dlci
                                                                                        
                                                                                        	Match FR DLCI range array
                                                                                        	**type**\:  :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                        
                                                                                        .. attribute:: src_mac
                                                                                        
                                                                                        	Match Source MAC address
                                                                                        	**type**\:  :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                        
                                                                                        .. attribute:: dst_mac
                                                                                        
                                                                                        	Match Destination MAC address
                                                                                        	**type**\:  :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                        
                                                                                        .. attribute:: atm_clp
                                                                                        
                                                                                        	Match ATM CLP level
                                                                                        	**type**\:  :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                        
                                                                                        .. attribute:: fr_de
                                                                                        
                                                                                        	Match FR DE value
                                                                                        	**type**\:  :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                        
                                                                                        .. attribute:: ipv4_acl
                                                                                        
                                                                                        	IPv4 Access\-list
                                                                                        	**type**\:  :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                        
                                                                                        .. attribute:: ipv6_acl
                                                                                        
                                                                                        	IPv6 Access\-list
                                                                                        	**type**\:  :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                        
                                                                                        .. attribute:: ether_service_acl
                                                                                        
                                                                                        	Ethernet\-Services Access\-list
                                                                                        	**type**\:  :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                        
                                                                                        .. attribute:: avail_id
                                                                                        
                                                                                        	Available Identifiers
                                                                                        	**type**\:  :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                        
                                                                                        .. attribute:: media_type
                                                                                        
                                                                                        	Media Type
                                                                                        	**type**\:  :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                        
                                                                                        .. attribute:: subs_protocol
                                                                                        
                                                                                        	Protocol
                                                                                        	**type**\:  :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                        
                                                                                        .. attribute:: dnis
                                                                                        
                                                                                        	DNIS
                                                                                        	**type**\:  :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                        
                                                                                        .. attribute:: dnis_regex
                                                                                        
                                                                                        	DNIS Regular Expression
                                                                                        	**type**\:  :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                        
                                                                                        .. attribute:: domain
                                                                                        
                                                                                        	Domain Name
                                                                                        	**type**\:  :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                        
                                                                                        .. attribute:: domain_regex
                                                                                        
                                                                                        	Domain Regular Expression
                                                                                        	**type**\:  :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                        
                                                                                        .. attribute:: nas_port
                                                                                        
                                                                                        	NAS Port
                                                                                        	**type**\:  :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                        
                                                                                        .. attribute:: service_name
                                                                                        
                                                                                        	Service Name
                                                                                        	**type**\:  :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                        
                                                                                        .. attribute:: service_name_regex
                                                                                        
                                                                                        	Service Name Regular Exp
                                                                                        	**type**\:  :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                        
                                                                                        .. attribute:: src_addr_ipv4
                                                                                        
                                                                                        	Source Address IPV4
                                                                                        	**type**\:  :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                        
                                                                                        .. attribute:: dst_addr_ipv4
                                                                                        
                                                                                        	Destination Address IPV4
                                                                                        	**type**\:  :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                        
                                                                                        .. attribute:: src_addr_ipv6
                                                                                        
                                                                                        	Source Address IPV6
                                                                                        	**type**\:  :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                        
                                                                                        .. attribute:: dst_addr_ipv6
                                                                                        
                                                                                        	Destination Address IPV6
                                                                                        	**type**\:  :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                        
                                                                                        .. attribute:: src_addr_mac
                                                                                        
                                                                                        	Source Address MAC
                                                                                        	**type**\:  :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                        
                                                                                        .. attribute:: timer
                                                                                        
                                                                                        	Timer
                                                                                        	**type**\:  :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                        
                                                                                        .. attribute:: timer_regexp
                                                                                        
                                                                                        	Timer Regular Expression
                                                                                        	**type**\:  :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                        
                                                                                        .. attribute:: tunnel_name
                                                                                        
                                                                                        	Tunnel Name
                                                                                        	**type**\:  :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                        
                                                                                        .. attribute:: tunnel_name_regex
                                                                                        
                                                                                        	Tunnel Name Regular Expression
                                                                                        	**type**\:  :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                        
                                                                                        .. attribute:: user_name
                                                                                        
                                                                                        	User Name
                                                                                        	**type**\:  :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                        
                                                                                        .. attribute:: user_name_regex
                                                                                        
                                                                                        	User Name Regular Expression
                                                                                        	**type**\:  :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                        
                                                                                        .. attribute:: auth_username
                                                                                        
                                                                                        	Authenticated User Name
                                                                                        	**type**\:  :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                        
                                                                                        .. attribute:: auth_username_regex
                                                                                        
                                                                                        	Authenticated User Name RegEx
                                                                                        	**type**\:  :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                        
                                                                                        .. attribute:: unauth_username
                                                                                        
                                                                                        	Unauthenticated User Name
                                                                                        	**type**\:  :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                        
                                                                                        .. attribute:: unauth_username_regex
                                                                                        
                                                                                        	Unauthenticated User Name RegEx
                                                                                        	**type**\:  :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                        
                                                                                        .. attribute:: auth_domain
                                                                                        
                                                                                        	Authenticated domain name
                                                                                        	**type**\:  :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                        
                                                                                        .. attribute:: auth_domain_regex
                                                                                        
                                                                                        	Authenticated Domain Name RegEx
                                                                                        	**type**\:  :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                        
                                                                                        .. attribute:: unauth_domain
                                                                                        
                                                                                        	Unauthenticated Domain Name
                                                                                        	**type**\:  :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                        
                                                                                        .. attribute:: unauth_domain_regex
                                                                                        
                                                                                        	Unauthenticated Domain Name RegEx
                                                                                        	**type**\:  :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                        
                                                                                        .. attribute:: vendor_id
                                                                                        
                                                                                        	Vendor ID
                                                                                        	**type**\:  :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                        
                                                                                        .. attribute:: vendor_id_regex
                                                                                        
                                                                                        	Vendor ID RegEx
                                                                                        	**type**\:  :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                        
                                                                                        .. attribute:: access_interface
                                                                                        
                                                                                        	Access interface
                                                                                        	**type**\:  :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                        
                                                                                        .. attribute:: input_interface
                                                                                        
                                                                                        	Input interface
                                                                                        	**type**\:  :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                        
                                                                                        .. attribute:: input_intfhdl
                                                                                        
                                                                                        	Input interface handle
                                                                                        	**type**\:  :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                        
                                                                                        .. attribute:: ethertype
                                                                                        
                                                                                        	Ethernet type
                                                                                        	**type**\:  :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                        
                                                                                        .. attribute:: flow_key_data
                                                                                        
                                                                                        	Flow key structure
                                                                                        	**type**\:  :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                        
                                                                                        .. attribute:: dhcp_client_id
                                                                                        
                                                                                        	Dhcp Client ID
                                                                                        	**type**\:  :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                        
                                                                                        .. attribute:: dhcp_client_id_regex
                                                                                        
                                                                                        	Dhcp Client ID RegEx
                                                                                        	**type**\:  :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                        
                                                                                        .. attribute:: circuit_id
                                                                                        
                                                                                        	Circuit ID
                                                                                        	**type**\:  :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                        
                                                                                        .. attribute:: circuit_id_regex
                                                                                        
                                                                                        	Circuit ID RegEx
                                                                                        	**type**\:  :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                        
                                                                                        .. attribute:: remote_id
                                                                                        
                                                                                        	Remote ID
                                                                                        	**type**\:  :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                        
                                                                                        .. attribute:: remote_id_regex
                                                                                        
                                                                                        	Remote ID RegEx
                                                                                        	**type**\:  :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                        
                                                                                        .. attribute:: src_port
                                                                                        
                                                                                        	Source port
                                                                                        	**type**\:  :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                        
                                                                                        .. attribute:: dst_port
                                                                                        
                                                                                        	Destination port
                                                                                        	**type**\:  :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                        
                                                                                        .. attribute:: type
                                                                                        
                                                                                        	type
                                                                                        	**type**\:  :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                        
                                                                                        .. attribute:: mpls_top_eos
                                                                                        
                                                                                        	MPLS Topmost EOS
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: fragment_type
                                                                                        
                                                                                        	Fragment type
                                                                                        	**type**\: int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: authen_status
                                                                                        
                                                                                        	Authentication Status
                                                                                        	**type**\:  :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                        
                                                                                        .. attribute:: mlp_negotiated
                                                                                        
                                                                                        	MLP Negotiated
                                                                                        	**type**\:  :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2018-01-17'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                            self.yang_name = "match-data"
                                                                                            self.yang_parent_name = "class-match-info-st"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self.ylist_key_names = []
                                                                                            self._child_classes = OrderedDict([("ipv4-dscp", ("ipv4_dscp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp)), ("ipv6-dscp", ("ipv6_dscp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp)), ("dscp", ("dscp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp)), ("ipv4-prec", ("ipv4_prec", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec)), ("ipv6-prec", ("ipv6_prec", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec)), ("prec", ("prec", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec)), ("discard-class", ("discard_class", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass)), ("qos-group", ("qos_group", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup)), ("traffic-class", ("traffic_class", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass)), ("proto", ("proto", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto)), ("icmp-v4", ("icmp_v4", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4)), ("icmp-v6", ("icmp_v6", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6)), ("ipv4-packet-len", ("ipv4_packet_len", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen)), ("ipv6-packet-len", ("ipv6_packet_len", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen)), ("packet-len", ("packet_len", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen)), ("flow-tag", ("flow_tag", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag)), ("tcp-flag", ("tcp_flag", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag)), ("icmpv4-type", ("icmpv4_type", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type)), ("icmpv4-code", ("icmpv4_code", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code)), ("icmpv6-type", ("icmpv6_type", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type)), ("icmpv6-code", ("icmpv6_code", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code)), ("mpls-exp", ("mpls_exp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp)), ("mpls-exp-imp", ("mpls_exp_imp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp)), ("mpls-disp-ipv4-acl", ("mpls_disp_ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl)), ("mpls-disp-ipv6-acl", ("mpls_disp_ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl)), ("mpls-top-label", ("mpls_top_label", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel)), ("cos", ("cos", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos)), ("cos-inr", ("cos_inr", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr)), ("dei", ("dei", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei)), ("dei-inr", ("dei_inr", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr)), ("vlan", ("vlan", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan)), ("vlan-inr", ("vlan_inr", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)), ("fr-dlci", ("fr_dlci", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci)), ("src-mac", ("src_mac", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac)), ("dst-mac", ("dst_mac", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac)), ("atm-clp", ("atm_clp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp)), ("fr-de", ("fr_de", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe)), ("ipv4-acl", ("ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl)), ("ipv6-acl", ("ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl)), ("ether-service-acl", ("ether_service_acl", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl)), ("avail-id", ("avail_id", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId)), ("media-type", ("media_type", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType)), ("subs-protocol", ("subs_protocol", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol)), ("dnis", ("dnis", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis)), ("dnis-regex", ("dnis_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex)), ("domain", ("domain", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain)), ("domain-regex", ("domain_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex)), ("nas-port", ("nas_port", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort)), ("service-name", ("service_name", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName)), ("service-name-regex", ("service_name_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex)), ("src-addr-ipv4", ("src_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4)), ("dst-addr-ipv4", ("dst_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4)), ("src-addr-ipv6", ("src_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6)), ("dst-addr-ipv6", ("dst_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6)), ("src-addr-mac", ("src_addr_mac", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac)), ("timer", ("timer", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer)), ("timer-regexp", ("timer_regexp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp)), ("tunnel-name", ("tunnel_name", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName)), ("tunnel-name-regex", ("tunnel_name_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex)), ("user-name", ("user_name", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName)), ("user-name-regex", ("user_name_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex)), ("auth-username", ("auth_username", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername)), ("auth-username-regex", ("auth_username_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex)), ("unauth-username", ("unauth_username", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername)), ("unauth-username-regex", ("unauth_username_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex)), ("auth-domain", ("auth_domain", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain)), ("auth-domain-regex", ("auth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex)), ("unauth-domain", ("unauth_domain", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain)), ("unauth-domain-regex", ("unauth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex)), ("vendor-id", ("vendor_id", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId)), ("vendor-id-regex", ("vendor_id_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex)), ("access-interface", ("access_interface", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface)), ("input-interface", ("input_interface", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface)), ("input-intfhdl", ("input_intfhdl", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl)), ("ethertype", ("ethertype", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype)), ("flow-key-data", ("flow_key_data", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData)), ("dhcp-client-id", ("dhcp_client_id", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId)), ("dhcp-client-id-regex", ("dhcp_client_id_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex)), ("circuit-id", ("circuit_id", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId)), ("circuit-id-regex", ("circuit_id_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex)), ("remote-id", ("remote_id", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId)), ("remote-id-regex", ("remote_id_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex)), ("src-port", ("src_port", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort)), ("dst-port", ("dst_port", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort))])
                                                                                            self._leafs = OrderedDict([
                                                                                                ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchTypeEn', '')])),
                                                                                                ('mpls_top_eos', (YLeaf(YType.uint8, 'mpls-top-eos'), ['int'])),
                                                                                                ('fragment_type', (YLeaf(YType.uint8, 'fragment-type'), ['int'])),
                                                                                                ('authen_status', (YLeaf(YType.enumeration, 'authen-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchAuthenStatusEn', '')])),
                                                                                                ('mlp_negotiated', (YLeaf(YType.enumeration, 'mlp-negotiated'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchMlpNegotiatedEn', '')])),
                                                                                            ])
                                                                                            self.type = None
                                                                                            self.mpls_top_eos = None
                                                                                            self.fragment_type = None
                                                                                            self.authen_status = None
                                                                                            self.mlp_negotiated = None

                                                                                            self.ipv4_dscp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                            self.ipv4_dscp.parent = self
                                                                                            self._children_name_map["ipv4_dscp"] = "ipv4-dscp"

                                                                                            self.ipv6_dscp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                            self.ipv6_dscp.parent = self
                                                                                            self._children_name_map["ipv6_dscp"] = "ipv6-dscp"

                                                                                            self.dscp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                            self.dscp.parent = self
                                                                                            self._children_name_map["dscp"] = "dscp"

                                                                                            self.ipv4_prec = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                            self.ipv4_prec.parent = self
                                                                                            self._children_name_map["ipv4_prec"] = "ipv4-prec"

                                                                                            self.ipv6_prec = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                            self.ipv6_prec.parent = self
                                                                                            self._children_name_map["ipv6_prec"] = "ipv6-prec"

                                                                                            self.prec = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                            self.prec.parent = self
                                                                                            self._children_name_map["prec"] = "prec"

                                                                                            self.discard_class = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                            self.discard_class.parent = self
                                                                                            self._children_name_map["discard_class"] = "discard-class"

                                                                                            self.qos_group = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                            self.qos_group.parent = self
                                                                                            self._children_name_map["qos_group"] = "qos-group"

                                                                                            self.traffic_class = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                            self.traffic_class.parent = self
                                                                                            self._children_name_map["traffic_class"] = "traffic-class"

                                                                                            self.proto = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                            self.proto.parent = self
                                                                                            self._children_name_map["proto"] = "proto"

                                                                                            self.icmp_v4 = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                            self.icmp_v4.parent = self
                                                                                            self._children_name_map["icmp_v4"] = "icmp-v4"

                                                                                            self.icmp_v6 = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                            self.icmp_v6.parent = self
                                                                                            self._children_name_map["icmp_v6"] = "icmp-v6"

                                                                                            self.ipv4_packet_len = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                            self.ipv4_packet_len.parent = self
                                                                                            self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"

                                                                                            self.ipv6_packet_len = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                            self.ipv6_packet_len.parent = self
                                                                                            self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"

                                                                                            self.packet_len = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                            self.packet_len.parent = self
                                                                                            self._children_name_map["packet_len"] = "packet-len"

                                                                                            self.flow_tag = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                            self.flow_tag.parent = self
                                                                                            self._children_name_map["flow_tag"] = "flow-tag"

                                                                                            self.tcp_flag = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                            self.tcp_flag.parent = self
                                                                                            self._children_name_map["tcp_flag"] = "tcp-flag"

                                                                                            self.icmpv4_type = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                            self.icmpv4_type.parent = self
                                                                                            self._children_name_map["icmpv4_type"] = "icmpv4-type"

                                                                                            self.icmpv4_code = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                            self.icmpv4_code.parent = self
                                                                                            self._children_name_map["icmpv4_code"] = "icmpv4-code"

                                                                                            self.icmpv6_type = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                            self.icmpv6_type.parent = self
                                                                                            self._children_name_map["icmpv6_type"] = "icmpv6-type"

                                                                                            self.icmpv6_code = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                            self.icmpv6_code.parent = self
                                                                                            self._children_name_map["icmpv6_code"] = "icmpv6-code"

                                                                                            self.mpls_exp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                            self.mpls_exp.parent = self
                                                                                            self._children_name_map["mpls_exp"] = "mpls-exp"

                                                                                            self.mpls_exp_imp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                            self.mpls_exp_imp.parent = self
                                                                                            self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"

                                                                                            self.mpls_disp_ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                            self.mpls_disp_ipv4_acl.parent = self
                                                                                            self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"

                                                                                            self.mpls_disp_ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                            self.mpls_disp_ipv6_acl.parent = self
                                                                                            self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"

                                                                                            self.mpls_top_label = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                            self.mpls_top_label.parent = self
                                                                                            self._children_name_map["mpls_top_label"] = "mpls-top-label"

                                                                                            self.cos = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                            self.cos.parent = self
                                                                                            self._children_name_map["cos"] = "cos"

                                                                                            self.cos_inr = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                            self.cos_inr.parent = self
                                                                                            self._children_name_map["cos_inr"] = "cos-inr"

                                                                                            self.dei = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                            self.dei.parent = self
                                                                                            self._children_name_map["dei"] = "dei"

                                                                                            self.dei_inr = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                            self.dei_inr.parent = self
                                                                                            self._children_name_map["dei_inr"] = "dei-inr"

                                                                                            self.vlan = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                            self.vlan.parent = self
                                                                                            self._children_name_map["vlan"] = "vlan"

                                                                                            self.vlan_inr = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                            self.vlan_inr.parent = self
                                                                                            self._children_name_map["vlan_inr"] = "vlan-inr"

                                                                                            self.fr_dlci = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                            self.fr_dlci.parent = self
                                                                                            self._children_name_map["fr_dlci"] = "fr-dlci"

                                                                                            self.src_mac = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                            self.src_mac.parent = self
                                                                                            self._children_name_map["src_mac"] = "src-mac"

                                                                                            self.dst_mac = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                            self.dst_mac.parent = self
                                                                                            self._children_name_map["dst_mac"] = "dst-mac"

                                                                                            self.atm_clp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                            self.atm_clp.parent = self
                                                                                            self._children_name_map["atm_clp"] = "atm-clp"

                                                                                            self.fr_de = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                            self.fr_de.parent = self
                                                                                            self._children_name_map["fr_de"] = "fr-de"

                                                                                            self.ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                            self.ipv4_acl.parent = self
                                                                                            self._children_name_map["ipv4_acl"] = "ipv4-acl"

                                                                                            self.ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                            self.ipv6_acl.parent = self
                                                                                            self._children_name_map["ipv6_acl"] = "ipv6-acl"

                                                                                            self.ether_service_acl = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                            self.ether_service_acl.parent = self
                                                                                            self._children_name_map["ether_service_acl"] = "ether-service-acl"

                                                                                            self.avail_id = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                            self.avail_id.parent = self
                                                                                            self._children_name_map["avail_id"] = "avail-id"

                                                                                            self.media_type = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                            self.media_type.parent = self
                                                                                            self._children_name_map["media_type"] = "media-type"

                                                                                            self.subs_protocol = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                            self.subs_protocol.parent = self
                                                                                            self._children_name_map["subs_protocol"] = "subs-protocol"

                                                                                            self.dnis = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                            self.dnis.parent = self
                                                                                            self._children_name_map["dnis"] = "dnis"

                                                                                            self.dnis_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                            self.dnis_regex.parent = self
                                                                                            self._children_name_map["dnis_regex"] = "dnis-regex"

                                                                                            self.domain = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                            self.domain.parent = self
                                                                                            self._children_name_map["domain"] = "domain"

                                                                                            self.domain_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                            self.domain_regex.parent = self
                                                                                            self._children_name_map["domain_regex"] = "domain-regex"

                                                                                            self.nas_port = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                            self.nas_port.parent = self
                                                                                            self._children_name_map["nas_port"] = "nas-port"

                                                                                            self.service_name = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                            self.service_name.parent = self
                                                                                            self._children_name_map["service_name"] = "service-name"

                                                                                            self.service_name_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                            self.service_name_regex.parent = self
                                                                                            self._children_name_map["service_name_regex"] = "service-name-regex"

                                                                                            self.src_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                            self.src_addr_ipv4.parent = self
                                                                                            self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"

                                                                                            self.dst_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                            self.dst_addr_ipv4.parent = self
                                                                                            self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"

                                                                                            self.src_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                            self.src_addr_ipv6.parent = self
                                                                                            self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"

                                                                                            self.dst_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                            self.dst_addr_ipv6.parent = self
                                                                                            self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"

                                                                                            self.src_addr_mac = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                            self.src_addr_mac.parent = self
                                                                                            self._children_name_map["src_addr_mac"] = "src-addr-mac"

                                                                                            self.timer = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                            self.timer.parent = self
                                                                                            self._children_name_map["timer"] = "timer"

                                                                                            self.timer_regexp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                            self.timer_regexp.parent = self
                                                                                            self._children_name_map["timer_regexp"] = "timer-regexp"

                                                                                            self.tunnel_name = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                            self.tunnel_name.parent = self
                                                                                            self._children_name_map["tunnel_name"] = "tunnel-name"

                                                                                            self.tunnel_name_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                            self.tunnel_name_regex.parent = self
                                                                                            self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"

                                                                                            self.user_name = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                            self.user_name.parent = self
                                                                                            self._children_name_map["user_name"] = "user-name"

                                                                                            self.user_name_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                            self.user_name_regex.parent = self
                                                                                            self._children_name_map["user_name_regex"] = "user-name-regex"

                                                                                            self.auth_username = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                            self.auth_username.parent = self
                                                                                            self._children_name_map["auth_username"] = "auth-username"

                                                                                            self.auth_username_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                            self.auth_username_regex.parent = self
                                                                                            self._children_name_map["auth_username_regex"] = "auth-username-regex"

                                                                                            self.unauth_username = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                            self.unauth_username.parent = self
                                                                                            self._children_name_map["unauth_username"] = "unauth-username"

                                                                                            self.unauth_username_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                            self.unauth_username_regex.parent = self
                                                                                            self._children_name_map["unauth_username_regex"] = "unauth-username-regex"

                                                                                            self.auth_domain = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                            self.auth_domain.parent = self
                                                                                            self._children_name_map["auth_domain"] = "auth-domain"

                                                                                            self.auth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                            self.auth_domain_regex.parent = self
                                                                                            self._children_name_map["auth_domain_regex"] = "auth-domain-regex"

                                                                                            self.unauth_domain = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                            self.unauth_domain.parent = self
                                                                                            self._children_name_map["unauth_domain"] = "unauth-domain"

                                                                                            self.unauth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                            self.unauth_domain_regex.parent = self
                                                                                            self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"

                                                                                            self.vendor_id = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                            self.vendor_id.parent = self
                                                                                            self._children_name_map["vendor_id"] = "vendor-id"

                                                                                            self.vendor_id_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                            self.vendor_id_regex.parent = self
                                                                                            self._children_name_map["vendor_id_regex"] = "vendor-id-regex"

                                                                                            self.access_interface = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                            self.access_interface.parent = self
                                                                                            self._children_name_map["access_interface"] = "access-interface"

                                                                                            self.input_interface = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                            self.input_interface.parent = self
                                                                                            self._children_name_map["input_interface"] = "input-interface"

                                                                                            self.input_intfhdl = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                            self.input_intfhdl.parent = self
                                                                                            self._children_name_map["input_intfhdl"] = "input-intfhdl"

                                                                                            self.ethertype = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                            self.ethertype.parent = self
                                                                                            self._children_name_map["ethertype"] = "ethertype"

                                                                                            self.flow_key_data = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                            self.flow_key_data.parent = self
                                                                                            self._children_name_map["flow_key_data"] = "flow-key-data"

                                                                                            self.dhcp_client_id = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                            self.dhcp_client_id.parent = self
                                                                                            self._children_name_map["dhcp_client_id"] = "dhcp-client-id"

                                                                                            self.dhcp_client_id_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                            self.dhcp_client_id_regex.parent = self
                                                                                            self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"

                                                                                            self.circuit_id = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                            self.circuit_id.parent = self
                                                                                            self._children_name_map["circuit_id"] = "circuit-id"

                                                                                            self.circuit_id_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                            self.circuit_id_regex.parent = self
                                                                                            self._children_name_map["circuit_id_regex"] = "circuit-id-regex"

                                                                                            self.remote_id = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                            self.remote_id.parent = self
                                                                                            self._children_name_map["remote_id"] = "remote-id"

                                                                                            self.remote_id_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                            self.remote_id_regex.parent = self
                                                                                            self._children_name_map["remote_id_regex"] = "remote-id-regex"

                                                                                            self.src_port = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                            self.src_port.parent = self
                                                                                            self._children_name_map["src_port"] = "src-port"

                                                                                            self.dst_port = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                            self.dst_port.parent = self
                                                                                            self._children_name_map["dst_port"] = "dst-port"
                                                                                            self._segment_path = lambda: "match-data"
                                                                                            self._is_frozen = True

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['type', 'mpls_top_eos', 'fragment_type', 'authen_status', 'mlp_negotiated'], name, value)


                                                                                        class Ipv4Dscp(Entity):
                                                                                            """
                                                                                            IPv4 DSCP
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                self.yang_name = "ipv4-dscp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ipv4-dscp"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "ipv4-dscp"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                        class Ipv6Dscp(Entity):
                                                                                            """
                                                                                            IPv6 DSCP
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                self.yang_name = "ipv6-dscp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ipv6-dscp"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "ipv6-dscp"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                        class Dscp(Entity):
                                                                                            """
                                                                                            Match DSCP range array
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                self.yang_name = "dscp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "dscp"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "dscp"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['min', 'max'], name, value)


                                                                                        class Ipv4Prec(Entity):
                                                                                            """
                                                                                            IPv4 Precedence
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                self.yang_name = "ipv4-prec"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "ipv4-prec"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                        class Ipv6Prec(Entity):
                                                                                            """
                                                                                            IPv6 Precedence
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                self.yang_name = "ipv6-prec"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "ipv6-prec"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                        class Prec(Entity):
                                                                                            """
                                                                                            Match Precedence array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                self.yang_name = "prec"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "prec"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                        class DiscardClass(Entity):
                                                                                            """
                                                                                            Match Discard Class array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                self.yang_name = "discard-class"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "discard-class"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                        class QosGroup(Entity):
                                                                                            """
                                                                                            Match QoS group array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                self.yang_name = "qos-group"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "qos-group"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "qos-group"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['min', 'max'], name, value)


                                                                                        class TrafficClass(Entity):
                                                                                            """
                                                                                            Match Traffic class array
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                self.yang_name = "traffic-class"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "traffic-class"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "traffic-class"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['min', 'max'], name, value)


                                                                                        class Proto(Entity):
                                                                                            """
                                                                                            Match Protocol array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                self.yang_name = "proto"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "proto"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "proto"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['min', 'max'], name, value)


                                                                                        class IcmpV4(Entity):
                                                                                            """
                                                                                            Match ICMPV4 Protocol
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	Protocol type
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: code
                                                                                            
                                                                                            	Protocol code
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                self.yang_name = "icmp-v4"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                    ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                ])
                                                                                                self.type = None
                                                                                                self.code = None
                                                                                                self._segment_path = lambda: "icmp-v4"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['type', 'code'], name, value)


                                                                                        class IcmpV6(Entity):
                                                                                            """
                                                                                            Match ICMPV6 Protocol array
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	Protocol type
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: code
                                                                                            
                                                                                            	Protocol code
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                self.yang_name = "icmp-v6"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                                                                                                    ('code', (YLeaf(YType.uint8, 'code'), ['int'])),
                                                                                                ])
                                                                                                self.type = None
                                                                                                self.code = None
                                                                                                self._segment_path = lambda: "icmp-v6"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['type', 'code'], name, value)


                                                                                        class Ipv4PacketLen(Entity):
                                                                                            """
                                                                                            IPv4 packet length array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                self.yang_name = "ipv4-packet-len"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ipv4-packet-len"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "ipv4-packet-len"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                        class Ipv6PacketLen(Entity):
                                                                                            """
                                                                                            IPv6 packet length array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                self.yang_name = "ipv6-packet-len"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ipv6-packet-len"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "ipv6-packet-len"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                        class PacketLen(Entity):
                                                                                            """
                                                                                            Match packet length array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                self.yang_name = "packet-len"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "packet-len"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "packet-len"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['min', 'max'], name, value)


                                                                                        class FlowTag(Entity):
                                                                                            """
                                                                                            Match flow\-tag array
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                self.yang_name = "flow-tag"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "flow-tag"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "flow-tag"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['min', 'max'], name, value)


                                                                                        class TcpFlag(Entity):
                                                                                            """
                                                                                            Match tcp flag value
                                                                                            
                                                                                            .. attribute:: value
                                                                                            
                                                                                            	Value of TCP flag
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: match_any
                                                                                            
                                                                                            	Match any TCP flag bit
                                                                                            	**type**\: bool
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                self.yang_name = "tcp-flag"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('value', (YLeaf(YType.uint16, 'value'), ['int'])),
                                                                                                    ('match_any', (YLeaf(YType.boolean, 'match-any'), ['bool'])),
                                                                                                ])
                                                                                                self.value = None
                                                                                                self.match_any = None
                                                                                                self._segment_path = lambda: "tcp-flag"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['value', 'match_any'], name, value)


                                                                                        class Icmpv4Type(Entity):
                                                                                            """
                                                                                            Match ipv4 icmp type
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                self.yang_name = "icmpv4-type"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "icmpv4-type"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "icmpv4-type"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                        class Icmpv4Code(Entity):
                                                                                            """
                                                                                            Match ipv4 icmp code
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                self.yang_name = "icmpv4-code"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "icmpv4-code"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "icmpv4-code"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                        class Icmpv6Type(Entity):
                                                                                            """
                                                                                            Match ipv6 icmp type
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                self.yang_name = "icmpv6-type"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "icmpv6-type"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "icmpv6-type"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['min', 'max'], name, value)


                                                                                        class Icmpv6Code(Entity):
                                                                                            """
                                                                                            Match ipv6 icmp code
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                self.yang_name = "icmpv6-code"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint8_rng_array", ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "icmpv6-code"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "icmpv6-code"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint8, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint8, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint8_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['min', 'max'], name, value)


                                                                                        class MplsExp(Entity):
                                                                                            """
                                                                                            Match MPLS experimental topmost array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                self.yang_name = "mpls-exp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "mpls-exp"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                        class MplsExpImp(Entity):
                                                                                            """
                                                                                            Match MPLS experimental imposition array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                self.yang_name = "mpls-exp-imp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "mpls-exp-imp"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                        class MplsDispIpv4Acl(Entity):
                                                                                            """
                                                                                            MPLS Disposition IPv4 Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "mpls-disp-ipv4-acl"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                        class MplsDispIpv6Acl(Entity):
                                                                                            """
                                                                                            MPLS Disposition IPv6 Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "mpls-disp-ipv6-acl"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                        class MplsTopLabel(Entity):
                                                                                            """
                                                                                            MPLS Topmost LABEL
                                                                                            
                                                                                            .. attribute:: uint32_rng_array
                                                                                            
                                                                                            	uint32 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                self.yang_name = "mpls-top-label"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint32_rng_array", ("uint32_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint32_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "mpls-top-label"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                            class Uint32RngArray(Entity):
                                                                                                """
                                                                                                uint32 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                    self.yang_name = "uint32_rng_array"
                                                                                                    self.yang_parent_name = "mpls-top-label"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint32, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint32, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint32_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['min', 'max'], name, value)


                                                                                        class Cos(Entity):
                                                                                            """
                                                                                            Match CoS array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                self.yang_name = "cos"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "cos"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                        class CosInr(Entity):
                                                                                            """
                                                                                            Match inner header CoS
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                self.yang_name = "cos-inr"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "cos-inr"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                        class Dei(Entity):
                                                                                            """
                                                                                            Match DEI Bit
                                                                                            
                                                                                            .. attribute:: bit_value
                                                                                            
                                                                                            	Value of the DEI bit
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                self.yang_name = "dei"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                ])
                                                                                                self.bit_value = None
                                                                                                self._segment_path = lambda: "dei"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                        class DeiInr(Entity):
                                                                                            """
                                                                                            Match inner DEI Bit
                                                                                            
                                                                                            .. attribute:: bit_value
                                                                                            
                                                                                            	Value of the DEI bit
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                self.yang_name = "dei-inr"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('bit_value', (YLeaf(YType.uint32, 'bit-value'), ['int'])),
                                                                                                ])
                                                                                                self.bit_value = None
                                                                                                self._segment_path = lambda: "dei-inr"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                        class Vlan(Entity):
                                                                                            """
                                                                                            Match VLAN array
                                                                                            
                                                                                            .. attribute:: vlan_id_array
                                                                                            
                                                                                            	vlan id array
                                                                                            	**type**\: list of  		 :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                self.yang_name = "vlan"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("vlan-id-array", ("vlan_id_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.vlan_id_array = YList(self)
                                                                                                self._segment_path = lambda: "vlan"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                            class VlanIdArray(Entity):
                                                                                                """
                                                                                                vlan id array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	VLAN mask
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                    self.yang_name = "vlan-id-array"
                                                                                                    self.yang_parent_name = "vlan"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                        ('mask', (YLeaf(YType.uint16, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self.mask = None
                                                                                                    self._segment_path = lambda: "vlan-id-array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['min', 'max', 'mask'], name, value)


                                                                                        class VlanInr(Entity):
                                                                                            """
                                                                                            Match inner header VLAN range array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                self.yang_name = "vlan-inr"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "vlan-inr"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "vlan-inr"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['min', 'max'], name, value)


                                                                                        class FrDlci(Entity):
                                                                                            """
                                                                                            Match FR DLCI range array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                self.yang_name = "fr-dlci"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "fr-dlci"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "fr-dlci"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['min', 'max'], name, value)


                                                                                        class SrcMac(Entity):
                                                                                            """
                                                                                            Match Source MAC address
                                                                                            
                                                                                            .. attribute:: mac_addr
                                                                                            
                                                                                            	MAC address
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	MAC mask
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                self.yang_name = "src-mac"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                    ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                ])
                                                                                                self.mac_addr = []
                                                                                                self.mask = []
                                                                                                self._segment_path = lambda: "src-mac"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                        class DstMac(Entity):
                                                                                            """
                                                                                            Match Destination MAC address
                                                                                            
                                                                                            .. attribute:: mac_addr
                                                                                            
                                                                                            	MAC address
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	MAC mask
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                self.yang_name = "dst-mac"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                    ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                ])
                                                                                                self.mac_addr = []
                                                                                                self.mask = []
                                                                                                self._segment_path = lambda: "dst-mac"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                        class AtmClp(Entity):
                                                                                            """
                                                                                            Match ATM CLP level
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                self.yang_name = "atm-clp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "atm-clp"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                        class FrDe(Entity):
                                                                                            """
                                                                                            Match FR DE value
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                self.yang_name = "fr-de"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "fr-de"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                        class Ipv4Acl(Entity):
                                                                                            """
                                                                                            IPv4 Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                self.yang_name = "ipv4-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "ipv4-acl"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                        class Ipv6Acl(Entity):
                                                                                            """
                                                                                            IPv6 Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                self.yang_name = "ipv6-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "ipv6-acl"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                        class EtherServiceAcl(Entity):
                                                                                            """
                                                                                            Ethernet\-Services Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                self.yang_name = "ether-service-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "ether-service-acl"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                        class AvailId(Entity):
                                                                                            """
                                                                                            Available Identifiers
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                self.yang_name = "avail-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "avail-id"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                        class MediaType(Entity):
                                                                                            """
                                                                                            Media Type
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                self.yang_name = "media-type"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "media-type"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                        class SubsProtocol(Entity):
                                                                                            """
                                                                                            Protocol
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                self.yang_name = "subs-protocol"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint8_array', (YLeafList(YType.uint8, 'uint8_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint8_array = []
                                                                                                self._segment_path = lambda: "subs-protocol"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                        class Dnis(Entity):
                                                                                            """
                                                                                            DNIS
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                self.yang_name = "dnis"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "dnis"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                        class DnisRegex(Entity):
                                                                                            """
                                                                                            DNIS Regular Expression
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                self.yang_name = "dnis-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "dnis-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                        class Domain(Entity):
                                                                                            """
                                                                                            Domain Name
                                                                                            
                                                                                            .. attribute:: domain_array
                                                                                            
                                                                                            	domain array
                                                                                            	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                self.yang_name = "domain"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.domain_array = YList(self)
                                                                                                self._segment_path = lambda: "domain"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                            class DomainArray(Entity):
                                                                                                """
                                                                                                domain array
                                                                                                
                                                                                                .. attribute:: domain_name
                                                                                                
                                                                                                	domain name
                                                                                                	**type**\: str
                                                                                                
                                                                                                .. attribute:: format_name
                                                                                                
                                                                                                	format name
                                                                                                	**type**\: str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                    self.yang_name = "domain-array"
                                                                                                    self.yang_parent_name = "domain"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                        ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                    ])
                                                                                                    self.domain_name = None
                                                                                                    self.format_name = None
                                                                                                    self._segment_path = lambda: "domain-array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                        class DomainRegex(Entity):
                                                                                            """
                                                                                            Domain Regular Expression
                                                                                            
                                                                                            .. attribute:: domain_array
                                                                                            
                                                                                            	domain array
                                                                                            	**type**\: list of  		 :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                self.yang_name = "domain-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("domain-array", ("domain_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.domain_array = YList(self)
                                                                                                self._segment_path = lambda: "domain-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                            class DomainArray(Entity):
                                                                                                """
                                                                                                domain array
                                                                                                
                                                                                                .. attribute:: domain_name
                                                                                                
                                                                                                	domain name
                                                                                                	**type**\: str
                                                                                                
                                                                                                .. attribute:: format_name
                                                                                                
                                                                                                	format name
                                                                                                	**type**\: str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                    self.yang_name = "domain-array"
                                                                                                    self.yang_parent_name = "domain-regex"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('domain_name', (YLeaf(YType.str, 'domain-name'), ['str'])),
                                                                                                        ('format_name', (YLeaf(YType.str, 'format-name'), ['str'])),
                                                                                                    ])
                                                                                                    self.domain_name = None
                                                                                                    self.format_name = None
                                                                                                    self._segment_path = lambda: "domain-array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                        class NasPort(Entity):
                                                                                            """
                                                                                            NAS Port
                                                                                            
                                                                                            .. attribute:: nas_port_array
                                                                                            
                                                                                            	nas port array
                                                                                            	**type**\: list of  		 :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                self.yang_name = "nas-port"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("nas-port-array", ("nas_port_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.nas_port_array = YList(self)
                                                                                                self._segment_path = lambda: "nas-port"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                            class NasPortArray(Entity):
                                                                                                """
                                                                                                nas port array
                                                                                                
                                                                                                .. attribute:: sub_id
                                                                                                
                                                                                                	sub id
                                                                                                	**type**\:  :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                
                                                                                                .. attribute:: operator
                                                                                                
                                                                                                	operator
                                                                                                	**type**\:  :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                
                                                                                                .. attribute:: value
                                                                                                
                                                                                                	value
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                    self.yang_name = "nas-port-array"
                                                                                                    self.yang_parent_name = "nas-port"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('sub_id', (YLeaf(YType.enumeration, 'sub-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchNasPortSubIdEn', '')])),
                                                                                                        ('operator', (YLeaf(YType.enumeration, 'operator'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'MatchLogicalOperatorEn', '')])),
                                                                                                        ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                                    ])
                                                                                                    self.sub_id = None
                                                                                                    self.operator = None
                                                                                                    self.value = None
                                                                                                    self._segment_path = lambda: "nas-port-array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['sub_id', 'operator', 'value'], name, value)


                                                                                        class ServiceName(Entity):
                                                                                            """
                                                                                            Service Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                self.yang_name = "service-name"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "service-name"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                        class ServiceNameRegex(Entity):
                                                                                            """
                                                                                            Service Name Regular Exp
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                self.yang_name = "service-name-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "service-name-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                        class SrcAddrIpv4(Entity):
                                                                                            """
                                                                                            Source Address IPV4
                                                                                            
                                                                                            .. attribute:: ipv4_addr_array
                                                                                            
                                                                                            	ipv4 addr array
                                                                                            	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                self.yang_name = "src-addr-ipv4"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.ipv4_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "src-addr-ipv4"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                            class Ipv4AddrArray(Entity):
                                                                                                """
                                                                                                ipv4 addr array
                                                                                                
                                                                                                .. attribute:: prefix
                                                                                                
                                                                                                	prefix
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	mask
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                    self.yang_name = "ipv4-addr-array"
                                                                                                    self.yang_parent_name = "src-addr-ipv4"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                        ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                    ])
                                                                                                    self.prefix = None
                                                                                                    self.mask = None
                                                                                                    self._segment_path = lambda: "ipv4-addr-array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                        class DstAddrIpv4(Entity):
                                                                                            """
                                                                                            Destination Address IPV4
                                                                                            
                                                                                            .. attribute:: ipv4_addr_array
                                                                                            
                                                                                            	ipv4 addr array
                                                                                            	**type**\: list of  		 :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                self.yang_name = "dst-addr-ipv4"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("ipv4-addr-array", ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.ipv4_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "dst-addr-ipv4"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                            class Ipv4AddrArray(Entity):
                                                                                                """
                                                                                                ipv4 addr array
                                                                                                
                                                                                                .. attribute:: prefix
                                                                                                
                                                                                                	prefix
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	mask
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                    self.yang_name = "ipv4-addr-array"
                                                                                                    self.yang_parent_name = "dst-addr-ipv4"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                        ('mask', (YLeaf(YType.str, 'mask'), ['str'])),
                                                                                                    ])
                                                                                                    self.prefix = None
                                                                                                    self.mask = None
                                                                                                    self._segment_path = lambda: "ipv4-addr-array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['prefix', 'mask'], name, value)


                                                                                        class SrcAddrIpv6(Entity):
                                                                                            """
                                                                                            Source Address IPV6
                                                                                            
                                                                                            .. attribute:: ipv6_addr_array
                                                                                            
                                                                                            	ipv6 addr array
                                                                                            	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                self.yang_name = "src-addr-ipv6"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.ipv6_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "src-addr-ipv6"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                            class Ipv6AddrArray(Entity):
                                                                                                """
                                                                                                ipv6 addr array
                                                                                                
                                                                                                .. attribute:: prefix
                                                                                                
                                                                                                	IPV6 prefix
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	IPV6 mask
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                    self.yang_name = "ipv6-addr-array"
                                                                                                    self.yang_parent_name = "src-addr-ipv6"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                        ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.prefix = None
                                                                                                    self.mask = None
                                                                                                    self._segment_path = lambda: "ipv6-addr-array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                        class DstAddrIpv6(Entity):
                                                                                            """
                                                                                            Destination Address IPV6
                                                                                            
                                                                                            .. attribute:: ipv6_addr_array
                                                                                            
                                                                                            	ipv6 addr array
                                                                                            	**type**\: list of  		 :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                self.yang_name = "dst-addr-ipv6"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("ipv6-addr-array", ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.ipv6_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "dst-addr-ipv6"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                            class Ipv6AddrArray(Entity):
                                                                                                """
                                                                                                ipv6 addr array
                                                                                                
                                                                                                .. attribute:: prefix
                                                                                                
                                                                                                	IPV6 prefix
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	IPV6 mask
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                    self.yang_name = "ipv6-addr-array"
                                                                                                    self.yang_parent_name = "dst-addr-ipv6"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                                                                                        ('mask', (YLeaf(YType.uint32, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.prefix = None
                                                                                                    self.mask = None
                                                                                                    self._segment_path = lambda: "ipv6-addr-array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['prefix', 'mask'], name, value)


                                                                                        class SrcAddrMac(Entity):
                                                                                            """
                                                                                            Source Address MAC
                                                                                            
                                                                                            .. attribute:: mac_addr_array
                                                                                            
                                                                                            	mac addr array
                                                                                            	**type**\: list of  		 :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                self.yang_name = "src-addr-mac"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("mac-addr-array", ("mac_addr_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.mac_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "src-addr-mac"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                            class MacAddrArray(Entity):
                                                                                                """
                                                                                                mac addr array
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\: list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                    self.yang_name = "mac-addr-array"
                                                                                                    self.yang_parent_name = "src-addr-mac"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('mac_addr', (YLeafList(YType.uint16, 'mac-addr'), ['int'])),
                                                                                                        ('mask', (YLeafList(YType.uint16, 'mask'), ['int'])),
                                                                                                    ])
                                                                                                    self.mac_addr = []
                                                                                                    self.mask = []
                                                                                                    self._segment_path = lambda: "mac-addr-array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                        class Timer(Entity):
                                                                                            """
                                                                                            Timer
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                self.yang_name = "timer"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "timer"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                        class TimerRegexp(Entity):
                                                                                            """
                                                                                            Timer Regular Expression
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                self.yang_name = "timer-regexp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "timer-regexp"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                        class TunnelName(Entity):
                                                                                            """
                                                                                            Tunnel Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                self.yang_name = "tunnel-name"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "tunnel-name"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                        class TunnelNameRegex(Entity):
                                                                                            """
                                                                                            Tunnel Name Regular Expression
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                self.yang_name = "tunnel-name-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "tunnel-name-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                        class UserName(Entity):
                                                                                            """
                                                                                            User Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                self.yang_name = "user-name"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "user-name"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                        class UserNameRegex(Entity):
                                                                                            """
                                                                                            User Name Regular Expression
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                self.yang_name = "user-name-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "user-name-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                        class AuthUsername(Entity):
                                                                                            """
                                                                                            Authenticated User Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                self.yang_name = "auth-username"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "auth-username"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                        class AuthUsernameRegex(Entity):
                                                                                            """
                                                                                            Authenticated User Name RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                self.yang_name = "auth-username-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "auth-username-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                        class UnauthUsername(Entity):
                                                                                            """
                                                                                            Unauthenticated User Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                self.yang_name = "unauth-username"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "unauth-username"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                        class UnauthUsernameRegex(Entity):
                                                                                            """
                                                                                            Unauthenticated User Name RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                self.yang_name = "unauth-username-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "unauth-username-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                        class AuthDomain(Entity):
                                                                                            """
                                                                                            Authenticated domain name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                self.yang_name = "auth-domain"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "auth-domain"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                        class AuthDomainRegex(Entity):
                                                                                            """
                                                                                            Authenticated Domain Name RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                self.yang_name = "auth-domain-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "auth-domain-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                        class UnauthDomain(Entity):
                                                                                            """
                                                                                            Unauthenticated Domain Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                self.yang_name = "unauth-domain"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "unauth-domain"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                        class UnauthDomainRegex(Entity):
                                                                                            """
                                                                                            Unauthenticated Domain Name RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                self.yang_name = "unauth-domain-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "unauth-domain-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                        class VendorId(Entity):
                                                                                            """
                                                                                            Vendor ID
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                self.yang_name = "vendor-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "vendor-id"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                        class VendorIdRegex(Entity):
                                                                                            """
                                                                                            Vendor ID RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                self.yang_name = "vendor-id-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "vendor-id-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                        class AccessInterface(Entity):
                                                                                            """
                                                                                            Access interface
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                self.yang_name = "access-interface"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "access-interface"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                        class InputInterface(Entity):
                                                                                            """
                                                                                            Input interface
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                self.yang_name = "input-interface"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "input-interface"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                        class InputIntfhdl(Entity):
                                                                                            """
                                                                                            Input interface handle
                                                                                            
                                                                                            .. attribute:: uint64_array
                                                                                            
                                                                                            	uint64 array
                                                                                            	**type**\: list of int
                                                                                            
                                                                                            	**range:** 0..18446744073709551615
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                self.yang_name = "input-intfhdl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('uint64_array', (YLeafList(YType.uint64, 'uint64_array'), ['int'])),
                                                                                                ])
                                                                                                self.uint64_array = []
                                                                                                self._segment_path = lambda: "input-intfhdl"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                        class Ethertype(Entity):
                                                                                            """
                                                                                            Ethernet type
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                self.yang_name = "ethertype"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ethertype"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "ethertype"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['min', 'max'], name, value)


                                                                                        class FlowKeyData(Entity):
                                                                                            """
                                                                                            Flow key structure
                                                                                            
                                                                                            .. attribute:: flow_keys
                                                                                            
                                                                                            	flow keys
                                                                                            	**type**\:  :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                            
                                                                                            .. attribute:: max_count
                                                                                            
                                                                                            	Maximum count of flows
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: idle_timeout
                                                                                            
                                                                                            	Idle timeout of flows (in seconds)
                                                                                            	**type**\: int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            	**units**\: second
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                self.yang_name = "flow-key-data"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("flow-keys", ("flow_keys", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys))])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('max_count', (YLeaf(YType.uint16, 'max-count'), ['int'])),
                                                                                                    ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                                                ])
                                                                                                self.max_count = None
                                                                                                self.idle_timeout = None

                                                                                                self.flow_keys = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                self.flow_keys.parent = self
                                                                                                self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                self._segment_path = lambda: "flow-key-data"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['max_count', 'idle_timeout'], name, value)


                                                                                            class FlowKeys(Entity):
                                                                                                """
                                                                                                flow keys
                                                                                                
                                                                                                .. attribute:: keys
                                                                                                
                                                                                                	keys
                                                                                                	**type**\: str
                                                                                                
                                                                                                	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                
                                                                                                .. attribute:: num
                                                                                                
                                                                                                	num
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                    self.yang_name = "flow-keys"
                                                                                                    self.yang_parent_name = "flow-key-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('keys', (YLeaf(YType.str, 'keys'), ['str'])),
                                                                                                        ('num', (YLeaf(YType.uint8, 'num'), ['int'])),
                                                                                                    ])
                                                                                                    self.keys = None
                                                                                                    self.num = None
                                                                                                    self._segment_path = lambda: "flow-keys"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                        class DhcpClientId(Entity):
                                                                                            """
                                                                                            Dhcp Client ID
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                self.yang_name = "dhcp-client-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "dhcp-client-id"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                        class DhcpClientIdRegex(Entity):
                                                                                            """
                                                                                            Dhcp Client ID RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                self.yang_name = "dhcp-client-id-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "dhcp-client-id-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                        class CircuitId(Entity):
                                                                                            """
                                                                                            Circuit ID
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                self.yang_name = "circuit-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "circuit-id"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                        class CircuitIdRegex(Entity):
                                                                                            """
                                                                                            Circuit ID RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                self.yang_name = "circuit-id-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "circuit-id-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                        class RemoteId(Entity):
                                                                                            """
                                                                                            Remote ID
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                self.yang_name = "remote-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "remote-id"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                        class RemoteIdRegex(Entity):
                                                                                            """
                                                                                            Remote ID RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\: list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                self.yang_name = "remote-id-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([])
                                                                                                self._leafs = OrderedDict([
                                                                                                    ('string_array', (YLeafList(YType.str, 'string-array'), ['str'])),
                                                                                                ])
                                                                                                self.string_array = []
                                                                                                self._segment_path = lambda: "remote-id-regex"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                        class SrcPort(Entity):
                                                                                            """
                                                                                            Source port
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                self.yang_name = "src-port"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "src-port"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "src-port"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                                        class DstPort(Entity):
                                                                                            """
                                                                                            Destination port
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of  		 :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2018-01-17'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                self.yang_name = "dst-port"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self.ylist_key_names = []
                                                                                                self._child_classes = OrderedDict([("uint16_rng_array", ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray))])
                                                                                                self._leafs = OrderedDict()

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "dst-port"
                                                                                                self._is_frozen = True

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\: int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2018-01-17'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "dst-port"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self.ylist_key_names = []
                                                                                                    self._child_classes = OrderedDict([])
                                                                                                    self._leafs = OrderedDict([
                                                                                                        ('min', (YLeaf(YType.uint16, 'min'), ['int'])),
                                                                                                        ('max', (YLeaf(YType.uint16, 'max'), ['int'])),
                                                                                                    ])
                                                                                                    self.min = None
                                                                                                    self.max = None
                                                                                                    self._segment_path = lambda: "uint16_rng_array"
                                                                                                    self._is_frozen = True

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['min', 'max'], name, value)


                                                                class Shape(Entity):
                                                                    """
                                                                    shape
                                                                    
                                                                    .. attribute:: bw
                                                                    
                                                                    	bw
                                                                    	**type**\:  :py:class:`Bw <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw>`
                                                                    
                                                                    .. attribute:: be
                                                                    
                                                                    	be
                                                                    	**type**\:  :py:class:`Be <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape, self).__init__()

                                                                        self.yang_name = "shape"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("bw", ("bw", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw)), ("be", ("be", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be))])
                                                                        self._leafs = OrderedDict()

                                                                        self.bw = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw()
                                                                        self.bw.parent = self
                                                                        self._children_name_map["bw"] = "bw"

                                                                        self.be = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be()
                                                                        self.be.parent = self
                                                                        self._children_name_map["be"] = "be"
                                                                        self._segment_path = lambda: "shape"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape, [], name, value)


                                                                    class Bw(Entity):
                                                                        """
                                                                        bw
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw, self).__init__()

                                                                            self.yang_name = "bw"
                                                                            self.yang_parent_name = "shape"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                            ])
                                                                            self.value = None
                                                                            self.unit = None
                                                                            self._segment_path = lambda: "bw"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw, ['value', 'unit'], name, value)


                                                                    class Be(Entity):
                                                                        """
                                                                        be
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be, self).__init__()

                                                                            self.yang_name = "be"
                                                                            self.yang_parent_name = "shape"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                            ])
                                                                            self.value = None
                                                                            self.unit = None
                                                                            self._segment_path = lambda: "be"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be, ['value', 'unit'], name, value)


                                                                class ChildPolicy(Entity):
                                                                    """
                                                                    child policy
                                                                    
                                                                    .. attribute:: info
                                                                    
                                                                    	info
                                                                    	**type**\:  :py:class:`Info <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info>`
                                                                    
                                                                    .. attribute:: hd_info
                                                                    
                                                                    	hd info
                                                                    	**type**\:  :py:class:`HdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo>`
                                                                    
                                                                    .. attribute:: enc
                                                                    
                                                                    	enc
                                                                    	**type**\:  :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy, self).__init__()

                                                                        self.yang_name = "child-policy"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("info", ("info", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info)), ("hd-info", ("hd_info", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo))])
                                                                        self._leafs = OrderedDict([
                                                                            ('enc', (YLeaf(YType.enumeration, 'enc'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyObjEncEn', '')])),
                                                                        ])
                                                                        self.enc = None

                                                                        self.info = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info()
                                                                        self.info.parent = self
                                                                        self._children_name_map["info"] = "info"

                                                                        self.hd_info = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo()
                                                                        self.hd_info.parent = self
                                                                        self._children_name_map["hd_info"] = "hd-info"
                                                                        self._segment_path = lambda: "child-policy"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy, ['enc'], name, value)


                                                                    class Info(Entity):
                                                                        """
                                                                        info
                                                                        
                                                                        .. attribute:: name
                                                                        
                                                                        	name
                                                                        	**type**\: str
                                                                        
                                                                        	**length:** 0..65
                                                                        
                                                                        .. attribute:: type
                                                                        
                                                                        	type
                                                                        	**type**\:  :py:class:`PolicyMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyMapTypeEn>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info, self).__init__()

                                                                            self.yang_name = "info"
                                                                            self.yang_parent_name = "child-policy"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                                                ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyMapTypeEn', '')])),
                                                                            ])
                                                                            self.name = None
                                                                            self.type = None
                                                                            self._segment_path = lambda: "info"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info, ['name', 'type'], name, value)


                                                                    class HdInfo(Entity):
                                                                        """
                                                                        hd info
                                                                        
                                                                        .. attribute:: data_hd
                                                                        
                                                                        	data hd
                                                                        	**type**\:  :py:class:`DataHd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd>`
                                                                        
                                                                        .. attribute:: hd
                                                                        
                                                                        	hd
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo, self).__init__()

                                                                            self.yang_name = "hd-info"
                                                                            self.yang_parent_name = "child-policy"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([("data-hd", ("data_hd", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd))])
                                                                            self._leafs = OrderedDict([
                                                                                ('hd', (YLeaf(YType.uint64, 'hd'), ['int'])),
                                                                            ])
                                                                            self.hd = None

                                                                            self.data_hd = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd()
                                                                            self.data_hd.parent = self
                                                                            self._children_name_map["data_hd"] = "data-hd"
                                                                            self._segment_path = lambda: "hd-info"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo, ['hd'], name, value)


                                                                        class DataHd(Entity):
                                                                            """
                                                                            data hd
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2018-01-17'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd, self).__init__()

                                                                                self.yang_name = "data-hd"
                                                                                self.yang_parent_name = "hd-info"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self.ylist_key_names = []
                                                                                self._child_classes = OrderedDict([])
                                                                                self._leafs = OrderedDict()
                                                                                self._segment_path = lambda: "data-hd"
                                                                                self._is_frozen = True


                                                                class Cac(Entity):
                                                                    """
                                                                    cac
                                                                    
                                                                    .. attribute:: flow_rate
                                                                    
                                                                    	flow rate
                                                                    	**type**\:  :py:class:`FlowRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate>`
                                                                    
                                                                    .. attribute:: rate
                                                                    
                                                                    	rate
                                                                    	**type**\:  :py:class:`Rate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate>`
                                                                    
                                                                    .. attribute:: cac_type
                                                                    
                                                                    	cac type
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    .. attribute:: idle_timeout
                                                                    
                                                                    	idle timeout
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..65535
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac, self).__init__()

                                                                        self.yang_name = "cac"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("flow-rate", ("flow_rate", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate)), ("rate", ("rate", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate))])
                                                                        self._leafs = OrderedDict([
                                                                            ('cac_type', (YLeaf(YType.uint8, 'cac-type'), ['int'])),
                                                                            ('idle_timeout', (YLeaf(YType.uint16, 'idle-timeout'), ['int'])),
                                                                        ])
                                                                        self.cac_type = None
                                                                        self.idle_timeout = None

                                                                        self.flow_rate = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate()
                                                                        self.flow_rate.parent = self
                                                                        self._children_name_map["flow_rate"] = "flow-rate"

                                                                        self.rate = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate()
                                                                        self.rate.parent = self
                                                                        self._children_name_map["rate"] = "rate"
                                                                        self._segment_path = lambda: "cac"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac, ['cac_type', 'idle_timeout'], name, value)


                                                                    class FlowRate(Entity):
                                                                        """
                                                                        flow rate
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate, self).__init__()

                                                                            self.yang_name = "flow-rate"
                                                                            self.yang_parent_name = "cac"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                            ])
                                                                            self.value = None
                                                                            self.unit = None
                                                                            self._segment_path = lambda: "flow-rate"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate, ['value', 'unit'], name, value)


                                                                    class Rate(Entity):
                                                                        """
                                                                        rate
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate, self).__init__()

                                                                            self.yang_name = "rate"
                                                                            self.yang_parent_name = "cac"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                            ])
                                                                            self.value = None
                                                                            self.unit = None
                                                                            self._segment_path = lambda: "rate"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate, ['value', 'unit'], name, value)


                                                                class Pfc(Entity):
                                                                    """
                                                                    pfc
                                                                    
                                                                    .. attribute:: buffer_size
                                                                    
                                                                    	buffer size
                                                                    	**type**\:  :py:class:`BufferSize <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize>`
                                                                    
                                                                    .. attribute:: pause_threshold
                                                                    
                                                                    	pause threshold
                                                                    	**type**\:  :py:class:`PauseThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold>`
                                                                    
                                                                    .. attribute:: resume_threshold
                                                                    
                                                                    	resume threshold
                                                                    	**type**\:  :py:class:`ResumeThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold>`
                                                                    
                                                                    .. attribute:: pfc_pause_set
                                                                    
                                                                    	pfc pause set
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: buffer_size_flag
                                                                    
                                                                    	buffer size flag
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc, self).__init__()

                                                                        self.yang_name = "pfc"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("buffer-size", ("buffer_size", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize)), ("pause-threshold", ("pause_threshold", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold)), ("resume-threshold", ("resume_threshold", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold))])
                                                                        self._leafs = OrderedDict([
                                                                            ('pfc_pause_set', (YLeaf(YType.uint32, 'pfc-pause-set'), ['int'])),
                                                                            ('buffer_size_flag', (YLeaf(YType.uint32, 'buffer-size-flag'), ['int'])),
                                                                        ])
                                                                        self.pfc_pause_set = None
                                                                        self.buffer_size_flag = None

                                                                        self.buffer_size = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize()
                                                                        self.buffer_size.parent = self
                                                                        self._children_name_map["buffer_size"] = "buffer-size"

                                                                        self.pause_threshold = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold()
                                                                        self.pause_threshold.parent = self
                                                                        self._children_name_map["pause_threshold"] = "pause-threshold"

                                                                        self.resume_threshold = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold()
                                                                        self.resume_threshold.parent = self
                                                                        self._children_name_map["resume_threshold"] = "resume-threshold"
                                                                        self._segment_path = lambda: "pfc"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc, ['pfc_pause_set', 'buffer_size_flag'], name, value)


                                                                    class BufferSize(Entity):
                                                                        """
                                                                        buffer size
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize, self).__init__()

                                                                            self.yang_name = "buffer-size"
                                                                            self.yang_parent_name = "pfc"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                            ])
                                                                            self.value = None
                                                                            self.unit = None
                                                                            self._segment_path = lambda: "buffer-size"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize, ['value', 'unit'], name, value)


                                                                    class PauseThreshold(Entity):
                                                                        """
                                                                        pause threshold
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold, self).__init__()

                                                                            self.yang_name = "pause-threshold"
                                                                            self.yang_parent_name = "pfc"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                            ])
                                                                            self.value = None
                                                                            self.unit = None
                                                                            self._segment_path = lambda: "pause-threshold"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold, ['value', 'unit'], name, value)


                                                                    class ResumeThreshold(Entity):
                                                                        """
                                                                        resume threshold
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold, self).__init__()

                                                                            self.yang_name = "resume-threshold"
                                                                            self.yang_parent_name = "pfc"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                            ])
                                                                            self.value = None
                                                                            self.unit = None
                                                                            self._segment_path = lambda: "resume-threshold"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold, ['value', 'unit'], name, value)


                                                                class FlowParm(Entity):
                                                                    """
                                                                    flow parm
                                                                    
                                                                    .. attribute:: max_mon_flows
                                                                    
                                                                    	max simult flows monitored per policy class
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: mon_interval
                                                                    
                                                                    	monitored interval duration in secs
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: second
                                                                    
                                                                    .. attribute:: intvl_hist
                                                                    
                                                                    	num intervals of data stored on rtr
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: flow_timeout
                                                                    
                                                                    	timeout in secs
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: second
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm, self).__init__()

                                                                        self.yang_name = "flow-parm"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('max_mon_flows', (YLeaf(YType.uint32, 'max-mon-flows'), ['int'])),
                                                                            ('mon_interval', (YLeaf(YType.uint32, 'mon-interval'), ['int'])),
                                                                            ('intvl_hist', (YLeaf(YType.uint32, 'intvl-hist'), ['int'])),
                                                                            ('flow_timeout', (YLeaf(YType.uint32, 'flow-timeout'), ['int'])),
                                                                        ])
                                                                        self.max_mon_flows = None
                                                                        self.mon_interval = None
                                                                        self.intvl_hist = None
                                                                        self.flow_timeout = None
                                                                        self._segment_path = lambda: "flow-parm"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm, ['max_mon_flows', 'mon_interval', 'intvl_hist', 'flow_timeout'], name, value)


                                                                class Ipcbr(Entity):
                                                                    """
                                                                    ipcbr
                                                                    
                                                                    .. attribute:: ip_bit_rate
                                                                    
                                                                    	data rate in bps
                                                                    	**type**\:  :py:class:`IpBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate>`
                                                                    
                                                                    .. attribute:: media_bit_rate
                                                                    
                                                                    	media data rate in bps
                                                                    	**type**\:  :py:class:`MediaBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate>`
                                                                    
                                                                    .. attribute:: action_metric_type
                                                                    
                                                                    	metric type
                                                                    	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                    
                                                                    .. attribute:: ip_pkt_rate
                                                                    
                                                                    	packet rate in pps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: media_pkt_size
                                                                    
                                                                    	media packet size in bytes
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: media_pkts_per_ip
                                                                    
                                                                    	media packets per ip pkt
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr, self).__init__()

                                                                        self.yang_name = "ipcbr"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("ip-bit-rate", ("ip_bit_rate", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate)), ("media-bit-rate", ("media_bit_rate", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate))])
                                                                        self._leafs = OrderedDict([
                                                                            ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                            ('ip_pkt_rate', (YLeaf(YType.uint32, 'ip-pkt-rate'), ['int'])),
                                                                            ('media_pkt_size', (YLeaf(YType.uint32, 'media-pkt-size'), ['int'])),
                                                                            ('media_pkts_per_ip', (YLeaf(YType.uint32, 'media-pkts-per-ip'), ['int'])),
                                                                        ])
                                                                        self.action_metric_type = None
                                                                        self.ip_pkt_rate = None
                                                                        self.media_pkt_size = None
                                                                        self.media_pkts_per_ip = None

                                                                        self.ip_bit_rate = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate()
                                                                        self.ip_bit_rate.parent = self
                                                                        self._children_name_map["ip_bit_rate"] = "ip-bit-rate"

                                                                        self.media_bit_rate = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate()
                                                                        self.media_bit_rate.parent = self
                                                                        self._children_name_map["media_bit_rate"] = "media-bit-rate"
                                                                        self._segment_path = lambda: "ipcbr"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr, ['action_metric_type', 'ip_pkt_rate', 'media_pkt_size', 'media_pkts_per_ip'], name, value)


                                                                    class IpBitRate(Entity):
                                                                        """
                                                                        data rate in bps
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate, self).__init__()

                                                                            self.yang_name = "ip-bit-rate"
                                                                            self.yang_parent_name = "ipcbr"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                            ])
                                                                            self.value = None
                                                                            self.unit = None
                                                                            self._segment_path = lambda: "ip-bit-rate"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate, ['value', 'unit'], name, value)


                                                                    class MediaBitRate(Entity):
                                                                        """
                                                                        media data rate in bps
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate, self).__init__()

                                                                            self.yang_name = "media-bit-rate"
                                                                            self.yang_parent_name = "ipcbr"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                            ])
                                                                            self.value = None
                                                                            self.unit = None
                                                                            self._segment_path = lambda: "media-bit-rate"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate, ['value', 'unit'], name, value)


                                                                class Rtp(Entity):
                                                                    """
                                                                    rtp
                                                                    
                                                                    .. attribute:: action_metric_type
                                                                    
                                                                    	metric type
                                                                    	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                    
                                                                    .. attribute:: min_sequential
                                                                    
                                                                    	min sequential
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: max_dropout
                                                                    
                                                                    	max dropout
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: max_misorder
                                                                    
                                                                    	max misorder
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: seq_ext_cop4
                                                                    
                                                                    	enable seq extension cop4
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: clock_rate
                                                                    
                                                                    	clock rate
                                                                    	**type**\: list of  		 :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp, self).__init__()

                                                                        self.yang_name = "rtp"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("clock-rate", ("clock_rate", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate))])
                                                                        self._leafs = OrderedDict([
                                                                            ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                            ('min_sequential', (YLeaf(YType.uint32, 'min-sequential'), ['int'])),
                                                                            ('max_dropout', (YLeaf(YType.uint32, 'max-dropout'), ['int'])),
                                                                            ('max_misorder', (YLeaf(YType.uint32, 'max-misorder'), ['int'])),
                                                                            ('seq_ext_cop4', (YLeaf(YType.uint32, 'seq-ext-cop4'), ['int'])),
                                                                        ])
                                                                        self.action_metric_type = None
                                                                        self.min_sequential = None
                                                                        self.max_dropout = None
                                                                        self.max_misorder = None
                                                                        self.seq_ext_cop4 = None

                                                                        self.clock_rate = YList(self)
                                                                        self._segment_path = lambda: "rtp"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp, ['action_metric_type', 'min_sequential', 'max_dropout', 'max_misorder', 'seq_ext_cop4'], name, value)


                                                                    class ClockRate(Entity):
                                                                        """
                                                                        clock rate
                                                                        
                                                                        .. attribute:: pt
                                                                        
                                                                        	pt
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: frequency
                                                                        
                                                                        	frequency
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate, self).__init__()

                                                                            self.yang_name = "clock-rate"
                                                                            self.yang_parent_name = "rtp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('pt', (YLeaf(YType.uint32, 'pt'), ['int'])),
                                                                                ('frequency', (YLeaf(YType.uint32, 'frequency'), ['int'])),
                                                                            ])
                                                                            self.pt = None
                                                                            self.frequency = None
                                                                            self._segment_path = lambda: "clock-rate"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate, ['pt', 'frequency'], name, value)


                                                                class RtpMmr(Entity):
                                                                    """
                                                                    rtp mmr
                                                                    
                                                                    .. attribute:: action_metric_type
                                                                    
                                                                    	metric type
                                                                    	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                    
                                                                    .. attribute:: min_sequential
                                                                    
                                                                    	min sequential
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: max_dropout
                                                                    
                                                                    	max dropout
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: max_misorder
                                                                    
                                                                    	max misorder
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: seq_ext_cop4
                                                                    
                                                                    	enable seq extension cop4
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: clock_rate
                                                                    
                                                                    	clock rate
                                                                    	**type**\: list of  		 :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr, self).__init__()

                                                                        self.yang_name = "rtp-mmr"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("clock-rate", ("clock_rate", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate))])
                                                                        self._leafs = OrderedDict([
                                                                            ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                            ('min_sequential', (YLeaf(YType.uint32, 'min-sequential'), ['int'])),
                                                                            ('max_dropout', (YLeaf(YType.uint32, 'max-dropout'), ['int'])),
                                                                            ('max_misorder', (YLeaf(YType.uint32, 'max-misorder'), ['int'])),
                                                                            ('seq_ext_cop4', (YLeaf(YType.uint32, 'seq-ext-cop4'), ['int'])),
                                                                        ])
                                                                        self.action_metric_type = None
                                                                        self.min_sequential = None
                                                                        self.max_dropout = None
                                                                        self.max_misorder = None
                                                                        self.seq_ext_cop4 = None

                                                                        self.clock_rate = YList(self)
                                                                        self._segment_path = lambda: "rtp-mmr"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr, ['action_metric_type', 'min_sequential', 'max_dropout', 'max_misorder', 'seq_ext_cop4'], name, value)


                                                                    class ClockRate(Entity):
                                                                        """
                                                                        clock rate
                                                                        
                                                                        .. attribute:: pt
                                                                        
                                                                        	pt
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: frequency
                                                                        
                                                                        	frequency
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate, self).__init__()

                                                                            self.yang_name = "clock-rate"
                                                                            self.yang_parent_name = "rtp-mmr"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('pt', (YLeaf(YType.uint32, 'pt'), ['int'])),
                                                                                ('frequency', (YLeaf(YType.uint32, 'frequency'), ['int'])),
                                                                            ])
                                                                            self.pt = None
                                                                            self.frequency = None
                                                                            self._segment_path = lambda: "clock-rate"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate, ['pt', 'frequency'], name, value)


                                                                class RtpJ2k(Entity):
                                                                    """
                                                                    rtp j2k
                                                                    
                                                                    .. attribute:: action_metric_type
                                                                    
                                                                    	metric type
                                                                    	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                    
                                                                    .. attribute:: min_sequential
                                                                    
                                                                    	min sequential
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: max_dropout
                                                                    
                                                                    	max dropout
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: max_misorder
                                                                    
                                                                    	max misorder
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: seq_ext_cop4
                                                                    
                                                                    	enable seq extension cop4
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: clock_rate
                                                                    
                                                                    	clock rate
                                                                    	**type**\: list of  		 :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k.ClockRate>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k, self).__init__()

                                                                        self.yang_name = "rtp-j2k"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("clock-rate", ("clock_rate", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k.ClockRate))])
                                                                        self._leafs = OrderedDict([
                                                                            ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                            ('min_sequential', (YLeaf(YType.uint32, 'min-sequential'), ['int'])),
                                                                            ('max_dropout', (YLeaf(YType.uint32, 'max-dropout'), ['int'])),
                                                                            ('max_misorder', (YLeaf(YType.uint32, 'max-misorder'), ['int'])),
                                                                            ('seq_ext_cop4', (YLeaf(YType.uint32, 'seq-ext-cop4'), ['int'])),
                                                                        ])
                                                                        self.action_metric_type = None
                                                                        self.min_sequential = None
                                                                        self.max_dropout = None
                                                                        self.max_misorder = None
                                                                        self.seq_ext_cop4 = None

                                                                        self.clock_rate = YList(self)
                                                                        self._segment_path = lambda: "rtp-j2k"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k, ['action_metric_type', 'min_sequential', 'max_dropout', 'max_misorder', 'seq_ext_cop4'], name, value)


                                                                    class ClockRate(Entity):
                                                                        """
                                                                        clock rate
                                                                        
                                                                        .. attribute:: pt
                                                                        
                                                                        	pt
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: frequency
                                                                        
                                                                        	frequency
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k.ClockRate, self).__init__()

                                                                            self.yang_name = "clock-rate"
                                                                            self.yang_parent_name = "rtp-j2k"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('pt', (YLeaf(YType.uint32, 'pt'), ['int'])),
                                                                                ('frequency', (YLeaf(YType.uint32, 'frequency'), ['int'])),
                                                                            ])
                                                                            self.pt = None
                                                                            self.frequency = None
                                                                            self._segment_path = lambda: "clock-rate"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2k.ClockRate, ['pt', 'frequency'], name, value)


                                                                class RtpVoice(Entity):
                                                                    """
                                                                    rtp voice
                                                                    
                                                                    .. attribute:: action_metric_type
                                                                    
                                                                    	metric type
                                                                    	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                    
                                                                    .. attribute:: min_sequential
                                                                    
                                                                    	min sequential
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: max_dropout
                                                                    
                                                                    	max dropout
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: max_misorder
                                                                    
                                                                    	max misorder
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: seq_ext_cop4
                                                                    
                                                                    	enable seq extension cop4
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: clock_rate
                                                                    
                                                                    	clock rate
                                                                    	**type**\: list of  		 :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice, self).__init__()

                                                                        self.yang_name = "rtp-voice"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("clock-rate", ("clock_rate", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate))])
                                                                        self._leafs = OrderedDict([
                                                                            ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                            ('min_sequential', (YLeaf(YType.uint32, 'min-sequential'), ['int'])),
                                                                            ('max_dropout', (YLeaf(YType.uint32, 'max-dropout'), ['int'])),
                                                                            ('max_misorder', (YLeaf(YType.uint32, 'max-misorder'), ['int'])),
                                                                            ('seq_ext_cop4', (YLeaf(YType.uint32, 'seq-ext-cop4'), ['int'])),
                                                                        ])
                                                                        self.action_metric_type = None
                                                                        self.min_sequential = None
                                                                        self.max_dropout = None
                                                                        self.max_misorder = None
                                                                        self.seq_ext_cop4 = None

                                                                        self.clock_rate = YList(self)
                                                                        self._segment_path = lambda: "rtp-voice"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice, ['action_metric_type', 'min_sequential', 'max_dropout', 'max_misorder', 'seq_ext_cop4'], name, value)


                                                                    class ClockRate(Entity):
                                                                        """
                                                                        clock rate
                                                                        
                                                                        .. attribute:: pt
                                                                        
                                                                        	pt
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: frequency
                                                                        
                                                                        	frequency
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate, self).__init__()

                                                                            self.yang_name = "clock-rate"
                                                                            self.yang_parent_name = "rtp-voice"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('pt', (YLeaf(YType.uint32, 'pt'), ['int'])),
                                                                                ('frequency', (YLeaf(YType.uint32, 'frequency'), ['int'])),
                                                                            ])
                                                                            self.pt = None
                                                                            self.frequency = None
                                                                            self._segment_path = lambda: "clock-rate"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate, ['pt', 'frequency'], name, value)


                                                                class Mdi(Entity):
                                                                    """
                                                                    mdi
                                                                    
                                                                    .. attribute:: ip_bit_rate
                                                                    
                                                                    	data rate in bps
                                                                    	**type**\:  :py:class:`IpBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate>`
                                                                    
                                                                    .. attribute:: action_metric_type
                                                                    
                                                                    	metric type
                                                                    	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                    
                                                                    .. attribute:: filtered_pkt_rate
                                                                    
                                                                    	filtered packet rate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: ip_pkt_rate
                                                                    
                                                                    	packet rate in pps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: pids
                                                                    
                                                                    	array of monitoredcd  pids
                                                                    	**type**\: list of int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi, self).__init__()

                                                                        self.yang_name = "mdi"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("ip-bit-rate", ("ip_bit_rate", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate))])
                                                                        self._leafs = OrderedDict([
                                                                            ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                            ('filtered_pkt_rate', (YLeaf(YType.uint32, 'filtered-pkt-rate'), ['int'])),
                                                                            ('ip_pkt_rate', (YLeaf(YType.uint32, 'ip-pkt-rate'), ['int'])),
                                                                            ('pids', (YLeafList(YType.uint32, 'pids'), ['int'])),
                                                                        ])
                                                                        self.action_metric_type = None
                                                                        self.filtered_pkt_rate = None
                                                                        self.ip_pkt_rate = None
                                                                        self.pids = []

                                                                        self.ip_bit_rate = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate()
                                                                        self.ip_bit_rate.parent = self
                                                                        self._children_name_map["ip_bit_rate"] = "ip-bit-rate"
                                                                        self._segment_path = lambda: "mdi"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi, ['action_metric_type', 'filtered_pkt_rate', 'ip_pkt_rate', 'pids'], name, value)


                                                                    class IpBitRate(Entity):
                                                                        """
                                                                        data rate in bps
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate, self).__init__()

                                                                            self.yang_name = "ip-bit-rate"
                                                                            self.yang_parent_name = "mdi"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                            ])
                                                                            self.value = None
                                                                            self.unit = None
                                                                            self._segment_path = lambda: "ip-bit-rate"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate, ['value', 'unit'], name, value)


                                                                class MdiRtp(Entity):
                                                                    """
                                                                    mdi rtp
                                                                    
                                                                    .. attribute:: ip_bit_rate
                                                                    
                                                                    	data rate in bps
                                                                    	**type**\:  :py:class:`IpBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate>`
                                                                    
                                                                    .. attribute:: action_metric_type
                                                                    
                                                                    	metric type
                                                                    	**type**\:  :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                    
                                                                    .. attribute:: filtered_pkt_rate
                                                                    
                                                                    	filtered packet rate
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: ip_pkt_rate
                                                                    
                                                                    	packet rate in pps
                                                                    	**type**\: int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: pids
                                                                    
                                                                    	array of monitoredcd  pids
                                                                    	**type**\: list of int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp, self).__init__()

                                                                        self.yang_name = "mdi-rtp"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("ip-bit-rate", ("ip_bit_rate", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate))])
                                                                        self._leafs = OrderedDict([
                                                                            ('action_metric_type', (YLeaf(YType.enumeration, 'action-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyActionEn', '')])),
                                                                            ('filtered_pkt_rate', (YLeaf(YType.uint32, 'filtered-pkt-rate'), ['int'])),
                                                                            ('ip_pkt_rate', (YLeaf(YType.uint32, 'ip-pkt-rate'), ['int'])),
                                                                            ('pids', (YLeafList(YType.uint32, 'pids'), ['int'])),
                                                                        ])
                                                                        self.action_metric_type = None
                                                                        self.filtered_pkt_rate = None
                                                                        self.ip_pkt_rate = None
                                                                        self.pids = []

                                                                        self.ip_bit_rate = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate()
                                                                        self.ip_bit_rate.parent = self
                                                                        self._children_name_map["ip_bit_rate"] = "ip-bit-rate"
                                                                        self._segment_path = lambda: "mdi-rtp"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp, ['action_metric_type', 'filtered_pkt_rate', 'ip_pkt_rate', 'pids'], name, value)


                                                                    class IpBitRate(Entity):
                                                                        """
                                                                        data rate in bps
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:  :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate, self).__init__()

                                                                            self.yang_name = "ip-bit-rate"
                                                                            self.yang_parent_name = "mdi-rtp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('value', (YLeaf(YType.uint32, 'value'), ['int'])),
                                                                                ('unit', (YLeaf(YType.enumeration, 'unit'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicyParamUnitType', '')])),
                                                                            ])
                                                                            self.value = None
                                                                            self.unit = None
                                                                            self._segment_path = lambda: "ip-bit-rate"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate, ['value', 'unit'], name, value)


                                                                class Fmm(Entity):
                                                                    """
                                                                    fmm
                                                                    
                                                                    .. attribute:: fmm_name
                                                                    
                                                                    	flow monitor name
                                                                    	**type**\: str
                                                                    
                                                                    	**length:** 0..33
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm, self).__init__()

                                                                        self.yang_name = "fmm"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([])
                                                                        self._leafs = OrderedDict([
                                                                            ('fmm_name', (YLeaf(YType.str, 'fmm-name'), ['str'])),
                                                                        ])
                                                                        self.fmm_name = None
                                                                        self._segment_path = lambda: "fmm"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm, ['fmm_name'], name, value)


                                                                class Pbf(Entity):
                                                                    """
                                                                    pbf
                                                                    
                                                                    .. attribute:: action_pbf_info_array
                                                                    
                                                                    	action pbf info array
                                                                    	**type**\: list of  		 :py:class:`ActionPbfInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf, self).__init__()

                                                                        self.yang_name = "pbf"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("action-pbf-info-array", ("action_pbf_info_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray))])
                                                                        self._leafs = OrderedDict()

                                                                        self.action_pbf_info_array = YList(self)
                                                                        self._segment_path = lambda: "pbf"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf, [], name, value)


                                                                    class ActionPbfInfoArray(Entity):
                                                                        """
                                                                        action pbf info array
                                                                        
                                                                        .. attribute:: addr
                                                                        
                                                                        	v4 or v6 address
                                                                        	**type**\: str
                                                                        
                                                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                        
                                                                        .. attribute:: vrf
                                                                        
                                                                        	vrf name
                                                                        	**type**\: str
                                                                        
                                                                        .. attribute:: rt_type
                                                                        
                                                                        	route target type
                                                                        	**type**\: int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: rt
                                                                        
                                                                        	route target
                                                                        	**type**\: str
                                                                        
                                                                        	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray, self).__init__()

                                                                            self.yang_name = "action-pbf-info-array"
                                                                            self.yang_parent_name = "pbf"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('addr', (YLeaf(YType.str, 'addr'), ['str'])),
                                                                                ('vrf', (YLeaf(YType.str, 'vrf'), ['str'])),
                                                                                ('rt_type', (YLeaf(YType.uint8, 'rt-type'), ['int'])),
                                                                                ('rt', (YLeaf(YType.str, 'rt'), ['str'])),
                                                                            ])
                                                                            self.addr = None
                                                                            self.vrf = None
                                                                            self.rt_type = None
                                                                            self.rt = None
                                                                            self._segment_path = lambda: "action-pbf-info-array"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray, ['addr', 'vrf', 'rt_type', 'rt'], name, value)


                                                                class Ipv4Nh(Entity):
                                                                    """
                                                                    ipv4 nh
                                                                    
                                                                    .. attribute:: action_ipv4_nh_info_array
                                                                    
                                                                    	action ipv4 nh info array
                                                                    	**type**\: list of  		 :py:class:`ActionIpv4NhInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh, self).__init__()

                                                                        self.yang_name = "ipv4-nh"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("action-ipv4-nh-info-array", ("action_ipv4_nh_info_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray))])
                                                                        self._leafs = OrderedDict()

                                                                        self.action_ipv4_nh_info_array = YList(self)
                                                                        self._segment_path = lambda: "ipv4-nh"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh, [], name, value)


                                                                    class ActionIpv4NhInfoArray(Entity):
                                                                        """
                                                                        action ipv4 nh info array
                                                                        
                                                                        .. attribute:: nh_addr
                                                                        
                                                                        	nh addr
                                                                        	**type**\: str
                                                                        
                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                        
                                                                        .. attribute:: vrf_name
                                                                        
                                                                        	Vrf name
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray, self).__init__()

                                                                            self.yang_name = "action-ipv4-nh-info-array"
                                                                            self.yang_parent_name = "ipv4-nh"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('nh_addr', (YLeaf(YType.str, 'nh-addr'), ['str'])),
                                                                                ('vrf_name', (YLeaf(YType.str, 'vrf-name'), ['str'])),
                                                                            ])
                                                                            self.nh_addr = None
                                                                            self.vrf_name = None
                                                                            self._segment_path = lambda: "action-ipv4-nh-info-array"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray, ['nh_addr', 'vrf_name'], name, value)


                                                                class Ipv6Nh(Entity):
                                                                    """
                                                                    ipv6 nh
                                                                    
                                                                    .. attribute:: action_ipv6_nh_info_array
                                                                    
                                                                    	action ipv6 nh info array
                                                                    	**type**\: list of  		 :py:class:`ActionIpv6NhInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2018-01-17'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh, self).__init__()

                                                                        self.yang_name = "ipv6-nh"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self.ylist_key_names = []
                                                                        self._child_classes = OrderedDict([("action-ipv6-nh-info-array", ("action_ipv6_nh_info_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray))])
                                                                        self._leafs = OrderedDict()

                                                                        self.action_ipv6_nh_info_array = YList(self)
                                                                        self._segment_path = lambda: "ipv6-nh"
                                                                        self._is_frozen = True

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh, [], name, value)


                                                                    class ActionIpv6NhInfoArray(Entity):
                                                                        """
                                                                        action ipv6 nh info array
                                                                        
                                                                        .. attribute:: nh_addr
                                                                        
                                                                        	IPV6 Address
                                                                        	**type**\: str
                                                                        
                                                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                        
                                                                        .. attribute:: vrf_name
                                                                        
                                                                        	Vrf name
                                                                        	**type**\: str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2018-01-17'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray, self).__init__()

                                                                            self.yang_name = "action-ipv6-nh-info-array"
                                                                            self.yang_parent_name = "ipv6-nh"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self.ylist_key_names = []
                                                                            self._child_classes = OrderedDict([])
                                                                            self._leafs = OrderedDict([
                                                                                ('nh_addr', (YLeaf(YType.str, 'nh-addr'), ['str'])),
                                                                                ('vrf_name', (YLeaf(YType.str, 'vrf-name'), ['str'])),
                                                                            ])
                                                                            self.nh_addr = None
                                                                            self.vrf_name = None
                                                                            self._segment_path = lambda: "action-ipv6-nh-info-array"
                                                                            self._is_frozen = True

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap_.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray, ['nh_addr', 'vrf_name'], name, value)


                        class PolicyMapDetails(Entity):
                            """
                            Policy\-map table
                            
                            .. attribute:: policy_map_detail
                            
                            	Policy\-map detail information
                            	**type**\: list of  		 :py:class:`PolicyMapDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail>`
                            
                            

                            """

                            _prefix = 'infra-policymgr-oper'
                            _revision = '2018-01-17'

                            def __init__(self):
                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails, self).__init__()

                                self.yang_name = "policy-map-details"
                                self.yang_parent_name = "policy-map-type"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("policy-map-detail", ("policy_map_detail", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail))])
                                self._leafs = OrderedDict()

                                self.policy_map_detail = YList(self)
                                self._segment_path = lambda: "policy-map-details"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails, [], name, value)


                            class PolicyMapDetail(Entity):
                                """
                                Policy\-map detail information
                                
                                .. attribute:: policy_map_name  (key)
                                
                                	Name of policy\-map
                                	**type**\: str
                                
                                	**length:** 1..63
                                
                                .. attribute:: object_type
                                
                                	Application type configured
                                	**type**\:  :py:class:`PlmgrApplnTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrApplnTypeEn>`
                                
                                .. attribute:: total_objects
                                
                                	Total number of objects configured for a specific object type
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: transient
                                
                                	Transient object
                                	**type**\: bool
                                
                                .. attribute:: reference
                                
                                	Each Policymap details
                                	**type**\: list of  		 :py:class:`Reference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail.Reference>`
                                
                                .. attribute:: objects
                                
                                	Each object details
                                	**type**\: list of  		 :py:class:`Objects <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail.Objects>`
                                
                                .. attribute:: class_map_reference
                                
                                	Each Classmapdetails
                                	**type**\: list of  		 :py:class:`ClassMapReference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail.ClassMapReference>`
                                
                                

                                """

                                _prefix = 'infra-policymgr-oper'
                                _revision = '2018-01-17'

                                def __init__(self):
                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail, self).__init__()

                                    self.yang_name = "policy-map-detail"
                                    self.yang_parent_name = "policy-map-details"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = ['policy_map_name']
                                    self._child_classes = OrderedDict([("reference", ("reference", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail.Reference)), ("objects", ("objects", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail.Objects)), ("class-map-reference", ("class_map_reference", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail.ClassMapReference))])
                                    self._leafs = OrderedDict([
                                        ('policy_map_name', (YLeaf(YType.str, 'policy-map-name'), ['str'])),
                                        ('object_type', (YLeaf(YType.enumeration, 'object-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PlmgrApplnTypeEn', '')])),
                                        ('total_objects', (YLeaf(YType.uint32, 'total-objects'), ['int'])),
                                        ('transient', (YLeaf(YType.boolean, 'transient'), ['bool'])),
                                    ])
                                    self.policy_map_name = None
                                    self.object_type = None
                                    self.total_objects = None
                                    self.transient = None

                                    self.reference = YList(self)
                                    self.objects = YList(self)
                                    self.class_map_reference = YList(self)
                                    self._segment_path = lambda: "policy-map-detail" + "[policy-map-name='" + str(self.policy_map_name) + "']"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail, ['policy_map_name', 'object_type', 'total_objects', 'transient'], name, value)


                                class Reference(Entity):
                                    """
                                    Each Policymap details
                                    
                                    .. attribute:: total_internal_reference_objects
                                    
                                    	Total number of internal reference objects
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: total_class_maps
                                    
                                    	Total number of Classmaps in a Policymap
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: total_flows
                                    
                                    	Total flows in a Policymap
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2018-01-17'

                                    def __init__(self):
                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail.Reference, self).__init__()

                                        self.yang_name = "reference"
                                        self.yang_parent_name = "policy-map-detail"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('total_internal_reference_objects', (YLeaf(YType.uint32, 'total-internal-reference-objects'), ['int'])),
                                            ('total_class_maps', (YLeaf(YType.uint32, 'total-class-maps'), ['int'])),
                                            ('total_flows', (YLeaf(YType.uint32, 'total-flows'), ['int'])),
                                        ])
                                        self.total_internal_reference_objects = None
                                        self.total_class_maps = None
                                        self.total_flows = None
                                        self._segment_path = lambda: "reference"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail.Reference, ['total_internal_reference_objects', 'total_class_maps', 'total_flows'], name, value)


                                class Objects(Entity):
                                    """
                                    Each object details
                                    
                                    .. attribute:: object_name
                                    
                                    	Name of object (Policymap/Classmap)
                                    	**type**\: str
                                    
                                    	**length:** 0..64
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2018-01-17'

                                    def __init__(self):
                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail.Objects, self).__init__()

                                        self.yang_name = "objects"
                                        self.yang_parent_name = "policy-map-detail"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('object_name', (YLeaf(YType.str, 'object-name'), ['str'])),
                                        ])
                                        self.object_name = None
                                        self._segment_path = lambda: "objects"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail.Objects, ['object_name'], name, value)


                                class ClassMapReference(Entity):
                                    """
                                    Each Classmapdetails
                                    
                                    .. attribute:: total_reference_objects
                                    
                                    	Total number of Policymaps referencing a Classmap
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: policy_map_reference
                                    
                                    	List of Policymaps referencing a Classmap
                                    	**type**\: list of  		 :py:class:`PolicyMapReference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail.ClassMapReference.PolicyMapReference>`
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2018-01-17'

                                    def __init__(self):
                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail.ClassMapReference, self).__init__()

                                        self.yang_name = "class-map-reference"
                                        self.yang_parent_name = "policy-map-detail"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("policy-map-reference", ("policy_map_reference", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail.ClassMapReference.PolicyMapReference))])
                                        self._leafs = OrderedDict([
                                            ('total_reference_objects', (YLeaf(YType.uint32, 'total-reference-objects'), ['int'])),
                                        ])
                                        self.total_reference_objects = None

                                        self.policy_map_reference = YList(self)
                                        self._segment_path = lambda: "class-map-reference"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail.ClassMapReference, ['total_reference_objects'], name, value)


                                    class PolicyMapReference(Entity):
                                        """
                                        List of Policymaps referencing a Classmap
                                        
                                        .. attribute:: object_type
                                        
                                        	Application type configured
                                        	**type**\:  :py:class:`PlmgrApplnTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrApplnTypeEn>`
                                        
                                        .. attribute:: policy_map_name
                                        
                                        	Name of Policymap referencing a Classmap
                                        	**type**\: str
                                        
                                        	**length:** 0..64
                                        
                                        

                                        """

                                        _prefix = 'infra-policymgr-oper'
                                        _revision = '2018-01-17'

                                        def __init__(self):
                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail.ClassMapReference.PolicyMapReference, self).__init__()

                                            self.yang_name = "policy-map-reference"
                                            self.yang_parent_name = "class-map-reference"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('object_type', (YLeaf(YType.enumeration, 'object-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PlmgrApplnTypeEn', '')])),
                                                ('policy_map_name', (YLeaf(YType.str, 'policy-map-name'), ['str'])),
                                            ])
                                            self.object_type = None
                                            self.policy_map_name = None
                                            self._segment_path = lambda: "policy-map-reference"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail.ClassMapReference.PolicyMapReference, ['object_type', 'policy_map_name'], name, value)


                class TransientPolicyMapTypes(Entity):
                    """
                    Application type of transient policy\-map list
                    
                    .. attribute:: transient_policy_map_type
                    
                    	Transient policy\-map type
                    	**type**\: list of  		 :py:class:`TransientPolicyMapType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType>`
                    
                    

                    """

                    _prefix = 'infra-policymgr-oper'
                    _revision = '2018-01-17'

                    def __init__(self):
                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypes, self).__init__()

                        self.yang_name = "transient-policy-map-types"
                        self.yang_parent_name = "policy-map"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("transient-policy-map-type", ("transient_policy_map_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType))])
                        self._leafs = OrderedDict()

                        self.transient_policy_map_type = YList(self)
                        self._segment_path = lambda: "transient-policy-map-types"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypes, [], name, value)


                    class TransientPolicyMapType(Entity):
                        """
                        Transient policy\-map type
                        
                        .. attribute:: type  (key)
                        
                        	The application type
                        	**type**\:  :py:class:`PolicymgrPolicyMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicymgrPolicyMap>`
                        
                        .. attribute:: transient_list_unuseds
                        
                        	Transient policy\-map list unused table
                        	**type**\:  :py:class:`TransientListUnuseds <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds>`
                        
                        

                        """

                        _prefix = 'infra-policymgr-oper'
                        _revision = '2018-01-17'

                        def __init__(self):
                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType, self).__init__()

                            self.yang_name = "transient-policy-map-type"
                            self.yang_parent_name = "transient-policy-map-types"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = ['type']
                            self._child_classes = OrderedDict([("transient-list-unuseds", ("transient_list_unuseds", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds))])
                            self._leafs = OrderedDict([
                                ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PolicymgrPolicyMap', '')])),
                            ])
                            self.type = None

                            self.transient_list_unuseds = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds()
                            self.transient_list_unuseds.parent = self
                            self._children_name_map["transient_list_unuseds"] = "transient-list-unuseds"
                            self._segment_path = lambda: "transient-policy-map-type" + "[type='" + str(self.type) + "']"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType, ['type'], name, value)


                        class TransientListUnuseds(Entity):
                            """
                            Transient policy\-map list unused table
                            
                            .. attribute:: transient_list_unused
                            
                            	Policy\-map list unused
                            	**type**\: list of  		 :py:class:`TransientListUnused <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused>`
                            
                            

                            """

                            _prefix = 'infra-policymgr-oper'
                            _revision = '2018-01-17'

                            def __init__(self):
                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds, self).__init__()

                                self.yang_name = "transient-list-unuseds"
                                self.yang_parent_name = "transient-policy-map-type"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("transient-list-unused", ("transient_list_unused", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused))])
                                self._leafs = OrderedDict()

                                self.transient_list_unused = YList(self)
                                self._segment_path = lambda: "transient-list-unuseds"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds, [], name, value)


                            class TransientListUnused(Entity):
                                """
                                Policy\-map list unused
                                
                                .. attribute:: policy_map_name  (key)
                                
                                	Name of policy\-map
                                	**type**\: str
                                
                                	**length:** 1..63
                                
                                .. attribute:: object_type
                                
                                	Application type configured
                                	**type**\:  :py:class:`PlmgrApplnTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrApplnTypeEn>`
                                
                                .. attribute:: total_objects
                                
                                	Total number of objects configured for a specific object type
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: transient
                                
                                	Transient object
                                	**type**\: bool
                                
                                .. attribute:: reference
                                
                                	Each Policymap details
                                	**type**\: list of  		 :py:class:`Reference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused.Reference>`
                                
                                .. attribute:: objects
                                
                                	Each object details
                                	**type**\: list of  		 :py:class:`Objects <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused.Objects>`
                                
                                .. attribute:: class_map_reference
                                
                                	Each Classmapdetails
                                	**type**\: list of  		 :py:class:`ClassMapReference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused.ClassMapReference>`
                                
                                

                                """

                                _prefix = 'infra-policymgr-oper'
                                _revision = '2018-01-17'

                                def __init__(self):
                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused, self).__init__()

                                    self.yang_name = "transient-list-unused"
                                    self.yang_parent_name = "transient-list-unuseds"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = ['policy_map_name']
                                    self._child_classes = OrderedDict([("reference", ("reference", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused.Reference)), ("objects", ("objects", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused.Objects)), ("class-map-reference", ("class_map_reference", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused.ClassMapReference))])
                                    self._leafs = OrderedDict([
                                        ('policy_map_name', (YLeaf(YType.str, 'policy-map-name'), ['str'])),
                                        ('object_type', (YLeaf(YType.enumeration, 'object-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PlmgrApplnTypeEn', '')])),
                                        ('total_objects', (YLeaf(YType.uint32, 'total-objects'), ['int'])),
                                        ('transient', (YLeaf(YType.boolean, 'transient'), ['bool'])),
                                    ])
                                    self.policy_map_name = None
                                    self.object_type = None
                                    self.total_objects = None
                                    self.transient = None

                                    self.reference = YList(self)
                                    self.objects = YList(self)
                                    self.class_map_reference = YList(self)
                                    self._segment_path = lambda: "transient-list-unused" + "[policy-map-name='" + str(self.policy_map_name) + "']"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused, ['policy_map_name', 'object_type', 'total_objects', 'transient'], name, value)


                                class Reference(Entity):
                                    """
                                    Each Policymap details
                                    
                                    .. attribute:: total_internal_reference_objects
                                    
                                    	Total number of internal reference objects
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: total_class_maps
                                    
                                    	Total number of Classmaps in a Policymap
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: total_flows
                                    
                                    	Total flows in a Policymap
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2018-01-17'

                                    def __init__(self):
                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused.Reference, self).__init__()

                                        self.yang_name = "reference"
                                        self.yang_parent_name = "transient-list-unused"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('total_internal_reference_objects', (YLeaf(YType.uint32, 'total-internal-reference-objects'), ['int'])),
                                            ('total_class_maps', (YLeaf(YType.uint32, 'total-class-maps'), ['int'])),
                                            ('total_flows', (YLeaf(YType.uint32, 'total-flows'), ['int'])),
                                        ])
                                        self.total_internal_reference_objects = None
                                        self.total_class_maps = None
                                        self.total_flows = None
                                        self._segment_path = lambda: "reference"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused.Reference, ['total_internal_reference_objects', 'total_class_maps', 'total_flows'], name, value)


                                class Objects(Entity):
                                    """
                                    Each object details
                                    
                                    .. attribute:: object_name
                                    
                                    	Name of object (Policymap/Classmap)
                                    	**type**\: str
                                    
                                    	**length:** 0..64
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2018-01-17'

                                    def __init__(self):
                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused.Objects, self).__init__()

                                        self.yang_name = "objects"
                                        self.yang_parent_name = "transient-list-unused"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('object_name', (YLeaf(YType.str, 'object-name'), ['str'])),
                                        ])
                                        self.object_name = None
                                        self._segment_path = lambda: "objects"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused.Objects, ['object_name'], name, value)


                                class ClassMapReference(Entity):
                                    """
                                    Each Classmapdetails
                                    
                                    .. attribute:: total_reference_objects
                                    
                                    	Total number of Policymaps referencing a Classmap
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: policy_map_reference
                                    
                                    	List of Policymaps referencing a Classmap
                                    	**type**\: list of  		 :py:class:`PolicyMapReference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused.ClassMapReference.PolicyMapReference>`
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2018-01-17'

                                    def __init__(self):
                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused.ClassMapReference, self).__init__()

                                        self.yang_name = "class-map-reference"
                                        self.yang_parent_name = "transient-list-unused"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("policy-map-reference", ("policy_map_reference", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused.ClassMapReference.PolicyMapReference))])
                                        self._leafs = OrderedDict([
                                            ('total_reference_objects', (YLeaf(YType.uint32, 'total-reference-objects'), ['int'])),
                                        ])
                                        self.total_reference_objects = None

                                        self.policy_map_reference = YList(self)
                                        self._segment_path = lambda: "class-map-reference"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused.ClassMapReference, ['total_reference_objects'], name, value)


                                    class PolicyMapReference(Entity):
                                        """
                                        List of Policymaps referencing a Classmap
                                        
                                        .. attribute:: object_type
                                        
                                        	Application type configured
                                        	**type**\:  :py:class:`PlmgrApplnTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrApplnTypeEn>`
                                        
                                        .. attribute:: policy_map_name
                                        
                                        	Name of Policymap referencing a Classmap
                                        	**type**\: str
                                        
                                        	**length:** 0..64
                                        
                                        

                                        """

                                        _prefix = 'infra-policymgr-oper'
                                        _revision = '2018-01-17'

                                        def __init__(self):
                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused.ClassMapReference.PolicyMapReference, self).__init__()

                                            self.yang_name = "policy-map-reference"
                                            self.yang_parent_name = "class-map-reference"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('object_type', (YLeaf(YType.enumeration, 'object-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PlmgrApplnTypeEn', '')])),
                                                ('policy_map_name', (YLeaf(YType.str, 'policy-map-name'), ['str'])),
                                            ])
                                            self.object_type = None
                                            self.policy_map_name = None
                                            self._segment_path = lambda: "policy-map-reference"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused.ClassMapReference.PolicyMapReference, ['object_type', 'policy_map_name'], name, value)


            class Summary(Entity):
                """
                Summary of policy\-maps and class\-maps configured
                
                .. attribute:: total_class_maps
                
                	Total number of Classmaps configured
                	**type**\: int
                
                	**range:** 0..4294967295
                
                .. attribute:: total_class_map_types
                
                	Total number of Classmap types configured
                	**type**\: int
                
                	**range:** 0..4294967295
                
                .. attribute:: total_policy_maps
                
                	Total number of Policymaps configured
                	**type**\: int
                
                	**range:** 0..4294967295
                
                .. attribute:: total_policy_map_types
                
                	Total number of Policymap types configured
                	**type**\: int
                
                	**range:** 0..4294967295
                
                .. attribute:: class_maps
                
                	Summary of Classmap database
                	**type**\: list of  		 :py:class:`ClassMaps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.Summary.ClassMaps>`
                
                .. attribute:: policy_maps
                
                	Summary of Policymap database
                	**type**\: list of  		 :py:class:`PolicyMaps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.Summary.PolicyMaps>`
                
                

                """

                _prefix = 'infra-policymgr-oper'
                _revision = '2018-01-17'

                def __init__(self):
                    super(PolicyManager.Nodes.Node.Summary, self).__init__()

                    self.yang_name = "summary"
                    self.yang_parent_name = "node"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("class-maps", ("class_maps", PolicyManager.Nodes.Node.Summary.ClassMaps)), ("policy-maps", ("policy_maps", PolicyManager.Nodes.Node.Summary.PolicyMaps))])
                    self._leafs = OrderedDict([
                        ('total_class_maps', (YLeaf(YType.uint32, 'total-class-maps'), ['int'])),
                        ('total_class_map_types', (YLeaf(YType.uint32, 'total-class-map-types'), ['int'])),
                        ('total_policy_maps', (YLeaf(YType.uint32, 'total-policy-maps'), ['int'])),
                        ('total_policy_map_types', (YLeaf(YType.uint32, 'total-policy-map-types'), ['int'])),
                    ])
                    self.total_class_maps = None
                    self.total_class_map_types = None
                    self.total_policy_maps = None
                    self.total_policy_map_types = None

                    self.class_maps = YList(self)
                    self.policy_maps = YList(self)
                    self._segment_path = lambda: "summary"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(PolicyManager.Nodes.Node.Summary, ['total_class_maps', 'total_class_map_types', 'total_policy_maps', 'total_policy_map_types'], name, value)


                class ClassMaps(Entity):
                    """
                    Summary of Classmap database
                    
                    .. attribute:: object_type
                    
                    	Application type configured
                    	**type**\:  :py:class:`PlmgrApplnTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrApplnTypeEn>`
                    
                    .. attribute:: total_objects
                    
                    	Total number of objects configured for a specific object type
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: transient
                    
                    	Transient object
                    	**type**\: bool
                    
                    .. attribute:: reference
                    
                    	Each Policymap details
                    	**type**\: list of  		 :py:class:`Reference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.Summary.ClassMaps.Reference>`
                    
                    .. attribute:: objects
                    
                    	Each object details
                    	**type**\: list of  		 :py:class:`Objects <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.Summary.ClassMaps.Objects>`
                    
                    .. attribute:: class_map_reference
                    
                    	Each Classmapdetails
                    	**type**\: list of  		 :py:class:`ClassMapReference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.Summary.ClassMaps.ClassMapReference>`
                    
                    

                    """

                    _prefix = 'infra-policymgr-oper'
                    _revision = '2018-01-17'

                    def __init__(self):
                        super(PolicyManager.Nodes.Node.Summary.ClassMaps, self).__init__()

                        self.yang_name = "class-maps"
                        self.yang_parent_name = "summary"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("reference", ("reference", PolicyManager.Nodes.Node.Summary.ClassMaps.Reference)), ("objects", ("objects", PolicyManager.Nodes.Node.Summary.ClassMaps.Objects)), ("class-map-reference", ("class_map_reference", PolicyManager.Nodes.Node.Summary.ClassMaps.ClassMapReference))])
                        self._leafs = OrderedDict([
                            ('object_type', (YLeaf(YType.enumeration, 'object-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PlmgrApplnTypeEn', '')])),
                            ('total_objects', (YLeaf(YType.uint32, 'total-objects'), ['int'])),
                            ('transient', (YLeaf(YType.boolean, 'transient'), ['bool'])),
                        ])
                        self.object_type = None
                        self.total_objects = None
                        self.transient = None

                        self.reference = YList(self)
                        self.objects = YList(self)
                        self.class_map_reference = YList(self)
                        self._segment_path = lambda: "class-maps"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(PolicyManager.Nodes.Node.Summary.ClassMaps, ['object_type', 'total_objects', 'transient'], name, value)


                    class Reference(Entity):
                        """
                        Each Policymap details
                        
                        .. attribute:: total_internal_reference_objects
                        
                        	Total number of internal reference objects
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: total_class_maps
                        
                        	Total number of Classmaps in a Policymap
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: total_flows
                        
                        	Total flows in a Policymap
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'infra-policymgr-oper'
                        _revision = '2018-01-17'

                        def __init__(self):
                            super(PolicyManager.Nodes.Node.Summary.ClassMaps.Reference, self).__init__()

                            self.yang_name = "reference"
                            self.yang_parent_name = "class-maps"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('total_internal_reference_objects', (YLeaf(YType.uint32, 'total-internal-reference-objects'), ['int'])),
                                ('total_class_maps', (YLeaf(YType.uint32, 'total-class-maps'), ['int'])),
                                ('total_flows', (YLeaf(YType.uint32, 'total-flows'), ['int'])),
                            ])
                            self.total_internal_reference_objects = None
                            self.total_class_maps = None
                            self.total_flows = None
                            self._segment_path = lambda: "reference"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(PolicyManager.Nodes.Node.Summary.ClassMaps.Reference, ['total_internal_reference_objects', 'total_class_maps', 'total_flows'], name, value)


                    class Objects(Entity):
                        """
                        Each object details
                        
                        .. attribute:: object_name
                        
                        	Name of object (Policymap/Classmap)
                        	**type**\: str
                        
                        	**length:** 0..64
                        
                        

                        """

                        _prefix = 'infra-policymgr-oper'
                        _revision = '2018-01-17'

                        def __init__(self):
                            super(PolicyManager.Nodes.Node.Summary.ClassMaps.Objects, self).__init__()

                            self.yang_name = "objects"
                            self.yang_parent_name = "class-maps"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('object_name', (YLeaf(YType.str, 'object-name'), ['str'])),
                            ])
                            self.object_name = None
                            self._segment_path = lambda: "objects"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(PolicyManager.Nodes.Node.Summary.ClassMaps.Objects, ['object_name'], name, value)


                    class ClassMapReference(Entity):
                        """
                        Each Classmapdetails
                        
                        .. attribute:: total_reference_objects
                        
                        	Total number of Policymaps referencing a Classmap
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: policy_map_reference
                        
                        	List of Policymaps referencing a Classmap
                        	**type**\: list of  		 :py:class:`PolicyMapReference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.Summary.ClassMaps.ClassMapReference.PolicyMapReference>`
                        
                        

                        """

                        _prefix = 'infra-policymgr-oper'
                        _revision = '2018-01-17'

                        def __init__(self):
                            super(PolicyManager.Nodes.Node.Summary.ClassMaps.ClassMapReference, self).__init__()

                            self.yang_name = "class-map-reference"
                            self.yang_parent_name = "class-maps"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("policy-map-reference", ("policy_map_reference", PolicyManager.Nodes.Node.Summary.ClassMaps.ClassMapReference.PolicyMapReference))])
                            self._leafs = OrderedDict([
                                ('total_reference_objects', (YLeaf(YType.uint32, 'total-reference-objects'), ['int'])),
                            ])
                            self.total_reference_objects = None

                            self.policy_map_reference = YList(self)
                            self._segment_path = lambda: "class-map-reference"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(PolicyManager.Nodes.Node.Summary.ClassMaps.ClassMapReference, ['total_reference_objects'], name, value)


                        class PolicyMapReference(Entity):
                            """
                            List of Policymaps referencing a Classmap
                            
                            .. attribute:: object_type
                            
                            	Application type configured
                            	**type**\:  :py:class:`PlmgrApplnTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrApplnTypeEn>`
                            
                            .. attribute:: policy_map_name
                            
                            	Name of Policymap referencing a Classmap
                            	**type**\: str
                            
                            	**length:** 0..64
                            
                            

                            """

                            _prefix = 'infra-policymgr-oper'
                            _revision = '2018-01-17'

                            def __init__(self):
                                super(PolicyManager.Nodes.Node.Summary.ClassMaps.ClassMapReference.PolicyMapReference, self).__init__()

                                self.yang_name = "policy-map-reference"
                                self.yang_parent_name = "class-map-reference"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('object_type', (YLeaf(YType.enumeration, 'object-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PlmgrApplnTypeEn', '')])),
                                    ('policy_map_name', (YLeaf(YType.str, 'policy-map-name'), ['str'])),
                                ])
                                self.object_type = None
                                self.policy_map_name = None
                                self._segment_path = lambda: "policy-map-reference"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(PolicyManager.Nodes.Node.Summary.ClassMaps.ClassMapReference.PolicyMapReference, ['object_type', 'policy_map_name'], name, value)


                class PolicyMaps(Entity):
                    """
                    Summary of Policymap database
                    
                    .. attribute:: object_type
                    
                    	Application type configured
                    	**type**\:  :py:class:`PlmgrApplnTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrApplnTypeEn>`
                    
                    .. attribute:: total_objects
                    
                    	Total number of objects configured for a specific object type
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: transient
                    
                    	Transient object
                    	**type**\: bool
                    
                    .. attribute:: reference
                    
                    	Each Policymap details
                    	**type**\: list of  		 :py:class:`Reference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.Summary.PolicyMaps.Reference>`
                    
                    .. attribute:: objects
                    
                    	Each object details
                    	**type**\: list of  		 :py:class:`Objects <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.Summary.PolicyMaps.Objects>`
                    
                    .. attribute:: class_map_reference
                    
                    	Each Classmapdetails
                    	**type**\: list of  		 :py:class:`ClassMapReference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.Summary.PolicyMaps.ClassMapReference>`
                    
                    

                    """

                    _prefix = 'infra-policymgr-oper'
                    _revision = '2018-01-17'

                    def __init__(self):
                        super(PolicyManager.Nodes.Node.Summary.PolicyMaps, self).__init__()

                        self.yang_name = "policy-maps"
                        self.yang_parent_name = "summary"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("reference", ("reference", PolicyManager.Nodes.Node.Summary.PolicyMaps.Reference)), ("objects", ("objects", PolicyManager.Nodes.Node.Summary.PolicyMaps.Objects)), ("class-map-reference", ("class_map_reference", PolicyManager.Nodes.Node.Summary.PolicyMaps.ClassMapReference))])
                        self._leafs = OrderedDict([
                            ('object_type', (YLeaf(YType.enumeration, 'object-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PlmgrApplnTypeEn', '')])),
                            ('total_objects', (YLeaf(YType.uint32, 'total-objects'), ['int'])),
                            ('transient', (YLeaf(YType.boolean, 'transient'), ['bool'])),
                        ])
                        self.object_type = None
                        self.total_objects = None
                        self.transient = None

                        self.reference = YList(self)
                        self.objects = YList(self)
                        self.class_map_reference = YList(self)
                        self._segment_path = lambda: "policy-maps"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(PolicyManager.Nodes.Node.Summary.PolicyMaps, ['object_type', 'total_objects', 'transient'], name, value)


                    class Reference(Entity):
                        """
                        Each Policymap details
                        
                        .. attribute:: total_internal_reference_objects
                        
                        	Total number of internal reference objects
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: total_class_maps
                        
                        	Total number of Classmaps in a Policymap
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: total_flows
                        
                        	Total flows in a Policymap
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'infra-policymgr-oper'
                        _revision = '2018-01-17'

                        def __init__(self):
                            super(PolicyManager.Nodes.Node.Summary.PolicyMaps.Reference, self).__init__()

                            self.yang_name = "reference"
                            self.yang_parent_name = "policy-maps"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('total_internal_reference_objects', (YLeaf(YType.uint32, 'total-internal-reference-objects'), ['int'])),
                                ('total_class_maps', (YLeaf(YType.uint32, 'total-class-maps'), ['int'])),
                                ('total_flows', (YLeaf(YType.uint32, 'total-flows'), ['int'])),
                            ])
                            self.total_internal_reference_objects = None
                            self.total_class_maps = None
                            self.total_flows = None
                            self._segment_path = lambda: "reference"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(PolicyManager.Nodes.Node.Summary.PolicyMaps.Reference, ['total_internal_reference_objects', 'total_class_maps', 'total_flows'], name, value)


                    class Objects(Entity):
                        """
                        Each object details
                        
                        .. attribute:: object_name
                        
                        	Name of object (Policymap/Classmap)
                        	**type**\: str
                        
                        	**length:** 0..64
                        
                        

                        """

                        _prefix = 'infra-policymgr-oper'
                        _revision = '2018-01-17'

                        def __init__(self):
                            super(PolicyManager.Nodes.Node.Summary.PolicyMaps.Objects, self).__init__()

                            self.yang_name = "objects"
                            self.yang_parent_name = "policy-maps"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('object_name', (YLeaf(YType.str, 'object-name'), ['str'])),
                            ])
                            self.object_name = None
                            self._segment_path = lambda: "objects"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(PolicyManager.Nodes.Node.Summary.PolicyMaps.Objects, ['object_name'], name, value)


                    class ClassMapReference(Entity):
                        """
                        Each Classmapdetails
                        
                        .. attribute:: total_reference_objects
                        
                        	Total number of Policymaps referencing a Classmap
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: policy_map_reference
                        
                        	List of Policymaps referencing a Classmap
                        	**type**\: list of  		 :py:class:`PolicyMapReference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.Summary.PolicyMaps.ClassMapReference.PolicyMapReference>`
                        
                        

                        """

                        _prefix = 'infra-policymgr-oper'
                        _revision = '2018-01-17'

                        def __init__(self):
                            super(PolicyManager.Nodes.Node.Summary.PolicyMaps.ClassMapReference, self).__init__()

                            self.yang_name = "class-map-reference"
                            self.yang_parent_name = "policy-maps"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("policy-map-reference", ("policy_map_reference", PolicyManager.Nodes.Node.Summary.PolicyMaps.ClassMapReference.PolicyMapReference))])
                            self._leafs = OrderedDict([
                                ('total_reference_objects', (YLeaf(YType.uint32, 'total-reference-objects'), ['int'])),
                            ])
                            self.total_reference_objects = None

                            self.policy_map_reference = YList(self)
                            self._segment_path = lambda: "class-map-reference"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(PolicyManager.Nodes.Node.Summary.PolicyMaps.ClassMapReference, ['total_reference_objects'], name, value)


                        class PolicyMapReference(Entity):
                            """
                            List of Policymaps referencing a Classmap
                            
                            .. attribute:: object_type
                            
                            	Application type configured
                            	**type**\:  :py:class:`PlmgrApplnTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrApplnTypeEn>`
                            
                            .. attribute:: policy_map_name
                            
                            	Name of Policymap referencing a Classmap
                            	**type**\: str
                            
                            	**length:** 0..64
                            
                            

                            """

                            _prefix = 'infra-policymgr-oper'
                            _revision = '2018-01-17'

                            def __init__(self):
                                super(PolicyManager.Nodes.Node.Summary.PolicyMaps.ClassMapReference.PolicyMapReference, self).__init__()

                                self.yang_name = "policy-map-reference"
                                self.yang_parent_name = "class-map-reference"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('object_type', (YLeaf(YType.enumeration, 'object-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper', 'PlmgrApplnTypeEn', '')])),
                                    ('policy_map_name', (YLeaf(YType.str, 'policy-map-name'), ['str'])),
                                ])
                                self.object_type = None
                                self.policy_map_name = None
                                self._segment_path = lambda: "policy-map-reference"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(PolicyManager.Nodes.Node.Summary.PolicyMaps.ClassMapReference.PolicyMapReference, ['object_type', 'policy_map_name'], name, value)

    def clone_ptr(self):
        self._top_entity = PolicyManager()
        return self._top_entity

